/*===========================================================================*/
/*   (Llib/flac_alsadec.scm)                                                 */
/*   Bigloo (4.3h)                                                           */
/*   Inria -- Sophia Antipolis (c)       Tue 12 May 2020 08:36:09 AM CEST    */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.3h/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.3h/lib/bigloo/4.3h -I Llib -lib-dir /builddir/build/BUILD/bigloo-4.3h/lib/bigloo/4.3h -unsafe -safee -srfi flac -copt  -copt -fPIC -copt -IClib Llib/flac_alsadec.scm -o objs/flac_alsadec.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>
#include <FLAC/stream_decoder.h>
#include <bglflac.h>
#include <alsa/asoundlib.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_musicz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
} *BgL_musicz00_bglt;

typedef struct BgL_musicstatusz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_statez00;
   obj_t BgL_volumez00;
   bool_t BgL_repeatz00;
   bool_t BgL_randomz00;
   int BgL_playlistidz00;
   int BgL_playlistlengthz00;
   int BgL_xfadez00;
   int BgL_songz00;
   int BgL_songidz00;
   obj_t BgL_songposz00;
   int BgL_songlengthz00;
   int BgL_bitratez00;
   int BgL_khza7za7;
   obj_t BgL_errz00;
   int BgL_bufferingz00;
} *BgL_musicstatusz00_bglt;

typedef struct BgL_musicbufferz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_urlz00;
   bool_t BgL_z52eofz52;
   obj_t BgL_z52bcondvz52;
   obj_t BgL_z52bmutexz52;
   long BgL_z52inlenz52;
   char * BgL_z52inbufpz52;
   long BgL_z52headz52;
   long BgL_z52tailz52;
   bool_t BgL_z52emptyz52;
} *BgL_musicbufferz00_bglt;

typedef struct BgL_musicbufz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
   obj_t BgL_inbufz00;
   obj_t BgL_decodersz00;
   obj_t BgL_mkthreadz00;
   obj_t BgL_timeoutz00;
   obj_t BgL_z52decoderz52;
   obj_t BgL_z52bufferz52;
   obj_t BgL_z52nextbufferz52;
   obj_t BgL_z52playlistz52;
   bool_t BgL_z52areadyz52;
   obj_t BgL_z52amutexz52;
   int BgL_z52z12pidz40;
   obj_t BgL_z52acondvz52;
} *BgL_musicbufz00_bglt;

typedef struct BgL_musicdecoderz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_mimetypesz00;
   int BgL_bufferzd2timezd2nearz00;
   int BgL_bufferzd2siza7ezd2nearzd2ratioz75;
   int BgL_periodzd2siza7ezd2nearzd2ratioz75;
   bool_t BgL_z52z12dpausez40;
   bool_t BgL_z52z12dabortz40;
   bool_t BgL_z52z12stopz40;
   obj_t BgL_z52dmutexz52;
   obj_t BgL_z52dcondvz52;
   obj_t BgL_z52doutcondvz52;
} *BgL_musicdecoderz00_bglt;

typedef struct BgL_alsamusicz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
   obj_t BgL_inbufz00;
   obj_t BgL_decodersz00;
   obj_t BgL_mkthreadz00;
   obj_t BgL_timeoutz00;
   obj_t BgL_z52decoderz52;
   obj_t BgL_z52bufferz52;
   obj_t BgL_z52nextbufferz52;
   obj_t BgL_z52playlistz52;
   bool_t BgL_z52areadyz52;
   obj_t BgL_z52amutexz52;
   int BgL_z52z12pidz40;
   obj_t BgL_z52acondvz52;
   struct BgL_alsazd2sndzd2pcmz00_bgl * BgL_pcmz00;
} *BgL_alsamusicz00_bglt;

typedef struct BgL_alsazd2sndzd2pcmz00_bgl {
   header_t header;
   obj_t widening;
   snd_pcm_t * BgL_z42builtinz42;
   obj_t BgL_namez00;
   obj_t BgL_devicez00;
   obj_t BgL_streamz00;
   obj_t BgL_modez00;
   int BgL_hwbpsz00;
   int BgL_hwsratez00;
} *BgL_alsazd2sndzd2pcmz00_bglt;

typedef struct BgL_flaczd2decoderzd2_bgl {
   header_t header;
   obj_t widening;
   FLAC__StreamDecoder * BgL_z42builtinz42;
   obj_t BgL_z52flacbufz52;
   obj_t BgL_outbufz00;
   bool_t BgL_z52eofz52;
   long BgL_z52samplez52;
   double BgL_z52volumez52;
   bool_t BgL_md5checkz00;
   int BgL_z52bchecksumz52;
   int BgL_z52rchecksumz52;
} *BgL_flaczd2decoderzd2_bglt;

typedef struct BgL_flacdecz00_bgl {
   header_t header;
   obj_t widening;
   FLAC__StreamDecoder * BgL_z42builtinz42;
   obj_t BgL_z52flacbufz52;
   obj_t BgL_outbufz00;
   bool_t BgL_z52eofz52;
   long BgL_z52samplez52;
   double BgL_z52volumez52;
   bool_t BgL_md5checkz00;
   int BgL_z52bchecksumz52;
   int BgL_z52rchecksumz52;
   obj_t BgL_z52musicz52;
   obj_t BgL_z52bufferz52;
   obj_t BgL_z52decoderz52;
   int BgL_z52ratez52;
   int BgL_z52ratezd2maxz80;
   int BgL_z52ratezd2minz80;
   int BgL_z52lastzd2percentagez80;
} *BgL_flacdecz00_bglt;

typedef struct BgL_flacmusicdecoderz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_mimetypesz00;
   int BgL_bufferzd2timezd2nearz00;
   int BgL_bufferzd2siza7ezd2nearzd2ratioz75;
   int BgL_periodzd2siza7ezd2nearzd2ratioz75;
   bool_t BgL_z52z12dpausez40;
   bool_t BgL_z52z12dabortz40;
   bool_t BgL_z52z12stopz40;
   obj_t BgL_z52dmutexz52;
   obj_t BgL_z52dcondvz52;
   obj_t BgL_z52doutcondvz52;
   obj_t BgL_z52flacz52;
   obj_t BgL_z52inseekz52;
} *BgL_flacmusicdecoderz00_bglt;

typedef struct BgL_flacalsadecz00_bgl {
   header_t header;
   obj_t widening;
   FLAC__StreamDecoder * BgL_z42builtinz42;
   obj_t BgL_z52flacbufz52;
   obj_t BgL_outbufz00;
   bool_t BgL_z52eofz52;
   long BgL_z52samplez52;
   double BgL_z52volumez52;
   bool_t BgL_md5checkz00;
   int BgL_z52bchecksumz52;
   int BgL_z52rchecksumz52;
   obj_t BgL_z52musicz52;
   obj_t BgL_z52bufferz52;
   obj_t BgL_z52decoderz52;
   int BgL_z52ratez52;
   int BgL_z52ratezd2maxz80;
   int BgL_z52ratezd2minz80;
   int BgL_z52lastzd2percentagez80;
} *BgL_flacalsadecz00_bglt;

typedef struct BgL_flaczd2alsadecoderzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_mimetypesz00;
   int BgL_bufferzd2timezd2nearz00;
   int BgL_bufferzd2siza7ezd2nearzd2ratioz75;
   int BgL_periodzd2siza7ezd2nearzd2ratioz75;
   bool_t BgL_z52z12dpausez40;
   bool_t BgL_z52z12dabortz40;
   bool_t BgL_z52z12stopz40;
   obj_t BgL_z52dmutexz52;
   obj_t BgL_z52dcondvz52;
   obj_t BgL_z52doutcondvz52;
   obj_t BgL_z52flacz52;
   obj_t BgL_z52inseekz52;
} *BgL_flaczd2alsadecoderzd2_bglt;


BGL_IMPORT obj_t BGl_alsazd2sndzd2pcmzd2hwzd2setzd2paramsz12zc0zz__alsa_pcmz00(BgL_alsazd2sndzd2pcmz00_bglt, obj_t);
static obj_t BGl_flacalsadecz00zz__flac_alsadecz00 = BUNSPEC;
static obj_t BGl_objectzd2initzd2zz__flac_alsadecz00();
static obj_t BGl_z62zc3z04anonymousza31232ze3ze5zz__flac_alsadecz00(obj_t);
static obj_t BGl_methodzd2initzd2zz__flac_alsadecz00();
static obj_t BGl_z62zc3z04anonymousza31180ze3ze5zz__flac_alsadecz00(obj_t, obj_t);
static BgL_flaczd2alsadecoderzd2_bglt BGl_z62lambda1201z62zz__flac_alsadecz00(obj_t);
extern obj_t BGl_flaczd2decoderzd2decode16z00zz__flac_flacz00(BgL_flaczd2decoderzd2_bglt);
static obj_t BGl_z62musicdecoderzd2initzd2fl1154z62zz__flac_alsadecz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_conditionzd2variablezd2nilz00zz__threadz00();
BGL_IMPORT obj_t BGl_alsazd2sndzd2pcmzd2reopenzd2zz__alsa_pcmz00(BgL_alsazd2sndzd2pcmz00_bglt);
BGL_IMPORT obj_t BGl_alsazd2sndzd2pcmzd2swzd2setzd2paramsz12zc0zz__alsa_pcmz00(BgL_alsazd2sndzd2pcmz00_bglt, obj_t);
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__flac_alsadecz00();
BGL_IMPORT long BGl_musicbufferzd2availablezd2zz__multimediazd2musicbufzd2(BgL_musicbufferz00_bglt);
BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_exitdzd2popzd2protectz12z12zz__bexitz00(obj_t);
extern obj_t BGl_flaczd2decoderzd2decodez00zz__flac_flacz00(BgL_flaczd2decoderzd2_bglt);
BGL_IMPORT obj_t BGl_findzd2superzd2classzd2methodzd2zz__objectz00(BgL_objectz00_bglt, obj_t, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zz__flac_alsadecz00 = BUNSPEC;
static obj_t BGl_z62musicdecoderzd2decodezd21156z62zz__flac_alsadecz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31203ze3ze5zz__flac_alsadecz00(obj_t, obj_t);
static obj_t BGl_toplevelzd2initzd2zz__flac_alsadecz00();
BGL_IMPORT obj_t BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(BgL_musicz00_bglt, obj_t);
BGL_IMPORT obj_t BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(obj_t, obj_t);
static obj_t BGl_genericzd2initzd2zz__flac_alsadecz00();
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_mutexzd2nilzd2zz__threadz00();
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
static obj_t BGl_z62flaczd2decoderzd2readzd2fl1160zb0zz__flac_alsadecz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62flaczd2decoderzd2metadat1158z62zz__flac_alsadecz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2constructorzd2zz__objectz00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__flac_alsadecz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__flac_decoderz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__flac_flacz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__alsa_alsaz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__alsa_pcmz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2musicbufzd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__customz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
static BgL_flacalsadecz00_bglt BGl_z62lambda1172z62zz__flac_alsadecz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_flacalsadecz00_bglt BGl_z62lambda1175z62zz__flac_alsadecz00(obj_t);
static obj_t BGl_cnstzd2initzd2zz__flac_alsadecz00();
static obj_t BGl_libraryzd2moduleszd2initz00zz__flac_alsadecz00();
static obj_t BGl_importedzd2moduleszd2initz00zz__flac_alsadecz00();
BGL_IMPORT long BGl_musicdecoderzd2positionzd2zz__multimediazd2musicbufzd2(BgL_musicdecoderz00_bglt, BgL_musicbufferz00_bglt);
static BgL_flaczd2alsadecoderzd2_bglt BGl_z62lambda1198z62zz__flac_alsadecz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t bgl_custom_nil();
BGL_EXPORTED_DEF obj_t BGl_flaczd2alsadecoderzd2zz__flac_alsadecz00 = BUNSPEC;
BGL_IMPORT obj_t BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(obj_t);
extern obj_t BGl_flacdecz00zz__flac_decoderz00;
BGL_IMPORT obj_t BGl_alsazd2sndzd2pcmzd2cleanupzd2zz__alsa_pcmz00(BgL_alsazd2sndzd2pcmz00_bglt);
extern obj_t BGl_flacmusicdecoderz00zz__flac_decoderz00;
static obj_t __cnst[ 22 ] ;


BGL_IMPORT obj_t BGl_musicdecoderzd2decodezd2envz00zz__multimediazd2musicbufzd2;
extern obj_t BGl_flaczd2decoderzd2metadatazd2envzd2zz__flac_flacz00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1900z00zz__flac_alsadecz00, BgL_bgl_za762musicdecoderza71913z00, BGl_z62musicdecoderzd2initzd2fl1154z62zz__flac_alsadecz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1902z00zz__flac_alsadecz00, BgL_bgl_za762musicdecoderza71914z00, BGl_z62musicdecoderzd2decodezd21156z62zz__flac_alsadecz00, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1904z00zz__flac_alsadecz00, BgL_bgl_za762flacza7d2decode1915z00, BGl_z62flaczd2decoderzd2metadat1158z62zz__flac_alsadecz00, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1906z00zz__flac_alsadecz00, BgL_bgl_za762flacza7d2decode1916z00, BGl_z62flaczd2decoderzd2readzd2fl1160zb0zz__flac_alsadecz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string1892z00zz__flac_alsadecz00, BgL_bgl_string1892za700za7za7_1917za7, "Llib/flac_alsadec.scm", 21 );
DEFINE_STRING( BGl_string1899z00zz__flac_alsadecz00, BgL_bgl_string1899za700za7za7_1918za7, "", 0 );
extern obj_t BGl_flaczd2decoderzd2initzd2envzd2zz__flac_flacz00;
DEFINE_STRING( BGl_string1901z00zz__flac_alsadecz00, BgL_bgl_string1901za700za7za7_1919za7, "musicdecoder-init", 17 );
DEFINE_STRING( BGl_string1903z00zz__flac_alsadecz00, BgL_bgl_string1903za700za7za7_1920za7, "musicdecoder-decode", 19 );
DEFINE_STRING( BGl_string1905z00zz__flac_alsadecz00, BgL_bgl_string1905za700za7za7_1921za7, "flac-decoder-metadata", 21 );
DEFINE_STRING( BGl_string1907z00zz__flac_alsadecz00, BgL_bgl_string1907za700za7za7_1922za7, "flac-decoder-read", 17 );
DEFINE_STRING( BGl_string1908z00zz__flac_alsadecz00, BgL_bgl_string1908za700za7za7_1923za7, "__flac_alsadec", 14 );
DEFINE_STRING( BGl_string1909z00zz__flac_alsadecz00, BgL_bgl_string1909za700za7za7_1924za7, "stop ended :start-threshold :avail-min :rate-resample :access rw-interleaved :format :channels :rate-near :buffer-time-near :buffer-size-near :period-size-near s32 s24-3le s16 buffering play pause flac-alsadecoder __flac_alsadec flacalsadec ", 241 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1893z00zz__flac_alsadecz00, BgL_bgl_za762za7c3za704anonymo1925za7, BGl_z62zc3z04anonymousza31180ze3ze5zz__flac_alsadecz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1894z00zz__flac_alsadecz00, BgL_bgl_za762lambda1175za7621926z00, BGl_z62lambda1175z62zz__flac_alsadecz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1895z00zz__flac_alsadecz00, BgL_bgl_za762lambda1172za7621927z00, BGl_z62lambda1172z62zz__flac_alsadecz00, 0L, BUNSPEC, 16 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1896z00zz__flac_alsadecz00, BgL_bgl_za762za7c3za704anonymo1928za7, BGl_z62zc3z04anonymousza31203ze3ze5zz__flac_alsadecz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1897z00zz__flac_alsadecz00, BgL_bgl_za762lambda1201za7621929z00, BGl_z62lambda1201z62zz__flac_alsadecz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1898z00zz__flac_alsadecz00, BgL_bgl_za762lambda1198za7621930z00, BGl_z62lambda1198z62zz__flac_alsadecz00, 0L, BUNSPEC, 12 );
extern obj_t BGl_flaczd2decoderzd2readzd2envzd2zz__flac_flacz00;
BGL_IMPORT obj_t BGl_musicdecoderzd2initzd2envz00zz__multimediazd2musicbufzd2;

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_flacalsadecz00zz__flac_alsadecz00) );
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__flac_alsadecz00) );
ADD_ROOT( (void *)(&BGl_flaczd2alsadecoderzd2zz__flac_alsadecz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__flac_alsadecz00(long BgL_checksumz00_696, char * BgL_fromz00_697)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__flac_alsadecz00))
{ 
BGl_requirezd2initializa7ationz75zz__flac_alsadecz00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__flac_alsadecz00(); 
BGl_libraryzd2moduleszd2initz00zz__flac_alsadecz00(); 
BGl_cnstzd2initzd2zz__flac_alsadecz00(); 
BGl_importedzd2moduleszd2initz00zz__flac_alsadecz00(); 
BGl_objectzd2initzd2zz__flac_alsadecz00(); 
BGl_methodzd2initzd2zz__flac_alsadecz00(); 
return 
BGl_toplevelzd2initzd2zz__flac_alsadecz00();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__flac_alsadecz00()
{
{ /* Llib/flac_alsadec.scm 15 */
BGl_modulezd2initializa7ationz75zz__multimediazd2musicbufzd2(((long)0), "__flac_alsadec"); 
BGl_modulezd2initializa7ationz75zz__alsa_pcmz00(((long)0), "__flac_alsadec"); 
BGl_modulezd2initializa7ationz75zz__threadz00(((long)0), "__flac_alsadec"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__flac_alsadec"); 
BGl_modulezd2initializa7ationz75zz__bexitz00(((long)0), "__flac_alsadec"); 
BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(((long)0), "__flac_alsadec"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__flac_alsadec"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__flac_alsadec"); 
BGl_modulezd2initializa7ationz75zz__alsa_alsaz00(((long)0), "__flac_alsadec"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__flac_alsadec"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__flac_alsadec"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__flac_alsadec"); 
BGl_modulezd2initializa7ationz75zz__customz00(((long)0), "__flac_alsadec"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__flac_alsadecz00()
{
{ /* Llib/flac_alsadec.scm 15 */
{ /* Llib/flac_alsadec.scm 15 */
obj_t BgL_cportz00_528;
{ /* Llib/flac_alsadec.scm 15 */
obj_t BgL_stringz00_536;
BgL_stringz00_536 = BGl_string1909z00zz__flac_alsadecz00; 
{ /* Llib/flac_alsadec.scm 15 */
obj_t BgL_startz00_537;
BgL_startz00_537 = 
BINT(((long)0)); 
{ /* Llib/flac_alsadec.scm 15 */
obj_t BgL_endz00_538;
BgL_endz00_538 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_536))); 
{ /* Llib/flac_alsadec.scm 15 */

BgL_cportz00_528 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_536, BgL_startz00_537, BgL_endz00_538); } } } } 
{ 
long BgL_iz00_529;
BgL_iz00_529 = ((long)21); 
BgL_loopz00_530:
if(
(BgL_iz00_529==((long)-1)))
{ /* Llib/flac_alsadec.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/flac_alsadec.scm 15 */
{ /* Llib/flac_alsadec.scm 15 */
obj_t BgL_arg1911z00_532;
{ /* Llib/flac_alsadec.scm 15 */

{ /* Llib/flac_alsadec.scm 15 */
obj_t BgL_locationz00_534;
BgL_locationz00_534 = 
BBOOL(((bool_t)0)); 
{ /* Llib/flac_alsadec.scm 15 */

BgL_arg1911z00_532 = 
BGl_readz00zz__readerz00(BgL_cportz00_528, BgL_locationz00_534); } } } 
{ /* Llib/flac_alsadec.scm 15 */
int BgL_tmpz00_730;
BgL_tmpz00_730 = 
(int)(BgL_iz00_529); 
CNST_TABLE_SET(BgL_tmpz00_730, BgL_arg1911z00_532); } } 
{ /* Llib/flac_alsadec.scm 15 */
int BgL_auxz00_535;
BgL_auxz00_535 = 
(int)(
(BgL_iz00_529-((long)1))); 
{ 
long BgL_iz00_735;
BgL_iz00_735 = 
(long)(BgL_auxz00_535); 
BgL_iz00_529 = BgL_iz00_735; 
goto BgL_loopz00_530;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__flac_alsadecz00()
{
{ /* Llib/flac_alsadec.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__flac_alsadecz00()
{
{ /* Llib/flac_alsadec.scm 15 */
BGl_modulezd2initializa7ationz75zz__alsa_alsaz00(((long)0), 
BSTRING_TO_STRING(BGl_string1892z00zz__flac_alsadecz00)); 
BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(((long)0), 
BSTRING_TO_STRING(BGl_string1892z00zz__flac_alsadecz00)); 
return BUNSPEC;} 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__flac_alsadecz00()
{
{ /* Llib/flac_alsadec.scm 15 */
{ /* Llib/flac_alsadec.scm 26 */
obj_t BgL_arg1170z00_25;obj_t BgL_arg1171z00_26;
{ /* Llib/flac_alsadec.scm 26 */
obj_t BgL_v1149z00_53;
BgL_v1149z00_53 = 
create_vector(((long)0)); 
BgL_arg1170z00_25 = BgL_v1149z00_53; } 
{ /* Llib/flac_alsadec.scm 26 */
obj_t BgL_v1150z00_54;
BgL_v1150z00_54 = 
create_vector(((long)0)); 
BgL_arg1171z00_26 = BgL_v1150z00_54; } 
BGl_flacalsadecz00zz__flac_alsadecz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)0)), 
CNST_TABLE_REF(((long)1)), BGl_flacdecz00zz__flac_decoderz00, ((long)31914), BGl_proc1895z00zz__flac_alsadecz00, BGl_proc1894z00zz__flac_alsadecz00, BGl_flaczd2decoderzd2initzd2envzd2zz__flac_flacz00, BGl_proc1893z00zz__flac_alsadecz00, BFALSE, BgL_arg1170z00_25, BgL_arg1171z00_26); } 
{ /* Llib/flac_alsadec.scm 30 */
obj_t BgL_arg1196z00_61;obj_t BgL_arg1197z00_62;
{ /* Llib/flac_alsadec.scm 30 */
obj_t BgL_v1151z00_85;
BgL_v1151z00_85 = 
create_vector(((long)0)); 
BgL_arg1196z00_61 = BgL_v1151z00_85; } 
{ /* Llib/flac_alsadec.scm 30 */
obj_t BgL_v1152z00_86;
BgL_v1152z00_86 = 
create_vector(((long)0)); 
BgL_arg1197z00_62 = BgL_v1152z00_86; } 
return ( 
BGl_flaczd2alsadecoderzd2zz__flac_alsadecz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)2)), 
CNST_TABLE_REF(((long)1)), BGl_flacmusicdecoderz00zz__flac_decoderz00, ((long)10516), BGl_proc1898z00zz__flac_alsadecz00, BGl_proc1897z00zz__flac_alsadecz00, BGl_musicdecoderzd2initzd2envz00zz__multimediazd2musicbufzd2, BGl_proc1896z00zz__flac_alsadecz00, BFALSE, BgL_arg1196z00_61, BgL_arg1197z00_62), BUNSPEC) ;} } 

}



/* &<@anonymous:1203> */
obj_t BGl_z62zc3z04anonymousza31203ze3ze5zz__flac_alsadecz00(obj_t BgL_envz00_451, obj_t BgL_new1120z00_452)
{
{ /* Llib/flac_alsadec.scm 30 */
{ 
BgL_flaczd2alsadecoderzd2_bglt BgL_auxz00_752;
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flaczd2alsadecoderzd2_bglt)BgL_new1120z00_452))))->BgL_mimetypesz00)=((obj_t)BNIL),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flaczd2alsadecoderzd2_bglt)BgL_new1120z00_452))))->BgL_bufferzd2timezd2nearz00)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flaczd2alsadecoderzd2_bglt)BgL_new1120z00_452))))->BgL_bufferzd2siza7ezd2nearzd2ratioz75)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flaczd2alsadecoderzd2_bglt)BgL_new1120z00_452))))->BgL_periodzd2siza7ezd2nearzd2ratioz75)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flaczd2alsadecoderzd2_bglt)BgL_new1120z00_452))))->BgL_z52z12dpausez40)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flaczd2alsadecoderzd2_bglt)BgL_new1120z00_452))))->BgL_z52z12dabortz40)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flaczd2alsadecoderzd2_bglt)BgL_new1120z00_452))))->BgL_z52z12stopz40)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flaczd2alsadecoderzd2_bglt)BgL_new1120z00_452))))->BgL_z52dmutexz52)=((obj_t)
BGl_mutexzd2nilzd2zz__threadz00()),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flaczd2alsadecoderzd2_bglt)BgL_new1120z00_452))))->BgL_z52dcondvz52)=((obj_t)
BGl_conditionzd2variablezd2nilz00zz__threadz00()),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flaczd2alsadecoderzd2_bglt)BgL_new1120z00_452))))->BgL_z52doutcondvz52)=((obj_t)
BGl_conditionzd2variablezd2nilz00zz__threadz00()),BUNSPEC); 
((((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)
((BgL_flaczd2alsadecoderzd2_bglt)BgL_new1120z00_452))))->BgL_z52flacz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)
((BgL_flaczd2alsadecoderzd2_bglt)BgL_new1120z00_452))))->BgL_z52inseekz52)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_752 = 
((BgL_flaczd2alsadecoderzd2_bglt)BgL_new1120z00_452); 
return 
((obj_t)BgL_auxz00_752);} } 

}



/* &lambda1201 */
BgL_flaczd2alsadecoderzd2_bglt BGl_z62lambda1201z62zz__flac_alsadecz00(obj_t BgL_envz00_453)
{
{ /* Llib/flac_alsadec.scm 30 */
{ /* Llib/flac_alsadec.scm 30 */
BgL_flaczd2alsadecoderzd2_bglt BgL_new1119z00_542;
BgL_new1119z00_542 = 
((BgL_flaczd2alsadecoderzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_flaczd2alsadecoderzd2_bgl) ))); 
{ /* Llib/flac_alsadec.scm 30 */
long BgL_arg1202z00_543;
{ /* Llib/flac_alsadec.scm 30 */
long BgL_res1748z00_544;
BgL_res1748z00_544 = 
BGL_CLASS_INDEX(BGl_flaczd2alsadecoderzd2zz__flac_alsadecz00); 
BgL_arg1202z00_543 = BgL_res1748z00_544; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1119z00_542), BgL_arg1202z00_543); } 
return BgL_new1119z00_542;} } 

}



/* &lambda1198 */
BgL_flaczd2alsadecoderzd2_bglt BGl_z62lambda1198z62zz__flac_alsadecz00(obj_t BgL_envz00_454, obj_t BgL_mimetypes1107z00_455, obj_t BgL_bufferzd2timezd2near1108z00_456, obj_t BgL_bufferzd2siza7ezd2nearzd2rat1109z75_457, obj_t BgL_periodzd2siza7ezd2nearzd2rat1110z75_458, obj_t BgL_z52z12dpause1111z40_459, obj_t BgL_z52z12dabort1112z40_460, obj_t BgL_z52z12stop1113z40_461, obj_t BgL_z52dmutex1114z52_462, obj_t BgL_z52dcondv1115z52_463, obj_t BgL_z52doutcondv1116z52_464, obj_t BgL_z52flac1117z52_465, obj_t BgL_z52inseek1118z52_466)
{
{ /* Llib/flac_alsadec.scm 30 */
{ /* Llib/flac_alsadec.scm 30 */
int BgL_bufferzd2timezd2near1108z00_546;int BgL_bufferzd2siza7ezd2nearzd2rat1109z75_547;int BgL_periodzd2siza7ezd2nearzd2rat1110z75_548;bool_t BgL_z52z12dpause1111z40_549;bool_t BgL_z52z12dabort1112z40_550;bool_t BgL_z52z12stop1113z40_551;
BgL_bufferzd2timezd2near1108z00_546 = 
CINT(BgL_bufferzd2timezd2near1108z00_456); 
BgL_bufferzd2siza7ezd2nearzd2rat1109z75_547 = 
CINT(BgL_bufferzd2siza7ezd2nearzd2rat1109z75_457); 
BgL_periodzd2siza7ezd2nearzd2rat1110z75_548 = 
CINT(BgL_periodzd2siza7ezd2nearzd2rat1110z75_458); 
BgL_z52z12dpause1111z40_549 = 
CBOOL(BgL_z52z12dpause1111z40_459); 
BgL_z52z12dabort1112z40_550 = 
CBOOL(BgL_z52z12dabort1112z40_460); 
BgL_z52z12stop1113z40_551 = 
CBOOL(BgL_z52z12stop1113z40_461); 
{ /* Llib/flac_alsadec.scm 30 */
BgL_flaczd2alsadecoderzd2_bglt BgL_new1148z00_555;
{ /* Llib/flac_alsadec.scm 30 */
BgL_flaczd2alsadecoderzd2_bglt BgL_new1147z00_556;
BgL_new1147z00_556 = 
((BgL_flaczd2alsadecoderzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_flaczd2alsadecoderzd2_bgl) ))); 
{ /* Llib/flac_alsadec.scm 30 */
long BgL_arg1200z00_557;
{ /* Llib/flac_alsadec.scm 30 */
long BgL_res1747z00_558;
BgL_res1747z00_558 = 
BGL_CLASS_INDEX(BGl_flaczd2alsadecoderzd2zz__flac_alsadecz00); 
BgL_arg1200z00_557 = BgL_res1747z00_558; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1147z00_556), BgL_arg1200z00_557); } 
BgL_new1148z00_555 = BgL_new1147z00_556; } 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1148z00_555)))->BgL_mimetypesz00)=((obj_t)
((obj_t)BgL_mimetypes1107z00_455)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1148z00_555)))->BgL_bufferzd2timezd2nearz00)=((int)BgL_bufferzd2timezd2near1108z00_546),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1148z00_555)))->BgL_bufferzd2siza7ezd2nearzd2ratioz75)=((int)BgL_bufferzd2siza7ezd2nearzd2rat1109z75_547),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1148z00_555)))->BgL_periodzd2siza7ezd2nearzd2ratioz75)=((int)BgL_periodzd2siza7ezd2nearzd2rat1110z75_548),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1148z00_555)))->BgL_z52z12dpausez40)=((bool_t)BgL_z52z12dpause1111z40_549),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1148z00_555)))->BgL_z52z12dabortz40)=((bool_t)BgL_z52z12dabort1112z40_550),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1148z00_555)))->BgL_z52z12stopz40)=((bool_t)BgL_z52z12stop1113z40_551),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1148z00_555)))->BgL_z52dmutexz52)=((obj_t)
((obj_t)BgL_z52dmutex1114z52_462)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1148z00_555)))->BgL_z52dcondvz52)=((obj_t)
((obj_t)BgL_z52dcondv1115z52_463)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1148z00_555)))->BgL_z52doutcondvz52)=((obj_t)
((obj_t)BgL_z52doutcondv1116z52_464)),BUNSPEC); 
((((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)BgL_new1148z00_555)))->BgL_z52flacz52)=((obj_t)BgL_z52flac1117z52_465),BUNSPEC); 
((((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)BgL_new1148z00_555)))->BgL_z52inseekz52)=((obj_t)BgL_z52inseek1118z52_466),BUNSPEC); 
{ /* Llib/flac_alsadec.scm 30 */
obj_t BgL_fun1199z00_559;
BgL_fun1199z00_559 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_flaczd2alsadecoderzd2zz__flac_alsadecz00); 
PROCEDURE_ENTRY(BgL_fun1199z00_559)(BgL_fun1199z00_559, 
((obj_t)BgL_new1148z00_555), BEOA); } 
return BgL_new1148z00_555;} } } 

}



/* &<@anonymous:1180> */
obj_t BGl_z62zc3z04anonymousza31180ze3ze5zz__flac_alsadecz00(obj_t BgL_envz00_467, obj_t BgL_new1105z00_468)
{
{ /* Llib/flac_alsadec.scm 26 */
{ 
BgL_flacalsadecz00_bglt BgL_auxz00_845;
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacalsadecz00_bglt)BgL_new1105z00_468))))->BgL_z42builtinz42)=((FLAC__StreamDecoder *)
0L),BUNSPEC); 
{ 
obj_t BgL_auxz00_850;
{ /* Llib/flac_alsadec.scm 26 */
obj_t BgL_res1746z00_561;
BgL_res1746z00_561 = 
bgl_custom_nil(); 
BgL_auxz00_850 = BgL_res1746z00_561; } 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacalsadecz00_bglt)BgL_new1105z00_468))))->BgL_z52flacbufz52)=((obj_t)BgL_auxz00_850),BUNSPEC); } 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacalsadecz00_bglt)BgL_new1105z00_468))))->BgL_outbufz00)=((obj_t)BGl_string1899z00zz__flac_alsadecz00),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacalsadecz00_bglt)BgL_new1105z00_468))))->BgL_z52eofz52)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacalsadecz00_bglt)BgL_new1105z00_468))))->BgL_z52samplez52)=((long)((long)0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacalsadecz00_bglt)BgL_new1105z00_468))))->BgL_z52volumez52)=((double)((double)0.0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacalsadecz00_bglt)BgL_new1105z00_468))))->BgL_md5checkz00)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacalsadecz00_bglt)BgL_new1105z00_468))))->BgL_z52bchecksumz52)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacalsadecz00_bglt)BgL_new1105z00_468))))->BgL_z52rchecksumz52)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_new1105z00_468))))->BgL_z52musicz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_new1105z00_468))))->BgL_z52bufferz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_new1105z00_468))))->BgL_z52decoderz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_new1105z00_468))))->BgL_z52ratez52)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_new1105z00_468))))->BgL_z52ratezd2maxz80)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_new1105z00_468))))->BgL_z52ratezd2minz80)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_new1105z00_468))))->BgL_z52lastzd2percentagez80)=((int)
(int)(((long)0))),BUNSPEC); 
BgL_auxz00_845 = 
((BgL_flacalsadecz00_bglt)BgL_new1105z00_468); 
return 
((obj_t)BgL_auxz00_845);} } 

}



/* &lambda1175 */
BgL_flacalsadecz00_bglt BGl_z62lambda1175z62zz__flac_alsadecz00(obj_t BgL_envz00_469)
{
{ /* Llib/flac_alsadec.scm 26 */
{ /* Llib/flac_alsadec.scm 26 */
BgL_flacalsadecz00_bglt BgL_new1103z00_562;
BgL_new1103z00_562 = 
((BgL_flacalsadecz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_flacalsadecz00_bgl) ))); 
{ /* Llib/flac_alsadec.scm 26 */
long BgL_arg1179z00_563;
{ /* Llib/flac_alsadec.scm 26 */
long BgL_res1745z00_564;
BgL_res1745z00_564 = 
BGL_CLASS_INDEX(BGl_flacalsadecz00zz__flac_alsadecz00); 
BgL_arg1179z00_563 = BgL_res1745z00_564; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1103z00_562), BgL_arg1179z00_563); } 
return BgL_new1103z00_562;} } 

}



/* &lambda1172 */
BgL_flacalsadecz00_bglt BGl_z62lambda1172z62zz__flac_alsadecz00(obj_t BgL_envz00_470, obj_t BgL_z42builtin1087z42_471, obj_t BgL_z52flacbuf1088z52_472, obj_t BgL_outbuf1089z00_473, obj_t BgL_z52eof1090z52_474, obj_t BgL_z52sample1091z52_475, obj_t BgL_z52volume1092z52_476, obj_t BgL_md5check1093z00_477, obj_t BgL_z52bchecksum1094z52_478, obj_t BgL_z52rchecksum1095z52_479, obj_t BgL_z52music1096z52_480, obj_t BgL_z52buffer1097z52_481, obj_t BgL_z52decoder1098z52_482, obj_t BgL_z52rate1099z52_483, obj_t BgL_z52ratezd2max1100z80_484, obj_t BgL_z52ratezd2min1101z80_485, obj_t BgL_z52lastzd2percentage1102z80_486)
{
{ /* Llib/flac_alsadec.scm 26 */
{ /* Llib/flac_alsadec.scm 26 */
FLAC__StreamDecoder * BgL_z42builtin1087z42_565;bool_t BgL_z52eof1090z52_568;long BgL_z52sample1091z52_569;double BgL_z52volume1092z52_570;bool_t BgL_md5check1093z00_571;int BgL_z52bchecksum1094z52_572;int BgL_z52rchecksum1095z52_573;int BgL_z52rate1099z52_574;int BgL_z52ratezd2max1100z80_575;int BgL_z52ratezd2min1101z80_576;int BgL_z52lastzd2percentage1102z80_577;
BgL_z42builtin1087z42_565 = 
FOREIGN_TO_COBJ(BgL_z42builtin1087z42_471); 
BgL_z52eof1090z52_568 = 
CBOOL(BgL_z52eof1090z52_474); 
BgL_z52sample1091z52_569 = 
(long)CINT(BgL_z52sample1091z52_475); 
BgL_z52volume1092z52_570 = 
REAL_TO_DOUBLE(BgL_z52volume1092z52_476); 
BgL_md5check1093z00_571 = 
CBOOL(BgL_md5check1093z00_477); 
BgL_z52bchecksum1094z52_572 = 
CINT(BgL_z52bchecksum1094z52_478); 
BgL_z52rchecksum1095z52_573 = 
CINT(BgL_z52rchecksum1095z52_479); 
BgL_z52rate1099z52_574 = 
CINT(BgL_z52rate1099z52_483); 
BgL_z52ratezd2max1100z80_575 = 
CINT(BgL_z52ratezd2max1100z80_484); 
BgL_z52ratezd2min1101z80_576 = 
CINT(BgL_z52ratezd2min1101z80_485); 
BgL_z52lastzd2percentage1102z80_577 = 
CINT(BgL_z52lastzd2percentage1102z80_486); 
{ /* Llib/flac_alsadec.scm 26 */
BgL_flacalsadecz00_bglt BgL_new1146z00_578;
{ /* Llib/flac_alsadec.scm 26 */
BgL_flacalsadecz00_bglt BgL_new1145z00_579;
BgL_new1145z00_579 = 
((BgL_flacalsadecz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_flacalsadecz00_bgl) ))); 
{ /* Llib/flac_alsadec.scm 26 */
long BgL_arg1174z00_580;
{ /* Llib/flac_alsadec.scm 26 */
long BgL_res1744z00_581;
BgL_res1744z00_581 = 
BGL_CLASS_INDEX(BGl_flacalsadecz00zz__flac_alsadecz00); 
BgL_arg1174z00_580 = BgL_res1744z00_581; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1145z00_579), BgL_arg1174z00_580); } 
BgL_new1146z00_578 = BgL_new1145z00_579; } 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1146z00_578)))->BgL_z42builtinz42)=((FLAC__StreamDecoder *)BgL_z42builtin1087z42_565),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1146z00_578)))->BgL_z52flacbufz52)=((obj_t)
((obj_t)BgL_z52flacbuf1088z52_472)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1146z00_578)))->BgL_outbufz00)=((obj_t)
((obj_t)BgL_outbuf1089z00_473)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1146z00_578)))->BgL_z52eofz52)=((bool_t)BgL_z52eof1090z52_568),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1146z00_578)))->BgL_z52samplez52)=((long)BgL_z52sample1091z52_569),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1146z00_578)))->BgL_z52volumez52)=((double)BgL_z52volume1092z52_570),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1146z00_578)))->BgL_md5checkz00)=((bool_t)BgL_md5check1093z00_571),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1146z00_578)))->BgL_z52bchecksumz52)=((int)BgL_z52bchecksum1094z52_572),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1146z00_578)))->BgL_z52rchecksumz52)=((int)BgL_z52rchecksum1095z52_573),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1146z00_578)))->BgL_z52musicz52)=((obj_t)BgL_z52music1096z52_480),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1146z00_578)))->BgL_z52bufferz52)=((obj_t)BgL_z52buffer1097z52_481),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1146z00_578)))->BgL_z52decoderz52)=((obj_t)BgL_z52decoder1098z52_482),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1146z00_578)))->BgL_z52ratez52)=((int)BgL_z52rate1099z52_574),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1146z00_578)))->BgL_z52ratezd2maxz80)=((int)BgL_z52ratezd2max1100z80_575),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1146z00_578)))->BgL_z52ratezd2minz80)=((int)BgL_z52ratezd2min1101z80_576),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1146z00_578)))->BgL_z52lastzd2percentagez80)=((int)BgL_z52lastzd2percentage1102z80_577),BUNSPEC); 
{ /* Llib/flac_alsadec.scm 26 */
obj_t BgL_fun1173z00_582;
BgL_fun1173z00_582 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_flacalsadecz00zz__flac_alsadecz00); 
PROCEDURE_ENTRY(BgL_fun1173z00_582)(BgL_fun1173z00_582, 
((obj_t)BgL_new1146z00_578), BEOA); } 
return BgL_new1146z00_578;} } } 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__flac_alsadecz00()
{
{ /* Llib/flac_alsadec.scm 15 */
return BUNSPEC;} 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__flac_alsadecz00()
{
{ /* Llib/flac_alsadec.scm 15 */
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2initzd2envz00zz__multimediazd2musicbufzd2, BGl_flaczd2alsadecoderzd2zz__flac_alsadecz00, BGl_proc1900z00zz__flac_alsadecz00, BGl_string1901z00zz__flac_alsadecz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2decodezd2envz00zz__multimediazd2musicbufzd2, BGl_flaczd2alsadecoderzd2zz__flac_alsadecz00, BGl_proc1902z00zz__flac_alsadecz00, BGl_string1903z00zz__flac_alsadecz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_flaczd2decoderzd2metadatazd2envzd2zz__flac_flacz00, BGl_flacalsadecz00zz__flac_alsadecz00, BGl_proc1904z00zz__flac_alsadecz00, BGl_string1905z00zz__flac_alsadecz00); 
return 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_flaczd2decoderzd2readzd2envzd2zz__flac_flacz00, BGl_flacalsadecz00zz__flac_alsadecz00, BGl_proc1906z00zz__flac_alsadecz00, BGl_string1907z00zz__flac_alsadecz00);} 

}



/* &flac-decoder-read-fl1160 */
obj_t BGl_z62flaczd2decoderzd2readzd2fl1160zb0zz__flac_alsadecz00(obj_t BgL_envz00_496, obj_t BgL_oz00_497, obj_t BgL_siza7eza7_498)
{
{ /* Llib/flac_alsadec.scm 97 */
{ /* Llib/flac_alsadec.scm 98 */
long BgL_siza7eza7_584;
BgL_siza7eza7_584 = 
(long)CINT(BgL_siza7eza7_498); 
{ /* Llib/flac_alsadec.scm 100 */
BgL_musicdecoderz00_bglt BgL_i1138z00_585;
BgL_i1138z00_585 = 
((BgL_musicdecoderz00_bglt)
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_497))))->BgL_z52decoderz52)); 
{ /* Llib/flac_alsadec.scm 101 */
BgL_musicbufferz00_bglt BgL_i1139z00_586;
BgL_i1139z00_586 = 
((BgL_musicbufferz00_bglt)
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_497))))->BgL_z52bufferz52)); 
{ /* Llib/flac_alsadec.scm 101 */
long BgL_inlenz00_587;
BgL_inlenz00_587 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1139z00_586))->BgL_z52inlenz52); 
{ /* Llib/flac_alsadec.scm 109 */
char * BgL_flacbufz00_588;
{ /* Llib/flac_alsadec.scm 109 */
obj_t BgL_arg1743z00_589;
BgL_arg1743z00_589 = 
(((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_497)))))->BgL_z52flacbufz52); 
BgL_flacbufz00_588 = 
CUSTOM_IDENTIFIER(BgL_arg1743z00_589); } 
{ 

{ 

{ 
long BgL_siza7eza7_606;
{ 
long BgL_siza7eza7_615;long BgL_iz00_616;
BgL_siza7eza7_615 = BgL_siza7eza7_584; 
BgL_iz00_616 = ((long)0); 
BgL_loopz00_614:
if(
(((BgL_musicdecoderz00_bglt)COBJECT(BgL_i1138z00_585))->BgL_z52z12dpausez40))
{ /* Llib/flac_alsadec.scm 156 */
{ /* Llib/flac_alsadec.scm 157 */
obj_t BgL_arg1517z00_617;
BgL_arg1517z00_617 = 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_497))))->BgL_z52musicz52); 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_arg1517z00_617), 
CNST_TABLE_REF(((long)3))); } 
{ /* Llib/flac_alsadec.scm 159 */
BgL_alsamusicz00_bglt BgL_i1141z00_618;
BgL_i1141z00_618 = 
((BgL_alsamusicz00_bglt)
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_497))))->BgL_z52musicz52)); 
{ /* Llib/flac_alsadec.scm 160 */
BgL_musicstatusz00_bglt BgL_i1142z00_619;
BgL_i1142z00_619 = 
(((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)BgL_i1141z00_618)))->BgL_z52statusz52); 
{ 
obj_t BgL_auxz00_997;
{ /* Llib/flac_alsadec.scm 162 */
obj_t BgL_arg1518z00_620;obj_t BgL_arg1524z00_621;
BgL_arg1518z00_620 = 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_497))))->BgL_z52decoderz52); 
BgL_arg1524z00_621 = 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_497))))->BgL_z52bufferz52); 
BgL_auxz00_997 = 
BINT(
BGl_musicdecoderzd2positionzd2zz__multimediazd2musicbufzd2(
((BgL_musicdecoderz00_bglt)BgL_arg1518z00_620), 
((BgL_musicbufferz00_bglt)BgL_arg1524z00_621))); } 
((((BgL_musicstatusz00_bglt)COBJECT(BgL_i1142z00_619))->BgL_songposz00)=((obj_t)BgL_auxz00_997),BUNSPEC); } } } 
{ /* Llib/flac_alsadec.scm 163 */
obj_t BgL_mutex1525z00_622;
BgL_mutex1525z00_622 = 
(((BgL_musicdecoderz00_bglt)COBJECT(BgL_i1138z00_585))->BgL_z52dmutexz52); 
BGL_MUTEX_LOCK(BgL_mutex1525z00_622); 
{ /* Llib/flac_alsadec.scm 163 */
bool_t BgL_tmp1934z00_1010;
{ 

BgL_liipz00_623:
if(
(((BgL_musicdecoderz00_bglt)COBJECT(BgL_i1138z00_585))->BgL_z52z12dpausez40))
{ /* Llib/flac_alsadec.scm 165 */
{ /* Llib/flac_alsadec.scm 166 */
obj_t BgL_arg1537z00_624;obj_t BgL_arg1545z00_625;
BgL_arg1537z00_624 = 
(((BgL_musicdecoderz00_bglt)COBJECT(BgL_i1138z00_585))->BgL_z52dcondvz52); 
BgL_arg1545z00_625 = 
(((BgL_musicdecoderz00_bglt)COBJECT(BgL_i1138z00_585))->BgL_z52dmutexz52); 
{ /* Llib/flac_alsadec.scm 166 */

{ /* Llib/flac_alsadec.scm 166 */
bool_t BgL_res1779z00_626;
BgL_res1779z00_626 = 
BGL_CONDVAR_WAIT(BgL_arg1537z00_624, BgL_arg1545z00_625); BgL_res1779z00_626; } } } 
goto BgL_liipz00_623;}  else 
{ /* Llib/flac_alsadec.scm 165 */
BgL_tmp1934z00_1010 = ((bool_t)0); } } 
BGL_MUTEX_UNLOCK(BgL_mutex1525z00_622); BgL_tmp1934z00_1010; } } 
{ /* Llib/flac_alsadec.scm 168 */
obj_t BgL_arg1546z00_627;
BgL_arg1546z00_627 = 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_497))))->BgL_z52musicz52); 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_arg1546z00_627), 
CNST_TABLE_REF(((long)4))); } 
{ 

goto BgL_loopz00_614;} }  else 
{ /* Llib/flac_alsadec.scm 156 */
if(
(((BgL_musicdecoderz00_bglt)COBJECT(BgL_i1138z00_585))->BgL_z52z12dabortz40))
{ /* Llib/flac_alsadec.scm 170 */
return 
BINT(((long)-1));}  else 
{ /* Llib/flac_alsadec.scm 170 */
if(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1139z00_586))->BgL_z52emptyz52))
{ /* Llib/flac_alsadec.scm 173 */
if(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1139z00_586))->BgL_z52eofz52))
{ /* Llib/flac_alsadec.scm 175 */
return BEOF;}  else 
{ /* Llib/flac_alsadec.scm 175 */
{ /* Llib/flac_alsadec.scm 178 */
BgL_alsamusicz00_bglt BgL_i1143z00_628;
BgL_i1143z00_628 = 
((BgL_alsamusicz00_bglt)
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_497))))->BgL_z52musicz52)); 
{ /* Llib/flac_alsadec.scm 179 */
BgL_musicstatusz00_bglt BgL_i1144z00_629;
BgL_i1144z00_629 = 
(((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)BgL_i1143z00_628)))->BgL_z52statusz52); 
{ 
int BgL_auxz00_1037;
{ /* Llib/flac_alsadec.scm 181 */
long BgL_tmpz00_1038;
{ /* Llib/flac_alsadec.scm 114 */
BGL_LONGLONG_T BgL_arg1718z00_591;
{ /* Llib/flac_alsadec.scm 114 */
BGL_LONGLONG_T BgL_arg1719z00_592;BGL_LONGLONG_T BgL_arg1722z00_593;
{ /* Llib/flac_alsadec.scm 114 */
BGL_LONGLONG_T BgL_arg1728z00_594;
{ /* Llib/flac_alsadec.scm 114 */
long BgL_arg1740z00_595;
{ /* Llib/flac_alsadec.scm 114 */
obj_t BgL_arg1741z00_596;
BgL_arg1741z00_596 = 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_497))))->BgL_z52bufferz52); 
BgL_arg1740z00_595 = 
BGl_musicbufferzd2availablezd2zz__multimediazd2musicbufzd2(
((BgL_musicbufferz00_bglt)BgL_arg1741z00_596)); } 
{ /* Llib/flac_alsadec.scm 114 */
BGL_LONGLONG_T BgL_res1756z00_597;
BgL_res1756z00_597 = 
LONG_TO_LLONG(BgL_arg1740z00_595); 
BgL_arg1728z00_594 = BgL_res1756z00_597; } } 
BgL_arg1719z00_592 = 
(((BGL_LONGLONG_T)100)*BgL_arg1728z00_594); } 
{ /* Llib/flac_alsadec.scm 115 */
BGL_LONGLONG_T BgL_res1758z00_598;
BgL_res1758z00_598 = 
LONG_TO_LLONG(BgL_inlenz00_587); 
BgL_arg1722z00_593 = BgL_res1758z00_598; } 
{ /* Llib/flac_alsadec.scm 113 */
BGL_LONGLONG_T BgL_res1759z00_599;
BgL_res1759z00_599 = 
(BgL_arg1719z00_592/BgL_arg1722z00_593); 
BgL_arg1718z00_591 = BgL_res1759z00_599; } } 
{ /* Llib/flac_alsadec.scm 112 */
long BgL_res1760z00_600;
BgL_res1760z00_600 = 
LLONG_TO_LONG(BgL_arg1718z00_591); 
BgL_tmpz00_1038 = BgL_res1760z00_600; } } 
BgL_auxz00_1037 = 
(int)(BgL_tmpz00_1038); } 
((((BgL_musicstatusz00_bglt)COBJECT(BgL_i1144z00_629))->BgL_bufferingz00)=((int)BgL_auxz00_1037),BUNSPEC); } } } 
{ /* Llib/flac_alsadec.scm 182 */
obj_t BgL_arg1560z00_630;
BgL_arg1560z00_630 = 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_497))))->BgL_z52musicz52); 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_arg1560z00_630), 
CNST_TABLE_REF(((long)5))); } 
{ /* Llib/flac_alsadec.scm 183 */
obj_t BgL_mutex1561z00_631;
BgL_mutex1561z00_631 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1139z00_586))->BgL_z52bmutexz52); 
{ /* Llib/flac_alsadec.scm 183 */
obj_t BgL_top1940z00_1059;
BgL_top1940z00_1059 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGL_MUTEX_LOCK(BgL_mutex1561z00_631); 
BGL_EXITD_PUSH_PROTECT(BgL_top1940z00_1059, BgL_mutex1561z00_631); BUNSPEC; 
{ /* Llib/flac_alsadec.scm 183 */
bool_t BgL_tmp1939z00_1058;
{ /* Llib/flac_alsadec.scm 185 */
bool_t BgL_test1941z00_1063;
if(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1139z00_586))->BgL_z52emptyz52))
{ /* Llib/flac_alsadec.scm 185 */
if(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1139z00_586))->BgL_z52eofz52))
{ /* Llib/flac_alsadec.scm 185 */
BgL_test1941z00_1063 = ((bool_t)1)
; }  else 
{ /* Llib/flac_alsadec.scm 185 */
if(
(((BgL_musicdecoderz00_bglt)COBJECT(BgL_i1138z00_585))->BgL_z52z12dabortz40))
{ /* Llib/flac_alsadec.scm 185 */
BgL_test1941z00_1063 = ((bool_t)1)
; }  else 
{ /* Llib/flac_alsadec.scm 185 */
if(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1139z00_586))->BgL_z52emptyz52))
{ /* Llib/flac_alsadec.scm 119 */
BgL_test1941z00_1063 = ((bool_t)0)
; }  else 
{ /* Llib/flac_alsadec.scm 120 */
long BgL_arg1707z00_602;
{ /* Llib/flac_alsadec.scm 120 */
long BgL_arg1708z00_603;
{ /* Llib/flac_alsadec.scm 120 */
obj_t BgL_arg1711z00_604;
BgL_arg1711z00_604 = 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_497))))->BgL_z52bufferz52); 
BgL_arg1708z00_603 = 
BGl_musicbufferzd2availablezd2zz__multimediazd2musicbufzd2(
((BgL_musicbufferz00_bglt)BgL_arg1711z00_604)); } 
BgL_arg1707z00_602 = 
(((long)4)*BgL_arg1708z00_603); } 
BgL_test1941z00_1063 = 
(BgL_arg1707z00_602>BgL_inlenz00_587); } } } }  else 
{ /* Llib/flac_alsadec.scm 185 */
BgL_test1941z00_1063 = ((bool_t)1)
; } 
if(BgL_test1941z00_1063)
{ /* Llib/flac_alsadec.scm 185 */
BgL_tmp1939z00_1058 = ((bool_t)0); }  else 
{ /* Llib/flac_alsadec.scm 189 */
obj_t BgL_arg1577z00_632;obj_t BgL_arg1578z00_633;
BgL_arg1577z00_632 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1139z00_586))->BgL_z52bcondvz52); 
BgL_arg1578z00_633 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1139z00_586))->BgL_z52bmutexz52); 
{ /* Llib/flac_alsadec.scm 189 */

{ /* Llib/flac_alsadec.scm 189 */
bool_t BgL_res1781z00_634;
BgL_res1781z00_634 = 
BGL_CONDVAR_WAIT(BgL_arg1577z00_632, BgL_arg1578z00_633); 
BgL_tmp1939z00_1058 = BgL_res1781z00_634; } } } } 
BGL_EXITD_POP_PROTECT(BgL_top1940z00_1059); BUNSPEC; 
BGL_MUTEX_UNLOCK(BgL_mutex1561z00_631); BgL_tmp1939z00_1058; } } } 
{ /* Llib/flac_alsadec.scm 190 */
obj_t BgL_arg1579z00_635;
BgL_arg1579z00_635 = 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_497))))->BgL_z52musicz52); 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_arg1579z00_635), 
CNST_TABLE_REF(((long)4))); } 
{ 

goto BgL_loopz00_614;} } }  else 
{ /* Llib/flac_alsadec.scm 193 */
long BgL_sz00_636;
{ /* Llib/flac_alsadec.scm 193 */
long BgL_bz00_637;
if(
(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1139z00_586))->BgL_z52headz52)>
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1139z00_586))->BgL_z52tailz52)))
{ /* Llib/flac_alsadec.scm 194 */
BgL_bz00_637 = 
(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1139z00_586))->BgL_z52headz52)-
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1139z00_586))->BgL_z52tailz52)); }  else 
{ /* Llib/flac_alsadec.scm 194 */
BgL_bz00_637 = 
(BgL_inlenz00_587-
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1139z00_586))->BgL_z52tailz52)); } 
if(
(BgL_siza7eza7_615<BgL_bz00_637))
{ /* Llib/flac_alsadec.scm 194 */
BgL_sz00_636 = BgL_siza7eza7_615; }  else 
{ /* Llib/flac_alsadec.scm 194 */
BgL_sz00_636 = BgL_bz00_637; } } 
if(
(BgL_sz00_636>((long)0)))
{ /* Llib/flac_alsadec.scm 197 */
{ /* Llib/flac_alsadec.scm 198 */
char * BgL_arg1590z00_638;long BgL_arg1591z00_639;
BgL_arg1590z00_638 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1139z00_586))->BgL_z52inbufpz52); 
BgL_arg1591z00_639 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1139z00_586))->BgL_z52tailz52); 
BGL_FLAC_BLIT_STRING(BgL_arg1590z00_638, BgL_arg1591z00_639, BgL_flacbufz00_588, BgL_iz00_616, BgL_sz00_636); BUNSPEC; } 
BgL_siza7eza7_606 = BgL_sz00_636; 
{ /* Llib/flac_alsadec.scm 128 */
long BgL_ntailz00_607;
BgL_ntailz00_607 = 
(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1139z00_586))->BgL_z52tailz52)+BgL_siza7eza7_606); 
if(
(BgL_ntailz00_607==BgL_inlenz00_587))
{ /* Llib/flac_alsadec.scm 129 */
BgL_ntailz00_607 = ((long)0); }  else 
{ /* Llib/flac_alsadec.scm 129 */BFALSE; } 
if(
(BgL_ntailz00_607==
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1139z00_586))->BgL_z52headz52)))
{ /* Llib/flac_alsadec.scm 132 */
if(
(
(long)(
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_497))))->BgL_z52ratez52))<((long)80)))
{ /* Llib/flac_alsadec.scm 133 */
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_497))))->BgL_z52ratez52)=((int)
(int)(((long)80))),BUNSPEC); }  else 
{ /* Llib/flac_alsadec.scm 133 */BFALSE; } 
((((BgL_musicbufferz00_bglt)COBJECT(BgL_i1139z00_586))->BgL_z52emptyz52)=((bool_t)((bool_t)1)),BUNSPEC); }  else 
{ /* Llib/flac_alsadec.scm 132 */BFALSE; } 
((((BgL_musicbufferz00_bglt)COBJECT(BgL_i1139z00_586))->BgL_z52tailz52)=((long)BgL_ntailz00_607),BUNSPEC); } 
if(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1139z00_586))->BgL_z52eofz52))
{ /* Llib/flac_alsadec.scm 137 */BFALSE; }  else 
{ /* Llib/flac_alsadec.scm 140 */
long BgL_availz00_608;
{ /* Llib/flac_alsadec.scm 140 */
obj_t BgL_arg1698z00_609;
BgL_arg1698z00_609 = 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_497))))->BgL_z52bufferz52); 
BgL_availz00_608 = 
BGl_musicbufferzd2availablezd2zz__multimediazd2musicbufzd2(
((BgL_musicbufferz00_bglt)BgL_arg1698z00_609)); } 
{ /* Llib/flac_alsadec.scm 140 */
long BgL_pz00_610;
BgL_pz00_610 = 
(
(BgL_availz00_608*((long)100))/BgL_inlenz00_587); 
{ /* Llib/flac_alsadec.scm 141 */

if(
(BgL_pz00_610<
(long)(
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_497))))->BgL_z52ratez52))))
{ /* Llib/flac_alsadec.scm 143 */
{ /* Llib/flac_alsadec.scm 123 */
obj_t BgL_mutex1700z00_611;
BgL_mutex1700z00_611 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1139z00_586))->BgL_z52bmutexz52); 
BGL_MUTEX_LOCK(BgL_mutex1700z00_611); 
{ /* Llib/flac_alsadec.scm 123 */
bool_t BgL_tmp1954z00_1141;
{ /* Llib/flac_alsadec.scm 124 */
obj_t BgL_arg1701z00_612;
BgL_arg1701z00_612 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1139z00_586))->BgL_z52bcondvz52); 
{ /* Llib/flac_alsadec.scm 124 */
bool_t BgL_res1771z00_613;
BgL_res1771z00_613 = 
BGL_CONDVAR_BROADCAST(BgL_arg1701z00_612); 
BgL_tmp1954z00_1141 = BgL_res1771z00_613; } } 
BGL_MUTEX_UNLOCK(BgL_mutex1700z00_611); BgL_tmp1954z00_1141; } } 
{ /* Llib/flac_alsadec.scm 145 */
bool_t BgL_test1955z00_1146;
if(
(BgL_pz00_610<=
(long)(
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_497))))->BgL_z52lastzd2percentagez80))))
{ /* Llib/flac_alsadec.scm 145 */
BgL_test1955z00_1146 = 
(
(long)(
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_497))))->BgL_z52ratez52))<
(long)(
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_497))))->BgL_z52ratezd2maxz80)))
; }  else 
{ /* Llib/flac_alsadec.scm 145 */
BgL_test1955z00_1146 = ((bool_t)0)
; } 
if(BgL_test1955z00_1146)
{ /* Llib/flac_alsadec.scm 145 */
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_497))))->BgL_z52ratez52)=((int)
(int)(
(
(long)(
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_497))))->BgL_z52ratez52))+((long)10)))),BUNSPEC); }  else 
{ /* Llib/flac_alsadec.scm 145 */BFALSE; } } }  else 
{ /* Llib/flac_alsadec.scm 143 */
if(
(BgL_pz00_610>
(long)(
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_497))))->BgL_z52ratezd2minz80))))
{ /* Llib/flac_alsadec.scm 147 */
if(
(
(long)(
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_497))))->BgL_z52ratez52))>
(long)(
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_497))))->BgL_z52ratezd2minz80))))
{ /* Llib/flac_alsadec.scm 148 */
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_497))))->BgL_z52ratez52)=((int)
(int)(
(
(long)(
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_497))))->BgL_z52ratez52))-((long)1)))),BUNSPEC); }  else 
{ /* Llib/flac_alsadec.scm 148 */BFALSE; } }  else 
{ /* Llib/flac_alsadec.scm 147 */BFALSE; } } 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_497))))->BgL_z52lastzd2percentagez80)=((int)
(int)(BgL_pz00_610)),BUNSPEC); BUNSPEC; } } } }  else 
{ /* Llib/flac_alsadec.scm 197 */BFALSE; } 
if(
(BgL_sz00_636<BgL_siza7eza7_615))
{ 
long BgL_iz00_1204;long BgL_siza7eza7_1202;
BgL_siza7eza7_1202 = 
(BgL_siza7eza7_615-BgL_sz00_636); 
BgL_iz00_1204 = 
(BgL_iz00_616+BgL_sz00_636); 
BgL_iz00_616 = BgL_iz00_1204; 
BgL_siza7eza7_615 = BgL_siza7eza7_1202; 
goto BgL_loopz00_614;}  else 
{ /* Llib/flac_alsadec.scm 200 */
return 
BINT(
(BgL_iz00_616+BgL_sz00_636));} } } } } } } } } } } } } } 

}



/* &flac-decoder-metadat1158 */
obj_t BGl_z62flaczd2decoderzd2metadat1158z62zz__flac_alsadecz00(obj_t BgL_envz00_499, obj_t BgL_oz00_500, obj_t BgL_totalz00_501, obj_t BgL_ratez00_502, obj_t BgL_channelsz00_503, obj_t BgL_bpsz00_504)
{
{ /* Llib/flac_alsadec.scm 72 */
{ /* Llib/flac_alsadec.scm 74 */
BgL_alsamusicz00_bglt BgL_i1134z00_641;
BgL_i1134z00_641 = 
((BgL_alsamusicz00_bglt)
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_500))))->BgL_z52musicz52)); 
{ /* Llib/flac_alsadec.scm 75 */
obj_t BgL_encodingz00_642;
if(
INTEGERP(BgL_bpsz00_504))
{ /* Llib/flac_alsadec.scm 75 */
switch( 
(long)CINT(BgL_bpsz00_504)) { case ((long)8) : 

BgL_encodingz00_642 = 
CNST_TABLE_REF(((long)6)); break;case ((long)16) : 

BgL_encodingz00_642 = 
CNST_TABLE_REF(((long)6)); break;case ((long)24) : 

BgL_encodingz00_642 = 
CNST_TABLE_REF(((long)7)); break;case ((long)32) : 

BgL_encodingz00_642 = 
CNST_TABLE_REF(((long)8)); break;
default: 
BgL_encodingz00_642 = BUNSPEC; } }  else 
{ /* Llib/flac_alsadec.scm 75 */
BgL_encodingz00_642 = BUNSPEC; } 
BGl_alsazd2sndzd2pcmzd2reopenzd2zz__alsa_pcmz00(
(((BgL_alsamusicz00_bglt)COBJECT(BgL_i1134z00_641))->BgL_pcmz00)); 
{ /* Llib/flac_alsadec.scm 81 */
BgL_alsazd2sndzd2pcmz00_bglt BgL_arg1266z00_643;long BgL_arg1267z00_644;long BgL_arg1268z00_645;
BgL_arg1266z00_643 = 
(((BgL_alsamusicz00_bglt)COBJECT(BgL_i1134z00_641))->BgL_pcmz00); 
BgL_arg1267z00_644 = 
(
(long)CINT(BgL_ratez00_502)/((long)2)); 
BgL_arg1268z00_645 = 
(
(long)CINT(BgL_ratez00_502)/((long)8)); 
{ /* Llib/flac_alsadec.scm 81 */
obj_t BgL_list1269z00_646;
{ /* Llib/flac_alsadec.scm 81 */
obj_t BgL_arg1281z00_647;
{ /* Llib/flac_alsadec.scm 81 */
obj_t BgL_arg1300z00_648;
{ /* Llib/flac_alsadec.scm 81 */
obj_t BgL_arg1325z00_649;
{ /* Llib/flac_alsadec.scm 81 */
obj_t BgL_arg1326z00_650;
{ /* Llib/flac_alsadec.scm 81 */
obj_t BgL_arg1330z00_651;
{ /* Llib/flac_alsadec.scm 81 */
obj_t BgL_arg1333z00_652;
{ /* Llib/flac_alsadec.scm 81 */
obj_t BgL_arg1334z00_653;
{ /* Llib/flac_alsadec.scm 81 */
obj_t BgL_arg1336z00_654;
{ /* Llib/flac_alsadec.scm 81 */
obj_t BgL_arg1337z00_655;
{ /* Llib/flac_alsadec.scm 81 */
obj_t BgL_arg1338z00_656;
{ /* Llib/flac_alsadec.scm 81 */
obj_t BgL_arg1347z00_657;
{ /* Llib/flac_alsadec.scm 81 */
obj_t BgL_arg1348z00_658;
{ /* Llib/flac_alsadec.scm 81 */
obj_t BgL_arg1349z00_659;
{ /* Llib/flac_alsadec.scm 81 */
obj_t BgL_arg1351z00_660;
{ /* Llib/flac_alsadec.scm 81 */
obj_t BgL_arg1352z00_661;
BgL_arg1352z00_661 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1268z00_645), BNIL); 
BgL_arg1351z00_660 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)9)), BgL_arg1352z00_661); } 
BgL_arg1349z00_659 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1267z00_644), BgL_arg1351z00_660); } 
BgL_arg1348z00_658 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)10)), BgL_arg1349z00_659); } 
BgL_arg1347z00_657 = 
MAKE_YOUNG_PAIR(
BINT(((long)500000)), BgL_arg1348z00_658); } 
BgL_arg1338z00_656 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)11)), BgL_arg1347z00_657); } 
BgL_arg1337z00_655 = 
MAKE_YOUNG_PAIR(BgL_ratez00_502, BgL_arg1338z00_656); } 
BgL_arg1336z00_654 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)12)), BgL_arg1337z00_655); } 
BgL_arg1334z00_653 = 
MAKE_YOUNG_PAIR(BgL_channelsz00_503, BgL_arg1336z00_654); } 
BgL_arg1333z00_652 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)13)), BgL_arg1334z00_653); } 
BgL_arg1330z00_651 = 
MAKE_YOUNG_PAIR(BgL_encodingz00_642, BgL_arg1333z00_652); } 
BgL_arg1326z00_650 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)14)), BgL_arg1330z00_651); } 
BgL_arg1325z00_649 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)15)), BgL_arg1326z00_650); } 
BgL_arg1300z00_648 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)16)), BgL_arg1325z00_649); } 
BgL_arg1281z00_647 = 
MAKE_YOUNG_PAIR(
BINT(((long)1)), BgL_arg1300z00_648); } 
BgL_list1269z00_646 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)17)), BgL_arg1281z00_647); } 
BGl_alsazd2sndzd2pcmzd2hwzd2setzd2paramsz12zc0zz__alsa_pcmz00(BgL_arg1266z00_643, BgL_list1269z00_646); } } 
{ /* Llib/flac_alsadec.scm 90 */
BgL_alsazd2sndzd2pcmz00_bglt BgL_arg1353z00_662;
BgL_arg1353z00_662 = 
(((BgL_alsamusicz00_bglt)COBJECT(BgL_i1134z00_641))->BgL_pcmz00); 
{ /* Llib/flac_alsadec.scm 90 */
obj_t BgL_list1354z00_663;
{ /* Llib/flac_alsadec.scm 90 */
obj_t BgL_arg1383z00_664;
{ /* Llib/flac_alsadec.scm 90 */
obj_t BgL_arg1384z00_665;
{ /* Llib/flac_alsadec.scm 90 */
obj_t BgL_arg1505z00_666;
BgL_arg1505z00_666 = 
MAKE_YOUNG_PAIR(
BINT(((long)1)), BNIL); 
BgL_arg1384z00_665 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)18)), BgL_arg1505z00_666); } 
BgL_arg1383z00_664 = 
MAKE_YOUNG_PAIR(
BINT(((long)1)), BgL_arg1384z00_665); } 
BgL_list1354z00_663 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)19)), BgL_arg1383z00_664); } 
return 
BGl_alsazd2sndzd2pcmzd2swzd2setzd2paramsz12zc0zz__alsa_pcmz00(BgL_arg1353z00_662, BgL_list1354z00_663);} } } } } 

}



/* &musicdecoder-decode-1156 */
obj_t BGl_z62musicdecoderzd2decodezd21156z62zz__flac_alsadecz00(obj_t BgL_envz00_505, obj_t BgL_decz00_506, obj_t BgL_amz00_507, obj_t BgL_bufferz00_508)
{
{ /* Llib/flac_alsadec.scm 50 */
{ /* Llib/flac_alsadec.scm 54 */
BgL_flacdecz00_bglt BgL_i1125z00_670;
BgL_i1125z00_670 = 
((BgL_flacdecz00_bglt)
(((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)
((BgL_flaczd2alsadecoderzd2_bglt)BgL_decz00_506))))->BgL_z52flacz52)); 
((((BgL_flacdecz00_bglt)COBJECT(BgL_i1125z00_670))->BgL_z52bufferz52)=((obj_t)
((obj_t)
((BgL_musicbufferz00_bglt)BgL_bufferz00_508))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(BgL_i1125z00_670))->BgL_z52musicz52)=((obj_t)
((obj_t)
((BgL_musicbufz00_bglt)BgL_amz00_507))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(BgL_i1125z00_670))->BgL_z52decoderz52)=((obj_t)
((obj_t)
((BgL_flaczd2alsadecoderzd2_bglt)BgL_decz00_506))),BUNSPEC); 
{ /* Llib/flac_alsadec.scm 60 */
obj_t BgL_exitd1128z00_671;
BgL_exitd1128z00_671 = 
BGL_EXITD_TOP_AS_OBJ(); 
{ /* Llib/flac_alsadec.scm 65 */
obj_t BgL_zc3z04anonymousza31232ze3z87_672;
BgL_zc3z04anonymousza31232ze3z87_672 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31232ze3ze5zz__flac_alsadecz00, 
(int)(((long)0)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31232ze3z87_672, 
(int)(((long)0)), 
((obj_t)BgL_i1125z00_670)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31232ze3z87_672, 
(int)(((long)1)), 
((obj_t)
((BgL_alsamusicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_507)))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31232ze3z87_672, 
(int)(((long)2)), 
((obj_t)
((BgL_musicbufz00_bglt)BgL_amz00_507))); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1128z00_671, BgL_zc3z04anonymousza31232ze3z87_672); 
{ /* Llib/flac_alsadec.scm 61 */
obj_t BgL_tmp1130z00_673;
{ /* Llib/flac_alsadec.scm 61 */
BgL_alsazd2sndzd2pcmz00_bglt BgL_i1132z00_674;
BgL_i1132z00_674 = 
(((BgL_alsamusicz00_bglt)COBJECT(
((BgL_alsamusicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_507))))->BgL_pcmz00); 
if(
(
(long)(
(((BgL_alsazd2sndzd2pcmz00_bglt)COBJECT(BgL_i1132z00_674))->BgL_hwbpsz00))<=((long)16)))
{ /* Llib/flac_alsadec.scm 63 */
obj_t BgL_arg1218z00_675;
BgL_arg1218z00_675 = 
(((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)
((BgL_flaczd2alsadecoderzd2_bglt)BgL_decz00_506))))->BgL_z52flacz52); 
BgL_tmp1130z00_673 = 
BGl_flaczd2decoderzd2decode16z00zz__flac_flacz00(
((BgL_flaczd2decoderzd2_bglt)BgL_arg1218z00_675)); }  else 
{ /* Llib/flac_alsadec.scm 64 */
obj_t BgL_arg1230z00_676;
BgL_arg1230z00_676 = 
(((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)
((BgL_flaczd2alsadecoderzd2_bglt)BgL_decz00_506))))->BgL_z52flacz52); 
BgL_tmp1130z00_673 = 
BGl_flaczd2decoderzd2decodez00zz__flac_flacz00(
((BgL_flaczd2decoderzd2_bglt)BgL_arg1230z00_676)); } } 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1128z00_671); 
BGl_z62zc3z04anonymousza31232ze3ze5zz__flac_alsadecz00(BgL_zc3z04anonymousza31232ze3z87_672); 
return BgL_tmp1130z00_673;} } } } } 

}



/* &<@anonymous:1232> */
obj_t BGl_z62zc3z04anonymousza31232ze3ze5zz__flac_alsadecz00(obj_t BgL_envz00_509)
{
{ /* Llib/flac_alsadec.scm 60 */
{ /* Llib/flac_alsadec.scm 65 */
BgL_flacdecz00_bglt BgL_i1125z00_510;BgL_alsamusicz00_bglt BgL_i1126z00_511;BgL_musicbufz00_bglt BgL_amz00_512;
BgL_i1125z00_510 = 
((BgL_flacdecz00_bglt)
PROCEDURE_REF(BgL_envz00_509, 
(int)(((long)0)))); 
BgL_i1126z00_511 = 
((BgL_alsamusicz00_bglt)
PROCEDURE_REF(BgL_envz00_509, 
(int)(((long)1)))); 
BgL_amz00_512 = 
((BgL_musicbufz00_bglt)
PROCEDURE_REF(BgL_envz00_509, 
(int)(((long)2)))); 
{ /* Llib/flac_alsadec.scm 65 */
BgL_musicbufferz00_bglt BgL_i1131z00_677;
BgL_i1131z00_677 = 
((BgL_musicbufferz00_bglt)
(((BgL_flacdecz00_bglt)COBJECT(BgL_i1125z00_510))->BgL_z52bufferz52)); 
BGl_alsazd2sndzd2pcmzd2cleanupzd2zz__alsa_pcmz00(
(((BgL_alsamusicz00_bglt)COBJECT(BgL_i1126z00_511))->BgL_pcmz00)); 
{ /* Llib/flac_alsadec.scm 67 */
obj_t BgL_arg1258z00_678;
if(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1131z00_677))->BgL_z52eofz52))
{ /* Llib/flac_alsadec.scm 67 */
BgL_arg1258z00_678 = 
CNST_TABLE_REF(((long)20)); }  else 
{ /* Llib/flac_alsadec.scm 67 */
BgL_arg1258z00_678 = 
CNST_TABLE_REF(((long)21)); } 
return 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_amz00_512), BgL_arg1258z00_678);} } } } 

}



/* &musicdecoder-init-fl1154 */
obj_t BGl_z62musicdecoderzd2initzd2fl1154z62zz__flac_alsadecz00(obj_t BgL_envz00_513, obj_t BgL_decz00_514)
{
{ /* Llib/flac_alsadec.scm 42 */
{ 

{ /* Llib/flac_alsadec.scm 42 */
obj_t BgL_nextzd2method1153zd2_681;
BgL_nextzd2method1153zd2_681 = 
BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
((BgL_objectz00_bglt)
((BgL_flaczd2alsadecoderzd2_bglt)BgL_decz00_514)), BGl_musicdecoderzd2initzd2envz00zz__multimediazd2musicbufzd2, BGl_flaczd2alsadecoderzd2zz__flac_alsadecz00); 
PROCEDURE_ENTRY(BgL_nextzd2method1153zd2_681)(BgL_nextzd2method1153zd2_681, 
((obj_t)
((BgL_flaczd2alsadecoderzd2_bglt)BgL_decz00_514)), BEOA); } 
if(
CBOOL(
(((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)
((BgL_flaczd2alsadecoderzd2_bglt)BgL_decz00_514))))->BgL_z52flacz52)))
{ /* Llib/flac_alsadec.scm 45 */
return BFALSE;}  else 
{ 
obj_t BgL_auxz00_1349;
{ /* Llib/flac_alsadec.scm 45 */
BgL_flacalsadecz00_bglt BgL_new1123z00_682;
{ /* Llib/flac_alsadec.scm 45 */
BgL_flacalsadecz00_bglt BgL_new1122z00_683;
BgL_new1122z00_683 = 
((BgL_flacalsadecz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_flacalsadecz00_bgl) ))); 
{ /* Llib/flac_alsadec.scm 45 */
long BgL_arg1210z00_684;
{ /* Llib/flac_alsadec.scm 45 */
long BgL_res1749z00_685;
{ /* Llib/flac_alsadec.scm 45 */
obj_t BgL_classz00_686;
BgL_classz00_686 = BGl_flacalsadecz00zz__flac_alsadecz00; 
BgL_res1749z00_685 = 
BGL_CLASS_INDEX(BgL_classz00_686); } 
BgL_arg1210z00_684 = BgL_res1749z00_685; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1122z00_683), BgL_arg1210z00_684); } 
BgL_new1123z00_682 = BgL_new1122z00_683; } 
{ 
void * BgL_auxz00_1356;
{ /* Llib/flac_alsadec.scm 45 */
obj_t BgL_arg1205z00_687;
{ /* Llib/flac_alsadec.scm 45 */
obj_t BgL_arg1206z00_688;
{ /* Llib/flac_alsadec.scm 45 */
obj_t BgL_res1750z00_689;
{ /* Llib/flac_alsadec.scm 45 */
obj_t BgL_classz00_690;
BgL_classz00_690 = BGl_flacalsadecz00zz__flac_alsadecz00; 
BgL_res1750z00_689 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_690); } 
BgL_arg1206z00_688 = BgL_res1750z00_689; } 
BgL_arg1205z00_687 = 
VECTOR_REF(BgL_arg1206z00_688,((long)0)); } 
BgL_auxz00_1356 = 
FOREIGN_TO_COBJ(
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1205z00_687)); } 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1123z00_682)))->BgL_z42builtinz42)=((FLAC__StreamDecoder *)BgL_auxz00_1356),BUNSPEC); } 
{ 
obj_t BgL_auxz00_1363;
{ /* Llib/flac_alsadec.scm 45 */
obj_t BgL_arg1207z00_691;
{ /* Llib/flac_alsadec.scm 45 */
obj_t BgL_arg1208z00_692;
{ /* Llib/flac_alsadec.scm 45 */
obj_t BgL_res1751z00_693;
{ /* Llib/flac_alsadec.scm 45 */
obj_t BgL_classz00_694;
BgL_classz00_694 = BGl_flacalsadecz00zz__flac_alsadecz00; 
BgL_res1751z00_693 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_694); } 
BgL_arg1208z00_692 = BgL_res1751z00_693; } 
BgL_arg1207z00_691 = 
VECTOR_REF(BgL_arg1208z00_692,((long)1)); } 
BgL_auxz00_1363 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1207z00_691); } 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1123z00_682)))->BgL_z52flacbufz52)=((obj_t)BgL_auxz00_1363),BUNSPEC); } 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1123z00_682)))->BgL_outbufz00)=((obj_t)BGl_string1899z00zz__flac_alsadecz00),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1123z00_682)))->BgL_z52eofz52)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1123z00_682)))->BgL_z52samplez52)=((long)((long)0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1123z00_682)))->BgL_z52volumez52)=((double)((double)1.0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1123z00_682)))->BgL_md5checkz00)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1123z00_682)))->BgL_z52bchecksumz52)=((int)
(int)(((long)128))),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1123z00_682)))->BgL_z52rchecksumz52)=((int)
(int)(((long)128))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1123z00_682)))->BgL_z52musicz52)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1123z00_682)))->BgL_z52bufferz52)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1123z00_682)))->BgL_z52decoderz52)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1123z00_682)))->BgL_z52ratez52)=((int)
(int)(((long)80))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1123z00_682)))->BgL_z52ratezd2maxz80)=((int)
(int)(((long)80))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1123z00_682)))->BgL_z52ratezd2minz80)=((int)
(int)(((long)50))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1123z00_682)))->BgL_z52lastzd2percentagez80)=((int)
(int)(((long)0))),BUNSPEC); 
{ /* Llib/flac_alsadec.scm 45 */
obj_t BgL_fun1209z00_695;
BgL_fun1209z00_695 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_flacalsadecz00zz__flac_alsadecz00); 
PROCEDURE_ENTRY(BgL_fun1209z00_695)(BgL_fun1209z00_695, 
((obj_t)BgL_new1123z00_682), BEOA); } 
BgL_auxz00_1349 = 
((obj_t)BgL_new1123z00_682); } 
return 
((((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)
((BgL_flaczd2alsadecoderzd2_bglt)BgL_decz00_514))))->BgL_z52flacz52)=((obj_t)BgL_auxz00_1349),BUNSPEC);} } } 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__flac_alsadecz00()
{
{ /* Llib/flac_alsadec.scm 15 */
BGl_modulezd2initializa7ationz75zz__flac_flacz00(((long)107017853), 
BSTRING_TO_STRING(BGl_string1908z00zz__flac_alsadecz00)); 
return 
BGl_modulezd2initializa7ationz75zz__flac_decoderz00(((long)630617), 
BSTRING_TO_STRING(BGl_string1908z00zz__flac_alsadecz00));} 

}

#ifdef __cplusplus
}
#endif
