/*===========================================================================*/
/*   (Llib/flac_padec.scm)                                                   */
/*   Bigloo (4.3h)                                                           */
/*   Inria -- Sophia Antipolis (c)       Tue 12 May 2020 08:36:09 AM CEST    */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.3h/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.3h/lib/bigloo/4.3h -I Llib -lib-dir /builddir/build/BUILD/bigloo-4.3h/lib/bigloo/4.3h -unsafe -safee -srfi flac -copt  -copt -fPIC -copt -IClib Llib/flac_padec.scm -o objs/flac_padec.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>
#include <FLAC/stream_decoder.h>
#include <bglflac.h>
#include <pulse/simple.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_musicz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
} *BgL_musicz00_bglt;

typedef struct BgL_musicstatusz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_statez00;
   obj_t BgL_volumez00;
   bool_t BgL_repeatz00;
   bool_t BgL_randomz00;
   int BgL_playlistidz00;
   int BgL_playlistlengthz00;
   int BgL_xfadez00;
   int BgL_songz00;
   int BgL_songidz00;
   obj_t BgL_songposz00;
   int BgL_songlengthz00;
   int BgL_bitratez00;
   int BgL_khza7za7;
   obj_t BgL_errz00;
   int BgL_bufferingz00;
} *BgL_musicstatusz00_bglt;

typedef struct BgL_musicbufferz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_urlz00;
   bool_t BgL_z52eofz52;
   obj_t BgL_z52bcondvz52;
   obj_t BgL_z52bmutexz52;
   long BgL_z52inlenz52;
   char * BgL_z52inbufpz52;
   long BgL_z52headz52;
   long BgL_z52tailz52;
   bool_t BgL_z52emptyz52;
} *BgL_musicbufferz00_bglt;

typedef struct BgL_musicbufz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
   obj_t BgL_inbufz00;
   obj_t BgL_decodersz00;
   obj_t BgL_mkthreadz00;
   obj_t BgL_timeoutz00;
   obj_t BgL_z52decoderz52;
   obj_t BgL_z52bufferz52;
   obj_t BgL_z52nextbufferz52;
   obj_t BgL_z52playlistz52;
   bool_t BgL_z52areadyz52;
   obj_t BgL_z52amutexz52;
   int BgL_z52z12pidz40;
   obj_t BgL_z52acondvz52;
} *BgL_musicbufz00_bglt;

typedef struct BgL_musicdecoderz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_mimetypesz00;
   int BgL_bufferzd2timezd2nearz00;
   int BgL_bufferzd2siza7ezd2nearzd2ratioz75;
   int BgL_periodzd2siza7ezd2nearzd2ratioz75;
   bool_t BgL_z52z12dpausez40;
   bool_t BgL_z52z12dabortz40;
   bool_t BgL_z52z12stopz40;
   obj_t BgL_z52dmutexz52;
   obj_t BgL_z52dcondvz52;
   obj_t BgL_z52doutcondvz52;
} *BgL_musicdecoderz00_bglt;

typedef struct BgL_pulseaudiozd2simplezd2_bgl {
   header_t header;
   obj_t widening;
   pa_simple * BgL_z42builtinz42;
   obj_t BgL_srvnamez00;
   obj_t BgL_namez00;
   obj_t BgL_streamz00;
   long BgL_ratez00;
   long BgL_channelsz00;
   int BgL_bpsz00;
   obj_t BgL_formatz00;
} *BgL_pulseaudiozd2simplezd2_bglt;

typedef struct BgL_pulseaudiomusicz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
   obj_t BgL_inbufz00;
   obj_t BgL_decodersz00;
   obj_t BgL_mkthreadz00;
   obj_t BgL_timeoutz00;
   obj_t BgL_z52decoderz52;
   obj_t BgL_z52bufferz52;
   obj_t BgL_z52nextbufferz52;
   obj_t BgL_z52playlistz52;
   bool_t BgL_z52areadyz52;
   obj_t BgL_z52amutexz52;
   int BgL_z52z12pidz40;
   obj_t BgL_z52acondvz52;
   struct BgL_pulseaudiozd2simplezd2_bgl * BgL_simplez00;
   obj_t BgL_namez00;
} *BgL_pulseaudiomusicz00_bglt;

typedef struct BgL_flaczd2decoderzd2_bgl {
   header_t header;
   obj_t widening;
   FLAC__StreamDecoder * BgL_z42builtinz42;
   obj_t BgL_z52flacbufz52;
   obj_t BgL_outbufz00;
   bool_t BgL_z52eofz52;
   long BgL_z52samplez52;
   double BgL_z52volumez52;
   bool_t BgL_md5checkz00;
   int BgL_z52bchecksumz52;
   int BgL_z52rchecksumz52;
} *BgL_flaczd2decoderzd2_bglt;

typedef struct BgL_flacdecz00_bgl {
   header_t header;
   obj_t widening;
   FLAC__StreamDecoder * BgL_z42builtinz42;
   obj_t BgL_z52flacbufz52;
   obj_t BgL_outbufz00;
   bool_t BgL_z52eofz52;
   long BgL_z52samplez52;
   double BgL_z52volumez52;
   bool_t BgL_md5checkz00;
   int BgL_z52bchecksumz52;
   int BgL_z52rchecksumz52;
   obj_t BgL_z52musicz52;
   obj_t BgL_z52bufferz52;
   obj_t BgL_z52decoderz52;
   int BgL_z52ratez52;
   int BgL_z52ratezd2maxz80;
   int BgL_z52ratezd2minz80;
   int BgL_z52lastzd2percentagez80;
} *BgL_flacdecz00_bglt;

typedef struct BgL_flacmusicdecoderz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_mimetypesz00;
   int BgL_bufferzd2timezd2nearz00;
   int BgL_bufferzd2siza7ezd2nearzd2ratioz75;
   int BgL_periodzd2siza7ezd2nearzd2ratioz75;
   bool_t BgL_z52z12dpausez40;
   bool_t BgL_z52z12dabortz40;
   bool_t BgL_z52z12stopz40;
   obj_t BgL_z52dmutexz52;
   obj_t BgL_z52dcondvz52;
   obj_t BgL_z52doutcondvz52;
   obj_t BgL_z52flacz52;
   obj_t BgL_z52inseekz52;
} *BgL_flacmusicdecoderz00_bglt;

typedef struct BgL_flacpadecz00_bgl {
   header_t header;
   obj_t widening;
   FLAC__StreamDecoder * BgL_z42builtinz42;
   obj_t BgL_z52flacbufz52;
   obj_t BgL_outbufz00;
   bool_t BgL_z52eofz52;
   long BgL_z52samplez52;
   double BgL_z52volumez52;
   bool_t BgL_md5checkz00;
   int BgL_z52bchecksumz52;
   int BgL_z52rchecksumz52;
   obj_t BgL_z52musicz52;
   obj_t BgL_z52bufferz52;
   obj_t BgL_z52decoderz52;
   int BgL_z52ratez52;
   int BgL_z52ratezd2maxz80;
   int BgL_z52ratezd2minz80;
   int BgL_z52lastzd2percentagez80;
} *BgL_flacpadecz00_bglt;

typedef struct BgL_flaczd2pulseaudiodecoderzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_mimetypesz00;
   int BgL_bufferzd2timezd2nearz00;
   int BgL_bufferzd2siza7ezd2nearzd2ratioz75;
   int BgL_periodzd2siza7ezd2nearzd2ratioz75;
   bool_t BgL_z52z12dpausez40;
   bool_t BgL_z52z12dabortz40;
   bool_t BgL_z52z12stopz40;
   obj_t BgL_z52dmutexz52;
   obj_t BgL_z52dcondvz52;
   obj_t BgL_z52doutcondvz52;
   obj_t BgL_z52flacz52;
   obj_t BgL_z52inseekz52;
} *BgL_flaczd2pulseaudiodecoderzd2_bglt;


static obj_t BGl_z62zc3z04anonymousza31211ze3ze5zz__flac_padecz00(obj_t);
static obj_t BGl_objectzd2initzd2zz__flac_padecz00();
BGL_IMPORT obj_t BGl_pulseaudiomusiczd2simplezd2setz12z12zz__pulseaudio_musicz00(BgL_pulseaudiomusicz00_bglt, BgL_pulseaudiozd2simplezd2_bglt);
static obj_t BGl_methodzd2initzd2zz__flac_padecz00();
static obj_t BGl_z62zc3z04anonymousza31162ze3ze5zz__flac_padecz00(obj_t, obj_t);
static obj_t BGl_z62musicdecoderzd2initzd2fl1141z62zz__flac_padecz00(obj_t, obj_t);
extern obj_t BGl_flaczd2decoderzd2decode16z00zz__flac_flacz00(BgL_flaczd2decoderzd2_bglt);
BGL_EXPORTED_DEF obj_t BGl_flaczd2pulseaudiodecoderzd2zz__flac_padecz00 = BUNSPEC;
BGL_IMPORT obj_t BGl_conditionzd2variablezd2nilz00zz__threadz00();
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__flac_padecz00();
BGL_IMPORT int bgl_pulseaudio_error(char *, char *, obj_t);
static obj_t BGl_flacpadecz00zz__flac_padecz00 = BUNSPEC;
BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_exitdzd2popzd2protectz12z12zz__bexitz00(obj_t);
extern obj_t BGl_flaczd2decoderzd2decodez00zz__flac_flacz00(BgL_flaczd2decoderzd2_bglt);
BGL_IMPORT obj_t BGl_findzd2superzd2classzd2methodzd2zz__objectz00(BgL_objectz00_bglt, obj_t, obj_t);
BGL_IMPORT obj_t BGl_pulseaudiozd2simplezd2zz__pulseaudio_simplez00;
static obj_t BGl_z62musicdecoderzd2decodezd21143z62zz__flac_padecz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zz__flac_padecz00 = BUNSPEC;
static obj_t BGl_toplevelzd2initzd2zz__flac_padecz00();
BGL_IMPORT obj_t BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(BgL_musicz00_bglt, obj_t);
BGL_IMPORT obj_t BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(obj_t, obj_t);
static obj_t BGl_genericzd2initzd2zz__flac_padecz00();
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_mutexzd2nilzd2zz__threadz00();
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
static obj_t BGl_z62flaczd2decoderzd2metadat1145z62zz__flac_padecz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2constructorzd2zz__objectz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31176ze3ze5zz__flac_padecz00(obj_t, obj_t);
static BgL_flacpadecz00_bglt BGl_z62lambda1155z62zz__flac_padecz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_flacpadecz00_bglt BGl_z62lambda1158z62zz__flac_padecz00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__flac_padecz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__flac_decoderz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__flac_flacz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__pulseaudio_pulseaudioz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__pulseaudio_musicz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__pulseaudio_simplez00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2musicbufzd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__customz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
static BgL_flaczd2pulseaudiodecoderzd2_bglt BGl_z62lambda1171z62zz__flac_padecz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_flaczd2pulseaudiodecoderzd2_bglt BGl_z62lambda1174z62zz__flac_padecz00(obj_t);
static obj_t BGl_cnstzd2initzd2zz__flac_padecz00();
static obj_t BGl_libraryzd2moduleszd2initz00zz__flac_padecz00();
static obj_t BGl_importedzd2moduleszd2initz00zz__flac_padecz00();
BGL_IMPORT obj_t bgl_custom_nil();
BGL_IMPORT obj_t BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(obj_t);
extern obj_t BGl_flacdecz00zz__flac_decoderz00;
extern obj_t BGl_flacmusicdecoderz00zz__flac_decoderz00;
static obj_t __cnst[ 6 ] ;


BGL_IMPORT obj_t BGl_musicdecoderzd2decodezd2envz00zz__multimediazd2musicbufzd2;
extern obj_t BGl_flaczd2decoderzd2metadatazd2envzd2zz__flac_flacz00;
DEFINE_STRING( BGl_string1283z00zz__flac_padecz00, BgL_bgl_string1283za700za7za7_1327za7, "Llib/flac_padec.scm", 19 );
DEFINE_STRING( BGl_string1290z00zz__flac_padecz00, BgL_bgl_string1290za700za7za7_1328za7, "", 0 );
DEFINE_STRING( BGl_string1292z00zz__flac_padecz00, BgL_bgl_string1292za700za7za7_1329za7, "musicdecoder-init", 17 );
DEFINE_STRING( BGl_string1294z00zz__flac_padecz00, BgL_bgl_string1294za700za7za7_1330za7, "musicdecoder-decode", 19 );
DEFINE_STRING( BGl_string1296z00zz__flac_padecz00, BgL_bgl_string1296za700za7za7_1331za7, "flac-decoder-metadata", 21 );
DEFINE_STRING( BGl_string1297z00zz__flac_padecz00, BgL_bgl_string1297za700za7za7_1332za7, "pulseaudio-simple-flush", 23 );
DEFINE_STRING( BGl_string1298z00zz__flac_padecz00, BgL_bgl_string1298za700za7za7_1333za7, "__flac_padec", 12 );
DEFINE_STRING( BGl_string1299z00zz__flac_padecz00, BgL_bgl_string1299za700za7za7_1334za7, "stop ended s16 flac-pulseaudiodecoder __flac_padec flacpadec ", 61 );
extern obj_t BGl_flaczd2decoderzd2initzd2envzd2zz__flac_flacz00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1284z00zz__flac_padecz00, BgL_bgl_za762za7c3za704anonymo1335za7, BGl_z62zc3z04anonymousza31162ze3ze5zz__flac_padecz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1285z00zz__flac_padecz00, BgL_bgl_za762lambda1158za7621336z00, BGl_z62lambda1158z62zz__flac_padecz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1286z00zz__flac_padecz00, BgL_bgl_za762lambda1155za7621337z00, BGl_z62lambda1155z62zz__flac_padecz00, 0L, BUNSPEC, 16 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1287z00zz__flac_padecz00, BgL_bgl_za762za7c3za704anonymo1338za7, BGl_z62zc3z04anonymousza31176ze3ze5zz__flac_padecz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1288z00zz__flac_padecz00, BgL_bgl_za762lambda1174za7621339z00, BGl_z62lambda1174z62zz__flac_padecz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1289z00zz__flac_padecz00, BgL_bgl_za762lambda1171za7621340z00, BGl_z62lambda1171z62zz__flac_padecz00, 0L, BUNSPEC, 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1291z00zz__flac_padecz00, BgL_bgl_za762musicdecoderza71341z00, BGl_z62musicdecoderzd2initzd2fl1141z62zz__flac_padecz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1293z00zz__flac_padecz00, BgL_bgl_za762musicdecoderza71342z00, BGl_z62musicdecoderzd2decodezd21143z62zz__flac_padecz00, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1295z00zz__flac_padecz00, BgL_bgl_za762flacza7d2decode1343z00, BGl_z62flaczd2decoderzd2metadat1145z62zz__flac_padecz00, 0L, BUNSPEC, 5 );
BGL_IMPORT obj_t BGl_musicdecoderzd2initzd2envz00zz__multimediazd2musicbufzd2;

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_flaczd2pulseaudiodecoderzd2zz__flac_padecz00) );
ADD_ROOT( (void *)(&BGl_flacpadecz00zz__flac_padecz00) );
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__flac_padecz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__flac_padecz00(long BgL_checksumz00_409, char * BgL_fromz00_410)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__flac_padecz00))
{ 
BGl_requirezd2initializa7ationz75zz__flac_padecz00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__flac_padecz00(); 
BGl_libraryzd2moduleszd2initz00zz__flac_padecz00(); 
BGl_cnstzd2initzd2zz__flac_padecz00(); 
BGl_importedzd2moduleszd2initz00zz__flac_padecz00(); 
BGl_objectzd2initzd2zz__flac_padecz00(); 
BGl_methodzd2initzd2zz__flac_padecz00(); 
return 
BGl_toplevelzd2initzd2zz__flac_padecz00();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__flac_padecz00()
{
{ /* Llib/flac_padec.scm 15 */
BGl_modulezd2initializa7ationz75zz__multimediazd2musicbufzd2(((long)0), "__flac_padec"); 
BGl_modulezd2initializa7ationz75zz__pulseaudio_musicz00(((long)0), "__flac_padec"); 
BGl_modulezd2initializa7ationz75zz__threadz00(((long)0), "__flac_padec"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__flac_padec"); 
BGl_modulezd2initializa7ationz75zz__pulseaudio_pulseaudioz00(((long)0), "__flac_padec"); 
BGl_modulezd2initializa7ationz75zz__bexitz00(((long)0), "__flac_padec"); 
BGl_modulezd2initializa7ationz75zz__pulseaudio_simplez00(((long)0), "__flac_padec"); 
BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(((long)0), "__flac_padec"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__flac_padec"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__flac_padec"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__flac_padec"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__flac_padec"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__flac_padec"); 
BGl_modulezd2initializa7ationz75zz__customz00(((long)0), "__flac_padec"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__flac_padecz00()
{
{ /* Llib/flac_padec.scm 15 */
{ /* Llib/flac_padec.scm 15 */
obj_t BgL_cportz00_293;
{ /* Llib/flac_padec.scm 15 */
obj_t BgL_stringz00_301;
BgL_stringz00_301 = BGl_string1299z00zz__flac_padecz00; 
{ /* Llib/flac_padec.scm 15 */
obj_t BgL_startz00_302;
BgL_startz00_302 = 
BINT(((long)0)); 
{ /* Llib/flac_padec.scm 15 */
obj_t BgL_endz00_303;
BgL_endz00_303 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_301))); 
{ /* Llib/flac_padec.scm 15 */

BgL_cportz00_293 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_301, BgL_startz00_302, BgL_endz00_303); } } } } 
{ 
long BgL_iz00_294;
BgL_iz00_294 = ((long)5); 
BgL_loopz00_295:
if(
(BgL_iz00_294==((long)-1)))
{ /* Llib/flac_padec.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/flac_padec.scm 15 */
{ /* Llib/flac_padec.scm 15 */
obj_t BgL_arg1325z00_297;
{ /* Llib/flac_padec.scm 15 */

{ /* Llib/flac_padec.scm 15 */
obj_t BgL_locationz00_299;
BgL_locationz00_299 = 
BBOOL(((bool_t)0)); 
{ /* Llib/flac_padec.scm 15 */

BgL_arg1325z00_297 = 
BGl_readz00zz__readerz00(BgL_cportz00_293, BgL_locationz00_299); } } } 
{ /* Llib/flac_padec.scm 15 */
int BgL_tmpz00_444;
BgL_tmpz00_444 = 
(int)(BgL_iz00_294); 
CNST_TABLE_SET(BgL_tmpz00_444, BgL_arg1325z00_297); } } 
{ /* Llib/flac_padec.scm 15 */
int BgL_auxz00_300;
BgL_auxz00_300 = 
(int)(
(BgL_iz00_294-((long)1))); 
{ 
long BgL_iz00_449;
BgL_iz00_449 = 
(long)(BgL_auxz00_300); 
BgL_iz00_294 = BgL_iz00_449; 
goto BgL_loopz00_295;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__flac_padecz00()
{
{ /* Llib/flac_padec.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__flac_padecz00()
{
{ /* Llib/flac_padec.scm 15 */
BGl_modulezd2initializa7ationz75zz__pulseaudio_pulseaudioz00(((long)0), 
BSTRING_TO_STRING(BGl_string1283z00zz__flac_padecz00)); 
BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(((long)0), 
BSTRING_TO_STRING(BGl_string1283z00zz__flac_padecz00)); 
return BUNSPEC;} 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__flac_padecz00()
{
{ /* Llib/flac_padec.scm 15 */
{ /* Llib/flac_padec.scm 26 */
obj_t BgL_arg1153z00_23;obj_t BgL_arg1154z00_24;
{ /* Llib/flac_padec.scm 26 */
obj_t BgL_v1136z00_51;
BgL_v1136z00_51 = 
create_vector(((long)0)); 
BgL_arg1153z00_23 = BgL_v1136z00_51; } 
{ /* Llib/flac_padec.scm 26 */
obj_t BgL_v1137z00_52;
BgL_v1137z00_52 = 
create_vector(((long)0)); 
BgL_arg1154z00_24 = BgL_v1137z00_52; } 
BGl_flacpadecz00zz__flac_padecz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)0)), 
CNST_TABLE_REF(((long)1)), BGl_flacdecz00zz__flac_decoderz00, ((long)11770), BGl_proc1286z00zz__flac_padecz00, BGl_proc1285z00zz__flac_padecz00, BGl_flaczd2decoderzd2initzd2envzd2zz__flac_flacz00, BGl_proc1284z00zz__flac_padecz00, BFALSE, BgL_arg1153z00_23, BgL_arg1154z00_24); } 
{ /* Llib/flac_padec.scm 30 */
obj_t BgL_arg1169z00_59;obj_t BgL_arg1170z00_60;
{ /* Llib/flac_padec.scm 30 */
obj_t BgL_v1138z00_83;
BgL_v1138z00_83 = 
create_vector(((long)0)); 
BgL_arg1169z00_59 = BgL_v1138z00_83; } 
{ /* Llib/flac_padec.scm 30 */
obj_t BgL_v1139z00_84;
BgL_v1139z00_84 = 
create_vector(((long)0)); 
BgL_arg1170z00_60 = BgL_v1139z00_84; } 
return ( 
BGl_flaczd2pulseaudiodecoderzd2zz__flac_padecz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)2)), 
CNST_TABLE_REF(((long)1)), BGl_flacmusicdecoderz00zz__flac_decoderz00, ((long)38574), BGl_proc1289z00zz__flac_padecz00, BGl_proc1288z00zz__flac_padecz00, BGl_musicdecoderzd2initzd2envz00zz__multimediazd2musicbufzd2, BGl_proc1287z00zz__flac_padecz00, BFALSE, BgL_arg1169z00_59, BgL_arg1170z00_60), BUNSPEC) ;} } 

}



/* &<@anonymous:1176> */
obj_t BGl_z62zc3z04anonymousza31176ze3ze5zz__flac_padecz00(obj_t BgL_envz00_223, obj_t BgL_new1113z00_224)
{
{ /* Llib/flac_padec.scm 30 */
{ 
BgL_flaczd2pulseaudiodecoderzd2_bglt BgL_auxz00_466;
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BgL_new1113z00_224))))->BgL_mimetypesz00)=((obj_t)BNIL),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BgL_new1113z00_224))))->BgL_bufferzd2timezd2nearz00)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BgL_new1113z00_224))))->BgL_bufferzd2siza7ezd2nearzd2ratioz75)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BgL_new1113z00_224))))->BgL_periodzd2siza7ezd2nearzd2ratioz75)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BgL_new1113z00_224))))->BgL_z52z12dpausez40)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BgL_new1113z00_224))))->BgL_z52z12dabortz40)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BgL_new1113z00_224))))->BgL_z52z12stopz40)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BgL_new1113z00_224))))->BgL_z52dmutexz52)=((obj_t)
BGl_mutexzd2nilzd2zz__threadz00()),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BgL_new1113z00_224))))->BgL_z52dcondvz52)=((obj_t)
BGl_conditionzd2variablezd2nilz00zz__threadz00()),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BgL_new1113z00_224))))->BgL_z52doutcondvz52)=((obj_t)
BGl_conditionzd2variablezd2nilz00zz__threadz00()),BUNSPEC); 
((((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BgL_new1113z00_224))))->BgL_z52flacz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BgL_new1113z00_224))))->BgL_z52inseekz52)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_466 = 
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BgL_new1113z00_224); 
return 
((obj_t)BgL_auxz00_466);} } 

}



/* &lambda1174 */
BgL_flaczd2pulseaudiodecoderzd2_bglt BGl_z62lambda1174z62zz__flac_padecz00(obj_t BgL_envz00_225)
{
{ /* Llib/flac_padec.scm 30 */
{ /* Llib/flac_padec.scm 30 */
BgL_flaczd2pulseaudiodecoderzd2_bglt BgL_new1112z00_307;
BgL_new1112z00_307 = 
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_flaczd2pulseaudiodecoderzd2_bgl) ))); 
{ /* Llib/flac_padec.scm 30 */
long BgL_arg1175z00_308;
{ /* Llib/flac_padec.scm 30 */
long BgL_res1263z00_309;
BgL_res1263z00_309 = 
BGL_CLASS_INDEX(BGl_flaczd2pulseaudiodecoderzd2zz__flac_padecz00); 
BgL_arg1175z00_308 = BgL_res1263z00_309; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1112z00_307), BgL_arg1175z00_308); } 
return BgL_new1112z00_307;} } 

}



/* &lambda1171 */
BgL_flaczd2pulseaudiodecoderzd2_bglt BGl_z62lambda1171z62zz__flac_padecz00(obj_t BgL_envz00_226, obj_t BgL_mimetypes1100z00_227, obj_t BgL_bufferzd2timezd2near1101z00_228, obj_t BgL_bufferzd2siza7ezd2nearzd2rat1102z75_229, obj_t BgL_periodzd2siza7ezd2nearzd2rat1103z75_230, obj_t BgL_z52z12dpause1104z40_231, obj_t BgL_z52z12dabort1105z40_232, obj_t BgL_z52z12stop1106z40_233, obj_t BgL_z52dmutex1107z52_234, obj_t BgL_z52dcondv1108z52_235, obj_t BgL_z52doutcondv1109z52_236, obj_t BgL_z52flac1110z52_237, obj_t BgL_z52inseek1111z52_238)
{
{ /* Llib/flac_padec.scm 30 */
{ /* Llib/flac_padec.scm 30 */
int BgL_bufferzd2timezd2near1101z00_311;int BgL_bufferzd2siza7ezd2nearzd2rat1102z75_312;int BgL_periodzd2siza7ezd2nearzd2rat1103z75_313;bool_t BgL_z52z12dpause1104z40_314;bool_t BgL_z52z12dabort1105z40_315;bool_t BgL_z52z12stop1106z40_316;
BgL_bufferzd2timezd2near1101z00_311 = 
CINT(BgL_bufferzd2timezd2near1101z00_228); 
BgL_bufferzd2siza7ezd2nearzd2rat1102z75_312 = 
CINT(BgL_bufferzd2siza7ezd2nearzd2rat1102z75_229); 
BgL_periodzd2siza7ezd2nearzd2rat1103z75_313 = 
CINT(BgL_periodzd2siza7ezd2nearzd2rat1103z75_230); 
BgL_z52z12dpause1104z40_314 = 
CBOOL(BgL_z52z12dpause1104z40_231); 
BgL_z52z12dabort1105z40_315 = 
CBOOL(BgL_z52z12dabort1105z40_232); 
BgL_z52z12stop1106z40_316 = 
CBOOL(BgL_z52z12stop1106z40_233); 
{ /* Llib/flac_padec.scm 30 */
BgL_flaczd2pulseaudiodecoderzd2_bglt BgL_new1135z00_320;
{ /* Llib/flac_padec.scm 30 */
BgL_flaczd2pulseaudiodecoderzd2_bglt BgL_new1134z00_321;
BgL_new1134z00_321 = 
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_flaczd2pulseaudiodecoderzd2_bgl) ))); 
{ /* Llib/flac_padec.scm 30 */
long BgL_arg1173z00_322;
{ /* Llib/flac_padec.scm 30 */
long BgL_res1262z00_323;
BgL_res1262z00_323 = 
BGL_CLASS_INDEX(BGl_flaczd2pulseaudiodecoderzd2zz__flac_padecz00); 
BgL_arg1173z00_322 = BgL_res1262z00_323; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1134z00_321), BgL_arg1173z00_322); } 
BgL_new1135z00_320 = BgL_new1134z00_321; } 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1135z00_320)))->BgL_mimetypesz00)=((obj_t)
((obj_t)BgL_mimetypes1100z00_227)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1135z00_320)))->BgL_bufferzd2timezd2nearz00)=((int)BgL_bufferzd2timezd2near1101z00_311),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1135z00_320)))->BgL_bufferzd2siza7ezd2nearzd2ratioz75)=((int)BgL_bufferzd2siza7ezd2nearzd2rat1102z75_312),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1135z00_320)))->BgL_periodzd2siza7ezd2nearzd2ratioz75)=((int)BgL_periodzd2siza7ezd2nearzd2rat1103z75_313),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1135z00_320)))->BgL_z52z12dpausez40)=((bool_t)BgL_z52z12dpause1104z40_314),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1135z00_320)))->BgL_z52z12dabortz40)=((bool_t)BgL_z52z12dabort1105z40_315),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1135z00_320)))->BgL_z52z12stopz40)=((bool_t)BgL_z52z12stop1106z40_316),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1135z00_320)))->BgL_z52dmutexz52)=((obj_t)
((obj_t)BgL_z52dmutex1107z52_234)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1135z00_320)))->BgL_z52dcondvz52)=((obj_t)
((obj_t)BgL_z52dcondv1108z52_235)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1135z00_320)))->BgL_z52doutcondvz52)=((obj_t)
((obj_t)BgL_z52doutcondv1109z52_236)),BUNSPEC); 
((((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)BgL_new1135z00_320)))->BgL_z52flacz52)=((obj_t)BgL_z52flac1110z52_237),BUNSPEC); 
((((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)BgL_new1135z00_320)))->BgL_z52inseekz52)=((obj_t)BgL_z52inseek1111z52_238),BUNSPEC); 
{ /* Llib/flac_padec.scm 30 */
obj_t BgL_fun1172z00_324;
BgL_fun1172z00_324 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_flaczd2pulseaudiodecoderzd2zz__flac_padecz00); 
PROCEDURE_ENTRY(BgL_fun1172z00_324)(BgL_fun1172z00_324, 
((obj_t)BgL_new1135z00_320), BEOA); } 
return BgL_new1135z00_320;} } } 

}



/* &<@anonymous:1162> */
obj_t BGl_z62zc3z04anonymousza31162ze3ze5zz__flac_padecz00(obj_t BgL_envz00_239, obj_t BgL_new1098z00_240)
{
{ /* Llib/flac_padec.scm 26 */
{ 
BgL_flacpadecz00_bglt BgL_auxz00_559;
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacpadecz00_bglt)BgL_new1098z00_240))))->BgL_z42builtinz42)=((FLAC__StreamDecoder *)
0L),BUNSPEC); 
{ 
obj_t BgL_auxz00_564;
{ /* Llib/flac_padec.scm 26 */
obj_t BgL_res1261z00_326;
BgL_res1261z00_326 = 
bgl_custom_nil(); 
BgL_auxz00_564 = BgL_res1261z00_326; } 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacpadecz00_bglt)BgL_new1098z00_240))))->BgL_z52flacbufz52)=((obj_t)BgL_auxz00_564),BUNSPEC); } 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacpadecz00_bglt)BgL_new1098z00_240))))->BgL_outbufz00)=((obj_t)BGl_string1290z00zz__flac_padecz00),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacpadecz00_bglt)BgL_new1098z00_240))))->BgL_z52eofz52)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacpadecz00_bglt)BgL_new1098z00_240))))->BgL_z52samplez52)=((long)((long)0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacpadecz00_bglt)BgL_new1098z00_240))))->BgL_z52volumez52)=((double)((double)0.0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacpadecz00_bglt)BgL_new1098z00_240))))->BgL_md5checkz00)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacpadecz00_bglt)BgL_new1098z00_240))))->BgL_z52bchecksumz52)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacpadecz00_bglt)BgL_new1098z00_240))))->BgL_z52rchecksumz52)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacpadecz00_bglt)BgL_new1098z00_240))))->BgL_z52musicz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacpadecz00_bglt)BgL_new1098z00_240))))->BgL_z52bufferz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacpadecz00_bglt)BgL_new1098z00_240))))->BgL_z52decoderz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacpadecz00_bglt)BgL_new1098z00_240))))->BgL_z52ratez52)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacpadecz00_bglt)BgL_new1098z00_240))))->BgL_z52ratezd2maxz80)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacpadecz00_bglt)BgL_new1098z00_240))))->BgL_z52ratezd2minz80)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacpadecz00_bglt)BgL_new1098z00_240))))->BgL_z52lastzd2percentagez80)=((int)
(int)(((long)0))),BUNSPEC); 
BgL_auxz00_559 = 
((BgL_flacpadecz00_bglt)BgL_new1098z00_240); 
return 
((obj_t)BgL_auxz00_559);} } 

}



/* &lambda1158 */
BgL_flacpadecz00_bglt BGl_z62lambda1158z62zz__flac_padecz00(obj_t BgL_envz00_241)
{
{ /* Llib/flac_padec.scm 26 */
{ /* Llib/flac_padec.scm 26 */
BgL_flacpadecz00_bglt BgL_new1097z00_327;
BgL_new1097z00_327 = 
((BgL_flacpadecz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_flacpadecz00_bgl) ))); 
{ /* Llib/flac_padec.scm 26 */
long BgL_arg1161z00_328;
{ /* Llib/flac_padec.scm 26 */
long BgL_res1260z00_329;
BgL_res1260z00_329 = 
BGL_CLASS_INDEX(BGl_flacpadecz00zz__flac_padecz00); 
BgL_arg1161z00_328 = BgL_res1260z00_329; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1097z00_327), BgL_arg1161z00_328); } 
return BgL_new1097z00_327;} } 

}



/* &lambda1155 */
BgL_flacpadecz00_bglt BGl_z62lambda1155z62zz__flac_padecz00(obj_t BgL_envz00_242, obj_t BgL_z42builtin1081z42_243, obj_t BgL_z52flacbuf1082z52_244, obj_t BgL_outbuf1083z00_245, obj_t BgL_z52eof1084z52_246, obj_t BgL_z52sample1085z52_247, obj_t BgL_z52volume1086z52_248, obj_t BgL_md5check1087z00_249, obj_t BgL_z52bchecksum1088z52_250, obj_t BgL_z52rchecksum1089z52_251, obj_t BgL_z52music1090z52_252, obj_t BgL_z52buffer1091z52_253, obj_t BgL_z52decoder1092z52_254, obj_t BgL_z52rate1093z52_255, obj_t BgL_z52ratezd2max1094z80_256, obj_t BgL_z52ratezd2min1095z80_257, obj_t BgL_z52lastzd2percentage1096z80_258)
{
{ /* Llib/flac_padec.scm 26 */
{ /* Llib/flac_padec.scm 26 */
FLAC__StreamDecoder * BgL_z42builtin1081z42_330;bool_t BgL_z52eof1084z52_333;long BgL_z52sample1085z52_334;double BgL_z52volume1086z52_335;bool_t BgL_md5check1087z00_336;int BgL_z52bchecksum1088z52_337;int BgL_z52rchecksum1089z52_338;int BgL_z52rate1093z52_339;int BgL_z52ratezd2max1094z80_340;int BgL_z52ratezd2min1095z80_341;int BgL_z52lastzd2percentage1096z80_342;
BgL_z42builtin1081z42_330 = 
FOREIGN_TO_COBJ(BgL_z42builtin1081z42_243); 
BgL_z52eof1084z52_333 = 
CBOOL(BgL_z52eof1084z52_246); 
BgL_z52sample1085z52_334 = 
(long)CINT(BgL_z52sample1085z52_247); 
BgL_z52volume1086z52_335 = 
REAL_TO_DOUBLE(BgL_z52volume1086z52_248); 
BgL_md5check1087z00_336 = 
CBOOL(BgL_md5check1087z00_249); 
BgL_z52bchecksum1088z52_337 = 
CINT(BgL_z52bchecksum1088z52_250); 
BgL_z52rchecksum1089z52_338 = 
CINT(BgL_z52rchecksum1089z52_251); 
BgL_z52rate1093z52_339 = 
CINT(BgL_z52rate1093z52_255); 
BgL_z52ratezd2max1094z80_340 = 
CINT(BgL_z52ratezd2max1094z80_256); 
BgL_z52ratezd2min1095z80_341 = 
CINT(BgL_z52ratezd2min1095z80_257); 
BgL_z52lastzd2percentage1096z80_342 = 
CINT(BgL_z52lastzd2percentage1096z80_258); 
{ /* Llib/flac_padec.scm 26 */
BgL_flacpadecz00_bglt BgL_new1133z00_343;
{ /* Llib/flac_padec.scm 26 */
BgL_flacpadecz00_bglt BgL_new1132z00_344;
BgL_new1132z00_344 = 
((BgL_flacpadecz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_flacpadecz00_bgl) ))); 
{ /* Llib/flac_padec.scm 26 */
long BgL_arg1157z00_345;
{ /* Llib/flac_padec.scm 26 */
long BgL_res1259z00_346;
BgL_res1259z00_346 = 
BGL_CLASS_INDEX(BGl_flacpadecz00zz__flac_padecz00); 
BgL_arg1157z00_345 = BgL_res1259z00_346; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1132z00_344), BgL_arg1157z00_345); } 
BgL_new1133z00_343 = BgL_new1132z00_344; } 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1133z00_343)))->BgL_z42builtinz42)=((FLAC__StreamDecoder *)BgL_z42builtin1081z42_330),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1133z00_343)))->BgL_z52flacbufz52)=((obj_t)
((obj_t)BgL_z52flacbuf1082z52_244)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1133z00_343)))->BgL_outbufz00)=((obj_t)
((obj_t)BgL_outbuf1083z00_245)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1133z00_343)))->BgL_z52eofz52)=((bool_t)BgL_z52eof1084z52_333),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1133z00_343)))->BgL_z52samplez52)=((long)BgL_z52sample1085z52_334),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1133z00_343)))->BgL_z52volumez52)=((double)BgL_z52volume1086z52_335),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1133z00_343)))->BgL_md5checkz00)=((bool_t)BgL_md5check1087z00_336),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1133z00_343)))->BgL_z52bchecksumz52)=((int)BgL_z52bchecksum1088z52_337),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1133z00_343)))->BgL_z52rchecksumz52)=((int)BgL_z52rchecksum1089z52_338),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1133z00_343)))->BgL_z52musicz52)=((obj_t)BgL_z52music1090z52_252),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1133z00_343)))->BgL_z52bufferz52)=((obj_t)BgL_z52buffer1091z52_253),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1133z00_343)))->BgL_z52decoderz52)=((obj_t)BgL_z52decoder1092z52_254),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1133z00_343)))->BgL_z52ratez52)=((int)BgL_z52rate1093z52_339),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1133z00_343)))->BgL_z52ratezd2maxz80)=((int)BgL_z52ratezd2max1094z80_340),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1133z00_343)))->BgL_z52ratezd2minz80)=((int)BgL_z52ratezd2min1095z80_341),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1133z00_343)))->BgL_z52lastzd2percentagez80)=((int)BgL_z52lastzd2percentage1096z80_342),BUNSPEC); 
{ /* Llib/flac_padec.scm 26 */
obj_t BgL_fun1156z00_347;
BgL_fun1156z00_347 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_flacpadecz00zz__flac_padecz00); 
PROCEDURE_ENTRY(BgL_fun1156z00_347)(BgL_fun1156z00_347, 
((obj_t)BgL_new1133z00_343), BEOA); } 
return BgL_new1133z00_343;} } } 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__flac_padecz00()
{
{ /* Llib/flac_padec.scm 15 */
return BUNSPEC;} 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__flac_padecz00()
{
{ /* Llib/flac_padec.scm 15 */
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2initzd2envz00zz__multimediazd2musicbufzd2, BGl_flaczd2pulseaudiodecoderzd2zz__flac_padecz00, BGl_proc1291z00zz__flac_padecz00, BGl_string1292z00zz__flac_padecz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2decodezd2envz00zz__multimediazd2musicbufzd2, BGl_flaczd2pulseaudiodecoderzd2zz__flac_padecz00, BGl_proc1293z00zz__flac_padecz00, BGl_string1294z00zz__flac_padecz00); 
return 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_flaczd2decoderzd2metadatazd2envzd2zz__flac_flacz00, BGl_flacpadecz00zz__flac_padecz00, BGl_proc1295z00zz__flac_padecz00, BGl_string1296z00zz__flac_padecz00);} 

}



/* &flac-decoder-metadat1145 */
obj_t BGl_z62flaczd2decoderzd2metadat1145z62zz__flac_padecz00(obj_t BgL_envz00_267, obj_t BgL_oz00_268, obj_t BgL_totalz00_269, obj_t BgL_ratez00_270, obj_t BgL_channelsz00_271, obj_t BgL_bpsz00_272)
{
{ /* Llib/flac_padec.scm 73 */
{ /* Llib/flac_padec.scm 75 */
BgL_pulseaudiomusicz00_bglt BgL_i1129z00_349;
BgL_i1129z00_349 = 
((BgL_pulseaudiomusicz00_bglt)
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacpadecz00_bglt)BgL_oz00_268))))->BgL_z52musicz52)); 
{ /* Llib/flac_padec.scm 76 */
obj_t BgL_arg1218z00_350;BgL_pulseaudiozd2simplezd2_bglt BgL_arg1230z00_351;
BgL_arg1218z00_350 = 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacpadecz00_bglt)BgL_oz00_268))))->BgL_z52musicz52); 
{ /* Llib/flac_padec.scm 77 */
BgL_pulseaudiozd2simplezd2_bglt BgL_new1131z00_352;
{ /* Llib/flac_padec.scm 77 */
BgL_pulseaudiozd2simplezd2_bglt BgL_new1130z00_353;
BgL_new1130z00_353 = 
((BgL_pulseaudiozd2simplezd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pulseaudiozd2simplezd2_bgl) ))); 
{ /* Llib/flac_padec.scm 77 */
long BgL_arg1258z00_354;
{ /* Llib/flac_padec.scm 77 */
long BgL_res1271z00_355;
BgL_res1271z00_355 = 
BGL_CLASS_INDEX(BGl_pulseaudiozd2simplezd2zz__pulseaudio_simplez00); 
BgL_arg1258z00_354 = BgL_res1271z00_355; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1130z00_353), BgL_arg1258z00_354); } 
BgL_new1131z00_352 = BgL_new1130z00_353; } 
{ 
void * BgL_auxz00_692;
{ /* Llib/flac_padec.scm 77 */
obj_t BgL_arg1231z00_356;
{ /* Llib/flac_padec.scm 77 */
obj_t BgL_arg1232z00_357;
{ /* Llib/flac_padec.scm 77 */
obj_t BgL_res1272z00_358;
{ /* Llib/flac_padec.scm 77 */
obj_t BgL_classz00_359;
BgL_classz00_359 = BGl_pulseaudiozd2simplezd2zz__pulseaudio_simplez00; 
BgL_res1272z00_358 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_359); } 
BgL_arg1232z00_357 = BgL_res1272z00_358; } 
BgL_arg1231z00_356 = 
VECTOR_REF(BgL_arg1232z00_357,((long)0)); } 
BgL_auxz00_692 = 
FOREIGN_TO_COBJ(
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1231z00_356)); } 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1131z00_352))->BgL_z42builtinz42)=((pa_simple *)BgL_auxz00_692),BUNSPEC); } 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1131z00_352))->BgL_srvnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1131z00_352))->BgL_namez00)=((obj_t)
(((BgL_pulseaudiomusicz00_bglt)COBJECT(BgL_i1129z00_349))->BgL_namez00)),BUNSPEC); 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1131z00_352))->BgL_streamz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1131z00_352))->BgL_ratez00)=((long)
(long)CINT(BgL_ratez00_270)),BUNSPEC); 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1131z00_352))->BgL_channelsz00)=((long)
(long)CINT(BgL_channelsz00_271)),BUNSPEC); 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1131z00_352))->BgL_bpsz00)=((int)
CINT(BgL_bpsz00_272)),BUNSPEC); 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1131z00_352))->BgL_formatz00)=((obj_t)
CNST_TABLE_REF(((long)3))),BUNSPEC); 
{ /* Llib/flac_padec.scm 77 */
obj_t BgL_fun1233z00_360;
BgL_fun1233z00_360 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_pulseaudiozd2simplezd2zz__pulseaudio_simplez00); 
PROCEDURE_ENTRY(BgL_fun1233z00_360)(BgL_fun1233z00_360, 
((obj_t)BgL_new1131z00_352), BEOA); } 
BgL_arg1230z00_351 = BgL_new1131z00_352; } 
return 
BGl_pulseaudiomusiczd2simplezd2setz12z12zz__pulseaudio_musicz00(
((BgL_pulseaudiomusicz00_bglt)BgL_arg1218z00_350), BgL_arg1230z00_351);} } } 

}



/* &musicdecoder-decode-1143 */
obj_t BGl_z62musicdecoderzd2decodezd21143z62zz__flac_padecz00(obj_t BgL_envz00_273, obj_t BgL_decz00_274, obj_t BgL_amz00_275, obj_t BgL_bufferz00_276)
{
{ /* Llib/flac_padec.scm 50 */
if(
CBOOL(
(((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BgL_decz00_274))))->BgL_z52flacz52)))
{ /* Llib/flac_padec.scm 54 */BFALSE; }  else 
{ 
obj_t BgL_auxz00_723;
{ /* Llib/flac_padec.scm 54 */
BgL_flacpadecz00_bglt BgL_new1119z00_364;
{ /* Llib/flac_padec.scm 54 */
BgL_flacpadecz00_bglt BgL_new1118z00_365;
BgL_new1118z00_365 = 
((BgL_flacpadecz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_flacpadecz00_bgl) ))); 
{ /* Llib/flac_padec.scm 54 */
long BgL_arg1204z00_366;
{ /* Llib/flac_padec.scm 54 */
long BgL_res1267z00_367;
{ /* Llib/flac_padec.scm 54 */
obj_t BgL_classz00_368;
BgL_classz00_368 = BGl_flacpadecz00zz__flac_padecz00; 
BgL_res1267z00_367 = 
BGL_CLASS_INDEX(BgL_classz00_368); } 
BgL_arg1204z00_366 = BgL_res1267z00_367; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1118z00_365), BgL_arg1204z00_366); } 
BgL_new1119z00_364 = BgL_new1118z00_365; } 
{ 
void * BgL_auxz00_730;
{ /* Llib/flac_padec.scm 54 */
obj_t BgL_arg1199z00_369;
{ /* Llib/flac_padec.scm 54 */
obj_t BgL_arg1200z00_370;
{ /* Llib/flac_padec.scm 54 */
obj_t BgL_res1268z00_371;
{ /* Llib/flac_padec.scm 54 */
obj_t BgL_classz00_372;
BgL_classz00_372 = BGl_flacpadecz00zz__flac_padecz00; 
BgL_res1268z00_371 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_372); } 
BgL_arg1200z00_370 = BgL_res1268z00_371; } 
BgL_arg1199z00_369 = 
VECTOR_REF(BgL_arg1200z00_370,((long)0)); } 
BgL_auxz00_730 = 
FOREIGN_TO_COBJ(
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1199z00_369)); } 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1119z00_364)))->BgL_z42builtinz42)=((FLAC__StreamDecoder *)BgL_auxz00_730),BUNSPEC); } 
{ 
obj_t BgL_auxz00_737;
{ /* Llib/flac_padec.scm 54 */
obj_t BgL_arg1201z00_373;
{ /* Llib/flac_padec.scm 54 */
obj_t BgL_arg1202z00_374;
{ /* Llib/flac_padec.scm 54 */
obj_t BgL_res1269z00_375;
{ /* Llib/flac_padec.scm 54 */
obj_t BgL_classz00_376;
BgL_classz00_376 = BGl_flacpadecz00zz__flac_padecz00; 
BgL_res1269z00_375 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_376); } 
BgL_arg1202z00_374 = BgL_res1269z00_375; } 
BgL_arg1201z00_373 = 
VECTOR_REF(BgL_arg1202z00_374,((long)1)); } 
BgL_auxz00_737 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1201z00_373); } 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1119z00_364)))->BgL_z52flacbufz52)=((obj_t)BgL_auxz00_737),BUNSPEC); } 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1119z00_364)))->BgL_outbufz00)=((obj_t)BGl_string1290z00zz__flac_padecz00),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1119z00_364)))->BgL_z52eofz52)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1119z00_364)))->BgL_z52samplez52)=((long)((long)0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1119z00_364)))->BgL_z52volumez52)=((double)((double)1.0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1119z00_364)))->BgL_md5checkz00)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1119z00_364)))->BgL_z52bchecksumz52)=((int)
(int)(((long)128))),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1119z00_364)))->BgL_z52rchecksumz52)=((int)
(int)(((long)128))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1119z00_364)))->BgL_z52musicz52)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1119z00_364)))->BgL_z52bufferz52)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1119z00_364)))->BgL_z52decoderz52)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1119z00_364)))->BgL_z52ratez52)=((int)
(int)(((long)80))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1119z00_364)))->BgL_z52ratezd2maxz80)=((int)
(int)(((long)80))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1119z00_364)))->BgL_z52ratezd2minz80)=((int)
(int)(((long)50))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1119z00_364)))->BgL_z52lastzd2percentagez80)=((int)
(int)(((long)0))),BUNSPEC); 
{ /* Llib/flac_padec.scm 54 */
obj_t BgL_fun1203z00_377;
BgL_fun1203z00_377 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_flacpadecz00zz__flac_padecz00); 
PROCEDURE_ENTRY(BgL_fun1203z00_377)(BgL_fun1203z00_377, 
((obj_t)BgL_new1119z00_364), BEOA); } 
BgL_auxz00_723 = 
((obj_t)BgL_new1119z00_364); } 
((((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BgL_decz00_274))))->BgL_z52flacz52)=((obj_t)BgL_auxz00_723),BUNSPEC); } 
{ /* Llib/flac_padec.scm 55 */
BgL_flacpadecz00_bglt BgL_i1120z00_378;
BgL_i1120z00_378 = 
((BgL_flacpadecz00_bglt)
(((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BgL_decz00_274))))->BgL_z52flacz52)); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_i1120z00_378)))->BgL_z52bufferz52)=((obj_t)
((obj_t)
((BgL_musicbufferz00_bglt)BgL_bufferz00_276))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_i1120z00_378)))->BgL_z52musicz52)=((obj_t)
((obj_t)
((BgL_musicbufz00_bglt)BgL_amz00_275))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_i1120z00_378)))->BgL_z52decoderz52)=((obj_t)
((obj_t)
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BgL_decz00_274))),BUNSPEC); 
{ /* Llib/flac_padec.scm 61 */
obj_t BgL_exitd1123z00_379;
BgL_exitd1123z00_379 = 
BGL_EXITD_TOP_AS_OBJ(); 
{ /* Llib/flac_padec.scm 66 */
obj_t BgL_zc3z04anonymousza31211ze3z87_380;
BgL_zc3z04anonymousza31211ze3z87_380 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31211ze3ze5zz__flac_padecz00, 
(int)(((long)0)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31211ze3z87_380, 
(int)(((long)0)), 
((obj_t)BgL_i1120z00_378)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31211ze3z87_380, 
(int)(((long)1)), 
((obj_t)
((BgL_pulseaudiomusicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_275)))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31211ze3z87_380, 
(int)(((long)2)), 
((obj_t)
((BgL_musicbufz00_bglt)BgL_amz00_275))); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1123z00_379, BgL_zc3z04anonymousza31211ze3z87_380); 
{ /* Llib/flac_padec.scm 62 */
obj_t BgL_tmp1125z00_381;
{ /* Llib/flac_padec.scm 62 */
BgL_pulseaudiozd2simplezd2_bglt BgL_i1127z00_382;
BgL_i1127z00_382 = 
(((BgL_pulseaudiomusicz00_bglt)COBJECT(
((BgL_pulseaudiomusicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_275))))->BgL_simplez00); 
if(
(
(long)(
(((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_i1127z00_382))->BgL_bpsz00))<=((long)16)))
{ /* Llib/flac_padec.scm 64 */
obj_t BgL_arg1207z00_383;
BgL_arg1207z00_383 = 
(((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BgL_decz00_274))))->BgL_z52flacz52); 
BgL_tmp1125z00_381 = 
BGl_flaczd2decoderzd2decode16z00zz__flac_flacz00(
((BgL_flaczd2decoderzd2_bglt)BgL_arg1207z00_383)); }  else 
{ /* Llib/flac_padec.scm 65 */
obj_t BgL_arg1208z00_384;
BgL_arg1208z00_384 = 
(((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BgL_decz00_274))))->BgL_z52flacz52); 
BgL_tmp1125z00_381 = 
BGl_flaczd2decoderzd2decodez00zz__flac_flacz00(
((BgL_flaczd2decoderzd2_bglt)BgL_arg1208z00_384)); } } 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1123z00_379); 
BGl_z62zc3z04anonymousza31211ze3ze5zz__flac_padecz00(BgL_zc3z04anonymousza31211ze3z87_380); 
return BgL_tmp1125z00_381;} } } } } 

}



/* &<@anonymous:1211> */
obj_t BGl_z62zc3z04anonymousza31211ze3ze5zz__flac_padecz00(obj_t BgL_envz00_277)
{
{ /* Llib/flac_padec.scm 61 */
{ /* Llib/flac_padec.scm 66 */
BgL_flacpadecz00_bglt BgL_i1120z00_278;BgL_pulseaudiomusicz00_bglt BgL_i1121z00_279;BgL_musicbufz00_bglt BgL_amz00_280;
BgL_i1120z00_278 = 
((BgL_flacpadecz00_bglt)
PROCEDURE_REF(BgL_envz00_277, 
(int)(((long)0)))); 
BgL_i1121z00_279 = 
((BgL_pulseaudiomusicz00_bglt)
PROCEDURE_REF(BgL_envz00_277, 
(int)(((long)1)))); 
BgL_amz00_280 = 
((BgL_musicbufz00_bglt)
PROCEDURE_REF(BgL_envz00_277, 
(int)(((long)2)))); 
{ /* Llib/flac_padec.scm 66 */
BgL_musicbufferz00_bglt BgL_i1126z00_385;
BgL_i1126z00_385 = 
((BgL_musicbufferz00_bglt)
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_i1120z00_278)))->BgL_z52bufferz52)); 
{ /* Llib/flac_padec.scm 67 */
BgL_pulseaudiozd2simplezd2_bglt BgL_arg1212z00_386;
BgL_arg1212z00_386 = 
(((BgL_pulseaudiomusicz00_bglt)COBJECT(BgL_i1121z00_279))->BgL_simplez00); 
{ /* Llib/flac_padec.scm 67 */
int BgL_errz00_387;
BgL_errz00_387 = 
(int)(((long)0)); 
{ /* Llib/flac_padec.scm 67 */
pa_simple * BgL_arg1085z00_388;int * BgL_arg1086z00_389;
BgL_arg1085z00_388 = 
(((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_arg1212z00_386))->BgL_z42builtinz42); 
BgL_arg1086z00_389 = 
&(BgL_errz00_387); 
pa_simple_flush(BgL_arg1085z00_388, BgL_arg1086z00_389); } 
if(
(
(long)(BgL_errz00_387)<((long)0)))
{ /* Llib/flac_padec.scm 67 */
char * BgL_arg1088z00_390;
{ /* Llib/flac_padec.scm 67 */
int BgL_tmpz00_857;
BgL_tmpz00_857 = 
(int)(((long)0)); 
BgL_arg1088z00_390 = 
pa_strerror(BgL_tmpz00_857); } 
BINT(
bgl_pulseaudio_error(
BSTRING_TO_STRING(BGl_string1297z00zz__flac_padecz00), BgL_arg1088z00_390, 
BINT(((long)0)))); }  else 
{ /* Llib/flac_padec.scm 67 */BFALSE; } } } 
{ /* Llib/flac_padec.scm 68 */
obj_t BgL_arg1214z00_391;
if(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1126z00_385))->BgL_z52eofz52))
{ /* Llib/flac_padec.scm 68 */
BgL_arg1214z00_391 = 
CNST_TABLE_REF(((long)4)); }  else 
{ /* Llib/flac_padec.scm 68 */
BgL_arg1214z00_391 = 
CNST_TABLE_REF(((long)5)); } 
return 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_amz00_280), BgL_arg1214z00_391);} } } } 

}



/* &musicdecoder-init-fl1141 */
obj_t BGl_z62musicdecoderzd2initzd2fl1141z62zz__flac_padecz00(obj_t BgL_envz00_281, obj_t BgL_decz00_282)
{
{ /* Llib/flac_padec.scm 42 */
{ 

{ /* Llib/flac_padec.scm 42 */
obj_t BgL_nextzd2method1140zd2_394;
BgL_nextzd2method1140zd2_394 = 
BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
((BgL_objectz00_bglt)
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BgL_decz00_282)), BGl_musicdecoderzd2initzd2envz00zz__multimediazd2musicbufzd2, BGl_flaczd2pulseaudiodecoderzd2zz__flac_padecz00); 
PROCEDURE_ENTRY(BgL_nextzd2method1140zd2_394)(BgL_nextzd2method1140zd2_394, 
((obj_t)
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BgL_decz00_282)), BEOA); } 
if(
CBOOL(
(((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BgL_decz00_282))))->BgL_z52flacz52)))
{ /* Llib/flac_padec.scm 45 */
return BFALSE;}  else 
{ 
obj_t BgL_auxz00_884;
{ /* Llib/flac_padec.scm 45 */
BgL_flacpadecz00_bglt BgL_new1116z00_395;
{ /* Llib/flac_padec.scm 45 */
BgL_flacpadecz00_bglt BgL_new1115z00_396;
BgL_new1115z00_396 = 
((BgL_flacpadecz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_flacpadecz00_bgl) ))); 
{ /* Llib/flac_padec.scm 45 */
long BgL_arg1197z00_397;
{ /* Llib/flac_padec.scm 45 */
long BgL_res1264z00_398;
{ /* Llib/flac_padec.scm 45 */
obj_t BgL_classz00_399;
BgL_classz00_399 = BGl_flacpadecz00zz__flac_padecz00; 
BgL_res1264z00_398 = 
BGL_CLASS_INDEX(BgL_classz00_399); } 
BgL_arg1197z00_397 = BgL_res1264z00_398; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1115z00_396), BgL_arg1197z00_397); } 
BgL_new1116z00_395 = BgL_new1115z00_396; } 
{ 
void * BgL_auxz00_891;
{ /* Llib/flac_padec.scm 45 */
obj_t BgL_arg1179z00_400;
{ /* Llib/flac_padec.scm 45 */
obj_t BgL_arg1182z00_401;
{ /* Llib/flac_padec.scm 45 */
obj_t BgL_res1265z00_402;
{ /* Llib/flac_padec.scm 45 */
obj_t BgL_classz00_403;
BgL_classz00_403 = BGl_flacpadecz00zz__flac_padecz00; 
BgL_res1265z00_402 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_403); } 
BgL_arg1182z00_401 = BgL_res1265z00_402; } 
BgL_arg1179z00_400 = 
VECTOR_REF(BgL_arg1182z00_401,((long)0)); } 
BgL_auxz00_891 = 
FOREIGN_TO_COBJ(
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1179z00_400)); } 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1116z00_395)))->BgL_z42builtinz42)=((FLAC__StreamDecoder *)BgL_auxz00_891),BUNSPEC); } 
{ 
obj_t BgL_auxz00_898;
{ /* Llib/flac_padec.scm 45 */
obj_t BgL_arg1194z00_404;
{ /* Llib/flac_padec.scm 45 */
obj_t BgL_arg1195z00_405;
{ /* Llib/flac_padec.scm 45 */
obj_t BgL_res1266z00_406;
{ /* Llib/flac_padec.scm 45 */
obj_t BgL_classz00_407;
BgL_classz00_407 = BGl_flacpadecz00zz__flac_padecz00; 
BgL_res1266z00_406 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_407); } 
BgL_arg1195z00_405 = BgL_res1266z00_406; } 
BgL_arg1194z00_404 = 
VECTOR_REF(BgL_arg1195z00_405,((long)1)); } 
BgL_auxz00_898 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1194z00_404); } 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1116z00_395)))->BgL_z52flacbufz52)=((obj_t)BgL_auxz00_898),BUNSPEC); } 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1116z00_395)))->BgL_outbufz00)=((obj_t)BGl_string1290z00zz__flac_padecz00),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1116z00_395)))->BgL_z52eofz52)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1116z00_395)))->BgL_z52samplez52)=((long)((long)0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1116z00_395)))->BgL_z52volumez52)=((double)((double)1.0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1116z00_395)))->BgL_md5checkz00)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1116z00_395)))->BgL_z52bchecksumz52)=((int)
(int)(((long)128))),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1116z00_395)))->BgL_z52rchecksumz52)=((int)
(int)(((long)128))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1116z00_395)))->BgL_z52musicz52)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1116z00_395)))->BgL_z52bufferz52)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1116z00_395)))->BgL_z52decoderz52)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1116z00_395)))->BgL_z52ratez52)=((int)
(int)(((long)80))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1116z00_395)))->BgL_z52ratezd2maxz80)=((int)
(int)(((long)80))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1116z00_395)))->BgL_z52ratezd2minz80)=((int)
(int)(((long)50))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1116z00_395)))->BgL_z52lastzd2percentagez80)=((int)
(int)(((long)0))),BUNSPEC); 
{ /* Llib/flac_padec.scm 45 */
obj_t BgL_fun1196z00_408;
BgL_fun1196z00_408 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_flacpadecz00zz__flac_padecz00); 
PROCEDURE_ENTRY(BgL_fun1196z00_408)(BgL_fun1196z00_408, 
((obj_t)BgL_new1116z00_395), BEOA); } 
BgL_auxz00_884 = 
((obj_t)BgL_new1116z00_395); } 
return 
((((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BgL_decz00_282))))->BgL_z52flacz52)=((obj_t)BgL_auxz00_884),BUNSPEC);} } } 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__flac_padecz00()
{
{ /* Llib/flac_padec.scm 15 */
BGl_modulezd2initializa7ationz75zz__flac_flacz00(((long)107017853), 
BSTRING_TO_STRING(BGl_string1298z00zz__flac_padecz00)); 
return 
BGl_modulezd2initializa7ationz75zz__flac_decoderz00(((long)630617), 
BSTRING_TO_STRING(BGl_string1298z00zz__flac_padecz00));} 

}

#ifdef __cplusplus
}
#endif
