/*===========================================================================*/
/*   (Llib/_pthread.scm)                                                     */
/*   Bigloo (4.3h)                                                           */
/*   Inria -- Sophia Antipolis (c)       Tue 12 May 2020 08:36:09 AM CEST    */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.3h/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.3h/lib/bigloo/4.3h -I Llib -lib-dir /builddir/build/BUILD/bigloo-4.3h/lib/bigloo/4.3h -unsafe -safee -copt -fPIC -copt -IPosix Llib/_pthread.scm -o objs/_pthread.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_threadz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
} *BgL_threadz00_bglt;

typedef struct BgL_z62exceptionz62_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_fnamez00;
   obj_t BgL_locationz00;
   obj_t BgL_stackz00;
} *BgL_z62exceptionz62_bglt;

typedef struct BgL_uncaughtzd2exceptionzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_fnamez00;
   obj_t BgL_locationz00;
   obj_t BgL_stackz00;
   obj_t BgL_reasonz00;
} *BgL_uncaughtzd2exceptionzd2_bglt;

typedef struct BgL_pthreadz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_bodyz00;
   bool_t BgL_detachedpz00;
   obj_t BgL_endzd2resultzd2;
   obj_t BgL_endzd2exceptionzd2;
   void * BgL_z42builtinz42;
} *BgL_pthreadz00_bglt;

typedef struct BgL_fthreadz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_schedulerz00;
   obj_t BgL_z52builtinz52;
   int BgL_z52timeoutz52;
   obj_t BgL_z52statez52;
   bool_t BgL_z52iszd2suspendz80;
   obj_t BgL_z52terminatez52;
   obj_t BgL_z52resultz52;
   obj_t BgL_z52exczd2resultz80;
   bool_t BgL_z52exczd2raisedz80;
   int BgL_z52identz52;
   obj_t BgL_z52signalsz52;
   obj_t BgL_z52awakezd2signalz80;
   obj_t BgL_z52awakezd2valuez80;
   obj_t BgL_z52cleanupz52;
   obj_t BgL_z52specificz52;
   obj_t BgL_bodyz00;
} *BgL_fthreadz00_bglt;

typedef struct BgL_schedulerz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_schedulerz00;
   obj_t BgL_z52builtinz52;
   int BgL_z52timeoutz52;
   obj_t BgL_z52statez52;
   bool_t BgL_z52iszd2suspendz80;
   obj_t BgL_z52terminatez52;
   obj_t BgL_z52resultz52;
   obj_t BgL_z52exczd2resultz80;
   bool_t BgL_z52exczd2raisedz80;
   int BgL_z52identz52;
   obj_t BgL_z52signalsz52;
   obj_t BgL_z52awakezd2signalz80;
   obj_t BgL_z52awakezd2valuez80;
   obj_t BgL_z52cleanupz52;
   obj_t BgL_z52specificz52;
   obj_t BgL_bodyz00;
   obj_t BgL_envzb2zb2;
   obj_t BgL_strictzd2orderzf3z21;
} *BgL_schedulerz00_bglt;

typedef struct BgL_z52sigjoinz52_bgl {
   header_t header;
   obj_t widening;
   struct BgL_fthreadz00_bgl * BgL_threadz00;
} *BgL_z52sigjoinz52_bglt;

typedef struct BgL_z52schedulerz52_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_schedulerz00;
   obj_t BgL_z52builtinz52;
   int BgL_z52timeoutz52;
   obj_t BgL_z52statez52;
   bool_t BgL_z52iszd2suspendz80;
   obj_t BgL_z52terminatez52;
   obj_t BgL_z52resultz52;
   obj_t BgL_z52exczd2resultz80;
   bool_t BgL_z52exczd2raisedz80;
   int BgL_z52identz52;
   obj_t BgL_z52signalsz52;
   obj_t BgL_z52awakezd2signalz80;
   obj_t BgL_z52awakezd2valuez80;
   obj_t BgL_z52cleanupz52;
   obj_t BgL_z52specificz52;
   obj_t BgL_bodyz00;
   obj_t BgL_envzb2zb2;
   obj_t BgL_strictzd2orderzf3z21;
   obj_t BgL_nextzd2instantzd2;
   obj_t BgL_currentzd2threadzd2;
   int BgL_z52livezd2threadzd2numberz52;
   bool_t BgL_z52threadszd2readyz80;
   obj_t BgL_threadszd2runnablezd2;
   obj_t BgL_threadszd2runnablezd2lastzd2pairzd2;
   obj_t BgL_asynczd2runnablezd2;
   obj_t BgL_threadszd2timeoutzd2;
   obj_t BgL_threadszd2yieldzd2;
   obj_t BgL_tostartz00;
   obj_t BgL_toterminatez00;
   obj_t BgL_tosuspendzf2resumezf2;
   obj_t BgL_tobroadcastz00;
   obj_t BgL_tospawnz00;
   obj_t BgL_currentzd2tokenzd2;
} *BgL_z52schedulerz52_bglt;

typedef struct BgL_z52pthreadz52_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_bodyz00;
   bool_t BgL_detachedpz00;
   obj_t BgL_endzd2resultzd2;
   obj_t BgL_endzd2exceptionzd2;
   void * BgL_z42builtinz42;
   obj_t BgL_fthreadz00;
   obj_t BgL_mutexz00;
   obj_t BgL_condvarz00;
   obj_t BgL_idz00;
   obj_t BgL_parentz00;
} *BgL_z52pthreadz52_bglt;


static obj_t BGl_z62zc3z04anonymousza31121ze3ze5zz__ft_z52pthreadz52(obj_t);
static obj_t BGl_z62objectzd2displayzd2z52pthr1103z30zz__ft_z52pthreadz52(obj_t, obj_t, obj_t);
static obj_t BGl_z62terminatez62zz__ft_z52pthreadz52(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_z52asynczd2synchroniza7ez27zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt);
BGL_IMPORT void * BGl_z42pthreadzd2nilz90zz__pth_threadz00();
static obj_t BGl_objectzd2initzd2zz__ft_z52pthreadz52();
BGL_EXPORTED_DECL obj_t BGl_z52asynczd2spawnz80zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31142ze3ze5zz__ft_z52pthreadz52(obj_t);
extern obj_t BGl_z52schedulerz52zz__ft_z52typesz52;
BGL_IMPORT obj_t bstring_to_symbol(obj_t);
BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
extern obj_t BGl_z52threadzd2killz12z92zz__ft_z52threadz52(BgL_fthreadz00_bglt);
static obj_t BGl_z62z52pthreadzd2leavezd2schedulerz30zz__ft_z52pthreadz52(obj_t, obj_t);
static obj_t BGl_z62z52asynczd2schedulerzd2notifyz30zz__ft_z52pthreadz52(obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__ft_z52pthreadz52();
static obj_t BGl_z62zc3z04anonymousza31162ze3ze5zz__ft_z52pthreadz52(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_z52asynczd2schedulerzd2waitz52zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt);
BGL_IMPORT obj_t BGl_uncaughtzd2exceptionzd2zz__pth_threadz00;
BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62z52asynczd2schedulerzd2waitz30zz__ft_z52pthreadz52(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31168ze3ze5zz__ft_z52pthreadz52(obj_t);
BGL_IMPORT obj_t BGl_exceptionzd2notifyzd2zz__objectz00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_z52pthreadzd2enterzd2schedulerz52zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt);
BGL_IMPORT obj_t BGl_unwindzd2untilz12zc0zz__bexitz00(obj_t, obj_t);
static obj_t BGl_z62z52pthreadzd2switchze2zz__ft_z52pthreadz52(obj_t, obj_t, obj_t);
static obj_t BGl_z62z52asynczd2spawnze2zz__ft_z52pthreadz52(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_schedulerz00zz__ft_typesz00;
BGL_IMPORT obj_t BGl_threadzd2startz12zc0zz__threadz00(BgL_threadz00_bglt, obj_t);
extern obj_t BGl_currentzd2schedulerzd2setz12z12zz__ft_schedulerz00(obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__ft_z52pthreadz52();
static obj_t BGl_za2schedulerzd2currentzd2tokenza2z00zz__ft_z52pthreadz52 = BUNSPEC;
BGL_IMPORT obj_t BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_displayza2za2zz__r4_output_6_10_3z00(obj_t);
extern obj_t BGl_z52threadzd2timeoutz12z92zz__ft_z52threadz52(BgL_fthreadz00_bglt, int);
static obj_t BGl_z62z52userzd2threadzd2yieldz12zd21107zf0zz__ft_z52pthreadz52(obj_t, obj_t);
extern obj_t BGl_currentzd2schedulerzd2zz__ft_schedulerz00();
BGL_IMPORT obj_t BGl_gensymz00zz__r4_symbols_6_4z00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_z52fschedulerzd2newz80zz__ft_z52pthreadz52(BgL_z52schedulerz52_bglt);
BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62z52userzd2threadzd2yieldz12zd21113zf0zz__ft_z52pthreadz52(obj_t, obj_t);
BGL_IMPORT obj_t bgl_find_runtime_type(obj_t);
BGL_EXPORTED_DECL obj_t BGl_z52pthreadzd2waitz80zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt);
extern obj_t BGl_defaultzd2schedulerzd2zz__ft_schedulerz00(obj_t);
static obj_t BGl_z62z52asynczd2asynchroniza7ez45zz__ft_z52pthreadz52(obj_t, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zz__ft_z52pthreadz52 = BUNSPEC;
BGL_IMPORT obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_toplevelzd2initzd2zz__ft_z52pthreadz52();
static obj_t BGl_z62objectzd2writezd2z52pthrea1101z30zz__ft_z52pthreadz52(obj_t, obj_t, obj_t);
static obj_t BGl_genericzd2initzd2zz__ft_z52pthreadz52();
BGL_IMPORT obj_t BGl_stringzd2copyzd2zz__r4_strings_6_7z00(obj_t);
extern obj_t BGl_broadcastz12z12zz__ft_schedulerz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_pthreadz00zz__pth_threadz00;
BGL_EXPORTED_DECL obj_t BGl_z52asynczd2asynchroniza7ez27zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt);
static obj_t BGl_z62z52pthreadzd2enterzd2schedulerz30zz__ft_z52pthreadz52(obj_t, obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
extern obj_t BGl_fthreadz00zz__ft_typesz00;
BGL_IMPORT obj_t BGl_objectzd2writezd2zz__objectz00(BgL_objectz00_bglt, obj_t);
extern obj_t BGl_z52sigjoinz52zz__ft_typesz00;
BGL_EXPORTED_DECL obj_t BGl_z52pthreadzd2newz80zz__ft_z52pthreadz52(BgL_fthreadz00_bglt);
static obj_t BGl_z62z52userzd2currentzd2thread1105z30zz__ft_z52pthreadz52(obj_t, obj_t);
static obj_t BGl_z62z52userzd2currentzd2thread1111z30zz__ft_z52pthreadz52(obj_t, obj_t);
BGL_IMPORT obj_t string_append(obj_t, obj_t);
extern obj_t BGl_z52pthreadz52zz__ft_z52typesz52;
static obj_t BGl_z62z52userzd2threadzd2sleepz12zd21109zf0zz__ft_z52pthreadz52(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2constructorzd2zz__objectz00(obj_t);
static obj_t BGl_z62z52userzd2threadzd2sleepz12zd21115zf0zz__ft_z52pthreadz52(obj_t, obj_t, obj_t);
static obj_t BGl_z62z52pthreadzd2waitze2zz__ft_z52pthreadz52(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__ft_z52pthreadz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_signalz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52schedulerz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_schedulerz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52threadz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52typesz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_typesz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__pth_threadz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
BGL_IMPORT obj_t BGl_withzd2outputzd2tozd2portzd2zz__r4_ports_6_10_1z00(obj_t, obj_t);
static obj_t BGl_z52getzd2schedulerzd2tokenz52zz__ft_z52pthreadz52();
BGL_EXPORTED_DECL obj_t BGl_z52pthreadzd2switchz80zz__ft_z52pthreadz52(obj_t, BgL_z52pthreadz52_bglt);
static obj_t BGl_z62zc3z04anonymousza31518ze3ze5zz__ft_z52pthreadz52(obj_t);
BGL_IMPORT obj_t BGl_currentzd2threadzd2zz__threadz00();
static obj_t BGl_zc3z04exitza31156ze3ze70z60zz__ft_z52pthreadz52(BgL_fthreadz00_bglt, BgL_fthreadz00_bglt);
BGL_EXPORTED_DECL obj_t BGl_z52pthreadzd2leavezd2schedulerz52zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt);
static obj_t BGl_cnstzd2initzd2zz__ft_z52pthreadz52();
static obj_t BGl_libraryzd2moduleszd2initz00zz__ft_z52pthreadz52();
static obj_t BGl_importedzd2moduleszd2initz00zz__ft_z52pthreadz52();
static obj_t BGl_z62z52asynczd2synchroniza7ez45zz__ft_z52pthreadz52(obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(obj_t);
static obj_t BGl_z62z52pthreadzd2newze2zz__ft_z52pthreadz52(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_z52asynczd2schedulerzd2notifyz52zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt);
static obj_t BGl_z62z52fschedulerzd2newze2zz__ft_z52pthreadz52(obj_t, obj_t);
static obj_t BGl_z52setzd2schedulerzd2tokenz12z40zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt);
BGL_IMPORT obj_t BGl_withzd2exceptionzd2handlerz00zz__errorz00(obj_t, obj_t);
extern obj_t BGl_z52threadzd2yieldz12z92zz__ft_z52threadz52(BgL_fthreadz00_bglt);
static obj_t __cnst[ 2 ] ;


DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52pthreadzd2enterzd2schedulerzd2envz80zz__ft_z52pthreadz52, BgL_bgl_za762za752pthreadza7d21758za7, BGl_z62z52pthreadzd2enterzd2schedulerz30zz__ft_z52pthreadz52, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52pthreadzd2switchzd2envz52zz__ft_z52pthreadz52, BgL_bgl_za762za752pthreadza7d21759za7, BGl_z62z52pthreadzd2switchze2zz__ft_z52pthreadz52, 0L, BUNSPEC, 2 );
BGL_IMPORT obj_t BGl_objectzd2writezd2envz00zz__objectz00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1715z00zz__ft_z52pthreadz52, BgL_bgl_za762za7c3za704anonymo1760za7, BGl_z62zc3z04anonymousza31121ze3ze5zz__ft_z52pthreadz52, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52asynczd2spawnzd2envz52zz__ft_z52pthreadz52, BgL_bgl_za762za752asyncza7d2sp1761za7, BGl_z62z52asynczd2spawnze2zz__ft_z52pthreadz52, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1735z00zz__ft_z52pthreadz52, BgL_bgl_za762objectza7d2writ1762z00, va_generic_entry, BGl_z62objectzd2writezd2z52pthrea1101z30zz__ft_z52pthreadz52, BUNSPEC, -2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1737z00zz__ft_z52pthreadz52, BgL_bgl_za762objectza7d2disp1763z00, va_generic_entry, BGl_z62objectzd2displayzd2z52pthr1103z30zz__ft_z52pthreadz52, BUNSPEC, -2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1739z00zz__ft_z52pthreadz52, BgL_bgl_za762za752userza7d2cur1764za7, BGl_z62z52userzd2currentzd2thread1105z30zz__ft_z52pthreadz52, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1741z00zz__ft_z52pthreadz52, BgL_bgl_za762za752userza7d2thr1765za7, BGl_z62z52userzd2threadzd2yieldz12zd21107zf0zz__ft_z52pthreadz52, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1743z00zz__ft_z52pthreadz52, BgL_bgl_za762za752userza7d2thr1766za7, BGl_z62z52userzd2threadzd2sleepz12zd21109zf0zz__ft_z52pthreadz52, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1745z00zz__ft_z52pthreadz52, BgL_bgl_za762za752userza7d2cur1767za7, BGl_z62z52userzd2currentzd2thread1111z30zz__ft_z52pthreadz52, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1746z00zz__ft_z52pthreadz52, BgL_bgl_za762za752userza7d2thr1768za7, BGl_z62z52userzd2threadzd2yieldz12zd21113zf0zz__ft_z52pthreadz52, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1747z00zz__ft_z52pthreadz52, BgL_bgl_za762za752userza7d2thr1769za7, BGl_z62z52userzd2threadzd2sleepz12zd21115zf0zz__ft_z52pthreadz52, 0L, BUNSPEC, 2 );
BGL_IMPORT obj_t BGl_objectzd2displayzd2envz00zz__objectz00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52asynczd2synchroniza7ezd2envzf5zz__ft_z52pthreadz52, BgL_bgl_za762za752asyncza7d2sy1770za7, BGl_z62z52asynczd2synchroniza7ez45zz__ft_z52pthreadz52, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52pthreadzd2newzd2envz52zz__ft_z52pthreadz52, BgL_bgl_za762za752pthreadza7d21771za7, BGl_z62z52pthreadzd2newze2zz__ft_z52pthreadz52, 0L, BUNSPEC, 1 );
BGL_IMPORT obj_t BGl_z52userzd2threadzd2yieldz12zd2envz92zz__threadz00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52pthreadzd2leavezd2schedulerzd2envz80zz__ft_z52pthreadz52, BgL_bgl_za762za752pthreadza7d21772za7, BGl_z62z52pthreadzd2leavezd2schedulerz30zz__ft_z52pthreadz52, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1714z00zz__ft_z52pthreadz52, BgL_bgl_string1714za700za7za7_1773za7, "Llib/_pthread.scm", 17 );
DEFINE_STRING( BGl_string1716z00zz__ft_z52pthreadz52, BgL_bgl_string1716za700za7za7_1774za7, "/builddir/build/BUILD/bigloo-4.3h/api/fthread/src/Llib/_pthread.scm", 67 );
DEFINE_STRING( BGl_string1717z00zz__ft_z52pthreadz52, BgL_bgl_string1717za700za7za7_1775za7, "&%fscheduler-new", 16 );
DEFINE_STRING( BGl_string1718z00zz__ft_z52pthreadz52, BgL_bgl_string1718za700za7za7_1776za7, "%scheduler", 10 );
DEFINE_STRING( BGl_string1719z00zz__ft_z52pthreadz52, BgL_bgl_string1719za700za7za7_1777za7, "&%pthread-new", 13 );
DEFINE_STRING( BGl_string1720z00zz__ft_z52pthreadz52, BgL_bgl_string1720za700za7za7_1778za7, "fthread", 7 );
DEFINE_STRING( BGl_string1721z00zz__ft_z52pthreadz52, BgL_bgl_string1721za700za7za7_1779za7, "Illegal cleanup function", 24 );
DEFINE_STRING( BGl_string1722z00zz__ft_z52pthreadz52, BgL_bgl_string1722za700za7za7_1780za7, "&%pthread-wait", 14 );
DEFINE_STRING( BGl_string1723z00zz__ft_z52pthreadz52, BgL_bgl_string1723za700za7za7_1781za7, "%pthread", 8 );
DEFINE_STRING( BGl_string1724z00zz__ft_z52pthreadz52, BgL_bgl_string1724za700za7za7_1782za7, "&%pthread-switch", 16 );
DEFINE_STRING( BGl_string1725z00zz__ft_z52pthreadz52, BgL_bgl_string1725za700za7za7_1783za7, "Bogus (current-thread) procedure", 32 );
DEFINE_STRING( BGl_string1726z00zz__ft_z52pthreadz52, BgL_bgl_string1726za700za7za7_1784za7, "Undefined current-thread", 24 );
DEFINE_STRING( BGl_string1727z00zz__ft_z52pthreadz52, BgL_bgl_string1727za700za7za7_1785za7, "&%pthread-enter-scheduler", 25 );
DEFINE_STRING( BGl_string1728z00zz__ft_z52pthreadz52, BgL_bgl_string1728za700za7za7_1786za7, "&%pthread-leave-scheduler", 25 );
DEFINE_STRING( BGl_string1729z00zz__ft_z52pthreadz52, BgL_bgl_string1729za700za7za7_1787za7, "&%async-spawn", 13 );
DEFINE_STRING( BGl_string1730z00zz__ft_z52pthreadz52, BgL_bgl_string1730za700za7za7_1788za7, "procedure", 9 );
DEFINE_STRING( BGl_string1731z00zz__ft_z52pthreadz52, BgL_bgl_string1731za700za7za7_1789za7, "&%async-synchronize", 19 );
DEFINE_STRING( BGl_string1732z00zz__ft_z52pthreadz52, BgL_bgl_string1732za700za7za7_1790za7, "&%async-asynchronize", 20 );
DEFINE_STRING( BGl_string1733z00zz__ft_z52pthreadz52, BgL_bgl_string1733za700za7za7_1791za7, "&%async-scheduler-wait", 22 );
DEFINE_STRING( BGl_string1734z00zz__ft_z52pthreadz52, BgL_bgl_string1734za700za7za7_1792za7, "&%async-scheduler-notify", 24 );
DEFINE_STRING( BGl_string1736z00zz__ft_z52pthreadz52, BgL_bgl_string1736za700za7za7_1793za7, "object-write", 12 );
DEFINE_STRING( BGl_string1738z00zz__ft_z52pthreadz52, BgL_bgl_string1738za700za7za7_1794za7, "object-display", 14 );
DEFINE_STRING( BGl_string1740z00zz__ft_z52pthreadz52, BgL_bgl_string1740za700za7za7_1795za7, "%user-current-thread", 20 );
DEFINE_STRING( BGl_string1742z00zz__ft_z52pthreadz52, BgL_bgl_string1742za700za7za7_1796za7, "%user-thread-yield!", 19 );
DEFINE_STRING( BGl_string1744z00zz__ft_z52pthreadz52, BgL_bgl_string1744za700za7za7_1797za7, "%user-thread-sleep!", 19 );
DEFINE_STRING( BGl_string1748z00zz__ft_z52pthreadz52, BgL_bgl_string1748za700za7za7_1798za7, "*self*", 6 );
DEFINE_STRING( BGl_string1749z00zz__ft_z52pthreadz52, BgL_bgl_string1749za700za7za7_1799za7, ">", 1 );
DEFINE_STRING( BGl_string1750z00zz__ft_z52pthreadz52, BgL_bgl_string1750za700za7za7_1800za7, " parent:", 8 );
DEFINE_STRING( BGl_string1751z00zz__ft_z52pthreadz52, BgL_bgl_string1751za700za7za7_1801za7, "#<%pthread:", 11 );
DEFINE_STRING( BGl_string1752z00zz__ft_z52pthreadz52, BgL_bgl_string1752za700za7za7_1802za7, "__ft_%pthread", 13 );
DEFINE_STRING( BGl_string1753z00zz__ft_z52pthreadz52, BgL_bgl_string1753za700za7za7_1803za7, "async %pthread-enter-scheduler ", 31 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52asynczd2schedulerzd2notifyzd2envz80zz__ft_z52pthreadz52, BgL_bgl_za762za752asyncza7d2sc1804za7, BGl_z62z52asynczd2schedulerzd2notifyz30zz__ft_z52pthreadz52, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52asynczd2schedulerzd2waitzd2envz80zz__ft_z52pthreadz52, BgL_bgl_za762za752asyncza7d2sc1805za7, BGl_z62z52asynczd2schedulerzd2waitz30zz__ft_z52pthreadz52, 0L, BUNSPEC, 1 );
BGL_IMPORT obj_t BGl_z52userzd2threadzd2sleepz12zd2envz92zz__threadz00;
BGL_IMPORT obj_t BGl_z52userzd2currentzd2threadzd2envz80zz__threadz00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52pthreadzd2waitzd2envz52zz__ft_z52pthreadz52, BgL_bgl_za762za752pthreadza7d21806za7, BGl_z62z52pthreadzd2waitze2zz__ft_z52pthreadz52, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52asynczd2asynchroniza7ezd2envzf5zz__ft_z52pthreadz52, BgL_bgl_za762za752asyncza7d2as1807za7, BGl_z62z52asynczd2asynchroniza7ez45zz__ft_z52pthreadz52, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52fschedulerzd2newzd2envz52zz__ft_z52pthreadz52, BgL_bgl_za762za752fscheduler1808z00, BGl_z62z52fschedulerzd2newze2zz__ft_z52pthreadz52, 0L, BUNSPEC, 1 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_za2schedulerzd2currentzd2tokenza2z00zz__ft_z52pthreadz52) );
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__ft_z52pthreadz52) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__ft_z52pthreadz52(long BgL_checksumz00_614, char * BgL_fromz00_615)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__ft_z52pthreadz52))
{ 
BGl_requirezd2initializa7ationz75zz__ft_z52pthreadz52 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__ft_z52pthreadz52(); 
BGl_libraryzd2moduleszd2initz00zz__ft_z52pthreadz52(); 
BGl_cnstzd2initzd2zz__ft_z52pthreadz52(); 
BGl_importedzd2moduleszd2initz00zz__ft_z52pthreadz52(); 
BGl_methodzd2initzd2zz__ft_z52pthreadz52(); 
return 
BGl_toplevelzd2initzd2zz__ft_z52pthreadz52();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__ft_z52pthreadz52()
{
{ /* Llib/_pthread.scm 6 */
BGl_modulezd2initializa7ationz75zz__pth_threadz00(((long)0), "__ft_%pthread"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__ft_%pthread"); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "__ft_%pthread"); 
BGl_modulezd2initializa7ationz75zz__bexitz00(((long)0), "__ft_%pthread"); 
BGl_modulezd2initializa7ationz75zz__threadz00(((long)0), "__ft_%pthread"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__ft_%pthread"); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "__ft_%pthread"); 
BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long)0), "__ft_%pthread"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__ft_%pthread"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__ft_%pthread"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__ft_%pthread"); 
BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(((long)0), "__ft_%pthread"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__ft_%pthread"); 
BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)0), "__ft_%pthread"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__ft_%pthread"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__ft_z52pthreadz52()
{
{ /* Llib/_pthread.scm 6 */
{ /* Llib/_pthread.scm 6 */
obj_t BgL_cportz00_550;
{ /* Llib/_pthread.scm 6 */
obj_t BgL_stringz00_558;
BgL_stringz00_558 = BGl_string1753z00zz__ft_z52pthreadz52; 
{ /* Llib/_pthread.scm 6 */
obj_t BgL_startz00_559;
BgL_startz00_559 = 
BINT(((long)0)); 
{ /* Llib/_pthread.scm 6 */
obj_t BgL_endz00_560;
BgL_endz00_560 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_558))); 
{ /* Llib/_pthread.scm 6 */

BgL_cportz00_550 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_558, BgL_startz00_559, BgL_endz00_560); } } } } 
{ 
long BgL_iz00_551;
BgL_iz00_551 = ((long)1); 
BgL_loopz00_552:
if(
(BgL_iz00_551==((long)-1)))
{ /* Llib/_pthread.scm 6 */
return BUNSPEC;}  else 
{ /* Llib/_pthread.scm 6 */
{ /* Llib/_pthread.scm 6 */
obj_t BgL_arg1756z00_554;
{ /* Llib/_pthread.scm 6 */

{ /* Llib/_pthread.scm 6 */
obj_t BgL_locationz00_556;
BgL_locationz00_556 = 
BBOOL(((bool_t)0)); 
{ /* Llib/_pthread.scm 6 */

BgL_arg1756z00_554 = 
BGl_readz00zz__readerz00(BgL_cportz00_550, BgL_locationz00_556); } } } 
{ /* Llib/_pthread.scm 6 */
int BgL_tmpz00_649;
BgL_tmpz00_649 = 
(int)(BgL_iz00_551); 
CNST_TABLE_SET(BgL_tmpz00_649, BgL_arg1756z00_554); } } 
{ /* Llib/_pthread.scm 6 */
int BgL_auxz00_557;
BgL_auxz00_557 = 
(int)(
(BgL_iz00_551-((long)1))); 
{ 
long BgL_iz00_654;
BgL_iz00_654 = 
(long)(BgL_auxz00_557); 
BgL_iz00_551 = BgL_iz00_654; 
goto BgL_loopz00_552;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__ft_z52pthreadz52()
{
{ /* Llib/_pthread.scm 6 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__ft_z52pthreadz52()
{
{ /* Llib/_pthread.scm 6 */
BGl_modulezd2initializa7ationz75zz__pth_threadz00(((long)0), 
BSTRING_TO_STRING(BGl_string1714z00zz__ft_z52pthreadz52)); 
BGl_za2schedulerzd2currentzd2tokenza2z00zz__ft_z52pthreadz52 = BFALSE; 
return BUNSPEC;} 

}



/* %get-scheduler-token */
obj_t BGl_z52getzd2schedulerzd2tokenz52zz__ft_z52pthreadz52()
{
{ /* Llib/_pthread.scm 36 */
{ /* Llib/_pthread.scm 37 */
obj_t BgL_scdlz00_39;
BgL_scdlz00_39 = 
BGl_currentzd2schedulerzd2zz__ft_schedulerz00(); 
if(
BGl_isazf3zf3zz__objectz00(BgL_scdlz00_39, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* Llib/_pthread.scm 38 */
return 
(((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_39)))->BgL_currentzd2tokenzd2);}  else 
{ /* Llib/_pthread.scm 38 */
return BGl_za2schedulerzd2currentzd2tokenza2z00zz__ft_z52pthreadz52;} } } 

}



/* %set-scheduler-token! */
obj_t BGl_z52setzd2schedulerzd2tokenz12z40zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt BgL_tokenz00_3)
{
{ /* Llib/_pthread.scm 43 */
{ /* Llib/_pthread.scm 44 */
obj_t BgL_scdlz00_42;
BgL_scdlz00_42 = 
BGl_currentzd2schedulerzd2zz__ft_schedulerz00(); 
if(
BGl_isazf3zf3zz__objectz00(BgL_scdlz00_42, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* Llib/_pthread.scm 45 */
return 
((((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_42)))->BgL_currentzd2tokenzd2)=((obj_t)
((obj_t)BgL_tokenz00_3)),BUNSPEC);}  else 
{ /* Llib/_pthread.scm 45 */
return ( 
BGl_za2schedulerzd2currentzd2tokenza2z00zz__ft_z52pthreadz52 = 
((obj_t)BgL_tokenz00_3), BUNSPEC) ;} } } 

}



/* %fscheduler-new */
BGL_EXPORTED_DEF obj_t BGl_z52fschedulerzd2newz80zz__ft_z52pthreadz52(BgL_z52schedulerz52_bglt BgL_scdlz00_4)
{
{ /* Llib/_pthread.scm 53 */
{ /* Llib/_pthread.scm 56 */
BgL_z52pthreadz52_bglt BgL_z52pthz52_46;
{ /* Llib/_pthread.scm 56 */
BgL_z52pthreadz52_bglt BgL_new1064z00_47;
{ /* Llib/_pthread.scm 58 */
BgL_z52pthreadz52_bglt BgL_new1063z00_56;
BgL_new1063z00_56 = 
((BgL_z52pthreadz52_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52pthreadz52_bgl) ))); 
{ /* Llib/_pthread.scm 58 */
long BgL_arg1141z00_57;
{ /* Llib/_pthread.scm 58 */
long BgL_res1646z00_276;
BgL_res1646z00_276 = 
BGL_CLASS_INDEX(BGl_z52pthreadz52zz__ft_z52typesz52); 
BgL_arg1141z00_57 = BgL_res1646z00_276; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1063z00_56), BgL_arg1141z00_57); } 
BgL_new1064z00_47 = BgL_new1063z00_56; } 
((((BgL_threadz00_bglt)COBJECT(
((BgL_threadz00_bglt)BgL_new1064z00_47)))->BgL_namez00)=((obj_t)
(((BgL_threadz00_bglt)COBJECT(
((BgL_threadz00_bglt)BgL_scdlz00_4)))->BgL_namez00)),BUNSPEC); 
((((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_new1064z00_47)))->BgL_bodyz00)=((obj_t)BGl_proc1715z00zz__ft_z52pthreadz52),BUNSPEC); 
((((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_new1064z00_47)))->BgL_detachedpz00)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_new1064z00_47)))->BgL_endzd2resultzd2)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_new1064z00_47)))->BgL_endzd2exceptionzd2)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_new1064z00_47)))->BgL_z42builtinz42)=((void *)
BGl_z42pthreadzd2nilz90zz__pth_threadz00()),BUNSPEC); 
((((BgL_z52pthreadz52_bglt)COBJECT(BgL_new1064z00_47))->BgL_fthreadz00)=((obj_t)
((obj_t)BgL_scdlz00_4)),BUNSPEC); 
{ 
obj_t BgL_auxz00_692;
{ /* Llib/_pthread.scm 59 */
obj_t BgL_arg1132z00_49;
{ /* Llib/_pthread.scm 59 */
obj_t BgL_arg1133z00_50;
{ /* Llib/_pthread.scm 59 */
obj_t BgL_res1647z00_280;
{ /* Llib/_pthread.scm 59 */
obj_t BgL_classz00_279;
BgL_classz00_279 = BGl_z52pthreadz52zz__ft_z52typesz52; 
BgL_res1647z00_280 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_279); } 
BgL_arg1133z00_50 = BgL_res1647z00_280; } 
BgL_arg1132z00_49 = 
VECTOR_REF(BgL_arg1133z00_50,((long)9)); } 
BgL_auxz00_692 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1132z00_49); } 
((((BgL_z52pthreadz52_bglt)COBJECT(BgL_new1064z00_47))->BgL_mutexz00)=((obj_t)BgL_auxz00_692),BUNSPEC); } 
{ 
obj_t BgL_auxz00_697;
{ /* Llib/_pthread.scm 59 */
obj_t BgL_arg1134z00_51;
{ /* Llib/_pthread.scm 59 */
obj_t BgL_arg1136z00_52;
{ /* Llib/_pthread.scm 59 */
obj_t BgL_res1648z00_283;
{ /* Llib/_pthread.scm 59 */
obj_t BgL_classz00_282;
BgL_classz00_282 = BGl_z52pthreadz52zz__ft_z52typesz52; 
BgL_res1648z00_283 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_282); } 
BgL_arg1136z00_52 = BgL_res1648z00_283; } 
BgL_arg1134z00_51 = 
VECTOR_REF(BgL_arg1136z00_52,((long)10)); } 
BgL_auxz00_697 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1134z00_51); } 
((((BgL_z52pthreadz52_bglt)COBJECT(BgL_new1064z00_47))->BgL_condvarz00)=((obj_t)BgL_auxz00_697),BUNSPEC); } 
{ 
obj_t BgL_auxz00_702;
{ /* Llib/_pthread.scm 59 */
obj_t BgL_arg1137z00_53;
{ /* Llib/_pthread.scm 59 */
obj_t BgL_arg1138z00_54;
{ /* Llib/_pthread.scm 59 */
obj_t BgL_res1649z00_286;
{ /* Llib/_pthread.scm 59 */
obj_t BgL_classz00_285;
BgL_classz00_285 = BGl_z52pthreadz52zz__ft_z52typesz52; 
BgL_res1649z00_286 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_285); } 
BgL_arg1138z00_54 = BgL_res1649z00_286; } 
BgL_arg1137z00_53 = 
VECTOR_REF(BgL_arg1138z00_54,((long)11)); } 
BgL_auxz00_702 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1137z00_53); } 
((((BgL_z52pthreadz52_bglt)COBJECT(BgL_new1064z00_47))->BgL_idz00)=((obj_t)BgL_auxz00_702),BUNSPEC); } 
((((BgL_z52pthreadz52_bglt)COBJECT(BgL_new1064z00_47))->BgL_parentz00)=((obj_t)BFALSE),BUNSPEC); 
{ /* Llib/_pthread.scm 56 */
obj_t BgL_fun1139z00_55;
BgL_fun1139z00_55 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_z52pthreadz52zz__ft_z52typesz52); 
PROCEDURE_ENTRY(BgL_fun1139z00_55)(BgL_fun1139z00_55, 
((obj_t)BgL_new1064z00_47), BEOA); } 
BgL_z52pthz52_46 = BgL_new1064z00_47; } 
return 
((obj_t)BgL_z52pthz52_46);} } 

}



/* &%fscheduler-new */
obj_t BGl_z62z52fschedulerzd2newze2zz__ft_z52pthreadz52(obj_t BgL_envz00_412, obj_t BgL_scdlz00_413)
{
{ /* Llib/_pthread.scm 53 */
{ /* Llib/_pthread.scm 55 */
BgL_z52schedulerz52_bglt BgL_auxz00_715;
if(
BGl_isazf3zf3zz__objectz00(BgL_scdlz00_413, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* Llib/_pthread.scm 55 */
BgL_auxz00_715 = 
((BgL_z52schedulerz52_bglt)BgL_scdlz00_413)
; }  else 
{ 
obj_t BgL_auxz00_719;
BgL_auxz00_719 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1716z00zz__ft_z52pthreadz52, 
BINT(((long)1881)), BGl_string1717z00zz__ft_z52pthreadz52, BGl_string1718z00zz__ft_z52pthreadz52, BgL_scdlz00_413); 
FAILURE(BgL_auxz00_719,BFALSE,BFALSE);} 
return 
BGl_z52fschedulerzd2newz80zz__ft_z52pthreadz52(BgL_auxz00_715);} } 

}



/* &<@anonymous:1121> */
obj_t BGl_z62zc3z04anonymousza31121ze3ze5zz__ft_z52pthreadz52(obj_t BgL_envz00_414)
{
{ /* Llib/_pthread.scm 57 */
return BUNSPEC;} 

}



/* %pthread-new */
BGL_EXPORTED_DEF obj_t BGl_z52pthreadzd2newz80zz__ft_z52pthreadz52(BgL_fthreadz00_bglt BgL_ftz00_5)
{
{ /* Llib/_pthread.scm 66 */
{ /* Llib/_pthread.scm 95 */
obj_t BgL_z52pthz52_434;
BgL_z52pthz52_434 = 
MAKE_CELL(BUNSPEC); 
{ /* Llib/_pthread.scm 95 */
BgL_z52pthreadz52_bglt BgL_g1154z00_74;
{ /* Llib/_pthread.scm 96 */
BgL_z52pthreadz52_bglt BgL_new1078z00_61;
{ /* Llib/_pthread.scm 102 */
BgL_z52pthreadz52_bglt BgL_new1077z00_72;
BgL_new1077z00_72 = 
((BgL_z52pthreadz52_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52pthreadz52_bgl) ))); 
{ /* Llib/_pthread.scm 102 */
long BgL_arg1153z00_73;
{ /* Llib/_pthread.scm 102 */
long BgL_res1654z00_301;
BgL_res1654z00_301 = 
BGL_CLASS_INDEX(BGl_z52pthreadz52zz__ft_z52typesz52); 
BgL_arg1153z00_73 = BgL_res1654z00_301; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1077z00_72), BgL_arg1153z00_73); } 
BgL_new1078z00_61 = BgL_new1077z00_72; } 
((((BgL_threadz00_bglt)COBJECT(
((BgL_threadz00_bglt)BgL_new1078z00_61)))->BgL_namez00)=((obj_t)
(((BgL_threadz00_bglt)COBJECT(
((BgL_threadz00_bglt)BgL_ftz00_5)))->BgL_namez00)),BUNSPEC); 
{ 
obj_t BgL_auxz00_732;
{ /* Llib/_pthread.scm 98 */
obj_t BgL_zc3z04anonymousza31142ze3z87_418;
BgL_zc3z04anonymousza31142ze3z87_418 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31142ze3ze5zz__ft_z52pthreadz52, 
(int)(((long)0)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31142ze3z87_418, 
(int)(((long)0)), 
((obj_t)BgL_ftz00_5)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31142ze3z87_418, 
(int)(((long)1)), 
((obj_t)BgL_z52pthz52_434)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31142ze3z87_418, 
(int)(((long)2)), 
((obj_t)BgL_ftz00_5)); 
BgL_auxz00_732 = BgL_zc3z04anonymousza31142ze3z87_418; } 
((((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_new1078z00_61)))->BgL_bodyz00)=((obj_t)BgL_auxz00_732),BUNSPEC); } 
((((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_new1078z00_61)))->BgL_detachedpz00)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_new1078z00_61)))->BgL_endzd2resultzd2)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_new1078z00_61)))->BgL_endzd2exceptionzd2)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_new1078z00_61)))->BgL_z42builtinz42)=((void *)
BGl_z42pthreadzd2nilz90zz__pth_threadz00()),BUNSPEC); 
((((BgL_z52pthreadz52_bglt)COBJECT(BgL_new1078z00_61))->BgL_fthreadz00)=((obj_t)
((obj_t)BgL_ftz00_5)),BUNSPEC); 
{ 
obj_t BgL_auxz00_758;
{ /* Llib/_pthread.scm 97 */
obj_t BgL_arg1145z00_65;
{ /* Llib/_pthread.scm 97 */
obj_t BgL_arg1146z00_66;
{ /* Llib/_pthread.scm 97 */
obj_t BgL_res1655z00_305;
{ /* Llib/_pthread.scm 97 */
obj_t BgL_classz00_304;
BgL_classz00_304 = BGl_z52pthreadz52zz__ft_z52typesz52; 
BgL_res1655z00_305 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_304); } 
BgL_arg1146z00_66 = BgL_res1655z00_305; } 
BgL_arg1145z00_65 = 
VECTOR_REF(BgL_arg1146z00_66,((long)9)); } 
BgL_auxz00_758 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1145z00_65); } 
((((BgL_z52pthreadz52_bglt)COBJECT(BgL_new1078z00_61))->BgL_mutexz00)=((obj_t)BgL_auxz00_758),BUNSPEC); } 
{ 
obj_t BgL_auxz00_763;
{ /* Llib/_pthread.scm 97 */
obj_t BgL_arg1147z00_67;
{ /* Llib/_pthread.scm 97 */
obj_t BgL_arg1148z00_68;
{ /* Llib/_pthread.scm 97 */
obj_t BgL_res1656z00_308;
{ /* Llib/_pthread.scm 97 */
obj_t BgL_classz00_307;
BgL_classz00_307 = BGl_z52pthreadz52zz__ft_z52typesz52; 
BgL_res1656z00_308 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_307); } 
BgL_arg1148z00_68 = BgL_res1656z00_308; } 
BgL_arg1147z00_67 = 
VECTOR_REF(BgL_arg1148z00_68,((long)10)); } 
BgL_auxz00_763 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1147z00_67); } 
((((BgL_z52pthreadz52_bglt)COBJECT(BgL_new1078z00_61))->BgL_condvarz00)=((obj_t)BgL_auxz00_763),BUNSPEC); } 
{ 
obj_t BgL_auxz00_768;
{ /* Llib/_pthread.scm 97 */
obj_t BgL_arg1149z00_69;
{ /* Llib/_pthread.scm 97 */
obj_t BgL_arg1151z00_70;
{ /* Llib/_pthread.scm 97 */
obj_t BgL_res1657z00_311;
{ /* Llib/_pthread.scm 97 */
obj_t BgL_classz00_310;
BgL_classz00_310 = BGl_z52pthreadz52zz__ft_z52typesz52; 
BgL_res1657z00_311 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_310); } 
BgL_arg1151z00_70 = BgL_res1657z00_311; } 
BgL_arg1149z00_69 = 
VECTOR_REF(BgL_arg1151z00_70,((long)11)); } 
BgL_auxz00_768 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1149z00_69); } 
((((BgL_z52pthreadz52_bglt)COBJECT(BgL_new1078z00_61))->BgL_idz00)=((obj_t)BgL_auxz00_768),BUNSPEC); } 
((((BgL_z52pthreadz52_bglt)COBJECT(BgL_new1078z00_61))->BgL_parentz00)=((obj_t)BFALSE),BUNSPEC); 
{ /* Llib/_pthread.scm 96 */
obj_t BgL_fun1152z00_71;
BgL_fun1152z00_71 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_z52pthreadz52zz__ft_z52typesz52); 
PROCEDURE_ENTRY(BgL_fun1152z00_71)(BgL_fun1152z00_71, 
((obj_t)BgL_new1078z00_61), BEOA); } 
BgL_g1154z00_74 = BgL_new1078z00_61; } 
CELL_SET(BgL_z52pthz52_434, 
((obj_t)BgL_g1154z00_74)); 
return 
CELL_REF(BgL_z52pthz52_434);} } } 

}



/* &%pthread-new */
obj_t BGl_z62z52pthreadzd2newze2zz__ft_z52pthreadz52(obj_t BgL_envz00_419, obj_t BgL_ftz00_420)
{
{ /* Llib/_pthread.scm 66 */
{ /* Llib/_pthread.scm 68 */
BgL_fthreadz00_bglt BgL_auxz00_781;
if(
BGl_isazf3zf3zz__objectz00(BgL_ftz00_420, BGl_fthreadz00zz__ft_typesz00))
{ /* Llib/_pthread.scm 68 */
BgL_auxz00_781 = 
((BgL_fthreadz00_bglt)BgL_ftz00_420)
; }  else 
{ 
obj_t BgL_auxz00_785;
BgL_auxz00_785 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1716z00zz__ft_z52pthreadz52, 
BINT(((long)2397)), BGl_string1719z00zz__ft_z52pthreadz52, BGl_string1720z00zz__ft_z52pthreadz52, BgL_ftz00_420); 
FAILURE(BgL_auxz00_785,BFALSE,BFALSE);} 
return 
BGl_z52pthreadzd2newz80zz__ft_z52pthreadz52(BgL_auxz00_781);} } 

}



/* &<@anonymous:1142> */
obj_t BGl_z62zc3z04anonymousza31142ze3ze5zz__ft_z52pthreadz52(obj_t BgL_envz00_421)
{
{ /* Llib/_pthread.scm 98 */
{ /* Llib/_pthread.scm 99 */
BgL_fthreadz00_bglt BgL_i1076z00_422;obj_t BgL_z52pthz52_423;BgL_fthreadz00_bglt BgL_ftz00_424;
BgL_i1076z00_422 = 
((BgL_fthreadz00_bglt)
PROCEDURE_REF(BgL_envz00_421, 
(int)(((long)0)))); 
BgL_z52pthz52_423 = 
PROCEDURE_REF(BgL_envz00_421, 
(int)(((long)1))); 
BgL_ftz00_424 = 
((BgL_fthreadz00_bglt)
PROCEDURE_REF(BgL_envz00_421, 
(int)(((long)2)))); 
{ 
BgL_fthreadz00_bglt BgL_tz00_564;
{ /* Llib/_pthread.scm 99 */
obj_t BgL_arg1143z00_574;
BgL_arg1143z00_574 = 
(((BgL_fthreadz00_bglt)COBJECT(BgL_i1076z00_422))->BgL_schedulerz00); 
{ /* Llib/_pthread.scm 99 */
obj_t BgL_list1144z00_575;
BgL_list1144z00_575 = 
MAKE_YOUNG_PAIR(BgL_arg1143z00_574, BNIL); 
BGl_defaultzd2schedulerzd2zz__ft_schedulerz00(BgL_list1144z00_575); } } 
BGl_z52pthreadzd2waitz80zz__ft_z52pthreadz52(
((BgL_z52pthreadz52_bglt)
((BgL_z52pthreadz52_bglt)
CELL_REF(BgL_z52pthz52_423)))); 
BgL_tz00_564 = BgL_ftz00_424; 
BGl_zc3z04exitza31156ze3ze70z60zz__ft_z52pthreadz52(BgL_tz00_564, BgL_tz00_564); 
{ /* Llib/_pthread.scm 85 */
BgL_z52sigjoinz52_bglt BgL_arg1170z00_565;obj_t BgL_arg1171z00_566;
{ /* Llib/_pthread.scm 85 */
BgL_z52sigjoinz52_bglt BgL_new1075z00_567;
{ /* Llib/_pthread.scm 85 */
BgL_z52sigjoinz52_bglt BgL_new1074z00_568;
BgL_new1074z00_568 = 
((BgL_z52sigjoinz52_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52sigjoinz52_bgl) ))); 
{ /* Llib/_pthread.scm 85 */
long BgL_arg1173z00_569;
{ /* Llib/_pthread.scm 85 */
long BgL_res1652z00_570;
BgL_res1652z00_570 = 
BGL_CLASS_INDEX(BGl_z52sigjoinz52zz__ft_typesz00); 
BgL_arg1173z00_569 = BgL_res1652z00_570; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1074z00_568), BgL_arg1173z00_569); } 
BgL_new1075z00_567 = BgL_new1074z00_568; } 
((((BgL_z52sigjoinz52_bglt)COBJECT(BgL_new1075z00_567))->BgL_threadz00)=((BgL_fthreadz00_bglt)BgL_tz00_564),BUNSPEC); 
BgL_arg1170z00_565 = BgL_new1075z00_567; } 
BgL_arg1171z00_566 = 
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_564))->BgL_z52resultz52); 
{ /* Llib/_pthread.scm 85 */
obj_t BgL_list1172z00_571;
BgL_list1172z00_571 = 
MAKE_YOUNG_PAIR(BgL_arg1171z00_566, BNIL); 
BGl_broadcastz12z12zz__ft_schedulerz00(
((obj_t)BgL_arg1170z00_565), BgL_list1172z00_571); } } 
{ /* Llib/_pthread.scm 87 */
bool_t BgL_test1815z00_814;
{ /* Llib/_pthread.scm 87 */
obj_t BgL_tmpz00_815;
BgL_tmpz00_815 = 
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_564))->BgL_z52cleanupz52); 
BgL_test1815z00_814 = 
PROCEDUREP(BgL_tmpz00_815); } 
if(BgL_test1815z00_814)
{ /* Llib/_pthread.scm 87 */
if(
PROCEDURE_CORRECT_ARITYP(
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_564))->BgL_z52cleanupz52), 
(int)(((long)1))))
{ /* Llib/_pthread.scm 89 */
obj_t BgL_fun1182z00_572;
BgL_fun1182z00_572 = 
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_564))->BgL_z52cleanupz52); 
PROCEDURE_ENTRY(BgL_fun1182z00_572)(BgL_fun1182z00_572, 
((obj_t)BgL_tz00_564), BEOA); }  else 
{ /* Llib/_pthread.scm 90 */
obj_t BgL_arg1194z00_573;
BgL_arg1194z00_573 = 
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_564))->BgL_z52cleanupz52); 
BGl_errorz00zz__errorz00(
((obj_t)BgL_tz00_564), BGl_string1721z00zz__ft_z52pthreadz52, BgL_arg1194z00_573); } }  else 
{ /* Llib/_pthread.scm 87 */BFALSE; } } 
return 
BGl_z52threadzd2killz12z92zz__ft_z52threadz52(BgL_tz00_564);} } } 

}



/* <@exit:1156>~0 */
obj_t BGl_zc3z04exitza31156ze3ze70z60zz__ft_z52pthreadz52(BgL_fthreadz00_bglt BgL_i1065z00_503, BgL_fthreadz00_bglt BgL_tz00_502)
{
{ /* Llib/_pthread.scm 70 */
jmp_buf_t jmpbuf; 
void * BgL_an_exit1070z00_79;
if( SET_EXIT(BgL_an_exit1070z00_79) ) { 
return 
BGL_EXIT_VALUE();
} else {
#if( SIGSETJMP_SAVESIGS == 0 )
  bgl_restore_signal_handlers();
#endif

BgL_an_exit1070z00_79 = 
(void *)jmpbuf; 
{ /* Llib/_pthread.scm 70 */

PUSH_EXIT(BgL_an_exit1070z00_79, ((long)1)); 
{ /* Llib/_pthread.scm 70 */
obj_t BgL_an_exitd1071z00_80;
BgL_an_exitd1071z00_80 = 
((obj_t)(&exitd)); 
{ /* Llib/_pthread.scm 70 */
obj_t BgL_terminatez00_415;
BgL_terminatez00_415 = 
MAKE_FX_PROCEDURE(BGl_z62terminatez62zz__ft_z52pthreadz52, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_terminatez00_415, 
(int)(((long)0)), BgL_an_exitd1071z00_80); 
{ /* Llib/_pthread.scm 70 */
obj_t BgL_res1073z00_83;
((((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_502))->BgL_z52terminatez52)=((obj_t)BgL_terminatez00_415),BUNSPEC); 
{ /* Llib/_pthread.scm 75 */
obj_t BgL_zc3z04anonymousza31168ze3z87_417;obj_t BgL_zc3z04anonymousza31162ze3z87_416;
BgL_zc3z04anonymousza31168ze3z87_417 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31168ze3ze5zz__ft_z52pthreadz52, 
(int)(((long)0)), 
(int)(((long)1))); 
BgL_zc3z04anonymousza31162ze3z87_416 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31162ze3ze5zz__ft_z52pthreadz52, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31168ze3z87_417, 
(int)(((long)0)), 
((obj_t)BgL_i1065z00_503)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31162ze3z87_416, 
(int)(((long)0)), 
((obj_t)BgL_tz00_502)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31162ze3z87_416, 
(int)(((long)1)), BgL_an_exitd1071z00_80); 
BgL_res1073z00_83 = 
BGl_withzd2exceptionzd2handlerz00zz__errorz00(BgL_zc3z04anonymousza31162ze3z87_416, BgL_zc3z04anonymousza31168ze3z87_417); } 
POP_EXIT(); 
return BgL_res1073z00_83;} } } } 
} } 

}



/* &<@anonymous:1168> */
obj_t BGl_z62zc3z04anonymousza31168ze3ze5zz__ft_z52pthreadz52(obj_t BgL_envz00_425)
{
{ /* Llib/_pthread.scm 81 */
{ /* Llib/_pthread.scm 81 */
BgL_fthreadz00_bglt BgL_i1065z00_426;
BgL_i1065z00_426 = 
((BgL_fthreadz00_bglt)
PROCEDURE_REF(BgL_envz00_425, 
(int)(((long)0)))); 
{ 
obj_t BgL_auxz00_860;
{ /* Llib/_pthread.scm 83 */
obj_t BgL_fun1169z00_576;
BgL_fun1169z00_576 = 
(((BgL_fthreadz00_bglt)COBJECT(BgL_i1065z00_426))->BgL_bodyz00); 
BgL_auxz00_860 = 
PROCEDURE_ENTRY(BgL_fun1169z00_576)(BgL_fun1169z00_576, BEOA); } 
return 
((((BgL_fthreadz00_bglt)COBJECT(BgL_i1065z00_426))->BgL_z52resultz52)=((obj_t)BgL_auxz00_860),BUNSPEC);} } } 

}



/* &<@anonymous:1162> */
obj_t BGl_z62zc3z04anonymousza31162ze3ze5zz__ft_z52pthreadz52(obj_t BgL_envz00_427, obj_t BgL_ez00_430)
{
{ /* Llib/_pthread.scm 74 */
{ /* Llib/_pthread.scm 75 */
BgL_fthreadz00_bglt BgL_tz00_428;obj_t BgL_an_exitd1071z00_429;
BgL_tz00_428 = 
((BgL_fthreadz00_bglt)
PROCEDURE_REF(BgL_envz00_427, 
(int)(((long)0)))); 
BgL_an_exitd1071z00_429 = 
PROCEDURE_REF(BgL_envz00_427, 
(int)(((long)1))); 
{ /* Llib/_pthread.scm 75 */
BgL_uncaughtzd2exceptionzd2_bglt BgL_uz00_577;
{ /* Llib/_pthread.scm 75 */
BgL_uncaughtzd2exceptionzd2_bglt BgL_new1068z00_578;
{ /* Llib/_pthread.scm 75 */
BgL_uncaughtzd2exceptionzd2_bglt BgL_new1067z00_579;
BgL_new1067z00_579 = 
((BgL_uncaughtzd2exceptionzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uncaughtzd2exceptionzd2_bgl) ))); 
{ /* Llib/_pthread.scm 75 */
long BgL_arg1167z00_580;
{ /* Llib/_pthread.scm 75 */
long BgL_res1650z00_581;
BgL_res1650z00_581 = 
BGL_CLASS_INDEX(BGl_uncaughtzd2exceptionzd2zz__pth_threadz00); 
BgL_arg1167z00_580 = BgL_res1650z00_581; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1067z00_579), BgL_arg1167z00_580); } 
BgL_new1068z00_578 = BgL_new1067z00_579; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1068z00_578)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1068z00_578)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_879;
{ /* Llib/_pthread.scm 75 */
obj_t BgL_arg1165z00_582;
{ /* Llib/_pthread.scm 75 */
obj_t BgL_arg1166z00_583;
{ /* Llib/_pthread.scm 75 */
obj_t BgL_res1651z00_584;
{ /* Llib/_pthread.scm 75 */
obj_t BgL_classz00_585;
BgL_classz00_585 = BGl_uncaughtzd2exceptionzd2zz__pth_threadz00; 
BgL_res1651z00_584 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_585); } 
BgL_arg1166z00_583 = BgL_res1651z00_584; } 
BgL_arg1165z00_582 = 
VECTOR_REF(BgL_arg1166z00_583,((long)2)); } 
BgL_auxz00_879 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1165z00_582); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1068z00_578)))->BgL_stackz00)=((obj_t)BgL_auxz00_879),BUNSPEC); } 
((((BgL_uncaughtzd2exceptionzd2_bglt)COBJECT(BgL_new1068z00_578))->BgL_reasonz00)=((obj_t)BgL_ez00_430),BUNSPEC); 
BgL_uz00_577 = BgL_new1068z00_578; } 
((((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_428))->BgL_z52exczd2resultz80)=((obj_t)
((obj_t)BgL_uz00_577)),BUNSPEC); 
BGl_exceptionzd2notifyzd2zz__objectz00(BgL_ez00_430); 
return 
BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1071z00_429, BFALSE);} } } 

}



/* &terminate */
obj_t BGl_z62terminatez62zz__ft_z52pthreadz52(obj_t BgL_envz00_431, obj_t BgL_val1072z00_433)
{
{ /* Llib/_pthread.scm 70 */
return 
BGl_unwindzd2untilz12zc0zz__bexitz00(
PROCEDURE_REF(BgL_envz00_431, 
(int)(((long)0))), BgL_val1072z00_433);} 

}



/* %pthread-wait */
BGL_EXPORTED_DEF obj_t BGl_z52pthreadzd2waitz80zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt BgL_ftz00_6)
{
{ /* Llib/_pthread.scm 109 */
{ /* Llib/_pthread.scm 116 */
obj_t BgL_mutex1197z00_116;
BgL_mutex1197z00_116 = 
(((BgL_z52pthreadz52_bglt)COBJECT(BgL_ftz00_6))->BgL_mutexz00); 
{ /* Llib/_pthread.scm 116 */
obj_t BgL_top1818z00_895;
BgL_top1818z00_895 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGL_MUTEX_LOCK(BgL_mutex1197z00_116); 
BGL_EXITD_PUSH_PROTECT(BgL_top1818z00_895, BgL_mutex1197z00_116); BUNSPEC; 
{ /* Llib/_pthread.scm 116 */
obj_t BgL_tmp1817z00_894;
{ 

{ /* Llib/_pthread.scm 117 */
bool_t BgL_tmpz00_899;
BgL_zc3z04anonymousza31198ze3z87_118:
{ /* Llib/_pthread.scm 118 */
bool_t BgL_test1819z00_900;
{ /* Llib/_pthread.scm 118 */
obj_t BgL_arg1203z00_126;
BgL_arg1203z00_126 = 
BGl_z52getzd2schedulerzd2tokenz52zz__ft_z52pthreadz52(); 
BgL_test1819z00_900 = 
(BgL_arg1203z00_126==
((obj_t)BgL_ftz00_6)); } 
if(BgL_test1819z00_900)
{ /* Llib/_pthread.scm 118 */
BgL_tmpz00_899 = ((bool_t)0)
; }  else 
{ /* Llib/_pthread.scm 118 */
{ /* Llib/_pthread.scm 119 */
obj_t BgL_arg1201z00_121;obj_t BgL_arg1202z00_122;
BgL_arg1201z00_121 = 
(((BgL_z52pthreadz52_bglt)COBJECT(BgL_ftz00_6))->BgL_condvarz00); 
BgL_arg1202z00_122 = 
(((BgL_z52pthreadz52_bglt)COBJECT(BgL_ftz00_6))->BgL_mutexz00); 
{ /* Llib/_pthread.scm 119 */

{ /* Llib/_pthread.scm 119 */
bool_t BgL_res1659z00_319;
BgL_res1659z00_319 = 
BGL_CONDVAR_WAIT(BgL_arg1201z00_121, BgL_arg1202z00_122); BgL_res1659z00_319; } } } 
goto BgL_zc3z04anonymousza31198ze3z87_118;} } 
BgL_tmp1817z00_894 = 
BBOOL(BgL_tmpz00_899); } } 
BGL_EXITD_POP_PROTECT(BgL_top1818z00_895); BUNSPEC; 
BGL_MUTEX_UNLOCK(BgL_mutex1197z00_116); 
return BgL_tmp1817z00_894;} } } } 

}



/* &%pthread-wait */
obj_t BGl_z62z52pthreadzd2waitze2zz__ft_z52pthreadz52(obj_t BgL_envz00_437, obj_t BgL_ftz00_438)
{
{ /* Llib/_pthread.scm 109 */
{ /* Llib/_pthread.scm 111 */
BgL_z52pthreadz52_bglt BgL_auxz00_910;
if(
BGl_isazf3zf3zz__objectz00(BgL_ftz00_438, BGl_z52pthreadz52zz__ft_z52typesz52))
{ /* Llib/_pthread.scm 111 */
BgL_auxz00_910 = 
((BgL_z52pthreadz52_bglt)BgL_ftz00_438)
; }  else 
{ 
obj_t BgL_auxz00_914;
BgL_auxz00_914 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1716z00zz__ft_z52pthreadz52, 
BINT(((long)3945)), BGl_string1722z00zz__ft_z52pthreadz52, BGl_string1723z00zz__ft_z52pthreadz52, BgL_ftz00_438); 
FAILURE(BgL_auxz00_914,BFALSE,BFALSE);} 
return 
BGl_z52pthreadzd2waitz80zz__ft_z52pthreadz52(BgL_auxz00_910);} } 

}



/* %pthread-switch */
BGL_EXPORTED_DEF obj_t BGl_z52pthreadzd2switchz80zz__ft_z52pthreadz52(obj_t BgL_ftz00_7, BgL_z52pthreadz52_bglt BgL_ntz00_8)
{
{ /* Llib/_pthread.scm 125 */
{ /* Llib/_pthread.scm 131 */
obj_t BgL_mutex1204z00_321;
BgL_mutex1204z00_321 = 
(((BgL_z52pthreadz52_bglt)COBJECT(BgL_ntz00_8))->BgL_mutexz00); 
{ /* Llib/_pthread.scm 131 */
obj_t BgL_top1822z00_921;
BgL_top1822z00_921 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGL_MUTEX_LOCK(BgL_mutex1204z00_321); 
BGL_EXITD_PUSH_PROTECT(BgL_top1822z00_921, BgL_mutex1204z00_321); BUNSPEC; 
{ /* Llib/_pthread.scm 131 */
obj_t BgL_tmp1821z00_920;
BGl_z52setzd2schedulerzd2tokenz12z40zz__ft_z52pthreadz52(BgL_ntz00_8); 
{ /* Llib/_pthread.scm 134 */
obj_t BgL_arg1205z00_322;
BgL_arg1205z00_322 = 
(((BgL_z52pthreadz52_bglt)COBJECT(BgL_ntz00_8))->BgL_condvarz00); 
{ /* Llib/_pthread.scm 134 */
bool_t BgL_res1660z00_324;
BgL_res1660z00_324 = 
BGL_CONDVAR_SIGNAL(BgL_arg1205z00_322); 
BgL_tmp1821z00_920 = 
BBOOL(BgL_res1660z00_324); } } 
BGL_EXITD_POP_PROTECT(BgL_top1822z00_921); BUNSPEC; 
BGL_MUTEX_UNLOCK(BgL_mutex1204z00_321); 
return BgL_tmp1821z00_920;} } } } 

}



/* &%pthread-switch */
obj_t BGl_z62z52pthreadzd2switchze2zz__ft_z52pthreadz52(obj_t BgL_envz00_439, obj_t BgL_ftz00_440, obj_t BgL_ntz00_441)
{
{ /* Llib/_pthread.scm 125 */
{ /* Llib/_pthread.scm 130 */
BgL_z52pthreadz52_bglt BgL_auxz00_931;
if(
BGl_isazf3zf3zz__objectz00(BgL_ntz00_441, BGl_z52pthreadz52zz__ft_z52typesz52))
{ /* Llib/_pthread.scm 130 */
BgL_auxz00_931 = 
((BgL_z52pthreadz52_bglt)BgL_ntz00_441)
; }  else 
{ 
obj_t BgL_auxz00_935;
BgL_auxz00_935 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1716z00zz__ft_z52pthreadz52, 
BINT(((long)4678)), BGl_string1724z00zz__ft_z52pthreadz52, BGl_string1723z00zz__ft_z52pthreadz52, BgL_ntz00_441); 
FAILURE(BgL_auxz00_935,BFALSE,BFALSE);} 
return 
BGl_z52pthreadzd2switchz80zz__ft_z52pthreadz52(BgL_ftz00_440, BgL_auxz00_931);} } 

}



/* %pthread-enter-scheduler */
BGL_EXPORTED_DEF obj_t BGl_z52pthreadzd2enterzd2schedulerz52zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt BgL_scdlz00_9)
{
{ /* Llib/_pthread.scm 139 */
if(
CBOOL(
(((BgL_z52pthreadz52_bglt)COBJECT(BgL_scdlz00_9))->BgL_parentz00)))
{ /* Llib/_pthread.scm 145 */BFALSE; }  else 
{ /* Llib/_pthread.scm 145 */
{ /* Llib/_pthread.scm 146 */
obj_t BgL_thz00_133;
BgL_thz00_133 = 
BGl_currentzd2threadzd2zz__threadz00(); 
if(
BGl_isazf3zf3zz__objectz00(BgL_thz00_133, BGl_z52pthreadz52zz__ft_z52typesz52))
{ /* Llib/_pthread.scm 149 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string1725z00zz__ft_z52pthreadz52, BgL_thz00_133); }  else 
{ /* Llib/_pthread.scm 149 */
if(
BGl_isazf3zf3zz__objectz00(BgL_thz00_133, BGl_schedulerz00zz__ft_typesz00))
{ /* Llib/_pthread.scm 154 */BUNSPEC; }  else 
{ /* Llib/_pthread.scm 154 */
if(
BGl_isazf3zf3zz__objectz00(BgL_thz00_133, 
(((BgL_z52pthreadz52_bglt)COBJECT(BgL_scdlz00_9))->BgL_fthreadz00)))
{ /* Llib/_pthread.scm 157 */BUNSPEC; }  else 
{ /* Llib/_pthread.scm 157 */
if(
BGl_isazf3zf3zz__objectz00(BgL_thz00_133, BGl_pthreadz00zz__pth_threadz00))
{ /* Llib/_pthread.scm 160 */
((((BgL_z52pthreadz52_bglt)COBJECT(BgL_scdlz00_9))->BgL_parentz00)=((obj_t)BgL_thz00_133),BUNSPEC); }  else 
{ /* Llib/_pthread.scm 163 */
bool_t BgL_test1829z00_956;
if(
BOOLEANP(BgL_thz00_133))
{ /* Llib/_pthread.scm 163 */
if(
CBOOL(BgL_thz00_133))
{ /* Llib/_pthread.scm 163 */
BgL_test1829z00_956 = ((bool_t)0)
; }  else 
{ /* Llib/_pthread.scm 163 */
BgL_test1829z00_956 = ((bool_t)1)
; } }  else 
{ /* Llib/_pthread.scm 163 */
BgL_test1829z00_956 = ((bool_t)0)
; } 
if(BgL_test1829z00_956)
{ /* Llib/_pthread.scm 163 */
((((BgL_z52pthreadz52_bglt)COBJECT(BgL_scdlz00_9))->BgL_parentz00)=((obj_t)BFALSE),BUNSPEC); }  else 
{ /* Llib/_pthread.scm 169 */
obj_t BgL_arg1230z00_141;
BgL_arg1230z00_141 = 
bgl_find_runtime_type(BgL_thz00_133); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string1726z00zz__ft_z52pthreadz52, BgL_arg1230z00_141); } } } } } } BUNSPEC; } 
{ /* Llib/_pthread.scm 173 */
bool_t BgL_test1832z00_965;
{ /* Llib/_pthread.scm 173 */
obj_t BgL_arg1259z00_147;
BgL_arg1259z00_147 = 
BGl_currentzd2schedulerzd2zz__ft_schedulerz00(); 
BgL_test1832z00_965 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1259z00_147, BGl_schedulerz00zz__ft_typesz00); } 
if(BgL_test1832z00_965)
{ /* Llib/_pthread.scm 173 */BFALSE; }  else 
{ /* Llib/_pthread.scm 173 */
BGl_currentzd2schedulerzd2setz12z12zz__ft_schedulerz00(
(((BgL_z52pthreadz52_bglt)COBJECT(BgL_scdlz00_9))->BgL_fthreadz00)); } } 
{ /* Llib/_pthread.scm 177 */
BgL_schedulerz00_bglt BgL_i1082z00_148;
BgL_i1082z00_148 = 
((BgL_schedulerz00_bglt)
(((BgL_z52pthreadz52_bglt)COBJECT(BgL_scdlz00_9))->BgL_fthreadz00)); 
{ /* Llib/_pthread.scm 178 */
obj_t BgL_fun1260z00_149;
BgL_fun1260z00_149 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_i1082z00_148)))->BgL_bodyz00); 
return 
PROCEDURE_ENTRY(BgL_fun1260z00_149)(BgL_fun1260z00_149, BEOA);} } } 

}



/* &%pthread-enter-scheduler */
obj_t BGl_z62z52pthreadzd2enterzd2schedulerz30zz__ft_z52pthreadz52(obj_t BgL_envz00_442, obj_t BgL_scdlz00_443)
{
{ /* Llib/_pthread.scm 139 */
{ /* Llib/_pthread.scm 143 */
BgL_z52pthreadz52_bglt BgL_auxz00_977;
if(
BGl_isazf3zf3zz__objectz00(BgL_scdlz00_443, BGl_z52pthreadz52zz__ft_z52typesz52))
{ /* Llib/_pthread.scm 143 */
BgL_auxz00_977 = 
((BgL_z52pthreadz52_bglt)BgL_scdlz00_443)
; }  else 
{ 
obj_t BgL_auxz00_981;
BgL_auxz00_981 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1716z00zz__ft_z52pthreadz52, 
BINT(((long)5251)), BGl_string1727z00zz__ft_z52pthreadz52, BGl_string1723z00zz__ft_z52pthreadz52, BgL_scdlz00_443); 
FAILURE(BgL_auxz00_981,BFALSE,BFALSE);} 
return 
BGl_z52pthreadzd2enterzd2schedulerz52zz__ft_z52pthreadz52(BgL_auxz00_977);} } 

}



/* %pthread-leave-scheduler */
BGL_EXPORTED_DEF obj_t BGl_z52pthreadzd2leavezd2schedulerz52zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt BgL_scdlz00_10)
{
{ /* Llib/_pthread.scm 183 */
{ /* Llib/_pthread.scm 187 */
bool_t BgL_test1834z00_986;
{ /* Llib/_pthread.scm 187 */
obj_t BgL_arg1281z00_153;
BgL_arg1281z00_153 = 
BGl_currentzd2threadzd2zz__threadz00(); 
BgL_test1834z00_986 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1281z00_153, BGl_fthreadz00zz__ft_typesz00); } 
if(BgL_test1834z00_986)
{ /* Llib/_pthread.scm 187 */BFALSE; }  else 
{ /* Llib/_pthread.scm 187 */
BGl_currentzd2schedulerzd2setz12z12zz__ft_schedulerz00(BFALSE); 
((((BgL_z52pthreadz52_bglt)COBJECT(BgL_scdlz00_10))->BgL_parentz00)=((obj_t)BFALSE),BUNSPEC); } } 
return BFALSE;} 

}



/* &%pthread-leave-scheduler */
obj_t BGl_z62z52pthreadzd2leavezd2schedulerz30zz__ft_z52pthreadz52(obj_t BgL_envz00_444, obj_t BgL_scdlz00_445)
{
{ /* Llib/_pthread.scm 183 */
{ /* Llib/_pthread.scm 187 */
BgL_z52pthreadz52_bglt BgL_auxz00_991;
if(
BGl_isazf3zf3zz__objectz00(BgL_scdlz00_445, BGl_z52pthreadz52zz__ft_z52typesz52))
{ /* Llib/_pthread.scm 187 */
BgL_auxz00_991 = 
((BgL_z52pthreadz52_bglt)BgL_scdlz00_445)
; }  else 
{ 
obj_t BgL_auxz00_995;
BgL_auxz00_995 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1716z00zz__ft_z52pthreadz52, 
BINT(((long)6787)), BGl_string1728z00zz__ft_z52pthreadz52, BGl_string1723z00zz__ft_z52pthreadz52, BgL_scdlz00_445); 
FAILURE(BgL_auxz00_995,BFALSE,BFALSE);} 
return 
BGl_z52pthreadzd2leavezd2schedulerz52zz__ft_z52pthreadz52(BgL_auxz00_991);} } 

}



/* %async-spawn */
BGL_EXPORTED_DEF obj_t BGl_z52asynczd2spawnz80zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt BgL_scdlz00_11, obj_t BgL_bodyz00_12, obj_t BgL_oz00_13)
{
{ /* Llib/_pthread.scm 196 */
{ /* Llib/_pthread.scm 201 */
BgL_z52pthreadz52_bglt BgL_z52pthz52_154;
{ /* Llib/_pthread.scm 201 */
BgL_z52pthreadz52_bglt BgL_new1085z00_156;
{ /* Llib/_pthread.scm 204 */
BgL_z52pthreadz52_bglt BgL_new1084z00_166;
BgL_new1084z00_166 = 
((BgL_z52pthreadz52_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52pthreadz52_bgl) ))); 
{ /* Llib/_pthread.scm 204 */
long BgL_arg1347z00_167;
{ /* Llib/_pthread.scm 204 */
long BgL_res1662z00_327;
BgL_res1662z00_327 = 
BGL_CLASS_INDEX(BGl_z52pthreadz52zz__ft_z52typesz52); 
BgL_arg1347z00_167 = BgL_res1662z00_327; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1084z00_166), BgL_arg1347z00_167); } 
BgL_new1085z00_156 = BgL_new1084z00_166; } 
{ 
obj_t BgL_auxz00_1004;
{ /* Llib/_pthread.scm 204 */
obj_t BgL_arg1300z00_157;
{ /* Llib/_pthread.scm 204 */
obj_t BgL_arg1325z00_158;obj_t BgL_arg1326z00_159;
{ /* Llib/_pthread.scm 204 */
obj_t BgL_arg1330z00_160;
BgL_arg1330z00_160 = 
BGl_gensymz00zz__r4_symbols_6_4z00(
CNST_TABLE_REF(((long)1))); 
{ /* Llib/_pthread.scm 204 */
obj_t BgL_res1663z00_332;
{ /* Llib/_pthread.scm 204 */
obj_t BgL_arg1429z00_331;
BgL_arg1429z00_331 = 
SYMBOL_TO_STRING(BgL_arg1330z00_160); 
BgL_res1663z00_332 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg1429z00_331); } 
BgL_arg1325z00_158 = BgL_res1663z00_332; } } 
{ /* Llib/_pthread.scm 204 */
obj_t BgL_res1664z00_335;
{ /* Llib/_pthread.scm 204 */
obj_t BgL_arg1429z00_334;
BgL_arg1429z00_334 = 
SYMBOL_TO_STRING(
((obj_t)BgL_oz00_13)); 
BgL_res1664z00_335 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg1429z00_334); } 
BgL_arg1326z00_159 = BgL_res1664z00_335; } 
BgL_arg1300z00_157 = 
string_append(BgL_arg1325z00_158, BgL_arg1326z00_159); } 
{ /* Llib/_pthread.scm 204 */
obj_t BgL_res1665z00_337;
BgL_res1665z00_337 = 
bstring_to_symbol(BgL_arg1300z00_157); 
BgL_auxz00_1004 = BgL_res1665z00_337; } } 
((((BgL_threadz00_bglt)COBJECT(
((BgL_threadz00_bglt)BgL_new1085z00_156)))->BgL_namez00)=((obj_t)BgL_auxz00_1004),BUNSPEC); } 
((((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_new1085z00_156)))->BgL_bodyz00)=((obj_t)BgL_bodyz00_12),BUNSPEC); 
((((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_new1085z00_156)))->BgL_detachedpz00)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_new1085z00_156)))->BgL_endzd2resultzd2)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_new1085z00_156)))->BgL_endzd2exceptionzd2)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_new1085z00_156)))->BgL_z42builtinz42)=((void *)
BGl_z42pthreadzd2nilz90zz__pth_threadz00()),BUNSPEC); 
((((BgL_z52pthreadz52_bglt)COBJECT(BgL_new1085z00_156))->BgL_fthreadz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_1028;
{ /* Llib/_pthread.scm 203 */
obj_t BgL_arg1333z00_161;
{ /* Llib/_pthread.scm 203 */
obj_t BgL_arg1334z00_162;
{ /* Llib/_pthread.scm 203 */
obj_t BgL_res1666z00_339;
{ /* Llib/_pthread.scm 203 */
obj_t BgL_classz00_338;
BgL_classz00_338 = BGl_z52pthreadz52zz__ft_z52typesz52; 
BgL_res1666z00_339 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_338); } 
BgL_arg1334z00_162 = BgL_res1666z00_339; } 
BgL_arg1333z00_161 = 
VECTOR_REF(BgL_arg1334z00_162,((long)9)); } 
BgL_auxz00_1028 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1333z00_161); } 
((((BgL_z52pthreadz52_bglt)COBJECT(BgL_new1085z00_156))->BgL_mutexz00)=((obj_t)BgL_auxz00_1028),BUNSPEC); } 
{ 
obj_t BgL_auxz00_1033;
{ /* Llib/_pthread.scm 203 */
obj_t BgL_arg1336z00_163;
{ /* Llib/_pthread.scm 203 */
obj_t BgL_arg1337z00_164;
{ /* Llib/_pthread.scm 203 */
obj_t BgL_res1667z00_342;
{ /* Llib/_pthread.scm 203 */
obj_t BgL_classz00_341;
BgL_classz00_341 = BGl_z52pthreadz52zz__ft_z52typesz52; 
BgL_res1667z00_342 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_341); } 
BgL_arg1337z00_164 = BgL_res1667z00_342; } 
BgL_arg1336z00_163 = 
VECTOR_REF(BgL_arg1337z00_164,((long)10)); } 
BgL_auxz00_1033 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1336z00_163); } 
((((BgL_z52pthreadz52_bglt)COBJECT(BgL_new1085z00_156))->BgL_condvarz00)=((obj_t)BgL_auxz00_1033),BUNSPEC); } 
((((BgL_z52pthreadz52_bglt)COBJECT(BgL_new1085z00_156))->BgL_idz00)=((obj_t)BgL_oz00_13),BUNSPEC); 
((((BgL_z52pthreadz52_bglt)COBJECT(BgL_new1085z00_156))->BgL_parentz00)=((obj_t)BFALSE),BUNSPEC); 
{ /* Llib/_pthread.scm 201 */
obj_t BgL_fun1338z00_165;
BgL_fun1338z00_165 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_z52pthreadz52zz__ft_z52typesz52); 
PROCEDURE_ENTRY(BgL_fun1338z00_165)(BgL_fun1338z00_165, 
((obj_t)BgL_new1085z00_156), BEOA); } 
BgL_z52pthz52_154 = BgL_new1085z00_156; } 
BGl_threadzd2startz12zc0zz__threadz00(
((BgL_threadz00_bglt)BgL_z52pthz52_154), BNIL); 
return 
((obj_t)BgL_z52pthz52_154);} } 

}



/* &%async-spawn */
obj_t BGl_z62z52asynczd2spawnze2zz__ft_z52pthreadz52(obj_t BgL_envz00_446, obj_t BgL_scdlz00_447, obj_t BgL_bodyz00_448, obj_t BgL_oz00_449)
{
{ /* Llib/_pthread.scm 196 */
{ /* Llib/_pthread.scm 201 */
obj_t BgL_auxz00_1057;BgL_z52pthreadz52_bglt BgL_auxz00_1049;
if(
PROCEDUREP(BgL_bodyz00_448))
{ /* Llib/_pthread.scm 201 */
BgL_auxz00_1057 = BgL_bodyz00_448
; }  else 
{ 
obj_t BgL_auxz00_1060;
BgL_auxz00_1060 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1716z00zz__ft_z52pthreadz52, 
BINT(((long)7392)), BGl_string1729z00zz__ft_z52pthreadz52, BGl_string1730z00zz__ft_z52pthreadz52, BgL_bodyz00_448); 
FAILURE(BgL_auxz00_1060,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_scdlz00_447, BGl_z52pthreadz52zz__ft_z52typesz52))
{ /* Llib/_pthread.scm 201 */
BgL_auxz00_1049 = 
((BgL_z52pthreadz52_bglt)BgL_scdlz00_447)
; }  else 
{ 
obj_t BgL_auxz00_1053;
BgL_auxz00_1053 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1716z00zz__ft_z52pthreadz52, 
BINT(((long)7392)), BGl_string1729z00zz__ft_z52pthreadz52, BGl_string1723z00zz__ft_z52pthreadz52, BgL_scdlz00_447); 
FAILURE(BgL_auxz00_1053,BFALSE,BFALSE);} 
return 
BGl_z52asynczd2spawnz80zz__ft_z52pthreadz52(BgL_auxz00_1049, BgL_auxz00_1057, BgL_oz00_449);} } 

}



/* %async-synchronize */
BGL_EXPORTED_DEF obj_t BGl_z52asynczd2synchroniza7ez27zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt BgL_scdlz00_14)
{
{ /* Llib/_pthread.scm 211 */
{ /* Llib/_pthread.scm 215 */
obj_t BgL_arg1348z00_345;
BgL_arg1348z00_345 = 
(((BgL_z52pthreadz52_bglt)COBJECT(BgL_scdlz00_14))->BgL_mutexz00); 
{ /* Llib/_pthread.scm 215 */

{ /* Llib/_pthread.scm 215 */
int BgL_arg1652z00_351;
BgL_arg1652z00_351 = 
BGL_MUTEX_LOCK(BgL_arg1348z00_345); 
return 
BBOOL(
(
(long)(BgL_arg1652z00_351)==((long)0)));} } } } 

}



/* &%async-synchronize */
obj_t BGl_z62z52asynczd2synchroniza7ez45zz__ft_z52pthreadz52(obj_t BgL_envz00_450, obj_t BgL_scdlz00_451)
{
{ /* Llib/_pthread.scm 211 */
{ /* Llib/_pthread.scm 214 */
BgL_z52pthreadz52_bglt BgL_auxz00_1070;
if(
BGl_isazf3zf3zz__objectz00(BgL_scdlz00_451, BGl_z52pthreadz52zz__ft_z52typesz52))
{ /* Llib/_pthread.scm 214 */
BgL_auxz00_1070 = 
((BgL_z52pthreadz52_bglt)BgL_scdlz00_451)
; }  else 
{ 
obj_t BgL_auxz00_1074;
BgL_auxz00_1074 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1716z00zz__ft_z52pthreadz52, 
BINT(((long)7893)), BGl_string1731z00zz__ft_z52pthreadz52, BGl_string1723z00zz__ft_z52pthreadz52, BgL_scdlz00_451); 
FAILURE(BgL_auxz00_1074,BFALSE,BFALSE);} 
return 
BGl_z52asynczd2synchroniza7ez27zz__ft_z52pthreadz52(BgL_auxz00_1070);} } 

}



/* %async-asynchronize */
BGL_EXPORTED_DEF obj_t BGl_z52asynczd2asynchroniza7ez27zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt BgL_scdlz00_15)
{
{ /* Llib/_pthread.scm 220 */
{ /* Llib/_pthread.scm 224 */
obj_t BgL_arg1349z00_360;
BgL_arg1349z00_360 = 
(((BgL_z52pthreadz52_bglt)COBJECT(BgL_scdlz00_15))->BgL_mutexz00); 
{ /* Llib/_pthread.scm 224 */
int BgL_arg1648z00_362;
BgL_arg1648z00_362 = 
BGL_MUTEX_UNLOCK(BgL_arg1349z00_360); 
return 
BBOOL(
(
(long)(BgL_arg1648z00_362)==((long)0)));} } } 

}



/* &%async-asynchronize */
obj_t BGl_z62z52asynczd2asynchroniza7ez45zz__ft_z52pthreadz52(obj_t BgL_envz00_452, obj_t BgL_scdlz00_453)
{
{ /* Llib/_pthread.scm 220 */
{ /* Llib/_pthread.scm 223 */
BgL_z52pthreadz52_bglt BgL_auxz00_1084;
if(
BGl_isazf3zf3zz__objectz00(BgL_scdlz00_453, BGl_z52pthreadz52zz__ft_z52typesz52))
{ /* Llib/_pthread.scm 223 */
BgL_auxz00_1084 = 
((BgL_z52pthreadz52_bglt)BgL_scdlz00_453)
; }  else 
{ 
obj_t BgL_auxz00_1088;
BgL_auxz00_1088 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1716z00zz__ft_z52pthreadz52, 
BINT(((long)8317)), BGl_string1732z00zz__ft_z52pthreadz52, BGl_string1723z00zz__ft_z52pthreadz52, BgL_scdlz00_453); 
FAILURE(BgL_auxz00_1088,BFALSE,BFALSE);} 
return 
BGl_z52asynczd2asynchroniza7ez27zz__ft_z52pthreadz52(BgL_auxz00_1084);} } 

}



/* %async-scheduler-wait */
BGL_EXPORTED_DEF obj_t BGl_z52asynczd2schedulerzd2waitz52zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt BgL_scdlz00_16)
{
{ /* Llib/_pthread.scm 229 */
{ /* Llib/_pthread.scm 233 */
obj_t BgL_arg1351z00_175;obj_t BgL_arg1352z00_176;
BgL_arg1351z00_175 = 
(((BgL_z52pthreadz52_bglt)COBJECT(BgL_scdlz00_16))->BgL_condvarz00); 
BgL_arg1352z00_176 = 
(((BgL_z52pthreadz52_bglt)COBJECT(BgL_scdlz00_16))->BgL_mutexz00); 
{ /* Llib/_pthread.scm 233 */

{ /* Llib/_pthread.scm 233 */
bool_t BgL_res1673z00_371;
BgL_res1673z00_371 = 
BGL_CONDVAR_WAIT(BgL_arg1351z00_175, BgL_arg1352z00_176); 
return 
BBOOL(BgL_res1673z00_371);} } } } 

}



/* &%async-scheduler-wait */
obj_t BGl_z62z52asynczd2schedulerzd2waitz30zz__ft_z52pthreadz52(obj_t BgL_envz00_454, obj_t BgL_scdlz00_455)
{
{ /* Llib/_pthread.scm 229 */
{ /* Llib/_pthread.scm 232 */
BgL_z52pthreadz52_bglt BgL_auxz00_1097;
if(
BGl_isazf3zf3zz__objectz00(BgL_scdlz00_455, BGl_z52pthreadz52zz__ft_z52typesz52))
{ /* Llib/_pthread.scm 232 */
BgL_auxz00_1097 = 
((BgL_z52pthreadz52_bglt)BgL_scdlz00_455)
; }  else 
{ 
obj_t BgL_auxz00_1101;
BgL_auxz00_1101 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1716z00zz__ft_z52pthreadz52, 
BINT(((long)8744)), BGl_string1733z00zz__ft_z52pthreadz52, BGl_string1723z00zz__ft_z52pthreadz52, BgL_scdlz00_455); 
FAILURE(BgL_auxz00_1101,BFALSE,BFALSE);} 
return 
BGl_z52asynczd2schedulerzd2waitz52zz__ft_z52pthreadz52(BgL_auxz00_1097);} } 

}



/* %async-scheduler-notify */
BGL_EXPORTED_DEF obj_t BGl_z52asynczd2schedulerzd2notifyz52zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt BgL_scdlz00_17)
{
{ /* Llib/_pthread.scm 238 */
{ /* Llib/_pthread.scm 242 */
obj_t BgL_arg1353z00_373;
BgL_arg1353z00_373 = 
(((BgL_z52pthreadz52_bglt)COBJECT(BgL_scdlz00_17))->BgL_condvarz00); 
{ /* Llib/_pthread.scm 242 */
bool_t BgL_res1674z00_375;
BgL_res1674z00_375 = 
BGL_CONDVAR_SIGNAL(BgL_arg1353z00_373); 
return 
BBOOL(BgL_res1674z00_375);} } } 

}



/* &%async-scheduler-notify */
obj_t BGl_z62z52asynczd2schedulerzd2notifyz30zz__ft_z52pthreadz52(obj_t BgL_envz00_456, obj_t BgL_scdlz00_457)
{
{ /* Llib/_pthread.scm 238 */
{ /* Llib/_pthread.scm 241 */
BgL_z52pthreadz52_bglt BgL_auxz00_1109;
if(
BGl_isazf3zf3zz__objectz00(BgL_scdlz00_457, BGl_z52pthreadz52zz__ft_z52typesz52))
{ /* Llib/_pthread.scm 241 */
BgL_auxz00_1109 = 
((BgL_z52pthreadz52_bglt)BgL_scdlz00_457)
; }  else 
{ 
obj_t BgL_auxz00_1113;
BgL_auxz00_1113 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1716z00zz__ft_z52pthreadz52, 
BINT(((long)9202)), BGl_string1734z00zz__ft_z52pthreadz52, BGl_string1723z00zz__ft_z52pthreadz52, BgL_scdlz00_457); 
FAILURE(BgL_auxz00_1113,BFALSE,BFALSE);} 
return 
BGl_z52asynczd2schedulerzd2notifyz52zz__ft_z52pthreadz52(BgL_auxz00_1109);} } 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__ft_z52pthreadz52()
{
{ /* Llib/_pthread.scm 6 */
return BUNSPEC;} 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__ft_z52pthreadz52()
{
{ /* Llib/_pthread.scm 6 */
return BUNSPEC;} 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__ft_z52pthreadz52()
{
{ /* Llib/_pthread.scm 6 */
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_objectzd2writezd2envz00zz__objectz00, BGl_z52pthreadz52zz__ft_z52typesz52, BGl_proc1735z00zz__ft_z52pthreadz52, BGl_string1736z00zz__ft_z52pthreadz52); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_objectzd2displayzd2envz00zz__objectz00, BGl_z52pthreadz52zz__ft_z52typesz52, BGl_proc1737z00zz__ft_z52pthreadz52, BGl_string1738z00zz__ft_z52pthreadz52); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_z52userzd2currentzd2threadzd2envz80zz__threadz00, BGl_z52pthreadz52zz__ft_z52typesz52, BGl_proc1739z00zz__ft_z52pthreadz52, BGl_string1740z00zz__ft_z52pthreadz52); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_z52userzd2threadzd2yieldz12zd2envz92zz__threadz00, BGl_z52pthreadz52zz__ft_z52typesz52, BGl_proc1741z00zz__ft_z52pthreadz52, BGl_string1742z00zz__ft_z52pthreadz52); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_z52userzd2threadzd2sleepz12zd2envz92zz__threadz00, BGl_z52pthreadz52zz__ft_z52typesz52, BGl_proc1743z00zz__ft_z52pthreadz52, BGl_string1744z00zz__ft_z52pthreadz52); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_z52userzd2currentzd2threadzd2envz80zz__threadz00, BGl_fthreadz00zz__ft_typesz00, BGl_proc1745z00zz__ft_z52pthreadz52, BGl_string1740z00zz__ft_z52pthreadz52); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_z52userzd2threadzd2yieldz12zd2envz92zz__threadz00, BGl_fthreadz00zz__ft_typesz00, BGl_proc1746z00zz__ft_z52pthreadz52, BGl_string1742z00zz__ft_z52pthreadz52); 
return 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_z52userzd2threadzd2sleepz12zd2envz92zz__threadz00, BGl_fthreadz00zz__ft_typesz00, BGl_proc1747z00zz__ft_z52pthreadz52, BGl_string1744z00zz__ft_z52pthreadz52);} 

}



/* &%user-thread-sleep!-1115 */
obj_t BGl_z62z52userzd2threadzd2sleepz12zd21115zf0zz__ft_z52pthreadz52(obj_t BgL_envz00_467, obj_t BgL_oz00_468, obj_t BgL_timeoutz00_469)
{
{ /* Llib/_pthread.scm 317 */
if(
(
(long)CINT(BgL_timeoutz00_469)>((long)0)))
{ /* Llib/_pthread.scm 318 */
return 
BGl_z52threadzd2timeoutz12z92zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_oz00_468), 
CINT(BgL_timeoutz00_469));}  else 
{ /* Llib/_pthread.scm 318 */
return BFALSE;} } 

}



/* &%user-thread-yield!-1113 */
obj_t BGl_z62z52userzd2threadzd2yieldz12zd21113zf0zz__ft_z52pthreadz52(obj_t BgL_envz00_470, obj_t BgL_oz00_471)
{
{ /* Llib/_pthread.scm 311 */
return 
BGl_z52threadzd2yieldz12z92zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_oz00_471));} 

}



/* &%user-current-thread1111 */
obj_t BGl_z62z52userzd2currentzd2thread1111z30zz__ft_z52pthreadz52(obj_t BgL_envz00_472, obj_t BgL_oz00_473)
{
{ /* Llib/_pthread.scm 305 */
return 
((obj_t)
((BgL_fthreadz00_bglt)BgL_oz00_473));} 

}



/* &%user-thread-sleep!-1109 */
obj_t BGl_z62z52userzd2threadzd2sleepz12zd21109zf0zz__ft_z52pthreadz52(obj_t BgL_envz00_474, obj_t BgL_oz00_475, obj_t BgL_timeoutz00_476)
{
{ /* Llib/_pthread.scm 297 */
{ /* Llib/_pthread.scm 299 */
bool_t BgL_test1843z00_1136;
{ /* Llib/_pthread.scm 299 */
bool_t BgL_test1844z00_1137;
{ /* Llib/_pthread.scm 299 */
obj_t BgL_arg1621z00_590;
BgL_arg1621z00_590 = 
(((BgL_z52pthreadz52_bglt)COBJECT(
((BgL_z52pthreadz52_bglt)BgL_oz00_475)))->BgL_fthreadz00); 
BgL_test1844z00_1137 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1621z00_590, BGl_fthreadz00zz__ft_typesz00); } 
if(BgL_test1844z00_1137)
{ /* Llib/_pthread.scm 299 */
BgL_test1843z00_1136 = 
(
(long)CINT(BgL_timeoutz00_476)>((long)0))
; }  else 
{ /* Llib/_pthread.scm 299 */
BgL_test1843z00_1136 = ((bool_t)0)
; } } 
if(BgL_test1843z00_1136)
{ /* Llib/_pthread.scm 300 */
obj_t BgL_arg1616z00_591;
BgL_arg1616z00_591 = 
(((BgL_z52pthreadz52_bglt)COBJECT(
((BgL_z52pthreadz52_bglt)BgL_oz00_475)))->BgL_fthreadz00); 
return 
BGl_z52threadzd2timeoutz12z92zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_arg1616z00_591), 
CINT(BgL_timeoutz00_476));}  else 
{ /* Llib/_pthread.scm 299 */
return BFALSE;} } } 

}



/* &%user-thread-yield!-1107 */
obj_t BGl_z62z52userzd2threadzd2yieldz12zd21107zf0zz__ft_z52pthreadz52(obj_t BgL_envz00_477, obj_t BgL_oz00_478)
{
{ /* Llib/_pthread.scm 289 */
if(
CBOOL(
(((BgL_z52pthreadz52_bglt)COBJECT(
((BgL_z52pthreadz52_bglt)BgL_oz00_478)))->BgL_fthreadz00)))
{ /* Llib/_pthread.scm 292 */
obj_t BgL_arg1590z00_593;
BgL_arg1590z00_593 = 
(((BgL_z52pthreadz52_bglt)COBJECT(
((BgL_z52pthreadz52_bglt)BgL_oz00_478)))->BgL_fthreadz00); 
return 
BGl_z52threadzd2yieldz12z92zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_arg1590z00_593));}  else 
{ /* Llib/_pthread.scm 291 */
return BFALSE;} } 

}



/* &%user-current-thread1105 */
obj_t BGl_z62z52userzd2currentzd2thread1105z30zz__ft_z52pthreadz52(obj_t BgL_envz00_479, obj_t BgL_oz00_480)
{
{ /* Llib/_pthread.scm 280 */
{ /* Llib/_pthread.scm 282 */
bool_t BgL_test1846z00_1156;
{ /* Llib/_pthread.scm 282 */
obj_t BgL_arg1579z00_595;
BgL_arg1579z00_595 = 
(((BgL_z52pthreadz52_bglt)COBJECT(
((BgL_z52pthreadz52_bglt)BgL_oz00_480)))->BgL_fthreadz00); 
BgL_test1846z00_1156 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1579z00_595, BGl_fthreadz00zz__ft_typesz00); } 
if(BgL_test1846z00_1156)
{ /* Llib/_pthread.scm 282 */
return 
(((BgL_z52pthreadz52_bglt)COBJECT(
((BgL_z52pthreadz52_bglt)BgL_oz00_480)))->BgL_fthreadz00);}  else 
{ /* Llib/_pthread.scm 268 */
obj_t BgL_csz00_596;
BgL_csz00_596 = 
BGl_currentzd2schedulerzd2zz__ft_schedulerz00(); 
if(
BGl_isazf3zf3zz__objectz00(BgL_csz00_596, BGl_schedulerz00zz__ft_typesz00))
{ /* Llib/_pthread.scm 269 */
return 
(((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)
((BgL_schedulerz00_bglt)BgL_csz00_596))))->BgL_currentzd2threadzd2);}  else 
{ /* Llib/_pthread.scm 272 */
obj_t BgL_dsz00_597;
BgL_dsz00_597 = 
BGl_defaultzd2schedulerzd2zz__ft_schedulerz00(BNIL); 
if(
BGl_isazf3zf3zz__objectz00(BgL_dsz00_597, BGl_schedulerz00zz__ft_typesz00))
{ /* Llib/_pthread.scm 273 */
return 
(((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)
((BgL_schedulerz00_bglt)BgL_dsz00_597))))->BgL_currentzd2threadzd2);}  else 
{ /* Llib/_pthread.scm 273 */
return BFALSE;} } } } } 

}



/* &object-display-%pthr1103 */
obj_t BGl_z62objectzd2displayzd2z52pthr1103z30zz__ft_z52pthreadz52(obj_t BgL_envz00_481, obj_t BgL_oz00_482, obj_t BgL_portz00_483)
{
{ /* Llib/_pthread.scm 260 */
{ /* Llib/_pthread.scm 261 */
obj_t BgL_runner1564z00_599;
{ /* Llib/_pthread.scm 261 */
obj_t BgL_list1562z00_600;
BgL_list1562z00_600 = 
MAKE_YOUNG_PAIR(BgL_portz00_483, BNIL); 
BgL_runner1564z00_599 = 
BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(
((obj_t)
((BgL_z52pthreadz52_bglt)BgL_oz00_482)), BgL_list1562z00_600); } 
{ /* Llib/_pthread.scm 261 */
BgL_objectz00_bglt BgL_aux1563z00_601;
{ /* Llib/_pthread.scm 261 */
obj_t BgL_pairz00_602;
BgL_pairz00_602 = BgL_runner1564z00_599; 
BgL_aux1563z00_601 = 
((BgL_objectz00_bglt)
CAR(BgL_pairz00_602)); } 
BgL_runner1564z00_599 = 
CDR(BgL_runner1564z00_599); 
return 
BGl_objectzd2writezd2zz__objectz00(BgL_aux1563z00_601, BgL_runner1564z00_599);} } } 

}



/* &object-write-%pthrea1101 */
obj_t BGl_z62objectzd2writezd2z52pthrea1101z30zz__ft_z52pthreadz52(obj_t BgL_envz00_484, obj_t BgL_oz00_485, obj_t BgL_portz00_486)
{
{ /* Llib/_pthread.scm 247 */
{ /* Llib/_pthread.scm 248 */
obj_t BgL_arg1383z00_604;
{ /* Llib/_pthread.scm 248 */
bool_t BgL_test1849z00_1182;
if(
PAIRP(BgL_portz00_486))
{ /* Llib/_pthread.scm 248 */
obj_t BgL_tmpz00_1185;
BgL_tmpz00_1185 = 
CAR(BgL_portz00_486); 
BgL_test1849z00_1182 = 
OUTPUT_PORTP(BgL_tmpz00_1185); }  else 
{ /* Llib/_pthread.scm 248 */
BgL_test1849z00_1182 = ((bool_t)0)
; } 
if(BgL_test1849z00_1182)
{ /* Llib/_pthread.scm 248 */
BgL_arg1383z00_604 = 
CAR(BgL_portz00_486); }  else 
{ /* Llib/_pthread.scm 250 */
obj_t BgL_res1676z00_605;
{ /* Llib/_pthread.scm 250 */
obj_t BgL_tmpz00_1189;
BgL_tmpz00_1189 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_res1676z00_605 = 
BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_1189); } 
BgL_arg1383z00_604 = BgL_res1676z00_605; } } 
{ /* Llib/_pthread.scm 252 */
obj_t BgL_zc3z04anonymousza31518ze3z87_606;
BgL_zc3z04anonymousza31518ze3z87_606 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31518ze3ze5zz__ft_z52pthreadz52, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31518ze3z87_606, 
(int)(((long)0)), 
((obj_t)
((BgL_z52pthreadz52_bglt)BgL_oz00_485))); 
return 
BGl_withzd2outputzd2tozd2portzd2zz__r4_ports_6_10_1z00(BgL_arg1383z00_604, BgL_zc3z04anonymousza31518ze3z87_606);} } } 

}



/* &<@anonymous:1518> */
obj_t BGl_z62zc3z04anonymousza31518ze3ze5zz__ft_z52pthreadz52(obj_t BgL_envz00_487)
{
{ /* Llib/_pthread.scm 251 */
{ /* Llib/_pthread.scm 252 */
BgL_z52pthreadz52_bglt BgL_oz00_488;
BgL_oz00_488 = 
((BgL_z52pthreadz52_bglt)
PROCEDURE_REF(BgL_envz00_487, 
(int)(((long)0)))); 
{ /* Llib/_pthread.scm 254 */
obj_t BgL_thezd2parentzd2_607;
if(
(
((obj_t)BgL_oz00_488)==
(((BgL_z52pthreadz52_bglt)COBJECT(BgL_oz00_488))->BgL_parentz00)))
{ /* Llib/_pthread.scm 254 */
BgL_thezd2parentzd2_607 = BGl_string1748z00zz__ft_z52pthreadz52; }  else 
{ /* Llib/_pthread.scm 254 */
BgL_thezd2parentzd2_607 = 
(((BgL_z52pthreadz52_bglt)COBJECT(BgL_oz00_488))->BgL_parentz00); } 
{ /* Llib/_pthread.scm 255 */
obj_t BgL_arg1524z00_608;
BgL_arg1524z00_608 = 
(((BgL_threadz00_bglt)COBJECT(
((BgL_threadz00_bglt)BgL_oz00_488)))->BgL_namez00); 
{ /* Llib/_pthread.scm 255 */
obj_t BgL_list1525z00_609;
{ /* Llib/_pthread.scm 255 */
obj_t BgL_arg1537z00_610;
{ /* Llib/_pthread.scm 255 */
obj_t BgL_arg1545z00_611;
{ /* Llib/_pthread.scm 255 */
obj_t BgL_arg1546z00_612;
{ /* Llib/_pthread.scm 255 */
obj_t BgL_arg1547z00_613;
BgL_arg1547z00_613 = 
MAKE_YOUNG_PAIR(BGl_string1749z00zz__ft_z52pthreadz52, BNIL); 
BgL_arg1546z00_612 = 
MAKE_YOUNG_PAIR(BgL_thezd2parentzd2_607, BgL_arg1547z00_613); } 
BgL_arg1545z00_611 = 
MAKE_YOUNG_PAIR(BGl_string1750z00zz__ft_z52pthreadz52, BgL_arg1546z00_612); } 
BgL_arg1537z00_610 = 
MAKE_YOUNG_PAIR(BgL_arg1524z00_608, BgL_arg1545z00_611); } 
BgL_list1525z00_609 = 
MAKE_YOUNG_PAIR(BGl_string1751z00zz__ft_z52pthreadz52, BgL_arg1537z00_610); } 
return 
BGl_displayza2za2zz__r4_output_6_10_3z00(BgL_list1525z00_609);} } } } } 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__ft_z52pthreadz52()
{
{ /* Llib/_pthread.scm 6 */
BGl_modulezd2initializa7ationz75zz__ft_typesz00(((long)414892275), 
BSTRING_TO_STRING(BGl_string1752z00zz__ft_z52pthreadz52)); 
BGl_modulezd2initializa7ationz75zz__ft_z52typesz52(((long)0), 
BSTRING_TO_STRING(BGl_string1752z00zz__ft_z52pthreadz52)); 
BGl_modulezd2initializa7ationz75zz__ft_z52threadz52(((long)536507091), 
BSTRING_TO_STRING(BGl_string1752z00zz__ft_z52pthreadz52)); 
BGl_modulezd2initializa7ationz75zz__ft_schedulerz00(((long)427827911), 
BSTRING_TO_STRING(BGl_string1752z00zz__ft_z52pthreadz52)); 
BGl_modulezd2initializa7ationz75zz__ft_z52schedulerz52(((long)398966270), 
BSTRING_TO_STRING(BGl_string1752z00zz__ft_z52pthreadz52)); 
return 
BGl_modulezd2initializa7ationz75zz__ft_signalz00(((long)295111899), 
BSTRING_TO_STRING(BGl_string1752z00zz__ft_z52pthreadz52));} 

}

#ifdef __cplusplus
}
#endif
