/*===========================================================================*/
/*   (Llib/_thread.scm)                                                      */
/*   Bigloo (4.3h)                                                           */
/*   Inria -- Sophia Antipolis (c)       Tue 12 May 2020 08:36:09 AM CEST    */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.3h/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.3h/lib/bigloo/4.3h -I Llib -lib-dir /builddir/build/BUILD/bigloo-4.3h/lib/bigloo/4.3h -unsafe -safee -copt -fPIC -copt -IPosix Llib/_thread.scm -o objs/_thread.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_threadz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
} *BgL_threadz00_bglt;

typedef struct BgL_fthreadz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_schedulerz00;
   obj_t BgL_z52builtinz52;
   int BgL_z52timeoutz52;
   obj_t BgL_z52statez52;
   bool_t BgL_z52iszd2suspendz80;
   obj_t BgL_z52terminatez52;
   obj_t BgL_z52resultz52;
   obj_t BgL_z52exczd2resultz80;
   bool_t BgL_z52exczd2raisedz80;
   int BgL_z52identz52;
   obj_t BgL_z52signalsz52;
   obj_t BgL_z52awakezd2signalz80;
   obj_t BgL_z52awakezd2valuez80;
   obj_t BgL_z52cleanupz52;
   obj_t BgL_z52specificz52;
   obj_t BgL_bodyz00;
} *BgL_fthreadz00_bglt;

typedef struct BgL_schedulerz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_schedulerz00;
   obj_t BgL_z52builtinz52;
   int BgL_z52timeoutz52;
   obj_t BgL_z52statez52;
   bool_t BgL_z52iszd2suspendz80;
   obj_t BgL_z52terminatez52;
   obj_t BgL_z52resultz52;
   obj_t BgL_z52exczd2resultz80;
   bool_t BgL_z52exczd2raisedz80;
   int BgL_z52identz52;
   obj_t BgL_z52signalsz52;
   obj_t BgL_z52awakezd2signalz80;
   obj_t BgL_z52awakezd2valuez80;
   obj_t BgL_z52cleanupz52;
   obj_t BgL_z52specificz52;
   obj_t BgL_bodyz00;
   obj_t BgL_envzb2zb2;
   obj_t BgL_strictzd2orderzf3z21;
} *BgL_schedulerz00_bglt;

typedef struct BgL_z52schedulerz52_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_schedulerz00;
   obj_t BgL_z52builtinz52;
   int BgL_z52timeoutz52;
   obj_t BgL_z52statez52;
   bool_t BgL_z52iszd2suspendz80;
   obj_t BgL_z52terminatez52;
   obj_t BgL_z52resultz52;
   obj_t BgL_z52exczd2resultz80;
   bool_t BgL_z52exczd2raisedz80;
   int BgL_z52identz52;
   obj_t BgL_z52signalsz52;
   obj_t BgL_z52awakezd2signalz80;
   obj_t BgL_z52awakezd2valuez80;
   obj_t BgL_z52cleanupz52;
   obj_t BgL_z52specificz52;
   obj_t BgL_bodyz00;
   obj_t BgL_envzb2zb2;
   obj_t BgL_strictzd2orderzf3z21;
   obj_t BgL_nextzd2instantzd2;
   obj_t BgL_currentzd2threadzd2;
   int BgL_z52livezd2threadzd2numberz52;
   bool_t BgL_z52threadszd2readyz80;
   obj_t BgL_threadszd2runnablezd2;
   obj_t BgL_threadszd2runnablezd2lastzd2pairzd2;
   obj_t BgL_asynczd2runnablezd2;
   obj_t BgL_threadszd2timeoutzd2;
   obj_t BgL_threadszd2yieldzd2;
   obj_t BgL_tostartz00;
   obj_t BgL_toterminatez00;
   obj_t BgL_tosuspendzf2resumezf2;
   obj_t BgL_tobroadcastz00;
   obj_t BgL_tospawnz00;
   obj_t BgL_currentzd2tokenzd2;
} *BgL_z52schedulerz52_bglt;

typedef struct BgL_z52pthreadz52_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_bodyz00;
   bool_t BgL_detachedpz00;
   obj_t BgL_endzd2resultzd2;
   obj_t BgL_endzd2exceptionzd2;
   void * BgL_z42builtinz42;
   obj_t BgL_fthreadz00;
   obj_t BgL_mutexz00;
   obj_t BgL_condvarz00;
   obj_t BgL_idz00;
   obj_t BgL_parentz00;
} *BgL_z52pthreadz52_bglt;


BGL_EXPORTED_DECL bool_t BGl_z52threadzd2iszd2deadz52zz__ft_z52threadz52(BgL_fthreadz00_bglt, obj_t);
extern obj_t BGl_z52schedulerzd2switchzd2tozd2nextzd2threadz52zz__ft_z52schedulerz52(BgL_fthreadz00_bglt, BgL_schedulerz00_bglt);
static obj_t BGl_objectzd2initzd2zz__ft_z52threadz52();
extern obj_t BGl_z52schedulerzd2addzd2asynczd2runnablez12z92zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt, BgL_fthreadz00_bglt);
BGL_EXPORTED_DECL obj_t BGl_z52threadzd2unregisterzd2signalsz12z40zz__ft_z52threadz52(BgL_fthreadz00_bglt);
BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_z52threadzd2killz12z92zz__ft_z52threadz52(BgL_fthreadz00_bglt);
static obj_t BGl_methodzd2initzd2zz__ft_z52threadz52();
BGL_EXPORTED_DECL bool_t BGl_z52threadzd2iszd2terminatedz52zz__ft_z52threadz52(BgL_fthreadz00_bglt, obj_t);
BGL_EXPORTED_DECL obj_t BGl_z52threadzd2awakez12z92zz__ft_z52threadz52(BgL_fthreadz00_bglt);
BGL_EXPORTED_DECL bool_t BGl_z52threadzd2iszd2toterminatez52zz__ft_z52threadz52(BgL_fthreadz00_bglt, obj_t);
BGL_IMPORT obj_t bgl_remq_bang(obj_t, obj_t);
static obj_t BGl_z62z52threadzd2iszd2terminatedz30zz__ft_z52threadz52(obj_t, obj_t, obj_t);
extern obj_t BGl_schedulerz00zz__ft_typesz00;
static obj_t BGl_gczd2rootszd2initz00zz__ft_z52threadz52();
static obj_t BGl_z62z52threadzd2yieldz12zf0zz__ft_z52threadz52(obj_t, obj_t);
static obj_t BGl_z62z52threadzd2attachedzf3z11zz__ft_z52threadz52(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_z52threadzd2timeoutz12z92zz__ft_z52threadz52(BgL_fthreadz00_bglt, int);
static obj_t BGl_z62z52threadzd2iszd2toterminatez30zz__ft_z52threadz52(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_z52threadzd2asynchroniza7ez12z35zz__ft_z52threadz52(BgL_fthreadz00_bglt, obj_t);
extern obj_t BGl_signalzd2unbindzd2threadz12z12zz__ft_signalz00(obj_t, BgL_threadz00_bglt);
extern obj_t BGl_z52pthreadzd2waitz80zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt);
static obj_t BGl_z62z52threadzd2killz12zf0zz__ft_z52threadz52(obj_t, obj_t);
static obj_t BGl_z62z52threadzd2asynchroniza7ez12z57zz__ft_z52threadz52(obj_t, obj_t, obj_t);
extern obj_t BGl_z52schedulerzd2nextzd2threadz52zz__ft_z52schedulerz52(BgL_fthreadz00_bglt, BgL_schedulerz00_bglt);
static obj_t BGl_requirezd2initializa7ationz75zz__ft_z52threadz52 = BUNSPEC;
static obj_t BGl_z62z52threadzd2cooperateze2zz__ft_z52threadz52(obj_t, obj_t);
BGL_IMPORT obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62z52threadzd2iszd2deadz30zz__ft_z52threadz52(obj_t, obj_t, obj_t);
static obj_t BGl_toplevelzd2initzd2zz__ft_z52threadz52();
static obj_t BGl_genericzd2initzd2zz__ft_z52threadz52();
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
static obj_t BGl_z62z52threadzd2awakez12zf0zz__ft_z52threadz52(obj_t, obj_t);
extern obj_t BGl_fthreadz00zz__ft_typesz00;
BGL_EXPORTED_DECL bool_t BGl_z52threadzd2attachedzf3z73zz__ft_z52threadz52(BgL_fthreadz00_bglt);
static obj_t BGl_z62z52threadzd2unregisterzd2signalsz12z22zz__ft_z52threadz52(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__ft_z52threadz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52pthreadz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52schedulerz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_schedulerz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_signalz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52typesz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_typesz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__pth_threadz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
extern obj_t BGl_z52pthreadzd2switchz80zz__ft_z52pthreadz52(obj_t, BgL_z52pthreadz52_bglt);
static obj_t BGl_cnstzd2initzd2zz__ft_z52threadz52();
static obj_t BGl_libraryzd2moduleszd2initz00zz__ft_z52threadz52();
static obj_t BGl_importedzd2moduleszd2initz00zz__ft_z52threadz52();
BGL_EXPORTED_DECL obj_t BGl_z52threadzd2cooperatez80zz__ft_z52threadz52(BgL_fthreadz00_bglt);
static obj_t BGl_z62z52threadzd2synchroniza7ez12z57zz__ft_z52threadz52(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_z52threadzd2synchroniza7ez12z35zz__ft_z52threadz52(obj_t);
BGL_IMPORT obj_t BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_z52threadzd2yieldz12z92zz__ft_z52threadz52(BgL_fthreadz00_bglt);
static obj_t BGl_z62z52threadzd2timeoutz12zf0zz__ft_z52threadz52(obj_t, obj_t, obj_t);
static obj_t __cnst[ 3 ] ;


DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52threadzd2timeoutz12zd2envz40zz__ft_z52threadz52, BgL_bgl_za762za752threadza7d2t1201za7, BGl_z62z52threadzd2timeoutz12zf0zz__ft_z52threadz52, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52threadzd2cooperatezd2envz52zz__ft_z52threadz52, BgL_bgl_za762za752threadza7d2c1202za7, BGl_z62z52threadzd2cooperateze2zz__ft_z52threadz52, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52threadzd2killz12zd2envz40zz__ft_z52threadz52, BgL_bgl_za762za752threadza7d2k1203za7, BGl_z62z52threadzd2killz12zf0zz__ft_z52threadz52, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52threadzd2asynchroniza7ez12zd2envze7zz__ft_z52threadz52, BgL_bgl_za762za752threadza7d2a1204za7, BGl_z62z52threadzd2asynchroniza7ez12z57zz__ft_z52threadz52, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string1180z00zz__ft_z52threadz52, BgL_bgl_string1180za700za7za7_1205za7, "Llib/_thread.scm", 16 );
DEFINE_STRING( BGl_string1181z00zz__ft_z52threadz52, BgL_bgl_string1181za700za7za7_1206za7, "/builddir/build/BUILD/bigloo-4.3h/api/fthread/src/Llib/_thread.scm", 66 );
DEFINE_STRING( BGl_string1182z00zz__ft_z52threadz52, BgL_bgl_string1182za700za7za7_1207za7, "&%thread-awake!", 15 );
DEFINE_STRING( BGl_string1183z00zz__ft_z52threadz52, BgL_bgl_string1183za700za7za7_1208za7, "fthread", 7 );
DEFINE_STRING( BGl_string1184z00zz__ft_z52threadz52, BgL_bgl_string1184za700za7za7_1209za7, "&%thread-cooperate", 18 );
DEFINE_STRING( BGl_string1185z00zz__ft_z52threadz52, BgL_bgl_string1185za700za7za7_1210za7, "&%thread-yield!", 15 );
DEFINE_STRING( BGl_string1186z00zz__ft_z52threadz52, BgL_bgl_string1186za700za7za7_1211za7, "&%thread-timeout!", 17 );
DEFINE_STRING( BGl_string1187z00zz__ft_z52threadz52, BgL_bgl_string1187za700za7za7_1212za7, "bint", 4 );
DEFINE_STRING( BGl_string1188z00zz__ft_z52threadz52, BgL_bgl_string1188za700za7za7_1213za7, "&%thread-kill!", 14 );
DEFINE_STRING( BGl_string1189z00zz__ft_z52threadz52, BgL_bgl_string1189za700za7za7_1214za7, "&%thread-unregister-signals!", 28 );
DEFINE_STRING( BGl_string1190z00zz__ft_z52threadz52, BgL_bgl_string1190za700za7za7_1215za7, "&%thread-attached?", 18 );
DEFINE_STRING( BGl_string1191z00zz__ft_z52threadz52, BgL_bgl_string1191za700za7za7_1216za7, "&%thread-is-dead", 16 );
DEFINE_STRING( BGl_string1192z00zz__ft_z52threadz52, BgL_bgl_string1192za700za7za7_1217za7, "&%thread-is-toterminate", 23 );
DEFINE_STRING( BGl_string1193z00zz__ft_z52threadz52, BgL_bgl_string1193za700za7za7_1218za7, "&%thread-is-terminated", 22 );
DEFINE_STRING( BGl_string1194z00zz__ft_z52threadz52, BgL_bgl_string1194za700za7za7_1219za7, "&%thread-asynchronize!", 22 );
DEFINE_STRING( BGl_string1195z00zz__ft_z52threadz52, BgL_bgl_string1195za700za7za7_1220za7, "symbol", 6 );
DEFINE_STRING( BGl_string1196z00zz__ft_z52threadz52, BgL_bgl_string1196za700za7za7_1221za7, "__ft_%thread", 12 );
DEFINE_STRING( BGl_string1197z00zz__ft_z52threadz52, BgL_bgl_string1197za700za7za7_1222za7, "terminated toterminate dead ", 28 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52threadzd2yieldz12zd2envz40zz__ft_z52threadz52, BgL_bgl_za762za752threadza7d2y1223za7, BGl_z62z52threadzd2yieldz12zf0zz__ft_z52threadz52, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52threadzd2iszd2deadzd2envz80zz__ft_z52threadz52, BgL_bgl_za762za752threadza7d2i1224za7, va_generic_entry, BGl_z62z52threadzd2iszd2deadz30zz__ft_z52threadz52, BUNSPEC, -2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52threadzd2attachedzf3zd2envza1zz__ft_z52threadz52, BgL_bgl_za762za752threadza7d2a1225za7, BGl_z62z52threadzd2attachedzf3z11zz__ft_z52threadz52, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52threadzd2iszd2toterminatezd2envz80zz__ft_z52threadz52, BgL_bgl_za762za752threadza7d2i1226za7, va_generic_entry, BGl_z62z52threadzd2iszd2toterminatez30zz__ft_z52threadz52, BUNSPEC, -2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52threadzd2unregisterzd2signalsz12zd2envz92zz__ft_z52threadz52, BgL_bgl_za762za752threadza7d2u1227za7, BGl_z62z52threadzd2unregisterzd2signalsz12z22zz__ft_z52threadz52, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52threadzd2iszd2terminatedzd2envz80zz__ft_z52threadz52, BgL_bgl_za762za752threadza7d2i1228za7, va_generic_entry, BGl_z62z52threadzd2iszd2terminatedz30zz__ft_z52threadz52, BUNSPEC, -2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52threadzd2synchroniza7ez12zd2envze7zz__ft_z52threadz52, BgL_bgl_za762za752threadza7d2s1229za7, BGl_z62z52threadzd2synchroniza7ez12z57zz__ft_z52threadz52, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52threadzd2awakez12zd2envz40zz__ft_z52threadz52, BgL_bgl_za762za752threadza7d2a1230za7, BGl_z62z52threadzd2awakez12zf0zz__ft_z52threadz52, 0L, BUNSPEC, 1 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__ft_z52threadz52) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__ft_z52threadz52(long BgL_checksumz00_228, char * BgL_fromz00_229)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__ft_z52threadz52))
{ 
BGl_requirezd2initializa7ationz75zz__ft_z52threadz52 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__ft_z52threadz52(); 
BGl_libraryzd2moduleszd2initz00zz__ft_z52threadz52(); 
BGl_cnstzd2initzd2zz__ft_z52threadz52(); 
BGl_importedzd2moduleszd2initz00zz__ft_z52threadz52(); 
return 
BGl_toplevelzd2initzd2zz__ft_z52threadz52();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__ft_z52threadz52()
{
{ /* Llib/_thread.scm 15 */
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__ft_%thread"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__ft_%thread"); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "__ft_%thread"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__ft_%thread"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__ft_%thread"); 
BGl_modulezd2initializa7ationz75zz__pth_threadz00(((long)0), "__ft_%thread"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__ft_%thread"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__ft_%thread"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__ft_z52threadz52()
{
{ /* Llib/_thread.scm 15 */
{ /* Llib/_thread.scm 15 */
obj_t BgL_cportz00_211;
{ /* Llib/_thread.scm 15 */
obj_t BgL_stringz00_219;
BgL_stringz00_219 = BGl_string1197z00zz__ft_z52threadz52; 
{ /* Llib/_thread.scm 15 */
obj_t BgL_startz00_220;
BgL_startz00_220 = 
BINT(((long)0)); 
{ /* Llib/_thread.scm 15 */
obj_t BgL_endz00_221;
BgL_endz00_221 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_219))); 
{ /* Llib/_thread.scm 15 */

BgL_cportz00_211 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_219, BgL_startz00_220, BgL_endz00_221); } } } } 
{ 
long BgL_iz00_212;
BgL_iz00_212 = ((long)2); 
BgL_loopz00_213:
if(
(BgL_iz00_212==((long)-1)))
{ /* Llib/_thread.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/_thread.scm 15 */
{ /* Llib/_thread.scm 15 */
obj_t BgL_arg1199z00_215;
{ /* Llib/_thread.scm 15 */

{ /* Llib/_thread.scm 15 */
obj_t BgL_locationz00_217;
BgL_locationz00_217 = 
BBOOL(((bool_t)0)); 
{ /* Llib/_thread.scm 15 */

BgL_arg1199z00_215 = 
BGl_readz00zz__readerz00(BgL_cportz00_211, BgL_locationz00_217); } } } 
{ /* Llib/_thread.scm 15 */
int BgL_tmpz00_255;
BgL_tmpz00_255 = 
(int)(BgL_iz00_212); 
CNST_TABLE_SET(BgL_tmpz00_255, BgL_arg1199z00_215); } } 
{ /* Llib/_thread.scm 15 */
int BgL_auxz00_218;
BgL_auxz00_218 = 
(int)(
(BgL_iz00_212-((long)1))); 
{ 
long BgL_iz00_260;
BgL_iz00_260 = 
(long)(BgL_auxz00_218); 
BgL_iz00_212 = BgL_iz00_260; 
goto BgL_loopz00_213;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__ft_z52threadz52()
{
{ /* Llib/_thread.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__ft_z52threadz52()
{
{ /* Llib/_thread.scm 15 */
BGl_modulezd2initializa7ationz75zz__pth_threadz00(((long)0), 
BSTRING_TO_STRING(BGl_string1180z00zz__ft_z52threadz52)); 
return BFALSE;} 

}



/* %thread-awake! */
BGL_EXPORTED_DEF obj_t BGl_z52threadzd2awakez12z92zz__ft_z52threadz52(BgL_fthreadz00_bglt BgL_tz00_3)
{
{ /* Llib/_thread.scm 42 */
{ /* Llib/_thread.scm 44 */
BgL_z52schedulerz52_bglt BgL_i1061z00_30;
BgL_i1061z00_30 = 
((BgL_z52schedulerz52_bglt)
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_3))->BgL_schedulerz00)); 
((((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_3))->BgL_z52timeoutz52)=((int)
(int)(((long)1))),BUNSPEC); 
if(
NULLP(
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1061z00_30))->BgL_threadszd2runnablezd2lastzd2pairzd2)))
{ /* Llib/_thread.scm 47 */
{ 
obj_t BgL_auxz00_272;
{ /* Llib/_thread.scm 52 */
obj_t BgL_list1092z00_35;
BgL_list1092z00_35 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_tz00_3), BNIL); 
BgL_auxz00_272 = BgL_list1092z00_35; } 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1061z00_30))->BgL_threadszd2runnablezd2)=((obj_t)BgL_auxz00_272),BUNSPEC); } 
return 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1061z00_30))->BgL_threadszd2runnablezd2lastzd2pairzd2)=((obj_t)
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1061z00_30))->BgL_threadszd2runnablezd2)),BUNSPEC);}  else 
{ /* Llib/_thread.scm 48 */
obj_t BgL_pz00_33;
BgL_pz00_33 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_tz00_3), BNIL); 
{ /* Llib/_thread.scm 49 */
obj_t BgL_arg1091z00_34;
BgL_arg1091z00_34 = 
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1061z00_30))->BgL_threadszd2runnablezd2lastzd2pairzd2); 
{ /* Llib/_thread.scm 49 */
obj_t BgL_tmpz00_281;
BgL_tmpz00_281 = 
((obj_t)BgL_arg1091z00_34); 
SET_CDR(BgL_tmpz00_281, BgL_pz00_33); } } 
return 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1061z00_30))->BgL_threadszd2runnablezd2lastzd2pairzd2)=((obj_t)BgL_pz00_33),BUNSPEC);} } } 

}



/* &%thread-awake! */
obj_t BGl_z62z52threadzd2awakez12zf0zz__ft_z52threadz52(obj_t BgL_envz00_131, obj_t BgL_tz00_132)
{
{ /* Llib/_thread.scm 42 */
{ /* Llib/_thread.scm 43 */
BgL_fthreadz00_bglt BgL_auxz00_285;
if(
BGl_isazf3zf3zz__objectz00(BgL_tz00_132, BGl_fthreadz00zz__ft_typesz00))
{ /* Llib/_thread.scm 43 */
BgL_auxz00_285 = 
((BgL_fthreadz00_bglt)BgL_tz00_132)
; }  else 
{ 
obj_t BgL_auxz00_289;
BgL_auxz00_289 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1181z00zz__ft_z52threadz52, 
BINT(((long)1915)), BGl_string1182z00zz__ft_z52threadz52, BGl_string1183z00zz__ft_z52threadz52, BgL_tz00_132); 
FAILURE(BgL_auxz00_289,BFALSE,BFALSE);} 
return 
BGl_z52threadzd2awakez12z92zz__ft_z52threadz52(BgL_auxz00_285);} } 

}



/* %thread-cooperate */
BGL_EXPORTED_DEF obj_t BGl_z52threadzd2cooperatez80zz__ft_z52threadz52(BgL_fthreadz00_bglt BgL_tz00_4)
{
{ /* Llib/_thread.scm 58 */
{ /* Llib/_thread.scm 64 */
obj_t BgL_arg1094z00_38;
BgL_arg1094z00_38 = 
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_4))->BgL_schedulerz00); 
BGl_z52schedulerzd2switchzd2tozd2nextzd2threadz52zz__ft_z52schedulerz52(BgL_tz00_4, 
((BgL_schedulerz00_bglt)BgL_arg1094z00_38)); } 
if(
BGl_z52threadzd2iszd2terminatedz52zz__ft_z52threadz52(BgL_tz00_4, BNIL))
{ /* Llib/_thread.scm 66 */
obj_t BgL_fun1097z00_41;
BgL_fun1097z00_41 = 
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_4))->BgL_z52terminatez52); 
return 
PROCEDURE_ENTRY(BgL_fun1097z00_41)(BgL_fun1097z00_41, 
((obj_t)BgL_tz00_4), BEOA);}  else 
{ /* Llib/_thread.scm 65 */
return BFALSE;} } 

}



/* &%thread-cooperate */
obj_t BGl_z62z52threadzd2cooperateze2zz__ft_z52threadz52(obj_t BgL_envz00_133, obj_t BgL_tz00_134)
{
{ /* Llib/_thread.scm 58 */
{ /* Llib/_thread.scm 59 */
BgL_fthreadz00_bglt BgL_auxz00_305;
if(
BGl_isazf3zf3zz__objectz00(BgL_tz00_134, BGl_fthreadz00zz__ft_typesz00))
{ /* Llib/_thread.scm 59 */
BgL_auxz00_305 = 
((BgL_fthreadz00_bglt)BgL_tz00_134)
; }  else 
{ 
obj_t BgL_auxz00_309;
BgL_auxz00_309 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1181z00zz__ft_z52threadz52, 
BINT(((long)2597)), BGl_string1184z00zz__ft_z52threadz52, BGl_string1183z00zz__ft_z52threadz52, BgL_tz00_134); 
FAILURE(BgL_auxz00_309,BFALSE,BFALSE);} 
return 
BGl_z52threadzd2cooperatez80zz__ft_z52threadz52(BgL_auxz00_305);} } 

}



/* %thread-yield! */
BGL_EXPORTED_DEF obj_t BGl_z52threadzd2yieldz12z92zz__ft_z52threadz52(BgL_fthreadz00_bglt BgL_tz00_5)
{
{ /* Llib/_thread.scm 71 */
{ /* Llib/_thread.scm 73 */
BgL_z52schedulerz52_bglt BgL_i1064z00_44;
BgL_i1064z00_44 = 
((BgL_z52schedulerz52_bglt)
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_5))->BgL_schedulerz00)); 
{ 
obj_t BgL_auxz00_316;
{ /* Llib/_thread.scm 74 */
obj_t BgL_arg1099z00_45;
BgL_arg1099z00_45 = 
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1064z00_44))->BgL_threadszd2yieldzd2); 
BgL_auxz00_316 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_tz00_5), BgL_arg1099z00_45); } 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1064z00_44))->BgL_threadszd2yieldzd2)=((obj_t)BgL_auxz00_316),BUNSPEC); } 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1064z00_44))->BgL_z52threadszd2readyz80)=((bool_t)((bool_t)1)),BUNSPEC); 
return 
BGl_z52threadzd2cooperatez80zz__ft_z52threadz52(BgL_tz00_5);} } 

}



/* &%thread-yield! */
obj_t BGl_z62z52threadzd2yieldz12zf0zz__ft_z52threadz52(obj_t BgL_envz00_135, obj_t BgL_tz00_136)
{
{ /* Llib/_thread.scm 71 */
{ /* Llib/_thread.scm 72 */
BgL_fthreadz00_bglt BgL_auxz00_323;
if(
BGl_isazf3zf3zz__objectz00(BgL_tz00_136, BGl_fthreadz00zz__ft_typesz00))
{ /* Llib/_thread.scm 72 */
BgL_auxz00_323 = 
((BgL_fthreadz00_bglt)BgL_tz00_136)
; }  else 
{ 
obj_t BgL_auxz00_327;
BgL_auxz00_327 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1181z00zz__ft_z52threadz52, 
BINT(((long)3208)), BGl_string1185z00zz__ft_z52threadz52, BGl_string1183z00zz__ft_z52threadz52, BgL_tz00_136); 
FAILURE(BgL_auxz00_327,BFALSE,BFALSE);} 
return 
BGl_z52threadzd2yieldz12z92zz__ft_z52threadz52(BgL_auxz00_323);} } 

}



/* %thread-timeout! */
BGL_EXPORTED_DEF obj_t BGl_z52threadzd2timeoutz12z92zz__ft_z52threadz52(BgL_fthreadz00_bglt BgL_tz00_6, int BgL_tmtz00_7)
{
{ /* Llib/_thread.scm 81 */
((((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_6))->BgL_z52timeoutz52)=((int)BgL_tmtz00_7),BUNSPEC); 
{ /* Llib/_thread.scm 84 */
BgL_z52schedulerz52_bglt BgL_i1066z00_47;
BgL_i1066z00_47 = 
((BgL_z52schedulerz52_bglt)
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_6))->BgL_schedulerz00)); 
{ 
obj_t BgL_auxz00_335;
{ /* Llib/_thread.scm 85 */
obj_t BgL_arg1100z00_48;
BgL_arg1100z00_48 = 
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1066z00_47))->BgL_threadszd2timeoutzd2); 
BgL_auxz00_335 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_tz00_6), BgL_arg1100z00_48); } 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1066z00_47))->BgL_threadszd2timeoutzd2)=((obj_t)BgL_auxz00_335),BUNSPEC); } 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1066z00_47))->BgL_z52threadszd2readyz80)=((bool_t)((bool_t)1)),BUNSPEC); 
return 
BGl_z52threadzd2cooperatez80zz__ft_z52threadz52(BgL_tz00_6);} } 

}



/* &%thread-timeout! */
obj_t BGl_z62z52threadzd2timeoutz12zf0zz__ft_z52threadz52(obj_t BgL_envz00_137, obj_t BgL_tz00_138, obj_t BgL_tmtz00_139)
{
{ /* Llib/_thread.scm 81 */
{ /* Llib/_thread.scm 82 */
int BgL_auxz00_350;BgL_fthreadz00_bglt BgL_auxz00_342;
{ /* Llib/_thread.scm 82 */
obj_t BgL_tmpz00_351;
if(
INTEGERP(BgL_tmtz00_139))
{ /* Llib/_thread.scm 82 */
BgL_tmpz00_351 = BgL_tmtz00_139
; }  else 
{ 
obj_t BgL_auxz00_354;
BgL_auxz00_354 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1181z00zz__ft_z52threadz52, 
BINT(((long)3689)), BGl_string1186z00zz__ft_z52threadz52, BGl_string1187z00zz__ft_z52threadz52, BgL_tmtz00_139); 
FAILURE(BgL_auxz00_354,BFALSE,BFALSE);} 
BgL_auxz00_350 = 
CINT(BgL_tmpz00_351); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_tz00_138, BGl_fthreadz00zz__ft_typesz00))
{ /* Llib/_thread.scm 82 */
BgL_auxz00_342 = 
((BgL_fthreadz00_bglt)BgL_tz00_138)
; }  else 
{ 
obj_t BgL_auxz00_346;
BgL_auxz00_346 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1181z00zz__ft_z52threadz52, 
BINT(((long)3689)), BGl_string1186z00zz__ft_z52threadz52, BGl_string1183z00zz__ft_z52threadz52, BgL_tz00_138); 
FAILURE(BgL_auxz00_346,BFALSE,BFALSE);} 
return 
BGl_z52threadzd2timeoutz12z92zz__ft_z52threadz52(BgL_auxz00_342, BgL_auxz00_350);} } 

}



/* %thread-kill! */
BGL_EXPORTED_DEF obj_t BGl_z52threadzd2killz12z92zz__ft_z52threadz52(BgL_fthreadz00_bglt BgL_tz00_8)
{
{ /* Llib/_thread.scm 92 */
{ /* Llib/_thread.scm 96 */
obj_t BgL_list1101z00_50;
BgL_list1101z00_50 = 
MAKE_YOUNG_PAIR(BTRUE, BNIL); 
BGl_z52threadzd2iszd2deadz52zz__ft_z52threadz52(BgL_tz00_8, BgL_list1101z00_50); } 
{ /* Llib/_thread.scm 97 */
BgL_z52schedulerz52_bglt BgL_i1068z00_51;
BgL_i1068z00_51 = 
((BgL_z52schedulerz52_bglt)
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_8))->BgL_schedulerz00)); 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1068z00_51))->BgL_z52livezd2threadzd2numberz52)=((int)
(int)(
(
(long)(
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1068z00_51))->BgL_z52livezd2threadzd2numberz52))-((long)1)))),BUNSPEC); 
{ 
obj_t BgL_auxz00_369;
{ /* Llib/_thread.scm 101 */
obj_t BgL_arg1104z00_53;
BgL_arg1104z00_53 = 
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1068z00_51))->BgL_threadszd2runnablezd2); 
BgL_auxz00_369 = 
bgl_remq_bang(
((obj_t)BgL_tz00_8), BgL_arg1104z00_53); } 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1068z00_51))->BgL_threadszd2runnablezd2)=((obj_t)BgL_auxz00_369),BUNSPEC); } 
if(
NULLP(
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1068z00_51))->BgL_threadszd2runnablezd2)))
{ /* Llib/_thread.scm 102 */
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1068z00_51))->BgL_threadszd2runnablezd2lastzd2pairzd2)=((obj_t)BNIL),BUNSPEC); }  else 
{ /* Llib/_thread.scm 102 */
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1068z00_51))->BgL_threadszd2runnablezd2lastzd2pairzd2)=((obj_t)
BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1068z00_51))->BgL_threadszd2runnablezd2))),BUNSPEC); } 
{ /* Llib/_thread.scm 122 */
obj_t BgL_g1085z00_104;
BgL_g1085z00_104 = 
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_8))->BgL_z52signalsz52); 
{ 
obj_t BgL_l1079z00_106;
BgL_l1079z00_106 = BgL_g1085z00_104; 
BgL_zc3z04anonymousza31110ze3z87_105:
if(
PAIRP(BgL_l1079z00_106))
{ /* Llib/_thread.scm 122 */
{ /* Llib/_thread.scm 122 */
obj_t BgL_sz00_108;
BgL_sz00_108 = 
CAR(BgL_l1079z00_106); 
BGl_signalzd2unbindzd2threadz12z12zz__ft_signalz00(BgL_sz00_108, 
((BgL_threadz00_bglt)BgL_tz00_8)); } 
{ 
obj_t BgL_l1079z00_387;
BgL_l1079z00_387 = 
CDR(BgL_l1079z00_106); 
BgL_l1079z00_106 = BgL_l1079z00_387; 
goto BgL_zc3z04anonymousza31110ze3z87_105;} }  else 
{ /* Llib/_thread.scm 122 */((bool_t)1); } } } 
{ /* Llib/_thread.scm 106 */
obj_t BgL_arg1109z00_58;
BgL_arg1109z00_58 = 
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_8))->BgL_schedulerz00); 
BGl_z52schedulerzd2switchzd2tozd2nextzd2threadz52zz__ft_z52schedulerz52(BgL_tz00_8, 
((BgL_schedulerz00_bglt)BgL_arg1109z00_58)); } 
return BUNSPEC;} } 

}



/* &%thread-kill! */
obj_t BGl_z62z52threadzd2killz12zf0zz__ft_z52threadz52(obj_t BgL_envz00_140, obj_t BgL_tz00_141)
{
{ /* Llib/_thread.scm 92 */
{ /* Llib/_thread.scm 93 */
BgL_fthreadz00_bglt BgL_auxz00_392;
if(
BGl_isazf3zf3zz__objectz00(BgL_tz00_141, BGl_fthreadz00zz__ft_typesz00))
{ /* Llib/_thread.scm 93 */
BgL_auxz00_392 = 
((BgL_fthreadz00_bglt)BgL_tz00_141)
; }  else 
{ 
obj_t BgL_auxz00_396;
BgL_auxz00_396 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1181z00zz__ft_z52threadz52, 
BINT(((long)4201)), BGl_string1188z00zz__ft_z52threadz52, BGl_string1183z00zz__ft_z52threadz52, BgL_tz00_141); 
FAILURE(BgL_auxz00_396,BFALSE,BFALSE);} 
return 
BGl_z52threadzd2killz12z92zz__ft_z52threadz52(BgL_auxz00_392);} } 

}



/* %thread-unregister-signals! */
BGL_EXPORTED_DEF obj_t BGl_z52threadzd2unregisterzd2signalsz12z40zz__ft_z52threadz52(BgL_fthreadz00_bglt BgL_tz00_10)
{
{ /* Llib/_thread.scm 120 */
{ /* Llib/_thread.scm 122 */
obj_t BgL_g1085z00_224;
BgL_g1085z00_224 = 
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_10))->BgL_z52signalsz52); 
{ 
obj_t BgL_l1079z00_226;
{ /* Llib/_thread.scm 122 */
bool_t BgL_tmpz00_402;
BgL_l1079z00_226 = BgL_g1085z00_224; 
BgL_zc3z04anonymousza31110ze3z87_225:
if(
PAIRP(BgL_l1079z00_226))
{ /* Llib/_thread.scm 122 */
{ /* Llib/_thread.scm 122 */
obj_t BgL_sz00_227;
BgL_sz00_227 = 
CAR(BgL_l1079z00_226); 
BGl_signalzd2unbindzd2threadz12z12zz__ft_signalz00(BgL_sz00_227, 
((BgL_threadz00_bglt)BgL_tz00_10)); } 
{ 
obj_t BgL_l1079z00_408;
BgL_l1079z00_408 = 
CDR(BgL_l1079z00_226); 
BgL_l1079z00_226 = BgL_l1079z00_408; 
goto BgL_zc3z04anonymousza31110ze3z87_225;} }  else 
{ /* Llib/_thread.scm 122 */
BgL_tmpz00_402 = ((bool_t)1)
; } 
return 
BBOOL(BgL_tmpz00_402);} } } } 

}



/* &%thread-unregister-signals! */
obj_t BGl_z62z52threadzd2unregisterzd2signalsz12z22zz__ft_z52threadz52(obj_t BgL_envz00_142, obj_t BgL_tz00_143)
{
{ /* Llib/_thread.scm 120 */
{ /* Llib/_thread.scm 121 */
BgL_fthreadz00_bglt BgL_auxz00_411;
if(
BGl_isazf3zf3zz__objectz00(BgL_tz00_143, BGl_fthreadz00zz__ft_typesz00))
{ /* Llib/_thread.scm 121 */
BgL_auxz00_411 = 
((BgL_fthreadz00_bglt)BgL_tz00_143)
; }  else 
{ 
obj_t BgL_auxz00_415;
BgL_auxz00_415 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1181z00zz__ft_z52threadz52, 
BINT(((long)5556)), BGl_string1189z00zz__ft_z52threadz52, BGl_string1183z00zz__ft_z52threadz52, BgL_tz00_143); 
FAILURE(BgL_auxz00_415,BFALSE,BFALSE);} 
return 
BGl_z52threadzd2unregisterzd2signalsz12z40zz__ft_z52threadz52(BgL_auxz00_411);} } 

}



/* %thread-attached? */
BGL_EXPORTED_DEF bool_t BGl_z52threadzd2attachedzf3z73zz__ft_z52threadz52(BgL_fthreadz00_bglt BgL_tz00_11)
{
{ /* Llib/_thread.scm 127 */
{ /* Llib/_thread.scm 129 */
obj_t BgL_arg1114z00_124;
BgL_arg1114z00_124 = 
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_11))->BgL_schedulerz00); 
return 
BGl_isazf3zf3zz__objectz00(BgL_arg1114z00_124, BGl_schedulerz00zz__ft_typesz00);} } 

}



/* &%thread-attached? */
obj_t BGl_z62z52threadzd2attachedzf3z11zz__ft_z52threadz52(obj_t BgL_envz00_144, obj_t BgL_tz00_145)
{
{ /* Llib/_thread.scm 127 */
{ /* Llib/_thread.scm 128 */
bool_t BgL_tmpz00_422;
{ /* Llib/_thread.scm 128 */
BgL_fthreadz00_bglt BgL_auxz00_423;
if(
BGl_isazf3zf3zz__objectz00(BgL_tz00_145, BGl_fthreadz00zz__ft_typesz00))
{ /* Llib/_thread.scm 128 */
BgL_auxz00_423 = 
((BgL_fthreadz00_bglt)BgL_tz00_145)
; }  else 
{ 
obj_t BgL_auxz00_427;
BgL_auxz00_427 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1181z00zz__ft_z52threadz52, 
BINT(((long)5925)), BGl_string1190z00zz__ft_z52threadz52, BGl_string1183z00zz__ft_z52threadz52, BgL_tz00_145); 
FAILURE(BgL_auxz00_427,BFALSE,BFALSE);} 
BgL_tmpz00_422 = 
BGl_z52threadzd2attachedzf3z73zz__ft_z52threadz52(BgL_auxz00_423); } 
return 
BBOOL(BgL_tmpz00_422);} } 

}



/* %thread-is-dead */
BGL_EXPORTED_DEF bool_t BGl_z52threadzd2iszd2deadz52zz__ft_z52threadz52(BgL_fthreadz00_bglt BgL_tz00_12, obj_t BgL_vz00_13)
{
{ /* Llib/_thread.scm 134 */
{ /* Llib/_thread.scm 136 */
bool_t BgL_test1248z00_433;
if(
PAIRP(BgL_vz00_13))
{ /* Llib/_thread.scm 136 */
BgL_test1248z00_433 = 
CBOOL(
CAR(BgL_vz00_13))
; }  else 
{ /* Llib/_thread.scm 136 */
BgL_test1248z00_433 = ((bool_t)0)
; } 
if(BgL_test1248z00_433)
{ /* Llib/_thread.scm 137 */
obj_t BgL_xz00_190;
BgL_xz00_190 = 
((((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_12))->BgL_z52statez52)=((obj_t)
CNST_TABLE_REF(((long)0))),BUNSPEC); 
return ((bool_t)1);}  else 
{ /* Llib/_thread.scm 136 */
return 
(
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_12))->BgL_z52statez52)==
CNST_TABLE_REF(((long)0)));} } } 

}



/* &%thread-is-dead */
obj_t BGl_z62z52threadzd2iszd2deadz30zz__ft_z52threadz52(obj_t BgL_envz00_146, obj_t BgL_tz00_147, obj_t BgL_vz00_148)
{
{ /* Llib/_thread.scm 134 */
{ /* Llib/_thread.scm 135 */
bool_t BgL_tmpz00_443;
{ /* Llib/_thread.scm 135 */
BgL_fthreadz00_bglt BgL_auxz00_444;
if(
BGl_isazf3zf3zz__objectz00(BgL_tz00_147, BGl_fthreadz00zz__ft_typesz00))
{ /* Llib/_thread.scm 135 */
BgL_auxz00_444 = 
((BgL_fthreadz00_bglt)BgL_tz00_147)
; }  else 
{ 
obj_t BgL_auxz00_448;
BgL_auxz00_448 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1181z00zz__ft_z52threadz52, 
BINT(((long)6265)), BGl_string1191z00zz__ft_z52threadz52, BGl_string1183z00zz__ft_z52threadz52, BgL_tz00_147); 
FAILURE(BgL_auxz00_448,BFALSE,BFALSE);} 
BgL_tmpz00_443 = 
BGl_z52threadzd2iszd2deadz52zz__ft_z52threadz52(BgL_auxz00_444, BgL_vz00_148); } 
return 
BBOOL(BgL_tmpz00_443);} } 

}



/* %thread-is-toterminate */
BGL_EXPORTED_DEF bool_t BGl_z52threadzd2iszd2toterminatez52zz__ft_z52threadz52(BgL_fthreadz00_bglt BgL_tz00_14, obj_t BgL_vz00_15)
{
{ /* Llib/_thread.scm 143 */
{ /* Llib/_thread.scm 145 */
bool_t BgL_test1251z00_454;
if(
PAIRP(BgL_vz00_15))
{ /* Llib/_thread.scm 145 */
BgL_test1251z00_454 = 
CBOOL(
CAR(BgL_vz00_15))
; }  else 
{ /* Llib/_thread.scm 145 */
BgL_test1251z00_454 = ((bool_t)0)
; } 
if(BgL_test1251z00_454)
{ /* Llib/_thread.scm 146 */
obj_t BgL_xz00_195;
BgL_xz00_195 = 
((((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_14))->BgL_z52statez52)=((obj_t)
CNST_TABLE_REF(((long)1))),BUNSPEC); 
return ((bool_t)1);}  else 
{ /* Llib/_thread.scm 145 */
return 
(
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_14))->BgL_z52statez52)==
CNST_TABLE_REF(((long)1)));} } } 

}



/* &%thread-is-toterminate */
obj_t BGl_z62z52threadzd2iszd2toterminatez30zz__ft_z52threadz52(obj_t BgL_envz00_149, obj_t BgL_tz00_150, obj_t BgL_vz00_151)
{
{ /* Llib/_thread.scm 143 */
{ /* Llib/_thread.scm 144 */
bool_t BgL_tmpz00_464;
{ /* Llib/_thread.scm 144 */
BgL_fthreadz00_bglt BgL_auxz00_465;
if(
BGl_isazf3zf3zz__objectz00(BgL_tz00_150, BGl_fthreadz00zz__ft_typesz00))
{ /* Llib/_thread.scm 144 */
BgL_auxz00_465 = 
((BgL_fthreadz00_bglt)BgL_tz00_150)
; }  else 
{ 
obj_t BgL_auxz00_469;
BgL_auxz00_469 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1181z00zz__ft_z52threadz52, 
BINT(((long)6654)), BGl_string1192z00zz__ft_z52threadz52, BGl_string1183z00zz__ft_z52threadz52, BgL_tz00_150); 
FAILURE(BgL_auxz00_469,BFALSE,BFALSE);} 
BgL_tmpz00_464 = 
BGl_z52threadzd2iszd2toterminatez52zz__ft_z52threadz52(BgL_auxz00_465, BgL_vz00_151); } 
return 
BBOOL(BgL_tmpz00_464);} } 

}



/* %thread-is-terminated */
BGL_EXPORTED_DEF bool_t BGl_z52threadzd2iszd2terminatedz52zz__ft_z52threadz52(BgL_fthreadz00_bglt BgL_tz00_16, obj_t BgL_vz00_17)
{
{ /* Llib/_thread.scm 152 */
{ /* Llib/_thread.scm 154 */
bool_t BgL_test1254z00_475;
if(
PAIRP(BgL_vz00_17))
{ /* Llib/_thread.scm 154 */
BgL_test1254z00_475 = 
CBOOL(
CAR(BgL_vz00_17))
; }  else 
{ /* Llib/_thread.scm 154 */
BgL_test1254z00_475 = ((bool_t)0)
; } 
if(BgL_test1254z00_475)
{ /* Llib/_thread.scm 155 */
obj_t BgL_xz00_200;
BgL_xz00_200 = 
((((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_16))->BgL_z52statez52)=((obj_t)
CNST_TABLE_REF(((long)2))),BUNSPEC); 
return ((bool_t)1);}  else 
{ /* Llib/_thread.scm 154 */
return 
(
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_16))->BgL_z52statez52)==
CNST_TABLE_REF(((long)2)));} } } 

}



/* &%thread-is-terminated */
obj_t BGl_z62z52threadzd2iszd2terminatedz30zz__ft_z52threadz52(obj_t BgL_envz00_152, obj_t BgL_tz00_153, obj_t BgL_vz00_154)
{
{ /* Llib/_thread.scm 152 */
{ /* Llib/_thread.scm 153 */
bool_t BgL_tmpz00_485;
{ /* Llib/_thread.scm 153 */
BgL_fthreadz00_bglt BgL_auxz00_486;
if(
BGl_isazf3zf3zz__objectz00(BgL_tz00_153, BGl_fthreadz00zz__ft_typesz00))
{ /* Llib/_thread.scm 153 */
BgL_auxz00_486 = 
((BgL_fthreadz00_bglt)BgL_tz00_153)
; }  else 
{ 
obj_t BgL_auxz00_490;
BgL_auxz00_490 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1181z00zz__ft_z52threadz52, 
BINT(((long)7056)), BGl_string1193z00zz__ft_z52threadz52, BGl_string1183z00zz__ft_z52threadz52, BgL_tz00_153); 
FAILURE(BgL_auxz00_490,BFALSE,BFALSE);} 
BgL_tmpz00_485 = 
BGl_z52threadzd2iszd2terminatedz52zz__ft_z52threadz52(BgL_auxz00_486, BgL_vz00_154); } 
return 
BBOOL(BgL_tmpz00_485);} } 

}



/* %thread-asynchronize! */
BGL_EXPORTED_DEF obj_t BGl_z52threadzd2asynchroniza7ez12z35zz__ft_z52threadz52(BgL_fthreadz00_bglt BgL_tz00_18, obj_t BgL_idz00_19)
{
{ /* Llib/_thread.scm 161 */
{ /* Llib/_thread.scm 166 */
BgL_z52pthreadz52_bglt BgL_i1075z00_86;
BgL_i1075z00_86 = 
((BgL_z52pthreadz52_bglt)
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_18))->BgL_z52builtinz52)); 
((((BgL_z52pthreadz52_bglt)COBJECT(BgL_i1075z00_86))->BgL_idz00)=((obj_t)BgL_idz00_19),BUNSPEC); } 
{ /* Llib/_thread.scm 168 */
obj_t BgL_ntz00_87;
{ /* Llib/_thread.scm 168 */
obj_t BgL_arg1139z00_91;
BgL_arg1139z00_91 = 
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_18))->BgL_schedulerz00); 
BgL_ntz00_87 = 
BGl_z52schedulerzd2nextzd2threadz52zz__ft_z52schedulerz52(BgL_tz00_18, 
((BgL_schedulerz00_bglt)BgL_arg1139z00_91)); } 
{ /* Llib/_thread.scm 170 */
obj_t BgL_arg1137z00_89;obj_t BgL_arg1138z00_90;
BgL_arg1137z00_89 = 
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_18))->BgL_z52builtinz52); 
BgL_arg1138z00_90 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_ntz00_87)))->BgL_z52builtinz52); 
BGl_z52pthreadzd2switchz80zz__ft_z52pthreadz52(BgL_arg1137z00_89, 
((BgL_z52pthreadz52_bglt)BgL_arg1138z00_90)); } } 
return BUNSPEC;} 

}



/* &%thread-asynchronize! */
obj_t BGl_z62z52threadzd2asynchroniza7ez12z57zz__ft_z52threadz52(obj_t BgL_envz00_155, obj_t BgL_tz00_156, obj_t BgL_idz00_157)
{
{ /* Llib/_thread.scm 161 */
{ /* Llib/_thread.scm 165 */
obj_t BgL_auxz00_515;BgL_fthreadz00_bglt BgL_auxz00_507;
if(
SYMBOLP(BgL_idz00_157))
{ /* Llib/_thread.scm 165 */
BgL_auxz00_515 = BgL_idz00_157
; }  else 
{ 
obj_t BgL_auxz00_518;
BgL_auxz00_518 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1181z00zz__ft_z52threadz52, 
BINT(((long)7578)), BGl_string1194z00zz__ft_z52threadz52, BGl_string1195z00zz__ft_z52threadz52, BgL_idz00_157); 
FAILURE(BgL_auxz00_518,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_tz00_156, BGl_fthreadz00zz__ft_typesz00))
{ /* Llib/_thread.scm 165 */
BgL_auxz00_507 = 
((BgL_fthreadz00_bglt)BgL_tz00_156)
; }  else 
{ 
obj_t BgL_auxz00_511;
BgL_auxz00_511 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1181z00zz__ft_z52threadz52, 
BINT(((long)7578)), BGl_string1194z00zz__ft_z52threadz52, BGl_string1183z00zz__ft_z52threadz52, BgL_tz00_156); 
FAILURE(BgL_auxz00_511,BFALSE,BFALSE);} 
return 
BGl_z52threadzd2asynchroniza7ez12z35zz__ft_z52threadz52(BgL_auxz00_507, BgL_auxz00_515);} } 

}



/* %thread-synchronize! */
BGL_EXPORTED_DEF obj_t BGl_z52threadzd2synchroniza7ez12z35zz__ft_z52threadz52(obj_t BgL_tz00_20)
{
{ /* Llib/_thread.scm 176 */
{ /* Llib/_thread.scm 182 */
obj_t BgL_arg1141z00_93;
BgL_arg1141z00_93 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_20)))->BgL_schedulerz00); 
BGl_z52schedulerzd2addzd2asynczd2runnablez12z92zz__ft_z52schedulerz52(
((BgL_z52schedulerz52_bglt)BgL_arg1141z00_93), 
((BgL_fthreadz00_bglt)BgL_tz00_20)); } 
{ /* Llib/_thread.scm 184 */
obj_t BgL_arg1142z00_94;
BgL_arg1142z00_94 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_20)))->BgL_z52builtinz52); 
BGl_z52pthreadzd2waitz80zz__ft_z52pthreadz52(
((BgL_z52pthreadz52_bglt)BgL_arg1142z00_94)); } 
{ /* Llib/_thread.scm 185 */
BgL_z52pthreadz52_bglt BgL_i1078z00_95;
BgL_i1078z00_95 = 
((BgL_z52pthreadz52_bglt)
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_20)))->BgL_z52builtinz52)); 
return 
((((BgL_z52pthreadz52_bglt)COBJECT(BgL_i1078z00_95))->BgL_idz00)=((obj_t)
(((BgL_threadz00_bglt)COBJECT(
((BgL_threadz00_bglt)
((BgL_fthreadz00_bglt)BgL_tz00_20))))->BgL_namez00)),BUNSPEC);} } 

}



/* &%thread-synchronize! */
obj_t BGl_z62z52threadzd2synchroniza7ez12z57zz__ft_z52threadz52(obj_t BgL_envz00_158, obj_t BgL_tz00_159)
{
{ /* Llib/_thread.scm 176 */
return 
BGl_z52threadzd2synchroniza7ez12z35zz__ft_z52threadz52(BgL_tz00_159);} 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__ft_z52threadz52()
{
{ /* Llib/_thread.scm 15 */
return BUNSPEC;} 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__ft_z52threadz52()
{
{ /* Llib/_thread.scm 15 */
return BUNSPEC;} 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__ft_z52threadz52()
{
{ /* Llib/_thread.scm 15 */
return BUNSPEC;} 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__ft_z52threadz52()
{
{ /* Llib/_thread.scm 15 */
BGl_modulezd2initializa7ationz75zz__ft_typesz00(((long)414892275), 
BSTRING_TO_STRING(BGl_string1196z00zz__ft_z52threadz52)); 
BGl_modulezd2initializa7ationz75zz__ft_z52typesz52(((long)0), 
BSTRING_TO_STRING(BGl_string1196z00zz__ft_z52threadz52)); 
BGl_modulezd2initializa7ationz75zz__ft_signalz00(((long)295111899), 
BSTRING_TO_STRING(BGl_string1196z00zz__ft_z52threadz52)); 
BGl_modulezd2initializa7ationz75zz__ft_schedulerz00(((long)427827911), 
BSTRING_TO_STRING(BGl_string1196z00zz__ft_z52threadz52)); 
BGl_modulezd2initializa7ationz75zz__ft_z52schedulerz52(((long)398966270), 
BSTRING_TO_STRING(BGl_string1196z00zz__ft_z52threadz52)); 
return 
BGl_modulezd2initializa7ationz75zz__ft_z52pthreadz52(((long)486293435), 
BSTRING_TO_STRING(BGl_string1196z00zz__ft_z52threadz52));} 

}

#ifdef __cplusplus
}
#endif
