/*===========================================================================*/
/*   (Llib/thread.scm)                                                       */
/*   Bigloo (4.3h)                                                           */
/*   Inria -- Sophia Antipolis (c)       Tue 12 May 2020 08:36:09 AM CEST    */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.3h/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.3h/lib/bigloo/4.3h -I Llib -lib-dir /builddir/build/BUILD/bigloo-4.3h/lib/bigloo/4.3h -unsafe -safee -copt -fPIC -copt -IPosix Llib/thread.scm -o objs/thread.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_threadz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
} *BgL_threadz00_bglt;

typedef struct BgL_z62exceptionz62_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_fnamez00;
   obj_t BgL_locationz00;
   obj_t BgL_stackz00;
} *BgL_z62exceptionz62_bglt;

typedef struct BgL_terminatedzd2threadzd2exceptionz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_fnamez00;
   obj_t BgL_locationz00;
   obj_t BgL_stackz00;
} *BgL_terminatedzd2threadzd2exceptionz00_bglt;

typedef struct BgL_fthreadz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_schedulerz00;
   obj_t BgL_z52builtinz52;
   int BgL_z52timeoutz52;
   obj_t BgL_z52statez52;
   bool_t BgL_z52iszd2suspendz80;
   obj_t BgL_z52terminatez52;
   obj_t BgL_z52resultz52;
   obj_t BgL_z52exczd2resultz80;
   bool_t BgL_z52exczd2raisedz80;
   int BgL_z52identz52;
   obj_t BgL_z52signalsz52;
   obj_t BgL_z52awakezd2signalz80;
   obj_t BgL_z52awakezd2valuez80;
   obj_t BgL_z52cleanupz52;
   obj_t BgL_z52specificz52;
   obj_t BgL_bodyz00;
} *BgL_fthreadz00_bglt;

typedef struct BgL_schedulerz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_schedulerz00;
   obj_t BgL_z52builtinz52;
   int BgL_z52timeoutz52;
   obj_t BgL_z52statez52;
   bool_t BgL_z52iszd2suspendz80;
   obj_t BgL_z52terminatez52;
   obj_t BgL_z52resultz52;
   obj_t BgL_z52exczd2resultz80;
   bool_t BgL_z52exczd2raisedz80;
   int BgL_z52identz52;
   obj_t BgL_z52signalsz52;
   obj_t BgL_z52awakezd2signalz80;
   obj_t BgL_z52awakezd2valuez80;
   obj_t BgL_z52cleanupz52;
   obj_t BgL_z52specificz52;
   obj_t BgL_bodyz00;
   obj_t BgL_envzb2zb2;
   obj_t BgL_strictzd2orderzf3z21;
} *BgL_schedulerz00_bglt;

typedef struct BgL_z52sigjoinz52_bgl {
   header_t header;
   obj_t widening;
   struct BgL_fthreadz00_bgl * BgL_threadz00;
} *BgL_z52sigjoinz52_bglt;

typedef struct BgL_z52schedulerz52_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_schedulerz00;
   obj_t BgL_z52builtinz52;
   int BgL_z52timeoutz52;
   obj_t BgL_z52statez52;
   bool_t BgL_z52iszd2suspendz80;
   obj_t BgL_z52terminatez52;
   obj_t BgL_z52resultz52;
   obj_t BgL_z52exczd2resultz80;
   bool_t BgL_z52exczd2raisedz80;
   int BgL_z52identz52;
   obj_t BgL_z52signalsz52;
   obj_t BgL_z52awakezd2signalz80;
   obj_t BgL_z52awakezd2valuez80;
   obj_t BgL_z52cleanupz52;
   obj_t BgL_z52specificz52;
   obj_t BgL_bodyz00;
   obj_t BgL_envzb2zb2;
   obj_t BgL_strictzd2orderzf3z21;
   obj_t BgL_nextzd2instantzd2;
   obj_t BgL_currentzd2threadzd2;
   int BgL_z52livezd2threadzd2numberz52;
   bool_t BgL_z52threadszd2readyz80;
   obj_t BgL_threadszd2runnablezd2;
   obj_t BgL_threadszd2runnablezd2lastzd2pairzd2;
   obj_t BgL_asynczd2runnablezd2;
   obj_t BgL_threadszd2timeoutzd2;
   obj_t BgL_threadszd2yieldzd2;
   obj_t BgL_tostartz00;
   obj_t BgL_toterminatez00;
   obj_t BgL_tosuspendzf2resumezf2;
   obj_t BgL_tobroadcastz00;
   obj_t BgL_tospawnz00;
   obj_t BgL_currentzd2tokenzd2;
} *BgL_z52schedulerz52_bglt;

typedef struct BgL_z52sigasyncz52_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_spawnedz00;
   obj_t BgL_idz00;
   obj_t BgL_thunkz00;
} *BgL_z52sigasyncz52_bglt;

typedef struct BgL_joinzd2timeoutzd2exceptionz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_fnamez00;
   obj_t BgL_locationz00;
   obj_t BgL_stackz00;
} *BgL_joinzd2timeoutzd2exceptionz00_bglt;


BGL_EXPORTED_DECL obj_t BGl_threadzd2awaitza2z12z62zz__ft_threadz00(obj_t, obj_t);
static obj_t BGl_z62threadzd2specificzd2fthr1152z62zz__ft_threadz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_raisez00zz__errorz00(obj_t);
static obj_t BGl_z62threadzd2resumez12za2zz__ft_threadz00(obj_t, obj_t);
extern bool_t BGl_z52threadzd2iszd2deadz52zz__ft_z52threadz52(BgL_fthreadz00_bglt, obj_t);
static obj_t BGl_z62threadzd2joinz12zd2fthread1144z70zz__ft_threadz00(obj_t, obj_t, obj_t);
static obj_t BGl_objectzd2initzd2zz__ft_threadz00();
BGL_IMPORT bool_t BGl_2ze3ze3zz__r4_numbers_6_5z00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_z62exceptionz62zz__objectz00;
BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__ft_threadz00();
static obj_t BGl_z62threadzd2cleanupzd2fthre1156z62zz__ft_threadz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_joinzd2timeoutzd2exceptionz00zz__ft_threadz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31181ze3ze5zz__ft_threadz00(obj_t);
extern bool_t BGl_z52threadzd2iszd2terminatedz52zz__ft_z52threadz52(BgL_fthreadz00_bglt, obj_t);
BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
extern bool_t BGl_z52threadzd2iszd2toterminatez52zz__ft_z52threadz52(BgL_fthreadz00_bglt, obj_t);
extern obj_t BGl_z52schedulerzd2spawnzd2asyncz52zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt, BgL_z52sigasyncz52_bglt);
BGL_IMPORT obj_t BGl_terminatedzd2threadzd2exceptionz00zz__pth_threadz00;
BGL_IMPORT bool_t BGl_numberzf3zf3zz__r4_numbers_6_5z00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_threadzd2awaitz12zc0zz__ft_threadz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_threadzd2startz12zc0zz__threadz00(BgL_threadz00_bglt, obj_t);
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__ft_threadz00();
static obj_t BGl_z62threadzd2suspendz12za2zz__ft_threadz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
static BgL_joinzd2timeoutzd2exceptionz00_bglt BGl_z62lambda1614z62zz__ft_threadz00(obj_t, obj_t, obj_t, obj_t);
static BgL_joinzd2timeoutzd2exceptionz00_bglt BGl_z62lambda1617z62zz__ft_threadz00(obj_t);
BGL_IMPORT obj_t BGl_displayza2za2zz__r4_output_6_10_3z00(obj_t);
static obj_t BGl_threadzd2suspendzf2resumez12z32zz__ft_threadz00(BgL_fthreadz00_bglt, obj_t, bool_t);
extern obj_t BGl_z52threadzd2timeoutz12z92zz__ft_z52threadz52(BgL_fthreadz00_bglt, int);
static obj_t BGl_z62threadzd2getzd2valuesza2z12zd2zz__ft_threadz00(obj_t, obj_t);
static obj_t BGl_z62threadzd2awaitza2z12z00zz__ft_threadz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31743ze3ze5zz__ft_threadz00(obj_t);
BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_bigloozd2typezd2errorz00zz__errorz00(obj_t, obj_t, obj_t);
extern BgL_schedulerz00_bglt BGl_z52getzd2optionalzd2schedulerz52zz__ft_z52schedulerz52(obj_t, obj_t);
extern obj_t BGl_z52threadzd2asynchroniza7ez12z35zz__ft_z52threadz52(BgL_fthreadz00_bglt, obj_t);
BGL_IMPORT obj_t BGl_exitdzd2popzd2protectz12z12zz__bexitz00(obj_t);
static obj_t BGl_z62threadzd2startz12zd2fthrea1148z70zz__ft_threadz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62objectzd2equalzf3zd2z52sigjo1142zc3zz__ft_threadz00(obj_t, obj_t, obj_t);
extern obj_t BGl_signalzd2lastzd2valuesz00zz__ft_signalz00(obj_t, obj_t);
static obj_t BGl_z62threadzd2getzd2valuesz12z70zz__ft_threadz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_threadzd2getzd2valuesza2z12zb0zz__ft_threadz00(obj_t);
static obj_t BGl_requirezd2initializa7ationz75zz__ft_threadz00 = BUNSPEC;
BGL_IMPORT obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_threadzd2awaitzd2valuesza2z12zb0zz__ft_threadz00(obj_t, obj_t);
static obj_t BGl_toplevelzd2initzd2zz__ft_threadz00();
BGL_IMPORT obj_t BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(obj_t, obj_t);
static obj_t BGl_genericzd2initzd2zz__ft_threadz00();
static obj_t BGl_z62threadzd2awaitzd2valuesza2z12zd2zz__ft_threadz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_threadzd2resumez12zc0zz__ft_threadz00(BgL_fthreadz00_bglt);
static obj_t BGl_z62threadzd2awaitz12za2zz__ft_threadz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62objectzd2writezd2fthread1146z62zz__ft_threadz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
extern obj_t BGl_fthreadz00zz__ft_typesz00;
extern obj_t BGl_z52sigjoinz52zz__ft_typesz00;
extern obj_t BGl_z52pthreadzd2newz80zz__ft_z52pthreadz52(BgL_fthreadz00_bglt);
extern bool_t BGl_z52threadzd2attachedzf3z73zz__ft_z52threadz52(BgL_fthreadz00_bglt);
extern obj_t BGl_signalzd2registerzd2threadz12z12zz__ft_signalz00(obj_t, obj_t, BgL_threadz00_bglt);
BGL_EXPORTED_DECL obj_t BGl_threadzd2getzd2valuesz12z12zz__ft_threadz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31622ze3ze5zz__ft_threadz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__ft_threadz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52pthreadz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_signalz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52envz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_envz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52schedulerz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_schedulerz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52threadz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52typesz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_typesz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__pth_threadz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
BGL_IMPORT obj_t BGl_withzd2outputzd2tozd2portzd2zz__r4_ports_6_10_1z00(obj_t, obj_t);
static obj_t BGl_z62threadzd2terminatez12zd2ft1150z70zz__ft_threadz00(obj_t, obj_t);
extern obj_t BGl_z52sigasyncz52zz__ft_z52typesz52;
BGL_IMPORT obj_t BGl_currentzd2threadzd2zz__threadz00();
static obj_t BGl_cnstzd2initzd2zz__ft_threadz00();
static obj_t BGl_libraryzd2moduleszd2initz00zz__ft_threadz00();
static obj_t BGl_importedzd2moduleszd2initz00zz__ft_threadz00();
extern obj_t BGl_z52threadzd2cooperatez80zz__ft_z52threadz52(BgL_fthreadz00_bglt);
BGL_EXPORTED_DECL obj_t BGl_threadzd2suspendz12zc0zz__ft_threadz00(BgL_fthreadz00_bglt);
static obj_t BGl_z62threadzd2specificzd2setz121154z70zz__ft_threadz00(obj_t, obj_t, obj_t);
extern obj_t BGl_signalzd2lookupzd2zz__ft_signalz00(obj_t, obj_t);
static obj_t BGl_z62threadzd2awaitzd2valuesz12z70zz__ft_threadz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(obj_t);
static obj_t BGl_z62threadzd2cleanupzd2setz12zd21158za2zz__ft_threadz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_threadzd2awaitzd2valuesz12z12zz__ft_threadz00(obj_t, obj_t);
extern obj_t BGl_signalzd2valuezd2zz__ft_signalz00(obj_t, obj_t);
extern obj_t BGl_z52threadzd2synchroniza7ez12z35zz__ft_z52threadz52(obj_t);
extern obj_t BGl_z52threadzd2yieldz12z92zz__ft_z52threadz52(BgL_fthreadz00_bglt);
BGL_IMPORT bool_t BGl_2ze3zd3z30zz__r4_numbers_6_5z00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_threadz00zz__threadz00;
extern obj_t BGl_z52broadcastz12z40zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt, obj_t, obj_t);
static obj_t __cnst[ 11 ] ;


BGL_IMPORT obj_t BGl_threadzd2startz12zd2envz12zz__threadz00;
BGL_IMPORT obj_t BGl_objectzd2writezd2envz00zz__objectz00;
BGL_IMPORT obj_t BGl_threadzd2specificzd2envz00zz__threadz00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_threadzd2awaitzd2valuesza2z12zd2envz62zz__ft_threadz00, BgL_bgl_za762threadza7d2awai1954z00, va_generic_entry, BGl_z62threadzd2awaitzd2valuesza2z12zd2zz__ft_threadz00, BUNSPEC, -2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1920z00zz__ft_threadz00, BgL_bgl_za762za7c3za704anonymo1955za7, BGl_z62zc3z04anonymousza31622ze3ze5zz__ft_threadz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1921z00zz__ft_threadz00, BgL_bgl_za762lambda1617za7621956z00, BGl_z62lambda1617z62zz__ft_threadz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1922z00zz__ft_threadz00, BgL_bgl_za762lambda1614za7621957z00, BGl_z62lambda1614z62zz__ft_threadz00, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1923z00zz__ft_threadz00, BgL_bgl_za762objectza7d2equa1958z00, BGl_z62objectzd2equalzf3zd2z52sigjo1142zc3zz__ft_threadz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1925z00zz__ft_threadz00, BgL_bgl_za762threadza7d2join1959z00, va_generic_entry, BGl_z62threadzd2joinz12zd2fthread1144z70zz__ft_threadz00, BUNSPEC, -2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1927z00zz__ft_threadz00, BgL_bgl_za762objectza7d2writ1960z00, va_generic_entry, BGl_z62objectzd2writezd2fthread1146z62zz__ft_threadz00, BUNSPEC, -2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1929z00zz__ft_threadz00, BgL_bgl_za762threadza7d2star1961z00, va_generic_entry, BGl_z62threadzd2startz12zd2fthrea1148z70zz__ft_threadz00, BUNSPEC, -2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1931z00zz__ft_threadz00, BgL_bgl_za762threadza7d2term1962z00, BGl_z62threadzd2terminatez12zd2ft1150z70zz__ft_threadz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1933z00zz__ft_threadz00, BgL_bgl_za762threadza7d2spec1963z00, BGl_z62threadzd2specificzd2fthr1152z62zz__ft_threadz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1935z00zz__ft_threadz00, BgL_bgl_za762threadza7d2spec1964z00, BGl_z62threadzd2specificzd2setz121154z70zz__ft_threadz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1937z00zz__ft_threadz00, BgL_bgl_za762threadza7d2clea1965z00, BGl_z62threadzd2cleanupzd2fthre1156z62zz__ft_threadz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1939z00zz__ft_threadz00, BgL_bgl_za762threadza7d2clea1966z00, BGl_z62threadzd2cleanupzd2setz12zd21158za2zz__ft_threadz00, 0L, BUNSPEC, 2 );
BGL_IMPORT obj_t BGl_threadzd2terminatez12zd2envz12zz__threadz00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_threadzd2getzd2valuesz12zd2envzc0zz__ft_threadz00, BgL_bgl_za762threadza7d2getza71967za7, BGl_z62threadzd2getzd2valuesz12z70zz__ft_threadz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_threadzd2resumez12zd2envz12zz__ft_threadz00, BgL_bgl_za762threadza7d2resu1968z00, BGl_z62threadzd2resumez12za2zz__ft_threadz00, 0L, BUNSPEC, 1 );
BGL_IMPORT obj_t BGl_threadzd2cleanupzd2envz00zz__threadz00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_threadzd2awaitz12zd2envz12zz__ft_threadz00, BgL_bgl_za762threadza7d2awai1969z00, va_generic_entry, BGl_z62threadzd2awaitz12za2zz__ft_threadz00, BUNSPEC, -2 );
BGL_IMPORT obj_t BGl_threadzd2joinz12zd2envz12zz__threadz00;
DEFINE_STRING( BGl_string1905z00zz__ft_threadz00, BgL_bgl_string1905za700za7za7_1970za7, "Llib/thread.scm", 15 );
DEFINE_STRING( BGl_string1906z00zz__ft_threadz00, BgL_bgl_string1906za700za7za7_1971za7, "thread-await", 12 );
DEFINE_STRING( BGl_string1907z00zz__ft_threadz00, BgL_bgl_string1907za700za7za7_1972za7, "Illegal timeout", 15 );
DEFINE_STRING( BGl_string1908z00zz__ft_threadz00, BgL_bgl_string1908za700za7za7_1973za7, "unattached thread", 17 );
DEFINE_STRING( BGl_string1909z00zz__ft_threadz00, BgL_bgl_string1909za700za7za7_1974za7, "no such thread", 14 );
DEFINE_STRING( BGl_string1910z00zz__ft_threadz00, BgL_bgl_string1910za700za7za7_1975za7, "thread-await*", 13 );
DEFINE_STRING( BGl_string1911z00zz__ft_threadz00, BgL_bgl_string1911za700za7za7_1976za7, "/builddir/build/BUILD/bigloo-4.3h/api/fthread/src/Llib/thread.scm", 65 );
DEFINE_STRING( BGl_string1912z00zz__ft_threadz00, BgL_bgl_string1912za700za7za7_1977za7, "&thread-await*!", 15 );
DEFINE_STRING( BGl_string1913z00zz__ft_threadz00, BgL_bgl_string1913za700za7za7_1978za7, "pair", 4 );
DEFINE_STRING( BGl_string1914z00zz__ft_threadz00, BgL_bgl_string1914za700za7za7_1979za7, "&thread-get-values*!", 20 );
DEFINE_STRING( BGl_string1915z00zz__ft_threadz00, BgL_bgl_string1915za700za7za7_1980za7, "&thread-await-values*!", 22 );
DEFINE_STRING( BGl_string1916z00zz__ft_threadz00, BgL_bgl_string1916za700za7za7_1981za7, "Unattached thread", 17 );
DEFINE_STRING( BGl_string1917z00zz__ft_threadz00, BgL_bgl_string1917za700za7za7_1982za7, "&thread-suspend!", 16 );
DEFINE_STRING( BGl_string1918z00zz__ft_threadz00, BgL_bgl_string1918za700za7za7_1983za7, "fthread", 7 );
DEFINE_STRING( BGl_string1919z00zz__ft_threadz00, BgL_bgl_string1919za700za7za7_1984za7, "&thread-resume!", 15 );
DEFINE_STRING( BGl_string1924z00zz__ft_threadz00, BgL_bgl_string1924za700za7za7_1985za7, "object-equal?", 13 );
DEFINE_STRING( BGl_string1926z00zz__ft_threadz00, BgL_bgl_string1926za700za7za7_1986za7, "thread-join!", 12 );
DEFINE_STRING( BGl_string1928z00zz__ft_threadz00, BgL_bgl_string1928za700za7za7_1987za7, "object-write", 12 );
DEFINE_STRING( BGl_string1930z00zz__ft_threadz00, BgL_bgl_string1930za700za7za7_1988za7, "thread-start!", 13 );
DEFINE_STRING( BGl_string1932z00zz__ft_threadz00, BgL_bgl_string1932za700za7za7_1989za7, "thread-terminate!", 17 );
DEFINE_STRING( BGl_string1934z00zz__ft_threadz00, BgL_bgl_string1934za700za7za7_1990za7, "thread-specific", 15 );
DEFINE_STRING( BGl_string1936z00zz__ft_threadz00, BgL_bgl_string1936za700za7za7_1991za7, "thread-specific-set!", 20 );
DEFINE_STRING( BGl_string1938z00zz__ft_threadz00, BgL_bgl_string1938za700za7za7_1992za7, "thread-cleanup", 14 );
DEFINE_STRING( BGl_string1940z00zz__ft_threadz00, BgL_bgl_string1940za700za7za7_1993za7, "thread-cleanup-set!", 19 );
DEFINE_STRING( BGl_string1941z00zz__ft_threadz00, BgL_bgl_string1941za700za7za7_1994za7, "thread already running", 22 );
DEFINE_STRING( BGl_string1942z00zz__ft_threadz00, BgL_bgl_string1942za700za7za7_1995za7, ">", 1 );
DEFINE_STRING( BGl_string1943z00zz__ft_threadz00, BgL_bgl_string1943za700za7za7_1996za7, " signals=", 9 );
DEFINE_STRING( BGl_string1944z00zz__ft_threadz00, BgL_bgl_string1944za700za7za7_1997za7, " timeout=", 9 );
DEFINE_STRING( BGl_string1945z00zz__ft_threadz00, BgL_bgl_string1945za700za7za7_1998za7, " state=", 7 );
DEFINE_STRING( BGl_string1946z00zz__ft_threadz00, BgL_bgl_string1946za700za7za7_1999za7, "#<fthread:", 10 );
DEFINE_STRING( BGl_string1947z00zz__ft_threadz00, BgL_bgl_string1947za700za7za7_2000za7, "thread-join", 11 );
DEFINE_STRING( BGl_string1948z00zz__ft_threadz00, BgL_bgl_string1948za700za7za7_2001za7, "integer", 7 );
DEFINE_STRING( BGl_string1949z00zz__ft_threadz00, BgL_bgl_string1949za700za7za7_2002za7, "__ft_thread", 11 );
DEFINE_STRING( BGl_string1950z00zz__ft_threadz00, BgL_bgl_string1950za700za7za7_2003za7, "dead terminated started thread-start! thread-terminate! __ft_thread join-timeout-exception thread-resume! thread-suspend! end init ", 131 );
BGL_IMPORT obj_t BGl_objectzd2equalzf3zd2envzf3zz__objectz00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_threadzd2getzd2valuesza2z12zd2envz62zz__ft_threadz00, BgL_bgl_za762threadza7d2getza72004za7, BGl_z62threadzd2getzd2valuesza2z12zd2zz__ft_threadz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_threadzd2suspendz12zd2envz12zz__ft_threadz00, BgL_bgl_za762threadza7d2susp2005z00, BGl_z62threadzd2suspendz12za2zz__ft_threadz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_threadzd2awaitza2z12zd2envzb0zz__ft_threadz00, BgL_bgl_za762threadza7d2awai2006z00, va_generic_entry, BGl_z62threadzd2awaitza2z12z00zz__ft_threadz00, BUNSPEC, -2 );
BGL_IMPORT obj_t BGl_threadzd2specificzd2setz12zd2envzc0zz__threadz00;
BGL_IMPORT obj_t BGl_threadzd2cleanupzd2setz12zd2envzc0zz__threadz00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_threadzd2awaitzd2valuesz12zd2envzc0zz__ft_threadz00, BgL_bgl_za762threadza7d2awai2007z00, va_generic_entry, BGl_z62threadzd2awaitzd2valuesz12z70zz__ft_threadz00, BUNSPEC, -2 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_joinzd2timeoutzd2exceptionz00zz__ft_threadz00) );
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__ft_threadz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__ft_threadz00(long BgL_checksumz00_749, char * BgL_fromz00_750)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__ft_threadz00))
{ 
BGl_requirezd2initializa7ationz75zz__ft_threadz00 = 
BBOOL(((bool_t)0)); 
BGL_GC_INIT(); 
BGl_gczd2rootszd2initz00zz__ft_threadz00(); 
BGl_libraryzd2moduleszd2initz00zz__ft_threadz00(); 
BGl_cnstzd2initzd2zz__ft_threadz00(); 
BGl_importedzd2moduleszd2initz00zz__ft_threadz00(); 
BGl_objectzd2initzd2zz__ft_threadz00(); 
BGl_methodzd2initzd2zz__ft_threadz00(); 
return 
BGl_toplevelzd2initzd2zz__ft_threadz00();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__ft_threadz00()
{
{ /* Llib/thread.scm 15 */
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "__ft_thread"); 
BGl_modulezd2initializa7ationz75zz__threadz00(((long)0), "__ft_thread"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__ft_thread"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long)0), "__ft_thread"); 
BGl_modulezd2initializa7ationz75zz__pth_threadz00(((long)0), "__ft_thread"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__ft_thread"); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "__ft_thread"); 
BGl_modulezd2initializa7ationz75zz__bexitz00(((long)0), "__ft_thread"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__ft_thread"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__ft_thread"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__ft_thread"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__ft_thread"); 
BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)0), "__ft_thread"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__ft_thread"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__ft_threadz00()
{
{ /* Llib/thread.scm 15 */
{ /* Llib/thread.scm 15 */
obj_t BgL_cportz00_649;
{ /* Llib/thread.scm 15 */
obj_t BgL_stringz00_657;
BgL_stringz00_657 = BGl_string1950z00zz__ft_threadz00; 
{ /* Llib/thread.scm 15 */
obj_t BgL_startz00_658;
BgL_startz00_658 = 
BINT(((long)0)); 
{ /* Llib/thread.scm 15 */
obj_t BgL_endz00_659;
BgL_endz00_659 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_657))); 
{ /* Llib/thread.scm 15 */

BgL_cportz00_649 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_657, BgL_startz00_658, BgL_endz00_659); } } } } 
{ 
long BgL_iz00_650;
BgL_iz00_650 = ((long)10); 
BgL_loopz00_651:
if(
(BgL_iz00_650==((long)-1)))
{ /* Llib/thread.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/thread.scm 15 */
{ /* Llib/thread.scm 15 */
obj_t BgL_arg1952z00_653;
{ /* Llib/thread.scm 15 */

{ /* Llib/thread.scm 15 */
obj_t BgL_locationz00_655;
BgL_locationz00_655 = 
BBOOL(((bool_t)0)); 
{ /* Llib/thread.scm 15 */

BgL_arg1952z00_653 = 
BGl_readz00zz__readerz00(BgL_cportz00_649, BgL_locationz00_655); } } } 
{ /* Llib/thread.scm 15 */
int BgL_tmpz00_785;
BgL_tmpz00_785 = 
(int)(BgL_iz00_650); 
CNST_TABLE_SET(BgL_tmpz00_785, BgL_arg1952z00_653); } } 
{ /* Llib/thread.scm 15 */
int BgL_auxz00_656;
BgL_auxz00_656 = 
(int)(
(BgL_iz00_650-((long)1))); 
{ 
long BgL_iz00_790;
BgL_iz00_790 = 
(long)(BgL_auxz00_656); 
BgL_iz00_650 = BgL_iz00_790; 
goto BgL_loopz00_651;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__ft_threadz00()
{
{ /* Llib/thread.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__ft_threadz00()
{
{ /* Llib/thread.scm 15 */
BGl_modulezd2initializa7ationz75zz__pth_threadz00(((long)0), 
BSTRING_TO_STRING(BGl_string1905z00zz__ft_threadz00)); 
return BUNSPEC;} 

}



/* thread-await! */
BGL_EXPORTED_DEF obj_t BGl_threadzd2awaitz12zc0zz__ft_threadz00(obj_t BgL_sigz00_7, obj_t BgL_argz00_8)
{
{ /* Llib/thread.scm 102 */
{ /* Llib/thread.scm 103 */
obj_t BgL_tz00_42;
BgL_tz00_42 = 
BGl_currentzd2threadzd2zz__threadz00(); 
{ /* Llib/thread.scm 103 */

{ 
BgL_schedulerz00_bglt BgL_scdlz00_79;obj_t BgL_sigz00_80;obj_t BgL_timeoutz00_81;BgL_schedulerz00_bglt BgL_scdlz00_53;obj_t BgL_sigz00_54;
if(
BGl_isazf3zf3zz__objectz00(BgL_tz00_42, BGl_threadz00zz__threadz00))
{ /* Llib/thread.scm 154 */
if(
BGl_z52threadzd2attachedzf3z73zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)
((BgL_threadz00_bglt)BgL_tz00_42))))
{ /* Llib/thread.scm 156 */
if(
PAIRP(BgL_argz00_8))
{ /* Llib/thread.scm 160 */
obj_t BgL_arg1166z00_49;obj_t BgL_arg1167z00_50;
BgL_arg1166z00_49 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)
((BgL_threadz00_bglt)BgL_tz00_42))))->BgL_schedulerz00); 
BgL_arg1167z00_50 = 
CAR(BgL_argz00_8); 
BgL_scdlz00_79 = 
((BgL_schedulerz00_bglt)BgL_arg1166z00_49); 
BgL_sigz00_80 = BgL_sigz00_7; 
BgL_timeoutz00_81 = BgL_arg1167z00_50; 
{ /* Llib/thread.scm 132 */
bool_t BgL_test2013z00_808;
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_timeoutz00_81))
{ /* Llib/thread.scm 132 */
if(
INTEGERP(BgL_timeoutz00_81))
{ /* Llib/thread.scm 132 */
BgL_test2013z00_808 = 
(
(long)CINT(BgL_timeoutz00_81)>((long)0))
; }  else 
{ /* Llib/thread.scm 132 */
BgL_test2013z00_808 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(BgL_timeoutz00_81, 
BINT(((long)0)))
; } }  else 
{ /* Llib/thread.scm 132 */
BgL_test2013z00_808 = ((bool_t)0)
; } 
if(BgL_test2013z00_808)
{ /* Llib/thread.scm 135 */
bool_t BgL_test2016z00_817;
{ /* Llib/thread.scm 135 */
obj_t BgL_arg1211z00_96;
BgL_arg1211z00_96 = 
(((BgL_schedulerz00_bglt)COBJECT(BgL_scdlz00_79))->BgL_envzb2zb2); 
BgL_test2016z00_817 = 
CBOOL(
BGl_signalzd2lookupzd2zz__ft_signalz00(BgL_sigz00_80, BgL_arg1211z00_96)); } 
if(BgL_test2016z00_817)
{ /* Llib/thread.scm 135 */
return 
BGl_signalzd2valuezd2zz__ft_signalz00(BgL_sigz00_80, 
(((BgL_schedulerz00_bglt)COBJECT(BgL_scdlz00_79))->BgL_envzb2zb2));}  else 
{ /* Llib/thread.scm 135 */
{ /* Llib/thread.scm 139 */
obj_t BgL_arg1204z00_90;
BgL_arg1204z00_90 = 
(((BgL_schedulerz00_bglt)COBJECT(BgL_scdlz00_79))->BgL_envzb2zb2); 
BGl_signalzd2registerzd2threadz12z12zz__ft_signalz00(BgL_sigz00_80, BgL_arg1204z00_90, 
((BgL_threadz00_bglt)BgL_tz00_42)); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_sigz00_80, BGl_z52sigasyncz52zz__ft_z52typesz52))
{ /* Llib/thread.scm 142 */
BGl_z52schedulerzd2spawnzd2asyncz52zz__ft_z52schedulerz52(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_79), 
((BgL_z52sigasyncz52_bglt)BgL_sigz00_80)); }  else 
{ /* Llib/thread.scm 142 */BFALSE; } 
BGl_z52threadzd2timeoutz12z92zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_tz00_42), 
CINT(BgL_timeoutz00_81)); 
{ /* Llib/thread.scm 147 */
bool_t BgL_test2018z00_834;
{ /* Llib/thread.scm 147 */
obj_t BgL_arg1210z00_95;
BgL_arg1210z00_95 = 
(((BgL_schedulerz00_bglt)COBJECT(BgL_scdlz00_79))->BgL_envzb2zb2); 
BgL_test2018z00_834 = 
CBOOL(
BGl_signalzd2lookupzd2zz__ft_signalz00(BgL_sigz00_80, BgL_arg1210z00_95)); } 
if(BgL_test2018z00_834)
{ /* Llib/thread.scm 147 */
return 
BGl_signalzd2valuezd2zz__ft_signalz00(BgL_sigz00_80, 
(((BgL_schedulerz00_bglt)COBJECT(BgL_scdlz00_79))->BgL_envzb2zb2));}  else 
{ /* Llib/thread.scm 147 */
return BFALSE;} } } }  else 
{ /* Llib/thread.scm 132 */
return 
BGl_errorz00zz__errorz00(BGl_string1906z00zz__ft_threadz00, BGl_string1907z00zz__ft_threadz00, BgL_timeoutz00_81);} } }  else 
{ /* Llib/thread.scm 163 */
obj_t BgL_arg1169z00_52;
BgL_arg1169z00_52 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)
((BgL_threadz00_bglt)BgL_tz00_42))))->BgL_schedulerz00); 
BgL_scdlz00_53 = 
((BgL_schedulerz00_bglt)BgL_arg1169z00_52); 
BgL_sigz00_54 = BgL_sigz00_7; 
{ /* Llib/thread.scm 108 */
bool_t BgL_test2019z00_845;
{ /* Llib/thread.scm 108 */
obj_t BgL_arg1195z00_78;
BgL_arg1195z00_78 = 
(((BgL_schedulerz00_bglt)COBJECT(BgL_scdlz00_53))->BgL_envzb2zb2); 
BgL_test2019z00_845 = 
CBOOL(
BGl_signalzd2lookupzd2zz__ft_signalz00(BgL_sigz00_54, BgL_arg1195z00_78)); } 
if(BgL_test2019z00_845)
{ /* Llib/thread.scm 108 */
return 
BGl_signalzd2valuezd2zz__ft_signalz00(BgL_sigz00_54, 
(((BgL_schedulerz00_bglt)COBJECT(BgL_scdlz00_53))->BgL_envzb2zb2));}  else 
{ /* Llib/thread.scm 111 */
bool_t BgL_test2020z00_851;
if(
BGl_isazf3zf3zz__objectz00(BgL_sigz00_54, BGl_z52sigasyncz52zz__ft_z52typesz52))
{ /* Llib/thread.scm 111 */
if(
(((BgL_z52sigasyncz52_bglt)COBJECT(
((BgL_z52sigasyncz52_bglt)BgL_sigz00_54)))->BgL_spawnedz00))
{ /* Llib/thread.scm 113 */
BgL_test2020z00_851 = ((bool_t)0)
; }  else 
{ /* Llib/thread.scm 113 */
BgL_test2020z00_851 = ((bool_t)1)
; } }  else 
{ /* Llib/thread.scm 111 */
BgL_test2020z00_851 = ((bool_t)0)
; } 
if(BgL_test2020z00_851)
{ /* Llib/thread.scm 111 */
((((BgL_z52sigasyncz52_bglt)COBJECT(
((BgL_z52sigasyncz52_bglt)BgL_sigz00_54)))->BgL_spawnedz00)=((bool_t)((bool_t)1)),BUNSPEC); 
{ /* Llib/thread.scm 118 */
obj_t BgL_arg1179z00_65;
BgL_arg1179z00_65 = 
(((BgL_z52sigasyncz52_bglt)COBJECT(
((BgL_z52sigasyncz52_bglt)BgL_sigz00_54)))->BgL_idz00); 
BGl_z52threadzd2asynchroniza7ez12z35zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_tz00_42), BgL_arg1179z00_65); } 
{ /* Llib/thread.scm 119 */
obj_t BgL_resz00_66;
{ /* Llib/thread.scm 119 */
obj_t BgL_exitd1084z00_67;
BgL_exitd1084z00_67 = 
BGL_EXITD_TOP_AS_OBJ(); 
{ /* Llib/thread.scm 121 */
obj_t BgL_zc3z04anonymousza31181ze3z87_542;
BgL_zc3z04anonymousza31181ze3z87_542 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31181ze3ze5zz__ft_threadz00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31181ze3z87_542, 
(int)(((long)0)), BgL_tz00_42); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1084z00_67, BgL_zc3z04anonymousza31181ze3z87_542); 
{ /* Llib/thread.scm 120 */
obj_t BgL_tmp1086z00_69;
{ /* Llib/thread.scm 120 */
obj_t BgL_fun1180z00_70;
BgL_fun1180z00_70 = 
(((BgL_z52sigasyncz52_bglt)COBJECT(
((BgL_z52sigasyncz52_bglt)BgL_sigz00_54)))->BgL_thunkz00); 
BgL_tmp1086z00_69 = 
PROCEDURE_ENTRY(BgL_fun1180z00_70)(BgL_fun1180z00_70, BEOA); } 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1084z00_67); 
BGl_z52threadzd2synchroniza7ez12z35zz__ft_z52threadz52(BgL_tz00_42); 
BgL_resz00_66 = BgL_tmp1086z00_69; } } } 
BGl_z52broadcastz12z40zz__ft_z52schedulerz52(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_53), BgL_sigz00_54, BgL_resz00_66); 
return BgL_resz00_66;} }  else 
{ /* Llib/thread.scm 111 */
{ /* Llib/thread.scm 126 */
obj_t BgL_arg1182z00_73;
BgL_arg1182z00_73 = 
(((BgL_schedulerz00_bglt)COBJECT(BgL_scdlz00_53))->BgL_envzb2zb2); 
BGl_signalzd2registerzd2threadz12z12zz__ft_signalz00(BgL_sigz00_54, BgL_arg1182z00_73, 
((BgL_threadz00_bglt)BgL_tz00_42)); } 
BGl_z52threadzd2cooperatez80zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_tz00_42)); 
return 
BGl_signalzd2valuezd2zz__ft_signalz00(BgL_sigz00_54, 
(((BgL_schedulerz00_bglt)COBJECT(BgL_scdlz00_53))->BgL_envzb2zb2));} } } } }  else 
{ /* Llib/thread.scm 156 */
return 
BGl_errorz00zz__errorz00(BGl_string1906z00zz__ft_threadz00, BGl_string1908z00zz__ft_threadz00, BgL_tz00_42);} }  else 
{ /* Llib/thread.scm 154 */
return 
BGl_errorz00zz__errorz00(BGl_string1906z00zz__ft_threadz00, BGl_string1909z00zz__ft_threadz00, BgL_tz00_42);} } } } } 

}



/* &thread-await! */
obj_t BGl_z62threadzd2awaitz12za2zz__ft_threadz00(obj_t BgL_envz00_543, obj_t BgL_sigz00_544, obj_t BgL_argz00_545)
{
{ /* Llib/thread.scm 102 */
return 
BGl_threadzd2awaitz12zc0zz__ft_threadz00(BgL_sigz00_544, BgL_argz00_545);} 

}



/* &<@anonymous:1181> */
obj_t BGl_z62zc3z04anonymousza31181ze3ze5zz__ft_threadz00(obj_t BgL_envz00_546)
{
{ /* Llib/thread.scm 119 */
return 
BGl_z52threadzd2synchroniza7ez12z35zz__ft_z52threadz52(
PROCEDURE_REF(BgL_envz00_546, 
(int)(((long)0))));} 

}



/* thread-await*! */
BGL_EXPORTED_DEF obj_t BGl_threadzd2awaitza2z12z62zz__ft_threadz00(obj_t BgL_sza2za2_9, obj_t BgL_argz00_10)
{
{ /* Llib/thread.scm 168 */
{ /* Llib/thread.scm 169 */
obj_t BgL_tz00_101;
BgL_tz00_101 = 
BGl_currentzd2threadzd2zz__threadz00(); 
{ /* Llib/thread.scm 169 */

{ 
obj_t BgL_eza2za2_143;obj_t BgL_sz00_144;obj_t BgL_timeoutz00_145;obj_t BgL_eza2za2_112;obj_t BgL_sz00_113;
if(
BGl_isazf3zf3zz__objectz00(BgL_tz00_101, BGl_threadz00zz__threadz00))
{ /* Llib/thread.scm 210 */
if(
BGl_z52threadzd2attachedzf3z73zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)
((BgL_threadz00_bglt)BgL_tz00_101))))
{ /* Llib/thread.scm 212 */
if(
PAIRP(BgL_argz00_10))
{ /* Llib/thread.scm 216 */
obj_t BgL_arg1218z00_108;obj_t BgL_arg1230z00_109;
BgL_arg1218z00_108 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)
((BgL_threadz00_bglt)BgL_tz00_101))))->BgL_schedulerz00); 
BgL_arg1230z00_109 = 
CAR(BgL_argz00_10); 
BgL_eza2za2_143 = BgL_sza2za2_9; 
BgL_sz00_144 = BgL_arg1218z00_108; 
BgL_timeoutz00_145 = BgL_arg1230z00_109; 
{ /* Llib/thread.scm 189 */
bool_t BgL_test2026z00_906;
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_timeoutz00_145))
{ /* Llib/thread.scm 189 */
if(
INTEGERP(BgL_timeoutz00_145))
{ /* Llib/thread.scm 189 */
BgL_test2026z00_906 = 
(
(long)CINT(BgL_timeoutz00_145)>=((long)0))
; }  else 
{ /* Llib/thread.scm 189 */
BgL_test2026z00_906 = 
BGl_2ze3zd3z30zz__r4_numbers_6_5z00(BgL_timeoutz00_145, 
BINT(((long)0)))
; } }  else 
{ /* Llib/thread.scm 189 */
BgL_test2026z00_906 = ((bool_t)0)
; } 
if(BgL_test2026z00_906)
{ /* Llib/thread.scm 191 */
obj_t BgL_g1094z00_151;
BgL_g1094z00_151 = 
CNST_TABLE_REF(((long)0)); 
{ 
obj_t BgL_esz00_153;obj_t BgL_stagez00_154;
BgL_esz00_153 = BgL_eza2za2_143; 
BgL_stagez00_154 = BgL_g1094z00_151; 
BgL_zc3z04anonymousza31336ze3z87_155:
if(
NULLP(BgL_esz00_153))
{ /* Llib/thread.scm 194 */
if(
(BgL_stagez00_154==
CNST_TABLE_REF(((long)0))))
{ /* Llib/thread.scm 195 */
{ /* Llib/thread.scm 197 */
BgL_schedulerz00_bglt BgL_i1096z00_159;
BgL_i1096z00_159 = 
((BgL_schedulerz00_bglt)
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_101)))->BgL_schedulerz00)); 
{ 
obj_t BgL_l1125z00_161;
BgL_l1125z00_161 = BgL_eza2za2_143; 
BgL_zc3z04anonymousza31341ze3z87_162:
if(
PAIRP(BgL_l1125z00_161))
{ /* Llib/thread.scm 198 */
{ /* Llib/thread.scm 199 */
obj_t BgL_ez00_164;
BgL_ez00_164 = 
CAR(BgL_l1125z00_161); 
{ /* Llib/thread.scm 199 */
obj_t BgL_arg1347z00_165;
BgL_arg1347z00_165 = 
(((BgL_schedulerz00_bglt)COBJECT(BgL_i1096z00_159))->BgL_envzb2zb2); 
BGl_signalzd2registerzd2threadz12z12zz__ft_signalz00(BgL_ez00_164, BgL_arg1347z00_165, 
((BgL_threadz00_bglt)BgL_tz00_101)); } } 
{ 
obj_t BgL_l1125z00_930;
BgL_l1125z00_930 = 
CDR(BgL_l1125z00_161); 
BgL_l1125z00_161 = BgL_l1125z00_930; 
goto BgL_zc3z04anonymousza31341ze3z87_162;} }  else 
{ /* Llib/thread.scm 198 */((bool_t)1); } } } 
BGl_z52threadzd2timeoutz12z92zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_tz00_101), 
CINT(BgL_timeoutz00_145)); 
{ 
obj_t BgL_stagez00_936;obj_t BgL_esz00_935;
BgL_esz00_935 = BgL_eza2za2_143; 
BgL_stagez00_936 = 
CNST_TABLE_REF(((long)1)); 
BgL_stagez00_154 = BgL_stagez00_936; 
BgL_esz00_153 = BgL_esz00_935; 
goto BgL_zc3z04anonymousza31336ze3z87_155;} }  else 
{ /* Llib/thread.scm 195 */
{ /* Llib/thread.scm 203 */
int BgL_res1798z00_454;
{ /* Llib/thread.scm 203 */
int BgL_tmpz00_938;
BgL_tmpz00_938 = 
(int)(((long)2)); 
BgL_res1798z00_454 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_938); } BgL_res1798z00_454; } 
{ /* Llib/thread.scm 203 */
int BgL_tmpz00_941;
BgL_tmpz00_941 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_941, BFALSE); } 
return BFALSE;} }  else 
{ /* Llib/thread.scm 204 */
bool_t BgL_test2032z00_944;
{ /* Llib/thread.scm 204 */
obj_t BgL_arg1506z00_178;obj_t BgL_arg1517z00_179;
BgL_arg1506z00_178 = 
CAR(
((obj_t)BgL_esz00_153)); 
BgL_arg1517z00_179 = 
(((BgL_schedulerz00_bglt)COBJECT(
((BgL_schedulerz00_bglt)BgL_sz00_144)))->BgL_envzb2zb2); 
BgL_test2032z00_944 = 
CBOOL(
BGl_signalzd2lookupzd2zz__ft_signalz00(BgL_arg1506z00_178, BgL_arg1517z00_179)); } 
if(BgL_test2032z00_944)
{ /* Llib/thread.scm 205 */
obj_t BgL_val0_1129z00_173;obj_t BgL_val1_1130z00_174;
{ /* Llib/thread.scm 205 */
obj_t BgL_arg1383z00_175;obj_t BgL_arg1384z00_176;
BgL_arg1383z00_175 = 
CAR(
((obj_t)BgL_esz00_153)); 
BgL_arg1384z00_176 = 
(((BgL_schedulerz00_bglt)COBJECT(
((BgL_schedulerz00_bglt)BgL_sz00_144)))->BgL_envzb2zb2); 
BgL_val0_1129z00_173 = 
BGl_signalzd2valuezd2zz__ft_signalz00(BgL_arg1383z00_175, BgL_arg1384z00_176); } 
BgL_val1_1130z00_174 = 
CAR(
((obj_t)BgL_esz00_153)); 
{ /* Llib/thread.scm 205 */
int BgL_res1799z00_458;
{ /* Llib/thread.scm 205 */
int BgL_tmpz00_958;
BgL_tmpz00_958 = 
(int)(((long)2)); 
BgL_res1799z00_458 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_958); } BgL_res1799z00_458; } 
{ /* Llib/thread.scm 205 */
int BgL_tmpz00_961;
BgL_tmpz00_961 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_961, BgL_val1_1130z00_174); } 
return BgL_val0_1129z00_173;}  else 
{ /* Llib/thread.scm 207 */
obj_t BgL_arg1505z00_177;
BgL_arg1505z00_177 = 
CDR(
((obj_t)BgL_esz00_153)); 
{ 
obj_t BgL_esz00_966;
BgL_esz00_966 = BgL_arg1505z00_177; 
BgL_esz00_153 = BgL_esz00_966; 
goto BgL_zc3z04anonymousza31336ze3z87_155;} } } } }  else 
{ /* Llib/thread.scm 189 */
return 
BGl_errorz00zz__errorz00(BGl_string1910z00zz__ft_threadz00, BGl_string1907z00zz__ft_threadz00, BgL_timeoutz00_145);} } }  else 
{ /* Llib/thread.scm 219 */
obj_t BgL_arg1231z00_111;
BgL_arg1231z00_111 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)
((BgL_threadz00_bglt)BgL_tz00_101))))->BgL_schedulerz00); 
BgL_eza2za2_112 = BgL_sza2za2_9; 
BgL_sz00_113 = BgL_arg1231z00_111; 
{ 
obj_t BgL_esz00_117;
BgL_esz00_117 = BgL_eza2za2_112; 
BgL_zc3z04anonymousza31233ze3z87_118:
if(
NULLP(BgL_esz00_117))
{ /* Llib/thread.scm 175 */
{ 
obj_t BgL_l1119z00_122;
BgL_l1119z00_122 = BgL_eza2za2_112; 
BgL_zc3z04anonymousza31235ze3z87_123:
if(
PAIRP(BgL_l1119z00_122))
{ /* Llib/thread.scm 177 */
{ /* Llib/thread.scm 178 */
obj_t BgL_ez00_125;
BgL_ez00_125 = 
CAR(BgL_l1119z00_122); 
{ /* Llib/thread.scm 178 */
obj_t BgL_arg1258z00_126;
BgL_arg1258z00_126 = 
(((BgL_schedulerz00_bglt)COBJECT(
((BgL_schedulerz00_bglt)BgL_sz00_113)))->BgL_envzb2zb2); 
BGl_signalzd2registerzd2threadz12z12zz__ft_signalz00(BgL_ez00_125, BgL_arg1258z00_126, 
((BgL_threadz00_bglt)BgL_tz00_101)); } } 
{ 
obj_t BgL_l1119z00_980;
BgL_l1119z00_980 = 
CDR(BgL_l1119z00_122); 
BgL_l1119z00_122 = BgL_l1119z00_980; 
goto BgL_zc3z04anonymousza31235ze3z87_123;} }  else 
{ /* Llib/thread.scm 177 */((bool_t)1); } } 
BGl_z52threadzd2cooperatez80zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_tz00_101)); 
{ /* Llib/thread.scm 182 */
obj_t BgL_val0_1121z00_130;obj_t BgL_val1_1122z00_131;
BgL_val0_1121z00_130 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_101)))->BgL_z52awakezd2valuez80); 
BgL_val1_1122z00_131 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_101)))->BgL_z52awakezd2signalz80); 
{ /* Llib/thread.scm 182 */
int BgL_res1792z00_441;
{ /* Llib/thread.scm 182 */
int BgL_tmpz00_988;
BgL_tmpz00_988 = 
(int)(((long)2)); 
BgL_res1792z00_441 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_988); } BgL_res1792z00_441; } 
{ /* Llib/thread.scm 182 */
int BgL_tmpz00_991;
BgL_tmpz00_991 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_991, BgL_val1_1122z00_131); } 
return BgL_val0_1121z00_130;} }  else 
{ /* Llib/thread.scm 183 */
bool_t BgL_test2035z00_994;
{ /* Llib/thread.scm 183 */
obj_t BgL_arg1326z00_140;obj_t BgL_arg1330z00_141;
BgL_arg1326z00_140 = 
CAR(
((obj_t)BgL_esz00_117)); 
BgL_arg1330z00_141 = 
(((BgL_schedulerz00_bglt)COBJECT(
((BgL_schedulerz00_bglt)BgL_sz00_113)))->BgL_envzb2zb2); 
BgL_test2035z00_994 = 
CBOOL(
BGl_signalzd2lookupzd2zz__ft_signalz00(BgL_arg1326z00_140, BgL_arg1330z00_141)); } 
if(BgL_test2035z00_994)
{ /* Llib/thread.scm 184 */
obj_t BgL_val0_1123z00_135;obj_t BgL_val1_1124z00_136;
{ /* Llib/thread.scm 184 */
obj_t BgL_arg1281z00_137;obj_t BgL_arg1300z00_138;
BgL_arg1281z00_137 = 
CAR(
((obj_t)BgL_esz00_117)); 
BgL_arg1300z00_138 = 
(((BgL_schedulerz00_bglt)COBJECT(
((BgL_schedulerz00_bglt)BgL_sz00_113)))->BgL_envzb2zb2); 
BgL_val0_1123z00_135 = 
BGl_signalzd2valuezd2zz__ft_signalz00(BgL_arg1281z00_137, BgL_arg1300z00_138); } 
BgL_val1_1124z00_136 = 
CAR(
((obj_t)BgL_esz00_117)); 
{ /* Llib/thread.scm 184 */
int BgL_res1793z00_445;
{ /* Llib/thread.scm 184 */
int BgL_tmpz00_1008;
BgL_tmpz00_1008 = 
(int)(((long)2)); 
BgL_res1793z00_445 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_1008); } BgL_res1793z00_445; } 
{ /* Llib/thread.scm 184 */
int BgL_tmpz00_1011;
BgL_tmpz00_1011 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_1011, BgL_val1_1124z00_136); } 
return BgL_val0_1123z00_135;}  else 
{ /* Llib/thread.scm 186 */
obj_t BgL_arg1325z00_139;
BgL_arg1325z00_139 = 
CDR(
((obj_t)BgL_esz00_117)); 
{ 
obj_t BgL_esz00_1016;
BgL_esz00_1016 = BgL_arg1325z00_139; 
BgL_esz00_117 = BgL_esz00_1016; 
goto BgL_zc3z04anonymousza31233ze3z87_118;} } } } } }  else 
{ /* Llib/thread.scm 212 */
return 
BGl_errorz00zz__errorz00(BGl_string1906z00zz__ft_threadz00, BGl_string1908z00zz__ft_threadz00, BgL_tz00_101);} }  else 
{ /* Llib/thread.scm 210 */
return 
BGl_errorz00zz__errorz00(BGl_string1906z00zz__ft_threadz00, BGl_string1909z00zz__ft_threadz00, BgL_tz00_101);} } } } } 

}



/* &thread-await*! */
obj_t BGl_z62threadzd2awaitza2z12z00zz__ft_threadz00(obj_t BgL_envz00_548, obj_t BgL_sza2za2_549, obj_t BgL_argz00_550)
{
{ /* Llib/thread.scm 168 */
{ /* Llib/thread.scm 169 */
obj_t BgL_auxz00_1019;
if(
PAIRP(BgL_sza2za2_549))
{ /* Llib/thread.scm 169 */
BgL_auxz00_1019 = BgL_sza2za2_549
; }  else 
{ 
obj_t BgL_auxz00_1022;
BgL_auxz00_1022 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1911z00zz__ft_threadz00, 
BINT(((long)6257)), BGl_string1912z00zz__ft_threadz00, BGl_string1913z00zz__ft_threadz00, BgL_sza2za2_549); 
FAILURE(BgL_auxz00_1022,BFALSE,BFALSE);} 
return 
BGl_threadzd2awaitza2z12z62zz__ft_threadz00(BgL_auxz00_1019, BgL_argz00_550);} } 

}



/* thread-get-values! */
BGL_EXPORTED_DEF obj_t BGl_threadzd2getzd2valuesz12z12zz__ft_threadz00(obj_t BgL_sz00_11)
{
{ /* Llib/thread.scm 224 */
{ /* Llib/thread.scm 225 */
obj_t BgL_tz00_185;
BgL_tz00_185 = 
BGl_currentzd2threadzd2zz__threadz00(); 
if(
BGl_isazf3zf3zz__objectz00(BgL_tz00_185, BGl_threadz00zz__threadz00))
{ /* Llib/thread.scm 226 */
BGl_z52threadzd2yieldz12z92zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)
((BgL_threadz00_bglt)BgL_tz00_185))); 
{ /* Llib/thread.scm 229 */
BgL_schedulerz00_bglt BgL_i1100z00_188;
BgL_i1100z00_188 = 
((BgL_schedulerz00_bglt)
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)
((BgL_threadz00_bglt)BgL_tz00_185))))->BgL_schedulerz00)); 
return 
BGl_signalzd2lastzd2valuesz00zz__ft_signalz00(BgL_sz00_11, 
(((BgL_schedulerz00_bglt)COBJECT(BgL_i1100z00_188))->BgL_envzb2zb2));} }  else 
{ /* Llib/thread.scm 226 */
return BFALSE;} } } 

}



/* &thread-get-values! */
obj_t BGl_z62threadzd2getzd2valuesz12z70zz__ft_threadz00(obj_t BgL_envz00_551, obj_t BgL_sz00_552)
{
{ /* Llib/thread.scm 224 */
return 
BGl_threadzd2getzd2valuesz12z12zz__ft_threadz00(BgL_sz00_552);} 

}



/* thread-get-values*! */
BGL_EXPORTED_DEF obj_t BGl_threadzd2getzd2valuesza2z12zb0zz__ft_threadz00(obj_t BgL_sza2za2_12)
{
{ /* Llib/thread.scm 235 */
{ /* Llib/thread.scm 236 */
obj_t BgL_tz00_190;
BgL_tz00_190 = 
BGl_currentzd2threadzd2zz__threadz00(); 
if(
BGl_isazf3zf3zz__objectz00(BgL_tz00_190, BGl_threadz00zz__threadz00))
{ /* Llib/thread.scm 237 */
BGl_z52threadzd2yieldz12z92zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)
((BgL_threadz00_bglt)BgL_tz00_190))); 
{ /* Llib/thread.scm 239 */
obj_t BgL_head1133z00_194;
{ /* Llib/thread.scm 239 */
obj_t BgL_res1802z00_463;
BgL_res1802z00_463 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1133z00_194 = BgL_res1802z00_463; } 
{ 
obj_t BgL_l1131z00_196;obj_t BgL_tail1134z00_197;
BgL_l1131z00_196 = BgL_sza2za2_12; 
BgL_tail1134z00_197 = BgL_head1133z00_194; 
BgL_zc3z04anonymousza31528ze3z87_198:
if(
NULLP(BgL_l1131z00_196))
{ /* Llib/thread.scm 239 */
return 
CDR(BgL_head1133z00_194);}  else 
{ /* Llib/thread.scm 239 */
obj_t BgL_newtail1135z00_200;
{ /* Llib/thread.scm 239 */
obj_t BgL_arg1545z00_202;
{ /* Llib/thread.scm 239 */
obj_t BgL_sz00_203;
BgL_sz00_203 = 
CAR(
((obj_t)BgL_l1131z00_196)); 
{ /* Llib/thread.scm 241 */
BgL_schedulerz00_bglt BgL_i1102z00_205;
BgL_i1102z00_205 = 
((BgL_schedulerz00_bglt)
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_190)))->BgL_schedulerz00)); 
BgL_arg1545z00_202 = 
MAKE_YOUNG_PAIR(BgL_sz00_203, 
BGl_signalzd2lastzd2valuesz00zz__ft_signalz00(BgL_sz00_203, 
(((BgL_schedulerz00_bglt)COBJECT(BgL_i1102z00_205))->BgL_envzb2zb2))); } } 
{ /* Llib/thread.scm 239 */
obj_t BgL_res1804z00_467;
BgL_res1804z00_467 = 
MAKE_YOUNG_PAIR(BgL_arg1545z00_202, BNIL); 
BgL_newtail1135z00_200 = BgL_res1804z00_467; } } 
SET_CDR(BgL_tail1134z00_197, BgL_newtail1135z00_200); 
{ /* Llib/thread.scm 239 */
obj_t BgL_arg1537z00_201;
BgL_arg1537z00_201 = 
CDR(
((obj_t)BgL_l1131z00_196)); 
{ 
obj_t BgL_tail1134z00_1063;obj_t BgL_l1131z00_1062;
BgL_l1131z00_1062 = BgL_arg1537z00_201; 
BgL_tail1134z00_1063 = BgL_newtail1135z00_200; 
BgL_tail1134z00_197 = BgL_tail1134z00_1063; 
BgL_l1131z00_196 = BgL_l1131z00_1062; 
goto BgL_zc3z04anonymousza31528ze3z87_198;} } } } } }  else 
{ /* Llib/thread.scm 237 */
return BFALSE;} } } 

}



/* &thread-get-values*! */
obj_t BGl_z62threadzd2getzd2valuesza2z12zd2zz__ft_threadz00(obj_t BgL_envz00_553, obj_t BgL_sza2za2_554)
{
{ /* Llib/thread.scm 235 */
{ /* Llib/thread.scm 236 */
obj_t BgL_auxz00_1064;
if(
PAIRP(BgL_sza2za2_554))
{ /* Llib/thread.scm 236 */
BgL_auxz00_1064 = BgL_sza2za2_554
; }  else 
{ 
obj_t BgL_auxz00_1067;
BgL_auxz00_1067 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1911z00zz__ft_threadz00, 
BINT(((long)8676)), BGl_string1914z00zz__ft_threadz00, BGl_string1913z00zz__ft_threadz00, BgL_sza2za2_554); 
FAILURE(BgL_auxz00_1067,BFALSE,BFALSE);} 
return 
BGl_threadzd2getzd2valuesza2z12zb0zz__ft_threadz00(BgL_auxz00_1064);} } 

}



/* thread-await-values! */
BGL_EXPORTED_DEF obj_t BGl_threadzd2awaitzd2valuesz12z12zz__ft_threadz00(obj_t BgL_sz00_13, obj_t BgL_tmtz00_14)
{
{ /* Llib/thread.scm 248 */
{ /* Llib/thread.scm 249 */
obj_t BgL_runner1550z00_470;
{ /* Llib/thread.scm 249 */
obj_t BgL_list1548z00_471;
BgL_list1548z00_471 = 
MAKE_YOUNG_PAIR(BgL_tmtz00_14, BNIL); 
BgL_runner1550z00_470 = 
BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(BgL_sz00_13, BgL_list1548z00_471); } 
{ /* Llib/thread.scm 249 */
obj_t BgL_aux1549z00_472;
BgL_aux1549z00_472 = 
CAR(BgL_runner1550z00_470); 
BgL_runner1550z00_470 = 
CDR(BgL_runner1550z00_470); 
BGl_threadzd2awaitz12zc0zz__ft_threadz00(BgL_aux1549z00_472, BgL_runner1550z00_470); } } 
return 
BGl_threadzd2getzd2valuesz12z12zz__ft_threadz00(BgL_sz00_13);} 

}



/* &thread-await-values! */
obj_t BGl_z62threadzd2awaitzd2valuesz12z70zz__ft_threadz00(obj_t BgL_envz00_555, obj_t BgL_sz00_556, obj_t BgL_tmtz00_557)
{
{ /* Llib/thread.scm 248 */
return 
BGl_threadzd2awaitzd2valuesz12z12zz__ft_threadz00(BgL_sz00_556, BgL_tmtz00_557);} 

}



/* thread-await-values*! */
BGL_EXPORTED_DEF obj_t BGl_threadzd2awaitzd2valuesza2z12zb0zz__ft_threadz00(obj_t BgL_sza2za2_15, obj_t BgL_tmtz00_16)
{
{ /* Llib/thread.scm 255 */
{ /* Llib/thread.scm 256 */
obj_t BgL_runner1553z00_475;
{ /* Llib/thread.scm 256 */
obj_t BgL_list1551z00_476;
BgL_list1551z00_476 = 
MAKE_YOUNG_PAIR(BgL_tmtz00_16, BNIL); 
BgL_runner1553z00_475 = 
BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(BgL_sza2za2_15, BgL_list1551z00_476); } 
{ /* Llib/thread.scm 256 */
obj_t BgL_aux1552z00_477;
BgL_aux1552z00_477 = 
CAR(BgL_runner1553z00_475); 
BgL_runner1553z00_475 = 
CDR(BgL_runner1553z00_475); 
BGl_threadzd2awaitza2z12z62zz__ft_threadz00(BgL_aux1552z00_477, BgL_runner1553z00_475); } } 
return 
BGl_threadzd2getzd2valuesza2z12zb0zz__ft_threadz00(BgL_sza2za2_15);} 

}



/* &thread-await-values*! */
obj_t BGl_z62threadzd2awaitzd2valuesza2z12zd2zz__ft_threadz00(obj_t BgL_envz00_558, obj_t BgL_sza2za2_559, obj_t BgL_tmtz00_560)
{
{ /* Llib/thread.scm 255 */
{ /* Llib/thread.scm 256 */
obj_t BgL_auxz00_1085;
if(
PAIRP(BgL_sza2za2_559))
{ /* Llib/thread.scm 256 */
BgL_auxz00_1085 = BgL_sza2za2_559
; }  else 
{ 
obj_t BgL_auxz00_1088;
BgL_auxz00_1088 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1911z00zz__ft_threadz00, 
BINT(((long)9537)), BGl_string1915z00zz__ft_threadz00, BGl_string1913z00zz__ft_threadz00, BgL_sza2za2_559); 
FAILURE(BgL_auxz00_1088,BFALSE,BFALSE);} 
return 
BGl_threadzd2awaitzd2valuesza2z12zb0zz__ft_threadz00(BgL_auxz00_1085, BgL_tmtz00_560);} } 

}



/* thread-suspend/resume! */
obj_t BGl_threadzd2suspendzf2resumez12z32zz__ft_threadz00(BgL_fthreadz00_bglt BgL_tz00_22, obj_t BgL_whoz00_23, bool_t BgL_valz00_24)
{
{ /* Llib/thread.scm 336 */
if(
BGl_z52threadzd2attachedzf3z73zz__ft_z52threadz52(BgL_tz00_22))
{ /* Llib/thread.scm 341 */
bool_t BgL_test2043z00_1095;
if(
BGl_z52threadzd2iszd2toterminatez52zz__ft_z52threadz52(BgL_tz00_22, BNIL))
{ /* Llib/thread.scm 341 */
BgL_test2043z00_1095 = ((bool_t)1)
; }  else 
{ /* Llib/thread.scm 341 */
if(
BGl_z52threadzd2iszd2terminatedz52zz__ft_z52threadz52(BgL_tz00_22, BNIL))
{ /* Llib/thread.scm 342 */
BgL_test2043z00_1095 = ((bool_t)1)
; }  else 
{ /* Llib/thread.scm 342 */
BgL_test2043z00_1095 = 
BGl_z52threadzd2iszd2deadz52zz__ft_z52threadz52(BgL_tz00_22, BNIL)
; } } 
if(BgL_test2043z00_1095)
{ /* Llib/thread.scm 341 */
return BUNSPEC;}  else 
{ /* Llib/thread.scm 350 */
BgL_z52schedulerz52_bglt BgL_i1111z00_225;
BgL_i1111z00_225 = 
((BgL_z52schedulerz52_bglt)
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_22))->BgL_schedulerz00)); 
{ 
obj_t BgL_auxz00_1103;
{ /* Llib/thread.scm 351 */
obj_t BgL_arg1577z00_226;obj_t BgL_arg1578z00_227;
BgL_arg1577z00_226 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_tz00_22), 
BBOOL(BgL_valz00_24)); 
BgL_arg1578z00_227 = 
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1111z00_225))->BgL_tosuspendzf2resumezf2); 
BgL_auxz00_1103 = 
MAKE_YOUNG_PAIR(BgL_arg1577z00_226, BgL_arg1578z00_227); } 
return 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1111z00_225))->BgL_tosuspendzf2resumezf2)=((obj_t)BgL_auxz00_1103),BUNSPEC);} } }  else 
{ /* Llib/thread.scm 338 */
return 
BGl_errorz00zz__errorz00(BgL_whoz00_23, BGl_string1916z00zz__ft_threadz00, 
((obj_t)BgL_tz00_22));} } 

}



/* thread-suspend! */
BGL_EXPORTED_DEF obj_t BGl_threadzd2suspendz12zc0zz__ft_threadz00(BgL_fthreadz00_bglt BgL_tz00_25)
{
{ /* Llib/thread.scm 356 */
return 
BGl_threadzd2suspendzf2resumez12z32zz__ft_threadz00(BgL_tz00_25, 
CNST_TABLE_REF(((long)2)), ((bool_t)1));} 

}



/* &thread-suspend! */
obj_t BGl_z62threadzd2suspendz12za2zz__ft_threadz00(obj_t BgL_envz00_561, obj_t BgL_tz00_562)
{
{ /* Llib/thread.scm 356 */
{ /* Llib/thread.scm 357 */
BgL_fthreadz00_bglt BgL_auxz00_1114;
if(
BGl_isazf3zf3zz__objectz00(BgL_tz00_562, BGl_fthreadz00zz__ft_typesz00))
{ /* Llib/thread.scm 357 */
BgL_auxz00_1114 = 
((BgL_fthreadz00_bglt)BgL_tz00_562)
; }  else 
{ 
obj_t BgL_auxz00_1118;
BgL_auxz00_1118 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1911z00zz__ft_threadz00, 
BINT(((long)14001)), BGl_string1917z00zz__ft_threadz00, BGl_string1918z00zz__ft_threadz00, BgL_tz00_562); 
FAILURE(BgL_auxz00_1118,BFALSE,BFALSE);} 
return 
BGl_threadzd2suspendz12zc0zz__ft_threadz00(BgL_auxz00_1114);} } 

}



/* thread-resume! */
BGL_EXPORTED_DEF obj_t BGl_threadzd2resumez12zc0zz__ft_threadz00(BgL_fthreadz00_bglt BgL_tz00_26)
{
{ /* Llib/thread.scm 362 */
return 
BGl_threadzd2suspendzf2resumez12z32zz__ft_threadz00(BgL_tz00_26, 
CNST_TABLE_REF(((long)3)), ((bool_t)0));} 

}



/* &thread-resume! */
obj_t BGl_z62threadzd2resumez12za2zz__ft_threadz00(obj_t BgL_envz00_563, obj_t BgL_tz00_564)
{
{ /* Llib/thread.scm 362 */
{ /* Llib/thread.scm 363 */
BgL_fthreadz00_bglt BgL_auxz00_1125;
if(
BGl_isazf3zf3zz__objectz00(BgL_tz00_564, BGl_fthreadz00zz__ft_typesz00))
{ /* Llib/thread.scm 363 */
BgL_auxz00_1125 = 
((BgL_fthreadz00_bglt)BgL_tz00_564)
; }  else 
{ 
obj_t BgL_auxz00_1129;
BgL_auxz00_1129 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1911z00zz__ft_threadz00, 
BINT(((long)14302)), BGl_string1919z00zz__ft_threadz00, BGl_string1918z00zz__ft_threadz00, BgL_tz00_564); 
FAILURE(BgL_auxz00_1129,BFALSE,BFALSE);} 
return 
BGl_threadzd2resumez12zc0zz__ft_threadz00(BgL_auxz00_1125);} } 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__ft_threadz00()
{
{ /* Llib/thread.scm 15 */
{ /* Llib/thread.scm 31 */
obj_t BgL_arg1612z00_236;obj_t BgL_arg1613z00_237;
{ /* Llib/thread.scm 31 */
obj_t BgL_v1136z00_250;
BgL_v1136z00_250 = 
create_vector(((long)0)); 
BgL_arg1612z00_236 = BgL_v1136z00_250; } 
{ /* Llib/thread.scm 31 */
obj_t BgL_v1137z00_251;
BgL_v1137z00_251 = 
create_vector(((long)0)); 
BgL_arg1613z00_237 = BgL_v1137z00_251; } 
return ( 
BGl_joinzd2timeoutzd2exceptionz00zz__ft_threadz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)4)), 
CNST_TABLE_REF(((long)5)), BGl_z62exceptionz62zz__objectz00, ((long)60410), BGl_proc1922z00zz__ft_threadz00, BGl_proc1921z00zz__ft_threadz00, BFALSE, BGl_proc1920z00zz__ft_threadz00, BFALSE, BgL_arg1612z00_236, BgL_arg1613z00_237), BUNSPEC) ;} } 

}



/* &<@anonymous:1622> */
obj_t BGl_z62zc3z04anonymousza31622ze3ze5zz__ft_threadz00(obj_t BgL_envz00_568, obj_t BgL_new1066z00_569)
{
{ /* Llib/thread.scm 31 */
{ 
BgL_joinzd2timeoutzd2exceptionz00_bglt BgL_auxz00_1139;
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)
((BgL_joinzd2timeoutzd2exceptionz00_bglt)BgL_new1066z00_569))))->BgL_fnamez00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)
((BgL_joinzd2timeoutzd2exceptionz00_bglt)BgL_new1066z00_569))))->BgL_locationz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)
((BgL_joinzd2timeoutzd2exceptionz00_bglt)BgL_new1066z00_569))))->BgL_stackz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_1139 = 
((BgL_joinzd2timeoutzd2exceptionz00_bglt)BgL_new1066z00_569); 
return 
((obj_t)BgL_auxz00_1139);} } 

}



/* &lambda1617 */
BgL_joinzd2timeoutzd2exceptionz00_bglt BGl_z62lambda1617z62zz__ft_threadz00(obj_t BgL_envz00_570)
{
{ /* Llib/thread.scm 31 */
{ /* Llib/thread.scm 31 */
BgL_joinzd2timeoutzd2exceptionz00_bglt BgL_new1065z00_663;
BgL_new1065z00_663 = 
((BgL_joinzd2timeoutzd2exceptionz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_joinzd2timeoutzd2exceptionz00_bgl) ))); 
{ /* Llib/thread.scm 31 */
long BgL_arg1621z00_664;
{ /* Llib/thread.scm 31 */
long BgL_res1806z00_665;
BgL_res1806z00_665 = 
BGL_CLASS_INDEX(BGl_joinzd2timeoutzd2exceptionz00zz__ft_threadz00); 
BgL_arg1621z00_664 = BgL_res1806z00_665; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1065z00_663), BgL_arg1621z00_664); } 
return BgL_new1065z00_663;} } 

}



/* &lambda1614 */
BgL_joinzd2timeoutzd2exceptionz00_bglt BGl_z62lambda1614z62zz__ft_threadz00(obj_t BgL_envz00_571, obj_t BgL_fname1062z00_572, obj_t BgL_location1063z00_573, obj_t BgL_stack1064z00_574)
{
{ /* Llib/thread.scm 31 */
{ /* Llib/thread.scm 31 */
BgL_joinzd2timeoutzd2exceptionz00_bglt BgL_new1117z00_666;
{ /* Llib/thread.scm 31 */
BgL_joinzd2timeoutzd2exceptionz00_bglt BgL_new1116z00_667;
BgL_new1116z00_667 = 
((BgL_joinzd2timeoutzd2exceptionz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_joinzd2timeoutzd2exceptionz00_bgl) ))); 
{ /* Llib/thread.scm 31 */
long BgL_arg1616z00_668;
{ /* Llib/thread.scm 31 */
long BgL_res1805z00_669;
BgL_res1805z00_669 = 
BGL_CLASS_INDEX(BGl_joinzd2timeoutzd2exceptionz00zz__ft_threadz00); 
BgL_arg1616z00_668 = BgL_res1805z00_669; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1116z00_667), BgL_arg1616z00_668); } 
BgL_new1117z00_666 = BgL_new1116z00_667; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1117z00_666)))->BgL_fnamez00)=((obj_t)BgL_fname1062z00_572),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1117z00_666)))->BgL_locationz00)=((obj_t)BgL_location1063z00_573),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1117z00_666)))->BgL_stackz00)=((obj_t)BgL_stack1064z00_574),BUNSPEC); 
return BgL_new1117z00_666;} } 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__ft_threadz00()
{
{ /* Llib/thread.scm 15 */
return BUNSPEC;} 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__ft_threadz00()
{
{ /* Llib/thread.scm 15 */
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_objectzd2equalzf3zd2envzf3zz__objectz00, BGl_z52sigjoinz52zz__ft_typesz00, BGl_proc1923z00zz__ft_threadz00, BGl_string1924z00zz__ft_threadz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_threadzd2joinz12zd2envz12zz__threadz00, BGl_fthreadz00zz__ft_typesz00, BGl_proc1925z00zz__ft_threadz00, BGl_string1926z00zz__ft_threadz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_objectzd2writezd2envz00zz__objectz00, BGl_fthreadz00zz__ft_typesz00, BGl_proc1927z00zz__ft_threadz00, BGl_string1928z00zz__ft_threadz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_threadzd2startz12zd2envz12zz__threadz00, BGl_fthreadz00zz__ft_typesz00, BGl_proc1929z00zz__ft_threadz00, BGl_string1930z00zz__ft_threadz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_threadzd2terminatez12zd2envz12zz__threadz00, BGl_fthreadz00zz__ft_typesz00, BGl_proc1931z00zz__ft_threadz00, BGl_string1932z00zz__ft_threadz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_threadzd2specificzd2envz00zz__threadz00, BGl_fthreadz00zz__ft_typesz00, BGl_proc1933z00zz__ft_threadz00, BGl_string1934z00zz__ft_threadz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_threadzd2specificzd2setz12zd2envzc0zz__threadz00, BGl_fthreadz00zz__ft_typesz00, BGl_proc1935z00zz__ft_threadz00, BGl_string1936z00zz__ft_threadz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_threadzd2cleanupzd2envz00zz__threadz00, BGl_fthreadz00zz__ft_typesz00, BGl_proc1937z00zz__ft_threadz00, BGl_string1938z00zz__ft_threadz00); 
return 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_threadzd2cleanupzd2setz12zd2envzc0zz__threadz00, BGl_fthreadz00zz__ft_typesz00, BGl_proc1939z00zz__ft_threadz00, BGl_string1940z00zz__ft_threadz00);} 

}



/* &thread-cleanup-set!-1158 */
obj_t BGl_z62threadzd2cleanupzd2setz12zd21158za2zz__ft_threadz00(obj_t BgL_envz00_585, obj_t BgL_thz00_586, obj_t BgL_vz00_587)
{
{ /* Llib/thread.scm 389 */
return 
((((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_thz00_586)))->BgL_z52cleanupz52)=((obj_t)BgL_vz00_587),BUNSPEC);} 

}



/* &thread-cleanup-fthre1156 */
obj_t BGl_z62threadzd2cleanupzd2fthre1156z62zz__ft_threadz00(obj_t BgL_envz00_588, obj_t BgL_thz00_589)
{
{ /* Llib/thread.scm 382 */
return 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_thz00_589)))->BgL_z52cleanupz52);} 

}



/* &thread-specific-set!1154 */
obj_t BGl_z62threadzd2specificzd2setz121154z70zz__ft_threadz00(obj_t BgL_envz00_590, obj_t BgL_thz00_591, obj_t BgL_vz00_592)
{
{ /* Llib/thread.scm 375 */
return 
((((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_thz00_591)))->BgL_z52specificz52)=((obj_t)BgL_vz00_592),BUNSPEC);} 

}



/* &thread-specific-fthr1152 */
obj_t BGl_z62threadzd2specificzd2fthr1152z62zz__ft_threadz00(obj_t BgL_envz00_593, obj_t BgL_thz00_594)
{
{ /* Llib/thread.scm 368 */
return 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_thz00_594)))->BgL_z52specificz52);} 

}



/* &thread-terminate!-ft1150 */
obj_t BGl_z62threadzd2terminatez12zd2ft1150z70zz__ft_threadz00(obj_t BgL_envz00_595, obj_t BgL_tz00_596)
{
{ /* Llib/thread.scm 304 */
if(
BGl_z52threadzd2attachedzf3z73zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_tz00_596)))
{ /* Llib/thread.scm 313 */
if(
BGl_z52threadzd2iszd2deadz52zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_tz00_596), BNIL))
{ /* Llib/thread.scm 316 */
return BUNSPEC;}  else 
{ /* Llib/thread.scm 316 */
if(
BGl_z52threadzd2iszd2toterminatez52zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_tz00_596), BNIL))
{ /* Llib/thread.scm 319 */
return BUNSPEC;}  else 
{ /* Llib/thread.scm 319 */
{ /* Llib/thread.scm 324 */
obj_t BgL_list1777z00_675;
BgL_list1777z00_675 = 
MAKE_YOUNG_PAIR(BTRUE, BNIL); 
BGl_z52threadzd2iszd2toterminatez52zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_tz00_596), BgL_list1777z00_675); } 
{ 
obj_t BgL_auxz00_1194;
{ /* Llib/thread.scm 326 */
BgL_terminatedzd2threadzd2exceptionz00_bglt BgL_new1108z00_676;
{ /* Llib/thread.scm 326 */
BgL_terminatedzd2threadzd2exceptionz00_bglt BgL_new1107z00_677;
BgL_new1107z00_677 = 
((BgL_terminatedzd2threadzd2exceptionz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_terminatedzd2threadzd2exceptionz00_bgl) ))); 
{ /* Llib/thread.scm 326 */
long BgL_arg1780z00_678;
{ /* Llib/thread.scm 326 */
long BgL_res1819z00_679;
{ /* Llib/thread.scm 326 */
obj_t BgL_classz00_680;
BgL_classz00_680 = BGl_terminatedzd2threadzd2exceptionz00zz__pth_threadz00; 
BgL_res1819z00_679 = 
BGL_CLASS_INDEX(BgL_classz00_680); } 
BgL_arg1780z00_678 = BgL_res1819z00_679; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1107z00_677), BgL_arg1780z00_678); } 
BgL_new1108z00_676 = BgL_new1107z00_677; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1108z00_676)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1108z00_676)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_1204;
{ /* Llib/thread.scm 326 */
obj_t BgL_arg1778z00_681;
{ /* Llib/thread.scm 326 */
obj_t BgL_arg1779z00_682;
{ /* Llib/thread.scm 326 */
obj_t BgL_res1820z00_683;
{ /* Llib/thread.scm 326 */
obj_t BgL_classz00_684;
BgL_classz00_684 = BGl_terminatedzd2threadzd2exceptionz00zz__pth_threadz00; 
BgL_res1820z00_683 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_684); } 
BgL_arg1779z00_682 = BgL_res1820z00_683; } 
BgL_arg1778z00_681 = 
VECTOR_REF(BgL_arg1779z00_682,((long)2)); } 
BgL_auxz00_1204 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1778z00_681); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1108z00_676)))->BgL_stackz00)=((obj_t)BgL_auxz00_1204),BUNSPEC); } 
BgL_auxz00_1194 = 
((obj_t)BgL_new1108z00_676); } 
((((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_596)))->BgL_z52exczd2resultz80)=((obj_t)BgL_auxz00_1194),BUNSPEC); } 
{ /* Llib/thread.scm 329 */
BgL_z52schedulerz52_bglt BgL_i1109z00_685;
BgL_i1109z00_685 = 
((BgL_z52schedulerz52_bglt)
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_596)))->BgL_schedulerz00)); 
{ 
obj_t BgL_auxz00_1215;
{ /* Llib/thread.scm 331 */
obj_t BgL_arg1781z00_686;
BgL_arg1781z00_686 = 
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1109z00_685))->BgL_toterminatez00); 
BgL_auxz00_1215 = 
MAKE_YOUNG_PAIR(
((obj_t)
((BgL_fthreadz00_bglt)BgL_tz00_596)), BgL_arg1781z00_686); } 
return 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1109z00_685))->BgL_toterminatez00)=((obj_t)BgL_auxz00_1215),BUNSPEC);} } } } }  else 
{ /* Llib/thread.scm 313 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)6)), BGl_string1916z00zz__ft_threadz00, 
((obj_t)
((BgL_fthreadz00_bglt)BgL_tz00_596)));} } 

}



/* &thread-start!-fthrea1148 */
obj_t BGl_z62threadzd2startz12zd2fthrea1148z70zz__ft_threadz00(obj_t BgL_envz00_597, obj_t BgL_tz00_598, obj_t BgL_oz00_599)
{
{ /* Llib/thread.scm 275 */
if(
BGl_z52threadzd2attachedzf3z73zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_tz00_598)))
{ /* Llib/thread.scm 281 */
return 
BGl_errorz00zz__errorz00(BGl_string1930z00zz__ft_threadz00, BGl_string1941z00zz__ft_threadz00, 
((obj_t)
((BgL_fthreadz00_bglt)BgL_tz00_598)));}  else 
{ /* Llib/thread.scm 283 */
BgL_schedulerz00_bglt BgL_scdlz00_688;
BgL_scdlz00_688 = 
BGl_z52getzd2optionalzd2schedulerz52zz__ft_z52schedulerz52(
CNST_TABLE_REF(((long)7)), BgL_oz00_599); 
((((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_598)))->BgL_schedulerz00)=((obj_t)
((obj_t)BgL_scdlz00_688)),BUNSPEC); 
((((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_598)))->BgL_z52builtinz52)=((obj_t)
BGl_z52pthreadzd2newz80zz__ft_z52pthreadz52(
((BgL_fthreadz00_bglt)BgL_tz00_598))),BUNSPEC); 
((((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_598)))->BgL_z52statez52)=((obj_t)
CNST_TABLE_REF(((long)8))),BUNSPEC); 
{ /* Llib/thread.scm 290 */
obj_t BgL_arg1767z00_689;
BgL_arg1767z00_689 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_598)))->BgL_z52builtinz52); 
BGl_threadzd2startz12zc0zz__threadz00(
((BgL_threadz00_bglt)BgL_arg1767z00_689), BNIL); } 
((((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_688)))->BgL_z52livezd2threadzd2numberz52)=((int)
(int)(
(((long)1)+
(long)(
(((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_688)))->BgL_z52livezd2threadzd2numberz52))))),BUNSPEC); 
{ 
obj_t BgL_auxz00_1254;
{ /* Llib/thread.scm 297 */
obj_t BgL_arg1770z00_690;
BgL_arg1770z00_690 = 
(((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_688)))->BgL_tostartz00); 
BgL_auxz00_1254 = 
MAKE_YOUNG_PAIR(
((obj_t)
((BgL_fthreadz00_bglt)BgL_tz00_598)), BgL_arg1770z00_690); } 
((((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_688)))->BgL_tostartz00)=((obj_t)BgL_auxz00_1254),BUNSPEC); } 
return 
((obj_t)
((BgL_fthreadz00_bglt)BgL_tz00_598));} } 

}



/* &object-write-fthread1146 */
obj_t BGl_z62objectzd2writezd2fthread1146z62zz__ft_threadz00(obj_t BgL_envz00_600, obj_t BgL_oz00_601, obj_t BgL_portz00_602)
{
{ /* Llib/thread.scm 262 */
{ /* Llib/thread.scm 263 */
obj_t BgL_arg1728z00_692;
if(
PAIRP(BgL_portz00_602))
{ /* Llib/thread.scm 263 */
BgL_arg1728z00_692 = 
CAR(BgL_portz00_602); }  else 
{ /* Llib/thread.scm 263 */
obj_t BgL_res1817z00_693;
{ /* Llib/thread.scm 263 */
obj_t BgL_tmpz00_1267;
BgL_tmpz00_1267 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_res1817z00_693 = 
BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_1267); } 
BgL_arg1728z00_692 = BgL_res1817z00_693; } 
{ /* Llib/thread.scm 265 */
obj_t BgL_zc3z04anonymousza31743ze3z87_694;
BgL_zc3z04anonymousza31743ze3z87_694 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31743ze3ze5zz__ft_threadz00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31743ze3z87_694, 
(int)(((long)0)), 
((obj_t)
((BgL_fthreadz00_bglt)BgL_oz00_601))); 
return 
BGl_withzd2outputzd2tozd2portzd2zz__r4_ports_6_10_1z00(BgL_arg1728z00_692, BgL_zc3z04anonymousza31743ze3z87_694);} } } 

}



/* &<@anonymous:1743> */
obj_t BGl_z62zc3z04anonymousza31743ze3ze5zz__ft_threadz00(obj_t BgL_envz00_603)
{
{ /* Llib/thread.scm 264 */
{ /* Llib/thread.scm 265 */
BgL_fthreadz00_bglt BgL_oz00_604;
BgL_oz00_604 = 
((BgL_fthreadz00_bglt)
PROCEDURE_REF(BgL_envz00_603, 
(int)(((long)0)))); 
{ /* Llib/thread.scm 266 */
obj_t BgL_arg1752z00_695;obj_t BgL_arg1753z00_696;int BgL_arg1754z00_697;obj_t BgL_arg1755z00_698;
BgL_arg1752z00_695 = 
(((BgL_threadz00_bglt)COBJECT(
((BgL_threadz00_bglt)BgL_oz00_604)))->BgL_namez00); 
BgL_arg1753z00_696 = 
(((BgL_fthreadz00_bglt)COBJECT(BgL_oz00_604))->BgL_z52statez52); 
BgL_arg1754z00_697 = 
(((BgL_fthreadz00_bglt)COBJECT(BgL_oz00_604))->BgL_z52timeoutz52); 
BgL_arg1755z00_698 = 
(((BgL_fthreadz00_bglt)COBJECT(BgL_oz00_604))->BgL_z52signalsz52); 
{ /* Llib/thread.scm 266 */
obj_t BgL_list1756z00_699;
{ /* Llib/thread.scm 266 */
obj_t BgL_arg1757z00_700;
{ /* Llib/thread.scm 266 */
obj_t BgL_arg1758z00_701;
{ /* Llib/thread.scm 266 */
obj_t BgL_arg1759z00_702;
{ /* Llib/thread.scm 266 */
obj_t BgL_arg1760z00_703;
{ /* Llib/thread.scm 266 */
obj_t BgL_arg1761z00_704;
{ /* Llib/thread.scm 266 */
obj_t BgL_arg1762z00_705;
{ /* Llib/thread.scm 266 */
obj_t BgL_arg1763z00_706;
{ /* Llib/thread.scm 266 */
obj_t BgL_arg1764z00_707;
BgL_arg1764z00_707 = 
MAKE_YOUNG_PAIR(BGl_string1942z00zz__ft_threadz00, BNIL); 
BgL_arg1763z00_706 = 
MAKE_YOUNG_PAIR(BgL_arg1755z00_698, BgL_arg1764z00_707); } 
BgL_arg1762z00_705 = 
MAKE_YOUNG_PAIR(BGl_string1943z00zz__ft_threadz00, BgL_arg1763z00_706); } 
BgL_arg1761z00_704 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1754z00_697), BgL_arg1762z00_705); } 
BgL_arg1760z00_703 = 
MAKE_YOUNG_PAIR(BGl_string1944z00zz__ft_threadz00, BgL_arg1761z00_704); } 
BgL_arg1759z00_702 = 
MAKE_YOUNG_PAIR(BgL_arg1753z00_696, BgL_arg1760z00_703); } 
BgL_arg1758z00_701 = 
MAKE_YOUNG_PAIR(BGl_string1945z00zz__ft_threadz00, BgL_arg1759z00_702); } 
BgL_arg1757z00_700 = 
MAKE_YOUNG_PAIR(BgL_arg1752z00_695, BgL_arg1758z00_701); } 
BgL_list1756z00_699 = 
MAKE_YOUNG_PAIR(BGl_string1946z00zz__ft_threadz00, BgL_arg1757z00_700); } 
return 
BGl_displayza2za2zz__r4_output_6_10_3z00(BgL_list1756z00_699);} } } } 

}



/* &thread-join!-fthread1144 */
obj_t BGl_z62threadzd2joinz12zd2fthread1144z70zz__ft_threadz00(obj_t BgL_envz00_605, obj_t BgL_tz00_606, obj_t BgL_argsz00_607)
{
{ /* Llib/thread.scm 54 */
{ /* Llib/thread.scm 56 */
bool_t BgL_test2053z00_1297;
if(
(
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_606)))->BgL_z52statez52)==
CNST_TABLE_REF(((long)9))))
{ /* Llib/thread.scm 56 */
BgL_test2053z00_1297 = ((bool_t)1)
; }  else 
{ /* Llib/thread.scm 56 */
BgL_test2053z00_1297 = 
(
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_606)))->BgL_z52statez52)==
CNST_TABLE_REF(((long)10)))
; } 
if(BgL_test2053z00_1297)
{ /* Llib/thread.scm 56 */
if(
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_606)))->BgL_z52exczd2raisedz80))
{ /* Llib/thread.scm 57 */
return 
BGl_raisez00zz__errorz00(
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_606)))->BgL_z52exczd2resultz80));}  else 
{ /* Llib/thread.scm 57 */
return 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_606)))->BgL_z52resultz52);} }  else 
{ 
obj_t BgL_toz00_737;obj_t BgL_tozd2valzd2_738;obj_t BgL_toz00_719;
if(
PAIRP(BgL_argsz00_607))
{ /* Llib/thread.scm 60 */
obj_t BgL_cdrzd2110zd2_747;
BgL_cdrzd2110zd2_747 = 
CDR(BgL_argsz00_607); 
if(
PAIRP(BgL_cdrzd2110zd2_747))
{ /* Llib/thread.scm 60 */
if(
NULLP(
CDR(BgL_cdrzd2110zd2_747)))
{ /* Llib/thread.scm 60 */
BgL_toz00_737 = 
CAR(BgL_argsz00_607); 
BgL_tozd2valzd2_738 = 
CAR(BgL_cdrzd2110zd2_747); 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_toz00_737))
{ /* Llib/thread.scm 64 */
obj_t BgL_vz00_739;
{ /* Llib/thread.scm 64 */
BgL_z52sigjoinz52_bglt BgL_arg1680z00_740;
{ /* Llib/thread.scm 64 */
BgL_z52sigjoinz52_bglt BgL_new1071z00_741;
{ /* Llib/thread.scm 65 */
BgL_z52sigjoinz52_bglt BgL_new1070z00_742;
BgL_new1070z00_742 = 
((BgL_z52sigjoinz52_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52sigjoinz52_bgl) ))); 
{ /* Llib/thread.scm 65 */
long BgL_arg1682z00_743;
{ /* Llib/thread.scm 65 */
long BgL_res1807z00_744;
BgL_res1807z00_744 = 
BGL_CLASS_INDEX(BGl_z52sigjoinz52zz__ft_typesz00); 
BgL_arg1682z00_743 = BgL_res1807z00_744; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1070z00_742), BgL_arg1682z00_743); } 
BgL_new1071z00_741 = BgL_new1070z00_742; } 
((((BgL_z52sigjoinz52_bglt)COBJECT(BgL_new1071z00_741))->BgL_threadz00)=((BgL_fthreadz00_bglt)
((BgL_fthreadz00_bglt)BgL_tz00_606)),BUNSPEC); 
BgL_arg1680z00_740 = BgL_new1071z00_741; } 
{ /* Llib/thread.scm 64 */
obj_t BgL_list1681z00_745;
BgL_list1681z00_745 = 
MAKE_YOUNG_PAIR(BgL_toz00_737, BNIL); 
BgL_vz00_739 = 
BGl_threadzd2awaitz12zc0zz__ft_threadz00(
((obj_t)BgL_arg1680z00_740), BgL_list1681z00_745); } } 
{ /* Llib/thread.scm 69 */
bool_t BgL_test2060z00_1334;
{ /* Llib/thread.scm 69 */
obj_t BgL_arg1679z00_746;
BgL_arg1679z00_746 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_606)))->BgL_z52exczd2resultz80); 
BgL_test2060z00_1334 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1679z00_746, BGl_terminatedzd2threadzd2exceptionz00zz__pth_threadz00); } 
if(BgL_test2060z00_1334)
{ /* Llib/thread.scm 69 */
return 
BGl_raisez00zz__errorz00(
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_606)))->BgL_z52exczd2resultz80));}  else 
{ /* Llib/thread.scm 69 */
if(
CBOOL(BgL_vz00_739))
{ /* Llib/thread.scm 71 */
return BgL_vz00_739;}  else 
{ /* Llib/thread.scm 71 */
return BgL_tozd2valzd2_738;} } } }  else 
{ /* Llib/thread.scm 62 */
return 
BGl_bigloozd2typezd2errorz00zz__errorz00(BGl_string1947z00zz__ft_threadz00, BGl_string1948z00zz__ft_threadz00, BgL_toz00_737);} }  else 
{ /* Llib/thread.scm 60 */
BgL_tagzd2103zd2_709:
{ /* Llib/thread.scm 90 */
obj_t BgL_vz00_712;
{ /* Llib/thread.scm 90 */
BgL_z52sigjoinz52_bglt BgL_arg1711z00_713;
{ /* Llib/thread.scm 90 */
BgL_z52sigjoinz52_bglt BgL_new1079z00_714;
{ /* Llib/thread.scm 91 */
BgL_z52sigjoinz52_bglt BgL_new1078z00_715;
BgL_new1078z00_715 = 
((BgL_z52sigjoinz52_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52sigjoinz52_bgl) ))); 
{ /* Llib/thread.scm 91 */
long BgL_arg1718z00_716;
{ /* Llib/thread.scm 91 */
long BgL_res1811z00_717;
BgL_res1811z00_717 = 
BGL_CLASS_INDEX(BGl_z52sigjoinz52zz__ft_typesz00); 
BgL_arg1718z00_716 = BgL_res1811z00_717; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1078z00_715), BgL_arg1718z00_716); } 
BgL_new1079z00_714 = BgL_new1078z00_715; } 
((((BgL_z52sigjoinz52_bglt)COBJECT(BgL_new1079z00_714))->BgL_threadz00)=((BgL_fthreadz00_bglt)
((BgL_fthreadz00_bglt)BgL_tz00_606)),BUNSPEC); 
BgL_arg1711z00_713 = BgL_new1079z00_714; } 
BgL_vz00_712 = 
BGl_threadzd2awaitz12zc0zz__ft_threadz00(
((obj_t)BgL_arg1711z00_713), BNIL); } 
{ /* Llib/thread.scm 94 */
bool_t BgL_test2062z00_1354;
{ /* Llib/thread.scm 94 */
obj_t BgL_arg1708z00_718;
BgL_arg1708z00_718 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_606)))->BgL_z52exczd2resultz80); 
BgL_test2062z00_1354 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1708z00_718, BGl_terminatedzd2threadzd2exceptionz00zz__pth_threadz00); } 
if(BgL_test2062z00_1354)
{ /* Llib/thread.scm 94 */
return 
BGl_raisez00zz__errorz00(
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_606)))->BgL_z52exczd2resultz80));}  else 
{ /* Llib/thread.scm 94 */
return BgL_vz00_712;} } } } }  else 
{ /* Llib/thread.scm 60 */
if(
NULLP(BgL_cdrzd2110zd2_747))
{ /* Llib/thread.scm 60 */
BgL_toz00_719 = 
CAR(BgL_argsz00_607); 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_toz00_719))
{ /* Llib/thread.scm 78 */
obj_t BgL_vz00_720;
{ /* Llib/thread.scm 78 */
BgL_z52sigjoinz52_bglt BgL_arg1697z00_721;
{ /* Llib/thread.scm 78 */
BgL_z52sigjoinz52_bglt BgL_new1074z00_722;
{ /* Llib/thread.scm 79 */
BgL_z52sigjoinz52_bglt BgL_new1073z00_723;
BgL_new1073z00_723 = 
((BgL_z52sigjoinz52_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52sigjoinz52_bgl) ))); 
{ /* Llib/thread.scm 79 */
long BgL_arg1699z00_724;
{ /* Llib/thread.scm 79 */
long BgL_res1808z00_725;
BgL_res1808z00_725 = 
BGL_CLASS_INDEX(BGl_z52sigjoinz52zz__ft_typesz00); 
BgL_arg1699z00_724 = BgL_res1808z00_725; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1073z00_723), BgL_arg1699z00_724); } 
BgL_new1074z00_722 = BgL_new1073z00_723; } 
((((BgL_z52sigjoinz52_bglt)COBJECT(BgL_new1074z00_722))->BgL_threadz00)=((BgL_fthreadz00_bglt)
((BgL_fthreadz00_bglt)BgL_tz00_606)),BUNSPEC); 
BgL_arg1697z00_721 = BgL_new1074z00_722; } 
{ /* Llib/thread.scm 78 */
obj_t BgL_list1698z00_726;
BgL_list1698z00_726 = 
MAKE_YOUNG_PAIR(BgL_toz00_719, BNIL); 
BgL_vz00_720 = 
BGl_threadzd2awaitz12zc0zz__ft_threadz00(
((obj_t)BgL_arg1697z00_721), BgL_list1698z00_726); } } 
{ /* Llib/thread.scm 83 */
bool_t BgL_test2065z00_1374;
{ /* Llib/thread.scm 83 */
obj_t BgL_arg1696z00_727;
BgL_arg1696z00_727 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_606)))->BgL_z52exczd2resultz80); 
BgL_test2065z00_1374 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1696z00_727, BGl_terminatedzd2threadzd2exceptionz00zz__pth_threadz00); } 
if(BgL_test2065z00_1374)
{ /* Llib/thread.scm 83 */
return 
BGl_raisez00zz__errorz00(
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_606)))->BgL_z52exczd2resultz80));}  else 
{ /* Llib/thread.scm 83 */
if(
CBOOL(BgL_vz00_720))
{ /* Llib/thread.scm 85 */
return BgL_vz00_720;}  else 
{ /* Llib/thread.scm 88 */
BgL_joinzd2timeoutzd2exceptionz00_bglt BgL_arg1687z00_728;
{ /* Llib/thread.scm 88 */
BgL_joinzd2timeoutzd2exceptionz00_bglt BgL_new1077z00_729;
{ /* Llib/thread.scm 88 */
BgL_joinzd2timeoutzd2exceptionz00_bglt BgL_new1076z00_730;
BgL_new1076z00_730 = 
((BgL_joinzd2timeoutzd2exceptionz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_joinzd2timeoutzd2exceptionz00_bgl) ))); 
{ /* Llib/thread.scm 88 */
long BgL_arg1695z00_731;
{ /* Llib/thread.scm 88 */
long BgL_res1809z00_732;
BgL_res1809z00_732 = 
BGL_CLASS_INDEX(BGl_joinzd2timeoutzd2exceptionz00zz__ft_threadz00); 
BgL_arg1695z00_731 = BgL_res1809z00_732; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1076z00_730), BgL_arg1695z00_731); } 
BgL_new1077z00_729 = BgL_new1076z00_730; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1077z00_729)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1077z00_729)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_1391;
{ /* Llib/thread.scm 88 */
obj_t BgL_arg1693z00_733;
{ /* Llib/thread.scm 88 */
obj_t BgL_arg1694z00_734;
{ /* Llib/thread.scm 88 */
obj_t BgL_res1810z00_735;
{ /* Llib/thread.scm 88 */
obj_t BgL_classz00_736;
BgL_classz00_736 = BGl_joinzd2timeoutzd2exceptionz00zz__ft_threadz00; 
BgL_res1810z00_735 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_736); } 
BgL_arg1694z00_734 = BgL_res1810z00_735; } 
BgL_arg1693z00_733 = 
VECTOR_REF(BgL_arg1694z00_734,((long)2)); } 
BgL_auxz00_1391 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1693z00_733); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1077z00_729)))->BgL_stackz00)=((obj_t)BgL_auxz00_1391),BUNSPEC); } 
BgL_arg1687z00_728 = BgL_new1077z00_729; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1687z00_728));} } } }  else 
{ /* Llib/thread.scm 76 */
return 
BGl_bigloozd2typezd2errorz00zz__errorz00(BGl_string1947z00zz__ft_threadz00, BGl_string1948z00zz__ft_threadz00, BgL_toz00_719);} }  else 
{ /* Llib/thread.scm 60 */
goto BgL_tagzd2103zd2_709;} } }  else 
{ /* Llib/thread.scm 60 */
goto BgL_tagzd2103zd2_709;} } } } 

}



/* &object-equal?-%sigjo1142 */
obj_t BGl_z62objectzd2equalzf3zd2z52sigjo1142zc3zz__ft_threadz00(obj_t BgL_envz00_608, obj_t BgL_o1z00_609, obj_t BgL_o2z00_610)
{
{ /* Llib/thread.scm 45 */
{ /* Llib/thread.scm 46 */
bool_t BgL_tmpz00_1401;
if(
BGl_isazf3zf3zz__objectz00(BgL_o2z00_610, BGl_z52sigjoinz52zz__ft_typesz00))
{ /* Llib/thread.scm 46 */
BgL_tmpz00_1401 = 
(
((obj_t)
(((BgL_z52sigjoinz52_bglt)COBJECT(
((BgL_z52sigjoinz52_bglt)BgL_o1z00_609)))->BgL_threadz00))==
((obj_t)
(((BgL_z52sigjoinz52_bglt)COBJECT(
((BgL_z52sigjoinz52_bglt)BgL_o2z00_610)))->BgL_threadz00)))
; }  else 
{ /* Llib/thread.scm 46 */
BgL_tmpz00_1401 = ((bool_t)0)
; } 
return 
BBOOL(BgL_tmpz00_1401);} } 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__ft_threadz00()
{
{ /* Llib/thread.scm 15 */
BGl_modulezd2initializa7ationz75zz__ft_typesz00(((long)414892275), 
BSTRING_TO_STRING(BGl_string1949z00zz__ft_threadz00)); 
BGl_modulezd2initializa7ationz75zz__ft_z52typesz52(((long)0), 
BSTRING_TO_STRING(BGl_string1949z00zz__ft_threadz00)); 
BGl_modulezd2initializa7ationz75zz__ft_z52threadz52(((long)536507091), 
BSTRING_TO_STRING(BGl_string1949z00zz__ft_threadz00)); 
BGl_modulezd2initializa7ationz75zz__ft_schedulerz00(((long)427827911), 
BSTRING_TO_STRING(BGl_string1949z00zz__ft_threadz00)); 
BGl_modulezd2initializa7ationz75zz__ft_z52schedulerz52(((long)398966270), 
BSTRING_TO_STRING(BGl_string1949z00zz__ft_threadz00)); 
BGl_modulezd2initializa7ationz75zz__ft_envz00(((long)360853603), 
BSTRING_TO_STRING(BGl_string1949z00zz__ft_threadz00)); 
BGl_modulezd2initializa7ationz75zz__ft_z52envz52(((long)471565054), 
BSTRING_TO_STRING(BGl_string1949z00zz__ft_threadz00)); 
BGl_modulezd2initializa7ationz75zz__ft_signalz00(((long)295111899), 
BSTRING_TO_STRING(BGl_string1949z00zz__ft_threadz00)); 
return 
BGl_modulezd2initializa7ationz75zz__ft_z52pthreadz52(((long)486293435), 
BSTRING_TO_STRING(BGl_string1949z00zz__ft_threadz00));} 

}

#ifdef __cplusplus
}
#endif
