/*===========================================================================*/
/*   (Llib/mpg123.scm)                                                       */
/*   Bigloo (4.3h)                                                           */
/*   Inria -- Sophia Antipolis (c)       Tue 12 May 2020 08:36:09 AM CEST    */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.3h/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.3h/lib/bigloo/4.3h -I Llib -lib-dir /builddir/build/BUILD/bigloo-4.3h/lib/bigloo/4.3h -unsafe -safee -srfi mpg123 -copt  -copt -fPIC -copt -IClib Llib/mpg123.scm -o objs/mpg123.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>
#include <mpg123.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_z62errorz62_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_fnamez00;
   obj_t BgL_locationz00;
   obj_t BgL_stackz00;
   obj_t BgL_procz00;
   obj_t BgL_msgz00;
   obj_t BgL_objz00;
} *BgL_z62errorz62_bglt;

typedef struct BgL_z62exceptionz62_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_fnamez00;
   obj_t BgL_locationz00;
   obj_t BgL_stackz00;
} *BgL_z62exceptionz62_bglt;

typedef struct BgL_mpg123zd2handlezd2_bgl {
   header_t header;
   obj_t widening;
   mpg123_handle * BgL_z42builtinz42;
   obj_t BgL_decoderz00;
   long BgL_siza7eza7;
} *BgL_mpg123zd2handlezd2_bglt;

typedef struct BgL_z62mpg123zd2errorzb0_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_fnamez00;
   obj_t BgL_locationz00;
   obj_t BgL_stackz00;
   obj_t BgL_procz00;
   obj_t BgL_msgz00;
   obj_t BgL_objz00;
} *BgL_z62mpg123zd2errorzb0_bglt;


BGL_IMPORT obj_t BGl_raisez00zz__errorz00(obj_t);
BGL_EXPORTED_DECL long BGl_mpg123zd2seekzd2zz__mpg123_mpg123z00(BgL_mpg123zd2handlezd2_bglt, long);
static obj_t BGl_z62mpg123zd2positionzb0zz__mpg123_mpg123z00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_z52z42mpg123zd2handlezd2nilz10zz__mpg123_mpg123z00();
static obj_t BGl_objectzd2initzd2zz__mpg123_mpg123z00();
BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__mpg123_mpg123z00();
static obj_t BGl_z62mpg123zd2seekzb0zz__mpg123_mpg123z00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpg123zd2decodezd2zz__mpg123_mpg123z00(BgL_mpg123zd2handlezd2_bglt, obj_t, long, long, obj_t, long);
static obj_t BGl_z62mpg123zd2getzd2formatz62zz__mpg123_mpg123z00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
static obj_t BGl_mpg123zd2formatzd2ze3symbolze3zz__mpg123_mpg123z00(obj_t);
static obj_t BGl_z62mpg123zd2paramzd2getz62zz__mpg123_mpg123z00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31615ze3ze5zz__mpg123_mpg123z00(obj_t);
extern long bgl_mpg123_position(mpg123_handle *);
static enum mpg123_parms BGl_symbolzd2ze3mpg123zd2paramze3zz__mpg123_mpg123z00(obj_t);
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__mpg123_mpg123z00();
static obj_t BGl_z62zc3z04anonymousza31561ze3ze5zz__mpg123_mpg123z00(obj_t, obj_t);
extern double bgl_mpg123_getvolume(mpg123_handle *);
static obj_t BGl_z62lambda1613z62zz__mpg123_mpg123z00(obj_t, obj_t);
static obj_t BGl_z62lambda1614z62zz__mpg123_mpg123z00(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpg123zd2handlezd2init1100z62zz__mpg123_mpg123z00(obj_t, obj_t);
BGL_IMPORT obj_t void_star_to_obj(void *);
BGL_EXPORTED_DECL long BGl_mpg123zd2infozd2zz__mpg123_mpg123z00(BgL_mpg123zd2handlezd2_bglt);
static obj_t BGl_z62lambda1625z62zz__mpg123_mpg123z00(obj_t, obj_t);
static obj_t BGl_z62lambda1626z62zz__mpg123_mpg123z00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31582ze3ze5zz__mpg123_mpg123z00(obj_t);
static BgL_z62mpg123zd2errorzb0_bglt BGl_z62lambda1651z62zz__mpg123_mpg123z00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_z62mpg123zd2errorzb0_bglt BGl_z62lambda1656z62zz__mpg123_mpg123z00(obj_t);
extern long bgl_mpg123_getformat(mpg123_handle *);
static obj_t BGl_z62mpg123zd2volumezd2setz12z70zz__mpg123_mpg123z00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31659ze3ze5zz__mpg123_mpg123z00(obj_t, obj_t);
static obj_t BGl_z62mpg123zd2handlezd2closez62zz__mpg123_mpg123z00(obj_t, obj_t);
static obj_t BGl_z62mpg123zd2decodezb0zz__mpg123_mpg123z00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zz__mpg123_mpg123z00 = BUNSPEC;
static obj_t BGl_z62mpg123zd2infozb0zz__mpg123_mpg123z00(obj_t, obj_t);
static obj_t BGl_z62mpg123zd2volumezd2getz62zz__mpg123_mpg123z00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpg123zd2getzd2formatz00zz__mpg123_mpg123z00(BgL_mpg123zd2handlezd2_bglt);
static obj_t BGl_z62mpg123zd2error1743zb0zz__mpg123_mpg123z00(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t, obj_t, obj_t);
extern obj_t bgl_mpg123_getparam(mpg123_handle *, enum mpg123_parms);
static obj_t BGl_toplevelzd2initzd2zz__mpg123_mpg123z00();
BGL_EXPORTED_DEF obj_t BGl_mpg123zd2handlezd2zz__mpg123_mpg123z00 = BUNSPEC;
BGL_EXPORTED_DECL long BGl_mpg123zd2positionzd2zz__mpg123_mpg123z00(BgL_mpg123zd2handlezd2_bglt);
BGL_IMPORT double BGl_roundflz00zz__r4_numbers_6_5_flonumz00(double);
static obj_t BGl_genericzd2initzd2zz__mpg123_mpg123z00();
BGL_IMPORT obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t, bool_t, bool_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpg123zd2handlezd2closez00zz__mpg123_mpg123z00(BgL_mpg123zd2handlezd2_bglt);
BGL_EXPORTED_DECL int bgl_mpg123_error(char *, char *, obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpg123zd2decodezd2statuszd2ze3symbolz53zz__mpg123_mpg123z00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpg123zd2volumezd2setz12z12zz__mpg123_mpg123z00(BgL_mpg123zd2handlezd2_bglt, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpg123zd2paramzd2getz00zz__mpg123_mpg123z00(BgL_mpg123zd2handlezd2_bglt, obj_t);
extern int bgl_mpg123_decode(obj_t, char *, long, long, char *, long);
extern long bgl_mpg123_info(mpg123_handle *);
BGL_IMPORT obj_t BGl_classzd2constructorzd2zz__objectz00(obj_t);
static obj_t BGl_z62mpg123zd2handlezd2resetz12z70zz__mpg123_mpg123z00(obj_t, obj_t);
static BgL_mpg123zd2handlezd2_bglt BGl_z62mpg123zd2handlezd2initz62zz__mpg123_mpg123z00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__mpg123_mpg123z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
BGL_EXPORTED_DECL obj_t BGl_mpg123zd2handlezd2resetz12z12zz__mpg123_mpg123z00(BgL_mpg123zd2handlezd2_bglt);
BGL_IMPORT obj_t BGl_z62errorz62zz__objectz00;
BGL_IMPORT obj_t BGl_tprintz00zz__r4_output_6_10_3z00(obj_t, obj_t);
static obj_t BGl_cnstzd2initzd2zz__mpg123_mpg123z00();
static obj_t BGl_libraryzd2moduleszd2initz00zz__mpg123_mpg123z00();
BGL_EXPORTED_DECL obj_t BGl_mpg123zd2volumezd2getz00zz__mpg123_mpg123z00(BgL_mpg123zd2handlezd2_bglt);
static obj_t BGl_z62zc3z04anonymousza31627ze3ze5zz__mpg123_mpg123z00(obj_t);
BGL_EXPORTED_DEF obj_t BGl_z62mpg123zd2errorzb0zz__mpg123_mpg123z00 = BUNSPEC;
BGL_IMPORT obj_t BGl_objectz00zz__objectz00;
BGL_IMPORT obj_t BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(obj_t);
static BgL_mpg123zd2handlezd2_bglt BGl_z62lambda1547z62zz__mpg123_mpg123z00(obj_t, obj_t, obj_t, obj_t);
static BgL_mpg123zd2handlezd2_bglt BGl_z62lambda1550z62zz__mpg123_mpg123z00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpg123zd2decodezd2statuszd2ze3symbolz31zz__mpg123_mpg123z00(int);
static obj_t BGl_z62lambda1580z62zz__mpg123_mpg123z00(obj_t, obj_t);
static obj_t BGl_z62lambda1581z62zz__mpg123_mpg123z00(obj_t, obj_t, obj_t);
static obj_t BGl_z62z52z42mpg123zd2handlezd2nilz72zz__mpg123_mpg123z00(obj_t);
BGL_EXPORTED_DECL BgL_mpg123zd2handlezd2_bglt BGl_mpg123zd2handlezd2initz00zz__mpg123_mpg123z00(BgL_mpg123zd2handlezd2_bglt);
extern mpg123_handle * bgl_mpg123_new(char *);
static obj_t __cnst[ 40 ] ;


DEFINE_EXPORT_BGL_PROCEDURE( BGl_mpg123zd2infozd2envz00zz__mpg123_mpg123z00, BgL_bgl_za762mpg123za7d2info1840z00, BGl_z62mpg123zd2infozb0zz__mpg123_mpg123z00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_mpg123zd2volumezd2getzd2envzd2zz__mpg123_mpg123z00, BgL_bgl_za762mpg123za7d2volu1841z00, BGl_z62mpg123zd2volumezd2getz62zz__mpg123_mpg123z00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1800z00zz__mpg123_mpg123z00, BgL_bgl_string1800za700za7za7_1842za7, "Unknown decode-status", 21 );
DEFINE_STRING( BGl_string1801z00zz__mpg123_mpg123z00, BgL_bgl_string1801za700za7za7_1843za7, "&mpg123-decode-status->symbol", 29 );
DEFINE_STRING( BGl_string1802z00zz__mpg123_mpg123z00, BgL_bgl_string1802za700za7za7_1844za7, "mpg123-format->alsa-format", 26 );
DEFINE_STRING( BGl_string1803z00zz__mpg123_mpg123z00, BgL_bgl_string1803za700za7za7_1845za7, "Unknown format", 14 );
DEFINE_STRING( BGl_string1804z00zz__mpg123_mpg123z00, BgL_bgl_string1804za700za7za7_1846za7, "&mpg123-param-get", 17 );
DEFINE_STRING( BGl_string1805z00zz__mpg123_mpg123z00, BgL_bgl_string1805za700za7za7_1847za7, "symbol", 6 );
DEFINE_STRING( BGl_string1806z00zz__mpg123_mpg123z00, BgL_bgl_string1806za700za7za7_1848za7, "mpg123-param->symbol", 20 );
DEFINE_STRING( BGl_string1807z00zz__mpg123_mpg123z00, BgL_bgl_string1807za700za7za7_1849za7, "unknown param", 13 );
DEFINE_STRING( BGl_string1808z00zz__mpg123_mpg123z00, BgL_bgl_string1808za700za7za7_1850za7, "&mpg123-info", 12 );
DEFINE_STRING( BGl_string1809z00zz__mpg123_mpg123z00, BgL_bgl_string1809za700za7za7_1851za7, "MPG123-SEEK, f=", 15 );
DEFINE_STRING( BGl_string1810z00zz__mpg123_mpg123z00, BgL_bgl_string1810za700za7za7_1852za7, ":", 1 );
DEFINE_STRING( BGl_string1811z00zz__mpg123_mpg123z00, BgL_bgl_string1811za700za7za7_1853za7, ",", 1 );
DEFINE_STRING( BGl_string1812z00zz__mpg123_mpg123z00, BgL_bgl_string1812za700za7za7_1854za7, "Llib/mpg123.scm", 15 );
DEFINE_STRING( BGl_string1813z00zz__mpg123_mpg123z00, BgL_bgl_string1813za700za7za7_1855za7, "MPG123-SEEK, o=", 15 );
DEFINE_STRING( BGl_string1814z00zz__mpg123_mpg123z00, BgL_bgl_string1814za700za7za7_1856za7, "&mpg123-seek", 12 );
DEFINE_STRING( BGl_string1815z00zz__mpg123_mpg123z00, BgL_bgl_string1815za700za7za7_1857za7, "Cannot get volume", 17 );
DEFINE_STRING( BGl_string1816z00zz__mpg123_mpg123z00, BgL_bgl_string1816za700za7za7_1858za7, "&mpg123-volume-get", 18 );
DEFINE_STRING( BGl_string1817z00zz__mpg123_mpg123z00, BgL_bgl_string1817za700za7za7_1859za7, "&mpg123-volume-set!", 19 );
DEFINE_STRING( BGl_string1834z00zz__mpg123_mpg123z00, BgL_bgl_string1834za700za7za7_1860za7, "mpg123-handle-init1100", 22 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_mpg123zd2errorzd2envz00zz__mpg123_mpg123z00, BgL_bgl_za762mpg123za7d2erro1861z00, BGl_z62mpg123zd2error1743zb0zz__mpg123_mpg123z00, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string1835z00zz__mpg123_mpg123z00, BgL_bgl_string1835za700za7za7_1862za7, "&mpg123-handle-init", 19 );
DEFINE_STRING( BGl_string1836z00zz__mpg123_mpg123z00, BgL_bgl_string1836za700za7za7_1863za7, "&mpg123-error __mpg123_mpg123 mpg123-handle long size obj decoder $mpg123-handle $builtin index-size resync-limit remove-flags timeout outscale icy-interval decode-frames start-frame upspeed downspeed rva down-sample force-rate add-flags flags verbose float64 float u32 s32 mu-law a-law s8 u8 u16 s16 done need-more err new-format ok ", 334 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_mpg123zd2decodezd2statuszd2ze3symbolzd2envze3zz__mpg123_mpg123z00, BgL_bgl_za762mpg123za7d2deco1864z00, BGl_z62mpg123zd2decodezd2statuszd2ze3symbolz53zz__mpg123_mpg123z00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52z42mpg123zd2handlezd2nilzd2envzc2zz__mpg123_mpg123z00, BgL_bgl_za762za752za742mpg123za71865z00, BGl_z62z52z42mpg123zd2handlezd2nilz72zz__mpg123_mpg123z00, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_mpg123zd2decodezd2envz00zz__mpg123_mpg123z00, BgL_bgl_za762mpg123za7d2deco1866z00, BGl_z62mpg123zd2decodezb0zz__mpg123_mpg123z00, 0L, BUNSPEC, 6 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_mpg123zd2seekzd2envz00zz__mpg123_mpg123z00, BgL_bgl_za762mpg123za7d2seek1867z00, BGl_z62mpg123zd2seekzb0zz__mpg123_mpg123z00, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_mpg123zd2handlezd2closezd2envzd2zz__mpg123_mpg123z00, BgL_bgl_za762mpg123za7d2hand1868z00, BGl_z62mpg123zd2handlezd2closez62zz__mpg123_mpg123z00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_mpg123zd2paramzd2getzd2envzd2zz__mpg123_mpg123z00, BgL_bgl_za762mpg123za7d2para1869z00, BGl_z62mpg123zd2paramzd2getz62zz__mpg123_mpg123z00, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_mpg123zd2handlezd2resetz12zd2envzc0zz__mpg123_mpg123z00, BgL_bgl_za762mpg123za7d2hand1870z00, BGl_z62mpg123zd2handlezd2resetz12z70zz__mpg123_mpg123z00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1818z00zz__mpg123_mpg123z00, BgL_bgl_za762za7c3za704anonymo1871za7, BGl_z62zc3z04anonymousza31582ze3ze5zz__mpg123_mpg123z00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1819z00zz__mpg123_mpg123z00, BgL_bgl_za762lambda1581za7621872z00, BGl_z62lambda1581z62zz__mpg123_mpg123z00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1820z00zz__mpg123_mpg123z00, BgL_bgl_za762lambda1580za7621873z00, BGl_z62lambda1580z62zz__mpg123_mpg123z00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1821z00zz__mpg123_mpg123z00, BgL_bgl_za762za7c3za704anonymo1874za7, BGl_z62zc3z04anonymousza31615ze3ze5zz__mpg123_mpg123z00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1822z00zz__mpg123_mpg123z00, BgL_bgl_za762lambda1614za7621875z00, BGl_z62lambda1614z62zz__mpg123_mpg123z00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1823z00zz__mpg123_mpg123z00, BgL_bgl_za762lambda1613za7621876z00, BGl_z62lambda1613z62zz__mpg123_mpg123z00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1824z00zz__mpg123_mpg123z00, BgL_bgl_za762za7c3za704anonymo1877za7, BGl_z62zc3z04anonymousza31627ze3ze5zz__mpg123_mpg123z00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1825z00zz__mpg123_mpg123z00, BgL_bgl_za762lambda1626za7621878z00, BGl_z62lambda1626z62zz__mpg123_mpg123z00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1826z00zz__mpg123_mpg123z00, BgL_bgl_za762lambda1625za7621879z00, BGl_z62lambda1625z62zz__mpg123_mpg123z00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1827z00zz__mpg123_mpg123z00, BgL_bgl_za762za7c3za704anonymo1880za7, BGl_z62zc3z04anonymousza31561ze3ze5zz__mpg123_mpg123z00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1828z00zz__mpg123_mpg123z00, BgL_bgl_za762lambda1550za7621881z00, BGl_z62lambda1550z62zz__mpg123_mpg123z00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1829z00zz__mpg123_mpg123z00, BgL_bgl_za762lambda1547za7621882z00, BGl_z62lambda1547z62zz__mpg123_mpg123z00, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1830z00zz__mpg123_mpg123z00, BgL_bgl_za762za7c3za704anonymo1883za7, BGl_z62zc3z04anonymousza31659ze3ze5zz__mpg123_mpg123z00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1831z00zz__mpg123_mpg123z00, BgL_bgl_za762lambda1656za7621884z00, BGl_z62lambda1656z62zz__mpg123_mpg123z00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1832z00zz__mpg123_mpg123z00, BgL_bgl_za762lambda1651za7621885z00, BGl_z62lambda1651z62zz__mpg123_mpg123z00, 0L, BUNSPEC, 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1833z00zz__mpg123_mpg123z00, BgL_bgl_za762mpg123za7d2hand1886z00, BGl_z62mpg123zd2handlezd2init1100z62zz__mpg123_mpg123z00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpg123zd2handlezd2initzd2envzd2zz__mpg123_mpg123z00, BgL_bgl_za762mpg123za7d2hand1887z00, BGl_z62mpg123zd2handlezd2initz62zz__mpg123_mpg123z00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1788z00zz__mpg123_mpg123z00, BgL_bgl_string1788za700za7za7_1888za7, "mpg123", 6 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_mpg123zd2volumezd2setz12zd2envzc0zz__mpg123_mpg123z00, BgL_bgl_za762mpg123za7d2volu1889z00, BGl_z62mpg123zd2volumezd2setz12z70zz__mpg123_mpg123z00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string1789z00zz__mpg123_mpg123z00, BgL_bgl_string1789za700za7za7_1890za7, "/builddir/build/BUILD/bigloo-4.3h/api/mpg123/src/Llib/mpg123.scm", 64 );
DEFINE_STRING( BGl_string1790z00zz__mpg123_mpg123z00, BgL_bgl_string1790za700za7za7_1891za7, "&mpg123-handle-close", 20 );
DEFINE_STRING( BGl_string1791z00zz__mpg123_mpg123z00, BgL_bgl_string1791za700za7za7_1892za7, "mpg123-handle", 13 );
DEFINE_STRING( BGl_string1792z00zz__mpg123_mpg123z00, BgL_bgl_string1792za700za7za7_1893za7, "&mpg123-handle-reset!", 21 );
DEFINE_STRING( BGl_string1793z00zz__mpg123_mpg123z00, BgL_bgl_string1793za700za7za7_1894za7, "&mpg123-error1743", 17 );
DEFINE_STRING( BGl_string1794z00zz__mpg123_mpg123z00, BgL_bgl_string1794za700za7za7_1895za7, "bstring", 7 );
DEFINE_STRING( BGl_string1795z00zz__mpg123_mpg123z00, BgL_bgl_string1795za700za7za7_1896za7, "&mpg123-decode", 14 );
DEFINE_STRING( BGl_string1796z00zz__mpg123_mpg123z00, BgL_bgl_string1796za700za7za7_1897za7, "bint", 4 );
DEFINE_STRING( BGl_string1797z00zz__mpg123_mpg123z00, BgL_bgl_string1797za700za7za7_1898za7, "&mpg123-get-format", 18 );
DEFINE_STRING( BGl_string1798z00zz__mpg123_mpg123z00, BgL_bgl_string1798za700za7za7_1899za7, "&mpg123-position", 16 );
DEFINE_STRING( BGl_string1799z00zz__mpg123_mpg123z00, BgL_bgl_string1799za700za7za7_1900za7, "mpg123-decode-status->symbol", 28 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_mpg123zd2positionzd2envz00zz__mpg123_mpg123z00, BgL_bgl_za762mpg123za7d2posi1901z00, BGl_z62mpg123zd2positionzb0zz__mpg123_mpg123z00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_mpg123zd2getzd2formatzd2envzd2zz__mpg123_mpg123z00, BgL_bgl_za762mpg123za7d2getza71902za7, BGl_z62mpg123zd2getzd2formatz62zz__mpg123_mpg123z00, 0L, BUNSPEC, 1 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__mpg123_mpg123z00) );
ADD_ROOT( (void *)(&BGl_mpg123zd2handlezd2zz__mpg123_mpg123z00) );
ADD_ROOT( (void *)(&BGl_z62mpg123zd2errorzb0zz__mpg123_mpg123z00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__mpg123_mpg123z00(long BgL_checksumz00_718, char * BgL_fromz00_719)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__mpg123_mpg123z00))
{ 
BGl_requirezd2initializa7ationz75zz__mpg123_mpg123z00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__mpg123_mpg123z00(); 
BGl_libraryzd2moduleszd2initz00zz__mpg123_mpg123z00(); 
BGl_cnstzd2initzd2zz__mpg123_mpg123z00(); 
BGl_objectzd2initzd2zz__mpg123_mpg123z00(); 
BGl_genericzd2initzd2zz__mpg123_mpg123z00(); 
return 
BGl_toplevelzd2initzd2zz__mpg123_mpg123z00();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__mpg123_mpg123z00()
{
{ /* Llib/mpg123.scm 15 */
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "__mpg123_mpg123"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__mpg123_mpg123"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(((long)0), "__mpg123_mpg123"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__mpg123_mpg123"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__mpg123_mpg123"); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "__mpg123_mpg123"); 
BGl_modulezd2initializa7ationz75zz__bitz00(((long)0), "__mpg123_mpg123"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__mpg123_mpg123"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long)0), "__mpg123_mpg123"); 
BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)0), "__mpg123_mpg123"); 
BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)0), "__mpg123_mpg123"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__mpg123_mpg123"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__mpg123_mpg123"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__mpg123_mpg123z00()
{
{ /* Llib/mpg123.scm 15 */
{ /* Llib/mpg123.scm 15 */
obj_t BgL_cportz00_676;
{ /* Llib/mpg123.scm 15 */
obj_t BgL_stringz00_684;
BgL_stringz00_684 = BGl_string1836z00zz__mpg123_mpg123z00; 
{ /* Llib/mpg123.scm 15 */
obj_t BgL_startz00_685;
BgL_startz00_685 = 
BINT(((long)0)); 
{ /* Llib/mpg123.scm 15 */
obj_t BgL_endz00_686;
BgL_endz00_686 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_684))); 
{ /* Llib/mpg123.scm 15 */

BgL_cportz00_676 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_684, BgL_startz00_685, BgL_endz00_686); } } } } 
{ 
long BgL_iz00_677;
BgL_iz00_677 = ((long)39); 
BgL_loopz00_678:
if(
(BgL_iz00_677==((long)-1)))
{ /* Llib/mpg123.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/mpg123.scm 15 */
{ /* Llib/mpg123.scm 15 */
obj_t BgL_arg1838z00_680;
{ /* Llib/mpg123.scm 15 */

{ /* Llib/mpg123.scm 15 */
obj_t BgL_locationz00_682;
BgL_locationz00_682 = 
BBOOL(((bool_t)0)); 
{ /* Llib/mpg123.scm 15 */

BgL_arg1838z00_680 = 
BGl_readz00zz__readerz00(BgL_cportz00_676, BgL_locationz00_682); } } } 
{ /* Llib/mpg123.scm 15 */
int BgL_tmpz00_751;
BgL_tmpz00_751 = 
(int)(BgL_iz00_677); 
CNST_TABLE_SET(BgL_tmpz00_751, BgL_arg1838z00_680); } } 
{ /* Llib/mpg123.scm 15 */
int BgL_auxz00_683;
BgL_auxz00_683 = 
(int)(
(BgL_iz00_677-((long)1))); 
{ 
long BgL_iz00_756;
BgL_iz00_756 = 
(long)(BgL_auxz00_683); 
BgL_iz00_677 = BgL_iz00_756; 
goto BgL_loopz00_678;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__mpg123_mpg123z00()
{
{ /* Llib/mpg123.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__mpg123_mpg123z00()
{
{ /* Llib/mpg123.scm 15 */
{ /* Llib/mpg123.scm 222 */
int BgL_errz00_32;
BgL_errz00_32 = 
mpg123_init(); 
if(
(
(long)(BgL_errz00_32)==
(long)(MPG123_OK)))
{ /* Llib/mpg123.scm 223 */
return BFALSE;}  else 
{ /* Llib/mpg123.scm 224 */
BgL_z62mpg123zd2errorzb0_bglt BgL_arg1103z00_34;
{ /* Llib/mpg123.scm 224 */
BgL_z62mpg123zd2errorzb0_bglt BgL_new1078z00_35;
{ /* Llib/mpg123.scm 224 */
BgL_z62mpg123zd2errorzb0_bglt BgL_new1077z00_38;
BgL_new1077z00_38 = 
((BgL_z62mpg123zd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62mpg123zd2errorzb0_bgl) ))); 
{ /* Llib/mpg123.scm 224 */
long BgL_arg1106z00_39;
{ /* Llib/mpg123.scm 224 */
long BgL_res1670z00_294;
BgL_res1670z00_294 = 
BGL_CLASS_INDEX(BGl_z62mpg123zd2errorzb0zz__mpg123_mpg123z00); 
BgL_arg1106z00_39 = BgL_res1670z00_294; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1077z00_38), BgL_arg1106z00_39); } 
BgL_new1078z00_35 = BgL_new1077z00_38; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1078z00_35)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1078z00_35)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_772;
{ /* Llib/mpg123.scm 224 */
obj_t BgL_arg1104z00_36;
{ /* Llib/mpg123.scm 224 */
obj_t BgL_arg1105z00_37;
{ /* Llib/mpg123.scm 224 */
obj_t BgL_res1671z00_298;
{ /* Llib/mpg123.scm 224 */
obj_t BgL_classz00_297;
BgL_classz00_297 = BGl_z62mpg123zd2errorzb0zz__mpg123_mpg123z00; 
BgL_res1671z00_298 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_297); } 
BgL_arg1105z00_37 = BgL_res1671z00_298; } 
BgL_arg1104z00_36 = 
VECTOR_REF(BgL_arg1105z00_37,((long)2)); } 
BgL_auxz00_772 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1104z00_36); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1078z00_35)))->BgL_stackz00)=((obj_t)BgL_auxz00_772),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1078z00_35)))->BgL_procz00)=((obj_t)BGl_string1788z00zz__mpg123_mpg123z00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1078z00_35)))->BgL_msgz00)=((obj_t)
string_to_bstring(
(char *)mpg123_plain_strerror(BgL_errz00_32))),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1078z00_35)))->BgL_objz00)=((obj_t)BFALSE),BUNSPEC); 
BgL_arg1103z00_34 = BgL_new1078z00_35; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1103z00_34));} } } 

}



/* %$mpg123-handle-nil */
BGL_EXPORTED_DEF obj_t BGl_z52z42mpg123zd2handlezd2nilz10zz__mpg123_mpg123z00()
{
{ /* Llib/mpg123.scm 48 */
return 
void_star_to_obj((mpg123_handle *)0L);} 

}



/* &%$mpg123-handle-nil */
obj_t BGl_z62z52z42mpg123zd2handlezd2nilz72zz__mpg123_mpg123z00(obj_t BgL_envz00_522)
{
{ /* Llib/mpg123.scm 48 */
return 
BGl_z52z42mpg123zd2handlezd2nilz10zz__mpg123_mpg123z00();} 

}



/* mpg123-handle-close */
BGL_EXPORTED_DEF obj_t BGl_mpg123zd2handlezd2closez00zz__mpg123_mpg123z00(BgL_mpg123zd2handlezd2_bglt BgL_oz00_4)
{
{ /* Llib/mpg123.scm 64 */
{ /* Llib/mpg123.scm 66 */
mpg123_handle * BgL_arg1113z00_301;
BgL_arg1113z00_301 = 
(((BgL_mpg123zd2handlezd2_bglt)COBJECT(BgL_oz00_4))->BgL_z42builtinz42); 
mpg123_delete(BgL_arg1113z00_301); BUNSPEC; } 
return 
((obj_t)BgL_oz00_4);} 

}



/* &mpg123-handle-close */
obj_t BGl_z62mpg123zd2handlezd2closez62zz__mpg123_mpg123z00(obj_t BgL_envz00_523, obj_t BgL_oz00_524)
{
{ /* Llib/mpg123.scm 64 */
{ /* Llib/mpg123.scm 65 */
BgL_mpg123zd2handlezd2_bglt BgL_auxz00_793;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_524, BGl_mpg123zd2handlezd2zz__mpg123_mpg123z00))
{ /* Llib/mpg123.scm 65 */
BgL_auxz00_793 = 
((BgL_mpg123zd2handlezd2_bglt)BgL_oz00_524)
; }  else 
{ 
obj_t BgL_auxz00_797;
BgL_auxz00_797 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1789z00zz__mpg123_mpg123z00, 
BINT(((long)3009)), BGl_string1790z00zz__mpg123_mpg123z00, BGl_string1791z00zz__mpg123_mpg123z00, BgL_oz00_524); 
FAILURE(BgL_auxz00_797,BFALSE,BFALSE);} 
return 
BGl_mpg123zd2handlezd2closez00zz__mpg123_mpg123z00(BgL_auxz00_793);} } 

}



/* mpg123-handle-reset! */
BGL_EXPORTED_DEF obj_t BGl_mpg123zd2handlezd2resetz12z12zz__mpg123_mpg123z00(BgL_mpg123zd2handlezd2_bglt BgL_oz00_5)
{
{ /* Llib/mpg123.scm 72 */
{ /* Llib/mpg123.scm 74 */
mpg123_handle * BgL_tmpz00_802;
BgL_tmpz00_802 = 
(((BgL_mpg123zd2handlezd2_bglt)COBJECT(BgL_oz00_5))->BgL_z42builtinz42); 
mpg123_close(BgL_tmpz00_802); } 
{ /* Llib/mpg123.scm 75 */
mpg123_handle * BgL_arg1116z00_304;
BgL_arg1116z00_304 = 
(((BgL_mpg123zd2handlezd2_bglt)COBJECT(BgL_oz00_5))->BgL_z42builtinz42); 
return 
BINT(
mpg123_open_feed(BgL_arg1116z00_304));} } 

}



/* &mpg123-handle-reset! */
obj_t BGl_z62mpg123zd2handlezd2resetz12z70zz__mpg123_mpg123z00(obj_t BgL_envz00_525, obj_t BgL_oz00_526)
{
{ /* Llib/mpg123.scm 72 */
{ /* Llib/mpg123.scm 73 */
BgL_mpg123zd2handlezd2_bglt BgL_auxz00_808;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_526, BGl_mpg123zd2handlezd2zz__mpg123_mpg123z00))
{ /* Llib/mpg123.scm 73 */
BgL_auxz00_808 = 
((BgL_mpg123zd2handlezd2_bglt)BgL_oz00_526)
; }  else 
{ 
obj_t BgL_auxz00_812;
BgL_auxz00_812 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1789z00zz__mpg123_mpg123z00, 
BINT(((long)3366)), BGl_string1792z00zz__mpg123_mpg123z00, BGl_string1791z00zz__mpg123_mpg123z00, BgL_oz00_526); 
FAILURE(BgL_auxz00_812,BFALSE,BFALSE);} 
return 
BGl_mpg123zd2handlezd2resetz12z12zz__mpg123_mpg123z00(BgL_auxz00_808);} } 

}



/* mpg123-error */
BGL_EXPORTED_DEF int bgl_mpg123_error(char * BgL_procz00_6, char * BgL_msgz00_7, obj_t BgL_objz00_8)
{
{ /* Llib/mpg123.scm 80 */
{ /* Llib/mpg123.scm 81 */
BgL_z62mpg123zd2errorzb0_bglt BgL_arg1117z00_53;
{ /* Llib/mpg123.scm 81 */
BgL_z62mpg123zd2errorzb0_bglt BgL_new1067z00_54;
{ /* Llib/mpg123.scm 81 */
BgL_z62mpg123zd2errorzb0_bglt BgL_new1066z00_57;
BgL_new1066z00_57 = 
((BgL_z62mpg123zd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62mpg123zd2errorzb0_bgl) ))); 
{ /* Llib/mpg123.scm 81 */
long BgL_arg1133z00_58;
{ /* Llib/mpg123.scm 81 */
long BgL_res1672z00_306;
BgL_res1672z00_306 = 
BGL_CLASS_INDEX(BGl_z62mpg123zd2errorzb0zz__mpg123_mpg123z00); 
BgL_arg1133z00_58 = BgL_res1672z00_306; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1066z00_57), BgL_arg1133z00_58); } 
BgL_new1067z00_54 = BgL_new1066z00_57; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1067z00_54)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1067z00_54)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_825;
{ /* Llib/mpg123.scm 81 */
obj_t BgL_arg1118z00_55;
{ /* Llib/mpg123.scm 81 */
obj_t BgL_arg1132z00_56;
{ /* Llib/mpg123.scm 81 */
obj_t BgL_res1673z00_310;
{ /* Llib/mpg123.scm 81 */
obj_t BgL_classz00_309;
BgL_classz00_309 = BGl_z62mpg123zd2errorzb0zz__mpg123_mpg123z00; 
BgL_res1673z00_310 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_309); } 
BgL_arg1132z00_56 = BgL_res1673z00_310; } 
BgL_arg1118z00_55 = 
VECTOR_REF(BgL_arg1132z00_56,((long)2)); } 
BgL_auxz00_825 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1118z00_55); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1067z00_54)))->BgL_stackz00)=((obj_t)BgL_auxz00_825),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1067z00_54)))->BgL_procz00)=((obj_t)
string_to_bstring(BgL_procz00_6)),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1067z00_54)))->BgL_msgz00)=((obj_t)
string_to_bstring(BgL_msgz00_7)),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1067z00_54)))->BgL_objz00)=((obj_t)BgL_objz00_8),BUNSPEC); 
BgL_arg1117z00_53 = BgL_new1067z00_54; } 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1117z00_53)); } 
return 
(int)(((long)0));} 

}



/* &mpg123-error1743 */
obj_t BGl_z62mpg123zd2error1743zb0zz__mpg123_mpg123z00(obj_t BgL_envz00_527, obj_t BgL_procz00_528, obj_t BgL_msgz00_529, obj_t BgL_objz00_530)
{
{ /* Llib/mpg123.scm 80 */
{ /* Llib/mpg123.scm 84 */
int BgL_tmpz00_842;
{ /* Llib/mpg123.scm 84 */
char * BgL_auxz00_852;char * BgL_auxz00_843;
{ /* Llib/mpg123.scm 84 */
obj_t BgL_tmpz00_853;
if(
STRINGP(BgL_msgz00_529))
{ /* Llib/mpg123.scm 84 */
BgL_tmpz00_853 = BgL_msgz00_529
; }  else 
{ 
obj_t BgL_auxz00_856;
BgL_auxz00_856 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1789z00zz__mpg123_mpg123z00, 
BINT(((long)3828)), BGl_string1793z00zz__mpg123_mpg123z00, BGl_string1794z00zz__mpg123_mpg123z00, BgL_msgz00_529); 
FAILURE(BgL_auxz00_856,BFALSE,BFALSE);} 
BgL_auxz00_852 = 
BSTRING_TO_STRING(BgL_tmpz00_853); } 
{ /* Llib/mpg123.scm 84 */
obj_t BgL_tmpz00_844;
if(
STRINGP(BgL_procz00_528))
{ /* Llib/mpg123.scm 84 */
BgL_tmpz00_844 = BgL_procz00_528
; }  else 
{ 
obj_t BgL_auxz00_847;
BgL_auxz00_847 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1789z00zz__mpg123_mpg123z00, 
BINT(((long)3828)), BGl_string1793z00zz__mpg123_mpg123z00, BGl_string1794z00zz__mpg123_mpg123z00, BgL_procz00_528); 
FAILURE(BgL_auxz00_847,BFALSE,BFALSE);} 
BgL_auxz00_843 = 
BSTRING_TO_STRING(BgL_tmpz00_844); } 
BgL_tmpz00_842 = 
bgl_mpg123_error(BgL_auxz00_843, BgL_auxz00_852, BgL_objz00_530); } 
return 
BINT(BgL_tmpz00_842);} } 

}



/* mpg123-decode */
BGL_EXPORTED_DEF obj_t BGl_mpg123zd2decodezd2zz__mpg123_mpg123z00(BgL_mpg123zd2handlezd2_bglt BgL_mz00_9, obj_t BgL_inbufz00_10, long BgL_inoffz00_11, long BgL_insza7za7_12, obj_t BgL_outbufz00_13, long BgL_outsza7za7_14)
{
{ /* Llib/mpg123.scm 90 */
{ /* Llib/mpg123.scm 91 */
int BgL_statusz00_312;
BgL_statusz00_312 = 
bgl_mpg123_decode(
((obj_t)BgL_mz00_9), 
BSTRING_TO_STRING(BgL_inbufz00_10), BgL_inoffz00_11, BgL_insza7za7_12, 
BSTRING_TO_STRING(BgL_outbufz00_13), BgL_outsza7za7_14); 
{ /* Llib/mpg123.scm 92 */
obj_t BgL_val0_1091z00_313;long BgL_val1_1092z00_314;
BgL_val0_1091z00_313 = 
BGl_mpg123zd2decodezd2statuszd2ze3symbolz31zz__mpg123_mpg123z00(BgL_statusz00_312); 
BgL_val1_1092z00_314 = 
(((BgL_mpg123zd2handlezd2_bglt)COBJECT(BgL_mz00_9))->BgL_siza7eza7); 
{ /* Llib/mpg123.scm 92 */
int BgL_res1674z00_316;
{ /* Llib/mpg123.scm 92 */
int BgL_tmpz00_869;
BgL_tmpz00_869 = 
(int)(((long)2)); 
BgL_res1674z00_316 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_869); } BgL_res1674z00_316; } 
{ /* Llib/mpg123.scm 92 */
obj_t BgL_auxz00_874;int BgL_tmpz00_872;
BgL_auxz00_874 = 
BINT(BgL_val1_1092z00_314); 
BgL_tmpz00_872 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_872, BgL_auxz00_874); } 
return BgL_val0_1091z00_313;} } } 

}



/* &mpg123-decode */
obj_t BGl_z62mpg123zd2decodezb0zz__mpg123_mpg123z00(obj_t BgL_envz00_531, obj_t BgL_mz00_532, obj_t BgL_inbufz00_533, obj_t BgL_inoffz00_534, obj_t BgL_insza7za7_535, obj_t BgL_outbufz00_536, obj_t BgL_outsza7za7_537)
{
{ /* Llib/mpg123.scm 90 */
{ /* Llib/mpg123.scm 91 */
long BgL_auxz00_917;obj_t BgL_auxz00_910;long BgL_auxz00_901;long BgL_auxz00_892;obj_t BgL_auxz00_885;BgL_mpg123zd2handlezd2_bglt BgL_auxz00_877;
{ /* Llib/mpg123.scm 91 */
obj_t BgL_tmpz00_918;
if(
INTEGERP(BgL_outsza7za7_537))
{ /* Llib/mpg123.scm 91 */
BgL_tmpz00_918 = BgL_outsza7za7_537
; }  else 
{ 
obj_t BgL_auxz00_921;
BgL_auxz00_921 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1789z00zz__mpg123_mpg123z00, 
BINT(((long)4133)), BGl_string1795z00zz__mpg123_mpg123z00, BGl_string1796z00zz__mpg123_mpg123z00, BgL_outsza7za7_537); 
FAILURE(BgL_auxz00_921,BFALSE,BFALSE);} 
BgL_auxz00_917 = 
(long)CINT(BgL_tmpz00_918); } 
if(
STRINGP(BgL_outbufz00_536))
{ /* Llib/mpg123.scm 91 */
BgL_auxz00_910 = BgL_outbufz00_536
; }  else 
{ 
obj_t BgL_auxz00_913;
BgL_auxz00_913 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1789z00zz__mpg123_mpg123z00, 
BINT(((long)4133)), BGl_string1795z00zz__mpg123_mpg123z00, BGl_string1794z00zz__mpg123_mpg123z00, BgL_outbufz00_536); 
FAILURE(BgL_auxz00_913,BFALSE,BFALSE);} 
{ /* Llib/mpg123.scm 91 */
obj_t BgL_tmpz00_902;
if(
INTEGERP(BgL_insza7za7_535))
{ /* Llib/mpg123.scm 91 */
BgL_tmpz00_902 = BgL_insza7za7_535
; }  else 
{ 
obj_t BgL_auxz00_905;
BgL_auxz00_905 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1789z00zz__mpg123_mpg123z00, 
BINT(((long)4133)), BGl_string1795z00zz__mpg123_mpg123z00, BGl_string1796z00zz__mpg123_mpg123z00, BgL_insza7za7_535); 
FAILURE(BgL_auxz00_905,BFALSE,BFALSE);} 
BgL_auxz00_901 = 
(long)CINT(BgL_tmpz00_902); } 
{ /* Llib/mpg123.scm 91 */
obj_t BgL_tmpz00_893;
if(
INTEGERP(BgL_inoffz00_534))
{ /* Llib/mpg123.scm 91 */
BgL_tmpz00_893 = BgL_inoffz00_534
; }  else 
{ 
obj_t BgL_auxz00_896;
BgL_auxz00_896 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1789z00zz__mpg123_mpg123z00, 
BINT(((long)4133)), BGl_string1795z00zz__mpg123_mpg123z00, BGl_string1796z00zz__mpg123_mpg123z00, BgL_inoffz00_534); 
FAILURE(BgL_auxz00_896,BFALSE,BFALSE);} 
BgL_auxz00_892 = 
(long)CINT(BgL_tmpz00_893); } 
if(
STRINGP(BgL_inbufz00_533))
{ /* Llib/mpg123.scm 91 */
BgL_auxz00_885 = BgL_inbufz00_533
; }  else 
{ 
obj_t BgL_auxz00_888;
BgL_auxz00_888 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1789z00zz__mpg123_mpg123z00, 
BINT(((long)4133)), BGl_string1795z00zz__mpg123_mpg123z00, BGl_string1794z00zz__mpg123_mpg123z00, BgL_inbufz00_533); 
FAILURE(BgL_auxz00_888,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mz00_532, BGl_mpg123zd2handlezd2zz__mpg123_mpg123z00))
{ /* Llib/mpg123.scm 91 */
BgL_auxz00_877 = 
((BgL_mpg123zd2handlezd2_bglt)BgL_mz00_532)
; }  else 
{ 
obj_t BgL_auxz00_881;
BgL_auxz00_881 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1789z00zz__mpg123_mpg123z00, 
BINT(((long)4133)), BGl_string1795z00zz__mpg123_mpg123z00, BGl_string1791z00zz__mpg123_mpg123z00, BgL_mz00_532); 
FAILURE(BgL_auxz00_881,BFALSE,BFALSE);} 
return 
BGl_mpg123zd2decodezd2zz__mpg123_mpg123z00(BgL_auxz00_877, BgL_auxz00_885, BgL_auxz00_892, BgL_auxz00_901, BgL_auxz00_910, BgL_auxz00_917);} } 

}



/* mpg123-get-format */
BGL_EXPORTED_DEF obj_t BGl_mpg123zd2getzd2formatz00zz__mpg123_mpg123z00(BgL_mpg123zd2handlezd2_bglt BgL_mz00_15)
{
{ /* Llib/mpg123.scm 99 */
{ /* Llib/mpg123.scm 101 */
long BgL_ratez00_64;
BgL_ratez00_64 = 
bgl_mpg123_getformat(
(((BgL_mpg123zd2handlezd2_bglt)COBJECT(BgL_mz00_15))->BgL_z42builtinz42)); 
{ /* Llib/mpg123.scm 102 */
obj_t BgL_channelsz00_65;obj_t BgL_encodingz00_66;
{ /* Llib/mpg123.scm 103 */
int BgL_tmpz00_929;
BgL_tmpz00_929 = 
(int)(((long)1)); 
BgL_channelsz00_65 = 
BGL_MVALUES_VAL(BgL_tmpz00_929); } 
{ /* Llib/mpg123.scm 103 */
int BgL_tmpz00_932;
BgL_tmpz00_932 = 
(int)(((long)2)); 
BgL_encodingz00_66 = 
BGL_MVALUES_VAL(BgL_tmpz00_932); } 
{ /* Llib/mpg123.scm 103 */
obj_t BgL_val2_1095z00_69;
BgL_val2_1095z00_69 = 
BGl_mpg123zd2formatzd2ze3symbolze3zz__mpg123_mpg123z00(BgL_encodingz00_66); 
{ /* Llib/mpg123.scm 103 */
int BgL_res1675z00_317;
{ /* Llib/mpg123.scm 103 */
int BgL_tmpz00_936;
BgL_tmpz00_936 = 
(int)(((long)3)); 
BgL_res1675z00_317 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_936); } BgL_res1675z00_317; } 
{ /* Llib/mpg123.scm 103 */
int BgL_tmpz00_939;
BgL_tmpz00_939 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_939, BgL_channelsz00_65); } 
{ /* Llib/mpg123.scm 103 */
int BgL_tmpz00_942;
BgL_tmpz00_942 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_942, BgL_val2_1095z00_69); } 
return 
BINT(BgL_ratez00_64);} } } } 

}



/* &mpg123-get-format */
obj_t BGl_z62mpg123zd2getzd2formatz62zz__mpg123_mpg123z00(obj_t BgL_envz00_538, obj_t BgL_mz00_539)
{
{ /* Llib/mpg123.scm 99 */
{ /* Llib/mpg123.scm 100 */
BgL_mpg123zd2handlezd2_bglt BgL_auxz00_946;
if(
BGl_isazf3zf3zz__objectz00(BgL_mz00_539, BGl_mpg123zd2handlezd2zz__mpg123_mpg123z00))
{ /* Llib/mpg123.scm 100 */
BgL_auxz00_946 = 
((BgL_mpg123zd2handlezd2_bglt)BgL_mz00_539)
; }  else 
{ 
obj_t BgL_auxz00_950;
BgL_auxz00_950 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1789z00zz__mpg123_mpg123z00, 
BINT(((long)4578)), BGl_string1797z00zz__mpg123_mpg123z00, BGl_string1791z00zz__mpg123_mpg123z00, BgL_mz00_539); 
FAILURE(BgL_auxz00_950,BFALSE,BFALSE);} 
return 
BGl_mpg123zd2getzd2formatz00zz__mpg123_mpg123z00(BgL_auxz00_946);} } 

}



/* mpg123-position */
BGL_EXPORTED_DEF long BGl_mpg123zd2positionzd2zz__mpg123_mpg123z00(BgL_mpg123zd2handlezd2_bglt BgL_mz00_16)
{
{ /* Llib/mpg123.scm 108 */
return 
bgl_mpg123_position(
(((BgL_mpg123zd2handlezd2_bglt)COBJECT(BgL_mz00_16))->BgL_z42builtinz42));} 

}



/* &mpg123-position */
obj_t BGl_z62mpg123zd2positionzb0zz__mpg123_mpg123z00(obj_t BgL_envz00_540, obj_t BgL_mz00_541)
{
{ /* Llib/mpg123.scm 108 */
{ /* Llib/mpg123.scm 109 */
long BgL_tmpz00_957;
{ /* Llib/mpg123.scm 109 */
BgL_mpg123zd2handlezd2_bglt BgL_auxz00_958;
if(
BGl_isazf3zf3zz__objectz00(BgL_mz00_541, BGl_mpg123zd2handlezd2zz__mpg123_mpg123z00))
{ /* Llib/mpg123.scm 109 */
BgL_auxz00_958 = 
((BgL_mpg123zd2handlezd2_bglt)BgL_mz00_541)
; }  else 
{ 
obj_t BgL_auxz00_962;
BgL_auxz00_962 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1789z00zz__mpg123_mpg123z00, 
BINT(((long)5037)), BGl_string1798z00zz__mpg123_mpg123z00, BGl_string1791z00zz__mpg123_mpg123z00, BgL_mz00_541); 
FAILURE(BgL_auxz00_962,BFALSE,BFALSE);} 
BgL_tmpz00_957 = 
BGl_mpg123zd2positionzd2zz__mpg123_mpg123z00(BgL_auxz00_958); } 
return 
BINT(BgL_tmpz00_957);} } 

}



/* mpg123-decode-status->symbol */
BGL_EXPORTED_DEF obj_t BGl_mpg123zd2decodezd2statuszd2ze3symbolz31zz__mpg123_mpg123z00(int BgL_sz00_17)
{
{ /* Llib/mpg123.scm 115 */
if(
(
(long)(BgL_sz00_17)==
(long)(MPG123_OK)))
{ /* Llib/mpg123.scm 117 */
return 
CNST_TABLE_REF(((long)0));}  else 
{ /* Llib/mpg123.scm 117 */
if(
(
(long)(BgL_sz00_17)==
(long)(MPG123_NEW_FORMAT)))
{ /* Llib/mpg123.scm 118 */
return 
CNST_TABLE_REF(((long)1));}  else 
{ /* Llib/mpg123.scm 118 */
if(
(
(long)(BgL_sz00_17)==
(long)(MPG123_ERR)))
{ /* Llib/mpg123.scm 119 */
return 
CNST_TABLE_REF(((long)2));}  else 
{ /* Llib/mpg123.scm 119 */
if(
(
(long)(BgL_sz00_17)==
(long)(MPG123_NEED_MORE)))
{ /* Llib/mpg123.scm 120 */
return 
CNST_TABLE_REF(((long)3));}  else 
{ /* Llib/mpg123.scm 120 */
if(
(
(long)(BgL_sz00_17)==
(long)(MPG123_DONE)))
{ /* Llib/mpg123.scm 121 */
return 
CNST_TABLE_REF(((long)4));}  else 
{ /* Llib/mpg123.scm 122 */
BgL_z62mpg123zd2errorzb0_bglt BgL_arg1142z00_78;
{ /* Llib/mpg123.scm 122 */
BgL_z62mpg123zd2errorzb0_bglt BgL_new1072z00_79;
{ /* Llib/mpg123.scm 122 */
BgL_z62mpg123zd2errorzb0_bglt BgL_new1071z00_82;
BgL_new1071z00_82 = 
((BgL_z62mpg123zd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62mpg123zd2errorzb0_bgl) ))); 
{ /* Llib/mpg123.scm 122 */
long BgL_arg1145z00_83;
{ /* Llib/mpg123.scm 122 */
long BgL_res1681z00_336;
BgL_res1681z00_336 = 
BGL_CLASS_INDEX(BGl_z62mpg123zd2errorzb0zz__mpg123_mpg123z00); 
BgL_arg1145z00_83 = BgL_res1681z00_336; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1071z00_82), BgL_arg1145z00_83); } 
BgL_new1072z00_79 = BgL_new1071z00_82; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1072z00_79)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1072z00_79)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_1001;
{ /* Llib/mpg123.scm 122 */
obj_t BgL_arg1143z00_80;
{ /* Llib/mpg123.scm 122 */
obj_t BgL_arg1144z00_81;
{ /* Llib/mpg123.scm 122 */
obj_t BgL_res1682z00_340;
{ /* Llib/mpg123.scm 122 */
obj_t BgL_classz00_339;
BgL_classz00_339 = BGl_z62mpg123zd2errorzb0zz__mpg123_mpg123z00; 
BgL_res1682z00_340 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_339); } 
BgL_arg1144z00_81 = BgL_res1682z00_340; } 
BgL_arg1143z00_80 = 
VECTOR_REF(BgL_arg1144z00_81,((long)2)); } 
BgL_auxz00_1001 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1143z00_80); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1072z00_79)))->BgL_stackz00)=((obj_t)BgL_auxz00_1001),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1072z00_79)))->BgL_procz00)=((obj_t)BGl_string1799z00zz__mpg123_mpg123z00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1072z00_79)))->BgL_msgz00)=((obj_t)BGl_string1800z00zz__mpg123_mpg123z00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1072z00_79)))->BgL_objz00)=((obj_t)
BINT(BgL_sz00_17)),BUNSPEC); 
BgL_arg1142z00_78 = BgL_new1072z00_79; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1142z00_78));} } } } } } 

}



/* &mpg123-decode-status->symbol */
obj_t BGl_z62mpg123zd2decodezd2statuszd2ze3symbolz53zz__mpg123_mpg123z00(obj_t BgL_envz00_542, obj_t BgL_sz00_543)
{
{ /* Llib/mpg123.scm 115 */
{ /* Llib/mpg123.scm 117 */
int BgL_auxz00_1016;
{ /* Llib/mpg123.scm 117 */
obj_t BgL_tmpz00_1017;
if(
INTEGERP(BgL_sz00_543))
{ /* Llib/mpg123.scm 117 */
BgL_tmpz00_1017 = BgL_sz00_543
; }  else 
{ 
obj_t BgL_auxz00_1020;
BgL_auxz00_1020 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1789z00zz__mpg123_mpg123z00, 
BINT(((long)5397)), BGl_string1801z00zz__mpg123_mpg123z00, BGl_string1796z00zz__mpg123_mpg123z00, BgL_sz00_543); 
FAILURE(BgL_auxz00_1020,BFALSE,BFALSE);} 
BgL_auxz00_1016 = 
CINT(BgL_tmpz00_1017); } 
return 
BGl_mpg123zd2decodezd2statuszd2ze3symbolz31zz__mpg123_mpg123z00(BgL_auxz00_1016);} } 

}



/* mpg123-format->symbol */
obj_t BGl_mpg123zd2formatzd2ze3symbolze3zz__mpg123_mpg123z00(obj_t BgL_fz00_18)
{
{ /* Llib/mpg123.scm 130 */
if(
(
(long)CINT(BgL_fz00_18)==MPG123_ENC_SIGNED_16))
{ /* Llib/mpg123.scm 132 */
return 
CNST_TABLE_REF(((long)5));}  else 
{ /* Llib/mpg123.scm 132 */
if(
(
(long)CINT(BgL_fz00_18)==MPG123_ENC_UNSIGNED_16))
{ /* Llib/mpg123.scm 133 */
return 
CNST_TABLE_REF(((long)6));}  else 
{ /* Llib/mpg123.scm 133 */
if(
(
(long)CINT(BgL_fz00_18)==MPG123_ENC_UNSIGNED_8))
{ /* Llib/mpg123.scm 134 */
return 
CNST_TABLE_REF(((long)7));}  else 
{ /* Llib/mpg123.scm 134 */
if(
(
(long)CINT(BgL_fz00_18)==MPG123_ENC_SIGNED_8))
{ /* Llib/mpg123.scm 135 */
return 
CNST_TABLE_REF(((long)8));}  else 
{ /* Llib/mpg123.scm 135 */
if(
(
(long)CINT(BgL_fz00_18)==MPG123_ENC_ALAW_8))
{ /* Llib/mpg123.scm 136 */
return 
CNST_TABLE_REF(((long)9));}  else 
{ /* Llib/mpg123.scm 136 */
if(
(
(long)CINT(BgL_fz00_18)==MPG123_ENC_ULAW_8))
{ /* Llib/mpg123.scm 137 */
return 
CNST_TABLE_REF(((long)10));}  else 
{ /* Llib/mpg123.scm 137 */
if(
(
(long)CINT(BgL_fz00_18)==MPG123_ENC_SIGNED_32))
{ /* Llib/mpg123.scm 138 */
return 
CNST_TABLE_REF(((long)11));}  else 
{ /* Llib/mpg123.scm 138 */
if(
(
(long)CINT(BgL_fz00_18)==MPG123_ENC_UNSIGNED_32))
{ /* Llib/mpg123.scm 139 */
return 
CNST_TABLE_REF(((long)12));}  else 
{ /* Llib/mpg123.scm 139 */
if(
(
(long)CINT(BgL_fz00_18)==MPG123_ENC_FLOAT_32))
{ /* Llib/mpg123.scm 144 */
return 
CNST_TABLE_REF(((long)13));}  else 
{ /* Llib/mpg123.scm 144 */
if(
(
(long)CINT(BgL_fz00_18)==MPG123_ENC_FLOAT_64))
{ /* Llib/mpg123.scm 145 */
return 
CNST_TABLE_REF(((long)14));}  else 
{ /* Llib/mpg123.scm 146 */
BgL_z62mpg123zd2errorzb0_bglt BgL_arg1156z00_94;
{ /* Llib/mpg123.scm 146 */
BgL_z62mpg123zd2errorzb0_bglt BgL_new1074z00_95;
{ /* Llib/mpg123.scm 146 */
BgL_z62mpg123zd2errorzb0_bglt BgL_new1073z00_98;
BgL_new1073z00_98 = 
((BgL_z62mpg123zd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62mpg123zd2errorzb0_bgl) ))); 
{ /* Llib/mpg123.scm 146 */
long BgL_arg1162z00_99;
{ /* Llib/mpg123.scm 146 */
long BgL_res1693z00_373;
BgL_res1693z00_373 = 
BGL_CLASS_INDEX(BGl_z62mpg123zd2errorzb0zz__mpg123_mpg123z00); 
BgL_arg1162z00_99 = BgL_res1693z00_373; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1073z00_98), BgL_arg1162z00_99); } 
BgL_new1074z00_95 = BgL_new1073z00_98; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1074z00_95)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1074z00_95)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_1074;
{ /* Llib/mpg123.scm 146 */
obj_t BgL_arg1157z00_96;
{ /* Llib/mpg123.scm 146 */
obj_t BgL_arg1161z00_97;
{ /* Llib/mpg123.scm 146 */
obj_t BgL_res1694z00_377;
{ /* Llib/mpg123.scm 146 */
obj_t BgL_classz00_376;
BgL_classz00_376 = BGl_z62mpg123zd2errorzb0zz__mpg123_mpg123z00; 
BgL_res1694z00_377 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_376); } 
BgL_arg1161z00_97 = BgL_res1694z00_377; } 
BgL_arg1157z00_96 = 
VECTOR_REF(BgL_arg1161z00_97,((long)2)); } 
BgL_auxz00_1074 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1157z00_96); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1074z00_95)))->BgL_stackz00)=((obj_t)BgL_auxz00_1074),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1074z00_95)))->BgL_procz00)=((obj_t)BGl_string1802z00zz__mpg123_mpg123z00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1074z00_95)))->BgL_msgz00)=((obj_t)BGl_string1803z00zz__mpg123_mpg123z00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1074z00_95)))->BgL_objz00)=((obj_t)BgL_fz00_18),BUNSPEC); 
BgL_arg1156z00_94 = BgL_new1074z00_95; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1156z00_94));} } } } } } } } } } } 

}



/* mpg123-param-get */
BGL_EXPORTED_DEF obj_t BGl_mpg123zd2paramzd2getz00zz__mpg123_mpg123z00(BgL_mpg123zd2handlezd2_bglt BgL_mz00_19, obj_t BgL_typez00_20)
{
{ /* Llib/mpg123.scm 154 */
return 
bgl_mpg123_getparam(
(((BgL_mpg123zd2handlezd2_bglt)COBJECT(BgL_mz00_19))->BgL_z42builtinz42), 
BGl_symbolzd2ze3mpg123zd2paramze3zz__mpg123_mpg123z00(BgL_typez00_20));} 

}



/* &mpg123-param-get */
obj_t BGl_z62mpg123zd2paramzd2getz62zz__mpg123_mpg123z00(obj_t BgL_envz00_544, obj_t BgL_mz00_545, obj_t BgL_typez00_546)
{
{ /* Llib/mpg123.scm 154 */
{ /* Llib/mpg123.scm 155 */
obj_t BgL_auxz00_1099;BgL_mpg123zd2handlezd2_bglt BgL_auxz00_1091;
if(
SYMBOLP(BgL_typez00_546))
{ /* Llib/mpg123.scm 155 */
BgL_auxz00_1099 = BgL_typez00_546
; }  else 
{ 
obj_t BgL_auxz00_1102;
BgL_auxz00_1102 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1789z00zz__mpg123_mpg123z00, 
BINT(((long)7171)), BGl_string1804z00zz__mpg123_mpg123z00, BGl_string1805z00zz__mpg123_mpg123z00, BgL_typez00_546); 
FAILURE(BgL_auxz00_1102,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mz00_545, BGl_mpg123zd2handlezd2zz__mpg123_mpg123z00))
{ /* Llib/mpg123.scm 155 */
BgL_auxz00_1091 = 
((BgL_mpg123zd2handlezd2_bglt)BgL_mz00_545)
; }  else 
{ 
obj_t BgL_auxz00_1095;
BgL_auxz00_1095 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1789z00zz__mpg123_mpg123z00, 
BINT(((long)7171)), BGl_string1804z00zz__mpg123_mpg123z00, BGl_string1791z00zz__mpg123_mpg123z00, BgL_mz00_545); 
FAILURE(BgL_auxz00_1095,BFALSE,BFALSE);} 
return 
BGl_mpg123zd2paramzd2getz00zz__mpg123_mpg123z00(BgL_auxz00_1091, BgL_auxz00_1099);} } 

}



/* symbol->mpg123-param */
enum mpg123_parms BGl_symbolzd2ze3mpg123zd2paramze3zz__mpg123_mpg123z00(obj_t BgL_pz00_25)
{
{ /* Llib/mpg123.scm 196 */
if(
(BgL_pz00_25==
CNST_TABLE_REF(((long)15))))
{ /* Llib/mpg123.scm 197 */
return MPG123_VERBOSE;}  else 
{ /* Llib/mpg123.scm 197 */
if(
(BgL_pz00_25==
CNST_TABLE_REF(((long)16))))
{ /* Llib/mpg123.scm 197 */
return MPG123_FLAGS;}  else 
{ /* Llib/mpg123.scm 197 */
if(
(BgL_pz00_25==
CNST_TABLE_REF(((long)17))))
{ /* Llib/mpg123.scm 197 */
return MPG123_ADD_FLAGS;}  else 
{ /* Llib/mpg123.scm 197 */
if(
(BgL_pz00_25==
CNST_TABLE_REF(((long)18))))
{ /* Llib/mpg123.scm 197 */
return MPG123_FORCE_RATE;}  else 
{ /* Llib/mpg123.scm 197 */
if(
(BgL_pz00_25==
CNST_TABLE_REF(((long)19))))
{ /* Llib/mpg123.scm 197 */
return MPG123_DOWN_SAMPLE;}  else 
{ /* Llib/mpg123.scm 197 */
if(
(BgL_pz00_25==
CNST_TABLE_REF(((long)20))))
{ /* Llib/mpg123.scm 197 */
return MPG123_RVA;}  else 
{ /* Llib/mpg123.scm 197 */
if(
(BgL_pz00_25==
CNST_TABLE_REF(((long)21))))
{ /* Llib/mpg123.scm 197 */
return MPG123_DOWNSPEED;}  else 
{ /* Llib/mpg123.scm 197 */
if(
(BgL_pz00_25==
CNST_TABLE_REF(((long)22))))
{ /* Llib/mpg123.scm 197 */
return MPG123_UPSPEED;}  else 
{ /* Llib/mpg123.scm 197 */
if(
(BgL_pz00_25==
CNST_TABLE_REF(((long)23))))
{ /* Llib/mpg123.scm 197 */
return MPG123_START_FRAME;}  else 
{ /* Llib/mpg123.scm 197 */
if(
(BgL_pz00_25==
CNST_TABLE_REF(((long)24))))
{ /* Llib/mpg123.scm 197 */
return MPG123_DECODE_FRAMES;}  else 
{ /* Llib/mpg123.scm 197 */
if(
(BgL_pz00_25==
CNST_TABLE_REF(((long)25))))
{ /* Llib/mpg123.scm 197 */
return MPG123_ICY_INTERVAL;}  else 
{ /* Llib/mpg123.scm 197 */
if(
(BgL_pz00_25==
CNST_TABLE_REF(((long)26))))
{ /* Llib/mpg123.scm 197 */
return MPG123_OUTSCALE;}  else 
{ /* Llib/mpg123.scm 197 */
if(
(BgL_pz00_25==
CNST_TABLE_REF(((long)27))))
{ /* Llib/mpg123.scm 197 */
return MPG123_TIMEOUT;}  else 
{ /* Llib/mpg123.scm 197 */
if(
(BgL_pz00_25==
CNST_TABLE_REF(((long)28))))
{ /* Llib/mpg123.scm 197 */
return MPG123_REMOVE_FLAGS;}  else 
{ /* Llib/mpg123.scm 197 */
if(
(BgL_pz00_25==
CNST_TABLE_REF(((long)29))))
{ /* Llib/mpg123.scm 197 */
return MPG123_RESYNC_LIMIT;}  else 
{ /* Llib/mpg123.scm 197 */
if(
(BgL_pz00_25==
CNST_TABLE_REF(((long)30))))
{ /* Llib/mpg123.scm 197 */
return MPG123_INDEX_SIZE;}  else 
{ /* Llib/mpg123.scm 197 */
return 
(long)CINT(
BGl_errorz00zz__errorz00(BGl_string1806z00zz__mpg123_mpg123z00, BGl_string1807z00zz__mpg123_mpg123z00, BgL_pz00_25));} } } } } } } } } } } } } } } } } 

}



/* mpg123-info */
BGL_EXPORTED_DEF long BGl_mpg123zd2infozd2zz__mpg123_mpg123z00(BgL_mpg123zd2handlezd2_bglt BgL_mz00_26)
{
{ /* Llib/mpg123.scm 232 */
return 
bgl_mpg123_info(
(((BgL_mpg123zd2handlezd2_bglt)COBJECT(BgL_mz00_26))->BgL_z42builtinz42));} 

}



/* &mpg123-info */
obj_t BGl_z62mpg123zd2infozb0zz__mpg123_mpg123z00(obj_t BgL_envz00_547, obj_t BgL_mz00_548)
{
{ /* Llib/mpg123.scm 232 */
{ /* Llib/mpg123.scm 233 */
long BgL_tmpz00_1159;
{ /* Llib/mpg123.scm 233 */
BgL_mpg123zd2handlezd2_bglt BgL_auxz00_1160;
if(
BGl_isazf3zf3zz__objectz00(BgL_mz00_548, BGl_mpg123zd2handlezd2zz__mpg123_mpg123z00))
{ /* Llib/mpg123.scm 233 */
BgL_auxz00_1160 = 
((BgL_mpg123zd2handlezd2_bglt)BgL_mz00_548)
; }  else 
{ 
obj_t BgL_auxz00_1164;
BgL_auxz00_1164 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1789z00zz__mpg123_mpg123z00, 
BINT(((long)10878)), BGl_string1808z00zz__mpg123_mpg123z00, BGl_string1791z00zz__mpg123_mpg123z00, BgL_mz00_548); 
FAILURE(BgL_auxz00_1164,BFALSE,BFALSE);} 
BgL_tmpz00_1159 = 
BGl_mpg123zd2infozd2zz__mpg123_mpg123z00(BgL_auxz00_1160); } 
return 
BINT(BgL_tmpz00_1159);} } 

}



/* mpg123-seek */
BGL_EXPORTED_DEF long BGl_mpg123zd2seekzd2zz__mpg123_mpg123z00(BgL_mpg123zd2handlezd2_bglt BgL_mz00_27, long BgL_secz00_28)
{
{ /* Llib/mpg123.scm 239 */
{ /* Llib/mpg123.scm 241 */
long BgL_fz00_146;
{ /* Llib/mpg123.scm 241 */
mpg123_handle * BgL_arg1333z00_164;double BgL_arg1334z00_165;
BgL_arg1333z00_164 = 
(((BgL_mpg123zd2handlezd2_bglt)COBJECT(BgL_mz00_27))->BgL_z42builtinz42); 
BgL_arg1334z00_165 = 
(double)(BgL_secz00_28); 
BgL_fz00_146 = 
mpg123_timeframe(BgL_arg1333z00_164, BgL_arg1334z00_165); } 
{ /* Llib/mpg123.scm 242 */
obj_t BgL_arg1230z00_147;
{ /* Llib/mpg123.scm 242 */
obj_t BgL_res1712z00_419;
{ /* Llib/mpg123.scm 242 */
obj_t BgL_tmpz00_1173;
BgL_tmpz00_1173 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_res1712z00_419 = 
BGL_ENV_CURRENT_ERROR_PORT(BgL_tmpz00_1173); } 
BgL_arg1230z00_147 = BgL_res1712z00_419; } 
{ /* Llib/mpg123.scm 242 */
obj_t BgL_list1231z00_148;
{ /* Llib/mpg123.scm 242 */
obj_t BgL_arg1232z00_149;
{ /* Llib/mpg123.scm 242 */
obj_t BgL_arg1233z00_150;
{ /* Llib/mpg123.scm 242 */
obj_t BgL_arg1258z00_151;
{ /* Llib/mpg123.scm 242 */
obj_t BgL_arg1259z00_152;
{ /* Llib/mpg123.scm 242 */
obj_t BgL_arg1265z00_153;
BgL_arg1265z00_153 = 
MAKE_YOUNG_PAIR(
BINT(BgL_fz00_146), BNIL); 
BgL_arg1259z00_152 = 
MAKE_YOUNG_PAIR(BGl_string1809z00zz__mpg123_mpg123z00, BgL_arg1265z00_153); } 
BgL_arg1258z00_151 = 
MAKE_YOUNG_PAIR(BGl_string1810z00zz__mpg123_mpg123z00, BgL_arg1259z00_152); } 
BgL_arg1233z00_150 = 
MAKE_YOUNG_PAIR(
BINT(((long)242)), BgL_arg1258z00_151); } 
BgL_arg1232z00_149 = 
MAKE_YOUNG_PAIR(BGl_string1811z00zz__mpg123_mpg123z00, BgL_arg1233z00_150); } 
BgL_list1231z00_148 = 
MAKE_YOUNG_PAIR(BGl_string1812z00zz__mpg123_mpg123z00, BgL_arg1232z00_149); } 
BGl_tprintz00zz__r4_output_6_10_3z00(BgL_arg1230z00_147, BgL_list1231z00_148); } } 
{ /* Llib/mpg123.scm 243 */
long BgL_oz00_154;
{ /* Llib/mpg123.scm 243 */
mpg123_handle * BgL_tmpz00_1185;
BgL_tmpz00_1185 = 
(((BgL_mpg123zd2handlezd2_bglt)COBJECT(BgL_mz00_27))->BgL_z42builtinz42); 
BgL_oz00_154 = 
mpg123_seek_frame(BgL_tmpz00_1185, BgL_fz00_146, SEEK_SET); } 
{ /* Llib/mpg123.scm 244 */
obj_t BgL_arg1266z00_155;
{ /* Llib/mpg123.scm 244 */
obj_t BgL_res1713z00_421;
{ /* Llib/mpg123.scm 244 */
obj_t BgL_tmpz00_1188;
BgL_tmpz00_1188 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_res1713z00_421 = 
BGL_ENV_CURRENT_ERROR_PORT(BgL_tmpz00_1188); } 
BgL_arg1266z00_155 = BgL_res1713z00_421; } 
{ /* Llib/mpg123.scm 244 */
obj_t BgL_list1267z00_156;
{ /* Llib/mpg123.scm 244 */
obj_t BgL_arg1268z00_157;
{ /* Llib/mpg123.scm 244 */
obj_t BgL_arg1269z00_158;
{ /* Llib/mpg123.scm 244 */
obj_t BgL_arg1281z00_159;
{ /* Llib/mpg123.scm 244 */
obj_t BgL_arg1300z00_160;
{ /* Llib/mpg123.scm 244 */
obj_t BgL_arg1325z00_161;
BgL_arg1325z00_161 = 
MAKE_YOUNG_PAIR(
BINT(BgL_oz00_154), BNIL); 
BgL_arg1300z00_160 = 
MAKE_YOUNG_PAIR(BGl_string1813z00zz__mpg123_mpg123z00, BgL_arg1325z00_161); } 
BgL_arg1281z00_159 = 
MAKE_YOUNG_PAIR(BGl_string1810z00zz__mpg123_mpg123z00, BgL_arg1300z00_160); } 
BgL_arg1269z00_158 = 
MAKE_YOUNG_PAIR(
BINT(((long)244)), BgL_arg1281z00_159); } 
BgL_arg1268z00_157 = 
MAKE_YOUNG_PAIR(BGl_string1811z00zz__mpg123_mpg123z00, BgL_arg1269z00_158); } 
BgL_list1267z00_156 = 
MAKE_YOUNG_PAIR(BGl_string1812z00zz__mpg123_mpg123z00, BgL_arg1268z00_157); } 
BGl_tprintz00zz__r4_output_6_10_3z00(BgL_arg1266z00_155, BgL_list1267z00_156); } } 
if(
(BgL_oz00_154<((long)0)))
{ /* Llib/mpg123.scm 245 */
return ((long)0);}  else 
{ /* Llib/mpg123.scm 245 */
return BgL_oz00_154;} } } } 

}



/* &mpg123-seek */
obj_t BGl_z62mpg123zd2seekzb0zz__mpg123_mpg123z00(obj_t BgL_envz00_549, obj_t BgL_mz00_550, obj_t BgL_secz00_551)
{
{ /* Llib/mpg123.scm 239 */
{ /* Llib/mpg123.scm 240 */
long BgL_tmpz00_1202;
{ /* Llib/mpg123.scm 240 */
long BgL_auxz00_1211;BgL_mpg123zd2handlezd2_bglt BgL_auxz00_1203;
{ /* Llib/mpg123.scm 240 */
obj_t BgL_tmpz00_1212;
if(
INTEGERP(BgL_secz00_551))
{ /* Llib/mpg123.scm 240 */
BgL_tmpz00_1212 = BgL_secz00_551
; }  else 
{ 
obj_t BgL_auxz00_1215;
BgL_auxz00_1215 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1789z00zz__mpg123_mpg123z00, 
BINT(((long)11227)), BGl_string1814z00zz__mpg123_mpg123z00, BGl_string1796z00zz__mpg123_mpg123z00, BgL_secz00_551); 
FAILURE(BgL_auxz00_1215,BFALSE,BFALSE);} 
BgL_auxz00_1211 = 
(long)CINT(BgL_tmpz00_1212); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_mz00_550, BGl_mpg123zd2handlezd2zz__mpg123_mpg123z00))
{ /* Llib/mpg123.scm 240 */
BgL_auxz00_1203 = 
((BgL_mpg123zd2handlezd2_bglt)BgL_mz00_550)
; }  else 
{ 
obj_t BgL_auxz00_1207;
BgL_auxz00_1207 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1789z00zz__mpg123_mpg123z00, 
BINT(((long)11227)), BGl_string1814z00zz__mpg123_mpg123z00, BGl_string1791z00zz__mpg123_mpg123z00, BgL_mz00_550); 
FAILURE(BgL_auxz00_1207,BFALSE,BFALSE);} 
BgL_tmpz00_1202 = 
BGl_mpg123zd2seekzd2zz__mpg123_mpg123z00(BgL_auxz00_1203, BgL_auxz00_1211); } 
return 
BINT(BgL_tmpz00_1202);} } 

}



/* mpg123-volume-get */
BGL_EXPORTED_DEF obj_t BGl_mpg123zd2volumezd2getz00zz__mpg123_mpg123z00(BgL_mpg123zd2handlezd2_bglt BgL_mz00_29)
{
{ /* Llib/mpg123.scm 256 */
{ /* Llib/mpg123.scm 258 */
double BgL_volz00_167;
BgL_volz00_167 = 
bgl_mpg123_getvolume(
(((BgL_mpg123zd2handlezd2_bglt)COBJECT(BgL_mz00_29))->BgL_z42builtinz42)); 
if(
(BgL_volz00_167<((double)0.0)))
{ /* Llib/mpg123.scm 260 */
BgL_z62mpg123zd2errorzb0_bglt BgL_arg1336z00_169;
{ /* Llib/mpg123.scm 260 */
BgL_z62mpg123zd2errorzb0_bglt BgL_new1083z00_170;
{ /* Llib/mpg123.scm 260 */
BgL_z62mpg123zd2errorzb0_bglt BgL_new1082z00_173;
BgL_new1082z00_173 = 
((BgL_z62mpg123zd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62mpg123zd2errorzb0_bgl) ))); 
{ /* Llib/mpg123.scm 260 */
long BgL_arg1347z00_174;
{ /* Llib/mpg123.scm 260 */
long BgL_res1716z00_428;
BgL_res1716z00_428 = 
BGL_CLASS_INDEX(BGl_z62mpg123zd2errorzb0zz__mpg123_mpg123z00); 
BgL_arg1347z00_174 = BgL_res1716z00_428; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1082z00_173), BgL_arg1347z00_174); } 
BgL_new1083z00_170 = BgL_new1082z00_173; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1083z00_170)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1083z00_170)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_1234;
{ /* Llib/mpg123.scm 260 */
obj_t BgL_arg1337z00_171;
{ /* Llib/mpg123.scm 260 */
obj_t BgL_arg1338z00_172;
{ /* Llib/mpg123.scm 260 */
obj_t BgL_res1717z00_432;
{ /* Llib/mpg123.scm 260 */
obj_t BgL_classz00_431;
BgL_classz00_431 = BGl_z62mpg123zd2errorzb0zz__mpg123_mpg123z00; 
BgL_res1717z00_432 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_431); } 
BgL_arg1338z00_172 = BgL_res1717z00_432; } 
BgL_arg1337z00_171 = 
VECTOR_REF(BgL_arg1338z00_172,((long)2)); } 
BgL_auxz00_1234 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1337z00_171); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1083z00_170)))->BgL_stackz00)=((obj_t)BgL_auxz00_1234),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1083z00_170)))->BgL_procz00)=((obj_t)BGl_string1788z00zz__mpg123_mpg123z00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1083z00_170)))->BgL_msgz00)=((obj_t)BGl_string1815z00zz__mpg123_mpg123z00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1083z00_170)))->BgL_objz00)=((obj_t)
((obj_t)BgL_mz00_29)),BUNSPEC); 
BgL_arg1336z00_169 = BgL_new1083z00_170; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1336z00_169));}  else 
{ /* Llib/mpg123.scm 264 */
double BgL_arg1348z00_175;
BgL_arg1348z00_175 = 
BGl_roundflz00zz__r4_numbers_6_5_flonumz00(
(((double)100.0)*
sqrt(BgL_volz00_167))); 
return 
BINT(
(long)(BgL_arg1348z00_175));} } } 

}



/* &mpg123-volume-get */
obj_t BGl_z62mpg123zd2volumezd2getz62zz__mpg123_mpg123z00(obj_t BgL_envz00_552, obj_t BgL_mz00_553)
{
{ /* Llib/mpg123.scm 256 */
{ /* Llib/mpg123.scm 257 */
BgL_mpg123zd2handlezd2_bglt BgL_auxz00_1254;
if(
BGl_isazf3zf3zz__objectz00(BgL_mz00_553, BGl_mpg123zd2handlezd2zz__mpg123_mpg123z00))
{ /* Llib/mpg123.scm 257 */
BgL_auxz00_1254 = 
((BgL_mpg123zd2handlezd2_bglt)BgL_mz00_553)
; }  else 
{ 
obj_t BgL_auxz00_1258;
BgL_auxz00_1258 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1789z00zz__mpg123_mpg123z00, 
BINT(((long)11999)), BGl_string1816z00zz__mpg123_mpg123z00, BGl_string1791z00zz__mpg123_mpg123z00, BgL_mz00_553); 
FAILURE(BgL_auxz00_1258,BFALSE,BFALSE);} 
return 
BGl_mpg123zd2volumezd2getz00zz__mpg123_mpg123z00(BgL_auxz00_1254);} } 

}



/* mpg123-volume-set! */
BGL_EXPORTED_DEF obj_t BGl_mpg123zd2volumezd2setz12z12zz__mpg123_mpg123z00(BgL_mpg123zd2handlezd2_bglt BgL_mz00_30, obj_t BgL_volz00_31)
{
{ /* Llib/mpg123.scm 269 */
{ /* Llib/mpg123.scm 271 */
double BgL_vz00_180;
BgL_vz00_180 = 
(
(double)(
(long)CINT(BgL_volz00_31))/((double)100.0)); 
{ /* Llib/mpg123.scm 271 */
double BgL_v2z00_181;
BgL_v2z00_181 = 
(BgL_vz00_180*BgL_vz00_180); 
{ /* Llib/mpg123.scm 272 */

{ /* Llib/mpg123.scm 273 */
int BgL_errz00_182;
{ /* Llib/mpg123.scm 273 */
mpg123_handle * BgL_tmpz00_1267;
BgL_tmpz00_1267 = 
(((BgL_mpg123zd2handlezd2_bglt)COBJECT(BgL_mz00_30))->BgL_z42builtinz42); 
BgL_errz00_182 = 
mpg123_volume(BgL_tmpz00_1267, BgL_v2z00_181); } 
if(
(
(long)(BgL_errz00_182)<((long)0)))
{ /* Llib/mpg123.scm 275 */
BgL_z62mpg123zd2errorzb0_bglt BgL_arg1383z00_184;
{ /* Llib/mpg123.scm 275 */
BgL_z62mpg123zd2errorzb0_bglt BgL_new1086z00_185;
{ /* Llib/mpg123.scm 275 */
BgL_z62mpg123zd2errorzb0_bglt BgL_new1085z00_188;
BgL_new1085z00_188 = 
((BgL_z62mpg123zd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62mpg123zd2errorzb0_bgl) ))); 
{ /* Llib/mpg123.scm 275 */
long BgL_arg1506z00_189;
{ /* Llib/mpg123.scm 275 */
long BgL_res1725z00_452;
BgL_res1725z00_452 = 
BGL_CLASS_INDEX(BGl_z62mpg123zd2errorzb0zz__mpg123_mpg123z00); 
BgL_arg1506z00_189 = BgL_res1725z00_452; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1085z00_188), BgL_arg1506z00_189); } 
BgL_new1086z00_185 = BgL_new1085z00_188; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1086z00_185)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1086z00_185)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_1281;
{ /* Llib/mpg123.scm 275 */
obj_t BgL_arg1384z00_186;
{ /* Llib/mpg123.scm 275 */
obj_t BgL_arg1505z00_187;
{ /* Llib/mpg123.scm 275 */
obj_t BgL_res1726z00_456;
{ /* Llib/mpg123.scm 275 */
obj_t BgL_classz00_455;
BgL_classz00_455 = BGl_z62mpg123zd2errorzb0zz__mpg123_mpg123z00; 
BgL_res1726z00_456 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_455); } 
BgL_arg1505z00_187 = BgL_res1726z00_456; } 
BgL_arg1384z00_186 = 
VECTOR_REF(BgL_arg1505z00_187,((long)2)); } 
BgL_auxz00_1281 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1384z00_186); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1086z00_185)))->BgL_stackz00)=((obj_t)BgL_auxz00_1281),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1086z00_185)))->BgL_procz00)=((obj_t)BGl_string1788z00zz__mpg123_mpg123z00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1086z00_185)))->BgL_msgz00)=((obj_t)
string_to_bstring(
(char *)mpg123_plain_strerror(BgL_errz00_182))),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1086z00_185)))->BgL_objz00)=((obj_t)
((obj_t)BgL_mz00_30)),BUNSPEC); 
BgL_arg1383z00_184 = BgL_new1086z00_185; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1383z00_184));}  else 
{ /* Llib/mpg123.scm 274 */
return BFALSE;} } } } } } 

}



/* &mpg123-volume-set! */
obj_t BGl_z62mpg123zd2volumezd2setz12z70zz__mpg123_mpg123z00(obj_t BgL_envz00_554, obj_t BgL_mz00_555, obj_t BgL_volz00_556)
{
{ /* Llib/mpg123.scm 269 */
{ /* Llib/mpg123.scm 270 */
BgL_mpg123zd2handlezd2_bglt BgL_auxz00_1298;
if(
BGl_isazf3zf3zz__objectz00(BgL_mz00_555, BGl_mpg123zd2handlezd2zz__mpg123_mpg123z00))
{ /* Llib/mpg123.scm 270 */
BgL_auxz00_1298 = 
((BgL_mpg123zd2handlezd2_bglt)BgL_mz00_555)
; }  else 
{ 
obj_t BgL_auxz00_1302;
BgL_auxz00_1302 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1789z00zz__mpg123_mpg123z00, 
BINT(((long)12556)), BGl_string1817z00zz__mpg123_mpg123z00, BGl_string1791z00zz__mpg123_mpg123z00, BgL_mz00_555); 
FAILURE(BgL_auxz00_1302,BFALSE,BFALSE);} 
return 
BGl_mpg123zd2volumezd2setz12z12zz__mpg123_mpg123z00(BgL_auxz00_1298, BgL_volz00_556);} } 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__mpg123_mpg123z00()
{
{ /* Llib/mpg123.scm 15 */
{ /* Llib/mpg123.scm 21 */
obj_t BgL_arg1545z00_195;obj_t BgL_arg1546z00_196;
{ /* Llib/mpg123.scm 21 */
obj_t BgL_v1096z00_210;
BgL_v1096z00_210 = 
create_vector(((long)3)); 
{ /* Llib/mpg123.scm 21 */
obj_t BgL_arg1563z00_211;
BgL_arg1563z00_211 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)31)), BGl_proc1820z00zz__mpg123_mpg123z00, BGl_proc1819z00zz__mpg123_mpg123z00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1818z00zz__mpg123_mpg123z00, 
CNST_TABLE_REF(((long)32))); 
VECTOR_SET(BgL_v1096z00_210,((long)0),BgL_arg1563z00_211); } 
{ /* Llib/mpg123.scm 21 */
obj_t BgL_arg1590z00_224;
BgL_arg1590z00_224 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)33)), BGl_proc1823z00zz__mpg123_mpg123z00, BGl_proc1822z00zz__mpg123_mpg123z00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc1821z00zz__mpg123_mpg123z00, 
CNST_TABLE_REF(((long)34))); 
VECTOR_SET(BgL_v1096z00_210,((long)1),BgL_arg1590z00_224); } 
{ /* Llib/mpg123.scm 21 */
obj_t BgL_arg1616z00_237;
BgL_arg1616z00_237 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)35)), BGl_proc1826z00zz__mpg123_mpg123z00, BGl_proc1825z00zz__mpg123_mpg123z00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1824z00zz__mpg123_mpg123z00, 
CNST_TABLE_REF(((long)36))); 
VECTOR_SET(BgL_v1096z00_210,((long)2),BgL_arg1616z00_237); } 
BgL_arg1545z00_195 = BgL_v1096z00_210; } 
{ /* Llib/mpg123.scm 21 */
obj_t BgL_v1097z00_250;
BgL_v1097z00_250 = 
create_vector(((long)0)); 
BgL_arg1546z00_196 = BgL_v1097z00_250; } 
BGl_mpg123zd2handlezd2zz__mpg123_mpg123z00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)37)), 
CNST_TABLE_REF(((long)38)), BGl_objectz00zz__objectz00, ((long)38616), BGl_proc1829z00zz__mpg123_mpg123z00, BGl_proc1828z00zz__mpg123_mpg123z00, BGl_mpg123zd2handlezd2initzd2envzd2zz__mpg123_mpg123z00, BGl_proc1827z00zz__mpg123_mpg123z00, BFALSE, BgL_arg1545z00_195, BgL_arg1546z00_196); } 
{ /* Llib/mpg123.scm 27 */
obj_t BgL_arg1649z00_257;obj_t BgL_arg1650z00_258;
{ /* Llib/mpg123.scm 27 */
obj_t BgL_v1098z00_274;
BgL_v1098z00_274 = 
create_vector(((long)0)); 
BgL_arg1649z00_257 = BgL_v1098z00_274; } 
{ /* Llib/mpg123.scm 27 */
obj_t BgL_v1099z00_275;
BgL_v1099z00_275 = 
create_vector(((long)0)); 
BgL_arg1650z00_258 = BgL_v1099z00_275; } 
return ( 
BGl_z62mpg123zd2errorzb0zz__mpg123_mpg123z00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)39)), 
CNST_TABLE_REF(((long)38)), BGl_z62errorz62zz__objectz00, ((long)29460), BGl_proc1832z00zz__mpg123_mpg123z00, BGl_proc1831z00zz__mpg123_mpg123z00, BFALSE, BGl_proc1830z00zz__mpg123_mpg123z00, BFALSE, BgL_arg1649z00_257, BgL_arg1650z00_258), BUNSPEC) ;} } 

}



/* &<@anonymous:1659> */
obj_t BGl_z62zc3z04anonymousza31659ze3ze5zz__mpg123_mpg123z00(obj_t BgL_envz00_572, obj_t BgL_new1062z00_573)
{
{ /* Llib/mpg123.scm 27 */
{ 
BgL_z62mpg123zd2errorzb0_bglt BgL_auxz00_1329;
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)
((BgL_z62mpg123zd2errorzb0_bglt)BgL_new1062z00_573))))->BgL_fnamez00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)
((BgL_z62mpg123zd2errorzb0_bglt)BgL_new1062z00_573))))->BgL_locationz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)
((BgL_z62mpg123zd2errorzb0_bglt)BgL_new1062z00_573))))->BgL_stackz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)
((BgL_z62mpg123zd2errorzb0_bglt)BgL_new1062z00_573))))->BgL_procz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)
((BgL_z62mpg123zd2errorzb0_bglt)BgL_new1062z00_573))))->BgL_msgz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)
((BgL_z62mpg123zd2errorzb0_bglt)BgL_new1062z00_573))))->BgL_objz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_1329 = 
((BgL_z62mpg123zd2errorzb0_bglt)BgL_new1062z00_573); 
return 
((obj_t)BgL_auxz00_1329);} } 

}



/* &lambda1656 */
BgL_z62mpg123zd2errorzb0_bglt BGl_z62lambda1656z62zz__mpg123_mpg123z00(obj_t BgL_envz00_574)
{
{ /* Llib/mpg123.scm 27 */
{ /* Llib/mpg123.scm 27 */
BgL_z62mpg123zd2errorzb0_bglt BgL_new1061z00_690;
BgL_new1061z00_690 = 
((BgL_z62mpg123zd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62mpg123zd2errorzb0_bgl) ))); 
{ /* Llib/mpg123.scm 27 */
long BgL_arg1658z00_691;
{ /* Llib/mpg123.scm 27 */
long BgL_res1730z00_692;
BgL_res1730z00_692 = 
BGL_CLASS_INDEX(BGl_z62mpg123zd2errorzb0zz__mpg123_mpg123z00); 
BgL_arg1658z00_691 = BgL_res1730z00_692; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1061z00_690), BgL_arg1658z00_691); } 
return BgL_new1061z00_690;} } 

}



/* &lambda1651 */
BgL_z62mpg123zd2errorzb0_bglt BGl_z62lambda1651z62zz__mpg123_mpg123z00(obj_t BgL_envz00_575, obj_t BgL_fname1054z00_576, obj_t BgL_location1055z00_577, obj_t BgL_stack1056z00_578, obj_t BgL_proc1057z00_579, obj_t BgL_msg1058z00_580, obj_t BgL_obj1059z00_581)
{
{ /* Llib/mpg123.scm 27 */
{ /* Llib/mpg123.scm 27 */
BgL_z62mpg123zd2errorzb0_bglt BgL_new1090z00_693;
{ /* Llib/mpg123.scm 27 */
BgL_z62mpg123zd2errorzb0_bglt BgL_new1089z00_694;
BgL_new1089z00_694 = 
((BgL_z62mpg123zd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62mpg123zd2errorzb0_bgl) ))); 
{ /* Llib/mpg123.scm 27 */
long BgL_arg1655z00_695;
{ /* Llib/mpg123.scm 27 */
long BgL_res1729z00_696;
BgL_res1729z00_696 = 
BGL_CLASS_INDEX(BGl_z62mpg123zd2errorzb0zz__mpg123_mpg123z00); 
BgL_arg1655z00_695 = BgL_res1729z00_696; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1089z00_694), BgL_arg1655z00_695); } 
BgL_new1090z00_693 = BgL_new1089z00_694; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1090z00_693)))->BgL_fnamez00)=((obj_t)BgL_fname1054z00_576),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1090z00_693)))->BgL_locationz00)=((obj_t)BgL_location1055z00_577),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1090z00_693)))->BgL_stackz00)=((obj_t)BgL_stack1056z00_578),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1090z00_693)))->BgL_procz00)=((obj_t)BgL_proc1057z00_579),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1090z00_693)))->BgL_msgz00)=((obj_t)BgL_msg1058z00_580),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1090z00_693)))->BgL_objz00)=((obj_t)BgL_obj1059z00_581),BUNSPEC); 
return BgL_new1090z00_693;} } 

}



/* &<@anonymous:1561> */
obj_t BGl_z62zc3z04anonymousza31561ze3ze5zz__mpg123_mpg123z00(obj_t BgL_envz00_582, obj_t BgL_new1052z00_583)
{
{ /* Llib/mpg123.scm 21 */
{ 
BgL_mpg123zd2handlezd2_bglt BgL_auxz00_1370;
((((BgL_mpg123zd2handlezd2_bglt)COBJECT(
((BgL_mpg123zd2handlezd2_bglt)BgL_new1052z00_583)))->BgL_z42builtinz42)=((mpg123_handle *)
0L),BUNSPEC); 
((((BgL_mpg123zd2handlezd2_bglt)COBJECT(
((BgL_mpg123zd2handlezd2_bglt)BgL_new1052z00_583)))->BgL_decoderz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_mpg123zd2handlezd2_bglt)COBJECT(
((BgL_mpg123zd2handlezd2_bglt)BgL_new1052z00_583)))->BgL_siza7eza7)=((long)((long)0)),BUNSPEC); 
BgL_auxz00_1370 = 
((BgL_mpg123zd2handlezd2_bglt)BgL_new1052z00_583); 
return 
((obj_t)BgL_auxz00_1370);} } 

}



/* &lambda1550 */
BgL_mpg123zd2handlezd2_bglt BGl_z62lambda1550z62zz__mpg123_mpg123z00(obj_t BgL_envz00_584)
{
{ /* Llib/mpg123.scm 21 */
{ /* Llib/mpg123.scm 21 */
BgL_mpg123zd2handlezd2_bglt BgL_new1051z00_698;
BgL_new1051z00_698 = 
((BgL_mpg123zd2handlezd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_mpg123zd2handlezd2_bgl) ))); 
{ /* Llib/mpg123.scm 21 */
long BgL_arg1560z00_699;
{ /* Llib/mpg123.scm 21 */
long BgL_res1728z00_700;
BgL_res1728z00_700 = 
BGL_CLASS_INDEX(BGl_mpg123zd2handlezd2zz__mpg123_mpg123z00); 
BgL_arg1560z00_699 = BgL_res1728z00_700; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1051z00_698), BgL_arg1560z00_699); } 
return BgL_new1051z00_698;} } 

}



/* &lambda1547 */
BgL_mpg123zd2handlezd2_bglt BGl_z62lambda1547z62zz__mpg123_mpg123z00(obj_t BgL_envz00_585, obj_t BgL_z42builtin1048z42_586, obj_t BgL_decoder1049z00_587, obj_t BgL_siza7e1050za7_588)
{
{ /* Llib/mpg123.scm 21 */
{ /* Llib/mpg123.scm 21 */
mpg123_handle * BgL_z42builtin1048z42_701;long BgL_siza7e1050za7_702;
BgL_z42builtin1048z42_701 = 
FOREIGN_TO_COBJ(BgL_z42builtin1048z42_586); 
BgL_siza7e1050za7_702 = 
(long)CINT(BgL_siza7e1050za7_588); 
{ /* Llib/mpg123.scm 21 */
BgL_mpg123zd2handlezd2_bglt BgL_new1088z00_703;
{ /* Llib/mpg123.scm 21 */
BgL_mpg123zd2handlezd2_bglt BgL_new1087z00_704;
BgL_new1087z00_704 = 
((BgL_mpg123zd2handlezd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_mpg123zd2handlezd2_bgl) ))); 
{ /* Llib/mpg123.scm 21 */
long BgL_arg1549z00_705;
{ /* Llib/mpg123.scm 21 */
long BgL_res1727z00_706;
BgL_res1727z00_706 = 
BGL_CLASS_INDEX(BGl_mpg123zd2handlezd2zz__mpg123_mpg123z00); 
BgL_arg1549z00_705 = BgL_res1727z00_706; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1087z00_704), BgL_arg1549z00_705); } 
BgL_new1088z00_703 = BgL_new1087z00_704; } 
((((BgL_mpg123zd2handlezd2_bglt)COBJECT(BgL_new1088z00_703))->BgL_z42builtinz42)=((mpg123_handle *)BgL_z42builtin1048z42_701),BUNSPEC); 
((((BgL_mpg123zd2handlezd2_bglt)COBJECT(BgL_new1088z00_703))->BgL_decoderz00)=((obj_t)BgL_decoder1049z00_587),BUNSPEC); 
((((BgL_mpg123zd2handlezd2_bglt)COBJECT(BgL_new1088z00_703))->BgL_siza7eza7)=((long)BgL_siza7e1050za7_702),BUNSPEC); 
{ /* Llib/mpg123.scm 21 */
obj_t BgL_fun1548z00_707;
BgL_fun1548z00_707 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_mpg123zd2handlezd2zz__mpg123_mpg123z00); 
PROCEDURE_ENTRY(BgL_fun1548z00_707)(BgL_fun1548z00_707, 
((obj_t)BgL_new1088z00_703), BEOA); } 
return BgL_new1088z00_703;} } } 

}



/* &<@anonymous:1627> */
obj_t BGl_z62zc3z04anonymousza31627ze3ze5zz__mpg123_mpg123z00(obj_t BgL_envz00_589)
{
{ /* Llib/mpg123.scm 21 */
return 
BINT(((long)0));} 

}



/* &lambda1626 */
obj_t BGl_z62lambda1626z62zz__mpg123_mpg123z00(obj_t BgL_envz00_590, obj_t BgL_oz00_591, obj_t BgL_vz00_592)
{
{ /* Llib/mpg123.scm 21 */
{ /* Llib/mpg123.scm 21 */
long BgL_vz00_709;
BgL_vz00_709 = 
(long)CINT(BgL_vz00_592); 
return 
((((BgL_mpg123zd2handlezd2_bglt)COBJECT(
((BgL_mpg123zd2handlezd2_bglt)BgL_oz00_591)))->BgL_siza7eza7)=((long)BgL_vz00_709),BUNSPEC);} } 

}



/* &lambda1625 */
obj_t BGl_z62lambda1625z62zz__mpg123_mpg123z00(obj_t BgL_envz00_593, obj_t BgL_oz00_594)
{
{ /* Llib/mpg123.scm 21 */
return 
BINT(
(((BgL_mpg123zd2handlezd2_bglt)COBJECT(
((BgL_mpg123zd2handlezd2_bglt)BgL_oz00_594)))->BgL_siza7eza7));} 

}



/* &<@anonymous:1615> */
obj_t BGl_z62zc3z04anonymousza31615ze3ze5zz__mpg123_mpg123z00(obj_t BgL_envz00_595)
{
{ /* Llib/mpg123.scm 21 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda1614 */
obj_t BGl_z62lambda1614z62zz__mpg123_mpg123z00(obj_t BgL_envz00_596, obj_t BgL_oz00_597, obj_t BgL_vz00_598)
{
{ /* Llib/mpg123.scm 21 */
return 
((((BgL_mpg123zd2handlezd2_bglt)COBJECT(
((BgL_mpg123zd2handlezd2_bglt)BgL_oz00_597)))->BgL_decoderz00)=((obj_t)BgL_vz00_598),BUNSPEC);} 

}



/* &lambda1613 */
obj_t BGl_z62lambda1613z62zz__mpg123_mpg123z00(obj_t BgL_envz00_599, obj_t BgL_oz00_600)
{
{ /* Llib/mpg123.scm 21 */
return 
(((BgL_mpg123zd2handlezd2_bglt)COBJECT(
((BgL_mpg123zd2handlezd2_bglt)BgL_oz00_600)))->BgL_decoderz00);} 

}



/* &<@anonymous:1582> */
obj_t BGl_z62zc3z04anonymousza31582ze3ze5zz__mpg123_mpg123z00(obj_t BgL_envz00_601)
{
{ /* Llib/mpg123.scm 21 */
return 
void_star_to_obj((mpg123_handle *)0L);} 

}



/* &lambda1581 */
obj_t BGl_z62lambda1581z62zz__mpg123_mpg123z00(obj_t BgL_envz00_602, obj_t BgL_oz00_603, obj_t BgL_vz00_604)
{
{ /* Llib/mpg123.scm 21 */
{ /* Llib/mpg123.scm 21 */
mpg123_handle * BgL_vz00_714;
BgL_vz00_714 = 
FOREIGN_TO_COBJ(BgL_vz00_604); 
return 
((((BgL_mpg123zd2handlezd2_bglt)COBJECT(
((BgL_mpg123zd2handlezd2_bglt)BgL_oz00_603)))->BgL_z42builtinz42)=((mpg123_handle *)BgL_vz00_714),BUNSPEC);} } 

}



/* &lambda1580 */
obj_t BGl_z62lambda1580z62zz__mpg123_mpg123z00(obj_t BgL_envz00_605, obj_t BgL_oz00_606)
{
{ /* Llib/mpg123.scm 21 */
return 
void_star_to_obj(
(((BgL_mpg123zd2handlezd2_bglt)COBJECT(
((BgL_mpg123zd2handlezd2_bglt)BgL_oz00_606)))->BgL_z42builtinz42));} 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__mpg123_mpg123z00()
{
{ /* Llib/mpg123.scm 15 */
return 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpg123zd2handlezd2initzd2envzd2zz__mpg123_mpg123z00, BGl_proc1833z00zz__mpg123_mpg123z00, BGl_mpg123zd2handlezd2zz__mpg123_mpg123z00, BGl_string1834z00zz__mpg123_mpg123z00);} 

}



/* &mpg123-handle-init1100 */
obj_t BGl_z62mpg123zd2handlezd2init1100z62zz__mpg123_mpg123z00(obj_t BgL_envz00_610, obj_t BgL_oz00_611)
{
{ /* Llib/mpg123.scm 54 */
{ 
BgL_mpg123zd2handlezd2_bglt BgL_auxz00_1419;
{ /* Llib/mpg123.scm 56 */
char * BgL_dz00_717;
{ /* Llib/mpg123.scm 56 */
bool_t BgL_test1960z00_1420;
{ /* Llib/mpg123.scm 56 */
obj_t BgL_tmpz00_1421;
BgL_tmpz00_1421 = 
(((BgL_mpg123zd2handlezd2_bglt)COBJECT(
((BgL_mpg123zd2handlezd2_bglt)BgL_oz00_611)))->BgL_decoderz00); 
BgL_test1960z00_1420 = 
STRINGP(BgL_tmpz00_1421); } 
if(BgL_test1960z00_1420)
{ /* Llib/mpg123.scm 56 */
BgL_dz00_717 = 
BSTRING_TO_STRING(
(((BgL_mpg123zd2handlezd2_bglt)COBJECT(
((BgL_mpg123zd2handlezd2_bglt)BgL_oz00_611)))->BgL_decoderz00)); }  else 
{ /* Llib/mpg123.scm 56 */
BgL_dz00_717 = ((char *)0L); } } 
((((BgL_mpg123zd2handlezd2_bglt)COBJECT(
((BgL_mpg123zd2handlezd2_bglt)BgL_oz00_611)))->BgL_z42builtinz42)=((mpg123_handle *)
bgl_mpg123_new(BgL_dz00_717)),BUNSPEC); } 
{ /* Llib/mpg123.scm 58 */
mpg123_handle * BgL_tmpz00_1431;
BgL_tmpz00_1431 = 
(((BgL_mpg123zd2handlezd2_bglt)COBJECT(
((BgL_mpg123zd2handlezd2_bglt)BgL_oz00_611)))->BgL_z42builtinz42); 
mpg123_open_feed(BgL_tmpz00_1431); } 
BgL_auxz00_1419 = 
((BgL_mpg123zd2handlezd2_bglt)BgL_oz00_611); 
return 
((obj_t)BgL_auxz00_1419);} } 

}



/* mpg123-handle-init */
BGL_EXPORTED_DEF BgL_mpg123zd2handlezd2_bglt BGl_mpg123zd2handlezd2initz00zz__mpg123_mpg123z00(BgL_mpg123zd2handlezd2_bglt BgL_oz00_3)
{
{ /* Llib/mpg123.scm 54 */
{ /* Llib/mpg123.scm 54 */
obj_t BgL_method1101z00_289;
{ /* Llib/mpg123.scm 54 */
obj_t BgL_res1742z00_521;
{ /* Llib/mpg123.scm 54 */
long BgL_objzd2classzd2numz00_486;
{ /* Llib/mpg123.scm 54 */
long BgL_res1732z00_489;
BgL_res1732z00_489 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_3)); 
BgL_objzd2classzd2numz00_486 = BgL_res1732z00_489; } 
{ /* Llib/mpg123.scm 54 */
obj_t BgL_arg1745z00_487;
BgL_arg1745z00_487 = 
PROCEDURE_REF(BGl_mpg123zd2handlezd2initzd2envzd2zz__mpg123_mpg123z00, 
(int)(((long)1))); 
{ /* Llib/mpg123.scm 54 */
int BgL_offsetz00_491;
BgL_offsetz00_491 = 
(int)(BgL_objzd2classzd2numz00_486); 
{ /* Llib/mpg123.scm 54 */
long BgL_offsetz00_492;
BgL_offsetz00_492 = 
(
(long)(BgL_offsetz00_491)-OBJECT_TYPE); 
{ /* Llib/mpg123.scm 54 */
long BgL_modz00_493;
BgL_modz00_493 = 
(BgL_offsetz00_492 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpg123.scm 54 */
long BgL_restz00_495;
BgL_restz00_495 = 
(BgL_offsetz00_492 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpg123.scm 54 */

{ /* Llib/mpg123.scm 54 */
obj_t BgL_bucketz00_497;
BgL_bucketz00_497 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_487),BgL_modz00_493); 
BgL_res1742z00_521 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_497),BgL_restz00_495); } } } } } } } } 
BgL_method1101z00_289 = BgL_res1742z00_521; } 
return 
((BgL_mpg123zd2handlezd2_bglt)
PROCEDURE_ENTRY(BgL_method1101z00_289)(BgL_method1101z00_289, 
((obj_t)BgL_oz00_3), BEOA));} } 

}



/* &mpg123-handle-init */
BgL_mpg123zd2handlezd2_bglt BGl_z62mpg123zd2handlezd2initz62zz__mpg123_mpg123z00(obj_t BgL_envz00_607, obj_t BgL_oz00_608)
{
{ /* Llib/mpg123.scm 54 */
{ /* Llib/mpg123.scm 54 */
BgL_mpg123zd2handlezd2_bglt BgL_auxz00_1468;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_608, BGl_mpg123zd2handlezd2zz__mpg123_mpg123z00))
{ /* Llib/mpg123.scm 54 */
BgL_auxz00_1468 = 
((BgL_mpg123zd2handlezd2_bglt)BgL_oz00_608)
; }  else 
{ 
obj_t BgL_auxz00_1472;
BgL_auxz00_1472 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1789z00zz__mpg123_mpg123z00, 
BINT(((long)2480)), BGl_string1835z00zz__mpg123_mpg123z00, BGl_string1791z00zz__mpg123_mpg123z00, BgL_oz00_608); 
FAILURE(BgL_auxz00_1472,BFALSE,BFALSE);} 
return 
BGl_mpg123zd2handlezd2initz00zz__mpg123_mpg123z00(BgL_auxz00_1468);} } 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__mpg123_mpg123z00()
{
{ /* Llib/mpg123.scm 15 */
return BUNSPEC;} 

}

#ifdef __cplusplus
}
#endif
