/*===========================================================================*/
/*   (Llib/mpg123_padec.scm)                                                 */
/*   Bigloo (4.3h)                                                           */
/*   Inria -- Sophia Antipolis (c)       Tue 12 May 2020 08:36:09 AM CEST    */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.3h/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.3h/lib/bigloo/4.3h -I Llib -lib-dir /builddir/build/BUILD/bigloo-4.3h/lib/bigloo/4.3h -unsafe -safee -srfi mpg123 -copt  -copt -fPIC -copt -IClib Llib/mpg123_padec.scm -o objs/mpg123_padec.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>
#include <mpg123.h>
#include <pulse/simple.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_musicdecoderz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_mimetypesz00;
   int BgL_bufferzd2timezd2nearz00;
   int BgL_bufferzd2siza7ezd2nearzd2ratioz75;
   int BgL_periodzd2siza7ezd2nearzd2ratioz75;
   bool_t BgL_z52z12dpausez40;
   bool_t BgL_z52z12dabortz40;
   bool_t BgL_z52z12stopz40;
   obj_t BgL_z52dmutexz52;
   obj_t BgL_z52dcondvz52;
   obj_t BgL_z52doutcondvz52;
} *BgL_musicdecoderz00_bglt;

typedef struct BgL_pulseaudiozd2simplezd2_bgl {
   header_t header;
   obj_t widening;
   pa_simple * BgL_z42builtinz42;
   obj_t BgL_srvnamez00;
   obj_t BgL_namez00;
   obj_t BgL_streamz00;
   long BgL_ratez00;
   long BgL_channelsz00;
   int BgL_bpsz00;
   obj_t BgL_formatz00;
} *BgL_pulseaudiozd2simplezd2_bglt;

typedef struct BgL_pulseaudiomusicz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
   obj_t BgL_inbufz00;
   obj_t BgL_decodersz00;
   obj_t BgL_mkthreadz00;
   obj_t BgL_timeoutz00;
   obj_t BgL_z52decoderz52;
   obj_t BgL_z52bufferz52;
   obj_t BgL_z52nextbufferz52;
   obj_t BgL_z52playlistz52;
   bool_t BgL_z52areadyz52;
   obj_t BgL_z52amutexz52;
   int BgL_z52z12pidz40;
   obj_t BgL_z52acondvz52;
   struct BgL_pulseaudiozd2simplezd2_bgl * BgL_simplez00;
   obj_t BgL_namez00;
} *BgL_pulseaudiomusicz00_bglt;

typedef struct BgL_mpg123zd2decoderzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_mimetypesz00;
   int BgL_bufferzd2timezd2nearz00;
   int BgL_bufferzd2siza7ezd2nearzd2ratioz75;
   int BgL_periodzd2siza7ezd2nearzd2ratioz75;
   bool_t BgL_z52z12dpausez40;
   bool_t BgL_z52z12dabortz40;
   bool_t BgL_z52z12stopz40;
   obj_t BgL_z52dmutexz52;
   obj_t BgL_z52dcondvz52;
   obj_t BgL_z52doutcondvz52;
   obj_t BgL_outbufz00;
   obj_t BgL_z52mpg123z52;
   long BgL_z52z12dseekz40;
   int BgL_z52ratez52;
   int BgL_z52channelsz52;
   obj_t BgL_z52encodingz52;
} *BgL_mpg123zd2decoderzd2_bglt;

typedef struct BgL_mpg123zd2pulseaudiodecoderzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_mimetypesz00;
   int BgL_bufferzd2timezd2nearz00;
   int BgL_bufferzd2siza7ezd2nearzd2ratioz75;
   int BgL_periodzd2siza7ezd2nearzd2ratioz75;
   bool_t BgL_z52z12dpausez40;
   bool_t BgL_z52z12dabortz40;
   bool_t BgL_z52z12stopz40;
   obj_t BgL_z52dmutexz52;
   obj_t BgL_z52dcondvz52;
   obj_t BgL_z52doutcondvz52;
   obj_t BgL_outbufz00;
   obj_t BgL_z52mpg123z52;
   long BgL_z52z12dseekz40;
   int BgL_z52ratez52;
   int BgL_z52channelsz52;
   obj_t BgL_z52encodingz52;
} *BgL_mpg123zd2pulseaudiodecoderzd2_bglt;


extern obj_t BGl_mpg123zd2decoderzd2zz__mpg123_decoderz00;
BGL_EXPORTED_DEF obj_t BGl_mpg123zd2pulseaudiodecoderzd2zz__mpg123_padecz00 = BUNSPEC;
static obj_t BGl_objectzd2initzd2zz__mpg123_padecz00();
BGL_IMPORT obj_t BGl_pulseaudiomusiczd2simplezd2setz12z12zz__pulseaudio_musicz00(BgL_pulseaudiomusicz00_bglt, BgL_pulseaudiozd2simplezd2_bglt);
static obj_t BGl_methodzd2initzd2zz__mpg123_padecz00();
BGL_IMPORT obj_t BGl_conditionzd2variablezd2nilz00zz__threadz00();
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__mpg123_padecz00();
BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_pulseaudiozd2simplezd2zz__pulseaudio_simplez00;
static obj_t BGl_requirezd2initializa7ationz75zz__mpg123_padecz00 = BUNSPEC;
static obj_t BGl_toplevelzd2initzd2zz__mpg123_padecz00();
static obj_t BGl_genericzd2initzd2zz__mpg123_padecz00();
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_mutexzd2nilzd2zz__threadz00();
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31139ze3ze5zz__mpg123_padecz00(obj_t, obj_t);
static obj_t BGl_z62musicdecoderzd2hwparam1107zb0zz__mpg123_padecz00(obj_t, obj_t, obj_t, obj_t);
static BgL_mpg123zd2pulseaudiodecoderzd2_bglt BGl_z62lambda1133z62zz__mpg123_padecz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_mpg123zd2pulseaudiodecoderzd2_bglt BGl_z62lambda1137z62zz__mpg123_padecz00(obj_t);
BGL_IMPORT obj_t BGl_classzd2constructorzd2zz__objectz00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__mpg123_padecz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__mpg123_decoderz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__mpg123_mpg123z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__pulseaudio_pulseaudioz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__pulseaudio_musicz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__pulseaudio_simplez00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2musicbufzd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
static obj_t BGl_cnstzd2initzd2zz__mpg123_padecz00();
static obj_t BGl_libraryzd2moduleszd2initz00zz__mpg123_padecz00();
static obj_t BGl_importedzd2moduleszd2initz00zz__mpg123_padecz00();
BGL_IMPORT obj_t BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(obj_t);
static obj_t __cnst[ 3 ] ;


DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1156z00zz__mpg123_padecz00, BgL_bgl_za762za7c3za704anonymo1167za7, BGl_z62zc3z04anonymousza31139ze3ze5zz__mpg123_padecz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1157z00zz__mpg123_padecz00, BgL_bgl_za762lambda1137za7621168z00, BGl_z62lambda1137z62zz__mpg123_padecz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1158z00zz__mpg123_padecz00, BgL_bgl_za762lambda1133za7621169z00, BGl_z62lambda1133z62zz__mpg123_padecz00, 0L, BUNSPEC, 16 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1160z00zz__mpg123_padecz00, BgL_bgl_za762musicdecoderza71170z00, BGl_z62musicdecoderzd2hwparam1107zb0zz__mpg123_padecz00, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string1155z00zz__mpg123_padecz00, BgL_bgl_string1155za700za7za7_1171za7, "Llib/mpg123_padec.scm", 21 );
DEFINE_STRING( BGl_string1159z00zz__mpg123_padecz00, BgL_bgl_string1159za700za7za7_1172za7, "", 0 );
DEFINE_STRING( BGl_string1161z00zz__mpg123_padecz00, BgL_bgl_string1161za700za7za7_1173za7, "musicdecoder-hwparams-set!", 26 );
DEFINE_STRING( BGl_string1162z00zz__mpg123_padecz00, BgL_bgl_string1162za700za7za7_1174za7, "__mpg123_padec", 14 );
DEFINE_STRING( BGl_string1163z00zz__mpg123_padecz00, BgL_bgl_string1163za700za7za7_1175za7, "_ __mpg123_padec mpg123-pulseaudiodecoder ", 42 );
BGL_IMPORT obj_t BGl_musicdecoderzd2initzd2envz00zz__multimediazd2musicbufzd2;
BGL_IMPORT obj_t BGl_musicdecoderzd2hwparamszd2setz12zd2envzc0zz__multimediazd2musicbufzd2;

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_mpg123zd2pulseaudiodecoderzd2zz__mpg123_padecz00) );
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__mpg123_padecz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__mpg123_padecz00(long BgL_checksumz00_166, char * BgL_fromz00_167)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__mpg123_padecz00))
{ 
BGl_requirezd2initializa7ationz75zz__mpg123_padecz00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__mpg123_padecz00(); 
BGl_libraryzd2moduleszd2initz00zz__mpg123_padecz00(); 
BGl_cnstzd2initzd2zz__mpg123_padecz00(); 
BGl_importedzd2moduleszd2initz00zz__mpg123_padecz00(); 
BGl_objectzd2initzd2zz__mpg123_padecz00(); 
BGl_methodzd2initzd2zz__mpg123_padecz00(); 
return 
BGl_toplevelzd2initzd2zz__mpg123_padecz00();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__mpg123_padecz00()
{
{ /* Llib/mpg123_padec.scm 15 */
BGl_modulezd2initializa7ationz75zz__pulseaudio_musicz00(((long)0), "__mpg123_padec"); 
BGl_modulezd2initializa7ationz75zz__threadz00(((long)0), "__mpg123_padec"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__mpg123_padec"); 
BGl_modulezd2initializa7ationz75zz__pulseaudio_simplez00(((long)0), "__mpg123_padec"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__mpg123_padec"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__mpg123_padec"); 
BGl_modulezd2initializa7ationz75zz__pulseaudio_pulseaudioz00(((long)0), "__mpg123_padec"); 
BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(((long)0), "__mpg123_padec"); 
BGl_modulezd2initializa7ationz75zz__multimediazd2musicbufzd2(((long)0), "__mpg123_padec"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__mpg123_padec"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__mpg123_padec"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__mpg123_padecz00()
{
{ /* Llib/mpg123_padec.scm 15 */
{ /* Llib/mpg123_padec.scm 15 */
obj_t BgL_cportz00_118;
{ /* Llib/mpg123_padec.scm 15 */
obj_t BgL_stringz00_126;
BgL_stringz00_126 = BGl_string1163z00zz__mpg123_padecz00; 
{ /* Llib/mpg123_padec.scm 15 */
obj_t BgL_startz00_127;
BgL_startz00_127 = 
BINT(((long)0)); 
{ /* Llib/mpg123_padec.scm 15 */
obj_t BgL_endz00_128;
BgL_endz00_128 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_126))); 
{ /* Llib/mpg123_padec.scm 15 */

BgL_cportz00_118 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_126, BgL_startz00_127, BgL_endz00_128); } } } } 
{ 
long BgL_iz00_119;
BgL_iz00_119 = ((long)2); 
BgL_loopz00_120:
if(
(BgL_iz00_119==((long)-1)))
{ /* Llib/mpg123_padec.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/mpg123_padec.scm 15 */
{ /* Llib/mpg123_padec.scm 15 */
obj_t BgL_arg1165z00_122;
{ /* Llib/mpg123_padec.scm 15 */

{ /* Llib/mpg123_padec.scm 15 */
obj_t BgL_locationz00_124;
BgL_locationz00_124 = 
BBOOL(((bool_t)0)); 
{ /* Llib/mpg123_padec.scm 15 */

BgL_arg1165z00_122 = 
BGl_readz00zz__readerz00(BgL_cportz00_118, BgL_locationz00_124); } } } 
{ /* Llib/mpg123_padec.scm 15 */
int BgL_tmpz00_198;
BgL_tmpz00_198 = 
(int)(BgL_iz00_119); 
CNST_TABLE_SET(BgL_tmpz00_198, BgL_arg1165z00_122); } } 
{ /* Llib/mpg123_padec.scm 15 */
int BgL_auxz00_125;
BgL_auxz00_125 = 
(int)(
(BgL_iz00_119-((long)1))); 
{ 
long BgL_iz00_203;
BgL_iz00_203 = 
(long)(BgL_auxz00_125); 
BgL_iz00_119 = BgL_iz00_203; 
goto BgL_loopz00_120;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__mpg123_padecz00()
{
{ /* Llib/mpg123_padec.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__mpg123_padecz00()
{
{ /* Llib/mpg123_padec.scm 15 */
BGl_modulezd2initializa7ationz75zz__pulseaudio_pulseaudioz00(((long)0), 
BSTRING_TO_STRING(BGl_string1155z00zz__mpg123_padecz00)); 
BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(((long)0), 
BSTRING_TO_STRING(BGl_string1155z00zz__mpg123_padecz00)); 
return BUNSPEC;} 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__mpg123_padecz00()
{
{ /* Llib/mpg123_padec.scm 15 */
{ /* Llib/mpg123_padec.scm 28 */
obj_t BgL_arg1118z00_17;obj_t BgL_arg1132z00_18;
{ /* Llib/mpg123_padec.scm 28 */
obj_t BgL_v1104z00_45;
BgL_v1104z00_45 = 
create_vector(((long)0)); 
BgL_arg1118z00_17 = BgL_v1104z00_45; } 
{ /* Llib/mpg123_padec.scm 28 */
obj_t BgL_v1105z00_46;
BgL_v1105z00_46 = 
create_vector(((long)0)); 
BgL_arg1132z00_18 = BgL_v1105z00_46; } 
return ( 
BGl_mpg123zd2pulseaudiodecoderzd2zz__mpg123_padecz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)0)), 
CNST_TABLE_REF(((long)1)), BGl_mpg123zd2decoderzd2zz__mpg123_decoderz00, ((long)4890), BGl_proc1158z00zz__mpg123_padecz00, BGl_proc1157z00zz__mpg123_padecz00, BGl_musicdecoderzd2initzd2envz00zz__multimediazd2musicbufzd2, BGl_proc1156z00zz__mpg123_padecz00, BFALSE, BgL_arg1118z00_17, BgL_arg1132z00_18), BUNSPEC) ;} } 

}



/* &<@anonymous:1139> */
obj_t BGl_z62zc3z04anonymousza31139ze3ze5zz__mpg123_padecz00(obj_t BgL_envz00_87, obj_t BgL_new1097z00_88)
{
{ /* Llib/mpg123_padec.scm 28 */
{ 
BgL_mpg123zd2pulseaudiodecoderzd2_bglt BgL_auxz00_215;
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2pulseaudiodecoderzd2_bglt)BgL_new1097z00_88))))->BgL_mimetypesz00)=((obj_t)BNIL),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2pulseaudiodecoderzd2_bglt)BgL_new1097z00_88))))->BgL_bufferzd2timezd2nearz00)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2pulseaudiodecoderzd2_bglt)BgL_new1097z00_88))))->BgL_bufferzd2siza7ezd2nearzd2ratioz75)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2pulseaudiodecoderzd2_bglt)BgL_new1097z00_88))))->BgL_periodzd2siza7ezd2nearzd2ratioz75)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2pulseaudiodecoderzd2_bglt)BgL_new1097z00_88))))->BgL_z52z12dpausez40)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2pulseaudiodecoderzd2_bglt)BgL_new1097z00_88))))->BgL_z52z12dabortz40)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2pulseaudiodecoderzd2_bglt)BgL_new1097z00_88))))->BgL_z52z12stopz40)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2pulseaudiodecoderzd2_bglt)BgL_new1097z00_88))))->BgL_z52dmutexz52)=((obj_t)
BGl_mutexzd2nilzd2zz__threadz00()),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2pulseaudiodecoderzd2_bglt)BgL_new1097z00_88))))->BgL_z52dcondvz52)=((obj_t)
BGl_conditionzd2variablezd2nilz00zz__threadz00()),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2pulseaudiodecoderzd2_bglt)BgL_new1097z00_88))))->BgL_z52doutcondvz52)=((obj_t)
BGl_conditionzd2variablezd2nilz00zz__threadz00()),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)
((BgL_mpg123zd2pulseaudiodecoderzd2_bglt)BgL_new1097z00_88))))->BgL_outbufz00)=((obj_t)BGl_string1159z00zz__mpg123_padecz00),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)
((BgL_mpg123zd2pulseaudiodecoderzd2_bglt)BgL_new1097z00_88))))->BgL_z52mpg123z52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)
((BgL_mpg123zd2pulseaudiodecoderzd2_bglt)BgL_new1097z00_88))))->BgL_z52z12dseekz40)=((long)((long)0)),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)
((BgL_mpg123zd2pulseaudiodecoderzd2_bglt)BgL_new1097z00_88))))->BgL_z52ratez52)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)
((BgL_mpg123zd2pulseaudiodecoderzd2_bglt)BgL_new1097z00_88))))->BgL_z52channelsz52)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)
((BgL_mpg123zd2pulseaudiodecoderzd2_bglt)BgL_new1097z00_88))))->BgL_z52encodingz52)=((obj_t)
CNST_TABLE_REF(((long)2))),BUNSPEC); 
BgL_auxz00_215 = 
((BgL_mpg123zd2pulseaudiodecoderzd2_bglt)BgL_new1097z00_88); 
return 
((obj_t)BgL_auxz00_215);} } 

}



/* &lambda1137 */
BgL_mpg123zd2pulseaudiodecoderzd2_bglt BGl_z62lambda1137z62zz__mpg123_padecz00(obj_t BgL_envz00_89)
{
{ /* Llib/mpg123_padec.scm 28 */
{ /* Llib/mpg123_padec.scm 28 */
BgL_mpg123zd2pulseaudiodecoderzd2_bglt BgL_new1096z00_132;
BgL_new1096z00_132 = 
((BgL_mpg123zd2pulseaudiodecoderzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_mpg123zd2pulseaudiodecoderzd2_bgl) ))); 
{ /* Llib/mpg123_padec.scm 28 */
long BgL_arg1138z00_133;
{ /* Llib/mpg123_padec.scm 28 */
long BgL_res1147z00_134;
BgL_res1147z00_134 = 
BGL_CLASS_INDEX(BGl_mpg123zd2pulseaudiodecoderzd2zz__mpg123_padecz00); 
BgL_arg1138z00_133 = BgL_res1147z00_134; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1096z00_132), BgL_arg1138z00_133); } 
return BgL_new1096z00_132;} } 

}



/* &lambda1133 */
BgL_mpg123zd2pulseaudiodecoderzd2_bglt BGl_z62lambda1133z62zz__mpg123_padecz00(obj_t BgL_envz00_90, obj_t BgL_mimetypes1080z00_91, obj_t BgL_bufferzd2timezd2near1081z00_92, obj_t BgL_bufferzd2siza7ezd2nearzd2rat1082z75_93, obj_t BgL_periodzd2siza7ezd2nearzd2rat1083z75_94, obj_t BgL_z52z12dpause1084z40_95, obj_t BgL_z52z12dabort1085z40_96, obj_t BgL_z52z12stop1086z40_97, obj_t BgL_z52dmutex1087z52_98, obj_t BgL_z52dcondv1088z52_99, obj_t BgL_z52doutcondv1089z52_100, obj_t BgL_outbuf1090z00_101, obj_t BgL_z52mpg1231091z52_102, obj_t BgL_z52z12dseek1092z40_103, obj_t BgL_z52rate1093z52_104, obj_t BgL_z52channels1094z52_105, obj_t BgL_z52encoding1095z52_106)
{
{ /* Llib/mpg123_padec.scm 28 */
{ /* Llib/mpg123_padec.scm 28 */
int BgL_bufferzd2timezd2near1081z00_136;int BgL_bufferzd2siza7ezd2nearzd2rat1082z75_137;int BgL_periodzd2siza7ezd2nearzd2rat1083z75_138;bool_t BgL_z52z12dpause1084z40_139;bool_t BgL_z52z12dabort1085z40_140;bool_t BgL_z52z12stop1086z40_141;long BgL_z52z12dseek1092z40_146;int BgL_z52rate1093z52_147;int BgL_z52channels1094z52_148;
BgL_bufferzd2timezd2near1081z00_136 = 
CINT(BgL_bufferzd2timezd2near1081z00_92); 
BgL_bufferzd2siza7ezd2nearzd2rat1082z75_137 = 
CINT(BgL_bufferzd2siza7ezd2nearzd2rat1082z75_93); 
BgL_periodzd2siza7ezd2nearzd2rat1083z75_138 = 
CINT(BgL_periodzd2siza7ezd2nearzd2rat1083z75_94); 
BgL_z52z12dpause1084z40_139 = 
CBOOL(BgL_z52z12dpause1084z40_95); 
BgL_z52z12dabort1085z40_140 = 
CBOOL(BgL_z52z12dabort1085z40_96); 
BgL_z52z12stop1086z40_141 = 
CBOOL(BgL_z52z12stop1086z40_97); 
BgL_z52z12dseek1092z40_146 = 
(long)CINT(BgL_z52z12dseek1092z40_103); 
BgL_z52rate1093z52_147 = 
CINT(BgL_z52rate1093z52_104); 
BgL_z52channels1094z52_148 = 
CINT(BgL_z52channels1094z52_105); 
{ /* Llib/mpg123_padec.scm 28 */
BgL_mpg123zd2pulseaudiodecoderzd2_bglt BgL_new1103z00_150;
{ /* Llib/mpg123_padec.scm 28 */
BgL_mpg123zd2pulseaudiodecoderzd2_bglt BgL_new1102z00_151;
BgL_new1102z00_151 = 
((BgL_mpg123zd2pulseaudiodecoderzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_mpg123zd2pulseaudiodecoderzd2_bgl) ))); 
{ /* Llib/mpg123_padec.scm 28 */
long BgL_arg1136z00_152;
{ /* Llib/mpg123_padec.scm 28 */
long BgL_res1146z00_153;
BgL_res1146z00_153 = 
BGL_CLASS_INDEX(BGl_mpg123zd2pulseaudiodecoderzd2zz__mpg123_padecz00); 
BgL_arg1136z00_152 = BgL_res1146z00_153; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1102z00_151), BgL_arg1136z00_152); } 
BgL_new1103z00_150 = BgL_new1102z00_151; } 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1103z00_150)))->BgL_mimetypesz00)=((obj_t)
((obj_t)BgL_mimetypes1080z00_91)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1103z00_150)))->BgL_bufferzd2timezd2nearz00)=((int)BgL_bufferzd2timezd2near1081z00_136),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1103z00_150)))->BgL_bufferzd2siza7ezd2nearzd2ratioz75)=((int)BgL_bufferzd2siza7ezd2nearzd2rat1082z75_137),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1103z00_150)))->BgL_periodzd2siza7ezd2nearzd2ratioz75)=((int)BgL_periodzd2siza7ezd2nearzd2rat1083z75_138),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1103z00_150)))->BgL_z52z12dpausez40)=((bool_t)BgL_z52z12dpause1084z40_139),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1103z00_150)))->BgL_z52z12dabortz40)=((bool_t)BgL_z52z12dabort1085z40_140),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1103z00_150)))->BgL_z52z12stopz40)=((bool_t)BgL_z52z12stop1086z40_141),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1103z00_150)))->BgL_z52dmutexz52)=((obj_t)
((obj_t)BgL_z52dmutex1087z52_98)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1103z00_150)))->BgL_z52dcondvz52)=((obj_t)
((obj_t)BgL_z52dcondv1088z52_99)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1103z00_150)))->BgL_z52doutcondvz52)=((obj_t)
((obj_t)BgL_z52doutcondv1089z52_100)),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_new1103z00_150)))->BgL_outbufz00)=((obj_t)
((obj_t)BgL_outbuf1090z00_101)),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_new1103z00_150)))->BgL_z52mpg123z52)=((obj_t)BgL_z52mpg1231091z52_102),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_new1103z00_150)))->BgL_z52z12dseekz40)=((long)BgL_z52z12dseek1092z40_146),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_new1103z00_150)))->BgL_z52ratez52)=((int)BgL_z52rate1093z52_147),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_new1103z00_150)))->BgL_z52channelsz52)=((int)BgL_z52channels1094z52_148),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_new1103z00_150)))->BgL_z52encodingz52)=((obj_t)
((obj_t)BgL_z52encoding1095z52_106)),BUNSPEC); 
{ /* Llib/mpg123_padec.scm 28 */
obj_t BgL_fun1134z00_154;
BgL_fun1134z00_154 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_mpg123zd2pulseaudiodecoderzd2zz__mpg123_padecz00); 
PROCEDURE_ENTRY(BgL_fun1134z00_154)(BgL_fun1134z00_154, 
((obj_t)BgL_new1103z00_150), BEOA); } 
return BgL_new1103z00_150;} } } 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__mpg123_padecz00()
{
{ /* Llib/mpg123_padec.scm 15 */
return BUNSPEC;} 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__mpg123_padecz00()
{
{ /* Llib/mpg123_padec.scm 15 */
return 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2hwparamszd2setz12zd2envzc0zz__multimediazd2musicbufzd2, BGl_mpg123zd2pulseaudiodecoderzd2zz__mpg123_padecz00, BGl_proc1160z00zz__mpg123_padecz00, BGl_string1161z00zz__mpg123_padecz00);} 

}



/* &musicdecoder-hwparam1107 */
obj_t BGl_z62musicdecoderzd2hwparam1107zb0zz__mpg123_padecz00(obj_t BgL_envz00_110, obj_t BgL_decz00_111, obj_t BgL_amz00_112, obj_t BgL_bufferz00_113)
{
{ /* Llib/mpg123_padec.scm 40 */
{ /* Llib/mpg123_padec.scm 49 */
BgL_pulseaudiozd2simplezd2_bglt BgL_arg1141z00_156;
{ /* Llib/mpg123_padec.scm 49 */
BgL_pulseaudiozd2simplezd2_bglt BgL_new1101z00_157;
{ /* Llib/mpg123_padec.scm 49 */
BgL_pulseaudiozd2simplezd2_bglt BgL_new1100z00_158;
BgL_new1100z00_158 = 
((BgL_pulseaudiozd2simplezd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pulseaudiozd2simplezd2_bgl) ))); 
{ /* Llib/mpg123_padec.scm 49 */
long BgL_arg1145z00_159;
{ /* Llib/mpg123_padec.scm 49 */
long BgL_res1148z00_160;
BgL_res1148z00_160 = 
BGL_CLASS_INDEX(BGl_pulseaudiozd2simplezd2zz__pulseaudio_simplez00); 
BgL_arg1145z00_159 = BgL_res1148z00_160; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1100z00_158), BgL_arg1145z00_159); } 
BgL_new1101z00_157 = BgL_new1100z00_158; } 
{ 
void * BgL_auxz00_341;
{ /* Llib/mpg123_padec.scm 49 */
obj_t BgL_arg1142z00_161;
{ /* Llib/mpg123_padec.scm 49 */
obj_t BgL_arg1143z00_162;
{ /* Llib/mpg123_padec.scm 49 */
obj_t BgL_res1149z00_163;
{ /* Llib/mpg123_padec.scm 49 */
obj_t BgL_classz00_164;
BgL_classz00_164 = BGl_pulseaudiozd2simplezd2zz__pulseaudio_simplez00; 
BgL_res1149z00_163 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_164); } 
BgL_arg1143z00_162 = BgL_res1149z00_163; } 
BgL_arg1142z00_161 = 
VECTOR_REF(BgL_arg1143z00_162,((long)0)); } 
BgL_auxz00_341 = 
FOREIGN_TO_COBJ(
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1142z00_161)); } 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1101z00_157))->BgL_z42builtinz42)=((pa_simple *)BgL_auxz00_341),BUNSPEC); } 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1101z00_157))->BgL_srvnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1101z00_157))->BgL_namez00)=((obj_t)
(((BgL_pulseaudiomusicz00_bglt)COBJECT(
((BgL_pulseaudiomusicz00_bglt)BgL_amz00_112)))->BgL_namez00)),BUNSPEC); 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1101z00_157))->BgL_streamz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1101z00_157))->BgL_ratez00)=((long)
(long)(
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)
((BgL_mpg123zd2pulseaudiodecoderzd2_bglt)BgL_decz00_111))))->BgL_z52ratez52))),BUNSPEC); 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1101z00_157))->BgL_channelsz00)=((long)
(long)(
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)
((BgL_mpg123zd2pulseaudiodecoderzd2_bglt)BgL_decz00_111))))->BgL_z52channelsz52))),BUNSPEC); 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1101z00_157))->BgL_bpsz00)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1101z00_157))->BgL_formatz00)=((obj_t)
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)
((BgL_mpg123zd2pulseaudiodecoderzd2_bglt)BgL_decz00_111))))->BgL_z52encodingz52)),BUNSPEC); 
{ /* Llib/mpg123_padec.scm 49 */
obj_t BgL_fun1144z00_165;
BgL_fun1144z00_165 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_pulseaudiozd2simplezd2zz__pulseaudio_simplez00); 
PROCEDURE_ENTRY(BgL_fun1144z00_165)(BgL_fun1144z00_165, 
((obj_t)BgL_new1101z00_157), BEOA); } 
BgL_arg1141z00_156 = BgL_new1101z00_157; } 
return 
BGl_pulseaudiomusiczd2simplezd2setz12z12zz__pulseaudio_musicz00(
((BgL_pulseaudiomusicz00_bglt)BgL_amz00_112), BgL_arg1141z00_156);} } 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__mpg123_padecz00()
{
{ /* Llib/mpg123_padec.scm 15 */
BGl_modulezd2initializa7ationz75zz__mpg123_mpg123z00(((long)388603996), 
BSTRING_TO_STRING(BGl_string1162z00zz__mpg123_padecz00)); 
return 
BGl_modulezd2initializa7ationz75zz__mpg123_decoderz00(((long)0), 
BSTRING_TO_STRING(BGl_string1162z00zz__mpg123_padecz00));} 

}

#ifdef __cplusplus
}
#endif
