/*===========================================================================*/
/*   (Llib/soundcard.scm)                                                    */
/*   Bigloo (4.3h)                                                           */
/*   Inria -- Sophia Antipolis (c)       Tue 12 May 2020 08:36:09 AM CEST    */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.3h/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.3h/lib/bigloo/4.3h -I Llib -lib-dir /builddir/build/BUILD/bigloo-4.3h/lib/bigloo/4.3h -unsafe -safee -copt -fPIC -copt -IUnix Llib/soundcard.scm -o objs/soundcard.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_mixerz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_devicesz00;
} *BgL_mixerz00_bglt;

typedef struct BgL_soundcardz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_devicesz00;
   obj_t BgL_devicez00;
   obj_t BgL_z52devicesz52;
   obj_t BgL_z52mixerz52;
} *BgL_soundcardz00_bglt;


BGL_IMPORT obj_t BGl_assocz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
static obj_t BGl_z62mixerzd2volumezd2getzd2sou1081zb0zz__multimediazd2soundcardzd2(obj_t, obj_t, obj_t);
extern char * bgl_mixer_dev_name(obj_t, int);
static obj_t BGl_objectzd2initzd2zz__multimediazd2soundcardzd2();
static obj_t BGl_z62zc3z04anonymousza31142ze3ze5zz__multimediazd2soundcardzd2(obj_t);
BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__multimediazd2soundcardzd2();
static obj_t BGl_z62zc3z04anonymousza31149ze3ze5zz__multimediazd2soundcardzd2(obj_t);
BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
extern obj_t bgl_mixer_write_vol(obj_t, int, int);
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_iotaz00zz__r4_pairs_and_lists_6_3z00(int, obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__multimediazd2soundcardzd2();
BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mixerzd2closezd2soundcar1077z62zz__multimediazd2soundcardzd2(obj_t, obj_t);
extern obj_t bgl_close_mixer(obj_t);
static obj_t BGl_requirezd2initializa7ationz75zz__multimediazd2soundcardzd2 = BUNSPEC;
BGL_EXPORTED_DECL obj_t BGl_soundcardzd2openzd2zz__multimediazd2soundcardzd2(BgL_soundcardz00_bglt);
BGL_IMPORT obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_toplevelzd2initzd2zz__multimediazd2soundcardzd2();
BGL_EXPORTED_DEF obj_t BGl_soundcardz00zz__multimediazd2soundcardzd2 = BUNSPEC;
static obj_t BGl_genericzd2initzd2zz__multimediazd2soundcardzd2();
static obj_t BGl_z62zc3z04anonymousza31117ze3ze5zz__multimediazd2soundcardzd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t, bool_t, bool_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
extern obj_t bgl_open_mixer(char *);
static BgL_soundcardz00_bglt BGl_z62lambda1109z62zz__multimediazd2soundcardzd2(obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_soundcardz00_bglt BGl_z62lambda1114z62zz__multimediazd2soundcardzd2(obj_t);
extern int bgl_mixer_dev_num(obj_t);
static obj_t BGl_z62lambda1134z62zz__multimediazd2soundcardzd2(obj_t, obj_t);
static obj_t BGl_z62lambda1135z62zz__multimediazd2soundcardzd2(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2constructorzd2zz__objectz00(obj_t);
static obj_t BGl_z62lambda1140z62zz__multimediazd2soundcardzd2(obj_t, obj_t);
static obj_t BGl_z62lambda1141z62zz__multimediazd2soundcardzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1147z62zz__multimediazd2soundcardzd2(obj_t, obj_t);
static obj_t BGl_z62lambda1148z62zz__multimediazd2soundcardzd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2soundcardzd2(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2mixerzd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
static obj_t BGl_cnstzd2initzd2zz__multimediazd2soundcardzd2();
static obj_t BGl_libraryzd2moduleszd2initz00zz__multimediazd2soundcardzd2();
extern obj_t BGl_mixerz00zz__multimediazd2mixerzd2;
static obj_t BGl_importedzd2moduleszd2initz00zz__multimediazd2soundcardzd2();
extern int bgl_mixer_read_vol(obj_t, int, bool_t);
static obj_t BGl_z62soundcardzd2openzb0zz__multimediazd2soundcardzd2(obj_t, obj_t);
static obj_t BGl_z62mixerzd2volumezd2setz12zd2so1079za2zz__multimediazd2soundcardzd2(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t __cnst[ 8 ] ;


extern obj_t BGl_mixerzd2volumezd2getzd2envzd2zz__multimediazd2mixerzd2;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1190z00zz__multimediazd2soundcardzd2, BgL_bgl_za762lambda1135za7621220z00, BGl_z62lambda1135z62zz__multimediazd2soundcardzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1191z00zz__multimediazd2soundcardzd2, BgL_bgl_za762lambda1134za7621221z00, BGl_z62lambda1134z62zz__multimediazd2soundcardzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1192z00zz__multimediazd2soundcardzd2, BgL_bgl_za762za7c3za704anonymo1222za7, BGl_z62zc3z04anonymousza31142ze3ze5zz__multimediazd2soundcardzd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1193z00zz__multimediazd2soundcardzd2, BgL_bgl_za762lambda1141za7621223z00, BGl_z62lambda1141z62zz__multimediazd2soundcardzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1194z00zz__multimediazd2soundcardzd2, BgL_bgl_za762lambda1140za7621224z00, BGl_z62lambda1140z62zz__multimediazd2soundcardzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1195z00zz__multimediazd2soundcardzd2, BgL_bgl_za762za7c3za704anonymo1225za7, BGl_z62zc3z04anonymousza31149ze3ze5zz__multimediazd2soundcardzd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1196z00zz__multimediazd2soundcardzd2, BgL_bgl_za762lambda1148za7621226z00, BGl_z62lambda1148z62zz__multimediazd2soundcardzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1197z00zz__multimediazd2soundcardzd2, BgL_bgl_za762lambda1147za7621227z00, BGl_z62lambda1147z62zz__multimediazd2soundcardzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1198z00zz__multimediazd2soundcardzd2, BgL_bgl_za762za7c3za704anonymo1228za7, BGl_z62zc3z04anonymousza31117ze3ze5zz__multimediazd2soundcardzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1199z00zz__multimediazd2soundcardzd2, BgL_bgl_za762lambda1114za7621229z00, BGl_z62lambda1114z62zz__multimediazd2soundcardzd2, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_soundcardzd2openzd2envz00zz__multimediazd2soundcardzd2, BgL_bgl_za762soundcardza7d2o1230z00, BGl_z62soundcardzd2openzb0zz__multimediazd2soundcardzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1200z00zz__multimediazd2soundcardzd2, BgL_bgl_za762lambda1109za7621231z00, BGl_z62lambda1109z62zz__multimediazd2soundcardzd2, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1202z00zz__multimediazd2soundcardzd2, BgL_bgl_za762mixerza7d2close1232z00, BGl_z62mixerzd2closezd2soundcar1077z62zz__multimediazd2soundcardzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1204z00zz__multimediazd2soundcardzd2, BgL_bgl_za762mixerza7d2volum1233z00, BGl_z62mixerzd2volumezd2setz12zd2so1079za2zz__multimediazd2soundcardzd2, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1206z00zz__multimediazd2soundcardzd2, BgL_bgl_za762mixerza7d2volum1234z00, BGl_z62mixerzd2volumezd2getzd2sou1081zb0zz__multimediazd2soundcardzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string1187z00zz__multimediazd2soundcardzd2, BgL_bgl_string1187za700za7za7_1235za7, "/builddir/build/BUILD/bigloo-4.3h/api/multimedia/src/Llib/soundcard.scm", 71 );
DEFINE_STRING( BGl_string1188z00zz__multimediazd2soundcardzd2, BgL_bgl_string1188za700za7za7_1236za7, "&soundcard-open", 15 );
DEFINE_STRING( BGl_string1189z00zz__multimediazd2soundcardzd2, BgL_bgl_string1189za700za7za7_1237za7, "soundcard", 9 );
extern obj_t BGl_mixerzd2closezd2envz00zz__multimediazd2mixerzd2;
extern obj_t BGl_mixerzd2volumezd2setz12zd2envzc0zz__multimediazd2mixerzd2;
DEFINE_STRING( BGl_string1201z00zz__multimediazd2soundcardzd2, BgL_bgl_string1201za700za7za7_1238za7, "", 0 );
DEFINE_STRING( BGl_string1203z00zz__multimediazd2soundcardzd2, BgL_bgl_string1203za700za7za7_1239za7, "mixer-close", 11 );
DEFINE_STRING( BGl_string1205z00zz__multimediazd2soundcardzd2, BgL_bgl_string1205za700za7za7_1240za7, "mixer-volume-set!", 17 );
DEFINE_STRING( BGl_string1207z00zz__multimediazd2soundcardzd2, BgL_bgl_string1207za700za7za7_1241za7, "mixer-volume-get", 16 );
DEFINE_STRING( BGl_string1208z00zz__multimediazd2soundcardzd2, BgL_bgl_string1208za700za7za7_1242za7, "Unknown device", 14 );
DEFINE_STRING( BGl_string1209z00zz__multimediazd2soundcardzd2, BgL_bgl_string1209za700za7za7_1243za7, "__multimedia-soundcard", 22 );
DEFINE_STRING( BGl_string1210z00zz__multimediazd2soundcardzd2, BgL_bgl_string1210za700za7za7_1244za7, "__multimedia-soundcard soundcard obj %mixer pair-nil %devices bstring device ", 77 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__multimediazd2soundcardzd2) );
ADD_ROOT( (void *)(&BGl_soundcardz00zz__multimediazd2soundcardzd2) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2soundcardzd2(long BgL_checksumz00_358, char * BgL_fromz00_359)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__multimediazd2soundcardzd2))
{ 
BGl_requirezd2initializa7ationz75zz__multimediazd2soundcardzd2 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__multimediazd2soundcardzd2(); 
BGl_libraryzd2moduleszd2initz00zz__multimediazd2soundcardzd2(); 
BGl_cnstzd2initzd2zz__multimediazd2soundcardzd2(); 
BGl_importedzd2moduleszd2initz00zz__multimediazd2soundcardzd2(); 
BGl_objectzd2initzd2zz__multimediazd2soundcardzd2(); 
BGl_methodzd2initzd2zz__multimediazd2soundcardzd2(); 
return 
BGl_toplevelzd2initzd2zz__multimediazd2soundcardzd2();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__multimediazd2soundcardzd2()
{
{ /* Llib/soundcard.scm 15 */
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__multimedia-soundcard"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__multimedia-soundcard"); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "__multimedia-soundcard"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__multimedia-soundcard"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__multimedia-soundcard"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__multimedia-soundcard"); 
BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)0), "__multimedia-soundcard"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__multimedia-soundcard"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__multimedia-soundcard"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__multimediazd2soundcardzd2()
{
{ /* Llib/soundcard.scm 15 */
{ /* Llib/soundcard.scm 15 */
obj_t BgL_cportz00_294;
{ /* Llib/soundcard.scm 15 */
obj_t BgL_stringz00_302;
BgL_stringz00_302 = BGl_string1210z00zz__multimediazd2soundcardzd2; 
{ /* Llib/soundcard.scm 15 */
obj_t BgL_startz00_303;
BgL_startz00_303 = 
BINT(((long)0)); 
{ /* Llib/soundcard.scm 15 */
obj_t BgL_endz00_304;
BgL_endz00_304 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_302))); 
{ /* Llib/soundcard.scm 15 */

BgL_cportz00_294 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_302, BgL_startz00_303, BgL_endz00_304); } } } } 
{ 
long BgL_iz00_295;
BgL_iz00_295 = ((long)7); 
BgL_loopz00_296:
if(
(BgL_iz00_295==((long)-1)))
{ /* Llib/soundcard.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/soundcard.scm 15 */
{ /* Llib/soundcard.scm 15 */
obj_t BgL_arg1218z00_298;
{ /* Llib/soundcard.scm 15 */

{ /* Llib/soundcard.scm 15 */
obj_t BgL_locationz00_300;
BgL_locationz00_300 = 
BBOOL(((bool_t)0)); 
{ /* Llib/soundcard.scm 15 */

BgL_arg1218z00_298 = 
BGl_readz00zz__readerz00(BgL_cportz00_294, BgL_locationz00_300); } } } 
{ /* Llib/soundcard.scm 15 */
int BgL_tmpz00_388;
BgL_tmpz00_388 = 
(int)(BgL_iz00_295); 
CNST_TABLE_SET(BgL_tmpz00_388, BgL_arg1218z00_298); } } 
{ /* Llib/soundcard.scm 15 */
int BgL_auxz00_301;
BgL_auxz00_301 = 
(int)(
(BgL_iz00_295-((long)1))); 
{ 
long BgL_iz00_393;
BgL_iz00_393 = 
(long)(BgL_auxz00_301); 
BgL_iz00_295 = BgL_iz00_393; 
goto BgL_loopz00_296;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__multimediazd2soundcardzd2()
{
{ /* Llib/soundcard.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__multimediazd2soundcardzd2()
{
{ /* Llib/soundcard.scm 15 */
return BUNSPEC;} 

}



/* soundcard-open */
BGL_EXPORTED_DEF obj_t BGl_soundcardzd2openzd2zz__multimediazd2soundcardzd2(BgL_soundcardz00_bglt BgL_mz00_3)
{
{ /* Llib/soundcard.scm 37 */
{ /* Llib/soundcard.scm 42 */
obj_t BgL_mixz00_22;
{ /* Llib/soundcard.scm 42 */
obj_t BgL_arg1101z00_51;
BgL_arg1101z00_51 = 
(((BgL_soundcardz00_bglt)COBJECT(BgL_mz00_3))->BgL_devicez00); 
BgL_mixz00_22 = 
bgl_open_mixer(
BSTRING_TO_STRING(BgL_arg1101z00_51)); } 
((((BgL_soundcardz00_bglt)COBJECT(BgL_mz00_3))->BgL_z52mixerz52)=((obj_t)BgL_mixz00_22),BUNSPEC); 
{ 
obj_t BgL_auxz00_400;
{ /* Llib/soundcard.scm 45 */
obj_t BgL_l01065z00_23;
{ /* Llib/soundcard.scm 47 */
int BgL_arg1091z00_33;
BgL_arg1091z00_33 = 
bgl_mixer_dev_num(BgL_mixz00_22); 
{ /* Llib/soundcard.scm 47 */
obj_t BgL_list1092z00_34;
BgL_list1092z00_34 = 
MAKE_YOUNG_PAIR(
BINT(((long)0)), BNIL); 
BgL_l01065z00_23 = 
BGl_iotaz00zz__r4_pairs_and_lists_6_3z00(BgL_arg1091z00_33, BgL_list1092z00_34); } } 
{ 
obj_t BgL_l1064z00_25;
BgL_l1064z00_25 = BgL_l01065z00_23; 
BgL_zc3z04anonymousza31085ze3z87_26:
if(
NULLP(BgL_l1064z00_25))
{ /* Llib/soundcard.scm 47 */
BgL_auxz00_400 = BgL_l01065z00_23
; }  else 
{ /* Llib/soundcard.scm 47 */
{ /* Llib/soundcard.scm 46 */
obj_t BgL_arg1087z00_28;
{ /* Llib/soundcard.scm 46 */
obj_t BgL_nz00_29;
BgL_nz00_29 = 
CAR(
((obj_t)BgL_l1064z00_25)); 
{ /* Llib/soundcard.scm 46 */
char * BgL_arg1088z00_30;
BgL_arg1088z00_30 = 
bgl_mixer_dev_name(BgL_mixz00_22, 
CINT(BgL_nz00_29)); 
BgL_arg1087z00_28 = 
MAKE_YOUNG_PAIR(
string_to_bstring(BgL_arg1088z00_30), BgL_nz00_29); } } 
{ /* Llib/soundcard.scm 47 */
obj_t BgL_tmpz00_413;
BgL_tmpz00_413 = 
((obj_t)BgL_l1064z00_25); 
SET_CAR(BgL_tmpz00_413, BgL_arg1087z00_28); } } 
{ /* Llib/soundcard.scm 47 */
obj_t BgL_arg1089z00_31;
BgL_arg1089z00_31 = 
CDR(
((obj_t)BgL_l1064z00_25)); 
{ 
obj_t BgL_l1064z00_418;
BgL_l1064z00_418 = BgL_arg1089z00_31; 
BgL_l1064z00_25 = BgL_l1064z00_418; 
goto BgL_zc3z04anonymousza31085ze3z87_26;} } } } } 
((((BgL_soundcardz00_bglt)COBJECT(BgL_mz00_3))->BgL_z52devicesz52)=((obj_t)BgL_auxz00_400),BUNSPEC); } 
{ 
obj_t BgL_auxz00_420;
{ /* Llib/soundcard.scm 48 */
obj_t BgL_l1066z00_35;
BgL_l1066z00_35 = 
(((BgL_soundcardz00_bglt)COBJECT(BgL_mz00_3))->BgL_z52devicesz52); 
if(
NULLP(BgL_l1066z00_35))
{ /* Llib/soundcard.scm 48 */
BgL_auxz00_420 = BNIL
; }  else 
{ /* Llib/soundcard.scm 48 */
obj_t BgL_head1068z00_37;
{ /* Llib/soundcard.scm 48 */
obj_t BgL_arg1099z00_49;
{ /* Llib/soundcard.scm 48 */
obj_t BgL_pairz00_151;
BgL_pairz00_151 = 
CAR(BgL_l1066z00_35); 
BgL_arg1099z00_49 = 
CAR(BgL_pairz00_151); } 
{ /* Llib/soundcard.scm 48 */
obj_t BgL_res1160z00_152;
BgL_res1160z00_152 = 
MAKE_YOUNG_PAIR(BgL_arg1099z00_49, BNIL); 
BgL_head1068z00_37 = BgL_res1160z00_152; } } 
{ /* Llib/soundcard.scm 48 */
obj_t BgL_g1071z00_38;
BgL_g1071z00_38 = 
CDR(BgL_l1066z00_35); 
{ 
obj_t BgL_l1066z00_40;obj_t BgL_tail1069z00_41;
BgL_l1066z00_40 = BgL_g1071z00_38; 
BgL_tail1069z00_41 = BgL_head1068z00_37; 
BgL_zc3z04anonymousza31094ze3z87_42:
if(
NULLP(BgL_l1066z00_40))
{ /* Llib/soundcard.scm 48 */
BgL_auxz00_420 = BgL_head1068z00_37
; }  else 
{ /* Llib/soundcard.scm 48 */
obj_t BgL_newtail1070z00_44;
{ /* Llib/soundcard.scm 48 */
obj_t BgL_arg1097z00_46;
{ /* Llib/soundcard.scm 48 */
obj_t BgL_pairz00_156;
BgL_pairz00_156 = 
CAR(
((obj_t)BgL_l1066z00_40)); 
BgL_arg1097z00_46 = 
CAR(BgL_pairz00_156); } 
{ /* Llib/soundcard.scm 48 */
obj_t BgL_res1162z00_157;
BgL_res1162z00_157 = 
MAKE_YOUNG_PAIR(BgL_arg1097z00_46, BNIL); 
BgL_newtail1070z00_44 = BgL_res1162z00_157; } } 
SET_CDR(BgL_tail1069z00_41, BgL_newtail1070z00_44); 
{ /* Llib/soundcard.scm 48 */
obj_t BgL_arg1096z00_45;
BgL_arg1096z00_45 = 
CDR(
((obj_t)BgL_l1066z00_40)); 
{ 
obj_t BgL_tail1069z00_439;obj_t BgL_l1066z00_438;
BgL_l1066z00_438 = BgL_arg1096z00_45; 
BgL_tail1069z00_439 = BgL_newtail1070z00_44; 
BgL_tail1069z00_41 = BgL_tail1069z00_439; 
BgL_l1066z00_40 = BgL_l1066z00_438; 
goto BgL_zc3z04anonymousza31094ze3z87_42;} } } } } } } 
((((BgL_mixerz00_bglt)COBJECT(
((BgL_mixerz00_bglt)BgL_mz00_3)))->BgL_devicesz00)=((obj_t)BgL_auxz00_420),BUNSPEC); } } 
return 
((obj_t)BgL_mz00_3);} 

}



/* &soundcard-open */
obj_t BGl_z62soundcardzd2openzb0zz__multimediazd2soundcardzd2(obj_t BgL_envz00_229, obj_t BgL_mz00_230)
{
{ /* Llib/soundcard.scm 37 */
{ /* Llib/soundcard.scm 40 */
BgL_soundcardz00_bglt BgL_auxz00_442;
if(
BGl_isazf3zf3zz__objectz00(BgL_mz00_230, BGl_soundcardz00zz__multimediazd2soundcardzd2))
{ /* Llib/soundcard.scm 40 */
BgL_auxz00_442 = 
((BgL_soundcardz00_bglt)BgL_mz00_230)
; }  else 
{ 
obj_t BgL_auxz00_446;
BgL_auxz00_446 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1187z00zz__multimediazd2soundcardzd2, 
BINT(((long)1988)), BGl_string1188z00zz__multimediazd2soundcardzd2, BGl_string1189z00zz__multimediazd2soundcardzd2, BgL_mz00_230); 
FAILURE(BgL_auxz00_446,BFALSE,BFALSE);} 
return 
BGl_soundcardzd2openzd2zz__multimediazd2soundcardzd2(BgL_auxz00_442);} } 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__multimediazd2soundcardzd2()
{
{ /* Llib/soundcard.scm 15 */
{ /* Llib/soundcard.scm 28 */
obj_t BgL_arg1107z00_59;obj_t BgL_arg1108z00_60;
{ /* Llib/soundcard.scm 28 */
obj_t BgL_v1074z00_75;
BgL_v1074z00_75 = 
create_vector(((long)3)); 
{ /* Llib/soundcard.scm 28 */
obj_t BgL_arg1118z00_76;
BgL_arg1118z00_76 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)0)), BGl_proc1191z00zz__multimediazd2soundcardzd2, BGl_proc1190z00zz__multimediazd2soundcardzd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)1))); 
VECTOR_SET(BgL_v1074z00_75,((long)0),BgL_arg1118z00_76); } 
{ /* Llib/soundcard.scm 28 */
obj_t BgL_arg1136z00_86;
BgL_arg1136z00_86 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)2)), BGl_proc1194z00zz__multimediazd2soundcardzd2, BGl_proc1193z00zz__multimediazd2soundcardzd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1192z00zz__multimediazd2soundcardzd2, 
CNST_TABLE_REF(((long)3))); 
VECTOR_SET(BgL_v1074z00_75,((long)1),BgL_arg1136z00_86); } 
{ /* Llib/soundcard.scm 28 */
obj_t BgL_arg1143z00_99;
BgL_arg1143z00_99 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)4)), BGl_proc1197z00zz__multimediazd2soundcardzd2, BGl_proc1196z00zz__multimediazd2soundcardzd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1195z00zz__multimediazd2soundcardzd2, 
CNST_TABLE_REF(((long)5))); 
VECTOR_SET(BgL_v1074z00_75,((long)2),BgL_arg1143z00_99); } 
BgL_arg1107z00_59 = BgL_v1074z00_75; } 
{ /* Llib/soundcard.scm 28 */
obj_t BgL_v1075z00_112;
BgL_v1075z00_112 = 
create_vector(((long)0)); 
BgL_arg1108z00_60 = BgL_v1075z00_112; } 
return ( 
BGl_soundcardz00zz__multimediazd2soundcardzd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)6)), 
CNST_TABLE_REF(((long)7)), BGl_mixerz00zz__multimediazd2mixerzd2, ((long)29670), BGl_proc1200z00zz__multimediazd2soundcardzd2, BGl_proc1199z00zz__multimediazd2soundcardzd2, BGl_soundcardzd2openzd2envz00zz__multimediazd2soundcardzd2, BGl_proc1198z00zz__multimediazd2soundcardzd2, BFALSE, BgL_arg1107z00_59, BgL_arg1108z00_60), BUNSPEC) ;} } 

}



/* &<@anonymous:1117> */
obj_t BGl_z62zc3z04anonymousza31117ze3ze5zz__multimediazd2soundcardzd2(obj_t BgL_envz00_242, obj_t BgL_new1054z00_243)
{
{ /* Llib/soundcard.scm 28 */
{ 
BgL_soundcardz00_bglt BgL_auxz00_468;
((((BgL_mixerz00_bglt)COBJECT(
((BgL_mixerz00_bglt)
((BgL_soundcardz00_bglt)BgL_new1054z00_243))))->BgL_devicesz00)=((obj_t)BNIL),BUNSPEC); 
((((BgL_soundcardz00_bglt)COBJECT(
((BgL_soundcardz00_bglt)BgL_new1054z00_243)))->BgL_devicez00)=((obj_t)BGl_string1201z00zz__multimediazd2soundcardzd2),BUNSPEC); 
((((BgL_soundcardz00_bglt)COBJECT(
((BgL_soundcardz00_bglt)BgL_new1054z00_243)))->BgL_z52devicesz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_soundcardz00_bglt)COBJECT(
((BgL_soundcardz00_bglt)BgL_new1054z00_243)))->BgL_z52mixerz52)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_468 = 
((BgL_soundcardz00_bglt)BgL_new1054z00_243); 
return 
((obj_t)BgL_auxz00_468);} } 

}



/* &lambda1114 */
BgL_soundcardz00_bglt BGl_z62lambda1114z62zz__multimediazd2soundcardzd2(obj_t BgL_envz00_244)
{
{ /* Llib/soundcard.scm 28 */
{ /* Llib/soundcard.scm 28 */
BgL_soundcardz00_bglt BgL_new1053z00_308;
BgL_new1053z00_308 = 
((BgL_soundcardz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_soundcardz00_bgl) ))); 
{ /* Llib/soundcard.scm 28 */
long BgL_arg1116z00_309;
{ /* Llib/soundcard.scm 28 */
long BgL_res1165z00_310;
BgL_res1165z00_310 = 
BGL_CLASS_INDEX(BGl_soundcardz00zz__multimediazd2soundcardzd2); 
BgL_arg1116z00_309 = BgL_res1165z00_310; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1053z00_308), BgL_arg1116z00_309); } 
return BgL_new1053z00_308;} } 

}



/* &lambda1109 */
BgL_soundcardz00_bglt BGl_z62lambda1109z62zz__multimediazd2soundcardzd2(obj_t BgL_envz00_245, obj_t BgL_devices1049z00_246, obj_t BgL_device1050z00_247, obj_t BgL_z52devices1051z52_248, obj_t BgL_z52mixer1052z52_249)
{
{ /* Llib/soundcard.scm 28 */
{ /* Llib/soundcard.scm 28 */
BgL_soundcardz00_bglt BgL_new1062z00_314;
{ /* Llib/soundcard.scm 28 */
BgL_soundcardz00_bglt BgL_new1061z00_315;
BgL_new1061z00_315 = 
((BgL_soundcardz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_soundcardz00_bgl) ))); 
{ /* Llib/soundcard.scm 28 */
long BgL_arg1113z00_316;
{ /* Llib/soundcard.scm 28 */
long BgL_res1164z00_317;
BgL_res1164z00_317 = 
BGL_CLASS_INDEX(BGl_soundcardz00zz__multimediazd2soundcardzd2); 
BgL_arg1113z00_316 = BgL_res1164z00_317; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1061z00_315), BgL_arg1113z00_316); } 
BgL_new1062z00_314 = BgL_new1061z00_315; } 
((((BgL_mixerz00_bglt)COBJECT(
((BgL_mixerz00_bglt)BgL_new1062z00_314)))->BgL_devicesz00)=((obj_t)
((obj_t)BgL_devices1049z00_246)),BUNSPEC); 
((((BgL_soundcardz00_bglt)COBJECT(BgL_new1062z00_314))->BgL_devicez00)=((obj_t)
((obj_t)BgL_device1050z00_247)),BUNSPEC); 
((((BgL_soundcardz00_bglt)COBJECT(BgL_new1062z00_314))->BgL_z52devicesz52)=((obj_t)
((obj_t)BgL_z52devices1051z52_248)),BUNSPEC); 
((((BgL_soundcardz00_bglt)COBJECT(BgL_new1062z00_314))->BgL_z52mixerz52)=((obj_t)BgL_z52mixer1052z52_249),BUNSPEC); 
{ /* Llib/soundcard.scm 28 */
obj_t BgL_fun1110z00_318;
BgL_fun1110z00_318 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_soundcardz00zz__multimediazd2soundcardzd2); 
PROCEDURE_ENTRY(BgL_fun1110z00_318)(BgL_fun1110z00_318, 
((obj_t)BgL_new1062z00_314), BEOA); } 
return BgL_new1062z00_314;} } 

}



/* &<@anonymous:1149> */
obj_t BGl_z62zc3z04anonymousza31149ze3ze5zz__multimediazd2soundcardzd2(obj_t BgL_envz00_250)
{
{ /* Llib/soundcard.scm 28 */
return BUNSPEC;} 

}



/* &lambda1148 */
obj_t BGl_z62lambda1148z62zz__multimediazd2soundcardzd2(obj_t BgL_envz00_251, obj_t BgL_oz00_252, obj_t BgL_vz00_253)
{
{ /* Llib/soundcard.scm 28 */
return 
((((BgL_soundcardz00_bglt)COBJECT(
((BgL_soundcardz00_bglt)BgL_oz00_252)))->BgL_z52mixerz52)=((obj_t)BgL_vz00_253),BUNSPEC);} 

}



/* &lambda1147 */
obj_t BGl_z62lambda1147z62zz__multimediazd2soundcardzd2(obj_t BgL_envz00_254, obj_t BgL_oz00_255)
{
{ /* Llib/soundcard.scm 28 */
return 
(((BgL_soundcardz00_bglt)COBJECT(
((BgL_soundcardz00_bglt)BgL_oz00_255)))->BgL_z52mixerz52);} 

}



/* &<@anonymous:1142> */
obj_t BGl_z62zc3z04anonymousza31142ze3ze5zz__multimediazd2soundcardzd2(obj_t BgL_envz00_256)
{
{ /* Llib/soundcard.scm 28 */
return BNIL;} 

}



/* &lambda1141 */
obj_t BGl_z62lambda1141z62zz__multimediazd2soundcardzd2(obj_t BgL_envz00_257, obj_t BgL_oz00_258, obj_t BgL_vz00_259)
{
{ /* Llib/soundcard.scm 28 */
return 
((((BgL_soundcardz00_bglt)COBJECT(
((BgL_soundcardz00_bglt)BgL_oz00_258)))->BgL_z52devicesz52)=((obj_t)
((obj_t)BgL_vz00_259)),BUNSPEC);} 

}



/* &lambda1140 */
obj_t BGl_z62lambda1140z62zz__multimediazd2soundcardzd2(obj_t BgL_envz00_260, obj_t BgL_oz00_261)
{
{ /* Llib/soundcard.scm 28 */
return 
(((BgL_soundcardz00_bglt)COBJECT(
((BgL_soundcardz00_bglt)BgL_oz00_261)))->BgL_z52devicesz52);} 

}



/* &lambda1135 */
obj_t BGl_z62lambda1135z62zz__multimediazd2soundcardzd2(obj_t BgL_envz00_262, obj_t BgL_oz00_263, obj_t BgL_vz00_264)
{
{ /* Llib/soundcard.scm 28 */
return 
((((BgL_soundcardz00_bglt)COBJECT(
((BgL_soundcardz00_bglt)BgL_oz00_263)))->BgL_devicez00)=((obj_t)
((obj_t)BgL_vz00_264)),BUNSPEC);} 

}



/* &lambda1134 */
obj_t BGl_z62lambda1134z62zz__multimediazd2soundcardzd2(obj_t BgL_envz00_265, obj_t BgL_oz00_266)
{
{ /* Llib/soundcard.scm 28 */
return 
(((BgL_soundcardz00_bglt)COBJECT(
((BgL_soundcardz00_bglt)BgL_oz00_266)))->BgL_devicez00);} 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__multimediazd2soundcardzd2()
{
{ /* Llib/soundcard.scm 15 */
return BUNSPEC;} 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__multimediazd2soundcardzd2()
{
{ /* Llib/soundcard.scm 15 */
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_mixerzd2closezd2envz00zz__multimediazd2mixerzd2, BGl_soundcardz00zz__multimediazd2soundcardzd2, BGl_proc1202z00zz__multimediazd2soundcardzd2, BGl_string1203z00zz__multimediazd2soundcardzd2); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_mixerzd2volumezd2setz12zd2envzc0zz__multimediazd2mixerzd2, BGl_soundcardz00zz__multimediazd2soundcardzd2, BGl_proc1204z00zz__multimediazd2soundcardzd2, BGl_string1205z00zz__multimediazd2soundcardzd2); 
return 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_mixerzd2volumezd2getzd2envzd2zz__multimediazd2mixerzd2, BGl_soundcardz00zz__multimediazd2soundcardzd2, BGl_proc1206z00zz__multimediazd2soundcardzd2, BGl_string1207z00zz__multimediazd2soundcardzd2);} 

}



/* &mixer-volume-get-sou1081 */
obj_t BGl_z62mixerzd2volumezd2getzd2sou1081zb0zz__multimediazd2soundcardzd2(obj_t BgL_envz00_270, obj_t BgL_mz00_271, obj_t BgL_devz00_272)
{
{ /* Llib/soundcard.scm 96 */
{ /* Llib/soundcard.scm 101 */
int BgL_volz00_329;
{ /* Llib/soundcard.scm 101 */
obj_t BgL_arg1156z00_330;obj_t BgL_arg1157z00_331;
BgL_arg1156z00_330 = 
(((BgL_soundcardz00_bglt)COBJECT(
((BgL_soundcardz00_bglt)BgL_mz00_271)))->BgL_z52mixerz52); 
{ /* Llib/soundcard.scm 73 */
obj_t BgL_cz00_332;
BgL_cz00_332 = 
BGl_assocz00zz__r4_pairs_and_lists_6_3z00(
((obj_t)BgL_devz00_272), 
(((BgL_soundcardz00_bglt)COBJECT(
((BgL_soundcardz00_bglt)BgL_mz00_271)))->BgL_z52devicesz52)); 
if(
PAIRP(BgL_cz00_332))
{ /* Llib/soundcard.scm 74 */
BgL_arg1157z00_331 = 
CDR(BgL_cz00_332); }  else 
{ /* Llib/soundcard.scm 74 */
BgL_arg1157z00_331 = 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)6)), BGl_string1208z00zz__multimediazd2soundcardzd2, 
((obj_t)BgL_devz00_272)); } } 
BgL_volz00_329 = 
bgl_mixer_read_vol(BgL_arg1156z00_330, 
CINT(BgL_arg1157z00_331), ((bool_t)1)); } 
{ /* Llib/soundcard.scm 102 */
long BgL_val0_1072z00_333;long BgL_val1_1073z00_334;
{ /* Llib/soundcard.scm 102 */
long BgL_res1175z00_335;
{ /* Llib/soundcard.scm 102 */
long BgL_n1z00_336;long BgL_n2z00_337;
BgL_n1z00_336 = 
(long)(BgL_volz00_329); 
BgL_n2z00_337 = ((long)256); 
{ /* Llib/soundcard.scm 102 */
bool_t BgL_test1252z00_534;
{ /* Llib/soundcard.scm 102 */
long BgL_arg1299z00_338;
BgL_arg1299z00_338 = 
(((BgL_n1z00_336) | (BgL_n2z00_337)) & -2147483648); 
BgL_test1252z00_534 = 
(BgL_arg1299z00_338==((long)0)); } 
if(BgL_test1252z00_534)
{ /* Llib/soundcard.scm 102 */
int32_t BgL_arg1287z00_339;
{ /* Llib/soundcard.scm 102 */
int32_t BgL_arg1293z00_340;int32_t BgL_arg1294z00_341;
{ /* Llib/soundcard.scm 102 */
int32_t BgL_res1171z00_342;
BgL_res1171z00_342 = 
(int32_t)(BgL_n1z00_336); 
BgL_arg1293z00_340 = BgL_res1171z00_342; } 
{ /* Llib/soundcard.scm 102 */
int32_t BgL_res1172z00_343;
BgL_res1172z00_343 = 
(int32_t)(BgL_n2z00_337); 
BgL_arg1294z00_341 = BgL_res1172z00_343; } 
BgL_arg1287z00_339 = 
(BgL_arg1293z00_340%BgL_arg1294z00_341); } 
{ /* Llib/soundcard.scm 102 */
long BgL_res1174z00_344;
{ /* Llib/soundcard.scm 102 */
long BgL_arg1421z00_345;
BgL_arg1421z00_345 = 
(long)(BgL_arg1287z00_339); 
{ /* Llib/soundcard.scm 102 */
long BgL_res1173z00_346;
BgL_res1173z00_346 = 
(long)(BgL_arg1421z00_345); 
BgL_res1174z00_344 = BgL_res1173z00_346; } } 
BgL_res1175z00_335 = BgL_res1174z00_344; } }  else 
{ /* Llib/soundcard.scm 102 */
BgL_res1175z00_335 = 
(BgL_n1z00_336%BgL_n2z00_337); } } } 
BgL_val0_1072z00_333 = BgL_res1175z00_335; } 
{ /* Llib/soundcard.scm 102 */
long BgL_res1176z00_347;
{ /* Llib/soundcard.scm 102 */
long BgL_tmpz00_543;
BgL_tmpz00_543 = 
(long)(BgL_volz00_329); 
BgL_res1176z00_347 = 
(BgL_tmpz00_543/((long)256)); } 
BgL_val1_1073z00_334 = BgL_res1176z00_347; } 
{ /* Llib/soundcard.scm 102 */
int BgL_res1177z00_348;
{ /* Llib/soundcard.scm 102 */
int BgL_tmpz00_546;
BgL_tmpz00_546 = 
(int)(((long)2)); 
BgL_res1177z00_348 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_546); } BgL_res1177z00_348; } 
{ /* Llib/soundcard.scm 102 */
obj_t BgL_auxz00_551;int BgL_tmpz00_549;
BgL_auxz00_551 = 
BINT(BgL_val1_1073z00_334); 
BgL_tmpz00_549 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_549, BgL_auxz00_551); } 
return 
BINT(BgL_val0_1072z00_333);} } } 

}



/* &mixer-volume-set!-so1079 */
obj_t BGl_z62mixerzd2volumezd2setz12zd2so1079za2zz__multimediazd2soundcardzd2(obj_t BgL_envz00_273, obj_t BgL_mz00_274, obj_t BgL_devz00_275, obj_t BgL_lz00_276, obj_t BgL_rz00_277)
{
{ /* Llib/soundcard.scm 83 */
{ /* Llib/soundcard.scm 87 */
int BgL_lz00_351;int BgL_rz00_352;
BgL_lz00_351 = 
CINT(BgL_lz00_276); 
BgL_rz00_352 = 
CINT(BgL_rz00_277); 
{ /* Llib/soundcard.scm 88 */
long BgL_volz00_353;
BgL_volz00_353 = 
(
(((long)256)*
(long)(BgL_rz00_352))+
(long)(BgL_lz00_351)); 
{ /* Llib/soundcard.scm 89 */
obj_t BgL_arg1152z00_354;obj_t BgL_arg1153z00_355;
BgL_arg1152z00_354 = 
(((BgL_soundcardz00_bglt)COBJECT(
((BgL_soundcardz00_bglt)BgL_mz00_274)))->BgL_z52mixerz52); 
{ /* Llib/soundcard.scm 73 */
obj_t BgL_cz00_356;
BgL_cz00_356 = 
BGl_assocz00zz__r4_pairs_and_lists_6_3z00(
((obj_t)BgL_devz00_275), 
(((BgL_soundcardz00_bglt)COBJECT(
((BgL_soundcardz00_bglt)BgL_mz00_274)))->BgL_z52devicesz52)); 
if(
PAIRP(BgL_cz00_356))
{ /* Llib/soundcard.scm 74 */
BgL_arg1153z00_355 = 
CDR(BgL_cz00_356); }  else 
{ /* Llib/soundcard.scm 74 */
BgL_arg1153z00_355 = 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)6)), BGl_string1208z00zz__multimediazd2soundcardzd2, 
((obj_t)BgL_devz00_275)); } } 
return 
bgl_mixer_write_vol(BgL_arg1152z00_354, 
CINT(BgL_arg1153z00_355), 
(int)(BgL_volz00_353));} } } } 

}



/* &mixer-close-soundcar1077 */
obj_t BGl_z62mixerzd2closezd2soundcar1077z62zz__multimediazd2soundcardzd2(obj_t BgL_envz00_278, obj_t BgL_mz00_279)
{
{ /* Llib/soundcard.scm 56 */
return 
bgl_close_mixer(
(((BgL_soundcardz00_bglt)COBJECT(
((BgL_soundcardz00_bglt)BgL_mz00_279)))->BgL_z52mixerz52));} 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__multimediazd2soundcardzd2()
{
{ /* Llib/soundcard.scm 15 */
return 
BGl_modulezd2initializa7ationz75zz__multimediazd2mixerzd2(((long)176492886), 
BSTRING_TO_STRING(BGl_string1209z00zz__multimediazd2soundcardzd2));} 

}

#ifdef __cplusplus
}
#endif
