/*===========================================================================*/
/*   (Llib/wav_decoder.scm)                                                  */
/*   Bigloo (4.3h)                                                           */
/*   Inria -- Sophia Antipolis (c)       Tue 12 May 2020 08:36:09 AM CEST    */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.3h/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.3h/lib/bigloo/4.3h -I Llib -lib-dir /builddir/build/BUILD/bigloo-4.3h/lib/bigloo/4.3h -safee -unsafe -srfi wav -copt  -copt -fPIC -copt -IClib Llib/wav_decoder.scm -o objs/wav_decoder.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_musicz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
} *BgL_musicz00_bglt;

typedef struct BgL_musicstatusz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_statez00;
   obj_t BgL_volumez00;
   bool_t BgL_repeatz00;
   bool_t BgL_randomz00;
   int BgL_playlistidz00;
   int BgL_playlistlengthz00;
   int BgL_xfadez00;
   int BgL_songz00;
   int BgL_songidz00;
   obj_t BgL_songposz00;
   int BgL_songlengthz00;
   int BgL_bitratez00;
   int BgL_khza7za7;
   obj_t BgL_errz00;
   int BgL_bufferingz00;
} *BgL_musicstatusz00_bglt;

typedef struct BgL_musicbufferz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_urlz00;
   bool_t BgL_z52eofz52;
   obj_t BgL_z52bcondvz52;
   obj_t BgL_z52bmutexz52;
   long BgL_z52inlenz52;
   char * BgL_z52inbufpz52;
   long BgL_z52headz52;
   long BgL_z52tailz52;
   bool_t BgL_z52emptyz52;
} *BgL_musicbufferz00_bglt;

typedef struct BgL_musicbufz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
   obj_t BgL_inbufz00;
   obj_t BgL_decodersz00;
   obj_t BgL_mkthreadz00;
   obj_t BgL_timeoutz00;
   obj_t BgL_z52decoderz52;
   obj_t BgL_z52bufferz52;
   obj_t BgL_z52nextbufferz52;
   obj_t BgL_z52playlistz52;
   bool_t BgL_z52areadyz52;
   obj_t BgL_z52amutexz52;
   int BgL_z52z12pidz40;
   obj_t BgL_z52acondvz52;
} *BgL_musicbufz00_bglt;

typedef struct BgL_musicdecoderz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_mimetypesz00;
   int BgL_bufferzd2timezd2nearz00;
   int BgL_bufferzd2siza7ezd2nearzd2ratioz75;
   int BgL_periodzd2siza7ezd2nearzd2ratioz75;
   bool_t BgL_z52z12dpausez40;
   bool_t BgL_z52z12dabortz40;
   bool_t BgL_z52z12stopz40;
   obj_t BgL_z52dmutexz52;
   obj_t BgL_z52dcondvz52;
   obj_t BgL_z52doutcondvz52;
} *BgL_musicdecoderz00_bglt;

typedef struct BgL_wavinfoz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_formatz00;
   long BgL_sampleratez00;
   int BgL_channelsz00;
   int BgL_bpsz00;
   long BgL_durationz00;
   obj_t BgL_audiofmtz00;
   int BgL_byteratez00;
   int BgL_blockalignz00;
   long BgL_chunksiza7eza7;
} *BgL_wavinfoz00_bglt;

typedef struct BgL_wavmusicdecoderz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_mimetypesz00;
   int BgL_bufferzd2timezd2nearz00;
   int BgL_bufferzd2siza7ezd2nearzd2ratioz75;
   int BgL_periodzd2siza7ezd2nearzd2ratioz75;
   bool_t BgL_z52z12dpausez40;
   bool_t BgL_z52z12dabortz40;
   bool_t BgL_z52z12stopz40;
   obj_t BgL_z52dmutexz52;
   obj_t BgL_z52dcondvz52;
   obj_t BgL_z52doutcondvz52;
   obj_t BgL_outbufz00;
   obj_t BgL_z52headerz52;
   int BgL_z52cursorz52;
   int BgL_z52siza7ezf5;
   int BgL_z52positionz52;
} *BgL_wavmusicdecoderz00_bglt;


static long BGl_z42wavzd2statuszd2okz42zz__wav_decoderz00;
BGL_IMPORT obj_t bgl_display_obj(obj_t, obj_t);
BGL_IMPORT obj_t BGl_musicbufferzd2blitzd2stringz12z12zz__multimediazd2musicbufzd2(BgL_musicbufferz00_bglt, int, obj_t, int, int);
BGL_IMPORT obj_t BGl_musicbufzd2writezd2zz__multimediazd2musicbufzd2(BgL_musicbufz00_bglt, obj_t, long);
static obj_t BGl_objectzd2initzd2zz__wav_decoderz00();
static obj_t BGl_z62musicdecoderzd2positio1135zb0zz__wav_decoderz00(obj_t, obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__wav_decoderz00();
static obj_t BGl_z62zc3z04anonymousza31219ze3ze5zz__wav_decoderz00(obj_t);
BGL_IMPORT obj_t make_string(long, unsigned char);
static obj_t BGl_inczd2tailz12ze70z27zz__wav_decoderz00(BgL_musicbufferz00_bglt, long, BgL_musicbufferz00_bglt, obj_t, long);
BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_conditionzd2variablezd2nilz00zz__threadz00();
static long BGl_z42wavzd2statuszd2newzd2formatz90zz__wav_decoderz00;
static obj_t BGl_z62zc3z04anonymousza31509ze3ze5zz__wav_decoderz00(obj_t);
BGL_IMPORT obj_t BGl_unwindzd2untilz12zc0zz__bexitz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31348ze3ze5zz__wav_decoderz00(obj_t, obj_t);
BGL_IMPORT int bgl_debug();
static obj_t BGl_z62zc3z04anonymousza31528ze3ze5zz__wav_decoderz00(obj_t);
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__wav_decoderz00();
BGL_IMPORT long BGl_musicbufferzd2availablezd2zz__multimediazd2musicbufzd2(BgL_musicbufferz00_bglt);
extern long BGl_wavzd2headerzd2siza7eza7zz__wav_wavz00();
static obj_t BGl_z62zc3z04anonymousza31581ze3ze5zz__wav_decoderz00(obj_t);
BGL_IMPORT obj_t BGl_musicdecoderzd2hwparamszd2setz12z12zz__multimediazd2musicbufzd2(BgL_musicdecoderz00_bglt, BgL_musicz00_bglt, BgL_musicbufferz00_bglt);
BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_exitdzd2popzd2protectz12z12zz__bexitz00(obj_t);
static obj_t BGl_za2debugzd2portza2zd2zz__wav_decoderz00 = BUNSPEC;
static bool_t BGl_flushze70ze7zz__wav_decoderz00(BgL_musicbufz00_bglt, BgL_wavmusicdecoderz00_bglt, int);
BGL_IMPORT obj_t BGl_findzd2superzd2classzd2methodzd2zz__objectz00(BgL_objectz00_bglt, obj_t, obj_t);
static obj_t BGl_z62musicdecoderzd2decodezd21137z62zz__wav_decoderz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zz__wav_decoderz00 = BUNSPEC;
static obj_t BGl_toplevelzd2initzd2zz__wav_decoderz00();
static obj_t BGl_zc3z04exitza31206ze3ze70z60zz__wav_decoderz00(int, BgL_wavmusicdecoderz00_bglt, BgL_musicbufferz00_bglt, obj_t);
BGL_IMPORT obj_t BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(BgL_musicz00_bglt, obj_t);
BGL_IMPORT obj_t BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(obj_t, obj_t);
static obj_t BGl_genericzd2initzd2zz__wav_decoderz00();
static obj_t BGl_wavzd2decodezd2statuszd2ze3symbolz31zz__wav_decoderz00(obj_t);
BGL_IMPORT obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t, bool_t, bool_t, obj_t, obj_t, obj_t);
static obj_t BGl_debugz00zz__wav_decoderz00(obj_t);
static long BGl_z42wavzd2statuszd2needzd2morez90zz__wav_decoderz00;
static obj_t BGl_z62zc3z04anonymousza31209ze3ze5zz__wav_decoderz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_mutexzd2nilzd2zz__threadz00();
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
static obj_t BGl_wavzd2decodezd2zz__wav_decoderz00(BgL_wavmusicdecoderz00_bglt, BgL_musicbufz00_bglt, BgL_musicbufferz00_bglt, int, int);
BGL_IMPORT obj_t BGl_musicdecoderz00zz__multimediazd2musicbufzd2;
BGL_IMPORT obj_t BGl_openzd2outputzd2filez00zz__r4_ports_6_10_1z00(obj_t, obj_t);
static int BGl_wavzd2debugzd2zz__wav_decoderz00();
BGL_IMPORT obj_t bgl_close_output_port(obj_t);
static long BGl_bufferzd2percentagezd2filledze70ze7zz__wav_decoderz00(long, BgL_musicbufferz00_bglt);
BGL_IMPORT BGL_LONGLONG_T bgl_current_microseconds();
static obj_t BGl_z62musicdecoderzd2resetz12zd21133z70zz__wav_decoderz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2constructorzd2zz__objectz00(obj_t);
BGL_IMPORT obj_t BGl_musiczd2errorzd2setz12z12zz__multimediazd2musiczd2(BgL_musicz00_bglt, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__wav_decoderz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__wav_wavz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2musicbufzd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__datez00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
static obj_t BGl_z62zc3z04anonymousza31550ze3ze5zz__wav_decoderz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31356ze3ze5zz__wav_decoderz00(obj_t);
static BgL_wavmusicdecoderz00_bglt BGl_z62lambda1335z62zz__wav_decoderz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_wavmusicdecoderz00_bglt BGl_z62lambda1338z62zz__wav_decoderz00(obj_t);
static obj_t BGl_z62lambda1507z62zz__wav_decoderz00(obj_t, obj_t);
static obj_t BGl_z62lambda1508z62zz__wav_decoderz00(obj_t, obj_t, obj_t);
static obj_t BGl_cnstzd2initzd2zz__wav_decoderz00();
static obj_t BGl_libraryzd2moduleszd2initz00zz__wav_decoderz00();
static obj_t BGl_debugzd2initz12zc0zz__wav_decoderz00(obj_t);
static obj_t BGl_importedzd2moduleszd2initz00zz__wav_decoderz00();
static obj_t BGl_z62lambda1354z62zz__wav_decoderz00(obj_t, obj_t);
static obj_t BGl_z62lambda1355z62zz__wav_decoderz00(obj_t, obj_t, obj_t);
BGL_IMPORT long BGl_musicdecoderzd2positionzd2zz__multimediazd2musicbufzd2(BgL_musicdecoderz00_bglt, BgL_musicbufferz00_bglt);
static obj_t BGl_z62musicdecoderzd2initzd2wa1131z62zz__wav_decoderz00(obj_t, obj_t);
static obj_t BGl_z62lambda1526z62zz__wav_decoderz00(obj_t, obj_t);
static obj_t BGl_z62lambda1527z62zz__wav_decoderz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62musicdecoderzd2volumezd21139z62zz__wav_decoderz00(obj_t, obj_t, obj_t);
static obj_t BGl_debugzd2stopz12zc0zz__wav_decoderz00(obj_t);
static obj_t BGl_z62objectzd2printzd2wavmusi1129z62zz__wav_decoderz00(obj_t, obj_t, obj_t, obj_t);
static long BGl_z42wavzd2statuszd2donez42zz__wav_decoderz00;
static obj_t BGl_z62lambda1548z62zz__wav_decoderz00(obj_t, obj_t);
static obj_t BGl_z62lambda1549z62zz__wav_decoderz00(obj_t, obj_t, obj_t);
extern obj_t BGl_wavzd2parsezd2headerz00zz__wav_wavz00(obj_t);
BGL_EXPORTED_DEF obj_t BGl_wavmusicdecoderz00zz__wav_decoderz00 = BUNSPEC;
static obj_t BGl_z62lambda1579z62zz__wav_decoderz00(obj_t, obj_t);
static obj_t BGl_z62lambda1580z62zz__wav_decoderz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_musicbufferzd2substringzd2zz__multimediazd2musicbufzd2(BgL_musicbufferz00_bglt, int, int);
static obj_t __cnst[ 23 ] ;


BGL_IMPORT obj_t BGl_musicdecoderzd2decodezd2envz00zz__multimediazd2musicbufzd2;
BGL_IMPORT obj_t BGl_musicdecoderzd2volumezd2setz12zd2envzc0zz__multimediazd2musicbufzd2;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1976z00zz__wav_decoderz00, BgL_bgl_za762za7c3za704anonymo2033za7, BGl_z62zc3z04anonymousza31356ze3ze5zz__wav_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1977z00zz__wav_decoderz00, BgL_bgl_za762lambda1355za7622034z00, BGl_z62lambda1355z62zz__wav_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1978z00zz__wav_decoderz00, BgL_bgl_za762lambda1354za7622035z00, BGl_z62lambda1354z62zz__wav_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1979z00zz__wav_decoderz00, BgL_bgl_za762za7c3za704anonymo2036za7, BGl_z62zc3z04anonymousza31509ze3ze5zz__wav_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1980z00zz__wav_decoderz00, BgL_bgl_za762lambda1508za7622037z00, BGl_z62lambda1508z62zz__wav_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1981z00zz__wav_decoderz00, BgL_bgl_za762lambda1507za7622038z00, BGl_z62lambda1507z62zz__wav_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1982z00zz__wav_decoderz00, BgL_bgl_za762za7c3za704anonymo2039za7, BGl_z62zc3z04anonymousza31528ze3ze5zz__wav_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1983z00zz__wav_decoderz00, BgL_bgl_za762lambda1527za7622040z00, BGl_z62lambda1527z62zz__wav_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1984z00zz__wav_decoderz00, BgL_bgl_za762lambda1526za7622041z00, BGl_z62lambda1526z62zz__wav_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1985z00zz__wav_decoderz00, BgL_bgl_za762za7c3za704anonymo2042za7, BGl_z62zc3z04anonymousza31550ze3ze5zz__wav_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1986z00zz__wav_decoderz00, BgL_bgl_za762lambda1549za7622043z00, BGl_z62lambda1549z62zz__wav_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1987z00zz__wav_decoderz00, BgL_bgl_za762lambda1548za7622044z00, BGl_z62lambda1548z62zz__wav_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1988z00zz__wav_decoderz00, BgL_bgl_za762za7c3za704anonymo2045za7, BGl_z62zc3z04anonymousza31581ze3ze5zz__wav_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1989z00zz__wav_decoderz00, BgL_bgl_za762lambda1580za7622046z00, BGl_z62lambda1580z62zz__wav_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1990z00zz__wav_decoderz00, BgL_bgl_za762lambda1579za7622047z00, BGl_z62lambda1579z62zz__wav_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1991z00zz__wav_decoderz00, BgL_bgl_za762za7c3za704anonymo2048za7, BGl_z62zc3z04anonymousza31348ze3ze5zz__wav_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1992z00zz__wav_decoderz00, BgL_bgl_za762lambda1338za7622049z00, BGl_z62lambda1338z62zz__wav_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1993z00zz__wav_decoderz00, BgL_bgl_za762lambda1335za7622050z00, BGl_z62lambda1335z62zz__wav_decoderz00, 0L, BUNSPEC, 15 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1995z00zz__wav_decoderz00, BgL_bgl_za762objectza7d2prin2051z00, BGl_z62objectzd2printzd2wavmusi1129z62zz__wav_decoderz00, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1997z00zz__wav_decoderz00, BgL_bgl_za762musicdecoderza72052z00, BGl_z62musicdecoderzd2initzd2wa1131z62zz__wav_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1999z00zz__wav_decoderz00, BgL_bgl_za762musicdecoderza72053z00, BGl_z62musicdecoderzd2resetz12zd21133z70zz__wav_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2000z00zz__wav_decoderz00, BgL_bgl_string2000za700za7za7_2054za7, "musicdecoder-reset!", 19 );
DEFINE_STRING( BGl_string2002z00zz__wav_decoderz00, BgL_bgl_string2002za700za7za7_2055za7, "musicdecoder-position", 21 );
DEFINE_STRING( BGl_string2004z00zz__wav_decoderz00, BgL_bgl_string2004za700za7za7_2056za7, "musicdecoder-decode", 19 );
DEFINE_STRING( BGl_string2006z00zz__wav_decoderz00, BgL_bgl_string2006za700za7za7_2057za7, "musicdecoder-volume-set!", 24 );
DEFINE_STRING( BGl_string2007z00zz__wav_decoderz00, BgL_bgl_string2007za700za7za7_2058za7, "~~~ WAV_DECODER, EOF ", 21 );
DEFINE_STRING( BGl_string2008z00zz__wav_decoderz00, BgL_bgl_string2008za700za7za7_2059za7, "...", 3 );
DEFINE_STRING( BGl_string2009z00zz__wav_decoderz00, BgL_bgl_string2009za700za7za7_2060za7, "<-- WAV_DECODER, wait not-empty ", 32 );
DEFINE_STRING( BGl_string2010z00zz__wav_decoderz00, BgL_bgl_string2010za700za7za7_2061za7, " -> status=", 11 );
DEFINE_STRING( BGl_string2011z00zz__wav_decoderz00, BgL_bgl_string2011za700za7za7_2062za7, " hd=", 4 );
DEFINE_STRING( BGl_string2012z00zz__wav_decoderz00, BgL_bgl_string2012za700za7za7_2063za7, " tl=", 4 );
DEFINE_STRING( BGl_string2013z00zz__wav_decoderz00, BgL_bgl_string2013za700za7za7_2064za7, "~~~ WAV_DECODER, s=", 19 );
DEFINE_STRING( BGl_string2014z00zz__wav_decoderz00, BgL_bgl_string2014za700za7za7_2065za7, " size=", 6 );
DEFINE_STRING( BGl_string2015z00zz__wav_decoderz00, BgL_bgl_string2015za700za7za7_2066za7, "~~~ WAV_DECODER, OK s=", 22 );
DEFINE_STRING( BGl_string2016z00zz__wav_decoderz00, BgL_bgl_string2016za700za7za7_2067za7, " tail=", 6 );
DEFINE_STRING( BGl_string2017z00zz__wav_decoderz00, BgL_bgl_string2017za700za7za7_2068za7, " %empty=", 8 );
DEFINE_STRING( BGl_string2018z00zz__wav_decoderz00, BgL_bgl_string2018za700za7za7_2069za7, "~~~ WAV_DECODER, NEED-MORE s=", 29 );
DEFINE_STRING( BGl_string2019z00zz__wav_decoderz00, BgL_bgl_string2019za700za7za7_2070za7, "wav decoding error", 18 );
DEFINE_STRING( BGl_string2020z00zz__wav_decoderz00, BgL_bgl_string2020za700za7za7_2071za7, "\033[0m\033[1;33m", 11 );
DEFINE_STRING( BGl_string2021z00zz__wav_decoderz00, BgL_bgl_string2021za700za7za7_2072za7, "\033[0m\033[1;32m", 11 );
DEFINE_STRING( BGl_string2022z00zz__wav_decoderz00, BgL_bgl_string2022za700za7za7_2073za7, " EOF", 4 );
DEFINE_STRING( BGl_string2023z00zz__wav_decoderz00, BgL_bgl_string2023za700za7za7_2074za7, " url=", 5 );
DEFINE_STRING( BGl_string2024z00zz__wav_decoderz00, BgL_bgl_string2024za700za7za7_2075za7, "%\033[0m", 5 );
DEFINE_STRING( BGl_string2025z00zz__wav_decoderz00, BgL_bgl_string2025za700za7za7_2076za7, "--- WAV_DECODER, buffer fill: ", 30 );
DEFINE_STRING( BGl_string2026z00zz__wav_decoderz00, BgL_bgl_string2026za700za7za7_2077za7, "--> WAV_DECODER, broadcast not-full ", 36 );
DEFINE_STRING( BGl_string2027z00zz__wav_decoderz00, BgL_bgl_string2027za700za7za7_2078za7, "#|wavmusicdecoder|", 18 );
DEFINE_STRING( BGl_string2028z00zz__wav_decoderz00, BgL_bgl_string2028za700za7za7_2079za7, "__wav_decoder", 13 );
DEFINE_STRING( BGl_string2029z00zz__wav_decoderz00, BgL_bgl_string2029za700za7za7_2080za7, "(\"audio/wav\" \"audio/x-wav\" \"audio/x-pn-windows-acm\") error buffering ended stop play pause __wav_decoder wavmusicdecoder %position %size int %cursor obj %header bstring outbuf pcm unknown-status ok need-more done new-format ", 224 );
BGL_IMPORT obj_t BGl_objectzd2printzd2envz00zz__objectz00;
DEFINE_STRING( BGl_string1968z00zz__wav_decoderz00, BgL_bgl_string1968za700za7za7_2081za7, "Llib/wav_decoder.scm", 20 );
DEFINE_STRING( BGl_string1969z00zz__wav_decoderz00, BgL_bgl_string1969za700za7za7_2082za7, "wav-decode", 10 );
DEFINE_STRING( BGl_string1970z00zz__wav_decoderz00, BgL_bgl_string1970za700za7za7_2083za7, "Cannot play none PCM wav format", 31 );
DEFINE_STRING( BGl_string1971z00zz__wav_decoderz00, BgL_bgl_string1971za700za7za7_2084za7, "/tmp/WAV.log", 12 );
DEFINE_STRING( BGl_string1972z00zz__wav_decoderz00, BgL_bgl_string1972za700za7za7_2085za7, "\n", 1 );
DEFINE_STRING( BGl_string1973z00zz__wav_decoderz00, BgL_bgl_string1973za700za7za7_2086za7, " ", 1 );
DEFINE_STRING( BGl_string1974z00zz__wav_decoderz00, BgL_bgl_string1974za700za7za7_2087za7, ">>> WAV_DECODER init ", 21 );
DEFINE_STRING( BGl_string1975z00zz__wav_decoderz00, BgL_bgl_string1975za700za7za7_2088za7, ">>> WAV_DECODER stop ", 21 );
DEFINE_STRING( BGl_string1994z00zz__wav_decoderz00, BgL_bgl_string1994za700za7za7_2089za7, "", 0 );
DEFINE_STRING( BGl_string1996z00zz__wav_decoderz00, BgL_bgl_string1996za700za7za7_2090za7, "object-print", 12 );
DEFINE_STRING( BGl_string1998z00zz__wav_decoderz00, BgL_bgl_string1998za700za7za7_2091za7, "musicdecoder-init", 17 );
BGL_IMPORT obj_t BGl_musicdecoderzd2resetz12zd2envz12zz__multimediazd2musicbufzd2;
BGL_IMPORT obj_t BGl_musicdecoderzd2initzd2envz00zz__multimediazd2musicbufzd2;
BGL_IMPORT obj_t BGl_musicdecoderzd2positionzd2envz00zz__multimediazd2musicbufzd2;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2001z00zz__wav_decoderz00, BgL_bgl_za762musicdecoderza72092z00, BGl_z62musicdecoderzd2positio1135zb0zz__wav_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2003z00zz__wav_decoderz00, BgL_bgl_za762musicdecoderza72093z00, BGl_z62musicdecoderzd2decodezd21137z62zz__wav_decoderz00, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2005z00zz__wav_decoderz00, BgL_bgl_za762musicdecoderza72094z00, BGl_z62musicdecoderzd2volumezd21139z62zz__wav_decoderz00, 0L, BUNSPEC, 2 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_za2debugzd2portza2zd2zz__wav_decoderz00) );
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__wav_decoderz00) );
ADD_ROOT( (void *)(&BGl_wavmusicdecoderz00zz__wav_decoderz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__wav_decoderz00(long BgL_checksumz00_984, char * BgL_fromz00_985)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__wav_decoderz00))
{ 
BGl_requirezd2initializa7ationz75zz__wav_decoderz00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__wav_decoderz00(); 
BGl_libraryzd2moduleszd2initz00zz__wav_decoderz00(); 
BGl_cnstzd2initzd2zz__wav_decoderz00(); 
BGl_importedzd2moduleszd2initz00zz__wav_decoderz00(); 
BGl_objectzd2initzd2zz__wav_decoderz00(); 
BGl_methodzd2initzd2zz__wav_decoderz00(); 
return 
BGl_toplevelzd2initzd2zz__wav_decoderz00();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__wav_decoderz00()
{
{ /* Llib/wav_decoder.scm 15 */
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "__wav_decoder"); 
BGl_modulezd2initializa7ationz75zz__multimediazd2musicbufzd2(((long)0), "__wav_decoder"); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "__wav_decoder"); 
BGl_modulezd2initializa7ationz75zz__threadz00(((long)0), "__wav_decoder"); 
BGl_modulezd2initializa7ationz75zz__bexitz00(((long)0), "__wav_decoder"); 
BGl_modulezd2initializa7ationz75zz__paramz00(((long)0), "__wav_decoder"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__wav_decoder"); 
BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(((long)0), "__wav_decoder"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__wav_decoder"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__wav_decoder"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__wav_decoder"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__wav_decoder"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__wav_decoder"); 
BGl_modulezd2initializa7ationz75zz__datez00(((long)0), "__wav_decoder"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__wav_decoder"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__wav_decoderz00()
{
{ /* Llib/wav_decoder.scm 15 */
{ /* Llib/wav_decoder.scm 15 */
obj_t BgL_cportz00_848;
{ /* Llib/wav_decoder.scm 15 */
obj_t BgL_stringz00_856;
BgL_stringz00_856 = BGl_string2029z00zz__wav_decoderz00; 
{ /* Llib/wav_decoder.scm 15 */
obj_t BgL_startz00_857;
BgL_startz00_857 = 
BINT(((long)0)); 
{ /* Llib/wav_decoder.scm 15 */
obj_t BgL_endz00_858;
BgL_endz00_858 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_856))); 
{ /* Llib/wav_decoder.scm 15 */

BgL_cportz00_848 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_856, BgL_startz00_857, BgL_endz00_858); } } } } 
{ 
long BgL_iz00_849;
BgL_iz00_849 = ((long)22); 
BgL_loopz00_850:
if(
(BgL_iz00_849==((long)-1)))
{ /* Llib/wav_decoder.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/wav_decoder.scm 15 */
{ /* Llib/wav_decoder.scm 15 */
obj_t BgL_arg2031z00_852;
{ /* Llib/wav_decoder.scm 15 */

{ /* Llib/wav_decoder.scm 15 */
obj_t BgL_locationz00_854;
BgL_locationz00_854 = 
BBOOL(((bool_t)0)); 
{ /* Llib/wav_decoder.scm 15 */

BgL_arg2031z00_852 = 
BGl_readz00zz__readerz00(BgL_cportz00_848, BgL_locationz00_854); } } } 
{ /* Llib/wav_decoder.scm 15 */
int BgL_tmpz00_1020;
BgL_tmpz00_1020 = 
(int)(BgL_iz00_849); 
CNST_TABLE_SET(BgL_tmpz00_1020, BgL_arg2031z00_852); } } 
{ /* Llib/wav_decoder.scm 15 */
int BgL_auxz00_855;
BgL_auxz00_855 = 
(int)(
(BgL_iz00_849-((long)1))); 
{ 
long BgL_iz00_1025;
BgL_iz00_1025 = 
(long)(BgL_auxz00_855); 
BgL_iz00_849 = BgL_iz00_1025; 
goto BgL_loopz00_850;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__wav_decoderz00()
{
{ /* Llib/wav_decoder.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__wav_decoderz00()
{
{ /* Llib/wav_decoder.scm 15 */
BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(((long)0), 
BSTRING_TO_STRING(BGl_string1968z00zz__wav_decoderz00)); 
BGl_z42wavzd2statuszd2newzd2formatz90zz__wav_decoderz00 = ((long)1); 
BGl_z42wavzd2statuszd2donez42zz__wav_decoderz00 = ((long)2); 
BGl_z42wavzd2statuszd2needzd2morez90zz__wav_decoderz00 = ((long)3); 
BGl_z42wavzd2statuszd2okz42zz__wav_decoderz00 = ((long)4); 
return ( 
BGl_za2debugzd2portza2zd2zz__wav_decoderz00 = BFALSE, BUNSPEC) ;} 

}



/* wav-debug */
int BGl_wavzd2debugzd2zz__wav_decoderz00()
{
{ /* Llib/wav_decoder.scm 37 */
if(
(((long)0)>((long)0)))
{ /* Llib/wav_decoder.scm 38 */
return 
bgl_debug();}  else 
{ /* Llib/wav_decoder.scm 38 */
return 
(int)(((long)0));} } 

}



/* wav-decode-status->symbol */
obj_t BGl_wavzd2decodezd2statuszd2ze3symbolz31zz__wav_decoderz00(obj_t BgL_statusz00_10)
{
{ /* Llib/wav_decoder.scm 82 */
if(
(((long)1)==
(long)CINT(BgL_statusz00_10)))
{ /* Llib/wav_decoder.scm 84 */
return 
CNST_TABLE_REF(((long)0));}  else 
{ /* Llib/wav_decoder.scm 84 */
if(
(((long)2)==
(long)CINT(BgL_statusz00_10)))
{ /* Llib/wav_decoder.scm 85 */
return 
CNST_TABLE_REF(((long)1));}  else 
{ /* Llib/wav_decoder.scm 85 */
if(
(((long)3)==
(long)CINT(BgL_statusz00_10)))
{ /* Llib/wav_decoder.scm 86 */
return 
CNST_TABLE_REF(((long)2));}  else 
{ /* Llib/wav_decoder.scm 86 */
if(
(((long)4)==
(long)CINT(BgL_statusz00_10)))
{ /* Llib/wav_decoder.scm 87 */
return 
CNST_TABLE_REF(((long)3));}  else 
{ /* Llib/wav_decoder.scm 87 */
return 
CNST_TABLE_REF(((long)4));} } } } } 

}



/* wav-decode */
obj_t BGl_wavzd2decodezd2zz__wav_decoderz00(BgL_wavmusicdecoderz00_bglt BgL_decz00_14, BgL_musicbufz00_bglt BgL_amz00_15, BgL_musicbufferz00_bglt BgL_bufferz00_16, int BgL_tailz00_17, int BgL_sz00_18)
{
{ /* Llib/wav_decoder.scm 267 */
if(
CBOOL(
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_14))->BgL_z52headerz52)))
{ /* Llib/wav_decoder.scm 288 */
BgL_wavinfoz00_bglt BgL_i1121z00_40;
BgL_i1121z00_40 = 
((BgL_wavinfoz00_bglt)
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_14))->BgL_z52headerz52)); 
if(
(
(long)(BgL_sz00_18)<
(long)(
(((BgL_wavinfoz00_bglt)COBJECT(BgL_i1121z00_40))->BgL_blockalignz00))))
{ /* Llib/wav_decoder.scm 290 */
{ /* Llib/wav_decoder.scm 291 */
long BgL_arg1151z00_43;obj_t BgL_arg1152z00_44;int BgL_arg1153z00_45;
BgL_arg1151z00_43 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_bufferz00_16))->BgL_z52tailz52); 
BgL_arg1152z00_44 = 
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_14))->BgL_outbufz00); 
BgL_arg1153z00_45 = 
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_14))->BgL_z52cursorz52); 
BGl_musicbufferzd2blitzd2stringz12z12zz__multimediazd2musicbufzd2(BgL_bufferz00_16, 
(int)(BgL_arg1151z00_43), BgL_arg1152z00_44, BgL_arg1153z00_45, BgL_sz00_18); } 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_14))->BgL_z52cursorz52)=((int)
(int)(
(
(long)(
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_14))->BgL_z52cursorz52))+
(long)(BgL_sz00_18)))),BUNSPEC); 
return 
BINT(((long)3));}  else 
{ /* Llib/wav_decoder.scm 294 */
bool_t BgL_test2104z00_1073;
{ /* Llib/wav_decoder.scm 294 */
long BgL_n1z00_538;long BgL_n2z00_539;
BgL_n1z00_538 = 
(long)(
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_14))->BgL_z52positionz52)); 
{ /* Llib/wav_decoder.scm 294 */
long BgL_tmpz00_1076;
BgL_tmpz00_1076 = 
(((BgL_wavinfoz00_bglt)COBJECT(BgL_i1121z00_40))->BgL_chunksiza7eza7); 
BgL_n2z00_539 = 
(long)(BgL_tmpz00_1076); } 
BgL_test2104z00_1073 = 
(BgL_n1z00_538>=BgL_n2z00_539); } 
if(BgL_test2104z00_1073)
{ /* Llib/wav_decoder.scm 294 */
return 
BINT(((long)2));}  else 
{ /* Llib/wav_decoder.scm 294 */
{ 
int BgL_auxz00_1081;
{ /* Llib/wav_decoder.scm 297 */
long BgL_za71za7_544;
BgL_za71za7_544 = 
(long)(
(((BgL_wavinfoz00_bglt)COBJECT(BgL_i1121z00_40))->BgL_blockalignz00)); 
BgL_auxz00_1081 = 
(int)(
(BgL_za71za7_544*
(
(long)(BgL_sz00_18)/BgL_za71za7_544))); } 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_14))->BgL_z52siza7ezf5)=((int)BgL_auxz00_1081),BUNSPEC); } 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_14))->BgL_z52positionz52)=((int)
(int)(
(
(long)(
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_14))->BgL_z52positionz52))+
(long)(
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_14))->BgL_z52siza7ezf5))))),BUNSPEC); 
{ /* Llib/wav_decoder.scm 299 */
long BgL_arg1169z00_55;obj_t BgL_arg1170z00_56;int BgL_arg1171z00_57;int BgL_arg1172z00_58;
BgL_arg1169z00_55 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_bufferz00_16))->BgL_z52tailz52); 
BgL_arg1170z00_56 = 
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_14))->BgL_outbufz00); 
BgL_arg1171z00_57 = 
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_14))->BgL_z52cursorz52); 
BgL_arg1172z00_58 = 
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_14))->BgL_z52siza7ezf5); 
BGl_musicbufferzd2blitzd2stringz12z12zz__multimediazd2musicbufzd2(BgL_bufferz00_16, 
(int)(BgL_arg1169z00_55), BgL_arg1170z00_56, BgL_arg1171z00_57, BgL_arg1172z00_58); } 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_14))->BgL_z52cursorz52)=((int)
(int)(((long)0))),BUNSPEC); 
return 
BINT(((long)4));} } }  else 
{ /* Llib/wav_decoder.scm 271 */
obj_t BgL_res1109z00_721;
BgL_res1109z00_721 = 
MAKE_CELL(BUNSPEC); 
if(
CBOOL(
BGl_zc3z04exitza31206ze3ze70z60zz__wav_decoderz00(BgL_sz00_18, BgL_decz00_14, BgL_bufferz00_16, BgL_res1109z00_721)))
{ /* Llib/wav_decoder.scm 271 */
obj_t BgL_ez00_555;
BgL_ez00_555 = 
CELL_REF(BgL_res1109z00_721); 
return 
BGl_musiczd2errorzd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_amz00_15), BgL_ez00_555);}  else 
{ /* Llib/wav_decoder.scm 271 */
return 
CELL_REF(BgL_res1109z00_721);} } } 

}



/* <@exit:1206>~0 */
obj_t BGl_zc3z04exitza31206ze3ze70z60zz__wav_decoderz00(int BgL_sz00_847, BgL_wavmusicdecoderz00_bglt BgL_i1106z00_846, BgL_musicbufferz00_bglt BgL_bufferz00_845, obj_t BgL_res1109z00_844)
{
{ /* Llib/wav_decoder.scm 271 */
jmp_buf_t jmpbuf; 
void * BgL_an_exit1116z00_94;
if( SET_EXIT(BgL_an_exit1116z00_94) ) { 
return 
BGL_EXIT_VALUE();
} else {
#if( SIGSETJMP_SAVESIGS == 0 )
  bgl_restore_signal_handlers();
#endif

BgL_an_exit1116z00_94 = 
(void *)jmpbuf; 
{ /* Llib/wav_decoder.scm 271 */

PUSH_EXIT(BgL_an_exit1116z00_94, ((long)1)); 
{ /* Llib/wav_decoder.scm 271 */
obj_t BgL_an_exitd1117z00_95;
BgL_an_exitd1117z00_95 = 
((obj_t)(&exitd)); 
{ /* Llib/wav_decoder.scm 271 */
bool_t BgL_res1119z00_98;
{ /* Llib/wav_decoder.scm 271 */
obj_t BgL_ohs1107z00_99;
BgL_ohs1107z00_99 = 
BGL_ERROR_HANDLER_GET(); 
{ /* Llib/wav_decoder.scm 271 */
obj_t BgL_exitd1112z00_100;
BgL_exitd1112z00_100 = 
((obj_t)(&exitd)); 
{ 
obj_t BgL_zc3z04anonymousza31219ze3z87_713;
BgL_zc3z04anonymousza31219ze3z87_713 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31219ze3ze5zz__wav_decoderz00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31219ze3z87_713, 
(int)(((long)0)), BgL_ohs1107z00_99); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1112z00_100, BgL_zc3z04anonymousza31219ze3z87_713); 
{ /* Llib/wav_decoder.scm 271 */
bool_t BgL_tmp1114z00_102;
{ /* Llib/wav_decoder.scm 271 */
obj_t BgL_arg1207z00_103;
{ /* Llib/wav_decoder.scm 271 */
obj_t BgL_zc3z04anonymousza31209ze3z87_712;
BgL_zc3z04anonymousza31209ze3z87_712 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31209ze3ze5zz__wav_decoderz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31209ze3z87_712, 
(int)(((long)0)), 
((obj_t)BgL_res1109z00_844)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31209ze3z87_712, 
(int)(((long)1)), BgL_an_exitd1117z00_95); 
BgL_arg1207z00_103 = 
MAKE_YOUNG_PAIR(BgL_zc3z04anonymousza31209ze3z87_712, BgL_ohs1107z00_99); } 
BGL_ERROR_HANDLER_SET(BgL_arg1207z00_103); BUNSPEC; } 
{ /* Llib/wav_decoder.scm 271 */
obj_t BgL_auxz00_722;
{ /* Llib/wav_decoder.scm 274 */
bool_t BgL_test2106z00_1130;
{ /* Llib/wav_decoder.scm 274 */
long BgL_arg1218z00_116;
BgL_arg1218z00_116 = 
BGl_wavzd2headerzd2siza7eza7zz__wav_wavz00(); 
{ /* Llib/wav_decoder.scm 274 */
long BgL_n1z00_550;long BgL_n2z00_551;
BgL_n1z00_550 = 
(long)(BgL_sz00_847); 
BgL_n2z00_551 = 
(long)(BgL_arg1218z00_116); 
BgL_test2106z00_1130 = 
(BgL_n1z00_550<BgL_n2z00_551); } } 
if(BgL_test2106z00_1130)
{ /* Llib/wav_decoder.scm 274 */
BgL_auxz00_722 = 
BINT(((long)3)); }  else 
{ /* Llib/wav_decoder.scm 276 */
obj_t BgL_strz00_109;
{ /* Llib/wav_decoder.scm 277 */
long BgL_arg1212z00_114;
{ /* Llib/wav_decoder.scm 277 */
long BgL_arg1214z00_115;
BgL_arg1214z00_115 = 
BGl_wavzd2headerzd2siza7eza7zz__wav_wavz00(); 
{ /* Llib/wav_decoder.scm 277 */
long BgL_res1890z00_554;
BgL_res1890z00_554 = 
(long)(BgL_arg1214z00_115); 
BgL_arg1212z00_114 = BgL_res1890z00_554; } } 
BgL_strz00_109 = 
BGl_musicbufferzd2substringzd2zz__multimediazd2musicbufzd2(BgL_bufferz00_845, 
(int)(((long)0)), 
(int)(BgL_arg1212z00_114)); } 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_i1106z00_846))->BgL_z52headerz52)=((obj_t)
BGl_wavzd2parsezd2headerz00zz__wav_wavz00(BgL_strz00_109)),BUNSPEC); 
{ /* Llib/wav_decoder.scm 279 */
BgL_wavinfoz00_bglt BgL_i1115z00_110;
BgL_i1115z00_110 = 
((BgL_wavinfoz00_bglt)
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_i1106z00_846))->BgL_z52headerz52)); 
if(
(
(((BgL_wavinfoz00_bglt)COBJECT(BgL_i1115z00_110))->BgL_audiofmtz00)==
CNST_TABLE_REF(((long)5))))
{ /* Llib/wav_decoder.scm 280 */BFALSE; }  else 
{ /* Llib/wav_decoder.scm 280 */
BGl_errorz00zz__errorz00(BGl_string1969z00zz__wav_decoderz00, BGl_string1970z00zz__wav_decoderz00, 
(((BgL_wavinfoz00_bglt)COBJECT(BgL_i1115z00_110))->BgL_audiofmtz00)); } } 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_i1106z00_846))->BgL_z52siza7ezf5)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_i1106z00_846))->BgL_z52cursorz52)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_i1106z00_846))->BgL_z52positionz52)=((int)
(int)(((long)0))),BUNSPEC); 
BgL_auxz00_722 = 
BINT(((long)1)); } } 
CELL_SET(BgL_res1109z00_844, BgL_auxz00_722); } 
BgL_tmp1114z00_102 = ((bool_t)0); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1112z00_100); 
BGL_ERROR_HANDLER_SET(BgL_ohs1107z00_99); BUNSPEC; 
BgL_res1119z00_98 = BgL_tmp1114z00_102; } } } } 
POP_EXIT(); 
return 
BBOOL(BgL_res1119z00_98);} } } 
} } 

}



/* &<@anonymous:1209> */
obj_t BGl_z62zc3z04anonymousza31209ze3ze5zz__wav_decoderz00(obj_t BgL_envz00_714, obj_t BgL_ez00_717)
{
{ /* Llib/wav_decoder.scm 271 */
{ /* Llib/wav_decoder.scm 271 */
obj_t BgL_res1109z00_715;obj_t BgL_an_exitd1117z00_716;
BgL_res1109z00_715 = 
PROCEDURE_REF(BgL_envz00_714, 
(int)(((long)0))); 
BgL_an_exitd1117z00_716 = 
PROCEDURE_REF(BgL_envz00_714, 
(int)(((long)1))); 
CELL_SET(BgL_res1109z00_715, BgL_ez00_717); 
return 
BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1117z00_716, BTRUE);} } 

}



/* &<@anonymous:1219> */
obj_t BGl_z62zc3z04anonymousza31219ze3ze5zz__wav_decoderz00(obj_t BgL_envz00_719)
{
{ /* Llib/wav_decoder.scm 271 */
{ 
obj_t BgL_ohs1107z00_720;
BgL_ohs1107z00_720 = 
PROCEDURE_REF(BgL_envz00_719, 
(int)(((long)0))); 
BGL_ERROR_HANDLER_SET(BgL_ohs1107z00_720); 
return BUNSPEC;} } 

}



/* debug-init! */
obj_t BGl_debugzd2initz12zc0zz__wav_decoderz00(obj_t BgL_urlz00_21)
{
{ /* Llib/wav_decoder.scm 317 */
{ /* Llib/wav_decoder.scm 318 */

BGl_za2debugzd2portza2zd2zz__wav_decoderz00 = 
BGl_openzd2outputzd2filez00zz__r4_ports_6_10_1z00(BGl_string1971z00zz__wav_decoderz00, BTRUE); } 
{ /* Llib/wav_decoder.scm 319 */
BGL_LONGLONG_T BgL_arg1230z00_124;
BgL_arg1230z00_124 = 
bgl_current_microseconds(); 
{ /* Llib/wav_decoder.scm 319 */
obj_t BgL_list1231z00_125;
{ /* Llib/wav_decoder.scm 319 */
obj_t BgL_arg1232z00_126;
{ /* Llib/wav_decoder.scm 319 */
obj_t BgL_arg1233z00_127;
{ /* Llib/wav_decoder.scm 319 */
obj_t BgL_arg1258z00_128;
{ /* Llib/wav_decoder.scm 319 */
obj_t BgL_arg1259z00_129;
BgL_arg1259z00_129 = 
MAKE_YOUNG_PAIR(BGl_string1972z00zz__wav_decoderz00, BNIL); 
BgL_arg1258z00_128 = 
MAKE_YOUNG_PAIR(
make_bllong(BgL_arg1230z00_124), BgL_arg1259z00_129); } 
BgL_arg1233z00_127 = 
MAKE_YOUNG_PAIR(BGl_string1973z00zz__wav_decoderz00, BgL_arg1258z00_128); } 
BgL_arg1232z00_126 = 
MAKE_YOUNG_PAIR(BgL_urlz00_21, BgL_arg1233z00_127); } 
BgL_list1231z00_125 = 
MAKE_YOUNG_PAIR(BGl_string1974z00zz__wav_decoderz00, BgL_arg1232z00_126); } 
return 
BGl_debugz00zz__wav_decoderz00(BgL_list1231z00_125);} } } 

}



/* debug-stop! */
obj_t BGl_debugzd2stopz12zc0zz__wav_decoderz00(obj_t BgL_urlz00_22)
{
{ /* Llib/wav_decoder.scm 324 */
{ /* Llib/wav_decoder.scm 325 */
BGL_LONGLONG_T BgL_arg1265z00_130;
BgL_arg1265z00_130 = 
bgl_current_microseconds(); 
{ /* Llib/wav_decoder.scm 325 */
obj_t BgL_list1266z00_131;
{ /* Llib/wav_decoder.scm 325 */
obj_t BgL_arg1267z00_132;
{ /* Llib/wav_decoder.scm 325 */
obj_t BgL_arg1268z00_133;
{ /* Llib/wav_decoder.scm 325 */
obj_t BgL_arg1269z00_134;
{ /* Llib/wav_decoder.scm 325 */
obj_t BgL_arg1281z00_135;
BgL_arg1281z00_135 = 
MAKE_YOUNG_PAIR(BGl_string1972z00zz__wav_decoderz00, BNIL); 
BgL_arg1269z00_134 = 
MAKE_YOUNG_PAIR(
make_bllong(BgL_arg1265z00_130), BgL_arg1281z00_135); } 
BgL_arg1268z00_133 = 
MAKE_YOUNG_PAIR(BGl_string1973z00zz__wav_decoderz00, BgL_arg1269z00_134); } 
BgL_arg1267z00_132 = 
MAKE_YOUNG_PAIR(BgL_urlz00_22, BgL_arg1268z00_133); } 
BgL_list1266z00_131 = 
MAKE_YOUNG_PAIR(BGl_string1975z00zz__wav_decoderz00, BgL_arg1267z00_132); } 
BGl_debugz00zz__wav_decoderz00(BgL_list1266z00_131); } } 
return 
bgl_close_output_port(BGl_za2debugzd2portza2zd2zz__wav_decoderz00);} 

}



/* debug */
obj_t BGl_debugz00zz__wav_decoderz00(obj_t BgL_argsz00_23)
{
{ /* Llib/wav_decoder.scm 331 */
{ 
obj_t BgL_l1124z00_137;
BgL_l1124z00_137 = BgL_argsz00_23; 
BgL_zc3z04anonymousza31282ze3z87_138:
if(
PAIRP(BgL_l1124z00_137))
{ /* Llib/wav_decoder.scm 332 */
{ /* Llib/wav_decoder.scm 332 */
obj_t BgL_az00_140;
BgL_az00_140 = 
CAR(BgL_l1124z00_137); 
bgl_display_obj(BgL_az00_140, BGl_za2debugzd2portza2zd2zz__wav_decoderz00); } 
{ 
obj_t BgL_l1124z00_1192;
BgL_l1124z00_1192 = 
CDR(BgL_l1124z00_137); 
BgL_l1124z00_137 = BgL_l1124z00_1192; 
goto BgL_zc3z04anonymousza31282ze3z87_138;} }  else 
{ /* Llib/wav_decoder.scm 332 */((bool_t)1); } } 
return 
bgl_flush_output_port(BGl_za2debugzd2portza2zd2zz__wav_decoderz00);} 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__wav_decoderz00()
{
{ /* Llib/wav_decoder.scm 15 */
{ /* Llib/wav_decoder.scm 21 */
obj_t BgL_arg1333z00_146;obj_t BgL_arg1334z00_147;
{ /* Llib/wav_decoder.scm 21 */
obj_t BgL_v1126z00_173;
BgL_v1126z00_173 = 
create_vector(((long)5)); 
{ /* Llib/wav_decoder.scm 21 */
obj_t BgL_arg1349z00_174;
BgL_arg1349z00_174 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)6)), BGl_proc1978z00zz__wav_decoderz00, BGl_proc1977z00zz__wav_decoderz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc1976z00zz__wav_decoderz00, 
CNST_TABLE_REF(((long)7))); 
VECTOR_SET(BgL_v1126z00_173,((long)0),BgL_arg1349z00_174); } 
{ /* Llib/wav_decoder.scm 21 */
obj_t BgL_arg1383z00_189;
BgL_arg1383z00_189 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)8)), BGl_proc1981z00zz__wav_decoderz00, BGl_proc1980z00zz__wav_decoderz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1979z00zz__wav_decoderz00, 
CNST_TABLE_REF(((long)9))); 
VECTOR_SET(BgL_v1126z00_173,((long)1),BgL_arg1383z00_189); } 
{ /* Llib/wav_decoder.scm 21 */
obj_t BgL_arg1517z00_202;
BgL_arg1517z00_202 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)10)), BGl_proc1984z00zz__wav_decoderz00, BGl_proc1983z00zz__wav_decoderz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1982z00zz__wav_decoderz00, 
CNST_TABLE_REF(((long)11))); 
VECTOR_SET(BgL_v1126z00_173,((long)2),BgL_arg1517z00_202); } 
{ /* Llib/wav_decoder.scm 21 */
obj_t BgL_arg1537z00_215;
BgL_arg1537z00_215 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)12)), BGl_proc1987z00zz__wav_decoderz00, BGl_proc1986z00zz__wav_decoderz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1985z00zz__wav_decoderz00, 
CNST_TABLE_REF(((long)11))); 
VECTOR_SET(BgL_v1126z00_173,((long)3),BgL_arg1537z00_215); } 
{ /* Llib/wav_decoder.scm 21 */
obj_t BgL_arg1560z00_228;
BgL_arg1560z00_228 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)13)), BGl_proc1990z00zz__wav_decoderz00, BGl_proc1989z00zz__wav_decoderz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1988z00zz__wav_decoderz00, 
CNST_TABLE_REF(((long)11))); 
VECTOR_SET(BgL_v1126z00_173,((long)4),BgL_arg1560z00_228); } 
BgL_arg1333z00_146 = BgL_v1126z00_173; } 
{ /* Llib/wav_decoder.scm 21 */
obj_t BgL_v1127z00_241;
BgL_v1127z00_241 = 
create_vector(((long)0)); 
BgL_arg1334z00_147 = BgL_v1127z00_241; } 
return ( 
BGl_wavmusicdecoderz00zz__wav_decoderz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)14)), 
CNST_TABLE_REF(((long)15)), BGl_musicdecoderz00zz__multimediazd2musicbufzd2, ((long)3767), BGl_proc1993z00zz__wav_decoderz00, BGl_proc1992z00zz__wav_decoderz00, BGl_musicdecoderzd2initzd2envz00zz__multimediazd2musicbufzd2, BGl_proc1991z00zz__wav_decoderz00, BFALSE, BgL_arg1333z00_146, BgL_arg1334z00_147), BUNSPEC) ;} } 

}



/* &<@anonymous:1348> */
obj_t BGl_z62zc3z04anonymousza31348ze3ze5zz__wav_decoderz00(obj_t BgL_envz00_742, obj_t BgL_new1091z00_743)
{
{ /* Llib/wav_decoder.scm 21 */
{ 
BgL_wavmusicdecoderz00_bglt BgL_auxz00_1220;
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavmusicdecoderz00_bglt)BgL_new1091z00_743))))->BgL_mimetypesz00)=((obj_t)BNIL),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavmusicdecoderz00_bglt)BgL_new1091z00_743))))->BgL_bufferzd2timezd2nearz00)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavmusicdecoderz00_bglt)BgL_new1091z00_743))))->BgL_bufferzd2siza7ezd2nearzd2ratioz75)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavmusicdecoderz00_bglt)BgL_new1091z00_743))))->BgL_periodzd2siza7ezd2nearzd2ratioz75)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavmusicdecoderz00_bglt)BgL_new1091z00_743))))->BgL_z52z12dpausez40)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavmusicdecoderz00_bglt)BgL_new1091z00_743))))->BgL_z52z12dabortz40)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavmusicdecoderz00_bglt)BgL_new1091z00_743))))->BgL_z52z12stopz40)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavmusicdecoderz00_bglt)BgL_new1091z00_743))))->BgL_z52dmutexz52)=((obj_t)
BGl_mutexzd2nilzd2zz__threadz00()),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavmusicdecoderz00_bglt)BgL_new1091z00_743))))->BgL_z52dcondvz52)=((obj_t)
BGl_conditionzd2variablezd2nilz00zz__threadz00()),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavmusicdecoderz00_bglt)BgL_new1091z00_743))))->BgL_z52doutcondvz52)=((obj_t)
BGl_conditionzd2variablezd2nilz00zz__threadz00()),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_new1091z00_743)))->BgL_outbufz00)=((obj_t)BGl_string1994z00zz__wav_decoderz00),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_new1091z00_743)))->BgL_z52headerz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_new1091z00_743)))->BgL_z52cursorz52)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_new1091z00_743)))->BgL_z52siza7ezf5)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_new1091z00_743)))->BgL_z52positionz52)=((int)
(int)(((long)0))),BUNSPEC); 
BgL_auxz00_1220 = 
((BgL_wavmusicdecoderz00_bglt)BgL_new1091z00_743); 
return 
((obj_t)BgL_auxz00_1220);} } 

}



/* &lambda1338 */
BgL_wavmusicdecoderz00_bglt BGl_z62lambda1338z62zz__wav_decoderz00(obj_t BgL_envz00_744)
{
{ /* Llib/wav_decoder.scm 21 */
{ /* Llib/wav_decoder.scm 21 */
BgL_wavmusicdecoderz00_bglt BgL_new1090z00_862;
BgL_new1090z00_862 = 
((BgL_wavmusicdecoderz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_wavmusicdecoderz00_bgl) ))); 
{ /* Llib/wav_decoder.scm 21 */
long BgL_arg1347z00_863;
{ /* Llib/wav_decoder.scm 21 */
long BgL_res1896z00_864;
BgL_res1896z00_864 = 
BGL_CLASS_INDEX(BGl_wavmusicdecoderz00zz__wav_decoderz00); 
BgL_arg1347z00_863 = BgL_res1896z00_864; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1090z00_862), BgL_arg1347z00_863); } 
return BgL_new1090z00_862;} } 

}



/* &lambda1335 */
BgL_wavmusicdecoderz00_bglt BGl_z62lambda1335z62zz__wav_decoderz00(obj_t BgL_envz00_745, obj_t BgL_mimetypes1075z00_746, obj_t BgL_bufferzd2timezd2near1076z00_747, obj_t BgL_bufferzd2siza7ezd2nearzd2rat1077z75_748, obj_t BgL_periodzd2siza7ezd2nearzd2rat1078z75_749, obj_t BgL_z52z12dpause1079z40_750, obj_t BgL_z52z12dabort1080z40_751, obj_t BgL_z52z12stop1081z40_752, obj_t BgL_z52dmutex1082z52_753, obj_t BgL_z52dcondv1083z52_754, obj_t BgL_z52doutcondv1084z52_755, obj_t BgL_outbuf1085z00_756, obj_t BgL_z52header1086z52_757, obj_t BgL_z52cursor1087z52_758, obj_t BgL_z52siza7e1088zf5_759, obj_t BgL_z52position1089z52_760)
{
{ /* Llib/wav_decoder.scm 21 */
{ /* Llib/wav_decoder.scm 21 */
int BgL_bufferzd2timezd2near1076z00_866;int BgL_bufferzd2siza7ezd2nearzd2rat1077z75_867;int BgL_periodzd2siza7ezd2nearzd2rat1078z75_868;bool_t BgL_z52z12dpause1079z40_869;bool_t BgL_z52z12dabort1080z40_870;bool_t BgL_z52z12stop1081z40_871;int BgL_z52cursor1087z52_876;int BgL_z52siza7e1088zf5_877;int BgL_z52position1089z52_878;
BgL_bufferzd2timezd2near1076z00_866 = 
CINT(BgL_bufferzd2timezd2near1076z00_747); 
BgL_bufferzd2siza7ezd2nearzd2rat1077z75_867 = 
CINT(BgL_bufferzd2siza7ezd2nearzd2rat1077z75_748); 
BgL_periodzd2siza7ezd2nearzd2rat1078z75_868 = 
CINT(BgL_periodzd2siza7ezd2nearzd2rat1078z75_749); 
BgL_z52z12dpause1079z40_869 = 
CBOOL(BgL_z52z12dpause1079z40_750); 
BgL_z52z12dabort1080z40_870 = 
CBOOL(BgL_z52z12dabort1080z40_751); 
BgL_z52z12stop1081z40_871 = 
CBOOL(BgL_z52z12stop1081z40_752); 
BgL_z52cursor1087z52_876 = 
CINT(BgL_z52cursor1087z52_758); 
BgL_z52siza7e1088zf5_877 = 
CINT(BgL_z52siza7e1088zf5_759); 
BgL_z52position1089z52_878 = 
CINT(BgL_z52position1089z52_760); 
{ /* Llib/wav_decoder.scm 21 */
BgL_wavmusicdecoderz00_bglt BgL_new1123z00_879;
{ /* Llib/wav_decoder.scm 21 */
BgL_wavmusicdecoderz00_bglt BgL_new1122z00_880;
BgL_new1122z00_880 = 
((BgL_wavmusicdecoderz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_wavmusicdecoderz00_bgl) ))); 
{ /* Llib/wav_decoder.scm 21 */
long BgL_arg1337z00_881;
{ /* Llib/wav_decoder.scm 21 */
long BgL_res1895z00_882;
BgL_res1895z00_882 = 
BGL_CLASS_INDEX(BGl_wavmusicdecoderz00zz__wav_decoderz00); 
BgL_arg1337z00_881 = BgL_res1895z00_882; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1122z00_880), BgL_arg1337z00_881); } 
BgL_new1123z00_879 = BgL_new1122z00_880; } 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1123z00_879)))->BgL_mimetypesz00)=((obj_t)
((obj_t)BgL_mimetypes1075z00_746)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1123z00_879)))->BgL_bufferzd2timezd2nearz00)=((int)BgL_bufferzd2timezd2near1076z00_866),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1123z00_879)))->BgL_bufferzd2siza7ezd2nearzd2ratioz75)=((int)BgL_bufferzd2siza7ezd2nearzd2rat1077z75_867),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1123z00_879)))->BgL_periodzd2siza7ezd2nearzd2ratioz75)=((int)BgL_periodzd2siza7ezd2nearzd2rat1078z75_868),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1123z00_879)))->BgL_z52z12dpausez40)=((bool_t)BgL_z52z12dpause1079z40_869),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1123z00_879)))->BgL_z52z12dabortz40)=((bool_t)BgL_z52z12dabort1080z40_870),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1123z00_879)))->BgL_z52z12stopz40)=((bool_t)BgL_z52z12stop1081z40_871),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1123z00_879)))->BgL_z52dmutexz52)=((obj_t)
((obj_t)BgL_z52dmutex1082z52_753)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1123z00_879)))->BgL_z52dcondvz52)=((obj_t)
((obj_t)BgL_z52dcondv1083z52_754)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1123z00_879)))->BgL_z52doutcondvz52)=((obj_t)
((obj_t)BgL_z52doutcondv1084z52_755)),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_new1123z00_879))->BgL_outbufz00)=((obj_t)
((obj_t)BgL_outbuf1085z00_756)),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_new1123z00_879))->BgL_z52headerz52)=((obj_t)BgL_z52header1086z52_757),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_new1123z00_879))->BgL_z52cursorz52)=((int)BgL_z52cursor1087z52_876),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_new1123z00_879))->BgL_z52siza7ezf5)=((int)BgL_z52siza7e1088zf5_877),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_new1123z00_879))->BgL_z52positionz52)=((int)BgL_z52position1089z52_878),BUNSPEC); 
{ /* Llib/wav_decoder.scm 21 */
obj_t BgL_fun1336z00_883;
BgL_fun1336z00_883 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_wavmusicdecoderz00zz__wav_decoderz00); 
PROCEDURE_ENTRY(BgL_fun1336z00_883)(BgL_fun1336z00_883, 
((obj_t)BgL_new1123z00_879), BEOA); } 
return BgL_new1123z00_879;} } } 

}



/* &<@anonymous:1581> */
obj_t BGl_z62zc3z04anonymousza31581ze3ze5zz__wav_decoderz00(obj_t BgL_envz00_761)
{
{ /* Llib/wav_decoder.scm 21 */
return 
BINT(((long)0));} 

}



/* &lambda1580 */
obj_t BGl_z62lambda1580z62zz__wav_decoderz00(obj_t BgL_envz00_762, obj_t BgL_oz00_763, obj_t BgL_vz00_764)
{
{ /* Llib/wav_decoder.scm 21 */
{ /* Llib/wav_decoder.scm 21 */
int BgL_vz00_885;
BgL_vz00_885 = 
CINT(BgL_vz00_764); 
return 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_oz00_763)))->BgL_z52positionz52)=((int)BgL_vz00_885),BUNSPEC);} } 

}



/* &lambda1579 */
obj_t BGl_z62lambda1579z62zz__wav_decoderz00(obj_t BgL_envz00_765, obj_t BgL_oz00_766)
{
{ /* Llib/wav_decoder.scm 21 */
return 
BINT(
(((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_oz00_766)))->BgL_z52positionz52));} 

}



/* &<@anonymous:1550> */
obj_t BGl_z62zc3z04anonymousza31550ze3ze5zz__wav_decoderz00(obj_t BgL_envz00_767)
{
{ /* Llib/wav_decoder.scm 21 */
return 
BINT(((long)0));} 

}



/* &lambda1549 */
obj_t BGl_z62lambda1549z62zz__wav_decoderz00(obj_t BgL_envz00_768, obj_t BgL_oz00_769, obj_t BgL_vz00_770)
{
{ /* Llib/wav_decoder.scm 21 */
{ /* Llib/wav_decoder.scm 21 */
int BgL_vz00_888;
BgL_vz00_888 = 
CINT(BgL_vz00_770); 
return 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_oz00_769)))->BgL_z52siza7ezf5)=((int)BgL_vz00_888),BUNSPEC);} } 

}



/* &lambda1548 */
obj_t BGl_z62lambda1548z62zz__wav_decoderz00(obj_t BgL_envz00_771, obj_t BgL_oz00_772)
{
{ /* Llib/wav_decoder.scm 21 */
return 
BINT(
(((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_oz00_772)))->BgL_z52siza7ezf5));} 

}



/* &<@anonymous:1528> */
obj_t BGl_z62zc3z04anonymousza31528ze3ze5zz__wav_decoderz00(obj_t BgL_envz00_773)
{
{ /* Llib/wav_decoder.scm 21 */
return 
BINT(((long)0));} 

}



/* &lambda1527 */
obj_t BGl_z62lambda1527z62zz__wav_decoderz00(obj_t BgL_envz00_774, obj_t BgL_oz00_775, obj_t BgL_vz00_776)
{
{ /* Llib/wav_decoder.scm 21 */
{ /* Llib/wav_decoder.scm 21 */
int BgL_vz00_891;
BgL_vz00_891 = 
CINT(BgL_vz00_776); 
return 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_oz00_775)))->BgL_z52cursorz52)=((int)BgL_vz00_891),BUNSPEC);} } 

}



/* &lambda1526 */
obj_t BGl_z62lambda1526z62zz__wav_decoderz00(obj_t BgL_envz00_777, obj_t BgL_oz00_778)
{
{ /* Llib/wav_decoder.scm 21 */
return 
BINT(
(((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_oz00_778)))->BgL_z52cursorz52));} 

}



/* &<@anonymous:1509> */
obj_t BGl_z62zc3z04anonymousza31509ze3ze5zz__wav_decoderz00(obj_t BgL_envz00_779)
{
{ /* Llib/wav_decoder.scm 21 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda1508 */
obj_t BGl_z62lambda1508z62zz__wav_decoderz00(obj_t BgL_envz00_780, obj_t BgL_oz00_781, obj_t BgL_vz00_782)
{
{ /* Llib/wav_decoder.scm 21 */
return 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_oz00_781)))->BgL_z52headerz52)=((obj_t)BgL_vz00_782),BUNSPEC);} 

}



/* &lambda1507 */
obj_t BGl_z62lambda1507z62zz__wav_decoderz00(obj_t BgL_envz00_783, obj_t BgL_oz00_784)
{
{ /* Llib/wav_decoder.scm 21 */
return 
(((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_oz00_784)))->BgL_z52headerz52);} 

}



/* &<@anonymous:1356> */
obj_t BGl_z62zc3z04anonymousza31356ze3ze5zz__wav_decoderz00(obj_t BgL_envz00_785)
{
{ /* Llib/wav_decoder.scm 21 */
{ /* Llib/wav_decoder.scm 22 */

return 
make_string(((long)2048), ((unsigned char)' '));} } 

}



/* &lambda1355 */
obj_t BGl_z62lambda1355z62zz__wav_decoderz00(obj_t BgL_envz00_786, obj_t BgL_oz00_787, obj_t BgL_vz00_788)
{
{ /* Llib/wav_decoder.scm 21 */
return 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_oz00_787)))->BgL_outbufz00)=((obj_t)
((obj_t)BgL_vz00_788)),BUNSPEC);} 

}



/* &lambda1354 */
obj_t BGl_z62lambda1354z62zz__wav_decoderz00(obj_t BgL_envz00_789, obj_t BgL_oz00_790)
{
{ /* Llib/wav_decoder.scm 21 */
return 
(((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_oz00_790)))->BgL_outbufz00);} 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__wav_decoderz00()
{
{ /* Llib/wav_decoder.scm 15 */
return BUNSPEC;} 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__wav_decoderz00()
{
{ /* Llib/wav_decoder.scm 15 */
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_objectzd2printzd2envz00zz__objectz00, BGl_wavmusicdecoderz00zz__wav_decoderz00, BGl_proc1995z00zz__wav_decoderz00, BGl_string1996z00zz__wav_decoderz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2initzd2envz00zz__multimediazd2musicbufzd2, BGl_wavmusicdecoderz00zz__wav_decoderz00, BGl_proc1997z00zz__wav_decoderz00, BGl_string1998z00zz__wav_decoderz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2resetz12zd2envz12zz__multimediazd2musicbufzd2, BGl_wavmusicdecoderz00zz__wav_decoderz00, BGl_proc1999z00zz__wav_decoderz00, BGl_string2000z00zz__wav_decoderz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2positionzd2envz00zz__multimediazd2musicbufzd2, BGl_wavmusicdecoderz00zz__wav_decoderz00, BGl_proc2001z00zz__wav_decoderz00, BGl_string2002z00zz__wav_decoderz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2decodezd2envz00zz__multimediazd2musicbufzd2, BGl_wavmusicdecoderz00zz__wav_decoderz00, BGl_proc2003z00zz__wav_decoderz00, BGl_string2004z00zz__wav_decoderz00); 
return 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2volumezd2setz12zd2envzc0zz__multimediazd2musicbufzd2, BGl_wavmusicdecoderz00zz__wav_decoderz00, BGl_proc2005z00zz__wav_decoderz00, BGl_string2006z00zz__wav_decoderz00);} 

}



/* &musicdecoder-volume-1139 */
obj_t BGl_z62musicdecoderzd2volumezd21139z62zz__wav_decoderz00(obj_t BgL_envz00_801, obj_t BgL_decz00_802, obj_t BgL_volz00_803)
{
{ /* Llib/wav_decoder.scm 306 */
return BFALSE;} 

}



/* &musicdecoder-decode-1137 */
obj_t BGl_z62musicdecoderzd2decodezd21137z62zz__wav_decoderz00(obj_t BgL_envz00_804, obj_t BgL_decz00_805, obj_t BgL_amz00_806, obj_t BgL_bufferz00_807)
{
{ /* Llib/wav_decoder.scm 93 */
{ /* Llib/wav_decoder.scm 99 */
obj_t BgL_haszd2beenzd2emptyzd2oncezd2_902;
BgL_haszd2beenzd2emptyzd2oncezd2_902 = 
MAKE_CELL(BFALSE); 
{ /* Llib/wav_decoder.scm 99 */
long BgL_inlenz00_903;
BgL_inlenz00_903 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_807)))->BgL_z52inlenz52); 
{ /* Llib/wav_decoder.scm 107 */
long BgL_outlenz00_904;
BgL_outlenz00_904 = 
STRING_LENGTH(
(((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_805)))->BgL_outbufz00)); 
{ 

{ /* Llib/wav_decoder.scm 169 */
bool_t BgL_test2109z00_1368;
{ /* Llib/wav_decoder.scm 169 */
int BgL_arg1621z00_906;
BgL_arg1621z00_906 = 
BGl_wavzd2debugzd2zz__wav_decoderz00(); 
BgL_test2109z00_1368 = 
(
(long)(BgL_arg1621z00_906)>((long)0)); } 
if(BgL_test2109z00_1368)
{ /* Llib/wav_decoder.scm 169 */
BGl_debugzd2initz12zc0zz__wav_decoderz00(
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_807)))->BgL_urlz00)); }  else 
{ /* Llib/wav_decoder.scm 169 */BFALSE; } } 
{ 

BgL_loopz00_907:
if(
(((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_805))))->BgL_z52z12dpausez40))
{ /* Llib/wav_decoder.scm 173 */
{ /* Llib/wav_decoder.scm 175 */
BgL_musicstatusz00_bglt BgL_i1102z00_908;
BgL_i1102z00_908 = 
(((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_806))))->BgL_z52statusz52); 
((((BgL_musicstatusz00_bglt)COBJECT(BgL_i1102z00_908))->BgL_songposz00)=((obj_t)
BINT(
BGl_musicdecoderzd2positionzd2zz__multimediazd2musicbufzd2(
((BgL_musicdecoderz00_bglt)
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_805)), 
((BgL_musicbufferz00_bglt)BgL_bufferz00_807)))),BUNSPEC); } 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_806)), 
CNST_TABLE_REF(((long)16))); 
{ /* Llib/wav_decoder.scm 178 */
obj_t BgL_mutex1624z00_909;
BgL_mutex1624z00_909 = 
(((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_805))))->BgL_z52dmutexz52); 
BGL_MUTEX_LOCK(BgL_mutex1624z00_909); 
{ /* Llib/wav_decoder.scm 178 */
bool_t BgL_tmp2111z00_1395;
{ 

BgL_liipz00_910:
if(
(((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_805))))->BgL_z52z12dpausez40))
{ /* Llib/wav_decoder.scm 180 */
{ /* Llib/wav_decoder.scm 181 */
obj_t BgL_arg1645z00_911;obj_t BgL_arg1646z00_912;
BgL_arg1645z00_911 = 
(((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_805))))->BgL_z52dcondvz52); 
BgL_arg1646z00_912 = 
(((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_805))))->BgL_z52dmutexz52); 
{ /* Llib/wav_decoder.scm 181 */

{ /* Llib/wav_decoder.scm 181 */
bool_t BgL_res1929z00_913;
BgL_res1929z00_913 = 
BGL_CONDVAR_WAIT(BgL_arg1645z00_911, BgL_arg1646z00_912); BgL_res1929z00_913; } } } 
goto BgL_liipz00_910;}  else 
{ /* Llib/wav_decoder.scm 180 */
BgL_tmp2111z00_1395 = ((bool_t)0); } } 
BGL_MUTEX_UNLOCK(BgL_mutex1624z00_909); BgL_tmp2111z00_1395; } } 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_806)), 
CNST_TABLE_REF(((long)17))); 
goto BgL_loopz00_907;}  else 
{ /* Llib/wav_decoder.scm 173 */
if(
(((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_805))))->BgL_z52z12dabortz40))
{ /* Llib/wav_decoder.scm 185 */
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_806)), 
CNST_TABLE_REF(((long)18))); }  else 
{ /* Llib/wav_decoder.scm 185 */
if(
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_807)))->BgL_z52emptyz52))
{ /* Llib/wav_decoder.scm 188 */
if(
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_807)))->BgL_z52eofz52))
{ /* Llib/wav_decoder.scm 190 */
{ /* Llib/wav_decoder.scm 192 */
bool_t BgL_test2116z00_1427;
{ /* Llib/wav_decoder.scm 192 */
int BgL_arg1662z00_914;
BgL_arg1662z00_914 = 
BGl_wavzd2debugzd2zz__wav_decoderz00(); 
BgL_test2116z00_1427 = 
(
(long)(BgL_arg1662z00_914)>=((long)2)); } 
if(BgL_test2116z00_1427)
{ /* Llib/wav_decoder.scm 193 */
obj_t BgL_arg1655z00_915;
BgL_arg1655z00_915 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_807)))->BgL_urlz00); 
{ /* Llib/wav_decoder.scm 193 */
obj_t BgL_list1656z00_916;
{ /* Llib/wav_decoder.scm 193 */
obj_t BgL_arg1658z00_917;
{ /* Llib/wav_decoder.scm 193 */
obj_t BgL_arg1661z00_918;
BgL_arg1661z00_918 = 
MAKE_YOUNG_PAIR(BGl_string1972z00zz__wav_decoderz00, BNIL); 
BgL_arg1658z00_917 = 
MAKE_YOUNG_PAIR(BgL_arg1655z00_915, BgL_arg1661z00_918); } 
BgL_list1656z00_916 = 
MAKE_YOUNG_PAIR(BGl_string2007z00zz__wav_decoderz00, BgL_arg1658z00_917); } 
BGl_debugz00zz__wav_decoderz00(BgL_list1656z00_916); } }  else 
{ /* Llib/wav_decoder.scm 192 */BFALSE; } } 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_806)), 
CNST_TABLE_REF(((long)19))); }  else 
{ /* Llib/wav_decoder.scm 190 */
{ /* Llib/wav_decoder.scm 196 */
bool_t BgL_test2117z00_1441;
{ /* Llib/wav_decoder.scm 196 */
int BgL_arg1680z00_919;
BgL_arg1680z00_919 = 
BGl_wavzd2debugzd2zz__wav_decoderz00(); 
BgL_test2117z00_1441 = 
(
(long)(BgL_arg1680z00_919)>=((long)1)); } 
if(BgL_test2117z00_1441)
{ /* Llib/wav_decoder.scm 197 */
obj_t BgL_arg1669z00_920;BGL_LONGLONG_T BgL_arg1670z00_921;
BgL_arg1669z00_920 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_807)))->BgL_urlz00); 
BgL_arg1670z00_921 = 
bgl_current_microseconds(); 
{ /* Llib/wav_decoder.scm 197 */
obj_t BgL_list1671z00_922;
{ /* Llib/wav_decoder.scm 197 */
obj_t BgL_arg1673z00_923;
{ /* Llib/wav_decoder.scm 197 */
obj_t BgL_arg1674z00_924;
{ /* Llib/wav_decoder.scm 197 */
obj_t BgL_arg1676z00_925;
{ /* Llib/wav_decoder.scm 197 */
obj_t BgL_arg1679z00_926;
BgL_arg1679z00_926 = 
MAKE_YOUNG_PAIR(BGl_string2008z00zz__wav_decoderz00, BNIL); 
BgL_arg1676z00_925 = 
MAKE_YOUNG_PAIR(
make_bllong(BgL_arg1670z00_921), BgL_arg1679z00_926); } 
BgL_arg1674z00_924 = 
MAKE_YOUNG_PAIR(BGl_string1973z00zz__wav_decoderz00, BgL_arg1676z00_925); } 
BgL_arg1673z00_923 = 
MAKE_YOUNG_PAIR(BgL_arg1669z00_920, BgL_arg1674z00_924); } 
BgL_list1671z00_922 = 
MAKE_YOUNG_PAIR(BGl_string2009z00zz__wav_decoderz00, BgL_arg1673z00_923); } 
BGl_debugz00zz__wav_decoderz00(BgL_list1671z00_922); } }  else 
{ /* Llib/wav_decoder.scm 196 */BFALSE; } } 
{ /* Llib/wav_decoder.scm 200 */
BgL_musicstatusz00_bglt BgL_i1104z00_927;
BgL_i1104z00_927 = 
(((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_806))))->BgL_z52statusz52); 
((((BgL_musicstatusz00_bglt)COBJECT(BgL_i1104z00_927))->BgL_bufferingz00)=((int)
(int)(
BGl_bufferzd2percentagezd2filledze70ze7zz__wav_decoderz00(BgL_inlenz00_903, 
((BgL_musicbufferz00_bglt)BgL_bufferz00_807)))),BUNSPEC); } 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_806)), 
CNST_TABLE_REF(((long)20))); 
{ /* Llib/wav_decoder.scm 204 */
obj_t BgL_mutex1681z00_928;
BgL_mutex1681z00_928 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_807)))->BgL_z52bmutexz52); 
{ /* Llib/wav_decoder.scm 204 */
obj_t BgL_top2119z00_1469;
BgL_top2119z00_1469 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGL_MUTEX_LOCK(BgL_mutex1681z00_928); 
BGL_EXITD_PUSH_PROTECT(BgL_top2119z00_1469, BgL_mutex1681z00_928); BUNSPEC; 
{ /* Llib/wav_decoder.scm 204 */
bool_t BgL_tmp2118z00_1468;
{ /* Llib/wav_decoder.scm 206 */
bool_t BgL_test2120z00_1473;
if(
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_807)))->BgL_z52emptyz52))
{ /* Llib/wav_decoder.scm 206 */
if(
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_807)))->BgL_z52eofz52))
{ /* Llib/wav_decoder.scm 206 */
BgL_test2120z00_1473 = ((bool_t)1)
; }  else 
{ /* Llib/wav_decoder.scm 206 */
if(
(((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_805))))->BgL_z52z12dabortz40))
{ /* Llib/wav_decoder.scm 206 */
BgL_test2120z00_1473 = ((bool_t)1)
; }  else 
{ /* Llib/wav_decoder.scm 206 */
BgL_test2120z00_1473 = 
(
(((long)8)*
BGl_musicbufferzd2availablezd2zz__multimediazd2musicbufzd2(
((BgL_musicbufferz00_bglt)BgL_bufferz00_807)))>BgL_inlenz00_903)
; } } }  else 
{ /* Llib/wav_decoder.scm 206 */
BgL_test2120z00_1473 = ((bool_t)1)
; } 
if(BgL_test2120z00_1473)
{ /* Llib/wav_decoder.scm 206 */
BgL_tmp2118z00_1468 = ((bool_t)0); }  else 
{ /* Llib/wav_decoder.scm 210 */
obj_t BgL_arg1687z00_929;obj_t BgL_arg1693z00_930;
BgL_arg1687z00_929 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_807)))->BgL_z52bcondvz52); 
BgL_arg1693z00_930 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_807)))->BgL_z52bmutexz52); 
{ /* Llib/wav_decoder.scm 210 */

{ /* Llib/wav_decoder.scm 210 */
bool_t BgL_res1936z00_931;
BgL_res1936z00_931 = 
BGL_CONDVAR_WAIT(BgL_arg1687z00_929, BgL_arg1693z00_930); 
BgL_tmp2118z00_1468 = BgL_res1936z00_931; } } } } 
BGL_EXITD_POP_PROTECT(BgL_top2119z00_1469); BUNSPEC; 
BGL_MUTEX_UNLOCK(BgL_mutex1681z00_928); BgL_tmp2118z00_1468; } } } 
{ /* Llib/wav_decoder.scm 211 */
bool_t BgL_test2124z00_1495;
{ /* Llib/wav_decoder.scm 211 */
int BgL_arg1699z00_932;
BgL_arg1699z00_932 = 
BGl_wavzd2debugzd2zz__wav_decoderz00(); 
BgL_test2124z00_1495 = 
(
(long)(BgL_arg1699z00_932)>=((long)1)); } 
if(BgL_test2124z00_1495)
{ /* Llib/wav_decoder.scm 212 */
BGL_LONGLONG_T BgL_arg1696z00_933;
BgL_arg1696z00_933 = 
bgl_current_microseconds(); 
{ /* Llib/wav_decoder.scm 212 */
obj_t BgL_list1697z00_934;
{ /* Llib/wav_decoder.scm 212 */
obj_t BgL_arg1698z00_935;
BgL_arg1698z00_935 = 
MAKE_YOUNG_PAIR(BGl_string1972z00zz__wav_decoderz00, BNIL); 
BgL_list1697z00_934 = 
MAKE_YOUNG_PAIR(
make_bllong(BgL_arg1696z00_933), BgL_arg1698z00_935); } 
BGl_debugz00zz__wav_decoderz00(BgL_list1697z00_934); } }  else 
{ /* Llib/wav_decoder.scm 211 */BFALSE; } } 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_806)), 
CNST_TABLE_REF(((long)17))); 
goto BgL_loopz00_907;} }  else 
{ /* Llib/wav_decoder.scm 217 */
long BgL_sz00_936;
{ /* Llib/wav_decoder.scm 217 */
long BgL_bz00_937;
if(
(
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_807)))->BgL_z52headz52)>
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_807)))->BgL_z52tailz52)))
{ /* Llib/wav_decoder.scm 218 */
BgL_bz00_937 = 
(
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_807)))->BgL_z52headz52)-
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_807)))->BgL_z52tailz52)); }  else 
{ /* Llib/wav_decoder.scm 218 */
BgL_bz00_937 = 
(BgL_inlenz00_903-
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_807)))->BgL_z52tailz52)); } 
if(
(BgL_outlenz00_904<BgL_bz00_937))
{ /* Llib/wav_decoder.scm 218 */
BgL_sz00_936 = BgL_outlenz00_904; }  else 
{ /* Llib/wav_decoder.scm 218 */
BgL_sz00_936 = BgL_bz00_937; } } 
if(
(BgL_sz00_936==((long)0)))
{ /* Llib/wav_decoder.scm 221 */
goto BgL_loopz00_907;}  else 
{ /* Llib/wav_decoder.scm 223 */
obj_t BgL_statusz00_938;
{ /* Llib/wav_decoder.scm 223 */
long BgL_arg1789z00_939;
BgL_arg1789z00_939 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_807)))->BgL_z52tailz52); 
BgL_statusz00_938 = 
BGl_wavzd2decodezd2zz__wav_decoderz00(
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_805), 
((BgL_musicbufz00_bglt)BgL_amz00_806), 
((BgL_musicbufferz00_bglt)BgL_bufferz00_807), 
(int)(BgL_arg1789z00_939), 
(int)(BgL_sz00_936)); } 
{ /* Llib/wav_decoder.scm 224 */
bool_t BgL_test2128z00_1534;
{ /* Llib/wav_decoder.scm 224 */
int BgL_arg1753z00_940;
BgL_arg1753z00_940 = 
BGl_wavzd2debugzd2zz__wav_decoderz00(); 
BgL_test2128z00_1534 = 
(
(long)(BgL_arg1753z00_940)>=((long)4)); } 
if(BgL_test2128z00_1534)
{ /* Llib/wav_decoder.scm 225 */
long BgL_arg1707z00_941;long BgL_arg1708z00_942;obj_t BgL_arg1711z00_943;
BgL_arg1707z00_941 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_807)))->BgL_z52tailz52); 
BgL_arg1708z00_942 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_807)))->BgL_z52headz52); 
BgL_arg1711z00_943 = 
BGl_wavzd2decodezd2statuszd2ze3symbolz31zz__wav_decoderz00(BgL_statusz00_938); 
{ /* Llib/wav_decoder.scm 225 */
obj_t BgL_list1712z00_944;
{ /* Llib/wav_decoder.scm 225 */
obj_t BgL_arg1718z00_945;
{ /* Llib/wav_decoder.scm 225 */
obj_t BgL_arg1719z00_946;
{ /* Llib/wav_decoder.scm 225 */
obj_t BgL_arg1722z00_947;
{ /* Llib/wav_decoder.scm 225 */
obj_t BgL_arg1728z00_948;
{ /* Llib/wav_decoder.scm 225 */
obj_t BgL_arg1740z00_949;
{ /* Llib/wav_decoder.scm 225 */
obj_t BgL_arg1741z00_950;
{ /* Llib/wav_decoder.scm 225 */
obj_t BgL_arg1743z00_951;
{ /* Llib/wav_decoder.scm 225 */
obj_t BgL_arg1752z00_952;
BgL_arg1752z00_952 = 
MAKE_YOUNG_PAIR(BGl_string1972z00zz__wav_decoderz00, BNIL); 
BgL_arg1743z00_951 = 
MAKE_YOUNG_PAIR(BgL_arg1711z00_943, BgL_arg1752z00_952); } 
BgL_arg1741z00_950 = 
MAKE_YOUNG_PAIR(BGl_string2010z00zz__wav_decoderz00, BgL_arg1743z00_951); } 
BgL_arg1740z00_949 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1708z00_942), BgL_arg1741z00_950); } 
BgL_arg1728z00_948 = 
MAKE_YOUNG_PAIR(BGl_string2011z00zz__wav_decoderz00, BgL_arg1740z00_949); } 
BgL_arg1722z00_947 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1707z00_941), BgL_arg1728z00_948); } 
BgL_arg1719z00_946 = 
MAKE_YOUNG_PAIR(BGl_string2012z00zz__wav_decoderz00, BgL_arg1722z00_947); } 
BgL_arg1718z00_945 = 
MAKE_YOUNG_PAIR(
BINT(BgL_sz00_936), BgL_arg1719z00_946); } 
BgL_list1712z00_944 = 
MAKE_YOUNG_PAIR(BGl_string2013z00zz__wav_decoderz00, BgL_arg1718z00_945); } 
BGl_debugz00zz__wav_decoderz00(BgL_list1712z00_944); } }  else 
{ /* Llib/wav_decoder.scm 224 */BFALSE; } } 
if(
(
(long)CINT(BgL_statusz00_938)==((long)4)))
{ /* Llib/wav_decoder.scm 231 */
{ /* Llib/wav_decoder.scm 233 */
bool_t BgL_test2130z00_1559;
{ /* Llib/wav_decoder.scm 233 */
int BgL_arg1764z00_953;
BgL_arg1764z00_953 = 
BGl_wavzd2debugzd2zz__wav_decoderz00(); 
BgL_test2130z00_1559 = 
(
(long)(BgL_arg1764z00_953)>=((long)5)); } 
if(BgL_test2130z00_1559)
{ /* Llib/wav_decoder.scm 234 */
int BgL_arg1758z00_954;
BgL_arg1758z00_954 = 
(((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_805)))->BgL_z52siza7ezf5); 
{ /* Llib/wav_decoder.scm 234 */
obj_t BgL_list1759z00_955;
{ /* Llib/wav_decoder.scm 234 */
obj_t BgL_arg1760z00_956;
{ /* Llib/wav_decoder.scm 234 */
obj_t BgL_arg1761z00_957;
{ /* Llib/wav_decoder.scm 234 */
obj_t BgL_arg1762z00_958;
{ /* Llib/wav_decoder.scm 234 */
obj_t BgL_arg1763z00_959;
BgL_arg1763z00_959 = 
MAKE_YOUNG_PAIR(BGl_string1972z00zz__wav_decoderz00, BNIL); 
BgL_arg1762z00_958 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1758z00_954), BgL_arg1763z00_959); } 
BgL_arg1761z00_957 = 
MAKE_YOUNG_PAIR(BGl_string2014z00zz__wav_decoderz00, BgL_arg1762z00_958); } 
BgL_arg1760z00_956 = 
MAKE_YOUNG_PAIR(
BINT(BgL_sz00_936), BgL_arg1761z00_957); } 
BgL_list1759z00_955 = 
MAKE_YOUNG_PAIR(BGl_string2015z00zz__wav_decoderz00, BgL_arg1760z00_956); } 
BGl_debugz00zz__wav_decoderz00(BgL_list1759z00_955); } }  else 
{ /* Llib/wav_decoder.scm 233 */BFALSE; } } 
BGl_flushze70ze7zz__wav_decoderz00(
((BgL_musicbufz00_bglt)BgL_amz00_806), 
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_805), 
(int)(BgL_sz00_936)); 
BGl_inczd2tailz12ze70z27zz__wav_decoderz00(
((BgL_musicbufferz00_bglt)BgL_bufferz00_807), BgL_inlenz00_903, 
((BgL_musicbufferz00_bglt)BgL_bufferz00_807), BgL_haszd2beenzd2emptyzd2oncezd2_902, BgL_sz00_936); 
goto BgL_loopz00_907;}  else 
{ /* Llib/wav_decoder.scm 231 */
if(
(
(long)CINT(BgL_statusz00_938)==((long)3)))
{ /* Llib/wav_decoder.scm 239 */
{ /* Llib/wav_decoder.scm 241 */
bool_t BgL_test2132z00_1583;
{ /* Llib/wav_decoder.scm 241 */
int BgL_arg1780z00_960;
BgL_arg1780z00_960 = 
BGl_wavzd2debugzd2zz__wav_decoderz00(); 
BgL_test2132z00_1583 = 
(
(long)(BgL_arg1780z00_960)>=((long)5)); } 
if(BgL_test2132z00_1583)
{ /* Llib/wav_decoder.scm 242 */
int BgL_arg1768z00_961;bool_t BgL_arg1769z00_962;long BgL_arg1770z00_963;
BgL_arg1768z00_961 = 
(((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_805)))->BgL_z52siza7ezf5); 
BgL_arg1769z00_962 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_807)))->BgL_z52emptyz52); 
BgL_arg1770z00_963 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_807)))->BgL_z52tailz52); 
{ /* Llib/wav_decoder.scm 242 */
obj_t BgL_list1771z00_964;
{ /* Llib/wav_decoder.scm 242 */
obj_t BgL_arg1772z00_965;
{ /* Llib/wav_decoder.scm 242 */
obj_t BgL_arg1773z00_966;
{ /* Llib/wav_decoder.scm 242 */
obj_t BgL_arg1774z00_967;
{ /* Llib/wav_decoder.scm 242 */
obj_t BgL_arg1775z00_968;
{ /* Llib/wav_decoder.scm 242 */
obj_t BgL_arg1776z00_969;
{ /* Llib/wav_decoder.scm 242 */
obj_t BgL_arg1777z00_970;
{ /* Llib/wav_decoder.scm 242 */
obj_t BgL_arg1778z00_971;
{ /* Llib/wav_decoder.scm 242 */
obj_t BgL_arg1779z00_972;
BgL_arg1779z00_972 = 
MAKE_YOUNG_PAIR(BGl_string1972z00zz__wav_decoderz00, BNIL); 
BgL_arg1778z00_971 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1770z00_963), BgL_arg1779z00_972); } 
BgL_arg1777z00_970 = 
MAKE_YOUNG_PAIR(BGl_string2016z00zz__wav_decoderz00, BgL_arg1778z00_971); } 
BgL_arg1776z00_969 = 
MAKE_YOUNG_PAIR(
BBOOL(BgL_arg1769z00_962), BgL_arg1777z00_970); } 
BgL_arg1775z00_968 = 
MAKE_YOUNG_PAIR(BGl_string2017z00zz__wav_decoderz00, BgL_arg1776z00_969); } 
BgL_arg1774z00_967 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1768z00_961), BgL_arg1775z00_968); } 
BgL_arg1773z00_966 = 
MAKE_YOUNG_PAIR(BGl_string2014z00zz__wav_decoderz00, BgL_arg1774z00_967); } 
BgL_arg1772z00_965 = 
MAKE_YOUNG_PAIR(
BINT(BgL_sz00_936), BgL_arg1773z00_966); } 
BgL_list1771z00_964 = 
MAKE_YOUNG_PAIR(BGl_string2018z00zz__wav_decoderz00, BgL_arg1772z00_965); } 
BGl_debugz00zz__wav_decoderz00(BgL_list1771z00_964); } }  else 
{ /* Llib/wav_decoder.scm 241 */BFALSE; } } 
goto BgL_loopz00_907;}  else 
{ /* Llib/wav_decoder.scm 239 */
if(
(
(long)CINT(BgL_statusz00_938)==((long)1)))
{ /* Llib/wav_decoder.scm 246 */
BGl_musicdecoderzd2hwparamszd2setz12z12zz__multimediazd2musicbufzd2(
((BgL_musicdecoderz00_bglt)
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_805)), 
((BgL_musicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_806)), 
((BgL_musicbufferz00_bglt)BgL_bufferz00_807)); 
{ /* Llib/wav_decoder.scm 249 */
long BgL_arg1782z00_973;
{ /* Llib/wav_decoder.scm 249 */
long BgL_arg1783z00_974;
BgL_arg1783z00_974 = 
BGl_wavzd2headerzd2siza7eza7zz__wav_wavz00(); 
{ /* Llib/wav_decoder.scm 249 */
long BgL_res1952z00_975;
BgL_res1952z00_975 = 
(long)(BgL_arg1783z00_974); 
BgL_arg1782z00_973 = BgL_res1952z00_975; } } 
BGl_inczd2tailz12ze70z27zz__wav_decoderz00(
((BgL_musicbufferz00_bglt)BgL_bufferz00_807), BgL_inlenz00_903, 
((BgL_musicbufferz00_bglt)BgL_bufferz00_807), BgL_haszd2beenzd2emptyzd2oncezd2_902, BgL_arg1782z00_973); } 
goto BgL_loopz00_907;}  else 
{ /* Llib/wav_decoder.scm 246 */
if(
(
(long)CINT(BgL_statusz00_938)==((long)2)))
{ /* Llib/wav_decoder.scm 251 */
if(
(
(long)(
(((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_805)))->BgL_z52siza7ezf5))>((long)0)))
{ /* Llib/wav_decoder.scm 253 */
BGl_flushze70ze7zz__wav_decoderz00(
((BgL_musicbufz00_bglt)BgL_amz00_806), 
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_805), 
(((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_805)))->BgL_z52siza7ezf5)); }  else 
{ /* Llib/wav_decoder.scm 253 */((bool_t)0); } 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_806)), 
CNST_TABLE_REF(((long)19))); }  else 
{ /* Llib/wav_decoder.scm 251 */
{ /* Llib/wav_decoder.scm 257 */
BgL_musicstatusz00_bglt BgL_i1105z00_976;
BgL_i1105z00_976 = 
(((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_806))))->BgL_z52statusz52); 
((((BgL_musicstatusz00_bglt)COBJECT(BgL_i1105z00_976))->BgL_errz00)=((obj_t)BGl_string2019z00zz__wav_decoderz00),BUNSPEC); 
((((BgL_musicstatusz00_bglt)COBJECT(BgL_i1105z00_976))->BgL_statez00)=((obj_t)
CNST_TABLE_REF(((long)21))),BUNSPEC); } 
BGl_musiczd2errorzd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_806)), BGl_string2019z00zz__wav_decoderz00); } } } } } } } } } 
{ /* Llib/wav_decoder.scm 261 */
bool_t BgL_test2136z00_1647;
{ /* Llib/wav_decoder.scm 261 */
int BgL_arg1802z00_977;
BgL_arg1802z00_977 = 
BGl_wavzd2debugzd2zz__wav_decoderz00(); 
BgL_test2136z00_1647 = 
(
(long)(BgL_arg1802z00_977)>((long)0)); } 
if(BgL_test2136z00_1647)
{ /* Llib/wav_decoder.scm 261 */
return 
BGl_debugzd2stopz12zc0zz__wav_decoderz00(
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_807)))->BgL_urlz00));}  else 
{ /* Llib/wav_decoder.scm 261 */
return BFALSE;} } } } } } } 

}



/* flush~0 */
bool_t BGl_flushze70ze7zz__wav_decoderz00(BgL_musicbufz00_bglt BgL_amz00_834, BgL_wavmusicdecoderz00_bglt BgL_i1100z00_833, int BgL_sza7za7_504)
{
{ /* Llib/wav_decoder.scm 167 */
BGl_flushze70ze7zz__wav_decoderz00:
if(
(
(long)(BgL_sza7za7_504)>((long)0)))
{ /* Llib/wav_decoder.scm 167 */
long BgL_arg1874z00_507;
{ /* Llib/wav_decoder.scm 167 */
obj_t BgL_arg1875z00_508;
BgL_arg1875z00_508 = 
BGl_musicbufzd2writezd2zz__multimediazd2musicbufzd2(BgL_amz00_834, 
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_i1100z00_833))->BgL_outbufz00), 
(long)(BgL_sza7za7_504)); 
BgL_arg1874z00_507 = 
(
(long)(BgL_sza7za7_504)-
(long)CINT(BgL_arg1875z00_508)); } 
{ 
int BgL_sza7za7_1663;
BgL_sza7za7_1663 = 
(int)(BgL_arg1874z00_507); 
BgL_sza7za7_504 = BgL_sza7za7_1663; 
goto BGl_flushze70ze7zz__wav_decoderz00;} }  else 
{ /* Llib/wav_decoder.scm 166 */
return ((bool_t)0);} } 

}



/* inc-tail!~0 */
obj_t BGl_inczd2tailz12ze70z27zz__wav_decoderz00(BgL_musicbufferz00_bglt BgL_i1101z00_838, long BgL_inlenz00_837, BgL_musicbufferz00_bglt BgL_bufferz00_836, obj_t BgL_haszd2beenzd2emptyzd2oncezd2_835, long BgL_siza7eza7_473)
{
{ /* Llib/wav_decoder.scm 152 */
{ 

{ /* Llib/wav_decoder.scm 145 */
long BgL_ntailz00_475;
BgL_ntailz00_475 = 
(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1101z00_838))->BgL_z52tailz52)+BgL_siza7eza7_473); 
if(
(BgL_ntailz00_475==BgL_inlenz00_837))
{ /* Llib/wav_decoder.scm 146 */
BgL_ntailz00_475 = ((long)0); }  else 
{ /* Llib/wav_decoder.scm 146 */BFALSE; } 
if(
(BgL_ntailz00_475==
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1101z00_838))->BgL_z52headz52)))
{ /* Llib/wav_decoder.scm 149 */
{ /* Llib/wav_decoder.scm 150 */
obj_t BgL_auxz00_839;
BgL_auxz00_839 = BTRUE; 
CELL_SET(BgL_haszd2beenzd2emptyzd2oncezd2_835, BgL_auxz00_839); } 
((((BgL_musicbufferz00_bglt)COBJECT(BgL_i1101z00_838))->BgL_z52emptyz52)=((bool_t)((bool_t)1)),BUNSPEC); }  else 
{ /* Llib/wav_decoder.scm 149 */BFALSE; } 
((((BgL_musicbufferz00_bglt)COBJECT(BgL_i1101z00_838))->BgL_z52tailz52)=((long)BgL_ntailz00_475),BUNSPEC); } 
{ /* Llib/wav_decoder.scm 128 */
bool_t BgL_test2140z00_1674;
{ /* Llib/wav_decoder.scm 128 */
int BgL_arg1844z00_472;
BgL_arg1844z00_472 = 
BGl_wavzd2debugzd2zz__wav_decoderz00(); 
BgL_test2140z00_1674 = 
(
(long)(BgL_arg1844z00_472)>=((long)3)); } 
if(BgL_test2140z00_1674)
{ /* Llib/wav_decoder.scm 129 */
long BgL_pz00_433;
BgL_pz00_433 = 
BGl_bufferzd2percentagezd2filledze70ze7zz__wav_decoderz00(BgL_inlenz00_837, BgL_bufferz00_836); 
{ /* Llib/wav_decoder.scm 130 */
bool_t BgL_test2141z00_1679;
{ /* Llib/wav_decoder.scm 130 */
bool_t BgL_test2142z00_1680;
{ /* Llib/wav_decoder.scm 130 */
bool_t BgL_test2143z00_1681;
if(
(BgL_pz00_433<((long)75)))
{ /* Llib/wav_decoder.scm 130 */
BgL_test2143z00_1681 = ((bool_t)1)
; }  else 
{ /* Llib/wav_decoder.scm 130 */
BgL_test2143z00_1681 = 
CBOOL(
CELL_REF(BgL_haszd2beenzd2emptyzd2oncezd2_835))
; } 
if(BgL_test2143z00_1681)
{ /* Llib/wav_decoder.scm 130 */
if(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1101z00_838))->BgL_z52eofz52))
{ /* Llib/wav_decoder.scm 131 */
BgL_test2142z00_1680 = ((bool_t)0)
; }  else 
{ /* Llib/wav_decoder.scm 131 */
BgL_test2142z00_1680 = ((bool_t)1)
; } }  else 
{ /* Llib/wav_decoder.scm 130 */
BgL_test2142z00_1680 = ((bool_t)0)
; } } 
if(BgL_test2142z00_1680)
{ /* Llib/wav_decoder.scm 130 */
BgL_test2141z00_1679 = ((bool_t)1)
; }  else 
{ /* Llib/wav_decoder.scm 132 */
int BgL_arg1843z00_467;
BgL_arg1843z00_467 = 
BGl_wavzd2debugzd2zz__wav_decoderz00(); 
BgL_test2141z00_1679 = 
(
(long)(BgL_arg1843z00_467)>=((long)4)); } } 
if(BgL_test2141z00_1679)
{ /* Llib/wav_decoder.scm 135 */
obj_t BgL_arg1827z00_448;obj_t BgL_arg1828z00_449;obj_t BgL_arg1829z00_450;
if(
(BgL_pz00_433>=((long)80)))
{ /* Llib/wav_decoder.scm 135 */
BgL_arg1827z00_448 = BGl_string1994z00zz__wav_decoderz00; }  else 
{ /* Llib/wav_decoder.scm 135 */
if(
(BgL_pz00_433>((long)25)))
{ /* Llib/wav_decoder.scm 136 */
BgL_arg1827z00_448 = BGl_string2020z00zz__wav_decoderz00; }  else 
{ /* Llib/wav_decoder.scm 136 */
BgL_arg1827z00_448 = BGl_string2021z00zz__wav_decoderz00; } } 
if(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1101z00_838))->BgL_z52eofz52))
{ /* Llib/wav_decoder.scm 140 */
BgL_arg1828z00_449 = BGl_string2022z00zz__wav_decoderz00; }  else 
{ /* Llib/wav_decoder.scm 140 */
BgL_arg1828z00_449 = BGl_string1994z00zz__wav_decoderz00; } 
BgL_arg1829z00_450 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1101z00_838))->BgL_urlz00); 
{ /* Llib/wav_decoder.scm 133 */
obj_t BgL_list1830z00_451;
{ /* Llib/wav_decoder.scm 133 */
obj_t BgL_arg1831z00_452;
{ /* Llib/wav_decoder.scm 133 */
obj_t BgL_arg1832z00_453;
{ /* Llib/wav_decoder.scm 133 */
obj_t BgL_arg1833z00_454;
{ /* Llib/wav_decoder.scm 133 */
obj_t BgL_arg1834z00_455;
{ /* Llib/wav_decoder.scm 133 */
obj_t BgL_arg1835z00_456;
{ /* Llib/wav_decoder.scm 133 */
obj_t BgL_arg1836z00_457;
{ /* Llib/wav_decoder.scm 133 */
obj_t BgL_arg1837z00_458;
BgL_arg1837z00_458 = 
MAKE_YOUNG_PAIR(BGl_string1972z00zz__wav_decoderz00, BNIL); 
BgL_arg1836z00_457 = 
MAKE_YOUNG_PAIR(BgL_arg1829z00_450, BgL_arg1837z00_458); } 
BgL_arg1835z00_456 = 
MAKE_YOUNG_PAIR(BGl_string2023z00zz__wav_decoderz00, BgL_arg1836z00_457); } 
BgL_arg1834z00_455 = 
MAKE_YOUNG_PAIR(BgL_arg1828z00_449, BgL_arg1835z00_456); } 
BgL_arg1833z00_454 = 
MAKE_YOUNG_PAIR(BGl_string2024z00zz__wav_decoderz00, BgL_arg1834z00_455); } 
BgL_arg1832z00_453 = 
MAKE_YOUNG_PAIR(
BINT(BgL_pz00_433), BgL_arg1833z00_454); } 
BgL_arg1831z00_452 = 
MAKE_YOUNG_PAIR(BgL_arg1827z00_448, BgL_arg1832z00_453); } 
BgL_list1830z00_451 = 
MAKE_YOUNG_PAIR(BGl_string2025z00zz__wav_decoderz00, BgL_arg1831z00_452); } 
BGl_debugz00zz__wav_decoderz00(BgL_list1830z00_451); } }  else 
{ /* Llib/wav_decoder.scm 130 */BFALSE; } } }  else 
{ /* Llib/wav_decoder.scm 128 */BFALSE; } } 
{ /* Llib/wav_decoder.scm 156 */
bool_t BgL_test2149z00_1707;
{ /* Llib/wav_decoder.scm 156 */
bool_t BgL_test2150z00_1708;
{ /* Llib/wav_decoder.scm 123 */
long BgL_arg1813z00_426;
{ /* Llib/wav_decoder.scm 123 */
long BgL_arg1814z00_427;long BgL_arg1815z00_428;
if(
CBOOL(
CELL_REF(BgL_haszd2beenzd2emptyzd2oncezd2_835)))
{ /* Llib/wav_decoder.scm 123 */
BgL_arg1814z00_427 = ((long)2); }  else 
{ /* Llib/wav_decoder.scm 123 */
BgL_arg1814z00_427 = ((long)4); } 
BgL_arg1815z00_428 = 
(BgL_inlenz00_837-
BGl_musicbufferzd2availablezd2zz__multimediazd2musicbufzd2(BgL_bufferz00_836)); 
BgL_arg1813z00_426 = 
(BgL_arg1814z00_427*BgL_arg1815z00_428); } 
BgL_test2150z00_1708 = 
(BgL_arg1813z00_426>BgL_inlenz00_837); } 
if(BgL_test2150z00_1708)
{ /* Llib/wav_decoder.scm 156 */
if(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1101z00_838))->BgL_z52eofz52))
{ /* Llib/wav_decoder.scm 156 */
BgL_test2149z00_1707 = ((bool_t)0)
; }  else 
{ /* Llib/wav_decoder.scm 156 */
BgL_test2149z00_1707 = ((bool_t)1)
; } }  else 
{ /* Llib/wav_decoder.scm 156 */
BgL_test2149z00_1707 = ((bool_t)0)
; } } 
if(BgL_test2149z00_1707)
{ /* Llib/wav_decoder.scm 156 */
{ /* Llib/wav_decoder.scm 157 */
bool_t BgL_test2153z00_1717;
{ /* Llib/wav_decoder.scm 157 */
int BgL_arg1863z00_493;
BgL_arg1863z00_493 = 
BGl_wavzd2debugzd2zz__wav_decoderz00(); 
BgL_test2153z00_1717 = 
(
(long)(BgL_arg1863z00_493)>=((long)2)); } 
if(BgL_test2153z00_1717)
{ /* Llib/wav_decoder.scm 158 */
obj_t BgL_arg1856z00_486;BGL_LONGLONG_T BgL_arg1857z00_487;
BgL_arg1856z00_486 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1101z00_838))->BgL_urlz00); 
BgL_arg1857z00_487 = 
bgl_current_microseconds(); 
{ /* Llib/wav_decoder.scm 158 */
obj_t BgL_list1858z00_488;
{ /* Llib/wav_decoder.scm 158 */
obj_t BgL_arg1859z00_489;
{ /* Llib/wav_decoder.scm 158 */
obj_t BgL_arg1860z00_490;
{ /* Llib/wav_decoder.scm 158 */
obj_t BgL_arg1861z00_491;
{ /* Llib/wav_decoder.scm 158 */
obj_t BgL_arg1862z00_492;
BgL_arg1862z00_492 = 
MAKE_YOUNG_PAIR(BGl_string2008z00zz__wav_decoderz00, BNIL); 
BgL_arg1861z00_491 = 
MAKE_YOUNG_PAIR(
make_bllong(BgL_arg1857z00_487), BgL_arg1862z00_492); } 
BgL_arg1860z00_490 = 
MAKE_YOUNG_PAIR(BGl_string1973z00zz__wav_decoderz00, BgL_arg1861z00_491); } 
BgL_arg1859z00_489 = 
MAKE_YOUNG_PAIR(BgL_arg1856z00_486, BgL_arg1860z00_490); } 
BgL_list1858z00_488 = 
MAKE_YOUNG_PAIR(BGl_string2026z00zz__wav_decoderz00, BgL_arg1859z00_489); } 
BGl_debugz00zz__wav_decoderz00(BgL_list1858z00_488); } }  else 
{ /* Llib/wav_decoder.scm 157 */BFALSE; } } 
{ /* Llib/wav_decoder.scm 160 */
obj_t BgL_mutex1864z00_494;
BgL_mutex1864z00_494 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1101z00_838))->BgL_z52bmutexz52); 
BGL_MUTEX_LOCK(BgL_mutex1864z00_494); 
{ /* Llib/wav_decoder.scm 160 */
bool_t BgL_tmp2154z00_1731;
{ /* Llib/wav_decoder.scm 161 */
obj_t BgL_arg1865z00_495;
BgL_arg1865z00_495 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1101z00_838))->BgL_z52bcondvz52); 
{ /* Llib/wav_decoder.scm 161 */
bool_t BgL_res1922z00_645;
BgL_res1922z00_645 = 
BGL_CONDVAR_BROADCAST(BgL_arg1865z00_495); 
BgL_tmp2154z00_1731 = BgL_res1922z00_645; } } 
BGL_MUTEX_UNLOCK(BgL_mutex1864z00_494); BgL_tmp2154z00_1731; } } 
{ /* Llib/wav_decoder.scm 162 */
bool_t BgL_test2155z00_1736;
{ /* Llib/wav_decoder.scm 162 */
int BgL_arg1871z00_501;
BgL_arg1871z00_501 = 
BGl_wavzd2debugzd2zz__wav_decoderz00(); 
BgL_test2155z00_1736 = 
(
(long)(BgL_arg1871z00_501)>=((long)2)); } 
if(BgL_test2155z00_1736)
{ /* Llib/wav_decoder.scm 163 */
BGL_LONGLONG_T BgL_arg1868z00_498;
BgL_arg1868z00_498 = 
bgl_current_microseconds(); 
{ /* Llib/wav_decoder.scm 163 */
obj_t BgL_list1869z00_499;
{ /* Llib/wav_decoder.scm 163 */
obj_t BgL_arg1870z00_500;
BgL_arg1870z00_500 = 
MAKE_YOUNG_PAIR(BGl_string1972z00zz__wav_decoderz00, BNIL); 
BgL_list1869z00_499 = 
MAKE_YOUNG_PAIR(
make_bllong(BgL_arg1868z00_498), BgL_arg1870z00_500); } 
return 
BGl_debugz00zz__wav_decoderz00(BgL_list1869z00_499);} }  else 
{ /* Llib/wav_decoder.scm 162 */
return BFALSE;} } }  else 
{ /* Llib/wav_decoder.scm 156 */
return BFALSE;} } } } 

}



/* buffer-percentage-filled~0 */
long BGl_bufferzd2percentagezd2filledze70ze7zz__wav_decoderz00(long BgL_inlenz00_841, BgL_musicbufferz00_bglt BgL_bufferz00_840)
{
{ /* Llib/wav_decoder.scm 115 */
{ /* Llib/wav_decoder.scm 114 */
BGL_LONGLONG_T BgL_arg1804z00_417;
{ /* Llib/wav_decoder.scm 114 */
BGL_LONGLONG_T BgL_arg1805z00_418;BGL_LONGLONG_T BgL_arg1806z00_419;
{ /* Llib/wav_decoder.scm 114 */
BGL_LONGLONG_T BgL_arg1807z00_420;
{ /* Llib/wav_decoder.scm 114 */
long BgL_arg1808z00_421;
BgL_arg1808z00_421 = 
BGl_musicbufferzd2availablezd2zz__multimediazd2musicbufzd2(BgL_bufferz00_840); 
{ /* Llib/wav_decoder.scm 114 */
BGL_LONGLONG_T BgL_res1899z00_594;
BgL_res1899z00_594 = 
LONG_TO_LLONG(BgL_arg1808z00_421); 
BgL_arg1807z00_420 = BgL_res1899z00_594; } } 
BgL_arg1805z00_418 = 
(((BGL_LONGLONG_T)100)*BgL_arg1807z00_420); } 
{ /* Llib/wav_decoder.scm 115 */
BGL_LONGLONG_T BgL_res1901z00_599;
BgL_res1901z00_599 = 
LONG_TO_LLONG(BgL_inlenz00_841); 
BgL_arg1806z00_419 = BgL_res1901z00_599; } 
{ /* Llib/wav_decoder.scm 113 */
BGL_LONGLONG_T BgL_res1902z00_602;
BgL_res1902z00_602 = 
(BgL_arg1805z00_418/BgL_arg1806z00_419); 
BgL_arg1804z00_417 = BgL_res1902z00_602; } } 
{ /* Llib/wav_decoder.scm 112 */
long BgL_res1903z00_604;
BgL_res1903z00_604 = 
LLONG_TO_LONG(BgL_arg1804z00_417); 
return BgL_res1903z00_604;} } } 

}



/* &musicdecoder-positio1135 */
obj_t BGl_z62musicdecoderzd2positio1135zb0zz__wav_decoderz00(obj_t BgL_envz00_808, obj_t BgL_decz00_809, obj_t BgL_bz00_810)
{
{ /* Llib/wav_decoder.scm 67 */
return 
BINT(
(((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_809)))->BgL_z52positionz52));} 

}



/* &musicdecoder-reset!-1133 */
obj_t BGl_z62musicdecoderzd2resetz12zd21133z70zz__wav_decoderz00(obj_t BgL_envz00_811, obj_t BgL_decz00_812)
{
{ /* Llib/wav_decoder.scm 59 */
{ 

((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_812)))->BgL_z52headerz52)=((obj_t)BFALSE),BUNSPEC); 
{ /* Llib/wav_decoder.scm 59 */
obj_t BgL_nextzd2method1132zd2_981;
BgL_nextzd2method1132zd2_981 = 
BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
((BgL_objectz00_bglt)
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_812)), BGl_musicdecoderzd2resetz12zd2envz12zz__multimediazd2musicbufzd2, BGl_wavmusicdecoderz00zz__wav_decoderz00); 
return 
PROCEDURE_ENTRY(BgL_nextzd2method1132zd2_981)(BgL_nextzd2method1132zd2_981, 
((obj_t)
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_812)), BEOA);} } } 

}



/* &musicdecoder-init-wa1131 */
obj_t BGl_z62musicdecoderzd2initzd2wa1131z62zz__wav_decoderz00(obj_t BgL_envz00_813, obj_t BgL_decz00_814)
{
{ /* Llib/wav_decoder.scm 51 */
if(
NULLP(
(((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_814))))->BgL_mimetypesz00)))
{ /* Llib/wav_decoder.scm 53 */
return 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_814))))->BgL_mimetypesz00)=((obj_t)
CNST_TABLE_REF(((long)22))),BUNSPEC);}  else 
{ /* Llib/wav_decoder.scm 53 */
return BFALSE;} } 

}



/* &object-print-wavmusi1129 */
obj_t BGl_z62objectzd2printzd2wavmusi1129z62zz__wav_decoderz00(obj_t BgL_envz00_815, obj_t BgL_oz00_816, obj_t BgL_portz00_817, obj_t BgL_printzd2slotzd2_818)
{
{ /* Llib/wav_decoder.scm 45 */
{ /* Llib/wav_decoder.scm 46 */
obj_t BgL_tmpz00_1774;
BgL_tmpz00_1774 = 
((obj_t)BgL_portz00_817); 
return 
bgl_display_string(BGl_string2027z00zz__wav_decoderz00, BgL_tmpz00_1774);} } 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__wav_decoderz00()
{
{ /* Llib/wav_decoder.scm 15 */
return 
BGl_modulezd2initializa7ationz75zz__wav_wavz00(((long)21080121), 
BSTRING_TO_STRING(BGl_string2028z00zz__wav_decoderz00));} 

}

#ifdef __cplusplus
}
#endif
