/*===========================================================================*/
/*   (Ast/glo_def.scm)                                                       */
/*   Bigloo (4.3h)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 11 May 2020 12:14:39 PM CEST    */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.3h -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Ast/glo_def.scm) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_backendz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_languagez00;
		obj_t BgL_srfi0z00;
		obj_t BgL_namez00;
		obj_t BgL_externzd2variableszd2;
		obj_t BgL_externzd2functionszd2;
		obj_t BgL_externzd2typeszd2;
		obj_t BgL_variablesz00;
		obj_t BgL_functionsz00;
		obj_t BgL_typesz00;
		bool_t BgL_typedz00;
		obj_t BgL_heapzd2suffixzd2;
		obj_t BgL_heapzd2compatiblezd2;
		bool_t BgL_callccz00;
		bool_t BgL_qualifiedzd2typeszd2;
		bool_t BgL_effectzb2zb2;
		bool_t BgL_removezd2emptyzd2letz00;
		bool_t BgL_foreignzd2closurezd2;
		bool_t BgL_typedzd2eqzd2;
		bool_t BgL_tracezd2supportzd2;
		obj_t BgL_foreignzd2clausezd2supportz00;
		obj_t BgL_debugzd2supportzd2;
		bool_t BgL_pragmazd2supportzd2;
		bool_t BgL_tvectorzd2descrzd2supportz00;
		bool_t BgL_requirezd2tailczd2;
		obj_t BgL_registersz00;
		obj_t BgL_pregistersz00;
		bool_t BgL_boundzd2checkzd2;
		bool_t BgL_typezd2checkzd2;
		bool_t BgL_typedzd2funcallzd2;
	}                 *BgL_backendz00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		bool_t BgL_evalzf3zf3;
		obj_t BgL_libraryz00;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
		obj_t BgL_initz00;
		obj_t BgL_aliasz00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_localz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		long BgL_keyz00;
	}               *BgL_localz00_bglt;

	typedef struct BgL_funz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
	}             *BgL_funz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
		obj_t BgL_strengthz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_svarz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
	}              *BgL_svarz00_bglt;


	BGL_IMPORT bool_t BGl_equalzf3zf3zz__r4_equivalence_6_2z00(obj_t, obj_t);
	extern obj_t BGl_sfunz00zzast_varz00;
	extern obj_t BGl_dssslzd2formalszd2zztools_dssslz00(obj_t);
	static obj_t BGl_objectzd2initzd2zzast_glozd2defzd2();
	static BgL_globalz00_bglt
		BGl_z62defzd2globalzd2svarz12z70zzast_glozd2defzd2(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	extern BgL_globalz00_bglt
		BGl_declarezd2globalzd2scnstz12z12zzast_glozd2declzd2(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	BGL_IMPORT obj_t string_append_3(obj_t, obj_t, obj_t);
	static BgL_globalz00_bglt
		BGl_z62defzd2globalzd2sfunzd2nozd2warningz12z70zzast_glozd2defzd2(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
	extern bool_t BGl_dssslzd2keyzd2onlyzd2prototypezf3z21zztools_dssslz00(obj_t);
	extern obj_t BGl_thezd2backendzd2zzbackend_backendz00();
	BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	static BgL_globalz00_bglt
		BGl_checkzd2sfunzd2definitionz00zzast_glozd2defzd2(BgL_globalz00_bglt,
		obj_t, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zzast_glozd2defzd2();
	extern obj_t BGl_za2bdbzd2debugza2zd2zzengine_paramz00;
	extern obj_t BGl_removezd2varzd2fromz12z12zzast_removez00(obj_t,
		BgL_variablez00_bglt);
	static BgL_globalz00_bglt
		BGl_mismatchzd2errorzd2zzast_glozd2defzd2(BgL_globalz00_bglt, obj_t, obj_t);
	extern obj_t BGl_za2_za2z00zztype_cachez00;
	extern obj_t BGl_svarz00zzast_varz00;
	extern obj_t BGl_za2objza2z00zztype_cachez00;
	extern obj_t BGl_findzd2locationzd2zztools_locationz00(obj_t);
	extern bool_t BGl_typezd2subclasszf3z21zzobject_classz00(BgL_typez00_bglt,
		BgL_typez00_bglt);
	extern obj_t BGl_enterzd2functionzd2zztools_errorz00(obj_t);
	BGL_EXPORTED_DECL BgL_globalz00_bglt
		BGl_defzd2globalzd2sfunz12z12zzast_glozd2defzd2(obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static BgL_globalz00_bglt
		BGl_checkzd2svarzd2definitionz00zzast_glozd2defzd2(BgL_globalz00_bglt,
		obj_t, obj_t);
	BGL_IMPORT long bgl_list_length(obj_t);
	static obj_t BGl_gczd2rootszd2initz00zzast_glozd2defzd2();
	extern obj_t BGl_parsezd2idzd2zzast_identz00(obj_t, obj_t);
	static bool_t BGl_compatiblezd2typezf3z21zzast_glozd2defzd2(bool_t,
		BgL_typez00_bglt, BgL_typez00_bglt);
	static BgL_globalz00_bglt
		BGl_z62defzd2globalzd2scnstz12z70zzast_glozd2defzd2(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL bool_t
		BGl_checkzd2methodzd2definitionz00zzast_glozd2defzd2(obj_t, obj_t, obj_t,
		obj_t);
	extern bool_t BGl_dssslzd2prototypezf3z21zztools_dssslz00(obj_t);
	BGL_EXPORTED_DECL BgL_globalz00_bglt
		BGl_defzd2globalzd2sfunzd2nozd2warningz12z12zzast_glozd2defzd2(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL BgL_globalz00_bglt
		BGl_defzd2globalzd2svarz12z12zzast_glozd2defzd2(obj_t, obj_t, obj_t, obj_t);
	BGL_IMPORT int BGl_bigloozd2warningzd2zz__paramz00();
	static obj_t BGl_requirezd2initializa7ationz75zzast_glozd2defzd2 = BUNSPEC;
	extern obj_t BGl_dssslzd2keyszd2zztools_dssslz00(obj_t);
	extern obj_t BGl_tclassz00zzobject_classz00;
	BGL_IMPORT obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
	extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_genericzd2initzd2zzast_glozd2defzd2();
	extern obj_t BGl_leavezd2functionzd2zztools_errorz00();
	extern obj_t BGl_shapez00zztools_shapez00(obj_t);
	extern obj_t BGl_typez00zztype_typez00;
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t,
		obj_t, obj_t);
	extern BgL_globalz00_bglt
		BGl_declarezd2globalzd2sfunz12z12zzast_glozd2declzd2(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_bigloozd2warningzd2setz12z12zz__paramz00(int);
	extern obj_t BGl_findzd2globalzd2zzast_envz00(obj_t, obj_t);
	static obj_t BGl_z62checkzd2methodzd2definitionz62zzast_glozd2defzd2(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	extern obj_t BGl_idzd2ofzd2idz00zzast_identz00(obj_t, obj_t);
	BGL_EXPORTED_DECL BgL_globalz00_bglt
		BGl_defzd2globalzd2scnstz12z12zzast_glozd2defzd2(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	extern bool_t
		BGl_dssslzd2optionalzd2onlyzd2prototypezf3z21zztools_dssslz00(obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzast_glozd2defzd2(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_classz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_dssslz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_locationz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_argsz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_removez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_glozd2declzd2(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_identz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
	extern BgL_typez00_bglt BGl_typezd2ofzd2idz00zzast_identz00(obj_t, obj_t);
	extern obj_t BGl_localz00zzast_varz00;
	static obj_t BGl_cnstzd2initzd2zzast_glozd2defzd2();
	static obj_t BGl_libraryzd2moduleszd2initz00zzast_glozd2defzd2();
	extern long BGl_globalzd2arityzd2zztools_argsz00(obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zzast_glozd2defzd2();
	extern obj_t BGl_dssslzd2optionalszd2zztools_dssslz00(obj_t);
	extern BgL_globalz00_bglt
		BGl_declarezd2globalzd2svarz12z12zzast_glozd2declzd2(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_findzd2globalzf2modulez20zzast_envz00(obj_t, obj_t);
	static BgL_globalz00_bglt
		BGl_z62defzd2globalzd2sfunz12z70zzast_glozd2defzd2(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
	extern obj_t BGl_userzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t, obj_t);
	extern obj_t BGl_globalz00zzast_varz00;
	static obj_t __cnst[6];


	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_checkzd2methodzd2definitionzd2envzd2zzast_glozd2defzd2,
		BgL_bgl_za762checkza7d2metho1913z00,
		BGl_z62checkzd2methodzd2definitionz62zzast_glozd2defzd2, 0L, BUNSPEC, 4);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_defzd2globalzd2sfunzd2nozd2warningz12zd2envzc0zzast_glozd2defzd2,
		BgL_bgl_za762defza7d2globalza71914za7,
		BGl_z62defzd2globalzd2sfunzd2nozd2warningz12z70zzast_glozd2defzd2, 0L,
		BUNSPEC, 8);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_defzd2globalzd2sfunz12zd2envzc0zzast_glozd2defzd2,
		BgL_bgl_za762defza7d2globalza71915za7,
		BGl_z62defzd2globalzd2sfunz12z70zzast_glozd2defzd2, 0L, BUNSPEC, 8);
	      DEFINE_STRING(BGl_string1891z00zzast_glozd2defzd2,
		BgL_bgl_string1891za700za7za7a1916za7, "check-method-definition", 23);
	      DEFINE_STRING(BGl_string1892z00zzast_glozd2defzd2,
		BgL_bgl_string1892za700za7za7a1917za7, "unexpected generic arg", 22);
	      DEFINE_STRING(BGl_string1893z00zzast_glozd2defzd2,
		BgL_bgl_string1893za700za7za7a1918za7,
		"(incompatible DSSSL #!optional prototype)", 41);
	      DEFINE_STRING(BGl_string1894z00zzast_glozd2defzd2,
		BgL_bgl_string1894za700za7za7a1919za7,
		"(incompatible DSSSL #!key prototype)", 36);
	      DEFINE_STRING(BGl_string1895z00zzast_glozd2defzd2,
		BgL_bgl_string1895za700za7za7a1920za7, "(incompatible Dsssl prototype)",
		30);
	      DEFINE_STRING(BGl_string1896z00zzast_glozd2defzd2,
		BgL_bgl_string1896za700za7za7a1921za7, "(arity differs)", 15);
	      DEFINE_STRING(BGl_string1897z00zzast_glozd2defzd2,
		BgL_bgl_string1897za700za7za7a1922za7, "(incompatible formal type)", 26);
	      DEFINE_STRING(BGl_string1898z00zzast_glozd2defzd2,
		BgL_bgl_string1898za700za7za7a1923za7,
		"(incompatible function type result)", 35);
	      DEFINE_STRING(BGl_string1899z00zzast_glozd2defzd2,
		BgL_bgl_string1899za700za7za7a1924za7,
		"(declared as function of another class (~a/~a))", 47);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_defzd2globalzd2svarz12zd2envzc0zzast_glozd2defzd2,
		BgL_bgl_za762defza7d2globalza71925za7,
		BGl_z62defzd2globalzd2svarz12z70zzast_glozd2defzd2, 0L, BUNSPEC, 4);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_defzd2globalzd2scnstz12zd2envzc0zzast_glozd2defzd2,
		BgL_bgl_za762defza7d2globalza71926za7,
		BGl_z62defzd2globalzd2scnstz12z70zzast_glozd2defzd2, 0L, BUNSPEC, 5);
	      DEFINE_STRING(BGl_string1900z00zzast_glozd2defzd2,
		BgL_bgl_string1900za700za7za7a1927za7, "(not declared as function)", 26);
	      DEFINE_STRING(BGl_string1901z00zzast_glozd2defzd2,
		BgL_bgl_string1901za700za7za7a1928za7, "Illegal type for global variable",
		32);
	      DEFINE_STRING(BGl_string1902z00zzast_glozd2defzd2,
		BgL_bgl_string1902za700za7za7a1929za7, "(incompatible variable type)", 28);
	      DEFINE_STRING(BGl_string1903z00zzast_glozd2defzd2,
		BgL_bgl_string1903za700za7za7a1930za7, "(not declared as a variable)", 28);
	      DEFINE_STRING(BGl_string1904z00zzast_glozd2defzd2,
		BgL_bgl_string1904za700za7za7a1931za7,
		"Prototype and definition don't match", 36);
	      DEFINE_STRING(BGl_string1905z00zzast_glozd2defzd2,
		BgL_bgl_string1905za700za7za7a1932za7, " ", 1);
	      DEFINE_STRING(BGl_string1906z00zzast_glozd2defzd2,
		BgL_bgl_string1906za700za7za7a1933za7, "argument missing", 16);
	      DEFINE_STRING(BGl_string1907z00zzast_glozd2defzd2,
		BgL_bgl_string1907za700za7za7a1934za7, "(generic not found for method)",
		30);
	      DEFINE_STRING(BGl_string1908z00zzast_glozd2defzd2,
		BgL_bgl_string1908za700za7za7a1935za7, "ast_glo-def", 11);
	      DEFINE_STRING(BGl_string1909z00zzast_glozd2defzd2,
		BgL_bgl_string1909za700za7za7a1936za7,
		"bigloo now sgfun static export bdb ", 35);

/* GC roots registration */
	static obj_t bgl_gc_roots_register()
	{
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
		void *roots_min = (void *) ULONG_MAX, *roots_max = 0;
		   
			 ADD_ROOT((void
				*) (&BGl_requirezd2initializa7ationz75zzast_glozd2defzd2));
#undef ADD_ROOT
		if   (roots_max > 0)
			     GC_add_roots(roots_min, ((void **) roots_max) + 1);
#endif
		     return BUNSPEC;
	}



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzast_glozd2defzd2(long
		BgL_checksumz00_2353, char *BgL_fromz00_2354)
	{
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzast_glozd2defzd2))
				{
					BGl_requirezd2initializa7ationz75zzast_glozd2defzd2 =
						BBOOL(((bool_t) 0));
					BGl_gczd2rootszd2initz00zzast_glozd2defzd2();
					BGl_libraryzd2moduleszd2initz00zzast_glozd2defzd2();
					BGl_cnstzd2initzd2zzast_glozd2defzd2();
					BGl_importedzd2moduleszd2initz00zzast_glozd2defzd2();
					return BGl_methodzd2initzd2zzast_glozd2defzd2();
				}
			else
				{
					return BUNSPEC;
				}
		}

	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzast_glozd2defzd2()
	{
		{	/* Ast/glo_def.scm 15 */
			BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long) 0),
				"ast_glo-def");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"ast_glo-def");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0), "ast_glo-def");
			BGl_modulezd2initializa7ationz75zz__paramz00(((long) 0), "ast_glo-def");
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 0),
				"ast_glo-def");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0), "ast_glo-def");
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"ast_glo-def");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"ast_glo-def");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long) 0),
				"ast_glo-def");
			return BUNSPEC;
		}

	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzast_glozd2defzd2()
	{
		{	/* Ast/glo_def.scm 15 */
			{	/* Ast/glo_def.scm 15 */
				obj_t BgL_cportz00_2340;

				{	/* Ast/glo_def.scm 15 */
					obj_t BgL_stringz00_2348;

					BgL_stringz00_2348 = BGl_string1909z00zzast_glozd2defzd2;
					{	/* Ast/glo_def.scm 15 */
						obj_t BgL_startz00_2349;

						BgL_startz00_2349 = BINT(((long) 0));
						{	/* Ast/glo_def.scm 15 */
							obj_t BgL_endz00_2350;

							BgL_endz00_2350 =
								BINT(STRING_LENGTH(((obj_t) BgL_stringz00_2348)));
							{	/* Ast/glo_def.scm 15 */

								BgL_cportz00_2340 =
									BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00
									(BgL_stringz00_2348, BgL_startz00_2349, BgL_endz00_2350);
				}}}}
				{
					long BgL_iz00_2341;

					BgL_iz00_2341 = ((long) 5);
				BgL_loopz00_2342:
					if ((BgL_iz00_2341 == ((long) -1)))
						{	/* Ast/glo_def.scm 15 */
							return BUNSPEC;
						}
					else
						{	/* Ast/glo_def.scm 15 */
							{	/* Ast/glo_def.scm 15 */
								obj_t BgL_arg1911z00_2344;

								{	/* Ast/glo_def.scm 15 */

									{	/* Ast/glo_def.scm 15 */
										obj_t BgL_locationz00_2346;

										BgL_locationz00_2346 = BBOOL(((bool_t) 0));
										{	/* Ast/glo_def.scm 15 */

											BgL_arg1911z00_2344 =
												BGl_readz00zz__readerz00(BgL_cportz00_2340,
												BgL_locationz00_2346);
										}
									}
								}
								{	/* Ast/glo_def.scm 15 */
									int BgL_tmpz00_2381;

									BgL_tmpz00_2381 = (int) (BgL_iz00_2341);
									CNST_TABLE_SET(BgL_tmpz00_2381, BgL_arg1911z00_2344);
							}}
							{	/* Ast/glo_def.scm 15 */
								int BgL_auxz00_2347;

								BgL_auxz00_2347 = (int) ((BgL_iz00_2341 - ((long) 1)));
								{
									long BgL_iz00_2386;

									BgL_iz00_2386 = (long) (BgL_auxz00_2347);
									BgL_iz00_2341 = BgL_iz00_2386;
									goto BgL_loopz00_2342;
								}
							}
						}
				}
			}
		}

	}



/* gc-roots-init */
	obj_t BGl_gczd2rootszd2initz00zzast_glozd2defzd2()
	{
		{	/* Ast/glo_def.scm 15 */
			return bgl_gc_roots_register();
		}

	}



/* def-global-sfun-no-warning! */
	BGL_EXPORTED_DEF BgL_globalz00_bglt
		BGl_defzd2globalzd2sfunzd2nozd2warningz12z12zzast_glozd2defzd2(obj_t
		BgL_idz00_3, obj_t BgL_argsz00_4, obj_t BgL_locz00_5, obj_t BgL_modz00_6,
		obj_t BgL_classz00_7, obj_t BgL_srczd2expzd2_8, obj_t BgL_remz00_9,
		obj_t BgL_nodez00_10)
	{
		{	/* Ast/glo_def.scm 67 */
			{	/* Ast/glo_def.scm 68 */
				int BgL_warningz00_2151;

				BgL_warningz00_2151 = BGl_bigloozd2warningzd2zz__paramz00();
				BGl_bigloozd2warningzd2setz12z12zz__paramz00((int) (((long) 0)));
				{	/* Ast/glo_def.scm 70 */
					BgL_globalz00_bglt BgL_funz00_2152;

					BgL_funz00_2152 =
						BGl_defzd2globalzd2sfunz12z12zzast_glozd2defzd2(BgL_idz00_3,
						BgL_argsz00_4, BgL_locz00_5, BgL_modz00_6, BgL_classz00_7,
						BgL_srczd2expzd2_8, BgL_remz00_9, BgL_nodez00_10);
					BGl_bigloozd2warningzd2setz12z12zz__paramz00(BgL_warningz00_2151);
					return BgL_funz00_2152;
				}
			}
		}

	}



/* &def-global-sfun-no-warning! */
	BgL_globalz00_bglt
		BGl_z62defzd2globalzd2sfunzd2nozd2warningz12z70zzast_glozd2defzd2(obj_t
		BgL_envz00_2306, obj_t BgL_idz00_2307, obj_t BgL_argsz00_2308,
		obj_t BgL_locz00_2309, obj_t BgL_modz00_2310, obj_t BgL_classz00_2311,
		obj_t BgL_srczd2expzd2_2312, obj_t BgL_remz00_2313, obj_t BgL_nodez00_2314)
	{
		{	/* Ast/glo_def.scm 67 */
			return
				BGl_defzd2globalzd2sfunzd2nozd2warningz12z12zzast_glozd2defzd2
				(BgL_idz00_2307, BgL_argsz00_2308, BgL_locz00_2309, BgL_modz00_2310,
				BgL_classz00_2311, BgL_srczd2expzd2_2312, BgL_remz00_2313,
				BgL_nodez00_2314);
		}

	}



/* def-global-sfun! */
	BGL_EXPORTED_DEF BgL_globalz00_bglt
		BGl_defzd2globalzd2sfunz12z12zzast_glozd2defzd2(obj_t BgL_idz00_11,
		obj_t BgL_argsz00_12, obj_t BgL_localsz00_13, obj_t BgL_modulez00_14,
		obj_t BgL_classz00_15, obj_t BgL_srczd2expzd2_16, obj_t BgL_remz00_17,
		obj_t BgL_nodez00_18)
	{
		{	/* Ast/glo_def.scm 80 */
			BGl_enterzd2functionzd2zztools_errorz00(BgL_idz00_11);
			{	/* Ast/glo_def.scm 86 */
				obj_t BgL_locz00_1657;

				BgL_locz00_1657 =
					BGl_findzd2locationzd2zztools_locationz00(BgL_srczd2expzd2_16);
				{	/* Ast/glo_def.scm 86 */
					obj_t BgL_idzd2typezd2_1658;

					BgL_idzd2typezd2_1658 =
						BGl_parsezd2idzd2zzast_identz00(BgL_idz00_11, BgL_locz00_1657);
					{	/* Ast/glo_def.scm 87 */
						obj_t BgL_typezd2reszd2_1659;

						BgL_typezd2reszd2_1659 = CDR(BgL_idzd2typezd2_1658);
						{	/* Ast/glo_def.scm 88 */
							obj_t BgL_idz00_1660;

							BgL_idz00_1660 = CAR(BgL_idzd2typezd2_1658);
							{	/* Ast/glo_def.scm 89 */
								obj_t BgL_importz00_1661;

								{	/* Ast/glo_def.scm 90 */
									bool_t BgL_test1939z00_2400;

									if (
										((long) CINT(BGl_za2bdbzd2debugza2zd2zzengine_paramz00) >=
											((long) 3)))
										{	/* Ast/glo_def.scm 91 */
											obj_t BgL_arg1492z00_1714;

											{	/* Ast/glo_def.scm 91 */
												obj_t BgL_arg1493z00_1715;

												BgL_arg1493z00_1715 =
													BGl_thezd2backendzd2zzbackend_backendz00();
												BgL_arg1492z00_1714 =
													(((BgL_backendz00_bglt) COBJECT(
															((BgL_backendz00_bglt) BgL_arg1493z00_1715)))->
													BgL_debugzd2supportzd2);
											}
											BgL_test1939z00_2400 =
												CBOOL(BGl_memqz00zz__r4_pairs_and_lists_6_3z00
												(CNST_TABLE_REF(((long) 0)), BgL_arg1492z00_1714));
										}
									else
										{	/* Ast/glo_def.scm 90 */
											BgL_test1939z00_2400 = ((bool_t) 0);
										}
									if (BgL_test1939z00_2400)
										{	/* Ast/glo_def.scm 90 */
											BgL_importz00_1661 = CNST_TABLE_REF(((long) 1));
										}
									else
										{	/* Ast/glo_def.scm 90 */
											BgL_importz00_1661 = CNST_TABLE_REF(((long) 2));
								}}
								{	/* Ast/glo_def.scm 90 */
									obj_t BgL_oldzd2globalzd2_1662;

									BgL_oldzd2globalzd2_1662 =
										BGl_findzd2globalzf2modulez20zzast_envz00(BgL_idz00_1660,
										BgL_modulez00_14);
									{	/* Ast/glo_def.scm 94 */
										BgL_globalz00_bglt BgL_globalz00_1663;

										if (BGl_isazf3zf3zz__objectz00(BgL_oldzd2globalzd2_1662,
												BGl_globalz00zzast_varz00))
											{	/* Ast/glo_def.scm 96 */
												BgL_globalz00_1663 =
													BGl_checkzd2sfunzd2definitionz00zzast_glozd2defzd2(
													((BgL_globalz00_bglt) BgL_oldzd2globalzd2_1662),
													BgL_typezd2reszd2_1659, BgL_argsz00_12,
													BgL_localsz00_13, BgL_classz00_15,
													BgL_srczd2expzd2_16);
											}
										else
											{	/* Ast/glo_def.scm 96 */
												BgL_globalz00_1663 =
													BGl_declarezd2globalzd2sfunz12z12zzast_glozd2declzd2
													(BgL_idz00_1660, BFALSE, BgL_argsz00_12,
													BgL_modulez00_14, BgL_importz00_1661, BgL_classz00_15,
													BgL_srczd2expzd2_16, BFALSE);
											}
										{	/* Ast/glo_def.scm 95 */
											obj_t BgL_defzd2loczd2_1664;

											BgL_defzd2loczd2_1664 =
												BGl_findzd2locationzd2zztools_locationz00
												(BgL_srczd2expzd2_16);
											{	/* Ast/glo_def.scm 102 */

												{	/* Ast/glo_def.scm 103 */
													bool_t BgL_test1942z00_2419;

													{	/* Ast/glo_def.scm 103 */
														BgL_valuez00_bglt BgL_arg1473z00_1707;

														BgL_arg1473z00_1707 =
															(((BgL_variablez00_bglt) COBJECT(
																	((BgL_variablez00_bglt)
																		BgL_globalz00_1663)))->BgL_valuez00);
														{	/* Ast/glo_def.scm 103 */
															bool_t BgL_res1852z00_2162;

															BgL_res1852z00_2162 =
																BGl_isazf3zf3zz__objectz00(
																((obj_t) BgL_arg1473z00_1707),
																BGl_sfunz00zzast_varz00);
															BgL_test1942z00_2419 = BgL_res1852z00_2162;
														}
													}
													if (BgL_test1942z00_2419)
														{	/* Ast/glo_def.scm 103 */
															{	/* Ast/glo_def.scm 300 */
																BgL_typez00_bglt BgL_oldzd2typezd2_2165;

																BgL_oldzd2typezd2_2165 =
																	(((BgL_variablez00_bglt) COBJECT(
																			((BgL_variablez00_bglt)
																				BgL_globalz00_1663)))->BgL_typez00);
																if ((((obj_t) BgL_oldzd2typezd2_2165) ==
																		BGl_za2_za2z00zztype_cachez00))
																	{	/* Ast/glo_def.scm 301 */
																		((((BgL_variablez00_bglt) COBJECT(
																						((BgL_variablez00_bglt)
																							BgL_globalz00_1663)))->
																				BgL_typez00) =
																			((BgL_typez00_bglt) ((BgL_typez00_bglt)
																					BgL_typezd2reszd2_1659)), BUNSPEC);
																	}
																else
																	{	/* Ast/glo_def.scm 301 */
																		BFALSE;
																	}
															}
															if (
																(bgl_list_length(BgL_localsz00_13) ==
																	bgl_list_length(
																		(((BgL_sfunz00_bglt) COBJECT(
																					((BgL_sfunz00_bglt)
																						(((BgL_variablez00_bglt) COBJECT(
																									((BgL_variablez00_bglt)
																										BgL_globalz00_1663)))->
																							BgL_valuez00))))->BgL_argsz00))))
																{	/* Ast/glo_def.scm 114 */
																	obj_t BgL_typesz00_1672;

																	{	/* Ast/glo_def.scm 114 */
																		obj_t BgL_l1298z00_1683;

																		BgL_l1298z00_1683 =
																			(((BgL_sfunz00_bglt) COBJECT(
																					((BgL_sfunz00_bglt)
																						(((BgL_variablez00_bglt) COBJECT(
																									((BgL_variablez00_bglt)
																										BgL_globalz00_1663)))->
																							BgL_valuez00))))->BgL_argsz00);
																		if (NULLP(BgL_l1298z00_1683))
																			{	/* Ast/glo_def.scm 114 */
																				BgL_typesz00_1672 = BNIL;
																			}
																		else
																			{	/* Ast/glo_def.scm 114 */
																				obj_t BgL_head1300z00_1685;

																				{	/* Ast/glo_def.scm 114 */
																					obj_t BgL_res1855z00_2178;

																					BgL_res1855z00_2178 =
																						MAKE_YOUNG_PAIR(BNIL, BNIL);
																					BgL_head1300z00_1685 =
																						BgL_res1855z00_2178;
																				}
																				{
																					obj_t BgL_l1298z00_1687;
																					obj_t BgL_tail1301z00_1688;

																					BgL_l1298z00_1687 = BgL_l1298z00_1683;
																					BgL_tail1301z00_1688 =
																						BgL_head1300z00_1685;
																				BgL_zc3z04anonymousza31370ze3z87_1689:
																					if (NULLP(BgL_l1298z00_1687))
																						{	/* Ast/glo_def.scm 114 */
																							BgL_typesz00_1672 =
																								CDR(BgL_head1300z00_1685);
																						}
																					else
																						{	/* Ast/glo_def.scm 114 */
																							obj_t BgL_newtail1302z00_1691;

																							{	/* Ast/glo_def.scm 114 */
																								obj_t BgL_arg1406z00_1693;

																								{	/* Ast/glo_def.scm 114 */
																									obj_t BgL_az00_1694;

																									BgL_az00_1694 =
																										CAR(
																										((obj_t)
																											BgL_l1298z00_1687));
																									if (BGl_isazf3zf3zz__objectz00
																										(BgL_az00_1694,
																											BGl_localz00zzast_varz00))
																										{	/* Ast/glo_def.scm 116 */
																											BgL_arg1406z00_1693 =
																												((obj_t)
																												(((BgL_variablez00_bglt)
																														COBJECT((
																																(BgL_variablez00_bglt)
																																((BgL_localz00_bglt) BgL_az00_1694))))->BgL_typez00));
																										}
																									else
																										{	/* Ast/glo_def.scm 116 */
																											if (BGl_isazf3zf3zz__objectz00(BgL_az00_1694, BGl_typez00zztype_typez00))
																												{	/* Ast/glo_def.scm 118 */
																													BgL_arg1406z00_1693 =
																														BgL_az00_1694;
																												}
																											else
																												{	/* Ast/glo_def.scm 118 */
																													BgL_arg1406z00_1693 =
																														BGl_internalzd2errorzd2zztools_errorz00
																														(BGl_string1891z00zzast_glozd2defzd2,
																														BGl_string1892z00zzast_glozd2defzd2,
																														BGl_shapez00zztools_shapez00
																														(BgL_az00_1694));
																												}
																										}
																								}
																								{	/* Ast/glo_def.scm 114 */
																									obj_t BgL_res1859z00_2185;

																									BgL_res1859z00_2185 =
																										MAKE_YOUNG_PAIR
																										(BgL_arg1406z00_1693, BNIL);
																									BgL_newtail1302z00_1691 =
																										BgL_res1859z00_2185;
																								}
																							}
																							SET_CDR(BgL_tail1301z00_1688,
																								BgL_newtail1302z00_1691);
																							{	/* Ast/glo_def.scm 114 */
																								obj_t BgL_arg1379z00_1692;

																								BgL_arg1379z00_1692 =
																									CDR(
																									((obj_t) BgL_l1298z00_1687));
																								{
																									obj_t BgL_tail1301z00_2467;
																									obj_t BgL_l1298z00_2466;

																									BgL_l1298z00_2466 =
																										BgL_arg1379z00_1692;
																									BgL_tail1301z00_2467 =
																										BgL_newtail1302z00_1691;
																									BgL_tail1301z00_1688 =
																										BgL_tail1301z00_2467;
																									BgL_l1298z00_1687 =
																										BgL_l1298z00_2466;
																									goto
																										BgL_zc3z04anonymousza31370ze3z87_1689;
																								}
																							}
																						}
																				}
																			}
																	}
																	{
																		obj_t BgL_ll1303z00_1674;
																		obj_t BgL_ll1304z00_1675;

																		BgL_ll1303z00_1674 = BgL_localsz00_13;
																		BgL_ll1304z00_1675 = BgL_typesz00_1672;
																	BgL_zc3z04anonymousza31340ze3z87_1676:
																		if (NULLP(BgL_ll1303z00_1674))
																			{	/* Ast/glo_def.scm 126 */
																				((bool_t) 1);
																			}
																		else
																			{	/* Ast/glo_def.scm 126 */
																				{	/* Ast/glo_def.scm 126 */
																					obj_t BgL_arg1343z00_1678;
																					obj_t BgL_arg1364z00_1679;

																					BgL_arg1343z00_1678 =
																						CAR(((obj_t) BgL_ll1303z00_1674));
																					BgL_arg1364z00_1679 =
																						CAR(((obj_t) BgL_ll1304z00_1675));
																					{	/* Ast/glo_def.scm 300 */
																						BgL_typez00_bglt
																							BgL_oldzd2typezd2_2193;
																						BgL_oldzd2typezd2_2193 =
																							(((BgL_variablez00_bglt)
																								COBJECT(((BgL_variablez00_bglt)
																										BgL_arg1343z00_1678)))->
																							BgL_typez00);
																						if ((((obj_t)
																									BgL_oldzd2typezd2_2193) ==
																								BGl_za2_za2z00zztype_cachez00))
																							{	/* Ast/glo_def.scm 301 */
																								((((BgL_variablez00_bglt)
																											COBJECT((
																													(BgL_variablez00_bglt)
																													BgL_arg1343z00_1678)))->
																										BgL_typez00) =
																									((BgL_typez00_bglt) (
																											(BgL_typez00_bglt)
																											BgL_arg1364z00_1679)),
																									BUNSPEC);
																							}
																						else
																							{	/* Ast/glo_def.scm 301 */
																								BFALSE;
																							}
																					}
																				}
																				{	/* Ast/glo_def.scm 126 */
																					obj_t BgL_arg1367z00_1680;
																					obj_t BgL_arg1368z00_1681;

																					BgL_arg1367z00_1680 =
																						CDR(((obj_t) BgL_ll1303z00_1674));
																					BgL_arg1368z00_1681 =
																						CDR(((obj_t) BgL_ll1304z00_1675));
																					{
																						obj_t BgL_ll1304z00_2487;
																						obj_t BgL_ll1303z00_2486;

																						BgL_ll1303z00_2486 =
																							BgL_arg1367z00_1680;
																						BgL_ll1304z00_2487 =
																							BgL_arg1368z00_1681;
																						BgL_ll1304z00_1675 =
																							BgL_ll1304z00_2487;
																						BgL_ll1303z00_1674 =
																							BgL_ll1303z00_2486;
																						goto
																							BgL_zc3z04anonymousza31340ze3z87_1676;
																					}
																				}
																			}
																	}
																}
															else
																{	/* Ast/glo_def.scm 112 */
																	((bool_t) 0);
																}
															BGl_removezd2varzd2fromz12z12zzast_removez00
																(BgL_remz00_17,
																((BgL_variablez00_bglt) BgL_globalz00_1663));
															{	/* Ast/glo_def.scm 130 */
																BgL_valuez00_bglt BgL_arg1442z00_1704;

																BgL_arg1442z00_1704 =
																	(((BgL_variablez00_bglt) COBJECT(
																			((BgL_variablez00_bglt)
																				BgL_globalz00_1663)))->BgL_valuez00);
																((((BgL_sfunz00_bglt)
																			COBJECT(((BgL_sfunz00_bglt)
																					BgL_arg1442z00_1704)))->BgL_bodyz00) =
																	((obj_t) BgL_nodez00_18), BUNSPEC);
															}
															{	/* Ast/glo_def.scm 132 */
																BgL_valuez00_bglt BgL_arg1457z00_1705;

																BgL_arg1457z00_1705 =
																	(((BgL_variablez00_bglt) COBJECT(
																			((BgL_variablez00_bglt)
																				BgL_globalz00_1663)))->BgL_valuez00);
																((((BgL_sfunz00_bglt)
																			COBJECT(((BgL_sfunz00_bglt)
																					BgL_arg1457z00_1705)))->BgL_argsz00) =
																	((obj_t) BgL_localsz00_13), BUNSPEC);
															}
															{	/* Ast/glo_def.scm 134 */
																BgL_valuez00_bglt BgL_arg1466z00_1706;

																BgL_arg1466z00_1706 =
																	(((BgL_variablez00_bglt) COBJECT(
																			((BgL_variablez00_bglt)
																				BgL_globalz00_1663)))->BgL_valuez00);
																((((BgL_sfunz00_bglt)
																			COBJECT(((BgL_sfunz00_bglt)
																					BgL_arg1466z00_1706)))->BgL_locz00) =
																	((obj_t) BgL_defzd2loczd2_1664), BUNSPEC);
															}
															BGl_leavezd2functionzd2zztools_errorz00();
														}
													else
														{	/* Ast/glo_def.scm 103 */
															BFALSE;
														}
												}
												return BgL_globalz00_1663;
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}

	}



/* &def-global-sfun! */
	BgL_globalz00_bglt BGl_z62defzd2globalzd2sfunz12z70zzast_glozd2defzd2(obj_t
		BgL_envz00_2315, obj_t BgL_idz00_2316, obj_t BgL_argsz00_2317,
		obj_t BgL_localsz00_2318, obj_t BgL_modulez00_2319, obj_t BgL_classz00_2320,
		obj_t BgL_srczd2expzd2_2321, obj_t BgL_remz00_2322, obj_t BgL_nodez00_2323)
	{
		{	/* Ast/glo_def.scm 80 */
			return
				BGl_defzd2globalzd2sfunz12z12zzast_glozd2defzd2(BgL_idz00_2316,
				BgL_argsz00_2317, BgL_localsz00_2318, BgL_modulez00_2319,
				BgL_classz00_2320, BgL_srczd2expzd2_2321, BgL_remz00_2322,
				BgL_nodez00_2323);
		}

	}



/* check-sfun-definition */
	BgL_globalz00_bglt
		BGl_checkzd2sfunzd2definitionz00zzast_glozd2defzd2(BgL_globalz00_bglt
		BgL_oldz00_19, obj_t BgL_typezd2reszd2_20, obj_t BgL_argsz00_21,
		obj_t BgL_localsz00_22, obj_t BgL_classz00_23, obj_t BgL_srczd2expzd2_24)
	{
		{	/* Ast/glo_def.scm 142 */
			{	/* Ast/glo_def.scm 145 */
				BgL_valuez00_bglt BgL_oldzd2valuezd2_1716;

				BgL_oldzd2valuezd2_1716 =
					(((BgL_variablez00_bglt) COBJECT(
							((BgL_variablez00_bglt) BgL_oldz00_19)))->BgL_valuez00);
				{	/* Ast/glo_def.scm 147 */
					bool_t BgL_test1951z00_2506;

					{	/* Ast/glo_def.scm 147 */
						bool_t BgL_res1861z00_2207;

						BgL_res1861z00_2207 =
							BGl_isazf3zf3zz__objectz00(
							((obj_t) BgL_oldzd2valuezd2_1716), BGl_sfunz00zzast_varz00);
						BgL_test1951z00_2506 = BgL_res1861z00_2207;
					}
					if (BgL_test1951z00_2506)
						{	/* Ast/glo_def.scm 147 */
							if (
								((((BgL_sfunz00_bglt) COBJECT(
												((BgL_sfunz00_bglt) BgL_oldzd2valuezd2_1716)))->
										BgL_classz00) == BgL_classz00_23))
								{	/* Ast/glo_def.scm 154 */
									bool_t BgL_test1953z00_2513;

									{	/* Ast/glo_def.scm 154 */
										long BgL_arg1641z00_1793;
										long BgL_arg1642z00_1794;

										BgL_arg1641z00_1793 =
											(((BgL_funz00_bglt) COBJECT(
													((BgL_funz00_bglt)
														((BgL_sfunz00_bglt) BgL_oldzd2valuezd2_1716))))->
											BgL_arityz00);
										BgL_arg1642z00_1794 =
											BGl_globalzd2arityzd2zztools_argsz00(BgL_argsz00_21);
										BgL_test1953z00_2513 =
											(BgL_arg1641z00_1793 == BgL_arg1642z00_1794);
									}
									if (BgL_test1953z00_2513)
										{	/* Ast/glo_def.scm 156 */
											bool_t BgL_test1954z00_2519;

											{	/* Ast/glo_def.scm 156 */
												bool_t BgL_arg1633z00_1790;
												BgL_typez00_bglt BgL_arg1636z00_1791;

												BgL_arg1633z00_1790 =
													(CNST_TABLE_REF(((long) 3)) == BgL_classz00_23);
												BgL_arg1636z00_1791 =
													(((BgL_variablez00_bglt) COBJECT(
															((BgL_variablez00_bglt) BgL_oldz00_19)))->
													BgL_typez00);
												BgL_test1954z00_2519 =
													BGl_compatiblezd2typezf3z21zzast_glozd2defzd2
													(BgL_arg1633z00_1790,
													((BgL_typez00_bglt) BgL_typezd2reszd2_20),
													BgL_arg1636z00_1791);
											}
											if (BgL_test1954z00_2519)
												{	/* Ast/glo_def.scm 156 */
													if (BGl_dssslzd2prototypezf3z21zztools_dssslz00
														(BgL_argsz00_21))
														{	/* Ast/glo_def.scm 162 */
															if (BGl_dssslzd2optionalzd2onlyzd2prototypezf3z21zztools_dssslz00(BgL_argsz00_21))
																{	/* Ast/glo_def.scm 165 */
																	bool_t BgL_test1957z00_2530;

																	{	/* Ast/glo_def.scm 165 */
																		obj_t BgL_arg1531z00_1732;
																		obj_t BgL_arg1540z00_1733;

																		BgL_arg1531z00_1732 =
																			BGl_dssslzd2optionalszd2zztools_dssslz00
																			(BgL_argsz00_21);
																		BgL_arg1540z00_1733 =
																			(((BgL_sfunz00_bglt)
																				COBJECT(((BgL_sfunz00_bglt)
																						BgL_oldzd2valuezd2_1716)))->
																			BgL_optionalsz00);
																		BgL_test1957z00_2530 =
																			BGl_equalzf3zf3zz__r4_equivalence_6_2z00
																			(BgL_arg1531z00_1732,
																			BgL_arg1540z00_1733);
																	}
																	if (BgL_test1957z00_2530)
																		{	/* Ast/glo_def.scm 165 */
																			((obj_t) BgL_oldz00_19);
																		}
																	else
																		{	/* Ast/glo_def.scm 167 */
																			obj_t BgL_list1530z00_1731;

																			BgL_list1530z00_1731 =
																				MAKE_YOUNG_PAIR
																				(BGl_string1893z00zzast_glozd2defzd2,
																				BNIL);
																			((obj_t)
																				BGl_mismatchzd2errorzd2zzast_glozd2defzd2
																				(BgL_oldz00_19, BgL_srczd2expzd2_24,
																					BgL_list1530z00_1731));
																		}
																}
															else
																{	/* Ast/glo_def.scm 164 */
																	if (BGl_dssslzd2keyzd2onlyzd2prototypezf3z21zztools_dssslz00(BgL_argsz00_21))
																		{	/* Ast/glo_def.scm 171 */
																			bool_t BgL_test1959z00_2541;

																			{	/* Ast/glo_def.scm 171 */
																				obj_t BgL_arg1547z00_1739;
																				obj_t BgL_arg1548z00_1740;

																				BgL_arg1547z00_1739 =
																					BGl_dssslzd2keyszd2zztools_dssslz00
																					(BgL_argsz00_21);
																				BgL_arg1548z00_1740 =
																					(((BgL_sfunz00_bglt)
																						COBJECT(((BgL_sfunz00_bglt)
																								BgL_oldzd2valuezd2_1716)))->
																					BgL_keysz00);
																				BgL_test1959z00_2541 =
																					BGl_equalzf3zf3zz__r4_equivalence_6_2z00
																					(BgL_arg1547z00_1739,
																					BgL_arg1548z00_1740);
																			}
																			if (BgL_test1959z00_2541)
																				{	/* Ast/glo_def.scm 171 */
																					((obj_t) BgL_oldz00_19);
																				}
																			else
																				{	/* Ast/glo_def.scm 173 */
																					obj_t BgL_list1546z00_1738;

																					BgL_list1546z00_1738 =
																						MAKE_YOUNG_PAIR
																						(BGl_string1894z00zzast_glozd2defzd2,
																						BNIL);
																					((obj_t)
																						BGl_mismatchzd2errorzd2zzast_glozd2defzd2
																						(BgL_oldz00_19, BgL_srczd2expzd2_24,
																							BgL_list1546z00_1738));
																				}
																		}
																	else
																		{	/* Ast/glo_def.scm 176 */
																			bool_t BgL_test1960z00_2550;

																			{	/* Ast/glo_def.scm 176 */
																				obj_t BgL_arg1565z00_1745;
																				obj_t BgL_arg1566z00_1746;

																				BgL_arg1565z00_1745 =
																					(((BgL_sfunz00_bglt) COBJECT(
																							((BgL_sfunz00_bglt)
																								BgL_oldzd2valuezd2_1716)))->
																					BgL_dssslzd2keywordszd2);
																				BgL_arg1566z00_1746 =
																					BGl_dssslzd2formalszd2zztools_dssslz00
																					(BgL_argsz00_21);
																				BgL_test1960z00_2550 =
																					BGl_equalzf3zf3zz__r4_equivalence_6_2z00
																					(BgL_arg1565z00_1745,
																					BgL_arg1566z00_1746);
																			}
																			if (BgL_test1960z00_2550)
																				{	/* Ast/glo_def.scm 176 */
																					BFALSE;
																				}
																			else
																				{	/* Ast/glo_def.scm 178 */
																					obj_t BgL_list1564z00_1744;

																					BgL_list1564z00_1744 =
																						MAKE_YOUNG_PAIR
																						(BGl_string1895z00zzast_glozd2defzd2,
																						BNIL);
																					((obj_t)
																						BGl_mismatchzd2errorzd2zzast_glozd2defzd2
																						(BgL_oldz00_19, BgL_srczd2expzd2_24,
																							BgL_list1564z00_1744));
																				}
																		}
																}
														}
													else
														{	/* Ast/glo_def.scm 180 */
															obj_t BgL_g1108z00_1747;

															{	/* Ast/glo_def.scm 181 */
																obj_t BgL_l1306z00_1773;

																BgL_l1306z00_1773 =
																	(((BgL_sfunz00_bglt) COBJECT(
																			((BgL_sfunz00_bglt)
																				BgL_oldzd2valuezd2_1716)))->
																	BgL_argsz00);
																if (NULLP(BgL_l1306z00_1773))
																	{	/* Ast/glo_def.scm 181 */
																		BgL_g1108z00_1747 = BNIL;
																	}
																else
																	{	/* Ast/glo_def.scm 181 */
																		obj_t BgL_head1308z00_1775;

																		{	/* Ast/glo_def.scm 181 */
																			obj_t BgL_res1864z00_2219;

																			BgL_res1864z00_2219 =
																				MAKE_YOUNG_PAIR(BNIL, BNIL);
																			BgL_head1308z00_1775 =
																				BgL_res1864z00_2219;
																		}
																		{
																			obj_t BgL_l1306z00_1777;
																			obj_t BgL_tail1309z00_1778;

																			BgL_l1306z00_1777 = BgL_l1306z00_1773;
																			BgL_tail1309z00_1778 =
																				BgL_head1308z00_1775;
																		BgL_zc3z04anonymousza31616ze3z87_1779:
																			if (NULLP(BgL_l1306z00_1777))
																				{	/* Ast/glo_def.scm 181 */
																					BgL_g1108z00_1747 =
																						CDR(BgL_head1308z00_1775);
																				}
																			else
																				{	/* Ast/glo_def.scm 181 */
																					obj_t BgL_newtail1310z00_1781;

																					{	/* Ast/glo_def.scm 181 */
																						obj_t BgL_arg1626z00_1783;

																						{	/* Ast/glo_def.scm 181 */
																							obj_t BgL_az00_1784;

																							BgL_az00_1784 =
																								CAR(
																								((obj_t) BgL_l1306z00_1777));
																							if (BGl_isazf3zf3zz__objectz00
																								(BgL_az00_1784,
																									BGl_localz00zzast_varz00))
																								{	/* Ast/glo_def.scm 183 */
																									BgL_arg1626z00_1783 =
																										((obj_t)
																										(((BgL_variablez00_bglt)
																												COBJECT((
																														(BgL_variablez00_bglt)
																														((BgL_localz00_bglt)
																															BgL_az00_1784))))->
																											BgL_typez00));
																								}
																							else
																								{	/* Ast/glo_def.scm 183 */
																									if (BGl_isazf3zf3zz__objectz00
																										(BgL_az00_1784,
																											BGl_typez00zztype_typez00))
																										{	/* Ast/glo_def.scm 185 */
																											BgL_arg1626z00_1783 =
																												BgL_az00_1784;
																										}
																									else
																										{	/* Ast/glo_def.scm 185 */
																											BgL_arg1626z00_1783 =
																												BGl_internalzd2errorzd2zztools_errorz00
																												(BGl_string1891z00zzast_glozd2defzd2,
																												BGl_string1892z00zzast_glozd2defzd2,
																												BGl_shapez00zztools_shapez00
																												(BgL_az00_1784));
																										}
																								}
																						}
																						{	/* Ast/glo_def.scm 181 */
																							obj_t BgL_res1868z00_2226;

																							BgL_res1868z00_2226 =
																								MAKE_YOUNG_PAIR
																								(BgL_arg1626z00_1783, BNIL);
																							BgL_newtail1310z00_1781 =
																								BgL_res1868z00_2226;
																						}
																					}
																					SET_CDR(BgL_tail1309z00_1778,
																						BgL_newtail1310z00_1781);
																					{	/* Ast/glo_def.scm 181 */
																						obj_t BgL_arg1622z00_1782;

																						BgL_arg1622z00_1782 =
																							CDR(((obj_t) BgL_l1306z00_1777));
																						{
																							obj_t BgL_tail1309z00_2583;
																							obj_t BgL_l1306z00_2582;

																							BgL_l1306z00_2582 =
																								BgL_arg1622z00_1782;
																							BgL_tail1309z00_2583 =
																								BgL_newtail1310z00_1781;
																							BgL_tail1309z00_1778 =
																								BgL_tail1309z00_2583;
																							BgL_l1306z00_1777 =
																								BgL_l1306z00_2582;
																							goto
																								BgL_zc3z04anonymousza31616ze3z87_1779;
																						}
																					}
																				}
																		}
																	}
															}
															{
																obj_t BgL_localsz00_1749;
																obj_t BgL_typesz00_1750;

																BgL_localsz00_1749 = BgL_localsz00_22;
																BgL_typesz00_1750 = BgL_g1108z00_1747;
															BgL_zc3z04anonymousza31567ze3z87_1751:
																if (NULLP(BgL_localsz00_1749))
																	{	/* Ast/glo_def.scm 193 */
																		if (NULLP(BgL_typesz00_1750))
																			{	/* Ast/glo_def.scm 196 */
																				((((BgL_globalz00_bglt)
																							COBJECT(BgL_oldz00_19))->
																						BgL_srcz00) =
																					((obj_t) BgL_srczd2expzd2_24),
																					BUNSPEC);
																			}
																		else
																			{	/* Ast/glo_def.scm 198 */
																				obj_t BgL_list1570z00_1754;

																				BgL_list1570z00_1754 =
																					MAKE_YOUNG_PAIR
																					(BGl_string1896z00zzast_glozd2defzd2,
																					BNIL);
																				((obj_t)
																					BGl_mismatchzd2errorzd2zzast_glozd2defzd2
																					(BgL_oldz00_19, BgL_srczd2expzd2_24,
																						BgL_list1570z00_1754));
																			}
																	}
																else
																	{	/* Ast/glo_def.scm 199 */
																		bool_t BgL_test1967z00_2592;

																		if (NULLP(BgL_typesz00_1750))
																			{	/* Ast/glo_def.scm 199 */
																				BgL_test1967z00_2592 = ((bool_t) 1);
																			}
																		else
																			{	/* Ast/glo_def.scm 200 */
																				bool_t BgL_test1969z00_2595;

																				{	/* Ast/glo_def.scm 201 */
																					BgL_typez00_bglt BgL_arg1608z00_1769;
																					obj_t BgL_arg1610z00_1770;

																					BgL_arg1608z00_1769 =
																						(((BgL_variablez00_bglt) COBJECT(
																								((BgL_variablez00_bglt)
																									((BgL_localz00_bglt)
																										CAR(
																											((obj_t)
																												BgL_localsz00_1749))))))->
																						BgL_typez00);
																					BgL_arg1610z00_1770 =
																						CAR(((obj_t) BgL_typesz00_1750));
																					BgL_test1969z00_2595 =
																						BGl_compatiblezd2typezf3z21zzast_glozd2defzd2
																						(((bool_t) 0), BgL_arg1608z00_1769,
																						((BgL_typez00_bglt)
																							BgL_arg1610z00_1770));
																				}
																				if (BgL_test1969z00_2595)
																					{	/* Ast/glo_def.scm 200 */
																						BgL_test1967z00_2592 = ((bool_t) 0);
																					}
																				else
																					{	/* Ast/glo_def.scm 200 */
																						BgL_test1967z00_2592 = ((bool_t) 1);
																					}
																			}
																		if (BgL_test1967z00_2592)
																			{	/* Ast/glo_def.scm 203 */
																				obj_t BgL_list1596z00_1764;

																				BgL_list1596z00_1764 =
																					MAKE_YOUNG_PAIR
																					(BGl_string1897z00zzast_glozd2defzd2,
																					BNIL);
																				((obj_t)
																					BGl_mismatchzd2errorzd2zzast_glozd2defzd2
																					(BgL_oldz00_19, BgL_srczd2expzd2_24,
																						BgL_list1596z00_1764));
																			}
																		else
																			{	/* Ast/glo_def.scm 205 */
																				obj_t BgL_arg1599z00_1765;
																				obj_t BgL_arg1600z00_1766;

																				BgL_arg1599z00_1765 =
																					CDR(((obj_t) BgL_localsz00_1749));
																				BgL_arg1600z00_1766 =
																					CDR(((obj_t) BgL_typesz00_1750));
																				{
																					obj_t BgL_typesz00_2613;
																					obj_t BgL_localsz00_2612;

																					BgL_localsz00_2612 =
																						BgL_arg1599z00_1765;
																					BgL_typesz00_2613 =
																						BgL_arg1600z00_1766;
																					BgL_typesz00_1750 = BgL_typesz00_2613;
																					BgL_localsz00_1749 =
																						BgL_localsz00_2612;
																					goto
																						BgL_zc3z04anonymousza31567ze3z87_1751;
																				}
																			}
																	}
															}
														}
												}
											else
												{	/* Ast/glo_def.scm 159 */
													obj_t BgL_list1632z00_1789;

													BgL_list1632z00_1789 =
														MAKE_YOUNG_PAIR(BGl_string1898z00zzast_glozd2defzd2,
														BNIL);
													((obj_t)
														BGl_mismatchzd2errorzd2zzast_glozd2defzd2
														(BgL_oldz00_19, BgL_srczd2expzd2_24,
															BgL_list1632z00_1789));
												}
										}
									else
										{	/* Ast/glo_def.scm 155 */
											obj_t BgL_list1637z00_1792;

											BgL_list1637z00_1792 =
												MAKE_YOUNG_PAIR(BGl_string1896z00zzast_glozd2defzd2,
												BNIL);
											((obj_t)
												BGl_mismatchzd2errorzd2zzast_glozd2defzd2(BgL_oldz00_19,
													BgL_srczd2expzd2_24, BgL_list1637z00_1792));
										}
								}
							else
								{	/* Ast/glo_def.scm 153 */
									obj_t BgL_arg1645z00_1795;

									{	/* Ast/glo_def.scm 153 */
										obj_t BgL_arg1648z00_1797;

										BgL_arg1648z00_1797 =
											(((BgL_sfunz00_bglt) COBJECT(
													((BgL_sfunz00_bglt) BgL_oldzd2valuezd2_1716)))->
											BgL_classz00);
										{	/* Ast/glo_def.scm 152 */
											obj_t BgL_list1649z00_1798;

											{	/* Ast/glo_def.scm 152 */
												obj_t BgL_arg1651z00_1799;

												BgL_arg1651z00_1799 =
													MAKE_YOUNG_PAIR(BgL_classz00_23, BNIL);
												BgL_list1649z00_1798 =
													MAKE_YOUNG_PAIR(BgL_arg1648z00_1797,
													BgL_arg1651z00_1799);
											}
											BgL_arg1645z00_1795 =
												BGl_formatz00zz__r4_output_6_10_3z00
												(BGl_string1899z00zzast_glozd2defzd2,
												BgL_list1649z00_1798);
										}
									}
									{	/* Ast/glo_def.scm 151 */
										obj_t BgL_list1646z00_1796;

										BgL_list1646z00_1796 =
											MAKE_YOUNG_PAIR(BgL_arg1645z00_1795, BNIL);
										((obj_t)
											BGl_mismatchzd2errorzd2zzast_glozd2defzd2(BgL_oldz00_19,
												BgL_srczd2expzd2_24, BgL_list1646z00_1796));
									}
								}
						}
					else
						{	/* Ast/glo_def.scm 148 */
							obj_t BgL_list1655z00_1801;

							BgL_list1655z00_1801 =
								MAKE_YOUNG_PAIR(BGl_string1900z00zzast_glozd2defzd2, BNIL);
							((obj_t)
								BGl_mismatchzd2errorzd2zzast_glozd2defzd2(BgL_oldz00_19,
									BgL_srczd2expzd2_24, BgL_list1655z00_1801));
						}
				}
				return BgL_oldz00_19;
			}
		}

	}



/* def-global-scnst! */
	BGL_EXPORTED_DEF BgL_globalz00_bglt
		BGl_defzd2globalzd2scnstz12z12zzast_glozd2defzd2(obj_t BgL_idz00_25,
		obj_t BgL_modulez00_26, obj_t BgL_nodez00_27, obj_t BgL_classz00_28,
		obj_t BgL_locz00_29)
	{
		{	/* Ast/glo_def.scm 211 */
			BGl_enterzd2functionzd2zztools_errorz00(BgL_idz00_25);
			{	/* Ast/glo_def.scm 213 */
				obj_t BgL_idzd2typezd2_2239;

				BgL_idzd2typezd2_2239 =
					BGl_parsezd2idzd2zzast_identz00(BgL_idz00_25, BgL_locz00_29);
				{	/* Ast/glo_def.scm 213 */
					obj_t BgL_idzd2idzd2_2240;

					BgL_idzd2idzd2_2240 = CAR(BgL_idzd2typezd2_2239);
					{	/* Ast/glo_def.scm 214 */
						obj_t BgL_oldzd2globalzd2_2241;

						BgL_oldzd2globalzd2_2241 =
							BGl_findzd2globalzf2modulez20zzast_envz00(BgL_idzd2idzd2_2240,
							BgL_modulez00_26);
						{	/* Ast/glo_def.scm 215 */
							BgL_globalz00_bglt BgL_globalz00_2242;

							BgL_globalz00_2242 =
								BGl_declarezd2globalzd2scnstz12z12zzast_glozd2declzd2
								(BgL_idz00_25, BFALSE, BgL_modulez00_26,
								CNST_TABLE_REF(((long) 2)), BgL_nodez00_27, BgL_classz00_28,
								BgL_locz00_29);
							{	/* Ast/glo_def.scm 216 */

								BGl_removezd2varzd2fromz12z12zzast_removez00(CNST_TABLE_REF((
											(long) 4)), ((BgL_variablez00_bglt) BgL_globalz00_2242));
								BGl_leavezd2functionzd2zztools_errorz00();
								return BgL_globalz00_2242;
							}
						}
					}
				}
			}
		}

	}



/* &def-global-scnst! */
	BgL_globalz00_bglt BGl_z62defzd2globalzd2scnstz12z70zzast_glozd2defzd2(obj_t
		BgL_envz00_2324, obj_t BgL_idz00_2325, obj_t BgL_modulez00_2326,
		obj_t BgL_nodez00_2327, obj_t BgL_classz00_2328, obj_t BgL_locz00_2329)
	{
		{	/* Ast/glo_def.scm 211 */
			return
				BGl_defzd2globalzd2scnstz12z12zzast_glozd2defzd2(BgL_idz00_2325,
				BgL_modulez00_2326, BgL_nodez00_2327, BgL_classz00_2328,
				BgL_locz00_2329);
		}

	}



/* def-global-svar! */
	BGL_EXPORTED_DEF BgL_globalz00_bglt
		BGl_defzd2globalzd2svarz12z12zzast_glozd2defzd2(obj_t BgL_idz00_30,
		obj_t BgL_modulez00_31, obj_t BgL_srczd2expzd2_32, obj_t BgL_remz00_33)
	{
		{	/* Ast/glo_def.scm 227 */
			{	/* Ast/glo_def.scm 228 */
				obj_t BgL_locz00_1806;

				BgL_locz00_1806 =
					BGl_findzd2locationzd2zztools_locationz00(BgL_srczd2expzd2_32);
				{	/* Ast/glo_def.scm 228 */
					obj_t BgL_idzd2typezd2_1807;

					BgL_idzd2typezd2_1807 =
						BGl_parsezd2idzd2zzast_identz00(BgL_idz00_30, BgL_locz00_1806);
					{	/* Ast/glo_def.scm 229 */
						obj_t BgL_idzd2idzd2_1808;

						BgL_idzd2idzd2_1808 = CAR(BgL_idzd2typezd2_1807);
						{	/* Ast/glo_def.scm 230 */
							obj_t BgL_oldzd2globalzd2_1809;

							BgL_oldzd2globalzd2_1809 =
								BGl_findzd2globalzf2modulez20zzast_envz00(BgL_idzd2idzd2_1808,
								BgL_modulez00_31);
							{	/* Ast/glo_def.scm 231 */
								obj_t BgL_importz00_1810;

								{	/* Ast/glo_def.scm 232 */
									bool_t BgL_test1970z00_2646;

									if (
										((long) CINT(BGl_za2bdbzd2debugza2zd2zzengine_paramz00) >=
											((long) 3)))
										{	/* Ast/glo_def.scm 233 */
											obj_t BgL_arg1677z00_1830;

											{	/* Ast/glo_def.scm 233 */
												obj_t BgL_arg1679z00_1831;

												BgL_arg1679z00_1831 =
													BGl_thezd2backendzd2zzbackend_backendz00();
												BgL_arg1677z00_1830 =
													(((BgL_backendz00_bglt) COBJECT(
															((BgL_backendz00_bglt) BgL_arg1679z00_1831)))->
													BgL_debugzd2supportzd2);
											}
											BgL_test1970z00_2646 =
												CBOOL(BGl_memqz00zz__r4_pairs_and_lists_6_3z00
												(CNST_TABLE_REF(((long) 0)), BgL_arg1677z00_1830));
										}
									else
										{	/* Ast/glo_def.scm 232 */
											BgL_test1970z00_2646 = ((bool_t) 0);
										}
									if (BgL_test1970z00_2646)
										{	/* Ast/glo_def.scm 232 */
											BgL_importz00_1810 = CNST_TABLE_REF(((long) 1));
										}
									else
										{	/* Ast/glo_def.scm 232 */
											BgL_importz00_1810 = CNST_TABLE_REF(((long) 2));
								}}
								{	/* Ast/glo_def.scm 232 */
									obj_t BgL_typez00_1811;

									{	/* Ast/glo_def.scm 236 */
										obj_t BgL_typez00_1819;

										BgL_typez00_1819 = CDR(BgL_idzd2typezd2_1807);
										if (
											((((BgL_typez00_bglt) COBJECT(
															((BgL_typez00_bglt) BgL_typez00_1819)))->
													BgL_classz00) == CNST_TABLE_REF(((long) 5))))
											{	/* Ast/glo_def.scm 239 */
												BgL_typez00_1811 = BgL_typez00_1819;
											}
										else
											{	/* Ast/glo_def.scm 239 */
												BgL_typez00_1811 =
													BGl_userzd2errorzd2zztools_errorz00
													(BgL_idzd2idzd2_1808,
													BGl_string1901z00zzast_glozd2defzd2,
													BGl_shapez00zztools_shapez00(BgL_typez00_1819), BNIL);
											}
									}
									{	/* Ast/glo_def.scm 236 */
										BgL_globalz00_bglt BgL_globalz00_1812;

										if (BGl_isazf3zf3zz__objectz00(BgL_oldzd2globalzd2_1809,
												BGl_globalz00zzast_varz00))
											{	/* Ast/glo_def.scm 245 */
												BgL_globalz00_1812 =
													BGl_checkzd2svarzd2definitionz00zzast_glozd2defzd2(
													((BgL_globalz00_bglt) BgL_oldzd2globalzd2_1809),
													BgL_typez00_1811, BgL_srczd2expzd2_32);
											}
										else
											{	/* Ast/glo_def.scm 245 */
												BgL_globalz00_1812 =
													BGl_declarezd2globalzd2svarz12z12zzast_glozd2declzd2
													(BgL_idz00_30, BFALSE, BgL_modulez00_31,
													BgL_importz00_1810, BgL_srczd2expzd2_32, BFALSE);
											}
										{	/* Ast/glo_def.scm 244 */
											obj_t BgL_defzd2loczd2_1813;

											BgL_defzd2loczd2_1813 =
												BGl_findzd2locationzd2zztools_locationz00
												(BgL_srczd2expzd2_32);
											{	/* Ast/glo_def.scm 250 */

												{	/* Ast/glo_def.scm 300 */
													BgL_typez00_bglt BgL_oldzd2typezd2_2255;

													BgL_oldzd2typezd2_2255 =
														(((BgL_variablez00_bglt) COBJECT(
																((BgL_variablez00_bglt) BgL_globalz00_1812)))->
														BgL_typez00);
													if ((((obj_t) BgL_oldzd2typezd2_2255) ==
															BGl_za2_za2z00zztype_cachez00))
														{	/* Ast/glo_def.scm 301 */
															((((BgL_variablez00_bglt) COBJECT(
																			((BgL_variablez00_bglt)
																				BgL_globalz00_1812)))->BgL_typez00) =
																((BgL_typez00_bglt) ((BgL_typez00_bglt)
																		BgL_typez00_1811)), BUNSPEC);
														}
													else
														{	/* Ast/glo_def.scm 301 */
															BFALSE;
														}
												}
												{	/* Ast/glo_def.scm 254 */
													bool_t BgL_test1975z00_2680;

													{	/* Ast/glo_def.scm 254 */
														BgL_valuez00_bglt BgL_arg1661z00_1817;

														BgL_arg1661z00_1817 =
															(((BgL_variablez00_bglt) COBJECT(
																	((BgL_variablez00_bglt)
																		BgL_globalz00_1812)))->BgL_valuez00);
														{	/* Ast/glo_def.scm 254 */
															bool_t BgL_res1875z00_2261;

															BgL_res1875z00_2261 =
																BGl_isazf3zf3zz__objectz00(
																((obj_t) BgL_arg1661z00_1817),
																BGl_svarz00zzast_varz00);
															BgL_test1975z00_2680 = BgL_res1875z00_2261;
														}
													}
													if (BgL_test1975z00_2680)
														{	/* Ast/glo_def.scm 256 */
															BgL_valuez00_bglt BgL_arg1660z00_1816;

															BgL_arg1660z00_1816 =
																(((BgL_variablez00_bglt) COBJECT(
																		((BgL_variablez00_bglt)
																			BgL_globalz00_1812)))->BgL_valuez00);
															((((BgL_svarz00_bglt) COBJECT(((BgL_svarz00_bglt)
																				BgL_arg1660z00_1816)))->BgL_locz00) =
																((obj_t) BgL_defzd2loczd2_1813), BUNSPEC);
														}
													else
														{	/* Ast/glo_def.scm 254 */
															BFALSE;
														}
												}
												BGl_removezd2varzd2fromz12z12zzast_removez00
													(BgL_remz00_33,
													((BgL_variablez00_bglt) BgL_globalz00_1812));
												return BgL_globalz00_1812;
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}

	}



/* &def-global-svar! */
	BgL_globalz00_bglt BGl_z62defzd2globalzd2svarz12z70zzast_glozd2defzd2(obj_t
		BgL_envz00_2330, obj_t BgL_idz00_2331, obj_t BgL_modulez00_2332,
		obj_t BgL_srczd2expzd2_2333, obj_t BgL_remz00_2334)
	{
		{	/* Ast/glo_def.scm 227 */
			return
				BGl_defzd2globalzd2svarz12z12zzast_glozd2defzd2(BgL_idz00_2331,
				BgL_modulez00_2332, BgL_srczd2expzd2_2333, BgL_remz00_2334);
		}

	}



/* check-svar-definition */
	BgL_globalz00_bglt
		BGl_checkzd2svarzd2definitionz00zzast_glozd2defzd2(BgL_globalz00_bglt
		BgL_oldz00_34, obj_t BgL_typez00_35, obj_t BgL_srczd2expzd2_36)
	{
		{	/* Ast/glo_def.scm 264 */
			{	/* Ast/glo_def.scm 265 */
				BgL_valuez00_bglt BgL_oldzd2valuezd2_1832;

				BgL_oldzd2valuezd2_1832 =
					(((BgL_variablez00_bglt) COBJECT(
							((BgL_variablez00_bglt) BgL_oldz00_34)))->BgL_valuez00);
				{	/* Ast/glo_def.scm 267 */
					bool_t BgL_test1976z00_2694;

					{	/* Ast/glo_def.scm 267 */
						bool_t BgL_res1876z00_2265;

						BgL_res1876z00_2265 =
							BGl_isazf3zf3zz__objectz00(
							((obj_t) BgL_oldzd2valuezd2_1832), BGl_svarz00zzast_varz00);
						BgL_test1976z00_2694 = BgL_res1876z00_2265;
					}
					if (BgL_test1976z00_2694)
						{	/* Ast/glo_def.scm 269 */
							bool_t BgL_test1977z00_2697;

							{	/* Ast/glo_def.scm 269 */
								BgL_typez00_bglt BgL_arg1689z00_1837;

								BgL_arg1689z00_1837 =
									(((BgL_variablez00_bglt) COBJECT(
											((BgL_variablez00_bglt) BgL_oldz00_34)))->BgL_typez00);
								BgL_test1977z00_2697 =
									BGl_compatiblezd2typezf3z21zzast_glozd2defzd2(((bool_t) 0),
									((BgL_typez00_bglt) BgL_typez00_35), BgL_arg1689z00_1837);
							}
							if (BgL_test1977z00_2697)
								{	/* Ast/glo_def.scm 269 */
									return BgL_oldz00_34;
								}
							else
								{	/* Ast/glo_def.scm 270 */
									obj_t BgL_list1684z00_1836;

									BgL_list1684z00_1836 =
										MAKE_YOUNG_PAIR(BGl_string1902z00zzast_glozd2defzd2, BNIL);
									return
										BGl_mismatchzd2errorzd2zzast_glozd2defzd2(BgL_oldz00_34,
										BgL_srczd2expzd2_36, BgL_list1684z00_1836);
								}
						}
					else
						{	/* Ast/glo_def.scm 268 */
							obj_t BgL_list1690z00_1838;

							BgL_list1690z00_1838 =
								MAKE_YOUNG_PAIR(BGl_string1903z00zzast_glozd2defzd2, BNIL);
							return
								BGl_mismatchzd2errorzd2zzast_glozd2defzd2(BgL_oldz00_34,
								BgL_srczd2expzd2_36, BgL_list1690z00_1838);
						}
				}
			}
		}

	}



/* compatible-type? */
	bool_t BGl_compatiblezd2typezf3z21zzast_glozd2defzd2(bool_t BgL_subzf3zf3_37,
		BgL_typez00_bglt BgL_newz00_38, BgL_typez00_bglt BgL_oldz00_39)
	{
		{	/* Ast/glo_def.scm 277 */
			{	/* Ast/glo_def.scm 278 */
				bool_t BgL__ortest_1109z00_1839;

				BgL__ortest_1109z00_1839 =
					(((obj_t) BgL_newz00_38) == BGl_za2_za2z00zztype_cachez00);
				if (BgL__ortest_1109z00_1839)
					{	/* Ast/glo_def.scm 278 */
						return BgL__ortest_1109z00_1839;
					}
				else
					{	/* Ast/glo_def.scm 279 */
						bool_t BgL__ortest_1110z00_1840;

						BgL__ortest_1110z00_1840 =
							(((obj_t) BgL_oldz00_39) == ((obj_t) BgL_newz00_38));
						if (BgL__ortest_1110z00_1840)
							{	/* Ast/glo_def.scm 279 */
								return BgL__ortest_1110z00_1840;
							}
						else
							{	/* Ast/glo_def.scm 279 */
								if (BgL_subzf3zf3_37)
									{	/* Ast/glo_def.scm 281 */
										bool_t BgL__ortest_1112z00_1842;

										BgL__ortest_1112z00_1842 =
											BGl_typezd2subclasszf3z21zzobject_classz00(BgL_newz00_38,
											BgL_oldz00_39);
										if (BgL__ortest_1112z00_1842)
											{	/* Ast/glo_def.scm 281 */
												return BgL__ortest_1112z00_1842;
											}
										else
											{	/* Ast/glo_def.scm 282 */
												bool_t BgL_test1982z00_2716;

												{	/* Ast/glo_def.scm 282 */
													bool_t BgL_res1877z00_2267;

													BgL_res1877z00_2267 =
														BGl_isazf3zf3zz__objectz00(
														((obj_t) BgL_newz00_38),
														BGl_tclassz00zzobject_classz00);
													BgL_test1982z00_2716 = BgL_res1877z00_2267;
												}
												if (BgL_test1982z00_2716)
													{	/* Ast/glo_def.scm 282 */
														return
															(
															((obj_t) BgL_oldz00_39) ==
															BGl_za2objza2z00zztype_cachez00);
													}
												else
													{	/* Ast/glo_def.scm 282 */
														return ((bool_t) 0);
													}
											}
									}
								else
									{	/* Ast/glo_def.scm 280 */
										return ((bool_t) 0);
									}
							}
					}
			}
		}

	}



/* mismatch-error */
	BgL_globalz00_bglt
		BGl_mismatchzd2errorzd2zzast_glozd2defzd2(BgL_globalz00_bglt
		BgL_globalz00_40, obj_t BgL_srczd2expzd2_41, obj_t BgL_addzd2msgzd2_42)
	{
		{	/* Ast/glo_def.scm 287 */
			{	/* Ast/glo_def.scm 289 */
				obj_t BgL_arg1692z00_1845;
				obj_t BgL_arg1693z00_1846;

				if (PAIRP(BgL_addzd2msgzd2_42))
					{	/* Ast/glo_def.scm 289 */
						BgL_arg1692z00_1845 =
							string_append_3(BGl_string1904z00zzast_glozd2defzd2,
							BGl_string1905z00zzast_glozd2defzd2, CAR(BgL_addzd2msgzd2_42));
					}
				else
					{	/* Ast/glo_def.scm 289 */
						BgL_arg1692z00_1845 = BGl_string1904z00zzast_glozd2defzd2;
					}
				BgL_arg1693z00_1846 =
					BGl_shapez00zztools_shapez00(
					(((BgL_globalz00_bglt) COBJECT(BgL_globalz00_40))->BgL_srcz00));
				{	/* Ast/glo_def.scm 289 */
					obj_t BgL_list1694z00_1847;

					BgL_list1694z00_1847 =
						MAKE_YOUNG_PAIR(((obj_t) BgL_globalz00_40), BNIL);
					return
						((BgL_globalz00_bglt)
						BGl_userzd2errorzd2zztools_errorz00(BgL_arg1692z00_1845,
							BgL_arg1693z00_1846, BgL_srczd2expzd2_41, BgL_list1694z00_1847));
				}
			}
		}

	}



/* check-method-definition */
	BGL_EXPORTED_DEF bool_t
		BGl_checkzd2methodzd2definitionz00zzast_glozd2defzd2(obj_t BgL_idz00_45,
		obj_t BgL_argsz00_46, obj_t BgL_localsz00_47, obj_t BgL_srcz00_48)
	{
		{	/* Ast/glo_def.scm 307 */
			{	/* Ast/glo_def.scm 308 */
				obj_t BgL_locz00_1853;

				BgL_locz00_1853 =
					BGl_findzd2locationzd2zztools_locationz00(BgL_srcz00_48);
				{	/* Ast/glo_def.scm 308 */
					BgL_typez00_bglt BgL_typezd2reszd2_1854;

					BgL_typezd2reszd2_1854 =
						BGl_typezd2ofzd2idz00zzast_identz00(BgL_idz00_45, BgL_locz00_1853);
					{	/* Ast/glo_def.scm 309 */
						obj_t BgL_methodzd2idzd2_1855;

						BgL_methodzd2idzd2_1855 =
							BGl_idzd2ofzd2idz00zzast_identz00(BgL_idz00_45, BgL_locz00_1853);
						{	/* Ast/glo_def.scm 310 */
							obj_t BgL_genericz00_1856;

							BgL_genericz00_1856 =
								BGl_findzd2globalzd2zzast_envz00(BgL_idz00_45, BNIL);
							{	/* Ast/glo_def.scm 311 */

								if (NULLP(BgL_argsz00_46))
									{	/* Ast/glo_def.scm 313 */
										BGl_userzd2errorzd2zztools_errorz00(BgL_idz00_45,
											BGl_shapez00zztools_shapez00(BgL_srcz00_48),
											BGl_string1906z00zzast_glozd2defzd2, BNIL);
										return ((bool_t) 1);
									}
								else
									{	/* Ast/glo_def.scm 313 */
										if (BGl_isazf3zf3zz__objectz00(BgL_genericz00_1856,
												BGl_globalz00zzast_varz00))
											{	/* Ast/glo_def.scm 321 */
												BgL_valuez00_bglt BgL_genericzd2valuezd2_1861;

												BgL_genericzd2valuezd2_1861 =
													(((BgL_variablez00_bglt) COBJECT(
															((BgL_variablez00_bglt)
																((BgL_globalz00_bglt) BgL_genericz00_1856))))->
													BgL_valuez00);
												{	/* Ast/glo_def.scm 323 */
													bool_t BgL_test1986z00_2744;

													{	/* Ast/glo_def.scm 323 */
														bool_t BgL_res1881z00_2279;

														BgL_res1881z00_2279 =
															BGl_isazf3zf3zz__objectz00(
															((obj_t) BgL_genericzd2valuezd2_1861),
															BGl_sfunz00zzast_varz00);
														BgL_test1986z00_2744 = BgL_res1881z00_2279;
													}
													if (BgL_test1986z00_2744)
														{	/* Ast/glo_def.scm 323 */
															if (
																((((BgL_sfunz00_bglt) COBJECT(
																				((BgL_sfunz00_bglt)
																					BgL_genericzd2valuezd2_1861)))->
																		BgL_classz00) ==
																	CNST_TABLE_REF(((long) 3))))
																{	/* Ast/glo_def.scm 329 */
																	bool_t BgL_test1988z00_2752;

																	{	/* Ast/glo_def.scm 329 */
																		long BgL_arg1766z00_1910;
																		long BgL_arg1768z00_1911;

																		BgL_arg1766z00_1910 =
																			(((BgL_funz00_bglt) COBJECT(
																					((BgL_funz00_bglt)
																						((BgL_sfunz00_bglt)
																							BgL_genericzd2valuezd2_1861))))->
																			BgL_arityz00);
																		BgL_arg1768z00_1911 =
																			BGl_globalzd2arityzd2zztools_argsz00
																			(BgL_argsz00_46);
																		BgL_test1988z00_2752 =
																			(BgL_arg1766z00_1910 ==
																			BgL_arg1768z00_1911);
																	}
																	if (BgL_test1988z00_2752)
																		{	/* Ast/glo_def.scm 332 */
																			bool_t BgL_test1989z00_2758;

																			{	/* Ast/glo_def.scm 332 */
																				BgL_typez00_bglt BgL_arg1764z00_1908;

																				BgL_arg1764z00_1908 =
																					(((BgL_variablez00_bglt) COBJECT(
																							((BgL_variablez00_bglt)
																								((BgL_globalz00_bglt)
																									BgL_genericz00_1856))))->
																					BgL_typez00);
																				BgL_test1989z00_2758 =
																					BGl_compatiblezd2typezf3z21zzast_glozd2defzd2
																					(((bool_t) 1), BgL_typezd2reszd2_1854,
																					BgL_arg1764z00_1908);
																			}
																			if (BgL_test1989z00_2758)
																				{	/* Ast/glo_def.scm 337 */
																					obj_t BgL__ortest_1114z00_1870;

																					{	/* Ast/glo_def.scm 337 */
																						obj_t BgL_g1115z00_1871;

																						{	/* Ast/glo_def.scm 338 */
																							obj_t BgL_l1311z00_1891;

																							BgL_l1311z00_1891 =
																								(((BgL_sfunz00_bglt) COBJECT(
																										((BgL_sfunz00_bglt)
																											BgL_genericzd2valuezd2_1861)))->
																								BgL_argsz00);
																							if (NULLP(BgL_l1311z00_1891))
																								{	/* Ast/glo_def.scm 338 */
																									BgL_g1115z00_1871 = BNIL;
																								}
																							else
																								{	/* Ast/glo_def.scm 338 */
																									obj_t BgL_head1313z00_1893;

																									{	/* Ast/glo_def.scm 338 */
																										obj_t BgL_res1884z00_2288;

																										BgL_res1884z00_2288 =
																											MAKE_YOUNG_PAIR(BNIL,
																											BNIL);
																										BgL_head1313z00_1893 =
																											BgL_res1884z00_2288;
																									}
																									{
																										obj_t BgL_l1311z00_1895;
																										obj_t BgL_tail1314z00_1896;

																										BgL_l1311z00_1895 =
																											BgL_l1311z00_1891;
																										BgL_tail1314z00_1896 =
																											BgL_head1313z00_1893;
																									BgL_zc3z04anonymousza31756ze3z87_1897:
																										if (NULLP
																											(BgL_l1311z00_1895))
																											{	/* Ast/glo_def.scm 338 */
																												BgL_g1115z00_1871 =
																													CDR
																													(BgL_head1313z00_1893);
																											}
																										else
																											{	/* Ast/glo_def.scm 338 */
																												obj_t
																													BgL_newtail1315z00_1899;
																												{	/* Ast/glo_def.scm 338 */
																													obj_t
																														BgL_arg1759z00_1901;
																													{	/* Ast/glo_def.scm 338 */
																														obj_t BgL_az00_1902;

																														BgL_az00_1902 =
																															CAR(
																															((obj_t)
																																BgL_l1311z00_1895));
																														if (BGl_isazf3zf3zz__objectz00(BgL_az00_1902, BGl_localz00zzast_varz00))
																															{	/* Ast/glo_def.scm 340 */
																																BgL_arg1759z00_1901
																																	=
																																	((obj_t) ((
																																			(BgL_variablez00_bglt)
																																			COBJECT((
																																					(BgL_variablez00_bglt)
																																					((BgL_localz00_bglt) BgL_az00_1902))))->BgL_typez00));
																															}
																														else
																															{	/* Ast/glo_def.scm 340 */
																																if (BGl_isazf3zf3zz__objectz00(BgL_az00_1902, BGl_typez00zztype_typez00))
																																	{	/* Ast/glo_def.scm 342 */
																																		BgL_arg1759z00_1901
																																			=
																																			BgL_az00_1902;
																																	}
																																else
																																	{	/* Ast/glo_def.scm 342 */
																																		BgL_arg1759z00_1901
																																			=
																																			BGl_internalzd2errorzd2zztools_errorz00
																																			(BGl_string1891z00zzast_glozd2defzd2,
																																			BGl_string1892z00zzast_glozd2defzd2,
																																			BGl_shapez00zztools_shapez00
																																			(BgL_az00_1902));
																																	}
																															}
																													}
																													{	/* Ast/glo_def.scm 338 */
																														obj_t
																															BgL_res1888z00_2295;
																														BgL_res1888z00_2295
																															=
																															MAKE_YOUNG_PAIR
																															(BgL_arg1759z00_1901,
																															BNIL);
																														BgL_newtail1315z00_1899
																															=
																															BgL_res1888z00_2295;
																													}
																												}
																												SET_CDR
																													(BgL_tail1314z00_1896,
																													BgL_newtail1315z00_1899);
																												{	/* Ast/glo_def.scm 338 */
																													obj_t
																														BgL_arg1758z00_1900;
																													BgL_arg1758z00_1900 =
																														CDR(((obj_t)
																															BgL_l1311z00_1895));
																													{
																														obj_t
																															BgL_tail1314z00_2788;
																														obj_t
																															BgL_l1311z00_2787;
																														BgL_l1311z00_2787 =
																															BgL_arg1758z00_1900;
																														BgL_tail1314z00_2788
																															=
																															BgL_newtail1315z00_1899;
																														BgL_tail1314z00_1896
																															=
																															BgL_tail1314z00_2788;
																														BgL_l1311z00_1895 =
																															BgL_l1311z00_2787;
																														goto
																															BgL_zc3z04anonymousza31756ze3z87_1897;
																													}
																												}
																											}
																									}
																								}
																						}
																						{
																							obj_t BgL_localsz00_1873;
																							obj_t BgL_typesz00_1874;
																							bool_t BgL_subzf3zf3_1875;

																							BgL_localsz00_1873 =
																								BgL_localsz00_47;
																							BgL_typesz00_1874 =
																								BgL_g1115z00_1871;
																							BgL_subzf3zf3_1875 = ((bool_t) 1);
																						BgL_zc3z04anonymousza31721ze3z87_1876:
																							if (NULLP
																								(BgL_localsz00_1873))
																								{	/* Ast/glo_def.scm 352 */
																									BgL__ortest_1114z00_1870 =
																										BTRUE;
																								}
																							else
																								{	/* Ast/glo_def.scm 352 */
																									if (NULLP(BgL_typesz00_1874))
																										{	/* Ast/glo_def.scm 355 */
																											obj_t
																												BgL_list1724z00_1879;
																											BgL_list1724z00_1879 =
																												MAKE_YOUNG_PAIR
																												(BGl_string1897z00zzast_glozd2defzd2,
																												BNIL);
																											BgL__ortest_1114z00_1870 =
																												((obj_t)
																												BGl_mismatchzd2errorzd2zzast_glozd2defzd2
																												(((BgL_globalz00_bglt)
																														BgL_genericz00_1856),
																													BgL_srcz00_48,
																													BgL_list1724z00_1879));
																										}
																									else
																										{	/* Ast/glo_def.scm 358 */
																											bool_t
																												BgL_test1996z00_2797;
																											{	/* Ast/glo_def.scm 359 */
																												BgL_typez00_bglt
																													BgL_arg1752z00_1887;
																												obj_t
																													BgL_arg1753z00_1888;
																												BgL_arg1752z00_1887 =
																													(((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt) ((BgL_localz00_bglt) CAR(((obj_t) BgL_localsz00_1873))))))->BgL_typez00);
																												BgL_arg1753z00_1888 =
																													CAR(((obj_t)
																														BgL_typesz00_1874));
																												BgL_test1996z00_2797 =
																													BGl_compatiblezd2typezf3z21zzast_glozd2defzd2
																													(BgL_subzf3zf3_1875,
																													BgL_arg1752z00_1887,
																													((BgL_typez00_bglt)
																														BgL_arg1753z00_1888));
																											}
																											if (BgL_test1996z00_2797)
																												{	/* Ast/glo_def.scm 366 */
																													obj_t
																														BgL_arg1749z00_1884;
																													obj_t
																														BgL_arg1750z00_1885;
																													BgL_arg1749z00_1884 =
																														CDR(((obj_t)
																															BgL_localsz00_1873));
																													BgL_arg1750z00_1885 =
																														CDR(((obj_t)
																															BgL_typesz00_1874));
																													{
																														bool_t
																															BgL_subzf3zf3_2813;
																														obj_t
																															BgL_typesz00_2812;
																														obj_t
																															BgL_localsz00_2811;
																														BgL_localsz00_2811 =
																															BgL_arg1749z00_1884;
																														BgL_typesz00_2812 =
																															BgL_arg1750z00_1885;
																														BgL_subzf3zf3_2813 =
																															((bool_t) 0);
																														BgL_subzf3zf3_1875 =
																															BgL_subzf3zf3_2813;
																														BgL_typesz00_1874 =
																															BgL_typesz00_2812;
																														BgL_localsz00_1873 =
																															BgL_localsz00_2811;
																														goto
																															BgL_zc3z04anonymousza31721ze3z87_1876;
																													}
																												}
																											else
																												{	/* Ast/glo_def.scm 358 */
																													{	/* Ast/glo_def.scm 361 */
																														obj_t
																															BgL_list1751z00_1886;
																														BgL_list1751z00_1886
																															=
																															MAKE_YOUNG_PAIR
																															(BGl_string1897z00zzast_glozd2defzd2,
																															BNIL);
																														BGl_mismatchzd2errorzd2zzast_glozd2defzd2
																															(((BgL_globalz00_bglt) BgL_genericz00_1856), BgL_srcz00_48, BgL_list1751z00_1886);
																													}
																													BgL__ortest_1114z00_1870
																														= BFALSE;
																												}
																										}
																								}
																						}
																					}
																					if (CBOOL(BgL__ortest_1114z00_1870))
																						{	/* Ast/glo_def.scm 337 */
																							return
																								CBOOL(BgL__ortest_1114z00_1870);
																						}
																					else
																						{	/* Ast/glo_def.scm 337 */
																							return ((bool_t) 1);
																						}
																				}
																			else
																				{	/* Ast/glo_def.scm 332 */
																					{	/* Ast/glo_def.scm 333 */
																						obj_t BgL_list1763z00_1907;

																						BgL_list1763z00_1907 =
																							MAKE_YOUNG_PAIR
																							(BGl_string1898z00zzast_glozd2defzd2,
																							BNIL);
																						BGl_mismatchzd2errorzd2zzast_glozd2defzd2
																							(((BgL_globalz00_bglt)
																								BgL_genericz00_1856),
																							BgL_srcz00_48,
																							BgL_list1763z00_1907);
																					}
																					return ((bool_t) 0);
																				}
																		}
																	else
																		{	/* Ast/glo_def.scm 329 */
																			{	/* Ast/glo_def.scm 330 */
																				obj_t BgL_list1765z00_1909;

																				BgL_list1765z00_1909 =
																					MAKE_YOUNG_PAIR
																					(BGl_string1896z00zzast_glozd2defzd2,
																					BNIL);
																				BGl_mismatchzd2errorzd2zzast_glozd2defzd2
																					(((BgL_globalz00_bglt)
																						BgL_genericz00_1856), BgL_srcz00_48,
																					BgL_list1765z00_1909);
																			}
																			return ((bool_t) 0);
																		}
																}
															else
																{	/* Ast/glo_def.scm 326 */
																	{	/* Ast/glo_def.scm 327 */
																		obj_t BgL_list1769z00_1912;

																		BgL_list1769z00_1912 =
																			MAKE_YOUNG_PAIR
																			(BGl_string1907z00zzast_glozd2defzd2,
																			BNIL);
																		BGl_mismatchzd2errorzd2zzast_glozd2defzd2((
																				(BgL_globalz00_bglt)
																				BgL_genericz00_1856), BgL_srcz00_48,
																			BgL_list1769z00_1912);
																	}
																	return ((bool_t) 0);
																}
														}
													else
														{	/* Ast/glo_def.scm 323 */
															{	/* Ast/glo_def.scm 324 */
																obj_t BgL_list1771z00_1914;

																BgL_list1771z00_1914 =
																	MAKE_YOUNG_PAIR
																	(BGl_string1907z00zzast_glozd2defzd2, BNIL);
																BGl_mismatchzd2errorzd2zzast_glozd2defzd2((
																		(BgL_globalz00_bglt) BgL_genericz00_1856),
																	BgL_srcz00_48, BgL_list1771z00_1914);
															}
															return ((bool_t) 0);
														}
												}
											}
										else
											{	/* Ast/glo_def.scm 316 */
												return ((bool_t) 1);
											}
									}
							}
						}
					}
				}
			}
		}

	}



/* &check-method-definition */
	obj_t BGl_z62checkzd2methodzd2definitionz62zzast_glozd2defzd2(obj_t
		BgL_envz00_2335, obj_t BgL_idz00_2336, obj_t BgL_argsz00_2337,
		obj_t BgL_localsz00_2338, obj_t BgL_srcz00_2339)
	{
		{	/* Ast/glo_def.scm 307 */
			return
				BBOOL(BGl_checkzd2methodzd2definitionz00zzast_glozd2defzd2
				(BgL_idz00_2336, BgL_argsz00_2337, BgL_localsz00_2338,
					BgL_srcz00_2339));
		}

	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzast_glozd2defzd2()
	{
		{	/* Ast/glo_def.scm 15 */
			return BUNSPEC;
		}

	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzast_glozd2defzd2()
	{
		{	/* Ast/glo_def.scm 15 */
			return BUNSPEC;
		}

	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzast_glozd2defzd2()
	{
		{	/* Ast/glo_def.scm 15 */
			return BUNSPEC;
		}

	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzast_glozd2defzd2()
	{
		{	/* Ast/glo_def.scm 15 */
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 54713316),
				BSTRING_TO_STRING(BGl_string1908z00zzast_glozd2defzd2));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 515343395),
				BSTRING_TO_STRING(BGl_string1908z00zzast_glozd2defzd2));
			BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 216206620),
				BSTRING_TO_STRING(BGl_string1908z00zzast_glozd2defzd2));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 90839984),
				BSTRING_TO_STRING(BGl_string1908z00zzast_glozd2defzd2));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 506185397),
				BSTRING_TO_STRING(BGl_string1908z00zzast_glozd2defzd2));
			BGl_modulezd2initializa7ationz75zzast_envz00(((long) 146730773),
				BSTRING_TO_STRING(BGl_string1908z00zzast_glozd2defzd2));
			BGl_modulezd2initializa7ationz75zzast_identz00(((long) 174885617),
				BSTRING_TO_STRING(BGl_string1908z00zzast_glozd2defzd2));
			BGl_modulezd2initializa7ationz75zzast_glozd2declzd2(((long) 374700232),
				BSTRING_TO_STRING(BGl_string1908z00zzast_glozd2defzd2));
			BGl_modulezd2initializa7ationz75zzast_removez00(((long) 383247627),
				BSTRING_TO_STRING(BGl_string1908z00zzast_glozd2defzd2));
			BGl_modulezd2initializa7ationz75zztype_envz00(((long) 296457443),
				BSTRING_TO_STRING(BGl_string1908z00zzast_glozd2defzd2));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 346491734),
				BSTRING_TO_STRING(BGl_string1908z00zzast_glozd2defzd2));
			BGl_modulezd2initializa7ationz75zztools_argsz00(((long) 47102372),
				BSTRING_TO_STRING(BGl_string1908z00zzast_glozd2defzd2));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 300504031),
				BSTRING_TO_STRING(BGl_string1908z00zzast_glozd2defzd2));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 365925558),
				BSTRING_TO_STRING(BGl_string1908z00zzast_glozd2defzd2));
			BGl_modulezd2initializa7ationz75zztools_locationz00(((long) 462333240),
				BSTRING_TO_STRING(BGl_string1908z00zzast_glozd2defzd2));
			BGl_modulezd2initializa7ationz75zztools_dssslz00(((long) 275867955),
				BSTRING_TO_STRING(BGl_string1908z00zzast_glozd2defzd2));
			BGl_modulezd2initializa7ationz75zzobject_classz00(((long) 502007119),
				BSTRING_TO_STRING(BGl_string1908z00zzast_glozd2defzd2));
			return
				BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 476633989),
				BSTRING_TO_STRING(BGl_string1908z00zzast_glozd2defzd2));
		}

	}

#ifdef __cplusplus
}
#endif
