/*===========================================================================*/
/*   (Return/walk.scm)                                                       */
/*   Bigloo (4.3h)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 11 May 2020 12:14:39 PM CEST    */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.3h -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Return/walk.scm) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_localz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		long BgL_keyz00;
	}               *BgL_localz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
		obj_t BgL_strengthz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_nodezf2effectzf2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
	}                       *BgL_nodezf2effectzf2_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
		bool_t BgL_unsafez00;
		obj_t BgL_metaz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_castz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}              *BgL_castz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_setzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                       *BgL_setzd2exzd2itz00_bglt;

	typedef struct BgL_retblockz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                  *BgL_retblockz00_bglt;

	typedef struct BgL_returnz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_retblockz00_bgl *BgL_blockz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                *BgL_returnz00_bglt;


	static obj_t BGl_z62returnzd2walkz12za2zzreturn_walkz00(obj_t, obj_t);
	BGL_IMPORT obj_t bgl_display_obj(obj_t, obj_t);
	static obj_t BGl_iszd2returnzf3z21zzreturn_walkz00(BgL_nodez00_bglt, obj_t,
		obj_t);
	static obj_t BGl_returnzd2funz12zc0zzreturn_walkz00(obj_t);
	extern obj_t BGl_sequencez00zzast_nodez00;
	static obj_t BGl_z62iszd2returnzf31346z43zzreturn_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	BGL_IMPORT bool_t BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(obj_t);
	static obj_t BGl_z62iszd2returnzf3z43zzreturn_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	static obj_t BGl_objectzd2initzd2zzreturn_walkz00();
	static BgL_nodez00_bglt BGl_returnz12z12zzreturn_walkz00(BgL_nodez00_bglt,
		BgL_localz00_bglt, BgL_retblockz00_bglt);
	BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	BGL_IMPORT bool_t BGl_2ze3ze3zz__r4_numbers_6_5z00(obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62returnz12zd2app1358za2zzreturn_walkz00(obj_t,
		obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62returnzd2gotozd2funsz12z70zzreturn_walkz00(obj_t, obj_t);
	BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zzreturn_walkz00();
	static obj_t BGl_z62iszd2exitzd2returnzf3z91zzreturn_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62iszd2unwindzd2untilzf3z91zzreturn_walkz00(obj_t, obj_t);
	static obj_t BGl_z62iszd2returnzf3zd2app1353z91zzreturn_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62abortz62zzreturn_walkz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_unwindzd2untilz12zc0zz__bexitz00(obj_t, obj_t);
	extern obj_t BGl_enterzd2functionzd2zztools_errorz00(obj_t);
	static obj_t BGl_za2getzd2exitdzd2topza2z00zzreturn_walkz00 = BUNSPEC;
	BGL_IMPORT long bgl_list_length(obj_t);
	static obj_t BGl_gczd2rootszd2initz00zzreturn_walkz00();
	extern obj_t BGl_za2currentzd2passza2zd2zzengine_passz00;
	BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_za2unwindzd2untilz12za2zc0zzreturn_walkz00 = BUNSPEC;
	static obj_t BGl_z62returnz121354z70zzreturn_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static BgL_nodez00_bglt
		BGl_returnzd2gotozd2funsz12z12zzreturn_walkz00(BgL_nodez00_bglt);
	extern obj_t BGl_verbosez00zztools_speekz00(obj_t, obj_t);
	static obj_t BGl_z62functionzd2exitzd2nodez62zzreturn_walkz00(obj_t, obj_t);
	extern obj_t BGl_returnz00zzast_nodez00;
	static obj_t BGl_requirezd2initializa7ationz75zzreturn_walkz00 = BUNSPEC;
	static BgL_nodez00_bglt
		BGl_z62returnzd2gotozd2funsz12zd2le1362za2zzreturn_walkz00(obj_t, obj_t);
	static obj_t BGl_z62clearzd2returnzd2cachez12z70zzreturn_walkz00(obj_t);
	extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
	static obj_t BGl_za2popzd2exitz12za2zc0zzreturn_walkz00 = BUNSPEC;
	BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_step6ze70ze7zzreturn_walkz00(BgL_nodez00_bglt,
		BgL_localz00_bglt);
	static obj_t BGl_toplevelzd2initzd2zzreturn_walkz00();
	extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL bool_t
		BGl_iszd2unwindzd2untilzf3zf3zzreturn_walkz00(BgL_variablez00_bglt);
	static obj_t BGl_genericzd2initzd2zzreturn_walkz00();
	extern obj_t BGl_leavezd2functionzd2zztools_errorz00();
	static obj_t BGl_zc3z04exitza31761ze3ze70z60zzreturn_walkz00(BgL_nodez00_bglt,
		BgL_localz00_bglt);
	extern obj_t BGl_castz00zzast_nodez00;
	static obj_t BGl_step8ze70ze7zzreturn_walkz00(BgL_nodez00_bglt,
		BgL_localz00_bglt);
	static obj_t BGl_z62iszd2returnzf3zd2var1349z91zzreturn_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62iszd2getzd2exitdzd2topzf3z43zzreturn_walkz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	static obj_t BGl_z62returnzd2gotozd2funsz121359z70zzreturn_walkz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_za2pushzd2exitz12za2zc0zzreturn_walkz00 = BUNSPEC;
	BGL_EXPORTED_DECL bool_t
		BGl_iszd2exitzd2returnzf3zf3zzreturn_walkz00(BgL_nodez00_bglt,
		BgL_localz00_bglt);
	extern obj_t BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00;
	extern obj_t BGl_findzd2globalzd2zzast_envz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_functionzd2exitzd2nodez00zzreturn_walkz00(BgL_nodez00_bglt);
	extern obj_t BGl_varz00zzast_nodez00;
	static obj_t BGl_z62initzd2returnzd2cachez12z70zzreturn_walkz00(obj_t);
	BGL_IMPORT obj_t BGl_exitz00zz__errorz00(obj_t);
	BGL_EXPORTED_DECL obj_t BGl_returnzd2walkz12zc0zzreturn_walkz00(obj_t);
	extern obj_t BGl_walk2z00zzast_walkz00(BgL_nodez00_bglt, obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zzreturn_walkz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_walkz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_dumpz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_lvtypez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_privatez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_sexpz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_localz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_identz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_locationz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_passz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_speekz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
	extern obj_t BGl_appz00zzast_nodez00;
	static obj_t BGl_z62iszd2returnzf3zd2letzd2var1351z43zzreturn_walkz00(obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_nodez00zzast_nodez00;
	extern obj_t BGl_za2optimzd2returnzd2gotozf3za2zf3zzengine_paramz00;
	static obj_t BGl_cnstzd2initzd2zzreturn_walkz00();
	static obj_t BGl_libraryzd2moduleszd2initz00zzreturn_walkz00();
	static obj_t BGl_importedzd2moduleszd2initz00zzreturn_walkz00();
	extern BgL_nodez00_bglt BGl_walk0z12z12zzast_walkz00(BgL_nodez00_bglt, obj_t);
	static BgL_nodez00_bglt BGl_z62returnz12z70zzreturn_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_retblockz00zzast_nodez00;
	extern BgL_nodez00_bglt BGl_walk2z12z12zzast_walkz00(BgL_nodez00_bglt, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_letzd2funzd2zzast_nodez00;
	BGL_EXPORTED_DECL bool_t
		BGl_iszd2getzd2exitdzd2topzf3z21zzreturn_walkz00(BgL_variablez00_bglt);
	BGL_EXPORTED_DECL obj_t BGl_initzd2returnzd2cachez12z12zzreturn_walkz00();
	extern obj_t BGl_globalz00zzast_varz00;
	static obj_t __cnst[10];


	   
		 
		DEFINE_STATIC_BGL_GENERIC(BGl_iszd2returnzf3zd2envzf3zzreturn_walkz00,
		BgL_bgl_za762isza7d2returnza7f2009za7,
		BGl_z62iszd2returnzf3z43zzreturn_walkz00, 0L, BUNSPEC, 3);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_returnzd2walkz12zd2envz12zzreturn_walkz00,
		BgL_bgl_za762returnza7d2walk2010z00,
		BGl_z62returnzd2walkz12za2zzreturn_walkz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_iszd2exitzd2returnzf3zd2envz21zzreturn_walkz00,
		BgL_bgl_za762isza7d2exitza7d2r2011za7,
		BGl_z62iszd2exitzd2returnzf3z91zzreturn_walkz00, 0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_functionzd2exitzd2nodezd2envzd2zzreturn_walkz00,
		BgL_bgl_za762functionza7d2ex2012z00,
		BGl_z62functionzd2exitzd2nodez62zzreturn_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1990z00zzreturn_walkz00,
		BgL_bgl_za762isza7d2returnza7f2013za7,
		BGl_z62iszd2returnzf31346z43zzreturn_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1992z00zzreturn_walkz00,
		BgL_bgl_za762returnza71213542014z00,
		BGl_z62returnz121354z70zzreturn_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1994z00zzreturn_walkz00,
		BgL_bgl_za762returnza7d2goto2015z00,
		BGl_z62returnzd2gotozd2funsz121359z70zzreturn_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1996z00zzreturn_walkz00,
		BgL_bgl_za762isza7d2returnza7f2016za7,
		BGl_z62iszd2returnzf3zd2var1349z91zzreturn_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1998z00zzreturn_walkz00,
		BgL_bgl_za762isza7d2returnza7f2017za7,
		BGl_z62iszd2returnzf3zd2letzd2var1351z43zzreturn_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1999z00zzreturn_walkz00,
		BgL_bgl_za762isza7d2returnza7f2018za7,
		BGl_z62iszd2returnzf3zd2app1353z91zzreturn_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STRING(BGl_string2001z00zzreturn_walkz00,
		BgL_bgl_string2001za700za7za7r2019za7, "return!::node", 13);
	      DEFINE_STRING(BGl_string2003z00zzreturn_walkz00,
		BgL_bgl_string2003za700za7za7r2020za7, "return-goto-funs!::node", 23);
	      DEFINE_STRING(BGl_string2004z00zzreturn_walkz00,
		BgL_bgl_string2004za700za7za7r2021za7, "return_walk", 11);
	      DEFINE_STRING(BGl_string2005z00zzreturn_walkz00,
		BgL_bgl_string2005za700za7za7r2022za7,
		"sfun push-exit! pop-exit! unwind-until! __bexit $get-exitd-top foreign (clear-return-cache!) pass-started (init-return-cache!) ",
		127);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_iszd2unwindzd2untilzf3zd2envz21zzreturn_walkz00,
		BgL_bgl_za762isza7d2unwindza7d2023za7,
		BGl_z62iszd2unwindzd2untilzf3z91zzreturn_walkz00, 0L, BUNSPEC, 1);
	     
		DEFINE_STATIC_BGL_PROCEDURE
		(BGl_clearzd2returnzd2cachez12zd2envzc0zzreturn_walkz00,
		BgL_bgl_za762clearza7d2retur2024z00,
		BGl_z62clearzd2returnzd2cachez12z70zzreturn_walkz00, 0L, BUNSPEC, 0);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_iszd2getzd2exitdzd2topzf3zd2envzf3zzreturn_walkz00,
		BgL_bgl_za762isza7d2getza7d2ex2025za7,
		BGl_z62iszd2getzd2exitdzd2topzf3z43zzreturn_walkz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_initzd2returnzd2cachez12zd2envzc0zzreturn_walkz00,
		BgL_bgl_za762initza7d2return2026z00,
		BGl_z62initzd2returnzd2cachez12z70zzreturn_walkz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_GENERIC(BGl_returnz12zd2envzc0zzreturn_walkz00,
		BgL_bgl_za762returnza712za770za72027z00,
		BGl_z62returnz12z70zzreturn_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STRING(BGl_string1982z00zzreturn_walkz00,
		BgL_bgl_string1982za700za7za7r2028za7, "Return", 6);
	      DEFINE_STRING(BGl_string1983z00zzreturn_walkz00,
		BgL_bgl_string1983za700za7za7r2029za7, "   . ", 5);
	      DEFINE_STRING(BGl_string1984z00zzreturn_walkz00,
		BgL_bgl_string1984za700za7za7r2030za7, "failure during prelude hook", 27);
	      DEFINE_STRING(BGl_string1985z00zzreturn_walkz00,
		BgL_bgl_string1985za700za7za7r2031za7, " error", 6);
	      DEFINE_STRING(BGl_string1986z00zzreturn_walkz00,
		BgL_bgl_string1986za700za7za7r2032za7, "s", 1);
	      DEFINE_STRING(BGl_string1987z00zzreturn_walkz00,
		BgL_bgl_string1987za700za7za7r2033za7, "", 0);
	      DEFINE_STRING(BGl_string1988z00zzreturn_walkz00,
		BgL_bgl_string1988za700za7za7r2034za7, " occured, ending ...", 20);
	      DEFINE_STRING(BGl_string1989z00zzreturn_walkz00,
		BgL_bgl_string1989za700za7za7r2035za7, "failure during postlude hook", 28);
	      DEFINE_STRING(BGl_string1991z00zzreturn_walkz00,
		BgL_bgl_string1991za700za7za7r2036za7, "is-return?1346", 14);
	      DEFINE_STRING(BGl_string1993z00zzreturn_walkz00,
		BgL_bgl_string1993za700za7za7r2037za7, "return!1354", 11);
	      DEFINE_STRING(BGl_string1995z00zzreturn_walkz00,
		BgL_bgl_string1995za700za7za7r2038za7, "return-goto-funs!1359", 21);
	      DEFINE_STRING(BGl_string1997z00zzreturn_walkz00,
		BgL_bgl_string1997za700za7za7r2039za7, "is-return?", 10);
	     
		DEFINE_STATIC_BGL_GENERIC
		(BGl_returnzd2gotozd2funsz12zd2envzc0zzreturn_walkz00,
		BgL_bgl_za762returnza7d2goto2040z00,
		BGl_z62returnzd2gotozd2funsz12z70zzreturn_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2000z00zzreturn_walkz00,
		BgL_bgl_za762returnza712za7d2a2041za7,
		BGl_z62returnz12zd2app1358za2zzreturn_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2002z00zzreturn_walkz00,
		BgL_bgl_za762returnza7d2goto2042z00,
		BGl_z62returnzd2gotozd2funsz12zd2le1362za2zzreturn_walkz00, 0L, BUNSPEC, 1);

/* GC roots registration */
	static obj_t bgl_gc_roots_register()
	{
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
		void *roots_min = (void *) ULONG_MAX, *roots_max = 0;
		     ADD_ROOT((void *) (&BGl_za2getzd2exitdzd2topza2z00zzreturn_walkz00));
		     ADD_ROOT((void *) (&BGl_za2unwindzd2untilz12za2zc0zzreturn_walkz00));
		   
			 ADD_ROOT((void *) (&BGl_requirezd2initializa7ationz75zzreturn_walkz00));
		     ADD_ROOT((void *) (&BGl_za2popzd2exitz12za2zc0zzreturn_walkz00));
		     ADD_ROOT((void *) (&BGl_za2pushzd2exitz12za2zc0zzreturn_walkz00));
#undef ADD_ROOT
		if   (roots_max > 0)
			     GC_add_roots(roots_min, ((void **) roots_max) + 1);
#endif
		     return BUNSPEC;
	}



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzreturn_walkz00(long
		BgL_checksumz00_2524, char *BgL_fromz00_2525)
	{
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzreturn_walkz00))
				{
					BGl_requirezd2initializa7ationz75zzreturn_walkz00 =
						BBOOL(((bool_t) 0));
					BGl_gczd2rootszd2initz00zzreturn_walkz00();
					BGl_libraryzd2moduleszd2initz00zzreturn_walkz00();
					BGl_cnstzd2initzd2zzreturn_walkz00();
					BGl_importedzd2moduleszd2initz00zzreturn_walkz00();
					BGl_genericzd2initzd2zzreturn_walkz00();
					BGl_methodzd2initzd2zzreturn_walkz00();
					return BGl_toplevelzd2initzd2zzreturn_walkz00();
				}
			else
				{
					return BUNSPEC;
				}
		}

	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzreturn_walkz00()
	{
		{	/* Return/walk.scm 16 */
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 0),
				"return_walk");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long) 0),
				"return_walk");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"return_walk");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long) 0),
				"return_walk");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0), "return_walk");
			BGl_modulezd2initializa7ationz75zz__bexitz00(((long) 0), "return_walk");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0), "return_walk");
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"return_walk");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "return_walk");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"return_walk");
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 0),
				"return_walk");
			BGl_modulezd2initializa7ationz75zz__bitz00(((long) 0), "return_walk");
			BGl_modulezd2initializa7ationz75zz__biglooz00(((long) 0), "return_walk");
			return BUNSPEC;
		}

	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzreturn_walkz00()
	{
		{	/* Return/walk.scm 16 */
			{	/* Return/walk.scm 16 */
				obj_t BgL_cportz00_2461;

				{	/* Return/walk.scm 16 */
					obj_t BgL_stringz00_2469;

					BgL_stringz00_2469 = BGl_string2005z00zzreturn_walkz00;
					{	/* Return/walk.scm 16 */
						obj_t BgL_startz00_2470;

						BgL_startz00_2470 = BINT(((long) 0));
						{	/* Return/walk.scm 16 */
							obj_t BgL_endz00_2471;

							BgL_endz00_2471 =
								BINT(STRING_LENGTH(((obj_t) BgL_stringz00_2469)));
							{	/* Return/walk.scm 16 */

								BgL_cportz00_2461 =
									BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00
									(BgL_stringz00_2469, BgL_startz00_2470, BgL_endz00_2471);
				}}}}
				{
					long BgL_iz00_2462;

					BgL_iz00_2462 = ((long) 9);
				BgL_loopz00_2463:
					if ((BgL_iz00_2462 == ((long) -1)))
						{	/* Return/walk.scm 16 */
							return BUNSPEC;
						}
					else
						{	/* Return/walk.scm 16 */
							{	/* Return/walk.scm 16 */
								obj_t BgL_arg2007z00_2465;

								{	/* Return/walk.scm 16 */

									{	/* Return/walk.scm 16 */
										obj_t BgL_locationz00_2467;

										BgL_locationz00_2467 = BBOOL(((bool_t) 0));
										{	/* Return/walk.scm 16 */

											BgL_arg2007z00_2465 =
												BGl_readz00zz__readerz00(BgL_cportz00_2461,
												BgL_locationz00_2467);
										}
									}
								}
								{	/* Return/walk.scm 16 */
									int BgL_tmpz00_2558;

									BgL_tmpz00_2558 = (int) (BgL_iz00_2462);
									CNST_TABLE_SET(BgL_tmpz00_2558, BgL_arg2007z00_2465);
							}}
							{	/* Return/walk.scm 16 */
								int BgL_auxz00_2468;

								BgL_auxz00_2468 = (int) ((BgL_iz00_2462 - ((long) 1)));
								{
									long BgL_iz00_2563;

									BgL_iz00_2563 = (long) (BgL_auxz00_2468);
									BgL_iz00_2462 = BgL_iz00_2563;
									goto BgL_loopz00_2463;
								}
							}
						}
				}
			}
		}

	}



/* gc-roots-init */
	obj_t BGl_gczd2rootszd2initz00zzreturn_walkz00()
	{
		{	/* Return/walk.scm 16 */
			return bgl_gc_roots_register();
		}

	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzreturn_walkz00()
	{
		{	/* Return/walk.scm 16 */
			BGl_za2getzd2exitdzd2topza2z00zzreturn_walkz00 = BUNSPEC;
			BGl_za2unwindzd2untilz12za2zc0zzreturn_walkz00 = BUNSPEC;
			BGl_za2pushzd2exitz12za2zc0zzreturn_walkz00 = BUNSPEC;
			BGl_za2popzd2exitz12za2zc0zzreturn_walkz00 = BUNSPEC;
			return BUNSPEC;
		}

	}



/* return-walk! */
	BGL_EXPORTED_DEF obj_t BGl_returnzd2walkz12zc0zzreturn_walkz00(obj_t
		BgL_globalsz00_17)
	{
		{	/* Return/walk.scm 44 */
			{	/* Return/walk.scm 45 */
				obj_t BgL_list1411z00_1433;

				{	/* Return/walk.scm 45 */
					obj_t BgL_arg1421z00_1434;

					{	/* Return/walk.scm 45 */
						obj_t BgL_arg1422z00_1435;

						BgL_arg1422z00_1435 =
							MAKE_YOUNG_PAIR(BCHAR(((unsigned char) 10)), BNIL);
						BgL_arg1421z00_1434 =
							MAKE_YOUNG_PAIR(BGl_string1982z00zzreturn_walkz00,
							BgL_arg1422z00_1435);
					}
					BgL_list1411z00_1433 =
						MAKE_YOUNG_PAIR(BGl_string1983z00zzreturn_walkz00,
						BgL_arg1421z00_1434);
				}
				BGl_verbosez00zztools_speekz00(BINT(((long) 1)), BgL_list1411z00_1433);
			}
			BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00 = BINT(((long) 0));
			BGl_za2currentzd2passza2zd2zzengine_passz00 =
				BGl_string1982z00zzreturn_walkz00;
			{	/* Return/walk.scm 45 */
				obj_t BgL_g1116z00_1436;
				obj_t BgL_g1117z00_1437;

				{	/* Return/walk.scm 45 */
					obj_t BgL_list1445z00_1450;

					BgL_list1445z00_1450 =
						MAKE_YOUNG_PAIR
						(BGl_initzd2returnzd2cachez12zd2envzc0zzreturn_walkz00, BNIL);
					BgL_g1116z00_1436 = BgL_list1445z00_1450;
				}
				BgL_g1117z00_1437 = CNST_TABLE_REF(((long) 0));
				{
					obj_t BgL_hooksz00_1439;
					obj_t BgL_hnamesz00_1440;

					BgL_hooksz00_1439 = BgL_g1116z00_1436;
					BgL_hnamesz00_1440 = BgL_g1117z00_1437;
				BgL_zc3z04anonymousza31423ze3z87_1441:
					if (NULLP(BgL_hooksz00_1439))
						{	/* Return/walk.scm 45 */
							CNST_TABLE_REF(((long) 1));
						}
					else
						{	/* Return/walk.scm 45 */
							bool_t BgL_test2046z00_2578;

							{	/* Return/walk.scm 45 */
								obj_t BgL_fun1444z00_1448;

								BgL_fun1444z00_1448 = CAR(((obj_t) BgL_hooksz00_1439));
								BgL_test2046z00_2578 =
									CBOOL(PROCEDURE_ENTRY(BgL_fun1444z00_1448)
									(BgL_fun1444z00_1448, BEOA));
							}
							if (BgL_test2046z00_2578)
								{	/* Return/walk.scm 45 */
									obj_t BgL_arg1429z00_1445;
									obj_t BgL_arg1430z00_1446;

									BgL_arg1429z00_1445 = CDR(((obj_t) BgL_hooksz00_1439));
									BgL_arg1430z00_1446 = CDR(((obj_t) BgL_hnamesz00_1440));
									{
										obj_t BgL_hnamesz00_2590;
										obj_t BgL_hooksz00_2589;

										BgL_hooksz00_2589 = BgL_arg1429z00_1445;
										BgL_hnamesz00_2590 = BgL_arg1430z00_1446;
										BgL_hnamesz00_1440 = BgL_hnamesz00_2590;
										BgL_hooksz00_1439 = BgL_hooksz00_2589;
										goto BgL_zc3z04anonymousza31423ze3z87_1441;
									}
								}
							else
								{	/* Return/walk.scm 45 */
									obj_t BgL_arg1442z00_1447;

									BgL_arg1442z00_1447 = CAR(((obj_t) BgL_hnamesz00_1440));
									BGl_internalzd2errorzd2zztools_errorz00
										(BGl_string1982z00zzreturn_walkz00,
										BGl_string1984z00zzreturn_walkz00, BgL_arg1442z00_1447);
								}
						}
				}
			}
			{
				obj_t BgL_l1336z00_1452;

				BgL_l1336z00_1452 = BgL_globalsz00_17;
			BgL_zc3z04anonymousza31446ze3z87_1453:
				if (PAIRP(BgL_l1336z00_1452))
					{	/* Return/walk.scm 46 */
						BGl_returnzd2funz12zc0zzreturn_walkz00(CAR(BgL_l1336z00_1452));
						{
							obj_t BgL_l1336z00_2598;

							BgL_l1336z00_2598 = CDR(BgL_l1336z00_1452);
							BgL_l1336z00_1452 = BgL_l1336z00_2598;
							goto BgL_zc3z04anonymousza31446ze3z87_1453;
						}
					}
				else
					{	/* Return/walk.scm 46 */
						((bool_t) 1);
					}
			}
			if (
				((long) CINT(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00) >
					((long) 0)))
				{	/* Return/walk.scm 47 */
					{	/* Return/walk.scm 47 */
						obj_t BgL_port1338z00_1460;

						{	/* Return/walk.scm 47 */
							obj_t BgL_res1923z00_2167;

							{	/* Return/walk.scm 47 */
								obj_t BgL_tmpz00_2603;

								BgL_tmpz00_2603 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res1923z00_2167 =
									BGL_ENV_CURRENT_ERROR_PORT(BgL_tmpz00_2603);
							}
							BgL_port1338z00_1460 = BgL_res1923z00_2167;
						}
						bgl_display_obj(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00,
							BgL_port1338z00_1460);
						bgl_display_string(BGl_string1985z00zzreturn_walkz00,
							BgL_port1338z00_1460);
						{	/* Return/walk.scm 47 */
							obj_t BgL_arg1473z00_1461;

							{	/* Return/walk.scm 47 */
								bool_t BgL_test2049z00_2608;

								if (BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00
									(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00))
									{	/* Return/walk.scm 47 */
										if (INTEGERP
											(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00))
											{	/* Return/walk.scm 47 */
												BgL_test2049z00_2608 =
													(
													(long)
													CINT
													(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00)
													> ((long) 1));
											}
										else
											{	/* Return/walk.scm 47 */
												BgL_test2049z00_2608 =
													BGl_2ze3ze3zz__r4_numbers_6_5z00
													(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00,
													BINT(((long) 1)));
									}}
								else
									{	/* Return/walk.scm 47 */
										BgL_test2049z00_2608 = ((bool_t) 0);
									}
								if (BgL_test2049z00_2608)
									{	/* Return/walk.scm 47 */
										BgL_arg1473z00_1461 = BGl_string1986z00zzreturn_walkz00;
									}
								else
									{	/* Return/walk.scm 47 */
										BgL_arg1473z00_1461 = BGl_string1987z00zzreturn_walkz00;
									}
							}
							bgl_display_obj(BgL_arg1473z00_1461, BgL_port1338z00_1460);
						}
						bgl_display_string(BGl_string1988z00zzreturn_walkz00,
							BgL_port1338z00_1460);
						bgl_display_char(((unsigned char) 10), BgL_port1338z00_1460);
					}
					{	/* Return/walk.scm 47 */
						obj_t BgL_list1477z00_1467;

						BgL_list1477z00_1467 = MAKE_YOUNG_PAIR(BINT(((long) -1)), BNIL);
						return BGl_exitz00zz__errorz00(BgL_list1477z00_1467);
					}
				}
			else
				{	/* Return/walk.scm 47 */
					obj_t BgL_g1118z00_1468;
					obj_t BgL_g1119z00_1469;

					{	/* Return/walk.scm 47 */
						obj_t BgL_list1494z00_1482;

						BgL_list1494z00_1482 =
							MAKE_YOUNG_PAIR
							(BGl_clearzd2returnzd2cachez12zd2envzc0zzreturn_walkz00, BNIL);
						BgL_g1118z00_1468 = BgL_list1494z00_1482;
					}
					BgL_g1119z00_1469 = CNST_TABLE_REF(((long) 2));
					{
						obj_t BgL_hooksz00_1471;
						obj_t BgL_hnamesz00_1472;

						BgL_hooksz00_1471 = BgL_g1118z00_1468;
						BgL_hnamesz00_1472 = BgL_g1119z00_1469;
					BgL_zc3z04anonymousza31478ze3z87_1473:
						if (NULLP(BgL_hooksz00_1471))
							{	/* Return/walk.scm 47 */
								return BgL_globalsz00_17;
							}
						else
							{	/* Return/walk.scm 47 */
								bool_t BgL_test2053z00_2627;

								{	/* Return/walk.scm 47 */
									obj_t BgL_fun1493z00_1480;

									BgL_fun1493z00_1480 = CAR(((obj_t) BgL_hooksz00_1471));
									BgL_test2053z00_2627 =
										CBOOL(PROCEDURE_ENTRY(BgL_fun1493z00_1480)
										(BgL_fun1493z00_1480, BEOA));
								}
								if (BgL_test2053z00_2627)
									{	/* Return/walk.scm 47 */
										obj_t BgL_arg1488z00_1477;
										obj_t BgL_arg1490z00_1478;

										BgL_arg1488z00_1477 = CDR(((obj_t) BgL_hooksz00_1471));
										BgL_arg1490z00_1478 = CDR(((obj_t) BgL_hnamesz00_1472));
										{
											obj_t BgL_hnamesz00_2639;
											obj_t BgL_hooksz00_2638;

											BgL_hooksz00_2638 = BgL_arg1488z00_1477;
											BgL_hnamesz00_2639 = BgL_arg1490z00_1478;
											BgL_hnamesz00_1472 = BgL_hnamesz00_2639;
											BgL_hooksz00_1471 = BgL_hooksz00_2638;
											goto BgL_zc3z04anonymousza31478ze3z87_1473;
										}
									}
								else
									{	/* Return/walk.scm 47 */
										obj_t BgL_arg1492z00_1479;

										BgL_arg1492z00_1479 = CAR(((obj_t) BgL_hnamesz00_1472));
										return
											BGl_internalzd2errorzd2zztools_errorz00
											(BGl_za2currentzd2passza2zd2zzengine_passz00,
											BGl_string1989z00zzreturn_walkz00, BgL_arg1492z00_1479);
									}
							}
					}
				}
		}

	}



/* &return-walk! */
	obj_t BGl_z62returnzd2walkz12za2zzreturn_walkz00(obj_t BgL_envz00_2395,
		obj_t BgL_globalsz00_2396)
	{
		{	/* Return/walk.scm 44 */
			return BGl_returnzd2walkz12zc0zzreturn_walkz00(BgL_globalsz00_2396);
		}

	}



/* init-return-cache! */
	BGL_EXPORTED_DEF obj_t BGl_initzd2returnzd2cachez12z12zzreturn_walkz00()
	{
		{	/* Return/walk.scm 60 */
			{	/* Return/walk.scm 61 */
				bool_t BgL_test2054z00_2644;

				{	/* Return/walk.scm 61 */
					bool_t BgL_res1928z00_2184;

					{	/* Return/walk.scm 61 */
						obj_t BgL_objz00_2183;

						BgL_objz00_2183 = BGl_za2getzd2exitdzd2topza2z00zzreturn_walkz00;
						BgL_res1928z00_2184 =
							BGl_isazf3zf3zz__objectz00(BgL_objz00_2183,
							BGl_globalz00zzast_varz00);
					}
					BgL_test2054z00_2644 = BgL_res1928z00_2184;
				}
				if (BgL_test2054z00_2644)
					{	/* Return/walk.scm 61 */
						BFALSE;
					}
				else
					{	/* Return/walk.scm 61 */
						{	/* Return/walk.scm 62 */
							obj_t BgL_list1496z00_1484;

							BgL_list1496z00_1484 =
								MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 3)), BNIL);
							BGl_za2getzd2exitdzd2topza2z00zzreturn_walkz00 =
								BGl_findzd2globalzd2zzast_envz00(CNST_TABLE_REF(((long) 4)),
								BgL_list1496z00_1484);
						}
						{	/* Return/walk.scm 63 */
							obj_t BgL_list1497z00_1485;

							BgL_list1497z00_1485 =
								MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 5)), BNIL);
							BGl_za2unwindzd2untilz12za2zc0zzreturn_walkz00 =
								BGl_findzd2globalzd2zzast_envz00(CNST_TABLE_REF(((long) 6)),
								BgL_list1497z00_1485);
						}
						{	/* Return/walk.scm 64 */
							obj_t BgL_list1498z00_1486;

							BgL_list1498z00_1486 =
								MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 3)), BNIL);
							BGl_za2popzd2exitz12za2zc0zzreturn_walkz00 =
								BGl_findzd2globalzd2zzast_envz00(CNST_TABLE_REF(((long) 7)),
								BgL_list1498z00_1486);
						}
						{	/* Return/walk.scm 65 */
							obj_t BgL_list1499z00_1487;

							BgL_list1499z00_1487 =
								MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 3)), BNIL);
							BGl_za2pushzd2exitz12za2zc0zzreturn_walkz00 =
								BGl_findzd2globalzd2zzast_envz00(CNST_TABLE_REF(((long) 8)),
								BgL_list1499z00_1487);
			}}}
			return BUNSPEC;
		}

	}



/* &init-return-cache! */
	obj_t BGl_z62initzd2returnzd2cachez12z70zzreturn_walkz00(obj_t
		BgL_envz00_2397)
	{
		{	/* Return/walk.scm 60 */
			return BGl_initzd2returnzd2cachez12z12zzreturn_walkz00();
		}

	}



/* &clear-return-cache! */
	obj_t BGl_z62clearzd2returnzd2cachez12z70zzreturn_walkz00(obj_t
		BgL_envz00_2398)
	{
		{	/* Return/walk.scm 71 */
			BGl_za2getzd2exitdzd2topza2z00zzreturn_walkz00 = BFALSE;
			BGl_za2unwindzd2untilz12za2zc0zzreturn_walkz00 = BFALSE;
			BGl_za2pushzd2exitz12za2zc0zzreturn_walkz00 = BFALSE;
			return (BGl_za2popzd2exitz12za2zc0zzreturn_walkz00 = BFALSE, BUNSPEC);
		}

	}



/* return-fun! */
	obj_t BGl_returnzd2funz12zc0zzreturn_walkz00(obj_t BgL_varz00_18)
	{
		{	/* Return/walk.scm 80 */
			{	/* Return/walk.scm 81 */
				obj_t BgL_arg1502z00_1488;

				BgL_arg1502z00_1488 =
					(((BgL_variablez00_bglt) COBJECT(
							((BgL_variablez00_bglt) BgL_varz00_18)))->BgL_idz00);
				BGl_enterzd2functionzd2zztools_errorz00(BgL_arg1502z00_1488);
			}
			{	/* Return/walk.scm 82 */
				BgL_valuez00_bglt BgL_funz00_1489;

				BgL_funz00_1489 =
					(((BgL_variablez00_bglt) COBJECT(
							((BgL_variablez00_bglt) BgL_varz00_18)))->BgL_valuez00);
				{	/* Return/walk.scm 82 */
					obj_t BgL_bodyz00_1490;

					BgL_bodyz00_1490 =
						(((BgL_sfunz00_bglt) COBJECT(
								((BgL_sfunz00_bglt) BgL_funz00_1489)))->BgL_bodyz00);
					{	/* Return/walk.scm 83 */
						obj_t BgL_exitz00_1491;

						BgL_exitz00_1491 =
							BGl_functionzd2exitzd2nodez00zzreturn_walkz00(
							((BgL_nodez00_bglt) BgL_bodyz00_1490));
						{	/* Return/walk.scm 84 */

							if (PAIRP(BgL_exitz00_1491))
								{	/* Return/walk.scm 86 */
									obj_t BgL_exitvarz00_1493;
									obj_t BgL_exitnodez00_1494;

									BgL_exitvarz00_1493 = CAR(BgL_exitz00_1491);
									BgL_exitnodez00_1494 = CDR(BgL_exitz00_1491);
									if (BGl_iszd2exitzd2returnzf3zf3zzreturn_walkz00(
											((BgL_nodez00_bglt) BgL_exitnodez00_1494),
											((BgL_localz00_bglt) BgL_exitvarz00_1493)))
										{	/* Return/walk.scm 89 */
											BgL_retblockz00_bglt BgL_rblockz00_1496;

											{	/* Return/walk.scm 89 */
												BgL_retblockz00_bglt BgL_new1121z00_1498;

												{	/* Return/walk.scm 90 */
													BgL_retblockz00_bglt BgL_new1120z00_1499;

													BgL_new1120z00_1499 =
														((BgL_retblockz00_bglt)
														BOBJECT(GC_MALLOC(sizeof(struct
																	BgL_retblockz00_bgl))));
													{	/* Return/walk.scm 90 */
														long BgL_arg1510z00_1500;

														{	/* Return/walk.scm 90 */
															long BgL_res1930z00_2192;

															BgL_res1930z00_2192 =
																BGL_CLASS_INDEX(BGl_retblockz00zzast_nodez00);
															BgL_arg1510z00_1500 = BgL_res1930z00_2192;
														}
														BGL_OBJECT_CLASS_NUM_SET(
															((BgL_objectz00_bglt) BgL_new1120z00_1499),
															BgL_arg1510z00_1500);
													}
													{	/* Return/walk.scm 90 */
														BgL_objectz00_bglt BgL_tmpz00_2684;

														BgL_tmpz00_2684 =
															((BgL_objectz00_bglt) BgL_new1120z00_1499);
														BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2684, BFALSE);
													}
													((BgL_objectz00_bglt) BgL_new1120z00_1499);
													BgL_new1121z00_1498 = BgL_new1120z00_1499;
												}
												((((BgL_nodez00_bglt) COBJECT(
																((BgL_nodez00_bglt) BgL_new1121z00_1498)))->
														BgL_locz00) =
													((obj_t) (((BgL_nodez00_bglt)
																COBJECT(((BgL_nodez00_bglt)
																		BgL_bodyz00_1490)))->BgL_locz00)), BUNSPEC);
												((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
																	BgL_new1121z00_1498)))->BgL_typez00) =
													((BgL_typez00_bglt) (((BgL_nodez00_bglt)
																COBJECT(((BgL_nodez00_bglt)
																		BgL_exitnodez00_1494)))->BgL_typez00)),
													BUNSPEC);
												((((BgL_retblockz00_bglt)
															COBJECT(BgL_new1121z00_1498))->BgL_bodyz00) =
													((BgL_nodez00_bglt) ((BgL_nodez00_bglt)
															BgL_bodyz00_1490)), BUNSPEC);
												BgL_rblockz00_1496 = BgL_new1121z00_1498;
											}
											((((BgL_retblockz00_bglt) COBJECT(BgL_rblockz00_1496))->
													BgL_bodyz00) =
												((BgL_nodez00_bglt)
													BGl_returnz12z12zzreturn_walkz00(((BgL_nodez00_bglt)
															BgL_exitnodez00_1494),
														((BgL_localz00_bglt) BgL_exitvarz00_1493),
														BgL_rblockz00_1496)), BUNSPEC);
											{	/* Return/walk.scm 95 */
												obj_t BgL_vz00_2199;

												BgL_vz00_2199 = CNST_TABLE_REF(((long) 9));
												((((BgL_sfunz00_bglt) COBJECT(
																((BgL_sfunz00_bglt) BgL_funz00_1489)))->
														BgL_classz00) = ((obj_t) BgL_vz00_2199), BUNSPEC);
											}
											((((BgL_sfunz00_bglt) COBJECT(
															((BgL_sfunz00_bglt) BgL_funz00_1489)))->
													BgL_bodyz00) =
												((obj_t) ((obj_t) BgL_rblockz00_1496)), BUNSPEC);
										}
									else
										{	/* Return/walk.scm 88 */
											BFALSE;
										}
								}
							else
								{	/* Return/walk.scm 85 */
									BFALSE;
								}
							if (CBOOL(BGl_za2optimzd2returnzd2gotozf3za2zf3zzengine_paramz00))
								{	/* Return/walk.scm 97 */
									((obj_t)
										BGl_returnzd2gotozd2funsz12z12zzreturn_walkz00(
											((BgL_nodez00_bglt) BgL_bodyz00_1490)));
								}
							else
								{	/* Return/walk.scm 97 */
									BFALSE;
								}
							BGl_leavezd2functionzd2zztools_errorz00();
							return BgL_varz00_18;
						}
					}
				}
			}
		}

	}



/* function-exit-node */
	BGL_EXPORTED_DEF obj_t
		BGl_functionzd2exitzd2nodez00zzreturn_walkz00(BgL_nodez00_bglt
		BgL_nodez00_19)
	{
		{	/* Return/walk.scm 122 */
			{
				BgL_nodez00_bglt BgL_nodez00_1573;
				BgL_localz00_bglt BgL_varz00_1574;
				BgL_nodez00_bglt BgL_nodez00_1601;
				BgL_nodez00_bglt BgL_nodez00_1628;
				BgL_localz00_bglt BgL_exitvarz00_1629;
				obj_t BgL_nodesz00_1650;
				BgL_localz00_bglt BgL_varz00_1651;
				BgL_nodez00_bglt BgL_bodyz00_1668;
				BgL_varz00_bglt BgL_varz00_1669;

				if (BGl_isazf3zf3zz__objectz00(
						((obj_t) BgL_nodez00_19), BGl_setzd2exzd2itz00zzast_nodez00))
					{	/* Return/walk.scm 212 */
						BgL_nodez00_bglt BgL_arg1512z00_1511;
						BgL_varz00_bglt BgL_arg1514z00_1512;

						BgL_arg1512z00_1511 =
							(((BgL_setzd2exzd2itz00_bglt) COBJECT(
									((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_19)))->BgL_bodyz00);
						BgL_arg1514z00_1512 =
							(((BgL_setzd2exzd2itz00_bglt) COBJECT(
									((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_19)))->BgL_varz00);
						BgL_bodyz00_1668 = BgL_arg1512z00_1511;
						BgL_varz00_1669 = BgL_arg1514z00_1512;
						if (BGl_isazf3zf3zz__objectz00(
								((obj_t) BgL_bodyz00_1668), BGl_letzd2varzd2zzast_nodez00))
							{	/* Return/walk.scm 205 */
								bool_t BgL_test2060z00_2724;

								if (NULLP(
										(((BgL_letzd2varzd2_bglt) COBJECT(
													((BgL_letzd2varzd2_bglt) BgL_bodyz00_1668)))->
											BgL_bindingsz00)))
									{	/* Return/walk.scm 205 */
										BgL_nodez00_bglt BgL_arg1759z00_1683;

										BgL_arg1759z00_1683 =
											(((BgL_letzd2varzd2_bglt) COBJECT(
													((BgL_letzd2varzd2_bglt) BgL_bodyz00_1668)))->
											BgL_bodyz00);
										BgL_test2060z00_2724 =
											BGl_isazf3zf3zz__objectz00(((obj_t) BgL_arg1759z00_1683),
											BGl_sequencez00zzast_nodez00);
									}
								else
									{	/* Return/walk.scm 205 */
										BgL_test2060z00_2724 = ((bool_t) 0);
									}
								if (BgL_test2060z00_2724)
									{	/* Return/walk.scm 206 */
										BgL_sequencez00_bglt BgL_i1146z00_1678;

										BgL_i1146z00_1678 =
											((BgL_sequencez00_bglt)
											(((BgL_letzd2varzd2_bglt) COBJECT(
														((BgL_letzd2varzd2_bglt) BgL_bodyz00_1668)))->
												BgL_bodyz00));
										{	/* Return/walk.scm 208 */
											obj_t BgL_arg1757z00_1680;
											BgL_variablez00_bglt BgL_arg1758z00_1681;

											BgL_arg1757z00_1680 =
												(((BgL_sequencez00_bglt) COBJECT(BgL_i1146z00_1678))->
												BgL_nodesz00);
											BgL_arg1758z00_1681 =
												(((BgL_varz00_bglt) COBJECT(BgL_varz00_1669))->
												BgL_variablez00);
											BgL_nodesz00_1650 = BgL_arg1757z00_1680;
											BgL_varz00_1651 =
												((BgL_localz00_bglt) BgL_arg1758z00_1681);
											{	/* Return/walk.scm 194 */
												bool_t BgL_test2062z00_2738;

												if ((bgl_list_length(BgL_nodesz00_1650) == ((long) 2)))
													{	/* Return/walk.scm 194 */
														BgL_nodez00_1628 =
															((BgL_nodez00_bglt)
															CAR(((obj_t) BgL_nodesz00_1650)));
														BgL_exitvarz00_1629 = BgL_varz00_1651;
														if (BGl_isazf3zf3zz__objectz00(
																((obj_t) BgL_nodez00_1628),
																BGl_appz00zzast_nodez00))
															{	/* Return/walk.scm 182 */
																BgL_varz00_bglt BgL_i1142z00_1633;

																BgL_i1142z00_1633 =
																	(((BgL_appz00_bglt) COBJECT(
																			((BgL_appz00_bglt) BgL_nodez00_1628)))->
																	BgL_funz00);
																{	/* Return/walk.scm 184 */
																	bool_t BgL_test2065z00_2747;

																	{	/* Return/walk.scm 184 */
																		BgL_variablez00_bglt BgL_arg1702z00_1649;

																		BgL_arg1702z00_1649 =
																			(((BgL_varz00_bglt)
																				COBJECT(BgL_i1142z00_1633))->
																			BgL_variablez00);
																		BgL_test2065z00_2747 =
																			(((obj_t) BgL_arg1702z00_1649) ==
																			BGl_za2pushzd2exitz12za2zc0zzreturn_walkz00);
																	}
																	if (BgL_test2065z00_2747)
																		{	/* Return/walk.scm 184 */
																			if (
																				(bgl_list_length(
																						(((BgL_appz00_bglt) COBJECT(
																									((BgL_appz00_bglt)
																										BgL_nodez00_1628)))->
																							BgL_argsz00)) == ((long) 2)))
																				{	/* Return/walk.scm 188 */
																					bool_t BgL_test2067z00_2756;

																					{	/* Return/walk.scm 188 */
																						obj_t BgL_arg1693z00_1645;

																						{	/* Return/walk.scm 188 */
																							obj_t BgL_pairz00_2231;

																							BgL_pairz00_2231 =
																								(((BgL_appz00_bglt) COBJECT(
																										((BgL_appz00_bglt)
																											BgL_nodez00_1628)))->
																								BgL_argsz00);
																							BgL_arg1693z00_1645 =
																								CAR(BgL_pairz00_2231);
																						}
																						BgL_test2067z00_2756 =
																							BGl_isazf3zf3zz__objectz00
																							(BgL_arg1693z00_1645,
																							BGl_varz00zzast_nodez00);
																					}
																					if (BgL_test2067z00_2756)
																						{	/* Return/walk.scm 191 */
																							obj_t BgL_tmpz00_2761;

																							{
																								BgL_variablez00_bglt
																									BgL_auxz00_2762;
																								{
																									BgL_varz00_bglt
																										BgL_auxz00_2763;
																									{	/* Return/walk.scm 189 */
																										obj_t BgL_pairz00_2232;

																										BgL_pairz00_2232 =
																											(((BgL_appz00_bglt)
																												COBJECT((
																														(BgL_appz00_bglt)
																														BgL_nodez00_1628)))->
																											BgL_argsz00);
																										BgL_auxz00_2763 =
																											((BgL_varz00_bglt)
																											CAR(BgL_pairz00_2232));
																									}
																									BgL_auxz00_2762 =
																										(((BgL_varz00_bglt)
																											COBJECT
																											(BgL_auxz00_2763))->
																										BgL_variablez00);
																								}
																								BgL_tmpz00_2761 =
																									((obj_t) BgL_auxz00_2762);
																							}
																							BgL_test2062z00_2738 =
																								(BgL_tmpz00_2761 ==
																								((obj_t) BgL_exitvarz00_1629));
																						}
																					else
																						{	/* Return/walk.scm 188 */
																							BgL_test2062z00_2738 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Return/walk.scm 186 */
																					BgL_test2062z00_2738 = ((bool_t) 0);
																				}
																		}
																	else
																		{	/* Return/walk.scm 184 */
																			BgL_test2062z00_2738 = ((bool_t) 0);
																		}
																}
															}
														else
															{	/* Return/walk.scm 180 */
																BgL_test2062z00_2738 = ((bool_t) 0);
															}
													}
												else
													{	/* Return/walk.scm 194 */
														BgL_test2062z00_2738 = ((bool_t) 0);
													}
												if (BgL_test2062z00_2738)
													{	/* Return/walk.scm 195 */
														obj_t BgL_bindingz00_1658;

														{	/* Return/walk.scm 195 */
															obj_t BgL_pairz00_2239;

															BgL_pairz00_2239 =
																CDR(((obj_t) BgL_nodesz00_1650));
															BgL_nodez00_1601 =
																((BgL_nodez00_bglt) CAR(BgL_pairz00_2239));
														}
														if (BGl_isazf3zf3zz__objectz00(
																((obj_t) BgL_nodez00_1601),
																BGl_letzd2varzd2zzast_nodez00))
															{	/* Return/walk.scm 168 */
																bool_t BgL_test2069z00_2778;

																{	/* Return/walk.scm 168 */
																	bool_t BgL_test2070z00_2779;

																	{	/* Return/walk.scm 168 */
																		obj_t BgL_tmpz00_2780;

																		BgL_tmpz00_2780 =
																			(((BgL_letzd2varzd2_bglt) COBJECT(
																					((BgL_letzd2varzd2_bglt)
																						BgL_nodez00_1601)))->
																			BgL_bindingsz00);
																		BgL_test2070z00_2779 =
																			PAIRP(BgL_tmpz00_2780);
																	}
																	if (BgL_test2070z00_2779)
																		{	/* Return/walk.scm 168 */
																			obj_t BgL_tmpz00_2784;

																			{	/* Return/walk.scm 168 */
																				obj_t BgL_pairz00_2223;

																				BgL_pairz00_2223 =
																					(((BgL_letzd2varzd2_bglt) COBJECT(
																							((BgL_letzd2varzd2_bglt)
																								BgL_nodez00_1601)))->
																					BgL_bindingsz00);
																				BgL_tmpz00_2784 = CDR(BgL_pairz00_2223);
																			}
																			BgL_test2069z00_2778 =
																				NULLP(BgL_tmpz00_2784);
																		}
																	else
																		{	/* Return/walk.scm 168 */
																			BgL_test2069z00_2778 = ((bool_t) 0);
																		}
																}
																if (BgL_test2069z00_2778)
																	{	/* Return/walk.scm 169 */
																		obj_t BgL_bindingz00_1611;

																		{	/* Return/walk.scm 169 */
																			obj_t BgL_pairz00_2225;

																			BgL_pairz00_2225 =
																				(((BgL_letzd2varzd2_bglt) COBJECT(
																						((BgL_letzd2varzd2_bglt)
																							BgL_nodez00_1601)))->
																				BgL_bindingsz00);
																			BgL_bindingz00_1611 =
																				CAR(BgL_pairz00_2225);
																		}
																		{	/* Return/walk.scm 170 */
																			obj_t BgL_exprz00_1613;

																			BgL_exprz00_1613 =
																				CDR(((obj_t) BgL_bindingz00_1611));
																			{	/* Return/walk.scm 171 */

																				if (BGl_isazf3zf3zz__objectz00
																					(BgL_exprz00_1613,
																						BGl_appz00zzast_nodez00))
																					{	/* Return/walk.scm 172 */
																						if (NULLP(
																								(((BgL_appz00_bglt) COBJECT(
																											((BgL_appz00_bglt)
																												BgL_exprz00_1613)))->
																									BgL_argsz00)))
																							{	/* Return/walk.scm 176 */
																								bool_t BgL_test2073z00_2800;

																								{	/* Return/walk.scm 176 */
																									BgL_variablez00_bglt
																										BgL_arg1664z00_1621;
																									BgL_arg1664z00_1621 =
																										(((BgL_varz00_bglt)
																											COBJECT(((
																														(BgL_appz00_bglt)
																														COBJECT((
																																(BgL_appz00_bglt)
																																BgL_exprz00_1613)))->
																													BgL_funz00)))->
																										BgL_variablez00);
																									BgL_test2073z00_2800 =
																										(((obj_t)
																											BgL_arg1664z00_1621) ==
																										BGl_za2getzd2exitdzd2topza2z00zzreturn_walkz00);
																								}
																								if (BgL_test2073z00_2800)
																									{	/* Return/walk.scm 176 */
																										BgL_bindingz00_1658 =
																											BgL_bindingz00_1611;
																									}
																								else
																									{	/* Return/walk.scm 176 */
																										BgL_bindingz00_1658 =
																											BFALSE;
																									}
																							}
																						else
																							{	/* Return/walk.scm 174 */
																								BgL_bindingz00_1658 = BFALSE;
																							}
																					}
																				else
																					{	/* Return/walk.scm 172 */
																						BgL_bindingz00_1658 = BFALSE;
																					}
																			}
																		}
																	}
																else
																	{	/* Return/walk.scm 168 */
																		BgL_bindingz00_1658 = BFALSE;
																	}
															}
														else
															{	/* Return/walk.scm 166 */
																BgL_bindingz00_1658 = BFALSE;
															}
														if (CBOOL(BgL_bindingz00_1658))
															{	/* Return/walk.scm 197 */
																BgL_letzd2varzd2_bglt BgL_i1144z00_1659;

																{	/* Return/walk.scm 197 */
																	obj_t BgL_pairz00_2243;

																	BgL_pairz00_2243 =
																		CDR(((obj_t) BgL_nodesz00_1650));
																	BgL_i1144z00_1659 =
																		((BgL_letzd2varzd2_bglt)
																		CAR(BgL_pairz00_2243));
																}
																{	/* Return/walk.scm 198 */
																	obj_t BgL_exitnodez00_1660;

																	{	/* Return/walk.scm 198 */
																		BgL_nodez00_bglt BgL_arg1716z00_1662;
																		obj_t BgL_arg1719z00_1663;

																		BgL_arg1716z00_1662 =
																			(((BgL_letzd2varzd2_bglt)
																				COBJECT(BgL_i1144z00_1659))->
																			BgL_bodyz00);
																		BgL_arg1719z00_1663 =
																			CAR(((obj_t) BgL_bindingz00_1658));
																		BgL_nodez00_1573 = BgL_arg1716z00_1662;
																		BgL_varz00_1574 =
																			((BgL_localz00_bglt) BgL_arg1719z00_1663);
																		if (BGl_isazf3zf3zz__objectz00(
																				((obj_t) BgL_nodez00_1573),
																				BGl_letzd2varzd2zzast_nodez00))
																			{	/* Return/walk.scm 158 */
																				bool_t BgL_test2076z00_2822;

																				{	/* Return/walk.scm 158 */
																					bool_t BgL_test2077z00_2823;

																					{	/* Return/walk.scm 158 */
																						obj_t BgL_tmpz00_2824;

																						BgL_tmpz00_2824 =
																							(((BgL_letzd2varzd2_bglt) COBJECT(
																									((BgL_letzd2varzd2_bglt)
																										BgL_nodez00_1573)))->
																							BgL_bindingsz00);
																						BgL_test2077z00_2823 =
																							PAIRP(BgL_tmpz00_2824);
																					}
																					if (BgL_test2077z00_2823)
																						{	/* Return/walk.scm 158 */
																							obj_t BgL_tmpz00_2828;

																							{	/* Return/walk.scm 158 */
																								obj_t BgL_pairz00_2213;

																								BgL_pairz00_2213 =
																									(((BgL_letzd2varzd2_bglt)
																										COBJECT((
																												(BgL_letzd2varzd2_bglt)
																												BgL_nodez00_1573)))->
																									BgL_bindingsz00);
																								BgL_tmpz00_2828 =
																									CDR(BgL_pairz00_2213);
																							}
																							BgL_test2076z00_2822 =
																								NULLP(BgL_tmpz00_2828);
																						}
																					else
																						{	/* Return/walk.scm 158 */
																							BgL_test2076z00_2822 =
																								((bool_t) 0);
																						}
																				}
																				if (BgL_test2076z00_2822)
																					{	/* Return/walk.scm 159 */
																						obj_t BgL_bindingz00_1584;

																						{	/* Return/walk.scm 159 */
																							obj_t BgL_pairz00_2215;

																							BgL_pairz00_2215 =
																								(((BgL_letzd2varzd2_bglt)
																									COBJECT((
																											(BgL_letzd2varzd2_bglt)
																											BgL_nodez00_1573)))->
																								BgL_bindingsz00);
																							BgL_bindingz00_1584 =
																								CAR(BgL_pairz00_2215);
																						}
																						{	/* Return/walk.scm 159 */
																							obj_t BgL_nbodyz00_1585;

																							{	/* Return/walk.scm 160 */
																								BgL_nodez00_bglt
																									BgL_arg1633z00_1594;
																								obj_t BgL_arg1636z00_1595;

																								BgL_arg1633z00_1594 =
																									(((BgL_letzd2varzd2_bglt)
																										COBJECT((
																												(BgL_letzd2varzd2_bglt)
																												BgL_nodez00_1573)))->
																									BgL_bodyz00);
																								BgL_arg1636z00_1595 =
																									CAR(((obj_t)
																										BgL_bindingz00_1584));
																								BgL_nbodyz00_1585 =
																									BGl_step6ze70ze7zzreturn_walkz00
																									(BgL_arg1633z00_1594,
																									((BgL_localz00_bglt)
																										BgL_arg1636z00_1595));
																							}
																							{	/* Return/walk.scm 160 */

																								if (CBOOL(BgL_nbodyz00_1585))
																									{	/* Return/walk.scm 162 */
																										BgL_nodez00_bglt
																											BgL_duplicated1132z00_1586;
																										BgL_letzd2varzd2_bglt
																											BgL_new1130z00_1587;
																										BgL_duplicated1132z00_1586 =
																											BgL_nodez00_1573;
																										{	/* Return/walk.scm 162 */
																											BgL_letzd2varzd2_bglt
																												BgL_new1137z00_1592;
																											BgL_new1137z00_1592 =
																												((BgL_letzd2varzd2_bglt)
																												BOBJECT(GC_MALLOC(sizeof
																														(struct
																															BgL_letzd2varzd2_bgl))));
																											{	/* Return/walk.scm 162 */
																												long
																													BgL_arg1631z00_1593;
																												{	/* Return/walk.scm 162 */
																													long
																														BgL_res1936z00_2218;
																													BgL_res1936z00_2218 =
																														BGL_CLASS_INDEX
																														(BGl_letzd2varzd2zzast_nodez00);
																													BgL_arg1631z00_1593 =
																														BgL_res1936z00_2218;
																												}
																												BGL_OBJECT_CLASS_NUM_SET
																													(((BgL_objectz00_bglt)
																														BgL_new1137z00_1592),
																													BgL_arg1631z00_1593);
																											}
																											{	/* Return/walk.scm 162 */
																												BgL_objectz00_bglt
																													BgL_tmpz00_2848;
																												BgL_tmpz00_2848 =
																													((BgL_objectz00_bglt)
																													BgL_new1137z00_1592);
																												BGL_OBJECT_WIDENING_SET
																													(BgL_tmpz00_2848,
																													BFALSE);
																											}
																											((BgL_objectz00_bglt)
																												BgL_new1137z00_1592);
																											BgL_new1130z00_1587 =
																												BgL_new1137z00_1592;
																										}
																										((((BgL_nodez00_bglt)
																													COBJECT((
																															(BgL_nodez00_bglt)
																															BgL_new1130z00_1587)))->
																												BgL_locz00) =
																											((obj_t) ((
																														(BgL_nodez00_bglt)
																														COBJECT
																														(BgL_duplicated1132z00_1586))->
																													BgL_locz00)),
																											BUNSPEC);
																										((((BgL_nodez00_bglt)
																													COBJECT((
																															(BgL_nodez00_bglt)
																															BgL_new1130z00_1587)))->
																												BgL_typez00) =
																											((BgL_typez00_bglt) ((
																														(BgL_nodez00_bglt)
																														COBJECT
																														(BgL_duplicated1132z00_1586))->
																													BgL_typez00)),
																											BUNSPEC);
																										((((BgL_nodezf2effectzf2_bglt) COBJECT(((BgL_nodezf2effectzf2_bglt) BgL_new1130z00_1587)))->BgL_sidezd2effectzd2) = ((obj_t) (((BgL_nodezf2effectzf2_bglt) COBJECT(((BgL_nodezf2effectzf2_bglt) BgL_duplicated1132z00_1586)))->BgL_sidezd2effectzd2)), BUNSPEC);
																										((((BgL_nodezf2effectzf2_bglt) COBJECT(((BgL_nodezf2effectzf2_bglt) BgL_new1130z00_1587)))->BgL_keyz00) = ((obj_t) (((BgL_nodezf2effectzf2_bglt) COBJECT(((BgL_nodezf2effectzf2_bglt) BgL_duplicated1132z00_1586)))->BgL_keyz00)), BUNSPEC);
																										((((BgL_letzd2varzd2_bglt)
																													COBJECT
																													(BgL_new1130z00_1587))->
																												BgL_bindingsz00) =
																											((obj_t) ((
																														(BgL_letzd2varzd2_bglt)
																														COBJECT((
																																(BgL_letzd2varzd2_bglt)
																																BgL_duplicated1132z00_1586)))->
																													BgL_bindingsz00)),
																											BUNSPEC);
																										((((BgL_letzd2varzd2_bglt)
																													COBJECT
																													(BgL_new1130z00_1587))->
																												BgL_bodyz00) =
																											((BgL_nodez00_bglt) (
																													(BgL_nodez00_bglt)
																													BgL_nbodyz00_1585)),
																											BUNSPEC);
																										((((BgL_letzd2varzd2_bglt)
																													COBJECT
																													(BgL_new1130z00_1587))->
																												BgL_removablezf3zf3) =
																											((bool_t) ((
																														(BgL_letzd2varzd2_bglt)
																														COBJECT((
																																(BgL_letzd2varzd2_bglt)
																																BgL_duplicated1132z00_1586)))->
																													BgL_removablezf3zf3)),
																											BUNSPEC);
																										BgL_exitnodez00_1660 =
																											((obj_t)
																											BgL_new1130z00_1587);
																									}
																								else
																									{	/* Return/walk.scm 161 */
																										BgL_exitnodez00_1660 =
																											BFALSE;
																									}
																							}
																						}
																					}
																				else
																					{	/* Return/walk.scm 158 */
																						BgL_exitnodez00_1660 = BFALSE;
																					}
																			}
																		else
																			{	/* Return/walk.scm 156 */
																				BgL_exitnodez00_1660 = BFALSE;
																			}
																	}
																	if (CBOOL(BgL_exitnodez00_1660))
																		{	/* Return/walk.scm 200 */
																			obj_t BgL_arg1715z00_1661;

																			BgL_arg1715z00_1661 =
																				CAR(((obj_t) BgL_bindingz00_1658));
																			return
																				MAKE_YOUNG_PAIR(BgL_arg1715z00_1661,
																				BgL_exitnodez00_1660);
																		}
																	else
																		{	/* Return/walk.scm 199 */
																			return BFALSE;
																		}
																}
															}
														else
															{	/* Return/walk.scm 196 */
																return BFALSE;
															}
													}
												else
													{	/* Return/walk.scm 194 */
														return BFALSE;
													}
											}
										}
									}
								else
									{	/* Return/walk.scm 205 */
										return BFALSE;
									}
							}
						else
							{	/* Return/walk.scm 203 */
								return BFALSE;
							}
					}
				else
					{	/* Return/walk.scm 210 */
						return BFALSE;
					}
			}
		}

	}



/* step8~0 */
	obj_t BGl_step8ze70ze7zzreturn_walkz00(BgL_nodez00_bglt BgL_nodez00_1513,
		BgL_localz00_bglt BgL_resz00_1514)
	{
		{	/* Return/walk.scm 139 */
			if (BGl_isazf3zf3zz__objectz00(
					((obj_t) BgL_nodez00_1513), BGl_varz00zzast_nodez00))
				{	/* Return/walk.scm 126 */
					if (
						(((obj_t)
								(((BgL_varz00_bglt) COBJECT(
											((BgL_varz00_bglt) BgL_nodez00_1513)))->
									BgL_variablez00)) == ((obj_t) BgL_resz00_1514)))
						{	/* Return/walk.scm 128 */
							return ((obj_t) BgL_nodez00_1513);
						}
					else
						{	/* Return/walk.scm 128 */
							return BFALSE;
						}
				}
			else
				{	/* Return/walk.scm 126 */
					if (BGl_isazf3zf3zz__objectz00(
							((obj_t) BgL_nodez00_1513), BGl_appz00zzast_nodez00))
						{	/* Return/walk.scm 132 */
							bool_t BgL_test2083z00_2895;

							{
								obj_t BgL_l1339z00_1535;

								{	/* Return/walk.scm 132 */
									obj_t BgL_tmpz00_2896;

									BgL_l1339z00_1535 =
										(((BgL_appz00_bglt) COBJECT(
												((BgL_appz00_bglt) BgL_nodez00_1513)))->BgL_argsz00);
								BgL_zc3z04anonymousza31530ze3z87_1536:
									if (NULLP(BgL_l1339z00_1535))
										{	/* Return/walk.scm 132 */
											BgL_tmpz00_2896 = BFALSE;
										}
									else
										{	/* Return/walk.scm 132 */
											obj_t BgL__ortest_1342z00_1538;

											BgL__ortest_1342z00_1538 =
												BGl_step8ze70ze7zzreturn_walkz00(
												((BgL_nodez00_bglt)
													CAR(((obj_t) BgL_l1339z00_1535))), BgL_resz00_1514);
											if (CBOOL(BgL__ortest_1342z00_1538))
												{	/* Return/walk.scm 132 */
													BgL_tmpz00_2896 = BgL__ortest_1342z00_1538;
												}
											else
												{
													obj_t BgL_l1339z00_2905;

													BgL_l1339z00_2905 = CDR(((obj_t) BgL_l1339z00_1535));
													BgL_l1339z00_1535 = BgL_l1339z00_2905;
													goto BgL_zc3z04anonymousza31530ze3z87_1536;
												}
										}
									BgL_test2083z00_2895 = CBOOL(BgL_tmpz00_2896);
								}
							}
							if (BgL_test2083z00_2895)
								{	/* Return/walk.scm 132 */
									return ((obj_t) BgL_nodez00_1513);
								}
							else
								{	/* Return/walk.scm 132 */
									return BFALSE;
								}
						}
					else
						{	/* Return/walk.scm 130 */
							if (BGl_isazf3zf3zz__objectz00(
									((obj_t) BgL_nodez00_1513), BGl_castz00zzast_nodez00))
								{	/* Return/walk.scm 134 */
									if (CBOOL(BGl_step8ze70ze7zzreturn_walkz00(
												(((BgL_castz00_bglt) COBJECT(
															((BgL_castz00_bglt) BgL_nodez00_1513)))->
													BgL_argz00), BgL_resz00_1514)))
										{	/* Return/walk.scm 136 */
											return ((obj_t) BgL_nodez00_1513);
										}
									else
										{	/* Return/walk.scm 136 */
											return BFALSE;
										}
								}
							else
								{	/* Return/walk.scm 134 */
									return BFALSE;
								}
						}
				}
		}

	}



/* step6~0 */
	obj_t BGl_step6ze70ze7zzreturn_walkz00(BgL_nodez00_bglt BgL_nodez00_1556,
		BgL_localz00_bglt BgL_varz00_1557)
	{
		{	/* Return/walk.scm 153 */
			{
				BgL_nodez00_bglt BgL_nodez00_1547;

				if (BGl_isazf3zf3zz__objectz00(
						((obj_t) BgL_nodez00_1556), BGl_sequencez00zzast_nodez00))
					{	/* Return/walk.scm 149 */
						if (
							(bgl_list_length(
									(((BgL_sequencez00_bglt) COBJECT(
												((BgL_sequencez00_bglt) BgL_nodez00_1556)))->
										BgL_nodesz00)) == ((long) 2)))
							{	/* Return/walk.scm 152 */
								bool_t BgL_test2090z00_2929;

								{	/* Return/walk.scm 152 */
									obj_t BgL_pairz00_2207;

									BgL_pairz00_2207 =
										(((BgL_sequencez00_bglt) COBJECT(
												((BgL_sequencez00_bglt) BgL_nodez00_1556)))->
										BgL_nodesz00);
									BgL_nodez00_1547 = ((BgL_nodez00_bglt) CAR(BgL_pairz00_2207));
								}
								if (BGl_isazf3zf3zz__objectz00(
										((obj_t) BgL_nodez00_1547), BGl_appz00zzast_nodez00))
									{	/* Return/walk.scm 142 */
										if (NULLP(
												(((BgL_appz00_bglt) COBJECT(
															((BgL_appz00_bglt) BgL_nodez00_1547)))->
													BgL_argsz00)))
											{	/* Return/walk.scm 145 */
												BgL_varz00_bglt BgL_i1127z00_1553;

												BgL_i1127z00_1553 =
													(((BgL_appz00_bglt) COBJECT(
															((BgL_appz00_bglt) BgL_nodez00_1547)))->
													BgL_funz00);
												{	/* Return/walk.scm 146 */
													BgL_variablez00_bglt BgL_arg1551z00_1554;

													BgL_arg1551z00_1554 =
														(((BgL_varz00_bglt) COBJECT(BgL_i1127z00_1553))->
														BgL_variablez00);
													BgL_test2090z00_2929 =
														(((obj_t) BgL_arg1551z00_1554) ==
														BGl_za2popzd2exitz12za2zc0zzreturn_walkz00);
												}
											}
										else
											{	/* Return/walk.scm 144 */
												BgL_test2090z00_2929 = ((bool_t) 0);
											}
									}
								else
									{	/* Return/walk.scm 142 */
										BgL_test2090z00_2929 = ((bool_t) 0);
									}
								if (BgL_test2090z00_2929)
									{	/* Return/walk.scm 153 */
										BgL_nodez00_bglt BgL_auxz00_2946;

										{
											obj_t BgL_auxz00_2947;

											{	/* Return/walk.scm 153 */
												obj_t BgL_pairz00_2208;

												BgL_pairz00_2208 =
													(((BgL_sequencez00_bglt) COBJECT(
															((BgL_sequencez00_bglt) BgL_nodez00_1556)))->
													BgL_nodesz00);
												BgL_auxz00_2947 = CAR(CDR(BgL_pairz00_2208));
											}
											BgL_auxz00_2946 = ((BgL_nodez00_bglt) BgL_auxz00_2947);
										}
										return
											BGl_step8ze70ze7zzreturn_walkz00(BgL_auxz00_2946,
											BgL_varz00_1557);
									}
								else
									{	/* Return/walk.scm 152 */
										return BFALSE;
									}
							}
						else
							{	/* Return/walk.scm 151 */
								return BFALSE;
							}
					}
				else
					{	/* Return/walk.scm 149 */
						return BFALSE;
					}
			}
		}

	}



/* &function-exit-node */
	obj_t BGl_z62functionzd2exitzd2nodez62zzreturn_walkz00(obj_t BgL_envz00_2399,
		obj_t BgL_nodez00_2400)
	{
		{	/* Return/walk.scm 122 */
			return
				BGl_functionzd2exitzd2nodez00zzreturn_walkz00(
				((BgL_nodez00_bglt) BgL_nodez00_2400));
		}

	}



/* is-unwind-until? */
	BGL_EXPORTED_DEF bool_t
		BGl_iszd2unwindzd2untilzf3zf3zzreturn_walkz00(BgL_variablez00_bglt
		BgL_vz00_20)
	{
		{	/* Return/walk.scm 217 */
			return
				(
				((obj_t) BgL_vz00_20) ==
				BGl_za2unwindzd2untilz12za2zc0zzreturn_walkz00);
		}

	}



/* &is-unwind-until? */
	obj_t BGl_z62iszd2unwindzd2untilzf3z91zzreturn_walkz00(obj_t BgL_envz00_2401,
		obj_t BgL_vz00_2402)
	{
		{	/* Return/walk.scm 217 */
			return
				BBOOL(BGl_iszd2unwindzd2untilzf3zf3zzreturn_walkz00(
					((BgL_variablez00_bglt) BgL_vz00_2402)));
		}

	}



/* is-get-exitd-top? */
	BGL_EXPORTED_DEF bool_t
		BGl_iszd2getzd2exitdzd2topzf3z21zzreturn_walkz00(BgL_variablez00_bglt
		BgL_vz00_21)
	{
		{	/* Return/walk.scm 223 */
			return
				(
				((obj_t) BgL_vz00_21) ==
				BGl_za2getzd2exitdzd2topza2z00zzreturn_walkz00);
		}

	}



/* &is-get-exitd-top? */
	obj_t BGl_z62iszd2getzd2exitdzd2topzf3z43zzreturn_walkz00(obj_t
		BgL_envz00_2403, obj_t BgL_vz00_2404)
	{
		{	/* Return/walk.scm 223 */
			return
				BBOOL(BGl_iszd2getzd2exitdzd2topzf3z21zzreturn_walkz00(
					((BgL_variablez00_bglt) BgL_vz00_2404)));
		}

	}



/* is-exit-return? */
	BGL_EXPORTED_DEF bool_t
		BGl_iszd2exitzd2returnzf3zf3zzreturn_walkz00(BgL_nodez00_bglt
		BgL_nodez00_22, BgL_localz00_bglt BgL_exitvarz00_23)
	{
		{	/* Return/walk.scm 231 */
			return
				CBOOL(BGl_zc3z04exitza31761ze3ze70z60zzreturn_walkz00(BgL_nodez00_22,
					BgL_exitvarz00_23));
		}

	}



/* <@exit:1761>~0 */
	obj_t BGl_zc3z04exitza31761ze3ze70z60zzreturn_walkz00(BgL_nodez00_bglt
		BgL_nodez00_2459, BgL_localz00_bglt BgL_exitvarz00_2458)
	{
		{	/* Return/walk.scm 232 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1149z00_1694;

			if (SET_EXIT(BgL_an_exit1149z00_1694))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1149z00_1694 = (void *) jmpbuf;
					{	/* Return/walk.scm 232 */

						PUSH_EXIT(BgL_an_exit1149z00_1694, ((long) 1));
						{	/* Return/walk.scm 232 */
							obj_t BgL_an_exitd1150z00_1695;

							BgL_an_exitd1150z00_1695 = ((obj_t) (&exitd));
							{	/* Return/walk.scm 232 */
								obj_t BgL_abortz00_2405;

								BgL_abortz00_2405 =
									MAKE_FX_PROCEDURE(BGl_z62abortz62zzreturn_walkz00,
									(int) (((long) 1)), (int) (((long) 1)));
								PROCEDURE_SET(BgL_abortz00_2405,
									(int) (((long) 0)), BgL_an_exitd1150z00_1695);
								{	/* Return/walk.scm 232 */
									bool_t BgL_res1152z00_1698;

									{	/* Return/walk.scm 233 */
										obj_t BgL_arg1762z00_1699;

										{	/* Return/walk.scm 233 */
											obj_t BgL_list1763z00_1700;

											BgL_list1763z00_1700 =
												MAKE_YOUNG_PAIR(((obj_t) BgL_exitvarz00_2458), BNIL);
											BgL_arg1762z00_1699 = BgL_list1763z00_1700;
										}
										BGl_iszd2returnzf3z21zzreturn_walkz00(BgL_nodez00_2459,
											BgL_arg1762z00_1699, BgL_abortz00_2405);
									}
									BgL_res1152z00_1698 = ((bool_t) 1);
									POP_EXIT();
									return BBOOL(BgL_res1152z00_1698);
								}
							}
						}
					}
				}
		}

	}



/* &is-exit-return? */
	obj_t BGl_z62iszd2exitzd2returnzf3z91zzreturn_walkz00(obj_t BgL_envz00_2406,
		obj_t BgL_nodez00_2407, obj_t BgL_exitvarz00_2408)
	{
		{	/* Return/walk.scm 231 */
			return
				BBOOL(BGl_iszd2exitzd2returnzf3zf3zzreturn_walkz00(
					((BgL_nodez00_bglt) BgL_nodez00_2407),
					((BgL_localz00_bglt) BgL_exitvarz00_2408)));
		}

	}



/* &abort */
	obj_t BGl_z62abortz62zzreturn_walkz00(obj_t BgL_envz00_2409,
		obj_t BgL_val1151z00_2411)
	{
		{	/* Return/walk.scm 232 */
			return
				BGl_unwindzd2untilz12zc0zz__bexitz00(PROCEDURE_REF(BgL_envz00_2409,
					(int) (((long) 0))), BgL_val1151z00_2411);
		}

	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzreturn_walkz00()
	{
		{	/* Return/walk.scm 16 */
			return BUNSPEC;
		}

	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzreturn_walkz00()
	{
		{	/* Return/walk.scm 16 */
			BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_iszd2returnzf3zd2envzf3zzreturn_walkz00,
				BGl_proc1990z00zzreturn_walkz00, BGl_nodez00zzast_nodez00,
				BGl_string1991z00zzreturn_walkz00);
			BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_returnz12zd2envzc0zzreturn_walkz00,
				BGl_proc1992z00zzreturn_walkz00, BGl_nodez00zzast_nodez00,
				BGl_string1993z00zzreturn_walkz00);
			return
				BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_returnzd2gotozd2funsz12zd2envzc0zzreturn_walkz00,
				BGl_proc1994z00zzreturn_walkz00, BGl_nodez00zzast_nodez00,
				BGl_string1995z00zzreturn_walkz00);
		}

	}



/* &return-goto-funs!1359 */
	obj_t BGl_z62returnzd2gotozd2funsz121359z70zzreturn_walkz00(obj_t
		BgL_envz00_2425, obj_t BgL_nodez00_2426)
	{
		{	/* Return/walk.scm 317 */
			return
				((obj_t)
				BGl_walk0z12z12zzast_walkz00(
					((BgL_nodez00_bglt) BgL_nodez00_2426),
					BGl_returnzd2gotozd2funsz12zd2envzc0zzreturn_walkz00));
		}

	}



/* &return!1354 */
	obj_t BGl_z62returnz121354z70zzreturn_walkz00(obj_t BgL_envz00_2427,
		obj_t BgL_nodez00_2428, obj_t BgL_exitvarz00_2429, obj_t BgL_rblockz00_2430)
	{
		{	/* Return/walk.scm 291 */
			{
				BgL_nodez00_bglt BgL_auxz00_2994;

				{

					BgL_auxz00_2994 =
						BGl_walk2z12z12zzast_walkz00(
						((BgL_nodez00_bglt) BgL_nodez00_2428),
						BGl_returnz12zd2envzc0zzreturn_walkz00,
						((obj_t) ((BgL_localz00_bglt) BgL_exitvarz00_2429)),
						((obj_t) ((BgL_retblockz00_bglt) BgL_rblockz00_2430)));
				}
				return ((obj_t) BgL_auxz00_2994);
			}
		}

	}



/* &is-return?1346 */
	obj_t BGl_z62iszd2returnzf31346z43zzreturn_walkz00(obj_t BgL_envz00_2431,
		obj_t BgL_nodez00_2432, obj_t BgL_exitvarz00_2433, obj_t BgL_abortz00_2434)
	{
		{	/* Return/walk.scm 239 */
			{

				return
					BGl_walk2z00zzast_walkz00(
					((BgL_nodez00_bglt) BgL_nodez00_2432),
					BGl_iszd2returnzf3zd2envzf3zzreturn_walkz00,
					((obj_t) BgL_exitvarz00_2433), BgL_abortz00_2434);
			}
		}

	}



/* is-return? */
	obj_t BGl_iszd2returnzf3z21zzreturn_walkz00(BgL_nodez00_bglt BgL_nodez00_24,
		obj_t BgL_exitvarz00_25, obj_t BgL_abortz00_26)
	{
		{	/* Return/walk.scm 239 */
			{	/* Return/walk.scm 239 */
				obj_t BgL_method1347z00_1758;

				{	/* Return/walk.scm 239 */
					obj_t BgL_res1954z00_2287;

					{	/* Return/walk.scm 239 */
						long BgL_objzd2classzd2numz00_2252;

						{	/* Return/walk.scm 239 */
							long BgL_res1944z00_2255;

							BgL_res1944z00_2255 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nodez00_24));
							BgL_objzd2classzd2numz00_2252 = BgL_res1944z00_2255;
						}
						{	/* Return/walk.scm 239 */
							obj_t BgL_arg1742z00_2253;

							BgL_arg1742z00_2253 =
								PROCEDURE_REF(BGl_iszd2returnzf3zd2envzf3zzreturn_walkz00,
								(int) (((long) 1)));
							{	/* Return/walk.scm 239 */
								int BgL_offsetz00_2257;

								BgL_offsetz00_2257 = (int) (BgL_objzd2classzd2numz00_2252);
								{	/* Return/walk.scm 239 */
									long BgL_offsetz00_2258;

									BgL_offsetz00_2258 =
										((long) (BgL_offsetz00_2257) - OBJECT_TYPE);
									{	/* Return/walk.scm 239 */
										long BgL_modz00_2259;

										BgL_modz00_2259 =
											(BgL_offsetz00_2258 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Return/walk.scm 239 */
											long BgL_restz00_2261;

											BgL_restz00_2261 =
												(BgL_offsetz00_2258 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Return/walk.scm 239 */

												{	/* Return/walk.scm 239 */
													obj_t BgL_bucketz00_2263;

													BgL_bucketz00_2263 =
														VECTOR_REF(
														((obj_t) BgL_arg1742z00_2253), BgL_modz00_2259);
													BgL_res1954z00_2287 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_2263), BgL_restz00_2261);
					}}}}}}}}
					BgL_method1347z00_1758 = BgL_res1954z00_2287;
				}
				return
					PROCEDURE_ENTRY(BgL_method1347z00_1758) (BgL_method1347z00_1758,
					((obj_t) BgL_nodez00_24), BgL_exitvarz00_25, BgL_abortz00_26, BEOA);
			}
		}

	}



/* &is-return? */
	obj_t BGl_z62iszd2returnzf3z43zzreturn_walkz00(obj_t BgL_envz00_2421,
		obj_t BgL_nodez00_2422, obj_t BgL_exitvarz00_2423, obj_t BgL_abortz00_2424)
	{
		{	/* Return/walk.scm 239 */
			return
				BGl_iszd2returnzf3z21zzreturn_walkz00(
				((BgL_nodez00_bglt) BgL_nodez00_2422), BgL_exitvarz00_2423,
				BgL_abortz00_2424);
		}

	}



/* return! */
	BgL_nodez00_bglt BGl_returnz12z12zzreturn_walkz00(BgL_nodez00_bglt
		BgL_nodez00_36, BgL_localz00_bglt BgL_exitvarz00_37,
		BgL_retblockz00_bglt BgL_rblockz00_38)
	{
		{	/* Return/walk.scm 291 */
			{	/* Return/walk.scm 291 */
				obj_t BgL_method1356z00_1759;

				{	/* Return/walk.scm 291 */
					obj_t BgL_res1965z00_2324;

					{	/* Return/walk.scm 291 */
						long BgL_objzd2classzd2numz00_2289;

						{	/* Return/walk.scm 291 */
							long BgL_res1955z00_2292;

							BgL_res1955z00_2292 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nodez00_36));
							BgL_objzd2classzd2numz00_2289 = BgL_res1955z00_2292;
						}
						{	/* Return/walk.scm 291 */
							obj_t BgL_arg1742z00_2290;

							BgL_arg1742z00_2290 =
								PROCEDURE_REF(BGl_returnz12zd2envzc0zzreturn_walkz00,
								(int) (((long) 1)));
							{	/* Return/walk.scm 291 */
								int BgL_offsetz00_2294;

								BgL_offsetz00_2294 = (int) (BgL_objzd2classzd2numz00_2289);
								{	/* Return/walk.scm 291 */
									long BgL_offsetz00_2295;

									BgL_offsetz00_2295 =
										((long) (BgL_offsetz00_2294) - OBJECT_TYPE);
									{	/* Return/walk.scm 291 */
										long BgL_modz00_2296;

										BgL_modz00_2296 =
											(BgL_offsetz00_2295 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Return/walk.scm 291 */
											long BgL_restz00_2298;

											BgL_restz00_2298 =
												(BgL_offsetz00_2295 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Return/walk.scm 291 */

												{	/* Return/walk.scm 291 */
													obj_t BgL_bucketz00_2300;

													BgL_bucketz00_2300 =
														VECTOR_REF(
														((obj_t) BgL_arg1742z00_2290), BgL_modz00_2296);
													BgL_res1965z00_2324 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_2300), BgL_restz00_2298);
					}}}}}}}}
					BgL_method1356z00_1759 = BgL_res1965z00_2324;
				}
				return
					((BgL_nodez00_bglt)
					PROCEDURE_ENTRY(BgL_method1356z00_1759) (BgL_method1356z00_1759,
						((obj_t) BgL_nodez00_36),
						((obj_t) BgL_exitvarz00_37), ((obj_t) BgL_rblockz00_38), BEOA));
			}
		}

	}



/* &return! */
	BgL_nodez00_bglt BGl_z62returnz12z70zzreturn_walkz00(obj_t BgL_envz00_2416,
		obj_t BgL_nodez00_2417, obj_t BgL_exitvarz00_2418, obj_t BgL_rblockz00_2419)
	{
		{	/* Return/walk.scm 291 */
			return
				BGl_returnz12z12zzreturn_walkz00(
				((BgL_nodez00_bglt) BgL_nodez00_2417),
				((BgL_localz00_bglt) BgL_exitvarz00_2418),
				((BgL_retblockz00_bglt) BgL_rblockz00_2419));
		}

	}



/* return-goto-funs! */
	BgL_nodez00_bglt
		BGl_returnzd2gotozd2funsz12z12zzreturn_walkz00(BgL_nodez00_bglt
		BgL_nodez00_42)
	{
		{	/* Return/walk.scm 317 */
			{	/* Return/walk.scm 317 */
				obj_t BgL_method1360z00_1760;

				{	/* Return/walk.scm 317 */
					obj_t BgL_res1976z00_2361;

					{	/* Return/walk.scm 317 */
						long BgL_objzd2classzd2numz00_2326;

						{	/* Return/walk.scm 317 */
							long BgL_res1966z00_2329;

							BgL_res1966z00_2329 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nodez00_42));
							BgL_objzd2classzd2numz00_2326 = BgL_res1966z00_2329;
						}
						{	/* Return/walk.scm 317 */
							obj_t BgL_arg1742z00_2327;

							BgL_arg1742z00_2327 =
								PROCEDURE_REF
								(BGl_returnzd2gotozd2funsz12zd2envzc0zzreturn_walkz00,
								(int) (((long) 1)));
							{	/* Return/walk.scm 317 */
								int BgL_offsetz00_2331;

								BgL_offsetz00_2331 = (int) (BgL_objzd2classzd2numz00_2326);
								{	/* Return/walk.scm 317 */
									long BgL_offsetz00_2332;

									BgL_offsetz00_2332 =
										((long) (BgL_offsetz00_2331) - OBJECT_TYPE);
									{	/* Return/walk.scm 317 */
										long BgL_modz00_2333;

										BgL_modz00_2333 =
											(BgL_offsetz00_2332 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Return/walk.scm 317 */
											long BgL_restz00_2335;

											BgL_restz00_2335 =
												(BgL_offsetz00_2332 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Return/walk.scm 317 */

												{	/* Return/walk.scm 317 */
													obj_t BgL_bucketz00_2337;

													BgL_bucketz00_2337 =
														VECTOR_REF(
														((obj_t) BgL_arg1742z00_2327), BgL_modz00_2333);
													BgL_res1976z00_2361 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_2337), BgL_restz00_2335);
					}}}}}}}}
					BgL_method1360z00_1760 = BgL_res1976z00_2361;
				}
				return
					((BgL_nodez00_bglt)
					PROCEDURE_ENTRY(BgL_method1360z00_1760) (BgL_method1360z00_1760,
						((obj_t) BgL_nodez00_42), BEOA));
			}
		}

	}



/* &return-goto-funs! */
	BgL_nodez00_bglt BGl_z62returnzd2gotozd2funsz12z70zzreturn_walkz00(obj_t
		BgL_envz00_2413, obj_t BgL_nodez00_2414)
	{
		{	/* Return/walk.scm 317 */
			return
				BGl_returnzd2gotozd2funsz12z12zzreturn_walkz00(
				((BgL_nodez00_bglt) BgL_nodez00_2414));
		}

	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzreturn_walkz00()
	{
		{	/* Return/walk.scm 16 */
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_iszd2returnzf3zd2envzf3zzreturn_walkz00, BGl_varz00zzast_nodez00,
				BGl_proc1996z00zzreturn_walkz00, BGl_string1997z00zzreturn_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_iszd2returnzf3zd2envzf3zzreturn_walkz00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc1998z00zzreturn_walkz00,
				BGl_string1997z00zzreturn_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_iszd2returnzf3zd2envzf3zzreturn_walkz00, BGl_appz00zzast_nodez00,
				BGl_proc1999z00zzreturn_walkz00, BGl_string1997z00zzreturn_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_returnz12zd2envzc0zzreturn_walkz00, BGl_appz00zzast_nodez00,
				BGl_proc2000z00zzreturn_walkz00, BGl_string2001z00zzreturn_walkz00);
			return
				BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_returnzd2gotozd2funsz12zd2envzc0zzreturn_walkz00,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc2002z00zzreturn_walkz00,
				BGl_string2003z00zzreturn_walkz00);
		}

	}



/* &return-goto-funs!-le1362 */
	BgL_nodez00_bglt
		BGl_z62returnzd2gotozd2funsz12zd2le1362za2zzreturn_walkz00(obj_t
		BgL_envz00_2440, obj_t BgL_nodez00_2441)
	{
		{	/* Return/walk.scm 323 */
			{	/* Return/walk.scm 325 */
				obj_t BgL_g1345z00_2483;

				BgL_g1345z00_2483 =
					(((BgL_letzd2funzd2_bglt) COBJECT(
							((BgL_letzd2funzd2_bglt) BgL_nodez00_2441)))->BgL_localsz00);
				{
					obj_t BgL_l1343z00_2485;

					BgL_l1343z00_2485 = BgL_g1345z00_2483;
				BgL_zc3z04anonymousza31847ze3z87_2484:
					if (PAIRP(BgL_l1343z00_2485))
						{	/* Return/walk.scm 325 */
							BGl_returnzd2funz12zc0zzreturn_walkz00(CAR(BgL_l1343z00_2485));
							{
								obj_t BgL_l1343z00_3122;

								BgL_l1343z00_3122 = CDR(BgL_l1343z00_2485);
								BgL_l1343z00_2485 = BgL_l1343z00_3122;
								goto BgL_zc3z04anonymousza31847ze3z87_2484;
							}
						}
					else
						{	/* Return/walk.scm 325 */
							((bool_t) 1);
						}
				}
			}
			{
				BgL_nodez00_bglt BgL_auxz00_3124;

				{	/* Return/walk.scm 326 */
					BgL_nodez00_bglt BgL_arg1852z00_2486;

					BgL_arg1852z00_2486 =
						(((BgL_letzd2funzd2_bglt) COBJECT(
								((BgL_letzd2funzd2_bglt) BgL_nodez00_2441)))->BgL_bodyz00);
					BgL_auxz00_3124 =
						BGl_returnzd2gotozd2funsz12z12zzreturn_walkz00(BgL_arg1852z00_2486);
				}
				((((BgL_letzd2funzd2_bglt) COBJECT(
								((BgL_letzd2funzd2_bglt) BgL_nodez00_2441)))->BgL_bodyz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3124), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_letzd2funzd2_bglt) BgL_nodez00_2441));
		}

	}



/* &return!-app1358 */
	BgL_nodez00_bglt BGl_z62returnz12zd2app1358za2zzreturn_walkz00(obj_t
		BgL_envz00_2442, obj_t BgL_nodez00_2443, obj_t BgL_exitvarz00_2444,
		obj_t BgL_rblockz00_2445)
	{
		{	/* Return/walk.scm 297 */
			{

				{	/* Return/walk.scm 299 */
					BgL_varz00_bglt BgL_i1164z00_2491;

					BgL_i1164z00_2491 =
						(((BgL_appz00_bglt) COBJECT(
								((BgL_appz00_bglt) BgL_nodez00_2443)))->BgL_funz00);
					{	/* Return/walk.scm 300 */
						bool_t BgL_test2094z00_3134;

						{	/* Return/walk.scm 300 */
							BgL_variablez00_bglt BgL_arg1843z00_2492;

							BgL_arg1843z00_2492 =
								(((BgL_varz00_bglt) COBJECT(BgL_i1164z00_2491))->
								BgL_variablez00);
							BgL_test2094z00_3134 =
								(((obj_t) BgL_arg1843z00_2492) ==
								BGl_za2unwindzd2untilz12za2zc0zzreturn_walkz00);
						}
						if (BgL_test2094z00_3134)
							{	/* Return/walk.scm 302 */
								bool_t BgL_test2095z00_3138;

								{	/* Return/walk.scm 302 */
									obj_t BgL_arg1841z00_2493;

									BgL_arg1841z00_2493 =
										CAR(
										(((BgL_appz00_bglt) COBJECT(
													((BgL_appz00_bglt) BgL_nodez00_2443)))->BgL_argsz00));
									BgL_test2095z00_3138 =
										BGl_isazf3zf3zz__objectz00(BgL_arg1841z00_2493,
										BGl_varz00zzast_nodez00);
								}
								if (BgL_test2095z00_3138)
									{	/* Return/walk.scm 303 */
										BgL_varz00_bglt BgL_i1165z00_2494;

										{	/* Return/walk.scm 303 */
											obj_t BgL_pairz00_2495;

											BgL_pairz00_2495 =
												(((BgL_appz00_bglt) COBJECT(
														((BgL_appz00_bglt) BgL_nodez00_2443)))->
												BgL_argsz00);
											BgL_i1165z00_2494 =
												((BgL_varz00_bglt) CAR(BgL_pairz00_2495));
										}
										if (
											(((obj_t)
													(((BgL_varz00_bglt) COBJECT(BgL_i1165z00_2494))->
														BgL_variablez00)) ==
												((obj_t) ((BgL_localz00_bglt) BgL_exitvarz00_2444))))
											{	/* Return/walk.scm 305 */
												BgL_returnz00_bglt BgL_new1167z00_2496;

												{	/* Return/walk.scm 306 */
													BgL_returnz00_bglt BgL_new1166z00_2497;

													BgL_new1166z00_2497 =
														((BgL_returnz00_bglt)
														BOBJECT(GC_MALLOC(sizeof(struct
																	BgL_returnz00_bgl))));
													{	/* Return/walk.scm 306 */
														long BgL_arg1836z00_2498;

														{	/* Return/walk.scm 306 */
															long BgL_res1980z00_2499;

															BgL_res1980z00_2499 =
																BGL_CLASS_INDEX(BGl_returnz00zzast_nodez00);
															BgL_arg1836z00_2498 = BgL_res1980z00_2499;
														}
														BGL_OBJECT_CLASS_NUM_SET(
															((BgL_objectz00_bglt) BgL_new1166z00_2497),
															BgL_arg1836z00_2498);
													}
													{	/* Return/walk.scm 306 */
														BgL_objectz00_bglt BgL_tmpz00_3157;

														BgL_tmpz00_3157 =
															((BgL_objectz00_bglt) BgL_new1166z00_2497);
														BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3157, BFALSE);
													}
													((BgL_objectz00_bglt) BgL_new1166z00_2497);
													BgL_new1167z00_2496 = BgL_new1166z00_2497;
												}
												((((BgL_nodez00_bglt) COBJECT(
																((BgL_nodez00_bglt) BgL_new1167z00_2496)))->
														BgL_locz00) =
													((obj_t) (((BgL_nodez00_bglt)
																COBJECT(((BgL_nodez00_bglt) ((BgL_appz00_bglt)
																			BgL_nodez00_2443))))->BgL_locz00)),
													BUNSPEC);
												((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
																	BgL_new1167z00_2496)))->BgL_typez00) =
													((BgL_typez00_bglt) (((BgL_nodez00_bglt)
																COBJECT(((BgL_nodez00_bglt) (
																			(BgL_retblockz00_bglt)
																			BgL_rblockz00_2445))))->BgL_typez00)),
													BUNSPEC);
												((((BgL_returnz00_bglt) COBJECT(BgL_new1167z00_2496))->
														BgL_blockz00) =
													((BgL_retblockz00_bglt) ((BgL_retblockz00_bglt)
															BgL_rblockz00_2445)), BUNSPEC);
												{
													BgL_nodez00_bglt BgL_auxz00_3173;

													{	/* Return/walk.scm 309 */
														obj_t BgL_pairz00_2500;

														BgL_pairz00_2500 =
															(((BgL_appz00_bglt) COBJECT(
																	((BgL_appz00_bglt) BgL_nodez00_2443)))->
															BgL_argsz00);
														{	/* Return/walk.scm 309 */
															obj_t BgL_pairz00_2501;

															BgL_pairz00_2501 = CDR(BgL_pairz00_2500);
															BgL_auxz00_3173 =
																((BgL_nodez00_bglt) CAR(BgL_pairz00_2501));
													}}
													((((BgL_returnz00_bglt)
																COBJECT(BgL_new1167z00_2496))->BgL_valuez00) =
														((BgL_nodez00_bglt) BgL_auxz00_3173), BUNSPEC);
												}
												return ((BgL_nodez00_bglt) BgL_new1167z00_2496);
											}
										else
											{	/* Return/walk.scm 304 */
											BgL_callzd2defaultzd2walkerz00_2490:
												return
													BGl_walk2z12z12zzast_walkz00(
													((BgL_nodez00_bglt)
														((BgL_appz00_bglt) BgL_nodez00_2443)),
													BGl_returnz12zd2envzc0zzreturn_walkz00,
													((obj_t) ((BgL_localz00_bglt) BgL_exitvarz00_2444)),
													((obj_t) ((BgL_retblockz00_bglt)
															BgL_rblockz00_2445)));
											}
									}
								else
									{	/* Return/walk.scm 302 */
										goto BgL_callzd2defaultzd2walkerz00_2490;
									}
							}
						else
							{	/* Return/walk.scm 300 */
								goto BgL_callzd2defaultzd2walkerz00_2490;
							}
					}
				}
			}
		}

	}



/* &is-return?-app1353 */
	obj_t BGl_z62iszd2returnzf3zd2app1353z91zzreturn_walkz00(obj_t
		BgL_envz00_2446, obj_t BgL_nodez00_2447, obj_t BgL_exitvarz00_2448,
		obj_t BgL_abortz00_2449)
	{
		{	/* Return/walk.scm 273 */
			{

				{	/* Return/walk.scm 275 */
					BgL_varz00_bglt BgL_i1158z00_2504;

					BgL_i1158z00_2504 =
						(((BgL_appz00_bglt) COBJECT(
								((BgL_appz00_bglt) BgL_nodez00_2447)))->BgL_funz00);
					{	/* Return/walk.scm 277 */
						bool_t BgL_test2097z00_3190;

						{	/* Return/walk.scm 277 */
							BgL_variablez00_bglt BgL_arg1823z00_2505;

							BgL_arg1823z00_2505 =
								(((BgL_varz00_bglt) COBJECT(BgL_i1158z00_2504))->
								BgL_variablez00);
							BgL_test2097z00_3190 =
								(((obj_t) BgL_arg1823z00_2505) ==
								BGl_za2unwindzd2untilz12za2zc0zzreturn_walkz00);
						}
						if (BgL_test2097z00_3190)
							{	/* Return/walk.scm 278 */
								bool_t BgL_test2098z00_3194;

								{	/* Return/walk.scm 278 */
									obj_t BgL_arg1817z00_2506;

									BgL_arg1817z00_2506 =
										CAR(
										(((BgL_appz00_bglt) COBJECT(
													((BgL_appz00_bglt) BgL_nodez00_2447)))->BgL_argsz00));
									BgL_test2098z00_3194 =
										BGl_isazf3zf3zz__objectz00(BgL_arg1817z00_2506,
										BGl_varz00zzast_nodez00);
								}
								if (BgL_test2098z00_3194)
									{	/* Return/walk.scm 279 */
										BgL_varz00_bglt BgL_i1159z00_2507;

										{	/* Return/walk.scm 279 */
											obj_t BgL_pairz00_2508;

											BgL_pairz00_2508 =
												(((BgL_appz00_bglt) COBJECT(
														((BgL_appz00_bglt) BgL_nodez00_2447)))->
												BgL_argsz00);
											BgL_i1159z00_2507 =
												((BgL_varz00_bglt) CAR(BgL_pairz00_2508));
										}
										{	/* Return/walk.scm 280 */
											obj_t BgL__ortest_1160z00_2509;

											if (PAIRP(BgL_exitvarz00_2448))
												{	/* Return/walk.scm 280 */
													BgL__ortest_1160z00_2509 =
														BGl_memqz00zz__r4_pairs_and_lists_6_3z00(
														((obj_t)
															(((BgL_varz00_bglt) COBJECT(BgL_i1159z00_2507))->
																BgL_variablez00)), BgL_exitvarz00_2448);
												}
											else
												{	/* Return/walk.scm 280 */
													BgL__ortest_1160z00_2509 = BFALSE;
												}
											if (CBOOL(BgL__ortest_1160z00_2509))
												{	/* Return/walk.scm 280 */
													return BgL__ortest_1160z00_2509;
												}
											else
												{	/* Return/walk.scm 281 */
													obj_t BgL_arg1813z00_2510;

													BgL_arg1813z00_2510 =
														CAR(
														(((BgL_appz00_bglt) COBJECT(
																	((BgL_appz00_bglt) BgL_nodez00_2447)))->
															BgL_argsz00));
													return
														BGl_iszd2returnzf3z21zzreturn_walkz00((
															(BgL_nodez00_bglt) BgL_arg1813z00_2510),
														BgL_exitvarz00_2448, BgL_abortz00_2449);
												}
										}
									}
								else
									{	/* Return/walk.scm 278 */
									BgL_callzd2defaultzd2walkerz00_2503:
										return
											BGl_walk2z00zzast_walkz00(
											((BgL_nodez00_bglt)
												((BgL_appz00_bglt) BgL_nodez00_2447)),
											BGl_iszd2returnzf3zd2envzf3zzreturn_walkz00,
											BgL_exitvarz00_2448, BgL_abortz00_2449);
									}
							}
						else
							{	/* Return/walk.scm 283 */
								bool_t BgL_test2101z00_3218;

								{	/* Return/walk.scm 283 */
									BgL_variablez00_bglt BgL_arg1822z00_2511;

									BgL_arg1822z00_2511 =
										(((BgL_varz00_bglt) COBJECT(BgL_i1158z00_2504))->
										BgL_variablez00);
									BgL_test2101z00_3218 =
										(((obj_t) BgL_arg1822z00_2511) ==
										BGl_za2getzd2exitdzd2topza2z00zzreturn_walkz00);
								}
								if (BgL_test2101z00_3218)
									{	/* Return/walk.scm 284 */
										obj_t BgL__ortest_1162z00_2512;

										BgL__ortest_1162z00_2512 =
											BGl_za2optimzd2returnzd2gotozf3za2zf3zzengine_paramz00;
										if (CBOOL(BgL__ortest_1162z00_2512))
											{	/* Return/walk.scm 284 */
												return BgL__ortest_1162z00_2512;
											}
										else
											{	/* Return/walk.scm 284 */
												return
													PROCEDURE_ENTRY(BgL_abortz00_2449) (BgL_abortz00_2449,
													BFALSE, BEOA);
											}
									}
								else
									{	/* Return/walk.scm 283 */
										goto BgL_callzd2defaultzd2walkerz00_2503;
									}
							}
					}
				}
			}
		}

	}



/* &is-return?-let-var1351 */
	obj_t BGl_z62iszd2returnzf3zd2letzd2var1351z43zzreturn_walkz00(obj_t
		BgL_envz00_2450, obj_t BgL_nodez00_2451, obj_t BgL_exitvarz00_2452,
		obj_t BgL_abortz00_2453)
	{
		{	/* Return/walk.scm 253 */
			{

				if (CBOOL(BGl_za2optimzd2returnzd2gotozf3za2zf3zzengine_paramz00))
					{	/* Return/walk.scm 258 */
						bool_t BgL_test2104z00_3230;

						{	/* Return/walk.scm 258 */
							bool_t BgL_test2105z00_3231;

							{	/* Return/walk.scm 258 */
								obj_t BgL_tmpz00_3232;

								BgL_tmpz00_3232 =
									(((BgL_letzd2varzd2_bglt) COBJECT(
											((BgL_letzd2varzd2_bglt) BgL_nodez00_2451)))->
									BgL_bindingsz00);
								BgL_test2105z00_3231 = PAIRP(BgL_tmpz00_3232);
							}
							if (BgL_test2105z00_3231)
								{	/* Return/walk.scm 258 */
									BgL_test2104z00_3230 =
										NULLP(CDR(
											(((BgL_letzd2varzd2_bglt) COBJECT(
														((BgL_letzd2varzd2_bglt) BgL_nodez00_2451)))->
												BgL_bindingsz00)));
								}
							else
								{	/* Return/walk.scm 258 */
									BgL_test2104z00_3230 = ((bool_t) 0);
								}
						}
						if (BgL_test2104z00_3230)
							{	/* Return/walk.scm 259 */
								obj_t BgL_bnodez00_2515;

								{	/* Return/walk.scm 259 */
									obj_t BgL_pairz00_2516;

									BgL_pairz00_2516 =
										(((BgL_letzd2varzd2_bglt) COBJECT(
												((BgL_letzd2varzd2_bglt) BgL_nodez00_2451)))->
										BgL_bindingsz00);
									BgL_bnodez00_2515 = CDR(CAR(BgL_pairz00_2516));
								}
								if (BGl_isazf3zf3zz__objectz00(BgL_bnodez00_2515,
										BGl_appz00zzast_nodez00))
									{	/* Return/walk.scm 262 */
										BgL_varz00_bglt BgL_i1156z00_2517;

										BgL_i1156z00_2517 =
											(((BgL_appz00_bglt) COBJECT(
													((BgL_appz00_bglt) BgL_bnodez00_2515)))->BgL_funz00);
										{	/* Return/walk.scm 263 */
											bool_t BgL_test2107z00_3248;

											{	/* Return/walk.scm 263 */
												BgL_variablez00_bglt BgL_arg1798z00_2518;

												BgL_arg1798z00_2518 =
													(((BgL_varz00_bglt) COBJECT(BgL_i1156z00_2517))->
													BgL_variablez00);
												BgL_test2107z00_3248 =
													(((obj_t) BgL_arg1798z00_2518) ==
													BGl_za2getzd2exitdzd2topza2z00zzreturn_walkz00);
											}
											if (BgL_test2107z00_3248)
												{	/* Return/walk.scm 264 */
													BgL_nodez00_bglt BgL_arg1793z00_2519;
													obj_t BgL_arg1794z00_2520;

													BgL_arg1793z00_2519 =
														(((BgL_letzd2varzd2_bglt) COBJECT(
																((BgL_letzd2varzd2_bglt) BgL_nodez00_2451)))->
														BgL_bodyz00);
													{	/* Return/walk.scm 264 */
														obj_t BgL_arg1795z00_2521;

														{	/* Return/walk.scm 264 */
															obj_t BgL_pairz00_2522;

															BgL_pairz00_2522 =
																(((BgL_letzd2varzd2_bglt) COBJECT(
																		((BgL_letzd2varzd2_bglt)
																			BgL_nodez00_2451)))->BgL_bindingsz00);
															BgL_arg1795z00_2521 = CAR(CAR(BgL_pairz00_2522));
														}
														BgL_arg1794z00_2520 =
															MAKE_YOUNG_PAIR(BgL_arg1795z00_2521,
															BgL_exitvarz00_2452);
													}
													return
														BGl_iszd2returnzf3z21zzreturn_walkz00
														(BgL_arg1793z00_2519, BgL_arg1794z00_2520,
														BgL_abortz00_2453);
												}
											else
												{	/* Return/walk.scm 263 */
												BgL_callzd2defaultzd2walkerz00_2514:
													return
														BGl_walk2z00zzast_walkz00(
														((BgL_nodez00_bglt)
															((BgL_letzd2varzd2_bglt) BgL_nodez00_2451)),
														BGl_iszd2returnzf3zd2envzf3zzreturn_walkz00,
														BgL_exitvarz00_2452, BgL_abortz00_2453);
												}
										}
									}
								else
									{	/* Return/walk.scm 260 */
										goto BgL_callzd2defaultzd2walkerz00_2514;
									}
							}
						else
							{	/* Return/walk.scm 258 */
								goto BgL_callzd2defaultzd2walkerz00_2514;
							}
					}
				else
					{	/* Return/walk.scm 256 */
						goto BgL_callzd2defaultzd2walkerz00_2514;
					}
			}
		}

	}



/* &is-return?-var1349 */
	obj_t BGl_z62iszd2returnzf3zd2var1349z91zzreturn_walkz00(obj_t
		BgL_envz00_2454, obj_t BgL_nodez00_2455, obj_t BgL_exitvarz00_2456,
		obj_t BgL_abortz00_2457)
	{
		{	/* Return/walk.scm 245 */
			if (CBOOL(BGl_memqz00zz__r4_pairs_and_lists_6_3z00(
						((obj_t)
							(((BgL_varz00_bglt) COBJECT(
										((BgL_varz00_bglt) BgL_nodez00_2455)))->BgL_variablez00)),
						BgL_exitvarz00_2456)))
				{	/* Return/walk.scm 247 */
					return
						PROCEDURE_ENTRY(BgL_abortz00_2457) (BgL_abortz00_2457, BFALSE,
						BEOA);
				}
			else
				{	/* Return/walk.scm 247 */
					return BFALSE;
				}
		}

	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzreturn_walkz00()
	{
		{	/* Return/walk.scm 16 */
			BGl_modulezd2initializa7ationz75zztools_speekz00(((long) 61247943),
				BSTRING_TO_STRING(BGl_string2004z00zzreturn_walkz00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 300504031),
				BSTRING_TO_STRING(BGl_string2004z00zzreturn_walkz00));
			BGl_modulezd2initializa7ationz75zzengine_passz00(((long) 373082237),
				BSTRING_TO_STRING(BGl_string2004z00zzreturn_walkz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 515343395),
				BSTRING_TO_STRING(BGl_string2004z00zzreturn_walkz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 90839984),
				BSTRING_TO_STRING(BGl_string2004z00zzreturn_walkz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 506185397),
				BSTRING_TO_STRING(BGl_string2004z00zzreturn_walkz00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 365925558),
				BSTRING_TO_STRING(BGl_string2004z00zzreturn_walkz00));
			BGl_modulezd2initializa7ationz75zztools_locationz00(((long) 462333240),
				BSTRING_TO_STRING(BGl_string2004z00zzreturn_walkz00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 346491734),
				BSTRING_TO_STRING(BGl_string2004z00zzreturn_walkz00));
			BGl_modulezd2initializa7ationz75zzast_identz00(((long) 174885617),
				BSTRING_TO_STRING(BGl_string2004z00zzreturn_walkz00));
			BGl_modulezd2initializa7ationz75zzast_localz00(((long) 315247917),
				BSTRING_TO_STRING(BGl_string2004z00zzreturn_walkz00));
			BGl_modulezd2initializa7ationz75zzast_envz00(((long) 146730773),
				BSTRING_TO_STRING(BGl_string2004z00zzreturn_walkz00));
			BGl_modulezd2initializa7ationz75zzast_sexpz00(((long) 163122759),
				BSTRING_TO_STRING(BGl_string2004z00zzreturn_walkz00));
			BGl_modulezd2initializa7ationz75zzast_privatez00(((long) 135263837),
				BSTRING_TO_STRING(BGl_string2004z00zzreturn_walkz00));
			BGl_modulezd2initializa7ationz75zzast_lvtypez00(((long) 189769752),
				BSTRING_TO_STRING(BGl_string2004z00zzreturn_walkz00));
			BGl_modulezd2initializa7ationz75zzast_dumpz00(((long) 271707717),
				BSTRING_TO_STRING(BGl_string2004z00zzreturn_walkz00));
			BGl_modulezd2initializa7ationz75zzast_walkz00(((long) 343174225),
				BSTRING_TO_STRING(BGl_string2004z00zzreturn_walkz00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 476633989),
				BSTRING_TO_STRING(BGl_string2004z00zzreturn_walkz00));
			return
				BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 216206620),
				BSTRING_TO_STRING(BGl_string2004z00zzreturn_walkz00));
		}

	}

#ifdef __cplusplus
}
#endif
