/*===========================================================================*/
/*   (SawJvm/type.scm)                                                       */
/*   Bigloo (4.3h)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 11 May 2020 12:14:39 PM CEST    */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.3h -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent SawJvm/type.scm) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		bool_t BgL_evalzf3zf3;
		obj_t BgL_libraryz00;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
		obj_t BgL_initz00;
		obj_t BgL_aliasz00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_atomz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}              *BgL_atomz00_bglt;

	typedef struct BgL_rtl_regz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_varz00;
		obj_t BgL_onexprzf3zf3;
		obj_t BgL_namez00;
		obj_t BgL_keyz00;
		obj_t BgL_hardwarez00;
	}                 *BgL_rtl_regz00_bglt;

	typedef struct BgL_rtl_funz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
	}                 *BgL_rtl_funz00_bglt;

	typedef struct BgL_rtl_loadiz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_atomz00_bgl *BgL_constantz00;
	}                   *BgL_rtl_loadiz00_bglt;

	typedef struct BgL_rtl_loadgz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_globalz00_bgl *BgL_varz00;
	}                   *BgL_rtl_loadgz00_bglt;

	typedef struct BgL_rtl_getfieldz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_objtypez00;
		struct BgL_typez00_bgl *BgL_typez00;
	}                      *BgL_rtl_getfieldz00_bglt;

	typedef struct BgL_rtl_vrefz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                  *BgL_rtl_vrefz00_bglt;

	typedef struct BgL_rtl_callz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_globalz00_bgl *BgL_varz00;
	}                  *BgL_rtl_callz00_bglt;

	typedef struct BgL_rtl_insz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		obj_t BgL_z52spillz52;
		obj_t BgL_destz00;
		struct BgL_rtl_funz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}                 *BgL_rtl_insz00_bglt;


	extern obj_t BGl_rtl_funcallz00zzsaw_defsz00;
	static obj_t
		BGl_z62siza7ezd2destzd2funzd2rtl_vr1565z17zzsaw_jvm_typez00(obj_t, obj_t,
		obj_t);
	static obj_t
		BGl_z62siza7ezd2destzd2funzd2rtl_ge1563z17zzsaw_jvm_typez00(obj_t, obj_t,
		obj_t);
	static obj_t
		BGl_z62siza7ezd2destzd2funzd2rtl_lo1559z17zzsaw_jvm_typez00(obj_t, obj_t,
		obj_t);
	static int BGl_siza7ezd2destzd2funza7zzsaw_jvm_typez00(BgL_rtl_funz00_bglt,
		BgL_rtl_insz00_bglt);
	static obj_t
		BGl_z62siza7ezd2destzd2funzd2rtl_lo1561z17zzsaw_jvm_typez00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_rtl_vrefz00zzsaw_defsz00;
	static obj_t BGl_objectzd2initzd2zzsaw_jvm_typez00();
	static obj_t
		BGl_z62siza7ezd2destzd2funzd2rtl_mo1557z17zzsaw_jvm_typez00(obj_t, obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	extern obj_t BGl_rtl_lightfuncallz00zzsaw_defsz00;
	static obj_t
		BGl_z62siza7ezd2destzd2funzd2rtl_la1549z17zzsaw_jvm_typez00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_rtl_movz00zzsaw_defsz00;
	BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zzsaw_jvm_typez00();
	static obj_t
		BGl_z62siza7ezd2destzd2funzd2rtl_no1551z17zzsaw_jvm_typez00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62typeSiza7ezc5zzsaw_jvm_typez00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	static obj_t
		BGl_z62siza7ezd2destzd2funzd2rtl_ap1569z17zzsaw_jvm_typez00(obj_t, obj_t,
		obj_t);
	BGL_IMPORT bool_t BGl_numberzf3zf3zz__r4_numbers_6_5z00(obj_t);
	BGL_EXPORTED_DECL int BGl_typeSiza7eza7zzsaw_jvm_typez00(BgL_typez00_bglt);
	static obj_t BGl_gczd2rootszd2initz00zzsaw_jvm_typez00();
	static obj_t BGl_z62siza7ezd2destzd2funzc5zzsaw_jvm_typez00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62siza7ezd2destz17zzsaw_jvm_typez00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_classzd2namezd2zz__objectz00(obj_t);
	static BgL_typez00_bglt
		BGl_typezd2destzd2funz00zzsaw_jvm_typez00(BgL_rtl_funz00_bglt);
	BGL_EXPORTED_DECL int BGl_siza7ezd2destz75zzsaw_jvm_typez00(obj_t);
	extern obj_t BGl_rtl_effectz00zzsaw_defsz00;
	BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t
		BGl_z62siza7ezd2destzd2funzd2rtl_ca1575z17zzsaw_jvm_typez00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_rtl_funz00zzsaw_defsz00;
	extern obj_t BGl_rtl_newz00zzsaw_defsz00;
	static obj_t BGl_requirezd2initializa7ationz75zzsaw_jvm_typez00 = BUNSPEC;
	BGL_IMPORT obj_t BGl_za2classesza2z00zz__objectz00;
	BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	static BgL_typez00_bglt
		BGl_z62typezd2destzd2funzd2rtl_ca1579zb0zzsaw_jvm_typez00(obj_t, obj_t);
	static obj_t BGl_toplevelzd2initzd2zzsaw_jvm_typez00();
	static obj_t
		BGl_z62siza7ezd2destzd2funzd2rtl_ne1567z17zzsaw_jvm_typez00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_rtl_purez00zzsaw_defsz00;
	static obj_t BGl_genericzd2initzd2zzsaw_jvm_typez00();
	extern obj_t BGl_rtl_regz00zzsaw_defsz00;
	static obj_t BGl_z62typezd2destzd2fun1576z62zzsaw_jvm_typez00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t,
		obj_t, obj_t);
	static obj_t
		BGl_z62siza7ezd2destzd2funzd2rtl_li1571z17zzsaw_jvm_typez00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_za2za2longzd2typesza2za2zd2zzsaw_jvm_typez00 = BUNSPEC;
	static obj_t
		BGl_z62siza7ezd2destzd2funzd2rtl_pu1555z17zzsaw_jvm_typez00(obj_t, obj_t,
		obj_t);
	static BgL_typez00_bglt BGl_z62typezd2destzd2funz62zzsaw_jvm_typez00(obj_t,
		obj_t);
	extern obj_t BGl_rtl_callz00zzsaw_defsz00;
	static obj_t BGl_z62siza7ezd2destzd2fun1546zc5zzsaw_jvm_typez00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_rtl_lastz00zzsaw_defsz00;
	extern obj_t BGl_rtl_applyz00zzsaw_defsz00;
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzsaw_jvm_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzsaw_jvm_namesz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzsaw_defsz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_jvm_classz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_bvmz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	extern obj_t BGl_rtl_loadgz00zzsaw_defsz00;
	extern obj_t BGl_rtl_loadiz00zzsaw_defsz00;
	extern obj_t BGl_rtl_notseqz00zzsaw_defsz00;
	static obj_t BGl_cnstzd2initzd2zzsaw_jvm_typez00();
	static obj_t BGl_libraryzd2moduleszd2initz00zzsaw_jvm_typez00();
	static obj_t BGl_importedzd2moduleszd2initz00zzsaw_jvm_typez00();
	extern obj_t BGl_rtl_castz00zzsaw_defsz00;
	extern obj_t BGl_rtl_getfieldz00zzsaw_defsz00;
	static obj_t
		BGl_z62siza7ezd2destzd2funzd2rtl_ef1553z17zzsaw_jvm_typez00(obj_t, obj_t,
		obj_t);
	static obj_t
		BGl_z62siza7ezd2destzd2funzd2rtl_fu1573z17zzsaw_jvm_typez00(obj_t, obj_t,
		obj_t);
	static obj_t __cnst[3];


	   
		 
		DEFINE_STATIC_BGL_GENERIC(BGl_typezd2destzd2funzd2envzd2zzsaw_jvm_typez00,
		BgL_bgl_za762typeza7d2destza7d1879za7,
		BGl_z62typezd2destzd2funz62zzsaw_jvm_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string1852z00zzsaw_jvm_typez00,
		BgL_bgl_string1852za700za7za7s1880za7, "size-dest-fun1546", 17);
	      DEFINE_STRING(BGl_string1854z00zzsaw_jvm_typez00,
		BgL_bgl_string1854za700za7za7s1881za7, "type-dest-fun1576", 17);
	      DEFINE_STRING(BGl_string1855z00zzsaw_jvm_typez00,
		BgL_bgl_string1855za700za7za7s1882za7, "no method for", 13);
	      DEFINE_STRING(BGl_string1857z00zzsaw_jvm_typez00,
		BgL_bgl_string1857za700za7za7s1883za7, "size-dest-fun::int", 18);
	      DEFINE_STRING(BGl_string1867z00zzsaw_jvm_typez00,
		BgL_bgl_string1867za700za7za7s1884za7, "size-dest-fun::type", 19);
	      DEFINE_STRING(BGl_string1873z00zzsaw_jvm_typez00,
		BgL_bgl_string1873za700za7za7s1885za7, "type-dest-fun::type", 19);
	      DEFINE_STRING(BGl_string1874z00zzsaw_jvm_typez00,
		BgL_bgl_string1874za700za7za7s1886za7, "saw_jvm_type", 12);
	      DEFINE_STRING(BGl_string1875z00zzsaw_jvm_typez00,
		BgL_bgl_string1875za700za7za7s1887za7,
		"size-dest-fun void (elong llong uelong ullong double int64 uint64) ", 67);
	     
		DEFINE_STATIC_BGL_GENERIC(BGl_siza7ezd2destzd2funzd2envz75zzsaw_jvm_typez00,
		BgL_bgl_za762siza7a7eza7d2dest1888za7,
		BGl_z62siza7ezd2destzd2funzc5zzsaw_jvm_typez00, 0L, BUNSPEC, 2);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_siza7ezd2destzd2envza7zzsaw_jvm_typez00,
		BgL_bgl_za762siza7a7eza7d2dest1889za7,
		BGl_z62siza7ezd2destz17zzsaw_jvm_typez00, 0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_typeSiza7ezd2envz75zzsaw_jvm_typez00,
		BgL_bgl_za762typesiza7a7eza7c51890za7,
		BGl_z62typeSiza7ezc5zzsaw_jvm_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1851z00zzsaw_jvm_typez00,
		BgL_bgl_za762siza7a7eza7d2dest1891za7,
		BGl_z62siza7ezd2destzd2fun1546zc5zzsaw_jvm_typez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1853z00zzsaw_jvm_typez00,
		BgL_bgl_za762typeza7d2destza7d1892za7,
		BGl_z62typezd2destzd2fun1576z62zzsaw_jvm_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1856z00zzsaw_jvm_typez00,
		BgL_bgl_za762siza7a7eza7d2dest1893za7,
		BGl_z62siza7ezd2destzd2funzd2rtl_la1549z17zzsaw_jvm_typez00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1858z00zzsaw_jvm_typez00,
		BgL_bgl_za762siza7a7eza7d2dest1894za7,
		BGl_z62siza7ezd2destzd2funzd2rtl_no1551z17zzsaw_jvm_typez00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1859z00zzsaw_jvm_typez00,
		BgL_bgl_za762siza7a7eza7d2dest1895za7,
		BGl_z62siza7ezd2destzd2funzd2rtl_ef1553z17zzsaw_jvm_typez00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1860z00zzsaw_jvm_typez00,
		BgL_bgl_za762siza7a7eza7d2dest1896za7,
		BGl_z62siza7ezd2destzd2funzd2rtl_pu1555z17zzsaw_jvm_typez00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1861z00zzsaw_jvm_typez00,
		BgL_bgl_za762siza7a7eza7d2dest1897za7,
		BGl_z62siza7ezd2destzd2funzd2rtl_mo1557z17zzsaw_jvm_typez00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1862z00zzsaw_jvm_typez00,
		BgL_bgl_za762siza7a7eza7d2dest1898za7,
		BGl_z62siza7ezd2destzd2funzd2rtl_lo1559z17zzsaw_jvm_typez00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1863z00zzsaw_jvm_typez00,
		BgL_bgl_za762siza7a7eza7d2dest1899za7,
		BGl_z62siza7ezd2destzd2funzd2rtl_lo1561z17zzsaw_jvm_typez00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1864z00zzsaw_jvm_typez00,
		BgL_bgl_za762siza7a7eza7d2dest1900za7,
		BGl_z62siza7ezd2destzd2funzd2rtl_ge1563z17zzsaw_jvm_typez00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1865z00zzsaw_jvm_typez00,
		BgL_bgl_za762siza7a7eza7d2dest1901za7,
		BGl_z62siza7ezd2destzd2funzd2rtl_vr1565z17zzsaw_jvm_typez00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1866z00zzsaw_jvm_typez00,
		BgL_bgl_za762siza7a7eza7d2dest1902za7,
		BGl_z62siza7ezd2destzd2funzd2rtl_ne1567z17zzsaw_jvm_typez00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1868z00zzsaw_jvm_typez00,
		BgL_bgl_za762siza7a7eza7d2dest1903za7,
		BGl_z62siza7ezd2destzd2funzd2rtl_ap1569z17zzsaw_jvm_typez00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1869z00zzsaw_jvm_typez00,
		BgL_bgl_za762siza7a7eza7d2dest1904za7,
		BGl_z62siza7ezd2destzd2funzd2rtl_li1571z17zzsaw_jvm_typez00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1870z00zzsaw_jvm_typez00,
		BgL_bgl_za762siza7a7eza7d2dest1905za7,
		BGl_z62siza7ezd2destzd2funzd2rtl_fu1573z17zzsaw_jvm_typez00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1871z00zzsaw_jvm_typez00,
		BgL_bgl_za762siza7a7eza7d2dest1906za7,
		BGl_z62siza7ezd2destzd2funzd2rtl_ca1575z17zzsaw_jvm_typez00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1872z00zzsaw_jvm_typez00,
		BgL_bgl_za762typeza7d2destza7d1907za7,
		BGl_z62typezd2destzd2funzd2rtl_ca1579zb0zzsaw_jvm_typez00, 0L, BUNSPEC, 1);

/* GC roots registration */
	static obj_t bgl_gc_roots_register()
	{
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
		void *roots_min = (void *) ULONG_MAX, *roots_max = 0;
		   
			 ADD_ROOT((void *) (&BGl_requirezd2initializa7ationz75zzsaw_jvm_typez00));
		     ADD_ROOT((void *) (&BGl_za2za2longzd2typesza2za2zd2zzsaw_jvm_typez00));
#undef ADD_ROOT
		if   (roots_max > 0)
			     GC_add_roots(roots_min, ((void **) roots_max) + 1);
#endif
		     return BUNSPEC;
	}



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzsaw_jvm_typez00(long
		BgL_checksumz00_2968, char *BgL_fromz00_2969)
	{
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzsaw_jvm_typez00))
				{
					BGl_requirezd2initializa7ationz75zzsaw_jvm_typez00 =
						BBOOL(((bool_t) 0));
					BGl_gczd2rootszd2initz00zzsaw_jvm_typez00();
					BGl_libraryzd2moduleszd2initz00zzsaw_jvm_typez00();
					BGl_cnstzd2initzd2zzsaw_jvm_typez00();
					BGl_importedzd2moduleszd2initz00zzsaw_jvm_typez00();
					BGl_genericzd2initzd2zzsaw_jvm_typez00();
					BGl_methodzd2initzd2zzsaw_jvm_typez00();
					return BGl_toplevelzd2initzd2zzsaw_jvm_typez00();
				}
			else
				{
					return BUNSPEC;
				}
		}

	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzsaw_jvm_typez00()
	{
		{	/* SawJvm/type.scm 1 */
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"saw_jvm_type");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0), "saw_jvm_type");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "saw_jvm_type");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long) 0),
				"saw_jvm_type");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0), "saw_jvm_type");
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"saw_jvm_type");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"saw_jvm_type");
			BGl_modulezd2initializa7ationz75zz__bitz00(((long) 0), "saw_jvm_type");
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 0),
				"saw_jvm_type");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long) 0),
				"saw_jvm_type");
			return BUNSPEC;
		}

	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzsaw_jvm_typez00()
	{
		{	/* SawJvm/type.scm 1 */
			{	/* SawJvm/type.scm 1 */
				obj_t BgL_cportz00_2926;

				{	/* SawJvm/type.scm 1 */
					obj_t BgL_stringz00_2934;

					BgL_stringz00_2934 = BGl_string1875z00zzsaw_jvm_typez00;
					{	/* SawJvm/type.scm 1 */
						obj_t BgL_startz00_2935;

						BgL_startz00_2935 = BINT(((long) 0));
						{	/* SawJvm/type.scm 1 */
							obj_t BgL_endz00_2936;

							BgL_endz00_2936 =
								BINT(STRING_LENGTH(((obj_t) BgL_stringz00_2934)));
							{	/* SawJvm/type.scm 1 */

								BgL_cportz00_2926 =
									BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00
									(BgL_stringz00_2934, BgL_startz00_2935, BgL_endz00_2936);
				}}}}
				{
					long BgL_iz00_2927;

					BgL_iz00_2927 = ((long) 2);
				BgL_loopz00_2928:
					if ((BgL_iz00_2927 == ((long) -1)))
						{	/* SawJvm/type.scm 1 */
							return BUNSPEC;
						}
					else
						{	/* SawJvm/type.scm 1 */
							{	/* SawJvm/type.scm 1 */
								obj_t BgL_arg1877z00_2930;

								{	/* SawJvm/type.scm 1 */

									{	/* SawJvm/type.scm 1 */
										obj_t BgL_locationz00_2932;

										BgL_locationz00_2932 = BBOOL(((bool_t) 0));
										{	/* SawJvm/type.scm 1 */

											BgL_arg1877z00_2930 =
												BGl_readz00zz__readerz00(BgL_cportz00_2926,
												BgL_locationz00_2932);
										}
									}
								}
								{	/* SawJvm/type.scm 1 */
									int BgL_tmpz00_2999;

									BgL_tmpz00_2999 = (int) (BgL_iz00_2927);
									CNST_TABLE_SET(BgL_tmpz00_2999, BgL_arg1877z00_2930);
							}}
							{	/* SawJvm/type.scm 1 */
								int BgL_auxz00_2933;

								BgL_auxz00_2933 = (int) ((BgL_iz00_2927 - ((long) 1)));
								{
									long BgL_iz00_3004;

									BgL_iz00_3004 = (long) (BgL_auxz00_2933);
									BgL_iz00_2927 = BgL_iz00_3004;
									goto BgL_loopz00_2928;
								}
							}
						}
				}
			}
		}

	}



/* gc-roots-init */
	obj_t BGl_gczd2rootszd2initz00zzsaw_jvm_typez00()
	{
		{	/* SawJvm/type.scm 1 */
			return bgl_gc_roots_register();
		}

	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzsaw_jvm_typez00()
	{
		{	/* SawJvm/type.scm 1 */
			BGl_za2za2longzd2typesza2za2zd2zzsaw_jvm_typez00 =
				CNST_TABLE_REF(((long) 0));
			return BUNSPEC;
		}

	}



/* typeSize */
	BGL_EXPORTED_DEF int BGl_typeSiza7eza7zzsaw_jvm_typez00(BgL_typez00_bglt
		BgL_typez00_3)
	{
		{	/* SawJvm/type.scm 18 */
			{	/* SawJvm/type.scm 19 */
				obj_t BgL_idz00_2140;

				BgL_idz00_2140 =
					(((BgL_typez00_bglt) COBJECT(BgL_typez00_3))->BgL_idz00);
				if (CBOOL(BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_idz00_2140,
							CNST_TABLE_REF(((long) 0)))))
					{	/* SawJvm/type.scm 20 */
						return (int) (((long) 2));
					}
				else
					{	/* SawJvm/type.scm 20 */
						if ((BgL_idz00_2140 == CNST_TABLE_REF(((long) 1))))
							{	/* SawJvm/type.scm 21 */
								return (int) (((long) 0));
							}
						else
							{	/* SawJvm/type.scm 21 */
								return (int) (((long) 1));
		}}}}

	}



/* &typeSize */
	obj_t BGl_z62typeSiza7ezc5zzsaw_jvm_typez00(obj_t BgL_envz00_2851,
		obj_t BgL_typez00_2852)
	{
		{	/* SawJvm/type.scm 18 */
			return
				BINT(BGl_typeSiza7eza7zzsaw_jvm_typez00(
					((BgL_typez00_bglt) BgL_typez00_2852)));
		}

	}



/* size-dest */
	BGL_EXPORTED_DEF int BGl_siza7ezd2destz75zzsaw_jvm_typez00(obj_t BgL_insz00_4)
	{
		{	/* SawJvm/type.scm 24 */
			if (BGl_isazf3zf3zz__objectz00(BgL_insz00_4, BGl_rtl_regz00zzsaw_defsz00))
				{	/* SawJvm/type.scm 26 */
					BgL_typez00_bglt BgL_arg1594z00_2144;

					BgL_arg1594z00_2144 =
						(((BgL_rtl_regz00_bglt) COBJECT(
								((BgL_rtl_regz00_bglt) BgL_insz00_4)))->BgL_typez00);
					return BGl_typeSiza7eza7zzsaw_jvm_typez00(BgL_arg1594z00_2144);
				}
			else
				{	/* SawJvm/type.scm 25 */
					if (CBOOL(
							(((BgL_rtl_insz00_bglt) COBJECT(
										((BgL_rtl_insz00_bglt) BgL_insz00_4)))->BgL_destz00)))
						{	/* SawJvm/type.scm 29 */
							BgL_typez00_bglt BgL_arg1599z00_2147;

							BgL_arg1599z00_2147 =
								(((BgL_rtl_regz00_bglt) COBJECT(
										((BgL_rtl_regz00_bglt)
											(((BgL_rtl_insz00_bglt) COBJECT(
														((BgL_rtl_insz00_bglt) BgL_insz00_4)))->
												BgL_destz00))))->BgL_typez00);
							return BGl_typeSiza7eza7zzsaw_jvm_typez00(BgL_arg1599z00_2147);
						}
					else
						{	/* SawJvm/type.scm 30 */
							BgL_rtl_funz00_bglt BgL_arg1608z00_2149;

							BgL_arg1608z00_2149 =
								(((BgL_rtl_insz00_bglt) COBJECT(
										((BgL_rtl_insz00_bglt) BgL_insz00_4)))->BgL_funz00);
							return
								BGl_siza7ezd2destzd2funza7zzsaw_jvm_typez00(BgL_arg1608z00_2149,
								((BgL_rtl_insz00_bglt) BgL_insz00_4));
						}
				}
		}

	}



/* &size-dest */
	obj_t BGl_z62siza7ezd2destz17zzsaw_jvm_typez00(obj_t BgL_envz00_2853,
		obj_t BgL_insz00_2854)
	{
		{	/* SawJvm/type.scm 24 */
			return BINT(BGl_siza7ezd2destz75zzsaw_jvm_typez00(BgL_insz00_2854));
		}

	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzsaw_jvm_typez00()
	{
		{	/* SawJvm/type.scm 1 */
			return BUNSPEC;
		}

	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzsaw_jvm_typez00()
	{
		{	/* SawJvm/type.scm 1 */
			BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_siza7ezd2destzd2funzd2envz75zzsaw_jvm_typez00,
				BGl_proc1851z00zzsaw_jvm_typez00, BGl_rtl_funz00zzsaw_defsz00,
				BGl_string1852z00zzsaw_jvm_typez00);
			return
				BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_typezd2destzd2funzd2envzd2zzsaw_jvm_typez00,
				BGl_proc1853z00zzsaw_jvm_typez00, BGl_rtl_funz00zzsaw_defsz00,
				BGl_string1854z00zzsaw_jvm_typez00);
		}

	}



/* &type-dest-fun1576 */
	obj_t BGl_z62typezd2destzd2fun1576z62zzsaw_jvm_typez00(obj_t BgL_envz00_2857,
		obj_t BgL_funz00_2858)
	{
		{	/* SawJvm/type.scm 74 */
			{	/* SawJvm/type.scm 76 */
				obj_t BgL_arg1626z00_2940;

				{	/* SawJvm/type.scm 76 */
					obj_t BgL_arg1628z00_2941;

					{	/* SawJvm/type.scm 76 */
						long BgL_arg1745z00_2942;

						{	/* SawJvm/type.scm 76 */
							long BgL_arg1746z00_2943;

							{	/* SawJvm/type.scm 76 */
								long BgL_res1827z00_2944;

								BgL_res1827z00_2944 =
									BGL_OBJECT_CLASS_NUM(
									((BgL_objectz00_bglt)
										((BgL_rtl_funz00_bglt) BgL_funz00_2858)));
								BgL_arg1746z00_2943 = BgL_res1827z00_2944;
							}
							BgL_arg1745z00_2942 = (BgL_arg1746z00_2943 - OBJECT_TYPE);
						}
						BgL_arg1628z00_2941 =
							VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
							BgL_arg1745z00_2942);
					}
					BgL_arg1626z00_2940 =
						BGl_classzd2namezd2zz__objectz00(BgL_arg1628z00_2941);
				}
				return
					BGl_errorz00zz__errorz00(CNST_TABLE_REF(((long) 2)),
					BGl_string1855z00zzsaw_jvm_typez00, BgL_arg1626z00_2940);
		}}

	}



/* &size-dest-fun1546 */
	obj_t BGl_z62siza7ezd2destzd2fun1546zc5zzsaw_jvm_typez00(obj_t
		BgL_envz00_2859, obj_t BgL_funz00_2860, obj_t BgL_insz00_2861)
	{
		{	/* SawJvm/type.scm 35 */
			return
				BINT(BGl_typeSiza7eza7zzsaw_jvm_typez00
				(BGl_typezd2destzd2funz00zzsaw_jvm_typez00(((BgL_rtl_funz00_bglt)
							BgL_funz00_2860))));
		}

	}



/* size-dest-fun */
	int BGl_siza7ezd2destzd2funza7zzsaw_jvm_typez00(BgL_rtl_funz00_bglt
		BgL_funz00_5, BgL_rtl_insz00_bglt BgL_insz00_6)
	{
		{	/* SawJvm/type.scm 35 */
			{	/* SawJvm/type.scm 35 */
				obj_t BgL_method1547z00_2162;

				{	/* SawJvm/type.scm 35 */
					obj_t BgL_res1839z00_2795;

					{	/* SawJvm/type.scm 35 */
						long BgL_objzd2classzd2numz00_2760;

						{	/* SawJvm/type.scm 35 */
							long BgL_res1829z00_2763;

							BgL_res1829z00_2763 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_funz00_5));
							BgL_objzd2classzd2numz00_2760 = BgL_res1829z00_2763;
						}
						{	/* SawJvm/type.scm 35 */
							obj_t BgL_arg1742z00_2761;

							BgL_arg1742z00_2761 =
								PROCEDURE_REF(BGl_siza7ezd2destzd2funzd2envz75zzsaw_jvm_typez00,
								(int) (((long) 1)));
							{	/* SawJvm/type.scm 35 */
								int BgL_offsetz00_2765;

								BgL_offsetz00_2765 = (int) (BgL_objzd2classzd2numz00_2760);
								{	/* SawJvm/type.scm 35 */
									long BgL_offsetz00_2766;

									BgL_offsetz00_2766 =
										((long) (BgL_offsetz00_2765) - OBJECT_TYPE);
									{	/* SawJvm/type.scm 35 */
										long BgL_modz00_2767;

										BgL_modz00_2767 =
											(BgL_offsetz00_2766 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* SawJvm/type.scm 35 */
											long BgL_restz00_2769;

											BgL_restz00_2769 =
												(BgL_offsetz00_2766 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* SawJvm/type.scm 35 */

												{	/* SawJvm/type.scm 35 */
													obj_t BgL_bucketz00_2771;

													BgL_bucketz00_2771 =
														VECTOR_REF(
														((obj_t) BgL_arg1742z00_2761), BgL_modz00_2767);
													BgL_res1839z00_2795 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_2771), BgL_restz00_2769);
					}}}}}}}}
					BgL_method1547z00_2162 = BgL_res1839z00_2795;
				}
				return
					CINT(PROCEDURE_ENTRY(BgL_method1547z00_2162) (BgL_method1547z00_2162,
						((obj_t) BgL_funz00_5), ((obj_t) BgL_insz00_6), BEOA));
			}
		}

	}



/* &size-dest-fun */
	obj_t BGl_z62siza7ezd2destzd2funzc5zzsaw_jvm_typez00(obj_t BgL_envz00_2862,
		obj_t BgL_funz00_2863, obj_t BgL_insz00_2864)
	{
		{	/* SawJvm/type.scm 35 */
			return
				BINT(BGl_siza7ezd2destzd2funza7zzsaw_jvm_typez00(
					((BgL_rtl_funz00_bglt) BgL_funz00_2863),
					((BgL_rtl_insz00_bglt) BgL_insz00_2864)));
		}

	}



/* type-dest-fun */
	BgL_typez00_bglt BGl_typezd2destzd2funz00zzsaw_jvm_typez00(BgL_rtl_funz00_bglt
		BgL_funz00_35)
	{
		{	/* SawJvm/type.scm 74 */
			{	/* SawJvm/type.scm 74 */
				obj_t BgL_method1577z00_2163;

				{	/* SawJvm/type.scm 74 */
					obj_t BgL_res1850z00_2832;

					{	/* SawJvm/type.scm 74 */
						long BgL_objzd2classzd2numz00_2797;

						{	/* SawJvm/type.scm 74 */
							long BgL_res1840z00_2800;

							BgL_res1840z00_2800 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_funz00_35));
							BgL_objzd2classzd2numz00_2797 = BgL_res1840z00_2800;
						}
						{	/* SawJvm/type.scm 74 */
							obj_t BgL_arg1742z00_2798;

							BgL_arg1742z00_2798 =
								PROCEDURE_REF(BGl_typezd2destzd2funzd2envzd2zzsaw_jvm_typez00,
								(int) (((long) 1)));
							{	/* SawJvm/type.scm 74 */
								int BgL_offsetz00_2802;

								BgL_offsetz00_2802 = (int) (BgL_objzd2classzd2numz00_2797);
								{	/* SawJvm/type.scm 74 */
									long BgL_offsetz00_2803;

									BgL_offsetz00_2803 =
										((long) (BgL_offsetz00_2802) - OBJECT_TYPE);
									{	/* SawJvm/type.scm 74 */
										long BgL_modz00_2804;

										BgL_modz00_2804 =
											(BgL_offsetz00_2803 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* SawJvm/type.scm 74 */
											long BgL_restz00_2806;

											BgL_restz00_2806 =
												(BgL_offsetz00_2803 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* SawJvm/type.scm 74 */

												{	/* SawJvm/type.scm 74 */
													obj_t BgL_bucketz00_2808;

													BgL_bucketz00_2808 =
														VECTOR_REF(
														((obj_t) BgL_arg1742z00_2798), BgL_modz00_2804);
													BgL_res1850z00_2832 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_2808), BgL_restz00_2806);
					}}}}}}}}
					BgL_method1577z00_2163 = BgL_res1850z00_2832;
				}
				return
					((BgL_typez00_bglt)
					PROCEDURE_ENTRY(BgL_method1577z00_2163) (BgL_method1577z00_2163,
						((obj_t) BgL_funz00_35), BEOA));
			}
		}

	}



/* &type-dest-fun */
	BgL_typez00_bglt BGl_z62typezd2destzd2funz62zzsaw_jvm_typez00(obj_t
		BgL_envz00_2865, obj_t BgL_funz00_2866)
	{
		{	/* SawJvm/type.scm 74 */
			return
				BGl_typezd2destzd2funz00zzsaw_jvm_typez00(
				((BgL_rtl_funz00_bglt) BgL_funz00_2866));
		}

	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzsaw_jvm_typez00()
	{
		{	/* SawJvm/type.scm 1 */
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_siza7ezd2destzd2funzd2envz75zzsaw_jvm_typez00,
				BGl_rtl_lastz00zzsaw_defsz00, BGl_proc1856z00zzsaw_jvm_typez00,
				BGl_string1857z00zzsaw_jvm_typez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_siza7ezd2destzd2funzd2envz75zzsaw_jvm_typez00,
				BGl_rtl_notseqz00zzsaw_defsz00, BGl_proc1858z00zzsaw_jvm_typez00,
				BGl_string1857z00zzsaw_jvm_typez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_siza7ezd2destzd2funzd2envz75zzsaw_jvm_typez00,
				BGl_rtl_effectz00zzsaw_defsz00, BGl_proc1859z00zzsaw_jvm_typez00,
				BGl_string1857z00zzsaw_jvm_typez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_siza7ezd2destzd2funzd2envz75zzsaw_jvm_typez00,
				BGl_rtl_purez00zzsaw_defsz00, BGl_proc1860z00zzsaw_jvm_typez00,
				BGl_string1857z00zzsaw_jvm_typez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_siza7ezd2destzd2funzd2envz75zzsaw_jvm_typez00,
				BGl_rtl_movz00zzsaw_defsz00, BGl_proc1861z00zzsaw_jvm_typez00,
				BGl_string1857z00zzsaw_jvm_typez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_siza7ezd2destzd2funzd2envz75zzsaw_jvm_typez00,
				BGl_rtl_loadiz00zzsaw_defsz00, BGl_proc1862z00zzsaw_jvm_typez00,
				BGl_string1857z00zzsaw_jvm_typez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_siza7ezd2destzd2funzd2envz75zzsaw_jvm_typez00,
				BGl_rtl_loadgz00zzsaw_defsz00, BGl_proc1863z00zzsaw_jvm_typez00,
				BGl_string1857z00zzsaw_jvm_typez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_siza7ezd2destzd2funzd2envz75zzsaw_jvm_typez00,
				BGl_rtl_getfieldz00zzsaw_defsz00, BGl_proc1864z00zzsaw_jvm_typez00,
				BGl_string1857z00zzsaw_jvm_typez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_siza7ezd2destzd2funzd2envz75zzsaw_jvm_typez00,
				BGl_rtl_vrefz00zzsaw_defsz00, BGl_proc1865z00zzsaw_jvm_typez00,
				BGl_string1857z00zzsaw_jvm_typez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_siza7ezd2destzd2funzd2envz75zzsaw_jvm_typez00,
				BGl_rtl_newz00zzsaw_defsz00, BGl_proc1866z00zzsaw_jvm_typez00,
				BGl_string1867z00zzsaw_jvm_typez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_siza7ezd2destzd2funzd2envz75zzsaw_jvm_typez00,
				BGl_rtl_applyz00zzsaw_defsz00, BGl_proc1868z00zzsaw_jvm_typez00,
				BGl_string1867z00zzsaw_jvm_typez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_siza7ezd2destzd2funzd2envz75zzsaw_jvm_typez00,
				BGl_rtl_lightfuncallz00zzsaw_defsz00, BGl_proc1869z00zzsaw_jvm_typez00,
				BGl_string1867z00zzsaw_jvm_typez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_siza7ezd2destzd2funzd2envz75zzsaw_jvm_typez00,
				BGl_rtl_funcallz00zzsaw_defsz00, BGl_proc1870z00zzsaw_jvm_typez00,
				BGl_string1867z00zzsaw_jvm_typez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_siza7ezd2destzd2funzd2envz75zzsaw_jvm_typez00,
				BGl_rtl_castz00zzsaw_defsz00, BGl_proc1871z00zzsaw_jvm_typez00,
				BGl_string1867z00zzsaw_jvm_typez00);
			return
				BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_typezd2destzd2funzd2envzd2zzsaw_jvm_typez00,
				BGl_rtl_callz00zzsaw_defsz00, BGl_proc1872z00zzsaw_jvm_typez00,
				BGl_string1873z00zzsaw_jvm_typez00);
		}

	}



/* &type-dest-fun-rtl_ca1579 */
	BgL_typez00_bglt
		BGl_z62typezd2destzd2funzd2rtl_ca1579zb0zzsaw_jvm_typez00(obj_t
		BgL_envz00_2882, obj_t BgL_funz00_2883)
	{
		{	/* SawJvm/type.scm 78 */
			return
				(((BgL_variablez00_bglt) COBJECT(
						((BgL_variablez00_bglt)
							(((BgL_rtl_callz00_bglt) COBJECT(
										((BgL_rtl_callz00_bglt) BgL_funz00_2883)))->BgL_varz00))))->
				BgL_typez00);
		}

	}



/* &size-dest-fun-rtl_ca1575 */
	obj_t BGl_z62siza7ezd2destzd2funzd2rtl_ca1575z17zzsaw_jvm_typez00(obj_t
		BgL_envz00_2884, obj_t BgL_funz00_2885, obj_t BgL_insz00_2886)
	{
		{	/* SawJvm/type.scm 70 */
			return BINT(((long) 1));
		}

	}



/* &size-dest-fun-rtl_fu1573 */
	obj_t BGl_z62siza7ezd2destzd2funzd2rtl_fu1573z17zzsaw_jvm_typez00(obj_t
		BgL_envz00_2887, obj_t BgL_funz00_2888, obj_t BgL_insz00_2889)
	{
		{	/* SawJvm/type.scm 69 */
			return BINT(((long) 1));
		}

	}



/* &size-dest-fun-rtl_li1571 */
	obj_t BGl_z62siza7ezd2destzd2funzd2rtl_li1571z17zzsaw_jvm_typez00(obj_t
		BgL_envz00_2890, obj_t BgL_funz00_2891, obj_t BgL_insz00_2892)
	{
		{	/* SawJvm/type.scm 68 */
			return BINT(((long) 1));
		}

	}



/* &size-dest-fun-rtl_ap1569 */
	obj_t BGl_z62siza7ezd2destzd2funzd2rtl_ap1569z17zzsaw_jvm_typez00(obj_t
		BgL_envz00_2893, obj_t BgL_funz00_2894, obj_t BgL_insz00_2895)
	{
		{	/* SawJvm/type.scm 67 */
			return BINT(((long) 1));
		}

	}



/* &size-dest-fun-rtl_ne1567 */
	obj_t BGl_z62siza7ezd2destzd2funzd2rtl_ne1567z17zzsaw_jvm_typez00(obj_t
		BgL_envz00_2896, obj_t BgL_funz00_2897, obj_t BgL_insz00_2898)
	{
		{	/* SawJvm/type.scm 66 */
			return BINT(((long) 1));
		}

	}



/* &size-dest-fun-rtl_vr1565 */
	obj_t BGl_z62siza7ezd2destzd2funzd2rtl_vr1565z17zzsaw_jvm_typez00(obj_t
		BgL_envz00_2899, obj_t BgL_funz00_2900, obj_t BgL_insz00_2901)
	{
		{	/* SawJvm/type.scm 62 */
			return
				BINT(BGl_typeSiza7eza7zzsaw_jvm_typez00(
					(((BgL_rtl_vrefz00_bglt) COBJECT(
								((BgL_rtl_vrefz00_bglt) BgL_funz00_2900)))->BgL_typez00)));
		}

	}



/* &size-dest-fun-rtl_ge1563 */
	obj_t BGl_z62siza7ezd2destzd2funzd2rtl_ge1563z17zzsaw_jvm_typez00(obj_t
		BgL_envz00_2902, obj_t BgL_funz00_2903, obj_t BgL_insz00_2904)
	{
		{	/* SawJvm/type.scm 59 */
			return
				BINT(BGl_typeSiza7eza7zzsaw_jvm_typez00(
					(((BgL_rtl_getfieldz00_bglt) COBJECT(
								((BgL_rtl_getfieldz00_bglt) BgL_funz00_2903)))->BgL_typez00)));
		}

	}



/* &size-dest-fun-rtl_lo1561 */
	obj_t BGl_z62siza7ezd2destzd2funzd2rtl_lo1561z17zzsaw_jvm_typez00(obj_t
		BgL_envz00_2905, obj_t BgL_funz00_2906, obj_t BgL_insz00_2907)
	{
		{	/* SawJvm/type.scm 56 */
			{	/* SawJvm/type.scm 57 */
				int BgL_tmpz00_3158;

				{	/* SawJvm/type.scm 57 */
					BgL_typez00_bglt BgL_arg1637z00_2956;

					BgL_arg1637z00_2956 =
						(((BgL_variablez00_bglt) COBJECT(
								((BgL_variablez00_bglt)
									(((BgL_rtl_loadgz00_bglt) COBJECT(
												((BgL_rtl_loadgz00_bglt) BgL_funz00_2906)))->
										BgL_varz00))))->BgL_typez00);
					BgL_tmpz00_3158 =
						BGl_typeSiza7eza7zzsaw_jvm_typez00(BgL_arg1637z00_2956);
				}
				return BINT(BgL_tmpz00_3158);
			}
		}

	}



/* &size-dest-fun-rtl_lo1559 */
	obj_t BGl_z62siza7ezd2destzd2funzd2rtl_lo1559z17zzsaw_jvm_typez00(obj_t
		BgL_envz00_2908, obj_t BgL_funz00_2909, obj_t BgL_insz00_2910)
	{
		{	/* SawJvm/type.scm 49 */
			{	/* SawJvm/type.scm 50 */
				int BgL_tmpz00_3165;

				{	/* SawJvm/type.scm 50 */
					BgL_atomz00_bglt BgL_constantz00_2958;

					BgL_constantz00_2958 =
						(((BgL_rtl_loadiz00_bglt) COBJECT(
								((BgL_rtl_loadiz00_bglt) BgL_funz00_2909)))->BgL_constantz00);
					{	/* SawJvm/type.scm 51 */
						obj_t BgL_valuez00_2959;

						BgL_valuez00_2959 =
							(((BgL_atomz00_bglt) COBJECT(BgL_constantz00_2958))->
							BgL_valuez00);
						if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_valuez00_2959))
							{	/* SawJvm/type.scm 53 */
								BgL_typez00_bglt BgL_arg1636z00_2960;

								BgL_arg1636z00_2960 =
									(((BgL_nodez00_bglt) COBJECT(
											((BgL_nodez00_bglt) BgL_constantz00_2958)))->BgL_typez00);
								BgL_tmpz00_3165 =
									BGl_typeSiza7eza7zzsaw_jvm_typez00(BgL_arg1636z00_2960);
							}
						else
							{	/* SawJvm/type.scm 52 */
								BgL_tmpz00_3165 = (int) (((long) 1));
				}}}
				return BINT(BgL_tmpz00_3165);
			}
		}

	}



/* &size-dest-fun-rtl_mo1557 */
	obj_t BGl_z62siza7ezd2destzd2funzd2rtl_mo1557z17zzsaw_jvm_typez00(obj_t
		BgL_envz00_2911, obj_t BgL_funz00_2912, obj_t BgL_insz00_2913)
	{
		{	/* SawJvm/type.scm 46 */
			{	/* SawJvm/type.scm 47 */
				int BgL_tmpz00_3176;

				{	/* SawJvm/type.scm 47 */
					obj_t BgL_arg1631z00_2962;

					{	/* SawJvm/type.scm 47 */
						obj_t BgL_pairz00_2963;

						BgL_pairz00_2963 =
							(((BgL_rtl_insz00_bglt) COBJECT(
									((BgL_rtl_insz00_bglt) BgL_insz00_2913)))->BgL_argsz00);
						BgL_arg1631z00_2962 = CAR(BgL_pairz00_2963);
					}
					BgL_tmpz00_3176 =
						BGl_siza7ezd2destz75zzsaw_jvm_typez00(BgL_arg1631z00_2962);
				}
				return BINT(BgL_tmpz00_3176);
			}
		}

	}



/* &size-dest-fun-rtl_pu1555 */
	obj_t BGl_z62siza7ezd2destzd2funzd2rtl_pu1555z17zzsaw_jvm_typez00(obj_t
		BgL_envz00_2914, obj_t BgL_funz00_2915, obj_t BgL_insz00_2916)
	{
		{	/* SawJvm/type.scm 44 */
			return BINT(((long) 1));
		}

	}



/* &size-dest-fun-rtl_ef1553 */
	obj_t BGl_z62siza7ezd2destzd2funzd2rtl_ef1553z17zzsaw_jvm_typez00(obj_t
		BgL_envz00_2917, obj_t BgL_funz00_2918, obj_t BgL_insz00_2919)
	{
		{	/* SawJvm/type.scm 41 */
			return BINT(((long) 0));
		}

	}



/* &size-dest-fun-rtl_no1551 */
	obj_t BGl_z62siza7ezd2destzd2funzd2rtl_no1551z17zzsaw_jvm_typez00(obj_t
		BgL_envz00_2920, obj_t BgL_funz00_2921, obj_t BgL_insz00_2922)
	{
		{	/* SawJvm/type.scm 40 */
			return BINT(((long) 0));
		}

	}



/* &size-dest-fun-rtl_la1549 */
	obj_t BGl_z62siza7ezd2destzd2funzd2rtl_la1549z17zzsaw_jvm_typez00(obj_t
		BgL_envz00_2923, obj_t BgL_funz00_2924, obj_t BgL_insz00_2925)
	{
		{	/* SawJvm/type.scm 39 */
			return BINT(((long) 0));
		}

	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzsaw_jvm_typez00()
	{
		{	/* SawJvm/type.scm 1 */
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 515343395),
				BSTRING_TO_STRING(BGl_string1874z00zzsaw_jvm_typez00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 90839984),
				BSTRING_TO_STRING(BGl_string1874z00zzsaw_jvm_typez00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 506185397),
				BSTRING_TO_STRING(BGl_string1874z00zzsaw_jvm_typez00));
			BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 216206620),
				BSTRING_TO_STRING(BGl_string1874z00zzsaw_jvm_typez00));
			BGl_modulezd2initializa7ationz75zzbackend_bvmz00(((long) 336068337),
				BSTRING_TO_STRING(BGl_string1874z00zzsaw_jvm_typez00));
			BGl_modulezd2initializa7ationz75zzbackend_jvm_classz00(((long) 0),
				BSTRING_TO_STRING(BGl_string1874z00zzsaw_jvm_typez00));
			BGl_modulezd2initializa7ationz75zzsaw_defsz00(((long) 79517123),
				BSTRING_TO_STRING(BGl_string1874z00zzsaw_jvm_typez00));
			return
				BGl_modulezd2initializa7ationz75zzsaw_jvm_namesz00(((long) 179871433),
				BSTRING_TO_STRING(BGl_string1874z00zzsaw_jvm_typez00));
		}

	}

#ifdef __cplusplus
}
#endif
