/*===========================================================================*/
/*   (Eval/evaluate_uncomp.scm)                                              */
/*   Bigloo (4.3h)                                                           */
/*   Inria -- Sophia Antipolis (c)       Tue 12 May 2020 08:36:09 AM CEST    */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.3h/bin/bigloo -srfi enable-resolv -srfi enable-unistring -srfi enable-pcre -srfi enable-gmp -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.3h/lib/bigloo/4.3h -rm -copt -w -lib-dir /builddir/build/BUILD/bigloo-4.3h/lib/bigloo/4.3h -O4 -mklib -unsafe -safee -cc gcc -fsharing -q -no-hello -p -srfi bigloo-profile -c Eval/evaluate_uncomp.scm -o objs/obj_p/Eval/evaluate_uncomp.o) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_ev_exprz00_bgl {
   header_t header;
   obj_t widening;
} *BgL_ev_exprz00_bglt;

typedef struct BgL_ev_varz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_effz00;
   obj_t BgL_typez00;
} *BgL_ev_varz00_bglt;

typedef struct BgL_ev_globalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   obj_t BgL_namez00;
   obj_t BgL_modz00;
} *BgL_ev_globalz00_bglt;

typedef struct BgL_ev_littz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_valuez00;
} *BgL_ev_littz00_bglt;

typedef struct BgL_ev_ifz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_pz00;
   struct BgL_ev_exprz00_bgl * BgL_tz00;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
} *BgL_ev_ifz00_bglt;

typedef struct BgL_ev_listz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_argsz00;
} *BgL_ev_listz00_bglt;

typedef struct BgL_ev_orz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_argsz00;
} *BgL_ev_orz00_bglt;

typedef struct BgL_ev_andz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_argsz00;
} *BgL_ev_andz00_bglt;

typedef struct BgL_ev_prog2z00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_e1z00;
   struct BgL_ev_exprz00_bgl * BgL_e2z00;
} *BgL_ev_prog2z00_bglt;

typedef struct BgL_ev_hookz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
} *BgL_ev_hookz00_bglt;

typedef struct BgL_ev_trapz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
} *BgL_ev_trapz00_bglt;

typedef struct BgL_ev_setlocalz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
   struct BgL_ev_varz00_bgl * BgL_vz00;
} *BgL_ev_setlocalz00_bglt;

typedef struct BgL_ev_setglobalz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
   obj_t BgL_locz00;
   obj_t BgL_namez00;
   obj_t BgL_modz00;
} *BgL_ev_setglobalz00_bglt;

typedef struct BgL_ev_defglobalz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
   obj_t BgL_locz00;
   obj_t BgL_namez00;
   obj_t BgL_modz00;
} *BgL_ev_defglobalz00_bglt;

typedef struct BgL_ev_bindzd2exitzd2_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_varz00_bgl * BgL_varz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_bindzd2exitzd2_bglt;

typedef struct BgL_ev_unwindzd2protectzd2_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_unwindzd2protectzd2_bglt;

typedef struct BgL_ev_withzd2handlerzd2_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_handlerz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_withzd2handlerzd2_bglt;

typedef struct BgL_ev_synchroniza7eza7_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_ev_exprz00_bgl * BgL_mutexz00;
   struct BgL_ev_exprz00_bgl * BgL_prelockz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_synchroniza7eza7_bglt;

typedef struct BgL_ev_binderz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_binderz00_bglt;

typedef struct BgL_ev_letz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
   obj_t BgL_boxesz00;
} *BgL_ev_letz00_bglt;

typedef struct BgL_ev_letza2za2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
   obj_t BgL_boxesz00;
} *BgL_ev_letza2za2_bglt;

typedef struct BgL_ev_letrecz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_letrecz00_bglt;

typedef struct BgL_ev_labelsz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   obj_t BgL_envz00;
   obj_t BgL_stkz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
   obj_t BgL_boxesz00;
} *BgL_ev_labelsz00_bglt;

typedef struct BgL_ev_gotoz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_ev_varz00_bgl * BgL_labelz00;
   struct BgL_ev_labelsz00_bgl * BgL_labelsz00;
   obj_t BgL_argsz00;
} *BgL_ev_gotoz00_bglt;

typedef struct BgL_ev_appz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_ev_exprz00_bgl * BgL_funz00;
   obj_t BgL_argsz00;
   obj_t BgL_tailzf3zf3;
} *BgL_ev_appz00_bglt;

typedef struct BgL_ev_absz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   obj_t BgL_wherez00;
   obj_t BgL_arityz00;
   obj_t BgL_varsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
   int BgL_siza7eza7;
   obj_t BgL_bindz00;
   obj_t BgL_freez00;
   obj_t BgL_innerz00;
   obj_t BgL_boxesz00;
} *BgL_ev_absz00_bglt;


static obj_t BGl_z62uncompzd2ev_or1210zb0zz__evaluate_uncompz00(obj_t, obj_t);
extern obj_t BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
static obj_t BGl_z62uncompzd2ev_setlocal1222zb0zz__evaluate_uncompz00(obj_t, obj_t);
static obj_t BGl_z62uncomp1198z62zz__evaluate_uncompz00(obj_t, obj_t);
static obj_t BGl_z62uncompzd2ev_bindzd2exit1224z62zz__evaluate_uncompz00(obj_t, obj_t);
extern obj_t BGl_ev_letrecz00zz__evaluate_typesz00;
static obj_t BGl_z62uncompzd2ev_var1202zb0zz__evaluate_uncompz00(obj_t, obj_t);
static obj_t BGl_z62uncompzd2ev_prog21214zb0zz__evaluate_uncompz00(obj_t, obj_t);
extern obj_t BGl_ev_letz00zz__evaluate_typesz00;
static obj_t BGl_objectzd2initzd2zz__evaluate_uncompz00();
static obj_t BGl_z62uncompzd2ev_unwindzd2pro1226z62zz__evaluate_uncompz00(obj_t, obj_t);
extern obj_t bstring_to_symbol(obj_t);
extern bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
static obj_t BGl_z62uncompzd2ev_goto1240zb0zz__evaluate_uncompz00(obj_t, obj_t);
extern obj_t BGl_ev_labelsz00zz__evaluate_typesz00;
static obj_t BGl_methodzd2initzd2zz__evaluate_uncompz00();
static obj_t BGl_recze70ze7zz__evaluate_uncompz00(obj_t);
extern obj_t BGl_ev_absz00zz__evaluate_typesz00;
static obj_t BGl_keyword2024z00zz__evaluate_uncompz00 = BUNSPEC;
extern obj_t BGl_ev_ifz00zz__evaluate_typesz00;
extern obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
static obj_t BGl_symbol2016z00zz__evaluate_uncompz00 = BUNSPEC;
static obj_t BGl_symbol2018z00zz__evaluate_uncompz00 = BUNSPEC;
extern obj_t BGl_ev_gotoz00zz__evaluate_typesz00;
static obj_t BGl_symbol2020z00zz__evaluate_uncompz00 = BUNSPEC;
static obj_t BGl_symbol2022z00zz__evaluate_uncompz00 = BUNSPEC;
static obj_t BGl_symbol2026z00zz__evaluate_uncompz00 = BUNSPEC;
static obj_t BGl_symbol2028z00zz__evaluate_uncompz00 = BUNSPEC;
static obj_t BGl_symbol2030z00zz__evaluate_uncompz00 = BUNSPEC;
static obj_t BGl_symbol2032z00zz__evaluate_uncompz00 = BUNSPEC;
static obj_t BGl_symbol2034z00zz__evaluate_uncompz00 = BUNSPEC;
static obj_t BGl_symbol2036z00zz__evaluate_uncompz00 = BUNSPEC;
static obj_t BGl_symbol2038z00zz__evaluate_uncompz00 = BUNSPEC;
static obj_t BGl_symbol2040z00zz__evaluate_uncompz00 = BUNSPEC;
static obj_t BGl_symbol2042z00zz__evaluate_uncompz00 = BUNSPEC;
static obj_t BGl_symbol2044z00zz__evaluate_uncompz00 = BUNSPEC;
static obj_t BGl_z62uncompzd2ev_labels1238zb0zz__evaluate_uncompz00(obj_t, obj_t);
static obj_t BGl_symbol2046z00zz__evaluate_uncompz00 = BUNSPEC;
static obj_t BGl_symbol2048z00zz__evaluate_uncompz00 = BUNSPEC;
extern obj_t BGl_ev_orz00zz__evaluate_typesz00;
extern obj_t BGl_ev_varz00zz__evaluate_typesz00;
static obj_t BGl_gczd2rootszd2initz00zz__evaluate_uncompz00();
extern obj_t BGl_ev_andz00zz__evaluate_typesz00;
static obj_t BGl_z62uncompilez62zz__evaluate_uncompz00(obj_t, obj_t);
static obj_t BGl_z62uncompzd2ev_trap1216zb0zz__evaluate_uncompz00(obj_t, obj_t);
static obj_t BGl_z62uncompz62zz__evaluate_uncompz00(obj_t, obj_t);
extern obj_t BGl_ev_appz00zz__evaluate_typesz00;
extern obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_ev_synchroniza7eza7zz__evaluate_typesz00;
static obj_t BGl_profzd2initzd2zz__evaluate_uncompz00();
BGL_EXPORTED_DECL obj_t BGl_uncompilez00zz__evaluate_uncompz00(BgL_ev_exprz00_bglt);
static obj_t BGl_z62uncompzd2ev_withzd2handl1228z62zz__evaluate_uncompz00(obj_t, obj_t);
extern obj_t BGl_ev_defglobalz00zz__evaluate_typesz00;
static obj_t BGl_requirezd2initializa7ationz75zz__evaluate_uncompz00 = BUNSPEC;
extern obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_toplevelzd2initzd2zz__evaluate_uncompz00();
static obj_t BGl_genericzd2initzd2zz__evaluate_uncompz00();
extern obj_t BGl_ev_prog2z00zz__evaluate_typesz00;
static obj_t BGl_redovarsze70ze7zz__evaluate_uncompz00(obj_t, obj_t);
extern obj_t BGl_ev_bindzd2exitzd2zz__evaluate_typesz00;
static obj_t BGl_z62uncompzd2ev_let1232zb0zz__evaluate_uncompz00(obj_t, obj_t);
static obj_t BGl_symbol1990z00zz__evaluate_uncompz00 = BUNSPEC;
extern obj_t BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00;
extern obj_t BGl_ev_letza2za2zz__evaluate_typesz00;
extern obj_t BGl_ev_trapz00zz__evaluate_typesz00;
static obj_t BGl_z62uncompzd2ev_defglobal1220zb0zz__evaluate_uncompz00(obj_t, obj_t);
static obj_t BGl_z62uncompzd2ev_setglobal1218zb0zz__evaluate_uncompz00(obj_t, obj_t);
static obj_t BGl_z62uncompzd2ev_app1242zb0zz__evaluate_uncompz00(obj_t, obj_t);
extern obj_t BGl_ev_setglobalz00zz__evaluate_typesz00;
static obj_t BGl_uncompz00zz__evaluate_uncompz00(BgL_ev_exprz00_bglt);
static obj_t BGl_z62uncompzd2ev_and1212zb0zz__evaluate_uncompz00(obj_t, obj_t);
static obj_t BGl_z62uncompzd2ev_synchroniza71230z17zz__evaluate_uncompz00(obj_t, obj_t);
static obj_t BGl_z62uncompzd2ev_if1208zb0zz__evaluate_uncompz00(obj_t, obj_t);
static obj_t BGl_z62uncompzd2ev_global1204zb0zz__evaluate_uncompz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__evaluate_uncompz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__evmodulez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__everrorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__evcompilez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__evenvz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__expandz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__prognz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ppz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__dssslz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__bignumz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__structurez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__tvectorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__typez00(long, char *);
static obj_t BGl_z62uncompzd2ev_abs1244zb0zz__evaluate_uncompz00(obj_t, obj_t);
extern obj_t BGl_ev_globalz00zz__evaluate_typesz00;
extern obj_t BGl_ev_littz00zz__evaluate_typesz00;
static obj_t BGl_cnstzd2initzd2zz__evaluate_uncompz00();
static obj_t BGl_importedzd2moduleszd2initz00zz__evaluate_uncompz00();
extern obj_t BGl_ev_withzd2handlerzd2zz__evaluate_typesz00;
static obj_t BGl_z62uncompzd2ev_litt1206zb0zz__evaluate_uncompz00(obj_t, obj_t);
static obj_t BGl_z62uncompzd2ev_letza21234z12zz__evaluate_uncompz00(obj_t, obj_t);
extern obj_t BGl_ev_exprz00zz__evaluate_typesz00;
extern obj_t bstring_to_keyword(obj_t);
static obj_t BGl_z62uncompzd2ev_letrec1236zb0zz__evaluate_uncompz00(obj_t, obj_t);
extern obj_t BGl_ev_setlocalz00zz__evaluate_typesz00;
static obj_t *__cnst;


DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1988z00zz__evaluate_uncompz00, BgL_bgl_za762uncomp1198za7622051z00, BGl_z62uncomp1198z62zz__evaluate_uncompz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1993z00zz__evaluate_uncompz00, BgL_bgl_za762uncompza7d2ev_v2052z00, BGl_z62uncompzd2ev_var1202zb0zz__evaluate_uncompz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1995z00zz__evaluate_uncompz00, BgL_bgl_za762uncompza7d2ev_g2053z00, BGl_z62uncompzd2ev_global1204zb0zz__evaluate_uncompz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1996z00zz__evaluate_uncompz00, BgL_bgl_za762uncompza7d2ev_l2054z00, BGl_z62uncompzd2ev_litt1206zb0zz__evaluate_uncompz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1997z00zz__evaluate_uncompz00, BgL_bgl_za762uncompza7d2ev_i2055z00, BGl_z62uncompzd2ev_if1208zb0zz__evaluate_uncompz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1998z00zz__evaluate_uncompz00, BgL_bgl_za762uncompza7d2ev_o2056z00, BGl_z62uncompzd2ev_or1210zb0zz__evaluate_uncompz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1999z00zz__evaluate_uncompz00, BgL_bgl_za762uncompza7d2ev_a2057z00, BGl_z62uncompzd2ev_and1212zb0zz__evaluate_uncompz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_GENERIC( BGl_uncompzd2envzd2zz__evaluate_uncompz00, BgL_bgl_za762uncompza762za7za7__2058z00, BGl_z62uncompz62zz__evaluate_uncompz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2017z00zz__evaluate_uncompz00, BgL_bgl_string2017za700za7za7_2059za7, "lambda", 6 );
DEFINE_STRING( BGl_string2019z00zz__evaluate_uncompz00, BgL_bgl_string2019za700za7za7_2060za7, "letrec", 6 );
DEFINE_STRING( BGl_string2021z00zz__evaluate_uncompz00, BgL_bgl_string2021za700za7za7_2061za7, "let*", 4 );
DEFINE_STRING( BGl_string2023z00zz__evaluate_uncompz00, BgL_bgl_string2023za700za7za7_2062za7, "let", 3 );
DEFINE_STRING( BGl_string2025z00zz__evaluate_uncompz00, BgL_bgl_string2025za700za7za7_2063za7, "prelock", 7 );
DEFINE_STRING( BGl_string2027z00zz__evaluate_uncompz00, BgL_bgl_string2027za700za7za7_2064za7, "synchronize", 11 );
DEFINE_STRING( BGl_string2029z00zz__evaluate_uncompz00, BgL_bgl_string2029za700za7za7_2065za7, "with-handler", 12 );
DEFINE_STRING( BGl_string2031z00zz__evaluate_uncompz00, BgL_bgl_string2031za700za7za7_2066za7, "unwind-protect", 14 );
DEFINE_STRING( BGl_string2033z00zz__evaluate_uncompz00, BgL_bgl_string2033za700za7za7_2067za7, "bind-exit", 9 );
DEFINE_STRING( BGl_string2035z00zz__evaluate_uncompz00, BgL_bgl_string2035za700za7za7_2068za7, "set!", 4 );
DEFINE_STRING( BGl_string2037z00zz__evaluate_uncompz00, BgL_bgl_string2037za700za7za7_2069za7, "define", 6 );
DEFINE_STRING( BGl_string2039z00zz__evaluate_uncompz00, BgL_bgl_string2039za700za7za7_2070za7, "trap", 4 );
DEFINE_STRING( BGl_string2041z00zz__evaluate_uncompz00, BgL_bgl_string2041za700za7za7_2071za7, "begin", 5 );
DEFINE_STRING( BGl_string2043z00zz__evaluate_uncompz00, BgL_bgl_string2043za700za7za7_2072za7, "and", 3 );
DEFINE_STRING( BGl_string2045z00zz__evaluate_uncompz00, BgL_bgl_string2045za700za7za7_2073za7, "or", 2 );
DEFINE_STRING( BGl_string2047z00zz__evaluate_uncompz00, BgL_bgl_string2047za700za7za7_2074za7, "if", 2 );
DEFINE_STRING( BGl_string2049z00zz__evaluate_uncompz00, BgL_bgl_string2049za700za7za7_2075za7, "quote", 5 );
DEFINE_STRING( BGl_string2050z00zz__evaluate_uncompz00, BgL_bgl_string2050za700za7za7_2076za7, "__evaluate_uncomp", 17 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_uncompilezd2envzd2zz__evaluate_uncompz00, BgL_bgl_za762uncompileza762za72077za7, BGl_z62uncompilez62zz__evaluate_uncompz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1985z00zz__evaluate_uncompz00, BgL_bgl_string1985za700za7za7_2078za7, "/builddir/build/BUILD/bigloo-4.3h/runtime/Eval/evaluate_uncomp.scm", 66 );
DEFINE_STRING( BGl_string1986z00zz__evaluate_uncompz00, BgL_bgl_string1986za700za7za7_2079za7, "&uncompile", 10 );
DEFINE_STRING( BGl_string1987z00zz__evaluate_uncompz00, BgL_bgl_string1987za700za7za7_2080za7, "ev_expr", 7 );
DEFINE_STRING( BGl_string1989z00zz__evaluate_uncompz00, BgL_bgl_string1989za700za7za7_2081za7, "uncomp1198", 10 );
DEFINE_STRING( BGl_string1991z00zz__evaluate_uncompz00, BgL_bgl_string1991za700za7za7_2082za7, "No method for this object", 25 );
DEFINE_STRING( BGl_string1992z00zz__evaluate_uncompz00, BgL_bgl_string1992za700za7za7_2083za7, "&uncomp", 7 );
DEFINE_STRING( BGl_string1994z00zz__evaluate_uncompz00, BgL_bgl_string1994za700za7za7_2084za7, "uncomp", 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2000z00zz__evaluate_uncompz00, BgL_bgl_za762uncompza7d2ev_p2085z00, BGl_z62uncompzd2ev_prog21214zb0zz__evaluate_uncompz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2001z00zz__evaluate_uncompz00, BgL_bgl_za762uncompza7d2ev_t2086z00, BGl_z62uncompzd2ev_trap1216zb0zz__evaluate_uncompz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2002z00zz__evaluate_uncompz00, BgL_bgl_za762uncompza7d2ev_s2087z00, BGl_z62uncompzd2ev_setglobal1218zb0zz__evaluate_uncompz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2003z00zz__evaluate_uncompz00, BgL_bgl_za762uncompza7d2ev_d2088z00, BGl_z62uncompzd2ev_defglobal1220zb0zz__evaluate_uncompz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2004z00zz__evaluate_uncompz00, BgL_bgl_za762uncompza7d2ev_s2089z00, BGl_z62uncompzd2ev_setlocal1222zb0zz__evaluate_uncompz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2005z00zz__evaluate_uncompz00, BgL_bgl_za762uncompza7d2ev_b2090z00, BGl_z62uncompzd2ev_bindzd2exit1224z62zz__evaluate_uncompz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2006z00zz__evaluate_uncompz00, BgL_bgl_za762uncompza7d2ev_u2091z00, BGl_z62uncompzd2ev_unwindzd2pro1226z62zz__evaluate_uncompz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2007z00zz__evaluate_uncompz00, BgL_bgl_za762uncompza7d2ev_w2092z00, BGl_z62uncompzd2ev_withzd2handl1228z62zz__evaluate_uncompz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2008z00zz__evaluate_uncompz00, BgL_bgl_za762uncompza7d2ev_s2093z00, BGl_z62uncompzd2ev_synchroniza71230z17zz__evaluate_uncompz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2009z00zz__evaluate_uncompz00, BgL_bgl_za762uncompza7d2ev_l2094z00, BGl_z62uncompzd2ev_let1232zb0zz__evaluate_uncompz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2010z00zz__evaluate_uncompz00, BgL_bgl_za762uncompza7d2ev_l2095z00, BGl_z62uncompzd2ev_letza21234z12zz__evaluate_uncompz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2011z00zz__evaluate_uncompz00, BgL_bgl_za762uncompza7d2ev_l2096z00, BGl_z62uncompzd2ev_letrec1236zb0zz__evaluate_uncompz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2012z00zz__evaluate_uncompz00, BgL_bgl_za762uncompza7d2ev_l2097z00, BGl_z62uncompzd2ev_labels1238zb0zz__evaluate_uncompz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2013z00zz__evaluate_uncompz00, BgL_bgl_za762uncompza7d2ev_g2098z00, BGl_z62uncompzd2ev_goto1240zb0zz__evaluate_uncompz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2014z00zz__evaluate_uncompz00, BgL_bgl_za762uncompza7d2ev_a2099z00, BGl_z62uncompzd2ev_app1242zb0zz__evaluate_uncompz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2015z00zz__evaluate_uncompz00, BgL_bgl_za762uncompza7d2ev_a2100z00, BGl_z62uncompzd2ev_abs1244zb0zz__evaluate_uncompz00, 0L, BUNSPEC, 1 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_keyword2024z00zz__evaluate_uncompz00) );
ADD_ROOT( (void *)(&BGl_symbol2016z00zz__evaluate_uncompz00) );
ADD_ROOT( (void *)(&BGl_symbol2018z00zz__evaluate_uncompz00) );
ADD_ROOT( (void *)(&BGl_symbol2020z00zz__evaluate_uncompz00) );
ADD_ROOT( (void *)(&BGl_symbol2022z00zz__evaluate_uncompz00) );
ADD_ROOT( (void *)(&BGl_symbol2026z00zz__evaluate_uncompz00) );
ADD_ROOT( (void *)(&BGl_symbol2028z00zz__evaluate_uncompz00) );
ADD_ROOT( (void *)(&BGl_symbol2030z00zz__evaluate_uncompz00) );
ADD_ROOT( (void *)(&BGl_symbol2032z00zz__evaluate_uncompz00) );
ADD_ROOT( (void *)(&BGl_symbol2034z00zz__evaluate_uncompz00) );
ADD_ROOT( (void *)(&BGl_symbol2036z00zz__evaluate_uncompz00) );
ADD_ROOT( (void *)(&BGl_symbol2038z00zz__evaluate_uncompz00) );
ADD_ROOT( (void *)(&BGl_symbol2040z00zz__evaluate_uncompz00) );
ADD_ROOT( (void *)(&BGl_symbol2042z00zz__evaluate_uncompz00) );
ADD_ROOT( (void *)(&BGl_symbol2044z00zz__evaluate_uncompz00) );
ADD_ROOT( (void *)(&BGl_symbol2046z00zz__evaluate_uncompz00) );
ADD_ROOT( (void *)(&BGl_symbol2048z00zz__evaluate_uncompz00) );
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__evaluate_uncompz00) );
ADD_ROOT( (void *)(&BGl_symbol1990z00zz__evaluate_uncompz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* prof association table */
static obj_t write_bprof_table() {
   extern obj_t bprof_port;
   if( bprof_port == BUNSPEC ) bprof_port = (obj_t)fopen( "bmon.out", "w" );
   if( bprof_port ) {
      fputs( "(\"module-initialization\" \"BGl_modulezd2initializa7ationz75zz__evaluate_uncompz00\")\n", (FILE *)bprof_port );
      fputs( "((\"toplevel-init\" \"Eval/evaluate_uncomp.scm\" 963) \"BGl_toplevelzd2initzd2zz__evaluate_uncompz00\")\n", (FILE *)bprof_port );
      fputs( "((\"uncompile\" \"Eval/evaluate_uncomp.scm\" 1781) \"BGl_uncompilez00zz__evaluate_uncompz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&uncompile\" \"Eval/evaluate_uncomp.scm\" 1781) \"BGl_z62uncompilez62zz__evaluate_uncompz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&uncomp1198\" \"Eval/evaluate_uncomp.scm\" 1830) \"BGl_z62uncomp1198z62zz__evaluate_uncompz00\")\n", (FILE *)bprof_port );
      fputs( "((\"uncomp\" \"Eval/evaluate_uncomp.scm\" 1830) \"BGl_uncompz00zz__evaluate_uncompz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&uncomp\" \"Eval/evaluate_uncomp.scm\" 1830) \"BGl_z62uncompz62zz__evaluate_uncompz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&uncomp-ev_abs1244\" \"Eval/evaluate_uncomp.scm\" 4781) \"BGl_z62uncompzd2ev_abs1244zb0zz__evaluate_uncompz00\")\n", (FILE *)bprof_port );
      fputs( "((\"rec~0\" \"Eval/evaluate_uncomp.scm\" 4920) \"BGl_recze70ze7zz__evaluate_uncompz00\")\n", (FILE *)bprof_port );
      fputs( "((\"redovars~0\" \"Eval/evaluate_uncomp.scm\" 5012) \"BGl_redovarsze70ze7zz__evaluate_uncompz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&uncomp-ev_app1242\" \"Eval/evaluate_uncomp.scm\" 4662) \"BGl_z62uncompzd2ev_app1242zb0zz__evaluate_uncompz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&uncomp-ev_goto1240\" \"Eval/evaluate_uncomp.scm\" 4537) \"BGl_z62uncompzd2ev_goto1240zb0zz__evaluate_uncompz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&uncomp-ev_labels1238\" \"Eval/evaluate_uncomp.scm\" 4300) \"BGl_z62uncompzd2ev_labels1238zb0zz__evaluate_uncompz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&uncomp-ev_letrec1236\" \"Eval/evaluate_uncomp.scm\" 4122) \"BGl_z62uncompzd2ev_letrec1236zb0zz__evaluate_uncompz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&uncomp-ev_let*1234\" \"Eval/evaluate_uncomp.scm\" 3950) \"BGl_z62uncompzd2ev_letza21234z12zz__evaluate_uncompz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&uncomp-ev_let1232\" \"Eval/evaluate_uncomp.scm\" 3781) \"BGl_z62uncompzd2ev_let1232zb0zz__evaluate_uncompz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&uncomp-ev_synchroniz1230\" \"Eval/evaluate_uncomp.scm\" 3600) \"BGl_z62uncompzd2ev_synchroniza71230z17zz__evaluate_uncompz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&uncomp-ev_with-handl1228\" \"Eval/evaluate_uncomp.scm\" 3447) \"BGl_z62uncompzd2ev_withzd2handl1228z62zz__evaluate_uncompz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&uncomp-ev_unwind-pro1226\" \"Eval/evaluate_uncomp.scm\" 3294) \"BGl_z62uncompzd2ev_unwindzd2pro1226z62zz__evaluate_uncompz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&uncomp-ev_bind-exit1224\" \"Eval/evaluate_uncomp.scm\" 3150) \"BGl_z62uncompzd2ev_bindzd2exit1224z62zz__evaluate_uncompz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&uncomp-ev_setlocal1222\" \"Eval/evaluate_uncomp.scm\" 3025) \"BGl_z62uncompzd2ev_setlocal1222zb0zz__evaluate_uncompz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&uncomp-ev_defglobal1220\" \"Eval/evaluate_uncomp.scm\" 2905) \"BGl_z62uncompzd2ev_defglobal1220zb0zz__evaluate_uncompz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&uncomp-ev_setglobal1218\" \"Eval/evaluate_uncomp.scm\" 2787) \"BGl_z62uncompzd2ev_setglobal1218zb0zz__evaluate_uncompz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&uncomp-ev_trap1216\" \"Eval/evaluate_uncomp.scm\" 2690) \"BGl_z62uncompzd2ev_trap1216zb0zz__evaluate_uncompz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&uncomp-ev_prog21214\" \"Eval/evaluate_uncomp.scm\" 2464) \"BGl_z62uncompzd2ev_prog21214zb0zz__evaluate_uncompz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&uncomp-ev_and1212\" \"Eval/evaluate_uncomp.scm\" 2359) \"BGl_z62uncompzd2ev_and1212zb0zz__evaluate_uncompz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&uncomp-ev_or1210\" \"Eval/evaluate_uncomp.scm\" 2257) \"BGl_z62uncompzd2ev_or1210zb0zz__evaluate_uncompz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&uncomp-ev_if1208\" \"Eval/evaluate_uncomp.scm\" 2138) \"BGl_z62uncompzd2ev_if1208zb0zz__evaluate_uncompz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&uncomp-ev_litt1206\" \"Eval/evaluate_uncomp.scm\" 2048) \"BGl_z62uncompzd2ev_litt1206zb0zz__evaluate_uncompz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&uncomp-ev_global1204\" \"Eval/evaluate_uncomp.scm\" 1955) \"BGl_z62uncompzd2ev_global1204zb0zz__evaluate_uncompz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&uncomp-ev_var1202\" \"Eval/evaluate_uncomp.scm\" 1868) \"BGl_z62uncompzd2ev_var1202zb0zz__evaluate_uncompz00\")\n", (FILE *)bprof_port );
      fputs( "(\"CONS\" \"make_pair\")\n", (FILE *)bprof_port );
      fputs( "(\"%STRING->SYMBOL\" \"make_symbol\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-STRING\" \"string_to_bstring_len\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-OUTPUT-PORT\" \"bgl_make_output_port\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-INPUT-PORT\" \"bgl_make_input_port\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-ERROR-PORT\" \"make_error_port\")\n", (FILE *)bprof_port );
   }
   return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__evaluate_uncompz00(long BgL_checksumz00_2710, char * BgL_fromz00_2711)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__evaluate_uncompz00))
{ 
BGl_requirezd2initializa7ationz75zz__evaluate_uncompz00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__evaluate_uncompz00(); 
BGl_cnstzd2initzd2zz__evaluate_uncompz00(); 
BGl_importedzd2moduleszd2initz00zz__evaluate_uncompz00(); 
BGl_genericzd2initzd2zz__evaluate_uncompz00(); 
BGl_methodzd2initzd2zz__evaluate_uncompz00(); 
return 
BGl_profzd2initzd2zz__evaluate_uncompz00();}  else 
{ 
return BUNSPEC;} } 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__evaluate_uncompz00()
{
{ /* Eval/evaluate_uncomp.scm 15 */
BGl_symbol1990z00zz__evaluate_uncompz00 = 
bstring_to_symbol(BGl_string1989z00zz__evaluate_uncompz00); 
BGl_symbol2016z00zz__evaluate_uncompz00 = 
bstring_to_symbol(BGl_string2017z00zz__evaluate_uncompz00); 
BGl_symbol2018z00zz__evaluate_uncompz00 = 
bstring_to_symbol(BGl_string2019z00zz__evaluate_uncompz00); 
BGl_symbol2020z00zz__evaluate_uncompz00 = 
bstring_to_symbol(BGl_string2021z00zz__evaluate_uncompz00); 
BGl_symbol2022z00zz__evaluate_uncompz00 = 
bstring_to_symbol(BGl_string2023z00zz__evaluate_uncompz00); 
BGl_keyword2024z00zz__evaluate_uncompz00 = 
bstring_to_keyword(BGl_string2025z00zz__evaluate_uncompz00); 
BGl_symbol2026z00zz__evaluate_uncompz00 = 
bstring_to_symbol(BGl_string2027z00zz__evaluate_uncompz00); 
BGl_symbol2028z00zz__evaluate_uncompz00 = 
bstring_to_symbol(BGl_string2029z00zz__evaluate_uncompz00); 
BGl_symbol2030z00zz__evaluate_uncompz00 = 
bstring_to_symbol(BGl_string2031z00zz__evaluate_uncompz00); 
BGl_symbol2032z00zz__evaluate_uncompz00 = 
bstring_to_symbol(BGl_string2033z00zz__evaluate_uncompz00); 
BGl_symbol2034z00zz__evaluate_uncompz00 = 
bstring_to_symbol(BGl_string2035z00zz__evaluate_uncompz00); 
BGl_symbol2036z00zz__evaluate_uncompz00 = 
bstring_to_symbol(BGl_string2037z00zz__evaluate_uncompz00); 
BGl_symbol2038z00zz__evaluate_uncompz00 = 
bstring_to_symbol(BGl_string2039z00zz__evaluate_uncompz00); 
BGl_symbol2040z00zz__evaluate_uncompz00 = 
bstring_to_symbol(BGl_string2041z00zz__evaluate_uncompz00); 
BGl_symbol2042z00zz__evaluate_uncompz00 = 
bstring_to_symbol(BGl_string2043z00zz__evaluate_uncompz00); 
BGl_symbol2044z00zz__evaluate_uncompz00 = 
bstring_to_symbol(BGl_string2045z00zz__evaluate_uncompz00); 
BGl_symbol2046z00zz__evaluate_uncompz00 = 
bstring_to_symbol(BGl_string2047z00zz__evaluate_uncompz00); 
return ( 
BGl_symbol2048z00zz__evaluate_uncompz00 = 
bstring_to_symbol(BGl_string2049z00zz__evaluate_uncompz00), BUNSPEC) ;} 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__evaluate_uncompz00()
{
{ /* Eval/evaluate_uncomp.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* prof-init */
obj_t BGl_profzd2initzd2zz__evaluate_uncompz00()
{
{ /* Eval/evaluate_uncomp.scm 15 */
return 
write_bprof_table();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__evaluate_uncompz00()
{
{ /* Eval/evaluate_uncomp.scm 15 */
return BUNSPEC;} 

}



/* uncompile */
BGL_EXPORTED_DEF obj_t BGl_uncompilez00zz__evaluate_uncompz00(BgL_ev_exprz00_bglt BgL_ez00_3)
{
{ /* Eval/evaluate_uncomp.scm 62 */
return 
BGl_uncompz00zz__evaluate_uncompz00(BgL_ez00_3);} 

}



/* &uncompile */
obj_t BGl_z62uncompilez62zz__evaluate_uncompz00(obj_t BgL_envz00_2368, obj_t BgL_ez00_2369)
{
{ /* Eval/evaluate_uncomp.scm 62 */
{ /* Eval/evaluate_uncomp.scm 63 */
BgL_ev_exprz00_bglt BgL_auxz00_2742;
if(
BGl_isazf3zf3zz__objectz00(BgL_ez00_2369, BGl_ev_exprz00zz__evaluate_typesz00))
{ /* Eval/evaluate_uncomp.scm 63 */
BgL_auxz00_2742 = 
((BgL_ev_exprz00_bglt)BgL_ez00_2369)
; }  else 
{ 
obj_t BgL_auxz00_2746;
BgL_auxz00_2746 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1985z00zz__evaluate_uncompz00, 
BINT(((long)1816)), BGl_string1986z00zz__evaluate_uncompz00, BGl_string1987z00zz__evaluate_uncompz00, BgL_ez00_2369); 
FAILURE(BgL_auxz00_2746,BFALSE,BFALSE);} 
return 
BGl_uncompilez00zz__evaluate_uncompz00(BgL_auxz00_2742);} } 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__evaluate_uncompz00()
{
{ /* Eval/evaluate_uncomp.scm 15 */
return BUNSPEC;} 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__evaluate_uncompz00()
{
{ /* Eval/evaluate_uncomp.scm 15 */
return 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_uncompzd2envzd2zz__evaluate_uncompz00, BGl_proc1988z00zz__evaluate_uncompz00, BGl_ev_exprz00zz__evaluate_typesz00, BGl_string1989z00zz__evaluate_uncompz00);} 

}



/* &uncomp1198 */
obj_t BGl_z62uncomp1198z62zz__evaluate_uncompz00(obj_t BgL_envz00_2371, obj_t BgL_ez00_2372)
{
{ /* Eval/evaluate_uncomp.scm 65 */
return 
BGl_errorz00zz__errorz00(BGl_symbol1990z00zz__evaluate_uncompz00, BGl_string1991z00zz__evaluate_uncompz00, 
((obj_t)
((BgL_ev_exprz00_bglt)BgL_ez00_2372)));} 

}



/* uncomp */
obj_t BGl_uncompz00zz__evaluate_uncompz00(BgL_ev_exprz00_bglt BgL_ez00_4)
{
{ /* Eval/evaluate_uncomp.scm 65 */
{ /* Eval/evaluate_uncomp.scm 65 */
obj_t BgL_method1200z00_1100;
{ /* Eval/evaluate_uncomp.scm 65 */
obj_t BgL_res1858z00_1946;
{ /* Eval/evaluate_uncomp.scm 65 */
long BgL_objzd2classzd2numz00_1911;
{ /* Eval/evaluate_uncomp.scm 65 */
long BgL_res1848z00_1914;
BgL_res1848z00_1914 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_ez00_4)); 
BgL_objzd2classzd2numz00_1911 = BgL_res1848z00_1914; } 
{ /* Eval/evaluate_uncomp.scm 65 */
obj_t BgL_arg1840z00_1912;
BgL_arg1840z00_1912 = 
PROCEDURE_REF(BGl_uncompzd2envzd2zz__evaluate_uncompz00, 
(int)(((long)1))); 
{ /* Eval/evaluate_uncomp.scm 65 */
int BgL_offsetz00_1916;
BgL_offsetz00_1916 = 
(int)(BgL_objzd2classzd2numz00_1911); 
{ /* Eval/evaluate_uncomp.scm 65 */
long BgL_offsetz00_1917;
BgL_offsetz00_1917 = 
(
(long)(BgL_offsetz00_1916)-OBJECT_TYPE); 
{ /* Eval/evaluate_uncomp.scm 65 */
long BgL_modz00_1918;
BgL_modz00_1918 = 
(BgL_offsetz00_1917 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Eval/evaluate_uncomp.scm 65 */
long BgL_restz00_1920;
BgL_restz00_1920 = 
(BgL_offsetz00_1917 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Eval/evaluate_uncomp.scm 65 */

{ /* Eval/evaluate_uncomp.scm 65 */
obj_t BgL_bucketz00_1922;
BgL_bucketz00_1922 = 
VECTOR_REF(
((obj_t)BgL_arg1840z00_1912),BgL_modz00_1918); 
BgL_res1858z00_1946 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_1922),BgL_restz00_1920); } } } } } } } } 
BgL_method1200z00_1100 = BgL_res1858z00_1946; } 
return 
PROCEDURE_ENTRY(BgL_method1200z00_1100)(BgL_method1200z00_1100, 
((obj_t)BgL_ez00_4), BEOA);} } 

}



/* &uncomp */
obj_t BGl_z62uncompz62zz__evaluate_uncompz00(obj_t BgL_envz00_2373, obj_t BgL_ez00_2374)
{
{ /* Eval/evaluate_uncomp.scm 65 */
{ /* Eval/evaluate_uncomp.scm 65 */
BgL_ev_exprz00_bglt BgL_auxz00_2785;
if(
BGl_isazf3zf3zz__objectz00(BgL_ez00_2374, BGl_ev_exprz00zz__evaluate_typesz00))
{ /* Eval/evaluate_uncomp.scm 65 */
BgL_auxz00_2785 = 
((BgL_ev_exprz00_bglt)BgL_ez00_2374)
; }  else 
{ 
obj_t BgL_auxz00_2789;
BgL_auxz00_2789 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1985z00zz__evaluate_uncompz00, 
BINT(((long)1830)), BGl_string1992z00zz__evaluate_uncompz00, BGl_string1987z00zz__evaluate_uncompz00, BgL_ez00_2374); 
FAILURE(BgL_auxz00_2789,BFALSE,BFALSE);} 
return 
BGl_uncompz00zz__evaluate_uncompz00(BgL_auxz00_2785);} } 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__evaluate_uncompz00()
{
{ /* Eval/evaluate_uncomp.scm 15 */
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_uncompzd2envzd2zz__evaluate_uncompz00, BGl_ev_varz00zz__evaluate_typesz00, BGl_proc1993z00zz__evaluate_uncompz00, BGl_string1994z00zz__evaluate_uncompz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_uncompzd2envzd2zz__evaluate_uncompz00, BGl_ev_globalz00zz__evaluate_typesz00, BGl_proc1995z00zz__evaluate_uncompz00, BGl_string1994z00zz__evaluate_uncompz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_uncompzd2envzd2zz__evaluate_uncompz00, BGl_ev_littz00zz__evaluate_typesz00, BGl_proc1996z00zz__evaluate_uncompz00, BGl_string1994z00zz__evaluate_uncompz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_uncompzd2envzd2zz__evaluate_uncompz00, BGl_ev_ifz00zz__evaluate_typesz00, BGl_proc1997z00zz__evaluate_uncompz00, BGl_string1994z00zz__evaluate_uncompz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_uncompzd2envzd2zz__evaluate_uncompz00, BGl_ev_orz00zz__evaluate_typesz00, BGl_proc1998z00zz__evaluate_uncompz00, BGl_string1994z00zz__evaluate_uncompz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_uncompzd2envzd2zz__evaluate_uncompz00, BGl_ev_andz00zz__evaluate_typesz00, BGl_proc1999z00zz__evaluate_uncompz00, BGl_string1994z00zz__evaluate_uncompz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_uncompzd2envzd2zz__evaluate_uncompz00, BGl_ev_prog2z00zz__evaluate_typesz00, BGl_proc2000z00zz__evaluate_uncompz00, BGl_string1994z00zz__evaluate_uncompz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_uncompzd2envzd2zz__evaluate_uncompz00, BGl_ev_trapz00zz__evaluate_typesz00, BGl_proc2001z00zz__evaluate_uncompz00, BGl_string1994z00zz__evaluate_uncompz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_uncompzd2envzd2zz__evaluate_uncompz00, BGl_ev_setglobalz00zz__evaluate_typesz00, BGl_proc2002z00zz__evaluate_uncompz00, BGl_string1994z00zz__evaluate_uncompz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_uncompzd2envzd2zz__evaluate_uncompz00, BGl_ev_defglobalz00zz__evaluate_typesz00, BGl_proc2003z00zz__evaluate_uncompz00, BGl_string1994z00zz__evaluate_uncompz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_uncompzd2envzd2zz__evaluate_uncompz00, BGl_ev_setlocalz00zz__evaluate_typesz00, BGl_proc2004z00zz__evaluate_uncompz00, BGl_string1994z00zz__evaluate_uncompz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_uncompzd2envzd2zz__evaluate_uncompz00, BGl_ev_bindzd2exitzd2zz__evaluate_typesz00, BGl_proc2005z00zz__evaluate_uncompz00, BGl_string1994z00zz__evaluate_uncompz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_uncompzd2envzd2zz__evaluate_uncompz00, BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00, BGl_proc2006z00zz__evaluate_uncompz00, BGl_string1994z00zz__evaluate_uncompz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_uncompzd2envzd2zz__evaluate_uncompz00, BGl_ev_withzd2handlerzd2zz__evaluate_typesz00, BGl_proc2007z00zz__evaluate_uncompz00, BGl_string1994z00zz__evaluate_uncompz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_uncompzd2envzd2zz__evaluate_uncompz00, BGl_ev_synchroniza7eza7zz__evaluate_typesz00, BGl_proc2008z00zz__evaluate_uncompz00, BGl_string1994z00zz__evaluate_uncompz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_uncompzd2envzd2zz__evaluate_uncompz00, BGl_ev_letz00zz__evaluate_typesz00, BGl_proc2009z00zz__evaluate_uncompz00, BGl_string1994z00zz__evaluate_uncompz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_uncompzd2envzd2zz__evaluate_uncompz00, BGl_ev_letza2za2zz__evaluate_typesz00, BGl_proc2010z00zz__evaluate_uncompz00, BGl_string1994z00zz__evaluate_uncompz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_uncompzd2envzd2zz__evaluate_uncompz00, BGl_ev_letrecz00zz__evaluate_typesz00, BGl_proc2011z00zz__evaluate_uncompz00, BGl_string1994z00zz__evaluate_uncompz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_uncompzd2envzd2zz__evaluate_uncompz00, BGl_ev_labelsz00zz__evaluate_typesz00, BGl_proc2012z00zz__evaluate_uncompz00, BGl_string1994z00zz__evaluate_uncompz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_uncompzd2envzd2zz__evaluate_uncompz00, BGl_ev_gotoz00zz__evaluate_typesz00, BGl_proc2013z00zz__evaluate_uncompz00, BGl_string1994z00zz__evaluate_uncompz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_uncompzd2envzd2zz__evaluate_uncompz00, BGl_ev_appz00zz__evaluate_typesz00, BGl_proc2014z00zz__evaluate_uncompz00, BGl_string1994z00zz__evaluate_uncompz00); 
return 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_uncompzd2envzd2zz__evaluate_uncompz00, BGl_ev_absz00zz__evaluate_typesz00, BGl_proc2015z00zz__evaluate_uncompz00, BGl_string1994z00zz__evaluate_uncompz00);} 

}



/* &uncomp-ev_abs1244 */
obj_t BGl_z62uncompzd2ev_abs1244zb0zz__evaluate_uncompz00(obj_t BgL_envz00_2397, obj_t BgL_ez00_2398)
{
{ /* Eval/evaluate_uncomp.scm 157 */
{ /* Eval/evaluate_uncomp.scm 166 */
obj_t BgL_arg1522z00_2451;
{ /* Eval/evaluate_uncomp.scm 166 */
obj_t BgL_arg1523z00_2452;obj_t BgL_arg1524z00_2453;
{ /* Eval/evaluate_uncomp.scm 166 */
obj_t BgL_arg1525z00_2454;obj_t BgL_arg1526z00_2455;
BgL_arg1525z00_2454 = 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_ez00_2398)))->BgL_arityz00); 
{ /* Eval/evaluate_uncomp.scm 166 */
obj_t BgL_l1180z00_2456;
BgL_l1180z00_2456 = 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_ez00_2398)))->BgL_varsz00); 
if(
NULLP(BgL_l1180z00_2456))
{ /* Eval/evaluate_uncomp.scm 166 */
BgL_arg1526z00_2455 = BNIL; }  else 
{ /* Eval/evaluate_uncomp.scm 166 */
obj_t BgL_head1182z00_2457;
{ /* Eval/evaluate_uncomp.scm 166 */
obj_t BgL_res1899z00_2458;
BgL_res1899z00_2458 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1182z00_2457 = BgL_res1899z00_2458; } 
{ 
obj_t BgL_l1180z00_2460;obj_t BgL_tail1183z00_2461;
BgL_l1180z00_2460 = BgL_l1180z00_2456; 
BgL_tail1183z00_2461 = BgL_head1182z00_2457; 
BgL_zc3z04anonymousza31528ze3z87_2459:
if(
NULLP(BgL_l1180z00_2460))
{ /* Eval/evaluate_uncomp.scm 166 */
BgL_arg1526z00_2455 = 
CDR(BgL_head1182z00_2457); }  else 
{ /* Eval/evaluate_uncomp.scm 166 */
obj_t BgL_newtail1184z00_2462;
{ /* Eval/evaluate_uncomp.scm 166 */
obj_t BgL_arg1534z00_2463;
BgL_arg1534z00_2463 = 
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)
CAR(
((obj_t)BgL_l1180z00_2460)))))->BgL_namez00); 
{ /* Eval/evaluate_uncomp.scm 166 */
obj_t BgL_res1901z00_2464;
BgL_res1901z00_2464 = 
MAKE_YOUNG_PAIR(BgL_arg1534z00_2463, BNIL); 
BgL_newtail1184z00_2462 = BgL_res1901z00_2464; } } 
SET_CDR(BgL_tail1183z00_2461, BgL_newtail1184z00_2462); 
{ /* Eval/evaluate_uncomp.scm 166 */
obj_t BgL_arg1532z00_2465;
BgL_arg1532z00_2465 = 
CDR(
((obj_t)BgL_l1180z00_2460)); 
{ 
obj_t BgL_tail1183z00_2835;obj_t BgL_l1180z00_2834;
BgL_l1180z00_2834 = BgL_arg1532z00_2465; 
BgL_tail1183z00_2835 = BgL_newtail1184z00_2462; 
BgL_tail1183z00_2461 = BgL_tail1183z00_2835; 
BgL_l1180z00_2460 = BgL_l1180z00_2834; 
goto BgL_zc3z04anonymousza31528ze3z87_2459;} } } } } } 
BgL_arg1523z00_2452 = 
BGl_redovarsze70ze7zz__evaluate_uncompz00(BgL_arg1525z00_2454, BgL_arg1526z00_2455); } 
BgL_arg1524z00_2453 = 
MAKE_YOUNG_PAIR(
BGl_uncompz00zz__evaluate_uncompz00(
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_ez00_2398)))->BgL_bodyz00)), BNIL); 
BgL_arg1522z00_2451 = 
MAKE_YOUNG_PAIR(BgL_arg1523z00_2452, BgL_arg1524z00_2453); } 
return 
MAKE_YOUNG_PAIR(BGl_symbol2016z00zz__evaluate_uncompz00, BgL_arg1522z00_2451);} } 

}



/* rec~0 */
obj_t BGl_recze70ze7zz__evaluate_uncompz00(obj_t BgL_lz00_1507)
{
{ /* Eval/evaluate_uncomp.scm 162 */
if(
NULLP(
CDR(
((obj_t)BgL_lz00_1507))))
{ /* Eval/evaluate_uncomp.scm 163 */
return 
CAR(
((obj_t)BgL_lz00_1507));}  else 
{ /* Eval/evaluate_uncomp.scm 165 */
obj_t BgL_arg1544z00_1511;obj_t BgL_arg1545z00_1512;
BgL_arg1544z00_1511 = 
CAR(
((obj_t)BgL_lz00_1507)); 
{ /* Eval/evaluate_uncomp.scm 165 */
obj_t BgL_arg1546z00_1513;
BgL_arg1546z00_1513 = 
CDR(
((obj_t)BgL_lz00_1507)); 
BgL_arg1545z00_1512 = 
BGl_recze70ze7zz__evaluate_uncompz00(BgL_arg1546z00_1513); } 
return 
MAKE_YOUNG_PAIR(BgL_arg1544z00_1511, BgL_arg1545z00_1512);} } 

}



/* redovars~0 */
obj_t BGl_redovarsze70ze7zz__evaluate_uncompz00(obj_t BgL_nz00_1502, obj_t BgL_lz00_1503)
{
{ /* Eval/evaluate_uncomp.scm 165 */
if(
(
(long)CINT(BgL_nz00_1502)>=((long)0)))
{ /* Eval/evaluate_uncomp.scm 160 */
return BgL_lz00_1503;}  else 
{ /* Eval/evaluate_uncomp.scm 160 */
return 
BGl_recze70ze7zz__evaluate_uncompz00(BgL_lz00_1503);} } 

}



/* &uncomp-ev_app1242 */
obj_t BGl_z62uncompzd2ev_app1242zb0zz__evaluate_uncompz00(obj_t BgL_envz00_2399, obj_t BgL_ez00_2400)
{
{ /* Eval/evaluate_uncomp.scm 153 */
{ /* Eval/evaluate_uncomp.scm 155 */
obj_t BgL_arg1508z00_2467;obj_t BgL_arg1509z00_2468;
BgL_arg1508z00_2467 = 
BGl_uncompz00zz__evaluate_uncompz00(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_2400)))->BgL_funz00)); 
{ /* Eval/evaluate_uncomp.scm 155 */
obj_t BgL_arg1513z00_2469;
{ /* Eval/evaluate_uncomp.scm 155 */
obj_t BgL_l1174z00_2470;
BgL_l1174z00_2470 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_2400)))->BgL_argsz00); 
if(
NULLP(BgL_l1174z00_2470))
{ /* Eval/evaluate_uncomp.scm 155 */
BgL_arg1513z00_2469 = BNIL; }  else 
{ /* Eval/evaluate_uncomp.scm 155 */
obj_t BgL_head1176z00_2471;
{ /* Eval/evaluate_uncomp.scm 155 */
obj_t BgL_arg1520z00_2472;
{ /* Eval/evaluate_uncomp.scm 155 */
obj_t BgL_arg1521z00_2473;
BgL_arg1521z00_2473 = 
CAR(
((obj_t)BgL_l1174z00_2470)); 
BgL_arg1520z00_2472 = 
BGl_uncompz00zz__evaluate_uncompz00(
((BgL_ev_exprz00_bglt)BgL_arg1521z00_2473)); } 
{ /* Eval/evaluate_uncomp.scm 155 */
obj_t BgL_res1893z00_2474;
BgL_res1893z00_2474 = 
MAKE_YOUNG_PAIR(BgL_arg1520z00_2472, BNIL); 
BgL_head1176z00_2471 = BgL_res1893z00_2474; } } 
{ /* Eval/evaluate_uncomp.scm 155 */
obj_t BgL_g1179z00_2475;
BgL_g1179z00_2475 = 
CDR(
((obj_t)BgL_l1174z00_2470)); 
{ 
obj_t BgL_l1174z00_2477;obj_t BgL_tail1177z00_2478;
BgL_l1174z00_2477 = BgL_g1179z00_2475; 
BgL_tail1177z00_2478 = BgL_head1176z00_2471; 
BgL_zc3z04anonymousza31515ze3z87_2476:
if(
NULLP(BgL_l1174z00_2477))
{ /* Eval/evaluate_uncomp.scm 155 */
BgL_arg1513z00_2469 = BgL_head1176z00_2471; }  else 
{ /* Eval/evaluate_uncomp.scm 155 */
obj_t BgL_newtail1178z00_2479;
{ /* Eval/evaluate_uncomp.scm 155 */
obj_t BgL_arg1518z00_2480;
{ /* Eval/evaluate_uncomp.scm 155 */
obj_t BgL_arg1519z00_2481;
BgL_arg1519z00_2481 = 
CAR(
((obj_t)BgL_l1174z00_2477)); 
BgL_arg1518z00_2480 = 
BGl_uncompz00zz__evaluate_uncompz00(
((BgL_ev_exprz00_bglt)BgL_arg1519z00_2481)); } 
{ /* Eval/evaluate_uncomp.scm 155 */
obj_t BgL_res1895z00_2482;
BgL_res1895z00_2482 = 
MAKE_YOUNG_PAIR(BgL_arg1518z00_2480, BNIL); 
BgL_newtail1178z00_2479 = BgL_res1895z00_2482; } } 
SET_CDR(BgL_tail1177z00_2478, BgL_newtail1178z00_2479); 
{ /* Eval/evaluate_uncomp.scm 155 */
obj_t BgL_arg1517z00_2483;
BgL_arg1517z00_2483 = 
CDR(
((obj_t)BgL_l1174z00_2477)); 
{ 
obj_t BgL_tail1177z00_2884;obj_t BgL_l1174z00_2883;
BgL_l1174z00_2883 = BgL_arg1517z00_2483; 
BgL_tail1177z00_2884 = BgL_newtail1178z00_2479; 
BgL_tail1177z00_2478 = BgL_tail1177z00_2884; 
BgL_l1174z00_2477 = BgL_l1174z00_2883; 
goto BgL_zc3z04anonymousza31515ze3z87_2476;} } } } } } } 
BgL_arg1509z00_2468 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_arg1513z00_2469, BNIL); } 
return 
MAKE_YOUNG_PAIR(BgL_arg1508z00_2467, BgL_arg1509z00_2468);} } 

}



/* &uncomp-ev_goto1240 */
obj_t BGl_z62uncompzd2ev_goto1240zb0zz__evaluate_uncompz00(obj_t BgL_envz00_2401, obj_t BgL_ez00_2402)
{
{ /* Eval/evaluate_uncomp.scm 149 */
{ /* Eval/evaluate_uncomp.scm 151 */
obj_t BgL_arg1496z00_2485;obj_t BgL_arg1497z00_2486;
{ /* Eval/evaluate_uncomp.scm 151 */
BgL_ev_varz00_bglt BgL_arg1498z00_2487;
BgL_arg1498z00_2487 = 
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_ez00_2402)))->BgL_labelz00); 
BgL_arg1496z00_2485 = 
BGl_uncompz00zz__evaluate_uncompz00(
((BgL_ev_exprz00_bglt)BgL_arg1498z00_2487)); } 
{ /* Eval/evaluate_uncomp.scm 151 */
obj_t BgL_arg1499z00_2488;
{ /* Eval/evaluate_uncomp.scm 151 */
obj_t BgL_l1168z00_2489;
BgL_l1168z00_2489 = 
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_ez00_2402)))->BgL_argsz00); 
if(
NULLP(BgL_l1168z00_2489))
{ /* Eval/evaluate_uncomp.scm 151 */
BgL_arg1499z00_2488 = BNIL; }  else 
{ /* Eval/evaluate_uncomp.scm 151 */
obj_t BgL_head1170z00_2490;
{ /* Eval/evaluate_uncomp.scm 151 */
obj_t BgL_arg1506z00_2491;
{ /* Eval/evaluate_uncomp.scm 151 */
obj_t BgL_arg1507z00_2492;
BgL_arg1507z00_2492 = 
CAR(
((obj_t)BgL_l1168z00_2489)); 
BgL_arg1506z00_2491 = 
BGl_uncompz00zz__evaluate_uncompz00(
((BgL_ev_exprz00_bglt)BgL_arg1507z00_2492)); } 
{ /* Eval/evaluate_uncomp.scm 151 */
obj_t BgL_res1889z00_2493;
BgL_res1889z00_2493 = 
MAKE_YOUNG_PAIR(BgL_arg1506z00_2491, BNIL); 
BgL_head1170z00_2490 = BgL_res1889z00_2493; } } 
{ /* Eval/evaluate_uncomp.scm 151 */
obj_t BgL_g1173z00_2494;
BgL_g1173z00_2494 = 
CDR(
((obj_t)BgL_l1168z00_2489)); 
{ 
obj_t BgL_l1168z00_2496;obj_t BgL_tail1171z00_2497;
BgL_l1168z00_2496 = BgL_g1173z00_2494; 
BgL_tail1171z00_2497 = BgL_head1170z00_2490; 
BgL_zc3z04anonymousza31501ze3z87_2495:
if(
NULLP(BgL_l1168z00_2496))
{ /* Eval/evaluate_uncomp.scm 151 */
BgL_arg1499z00_2488 = BgL_head1170z00_2490; }  else 
{ /* Eval/evaluate_uncomp.scm 151 */
obj_t BgL_newtail1172z00_2498;
{ /* Eval/evaluate_uncomp.scm 151 */
obj_t BgL_arg1504z00_2499;
{ /* Eval/evaluate_uncomp.scm 151 */
obj_t BgL_arg1505z00_2500;
BgL_arg1505z00_2500 = 
CAR(
((obj_t)BgL_l1168z00_2496)); 
BgL_arg1504z00_2499 = 
BGl_uncompz00zz__evaluate_uncompz00(
((BgL_ev_exprz00_bglt)BgL_arg1505z00_2500)); } 
{ /* Eval/evaluate_uncomp.scm 151 */
obj_t BgL_res1891z00_2501;
BgL_res1891z00_2501 = 
MAKE_YOUNG_PAIR(BgL_arg1504z00_2499, BNIL); 
BgL_newtail1172z00_2498 = BgL_res1891z00_2501; } } 
SET_CDR(BgL_tail1171z00_2497, BgL_newtail1172z00_2498); 
{ /* Eval/evaluate_uncomp.scm 151 */
obj_t BgL_arg1503z00_2502;
BgL_arg1503z00_2502 = 
CDR(
((obj_t)BgL_l1168z00_2496)); 
{ 
obj_t BgL_tail1171z00_2913;obj_t BgL_l1168z00_2912;
BgL_l1168z00_2912 = BgL_arg1503z00_2502; 
BgL_tail1171z00_2913 = BgL_newtail1172z00_2498; 
BgL_tail1171z00_2497 = BgL_tail1171z00_2913; 
BgL_l1168z00_2496 = BgL_l1168z00_2912; 
goto BgL_zc3z04anonymousza31501ze3z87_2495;} } } } } } } 
BgL_arg1497z00_2486 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_arg1499z00_2488, BNIL); } 
return 
MAKE_YOUNG_PAIR(BgL_arg1496z00_2485, BgL_arg1497z00_2486);} } 

}



/* &uncomp-ev_labels1238 */
obj_t BGl_z62uncompzd2ev_labels1238zb0zz__evaluate_uncompz00(obj_t BgL_envz00_2403, obj_t BgL_ez00_2404)
{
{ /* Eval/evaluate_uncomp.scm 142 */
{ /* Eval/evaluate_uncomp.scm 144 */
obj_t BgL_arg1466z00_2504;
{ /* Eval/evaluate_uncomp.scm 144 */
obj_t BgL_arg1467z00_2505;obj_t BgL_arg1469z00_2506;
{ /* Eval/evaluate_uncomp.scm 144 */
obj_t BgL_ll1162z00_2507;obj_t BgL_ll1163z00_2508;
BgL_ll1162z00_2507 = 
(((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_ez00_2404)))->BgL_varsz00); 
BgL_ll1163z00_2508 = 
(((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_ez00_2404)))->BgL_valsz00); 
if(
NULLP(BgL_ll1162z00_2507))
{ /* Eval/evaluate_uncomp.scm 144 */
BgL_arg1467z00_2505 = BNIL; }  else 
{ /* Eval/evaluate_uncomp.scm 144 */
obj_t BgL_head1164z00_2509;
{ /* Eval/evaluate_uncomp.scm 144 */
obj_t BgL_res1881z00_2510;
BgL_res1881z00_2510 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1164z00_2509 = BgL_res1881z00_2510; } 
{ 
obj_t BgL_ll1162z00_2512;obj_t BgL_ll1163z00_2513;obj_t BgL_tail1165z00_2514;
BgL_ll1162z00_2512 = BgL_ll1162z00_2507; 
BgL_ll1163z00_2513 = BgL_ll1163z00_2508; 
BgL_tail1165z00_2514 = BgL_head1164z00_2509; 
BgL_zc3z04anonymousza31471ze3z87_2511:
if(
NULLP(BgL_ll1162z00_2512))
{ /* Eval/evaluate_uncomp.scm 144 */
BgL_arg1467z00_2505 = 
CDR(BgL_head1164z00_2509); }  else 
{ /* Eval/evaluate_uncomp.scm 144 */
obj_t BgL_newtail1166z00_2515;
{ /* Eval/evaluate_uncomp.scm 144 */
obj_t BgL_arg1475z00_2516;
{ /* Eval/evaluate_uncomp.scm 144 */
obj_t BgL_vz00_2517;obj_t BgL_az00_2518;
BgL_vz00_2517 = 
CAR(
((obj_t)BgL_ll1162z00_2512)); 
BgL_az00_2518 = 
CAR(
((obj_t)BgL_ll1163z00_2513)); 
{ /* Eval/evaluate_uncomp.scm 144 */
obj_t BgL_arg1476z00_2519;obj_t BgL_arg1477z00_2520;
BgL_arg1476z00_2519 = 
BGl_uncompz00zz__evaluate_uncompz00(
((BgL_ev_exprz00_bglt)BgL_vz00_2517)); 
{ /* Eval/evaluate_uncomp.scm 144 */
obj_t BgL_arg1478z00_2521;
{ /* Eval/evaluate_uncomp.scm 144 */
obj_t BgL_arg1479z00_2522;
{ /* Eval/evaluate_uncomp.scm 144 */
obj_t BgL_arg1480z00_2523;obj_t BgL_arg1481z00_2524;
{ /* Eval/evaluate_uncomp.scm 144 */
obj_t BgL_l1156z00_2525;
BgL_l1156z00_2525 = 
CAR(
((obj_t)BgL_az00_2518)); 
if(
NULLP(BgL_l1156z00_2525))
{ /* Eval/evaluate_uncomp.scm 144 */
BgL_arg1480z00_2523 = BNIL; }  else 
{ /* Eval/evaluate_uncomp.scm 144 */
obj_t BgL_head1158z00_2526;
{ /* Eval/evaluate_uncomp.scm 144 */
obj_t BgL_arg1490z00_2527;
{ /* Eval/evaluate_uncomp.scm 144 */
obj_t BgL_arg1491z00_2528;
BgL_arg1491z00_2528 = 
CAR(
((obj_t)BgL_l1156z00_2525)); 
BgL_arg1490z00_2527 = 
BGl_uncompz00zz__evaluate_uncompz00(
((BgL_ev_exprz00_bglt)BgL_arg1491z00_2528)); } 
{ /* Eval/evaluate_uncomp.scm 144 */
obj_t BgL_res1884z00_2529;
BgL_res1884z00_2529 = 
MAKE_YOUNG_PAIR(BgL_arg1490z00_2527, BNIL); 
BgL_head1158z00_2526 = BgL_res1884z00_2529; } } 
{ /* Eval/evaluate_uncomp.scm 144 */
obj_t BgL_g1161z00_2530;
BgL_g1161z00_2530 = 
CDR(
((obj_t)BgL_l1156z00_2525)); 
{ 
obj_t BgL_l1156z00_2532;obj_t BgL_tail1159z00_2533;
BgL_l1156z00_2532 = BgL_g1161z00_2530; 
BgL_tail1159z00_2533 = BgL_head1158z00_2526; 
BgL_zc3z04anonymousza31483ze3z87_2531:
if(
NULLP(BgL_l1156z00_2532))
{ /* Eval/evaluate_uncomp.scm 144 */
BgL_arg1480z00_2523 = BgL_head1158z00_2526; }  else 
{ /* Eval/evaluate_uncomp.scm 144 */
obj_t BgL_newtail1160z00_2534;
{ /* Eval/evaluate_uncomp.scm 144 */
obj_t BgL_arg1488z00_2535;
{ /* Eval/evaluate_uncomp.scm 144 */
obj_t BgL_arg1489z00_2536;
BgL_arg1489z00_2536 = 
CAR(
((obj_t)BgL_l1156z00_2532)); 
BgL_arg1488z00_2535 = 
BGl_uncompz00zz__evaluate_uncompz00(
((BgL_ev_exprz00_bglt)BgL_arg1489z00_2536)); } 
{ /* Eval/evaluate_uncomp.scm 144 */
obj_t BgL_res1886z00_2537;
BgL_res1886z00_2537 = 
MAKE_YOUNG_PAIR(BgL_arg1488z00_2535, BNIL); 
BgL_newtail1160z00_2534 = BgL_res1886z00_2537; } } 
SET_CDR(BgL_tail1159z00_2533, BgL_newtail1160z00_2534); 
{ /* Eval/evaluate_uncomp.scm 144 */
obj_t BgL_arg1486z00_2538;
BgL_arg1486z00_2538 = 
CDR(
((obj_t)BgL_l1156z00_2532)); 
{ 
obj_t BgL_tail1159z00_2954;obj_t BgL_l1156z00_2953;
BgL_l1156z00_2953 = BgL_arg1486z00_2538; 
BgL_tail1159z00_2954 = BgL_newtail1160z00_2534; 
BgL_tail1159z00_2533 = BgL_tail1159z00_2954; 
BgL_l1156z00_2532 = BgL_l1156z00_2953; 
goto BgL_zc3z04anonymousza31483ze3z87_2531;} } } } } } } 
{ /* Eval/evaluate_uncomp.scm 145 */
obj_t BgL_arg1492z00_2539;
{ /* Eval/evaluate_uncomp.scm 145 */
obj_t BgL_arg1493z00_2540;
BgL_arg1493z00_2540 = 
CDR(
((obj_t)BgL_az00_2518)); 
BgL_arg1492z00_2539 = 
BGl_uncompz00zz__evaluate_uncompz00(
((BgL_ev_exprz00_bglt)BgL_arg1493z00_2540)); } 
BgL_arg1481z00_2524 = 
MAKE_YOUNG_PAIR(BgL_arg1492z00_2539, BNIL); } 
BgL_arg1479z00_2522 = 
MAKE_YOUNG_PAIR(BgL_arg1480z00_2523, BgL_arg1481z00_2524); } 
BgL_arg1478z00_2521 = 
MAKE_YOUNG_PAIR(BGl_symbol2016z00zz__evaluate_uncompz00, BgL_arg1479z00_2522); } 
BgL_arg1477z00_2520 = 
MAKE_YOUNG_PAIR(BgL_arg1478z00_2521, BNIL); } 
BgL_arg1475z00_2516 = 
MAKE_YOUNG_PAIR(BgL_arg1476z00_2519, BgL_arg1477z00_2520); } } 
{ /* Eval/evaluate_uncomp.scm 144 */
obj_t BgL_res1887z00_2541;
BgL_res1887z00_2541 = 
MAKE_YOUNG_PAIR(BgL_arg1475z00_2516, BNIL); 
BgL_newtail1166z00_2515 = BgL_res1887z00_2541; } } 
SET_CDR(BgL_tail1165z00_2514, BgL_newtail1166z00_2515); 
{ /* Eval/evaluate_uncomp.scm 144 */
obj_t BgL_arg1473z00_2542;obj_t BgL_arg1474z00_2543;
BgL_arg1473z00_2542 = 
CDR(
((obj_t)BgL_ll1162z00_2512)); 
BgL_arg1474z00_2543 = 
CDR(
((obj_t)BgL_ll1163z00_2513)); 
{ 
obj_t BgL_tail1165z00_2972;obj_t BgL_ll1163z00_2971;obj_t BgL_ll1162z00_2970;
BgL_ll1162z00_2970 = BgL_arg1473z00_2542; 
BgL_ll1163z00_2971 = BgL_arg1474z00_2543; 
BgL_tail1165z00_2972 = BgL_newtail1166z00_2515; 
BgL_tail1165z00_2514 = BgL_tail1165z00_2972; 
BgL_ll1163z00_2513 = BgL_ll1163z00_2971; 
BgL_ll1162z00_2512 = BgL_ll1162z00_2970; 
goto BgL_zc3z04anonymousza31471ze3z87_2511;} } } } } } 
BgL_arg1469z00_2506 = 
MAKE_YOUNG_PAIR(
BGl_uncompz00zz__evaluate_uncompz00(
(((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_ez00_2404)))->BgL_bodyz00)), BNIL); 
BgL_arg1466z00_2504 = 
MAKE_YOUNG_PAIR(BgL_arg1467z00_2505, BgL_arg1469z00_2506); } 
return 
MAKE_YOUNG_PAIR(BGl_symbol2018z00zz__evaluate_uncompz00, BgL_arg1466z00_2504);} } 

}



/* &uncomp-ev_letrec1236 */
obj_t BGl_z62uncompzd2ev_letrec1236zb0zz__evaluate_uncompz00(obj_t BgL_envz00_2405, obj_t BgL_ez00_2406)
{
{ /* Eval/evaluate_uncomp.scm 138 */
{ /* Eval/evaluate_uncomp.scm 140 */
obj_t BgL_arg1451z00_2545;
{ /* Eval/evaluate_uncomp.scm 140 */
obj_t BgL_arg1452z00_2546;obj_t BgL_arg1453z00_2547;
{ /* Eval/evaluate_uncomp.scm 140 */
obj_t BgL_ll1150z00_2548;obj_t BgL_ll1151z00_2549;
BgL_ll1150z00_2548 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letrecz00_bglt)BgL_ez00_2406))))->BgL_varsz00); 
BgL_ll1151z00_2549 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letrecz00_bglt)BgL_ez00_2406))))->BgL_valsz00); 
if(
NULLP(BgL_ll1150z00_2548))
{ /* Eval/evaluate_uncomp.scm 140 */
BgL_arg1452z00_2546 = BNIL; }  else 
{ /* Eval/evaluate_uncomp.scm 140 */
obj_t BgL_head1152z00_2550;
{ /* Eval/evaluate_uncomp.scm 140 */
obj_t BgL_res1877z00_2551;
BgL_res1877z00_2551 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1152z00_2550 = BgL_res1877z00_2551; } 
{ 
obj_t BgL_ll1150z00_2553;obj_t BgL_ll1151z00_2554;obj_t BgL_tail1153z00_2555;
BgL_ll1150z00_2553 = BgL_ll1150z00_2548; 
BgL_ll1151z00_2554 = BgL_ll1151z00_2549; 
BgL_tail1153z00_2555 = BgL_head1152z00_2550; 
BgL_zc3z04anonymousza31455ze3z87_2552:
if(
NULLP(BgL_ll1150z00_2553))
{ /* Eval/evaluate_uncomp.scm 140 */
BgL_arg1452z00_2546 = 
CDR(BgL_head1152z00_2550); }  else 
{ /* Eval/evaluate_uncomp.scm 140 */
obj_t BgL_newtail1154z00_2556;
{ /* Eval/evaluate_uncomp.scm 140 */
obj_t BgL_arg1459z00_2557;
{ /* Eval/evaluate_uncomp.scm 140 */
obj_t BgL_vz00_2558;obj_t BgL_az00_2559;
BgL_vz00_2558 = 
CAR(
((obj_t)BgL_ll1150z00_2553)); 
BgL_az00_2559 = 
CAR(
((obj_t)BgL_ll1151z00_2554)); 
{ /* Eval/evaluate_uncomp.scm 140 */
obj_t BgL_arg1460z00_2560;obj_t BgL_arg1461z00_2561;
BgL_arg1460z00_2560 = 
BGl_uncompz00zz__evaluate_uncompz00(
((BgL_ev_exprz00_bglt)BgL_vz00_2558)); 
{ /* Eval/evaluate_uncomp.scm 140 */
obj_t BgL_arg1462z00_2562;
BgL_arg1462z00_2562 = 
BGl_uncompz00zz__evaluate_uncompz00(
((BgL_ev_exprz00_bglt)BgL_az00_2559)); 
BgL_arg1461z00_2561 = 
MAKE_YOUNG_PAIR(BgL_arg1462z00_2562, BNIL); } 
BgL_arg1459z00_2557 = 
MAKE_YOUNG_PAIR(BgL_arg1460z00_2560, BgL_arg1461z00_2561); } } 
{ /* Eval/evaluate_uncomp.scm 140 */
obj_t BgL_res1879z00_2563;
BgL_res1879z00_2563 = 
MAKE_YOUNG_PAIR(BgL_arg1459z00_2557, BNIL); 
BgL_newtail1154z00_2556 = BgL_res1879z00_2563; } } 
SET_CDR(BgL_tail1153z00_2555, BgL_newtail1154z00_2556); 
{ /* Eval/evaluate_uncomp.scm 140 */
obj_t BgL_arg1457z00_2564;obj_t BgL_arg1458z00_2565;
BgL_arg1457z00_2564 = 
CDR(
((obj_t)BgL_ll1150z00_2553)); 
BgL_arg1458z00_2565 = 
CDR(
((obj_t)BgL_ll1151z00_2554)); 
{ 
obj_t BgL_tail1153z00_3009;obj_t BgL_ll1151z00_3008;obj_t BgL_ll1150z00_3007;
BgL_ll1150z00_3007 = BgL_arg1457z00_2564; 
BgL_ll1151z00_3008 = BgL_arg1458z00_2565; 
BgL_tail1153z00_3009 = BgL_newtail1154z00_2556; 
BgL_tail1153z00_2555 = BgL_tail1153z00_3009; 
BgL_ll1151z00_2554 = BgL_ll1151z00_3008; 
BgL_ll1150z00_2553 = BgL_ll1150z00_3007; 
goto BgL_zc3z04anonymousza31455ze3z87_2552;} } } } } } 
{ /* Eval/evaluate_uncomp.scm 140 */
obj_t BgL_arg1463z00_2566;
{ /* Eval/evaluate_uncomp.scm 140 */
BgL_ev_exprz00_bglt BgL_arg1465z00_2567;
BgL_arg1465z00_2567 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letrecz00_bglt)BgL_ez00_2406))))->BgL_bodyz00); 
BgL_arg1463z00_2566 = 
BGl_uncompz00zz__evaluate_uncompz00(BgL_arg1465z00_2567); } 
BgL_arg1453z00_2547 = 
MAKE_YOUNG_PAIR(BgL_arg1463z00_2566, BNIL); } 
BgL_arg1451z00_2545 = 
MAKE_YOUNG_PAIR(BgL_arg1452z00_2546, BgL_arg1453z00_2547); } 
return 
MAKE_YOUNG_PAIR(BGl_symbol2018z00zz__evaluate_uncompz00, BgL_arg1451z00_2545);} } 

}



/* &uncomp-ev_let*1234 */
obj_t BGl_z62uncompzd2ev_letza21234z12zz__evaluate_uncompz00(obj_t BgL_envz00_2407, obj_t BgL_ez00_2408)
{
{ /* Eval/evaluate_uncomp.scm 134 */
{ /* Eval/evaluate_uncomp.scm 136 */
obj_t BgL_arg1437z00_2569;
{ /* Eval/evaluate_uncomp.scm 136 */
obj_t BgL_arg1438z00_2570;obj_t BgL_arg1439z00_2571;
{ /* Eval/evaluate_uncomp.scm 136 */
obj_t BgL_ll1144z00_2572;obj_t BgL_ll1145z00_2573;
BgL_ll1144z00_2572 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letza2za2_bglt)BgL_ez00_2408))))->BgL_varsz00); 
BgL_ll1145z00_2573 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letza2za2_bglt)BgL_ez00_2408))))->BgL_valsz00); 
if(
NULLP(BgL_ll1144z00_2572))
{ /* Eval/evaluate_uncomp.scm 136 */
BgL_arg1438z00_2570 = BNIL; }  else 
{ /* Eval/evaluate_uncomp.scm 136 */
obj_t BgL_head1146z00_2574;
{ /* Eval/evaluate_uncomp.scm 136 */
obj_t BgL_res1873z00_2575;
BgL_res1873z00_2575 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1146z00_2574 = BgL_res1873z00_2575; } 
{ 
obj_t BgL_ll1144z00_2577;obj_t BgL_ll1145z00_2578;obj_t BgL_tail1147z00_2579;
BgL_ll1144z00_2577 = BgL_ll1144z00_2572; 
BgL_ll1145z00_2578 = BgL_ll1145z00_2573; 
BgL_tail1147z00_2579 = BgL_head1146z00_2574; 
BgL_zc3z04anonymousza31441ze3z87_2576:
if(
NULLP(BgL_ll1144z00_2577))
{ /* Eval/evaluate_uncomp.scm 136 */
BgL_arg1438z00_2570 = 
CDR(BgL_head1146z00_2574); }  else 
{ /* Eval/evaluate_uncomp.scm 136 */
obj_t BgL_newtail1148z00_2580;
{ /* Eval/evaluate_uncomp.scm 136 */
obj_t BgL_arg1445z00_2581;
{ /* Eval/evaluate_uncomp.scm 136 */
obj_t BgL_vz00_2582;obj_t BgL_az00_2583;
BgL_vz00_2582 = 
CAR(
((obj_t)BgL_ll1144z00_2577)); 
BgL_az00_2583 = 
CAR(
((obj_t)BgL_ll1145z00_2578)); 
{ /* Eval/evaluate_uncomp.scm 136 */
obj_t BgL_arg1446z00_2584;obj_t BgL_arg1447z00_2585;
BgL_arg1446z00_2584 = 
BGl_uncompz00zz__evaluate_uncompz00(
((BgL_ev_exprz00_bglt)BgL_vz00_2582)); 
{ /* Eval/evaluate_uncomp.scm 136 */
obj_t BgL_arg1448z00_2586;
BgL_arg1448z00_2586 = 
BGl_uncompz00zz__evaluate_uncompz00(
((BgL_ev_exprz00_bglt)BgL_az00_2583)); 
BgL_arg1447z00_2585 = 
MAKE_YOUNG_PAIR(BgL_arg1448z00_2586, BNIL); } 
BgL_arg1445z00_2581 = 
MAKE_YOUNG_PAIR(BgL_arg1446z00_2584, BgL_arg1447z00_2585); } } 
{ /* Eval/evaluate_uncomp.scm 136 */
obj_t BgL_res1875z00_2587;
BgL_res1875z00_2587 = 
MAKE_YOUNG_PAIR(BgL_arg1445z00_2581, BNIL); 
BgL_newtail1148z00_2580 = BgL_res1875z00_2587; } } 
SET_CDR(BgL_tail1147z00_2579, BgL_newtail1148z00_2580); 
{ /* Eval/evaluate_uncomp.scm 136 */
obj_t BgL_arg1443z00_2588;obj_t BgL_arg1444z00_2589;
BgL_arg1443z00_2588 = 
CDR(
((obj_t)BgL_ll1144z00_2577)); 
BgL_arg1444z00_2589 = 
CDR(
((obj_t)BgL_ll1145z00_2578)); 
{ 
obj_t BgL_tail1147z00_3047;obj_t BgL_ll1145z00_3046;obj_t BgL_ll1144z00_3045;
BgL_ll1144z00_3045 = BgL_arg1443z00_2588; 
BgL_ll1145z00_3046 = BgL_arg1444z00_2589; 
BgL_tail1147z00_3047 = BgL_newtail1148z00_2580; 
BgL_tail1147z00_2579 = BgL_tail1147z00_3047; 
BgL_ll1145z00_2578 = BgL_ll1145z00_3046; 
BgL_ll1144z00_2577 = BgL_ll1144z00_3045; 
goto BgL_zc3z04anonymousza31441ze3z87_2576;} } } } } } 
{ /* Eval/evaluate_uncomp.scm 136 */
obj_t BgL_arg1449z00_2590;
{ /* Eval/evaluate_uncomp.scm 136 */
BgL_ev_exprz00_bglt BgL_arg1450z00_2591;
BgL_arg1450z00_2591 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letza2za2_bglt)BgL_ez00_2408))))->BgL_bodyz00); 
BgL_arg1449z00_2590 = 
BGl_uncompz00zz__evaluate_uncompz00(BgL_arg1450z00_2591); } 
BgL_arg1439z00_2571 = 
MAKE_YOUNG_PAIR(BgL_arg1449z00_2590, BNIL); } 
BgL_arg1437z00_2569 = 
MAKE_YOUNG_PAIR(BgL_arg1438z00_2570, BgL_arg1439z00_2571); } 
return 
MAKE_YOUNG_PAIR(BGl_symbol2020z00zz__evaluate_uncompz00, BgL_arg1437z00_2569);} } 

}



/* &uncomp-ev_let1232 */
obj_t BGl_z62uncompzd2ev_let1232zb0zz__evaluate_uncompz00(obj_t BgL_envz00_2409, obj_t BgL_ez00_2410)
{
{ /* Eval/evaluate_uncomp.scm 130 */
{ /* Eval/evaluate_uncomp.scm 132 */
obj_t BgL_arg1423z00_2593;
{ /* Eval/evaluate_uncomp.scm 132 */
obj_t BgL_arg1424z00_2594;obj_t BgL_arg1425z00_2595;
{ /* Eval/evaluate_uncomp.scm 132 */
obj_t BgL_ll1138z00_2596;obj_t BgL_ll1139z00_2597;
BgL_ll1138z00_2596 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letz00_bglt)BgL_ez00_2410))))->BgL_varsz00); 
BgL_ll1139z00_2597 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letz00_bglt)BgL_ez00_2410))))->BgL_valsz00); 
if(
NULLP(BgL_ll1138z00_2596))
{ /* Eval/evaluate_uncomp.scm 132 */
BgL_arg1424z00_2594 = BNIL; }  else 
{ /* Eval/evaluate_uncomp.scm 132 */
obj_t BgL_head1140z00_2598;
{ /* Eval/evaluate_uncomp.scm 132 */
obj_t BgL_res1869z00_2599;
BgL_res1869z00_2599 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1140z00_2598 = BgL_res1869z00_2599; } 
{ 
obj_t BgL_ll1138z00_2601;obj_t BgL_ll1139z00_2602;obj_t BgL_tail1141z00_2603;
BgL_ll1138z00_2601 = BgL_ll1138z00_2596; 
BgL_ll1139z00_2602 = BgL_ll1139z00_2597; 
BgL_tail1141z00_2603 = BgL_head1140z00_2598; 
BgL_zc3z04anonymousza31427ze3z87_2600:
if(
NULLP(BgL_ll1138z00_2601))
{ /* Eval/evaluate_uncomp.scm 132 */
BgL_arg1424z00_2594 = 
CDR(BgL_head1140z00_2598); }  else 
{ /* Eval/evaluate_uncomp.scm 132 */
obj_t BgL_newtail1142z00_2604;
{ /* Eval/evaluate_uncomp.scm 132 */
obj_t BgL_arg1431z00_2605;
{ /* Eval/evaluate_uncomp.scm 132 */
obj_t BgL_vz00_2606;obj_t BgL_az00_2607;
BgL_vz00_2606 = 
CAR(
((obj_t)BgL_ll1138z00_2601)); 
BgL_az00_2607 = 
CAR(
((obj_t)BgL_ll1139z00_2602)); 
{ /* Eval/evaluate_uncomp.scm 132 */
obj_t BgL_arg1432z00_2608;obj_t BgL_arg1433z00_2609;
BgL_arg1432z00_2608 = 
BGl_uncompz00zz__evaluate_uncompz00(
((BgL_ev_exprz00_bglt)BgL_vz00_2606)); 
{ /* Eval/evaluate_uncomp.scm 132 */
obj_t BgL_arg1434z00_2610;
BgL_arg1434z00_2610 = 
BGl_uncompz00zz__evaluate_uncompz00(
((BgL_ev_exprz00_bglt)BgL_az00_2607)); 
BgL_arg1433z00_2609 = 
MAKE_YOUNG_PAIR(BgL_arg1434z00_2610, BNIL); } 
BgL_arg1431z00_2605 = 
MAKE_YOUNG_PAIR(BgL_arg1432z00_2608, BgL_arg1433z00_2609); } } 
{ /* Eval/evaluate_uncomp.scm 132 */
obj_t BgL_res1871z00_2611;
BgL_res1871z00_2611 = 
MAKE_YOUNG_PAIR(BgL_arg1431z00_2605, BNIL); 
BgL_newtail1142z00_2604 = BgL_res1871z00_2611; } } 
SET_CDR(BgL_tail1141z00_2603, BgL_newtail1142z00_2604); 
{ /* Eval/evaluate_uncomp.scm 132 */
obj_t BgL_arg1429z00_2612;obj_t BgL_arg1430z00_2613;
BgL_arg1429z00_2612 = 
CDR(
((obj_t)BgL_ll1138z00_2601)); 
BgL_arg1430z00_2613 = 
CDR(
((obj_t)BgL_ll1139z00_2602)); 
{ 
obj_t BgL_tail1141z00_3085;obj_t BgL_ll1139z00_3084;obj_t BgL_ll1138z00_3083;
BgL_ll1138z00_3083 = BgL_arg1429z00_2612; 
BgL_ll1139z00_3084 = BgL_arg1430z00_2613; 
BgL_tail1141z00_3085 = BgL_newtail1142z00_2604; 
BgL_tail1141z00_2603 = BgL_tail1141z00_3085; 
BgL_ll1139z00_2602 = BgL_ll1139z00_3084; 
BgL_ll1138z00_2601 = BgL_ll1138z00_3083; 
goto BgL_zc3z04anonymousza31427ze3z87_2600;} } } } } } 
{ /* Eval/evaluate_uncomp.scm 132 */
obj_t BgL_arg1435z00_2614;
{ /* Eval/evaluate_uncomp.scm 132 */
BgL_ev_exprz00_bglt BgL_arg1436z00_2615;
BgL_arg1436z00_2615 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letz00_bglt)BgL_ez00_2410))))->BgL_bodyz00); 
BgL_arg1435z00_2614 = 
BGl_uncompz00zz__evaluate_uncompz00(BgL_arg1436z00_2615); } 
BgL_arg1425z00_2595 = 
MAKE_YOUNG_PAIR(BgL_arg1435z00_2614, BNIL); } 
BgL_arg1423z00_2593 = 
MAKE_YOUNG_PAIR(BgL_arg1424z00_2594, BgL_arg1425z00_2595); } 
return 
MAKE_YOUNG_PAIR(BGl_symbol2022z00zz__evaluate_uncompz00, BgL_arg1423z00_2593);} } 

}



/* &uncomp-ev_synchroniz1230 */
obj_t BGl_z62uncompzd2ev_synchroniza71230z17zz__evaluate_uncompz00(obj_t BgL_envz00_2411, obj_t BgL_ez00_2412)
{
{ /* Eval/evaluate_uncomp.scm 126 */
{ /* Eval/evaluate_uncomp.scm 128 */
obj_t BgL_arg1411z00_2617;
{ /* Eval/evaluate_uncomp.scm 128 */
obj_t BgL_arg1412z00_2618;obj_t BgL_arg1413z00_2619;
BgL_arg1412z00_2618 = 
BGl_uncompz00zz__evaluate_uncompz00(
(((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_ez00_2412)))->BgL_mutexz00)); 
{ /* Eval/evaluate_uncomp.scm 128 */
obj_t BgL_arg1415z00_2620;
{ /* Eval/evaluate_uncomp.scm 128 */
obj_t BgL_arg1416z00_2621;obj_t BgL_arg1417z00_2622;
BgL_arg1416z00_2621 = 
BGl_uncompz00zz__evaluate_uncompz00(
(((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_ez00_2412)))->BgL_prelockz00)); 
BgL_arg1417z00_2622 = 
MAKE_YOUNG_PAIR(
BGl_uncompz00zz__evaluate_uncompz00(
(((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_ez00_2412)))->BgL_bodyz00)), BNIL); 
BgL_arg1415z00_2620 = 
MAKE_YOUNG_PAIR(BgL_arg1416z00_2621, BgL_arg1417z00_2622); } 
BgL_arg1413z00_2619 = 
MAKE_YOUNG_PAIR(BGl_keyword2024z00zz__evaluate_uncompz00, BgL_arg1415z00_2620); } 
BgL_arg1411z00_2617 = 
MAKE_YOUNG_PAIR(BgL_arg1412z00_2618, BgL_arg1413z00_2619); } 
return 
MAKE_YOUNG_PAIR(BGl_symbol2026z00zz__evaluate_uncompz00, BgL_arg1411z00_2617);} } 

}



/* &uncomp-ev_with-handl1228 */
obj_t BGl_z62uncompzd2ev_withzd2handl1228z62zz__evaluate_uncompz00(obj_t BgL_envz00_2413, obj_t BgL_ez00_2414)
{
{ /* Eval/evaluate_uncomp.scm 122 */
{ /* Eval/evaluate_uncomp.scm 124 */
obj_t BgL_arg1405z00_2624;
{ /* Eval/evaluate_uncomp.scm 124 */
obj_t BgL_arg1406z00_2625;obj_t BgL_arg1407z00_2626;
BgL_arg1406z00_2625 = 
BGl_uncompz00zz__evaluate_uncompz00(
(((BgL_ev_withzd2handlerzd2_bglt)COBJECT(
((BgL_ev_withzd2handlerzd2_bglt)BgL_ez00_2414)))->BgL_handlerz00)); 
BgL_arg1407z00_2626 = 
MAKE_YOUNG_PAIR(
BGl_uncompz00zz__evaluate_uncompz00(
(((BgL_ev_withzd2handlerzd2_bglt)COBJECT(
((BgL_ev_withzd2handlerzd2_bglt)BgL_ez00_2414)))->BgL_bodyz00)), BNIL); 
BgL_arg1405z00_2624 = 
MAKE_YOUNG_PAIR(BgL_arg1406z00_2625, BgL_arg1407z00_2626); } 
return 
MAKE_YOUNG_PAIR(BGl_symbol2028z00zz__evaluate_uncompz00, BgL_arg1405z00_2624);} } 

}



/* &uncomp-ev_unwind-pro1226 */
obj_t BGl_z62uncompzd2ev_unwindzd2pro1226z62zz__evaluate_uncompz00(obj_t BgL_envz00_2415, obj_t BgL_ez00_2416)
{
{ /* Eval/evaluate_uncomp.scm 118 */
{ /* Eval/evaluate_uncomp.scm 120 */
obj_t BgL_arg1399z00_2628;
{ /* Eval/evaluate_uncomp.scm 120 */
obj_t BgL_arg1400z00_2629;obj_t BgL_arg1401z00_2630;
BgL_arg1400z00_2629 = 
BGl_uncompz00zz__evaluate_uncompz00(
(((BgL_ev_unwindzd2protectzd2_bglt)COBJECT(
((BgL_ev_unwindzd2protectzd2_bglt)BgL_ez00_2416)))->BgL_ez00)); 
BgL_arg1401z00_2630 = 
MAKE_YOUNG_PAIR(
BGl_uncompz00zz__evaluate_uncompz00(
(((BgL_ev_unwindzd2protectzd2_bglt)COBJECT(
((BgL_ev_unwindzd2protectzd2_bglt)BgL_ez00_2416)))->BgL_bodyz00)), BNIL); 
BgL_arg1399z00_2628 = 
MAKE_YOUNG_PAIR(BgL_arg1400z00_2629, BgL_arg1401z00_2630); } 
return 
MAKE_YOUNG_PAIR(BGl_symbol2030z00zz__evaluate_uncompz00, BgL_arg1399z00_2628);} } 

}



/* &uncomp-ev_bind-exit1224 */
obj_t BGl_z62uncompzd2ev_bindzd2exit1224z62zz__evaluate_uncompz00(obj_t BgL_envz00_2417, obj_t BgL_ez00_2418)
{
{ /* Eval/evaluate_uncomp.scm 114 */
{ /* Eval/evaluate_uncomp.scm 116 */
obj_t BgL_arg1390z00_2632;
{ /* Eval/evaluate_uncomp.scm 116 */
obj_t BgL_arg1391z00_2633;obj_t BgL_arg1392z00_2634;
{ /* Eval/evaluate_uncomp.scm 116 */
obj_t BgL_arg1393z00_2635;
{ /* Eval/evaluate_uncomp.scm 116 */
BgL_ev_varz00_bglt BgL_arg1396z00_2636;
BgL_arg1396z00_2636 = 
(((BgL_ev_bindzd2exitzd2_bglt)COBJECT(
((BgL_ev_bindzd2exitzd2_bglt)BgL_ez00_2418)))->BgL_varz00); 
BgL_arg1393z00_2635 = 
BGl_uncompz00zz__evaluate_uncompz00(
((BgL_ev_exprz00_bglt)BgL_arg1396z00_2636)); } 
BgL_arg1391z00_2633 = 
MAKE_YOUNG_PAIR(BgL_arg1393z00_2635, BNIL); } 
BgL_arg1392z00_2634 = 
MAKE_YOUNG_PAIR(
BGl_uncompz00zz__evaluate_uncompz00(
(((BgL_ev_bindzd2exitzd2_bglt)COBJECT(
((BgL_ev_bindzd2exitzd2_bglt)BgL_ez00_2418)))->BgL_bodyz00)), BNIL); 
BgL_arg1390z00_2632 = 
MAKE_YOUNG_PAIR(BgL_arg1391z00_2633, BgL_arg1392z00_2634); } 
return 
MAKE_YOUNG_PAIR(BGl_symbol2032z00zz__evaluate_uncompz00, BgL_arg1390z00_2632);} } 

}



/* &uncomp-ev_setlocal1222 */
obj_t BGl_z62uncompzd2ev_setlocal1222zb0zz__evaluate_uncompz00(obj_t BgL_envz00_2419, obj_t BgL_ez00_2420)
{
{ /* Eval/evaluate_uncomp.scm 110 */
{ /* Eval/evaluate_uncomp.scm 112 */
obj_t BgL_arg1383z00_2638;
{ /* Eval/evaluate_uncomp.scm 112 */
obj_t BgL_arg1384z00_2639;obj_t BgL_arg1385z00_2640;
{ /* Eval/evaluate_uncomp.scm 112 */
BgL_ev_varz00_bglt BgL_arg1387z00_2641;
BgL_arg1387z00_2641 = 
(((BgL_ev_setlocalz00_bglt)COBJECT(
((BgL_ev_setlocalz00_bglt)BgL_ez00_2420)))->BgL_vz00); 
BgL_arg1384z00_2639 = 
BGl_uncompz00zz__evaluate_uncompz00(
((BgL_ev_exprz00_bglt)BgL_arg1387z00_2641)); } 
{ /* Eval/evaluate_uncomp.scm 112 */
obj_t BgL_arg1388z00_2642;
{ /* Eval/evaluate_uncomp.scm 112 */
BgL_ev_exprz00_bglt BgL_arg1389z00_2643;
BgL_arg1389z00_2643 = 
(((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)
((BgL_ev_setlocalz00_bglt)BgL_ez00_2420))))->BgL_ez00); 
BgL_arg1388z00_2642 = 
BGl_uncompz00zz__evaluate_uncompz00(BgL_arg1389z00_2643); } 
BgL_arg1385z00_2640 = 
MAKE_YOUNG_PAIR(BgL_arg1388z00_2642, BNIL); } 
BgL_arg1383z00_2638 = 
MAKE_YOUNG_PAIR(BgL_arg1384z00_2639, BgL_arg1385z00_2640); } 
return 
MAKE_YOUNG_PAIR(BGl_symbol2034z00zz__evaluate_uncompz00, BgL_arg1383z00_2638);} } 

}



/* &uncomp-ev_defglobal1220 */
obj_t BGl_z62uncompzd2ev_defglobal1220zb0zz__evaluate_uncompz00(obj_t BgL_envz00_2421, obj_t BgL_ez00_2422)
{
{ /* Eval/evaluate_uncomp.scm 106 */
{ /* Eval/evaluate_uncomp.scm 108 */
obj_t BgL_arg1378z00_2645;
{ /* Eval/evaluate_uncomp.scm 108 */
obj_t BgL_arg1379z00_2646;obj_t BgL_arg1380z00_2647;
BgL_arg1379z00_2646 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)
((BgL_ev_defglobalz00_bglt)BgL_ez00_2422))))->BgL_namez00); 
{ /* Eval/evaluate_uncomp.scm 108 */
obj_t BgL_arg1381z00_2648;
{ /* Eval/evaluate_uncomp.scm 108 */
BgL_ev_exprz00_bglt BgL_arg1382z00_2649;
BgL_arg1382z00_2649 = 
(((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)
((BgL_ev_defglobalz00_bglt)BgL_ez00_2422))))->BgL_ez00); 
BgL_arg1381z00_2648 = 
BGl_uncompz00zz__evaluate_uncompz00(BgL_arg1382z00_2649); } 
BgL_arg1380z00_2647 = 
MAKE_YOUNG_PAIR(BgL_arg1381z00_2648, BNIL); } 
BgL_arg1378z00_2645 = 
MAKE_YOUNG_PAIR(BgL_arg1379z00_2646, BgL_arg1380z00_2647); } 
return 
MAKE_YOUNG_PAIR(BGl_symbol2036z00zz__evaluate_uncompz00, BgL_arg1378z00_2645);} } 

}



/* &uncomp-ev_setglobal1218 */
obj_t BGl_z62uncompzd2ev_setglobal1218zb0zz__evaluate_uncompz00(obj_t BgL_envz00_2423, obj_t BgL_ez00_2424)
{
{ /* Eval/evaluate_uncomp.scm 102 */
{ /* Eval/evaluate_uncomp.scm 104 */
obj_t BgL_arg1373z00_2651;
{ /* Eval/evaluate_uncomp.scm 104 */
obj_t BgL_arg1374z00_2652;obj_t BgL_arg1375z00_2653;
BgL_arg1374z00_2652 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_ez00_2424)))->BgL_namez00); 
{ /* Eval/evaluate_uncomp.scm 104 */
obj_t BgL_arg1376z00_2654;
{ /* Eval/evaluate_uncomp.scm 104 */
BgL_ev_exprz00_bglt BgL_arg1377z00_2655;
BgL_arg1377z00_2655 = 
(((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)
((BgL_ev_setglobalz00_bglt)BgL_ez00_2424))))->BgL_ez00); 
BgL_arg1376z00_2654 = 
BGl_uncompz00zz__evaluate_uncompz00(BgL_arg1377z00_2655); } 
BgL_arg1375z00_2653 = 
MAKE_YOUNG_PAIR(BgL_arg1376z00_2654, BNIL); } 
BgL_arg1373z00_2651 = 
MAKE_YOUNG_PAIR(BgL_arg1374z00_2652, BgL_arg1375z00_2653); } 
return 
MAKE_YOUNG_PAIR(BGl_symbol2034z00zz__evaluate_uncompz00, BgL_arg1373z00_2651);} } 

}



/* &uncomp-ev_trap1216 */
obj_t BGl_z62uncompzd2ev_trap1216zb0zz__evaluate_uncompz00(obj_t BgL_envz00_2425, obj_t BgL_ez00_2426)
{
{ /* Eval/evaluate_uncomp.scm 98 */
{ /* Eval/evaluate_uncomp.scm 100 */
obj_t BgL_arg1369z00_2657;
{ /* Eval/evaluate_uncomp.scm 100 */
obj_t BgL_arg1371z00_2658;
{ /* Eval/evaluate_uncomp.scm 100 */
BgL_ev_exprz00_bglt BgL_arg1372z00_2659;
BgL_arg1372z00_2659 = 
(((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)
((BgL_ev_trapz00_bglt)BgL_ez00_2426))))->BgL_ez00); 
BgL_arg1371z00_2658 = 
BGl_uncompz00zz__evaluate_uncompz00(BgL_arg1372z00_2659); } 
BgL_arg1369z00_2657 = 
MAKE_YOUNG_PAIR(BgL_arg1371z00_2658, BNIL); } 
return 
MAKE_YOUNG_PAIR(BGl_symbol2038z00zz__evaluate_uncompz00, BgL_arg1369z00_2657);} } 

}



/* &uncomp-ev_prog21214 */
obj_t BGl_z62uncompzd2ev_prog21214zb0zz__evaluate_uncompz00(obj_t BgL_envz00_2427, obj_t BgL_ez00_2428)
{
{ /* Eval/evaluate_uncomp.scm 91 */
{ /* Eval/evaluate_uncomp.scm 93 */
obj_t BgL_e1z00_2661;obj_t BgL_e2z00_2662;
BgL_e1z00_2661 = 
BGl_uncompz00zz__evaluate_uncompz00(
(((BgL_ev_prog2z00_bglt)COBJECT(
((BgL_ev_prog2z00_bglt)BgL_ez00_2428)))->BgL_e1z00)); 
BgL_e2z00_2662 = 
BGl_uncompz00zz__evaluate_uncompz00(
(((BgL_ev_prog2z00_bglt)COBJECT(
((BgL_ev_prog2z00_bglt)BgL_ez00_2428)))->BgL_e2z00)); 
{ /* Eval/evaluate_uncomp.scm 94 */
bool_t BgL_test2122z00_3178;
if(
PAIRP(BgL_e2z00_2662))
{ /* Eval/evaluate_uncomp.scm 94 */
BgL_test2122z00_3178 = 
(
CAR(BgL_e2z00_2662)==BGl_symbol2040z00zz__evaluate_uncompz00)
; }  else 
{ /* Eval/evaluate_uncomp.scm 94 */
BgL_test2122z00_3178 = ((bool_t)0)
; } 
if(BgL_test2122z00_3178)
{ /* Eval/evaluate_uncomp.scm 95 */
obj_t BgL_arg1361z00_2663;
BgL_arg1361z00_2663 = 
MAKE_YOUNG_PAIR(BgL_e1z00_2661, 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(
CDR(BgL_e2z00_2662), BNIL)); 
return 
MAKE_YOUNG_PAIR(BGl_symbol2040z00zz__evaluate_uncompz00, BgL_arg1361z00_2663);}  else 
{ /* Eval/evaluate_uncomp.scm 96 */
obj_t BgL_arg1364z00_2664;
{ /* Eval/evaluate_uncomp.scm 96 */
obj_t BgL_arg1365z00_2665;
BgL_arg1365z00_2665 = 
MAKE_YOUNG_PAIR(BgL_e2z00_2662, BNIL); 
BgL_arg1364z00_2664 = 
MAKE_YOUNG_PAIR(BgL_e1z00_2661, BgL_arg1365z00_2665); } 
return 
MAKE_YOUNG_PAIR(BGl_symbol2040z00zz__evaluate_uncompz00, BgL_arg1364z00_2664);} } } } 

}



/* &uncomp-ev_and1212 */
obj_t BGl_z62uncompzd2ev_and1212zb0zz__evaluate_uncompz00(obj_t BgL_envz00_2429, obj_t BgL_ez00_2430)
{
{ /* Eval/evaluate_uncomp.scm 87 */
{ /* Eval/evaluate_uncomp.scm 89 */
obj_t BgL_arg1347z00_2667;
{ /* Eval/evaluate_uncomp.scm 89 */
obj_t BgL_arg1348z00_2668;
{ /* Eval/evaluate_uncomp.scm 89 */
obj_t BgL_l1132z00_2669;
BgL_l1132z00_2669 = 
(((BgL_ev_listz00_bglt)COBJECT(
((BgL_ev_listz00_bglt)
((BgL_ev_andz00_bglt)BgL_ez00_2430))))->BgL_argsz00); 
if(
NULLP(BgL_l1132z00_2669))
{ /* Eval/evaluate_uncomp.scm 89 */
BgL_arg1348z00_2668 = BNIL; }  else 
{ /* Eval/evaluate_uncomp.scm 89 */
obj_t BgL_head1134z00_2670;
{ /* Eval/evaluate_uncomp.scm 89 */
obj_t BgL_arg1355z00_2671;
{ /* Eval/evaluate_uncomp.scm 89 */
obj_t BgL_arg1357z00_2672;
BgL_arg1357z00_2672 = 
CAR(
((obj_t)BgL_l1132z00_2669)); 
BgL_arg1355z00_2671 = 
BGl_uncompz00zz__evaluate_uncompz00(
((BgL_ev_exprz00_bglt)BgL_arg1357z00_2672)); } 
{ /* Eval/evaluate_uncomp.scm 89 */
obj_t BgL_res1864z00_2673;
BgL_res1864z00_2673 = 
MAKE_YOUNG_PAIR(BgL_arg1355z00_2671, BNIL); 
BgL_head1134z00_2670 = BgL_res1864z00_2673; } } 
{ /* Eval/evaluate_uncomp.scm 89 */
obj_t BgL_g1137z00_2674;
BgL_g1137z00_2674 = 
CDR(
((obj_t)BgL_l1132z00_2669)); 
{ 
obj_t BgL_l1132z00_2676;obj_t BgL_tail1135z00_2677;
BgL_l1132z00_2676 = BgL_g1137z00_2674; 
BgL_tail1135z00_2677 = BgL_head1134z00_2670; 
BgL_zc3z04anonymousza31350ze3z87_2675:
if(
NULLP(BgL_l1132z00_2676))
{ /* Eval/evaluate_uncomp.scm 89 */
BgL_arg1348z00_2668 = BgL_head1134z00_2670; }  else 
{ /* Eval/evaluate_uncomp.scm 89 */
obj_t BgL_newtail1136z00_2678;
{ /* Eval/evaluate_uncomp.scm 89 */
obj_t BgL_arg1353z00_2679;
{ /* Eval/evaluate_uncomp.scm 89 */
obj_t BgL_arg1354z00_2680;
BgL_arg1354z00_2680 = 
CAR(
((obj_t)BgL_l1132z00_2676)); 
BgL_arg1353z00_2679 = 
BGl_uncompz00zz__evaluate_uncompz00(
((BgL_ev_exprz00_bglt)BgL_arg1354z00_2680)); } 
{ /* Eval/evaluate_uncomp.scm 89 */
obj_t BgL_res1866z00_2681;
BgL_res1866z00_2681 = 
MAKE_YOUNG_PAIR(BgL_arg1353z00_2679, BNIL); 
BgL_newtail1136z00_2678 = BgL_res1866z00_2681; } } 
SET_CDR(BgL_tail1135z00_2677, BgL_newtail1136z00_2678); 
{ /* Eval/evaluate_uncomp.scm 89 */
obj_t BgL_arg1352z00_2682;
BgL_arg1352z00_2682 = 
CDR(
((obj_t)BgL_l1132z00_2676)); 
{ 
obj_t BgL_tail1135z00_3213;obj_t BgL_l1132z00_3212;
BgL_l1132z00_3212 = BgL_arg1352z00_2682; 
BgL_tail1135z00_3213 = BgL_newtail1136z00_2678; 
BgL_tail1135z00_2677 = BgL_tail1135z00_3213; 
BgL_l1132z00_2676 = BgL_l1132z00_3212; 
goto BgL_zc3z04anonymousza31350ze3z87_2675;} } } } } } } 
BgL_arg1347z00_2667 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_arg1348z00_2668, BNIL); } 
return 
MAKE_YOUNG_PAIR(BGl_symbol2042z00zz__evaluate_uncompz00, BgL_arg1347z00_2667);} } 

}



/* &uncomp-ev_or1210 */
obj_t BGl_z62uncompzd2ev_or1210zb0zz__evaluate_uncompz00(obj_t BgL_envz00_2431, obj_t BgL_ez00_2432)
{
{ /* Eval/evaluate_uncomp.scm 83 */
{ /* Eval/evaluate_uncomp.scm 85 */
obj_t BgL_arg1337z00_2684;
{ /* Eval/evaluate_uncomp.scm 85 */
obj_t BgL_arg1338z00_2685;
{ /* Eval/evaluate_uncomp.scm 85 */
obj_t BgL_l1126z00_2686;
BgL_l1126z00_2686 = 
(((BgL_ev_listz00_bglt)COBJECT(
((BgL_ev_listz00_bglt)
((BgL_ev_orz00_bglt)BgL_ez00_2432))))->BgL_argsz00); 
if(
NULLP(BgL_l1126z00_2686))
{ /* Eval/evaluate_uncomp.scm 85 */
BgL_arg1338z00_2685 = BNIL; }  else 
{ /* Eval/evaluate_uncomp.scm 85 */
obj_t BgL_head1128z00_2687;
{ /* Eval/evaluate_uncomp.scm 85 */
obj_t BgL_arg1345z00_2688;
{ /* Eval/evaluate_uncomp.scm 85 */
obj_t BgL_arg1346z00_2689;
BgL_arg1346z00_2689 = 
CAR(
((obj_t)BgL_l1126z00_2686)); 
BgL_arg1345z00_2688 = 
BGl_uncompz00zz__evaluate_uncompz00(
((BgL_ev_exprz00_bglt)BgL_arg1346z00_2689)); } 
{ /* Eval/evaluate_uncomp.scm 85 */
obj_t BgL_res1860z00_2690;
BgL_res1860z00_2690 = 
MAKE_YOUNG_PAIR(BgL_arg1345z00_2688, BNIL); 
BgL_head1128z00_2687 = BgL_res1860z00_2690; } } 
{ /* Eval/evaluate_uncomp.scm 85 */
obj_t BgL_g1131z00_2691;
BgL_g1131z00_2691 = 
CDR(
((obj_t)BgL_l1126z00_2686)); 
{ 
obj_t BgL_l1126z00_2693;obj_t BgL_tail1129z00_2694;
BgL_l1126z00_2693 = BgL_g1131z00_2691; 
BgL_tail1129z00_2694 = BgL_head1128z00_2687; 
BgL_zc3z04anonymousza31340ze3z87_2692:
if(
NULLP(BgL_l1126z00_2693))
{ /* Eval/evaluate_uncomp.scm 85 */
BgL_arg1338z00_2685 = BgL_head1128z00_2687; }  else 
{ /* Eval/evaluate_uncomp.scm 85 */
obj_t BgL_newtail1130z00_2695;
{ /* Eval/evaluate_uncomp.scm 85 */
obj_t BgL_arg1343z00_2696;
{ /* Eval/evaluate_uncomp.scm 85 */
obj_t BgL_arg1344z00_2697;
BgL_arg1344z00_2697 = 
CAR(
((obj_t)BgL_l1126z00_2693)); 
BgL_arg1343z00_2696 = 
BGl_uncompz00zz__evaluate_uncompz00(
((BgL_ev_exprz00_bglt)BgL_arg1344z00_2697)); } 
{ /* Eval/evaluate_uncomp.scm 85 */
obj_t BgL_res1862z00_2698;
BgL_res1862z00_2698 = 
MAKE_YOUNG_PAIR(BgL_arg1343z00_2696, BNIL); 
BgL_newtail1130z00_2695 = BgL_res1862z00_2698; } } 
SET_CDR(BgL_tail1129z00_2694, BgL_newtail1130z00_2695); 
{ /* Eval/evaluate_uncomp.scm 85 */
obj_t BgL_arg1342z00_2699;
BgL_arg1342z00_2699 = 
CDR(
((obj_t)BgL_l1126z00_2693)); 
{ 
obj_t BgL_tail1129z00_3239;obj_t BgL_l1126z00_3238;
BgL_l1126z00_3238 = BgL_arg1342z00_2699; 
BgL_tail1129z00_3239 = BgL_newtail1130z00_2695; 
BgL_tail1129z00_2694 = BgL_tail1129z00_3239; 
BgL_l1126z00_2693 = BgL_l1126z00_3238; 
goto BgL_zc3z04anonymousza31340ze3z87_2692;} } } } } } } 
BgL_arg1337z00_2684 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_arg1338z00_2685, BNIL); } 
return 
MAKE_YOUNG_PAIR(BGl_symbol2044z00zz__evaluate_uncompz00, BgL_arg1337z00_2684);} } 

}



/* &uncomp-ev_if1208 */
obj_t BGl_z62uncompzd2ev_if1208zb0zz__evaluate_uncompz00(obj_t BgL_envz00_2433, obj_t BgL_ez00_2434)
{
{ /* Eval/evaluate_uncomp.scm 79 */
{ /* Eval/evaluate_uncomp.scm 81 */
obj_t BgL_arg1325z00_2701;
{ /* Eval/evaluate_uncomp.scm 81 */
obj_t BgL_arg1326z00_2702;obj_t BgL_arg1329z00_2703;
BgL_arg1326z00_2702 = 
BGl_uncompz00zz__evaluate_uncompz00(
(((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_ez00_2434)))->BgL_pz00)); 
{ /* Eval/evaluate_uncomp.scm 81 */
obj_t BgL_arg1332z00_2704;obj_t BgL_arg1333z00_2705;
BgL_arg1332z00_2704 = 
BGl_uncompz00zz__evaluate_uncompz00(
(((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_ez00_2434)))->BgL_tz00)); 
BgL_arg1333z00_2705 = 
MAKE_YOUNG_PAIR(
BGl_uncompz00zz__evaluate_uncompz00(
(((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_ez00_2434)))->BgL_ez00)), BNIL); 
BgL_arg1329z00_2703 = 
MAKE_YOUNG_PAIR(BgL_arg1332z00_2704, BgL_arg1333z00_2705); } 
BgL_arg1325z00_2701 = 
MAKE_YOUNG_PAIR(BgL_arg1326z00_2702, BgL_arg1329z00_2703); } 
return 
MAKE_YOUNG_PAIR(BGl_symbol2046z00zz__evaluate_uncompz00, BgL_arg1325z00_2701);} } 

}



/* &uncomp-ev_litt1206 */
obj_t BGl_z62uncompzd2ev_litt1206zb0zz__evaluate_uncompz00(obj_t BgL_envz00_2435, obj_t BgL_ez00_2436)
{
{ /* Eval/evaluate_uncomp.scm 75 */
{ /* Eval/evaluate_uncomp.scm 77 */
obj_t BgL_arg1300z00_2707;
BgL_arg1300z00_2707 = 
MAKE_YOUNG_PAIR(
(((BgL_ev_littz00_bglt)COBJECT(
((BgL_ev_littz00_bglt)BgL_ez00_2436)))->BgL_valuez00), BNIL); 
return 
MAKE_YOUNG_PAIR(BGl_symbol2048z00zz__evaluate_uncompz00, BgL_arg1300z00_2707);} } 

}



/* &uncomp-ev_global1204 */
obj_t BGl_z62uncompzd2ev_global1204zb0zz__evaluate_uncompz00(obj_t BgL_envz00_2437, obj_t BgL_varz00_2438)
{
{ /* Eval/evaluate_uncomp.scm 71 */
return 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_varz00_2438)))->BgL_namez00);} 

}



/* &uncomp-ev_var1202 */
obj_t BGl_z62uncompzd2ev_var1202zb0zz__evaluate_uncompz00(obj_t BgL_envz00_2439, obj_t BgL_varz00_2440)
{
{ /* Eval/evaluate_uncomp.scm 67 */
return 
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_varz00_2440)))->BgL_namez00);} 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__evaluate_uncompz00()
{
{ /* Eval/evaluate_uncomp.scm 15 */
BGl_modulezd2initializa7ationz75zz__typez00(((long)121046086), 
BSTRING_TO_STRING(BGl_string2050z00zz__evaluate_uncompz00)); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)330490148), 
BSTRING_TO_STRING(BGl_string2050z00zz__evaluate_uncompz00)); 
BGl_modulezd2initializa7ationz75zz__biglooz00(((long)180158922), 
BSTRING_TO_STRING(BGl_string2050z00zz__evaluate_uncompz00)); 
BGl_modulezd2initializa7ationz75zz__tvectorz00(((long)135276775), 
BSTRING_TO_STRING(BGl_string2050z00zz__evaluate_uncompz00)); 
BGl_modulezd2initializa7ationz75zz__structurez00(((long)128218210), 
BSTRING_TO_STRING(BGl_string2050z00zz__evaluate_uncompz00)); 
BGl_modulezd2initializa7ationz75zz__bexitz00(((long)340267792), 
BSTRING_TO_STRING(BGl_string2050z00zz__evaluate_uncompz00)); 
BGl_modulezd2initializa7ationz75zz__bignumz00(((long)6519932), 
BSTRING_TO_STRING(BGl_string2050z00zz__evaluate_uncompz00)); 
BGl_modulezd2initializa7ationz75zz__osz00(((long)251314740), 
BSTRING_TO_STRING(BGl_string2050z00zz__evaluate_uncompz00)); 
BGl_modulezd2initializa7ationz75zz__dssslz00(((long)443936801), 
BSTRING_TO_STRING(BGl_string2050z00zz__evaluate_uncompz00)); 
BGl_modulezd2initializa7ationz75zz__bitz00(((long)439353001), 
BSTRING_TO_STRING(BGl_string2050z00zz__evaluate_uncompz00)); 
BGl_modulezd2initializa7ationz75zz__paramz00(((long)453939141), 
BSTRING_TO_STRING(BGl_string2050z00zz__evaluate_uncompz00)); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)193422112), 
BSTRING_TO_STRING(BGl_string2050z00zz__evaluate_uncompz00)); 
BGl_modulezd2initializa7ationz75zz__threadz00(((long)224967693), 
BSTRING_TO_STRING(BGl_string2050z00zz__evaluate_uncompz00)); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long)68574988), 
BSTRING_TO_STRING(BGl_string2050z00zz__evaluate_uncompz00)); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)93454137), 
BSTRING_TO_STRING(BGl_string2050z00zz__evaluate_uncompz00)); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(((long)437057797), 
BSTRING_TO_STRING(BGl_string2050z00zz__evaluate_uncompz00)); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(((long)268155843), 
BSTRING_TO_STRING(BGl_string2050z00zz__evaluate_uncompz00)); 
BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long)198620800), 
BSTRING_TO_STRING(BGl_string2050z00zz__evaluate_uncompz00)); 
BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)473309430), 
BSTRING_TO_STRING(BGl_string2050z00zz__evaluate_uncompz00)); 
BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(((long)459519430), 
BSTRING_TO_STRING(BGl_string2050z00zz__evaluate_uncompz00)); 
BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long)460262918), 
BSTRING_TO_STRING(BGl_string2050z00zz__evaluate_uncompz00)); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)-400105135), 
BSTRING_TO_STRING(BGl_string2050z00zz__evaluate_uncompz00)); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)9614678), 
BSTRING_TO_STRING(BGl_string2050z00zz__evaluate_uncompz00)); 
BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)376927882), 
BSTRING_TO_STRING(BGl_string2050z00zz__evaluate_uncompz00)); 
BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)228151370), 
BSTRING_TO_STRING(BGl_string2050z00zz__evaluate_uncompz00)); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)127905250), 
BSTRING_TO_STRING(BGl_string2050z00zz__evaluate_uncompz00)); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)331540577), 
BSTRING_TO_STRING(BGl_string2050z00zz__evaluate_uncompz00)); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)86988580), 
BSTRING_TO_STRING(BGl_string2050z00zz__evaluate_uncompz00)); 
BGl_modulezd2initializa7ationz75zz__ppz00(((long)233942021), 
BSTRING_TO_STRING(BGl_string2050z00zz__evaluate_uncompz00)); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)220648206), 
BSTRING_TO_STRING(BGl_string2050z00zz__evaluate_uncompz00)); 
BGl_modulezd2initializa7ationz75zz__prognz00(((long)177147622), 
BSTRING_TO_STRING(BGl_string2050z00zz__evaluate_uncompz00)); 
BGl_modulezd2initializa7ationz75zz__expandz00(((long)414007149), 
BSTRING_TO_STRING(BGl_string2050z00zz__evaluate_uncompz00)); 
BGl_modulezd2initializa7ationz75zz__evenvz00(((long)528345299), 
BSTRING_TO_STRING(BGl_string2050z00zz__evaluate_uncompz00)); 
BGl_modulezd2initializa7ationz75zz__evcompilez00(((long)492754569), 
BSTRING_TO_STRING(BGl_string2050z00zz__evaluate_uncompz00)); 
BGl_modulezd2initializa7ationz75zz__everrorz00(((long)375872221), 
BSTRING_TO_STRING(BGl_string2050z00zz__evaluate_uncompz00)); 
BGl_modulezd2initializa7ationz75zz__evmodulez00(((long)505897955), 
BSTRING_TO_STRING(BGl_string2050z00zz__evaluate_uncompz00)); 
return 
BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(((long)0), 
BSTRING_TO_STRING(BGl_string2050z00zz__evaluate_uncompz00));} 

}

#ifdef __cplusplus
}
#endif
