/*===========================================================================*/
/*   (Eval/evaluate_uncomp.scm)                                              */
/*   Bigloo (4.3h)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 11 May 2020 12:14:39 PM CEST    */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bigloo/bin/bigloo -srfi enable-gmp -srfi bigloo-unsafe -O3 -fcfa-arithmetic -q -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.3h -rm -copt -w -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.3h -mklib -cc gcc -fsharing -q -no-hello -unsafe -safee -O4 -c Eval/evaluate_uncomp.scm -indent -o objs/obj_u/Eval/evaluate_uncomp.c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* object type definitions */
	typedef struct BgL_ev_exprz00_bgl
	{
		header_t header;
		obj_t widening;
	}                 *BgL_ev_exprz00_bglt;

	typedef struct BgL_ev_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_namez00;
		obj_t BgL_effz00;
		obj_t BgL_typez00;
	}                *BgL_ev_varz00_bglt;

	typedef struct BgL_ev_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                   *BgL_ev_globalz00_bglt;

	typedef struct BgL_ev_littz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_valuez00;
	}                 *BgL_ev_littz00_bglt;

	typedef struct BgL_ev_ifz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_pz00;
		struct BgL_ev_exprz00_bgl *BgL_tz00;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}               *BgL_ev_ifz00_bglt;

	typedef struct BgL_ev_listz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}                 *BgL_ev_listz00_bglt;

	typedef struct BgL_ev_orz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}               *BgL_ev_orz00_bglt;

	typedef struct BgL_ev_andz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}                *BgL_ev_andz00_bglt;

	typedef struct BgL_ev_prog2z00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_e1z00;
		struct BgL_ev_exprz00_bgl *BgL_e2z00;
	}                  *BgL_ev_prog2z00_bglt;

	typedef struct BgL_ev_hookz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}                 *BgL_ev_hookz00_bglt;

	typedef struct BgL_ev_trapz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}                 *BgL_ev_trapz00_bglt;

	typedef struct BgL_ev_setlocalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		struct BgL_ev_varz00_bgl *BgL_vz00;
	}                     *BgL_ev_setlocalz00_bglt;

	typedef struct BgL_ev_setglobalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                      *BgL_ev_setglobalz00_bglt;

	typedef struct BgL_ev_defglobalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                      *BgL_ev_defglobalz00_bglt;

	typedef struct BgL_ev_bindzd2exitzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_varz00_bgl *BgL_varz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                        *BgL_ev_bindzd2exitzd2_bglt;

	typedef struct BgL_ev_unwindzd2protectzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                             *BgL_ev_unwindzd2protectzd2_bglt;

	typedef struct BgL_ev_withzd2handlerzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_handlerz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                           *BgL_ev_withzd2handlerzd2_bglt;

	typedef struct BgL_ev_synchroniza7eza7_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_ev_exprz00_bgl *BgL_mutexz00;
		struct BgL_ev_exprz00_bgl *BgL_prelockz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                          *BgL_ev_synchroniza7eza7_bglt;

	typedef struct BgL_ev_binderz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                   *BgL_ev_binderz00_bglt;

	typedef struct BgL_ev_letz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		obj_t BgL_boxesz00;
	}                *BgL_ev_letz00_bglt;

	typedef struct BgL_ev_letza2za2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		obj_t BgL_boxesz00;
	}                   *BgL_ev_letza2za2_bglt;

	typedef struct BgL_ev_letrecz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                   *BgL_ev_letrecz00_bglt;

	typedef struct BgL_ev_labelsz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		obj_t BgL_envz00;
		obj_t BgL_stkz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		obj_t BgL_boxesz00;
	}                   *BgL_ev_labelsz00_bglt;

	typedef struct BgL_ev_gotoz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_ev_varz00_bgl *BgL_labelz00;
		struct BgL_ev_labelsz00_bgl *BgL_labelsz00;
		obj_t BgL_argsz00;
	}                 *BgL_ev_gotoz00_bglt;

	typedef struct BgL_ev_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_ev_exprz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_tailzf3zf3;
	}                *BgL_ev_appz00_bglt;

	typedef struct BgL_ev_absz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		obj_t BgL_wherez00;
		obj_t BgL_arityz00;
		obj_t BgL_varsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		int BgL_siza7eza7;
		obj_t BgL_bindz00;
		obj_t BgL_freez00;
		obj_t BgL_innerz00;
		obj_t BgL_boxesz00;
	}                *BgL_ev_absz00_bglt;


	static obj_t BGl_z62uncompzd2ev_or1210zb0zz__evaluate_uncompz00(obj_t, obj_t);
	extern obj_t BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	static obj_t BGl_z62uncompzd2ev_setlocal1222zb0zz__evaluate_uncompz00(obj_t,
		obj_t);
	static obj_t
		BGl_z62uncompzd2ev_bindzd2exit1224z62zz__evaluate_uncompz00(obj_t, obj_t);
	static obj_t BGl_z62uncomp1199z62zz__evaluate_uncompz00(obj_t, obj_t);
	extern obj_t BGl_ev_letrecz00zz__evaluate_typesz00;
	static obj_t BGl_z62uncompzd2ev_var1202zb0zz__evaluate_uncompz00(obj_t,
		obj_t);
	static obj_t BGl_z62uncompzd2ev_prog21214zb0zz__evaluate_uncompz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_letz00zz__evaluate_typesz00;
	static obj_t BGl_objectzd2initzd2zz__evaluate_uncompz00();
	static obj_t
		BGl_z62uncompzd2ev_unwindzd2pro1226z62zz__evaluate_uncompz00(obj_t, obj_t);
	extern obj_t bstring_to_symbol(obj_t);
	extern bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	static obj_t BGl_z62uncompzd2ev_goto1240zb0zz__evaluate_uncompz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_labelsz00zz__evaluate_typesz00;
	static obj_t BGl_methodzd2initzd2zz__evaluate_uncompz00();
	static obj_t BGl_recze70ze7zz__evaluate_uncompz00(obj_t);
	extern obj_t BGl_ev_absz00zz__evaluate_typesz00;
	extern obj_t BGl_ev_ifz00zz__evaluate_typesz00;
	extern obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_ev_gotoz00zz__evaluate_typesz00;
	static obj_t BGl_keyword2070z00zz__evaluate_uncompz00 = BUNSPEC;
	static obj_t BGl_symbol2036z00zz__evaluate_uncompz00 = BUNSPEC;
	static obj_t BGl_z62uncompzd2ev_labels1238zb0zz__evaluate_uncompz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_orz00zz__evaluate_typesz00;
	extern obj_t BGl_ev_varz00zz__evaluate_typesz00;
	static obj_t BGl_symbol2062z00zz__evaluate_uncompz00 = BUNSPEC;
	static obj_t BGl_symbol2064z00zz__evaluate_uncompz00 = BUNSPEC;
	static obj_t BGl_symbol2066z00zz__evaluate_uncompz00 = BUNSPEC;
	static obj_t BGl_symbol2068z00zz__evaluate_uncompz00 = BUNSPEC;
	static obj_t BGl_gczd2rootszd2initz00zz__evaluate_uncompz00();
	static obj_t BGl_symbol2072z00zz__evaluate_uncompz00 = BUNSPEC;
	static obj_t BGl_symbol2074z00zz__evaluate_uncompz00 = BUNSPEC;
	static obj_t BGl_symbol2076z00zz__evaluate_uncompz00 = BUNSPEC;
	static obj_t BGl_symbol2078z00zz__evaluate_uncompz00 = BUNSPEC;
	extern obj_t BGl_ev_andz00zz__evaluate_typesz00;
	static obj_t BGl_symbol2080z00zz__evaluate_uncompz00 = BUNSPEC;
	static obj_t BGl_symbol2082z00zz__evaluate_uncompz00 = BUNSPEC;
	static obj_t BGl_symbol2084z00zz__evaluate_uncompz00 = BUNSPEC;
	static obj_t BGl_symbol2086z00zz__evaluate_uncompz00 = BUNSPEC;
	static obj_t BGl_symbol2088z00zz__evaluate_uncompz00 = BUNSPEC;
	static obj_t BGl_z62uncompilez62zz__evaluate_uncompz00(obj_t, obj_t);
	static obj_t BGl_z62uncompzd2ev_trap1216zb0zz__evaluate_uncompz00(obj_t,
		obj_t);
	static obj_t BGl_symbol2090z00zz__evaluate_uncompz00 = BUNSPEC;
	static obj_t BGl_symbol2092z00zz__evaluate_uncompz00 = BUNSPEC;
	static obj_t BGl_symbol2094z00zz__evaluate_uncompz00 = BUNSPEC;
	static obj_t BGl_z62uncompz62zz__evaluate_uncompz00(obj_t, obj_t);
	extern obj_t BGl_ev_appz00zz__evaluate_typesz00;
	extern obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_ev_synchroniza7eza7zz__evaluate_typesz00;
	BGL_EXPORTED_DECL obj_t
		BGl_uncompilez00zz__evaluate_uncompz00(BgL_ev_exprz00_bglt);
	static obj_t
		BGl_z62uncompzd2ev_withzd2handl1228z62zz__evaluate_uncompz00(obj_t, obj_t);
	extern obj_t BGl_ev_defglobalz00zz__evaluate_typesz00;
	static obj_t BGl_requirezd2initializa7ationz75zz__evaluate_uncompz00 =
		BUNSPEC;
	extern obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_toplevelzd2initzd2zz__evaluate_uncompz00();
	static obj_t BGl_genericzd2initzd2zz__evaluate_uncompz00();
	extern obj_t BGl_ev_prog2z00zz__evaluate_typesz00;
	static obj_t BGl_redovarsze70ze7zz__evaluate_uncompz00(obj_t, obj_t);
	extern obj_t BGl_ev_bindzd2exitzd2zz__evaluate_typesz00;
	static obj_t BGl_z62uncompzd2ev_let1232zb0zz__evaluate_uncompz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00;
	extern obj_t BGl_ev_letza2za2zz__evaluate_typesz00;
	extern obj_t BGl_ev_trapz00zz__evaluate_typesz00;
	static obj_t BGl_z62uncompzd2ev_defglobal1220zb0zz__evaluate_uncompz00(obj_t,
		obj_t);
	static obj_t BGl_z62uncompzd2ev_setglobal1218zb0zz__evaluate_uncompz00(obj_t,
		obj_t);
	static obj_t BGl_z62uncompzd2ev_app1242zb0zz__evaluate_uncompz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_setglobalz00zz__evaluate_typesz00;
	static obj_t BGl_uncompz00zz__evaluate_uncompz00(BgL_ev_exprz00_bglt);
	static obj_t BGl_z62uncompzd2ev_and1212zb0zz__evaluate_uncompz00(obj_t,
		obj_t);
	static obj_t
		BGl_z62uncompzd2ev_synchroniza71230z17zz__evaluate_uncompz00(obj_t, obj_t);
	static obj_t BGl_z62uncompzd2ev_if1208zb0zz__evaluate_uncompz00(obj_t, obj_t);
	static obj_t BGl_z62uncompzd2ev_global1204zb0zz__evaluate_uncompz00(obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zz__evaluate_uncompz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evmodulez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__everrorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evcompilez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evenvz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__expandz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__prognz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__ppz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(long, char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__dssslz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bignumz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__structurez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__tvectorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__typez00(long, char *);
	static obj_t BGl_z62uncompzd2ev_abs1244zb0zz__evaluate_uncompz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_globalz00zz__evaluate_typesz00;
	extern obj_t BGl_ev_littz00zz__evaluate_typesz00;
	static obj_t BGl_cnstzd2initzd2zz__evaluate_uncompz00();
	static obj_t BGl_importedzd2moduleszd2initz00zz__evaluate_uncompz00();
	extern obj_t BGl_ev_withzd2handlerzd2zz__evaluate_typesz00;
	static obj_t BGl_z62uncompzd2ev_litt1206zb0zz__evaluate_uncompz00(obj_t,
		obj_t);
	static obj_t BGl_z62uncompzd2ev_letza21234z12zz__evaluate_uncompz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_exprz00zz__evaluate_typesz00;
	extern obj_t bstring_to_keyword(obj_t);
	static obj_t BGl_z62uncompzd2ev_letrec1236zb0zz__evaluate_uncompz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_setlocalz00zz__evaluate_typesz00;
	static obj_t *__cnst;


	   
		 
		DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2034z00zz__evaluate_uncompz00,
		BgL_bgl_za762uncomp1199za7622097z00,
		BGl_z62uncomp1199z62zz__evaluate_uncompz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2039z00zz__evaluate_uncompz00,
		BgL_bgl_za762uncompza7d2ev_v2098z00,
		BGl_z62uncompzd2ev_var1202zb0zz__evaluate_uncompz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2041z00zz__evaluate_uncompz00,
		BgL_bgl_za762uncompza7d2ev_g2099z00,
		BGl_z62uncompzd2ev_global1204zb0zz__evaluate_uncompz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2042z00zz__evaluate_uncompz00,
		BgL_bgl_za762uncompza7d2ev_l2100z00,
		BGl_z62uncompzd2ev_litt1206zb0zz__evaluate_uncompz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2043z00zz__evaluate_uncompz00,
		BgL_bgl_za762uncompza7d2ev_i2101z00,
		BGl_z62uncompzd2ev_if1208zb0zz__evaluate_uncompz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2044z00zz__evaluate_uncompz00,
		BgL_bgl_za762uncompza7d2ev_o2102z00,
		BGl_z62uncompzd2ev_or1210zb0zz__evaluate_uncompz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2045z00zz__evaluate_uncompz00,
		BgL_bgl_za762uncompza7d2ev_a2103z00,
		BGl_z62uncompzd2ev_and1212zb0zz__evaluate_uncompz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2046z00zz__evaluate_uncompz00,
		BgL_bgl_za762uncompza7d2ev_p2104z00,
		BGl_z62uncompzd2ev_prog21214zb0zz__evaluate_uncompz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2047z00zz__evaluate_uncompz00,
		BgL_bgl_za762uncompza7d2ev_t2105z00,
		BGl_z62uncompzd2ev_trap1216zb0zz__evaluate_uncompz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2048z00zz__evaluate_uncompz00,
		BgL_bgl_za762uncompza7d2ev_s2106z00,
		BGl_z62uncompzd2ev_setglobal1218zb0zz__evaluate_uncompz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2049z00zz__evaluate_uncompz00,
		BgL_bgl_za762uncompza7d2ev_d2107z00,
		BGl_z62uncompzd2ev_defglobal1220zb0zz__evaluate_uncompz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2050z00zz__evaluate_uncompz00,
		BgL_bgl_za762uncompza7d2ev_s2108z00,
		BGl_z62uncompzd2ev_setlocal1222zb0zz__evaluate_uncompz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2051z00zz__evaluate_uncompz00,
		BgL_bgl_za762uncompza7d2ev_b2109z00,
		BGl_z62uncompzd2ev_bindzd2exit1224z62zz__evaluate_uncompz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2052z00zz__evaluate_uncompz00,
		BgL_bgl_za762uncompza7d2ev_u2110z00,
		BGl_z62uncompzd2ev_unwindzd2pro1226z62zz__evaluate_uncompz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2053z00zz__evaluate_uncompz00,
		BgL_bgl_za762uncompza7d2ev_w2111z00,
		BGl_z62uncompzd2ev_withzd2handl1228z62zz__evaluate_uncompz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2054z00zz__evaluate_uncompz00,
		BgL_bgl_za762uncompza7d2ev_s2112z00,
		BGl_z62uncompzd2ev_synchroniza71230z17zz__evaluate_uncompz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2055z00zz__evaluate_uncompz00,
		BgL_bgl_za762uncompza7d2ev_l2113z00,
		BGl_z62uncompzd2ev_let1232zb0zz__evaluate_uncompz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2056z00zz__evaluate_uncompz00,
		BgL_bgl_za762uncompza7d2ev_l2114z00,
		BGl_z62uncompzd2ev_letza21234z12zz__evaluate_uncompz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2057z00zz__evaluate_uncompz00,
		BgL_bgl_za762uncompza7d2ev_l2115z00,
		BGl_z62uncompzd2ev_letrec1236zb0zz__evaluate_uncompz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2058z00zz__evaluate_uncompz00,
		BgL_bgl_za762uncompza7d2ev_l2116z00,
		BGl_z62uncompzd2ev_labels1238zb0zz__evaluate_uncompz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2059z00zz__evaluate_uncompz00,
		BgL_bgl_za762uncompza7d2ev_g2117z00,
		BGl_z62uncompzd2ev_goto1240zb0zz__evaluate_uncompz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2060z00zz__evaluate_uncompz00,
		BgL_bgl_za762uncompza7d2ev_a2118z00,
		BGl_z62uncompzd2ev_app1242zb0zz__evaluate_uncompz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2061z00zz__evaluate_uncompz00,
		BgL_bgl_za762uncompza7d2ev_a2119z00,
		BGl_z62uncompzd2ev_abs1244zb0zz__evaluate_uncompz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_GENERIC(BGl_uncompzd2envzd2zz__evaluate_uncompz00,
		BgL_bgl_za762uncompza762za7za7__2120z00,
		BGl_z62uncompz62zz__evaluate_uncompz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2031z00zz__evaluate_uncompz00,
		BgL_bgl_string2031za700za7za7_2121za7,
		"/tmp/bigloo/runtime/Eval/evaluate_uncomp.scm", 44);
	      DEFINE_STRING(BGl_string2032z00zz__evaluate_uncompz00,
		BgL_bgl_string2032za700za7za7_2122za7, "&uncompile", 10);
	      DEFINE_STRING(BGl_string2033z00zz__evaluate_uncompz00,
		BgL_bgl_string2033za700za7za7_2123za7, "ev_expr", 7);
	      DEFINE_STRING(BGl_string2035z00zz__evaluate_uncompz00,
		BgL_bgl_string2035za700za7za7_2124za7, "uncomp1199", 10);
	      DEFINE_STRING(BGl_string2037z00zz__evaluate_uncompz00,
		BgL_bgl_string2037za700za7za7_2125za7, "No method for this object", 25);
	      DEFINE_STRING(BGl_string2038z00zz__evaluate_uncompz00,
		BgL_bgl_string2038za700za7za7_2126za7, "&uncomp", 7);
	      DEFINE_STRING(BGl_string2040z00zz__evaluate_uncompz00,
		BgL_bgl_string2040za700za7za7_2127za7, "uncomp", 6);
	      DEFINE_STRING(BGl_string2063z00zz__evaluate_uncompz00,
		BgL_bgl_string2063za700za7za7_2128za7, "lambda", 6);
	      DEFINE_STRING(BGl_string2065z00zz__evaluate_uncompz00,
		BgL_bgl_string2065za700za7za7_2129za7, "letrec", 6);
	      DEFINE_STRING(BGl_string2067z00zz__evaluate_uncompz00,
		BgL_bgl_string2067za700za7za7_2130za7, "let*", 4);
	      DEFINE_STRING(BGl_string2069z00zz__evaluate_uncompz00,
		BgL_bgl_string2069za700za7za7_2131za7, "let", 3);
	      DEFINE_STRING(BGl_string2071z00zz__evaluate_uncompz00,
		BgL_bgl_string2071za700za7za7_2132za7, "prelock", 7);
	      DEFINE_STRING(BGl_string2073z00zz__evaluate_uncompz00,
		BgL_bgl_string2073za700za7za7_2133za7, "synchronize", 11);
	      DEFINE_STRING(BGl_string2075z00zz__evaluate_uncompz00,
		BgL_bgl_string2075za700za7za7_2134za7, "with-handler", 12);
	      DEFINE_STRING(BGl_string2077z00zz__evaluate_uncompz00,
		BgL_bgl_string2077za700za7za7_2135za7, "unwind-protect", 14);
	      DEFINE_STRING(BGl_string2079z00zz__evaluate_uncompz00,
		BgL_bgl_string2079za700za7za7_2136za7, "bind-exit", 9);
	      DEFINE_STRING(BGl_string2081z00zz__evaluate_uncompz00,
		BgL_bgl_string2081za700za7za7_2137za7, "set!", 4);
	      DEFINE_STRING(BGl_string2083z00zz__evaluate_uncompz00,
		BgL_bgl_string2083za700za7za7_2138za7, "define", 6);
	      DEFINE_STRING(BGl_string2085z00zz__evaluate_uncompz00,
		BgL_bgl_string2085za700za7za7_2139za7, "trap", 4);
	      DEFINE_STRING(BGl_string2087z00zz__evaluate_uncompz00,
		BgL_bgl_string2087za700za7za7_2140za7, "begin", 5);
	      DEFINE_STRING(BGl_string2089z00zz__evaluate_uncompz00,
		BgL_bgl_string2089za700za7za7_2141za7, "and", 3);
	      DEFINE_STRING(BGl_string2091z00zz__evaluate_uncompz00,
		BgL_bgl_string2091za700za7za7_2142za7, "or", 2);
	      DEFINE_STRING(BGl_string2093z00zz__evaluate_uncompz00,
		BgL_bgl_string2093za700za7za7_2143za7, "if", 2);
	      DEFINE_STRING(BGl_string2095z00zz__evaluate_uncompz00,
		BgL_bgl_string2095za700za7za7_2144za7, "quote", 5);
	      DEFINE_STRING(BGl_string2096z00zz__evaluate_uncompz00,
		BgL_bgl_string2096za700za7za7_2145za7, "__evaluate_uncomp", 17);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_uncompilezd2envzd2zz__evaluate_uncompz00,
		BgL_bgl_za762uncompileza762za72146za7,
		BGl_z62uncompilez62zz__evaluate_uncompz00, 0L, BUNSPEC, 1);

/* GC roots registration */
	static obj_t bgl_gc_roots_register()
	{
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
		void *roots_min = (void *) ULONG_MAX, *roots_max = 0;
		     ADD_ROOT((void *) (&BGl_keyword2070z00zz__evaluate_uncompz00));
		     ADD_ROOT((void *) (&BGl_symbol2036z00zz__evaluate_uncompz00));
		     ADD_ROOT((void *) (&BGl_symbol2062z00zz__evaluate_uncompz00));
		     ADD_ROOT((void *) (&BGl_symbol2064z00zz__evaluate_uncompz00));
		     ADD_ROOT((void *) (&BGl_symbol2066z00zz__evaluate_uncompz00));
		     ADD_ROOT((void *) (&BGl_symbol2068z00zz__evaluate_uncompz00));
		     ADD_ROOT((void *) (&BGl_symbol2072z00zz__evaluate_uncompz00));
		     ADD_ROOT((void *) (&BGl_symbol2074z00zz__evaluate_uncompz00));
		     ADD_ROOT((void *) (&BGl_symbol2076z00zz__evaluate_uncompz00));
		     ADD_ROOT((void *) (&BGl_symbol2078z00zz__evaluate_uncompz00));
		     ADD_ROOT((void *) (&BGl_symbol2080z00zz__evaluate_uncompz00));
		     ADD_ROOT((void *) (&BGl_symbol2082z00zz__evaluate_uncompz00));
		     ADD_ROOT((void *) (&BGl_symbol2084z00zz__evaluate_uncompz00));
		     ADD_ROOT((void *) (&BGl_symbol2086z00zz__evaluate_uncompz00));
		     ADD_ROOT((void *) (&BGl_symbol2088z00zz__evaluate_uncompz00));
		     ADD_ROOT((void *) (&BGl_symbol2090z00zz__evaluate_uncompz00));
		     ADD_ROOT((void *) (&BGl_symbol2092z00zz__evaluate_uncompz00));
		     ADD_ROOT((void *) (&BGl_symbol2094z00zz__evaluate_uncompz00));
		   
			 ADD_ROOT((void
				*) (&BGl_requirezd2initializa7ationz75zz__evaluate_uncompz00));
#undef ADD_ROOT
		if   (roots_max > 0)
			     GC_add_roots(roots_min, ((void **) roots_max) + 1);
#endif
		     return BUNSPEC;
	}



/* module-initialization */
	BGL_EXPORTED_DEF obj_t
		BGl_modulezd2initializa7ationz75zz__evaluate_uncompz00(long
		BgL_checksumz00_2923, char *BgL_fromz00_2924)
	{
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zz__evaluate_uncompz00))
				{
					BGl_requirezd2initializa7ationz75zz__evaluate_uncompz00 =
						BBOOL(((bool_t) 0));
					BGl_gczd2rootszd2initz00zz__evaluate_uncompz00();
					BGl_cnstzd2initzd2zz__evaluate_uncompz00();
					BGl_importedzd2moduleszd2initz00zz__evaluate_uncompz00();
					BGl_genericzd2initzd2zz__evaluate_uncompz00();
					BGl_methodzd2initzd2zz__evaluate_uncompz00();
					return BGl_toplevelzd2initzd2zz__evaluate_uncompz00();
				}
			else
				{
					return BUNSPEC;
				}
		}

	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zz__evaluate_uncompz00()
	{
		{	/* Eval/evaluate_uncomp.scm 15 */
			BGl_symbol2036z00zz__evaluate_uncompz00 =
				bstring_to_symbol(BGl_string2035z00zz__evaluate_uncompz00);
			BGl_symbol2062z00zz__evaluate_uncompz00 =
				bstring_to_symbol(BGl_string2063z00zz__evaluate_uncompz00);
			BGl_symbol2064z00zz__evaluate_uncompz00 =
				bstring_to_symbol(BGl_string2065z00zz__evaluate_uncompz00);
			BGl_symbol2066z00zz__evaluate_uncompz00 =
				bstring_to_symbol(BGl_string2067z00zz__evaluate_uncompz00);
			BGl_symbol2068z00zz__evaluate_uncompz00 =
				bstring_to_symbol(BGl_string2069z00zz__evaluate_uncompz00);
			BGl_keyword2070z00zz__evaluate_uncompz00 =
				bstring_to_keyword(BGl_string2071z00zz__evaluate_uncompz00);
			BGl_symbol2072z00zz__evaluate_uncompz00 =
				bstring_to_symbol(BGl_string2073z00zz__evaluate_uncompz00);
			BGl_symbol2074z00zz__evaluate_uncompz00 =
				bstring_to_symbol(BGl_string2075z00zz__evaluate_uncompz00);
			BGl_symbol2076z00zz__evaluate_uncompz00 =
				bstring_to_symbol(BGl_string2077z00zz__evaluate_uncompz00);
			BGl_symbol2078z00zz__evaluate_uncompz00 =
				bstring_to_symbol(BGl_string2079z00zz__evaluate_uncompz00);
			BGl_symbol2080z00zz__evaluate_uncompz00 =
				bstring_to_symbol(BGl_string2081z00zz__evaluate_uncompz00);
			BGl_symbol2082z00zz__evaluate_uncompz00 =
				bstring_to_symbol(BGl_string2083z00zz__evaluate_uncompz00);
			BGl_symbol2084z00zz__evaluate_uncompz00 =
				bstring_to_symbol(BGl_string2085z00zz__evaluate_uncompz00);
			BGl_symbol2086z00zz__evaluate_uncompz00 =
				bstring_to_symbol(BGl_string2087z00zz__evaluate_uncompz00);
			BGl_symbol2088z00zz__evaluate_uncompz00 =
				bstring_to_symbol(BGl_string2089z00zz__evaluate_uncompz00);
			BGl_symbol2090z00zz__evaluate_uncompz00 =
				bstring_to_symbol(BGl_string2091z00zz__evaluate_uncompz00);
			BGl_symbol2092z00zz__evaluate_uncompz00 =
				bstring_to_symbol(BGl_string2093z00zz__evaluate_uncompz00);
			return (BGl_symbol2094z00zz__evaluate_uncompz00 =
				bstring_to_symbol(BGl_string2095z00zz__evaluate_uncompz00), BUNSPEC);
		}

	}



/* gc-roots-init */
	obj_t BGl_gczd2rootszd2initz00zz__evaluate_uncompz00()
	{
		{	/* Eval/evaluate_uncomp.scm 15 */
			return bgl_gc_roots_register();
		}

	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zz__evaluate_uncompz00()
	{
		{	/* Eval/evaluate_uncomp.scm 15 */
			return BUNSPEC;
		}

	}



/* uncompile */
	BGL_EXPORTED_DEF obj_t
		BGl_uncompilez00zz__evaluate_uncompz00(BgL_ev_exprz00_bglt BgL_ez00_3)
	{
		{	/* Eval/evaluate_uncomp.scm 62 */
			return BGl_uncompz00zz__evaluate_uncompz00(BgL_ez00_3);
		}

	}



/* &uncompile */
	obj_t BGl_z62uncompilez62zz__evaluate_uncompz00(obj_t BgL_envz00_2581,
		obj_t BgL_ez00_2582)
	{
		{	/* Eval/evaluate_uncomp.scm 62 */
			{	/* Eval/evaluate_uncomp.scm 63 */
				BgL_ev_exprz00_bglt BgL_auxz00_2954;

				if (BGl_isazf3zf3zz__objectz00(BgL_ez00_2582,
						BGl_ev_exprz00zz__evaluate_typesz00))
					{	/* Eval/evaluate_uncomp.scm 63 */
						BgL_auxz00_2954 = ((BgL_ev_exprz00_bglt) BgL_ez00_2582);
					}
				else
					{
						obj_t BgL_auxz00_2958;

						BgL_auxz00_2958 =
							BGl_typezd2errorzd2zz__errorz00
							(BGl_string2031z00zz__evaluate_uncompz00, BINT(((long) 1816)),
							BGl_string2032z00zz__evaluate_uncompz00,
							BGl_string2033z00zz__evaluate_uncompz00, BgL_ez00_2582);
						FAILURE(BgL_auxz00_2958, BFALSE, BFALSE);
					}
				return BGl_uncompilez00zz__evaluate_uncompz00(BgL_auxz00_2954);
			}
		}

	}



/* object-init */
	obj_t BGl_objectzd2initzd2zz__evaluate_uncompz00()
	{
		{	/* Eval/evaluate_uncomp.scm 15 */
			return BUNSPEC;
		}

	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zz__evaluate_uncompz00()
	{
		{	/* Eval/evaluate_uncomp.scm 15 */
			return
				BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_uncompzd2envzd2zz__evaluate_uncompz00,
				BGl_proc2034z00zz__evaluate_uncompz00,
				BGl_ev_exprz00zz__evaluate_typesz00,
				BGl_string2035z00zz__evaluate_uncompz00);
		}

	}



/* &uncomp1199 */
	obj_t BGl_z62uncomp1199z62zz__evaluate_uncompz00(obj_t BgL_envz00_2584,
		obj_t BgL_ez00_2585)
	{
		{	/* Eval/evaluate_uncomp.scm 65 */
			return
				BGl_errorz00zz__errorz00(BGl_symbol2036z00zz__evaluate_uncompz00,
				BGl_string2037z00zz__evaluate_uncompz00,
				((obj_t) ((BgL_ev_exprz00_bglt) BgL_ez00_2585)));
		}

	}



/* uncomp */
	obj_t BGl_uncompz00zz__evaluate_uncompz00(BgL_ev_exprz00_bglt BgL_ez00_4)
	{
		{	/* Eval/evaluate_uncomp.scm 65 */
			{	/* Eval/evaluate_uncomp.scm 65 */
				obj_t BgL_method1200z00_1100;

				{	/* Eval/evaluate_uncomp.scm 65 */
					obj_t BgL_res1880z00_1946;

					{	/* Eval/evaluate_uncomp.scm 65 */
						long BgL_objzd2classzd2numz00_1911;

						{	/* Eval/evaluate_uncomp.scm 65 */
							long BgL_res1870z00_1914;

							BgL_res1870z00_1914 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_ez00_4));
							BgL_objzd2classzd2numz00_1911 = BgL_res1870z00_1914;
						}
						{	/* Eval/evaluate_uncomp.scm 65 */
							obj_t BgL_arg1859z00_1912;

							BgL_arg1859z00_1912 =
								PROCEDURE_REF(BGl_uncompzd2envzd2zz__evaluate_uncompz00,
								(int) (((long) 1)));
							{	/* Eval/evaluate_uncomp.scm 65 */
								int BgL_offsetz00_1916;

								BgL_offsetz00_1916 = (int) (BgL_objzd2classzd2numz00_1911);
								{	/* Eval/evaluate_uncomp.scm 65 */
									long BgL_offsetz00_1917;

									BgL_offsetz00_1917 =
										((long) (BgL_offsetz00_1916) - OBJECT_TYPE);
									{	/* Eval/evaluate_uncomp.scm 65 */
										long BgL_modz00_1918;

										BgL_modz00_1918 =
											(BgL_offsetz00_1917 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Eval/evaluate_uncomp.scm 65 */
											long BgL_restz00_1920;

											BgL_restz00_1920 =
												(BgL_offsetz00_1917 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Eval/evaluate_uncomp.scm 65 */

												{	/* Eval/evaluate_uncomp.scm 65 */
													obj_t BgL_bucketz00_1922;

													BgL_bucketz00_1922 =
														VECTOR_REF(
														((obj_t) BgL_arg1859z00_1912), BgL_modz00_1918);
													BgL_res1880z00_1946 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_1922), BgL_restz00_1920);
					}}}}}}}}
					BgL_method1200z00_1100 = BgL_res1880z00_1946;
				}
				return
					PROCEDURE_ENTRY(BgL_method1200z00_1100) (BgL_method1200z00_1100,
					((obj_t) BgL_ez00_4), BEOA);
			}
		}

	}



/* &uncomp */
	obj_t BGl_z62uncompz62zz__evaluate_uncompz00(obj_t BgL_envz00_2586,
		obj_t BgL_ez00_2587)
	{
		{	/* Eval/evaluate_uncomp.scm 65 */
			{	/* Eval/evaluate_uncomp.scm 65 */
				BgL_ev_exprz00_bglt BgL_auxz00_2997;

				if (BGl_isazf3zf3zz__objectz00(BgL_ez00_2587,
						BGl_ev_exprz00zz__evaluate_typesz00))
					{	/* Eval/evaluate_uncomp.scm 65 */
						BgL_auxz00_2997 = ((BgL_ev_exprz00_bglt) BgL_ez00_2587);
					}
				else
					{
						obj_t BgL_auxz00_3001;

						BgL_auxz00_3001 =
							BGl_typezd2errorzd2zz__errorz00
							(BGl_string2031z00zz__evaluate_uncompz00, BINT(((long) 1830)),
							BGl_string2038z00zz__evaluate_uncompz00,
							BGl_string2033z00zz__evaluate_uncompz00, BgL_ez00_2587);
						FAILURE(BgL_auxz00_3001, BFALSE, BFALSE);
					}
				return BGl_uncompz00zz__evaluate_uncompz00(BgL_auxz00_2997);
			}
		}

	}



/* method-init */
	obj_t BGl_methodzd2initzd2zz__evaluate_uncompz00()
	{
		{	/* Eval/evaluate_uncomp.scm 15 */
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_uncompzd2envzd2zz__evaluate_uncompz00,
				BGl_ev_varz00zz__evaluate_typesz00,
				BGl_proc2039z00zz__evaluate_uncompz00,
				BGl_string2040z00zz__evaluate_uncompz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_uncompzd2envzd2zz__evaluate_uncompz00,
				BGl_ev_globalz00zz__evaluate_typesz00,
				BGl_proc2041z00zz__evaluate_uncompz00,
				BGl_string2040z00zz__evaluate_uncompz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_uncompzd2envzd2zz__evaluate_uncompz00,
				BGl_ev_littz00zz__evaluate_typesz00,
				BGl_proc2042z00zz__evaluate_uncompz00,
				BGl_string2040z00zz__evaluate_uncompz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_uncompzd2envzd2zz__evaluate_uncompz00,
				BGl_ev_ifz00zz__evaluate_typesz00,
				BGl_proc2043z00zz__evaluate_uncompz00,
				BGl_string2040z00zz__evaluate_uncompz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_uncompzd2envzd2zz__evaluate_uncompz00,
				BGl_ev_orz00zz__evaluate_typesz00,
				BGl_proc2044z00zz__evaluate_uncompz00,
				BGl_string2040z00zz__evaluate_uncompz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_uncompzd2envzd2zz__evaluate_uncompz00,
				BGl_ev_andz00zz__evaluate_typesz00,
				BGl_proc2045z00zz__evaluate_uncompz00,
				BGl_string2040z00zz__evaluate_uncompz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_uncompzd2envzd2zz__evaluate_uncompz00,
				BGl_ev_prog2z00zz__evaluate_typesz00,
				BGl_proc2046z00zz__evaluate_uncompz00,
				BGl_string2040z00zz__evaluate_uncompz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_uncompzd2envzd2zz__evaluate_uncompz00,
				BGl_ev_trapz00zz__evaluate_typesz00,
				BGl_proc2047z00zz__evaluate_uncompz00,
				BGl_string2040z00zz__evaluate_uncompz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_uncompzd2envzd2zz__evaluate_uncompz00,
				BGl_ev_setglobalz00zz__evaluate_typesz00,
				BGl_proc2048z00zz__evaluate_uncompz00,
				BGl_string2040z00zz__evaluate_uncompz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_uncompzd2envzd2zz__evaluate_uncompz00,
				BGl_ev_defglobalz00zz__evaluate_typesz00,
				BGl_proc2049z00zz__evaluate_uncompz00,
				BGl_string2040z00zz__evaluate_uncompz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_uncompzd2envzd2zz__evaluate_uncompz00,
				BGl_ev_setlocalz00zz__evaluate_typesz00,
				BGl_proc2050z00zz__evaluate_uncompz00,
				BGl_string2040z00zz__evaluate_uncompz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_uncompzd2envzd2zz__evaluate_uncompz00,
				BGl_ev_bindzd2exitzd2zz__evaluate_typesz00,
				BGl_proc2051z00zz__evaluate_uncompz00,
				BGl_string2040z00zz__evaluate_uncompz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_uncompzd2envzd2zz__evaluate_uncompz00,
				BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00,
				BGl_proc2052z00zz__evaluate_uncompz00,
				BGl_string2040z00zz__evaluate_uncompz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_uncompzd2envzd2zz__evaluate_uncompz00,
				BGl_ev_withzd2handlerzd2zz__evaluate_typesz00,
				BGl_proc2053z00zz__evaluate_uncompz00,
				BGl_string2040z00zz__evaluate_uncompz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_uncompzd2envzd2zz__evaluate_uncompz00,
				BGl_ev_synchroniza7eza7zz__evaluate_typesz00,
				BGl_proc2054z00zz__evaluate_uncompz00,
				BGl_string2040z00zz__evaluate_uncompz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_uncompzd2envzd2zz__evaluate_uncompz00,
				BGl_ev_letz00zz__evaluate_typesz00,
				BGl_proc2055z00zz__evaluate_uncompz00,
				BGl_string2040z00zz__evaluate_uncompz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_uncompzd2envzd2zz__evaluate_uncompz00,
				BGl_ev_letza2za2zz__evaluate_typesz00,
				BGl_proc2056z00zz__evaluate_uncompz00,
				BGl_string2040z00zz__evaluate_uncompz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_uncompzd2envzd2zz__evaluate_uncompz00,
				BGl_ev_letrecz00zz__evaluate_typesz00,
				BGl_proc2057z00zz__evaluate_uncompz00,
				BGl_string2040z00zz__evaluate_uncompz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_uncompzd2envzd2zz__evaluate_uncompz00,
				BGl_ev_labelsz00zz__evaluate_typesz00,
				BGl_proc2058z00zz__evaluate_uncompz00,
				BGl_string2040z00zz__evaluate_uncompz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_uncompzd2envzd2zz__evaluate_uncompz00,
				BGl_ev_gotoz00zz__evaluate_typesz00,
				BGl_proc2059z00zz__evaluate_uncompz00,
				BGl_string2040z00zz__evaluate_uncompz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_uncompzd2envzd2zz__evaluate_uncompz00,
				BGl_ev_appz00zz__evaluate_typesz00,
				BGl_proc2060z00zz__evaluate_uncompz00,
				BGl_string2040z00zz__evaluate_uncompz00);
			return
				BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_uncompzd2envzd2zz__evaluate_uncompz00,
				BGl_ev_absz00zz__evaluate_typesz00,
				BGl_proc2061z00zz__evaluate_uncompz00,
				BGl_string2040z00zz__evaluate_uncompz00);
		}

	}



/* &uncomp-ev_abs1244 */
	obj_t BGl_z62uncompzd2ev_abs1244zb0zz__evaluate_uncompz00(obj_t
		BgL_envz00_2610, obj_t BgL_ez00_2611)
	{
		{	/* Eval/evaluate_uncomp.scm 157 */
			{	/* Eval/evaluate_uncomp.scm 166 */
				obj_t BgL_arg1503z00_2664;

				{	/* Eval/evaluate_uncomp.scm 166 */
					obj_t BgL_arg1504z00_2665;
					obj_t BgL_arg1505z00_2666;

					{	/* Eval/evaluate_uncomp.scm 166 */
						obj_t BgL_arg1506z00_2667;
						obj_t BgL_arg1507z00_2668;

						BgL_arg1506z00_2667 =
							(((BgL_ev_absz00_bglt) COBJECT(
									((BgL_ev_absz00_bglt) BgL_ez00_2611)))->BgL_arityz00);
						{	/* Eval/evaluate_uncomp.scm 166 */
							obj_t BgL_l1181z00_2669;

							BgL_l1181z00_2669 =
								(((BgL_ev_absz00_bglt) COBJECT(
										((BgL_ev_absz00_bglt) BgL_ez00_2611)))->BgL_varsz00);
							if (NULLP(BgL_l1181z00_2669))
								{	/* Eval/evaluate_uncomp.scm 166 */
									BgL_arg1507z00_2668 = BNIL;
								}
							else
								{	/* Eval/evaluate_uncomp.scm 166 */
									obj_t BgL_head1183z00_2670;

									{	/* Eval/evaluate_uncomp.scm 166 */
										obj_t BgL_res1945z00_2671;

										BgL_res1945z00_2671 = MAKE_YOUNG_PAIR(BNIL, BNIL);
										BgL_head1183z00_2670 = BgL_res1945z00_2671;
									}
									{
										obj_t BgL_l1181z00_2673;
										obj_t BgL_tail1184z00_2674;

										BgL_l1181z00_2673 = BgL_l1181z00_2669;
										BgL_tail1184z00_2674 = BgL_head1183z00_2670;
									BgL_zc3z04anonymousza31509ze3z87_2672:
										if (NULLP(BgL_l1181z00_2673))
											{	/* Eval/evaluate_uncomp.scm 166 */
												BgL_arg1507z00_2668 = CDR(BgL_head1183z00_2670);
											}
										else
											{	/* Eval/evaluate_uncomp.scm 166 */
												obj_t BgL_newtail1185z00_2675;

												{	/* Eval/evaluate_uncomp.scm 166 */
													obj_t BgL_arg1514z00_2676;

													BgL_arg1514z00_2676 =
														(((BgL_ev_varz00_bglt) COBJECT(
																((BgL_ev_varz00_bglt)
																	CAR(
																		((obj_t) BgL_l1181z00_2673)))))->
														BgL_namez00);
													{	/* Eval/evaluate_uncomp.scm 166 */
														obj_t BgL_res1951z00_2677;

														BgL_res1951z00_2677 =
															MAKE_YOUNG_PAIR(BgL_arg1514z00_2676, BNIL);
														BgL_newtail1185z00_2675 = BgL_res1951z00_2677;
													}
												}
												SET_CDR(BgL_tail1184z00_2674, BgL_newtail1185z00_2675);
												{	/* Eval/evaluate_uncomp.scm 166 */
													obj_t BgL_arg1512z00_2678;

													BgL_arg1512z00_2678 =
														CDR(((obj_t) BgL_l1181z00_2673));
													{
														obj_t BgL_tail1184z00_3047;
														obj_t BgL_l1181z00_3046;

														BgL_l1181z00_3046 = BgL_arg1512z00_2678;
														BgL_tail1184z00_3047 = BgL_newtail1185z00_2675;
														BgL_tail1184z00_2674 = BgL_tail1184z00_3047;
														BgL_l1181z00_2673 = BgL_l1181z00_3046;
														goto BgL_zc3z04anonymousza31509ze3z87_2672;
													}
												}
											}
									}
								}
						}
						BgL_arg1504z00_2665 =
							BGl_redovarsze70ze7zz__evaluate_uncompz00(BgL_arg1506z00_2667,
							BgL_arg1507z00_2668);
					}
					BgL_arg1505z00_2666 =
						MAKE_YOUNG_PAIR(BGl_uncompz00zz__evaluate_uncompz00(
							(((BgL_ev_absz00_bglt) COBJECT(
										((BgL_ev_absz00_bglt) BgL_ez00_2611)))->BgL_bodyz00)),
						BNIL);
					BgL_arg1503z00_2664 =
						MAKE_YOUNG_PAIR(BgL_arg1504z00_2665, BgL_arg1505z00_2666);
				}
				return
					MAKE_YOUNG_PAIR(BGl_symbol2062z00zz__evaluate_uncompz00,
					BgL_arg1503z00_2664);
			}
		}

	}



/* rec~0 */
	obj_t BGl_recze70ze7zz__evaluate_uncompz00(obj_t BgL_lz00_1507)
	{
		{	/* Eval/evaluate_uncomp.scm 162 */
			if (NULLP(CDR(((obj_t) BgL_lz00_1507))))
				{	/* Eval/evaluate_uncomp.scm 163 */
					return CAR(((obj_t) BgL_lz00_1507));
				}
			else
				{	/* Eval/evaluate_uncomp.scm 165 */
					obj_t BgL_arg1523z00_1511;
					obj_t BgL_arg1524z00_1512;

					BgL_arg1523z00_1511 = CAR(((obj_t) BgL_lz00_1507));
					{	/* Eval/evaluate_uncomp.scm 165 */
						obj_t BgL_arg1527z00_1513;

						BgL_arg1527z00_1513 = CDR(((obj_t) BgL_lz00_1507));
						BgL_arg1524z00_1512 =
							BGl_recze70ze7zz__evaluate_uncompz00(BgL_arg1527z00_1513);
					}
					return MAKE_YOUNG_PAIR(BgL_arg1523z00_1511, BgL_arg1524z00_1512);
				}
		}

	}



/* redovars~0 */
	obj_t BGl_redovarsze70ze7zz__evaluate_uncompz00(obj_t BgL_nz00_1502,
		obj_t BgL_lz00_1503)
	{
		{	/* Eval/evaluate_uncomp.scm 165 */
			if (((long) CINT(BgL_nz00_1502) >= ((long) 0)))
				{	/* Eval/evaluate_uncomp.scm 160 */
					return BgL_lz00_1503;
				}
			else
				{	/* Eval/evaluate_uncomp.scm 160 */
					return BGl_recze70ze7zz__evaluate_uncompz00(BgL_lz00_1503);
				}
		}

	}



/* &uncomp-ev_app1242 */
	obj_t BGl_z62uncompzd2ev_app1242zb0zz__evaluate_uncompz00(obj_t
		BgL_envz00_2612, obj_t BgL_ez00_2613)
	{
		{	/* Eval/evaluate_uncomp.scm 153 */
			{	/* Eval/evaluate_uncomp.scm 155 */
				obj_t BgL_arg1488z00_2680;
				obj_t BgL_arg1489z00_2681;

				BgL_arg1488z00_2680 =
					BGl_uncompz00zz__evaluate_uncompz00(
					(((BgL_ev_appz00_bglt) COBJECT(
								((BgL_ev_appz00_bglt) BgL_ez00_2613)))->BgL_funz00));
				{	/* Eval/evaluate_uncomp.scm 155 */
					obj_t BgL_arg1491z00_2682;

					{	/* Eval/evaluate_uncomp.scm 155 */
						obj_t BgL_l1175z00_2683;

						BgL_l1175z00_2683 =
							(((BgL_ev_appz00_bglt) COBJECT(
									((BgL_ev_appz00_bglt) BgL_ez00_2613)))->BgL_argsz00);
						if (NULLP(BgL_l1175z00_2683))
							{	/* Eval/evaluate_uncomp.scm 155 */
								BgL_arg1491z00_2682 = BNIL;
							}
						else
							{	/* Eval/evaluate_uncomp.scm 155 */
								obj_t BgL_head1177z00_2684;

								{	/* Eval/evaluate_uncomp.scm 155 */
									obj_t BgL_arg1500z00_2685;

									{	/* Eval/evaluate_uncomp.scm 155 */
										obj_t BgL_arg1502z00_2686;

										BgL_arg1502z00_2686 = CAR(((obj_t) BgL_l1175z00_2683));
										BgL_arg1500z00_2685 =
											BGl_uncompz00zz__evaluate_uncompz00(
											((BgL_ev_exprz00_bglt) BgL_arg1502z00_2686));
									}
									{	/* Eval/evaluate_uncomp.scm 155 */
										obj_t BgL_res1935z00_2687;

										BgL_res1935z00_2687 =
											MAKE_YOUNG_PAIR(BgL_arg1500z00_2685, BNIL);
										BgL_head1177z00_2684 = BgL_res1935z00_2687;
									}
								}
								{	/* Eval/evaluate_uncomp.scm 155 */
									obj_t BgL_g1180z00_2688;

									BgL_g1180z00_2688 = CDR(((obj_t) BgL_l1175z00_2683));
									{
										obj_t BgL_l1175z00_2690;
										obj_t BgL_tail1178z00_2691;

										BgL_l1175z00_2690 = BgL_g1180z00_2688;
										BgL_tail1178z00_2691 = BgL_head1177z00_2684;
									BgL_zc3z04anonymousza31493ze3z87_2689:
										if (NULLP(BgL_l1175z00_2690))
											{	/* Eval/evaluate_uncomp.scm 155 */
												BgL_arg1491z00_2682 = BgL_head1177z00_2684;
											}
										else
											{	/* Eval/evaluate_uncomp.scm 155 */
												obj_t BgL_newtail1179z00_2692;

												{	/* Eval/evaluate_uncomp.scm 155 */
													obj_t BgL_arg1497z00_2693;

													{	/* Eval/evaluate_uncomp.scm 155 */
														obj_t BgL_arg1499z00_2694;

														BgL_arg1499z00_2694 =
															CAR(((obj_t) BgL_l1175z00_2690));
														BgL_arg1497z00_2693 =
															BGl_uncompz00zz__evaluate_uncompz00(
															((BgL_ev_exprz00_bglt) BgL_arg1499z00_2694));
													}
													{	/* Eval/evaluate_uncomp.scm 155 */
														obj_t BgL_res1941z00_2695;

														BgL_res1941z00_2695 =
															MAKE_YOUNG_PAIR(BgL_arg1497z00_2693, BNIL);
														BgL_newtail1179z00_2692 = BgL_res1941z00_2695;
													}
												}
												SET_CDR(BgL_tail1178z00_2691, BgL_newtail1179z00_2692);
												{	/* Eval/evaluate_uncomp.scm 155 */
													obj_t BgL_arg1496z00_2696;

													BgL_arg1496z00_2696 =
														CDR(((obj_t) BgL_l1175z00_2690));
													{
														obj_t BgL_tail1178z00_3096;
														obj_t BgL_l1175z00_3095;

														BgL_l1175z00_3095 = BgL_arg1496z00_2696;
														BgL_tail1178z00_3096 = BgL_newtail1179z00_2692;
														BgL_tail1178z00_2691 = BgL_tail1178z00_3096;
														BgL_l1175z00_2690 = BgL_l1175z00_3095;
														goto BgL_zc3z04anonymousza31493ze3z87_2689;
													}
												}
											}
									}
								}
							}
					}
					BgL_arg1489z00_2681 =
						BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_arg1491z00_2682,
						BNIL);
				}
				return MAKE_YOUNG_PAIR(BgL_arg1488z00_2680, BgL_arg1489z00_2681);
			}
		}

	}



/* &uncomp-ev_goto1240 */
	obj_t BGl_z62uncompzd2ev_goto1240zb0zz__evaluate_uncompz00(obj_t
		BgL_envz00_2614, obj_t BgL_ez00_2615)
	{
		{	/* Eval/evaluate_uncomp.scm 149 */
			{	/* Eval/evaluate_uncomp.scm 151 */
				obj_t BgL_arg1473z00_2698;
				obj_t BgL_arg1476z00_2699;

				{	/* Eval/evaluate_uncomp.scm 151 */
					BgL_ev_varz00_bglt BgL_arg1477z00_2700;

					BgL_arg1477z00_2700 =
						(((BgL_ev_gotoz00_bglt) COBJECT(
								((BgL_ev_gotoz00_bglt) BgL_ez00_2615)))->BgL_labelz00);
					BgL_arg1473z00_2698 =
						BGl_uncompz00zz__evaluate_uncompz00(
						((BgL_ev_exprz00_bglt) BgL_arg1477z00_2700));
				}
				{	/* Eval/evaluate_uncomp.scm 151 */
					obj_t BgL_arg1479z00_2701;

					{	/* Eval/evaluate_uncomp.scm 151 */
						obj_t BgL_l1169z00_2702;

						BgL_l1169z00_2702 =
							(((BgL_ev_gotoz00_bglt) COBJECT(
									((BgL_ev_gotoz00_bglt) BgL_ez00_2615)))->BgL_argsz00);
						if (NULLP(BgL_l1169z00_2702))
							{	/* Eval/evaluate_uncomp.scm 151 */
								BgL_arg1479z00_2701 = BNIL;
							}
						else
							{	/* Eval/evaluate_uncomp.scm 151 */
								obj_t BgL_head1171z00_2703;

								{	/* Eval/evaluate_uncomp.scm 151 */
									obj_t BgL_arg1486z00_2704;

									{	/* Eval/evaluate_uncomp.scm 151 */
										obj_t BgL_arg1487z00_2705;

										BgL_arg1487z00_2705 = CAR(((obj_t) BgL_l1169z00_2702));
										BgL_arg1486z00_2704 =
											BGl_uncompz00zz__evaluate_uncompz00(
											((BgL_ev_exprz00_bglt) BgL_arg1487z00_2705));
									}
									{	/* Eval/evaluate_uncomp.scm 151 */
										obj_t BgL_res1927z00_2706;

										BgL_res1927z00_2706 =
											MAKE_YOUNG_PAIR(BgL_arg1486z00_2704, BNIL);
										BgL_head1171z00_2703 = BgL_res1927z00_2706;
									}
								}
								{	/* Eval/evaluate_uncomp.scm 151 */
									obj_t BgL_g1174z00_2707;

									BgL_g1174z00_2707 = CDR(((obj_t) BgL_l1169z00_2702));
									{
										obj_t BgL_l1169z00_2709;
										obj_t BgL_tail1172z00_2710;

										BgL_l1169z00_2709 = BgL_g1174z00_2707;
										BgL_tail1172z00_2710 = BgL_head1171z00_2703;
									BgL_zc3z04anonymousza31481ze3z87_2708:
										if (NULLP(BgL_l1169z00_2709))
											{	/* Eval/evaluate_uncomp.scm 151 */
												BgL_arg1479z00_2701 = BgL_head1171z00_2703;
											}
										else
											{	/* Eval/evaluate_uncomp.scm 151 */
												obj_t BgL_newtail1173z00_2711;

												{	/* Eval/evaluate_uncomp.scm 151 */
													obj_t BgL_arg1484z00_2712;

													{	/* Eval/evaluate_uncomp.scm 151 */
														obj_t BgL_arg1485z00_2713;

														BgL_arg1485z00_2713 =
															CAR(((obj_t) BgL_l1169z00_2709));
														BgL_arg1484z00_2712 =
															BGl_uncompz00zz__evaluate_uncompz00(
															((BgL_ev_exprz00_bglt) BgL_arg1485z00_2713));
													}
													{	/* Eval/evaluate_uncomp.scm 151 */
														obj_t BgL_res1933z00_2714;

														BgL_res1933z00_2714 =
															MAKE_YOUNG_PAIR(BgL_arg1484z00_2712, BNIL);
														BgL_newtail1173z00_2711 = BgL_res1933z00_2714;
													}
												}
												SET_CDR(BgL_tail1172z00_2710, BgL_newtail1173z00_2711);
												{	/* Eval/evaluate_uncomp.scm 151 */
													obj_t BgL_arg1483z00_2715;

													BgL_arg1483z00_2715 =
														CDR(((obj_t) BgL_l1169z00_2709));
													{
														obj_t BgL_tail1172z00_3125;
														obj_t BgL_l1169z00_3124;

														BgL_l1169z00_3124 = BgL_arg1483z00_2715;
														BgL_tail1172z00_3125 = BgL_newtail1173z00_2711;
														BgL_tail1172z00_2710 = BgL_tail1172z00_3125;
														BgL_l1169z00_2709 = BgL_l1169z00_3124;
														goto BgL_zc3z04anonymousza31481ze3z87_2708;
													}
												}
											}
									}
								}
							}
					}
					BgL_arg1476z00_2699 =
						BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_arg1479z00_2701,
						BNIL);
				}
				return MAKE_YOUNG_PAIR(BgL_arg1473z00_2698, BgL_arg1476z00_2699);
			}
		}

	}



/* &uncomp-ev_labels1238 */
	obj_t BGl_z62uncompzd2ev_labels1238zb0zz__evaluate_uncompz00(obj_t
		BgL_envz00_2616, obj_t BgL_ez00_2617)
	{
		{	/* Eval/evaluate_uncomp.scm 142 */
			{	/* Eval/evaluate_uncomp.scm 144 */
				obj_t BgL_arg1442z00_2717;

				{	/* Eval/evaluate_uncomp.scm 144 */
					obj_t BgL_arg1443z00_2718;
					obj_t BgL_arg1445z00_2719;

					{	/* Eval/evaluate_uncomp.scm 144 */
						obj_t BgL_ll1163z00_2720;
						obj_t BgL_ll1164z00_2721;

						BgL_ll1163z00_2720 =
							(((BgL_ev_labelsz00_bglt) COBJECT(
									((BgL_ev_labelsz00_bglt) BgL_ez00_2617)))->BgL_varsz00);
						BgL_ll1164z00_2721 =
							(((BgL_ev_labelsz00_bglt) COBJECT(
									((BgL_ev_labelsz00_bglt) BgL_ez00_2617)))->BgL_valsz00);
						if (NULLP(BgL_ll1163z00_2720))
							{	/* Eval/evaluate_uncomp.scm 144 */
								BgL_arg1443z00_2718 = BNIL;
							}
						else
							{	/* Eval/evaluate_uncomp.scm 144 */
								obj_t BgL_head1165z00_2722;

								{	/* Eval/evaluate_uncomp.scm 144 */
									obj_t BgL_res1913z00_2723;

									BgL_res1913z00_2723 = MAKE_YOUNG_PAIR(BNIL, BNIL);
									BgL_head1165z00_2722 = BgL_res1913z00_2723;
								}
								{
									obj_t BgL_ll1163z00_2725;
									obj_t BgL_ll1164z00_2726;
									obj_t BgL_tail1166z00_2727;

									BgL_ll1163z00_2725 = BgL_ll1163z00_2720;
									BgL_ll1164z00_2726 = BgL_ll1164z00_2721;
									BgL_tail1166z00_2727 = BgL_head1165z00_2722;
								BgL_zc3z04anonymousza31447ze3z87_2724:
									if (NULLP(BgL_ll1163z00_2725))
										{	/* Eval/evaluate_uncomp.scm 144 */
											BgL_arg1443z00_2718 = CDR(BgL_head1165z00_2722);
										}
									else
										{	/* Eval/evaluate_uncomp.scm 144 */
											obj_t BgL_newtail1167z00_2728;

											{	/* Eval/evaluate_uncomp.scm 144 */
												obj_t BgL_arg1451z00_2729;

												{	/* Eval/evaluate_uncomp.scm 144 */
													obj_t BgL_vz00_2730;
													obj_t BgL_az00_2731;

													BgL_vz00_2730 = CAR(((obj_t) BgL_ll1163z00_2725));
													BgL_az00_2731 = CAR(((obj_t) BgL_ll1164z00_2726));
													{	/* Eval/evaluate_uncomp.scm 144 */
														obj_t BgL_arg1452z00_2732;
														obj_t BgL_arg1453z00_2733;

														BgL_arg1452z00_2732 =
															BGl_uncompz00zz__evaluate_uncompz00(
															((BgL_ev_exprz00_bglt) BgL_vz00_2730));
														{	/* Eval/evaluate_uncomp.scm 144 */
															obj_t BgL_arg1454z00_2734;

															{	/* Eval/evaluate_uncomp.scm 144 */
																obj_t BgL_arg1457z00_2735;

																{	/* Eval/evaluate_uncomp.scm 144 */
																	obj_t BgL_arg1458z00_2736;
																	obj_t BgL_arg1459z00_2737;

																	{	/* Eval/evaluate_uncomp.scm 144 */
																		obj_t BgL_l1157z00_2738;

																		BgL_l1157z00_2738 =
																			CAR(((obj_t) BgL_az00_2731));
																		if (NULLP(BgL_l1157z00_2738))
																			{	/* Eval/evaluate_uncomp.scm 144 */
																				BgL_arg1458z00_2736 = BNIL;
																			}
																		else
																			{	/* Eval/evaluate_uncomp.scm 144 */
																				obj_t BgL_head1159z00_2739;

																				{	/* Eval/evaluate_uncomp.scm 144 */
																					obj_t BgL_arg1466z00_2740;

																					{	/* Eval/evaluate_uncomp.scm 144 */
																						obj_t BgL_arg1467z00_2741;

																						BgL_arg1467z00_2741 =
																							CAR(((obj_t) BgL_l1157z00_2738));
																						BgL_arg1466z00_2740 =
																							BGl_uncompz00zz__evaluate_uncompz00
																							(((BgL_ev_exprz00_bglt)
																								BgL_arg1467z00_2741));
																					}
																					{	/* Eval/evaluate_uncomp.scm 144 */
																						obj_t BgL_res1916z00_2742;

																						BgL_res1916z00_2742 =
																							MAKE_YOUNG_PAIR
																							(BgL_arg1466z00_2740, BNIL);
																						BgL_head1159z00_2739 =
																							BgL_res1916z00_2742;
																					}
																				}
																				{	/* Eval/evaluate_uncomp.scm 144 */
																					obj_t BgL_g1162z00_2743;

																					BgL_g1162z00_2743 =
																						CDR(((obj_t) BgL_l1157z00_2738));
																					{
																						obj_t BgL_l1157z00_2745;
																						obj_t BgL_tail1160z00_2746;

																						BgL_l1157z00_2745 =
																							BgL_g1162z00_2743;
																						BgL_tail1160z00_2746 =
																							BgL_head1159z00_2739;
																					BgL_zc3z04anonymousza31461ze3z87_2744:
																						if (NULLP
																							(BgL_l1157z00_2745))
																							{	/* Eval/evaluate_uncomp.scm 144 */
																								BgL_arg1458z00_2736 =
																									BgL_head1159z00_2739;
																							}
																						else
																							{	/* Eval/evaluate_uncomp.scm 144 */
																								obj_t BgL_newtail1161z00_2747;

																								{	/* Eval/evaluate_uncomp.scm 144 */
																									obj_t BgL_arg1464z00_2748;

																									{	/* Eval/evaluate_uncomp.scm 144 */
																										obj_t BgL_arg1465z00_2749;

																										BgL_arg1465z00_2749 =
																											CAR(
																											((obj_t)
																												BgL_l1157z00_2745));
																										BgL_arg1464z00_2748 =
																											BGl_uncompz00zz__evaluate_uncompz00
																											(((BgL_ev_exprz00_bglt)
																												BgL_arg1465z00_2749));
																									}
																									{	/* Eval/evaluate_uncomp.scm 144 */
																										obj_t BgL_res1924z00_2750;

																										BgL_res1924z00_2750 =
																											MAKE_YOUNG_PAIR
																											(BgL_arg1464z00_2748,
																											BNIL);
																										BgL_newtail1161z00_2747 =
																											BgL_res1924z00_2750;
																									}
																								}
																								SET_CDR(BgL_tail1160z00_2746,
																									BgL_newtail1161z00_2747);
																								{	/* Eval/evaluate_uncomp.scm 144 */
																									obj_t BgL_arg1463z00_2751;

																									BgL_arg1463z00_2751 =
																										CDR(
																										((obj_t)
																											BgL_l1157z00_2745));
																									{
																										obj_t BgL_tail1160z00_3166;
																										obj_t BgL_l1157z00_3165;

																										BgL_l1157z00_3165 =
																											BgL_arg1463z00_2751;
																										BgL_tail1160z00_3166 =
																											BgL_newtail1161z00_2747;
																										BgL_tail1160z00_2746 =
																											BgL_tail1160z00_3166;
																										BgL_l1157z00_2745 =
																											BgL_l1157z00_3165;
																										goto
																											BgL_zc3z04anonymousza31461ze3z87_2744;
																									}
																								}
																							}
																					}
																				}
																			}
																	}
																	{	/* Eval/evaluate_uncomp.scm 145 */
																		obj_t BgL_arg1468z00_2752;

																		{	/* Eval/evaluate_uncomp.scm 145 */
																			obj_t BgL_arg1469z00_2753;

																			BgL_arg1469z00_2753 =
																				CDR(((obj_t) BgL_az00_2731));
																			BgL_arg1468z00_2752 =
																				BGl_uncompz00zz__evaluate_uncompz00(
																				((BgL_ev_exprz00_bglt)
																					BgL_arg1469z00_2753));
																		}
																		BgL_arg1459z00_2737 =
																			MAKE_YOUNG_PAIR(BgL_arg1468z00_2752,
																			BNIL);
																	}
																	BgL_arg1457z00_2735 =
																		MAKE_YOUNG_PAIR(BgL_arg1458z00_2736,
																		BgL_arg1459z00_2737);
																}
																BgL_arg1454z00_2734 =
																	MAKE_YOUNG_PAIR
																	(BGl_symbol2062z00zz__evaluate_uncompz00,
																	BgL_arg1457z00_2735);
															}
															BgL_arg1453z00_2733 =
																MAKE_YOUNG_PAIR(BgL_arg1454z00_2734, BNIL);
														}
														BgL_arg1451z00_2729 =
															MAKE_YOUNG_PAIR(BgL_arg1452z00_2732,
															BgL_arg1453z00_2733);
													}
												}
												{	/* Eval/evaluate_uncomp.scm 144 */
													obj_t BgL_res1925z00_2754;

													BgL_res1925z00_2754 =
														MAKE_YOUNG_PAIR(BgL_arg1451z00_2729, BNIL);
													BgL_newtail1167z00_2728 = BgL_res1925z00_2754;
												}
											}
											SET_CDR(BgL_tail1166z00_2727, BgL_newtail1167z00_2728);
											{	/* Eval/evaluate_uncomp.scm 144 */
												obj_t BgL_arg1449z00_2755;
												obj_t BgL_arg1450z00_2756;

												BgL_arg1449z00_2755 = CDR(((obj_t) BgL_ll1163z00_2725));
												BgL_arg1450z00_2756 = CDR(((obj_t) BgL_ll1164z00_2726));
												{
													obj_t BgL_tail1166z00_3184;
													obj_t BgL_ll1164z00_3183;
													obj_t BgL_ll1163z00_3182;

													BgL_ll1163z00_3182 = BgL_arg1449z00_2755;
													BgL_ll1164z00_3183 = BgL_arg1450z00_2756;
													BgL_tail1166z00_3184 = BgL_newtail1167z00_2728;
													BgL_tail1166z00_2727 = BgL_tail1166z00_3184;
													BgL_ll1164z00_2726 = BgL_ll1164z00_3183;
													BgL_ll1163z00_2725 = BgL_ll1163z00_3182;
													goto BgL_zc3z04anonymousza31447ze3z87_2724;
												}
											}
										}
								}
							}
					}
					BgL_arg1445z00_2719 =
						MAKE_YOUNG_PAIR(BGl_uncompz00zz__evaluate_uncompz00(
							(((BgL_ev_labelsz00_bglt) COBJECT(
										((BgL_ev_labelsz00_bglt) BgL_ez00_2617)))->BgL_bodyz00)),
						BNIL);
					BgL_arg1442z00_2717 =
						MAKE_YOUNG_PAIR(BgL_arg1443z00_2718, BgL_arg1445z00_2719);
				}
				return
					MAKE_YOUNG_PAIR(BGl_symbol2064z00zz__evaluate_uncompz00,
					BgL_arg1442z00_2717);
			}
		}

	}



/* &uncomp-ev_letrec1236 */
	obj_t BGl_z62uncompzd2ev_letrec1236zb0zz__evaluate_uncompz00(obj_t
		BgL_envz00_2618, obj_t BgL_ez00_2619)
	{
		{	/* Eval/evaluate_uncomp.scm 138 */
			{	/* Eval/evaluate_uncomp.scm 140 */
				obj_t BgL_arg1427z00_2758;

				{	/* Eval/evaluate_uncomp.scm 140 */
					obj_t BgL_arg1428z00_2759;
					obj_t BgL_arg1429z00_2760;

					{	/* Eval/evaluate_uncomp.scm 140 */
						obj_t BgL_ll1151z00_2761;
						obj_t BgL_ll1152z00_2762;

						BgL_ll1151z00_2761 =
							(((BgL_ev_binderz00_bglt) COBJECT(
									((BgL_ev_binderz00_bglt)
										((BgL_ev_letrecz00_bglt) BgL_ez00_2619))))->BgL_varsz00);
						BgL_ll1152z00_2762 =
							(((BgL_ev_binderz00_bglt) COBJECT(
									((BgL_ev_binderz00_bglt)
										((BgL_ev_letrecz00_bglt) BgL_ez00_2619))))->BgL_valsz00);
						if (NULLP(BgL_ll1151z00_2761))
							{	/* Eval/evaluate_uncomp.scm 140 */
								BgL_arg1428z00_2759 = BNIL;
							}
						else
							{	/* Eval/evaluate_uncomp.scm 140 */
								obj_t BgL_head1153z00_2763;

								{	/* Eval/evaluate_uncomp.scm 140 */
									obj_t BgL_res1909z00_2764;

									BgL_res1909z00_2764 = MAKE_YOUNG_PAIR(BNIL, BNIL);
									BgL_head1153z00_2763 = BgL_res1909z00_2764;
								}
								{
									obj_t BgL_ll1151z00_2766;
									obj_t BgL_ll1152z00_2767;
									obj_t BgL_tail1154z00_2768;

									BgL_ll1151z00_2766 = BgL_ll1151z00_2761;
									BgL_ll1152z00_2767 = BgL_ll1152z00_2762;
									BgL_tail1154z00_2768 = BgL_head1153z00_2763;
								BgL_zc3z04anonymousza31431ze3z87_2765:
									if (NULLP(BgL_ll1151z00_2766))
										{	/* Eval/evaluate_uncomp.scm 140 */
											BgL_arg1428z00_2759 = CDR(BgL_head1153z00_2763);
										}
									else
										{	/* Eval/evaluate_uncomp.scm 140 */
											obj_t BgL_newtail1155z00_2769;

											{	/* Eval/evaluate_uncomp.scm 140 */
												obj_t BgL_arg1436z00_2770;

												{	/* Eval/evaluate_uncomp.scm 140 */
													obj_t BgL_vz00_2771;
													obj_t BgL_az00_2772;

													BgL_vz00_2771 = CAR(((obj_t) BgL_ll1151z00_2766));
													BgL_az00_2772 = CAR(((obj_t) BgL_ll1152z00_2767));
													{	/* Eval/evaluate_uncomp.scm 140 */
														obj_t BgL_arg1437z00_2773;
														obj_t BgL_arg1438z00_2774;

														BgL_arg1437z00_2773 =
															BGl_uncompz00zz__evaluate_uncompz00(
															((BgL_ev_exprz00_bglt) BgL_vz00_2771));
														{	/* Eval/evaluate_uncomp.scm 140 */
															obj_t BgL_arg1439z00_2775;

															BgL_arg1439z00_2775 =
																BGl_uncompz00zz__evaluate_uncompz00(
																((BgL_ev_exprz00_bglt) BgL_az00_2772));
															BgL_arg1438z00_2774 =
																MAKE_YOUNG_PAIR(BgL_arg1439z00_2775, BNIL);
														}
														BgL_arg1436z00_2770 =
															MAKE_YOUNG_PAIR(BgL_arg1437z00_2773,
															BgL_arg1438z00_2774);
													}
												}
												{	/* Eval/evaluate_uncomp.scm 140 */
													obj_t BgL_res1911z00_2776;

													BgL_res1911z00_2776 =
														MAKE_YOUNG_PAIR(BgL_arg1436z00_2770, BNIL);
													BgL_newtail1155z00_2769 = BgL_res1911z00_2776;
												}
											}
											SET_CDR(BgL_tail1154z00_2768, BgL_newtail1155z00_2769);
											{	/* Eval/evaluate_uncomp.scm 140 */
												obj_t BgL_arg1433z00_2777;
												obj_t BgL_arg1435z00_2778;

												BgL_arg1433z00_2777 = CDR(((obj_t) BgL_ll1151z00_2766));
												BgL_arg1435z00_2778 = CDR(((obj_t) BgL_ll1152z00_2767));
												{
													obj_t BgL_tail1154z00_3221;
													obj_t BgL_ll1152z00_3220;
													obj_t BgL_ll1151z00_3219;

													BgL_ll1151z00_3219 = BgL_arg1433z00_2777;
													BgL_ll1152z00_3220 = BgL_arg1435z00_2778;
													BgL_tail1154z00_3221 = BgL_newtail1155z00_2769;
													BgL_tail1154z00_2768 = BgL_tail1154z00_3221;
													BgL_ll1152z00_2767 = BgL_ll1152z00_3220;
													BgL_ll1151z00_2766 = BgL_ll1151z00_3219;
													goto BgL_zc3z04anonymousza31431ze3z87_2765;
												}
											}
										}
								}
							}
					}
					{	/* Eval/evaluate_uncomp.scm 140 */
						obj_t BgL_arg1440z00_2779;

						{	/* Eval/evaluate_uncomp.scm 140 */
							BgL_ev_exprz00_bglt BgL_arg1441z00_2780;

							BgL_arg1441z00_2780 =
								(((BgL_ev_binderz00_bglt) COBJECT(
										((BgL_ev_binderz00_bglt)
											((BgL_ev_letrecz00_bglt) BgL_ez00_2619))))->BgL_bodyz00);
							BgL_arg1440z00_2779 =
								BGl_uncompz00zz__evaluate_uncompz00(BgL_arg1441z00_2780);
						}
						BgL_arg1429z00_2760 = MAKE_YOUNG_PAIR(BgL_arg1440z00_2779, BNIL);
					}
					BgL_arg1427z00_2758 =
						MAKE_YOUNG_PAIR(BgL_arg1428z00_2759, BgL_arg1429z00_2760);
				}
				return
					MAKE_YOUNG_PAIR(BGl_symbol2064z00zz__evaluate_uncompz00,
					BgL_arg1427z00_2758);
			}
		}

	}



/* &uncomp-ev_let*1234 */
	obj_t BGl_z62uncompzd2ev_letza21234z12zz__evaluate_uncompz00(obj_t
		BgL_envz00_2620, obj_t BgL_ez00_2621)
	{
		{	/* Eval/evaluate_uncomp.scm 134 */
			{	/* Eval/evaluate_uncomp.scm 136 */
				obj_t BgL_arg1410z00_2782;

				{	/* Eval/evaluate_uncomp.scm 136 */
					obj_t BgL_arg1411z00_2783;
					obj_t BgL_arg1414z00_2784;

					{	/* Eval/evaluate_uncomp.scm 136 */
						obj_t BgL_ll1145z00_2785;
						obj_t BgL_ll1146z00_2786;

						BgL_ll1145z00_2785 =
							(((BgL_ev_binderz00_bglt) COBJECT(
									((BgL_ev_binderz00_bglt)
										((BgL_ev_letza2za2_bglt) BgL_ez00_2621))))->BgL_varsz00);
						BgL_ll1146z00_2786 =
							(((BgL_ev_binderz00_bglt) COBJECT(
									((BgL_ev_binderz00_bglt)
										((BgL_ev_letza2za2_bglt) BgL_ez00_2621))))->BgL_valsz00);
						if (NULLP(BgL_ll1145z00_2785))
							{	/* Eval/evaluate_uncomp.scm 136 */
								BgL_arg1411z00_2783 = BNIL;
							}
						else
							{	/* Eval/evaluate_uncomp.scm 136 */
								obj_t BgL_head1147z00_2787;

								{	/* Eval/evaluate_uncomp.scm 136 */
									obj_t BgL_res1903z00_2788;

									BgL_res1903z00_2788 = MAKE_YOUNG_PAIR(BNIL, BNIL);
									BgL_head1147z00_2787 = BgL_res1903z00_2788;
								}
								{
									obj_t BgL_ll1145z00_2790;
									obj_t BgL_ll1146z00_2791;
									obj_t BgL_tail1148z00_2792;

									BgL_ll1145z00_2790 = BgL_ll1145z00_2785;
									BgL_ll1146z00_2791 = BgL_ll1146z00_2786;
									BgL_tail1148z00_2792 = BgL_head1147z00_2787;
								BgL_zc3z04anonymousza31416ze3z87_2789:
									if (NULLP(BgL_ll1145z00_2790))
										{	/* Eval/evaluate_uncomp.scm 136 */
											BgL_arg1411z00_2783 = CDR(BgL_head1147z00_2787);
										}
									else
										{	/* Eval/evaluate_uncomp.scm 136 */
											obj_t BgL_newtail1149z00_2793;

											{	/* Eval/evaluate_uncomp.scm 136 */
												obj_t BgL_arg1420z00_2794;

												{	/* Eval/evaluate_uncomp.scm 136 */
													obj_t BgL_vz00_2795;
													obj_t BgL_az00_2796;

													BgL_vz00_2795 = CAR(((obj_t) BgL_ll1145z00_2790));
													BgL_az00_2796 = CAR(((obj_t) BgL_ll1146z00_2791));
													{	/* Eval/evaluate_uncomp.scm 136 */
														obj_t BgL_arg1421z00_2797;
														obj_t BgL_arg1422z00_2798;

														BgL_arg1421z00_2797 =
															BGl_uncompz00zz__evaluate_uncompz00(
															((BgL_ev_exprz00_bglt) BgL_vz00_2795));
														{	/* Eval/evaluate_uncomp.scm 136 */
															obj_t BgL_arg1423z00_2799;

															BgL_arg1423z00_2799 =
																BGl_uncompz00zz__evaluate_uncompz00(
																((BgL_ev_exprz00_bglt) BgL_az00_2796));
															BgL_arg1422z00_2798 =
																MAKE_YOUNG_PAIR(BgL_arg1423z00_2799, BNIL);
														}
														BgL_arg1420z00_2794 =
															MAKE_YOUNG_PAIR(BgL_arg1421z00_2797,
															BgL_arg1422z00_2798);
													}
												}
												{	/* Eval/evaluate_uncomp.scm 136 */
													obj_t BgL_res1906z00_2800;

													BgL_res1906z00_2800 =
														MAKE_YOUNG_PAIR(BgL_arg1420z00_2794, BNIL);
													BgL_newtail1149z00_2793 = BgL_res1906z00_2800;
												}
											}
											SET_CDR(BgL_tail1148z00_2792, BgL_newtail1149z00_2793);
											{	/* Eval/evaluate_uncomp.scm 136 */
												obj_t BgL_arg1418z00_2801;
												obj_t BgL_arg1419z00_2802;

												BgL_arg1418z00_2801 = CDR(((obj_t) BgL_ll1145z00_2790));
												BgL_arg1419z00_2802 = CDR(((obj_t) BgL_ll1146z00_2791));
												{
													obj_t BgL_tail1148z00_3259;
													obj_t BgL_ll1146z00_3258;
													obj_t BgL_ll1145z00_3257;

													BgL_ll1145z00_3257 = BgL_arg1418z00_2801;
													BgL_ll1146z00_3258 = BgL_arg1419z00_2802;
													BgL_tail1148z00_3259 = BgL_newtail1149z00_2793;
													BgL_tail1148z00_2792 = BgL_tail1148z00_3259;
													BgL_ll1146z00_2791 = BgL_ll1146z00_3258;
													BgL_ll1145z00_2790 = BgL_ll1145z00_3257;
													goto BgL_zc3z04anonymousza31416ze3z87_2789;
												}
											}
										}
								}
							}
					}
					{	/* Eval/evaluate_uncomp.scm 136 */
						obj_t BgL_arg1424z00_2803;

						{	/* Eval/evaluate_uncomp.scm 136 */
							BgL_ev_exprz00_bglt BgL_arg1425z00_2804;

							BgL_arg1425z00_2804 =
								(((BgL_ev_binderz00_bglt) COBJECT(
										((BgL_ev_binderz00_bglt)
											((BgL_ev_letza2za2_bglt) BgL_ez00_2621))))->BgL_bodyz00);
							BgL_arg1424z00_2803 =
								BGl_uncompz00zz__evaluate_uncompz00(BgL_arg1425z00_2804);
						}
						BgL_arg1414z00_2784 = MAKE_YOUNG_PAIR(BgL_arg1424z00_2803, BNIL);
					}
					BgL_arg1410z00_2782 =
						MAKE_YOUNG_PAIR(BgL_arg1411z00_2783, BgL_arg1414z00_2784);
				}
				return
					MAKE_YOUNG_PAIR(BGl_symbol2066z00zz__evaluate_uncompz00,
					BgL_arg1410z00_2782);
			}
		}

	}



/* &uncomp-ev_let1232 */
	obj_t BGl_z62uncompzd2ev_let1232zb0zz__evaluate_uncompz00(obj_t
		BgL_envz00_2622, obj_t BgL_ez00_2623)
	{
		{	/* Eval/evaluate_uncomp.scm 130 */
			{	/* Eval/evaluate_uncomp.scm 132 */
				obj_t BgL_arg1394z00_2806;

				{	/* Eval/evaluate_uncomp.scm 132 */
					obj_t BgL_arg1395z00_2807;
					obj_t BgL_arg1396z00_2808;

					{	/* Eval/evaluate_uncomp.scm 132 */
						obj_t BgL_ll1139z00_2809;
						obj_t BgL_ll1140z00_2810;

						BgL_ll1139z00_2809 =
							(((BgL_ev_binderz00_bglt) COBJECT(
									((BgL_ev_binderz00_bglt)
										((BgL_ev_letz00_bglt) BgL_ez00_2623))))->BgL_varsz00);
						BgL_ll1140z00_2810 =
							(((BgL_ev_binderz00_bglt) COBJECT(
									((BgL_ev_binderz00_bglt)
										((BgL_ev_letz00_bglt) BgL_ez00_2623))))->BgL_valsz00);
						if (NULLP(BgL_ll1139z00_2809))
							{	/* Eval/evaluate_uncomp.scm 132 */
								BgL_arg1395z00_2807 = BNIL;
							}
						else
							{	/* Eval/evaluate_uncomp.scm 132 */
								obj_t BgL_head1141z00_2811;

								{	/* Eval/evaluate_uncomp.scm 132 */
									obj_t BgL_res1899z00_2812;

									BgL_res1899z00_2812 = MAKE_YOUNG_PAIR(BNIL, BNIL);
									BgL_head1141z00_2811 = BgL_res1899z00_2812;
								}
								{
									obj_t BgL_ll1139z00_2814;
									obj_t BgL_ll1140z00_2815;
									obj_t BgL_tail1142z00_2816;

									BgL_ll1139z00_2814 = BgL_ll1139z00_2809;
									BgL_ll1140z00_2815 = BgL_ll1140z00_2810;
									BgL_tail1142z00_2816 = BgL_head1141z00_2811;
								BgL_zc3z04anonymousza31398ze3z87_2813:
									if (NULLP(BgL_ll1139z00_2814))
										{	/* Eval/evaluate_uncomp.scm 132 */
											BgL_arg1395z00_2807 = CDR(BgL_head1141z00_2811);
										}
									else
										{	/* Eval/evaluate_uncomp.scm 132 */
											obj_t BgL_newtail1143z00_2817;

											{	/* Eval/evaluate_uncomp.scm 132 */
												obj_t BgL_arg1403z00_2818;

												{	/* Eval/evaluate_uncomp.scm 132 */
													obj_t BgL_vz00_2819;
													obj_t BgL_az00_2820;

													BgL_vz00_2819 = CAR(((obj_t) BgL_ll1139z00_2814));
													BgL_az00_2820 = CAR(((obj_t) BgL_ll1140z00_2815));
													{	/* Eval/evaluate_uncomp.scm 132 */
														obj_t BgL_arg1405z00_2821;
														obj_t BgL_arg1406z00_2822;

														BgL_arg1405z00_2821 =
															BGl_uncompz00zz__evaluate_uncompz00(
															((BgL_ev_exprz00_bglt) BgL_vz00_2819));
														{	/* Eval/evaluate_uncomp.scm 132 */
															obj_t BgL_arg1407z00_2823;

															BgL_arg1407z00_2823 =
																BGl_uncompz00zz__evaluate_uncompz00(
																((BgL_ev_exprz00_bglt) BgL_az00_2820));
															BgL_arg1406z00_2822 =
																MAKE_YOUNG_PAIR(BgL_arg1407z00_2823, BNIL);
														}
														BgL_arg1403z00_2818 =
															MAKE_YOUNG_PAIR(BgL_arg1405z00_2821,
															BgL_arg1406z00_2822);
													}
												}
												{	/* Eval/evaluate_uncomp.scm 132 */
													obj_t BgL_res1901z00_2824;

													BgL_res1901z00_2824 =
														MAKE_YOUNG_PAIR(BgL_arg1403z00_2818, BNIL);
													BgL_newtail1143z00_2817 = BgL_res1901z00_2824;
												}
											}
											SET_CDR(BgL_tail1142z00_2816, BgL_newtail1143z00_2817);
											{	/* Eval/evaluate_uncomp.scm 132 */
												obj_t BgL_arg1400z00_2825;
												obj_t BgL_arg1401z00_2826;

												BgL_arg1400z00_2825 = CDR(((obj_t) BgL_ll1139z00_2814));
												BgL_arg1401z00_2826 = CDR(((obj_t) BgL_ll1140z00_2815));
												{
													obj_t BgL_tail1142z00_3297;
													obj_t BgL_ll1140z00_3296;
													obj_t BgL_ll1139z00_3295;

													BgL_ll1139z00_3295 = BgL_arg1400z00_2825;
													BgL_ll1140z00_3296 = BgL_arg1401z00_2826;
													BgL_tail1142z00_3297 = BgL_newtail1143z00_2817;
													BgL_tail1142z00_2816 = BgL_tail1142z00_3297;
													BgL_ll1140z00_2815 = BgL_ll1140z00_3296;
													BgL_ll1139z00_2814 = BgL_ll1139z00_3295;
													goto BgL_zc3z04anonymousza31398ze3z87_2813;
												}
											}
										}
								}
							}
					}
					{	/* Eval/evaluate_uncomp.scm 132 */
						obj_t BgL_arg1408z00_2827;

						{	/* Eval/evaluate_uncomp.scm 132 */
							BgL_ev_exprz00_bglt BgL_arg1409z00_2828;

							BgL_arg1409z00_2828 =
								(((BgL_ev_binderz00_bglt) COBJECT(
										((BgL_ev_binderz00_bglt)
											((BgL_ev_letz00_bglt) BgL_ez00_2623))))->BgL_bodyz00);
							BgL_arg1408z00_2827 =
								BGl_uncompz00zz__evaluate_uncompz00(BgL_arg1409z00_2828);
						}
						BgL_arg1396z00_2808 = MAKE_YOUNG_PAIR(BgL_arg1408z00_2827, BNIL);
					}
					BgL_arg1394z00_2806 =
						MAKE_YOUNG_PAIR(BgL_arg1395z00_2807, BgL_arg1396z00_2808);
				}
				return
					MAKE_YOUNG_PAIR(BGl_symbol2068z00zz__evaluate_uncompz00,
					BgL_arg1394z00_2806);
			}
		}

	}



/* &uncomp-ev_synchroniz1230 */
	obj_t BGl_z62uncompzd2ev_synchroniza71230z17zz__evaluate_uncompz00(obj_t
		BgL_envz00_2624, obj_t BgL_ez00_2625)
	{
		{	/* Eval/evaluate_uncomp.scm 126 */
			{	/* Eval/evaluate_uncomp.scm 128 */
				obj_t BgL_arg1380z00_2830;

				{	/* Eval/evaluate_uncomp.scm 128 */
					obj_t BgL_arg1381z00_2831;
					obj_t BgL_arg1382z00_2832;

					BgL_arg1381z00_2831 =
						BGl_uncompz00zz__evaluate_uncompz00(
						(((BgL_ev_synchroniza7eza7_bglt) COBJECT(
									((BgL_ev_synchroniza7eza7_bglt) BgL_ez00_2625)))->
							BgL_mutexz00));
					{	/* Eval/evaluate_uncomp.scm 128 */
						obj_t BgL_arg1384z00_2833;

						{	/* Eval/evaluate_uncomp.scm 128 */
							obj_t BgL_arg1385z00_2834;
							obj_t BgL_arg1386z00_2835;

							BgL_arg1385z00_2834 =
								BGl_uncompz00zz__evaluate_uncompz00(
								(((BgL_ev_synchroniza7eza7_bglt) COBJECT(
											((BgL_ev_synchroniza7eza7_bglt) BgL_ez00_2625)))->
									BgL_prelockz00));
							BgL_arg1386z00_2835 =
								MAKE_YOUNG_PAIR(BGl_uncompz00zz__evaluate_uncompz00(((
											(BgL_ev_synchroniza7eza7_bglt)
											COBJECT(((BgL_ev_synchroniza7eza7_bglt) BgL_ez00_2625)))->
										BgL_bodyz00)), BNIL);
							BgL_arg1384z00_2833 =
								MAKE_YOUNG_PAIR(BgL_arg1385z00_2834, BgL_arg1386z00_2835);
						}
						BgL_arg1382z00_2832 =
							MAKE_YOUNG_PAIR(BGl_keyword2070z00zz__evaluate_uncompz00,
							BgL_arg1384z00_2833);
					}
					BgL_arg1380z00_2830 =
						MAKE_YOUNG_PAIR(BgL_arg1381z00_2831, BgL_arg1382z00_2832);
				}
				return
					MAKE_YOUNG_PAIR(BGl_symbol2072z00zz__evaluate_uncompz00,
					BgL_arg1380z00_2830);
			}
		}

	}



/* &uncomp-ev_with-handl1228 */
	obj_t BGl_z62uncompzd2ev_withzd2handl1228z62zz__evaluate_uncompz00(obj_t
		BgL_envz00_2626, obj_t BgL_ez00_2627)
	{
		{	/* Eval/evaluate_uncomp.scm 122 */
			{	/* Eval/evaluate_uncomp.scm 124 */
				obj_t BgL_arg1374z00_2837;

				{	/* Eval/evaluate_uncomp.scm 124 */
					obj_t BgL_arg1375z00_2838;
					obj_t BgL_arg1376z00_2839;

					BgL_arg1375z00_2838 =
						BGl_uncompz00zz__evaluate_uncompz00(
						(((BgL_ev_withzd2handlerzd2_bglt) COBJECT(
									((BgL_ev_withzd2handlerzd2_bglt) BgL_ez00_2627)))->
							BgL_handlerz00));
					BgL_arg1376z00_2839 =
						MAKE_YOUNG_PAIR(BGl_uncompz00zz__evaluate_uncompz00(((
									(BgL_ev_withzd2handlerzd2_bglt)
									COBJECT(((BgL_ev_withzd2handlerzd2_bglt) BgL_ez00_2627)))->
								BgL_bodyz00)), BNIL);
					BgL_arg1374z00_2837 =
						MAKE_YOUNG_PAIR(BgL_arg1375z00_2838, BgL_arg1376z00_2839);
				}
				return
					MAKE_YOUNG_PAIR(BGl_symbol2074z00zz__evaluate_uncompz00,
					BgL_arg1374z00_2837);
			}
		}

	}



/* &uncomp-ev_unwind-pro1226 */
	obj_t BGl_z62uncompzd2ev_unwindzd2pro1226z62zz__evaluate_uncompz00(obj_t
		BgL_envz00_2628, obj_t BgL_ez00_2629)
	{
		{	/* Eval/evaluate_uncomp.scm 118 */
			{	/* Eval/evaluate_uncomp.scm 120 */
				obj_t BgL_arg1368z00_2841;

				{	/* Eval/evaluate_uncomp.scm 120 */
					obj_t BgL_arg1369z00_2842;
					obj_t BgL_arg1370z00_2843;

					BgL_arg1369z00_2842 =
						BGl_uncompz00zz__evaluate_uncompz00(
						(((BgL_ev_unwindzd2protectzd2_bglt) COBJECT(
									((BgL_ev_unwindzd2protectzd2_bglt) BgL_ez00_2629)))->
							BgL_ez00));
					BgL_arg1370z00_2843 =
						MAKE_YOUNG_PAIR(BGl_uncompz00zz__evaluate_uncompz00(((
									(BgL_ev_unwindzd2protectzd2_bglt)
									COBJECT(((BgL_ev_unwindzd2protectzd2_bglt) BgL_ez00_2629)))->
								BgL_bodyz00)), BNIL);
					BgL_arg1368z00_2841 =
						MAKE_YOUNG_PAIR(BgL_arg1369z00_2842, BgL_arg1370z00_2843);
				}
				return
					MAKE_YOUNG_PAIR(BGl_symbol2076z00zz__evaluate_uncompz00,
					BgL_arg1368z00_2841);
			}
		}

	}



/* &uncomp-ev_bind-exit1224 */
	obj_t BGl_z62uncompzd2ev_bindzd2exit1224z62zz__evaluate_uncompz00(obj_t
		BgL_envz00_2630, obj_t BgL_ez00_2631)
	{
		{	/* Eval/evaluate_uncomp.scm 114 */
			{	/* Eval/evaluate_uncomp.scm 116 */
				obj_t BgL_arg1359z00_2845;

				{	/* Eval/evaluate_uncomp.scm 116 */
					obj_t BgL_arg1360z00_2846;
					obj_t BgL_arg1361z00_2847;

					{	/* Eval/evaluate_uncomp.scm 116 */
						obj_t BgL_arg1363z00_2848;

						{	/* Eval/evaluate_uncomp.scm 116 */
							BgL_ev_varz00_bglt BgL_arg1364z00_2849;

							BgL_arg1364z00_2849 =
								(((BgL_ev_bindzd2exitzd2_bglt) COBJECT(
										((BgL_ev_bindzd2exitzd2_bglt) BgL_ez00_2631)))->BgL_varz00);
							BgL_arg1363z00_2848 =
								BGl_uncompz00zz__evaluate_uncompz00(
								((BgL_ev_exprz00_bglt) BgL_arg1364z00_2849));
						}
						BgL_arg1360z00_2846 = MAKE_YOUNG_PAIR(BgL_arg1363z00_2848, BNIL);
					}
					BgL_arg1361z00_2847 =
						MAKE_YOUNG_PAIR(BGl_uncompz00zz__evaluate_uncompz00(
							(((BgL_ev_bindzd2exitzd2_bglt) COBJECT(
										((BgL_ev_bindzd2exitzd2_bglt) BgL_ez00_2631)))->
								BgL_bodyz00)), BNIL);
					BgL_arg1359z00_2845 =
						MAKE_YOUNG_PAIR(BgL_arg1360z00_2846, BgL_arg1361z00_2847);
				}
				return
					MAKE_YOUNG_PAIR(BGl_symbol2078z00zz__evaluate_uncompz00,
					BgL_arg1359z00_2845);
			}
		}

	}



/* &uncomp-ev_setlocal1222 */
	obj_t BGl_z62uncompzd2ev_setlocal1222zb0zz__evaluate_uncompz00(obj_t
		BgL_envz00_2632, obj_t BgL_ez00_2633)
	{
		{	/* Eval/evaluate_uncomp.scm 110 */
			{	/* Eval/evaluate_uncomp.scm 112 */
				obj_t BgL_arg1353z00_2851;

				{	/* Eval/evaluate_uncomp.scm 112 */
					obj_t BgL_arg1354z00_2852;
					obj_t BgL_arg1355z00_2853;

					{	/* Eval/evaluate_uncomp.scm 112 */
						BgL_ev_varz00_bglt BgL_arg1356z00_2854;

						BgL_arg1356z00_2854 =
							(((BgL_ev_setlocalz00_bglt) COBJECT(
									((BgL_ev_setlocalz00_bglt) BgL_ez00_2633)))->BgL_vz00);
						BgL_arg1354z00_2852 =
							BGl_uncompz00zz__evaluate_uncompz00(
							((BgL_ev_exprz00_bglt) BgL_arg1356z00_2854));
					}
					{	/* Eval/evaluate_uncomp.scm 112 */
						obj_t BgL_arg1357z00_2855;

						{	/* Eval/evaluate_uncomp.scm 112 */
							BgL_ev_exprz00_bglt BgL_arg1358z00_2856;

							BgL_arg1358z00_2856 =
								(((BgL_ev_hookz00_bglt) COBJECT(
										((BgL_ev_hookz00_bglt)
											((BgL_ev_setlocalz00_bglt) BgL_ez00_2633))))->BgL_ez00);
							BgL_arg1357z00_2855 =
								BGl_uncompz00zz__evaluate_uncompz00(BgL_arg1358z00_2856);
						}
						BgL_arg1355z00_2853 = MAKE_YOUNG_PAIR(BgL_arg1357z00_2855, BNIL);
					}
					BgL_arg1353z00_2851 =
						MAKE_YOUNG_PAIR(BgL_arg1354z00_2852, BgL_arg1355z00_2853);
				}
				return
					MAKE_YOUNG_PAIR(BGl_symbol2080z00zz__evaluate_uncompz00,
					BgL_arg1353z00_2851);
			}
		}

	}



/* &uncomp-ev_defglobal1220 */
	obj_t BGl_z62uncompzd2ev_defglobal1220zb0zz__evaluate_uncompz00(obj_t
		BgL_envz00_2634, obj_t BgL_ez00_2635)
	{
		{	/* Eval/evaluate_uncomp.scm 106 */
			{	/* Eval/evaluate_uncomp.scm 108 */
				obj_t BgL_arg1347z00_2858;

				{	/* Eval/evaluate_uncomp.scm 108 */
					obj_t BgL_arg1348z00_2859;
					obj_t BgL_arg1350z00_2860;

					BgL_arg1348z00_2859 =
						(((BgL_ev_setglobalz00_bglt) COBJECT(
								((BgL_ev_setglobalz00_bglt)
									((BgL_ev_defglobalz00_bglt) BgL_ez00_2635))))->BgL_namez00);
					{	/* Eval/evaluate_uncomp.scm 108 */
						obj_t BgL_arg1351z00_2861;

						{	/* Eval/evaluate_uncomp.scm 108 */
							BgL_ev_exprz00_bglt BgL_arg1352z00_2862;

							BgL_arg1352z00_2862 =
								(((BgL_ev_hookz00_bglt) COBJECT(
										((BgL_ev_hookz00_bglt)
											((BgL_ev_defglobalz00_bglt) BgL_ez00_2635))))->BgL_ez00);
							BgL_arg1351z00_2861 =
								BGl_uncompz00zz__evaluate_uncompz00(BgL_arg1352z00_2862);
						}
						BgL_arg1350z00_2860 = MAKE_YOUNG_PAIR(BgL_arg1351z00_2861, BNIL);
					}
					BgL_arg1347z00_2858 =
						MAKE_YOUNG_PAIR(BgL_arg1348z00_2859, BgL_arg1350z00_2860);
				}
				return
					MAKE_YOUNG_PAIR(BGl_symbol2082z00zz__evaluate_uncompz00,
					BgL_arg1347z00_2858);
			}
		}

	}



/* &uncomp-ev_setglobal1218 */
	obj_t BGl_z62uncompzd2ev_setglobal1218zb0zz__evaluate_uncompz00(obj_t
		BgL_envz00_2636, obj_t BgL_ez00_2637)
	{
		{	/* Eval/evaluate_uncomp.scm 102 */
			{	/* Eval/evaluate_uncomp.scm 104 */
				obj_t BgL_arg1342z00_2864;

				{	/* Eval/evaluate_uncomp.scm 104 */
					obj_t BgL_arg1343z00_2865;
					obj_t BgL_arg1344z00_2866;

					BgL_arg1343z00_2865 =
						(((BgL_ev_setglobalz00_bglt) COBJECT(
								((BgL_ev_setglobalz00_bglt) BgL_ez00_2637)))->BgL_namez00);
					{	/* Eval/evaluate_uncomp.scm 104 */
						obj_t BgL_arg1345z00_2867;

						{	/* Eval/evaluate_uncomp.scm 104 */
							BgL_ev_exprz00_bglt BgL_arg1346z00_2868;

							BgL_arg1346z00_2868 =
								(((BgL_ev_hookz00_bglt) COBJECT(
										((BgL_ev_hookz00_bglt)
											((BgL_ev_setglobalz00_bglt) BgL_ez00_2637))))->BgL_ez00);
							BgL_arg1345z00_2867 =
								BGl_uncompz00zz__evaluate_uncompz00(BgL_arg1346z00_2868);
						}
						BgL_arg1344z00_2866 = MAKE_YOUNG_PAIR(BgL_arg1345z00_2867, BNIL);
					}
					BgL_arg1342z00_2864 =
						MAKE_YOUNG_PAIR(BgL_arg1343z00_2865, BgL_arg1344z00_2866);
				}
				return
					MAKE_YOUNG_PAIR(BGl_symbol2080z00zz__evaluate_uncompz00,
					BgL_arg1342z00_2864);
			}
		}

	}



/* &uncomp-ev_trap1216 */
	obj_t BGl_z62uncompzd2ev_trap1216zb0zz__evaluate_uncompz00(obj_t
		BgL_envz00_2638, obj_t BgL_ez00_2639)
	{
		{	/* Eval/evaluate_uncomp.scm 98 */
			{	/* Eval/evaluate_uncomp.scm 100 */
				obj_t BgL_arg1339z00_2870;

				{	/* Eval/evaluate_uncomp.scm 100 */
					obj_t BgL_arg1340z00_2871;

					{	/* Eval/evaluate_uncomp.scm 100 */
						BgL_ev_exprz00_bglt BgL_arg1341z00_2872;

						BgL_arg1341z00_2872 =
							(((BgL_ev_hookz00_bglt) COBJECT(
									((BgL_ev_hookz00_bglt)
										((BgL_ev_trapz00_bglt) BgL_ez00_2639))))->BgL_ez00);
						BgL_arg1340z00_2871 =
							BGl_uncompz00zz__evaluate_uncompz00(BgL_arg1341z00_2872);
					}
					BgL_arg1339z00_2870 = MAKE_YOUNG_PAIR(BgL_arg1340z00_2871, BNIL);
				}
				return
					MAKE_YOUNG_PAIR(BGl_symbol2084z00zz__evaluate_uncompz00,
					BgL_arg1339z00_2870);
			}
		}

	}



/* &uncomp-ev_prog21214 */
	obj_t BGl_z62uncompzd2ev_prog21214zb0zz__evaluate_uncompz00(obj_t
		BgL_envz00_2640, obj_t BgL_ez00_2641)
	{
		{	/* Eval/evaluate_uncomp.scm 91 */
			{	/* Eval/evaluate_uncomp.scm 93 */
				obj_t BgL_e1z00_2874;
				obj_t BgL_e2z00_2875;

				BgL_e1z00_2874 =
					BGl_uncompz00zz__evaluate_uncompz00(
					(((BgL_ev_prog2z00_bglt) COBJECT(
								((BgL_ev_prog2z00_bglt) BgL_ez00_2641)))->BgL_e1z00));
				BgL_e2z00_2875 =
					BGl_uncompz00zz__evaluate_uncompz00(
					(((BgL_ev_prog2z00_bglt) COBJECT(
								((BgL_ev_prog2z00_bglt) BgL_ez00_2641)))->BgL_e2z00));
				{	/* Eval/evaluate_uncomp.scm 94 */
					bool_t BgL_test2168z00_3390;

					if (PAIRP(BgL_e2z00_2875))
						{	/* Eval/evaluate_uncomp.scm 94 */
							BgL_test2168z00_3390 =
								(CAR(BgL_e2z00_2875) ==
								BGl_symbol2086z00zz__evaluate_uncompz00);
						}
					else
						{	/* Eval/evaluate_uncomp.scm 94 */
							BgL_test2168z00_3390 = ((bool_t) 0);
						}
					if (BgL_test2168z00_3390)
						{	/* Eval/evaluate_uncomp.scm 95 */
							obj_t BgL_arg1331z00_2876;

							BgL_arg1331z00_2876 =
								MAKE_YOUNG_PAIR(BgL_e1z00_2874,
								BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(CDR
									(BgL_e2z00_2875), BNIL));
							return MAKE_YOUNG_PAIR(BGl_symbol2086z00zz__evaluate_uncompz00,
								BgL_arg1331z00_2876);
						}
					else
						{	/* Eval/evaluate_uncomp.scm 96 */
							obj_t BgL_arg1334z00_2877;

							{	/* Eval/evaluate_uncomp.scm 96 */
								obj_t BgL_arg1335z00_2878;

								BgL_arg1335z00_2878 = MAKE_YOUNG_PAIR(BgL_e2z00_2875, BNIL);
								BgL_arg1334z00_2877 =
									MAKE_YOUNG_PAIR(BgL_e1z00_2874, BgL_arg1335z00_2878);
							}
							return
								MAKE_YOUNG_PAIR(BGl_symbol2086z00zz__evaluate_uncompz00,
								BgL_arg1334z00_2877);
						}
				}
			}
		}

	}



/* &uncomp-ev_and1212 */
	obj_t BGl_z62uncompzd2ev_and1212zb0zz__evaluate_uncompz00(obj_t
		BgL_envz00_2642, obj_t BgL_ez00_2643)
	{
		{	/* Eval/evaluate_uncomp.scm 87 */
			{	/* Eval/evaluate_uncomp.scm 89 */
				obj_t BgL_arg1317z00_2880;

				{	/* Eval/evaluate_uncomp.scm 89 */
					obj_t BgL_arg1318z00_2881;

					{	/* Eval/evaluate_uncomp.scm 89 */
						obj_t BgL_l1133z00_2882;

						BgL_l1133z00_2882 =
							(((BgL_ev_listz00_bglt) COBJECT(
									((BgL_ev_listz00_bglt)
										((BgL_ev_andz00_bglt) BgL_ez00_2643))))->BgL_argsz00);
						if (NULLP(BgL_l1133z00_2882))
							{	/* Eval/evaluate_uncomp.scm 89 */
								BgL_arg1318z00_2881 = BNIL;
							}
						else
							{	/* Eval/evaluate_uncomp.scm 89 */
								obj_t BgL_head1135z00_2883;

								{	/* Eval/evaluate_uncomp.scm 89 */
									obj_t BgL_arg1325z00_2884;

									{	/* Eval/evaluate_uncomp.scm 89 */
										obj_t BgL_arg1326z00_2885;

										BgL_arg1326z00_2885 = CAR(((obj_t) BgL_l1133z00_2882));
										BgL_arg1325z00_2884 =
											BGl_uncompz00zz__evaluate_uncompz00(
											((BgL_ev_exprz00_bglt) BgL_arg1326z00_2885));
									}
									{	/* Eval/evaluate_uncomp.scm 89 */
										obj_t BgL_res1890z00_2886;

										BgL_res1890z00_2886 =
											MAKE_YOUNG_PAIR(BgL_arg1325z00_2884, BNIL);
										BgL_head1135z00_2883 = BgL_res1890z00_2886;
									}
								}
								{	/* Eval/evaluate_uncomp.scm 89 */
									obj_t BgL_g1138z00_2887;

									BgL_g1138z00_2887 = CDR(((obj_t) BgL_l1133z00_2882));
									{
										obj_t BgL_l1133z00_2889;
										obj_t BgL_tail1136z00_2890;

										BgL_l1133z00_2889 = BgL_g1138z00_2887;
										BgL_tail1136z00_2890 = BgL_head1135z00_2883;
									BgL_zc3z04anonymousza31320ze3z87_2888:
										if (NULLP(BgL_l1133z00_2889))
											{	/* Eval/evaluate_uncomp.scm 89 */
												BgL_arg1318z00_2881 = BgL_head1135z00_2883;
											}
										else
											{	/* Eval/evaluate_uncomp.scm 89 */
												obj_t BgL_newtail1137z00_2891;

												{	/* Eval/evaluate_uncomp.scm 89 */
													obj_t BgL_arg1323z00_2892;

													{	/* Eval/evaluate_uncomp.scm 89 */
														obj_t BgL_arg1324z00_2893;

														BgL_arg1324z00_2893 =
															CAR(((obj_t) BgL_l1133z00_2889));
														BgL_arg1323z00_2892 =
															BGl_uncompz00zz__evaluate_uncompz00(
															((BgL_ev_exprz00_bglt) BgL_arg1324z00_2893));
													}
													{	/* Eval/evaluate_uncomp.scm 89 */
														obj_t BgL_res1896z00_2894;

														BgL_res1896z00_2894 =
															MAKE_YOUNG_PAIR(BgL_arg1323z00_2892, BNIL);
														BgL_newtail1137z00_2891 = BgL_res1896z00_2894;
													}
												}
												SET_CDR(BgL_tail1136z00_2890, BgL_newtail1137z00_2891);
												{	/* Eval/evaluate_uncomp.scm 89 */
													obj_t BgL_arg1322z00_2895;

													BgL_arg1322z00_2895 =
														CDR(((obj_t) BgL_l1133z00_2889));
													{
														obj_t BgL_tail1136z00_3425;
														obj_t BgL_l1133z00_3424;

														BgL_l1133z00_3424 = BgL_arg1322z00_2895;
														BgL_tail1136z00_3425 = BgL_newtail1137z00_2891;
														BgL_tail1136z00_2890 = BgL_tail1136z00_3425;
														BgL_l1133z00_2889 = BgL_l1133z00_3424;
														goto BgL_zc3z04anonymousza31320ze3z87_2888;
													}
												}
											}
									}
								}
							}
					}
					BgL_arg1317z00_2880 =
						BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_arg1318z00_2881,
						BNIL);
				}
				return
					MAKE_YOUNG_PAIR(BGl_symbol2088z00zz__evaluate_uncompz00,
					BgL_arg1317z00_2880);
			}
		}

	}



/* &uncomp-ev_or1210 */
	obj_t BGl_z62uncompzd2ev_or1210zb0zz__evaluate_uncompz00(obj_t
		BgL_envz00_2644, obj_t BgL_ez00_2645)
	{
		{	/* Eval/evaluate_uncomp.scm 83 */
			{	/* Eval/evaluate_uncomp.scm 85 */
				obj_t BgL_arg1307z00_2897;

				{	/* Eval/evaluate_uncomp.scm 85 */
					obj_t BgL_arg1308z00_2898;

					{	/* Eval/evaluate_uncomp.scm 85 */
						obj_t BgL_l1127z00_2899;

						BgL_l1127z00_2899 =
							(((BgL_ev_listz00_bglt) COBJECT(
									((BgL_ev_listz00_bglt)
										((BgL_ev_orz00_bglt) BgL_ez00_2645))))->BgL_argsz00);
						if (NULLP(BgL_l1127z00_2899))
							{	/* Eval/evaluate_uncomp.scm 85 */
								BgL_arg1308z00_2898 = BNIL;
							}
						else
							{	/* Eval/evaluate_uncomp.scm 85 */
								obj_t BgL_head1129z00_2900;

								{	/* Eval/evaluate_uncomp.scm 85 */
									obj_t BgL_arg1315z00_2901;

									{	/* Eval/evaluate_uncomp.scm 85 */
										obj_t BgL_arg1316z00_2902;

										BgL_arg1316z00_2902 = CAR(((obj_t) BgL_l1127z00_2899));
										BgL_arg1315z00_2901 =
											BGl_uncompz00zz__evaluate_uncompz00(
											((BgL_ev_exprz00_bglt) BgL_arg1316z00_2902));
									}
									{	/* Eval/evaluate_uncomp.scm 85 */
										obj_t BgL_res1882z00_2903;

										BgL_res1882z00_2903 =
											MAKE_YOUNG_PAIR(BgL_arg1315z00_2901, BNIL);
										BgL_head1129z00_2900 = BgL_res1882z00_2903;
									}
								}
								{	/* Eval/evaluate_uncomp.scm 85 */
									obj_t BgL_g1132z00_2904;

									BgL_g1132z00_2904 = CDR(((obj_t) BgL_l1127z00_2899));
									{
										obj_t BgL_l1127z00_2906;
										obj_t BgL_tail1130z00_2907;

										BgL_l1127z00_2906 = BgL_g1132z00_2904;
										BgL_tail1130z00_2907 = BgL_head1129z00_2900;
									BgL_zc3z04anonymousza31310ze3z87_2905:
										if (NULLP(BgL_l1127z00_2906))
											{	/* Eval/evaluate_uncomp.scm 85 */
												BgL_arg1308z00_2898 = BgL_head1129z00_2900;
											}
										else
											{	/* Eval/evaluate_uncomp.scm 85 */
												obj_t BgL_newtail1131z00_2908;

												{	/* Eval/evaluate_uncomp.scm 85 */
													obj_t BgL_arg1313z00_2909;

													{	/* Eval/evaluate_uncomp.scm 85 */
														obj_t BgL_arg1314z00_2910;

														BgL_arg1314z00_2910 =
															CAR(((obj_t) BgL_l1127z00_2906));
														BgL_arg1313z00_2909 =
															BGl_uncompz00zz__evaluate_uncompz00(
															((BgL_ev_exprz00_bglt) BgL_arg1314z00_2910));
													}
													{	/* Eval/evaluate_uncomp.scm 85 */
														obj_t BgL_res1888z00_2911;

														BgL_res1888z00_2911 =
															MAKE_YOUNG_PAIR(BgL_arg1313z00_2909, BNIL);
														BgL_newtail1131z00_2908 = BgL_res1888z00_2911;
													}
												}
												SET_CDR(BgL_tail1130z00_2907, BgL_newtail1131z00_2908);
												{	/* Eval/evaluate_uncomp.scm 85 */
													obj_t BgL_arg1312z00_2912;

													BgL_arg1312z00_2912 =
														CDR(((obj_t) BgL_l1127z00_2906));
													{
														obj_t BgL_tail1130z00_3451;
														obj_t BgL_l1127z00_3450;

														BgL_l1127z00_3450 = BgL_arg1312z00_2912;
														BgL_tail1130z00_3451 = BgL_newtail1131z00_2908;
														BgL_tail1130z00_2907 = BgL_tail1130z00_3451;
														BgL_l1127z00_2906 = BgL_l1127z00_3450;
														goto BgL_zc3z04anonymousza31310ze3z87_2905;
													}
												}
											}
									}
								}
							}
					}
					BgL_arg1307z00_2897 =
						BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_arg1308z00_2898,
						BNIL);
				}
				return
					MAKE_YOUNG_PAIR(BGl_symbol2090z00zz__evaluate_uncompz00,
					BgL_arg1307z00_2897);
			}
		}

	}



/* &uncomp-ev_if1208 */
	obj_t BGl_z62uncompzd2ev_if1208zb0zz__evaluate_uncompz00(obj_t
		BgL_envz00_2646, obj_t BgL_ez00_2647)
	{
		{	/* Eval/evaluate_uncomp.scm 79 */
			{	/* Eval/evaluate_uncomp.scm 81 */
				obj_t BgL_arg1296z00_2914;

				{	/* Eval/evaluate_uncomp.scm 81 */
					obj_t BgL_arg1297z00_2915;
					obj_t BgL_arg1298z00_2916;

					BgL_arg1297z00_2915 =
						BGl_uncompz00zz__evaluate_uncompz00(
						(((BgL_ev_ifz00_bglt) COBJECT(
									((BgL_ev_ifz00_bglt) BgL_ez00_2647)))->BgL_pz00));
					{	/* Eval/evaluate_uncomp.scm 81 */
						obj_t BgL_arg1302z00_2917;
						obj_t BgL_arg1303z00_2918;

						BgL_arg1302z00_2917 =
							BGl_uncompz00zz__evaluate_uncompz00(
							(((BgL_ev_ifz00_bglt) COBJECT(
										((BgL_ev_ifz00_bglt) BgL_ez00_2647)))->BgL_tz00));
						BgL_arg1303z00_2918 =
							MAKE_YOUNG_PAIR(BGl_uncompz00zz__evaluate_uncompz00(
								(((BgL_ev_ifz00_bglt) COBJECT(
											((BgL_ev_ifz00_bglt) BgL_ez00_2647)))->BgL_ez00)), BNIL);
						BgL_arg1298z00_2916 =
							MAKE_YOUNG_PAIR(BgL_arg1302z00_2917, BgL_arg1303z00_2918);
					}
					BgL_arg1296z00_2914 =
						MAKE_YOUNG_PAIR(BgL_arg1297z00_2915, BgL_arg1298z00_2916);
				}
				return
					MAKE_YOUNG_PAIR(BGl_symbol2092z00zz__evaluate_uncompz00,
					BgL_arg1296z00_2914);
			}
		}

	}



/* &uncomp-ev_litt1206 */
	obj_t BGl_z62uncompzd2ev_litt1206zb0zz__evaluate_uncompz00(obj_t
		BgL_envz00_2648, obj_t BgL_ez00_2649)
	{
		{	/* Eval/evaluate_uncomp.scm 75 */
			{	/* Eval/evaluate_uncomp.scm 77 */
				obj_t BgL_arg1292z00_2920;

				BgL_arg1292z00_2920 =
					MAKE_YOUNG_PAIR(
					(((BgL_ev_littz00_bglt) COBJECT(
								((BgL_ev_littz00_bglt) BgL_ez00_2649)))->BgL_valuez00), BNIL);
				return
					MAKE_YOUNG_PAIR(BGl_symbol2094z00zz__evaluate_uncompz00,
					BgL_arg1292z00_2920);
			}
		}

	}



/* &uncomp-ev_global1204 */
	obj_t BGl_z62uncompzd2ev_global1204zb0zz__evaluate_uncompz00(obj_t
		BgL_envz00_2650, obj_t BgL_varz00_2651)
	{
		{	/* Eval/evaluate_uncomp.scm 71 */
			return
				(((BgL_ev_globalz00_bglt) COBJECT(
						((BgL_ev_globalz00_bglt) BgL_varz00_2651)))->BgL_namez00);
		}

	}



/* &uncomp-ev_var1202 */
	obj_t BGl_z62uncompzd2ev_var1202zb0zz__evaluate_uncompz00(obj_t
		BgL_envz00_2652, obj_t BgL_varz00_2653)
	{
		{	/* Eval/evaluate_uncomp.scm 67 */
			return
				(((BgL_ev_varz00_bglt) COBJECT(
						((BgL_ev_varz00_bglt) BgL_varz00_2653)))->BgL_namez00);
		}

	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zz__evaluate_uncompz00()
	{
		{	/* Eval/evaluate_uncomp.scm 15 */
			BGl_modulezd2initializa7ationz75zz__typez00(((long) 121046086),
				BSTRING_TO_STRING(BGl_string2096z00zz__evaluate_uncompz00));
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 330490148),
				BSTRING_TO_STRING(BGl_string2096z00zz__evaluate_uncompz00));
			BGl_modulezd2initializa7ationz75zz__biglooz00(((long) 180158922),
				BSTRING_TO_STRING(BGl_string2096z00zz__evaluate_uncompz00));
			BGl_modulezd2initializa7ationz75zz__tvectorz00(((long) 135276775),
				BSTRING_TO_STRING(BGl_string2096z00zz__evaluate_uncompz00));
			BGl_modulezd2initializa7ationz75zz__structurez00(((long) 128218210),
				BSTRING_TO_STRING(BGl_string2096z00zz__evaluate_uncompz00));
			BGl_modulezd2initializa7ationz75zz__bexitz00(((long) 340267792),
				BSTRING_TO_STRING(BGl_string2096z00zz__evaluate_uncompz00));
			BGl_modulezd2initializa7ationz75zz__bignumz00(((long) 6519932),
				BSTRING_TO_STRING(BGl_string2096z00zz__evaluate_uncompz00));
			BGl_modulezd2initializa7ationz75zz__osz00(((long) 251314740),
				BSTRING_TO_STRING(BGl_string2096z00zz__evaluate_uncompz00));
			BGl_modulezd2initializa7ationz75zz__dssslz00(((long) 443936801),
				BSTRING_TO_STRING(BGl_string2096z00zz__evaluate_uncompz00));
			BGl_modulezd2initializa7ationz75zz__bitz00(((long) 439353001),
				BSTRING_TO_STRING(BGl_string2096z00zz__evaluate_uncompz00));
			BGl_modulezd2initializa7ationz75zz__paramz00(((long) 453939141),
				BSTRING_TO_STRING(BGl_string2096z00zz__evaluate_uncompz00));
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 193422112),
				BSTRING_TO_STRING(BGl_string2096z00zz__evaluate_uncompz00));
			BGl_modulezd2initializa7ationz75zz__threadz00(((long) 224967693),
				BSTRING_TO_STRING(BGl_string2096z00zz__evaluate_uncompz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long) 68574988),
				BSTRING_TO_STRING(BGl_string2096z00zz__evaluate_uncompz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)
					93454137),
				BSTRING_TO_STRING(BGl_string2096z00zz__evaluate_uncompz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(((long)
					437057797),
				BSTRING_TO_STRING(BGl_string2096z00zz__evaluate_uncompz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(((long)
					268155843),
				BSTRING_TO_STRING(BGl_string2096z00zz__evaluate_uncompz00));
			BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long)
					198620800),
				BSTRING_TO_STRING(BGl_string2096z00zz__evaluate_uncompz00));
			BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)
					473309430),
				BSTRING_TO_STRING(BGl_string2096z00zz__evaluate_uncompz00));
			BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(((long) 459519430),
				BSTRING_TO_STRING(BGl_string2096z00zz__evaluate_uncompz00));
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 460262918),
				BSTRING_TO_STRING(BGl_string2096z00zz__evaluate_uncompz00));
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) -400105135),
				BSTRING_TO_STRING(BGl_string2096z00zz__evaluate_uncompz00));
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)
					9614678), BSTRING_TO_STRING(BGl_string2096z00zz__evaluate_uncompz00));
			BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)
					376927882),
				BSTRING_TO_STRING(BGl_string2096z00zz__evaluate_uncompz00));
			BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)
					228151370),
				BSTRING_TO_STRING(BGl_string2096z00zz__evaluate_uncompz00));
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 127905250),
				BSTRING_TO_STRING(BGl_string2096z00zz__evaluate_uncompz00));
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 331540577),
				BSTRING_TO_STRING(BGl_string2096z00zz__evaluate_uncompz00));
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 86988580),
				BSTRING_TO_STRING(BGl_string2096z00zz__evaluate_uncompz00));
			BGl_modulezd2initializa7ationz75zz__ppz00(((long) 233942021),
				BSTRING_TO_STRING(BGl_string2096z00zz__evaluate_uncompz00));
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 220648206),
				BSTRING_TO_STRING(BGl_string2096z00zz__evaluate_uncompz00));
			BGl_modulezd2initializa7ationz75zz__prognz00(((long) 177147622),
				BSTRING_TO_STRING(BGl_string2096z00zz__evaluate_uncompz00));
			BGl_modulezd2initializa7ationz75zz__expandz00(((long) 414007149),
				BSTRING_TO_STRING(BGl_string2096z00zz__evaluate_uncompz00));
			BGl_modulezd2initializa7ationz75zz__evenvz00(((long) 528345299),
				BSTRING_TO_STRING(BGl_string2096z00zz__evaluate_uncompz00));
			BGl_modulezd2initializa7ationz75zz__evcompilez00(((long) 492754569),
				BSTRING_TO_STRING(BGl_string2096z00zz__evaluate_uncompz00));
			BGl_modulezd2initializa7ationz75zz__everrorz00(((long) 375872221),
				BSTRING_TO_STRING(BGl_string2096z00zz__evaluate_uncompz00));
			BGl_modulezd2initializa7ationz75zz__evmodulez00(((long) 505897955),
				BSTRING_TO_STRING(BGl_string2096z00zz__evaluate_uncompz00));
			return BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(((long) 0),
				BSTRING_TO_STRING(BGl_string2096z00zz__evaluate_uncompz00));
		}

	}

#ifdef __cplusplus
}
#endif
