/*===========================================================================*/
/*   (Llib/midi.scm)                                                         */
/*   Bigloo (4.3h)                                                           */
/*   Inria -- Sophia Antipolis (c)       Tue 12 May 2020 08:36:09 AM CEST    */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.3h/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.3h/lib/bigloo/4.3h -I Llib -lib-dir /builddir/build/BUILD/bigloo-4.3h/lib/bigloo/4.3h -unsafe -safee -copt -fPIC -copt -IUnix Llib/midi.scm -o objs/midi.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_midiscorez00_bgl {
   header_t header;
   obj_t widening;
   long BgL_formatz00;
   long BgL_tempoz00;
   long BgL_ppqz00;
   obj_t BgL_tracksz00;
} *BgL_midiscorez00_bglt;

typedef struct BgL_miditrackz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_z52streamz52;
   struct BgL_midireaderz00_bgl * BgL_z52readerz52;
   obj_t BgL_z52closez52;
   bool_t BgL_z52eotz52;
   uint32_t BgL_z52wtickz52;
   long BgL_z52statusz52;
   int32_t BgL_lenz00;
   long BgL_tempoz00;
   obj_t BgL_ipz00;
   long BgL_startz00;
   long BgL_datastartz00;
   uint32_t BgL_wtickz00;
   long BgL_statusz00;
   bool_t BgL_eotz00;
} *BgL_miditrackz00_bglt;

typedef struct BgL_midireaderz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_peekzd2bytezd2;
   obj_t BgL_readzd2bytezd2;
   obj_t BgL_readzd2int16zd2;
   obj_t BgL_readzd2int32zd2;
   obj_t BgL_readzd2intzd2;
   obj_t BgL_readzd2vlqzd2;
   obj_t BgL_readzd2charszd2;
} *BgL_midireaderz00_bglt;

typedef struct BgL_midiplayerz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_errz00;
   obj_t BgL_cdelayz00;
   obj_t BgL_noteoffz00;
   obj_t BgL_noteonz00;
   obj_t BgL_aftertouchz00;
   obj_t BgL_ctrlchangez00;
   obj_t BgL_prgmchangez00;
   obj_t BgL_afterzd2touchzd2;
   obj_t BgL_pitchz00;
   obj_t BgL_sysexz00;
   obj_t BgL_metazd2seqnumzd2;
   obj_t BgL_metazd2textzd2;
   obj_t BgL_metazd2copyrightzd2;
   obj_t BgL_metazd2trackzd2;
   obj_t BgL_metazd2instrumentzd2;
   obj_t BgL_metazd2lyriczd2;
   obj_t BgL_metazd2markerzd2;
   obj_t BgL_metazd2cuezd2;
   obj_t BgL_metazd2prgmnamezd2;
   obj_t BgL_metazd2devnamezd2;
   obj_t BgL_metazd2channprefzd2;
   obj_t BgL_metazd2midiportzd2;
   obj_t BgL_metazd2eotzd2;
   obj_t BgL_metazd2tempozd2;
   obj_t BgL_metazd2smtpezd2;
   obj_t BgL_metazd2timesigzd2;
   obj_t BgL_metazd2keysigzd2;
   obj_t BgL_metazd2seqspeczd2;
} *BgL_midiplayerz00_bglt;

typedef struct BgL_midisinkz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_streamz00;
   obj_t BgL_usleepz00;
   obj_t BgL_writezd2bytezd2;
   obj_t BgL_writezd2stringzd2;
   obj_t BgL_flushz00;
} *BgL_midisinkz00_bglt;


static obj_t BGl_z62lambda2497z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2498z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midizd2controllerzd2namez00zz__multimediazd2midizd2(long);
static obj_t BGl_midizd2readzd2mthdz00zz__multimediazd2midizd2(obj_t);
static long BGl_readzd2intzd2zz__multimediazd2midizd2(long, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midisinkzd2initzd2zz__multimediazd2midizd2(BgL_midisinkz00_bglt);
BGL_IMPORT obj_t BGl_classzd2nilzd2initz12z12zz__objectz00(obj_t);
static obj_t BGl_z62midiplayerzd2pitchzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT bool_t bigloo_strcicmp(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2noteoffzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, long, long, long);
static obj_t BGl_z62zc3z04anonymousza32399ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza31687ze3ze5zz__multimediazd2midizd2(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_midiscorez00zz__multimediazd2midizd2 = BUNSPEC;
static BgL_midiscorez00_bglt BGl_z62midiscorezd2filezb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31688ze3ze5zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62stringzd2streamzd2readzd2int16zb0zz__multimediazd2midizd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_setzd2inputzd2portzd2positionz12zc0zz__r4_ports_6_10_1z00(obj_t, long);
static obj_t BGl_z62zc3z04anonymousza32120ze3ze5zz__multimediazd2midizd2(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2ctrlchangezd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, long, long, long);
BGL_EXPORTED_DECL obj_t BGl_midizd2programzd2namez00zz__multimediazd2midizd2(long);
static obj_t BGl_objectzd2initzd2zz__multimediazd2midizd2();
static int32_t BGl_readzd2int16zd2zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62stringzd2streamzd2readzd2int32zb0zz__multimediazd2midizd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_2zb2zb2zz__r4_numbers_6_5z00(obj_t, obj_t);
static BgL_miditrackz00_bglt BGl_z62miditrackzd2filezb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_midireaderz00zz__multimediazd2midizd2 = BUNSPEC;
static int32_t BGl_readzd2int32zd2zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62readzd2int16zb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_miditrackzd2waitzd2eventz00zz__multimediazd2midizd2(BgL_miditrackz00_bglt, BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long);
BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
static obj_t BGl_z62midiplayerzd2ctrlchangezb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62midireaderzd2init1234zb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32230ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_midizd2controllerzd2namesz00zz__multimediazd2midizd2 = BUNSPEC;
static obj_t BGl_midizd2readzd2mtrkz00zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62readzd2int32zb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__multimediazd2midizd2();
static obj_t BGl_z62zc3z04anonymousza32216ze3ze5zz__multimediazd2midizd2(obj_t);
BGL_EXPORTED_DEF obj_t BGl_midisinkz00zz__multimediazd2midizd2 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32322ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62midiplayerzd2cdelayzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2afterzd2touchz00zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, long, long);
static obj_t BGl_z62zc3z04anonymousza31270ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32251ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32413ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza31271ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32146ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32308ze3ze5zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31272ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62midiplayerzd2initzb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62stringzd2streamzd2readzd2vlqzb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62midiplayerzd2init1236zb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62midiscorezd2init1230zb0zz__multimediazd2midizd2(obj_t, obj_t);
static BgL_midiscorez00_bglt BGl_z62lambda2115z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32164ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza31273ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32237ze3ze5zz__multimediazd2midizd2(obj_t);
static BgL_midiscorez00_bglt BGl_z62lambda2118z62zz__multimediazd2midizd2(obj_t);
BGL_EXPORTED_DECL obj_t BGl_midireaderzd2initzd2zz__multimediazd2midizd2(BgL_midireaderz00_bglt);
static obj_t BGl_z62zc3z04anonymousza32181ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32343ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2124z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2125z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31274ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_openzd2inputzd2filez00zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2130z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2131z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32506ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza31275ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2137z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2138z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static long BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(obj_t);
static BgL_midiplayerz00_bglt BGl_z62lambda2303z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32434ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2144z62zz__multimediazd2midizd2(obj_t, obj_t);
static BgL_midiplayerz00_bglt BGl_z62lambda2306z62zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2145z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32329ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza31276ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62midisinkzd2initzb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62midiscorezd2initzb0zz__multimediazd2midizd2(obj_t, obj_t);
BGL_IMPORT obj_t create_struct(obj_t, int);
static obj_t BGl_z62lambda2313z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32524ze3ze5zz__multimediazd2midizd2(obj_t);
static BgL_miditrackz00_bglt BGl_z62lambda2152z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2314z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static BgL_miditrackz00_bglt BGl_z62lambda2155z62zz__multimediazd2midizd2(obj_t);
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2320z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2321z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__multimediazd2midizd2();
static obj_t BGl_z62lambda2162z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2163z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2327z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2328z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static BgL_midireaderz00_bglt BGl_z62lambda2168z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2169z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32364ze3ze5zz__multimediazd2midizd2(obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2aftertouchzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, long, long, long);
static obj_t BGl_z62lambda2334z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2173z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2335z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2174z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2179z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62miditrackzd2initzb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62midiplayerzd2afterzd2touchz62zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2341z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2180z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2342z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2504z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2505z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62midizd2programzd2indexz62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31547ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_midizd2textzd2namesz00zz__multimediazd2midizd2 = BUNSPEC;
static obj_t BGl_z62stringzd2streamzd2readzd2intzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2186z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2348z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2187z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2349z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62stringzd2streamzd2readzd2charszb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static BgL_midisinkz00_bglt BGl_z62lambda2512z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31580ze3ze5zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32455ze3ze5zz__multimediazd2midizd2(obj_t);
static BgL_midisinkz00_bglt BGl_z62lambda2515z62zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza31548ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32188ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2193z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2355z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2194z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2356z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t c_substring(obj_t, long, long);
static obj_t BGl_z62lambda2522z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31581ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2523z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static BgL_midireaderz00_bglt BGl_midireaderzd2stringzd2streamz00zz__multimediazd2midizd2;
static obj_t BGl_z62lambda2362z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2363z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2529z62zz__multimediazd2midizd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_readzd2charszd2zz__r4_input_6_10_2z00(obj_t, obj_t);
static obj_t BGl_z62lambda2369z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2530z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2370z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31582ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32546ze3ze5zz__multimediazd2midizd2(obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2pitchzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, long, long, long);
static obj_t BGl_z62lambda2536z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2537z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62midiplayerzd2aftertouchzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2376z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2377z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_midizd2notezd2namesz00zz__multimediazd2midizd2 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31583ze3ze5zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32385ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32547ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2544z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2383z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2545z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2384z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32491ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2390z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2552z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2391z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2553z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2397z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2398z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32492ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32476ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62midiplayerzd2noteonzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT bool_t bigloo_strcmp(obj_t, obj_t);
static obj_t BGl_z62midiplayerzd2sysexzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midizd2notezd2namez00zz__multimediazd2midizd2(long);
static BgL_midisinkz00_bglt BGl_midisinkzd2nullzd2zz__multimediazd2midizd2;
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2cdelayzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, BgL_miditrackz00_bglt, long, long, long);
static obj_t BGl_requirezd2initializa7ationz75zz__multimediazd2midizd2 = BUNSPEC;
BGL_IMPORT obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_writezd2stringzd2zz__r4_output_6_10_3z00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2prgmchangezd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, long, long);
BGL_IMPORT obj_t BGl_listzd2ze3vectorz31zz__r4_vectors_6_8z00(obj_t);
static BgL_miditrackz00_bglt BGl_z62miditrackzd2stringzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiscorezd2playzd2zz__multimediazd2midizd2(BgL_midiscorez00_bglt, BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt);
static obj_t BGl_z62stringzd2streamzd2peekzd2bytezb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_toplevelzd2initzd2zz__multimediazd2midizd2();
BGL_EXPORTED_DEF obj_t BGl_midiplayerz00zz__multimediazd2midizd2 = BUNSPEC;
static obj_t BGl_midizd2programzd2namesz00zz__multimediazd2midizd2 = BUNSPEC;
BGL_IMPORT obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
static obj_t BGl_miditrackszd2inputzd2portz00zz__multimediazd2midizd2(obj_t, long, obj_t);
static obj_t BGl_z62zc3z04anonymousza32499ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_genericzd2initzd2zz__multimediazd2midizd2();
static obj_t BGl_z62zc3z04anonymousza32202ze3ze5zz__multimediazd2midizd2(obj_t);
BGL_EXPORTED_DECL obj_t BGl_midizd2programzd2indexz00zz__multimediazd2midizd2(obj_t);
BGL_IMPORT obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t, bool_t, bool_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t bgl_reverse_bang(obj_t);
static obj_t BGl_z62midiplayerzd2prgmchangezb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_miditrackzd2playzd2eventz00zz__multimediazd2midizd2(BgL_miditrackz00_bglt, BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, long, long, BGL_LONGLONG_T);
static obj_t BGl_z62zc3z04anonymousza32132ze3ze5zz__multimediazd2midizd2(obj_t);
BGL_EXPORTED_DEF obj_t BGl_miditrackz00zz__multimediazd2midizd2 = BUNSPEC;
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
static obj_t BGl_z62midiplayerzd2ignorezb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL BgL_midiscorez00_bglt BGl_midiscorezd2filezd2zz__multimediazd2midizd2(obj_t);
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_readzd2charzd2zz__r4_input_6_10_2z00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32223ze3ze5zz__multimediazd2midizd2(obj_t);
static bool_t BGl_midiscorezd2play0zd2zz__multimediazd2midizd2(BgL_midiscorez00_bglt, BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt);
static bool_t BGl_midiscorezd2play1zd2zz__multimediazd2midizd2(BgL_midiscorez00_bglt, BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt);
BGL_EXPORTED_DECL BgL_miditrackz00_bglt BGl_miditrackzd2filezd2zz__multimediazd2midizd2(obj_t, long, long);
static obj_t BGl_z62zc3z04anonymousza32209ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32420ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32315ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62readzd2vlqzb0zz__multimediazd2midizd2(obj_t, obj_t);
BGL_IMPORT BGL_LONGLONG_T bgl_current_microseconds();
static obj_t BGl_z62zc3z04anonymousza32244ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32406ze3ze5zz__multimediazd2midizd2(obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2initzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt);
static obj_t BGl_z62zc3z04anonymousza32139ze3ze5zz__multimediazd2midizd2(obj_t);
static BgL_midiplayerz00_bglt BGl_midiplayerzd2readzd2zz__multimediazd2midizd2;
BGL_IMPORT obj_t BGl_classzd2constructorzd2zz__objectz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32350ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62midireaderzd2initzb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2200z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2201z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static BgL_miditrackz00_bglt BGl_z62miditrackzd2inputzd2portz62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32262ze3ze5zz__multimediazd2midizd2(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2noteonzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, long, long, long);
static obj_t BGl_z62lambda2207z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32157ze3ze5zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2208z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2midizd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_input_6_10_2z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__datez00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__structurez00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
static obj_t BGl_z62midizd2programzd2namez62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32441ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2214z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2215z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32336ze3ze5zz__multimediazd2midizd2(obj_t);
BGL_EXPORTED_DECL BgL_miditrackz00_bglt BGl_miditrackzd2inputzd2portz00zz__multimediazd2midizd2(obj_t, long);
static obj_t BGl_z62lambda2221z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32531ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2222z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62midiplayerzd2noteoffzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31268ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2228z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2229z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62midisinkzd2init1238zb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32427ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2235z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2236z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31269ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_cnstzd2initzd2zz__multimediazd2midizd2();
static obj_t BGl_libraryzd2moduleszd2initz00zz__multimediazd2midizd2();
static obj_t BGl_z62zc3z04anonymousza32371ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2242z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2404z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2243z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2405z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32517ze3ze5zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2249z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62readzd2intzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2411z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2250z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2412z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2418z62zz__multimediazd2midizd2(obj_t, obj_t);
static BgL_midireaderz00_bglt BGl_z62lambda2257z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2419z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_objectz00zz__objectz00;
static obj_t BGl_z62miditrackzd2init1232zb0zz__multimediazd2midizd2(obj_t, obj_t);
static BgL_midireaderz00_bglt BGl_z62lambda2260z62zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32462ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32195ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32357ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2425z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2426z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2266z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2267z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2sysexzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, obj_t);
static obj_t BGl_z62stringzd2streamzd2readzd2bytezb0zz__multimediazd2midizd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(obj_t);
static obj_t BGl_z62lambda2432z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2271z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2433z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2272z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2276z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2277z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2439z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62midizd2notezd2namez62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2440z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2281z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2282z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32448ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2446z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2447z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2286z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2287z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiscorezd2initzd2zz__multimediazd2midizd2(BgL_midiscorez00_bglt);
BGL_IMPORT obj_t BGl_callzd2withzd2inputzd2filezd2zz__r4_ports_6_10_1z00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32392ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32554ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2291z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2453z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32538ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2292z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2454z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2296z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2297z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static BgL_midireaderz00_bglt BGl_midireaderzd2inputzd2portz00zz__multimediazd2midizd2;
static obj_t BGl_z62lambda2460z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2461z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32539ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2467z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2468z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32483ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32378ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2474z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2475z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_miditrackzd2initzd2zz__multimediazd2midizd2(BgL_miditrackz00_bglt);
BGL_EXPORTED_DECL BgL_miditrackz00_bglt BGl_miditrackzd2stringzd2zz__multimediazd2midizd2(obj_t, long);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2ignorezd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, obj_t);
static obj_t BGl_z62midizd2controllerzd2namez62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62midiscorezd2playzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32484ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2481z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2482z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2489z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2490z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32469ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t __cnst[ 76 ] ;


BGL_IMPORT obj_t BGl_peekzd2bytezd2envz00zz__r4_input_6_10_2z00;
DEFINE_EXPORT_BGL_GENERIC( BGl_miditrackzd2initzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762miditrackza7d2i3320z00, BGl_z62miditrackzd2initzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3117z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2125za7623321z00, BGl_z62lambda2125z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3118z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2124za7623322z00, BGl_z62lambda2124z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3119z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3323za7, BGl_z62zc3z04anonymousza32132ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_GENERIC( BGl_midisinkzd2initzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midisinkza7d2in3324z00, BGl_z62midisinkzd2initzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3120z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2131za7623325z00, BGl_z62lambda2131z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3121z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2130za7623326z00, BGl_z62lambda2130z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3122z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3327za7, BGl_z62zc3z04anonymousza32139ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3123z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2138za7623328z00, BGl_z62lambda2138z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3124z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2137za7623329z00, BGl_z62lambda2137z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3125z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3330za7, BGl_z62zc3z04anonymousza32146ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3126z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2145za7623331z00, BGl_z62lambda2145z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3127z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2144za7623332z00, BGl_z62lambda2144z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3128z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3333za7, BGl_z62zc3z04anonymousza32120ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3129z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2118za7623334z00, BGl_z62lambda2118z62zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2ctrlchangezd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23335z00, BGl_z62midiplayerzd2ctrlchangezb0zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3130z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2115za7623336z00, BGl_z62lambda2115z62zz__multimediazd2midizd2, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3131z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3337za7, BGl_z62zc3z04anonymousza32164ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3132z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2163za7623338z00, BGl_z62lambda2163z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3133z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2162za7623339z00, BGl_z62lambda2162z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3134z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2169za7623340z00, BGl_z62lambda2169z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3135z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2168za7623341z00, BGl_z62lambda2168z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3136z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2174za7623342z00, BGl_z62lambda2174z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3137z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2173za7623343z00, BGl_z62lambda2173z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3138z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3344za7, BGl_z62zc3z04anonymousza32181ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3063z00zz__multimediazd2midizd2, BgL_bgl_string3063za700za7za7_3345za7, "midiscore-file", 14 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3139z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2180za7623346z00, BGl_z62lambda2180z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3064z00zz__multimediazd2midizd2, BgL_bgl_string3064za700za7za7_3347za7, "format not supported", 20 );
DEFINE_STRING( BGl_string3065z00zz__multimediazd2midizd2, BgL_bgl_string3065za700za7za7_3348za7, "midiplayer-file", 15 );
DEFINE_STRING( BGl_string3066z00zz__multimediazd2midizd2, BgL_bgl_string3066za700za7za7_3349za7, "bad midi format", 15 );
DEFINE_STRING( BGl_string3067z00zz__multimediazd2midizd2, BgL_bgl_string3067za700za7za7_3350za7, "/builddir/build/BUILD/bigloo-4.3h/api/multimedia/src/Llib/midi.scm", 66 );
DEFINE_STRING( BGl_string3068z00zz__multimediazd2midizd2, BgL_bgl_string3068za700za7za7_3351za7, "&midiscore-file", 15 );
DEFINE_STRING( BGl_string3069z00zz__multimediazd2midizd2, BgL_bgl_string3069za700za7za7_3352za7, "bstring", 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3300z00zz__multimediazd2midizd2, BgL_bgl_za762midiscoreza7d2i3353z00, BGl_z62midiscorezd2init1230zb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3302z00zz__multimediazd2midizd2, BgL_bgl_za762miditrackza7d2i3354z00, BGl_z62miditrackzd2init1232zb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3140z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2179za7623355z00, BGl_z62lambda2179z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3141z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3356za7, BGl_z62zc3z04anonymousza32188ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3304z00zz__multimediazd2midizd2, BgL_bgl_za762midireaderza7d23357z00, BGl_z62midireaderzd2init1234zb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3142z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2187za7623358z00, BGl_z62lambda2187z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3143z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2186za7623359z00, BGl_z62lambda2186z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3306z00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23360z00, BGl_z62midiplayerzd2init1236zb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3144z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3361za7, BGl_z62zc3z04anonymousza32195ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3145z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2194za7623362z00, BGl_z62lambda2194z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3070z00zz__multimediazd2midizd2, BgL_bgl_string3070za700za7za7_3363za7, "&miditrack-input-port", 21 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3308z00zz__multimediazd2midizd2, BgL_bgl_za762midisinkza7d2in3364z00, BGl_z62midisinkzd2init1238zb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3146z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2193za7623365z00, BGl_z62lambda2193z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3071z00zz__multimediazd2midizd2, BgL_bgl_string3071za700za7za7_3366za7, "input-port", 10 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3147z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3367za7, BGl_z62zc3z04anonymousza32202ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3072z00zz__multimediazd2midizd2, BgL_bgl_string3072za700za7za7_3368za7, "bint", 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3148z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2201za7623369z00, BGl_z62lambda2201z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3073z00zz__multimediazd2midizd2, BgL_bgl_string3073za700za7za7_3370za7, "&miditrack-file", 15 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3149z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2200za7623371z00, BGl_z62lambda2200z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3075z00zz__multimediazd2midizd2, BgL_bgl_string3075za700za7za7_3372za7, "&miditrack-string", 17 );
DEFINE_STRING( BGl_string3076z00zz__multimediazd2midizd2, BgL_bgl_string3076za700za7za7_3373za7, "midiscore-play", 14 );
DEFINE_STRING( BGl_string3077z00zz__multimediazd2midizd2, BgL_bgl_string3077za700za7za7_3374za7, "&midiscore-play", 15 );
DEFINE_STRING( BGl_string3078z00zz__multimediazd2midizd2, BgL_bgl_string3078za700za7za7_3375za7, "midiscore", 9 );
DEFINE_STRING( BGl_string3079z00zz__multimediazd2midizd2, BgL_bgl_string3079za700za7za7_3376za7, "midiplayer", 10 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3150z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3377za7, BGl_z62zc3z04anonymousza32209ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3151z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2208za7623378z00, BGl_z62lambda2208z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3152z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2207za7623379z00, BGl_z62lambda2207z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3153z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3380za7, BGl_z62zc3z04anonymousza32216ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3154z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2215za7623381z00, BGl_z62lambda2215z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3155z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2214za7623382z00, BGl_z62lambda2214z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3080z00zz__multimediazd2midizd2, BgL_bgl_string3080za700za7za7_3383za7, "midisink", 8 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3156z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3384za7, BGl_z62zc3z04anonymousza32223ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3081z00zz__multimediazd2midizd2, BgL_bgl_string3081za700za7za7_3385za7, "~x:~x", 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3157z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2222za7623386z00, BGl_z62lambda2222z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3082z00zz__multimediazd2midizd2, BgL_bgl_string3082za700za7za7_3387za7, "midiplay", 8 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3158z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2221za7623388z00, BGl_z62lambda2221z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3083z00zz__multimediazd2midizd2, BgL_bgl_string3083za700za7za7_3389za7, "illegal meta-event", 18 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3159z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3390za7, BGl_z62zc3z04anonymousza32230ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3084z00zz__multimediazd2midizd2, BgL_bgl_string3084za700za7za7_3391za7, "illegal event", 13 );
DEFINE_STRING( BGl_string3085z00zz__multimediazd2midizd2, BgL_bgl_string3085za700za7za7_3392za7, "MThd", 4 );
DEFINE_STRING( BGl_string3086z00zz__multimediazd2midizd2, BgL_bgl_string3086za700za7za7_3393za7, "read-midi-mthd", 14 );
DEFINE_STRING( BGl_string3087z00zz__multimediazd2midizd2, BgL_bgl_string3087za700za7za7_3394za7, "invalid number of SMPTE frames per second", 41 );
DEFINE_STRING( BGl_string3088z00zz__multimediazd2midizd2, BgL_bgl_string3088za700za7za7_3395za7, "Bad header", 10 );
DEFINE_STRING( BGl_string3089z00zz__multimediazd2midizd2, BgL_bgl_string3089za700za7za7_3396za7, "MTrk", 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_readzd2vlqzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762readza7d2vlqza7b03397za7, BGl_z62readzd2vlqzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3160z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2229za7623398z00, BGl_z62lambda2229z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3161z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2228za7623399z00, BGl_z62lambda2228z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3162z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3400za7, BGl_z62zc3z04anonymousza32237ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3163z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2236za7623401z00, BGl_z62lambda2236z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3164z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2235za7623402z00, BGl_z62lambda2235z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3165z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3403za7, BGl_z62zc3z04anonymousza32244ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3090z00zz__multimediazd2midizd2, BgL_bgl_string3090za700za7za7_3404za7, "read-midi-mtrk", 14 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3166z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2243za7623405z00, BGl_z62lambda2243z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3091z00zz__multimediazd2midizd2, BgL_bgl_string3091za700za7za7_3406za7, "&read-int", 9 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3167z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2242za7623407z00, BGl_z62lambda2242z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3092z00zz__multimediazd2midizd2, BgL_bgl_string3092za700za7za7_3408za7, "&string-stream-peek-byte", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3168z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3409za7, BGl_z62zc3z04anonymousza32251ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3093z00zz__multimediazd2midizd2, BgL_bgl_string3093za700za7za7_3410za7, "struct", 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3169z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2250za7623411z00, BGl_z62lambda2250z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3094z00zz__multimediazd2midizd2, BgL_bgl_string3094za700za7za7_3412za7, "&string-stream-read-byte", 24 );
DEFINE_STRING( BGl_string3095z00zz__multimediazd2midizd2, BgL_bgl_string3095za700za7za7_3413za7, "&string-stream-read-int16", 25 );
DEFINE_STRING( BGl_string3096z00zz__multimediazd2midizd2, BgL_bgl_string3096za700za7za7_3414za7, "&string-stream-read-int32", 25 );
DEFINE_STRING( BGl_string3097z00zz__multimediazd2midizd2, BgL_bgl_string3097za700za7za7_3415za7, "&string-stream-read-int", 23 );
DEFINE_STRING( BGl_string3098z00zz__multimediazd2midizd2, BgL_bgl_string3098za700za7za7_3416za7, "&string-stream-read-chars", 25 );
DEFINE_STRING( BGl_string3099z00zz__multimediazd2midizd2, BgL_bgl_string3099za700za7za7_3417za7, "&midiplayer-cdelay", 18 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3170z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2249za7623418z00, BGl_z62lambda2249z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3171z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3419za7, BGl_z62zc3z04anonymousza32157ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3172z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2155za7623420z00, BGl_z62lambda2155z62zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3173z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2152za7623421z00, BGl_z62lambda2152z62zz__multimediazd2midizd2, 0L, BUNSPEC, 14 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3174z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2267za7623422z00, BGl_z62lambda2267z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3175z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2266za7623423z00, BGl_z62lambda2266z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3176z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2272za7623424z00, BGl_z62lambda2272z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3177z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2271za7623425z00, BGl_z62lambda2271z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3178z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2277za7623426z00, BGl_z62lambda2277z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3179z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2276za7623427z00, BGl_z62lambda2276z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_stringzd2streamzd2readzd2vlqzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762stringza7d2stre3428z00, BGl_z62stringzd2streamzd2readzd2vlqzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3180z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2282za7623429z00, BGl_z62lambda2282z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3181z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2281za7623430z00, BGl_z62lambda2281z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3182z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2287za7623431z00, BGl_z62lambda2287z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3183z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2286za7623432z00, BGl_z62lambda2286z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3184z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2292za7623433z00, BGl_z62lambda2292z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3185z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2291za7623434z00, BGl_z62lambda2291z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3186z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2297za7623435z00, BGl_z62lambda2297z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3187z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2296za7623436z00, BGl_z62lambda2296z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3188z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3437za7, BGl_z62zc3z04anonymousza32262ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3189z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2260za7623438z00, BGl_z62lambda2260z62zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiscorezd2playzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiscoreza7d2p3439z00, BGl_z62midiscorezd2playzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3190z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2257za7623440z00, BGl_z62lambda2257z62zz__multimediazd2midizd2, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3191z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3441za7, BGl_z62zc3z04anonymousza32315ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3192z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2314za7623442z00, BGl_z62lambda2314z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3193z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2313za7623443z00, BGl_z62lambda2313z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3194z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3444za7, BGl_z62zc3z04anonymousza32322ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3195z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2321za7623445z00, BGl_z62lambda2321z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3196z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2320za7623446z00, BGl_z62lambda2320z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3197z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3447za7, BGl_z62zc3z04anonymousza32329ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3198z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2328za7623448z00, BGl_z62lambda2328z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3199z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2327za7623449z00, BGl_z62lambda2327z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_readzd2int32zd2envz00zz__multimediazd2midizd2, BgL_bgl_za762readza7d2int32za73450za7, BGl_z62readzd2int32zb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_midireaderzd2initzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midireaderza7d23451z00, BGl_z62midireaderzd2initzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_miditrackzd2stringzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762miditrackza7d2s3452z00, BGl_z62miditrackzd2stringzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midizd2notezd2namezd2envzd2zz__multimediazd2midizd2, BgL_bgl_za762midiza7d2noteza7d3453za7, BGl_z62midizd2notezd2namez62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2pitchzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23454z00, BGl_z62midiplayerzd2pitchzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2noteonzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23455z00, BGl_z62midiplayerzd2noteonzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_readzd2int16zd2envz00zz__multimediazd2midizd2, BgL_bgl_za762readza7d2int16za73456za7, BGl_z62readzd2int16zb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_midiplayerzd2initzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23457z00, BGl_z62midiplayerzd2initzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
BGL_IMPORT obj_t BGl_errorzd2envzd2zz__errorz00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2noteoffzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23458z00, BGl_z62midiplayerzd2noteoffzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_EXPORT_BGL_GENERIC( BGl_midiscorezd2initzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiscoreza7d2i3459z00, BGl_z62midiscorezd2initzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
BGL_IMPORT obj_t BGl_closezd2inputzd2portzd2envzd2zz__r4_ports_6_10_1z00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_miditrackzd2filezd2envz00zz__multimediazd2midizd2, BgL_bgl_za762miditrackza7d2f3460z00, BGl_z62miditrackzd2filezb0zz__multimediazd2midizd2, 0L, BUNSPEC, 3 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23461z00, BGl_z62midiplayerzd2ignorezb0zz__multimediazd2midizd2, 0L, BUNSPEC, 4 );
DEFINE_STRING( BGl_string3100z00zz__multimediazd2midizd2, BgL_bgl_string3100za700za7za7_3462za7, "miditrack", 9 );
DEFINE_STRING( BGl_string3101z00zz__multimediazd2midizd2, BgL_bgl_string3101za700za7za7_3463za7, "&midiplayer-ignore", 18 );
DEFINE_STRING( BGl_string3102z00zz__multimediazd2midizd2, BgL_bgl_string3102za700za7za7_3464za7, "&midiplayer-noteoff", 19 );
DEFINE_STRING( BGl_string3103z00zz__multimediazd2midizd2, BgL_bgl_string3103za700za7za7_3465za7, "&midiplayer-noteon", 18 );
DEFINE_STRING( BGl_string3104z00zz__multimediazd2midizd2, BgL_bgl_string3104za700za7za7_3466za7, "&midiplayer-aftertouch", 22 );
DEFINE_STRING( BGl_string3105z00zz__multimediazd2midizd2, BgL_bgl_string3105za700za7za7_3467za7, "&midiplayer-ctrlchange", 22 );
DEFINE_STRING( BGl_string3106z00zz__multimediazd2midizd2, BgL_bgl_string3106za700za7za7_3468za7, "&midiplayer-prgmchange", 22 );
DEFINE_STRING( BGl_string3107z00zz__multimediazd2midizd2, BgL_bgl_string3107za700za7za7_3469za7, "&midiplayer-after-touch", 23 );
DEFINE_STRING( BGl_string3108z00zz__multimediazd2midizd2, BgL_bgl_string3108za700za7za7_3470za7, "&midiplayer-pitch", 17 );
DEFINE_STRING( BGl_string3109z00zz__multimediazd2midizd2, BgL_bgl_string3109za700za7za7_3471za7, "&midiplayer-sysex", 17 );
BGL_IMPORT obj_t BGl_readzd2charszd2envz00zz__r4_input_6_10_2z00;
DEFINE_STRING( BGl_string3110z00zz__multimediazd2midizd2, BgL_bgl_string3110za700za7za7_3472za7, "~a[~a]", 6 );
DEFINE_STRING( BGl_string3111z00zz__multimediazd2midizd2, BgL_bgl_string3111za700za7za7_3473za7, "&midi-note-name", 15 );
DEFINE_STRING( BGl_string3112z00zz__multimediazd2midizd2, BgL_bgl_string3112za700za7za7_3474za7, "unknown controller", 18 );
DEFINE_STRING( BGl_string3113z00zz__multimediazd2midizd2, BgL_bgl_string3113za700za7za7_3475za7, "&midi-controller-name", 21 );
DEFINE_STRING( BGl_string3114z00zz__multimediazd2midizd2, BgL_bgl_string3114za700za7za7_3476za7, "unknown program", 15 );
DEFINE_STRING( BGl_string3115z00zz__multimediazd2midizd2, BgL_bgl_string3115za700za7za7_3477za7, "&midi-program-name", 18 );
DEFINE_STRING( BGl_string3116z00zz__multimediazd2midizd2, BgL_bgl_string3116za700za7za7_3478za7, "&midi-program-index", 19 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3200z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3479za7, BGl_z62zc3z04anonymousza32336ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3201z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2335za7623480z00, BGl_z62lambda2335z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3202z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2334za7623481z00, BGl_z62lambda2334z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3203z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3482za7, BGl_z62zc3z04anonymousza32343ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3204z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2342za7623483z00, BGl_z62lambda2342z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3205z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2341za7623484z00, BGl_z62lambda2341z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3206z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3485za7, BGl_z62zc3z04anonymousza32350ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3207z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2349za7623486z00, BGl_z62lambda2349z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3208z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2348za7623487z00, BGl_z62lambda2348z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3209z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3488za7, BGl_z62zc3z04anonymousza32357ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3048z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3489za7, BGl_z62zc3z04anonymousza31268ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3049z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3490za7, BGl_z62zc3z04anonymousza31269ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3210z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2356za7623491z00, BGl_z62lambda2356z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3211z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2355za7623492z00, BGl_z62lambda2355z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3212z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3493za7, BGl_z62zc3z04anonymousza32364ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3050z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3494za7, BGl_z62zc3z04anonymousza31270ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3213z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2363za7623495z00, BGl_z62lambda2363z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3051z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3496za7, BGl_z62zc3z04anonymousza31271ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_STRING( BGl_string3301z00zz__multimediazd2midizd2, BgL_bgl_string3301za700za7za7_3497za7, "midiscore-init1230", 18 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3214z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2362za7623498z00, BGl_z62lambda2362z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3052z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3499za7, BGl_z62zc3z04anonymousza31272ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3215z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3500za7, BGl_z62zc3z04anonymousza32371ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3053z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3501za7, BGl_z62zc3z04anonymousza31273ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 5 );
DEFINE_STRING( BGl_string3303z00zz__multimediazd2midizd2, BgL_bgl_string3303za700za7za7_3502za7, "miditrack-init1232", 18 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3216z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2370za7623503z00, BGl_z62lambda2370z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3054z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3504za7, BGl_z62zc3z04anonymousza31274ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3217z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2369za7623505z00, BGl_z62lambda2369z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3055z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3506za7, BGl_z62zc3z04anonymousza31275ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_STRING( BGl_string3305z00zz__multimediazd2midizd2, BgL_bgl_string3305za700za7za7_3507za7, "midireader-init1234", 19 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3218z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3508za7, BGl_z62zc3z04anonymousza32378ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3056z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3509za7, BGl_z62zc3z04anonymousza31276ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3219z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2377za7623510z00, BGl_z62lambda2377z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3057z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3511za7, BGl_z62zc3z04anonymousza31547ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 8 );
DEFINE_STRING( BGl_string3307z00zz__multimediazd2midizd2, BgL_bgl_string3307za700za7za7_3512za7, "midiplayer-init1236", 19 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3058z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3513za7, BGl_z62zc3z04anonymousza31548ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3059z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3514za7, BGl_z62zc3z04anonymousza31580ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3309z00zz__multimediazd2midizd2, BgL_bgl_string3309za700za7za7_3515za7, "midisink-init1238", 17 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3220z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2376za7623516z00, BGl_z62lambda2376z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3221z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3517za7, BGl_z62zc3z04anonymousza32385ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3222z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2384za7623518z00, BGl_z62lambda2384z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3060z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3519za7, BGl_z62zc3z04anonymousza31581ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3310z00zz__multimediazd2midizd2, BgL_bgl_string3310za700za7za7_3520za7, "&midiscore-init", 15 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3223z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2383za7623521z00, BGl_z62lambda2383z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3061z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3522za7, BGl_z62zc3z04anonymousza31582ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3311z00zz__multimediazd2midizd2, BgL_bgl_string3311za700za7za7_3523za7, "&miditrack-init", 15 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3224z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3524za7, BGl_z62zc3z04anonymousza32392ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3062z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3525za7, BGl_z62zc3z04anonymousza31583ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3312z00zz__multimediazd2midizd2, BgL_bgl_string3312za700za7za7_3526za7, "&midireader-init", 16 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3225z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2391za7623527z00, BGl_z62lambda2391z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3313z00zz__multimediazd2midizd2, BgL_bgl_string3313za700za7za7_3528za7, "midireader", 10 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3226z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2390za7623529z00, BGl_z62lambda2390z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3314z00zz__multimediazd2midizd2, BgL_bgl_string3314za700za7za7_3530za7, "&midiplayer-init", 16 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3227z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3531za7, BGl_z62zc3z04anonymousza32399ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3315z00zz__multimediazd2midizd2, BgL_bgl_string3315za700za7za7_3532za7, "&midisink-init", 14 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3228z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2398za7623533z00, BGl_z62lambda2398z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3316z00zz__multimediazd2midizd2, BgL_bgl_string3316za700za7za7_3534za7, "#() midisink flush write-string write-byte usleep stream midiplayer meta-seqspec meta-keysig meta-timesig meta-smtpe meta-tempo meta-eot meta-midiport meta-channpref meta-devname meta-prgmname meta-cue meta-marker meta-lyric meta-instrument meta-track meta-copyright meta-text meta-seqnum sysex pitch after-touch prgmchange ctrlchange aftertouch noteon noteoff cdelay err midireader read-chars read-vlq read-int read-int32 read-int16 read-byte peek-byte miditrack eot status wtick datastart start ip int32 len %status uint32 %wtick bool %eot procedure %close %reader obj %stream __multimedia-midi midiscore vector tracks ppq tempo long format string-stream #(\"C\" \"C#\" \"D\" \"D#\" \"E\" \"F\" \"F#\" \"G\" \"G#\" \"A\" \"A#\" \"B\") #(\"\" \"Acoustic Grand Piano\" \"Bright Acoustic Piano\" \"Electric Grand Piano\" \"Honky-tonk Piano\" \"Electric Piano 1\" \"Electric Piano 2\" \"Harpsichord\" \"Clavinet\" \"Celesta\" \"Glockenspiel\" \"Music Box\" \"Vibraphone\" \"Marimba\" \"Xylophone\" \"Tubular Bells\" \"Dulcimer"
"\" \"Drawbar Organ\" \"Percussive Organ\" \"Rock Organ\" \"Church Organ\" \"Reed Organ\" \"Accordion\" \"Harmonica\" \"Tango Accordion\" \"Acoustic Guitar (nylon)\" \"Acoustic Guitar (steel)\" \"Electric Guitar (jazz)\" \"Electric Guitar (clean)\" \"Electric Guitar (muted)\" \"Overdriven Guitar\" \"Distortion Guitar\" \"Guitar harmonics\" \"Acoustic Bass\" \"Electric Bass (finger)\" \"Electric Bass (pick)\" \"Fretless Bass\" \"Slap Bass 1\" \"Slap Bass 2\" \"Synth Bass 1\" \"Synth Bass 2\" \"Violin\" \"Viola\" \"Cello\" \"Contrabass\" \"Tremolo Strings\" \"Pizzicato Strings\" \"Orchestral Harp\" \"Timpani\" \"String Ensemble 1\" \"String Ensemble 2\" \"Synth Strings 1\" \"Synth Strings 2\" \"Choir Aahs\" \"Voice Oohs\" \"Synth Voice\" \"Orchestra Hit\" \"Trumpet\" \"Trombone\" \"Tuba\" \"Muted Trumpet\" \"French Horn\" \"Brass Section\" \"Synth Brass 1\" \"Synth Brass 2\" \"Soprano Sax\" \"Alto Sax\" \"Tenor Sax\" \"Baritone Sax\" \"Oboe\" \"English Horn\" \"Bassoon\" \"Clarinet\" \"Piccolo\" \"Flute\" \"Reco"
"rder\" \"Pan Flute\" \"Blown Bottle\" \"Shakuhachi\" \"Whistle\" \"Ocarina\" \"Lead 1 (square)\" \"Lead 2 (sawtooth)\" \"Lead 3 (calliope)\" \"Lead 4 (chiff)\" \"Lead 5 (charang)\" \"Lead 6 (voice)\" \"Lead 7 (fifths)\" \"Lead 8 (bass + lead)\" \"Pad 1 (new age)\" \"Pad 2 (warm)\" \"Pad 3 (polysynth)\" \"Pad 4 (choir)\" \"Pad 5 (bowed)\" \"Pad 6 (metallic)\" \"Pad 7 (halo)\" \"Pad 8 (sweep)\" \"FX 1 (rain)\" \"FX 2 (soundtrack)\" \"FX 3 (crystal)\" \"FX 4 (atmosphere)\" \"FX 5 (brightness)\" \"FX 6 (goblins)\" \"FX 7 (echoes)\" \"FX 8 (sci-fi)\" \"Sitar\" \"Banjo\" \"Shamisen\" \"Koto\" \"Kalimba\" \"Bag pipe\" \"Fiddle\" \"Shanai\" \"Tinkle Bell\" \"Agogo\" \"Steel Drums\" \"Woodblock\" \"Taiko Drum\" \"Melodic Tom\" \"Synth Drum\" \"Reverse Cymbal\" \"Guitar Fret Noise\" \"Breath Noise\" \"Seashore\" \"Bird Tweet\" \"Telephone Ring\" \"Helicopter\" \"Applause\" \"Gunshot\") #(\"Bank Select\" \"Modulation Wheel or Lever\" \"Breath Controller\" \"Undefined\" \"Foot Controller\" \"Portamento Time\" \"Data Entr"
"y MSB\" \"Channel Volume\" \"Balance\" \"Undefined\" \"Pan\" \"Expression Controller\" \"Effect Control 1\" \"Effect Control 2\" \"Undefined\" \"Undefined\" \"General Purpose Controller 1\" \"General Purpose Controller 2\" \"General Purpose Controller 3\" \"General Purpose Controller 4\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"LSB for Control 0\" \"LSB for Control 1\" \"LSB for Control 2\" \"LSB for Control 3\" \"LSB for Control 4\" \"LSB for Control 5\" \"LSB for Control 6\" \"LSB for Control 7\" \"LSB for Control 8\" \"LSB for Control 9\" \"LSB for Control 10\" \"LSB for Control 11\" \"LSB for Control 12\" \"LSB for Control 13\" \"LSB for Control 14\" \"LSB for Control 15\" \"LSB for Control 16\" \"LSB for Control 17\" \"LSB for Control 18\" \"LSB for Control 19\" \"LSB for Control 20\" \"LSB for Control 21\" \"LSB for Control 22\" \"LSB for Control 23\" \"LSB for Control 24\" \""
"LSB for Control 25\" \"LSB for Control 26\" \"LSB for Control 27\" \"LSB for Control 28\" \"LSB for Control 29\" \"LSB for Control 30\" \"LSB for Control 31\" \"Damper Pedal on/off (Sustain)\" \"Portamento On/Off\" \"Sostenuto On/Off\" \"Soft Pedal On/Off\" \"Legato Footswitch\" \"Hold 2\" \"Sound Controller 1 (default: Sound Variation)\" \"Sound Controller 2 (default: Timbre/Harmonic Intens.)\" \"Sound Controller 3 (default: Release Time)\" \"Sound Controller 4 (default: Attack Time)\" \"Sound Controller 5 (default: Brightness)\" \"Sound Controller 6 (default: Decay Time - see MMA RP-021)\" \"Sound Controller 7 (default: Vibrato Rate - see MMA RP-021)\" \"Sound Controller 8 (default: Vibrato Depth - see MMA RP-021)\" \"Sound Controller 9 (default: Vibrato Delay - see MMA RP-021)\" \"Sound Controller 10 (default undefined - see MMA RP-021)\" \"General Purpose Controller 5\" \"General Purpose Controller 6\" \"General Purpose Controller 7\" \"General Purpose Controller 8\" \"Portamento Control\" \"Undefined\" "
"\"Undefined\" \"Undefined\" \"High Resolution Velocity Prefix\" \"Undefined\" \"Undefined\" \"Effects 1 Depth\" \"Effects 2 Depth\" \"Effects 3 Depth\" \"Effects 4 Depth\" \"Effects 5 Depth\" \"Data Increment\" \"Data Decrement\" \"Non-Registered Parameter Number (NRPN)\" \"Non-Registered Parameter Number (NRPN)\" \"Registered Parameter Number (RPN)\" \"Registered Parameter Number (RPN)\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"[Channel Mode Message] All Sound Off\" \"[Channel Mode Message] Reset All Controllers\" \"[Channel Mode Message] Local Control On/Off\" \"[Channel Mode Message] All Notes Off\" \"[Channel Mode Message] Omni Mode Off (+ all notes off)\" \"[Channel Mode Message] Omni Mode On (+ all notes off)\" \"[Channel Mode Message] Mono Mode On (+ poly off, + all notes off)\" \"[Channel Mod"
"e Message] Poly Mode On (+ mono off, +all notes off)\") #(\"\" \"text\" \"copyright\" \"track\" \"instrument\" \"lyric\" \"marker\" \"cue\") ", 5730 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3229z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2397za7623535z00, BGl_z62lambda2397z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2prgmchangezd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23536z00, BGl_z62midiplayerzd2prgmchangezb0zz__multimediazd2midizd2, 0L, BUNSPEC, 5 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midizd2controllerzd2namezd2envzd2zz__multimediazd2midizd2, BgL_bgl_za762midiza7d2contro3537z00, BGl_z62midizd2controllerzd2namez62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3230z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3538za7, BGl_z62zc3z04anonymousza32406ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3231z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2405za7623539z00, BGl_z62lambda2405z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3232z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2404za7623540z00, BGl_z62lambda2404z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3233z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3541za7, BGl_z62zc3z04anonymousza32413ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3234z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2412za7623542z00, BGl_z62lambda2412z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3235z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2411za7623543z00, BGl_z62lambda2411z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3236z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3544za7, BGl_z62zc3z04anonymousza32420ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3074z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3545za7, BGl_z62zc3z04anonymousza31688ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3237z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2419za7623546z00, BGl_z62lambda2419z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3238z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2418za7623547z00, BGl_z62lambda2418z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3239z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3548za7, BGl_z62zc3z04anonymousza32427ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_stringzd2streamzd2readzd2int32zd2envz00zz__multimediazd2midizd2, BgL_bgl_za762stringza7d2stre3549z00, BGl_z62stringzd2streamzd2readzd2int32zb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3240z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2426za7623550z00, BGl_z62lambda2426z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3241z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2425za7623551z00, BGl_z62lambda2425z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3242z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3552za7, BGl_z62zc3z04anonymousza32434ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3243z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2433za7623553z00, BGl_z62lambda2433z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3244z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2432za7623554z00, BGl_z62lambda2432z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3245z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3555za7, BGl_z62zc3z04anonymousza32441ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3246z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2440za7623556z00, BGl_z62lambda2440z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3247z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2439za7623557z00, BGl_z62lambda2439z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3248z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3558za7, BGl_z62zc3z04anonymousza32448ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3249z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2447za7623559z00, BGl_z62lambda2447z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2afterzd2touchzd2envzd2zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23560z00, BGl_z62midiplayerzd2afterzd2touchz62zz__multimediazd2midizd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3250z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2446za7623561z00, BGl_z62lambda2446z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3251z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3562za7, BGl_z62zc3z04anonymousza32455ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3252z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2454za7623563z00, BGl_z62lambda2454z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3253z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2453za7623564z00, BGl_z62lambda2453z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3254z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3565za7, BGl_z62zc3z04anonymousza32462ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3255z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2461za7623566z00, BGl_z62lambda2461z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3256z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2460za7623567z00, BGl_z62lambda2460z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3257z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3568za7, BGl_z62zc3z04anonymousza32469ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3258z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2468za7623569z00, BGl_z62lambda2468z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3259z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2467za7623570z00, BGl_z62lambda2467z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
BGL_IMPORT obj_t BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3260z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3571za7, BGl_z62zc3z04anonymousza32476ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3261z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2475za7623572z00, BGl_z62lambda2475z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3262z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2474za7623573z00, BGl_z62lambda2474z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3263z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3574za7, BGl_z62zc3z04anonymousza32483ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3264z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2482za7623575z00, BGl_z62lambda2482z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3265z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2481za7623576z00, BGl_z62lambda2481z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3266z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3577za7, BGl_z62zc3z04anonymousza32491ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3267z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2490za7623578z00, BGl_z62lambda2490z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3268z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2489za7623579z00, BGl_z62lambda2489z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3269z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3580za7, BGl_z62zc3z04anonymousza32499ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3270z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2498za7623581z00, BGl_z62lambda2498z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3271z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2497za7623582z00, BGl_z62lambda2497z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3272z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3583za7, BGl_z62zc3z04anonymousza32506ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3273z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2505za7623584z00, BGl_z62lambda2505z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3274z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2504za7623585z00, BGl_z62lambda2504z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3275z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3586za7, BGl_z62zc3z04anonymousza32308ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3276z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2306za7623587z00, BGl_z62lambda2306z62zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3277z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2303za7623588z00, BGl_z62lambda2303z62zz__multimediazd2midizd2, 0L, BUNSPEC, 28 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3278z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3589za7, BGl_z62zc3z04anonymousza32524ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3279z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2523za7623590z00, BGl_z62lambda2523z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3280z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2522za7623591z00, BGl_z62lambda2522z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3281z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3592za7, BGl_z62zc3z04anonymousza32531ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3282z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2530za7623593z00, BGl_z62lambda2530z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3283z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2529za7623594z00, BGl_z62lambda2529z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3284z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3595za7, BGl_z62zc3z04anonymousza32538ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3285z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2537za7623596z00, BGl_z62lambda2537z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3286z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2536za7623597z00, BGl_z62lambda2536z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3287z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3598za7, BGl_z62zc3z04anonymousza32546ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3288z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2545za7623599z00, BGl_z62lambda2545z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3289z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2544za7623600z00, BGl_z62lambda2544z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3290z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3601za7, BGl_z62zc3z04anonymousza32554ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3291z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2553za7623602z00, BGl_z62lambda2553z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3292z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2552za7623603z00, BGl_z62lambda2552z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3293z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3604za7, BGl_z62zc3z04anonymousza32517ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3294z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2515za7623605z00, BGl_z62lambda2515z62zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3295z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2512za7623606z00, BGl_z62lambda2512z62zz__multimediazd2midizd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3296z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3607za7, BGl_z62zc3z04anonymousza32547ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3297z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3608za7, BGl_z62zc3z04anonymousza32539ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3298z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3609za7, BGl_z62zc3z04anonymousza32492ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3299z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3610za7, BGl_z62zc3z04anonymousza32484ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 8 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_stringzd2streamzd2readzd2int16zd2envz00zz__multimediazd2midizd2, BgL_bgl_za762stringza7d2stre3611z00, BGl_z62stringzd2streamzd2readzd2int16zb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_miditrackzd2inputzd2portzd2envzd2zz__multimediazd2midizd2, BgL_bgl_za762miditrackza7d2i3612z00, BGl_z62miditrackzd2inputzd2portz62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_readzd2intzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762readza7d2intza7b03613za7, BGl_z62readzd2intzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_stringzd2streamzd2readzd2bytezd2envz00zz__multimediazd2midizd2, BgL_bgl_za762stringza7d2stre3614z00, BGl_z62stringzd2streamzd2readzd2bytezb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
BGL_IMPORT obj_t BGl_readzd2bytezd2envz00zz__r4_input_6_10_2z00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_stringzd2streamzd2readzd2intzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762stringza7d2stre3615z00, BGl_z62stringzd2streamzd2readzd2intzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
BGL_IMPORT obj_t BGl_sleepzd2envzd2zz__osz00;
BGL_IMPORT obj_t BGl_flushzd2outputzd2portzd2envzd2zz__r4_ports_6_10_1z00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiscorezd2filezd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiscoreza7d2f3616z00, BGl_z62midiscorezd2filezb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midizd2programzd2indexzd2envzd2zz__multimediazd2midizd2, BgL_bgl_za762midiza7d2progra3617z00, BGl_z62midizd2programzd2indexz62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2sysexzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23618z00, BGl_z62midiplayerzd2sysexzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 4 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2cdelayzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23619z00, BGl_z62midiplayerzd2cdelayzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 7 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midizd2programzd2namezd2envzd2zz__multimediazd2midizd2, BgL_bgl_za762midiza7d2progra3620z00, BGl_z62midizd2programzd2namez62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_stringzd2streamzd2readzd2charszd2envz00zz__multimediazd2midizd2, BgL_bgl_za762stringza7d2stre3621z00, BGl_z62stringzd2streamzd2readzd2charszb0zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2aftertouchzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23622z00, BGl_z62midiplayerzd2aftertouchzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_stringzd2streamzd2peekzd2bytezd2envz00zz__multimediazd2midizd2, BgL_bgl_za762stringza7d2stre3623z00, BGl_z62stringzd2streamzd2peekzd2bytezb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_midiscorez00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midireaderz00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midizd2controllerzd2namesz00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midisinkz00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midizd2textzd2namesz00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midireaderzd2stringzd2streamz00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midizd2notezd2namesz00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midisinkzd2nullzd2zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midiplayerz00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midizd2programzd2namesz00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_miditrackz00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midiplayerzd2readzd2zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midireaderzd2inputzd2portz00zz__multimediazd2midizd2) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2midizd2(long BgL_checksumz00_4481, char * BgL_fromz00_4482)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__multimediazd2midizd2))
{ 
BGl_requirezd2initializa7ationz75zz__multimediazd2midizd2 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__multimediazd2midizd2(); 
BGl_libraryzd2moduleszd2initz00zz__multimediazd2midizd2(); 
BGl_cnstzd2initzd2zz__multimediazd2midizd2(); 
BGl_objectzd2initzd2zz__multimediazd2midizd2(); 
BGl_genericzd2initzd2zz__multimediazd2midizd2(); 
return 
BGl_toplevelzd2initzd2zz__multimediazd2midizd2();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__multimediazd2midizd2()
{
{ /* Llib/midi.scm 15 */
BGl_modulezd2initializa7ationz75zz__r4_input_6_10_2z00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__osz00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__bitz00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__datez00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__structurez00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__biglooz00(((long)0), "__multimedia-midi"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__multimediazd2midizd2()
{
{ /* Llib/midi.scm 15 */
{ /* Llib/midi.scm 15 */
obj_t BgL_cportz00_4114;
{ /* Llib/midi.scm 15 */
obj_t BgL_stringz00_4122;
BgL_stringz00_4122 = BGl_string3316z00zz__multimediazd2midizd2; 
{ /* Llib/midi.scm 15 */
obj_t BgL_startz00_4123;
BgL_startz00_4123 = 
BINT(((long)0)); 
{ /* Llib/midi.scm 15 */
obj_t BgL_endz00_4124;
BgL_endz00_4124 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_4122))); 
{ /* Llib/midi.scm 15 */

BgL_cportz00_4114 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_4122, BgL_startz00_4123, BgL_endz00_4124); } } } } 
{ 
long BgL_iz00_4115;
BgL_iz00_4115 = ((long)75); 
BgL_loopz00_4116:
if(
(BgL_iz00_4115==((long)-1)))
{ /* Llib/midi.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/midi.scm 15 */
{ /* Llib/midi.scm 15 */
obj_t BgL_arg3318z00_4118;
{ /* Llib/midi.scm 15 */

{ /* Llib/midi.scm 15 */
obj_t BgL_locationz00_4120;
BgL_locationz00_4120 = 
BBOOL(((bool_t)0)); 
{ /* Llib/midi.scm 15 */

BgL_arg3318z00_4118 = 
BGl_readz00zz__readerz00(BgL_cportz00_4114, BgL_locationz00_4120); } } } 
{ /* Llib/midi.scm 15 */
int BgL_tmpz00_4519;
BgL_tmpz00_4519 = 
(int)(BgL_iz00_4115); 
CNST_TABLE_SET(BgL_tmpz00_4519, BgL_arg3318z00_4118); } } 
{ /* Llib/midi.scm 15 */
int BgL_auxz00_4121;
BgL_auxz00_4121 = 
(int)(
(BgL_iz00_4115-((long)1))); 
{ 
long BgL_iz00_4524;
BgL_iz00_4524 = 
(long)(BgL_auxz00_4121); 
BgL_iz00_4115 = BgL_iz00_4524; 
goto BgL_loopz00_4116;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__multimediazd2midizd2()
{
{ /* Llib/midi.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__multimediazd2midizd2()
{
{ /* Llib/midi.scm 15 */
{ /* Llib/midi.scm 133 */
BgL_midireaderz00_bglt BgL_new1121z00_143;
{ /* Llib/midi.scm 134 */
BgL_midireaderz00_bglt BgL_new1120z00_145;
BgL_new1120z00_145 = 
((BgL_midireaderz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midireaderz00_bgl) ))); 
{ /* Llib/midi.scm 134 */
long BgL_arg1258z00_146;
{ /* Llib/midi.scm 134 */
long BgL_res2561z00_1862;
BgL_res2561z00_1862 = 
BGL_CLASS_INDEX(BGl_midireaderz00zz__multimediazd2midizd2); 
BgL_arg1258z00_146 = BgL_res2561z00_1862; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1120z00_145), BgL_arg1258z00_146); } 
BgL_new1121z00_143 = BgL_new1120z00_145; } 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1121z00_143))->BgL_peekzd2bytezd2)=((obj_t)BGl_peekzd2bytezd2envz00zz__r4_input_6_10_2z00),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1121z00_143))->BgL_readzd2bytezd2)=((obj_t)BGl_readzd2bytezd2envz00zz__r4_input_6_10_2z00),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1121z00_143))->BgL_readzd2int16zd2)=((obj_t)BGl_readzd2int16zd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1121z00_143))->BgL_readzd2int32zd2)=((obj_t)BGl_readzd2int32zd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1121z00_143))->BgL_readzd2intzd2)=((obj_t)BGl_readzd2intzd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1121z00_143))->BgL_readzd2vlqzd2)=((obj_t)BGl_readzd2vlqzd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1121z00_143))->BgL_readzd2charszd2)=((obj_t)BGl_readzd2charszd2envz00zz__r4_input_6_10_2z00),BUNSPEC); 
{ /* Llib/midi.scm 133 */
obj_t BgL_fun1240z00_144;
BgL_fun1240z00_144 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_midireaderz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun1240z00_144)(BgL_fun1240z00_144, 
((obj_t)BgL_new1121z00_143), BEOA); } 
BGl_midireaderzd2inputzd2portz00zz__multimediazd2midizd2 = BgL_new1121z00_143; } 
{ /* Llib/midi.scm 146 */
BgL_midireaderz00_bglt BgL_new1123z00_147;
{ /* Llib/midi.scm 147 */
BgL_midireaderz00_bglt BgL_new1122z00_149;
BgL_new1122z00_149 = 
((BgL_midireaderz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midireaderz00_bgl) ))); 
{ /* Llib/midi.scm 147 */
long BgL_arg1265z00_150;
{ /* Llib/midi.scm 147 */
long BgL_res2562z00_1866;
BgL_res2562z00_1866 = 
BGL_CLASS_INDEX(BGl_midireaderz00zz__multimediazd2midizd2); 
BgL_arg1265z00_150 = BgL_res2562z00_1866; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1122z00_149), BgL_arg1265z00_150); } 
BgL_new1123z00_147 = BgL_new1122z00_149; } 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1123z00_147))->BgL_peekzd2bytezd2)=((obj_t)BGl_stringzd2streamzd2peekzd2bytezd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1123z00_147))->BgL_readzd2bytezd2)=((obj_t)BGl_stringzd2streamzd2readzd2bytezd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1123z00_147))->BgL_readzd2int16zd2)=((obj_t)BGl_stringzd2streamzd2readzd2int16zd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1123z00_147))->BgL_readzd2int32zd2)=((obj_t)BGl_stringzd2streamzd2readzd2int32zd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1123z00_147))->BgL_readzd2intzd2)=((obj_t)BGl_stringzd2streamzd2readzd2intzd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1123z00_147))->BgL_readzd2vlqzd2)=((obj_t)BGl_stringzd2streamzd2readzd2vlqzd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1123z00_147))->BgL_readzd2charszd2)=((obj_t)BGl_stringzd2streamzd2readzd2charszd2envz00zz__multimediazd2midizd2),BUNSPEC); 
{ /* Llib/midi.scm 146 */
obj_t BgL_fun1259z00_148;
BgL_fun1259z00_148 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_midireaderz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun1259z00_148)(BgL_fun1259z00_148, 
((obj_t)BgL_new1123z00_147), BEOA); } 
BGl_midireaderzd2stringzd2streamz00zz__multimediazd2midizd2 = BgL_new1123z00_147; } 
{ /* Llib/midi.scm 159 */
BgL_midiplayerz00_bglt BgL_new1125z00_151;
{ /* Llib/midi.scm 159 */
BgL_midiplayerz00_bglt BgL_new1124z00_264;
BgL_new1124z00_264 = 
((BgL_midiplayerz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midiplayerz00_bgl) ))); 
{ /* Llib/midi.scm 159 */
long BgL_arg1579z00_265;
{ /* Llib/midi.scm 159 */
long BgL_res2563z00_1870;
BgL_res2563z00_1870 = 
BGL_CLASS_INDEX(BGl_midiplayerz00zz__multimediazd2midizd2); 
BgL_arg1579z00_265 = BgL_res2563z00_1870; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1124z00_264), BgL_arg1579z00_265); } 
BgL_new1125z00_151 = BgL_new1124z00_264; } 
{ 
obj_t BgL_auxz00_4565;
{ /* Llib/midi.scm 159 */
obj_t BgL_arg1266z00_152;
{ /* Llib/midi.scm 159 */
obj_t BgL_arg1267z00_153;
{ /* Llib/midi.scm 159 */
obj_t BgL_res2564z00_1874;
{ /* Llib/midi.scm 159 */
obj_t BgL_classz00_1873;
BgL_classz00_1873 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2564z00_1874 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1873); } 
BgL_arg1267z00_153 = BgL_res2564z00_1874; } 
BgL_arg1266z00_152 = 
VECTOR_REF(BgL_arg1267z00_153,((long)0)); } 
BgL_auxz00_4565 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1266z00_152); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_errz00)=((obj_t)BgL_auxz00_4565),BUNSPEC); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_cdelayz00)=((obj_t)BGl_proc3048z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_noteoffz00)=((obj_t)BGl_proc3049z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_noteonz00)=((obj_t)BGl_proc3050z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_aftertouchz00)=((obj_t)BGl_proc3051z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_ctrlchangez00)=((obj_t)BGl_proc3052z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_prgmchangez00)=((obj_t)BGl_proc3053z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_afterzd2touchzd2)=((obj_t)BGl_proc3054z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_pitchz00)=((obj_t)BGl_proc3055z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_sysexz00)=((obj_t)BGl_proc3056z00zz__multimediazd2midizd2),BUNSPEC); 
{ 
obj_t BgL_auxz00_4579;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1281z00_214;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1300z00_215;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2565z00_1877;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1876;
BgL_classz00_1876 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2565z00_1877 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1876); } 
BgL_arg1300z00_215 = BgL_res2565z00_1877; } 
BgL_arg1281z00_214 = 
VECTOR_REF(BgL_arg1300z00_215,((long)10)); } 
BgL_auxz00_4579 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1281z00_214); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2seqnumzd2)=((obj_t)BgL_auxz00_4579),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4584;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1325z00_216;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1326z00_217;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2566z00_1880;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1879;
BgL_classz00_1879 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2566z00_1880 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1879); } 
BgL_arg1326z00_217 = BgL_res2566z00_1880; } 
BgL_arg1325z00_216 = 
VECTOR_REF(BgL_arg1326z00_217,((long)11)); } 
BgL_auxz00_4584 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1325z00_216); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2textzd2)=((obj_t)BgL_auxz00_4584),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4589;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1330z00_218;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1333z00_219;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2567z00_1883;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1882;
BgL_classz00_1882 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2567z00_1883 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1882); } 
BgL_arg1333z00_219 = BgL_res2567z00_1883; } 
BgL_arg1330z00_218 = 
VECTOR_REF(BgL_arg1333z00_219,((long)12)); } 
BgL_auxz00_4589 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1330z00_218); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2copyrightzd2)=((obj_t)BgL_auxz00_4589),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4594;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1334z00_220;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1336z00_221;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2568z00_1886;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1885;
BgL_classz00_1885 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2568z00_1886 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1885); } 
BgL_arg1336z00_221 = BgL_res2568z00_1886; } 
BgL_arg1334z00_220 = 
VECTOR_REF(BgL_arg1336z00_221,((long)13)); } 
BgL_auxz00_4594 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1334z00_220); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2trackzd2)=((obj_t)BgL_auxz00_4594),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4599;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1337z00_222;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1338z00_223;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2569z00_1889;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1888;
BgL_classz00_1888 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2569z00_1889 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1888); } 
BgL_arg1338z00_223 = BgL_res2569z00_1889; } 
BgL_arg1337z00_222 = 
VECTOR_REF(BgL_arg1338z00_223,((long)14)); } 
BgL_auxz00_4599 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1337z00_222); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2instrumentzd2)=((obj_t)BgL_auxz00_4599),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4604;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1347z00_224;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1348z00_225;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2570z00_1892;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1891;
BgL_classz00_1891 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2570z00_1892 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1891); } 
BgL_arg1348z00_225 = BgL_res2570z00_1892; } 
BgL_arg1347z00_224 = 
VECTOR_REF(BgL_arg1348z00_225,((long)15)); } 
BgL_auxz00_4604 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1347z00_224); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2lyriczd2)=((obj_t)BgL_auxz00_4604),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4609;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1349z00_226;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1351z00_227;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2571z00_1895;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1894;
BgL_classz00_1894 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2571z00_1895 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1894); } 
BgL_arg1351z00_227 = BgL_res2571z00_1895; } 
BgL_arg1349z00_226 = 
VECTOR_REF(BgL_arg1351z00_227,((long)16)); } 
BgL_auxz00_4609 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1349z00_226); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2markerzd2)=((obj_t)BgL_auxz00_4609),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4614;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1352z00_228;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1353z00_229;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2572z00_1898;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1897;
BgL_classz00_1897 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2572z00_1898 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1897); } 
BgL_arg1353z00_229 = BgL_res2572z00_1898; } 
BgL_arg1352z00_228 = 
VECTOR_REF(BgL_arg1353z00_229,((long)17)); } 
BgL_auxz00_4614 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1352z00_228); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2cuezd2)=((obj_t)BgL_auxz00_4614),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4619;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1354z00_230;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1383z00_231;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2573z00_1901;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1900;
BgL_classz00_1900 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2573z00_1901 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1900); } 
BgL_arg1383z00_231 = BgL_res2573z00_1901; } 
BgL_arg1354z00_230 = 
VECTOR_REF(BgL_arg1383z00_231,((long)18)); } 
BgL_auxz00_4619 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1354z00_230); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2prgmnamezd2)=((obj_t)BgL_auxz00_4619),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4624;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1384z00_232;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1505z00_233;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2574z00_1904;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1903;
BgL_classz00_1903 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2574z00_1904 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1903); } 
BgL_arg1505z00_233 = BgL_res2574z00_1904; } 
BgL_arg1384z00_232 = 
VECTOR_REF(BgL_arg1505z00_233,((long)19)); } 
BgL_auxz00_4624 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1384z00_232); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2devnamezd2)=((obj_t)BgL_auxz00_4624),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4629;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1506z00_234;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1517z00_235;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2575z00_1907;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1906;
BgL_classz00_1906 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2575z00_1907 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1906); } 
BgL_arg1517z00_235 = BgL_res2575z00_1907; } 
BgL_arg1506z00_234 = 
VECTOR_REF(BgL_arg1517z00_235,((long)20)); } 
BgL_auxz00_4629 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1506z00_234); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2channprefzd2)=((obj_t)BgL_auxz00_4629),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4634;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1518z00_236;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1524z00_237;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2576z00_1910;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1909;
BgL_classz00_1909 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2576z00_1910 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1909); } 
BgL_arg1524z00_237 = BgL_res2576z00_1910; } 
BgL_arg1518z00_236 = 
VECTOR_REF(BgL_arg1524z00_237,((long)21)); } 
BgL_auxz00_4634 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1518z00_236); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2midiportzd2)=((obj_t)BgL_auxz00_4634),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4639;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1525z00_238;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1537z00_239;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2577z00_1913;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1912;
BgL_classz00_1912 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2577z00_1913 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1912); } 
BgL_arg1537z00_239 = BgL_res2577z00_1913; } 
BgL_arg1525z00_238 = 
VECTOR_REF(BgL_arg1537z00_239,((long)22)); } 
BgL_auxz00_4639 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1525z00_238); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2eotzd2)=((obj_t)BgL_auxz00_4639),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4644;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1545z00_240;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1546z00_241;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2578z00_1916;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1915;
BgL_classz00_1915 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2578z00_1916 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1915); } 
BgL_arg1546z00_241 = BgL_res2578z00_1916; } 
BgL_arg1545z00_240 = 
VECTOR_REF(BgL_arg1546z00_241,((long)23)); } 
BgL_auxz00_4644 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1545z00_240); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2tempozd2)=((obj_t)BgL_auxz00_4644),BUNSPEC); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2smtpezd2)=((obj_t)BGl_proc3057z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2timesigzd2)=((obj_t)BGl_proc3058z00zz__multimediazd2midizd2),BUNSPEC); 
{ 
obj_t BgL_auxz00_4651;
{ /* Llib/midi.scm 83 */
obj_t BgL_arg1549z00_259;
{ /* Llib/midi.scm 83 */
obj_t BgL_arg1560z00_260;
{ /* Llib/midi.scm 83 */
obj_t BgL_res2579z00_1919;
{ /* Llib/midi.scm 83 */
obj_t BgL_classz00_1918;
BgL_classz00_1918 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2579z00_1919 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1918); } 
BgL_arg1560z00_260 = BgL_res2579z00_1919; } 
BgL_arg1549z00_259 = 
VECTOR_REF(BgL_arg1560z00_260,((long)26)); } 
BgL_auxz00_4651 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1549z00_259); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2keysigzd2)=((obj_t)BgL_auxz00_4651),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4656;
{ /* Llib/midi.scm 83 */
obj_t BgL_arg1563z00_261;
{ /* Llib/midi.scm 83 */
obj_t BgL_arg1577z00_262;
{ /* Llib/midi.scm 83 */
obj_t BgL_res2580z00_1922;
{ /* Llib/midi.scm 83 */
obj_t BgL_classz00_1921;
BgL_classz00_1921 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2580z00_1922 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1921); } 
BgL_arg1577z00_262 = BgL_res2580z00_1922; } 
BgL_arg1563z00_261 = 
VECTOR_REF(BgL_arg1577z00_262,((long)27)); } 
BgL_auxz00_4656 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1563z00_261); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2seqspeczd2)=((obj_t)BgL_auxz00_4656),BUNSPEC); } 
{ /* Llib/midi.scm 159 */
obj_t BgL_fun1578z00_263;
BgL_fun1578z00_263 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_midiplayerz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun1578z00_263)(BgL_fun1578z00_263, 
((obj_t)BgL_new1125z00_151), BEOA); } 
BGl_midiplayerzd2readzd2zz__multimediazd2midizd2 = BgL_new1125z00_151; } 
{ /* Llib/midi.scm 174 */
BgL_midisinkz00_bglt BgL_new1127z00_266;
{ /* Llib/midi.scm 174 */
BgL_midisinkz00_bglt BgL_new1126z00_278;
BgL_new1126z00_278 = 
((BgL_midisinkz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midisinkz00_bgl) ))); 
{ /* Llib/midi.scm 174 */
long BgL_arg1590z00_279;
{ /* Llib/midi.scm 174 */
long BgL_res2581z00_1925;
BgL_res2581z00_1925 = 
BGL_CLASS_INDEX(BGl_midisinkz00zz__multimediazd2midizd2); 
BgL_arg1590z00_279 = BgL_res2581z00_1925; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1126z00_278), BgL_arg1590z00_279); } 
BgL_new1127z00_266 = BgL_new1126z00_278; } 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1127z00_266))->BgL_streamz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1127z00_266))->BgL_usleepz00)=((obj_t)BGl_proc3059z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1127z00_266))->BgL_writezd2bytezd2)=((obj_t)BGl_proc3060z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1127z00_266))->BgL_writezd2stringzd2)=((obj_t)BGl_proc3061z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1127z00_266))->BgL_flushz00)=((obj_t)BGl_proc3062z00zz__multimediazd2midizd2),BUNSPEC); 
{ /* Llib/midi.scm 174 */
obj_t BgL_fun1584z00_277;
BgL_fun1584z00_277 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_midisinkz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun1584z00_277)(BgL_fun1584z00_277, 
((obj_t)BgL_new1127z00_266), BEOA); } 
BGl_midisinkzd2nullzd2zz__multimediazd2midizd2 = BgL_new1127z00_266; } 
BGl_midizd2textzd2namesz00zz__multimediazd2midizd2 = 
CNST_TABLE_REF(((long)0)); 
BGl_midizd2controllerzd2namesz00zz__multimediazd2midizd2 = 
CNST_TABLE_REF(((long)1)); 
BGl_midizd2programzd2namesz00zz__multimediazd2midizd2 = 
CNST_TABLE_REF(((long)2)); 
BGl_midizd2notezd2namesz00zz__multimediazd2midizd2 = 
CNST_TABLE_REF(((long)3)); 
return BUNSPEC;} 

}



/* &<@anonymous:1583> */
obj_t BGl_z62zc3z04anonymousza31583ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3011, obj_t BgL_opz00_3012)
{
{ /* Llib/midi.scm 178 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1582> */
obj_t BGl_z62zc3z04anonymousza31582ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3013, obj_t BgL_opz00_3014, obj_t BgL_bz00_3015)
{
{ /* Llib/midi.scm 177 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1581> */
obj_t BGl_z62zc3z04anonymousza31581ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3016, obj_t BgL_opz00_3017, obj_t BgL_bz00_3018)
{
{ /* Llib/midi.scm 176 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1580> */
obj_t BGl_z62zc3z04anonymousza31580ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3019, obj_t BgL_sz00_3020)
{
{ /* Llib/midi.scm 175 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1548> */
obj_t BGl_z62zc3z04anonymousza31548ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3021, obj_t BgL_mpz00_3022, obj_t BgL_msz00_3023, obj_t BgL_tickz00_3024, obj_t BgL_nnz00_3025, obj_t BgL_ddz00_3026, obj_t BgL_ccz00_3027, obj_t BgL_bbz00_3028)
{
{ /* Llib/midi.scm 83 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1547> */
obj_t BGl_z62zc3z04anonymousza31547ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3029, obj_t BgL_mpz00_3030, obj_t BgL_msz00_3031, obj_t BgL_tickz00_3032, obj_t BgL_hrz00_3033, obj_t BgL_mmz00_3034, obj_t BgL_sez00_3035, obj_t BgL_frz00_3036, obj_t BgL_ffz00_3037)
{
{ /* Llib/midi.scm 82 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1276> */
obj_t BGl_z62zc3z04anonymousza31276ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3038, obj_t BgL_mpz00_3039, obj_t BgL_msz00_3040, obj_t BgL_tickz00_3041, obj_t BgL_sz00_3042)
{
{ /* Llib/midi.scm 168 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1275> */
obj_t BGl_z62zc3z04anonymousza31275ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3043, obj_t BgL_mpz00_3044, obj_t BgL_msz00_3045, obj_t BgL_tickz00_3046, obj_t BgL_xz00_3047, obj_t BgL_yz00_3048, obj_t BgL_za7za7_3049)
{
{ /* Llib/midi.scm 167 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1274> */
obj_t BGl_z62zc3z04anonymousza31274ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3050, obj_t BgL_mpz00_3051, obj_t BgL_msz00_3052, obj_t BgL_tickz00_3053, obj_t BgL_xz00_3054, obj_t BgL_yz00_3055)
{
{ /* Llib/midi.scm 166 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1273> */
obj_t BGl_z62zc3z04anonymousza31273ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3056, obj_t BgL_mpz00_3057, obj_t BgL_msz00_3058, obj_t BgL_tickz00_3059, obj_t BgL_xz00_3060, obj_t BgL_yz00_3061)
{
{ /* Llib/midi.scm 165 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1272> */
obj_t BGl_z62zc3z04anonymousza31272ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3062, obj_t BgL_mpz00_3063, obj_t BgL_msz00_3064, obj_t BgL_tickz00_3065, obj_t BgL_xz00_3066, obj_t BgL_yz00_3067, obj_t BgL_za7za7_3068)
{
{ /* Llib/midi.scm 164 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1271> */
obj_t BGl_z62zc3z04anonymousza31271ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3069, obj_t BgL_mpz00_3070, obj_t BgL_msz00_3071, obj_t BgL_tickz00_3072, obj_t BgL_xz00_3073, obj_t BgL_yz00_3074, obj_t BgL_za7za7_3075)
{
{ /* Llib/midi.scm 163 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1270> */
obj_t BGl_z62zc3z04anonymousza31270ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3076, obj_t BgL_mpz00_3077, obj_t BgL_msz00_3078, obj_t BgL_tickz00_3079, obj_t BgL_xz00_3080, obj_t BgL_yz00_3081, obj_t BgL_za7za7_3082)
{
{ /* Llib/midi.scm 162 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1269> */
obj_t BGl_z62zc3z04anonymousza31269ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3083, obj_t BgL_mpz00_3084, obj_t BgL_msz00_3085, obj_t BgL_tickz00_3086, obj_t BgL_xz00_3087, obj_t BgL_yz00_3088, obj_t BgL_za7za7_3089)
{
{ /* Llib/midi.scm 161 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1268> */
obj_t BGl_z62zc3z04anonymousza31268ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3090, obj_t BgL_mpz00_3091, obj_t BgL_msz00_3092, obj_t BgL_tickz00_3093, obj_t BgL_trackz00_3094, obj_t BgL_ppqz00_3095, obj_t BgL_dtz00_3096, obj_t BgL_usz00_3097)
{
{ /* Llib/midi.scm 160 */
return 
BBOOL(((bool_t)0));} 

}



/* midiscore-file */
BGL_EXPORTED_DEF BgL_midiscorez00_bglt BGl_midiscorezd2filezd2zz__multimediazd2midizd2(obj_t BgL_filenamez00_13)
{
{ /* Llib/midi.scm 183 */
{ /* Llib/midi.scm 184 */
obj_t BgL_ipz00_296;
{ /* Llib/midi.scm 184 */

BgL_ipz00_296 = 
BGl_openzd2inputzd2filez00zz__r4_ports_6_10_1z00(BgL_filenamez00_13, BTRUE, 
BINT(((long)5000000))); } 
{ /* Llib/midi.scm 185 */
obj_t BgL_sza7za7_297;
BgL_sza7za7_297 = 
BGl_midizd2readzd2mthdz00zz__multimediazd2midizd2(BgL_ipz00_296); 
{ /* Llib/midi.scm 186 */
obj_t BgL_fmtz00_298;obj_t BgL_tckz00_299;obj_t BgL_tempoz00_300;obj_t BgL_ppqz00_301;
{ /* Llib/midi.scm 187 */
int BgL_tmpz00_4704;
BgL_tmpz00_4704 = 
(int)(((long)1)); 
BgL_fmtz00_298 = 
BGL_MVALUES_VAL(BgL_tmpz00_4704); } 
{ /* Llib/midi.scm 187 */
int BgL_tmpz00_4707;
BgL_tmpz00_4707 = 
(int)(((long)2)); 
BgL_tckz00_299 = 
BGL_MVALUES_VAL(BgL_tmpz00_4707); } 
{ /* Llib/midi.scm 187 */
int BgL_tmpz00_4710;
BgL_tmpz00_4710 = 
(int)(((long)3)); 
BgL_tempoz00_300 = 
BGL_MVALUES_VAL(BgL_tmpz00_4710); } 
{ /* Llib/midi.scm 187 */
int BgL_tmpz00_4713;
BgL_tmpz00_4713 = 
(int)(((long)4)); 
BgL_ppqz00_301 = 
BGL_MVALUES_VAL(BgL_tmpz00_4713); } 
{ /* Llib/midi.scm 187 */
obj_t BgL_tracksz00_302;
if(
INTEGERP(BgL_fmtz00_298))
{ /* Llib/midi.scm 187 */
switch( 
(long)CINT(BgL_fmtz00_298)) { case ((long)0) : 

{ /* Llib/midi.scm 188 */
obj_t BgL_v1186z00_310;
BgL_v1186z00_310 = 
create_vector(((long)1)); 
{ /* Llib/midi.scm 188 */
BgL_miditrackz00_bglt BgL_arg1649z00_311;
BgL_arg1649z00_311 = 
BGl_miditrackzd2inputzd2portz00zz__multimediazd2midizd2(BgL_ipz00_296, 
(long)CINT(BgL_tempoz00_300)); 
VECTOR_SET(BgL_v1186z00_310,((long)0),
((obj_t)BgL_arg1649z00_311)); } 
BgL_tracksz00_302 = BgL_v1186z00_310; } break;case ((long)1) : 

BgL_tracksz00_302 = 
BGl_miditrackszd2inputzd2portz00zz__multimediazd2midizd2(BgL_ipz00_296, 
(long)CINT(BgL_tempoz00_300), BgL_tckz00_299); break;case ((long)2) : 

BgL_tracksz00_302 = 
BGl_errorz00zz__errorz00(BGl_string3063z00zz__multimediazd2midizd2, BGl_string3064z00zz__multimediazd2midizd2, BgL_fmtz00_298); break;
default: 
BgL_tracksz00_302 = 
BGl_errorz00zz__errorz00(BGl_string3065z00zz__multimediazd2midizd2, BGl_string3066z00zz__multimediazd2midizd2, BgL_fmtz00_298); } }  else 
{ /* Llib/midi.scm 187 */
BgL_tracksz00_302 = 
BGl_errorz00zz__errorz00(BGl_string3065z00zz__multimediazd2midizd2, BGl_string3066z00zz__multimediazd2midizd2, BgL_fmtz00_298); } 
{ /* Llib/midi.scm 192 */
BgL_midiscorez00_bglt BgL_new1131z00_303;
{ /* Llib/midi.scm 193 */
BgL_midiscorez00_bglt BgL_new1130z00_305;
BgL_new1130z00_305 = 
((BgL_midiscorez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midiscorez00_bgl) ))); 
{ /* Llib/midi.scm 193 */
long BgL_arg1647z00_306;
{ /* Llib/midi.scm 193 */
long BgL_res2582z00_1937;
BgL_res2582z00_1937 = 
BGL_CLASS_INDEX(BGl_midiscorez00zz__multimediazd2midizd2); 
BgL_arg1647z00_306 = BgL_res2582z00_1937; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1130z00_305), BgL_arg1647z00_306); } 
BgL_new1131z00_303 = BgL_new1130z00_305; } 
((((BgL_midiscorez00_bglt)COBJECT(BgL_new1131z00_303))->BgL_formatz00)=((long)
(long)CINT(BgL_fmtz00_298)),BUNSPEC); 
((((BgL_midiscorez00_bglt)COBJECT(BgL_new1131z00_303))->BgL_tempoz00)=((long)
(long)CINT(BgL_tempoz00_300)),BUNSPEC); 
((((BgL_midiscorez00_bglt)COBJECT(BgL_new1131z00_303))->BgL_ppqz00)=((long)
(long)CINT(BgL_ppqz00_301)),BUNSPEC); 
((((BgL_midiscorez00_bglt)COBJECT(BgL_new1131z00_303))->BgL_tracksz00)=((obj_t)BgL_tracksz00_302),BUNSPEC); 
{ /* Llib/midi.scm 192 */
obj_t BgL_fun1646z00_304;
BgL_fun1646z00_304 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_midiscorez00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun1646z00_304)(BgL_fun1646z00_304, 
((obj_t)BgL_new1131z00_303), BEOA); } 
return BgL_new1131z00_303;} } } } } } 

}



/* &midiscore-file */
BgL_midiscorez00_bglt BGl_z62midiscorezd2filezb0zz__multimediazd2midizd2(obj_t BgL_envz00_3130, obj_t BgL_filenamez00_3131)
{
{ /* Llib/midi.scm 183 */
{ /* Llib/midi.scm 184 */
obj_t BgL_auxz00_4747;
if(
STRINGP(BgL_filenamez00_3131))
{ /* Llib/midi.scm 184 */
BgL_auxz00_4747 = BgL_filenamez00_3131
; }  else 
{ 
obj_t BgL_auxz00_4750;
BgL_auxz00_4750 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)8489)), BGl_string3068z00zz__multimediazd2midizd2, BGl_string3069z00zz__multimediazd2midizd2, BgL_filenamez00_3131); 
FAILURE(BgL_auxz00_4750,BFALSE,BFALSE);} 
return 
BGl_midiscorezd2filezd2zz__multimediazd2midizd2(BgL_auxz00_4747);} } 

}



/* miditrack-input-port */
BGL_EXPORTED_DEF BgL_miditrackz00_bglt BGl_miditrackzd2inputzd2portz00zz__multimediazd2midizd2(obj_t BgL_ipz00_15, long BgL_tempoz00_16)
{
{ /* Llib/midi.scm 211 */
{ /* Llib/midi.scm 212 */
BgL_miditrackz00_bglt BgL_new1135z00_328;
{ /* Llib/midi.scm 213 */
BgL_miditrackz00_bglt BgL_new1134z00_330;
BgL_new1134z00_330 = 
((BgL_miditrackz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_miditrackz00_bgl) ))); 
{ /* Llib/midi.scm 213 */
long BgL_arg1661z00_331;
{ /* Llib/midi.scm 213 */
long BgL_res2583z00_1941;
BgL_res2583z00_1941 = 
BGL_CLASS_INDEX(BGl_miditrackz00zz__multimediazd2midizd2); 
BgL_arg1661z00_331 = BgL_res2583z00_1941; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1134z00_330), BgL_arg1661z00_331); } 
BgL_new1135z00_328 = BgL_new1134z00_330; } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1135z00_328))->BgL_z52streamz52)=((obj_t)BgL_ipz00_15),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1135z00_328))->BgL_z52readerz52)=((BgL_midireaderz00_bglt)BGl_midireaderzd2inputzd2portz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1135z00_328))->BgL_z52closez52)=((obj_t)BGl_closezd2inputzd2portzd2envzd2zz__r4_ports_6_10_1z00),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1135z00_328))->BgL_z52eotz52)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1135z00_328))->BgL_z52wtickz52)=((uint32_t)(uint32_t)(0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1135z00_328))->BgL_z52statusz52)=((long)((long)0)),BUNSPEC); 
{ 
int32_t BgL_auxz00_4765;
{ /* Llib/midi.scm 216 */
obj_t BgL_tmpz00_4766;
BgL_tmpz00_4766 = 
BGl_midizd2readzd2mtrkz00zz__multimediazd2midizd2(BgL_ipz00_15); 
BgL_auxz00_4765 = 
BGL_BINT32_TO_INT32(BgL_tmpz00_4766); } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1135z00_328))->BgL_lenz00)=((int32_t)BgL_auxz00_4765),BUNSPEC); } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1135z00_328))->BgL_tempoz00)=((long)BgL_tempoz00_16),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1135z00_328))->BgL_ipz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1135z00_328))->BgL_startz00)=((long)((long)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1135z00_328))->BgL_datastartz00)=((long)((long)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1135z00_328))->BgL_wtickz00)=((uint32_t)(uint32_t)(0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1135z00_328))->BgL_statusz00)=((long)((long)-1)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1135z00_328))->BgL_eotz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ /* Llib/midi.scm 212 */
obj_t BgL_fun1659z00_329;
BgL_fun1659z00_329 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_miditrackz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun1659z00_329)(BgL_fun1659z00_329, 
((obj_t)BgL_new1135z00_328), BEOA); } 
return BgL_new1135z00_328;} } 

}



/* &miditrack-input-port */
BgL_miditrackz00_bglt BGl_z62miditrackzd2inputzd2portz62zz__multimediazd2midizd2(obj_t BgL_envz00_3132, obj_t BgL_ipz00_3133, obj_t BgL_tempoz00_3134)
{
{ /* Llib/midi.scm 211 */
{ /* Llib/midi.scm 212 */
long BgL_auxz00_4790;obj_t BgL_auxz00_4783;
{ /* Llib/midi.scm 212 */
obj_t BgL_tmpz00_4791;
if(
INTEGERP(BgL_tempoz00_3134))
{ /* Llib/midi.scm 212 */
BgL_tmpz00_4791 = BgL_tempoz00_3134
; }  else 
{ 
obj_t BgL_auxz00_4794;
BgL_auxz00_4794 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)9695)), BGl_string3070z00zz__multimediazd2midizd2, BGl_string3072z00zz__multimediazd2midizd2, BgL_tempoz00_3134); 
FAILURE(BgL_auxz00_4794,BFALSE,BFALSE);} 
BgL_auxz00_4790 = 
(long)CINT(BgL_tmpz00_4791); } 
if(
INPUT_PORTP(BgL_ipz00_3133))
{ /* Llib/midi.scm 212 */
BgL_auxz00_4783 = BgL_ipz00_3133
; }  else 
{ 
obj_t BgL_auxz00_4786;
BgL_auxz00_4786 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)9695)), BGl_string3070z00zz__multimediazd2midizd2, BGl_string3071z00zz__multimediazd2midizd2, BgL_ipz00_3133); 
FAILURE(BgL_auxz00_4786,BFALSE,BFALSE);} 
return 
BGl_miditrackzd2inputzd2portz00zz__multimediazd2midizd2(BgL_auxz00_4783, BgL_auxz00_4790);} } 

}



/* miditracks-input-port */
obj_t BGl_miditrackszd2inputzd2portz00zz__multimediazd2midizd2(obj_t BgL_ipz00_17, long BgL_tempoz00_18, obj_t BgL_tnumz00_19)
{
{ /* Llib/midi.scm 222 */
{ 
obj_t BgL_ipz00_358;long BgL_tempoz00_359;
{ /* Llib/midi.scm 241 */
BgL_miditrackz00_bglt BgL_t0z00_334;
BgL_ipz00_358 = BgL_ipz00_17; 
BgL_tempoz00_359 = BgL_tempoz00_18; 
{ /* Llib/midi.scm 225 */
BgL_miditrackz00_bglt BgL_trackz00_361;
BgL_trackz00_361 = 
BGl_miditrackzd2inputzd2portz00zz__multimediazd2midizd2(BgL_ipz00_358, BgL_tempoz00_359); 
{ /* Llib/midi.scm 227 */
BgL_midireaderz00_bglt BgL_i1137z00_363;
BgL_i1137z00_363 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_361))->BgL_z52readerz52); 
{ 

BgL_zc3z04anonymousza31681ze3z87_365:
{ /* Llib/midi.scm 229 */
obj_t BgL_fun1683z00_366;
BgL_fun1683z00_366 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1137z00_363))->BgL_readzd2vlqzd2); 
{ /* Llib/midi.scm 229 */
obj_t BgL_arg1682z00_367;
BgL_arg1682z00_367 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_361))->BgL_z52streamz52); 
PROCEDURE_ENTRY(BgL_fun1683z00_366)(BgL_fun1683z00_366, BgL_arg1682z00_367, BEOA); } } 
BGl_miditrackzd2playzd2eventz00zz__multimediazd2midizd2(BgL_trackz00_361, BGl_midiplayerzd2readzd2zz__multimediazd2midizd2, BGl_midisinkzd2nullzd2zz__multimediazd2midizd2, ((long)0), ((long)0), ((long)0), 
LONG_TO_LLONG(((long)0))); 
if(
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_361))->BgL_z52eotz52))
{ /* Llib/midi.scm 232 */
BgL_t0z00_334 = BgL_trackz00_361; }  else 
{ /* Llib/midi.scm 232 */
goto BgL_zc3z04anonymousza31681ze3z87_365;} } } } 
{ /* Llib/midi.scm 243 */
obj_t BgL_filez00_336;
{ /* Llib/midi.scm 243 */
obj_t BgL_res2584z00_1949;
BgL_res2584z00_1949 = 
INPUT_PORT_NAME(BgL_ipz00_17); 
BgL_filez00_336 = BgL_res2584z00_1949; } 
{ /* Llib/midi.scm 244 */
long BgL_g1139z00_337;
{ /* Llib/midi.scm 245 */
long BgL_res2585z00_1951;
BgL_res2585z00_1951 = 
INPUT_PORT_FILEPOS(BgL_ipz00_17); 
BgL_g1139z00_337 = BgL_res2585z00_1951; } 
{ 
long BgL_iz00_340;long BgL_posz00_341;obj_t BgL_tksz00_342;
BgL_iz00_340 = ((long)1); 
BgL_posz00_341 = BgL_g1139z00_337; 
BgL_tksz00_342 = BNIL; 
BgL_zc3z04anonymousza31662ze3z87_343:
if(
(BgL_iz00_340==
(long)CINT(BgL_tnumz00_19)))
{ /* Llib/midi.scm 248 */
obj_t BgL_arg1667z00_345;
{ /* Llib/midi.scm 248 */
obj_t BgL_arg1668z00_346;
BgL_arg1668z00_346 = 
bgl_reverse_bang(BgL_tksz00_342); 
BgL_arg1667z00_345 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_t0z00_334), BgL_arg1668z00_346); } 
return 
BGl_listzd2ze3vectorz31zz__r4_vectors_6_8z00(BgL_arg1667z00_345);}  else 
{ /* Llib/midi.scm 249 */
obj_t BgL_ipz00_347;
{ /* Llib/midi.scm 237 */
obj_t BgL_portz00_1955;
{ /* Llib/midi.scm 237 */

BgL_portz00_1955 = 
BGl_openzd2inputzd2filez00zz__r4_ports_6_10_1z00(BgL_filez00_336, BTRUE, 
BINT(((long)5000000))); } 
BGl_setzd2inputzd2portzd2positionz12zc0zz__r4_ports_6_10_1z00(BgL_portz00_1955, BgL_posz00_341); 
BgL_ipz00_347 = BgL_portz00_1955; } 
{ /* Llib/midi.scm 249 */
BgL_miditrackz00_bglt BgL_tz00_348;
BgL_tz00_348 = 
BGl_miditrackzd2inputzd2portz00zz__multimediazd2midizd2(BgL_ipz00_347, 
(((BgL_miditrackz00_bglt)COBJECT(BgL_t0z00_334))->BgL_tempoz00)); 
{ /* Llib/midi.scm 250 */

{ /* Llib/midi.scm 252 */
long BgL_arg1669z00_350;long BgL_arg1670z00_351;obj_t BgL_arg1671z00_352;
BgL_arg1669z00_350 = 
(BgL_iz00_340+((long)1)); 
{ /* Llib/midi.scm 253 */
long BgL_arg1673z00_353;long BgL_arg1674z00_354;
{ /* Llib/midi.scm 253 */
long BgL_res2588z00_1962;
{ /* Llib/midi.scm 253 */
obj_t BgL_tmpz00_4827;
BgL_tmpz00_4827 = 
((obj_t)BgL_ipz00_347); 
BgL_res2588z00_1962 = 
INPUT_PORT_FILEPOS(BgL_tmpz00_4827); } 
BgL_arg1673z00_353 = BgL_res2588z00_1962; } 
{ /* Llib/midi.scm 253 */
int32_t BgL_arg1676z00_355;
BgL_arg1676z00_355 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_tz00_348))->BgL_lenz00); 
{ /* Llib/midi.scm 253 */
long BgL_res2590z00_1967;
{ /* Llib/midi.scm 253 */
long BgL_arg1421z00_1964;
BgL_arg1421z00_1964 = 
(long)(BgL_arg1676z00_355); 
{ /* Llib/midi.scm 253 */
long BgL_res2589z00_1966;
BgL_res2589z00_1966 = 
(long)(BgL_arg1421z00_1964); 
BgL_res2590z00_1967 = BgL_res2589z00_1966; } } 
BgL_arg1674z00_354 = BgL_res2590z00_1967; } } 
BgL_arg1670z00_351 = 
(BgL_arg1673z00_353+BgL_arg1674z00_354); } 
BgL_arg1671z00_352 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_tz00_348), BgL_tksz00_342); 
{ 
obj_t BgL_tksz00_4838;long BgL_posz00_4837;long BgL_iz00_4836;
BgL_iz00_4836 = BgL_arg1669z00_350; 
BgL_posz00_4837 = BgL_arg1670z00_351; 
BgL_tksz00_4838 = BgL_arg1671z00_352; 
BgL_tksz00_342 = BgL_tksz00_4838; 
BgL_posz00_341 = BgL_posz00_4837; 
BgL_iz00_340 = BgL_iz00_4836; 
goto BgL_zc3z04anonymousza31662ze3z87_343;} } } } } } } } } } } 

}



/* miditrack-file */
BGL_EXPORTED_DEF BgL_miditrackz00_bglt BGl_miditrackzd2filezd2zz__multimediazd2midizd2(obj_t BgL_filenamez00_20, long BgL_offsetz00_21, long BgL_tempoz00_22)
{
{ /* Llib/midi.scm 259 */
{ /* Llib/midi.scm 262 */
obj_t BgL_zc3z04anonymousza31687ze3z87_3137;
BgL_zc3z04anonymousza31687ze3z87_3137 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31687ze3ze5zz__multimediazd2midizd2, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31687ze3z87_3137, 
(int)(((long)0)), 
BINT(BgL_offsetz00_21)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31687ze3z87_3137, 
(int)(((long)1)), 
BINT(BgL_tempoz00_22)); 
return 
((BgL_miditrackz00_bglt)
BGl_callzd2withzd2inputzd2filezd2zz__r4_ports_6_10_1z00(BgL_filenamez00_20, BgL_zc3z04anonymousza31687ze3z87_3137));} } 

}



/* &miditrack-file */
BgL_miditrackz00_bglt BGl_z62miditrackzd2filezb0zz__multimediazd2midizd2(obj_t BgL_envz00_3138, obj_t BgL_filenamez00_3139, obj_t BgL_offsetz00_3140, obj_t BgL_tempoz00_3141)
{
{ /* Llib/midi.scm 259 */
{ /* Llib/midi.scm 262 */
long BgL_auxz00_4866;long BgL_auxz00_4857;obj_t BgL_auxz00_4850;
{ /* Llib/midi.scm 262 */
obj_t BgL_tmpz00_4867;
if(
INTEGERP(BgL_tempoz00_3141))
{ /* Llib/midi.scm 262 */
BgL_tmpz00_4867 = BgL_tempoz00_3141
; }  else 
{ 
obj_t BgL_auxz00_4870;
BgL_auxz00_4870 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)11501)), BGl_string3073z00zz__multimediazd2midizd2, BGl_string3072z00zz__multimediazd2midizd2, BgL_tempoz00_3141); 
FAILURE(BgL_auxz00_4870,BFALSE,BFALSE);} 
BgL_auxz00_4866 = 
(long)CINT(BgL_tmpz00_4867); } 
{ /* Llib/midi.scm 262 */
obj_t BgL_tmpz00_4858;
if(
INTEGERP(BgL_offsetz00_3140))
{ /* Llib/midi.scm 262 */
BgL_tmpz00_4858 = BgL_offsetz00_3140
; }  else 
{ 
obj_t BgL_auxz00_4861;
BgL_auxz00_4861 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)11501)), BGl_string3073z00zz__multimediazd2midizd2, BGl_string3072z00zz__multimediazd2midizd2, BgL_offsetz00_3140); 
FAILURE(BgL_auxz00_4861,BFALSE,BFALSE);} 
BgL_auxz00_4857 = 
(long)CINT(BgL_tmpz00_4858); } 
if(
STRINGP(BgL_filenamez00_3139))
{ /* Llib/midi.scm 262 */
BgL_auxz00_4850 = BgL_filenamez00_3139
; }  else 
{ 
obj_t BgL_auxz00_4853;
BgL_auxz00_4853 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)11501)), BGl_string3073z00zz__multimediazd2midizd2, BGl_string3069z00zz__multimediazd2midizd2, BgL_filenamez00_3139); 
FAILURE(BgL_auxz00_4853,BFALSE,BFALSE);} 
return 
BGl_miditrackzd2filezd2zz__multimediazd2midizd2(BgL_auxz00_4850, BgL_auxz00_4857, BgL_auxz00_4866);} } 

}



/* &<@anonymous:1687> */
obj_t BGl_z62zc3z04anonymousza31687ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3142, obj_t BgL_ipz00_3145)
{
{ /* Llib/midi.scm 261 */
{ /* Llib/midi.scm 262 */
long BgL_offsetz00_3143;long BgL_tempoz00_3144;
BgL_offsetz00_3143 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_3142, 
(int)(((long)0)))); 
BgL_tempoz00_3144 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_3142, 
(int)(((long)1)))); 
{ 
BgL_miditrackz00_bglt BgL_auxz00_4882;
BGl_setzd2inputzd2portzd2positionz12zc0zz__r4_ports_6_10_1z00(BgL_ipz00_3145, BgL_offsetz00_3143); 
BgL_auxz00_4882 = 
BGl_miditrackzd2inputzd2portz00zz__multimediazd2midizd2(BgL_ipz00_3145, BgL_tempoz00_3144); 
return 
((obj_t)BgL_auxz00_4882);} } } 

}



/* miditrack-string */
BGL_EXPORTED_DEF BgL_miditrackz00_bglt BGl_miditrackzd2stringzd2zz__multimediazd2midizd2(obj_t BgL_stringz00_23, long BgL_tempoz00_24)
{
{ /* Llib/midi.scm 268 */
{ /* Llib/midi.scm 269 */
BgL_miditrackz00_bglt BgL_new1143z00_383;
{ /* Llib/midi.scm 270 */
BgL_miditrackz00_bglt BgL_new1142z00_387;
BgL_new1142z00_387 = 
((BgL_miditrackz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_miditrackz00_bgl) ))); 
{ /* Llib/midi.scm 270 */
long BgL_arg1693z00_388;
{ /* Llib/midi.scm 270 */
long BgL_res2592z00_1974;
BgL_res2592z00_1974 = 
BGL_CLASS_INDEX(BGl_miditrackz00zz__multimediazd2midizd2); 
BgL_arg1693z00_388 = BgL_res2592z00_1974; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1142z00_387), BgL_arg1693z00_388); } 
BgL_new1143z00_383 = BgL_new1142z00_387; } 
{ 
obj_t BgL_auxz00_4890;
{ /* Llib/midi.scm 127 */
obj_t BgL_newz00_1977;
BgL_newz00_1977 = 
create_struct(
CNST_TABLE_REF(((long)4)), 
(int)(((long)2))); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_4896;int BgL_tmpz00_4894;
BgL_auxz00_4896 = 
BINT(((long)0)); 
BgL_tmpz00_4894 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_1977, BgL_tmpz00_4894, BgL_auxz00_4896); } 
{ /* Llib/midi.scm 127 */
int BgL_tmpz00_4899;
BgL_tmpz00_4899 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_1977, BgL_tmpz00_4899, BgL_stringz00_23); } 
BgL_auxz00_4890 = BgL_newz00_1977; } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_383))->BgL_z52streamz52)=((obj_t)BgL_auxz00_4890),BUNSPEC); } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_383))->BgL_z52readerz52)=((BgL_midireaderz00_bglt)BGl_midireaderzd2stringzd2streamz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_383))->BgL_z52closez52)=((obj_t)BGl_proc3074z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_383))->BgL_z52eotz52)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_383))->BgL_z52wtickz52)=((uint32_t)(uint32_t)(0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_383))->BgL_z52statusz52)=((long)((long)0)),BUNSPEC); 
{ 
int32_t BgL_auxz00_4908;
{ /* Llib/midi.scm 273 */
long BgL_tmpz00_4909;
BgL_tmpz00_4909 = 
STRING_LENGTH(BgL_stringz00_23); 
BgL_auxz00_4908 = 
(int32_t)(BgL_tmpz00_4909); } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_383))->BgL_lenz00)=((int32_t)BgL_auxz00_4908),BUNSPEC); } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_383))->BgL_tempoz00)=((long)BgL_tempoz00_24),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_383))->BgL_ipz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_383))->BgL_startz00)=((long)((long)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_383))->BgL_datastartz00)=((long)((long)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_383))->BgL_wtickz00)=((uint32_t)(uint32_t)(0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_383))->BgL_statusz00)=((long)((long)-1)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_383))->BgL_eotz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ /* Llib/midi.scm 269 */
obj_t BgL_fun1689z00_386;
BgL_fun1689z00_386 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_miditrackz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun1689z00_386)(BgL_fun1689z00_386, 
((obj_t)BgL_new1143z00_383), BEOA); } 
return BgL_new1143z00_383;} } 

}



/* &miditrack-string */
BgL_miditrackz00_bglt BGl_z62miditrackzd2stringzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3147, obj_t BgL_stringz00_3148, obj_t BgL_tempoz00_3149)
{
{ /* Llib/midi.scm 268 */
{ /* Llib/midi.scm 269 */
long BgL_auxz00_4933;obj_t BgL_auxz00_4926;
{ /* Llib/midi.scm 269 */
obj_t BgL_tmpz00_4934;
if(
INTEGERP(BgL_tempoz00_3149))
{ /* Llib/midi.scm 269 */
BgL_tmpz00_4934 = BgL_tempoz00_3149
; }  else 
{ 
obj_t BgL_auxz00_4937;
BgL_auxz00_4937 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)11847)), BGl_string3075z00zz__multimediazd2midizd2, BGl_string3072z00zz__multimediazd2midizd2, BgL_tempoz00_3149); 
FAILURE(BgL_auxz00_4937,BFALSE,BFALSE);} 
BgL_auxz00_4933 = 
(long)CINT(BgL_tmpz00_4934); } 
if(
STRINGP(BgL_stringz00_3148))
{ /* Llib/midi.scm 269 */
BgL_auxz00_4926 = BgL_stringz00_3148
; }  else 
{ 
obj_t BgL_auxz00_4929;
BgL_auxz00_4929 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)11847)), BGl_string3075z00zz__multimediazd2midizd2, BGl_string3069z00zz__multimediazd2midizd2, BgL_stringz00_3148); 
FAILURE(BgL_auxz00_4929,BFALSE,BFALSE);} 
return 
BGl_miditrackzd2stringzd2zz__multimediazd2midizd2(BgL_auxz00_4926, BgL_auxz00_4933);} } 

}



/* &<@anonymous:1688> */
obj_t BGl_z62zc3z04anonymousza31688ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3150, obj_t BgL_sz00_3151)
{
{ /* Llib/midi.scm 272 */
return 
BBOOL(((bool_t)0));} 

}



/* midiscore-play */
BGL_EXPORTED_DEF obj_t BGl_midiscorezd2playzd2zz__multimediazd2midizd2(BgL_midiscorez00_bglt BgL_mscorez00_25, BgL_midiplayerz00_bglt BgL_mplayerz00_26, BgL_midisinkz00_bglt BgL_msinkz00_27)
{
{ /* Llib/midi.scm 279 */
{ 

{ /* Llib/midi.scm 281 */
long BgL_aux1146z00_391;
BgL_aux1146z00_391 = 
(((BgL_midiscorez00_bglt)COBJECT(BgL_mscorez00_25))->BgL_formatz00); 
switch( BgL_aux1146z00_391) { case ((long)0) : 

return 
BBOOL(
BGl_midiscorezd2play0zd2zz__multimediazd2midizd2(BgL_mscorez00_25, BgL_mplayerz00_26, BgL_msinkz00_27));break;case ((long)1) : 

return 
BBOOL(
BGl_midiscorezd2play1zd2zz__multimediazd2midizd2(BgL_mscorez00_25, BgL_mplayerz00_26, BgL_msinkz00_27));break;
default: 
{ /* Llib/midi.scm 284 */
long BgL_arg1695z00_393;
BgL_arg1695z00_393 = 
(((BgL_midiscorez00_bglt)COBJECT(BgL_mscorez00_25))->BgL_formatz00); 
return 
BGl_errorz00zz__errorz00(BGl_string3076z00zz__multimediazd2midizd2, BGl_string3066z00zz__multimediazd2midizd2, 
BINT(BgL_arg1695z00_393));} } } } } 

}



/* &midiscore-play */
obj_t BGl_z62midiscorezd2playzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3152, obj_t BgL_mscorez00_3153, obj_t BgL_mplayerz00_3154, obj_t BgL_msinkz00_3155)
{
{ /* Llib/midi.scm 279 */
{ /* Llib/midi.scm 280 */
BgL_midisinkz00_bglt BgL_auxz00_4969;BgL_midiplayerz00_bglt BgL_auxz00_4961;BgL_midiscorez00_bglt BgL_auxz00_4953;
if(
BGl_isazf3zf3zz__objectz00(BgL_msinkz00_3155, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 280 */
BgL_auxz00_4969 = 
((BgL_midisinkz00_bglt)BgL_msinkz00_3155)
; }  else 
{ 
obj_t BgL_auxz00_4973;
BgL_auxz00_4973 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)12346)), BGl_string3077z00zz__multimediazd2midizd2, BGl_string3080z00zz__multimediazd2midizd2, BgL_msinkz00_3155); 
FAILURE(BgL_auxz00_4973,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mplayerz00_3154, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 280 */
BgL_auxz00_4961 = 
((BgL_midiplayerz00_bglt)BgL_mplayerz00_3154)
; }  else 
{ 
obj_t BgL_auxz00_4965;
BgL_auxz00_4965 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)12346)), BGl_string3077z00zz__multimediazd2midizd2, BGl_string3079z00zz__multimediazd2midizd2, BgL_mplayerz00_3154); 
FAILURE(BgL_auxz00_4965,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mscorez00_3153, BGl_midiscorez00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 280 */
BgL_auxz00_4953 = 
((BgL_midiscorez00_bglt)BgL_mscorez00_3153)
; }  else 
{ 
obj_t BgL_auxz00_4957;
BgL_auxz00_4957 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)12346)), BGl_string3077z00zz__multimediazd2midizd2, BGl_string3078z00zz__multimediazd2midizd2, BgL_mscorez00_3153); 
FAILURE(BgL_auxz00_4957,BFALSE,BFALSE);} 
return 
BGl_midiscorezd2playzd2zz__multimediazd2midizd2(BgL_auxz00_4953, BgL_auxz00_4961, BgL_auxz00_4969);} } 

}



/* midiscore-play0 */
bool_t BGl_midiscorezd2play0zd2zz__multimediazd2midizd2(BgL_midiscorez00_bglt BgL_mscorez00_28, BgL_midiplayerz00_bglt BgL_mplayerz00_29, BgL_midisinkz00_bglt BgL_msinkz00_30)
{
{ /* Llib/midi.scm 289 */
{ /* Llib/midi.scm 291 */
obj_t BgL_trackz00_395;
BgL_trackz00_395 = 
VECTOR_REF(
(((BgL_midiscorez00_bglt)COBJECT(BgL_mscorez00_28))->BgL_tracksz00),((long)0)); 
{ /* Llib/midi.scm 293 */
BgL_midireaderz00_bglt BgL_i1149z00_397;
BgL_i1149z00_397 = 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_trackz00_395)))->BgL_z52readerz52); 
{ 
uint32_t BgL_tickz00_399;
BgL_tickz00_399 = (uint32_t)(0); 
BgL_zc3z04anonymousza31696ze3z87_400:
{ /* Llib/midi.scm 295 */
BGL_LONGLONG_T BgL_t0z00_401;
BgL_t0z00_401 = 
bgl_current_microseconds(); 
{ /* Llib/midi.scm 295 */
obj_t BgL_dtz00_402;
{ /* Llib/midi.scm 296 */
obj_t BgL_fun1702z00_407;
BgL_fun1702z00_407 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1149z00_397))->BgL_readzd2vlqzd2); 
{ /* Llib/midi.scm 296 */
obj_t BgL_arg1701z00_408;
BgL_arg1701z00_408 = 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_trackz00_395)))->BgL_z52streamz52); 
BgL_dtz00_402 = 
PROCEDURE_ENTRY(BgL_fun1702z00_407)(BgL_fun1702z00_407, BgL_arg1701z00_408, BEOA); } } 
{ /* Llib/midi.scm 296 */

{ /* Llib/midi.scm 298 */
long BgL_arg1697z00_403;long BgL_arg1698z00_404;
{ /* Llib/midi.scm 298 */
long BgL_res2595z00_1985;
BgL_res2595z00_1985 = 
(long)(BgL_tickz00_399); 
BgL_arg1697z00_403 = BgL_res2595z00_1985; } 
BgL_arg1698z00_404 = 
(((BgL_midiscorez00_bglt)COBJECT(BgL_mscorez00_28))->BgL_ppqz00); 
BGl_miditrackzd2playzd2eventz00zz__multimediazd2midizd2(
((BgL_miditrackz00_bglt)BgL_trackz00_395), BgL_mplayerz00_29, BgL_msinkz00_30, BgL_arg1697z00_403, BgL_arg1698z00_404, 
(long)CINT(BgL_dtz00_402), BgL_t0z00_401); } 
if(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_trackz00_395)))->BgL_z52eotz52))
{ /* Llib/midi.scm 299 */
return ((bool_t)0);}  else 
{ /* Llib/midi.scm 300 */
uint32_t BgL_arg1700z00_406;
BgL_arg1700z00_406 = 
(BgL_tickz00_399+
(uint32_t)(((long)1))); 
{ 
uint32_t BgL_tickz00_5000;
BgL_tickz00_5000 = BgL_arg1700z00_406; 
BgL_tickz00_399 = BgL_tickz00_5000; 
goto BgL_zc3z04anonymousza31696ze3z87_400;} } } } } } } } } 

}



/* midiscore-play1 */
bool_t BGl_midiscorezd2play1zd2zz__multimediazd2midizd2(BgL_midiscorez00_bglt BgL_mscorez00_31, BgL_midiplayerz00_bglt BgL_mplayerz00_32, BgL_midisinkz00_bglt BgL_msinkz00_33)
{
{ /* Llib/midi.scm 305 */
{ /* Llib/midi.scm 307 */
obj_t BgL_v1192z00_412;
BgL_v1192z00_412 = 
(((BgL_midiscorez00_bglt)COBJECT(BgL_mscorez00_31))->BgL_tracksz00); 
{ /* Llib/midi.scm 307 */

{ 
long BgL_i1191z00_415;
BgL_i1191z00_415 = ((long)0); 
BgL_zc3z04anonymousza31708ze3z87_416:
if(
(BgL_i1191z00_415<
VECTOR_LENGTH(BgL_v1192z00_412)))
{ /* Llib/midi.scm 307 */
{ /* Llib/midi.scm 308 */
obj_t BgL_trackz00_418;
BgL_trackz00_418 = 
VECTOR_REF(BgL_v1192z00_412,BgL_i1191z00_415); 
if(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_trackz00_418)))->BgL_z52eotz52))
{ /* Llib/midi.scm 309 */BFALSE; }  else 
{ /* Llib/midi.scm 310 */
BgL_midireaderz00_bglt BgL_i1152z00_421;
BgL_i1152z00_421 = 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_trackz00_418)))->BgL_z52readerz52); 
{ /* Llib/midi.scm 311 */
obj_t BgL_dtz00_422;
{ /* Llib/midi.scm 311 */
obj_t BgL_fun1712z00_423;
BgL_fun1712z00_423 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1152z00_421))->BgL_readzd2vlqzd2); 
{ /* Llib/midi.scm 311 */
obj_t BgL_arg1711z00_424;
BgL_arg1711z00_424 = 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_trackz00_418)))->BgL_z52streamz52); 
BgL_dtz00_422 = 
PROCEDURE_ENTRY(BgL_fun1712z00_423)(BgL_fun1712z00_423, BgL_arg1711z00_424, BEOA); } } 
{ 
uint32_t BgL_auxz00_5018;
{ /* Llib/midi.scm 312 */
int32_t BgL_res2598z00_1996;
{ /* Llib/midi.scm 312 */
long BgL_xz00_1995;
BgL_xz00_1995 = 
(long)CINT(BgL_dtz00_422); 
BgL_res2598z00_1996 = 
(int32_t)(BgL_xz00_1995); } 
BgL_auxz00_5018 = 
(uint32_t)(BgL_res2598z00_1996); } 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_trackz00_418)))->BgL_z52wtickz52)=((uint32_t)BgL_auxz00_5018),BUNSPEC); } } } } 
{ 
long BgL_i1191z00_5024;
BgL_i1191z00_5024 = 
(BgL_i1191z00_415+((long)1)); 
BgL_i1191z00_415 = BgL_i1191z00_5024; 
goto BgL_zc3z04anonymousza31708ze3z87_416;} }  else 
{ /* Llib/midi.scm 307 */((bool_t)0); } } } } 
{ /* Llib/midi.scm 314 */
long BgL_resz00_427;
{ /* Llib/midi.scm 314 */
BgL_miditrackz00_bglt BgL_i1153z00_456;
{ /* Llib/midi.scm 314 */
obj_t BgL_arg1760z00_459;
BgL_arg1760z00_459 = 
(((BgL_midiscorez00_bglt)COBJECT(BgL_mscorez00_31))->BgL_tracksz00); 
BgL_i1153z00_456 = 
((BgL_miditrackz00_bglt)
VECTOR_REF(BgL_arg1760z00_459,((long)0))); } 
BgL_resz00_427 = 
(
(((BgL_miditrackz00_bglt)COBJECT(BgL_i1153z00_456))->BgL_tempoz00)/
(((BgL_midiscorez00_bglt)COBJECT(BgL_mscorez00_31))->BgL_ppqz00)); } 
{ 
uint32_t BgL_tickz00_429;
BgL_tickz00_429 = (uint32_t)(0); 
BgL_zc3z04anonymousza31719ze3z87_430:
{ /* Llib/midi.scm 317 */
BGL_LONGLONG_T BgL_t0z00_431;
BgL_t0z00_431 = 
bgl_current_microseconds(); 
{ /* Llib/midi.scm 317 */
bool_t BgL_eosz00_432;
BgL_eosz00_432 = ((bool_t)1); 
{ /* Llib/midi.scm 318 */

{ /* Llib/midi.scm 319 */
long BgL_g1154z00_433;
{ /* Llib/midi.scm 319 */
long BgL_arg1743z00_446;
BgL_arg1743z00_446 = 
VECTOR_LENGTH(
(((BgL_midiscorez00_bglt)COBJECT(BgL_mscorez00_31))->BgL_tracksz00)); 
BgL_g1154z00_433 = 
(BgL_arg1743z00_446-((long)1)); } 
{ 
long BgL_iz00_435;
BgL_iz00_435 = BgL_g1154z00_433; 
BgL_zc3z04anonymousza31720ze3z87_436:
if(
(BgL_iz00_435>((long)0)))
{ /* Llib/midi.scm 320 */
{ /* Llib/midi.scm 321 */
obj_t BgL_trackz00_438;
BgL_trackz00_438 = 
VECTOR_REF(
(((BgL_midiscorez00_bglt)COBJECT(BgL_mscorez00_31))->BgL_tracksz00),BgL_iz00_435); 
if(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_trackz00_438)))->BgL_z52eotz52))
{ /* Llib/midi.scm 323 */BFALSE; }  else 
{ /* Llib/midi.scm 323 */
{ /* Llib/midi.scm 325 */
long BgL_arg1728z00_441;
{ /* Llib/midi.scm 325 */
long BgL_res2604z00_2012;
BgL_res2604z00_2012 = 
(long)(BgL_tickz00_429); 
BgL_arg1728z00_441 = BgL_res2604z00_2012; } 
BGl_miditrackzd2waitzd2eventz00zz__multimediazd2midizd2(
((BgL_miditrackz00_bglt)BgL_trackz00_438), BgL_mplayerz00_32, BgL_msinkz00_33, BgL_arg1728z00_441); } 
if(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_trackz00_438)))->BgL_z52eotz52))
{ /* Llib/midi.scm 326 */BFALSE; }  else 
{ /* Llib/midi.scm 326 */
BgL_eosz00_432 = ((bool_t)0); } } } 
{ 
long BgL_iz00_5049;
BgL_iz00_5049 = 
(BgL_iz00_435-((long)1)); 
BgL_iz00_435 = BgL_iz00_5049; 
goto BgL_zc3z04anonymousza31720ze3z87_436;} }  else 
{ /* Llib/midi.scm 320 */((bool_t)0); } } } 
if(BgL_eosz00_432)
{ /* Llib/midi.scm 328 */
return ((bool_t)0);}  else 
{ /* Llib/midi.scm 329 */
long BgL_usz00_448;
{ /* Llib/midi.scm 329 */
BGL_LONGLONG_T BgL_arg1756z00_453;
BgL_arg1756z00_453 = 
(
bgl_current_microseconds()-BgL_t0z00_431); 
{ /* Llib/midi.scm 329 */
long BgL_res2608z00_2020;
BgL_res2608z00_2020 = 
LLONG_TO_LONG(BgL_arg1756z00_453); 
BgL_usz00_448 = BgL_res2608z00_2020; } } 
{ /* Llib/midi.scm 331 */
obj_t BgL_fun1754z00_450;
BgL_fun1754z00_450 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msinkz00_33))->BgL_usleepz00); 
{ /* Llib/midi.scm 331 */
long BgL_arg1753z00_451;
BgL_arg1753z00_451 = 
(BgL_resz00_427-BgL_usz00_448); 
PROCEDURE_ENTRY(BgL_fun1754z00_450)(BgL_fun1754z00_450, 
BINT(BgL_arg1753z00_451), BEOA); } } 
{ 
uint32_t BgL_tickz00_5062;
BgL_tickz00_5062 = 
(BgL_tickz00_429+(uint32_t)(1)); 
BgL_tickz00_429 = BgL_tickz00_5062; 
goto BgL_zc3z04anonymousza31719ze3z87_430;} } } } } } } } 

}



/* miditrack-wait-event */
obj_t BGl_miditrackzd2waitzd2eventz00zz__multimediazd2midizd2(BgL_miditrackz00_bglt BgL_trackz00_34, BgL_midiplayerz00_bglt BgL_mplayerz00_35, BgL_midisinkz00_bglt BgL_msinkz00_36, long BgL_tickz00_37)
{
{ /* Llib/midi.scm 337 */
{ /* Llib/midi.scm 340 */
BgL_midireaderz00_bglt BgL_i1158z00_461;
BgL_i1158z00_461 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_34))->BgL_z52readerz52); 
{ /* Llib/midi.scm 341 */
bool_t BgL_test3647z00_5065;
{ /* Llib/midi.scm 341 */
uint32_t BgL_n2z00_2028;
BgL_n2z00_2028 = 
(uint32_t)(BgL_tickz00_37); 
BgL_test3647z00_5065 = 
(
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_34))->BgL_z52wtickz52)<=BgL_n2z00_2028); } 
if(BgL_test3647z00_5065)
{ 

BgL_zc3z04anonymousza31763ze3z87_465:
BGl_miditrackzd2playzd2eventz00zz__multimediazd2midizd2(BgL_trackz00_34, BgL_mplayerz00_35, BgL_msinkz00_36, BgL_tickz00_37, ((long)0), ((long)0), ((BGL_LONGLONG_T)0)); 
if(
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_34))->BgL_z52eotz52))
{ /* Llib/midi.scm 344 */
return BFALSE;}  else 
{ /* Llib/midi.scm 345 */
obj_t BgL_dtz00_467;
{ /* Llib/midi.scm 345 */
obj_t BgL_fun1768z00_470;
BgL_fun1768z00_470 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1158z00_461))->BgL_readzd2vlqzd2); 
{ /* Llib/midi.scm 345 */
obj_t BgL_arg1767z00_471;
BgL_arg1767z00_471 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_34))->BgL_z52streamz52); 
BgL_dtz00_467 = 
PROCEDURE_ENTRY(BgL_fun1768z00_470)(BgL_fun1768z00_470, BgL_arg1767z00_471, BEOA); } } 
if(
(
(long)CINT(BgL_dtz00_467)==((long)0)))
{ /* Llib/midi.scm 346 */
goto BgL_zc3z04anonymousza31763ze3z87_465;}  else 
{ 
uint32_t BgL_auxz00_5081;
{ /* Llib/midi.scm 348 */
int32_t BgL_arg1766z00_469;
{ /* Llib/midi.scm 348 */
int32_t BgL_res2613z00_2033;
{ /* Llib/midi.scm 348 */
long BgL_xz00_2032;
BgL_xz00_2032 = 
(long)CINT(BgL_dtz00_467); 
BgL_res2613z00_2033 = 
(int32_t)(BgL_xz00_2032); } 
BgL_arg1766z00_469 = BgL_res2613z00_2033; } 
{ /* Llib/midi.scm 348 */
uint32_t BgL_za71za7_2034;uint32_t BgL_za72za7_2035;
BgL_za71za7_2034 = 
(uint32_t)(BgL_tickz00_37); 
BgL_za72za7_2035 = 
(uint32_t)(BgL_arg1766z00_469); 
BgL_auxz00_5081 = 
(BgL_za71za7_2034+BgL_za72za7_2035); } } 
return 
((((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_34))->BgL_z52wtickz52)=((uint32_t)BgL_auxz00_5081),BUNSPEC);} } }  else 
{ /* Llib/midi.scm 341 */
return BFALSE;} } } } 

}



/* miditrack-play-event */
obj_t BGl_miditrackzd2playzd2eventz00zz__multimediazd2midizd2(BgL_miditrackz00_bglt BgL_trackz00_38, BgL_midiplayerz00_bglt BgL_mplayerz00_39, BgL_midisinkz00_bglt BgL_msinkz00_40, long BgL_tickz00_41, long BgL_ppqz00_42, long BgL_dtz00_43, BGL_LONGLONG_T BgL_t0z00_44)
{
{ /* Llib/midi.scm 353 */
{ /* Llib/midi.scm 357 */
BgL_midireaderz00_bglt BgL_i1160z00_475;
BgL_i1160z00_475 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52readerz52); 
{ /* Llib/midi.scm 372 */
obj_t BgL_statusz00_477;
{ /* Llib/midi.scm 372 */
bool_t BgL_test3650z00_5089;
{ /* Llib/midi.scm 372 */
obj_t BgL_arg1975z00_711;
{ /* Llib/midi.scm 372 */
obj_t BgL_fun1977z00_712;
BgL_fun1977z00_712 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_peekzd2bytezd2); 
{ /* Llib/midi.scm 372 */
obj_t BgL_arg1976z00_713;
BgL_arg1976z00_713 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1975z00_711 = 
PROCEDURE_ENTRY(BgL_fun1977z00_712)(BgL_fun1977z00_712, BgL_arg1976z00_713, BEOA); } } 
BgL_test3650z00_5089 = 
(
(long)CINT(BgL_arg1975z00_711)<((long)128)); } 
if(BgL_test3650z00_5089)
{ /* Llib/midi.scm 372 */
BgL_statusz00_477 = 
BINT(
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52statusz52)); }  else 
{ /* Llib/midi.scm 374 */
obj_t BgL_sz00_708;
{ /* Llib/midi.scm 374 */
obj_t BgL_fun1974z00_709;
BgL_fun1974z00_709 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 374 */
obj_t BgL_arg1973z00_710;
BgL_arg1973z00_710 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_sz00_708 = 
PROCEDURE_ENTRY(BgL_fun1974z00_709)(BgL_fun1974z00_709, BgL_arg1973z00_710, BEOA); } } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52statusz52)=((long)
(long)CINT(BgL_sz00_708)),BUNSPEC); 
BgL_statusz00_477 = BgL_sz00_708; } } 
if(
(
(
(long)CINT(BgL_statusz00_477) >> 
(int)(((long)4)))==((long)8)))
{ /* Llib/midi.scm 380 */
long BgL_kkz00_480;
{ /* Llib/midi.scm 380 */
obj_t BgL_arg1781z00_491;
{ /* Llib/midi.scm 380 */
obj_t BgL_fun1783z00_492;
BgL_fun1783z00_492 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 380 */
obj_t BgL_arg1782z00_493;
BgL_arg1782z00_493 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1781z00_491 = 
PROCEDURE_ENTRY(BgL_fun1783z00_492)(BgL_fun1783z00_492, BgL_arg1782z00_493, BEOA); } } 
BgL_kkz00_480 = 
(((long)127) & 
(long)CINT(BgL_arg1781z00_491)); } 
{ /* Llib/midi.scm 380 */
long BgL_vvz00_481;
{ /* Llib/midi.scm 381 */
obj_t BgL_arg1778z00_488;
{ /* Llib/midi.scm 381 */
obj_t BgL_fun1780z00_489;
BgL_fun1780z00_489 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 381 */
obj_t BgL_arg1779z00_490;
BgL_arg1779z00_490 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1778z00_488 = 
PROCEDURE_ENTRY(BgL_fun1780z00_489)(BgL_fun1780z00_489, BgL_arg1779z00_490, BEOA); } } 
BgL_vvz00_481 = 
(((long)127) & 
(long)CINT(BgL_arg1778z00_488)); } 
{ /* Llib/midi.scm 381 */

{ /* Llib/midi.scm 382 */
obj_t BgL_fun1773z00_482;
BgL_fun1773z00_482 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_cdelayz00); 
{ /* Llib/midi.scm 383 */
long BgL_arg1772z00_483;
{ /* Llib/midi.scm 383 */
BGL_LONGLONG_T BgL_arg1774z00_484;
BgL_arg1774z00_484 = 
(
bgl_current_microseconds()-BgL_t0z00_44); 
{ /* Llib/midi.scm 383 */
long BgL_res2622z00_2054;
BgL_res2622z00_2054 = 
LLONG_TO_LONG(BgL_arg1774z00_484); 
BgL_arg1772z00_483 = BgL_res2622z00_2054; } } 
PROCEDURE_ENTRY(BgL_fun1773z00_482)(BgL_fun1773z00_482, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
((obj_t)BgL_trackz00_38), 
BINT(BgL_ppqz00_42), 
BINT(BgL_dtz00_43), 
BINT(BgL_arg1772z00_483), BEOA); } } 
{ /* Llib/midi.scm 384 */
obj_t BgL_fun1777z00_486;
BgL_fun1777z00_486 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_noteoffz00); 
{ /* Llib/midi.scm 384 */
long BgL_arg1776z00_487;
BgL_arg1776z00_487 = 
(
(long)CINT(BgL_statusz00_477) & ((long)15)); 
PROCEDURE_ENTRY(BgL_fun1777z00_486)(BgL_fun1777z00_486, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1776z00_487), 
BINT(BgL_kkz00_480), 
BINT(BgL_vvz00_481), BEOA); } } } } }  else 
{ /* Llib/midi.scm 378 */
if(
(
(
(long)CINT(BgL_statusz00_477) >> 
(int)(((long)4)))==((long)9)))
{ /* Llib/midi.scm 387 */
long BgL_kkz00_496;
{ /* Llib/midi.scm 387 */
obj_t BgL_arg1795z00_507;
{ /* Llib/midi.scm 387 */
obj_t BgL_fun1797z00_508;
BgL_fun1797z00_508 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 387 */
obj_t BgL_arg1796z00_509;
BgL_arg1796z00_509 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1795z00_507 = 
PROCEDURE_ENTRY(BgL_fun1797z00_508)(BgL_fun1797z00_508, BgL_arg1796z00_509, BEOA); } } 
BgL_kkz00_496 = 
(((long)127) & 
(long)CINT(BgL_arg1795z00_507)); } 
{ /* Llib/midi.scm 387 */
long BgL_vvz00_497;
{ /* Llib/midi.scm 388 */
obj_t BgL_arg1792z00_504;
{ /* Llib/midi.scm 388 */
obj_t BgL_fun1794z00_505;
BgL_fun1794z00_505 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 388 */
obj_t BgL_arg1793z00_506;
BgL_arg1793z00_506 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1792z00_504 = 
PROCEDURE_ENTRY(BgL_fun1794z00_505)(BgL_fun1794z00_505, BgL_arg1793z00_506, BEOA); } } 
BgL_vvz00_497 = 
(((long)127) & 
(long)CINT(BgL_arg1792z00_504)); } 
{ /* Llib/midi.scm 388 */

{ /* Llib/midi.scm 389 */
obj_t BgL_fun1787z00_498;
BgL_fun1787z00_498 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_cdelayz00); 
{ /* Llib/midi.scm 390 */
long BgL_arg1786z00_499;
{ /* Llib/midi.scm 390 */
BGL_LONGLONG_T BgL_arg1788z00_500;
BgL_arg1788z00_500 = 
(
bgl_current_microseconds()-BgL_t0z00_44); 
{ /* Llib/midi.scm 390 */
long BgL_res2630z00_2072;
BgL_res2630z00_2072 = 
LLONG_TO_LONG(BgL_arg1788z00_500); 
BgL_arg1786z00_499 = BgL_res2630z00_2072; } } 
PROCEDURE_ENTRY(BgL_fun1787z00_498)(BgL_fun1787z00_498, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
((obj_t)BgL_trackz00_38), 
BINT(BgL_ppqz00_42), 
BINT(BgL_dtz00_43), 
BINT(BgL_arg1786z00_499), BEOA); } } 
{ /* Llib/midi.scm 391 */
obj_t BgL_fun1791z00_502;
BgL_fun1791z00_502 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_noteonz00); 
{ /* Llib/midi.scm 391 */
long BgL_arg1790z00_503;
BgL_arg1790z00_503 = 
(
(long)CINT(BgL_statusz00_477) & ((long)15)); 
PROCEDURE_ENTRY(BgL_fun1791z00_502)(BgL_fun1791z00_502, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1790z00_503), 
BINT(BgL_kkz00_496), 
BINT(BgL_vvz00_497), BEOA); } } } } }  else 
{ /* Llib/midi.scm 385 */
if(
(
(
(long)CINT(BgL_statusz00_477) >> 
(int)(((long)4)))==((long)10)))
{ /* Llib/midi.scm 394 */
long BgL_ccz00_512;
{ /* Llib/midi.scm 394 */
obj_t BgL_arg1809z00_523;
{ /* Llib/midi.scm 394 */
obj_t BgL_fun1811z00_524;
BgL_fun1811z00_524 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 394 */
obj_t BgL_arg1810z00_525;
BgL_arg1810z00_525 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1809z00_523 = 
PROCEDURE_ENTRY(BgL_fun1811z00_524)(BgL_fun1811z00_524, BgL_arg1810z00_525, BEOA); } } 
BgL_ccz00_512 = 
(((long)127) & 
(long)CINT(BgL_arg1809z00_523)); } 
{ /* Llib/midi.scm 394 */
long BgL_vvz00_513;
{ /* Llib/midi.scm 395 */
obj_t BgL_arg1806z00_520;
{ /* Llib/midi.scm 395 */
obj_t BgL_fun1808z00_521;
BgL_fun1808z00_521 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 395 */
obj_t BgL_arg1807z00_522;
BgL_arg1807z00_522 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1806z00_520 = 
PROCEDURE_ENTRY(BgL_fun1808z00_521)(BgL_fun1808z00_521, BgL_arg1807z00_522, BEOA); } } 
BgL_vvz00_513 = 
(((long)127) & 
(long)CINT(BgL_arg1806z00_520)); } 
{ /* Llib/midi.scm 395 */

{ /* Llib/midi.scm 396 */
obj_t BgL_fun1801z00_514;
BgL_fun1801z00_514 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_cdelayz00); 
{ /* Llib/midi.scm 397 */
long BgL_arg1800z00_515;
{ /* Llib/midi.scm 397 */
BGL_LONGLONG_T BgL_arg1802z00_516;
BgL_arg1802z00_516 = 
(
bgl_current_microseconds()-BgL_t0z00_44); 
{ /* Llib/midi.scm 397 */
long BgL_res2638z00_2090;
BgL_res2638z00_2090 = 
LLONG_TO_LONG(BgL_arg1802z00_516); 
BgL_arg1800z00_515 = BgL_res2638z00_2090; } } 
PROCEDURE_ENTRY(BgL_fun1801z00_514)(BgL_fun1801z00_514, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
((obj_t)BgL_trackz00_38), 
BINT(BgL_ppqz00_42), 
BINT(BgL_dtz00_43), 
BINT(BgL_arg1800z00_515), BEOA); } } 
{ /* Llib/midi.scm 398 */
obj_t BgL_fun1805z00_518;
BgL_fun1805z00_518 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_aftertouchz00); 
{ /* Llib/midi.scm 398 */
long BgL_arg1804z00_519;
BgL_arg1804z00_519 = 
(
(long)CINT(BgL_statusz00_477) & ((long)15)); 
PROCEDURE_ENTRY(BgL_fun1805z00_518)(BgL_fun1805z00_518, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1804z00_519), 
BINT(BgL_ccz00_512), 
BINT(BgL_vvz00_513), BEOA); } } } } }  else 
{ /* Llib/midi.scm 392 */
if(
(
(
(long)CINT(BgL_statusz00_477) >> 
(int)(((long)4)))==((long)11)))
{ /* Llib/midi.scm 401 */
long BgL_ccz00_528;
{ /* Llib/midi.scm 401 */
obj_t BgL_arg1823z00_539;
{ /* Llib/midi.scm 401 */
obj_t BgL_fun1825z00_540;
BgL_fun1825z00_540 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 401 */
obj_t BgL_arg1824z00_541;
BgL_arg1824z00_541 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1823z00_539 = 
PROCEDURE_ENTRY(BgL_fun1825z00_540)(BgL_fun1825z00_540, BgL_arg1824z00_541, BEOA); } } 
BgL_ccz00_528 = 
(((long)127) & 
(long)CINT(BgL_arg1823z00_539)); } 
{ /* Llib/midi.scm 401 */
long BgL_nnz00_529;
{ /* Llib/midi.scm 402 */
obj_t BgL_arg1820z00_536;
{ /* Llib/midi.scm 402 */
obj_t BgL_fun1822z00_537;
BgL_fun1822z00_537 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 402 */
obj_t BgL_arg1821z00_538;
BgL_arg1821z00_538 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1820z00_536 = 
PROCEDURE_ENTRY(BgL_fun1822z00_537)(BgL_fun1822z00_537, BgL_arg1821z00_538, BEOA); } } 
BgL_nnz00_529 = 
(((long)127) & 
(long)CINT(BgL_arg1820z00_536)); } 
{ /* Llib/midi.scm 402 */

{ /* Llib/midi.scm 403 */
obj_t BgL_fun1815z00_530;
BgL_fun1815z00_530 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_cdelayz00); 
{ /* Llib/midi.scm 404 */
long BgL_arg1814z00_531;
{ /* Llib/midi.scm 404 */
BGL_LONGLONG_T BgL_arg1816z00_532;
BgL_arg1816z00_532 = 
(
bgl_current_microseconds()-BgL_t0z00_44); 
{ /* Llib/midi.scm 404 */
long BgL_res2646z00_2108;
BgL_res2646z00_2108 = 
LLONG_TO_LONG(BgL_arg1816z00_532); 
BgL_arg1814z00_531 = BgL_res2646z00_2108; } } 
PROCEDURE_ENTRY(BgL_fun1815z00_530)(BgL_fun1815z00_530, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
((obj_t)BgL_trackz00_38), 
BINT(BgL_ppqz00_42), 
BINT(BgL_dtz00_43), 
BINT(BgL_arg1814z00_531), BEOA); } } 
{ /* Llib/midi.scm 405 */
obj_t BgL_fun1819z00_534;
BgL_fun1819z00_534 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_ctrlchangez00); 
{ /* Llib/midi.scm 405 */
long BgL_arg1818z00_535;
BgL_arg1818z00_535 = 
(
(long)CINT(BgL_statusz00_477) & ((long)15)); 
PROCEDURE_ENTRY(BgL_fun1819z00_534)(BgL_fun1819z00_534, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1818z00_535), 
BINT(BgL_ccz00_528), 
BINT(BgL_nnz00_529), BEOA); } } } } }  else 
{ /* Llib/midi.scm 399 */
if(
(
(
(long)CINT(BgL_statusz00_477) >> 
(int)(((long)4)))==((long)12)))
{ /* Llib/midi.scm 408 */
long BgL_ppz00_544;
{ /* Llib/midi.scm 408 */
obj_t BgL_arg1834z00_551;
{ /* Llib/midi.scm 408 */
obj_t BgL_fun1836z00_552;
BgL_fun1836z00_552 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 408 */
obj_t BgL_arg1835z00_553;
BgL_arg1835z00_553 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1834z00_551 = 
PROCEDURE_ENTRY(BgL_fun1836z00_552)(BgL_fun1836z00_552, BgL_arg1835z00_553, BEOA); } } 
BgL_ppz00_544 = 
(((long)127) & 
(long)CINT(BgL_arg1834z00_551)); } 
{ /* Llib/midi.scm 409 */
obj_t BgL_fun1829z00_545;
BgL_fun1829z00_545 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_cdelayz00); 
{ /* Llib/midi.scm 410 */
long BgL_arg1828z00_546;
{ /* Llib/midi.scm 410 */
BGL_LONGLONG_T BgL_arg1830z00_547;
BgL_arg1830z00_547 = 
(
bgl_current_microseconds()-BgL_t0z00_44); 
{ /* Llib/midi.scm 410 */
long BgL_res2653z00_2123;
BgL_res2653z00_2123 = 
LLONG_TO_LONG(BgL_arg1830z00_547); 
BgL_arg1828z00_546 = BgL_res2653z00_2123; } } 
PROCEDURE_ENTRY(BgL_fun1829z00_545)(BgL_fun1829z00_545, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
((obj_t)BgL_trackz00_38), 
BINT(BgL_ppqz00_42), 
BINT(BgL_dtz00_43), 
BINT(BgL_arg1828z00_546), BEOA); } } 
{ /* Llib/midi.scm 411 */
obj_t BgL_fun1833z00_549;
BgL_fun1833z00_549 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_prgmchangez00); 
{ /* Llib/midi.scm 411 */
long BgL_arg1832z00_550;
BgL_arg1832z00_550 = 
(
(long)CINT(BgL_statusz00_477) & ((long)15)); 
PROCEDURE_ENTRY(BgL_fun1833z00_549)(BgL_fun1833z00_549, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1832z00_550), 
BINT(BgL_ppz00_544), BEOA); } } }  else 
{ /* Llib/midi.scm 406 */
if(
(
(
(long)CINT(BgL_statusz00_477) >> 
(int)(((long)4)))==((long)13)))
{ /* Llib/midi.scm 414 */
long BgL_ppz00_556;
{ /* Llib/midi.scm 414 */
obj_t BgL_arg1845z00_563;
{ /* Llib/midi.scm 414 */
obj_t BgL_fun1847z00_564;
BgL_fun1847z00_564 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 414 */
obj_t BgL_arg1846z00_565;
BgL_arg1846z00_565 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1845z00_563 = 
PROCEDURE_ENTRY(BgL_fun1847z00_564)(BgL_fun1847z00_564, BgL_arg1846z00_565, BEOA); } } 
BgL_ppz00_556 = 
(((long)127) & 
(long)CINT(BgL_arg1845z00_563)); } 
{ /* Llib/midi.scm 415 */
obj_t BgL_fun1840z00_557;
BgL_fun1840z00_557 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_cdelayz00); 
{ /* Llib/midi.scm 416 */
long BgL_arg1839z00_558;
{ /* Llib/midi.scm 416 */
BGL_LONGLONG_T BgL_arg1841z00_559;
BgL_arg1841z00_559 = 
(
bgl_current_microseconds()-BgL_t0z00_44); 
{ /* Llib/midi.scm 416 */
long BgL_res2660z00_2138;
BgL_res2660z00_2138 = 
LLONG_TO_LONG(BgL_arg1841z00_559); 
BgL_arg1839z00_558 = BgL_res2660z00_2138; } } 
PROCEDURE_ENTRY(BgL_fun1840z00_557)(BgL_fun1840z00_557, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
((obj_t)BgL_trackz00_38), 
BINT(BgL_ppqz00_42), 
BINT(BgL_dtz00_43), 
BINT(BgL_arg1839z00_558), BEOA); } } 
{ /* Llib/midi.scm 417 */
obj_t BgL_fun1844z00_561;
BgL_fun1844z00_561 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_afterzd2touchzd2); 
{ /* Llib/midi.scm 417 */
long BgL_arg1843z00_562;
BgL_arg1843z00_562 = 
(
(long)CINT(BgL_statusz00_477) & ((long)15)); 
PROCEDURE_ENTRY(BgL_fun1844z00_561)(BgL_fun1844z00_561, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1843z00_562), 
BINT(BgL_ppz00_556), BEOA); } } }  else 
{ /* Llib/midi.scm 412 */
if(
(
(
(long)CINT(BgL_statusz00_477) >> 
(int)(((long)4)))==((long)14)))
{ /* Llib/midi.scm 420 */
long BgL_ccz00_568;
{ /* Llib/midi.scm 420 */
obj_t BgL_arg1859z00_579;
{ /* Llib/midi.scm 420 */
obj_t BgL_fun1861z00_580;
BgL_fun1861z00_580 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 420 */
obj_t BgL_arg1860z00_581;
BgL_arg1860z00_581 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1859z00_579 = 
PROCEDURE_ENTRY(BgL_fun1861z00_580)(BgL_fun1861z00_580, BgL_arg1860z00_581, BEOA); } } 
BgL_ccz00_568 = 
(((long)127) & 
(long)CINT(BgL_arg1859z00_579)); } 
{ /* Llib/midi.scm 420 */
long BgL_vvz00_569;
{ /* Llib/midi.scm 421 */
obj_t BgL_arg1856z00_576;
{ /* Llib/midi.scm 421 */
obj_t BgL_fun1858z00_577;
BgL_fun1858z00_577 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 421 */
obj_t BgL_arg1857z00_578;
BgL_arg1857z00_578 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1856z00_576 = 
PROCEDURE_ENTRY(BgL_fun1858z00_577)(BgL_fun1858z00_577, BgL_arg1857z00_578, BEOA); } } 
BgL_vvz00_569 = 
(((long)127) & 
(long)CINT(BgL_arg1856z00_576)); } 
{ /* Llib/midi.scm 421 */

{ /* Llib/midi.scm 422 */
obj_t BgL_fun1851z00_570;
BgL_fun1851z00_570 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_cdelayz00); 
{ /* Llib/midi.scm 423 */
long BgL_arg1850z00_571;
{ /* Llib/midi.scm 423 */
BGL_LONGLONG_T BgL_arg1852z00_572;
BgL_arg1852z00_572 = 
(
bgl_current_microseconds()-BgL_t0z00_44); 
{ /* Llib/midi.scm 423 */
long BgL_res2668z00_2156;
BgL_res2668z00_2156 = 
LLONG_TO_LONG(BgL_arg1852z00_572); 
BgL_arg1850z00_571 = BgL_res2668z00_2156; } } 
PROCEDURE_ENTRY(BgL_fun1851z00_570)(BgL_fun1851z00_570, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
((obj_t)BgL_trackz00_38), 
BINT(BgL_ppqz00_42), 
BINT(BgL_dtz00_43), 
BINT(BgL_arg1850z00_571), BEOA); } } 
{ /* Llib/midi.scm 424 */
obj_t BgL_fun1855z00_574;
BgL_fun1855z00_574 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_pitchz00); 
{ /* Llib/midi.scm 424 */
long BgL_arg1854z00_575;
BgL_arg1854z00_575 = 
(
(long)CINT(BgL_statusz00_477) & ((long)15)); 
PROCEDURE_ENTRY(BgL_fun1855z00_574)(BgL_fun1855z00_574, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1854z00_575), 
BINT(BgL_ccz00_568), 
BINT(BgL_vvz00_569), BEOA); } } } } }  else 
{ /* Llib/midi.scm 418 */
if(
(
(long)CINT(BgL_statusz00_477)==((long)255)))
{ /* Llib/midi.scm 427 */
obj_t BgL_cz00_583;
{ /* Llib/midi.scm 427 */
obj_t BgL_fun1948z00_680;
BgL_fun1948z00_680 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 427 */
obj_t BgL_arg1947z00_681;
BgL_arg1947z00_681 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_cz00_583 = 
PROCEDURE_ENTRY(BgL_fun1948z00_680)(BgL_fun1948z00_680, BgL_arg1947z00_681, BEOA); } } 
{ /* Llib/midi.scm 427 */
obj_t BgL_lz00_584;
{ /* Llib/midi.scm 428 */
obj_t BgL_fun1946z00_678;
BgL_fun1946z00_678 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2vlqzd2); 
{ /* Llib/midi.scm 428 */
obj_t BgL_arg1945z00_679;
BgL_arg1945z00_679 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_lz00_584 = 
PROCEDURE_ENTRY(BgL_fun1946z00_678)(BgL_fun1946z00_678, BgL_arg1945z00_679, BEOA); } } 
{ /* Llib/midi.scm 428 */

{ 

if(
INTEGERP(BgL_cz00_583))
{ /* Llib/midi.scm 429 */
switch( 
(long)CINT(BgL_cz00_583)) { case ((long)0) : 

{ /* Llib/midi.scm 432 */
obj_t BgL_fun1865z00_588;
BgL_fun1865z00_588 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2seqnumzd2); 
{ /* Llib/midi.scm 432 */
int32_t BgL_arg1864z00_589;
BgL_arg1864z00_589 = 
BGl_readzd2int16zd2zz__multimediazd2midizd2(
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52)); 
PROCEDURE_ENTRY(BgL_fun1865z00_588)(BgL_fun1865z00_588, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BGL_INT32_TO_BINT32(BgL_arg1864z00_589), BEOA); } } break;case ((long)1) : 

{ /* Llib/midi.scm 435 */
obj_t BgL_fun1868z00_591;
BgL_fun1868z00_591 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2textzd2); 
{ /* Llib/midi.scm 435 */
obj_t BgL_arg1867z00_592;
{ /* Llib/midi.scm 435 */
obj_t BgL_fun1870z00_593;
BgL_fun1870z00_593 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 435 */
obj_t BgL_arg1869z00_594;
BgL_arg1869z00_594 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1867z00_592 = 
PROCEDURE_ENTRY(BgL_fun1870z00_593)(BgL_fun1870z00_593, BgL_lz00_584, BgL_arg1869z00_594, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1868z00_591)(BgL_fun1868z00_591, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1867z00_592, BEOA); } } break;case ((long)2) : 

{ /* Llib/midi.scm 438 */
obj_t BgL_fun1872z00_595;
BgL_fun1872z00_595 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2copyrightzd2); 
{ /* Llib/midi.scm 438 */
obj_t BgL_arg1871z00_596;
{ /* Llib/midi.scm 438 */
obj_t BgL_fun1874z00_597;
BgL_fun1874z00_597 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 438 */
obj_t BgL_arg1873z00_598;
BgL_arg1873z00_598 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1871z00_596 = 
PROCEDURE_ENTRY(BgL_fun1874z00_597)(BgL_fun1874z00_597, BgL_lz00_584, BgL_arg1873z00_598, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1872z00_595)(BgL_fun1872z00_595, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1871z00_596, BEOA); } } break;case ((long)3) : 

{ /* Llib/midi.scm 441 */
obj_t BgL_fun1876z00_599;
BgL_fun1876z00_599 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2trackzd2); 
{ /* Llib/midi.scm 441 */
obj_t BgL_arg1875z00_600;
{ /* Llib/midi.scm 441 */
obj_t BgL_fun1878z00_601;
BgL_fun1878z00_601 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 441 */
obj_t BgL_arg1877z00_602;
BgL_arg1877z00_602 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1875z00_600 = 
PROCEDURE_ENTRY(BgL_fun1878z00_601)(BgL_fun1878z00_601, BgL_lz00_584, BgL_arg1877z00_602, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1876z00_599)(BgL_fun1876z00_599, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1875z00_600, BEOA); } } break;case ((long)4) : 

{ /* Llib/midi.scm 444 */
obj_t BgL_fun1880z00_603;
BgL_fun1880z00_603 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2instrumentzd2); 
{ /* Llib/midi.scm 444 */
obj_t BgL_arg1879z00_604;
{ /* Llib/midi.scm 444 */
obj_t BgL_fun1882z00_605;
BgL_fun1882z00_605 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 444 */
obj_t BgL_arg1881z00_606;
BgL_arg1881z00_606 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1879z00_604 = 
PROCEDURE_ENTRY(BgL_fun1882z00_605)(BgL_fun1882z00_605, BgL_lz00_584, BgL_arg1881z00_606, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1880z00_603)(BgL_fun1880z00_603, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1879z00_604, BEOA); } } break;case ((long)5) : 

{ /* Llib/midi.scm 447 */
obj_t BgL_fun1884z00_607;
BgL_fun1884z00_607 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2lyriczd2); 
{ /* Llib/midi.scm 447 */
obj_t BgL_arg1883z00_608;
{ /* Llib/midi.scm 447 */
obj_t BgL_fun1886z00_609;
BgL_fun1886z00_609 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 447 */
obj_t BgL_arg1885z00_610;
BgL_arg1885z00_610 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1883z00_608 = 
PROCEDURE_ENTRY(BgL_fun1886z00_609)(BgL_fun1886z00_609, BgL_lz00_584, BgL_arg1885z00_610, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1884z00_607)(BgL_fun1884z00_607, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1883z00_608, BEOA); } } break;case ((long)6) : 

{ /* Llib/midi.scm 450 */
obj_t BgL_fun1888z00_611;
BgL_fun1888z00_611 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2markerzd2); 
{ /* Llib/midi.scm 450 */
obj_t BgL_arg1887z00_612;
{ /* Llib/midi.scm 450 */
obj_t BgL_fun1890z00_613;
BgL_fun1890z00_613 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 450 */
obj_t BgL_arg1889z00_614;
BgL_arg1889z00_614 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1887z00_612 = 
PROCEDURE_ENTRY(BgL_fun1890z00_613)(BgL_fun1890z00_613, BgL_lz00_584, BgL_arg1889z00_614, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1888z00_611)(BgL_fun1888z00_611, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1887z00_612, BEOA); } } break;case ((long)7) : 

{ /* Llib/midi.scm 453 */
obj_t BgL_fun1892z00_615;
BgL_fun1892z00_615 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2cuezd2); 
{ /* Llib/midi.scm 453 */
obj_t BgL_arg1891z00_616;
{ /* Llib/midi.scm 453 */
obj_t BgL_fun1894z00_617;
BgL_fun1894z00_617 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 453 */
obj_t BgL_arg1893z00_618;
BgL_arg1893z00_618 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1891z00_616 = 
PROCEDURE_ENTRY(BgL_fun1894z00_617)(BgL_fun1894z00_617, BgL_lz00_584, BgL_arg1893z00_618, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1892z00_615)(BgL_fun1892z00_615, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1891z00_616, BEOA); } } break;case ((long)8) : 

{ /* Llib/midi.scm 456 */
obj_t BgL_fun1896z00_619;
BgL_fun1896z00_619 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2prgmnamezd2); 
{ /* Llib/midi.scm 456 */
obj_t BgL_arg1895z00_620;
{ /* Llib/midi.scm 456 */
obj_t BgL_fun1898z00_621;
BgL_fun1898z00_621 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 456 */
obj_t BgL_arg1897z00_622;
BgL_arg1897z00_622 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1895z00_620 = 
PROCEDURE_ENTRY(BgL_fun1898z00_621)(BgL_fun1898z00_621, BgL_lz00_584, BgL_arg1897z00_622, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1896z00_619)(BgL_fun1896z00_619, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1895z00_620, BEOA); } } break;case ((long)9) : 

{ /* Llib/midi.scm 459 */
obj_t BgL_fun1900z00_623;
BgL_fun1900z00_623 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2devnamezd2); 
{ /* Llib/midi.scm 459 */
obj_t BgL_arg1899z00_624;
{ /* Llib/midi.scm 459 */
obj_t BgL_fun1902z00_625;
BgL_fun1902z00_625 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 459 */
obj_t BgL_arg1901z00_626;
BgL_arg1901z00_626 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1899z00_624 = 
PROCEDURE_ENTRY(BgL_fun1902z00_625)(BgL_fun1902z00_625, BgL_lz00_584, BgL_arg1901z00_626, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1900z00_623)(BgL_fun1900z00_623, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1899z00_624, BEOA); } } break;case ((long)32) : 

{ /* Llib/midi.scm 462 */
obj_t BgL_fun1904z00_627;
BgL_fun1904z00_627 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2channprefzd2); 
{ /* Llib/midi.scm 462 */
obj_t BgL_arg1903z00_628;
{ /* Llib/midi.scm 462 */
obj_t BgL_fun1906z00_629;
BgL_fun1906z00_629 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 462 */
obj_t BgL_arg1905z00_630;
BgL_arg1905z00_630 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1903z00_628 = 
PROCEDURE_ENTRY(BgL_fun1906z00_629)(BgL_fun1906z00_629, BgL_arg1905z00_630, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1904z00_627)(BgL_fun1904z00_627, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1903z00_628, BEOA); } } break;case ((long)33) : 

{ /* Llib/midi.scm 465 */
obj_t BgL_fun1908z00_631;
BgL_fun1908z00_631 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2channprefzd2); 
{ /* Llib/midi.scm 465 */
long BgL_arg1907z00_632;
BgL_arg1907z00_632 = 
BGl_readzd2intzd2zz__multimediazd2midizd2(
(long)CINT(BgL_lz00_584), 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52)); 
PROCEDURE_ENTRY(BgL_fun1908z00_631)(BgL_fun1908z00_631, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1907z00_632), BEOA); } } break;case ((long)47) : 

((((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52eotz52)=((bool_t)((bool_t)1)),BUNSPEC); 
{ /* Llib/midi.scm 469 */
obj_t BgL_fun1910z00_634;
BgL_fun1910z00_634 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2eotzd2); 
PROCEDURE_ENTRY(BgL_fun1910z00_634)(BgL_fun1910z00_634, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BUNSPEC, BEOA); } break;case ((long)81) : 

{ 
long BgL_auxz00_5745;
{ /* Llib/midi.scm 472 */
obj_t BgL_arg1911z00_635;
BgL_arg1911z00_635 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_auxz00_5745 = 
BGl_readzd2intzd2zz__multimediazd2midizd2(
(long)CINT(BgL_lz00_584), BgL_arg1911z00_635); } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_tempoz00)=((long)BgL_auxz00_5745),BUNSPEC); } 
{ /* Llib/midi.scm 473 */
obj_t BgL_fun1913z00_636;
BgL_fun1913z00_636 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2tempozd2); 
{ /* Llib/midi.scm 473 */
long BgL_arg1912z00_637;
BgL_arg1912z00_637 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_tempoz00); 
PROCEDURE_ENTRY(BgL_fun1913z00_636)(BgL_fun1913z00_636, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1912z00_637), BEOA); } } break;case ((long)84) : 

{ /* Llib/midi.scm 476 */
obj_t BgL_hrz00_638;
{ /* Llib/midi.scm 476 */
obj_t BgL_fun1924z00_652;
BgL_fun1924z00_652 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 476 */
obj_t BgL_arg1923z00_653;
BgL_arg1923z00_653 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_hrz00_638 = 
PROCEDURE_ENTRY(BgL_fun1924z00_652)(BgL_fun1924z00_652, BgL_arg1923z00_653, BEOA); } } 
{ /* Llib/midi.scm 476 */
obj_t BgL_mmz00_639;
{ /* Llib/midi.scm 477 */
obj_t BgL_fun1922z00_650;
BgL_fun1922z00_650 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 477 */
obj_t BgL_arg1921z00_651;
BgL_arg1921z00_651 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_mmz00_639 = 
PROCEDURE_ENTRY(BgL_fun1922z00_650)(BgL_fun1922z00_650, BgL_arg1921z00_651, BEOA); } } 
{ /* Llib/midi.scm 477 */
obj_t BgL_sez00_640;
{ /* Llib/midi.scm 478 */
obj_t BgL_fun1920z00_648;
BgL_fun1920z00_648 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 478 */
obj_t BgL_arg1919z00_649;
BgL_arg1919z00_649 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_sez00_640 = 
PROCEDURE_ENTRY(BgL_fun1920z00_648)(BgL_fun1920z00_648, BgL_arg1919z00_649, BEOA); } } 
{ /* Llib/midi.scm 478 */
obj_t BgL_frz00_641;
{ /* Llib/midi.scm 479 */
obj_t BgL_fun1918z00_646;
BgL_fun1918z00_646 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 479 */
obj_t BgL_arg1917z00_647;
BgL_arg1917z00_647 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_frz00_641 = 
PROCEDURE_ENTRY(BgL_fun1918z00_646)(BgL_fun1918z00_646, BgL_arg1917z00_647, BEOA); } } 
{ /* Llib/midi.scm 479 */
obj_t BgL_ffz00_642;
{ /* Llib/midi.scm 480 */
obj_t BgL_fun1916z00_644;
BgL_fun1916z00_644 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 480 */
obj_t BgL_arg1915z00_645;
BgL_arg1915z00_645 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_ffz00_642 = 
PROCEDURE_ENTRY(BgL_fun1916z00_644)(BgL_fun1916z00_644, BgL_arg1915z00_645, BEOA); } } 
{ /* Llib/midi.scm 480 */

{ /* Llib/midi.scm 481 */
obj_t BgL_fun1914z00_643;
BgL_fun1914z00_643 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2smtpezd2); 
PROCEDURE_ENTRY(BgL_fun1914z00_643)(BgL_fun1914z00_643, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_hrz00_638, BgL_mmz00_639, BgL_sez00_640, BgL_frz00_641, BgL_ffz00_642, BEOA); } } } } } } } break;case ((long)88) : 

{ /* Llib/midi.scm 484 */
obj_t BgL_nnz00_654;
{ /* Llib/midi.scm 484 */
obj_t BgL_fun1933z00_665;
BgL_fun1933z00_665 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 484 */
obj_t BgL_arg1932z00_666;
BgL_arg1932z00_666 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_nnz00_654 = 
PROCEDURE_ENTRY(BgL_fun1933z00_665)(BgL_fun1933z00_665, BgL_arg1932z00_666, BEOA); } } 
{ /* Llib/midi.scm 484 */
obj_t BgL_ddz00_655;
{ /* Llib/midi.scm 485 */
obj_t BgL_fun1931z00_663;
BgL_fun1931z00_663 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 485 */
obj_t BgL_arg1930z00_664;
BgL_arg1930z00_664 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_ddz00_655 = 
PROCEDURE_ENTRY(BgL_fun1931z00_663)(BgL_fun1931z00_663, BgL_arg1930z00_664, BEOA); } } 
{ /* Llib/midi.scm 485 */
obj_t BgL_ccz00_656;
{ /* Llib/midi.scm 486 */
obj_t BgL_fun1929z00_661;
BgL_fun1929z00_661 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 486 */
obj_t BgL_arg1928z00_662;
BgL_arg1928z00_662 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_ccz00_656 = 
PROCEDURE_ENTRY(BgL_fun1929z00_661)(BgL_fun1929z00_661, BgL_arg1928z00_662, BEOA); } } 
{ /* Llib/midi.scm 486 */
obj_t BgL_bbz00_657;
{ /* Llib/midi.scm 487 */
obj_t BgL_fun1927z00_659;
BgL_fun1927z00_659 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 487 */
obj_t BgL_arg1926z00_660;
BgL_arg1926z00_660 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_bbz00_657 = 
PROCEDURE_ENTRY(BgL_fun1927z00_659)(BgL_fun1927z00_659, BgL_arg1926z00_660, BEOA); } } 
{ /* Llib/midi.scm 487 */

{ /* Llib/midi.scm 488 */
obj_t BgL_fun1925z00_658;
BgL_fun1925z00_658 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2timesigzd2); 
PROCEDURE_ENTRY(BgL_fun1925z00_658)(BgL_fun1925z00_658, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_nnz00_654, BgL_ddz00_655, BgL_ccz00_656, BgL_bbz00_657, BEOA); } } } } } } break;case ((long)89) : 

{ /* Llib/midi.scm 491 */
obj_t BgL_fun1935z00_667;
BgL_fun1935z00_667 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2keysigzd2); 
{ /* Llib/midi.scm 491 */
long BgL_arg1934z00_668;
BgL_arg1934z00_668 = 
BGl_readzd2intzd2zz__multimediazd2midizd2(
(long)CINT(BgL_lz00_584), 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52)); 
PROCEDURE_ENTRY(BgL_fun1935z00_667)(BgL_fun1935z00_667, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1934z00_668), BEOA); } } break;case ((long)127) : 

{ /* Llib/midi.scm 494 */
obj_t BgL_fun1938z00_670;
BgL_fun1938z00_670 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2seqspeczd2); 
{ /* Llib/midi.scm 494 */
obj_t BgL_arg1937z00_671;
{ /* Llib/midi.scm 494 */
obj_t BgL_fun1940z00_672;
BgL_fun1940z00_672 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 494 */
obj_t BgL_arg1939z00_673;
BgL_arg1939z00_673 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1937z00_671 = 
PROCEDURE_ENTRY(BgL_fun1940z00_672)(BgL_fun1940z00_672, BgL_lz00_584, BgL_arg1939z00_673, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1938z00_670)(BgL_fun1938z00_670, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1937z00_671, BEOA); } } break;
default: 
BgL_case_else1162z00_585:
{ /* Llib/midi.scm 496 */
obj_t BgL_fun1942z00_674;
BgL_fun1942z00_674 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_errz00); 
{ /* Llib/midi.scm 497 */
obj_t BgL_arg1941z00_675;
{ /* Llib/midi.scm 497 */
obj_t BgL_list1943z00_676;
{ /* Llib/midi.scm 497 */
obj_t BgL_arg1944z00_677;
BgL_arg1944z00_677 = 
MAKE_YOUNG_PAIR(BgL_cz00_583, BNIL); 
BgL_list1943z00_676 = 
MAKE_YOUNG_PAIR(BgL_statusz00_477, BgL_arg1944z00_677); } 
BgL_arg1941z00_675 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string3081z00zz__multimediazd2midizd2, BgL_list1943z00_676); } 
PROCEDURE_ENTRY(BgL_fun1942z00_674)(BgL_fun1942z00_674, BGl_string3082z00zz__multimediazd2midizd2, BGl_string3083z00zz__multimediazd2midizd2, BgL_arg1941z00_675, BEOA); } } } }  else 
{ /* Llib/midi.scm 429 */
goto BgL_case_else1162z00_585;} } } } }  else 
{ /* Llib/midi.scm 498 */
bool_t BgL_test3660z00_5891;
if(
(
(long)CINT(BgL_statusz00_477)==((long)240)))
{ /* Llib/midi.scm 498 */
BgL_test3660z00_5891 = ((bool_t)1)
; }  else 
{ /* Llib/midi.scm 498 */
BgL_test3660z00_5891 = 
(
(long)CINT(BgL_statusz00_477)==((long)247))
; } 
if(BgL_test3660z00_5891)
{ /* Llib/midi.scm 500 */
obj_t BgL_strz00_684;
{ /* Llib/midi.scm 500 */
obj_t BgL_fun1958z00_690;
BgL_fun1958z00_690 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 500 */
obj_t BgL_arg1956z00_691;obj_t BgL_arg1957z00_692;
{ /* Llib/midi.scm 500 */
obj_t BgL_fun1960z00_693;
BgL_fun1960z00_693 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2vlqzd2); 
{ /* Llib/midi.scm 500 */
obj_t BgL_arg1959z00_694;
BgL_arg1959z00_694 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1956z00_691 = 
PROCEDURE_ENTRY(BgL_fun1960z00_693)(BgL_fun1960z00_693, BgL_arg1959z00_694, BEOA); } } 
BgL_arg1957z00_692 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_strz00_684 = 
PROCEDURE_ENTRY(BgL_fun1958z00_690)(BgL_fun1958z00_690, BgL_arg1956z00_691, BgL_arg1957z00_692, BEOA); } } 
{ /* Llib/midi.scm 501 */
obj_t BgL_fun1952z00_685;
BgL_fun1952z00_685 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_cdelayz00); 
{ /* Llib/midi.scm 502 */
long BgL_arg1951z00_686;
{ /* Llib/midi.scm 502 */
BGL_LONGLONG_T BgL_arg1953z00_687;
BgL_arg1953z00_687 = 
(
bgl_current_microseconds()-BgL_t0z00_44); 
{ /* Llib/midi.scm 502 */
long BgL_res2675z00_2170;
BgL_res2675z00_2170 = 
LLONG_TO_LONG(BgL_arg1953z00_687); 
BgL_arg1951z00_686 = BgL_res2675z00_2170; } } 
PROCEDURE_ENTRY(BgL_fun1952z00_685)(BgL_fun1952z00_685, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
((obj_t)BgL_trackz00_38), 
BINT(BgL_dtz00_43), 
BINT(BgL_ppqz00_42), 
BINT(BgL_arg1951z00_686), BEOA); } } 
{ /* Llib/midi.scm 503 */
obj_t BgL_fun1955z00_689;
BgL_fun1955z00_689 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_sysexz00); 
PROCEDURE_ENTRY(BgL_fun1955z00_689)(BgL_fun1955z00_689, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_strz00_684, BEOA); } }  else 
{ /* Llib/midi.scm 505 */
obj_t BgL_fun1961z00_695;
BgL_fun1961z00_695 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_errz00); 
PROCEDURE_ENTRY(BgL_fun1961z00_695)(BgL_fun1961z00_695, BGl_string3082z00zz__multimediazd2midizd2, BGl_string3084z00zz__multimediazd2midizd2, BgL_statusz00_477, BEOA); } } } } } } } } } } 
{ /* Llib/midi.scm 507 */
obj_t BgL_fun1979z00_715;
BgL_fun1979z00_715 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msinkz00_40))->BgL_flushz00); 
{ /* Llib/midi.scm 507 */
obj_t BgL_arg1978z00_716;
BgL_arg1978z00_716 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msinkz00_40))->BgL_streamz00); 
return 
PROCEDURE_ENTRY(BgL_fun1979z00_715)(BgL_fun1979z00_715, BgL_arg1978z00_716, BEOA);} } } } 

}



/* midi-read-mthd */
obj_t BGl_midizd2readzd2mthdz00zz__multimediazd2midizd2(obj_t BgL_ipz00_45)
{
{ /* Llib/midi.scm 512 */
{ /* Llib/midi.scm 513 */
obj_t BgL_tyz00_717;
BgL_tyz00_717 = 
BGl_readzd2charszd2zz__r4_input_6_10_2z00(
BINT(((long)4)), BgL_ipz00_45); 
if(
bigloo_strcmp(
((obj_t)BgL_tyz00_717), BGl_string3085z00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 516 */
int32_t BgL_sza7za7_719;
BgL_sza7za7_719 = 
BGl_readzd2int32zd2zz__multimediazd2midizd2(BgL_ipz00_45); 
{ /* Llib/midi.scm 516 */
long BgL_fmtz00_720;
{ /* Llib/midi.scm 517 */
int32_t BgL_arg1996z00_765;
BgL_arg1996z00_765 = 
BGl_readzd2int16zd2zz__multimediazd2midizd2(BgL_ipz00_45); 
{ /* Llib/midi.scm 517 */
long BgL_res2678z00_2178;
{ /* Llib/midi.scm 517 */
long BgL_arg1421z00_2175;
BgL_arg1421z00_2175 = 
(long)(BgL_arg1996z00_765); 
{ /* Llib/midi.scm 517 */
long BgL_res2677z00_2177;
BgL_res2677z00_2177 = 
(long)(BgL_arg1421z00_2175); 
BgL_res2678z00_2178 = BgL_res2677z00_2177; } } 
BgL_fmtz00_720 = BgL_res2678z00_2178; } } 
{ /* Llib/midi.scm 517 */
long BgL_tckz00_721;
{ /* Llib/midi.scm 518 */
int32_t BgL_arg1995z00_764;
BgL_arg1995z00_764 = 
BGl_readzd2int16zd2zz__multimediazd2midizd2(BgL_ipz00_45); 
{ /* Llib/midi.scm 518 */
long BgL_res2680z00_2183;
{ /* Llib/midi.scm 518 */
long BgL_arg1421z00_2180;
BgL_arg1421z00_2180 = 
(long)(BgL_arg1995z00_764); 
{ /* Llib/midi.scm 518 */
long BgL_res2679z00_2182;
BgL_res2679z00_2182 = 
(long)(BgL_arg1421z00_2180); 
BgL_res2680z00_2183 = BgL_res2679z00_2182; } } 
BgL_tckz00_721 = BgL_res2680z00_2183; } } 
{ /* Llib/midi.scm 518 */
long BgL_divz00_722;
{ /* Llib/midi.scm 519 */
int32_t BgL_arg1994z00_763;
BgL_arg1994z00_763 = 
BGl_readzd2int16zd2zz__multimediazd2midizd2(BgL_ipz00_45); 
{ /* Llib/midi.scm 519 */
long BgL_res2682z00_2188;
{ /* Llib/midi.scm 519 */
long BgL_arg1421z00_2185;
BgL_arg1421z00_2185 = 
(long)(BgL_arg1994z00_763); 
{ /* Llib/midi.scm 519 */
long BgL_res2681z00_2187;
BgL_res2681z00_2187 = 
(long)(BgL_arg1421z00_2185); 
BgL_res2682z00_2188 = BgL_res2681z00_2187; } } 
BgL_divz00_722 = BgL_res2682z00_2188; } } 
{ /* Llib/midi.scm 519 */

if(
(
(BgL_divz00_722 >> 
(int)(((long)15)))==((long)0)))
{ /* Llib/midi.scm 521 */
long BgL_val4_1199z00_729;
BgL_val4_1199z00_729 = 
(BgL_divz00_722 & ((long)32767)); 
{ /* Llib/midi.scm 521 */
int BgL_res2686z00_2195;
{ /* Llib/midi.scm 521 */
int BgL_tmpz00_5975;
BgL_tmpz00_5975 = 
(int)(((long)5)); 
BgL_res2686z00_2195 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_5975); } BgL_res2686z00_2195; } 
{ /* Llib/midi.scm 521 */
obj_t BgL_auxz00_5980;int BgL_tmpz00_5978;
BgL_auxz00_5980 = 
BINT(BgL_fmtz00_720); 
BgL_tmpz00_5978 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_5978, BgL_auxz00_5980); } 
{ /* Llib/midi.scm 521 */
obj_t BgL_auxz00_5985;int BgL_tmpz00_5983;
BgL_auxz00_5985 = 
BINT(BgL_tckz00_721); 
BgL_tmpz00_5983 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_5983, BgL_auxz00_5985); } 
{ /* Llib/midi.scm 521 */
obj_t BgL_auxz00_5990;int BgL_tmpz00_5988;
BgL_auxz00_5990 = 
BINT(((long)500000)); 
BgL_tmpz00_5988 = 
(int)(((long)3)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_5988, BgL_auxz00_5990); } 
{ /* Llib/midi.scm 521 */
obj_t BgL_auxz00_5995;int BgL_tmpz00_5993;
BgL_auxz00_5995 = 
BINT(BgL_val4_1199z00_729); 
BgL_tmpz00_5993 = 
(int)(((long)4)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_5993, BgL_auxz00_5995); } 
return 
BGL_INT32_TO_BINT32(BgL_sza7za7_719);}  else 
{ 

{ /* Llib/midi.scm 522 */
long BgL_aux1166z00_731;
BgL_aux1166z00_731 = 
(((long)128)-
(
(BgL_divz00_722 >> 
(int)(((long)8))) & ((long)127))); 
switch( BgL_aux1166z00_731) { case ((long)24) : 

{ /* Llib/midi.scm 524 */
long BgL_val4_1204z00_737;
BgL_val4_1204z00_737 = 
(((long)12)*
(BgL_divz00_722 & ((long)255))); 
{ /* Llib/midi.scm 524 */
int BgL_res2695z00_2212;
{ /* Llib/midi.scm 524 */
int BgL_tmpz00_6005;
BgL_tmpz00_6005 = 
(int)(((long)5)); 
BgL_res2695z00_2212 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_6005); } BgL_res2695z00_2212; } 
{ /* Llib/midi.scm 524 */
obj_t BgL_auxz00_6010;int BgL_tmpz00_6008;
BgL_auxz00_6010 = 
BINT(BgL_fmtz00_720); 
BgL_tmpz00_6008 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6008, BgL_auxz00_6010); } 
{ /* Llib/midi.scm 524 */
obj_t BgL_auxz00_6015;int BgL_tmpz00_6013;
BgL_auxz00_6015 = 
BINT(BgL_tckz00_721); 
BgL_tmpz00_6013 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6013, BgL_auxz00_6015); } 
{ /* Llib/midi.scm 524 */
obj_t BgL_auxz00_6020;int BgL_tmpz00_6018;
BgL_auxz00_6020 = 
BINT(((long)500000)); 
BgL_tmpz00_6018 = 
(int)(((long)3)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6018, BgL_auxz00_6020); } 
{ /* Llib/midi.scm 524 */
obj_t BgL_auxz00_6025;int BgL_tmpz00_6023;
BgL_auxz00_6025 = 
BINT(BgL_val4_1204z00_737); 
BgL_tmpz00_6023 = 
(int)(((long)4)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6023, BgL_auxz00_6025); } 
return 
BGL_INT32_TO_BINT32(BgL_sza7za7_719);} break;case ((long)25) : 

{ /* Llib/midi.scm 526 */
long BgL_val4_1209z00_743;
BgL_val4_1209z00_743 = 
(((long)10)*
(BgL_divz00_722 & ((long)255))); 
{ /* Llib/midi.scm 526 */
int BgL_res2698z00_2217;
{ /* Llib/midi.scm 526 */
int BgL_tmpz00_6031;
BgL_tmpz00_6031 = 
(int)(((long)5)); 
BgL_res2698z00_2217 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_6031); } BgL_res2698z00_2217; } 
{ /* Llib/midi.scm 526 */
obj_t BgL_auxz00_6036;int BgL_tmpz00_6034;
BgL_auxz00_6036 = 
BINT(BgL_fmtz00_720); 
BgL_tmpz00_6034 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6034, BgL_auxz00_6036); } 
{ /* Llib/midi.scm 526 */
obj_t BgL_auxz00_6041;int BgL_tmpz00_6039;
BgL_auxz00_6041 = 
BINT(BgL_tckz00_721); 
BgL_tmpz00_6039 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6039, BgL_auxz00_6041); } 
{ /* Llib/midi.scm 526 */
obj_t BgL_auxz00_6046;int BgL_tmpz00_6044;
BgL_auxz00_6046 = 
BINT(((long)400000)); 
BgL_tmpz00_6044 = 
(int)(((long)3)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6044, BgL_auxz00_6046); } 
{ /* Llib/midi.scm 526 */
obj_t BgL_auxz00_6051;int BgL_tmpz00_6049;
BgL_auxz00_6051 = 
BINT(BgL_val4_1209z00_743); 
BgL_tmpz00_6049 = 
(int)(((long)4)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6049, BgL_auxz00_6051); } 
return 
BGL_INT32_TO_BINT32(BgL_sza7za7_719);} break;case ((long)29) : 

{ /* Llib/midi.scm 528 */
long BgL_val4_1214z00_749;
BgL_val4_1214z00_749 = 
(((long)2997)*
(BgL_divz00_722 & ((long)255))); 
{ /* Llib/midi.scm 528 */
int BgL_res2701z00_2222;
{ /* Llib/midi.scm 528 */
int BgL_tmpz00_6057;
BgL_tmpz00_6057 = 
(int)(((long)5)); 
BgL_res2701z00_2222 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_6057); } BgL_res2701z00_2222; } 
{ /* Llib/midi.scm 528 */
obj_t BgL_auxz00_6062;int BgL_tmpz00_6060;
BgL_auxz00_6062 = 
BINT(BgL_fmtz00_720); 
BgL_tmpz00_6060 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6060, BgL_auxz00_6062); } 
{ /* Llib/midi.scm 528 */
obj_t BgL_auxz00_6067;int BgL_tmpz00_6065;
BgL_auxz00_6067 = 
BINT(BgL_tckz00_721); 
BgL_tmpz00_6065 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6065, BgL_auxz00_6067); } 
{ /* Llib/midi.scm 528 */
obj_t BgL_auxz00_6072;int BgL_tmpz00_6070;
BgL_auxz00_6072 = 
BINT(((long)100000000)); 
BgL_tmpz00_6070 = 
(int)(((long)3)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6070, BgL_auxz00_6072); } 
{ /* Llib/midi.scm 528 */
obj_t BgL_auxz00_6077;int BgL_tmpz00_6075;
BgL_auxz00_6077 = 
BINT(BgL_val4_1214z00_749); 
BgL_tmpz00_6075 = 
(int)(((long)4)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6075, BgL_auxz00_6077); } 
return 
BGL_INT32_TO_BINT32(BgL_sza7za7_719);} break;case ((long)30) : 

{ /* Llib/midi.scm 530 */
long BgL_val4_1219z00_755;
BgL_val4_1219z00_755 = 
(((long)15)*
(BgL_divz00_722 & ((long)255))); 
{ /* Llib/midi.scm 530 */
int BgL_res2704z00_2227;
{ /* Llib/midi.scm 530 */
int BgL_tmpz00_6083;
BgL_tmpz00_6083 = 
(int)(((long)5)); 
BgL_res2704z00_2227 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_6083); } BgL_res2704z00_2227; } 
{ /* Llib/midi.scm 530 */
obj_t BgL_auxz00_6088;int BgL_tmpz00_6086;
BgL_auxz00_6088 = 
BINT(BgL_fmtz00_720); 
BgL_tmpz00_6086 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6086, BgL_auxz00_6088); } 
{ /* Llib/midi.scm 530 */
obj_t BgL_auxz00_6093;int BgL_tmpz00_6091;
BgL_auxz00_6093 = 
BINT(BgL_tckz00_721); 
BgL_tmpz00_6091 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6091, BgL_auxz00_6093); } 
{ /* Llib/midi.scm 530 */
obj_t BgL_auxz00_6098;int BgL_tmpz00_6096;
BgL_auxz00_6098 = 
BINT(((long)500000)); 
BgL_tmpz00_6096 = 
(int)(((long)3)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6096, BgL_auxz00_6098); } 
{ /* Llib/midi.scm 530 */
obj_t BgL_auxz00_6103;int BgL_tmpz00_6101;
BgL_auxz00_6103 = 
BINT(BgL_val4_1219z00_755); 
BgL_tmpz00_6101 = 
(int)(((long)4)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6101, BgL_auxz00_6103); } 
return 
BGL_INT32_TO_BINT32(BgL_sza7za7_719);} break;
default: 
{ /* Llib/midi.scm 534 */
long BgL_arg1990z00_759;
BgL_arg1990z00_759 = 
(((long)128)-
(
(BgL_divz00_722 >> 
(int)(((long)8))) & ((long)127))); 
return 
BGl_errorz00zz__errorz00(BGl_string3086z00zz__multimediazd2midizd2, BGl_string3087z00zz__multimediazd2midizd2, 
BINT(BgL_arg1990z00_759));} } } } } } } } }  else 
{ /* Llib/midi.scm 514 */
return 
BGl_errorz00zz__errorz00(BGl_string3086z00zz__multimediazd2midizd2, BGl_string3088z00zz__multimediazd2midizd2, BgL_tyz00_717);} } } 

}



/* midi-read-mtrk */
obj_t BGl_midizd2readzd2mtrkz00zz__multimediazd2midizd2(obj_t BgL_ipz00_46)
{
{ /* Llib/midi.scm 539 */
{ /* Llib/midi.scm 540 */
obj_t BgL_tyz00_766;
BgL_tyz00_766 = 
BGl_readzd2charszd2zz__r4_input_6_10_2z00(
BINT(((long)4)), BgL_ipz00_46); 
if(
bigloo_strcmp(
((obj_t)BgL_tyz00_766), BGl_string3089z00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 543 */
int32_t BgL_tmpz00_6120;
BgL_tmpz00_6120 = 
BGl_readzd2int32zd2zz__multimediazd2midizd2(BgL_ipz00_46); 
return 
BGL_INT32_TO_BINT32(BgL_tmpz00_6120);}  else 
{ /* Llib/midi.scm 541 */
return 
BGl_errorz00zz__errorz00(BGl_string3090z00zz__multimediazd2midizd2, BGl_string3088z00zz__multimediazd2midizd2, BgL_tyz00_766);} } } 

}



/* read-int16 */
int32_t BGl_readzd2int16zd2zz__multimediazd2midizd2(obj_t BgL_ipz00_49)
{
{ /* Llib/midi.scm 560 */
{ /* Llib/midi.scm 561 */
obj_t BgL_b1z00_769;
BgL_b1z00_769 = 
BGl_readzd2charzd2zz__r4_input_6_10_2z00(BgL_ipz00_49); 
{ /* Llib/midi.scm 561 */
obj_t BgL_b0z00_770;
BgL_b0z00_770 = 
BGl_readzd2charzd2zz__r4_input_6_10_2z00(BgL_ipz00_49); 
{ /* Llib/midi.scm 562 */

{ /* Llib/midi.scm 563 */
int32_t BgL_arg1999z00_771;int32_t BgL_arg2000z00_772;
{ /* Llib/midi.scm 563 */
int32_t BgL_arg2001z00_773;
{ /* Llib/midi.scm 555 */
long BgL_arg1998z00_2238;
BgL_arg1998z00_2238 = 
(
CCHAR(BgL_b1z00_769)); 
{ /* Llib/midi.scm 555 */
int32_t BgL_res2710z00_2242;
BgL_res2710z00_2242 = 
(int32_t)(BgL_arg1998z00_2238); 
BgL_arg2001z00_773 = BgL_res2710z00_2242; } } 
BgL_arg1999z00_771 = 
(BgL_arg2001z00_773 << 
(int)(((long)8))); } 
{ /* Llib/midi.scm 555 */
long BgL_arg1998z00_2245;
BgL_arg1998z00_2245 = 
(
CCHAR(BgL_b0z00_770)); 
{ /* Llib/midi.scm 555 */
int32_t BgL_res2713z00_2249;
BgL_res2713z00_2249 = 
(int32_t)(BgL_arg1998z00_2245); 
BgL_arg2000z00_772 = BgL_res2713z00_2249; } } 
return 
(BgL_arg1999z00_771+BgL_arg2000z00_772);} } } } } 

}



/* &read-int16 */
obj_t BGl_z62readzd2int16zb0zz__multimediazd2midizd2(obj_t BgL_envz00_3102, obj_t BgL_ipz00_3103)
{
{ /* Llib/midi.scm 560 */
{ /* Llib/midi.scm 561 */
int32_t BgL_tmpz00_6135;
BgL_tmpz00_6135 = 
BGl_readzd2int16zd2zz__multimediazd2midizd2(BgL_ipz00_3103); 
return 
BGL_INT32_TO_BINT32(BgL_tmpz00_6135);} } 

}



/* read-int32 */
int32_t BGl_readzd2int32zd2zz__multimediazd2midizd2(obj_t BgL_ipz00_50)
{
{ /* Llib/midi.scm 569 */
{ /* Llib/midi.scm 570 */
obj_t BgL_b3z00_774;
BgL_b3z00_774 = 
BGl_readzd2charzd2zz__r4_input_6_10_2z00(BgL_ipz00_50); 
{ /* Llib/midi.scm 570 */
obj_t BgL_b2z00_775;
BgL_b2z00_775 = 
BGl_readzd2charzd2zz__r4_input_6_10_2z00(BgL_ipz00_50); 
{ /* Llib/midi.scm 571 */
obj_t BgL_b1z00_776;
BgL_b1z00_776 = 
BGl_readzd2charzd2zz__r4_input_6_10_2z00(BgL_ipz00_50); 
{ /* Llib/midi.scm 572 */
obj_t BgL_b0z00_777;
BgL_b0z00_777 = 
BGl_readzd2charzd2zz__r4_input_6_10_2z00(BgL_ipz00_50); 
{ /* Llib/midi.scm 573 */

{ /* Llib/midi.scm 574 */
int32_t BgL_arg2002z00_778;int32_t BgL_arg2003z00_779;
{ /* Llib/midi.scm 574 */
int32_t BgL_arg2004z00_780;
{ /* Llib/midi.scm 555 */
long BgL_arg1998z00_2253;
BgL_arg1998z00_2253 = 
(
CCHAR(BgL_b3z00_774)); 
{ /* Llib/midi.scm 555 */
int32_t BgL_res2716z00_2257;
BgL_res2716z00_2257 = 
(int32_t)(BgL_arg1998z00_2253); 
BgL_arg2004z00_780 = BgL_res2716z00_2257; } } 
BgL_arg2002z00_778 = 
(BgL_arg2004z00_780 << 
(int)(((long)24))); } 
{ /* Llib/midi.scm 575 */
int32_t BgL_arg2005z00_781;int32_t BgL_arg2006z00_782;
{ /* Llib/midi.scm 575 */
int32_t BgL_arg2007z00_783;
{ /* Llib/midi.scm 555 */
long BgL_arg1998z00_2260;
BgL_arg1998z00_2260 = 
(
CCHAR(BgL_b2z00_775)); 
{ /* Llib/midi.scm 555 */
int32_t BgL_res2719z00_2264;
BgL_res2719z00_2264 = 
(int32_t)(BgL_arg1998z00_2260); 
BgL_arg2007z00_783 = BgL_res2719z00_2264; } } 
BgL_arg2005z00_781 = 
(BgL_arg2007z00_783 << 
(int)(((long)16))); } 
{ /* Llib/midi.scm 576 */
int32_t BgL_arg2008z00_784;int32_t BgL_arg2009z00_785;
{ /* Llib/midi.scm 576 */
int32_t BgL_arg2010z00_786;
{ /* Llib/midi.scm 555 */
long BgL_arg1998z00_2267;
BgL_arg1998z00_2267 = 
(
CCHAR(BgL_b1z00_776)); 
{ /* Llib/midi.scm 555 */
int32_t BgL_res2722z00_2271;
BgL_res2722z00_2271 = 
(int32_t)(BgL_arg1998z00_2267); 
BgL_arg2010z00_786 = BgL_res2722z00_2271; } } 
BgL_arg2008z00_784 = 
(BgL_arg2010z00_786 << 
(int)(((long)8))); } 
{ /* Llib/midi.scm 555 */
long BgL_arg1998z00_2274;
BgL_arg1998z00_2274 = 
(
CCHAR(BgL_b0z00_777)); 
{ /* Llib/midi.scm 555 */
int32_t BgL_res2725z00_2278;
BgL_res2725z00_2278 = 
(int32_t)(BgL_arg1998z00_2274); 
BgL_arg2009z00_785 = BgL_res2725z00_2278; } } 
BgL_arg2006z00_782 = 
(BgL_arg2008z00_784+BgL_arg2009z00_785); } 
BgL_arg2003z00_779 = 
(BgL_arg2005z00_781+BgL_arg2006z00_782); } 
return 
(BgL_arg2002z00_778+BgL_arg2003z00_779);} } } } } } } 

}



/* &read-int32 */
obj_t BGl_z62readzd2int32zb0zz__multimediazd2midizd2(obj_t BgL_envz00_3104, obj_t BgL_ipz00_3105)
{
{ /* Llib/midi.scm 569 */
{ /* Llib/midi.scm 570 */
int32_t BgL_tmpz00_6163;
BgL_tmpz00_6163 = 
BGl_readzd2int32zd2zz__multimediazd2midizd2(BgL_ipz00_3105); 
return 
BGL_INT32_TO_BINT32(BgL_tmpz00_6163);} } 

}



/* read-int */
long BGl_readzd2intzd2zz__multimediazd2midizd2(long BgL_lenz00_51, obj_t BgL_ipz00_52)
{
{ /* Llib/midi.scm 582 */
{ /* Llib/midi.scm 583 */
long BgL_g1167z00_787;
{ /* Llib/midi.scm 583 */
obj_t BgL_arg2018z00_799;
BgL_arg2018z00_799 = 
BGl_readzd2charzd2zz__r4_input_6_10_2z00(BgL_ipz00_52); 
BgL_g1167z00_787 = 
(
CCHAR(BgL_arg2018z00_799)); } 
{ 
long BgL_valz00_789;long BgL_lenz00_790;
BgL_valz00_789 = BgL_g1167z00_787; 
BgL_lenz00_790 = BgL_lenz00_51; 
BgL_zc3z04anonymousza32011ze3z87_791:
if(
(BgL_lenz00_790==((long)1)))
{ /* Llib/midi.scm 585 */
return BgL_valz00_789;}  else 
{ /* Llib/midi.scm 587 */
long BgL_arg2013z00_793;long BgL_arg2014z00_794;
{ /* Llib/midi.scm 587 */
long BgL_arg2015z00_795;long BgL_arg2016z00_796;
BgL_arg2015z00_795 = 
(BgL_valz00_789 << 
(int)(((long)8))); 
{ /* Llib/midi.scm 587 */
obj_t BgL_arg2017z00_797;
BgL_arg2017z00_797 = 
BGl_readzd2charzd2zz__r4_input_6_10_2z00(BgL_ipz00_52); 
BgL_arg2016z00_796 = 
(
CCHAR(BgL_arg2017z00_797)); } 
BgL_arg2013z00_793 = 
(BgL_arg2015z00_795+BgL_arg2016z00_796); } 
BgL_arg2014z00_794 = 
(BgL_lenz00_790-((long)1)); 
{ 
long BgL_lenz00_6179;long BgL_valz00_6178;
BgL_valz00_6178 = BgL_arg2013z00_793; 
BgL_lenz00_6179 = BgL_arg2014z00_794; 
BgL_lenz00_790 = BgL_lenz00_6179; 
BgL_valz00_789 = BgL_valz00_6178; 
goto BgL_zc3z04anonymousza32011ze3z87_791;} } } } } 

}



/* &read-int */
obj_t BGl_z62readzd2intzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3106, obj_t BgL_lenz00_3107, obj_t BgL_ipz00_3108)
{
{ /* Llib/midi.scm 582 */
{ /* Llib/midi.scm 583 */
long BgL_tmpz00_6180;
{ /* Llib/midi.scm 583 */
obj_t BgL_auxz00_6190;long BgL_auxz00_6181;
if(
INPUT_PORTP(BgL_ipz00_3108))
{ /* Llib/midi.scm 583 */
BgL_auxz00_6190 = BgL_ipz00_3108
; }  else 
{ 
obj_t BgL_auxz00_6193;
BgL_auxz00_6193 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)24391)), BGl_string3091z00zz__multimediazd2midizd2, BGl_string3071z00zz__multimediazd2midizd2, BgL_ipz00_3108); 
FAILURE(BgL_auxz00_6193,BFALSE,BFALSE);} 
{ /* Llib/midi.scm 583 */
obj_t BgL_tmpz00_6182;
if(
INTEGERP(BgL_lenz00_3107))
{ /* Llib/midi.scm 583 */
BgL_tmpz00_6182 = BgL_lenz00_3107
; }  else 
{ 
obj_t BgL_auxz00_6185;
BgL_auxz00_6185 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)24391)), BGl_string3091z00zz__multimediazd2midizd2, BGl_string3072z00zz__multimediazd2midizd2, BgL_lenz00_3107); 
FAILURE(BgL_auxz00_6185,BFALSE,BFALSE);} 
BgL_auxz00_6181 = 
(long)CINT(BgL_tmpz00_6182); } 
BgL_tmpz00_6180 = 
BGl_readzd2intzd2zz__multimediazd2midizd2(BgL_auxz00_6181, BgL_auxz00_6190); } 
return 
BINT(BgL_tmpz00_6180);} } 

}



/* &read-vlq */
obj_t BGl_z62readzd2vlqzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3109, obj_t BgL_ipz00_3110)
{
{ /* Llib/midi.scm 593 */
{ /* Llib/midi.scm 595 */
long BgL_tmpz00_6199;
{ 
long BgL_accz00_4128;
BgL_accz00_4128 = ((long)0); 
BgL_loopz00_4127:
{ /* Llib/midi.scm 595 */
long BgL_cz00_4129;
{ /* Llib/midi.scm 595 */
obj_t BgL_arg2024z00_4130;
BgL_arg2024z00_4130 = 
BGl_readzd2charzd2zz__r4_input_6_10_2z00(BgL_ipz00_3110); 
BgL_cz00_4129 = 
(
CCHAR(BgL_arg2024z00_4130)); } 
if(
(BgL_cz00_4129<=((long)127)))
{ /* Llib/midi.scm 596 */
BgL_tmpz00_6199 = 
(BgL_cz00_4129+BgL_accz00_4128)
; }  else 
{ 
long BgL_accz00_6206;
BgL_accz00_6206 = 
(
(BgL_accz00_4128+
(BgL_cz00_4129 & ((long)127))) << 
(int)(((long)7))); 
BgL_accz00_4128 = BgL_accz00_6206; 
goto BgL_loopz00_4127;} } } 
return 
BINT(BgL_tmpz00_6199);} } 

}



/* string-stream-peek-byte */
long BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(obj_t BgL_ipz00_54)
{
{ /* Llib/midi.scm 603 */
return 
(
STRING_REF(
STRUCT_REF(BgL_ipz00_54, 
(int)(((long)0))), 
(long)CINT(
STRUCT_REF(BgL_ipz00_54, 
(int)(((long)1))))));} 

}



/* &string-stream-peek-byte */
obj_t BGl_z62stringzd2streamzd2peekzd2bytezb0zz__multimediazd2midizd2(obj_t BgL_envz00_3114, obj_t BgL_ipz00_3115)
{
{ /* Llib/midi.scm 603 */
{ /* Llib/midi.scm 605 */
long BgL_tmpz00_6219;
{ /* Llib/midi.scm 605 */
obj_t BgL_auxz00_6220;
if(
STRUCTP(BgL_ipz00_3115))
{ /* Llib/midi.scm 605 */
BgL_auxz00_6220 = BgL_ipz00_3115
; }  else 
{ 
obj_t BgL_auxz00_6223;
BgL_auxz00_6223 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)25285)), BGl_string3092z00zz__multimediazd2midizd2, BGl_string3093z00zz__multimediazd2midizd2, BgL_ipz00_3115); 
FAILURE(BgL_auxz00_6223,BFALSE,BFALSE);} 
BgL_tmpz00_6219 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(BgL_auxz00_6220); } 
return 
BINT(BgL_tmpz00_6219);} } 

}



/* &string-stream-read-byte */
obj_t BGl_z62stringzd2streamzd2readzd2bytezb0zz__multimediazd2midizd2(obj_t BgL_envz00_3116, obj_t BgL_ipz00_3117)
{
{ /* Llib/midi.scm 610 */
{ /* Llib/midi.scm 611 */
long BgL_tmpz00_6229;
{ /* Llib/midi.scm 611 */
obj_t BgL_ipz00_4131;
if(
STRUCTP(BgL_ipz00_3117))
{ /* Llib/midi.scm 611 */
BgL_ipz00_4131 = BgL_ipz00_3117; }  else 
{ 
obj_t BgL_auxz00_6232;
BgL_auxz00_6232 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)25610)), BGl_string3094z00zz__multimediazd2midizd2, BGl_string3093z00zz__multimediazd2midizd2, BgL_ipz00_3117); 
FAILURE(BgL_auxz00_6232,BFALSE,BFALSE);} 
{ /* Llib/midi.scm 611 */
long BgL_bz00_4132;
BgL_bz00_4132 = 
(
STRING_REF(
STRUCT_REF(BgL_ipz00_4131, 
(int)(((long)0))), 
(long)CINT(
STRUCT_REF(BgL_ipz00_4131, 
(int)(((long)1)))))); 
{ /* Llib/midi.scm 612 */
long BgL_arg2028z00_4133;
BgL_arg2028z00_4133 = 
(
(long)CINT(
STRUCT_REF(BgL_ipz00_4131, 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6249;int BgL_tmpz00_6247;
BgL_auxz00_6249 = 
BINT(BgL_arg2028z00_4133); 
BgL_tmpz00_6247 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_4131, BgL_tmpz00_6247, BgL_auxz00_6249); } } 
BgL_tmpz00_6229 = BgL_bz00_4132; } } 
return 
BINT(BgL_tmpz00_6229);} } 

}



/* &string-stream-read-int16 */
obj_t BGl_z62stringzd2streamzd2readzd2int16zb0zz__multimediazd2midizd2(obj_t BgL_envz00_3118, obj_t BgL_ipz00_3119)
{
{ /* Llib/midi.scm 618 */
{ /* Llib/midi.scm 619 */
int32_t BgL_tmpz00_6253;
{ /* Llib/midi.scm 619 */
obj_t BgL_ipz00_4134;
if(
STRUCTP(BgL_ipz00_3119))
{ /* Llib/midi.scm 619 */
BgL_ipz00_4134 = BgL_ipz00_3119; }  else 
{ 
obj_t BgL_auxz00_6256;
BgL_auxz00_6256 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)26001)), BGl_string3095z00zz__multimediazd2midizd2, BGl_string3093z00zz__multimediazd2midizd2, BgL_ipz00_3119); 
FAILURE(BgL_auxz00_6256,BFALSE,BFALSE);} 
{ /* Llib/midi.scm 619 */
long BgL_b1z00_4135;
{ /* Llib/midi.scm 611 */
long BgL_bz00_4136;
BgL_bz00_4136 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(BgL_ipz00_4134); 
{ /* Llib/midi.scm 612 */
long BgL_arg2028z00_4137;
BgL_arg2028z00_4137 = 
(
(long)CINT(
STRUCT_REF(BgL_ipz00_4134, 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6267;int BgL_tmpz00_6265;
BgL_auxz00_6267 = 
BINT(BgL_arg2028z00_4137); 
BgL_tmpz00_6265 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_4134, BgL_tmpz00_6265, BgL_auxz00_6267); } } 
BgL_b1z00_4135 = BgL_bz00_4136; } 
{ /* Llib/midi.scm 619 */
long BgL_b0z00_4138;
{ /* Llib/midi.scm 611 */
long BgL_bz00_4139;
BgL_bz00_4139 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(BgL_ipz00_4134); 
{ /* Llib/midi.scm 612 */
long BgL_arg2028z00_4140;
BgL_arg2028z00_4140 = 
(
(long)CINT(
STRUCT_REF(BgL_ipz00_4134, 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6277;int BgL_tmpz00_6275;
BgL_auxz00_6277 = 
BINT(BgL_arg2028z00_4140); 
BgL_tmpz00_6275 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_4134, BgL_tmpz00_6275, BgL_auxz00_6277); } } 
BgL_b0z00_4138 = BgL_bz00_4139; } 
{ /* Llib/midi.scm 620 */

{ /* Llib/midi.scm 621 */
int32_t BgL_arg2030z00_4141;int32_t BgL_arg2031z00_4142;
{ /* Llib/midi.scm 621 */
int32_t BgL_arg2032z00_4143;
{ /* Llib/midi.scm 621 */
int32_t BgL_res2748z00_4144;
BgL_res2748z00_4144 = 
(int32_t)(BgL_b1z00_4135); 
BgL_arg2032z00_4143 = BgL_res2748z00_4144; } 
BgL_arg2030z00_4141 = 
(BgL_arg2032z00_4143 << 
(int)(((long)8))); } 
{ /* Llib/midi.scm 621 */
int32_t BgL_res2750z00_4145;
BgL_res2750z00_4145 = 
(int32_t)(BgL_b0z00_4138); 
BgL_arg2031z00_4142 = BgL_res2750z00_4145; } 
BgL_tmpz00_6253 = 
(BgL_arg2030z00_4141+BgL_arg2031z00_4142); } } } } } 
return 
BGL_INT32_TO_BINT32(BgL_tmpz00_6253);} } 

}



/* &string-stream-read-int32 */
obj_t BGl_z62stringzd2streamzd2readzd2int32zb0zz__multimediazd2midizd2(obj_t BgL_envz00_3120, obj_t BgL_ipz00_3121)
{
{ /* Llib/midi.scm 626 */
{ /* Llib/midi.scm 627 */
int32_t BgL_tmpz00_6286;
{ /* Llib/midi.scm 627 */
obj_t BgL_ipz00_4146;
if(
STRUCTP(BgL_ipz00_3121))
{ /* Llib/midi.scm 627 */
BgL_ipz00_4146 = BgL_ipz00_3121; }  else 
{ 
obj_t BgL_auxz00_6289;
BgL_auxz00_6289 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)26420)), BGl_string3096z00zz__multimediazd2midizd2, BGl_string3093z00zz__multimediazd2midizd2, BgL_ipz00_3121); 
FAILURE(BgL_auxz00_6289,BFALSE,BFALSE);} 
{ /* Llib/midi.scm 627 */
long BgL_b3z00_4147;
{ /* Llib/midi.scm 611 */
long BgL_bz00_4148;
BgL_bz00_4148 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(BgL_ipz00_4146); 
{ /* Llib/midi.scm 612 */
long BgL_arg2028z00_4149;
BgL_arg2028z00_4149 = 
(
(long)CINT(
STRUCT_REF(BgL_ipz00_4146, 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6300;int BgL_tmpz00_6298;
BgL_auxz00_6300 = 
BINT(BgL_arg2028z00_4149); 
BgL_tmpz00_6298 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_4146, BgL_tmpz00_6298, BgL_auxz00_6300); } } 
BgL_b3z00_4147 = BgL_bz00_4148; } 
{ /* Llib/midi.scm 627 */
long BgL_b2z00_4150;
{ /* Llib/midi.scm 611 */
long BgL_bz00_4151;
BgL_bz00_4151 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(BgL_ipz00_4146); 
{ /* Llib/midi.scm 612 */
long BgL_arg2028z00_4152;
BgL_arg2028z00_4152 = 
(
(long)CINT(
STRUCT_REF(BgL_ipz00_4146, 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6310;int BgL_tmpz00_6308;
BgL_auxz00_6310 = 
BINT(BgL_arg2028z00_4152); 
BgL_tmpz00_6308 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_4146, BgL_tmpz00_6308, BgL_auxz00_6310); } } 
BgL_b2z00_4150 = BgL_bz00_4151; } 
{ /* Llib/midi.scm 628 */
long BgL_b1z00_4153;
{ /* Llib/midi.scm 611 */
long BgL_bz00_4154;
BgL_bz00_4154 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(BgL_ipz00_4146); 
{ /* Llib/midi.scm 612 */
long BgL_arg2028z00_4155;
BgL_arg2028z00_4155 = 
(
(long)CINT(
STRUCT_REF(BgL_ipz00_4146, 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6320;int BgL_tmpz00_6318;
BgL_auxz00_6320 = 
BINT(BgL_arg2028z00_4155); 
BgL_tmpz00_6318 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_4146, BgL_tmpz00_6318, BgL_auxz00_6320); } } 
BgL_b1z00_4153 = BgL_bz00_4154; } 
{ /* Llib/midi.scm 629 */
long BgL_b0z00_4156;
{ /* Llib/midi.scm 611 */
long BgL_bz00_4157;
BgL_bz00_4157 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(BgL_ipz00_4146); 
{ /* Llib/midi.scm 612 */
long BgL_arg2028z00_4158;
BgL_arg2028z00_4158 = 
(
(long)CINT(
STRUCT_REF(BgL_ipz00_4146, 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6330;int BgL_tmpz00_6328;
BgL_auxz00_6330 = 
BINT(BgL_arg2028z00_4158); 
BgL_tmpz00_6328 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_4146, BgL_tmpz00_6328, BgL_auxz00_6330); } } 
BgL_b0z00_4156 = BgL_bz00_4157; } 
{ /* Llib/midi.scm 630 */

{ /* Llib/midi.scm 631 */
int32_t BgL_arg2033z00_4159;int32_t BgL_arg2034z00_4160;
{ /* Llib/midi.scm 631 */
int32_t BgL_arg2035z00_4161;
{ /* Llib/midi.scm 631 */
int32_t BgL_res2756z00_4162;
BgL_res2756z00_4162 = 
(int32_t)(BgL_b3z00_4147); 
BgL_arg2035z00_4161 = BgL_res2756z00_4162; } 
BgL_arg2033z00_4159 = 
(BgL_arg2035z00_4161 << 
(int)(((long)24))); } 
{ /* Llib/midi.scm 632 */
int32_t BgL_arg2036z00_4163;int32_t BgL_arg2037z00_4164;
{ /* Llib/midi.scm 632 */
int32_t BgL_arg2038z00_4165;
{ /* Llib/midi.scm 632 */
int32_t BgL_res2758z00_4166;
BgL_res2758z00_4166 = 
(int32_t)(BgL_b2z00_4150); 
BgL_arg2038z00_4165 = BgL_res2758z00_4166; } 
BgL_arg2036z00_4163 = 
(BgL_arg2038z00_4165 << 
(int)(((long)16))); } 
{ /* Llib/midi.scm 633 */
int32_t BgL_arg2039z00_4167;int32_t BgL_arg2040z00_4168;
{ /* Llib/midi.scm 633 */
int32_t BgL_arg2041z00_4169;
{ /* Llib/midi.scm 633 */
int32_t BgL_res2760z00_4170;
BgL_res2760z00_4170 = 
(int32_t)(BgL_b1z00_4153); 
BgL_arg2041z00_4169 = BgL_res2760z00_4170; } 
BgL_arg2039z00_4167 = 
(BgL_arg2041z00_4169 << 
(int)(((long)8))); } 
{ /* Llib/midi.scm 634 */
int32_t BgL_res2762z00_4171;
BgL_res2762z00_4171 = 
(int32_t)(BgL_b0z00_4156); 
BgL_arg2040z00_4168 = BgL_res2762z00_4171; } 
BgL_arg2037z00_4164 = 
(BgL_arg2039z00_4167+BgL_arg2040z00_4168); } 
BgL_arg2034z00_4160 = 
(BgL_arg2036z00_4163+BgL_arg2037z00_4164); } 
BgL_tmpz00_6286 = 
(BgL_arg2033z00_4159+BgL_arg2034z00_4160); } } } } } } } 
return 
BGL_INT32_TO_BINT32(BgL_tmpz00_6286);} } 

}



/* &string-stream-read-int */
obj_t BGl_z62stringzd2streamzd2readzd2intzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3122, obj_t BgL_lenz00_3123, obj_t BgL_ipz00_3124)
{
{ /* Llib/midi.scm 639 */
{ /* Llib/midi.scm 640 */
long BgL_tmpz00_6347;
{ /* Llib/midi.scm 640 */
long BgL_lenz00_4172;obj_t BgL_ipz00_4173;
{ /* Llib/midi.scm 640 */
obj_t BgL_tmpz00_6348;
if(
INTEGERP(BgL_lenz00_3123))
{ /* Llib/midi.scm 640 */
BgL_tmpz00_6348 = BgL_lenz00_3123
; }  else 
{ 
obj_t BgL_auxz00_6351;
BgL_auxz00_6351 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)27020)), BGl_string3097z00zz__multimediazd2midizd2, BGl_string3072z00zz__multimediazd2midizd2, BgL_lenz00_3123); 
FAILURE(BgL_auxz00_6351,BFALSE,BFALSE);} 
BgL_lenz00_4172 = 
(long)CINT(BgL_tmpz00_6348); } 
if(
STRUCTP(BgL_ipz00_3124))
{ /* Llib/midi.scm 640 */
BgL_ipz00_4173 = BgL_ipz00_3124; }  else 
{ 
obj_t BgL_auxz00_6358;
BgL_auxz00_6358 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)27020)), BGl_string3097z00zz__multimediazd2midizd2, BGl_string3093z00zz__multimediazd2midizd2, BgL_ipz00_3124); 
FAILURE(BgL_auxz00_6358,BFALSE,BFALSE);} 
{ /* Llib/midi.scm 640 */
long BgL_g1169z00_4174;
{ /* Llib/midi.scm 611 */
long BgL_bz00_4175;
BgL_bz00_4175 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(BgL_ipz00_4173); 
{ /* Llib/midi.scm 612 */
long BgL_arg2028z00_4176;
BgL_arg2028z00_4176 = 
(
(long)CINT(
STRUCT_REF(BgL_ipz00_4173, 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6369;int BgL_tmpz00_6367;
BgL_auxz00_6369 = 
BINT(BgL_arg2028z00_4176); 
BgL_tmpz00_6367 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_4173, BgL_tmpz00_6367, BgL_auxz00_6369); } } 
BgL_g1169z00_4174 = BgL_bz00_4175; } 
{ 
long BgL_valz00_4178;long BgL_lenz00_4179;
BgL_valz00_4178 = BgL_g1169z00_4174; 
BgL_lenz00_4179 = BgL_lenz00_4172; 
BgL_loopz00_4177:
if(
(BgL_lenz00_4179==((long)1)))
{ /* Llib/midi.scm 642 */
BgL_tmpz00_6347 = BgL_valz00_4178
; }  else 
{ /* Llib/midi.scm 644 */
long BgL_arg2044z00_4180;long BgL_arg2045z00_4181;
{ /* Llib/midi.scm 644 */
long BgL_arg2046z00_4182;long BgL_arg2047z00_4183;
BgL_arg2046z00_4182 = 
(BgL_valz00_4178 << 
(int)(((long)8))); 
{ /* Llib/midi.scm 611 */
long BgL_bz00_4184;
BgL_bz00_4184 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(BgL_ipz00_4173); 
{ /* Llib/midi.scm 612 */
long BgL_arg2028z00_4185;
BgL_arg2028z00_4185 = 
(
(long)CINT(
STRUCT_REF(BgL_ipz00_4173, 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6383;int BgL_tmpz00_6381;
BgL_auxz00_6383 = 
BINT(BgL_arg2028z00_4185); 
BgL_tmpz00_6381 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_4173, BgL_tmpz00_6381, BgL_auxz00_6383); } } 
BgL_arg2047z00_4183 = BgL_bz00_4184; } 
BgL_arg2044z00_4180 = 
(BgL_arg2046z00_4182+BgL_arg2047z00_4183); } 
BgL_arg2045z00_4181 = 
(BgL_lenz00_4179-((long)1)); 
{ 
long BgL_lenz00_6389;long BgL_valz00_6388;
BgL_valz00_6388 = BgL_arg2044z00_4180; 
BgL_lenz00_6389 = BgL_arg2045z00_4181; 
BgL_lenz00_4179 = BgL_lenz00_6389; 
BgL_valz00_4178 = BgL_valz00_6388; 
goto BgL_loopz00_4177;} } } } } 
return 
BINT(BgL_tmpz00_6347);} } 

}



/* &string-stream-read-vlq */
obj_t BGl_z62stringzd2streamzd2readzd2vlqzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3125, obj_t BgL_ipz00_3126)
{
{ /* Llib/midi.scm 650 */
{ /* Llib/midi.scm 652 */
long BgL_tmpz00_6391;
{ 
long BgL_accz00_4187;
BgL_accz00_4187 = ((long)0); 
BgL_loopz00_4186:
{ /* Llib/midi.scm 652 */
long BgL_cz00_4188;
{ /* Llib/midi.scm 611 */
long BgL_bz00_4189;
BgL_bz00_4189 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(
((obj_t)BgL_ipz00_3126)); 
{ /* Llib/midi.scm 612 */
long BgL_arg2028z00_4190;
BgL_arg2028z00_4190 = 
(
(long)CINT(
STRUCT_REF(
((obj_t)BgL_ipz00_3126), 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6403;int BgL_auxz00_6401;obj_t BgL_tmpz00_6399;
BgL_auxz00_6403 = 
BINT(BgL_arg2028z00_4190); 
BgL_auxz00_6401 = 
(int)(((long)1)); 
BgL_tmpz00_6399 = 
((obj_t)BgL_ipz00_3126); 
STRUCT_SET(BgL_tmpz00_6399, BgL_auxz00_6401, BgL_auxz00_6403); } } 
BgL_cz00_4188 = BgL_bz00_4189; } 
if(
(BgL_cz00_4188<=((long)127)))
{ /* Llib/midi.scm 653 */
BgL_tmpz00_6391 = 
(BgL_cz00_4188+BgL_accz00_4187)
; }  else 
{ 
long BgL_accz00_6409;
BgL_accz00_6409 = 
(
(BgL_accz00_4187+
(BgL_cz00_4188 & ((long)127))) << 
(int)(((long)7))); 
BgL_accz00_4187 = BgL_accz00_6409; 
goto BgL_loopz00_4186;} } } 
return 
BINT(BgL_tmpz00_6391);} } 

}



/* &string-stream-read-chars */
obj_t BGl_z62stringzd2streamzd2readzd2charszb0zz__multimediazd2midizd2(obj_t BgL_envz00_3127, obj_t BgL_lenz00_3128, obj_t BgL_ipz00_3129)
{
{ /* Llib/midi.scm 660 */
{ /* Llib/midi.scm 661 */
obj_t BgL_ipz00_4191;
if(
STRUCTP(BgL_ipz00_3129))
{ /* Llib/midi.scm 661 */
BgL_ipz00_4191 = BgL_ipz00_3129; }  else 
{ 
obj_t BgL_auxz00_6417;
BgL_auxz00_6417 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)27894)), BGl_string3098z00zz__multimediazd2midizd2, BGl_string3093z00zz__multimediazd2midizd2, BgL_ipz00_3129); 
FAILURE(BgL_auxz00_6417,BFALSE,BFALSE);} 
{ /* Llib/midi.scm 661 */
obj_t BgL_sz00_4192;
{ /* Llib/midi.scm 661 */
obj_t BgL_arg2055z00_4193;obj_t BgL_arg2056z00_4194;obj_t BgL_arg2057z00_4195;
BgL_arg2055z00_4193 = 
STRUCT_REF(BgL_ipz00_4191, 
(int)(((long)0))); 
BgL_arg2056z00_4194 = 
STRUCT_REF(BgL_ipz00_4191, 
(int)(((long)1))); 
BgL_arg2057z00_4195 = 
BGl_2zb2zb2zz__r4_numbers_6_5z00(
STRUCT_REF(BgL_ipz00_4191, 
(int)(((long)1))), BgL_lenz00_3128); 
{ /* Llib/midi.scm 661 */
obj_t BgL_res2778z00_4196;
{ /* Llib/midi.scm 661 */
long BgL_startz00_4197;long BgL_endz00_4198;
BgL_startz00_4197 = 
(long)CINT(BgL_arg2056z00_4194); 
BgL_endz00_4198 = 
(long)CINT(BgL_arg2057z00_4195); 
BgL_res2778z00_4196 = 
c_substring(
((obj_t)BgL_arg2055z00_4193), BgL_startz00_4197, BgL_endz00_4198); } 
BgL_sz00_4192 = BgL_res2778z00_4196; } } 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6434;int BgL_tmpz00_6432;
BgL_auxz00_6434 = 
BGl_2zb2zb2zz__r4_numbers_6_5z00(
STRUCT_REF(BgL_ipz00_4191, 
(int)(((long)1))), BgL_lenz00_3128); 
BgL_tmpz00_6432 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_4191, BgL_tmpz00_6432, BgL_auxz00_6434); } 
return BgL_sz00_4192;} } } 

}



/* midiplayer-cdelay */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2cdelayzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_68, BgL_midisinkz00_bglt BgL_msz00_69, long BgL_tickz00_70, BgL_miditrackz00_bglt BgL_trackz00_71, long BgL_ppqz00_72, long BgL_dtz00_73, long BgL_usz00_74)
{
{ /* Llib/midi.scm 993 */
if(
(BgL_dtz00_73>((long)0)))
{ /* Llib/midi.scm 998 */
obj_t BgL_fun2061z00_2480;
BgL_fun2061z00_2480 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_69))->BgL_usleepz00); 
{ /* Llib/midi.scm 998 */
long BgL_arg2060z00_2481;
BgL_arg2060z00_2481 = 
(
(
(BgL_dtz00_73*
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_71))->BgL_tempoz00))/BgL_ppqz00_72)-BgL_usz00_74); 
return 
PROCEDURE_ENTRY(BgL_fun2061z00_2480)(BgL_fun2061z00_2480, 
BINT(BgL_arg2060z00_2481), BEOA);} }  else 
{ /* Llib/midi.scm 997 */
return BFALSE;} } 

}



/* &midiplayer-cdelay */
obj_t BGl_z62midiplayerzd2cdelayzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3156, obj_t BgL_mpz00_3157, obj_t BgL_msz00_3158, obj_t BgL_tickz00_3159, obj_t BgL_trackz00_3160, obj_t BgL_ppqz00_3161, obj_t BgL_dtz00_3162, obj_t BgL_usz00_3163)
{
{ /* Llib/midi.scm 993 */
{ /* Llib/midi.scm 995 */
long BgL_auxz00_6502;long BgL_auxz00_6493;long BgL_auxz00_6484;BgL_miditrackz00_bglt BgL_auxz00_6476;long BgL_auxz00_6467;BgL_midisinkz00_bglt BgL_auxz00_6459;BgL_midiplayerz00_bglt BgL_auxz00_6451;
{ /* Llib/midi.scm 995 */
obj_t BgL_tmpz00_6503;
if(
INTEGERP(BgL_usz00_3163))
{ /* Llib/midi.scm 995 */
BgL_tmpz00_6503 = BgL_usz00_3163
; }  else 
{ 
obj_t BgL_auxz00_6506;
BgL_auxz00_6506 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)37739)), BGl_string3099z00zz__multimediazd2midizd2, BGl_string3072z00zz__multimediazd2midizd2, BgL_usz00_3163); 
FAILURE(BgL_auxz00_6506,BFALSE,BFALSE);} 
BgL_auxz00_6502 = 
(long)CINT(BgL_tmpz00_6503); } 
{ /* Llib/midi.scm 995 */
obj_t BgL_tmpz00_6494;
if(
INTEGERP(BgL_dtz00_3162))
{ /* Llib/midi.scm 995 */
BgL_tmpz00_6494 = BgL_dtz00_3162
; }  else 
{ 
obj_t BgL_auxz00_6497;
BgL_auxz00_6497 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)37739)), BGl_string3099z00zz__multimediazd2midizd2, BGl_string3072z00zz__multimediazd2midizd2, BgL_dtz00_3162); 
FAILURE(BgL_auxz00_6497,BFALSE,BFALSE);} 
BgL_auxz00_6493 = 
(long)CINT(BgL_tmpz00_6494); } 
{ /* Llib/midi.scm 995 */
obj_t BgL_tmpz00_6485;
if(
INTEGERP(BgL_ppqz00_3161))
{ /* Llib/midi.scm 995 */
BgL_tmpz00_6485 = BgL_ppqz00_3161
; }  else 
{ 
obj_t BgL_auxz00_6488;
BgL_auxz00_6488 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)37739)), BGl_string3099z00zz__multimediazd2midizd2, BGl_string3072z00zz__multimediazd2midizd2, BgL_ppqz00_3161); 
FAILURE(BgL_auxz00_6488,BFALSE,BFALSE);} 
BgL_auxz00_6484 = 
(long)CINT(BgL_tmpz00_6485); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_trackz00_3160, BGl_miditrackz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 995 */
BgL_auxz00_6476 = 
((BgL_miditrackz00_bglt)BgL_trackz00_3160)
; }  else 
{ 
obj_t BgL_auxz00_6480;
BgL_auxz00_6480 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)37739)), BGl_string3099z00zz__multimediazd2midizd2, BGl_string3100z00zz__multimediazd2midizd2, BgL_trackz00_3160); 
FAILURE(BgL_auxz00_6480,BFALSE,BFALSE);} 
{ /* Llib/midi.scm 995 */
obj_t BgL_tmpz00_6468;
if(
INTEGERP(BgL_tickz00_3159))
{ /* Llib/midi.scm 995 */
BgL_tmpz00_6468 = BgL_tickz00_3159
; }  else 
{ 
obj_t BgL_auxz00_6471;
BgL_auxz00_6471 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)37739)), BGl_string3099z00zz__multimediazd2midizd2, BGl_string3072z00zz__multimediazd2midizd2, BgL_tickz00_3159); 
FAILURE(BgL_auxz00_6471,BFALSE,BFALSE);} 
BgL_auxz00_6467 = 
(long)CINT(BgL_tmpz00_6468); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_3158, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 995 */
BgL_auxz00_6459 = 
((BgL_midisinkz00_bglt)BgL_msz00_3158)
; }  else 
{ 
obj_t BgL_auxz00_6463;
BgL_auxz00_6463 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)37739)), BGl_string3099z00zz__multimediazd2midizd2, BGl_string3080z00zz__multimediazd2midizd2, BgL_msz00_3158); 
FAILURE(BgL_auxz00_6463,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_3157, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 995 */
BgL_auxz00_6451 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_3157)
; }  else 
{ 
obj_t BgL_auxz00_6455;
BgL_auxz00_6455 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)37739)), BGl_string3099z00zz__multimediazd2midizd2, BGl_string3079z00zz__multimediazd2midizd2, BgL_mpz00_3157); 
FAILURE(BgL_auxz00_6455,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2cdelayzd2zz__multimediazd2midizd2(BgL_auxz00_6451, BgL_auxz00_6459, BgL_auxz00_6467, BgL_auxz00_6476, BgL_auxz00_6484, BgL_auxz00_6493, BgL_auxz00_6502);} } 

}



/* midiplayer-ignore */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2ignorezd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_75, BgL_midisinkz00_bglt BgL_msz00_76, long BgL_tickz00_77, obj_t BgL_objz00_78)
{
{ /* Llib/midi.scm 1003 */
return BUNSPEC;} 

}



/* &midiplayer-ignore */
obj_t BGl_z62midiplayerzd2ignorezb0zz__multimediazd2midizd2(obj_t BgL_envz00_3164, obj_t BgL_mpz00_3165, obj_t BgL_msz00_3166, obj_t BgL_tickz00_3167, obj_t BgL_objz00_3168)
{
{ /* Llib/midi.scm 1003 */
{ /* Llib/midi.scm 1003 */
BgL_midiplayerz00_bglt BgL_mpz00_4199;BgL_midisinkz00_bglt BgL_msz00_4200;long BgL_tickz00_4201;
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_3165, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1003 */
BgL_mpz00_4199 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_3165); }  else 
{ 
obj_t BgL_auxz00_6515;
BgL_auxz00_6515 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)38117)), BGl_string3101z00zz__multimediazd2midizd2, BGl_string3079z00zz__multimediazd2midizd2, BgL_mpz00_3165); 
FAILURE(BgL_auxz00_6515,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_3166, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1003 */
BgL_msz00_4200 = 
((BgL_midisinkz00_bglt)BgL_msz00_3166); }  else 
{ 
obj_t BgL_auxz00_6522;
BgL_auxz00_6522 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)38117)), BGl_string3101z00zz__multimediazd2midizd2, BGl_string3080z00zz__multimediazd2midizd2, BgL_msz00_3166); 
FAILURE(BgL_auxz00_6522,BFALSE,BFALSE);} 
{ /* Llib/midi.scm 1003 */
obj_t BgL_tmpz00_6526;
if(
INTEGERP(BgL_tickz00_3167))
{ /* Llib/midi.scm 1003 */
BgL_tmpz00_6526 = BgL_tickz00_3167
; }  else 
{ 
obj_t BgL_auxz00_6529;
BgL_auxz00_6529 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)38117)), BGl_string3101z00zz__multimediazd2midizd2, BGl_string3072z00zz__multimediazd2midizd2, BgL_tickz00_3167); 
FAILURE(BgL_auxz00_6529,BFALSE,BFALSE);} 
BgL_tickz00_4201 = 
(long)CINT(BgL_tmpz00_6526); } 
return BUNSPEC;} } 

}



/* midiplayer-noteoff */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2noteoffzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_88, BgL_midisinkz00_bglt BgL_msz00_89, long BgL_tickz00_90, long BgL_nnz00_91, long BgL_kkz00_92, long BgL_vvz00_93)
{
{ /* Llib/midi.scm 1026 */
{ /* Llib/midi.scm 1019 */
obj_t BgL_fun2071z00_2521;
BgL_fun2071z00_2521 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_89))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1019 */
obj_t BgL_arg2069z00_2522;long BgL_arg2070z00_2523;
BgL_arg2069z00_2522 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_89))->BgL_streamz00); 
BgL_arg2070z00_2523 = 
(((long)128) | BgL_nnz00_91); 
PROCEDURE_ENTRY(BgL_fun2071z00_2521)(BgL_fun2071z00_2521, BgL_arg2069z00_2522, 
BINT(BgL_arg2070z00_2523), BEOA); } } 
{ /* Llib/midi.scm 1020 */
obj_t BgL_fun2073z00_2524;
BgL_fun2073z00_2524 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_89))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1020 */
obj_t BgL_arg2072z00_2525;
BgL_arg2072z00_2525 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_89))->BgL_streamz00); 
PROCEDURE_ENTRY(BgL_fun2073z00_2524)(BgL_fun2073z00_2524, BgL_arg2072z00_2525, 
BINT(BgL_kkz00_92), BEOA); } } 
{ /* Llib/midi.scm 1021 */
obj_t BgL_fun2075z00_2526;
BgL_fun2075z00_2526 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_89))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1021 */
obj_t BgL_arg2074z00_2527;
BgL_arg2074z00_2527 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_89))->BgL_streamz00); 
return 
PROCEDURE_ENTRY(BgL_fun2075z00_2526)(BgL_fun2075z00_2526, BgL_arg2074z00_2527, 
BINT(BgL_vvz00_93), BEOA);} } } 

}



/* &midiplayer-noteoff */
obj_t BGl_z62midiplayerzd2noteoffzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3169, obj_t BgL_mpz00_3170, obj_t BgL_msz00_3171, obj_t BgL_tickz00_3172, obj_t BgL_nnz00_3173, obj_t BgL_kkz00_3174, obj_t BgL_vvz00_3175)
{
{ /* Llib/midi.scm 1026 */
{ /* Llib/midi.scm 1028 */
long BgL_auxz00_6602;long BgL_auxz00_6593;long BgL_auxz00_6584;long BgL_auxz00_6575;BgL_midisinkz00_bglt BgL_auxz00_6567;BgL_midiplayerz00_bglt BgL_auxz00_6559;
{ /* Llib/midi.scm 1028 */
obj_t BgL_tmpz00_6603;
if(
INTEGERP(BgL_vvz00_3175))
{ /* Llib/midi.scm 1028 */
BgL_tmpz00_6603 = BgL_vvz00_3175
; }  else 
{ 
obj_t BgL_auxz00_6606;
BgL_auxz00_6606 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)39392)), BGl_string3102z00zz__multimediazd2midizd2, BGl_string3072z00zz__multimediazd2midizd2, BgL_vvz00_3175); 
FAILURE(BgL_auxz00_6606,BFALSE,BFALSE);} 
BgL_auxz00_6602 = 
(long)CINT(BgL_tmpz00_6603); } 
{ /* Llib/midi.scm 1028 */
obj_t BgL_tmpz00_6594;
if(
INTEGERP(BgL_kkz00_3174))
{ /* Llib/midi.scm 1028 */
BgL_tmpz00_6594 = BgL_kkz00_3174
; }  else 
{ 
obj_t BgL_auxz00_6597;
BgL_auxz00_6597 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)39392)), BGl_string3102z00zz__multimediazd2midizd2, BGl_string3072z00zz__multimediazd2midizd2, BgL_kkz00_3174); 
FAILURE(BgL_auxz00_6597,BFALSE,BFALSE);} 
BgL_auxz00_6593 = 
(long)CINT(BgL_tmpz00_6594); } 
{ /* Llib/midi.scm 1028 */
obj_t BgL_tmpz00_6585;
if(
INTEGERP(BgL_nnz00_3173))
{ /* Llib/midi.scm 1028 */
BgL_tmpz00_6585 = BgL_nnz00_3173
; }  else 
{ 
obj_t BgL_auxz00_6588;
BgL_auxz00_6588 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)39392)), BGl_string3102z00zz__multimediazd2midizd2, BGl_string3072z00zz__multimediazd2midizd2, BgL_nnz00_3173); 
FAILURE(BgL_auxz00_6588,BFALSE,BFALSE);} 
BgL_auxz00_6584 = 
(long)CINT(BgL_tmpz00_6585); } 
{ /* Llib/midi.scm 1028 */
obj_t BgL_tmpz00_6576;
if(
INTEGERP(BgL_tickz00_3172))
{ /* Llib/midi.scm 1028 */
BgL_tmpz00_6576 = BgL_tickz00_3172
; }  else 
{ 
obj_t BgL_auxz00_6579;
BgL_auxz00_6579 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)39392)), BGl_string3102z00zz__multimediazd2midizd2, BGl_string3072z00zz__multimediazd2midizd2, BgL_tickz00_3172); 
FAILURE(BgL_auxz00_6579,BFALSE,BFALSE);} 
BgL_auxz00_6575 = 
(long)CINT(BgL_tmpz00_6576); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_3171, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1028 */
BgL_auxz00_6567 = 
((BgL_midisinkz00_bglt)BgL_msz00_3171)
; }  else 
{ 
obj_t BgL_auxz00_6571;
BgL_auxz00_6571 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)39392)), BGl_string3102z00zz__multimediazd2midizd2, BGl_string3080z00zz__multimediazd2midizd2, BgL_msz00_3171); 
FAILURE(BgL_auxz00_6571,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_3170, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1028 */
BgL_auxz00_6559 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_3170)
; }  else 
{ 
obj_t BgL_auxz00_6563;
BgL_auxz00_6563 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)39392)), BGl_string3102z00zz__multimediazd2midizd2, BGl_string3079z00zz__multimediazd2midizd2, BgL_mpz00_3170); 
FAILURE(BgL_auxz00_6563,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2noteoffzd2zz__multimediazd2midizd2(BgL_auxz00_6559, BgL_auxz00_6567, BgL_auxz00_6575, BgL_auxz00_6584, BgL_auxz00_6593, BgL_auxz00_6602);} } 

}



/* midiplayer-noteon */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2noteonzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_94, BgL_midisinkz00_bglt BgL_msz00_95, long BgL_tickz00_96, long BgL_nnz00_97, long BgL_kkz00_98, long BgL_vvz00_99)
{
{ /* Llib/midi.scm 1033 */
{ /* Llib/midi.scm 1019 */
obj_t BgL_fun2071z00_2535;
BgL_fun2071z00_2535 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_95))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1019 */
obj_t BgL_arg2069z00_2536;long BgL_arg2070z00_2537;
BgL_arg2069z00_2536 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_95))->BgL_streamz00); 
BgL_arg2070z00_2537 = 
(((long)144) | BgL_nnz00_97); 
PROCEDURE_ENTRY(BgL_fun2071z00_2535)(BgL_fun2071z00_2535, BgL_arg2069z00_2536, 
BINT(BgL_arg2070z00_2537), BEOA); } } 
{ /* Llib/midi.scm 1020 */
obj_t BgL_fun2073z00_2538;
BgL_fun2073z00_2538 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_95))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1020 */
obj_t BgL_arg2072z00_2539;
BgL_arg2072z00_2539 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_95))->BgL_streamz00); 
PROCEDURE_ENTRY(BgL_fun2073z00_2538)(BgL_fun2073z00_2538, BgL_arg2072z00_2539, 
BINT(BgL_kkz00_98), BEOA); } } 
{ /* Llib/midi.scm 1021 */
obj_t BgL_fun2075z00_2540;
BgL_fun2075z00_2540 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_95))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1021 */
obj_t BgL_arg2074z00_2541;
BgL_arg2074z00_2541 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_95))->BgL_streamz00); 
return 
PROCEDURE_ENTRY(BgL_fun2075z00_2540)(BgL_fun2075z00_2540, BgL_arg2074z00_2541, 
BINT(BgL_vvz00_99), BEOA);} } } 

}



/* &midiplayer-noteon */
obj_t BGl_z62midiplayerzd2noteonzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3176, obj_t BgL_mpz00_3177, obj_t BgL_msz00_3178, obj_t BgL_tickz00_3179, obj_t BgL_nnz00_3180, obj_t BgL_kkz00_3181, obj_t BgL_vvz00_3182)
{
{ /* Llib/midi.scm 1033 */
{ /* Llib/midi.scm 1035 */
long BgL_auxz00_6680;long BgL_auxz00_6671;long BgL_auxz00_6662;long BgL_auxz00_6653;BgL_midisinkz00_bglt BgL_auxz00_6645;BgL_midiplayerz00_bglt BgL_auxz00_6637;
{ /* Llib/midi.scm 1035 */
obj_t BgL_tmpz00_6681;
if(
INTEGERP(BgL_vvz00_3182))
{ /* Llib/midi.scm 1035 */
BgL_tmpz00_6681 = BgL_vvz00_3182
; }  else 
{ 
obj_t BgL_auxz00_6684;
BgL_auxz00_6684 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)39752)), BGl_string3103z00zz__multimediazd2midizd2, BGl_string3072z00zz__multimediazd2midizd2, BgL_vvz00_3182); 
FAILURE(BgL_auxz00_6684,BFALSE,BFALSE);} 
BgL_auxz00_6680 = 
(long)CINT(BgL_tmpz00_6681); } 
{ /* Llib/midi.scm 1035 */
obj_t BgL_tmpz00_6672;
if(
INTEGERP(BgL_kkz00_3181))
{ /* Llib/midi.scm 1035 */
BgL_tmpz00_6672 = BgL_kkz00_3181
; }  else 
{ 
obj_t BgL_auxz00_6675;
BgL_auxz00_6675 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)39752)), BGl_string3103z00zz__multimediazd2midizd2, BGl_string3072z00zz__multimediazd2midizd2, BgL_kkz00_3181); 
FAILURE(BgL_auxz00_6675,BFALSE,BFALSE);} 
BgL_auxz00_6671 = 
(long)CINT(BgL_tmpz00_6672); } 
{ /* Llib/midi.scm 1035 */
obj_t BgL_tmpz00_6663;
if(
INTEGERP(BgL_nnz00_3180))
{ /* Llib/midi.scm 1035 */
BgL_tmpz00_6663 = BgL_nnz00_3180
; }  else 
{ 
obj_t BgL_auxz00_6666;
BgL_auxz00_6666 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)39752)), BGl_string3103z00zz__multimediazd2midizd2, BGl_string3072z00zz__multimediazd2midizd2, BgL_nnz00_3180); 
FAILURE(BgL_auxz00_6666,BFALSE,BFALSE);} 
BgL_auxz00_6662 = 
(long)CINT(BgL_tmpz00_6663); } 
{ /* Llib/midi.scm 1035 */
obj_t BgL_tmpz00_6654;
if(
INTEGERP(BgL_tickz00_3179))
{ /* Llib/midi.scm 1035 */
BgL_tmpz00_6654 = BgL_tickz00_3179
; }  else 
{ 
obj_t BgL_auxz00_6657;
BgL_auxz00_6657 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)39752)), BGl_string3103z00zz__multimediazd2midizd2, BGl_string3072z00zz__multimediazd2midizd2, BgL_tickz00_3179); 
FAILURE(BgL_auxz00_6657,BFALSE,BFALSE);} 
BgL_auxz00_6653 = 
(long)CINT(BgL_tmpz00_6654); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_3178, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1035 */
BgL_auxz00_6645 = 
((BgL_midisinkz00_bglt)BgL_msz00_3178)
; }  else 
{ 
obj_t BgL_auxz00_6649;
BgL_auxz00_6649 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)39752)), BGl_string3103z00zz__multimediazd2midizd2, BGl_string3080z00zz__multimediazd2midizd2, BgL_msz00_3178); 
FAILURE(BgL_auxz00_6649,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_3177, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1035 */
BgL_auxz00_6637 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_3177)
; }  else 
{ 
obj_t BgL_auxz00_6641;
BgL_auxz00_6641 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)39752)), BGl_string3103z00zz__multimediazd2midizd2, BGl_string3079z00zz__multimediazd2midizd2, BgL_mpz00_3177); 
FAILURE(BgL_auxz00_6641,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2noteonzd2zz__multimediazd2midizd2(BgL_auxz00_6637, BgL_auxz00_6645, BgL_auxz00_6653, BgL_auxz00_6662, BgL_auxz00_6671, BgL_auxz00_6680);} } 

}



/* midiplayer-aftertouch */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2aftertouchzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_100, BgL_midisinkz00_bglt BgL_msz00_101, long BgL_tickz00_102, long BgL_nnz00_103, long BgL_kkz00_104, long BgL_vvz00_105)
{
{ /* Llib/midi.scm 1040 */
{ /* Llib/midi.scm 1019 */
obj_t BgL_fun2071z00_2549;
BgL_fun2071z00_2549 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_101))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1019 */
obj_t BgL_arg2069z00_2550;long BgL_arg2070z00_2551;
BgL_arg2069z00_2550 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_101))->BgL_streamz00); 
BgL_arg2070z00_2551 = 
(((long)160) | BgL_nnz00_103); 
PROCEDURE_ENTRY(BgL_fun2071z00_2549)(BgL_fun2071z00_2549, BgL_arg2069z00_2550, 
BINT(BgL_arg2070z00_2551), BEOA); } } 
{ /* Llib/midi.scm 1020 */
obj_t BgL_fun2073z00_2552;
BgL_fun2073z00_2552 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_101))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1020 */
obj_t BgL_arg2072z00_2553;
BgL_arg2072z00_2553 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_101))->BgL_streamz00); 
PROCEDURE_ENTRY(BgL_fun2073z00_2552)(BgL_fun2073z00_2552, BgL_arg2072z00_2553, 
BINT(BgL_kkz00_104), BEOA); } } 
{ /* Llib/midi.scm 1021 */
obj_t BgL_fun2075z00_2554;
BgL_fun2075z00_2554 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_101))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1021 */
obj_t BgL_arg2074z00_2555;
BgL_arg2074z00_2555 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_101))->BgL_streamz00); 
return 
PROCEDURE_ENTRY(BgL_fun2075z00_2554)(BgL_fun2075z00_2554, BgL_arg2074z00_2555, 
BINT(BgL_vvz00_105), BEOA);} } } 

}



/* &midiplayer-aftertouch */
obj_t BGl_z62midiplayerzd2aftertouchzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3183, obj_t BgL_mpz00_3184, obj_t BgL_msz00_3185, obj_t BgL_tickz00_3186, obj_t BgL_nnz00_3187, obj_t BgL_kkz00_3188, obj_t BgL_vvz00_3189)
{
{ /* Llib/midi.scm 1040 */
{ /* Llib/midi.scm 1042 */
long BgL_auxz00_6758;long BgL_auxz00_6749;long BgL_auxz00_6740;long BgL_auxz00_6731;BgL_midisinkz00_bglt BgL_auxz00_6723;BgL_midiplayerz00_bglt BgL_auxz00_6715;
{ /* Llib/midi.scm 1042 */
obj_t BgL_tmpz00_6759;
if(
INTEGERP(BgL_vvz00_3189))
{ /* Llib/midi.scm 1042 */
BgL_tmpz00_6759 = BgL_vvz00_3189
; }  else 
{ 
obj_t BgL_auxz00_6762;
BgL_auxz00_6762 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)40116)), BGl_string3104z00zz__multimediazd2midizd2, BGl_string3072z00zz__multimediazd2midizd2, BgL_vvz00_3189); 
FAILURE(BgL_auxz00_6762,BFALSE,BFALSE);} 
BgL_auxz00_6758 = 
(long)CINT(BgL_tmpz00_6759); } 
{ /* Llib/midi.scm 1042 */
obj_t BgL_tmpz00_6750;
if(
INTEGERP(BgL_kkz00_3188))
{ /* Llib/midi.scm 1042 */
BgL_tmpz00_6750 = BgL_kkz00_3188
; }  else 
{ 
obj_t BgL_auxz00_6753;
BgL_auxz00_6753 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)40116)), BGl_string3104z00zz__multimediazd2midizd2, BGl_string3072z00zz__multimediazd2midizd2, BgL_kkz00_3188); 
FAILURE(BgL_auxz00_6753,BFALSE,BFALSE);} 
BgL_auxz00_6749 = 
(long)CINT(BgL_tmpz00_6750); } 
{ /* Llib/midi.scm 1042 */
obj_t BgL_tmpz00_6741;
if(
INTEGERP(BgL_nnz00_3187))
{ /* Llib/midi.scm 1042 */
BgL_tmpz00_6741 = BgL_nnz00_3187
; }  else 
{ 
obj_t BgL_auxz00_6744;
BgL_auxz00_6744 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)40116)), BGl_string3104z00zz__multimediazd2midizd2, BGl_string3072z00zz__multimediazd2midizd2, BgL_nnz00_3187); 
FAILURE(BgL_auxz00_6744,BFALSE,BFALSE);} 
BgL_auxz00_6740 = 
(long)CINT(BgL_tmpz00_6741); } 
{ /* Llib/midi.scm 1042 */
obj_t BgL_tmpz00_6732;
if(
INTEGERP(BgL_tickz00_3186))
{ /* Llib/midi.scm 1042 */
BgL_tmpz00_6732 = BgL_tickz00_3186
; }  else 
{ 
obj_t BgL_auxz00_6735;
BgL_auxz00_6735 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)40116)), BGl_string3104z00zz__multimediazd2midizd2, BGl_string3072z00zz__multimediazd2midizd2, BgL_tickz00_3186); 
FAILURE(BgL_auxz00_6735,BFALSE,BFALSE);} 
BgL_auxz00_6731 = 
(long)CINT(BgL_tmpz00_6732); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_3185, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1042 */
BgL_auxz00_6723 = 
((BgL_midisinkz00_bglt)BgL_msz00_3185)
; }  else 
{ 
obj_t BgL_auxz00_6727;
BgL_auxz00_6727 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)40116)), BGl_string3104z00zz__multimediazd2midizd2, BGl_string3080z00zz__multimediazd2midizd2, BgL_msz00_3185); 
FAILURE(BgL_auxz00_6727,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_3184, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1042 */
BgL_auxz00_6715 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_3184)
; }  else 
{ 
obj_t BgL_auxz00_6719;
BgL_auxz00_6719 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)40116)), BGl_string3104z00zz__multimediazd2midizd2, BGl_string3079z00zz__multimediazd2midizd2, BgL_mpz00_3184); 
FAILURE(BgL_auxz00_6719,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2aftertouchzd2zz__multimediazd2midizd2(BgL_auxz00_6715, BgL_auxz00_6723, BgL_auxz00_6731, BgL_auxz00_6740, BgL_auxz00_6749, BgL_auxz00_6758);} } 

}



/* midiplayer-ctrlchange */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2ctrlchangezd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_106, BgL_midisinkz00_bglt BgL_msz00_107, long BgL_tickz00_108, long BgL_nnz00_109, long BgL_kkz00_110, long BgL_vvz00_111)
{
{ /* Llib/midi.scm 1047 */
{ /* Llib/midi.scm 1019 */
obj_t BgL_fun2071z00_2563;
BgL_fun2071z00_2563 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_107))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1019 */
obj_t BgL_arg2069z00_2564;long BgL_arg2070z00_2565;
BgL_arg2069z00_2564 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_107))->BgL_streamz00); 
BgL_arg2070z00_2565 = 
(((long)176) | BgL_nnz00_109); 
PROCEDURE_ENTRY(BgL_fun2071z00_2563)(BgL_fun2071z00_2563, BgL_arg2069z00_2564, 
BINT(BgL_arg2070z00_2565), BEOA); } } 
{ /* Llib/midi.scm 1020 */
obj_t BgL_fun2073z00_2566;
BgL_fun2073z00_2566 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_107))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1020 */
obj_t BgL_arg2072z00_2567;
BgL_arg2072z00_2567 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_107))->BgL_streamz00); 
PROCEDURE_ENTRY(BgL_fun2073z00_2566)(BgL_fun2073z00_2566, BgL_arg2072z00_2567, 
BINT(BgL_kkz00_110), BEOA); } } 
{ /* Llib/midi.scm 1021 */
obj_t BgL_fun2075z00_2568;
BgL_fun2075z00_2568 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_107))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1021 */
obj_t BgL_arg2074z00_2569;
BgL_arg2074z00_2569 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_107))->BgL_streamz00); 
return 
PROCEDURE_ENTRY(BgL_fun2075z00_2568)(BgL_fun2075z00_2568, BgL_arg2074z00_2569, 
BINT(BgL_vvz00_111), BEOA);} } } 

}



/* &midiplayer-ctrlchange */
obj_t BGl_z62midiplayerzd2ctrlchangezb0zz__multimediazd2midizd2(obj_t BgL_envz00_3190, obj_t BgL_mpz00_3191, obj_t BgL_msz00_3192, obj_t BgL_tickz00_3193, obj_t BgL_nnz00_3194, obj_t BgL_kkz00_3195, obj_t BgL_vvz00_3196)
{
{ /* Llib/midi.scm 1047 */
{ /* Llib/midi.scm 1049 */
long BgL_auxz00_6836;long BgL_auxz00_6827;long BgL_auxz00_6818;long BgL_auxz00_6809;BgL_midisinkz00_bglt BgL_auxz00_6801;BgL_midiplayerz00_bglt BgL_auxz00_6793;
{ /* Llib/midi.scm 1049 */
obj_t BgL_tmpz00_6837;
if(
INTEGERP(BgL_vvz00_3196))
{ /* Llib/midi.scm 1049 */
BgL_tmpz00_6837 = BgL_vvz00_3196
; }  else 
{ 
obj_t BgL_auxz00_6840;
BgL_auxz00_6840 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)40480)), BGl_string3105z00zz__multimediazd2midizd2, BGl_string3072z00zz__multimediazd2midizd2, BgL_vvz00_3196); 
FAILURE(BgL_auxz00_6840,BFALSE,BFALSE);} 
BgL_auxz00_6836 = 
(long)CINT(BgL_tmpz00_6837); } 
{ /* Llib/midi.scm 1049 */
obj_t BgL_tmpz00_6828;
if(
INTEGERP(BgL_kkz00_3195))
{ /* Llib/midi.scm 1049 */
BgL_tmpz00_6828 = BgL_kkz00_3195
; }  else 
{ 
obj_t BgL_auxz00_6831;
BgL_auxz00_6831 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)40480)), BGl_string3105z00zz__multimediazd2midizd2, BGl_string3072z00zz__multimediazd2midizd2, BgL_kkz00_3195); 
FAILURE(BgL_auxz00_6831,BFALSE,BFALSE);} 
BgL_auxz00_6827 = 
(long)CINT(BgL_tmpz00_6828); } 
{ /* Llib/midi.scm 1049 */
obj_t BgL_tmpz00_6819;
if(
INTEGERP(BgL_nnz00_3194))
{ /* Llib/midi.scm 1049 */
BgL_tmpz00_6819 = BgL_nnz00_3194
; }  else 
{ 
obj_t BgL_auxz00_6822;
BgL_auxz00_6822 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)40480)), BGl_string3105z00zz__multimediazd2midizd2, BGl_string3072z00zz__multimediazd2midizd2, BgL_nnz00_3194); 
FAILURE(BgL_auxz00_6822,BFALSE,BFALSE);} 
BgL_auxz00_6818 = 
(long)CINT(BgL_tmpz00_6819); } 
{ /* Llib/midi.scm 1049 */
obj_t BgL_tmpz00_6810;
if(
INTEGERP(BgL_tickz00_3193))
{ /* Llib/midi.scm 1049 */
BgL_tmpz00_6810 = BgL_tickz00_3193
; }  else 
{ 
obj_t BgL_auxz00_6813;
BgL_auxz00_6813 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)40480)), BGl_string3105z00zz__multimediazd2midizd2, BGl_string3072z00zz__multimediazd2midizd2, BgL_tickz00_3193); 
FAILURE(BgL_auxz00_6813,BFALSE,BFALSE);} 
BgL_auxz00_6809 = 
(long)CINT(BgL_tmpz00_6810); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_3192, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1049 */
BgL_auxz00_6801 = 
((BgL_midisinkz00_bglt)BgL_msz00_3192)
; }  else 
{ 
obj_t BgL_auxz00_6805;
BgL_auxz00_6805 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)40480)), BGl_string3105z00zz__multimediazd2midizd2, BGl_string3080z00zz__multimediazd2midizd2, BgL_msz00_3192); 
FAILURE(BgL_auxz00_6805,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_3191, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1049 */
BgL_auxz00_6793 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_3191)
; }  else 
{ 
obj_t BgL_auxz00_6797;
BgL_auxz00_6797 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)40480)), BGl_string3105z00zz__multimediazd2midizd2, BGl_string3079z00zz__multimediazd2midizd2, BgL_mpz00_3191); 
FAILURE(BgL_auxz00_6797,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2ctrlchangezd2zz__multimediazd2midizd2(BgL_auxz00_6793, BgL_auxz00_6801, BgL_auxz00_6809, BgL_auxz00_6818, BgL_auxz00_6827, BgL_auxz00_6836);} } 

}



/* midiplayer-prgmchange */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2prgmchangezd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_112, BgL_midisinkz00_bglt BgL_msz00_113, long BgL_tickz00_114, long BgL_nnz00_115, long BgL_ppz00_116)
{
{ /* Llib/midi.scm 1054 */
{ /* Llib/midi.scm 1011 */
obj_t BgL_fun2066z00_2576;
BgL_fun2066z00_2576 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_113))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1011 */
obj_t BgL_arg2064z00_2577;long BgL_arg2065z00_2578;
BgL_arg2064z00_2577 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_113))->BgL_streamz00); 
BgL_arg2065z00_2578 = 
(((long)192) | BgL_nnz00_115); 
PROCEDURE_ENTRY(BgL_fun2066z00_2576)(BgL_fun2066z00_2576, BgL_arg2064z00_2577, 
BINT(BgL_arg2065z00_2578), BEOA); } } 
{ /* Llib/midi.scm 1012 */
obj_t BgL_fun2068z00_2579;
BgL_fun2068z00_2579 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_113))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1012 */
obj_t BgL_arg2067z00_2580;
BgL_arg2067z00_2580 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_113))->BgL_streamz00); 
return 
PROCEDURE_ENTRY(BgL_fun2068z00_2579)(BgL_fun2068z00_2579, BgL_arg2067z00_2580, 
BINT(BgL_ppz00_116), BEOA);} } } 

}



/* &midiplayer-prgmchange */
obj_t BGl_z62midiplayerzd2prgmchangezb0zz__multimediazd2midizd2(obj_t BgL_envz00_3197, obj_t BgL_mpz00_3198, obj_t BgL_msz00_3199, obj_t BgL_tickz00_3200, obj_t BgL_nnz00_3201, obj_t BgL_ppz00_3202)
{
{ /* Llib/midi.scm 1054 */
{ /* Llib/midi.scm 1056 */
long BgL_auxz00_6897;long BgL_auxz00_6888;long BgL_auxz00_6879;BgL_midisinkz00_bglt BgL_auxz00_6871;BgL_midiplayerz00_bglt BgL_auxz00_6863;
{ /* Llib/midi.scm 1056 */
obj_t BgL_tmpz00_6898;
if(
INTEGERP(BgL_ppz00_3202))
{ /* Llib/midi.scm 1056 */
BgL_tmpz00_6898 = BgL_ppz00_3202
; }  else 
{ 
obj_t BgL_auxz00_6901;
BgL_auxz00_6901 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)40835)), BGl_string3106z00zz__multimediazd2midizd2, BGl_string3072z00zz__multimediazd2midizd2, BgL_ppz00_3202); 
FAILURE(BgL_auxz00_6901,BFALSE,BFALSE);} 
BgL_auxz00_6897 = 
(long)CINT(BgL_tmpz00_6898); } 
{ /* Llib/midi.scm 1056 */
obj_t BgL_tmpz00_6889;
if(
INTEGERP(BgL_nnz00_3201))
{ /* Llib/midi.scm 1056 */
BgL_tmpz00_6889 = BgL_nnz00_3201
; }  else 
{ 
obj_t BgL_auxz00_6892;
BgL_auxz00_6892 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)40835)), BGl_string3106z00zz__multimediazd2midizd2, BGl_string3072z00zz__multimediazd2midizd2, BgL_nnz00_3201); 
FAILURE(BgL_auxz00_6892,BFALSE,BFALSE);} 
BgL_auxz00_6888 = 
(long)CINT(BgL_tmpz00_6889); } 
{ /* Llib/midi.scm 1056 */
obj_t BgL_tmpz00_6880;
if(
INTEGERP(BgL_tickz00_3200))
{ /* Llib/midi.scm 1056 */
BgL_tmpz00_6880 = BgL_tickz00_3200
; }  else 
{ 
obj_t BgL_auxz00_6883;
BgL_auxz00_6883 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)40835)), BGl_string3106z00zz__multimediazd2midizd2, BGl_string3072z00zz__multimediazd2midizd2, BgL_tickz00_3200); 
FAILURE(BgL_auxz00_6883,BFALSE,BFALSE);} 
BgL_auxz00_6879 = 
(long)CINT(BgL_tmpz00_6880); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_3199, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1056 */
BgL_auxz00_6871 = 
((BgL_midisinkz00_bglt)BgL_msz00_3199)
; }  else 
{ 
obj_t BgL_auxz00_6875;
BgL_auxz00_6875 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)40835)), BGl_string3106z00zz__multimediazd2midizd2, BGl_string3080z00zz__multimediazd2midizd2, BgL_msz00_3199); 
FAILURE(BgL_auxz00_6875,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_3198, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1056 */
BgL_auxz00_6863 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_3198)
; }  else 
{ 
obj_t BgL_auxz00_6867;
BgL_auxz00_6867 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)40835)), BGl_string3106z00zz__multimediazd2midizd2, BGl_string3079z00zz__multimediazd2midizd2, BgL_mpz00_3198); 
FAILURE(BgL_auxz00_6867,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2prgmchangezd2zz__multimediazd2midizd2(BgL_auxz00_6863, BgL_auxz00_6871, BgL_auxz00_6879, BgL_auxz00_6888, BgL_auxz00_6897);} } 

}



/* midiplayer-after-touch */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2afterzd2touchz00zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_117, BgL_midisinkz00_bglt BgL_msz00_118, long BgL_tickz00_119, long BgL_nnz00_120, long BgL_ppz00_121)
{
{ /* Llib/midi.scm 1061 */
{ /* Llib/midi.scm 1011 */
obj_t BgL_fun2066z00_2587;
BgL_fun2066z00_2587 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_118))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1011 */
obj_t BgL_arg2064z00_2588;long BgL_arg2065z00_2589;
BgL_arg2064z00_2588 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_118))->BgL_streamz00); 
BgL_arg2065z00_2589 = 
(((long)208) | BgL_nnz00_120); 
PROCEDURE_ENTRY(BgL_fun2066z00_2587)(BgL_fun2066z00_2587, BgL_arg2064z00_2588, 
BINT(BgL_arg2065z00_2589), BEOA); } } 
{ /* Llib/midi.scm 1012 */
obj_t BgL_fun2068z00_2590;
BgL_fun2068z00_2590 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_118))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1012 */
obj_t BgL_arg2067z00_2591;
BgL_arg2067z00_2591 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_118))->BgL_streamz00); 
return 
PROCEDURE_ENTRY(BgL_fun2068z00_2590)(BgL_fun2068z00_2590, BgL_arg2067z00_2591, 
BINT(BgL_ppz00_121), BEOA);} } } 

}



/* &midiplayer-after-touch */
obj_t BGl_z62midiplayerzd2afterzd2touchz62zz__multimediazd2midizd2(obj_t BgL_envz00_3203, obj_t BgL_mpz00_3204, obj_t BgL_msz00_3205, obj_t BgL_tickz00_3206, obj_t BgL_nnz00_3207, obj_t BgL_ppz00_3208)
{
{ /* Llib/midi.scm 1061 */
{ /* Llib/midi.scm 1063 */
long BgL_auxz00_6958;long BgL_auxz00_6949;long BgL_auxz00_6940;BgL_midisinkz00_bglt BgL_auxz00_6932;BgL_midiplayerz00_bglt BgL_auxz00_6924;
{ /* Llib/midi.scm 1063 */
obj_t BgL_tmpz00_6959;
if(
INTEGERP(BgL_ppz00_3208))
{ /* Llib/midi.scm 1063 */
BgL_tmpz00_6959 = BgL_ppz00_3208
; }  else 
{ 
obj_t BgL_auxz00_6962;
BgL_auxz00_6962 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)41188)), BGl_string3107z00zz__multimediazd2midizd2, BGl_string3072z00zz__multimediazd2midizd2, BgL_ppz00_3208); 
FAILURE(BgL_auxz00_6962,BFALSE,BFALSE);} 
BgL_auxz00_6958 = 
(long)CINT(BgL_tmpz00_6959); } 
{ /* Llib/midi.scm 1063 */
obj_t BgL_tmpz00_6950;
if(
INTEGERP(BgL_nnz00_3207))
{ /* Llib/midi.scm 1063 */
BgL_tmpz00_6950 = BgL_nnz00_3207
; }  else 
{ 
obj_t BgL_auxz00_6953;
BgL_auxz00_6953 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)41188)), BGl_string3107z00zz__multimediazd2midizd2, BGl_string3072z00zz__multimediazd2midizd2, BgL_nnz00_3207); 
FAILURE(BgL_auxz00_6953,BFALSE,BFALSE);} 
BgL_auxz00_6949 = 
(long)CINT(BgL_tmpz00_6950); } 
{ /* Llib/midi.scm 1063 */
obj_t BgL_tmpz00_6941;
if(
INTEGERP(BgL_tickz00_3206))
{ /* Llib/midi.scm 1063 */
BgL_tmpz00_6941 = BgL_tickz00_3206
; }  else 
{ 
obj_t BgL_auxz00_6944;
BgL_auxz00_6944 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)41188)), BGl_string3107z00zz__multimediazd2midizd2, BGl_string3072z00zz__multimediazd2midizd2, BgL_tickz00_3206); 
FAILURE(BgL_auxz00_6944,BFALSE,BFALSE);} 
BgL_auxz00_6940 = 
(long)CINT(BgL_tmpz00_6941); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_3205, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1063 */
BgL_auxz00_6932 = 
((BgL_midisinkz00_bglt)BgL_msz00_3205)
; }  else 
{ 
obj_t BgL_auxz00_6936;
BgL_auxz00_6936 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)41188)), BGl_string3107z00zz__multimediazd2midizd2, BGl_string3080z00zz__multimediazd2midizd2, BgL_msz00_3205); 
FAILURE(BgL_auxz00_6936,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_3204, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1063 */
BgL_auxz00_6924 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_3204)
; }  else 
{ 
obj_t BgL_auxz00_6928;
BgL_auxz00_6928 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)41188)), BGl_string3107z00zz__multimediazd2midizd2, BGl_string3079z00zz__multimediazd2midizd2, BgL_mpz00_3204); 
FAILURE(BgL_auxz00_6928,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2afterzd2touchz00zz__multimediazd2midizd2(BgL_auxz00_6924, BgL_auxz00_6932, BgL_auxz00_6940, BgL_auxz00_6949, BgL_auxz00_6958);} } 

}



/* midiplayer-pitch */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2pitchzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_122, BgL_midisinkz00_bglt BgL_msz00_123, long BgL_tickz00_124, long BgL_nnz00_125, long BgL_ccz00_126, long BgL_vvz00_127)
{
{ /* Llib/midi.scm 1068 */
{ /* Llib/midi.scm 1019 */
obj_t BgL_fun2071z00_2599;
BgL_fun2071z00_2599 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_123))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1019 */
obj_t BgL_arg2069z00_2600;long BgL_arg2070z00_2601;
BgL_arg2069z00_2600 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_123))->BgL_streamz00); 
BgL_arg2070z00_2601 = 
(((long)224) | BgL_nnz00_125); 
PROCEDURE_ENTRY(BgL_fun2071z00_2599)(BgL_fun2071z00_2599, BgL_arg2069z00_2600, 
BINT(BgL_arg2070z00_2601), BEOA); } } 
{ /* Llib/midi.scm 1020 */
obj_t BgL_fun2073z00_2602;
BgL_fun2073z00_2602 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_123))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1020 */
obj_t BgL_arg2072z00_2603;
BgL_arg2072z00_2603 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_123))->BgL_streamz00); 
PROCEDURE_ENTRY(BgL_fun2073z00_2602)(BgL_fun2073z00_2602, BgL_arg2072z00_2603, 
BINT(BgL_ccz00_126), BEOA); } } 
{ /* Llib/midi.scm 1021 */
obj_t BgL_fun2075z00_2604;
BgL_fun2075z00_2604 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_123))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1021 */
obj_t BgL_arg2074z00_2605;
BgL_arg2074z00_2605 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_123))->BgL_streamz00); 
return 
PROCEDURE_ENTRY(BgL_fun2075z00_2604)(BgL_fun2075z00_2604, BgL_arg2074z00_2605, 
BINT(BgL_vvz00_127), BEOA);} } } 

}



/* &midiplayer-pitch */
obj_t BGl_z62midiplayerzd2pitchzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3209, obj_t BgL_mpz00_3210, obj_t BgL_msz00_3211, obj_t BgL_tickz00_3212, obj_t BgL_nnz00_3213, obj_t BgL_ccz00_3214, obj_t BgL_vvz00_3215)
{
{ /* Llib/midi.scm 1068 */
{ /* Llib/midi.scm 1070 */
long BgL_auxz00_7036;long BgL_auxz00_7027;long BgL_auxz00_7018;long BgL_auxz00_7009;BgL_midisinkz00_bglt BgL_auxz00_7001;BgL_midiplayerz00_bglt BgL_auxz00_6993;
{ /* Llib/midi.scm 1070 */
obj_t BgL_tmpz00_7037;
if(
INTEGERP(BgL_vvz00_3215))
{ /* Llib/midi.scm 1070 */
BgL_tmpz00_7037 = BgL_vvz00_3215
; }  else 
{ 
obj_t BgL_auxz00_7040;
BgL_auxz00_7040 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)41544)), BGl_string3108z00zz__multimediazd2midizd2, BGl_string3072z00zz__multimediazd2midizd2, BgL_vvz00_3215); 
FAILURE(BgL_auxz00_7040,BFALSE,BFALSE);} 
BgL_auxz00_7036 = 
(long)CINT(BgL_tmpz00_7037); } 
{ /* Llib/midi.scm 1070 */
obj_t BgL_tmpz00_7028;
if(
INTEGERP(BgL_ccz00_3214))
{ /* Llib/midi.scm 1070 */
BgL_tmpz00_7028 = BgL_ccz00_3214
; }  else 
{ 
obj_t BgL_auxz00_7031;
BgL_auxz00_7031 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)41544)), BGl_string3108z00zz__multimediazd2midizd2, BGl_string3072z00zz__multimediazd2midizd2, BgL_ccz00_3214); 
FAILURE(BgL_auxz00_7031,BFALSE,BFALSE);} 
BgL_auxz00_7027 = 
(long)CINT(BgL_tmpz00_7028); } 
{ /* Llib/midi.scm 1070 */
obj_t BgL_tmpz00_7019;
if(
INTEGERP(BgL_nnz00_3213))
{ /* Llib/midi.scm 1070 */
BgL_tmpz00_7019 = BgL_nnz00_3213
; }  else 
{ 
obj_t BgL_auxz00_7022;
BgL_auxz00_7022 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)41544)), BGl_string3108z00zz__multimediazd2midizd2, BGl_string3072z00zz__multimediazd2midizd2, BgL_nnz00_3213); 
FAILURE(BgL_auxz00_7022,BFALSE,BFALSE);} 
BgL_auxz00_7018 = 
(long)CINT(BgL_tmpz00_7019); } 
{ /* Llib/midi.scm 1070 */
obj_t BgL_tmpz00_7010;
if(
INTEGERP(BgL_tickz00_3212))
{ /* Llib/midi.scm 1070 */
BgL_tmpz00_7010 = BgL_tickz00_3212
; }  else 
{ 
obj_t BgL_auxz00_7013;
BgL_auxz00_7013 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)41544)), BGl_string3108z00zz__multimediazd2midizd2, BGl_string3072z00zz__multimediazd2midizd2, BgL_tickz00_3212); 
FAILURE(BgL_auxz00_7013,BFALSE,BFALSE);} 
BgL_auxz00_7009 = 
(long)CINT(BgL_tmpz00_7010); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_3211, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1070 */
BgL_auxz00_7001 = 
((BgL_midisinkz00_bglt)BgL_msz00_3211)
; }  else 
{ 
obj_t BgL_auxz00_7005;
BgL_auxz00_7005 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)41544)), BGl_string3108z00zz__multimediazd2midizd2, BGl_string3080z00zz__multimediazd2midizd2, BgL_msz00_3211); 
FAILURE(BgL_auxz00_7005,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_3210, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1070 */
BgL_auxz00_6993 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_3210)
; }  else 
{ 
obj_t BgL_auxz00_6997;
BgL_auxz00_6997 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)41544)), BGl_string3108z00zz__multimediazd2midizd2, BGl_string3079z00zz__multimediazd2midizd2, BgL_mpz00_3210); 
FAILURE(BgL_auxz00_6997,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2pitchzd2zz__multimediazd2midizd2(BgL_auxz00_6993, BgL_auxz00_7001, BgL_auxz00_7009, BgL_auxz00_7018, BgL_auxz00_7027, BgL_auxz00_7036);} } 

}



/* midiplayer-sysex */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2sysexzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_128, BgL_midisinkz00_bglt BgL_msz00_129, long BgL_tickz00_130, obj_t BgL_dataz00_131)
{
{ /* Llib/midi.scm 1075 */
{ /* Llib/midi.scm 1077 */
obj_t BgL_fun2077z00_2609;
BgL_fun2077z00_2609 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_129))->BgL_writezd2stringzd2); 
{ /* Llib/midi.scm 1077 */
obj_t BgL_arg2076z00_2610;
BgL_arg2076z00_2610 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_129))->BgL_streamz00); 
return 
PROCEDURE_ENTRY(BgL_fun2077z00_2609)(BgL_fun2077z00_2609, BgL_arg2076z00_2610, BEOA);} } } 

}



/* &midiplayer-sysex */
obj_t BGl_z62midiplayerzd2sysexzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3216, obj_t BgL_mpz00_3217, obj_t BgL_msz00_3218, obj_t BgL_tickz00_3219, obj_t BgL_dataz00_3220)
{
{ /* Llib/midi.scm 1075 */
{ /* Llib/midi.scm 1076 */
obj_t BgL_auxz00_7077;long BgL_auxz00_7068;BgL_midisinkz00_bglt BgL_auxz00_7060;BgL_midiplayerz00_bglt BgL_auxz00_7052;
if(
STRINGP(BgL_dataz00_3220))
{ /* Llib/midi.scm 1076 */
BgL_auxz00_7077 = BgL_dataz00_3220
; }  else 
{ 
obj_t BgL_auxz00_7080;
BgL_auxz00_7080 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)41881)), BGl_string3109z00zz__multimediazd2midizd2, BGl_string3069z00zz__multimediazd2midizd2, BgL_dataz00_3220); 
FAILURE(BgL_auxz00_7080,BFALSE,BFALSE);} 
{ /* Llib/midi.scm 1076 */
obj_t BgL_tmpz00_7069;
if(
INTEGERP(BgL_tickz00_3219))
{ /* Llib/midi.scm 1076 */
BgL_tmpz00_7069 = BgL_tickz00_3219
; }  else 
{ 
obj_t BgL_auxz00_7072;
BgL_auxz00_7072 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)41881)), BGl_string3109z00zz__multimediazd2midizd2, BGl_string3072z00zz__multimediazd2midizd2, BgL_tickz00_3219); 
FAILURE(BgL_auxz00_7072,BFALSE,BFALSE);} 
BgL_auxz00_7068 = 
(long)CINT(BgL_tmpz00_7069); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_3218, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1076 */
BgL_auxz00_7060 = 
((BgL_midisinkz00_bglt)BgL_msz00_3218)
; }  else 
{ 
obj_t BgL_auxz00_7064;
BgL_auxz00_7064 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)41881)), BGl_string3109z00zz__multimediazd2midizd2, BGl_string3080z00zz__multimediazd2midizd2, BgL_msz00_3218); 
FAILURE(BgL_auxz00_7064,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_3217, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1076 */
BgL_auxz00_7052 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_3217)
; }  else 
{ 
obj_t BgL_auxz00_7056;
BgL_auxz00_7056 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)41881)), BGl_string3109z00zz__multimediazd2midizd2, BGl_string3079z00zz__multimediazd2midizd2, BgL_mpz00_3217); 
FAILURE(BgL_auxz00_7056,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2sysexzd2zz__multimediazd2midizd2(BgL_auxz00_7052, BgL_auxz00_7060, BgL_auxz00_7068, BgL_auxz00_7077);} } 

}



/* midi-note-name */
BGL_EXPORTED_DEF obj_t BGl_midizd2notezd2namez00zz__multimediazd2midizd2(long BgL_kkz00_132)
{
{ /* Llib/midi.scm 1082 */
{ /* Llib/midi.scm 1083 */
long BgL_notez00_885;long BgL_octavez00_886;
{ /* Llib/midi.scm 1083 */
long BgL_arg2081z00_890;
{ /* Llib/midi.scm 1083 */
obj_t BgL_vectorz00_2611;
BgL_vectorz00_2611 = 
CNST_TABLE_REF(((long)3)); 
BgL_arg2081z00_890 = 
VECTOR_LENGTH(BgL_vectorz00_2611); } 
{ /* Llib/midi.scm 1083 */
long BgL_res2797z00_2630;
{ /* Llib/midi.scm 1083 */
long BgL_n1z00_2612;long BgL_n2z00_2613;
BgL_n1z00_2612 = BgL_kkz00_132; 
BgL_n2z00_2613 = BgL_arg2081z00_890; 
{ /* Llib/midi.scm 1083 */
bool_t BgL_test3733z00_7087;
{ /* Llib/midi.scm 1083 */
long BgL_arg1299z00_2615;
BgL_arg1299z00_2615 = 
(((BgL_n1z00_2612) | (BgL_n2z00_2613)) & -2147483648); 
BgL_test3733z00_7087 = 
(BgL_arg1299z00_2615==((long)0)); } 
if(BgL_test3733z00_7087)
{ /* Llib/midi.scm 1083 */
int32_t BgL_arg1287z00_2616;
{ /* Llib/midi.scm 1083 */
int32_t BgL_arg1293z00_2617;int32_t BgL_arg1294z00_2618;
{ /* Llib/midi.scm 1083 */
int32_t BgL_res2793z00_2622;
BgL_res2793z00_2622 = 
(int32_t)(BgL_n1z00_2612); 
BgL_arg1293z00_2617 = BgL_res2793z00_2622; } 
{ /* Llib/midi.scm 1083 */
int32_t BgL_res2794z00_2624;
BgL_res2794z00_2624 = 
(int32_t)(BgL_n2z00_2613); 
BgL_arg1294z00_2618 = BgL_res2794z00_2624; } 
BgL_arg1287z00_2616 = 
(BgL_arg1293z00_2617%BgL_arg1294z00_2618); } 
{ /* Llib/midi.scm 1083 */
long BgL_res2796z00_2629;
{ /* Llib/midi.scm 1083 */
long BgL_arg1421z00_2626;
BgL_arg1421z00_2626 = 
(long)(BgL_arg1287z00_2616); 
{ /* Llib/midi.scm 1083 */
long BgL_res2795z00_2628;
BgL_res2795z00_2628 = 
(long)(BgL_arg1421z00_2626); 
BgL_res2796z00_2629 = BgL_res2795z00_2628; } } 
BgL_res2797z00_2630 = BgL_res2796z00_2629; } }  else 
{ /* Llib/midi.scm 1083 */
BgL_res2797z00_2630 = 
(BgL_n1z00_2612%BgL_n2z00_2613); } } } 
BgL_notez00_885 = BgL_res2797z00_2630; } } 
{ /* Llib/midi.scm 1084 */
long BgL_arg2082z00_891;
{ /* Llib/midi.scm 1084 */
obj_t BgL_vectorz00_2631;
BgL_vectorz00_2631 = 
CNST_TABLE_REF(((long)3)); 
BgL_arg2082z00_891 = 
VECTOR_LENGTH(BgL_vectorz00_2631); } 
BgL_octavez00_886 = 
(BgL_kkz00_132/BgL_arg2082z00_891); } 
{ /* Llib/midi.scm 1085 */
obj_t BgL_arg2078z00_887;
{ /* Llib/midi.scm 1085 */
obj_t BgL_vectorz00_2635;
BgL_vectorz00_2635 = 
CNST_TABLE_REF(((long)3)); 
BgL_arg2078z00_887 = 
VECTOR_REF(BgL_vectorz00_2635,BgL_notez00_885); } 
{ /* Llib/midi.scm 1085 */
obj_t BgL_list2079z00_888;
{ /* Llib/midi.scm 1085 */
obj_t BgL_arg2080z00_889;
BgL_arg2080z00_889 = 
MAKE_YOUNG_PAIR(
BINT(BgL_octavez00_886), BNIL); 
BgL_list2079z00_888 = 
MAKE_YOUNG_PAIR(BgL_arg2078z00_887, BgL_arg2080z00_889); } 
return 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string3110z00zz__multimediazd2midizd2, BgL_list2079z00_888);} } } } 

}



/* &midi-note-name */
obj_t BGl_z62midizd2notezd2namez62zz__multimediazd2midizd2(obj_t BgL_envz00_3221, obj_t BgL_kkz00_3222)
{
{ /* Llib/midi.scm 1082 */
{ /* Llib/midi.scm 1083 */
long BgL_auxz00_7105;
{ /* Llib/midi.scm 1083 */
obj_t BgL_tmpz00_7106;
if(
INTEGERP(BgL_kkz00_3222))
{ /* Llib/midi.scm 1083 */
BgL_tmpz00_7106 = BgL_kkz00_3222
; }  else 
{ 
obj_t BgL_auxz00_7109;
BgL_auxz00_7109 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)42219)), BGl_string3111z00zz__multimediazd2midizd2, BGl_string3072z00zz__multimediazd2midizd2, BgL_kkz00_3222); 
FAILURE(BgL_auxz00_7109,BFALSE,BFALSE);} 
BgL_auxz00_7105 = 
(long)CINT(BgL_tmpz00_7106); } 
return 
BGl_midizd2notezd2namez00zz__multimediazd2midizd2(BgL_auxz00_7105);} } 

}



/* midi-controller-name */
BGL_EXPORTED_DEF obj_t BGl_midizd2controllerzd2namez00zz__multimediazd2midizd2(long BgL_ccz00_133)
{
{ /* Llib/midi.scm 1090 */
{ /* Llib/midi.scm 1091 */
bool_t BgL_test3735z00_7115;
{ /* Llib/midi.scm 1091 */
long BgL_arg2085z00_2638;
{ /* Llib/midi.scm 1091 */
obj_t BgL_vectorz00_2639;
BgL_vectorz00_2639 = 
CNST_TABLE_REF(((long)1)); 
BgL_arg2085z00_2638 = 
VECTOR_LENGTH(BgL_vectorz00_2639); } 
BgL_test3735z00_7115 = 
(BgL_ccz00_133<BgL_arg2085z00_2638); } 
if(BgL_test3735z00_7115)
{ /* Llib/midi.scm 1092 */
obj_t BgL_vectorz00_2643;
BgL_vectorz00_2643 = 
CNST_TABLE_REF(((long)1)); 
return 
VECTOR_REF(BgL_vectorz00_2643,BgL_ccz00_133);}  else 
{ /* Llib/midi.scm 1091 */
return BGl_string3112z00zz__multimediazd2midizd2;} } } 

}



/* &midi-controller-name */
obj_t BGl_z62midizd2controllerzd2namez62zz__multimediazd2midizd2(obj_t BgL_envz00_3223, obj_t BgL_ccz00_3224)
{
{ /* Llib/midi.scm 1090 */
{ /* Llib/midi.scm 1091 */
long BgL_auxz00_7121;
{ /* Llib/midi.scm 1091 */
obj_t BgL_tmpz00_7122;
if(
INTEGERP(BgL_ccz00_3224))
{ /* Llib/midi.scm 1091 */
BgL_tmpz00_7122 = BgL_ccz00_3224
; }  else 
{ 
obj_t BgL_auxz00_7125;
BgL_auxz00_7125 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)42667)), BGl_string3113z00zz__multimediazd2midizd2, BGl_string3072z00zz__multimediazd2midizd2, BgL_ccz00_3224); 
FAILURE(BgL_auxz00_7125,BFALSE,BFALSE);} 
BgL_auxz00_7121 = 
(long)CINT(BgL_tmpz00_7122); } 
return 
BGl_midizd2controllerzd2namez00zz__multimediazd2midizd2(BgL_auxz00_7121);} } 

}



/* midi-program-name */
BGL_EXPORTED_DEF obj_t BGl_midizd2programzd2namez00zz__multimediazd2midizd2(long BgL_ppz00_134)
{
{ /* Llib/midi.scm 1098 */
{ /* Llib/midi.scm 1099 */
bool_t BgL_test3737z00_7131;
{ /* Llib/midi.scm 1099 */
long BgL_arg2088z00_2646;
{ /* Llib/midi.scm 1099 */
obj_t BgL_vectorz00_2647;
BgL_vectorz00_2647 = 
CNST_TABLE_REF(((long)2)); 
BgL_arg2088z00_2646 = 
VECTOR_LENGTH(BgL_vectorz00_2647); } 
BgL_test3737z00_7131 = 
(BgL_ppz00_134<BgL_arg2088z00_2646); } 
if(BgL_test3737z00_7131)
{ /* Llib/midi.scm 1100 */
obj_t BgL_vectorz00_2651;
BgL_vectorz00_2651 = 
CNST_TABLE_REF(((long)2)); 
return 
VECTOR_REF(BgL_vectorz00_2651,BgL_ppz00_134);}  else 
{ /* Llib/midi.scm 1099 */
return BGl_string3114z00zz__multimediazd2midizd2;} } } 

}



/* &midi-program-name */
obj_t BGl_z62midizd2programzd2namez62zz__multimediazd2midizd2(obj_t BgL_envz00_3225, obj_t BgL_ppz00_3226)
{
{ /* Llib/midi.scm 1098 */
{ /* Llib/midi.scm 1099 */
long BgL_auxz00_7137;
{ /* Llib/midi.scm 1099 */
obj_t BgL_tmpz00_7138;
if(
INTEGERP(BgL_ppz00_3226))
{ /* Llib/midi.scm 1099 */
BgL_tmpz00_7138 = BgL_ppz00_3226
; }  else 
{ 
obj_t BgL_auxz00_7141;
BgL_auxz00_7141 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)43056)), BGl_string3115z00zz__multimediazd2midizd2, BGl_string3072z00zz__multimediazd2midizd2, BgL_ppz00_3226); 
FAILURE(BgL_auxz00_7141,BFALSE,BFALSE);} 
BgL_auxz00_7137 = 
(long)CINT(BgL_tmpz00_7138); } 
return 
BGl_midizd2programzd2namez00zz__multimediazd2midizd2(BgL_auxz00_7137);} } 

}



/* midi-program-index */
BGL_EXPORTED_DEF obj_t BGl_midizd2programzd2indexz00zz__multimediazd2midizd2(obj_t BgL_prgmz00_135)
{
{ /* Llib/midi.scm 1106 */
{ /* Llib/midi.scm 1107 */
long BgL_g1175z00_898;
{ /* Llib/midi.scm 1107 */
long BgL_arg2095z00_908;
{ /* Llib/midi.scm 1107 */
obj_t BgL_vectorz00_2653;
BgL_vectorz00_2653 = 
CNST_TABLE_REF(((long)2)); 
BgL_arg2095z00_908 = 
VECTOR_LENGTH(BgL_vectorz00_2653); } 
BgL_g1175z00_898 = 
(BgL_arg2095z00_908-((long)1)); } 
{ 
long BgL_iz00_900;
BgL_iz00_900 = BgL_g1175z00_898; 
BgL_zc3z04anonymousza32089ze3z87_901:
if(
(BgL_iz00_900>=((long)0)))
{ /* Llib/midi.scm 1109 */
bool_t BgL_test3740z00_7152;
{ /* Llib/midi.scm 1109 */
obj_t BgL_arg2094z00_906;
{ /* Llib/midi.scm 1109 */
obj_t BgL_vectorz00_2658;
BgL_vectorz00_2658 = 
CNST_TABLE_REF(((long)2)); 
BgL_arg2094z00_906 = 
VECTOR_REF(BgL_vectorz00_2658,BgL_iz00_900); } 
BgL_test3740z00_7152 = 
bigloo_strcicmp(BgL_arg2094z00_906, BgL_prgmz00_135); } 
if(BgL_test3740z00_7152)
{ /* Llib/midi.scm 1109 */
return 
BINT(BgL_iz00_900);}  else 
{ 
long BgL_iz00_7157;
BgL_iz00_7157 = 
(BgL_iz00_900-((long)1)); 
BgL_iz00_900 = BgL_iz00_7157; 
goto BgL_zc3z04anonymousza32089ze3z87_901;} }  else 
{ /* Llib/midi.scm 1108 */
return BFALSE;} } } } 

}



/* &midi-program-index */
obj_t BGl_z62midizd2programzd2indexz62zz__multimediazd2midizd2(obj_t BgL_envz00_3227, obj_t BgL_prgmz00_3228)
{
{ /* Llib/midi.scm 1106 */
{ /* Llib/midi.scm 1107 */
obj_t BgL_auxz00_7159;
if(
STRINGP(BgL_prgmz00_3228))
{ /* Llib/midi.scm 1107 */
BgL_auxz00_7159 = BgL_prgmz00_3228
; }  else 
{ 
obj_t BgL_auxz00_7162;
BgL_auxz00_7162 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)43433)), BGl_string3116z00zz__multimediazd2midizd2, BGl_string3069z00zz__multimediazd2midizd2, BgL_prgmz00_3228); 
FAILURE(BgL_auxz00_7162,BFALSE,BFALSE);} 
return 
BGl_midizd2programzd2indexz00zz__multimediazd2midizd2(BgL_auxz00_7159);} } 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__multimediazd2midizd2()
{
{ /* Llib/midi.scm 15 */
{ /* Llib/midi.scm 17 */
obj_t BgL_arg2113z00_933;obj_t BgL_arg2114z00_934;
{ /* Llib/midi.scm 17 */
obj_t BgL_v1220z00_949;
BgL_v1220z00_949 = 
create_vector(((long)4)); 
{ /* Llib/midi.scm 17 */
obj_t BgL_arg2121z00_950;
BgL_arg2121z00_950 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)5)), BGl_proc3118z00zz__multimediazd2midizd2, BGl_proc3117z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1220z00_949,((long)0),BgL_arg2121z00_950); } 
{ /* Llib/midi.scm 17 */
obj_t BgL_arg2126z00_960;
BgL_arg2126z00_960 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)7)), BGl_proc3121z00zz__multimediazd2midizd2, BGl_proc3120z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3119z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1220z00_949,((long)1),BgL_arg2126z00_960); } 
{ /* Llib/midi.scm 17 */
obj_t BgL_arg2133z00_973;
BgL_arg2133z00_973 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)8)), BGl_proc3124z00zz__multimediazd2midizd2, BGl_proc3123z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3122z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1220z00_949,((long)2),BgL_arg2133z00_973); } 
{ /* Llib/midi.scm 17 */
obj_t BgL_arg2140z00_986;
BgL_arg2140z00_986 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)9)), BGl_proc3127z00zz__multimediazd2midizd2, BGl_proc3126z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3125z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)10))); 
VECTOR_SET(BgL_v1220z00_949,((long)3),BgL_arg2140z00_986); } 
BgL_arg2113z00_933 = BgL_v1220z00_949; } 
{ /* Llib/midi.scm 17 */
obj_t BgL_v1221z00_999;
BgL_v1221z00_999 = 
create_vector(((long)0)); 
BgL_arg2114z00_934 = BgL_v1221z00_999; } 
BGl_midiscorez00zz__multimediazd2midizd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)11)), 
CNST_TABLE_REF(((long)12)), BGl_objectz00zz__objectz00, ((long)5450), BGl_proc3130z00zz__multimediazd2midizd2, BGl_proc3129z00zz__multimediazd2midizd2, BGl_midiscorezd2initzd2envz00zz__multimediazd2midizd2, BGl_proc3128z00zz__multimediazd2midizd2, BFALSE, BgL_arg2113z00_933, BgL_arg2114z00_934); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2150z00_1006;obj_t BgL_arg2151z00_1007;
{ /* Llib/midi.scm 24 */
obj_t BgL_v1222z00_1032;
BgL_v1222z00_1032 = 
create_vector(((long)14)); 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2158z00_1033;
BgL_arg2158z00_1033 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)13)), BGl_proc3133z00zz__multimediazd2midizd2, BGl_proc3132z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3131z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)14))); 
VECTOR_SET(BgL_v1222z00_1032,((long)0),BgL_arg2158z00_1033); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2165z00_1046;
BgL_arg2165z00_1046 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)15)), BGl_proc3135z00zz__multimediazd2midizd2, BGl_proc3134z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_midireaderz00zz__multimediazd2midizd2); 
VECTOR_SET(BgL_v1222z00_1032,((long)1),BgL_arg2165z00_1046); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2170z00_1056;
BgL_arg2170z00_1056 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)16)), BGl_proc3137z00zz__multimediazd2midizd2, BGl_proc3136z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1222z00_1032,((long)2),BgL_arg2170z00_1056); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2175z00_1066;
BgL_arg2175z00_1066 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)18)), BGl_proc3140z00zz__multimediazd2midizd2, BGl_proc3139z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3138z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)19))); 
VECTOR_SET(BgL_v1222z00_1032,((long)3),BgL_arg2175z00_1066); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2182z00_1079;
BgL_arg2182z00_1079 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)20)), BGl_proc3143z00zz__multimediazd2midizd2, BGl_proc3142z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3141z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)21))); 
VECTOR_SET(BgL_v1222z00_1032,((long)4),BgL_arg2182z00_1079); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2189z00_1092;
BgL_arg2189z00_1092 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)22)), BGl_proc3146z00zz__multimediazd2midizd2, BGl_proc3145z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3144z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1222z00_1032,((long)5),BgL_arg2189z00_1092); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2196z00_1105;
BgL_arg2196z00_1105 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)23)), BGl_proc3149z00zz__multimediazd2midizd2, BGl_proc3148z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3147z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)24))); 
VECTOR_SET(BgL_v1222z00_1032,((long)6),BgL_arg2196z00_1105); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2203z00_1118;
BgL_arg2203z00_1118 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)7)), BGl_proc3152z00zz__multimediazd2midizd2, BGl_proc3151z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3150z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1222z00_1032,((long)7),BgL_arg2203z00_1118); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2210z00_1131;
BgL_arg2210z00_1131 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)25)), BGl_proc3155z00zz__multimediazd2midizd2, BGl_proc3154z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3153z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)14))); 
VECTOR_SET(BgL_v1222z00_1032,((long)8),BgL_arg2210z00_1131); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2217z00_1144;
BgL_arg2217z00_1144 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)26)), BGl_proc3158z00zz__multimediazd2midizd2, BGl_proc3157z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3156z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1222z00_1032,((long)9),BgL_arg2217z00_1144); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2224z00_1157;
BgL_arg2224z00_1157 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)27)), BGl_proc3161z00zz__multimediazd2midizd2, BGl_proc3160z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3159z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1222z00_1032,((long)10),BgL_arg2224z00_1157); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2231z00_1170;
BgL_arg2231z00_1170 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)28)), BGl_proc3164z00zz__multimediazd2midizd2, BGl_proc3163z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3162z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)21))); 
VECTOR_SET(BgL_v1222z00_1032,((long)11),BgL_arg2231z00_1170); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2238z00_1183;
BgL_arg2238z00_1183 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)29)), BGl_proc3167z00zz__multimediazd2midizd2, BGl_proc3166z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3165z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1222z00_1032,((long)12),BgL_arg2238z00_1183); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2245z00_1196;
BgL_arg2245z00_1196 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)30)), BGl_proc3170z00zz__multimediazd2midizd2, BGl_proc3169z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3168z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)19))); 
VECTOR_SET(BgL_v1222z00_1032,((long)13),BgL_arg2245z00_1196); } 
BgL_arg2150z00_1006 = BgL_v1222z00_1032; } 
{ /* Llib/midi.scm 24 */
obj_t BgL_v1223z00_1209;
BgL_v1223z00_1209 = 
create_vector(((long)0)); 
BgL_arg2151z00_1007 = BgL_v1223z00_1209; } 
BGl_miditrackz00zz__multimediazd2midizd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)31)), 
CNST_TABLE_REF(((long)12)), BGl_objectz00zz__objectz00, ((long)26896), BGl_proc3173z00zz__multimediazd2midizd2, BGl_proc3172z00zz__multimediazd2midizd2, BGl_miditrackzd2initzd2envz00zz__multimediazd2midizd2, BGl_proc3171z00zz__multimediazd2midizd2, BFALSE, BgL_arg2150z00_1006, BgL_arg2151z00_1007); } 
{ /* Llib/midi.scm 42 */
obj_t BgL_arg2255z00_1216;obj_t BgL_arg2256z00_1217;
{ /* Llib/midi.scm 42 */
obj_t BgL_v1224z00_1235;
BgL_v1224z00_1235 = 
create_vector(((long)7)); 
{ /* Llib/midi.scm 42 */
obj_t BgL_arg2263z00_1236;
BgL_arg2263z00_1236 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)32)), BGl_proc3175z00zz__multimediazd2midizd2, BGl_proc3174z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1224z00_1235,((long)0),BgL_arg2263z00_1236); } 
{ /* Llib/midi.scm 42 */
obj_t BgL_arg2268z00_1246;
BgL_arg2268z00_1246 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)33)), BGl_proc3177z00zz__multimediazd2midizd2, BGl_proc3176z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1224z00_1235,((long)1),BgL_arg2268z00_1246); } 
{ /* Llib/midi.scm 42 */
obj_t BgL_arg2273z00_1256;
BgL_arg2273z00_1256 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)34)), BGl_proc3179z00zz__multimediazd2midizd2, BGl_proc3178z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1224z00_1235,((long)2),BgL_arg2273z00_1256); } 
{ /* Llib/midi.scm 42 */
obj_t BgL_arg2278z00_1266;
BgL_arg2278z00_1266 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)35)), BGl_proc3181z00zz__multimediazd2midizd2, BGl_proc3180z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1224z00_1235,((long)3),BgL_arg2278z00_1266); } 
{ /* Llib/midi.scm 42 */
obj_t BgL_arg2283z00_1276;
BgL_arg2283z00_1276 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)36)), BGl_proc3183z00zz__multimediazd2midizd2, BGl_proc3182z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1224z00_1235,((long)4),BgL_arg2283z00_1276); } 
{ /* Llib/midi.scm 42 */
obj_t BgL_arg2288z00_1286;
BgL_arg2288z00_1286 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)37)), BGl_proc3185z00zz__multimediazd2midizd2, BGl_proc3184z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1224z00_1235,((long)5),BgL_arg2288z00_1286); } 
{ /* Llib/midi.scm 42 */
obj_t BgL_arg2293z00_1296;
BgL_arg2293z00_1296 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)38)), BGl_proc3187z00zz__multimediazd2midizd2, BGl_proc3186z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1224z00_1235,((long)6),BgL_arg2293z00_1296); } 
BgL_arg2255z00_1216 = BgL_v1224z00_1235; } 
{ /* Llib/midi.scm 42 */
obj_t BgL_v1225z00_1306;
BgL_v1225z00_1306 = 
create_vector(((long)0)); 
BgL_arg2256z00_1217 = BgL_v1225z00_1306; } 
BGl_midireaderz00zz__multimediazd2midizd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)39)), 
CNST_TABLE_REF(((long)12)), BGl_objectz00zz__objectz00, ((long)53877), BGl_proc3190z00zz__multimediazd2midizd2, BGl_proc3189z00zz__multimediazd2midizd2, BGl_midireaderzd2initzd2envz00zz__multimediazd2midizd2, BGl_proc3188z00zz__multimediazd2midizd2, BFALSE, BgL_arg2255z00_1216, BgL_arg2256z00_1217); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2301z00_1313;obj_t BgL_arg2302z00_1314;
{ /* Llib/midi.scm 52 */
obj_t BgL_v1226z00_1353;
BgL_v1226z00_1353 = 
create_vector(((long)28)); 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2309z00_1354;
BgL_arg2309z00_1354 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)40)), BGl_proc3193z00zz__multimediazd2midizd2, BGl_proc3192z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3191z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)0),BgL_arg2309z00_1354); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2316z00_1367;
BgL_arg2316z00_1367 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)41)), BGl_proc3196z00zz__multimediazd2midizd2, BGl_proc3195z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3194z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)1),BgL_arg2316z00_1367); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2323z00_1380;
BgL_arg2323z00_1380 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)42)), BGl_proc3199z00zz__multimediazd2midizd2, BGl_proc3198z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3197z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)2),BgL_arg2323z00_1380); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2330z00_1393;
BgL_arg2330z00_1393 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)43)), BGl_proc3202z00zz__multimediazd2midizd2, BGl_proc3201z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3200z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)3),BgL_arg2330z00_1393); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2337z00_1406;
BgL_arg2337z00_1406 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)44)), BGl_proc3205z00zz__multimediazd2midizd2, BGl_proc3204z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3203z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)4),BgL_arg2337z00_1406); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2344z00_1419;
BgL_arg2344z00_1419 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)45)), BGl_proc3208z00zz__multimediazd2midizd2, BGl_proc3207z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3206z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)5),BgL_arg2344z00_1419); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2351z00_1432;
BgL_arg2351z00_1432 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)46)), BGl_proc3211z00zz__multimediazd2midizd2, BGl_proc3210z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3209z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)6),BgL_arg2351z00_1432); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2358z00_1445;
BgL_arg2358z00_1445 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)47)), BGl_proc3214z00zz__multimediazd2midizd2, BGl_proc3213z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3212z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)7),BgL_arg2358z00_1445); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2365z00_1458;
BgL_arg2365z00_1458 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)48)), BGl_proc3217z00zz__multimediazd2midizd2, BGl_proc3216z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3215z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)8),BgL_arg2365z00_1458); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2372z00_1471;
BgL_arg2372z00_1471 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)49)), BGl_proc3220z00zz__multimediazd2midizd2, BGl_proc3219z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3218z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)9),BgL_arg2372z00_1471); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2379z00_1484;
BgL_arg2379z00_1484 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)50)), BGl_proc3223z00zz__multimediazd2midizd2, BGl_proc3222z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3221z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)10),BgL_arg2379z00_1484); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2386z00_1497;
BgL_arg2386z00_1497 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)51)), BGl_proc3226z00zz__multimediazd2midizd2, BGl_proc3225z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3224z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)11),BgL_arg2386z00_1497); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2393z00_1510;
BgL_arg2393z00_1510 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)52)), BGl_proc3229z00zz__multimediazd2midizd2, BGl_proc3228z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3227z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)12),BgL_arg2393z00_1510); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2400z00_1523;
BgL_arg2400z00_1523 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)53)), BGl_proc3232z00zz__multimediazd2midizd2, BGl_proc3231z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3230z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)13),BgL_arg2400z00_1523); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2407z00_1536;
BgL_arg2407z00_1536 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)54)), BGl_proc3235z00zz__multimediazd2midizd2, BGl_proc3234z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3233z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)14),BgL_arg2407z00_1536); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2414z00_1549;
BgL_arg2414z00_1549 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)55)), BGl_proc3238z00zz__multimediazd2midizd2, BGl_proc3237z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3236z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)15),BgL_arg2414z00_1549); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2421z00_1562;
BgL_arg2421z00_1562 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)56)), BGl_proc3241z00zz__multimediazd2midizd2, BGl_proc3240z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3239z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)16),BgL_arg2421z00_1562); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2428z00_1575;
BgL_arg2428z00_1575 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)57)), BGl_proc3244z00zz__multimediazd2midizd2, BGl_proc3243z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3242z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)17),BgL_arg2428z00_1575); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2435z00_1588;
BgL_arg2435z00_1588 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)58)), BGl_proc3247z00zz__multimediazd2midizd2, BGl_proc3246z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3245z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)18),BgL_arg2435z00_1588); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2442z00_1601;
BgL_arg2442z00_1601 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)59)), BGl_proc3250z00zz__multimediazd2midizd2, BGl_proc3249z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3248z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)19),BgL_arg2442z00_1601); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2449z00_1614;
BgL_arg2449z00_1614 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)60)), BGl_proc3253z00zz__multimediazd2midizd2, BGl_proc3252z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3251z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)20),BgL_arg2449z00_1614); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2456z00_1627;
BgL_arg2456z00_1627 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)61)), BGl_proc3256z00zz__multimediazd2midizd2, BGl_proc3255z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3254z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)21),BgL_arg2456z00_1627); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2463z00_1640;
BgL_arg2463z00_1640 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)62)), BGl_proc3259z00zz__multimediazd2midizd2, BGl_proc3258z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3257z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)22),BgL_arg2463z00_1640); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2470z00_1653;
BgL_arg2470z00_1653 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)63)), BGl_proc3262z00zz__multimediazd2midizd2, BGl_proc3261z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3260z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)23),BgL_arg2470z00_1653); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2477z00_1666;
BgL_arg2477z00_1666 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)64)), BGl_proc3265z00zz__multimediazd2midizd2, BGl_proc3264z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3263z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)24),BgL_arg2477z00_1666); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2485z00_1688;
BgL_arg2485z00_1688 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)65)), BGl_proc3268z00zz__multimediazd2midizd2, BGl_proc3267z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3266z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)25),BgL_arg2485z00_1688); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2493z00_1709;
BgL_arg2493z00_1709 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)66)), BGl_proc3271z00zz__multimediazd2midizd2, BGl_proc3270z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3269z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)26),BgL_arg2493z00_1709); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2500z00_1722;
BgL_arg2500z00_1722 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)67)), BGl_proc3274z00zz__multimediazd2midizd2, BGl_proc3273z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3272z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)27),BgL_arg2500z00_1722); } 
BgL_arg2301z00_1313 = BgL_v1226z00_1353; } 
{ /* Llib/midi.scm 52 */
obj_t BgL_v1227z00_1735;
BgL_v1227z00_1735 = 
create_vector(((long)0)); 
BgL_arg2302z00_1314 = BgL_v1227z00_1735; } 
BGl_midiplayerz00zz__multimediazd2midizd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)68)), 
CNST_TABLE_REF(((long)12)), BGl_objectz00zz__objectz00, ((long)52705), BGl_proc3277z00zz__multimediazd2midizd2, BGl_proc3276z00zz__multimediazd2midizd2, BGl_midiplayerzd2initzd2envz00zz__multimediazd2midizd2, BGl_proc3275z00zz__multimediazd2midizd2, BFALSE, BgL_arg2301z00_1313, BgL_arg2302z00_1314); } 
{ /* Llib/midi.scm 87 */
obj_t BgL_arg2510z00_1742;obj_t BgL_arg2511z00_1743;
{ /* Llib/midi.scm 87 */
obj_t BgL_v1228z00_1759;
BgL_v1228z00_1759 = 
create_vector(((long)5)); 
{ /* Llib/midi.scm 87 */
obj_t BgL_arg2518z00_1760;
BgL_arg2518z00_1760 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)69)), BGl_proc3280z00zz__multimediazd2midizd2, BGl_proc3279z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3278z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)14))); 
VECTOR_SET(BgL_v1228z00_1759,((long)0),BgL_arg2518z00_1760); } 
{ /* Llib/midi.scm 87 */
obj_t BgL_arg2525z00_1773;
BgL_arg2525z00_1773 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)70)), BGl_proc3283z00zz__multimediazd2midizd2, BGl_proc3282z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3281z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1228z00_1759,((long)1),BgL_arg2525z00_1773); } 
{ /* Llib/midi.scm 87 */
obj_t BgL_arg2532z00_1786;
BgL_arg2532z00_1786 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)71)), BGl_proc3286z00zz__multimediazd2midizd2, BGl_proc3285z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3284z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1228z00_1759,((long)2),BgL_arg2532z00_1786); } 
{ /* Llib/midi.scm 87 */
obj_t BgL_arg2540z00_1802;
BgL_arg2540z00_1802 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)72)), BGl_proc3289z00zz__multimediazd2midizd2, BGl_proc3288z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3287z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1228z00_1759,((long)3),BgL_arg2540z00_1802); } 
{ /* Llib/midi.scm 87 */
obj_t BgL_arg2548z00_1818;
BgL_arg2548z00_1818 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)73)), BGl_proc3292z00zz__multimediazd2midizd2, BGl_proc3291z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3290z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1228z00_1759,((long)4),BgL_arg2548z00_1818); } 
BgL_arg2510z00_1742 = BgL_v1228z00_1759; } 
{ /* Llib/midi.scm 87 */
obj_t BgL_v1229z00_1831;
BgL_v1229z00_1831 = 
create_vector(((long)0)); 
BgL_arg2511z00_1743 = BgL_v1229z00_1831; } 
return ( 
BGl_midisinkz00zz__multimediazd2midizd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)74)), 
CNST_TABLE_REF(((long)12)), BGl_objectz00zz__objectz00, ((long)13783), BGl_proc3295z00zz__multimediazd2midizd2, BGl_proc3294z00zz__multimediazd2midizd2, BGl_midisinkzd2initzd2envz00zz__multimediazd2midizd2, BGl_proc3293z00zz__multimediazd2midizd2, BFALSE, BgL_arg2510z00_1742, BgL_arg2511z00_1743), BUNSPEC) ;} } 

}



/* &<@anonymous:2517> */
obj_t BGl_z62zc3z04anonymousza32517ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3423, obj_t BgL_new1119z00_3424)
{
{ /* Llib/midi.scm 87 */
{ 
BgL_midisinkz00_bglt BgL_auxz00_7423;
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_new1119z00_3424)))->BgL_streamz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_new1119z00_3424)))->BgL_usleepz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_new1119z00_3424)))->BgL_writezd2bytezd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_new1119z00_3424)))->BgL_writezd2stringzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_new1119z00_3424)))->BgL_flushz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
BgL_auxz00_7423 = 
((BgL_midisinkz00_bglt)BgL_new1119z00_3424); 
return 
((obj_t)BgL_auxz00_7423);} } 

}



/* &lambda2515 */
BgL_midisinkz00_bglt BGl_z62lambda2515z62zz__multimediazd2midizd2(obj_t BgL_envz00_3425)
{
{ /* Llib/midi.scm 87 */
{ /* Llib/midi.scm 87 */
BgL_midisinkz00_bglt BgL_new1118z00_4203;
BgL_new1118z00_4203 = 
((BgL_midisinkz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midisinkz00_bgl) ))); 
{ /* Llib/midi.scm 87 */
long BgL_arg2516z00_4204;
{ /* Llib/midi.scm 87 */
long BgL_res2816z00_4205;
BgL_res2816z00_4205 = 
BGL_CLASS_INDEX(BGl_midisinkz00zz__multimediazd2midizd2); 
BgL_arg2516z00_4204 = BgL_res2816z00_4205; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1118z00_4203), BgL_arg2516z00_4204); } 
return BgL_new1118z00_4203;} } 

}



/* &lambda2512 */
BgL_midisinkz00_bglt BGl_z62lambda2512z62zz__multimediazd2midizd2(obj_t BgL_envz00_3426, obj_t BgL_stream1113z00_3427, obj_t BgL_usleep1114z00_3428, obj_t BgL_writezd2byte1115zd2_3429, obj_t BgL_writezd2string1116zd2_3430, obj_t BgL_flush1117z00_3431)
{
{ /* Llib/midi.scm 87 */
{ /* Llib/midi.scm 87 */
BgL_midisinkz00_bglt BgL_new1185z00_4210;
{ /* Llib/midi.scm 87 */
BgL_midisinkz00_bglt BgL_new1184z00_4211;
BgL_new1184z00_4211 = 
((BgL_midisinkz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midisinkz00_bgl) ))); 
{ /* Llib/midi.scm 87 */
long BgL_arg2514z00_4212;
{ /* Llib/midi.scm 87 */
long BgL_res2815z00_4213;
BgL_res2815z00_4213 = 
BGL_CLASS_INDEX(BGl_midisinkz00zz__multimediazd2midizd2); 
BgL_arg2514z00_4212 = BgL_res2815z00_4213; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1184z00_4211), BgL_arg2514z00_4212); } 
BgL_new1185z00_4210 = BgL_new1184z00_4211; } 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1185z00_4210))->BgL_streamz00)=((obj_t)BgL_stream1113z00_3427),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1185z00_4210))->BgL_usleepz00)=((obj_t)
((obj_t)BgL_usleep1114z00_3428)),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1185z00_4210))->BgL_writezd2bytezd2)=((obj_t)
((obj_t)BgL_writezd2byte1115zd2_3429)),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1185z00_4210))->BgL_writezd2stringzd2)=((obj_t)
((obj_t)BgL_writezd2string1116zd2_3430)),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1185z00_4210))->BgL_flushz00)=((obj_t)
((obj_t)BgL_flush1117z00_3431)),BUNSPEC); 
{ /* Llib/midi.scm 87 */
obj_t BgL_fun2513z00_4214;
BgL_fun2513z00_4214 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_midisinkz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun2513z00_4214)(BgL_fun2513z00_4214, 
((obj_t)BgL_new1185z00_4210), BEOA); } 
return BgL_new1185z00_4210;} } 

}



/* &<@anonymous:2554> */
obj_t BGl_z62zc3z04anonymousza32554ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3432)
{
{ /* Llib/midi.scm 87 */
return BGl_flushzd2outputzd2portzd2envzd2zz__r4_ports_6_10_1z00;} 

}



/* &lambda2553 */
obj_t BGl_z62lambda2553z62zz__multimediazd2midizd2(obj_t BgL_envz00_3433, obj_t BgL_oz00_3434, obj_t BgL_vz00_3435)
{
{ /* Llib/midi.scm 87 */
return 
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3434)))->BgL_flushz00)=((obj_t)
((obj_t)BgL_vz00_3435)),BUNSPEC);} 

}



/* &lambda2552 */
obj_t BGl_z62lambda2552z62zz__multimediazd2midizd2(obj_t BgL_envz00_3436, obj_t BgL_oz00_3437)
{
{ /* Llib/midi.scm 87 */
return 
(((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3437)))->BgL_flushz00);} 

}



/* &<@anonymous:2546> */
obj_t BGl_z62zc3z04anonymousza32546ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3438)
{
{ /* Llib/midi.scm 87 */
return BGl_proc3296z00zz__multimediazd2midizd2;} 

}



/* &lambda2545 */
obj_t BGl_z62lambda2545z62zz__multimediazd2midizd2(obj_t BgL_envz00_3439, obj_t BgL_oz00_3440, obj_t BgL_vz00_3441)
{
{ /* Llib/midi.scm 87 */
return 
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3440)))->BgL_writezd2stringzd2)=((obj_t)
((obj_t)BgL_vz00_3441)),BUNSPEC);} 

}



/* &lambda2544 */
obj_t BGl_z62lambda2544z62zz__multimediazd2midizd2(obj_t BgL_envz00_3442, obj_t BgL_oz00_3443)
{
{ /* Llib/midi.scm 87 */
return 
(((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3443)))->BgL_writezd2stringzd2);} 

}



/* &<@anonymous:2547> */
obj_t BGl_z62zc3z04anonymousza32547ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3444, obj_t BgL_opz00_3445, obj_t BgL_sz00_3446)
{
{ /* Llib/midi.scm 92 */
return 
BGl_writezd2stringzd2zz__r4_output_6_10_3z00(BgL_sz00_3446, BgL_opz00_3445);} 

}



/* &<@anonymous:2538> */
obj_t BGl_z62zc3z04anonymousza32538ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3447)
{
{ /* Llib/midi.scm 87 */
return BGl_proc3297z00zz__multimediazd2midizd2;} 

}



/* &lambda2537 */
obj_t BGl_z62lambda2537z62zz__multimediazd2midizd2(obj_t BgL_envz00_3448, obj_t BgL_oz00_3449, obj_t BgL_vz00_3450)
{
{ /* Llib/midi.scm 87 */
return 
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3449)))->BgL_writezd2bytezd2)=((obj_t)
((obj_t)BgL_vz00_3450)),BUNSPEC);} 

}



/* &lambda2536 */
obj_t BGl_z62lambda2536z62zz__multimediazd2midizd2(obj_t BgL_envz00_3451, obj_t BgL_oz00_3452)
{
{ /* Llib/midi.scm 87 */
return 
(((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3452)))->BgL_writezd2bytezd2);} 

}



/* &<@anonymous:2539> */
obj_t BGl_z62zc3z04anonymousza32539ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3453, obj_t BgL_opz00_3454, obj_t BgL_bz00_3455)
{
{ /* Llib/midi.scm 91 */
{ /* Llib/midi.scm 91 */
unsigned char BgL_bytez00_4224;
BgL_bytez00_4224 = 
(unsigned char)CINT(BgL_bz00_3455); 
{ /* Llib/midi.scm 91 */
obj_t BgL_tmpz00_7476;
BgL_tmpz00_7476 = 
((obj_t)BgL_opz00_3454); 
return 
bgl_display_char(BgL_bytez00_4224, BgL_tmpz00_7476);} } } 

}



/* &<@anonymous:2531> */
obj_t BGl_z62zc3z04anonymousza32531ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3456)
{
{ /* Llib/midi.scm 87 */
return BGl_sleepzd2envzd2zz__osz00;} 

}



/* &lambda2530 */
obj_t BGl_z62lambda2530z62zz__multimediazd2midizd2(obj_t BgL_envz00_3457, obj_t BgL_oz00_3458, obj_t BgL_vz00_3459)
{
{ /* Llib/midi.scm 87 */
return 
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3458)))->BgL_usleepz00)=((obj_t)
((obj_t)BgL_vz00_3459)),BUNSPEC);} 

}



/* &lambda2529 */
obj_t BGl_z62lambda2529z62zz__multimediazd2midizd2(obj_t BgL_envz00_3460, obj_t BgL_oz00_3461)
{
{ /* Llib/midi.scm 87 */
return 
(((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3461)))->BgL_usleepz00);} 

}



/* &<@anonymous:2524> */
obj_t BGl_z62zc3z04anonymousza32524ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3462)
{
{ /* Llib/midi.scm 87 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda2523 */
obj_t BGl_z62lambda2523z62zz__multimediazd2midizd2(obj_t BgL_envz00_3463, obj_t BgL_oz00_3464, obj_t BgL_vz00_3465)
{
{ /* Llib/midi.scm 87 */
return 
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3464)))->BgL_streamz00)=((obj_t)BgL_vz00_3465),BUNSPEC);} 

}



/* &lambda2522 */
obj_t BGl_z62lambda2522z62zz__multimediazd2midizd2(obj_t BgL_envz00_3466, obj_t BgL_oz00_3467)
{
{ /* Llib/midi.scm 87 */
return 
(((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3467)))->BgL_streamz00);} 

}



/* &<@anonymous:2308> */
obj_t BGl_z62zc3z04anonymousza32308ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3468, obj_t BgL_new1111z00_3469)
{
{ /* Llib/midi.scm 52 */
{ 
BgL_midiplayerz00_bglt BgL_auxz00_7489;
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3469)))->BgL_errz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3469)))->BgL_cdelayz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3469)))->BgL_noteoffz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3469)))->BgL_noteonz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3469)))->BgL_aftertouchz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3469)))->BgL_ctrlchangez00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3469)))->BgL_prgmchangez00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3469)))->BgL_afterzd2touchzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3469)))->BgL_pitchz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3469)))->BgL_sysexz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3469)))->BgL_metazd2seqnumzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3469)))->BgL_metazd2textzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3469)))->BgL_metazd2copyrightzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3469)))->BgL_metazd2trackzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3469)))->BgL_metazd2instrumentzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3469)))->BgL_metazd2lyriczd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3469)))->BgL_metazd2markerzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3469)))->BgL_metazd2cuezd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3469)))->BgL_metazd2prgmnamezd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3469)))->BgL_metazd2devnamezd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3469)))->BgL_metazd2channprefzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3469)))->BgL_metazd2midiportzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3469)))->BgL_metazd2eotzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3469)))->BgL_metazd2tempozd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3469)))->BgL_metazd2smtpezd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3469)))->BgL_metazd2timesigzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3469)))->BgL_metazd2keysigzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3469)))->BgL_metazd2seqspeczd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
BgL_auxz00_7489 = 
((BgL_midiplayerz00_bglt)BgL_new1111z00_3469); 
return 
((obj_t)BgL_auxz00_7489);} } 

}



/* &lambda2306 */
BgL_midiplayerz00_bglt BGl_z62lambda2306z62zz__multimediazd2midizd2(obj_t BgL_envz00_3470)
{
{ /* Llib/midi.scm 52 */
{ /* Llib/midi.scm 52 */
BgL_midiplayerz00_bglt BgL_new1110z00_4231;
BgL_new1110z00_4231 = 
((BgL_midiplayerz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midiplayerz00_bgl) ))); 
{ /* Llib/midi.scm 52 */
long BgL_arg2307z00_4232;
{ /* Llib/midi.scm 52 */
long BgL_res2814z00_4233;
BgL_res2814z00_4233 = 
BGL_CLASS_INDEX(BGl_midiplayerz00zz__multimediazd2midizd2); 
BgL_arg2307z00_4232 = BgL_res2814z00_4233; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1110z00_4231), BgL_arg2307z00_4232); } 
return BgL_new1110z00_4231;} } 

}



/* &lambda2303 */
BgL_midiplayerz00_bglt BGl_z62lambda2303z62zz__multimediazd2midizd2(obj_t BgL_envz00_3471, obj_t BgL_err1082z00_3472, obj_t BgL_cdelay1083z00_3473, obj_t BgL_noteoff1084z00_3474, obj_t BgL_noteon1085z00_3475, obj_t BgL_aftertouch1086z00_3476, obj_t BgL_ctrlchange1087z00_3477, obj_t BgL_prgmchange1088z00_3478, obj_t BgL_afterzd2touch1089zd2_3479, obj_t BgL_pitch1090z00_3480, obj_t BgL_sysex1091z00_3481, obj_t BgL_metazd2seqnum1092zd2_3482, obj_t BgL_metazd2text1093zd2_3483, obj_t BgL_metazd2copyright1094zd2_3484, obj_t BgL_metazd2track1095zd2_3485, obj_t BgL_metazd2instrument1096zd2_3486, obj_t BgL_metazd2lyric1097zd2_3487, obj_t BgL_metazd2marker1098zd2_3488, obj_t BgL_metazd2cue1099zd2_3489, obj_t BgL_metazd2prgmname1100zd2_3490, obj_t BgL_metazd2devname1101zd2_3491, obj_t BgL_metazd2channpref1102zd2_3492, obj_t BgL_metazd2midiport1103zd2_3493, obj_t BgL_metazd2eot1104zd2_3494, obj_t BgL_metazd2tempo1105zd2_3495, obj_t BgL_metazd2smtpe1106zd2_3496, obj_t BgL_metazd2timesig1107zd2_3497, obj_t BgL_metazd2keysig1108zd2_3498, obj_t BgL_metazd2seqspec1109zd2_3499)
{
{ /* Llib/midi.scm 52 */
{ /* Llib/midi.scm 52 */
BgL_midiplayerz00_bglt BgL_new1183z00_4262;
{ /* Llib/midi.scm 52 */
BgL_midiplayerz00_bglt BgL_new1182z00_4263;
BgL_new1182z00_4263 = 
((BgL_midiplayerz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midiplayerz00_bgl) ))); 
{ /* Llib/midi.scm 52 */
long BgL_arg2305z00_4264;
{ /* Llib/midi.scm 52 */
long BgL_res2813z00_4265;
BgL_res2813z00_4265 = 
BGL_CLASS_INDEX(BGl_midiplayerz00zz__multimediazd2midizd2); 
BgL_arg2305z00_4264 = BgL_res2813z00_4265; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1182z00_4263), BgL_arg2305z00_4264); } 
BgL_new1183z00_4262 = BgL_new1182z00_4263; } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4262))->BgL_errz00)=((obj_t)
((obj_t)BgL_err1082z00_3472)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4262))->BgL_cdelayz00)=((obj_t)
((obj_t)BgL_cdelay1083z00_3473)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4262))->BgL_noteoffz00)=((obj_t)
((obj_t)BgL_noteoff1084z00_3474)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4262))->BgL_noteonz00)=((obj_t)
((obj_t)BgL_noteon1085z00_3475)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4262))->BgL_aftertouchz00)=((obj_t)
((obj_t)BgL_aftertouch1086z00_3476)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4262))->BgL_ctrlchangez00)=((obj_t)
((obj_t)BgL_ctrlchange1087z00_3477)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4262))->BgL_prgmchangez00)=((obj_t)
((obj_t)BgL_prgmchange1088z00_3478)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4262))->BgL_afterzd2touchzd2)=((obj_t)
((obj_t)BgL_afterzd2touch1089zd2_3479)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4262))->BgL_pitchz00)=((obj_t)
((obj_t)BgL_pitch1090z00_3480)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4262))->BgL_sysexz00)=((obj_t)
((obj_t)BgL_sysex1091z00_3481)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4262))->BgL_metazd2seqnumzd2)=((obj_t)
((obj_t)BgL_metazd2seqnum1092zd2_3482)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4262))->BgL_metazd2textzd2)=((obj_t)
((obj_t)BgL_metazd2text1093zd2_3483)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4262))->BgL_metazd2copyrightzd2)=((obj_t)
((obj_t)BgL_metazd2copyright1094zd2_3484)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4262))->BgL_metazd2trackzd2)=((obj_t)
((obj_t)BgL_metazd2track1095zd2_3485)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4262))->BgL_metazd2instrumentzd2)=((obj_t)
((obj_t)BgL_metazd2instrument1096zd2_3486)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4262))->BgL_metazd2lyriczd2)=((obj_t)
((obj_t)BgL_metazd2lyric1097zd2_3487)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4262))->BgL_metazd2markerzd2)=((obj_t)
((obj_t)BgL_metazd2marker1098zd2_3488)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4262))->BgL_metazd2cuezd2)=((obj_t)
((obj_t)BgL_metazd2cue1099zd2_3489)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4262))->BgL_metazd2prgmnamezd2)=((obj_t)
((obj_t)BgL_metazd2prgmname1100zd2_3490)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4262))->BgL_metazd2devnamezd2)=((obj_t)
((obj_t)BgL_metazd2devname1101zd2_3491)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4262))->BgL_metazd2channprefzd2)=((obj_t)
((obj_t)BgL_metazd2channpref1102zd2_3492)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4262))->BgL_metazd2midiportzd2)=((obj_t)
((obj_t)BgL_metazd2midiport1103zd2_3493)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4262))->BgL_metazd2eotzd2)=((obj_t)
((obj_t)BgL_metazd2eot1104zd2_3494)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4262))->BgL_metazd2tempozd2)=((obj_t)
((obj_t)BgL_metazd2tempo1105zd2_3495)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4262))->BgL_metazd2smtpezd2)=((obj_t)
((obj_t)BgL_metazd2smtpe1106zd2_3496)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4262))->BgL_metazd2timesigzd2)=((obj_t)
((obj_t)BgL_metazd2timesig1107zd2_3497)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4262))->BgL_metazd2keysigzd2)=((obj_t)
((obj_t)BgL_metazd2keysig1108zd2_3498)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4262))->BgL_metazd2seqspeczd2)=((obj_t)
((obj_t)BgL_metazd2seqspec1109zd2_3499)),BUNSPEC); 
{ /* Llib/midi.scm 52 */
obj_t BgL_fun2304z00_4266;
BgL_fun2304z00_4266 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_midiplayerz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun2304z00_4266)(BgL_fun2304z00_4266, 
((obj_t)BgL_new1183z00_4262), BEOA); } 
return BgL_new1183z00_4262;} } 

}



/* &<@anonymous:2506> */
obj_t BGl_z62zc3z04anonymousza32506ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3500)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2505 */
obj_t BGl_z62lambda2505z62zz__multimediazd2midizd2(obj_t BgL_envz00_3501, obj_t BgL_oz00_3502, obj_t BgL_vz00_3503)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3502)))->BgL_metazd2seqspeczd2)=((obj_t)
((obj_t)BgL_vz00_3503)),BUNSPEC);} 

}



/* &lambda2504 */
obj_t BGl_z62lambda2504z62zz__multimediazd2midizd2(obj_t BgL_envz00_3504, obj_t BgL_oz00_3505)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3505)))->BgL_metazd2seqspeczd2);} 

}



/* &<@anonymous:2499> */
obj_t BGl_z62zc3z04anonymousza32499ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3506)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2498 */
obj_t BGl_z62lambda2498z62zz__multimediazd2midizd2(obj_t BgL_envz00_3507, obj_t BgL_oz00_3508, obj_t BgL_vz00_3509)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3508)))->BgL_metazd2keysigzd2)=((obj_t)
((obj_t)BgL_vz00_3509)),BUNSPEC);} 

}



/* &lambda2497 */
obj_t BGl_z62lambda2497z62zz__multimediazd2midizd2(obj_t BgL_envz00_3510, obj_t BgL_oz00_3511)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3511)))->BgL_metazd2keysigzd2);} 

}



/* &<@anonymous:2491> */
obj_t BGl_z62zc3z04anonymousza32491ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3512)
{
{ /* Llib/midi.scm 52 */
return BGl_proc3298z00zz__multimediazd2midizd2;} 

}



/* &lambda2490 */
obj_t BGl_z62lambda2490z62zz__multimediazd2midizd2(obj_t BgL_envz00_3513, obj_t BgL_oz00_3514, obj_t BgL_vz00_3515)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3514)))->BgL_metazd2timesigzd2)=((obj_t)
((obj_t)BgL_vz00_3515)),BUNSPEC);} 

}



/* &lambda2489 */
obj_t BGl_z62lambda2489z62zz__multimediazd2midizd2(obj_t BgL_envz00_3516, obj_t BgL_oz00_3517)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3517)))->BgL_metazd2timesigzd2);} 

}



/* &<@anonymous:2492> */
obj_t BGl_z62zc3z04anonymousza32492ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3518, obj_t BgL_mpz00_3519, obj_t BgL_msz00_3520, obj_t BgL_tickz00_3521, obj_t BgL_nnz00_3522, obj_t BgL_ddz00_3523, obj_t BgL_ccz00_3524, obj_t BgL_bbz00_3525)
{
{ /* Llib/midi.scm 83 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:2483> */
obj_t BGl_z62zc3z04anonymousza32483ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3526)
{
{ /* Llib/midi.scm 52 */
return BGl_proc3299z00zz__multimediazd2midizd2;} 

}



/* &lambda2482 */
obj_t BGl_z62lambda2482z62zz__multimediazd2midizd2(obj_t BgL_envz00_3527, obj_t BgL_oz00_3528, obj_t BgL_vz00_3529)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3528)))->BgL_metazd2smtpezd2)=((obj_t)
((obj_t)BgL_vz00_3529)),BUNSPEC);} 

}



/* &lambda2481 */
obj_t BGl_z62lambda2481z62zz__multimediazd2midizd2(obj_t BgL_envz00_3530, obj_t BgL_oz00_3531)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3531)))->BgL_metazd2smtpezd2);} 

}



/* &<@anonymous:2484> */
obj_t BGl_z62zc3z04anonymousza32484ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3532, obj_t BgL_mpz00_3533, obj_t BgL_msz00_3534, obj_t BgL_tickz00_3535, obj_t BgL_hrz00_3536, obj_t BgL_mmz00_3537, obj_t BgL_sez00_3538, obj_t BgL_frz00_3539, obj_t BgL_ffz00_3540)
{
{ /* Llib/midi.scm 82 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:2476> */
obj_t BGl_z62zc3z04anonymousza32476ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3541)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2475 */
obj_t BGl_z62lambda2475z62zz__multimediazd2midizd2(obj_t BgL_envz00_3542, obj_t BgL_oz00_3543, obj_t BgL_vz00_3544)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3543)))->BgL_metazd2tempozd2)=((obj_t)
((obj_t)BgL_vz00_3544)),BUNSPEC);} 

}



/* &lambda2474 */
obj_t BGl_z62lambda2474z62zz__multimediazd2midizd2(obj_t BgL_envz00_3545, obj_t BgL_oz00_3546)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3546)))->BgL_metazd2tempozd2);} 

}



/* &<@anonymous:2469> */
obj_t BGl_z62zc3z04anonymousza32469ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3547)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2468 */
obj_t BGl_z62lambda2468z62zz__multimediazd2midizd2(obj_t BgL_envz00_3548, obj_t BgL_oz00_3549, obj_t BgL_vz00_3550)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3549)))->BgL_metazd2eotzd2)=((obj_t)
((obj_t)BgL_vz00_3550)),BUNSPEC);} 

}



/* &lambda2467 */
obj_t BGl_z62lambda2467z62zz__multimediazd2midizd2(obj_t BgL_envz00_3551, obj_t BgL_oz00_3552)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3552)))->BgL_metazd2eotzd2);} 

}



/* &<@anonymous:2462> */
obj_t BGl_z62zc3z04anonymousza32462ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3553)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2461 */
obj_t BGl_z62lambda2461z62zz__multimediazd2midizd2(obj_t BgL_envz00_3554, obj_t BgL_oz00_3555, obj_t BgL_vz00_3556)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3555)))->BgL_metazd2midiportzd2)=((obj_t)
((obj_t)BgL_vz00_3556)),BUNSPEC);} 

}



/* &lambda2460 */
obj_t BGl_z62lambda2460z62zz__multimediazd2midizd2(obj_t BgL_envz00_3557, obj_t BgL_oz00_3558)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3558)))->BgL_metazd2midiportzd2);} 

}



/* &<@anonymous:2455> */
obj_t BGl_z62zc3z04anonymousza32455ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3559)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2454 */
obj_t BGl_z62lambda2454z62zz__multimediazd2midizd2(obj_t BgL_envz00_3560, obj_t BgL_oz00_3561, obj_t BgL_vz00_3562)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3561)))->BgL_metazd2channprefzd2)=((obj_t)
((obj_t)BgL_vz00_3562)),BUNSPEC);} 

}



/* &lambda2453 */
obj_t BGl_z62lambda2453z62zz__multimediazd2midizd2(obj_t BgL_envz00_3563, obj_t BgL_oz00_3564)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3564)))->BgL_metazd2channprefzd2);} 

}



/* &<@anonymous:2448> */
obj_t BGl_z62zc3z04anonymousza32448ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3565)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2447 */
obj_t BGl_z62lambda2447z62zz__multimediazd2midizd2(obj_t BgL_envz00_3566, obj_t BgL_oz00_3567, obj_t BgL_vz00_3568)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3567)))->BgL_metazd2devnamezd2)=((obj_t)
((obj_t)BgL_vz00_3568)),BUNSPEC);} 

}



/* &lambda2446 */
obj_t BGl_z62lambda2446z62zz__multimediazd2midizd2(obj_t BgL_envz00_3569, obj_t BgL_oz00_3570)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3570)))->BgL_metazd2devnamezd2);} 

}



/* &<@anonymous:2441> */
obj_t BGl_z62zc3z04anonymousza32441ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3571)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2440 */
obj_t BGl_z62lambda2440z62zz__multimediazd2midizd2(obj_t BgL_envz00_3572, obj_t BgL_oz00_3573, obj_t BgL_vz00_3574)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3573)))->BgL_metazd2prgmnamezd2)=((obj_t)
((obj_t)BgL_vz00_3574)),BUNSPEC);} 

}



/* &lambda2439 */
obj_t BGl_z62lambda2439z62zz__multimediazd2midizd2(obj_t BgL_envz00_3575, obj_t BgL_oz00_3576)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3576)))->BgL_metazd2prgmnamezd2);} 

}



/* &<@anonymous:2434> */
obj_t BGl_z62zc3z04anonymousza32434ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3577)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2433 */
obj_t BGl_z62lambda2433z62zz__multimediazd2midizd2(obj_t BgL_envz00_3578, obj_t BgL_oz00_3579, obj_t BgL_vz00_3580)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3579)))->BgL_metazd2cuezd2)=((obj_t)
((obj_t)BgL_vz00_3580)),BUNSPEC);} 

}



/* &lambda2432 */
obj_t BGl_z62lambda2432z62zz__multimediazd2midizd2(obj_t BgL_envz00_3581, obj_t BgL_oz00_3582)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3582)))->BgL_metazd2cuezd2);} 

}



/* &<@anonymous:2427> */
obj_t BGl_z62zc3z04anonymousza32427ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3583)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2426 */
obj_t BGl_z62lambda2426z62zz__multimediazd2midizd2(obj_t BgL_envz00_3584, obj_t BgL_oz00_3585, obj_t BgL_vz00_3586)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3585)))->BgL_metazd2markerzd2)=((obj_t)
((obj_t)BgL_vz00_3586)),BUNSPEC);} 

}



/* &lambda2425 */
obj_t BGl_z62lambda2425z62zz__multimediazd2midizd2(obj_t BgL_envz00_3587, obj_t BgL_oz00_3588)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3588)))->BgL_metazd2markerzd2);} 

}



/* &<@anonymous:2420> */
obj_t BGl_z62zc3z04anonymousza32420ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3589)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2419 */
obj_t BGl_z62lambda2419z62zz__multimediazd2midizd2(obj_t BgL_envz00_3590, obj_t BgL_oz00_3591, obj_t BgL_vz00_3592)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3591)))->BgL_metazd2lyriczd2)=((obj_t)
((obj_t)BgL_vz00_3592)),BUNSPEC);} 

}



/* &lambda2418 */
obj_t BGl_z62lambda2418z62zz__multimediazd2midizd2(obj_t BgL_envz00_3593, obj_t BgL_oz00_3594)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3594)))->BgL_metazd2lyriczd2);} 

}



/* &<@anonymous:2413> */
obj_t BGl_z62zc3z04anonymousza32413ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3595)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2412 */
obj_t BGl_z62lambda2412z62zz__multimediazd2midizd2(obj_t BgL_envz00_3596, obj_t BgL_oz00_3597, obj_t BgL_vz00_3598)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3597)))->BgL_metazd2instrumentzd2)=((obj_t)
((obj_t)BgL_vz00_3598)),BUNSPEC);} 

}



/* &lambda2411 */
obj_t BGl_z62lambda2411z62zz__multimediazd2midizd2(obj_t BgL_envz00_3599, obj_t BgL_oz00_3600)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3600)))->BgL_metazd2instrumentzd2);} 

}



/* &<@anonymous:2406> */
obj_t BGl_z62zc3z04anonymousza32406ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3601)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2405 */
obj_t BGl_z62lambda2405z62zz__multimediazd2midizd2(obj_t BgL_envz00_3602, obj_t BgL_oz00_3603, obj_t BgL_vz00_3604)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3603)))->BgL_metazd2trackzd2)=((obj_t)
((obj_t)BgL_vz00_3604)),BUNSPEC);} 

}



/* &lambda2404 */
obj_t BGl_z62lambda2404z62zz__multimediazd2midizd2(obj_t BgL_envz00_3605, obj_t BgL_oz00_3606)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3606)))->BgL_metazd2trackzd2);} 

}



/* &<@anonymous:2399> */
obj_t BGl_z62zc3z04anonymousza32399ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3607)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2398 */
obj_t BGl_z62lambda2398z62zz__multimediazd2midizd2(obj_t BgL_envz00_3608, obj_t BgL_oz00_3609, obj_t BgL_vz00_3610)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3609)))->BgL_metazd2copyrightzd2)=((obj_t)
((obj_t)BgL_vz00_3610)),BUNSPEC);} 

}



/* &lambda2397 */
obj_t BGl_z62lambda2397z62zz__multimediazd2midizd2(obj_t BgL_envz00_3611, obj_t BgL_oz00_3612)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3612)))->BgL_metazd2copyrightzd2);} 

}



/* &<@anonymous:2392> */
obj_t BGl_z62zc3z04anonymousza32392ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3613)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2391 */
obj_t BGl_z62lambda2391z62zz__multimediazd2midizd2(obj_t BgL_envz00_3614, obj_t BgL_oz00_3615, obj_t BgL_vz00_3616)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3615)))->BgL_metazd2textzd2)=((obj_t)
((obj_t)BgL_vz00_3616)),BUNSPEC);} 

}



/* &lambda2390 */
obj_t BGl_z62lambda2390z62zz__multimediazd2midizd2(obj_t BgL_envz00_3617, obj_t BgL_oz00_3618)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3618)))->BgL_metazd2textzd2);} 

}



/* &<@anonymous:2385> */
obj_t BGl_z62zc3z04anonymousza32385ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3619)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2384 */
obj_t BGl_z62lambda2384z62zz__multimediazd2midizd2(obj_t BgL_envz00_3620, obj_t BgL_oz00_3621, obj_t BgL_vz00_3622)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3621)))->BgL_metazd2seqnumzd2)=((obj_t)
((obj_t)BgL_vz00_3622)),BUNSPEC);} 

}



/* &lambda2383 */
obj_t BGl_z62lambda2383z62zz__multimediazd2midizd2(obj_t BgL_envz00_3623, obj_t BgL_oz00_3624)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3624)))->BgL_metazd2seqnumzd2);} 

}



/* &<@anonymous:2378> */
obj_t BGl_z62zc3z04anonymousza32378ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3625)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2sysexzd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2377 */
obj_t BGl_z62lambda2377z62zz__multimediazd2midizd2(obj_t BgL_envz00_3626, obj_t BgL_oz00_3627, obj_t BgL_vz00_3628)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3627)))->BgL_sysexz00)=((obj_t)
((obj_t)BgL_vz00_3628)),BUNSPEC);} 

}



/* &lambda2376 */
obj_t BGl_z62lambda2376z62zz__multimediazd2midizd2(obj_t BgL_envz00_3629, obj_t BgL_oz00_3630)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3630)))->BgL_sysexz00);} 

}



/* &<@anonymous:2371> */
obj_t BGl_z62zc3z04anonymousza32371ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3631)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2pitchzd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2370 */
obj_t BGl_z62lambda2370z62zz__multimediazd2midizd2(obj_t BgL_envz00_3632, obj_t BgL_oz00_3633, obj_t BgL_vz00_3634)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3633)))->BgL_pitchz00)=((obj_t)
((obj_t)BgL_vz00_3634)),BUNSPEC);} 

}



/* &lambda2369 */
obj_t BGl_z62lambda2369z62zz__multimediazd2midizd2(obj_t BgL_envz00_3635, obj_t BgL_oz00_3636)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3636)))->BgL_pitchz00);} 

}



/* &<@anonymous:2364> */
obj_t BGl_z62zc3z04anonymousza32364ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3637)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2afterzd2touchzd2envzd2zz__multimediazd2midizd2;} 

}



/* &lambda2363 */
obj_t BGl_z62lambda2363z62zz__multimediazd2midizd2(obj_t BgL_envz00_3638, obj_t BgL_oz00_3639, obj_t BgL_vz00_3640)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3639)))->BgL_afterzd2touchzd2)=((obj_t)
((obj_t)BgL_vz00_3640)),BUNSPEC);} 

}



/* &lambda2362 */
obj_t BGl_z62lambda2362z62zz__multimediazd2midizd2(obj_t BgL_envz00_3641, obj_t BgL_oz00_3642)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3642)))->BgL_afterzd2touchzd2);} 

}



/* &<@anonymous:2357> */
obj_t BGl_z62zc3z04anonymousza32357ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3643)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2prgmchangezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2356 */
obj_t BGl_z62lambda2356z62zz__multimediazd2midizd2(obj_t BgL_envz00_3644, obj_t BgL_oz00_3645, obj_t BgL_vz00_3646)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3645)))->BgL_prgmchangez00)=((obj_t)
((obj_t)BgL_vz00_3646)),BUNSPEC);} 

}



/* &lambda2355 */
obj_t BGl_z62lambda2355z62zz__multimediazd2midizd2(obj_t BgL_envz00_3647, obj_t BgL_oz00_3648)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3648)))->BgL_prgmchangez00);} 

}



/* &<@anonymous:2350> */
obj_t BGl_z62zc3z04anonymousza32350ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3649)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ctrlchangezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2349 */
obj_t BGl_z62lambda2349z62zz__multimediazd2midizd2(obj_t BgL_envz00_3650, obj_t BgL_oz00_3651, obj_t BgL_vz00_3652)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3651)))->BgL_ctrlchangez00)=((obj_t)
((obj_t)BgL_vz00_3652)),BUNSPEC);} 

}



/* &lambda2348 */
obj_t BGl_z62lambda2348z62zz__multimediazd2midizd2(obj_t BgL_envz00_3653, obj_t BgL_oz00_3654)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3654)))->BgL_ctrlchangez00);} 

}



/* &<@anonymous:2343> */
obj_t BGl_z62zc3z04anonymousza32343ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3655)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2aftertouchzd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2342 */
obj_t BGl_z62lambda2342z62zz__multimediazd2midizd2(obj_t BgL_envz00_3656, obj_t BgL_oz00_3657, obj_t BgL_vz00_3658)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3657)))->BgL_aftertouchz00)=((obj_t)
((obj_t)BgL_vz00_3658)),BUNSPEC);} 

}



/* &lambda2341 */
obj_t BGl_z62lambda2341z62zz__multimediazd2midizd2(obj_t BgL_envz00_3659, obj_t BgL_oz00_3660)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3660)))->BgL_aftertouchz00);} 

}



/* &<@anonymous:2336> */
obj_t BGl_z62zc3z04anonymousza32336ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3661)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2noteonzd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2335 */
obj_t BGl_z62lambda2335z62zz__multimediazd2midizd2(obj_t BgL_envz00_3662, obj_t BgL_oz00_3663, obj_t BgL_vz00_3664)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3663)))->BgL_noteonz00)=((obj_t)
((obj_t)BgL_vz00_3664)),BUNSPEC);} 

}



/* &lambda2334 */
obj_t BGl_z62lambda2334z62zz__multimediazd2midizd2(obj_t BgL_envz00_3665, obj_t BgL_oz00_3666)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3666)))->BgL_noteonz00);} 

}



/* &<@anonymous:2329> */
obj_t BGl_z62zc3z04anonymousza32329ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3667)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2noteoffzd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2328 */
obj_t BGl_z62lambda2328z62zz__multimediazd2midizd2(obj_t BgL_envz00_3668, obj_t BgL_oz00_3669, obj_t BgL_vz00_3670)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3669)))->BgL_noteoffz00)=((obj_t)
((obj_t)BgL_vz00_3670)),BUNSPEC);} 

}



/* &lambda2327 */
obj_t BGl_z62lambda2327z62zz__multimediazd2midizd2(obj_t BgL_envz00_3671, obj_t BgL_oz00_3672)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3672)))->BgL_noteoffz00);} 

}



/* &<@anonymous:2322> */
obj_t BGl_z62zc3z04anonymousza32322ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3673)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2cdelayzd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2321 */
obj_t BGl_z62lambda2321z62zz__multimediazd2midizd2(obj_t BgL_envz00_3674, obj_t BgL_oz00_3675, obj_t BgL_vz00_3676)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3675)))->BgL_cdelayz00)=((obj_t)
((obj_t)BgL_vz00_3676)),BUNSPEC);} 

}



/* &lambda2320 */
obj_t BGl_z62lambda2320z62zz__multimediazd2midizd2(obj_t BgL_envz00_3677, obj_t BgL_oz00_3678)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3678)))->BgL_cdelayz00);} 

}



/* &<@anonymous:2315> */
obj_t BGl_z62zc3z04anonymousza32315ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3679)
{
{ /* Llib/midi.scm 52 */
return BGl_errorzd2envzd2zz__errorz00;} 

}



/* &lambda2314 */
obj_t BGl_z62lambda2314z62zz__multimediazd2midizd2(obj_t BgL_envz00_3680, obj_t BgL_oz00_3681, obj_t BgL_vz00_3682)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3681)))->BgL_errz00)=((obj_t)
((obj_t)BgL_vz00_3682)),BUNSPEC);} 

}



/* &lambda2313 */
obj_t BGl_z62lambda2313z62zz__multimediazd2midizd2(obj_t BgL_envz00_3683, obj_t BgL_oz00_3684)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3684)))->BgL_errz00);} 

}



/* &<@anonymous:2262> */
obj_t BGl_z62zc3z04anonymousza32262ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3685, obj_t BgL_new1080z00_3686)
{
{ /* Llib/midi.scm 42 */
{ 
BgL_midireaderz00_bglt BgL_auxz00_7760;
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_new1080z00_3686)))->BgL_peekzd2bytezd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_new1080z00_3686)))->BgL_readzd2bytezd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_new1080z00_3686)))->BgL_readzd2int16zd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_new1080z00_3686)))->BgL_readzd2int32zd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_new1080z00_3686)))->BgL_readzd2intzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_new1080z00_3686)))->BgL_readzd2vlqzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_new1080z00_3686)))->BgL_readzd2charszd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
BgL_auxz00_7760 = 
((BgL_midireaderz00_bglt)BgL_new1080z00_3686); 
return 
((obj_t)BgL_auxz00_7760);} } 

}



/* &lambda2260 */
BgL_midireaderz00_bglt BGl_z62lambda2260z62zz__multimediazd2midizd2(obj_t BgL_envz00_3687)
{
{ /* Llib/midi.scm 42 */
{ /* Llib/midi.scm 42 */
BgL_midireaderz00_bglt BgL_new1079z00_4352;
BgL_new1079z00_4352 = 
((BgL_midireaderz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midireaderz00_bgl) ))); 
{ /* Llib/midi.scm 42 */
long BgL_arg2261z00_4353;
{ /* Llib/midi.scm 42 */
long BgL_res2812z00_4354;
BgL_res2812z00_4354 = 
BGL_CLASS_INDEX(BGl_midireaderz00zz__multimediazd2midizd2); 
BgL_arg2261z00_4353 = BgL_res2812z00_4354; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1079z00_4352), BgL_arg2261z00_4353); } 
return BgL_new1079z00_4352;} } 

}



/* &lambda2257 */
BgL_midireaderz00_bglt BGl_z62lambda2257z62zz__multimediazd2midizd2(obj_t BgL_envz00_3688, obj_t BgL_peekzd2byte1072zd2_3689, obj_t BgL_readzd2byte1073zd2_3690, obj_t BgL_readzd2int161074zd2_3691, obj_t BgL_readzd2int321075zd2_3692, obj_t BgL_readzd2int1076zd2_3693, obj_t BgL_readzd2vlq1077zd2_3694, obj_t BgL_readzd2chars1078zd2_3695)
{
{ /* Llib/midi.scm 42 */
{ /* Llib/midi.scm 42 */
BgL_midireaderz00_bglt BgL_new1181z00_4362;
{ /* Llib/midi.scm 42 */
BgL_midireaderz00_bglt BgL_new1180z00_4363;
BgL_new1180z00_4363 = 
((BgL_midireaderz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midireaderz00_bgl) ))); 
{ /* Llib/midi.scm 42 */
long BgL_arg2259z00_4364;
{ /* Llib/midi.scm 42 */
long BgL_res2811z00_4365;
BgL_res2811z00_4365 = 
BGL_CLASS_INDEX(BGl_midireaderz00zz__multimediazd2midizd2); 
BgL_arg2259z00_4364 = BgL_res2811z00_4365; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1180z00_4363), BgL_arg2259z00_4364); } 
BgL_new1181z00_4362 = BgL_new1180z00_4363; } 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1181z00_4362))->BgL_peekzd2bytezd2)=((obj_t)
((obj_t)BgL_peekzd2byte1072zd2_3689)),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1181z00_4362))->BgL_readzd2bytezd2)=((obj_t)
((obj_t)BgL_readzd2byte1073zd2_3690)),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1181z00_4362))->BgL_readzd2int16zd2)=((obj_t)
((obj_t)BgL_readzd2int161074zd2_3691)),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1181z00_4362))->BgL_readzd2int32zd2)=((obj_t)
((obj_t)BgL_readzd2int321075zd2_3692)),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1181z00_4362))->BgL_readzd2intzd2)=((obj_t)
((obj_t)BgL_readzd2int1076zd2_3693)),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1181z00_4362))->BgL_readzd2vlqzd2)=((obj_t)
((obj_t)BgL_readzd2vlq1077zd2_3694)),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1181z00_4362))->BgL_readzd2charszd2)=((obj_t)
((obj_t)BgL_readzd2chars1078zd2_3695)),BUNSPEC); 
{ /* Llib/midi.scm 42 */
obj_t BgL_fun2258z00_4366;
BgL_fun2258z00_4366 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_midireaderz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun2258z00_4366)(BgL_fun2258z00_4366, 
((obj_t)BgL_new1181z00_4362), BEOA); } 
return BgL_new1181z00_4362;} } 

}



/* &lambda2297 */
obj_t BGl_z62lambda2297z62zz__multimediazd2midizd2(obj_t BgL_envz00_3696, obj_t BgL_oz00_3697, obj_t BgL_vz00_3698)
{
{ /* Llib/midi.scm 42 */
return 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3697)))->BgL_readzd2charszd2)=((obj_t)
((obj_t)BgL_vz00_3698)),BUNSPEC);} 

}



/* &lambda2296 */
obj_t BGl_z62lambda2296z62zz__multimediazd2midizd2(obj_t BgL_envz00_3699, obj_t BgL_oz00_3700)
{
{ /* Llib/midi.scm 42 */
return 
(((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3700)))->BgL_readzd2charszd2);} 

}



/* &lambda2292 */
obj_t BGl_z62lambda2292z62zz__multimediazd2midizd2(obj_t BgL_envz00_3701, obj_t BgL_oz00_3702, obj_t BgL_vz00_3703)
{
{ /* Llib/midi.scm 42 */
return 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3702)))->BgL_readzd2vlqzd2)=((obj_t)
((obj_t)BgL_vz00_3703)),BUNSPEC);} 

}



/* &lambda2291 */
obj_t BGl_z62lambda2291z62zz__multimediazd2midizd2(obj_t BgL_envz00_3704, obj_t BgL_oz00_3705)
{
{ /* Llib/midi.scm 42 */
return 
(((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3705)))->BgL_readzd2vlqzd2);} 

}



/* &lambda2287 */
obj_t BGl_z62lambda2287z62zz__multimediazd2midizd2(obj_t BgL_envz00_3706, obj_t BgL_oz00_3707, obj_t BgL_vz00_3708)
{
{ /* Llib/midi.scm 42 */
return 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3707)))->BgL_readzd2intzd2)=((obj_t)
((obj_t)BgL_vz00_3708)),BUNSPEC);} 

}



/* &lambda2286 */
obj_t BGl_z62lambda2286z62zz__multimediazd2midizd2(obj_t BgL_envz00_3709, obj_t BgL_oz00_3710)
{
{ /* Llib/midi.scm 42 */
return 
(((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3710)))->BgL_readzd2intzd2);} 

}



/* &lambda2282 */
obj_t BGl_z62lambda2282z62zz__multimediazd2midizd2(obj_t BgL_envz00_3711, obj_t BgL_oz00_3712, obj_t BgL_vz00_3713)
{
{ /* Llib/midi.scm 42 */
return 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3712)))->BgL_readzd2int32zd2)=((obj_t)
((obj_t)BgL_vz00_3713)),BUNSPEC);} 

}



/* &lambda2281 */
obj_t BGl_z62lambda2281z62zz__multimediazd2midizd2(obj_t BgL_envz00_3714, obj_t BgL_oz00_3715)
{
{ /* Llib/midi.scm 42 */
return 
(((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3715)))->BgL_readzd2int32zd2);} 

}



/* &lambda2277 */
obj_t BGl_z62lambda2277z62zz__multimediazd2midizd2(obj_t BgL_envz00_3716, obj_t BgL_oz00_3717, obj_t BgL_vz00_3718)
{
{ /* Llib/midi.scm 42 */
return 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3717)))->BgL_readzd2int16zd2)=((obj_t)
((obj_t)BgL_vz00_3718)),BUNSPEC);} 

}



/* &lambda2276 */
obj_t BGl_z62lambda2276z62zz__multimediazd2midizd2(obj_t BgL_envz00_3719, obj_t BgL_oz00_3720)
{
{ /* Llib/midi.scm 42 */
return 
(((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3720)))->BgL_readzd2int16zd2);} 

}



/* &lambda2272 */
obj_t BGl_z62lambda2272z62zz__multimediazd2midizd2(obj_t BgL_envz00_3721, obj_t BgL_oz00_3722, obj_t BgL_vz00_3723)
{
{ /* Llib/midi.scm 42 */
return 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3722)))->BgL_readzd2bytezd2)=((obj_t)
((obj_t)BgL_vz00_3723)),BUNSPEC);} 

}



/* &lambda2271 */
obj_t BGl_z62lambda2271z62zz__multimediazd2midizd2(obj_t BgL_envz00_3724, obj_t BgL_oz00_3725)
{
{ /* Llib/midi.scm 42 */
return 
(((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3725)))->BgL_readzd2bytezd2);} 

}



/* &lambda2267 */
obj_t BGl_z62lambda2267z62zz__multimediazd2midizd2(obj_t BgL_envz00_3726, obj_t BgL_oz00_3727, obj_t BgL_vz00_3728)
{
{ /* Llib/midi.scm 42 */
return 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3727)))->BgL_peekzd2bytezd2)=((obj_t)
((obj_t)BgL_vz00_3728)),BUNSPEC);} 

}



/* &lambda2266 */
obj_t BGl_z62lambda2266z62zz__multimediazd2midizd2(obj_t BgL_envz00_3729, obj_t BgL_oz00_3730)
{
{ /* Llib/midi.scm 42 */
return 
(((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3730)))->BgL_peekzd2bytezd2);} 

}



/* &<@anonymous:2157> */
obj_t BGl_z62zc3z04anonymousza32157ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3731, obj_t BgL_new1070z00_3732)
{
{ /* Llib/midi.scm 24 */
{ 
BgL_miditrackz00_bglt BgL_auxz00_7840;
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1070z00_3732)))->BgL_z52streamz52)=((obj_t)BUNSPEC),BUNSPEC); 
{ 
BgL_midireaderz00_bglt BgL_auxz00_7843;
{ /* Llib/midi.scm 24 */
obj_t BgL_classz00_4389;
BgL_classz00_4389 = BGl_midireaderz00zz__multimediazd2midizd2; 
{ /* Llib/midi.scm 24 */
obj_t BgL__ortest_1107z00_4390;
BgL__ortest_1107z00_4390 = 
BGL_CLASS_NIL(BgL_classz00_4389); 
if(
CBOOL(BgL__ortest_1107z00_4390))
{ /* Llib/midi.scm 24 */
BgL_auxz00_7843 = 
((BgL_midireaderz00_bglt)BgL__ortest_1107z00_4390)
; }  else 
{ /* Llib/midi.scm 24 */
BgL_auxz00_7843 = 
((BgL_midireaderz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4389))
; } } } 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1070z00_3732)))->BgL_z52readerz52)=((BgL_midireaderz00_bglt)BgL_auxz00_7843),BUNSPEC); } 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1070z00_3732)))->BgL_z52closez52)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1070z00_3732)))->BgL_z52eotz52)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1070z00_3732)))->BgL_z52wtickz52)=((uint32_t)
0L),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1070z00_3732)))->BgL_z52statusz52)=((long)((long)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1070z00_3732)))->BgL_lenz00)=((int32_t)
0L),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1070z00_3732)))->BgL_tempoz00)=((long)((long)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1070z00_3732)))->BgL_ipz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1070z00_3732)))->BgL_startz00)=((long)((long)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1070z00_3732)))->BgL_datastartz00)=((long)((long)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1070z00_3732)))->BgL_wtickz00)=((uint32_t)
0L),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1070z00_3732)))->BgL_statusz00)=((long)((long)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1070z00_3732)))->BgL_eotz00)=((bool_t)((bool_t)0)),BUNSPEC); 
BgL_auxz00_7840 = 
((BgL_miditrackz00_bglt)BgL_new1070z00_3732); 
return 
((obj_t)BgL_auxz00_7840);} } 

}



/* &lambda2155 */
BgL_miditrackz00_bglt BGl_z62lambda2155z62zz__multimediazd2midizd2(obj_t BgL_envz00_3733)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
BgL_miditrackz00_bglt BgL_new1069z00_4391;
BgL_new1069z00_4391 = 
((BgL_miditrackz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_miditrackz00_bgl) ))); 
{ /* Llib/midi.scm 24 */
long BgL_arg2156z00_4392;
{ /* Llib/midi.scm 24 */
long BgL_res2810z00_4393;
BgL_res2810z00_4393 = 
BGL_CLASS_INDEX(BGl_miditrackz00zz__multimediazd2midizd2); 
BgL_arg2156z00_4392 = BgL_res2810z00_4393; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1069z00_4391), BgL_arg2156z00_4392); } 
return BgL_new1069z00_4391;} } 

}



/* &lambda2152 */
BgL_miditrackz00_bglt BGl_z62lambda2152z62zz__multimediazd2midizd2(obj_t BgL_envz00_3734, obj_t BgL_z52stream1055z52_3735, obj_t BgL_z52reader1056z52_3736, obj_t BgL_z52close1057z52_3737, obj_t BgL_z52eot1058z52_3738, obj_t BgL_z52wtick1059z52_3739, obj_t BgL_z52status1060z52_3740, obj_t BgL_len1061z00_3741, obj_t BgL_tempo1062z00_3742, obj_t BgL_ip1063z00_3743, obj_t BgL_start1064z00_3744, obj_t BgL_datastart1065z00_3745, obj_t BgL_wtick1066z00_3746, obj_t BgL_status1067z00_3747, obj_t BgL_eot1068z00_3748)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
bool_t BgL_z52eot1058z52_4396;uint32_t BgL_z52wtick1059z52_4397;long BgL_z52status1060z52_4398;int32_t BgL_len1061z00_4399;long BgL_tempo1062z00_4400;long BgL_start1064z00_4401;long BgL_datastart1065z00_4402;uint32_t BgL_wtick1066z00_4403;long BgL_status1067z00_4404;bool_t BgL_eot1068z00_4405;
BgL_z52eot1058z52_4396 = 
CBOOL(BgL_z52eot1058z52_3738); 
BgL_z52wtick1059z52_4397 = 
BGL_BUINT32_TO_UINT32(BgL_z52wtick1059z52_3739); 
BgL_z52status1060z52_4398 = 
(long)CINT(BgL_z52status1060z52_3740); 
BgL_len1061z00_4399 = 
BGL_BINT32_TO_INT32(BgL_len1061z00_3741); 
BgL_tempo1062z00_4400 = 
(long)CINT(BgL_tempo1062z00_3742); 
BgL_start1064z00_4401 = 
(long)CINT(BgL_start1064z00_3744); 
BgL_datastart1065z00_4402 = 
(long)CINT(BgL_datastart1065z00_3745); 
BgL_wtick1066z00_4403 = 
BGL_BUINT32_TO_UINT32(BgL_wtick1066z00_3746); 
BgL_status1067z00_4404 = 
(long)CINT(BgL_status1067z00_3747); 
BgL_eot1068z00_4405 = 
CBOOL(BgL_eot1068z00_3748); 
{ /* Llib/midi.scm 24 */
BgL_miditrackz00_bglt BgL_new1179z00_4406;
{ /* Llib/midi.scm 24 */
BgL_miditrackz00_bglt BgL_new1178z00_4407;
BgL_new1178z00_4407 = 
((BgL_miditrackz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_miditrackz00_bgl) ))); 
{ /* Llib/midi.scm 24 */
long BgL_arg2154z00_4408;
{ /* Llib/midi.scm 24 */
long BgL_res2809z00_4409;
BgL_res2809z00_4409 = 
BGL_CLASS_INDEX(BGl_miditrackz00zz__multimediazd2midizd2); 
BgL_arg2154z00_4408 = BgL_res2809z00_4409; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1178z00_4407), BgL_arg2154z00_4408); } 
BgL_new1179z00_4406 = BgL_new1178z00_4407; } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1179z00_4406))->BgL_z52streamz52)=((obj_t)BgL_z52stream1055z52_3735),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1179z00_4406))->BgL_z52readerz52)=((BgL_midireaderz00_bglt)
((BgL_midireaderz00_bglt)BgL_z52reader1056z52_3736)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1179z00_4406))->BgL_z52closez52)=((obj_t)
((obj_t)BgL_z52close1057z52_3737)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1179z00_4406))->BgL_z52eotz52)=((bool_t)BgL_z52eot1058z52_4396),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1179z00_4406))->BgL_z52wtickz52)=((uint32_t)BgL_z52wtick1059z52_4397),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1179z00_4406))->BgL_z52statusz52)=((long)BgL_z52status1060z52_4398),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1179z00_4406))->BgL_lenz00)=((int32_t)BgL_len1061z00_4399),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1179z00_4406))->BgL_tempoz00)=((long)BgL_tempo1062z00_4400),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1179z00_4406))->BgL_ipz00)=((obj_t)BgL_ip1063z00_3743),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1179z00_4406))->BgL_startz00)=((long)BgL_start1064z00_4401),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1179z00_4406))->BgL_datastartz00)=((long)BgL_datastart1065z00_4402),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1179z00_4406))->BgL_wtickz00)=((uint32_t)BgL_wtick1066z00_4403),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1179z00_4406))->BgL_statusz00)=((long)BgL_status1067z00_4404),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1179z00_4406))->BgL_eotz00)=((bool_t)BgL_eot1068z00_4405),BUNSPEC); 
{ /* Llib/midi.scm 24 */
obj_t BgL_fun2153z00_4410;
BgL_fun2153z00_4410 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_miditrackz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun2153z00_4410)(BgL_fun2153z00_4410, 
((obj_t)BgL_new1179z00_4406), BEOA); } 
return BgL_new1179z00_4406;} } } 

}



/* &<@anonymous:2251> */
obj_t BGl_z62zc3z04anonymousza32251ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3749)
{
{ /* Llib/midi.scm 24 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda2250 */
obj_t BGl_z62lambda2250z62zz__multimediazd2midizd2(obj_t BgL_envz00_3750, obj_t BgL_oz00_3751, obj_t BgL_vz00_3752)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
bool_t BgL_vz00_4412;
BgL_vz00_4412 = 
CBOOL(BgL_vz00_3752); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3751)))->BgL_eotz00)=((bool_t)BgL_vz00_4412),BUNSPEC);} } 

}



/* &lambda2249 */
obj_t BGl_z62lambda2249z62zz__multimediazd2midizd2(obj_t BgL_envz00_3753, obj_t BgL_oz00_3754)
{
{ /* Llib/midi.scm 24 */
return 
BBOOL(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3754)))->BgL_eotz00));} 

}



/* &<@anonymous:2244> */
obj_t BGl_z62zc3z04anonymousza32244ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3755)
{
{ /* Llib/midi.scm 24 */
return 
BINT(((long)-1));} 

}



/* &lambda2243 */
obj_t BGl_z62lambda2243z62zz__multimediazd2midizd2(obj_t BgL_envz00_3756, obj_t BgL_oz00_3757, obj_t BgL_vz00_3758)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
long BgL_vz00_4415;
BgL_vz00_4415 = 
(long)CINT(BgL_vz00_3758); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3757)))->BgL_statusz00)=((long)BgL_vz00_4415),BUNSPEC);} } 

}



/* &lambda2242 */
obj_t BGl_z62lambda2242z62zz__multimediazd2midizd2(obj_t BgL_envz00_3759, obj_t BgL_oz00_3760)
{
{ /* Llib/midi.scm 24 */
return 
BINT(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3760)))->BgL_statusz00));} 

}



/* &<@anonymous:2237> */
obj_t BGl_z62zc3z04anonymousza32237ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3761)
{
{ /* Llib/midi.scm 24 */
return 
BGL_UINT32_TO_BUINT32((uint32_t)(0));} 

}



/* &lambda2236 */
obj_t BGl_z62lambda2236z62zz__multimediazd2midizd2(obj_t BgL_envz00_3762, obj_t BgL_oz00_3763, obj_t BgL_vz00_3764)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
uint32_t BgL_vz00_4418;
BgL_vz00_4418 = 
BGL_BUINT32_TO_UINT32(BgL_vz00_3764); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3763)))->BgL_wtickz00)=((uint32_t)BgL_vz00_4418),BUNSPEC);} } 

}



/* &lambda2235 */
obj_t BGl_z62lambda2235z62zz__multimediazd2midizd2(obj_t BgL_envz00_3765, obj_t BgL_oz00_3766)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
uint32_t BgL_tmpz00_7939;
BgL_tmpz00_7939 = 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3766)))->BgL_wtickz00); 
return 
BGL_UINT32_TO_BUINT32(BgL_tmpz00_7939);} } 

}



/* &<@anonymous:2230> */
obj_t BGl_z62zc3z04anonymousza32230ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3767)
{
{ /* Llib/midi.scm 24 */
return 
BINT(((long)0));} 

}



/* &lambda2229 */
obj_t BGl_z62lambda2229z62zz__multimediazd2midizd2(obj_t BgL_envz00_3768, obj_t BgL_oz00_3769, obj_t BgL_vz00_3770)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
long BgL_vz00_4421;
BgL_vz00_4421 = 
(long)CINT(BgL_vz00_3770); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3769)))->BgL_datastartz00)=((long)BgL_vz00_4421),BUNSPEC);} } 

}



/* &lambda2228 */
obj_t BGl_z62lambda2228z62zz__multimediazd2midizd2(obj_t BgL_envz00_3771, obj_t BgL_oz00_3772)
{
{ /* Llib/midi.scm 24 */
return 
BINT(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3772)))->BgL_datastartz00));} 

}



/* &<@anonymous:2223> */
obj_t BGl_z62zc3z04anonymousza32223ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3773)
{
{ /* Llib/midi.scm 24 */
return 
BINT(((long)0));} 

}



/* &lambda2222 */
obj_t BGl_z62lambda2222z62zz__multimediazd2midizd2(obj_t BgL_envz00_3774, obj_t BgL_oz00_3775, obj_t BgL_vz00_3776)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
long BgL_vz00_4424;
BgL_vz00_4424 = 
(long)CINT(BgL_vz00_3776); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3775)))->BgL_startz00)=((long)BgL_vz00_4424),BUNSPEC);} } 

}



/* &lambda2221 */
obj_t BGl_z62lambda2221z62zz__multimediazd2midizd2(obj_t BgL_envz00_3777, obj_t BgL_oz00_3778)
{
{ /* Llib/midi.scm 24 */
return 
BINT(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3778)))->BgL_startz00));} 

}



/* &<@anonymous:2216> */
obj_t BGl_z62zc3z04anonymousza32216ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3779)
{
{ /* Llib/midi.scm 24 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda2215 */
obj_t BGl_z62lambda2215z62zz__multimediazd2midizd2(obj_t BgL_envz00_3780, obj_t BgL_oz00_3781, obj_t BgL_vz00_3782)
{
{ /* Llib/midi.scm 24 */
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3781)))->BgL_ipz00)=((obj_t)BgL_vz00_3782),BUNSPEC);} 

}



/* &lambda2214 */
obj_t BGl_z62lambda2214z62zz__multimediazd2midizd2(obj_t BgL_envz00_3783, obj_t BgL_oz00_3784)
{
{ /* Llib/midi.scm 24 */
return 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3784)))->BgL_ipz00);} 

}



/* &<@anonymous:2209> */
obj_t BGl_z62zc3z04anonymousza32209ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3785)
{
{ /* Llib/midi.scm 24 */
return 
BINT(((long)500000));} 

}



/* &lambda2208 */
obj_t BGl_z62lambda2208z62zz__multimediazd2midizd2(obj_t BgL_envz00_3786, obj_t BgL_oz00_3787, obj_t BgL_vz00_3788)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
long BgL_vz00_4429;
BgL_vz00_4429 = 
(long)CINT(BgL_vz00_3788); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3787)))->BgL_tempoz00)=((long)BgL_vz00_4429),BUNSPEC);} } 

}



/* &lambda2207 */
obj_t BGl_z62lambda2207z62zz__multimediazd2midizd2(obj_t BgL_envz00_3789, obj_t BgL_oz00_3790)
{
{ /* Llib/midi.scm 24 */
return 
BINT(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3790)))->BgL_tempoz00));} 

}



/* &<@anonymous:2202> */
obj_t BGl_z62zc3z04anonymousza32202ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3791)
{
{ /* Llib/midi.scm 24 */
return 
BINT(((long)0));} 

}



/* &lambda2201 */
obj_t BGl_z62lambda2201z62zz__multimediazd2midizd2(obj_t BgL_envz00_3792, obj_t BgL_oz00_3793, obj_t BgL_vz00_3794)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
int32_t BgL_vz00_4432;
BgL_vz00_4432 = 
BGL_BINT32_TO_INT32(BgL_vz00_3794); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3793)))->BgL_lenz00)=((int32_t)BgL_vz00_4432),BUNSPEC);} } 

}



/* &lambda2200 */
obj_t BGl_z62lambda2200z62zz__multimediazd2midizd2(obj_t BgL_envz00_3795, obj_t BgL_oz00_3796)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
int32_t BgL_tmpz00_7973;
BgL_tmpz00_7973 = 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3796)))->BgL_lenz00); 
return 
BGL_INT32_TO_BINT32(BgL_tmpz00_7973);} } 

}



/* &<@anonymous:2195> */
obj_t BGl_z62zc3z04anonymousza32195ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3797)
{
{ /* Llib/midi.scm 24 */
return 
BINT(((long)0));} 

}



/* &lambda2194 */
obj_t BGl_z62lambda2194z62zz__multimediazd2midizd2(obj_t BgL_envz00_3798, obj_t BgL_oz00_3799, obj_t BgL_vz00_3800)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
long BgL_vz00_4435;
BgL_vz00_4435 = 
(long)CINT(BgL_vz00_3800); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3799)))->BgL_z52statusz52)=((long)BgL_vz00_4435),BUNSPEC);} } 

}



/* &lambda2193 */
obj_t BGl_z62lambda2193z62zz__multimediazd2midizd2(obj_t BgL_envz00_3801, obj_t BgL_oz00_3802)
{
{ /* Llib/midi.scm 24 */
return 
BINT(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3802)))->BgL_z52statusz52));} 

}



/* &<@anonymous:2188> */
obj_t BGl_z62zc3z04anonymousza32188ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3803)
{
{ /* Llib/midi.scm 24 */
return 
BGL_UINT32_TO_BUINT32((uint32_t)(0));} 

}



/* &lambda2187 */
obj_t BGl_z62lambda2187z62zz__multimediazd2midizd2(obj_t BgL_envz00_3804, obj_t BgL_oz00_3805, obj_t BgL_vz00_3806)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
uint32_t BgL_vz00_4438;
BgL_vz00_4438 = 
BGL_BUINT32_TO_UINT32(BgL_vz00_3806); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3805)))->BgL_z52wtickz52)=((uint32_t)BgL_vz00_4438),BUNSPEC);} } 

}



/* &lambda2186 */
obj_t BGl_z62lambda2186z62zz__multimediazd2midizd2(obj_t BgL_envz00_3807, obj_t BgL_oz00_3808)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
uint32_t BgL_tmpz00_7988;
BgL_tmpz00_7988 = 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3808)))->BgL_z52wtickz52); 
return 
BGL_UINT32_TO_BUINT32(BgL_tmpz00_7988);} } 

}



/* &<@anonymous:2181> */
obj_t BGl_z62zc3z04anonymousza32181ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3809)
{
{ /* Llib/midi.scm 24 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda2180 */
obj_t BGl_z62lambda2180z62zz__multimediazd2midizd2(obj_t BgL_envz00_3810, obj_t BgL_oz00_3811, obj_t BgL_vz00_3812)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
bool_t BgL_vz00_4441;
BgL_vz00_4441 = 
CBOOL(BgL_vz00_3812); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3811)))->BgL_z52eotz52)=((bool_t)BgL_vz00_4441),BUNSPEC);} } 

}



/* &lambda2179 */
obj_t BGl_z62lambda2179z62zz__multimediazd2midizd2(obj_t BgL_envz00_3813, obj_t BgL_oz00_3814)
{
{ /* Llib/midi.scm 24 */
return 
BBOOL(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3814)))->BgL_z52eotz52));} 

}



/* &lambda2174 */
obj_t BGl_z62lambda2174z62zz__multimediazd2midizd2(obj_t BgL_envz00_3815, obj_t BgL_oz00_3816, obj_t BgL_vz00_3817)
{
{ /* Llib/midi.scm 24 */
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3816)))->BgL_z52closez52)=((obj_t)
((obj_t)BgL_vz00_3817)),BUNSPEC);} 

}



/* &lambda2173 */
obj_t BGl_z62lambda2173z62zz__multimediazd2midizd2(obj_t BgL_envz00_3818, obj_t BgL_oz00_3819)
{
{ /* Llib/midi.scm 24 */
return 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3819)))->BgL_z52closez52);} 

}



/* &lambda2169 */
obj_t BGl_z62lambda2169z62zz__multimediazd2midizd2(obj_t BgL_envz00_3820, obj_t BgL_oz00_3821, obj_t BgL_vz00_3822)
{
{ /* Llib/midi.scm 24 */
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3821)))->BgL_z52readerz52)=((BgL_midireaderz00_bglt)
((BgL_midireaderz00_bglt)BgL_vz00_3822)),BUNSPEC);} 

}



/* &lambda2168 */
BgL_midireaderz00_bglt BGl_z62lambda2168z62zz__multimediazd2midizd2(obj_t BgL_envz00_3823, obj_t BgL_oz00_3824)
{
{ /* Llib/midi.scm 24 */
return 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3824)))->BgL_z52readerz52);} 

}



/* &<@anonymous:2164> */
obj_t BGl_z62zc3z04anonymousza32164ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3825)
{
{ /* Llib/midi.scm 24 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda2163 */
obj_t BGl_z62lambda2163z62zz__multimediazd2midizd2(obj_t BgL_envz00_3826, obj_t BgL_oz00_3827, obj_t BgL_vz00_3828)
{
{ /* Llib/midi.scm 24 */
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3827)))->BgL_z52streamz52)=((obj_t)BgL_vz00_3828),BUNSPEC);} 

}



/* &lambda2162 */
obj_t BGl_z62lambda2162z62zz__multimediazd2midizd2(obj_t BgL_envz00_3829, obj_t BgL_oz00_3830)
{
{ /* Llib/midi.scm 24 */
return 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3830)))->BgL_z52streamz52);} 

}



/* &<@anonymous:2120> */
obj_t BGl_z62zc3z04anonymousza32120ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3831, obj_t BgL_new1053z00_3832)
{
{ /* Llib/midi.scm 17 */
{ 
BgL_midiscorez00_bglt BgL_auxz00_8014;
((((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_new1053z00_3832)))->BgL_formatz00)=((long)((long)0)),BUNSPEC); 
((((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_new1053z00_3832)))->BgL_tempoz00)=((long)((long)0)),BUNSPEC); 
((((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_new1053z00_3832)))->BgL_ppqz00)=((long)((long)0)),BUNSPEC); 
((((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_new1053z00_3832)))->BgL_tracksz00)=((obj_t)
CNST_TABLE_REF(((long)75))),BUNSPEC); 
BgL_auxz00_8014 = 
((BgL_midiscorez00_bglt)BgL_new1053z00_3832); 
return 
((obj_t)BgL_auxz00_8014);} } 

}



/* &lambda2118 */
BgL_midiscorez00_bglt BGl_z62lambda2118z62zz__multimediazd2midizd2(obj_t BgL_envz00_3833)
{
{ /* Llib/midi.scm 17 */
{ /* Llib/midi.scm 17 */
BgL_midiscorez00_bglt BgL_new1052z00_4452;
BgL_new1052z00_4452 = 
((BgL_midiscorez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midiscorez00_bgl) ))); 
{ /* Llib/midi.scm 17 */
long BgL_arg2119z00_4453;
{ /* Llib/midi.scm 17 */
long BgL_res2808z00_4454;
BgL_res2808z00_4454 = 
BGL_CLASS_INDEX(BGl_midiscorez00zz__multimediazd2midizd2); 
BgL_arg2119z00_4453 = BgL_res2808z00_4454; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1052z00_4452), BgL_arg2119z00_4453); } 
return BgL_new1052z00_4452;} } 

}



/* &lambda2115 */
BgL_midiscorez00_bglt BGl_z62lambda2115z62zz__multimediazd2midizd2(obj_t BgL_envz00_3834, obj_t BgL_format1048z00_3835, obj_t BgL_tempo1049z00_3836, obj_t BgL_ppq1050z00_3837, obj_t BgL_tracks1051z00_3838)
{
{ /* Llib/midi.scm 17 */
{ /* Llib/midi.scm 17 */
long BgL_format1048z00_4455;long BgL_tempo1049z00_4456;long BgL_ppq1050z00_4457;
BgL_format1048z00_4455 = 
(long)CINT(BgL_format1048z00_3835); 
BgL_tempo1049z00_4456 = 
(long)CINT(BgL_tempo1049z00_3836); 
BgL_ppq1050z00_4457 = 
(long)CINT(BgL_ppq1050z00_3837); 
{ /* Llib/midi.scm 17 */
BgL_midiscorez00_bglt BgL_new1177z00_4459;
{ /* Llib/midi.scm 17 */
BgL_midiscorez00_bglt BgL_new1176z00_4460;
BgL_new1176z00_4460 = 
((BgL_midiscorez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midiscorez00_bgl) ))); 
{ /* Llib/midi.scm 17 */
long BgL_arg2117z00_4461;
{ /* Llib/midi.scm 17 */
long BgL_res2807z00_4462;
BgL_res2807z00_4462 = 
BGL_CLASS_INDEX(BGl_midiscorez00zz__multimediazd2midizd2); 
BgL_arg2117z00_4461 = BgL_res2807z00_4462; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1176z00_4460), BgL_arg2117z00_4461); } 
BgL_new1177z00_4459 = BgL_new1176z00_4460; } 
((((BgL_midiscorez00_bglt)COBJECT(BgL_new1177z00_4459))->BgL_formatz00)=((long)BgL_format1048z00_4455),BUNSPEC); 
((((BgL_midiscorez00_bglt)COBJECT(BgL_new1177z00_4459))->BgL_tempoz00)=((long)BgL_tempo1049z00_4456),BUNSPEC); 
((((BgL_midiscorez00_bglt)COBJECT(BgL_new1177z00_4459))->BgL_ppqz00)=((long)BgL_ppq1050z00_4457),BUNSPEC); 
((((BgL_midiscorez00_bglt)COBJECT(BgL_new1177z00_4459))->BgL_tracksz00)=((obj_t)
((obj_t)BgL_tracks1051z00_3838)),BUNSPEC); 
{ /* Llib/midi.scm 17 */
obj_t BgL_fun2116z00_4463;
BgL_fun2116z00_4463 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_midiscorez00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun2116z00_4463)(BgL_fun2116z00_4463, 
((obj_t)BgL_new1177z00_4459), BEOA); } 
return BgL_new1177z00_4459;} } } 

}



/* &<@anonymous:2146> */
obj_t BGl_z62zc3z04anonymousza32146ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3839)
{
{ /* Llib/midi.scm 17 */
return 
CNST_TABLE_REF(((long)75));} 

}



/* &lambda2145 */
obj_t BGl_z62lambda2145z62zz__multimediazd2midizd2(obj_t BgL_envz00_3840, obj_t BgL_oz00_3841, obj_t BgL_vz00_3842)
{
{ /* Llib/midi.scm 17 */
return 
((((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_oz00_3841)))->BgL_tracksz00)=((obj_t)
((obj_t)BgL_vz00_3842)),BUNSPEC);} 

}



/* &lambda2144 */
obj_t BGl_z62lambda2144z62zz__multimediazd2midizd2(obj_t BgL_envz00_3843, obj_t BgL_oz00_3844)
{
{ /* Llib/midi.scm 17 */
return 
(((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_oz00_3844)))->BgL_tracksz00);} 

}



/* &<@anonymous:2139> */
obj_t BGl_z62zc3z04anonymousza32139ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3845)
{
{ /* Llib/midi.scm 17 */
return 
BINT(((long)96));} 

}



/* &lambda2138 */
obj_t BGl_z62lambda2138z62zz__multimediazd2midizd2(obj_t BgL_envz00_3846, obj_t BgL_oz00_3847, obj_t BgL_vz00_3848)
{
{ /* Llib/midi.scm 17 */
{ /* Llib/midi.scm 17 */
long BgL_vz00_4468;
BgL_vz00_4468 = 
(long)CINT(BgL_vz00_3848); 
return 
((((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_oz00_3847)))->BgL_ppqz00)=((long)BgL_vz00_4468),BUNSPEC);} } 

}



/* &lambda2137 */
obj_t BGl_z62lambda2137z62zz__multimediazd2midizd2(obj_t BgL_envz00_3849, obj_t BgL_oz00_3850)
{
{ /* Llib/midi.scm 17 */
return 
BINT(
(((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_oz00_3850)))->BgL_ppqz00));} 

}



/* &<@anonymous:2132> */
obj_t BGl_z62zc3z04anonymousza32132ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3851)
{
{ /* Llib/midi.scm 17 */
return 
BINT(((long)500000));} 

}



/* &lambda2131 */
obj_t BGl_z62lambda2131z62zz__multimediazd2midizd2(obj_t BgL_envz00_3852, obj_t BgL_oz00_3853, obj_t BgL_vz00_3854)
{
{ /* Llib/midi.scm 17 */
{ /* Llib/midi.scm 17 */
long BgL_vz00_4471;
BgL_vz00_4471 = 
(long)CINT(BgL_vz00_3854); 
return 
((((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_oz00_3853)))->BgL_tempoz00)=((long)BgL_vz00_4471),BUNSPEC);} } 

}



/* &lambda2130 */
obj_t BGl_z62lambda2130z62zz__multimediazd2midizd2(obj_t BgL_envz00_3855, obj_t BgL_oz00_3856)
{
{ /* Llib/midi.scm 17 */
return 
BINT(
(((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_oz00_3856)))->BgL_tempoz00));} 

}



/* &lambda2125 */
obj_t BGl_z62lambda2125z62zz__multimediazd2midizd2(obj_t BgL_envz00_3857, obj_t BgL_oz00_3858, obj_t BgL_vz00_3859)
{
{ /* Llib/midi.scm 17 */
{ /* Llib/midi.scm 17 */
long BgL_vz00_4474;
BgL_vz00_4474 = 
(long)CINT(BgL_vz00_3859); 
return 
((((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_oz00_3858)))->BgL_formatz00)=((long)BgL_vz00_4474),BUNSPEC);} } 

}



/* &lambda2124 */
obj_t BGl_z62lambda2124z62zz__multimediazd2midizd2(obj_t BgL_envz00_3860, obj_t BgL_oz00_3861)
{
{ /* Llib/midi.scm 17 */
return 
BINT(
(((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_oz00_3861)))->BgL_formatz00));} 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__multimediazd2midizd2()
{
{ /* Llib/midi.scm 15 */
BGl_registerzd2genericz12zc0zz__objectz00(BGl_midiscorezd2initzd2envz00zz__multimediazd2midizd2, BGl_proc3300z00zz__multimediazd2midizd2, BGl_midiscorez00zz__multimediazd2midizd2, BGl_string3301z00zz__multimediazd2midizd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_miditrackzd2initzd2envz00zz__multimediazd2midizd2, BGl_proc3302z00zz__multimediazd2midizd2, BGl_miditrackz00zz__multimediazd2midizd2, BGl_string3303z00zz__multimediazd2midizd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_midireaderzd2initzd2envz00zz__multimediazd2midizd2, BGl_proc3304z00zz__multimediazd2midizd2, BGl_midireaderz00zz__multimediazd2midizd2, BGl_string3305z00zz__multimediazd2midizd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_midiplayerzd2initzd2envz00zz__multimediazd2midizd2, BGl_proc3306z00zz__multimediazd2midizd2, BGl_midiplayerz00zz__multimediazd2midizd2, BGl_string3307z00zz__multimediazd2midizd2); 
return 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_midisinkzd2initzd2envz00zz__multimediazd2midizd2, BGl_proc3308z00zz__multimediazd2midizd2, BGl_midisinkz00zz__multimediazd2midizd2, BGl_string3309z00zz__multimediazd2midizd2);} 

}



/* &midisink-init1238 */
obj_t BGl_z62midisinkzd2init1238zb0zz__multimediazd2midizd2(obj_t BgL_envz00_3877, obj_t BgL_msinkz00_3878)
{
{ /* Llib/midi.scm 987 */
return 
((obj_t)
((BgL_midisinkz00_bglt)BgL_msinkz00_3878));} 

}



/* &midiplayer-init1236 */
obj_t BGl_z62midiplayerzd2init1236zb0zz__multimediazd2midizd2(obj_t BgL_envz00_3879, obj_t BgL_mplayerz00_3880)
{
{ /* Llib/midi.scm 981 */
return 
((obj_t)
((BgL_midiplayerz00_bglt)BgL_mplayerz00_3880));} 

}



/* &midireader-init1234 */
obj_t BGl_z62midireaderzd2init1234zb0zz__multimediazd2midizd2(obj_t BgL_envz00_3881, obj_t BgL_mreaderz00_3882)
{
{ /* Llib/midi.scm 975 */
return 
((obj_t)
((BgL_midireaderz00_bglt)BgL_mreaderz00_3882));} 

}



/* &miditrack-init1232 */
obj_t BGl_z62miditrackzd2init1232zb0zz__multimediazd2midizd2(obj_t BgL_envz00_3883, obj_t BgL_mtrackz00_3884)
{
{ /* Llib/midi.scm 969 */
return 
((obj_t)
((BgL_miditrackz00_bglt)BgL_mtrackz00_3884));} 

}



/* &midiscore-init1230 */
obj_t BGl_z62midiscorezd2init1230zb0zz__multimediazd2midizd2(obj_t BgL_envz00_3885, obj_t BgL_mscorez00_3886)
{
{ /* Llib/midi.scm 963 */
return 
((obj_t)
((BgL_midiscorez00_bglt)BgL_mscorez00_3886));} 

}



/* midiscore-init */
BGL_EXPORTED_DEF obj_t BGl_midiscorezd2initzd2zz__multimediazd2midizd2(BgL_midiscorez00_bglt BgL_mscorez00_63)
{
{ /* Llib/midi.scm 963 */
{ /* Llib/midi.scm 963 */
obj_t BgL_method1231z00_1855;
{ /* Llib/midi.scm 963 */
obj_t BgL_res2827z00_2847;
{ /* Llib/midi.scm 963 */
long BgL_objzd2classzd2numz00_2812;
{ /* Llib/midi.scm 963 */
long BgL_res2817z00_2815;
BgL_res2817z00_2815 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_mscorez00_63)); 
BgL_objzd2classzd2numz00_2812 = BgL_res2817z00_2815; } 
{ /* Llib/midi.scm 963 */
obj_t BgL_arg1745z00_2813;
BgL_arg1745z00_2813 = 
PROCEDURE_REF(BGl_midiscorezd2initzd2envz00zz__multimediazd2midizd2, 
(int)(((long)1))); 
{ /* Llib/midi.scm 963 */
int BgL_offsetz00_2817;
BgL_offsetz00_2817 = 
(int)(BgL_objzd2classzd2numz00_2812); 
{ /* Llib/midi.scm 963 */
long BgL_offsetz00_2818;
BgL_offsetz00_2818 = 
(
(long)(BgL_offsetz00_2817)-OBJECT_TYPE); 
{ /* Llib/midi.scm 963 */
long BgL_modz00_2819;
BgL_modz00_2819 = 
(BgL_offsetz00_2818 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/midi.scm 963 */
long BgL_restz00_2821;
BgL_restz00_2821 = 
(BgL_offsetz00_2818 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/midi.scm 963 */

{ /* Llib/midi.scm 963 */
obj_t BgL_bucketz00_2823;
BgL_bucketz00_2823 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_2813),BgL_modz00_2819); 
BgL_res2827z00_2847 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2823),BgL_restz00_2821); } } } } } } } } 
BgL_method1231z00_1855 = BgL_res2827z00_2847; } 
return 
PROCEDURE_ENTRY(BgL_method1231z00_1855)(BgL_method1231z00_1855, 
((obj_t)BgL_mscorez00_63), BEOA);} } 

}



/* &midiscore-init */
obj_t BGl_z62midiscorezd2initzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3862, obj_t BgL_mscorez00_3863)
{
{ /* Llib/midi.scm 963 */
{ /* Llib/midi.scm 963 */
BgL_midiscorez00_bglt BgL_auxz00_8119;
if(
BGl_isazf3zf3zz__objectz00(BgL_mscorez00_3863, BGl_midiscorez00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 963 */
BgL_auxz00_8119 = 
((BgL_midiscorez00_bglt)BgL_mscorez00_3863)
; }  else 
{ 
obj_t BgL_auxz00_8123;
BgL_auxz00_8123 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)36209)), BGl_string3310z00zz__multimediazd2midizd2, BGl_string3078z00zz__multimediazd2midizd2, BgL_mscorez00_3863); 
FAILURE(BgL_auxz00_8123,BFALSE,BFALSE);} 
return 
BGl_midiscorezd2initzd2zz__multimediazd2midizd2(BgL_auxz00_8119);} } 

}



/* miditrack-init */
BGL_EXPORTED_DEF obj_t BGl_miditrackzd2initzd2zz__multimediazd2midizd2(BgL_miditrackz00_bglt BgL_mtrackz00_64)
{
{ /* Llib/midi.scm 969 */
{ /* Llib/midi.scm 969 */
obj_t BgL_method1233z00_1856;
{ /* Llib/midi.scm 969 */
obj_t BgL_res2838z00_2884;
{ /* Llib/midi.scm 969 */
long BgL_objzd2classzd2numz00_2849;
{ /* Llib/midi.scm 969 */
long BgL_res2828z00_2852;
BgL_res2828z00_2852 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_mtrackz00_64)); 
BgL_objzd2classzd2numz00_2849 = BgL_res2828z00_2852; } 
{ /* Llib/midi.scm 969 */
obj_t BgL_arg1745z00_2850;
BgL_arg1745z00_2850 = 
PROCEDURE_REF(BGl_miditrackzd2initzd2envz00zz__multimediazd2midizd2, 
(int)(((long)1))); 
{ /* Llib/midi.scm 969 */
int BgL_offsetz00_2854;
BgL_offsetz00_2854 = 
(int)(BgL_objzd2classzd2numz00_2849); 
{ /* Llib/midi.scm 969 */
long BgL_offsetz00_2855;
BgL_offsetz00_2855 = 
(
(long)(BgL_offsetz00_2854)-OBJECT_TYPE); 
{ /* Llib/midi.scm 969 */
long BgL_modz00_2856;
BgL_modz00_2856 = 
(BgL_offsetz00_2855 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/midi.scm 969 */
long BgL_restz00_2858;
BgL_restz00_2858 = 
(BgL_offsetz00_2855 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/midi.scm 969 */

{ /* Llib/midi.scm 969 */
obj_t BgL_bucketz00_2860;
BgL_bucketz00_2860 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_2850),BgL_modz00_2856); 
BgL_res2838z00_2884 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2860),BgL_restz00_2858); } } } } } } } } 
BgL_method1233z00_1856 = BgL_res2838z00_2884; } 
return 
PROCEDURE_ENTRY(BgL_method1233z00_1856)(BgL_method1233z00_1856, 
((obj_t)BgL_mtrackz00_64), BEOA);} } 

}



/* &miditrack-init */
obj_t BGl_z62miditrackzd2initzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3864, obj_t BgL_mtrackz00_3865)
{
{ /* Llib/midi.scm 969 */
{ /* Llib/midi.scm 969 */
BgL_miditrackz00_bglt BgL_auxz00_8158;
if(
BGl_isazf3zf3zz__objectz00(BgL_mtrackz00_3865, BGl_miditrackz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 969 */
BgL_auxz00_8158 = 
((BgL_miditrackz00_bglt)BgL_mtrackz00_3865)
; }  else 
{ 
obj_t BgL_auxz00_8162;
BgL_auxz00_8162 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)36494)), BGl_string3311z00zz__multimediazd2midizd2, BGl_string3100z00zz__multimediazd2midizd2, BgL_mtrackz00_3865); 
FAILURE(BgL_auxz00_8162,BFALSE,BFALSE);} 
return 
BGl_miditrackzd2initzd2zz__multimediazd2midizd2(BgL_auxz00_8158);} } 

}



/* midireader-init */
BGL_EXPORTED_DEF obj_t BGl_midireaderzd2initzd2zz__multimediazd2midizd2(BgL_midireaderz00_bglt BgL_mreaderz00_65)
{
{ /* Llib/midi.scm 975 */
{ /* Llib/midi.scm 975 */
obj_t BgL_method1235z00_1857;
{ /* Llib/midi.scm 975 */
obj_t BgL_res2849z00_2921;
{ /* Llib/midi.scm 975 */
long BgL_objzd2classzd2numz00_2886;
{ /* Llib/midi.scm 975 */
long BgL_res2839z00_2889;
BgL_res2839z00_2889 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_mreaderz00_65)); 
BgL_objzd2classzd2numz00_2886 = BgL_res2839z00_2889; } 
{ /* Llib/midi.scm 975 */
obj_t BgL_arg1745z00_2887;
BgL_arg1745z00_2887 = 
PROCEDURE_REF(BGl_midireaderzd2initzd2envz00zz__multimediazd2midizd2, 
(int)(((long)1))); 
{ /* Llib/midi.scm 975 */
int BgL_offsetz00_2891;
BgL_offsetz00_2891 = 
(int)(BgL_objzd2classzd2numz00_2886); 
{ /* Llib/midi.scm 975 */
long BgL_offsetz00_2892;
BgL_offsetz00_2892 = 
(
(long)(BgL_offsetz00_2891)-OBJECT_TYPE); 
{ /* Llib/midi.scm 975 */
long BgL_modz00_2893;
BgL_modz00_2893 = 
(BgL_offsetz00_2892 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/midi.scm 975 */
long BgL_restz00_2895;
BgL_restz00_2895 = 
(BgL_offsetz00_2892 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/midi.scm 975 */

{ /* Llib/midi.scm 975 */
obj_t BgL_bucketz00_2897;
BgL_bucketz00_2897 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_2887),BgL_modz00_2893); 
BgL_res2849z00_2921 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2897),BgL_restz00_2895); } } } } } } } } 
BgL_method1235z00_1857 = BgL_res2849z00_2921; } 
return 
PROCEDURE_ENTRY(BgL_method1235z00_1857)(BgL_method1235z00_1857, 
((obj_t)BgL_mreaderz00_65), BEOA);} } 

}



/* &midireader-init */
obj_t BGl_z62midireaderzd2initzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3866, obj_t BgL_mreaderz00_3867)
{
{ /* Llib/midi.scm 975 */
{ /* Llib/midi.scm 975 */
BgL_midireaderz00_bglt BgL_auxz00_8197;
if(
BGl_isazf3zf3zz__objectz00(BgL_mreaderz00_3867, BGl_midireaderz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 975 */
BgL_auxz00_8197 = 
((BgL_midireaderz00_bglt)BgL_mreaderz00_3867)
; }  else 
{ 
obj_t BgL_auxz00_8201;
BgL_auxz00_8201 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)36779)), BGl_string3312z00zz__multimediazd2midizd2, BGl_string3313z00zz__multimediazd2midizd2, BgL_mreaderz00_3867); 
FAILURE(BgL_auxz00_8201,BFALSE,BFALSE);} 
return 
BGl_midireaderzd2initzd2zz__multimediazd2midizd2(BgL_auxz00_8197);} } 

}



/* midiplayer-init */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2initzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mplayerz00_66)
{
{ /* Llib/midi.scm 981 */
{ /* Llib/midi.scm 981 */
obj_t BgL_method1237z00_1858;
{ /* Llib/midi.scm 981 */
obj_t BgL_res2860z00_2958;
{ /* Llib/midi.scm 981 */
long BgL_objzd2classzd2numz00_2923;
{ /* Llib/midi.scm 981 */
long BgL_res2850z00_2926;
BgL_res2850z00_2926 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_mplayerz00_66)); 
BgL_objzd2classzd2numz00_2923 = BgL_res2850z00_2926; } 
{ /* Llib/midi.scm 981 */
obj_t BgL_arg1745z00_2924;
BgL_arg1745z00_2924 = 
PROCEDURE_REF(BGl_midiplayerzd2initzd2envz00zz__multimediazd2midizd2, 
(int)(((long)1))); 
{ /* Llib/midi.scm 981 */
int BgL_offsetz00_2928;
BgL_offsetz00_2928 = 
(int)(BgL_objzd2classzd2numz00_2923); 
{ /* Llib/midi.scm 981 */
long BgL_offsetz00_2929;
BgL_offsetz00_2929 = 
(
(long)(BgL_offsetz00_2928)-OBJECT_TYPE); 
{ /* Llib/midi.scm 981 */
long BgL_modz00_2930;
BgL_modz00_2930 = 
(BgL_offsetz00_2929 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/midi.scm 981 */
long BgL_restz00_2932;
BgL_restz00_2932 = 
(BgL_offsetz00_2929 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/midi.scm 981 */

{ /* Llib/midi.scm 981 */
obj_t BgL_bucketz00_2934;
BgL_bucketz00_2934 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_2924),BgL_modz00_2930); 
BgL_res2860z00_2958 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2934),BgL_restz00_2932); } } } } } } } } 
BgL_method1237z00_1858 = BgL_res2860z00_2958; } 
return 
PROCEDURE_ENTRY(BgL_method1237z00_1858)(BgL_method1237z00_1858, 
((obj_t)BgL_mplayerz00_66), BEOA);} } 

}



/* &midiplayer-init */
obj_t BGl_z62midiplayerzd2initzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3868, obj_t BgL_mplayerz00_3869)
{
{ /* Llib/midi.scm 981 */
{ /* Llib/midi.scm 981 */
BgL_midiplayerz00_bglt BgL_auxz00_8236;
if(
BGl_isazf3zf3zz__objectz00(BgL_mplayerz00_3869, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 981 */
BgL_auxz00_8236 = 
((BgL_midiplayerz00_bglt)BgL_mplayerz00_3869)
; }  else 
{ 
obj_t BgL_auxz00_8240;
BgL_auxz00_8240 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)37068)), BGl_string3314z00zz__multimediazd2midizd2, BGl_string3079z00zz__multimediazd2midizd2, BgL_mplayerz00_3869); 
FAILURE(BgL_auxz00_8240,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2initzd2zz__multimediazd2midizd2(BgL_auxz00_8236);} } 

}



/* midisink-init */
BGL_EXPORTED_DEF obj_t BGl_midisinkzd2initzd2zz__multimediazd2midizd2(BgL_midisinkz00_bglt BgL_msinkz00_67)
{
{ /* Llib/midi.scm 987 */
{ /* Llib/midi.scm 987 */
obj_t BgL_method1239z00_1859;
{ /* Llib/midi.scm 987 */
obj_t BgL_res2871z00_2995;
{ /* Llib/midi.scm 987 */
long BgL_objzd2classzd2numz00_2960;
{ /* Llib/midi.scm 987 */
long BgL_res2861z00_2963;
BgL_res2861z00_2963 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_msinkz00_67)); 
BgL_objzd2classzd2numz00_2960 = BgL_res2861z00_2963; } 
{ /* Llib/midi.scm 987 */
obj_t BgL_arg1745z00_2961;
BgL_arg1745z00_2961 = 
PROCEDURE_REF(BGl_midisinkzd2initzd2envz00zz__multimediazd2midizd2, 
(int)(((long)1))); 
{ /* Llib/midi.scm 987 */
int BgL_offsetz00_2965;
BgL_offsetz00_2965 = 
(int)(BgL_objzd2classzd2numz00_2960); 
{ /* Llib/midi.scm 987 */
long BgL_offsetz00_2966;
BgL_offsetz00_2966 = 
(
(long)(BgL_offsetz00_2965)-OBJECT_TYPE); 
{ /* Llib/midi.scm 987 */
long BgL_modz00_2967;
BgL_modz00_2967 = 
(BgL_offsetz00_2966 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/midi.scm 987 */
long BgL_restz00_2969;
BgL_restz00_2969 = 
(BgL_offsetz00_2966 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/midi.scm 987 */

{ /* Llib/midi.scm 987 */
obj_t BgL_bucketz00_2971;
BgL_bucketz00_2971 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_2961),BgL_modz00_2967); 
BgL_res2871z00_2995 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2971),BgL_restz00_2969); } } } } } } } } 
BgL_method1239z00_1859 = BgL_res2871z00_2995; } 
return 
PROCEDURE_ENTRY(BgL_method1239z00_1859)(BgL_method1239z00_1859, 
((obj_t)BgL_msinkz00_67), BEOA);} } 

}



/* &midisink-init */
obj_t BGl_z62midisinkzd2initzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3870, obj_t BgL_msinkz00_3871)
{
{ /* Llib/midi.scm 987 */
{ /* Llib/midi.scm 987 */
BgL_midisinkz00_bglt BgL_auxz00_8275;
if(
BGl_isazf3zf3zz__objectz00(BgL_msinkz00_3871, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 987 */
BgL_auxz00_8275 = 
((BgL_midisinkz00_bglt)BgL_msinkz00_3871)
; }  else 
{ 
obj_t BgL_auxz00_8279;
BgL_auxz00_8279 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3067z00zz__multimediazd2midizd2, 
BINT(((long)37357)), BGl_string3315z00zz__multimediazd2midizd2, BGl_string3080z00zz__multimediazd2midizd2, BgL_msinkz00_3871); 
FAILURE(BgL_auxz00_8279,BFALSE,BFALSE);} 
return 
BGl_midisinkzd2initzd2zz__multimediazd2midizd2(BgL_auxz00_8275);} } 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__multimediazd2midizd2()
{
{ /* Llib/midi.scm 15 */
return BUNSPEC;} 

}

#ifdef __cplusplus
}
#endif
