/*===========================================================================*/
/*   (Llib/pgp_encode.scm)                                                   */
/*   Bigloo (4.3h)                                                           */
/*   Inria -- Sophia Antipolis (c)       Tue 12 May 2020 08:36:09 AM CEST    */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.3h/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.3h/lib/bigloo/4.3h -I Llib -lib-dir /builddir/build/BUILD/bigloo-4.3h/lib/bigloo/4.3h -fno-reflection -unsafe -safee -copt -fPIC -copt -IPosix Llib/pgp_encode.scm -o objs/pgp_encode.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_rsazd2keyzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_modulusz00;
   obj_t BgL_exponentz00;
} *BgL_rsazd2keyzd2_bglt;

typedef struct BgL_elgamalzd2keyzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_pz00;
   obj_t BgL_gz00;
   obj_t BgL_yz00;
} *BgL_elgamalzd2keyzd2_bglt;

typedef struct BgL_dsazd2keyzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_pz00;
   obj_t BgL_qz00;
   obj_t BgL_gz00;
   obj_t BgL_yz00;
} *BgL_dsazd2keyzd2_bglt;

typedef struct BgL_pgpzd2packetzd2_bgl {
   header_t header;
   obj_t widening;
} *BgL_pgpzd2packetzd2_bglt;

typedef struct BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_versionz00;
   obj_t BgL_idz00;
   obj_t BgL_algoz00;
   obj_t BgL_encryptedzd2sessionzd2keyz00;
} *BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt;

typedef struct BgL_pgpzd2sigzd2packetz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_versionz00;
   obj_t BgL_signaturezd2typezd2;
   obj_t BgL_issuerz00;
   obj_t BgL_publiczd2keyzd2algoz00;
   obj_t BgL_hashzd2algozd2;
} *BgL_pgpzd2sigzd2packetz00_bglt;

typedef struct BgL_pgpzd2signaturezd2packetz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_versionz00;
   obj_t BgL_signaturezd2typezd2;
   obj_t BgL_issuerz00;
   obj_t BgL_publiczd2keyzd2algoz00;
   obj_t BgL_hashzd2algozd2;
   obj_t BgL_creationzd2datezd2;
   obj_t BgL_signaturez00;
   obj_t BgL_signedzd2packetzd2prefixz00;
   obj_t BgL_hashzd2trailerzd2;
   obj_t BgL_leftzd2hashzd2;
} *BgL_pgpzd2signaturezd2packetz00_bglt;

typedef struct BgL_pgpzd2signaturezd2v4zd2packetzd2_bgl {
   header_t header;
   obj_t widening;
   long BgL_versionz00;
   obj_t BgL_signaturezd2typezd2;
   obj_t BgL_issuerz00;
   obj_t BgL_publiczd2keyzd2algoz00;
   obj_t BgL_hashzd2algozd2;
   obj_t BgL_creationzd2datezd2;
   obj_t BgL_signaturez00;
   obj_t BgL_signedzd2packetzd2prefixz00;
   obj_t BgL_hashzd2trailerzd2;
   obj_t BgL_leftzd2hashzd2;
   obj_t BgL_securezd2subzd2packetsz00;
   obj_t BgL_insecurezd2subzd2packetsz00;
} *BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt;

typedef struct BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_versionz00;
   obj_t BgL_algoz00;
   obj_t BgL_s2kz00;
   obj_t BgL_encryptedzd2sessionzd2keyz00;
} *BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt;

typedef struct BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_versionz00;
   obj_t BgL_signaturezd2typezd2;
   obj_t BgL_issuerz00;
   obj_t BgL_publiczd2keyzd2algoz00;
   obj_t BgL_hashzd2algozd2;
   bool_t BgL_containszd2nestedzd2sigzf3zf3;
} *BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bglt;

typedef struct BgL_pgpzd2keyzd2packetz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   long BgL_versionz00;
   bool_t BgL_subkeyzf3zf3;
   obj_t BgL_algoz00;
   obj_t BgL_creationzd2datezd2;
   obj_t BgL_validzd2dayszd2;
   obj_t BgL_keyz00;
} *BgL_pgpzd2keyzd2packetz00_bglt;

typedef struct BgL_pgpzd2publiczd2keyzd2packetzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   long BgL_versionz00;
   bool_t BgL_subkeyzf3zf3;
   obj_t BgL_algoz00;
   obj_t BgL_creationzd2datezd2;
   obj_t BgL_validzd2dayszd2;
   obj_t BgL_keyz00;
} *BgL_pgpzd2publiczd2keyzd2packetzd2_bglt;

typedef struct BgL_pgpzd2secretzd2keyzd2packetzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   long BgL_versionz00;
   bool_t BgL_subkeyzf3zf3;
   obj_t BgL_algoz00;
   obj_t BgL_creationzd2datezd2;
   obj_t BgL_validzd2dayszd2;
   obj_t BgL_keyz00;
   obj_t BgL_passwordzd2protectedzd2secretzd2keyzd2dataz00;
} *BgL_pgpzd2secretzd2keyzd2packetzd2_bglt;

typedef struct BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_dataz00;
} *BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt;

typedef struct BgL_pgpzd2literalzd2packetz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_formatz00;
   bool_t BgL_forzd2yourzd2eyeszd2onlyzf3z21;
   obj_t BgL_filezd2namezd2;
   obj_t BgL_creationzd2datezd2;
   obj_t BgL_dataz00;
} *BgL_pgpzd2literalzd2packetz00_bglt;

typedef struct BgL_pgpzd2idzd2packetz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_dataz00;
} *BgL_pgpzd2idzd2packetz00_bglt;

typedef struct BgL_pgpzd2mdczd2symmetricallyzd2encryptedzd2packetz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_dataz00;
   long BgL_versionz00;
} *BgL_pgpzd2mdczd2symmetricallyzd2encryptedzd2packetz00_bglt;

typedef struct BgL_pgpzd2mdczd2packetz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_hashz00;
} *BgL_pgpzd2mdczd2packetz00_bglt;

typedef struct BgL_pgpzd2signaturezd2subzd2packetzd2_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_criticalzf3zf3;
} *BgL_pgpzd2signaturezd2subzd2packetzd2_bglt;

typedef struct BgL_pgpzd2signaturezd2subzd2genericzd2_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_criticalzf3zf3;
   obj_t BgL_typez00;
   obj_t BgL_dataz00;
} *BgL_pgpzd2signaturezd2subzd2genericzd2_bglt;

typedef struct BgL_pgpzd2signaturezd2subzd2creationzd2timez00_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_criticalzf3zf3;
   obj_t BgL_creationzd2datezd2;
} *BgL_pgpzd2signaturezd2subzd2creationzd2timez00_bglt;

typedef struct BgL_pgpzd2signaturezd2subzd2expirationzd2timez00_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_criticalzf3zf3;
   obj_t BgL_expirationzd2datezd2;
} *BgL_pgpzd2signaturezd2subzd2expirationzd2timez00_bglt;

typedef struct BgL_pgpzd2signaturezd2subzd2exportablezd2_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_criticalzf3zf3;
   bool_t BgL_exportablezf3zf3;
} *BgL_pgpzd2signaturezd2subzd2exportablezd2_bglt;

typedef struct BgL_pgpzd2signaturezd2subzd2trustzd2_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_criticalzf3zf3;
   int BgL_levelz00;
   int BgL_amountz00;
} *BgL_pgpzd2signaturezd2subzd2trustzd2_bglt;

typedef struct BgL_pgpzd2signaturezd2subzd2revocablezd2_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_criticalzf3zf3;
   bool_t BgL_revocablezf3zf3;
} *BgL_pgpzd2signaturezd2subzd2revocablezd2_bglt;

typedef struct BgL_pgpzd2signaturezd2subzd2keyzd2expirationzd2timezd2_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_criticalzf3zf3;
   long BgL_expirationzd2timezd2;
} *BgL_pgpzd2signaturezd2subzd2keyzd2expirationzd2timezd2_bglt;

typedef struct BgL_pgpzd2signaturezd2subzd2preferredzd2symmetricz00_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_criticalzf3zf3;
   obj_t BgL_algosz00;
} *BgL_pgpzd2signaturezd2subzd2preferredzd2symmetricz00_bglt;

typedef struct BgL_pgpzd2signaturezd2subzd2revocationzd2_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_criticalzf3zf3;
   char BgL_claza7za7z00;
   bool_t BgL_sensitivezf3zf3;
   char BgL_algidz00;
   obj_t BgL_fingerprintz00;
} *BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt;

typedef struct BgL_pgpzd2signaturezd2subzd2idzd2_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_criticalzf3zf3;
   obj_t BgL_keyzd2idzd2;
} *BgL_pgpzd2signaturezd2subzd2idzd2_bglt;

typedef struct BgL_pgpzd2signaturezd2subzd2notationzd2_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_criticalzf3zf3;
   obj_t BgL_flagsz00;
   obj_t BgL_namez00;
   obj_t BgL_valuez00;
} *BgL_pgpzd2signaturezd2subzd2notationzd2_bglt;

typedef struct BgL_pgpzd2signaturezd2subzd2preferredzd2hashz00_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_criticalzf3zf3;
   obj_t BgL_algosz00;
} *BgL_pgpzd2signaturezd2subzd2preferredzd2hashz00_bglt;

typedef struct BgL_pgpzd2signaturezd2subzd2preferredzd2compressionz00_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_criticalzf3zf3;
   obj_t BgL_algosz00;
} *BgL_pgpzd2signaturezd2subzd2preferredzd2compressionz00_bglt;

typedef struct BgL_pgpzd2signaturezd2subzd2preferredzd2keyzd2serverzd2_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_criticalzf3zf3;
   obj_t BgL_serverz00;
} *BgL_pgpzd2signaturezd2subzd2preferredzd2keyzd2serverzd2_bglt;

typedef struct BgL_pgpzd2signaturezd2subzd2primaryzd2idz00_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_criticalzf3zf3;
   bool_t BgL_primaryzf3zf3;
} *BgL_pgpzd2signaturezd2subzd2primaryzd2idz00_bglt;

typedef struct BgL_pgpzd2signaturezd2subzd2policyzd2_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_criticalzf3zf3;
   obj_t BgL_urlz00;
} *BgL_pgpzd2signaturezd2subzd2policyzd2_bglt;

typedef struct BgL_pgpzd2signaturezd2subzd2signerzd2idz00_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_criticalzf3zf3;
   obj_t BgL_idz00;
} *BgL_pgpzd2signaturezd2subzd2signerzd2idz00_bglt;

typedef struct BgL_pgpzd2signaturezd2subzd2revocationzd2reasonz00_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_criticalzf3zf3;
   obj_t BgL_codez00;
   obj_t BgL_reasonz00;
} *BgL_pgpzd2signaturezd2subzd2revocationzd2reasonz00_bglt;


static obj_t BGl_z62encodezd2contentzd2PGPzd2S1246zb0zz__openpgpzd2encodezd2(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_ElGamalzd2Keyzd2zz__cryptozd2elgamalzd2;
static obj_t BGl_z62encodezd2contentzd2PGPzd2S1250zb0zz__openpgpzd2encodezd2(obj_t, obj_t, obj_t);
static bool_t BGl_encodezd2prefszd2zz__openpgpzd2encodezd2(obj_t, obj_t, obj_t);
extern obj_t BGl_PGPzd2Signaturezd2Subzd2Keyzd2Expirationzd2Timezd2zz__openpgpzd2packetszd2;
BGL_IMPORT obj_t bgl_display_obj(obj_t, obj_t);
extern obj_t BGl_PGPzd2Signaturezd2Subzd2Policyzd2zz__openpgpzd2packetszd2;
extern obj_t BGl_PGPzd2Signaturezd2Subzd2Notationzd2zz__openpgpzd2packetszd2;
static obj_t BGl_z62encodezd2contentzb0zz__openpgpzd2encodezd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62encodezd2contentzd2PGPzd2T1256zb0zz__openpgpzd2encodezd2(obj_t, obj_t, obj_t);
static obj_t BGl_encodezd2subzd2packetzd2contentzd2zz__openpgpzd2encodezd2(BgL_pgpzd2signaturezd2subzd2packetzd2_bglt, obj_t);
extern obj_t BGl_publiczd2keyzd2algozd2ze3humanzd2readableze3zz__openpgpzd2humanzd2(obj_t);
extern obj_t BGl_PGPzd2Signaturezd2Subzd2Genericzd2zz__openpgpzd2packetszd2;
extern obj_t BGl_PGPzd2Signaturezd2Subzd2Preferredzd2Compressionz00zz__openpgpzd2packetszd2;
static obj_t BGl_objectzd2initzd2zz__openpgpzd2encodezd2();
static obj_t BGl_z62encodezd2packetzb0zz__openpgpzd2encodezd2(obj_t, obj_t, obj_t);
BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
extern obj_t BGl_PGPzd2Keyzd2Packetz00zz__openpgpzd2packetszd2;
static obj_t BGl_encodezd2s2kzd2zz__openpgpzd2encodezd2(obj_t, obj_t);
static obj_t BGl_appendzd221010zd2zz__openpgpzd2encodezd2(obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__openpgpzd2encodezd2();
static obj_t BGl_z62encodezd2packetszb0zz__openpgpzd2encodezd2(obj_t, obj_t, obj_t);
extern obj_t BGl_PGPzd2Signaturezd2Subzd2Expirationzd2Timez00zz__openpgpzd2packetszd2;
extern obj_t BGl_PGPzd2Signaturezd2Subzd2Creationzd2Timez00zz__openpgpzd2packetszd2;
extern long BGl_bignumzd2bitzd2lengthz00zz__openpgpzd2utilzd2(obj_t);
extern char BGl_literalzd2formatzd2ze3byteze3zz__openpgpzd2enumszd2(obj_t);
BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
extern obj_t BGl_PGPzd2Signaturezd2Subzd2Trustzd2zz__openpgpzd2packetszd2;
static obj_t BGl_z62createzd2signedzd2packetzd2prefixzd2v4z62zz__openpgpzd2encodezd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_bignumzd2ze3binzd2strze3zz__openpgpzd2utilzd2(obj_t, long);
extern char BGl_hashzd2algozd2ze3byteze3zz__openpgpzd2enumszd2(obj_t);
static obj_t BGl_z62encodezd2publiczd2keyzd2contentzb0zz__openpgpzd2encodezd2(obj_t, obj_t, obj_t);
extern obj_t BGl_PGPzd2Signaturezd2v4zd2Packetzd2zz__openpgpzd2packetszd2;
extern obj_t BGl_PGPzd2Signaturezd2Subzd2Preferredzd2Symmetricz00zz__openpgpzd2packetszd2;
extern obj_t BGl_PGPzd2Signaturezd2Subzd2Revocablezd2zz__openpgpzd2packetszd2;
extern obj_t BGl_PGPzd2Signaturezd2Subzd2Packetzd2zz__openpgpzd2packetszd2;
extern obj_t BGl_PGPzd2Signaturezd2Subzd2Revocationzd2zz__openpgpzd2packetszd2;
extern obj_t BGl_PGPzd2Literalzd2Packetz00zz__openpgpzd2packetszd2;
BGL_EXPORTED_DECL obj_t BGl_createzd2signedzd2packetzd2prefixzd2v4z00zz__openpgpzd2encodezd2(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_PGPzd2Signaturezd2Subzd2Preferredzd2Hashz00zz__openpgpzd2packetszd2;
static obj_t BGl_gczd2rootszd2initz00zz__openpgpzd2encodezd2();
extern obj_t BGl_PGPzd2Secretzd2Keyzd2Packetzd2zz__openpgpzd2packetszd2;
extern obj_t BGl_PGPzd2MDCzd2Packetz00zz__openpgpzd2packetszd2;
static obj_t BGl_z62encodezd2contentzd2PGPzd2I1258zb0zz__openpgpzd2encodezd2(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2namezd2zz__objectz00(obj_t);
extern obj_t BGl_s2kzd2countzd2zz__openpgpzd2s2kzd2(obj_t);
extern obj_t BGl_PGPzd2Trustzd2Packetz00zz__openpgpzd2packetszd2;
extern obj_t BGl_PGPzd2Signaturezd2Subzd2Exportablezd2zz__openpgpzd2packetszd2;
BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t, obj_t, obj_t);
extern char BGl_publiczd2keyzd2algozd2ze3bytez31zz__openpgpzd2enumszd2(obj_t);
BGL_IMPORT obj_t BGl_Dsazd2Keyzd2zz__cryptozd2dsazd2;
extern obj_t BGl_PGPzd2Signaturezd2Subzd2IDzd2zz__openpgpzd2packetszd2;
BGL_IMPORT long bgl_date_to_seconds(obj_t);
static obj_t BGl_z62encodezd2subzd2packetzd2co1201zb0zz__openpgpzd2encodezd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62encodezd2subzd2packetzd2co1204zb0zz__openpgpzd2encodezd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62encodezd2subzd2packetzd2co1206zb0zz__openpgpzd2encodezd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62encodezd2subzd2packetzd2co1208zb0zz__openpgpzd2encodezd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62encodezd2subzd2packetzd2co1210zb0zz__openpgpzd2encodezd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62encodezd2subzd2packetzd2co1212zb0zz__openpgpzd2encodezd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62encodezd2subzd2packetzd2co1214zb0zz__openpgpzd2encodezd2(obj_t, obj_t, obj_t);
BGL_IMPORT bool_t bigloo_strcmp(obj_t, obj_t);
static obj_t BGl_z62encodezd2subzd2packetzd2co1216zb0zz__openpgpzd2encodezd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62encodezd2subzd2packetzd2co1218zb0zz__openpgpzd2encodezd2(obj_t, obj_t, obj_t);
extern char BGl_symmetriczd2keyzd2algozd2ze3bytez31zz__openpgpzd2enumszd2(obj_t);
static obj_t BGl_z62encodezd2subzd2packetzd2co1220zb0zz__openpgpzd2encodezd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62encodezd2subzd2packetzd2co1222zb0zz__openpgpzd2encodezd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62encodezd2subzd2packetzd2co1224zb0zz__openpgpzd2encodezd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62encodezd2subzd2packetzd2co1226zb0zz__openpgpzd2encodezd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62encodezd2subzd2packetzd2co1228zb0zz__openpgpzd2encodezd2(obj_t, obj_t, obj_t);
extern char BGl_subpacketzd2typezd2ze3byteze3zz__openpgpzd2enumszd2(obj_t);
static obj_t BGl_z62encodezd2subzd2packetzd2co1230zb0zz__openpgpzd2encodezd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62encodezd2subzd2packetzd2co1232zb0zz__openpgpzd2encodezd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62encodezd2subzd2packetzd2co1234zb0zz__openpgpzd2encodezd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62encodezd2subzd2packetzd2co1236zb0zz__openpgpzd2encodezd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62encodezd2subzd2packetzd2co1238zb0zz__openpgpzd2encodezd2(obj_t, obj_t, obj_t);
static obj_t BGl_encodezd2insecurezd2subzd2packetszd2zz__openpgpzd2encodezd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zz__openpgpzd2encodezd2 = BUNSPEC;
static obj_t BGl_z62encodezd2subzd2packetzd2contentzb0zz__openpgpzd2encodezd2(obj_t, obj_t, obj_t);
extern obj_t BGl_fixnumzd2ze3scalarz31zz__openpgpzd2conversionzd2(long, long);
BGL_IMPORT obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_encodezd2subzd2packetsz00zz__openpgpzd2encodezd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_za2classesza2z00zz__objectz00;
BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t, obj_t, obj_t);
extern int BGl_s2kzd2saltzd2lengthz00zz__openpgpzd2s2kzd2();
extern obj_t BGl_PGPzd2Signaturezd2Subzd2Signerzd2IDz00zz__openpgpzd2packetszd2;
static obj_t BGl_toplevelzd2initzd2zz__openpgpzd2encodezd2();
static obj_t BGl_z62encodezd2contentzd2PGPzd2L1254zb0zz__openpgpzd2encodezd2(obj_t, obj_t, obj_t);
extern obj_t BGl_s2kzd2algozd2zz__openpgpzd2s2kzd2(obj_t);
extern char BGl_signaturezd2typezd2ze3byteze3zz__openpgpzd2enumszd2(obj_t);
static obj_t BGl_genericzd2initzd2zz__openpgpzd2encodezd2();
extern long BGl_iteratedzd2saltedzd2s2kzd2countzd2ze3octetze3zz__openpgpzd2s2kzd2(long);
static obj_t BGl_z62encodezd2contentzd2PGPzd2M1252zb0zz__openpgpzd2encodezd2(obj_t, obj_t, obj_t);
extern obj_t BGl_PGPzd2Markerzd2Packetz00zz__openpgpzd2packetszd2;
extern obj_t BGl_PGPzd2Compressedzd2Packetz00zz__openpgpzd2packetszd2;
static obj_t BGl_z62encodezd2contentzd2PGPzd2M1260zb0zz__openpgpzd2encodezd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62encodezd2contentzd2PGPzd2M1262zb0zz__openpgpzd2encodezd2(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
extern obj_t BGl_s2kzd2saltzd2zz__openpgpzd2s2kzd2(obj_t);
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
static obj_t BGl_encodezd2contentzd2zz__openpgpzd2encodezd2(BgL_pgpzd2packetzd2_bglt, obj_t);
extern obj_t BGl_PGPzd2Signaturezd2Subzd2Primaryzd2IDz00zz__openpgpzd2packetszd2;
static obj_t BGl_encodezd2octetzd2zz__openpgpzd2encodezd2(long, obj_t);
BGL_IMPORT obj_t BGl_openzd2outputzd2stringz00zz__r4_ports_6_10_1z00(obj_t);
static obj_t BGl_z62packetzd2ze3contentzd2tag1167z81zz__openpgpzd2encodezd2(obj_t, obj_t);
BGL_IMPORT obj_t bgl_close_output_port(obj_t);
extern obj_t BGl_PGPzd2Publiczd2Keyzd2Packetzd2zz__openpgpzd2packetszd2;
static obj_t BGl_z62encodezd2contentzd2PGPzd2P1200zb0zz__openpgpzd2encodezd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62encodezd2contentzd2PGPzd2O1244zb0zz__openpgpzd2encodezd2(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_Rsazd2Keyzd2zz__cryptozd2rsazd2;
extern obj_t BGl_s2kzd2hashzd2zz__openpgpzd2s2kzd2(obj_t);
BGL_IMPORT bool_t BGl_pairzd2orzd2nullzf3zf3zz__r4_pairs_and_lists_6_3z00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_encodezd2packetszd2zz__openpgpzd2encodezd2(obj_t, obj_t);
extern obj_t BGl_PGPzd2Symmetriczd2Keyzd2Encryptedzd2Sessionzd2Keyzd2Packetz00zz__openpgpzd2packetszd2;
extern char BGl_revocationzd2codezd2ze3byteze3zz__openpgpzd2enumszd2(obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__openpgpzd2encodezd2(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__openpgpzd2s2kzd2(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__openpgpzd2enumszd2(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__openpgpzd2humanzd2(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__openpgpzd2packetszd2(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__openpgpzd2conversionzd2(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__openpgpzd2utilzd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__cryptozd2cipherszd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__cryptozd2dsazd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__cryptozd2rsazd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__cryptozd2elgamalzd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__datez00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
extern char BGl_contentzd2tagzd2ze3byteze3zz__openpgpzd2enumszd2(obj_t);
extern obj_t BGl_PGPzd2Packetzd2zz__openpgpzd2packetszd2;
static obj_t BGl_z62encodezd2contentzd2PGPzd2P1248zb0zz__openpgpzd2encodezd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62packetzd2ze3contentzd2tagz81zz__openpgpzd2encodezd2(obj_t, obj_t);
extern obj_t BGl_PGPzd2Publiczd2Keyzd2Encryptedzd2Sessionzd2Keyzd2Packetz00zz__openpgpzd2packetszd2;
BGL_EXPORTED_DECL obj_t BGl_encodezd2packetzd2zz__openpgpzd2encodezd2(BgL_pgpzd2packetzd2_bglt, obj_t);
static obj_t BGl_cnstzd2initzd2zz__openpgpzd2encodezd2();
static obj_t BGl_libraryzd2moduleszd2initz00zz__openpgpzd2encodezd2();
static obj_t BGl_z62packetzd2ze3contentzd2tagzd21171z53zz__openpgpzd2encodezd2(obj_t, obj_t);
static obj_t BGl_z62packetzd2ze3contentzd2tagzd21173z53zz__openpgpzd2encodezd2(obj_t, obj_t);
extern obj_t BGl_PGPzd2IDzd2Packetz00zz__openpgpzd2packetszd2;
static obj_t BGl_z62packetzd2ze3contentzd2tagzd21175z53zz__openpgpzd2encodezd2(obj_t, obj_t);
static obj_t BGl_z62packetzd2ze3contentzd2tagzd21177z53zz__openpgpzd2encodezd2(obj_t, obj_t);
static obj_t BGl_importedzd2moduleszd2initz00zz__openpgpzd2encodezd2();
static obj_t BGl_z62packetzd2ze3contentzd2tagzd21179z53zz__openpgpzd2encodezd2(obj_t, obj_t);
static obj_t BGl_encodezd2lengthzd2v4z00zz__openpgpzd2encodezd2(long, obj_t);
extern obj_t BGl_PGPzd2MDCzd2Symmetricallyzd2Encryptedzd2Packetz00zz__openpgpzd2packetszd2;
static obj_t BGl_z62packetzd2ze3contentzd2tagzd21181z53zz__openpgpzd2encodezd2(obj_t, obj_t);
static obj_t BGl_z62packetzd2ze3contentzd2tagzd21183z53zz__openpgpzd2encodezd2(obj_t, obj_t);
static obj_t BGl_z62packetzd2ze3contentzd2tagzd21185z53zz__openpgpzd2encodezd2(obj_t, obj_t);
static obj_t BGl_z62packetzd2ze3contentzd2tagzd21187z53zz__openpgpzd2encodezd2(obj_t, obj_t);
static obj_t BGl_z62packetzd2ze3contentzd2tagzd21189z53zz__openpgpzd2encodezd2(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_encodezd2publiczd2keyzd2contentzd2zz__openpgpzd2encodezd2(BgL_pgpzd2keyzd2packetz00_bglt, obj_t);
static obj_t BGl_z62packetzd2ze3contentzd2tagzd21191z53zz__openpgpzd2encodezd2(obj_t, obj_t);
static obj_t BGl_z62packetzd2ze3contentzd2tagzd21193z53zz__openpgpzd2encodezd2(obj_t, obj_t);
static obj_t BGl_z62packetzd2ze3contentzd2tagzd21195z53zz__openpgpzd2encodezd2(obj_t, obj_t);
extern char BGl_s2kzd2algozd2ze3byteze3zz__openpgpzd2enumszd2(obj_t);
extern obj_t BGl_PGPzd2Onezd2Passzd2Signaturezd2Packetz00zz__openpgpzd2packetszd2;
extern obj_t BGl_PGPzd2Symmetricallyzd2Encryptedzd2Packetzd2zz__openpgpzd2packetszd2;
extern obj_t BGl_PGPzd2Signaturezd2Packetz00zz__openpgpzd2packetszd2;
static obj_t BGl_packetzd2ze3contentzd2tagze3zz__openpgpzd2encodezd2(BgL_pgpzd2packetzd2_bglt);
extern obj_t BGl_PGPzd2Signaturezd2Subzd2Revocationzd2Reasonz00zz__openpgpzd2packetszd2;
static obj_t BGl_z62encodezd2content1196zb0zz__openpgpzd2encodezd2(obj_t, obj_t, obj_t);
extern obj_t BGl_PGPzd2Signaturezd2Subzd2Preferredzd2Keyzd2Serverzd2zz__openpgpzd2packetszd2;
static obj_t BGl_z62encodezd2contentzd2PGPzd2S1240zb0zz__openpgpzd2encodezd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62encodezd2contentzd2PGPzd2S1242zb0zz__openpgpzd2encodezd2(obj_t, obj_t, obj_t);
static obj_t __cnst[ 59 ] ;


extern obj_t BGl_symmetriczd2keyzd2algozd2ze3bytezd2envze3zz__openpgpzd2enumszd2;
extern obj_t BGl_compressionzd2algozd2ze3bytezd2envz31zz__openpgpzd2enumszd2;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2424z00zz__openpgpzd2encodezd2, BgL_bgl_za762packetza7d2za7e3c2498za7, BGl_z62packetzd2ze3contentzd2tag1167z81zz__openpgpzd2encodezd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2426z00zz__openpgpzd2encodezd2, BgL_bgl_za762encodeza7d2cont2499z00, BGl_z62encodezd2content1196zb0zz__openpgpzd2encodezd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2428z00zz__openpgpzd2encodezd2, BgL_bgl_za762encodeza7d2subza72500za7, BGl_z62encodezd2subzd2packetzd2co1201zb0zz__openpgpzd2encodezd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2436z00zz__openpgpzd2encodezd2, BgL_bgl_za762packetza7d2za7e3c2501za7, BGl_z62packetzd2ze3contentzd2tagzd21171z53zz__openpgpzd2encodezd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2438z00zz__openpgpzd2encodezd2, BgL_bgl_za762packetza7d2za7e3c2502za7, BGl_z62packetzd2ze3contentzd2tagzd21173z53zz__openpgpzd2encodezd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2439z00zz__openpgpzd2encodezd2, BgL_bgl_za762packetza7d2za7e3c2503za7, BGl_z62packetzd2ze3contentzd2tagzd21175z53zz__openpgpzd2encodezd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2440z00zz__openpgpzd2encodezd2, BgL_bgl_za762packetza7d2za7e3c2504za7, BGl_z62packetzd2ze3contentzd2tagzd21177z53zz__openpgpzd2encodezd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2441z00zz__openpgpzd2encodezd2, BgL_bgl_za762packetza7d2za7e3c2505za7, BGl_z62packetzd2ze3contentzd2tagzd21179z53zz__openpgpzd2encodezd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2442z00zz__openpgpzd2encodezd2, BgL_bgl_za762packetza7d2za7e3c2506za7, BGl_z62packetzd2ze3contentzd2tagzd21181z53zz__openpgpzd2encodezd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2443z00zz__openpgpzd2encodezd2, BgL_bgl_za762packetza7d2za7e3c2507za7, BGl_z62packetzd2ze3contentzd2tagzd21183z53zz__openpgpzd2encodezd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2444z00zz__openpgpzd2encodezd2, BgL_bgl_za762packetza7d2za7e3c2508za7, BGl_z62packetzd2ze3contentzd2tagzd21185z53zz__openpgpzd2encodezd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2445z00zz__openpgpzd2encodezd2, BgL_bgl_za762packetza7d2za7e3c2509za7, BGl_z62packetzd2ze3contentzd2tagzd21187z53zz__openpgpzd2encodezd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2446z00zz__openpgpzd2encodezd2, BgL_bgl_za762packetza7d2za7e3c2510za7, BGl_z62packetzd2ze3contentzd2tagzd21189z53zz__openpgpzd2encodezd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2447z00zz__openpgpzd2encodezd2, BgL_bgl_za762packetza7d2za7e3c2511za7, BGl_z62packetzd2ze3contentzd2tagzd21191z53zz__openpgpzd2encodezd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2448z00zz__openpgpzd2encodezd2, BgL_bgl_za762packetza7d2za7e3c2512za7, BGl_z62packetzd2ze3contentzd2tagzd21193z53zz__openpgpzd2encodezd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2449z00zz__openpgpzd2encodezd2, BgL_bgl_za762packetza7d2za7e3c2513za7, BGl_z62packetzd2ze3contentzd2tagzd21195z53zz__openpgpzd2encodezd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2450z00zz__openpgpzd2encodezd2, BgL_bgl_za762encodeza7d2cont2514z00, BGl_z62encodezd2contentzd2PGPzd2P1200zb0zz__openpgpzd2encodezd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2452z00zz__openpgpzd2encodezd2, BgL_bgl_za762encodeza7d2subza72515za7, BGl_z62encodezd2subzd2packetzd2co1204zb0zz__openpgpzd2encodezd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2454z00zz__openpgpzd2encodezd2, BgL_bgl_za762encodeza7d2subza72516za7, BGl_z62encodezd2subzd2packetzd2co1206zb0zz__openpgpzd2encodezd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2455z00zz__openpgpzd2encodezd2, BgL_bgl_za762encodeza7d2subza72517za7, BGl_z62encodezd2subzd2packetzd2co1208zb0zz__openpgpzd2encodezd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2456z00zz__openpgpzd2encodezd2, BgL_bgl_za762encodeza7d2subza72518za7, BGl_z62encodezd2subzd2packetzd2co1210zb0zz__openpgpzd2encodezd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2457z00zz__openpgpzd2encodezd2, BgL_bgl_za762encodeza7d2subza72519za7, BGl_z62encodezd2subzd2packetzd2co1212zb0zz__openpgpzd2encodezd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2458z00zz__openpgpzd2encodezd2, BgL_bgl_za762encodeza7d2subza72520za7, BGl_z62encodezd2subzd2packetzd2co1214zb0zz__openpgpzd2encodezd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2459z00zz__openpgpzd2encodezd2, BgL_bgl_za762encodeza7d2subza72521za7, BGl_z62encodezd2subzd2packetzd2co1216zb0zz__openpgpzd2encodezd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2460z00zz__openpgpzd2encodezd2, BgL_bgl_za762encodeza7d2subza72522za7, BGl_z62encodezd2subzd2packetzd2co1218zb0zz__openpgpzd2encodezd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2461z00zz__openpgpzd2encodezd2, BgL_bgl_za762encodeza7d2subza72523za7, BGl_z62encodezd2subzd2packetzd2co1220zb0zz__openpgpzd2encodezd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2462z00zz__openpgpzd2encodezd2, BgL_bgl_za762encodeza7d2subza72524za7, BGl_z62encodezd2subzd2packetzd2co1222zb0zz__openpgpzd2encodezd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2463z00zz__openpgpzd2encodezd2, BgL_bgl_za762encodeza7d2subza72525za7, BGl_z62encodezd2subzd2packetzd2co1224zb0zz__openpgpzd2encodezd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2464z00zz__openpgpzd2encodezd2, BgL_bgl_za762encodeza7d2subza72526za7, BGl_z62encodezd2subzd2packetzd2co1226zb0zz__openpgpzd2encodezd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2465z00zz__openpgpzd2encodezd2, BgL_bgl_za762encodeza7d2subza72527za7, BGl_z62encodezd2subzd2packetzd2co1228zb0zz__openpgpzd2encodezd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2466z00zz__openpgpzd2encodezd2, BgL_bgl_za762encodeza7d2subza72528za7, BGl_z62encodezd2subzd2packetzd2co1230zb0zz__openpgpzd2encodezd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2467z00zz__openpgpzd2encodezd2, BgL_bgl_za762encodeza7d2subza72529za7, BGl_z62encodezd2subzd2packetzd2co1232zb0zz__openpgpzd2encodezd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2468z00zz__openpgpzd2encodezd2, BgL_bgl_za762encodeza7d2subza72530za7, BGl_z62encodezd2subzd2packetzd2co1234zb0zz__openpgpzd2encodezd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2469z00zz__openpgpzd2encodezd2, BgL_bgl_za762encodeza7d2subza72531za7, BGl_z62encodezd2subzd2packetzd2co1236zb0zz__openpgpzd2encodezd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2395z00zz__openpgpzd2encodezd2, BgL_bgl_string2395za700za7za7_2532za7, "Llib/pgp_encode.scm", 19 );
DEFINE_STRING( BGl_string2396z00zz__openpgpzd2encodezd2, BgL_bgl_string2396za700za7za7_2533za7, "/builddir/build/BUILD/bigloo-4.3h/api/openpgp/src/Llib/pgp_encode.scm", 69 );
DEFINE_STRING( BGl_string2397z00zz__openpgpzd2encodezd2, BgL_bgl_string2397za700za7za7_2534za7, "&encode-packets", 15 );
DEFINE_STRING( BGl_string2398z00zz__openpgpzd2encodezd2, BgL_bgl_string2398za700za7za7_2535za7, "output-port", 11 );
DEFINE_STRING( BGl_string2399z00zz__openpgpzd2encodezd2, BgL_bgl_string2399za700za7za7_2536za7, "given number is too big", 23 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2470z00zz__openpgpzd2encodezd2, BgL_bgl_za762encodeza7d2subza72537za7, BGl_z62encodezd2subzd2packetzd2co1238zb0zz__openpgpzd2encodezd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2471z00zz__openpgpzd2encodezd2, BgL_bgl_za762encodeza7d2cont2538z00, BGl_z62encodezd2contentzd2PGPzd2S1240zb0zz__openpgpzd2encodezd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2472z00zz__openpgpzd2encodezd2, BgL_bgl_za762encodeza7d2cont2539z00, BGl_z62encodezd2contentzd2PGPzd2S1242zb0zz__openpgpzd2encodezd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2473z00zz__openpgpzd2encodezd2, BgL_bgl_za762encodeza7d2cont2540z00, BGl_z62encodezd2contentzd2PGPzd2O1244zb0zz__openpgpzd2encodezd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2474z00zz__openpgpzd2encodezd2, BgL_bgl_za762encodeza7d2cont2541z00, BGl_z62encodezd2contentzd2PGPzd2S1246zb0zz__openpgpzd2encodezd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2475z00zz__openpgpzd2encodezd2, BgL_bgl_za762encodeza7d2cont2542z00, BGl_z62encodezd2contentzd2PGPzd2P1248zb0zz__openpgpzd2encodezd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2476z00zz__openpgpzd2encodezd2, BgL_bgl_za762encodeza7d2cont2543z00, BGl_z62encodezd2contentzd2PGPzd2S1250zb0zz__openpgpzd2encodezd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2477z00zz__openpgpzd2encodezd2, BgL_bgl_za762encodeza7d2cont2544z00, BGl_z62encodezd2contentzd2PGPzd2M1252zb0zz__openpgpzd2encodezd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2478z00zz__openpgpzd2encodezd2, BgL_bgl_za762encodeza7d2cont2545z00, BGl_z62encodezd2contentzd2PGPzd2L1254zb0zz__openpgpzd2encodezd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2479z00zz__openpgpzd2encodezd2, BgL_bgl_za762encodeza7d2cont2546z00, BGl_z62encodezd2contentzd2PGPzd2T1256zb0zz__openpgpzd2encodezd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2480z00zz__openpgpzd2encodezd2, BgL_bgl_za762encodeza7d2cont2547z00, BGl_z62encodezd2contentzd2PGPzd2I1258zb0zz__openpgpzd2encodezd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2481z00zz__openpgpzd2encodezd2, BgL_bgl_za762encodeza7d2cont2548z00, BGl_z62encodezd2contentzd2PGPzd2M1260zb0zz__openpgpzd2encodezd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2482z00zz__openpgpzd2encodezd2, BgL_bgl_za762encodeza7d2cont2549z00, BGl_z62encodezd2contentzd2PGPzd2M1262zb0zz__openpgpzd2encodezd2, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_encodezd2packetzd2envz00zz__openpgpzd2encodezd2, BgL_bgl_za762encodeza7d2pack2550z00, BGl_z62encodezd2packetzb0zz__openpgpzd2encodezd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_GENERIC( BGl_encodezd2contentzd2envz00zz__openpgpzd2encodezd2, BgL_bgl_za762encodeza7d2cont2551z00, BGl_z62encodezd2contentzb0zz__openpgpzd2encodezd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2400z00zz__openpgpzd2encodezd2, BgL_bgl_string2400za700za7za7_2552za7, "Preferences must be integers", 28 );
DEFINE_STRING( BGl_string2401z00zz__openpgpzd2encodezd2, BgL_bgl_string2401za700za7za7_2553za7, "encode-packet", 13 );
DEFINE_STRING( BGl_string2402z00zz__openpgpzd2encodezd2, BgL_bgl_string2402za700za7za7_2554za7, "content-tag too big", 19 );
DEFINE_STRING( BGl_string2403z00zz__openpgpzd2encodezd2, BgL_bgl_string2403za700za7za7_2555za7, "&encode-packet", 14 );
DEFINE_STRING( BGl_string2404z00zz__openpgpzd2encodezd2, BgL_bgl_string2404za700za7za7_2556za7, "PGP-Packet", 10 );
DEFINE_STRING( BGl_string2405z00zz__openpgpzd2encodezd2, BgL_bgl_string2405za700za7za7_2557za7, "creation-date ist mandatory", 27 );
DEFINE_STRING( BGl_string2406z00zz__openpgpzd2encodezd2, BgL_bgl_string2406za700za7za7_2558za7, "Conflicting creation-dates", 26 );
DEFINE_STRING( BGl_string2407z00zz__openpgpzd2encodezd2, BgL_bgl_string2407za700za7za7_2559za7, "&create-signed-packet-prefix-v4", 31 );
DEFINE_STRING( BGl_string2408z00zz__openpgpzd2encodezd2, BgL_bgl_string2408za700za7za7_2560za7, "symbol", 6 );
DEFINE_STRING( BGl_string2409z00zz__openpgpzd2encodezd2, BgL_bgl_string2409za700za7za7_2561za7, "pair-nil", 8 );
DEFINE_STRING( BGl_string2410z00zz__openpgpzd2encodezd2, BgL_bgl_string2410za700za7za7_2562za7, "Conflicting issuers", 19 );
DEFINE_STRING( BGl_string2411z00zz__openpgpzd2encodezd2, BgL_bgl_string2411za700za7za7_2563za7, "expected string as salt", 23 );
DEFINE_STRING( BGl_string2412z00zz__openpgpzd2encodezd2, BgL_bgl_string2412za700za7za7_2564za7, "given string has bad size", 25 );
DEFINE_STRING( BGl_string2413z00zz__openpgpzd2encodezd2, BgL_bgl_string2413za700za7za7_2565za7, "expected fixnum as count", 24 );
DEFINE_STRING( BGl_string2414z00zz__openpgpzd2encodezd2, BgL_bgl_string2414za700za7za7_2566za7, "encode-s2k", 10 );
DEFINE_STRING( BGl_string2415z00zz__openpgpzd2encodezd2, BgL_bgl_string2415za700za7za7_2567za7, "unknown s2k algorithm", 21 );
DEFINE_STRING( BGl_string2416z00zz__openpgpzd2encodezd2, BgL_bgl_string2416za700za7za7_2568za7, "v3 keys must have valid-days (as fixnum)", 40 );
DEFINE_STRING( BGl_string2417z00zz__openpgpzd2encodezd2, BgL_bgl_string2417za700za7za7_2569za7, "v3 keys must be RSA", 19 );
DEFINE_STRING( BGl_string2418z00zz__openpgpzd2encodezd2, BgL_bgl_string2418za700za7za7_2570za7, "invalid Rsa-Key", 15 );
DEFINE_STRING( BGl_string2419z00zz__openpgpzd2encodezd2, BgL_bgl_string2419za700za7za7_2571za7, "invalid Dsa-Key", 15 );
DEFINE_STRING( BGl_string2420z00zz__openpgpzd2encodezd2, BgL_bgl_string2420za700za7za7_2572za7, "invalid ElGamal-key", 19 );
DEFINE_STRING( BGl_string2421z00zz__openpgpzd2encodezd2, BgL_bgl_string2421za700za7za7_2573za7, "unsupported public key algorithm", 32 );
DEFINE_STRING( BGl_string2422z00zz__openpgpzd2encodezd2, BgL_bgl_string2422za700za7za7_2574za7, "&encode-public-key-content", 26 );
DEFINE_STRING( BGl_string2423z00zz__openpgpzd2encodezd2, BgL_bgl_string2423za700za7za7_2575za7, "PGP-Key-Packet", 14 );
DEFINE_STRING( BGl_string2425z00zz__openpgpzd2encodezd2, BgL_bgl_string2425za700za7za7_2576za7, "packet->content-tag1167", 23 );
DEFINE_STRING( BGl_string2427z00zz__openpgpzd2encodezd2, BgL_bgl_string2427za700za7za7_2577za7, "encode-content1196", 18 );
DEFINE_STRING( BGl_string2429z00zz__openpgpzd2encodezd2, BgL_bgl_string2429za700za7za7_2578za7, "encode-sub-packet-co1201", 24 );
DEFINE_STRING( BGl_string2430z00zz__openpgpzd2encodezd2, BgL_bgl_string2430za700za7za7_2579za7, "not yet implemented", 19 );
DEFINE_STRING( BGl_string2431z00zz__openpgpzd2encodezd2, BgL_bgl_string2431za700za7za7_2580za7, "internal error. forgot PGP-Packet type", 38 );
DEFINE_STRING( BGl_string2432z00zz__openpgpzd2encodezd2, BgL_bgl_string2432za700za7za7_2581za7, "&packet->content-tag", 20 );
DEFINE_STRING( BGl_string2433z00zz__openpgpzd2encodezd2, BgL_bgl_string2433za700za7za7_2582za7, "&encode-content", 15 );
DEFINE_STRING( BGl_string2434z00zz__openpgpzd2encodezd2, BgL_bgl_string2434za700za7za7_2583za7, "&encode-sub-packet-content", 26 );
DEFINE_STRING( BGl_string2435z00zz__openpgpzd2encodezd2, BgL_bgl_string2435za700za7za7_2584za7, "PGP-Signature-Sub-Packet", 24 );
DEFINE_STRING( BGl_string2437z00zz__openpgpzd2encodezd2, BgL_bgl_string2437za700za7za7_2585za7, "packet->content-tag", 19 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_encodezd2packetszd2envz00zz__openpgpzd2encodezd2, BgL_bgl_za762encodeza7d2pack2586z00, va_generic_entry, BGl_z62encodezd2packetszb0zz__openpgpzd2encodezd2, BUNSPEC, -2 );
DEFINE_STRING( BGl_string2451z00zz__openpgpzd2encodezd2, BgL_bgl_string2451za700za7za7_2587za7, "encode-content", 14 );
DEFINE_STRING( BGl_string2453z00zz__openpgpzd2encodezd2, BgL_bgl_string2453za700za7za7_2588za7, "encode-sub-packet-content", 25 );
DEFINE_STRING( BGl_string2483z00zz__openpgpzd2encodezd2, BgL_bgl_string2483za700za7za7_2589za7, "Trust Packet encoding not yet implemented", 41 );
DEFINE_STATIC_BGL_GENERIC( BGl_encodezd2subzd2packetzd2contentzd2envz00zz__openpgpzd2encodezd2, BgL_bgl_za762encodeza7d2subza72590za7, BGl_z62encodezd2subzd2packetzd2contentzb0zz__openpgpzd2encodezd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2484z00zz__openpgpzd2encodezd2, BgL_bgl_string2484za700za7za7_2591za7, "'for-your-eyes-only' excludes filename", 38 );
DEFINE_STRING( BGl_string2485z00zz__openpgpzd2encodezd2, BgL_bgl_string2485za700za7za7_2592za7, "_CONSOLE", 8 );
DEFINE_STRING( BGl_string2486z00zz__openpgpzd2encodezd2, BgL_bgl_string2486za700za7za7_2593za7, "", 0 );
DEFINE_STRING( BGl_string2487z00zz__openpgpzd2encodezd2, BgL_bgl_string2487za700za7za7_2594za7, "Filename too long (>255)", 24 );
DEFINE_STRING( BGl_string2488z00zz__openpgpzd2encodezd2, BgL_bgl_string2488za700za7za7_2595za7, "Only encoding packets of version 4", 34 );
DEFINE_STRING( BGl_string2489z00zz__openpgpzd2encodezd2, BgL_bgl_string2489za700za7za7_2596za7, "signature-data in DSA-mode must be a pair", 41 );
DEFINE_STRING( BGl_string2490z00zz__openpgpzd2encodezd2, BgL_bgl_string2490za700za7za7_2597za7, "signature-encoding not yet implemented", 38 );
DEFINE_STRING( BGl_string2491z00zz__openpgpzd2encodezd2, BgL_bgl_string2491za700za7za7_2598za7, "bad encrypted-session-key. ElGamal requires a pair", 50 );
DEFINE_STRING( BGl_string2492z00zz__openpgpzd2encodezd2, BgL_bgl_string2492za700za7za7_2599za7, "Not yet implemented", 19 );
DEFINE_STRING( BGl_string2493z00zz__openpgpzd2encodezd2, BgL_bgl_string2493za700za7za7_2600za7, "__openpgp-encode", 16 );
DEFINE_STRING( BGl_string2494z00zz__openpgpzd2encodezd2, BgL_bgl_string2494za700za7za7_2601za7, "public-key-encrypted-session-key signature symmetric-key-encrypted-session-key one-pass-signature secret-subkey secret-key public-subkey public-key compressed symmetrically-encrypted mdc-symmetrically-encrypted marker literal ID encode-Public-key-encrypted-session-key-packet creation-time expiration-time exportable? trust revocable? key-expiration-time preferred-symmetric revocation-key issuer-ID notation preferred-hash preferred-compression preferred-key-server primary-id? policy signer-ID revocation-reason encode-PGP-Signature-v4-Packet encode-Symmetric-Key-Encrypted-Session do-nothing encode-content-literal encode-content-trust packet->content-tag encode-content encode-signature-sub-packet-content elgamal-encrypt/sign elgamal-encrypt dsa encode-key ok rsa-sign rsa-encrypt rsa-encrypt/sign encode-public-key iterated encode-octets encode-s2k salted nothing-to-do simple encode-insecure-sub-packets create-signed-packet-prefix-v4 encode-pref encode-octet ", 967 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_encodezd2publiczd2keyzd2contentzd2envz00zz__openpgpzd2encodezd2, BgL_bgl_za762encodeza7d2publ2602z00, BGl_z62encodezd2publiczd2keyzd2contentzb0zz__openpgpzd2encodezd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_GENERIC( BGl_packetzd2ze3contentzd2tagzd2envz31zz__openpgpzd2encodezd2, BgL_bgl_za762packetza7d2za7e3c2603za7, BGl_z62packetzd2ze3contentzd2tagz81zz__openpgpzd2encodezd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_createzd2signedzd2packetzd2prefixzd2v4zd2envzd2zz__openpgpzd2encodezd2, BgL_bgl_za762createza7d2sign2604z00, BGl_z62createzd2signedzd2packetzd2prefixzd2v4z62zz__openpgpzd2encodezd2, 0L, BUNSPEC, 5 );
extern obj_t BGl_hashzd2algozd2ze3bytezd2envz31zz__openpgpzd2enumszd2;

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__openpgpzd2encodezd2) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__openpgpzd2encodezd2(long BgL_checksumz00_3153, char * BgL_fromz00_3154)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__openpgpzd2encodezd2))
{ 
BGl_requirezd2initializa7ationz75zz__openpgpzd2encodezd2 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__openpgpzd2encodezd2(); 
BGl_libraryzd2moduleszd2initz00zz__openpgpzd2encodezd2(); 
BGl_cnstzd2initzd2zz__openpgpzd2encodezd2(); 
BGl_importedzd2moduleszd2initz00zz__openpgpzd2encodezd2(); 
BGl_genericzd2initzd2zz__openpgpzd2encodezd2(); 
BGl_methodzd2initzd2zz__openpgpzd2encodezd2(); 
return 
BGl_toplevelzd2initzd2zz__openpgpzd2encodezd2();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__openpgpzd2encodezd2()
{
{ /* Llib/pgp_encode.scm 1 */
BGl_modulezd2initializa7ationz75zz__cryptozd2elgamalzd2(((long)0), "__openpgp-encode"); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "__openpgp-encode"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__openpgp-encode"); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "__openpgp-encode"); 
BGl_modulezd2initializa7ationz75zz__cryptozd2dsazd2(((long)0), "__openpgp-encode"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__openpgp-encode"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__openpgp-encode"); 
BGl_modulezd2initializa7ationz75zz__cryptozd2rsazd2(((long)0), "__openpgp-encode"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__openpgp-encode"); 
BGl_modulezd2initializa7ationz75zz__cryptozd2cipherszd2(((long)0), "__openpgp-encode"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__openpgp-encode"); 
BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)0), "__openpgp-encode"); 
BGl_modulezd2initializa7ationz75zz__datez00(((long)0), "__openpgp-encode"); 
BGl_modulezd2initializa7ationz75zz__bitz00(((long)0), "__openpgp-encode"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__openpgp-encode"); 
BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long)0), "__openpgp-encode"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__openpgp-encode"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__openpgpzd2encodezd2()
{
{ /* Llib/pgp_encode.scm 1 */
{ /* Llib/pgp_encode.scm 1 */
obj_t BgL_cportz00_2735;
{ /* Llib/pgp_encode.scm 1 */
obj_t BgL_stringz00_2743;
BgL_stringz00_2743 = BGl_string2494z00zz__openpgpzd2encodezd2; 
{ /* Llib/pgp_encode.scm 1 */
obj_t BgL_startz00_2744;
BgL_startz00_2744 = 
BINT(((long)0)); 
{ /* Llib/pgp_encode.scm 1 */
obj_t BgL_endz00_2745;
BgL_endz00_2745 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_2743))); 
{ /* Llib/pgp_encode.scm 1 */

BgL_cportz00_2735 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_2743, BgL_startz00_2744, BgL_endz00_2745); } } } } 
{ 
long BgL_iz00_2736;
BgL_iz00_2736 = ((long)58); 
BgL_loopz00_2737:
if(
(BgL_iz00_2736==((long)-1)))
{ /* Llib/pgp_encode.scm 1 */
return BUNSPEC;}  else 
{ /* Llib/pgp_encode.scm 1 */
{ /* Llib/pgp_encode.scm 1 */
obj_t BgL_arg2496z00_2739;
{ /* Llib/pgp_encode.scm 1 */

{ /* Llib/pgp_encode.scm 1 */
obj_t BgL_locationz00_2741;
BgL_locationz00_2741 = 
BBOOL(((bool_t)0)); 
{ /* Llib/pgp_encode.scm 1 */

BgL_arg2496z00_2739 = 
BGl_readz00zz__readerz00(BgL_cportz00_2735, BgL_locationz00_2741); } } } 
{ /* Llib/pgp_encode.scm 1 */
int BgL_tmpz00_3191;
BgL_tmpz00_3191 = 
(int)(BgL_iz00_2736); 
CNST_TABLE_SET(BgL_tmpz00_3191, BgL_arg2496z00_2739); } } 
{ /* Llib/pgp_encode.scm 1 */
int BgL_auxz00_2742;
BgL_auxz00_2742 = 
(int)(
(BgL_iz00_2736-((long)1))); 
{ 
long BgL_iz00_3196;
BgL_iz00_3196 = 
(long)(BgL_auxz00_2742); 
BgL_iz00_2736 = BgL_iz00_3196; 
goto BgL_loopz00_2737;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__openpgpzd2encodezd2()
{
{ /* Llib/pgp_encode.scm 1 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__openpgpzd2encodezd2()
{
{ /* Llib/pgp_encode.scm 1 */
BGl_modulezd2initializa7ationz75zz__cryptozd2cipherszd2(((long)0), 
BSTRING_TO_STRING(BGl_string2395z00zz__openpgpzd2encodezd2)); 
return BUNSPEC;} 

}



/* append-21010 */
obj_t BGl_appendzd221010zd2zz__openpgpzd2encodezd2(obj_t BgL_l1z00_1, obj_t BgL_l2z00_2)
{
{ 
{ 
obj_t BgL_headz00_145;
BgL_headz00_145 = 
MAKE_YOUNG_PAIR(BNIL, BgL_l2z00_2); 
{ 
obj_t BgL_prevz00_146;obj_t BgL_tailz00_147;
BgL_prevz00_146 = BgL_headz00_145; 
BgL_tailz00_147 = BgL_l1z00_1; 
BgL_loopz00_148:
if(
PAIRP(BgL_tailz00_147))
{ 
obj_t BgL_newzd2prevzd2_150;
BgL_newzd2prevzd2_150 = 
MAKE_YOUNG_PAIR(
CAR(BgL_tailz00_147), BgL_l2z00_2); 
SET_CDR(BgL_prevz00_146, BgL_newzd2prevzd2_150); 
{ 
obj_t BgL_tailz00_3208;obj_t BgL_prevz00_3207;
BgL_prevz00_3207 = BgL_newzd2prevzd2_150; 
BgL_tailz00_3208 = 
CDR(BgL_tailz00_147); 
BgL_tailz00_147 = BgL_tailz00_3208; 
BgL_prevz00_146 = BgL_prevz00_3207; 
goto BgL_loopz00_148;} }  else 
{ BNIL; } 
return 
CDR(BgL_headz00_145);} } } 

}



/* encode-packets */
BGL_EXPORTED_DEF obj_t BGl_encodezd2packetszd2zz__openpgpzd2encodezd2(obj_t BgL_pz00_3, obj_t BgL_packetsz00_4)
{
{ /* Llib/pgp_encode.scm 18 */
{ 
obj_t BgL_l1154z00_154;
{ /* Llib/pgp_encode.scm 19 */
bool_t BgL_tmpz00_3211;
BgL_l1154z00_154 = BgL_packetsz00_4; 
BgL_zc3z04anonymousza31267ze3z87_155:
if(
PAIRP(BgL_l1154z00_154))
{ /* Llib/pgp_encode.scm 19 */
{ /* Llib/pgp_encode.scm 19 */
obj_t BgL_packetz00_157;
BgL_packetz00_157 = 
CAR(BgL_l1154z00_154); 
BGl_encodezd2packetzd2zz__openpgpzd2encodezd2(
((BgL_pgpzd2packetzd2_bglt)BgL_packetz00_157), BgL_pz00_3); } 
{ 
obj_t BgL_l1154z00_3217;
BgL_l1154z00_3217 = 
CDR(BgL_l1154z00_154); 
BgL_l1154z00_154 = BgL_l1154z00_3217; 
goto BgL_zc3z04anonymousza31267ze3z87_155;} }  else 
{ /* Llib/pgp_encode.scm 19 */
BgL_tmpz00_3211 = ((bool_t)1)
; } 
return 
BBOOL(BgL_tmpz00_3211);} } } 

}



/* &encode-packets */
obj_t BGl_z62encodezd2packetszb0zz__openpgpzd2encodezd2(obj_t BgL_envz00_2493, obj_t BgL_pz00_2494, obj_t BgL_packetsz00_2495)
{
{ /* Llib/pgp_encode.scm 18 */
{ /* Llib/pgp_encode.scm 19 */
obj_t BgL_auxz00_3220;
if(
OUTPUT_PORTP(BgL_pz00_2494))
{ /* Llib/pgp_encode.scm 19 */
BgL_auxz00_3220 = BgL_pz00_2494
; }  else 
{ 
obj_t BgL_auxz00_3223;
BgL_auxz00_3223 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2396z00zz__openpgpzd2encodezd2, 
BINT(((long)575)), BGl_string2397z00zz__openpgpzd2encodezd2, BGl_string2398z00zz__openpgpzd2encodezd2, BgL_pz00_2494); 
FAILURE(BgL_auxz00_3223,BFALSE,BFALSE);} 
return 
BGl_encodezd2packetszd2zz__openpgpzd2encodezd2(BgL_auxz00_3220, BgL_packetsz00_2495);} } 

}



/* encode-octet */
obj_t BGl_encodezd2octetzd2zz__openpgpzd2encodezd2(long BgL_nz00_5, obj_t BgL_pz00_6)
{
{ /* Llib/pgp_encode.scm 21 */
if(
(BgL_nz00_5>=((long)256)))
{ /* Llib/pgp_encode.scm 22 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2399z00zz__openpgpzd2encodezd2, 
BINT(BgL_nz00_5)); }  else 
{ /* Llib/pgp_encode.scm 22 */BFALSE; } 
{ /* Llib/pgp_encode.scm 26 */
unsigned char BgL_arg1300z00_802;
BgL_arg1300z00_802 = 
(BgL_nz00_5); 
return 
bgl_display_obj(
BCHAR(BgL_arg1300z00_802), BgL_pz00_6);} } 

}



/* encode-length-v4 */
obj_t BGl_encodezd2lengthzd2v4z00zz__openpgpzd2encodezd2(long BgL_lenz00_15, obj_t BgL_pz00_16)
{
{ /* Llib/pgp_encode.scm 46 */
if(
(BgL_lenz00_15<((long)192)))
{ /* Llib/pgp_encode.scm 48 */
if(
(BgL_lenz00_15>=((long)256)))
{ /* Llib/pgp_encode.scm 22 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2399z00zz__openpgpzd2encodezd2, 
BINT(BgL_lenz00_15)); }  else 
{ /* Llib/pgp_encode.scm 22 */BFALSE; } 
{ /* Llib/pgp_encode.scm 26 */
unsigned char BgL_arg1300z00_864;
BgL_arg1300z00_864 = 
(BgL_lenz00_15); 
return 
bgl_display_obj(
BCHAR(BgL_arg1300z00_864), BgL_pz00_16);} }  else 
{ /* Llib/pgp_encode.scm 48 */
if(
(BgL_lenz00_15<=((long)8383)))
{ /* Llib/pgp_encode.scm 52 */
long BgL_tz00_172;
BgL_tz00_172 = 
(BgL_lenz00_15-((long)192)); 
{ /* Llib/pgp_encode.scm 53 */
long BgL_arg1347z00_173;
BgL_arg1347z00_173 = 
(((long)192)+
(BgL_tz00_172 >> 
(int)(((long)8)))); 
if(
(BgL_arg1347z00_173>=((long)256)))
{ /* Llib/pgp_encode.scm 22 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2399z00zz__openpgpzd2encodezd2, 
BINT(BgL_arg1347z00_173)); }  else 
{ /* Llib/pgp_encode.scm 22 */BFALSE; } 
{ /* Llib/pgp_encode.scm 26 */
unsigned char BgL_arg1300z00_880;
BgL_arg1300z00_880 = 
(BgL_arg1347z00_173); 
bgl_display_obj(
BCHAR(BgL_arg1300z00_880), BgL_pz00_16); } } 
{ /* Llib/pgp_encode.scm 54 */
long BgL_arg1349z00_175;
BgL_arg1349z00_175 = 
(BgL_tz00_172 & ((long)255)); 
if(
(BgL_arg1349z00_175>=((long)256)))
{ /* Llib/pgp_encode.scm 22 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2399z00zz__openpgpzd2encodezd2, 
BINT(BgL_arg1349z00_175)); }  else 
{ /* Llib/pgp_encode.scm 22 */BFALSE; } 
{ /* Llib/pgp_encode.scm 26 */
unsigned char BgL_arg1300z00_890;
BgL_arg1300z00_890 = 
(BgL_arg1349z00_175); 
return 
bgl_display_obj(
BCHAR(BgL_arg1300z00_890), BgL_pz00_16);} } }  else 
{ /* Llib/pgp_encode.scm 51 */
if(
(((long)255)>=((long)256)))
{ /* Llib/pgp_encode.scm 22 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2399z00zz__openpgpzd2encodezd2, 
BINT(((long)255))); }  else 
{ /* Llib/pgp_encode.scm 22 */BFALSE; } 
{ /* Llib/pgp_encode.scm 26 */
unsigned char BgL_arg1300z00_897;
BgL_arg1300z00_897 = 
(((long)255)); 
bgl_display_obj(
BCHAR(BgL_arg1300z00_897), BgL_pz00_16); } 
return 
bgl_display_obj(
BGl_fixnumzd2ze3scalarz31zz__openpgpzd2conversionzd2(BgL_lenz00_15, ((long)4)), BgL_pz00_16);} } } 

}



/* encode-prefs */
bool_t BGl_encodezd2prefszd2zz__openpgpzd2encodezd2(obj_t BgL_prefsz00_19, obj_t BgL_converterz00_20, obj_t BgL_pz00_21)
{
{ /* Llib/pgp_encode.scm 62 */
{ 
obj_t BgL_l1156z00_178;
BgL_l1156z00_178 = BgL_prefsz00_19; 
BgL_zc3z04anonymousza31352ze3z87_179:
if(
PAIRP(BgL_l1156z00_178))
{ /* Llib/pgp_encode.scm 63 */
{ /* Llib/pgp_encode.scm 67 */
obj_t BgL_prefz00_181;
BgL_prefz00_181 = 
CAR(BgL_l1156z00_178); 
if(
INTEGERP(BgL_prefz00_181))
{ /* Llib/pgp_encode.scm 64 */BFALSE; }  else 
{ /* Llib/pgp_encode.scm 64 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)1)), BGl_string2400z00zz__openpgpzd2encodezd2, BgL_prefz00_181); } 
{ /* Llib/pgp_encode.scm 68 */
obj_t BgL_arg1383z00_183;
BgL_arg1383z00_183 = 
PROCEDURE_ENTRY(BgL_converterz00_20)(BgL_converterz00_20, BgL_prefz00_181, BEOA); 
{ /* Llib/pgp_encode.scm 68 */
long BgL_nz00_912;
BgL_nz00_912 = 
(long)CINT(BgL_arg1383z00_183); 
if(
(BgL_nz00_912>=((long)256)))
{ /* Llib/pgp_encode.scm 22 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2399z00zz__openpgpzd2encodezd2, 
BINT(BgL_nz00_912)); }  else 
{ /* Llib/pgp_encode.scm 22 */BFALSE; } 
{ /* Llib/pgp_encode.scm 26 */
unsigned char BgL_arg1300z00_915;
BgL_arg1300z00_915 = 
(BgL_nz00_912); 
bgl_display_obj(
BCHAR(BgL_arg1300z00_915), BgL_pz00_21); } } } } 
{ 
obj_t BgL_l1156z00_3299;
BgL_l1156z00_3299 = 
CDR(BgL_l1156z00_178); 
BgL_l1156z00_178 = BgL_l1156z00_3299; 
goto BgL_zc3z04anonymousza31352ze3z87_179;} }  else 
{ /* Llib/pgp_encode.scm 63 */
return ((bool_t)1);} } } 

}



/* encode-packet */
BGL_EXPORTED_DEF obj_t BGl_encodezd2packetzd2zz__openpgpzd2encodezd2(BgL_pgpzd2packetzd2_bglt BgL_packetz00_36, obj_t BgL_pz00_37)
{
{ /* Llib/pgp_encode.scm 110 */
{ /* Llib/pgp_encode.scm 111 */
obj_t BgL_contentzd2tagzd2_186;
BgL_contentzd2tagzd2_186 = 
BGl_packetzd2ze3contentzd2tagze3zz__openpgpzd2encodezd2(BgL_packetz00_36); 
{ /* Llib/pgp_encode.scm 111 */
char BgL_contentzd2tagzd2bytez00_187;
BgL_contentzd2tagzd2bytez00_187 = 
BGl_contentzd2tagzd2ze3byteze3zz__openpgpzd2enumszd2(BgL_contentzd2tagzd2_186); 
{ /* Llib/pgp_encode.scm 113 */
obj_t BgL_strzd2pzd2_189;
{ /* Llib/pgp_encode.scm 115 */

{ /* Llib/pgp_encode.scm 115 */

BgL_strzd2pzd2_189 = 
BGl_openzd2outputzd2stringz00zz__r4_ports_6_10_1z00(BTRUE); } } 
{ /* Llib/pgp_encode.scm 115 */
obj_t BgL_contentz00_190;
BgL_contentz00_190 = 
BGl_encodezd2contentzd2zz__openpgpzd2encodezd2(BgL_packetz00_36, BgL_strzd2pzd2_189); 
{ /* Llib/pgp_encode.scm 116 */
obj_t BgL_strz00_191;
BgL_strz00_191 = 
bgl_close_output_port(BgL_strzd2pzd2_189); 
{ /* Llib/pgp_encode.scm 117 */
long BgL_lenz00_192;
BgL_lenz00_192 = 
STRING_LENGTH(
((obj_t)BgL_strz00_191)); 
{ /* Llib/pgp_encode.scm 118 */

if(
(
(long)(BgL_contentzd2tagzd2bytez00_187)>((long)31)))
{ /* Llib/pgp_encode.scm 119 */
BGl_errorz00zz__errorz00(BGl_string2401z00zz__openpgpzd2encodezd2, BGl_string2402z00zz__openpgpzd2encodezd2, BgL_contentzd2tagzd2_186); }  else 
{ /* Llib/pgp_encode.scm 119 */BFALSE; } 
{ /* Llib/pgp_encode.scm 124 */
long BgL_arg1505z00_194;
BgL_arg1505z00_194 = 
(((long)128)+
(((long)64)+
(long)(BgL_contentzd2tagzd2bytez00_187))); 
if(
(BgL_arg1505z00_194>=((long)256)))
{ /* Llib/pgp_encode.scm 22 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2399z00zz__openpgpzd2encodezd2, 
BINT(BgL_arg1505z00_194)); }  else 
{ /* Llib/pgp_encode.scm 22 */BFALSE; } 
{ /* Llib/pgp_encode.scm 26 */
unsigned char BgL_arg1300z00_933;
BgL_arg1300z00_933 = 
(BgL_arg1505z00_194); 
bgl_display_obj(
BCHAR(BgL_arg1300z00_933), BgL_pz00_37); } } 
BGl_encodezd2lengthzd2v4z00zz__openpgpzd2encodezd2(BgL_lenz00_192, BgL_pz00_37); 
return 
bgl_display_obj(BgL_strz00_191, BgL_pz00_37);} } } } } } } } 

}



/* &encode-packet */
obj_t BGl_z62encodezd2packetzb0zz__openpgpzd2encodezd2(obj_t BgL_envz00_2496, obj_t BgL_packetz00_2497, obj_t BgL_pz00_2498)
{
{ /* Llib/pgp_encode.scm 110 */
{ /* Llib/pgp_encode.scm 111 */
obj_t BgL_auxz00_3333;BgL_pgpzd2packetzd2_bglt BgL_auxz00_3325;
if(
OUTPUT_PORTP(BgL_pz00_2498))
{ /* Llib/pgp_encode.scm 111 */
BgL_auxz00_3333 = BgL_pz00_2498
; }  else 
{ 
obj_t BgL_auxz00_3336;
BgL_auxz00_3336 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2396z00zz__openpgpzd2encodezd2, 
BINT(((long)3698)), BGl_string2403z00zz__openpgpzd2encodezd2, BGl_string2398z00zz__openpgpzd2encodezd2, BgL_pz00_2498); 
FAILURE(BgL_auxz00_3336,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_packetz00_2497, BGl_PGPzd2Packetzd2zz__openpgpzd2packetszd2))
{ /* Llib/pgp_encode.scm 111 */
BgL_auxz00_3325 = 
((BgL_pgpzd2packetzd2_bglt)BgL_packetz00_2497)
; }  else 
{ 
obj_t BgL_auxz00_3329;
BgL_auxz00_3329 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2396z00zz__openpgpzd2encodezd2, 
BINT(((long)3698)), BGl_string2403z00zz__openpgpzd2encodezd2, BGl_string2404z00zz__openpgpzd2encodezd2, BgL_packetz00_2497); 
FAILURE(BgL_auxz00_3329,BFALSE,BFALSE);} 
return 
BGl_encodezd2packetzd2zz__openpgpzd2encodezd2(BgL_auxz00_3325, BgL_auxz00_3333);} } 

}



/* encode-sub-packets */
obj_t BGl_encodezd2subzd2packetsz00zz__openpgpzd2encodezd2(obj_t BgL_packetsz00_85, obj_t BgL_pz00_86)
{
{ /* Llib/pgp_encode.scm 282 */
{ /* Llib/pgp_encode.scm 283 */
obj_t BgL_strzd2pzd2_204;
{ /* Llib/pgp_encode.scm 283 */

{ /* Llib/pgp_encode.scm 283 */

BgL_strzd2pzd2_204 = 
BGl_openzd2outputzd2stringz00zz__r4_ports_6_10_1z00(BTRUE); } } 
{ 
obj_t BgL_l1158z00_206;
BgL_l1158z00_206 = BgL_packetsz00_85; 
BgL_zc3z04anonymousza31526ze3z87_207:
if(
PAIRP(BgL_l1158z00_206))
{ /* Llib/pgp_encode.scm 284 */
{ /* Llib/pgp_encode.scm 285 */
obj_t BgL_spacketz00_209;
BgL_spacketz00_209 = 
CAR(BgL_l1158z00_206); 
{ /* Llib/pgp_encode.scm 163 */
obj_t BgL_strzd2pzd2_970;
{ /* Llib/pgp_encode.scm 163 */

{ /* Llib/pgp_encode.scm 163 */

BgL_strzd2pzd2_970 = 
BGl_openzd2outputzd2stringz00zz__r4_ports_6_10_1z00(BTRUE); } } 
BGl_encodezd2subzd2packetzd2contentzd2zz__openpgpzd2encodezd2(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)BgL_spacketz00_209), BgL_strzd2pzd2_970); 
{ /* Llib/pgp_encode.scm 165 */
obj_t BgL_strz00_972;
BgL_strz00_972 = 
bgl_close_output_port(BgL_strzd2pzd2_970); 
{ /* Llib/pgp_encode.scm 166 */
long BgL_arg1517z00_973;
BgL_arg1517z00_973 = 
STRING_LENGTH(
((obj_t)BgL_strz00_972)); 
BGl_encodezd2lengthzd2v4z00zz__openpgpzd2encodezd2(BgL_arg1517z00_973, BgL_strzd2pzd2_204); } 
bgl_display_obj(BgL_strz00_972, BgL_strzd2pzd2_204); } } } 
{ 
obj_t BgL_l1158z00_3353;
BgL_l1158z00_3353 = 
CDR(BgL_l1158z00_206); 
BgL_l1158z00_206 = BgL_l1158z00_3353; 
goto BgL_zc3z04anonymousza31526ze3z87_207;} }  else 
{ /* Llib/pgp_encode.scm 284 */((bool_t)1); } } 
{ /* Llib/pgp_encode.scm 287 */
obj_t BgL_strz00_212;
BgL_strz00_212 = 
bgl_close_output_port(BgL_strzd2pzd2_204); 
{ /* Llib/pgp_encode.scm 288 */
long BgL_arg1545z00_213;
BgL_arg1545z00_213 = 
STRING_LENGTH(
((obj_t)BgL_strz00_212)); 
bgl_display_obj(
BGl_fixnumzd2ze3scalarz31zz__openpgpzd2conversionzd2(BgL_arg1545z00_213, ((long)2)), BgL_pz00_86); } 
return 
bgl_display_obj(BgL_strz00_212, BgL_pz00_86);} } } 

}



/* create-signed-packet-prefix-v4 */
BGL_EXPORTED_DEF obj_t BGl_createzd2signedzd2packetzd2prefixzd2v4z00zz__openpgpzd2encodezd2(obj_t BgL_signaturezd2typezd2_89, obj_t BgL_publiczd2keyzd2algoz00_90, obj_t BgL_hashzd2algozd2_91, obj_t BgL_creationzd2datezd2_92, obj_t BgL_signedzd2subzd2packetsz00_93)
{
{ /* Llib/pgp_encode.scm 298 */
{ /* Llib/pgp_encode.scm 304 */
obj_t BgL_strzd2pzd2_219;obj_t BgL_creationzd2timezd2packetz00_221;char BgL_publiczd2keyzd2algozd2bytezd2_222;char BgL_hashzd2algozd2bytez00_223;char BgL_signaturezd2typezd2bytez00_224;
{ /* Llib/pgp_encode.scm 304 */

{ /* Llib/pgp_encode.scm 304 */

BgL_strzd2pzd2_219 = 
BGl_openzd2outputzd2stringz00zz__r4_ports_6_10_1z00(BTRUE); } } 
{ 
obj_t BgL_l1160z00_247;
BgL_l1160z00_247 = BgL_signedzd2subzd2packetsz00_93; 
BgL_zc3z04anonymousza31580ze3z87_248:
if(
NULLP(BgL_l1160z00_247))
{ /* Llib/pgp_encode.scm 307 */
BgL_creationzd2timezd2packetz00_221 = BFALSE; }  else 
{ /* Llib/pgp_encode.scm 308 */
obj_t BgL__ortest_1162z00_250;
{ /* Llib/pgp_encode.scm 308 */
obj_t BgL_pz00_252;
BgL_pz00_252 = 
CAR(
((obj_t)BgL_l1160z00_247)); 
if(
BGl_isazf3zf3zz__objectz00(BgL_pz00_252, BGl_PGPzd2Signaturezd2Subzd2Creationzd2Timez00zz__openpgpzd2packetszd2))
{ /* Llib/pgp_encode.scm 308 */
BgL__ortest_1162z00_250 = BgL_pz00_252; }  else 
{ /* Llib/pgp_encode.scm 308 */
BgL__ortest_1162z00_250 = BFALSE; } } 
if(
CBOOL(BgL__ortest_1162z00_250))
{ /* Llib/pgp_encode.scm 307 */
BgL_creationzd2timezd2packetz00_221 = BgL__ortest_1162z00_250; }  else 
{ 
obj_t BgL_l1160z00_3370;
BgL_l1160z00_3370 = 
CDR(
((obj_t)BgL_l1160z00_247)); 
BgL_l1160z00_247 = BgL_l1160z00_3370; 
goto BgL_zc3z04anonymousza31580ze3z87_248;} } } 
BgL_publiczd2keyzd2algozd2bytezd2_222 = 
BGl_publiczd2keyzd2algozd2ze3bytez31zz__openpgpzd2enumszd2(BgL_publiczd2keyzd2algoz00_90); 
BgL_hashzd2algozd2bytez00_223 = 
BGl_hashzd2algozd2ze3byteze3zz__openpgpzd2enumszd2(BgL_hashzd2algozd2_91); 
BgL_signaturezd2typezd2bytez00_224 = 
BGl_signaturezd2typezd2ze3byteze3zz__openpgpzd2enumszd2(BgL_signaturezd2typezd2_89); 
if(
(((long)4)>=((long)256)))
{ /* Llib/pgp_encode.scm 22 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2399z00zz__openpgpzd2encodezd2, 
BINT(((long)4))); }  else 
{ /* Llib/pgp_encode.scm 22 */BFALSE; } 
{ /* Llib/pgp_encode.scm 26 */
unsigned char BgL_arg1300z00_1003;
BgL_arg1300z00_1003 = 
(((long)4)); 
bgl_display_obj(
BCHAR(BgL_arg1300z00_1003), BgL_strzd2pzd2_219); } 
{ /* Llib/pgp_encode.scm 322 */
long BgL_nz00_1008;
BgL_nz00_1008 = 
(long)(BgL_signaturezd2typezd2bytez00_224); 
if(
(BgL_nz00_1008>=((long)256)))
{ /* Llib/pgp_encode.scm 22 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2399z00zz__openpgpzd2encodezd2, 
BINT(BgL_nz00_1008)); }  else 
{ /* Llib/pgp_encode.scm 22 */BFALSE; } 
{ /* Llib/pgp_encode.scm 26 */
unsigned char BgL_arg1300z00_1011;
BgL_arg1300z00_1011 = 
(BgL_nz00_1008); 
bgl_display_obj(
BCHAR(BgL_arg1300z00_1011), BgL_strzd2pzd2_219); } } 
{ /* Llib/pgp_encode.scm 323 */
long BgL_nz00_1016;
BgL_nz00_1016 = 
(long)(BgL_publiczd2keyzd2algozd2bytezd2_222); 
if(
(BgL_nz00_1016>=((long)256)))
{ /* Llib/pgp_encode.scm 22 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2399z00zz__openpgpzd2encodezd2, 
BINT(BgL_nz00_1016)); }  else 
{ /* Llib/pgp_encode.scm 22 */BFALSE; } 
{ /* Llib/pgp_encode.scm 26 */
unsigned char BgL_arg1300z00_1019;
BgL_arg1300z00_1019 = 
(BgL_nz00_1016); 
bgl_display_obj(
BCHAR(BgL_arg1300z00_1019), BgL_strzd2pzd2_219); } } 
{ /* Llib/pgp_encode.scm 324 */
long BgL_nz00_1024;
BgL_nz00_1024 = 
(long)(BgL_hashzd2algozd2bytez00_223); 
if(
(BgL_nz00_1024>=((long)256)))
{ /* Llib/pgp_encode.scm 22 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2399z00zz__openpgpzd2encodezd2, 
BINT(BgL_nz00_1024)); }  else 
{ /* Llib/pgp_encode.scm 22 */BFALSE; } 
{ /* Llib/pgp_encode.scm 26 */
unsigned char BgL_arg1300z00_1027;
BgL_arg1300z00_1027 = 
(BgL_nz00_1024); 
bgl_display_obj(
BCHAR(BgL_arg1300z00_1027), BgL_strzd2pzd2_219); } } 
{ /* Llib/pgp_encode.scm 326 */
bool_t BgL_test2632z00_3411;
if(
BGL_DATEP(BgL_creationzd2datezd2_92))
{ /* Llib/pgp_encode.scm 326 */
BgL_test2632z00_3411 = ((bool_t)0)
; }  else 
{ /* Llib/pgp_encode.scm 326 */
if(
CBOOL(BgL_creationzd2timezd2packetz00_221))
{ /* Llib/pgp_encode.scm 327 */
BgL_test2632z00_3411 = ((bool_t)0)
; }  else 
{ /* Llib/pgp_encode.scm 327 */
BgL_test2632z00_3411 = ((bool_t)1)
; } } 
if(BgL_test2632z00_3411)
{ /* Llib/pgp_encode.scm 326 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)2)), BGl_string2405z00zz__openpgpzd2encodezd2, BFALSE); }  else 
{ /* Llib/pgp_encode.scm 331 */
bool_t BgL_test2635z00_3418;
if(
BGL_DATEP(BgL_creationzd2datezd2_92))
{ /* Llib/pgp_encode.scm 331 */
if(
CBOOL(BgL_creationzd2timezd2packetz00_221))
{ /* Llib/pgp_encode.scm 335 */
obj_t BgL_arg1579z00_242;
BgL_arg1579z00_242 = 
(((BgL_pgpzd2signaturezd2subzd2creationzd2timez00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2creationzd2timez00_bglt)BgL_creationzd2timezd2packetz00_221)))->BgL_creationzd2datezd2); 
{ /* Llib/pgp_encode.scm 294 */
long BgL_arg1546z00_1036;long BgL_arg1547z00_1037;
BgL_arg1546z00_1036 = 
bgl_date_to_seconds(BgL_creationzd2datezd2_92); 
BgL_arg1547z00_1037 = 
bgl_date_to_seconds(BgL_arg1579z00_242); 
{ /* Llib/pgp_encode.scm 294 */
long BgL_n1z00_1044;long BgL_n2z00_1045;
BgL_n1z00_1044 = 
(long)(BgL_arg1546z00_1036); 
BgL_n2z00_1045 = 
(long)(BgL_arg1547z00_1037); 
BgL_test2635z00_3418 = 
(BgL_n1z00_1044==BgL_n2z00_1045); } } }  else 
{ /* Llib/pgp_encode.scm 333 */
BgL_test2635z00_3418 = ((bool_t)0)
; } }  else 
{ /* Llib/pgp_encode.scm 331 */
BgL_test2635z00_3418 = ((bool_t)1)
; } 
if(BgL_test2635z00_3418)
{ /* Llib/pgp_encode.scm 331 */
BGl_encodezd2subzd2packetsz00zz__openpgpzd2encodezd2(BgL_signedzd2subzd2packetsz00_93, BgL_strzd2pzd2_219); }  else 
{ /* Llib/pgp_encode.scm 339 */
bool_t BgL_test2638z00_3431;
if(
BGL_DATEP(BgL_creationzd2datezd2_92))
{ /* Llib/pgp_encode.scm 339 */
BgL_test2638z00_3431 = 
CBOOL(BgL_creationzd2timezd2packetz00_221)
; }  else 
{ /* Llib/pgp_encode.scm 339 */
BgL_test2638z00_3431 = ((bool_t)0)
; } 
if(BgL_test2638z00_3431)
{ /* Llib/pgp_encode.scm 339 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)2)), BGl_string2406z00zz__openpgpzd2encodezd2, BgL_creationzd2datezd2_92); }  else 
{ /* Llib/pgp_encode.scm 345 */
BgL_pgpzd2signaturezd2subzd2creationzd2timez00_bglt BgL_packetz00_234;
{ /* Llib/pgp_encode.scm 345 */
BgL_pgpzd2signaturezd2subzd2creationzd2timez00_bglt BgL_new1130z00_236;
{ /* Llib/pgp_encode.scm 346 */
BgL_pgpzd2signaturezd2subzd2creationzd2timez00_bglt BgL_new1129z00_237;
BgL_new1129z00_237 = 
((BgL_pgpzd2signaturezd2subzd2creationzd2timez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2subzd2creationzd2timez00_bgl) ))); 
{ /* Llib/pgp_encode.scm 346 */
long BgL_arg1578z00_238;
{ /* Llib/pgp_encode.scm 346 */
long BgL_res2004z00_1049;
BgL_res2004z00_1049 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2Subzd2Creationzd2Timez00zz__openpgpzd2packetszd2); 
BgL_arg1578z00_238 = BgL_res2004z00_1049; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1129z00_237), BgL_arg1578z00_238); } 
{ /* Llib/pgp_encode.scm 346 */
BgL_objectz00_bglt BgL_tmpz00_3441;
BgL_tmpz00_3441 = 
((BgL_objectz00_bglt)BgL_new1129z00_237); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3441, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1129z00_237); 
BgL_new1130z00_236 = BgL_new1129z00_237; } 
((((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)BgL_new1130z00_236)))->BgL_criticalzf3zf3)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2creationzd2timez00_bglt)COBJECT(BgL_new1130z00_236))->BgL_creationzd2datezd2)=((obj_t)BgL_creationzd2datezd2_92),BUNSPEC); 
BgL_packetz00_234 = BgL_new1130z00_236; } 
{ /* Llib/pgp_encode.scm 348 */
obj_t BgL_arg1577z00_235;
BgL_arg1577z00_235 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_packetz00_234), BgL_signedzd2subzd2packetsz00_93); 
BGl_encodezd2subzd2packetsz00zz__openpgpzd2encodezd2(BgL_arg1577z00_235, BgL_strzd2pzd2_219); } } } } } 
return 
bgl_close_output_port(BgL_strzd2pzd2_219);} } 

}



/* &create-signed-packet-prefix-v4 */
obj_t BGl_z62createzd2signedzd2packetzd2prefixzd2v4z62zz__openpgpzd2encodezd2(obj_t BgL_envz00_2499, obj_t BgL_signaturezd2typezd2_2500, obj_t BgL_publiczd2keyzd2algoz00_2501, obj_t BgL_hashzd2algozd2_2502, obj_t BgL_creationzd2datezd2_2503, obj_t BgL_signedzd2subzd2packetsz00_2504)
{
{ /* Llib/pgp_encode.scm 298 */
{ /* Llib/pgp_encode.scm 304 */
obj_t BgL_auxz00_3473;obj_t BgL_auxz00_3466;obj_t BgL_auxz00_3459;obj_t BgL_auxz00_3452;
if(
BGl_pairzd2orzd2nullzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_signedzd2subzd2packetsz00_2504))
{ /* Llib/pgp_encode.scm 304 */
BgL_auxz00_3473 = BgL_signedzd2subzd2packetsz00_2504
; }  else 
{ 
obj_t BgL_auxz00_3476;
BgL_auxz00_3476 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2396z00zz__openpgpzd2encodezd2, 
BINT(((long)12287)), BGl_string2407z00zz__openpgpzd2encodezd2, BGl_string2409z00zz__openpgpzd2encodezd2, BgL_signedzd2subzd2packetsz00_2504); 
FAILURE(BgL_auxz00_3476,BFALSE,BFALSE);} 
if(
SYMBOLP(BgL_hashzd2algozd2_2502))
{ /* Llib/pgp_encode.scm 304 */
BgL_auxz00_3466 = BgL_hashzd2algozd2_2502
; }  else 
{ 
obj_t BgL_auxz00_3469;
BgL_auxz00_3469 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2396z00zz__openpgpzd2encodezd2, 
BINT(((long)12287)), BGl_string2407z00zz__openpgpzd2encodezd2, BGl_string2408z00zz__openpgpzd2encodezd2, BgL_hashzd2algozd2_2502); 
FAILURE(BgL_auxz00_3469,BFALSE,BFALSE);} 
if(
SYMBOLP(BgL_publiczd2keyzd2algoz00_2501))
{ /* Llib/pgp_encode.scm 304 */
BgL_auxz00_3459 = BgL_publiczd2keyzd2algoz00_2501
; }  else 
{ 
obj_t BgL_auxz00_3462;
BgL_auxz00_3462 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2396z00zz__openpgpzd2encodezd2, 
BINT(((long)12287)), BGl_string2407z00zz__openpgpzd2encodezd2, BGl_string2408z00zz__openpgpzd2encodezd2, BgL_publiczd2keyzd2algoz00_2501); 
FAILURE(BgL_auxz00_3462,BFALSE,BFALSE);} 
if(
SYMBOLP(BgL_signaturezd2typezd2_2500))
{ /* Llib/pgp_encode.scm 304 */
BgL_auxz00_3452 = BgL_signaturezd2typezd2_2500
; }  else 
{ 
obj_t BgL_auxz00_3455;
BgL_auxz00_3455 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2396z00zz__openpgpzd2encodezd2, 
BINT(((long)12287)), BGl_string2407z00zz__openpgpzd2encodezd2, BGl_string2408z00zz__openpgpzd2encodezd2, BgL_signaturezd2typezd2_2500); 
FAILURE(BgL_auxz00_3455,BFALSE,BFALSE);} 
return 
BGl_createzd2signedzd2packetzd2prefixzd2v4z00zz__openpgpzd2encodezd2(BgL_auxz00_3452, BgL_auxz00_3459, BgL_auxz00_3466, BgL_creationzd2datezd2_2503, BgL_auxz00_3473);} } 

}



/* encode-insecure-sub-packets */
obj_t BGl_encodezd2insecurezd2subzd2packetszd2zz__openpgpzd2encodezd2(obj_t BgL_securezd2packetszd2_94, obj_t BgL_insecurezd2packetszd2_95, obj_t BgL_issuerz00_96, obj_t BgL_pz00_97)
{
{ /* Llib/pgp_encode.scm 352 */
{ /* Llib/pgp_encode.scm 355 */
obj_t BgL_issuerzd2packetzd2_255;
{ /* Llib/pgp_encode.scm 355 */
obj_t BgL_g1165z00_266;
BgL_g1165z00_266 = 
BGl_appendzd221010zd2zz__openpgpzd2encodezd2(BgL_insecurezd2packetszd2_95, BgL_securezd2packetszd2_94); 
{ 
obj_t BgL_l1163z00_268;
BgL_l1163z00_268 = BgL_g1165z00_266; 
BgL_zc3z04anonymousza31617ze3z87_269:
if(
NULLP(BgL_l1163z00_268))
{ /* Llib/pgp_encode.scm 357 */
BgL_issuerzd2packetzd2_255 = BFALSE; }  else 
{ /* Llib/pgp_encode.scm 356 */
obj_t BgL__ortest_1166z00_271;
{ /* Llib/pgp_encode.scm 356 */
obj_t BgL_pz00_273;
BgL_pz00_273 = 
CAR(
((obj_t)BgL_l1163z00_268)); 
if(
BGl_isazf3zf3zz__objectz00(BgL_pz00_273, BGl_PGPzd2Signaturezd2Subzd2IDzd2zz__openpgpzd2packetszd2))
{ /* Llib/pgp_encode.scm 356 */
BgL__ortest_1166z00_271 = BgL_pz00_273; }  else 
{ /* Llib/pgp_encode.scm 356 */
BgL__ortest_1166z00_271 = BFALSE; } } 
if(
CBOOL(BgL__ortest_1166z00_271))
{ /* Llib/pgp_encode.scm 357 */
BgL_issuerzd2packetzd2_255 = BgL__ortest_1166z00_271; }  else 
{ 
obj_t BgL_l1163z00_3490;
BgL_l1163z00_3490 = 
CDR(
((obj_t)BgL_l1163z00_268)); 
BgL_l1163z00_268 = BgL_l1163z00_3490; 
goto BgL_zc3z04anonymousza31617ze3z87_269;} } } } 
if(
CBOOL(BgL_issuerzd2packetzd2_255))
{ /* Llib/pgp_encode.scm 359 */
if(
bigloo_strcmp(
((obj_t)BgL_issuerz00_96), 
(((BgL_pgpzd2signaturezd2subzd2idzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2idzd2_bglt)BgL_issuerzd2packetzd2_255)))->BgL_keyzd2idzd2)))
{ /* Llib/pgp_encode.scm 364 */
return 
BGl_encodezd2subzd2packetsz00zz__openpgpzd2encodezd2(BgL_insecurezd2packetszd2_95, BgL_pz00_97);}  else 
{ /* Llib/pgp_encode.scm 364 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)3)), BGl_string2410z00zz__openpgpzd2encodezd2, BgL_issuerz00_96);} }  else 
{ /* Llib/pgp_encode.scm 360 */
BgL_pgpzd2signaturezd2subzd2idzd2_bglt BgL_newzd2pzd2_261;
{ /* Llib/pgp_encode.scm 360 */
BgL_pgpzd2signaturezd2subzd2idzd2_bglt BgL_new1133z00_263;
{ /* Llib/pgp_encode.scm 361 */
BgL_pgpzd2signaturezd2subzd2idzd2_bglt BgL_new1132z00_264;
BgL_new1132z00_264 = 
((BgL_pgpzd2signaturezd2subzd2idzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2subzd2idzd2_bgl) ))); 
{ /* Llib/pgp_encode.scm 361 */
long BgL_arg1616z00_265;
{ /* Llib/pgp_encode.scm 361 */
long BgL_res2007z00_1061;
BgL_res2007z00_1061 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2Subzd2IDzd2zz__openpgpzd2packetszd2); 
BgL_arg1616z00_265 = BgL_res2007z00_1061; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1132z00_264), BgL_arg1616z00_265); } 
{ /* Llib/pgp_encode.scm 361 */
BgL_objectz00_bglt BgL_tmpz00_3507;
BgL_tmpz00_3507 = 
((BgL_objectz00_bglt)BgL_new1132z00_264); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3507, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1132z00_264); 
BgL_new1133z00_263 = BgL_new1132z00_264; } 
((((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)BgL_new1133z00_263)))->BgL_criticalzf3zf3)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2idzd2_bglt)COBJECT(BgL_new1133z00_263))->BgL_keyzd2idzd2)=((obj_t)BgL_issuerz00_96),BUNSPEC); 
BgL_newzd2pzd2_261 = BgL_new1133z00_263; } 
{ /* Llib/pgp_encode.scm 363 */
obj_t BgL_arg1613z00_262;
BgL_arg1613z00_262 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_newzd2pzd2_261), BgL_insecurezd2packetszd2_95); 
return 
BGl_encodezd2subzd2packetsz00zz__openpgpzd2encodezd2(BgL_arg1613z00_262, BgL_pz00_97);} } } } 

}



/* encode-s2k */
obj_t BGl_encodezd2s2kzd2zz__openpgpzd2encodezd2(obj_t BgL_s2kz00_100, obj_t BgL_pz00_101)
{
{ /* Llib/pgp_encode.scm 409 */
{ /* Llib/pgp_encode.scm 411 */
obj_t BgL_algoz00_276;
BgL_algoz00_276 = 
BGl_s2kzd2algozd2zz__openpgpzd2s2kzd2(BgL_s2kz00_100); 
{ /* Llib/pgp_encode.scm 411 */
char BgL_algozd2bytezd2_277;
BgL_algozd2bytezd2_277 = 
BGl_s2kzd2algozd2ze3byteze3zz__openpgpzd2enumszd2(BgL_algoz00_276); 
{ /* Llib/pgp_encode.scm 412 */
obj_t BgL_hashz00_278;
BgL_hashz00_278 = 
BGl_s2kzd2hashzd2zz__openpgpzd2s2kzd2(BgL_s2kz00_100); 
{ /* Llib/pgp_encode.scm 413 */
char BgL_hashzd2bytezd2_279;
BgL_hashzd2bytezd2_279 = 
BGl_hashzd2algozd2ze3byteze3zz__openpgpzd2enumszd2(BgL_hashz00_278); 
{ /* Llib/pgp_encode.scm 414 */
obj_t BgL_saltz00_280;
BgL_saltz00_280 = 
BGl_s2kzd2saltzd2zz__openpgpzd2s2kzd2(BgL_s2kz00_100); 
{ /* Llib/pgp_encode.scm 415 */
obj_t BgL_countz00_281;
BgL_countz00_281 = 
BGl_s2kzd2countzd2zz__openpgpzd2s2kzd2(BgL_s2kz00_100); 
{ /* Llib/pgp_encode.scm 416 */

{ /* Llib/pgp_encode.scm 420 */
long BgL_nz00_1065;
BgL_nz00_1065 = 
(long)(BgL_algozd2bytezd2_277); 
if(
(BgL_nz00_1065>=((long)256)))
{ /* Llib/pgp_encode.scm 22 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2399z00zz__openpgpzd2encodezd2, 
BINT(BgL_nz00_1065)); }  else 
{ /* Llib/pgp_encode.scm 22 */BFALSE; } 
{ /* Llib/pgp_encode.scm 26 */
unsigned char BgL_arg1300z00_1068;
BgL_arg1300z00_1068 = 
(BgL_nz00_1065); 
bgl_display_obj(
BCHAR(BgL_arg1300z00_1068), BgL_pz00_101); } } 
{ /* Llib/pgp_encode.scm 421 */
long BgL_nz00_1073;
BgL_nz00_1073 = 
(long)(BgL_hashzd2bytezd2_279); 
if(
(BgL_nz00_1073>=((long)256)))
{ /* Llib/pgp_encode.scm 22 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2399z00zz__openpgpzd2encodezd2, 
BINT(BgL_nz00_1073)); }  else 
{ /* Llib/pgp_encode.scm 22 */BFALSE; } 
{ /* Llib/pgp_encode.scm 26 */
unsigned char BgL_arg1300z00_1076;
BgL_arg1300z00_1076 = 
(BgL_nz00_1073); 
bgl_display_obj(
BCHAR(BgL_arg1300z00_1076), BgL_pz00_101); } } 
if(
(BgL_algoz00_276==
CNST_TABLE_REF(((long)4))))
{ /* Llib/pgp_encode.scm 422 */
return 
CNST_TABLE_REF(((long)5));}  else 
{ /* Llib/pgp_encode.scm 422 */
if(
(BgL_algoz00_276==
CNST_TABLE_REF(((long)6))))
{ /* Llib/pgp_encode.scm 422 */
if(
STRINGP(BgL_saltz00_280))
{ /* Llib/pgp_encode.scm 426 */BFALSE; }  else 
{ /* Llib/pgp_encode.scm 426 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)7)), BGl_string2411z00zz__openpgpzd2encodezd2, BgL_saltz00_280); } 
{ /* Llib/pgp_encode.scm 431 */
int BgL_arg1645z00_286;
BgL_arg1645z00_286 = 
BGl_s2kzd2saltzd2lengthz00zz__openpgpzd2s2kzd2(); 
{ /* Llib/pgp_encode.scm 431 */
long BgL_lenz00_1087;
BgL_lenz00_1087 = 
(long)(BgL_arg1645z00_286); 
if(
(
STRING_LENGTH(
((obj_t)BgL_saltz00_280))==BgL_lenz00_1087))
{ /* Llib/pgp_encode.scm 28 */BFALSE; }  else 
{ /* Llib/pgp_encode.scm 31 */
obj_t BgL_arg1330z00_1091;
BgL_arg1330z00_1091 = 
MAKE_YOUNG_PAIR(
BINT(BgL_lenz00_1087), 
((obj_t)BgL_saltz00_280)); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)8)), BGl_string2412z00zz__openpgpzd2encodezd2, BgL_arg1330z00_1091); } 
return 
bgl_display_obj(
((obj_t)BgL_saltz00_280), BgL_pz00_101);} } }  else 
{ /* Llib/pgp_encode.scm 422 */
if(
(BgL_algoz00_276==
CNST_TABLE_REF(((long)9))))
{ /* Llib/pgp_encode.scm 422 */
if(
STRINGP(BgL_saltz00_280))
{ /* Llib/pgp_encode.scm 433 */BFALSE; }  else 
{ /* Llib/pgp_encode.scm 433 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)7)), BGl_string2411z00zz__openpgpzd2encodezd2, BgL_saltz00_280); } 
if(
INTEGERP(BgL_countz00_281))
{ /* Llib/pgp_encode.scm 437 */BFALSE; }  else 
{ /* Llib/pgp_encode.scm 437 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)7)), BGl_string2413z00zz__openpgpzd2encodezd2, BgL_countz00_281); } 
{ /* Llib/pgp_encode.scm 441 */
long BgL_encodedzd2countzd2_290;
BgL_encodedzd2countzd2_290 = 
BGl_iteratedzd2saltedzd2s2kzd2countzd2ze3octetze3zz__openpgpzd2s2kzd2(
(long)CINT(BgL_countz00_281)); 
{ /* Llib/pgp_encode.scm 444 */
int BgL_arg1650z00_291;
BgL_arg1650z00_291 = 
BGl_s2kzd2saltzd2lengthz00zz__openpgpzd2s2kzd2(); 
{ /* Llib/pgp_encode.scm 444 */
long BgL_lenz00_1102;
BgL_lenz00_1102 = 
(long)(BgL_arg1650z00_291); 
if(
(
STRING_LENGTH(
((obj_t)BgL_saltz00_280))==BgL_lenz00_1102))
{ /* Llib/pgp_encode.scm 28 */BFALSE; }  else 
{ /* Llib/pgp_encode.scm 31 */
obj_t BgL_arg1330z00_1106;
BgL_arg1330z00_1106 = 
MAKE_YOUNG_PAIR(
BINT(BgL_lenz00_1102), 
((obj_t)BgL_saltz00_280)); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)8)), BGl_string2412z00zz__openpgpzd2encodezd2, BgL_arg1330z00_1106); } 
bgl_display_obj(
((obj_t)BgL_saltz00_280), BgL_pz00_101); } } 
if(
(BgL_encodedzd2countzd2_290>=((long)256)))
{ /* Llib/pgp_encode.scm 22 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2399z00zz__openpgpzd2encodezd2, 
BINT(BgL_encodedzd2countzd2_290)); }  else 
{ /* Llib/pgp_encode.scm 22 */BFALSE; } 
{ /* Llib/pgp_encode.scm 26 */
unsigned char BgL_arg1300z00_1115;
BgL_arg1300z00_1115 = 
(BgL_encodedzd2countzd2_290); 
return 
bgl_display_obj(
BCHAR(BgL_arg1300z00_1115), BgL_pz00_101);} } }  else 
{ /* Llib/pgp_encode.scm 422 */
return 
BGl_errorz00zz__errorz00(BGl_string2414z00zz__openpgpzd2encodezd2, BGl_string2415z00zz__openpgpzd2encodezd2, BgL_algoz00_276);} } } } } } } } } } } 

}



/* encode-public-key-content */
BGL_EXPORTED_DEF obj_t BGl_encodezd2publiczd2keyzd2contentzd2zz__openpgpzd2encodezd2(BgL_pgpzd2keyzd2packetz00_bglt BgL_packetz00_106, obj_t BgL_pz00_107)
{
{ /* Llib/pgp_encode.scm 499 */
{ /* Llib/pgp_encode.scm 503 */
long BgL_arg1655z00_293;
BgL_arg1655z00_293 = 
(((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(BgL_packetz00_106))->BgL_versionz00); 
if(
(BgL_arg1655z00_293>=((long)256)))
{ /* Llib/pgp_encode.scm 22 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2399z00zz__openpgpzd2encodezd2, 
BINT(BgL_arg1655z00_293)); }  else 
{ /* Llib/pgp_encode.scm 22 */BFALSE; } 
{ /* Llib/pgp_encode.scm 26 */
unsigned char BgL_arg1300z00_1123;
BgL_arg1300z00_1123 = 
(BgL_arg1655z00_293); 
bgl_display_obj(
BCHAR(BgL_arg1300z00_1123), BgL_pz00_107); } } 
{ /* Llib/pgp_encode.scm 504 */
obj_t BgL_arg1658z00_294;
BgL_arg1658z00_294 = 
(((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(BgL_packetz00_106))->BgL_creationzd2datezd2); 
{ /* Llib/pgp_encode.scm 60 */
long BgL_arg1351z00_1130;
BgL_arg1351z00_1130 = 
bgl_date_to_seconds(BgL_arg1658z00_294); 
{ /* Llib/pgp_encode.scm 60 */
long BgL_nnz00_1133;
BgL_nnz00_1133 = 
(long)(BgL_arg1351z00_1130); 
bgl_display_obj(
BGl_fixnumzd2ze3scalarz31zz__openpgpzd2conversionzd2(BgL_nnz00_1133, ((long)4)), BgL_pz00_107); } } } 
{ /* Llib/pgp_encode.scm 507 */
bool_t BgL_test2661z00_3614;
if(
(
(((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(BgL_packetz00_106))->BgL_versionz00)==((long)2)))
{ /* Llib/pgp_encode.scm 507 */
BgL_test2661z00_3614 = ((bool_t)1)
; }  else 
{ /* Llib/pgp_encode.scm 507 */
BgL_test2661z00_3614 = 
(
(((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(BgL_packetz00_106))->BgL_versionz00)==((long)3))
; } 
if(BgL_test2661z00_3614)
{ /* Llib/pgp_encode.scm 507 */
if(
INTEGERP(
(((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(BgL_packetz00_106))->BgL_validzd2dayszd2)))
{ /* Llib/pgp_encode.scm 508 */BFALSE; }  else 
{ /* Llib/pgp_encode.scm 509 */
obj_t BgL_arg1673z00_302;
BgL_arg1673z00_302 = 
(((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(BgL_packetz00_106))->BgL_validzd2dayszd2); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)10)), BGl_string2416z00zz__openpgpzd2encodezd2, BgL_arg1673z00_302); } 
{ /* Llib/pgp_encode.scm 512 */
obj_t BgL_arg1676z00_304;
BgL_arg1676z00_304 = 
(((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(BgL_packetz00_106))->BgL_validzd2dayszd2); 
{ /* Llib/pgp_encode.scm 512 */
long BgL_nnz00_1141;
BgL_nnz00_1141 = 
(long)CINT(BgL_arg1676z00_304); 
bgl_display_obj(
BGl_fixnumzd2ze3scalarz31zz__openpgpzd2conversionzd2(BgL_nnz00_1141, ((long)2)), BgL_pz00_107); } } }  else 
{ /* Llib/pgp_encode.scm 507 */BFALSE; } } 
{ /* Llib/pgp_encode.scm 513 */
char BgL_arg1681z00_308;
BgL_arg1681z00_308 = 
BGl_publiczd2keyzd2algozd2ze3bytez31zz__openpgpzd2enumszd2(
(((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(BgL_packetz00_106))->BgL_algoz00)); 
{ /* Llib/pgp_encode.scm 513 */
long BgL_nz00_1144;
BgL_nz00_1144 = 
(long)(BgL_arg1681z00_308); 
if(
(BgL_nz00_1144>=((long)256)))
{ /* Llib/pgp_encode.scm 22 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2399z00zz__openpgpzd2encodezd2, 
BINT(BgL_nz00_1144)); }  else 
{ /* Llib/pgp_encode.scm 22 */BFALSE; } 
{ /* Llib/pgp_encode.scm 26 */
unsigned char BgL_arg1300z00_1147;
BgL_arg1300z00_1147 = 
(BgL_nz00_1144); 
bgl_display_obj(
BCHAR(BgL_arg1300z00_1147), BgL_pz00_107); } } } 
{ /* Llib/pgp_encode.scm 514 */
bool_t BgL_test2665z00_3641;
if(
(
(((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(BgL_packetz00_106))->BgL_versionz00)==((long)2)))
{ /* Llib/pgp_encode.scm 514 */
BgL_test2665z00_3641 = ((bool_t)1)
; }  else 
{ /* Llib/pgp_encode.scm 514 */
BgL_test2665z00_3641 = 
(
(((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(BgL_packetz00_106))->BgL_versionz00)==((long)3))
; } 
if(BgL_test2665z00_3641)
{ /* Llib/pgp_encode.scm 515 */
obj_t BgL_casezd2valuezd2_315;
BgL_casezd2valuezd2_315 = 
(((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(BgL_packetz00_106))->BgL_algoz00); 
{ /* Llib/pgp_encode.scm 515 */
bool_t BgL_test2667z00_3648;
{ /* Llib/pgp_encode.scm 515 */
bool_t BgL__ortest_1140z00_323;
BgL__ortest_1140z00_323 = 
(BgL_casezd2valuezd2_315==
CNST_TABLE_REF(((long)11))); 
if(BgL__ortest_1140z00_323)
{ /* Llib/pgp_encode.scm 515 */
BgL_test2667z00_3648 = BgL__ortest_1140z00_323
; }  else 
{ /* Llib/pgp_encode.scm 515 */
bool_t BgL__ortest_1141z00_324;
BgL__ortest_1141z00_324 = 
(BgL_casezd2valuezd2_315==
CNST_TABLE_REF(((long)12))); 
if(BgL__ortest_1141z00_324)
{ /* Llib/pgp_encode.scm 515 */
BgL_test2667z00_3648 = BgL__ortest_1141z00_324
; }  else 
{ /* Llib/pgp_encode.scm 515 */
BgL_test2667z00_3648 = 
(BgL_casezd2valuezd2_315==
CNST_TABLE_REF(((long)13)))
; } } } 
if(BgL_test2667z00_3648)
{ /* Llib/pgp_encode.scm 515 */
CNST_TABLE_REF(((long)14)); }  else 
{ /* Llib/pgp_encode.scm 519 */
obj_t BgL_arg1693z00_319;
BgL_arg1693z00_319 = 
MAKE_YOUNG_PAIR(
(((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(BgL_packetz00_106))->BgL_algoz00), 
BGl_publiczd2keyzd2algozd2ze3humanzd2readableze3zz__openpgpzd2humanzd2(
(((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(BgL_packetz00_106))->BgL_algoz00))); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)10)), BGl_string2417z00zz__openpgpzd2encodezd2, BgL_arg1693z00_319); } } }  else 
{ /* Llib/pgp_encode.scm 514 */BFALSE; } } 
{ /* Llib/pgp_encode.scm 521 */
obj_t BgL_casezd2valuezd2_328;
BgL_casezd2valuezd2_328 = 
(((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(BgL_packetz00_106))->BgL_algoz00); 
{ /* Llib/pgp_encode.scm 521 */
bool_t BgL_test2670z00_3665;
{ /* Llib/pgp_encode.scm 521 */
bool_t BgL__ortest_1142z00_364;
BgL__ortest_1142z00_364 = 
(BgL_casezd2valuezd2_328==
CNST_TABLE_REF(((long)11))); 
if(BgL__ortest_1142z00_364)
{ /* Llib/pgp_encode.scm 521 */
BgL_test2670z00_3665 = BgL__ortest_1142z00_364
; }  else 
{ /* Llib/pgp_encode.scm 521 */
bool_t BgL__ortest_1143z00_365;
BgL__ortest_1143z00_365 = 
(BgL_casezd2valuezd2_328==
CNST_TABLE_REF(((long)12))); 
if(BgL__ortest_1143z00_365)
{ /* Llib/pgp_encode.scm 521 */
BgL_test2670z00_3665 = BgL__ortest_1143z00_365
; }  else 
{ /* Llib/pgp_encode.scm 521 */
BgL_test2670z00_3665 = 
(BgL_casezd2valuezd2_328==
CNST_TABLE_REF(((long)13)))
; } } } 
if(BgL_test2670z00_3665)
{ /* Llib/pgp_encode.scm 521 */
{ /* Llib/pgp_encode.scm 523 */
bool_t BgL_test2673z00_3674;
{ /* Llib/pgp_encode.scm 523 */
obj_t BgL_arg1708z00_335;
BgL_arg1708z00_335 = 
(((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(BgL_packetz00_106))->BgL_keyz00); 
BgL_test2673z00_3674 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1708z00_335, BGl_Rsazd2Keyzd2zz__cryptozd2rsazd2); } 
if(BgL_test2673z00_3674)
{ /* Llib/pgp_encode.scm 523 */BFALSE; }  else 
{ /* Llib/pgp_encode.scm 524 */
obj_t BgL_arg1707z00_334;
BgL_arg1707z00_334 = 
(((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(BgL_packetz00_106))->BgL_keyz00); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)15)), BGl_string2418z00zz__openpgpzd2encodezd2, BgL_arg1707z00_334); } } 
{ /* Llib/pgp_encode.scm 527 */
BgL_rsazd2keyzd2_bglt BgL_i1144z00_336;
BgL_i1144z00_336 = 
((BgL_rsazd2keyzd2_bglt)
(((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(BgL_packetz00_106))->BgL_keyz00)); 
{ /* Llib/pgp_encode.scm 528 */
obj_t BgL_arg1711z00_337;
BgL_arg1711z00_337 = 
(((BgL_rsazd2keyzd2_bglt)COBJECT(BgL_i1144z00_336))->BgL_modulusz00); 
{ /* Llib/pgp_encode.scm 40 */
long BgL_bitzd2lenzd2_1158;
BgL_bitzd2lenzd2_1158 = 
BGl_bignumzd2bitzd2lengthz00zz__openpgpzd2utilzd2(BgL_arg1711z00_337); 
{ /* Llib/pgp_encode.scm 40 */
long BgL_octetzd2lenzd2_1159;
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2046z00_1197;
{ /* Llib/pgp_encode.scm 41 */
long BgL_qz00_1162;long BgL_rz00_1163;
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2034z00_1167;
BgL_res2034z00_1167 = 
(BgL_bitzd2lenzd2_1158/((long)8)); 
BgL_qz00_1162 = BgL_res2034z00_1167; } 
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2040z00_1186;
{ /* Llib/pgp_encode.scm 41 */
long BgL_n1z00_1168;long BgL_n2z00_1169;
BgL_n1z00_1168 = BgL_bitzd2lenzd2_1158; 
BgL_n2z00_1169 = ((long)8); 
{ /* Llib/pgp_encode.scm 41 */
bool_t BgL_test2674z00_3685;
{ /* Llib/pgp_encode.scm 41 */
long BgL_arg1299z00_1171;
BgL_arg1299z00_1171 = 
(((BgL_n1z00_1168) | (BgL_n2z00_1169)) & -2147483648); 
BgL_test2674z00_3685 = 
(BgL_arg1299z00_1171==((long)0)); } 
if(BgL_test2674z00_3685)
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_arg1287z00_1172;
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_arg1293z00_1173;int32_t BgL_arg1294z00_1174;
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_res2036z00_1178;
BgL_res2036z00_1178 = 
(int32_t)(BgL_n1z00_1168); 
BgL_arg1293z00_1173 = BgL_res2036z00_1178; } 
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_res2037z00_1180;
BgL_res2037z00_1180 = 
(int32_t)(BgL_n2z00_1169); 
BgL_arg1294z00_1174 = BgL_res2037z00_1180; } 
BgL_arg1287z00_1172 = 
(BgL_arg1293z00_1173%BgL_arg1294z00_1174); } 
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2039z00_1185;
{ /* Llib/pgp_encode.scm 41 */
long BgL_arg1421z00_1182;
BgL_arg1421z00_1182 = 
(long)(BgL_arg1287z00_1172); 
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2038z00_1184;
BgL_res2038z00_1184 = 
(long)(BgL_arg1421z00_1182); 
BgL_res2039z00_1185 = BgL_res2038z00_1184; } } 
BgL_res2040z00_1186 = BgL_res2039z00_1185; } }  else 
{ /* Llib/pgp_encode.scm 41 */
BgL_res2040z00_1186 = 
(BgL_n1z00_1168%BgL_n2z00_1169); } } } 
BgL_rz00_1163 = BgL_res2040z00_1186; } 
if(
(BgL_rz00_1163==((long)0)))
{ /* Llib/pgp_encode.scm 41 */
BgL_res2046z00_1197 = BgL_qz00_1162; }  else 
{ /* Llib/pgp_encode.scm 41 */
if(
(BgL_rz00_1163>((long)0)))
{ /* Llib/pgp_encode.scm 41 */
BgL_res2046z00_1197 = 
(BgL_qz00_1162+((long)1)); }  else 
{ /* Llib/pgp_encode.scm 41 */
BgL_res2046z00_1197 = 
(BgL_qz00_1162-((long)1)); } } } 
BgL_octetzd2lenzd2_1159 = BgL_res2046z00_1197; } 
{ /* Llib/pgp_encode.scm 41 */
obj_t BgL_strz00_1160;
BgL_strz00_1160 = 
BGl_bignumzd2ze3binzd2strze3zz__openpgpzd2utilzd2(BgL_arg1711z00_337, BgL_octetzd2lenzd2_1159); 
{ /* Llib/pgp_encode.scm 42 */

bgl_display_obj(
BGl_fixnumzd2ze3scalarz31zz__openpgpzd2conversionzd2(BgL_bitzd2lenzd2_1158, ((long)2)), BgL_pz00_107); 
bgl_display_obj(BgL_strz00_1160, BgL_pz00_107); } } } } } 
{ /* Llib/pgp_encode.scm 529 */
obj_t BgL_arg1718z00_338;
BgL_arg1718z00_338 = 
(((BgL_rsazd2keyzd2_bglt)COBJECT(BgL_i1144z00_336))->BgL_exponentz00); 
{ /* Llib/pgp_encode.scm 40 */
long BgL_bitzd2lenzd2_1203;
BgL_bitzd2lenzd2_1203 = 
BGl_bignumzd2bitzd2lengthz00zz__openpgpzd2utilzd2(BgL_arg1718z00_338); 
{ /* Llib/pgp_encode.scm 40 */
long BgL_octetzd2lenzd2_1204;
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2059z00_1242;
{ /* Llib/pgp_encode.scm 41 */
long BgL_qz00_1207;long BgL_rz00_1208;
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2047z00_1212;
BgL_res2047z00_1212 = 
(BgL_bitzd2lenzd2_1203/((long)8)); 
BgL_qz00_1207 = BgL_res2047z00_1212; } 
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2053z00_1231;
{ /* Llib/pgp_encode.scm 41 */
long BgL_n1z00_1213;long BgL_n2z00_1214;
BgL_n1z00_1213 = BgL_bitzd2lenzd2_1203; 
BgL_n2z00_1214 = ((long)8); 
{ /* Llib/pgp_encode.scm 41 */
bool_t BgL_test2677z00_3707;
{ /* Llib/pgp_encode.scm 41 */
long BgL_arg1299z00_1216;
BgL_arg1299z00_1216 = 
(((BgL_n1z00_1213) | (BgL_n2z00_1214)) & -2147483648); 
BgL_test2677z00_3707 = 
(BgL_arg1299z00_1216==((long)0)); } 
if(BgL_test2677z00_3707)
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_arg1287z00_1217;
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_arg1293z00_1218;int32_t BgL_arg1294z00_1219;
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_res2049z00_1223;
BgL_res2049z00_1223 = 
(int32_t)(BgL_n1z00_1213); 
BgL_arg1293z00_1218 = BgL_res2049z00_1223; } 
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_res2050z00_1225;
BgL_res2050z00_1225 = 
(int32_t)(BgL_n2z00_1214); 
BgL_arg1294z00_1219 = BgL_res2050z00_1225; } 
BgL_arg1287z00_1217 = 
(BgL_arg1293z00_1218%BgL_arg1294z00_1219); } 
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2052z00_1230;
{ /* Llib/pgp_encode.scm 41 */
long BgL_arg1421z00_1227;
BgL_arg1421z00_1227 = 
(long)(BgL_arg1287z00_1217); 
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2051z00_1229;
BgL_res2051z00_1229 = 
(long)(BgL_arg1421z00_1227); 
BgL_res2052z00_1230 = BgL_res2051z00_1229; } } 
BgL_res2053z00_1231 = BgL_res2052z00_1230; } }  else 
{ /* Llib/pgp_encode.scm 41 */
BgL_res2053z00_1231 = 
(BgL_n1z00_1213%BgL_n2z00_1214); } } } 
BgL_rz00_1208 = BgL_res2053z00_1231; } 
if(
(BgL_rz00_1208==((long)0)))
{ /* Llib/pgp_encode.scm 41 */
BgL_res2059z00_1242 = BgL_qz00_1207; }  else 
{ /* Llib/pgp_encode.scm 41 */
if(
(BgL_rz00_1208>((long)0)))
{ /* Llib/pgp_encode.scm 41 */
BgL_res2059z00_1242 = 
(BgL_qz00_1207+((long)1)); }  else 
{ /* Llib/pgp_encode.scm 41 */
BgL_res2059z00_1242 = 
(BgL_qz00_1207-((long)1)); } } } 
BgL_octetzd2lenzd2_1204 = BgL_res2059z00_1242; } 
{ /* Llib/pgp_encode.scm 41 */
obj_t BgL_strz00_1205;
BgL_strz00_1205 = 
BGl_bignumzd2ze3binzd2strze3zz__openpgpzd2utilzd2(BgL_arg1718z00_338, BgL_octetzd2lenzd2_1204); 
{ /* Llib/pgp_encode.scm 42 */

bgl_display_obj(
BGl_fixnumzd2ze3scalarz31zz__openpgpzd2conversionzd2(BgL_bitzd2lenzd2_1203, ((long)2)), BgL_pz00_107); 
return 
bgl_display_obj(BgL_strz00_1205, BgL_pz00_107);} } } } } } }  else 
{ /* Llib/pgp_encode.scm 521 */
if(
(BgL_casezd2valuezd2_328==
CNST_TABLE_REF(((long)16))))
{ /* Llib/pgp_encode.scm 521 */
{ /* Llib/pgp_encode.scm 531 */
bool_t BgL_test2681z00_3729;
{ /* Llib/pgp_encode.scm 531 */
obj_t BgL_arg1740z00_343;
BgL_arg1740z00_343 = 
(((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(BgL_packetz00_106))->BgL_keyz00); 
BgL_test2681z00_3729 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1740z00_343, BGl_Dsazd2Keyzd2zz__cryptozd2dsazd2); } 
if(BgL_test2681z00_3729)
{ /* Llib/pgp_encode.scm 531 */BFALSE; }  else 
{ /* Llib/pgp_encode.scm 532 */
obj_t BgL_arg1728z00_342;
BgL_arg1728z00_342 = 
(((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(BgL_packetz00_106))->BgL_keyz00); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)15)), BGl_string2419z00zz__openpgpzd2encodezd2, BgL_arg1728z00_342); } } 
{ /* Llib/pgp_encode.scm 535 */
BgL_dsazd2keyzd2_bglt BgL_i1145z00_344;
BgL_i1145z00_344 = 
((BgL_dsazd2keyzd2_bglt)
(((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(BgL_packetz00_106))->BgL_keyz00)); 
{ /* Llib/pgp_encode.scm 536 */
obj_t BgL_arg1741z00_345;
BgL_arg1741z00_345 = 
(((BgL_dsazd2keyzd2_bglt)COBJECT(BgL_i1145z00_344))->BgL_pz00); 
{ /* Llib/pgp_encode.scm 40 */
long BgL_bitzd2lenzd2_1250;
BgL_bitzd2lenzd2_1250 = 
BGl_bignumzd2bitzd2lengthz00zz__openpgpzd2utilzd2(BgL_arg1741z00_345); 
{ /* Llib/pgp_encode.scm 40 */
long BgL_octetzd2lenzd2_1251;
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2073z00_1289;
{ /* Llib/pgp_encode.scm 41 */
long BgL_qz00_1254;long BgL_rz00_1255;
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2061z00_1259;
BgL_res2061z00_1259 = 
(BgL_bitzd2lenzd2_1250/((long)8)); 
BgL_qz00_1254 = BgL_res2061z00_1259; } 
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2067z00_1278;
{ /* Llib/pgp_encode.scm 41 */
long BgL_n1z00_1260;long BgL_n2z00_1261;
BgL_n1z00_1260 = BgL_bitzd2lenzd2_1250; 
BgL_n2z00_1261 = ((long)8); 
{ /* Llib/pgp_encode.scm 41 */
bool_t BgL_test2682z00_3740;
{ /* Llib/pgp_encode.scm 41 */
long BgL_arg1299z00_1263;
BgL_arg1299z00_1263 = 
(((BgL_n1z00_1260) | (BgL_n2z00_1261)) & -2147483648); 
BgL_test2682z00_3740 = 
(BgL_arg1299z00_1263==((long)0)); } 
if(BgL_test2682z00_3740)
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_arg1287z00_1264;
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_arg1293z00_1265;int32_t BgL_arg1294z00_1266;
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_res2063z00_1270;
BgL_res2063z00_1270 = 
(int32_t)(BgL_n1z00_1260); 
BgL_arg1293z00_1265 = BgL_res2063z00_1270; } 
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_res2064z00_1272;
BgL_res2064z00_1272 = 
(int32_t)(BgL_n2z00_1261); 
BgL_arg1294z00_1266 = BgL_res2064z00_1272; } 
BgL_arg1287z00_1264 = 
(BgL_arg1293z00_1265%BgL_arg1294z00_1266); } 
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2066z00_1277;
{ /* Llib/pgp_encode.scm 41 */
long BgL_arg1421z00_1274;
BgL_arg1421z00_1274 = 
(long)(BgL_arg1287z00_1264); 
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2065z00_1276;
BgL_res2065z00_1276 = 
(long)(BgL_arg1421z00_1274); 
BgL_res2066z00_1277 = BgL_res2065z00_1276; } } 
BgL_res2067z00_1278 = BgL_res2066z00_1277; } }  else 
{ /* Llib/pgp_encode.scm 41 */
BgL_res2067z00_1278 = 
(BgL_n1z00_1260%BgL_n2z00_1261); } } } 
BgL_rz00_1255 = BgL_res2067z00_1278; } 
if(
(BgL_rz00_1255==((long)0)))
{ /* Llib/pgp_encode.scm 41 */
BgL_res2073z00_1289 = BgL_qz00_1254; }  else 
{ /* Llib/pgp_encode.scm 41 */
if(
(BgL_rz00_1255>((long)0)))
{ /* Llib/pgp_encode.scm 41 */
BgL_res2073z00_1289 = 
(BgL_qz00_1254+((long)1)); }  else 
{ /* Llib/pgp_encode.scm 41 */
BgL_res2073z00_1289 = 
(BgL_qz00_1254-((long)1)); } } } 
BgL_octetzd2lenzd2_1251 = BgL_res2073z00_1289; } 
{ /* Llib/pgp_encode.scm 41 */
obj_t BgL_strz00_1252;
BgL_strz00_1252 = 
BGl_bignumzd2ze3binzd2strze3zz__openpgpzd2utilzd2(BgL_arg1741z00_345, BgL_octetzd2lenzd2_1251); 
{ /* Llib/pgp_encode.scm 42 */

bgl_display_obj(
BGl_fixnumzd2ze3scalarz31zz__openpgpzd2conversionzd2(BgL_bitzd2lenzd2_1250, ((long)2)), BgL_pz00_107); 
bgl_display_obj(BgL_strz00_1252, BgL_pz00_107); } } } } } 
{ /* Llib/pgp_encode.scm 537 */
obj_t BgL_arg1743z00_346;
BgL_arg1743z00_346 = 
(((BgL_dsazd2keyzd2_bglt)COBJECT(BgL_i1145z00_344))->BgL_qz00); 
{ /* Llib/pgp_encode.scm 40 */
long BgL_bitzd2lenzd2_1295;
BgL_bitzd2lenzd2_1295 = 
BGl_bignumzd2bitzd2lengthz00zz__openpgpzd2utilzd2(BgL_arg1743z00_346); 
{ /* Llib/pgp_encode.scm 40 */
long BgL_octetzd2lenzd2_1296;
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2086z00_1334;
{ /* Llib/pgp_encode.scm 41 */
long BgL_qz00_1299;long BgL_rz00_1300;
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2074z00_1304;
BgL_res2074z00_1304 = 
(BgL_bitzd2lenzd2_1295/((long)8)); 
BgL_qz00_1299 = BgL_res2074z00_1304; } 
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2080z00_1323;
{ /* Llib/pgp_encode.scm 41 */
long BgL_n1z00_1305;long BgL_n2z00_1306;
BgL_n1z00_1305 = BgL_bitzd2lenzd2_1295; 
BgL_n2z00_1306 = ((long)8); 
{ /* Llib/pgp_encode.scm 41 */
bool_t BgL_test2685z00_3762;
{ /* Llib/pgp_encode.scm 41 */
long BgL_arg1299z00_1308;
BgL_arg1299z00_1308 = 
(((BgL_n1z00_1305) | (BgL_n2z00_1306)) & -2147483648); 
BgL_test2685z00_3762 = 
(BgL_arg1299z00_1308==((long)0)); } 
if(BgL_test2685z00_3762)
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_arg1287z00_1309;
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_arg1293z00_1310;int32_t BgL_arg1294z00_1311;
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_res2076z00_1315;
BgL_res2076z00_1315 = 
(int32_t)(BgL_n1z00_1305); 
BgL_arg1293z00_1310 = BgL_res2076z00_1315; } 
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_res2077z00_1317;
BgL_res2077z00_1317 = 
(int32_t)(BgL_n2z00_1306); 
BgL_arg1294z00_1311 = BgL_res2077z00_1317; } 
BgL_arg1287z00_1309 = 
(BgL_arg1293z00_1310%BgL_arg1294z00_1311); } 
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2079z00_1322;
{ /* Llib/pgp_encode.scm 41 */
long BgL_arg1421z00_1319;
BgL_arg1421z00_1319 = 
(long)(BgL_arg1287z00_1309); 
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2078z00_1321;
BgL_res2078z00_1321 = 
(long)(BgL_arg1421z00_1319); 
BgL_res2079z00_1322 = BgL_res2078z00_1321; } } 
BgL_res2080z00_1323 = BgL_res2079z00_1322; } }  else 
{ /* Llib/pgp_encode.scm 41 */
BgL_res2080z00_1323 = 
(BgL_n1z00_1305%BgL_n2z00_1306); } } } 
BgL_rz00_1300 = BgL_res2080z00_1323; } 
if(
(BgL_rz00_1300==((long)0)))
{ /* Llib/pgp_encode.scm 41 */
BgL_res2086z00_1334 = BgL_qz00_1299; }  else 
{ /* Llib/pgp_encode.scm 41 */
if(
(BgL_rz00_1300>((long)0)))
{ /* Llib/pgp_encode.scm 41 */
BgL_res2086z00_1334 = 
(BgL_qz00_1299+((long)1)); }  else 
{ /* Llib/pgp_encode.scm 41 */
BgL_res2086z00_1334 = 
(BgL_qz00_1299-((long)1)); } } } 
BgL_octetzd2lenzd2_1296 = BgL_res2086z00_1334; } 
{ /* Llib/pgp_encode.scm 41 */
obj_t BgL_strz00_1297;
BgL_strz00_1297 = 
BGl_bignumzd2ze3binzd2strze3zz__openpgpzd2utilzd2(BgL_arg1743z00_346, BgL_octetzd2lenzd2_1296); 
{ /* Llib/pgp_encode.scm 42 */

bgl_display_obj(
BGl_fixnumzd2ze3scalarz31zz__openpgpzd2conversionzd2(BgL_bitzd2lenzd2_1295, ((long)2)), BgL_pz00_107); 
bgl_display_obj(BgL_strz00_1297, BgL_pz00_107); } } } } } 
{ /* Llib/pgp_encode.scm 538 */
obj_t BgL_arg1752z00_347;
BgL_arg1752z00_347 = 
(((BgL_dsazd2keyzd2_bglt)COBJECT(BgL_i1145z00_344))->BgL_gz00); 
{ /* Llib/pgp_encode.scm 40 */
long BgL_bitzd2lenzd2_1340;
BgL_bitzd2lenzd2_1340 = 
BGl_bignumzd2bitzd2lengthz00zz__openpgpzd2utilzd2(BgL_arg1752z00_347); 
{ /* Llib/pgp_encode.scm 40 */
long BgL_octetzd2lenzd2_1341;
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2099z00_1379;
{ /* Llib/pgp_encode.scm 41 */
long BgL_qz00_1344;long BgL_rz00_1345;
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2087z00_1349;
BgL_res2087z00_1349 = 
(BgL_bitzd2lenzd2_1340/((long)8)); 
BgL_qz00_1344 = BgL_res2087z00_1349; } 
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2093z00_1368;
{ /* Llib/pgp_encode.scm 41 */
long BgL_n1z00_1350;long BgL_n2z00_1351;
BgL_n1z00_1350 = BgL_bitzd2lenzd2_1340; 
BgL_n2z00_1351 = ((long)8); 
{ /* Llib/pgp_encode.scm 41 */
bool_t BgL_test2688z00_3784;
{ /* Llib/pgp_encode.scm 41 */
long BgL_arg1299z00_1353;
BgL_arg1299z00_1353 = 
(((BgL_n1z00_1350) | (BgL_n2z00_1351)) & -2147483648); 
BgL_test2688z00_3784 = 
(BgL_arg1299z00_1353==((long)0)); } 
if(BgL_test2688z00_3784)
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_arg1287z00_1354;
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_arg1293z00_1355;int32_t BgL_arg1294z00_1356;
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_res2089z00_1360;
BgL_res2089z00_1360 = 
(int32_t)(BgL_n1z00_1350); 
BgL_arg1293z00_1355 = BgL_res2089z00_1360; } 
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_res2090z00_1362;
BgL_res2090z00_1362 = 
(int32_t)(BgL_n2z00_1351); 
BgL_arg1294z00_1356 = BgL_res2090z00_1362; } 
BgL_arg1287z00_1354 = 
(BgL_arg1293z00_1355%BgL_arg1294z00_1356); } 
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2092z00_1367;
{ /* Llib/pgp_encode.scm 41 */
long BgL_arg1421z00_1364;
BgL_arg1421z00_1364 = 
(long)(BgL_arg1287z00_1354); 
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2091z00_1366;
BgL_res2091z00_1366 = 
(long)(BgL_arg1421z00_1364); 
BgL_res2092z00_1367 = BgL_res2091z00_1366; } } 
BgL_res2093z00_1368 = BgL_res2092z00_1367; } }  else 
{ /* Llib/pgp_encode.scm 41 */
BgL_res2093z00_1368 = 
(BgL_n1z00_1350%BgL_n2z00_1351); } } } 
BgL_rz00_1345 = BgL_res2093z00_1368; } 
if(
(BgL_rz00_1345==((long)0)))
{ /* Llib/pgp_encode.scm 41 */
BgL_res2099z00_1379 = BgL_qz00_1344; }  else 
{ /* Llib/pgp_encode.scm 41 */
if(
(BgL_rz00_1345>((long)0)))
{ /* Llib/pgp_encode.scm 41 */
BgL_res2099z00_1379 = 
(BgL_qz00_1344+((long)1)); }  else 
{ /* Llib/pgp_encode.scm 41 */
BgL_res2099z00_1379 = 
(BgL_qz00_1344-((long)1)); } } } 
BgL_octetzd2lenzd2_1341 = BgL_res2099z00_1379; } 
{ /* Llib/pgp_encode.scm 41 */
obj_t BgL_strz00_1342;
BgL_strz00_1342 = 
BGl_bignumzd2ze3binzd2strze3zz__openpgpzd2utilzd2(BgL_arg1752z00_347, BgL_octetzd2lenzd2_1341); 
{ /* Llib/pgp_encode.scm 42 */

bgl_display_obj(
BGl_fixnumzd2ze3scalarz31zz__openpgpzd2conversionzd2(BgL_bitzd2lenzd2_1340, ((long)2)), BgL_pz00_107); 
bgl_display_obj(BgL_strz00_1342, BgL_pz00_107); } } } } } 
{ /* Llib/pgp_encode.scm 539 */
obj_t BgL_arg1753z00_348;
BgL_arg1753z00_348 = 
(((BgL_dsazd2keyzd2_bglt)COBJECT(BgL_i1145z00_344))->BgL_yz00); 
{ /* Llib/pgp_encode.scm 40 */
long BgL_bitzd2lenzd2_1385;
BgL_bitzd2lenzd2_1385 = 
BGl_bignumzd2bitzd2lengthz00zz__openpgpzd2utilzd2(BgL_arg1753z00_348); 
{ /* Llib/pgp_encode.scm 40 */
long BgL_octetzd2lenzd2_1386;
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2112z00_1424;
{ /* Llib/pgp_encode.scm 41 */
long BgL_qz00_1389;long BgL_rz00_1390;
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2100z00_1394;
BgL_res2100z00_1394 = 
(BgL_bitzd2lenzd2_1385/((long)8)); 
BgL_qz00_1389 = BgL_res2100z00_1394; } 
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2106z00_1413;
{ /* Llib/pgp_encode.scm 41 */
long BgL_n1z00_1395;long BgL_n2z00_1396;
BgL_n1z00_1395 = BgL_bitzd2lenzd2_1385; 
BgL_n2z00_1396 = ((long)8); 
{ /* Llib/pgp_encode.scm 41 */
bool_t BgL_test2691z00_3806;
{ /* Llib/pgp_encode.scm 41 */
long BgL_arg1299z00_1398;
BgL_arg1299z00_1398 = 
(((BgL_n1z00_1395) | (BgL_n2z00_1396)) & -2147483648); 
BgL_test2691z00_3806 = 
(BgL_arg1299z00_1398==((long)0)); } 
if(BgL_test2691z00_3806)
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_arg1287z00_1399;
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_arg1293z00_1400;int32_t BgL_arg1294z00_1401;
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_res2102z00_1405;
BgL_res2102z00_1405 = 
(int32_t)(BgL_n1z00_1395); 
BgL_arg1293z00_1400 = BgL_res2102z00_1405; } 
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_res2103z00_1407;
BgL_res2103z00_1407 = 
(int32_t)(BgL_n2z00_1396); 
BgL_arg1294z00_1401 = BgL_res2103z00_1407; } 
BgL_arg1287z00_1399 = 
(BgL_arg1293z00_1400%BgL_arg1294z00_1401); } 
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2105z00_1412;
{ /* Llib/pgp_encode.scm 41 */
long BgL_arg1421z00_1409;
BgL_arg1421z00_1409 = 
(long)(BgL_arg1287z00_1399); 
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2104z00_1411;
BgL_res2104z00_1411 = 
(long)(BgL_arg1421z00_1409); 
BgL_res2105z00_1412 = BgL_res2104z00_1411; } } 
BgL_res2106z00_1413 = BgL_res2105z00_1412; } }  else 
{ /* Llib/pgp_encode.scm 41 */
BgL_res2106z00_1413 = 
(BgL_n1z00_1395%BgL_n2z00_1396); } } } 
BgL_rz00_1390 = BgL_res2106z00_1413; } 
if(
(BgL_rz00_1390==((long)0)))
{ /* Llib/pgp_encode.scm 41 */
BgL_res2112z00_1424 = BgL_qz00_1389; }  else 
{ /* Llib/pgp_encode.scm 41 */
if(
(BgL_rz00_1390>((long)0)))
{ /* Llib/pgp_encode.scm 41 */
BgL_res2112z00_1424 = 
(BgL_qz00_1389+((long)1)); }  else 
{ /* Llib/pgp_encode.scm 41 */
BgL_res2112z00_1424 = 
(BgL_qz00_1389-((long)1)); } } } 
BgL_octetzd2lenzd2_1386 = BgL_res2112z00_1424; } 
{ /* Llib/pgp_encode.scm 41 */
obj_t BgL_strz00_1387;
BgL_strz00_1387 = 
BGl_bignumzd2ze3binzd2strze3zz__openpgpzd2utilzd2(BgL_arg1753z00_348, BgL_octetzd2lenzd2_1386); 
{ /* Llib/pgp_encode.scm 42 */

bgl_display_obj(
BGl_fixnumzd2ze3scalarz31zz__openpgpzd2conversionzd2(BgL_bitzd2lenzd2_1385, ((long)2)), BgL_pz00_107); 
return 
bgl_display_obj(BgL_strz00_1387, BgL_pz00_107);} } } } } } }  else 
{ /* Llib/pgp_encode.scm 521 */
bool_t BgL_test2694z00_3825;
{ /* Llib/pgp_encode.scm 521 */
bool_t BgL__ortest_1146z00_363;
BgL__ortest_1146z00_363 = 
(BgL_casezd2valuezd2_328==
CNST_TABLE_REF(((long)17))); 
if(BgL__ortest_1146z00_363)
{ /* Llib/pgp_encode.scm 521 */
BgL_test2694z00_3825 = BgL__ortest_1146z00_363
; }  else 
{ /* Llib/pgp_encode.scm 521 */
BgL_test2694z00_3825 = 
(BgL_casezd2valuezd2_328==
CNST_TABLE_REF(((long)18)))
; } } 
if(BgL_test2694z00_3825)
{ /* Llib/pgp_encode.scm 521 */
{ /* Llib/pgp_encode.scm 541 */
bool_t BgL_test2696z00_3831;
{ /* Llib/pgp_encode.scm 541 */
obj_t BgL_arg1759z00_354;
BgL_arg1759z00_354 = 
(((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(BgL_packetz00_106))->BgL_keyz00); 
BgL_test2696z00_3831 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1759z00_354, BGl_ElGamalzd2Keyzd2zz__cryptozd2elgamalzd2); } 
if(BgL_test2696z00_3831)
{ /* Llib/pgp_encode.scm 541 */BFALSE; }  else 
{ /* Llib/pgp_encode.scm 542 */
obj_t BgL_arg1758z00_353;
BgL_arg1758z00_353 = 
(((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(BgL_packetz00_106))->BgL_keyz00); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)15)), BGl_string2420z00zz__openpgpzd2encodezd2, BgL_arg1758z00_353); } } 
{ /* Llib/pgp_encode.scm 545 */
BgL_elgamalzd2keyzd2_bglt BgL_i1147z00_355;
BgL_i1147z00_355 = 
((BgL_elgamalzd2keyzd2_bglt)
(((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(BgL_packetz00_106))->BgL_keyz00)); 
{ /* Llib/pgp_encode.scm 546 */
obj_t BgL_arg1760z00_356;
BgL_arg1760z00_356 = 
(((BgL_elgamalzd2keyzd2_bglt)COBJECT(BgL_i1147z00_355))->BgL_pz00); 
{ /* Llib/pgp_encode.scm 40 */
long BgL_bitzd2lenzd2_1430;
BgL_bitzd2lenzd2_1430 = 
BGl_bignumzd2bitzd2lengthz00zz__openpgpzd2utilzd2(BgL_arg1760z00_356); 
{ /* Llib/pgp_encode.scm 40 */
long BgL_octetzd2lenzd2_1431;
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2125z00_1469;
{ /* Llib/pgp_encode.scm 41 */
long BgL_qz00_1434;long BgL_rz00_1435;
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2113z00_1439;
BgL_res2113z00_1439 = 
(BgL_bitzd2lenzd2_1430/((long)8)); 
BgL_qz00_1434 = BgL_res2113z00_1439; } 
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2119z00_1458;
{ /* Llib/pgp_encode.scm 41 */
long BgL_n1z00_1440;long BgL_n2z00_1441;
BgL_n1z00_1440 = BgL_bitzd2lenzd2_1430; 
BgL_n2z00_1441 = ((long)8); 
{ /* Llib/pgp_encode.scm 41 */
bool_t BgL_test2697z00_3842;
{ /* Llib/pgp_encode.scm 41 */
long BgL_arg1299z00_1443;
BgL_arg1299z00_1443 = 
(((BgL_n1z00_1440) | (BgL_n2z00_1441)) & -2147483648); 
BgL_test2697z00_3842 = 
(BgL_arg1299z00_1443==((long)0)); } 
if(BgL_test2697z00_3842)
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_arg1287z00_1444;
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_arg1293z00_1445;int32_t BgL_arg1294z00_1446;
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_res2115z00_1450;
BgL_res2115z00_1450 = 
(int32_t)(BgL_n1z00_1440); 
BgL_arg1293z00_1445 = BgL_res2115z00_1450; } 
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_res2116z00_1452;
BgL_res2116z00_1452 = 
(int32_t)(BgL_n2z00_1441); 
BgL_arg1294z00_1446 = BgL_res2116z00_1452; } 
BgL_arg1287z00_1444 = 
(BgL_arg1293z00_1445%BgL_arg1294z00_1446); } 
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2118z00_1457;
{ /* Llib/pgp_encode.scm 41 */
long BgL_arg1421z00_1454;
BgL_arg1421z00_1454 = 
(long)(BgL_arg1287z00_1444); 
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2117z00_1456;
BgL_res2117z00_1456 = 
(long)(BgL_arg1421z00_1454); 
BgL_res2118z00_1457 = BgL_res2117z00_1456; } } 
BgL_res2119z00_1458 = BgL_res2118z00_1457; } }  else 
{ /* Llib/pgp_encode.scm 41 */
BgL_res2119z00_1458 = 
(BgL_n1z00_1440%BgL_n2z00_1441); } } } 
BgL_rz00_1435 = BgL_res2119z00_1458; } 
if(
(BgL_rz00_1435==((long)0)))
{ /* Llib/pgp_encode.scm 41 */
BgL_res2125z00_1469 = BgL_qz00_1434; }  else 
{ /* Llib/pgp_encode.scm 41 */
if(
(BgL_rz00_1435>((long)0)))
{ /* Llib/pgp_encode.scm 41 */
BgL_res2125z00_1469 = 
(BgL_qz00_1434+((long)1)); }  else 
{ /* Llib/pgp_encode.scm 41 */
BgL_res2125z00_1469 = 
(BgL_qz00_1434-((long)1)); } } } 
BgL_octetzd2lenzd2_1431 = BgL_res2125z00_1469; } 
{ /* Llib/pgp_encode.scm 41 */
obj_t BgL_strz00_1432;
BgL_strz00_1432 = 
BGl_bignumzd2ze3binzd2strze3zz__openpgpzd2utilzd2(BgL_arg1760z00_356, BgL_octetzd2lenzd2_1431); 
{ /* Llib/pgp_encode.scm 42 */

bgl_display_obj(
BGl_fixnumzd2ze3scalarz31zz__openpgpzd2conversionzd2(BgL_bitzd2lenzd2_1430, ((long)2)), BgL_pz00_107); 
bgl_display_obj(BgL_strz00_1432, BgL_pz00_107); } } } } } 
{ /* Llib/pgp_encode.scm 547 */
obj_t BgL_arg1761z00_357;
BgL_arg1761z00_357 = 
(((BgL_elgamalzd2keyzd2_bglt)COBJECT(BgL_i1147z00_355))->BgL_gz00); 
{ /* Llib/pgp_encode.scm 40 */
long BgL_bitzd2lenzd2_1475;
BgL_bitzd2lenzd2_1475 = 
BGl_bignumzd2bitzd2lengthz00zz__openpgpzd2utilzd2(BgL_arg1761z00_357); 
{ /* Llib/pgp_encode.scm 40 */
long BgL_octetzd2lenzd2_1476;
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2138z00_1514;
{ /* Llib/pgp_encode.scm 41 */
long BgL_qz00_1479;long BgL_rz00_1480;
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2126z00_1484;
BgL_res2126z00_1484 = 
(BgL_bitzd2lenzd2_1475/((long)8)); 
BgL_qz00_1479 = BgL_res2126z00_1484; } 
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2132z00_1503;
{ /* Llib/pgp_encode.scm 41 */
long BgL_n1z00_1485;long BgL_n2z00_1486;
BgL_n1z00_1485 = BgL_bitzd2lenzd2_1475; 
BgL_n2z00_1486 = ((long)8); 
{ /* Llib/pgp_encode.scm 41 */
bool_t BgL_test2700z00_3864;
{ /* Llib/pgp_encode.scm 41 */
long BgL_arg1299z00_1488;
BgL_arg1299z00_1488 = 
(((BgL_n1z00_1485) | (BgL_n2z00_1486)) & -2147483648); 
BgL_test2700z00_3864 = 
(BgL_arg1299z00_1488==((long)0)); } 
if(BgL_test2700z00_3864)
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_arg1287z00_1489;
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_arg1293z00_1490;int32_t BgL_arg1294z00_1491;
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_res2128z00_1495;
BgL_res2128z00_1495 = 
(int32_t)(BgL_n1z00_1485); 
BgL_arg1293z00_1490 = BgL_res2128z00_1495; } 
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_res2129z00_1497;
BgL_res2129z00_1497 = 
(int32_t)(BgL_n2z00_1486); 
BgL_arg1294z00_1491 = BgL_res2129z00_1497; } 
BgL_arg1287z00_1489 = 
(BgL_arg1293z00_1490%BgL_arg1294z00_1491); } 
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2131z00_1502;
{ /* Llib/pgp_encode.scm 41 */
long BgL_arg1421z00_1499;
BgL_arg1421z00_1499 = 
(long)(BgL_arg1287z00_1489); 
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2130z00_1501;
BgL_res2130z00_1501 = 
(long)(BgL_arg1421z00_1499); 
BgL_res2131z00_1502 = BgL_res2130z00_1501; } } 
BgL_res2132z00_1503 = BgL_res2131z00_1502; } }  else 
{ /* Llib/pgp_encode.scm 41 */
BgL_res2132z00_1503 = 
(BgL_n1z00_1485%BgL_n2z00_1486); } } } 
BgL_rz00_1480 = BgL_res2132z00_1503; } 
if(
(BgL_rz00_1480==((long)0)))
{ /* Llib/pgp_encode.scm 41 */
BgL_res2138z00_1514 = BgL_qz00_1479; }  else 
{ /* Llib/pgp_encode.scm 41 */
if(
(BgL_rz00_1480>((long)0)))
{ /* Llib/pgp_encode.scm 41 */
BgL_res2138z00_1514 = 
(BgL_qz00_1479+((long)1)); }  else 
{ /* Llib/pgp_encode.scm 41 */
BgL_res2138z00_1514 = 
(BgL_qz00_1479-((long)1)); } } } 
BgL_octetzd2lenzd2_1476 = BgL_res2138z00_1514; } 
{ /* Llib/pgp_encode.scm 41 */
obj_t BgL_strz00_1477;
BgL_strz00_1477 = 
BGl_bignumzd2ze3binzd2strze3zz__openpgpzd2utilzd2(BgL_arg1761z00_357, BgL_octetzd2lenzd2_1476); 
{ /* Llib/pgp_encode.scm 42 */

bgl_display_obj(
BGl_fixnumzd2ze3scalarz31zz__openpgpzd2conversionzd2(BgL_bitzd2lenzd2_1475, ((long)2)), BgL_pz00_107); 
bgl_display_obj(BgL_strz00_1477, BgL_pz00_107); } } } } } 
{ /* Llib/pgp_encode.scm 548 */
obj_t BgL_arg1762z00_358;
BgL_arg1762z00_358 = 
(((BgL_elgamalzd2keyzd2_bglt)COBJECT(BgL_i1147z00_355))->BgL_yz00); 
{ /* Llib/pgp_encode.scm 40 */
long BgL_bitzd2lenzd2_1520;
BgL_bitzd2lenzd2_1520 = 
BGl_bignumzd2bitzd2lengthz00zz__openpgpzd2utilzd2(BgL_arg1762z00_358); 
{ /* Llib/pgp_encode.scm 40 */
long BgL_octetzd2lenzd2_1521;
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2151z00_1559;
{ /* Llib/pgp_encode.scm 41 */
long BgL_qz00_1524;long BgL_rz00_1525;
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2139z00_1529;
BgL_res2139z00_1529 = 
(BgL_bitzd2lenzd2_1520/((long)8)); 
BgL_qz00_1524 = BgL_res2139z00_1529; } 
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2145z00_1548;
{ /* Llib/pgp_encode.scm 41 */
long BgL_n1z00_1530;long BgL_n2z00_1531;
BgL_n1z00_1530 = BgL_bitzd2lenzd2_1520; 
BgL_n2z00_1531 = ((long)8); 
{ /* Llib/pgp_encode.scm 41 */
bool_t BgL_test2703z00_3886;
{ /* Llib/pgp_encode.scm 41 */
long BgL_arg1299z00_1533;
BgL_arg1299z00_1533 = 
(((BgL_n1z00_1530) | (BgL_n2z00_1531)) & -2147483648); 
BgL_test2703z00_3886 = 
(BgL_arg1299z00_1533==((long)0)); } 
if(BgL_test2703z00_3886)
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_arg1287z00_1534;
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_arg1293z00_1535;int32_t BgL_arg1294z00_1536;
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_res2141z00_1540;
BgL_res2141z00_1540 = 
(int32_t)(BgL_n1z00_1530); 
BgL_arg1293z00_1535 = BgL_res2141z00_1540; } 
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_res2142z00_1542;
BgL_res2142z00_1542 = 
(int32_t)(BgL_n2z00_1531); 
BgL_arg1294z00_1536 = BgL_res2142z00_1542; } 
BgL_arg1287z00_1534 = 
(BgL_arg1293z00_1535%BgL_arg1294z00_1536); } 
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2144z00_1547;
{ /* Llib/pgp_encode.scm 41 */
long BgL_arg1421z00_1544;
BgL_arg1421z00_1544 = 
(long)(BgL_arg1287z00_1534); 
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2143z00_1546;
BgL_res2143z00_1546 = 
(long)(BgL_arg1421z00_1544); 
BgL_res2144z00_1547 = BgL_res2143z00_1546; } } 
BgL_res2145z00_1548 = BgL_res2144z00_1547; } }  else 
{ /* Llib/pgp_encode.scm 41 */
BgL_res2145z00_1548 = 
(BgL_n1z00_1530%BgL_n2z00_1531); } } } 
BgL_rz00_1525 = BgL_res2145z00_1548; } 
if(
(BgL_rz00_1525==((long)0)))
{ /* Llib/pgp_encode.scm 41 */
BgL_res2151z00_1559 = BgL_qz00_1524; }  else 
{ /* Llib/pgp_encode.scm 41 */
if(
(BgL_rz00_1525>((long)0)))
{ /* Llib/pgp_encode.scm 41 */
BgL_res2151z00_1559 = 
(BgL_qz00_1524+((long)1)); }  else 
{ /* Llib/pgp_encode.scm 41 */
BgL_res2151z00_1559 = 
(BgL_qz00_1524-((long)1)); } } } 
BgL_octetzd2lenzd2_1521 = BgL_res2151z00_1559; } 
{ /* Llib/pgp_encode.scm 41 */
obj_t BgL_strz00_1522;
BgL_strz00_1522 = 
BGl_bignumzd2ze3binzd2strze3zz__openpgpzd2utilzd2(BgL_arg1762z00_358, BgL_octetzd2lenzd2_1521); 
{ /* Llib/pgp_encode.scm 42 */

bgl_display_obj(
BGl_fixnumzd2ze3scalarz31zz__openpgpzd2conversionzd2(BgL_bitzd2lenzd2_1520, ((long)2)), BgL_pz00_107); 
return 
bgl_display_obj(BgL_strz00_1522, BgL_pz00_107);} } } } } } }  else 
{ /* Llib/pgp_encode.scm 552 */
obj_t BgL_arg1763z00_359;
BgL_arg1763z00_359 = 
MAKE_YOUNG_PAIR(
(((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(BgL_packetz00_106))->BgL_algoz00), 
BGl_publiczd2keyzd2algozd2ze3humanzd2readableze3zz__openpgpzd2humanzd2(
(((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(BgL_packetz00_106))->BgL_algoz00))); 
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)15)), BGl_string2421z00zz__openpgpzd2encodezd2, BgL_arg1763z00_359);} } } } } } 

}



/* &encode-public-key-content */
obj_t BGl_z62encodezd2publiczd2keyzd2contentzb0zz__openpgpzd2encodezd2(obj_t BgL_envz00_2505, obj_t BgL_packetz00_2506, obj_t BgL_pz00_2507)
{
{ /* Llib/pgp_encode.scm 499 */
{ /* Llib/pgp_encode.scm 501 */
obj_t BgL_auxz00_3919;BgL_pgpzd2keyzd2packetz00_bglt BgL_auxz00_3911;
if(
OUTPUT_PORTP(BgL_pz00_2507))
{ /* Llib/pgp_encode.scm 501 */
BgL_auxz00_3919 = BgL_pz00_2507
; }  else 
{ 
obj_t BgL_auxz00_3922;
BgL_auxz00_3922 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2396z00zz__openpgpzd2encodezd2, 
BINT(((long)19725)), BGl_string2422z00zz__openpgpzd2encodezd2, BGl_string2398z00zz__openpgpzd2encodezd2, BgL_pz00_2507); 
FAILURE(BgL_auxz00_3922,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_packetz00_2506, BGl_PGPzd2Keyzd2Packetz00zz__openpgpzd2packetszd2))
{ /* Llib/pgp_encode.scm 501 */
BgL_auxz00_3911 = 
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_packetz00_2506)
; }  else 
{ 
obj_t BgL_auxz00_3915;
BgL_auxz00_3915 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2396z00zz__openpgpzd2encodezd2, 
BINT(((long)19725)), BGl_string2422z00zz__openpgpzd2encodezd2, BGl_string2423z00zz__openpgpzd2encodezd2, BgL_packetz00_2506); 
FAILURE(BgL_auxz00_3915,BFALSE,BFALSE);} 
return 
BGl_encodezd2publiczd2keyzd2contentzd2zz__openpgpzd2encodezd2(BgL_auxz00_3911, BgL_auxz00_3919);} } 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__openpgpzd2encodezd2()
{
{ /* Llib/pgp_encode.scm 1 */
return BUNSPEC;} 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__openpgpzd2encodezd2()
{
{ /* Llib/pgp_encode.scm 1 */
BGl_registerzd2genericz12zc0zz__objectz00(BGl_packetzd2ze3contentzd2tagzd2envz31zz__openpgpzd2encodezd2, BGl_proc2424z00zz__openpgpzd2encodezd2, BGl_PGPzd2Packetzd2zz__openpgpzd2packetszd2, BGl_string2425z00zz__openpgpzd2encodezd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_encodezd2contentzd2envz00zz__openpgpzd2encodezd2, BGl_proc2426z00zz__openpgpzd2encodezd2, BGl_PGPzd2Packetzd2zz__openpgpzd2packetszd2, BGl_string2427z00zz__openpgpzd2encodezd2); 
return 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_encodezd2subzd2packetzd2contentzd2envz00zz__openpgpzd2encodezd2, BGl_proc2428z00zz__openpgpzd2encodezd2, BGl_PGPzd2Signaturezd2Subzd2Packetzd2zz__openpgpzd2packetszd2, BGl_string2429z00zz__openpgpzd2encodezd2);} 

}



/* &encode-sub-packet-co1201 */
obj_t BGl_z62encodezd2subzd2packetzd2co1201zb0zz__openpgpzd2encodezd2(obj_t BgL_envz00_2511, obj_t BgL_spz00_2512, obj_t BgL_pz00_2513)
{
{ /* Llib/pgp_encode.scm 169 */
{ /* Llib/pgp_encode.scm 173 */
obj_t BgL_arg1774z00_2750;
{ /* Llib/pgp_encode.scm 173 */
obj_t BgL_arg1775z00_2751;
{ /* Llib/pgp_encode.scm 173 */
long BgL_arg1748z00_2752;
{ /* Llib/pgp_encode.scm 173 */
long BgL_arg1749z00_2753;
{ /* Llib/pgp_encode.scm 173 */
long BgL_res2156z00_2754;
BgL_res2156z00_2754 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)BgL_spz00_2512))); 
BgL_arg1749z00_2753 = BgL_res2156z00_2754; } 
BgL_arg1748z00_2752 = 
(BgL_arg1749z00_2753-OBJECT_TYPE); } 
BgL_arg1775z00_2751 = 
VECTOR_REF(BGl_za2classesza2z00zz__objectz00,BgL_arg1748z00_2752); } 
BgL_arg1774z00_2750 = 
BGl_classzd2namezd2zz__objectz00(BgL_arg1775z00_2751); } 
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)19)), BGl_string2430z00zz__openpgpzd2encodezd2, BgL_arg1774z00_2750);} } 

}



/* &encode-content1196 */
obj_t BGl_z62encodezd2content1196zb0zz__openpgpzd2encodezd2(obj_t BgL_envz00_2514, obj_t BgL_packetz00_2515, obj_t BgL_pz00_2516)
{
{ /* Llib/pgp_encode.scm 129 */
{ /* Llib/pgp_encode.scm 133 */
obj_t BgL_arg1771z00_2757;
{ /* Llib/pgp_encode.scm 133 */
obj_t BgL_arg1772z00_2758;
{ /* Llib/pgp_encode.scm 133 */
long BgL_arg1748z00_2759;
{ /* Llib/pgp_encode.scm 133 */
long BgL_arg1749z00_2760;
{ /* Llib/pgp_encode.scm 133 */
long BgL_res2154z00_2761;
BgL_res2154z00_2761 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)
((BgL_pgpzd2packetzd2_bglt)BgL_packetz00_2515))); 
BgL_arg1749z00_2760 = BgL_res2154z00_2761; } 
BgL_arg1748z00_2759 = 
(BgL_arg1749z00_2760-OBJECT_TYPE); } 
BgL_arg1772z00_2758 = 
VECTOR_REF(BGl_za2classesza2z00zz__objectz00,BgL_arg1748z00_2759); } 
BgL_arg1771z00_2757 = 
BGl_classzd2namezd2zz__objectz00(BgL_arg1772z00_2758); } 
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)20)), BGl_string2430z00zz__openpgpzd2encodezd2, BgL_arg1771z00_2757);} } 

}



/* &packet->content-tag1167 */
obj_t BGl_z62packetzd2ze3contentzd2tag1167z81zz__openpgpzd2encodezd2(obj_t BgL_envz00_2517, obj_t BgL_pz00_2518)
{
{ /* Llib/pgp_encode.scm 70 */
{ /* Llib/pgp_encode.scm 73 */
obj_t BgL_arg1768z00_2763;
{ /* Llib/pgp_encode.scm 73 */
obj_t BgL_arg1769z00_2764;
{ /* Llib/pgp_encode.scm 73 */
long BgL_arg1748z00_2765;
{ /* Llib/pgp_encode.scm 73 */
long BgL_arg1749z00_2766;
{ /* Llib/pgp_encode.scm 73 */
long BgL_res2152z00_2767;
BgL_res2152z00_2767 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)
((BgL_pgpzd2packetzd2_bglt)BgL_pz00_2518))); 
BgL_arg1749z00_2766 = BgL_res2152z00_2767; } 
BgL_arg1748z00_2765 = 
(BgL_arg1749z00_2766-OBJECT_TYPE); } 
BgL_arg1769z00_2764 = 
VECTOR_REF(BGl_za2classesza2z00zz__objectz00,BgL_arg1748z00_2765); } 
BgL_arg1768z00_2763 = 
BGl_classzd2namezd2zz__objectz00(BgL_arg1769z00_2764); } 
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)21)), BGl_string2431z00zz__openpgpzd2encodezd2, BgL_arg1768z00_2763);} } 

}



/* packet->content-tag */
obj_t BGl_packetzd2ze3contentzd2tagze3zz__openpgpzd2encodezd2(BgL_pgpzd2packetzd2_bglt BgL_pz00_22)
{
{ /* Llib/pgp_encode.scm 70 */
{ /* Llib/pgp_encode.scm 70 */
obj_t BgL_method1169z00_386;
{ /* Llib/pgp_encode.scm 70 */
obj_t BgL_res2168z00_1635;
{ /* Llib/pgp_encode.scm 70 */
long BgL_objzd2classzd2numz00_1600;
{ /* Llib/pgp_encode.scm 70 */
long BgL_res2158z00_1603;
BgL_res2158z00_1603 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_pz00_22)); 
BgL_objzd2classzd2numz00_1600 = BgL_res2158z00_1603; } 
{ /* Llib/pgp_encode.scm 70 */
obj_t BgL_arg1745z00_1601;
BgL_arg1745z00_1601 = 
PROCEDURE_REF(BGl_packetzd2ze3contentzd2tagzd2envz31zz__openpgpzd2encodezd2, 
(int)(((long)1))); 
{ /* Llib/pgp_encode.scm 70 */
int BgL_offsetz00_1605;
BgL_offsetz00_1605 = 
(int)(BgL_objzd2classzd2numz00_1600); 
{ /* Llib/pgp_encode.scm 70 */
long BgL_offsetz00_1606;
BgL_offsetz00_1606 = 
(
(long)(BgL_offsetz00_1605)-OBJECT_TYPE); 
{ /* Llib/pgp_encode.scm 70 */
long BgL_modz00_1607;
BgL_modz00_1607 = 
(BgL_offsetz00_1606 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/pgp_encode.scm 70 */
long BgL_restz00_1609;
BgL_restz00_1609 = 
(BgL_offsetz00_1606 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/pgp_encode.scm 70 */

{ /* Llib/pgp_encode.scm 70 */
obj_t BgL_bucketz00_1611;
BgL_bucketz00_1611 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_1601),BgL_modz00_1607); 
BgL_res2168z00_1635 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_1611),BgL_restz00_1609); } } } } } } } } 
BgL_method1169z00_386 = BgL_res2168z00_1635; } 
return 
PROCEDURE_ENTRY(BgL_method1169z00_386)(BgL_method1169z00_386, 
((obj_t)BgL_pz00_22), BEOA);} } 

}



/* &packet->content-tag */
obj_t BGl_z62packetzd2ze3contentzd2tagz81zz__openpgpzd2encodezd2(obj_t BgL_envz00_2519, obj_t BgL_pz00_2520)
{
{ /* Llib/pgp_encode.scm 70 */
{ /* Llib/pgp_encode.scm 70 */
BgL_pgpzd2packetzd2_bglt BgL_auxz00_3984;
if(
BGl_isazf3zf3zz__objectz00(BgL_pz00_2520, BGl_PGPzd2Packetzd2zz__openpgpzd2packetszd2))
{ /* Llib/pgp_encode.scm 70 */
BgL_auxz00_3984 = 
((BgL_pgpzd2packetzd2_bglt)BgL_pz00_2520)
; }  else 
{ 
obj_t BgL_auxz00_3988;
BgL_auxz00_3988 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2396z00zz__openpgpzd2encodezd2, 
BINT(((long)2156)), BGl_string2432z00zz__openpgpzd2encodezd2, BGl_string2404z00zz__openpgpzd2encodezd2, BgL_pz00_2520); 
FAILURE(BgL_auxz00_3988,BFALSE,BFALSE);} 
return 
BGl_packetzd2ze3contentzd2tagze3zz__openpgpzd2encodezd2(BgL_auxz00_3984);} } 

}



/* encode-content */
obj_t BGl_encodezd2contentzd2zz__openpgpzd2encodezd2(BgL_pgpzd2packetzd2_bglt BgL_packetz00_38, obj_t BgL_pz00_39)
{
{ /* Llib/pgp_encode.scm 129 */
{ /* Llib/pgp_encode.scm 129 */
obj_t BgL_method1198z00_387;
{ /* Llib/pgp_encode.scm 129 */
obj_t BgL_res2179z00_1672;
{ /* Llib/pgp_encode.scm 129 */
long BgL_objzd2classzd2numz00_1637;
{ /* Llib/pgp_encode.scm 129 */
long BgL_res2169z00_1640;
BgL_res2169z00_1640 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_packetz00_38)); 
BgL_objzd2classzd2numz00_1637 = BgL_res2169z00_1640; } 
{ /* Llib/pgp_encode.scm 129 */
obj_t BgL_arg1745z00_1638;
BgL_arg1745z00_1638 = 
PROCEDURE_REF(BGl_encodezd2contentzd2envz00zz__openpgpzd2encodezd2, 
(int)(((long)1))); 
{ /* Llib/pgp_encode.scm 129 */
int BgL_offsetz00_1642;
BgL_offsetz00_1642 = 
(int)(BgL_objzd2classzd2numz00_1637); 
{ /* Llib/pgp_encode.scm 129 */
long BgL_offsetz00_1643;
BgL_offsetz00_1643 = 
(
(long)(BgL_offsetz00_1642)-OBJECT_TYPE); 
{ /* Llib/pgp_encode.scm 129 */
long BgL_modz00_1644;
BgL_modz00_1644 = 
(BgL_offsetz00_1643 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/pgp_encode.scm 129 */
long BgL_restz00_1646;
BgL_restz00_1646 = 
(BgL_offsetz00_1643 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/pgp_encode.scm 129 */

{ /* Llib/pgp_encode.scm 129 */
obj_t BgL_bucketz00_1648;
BgL_bucketz00_1648 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_1638),BgL_modz00_1644); 
BgL_res2179z00_1672 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_1648),BgL_restz00_1646); } } } } } } } } 
BgL_method1198z00_387 = BgL_res2179z00_1672; } 
return 
PROCEDURE_ENTRY(BgL_method1198z00_387)(BgL_method1198z00_387, 
((obj_t)BgL_packetz00_38), BgL_pz00_39, BEOA);} } 

}



/* &encode-content */
obj_t BGl_z62encodezd2contentzb0zz__openpgpzd2encodezd2(obj_t BgL_envz00_2521, obj_t BgL_packetz00_2522, obj_t BgL_pz00_2523)
{
{ /* Llib/pgp_encode.scm 129 */
{ /* Llib/pgp_encode.scm 129 */
obj_t BgL_auxz00_4032;BgL_pgpzd2packetzd2_bglt BgL_auxz00_4024;
if(
OUTPUT_PORTP(BgL_pz00_2523))
{ /* Llib/pgp_encode.scm 129 */
BgL_auxz00_4032 = BgL_pz00_2523
; }  else 
{ 
obj_t BgL_auxz00_4035;
BgL_auxz00_4035 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2396z00zz__openpgpzd2encodezd2, 
BINT(((long)4461)), BGl_string2433z00zz__openpgpzd2encodezd2, BGl_string2398z00zz__openpgpzd2encodezd2, BgL_pz00_2523); 
FAILURE(BgL_auxz00_4035,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_packetz00_2522, BGl_PGPzd2Packetzd2zz__openpgpzd2packetszd2))
{ /* Llib/pgp_encode.scm 129 */
BgL_auxz00_4024 = 
((BgL_pgpzd2packetzd2_bglt)BgL_packetz00_2522)
; }  else 
{ 
obj_t BgL_auxz00_4028;
BgL_auxz00_4028 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2396z00zz__openpgpzd2encodezd2, 
BINT(((long)4461)), BGl_string2433z00zz__openpgpzd2encodezd2, BGl_string2404z00zz__openpgpzd2encodezd2, BgL_packetz00_2522); 
FAILURE(BgL_auxz00_4028,BFALSE,BFALSE);} 
return 
BGl_encodezd2contentzd2zz__openpgpzd2encodezd2(BgL_auxz00_4024, BgL_auxz00_4032);} } 

}



/* encode-sub-packet-content */
obj_t BGl_encodezd2subzd2packetzd2contentzd2zz__openpgpzd2encodezd2(BgL_pgpzd2signaturezd2subzd2packetzd2_bglt BgL_spz00_44, obj_t BgL_pz00_45)
{
{ /* Llib/pgp_encode.scm 169 */
{ /* Llib/pgp_encode.scm 169 */
obj_t BgL_method1202z00_388;
{ /* Llib/pgp_encode.scm 169 */
obj_t BgL_res2190z00_1709;
{ /* Llib/pgp_encode.scm 169 */
long BgL_objzd2classzd2numz00_1674;
{ /* Llib/pgp_encode.scm 169 */
long BgL_res2180z00_1677;
BgL_res2180z00_1677 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_spz00_44)); 
BgL_objzd2classzd2numz00_1674 = BgL_res2180z00_1677; } 
{ /* Llib/pgp_encode.scm 169 */
obj_t BgL_arg1745z00_1675;
BgL_arg1745z00_1675 = 
PROCEDURE_REF(BGl_encodezd2subzd2packetzd2contentzd2envz00zz__openpgpzd2encodezd2, 
(int)(((long)1))); 
{ /* Llib/pgp_encode.scm 169 */
int BgL_offsetz00_1679;
BgL_offsetz00_1679 = 
(int)(BgL_objzd2classzd2numz00_1674); 
{ /* Llib/pgp_encode.scm 169 */
long BgL_offsetz00_1680;
BgL_offsetz00_1680 = 
(
(long)(BgL_offsetz00_1679)-OBJECT_TYPE); 
{ /* Llib/pgp_encode.scm 169 */
long BgL_modz00_1681;
BgL_modz00_1681 = 
(BgL_offsetz00_1680 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/pgp_encode.scm 169 */
long BgL_restz00_1683;
BgL_restz00_1683 = 
(BgL_offsetz00_1680 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/pgp_encode.scm 169 */

{ /* Llib/pgp_encode.scm 169 */
obj_t BgL_bucketz00_1685;
BgL_bucketz00_1685 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_1675),BgL_modz00_1681); 
BgL_res2190z00_1709 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_1685),BgL_restz00_1683); } } } } } } } } 
BgL_method1202z00_388 = BgL_res2190z00_1709; } 
return 
PROCEDURE_ENTRY(BgL_method1202z00_388)(BgL_method1202z00_388, 
((obj_t)BgL_spz00_44), BgL_pz00_45, BEOA);} } 

}



/* &encode-sub-packet-content */
obj_t BGl_z62encodezd2subzd2packetzd2contentzb0zz__openpgpzd2encodezd2(obj_t BgL_envz00_2524, obj_t BgL_spz00_2525, obj_t BgL_pz00_2526)
{
{ /* Llib/pgp_encode.scm 169 */
{ /* Llib/pgp_encode.scm 169 */
obj_t BgL_auxz00_4079;BgL_pgpzd2signaturezd2subzd2packetzd2_bglt BgL_auxz00_4071;
if(
OUTPUT_PORTP(BgL_pz00_2526))
{ /* Llib/pgp_encode.scm 169 */
BgL_auxz00_4079 = BgL_pz00_2526
; }  else 
{ 
obj_t BgL_auxz00_4082;
BgL_auxz00_4082 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2396z00zz__openpgpzd2encodezd2, 
BINT(((long)5980)), BGl_string2434z00zz__openpgpzd2encodezd2, BGl_string2398z00zz__openpgpzd2encodezd2, BgL_pz00_2526); 
FAILURE(BgL_auxz00_4082,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_spz00_2525, BGl_PGPzd2Signaturezd2Subzd2Packetzd2zz__openpgpzd2packetszd2))
{ /* Llib/pgp_encode.scm 169 */
BgL_auxz00_4071 = 
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)BgL_spz00_2525)
; }  else 
{ 
obj_t BgL_auxz00_4075;
BgL_auxz00_4075 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2396z00zz__openpgpzd2encodezd2, 
BINT(((long)5980)), BGl_string2434z00zz__openpgpzd2encodezd2, BGl_string2435z00zz__openpgpzd2encodezd2, BgL_spz00_2525); 
FAILURE(BgL_auxz00_4075,BFALSE,BFALSE);} 
return 
BGl_encodezd2subzd2packetzd2contentzd2zz__openpgpzd2encodezd2(BgL_auxz00_4071, BgL_auxz00_4079);} } 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__openpgpzd2encodezd2()
{
{ /* Llib/pgp_encode.scm 1 */
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_packetzd2ze3contentzd2tagzd2envz31zz__openpgpzd2encodezd2, BGl_PGPzd2Publiczd2Keyzd2Encryptedzd2Sessionzd2Keyzd2Packetz00zz__openpgpzd2packetszd2, BGl_proc2436z00zz__openpgpzd2encodezd2, BGl_string2437z00zz__openpgpzd2encodezd2); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_packetzd2ze3contentzd2tagzd2envz31zz__openpgpzd2encodezd2, BGl_PGPzd2Signaturezd2Packetz00zz__openpgpzd2packetszd2, BGl_proc2438z00zz__openpgpzd2encodezd2, BGl_string2437z00zz__openpgpzd2encodezd2); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_packetzd2ze3contentzd2tagzd2envz31zz__openpgpzd2encodezd2, BGl_PGPzd2Symmetriczd2Keyzd2Encryptedzd2Sessionzd2Keyzd2Packetz00zz__openpgpzd2packetszd2, BGl_proc2439z00zz__openpgpzd2encodezd2, BGl_string2437z00zz__openpgpzd2encodezd2); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_packetzd2ze3contentzd2tagzd2envz31zz__openpgpzd2encodezd2, BGl_PGPzd2Onezd2Passzd2Signaturezd2Packetz00zz__openpgpzd2packetszd2, BGl_proc2440z00zz__openpgpzd2encodezd2, BGl_string2437z00zz__openpgpzd2encodezd2); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_packetzd2ze3contentzd2tagzd2envz31zz__openpgpzd2encodezd2, BGl_PGPzd2Secretzd2Keyzd2Packetzd2zz__openpgpzd2packetszd2, BGl_proc2441z00zz__openpgpzd2encodezd2, BGl_string2437z00zz__openpgpzd2encodezd2); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_packetzd2ze3contentzd2tagzd2envz31zz__openpgpzd2encodezd2, BGl_PGPzd2Publiczd2Keyzd2Packetzd2zz__openpgpzd2packetszd2, BGl_proc2442z00zz__openpgpzd2encodezd2, BGl_string2437z00zz__openpgpzd2encodezd2); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_packetzd2ze3contentzd2tagzd2envz31zz__openpgpzd2encodezd2, BGl_PGPzd2Compressedzd2Packetz00zz__openpgpzd2packetszd2, BGl_proc2443z00zz__openpgpzd2encodezd2, BGl_string2437z00zz__openpgpzd2encodezd2); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_packetzd2ze3contentzd2tagzd2envz31zz__openpgpzd2encodezd2, BGl_PGPzd2Symmetricallyzd2Encryptedzd2Packetzd2zz__openpgpzd2packetszd2, BGl_proc2444z00zz__openpgpzd2encodezd2, BGl_string2437z00zz__openpgpzd2encodezd2); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_packetzd2ze3contentzd2tagzd2envz31zz__openpgpzd2encodezd2, BGl_PGPzd2MDCzd2Symmetricallyzd2Encryptedzd2Packetz00zz__openpgpzd2packetszd2, BGl_proc2445z00zz__openpgpzd2encodezd2, BGl_string2437z00zz__openpgpzd2encodezd2); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_packetzd2ze3contentzd2tagzd2envz31zz__openpgpzd2encodezd2, BGl_PGPzd2Markerzd2Packetz00zz__openpgpzd2packetszd2, BGl_proc2446z00zz__openpgpzd2encodezd2, BGl_string2437z00zz__openpgpzd2encodezd2); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_packetzd2ze3contentzd2tagzd2envz31zz__openpgpzd2encodezd2, BGl_PGPzd2Literalzd2Packetz00zz__openpgpzd2packetszd2, BGl_proc2447z00zz__openpgpzd2encodezd2, BGl_string2437z00zz__openpgpzd2encodezd2); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_packetzd2ze3contentzd2tagzd2envz31zz__openpgpzd2encodezd2, BGl_PGPzd2Trustzd2Packetz00zz__openpgpzd2packetszd2, BGl_proc2448z00zz__openpgpzd2encodezd2, BGl_string2437z00zz__openpgpzd2encodezd2); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_packetzd2ze3contentzd2tagzd2envz31zz__openpgpzd2encodezd2, BGl_PGPzd2IDzd2Packetz00zz__openpgpzd2packetszd2, BGl_proc2449z00zz__openpgpzd2encodezd2, BGl_string2437z00zz__openpgpzd2encodezd2); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_encodezd2contentzd2envz00zz__openpgpzd2encodezd2, BGl_PGPzd2Publiczd2Keyzd2Encryptedzd2Sessionzd2Keyzd2Packetz00zz__openpgpzd2packetszd2, BGl_proc2450z00zz__openpgpzd2encodezd2, BGl_string2451z00zz__openpgpzd2encodezd2); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_encodezd2subzd2packetzd2contentzd2envz00zz__openpgpzd2encodezd2, BGl_PGPzd2Signaturezd2Subzd2Genericzd2zz__openpgpzd2packetszd2, BGl_proc2452z00zz__openpgpzd2encodezd2, BGl_string2453z00zz__openpgpzd2encodezd2); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_encodezd2subzd2packetzd2contentzd2envz00zz__openpgpzd2encodezd2, BGl_PGPzd2Signaturezd2Subzd2Creationzd2Timez00zz__openpgpzd2packetszd2, BGl_proc2454z00zz__openpgpzd2encodezd2, BGl_string2453z00zz__openpgpzd2encodezd2); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_encodezd2subzd2packetzd2contentzd2envz00zz__openpgpzd2encodezd2, BGl_PGPzd2Signaturezd2Subzd2Expirationzd2Timez00zz__openpgpzd2packetszd2, BGl_proc2455z00zz__openpgpzd2encodezd2, BGl_string2453z00zz__openpgpzd2encodezd2); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_encodezd2subzd2packetzd2contentzd2envz00zz__openpgpzd2encodezd2, BGl_PGPzd2Signaturezd2Subzd2Exportablezd2zz__openpgpzd2packetszd2, BGl_proc2456z00zz__openpgpzd2encodezd2, BGl_string2453z00zz__openpgpzd2encodezd2); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_encodezd2subzd2packetzd2contentzd2envz00zz__openpgpzd2encodezd2, BGl_PGPzd2Signaturezd2Subzd2Trustzd2zz__openpgpzd2packetszd2, BGl_proc2457z00zz__openpgpzd2encodezd2, BGl_string2453z00zz__openpgpzd2encodezd2); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_encodezd2subzd2packetzd2contentzd2envz00zz__openpgpzd2encodezd2, BGl_PGPzd2Signaturezd2Subzd2Revocablezd2zz__openpgpzd2packetszd2, BGl_proc2458z00zz__openpgpzd2encodezd2, BGl_string2453z00zz__openpgpzd2encodezd2); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_encodezd2subzd2packetzd2contentzd2envz00zz__openpgpzd2encodezd2, BGl_PGPzd2Signaturezd2Subzd2Keyzd2Expirationzd2Timezd2zz__openpgpzd2packetszd2, BGl_proc2459z00zz__openpgpzd2encodezd2, BGl_string2453z00zz__openpgpzd2encodezd2); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_encodezd2subzd2packetzd2contentzd2envz00zz__openpgpzd2encodezd2, BGl_PGPzd2Signaturezd2Subzd2Preferredzd2Symmetricz00zz__openpgpzd2packetszd2, BGl_proc2460z00zz__openpgpzd2encodezd2, BGl_string2453z00zz__openpgpzd2encodezd2); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_encodezd2subzd2packetzd2contentzd2envz00zz__openpgpzd2encodezd2, BGl_PGPzd2Signaturezd2Subzd2Revocationzd2zz__openpgpzd2packetszd2, BGl_proc2461z00zz__openpgpzd2encodezd2, BGl_string2453z00zz__openpgpzd2encodezd2); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_encodezd2subzd2packetzd2contentzd2envz00zz__openpgpzd2encodezd2, BGl_PGPzd2Signaturezd2Subzd2IDzd2zz__openpgpzd2packetszd2, BGl_proc2462z00zz__openpgpzd2encodezd2, BGl_string2453z00zz__openpgpzd2encodezd2); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_encodezd2subzd2packetzd2contentzd2envz00zz__openpgpzd2encodezd2, BGl_PGPzd2Signaturezd2Subzd2Notationzd2zz__openpgpzd2packetszd2, BGl_proc2463z00zz__openpgpzd2encodezd2, BGl_string2453z00zz__openpgpzd2encodezd2); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_encodezd2subzd2packetzd2contentzd2envz00zz__openpgpzd2encodezd2, BGl_PGPzd2Signaturezd2Subzd2Preferredzd2Hashz00zz__openpgpzd2packetszd2, BGl_proc2464z00zz__openpgpzd2encodezd2, BGl_string2453z00zz__openpgpzd2encodezd2); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_encodezd2subzd2packetzd2contentzd2envz00zz__openpgpzd2encodezd2, BGl_PGPzd2Signaturezd2Subzd2Preferredzd2Compressionz00zz__openpgpzd2packetszd2, BGl_proc2465z00zz__openpgpzd2encodezd2, BGl_string2453z00zz__openpgpzd2encodezd2); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_encodezd2subzd2packetzd2contentzd2envz00zz__openpgpzd2encodezd2, BGl_PGPzd2Signaturezd2Subzd2Preferredzd2Keyzd2Serverzd2zz__openpgpzd2packetszd2, BGl_proc2466z00zz__openpgpzd2encodezd2, BGl_string2453z00zz__openpgpzd2encodezd2); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_encodezd2subzd2packetzd2contentzd2envz00zz__openpgpzd2encodezd2, BGl_PGPzd2Signaturezd2Subzd2Primaryzd2IDz00zz__openpgpzd2packetszd2, BGl_proc2467z00zz__openpgpzd2encodezd2, BGl_string2453z00zz__openpgpzd2encodezd2); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_encodezd2subzd2packetzd2contentzd2envz00zz__openpgpzd2encodezd2, BGl_PGPzd2Signaturezd2Subzd2Policyzd2zz__openpgpzd2packetszd2, BGl_proc2468z00zz__openpgpzd2encodezd2, BGl_string2453z00zz__openpgpzd2encodezd2); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_encodezd2subzd2packetzd2contentzd2envz00zz__openpgpzd2encodezd2, BGl_PGPzd2Signaturezd2Subzd2Signerzd2IDz00zz__openpgpzd2packetszd2, BGl_proc2469z00zz__openpgpzd2encodezd2, BGl_string2453z00zz__openpgpzd2encodezd2); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_encodezd2subzd2packetzd2contentzd2envz00zz__openpgpzd2encodezd2, BGl_PGPzd2Signaturezd2Subzd2Revocationzd2Reasonz00zz__openpgpzd2packetszd2, BGl_proc2470z00zz__openpgpzd2encodezd2, BGl_string2453z00zz__openpgpzd2encodezd2); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_encodezd2contentzd2envz00zz__openpgpzd2encodezd2, BGl_PGPzd2Signaturezd2v4zd2Packetzd2zz__openpgpzd2packetszd2, BGl_proc2471z00zz__openpgpzd2encodezd2, BGl_string2451z00zz__openpgpzd2encodezd2); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_encodezd2contentzd2envz00zz__openpgpzd2encodezd2, BGl_PGPzd2Symmetriczd2Keyzd2Encryptedzd2Sessionzd2Keyzd2Packetz00zz__openpgpzd2packetszd2, BGl_proc2472z00zz__openpgpzd2encodezd2, BGl_string2451z00zz__openpgpzd2encodezd2); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_encodezd2contentzd2envz00zz__openpgpzd2encodezd2, BGl_PGPzd2Onezd2Passzd2Signaturezd2Packetz00zz__openpgpzd2packetszd2, BGl_proc2473z00zz__openpgpzd2encodezd2, BGl_string2451z00zz__openpgpzd2encodezd2); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_encodezd2contentzd2envz00zz__openpgpzd2encodezd2, BGl_PGPzd2Secretzd2Keyzd2Packetzd2zz__openpgpzd2packetszd2, BGl_proc2474z00zz__openpgpzd2encodezd2, BGl_string2451z00zz__openpgpzd2encodezd2); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_encodezd2contentzd2envz00zz__openpgpzd2encodezd2, BGl_PGPzd2Publiczd2Keyzd2Packetzd2zz__openpgpzd2packetszd2, BGl_proc2475z00zz__openpgpzd2encodezd2, BGl_string2451z00zz__openpgpzd2encodezd2); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_encodezd2contentzd2envz00zz__openpgpzd2encodezd2, BGl_PGPzd2Symmetricallyzd2Encryptedzd2Packetzd2zz__openpgpzd2packetszd2, BGl_proc2476z00zz__openpgpzd2encodezd2, BGl_string2451z00zz__openpgpzd2encodezd2); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_encodezd2contentzd2envz00zz__openpgpzd2encodezd2, BGl_PGPzd2Markerzd2Packetz00zz__openpgpzd2packetszd2, BGl_proc2477z00zz__openpgpzd2encodezd2, BGl_string2451z00zz__openpgpzd2encodezd2); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_encodezd2contentzd2envz00zz__openpgpzd2encodezd2, BGl_PGPzd2Literalzd2Packetz00zz__openpgpzd2packetszd2, BGl_proc2478z00zz__openpgpzd2encodezd2, BGl_string2451z00zz__openpgpzd2encodezd2); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_encodezd2contentzd2envz00zz__openpgpzd2encodezd2, BGl_PGPzd2Trustzd2Packetz00zz__openpgpzd2packetszd2, BGl_proc2479z00zz__openpgpzd2encodezd2, BGl_string2451z00zz__openpgpzd2encodezd2); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_encodezd2contentzd2envz00zz__openpgpzd2encodezd2, BGl_PGPzd2IDzd2Packetz00zz__openpgpzd2packetszd2, BGl_proc2480z00zz__openpgpzd2encodezd2, BGl_string2451z00zz__openpgpzd2encodezd2); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_encodezd2contentzd2envz00zz__openpgpzd2encodezd2, BGl_PGPzd2MDCzd2Symmetricallyzd2Encryptedzd2Packetz00zz__openpgpzd2packetszd2, BGl_proc2481z00zz__openpgpzd2encodezd2, BGl_string2451z00zz__openpgpzd2encodezd2); 
return 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_encodezd2contentzd2envz00zz__openpgpzd2encodezd2, BGl_PGPzd2MDCzd2Packetz00zz__openpgpzd2packetszd2, BGl_proc2482z00zz__openpgpzd2encodezd2, BGl_string2451z00zz__openpgpzd2encodezd2);} 

}



/* &encode-content-PGP-M1262 */
obj_t BGl_z62encodezd2contentzd2PGPzd2M1262zb0zz__openpgpzd2encodezd2(obj_t BgL_envz00_2577, obj_t BgL_packetz00_2578, obj_t BgL_pz00_2579)
{
{ /* Llib/pgp_encode.scm 622 */
return 
bgl_display_obj(
(((BgL_pgpzd2mdczd2packetz00_bglt)COBJECT(
((BgL_pgpzd2mdczd2packetz00_bglt)BgL_packetz00_2578)))->BgL_hashz00), 
((obj_t)BgL_pz00_2579));} 

}



/* &encode-content-PGP-M1260 */
obj_t BGl_z62encodezd2contentzd2PGPzd2M1260zb0zz__openpgpzd2encodezd2(obj_t BgL_envz00_2580, obj_t BgL_packetz00_2581, obj_t BgL_pz00_2582)
{
{ /* Llib/pgp_encode.scm 616 */
{ /* Llib/pgp_encode.scm 619 */
long BgL_arg1905z00_2772;
BgL_arg1905z00_2772 = 
(((BgL_pgpzd2mdczd2symmetricallyzd2encryptedzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2mdczd2symmetricallyzd2encryptedzd2packetz00_bglt)BgL_packetz00_2581)))->BgL_versionz00); 
if(
(BgL_arg1905z00_2772>=((long)256)))
{ /* Llib/pgp_encode.scm 22 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2399z00zz__openpgpzd2encodezd2, 
BINT(BgL_arg1905z00_2772)); }  else 
{ /* Llib/pgp_encode.scm 22 */BFALSE; } 
{ /* Llib/pgp_encode.scm 26 */
unsigned char BgL_arg1300z00_2773;
BgL_arg1300z00_2773 = 
(BgL_arg1905z00_2772); 
bgl_display_obj(
BCHAR(BgL_arg1300z00_2773), 
((obj_t)BgL_pz00_2582)); } } 
{ /* Llib/pgp_encode.scm 620 */
obj_t BgL_arg1906z00_2774;
BgL_arg1906z00_2774 = 
(((BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt)
((BgL_pgpzd2mdczd2symmetricallyzd2encryptedzd2packetz00_bglt)BgL_packetz00_2581))))->BgL_dataz00); 
return 
bgl_display_obj(BgL_arg1906z00_2774, 
((obj_t)BgL_pz00_2582));} } 

}



/* &encode-content-PGP-I1258 */
obj_t BGl_z62encodezd2contentzd2PGPzd2I1258zb0zz__openpgpzd2encodezd2(obj_t BgL_envz00_2583, obj_t BgL_packetz00_2584, obj_t BgL_pz00_2585)
{
{ /* Llib/pgp_encode.scm 611 */
return 
bgl_display_obj(
(((BgL_pgpzd2idzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2idzd2packetz00_bglt)BgL_packetz00_2584)))->BgL_dataz00), 
((obj_t)BgL_pz00_2585));} 

}



/* &encode-content-PGP-T1256 */
obj_t BGl_z62encodezd2contentzd2PGPzd2T1256zb0zz__openpgpzd2encodezd2(obj_t BgL_envz00_2586, obj_t BgL_packetz00_2587, obj_t BgL_pz00_2588)
{
{ /* Llib/pgp_encode.scm 605 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)22)), BGl_string2483z00zz__openpgpzd2encodezd2, BFALSE);} 

}



/* &encode-content-PGP-L1254 */
obj_t BGl_z62encodezd2contentzd2PGPzd2L1254zb0zz__openpgpzd2encodezd2(obj_t BgL_envz00_2589, obj_t BgL_packetz00_2590, obj_t BgL_pz00_2591)
{
{ /* Llib/pgp_encode.scm 576 */
{ /* Llib/pgp_encode.scm 580 */
bool_t BgL_test2714z00_4157;
if(
(((BgL_pgpzd2literalzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2literalzd2packetz00_bglt)BgL_packetz00_2590)))->BgL_forzd2yourzd2eyeszd2onlyzf3z21))
{ /* Llib/pgp_encode.scm 580 */
BgL_test2714z00_4157 = 
CBOOL(
(((BgL_pgpzd2literalzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2literalzd2packetz00_bglt)BgL_packetz00_2590)))->BgL_filezd2namezd2))
; }  else 
{ /* Llib/pgp_encode.scm 580 */
BgL_test2714z00_4157 = ((bool_t)0)
; } 
if(BgL_test2714z00_4157)
{ /* Llib/pgp_encode.scm 581 */
obj_t BgL_arg1891z00_2781;
BgL_arg1891z00_2781 = 
(((BgL_pgpzd2literalzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2literalzd2packetz00_bglt)BgL_packetz00_2590)))->BgL_filezd2namezd2); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)23)), BGl_string2484z00zz__openpgpzd2encodezd2, BgL_arg1891z00_2781); }  else 
{ /* Llib/pgp_encode.scm 580 */BFALSE; } } 
{ /* Llib/pgp_encode.scm 584 */
obj_t BgL_filez00_2782;
if(
(((BgL_pgpzd2literalzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2literalzd2packetz00_bglt)BgL_packetz00_2590)))->BgL_forzd2yourzd2eyeszd2onlyzf3z21))
{ /* Llib/pgp_encode.scm 585 */
BgL_filez00_2782 = BGl_string2485z00zz__openpgpzd2encodezd2; }  else 
{ /* Llib/pgp_encode.scm 587 */
bool_t BgL_test2717z00_4171;
{ /* Llib/pgp_encode.scm 587 */
obj_t BgL_tmpz00_4172;
BgL_tmpz00_4172 = 
(((BgL_pgpzd2literalzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2literalzd2packetz00_bglt)BgL_packetz00_2590)))->BgL_filezd2namezd2); 
BgL_test2717z00_4171 = 
STRINGP(BgL_tmpz00_4172); } 
if(BgL_test2717z00_4171)
{ /* Llib/pgp_encode.scm 587 */
BgL_filez00_2782 = 
(((BgL_pgpzd2literalzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2literalzd2packetz00_bglt)BgL_packetz00_2590)))->BgL_filezd2namezd2); }  else 
{ /* Llib/pgp_encode.scm 587 */
BgL_filez00_2782 = BGl_string2486z00zz__openpgpzd2encodezd2; } } 
if(
(
STRING_LENGTH(
((obj_t)BgL_filez00_2782))>((long)255)))
{ /* Llib/pgp_encode.scm 591 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)23)), BGl_string2487z00zz__openpgpzd2encodezd2, BgL_filez00_2782); }  else 
{ /* Llib/pgp_encode.scm 591 */BFALSE; } 
{ /* Llib/pgp_encode.scm 599 */
char BgL_arg1895z00_2783;
BgL_arg1895z00_2783 = 
BGl_literalzd2formatzd2ze3byteze3zz__openpgpzd2enumszd2(
(((BgL_pgpzd2literalzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2literalzd2packetz00_bglt)BgL_packetz00_2590)))->BgL_formatz00)); 
{ /* Llib/pgp_encode.scm 599 */
long BgL_nz00_2784;
BgL_nz00_2784 = 
(long)(BgL_arg1895z00_2783); 
if(
(BgL_nz00_2784>=((long)256)))
{ /* Llib/pgp_encode.scm 22 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2399z00zz__openpgpzd2encodezd2, 
BINT(BgL_nz00_2784)); }  else 
{ /* Llib/pgp_encode.scm 22 */BFALSE; } 
{ /* Llib/pgp_encode.scm 26 */
unsigned char BgL_arg1300z00_2785;
BgL_arg1300z00_2785 = 
(BgL_nz00_2784); 
bgl_display_obj(
BCHAR(BgL_arg1300z00_2785), 
((obj_t)BgL_pz00_2591)); } } } 
{ /* Llib/pgp_encode.scm 600 */
long BgL_arg1897z00_2786;
BgL_arg1897z00_2786 = 
STRING_LENGTH(
((obj_t)BgL_filez00_2782)); 
if(
(BgL_arg1897z00_2786>=((long)256)))
{ /* Llib/pgp_encode.scm 22 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2399z00zz__openpgpzd2encodezd2, 
BINT(BgL_arg1897z00_2786)); }  else 
{ /* Llib/pgp_encode.scm 22 */BFALSE; } 
{ /* Llib/pgp_encode.scm 26 */
unsigned char BgL_arg1300z00_2787;
BgL_arg1300z00_2787 = 
(BgL_arg1897z00_2786); 
bgl_display_obj(
BCHAR(BgL_arg1300z00_2787), 
((obj_t)BgL_pz00_2591)); } } 
bgl_display_obj(BgL_filez00_2782, 
((obj_t)BgL_pz00_2591)); 
{ /* Llib/pgp_encode.scm 602 */
obj_t BgL_arg1898z00_2788;
BgL_arg1898z00_2788 = 
(((BgL_pgpzd2literalzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2literalzd2packetz00_bglt)BgL_packetz00_2590)))->BgL_creationzd2datezd2); 
{ /* Llib/pgp_encode.scm 60 */
long BgL_arg1351z00_2789;
BgL_arg1351z00_2789 = 
bgl_date_to_seconds(BgL_arg1898z00_2788); 
{ /* Llib/pgp_encode.scm 60 */
long BgL_nnz00_2790;
BgL_nnz00_2790 = 
(long)(BgL_arg1351z00_2789); 
bgl_display_obj(
BGl_fixnumzd2ze3scalarz31zz__openpgpzd2conversionzd2(BgL_nnz00_2790, ((long)4)), 
((obj_t)BgL_pz00_2591)); } } } 
return 
bgl_display_obj(
(((BgL_pgpzd2literalzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2literalzd2packetz00_bglt)BgL_packetz00_2590)))->BgL_dataz00), 
((obj_t)BgL_pz00_2591));} } 

}



/* &encode-content-PGP-M1252 */
obj_t BGl_z62encodezd2contentzd2PGPzd2M1252zb0zz__openpgpzd2encodezd2(obj_t BgL_envz00_2592, obj_t BgL_packetz00_2593, obj_t BgL_pz00_2594)
{
{ /* Llib/pgp_encode.scm 572 */
return 
CNST_TABLE_REF(((long)24));} 

}



/* &encode-content-PGP-S1250 */
obj_t BGl_z62encodezd2contentzd2PGPzd2S1250zb0zz__openpgpzd2encodezd2(obj_t BgL_envz00_2595, obj_t BgL_packetz00_2596, obj_t BgL_pz00_2597)
{
{ /* Llib/pgp_encode.scm 566 */
return 
bgl_display_obj(
(((BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt)BgL_packetz00_2596)))->BgL_dataz00), 
((obj_t)BgL_pz00_2597));} 

}



/* &encode-content-PGP-P1248 */
obj_t BGl_z62encodezd2contentzd2PGPzd2P1248zb0zz__openpgpzd2encodezd2(obj_t BgL_envz00_2598, obj_t BgL_packetz00_2599, obj_t BgL_pz00_2600)
{
{ /* Llib/pgp_encode.scm 562 */
return 
BGl_encodezd2publiczd2keyzd2contentzd2zz__openpgpzd2encodezd2(
((BgL_pgpzd2keyzd2packetz00_bglt)
((BgL_pgpzd2publiczd2keyzd2packetzd2_bglt)BgL_packetz00_2599)), 
((obj_t)BgL_pz00_2600));} 

}



/* &encode-content-PGP-S1246 */
obj_t BGl_z62encodezd2contentzd2PGPzd2S1246zb0zz__openpgpzd2encodezd2(obj_t BgL_envz00_2601, obj_t BgL_packetz00_2602, obj_t BgL_pz00_2603)
{
{ /* Llib/pgp_encode.scm 555 */
BGl_encodezd2publiczd2keyzd2contentzd2zz__openpgpzd2encodezd2(
((BgL_pgpzd2keyzd2packetz00_bglt)
((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)BgL_packetz00_2602)), 
((obj_t)BgL_pz00_2603)); 
return 
bgl_display_obj(
(((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)BgL_packetz00_2602)))->BgL_passwordzd2protectedzd2secretzd2keyzd2dataz00), 
((obj_t)BgL_pz00_2603));} 

}



/* &encode-content-PGP-O1244 */
obj_t BGl_z62encodezd2contentzd2PGPzd2O1244zb0zz__openpgpzd2encodezd2(obj_t BgL_envz00_2604, obj_t BgL_packetz00_2605, obj_t BgL_pz00_2606)
{
{ /* Llib/pgp_encode.scm 474 */
{ /* Llib/pgp_encode.scm 488 */
long BgL_arg1877z00_2801;
BgL_arg1877z00_2801 = 
(((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bglt)BgL_packetz00_2605))))->BgL_versionz00); 
if(
(BgL_arg1877z00_2801>=((long)256)))
{ /* Llib/pgp_encode.scm 22 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2399z00zz__openpgpzd2encodezd2, 
BINT(BgL_arg1877z00_2801)); }  else 
{ /* Llib/pgp_encode.scm 22 */BFALSE; } 
{ /* Llib/pgp_encode.scm 26 */
unsigned char BgL_arg1300z00_2802;
BgL_arg1300z00_2802 = 
(BgL_arg1877z00_2801); 
bgl_display_obj(
BCHAR(BgL_arg1300z00_2802), 
((obj_t)BgL_pz00_2606)); } } 
{ /* Llib/pgp_encode.scm 489 */
char BgL_arg1878z00_2803;
{ /* Llib/pgp_encode.scm 489 */
obj_t BgL_arg1879z00_2804;
BgL_arg1879z00_2804 = 
(((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bglt)BgL_packetz00_2605))))->BgL_signaturezd2typezd2); 
BgL_arg1878z00_2803 = 
BGl_signaturezd2typezd2ze3byteze3zz__openpgpzd2enumszd2(BgL_arg1879z00_2804); } 
{ /* Llib/pgp_encode.scm 489 */
long BgL_nz00_2805;
BgL_nz00_2805 = 
(long)(BgL_arg1878z00_2803); 
if(
(BgL_nz00_2805>=((long)256)))
{ /* Llib/pgp_encode.scm 22 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2399z00zz__openpgpzd2encodezd2, 
BINT(BgL_nz00_2805)); }  else 
{ /* Llib/pgp_encode.scm 22 */BFALSE; } 
{ /* Llib/pgp_encode.scm 26 */
unsigned char BgL_arg1300z00_2806;
BgL_arg1300z00_2806 = 
(BgL_nz00_2805); 
bgl_display_obj(
BCHAR(BgL_arg1300z00_2806), 
((obj_t)BgL_pz00_2606)); } } } 
{ /* Llib/pgp_encode.scm 490 */
char BgL_arg1880z00_2807;
{ /* Llib/pgp_encode.scm 490 */
obj_t BgL_arg1881z00_2808;
BgL_arg1881z00_2808 = 
(((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bglt)BgL_packetz00_2605))))->BgL_hashzd2algozd2); 
BgL_arg1880z00_2807 = 
BGl_hashzd2algozd2ze3byteze3zz__openpgpzd2enumszd2(BgL_arg1881z00_2808); } 
{ /* Llib/pgp_encode.scm 490 */
long BgL_nz00_2809;
BgL_nz00_2809 = 
(long)(BgL_arg1880z00_2807); 
if(
(BgL_nz00_2809>=((long)256)))
{ /* Llib/pgp_encode.scm 22 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2399z00zz__openpgpzd2encodezd2, 
BINT(BgL_nz00_2809)); }  else 
{ /* Llib/pgp_encode.scm 22 */BFALSE; } 
{ /* Llib/pgp_encode.scm 26 */
unsigned char BgL_arg1300z00_2810;
BgL_arg1300z00_2810 = 
(BgL_nz00_2809); 
bgl_display_obj(
BCHAR(BgL_arg1300z00_2810), 
((obj_t)BgL_pz00_2606)); } } } 
{ /* Llib/pgp_encode.scm 491 */
char BgL_arg1882z00_2811;
{ /* Llib/pgp_encode.scm 491 */
obj_t BgL_arg1883z00_2812;
BgL_arg1883z00_2812 = 
(((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bglt)BgL_packetz00_2605))))->BgL_publiczd2keyzd2algoz00); 
BgL_arg1882z00_2811 = 
BGl_publiczd2keyzd2algozd2ze3bytez31zz__openpgpzd2enumszd2(BgL_arg1883z00_2812); } 
{ /* Llib/pgp_encode.scm 491 */
long BgL_nz00_2813;
BgL_nz00_2813 = 
(long)(BgL_arg1882z00_2811); 
if(
(BgL_nz00_2813>=((long)256)))
{ /* Llib/pgp_encode.scm 22 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2399z00zz__openpgpzd2encodezd2, 
BINT(BgL_nz00_2813)); }  else 
{ /* Llib/pgp_encode.scm 22 */BFALSE; } 
{ /* Llib/pgp_encode.scm 26 */
unsigned char BgL_arg1300z00_2814;
BgL_arg1300z00_2814 = 
(BgL_nz00_2813); 
bgl_display_obj(
BCHAR(BgL_arg1300z00_2814), 
((obj_t)BgL_pz00_2606)); } } } 
{ /* Llib/pgp_encode.scm 492 */
obj_t BgL_arg1884z00_2815;
BgL_arg1884z00_2815 = 
(((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bglt)BgL_packetz00_2605))))->BgL_issuerz00); 
if(
(
STRING_LENGTH(
((obj_t)BgL_arg1884z00_2815))==((long)8)))
{ /* Llib/pgp_encode.scm 28 */BFALSE; }  else 
{ /* Llib/pgp_encode.scm 31 */
obj_t BgL_arg1330z00_2816;
BgL_arg1330z00_2816 = 
MAKE_YOUNG_PAIR(
BINT(((long)8)), 
((obj_t)BgL_arg1884z00_2815)); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)8)), BGl_string2412z00zz__openpgpzd2encodezd2, BgL_arg1330z00_2816); } 
bgl_display_obj(
((obj_t)BgL_arg1884z00_2815), 
((obj_t)BgL_pz00_2606)); } 
{ /* Llib/pgp_encode.scm 493 */
long BgL_arg1885z00_2817;
if(
(((BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bglt)BgL_packetz00_2605)))->BgL_containszd2nestedzd2sigzf3zf3))
{ /* Llib/pgp_encode.scm 493 */
BgL_arg1885z00_2817 = ((long)0); }  else 
{ /* Llib/pgp_encode.scm 493 */
BgL_arg1885z00_2817 = ((long)1); } 
if(
(BgL_arg1885z00_2817>=((long)256)))
{ /* Llib/pgp_encode.scm 22 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2399z00zz__openpgpzd2encodezd2, 
BINT(BgL_arg1885z00_2817)); }  else 
{ /* Llib/pgp_encode.scm 22 */BFALSE; } 
{ /* Llib/pgp_encode.scm 26 */
unsigned char BgL_arg1300z00_2818;
BgL_arg1300z00_2818 = 
(BgL_arg1885z00_2817); 
return 
bgl_display_obj(
BCHAR(BgL_arg1300z00_2818), 
((obj_t)BgL_pz00_2606));} } } 

}



/* &encode-content-PGP-S1242 */
obj_t BGl_z62encodezd2contentzd2PGPzd2S1242zb0zz__openpgpzd2encodezd2(obj_t BgL_envz00_2607, obj_t BgL_packetz00_2608, obj_t BgL_pz00_2609)
{
{ /* Llib/pgp_encode.scm 451 */
if(
(
(((BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)BgL_packetz00_2608)))->BgL_versionz00)==((long)4)))
{ /* Llib/pgp_encode.scm 457 */BFALSE; }  else 
{ /* Llib/pgp_encode.scm 458 */
long BgL_arg1869z00_2821;
BgL_arg1869z00_2821 = 
(((BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)BgL_packetz00_2608)))->BgL_versionz00); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)25)), BGl_string2488z00zz__openpgpzd2encodezd2, 
BINT(BgL_arg1869z00_2821)); } 
{ /* Llib/pgp_encode.scm 464 */
long BgL_arg1871z00_2822;
BgL_arg1871z00_2822 = 
(((BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)BgL_packetz00_2608)))->BgL_versionz00); 
if(
(BgL_arg1871z00_2822>=((long)256)))
{ /* Llib/pgp_encode.scm 22 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2399z00zz__openpgpzd2encodezd2, 
BINT(BgL_arg1871z00_2822)); }  else 
{ /* Llib/pgp_encode.scm 22 */BFALSE; } 
{ /* Llib/pgp_encode.scm 26 */
unsigned char BgL_arg1300z00_2823;
BgL_arg1300z00_2823 = 
(BgL_arg1871z00_2822); 
bgl_display_obj(
BCHAR(BgL_arg1300z00_2823), 
((obj_t)BgL_pz00_2609)); } } 
{ /* Llib/pgp_encode.scm 465 */
char BgL_arg1872z00_2824;
BgL_arg1872z00_2824 = 
BGl_symmetriczd2keyzd2algozd2ze3bytez31zz__openpgpzd2enumszd2(
(((BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)BgL_packetz00_2608)))->BgL_algoz00)); 
{ /* Llib/pgp_encode.scm 465 */
long BgL_nz00_2825;
BgL_nz00_2825 = 
(long)(BgL_arg1872z00_2824); 
if(
(BgL_nz00_2825>=((long)256)))
{ /* Llib/pgp_encode.scm 22 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2399z00zz__openpgpzd2encodezd2, 
BINT(BgL_nz00_2825)); }  else 
{ /* Llib/pgp_encode.scm 22 */BFALSE; } 
{ /* Llib/pgp_encode.scm 26 */
unsigned char BgL_arg1300z00_2826;
BgL_arg1300z00_2826 = 
(BgL_nz00_2825); 
bgl_display_obj(
BCHAR(BgL_arg1300z00_2826), 
((obj_t)BgL_pz00_2609)); } } } 
BGl_encodezd2s2kzd2zz__openpgpzd2encodezd2(
(((BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)BgL_packetz00_2608)))->BgL_s2kz00), 
((obj_t)BgL_pz00_2609)); 
if(
CBOOL(
(((BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)BgL_packetz00_2608)))->BgL_encryptedzd2sessionzd2keyz00)))
{ /* Llib/pgp_encode.scm 469 */
bgl_display_obj(
(((BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)BgL_packetz00_2608)))->BgL_encryptedzd2sessionzd2keyz00), 
((obj_t)BgL_pz00_2609)); 
return BUNSPEC;}  else 
{ /* Llib/pgp_encode.scm 469 */
return BFALSE;} } 

}



/* &encode-content-PGP-S1240 */
obj_t BGl_z62encodezd2contentzd2PGPzd2S1240zb0zz__openpgpzd2encodezd2(obj_t BgL_envz00_2610, obj_t BgL_packetz00_2611, obj_t BgL_pz00_2612)
{
{ /* Llib/pgp_encode.scm 373 */
{ /* Llib/pgp_encode.scm 389 */
obj_t BgL_arg1847z00_2829;
BgL_arg1847z00_2829 = 
(((BgL_pgpzd2signaturezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2packetz00_bglt)
((BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt)BgL_packetz00_2611))))->BgL_signedzd2packetzd2prefixz00); 
bgl_display_obj(BgL_arg1847z00_2829, 
((obj_t)BgL_pz00_2612)); } 
{ /* Llib/pgp_encode.scm 390 */
obj_t BgL_arg1848z00_2830;obj_t BgL_arg1849z00_2831;obj_t BgL_arg1850z00_2832;
BgL_arg1848z00_2830 = 
(((BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt)BgL_packetz00_2611)))->BgL_securezd2subzd2packetsz00); 
BgL_arg1849z00_2831 = 
(((BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt)BgL_packetz00_2611)))->BgL_insecurezd2subzd2packetsz00); 
BgL_arg1850z00_2832 = 
(((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt)BgL_packetz00_2611))))->BgL_issuerz00); 
BGl_encodezd2insecurezd2subzd2packetszd2zz__openpgpzd2encodezd2(BgL_arg1848z00_2830, BgL_arg1849z00_2831, BgL_arg1850z00_2832, 
((obj_t)BgL_pz00_2612)); } 
{ /* Llib/pgp_encode.scm 392 */
obj_t BgL_arg1851z00_2833;
BgL_arg1851z00_2833 = 
(((BgL_pgpzd2signaturezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2packetz00_bglt)
((BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt)BgL_packetz00_2611))))->BgL_leftzd2hashzd2); 
if(
(
STRING_LENGTH(BgL_arg1851z00_2833)==((long)2)))
{ /* Llib/pgp_encode.scm 28 */BFALSE; }  else 
{ /* Llib/pgp_encode.scm 31 */
obj_t BgL_arg1330z00_2834;
BgL_arg1330z00_2834 = 
MAKE_YOUNG_PAIR(
BINT(((long)2)), BgL_arg1851z00_2833); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)8)), BGl_string2412z00zz__openpgpzd2encodezd2, BgL_arg1330z00_2834); } 
bgl_display_obj(BgL_arg1851z00_2833, 
((obj_t)BgL_pz00_2612)); } 
{ /* Llib/pgp_encode.scm 393 */
obj_t BgL_casezd2valuezd2_2835;
BgL_casezd2valuezd2_2835 = 
(((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt)BgL_packetz00_2611))))->BgL_publiczd2keyzd2algoz00); 
{ /* Llib/pgp_encode.scm 393 */
bool_t BgL_test2733z00_4393;
{ /* Llib/pgp_encode.scm 393 */
bool_t BgL__ortest_1136z00_2836;
BgL__ortest_1136z00_2836 = 
(BgL_casezd2valuezd2_2835==
CNST_TABLE_REF(((long)11))); 
if(BgL__ortest_1136z00_2836)
{ /* Llib/pgp_encode.scm 393 */
BgL_test2733z00_4393 = BgL__ortest_1136z00_2836
; }  else 
{ /* Llib/pgp_encode.scm 393 */
BgL_test2733z00_4393 = 
(BgL_casezd2valuezd2_2835==
CNST_TABLE_REF(((long)13)))
; } } 
if(BgL_test2733z00_4393)
{ /* Llib/pgp_encode.scm 395 */
obj_t BgL_arg1853z00_2837;
BgL_arg1853z00_2837 = 
(((BgL_pgpzd2signaturezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2packetz00_bglt)
((BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt)BgL_packetz00_2611))))->BgL_signaturez00); 
{ /* Llib/pgp_encode.scm 40 */
long BgL_bitzd2lenzd2_2838;
BgL_bitzd2lenzd2_2838 = 
BGl_bignumzd2bitzd2lengthz00zz__openpgpzd2utilzd2(
((obj_t)BgL_arg1853z00_2837)); 
{ /* Llib/pgp_encode.scm 40 */
long BgL_octetzd2lenzd2_2839;
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2295z00_2840;
{ /* Llib/pgp_encode.scm 41 */
long BgL_qz00_2841;long BgL_rz00_2842;
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2283z00_2843;
BgL_res2283z00_2843 = 
(BgL_bitzd2lenzd2_2838/((long)8)); 
BgL_qz00_2841 = BgL_res2283z00_2843; } 
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2289z00_2844;
{ /* Llib/pgp_encode.scm 41 */
long BgL_n1z00_2845;long BgL_n2z00_2846;
BgL_n1z00_2845 = BgL_bitzd2lenzd2_2838; 
BgL_n2z00_2846 = ((long)8); 
{ /* Llib/pgp_encode.scm 41 */
bool_t BgL_test2735z00_4405;
{ /* Llib/pgp_encode.scm 41 */
long BgL_arg1299z00_2847;
BgL_arg1299z00_2847 = 
(((BgL_n1z00_2845) | (BgL_n2z00_2846)) & -2147483648); 
BgL_test2735z00_4405 = 
(BgL_arg1299z00_2847==((long)0)); } 
if(BgL_test2735z00_4405)
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_arg1287z00_2848;
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_arg1293z00_2849;int32_t BgL_arg1294z00_2850;
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_res2285z00_2851;
BgL_res2285z00_2851 = 
(int32_t)(BgL_n1z00_2845); 
BgL_arg1293z00_2849 = BgL_res2285z00_2851; } 
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_res2286z00_2852;
BgL_res2286z00_2852 = 
(int32_t)(BgL_n2z00_2846); 
BgL_arg1294z00_2850 = BgL_res2286z00_2852; } 
BgL_arg1287z00_2848 = 
(BgL_arg1293z00_2849%BgL_arg1294z00_2850); } 
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2288z00_2853;
{ /* Llib/pgp_encode.scm 41 */
long BgL_arg1421z00_2854;
BgL_arg1421z00_2854 = 
(long)(BgL_arg1287z00_2848); 
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2287z00_2855;
BgL_res2287z00_2855 = 
(long)(BgL_arg1421z00_2854); 
BgL_res2288z00_2853 = BgL_res2287z00_2855; } } 
BgL_res2289z00_2844 = BgL_res2288z00_2853; } }  else 
{ /* Llib/pgp_encode.scm 41 */
BgL_res2289z00_2844 = 
(BgL_n1z00_2845%BgL_n2z00_2846); } } } 
BgL_rz00_2842 = BgL_res2289z00_2844; } 
if(
(BgL_rz00_2842==((long)0)))
{ /* Llib/pgp_encode.scm 41 */
BgL_res2295z00_2840 = BgL_qz00_2841; }  else 
{ /* Llib/pgp_encode.scm 41 */
if(
(BgL_rz00_2842>((long)0)))
{ /* Llib/pgp_encode.scm 41 */
BgL_res2295z00_2840 = 
(BgL_qz00_2841+((long)1)); }  else 
{ /* Llib/pgp_encode.scm 41 */
BgL_res2295z00_2840 = 
(BgL_qz00_2841-((long)1)); } } } 
BgL_octetzd2lenzd2_2839 = BgL_res2295z00_2840; } 
{ /* Llib/pgp_encode.scm 41 */
obj_t BgL_strz00_2856;
BgL_strz00_2856 = 
BGl_bignumzd2ze3binzd2strze3zz__openpgpzd2utilzd2(
((obj_t)BgL_arg1853z00_2837), BgL_octetzd2lenzd2_2839); 
{ /* Llib/pgp_encode.scm 42 */

bgl_display_obj(
BGl_fixnumzd2ze3scalarz31zz__openpgpzd2conversionzd2(BgL_bitzd2lenzd2_2838, ((long)2)), 
((obj_t)BgL_pz00_2612)); 
return 
bgl_display_obj(BgL_strz00_2856, 
((obj_t)BgL_pz00_2612));} } } } }  else 
{ /* Llib/pgp_encode.scm 393 */
if(
(BgL_casezd2valuezd2_2835==
CNST_TABLE_REF(((long)16))))
{ /* Llib/pgp_encode.scm 393 */
{ /* Llib/pgp_encode.scm 397 */
bool_t BgL_test2739z00_4430;
{ /* Llib/pgp_encode.scm 397 */
obj_t BgL_tmpz00_4431;
BgL_tmpz00_4431 = 
(((BgL_pgpzd2signaturezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2packetz00_bglt)
((BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt)BgL_packetz00_2611))))->BgL_signaturez00); 
BgL_test2739z00_4430 = 
PAIRP(BgL_tmpz00_4431); } 
if(BgL_test2739z00_4430)
{ /* Llib/pgp_encode.scm 397 */BFALSE; }  else 
{ /* Llib/pgp_encode.scm 398 */
obj_t BgL_arg1857z00_2857;
BgL_arg1857z00_2857 = 
(((BgL_pgpzd2signaturezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2packetz00_bglt)
((BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt)BgL_packetz00_2611))))->BgL_signaturez00); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)26)), BGl_string2489z00zz__openpgpzd2encodezd2, BgL_arg1857z00_2857); } } 
{ /* Llib/pgp_encode.scm 401 */
obj_t BgL_arg1859z00_2858;
{ /* Llib/pgp_encode.scm 401 */
obj_t BgL_pairz00_2859;
BgL_pairz00_2859 = 
(((BgL_pgpzd2signaturezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2packetz00_bglt)
((BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt)BgL_packetz00_2611))))->BgL_signaturez00); 
BgL_arg1859z00_2858 = 
CAR(BgL_pairz00_2859); } 
{ /* Llib/pgp_encode.scm 40 */
long BgL_bitzd2lenzd2_2860;
BgL_bitzd2lenzd2_2860 = 
BGl_bignumzd2bitzd2lengthz00zz__openpgpzd2utilzd2(
((obj_t)BgL_arg1859z00_2858)); 
{ /* Llib/pgp_encode.scm 40 */
long BgL_octetzd2lenzd2_2861;
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2310z00_2862;
{ /* Llib/pgp_encode.scm 41 */
long BgL_qz00_2863;long BgL_rz00_2864;
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2298z00_2865;
BgL_res2298z00_2865 = 
(BgL_bitzd2lenzd2_2860/((long)8)); 
BgL_qz00_2863 = BgL_res2298z00_2865; } 
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2304z00_2866;
{ /* Llib/pgp_encode.scm 41 */
long BgL_n1z00_2867;long BgL_n2z00_2868;
BgL_n1z00_2867 = BgL_bitzd2lenzd2_2860; 
BgL_n2z00_2868 = ((long)8); 
{ /* Llib/pgp_encode.scm 41 */
bool_t BgL_test2740z00_4448;
{ /* Llib/pgp_encode.scm 41 */
long BgL_arg1299z00_2869;
BgL_arg1299z00_2869 = 
(((BgL_n1z00_2867) | (BgL_n2z00_2868)) & -2147483648); 
BgL_test2740z00_4448 = 
(BgL_arg1299z00_2869==((long)0)); } 
if(BgL_test2740z00_4448)
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_arg1287z00_2870;
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_arg1293z00_2871;int32_t BgL_arg1294z00_2872;
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_res2300z00_2873;
BgL_res2300z00_2873 = 
(int32_t)(BgL_n1z00_2867); 
BgL_arg1293z00_2871 = BgL_res2300z00_2873; } 
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_res2301z00_2874;
BgL_res2301z00_2874 = 
(int32_t)(BgL_n2z00_2868); 
BgL_arg1294z00_2872 = BgL_res2301z00_2874; } 
BgL_arg1287z00_2870 = 
(BgL_arg1293z00_2871%BgL_arg1294z00_2872); } 
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2303z00_2875;
{ /* Llib/pgp_encode.scm 41 */
long BgL_arg1421z00_2876;
BgL_arg1421z00_2876 = 
(long)(BgL_arg1287z00_2870); 
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2302z00_2877;
BgL_res2302z00_2877 = 
(long)(BgL_arg1421z00_2876); 
BgL_res2303z00_2875 = BgL_res2302z00_2877; } } 
BgL_res2304z00_2866 = BgL_res2303z00_2875; } }  else 
{ /* Llib/pgp_encode.scm 41 */
BgL_res2304z00_2866 = 
(BgL_n1z00_2867%BgL_n2z00_2868); } } } 
BgL_rz00_2864 = BgL_res2304z00_2866; } 
if(
(BgL_rz00_2864==((long)0)))
{ /* Llib/pgp_encode.scm 41 */
BgL_res2310z00_2862 = BgL_qz00_2863; }  else 
{ /* Llib/pgp_encode.scm 41 */
if(
(BgL_rz00_2864>((long)0)))
{ /* Llib/pgp_encode.scm 41 */
BgL_res2310z00_2862 = 
(BgL_qz00_2863+((long)1)); }  else 
{ /* Llib/pgp_encode.scm 41 */
BgL_res2310z00_2862 = 
(BgL_qz00_2863-((long)1)); } } } 
BgL_octetzd2lenzd2_2861 = BgL_res2310z00_2862; } 
{ /* Llib/pgp_encode.scm 41 */
obj_t BgL_strz00_2878;
BgL_strz00_2878 = 
BGl_bignumzd2ze3binzd2strze3zz__openpgpzd2utilzd2(
((obj_t)BgL_arg1859z00_2858), BgL_octetzd2lenzd2_2861); 
{ /* Llib/pgp_encode.scm 42 */

bgl_display_obj(
BGl_fixnumzd2ze3scalarz31zz__openpgpzd2conversionzd2(BgL_bitzd2lenzd2_2860, ((long)2)), 
((obj_t)BgL_pz00_2612)); 
bgl_display_obj(BgL_strz00_2878, 
((obj_t)BgL_pz00_2612)); } } } } } 
{ /* Llib/pgp_encode.scm 402 */
obj_t BgL_arg1861z00_2879;
{ /* Llib/pgp_encode.scm 402 */
obj_t BgL_pairz00_2880;
BgL_pairz00_2880 = 
(((BgL_pgpzd2signaturezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2packetz00_bglt)
((BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt)BgL_packetz00_2611))))->BgL_signaturez00); 
BgL_arg1861z00_2879 = 
CDR(BgL_pairz00_2880); } 
{ /* Llib/pgp_encode.scm 40 */
long BgL_bitzd2lenzd2_2881;
BgL_bitzd2lenzd2_2881 = 
BGl_bignumzd2bitzd2lengthz00zz__openpgpzd2utilzd2(
((obj_t)BgL_arg1861z00_2879)); 
{ /* Llib/pgp_encode.scm 40 */
long BgL_octetzd2lenzd2_2882;
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2323z00_2883;
{ /* Llib/pgp_encode.scm 41 */
long BgL_qz00_2884;long BgL_rz00_2885;
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2311z00_2886;
BgL_res2311z00_2886 = 
(BgL_bitzd2lenzd2_2881/((long)8)); 
BgL_qz00_2884 = BgL_res2311z00_2886; } 
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2317z00_2887;
{ /* Llib/pgp_encode.scm 41 */
long BgL_n1z00_2888;long BgL_n2z00_2889;
BgL_n1z00_2888 = BgL_bitzd2lenzd2_2881; 
BgL_n2z00_2889 = ((long)8); 
{ /* Llib/pgp_encode.scm 41 */
bool_t BgL_test2743z00_4477;
{ /* Llib/pgp_encode.scm 41 */
long BgL_arg1299z00_2890;
BgL_arg1299z00_2890 = 
(((BgL_n1z00_2888) | (BgL_n2z00_2889)) & -2147483648); 
BgL_test2743z00_4477 = 
(BgL_arg1299z00_2890==((long)0)); } 
if(BgL_test2743z00_4477)
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_arg1287z00_2891;
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_arg1293z00_2892;int32_t BgL_arg1294z00_2893;
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_res2313z00_2894;
BgL_res2313z00_2894 = 
(int32_t)(BgL_n1z00_2888); 
BgL_arg1293z00_2892 = BgL_res2313z00_2894; } 
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_res2314z00_2895;
BgL_res2314z00_2895 = 
(int32_t)(BgL_n2z00_2889); 
BgL_arg1294z00_2893 = BgL_res2314z00_2895; } 
BgL_arg1287z00_2891 = 
(BgL_arg1293z00_2892%BgL_arg1294z00_2893); } 
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2316z00_2896;
{ /* Llib/pgp_encode.scm 41 */
long BgL_arg1421z00_2897;
BgL_arg1421z00_2897 = 
(long)(BgL_arg1287z00_2891); 
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2315z00_2898;
BgL_res2315z00_2898 = 
(long)(BgL_arg1421z00_2897); 
BgL_res2316z00_2896 = BgL_res2315z00_2898; } } 
BgL_res2317z00_2887 = BgL_res2316z00_2896; } }  else 
{ /* Llib/pgp_encode.scm 41 */
BgL_res2317z00_2887 = 
(BgL_n1z00_2888%BgL_n2z00_2889); } } } 
BgL_rz00_2885 = BgL_res2317z00_2887; } 
if(
(BgL_rz00_2885==((long)0)))
{ /* Llib/pgp_encode.scm 41 */
BgL_res2323z00_2883 = BgL_qz00_2884; }  else 
{ /* Llib/pgp_encode.scm 41 */
if(
(BgL_rz00_2885>((long)0)))
{ /* Llib/pgp_encode.scm 41 */
BgL_res2323z00_2883 = 
(BgL_qz00_2884+((long)1)); }  else 
{ /* Llib/pgp_encode.scm 41 */
BgL_res2323z00_2883 = 
(BgL_qz00_2884-((long)1)); } } } 
BgL_octetzd2lenzd2_2882 = BgL_res2323z00_2883; } 
{ /* Llib/pgp_encode.scm 41 */
obj_t BgL_strz00_2899;
BgL_strz00_2899 = 
BGl_bignumzd2ze3binzd2strze3zz__openpgpzd2utilzd2(
((obj_t)BgL_arg1861z00_2879), BgL_octetzd2lenzd2_2882); 
{ /* Llib/pgp_encode.scm 42 */

bgl_display_obj(
BGl_fixnumzd2ze3scalarz31zz__openpgpzd2conversionzd2(BgL_bitzd2lenzd2_2881, ((long)2)), 
((obj_t)BgL_pz00_2612)); 
return 
bgl_display_obj(BgL_strz00_2899, 
((obj_t)BgL_pz00_2612));} } } } } }  else 
{ /* Llib/pgp_encode.scm 406 */
obj_t BgL_arg1863z00_2900;
{ /* Llib/pgp_encode.scm 406 */
obj_t BgL_arg1864z00_2901;obj_t BgL_arg1865z00_2902;
BgL_arg1864z00_2901 = 
(((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt)BgL_packetz00_2611))))->BgL_publiczd2keyzd2algoz00); 
{ /* Llib/pgp_encode.scm 407 */
obj_t BgL_arg1866z00_2903;
BgL_arg1866z00_2903 = 
(((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt)BgL_packetz00_2611))))->BgL_publiczd2keyzd2algoz00); 
BgL_arg1865z00_2902 = 
BGl_publiczd2keyzd2algozd2ze3humanzd2readableze3zz__openpgpzd2humanzd2(BgL_arg1866z00_2903); } 
BgL_arg1863z00_2900 = 
MAKE_YOUNG_PAIR(BgL_arg1864z00_2901, BgL_arg1865z00_2902); } 
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)26)), BGl_string2490z00zz__openpgpzd2encodezd2, BgL_arg1863z00_2900);} } } } } 

}



/* &encode-sub-packet-co1238 */
obj_t BGl_z62encodezd2subzd2packetzd2co1238zb0zz__openpgpzd2encodezd2(obj_t BgL_envz00_2613, obj_t BgL_spz00_2614, obj_t BgL_pz00_2615)
{
{ /* Llib/pgp_encode.scm 275 */
{ /* Llib/pgp_encode.scm 278 */
bool_t BgL_arg1842z00_2906;
BgL_arg1842z00_2906 = 
(((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)
((BgL_pgpzd2signaturezd2subzd2revocationzd2reasonz00_bglt)BgL_spz00_2614))))->BgL_criticalzf3zf3); 
{ /* Llib/pgp_encode.scm 278 */
obj_t BgL_typez00_2907;
BgL_typez00_2907 = 
CNST_TABLE_REF(((long)27)); 
if(BgL_arg1842z00_2906)
{ /* Llib/pgp_encode.scm 177 */
long BgL_arg1518z00_2908;
{ /* Llib/pgp_encode.scm 177 */
char BgL_arg1524z00_2909;
BgL_arg1524z00_2909 = 
BGl_subpacketzd2typezd2ze3byteze3zz__openpgpzd2enumszd2(BgL_typez00_2907); 
BgL_arg1518z00_2908 = 
(
(long)(BgL_arg1524z00_2909)+((long)128)); } 
BGl_encodezd2octetzd2zz__openpgpzd2encodezd2(BgL_arg1518z00_2908, 
((obj_t)BgL_pz00_2615)); }  else 
{ /* Llib/pgp_encode.scm 178 */
char BgL_arg1525z00_2910;
BgL_arg1525z00_2910 = 
BGl_subpacketzd2typezd2ze3byteze3zz__openpgpzd2enumszd2(BgL_typez00_2907); 
BGl_encodezd2octetzd2zz__openpgpzd2encodezd2(
(long)(BgL_arg1525z00_2910), 
((obj_t)BgL_pz00_2615)); } } } 
{ /* Llib/pgp_encode.scm 279 */
char BgL_arg1843z00_2911;
BgL_arg1843z00_2911 = 
BGl_revocationzd2codezd2ze3byteze3zz__openpgpzd2enumszd2(
(((BgL_pgpzd2signaturezd2subzd2revocationzd2reasonz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2revocationzd2reasonz00_bglt)BgL_spz00_2614)))->BgL_codez00)); 
{ /* Llib/pgp_encode.scm 279 */
long BgL_nz00_2912;
BgL_nz00_2912 = 
(long)(BgL_arg1843z00_2911); 
if(
(BgL_nz00_2912>=((long)256)))
{ /* Llib/pgp_encode.scm 22 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2399z00zz__openpgpzd2encodezd2, 
BINT(BgL_nz00_2912)); }  else 
{ /* Llib/pgp_encode.scm 22 */BFALSE; } 
{ /* Llib/pgp_encode.scm 26 */
unsigned char BgL_arg1300z00_2913;
BgL_arg1300z00_2913 = 
(BgL_nz00_2912); 
bgl_display_obj(
BCHAR(BgL_arg1300z00_2913), 
((obj_t)BgL_pz00_2615)); } } } 
return 
bgl_display_obj(
(((BgL_pgpzd2signaturezd2subzd2revocationzd2reasonz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2revocationzd2reasonz00_bglt)BgL_spz00_2614)))->BgL_reasonz00), 
((obj_t)BgL_pz00_2615));} 

}



/* &encode-sub-packet-co1236 */
obj_t BGl_z62encodezd2subzd2packetzd2co1236zb0zz__openpgpzd2encodezd2(obj_t BgL_envz00_2616, obj_t BgL_spz00_2617, obj_t BgL_pz00_2618)
{
{ /* Llib/pgp_encode.scm 270 */
{ /* Llib/pgp_encode.scm 273 */
bool_t BgL_arg1840z00_2916;
BgL_arg1840z00_2916 = 
(((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)
((BgL_pgpzd2signaturezd2subzd2signerzd2idz00_bglt)BgL_spz00_2617))))->BgL_criticalzf3zf3); 
{ /* Llib/pgp_encode.scm 273 */
obj_t BgL_typez00_2917;
BgL_typez00_2917 = 
CNST_TABLE_REF(((long)28)); 
if(BgL_arg1840z00_2916)
{ /* Llib/pgp_encode.scm 177 */
long BgL_arg1518z00_2918;
{ /* Llib/pgp_encode.scm 177 */
char BgL_arg1524z00_2919;
BgL_arg1524z00_2919 = 
BGl_subpacketzd2typezd2ze3byteze3zz__openpgpzd2enumszd2(BgL_typez00_2917); 
BgL_arg1518z00_2918 = 
(
(long)(BgL_arg1524z00_2919)+((long)128)); } 
BGl_encodezd2octetzd2zz__openpgpzd2encodezd2(BgL_arg1518z00_2918, 
((obj_t)BgL_pz00_2618)); }  else 
{ /* Llib/pgp_encode.scm 178 */
char BgL_arg1525z00_2920;
BgL_arg1525z00_2920 = 
BGl_subpacketzd2typezd2ze3byteze3zz__openpgpzd2enumszd2(BgL_typez00_2917); 
BGl_encodezd2octetzd2zz__openpgpzd2encodezd2(
(long)(BgL_arg1525z00_2920), 
((obj_t)BgL_pz00_2618)); } } } 
return 
bgl_display_obj(
(((BgL_pgpzd2signaturezd2subzd2signerzd2idz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2signerzd2idz00_bglt)BgL_spz00_2617)))->BgL_idz00), 
((obj_t)BgL_pz00_2618));} 

}



/* &encode-sub-packet-co1234 */
obj_t BGl_z62encodezd2subzd2packetzd2co1234zb0zz__openpgpzd2encodezd2(obj_t BgL_envz00_2619, obj_t BgL_spz00_2620, obj_t BgL_pz00_2621)
{
{ /* Llib/pgp_encode.scm 265 */
{ /* Llib/pgp_encode.scm 268 */
bool_t BgL_arg1838z00_2923;
BgL_arg1838z00_2923 = 
(((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)
((BgL_pgpzd2signaturezd2subzd2policyzd2_bglt)BgL_spz00_2620))))->BgL_criticalzf3zf3); 
{ /* Llib/pgp_encode.scm 268 */
obj_t BgL_typez00_2924;
BgL_typez00_2924 = 
CNST_TABLE_REF(((long)29)); 
if(BgL_arg1838z00_2923)
{ /* Llib/pgp_encode.scm 177 */
long BgL_arg1518z00_2925;
{ /* Llib/pgp_encode.scm 177 */
char BgL_arg1524z00_2926;
BgL_arg1524z00_2926 = 
BGl_subpacketzd2typezd2ze3byteze3zz__openpgpzd2enumszd2(BgL_typez00_2924); 
BgL_arg1518z00_2925 = 
(
(long)(BgL_arg1524z00_2926)+((long)128)); } 
BGl_encodezd2octetzd2zz__openpgpzd2encodezd2(BgL_arg1518z00_2925, 
((obj_t)BgL_pz00_2621)); }  else 
{ /* Llib/pgp_encode.scm 178 */
char BgL_arg1525z00_2927;
BgL_arg1525z00_2927 = 
BGl_subpacketzd2typezd2ze3byteze3zz__openpgpzd2enumszd2(BgL_typez00_2924); 
BGl_encodezd2octetzd2zz__openpgpzd2encodezd2(
(long)(BgL_arg1525z00_2927), 
((obj_t)BgL_pz00_2621)); } } } 
return 
bgl_display_obj(
(((BgL_pgpzd2signaturezd2subzd2policyzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2policyzd2_bglt)BgL_spz00_2620)))->BgL_urlz00), 
((obj_t)BgL_pz00_2621));} 

}



/* &encode-sub-packet-co1232 */
obj_t BGl_z62encodezd2subzd2packetzd2co1232zb0zz__openpgpzd2encodezd2(obj_t BgL_envz00_2622, obj_t BgL_spz00_2623, obj_t BgL_pz00_2624)
{
{ /* Llib/pgp_encode.scm 260 */
{ /* Llib/pgp_encode.scm 263 */
bool_t BgL_arg1835z00_2930;
BgL_arg1835z00_2930 = 
(((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)
((BgL_pgpzd2signaturezd2subzd2primaryzd2idz00_bglt)BgL_spz00_2623))))->BgL_criticalzf3zf3); 
{ /* Llib/pgp_encode.scm 263 */
obj_t BgL_typez00_2931;
BgL_typez00_2931 = 
CNST_TABLE_REF(((long)30)); 
if(BgL_arg1835z00_2930)
{ /* Llib/pgp_encode.scm 177 */
long BgL_arg1518z00_2932;
{ /* Llib/pgp_encode.scm 177 */
char BgL_arg1524z00_2933;
BgL_arg1524z00_2933 = 
BGl_subpacketzd2typezd2ze3byteze3zz__openpgpzd2enumszd2(BgL_typez00_2931); 
BgL_arg1518z00_2932 = 
(
(long)(BgL_arg1524z00_2933)+((long)128)); } 
BGl_encodezd2octetzd2zz__openpgpzd2encodezd2(BgL_arg1518z00_2932, 
((obj_t)BgL_pz00_2624)); }  else 
{ /* Llib/pgp_encode.scm 178 */
char BgL_arg1525z00_2934;
BgL_arg1525z00_2934 = 
BGl_subpacketzd2typezd2ze3byteze3zz__openpgpzd2enumszd2(BgL_typez00_2931); 
BGl_encodezd2octetzd2zz__openpgpzd2encodezd2(
(long)(BgL_arg1525z00_2934), 
((obj_t)BgL_pz00_2624)); } } } 
{ /* Llib/pgp_encode.scm 264 */
long BgL_arg1836z00_2935;
if(
(((BgL_pgpzd2signaturezd2subzd2primaryzd2idz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2primaryzd2idz00_bglt)BgL_spz00_2623)))->BgL_primaryzf3zf3))
{ /* Llib/pgp_encode.scm 264 */
BgL_arg1836z00_2935 = ((long)1); }  else 
{ /* Llib/pgp_encode.scm 264 */
BgL_arg1836z00_2935 = ((long)0); } 
if(
(BgL_arg1836z00_2935>=((long)256)))
{ /* Llib/pgp_encode.scm 22 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2399z00zz__openpgpzd2encodezd2, 
BINT(BgL_arg1836z00_2935)); }  else 
{ /* Llib/pgp_encode.scm 22 */BFALSE; } 
{ /* Llib/pgp_encode.scm 26 */
unsigned char BgL_arg1300z00_2936;
BgL_arg1300z00_2936 = 
(BgL_arg1836z00_2935); 
return 
bgl_display_obj(
BCHAR(BgL_arg1300z00_2936), 
((obj_t)BgL_pz00_2624));} } } 

}



/* &encode-sub-packet-co1230 */
obj_t BGl_z62encodezd2subzd2packetzd2co1230zb0zz__openpgpzd2encodezd2(obj_t BgL_envz00_2625, obj_t BgL_spz00_2626, obj_t BgL_pz00_2627)
{
{ /* Llib/pgp_encode.scm 255 */
{ /* Llib/pgp_encode.scm 258 */
bool_t BgL_arg1833z00_2939;
BgL_arg1833z00_2939 = 
(((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)
((BgL_pgpzd2signaturezd2subzd2preferredzd2keyzd2serverzd2_bglt)BgL_spz00_2626))))->BgL_criticalzf3zf3); 
{ /* Llib/pgp_encode.scm 258 */
obj_t BgL_typez00_2940;
BgL_typez00_2940 = 
CNST_TABLE_REF(((long)31)); 
if(BgL_arg1833z00_2939)
{ /* Llib/pgp_encode.scm 177 */
long BgL_arg1518z00_2941;
{ /* Llib/pgp_encode.scm 177 */
char BgL_arg1524z00_2942;
BgL_arg1524z00_2942 = 
BGl_subpacketzd2typezd2ze3byteze3zz__openpgpzd2enumszd2(BgL_typez00_2940); 
BgL_arg1518z00_2941 = 
(
(long)(BgL_arg1524z00_2942)+((long)128)); } 
BGl_encodezd2octetzd2zz__openpgpzd2encodezd2(BgL_arg1518z00_2941, 
((obj_t)BgL_pz00_2627)); }  else 
{ /* Llib/pgp_encode.scm 178 */
char BgL_arg1525z00_2943;
BgL_arg1525z00_2943 = 
BGl_subpacketzd2typezd2ze3byteze3zz__openpgpzd2enumszd2(BgL_typez00_2940); 
BGl_encodezd2octetzd2zz__openpgpzd2encodezd2(
(long)(BgL_arg1525z00_2943), 
((obj_t)BgL_pz00_2627)); } } } 
return 
bgl_display_obj(
(((BgL_pgpzd2signaturezd2subzd2preferredzd2keyzd2serverzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2preferredzd2keyzd2serverzd2_bglt)BgL_spz00_2626)))->BgL_serverz00), 
((obj_t)BgL_pz00_2627));} 

}



/* &encode-sub-packet-co1228 */
obj_t BGl_z62encodezd2subzd2packetzd2co1228zb0zz__openpgpzd2encodezd2(obj_t BgL_envz00_2628, obj_t BgL_spz00_2629, obj_t BgL_pz00_2630)
{
{ /* Llib/pgp_encode.scm 250 */
{ /* Llib/pgp_encode.scm 252 */
bool_t BgL_tmpz00_4620;
{ /* Llib/pgp_encode.scm 253 */
bool_t BgL_arg1831z00_2946;
BgL_arg1831z00_2946 = 
(((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)
((BgL_pgpzd2signaturezd2subzd2preferredzd2compressionz00_bglt)BgL_spz00_2629))))->BgL_criticalzf3zf3); 
{ /* Llib/pgp_encode.scm 253 */
obj_t BgL_typez00_2947;
BgL_typez00_2947 = 
CNST_TABLE_REF(((long)32)); 
if(BgL_arg1831z00_2946)
{ /* Llib/pgp_encode.scm 177 */
long BgL_arg1518z00_2948;
{ /* Llib/pgp_encode.scm 177 */
char BgL_arg1524z00_2949;
BgL_arg1524z00_2949 = 
BGl_subpacketzd2typezd2ze3byteze3zz__openpgpzd2enumszd2(BgL_typez00_2947); 
BgL_arg1518z00_2948 = 
(
(long)(BgL_arg1524z00_2949)+((long)128)); } 
BGl_encodezd2octetzd2zz__openpgpzd2encodezd2(BgL_arg1518z00_2948, 
((obj_t)BgL_pz00_2630)); }  else 
{ /* Llib/pgp_encode.scm 178 */
char BgL_arg1525z00_2950;
BgL_arg1525z00_2950 = 
BGl_subpacketzd2typezd2ze3byteze3zz__openpgpzd2enumszd2(BgL_typez00_2947); 
BGl_encodezd2octetzd2zz__openpgpzd2encodezd2(
(long)(BgL_arg1525z00_2950), 
((obj_t)BgL_pz00_2630)); } } } 
BgL_tmpz00_4620 = 
BGl_encodezd2prefszd2zz__openpgpzd2encodezd2(
(((BgL_pgpzd2signaturezd2subzd2preferredzd2compressionz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2preferredzd2compressionz00_bglt)BgL_spz00_2629)))->BgL_algosz00), BGl_compressionzd2algozd2ze3bytezd2envz31zz__openpgpzd2enumszd2, 
((obj_t)BgL_pz00_2630)); 
return 
BBOOL(BgL_tmpz00_4620);} } 

}



/* &encode-sub-packet-co1226 */
obj_t BGl_z62encodezd2subzd2packetzd2co1226zb0zz__openpgpzd2encodezd2(obj_t BgL_envz00_2631, obj_t BgL_spz00_2632, obj_t BgL_pz00_2633)
{
{ /* Llib/pgp_encode.scm 245 */
{ /* Llib/pgp_encode.scm 247 */
bool_t BgL_tmpz00_4640;
{ /* Llib/pgp_encode.scm 248 */
bool_t BgL_arg1829z00_2953;
BgL_arg1829z00_2953 = 
(((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)
((BgL_pgpzd2signaturezd2subzd2preferredzd2hashz00_bglt)BgL_spz00_2632))))->BgL_criticalzf3zf3); 
{ /* Llib/pgp_encode.scm 248 */
obj_t BgL_typez00_2954;
BgL_typez00_2954 = 
CNST_TABLE_REF(((long)33)); 
if(BgL_arg1829z00_2953)
{ /* Llib/pgp_encode.scm 177 */
long BgL_arg1518z00_2955;
{ /* Llib/pgp_encode.scm 177 */
char BgL_arg1524z00_2956;
BgL_arg1524z00_2956 = 
BGl_subpacketzd2typezd2ze3byteze3zz__openpgpzd2enumszd2(BgL_typez00_2954); 
BgL_arg1518z00_2955 = 
(
(long)(BgL_arg1524z00_2956)+((long)128)); } 
BGl_encodezd2octetzd2zz__openpgpzd2encodezd2(BgL_arg1518z00_2955, 
((obj_t)BgL_pz00_2633)); }  else 
{ /* Llib/pgp_encode.scm 178 */
char BgL_arg1525z00_2957;
BgL_arg1525z00_2957 = 
BGl_subpacketzd2typezd2ze3byteze3zz__openpgpzd2enumszd2(BgL_typez00_2954); 
BGl_encodezd2octetzd2zz__openpgpzd2encodezd2(
(long)(BgL_arg1525z00_2957), 
((obj_t)BgL_pz00_2633)); } } } 
BgL_tmpz00_4640 = 
BGl_encodezd2prefszd2zz__openpgpzd2encodezd2(
(((BgL_pgpzd2signaturezd2subzd2preferredzd2hashz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2preferredzd2hashz00_bglt)BgL_spz00_2632)))->BgL_algosz00), BGl_hashzd2algozd2ze3bytezd2envz31zz__openpgpzd2enumszd2, 
((obj_t)BgL_pz00_2633)); 
return 
BBOOL(BgL_tmpz00_4640);} } 

}



/* &encode-sub-packet-co1224 */
obj_t BGl_z62encodezd2subzd2packetzd2co1224zb0zz__openpgpzd2encodezd2(obj_t BgL_envz00_2634, obj_t BgL_spz00_2635, obj_t BgL_pz00_2636)
{
{ /* Llib/pgp_encode.scm 236 */
{ /* Llib/pgp_encode.scm 239 */
bool_t BgL_arg1821z00_2960;
BgL_arg1821z00_2960 = 
(((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)
((BgL_pgpzd2signaturezd2subzd2notationzd2_bglt)BgL_spz00_2635))))->BgL_criticalzf3zf3); 
{ /* Llib/pgp_encode.scm 239 */
obj_t BgL_typez00_2961;
BgL_typez00_2961 = 
CNST_TABLE_REF(((long)34)); 
if(BgL_arg1821z00_2960)
{ /* Llib/pgp_encode.scm 177 */
long BgL_arg1518z00_2962;
{ /* Llib/pgp_encode.scm 177 */
char BgL_arg1524z00_2963;
BgL_arg1524z00_2963 = 
BGl_subpacketzd2typezd2ze3byteze3zz__openpgpzd2enumszd2(BgL_typez00_2961); 
BgL_arg1518z00_2962 = 
(
(long)(BgL_arg1524z00_2963)+((long)128)); } 
BGl_encodezd2octetzd2zz__openpgpzd2encodezd2(BgL_arg1518z00_2962, 
((obj_t)BgL_pz00_2636)); }  else 
{ /* Llib/pgp_encode.scm 178 */
char BgL_arg1525z00_2964;
BgL_arg1525z00_2964 = 
BGl_subpacketzd2typezd2ze3byteze3zz__openpgpzd2enumszd2(BgL_typez00_2961); 
BGl_encodezd2octetzd2zz__openpgpzd2encodezd2(
(long)(BgL_arg1525z00_2964), 
((obj_t)BgL_pz00_2636)); } } } 
{ /* Llib/pgp_encode.scm 240 */
obj_t BgL_arg1822z00_2965;
BgL_arg1822z00_2965 = 
(((BgL_pgpzd2signaturezd2subzd2notationzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2notationzd2_bglt)BgL_spz00_2635)))->BgL_flagsz00); 
if(
(
STRING_LENGTH(BgL_arg1822z00_2965)==((long)4)))
{ /* Llib/pgp_encode.scm 28 */BFALSE; }  else 
{ /* Llib/pgp_encode.scm 31 */
obj_t BgL_arg1330z00_2966;
BgL_arg1330z00_2966 = 
MAKE_YOUNG_PAIR(
BINT(((long)4)), BgL_arg1822z00_2965); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)8)), BGl_string2412z00zz__openpgpzd2encodezd2, BgL_arg1330z00_2966); } 
bgl_display_obj(BgL_arg1822z00_2965, 
((obj_t)BgL_pz00_2636)); } 
{ /* Llib/pgp_encode.scm 241 */
long BgL_arg1823z00_2967;
BgL_arg1823z00_2967 = 
STRING_LENGTH(
(((BgL_pgpzd2signaturezd2subzd2notationzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2notationzd2_bglt)BgL_spz00_2635)))->BgL_namez00)); 
bgl_display_obj(
BGl_fixnumzd2ze3scalarz31zz__openpgpzd2conversionzd2(BgL_arg1823z00_2967, ((long)2)), 
((obj_t)BgL_pz00_2636)); } 
{ /* Llib/pgp_encode.scm 242 */
long BgL_arg1825z00_2968;
BgL_arg1825z00_2968 = 
STRING_LENGTH(
(((BgL_pgpzd2signaturezd2subzd2notationzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2notationzd2_bglt)BgL_spz00_2635)))->BgL_valuez00)); 
bgl_display_obj(
BGl_fixnumzd2ze3scalarz31zz__openpgpzd2conversionzd2(BgL_arg1825z00_2968, ((long)2)), 
((obj_t)BgL_pz00_2636)); } 
bgl_display_obj(
(((BgL_pgpzd2signaturezd2subzd2notationzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2notationzd2_bglt)BgL_spz00_2635)))->BgL_namez00), 
((obj_t)BgL_pz00_2636)); 
return 
bgl_display_obj(
(((BgL_pgpzd2signaturezd2subzd2notationzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2notationzd2_bglt)BgL_spz00_2635)))->BgL_valuez00), 
((obj_t)BgL_pz00_2636));} 

}



/* &encode-sub-packet-co1222 */
obj_t BGl_z62encodezd2subzd2packetzd2co1222zb0zz__openpgpzd2encodezd2(obj_t BgL_envz00_2637, obj_t BgL_spz00_2638, obj_t BgL_pz00_2639)
{
{ /* Llib/pgp_encode.scm 231 */
{ /* Llib/pgp_encode.scm 234 */
bool_t BgL_arg1819z00_2971;
BgL_arg1819z00_2971 = 
(((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)
((BgL_pgpzd2signaturezd2subzd2idzd2_bglt)BgL_spz00_2638))))->BgL_criticalzf3zf3); 
{ /* Llib/pgp_encode.scm 234 */
obj_t BgL_typez00_2972;
BgL_typez00_2972 = 
CNST_TABLE_REF(((long)35)); 
if(BgL_arg1819z00_2971)
{ /* Llib/pgp_encode.scm 177 */
long BgL_arg1518z00_2973;
{ /* Llib/pgp_encode.scm 177 */
char BgL_arg1524z00_2974;
BgL_arg1524z00_2974 = 
BGl_subpacketzd2typezd2ze3byteze3zz__openpgpzd2enumszd2(BgL_typez00_2972); 
BgL_arg1518z00_2973 = 
(
(long)(BgL_arg1524z00_2974)+((long)128)); } 
BGl_encodezd2octetzd2zz__openpgpzd2encodezd2(BgL_arg1518z00_2973, 
((obj_t)BgL_pz00_2639)); }  else 
{ /* Llib/pgp_encode.scm 178 */
char BgL_arg1525z00_2975;
BgL_arg1525z00_2975 = 
BGl_subpacketzd2typezd2ze3byteze3zz__openpgpzd2enumszd2(BgL_typez00_2972); 
BGl_encodezd2octetzd2zz__openpgpzd2encodezd2(
(long)(BgL_arg1525z00_2975), 
((obj_t)BgL_pz00_2639)); } } } 
{ /* Llib/pgp_encode.scm 235 */
obj_t BgL_arg1820z00_2976;
BgL_arg1820z00_2976 = 
(((BgL_pgpzd2signaturezd2subzd2idzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2idzd2_bglt)BgL_spz00_2638)))->BgL_keyzd2idzd2); 
if(
(
STRING_LENGTH(BgL_arg1820z00_2976)==((long)8)))
{ /* Llib/pgp_encode.scm 28 */BFALSE; }  else 
{ /* Llib/pgp_encode.scm 31 */
obj_t BgL_arg1330z00_2977;
BgL_arg1330z00_2977 = 
MAKE_YOUNG_PAIR(
BINT(((long)8)), BgL_arg1820z00_2976); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)8)), BGl_string2412z00zz__openpgpzd2encodezd2, BgL_arg1330z00_2977); } 
return 
bgl_display_obj(BgL_arg1820z00_2976, 
((obj_t)BgL_pz00_2639));} } 

}



/* &encode-sub-packet-co1220 */
obj_t BGl_z62encodezd2subzd2packetzd2co1220zb0zz__openpgpzd2encodezd2(obj_t BgL_envz00_2640, obj_t BgL_spz00_2641, obj_t BgL_pz00_2642)
{
{ /* Llib/pgp_encode.scm 223 */
{ /* Llib/pgp_encode.scm 227 */
bool_t BgL_arg1815z00_2980;
BgL_arg1815z00_2980 = 
(((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)
((BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt)BgL_spz00_2641))))->BgL_criticalzf3zf3); 
{ /* Llib/pgp_encode.scm 227 */
obj_t BgL_typez00_2981;
BgL_typez00_2981 = 
CNST_TABLE_REF(((long)36)); 
if(BgL_arg1815z00_2980)
{ /* Llib/pgp_encode.scm 177 */
long BgL_arg1518z00_2982;
{ /* Llib/pgp_encode.scm 177 */
char BgL_arg1524z00_2983;
BgL_arg1524z00_2983 = 
BGl_subpacketzd2typezd2ze3byteze3zz__openpgpzd2enumszd2(BgL_typez00_2981); 
BgL_arg1518z00_2982 = 
(
(long)(BgL_arg1524z00_2983)+((long)128)); } 
BGl_encodezd2octetzd2zz__openpgpzd2encodezd2(BgL_arg1518z00_2982, 
((obj_t)BgL_pz00_2642)); }  else 
{ /* Llib/pgp_encode.scm 178 */
char BgL_arg1525z00_2984;
BgL_arg1525z00_2984 = 
BGl_subpacketzd2typezd2ze3byteze3zz__openpgpzd2enumszd2(BgL_typez00_2981); 
BGl_encodezd2octetzd2zz__openpgpzd2encodezd2(
(long)(BgL_arg1525z00_2984), 
((obj_t)BgL_pz00_2642)); } } } 
{ /* Llib/pgp_encode.scm 228 */
char BgL_arg1816z00_2985;
BgL_arg1816z00_2985 = 
(((BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt)BgL_spz00_2641)))->BgL_claza7za7z00); 
{ /* Llib/pgp_encode.scm 228 */
long BgL_nz00_2986;
BgL_nz00_2986 = 
(long)(BgL_arg1816z00_2985); 
if(
(BgL_nz00_2986>=((long)256)))
{ /* Llib/pgp_encode.scm 22 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2399z00zz__openpgpzd2encodezd2, 
BINT(BgL_nz00_2986)); }  else 
{ /* Llib/pgp_encode.scm 22 */BFALSE; } 
{ /* Llib/pgp_encode.scm 26 */
unsigned char BgL_arg1300z00_2987;
BgL_arg1300z00_2987 = 
(BgL_nz00_2986); 
bgl_display_obj(
BCHAR(BgL_arg1300z00_2987), 
((obj_t)BgL_pz00_2642)); } } } 
{ /* Llib/pgp_encode.scm 229 */
char BgL_arg1817z00_2988;
BgL_arg1817z00_2988 = 
(((BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt)BgL_spz00_2641)))->BgL_algidz00); 
{ /* Llib/pgp_encode.scm 229 */
long BgL_nz00_2989;
BgL_nz00_2989 = 
(long)(BgL_arg1817z00_2988); 
if(
(BgL_nz00_2989>=((long)256)))
{ /* Llib/pgp_encode.scm 22 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2399z00zz__openpgpzd2encodezd2, 
BINT(BgL_nz00_2989)); }  else 
{ /* Llib/pgp_encode.scm 22 */BFALSE; } 
{ /* Llib/pgp_encode.scm 26 */
unsigned char BgL_arg1300z00_2990;
BgL_arg1300z00_2990 = 
(BgL_nz00_2989); 
bgl_display_obj(
BCHAR(BgL_arg1300z00_2990), 
((obj_t)BgL_pz00_2642)); } } } 
{ /* Llib/pgp_encode.scm 230 */
obj_t BgL_arg1818z00_2991;
BgL_arg1818z00_2991 = 
(((BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt)BgL_spz00_2641)))->BgL_fingerprintz00); 
if(
(
STRING_LENGTH(BgL_arg1818z00_2991)==((long)20)))
{ /* Llib/pgp_encode.scm 28 */BFALSE; }  else 
{ /* Llib/pgp_encode.scm 31 */
obj_t BgL_arg1330z00_2992;
BgL_arg1330z00_2992 = 
MAKE_YOUNG_PAIR(
BINT(((long)20)), BgL_arg1818z00_2991); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)8)), BGl_string2412z00zz__openpgpzd2encodezd2, BgL_arg1330z00_2992); } 
return 
bgl_display_obj(BgL_arg1818z00_2991, 
((obj_t)BgL_pz00_2642));} } 

}



/* &encode-sub-packet-co1218 */
obj_t BGl_z62encodezd2subzd2packetzd2co1218zb0zz__openpgpzd2encodezd2(obj_t BgL_envz00_2643, obj_t BgL_spz00_2644, obj_t BgL_pz00_2645)
{
{ /* Llib/pgp_encode.scm 218 */
{ /* Llib/pgp_encode.scm 220 */
bool_t BgL_tmpz00_4779;
{ /* Llib/pgp_encode.scm 221 */
bool_t BgL_arg1813z00_2995;
BgL_arg1813z00_2995 = 
(((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)
((BgL_pgpzd2signaturezd2subzd2preferredzd2symmetricz00_bglt)BgL_spz00_2644))))->BgL_criticalzf3zf3); 
{ /* Llib/pgp_encode.scm 221 */
obj_t BgL_typez00_2996;
BgL_typez00_2996 = 
CNST_TABLE_REF(((long)37)); 
if(BgL_arg1813z00_2995)
{ /* Llib/pgp_encode.scm 177 */
long BgL_arg1518z00_2997;
{ /* Llib/pgp_encode.scm 177 */
char BgL_arg1524z00_2998;
BgL_arg1524z00_2998 = 
BGl_subpacketzd2typezd2ze3byteze3zz__openpgpzd2enumszd2(BgL_typez00_2996); 
BgL_arg1518z00_2997 = 
(
(long)(BgL_arg1524z00_2998)+((long)128)); } 
BGl_encodezd2octetzd2zz__openpgpzd2encodezd2(BgL_arg1518z00_2997, 
((obj_t)BgL_pz00_2645)); }  else 
{ /* Llib/pgp_encode.scm 178 */
char BgL_arg1525z00_2999;
BgL_arg1525z00_2999 = 
BGl_subpacketzd2typezd2ze3byteze3zz__openpgpzd2enumszd2(BgL_typez00_2996); 
BGl_encodezd2octetzd2zz__openpgpzd2encodezd2(
(long)(BgL_arg1525z00_2999), 
((obj_t)BgL_pz00_2645)); } } } 
BgL_tmpz00_4779 = 
BGl_encodezd2prefszd2zz__openpgpzd2encodezd2(
(((BgL_pgpzd2signaturezd2subzd2preferredzd2symmetricz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2preferredzd2symmetricz00_bglt)BgL_spz00_2644)))->BgL_algosz00), BGl_symmetriczd2keyzd2algozd2ze3bytezd2envze3zz__openpgpzd2enumszd2, 
((obj_t)BgL_pz00_2645)); 
return 
BBOOL(BgL_tmpz00_4779);} } 

}



/* &encode-sub-packet-co1216 */
obj_t BGl_z62encodezd2subzd2packetzd2co1216zb0zz__openpgpzd2encodezd2(obj_t BgL_envz00_2646, obj_t BgL_spz00_2647, obj_t BgL_pz00_2648)
{
{ /* Llib/pgp_encode.scm 212 */
{ /* Llib/pgp_encode.scm 216 */
bool_t BgL_arg1811z00_3002;
BgL_arg1811z00_3002 = 
(((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)
((BgL_pgpzd2signaturezd2subzd2keyzd2expirationzd2timezd2_bglt)BgL_spz00_2647))))->BgL_criticalzf3zf3); 
{ /* Llib/pgp_encode.scm 216 */
obj_t BgL_typez00_3003;
BgL_typez00_3003 = 
CNST_TABLE_REF(((long)38)); 
if(BgL_arg1811z00_3002)
{ /* Llib/pgp_encode.scm 177 */
long BgL_arg1518z00_3004;
{ /* Llib/pgp_encode.scm 177 */
char BgL_arg1524z00_3005;
BgL_arg1524z00_3005 = 
BGl_subpacketzd2typezd2ze3byteze3zz__openpgpzd2enumszd2(BgL_typez00_3003); 
BgL_arg1518z00_3004 = 
(
(long)(BgL_arg1524z00_3005)+((long)128)); } 
BGl_encodezd2octetzd2zz__openpgpzd2encodezd2(BgL_arg1518z00_3004, 
((obj_t)BgL_pz00_2648)); }  else 
{ /* Llib/pgp_encode.scm 178 */
char BgL_arg1525z00_3006;
BgL_arg1525z00_3006 = 
BGl_subpacketzd2typezd2ze3byteze3zz__openpgpzd2enumszd2(BgL_typez00_3003); 
BGl_encodezd2octetzd2zz__openpgpzd2encodezd2(
(long)(BgL_arg1525z00_3006), 
((obj_t)BgL_pz00_2648)); } } } 
{ /* Llib/pgp_encode.scm 217 */
long BgL_arg1812z00_3007;
BgL_arg1812z00_3007 = 
(((BgL_pgpzd2signaturezd2subzd2keyzd2expirationzd2timezd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2keyzd2expirationzd2timezd2_bglt)BgL_spz00_2647)))->BgL_expirationzd2timezd2); 
return 
bgl_display_obj(
BGl_fixnumzd2ze3scalarz31zz__openpgpzd2conversionzd2(BgL_arg1812z00_3007, ((long)4)), 
((obj_t)BgL_pz00_2648));} } 

}



/* &encode-sub-packet-co1214 */
obj_t BGl_z62encodezd2subzd2packetzd2co1214zb0zz__openpgpzd2encodezd2(obj_t BgL_envz00_2649, obj_t BgL_spz00_2650, obj_t BgL_pz00_2651)
{
{ /* Llib/pgp_encode.scm 207 */
{ /* Llib/pgp_encode.scm 210 */
bool_t BgL_arg1808z00_3010;
BgL_arg1808z00_3010 = 
(((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)
((BgL_pgpzd2signaturezd2subzd2revocablezd2_bglt)BgL_spz00_2650))))->BgL_criticalzf3zf3); 
{ /* Llib/pgp_encode.scm 210 */
obj_t BgL_typez00_3011;
BgL_typez00_3011 = 
CNST_TABLE_REF(((long)39)); 
if(BgL_arg1808z00_3010)
{ /* Llib/pgp_encode.scm 177 */
long BgL_arg1518z00_3012;
{ /* Llib/pgp_encode.scm 177 */
char BgL_arg1524z00_3013;
BgL_arg1524z00_3013 = 
BGl_subpacketzd2typezd2ze3byteze3zz__openpgpzd2enumszd2(BgL_typez00_3011); 
BgL_arg1518z00_3012 = 
(
(long)(BgL_arg1524z00_3013)+((long)128)); } 
BGl_encodezd2octetzd2zz__openpgpzd2encodezd2(BgL_arg1518z00_3012, 
((obj_t)BgL_pz00_2651)); }  else 
{ /* Llib/pgp_encode.scm 178 */
char BgL_arg1525z00_3014;
BgL_arg1525z00_3014 = 
BGl_subpacketzd2typezd2ze3byteze3zz__openpgpzd2enumszd2(BgL_typez00_3011); 
BGl_encodezd2octetzd2zz__openpgpzd2encodezd2(
(long)(BgL_arg1525z00_3014), 
((obj_t)BgL_pz00_2651)); } } } 
{ /* Llib/pgp_encode.scm 211 */
long BgL_arg1809z00_3015;
if(
(((BgL_pgpzd2signaturezd2subzd2revocablezd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2revocablezd2_bglt)BgL_spz00_2650)))->BgL_revocablezf3zf3))
{ /* Llib/pgp_encode.scm 211 */
BgL_arg1809z00_3015 = ((long)1); }  else 
{ /* Llib/pgp_encode.scm 211 */
BgL_arg1809z00_3015 = ((long)0); } 
if(
(BgL_arg1809z00_3015>=((long)256)))
{ /* Llib/pgp_encode.scm 22 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2399z00zz__openpgpzd2encodezd2, 
BINT(BgL_arg1809z00_3015)); }  else 
{ /* Llib/pgp_encode.scm 22 */BFALSE; } 
{ /* Llib/pgp_encode.scm 26 */
unsigned char BgL_arg1300z00_3016;
BgL_arg1300z00_3016 = 
(BgL_arg1809z00_3015); 
return 
bgl_display_obj(
BCHAR(BgL_arg1300z00_3016), 
((obj_t)BgL_pz00_2651));} } } 

}



/* &encode-sub-packet-co1212 */
obj_t BGl_z62encodezd2subzd2packetzd2co1212zb0zz__openpgpzd2encodezd2(obj_t BgL_envz00_2652, obj_t BgL_spz00_2653, obj_t BgL_pz00_2654)
{
{ /* Llib/pgp_encode.scm 201 */
{ /* Llib/pgp_encode.scm 204 */
bool_t BgL_arg1805z00_3019;
BgL_arg1805z00_3019 = 
(((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)
((BgL_pgpzd2signaturezd2subzd2trustzd2_bglt)BgL_spz00_2653))))->BgL_criticalzf3zf3); 
{ /* Llib/pgp_encode.scm 204 */
obj_t BgL_typez00_3020;
BgL_typez00_3020 = 
CNST_TABLE_REF(((long)40)); 
if(BgL_arg1805z00_3019)
{ /* Llib/pgp_encode.scm 177 */
long BgL_arg1518z00_3021;
{ /* Llib/pgp_encode.scm 177 */
char BgL_arg1524z00_3022;
BgL_arg1524z00_3022 = 
BGl_subpacketzd2typezd2ze3byteze3zz__openpgpzd2enumszd2(BgL_typez00_3020); 
BgL_arg1518z00_3021 = 
(
(long)(BgL_arg1524z00_3022)+((long)128)); } 
BGl_encodezd2octetzd2zz__openpgpzd2encodezd2(BgL_arg1518z00_3021, 
((obj_t)BgL_pz00_2654)); }  else 
{ /* Llib/pgp_encode.scm 178 */
char BgL_arg1525z00_3023;
BgL_arg1525z00_3023 = 
BGl_subpacketzd2typezd2ze3byteze3zz__openpgpzd2enumszd2(BgL_typez00_3020); 
BGl_encodezd2octetzd2zz__openpgpzd2encodezd2(
(long)(BgL_arg1525z00_3023), 
((obj_t)BgL_pz00_2654)); } } } 
{ /* Llib/pgp_encode.scm 205 */
int BgL_arg1806z00_3024;
BgL_arg1806z00_3024 = 
(((BgL_pgpzd2signaturezd2subzd2trustzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2trustzd2_bglt)BgL_spz00_2653)))->BgL_levelz00); 
{ /* Llib/pgp_encode.scm 205 */
long BgL_nz00_3025;
BgL_nz00_3025 = 
(long)(BgL_arg1806z00_3024); 
if(
(BgL_nz00_3025>=((long)256)))
{ /* Llib/pgp_encode.scm 22 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2399z00zz__openpgpzd2encodezd2, 
BINT(BgL_nz00_3025)); }  else 
{ /* Llib/pgp_encode.scm 22 */BFALSE; } 
{ /* Llib/pgp_encode.scm 26 */
unsigned char BgL_arg1300z00_3026;
BgL_arg1300z00_3026 = 
(BgL_nz00_3025); 
bgl_display_obj(
BCHAR(BgL_arg1300z00_3026), 
((obj_t)BgL_pz00_2654)); } } } 
{ /* Llib/pgp_encode.scm 206 */
int BgL_arg1807z00_3027;
BgL_arg1807z00_3027 = 
(((BgL_pgpzd2signaturezd2subzd2trustzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2trustzd2_bglt)BgL_spz00_2653)))->BgL_amountz00); 
{ /* Llib/pgp_encode.scm 206 */
long BgL_nz00_3028;
BgL_nz00_3028 = 
(long)(BgL_arg1807z00_3027); 
if(
(BgL_nz00_3028>=((long)256)))
{ /* Llib/pgp_encode.scm 22 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2399z00zz__openpgpzd2encodezd2, 
BINT(BgL_nz00_3028)); }  else 
{ /* Llib/pgp_encode.scm 22 */BFALSE; } 
{ /* Llib/pgp_encode.scm 26 */
unsigned char BgL_arg1300z00_3029;
BgL_arg1300z00_3029 = 
(BgL_nz00_3028); 
return 
bgl_display_obj(
BCHAR(BgL_arg1300z00_3029), 
((obj_t)BgL_pz00_2654));} } } } 

}



/* &encode-sub-packet-co1210 */
obj_t BGl_z62encodezd2subzd2packetzd2co1210zb0zz__openpgpzd2encodezd2(obj_t BgL_envz00_2655, obj_t BgL_spz00_2656, obj_t BgL_pz00_2657)
{
{ /* Llib/pgp_encode.scm 196 */
{ /* Llib/pgp_encode.scm 199 */
bool_t BgL_arg1802z00_3032;
BgL_arg1802z00_3032 = 
(((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)
((BgL_pgpzd2signaturezd2subzd2exportablezd2_bglt)BgL_spz00_2656))))->BgL_criticalzf3zf3); 
{ /* Llib/pgp_encode.scm 199 */
obj_t BgL_typez00_3033;
BgL_typez00_3033 = 
CNST_TABLE_REF(((long)41)); 
if(BgL_arg1802z00_3032)
{ /* Llib/pgp_encode.scm 177 */
long BgL_arg1518z00_3034;
{ /* Llib/pgp_encode.scm 177 */
char BgL_arg1524z00_3035;
BgL_arg1524z00_3035 = 
BGl_subpacketzd2typezd2ze3byteze3zz__openpgpzd2enumszd2(BgL_typez00_3033); 
BgL_arg1518z00_3034 = 
(
(long)(BgL_arg1524z00_3035)+((long)128)); } 
BGl_encodezd2octetzd2zz__openpgpzd2encodezd2(BgL_arg1518z00_3034, 
((obj_t)BgL_pz00_2657)); }  else 
{ /* Llib/pgp_encode.scm 178 */
char BgL_arg1525z00_3036;
BgL_arg1525z00_3036 = 
BGl_subpacketzd2typezd2ze3byteze3zz__openpgpzd2enumszd2(BgL_typez00_3033); 
BGl_encodezd2octetzd2zz__openpgpzd2encodezd2(
(long)(BgL_arg1525z00_3036), 
((obj_t)BgL_pz00_2657)); } } } 
{ /* Llib/pgp_encode.scm 200 */
long BgL_arg1803z00_3037;
if(
(((BgL_pgpzd2signaturezd2subzd2exportablezd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2exportablezd2_bglt)BgL_spz00_2656)))->BgL_exportablezf3zf3))
{ /* Llib/pgp_encode.scm 200 */
BgL_arg1803z00_3037 = ((long)1); }  else 
{ /* Llib/pgp_encode.scm 200 */
BgL_arg1803z00_3037 = ((long)0); } 
if(
(BgL_arg1803z00_3037>=((long)256)))
{ /* Llib/pgp_encode.scm 22 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2399z00zz__openpgpzd2encodezd2, 
BINT(BgL_arg1803z00_3037)); }  else 
{ /* Llib/pgp_encode.scm 22 */BFALSE; } 
{ /* Llib/pgp_encode.scm 26 */
unsigned char BgL_arg1300z00_3038;
BgL_arg1300z00_3038 = 
(BgL_arg1803z00_3037); 
return 
bgl_display_obj(
BCHAR(BgL_arg1300z00_3038), 
((obj_t)BgL_pz00_2657));} } } 

}



/* &encode-sub-packet-co1208 */
obj_t BGl_z62encodezd2subzd2packetzd2co1208zb0zz__openpgpzd2encodezd2(obj_t BgL_envz00_2658, obj_t BgL_spz00_2659, obj_t BgL_pz00_2660)
{
{ /* Llib/pgp_encode.scm 190 */
{ /* Llib/pgp_encode.scm 194 */
bool_t BgL_arg1800z00_3041;
BgL_arg1800z00_3041 = 
(((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)
((BgL_pgpzd2signaturezd2subzd2expirationzd2timez00_bglt)BgL_spz00_2659))))->BgL_criticalzf3zf3); 
{ /* Llib/pgp_encode.scm 194 */
obj_t BgL_typez00_3042;
BgL_typez00_3042 = 
CNST_TABLE_REF(((long)42)); 
if(BgL_arg1800z00_3041)
{ /* Llib/pgp_encode.scm 177 */
long BgL_arg1518z00_3043;
{ /* Llib/pgp_encode.scm 177 */
char BgL_arg1524z00_3044;
BgL_arg1524z00_3044 = 
BGl_subpacketzd2typezd2ze3byteze3zz__openpgpzd2enumszd2(BgL_typez00_3042); 
BgL_arg1518z00_3043 = 
(
(long)(BgL_arg1524z00_3044)+((long)128)); } 
BGl_encodezd2octetzd2zz__openpgpzd2encodezd2(BgL_arg1518z00_3043, 
((obj_t)BgL_pz00_2660)); }  else 
{ /* Llib/pgp_encode.scm 178 */
char BgL_arg1525z00_3045;
BgL_arg1525z00_3045 = 
BGl_subpacketzd2typezd2ze3byteze3zz__openpgpzd2enumszd2(BgL_typez00_3042); 
BGl_encodezd2octetzd2zz__openpgpzd2encodezd2(
(long)(BgL_arg1525z00_3045), 
((obj_t)BgL_pz00_2660)); } } } 
{ /* Llib/pgp_encode.scm 195 */
obj_t BgL_arg1801z00_3046;
BgL_arg1801z00_3046 = 
(((BgL_pgpzd2signaturezd2subzd2expirationzd2timez00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2expirationzd2timez00_bglt)BgL_spz00_2659)))->BgL_expirationzd2datezd2); 
{ /* Llib/pgp_encode.scm 60 */
long BgL_arg1351z00_3047;
BgL_arg1351z00_3047 = 
bgl_date_to_seconds(BgL_arg1801z00_3046); 
{ /* Llib/pgp_encode.scm 60 */
long BgL_nnz00_3048;
BgL_nnz00_3048 = 
(long)(BgL_arg1351z00_3047); 
return 
bgl_display_obj(
BGl_fixnumzd2ze3scalarz31zz__openpgpzd2conversionzd2(BgL_nnz00_3048, ((long)4)), 
((obj_t)BgL_pz00_2660));} } } } 

}



/* &encode-sub-packet-co1206 */
obj_t BGl_z62encodezd2subzd2packetzd2co1206zb0zz__openpgpzd2encodezd2(obj_t BgL_envz00_2661, obj_t BgL_spz00_2662, obj_t BgL_pz00_2663)
{
{ /* Llib/pgp_encode.scm 185 */
{ /* Llib/pgp_encode.scm 188 */
bool_t BgL_arg1798z00_3051;
BgL_arg1798z00_3051 = 
(((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)
((BgL_pgpzd2signaturezd2subzd2creationzd2timez00_bglt)BgL_spz00_2662))))->BgL_criticalzf3zf3); 
{ /* Llib/pgp_encode.scm 188 */
obj_t BgL_typez00_3052;
BgL_typez00_3052 = 
CNST_TABLE_REF(((long)43)); 
if(BgL_arg1798z00_3051)
{ /* Llib/pgp_encode.scm 177 */
long BgL_arg1518z00_3053;
{ /* Llib/pgp_encode.scm 177 */
char BgL_arg1524z00_3054;
BgL_arg1524z00_3054 = 
BGl_subpacketzd2typezd2ze3byteze3zz__openpgpzd2enumszd2(BgL_typez00_3052); 
BgL_arg1518z00_3053 = 
(
(long)(BgL_arg1524z00_3054)+((long)128)); } 
BGl_encodezd2octetzd2zz__openpgpzd2encodezd2(BgL_arg1518z00_3053, 
((obj_t)BgL_pz00_2663)); }  else 
{ /* Llib/pgp_encode.scm 178 */
char BgL_arg1525z00_3055;
BgL_arg1525z00_3055 = 
BGl_subpacketzd2typezd2ze3byteze3zz__openpgpzd2enumszd2(BgL_typez00_3052); 
BGl_encodezd2octetzd2zz__openpgpzd2encodezd2(
(long)(BgL_arg1525z00_3055), 
((obj_t)BgL_pz00_2663)); } } } 
{ /* Llib/pgp_encode.scm 189 */
obj_t BgL_arg1799z00_3056;
BgL_arg1799z00_3056 = 
(((BgL_pgpzd2signaturezd2subzd2creationzd2timez00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2creationzd2timez00_bglt)BgL_spz00_2662)))->BgL_creationzd2datezd2); 
{ /* Llib/pgp_encode.scm 60 */
long BgL_arg1351z00_3057;
BgL_arg1351z00_3057 = 
bgl_date_to_seconds(BgL_arg1799z00_3056); 
{ /* Llib/pgp_encode.scm 60 */
long BgL_nnz00_3058;
BgL_nnz00_3058 = 
(long)(BgL_arg1351z00_3057); 
return 
bgl_display_obj(
BGl_fixnumzd2ze3scalarz31zz__openpgpzd2conversionzd2(BgL_nnz00_3058, ((long)4)), 
((obj_t)BgL_pz00_2663));} } } } 

}



/* &encode-sub-packet-co1204 */
obj_t BGl_z62encodezd2subzd2packetzd2co1204zb0zz__openpgpzd2encodezd2(obj_t BgL_envz00_2664, obj_t BgL_spz00_2665, obj_t BgL_pz00_2666)
{
{ /* Llib/pgp_encode.scm 180 */
{ /* Llib/pgp_encode.scm 183 */
obj_t BgL_arg1795z00_3061;bool_t BgL_arg1796z00_3062;
BgL_arg1795z00_3061 = 
(((BgL_pgpzd2signaturezd2subzd2genericzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2genericzd2_bglt)BgL_spz00_2665)))->BgL_typez00); 
BgL_arg1796z00_3062 = 
(((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)
((BgL_pgpzd2signaturezd2subzd2genericzd2_bglt)BgL_spz00_2665))))->BgL_criticalzf3zf3); 
if(BgL_arg1796z00_3062)
{ /* Llib/pgp_encode.scm 177 */
long BgL_arg1518z00_3063;
{ /* Llib/pgp_encode.scm 177 */
char BgL_arg1524z00_3064;
BgL_arg1524z00_3064 = 
BGl_subpacketzd2typezd2ze3byteze3zz__openpgpzd2enumszd2(BgL_arg1795z00_3061); 
BgL_arg1518z00_3063 = 
(
(long)(BgL_arg1524z00_3064)+((long)128)); } 
BGl_encodezd2octetzd2zz__openpgpzd2encodezd2(BgL_arg1518z00_3063, 
((obj_t)BgL_pz00_2666)); }  else 
{ /* Llib/pgp_encode.scm 178 */
char BgL_arg1525z00_3065;
BgL_arg1525z00_3065 = 
BGl_subpacketzd2typezd2ze3byteze3zz__openpgpzd2enumszd2(BgL_arg1795z00_3061); 
BGl_encodezd2octetzd2zz__openpgpzd2encodezd2(
(long)(BgL_arg1525z00_3065), 
((obj_t)BgL_pz00_2666)); } } 
return 
bgl_display_obj(
(((BgL_pgpzd2signaturezd2subzd2genericzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2genericzd2_bglt)BgL_spz00_2665)))->BgL_dataz00), 
((obj_t)BgL_pz00_2666));} 

}



/* &encode-content-PGP-P1200 */
obj_t BGl_z62encodezd2contentzd2PGPzd2P1200zb0zz__openpgpzd2encodezd2(obj_t BgL_envz00_2667, obj_t BgL_packetz00_2668, obj_t BgL_pz00_2669)
{
{ /* Llib/pgp_encode.scm 135 */
{ /* Llib/pgp_encode.scm 141 */
long BgL_arg1778z00_3068;
BgL_arg1778z00_3068 = 
(((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)BgL_packetz00_2668)))->BgL_versionz00); 
if(
(BgL_arg1778z00_3068>=((long)256)))
{ /* Llib/pgp_encode.scm 22 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2399z00zz__openpgpzd2encodezd2, 
BINT(BgL_arg1778z00_3068)); }  else 
{ /* Llib/pgp_encode.scm 22 */BFALSE; } 
{ /* Llib/pgp_encode.scm 26 */
unsigned char BgL_arg1300z00_3069;
BgL_arg1300z00_3069 = 
(BgL_arg1778z00_3068); 
bgl_display_obj(
BCHAR(BgL_arg1300z00_3069), 
((obj_t)BgL_pz00_2669)); } } 
{ /* Llib/pgp_encode.scm 142 */
obj_t BgL_arg1779z00_3070;
BgL_arg1779z00_3070 = 
(((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)BgL_packetz00_2668)))->BgL_idz00); 
if(
(
STRING_LENGTH(BgL_arg1779z00_3070)==((long)8)))
{ /* Llib/pgp_encode.scm 28 */BFALSE; }  else 
{ /* Llib/pgp_encode.scm 31 */
obj_t BgL_arg1330z00_3071;
BgL_arg1330z00_3071 = 
MAKE_YOUNG_PAIR(
BINT(((long)8)), BgL_arg1779z00_3070); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)8)), BGl_string2412z00zz__openpgpzd2encodezd2, BgL_arg1330z00_3071); } 
bgl_display_obj(BgL_arg1779z00_3070, 
((obj_t)BgL_pz00_2669)); } 
{ /* Llib/pgp_encode.scm 143 */
char BgL_arg1780z00_3072;
BgL_arg1780z00_3072 = 
BGl_publiczd2keyzd2algozd2ze3bytez31zz__openpgpzd2enumszd2(
(((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)BgL_packetz00_2668)))->BgL_algoz00)); 
{ /* Llib/pgp_encode.scm 143 */
long BgL_nz00_3073;
BgL_nz00_3073 = 
(long)(BgL_arg1780z00_3072); 
if(
(BgL_nz00_3073>=((long)256)))
{ /* Llib/pgp_encode.scm 22 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2399z00zz__openpgpzd2encodezd2, 
BINT(BgL_nz00_3073)); }  else 
{ /* Llib/pgp_encode.scm 22 */BFALSE; } 
{ /* Llib/pgp_encode.scm 26 */
unsigned char BgL_arg1300z00_3074;
BgL_arg1300z00_3074 = 
(BgL_nz00_3073); 
bgl_display_obj(
BCHAR(BgL_arg1300z00_3074), 
((obj_t)BgL_pz00_2669)); } } } 
{ /* Llib/pgp_encode.scm 144 */
obj_t BgL_casezd2valuezd2_3075;
BgL_casezd2valuezd2_3075 = 
(((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)BgL_packetz00_2668)))->BgL_algoz00); 
{ /* Llib/pgp_encode.scm 144 */
bool_t BgL_test2781z00_5006;
{ /* Llib/pgp_encode.scm 144 */
bool_t BgL__ortest_1104z00_3076;
BgL__ortest_1104z00_3076 = 
(BgL_casezd2valuezd2_3075==
CNST_TABLE_REF(((long)11))); 
if(BgL__ortest_1104z00_3076)
{ /* Llib/pgp_encode.scm 144 */
BgL_test2781z00_5006 = BgL__ortest_1104z00_3076
; }  else 
{ /* Llib/pgp_encode.scm 144 */
BgL_test2781z00_5006 = 
(BgL_casezd2valuezd2_3075==
CNST_TABLE_REF(((long)12)))
; } } 
if(BgL_test2781z00_5006)
{ /* Llib/pgp_encode.scm 146 */
obj_t BgL_arg1783z00_3077;
BgL_arg1783z00_3077 = 
(((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)BgL_packetz00_2668)))->BgL_encryptedzd2sessionzd2keyz00); 
{ /* Llib/pgp_encode.scm 40 */
long BgL_bitzd2lenzd2_3078;
BgL_bitzd2lenzd2_3078 = 
BGl_bignumzd2bitzd2lengthz00zz__openpgpzd2utilzd2(
((obj_t)BgL_arg1783z00_3077)); 
{ /* Llib/pgp_encode.scm 40 */
long BgL_octetzd2lenzd2_3079;
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2209z00_3080;
{ /* Llib/pgp_encode.scm 41 */
long BgL_qz00_3081;long BgL_rz00_3082;
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2197z00_3083;
BgL_res2197z00_3083 = 
(BgL_bitzd2lenzd2_3078/((long)8)); 
BgL_qz00_3081 = BgL_res2197z00_3083; } 
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2203z00_3084;
{ /* Llib/pgp_encode.scm 41 */
long BgL_n1z00_3085;long BgL_n2z00_3086;
BgL_n1z00_3085 = BgL_bitzd2lenzd2_3078; 
BgL_n2z00_3086 = ((long)8); 
{ /* Llib/pgp_encode.scm 41 */
bool_t BgL_test2783z00_5017;
{ /* Llib/pgp_encode.scm 41 */
long BgL_arg1299z00_3087;
BgL_arg1299z00_3087 = 
(((BgL_n1z00_3085) | (BgL_n2z00_3086)) & -2147483648); 
BgL_test2783z00_5017 = 
(BgL_arg1299z00_3087==((long)0)); } 
if(BgL_test2783z00_5017)
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_arg1287z00_3088;
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_arg1293z00_3089;int32_t BgL_arg1294z00_3090;
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_res2199z00_3091;
BgL_res2199z00_3091 = 
(int32_t)(BgL_n1z00_3085); 
BgL_arg1293z00_3089 = BgL_res2199z00_3091; } 
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_res2200z00_3092;
BgL_res2200z00_3092 = 
(int32_t)(BgL_n2z00_3086); 
BgL_arg1294z00_3090 = BgL_res2200z00_3092; } 
BgL_arg1287z00_3088 = 
(BgL_arg1293z00_3089%BgL_arg1294z00_3090); } 
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2202z00_3093;
{ /* Llib/pgp_encode.scm 41 */
long BgL_arg1421z00_3094;
BgL_arg1421z00_3094 = 
(long)(BgL_arg1287z00_3088); 
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2201z00_3095;
BgL_res2201z00_3095 = 
(long)(BgL_arg1421z00_3094); 
BgL_res2202z00_3093 = BgL_res2201z00_3095; } } 
BgL_res2203z00_3084 = BgL_res2202z00_3093; } }  else 
{ /* Llib/pgp_encode.scm 41 */
BgL_res2203z00_3084 = 
(BgL_n1z00_3085%BgL_n2z00_3086); } } } 
BgL_rz00_3082 = BgL_res2203z00_3084; } 
if(
(BgL_rz00_3082==((long)0)))
{ /* Llib/pgp_encode.scm 41 */
BgL_res2209z00_3080 = BgL_qz00_3081; }  else 
{ /* Llib/pgp_encode.scm 41 */
if(
(BgL_rz00_3082>((long)0)))
{ /* Llib/pgp_encode.scm 41 */
BgL_res2209z00_3080 = 
(BgL_qz00_3081+((long)1)); }  else 
{ /* Llib/pgp_encode.scm 41 */
BgL_res2209z00_3080 = 
(BgL_qz00_3081-((long)1)); } } } 
BgL_octetzd2lenzd2_3079 = BgL_res2209z00_3080; } 
{ /* Llib/pgp_encode.scm 41 */
obj_t BgL_strz00_3096;
BgL_strz00_3096 = 
BGl_bignumzd2ze3binzd2strze3zz__openpgpzd2utilzd2(
((obj_t)BgL_arg1783z00_3077), BgL_octetzd2lenzd2_3079); 
{ /* Llib/pgp_encode.scm 42 */

bgl_display_obj(
BGl_fixnumzd2ze3scalarz31zz__openpgpzd2conversionzd2(BgL_bitzd2lenzd2_3078, ((long)2)), 
((obj_t)BgL_pz00_2669)); 
return 
bgl_display_obj(BgL_strz00_3096, 
((obj_t)BgL_pz00_2669));} } } } }  else 
{ /* Llib/pgp_encode.scm 144 */
bool_t BgL_test2786z00_5039;
{ /* Llib/pgp_encode.scm 144 */
bool_t BgL__ortest_1105z00_3097;
BgL__ortest_1105z00_3097 = 
(BgL_casezd2valuezd2_3075==
CNST_TABLE_REF(((long)17))); 
if(BgL__ortest_1105z00_3097)
{ /* Llib/pgp_encode.scm 144 */
BgL_test2786z00_5039 = BgL__ortest_1105z00_3097
; }  else 
{ /* Llib/pgp_encode.scm 144 */
BgL_test2786z00_5039 = 
(BgL_casezd2valuezd2_3075==
CNST_TABLE_REF(((long)18)))
; } } 
if(BgL_test2786z00_5039)
{ /* Llib/pgp_encode.scm 144 */
{ /* Llib/pgp_encode.scm 148 */
bool_t BgL_test2788z00_5045;
{ /* Llib/pgp_encode.scm 148 */
obj_t BgL_tmpz00_5046;
BgL_tmpz00_5046 = 
(((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)BgL_packetz00_2668)))->BgL_encryptedzd2sessionzd2keyz00); 
BgL_test2788z00_5045 = 
PAIRP(BgL_tmpz00_5046); } 
if(BgL_test2788z00_5045)
{ /* Llib/pgp_encode.scm 148 */BFALSE; }  else 
{ /* Llib/pgp_encode.scm 149 */
obj_t BgL_arg1787z00_3098;
BgL_arg1787z00_3098 = 
(((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)BgL_packetz00_2668)))->BgL_encryptedzd2sessionzd2keyz00); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)44)), BGl_string2491z00zz__openpgpzd2encodezd2, BgL_arg1787z00_3098); } } 
{ /* Llib/pgp_encode.scm 152 */
obj_t BgL_arg1789z00_3099;
BgL_arg1789z00_3099 = 
CAR(
(((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)BgL_packetz00_2668)))->BgL_encryptedzd2sessionzd2keyz00)); 
{ /* Llib/pgp_encode.scm 40 */
long BgL_bitzd2lenzd2_3100;
BgL_bitzd2lenzd2_3100 = 
BGl_bignumzd2bitzd2lengthz00zz__openpgpzd2utilzd2(
((obj_t)BgL_arg1789z00_3099)); 
{ /* Llib/pgp_encode.scm 40 */
long BgL_octetzd2lenzd2_3101;
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2223z00_3102;
{ /* Llib/pgp_encode.scm 41 */
long BgL_qz00_3103;long BgL_rz00_3104;
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2211z00_3105;
BgL_res2211z00_3105 = 
(BgL_bitzd2lenzd2_3100/((long)8)); 
BgL_qz00_3103 = BgL_res2211z00_3105; } 
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2217z00_3106;
{ /* Llib/pgp_encode.scm 41 */
long BgL_n1z00_3107;long BgL_n2z00_3108;
BgL_n1z00_3107 = BgL_bitzd2lenzd2_3100; 
BgL_n2z00_3108 = ((long)8); 
{ /* Llib/pgp_encode.scm 41 */
bool_t BgL_test2789z00_5060;
{ /* Llib/pgp_encode.scm 41 */
long BgL_arg1299z00_3109;
BgL_arg1299z00_3109 = 
(((BgL_n1z00_3107) | (BgL_n2z00_3108)) & -2147483648); 
BgL_test2789z00_5060 = 
(BgL_arg1299z00_3109==((long)0)); } 
if(BgL_test2789z00_5060)
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_arg1287z00_3110;
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_arg1293z00_3111;int32_t BgL_arg1294z00_3112;
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_res2213z00_3113;
BgL_res2213z00_3113 = 
(int32_t)(BgL_n1z00_3107); 
BgL_arg1293z00_3111 = BgL_res2213z00_3113; } 
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_res2214z00_3114;
BgL_res2214z00_3114 = 
(int32_t)(BgL_n2z00_3108); 
BgL_arg1294z00_3112 = BgL_res2214z00_3114; } 
BgL_arg1287z00_3110 = 
(BgL_arg1293z00_3111%BgL_arg1294z00_3112); } 
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2216z00_3115;
{ /* Llib/pgp_encode.scm 41 */
long BgL_arg1421z00_3116;
BgL_arg1421z00_3116 = 
(long)(BgL_arg1287z00_3110); 
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2215z00_3117;
BgL_res2215z00_3117 = 
(long)(BgL_arg1421z00_3116); 
BgL_res2216z00_3115 = BgL_res2215z00_3117; } } 
BgL_res2217z00_3106 = BgL_res2216z00_3115; } }  else 
{ /* Llib/pgp_encode.scm 41 */
BgL_res2217z00_3106 = 
(BgL_n1z00_3107%BgL_n2z00_3108); } } } 
BgL_rz00_3104 = BgL_res2217z00_3106; } 
if(
(BgL_rz00_3104==((long)0)))
{ /* Llib/pgp_encode.scm 41 */
BgL_res2223z00_3102 = BgL_qz00_3103; }  else 
{ /* Llib/pgp_encode.scm 41 */
if(
(BgL_rz00_3104>((long)0)))
{ /* Llib/pgp_encode.scm 41 */
BgL_res2223z00_3102 = 
(BgL_qz00_3103+((long)1)); }  else 
{ /* Llib/pgp_encode.scm 41 */
BgL_res2223z00_3102 = 
(BgL_qz00_3103-((long)1)); } } } 
BgL_octetzd2lenzd2_3101 = BgL_res2223z00_3102; } 
{ /* Llib/pgp_encode.scm 41 */
obj_t BgL_strz00_3118;
BgL_strz00_3118 = 
BGl_bignumzd2ze3binzd2strze3zz__openpgpzd2utilzd2(
((obj_t)BgL_arg1789z00_3099), BgL_octetzd2lenzd2_3101); 
{ /* Llib/pgp_encode.scm 42 */

bgl_display_obj(
BGl_fixnumzd2ze3scalarz31zz__openpgpzd2conversionzd2(BgL_bitzd2lenzd2_3100, ((long)2)), 
((obj_t)BgL_pz00_2669)); 
bgl_display_obj(BgL_strz00_3118, 
((obj_t)BgL_pz00_2669)); } } } } } 
{ /* Llib/pgp_encode.scm 153 */
obj_t BgL_arg1791z00_3119;
BgL_arg1791z00_3119 = 
CDR(
(((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)BgL_packetz00_2668)))->BgL_encryptedzd2sessionzd2keyz00)); 
{ /* Llib/pgp_encode.scm 40 */
long BgL_bitzd2lenzd2_3120;
BgL_bitzd2lenzd2_3120 = 
BGl_bignumzd2bitzd2lengthz00zz__openpgpzd2utilzd2(
((obj_t)BgL_arg1791z00_3119)); 
{ /* Llib/pgp_encode.scm 40 */
long BgL_octetzd2lenzd2_3121;
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2236z00_3122;
{ /* Llib/pgp_encode.scm 41 */
long BgL_qz00_3123;long BgL_rz00_3124;
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2224z00_3125;
BgL_res2224z00_3125 = 
(BgL_bitzd2lenzd2_3120/((long)8)); 
BgL_qz00_3123 = BgL_res2224z00_3125; } 
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2230z00_3126;
{ /* Llib/pgp_encode.scm 41 */
long BgL_n1z00_3127;long BgL_n2z00_3128;
BgL_n1z00_3127 = BgL_bitzd2lenzd2_3120; 
BgL_n2z00_3128 = ((long)8); 
{ /* Llib/pgp_encode.scm 41 */
bool_t BgL_test2792z00_5088;
{ /* Llib/pgp_encode.scm 41 */
long BgL_arg1299z00_3129;
BgL_arg1299z00_3129 = 
(((BgL_n1z00_3127) | (BgL_n2z00_3128)) & -2147483648); 
BgL_test2792z00_5088 = 
(BgL_arg1299z00_3129==((long)0)); } 
if(BgL_test2792z00_5088)
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_arg1287z00_3130;
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_arg1293z00_3131;int32_t BgL_arg1294z00_3132;
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_res2226z00_3133;
BgL_res2226z00_3133 = 
(int32_t)(BgL_n1z00_3127); 
BgL_arg1293z00_3131 = BgL_res2226z00_3133; } 
{ /* Llib/pgp_encode.scm 41 */
int32_t BgL_res2227z00_3134;
BgL_res2227z00_3134 = 
(int32_t)(BgL_n2z00_3128); 
BgL_arg1294z00_3132 = BgL_res2227z00_3134; } 
BgL_arg1287z00_3130 = 
(BgL_arg1293z00_3131%BgL_arg1294z00_3132); } 
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2229z00_3135;
{ /* Llib/pgp_encode.scm 41 */
long BgL_arg1421z00_3136;
BgL_arg1421z00_3136 = 
(long)(BgL_arg1287z00_3130); 
{ /* Llib/pgp_encode.scm 41 */
long BgL_res2228z00_3137;
BgL_res2228z00_3137 = 
(long)(BgL_arg1421z00_3136); 
BgL_res2229z00_3135 = BgL_res2228z00_3137; } } 
BgL_res2230z00_3126 = BgL_res2229z00_3135; } }  else 
{ /* Llib/pgp_encode.scm 41 */
BgL_res2230z00_3126 = 
(BgL_n1z00_3127%BgL_n2z00_3128); } } } 
BgL_rz00_3124 = BgL_res2230z00_3126; } 
if(
(BgL_rz00_3124==((long)0)))
{ /* Llib/pgp_encode.scm 41 */
BgL_res2236z00_3122 = BgL_qz00_3123; }  else 
{ /* Llib/pgp_encode.scm 41 */
if(
(BgL_rz00_3124>((long)0)))
{ /* Llib/pgp_encode.scm 41 */
BgL_res2236z00_3122 = 
(BgL_qz00_3123+((long)1)); }  else 
{ /* Llib/pgp_encode.scm 41 */
BgL_res2236z00_3122 = 
(BgL_qz00_3123-((long)1)); } } } 
BgL_octetzd2lenzd2_3121 = BgL_res2236z00_3122; } 
{ /* Llib/pgp_encode.scm 41 */
obj_t BgL_strz00_3138;
BgL_strz00_3138 = 
BGl_bignumzd2ze3binzd2strze3zz__openpgpzd2utilzd2(
((obj_t)BgL_arg1791z00_3119), BgL_octetzd2lenzd2_3121); 
{ /* Llib/pgp_encode.scm 42 */

bgl_display_obj(
BGl_fixnumzd2ze3scalarz31zz__openpgpzd2conversionzd2(BgL_bitzd2lenzd2_3120, ((long)2)), 
((obj_t)BgL_pz00_2669)); 
return 
bgl_display_obj(BgL_strz00_3138, 
((obj_t)BgL_pz00_2669));} } } } } }  else 
{ /* Llib/pgp_encode.scm 157 */
obj_t BgL_arg1793z00_3139;
BgL_arg1793z00_3139 = 
BGl_publiczd2keyzd2algozd2ze3humanzd2readableze3zz__openpgpzd2humanzd2(
(((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)BgL_packetz00_2668)))->BgL_algoz00)); 
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)44)), BGl_string2492z00zz__openpgpzd2encodezd2, BgL_arg1793z00_3139);} } } } } 

}



/* &packet->content-tag-1195 */
obj_t BGl_z62packetzd2ze3contentzd2tagzd21195z53zz__openpgpzd2encodezd2(obj_t BgL_envz00_2670, obj_t BgL_pz00_2671)
{
{ /* Llib/pgp_encode.scm 106 */
return 
CNST_TABLE_REF(((long)45));} 

}



/* &packet->content-tag-1193 */
obj_t BGl_z62packetzd2ze3contentzd2tagzd21193z53zz__openpgpzd2encodezd2(obj_t BgL_envz00_2672, obj_t BgL_pz00_2673)
{
{ /* Llib/pgp_encode.scm 104 */
return 
CNST_TABLE_REF(((long)40));} 

}



/* &packet->content-tag-1191 */
obj_t BGl_z62packetzd2ze3contentzd2tagzd21191z53zz__openpgpzd2encodezd2(obj_t BgL_envz00_2674, obj_t BgL_pz00_2675)
{
{ /* Llib/pgp_encode.scm 102 */
return 
CNST_TABLE_REF(((long)46));} 

}



/* &packet->content-tag-1189 */
obj_t BGl_z62packetzd2ze3contentzd2tagzd21189z53zz__openpgpzd2encodezd2(obj_t BgL_envz00_2676, obj_t BgL_pz00_2677)
{
{ /* Llib/pgp_encode.scm 100 */
return 
CNST_TABLE_REF(((long)47));} 

}



/* &packet->content-tag-1187 */
obj_t BGl_z62packetzd2ze3contentzd2tagzd21187z53zz__openpgpzd2encodezd2(obj_t BgL_envz00_2678, obj_t BgL_pz00_2679)
{
{ /* Llib/pgp_encode.scm 98 */
return 
CNST_TABLE_REF(((long)48));} 

}



/* &packet->content-tag-1185 */
obj_t BGl_z62packetzd2ze3contentzd2tagzd21185z53zz__openpgpzd2encodezd2(obj_t BgL_envz00_2680, obj_t BgL_pz00_2681)
{
{ /* Llib/pgp_encode.scm 96 */
return 
CNST_TABLE_REF(((long)49));} 

}



/* &packet->content-tag-1183 */
obj_t BGl_z62packetzd2ze3contentzd2tagzd21183z53zz__openpgpzd2encodezd2(obj_t BgL_envz00_2682, obj_t BgL_pz00_2683)
{
{ /* Llib/pgp_encode.scm 94 */
return 
CNST_TABLE_REF(((long)50));} 

}



/* &packet->content-tag-1181 */
obj_t BGl_z62packetzd2ze3contentzd2tagzd21181z53zz__openpgpzd2encodezd2(obj_t BgL_envz00_2684, obj_t BgL_pz00_2685)
{
{ /* Llib/pgp_encode.scm 89 */
if(
(((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)
((BgL_pgpzd2publiczd2keyzd2packetzd2_bglt)BgL_pz00_2685))))->BgL_subkeyzf3zf3))
{ /* Llib/pgp_encode.scm 91 */
return 
CNST_TABLE_REF(((long)51));}  else 
{ /* Llib/pgp_encode.scm 91 */
return 
CNST_TABLE_REF(((long)52));} } 

}



/* &packet->content-tag-1179 */
obj_t BGl_z62packetzd2ze3contentzd2tagzd21179z53zz__openpgpzd2encodezd2(obj_t BgL_envz00_2686, obj_t BgL_pz00_2687)
{
{ /* Llib/pgp_encode.scm 84 */
if(
(((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)
((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)BgL_pz00_2687))))->BgL_subkeyzf3zf3))
{ /* Llib/pgp_encode.scm 86 */
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/pgp_encode.scm 86 */
return 
CNST_TABLE_REF(((long)54));} } 

}



/* &packet->content-tag-1177 */
obj_t BGl_z62packetzd2ze3contentzd2tagzd21177z53zz__openpgpzd2encodezd2(obj_t BgL_envz00_2688, obj_t BgL_pz00_2689)
{
{ /* Llib/pgp_encode.scm 82 */
return 
CNST_TABLE_REF(((long)55));} 

}



/* &packet->content-tag-1175 */
obj_t BGl_z62packetzd2ze3contentzd2tagzd21175z53zz__openpgpzd2encodezd2(obj_t BgL_envz00_2690, obj_t BgL_pz00_2691)
{
{ /* Llib/pgp_encode.scm 79 */
return 
CNST_TABLE_REF(((long)56));} 

}



/* &packet->content-tag-1173 */
obj_t BGl_z62packetzd2ze3contentzd2tagzd21173z53zz__openpgpzd2encodezd2(obj_t BgL_envz00_2692, obj_t BgL_pz00_2693)
{
{ /* Llib/pgp_encode.scm 77 */
return 
CNST_TABLE_REF(((long)57));} 

}



/* &packet->content-tag-1171 */
obj_t BGl_z62packetzd2ze3contentzd2tagzd21171z53zz__openpgpzd2encodezd2(obj_t BgL_envz00_2694, obj_t BgL_pz00_2695)
{
{ /* Llib/pgp_encode.scm 74 */
return 
CNST_TABLE_REF(((long)58));} 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__openpgpzd2encodezd2()
{
{ /* Llib/pgp_encode.scm 1 */
BGl_modulezd2initializa7ationz75zz__openpgpzd2utilzd2(((long)211416812), 
BSTRING_TO_STRING(BGl_string2493z00zz__openpgpzd2encodezd2)); 
BGl_modulezd2initializa7ationz75zz__openpgpzd2conversionzd2(((long)103989188), 
BSTRING_TO_STRING(BGl_string2493z00zz__openpgpzd2encodezd2)); 
BGl_modulezd2initializa7ationz75zz__openpgpzd2packetszd2(((long)485669724), 
BSTRING_TO_STRING(BGl_string2493z00zz__openpgpzd2encodezd2)); 
BGl_modulezd2initializa7ationz75zz__openpgpzd2humanzd2(((long)524611842), 
BSTRING_TO_STRING(BGl_string2493z00zz__openpgpzd2encodezd2)); 
BGl_modulezd2initializa7ationz75zz__openpgpzd2enumszd2(((long)520811633), 
BSTRING_TO_STRING(BGl_string2493z00zz__openpgpzd2encodezd2)); 
return 
BGl_modulezd2initializa7ationz75zz__openpgpzd2s2kzd2(((long)249755061), 
BSTRING_TO_STRING(BGl_string2493z00zz__openpgpzd2encodezd2));} 

}

#ifdef __cplusplus
}
#endif
