/*===========================================================================*/
/*   (Llib/pgp_packets.scm)                                                  */
/*   Bigloo (4.3h)                                                           */
/*   Inria -- Sophia Antipolis (c)       Tue 12 May 2020 08:36:09 AM CEST    */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.3h/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.3h/lib/bigloo/4.3h -I Llib -lib-dir /builddir/build/BUILD/bigloo-4.3h/lib/bigloo/4.3h -fno-reflection -unsafe -safee -copt -fPIC -copt -IPosix Llib/pgp_packets.scm -o objs/pgp_packets.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_pgpzd2packetzd2_bgl {
   header_t header;
   obj_t widening;
} *BgL_pgpzd2packetzd2_bglt;

typedef struct BgL_pgpzd2sessionzd2keyzd2packetzd2_bgl {
   header_t header;
   obj_t widening;
} *BgL_pgpzd2sessionzd2keyzd2packetzd2_bglt;

typedef struct BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_versionz00;
   obj_t BgL_idz00;
   obj_t BgL_algoz00;
   obj_t BgL_encryptedzd2sessionzd2keyz00;
} *BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt;

typedef struct BgL_pgpzd2sigzd2packetz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_versionz00;
   obj_t BgL_signaturezd2typezd2;
   obj_t BgL_issuerz00;
   obj_t BgL_publiczd2keyzd2algoz00;
   obj_t BgL_hashzd2algozd2;
} *BgL_pgpzd2sigzd2packetz00_bglt;

typedef struct BgL_pgpzd2signaturezd2packetz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_versionz00;
   obj_t BgL_signaturezd2typezd2;
   obj_t BgL_issuerz00;
   obj_t BgL_publiczd2keyzd2algoz00;
   obj_t BgL_hashzd2algozd2;
   obj_t BgL_creationzd2datezd2;
   obj_t BgL_signaturez00;
   obj_t BgL_signedzd2packetzd2prefixz00;
   obj_t BgL_hashzd2trailerzd2;
   obj_t BgL_leftzd2hashzd2;
} *BgL_pgpzd2signaturezd2packetz00_bglt;

typedef struct BgL_pgpzd2signaturezd2v3zd2packetzd2_bgl {
   header_t header;
   obj_t widening;
   long BgL_versionz00;
   obj_t BgL_signaturezd2typezd2;
   obj_t BgL_issuerz00;
   obj_t BgL_publiczd2keyzd2algoz00;
   obj_t BgL_hashzd2algozd2;
   obj_t BgL_creationzd2datezd2;
   obj_t BgL_signaturez00;
   obj_t BgL_signedzd2packetzd2prefixz00;
   obj_t BgL_hashzd2trailerzd2;
   obj_t BgL_leftzd2hashzd2;
} *BgL_pgpzd2signaturezd2v3zd2packetzd2_bglt;

typedef struct BgL_pgpzd2signaturezd2v4zd2packetzd2_bgl {
   header_t header;
   obj_t widening;
   long BgL_versionz00;
   obj_t BgL_signaturezd2typezd2;
   obj_t BgL_issuerz00;
   obj_t BgL_publiczd2keyzd2algoz00;
   obj_t BgL_hashzd2algozd2;
   obj_t BgL_creationzd2datezd2;
   obj_t BgL_signaturez00;
   obj_t BgL_signedzd2packetzd2prefixz00;
   obj_t BgL_hashzd2trailerzd2;
   obj_t BgL_leftzd2hashzd2;
   obj_t BgL_securezd2subzd2packetsz00;
   obj_t BgL_insecurezd2subzd2packetsz00;
} *BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt;

typedef struct BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_versionz00;
   obj_t BgL_algoz00;
   obj_t BgL_s2kz00;
   obj_t BgL_encryptedzd2sessionzd2keyz00;
} *BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt;

typedef struct BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_versionz00;
   obj_t BgL_signaturezd2typezd2;
   obj_t BgL_issuerz00;
   obj_t BgL_publiczd2keyzd2algoz00;
   obj_t BgL_hashzd2algozd2;
   bool_t BgL_containszd2nestedzd2sigzf3zf3;
} *BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bglt;

typedef struct BgL_pgpzd2keyzd2packetz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   long BgL_versionz00;
   bool_t BgL_subkeyzf3zf3;
   obj_t BgL_algoz00;
   obj_t BgL_creationzd2datezd2;
   obj_t BgL_validzd2dayszd2;
   obj_t BgL_keyz00;
} *BgL_pgpzd2keyzd2packetz00_bglt;

typedef struct BgL_pgpzd2publiczd2keyzd2packetzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   long BgL_versionz00;
   bool_t BgL_subkeyzf3zf3;
   obj_t BgL_algoz00;
   obj_t BgL_creationzd2datezd2;
   obj_t BgL_validzd2dayszd2;
   obj_t BgL_keyz00;
} *BgL_pgpzd2publiczd2keyzd2packetzd2_bglt;

typedef struct BgL_pgpzd2secretzd2keyzd2packetzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   long BgL_versionz00;
   bool_t BgL_subkeyzf3zf3;
   obj_t BgL_algoz00;
   obj_t BgL_creationzd2datezd2;
   obj_t BgL_validzd2dayszd2;
   obj_t BgL_keyz00;
   obj_t BgL_passwordzd2protectedzd2secretzd2keyzd2dataz00;
} *BgL_pgpzd2secretzd2keyzd2packetzd2_bglt;

typedef struct BgL_pgpzd2secretzd2keyzd2decodedzd2packetz00_bgl {
   obj_t BgL_secretzd2keyzd2;
} *BgL_pgpzd2secretzd2keyzd2decodedzd2packetz00_bglt;

typedef struct BgL_pgpzd2compressedzd2packetz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_packetsz00;
} *BgL_pgpzd2compressedzd2packetz00_bglt;

typedef struct BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_dataz00;
} *BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt;

typedef struct BgL_pgpzd2markerzd2packetz00_bgl {
   header_t header;
   obj_t widening;
} *BgL_pgpzd2markerzd2packetz00_bglt;

typedef struct BgL_pgpzd2literalzd2packetz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_formatz00;
   bool_t BgL_forzd2yourzd2eyeszd2onlyzf3z21;
   obj_t BgL_filezd2namezd2;
   obj_t BgL_creationzd2datezd2;
   obj_t BgL_dataz00;
} *BgL_pgpzd2literalzd2packetz00_bglt;

typedef struct BgL_pgpzd2trustzd2packetz00_bgl {
   header_t header;
   obj_t widening;
} *BgL_pgpzd2trustzd2packetz00_bglt;

typedef struct BgL_pgpzd2idzd2packetz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_dataz00;
} *BgL_pgpzd2idzd2packetz00_bglt;

typedef struct BgL_pgpzd2attributezd2packetz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_dataz00;
} *BgL_pgpzd2attributezd2packetz00_bglt;

typedef struct BgL_pgpzd2mdczd2symmetricallyzd2encryptedzd2packetz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_dataz00;
   long BgL_versionz00;
} *BgL_pgpzd2mdczd2symmetricallyzd2encryptedzd2packetz00_bglt;

typedef struct BgL_pgpzd2mdczd2packetz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_hashz00;
} *BgL_pgpzd2mdczd2packetz00_bglt;

typedef struct BgL_pgpzd2signaturezd2subzd2packetzd2_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_criticalzf3zf3;
} *BgL_pgpzd2signaturezd2subzd2packetzd2_bglt;

typedef struct BgL_pgpzd2signaturezd2subzd2genericzd2_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_criticalzf3zf3;
   obj_t BgL_typez00;
   obj_t BgL_dataz00;
} *BgL_pgpzd2signaturezd2subzd2genericzd2_bglt;

typedef struct BgL_pgpzd2signaturezd2subzd2creationzd2timez00_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_criticalzf3zf3;
   obj_t BgL_creationzd2datezd2;
} *BgL_pgpzd2signaturezd2subzd2creationzd2timez00_bglt;

typedef struct BgL_pgpzd2signaturezd2subzd2expirationzd2timez00_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_criticalzf3zf3;
   obj_t BgL_expirationzd2datezd2;
} *BgL_pgpzd2signaturezd2subzd2expirationzd2timez00_bglt;

typedef struct BgL_pgpzd2signaturezd2subzd2exportablezd2_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_criticalzf3zf3;
   bool_t BgL_exportablezf3zf3;
} *BgL_pgpzd2signaturezd2subzd2exportablezd2_bglt;

typedef struct BgL_pgpzd2signaturezd2subzd2trustzd2_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_criticalzf3zf3;
   int BgL_levelz00;
   int BgL_amountz00;
} *BgL_pgpzd2signaturezd2subzd2trustzd2_bglt;

typedef struct BgL_pgpzd2signaturezd2subzd2revocablezd2_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_criticalzf3zf3;
   bool_t BgL_revocablezf3zf3;
} *BgL_pgpzd2signaturezd2subzd2revocablezd2_bglt;

typedef struct BgL_pgpzd2signaturezd2subzd2keyzd2expirationzd2timezd2_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_criticalzf3zf3;
   long BgL_expirationzd2timezd2;
} *BgL_pgpzd2signaturezd2subzd2keyzd2expirationzd2timezd2_bglt;

typedef struct BgL_pgpzd2signaturezd2subzd2preferredzd2symmetricz00_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_criticalzf3zf3;
   obj_t BgL_algosz00;
} *BgL_pgpzd2signaturezd2subzd2preferredzd2symmetricz00_bglt;

typedef struct BgL_pgpzd2signaturezd2subzd2revocationzd2_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_criticalzf3zf3;
   char BgL_claza7za7z00;
   bool_t BgL_sensitivezf3zf3;
   char BgL_algidz00;
   obj_t BgL_fingerprintz00;
} *BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt;

typedef struct BgL_pgpzd2signaturezd2subzd2idzd2_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_criticalzf3zf3;
   obj_t BgL_keyzd2idzd2;
} *BgL_pgpzd2signaturezd2subzd2idzd2_bglt;

typedef struct BgL_pgpzd2signaturezd2subzd2notationzd2_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_criticalzf3zf3;
   obj_t BgL_flagsz00;
   obj_t BgL_namez00;
   obj_t BgL_valuez00;
} *BgL_pgpzd2signaturezd2subzd2notationzd2_bglt;

typedef struct BgL_pgpzd2signaturezd2subzd2preferredzd2hashz00_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_criticalzf3zf3;
   obj_t BgL_algosz00;
} *BgL_pgpzd2signaturezd2subzd2preferredzd2hashz00_bglt;

typedef struct BgL_pgpzd2signaturezd2subzd2preferredzd2compressionz00_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_criticalzf3zf3;
   obj_t BgL_algosz00;
} *BgL_pgpzd2signaturezd2subzd2preferredzd2compressionz00_bglt;

typedef struct BgL_pgpzd2signaturezd2subzd2preferredzd2keyzd2serverzd2_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_criticalzf3zf3;
   obj_t BgL_serverz00;
} *BgL_pgpzd2signaturezd2subzd2preferredzd2keyzd2serverzd2_bglt;

typedef struct BgL_pgpzd2signaturezd2subzd2primaryzd2idz00_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_criticalzf3zf3;
   bool_t BgL_primaryzf3zf3;
} *BgL_pgpzd2signaturezd2subzd2primaryzd2idz00_bglt;

typedef struct BgL_pgpzd2signaturezd2subzd2policyzd2_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_criticalzf3zf3;
   obj_t BgL_urlz00;
} *BgL_pgpzd2signaturezd2subzd2policyzd2_bglt;

typedef struct BgL_pgpzd2signaturezd2subzd2signerzd2idz00_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_criticalzf3zf3;
   obj_t BgL_idz00;
} *BgL_pgpzd2signaturezd2subzd2signerzd2idz00_bglt;

typedef struct BgL_pgpzd2signaturezd2subzd2revocationzd2reasonz00_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_criticalzf3zf3;
   obj_t BgL_codez00;
   obj_t BgL_reasonz00;
} *BgL_pgpzd2signaturezd2subzd2revocationzd2reasonz00_bglt;


static obj_t BGl_z62lambda1765z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static BgL_pgpzd2secretzd2keyzd2packetzd2_bglt BGl_z62lambda1927z62zz__openpgpzd2packetszd2(obj_t);
static obj_t BGl_z62lambda1769z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda1770z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31919ze3ze5zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda1933z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda1934z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1774z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda1775z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1779z62zz__openpgpzd2packetszd2(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Signaturezd2Subzd2Keyzd2Expirationzd2Timezd2zz__openpgpzd2packetszd2 = BUNSPEC;
static BgL_pgpzd2secretzd2keyzd2packetzd2_bglt BGl_z62lambda1941z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31685ze3ze5zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda1780z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static BgL_pgpzd2secretzd2keyzd2packetzd2_bglt BGl_z62lambda1944z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda1784z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda1785z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static BgL_pgpzd2secretzd2keyzd2packetzd2_bglt BGl_z62lambda1947z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static BgL_pgpzd2signaturezd2v3zd2packetzd2_bglt BGl_z62lambda1791z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1954z62zz__openpgpzd2packetszd2(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Signaturezd2Subzd2Policyzd2zz__openpgpzd2packetszd2 = BUNSPEC;
static BgL_pgpzd2signaturezd2v3zd2packetzd2_bglt BGl_z62lambda1793z62zz__openpgpzd2packetszd2(obj_t);
static obj_t BGl_z62lambda1955z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Signaturezd2Subzd2Notationzd2zz__openpgpzd2packetszd2 = BUNSPEC;
static BgL_pgpzd2compressedzd2packetz00_bglt BGl_z62lambda1961z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static BgL_pgpzd2compressedzd2packetz00_bglt BGl_z62lambda1963z62zz__openpgpzd2packetszd2(obj_t);
static obj_t BGl_z62lambda1969z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda1970z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt BGl_z62lambda1976z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt BGl_z62lambda1978z62zz__openpgpzd2packetszd2(obj_t);
static obj_t BGl_z62lambda1984z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda1985z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Signaturezd2Subzd2Genericzd2zz__openpgpzd2packetszd2 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Signaturezd2Subzd2Preferredzd2Compressionz00zz__openpgpzd2packetszd2 = BUNSPEC;
static obj_t BGl_objectzd2initzd2zz__openpgpzd2packetszd2();
static obj_t BGl_z62zc3z04anonymousza31795ze3ze5zz__openpgpzd2packetszd2(obj_t, obj_t);
static BgL_pgpzd2markerzd2packetz00_bglt BGl_z62lambda1991z62zz__openpgpzd2packetszd2(obj_t);
static BgL_pgpzd2markerzd2packetz00_bglt BGl_z62lambda1993z62zz__openpgpzd2packetszd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32050ze3ze5zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32213ze3ze5zz__openpgpzd2packetszd2(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Keyzd2Packetz00zz__openpgpzd2packetszd2 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32303ze3ze5zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__openpgpzd2packetszd2();
static obj_t BGl_z62zc3z04anonymousza31889ze3ze5zz__openpgpzd2packetszd2(obj_t);
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Signaturezd2Subzd2Expirationzd2Timez00zz__openpgpzd2packetszd2 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32127ze3ze5zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31995ze3ze5zz__openpgpzd2packetszd2(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Signaturezd2Subzd2Creationzd2Timez00zz__openpgpzd2packetszd2 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Signaturezd2Subzd2Trustzd2zz__openpgpzd2packetszd2 = BUNSPEC;
static obj_t BGl_z62lambda2100z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32163ze3ze5zz__openpgpzd2packetszd2(obj_t, obj_t);
static BgL_pgpzd2signaturezd2subzd2packetzd2_bglt BGl_z62lambda2106z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static BgL_pgpzd2signaturezd2subzd2packetzd2_bglt BGl_z62lambda2108z62zz__openpgpzd2packetszd2(obj_t);
static obj_t BGl_z62lambda2115z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda2116z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32148ze3ze5zz__openpgpzd2packetszd2(obj_t, obj_t);
static BgL_pgpzd2signaturezd2subzd2genericzd2_bglt BGl_z62lambda2123z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32343ze3ze5zz__openpgpzd2packetszd2(obj_t, obj_t);
static BgL_pgpzd2signaturezd2subzd2genericzd2_bglt BGl_z62lambda2125z62zz__openpgpzd2packetszd2(obj_t);
BGL_IMPORT obj_t bgl_nanoseconds_to_date(BGL_LONGLONG_T);
static obj_t BGl_z62lambda2131z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda2132z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32328ze3ze5zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda2136z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda2137z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Signaturezd2v4zd2Packetzd2zz__openpgpzd2packetszd2 = BUNSPEC;
static BgL_pgpzd2signaturezd2subzd2notationzd2_bglt BGl_z62lambda2301z62zz__openpgpzd2packetszd2(obj_t);
static BgL_pgpzd2signaturezd2subzd2creationzd2timez00_bglt BGl_z62lambda2143z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32418ze3ze5zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda2307z62zz__openpgpzd2packetszd2(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Signaturezd2Subzd2Preferredzd2Symmetricz00zz__openpgpzd2packetszd2 = BUNSPEC;
static BgL_pgpzd2signaturezd2subzd2creationzd2timez00_bglt BGl_z62lambda2146z62zz__openpgpzd2packetszd2(obj_t);
static obj_t BGl_z62lambda2308z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Signaturezd2Subzd2Revocablezd2zz__openpgpzd2packetszd2 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Signaturezd2Subzd2Packetzd2zz__openpgpzd2packetszd2 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Signaturezd2Subzd2Revocationzd2zz__openpgpzd2packetszd2 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Literalzd2Packetz00zz__openpgpzd2packetszd2 = BUNSPEC;
static obj_t BGl_z62lambda2312z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda2313z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2152z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda2153z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32095ze3ze5zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda2317z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda2318z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static BgL_pgpzd2signaturezd2subzd2expirationzd2timez00_bglt BGl_z62lambda2159z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Signaturezd2Subzd2Preferredzd2Hashz00zz__openpgpzd2packetszd2 = BUNSPEC;
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__openpgpzd2packetszd2();
static BgL_pgpzd2signaturezd2subzd2expirationzd2timez00_bglt BGl_z62lambda2161z62zz__openpgpzd2packetszd2(obj_t);
static BgL_pgpzd2signaturezd2subzd2preferredzd2hashz00_bglt BGl_z62lambda2324z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32258ze3ze5zz__openpgpzd2packetszd2(obj_t, obj_t);
static BgL_pgpzd2signaturezd2subzd2preferredzd2hashz00_bglt BGl_z62lambda2326z62zz__openpgpzd2packetszd2(obj_t);
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Secretzd2Keyzd2Packetzd2zz__openpgpzd2packetszd2 = BUNSPEC;
static obj_t BGl_z62lambda2167z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda2168z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_PGPzd2MDCzd2Packetz00zz__openpgpzd2packetszd2 = BUNSPEC;
static obj_t BGl_z62lambda2332z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda2333z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static BgL_pgpzd2signaturezd2subzd2exportablezd2_bglt BGl_z62lambda2174z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static BgL_pgpzd2signaturezd2subzd2exportablezd2_bglt BGl_z62lambda2176z62zz__openpgpzd2packetszd2(obj_t);
static BgL_pgpzd2signaturezd2subzd2preferredzd2compressionz00_bglt BGl_z62lambda2339z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static BgL_pgpzd2signaturezd2subzd2preferredzd2compressionz00_bglt BGl_z62lambda2341z62zz__openpgpzd2packetszd2(obj_t);
static BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt BGl_z62lambda1614z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2182z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda2183z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt BGl_z62lambda1617z62zz__openpgpzd2packetszd2(obj_t);
static obj_t BGl_z62lambda2347z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda2348z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static BgL_pgpzd2signaturezd2subzd2trustzd2_bglt BGl_z62lambda2189z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31580ze3ze5zz__openpgpzd2packetszd2(obj_t, obj_t);
static BgL_pgpzd2signaturezd2subzd2trustzd2_bglt BGl_z62lambda2191z62zz__openpgpzd2packetszd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza31548ze3ze5zz__openpgpzd2packetszd2(obj_t, obj_t);
static BgL_pgpzd2signaturezd2subzd2preferredzd2keyzd2serverzd2_bglt BGl_z62lambda2354z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static BgL_pgpzd2signaturezd2subzd2preferredzd2keyzd2serverzd2_bglt BGl_z62lambda2356z62zz__openpgpzd2packetszd2(obj_t);
static obj_t BGl_z62lambda2197z62zz__openpgpzd2packetszd2(obj_t, obj_t);
BGL_IMPORT BGL_LONGLONG_T bgl_current_nanoseconds();
static obj_t BGl_z62lambda2198z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Secretzd2Keyzd2Decodedzd2Packetz00zz__openpgpzd2packetszd2 = BUNSPEC;
static obj_t BGl_z62lambda2362z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda2363z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static BgL_pgpzd2signaturezd2subzd2primaryzd2idz00_bglt BGl_z62lambda2369z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Trustzd2Packetz00zz__openpgpzd2packetszd2 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Signaturezd2Subzd2Exportablezd2zz__openpgpzd2packetszd2 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31760ze3ze5zz__openpgpzd2packetszd2(obj_t, obj_t);
static BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt BGl_z62lambda1801z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt BGl_z62lambda1803z62zz__openpgpzd2packetszd2(obj_t);
static BgL_pgpzd2signaturezd2subzd2primaryzd2idz00_bglt BGl_z62lambda2371z62zz__openpgpzd2packetszd2(obj_t);
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Signaturezd2Subzd2IDzd2zz__openpgpzd2packetszd2 = BUNSPEC;
static obj_t BGl_z62lambda1646z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda1647z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1809z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda2377z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda2378z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1810z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1814z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda1815z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static BgL_pgpzd2signaturezd2subzd2policyzd2_bglt BGl_z62lambda2384z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1656z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda1657z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static BgL_pgpzd2signaturezd2subzd2policyzd2_bglt BGl_z62lambda2386z62zz__openpgpzd2packetszd2(obj_t);
static BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt BGl_z62lambda1821z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt BGl_z62lambda1823z62zz__openpgpzd2packetszd2(obj_t);
static obj_t BGl_z62lambda1663z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda2392z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda1664z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2393z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1829z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static BgL_pgpzd2signaturezd2subzd2signerzd2idz00_bglt BGl_z62lambda2399z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1830z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1670z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda1671z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1834z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda1835z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1839z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda1840z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static BgL_pgpzd2sigzd2packetz00_bglt BGl_z62lambda1681z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1844z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32388ze3ze5zz__openpgpzd2packetszd2(obj_t, obj_t);
static BgL_pgpzd2sigzd2packetz00_bglt BGl_z62lambda1683z62zz__openpgpzd2packetszd2(obj_t);
static obj_t BGl_z62lambda1845z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31870ze3ze5zz__openpgpzd2packetszd2(obj_t, obj_t);
static BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bglt BGl_z62lambda1851z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bglt BGl_z62lambda1853z62zz__openpgpzd2packetszd2(obj_t);
static obj_t BGl_z62lambda1694z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda1695z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1859z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda1699z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zz__openpgpzd2packetszd2 = BUNSPEC;
static obj_t BGl_z62lambda1860z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31855ze3ze5zz__openpgpzd2packetszd2(obj_t, obj_t);
static BgL_pgpzd2keyzd2packetz00_bglt BGl_z62lambda1866z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_pgpzd2keyzd2packetz00_bglt BGl_z62lambda1868z62zz__openpgpzd2packetszd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza31929ze3ze5zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda1875z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda1876z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_za2classesza2z00zz__objectz00;
static obj_t BGl_z62zc3z04anonymousza32110ze3ze5zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32005ze3ze5zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31946ze3ze5zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda1881z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda1882z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1887z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda1888z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Signaturezd2Subzd2Signerzd2IDz00zz__openpgpzd2packetszd2 = BUNSPEC;
static obj_t BGl_toplevelzd2initzd2zz__openpgpzd2packetszd2();
static obj_t BGl_z62lambda1893z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda1894z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1898z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda1899z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31980ze3ze5zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_genericzd2initzd2zz__openpgpzd2packetszd2();
static obj_t BGl_z62zc3z04anonymousza32040ze3ze5zz__openpgpzd2packetszd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t, bool_t, bool_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31965ze3ze5zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31877ze3ze5zz__openpgpzd2packetszd2(obj_t);
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Markerzd2Packetz00zz__openpgpzd2packetszd2 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Compressedzd2Packetz00zz__openpgpzd2packetszd2 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Sessionzd2Keyzd2Packetzd2zz__openpgpzd2packetszd2 = BUNSPEC;
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32117ze3ze5zz__openpgpzd2packetszd2(obj_t);
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Signaturezd2Subzd2Primaryzd2IDz00zz__openpgpzd2packetszd2 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Signaturezd2v3zd2Packetzd2zz__openpgpzd2packetszd2 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32403ze3ze5zz__openpgpzd2packetszd2(obj_t, obj_t);
static BgL_pgpzd2literalzd2packetz00_bglt BGl_z62lambda2001z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_pgpzd2literalzd2packetz00_bglt BGl_z62lambda2003z62zz__openpgpzd2packetszd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32080ze3ze5zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda2009z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda2010z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2014z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32243ze3ze5zz__openpgpzd2packetszd2(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Publiczd2Keyzd2Packetzd2zz__openpgpzd2packetszd2 = BUNSPEC;
static obj_t BGl_z62lambda2015z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32065ze3ze5zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda2019z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda2020z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2024z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda2025z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32228ze3ze5zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda2029z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda2030z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Symmetriczd2Keyzd2Encryptedzd2Sessionzd2Keyzd2Packetz00zz__openpgpzd2packetszd2 = BUNSPEC;
static BgL_pgpzd2trustzd2packetz00_bglt BGl_z62lambda2036z62zz__openpgpzd2packetszd2(obj_t);
static BgL_pgpzd2trustzd2packetz00_bglt BGl_z62lambda2038z62zz__openpgpzd2packetszd2(obj_t);
static obj_t BGl_z62lambda2202z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31622ze3ze5zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda2203z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static BgL_pgpzd2idzd2packetz00_bglt BGl_z62lambda2046z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static BgL_pgpzd2signaturezd2subzd2revocablezd2_bglt BGl_z62lambda2209z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static BgL_pgpzd2idzd2packetz00_bglt BGl_z62lambda2048z62zz__openpgpzd2packetszd2(obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__openpgpzd2packetszd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__datez00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Packetzd2zz__openpgpzd2packetszd2 = BUNSPEC;
static BgL_pgpzd2signaturezd2subzd2revocablezd2_bglt BGl_z62lambda2211z62zz__openpgpzd2packetszd2(obj_t);
static obj_t BGl_z62lambda2054z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda2055z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2217z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda2218z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Sigzd2Packetz00zz__openpgpzd2packetszd2 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Attributezd2Packetz00zz__openpgpzd2packetszd2 = BUNSPEC;
static BgL_pgpzd2attributezd2packetz00_bglt BGl_z62lambda2061z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static BgL_pgpzd2signaturezd2subzd2keyzd2expirationzd2timezd2_bglt BGl_z62lambda2224z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static BgL_pgpzd2attributezd2packetz00_bglt BGl_z62lambda2063z62zz__openpgpzd2packetszd2(obj_t);
static BgL_pgpzd2signaturezd2subzd2keyzd2expirationzd2timezd2_bglt BGl_z62lambda2226z62zz__openpgpzd2packetszd2(obj_t);
static obj_t BGl_z62lambda2069z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda2070z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2232z62zz__openpgpzd2packetszd2(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Publiczd2Keyzd2Encryptedzd2Sessionzd2Keyzd2Packetz00zz__openpgpzd2packetszd2 = BUNSPEC;
static obj_t BGl_z62lambda2233z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static BgL_pgpzd2mdczd2symmetricallyzd2encryptedzd2packetz00_bglt BGl_z62lambda2076z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static BgL_pgpzd2signaturezd2subzd2preferredzd2symmetricz00_bglt BGl_z62lambda2239z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static BgL_pgpzd2mdczd2symmetricallyzd2encryptedzd2packetz00_bglt BGl_z62lambda2078z62zz__openpgpzd2packetszd2(obj_t);
static obj_t BGl_cnstzd2initzd2zz__openpgpzd2packetszd2();
static obj_t BGl_libraryzd2moduleszd2initz00zz__openpgpzd2packetszd2();
BGL_EXPORTED_DEF obj_t BGl_PGPzd2IDzd2Packetz00zz__openpgpzd2packetszd2 = BUNSPEC;
static BgL_pgpzd2signaturezd2subzd2signerzd2idz00_bglt BGl_z62lambda2401z62zz__openpgpzd2packetszd2(obj_t);
static BgL_pgpzd2signaturezd2subzd2preferredzd2symmetricz00_bglt BGl_z62lambda2241z62zz__openpgpzd2packetszd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32193ze3ze5zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda2407z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda2084z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda2408z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2085z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2247z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda2248z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_PGPzd2MDCzd2Symmetricallyzd2Encryptedzd2Packetz00zz__openpgpzd2packetszd2 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31805ze3ze5zz__openpgpzd2packetszd2(obj_t, obj_t);
static BgL_pgpzd2signaturezd2subzd2revocationzd2reasonz00_bglt BGl_z62lambda2414z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t, obj_t);
static BgL_pgpzd2mdczd2packetz00_bglt BGl_z62lambda2091z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt BGl_z62lambda2254z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_pgpzd2signaturezd2subzd2revocationzd2reasonz00_bglt BGl_z62lambda2416z62zz__openpgpzd2packetszd2(obj_t);
static BgL_pgpzd2mdczd2packetz00_bglt BGl_z62lambda2093z62zz__openpgpzd2packetszd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32178ze3ze5zz__openpgpzd2packetszd2(obj_t, obj_t);
static BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt BGl_z62lambda2256z62zz__openpgpzd2packetszd2(obj_t);
BGL_IMPORT obj_t BGl_objectz00zz__objectz00;
static obj_t BGl_z62lambda2099z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda2422z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32373ze3ze5zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda2423z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2262z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda2263z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2427z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda2428z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static BgL_pgpzd2packetzd2_bglt BGl_z62lambda1538z62zz__openpgpzd2packetszd2(obj_t);
static obj_t BGl_z62lambda2267z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda2268z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1700z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2272z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda2273z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32358ze3ze5zz__openpgpzd2packetszd2(obj_t, obj_t);
static BgL_pgpzd2packetzd2_bglt BGl_z62lambda1546z62zz__openpgpzd2packetszd2(obj_t);
static obj_t BGl_z62lambda1709z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda2277z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda2278z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Onezd2Passzd2Signaturezd2Packetz00zz__openpgpzd2packetszd2 = BUNSPEC;
static obj_t BGl_z62lambda1710z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static BgL_pgpzd2signaturezd2subzd2idzd2_bglt BGl_z62lambda2284z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static BgL_pgpzd2signaturezd2subzd2idzd2_bglt BGl_z62lambda2286z62zz__openpgpzd2packetszd2(obj_t);
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Symmetricallyzd2Encryptedzd2Packetzd2zz__openpgpzd2packetszd2 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Signaturezd2Packetz00zz__openpgpzd2packetszd2 = BUNSPEC;
static obj_t BGl_z62lambda1720z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda1721z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31825ze3ze5zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda2292z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda2293z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static BgL_pgpzd2signaturezd2subzd2notationzd2_bglt BGl_z62lambda2299z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2superzd2zz__objectz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32288ze3ze5zz__openpgpzd2packetszd2(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Signaturezd2Subzd2Revocationzd2Reasonz00zz__openpgpzd2packetszd2 = BUNSPEC;
static BgL_pgpzd2sessionzd2keyzd2packetzd2_bglt BGl_z62lambda1578z62zz__openpgpzd2packetszd2(obj_t);
static obj_t BGl_z62lambda1741z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda1903z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda1742z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1904z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1908z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t BGl_z62lambda1909z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t);
static BgL_pgpzd2publiczd2keyzd2packetzd2_bglt BGl_z62lambda1915z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_pgpzd2publiczd2keyzd2packetzd2_bglt BGl_z62lambda1917z62zz__openpgpzd2packetszd2(obj_t);
static BgL_pgpzd2signaturezd2packetz00_bglt BGl_z62lambda1756z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_pgpzd2signaturezd2packetz00_bglt BGl_z62lambda1758z62zz__openpgpzd2packetszd2(obj_t);
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Signaturezd2Subzd2Preferredzd2Keyzd2Serverzd2zz__openpgpzd2packetszd2 = BUNSPEC;
static BgL_pgpzd2secretzd2keyzd2packetzd2_bglt BGl_z62lambda1925z62zz__openpgpzd2packetszd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1764z62zz__openpgpzd2packetszd2(obj_t, obj_t);
static obj_t __cnst[ 102 ] ;


DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2600z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1894za7622791z00, BGl_z62lambda1894z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2601z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1893za7622792z00, BGl_z62lambda1893z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2602z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1899za7622793z00, BGl_z62lambda1899z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2603z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1898za7622794z00, BGl_z62lambda1898z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2604z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1904za7622795z00, BGl_z62lambda1904z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2605z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1903za7622796z00, BGl_z62lambda1903z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2606z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1909za7622797z00, BGl_z62lambda1909z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2607z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1908za7622798z00, BGl_z62lambda1908z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2608z00zz__openpgpzd2packetszd2, BgL_bgl_za762za7c3za704anonymo2799za7, BGl_z62zc3z04anonymousza31870ze3ze5zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2609z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1868za7622800z00, BGl_z62lambda1868z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2610z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1866za7622801z00, BGl_z62lambda1866z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2611z00zz__openpgpzd2packetszd2, BgL_bgl_za762za7c3za704anonymo2802za7, BGl_z62zc3z04anonymousza31919ze3ze5zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2612z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1917za7622803z00, BGl_z62lambda1917z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2613z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1915za7622804z00, BGl_z62lambda1915z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2614z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1934za7622805z00, BGl_z62lambda1934z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2615z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1933za7622806z00, BGl_z62lambda1933z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2616z00zz__openpgpzd2packetszd2, BgL_bgl_za762za7c3za704anonymo2807za7, BGl_z62zc3z04anonymousza31929ze3ze5zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2617z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1927za7622808z00, BGl_z62lambda1927z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2618z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1925za7622809z00, BGl_z62lambda1925z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 8 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2619z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1955za7622810z00, BGl_z62lambda1955z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2620z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1954za7622811z00, BGl_z62lambda1954z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2621z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1947za7622812z00, BGl_z62lambda1947z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2622z00zz__openpgpzd2packetszd2, BgL_bgl_za762za7c3za704anonymo2813za7, BGl_z62zc3z04anonymousza31946ze3ze5zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2623z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1944za7622814z00, BGl_z62lambda1944z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2624z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1941za7622815z00, BGl_z62lambda1941z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 9 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2625z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1970za7622816z00, BGl_z62lambda1970z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2626z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1969za7622817z00, BGl_z62lambda1969z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2627z00zz__openpgpzd2packetszd2, BgL_bgl_za762za7c3za704anonymo2818za7, BGl_z62zc3z04anonymousza31965ze3ze5zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2628z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1963za7622819z00, BGl_z62lambda1963z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2629z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1961za7622820z00, BGl_z62lambda1961z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2630z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1985za7622821z00, BGl_z62lambda1985z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2631z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1984za7622822z00, BGl_z62lambda1984z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2632z00zz__openpgpzd2packetszd2, BgL_bgl_za762za7c3za704anonymo2823za7, BGl_z62zc3z04anonymousza31980ze3ze5zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2633z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1978za7622824z00, BGl_z62lambda1978z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2634z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1976za7622825z00, BGl_z62lambda1976z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2635z00zz__openpgpzd2packetszd2, BgL_bgl_za762za7c3za704anonymo2826za7, BGl_z62zc3z04anonymousza31995ze3ze5zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2636z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1993za7622827z00, BGl_z62lambda1993z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2637z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1991za7622828z00, BGl_z62lambda1991z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2638z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2010za7622829z00, BGl_z62lambda2010z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2639z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2009za7622830z00, BGl_z62lambda2009z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2640z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2015za7622831z00, BGl_z62lambda2015z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2641z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2014za7622832z00, BGl_z62lambda2014z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2642z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2020za7622833z00, BGl_z62lambda2020z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2643z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2019za7622834z00, BGl_z62lambda2019z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2644z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2025za7622835z00, BGl_z62lambda2025z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2645z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2024za7622836z00, BGl_z62lambda2024z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2646z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2030za7622837z00, BGl_z62lambda2030z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2647z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2029za7622838z00, BGl_z62lambda2029z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2648z00zz__openpgpzd2packetszd2, BgL_bgl_za762za7c3za704anonymo2839za7, BGl_z62zc3z04anonymousza32005ze3ze5zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2649z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2003za7622840z00, BGl_z62lambda2003z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2650z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2001za7622841z00, BGl_z62lambda2001z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2651z00zz__openpgpzd2packetszd2, BgL_bgl_za762za7c3za704anonymo2842za7, BGl_z62zc3z04anonymousza32040ze3ze5zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2652z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2038za7622843z00, BGl_z62lambda2038z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2653z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2036za7622844z00, BGl_z62lambda2036z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2654z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2055za7622845z00, BGl_z62lambda2055z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2655z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2054za7622846z00, BGl_z62lambda2054z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2656z00zz__openpgpzd2packetszd2, BgL_bgl_za762za7c3za704anonymo2847za7, BGl_z62zc3z04anonymousza32050ze3ze5zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2657z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2048za7622848z00, BGl_z62lambda2048z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2658z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2046za7622849z00, BGl_z62lambda2046z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2659z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2070za7622850z00, BGl_z62lambda2070z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2660z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2069za7622851z00, BGl_z62lambda2069z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2661z00zz__openpgpzd2packetszd2, BgL_bgl_za762za7c3za704anonymo2852za7, BGl_z62zc3z04anonymousza32065ze3ze5zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2662z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2063za7622853z00, BGl_z62lambda2063z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2663z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2061za7622854z00, BGl_z62lambda2061z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2664z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2085za7622855z00, BGl_z62lambda2085z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2665z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2084za7622856z00, BGl_z62lambda2084z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2666z00zz__openpgpzd2packetszd2, BgL_bgl_za762za7c3za704anonymo2857za7, BGl_z62zc3z04anonymousza32080ze3ze5zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2667z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2078za7622858z00, BGl_z62lambda2078z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2668z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2076za7622859z00, BGl_z62lambda2076z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2669z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2100za7622860z00, BGl_z62lambda2100z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2670z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2099za7622861z00, BGl_z62lambda2099z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2671z00zz__openpgpzd2packetszd2, BgL_bgl_za762za7c3za704anonymo2862za7, BGl_z62zc3z04anonymousza32095ze3ze5zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2672z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2093za7622863z00, BGl_z62lambda2093z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2673z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2091za7622864z00, BGl_z62lambda2091z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2674z00zz__openpgpzd2packetszd2, BgL_bgl_za762za7c3za704anonymo2865za7, BGl_z62zc3z04anonymousza32117ze3ze5zz__openpgpzd2packetszd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2675z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2116za7622866z00, BGl_z62lambda2116z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2676z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2115za7622867z00, BGl_z62lambda2115z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2677z00zz__openpgpzd2packetszd2, BgL_bgl_za762za7c3za704anonymo2868za7, BGl_z62zc3z04anonymousza32110ze3ze5zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2678z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2108za7622869z00, BGl_z62lambda2108z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2679z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2106za7622870z00, BGl_z62lambda2106z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2680z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2132za7622871z00, BGl_z62lambda2132z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2681z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2131za7622872z00, BGl_z62lambda2131z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2682z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2137za7622873z00, BGl_z62lambda2137z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2683z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2136za7622874z00, BGl_z62lambda2136z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2684z00zz__openpgpzd2packetszd2, BgL_bgl_za762za7c3za704anonymo2875za7, BGl_z62zc3z04anonymousza32127ze3ze5zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2685z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2125za7622876z00, BGl_z62lambda2125z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2686z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2123za7622877z00, BGl_z62lambda2123z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2687z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2153za7622878z00, BGl_z62lambda2153z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2688z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2152za7622879z00, BGl_z62lambda2152z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2689z00zz__openpgpzd2packetszd2, BgL_bgl_za762za7c3za704anonymo2880za7, BGl_z62zc3z04anonymousza32148ze3ze5zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2690z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2146za7622881z00, BGl_z62lambda2146z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2691z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2143za7622882z00, BGl_z62lambda2143z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2692z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2168za7622883z00, BGl_z62lambda2168z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2693z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2167za7622884z00, BGl_z62lambda2167z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2694z00zz__openpgpzd2packetszd2, BgL_bgl_za762za7c3za704anonymo2885za7, BGl_z62zc3z04anonymousza32163ze3ze5zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2695z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2161za7622886z00, BGl_z62lambda2161z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2696z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2159za7622887z00, BGl_z62lambda2159z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2697z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2183za7622888z00, BGl_z62lambda2183z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2698z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2182za7622889z00, BGl_z62lambda2182z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2786z00zz__openpgpzd2packetszd2, BgL_bgl_string2786za700za7za7_2890za7, "", 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2699z00zz__openpgpzd2packetszd2, BgL_bgl_za762za7c3za704anonymo2891za7, BGl_z62zc3z04anonymousza32178ze3ze5zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2787z00zz__openpgpzd2packetszd2, BgL_bgl_string2787za700za7za7_2892za7, "_ PGP-Signature-Sub-Revocation-Reason reason code PGP-Signature-Sub-Signer-ID PGP-Signature-Sub-Policy url PGP-Signature-Sub-Primary-ID primary? PGP-Signature-Sub-Preferred-Key-Server server PGP-Signature-Sub-Preferred-Compression PGP-Signature-Sub-Preferred-Hash PGP-Signature-Sub-Notation value name flags PGP-Signature-Sub-ID key-id PGP-Signature-Sub-Revocation fingerprint algid sensitive? byte clazz PGP-Signature-Sub-Preferred-Symmetric algos PGP-Signature-Sub-Key-Expiration-Time expiration-time PGP-Signature-Sub-Revocable revocable? PGP-Signature-Sub-Trust amount int level PGP-Signature-Sub-Exportable exportable? PGP-Signature-Sub-Expiration-Time expiration-date PGP-Signature-Sub-Creation-Time PGP-Signature-Sub-Generic type PGP-Signature-Sub-Packet critical? PGP-MDC-Packet hash PGP-MDC-Symmetrically-Encrypted-Packet PGP-Attribute-Packet PGP-ID-Packet PGP-Trust-Packet PGP-Literal-Packet file-name for-your-eyes-only? format PGP-Marker-Packet PGP-Symmetrically-Encrypted-Packet data PGP-Compressed-Packet packe"
"ts PGP-Secret-Key-Decoded-Packet secret-key PGP-Secret-Key-Packet password-protected-secret-key-data PGP-Public-Key-Packet PGP-Key-Packet key valid-days subkey? PGP-One-Pass-Signature-Packet bool contains-nested-sig? PGP-Symmetric-Key-Encrypted-Session-Key-Packet s2k PGP-Signature-v4-Packet insecure-sub-packets pair-nil secure-sub-packets PGP-Signature-v3-Packet PGP-Signature-Packet left-hash hash-trailer signed-packet-prefix signature date creation-date PGP-Sig-Packet hash-algo public-key-algo issuer signature-type PGP-Public-Key-Encrypted-Session-Key-Packet obj encrypted-session-key symbol algo bstring id long version PGP-Session-Key-Packet __openpgp-packets PGP-Packet ", 1704 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2524z00zz__openpgpzd2packetszd2, BgL_bgl_za762za7c3za704anonymo2893za7, BGl_z62zc3z04anonymousza31548ze3ze5zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2525z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1546za7622894z00, BGl_z62lambda1546z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2526z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1538za7622895z00, BGl_z62lambda1538z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2527z00zz__openpgpzd2packetszd2, BgL_bgl_za762za7c3za704anonymo2896za7, BGl_z62zc3z04anonymousza31580ze3ze5zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2528z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1578za7622897z00, BGl_z62lambda1578z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2529z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1647za7622898z00, BGl_z62lambda1647z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2530z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1646za7622899z00, BGl_z62lambda1646z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2531z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1657za7622900z00, BGl_z62lambda1657z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2532z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1656za7622901z00, BGl_z62lambda1656z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2533z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1664za7622902z00, BGl_z62lambda1664z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2534z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1663za7622903z00, BGl_z62lambda1663z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2535z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1671za7622904z00, BGl_z62lambda1671z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2536z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1670za7622905z00, BGl_z62lambda1670z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2537z00zz__openpgpzd2packetszd2, BgL_bgl_za762za7c3za704anonymo2906za7, BGl_z62zc3z04anonymousza31622ze3ze5zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2538z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1617za7622907z00, BGl_z62lambda1617z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2539z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1614za7622908z00, BGl_z62lambda1614z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2700z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2176za7622909z00, BGl_z62lambda2176z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2701z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2174za7622910z00, BGl_z62lambda2174z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2702z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2198za7622911z00, BGl_z62lambda2198z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2540z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1695za7622912z00, BGl_z62lambda1695z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2703z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2197za7622913z00, BGl_z62lambda2197z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2541z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1694za7622914z00, BGl_z62lambda1694z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2704z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2203za7622915z00, BGl_z62lambda2203z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2542z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1700za7622916z00, BGl_z62lambda1700z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2705z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2202za7622917z00, BGl_z62lambda2202z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2543z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1699za7622918z00, BGl_z62lambda1699z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2706z00zz__openpgpzd2packetszd2, BgL_bgl_za762za7c3za704anonymo2919za7, BGl_z62zc3z04anonymousza32193ze3ze5zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2544z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1710za7622920z00, BGl_z62lambda1710z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2707z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2191za7622921z00, BGl_z62lambda2191z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2545z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1709za7622922z00, BGl_z62lambda1709z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2708z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2189za7622923z00, BGl_z62lambda2189z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2546z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1721za7622924z00, BGl_z62lambda1721z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2709z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2218za7622925z00, BGl_z62lambda2218z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2547z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1720za7622926z00, BGl_z62lambda1720z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2548z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1742za7622927z00, BGl_z62lambda1742z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2549z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1741za7622928z00, BGl_z62lambda1741z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2710z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2217za7622929z00, BGl_z62lambda2217z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2711z00zz__openpgpzd2packetszd2, BgL_bgl_za762za7c3za704anonymo2930za7, BGl_z62zc3z04anonymousza32213ze3ze5zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2712z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2211za7622931z00, BGl_z62lambda2211z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2550z00zz__openpgpzd2packetszd2, BgL_bgl_za762za7c3za704anonymo2932za7, BGl_z62zc3z04anonymousza31685ze3ze5zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2713z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2209za7622933z00, BGl_z62lambda2209z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2551z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1683za7622934z00, BGl_z62lambda1683z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2714z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2233za7622935z00, BGl_z62lambda2233z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2552z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1681za7622936z00, BGl_z62lambda1681z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2715z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2232za7622937z00, BGl_z62lambda2232z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2553z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1765za7622938z00, BGl_z62lambda1765z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2716z00zz__openpgpzd2packetszd2, BgL_bgl_za762za7c3za704anonymo2939za7, BGl_z62zc3z04anonymousza32228ze3ze5zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2554z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1764za7622940z00, BGl_z62lambda1764z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2717z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2226za7622941z00, BGl_z62lambda2226z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2555z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1770za7622942z00, BGl_z62lambda1770z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2718z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2224za7622943z00, BGl_z62lambda2224z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2556z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1769za7622944z00, BGl_z62lambda1769z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2719z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2248za7622945z00, BGl_z62lambda2248z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2557z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1775za7622946z00, BGl_z62lambda1775z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2558z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1774za7622947z00, BGl_z62lambda1774z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2559z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1780za7622948z00, BGl_z62lambda1780z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2720z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2247za7622949z00, BGl_z62lambda2247z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2721z00zz__openpgpzd2packetszd2, BgL_bgl_za762za7c3za704anonymo2950za7, BGl_z62zc3z04anonymousza32243ze3ze5zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2722z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2241za7622951z00, BGl_z62lambda2241z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2560z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1779za7622952z00, BGl_z62lambda1779z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2723z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2239za7622953z00, BGl_z62lambda2239z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2561z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1785za7622954z00, BGl_z62lambda1785z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2724z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2263za7622955z00, BGl_z62lambda2263z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2562z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1784za7622956z00, BGl_z62lambda1784z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2725z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2262za7622957z00, BGl_z62lambda2262z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2563z00zz__openpgpzd2packetszd2, BgL_bgl_za762za7c3za704anonymo2958za7, BGl_z62zc3z04anonymousza31760ze3ze5zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2726z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2268za7622959z00, BGl_z62lambda2268z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2564z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1758za7622960z00, BGl_z62lambda1758z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2727z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2267za7622961z00, BGl_z62lambda2267z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2565z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1756za7622962z00, BGl_z62lambda1756z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 10 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2728z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2273za7622963z00, BGl_z62lambda2273z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2566z00zz__openpgpzd2packetszd2, BgL_bgl_za762za7c3za704anonymo2964za7, BGl_z62zc3z04anonymousza31795ze3ze5zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2729z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2272za7622965z00, BGl_z62lambda2272z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2567z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1793za7622966z00, BGl_z62lambda1793z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2568z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1791za7622967z00, BGl_z62lambda1791z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 10 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2569z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1810za7622968z00, BGl_z62lambda1810z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2730z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2278za7622969z00, BGl_z62lambda2278z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2731z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2277za7622970z00, BGl_z62lambda2277z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2732z00zz__openpgpzd2packetszd2, BgL_bgl_za762za7c3za704anonymo2971za7, BGl_z62zc3z04anonymousza32258ze3ze5zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2570z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1809za7622972z00, BGl_z62lambda1809z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2733z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2256za7622973z00, BGl_z62lambda2256z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2571z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1815za7622974z00, BGl_z62lambda1815z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2734z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2254za7622975z00, BGl_z62lambda2254z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2572z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1814za7622976z00, BGl_z62lambda1814z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2735z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2293za7622977z00, BGl_z62lambda2293z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2573z00zz__openpgpzd2packetszd2, BgL_bgl_za762za7c3za704anonymo2978za7, BGl_z62zc3z04anonymousza31805ze3ze5zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2736z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2292za7622979z00, BGl_z62lambda2292z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2574z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1803za7622980z00, BGl_z62lambda1803z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2737z00zz__openpgpzd2packetszd2, BgL_bgl_za762za7c3za704anonymo2981za7, BGl_z62zc3z04anonymousza32288ze3ze5zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2575z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1801za7622982z00, BGl_z62lambda1801z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2738z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2286za7622983z00, BGl_z62lambda2286z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2576z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1830za7622984z00, BGl_z62lambda1830z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2739z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2284za7622985z00, BGl_z62lambda2284z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2577z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1829za7622986z00, BGl_z62lambda1829z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2578z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1835za7622987z00, BGl_z62lambda1835z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2579z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1834za7622988z00, BGl_z62lambda1834z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2740z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2308za7622989z00, BGl_z62lambda2308z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2741z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2307za7622990z00, BGl_z62lambda2307z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2742z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2313za7622991z00, BGl_z62lambda2313z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2580z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1840za7622992z00, BGl_z62lambda1840z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2743z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2312za7622993z00, BGl_z62lambda2312z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2581z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1839za7622994z00, BGl_z62lambda1839z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2744z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2318za7622995z00, BGl_z62lambda2318z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2582z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1845za7622996z00, BGl_z62lambda1845z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2745z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2317za7622997z00, BGl_z62lambda2317z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2583z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1844za7622998z00, BGl_z62lambda1844z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2746z00zz__openpgpzd2packetszd2, BgL_bgl_za762za7c3za704anonymo2999za7, BGl_z62zc3z04anonymousza32303ze3ze5zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2584z00zz__openpgpzd2packetszd2, BgL_bgl_za762za7c3za704anonymo3000za7, BGl_z62zc3z04anonymousza31825ze3ze5zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2747z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2301za7623001z00, BGl_z62lambda2301z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2585z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1823za7623002z00, BGl_z62lambda1823z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2748z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2299za7623003z00, BGl_z62lambda2299z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2586z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1821za7623004z00, BGl_z62lambda1821z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2749z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2333za7623005z00, BGl_z62lambda2333z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2587z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1860za7623006z00, BGl_z62lambda1860z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2588z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1859za7623007z00, BGl_z62lambda1859z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2589z00zz__openpgpzd2packetszd2, BgL_bgl_za762za7c3za704anonymo3008za7, BGl_z62zc3z04anonymousza31855ze3ze5zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2750z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2332za7623009z00, BGl_z62lambda2332z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2751z00zz__openpgpzd2packetszd2, BgL_bgl_za762za7c3za704anonymo3010za7, BGl_z62zc3z04anonymousza32328ze3ze5zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2752z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2326za7623011z00, BGl_z62lambda2326z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2590z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1853za7623012z00, BGl_z62lambda1853z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2753z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2324za7623013z00, BGl_z62lambda2324z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2591z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1851za7623014z00, BGl_z62lambda1851z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2754z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2348za7623015z00, BGl_z62lambda2348z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2592z00zz__openpgpzd2packetszd2, BgL_bgl_za762za7c3za704anonymo3016za7, BGl_z62zc3z04anonymousza31877ze3ze5zz__openpgpzd2packetszd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2755z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2347za7623017z00, BGl_z62lambda2347z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2593z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1876za7623018z00, BGl_z62lambda1876z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2756z00zz__openpgpzd2packetszd2, BgL_bgl_za762za7c3za704anonymo3019za7, BGl_z62zc3z04anonymousza32343ze3ze5zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2594z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1875za7623020z00, BGl_z62lambda1875z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2757z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2341za7623021z00, BGl_z62lambda2341z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2595z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1882za7623022z00, BGl_z62lambda1882z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2758z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2339za7623023z00, BGl_z62lambda2339z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2596z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1881za7623024z00, BGl_z62lambda1881z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2759z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2363za7623025z00, BGl_z62lambda2363z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2597z00zz__openpgpzd2packetszd2, BgL_bgl_za762za7c3za704anonymo3026za7, BGl_z62zc3z04anonymousza31889ze3ze5zz__openpgpzd2packetszd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2598z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1888za7623027z00, BGl_z62lambda1888z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2599z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda1887za7623028z00, BGl_z62lambda1887z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2760z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2362za7623029z00, BGl_z62lambda2362z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2761z00zz__openpgpzd2packetszd2, BgL_bgl_za762za7c3za704anonymo3030za7, BGl_z62zc3z04anonymousza32358ze3ze5zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2762z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2356za7623031z00, BGl_z62lambda2356z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2763z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2354za7623032z00, BGl_z62lambda2354z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2764z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2378za7623033z00, BGl_z62lambda2378z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2765z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2377za7623034z00, BGl_z62lambda2377z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2766z00zz__openpgpzd2packetszd2, BgL_bgl_za762za7c3za704anonymo3035za7, BGl_z62zc3z04anonymousza32373ze3ze5zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2767z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2371za7623036z00, BGl_z62lambda2371z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2768z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2369za7623037z00, BGl_z62lambda2369z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2769z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2393za7623038z00, BGl_z62lambda2393z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2770z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2392za7623039z00, BGl_z62lambda2392z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2771z00zz__openpgpzd2packetszd2, BgL_bgl_za762za7c3za704anonymo3040za7, BGl_z62zc3z04anonymousza32388ze3ze5zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2772z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2386za7623041z00, BGl_z62lambda2386z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2773z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2384za7623042z00, BGl_z62lambda2384z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2774z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2408za7623043z00, BGl_z62lambda2408z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2775z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2407za7623044z00, BGl_z62lambda2407z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2776z00zz__openpgpzd2packetszd2, BgL_bgl_za762za7c3za704anonymo3045za7, BGl_z62zc3z04anonymousza32403ze3ze5zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2777z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2401za7623046z00, BGl_z62lambda2401z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2778z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2399za7623047z00, BGl_z62lambda2399z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2779z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2423za7623048z00, BGl_z62lambda2423z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2780z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2422za7623049z00, BGl_z62lambda2422z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2781z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2428za7623050z00, BGl_z62lambda2428z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2782z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2427za7623051z00, BGl_z62lambda2427z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2783z00zz__openpgpzd2packetszd2, BgL_bgl_za762za7c3za704anonymo3052za7, BGl_z62zc3z04anonymousza32418ze3ze5zz__openpgpzd2packetszd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2784z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2416za7623053z00, BGl_z62lambda2416z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2785z00zz__openpgpzd2packetszd2, BgL_bgl_za762lambda2414za7623054z00, BGl_z62lambda2414z62zz__openpgpzd2packetszd2, 0L, BUNSPEC, 3 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_PGPzd2Signaturezd2Subzd2Keyzd2Expirationzd2Timezd2zz__openpgpzd2packetszd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Signaturezd2Subzd2Policyzd2zz__openpgpzd2packetszd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Signaturezd2Subzd2Notationzd2zz__openpgpzd2packetszd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Signaturezd2Subzd2Genericzd2zz__openpgpzd2packetszd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Signaturezd2Subzd2Preferredzd2Compressionz00zz__openpgpzd2packetszd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Keyzd2Packetz00zz__openpgpzd2packetszd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Signaturezd2Subzd2Expirationzd2Timez00zz__openpgpzd2packetszd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Signaturezd2Subzd2Creationzd2Timez00zz__openpgpzd2packetszd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Signaturezd2Subzd2Trustzd2zz__openpgpzd2packetszd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Signaturezd2v4zd2Packetzd2zz__openpgpzd2packetszd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Signaturezd2Subzd2Preferredzd2Symmetricz00zz__openpgpzd2packetszd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Signaturezd2Subzd2Revocablezd2zz__openpgpzd2packetszd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Signaturezd2Subzd2Packetzd2zz__openpgpzd2packetszd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Signaturezd2Subzd2Revocationzd2zz__openpgpzd2packetszd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Literalzd2Packetz00zz__openpgpzd2packetszd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Signaturezd2Subzd2Preferredzd2Hashz00zz__openpgpzd2packetszd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Secretzd2Keyzd2Packetzd2zz__openpgpzd2packetszd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2MDCzd2Packetz00zz__openpgpzd2packetszd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Secretzd2Keyzd2Decodedzd2Packetz00zz__openpgpzd2packetszd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Trustzd2Packetz00zz__openpgpzd2packetszd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Signaturezd2Subzd2Exportablezd2zz__openpgpzd2packetszd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Signaturezd2Subzd2IDzd2zz__openpgpzd2packetszd2) );
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__openpgpzd2packetszd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Signaturezd2Subzd2Signerzd2IDz00zz__openpgpzd2packetszd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Markerzd2Packetz00zz__openpgpzd2packetszd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Compressedzd2Packetz00zz__openpgpzd2packetszd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Sessionzd2Keyzd2Packetzd2zz__openpgpzd2packetszd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Signaturezd2Subzd2Primaryzd2IDz00zz__openpgpzd2packetszd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Signaturezd2v3zd2Packetzd2zz__openpgpzd2packetszd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Publiczd2Keyzd2Packetzd2zz__openpgpzd2packetszd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Symmetriczd2Keyzd2Encryptedzd2Sessionzd2Keyzd2Packetz00zz__openpgpzd2packetszd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Packetzd2zz__openpgpzd2packetszd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Sigzd2Packetz00zz__openpgpzd2packetszd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Attributezd2Packetz00zz__openpgpzd2packetszd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Publiczd2Keyzd2Encryptedzd2Sessionzd2Keyzd2Packetz00zz__openpgpzd2packetszd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2IDzd2Packetz00zz__openpgpzd2packetszd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2MDCzd2Symmetricallyzd2Encryptedzd2Packetz00zz__openpgpzd2packetszd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Onezd2Passzd2Signaturezd2Packetz00zz__openpgpzd2packetszd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Symmetricallyzd2Encryptedzd2Packetzd2zz__openpgpzd2packetszd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Signaturezd2Packetz00zz__openpgpzd2packetszd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Signaturezd2Subzd2Revocationzd2Reasonz00zz__openpgpzd2packetszd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Signaturezd2Subzd2Preferredzd2Keyzd2Serverzd2zz__openpgpzd2packetszd2) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__openpgpzd2packetszd2(long BgL_checksumz00_3774, char * BgL_fromz00_3775)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__openpgpzd2packetszd2))
{ 
BGl_requirezd2initializa7ationz75zz__openpgpzd2packetszd2 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__openpgpzd2packetszd2(); 
BGl_libraryzd2moduleszd2initz00zz__openpgpzd2packetszd2(); 
BGl_cnstzd2initzd2zz__openpgpzd2packetszd2(); 
BGl_objectzd2initzd2zz__openpgpzd2packetszd2(); 
return 
BGl_toplevelzd2initzd2zz__openpgpzd2packetszd2();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__openpgpzd2packetszd2()
{
{ /* Llib/pgp_packets.scm 1 */
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__openpgp-packets"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__openpgp-packets"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__openpgp-packets"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__openpgp-packets"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__openpgp-packets"); 
BGl_modulezd2initializa7ationz75zz__datez00(((long)0), "__openpgp-packets"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__openpgp-packets"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__openpgpzd2packetszd2()
{
{ /* Llib/pgp_packets.scm 1 */
{ /* Llib/pgp_packets.scm 1 */
obj_t BgL_cportz00_3096;
{ /* Llib/pgp_packets.scm 1 */
obj_t BgL_stringz00_3104;
BgL_stringz00_3104 = BGl_string2787z00zz__openpgpzd2packetszd2; 
{ /* Llib/pgp_packets.scm 1 */
obj_t BgL_startz00_3105;
BgL_startz00_3105 = 
BINT(((long)0)); 
{ /* Llib/pgp_packets.scm 1 */
obj_t BgL_endz00_3106;
BgL_endz00_3106 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_3104))); 
{ /* Llib/pgp_packets.scm 1 */

BgL_cportz00_3096 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_3104, BgL_startz00_3105, BgL_endz00_3106); } } } } 
{ 
long BgL_iz00_3097;
BgL_iz00_3097 = ((long)101); 
BgL_loopz00_3098:
if(
(BgL_iz00_3097==((long)-1)))
{ /* Llib/pgp_packets.scm 1 */
return BUNSPEC;}  else 
{ /* Llib/pgp_packets.scm 1 */
{ /* Llib/pgp_packets.scm 1 */
obj_t BgL_arg2789z00_3100;
{ /* Llib/pgp_packets.scm 1 */

{ /* Llib/pgp_packets.scm 1 */
obj_t BgL_locationz00_3102;
BgL_locationz00_3102 = 
BBOOL(((bool_t)0)); 
{ /* Llib/pgp_packets.scm 1 */

BgL_arg2789z00_3100 = 
BGl_readz00zz__readerz00(BgL_cportz00_3096, BgL_locationz00_3102); } } } 
{ /* Llib/pgp_packets.scm 1 */
int BgL_tmpz00_3800;
BgL_tmpz00_3800 = 
(int)(BgL_iz00_3097); 
CNST_TABLE_SET(BgL_tmpz00_3800, BgL_arg2789z00_3100); } } 
{ /* Llib/pgp_packets.scm 1 */
int BgL_auxz00_3103;
BgL_auxz00_3103 = 
(int)(
(BgL_iz00_3097-((long)1))); 
{ 
long BgL_iz00_3805;
BgL_iz00_3805 = 
(long)(BgL_auxz00_3103); 
BgL_iz00_3097 = BgL_iz00_3805; 
goto BgL_loopz00_3098;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__openpgpzd2packetszd2()
{
{ /* Llib/pgp_packets.scm 1 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__openpgpzd2packetszd2()
{
{ /* Llib/pgp_packets.scm 1 */
return BUNSPEC;} 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__openpgpzd2packetszd2()
{
{ /* Llib/pgp_packets.scm 1 */
{ /* Llib/pgp_packets.scm 3 */
obj_t BgL_arg1525z00_14;obj_t BgL_arg1537z00_15;
{ /* Llib/pgp_packets.scm 3 */
obj_t BgL_v1395z00_25;
BgL_v1395z00_25 = 
create_vector(((long)0)); 
BgL_arg1525z00_14 = BgL_v1395z00_25; } 
{ /* Llib/pgp_packets.scm 3 */
obj_t BgL_v1396z00_26;
BgL_v1396z00_26 = 
create_vector(((long)0)); 
BgL_arg1537z00_15 = BgL_v1396z00_26; } 
BGl_PGPzd2Packetzd2zz__openpgpzd2packetszd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)0)), 
CNST_TABLE_REF(((long)1)), BGl_objectz00zz__objectz00, ((long)34311), BGl_proc2526z00zz__openpgpzd2packetszd2, BGl_proc2525z00zz__openpgpzd2packetszd2, BFALSE, BGl_proc2524z00zz__openpgpzd2packetszd2, BFALSE, BgL_arg1525z00_14, BgL_arg1537z00_15); } 
{ /* Llib/pgp_packets.scm 4 */
obj_t BgL_arg1563z00_32;obj_t BgL_arg1577z00_33;
{ /* Llib/pgp_packets.scm 4 */
obj_t BgL_v1397z00_39;
BgL_v1397z00_39 = 
create_vector(((long)0)); 
BgL_arg1563z00_32 = BgL_v1397z00_39; } 
{ /* Llib/pgp_packets.scm 4 */
obj_t BgL_v1398z00_40;
BgL_v1398z00_40 = 
create_vector(((long)0)); 
BgL_arg1577z00_33 = BgL_v1398z00_40; } 
BGl_PGPzd2Sessionzd2Keyzd2Packetzd2zz__openpgpzd2packetszd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)2)), 
CNST_TABLE_REF(((long)1)), BGl_PGPzd2Packetzd2zz__openpgpzd2packetszd2, ((long)39181), BFALSE, BGl_proc2528z00zz__openpgpzd2packetszd2, BFALSE, BGl_proc2527z00zz__openpgpzd2packetszd2, BFALSE, BgL_arg1563z00_32, BgL_arg1577z00_33); } 
{ /* Llib/pgp_packets.scm 5 */
obj_t BgL_arg1612z00_46;obj_t BgL_arg1613z00_47;
{ /* Llib/pgp_packets.scm 5 */
obj_t BgL_v1399z00_61;
BgL_v1399z00_61 = 
create_vector(((long)4)); 
{ /* Llib/pgp_packets.scm 5 */
obj_t BgL_arg1623z00_62;
BgL_arg1623z00_62 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)3)), BGl_proc2530z00zz__openpgpzd2packetszd2, BGl_proc2529z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)4))); 
VECTOR_SET(BgL_v1399z00_61,((long)0),BgL_arg1623z00_62); } 
{ /* Llib/pgp_packets.scm 5 */
obj_t BgL_arg1649z00_72;
BgL_arg1649z00_72 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)5)), BGl_proc2532z00zz__openpgpzd2packetszd2, BGl_proc2531z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1399z00_61,((long)1),BgL_arg1649z00_72); } 
{ /* Llib/pgp_packets.scm 5 */
obj_t BgL_arg1658z00_82;
BgL_arg1658z00_82 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)7)), BGl_proc2534z00zz__openpgpzd2packetszd2, BGl_proc2533z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)8))); 
VECTOR_SET(BgL_v1399z00_61,((long)2),BgL_arg1658z00_82); } 
{ /* Llib/pgp_packets.scm 5 */
obj_t BgL_arg1667z00_92;
BgL_arg1667z00_92 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)9)), BGl_proc2536z00zz__openpgpzd2packetszd2, BGl_proc2535z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)10))); 
VECTOR_SET(BgL_v1399z00_61,((long)3),BgL_arg1667z00_92); } 
BgL_arg1612z00_46 = BgL_v1399z00_61; } 
{ /* Llib/pgp_packets.scm 5 */
obj_t BgL_v1400z00_102;
BgL_v1400z00_102 = 
create_vector(((long)0)); 
BgL_arg1613z00_47 = BgL_v1400z00_102; } 
BGl_PGPzd2Publiczd2Keyzd2Encryptedzd2Sessionzd2Keyzd2Packetz00zz__openpgpzd2packetszd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)11)), 
CNST_TABLE_REF(((long)1)), BGl_PGPzd2Sessionzd2Keyzd2Packetzd2zz__openpgpzd2packetszd2, ((long)41951), BGl_proc2539z00zz__openpgpzd2packetszd2, BGl_proc2538z00zz__openpgpzd2packetszd2, BFALSE, BGl_proc2537z00zz__openpgpzd2packetszd2, BFALSE, BgL_arg1612z00_46, BgL_arg1613z00_47); } 
{ /* Llib/pgp_packets.scm 15 */
obj_t BgL_arg1679z00_109;obj_t BgL_arg1680z00_110;
{ /* Llib/pgp_packets.scm 15 */
obj_t BgL_v1401z00_125;
BgL_v1401z00_125 = 
create_vector(((long)5)); 
{ /* Llib/pgp_packets.scm 15 */
obj_t BgL_arg1686z00_126;
BgL_arg1686z00_126 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)3)), BGl_proc2541z00zz__openpgpzd2packetszd2, BGl_proc2540z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)4))); 
VECTOR_SET(BgL_v1401z00_125,((long)0),BgL_arg1686z00_126); } 
{ /* Llib/pgp_packets.scm 15 */
obj_t BgL_arg1696z00_136;
BgL_arg1696z00_136 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)12)), BGl_proc2543z00zz__openpgpzd2packetszd2, BGl_proc2542z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)8))); 
VECTOR_SET(BgL_v1401z00_125,((long)1),BgL_arg1696z00_136); } 
{ /* Llib/pgp_packets.scm 15 */
obj_t BgL_arg1701z00_146;
BgL_arg1701z00_146 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)13)), BGl_proc2545z00zz__openpgpzd2packetszd2, BGl_proc2544z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)10))); 
VECTOR_SET(BgL_v1401z00_125,((long)2),BgL_arg1701z00_146); } 
{ /* Llib/pgp_packets.scm 15 */
obj_t BgL_arg1711z00_156;
BgL_arg1711z00_156 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)14)), BGl_proc2547z00zz__openpgpzd2packetszd2, BGl_proc2546z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)8))); 
VECTOR_SET(BgL_v1401z00_125,((long)3),BgL_arg1711z00_156); } 
{ /* Llib/pgp_packets.scm 15 */
obj_t BgL_arg1722z00_166;
BgL_arg1722z00_166 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)15)), BGl_proc2549z00zz__openpgpzd2packetszd2, BGl_proc2548z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)8))); 
VECTOR_SET(BgL_v1401z00_125,((long)4),BgL_arg1722z00_166); } 
BgL_arg1679z00_109 = BgL_v1401z00_125; } 
{ /* Llib/pgp_packets.scm 15 */
obj_t BgL_v1402z00_176;
BgL_v1402z00_176 = 
create_vector(((long)0)); 
BgL_arg1680z00_110 = BgL_v1402z00_176; } 
BGl_PGPzd2Sigzd2Packetz00zz__openpgpzd2packetszd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)16)), 
CNST_TABLE_REF(((long)1)), BGl_PGPzd2Packetzd2zz__openpgpzd2packetszd2, ((long)56552), BGl_proc2552z00zz__openpgpzd2packetszd2, BGl_proc2551z00zz__openpgpzd2packetszd2, BFALSE, BGl_proc2550z00zz__openpgpzd2packetszd2, BFALSE, BgL_arg1679z00_109, BgL_arg1680z00_110); } 
{ /* Llib/pgp_packets.scm 21 */
obj_t BgL_arg1754z00_183;obj_t BgL_arg1755z00_184;
{ /* Llib/pgp_packets.scm 21 */
obj_t BgL_v1403z00_204;
BgL_v1403z00_204 = 
create_vector(((long)5)); 
{ /* Llib/pgp_packets.scm 21 */
obj_t BgL_arg1761z00_205;
BgL_arg1761z00_205 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)17)), BGl_proc2554z00zz__openpgpzd2packetszd2, BGl_proc2553z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)18))); 
VECTOR_SET(BgL_v1403z00_204,((long)0),BgL_arg1761z00_205); } 
{ /* Llib/pgp_packets.scm 21 */
obj_t BgL_arg1766z00_215;
BgL_arg1766z00_215 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)19)), BGl_proc2556z00zz__openpgpzd2packetszd2, BGl_proc2555z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)10))); 
VECTOR_SET(BgL_v1403z00_204,((long)1),BgL_arg1766z00_215); } 
{ /* Llib/pgp_packets.scm 21 */
obj_t BgL_arg1771z00_225;
BgL_arg1771z00_225 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)20)), BGl_proc2558z00zz__openpgpzd2packetszd2, BGl_proc2557z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1403z00_204,((long)2),BgL_arg1771z00_225); } 
{ /* Llib/pgp_packets.scm 21 */
obj_t BgL_arg1776z00_235;
BgL_arg1776z00_235 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)21)), BGl_proc2560z00zz__openpgpzd2packetszd2, BGl_proc2559z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1403z00_204,((long)3),BgL_arg1776z00_235); } 
{ /* Llib/pgp_packets.scm 21 */
obj_t BgL_arg1781z00_245;
BgL_arg1781z00_245 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)22)), BGl_proc2562z00zz__openpgpzd2packetszd2, BGl_proc2561z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1403z00_204,((long)4),BgL_arg1781z00_245); } 
BgL_arg1754z00_183 = BgL_v1403z00_204; } 
{ /* Llib/pgp_packets.scm 21 */
obj_t BgL_v1404z00_255;
BgL_v1404z00_255 = 
create_vector(((long)0)); 
BgL_arg1755z00_184 = BgL_v1404z00_255; } 
BGl_PGPzd2Signaturezd2Packetz00zz__openpgpzd2packetszd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)23)), 
CNST_TABLE_REF(((long)1)), BGl_PGPzd2Sigzd2Packetz00zz__openpgpzd2packetszd2, ((long)10703), BGl_proc2565z00zz__openpgpzd2packetszd2, BGl_proc2564z00zz__openpgpzd2packetszd2, BFALSE, BGl_proc2563z00zz__openpgpzd2packetszd2, BFALSE, BgL_arg1754z00_183, BgL_arg1755z00_184); } 
{ /* Llib/pgp_packets.scm 27 */
obj_t BgL_arg1789z00_262;obj_t BgL_arg1790z00_263;
{ /* Llib/pgp_packets.scm 27 */
obj_t BgL_v1405z00_283;
BgL_v1405z00_283 = 
create_vector(((long)0)); 
BgL_arg1789z00_262 = BgL_v1405z00_283; } 
{ /* Llib/pgp_packets.scm 27 */
obj_t BgL_v1406z00_284;
BgL_v1406z00_284 = 
create_vector(((long)0)); 
BgL_arg1790z00_263 = BgL_v1406z00_284; } 
BGl_PGPzd2Signaturezd2v3zd2Packetzd2zz__openpgpzd2packetszd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)24)), 
CNST_TABLE_REF(((long)1)), BGl_PGPzd2Signaturezd2Packetz00zz__openpgpzd2packetszd2, ((long)284), BGl_proc2568z00zz__openpgpzd2packetszd2, BGl_proc2567z00zz__openpgpzd2packetszd2, BFALSE, BGl_proc2566z00zz__openpgpzd2packetszd2, BFALSE, BgL_arg1789z00_262, BgL_arg1790z00_263); } 
{ /* Llib/pgp_packets.scm 28 */
obj_t BgL_arg1799z00_291;obj_t BgL_arg1800z00_292;
{ /* Llib/pgp_packets.scm 28 */
obj_t BgL_v1407z00_314;
BgL_v1407z00_314 = 
create_vector(((long)2)); 
{ /* Llib/pgp_packets.scm 28 */
obj_t BgL_arg1806z00_315;
BgL_arg1806z00_315 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)25)), BGl_proc2570z00zz__openpgpzd2packetszd2, BGl_proc2569z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)26))); 
VECTOR_SET(BgL_v1407z00_314,((long)0),BgL_arg1806z00_315); } 
{ /* Llib/pgp_packets.scm 28 */
obj_t BgL_arg1811z00_325;
BgL_arg1811z00_325 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)27)), BGl_proc2572z00zz__openpgpzd2packetszd2, BGl_proc2571z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)26))); 
VECTOR_SET(BgL_v1407z00_314,((long)1),BgL_arg1811z00_325); } 
BgL_arg1799z00_291 = BgL_v1407z00_314; } 
{ /* Llib/pgp_packets.scm 28 */
obj_t BgL_v1408z00_335;
BgL_v1408z00_335 = 
create_vector(((long)0)); 
BgL_arg1800z00_292 = BgL_v1408z00_335; } 
BGl_PGPzd2Signaturezd2v4zd2Packetzd2zz__openpgpzd2packetszd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)28)), 
CNST_TABLE_REF(((long)1)), BGl_PGPzd2Signaturezd2Packetz00zz__openpgpzd2packetszd2, ((long)8690), BGl_proc2575z00zz__openpgpzd2packetszd2, BGl_proc2574z00zz__openpgpzd2packetszd2, BFALSE, BGl_proc2573z00zz__openpgpzd2packetszd2, BFALSE, BgL_arg1799z00_291, BgL_arg1800z00_292); } 
{ /* Llib/pgp_packets.scm 31 */
obj_t BgL_arg1819z00_342;obj_t BgL_arg1820z00_343;
{ /* Llib/pgp_packets.scm 31 */
obj_t BgL_v1409z00_357;
BgL_v1409z00_357 = 
create_vector(((long)4)); 
{ /* Llib/pgp_packets.scm 31 */
obj_t BgL_arg1826z00_358;
BgL_arg1826z00_358 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)3)), BGl_proc2577z00zz__openpgpzd2packetszd2, BGl_proc2576z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)4))); 
VECTOR_SET(BgL_v1409z00_357,((long)0),BgL_arg1826z00_358); } 
{ /* Llib/pgp_packets.scm 31 */
obj_t BgL_arg1831z00_368;
BgL_arg1831z00_368 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)7)), BGl_proc2579z00zz__openpgpzd2packetszd2, BGl_proc2578z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)8))); 
VECTOR_SET(BgL_v1409z00_357,((long)1),BgL_arg1831z00_368); } 
{ /* Llib/pgp_packets.scm 31 */
obj_t BgL_arg1836z00_378;
BgL_arg1836z00_378 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)29)), BGl_proc2581z00zz__openpgpzd2packetszd2, BGl_proc2580z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)10))); 
VECTOR_SET(BgL_v1409z00_357,((long)2),BgL_arg1836z00_378); } 
{ /* Llib/pgp_packets.scm 31 */
obj_t BgL_arg1841z00_388;
BgL_arg1841z00_388 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)9)), BGl_proc2583z00zz__openpgpzd2packetszd2, BGl_proc2582z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)10))); 
VECTOR_SET(BgL_v1409z00_357,((long)3),BgL_arg1841z00_388); } 
BgL_arg1819z00_342 = BgL_v1409z00_357; } 
{ /* Llib/pgp_packets.scm 31 */
obj_t BgL_v1410z00_398;
BgL_v1410z00_398 = 
create_vector(((long)0)); 
BgL_arg1820z00_343 = BgL_v1410z00_398; } 
BGl_PGPzd2Symmetriczd2Keyzd2Encryptedzd2Sessionzd2Keyzd2Packetz00zz__openpgpzd2packetszd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)30)), 
CNST_TABLE_REF(((long)1)), BGl_PGPzd2Sessionzd2Keyzd2Packetzd2zz__openpgpzd2packetszd2, ((long)36207), BGl_proc2586z00zz__openpgpzd2packetszd2, BGl_proc2585z00zz__openpgpzd2packetszd2, BFALSE, BGl_proc2584z00zz__openpgpzd2packetszd2, BFALSE, BgL_arg1819z00_342, BgL_arg1820z00_343); } 
{ /* Llib/pgp_packets.scm 39 */
obj_t BgL_arg1849z00_405;obj_t BgL_arg1850z00_406;
{ /* Llib/pgp_packets.scm 39 */
obj_t BgL_v1411z00_422;
BgL_v1411z00_422 = 
create_vector(((long)1)); 
{ /* Llib/pgp_packets.scm 39 */
obj_t BgL_arg1856z00_423;
BgL_arg1856z00_423 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)31)), BGl_proc2588z00zz__openpgpzd2packetszd2, BGl_proc2587z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)32))); 
VECTOR_SET(BgL_v1411z00_422,((long)0),BgL_arg1856z00_423); } 
BgL_arg1849z00_405 = BgL_v1411z00_422; } 
{ /* Llib/pgp_packets.scm 39 */
obj_t BgL_v1412z00_433;
BgL_v1412z00_433 = 
create_vector(((long)0)); 
BgL_arg1850z00_406 = BgL_v1412z00_433; } 
BGl_PGPzd2Onezd2Passzd2Signaturezd2Packetz00zz__openpgpzd2packetszd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)33)), 
CNST_TABLE_REF(((long)1)), BGl_PGPzd2Sigzd2Packetz00zz__openpgpzd2packetszd2, ((long)64132), BGl_proc2591z00zz__openpgpzd2packetszd2, BGl_proc2590z00zz__openpgpzd2packetszd2, BFALSE, BGl_proc2589z00zz__openpgpzd2packetszd2, BFALSE, BgL_arg1849z00_405, BgL_arg1850z00_406); } 
{ /* Llib/pgp_packets.scm 41 */
obj_t BgL_arg1864z00_440;obj_t BgL_arg1865z00_441;
{ /* Llib/pgp_packets.scm 41 */
obj_t BgL_v1413z00_458;
BgL_v1413z00_458 = 
create_vector(((long)7)); 
{ /* Llib/pgp_packets.scm 41 */
obj_t BgL_arg1871z00_459;
BgL_arg1871z00_459 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)5)), BGl_proc2594z00zz__openpgpzd2packetszd2, BGl_proc2593z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2592z00zz__openpgpzd2packetszd2, 
CNST_TABLE_REF(((long)10))); 
VECTOR_SET(BgL_v1413z00_458,((long)0),BgL_arg1871z00_459); } 
{ /* Llib/pgp_packets.scm 41 */
obj_t BgL_arg1878z00_472;
BgL_arg1878z00_472 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)3)), BGl_proc2596z00zz__openpgpzd2packetszd2, BGl_proc2595z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)4))); 
VECTOR_SET(BgL_v1413z00_458,((long)1),BgL_arg1878z00_472); } 
{ /* Llib/pgp_packets.scm 41 */
obj_t BgL_arg1883z00_482;
BgL_arg1883z00_482 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)34)), BGl_proc2599z00zz__openpgpzd2packetszd2, BGl_proc2598z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2597z00zz__openpgpzd2packetszd2, 
CNST_TABLE_REF(((long)32))); 
VECTOR_SET(BgL_v1413z00_458,((long)2),BgL_arg1883z00_482); } 
{ /* Llib/pgp_packets.scm 41 */
obj_t BgL_arg1890z00_495;
BgL_arg1890z00_495 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)7)), BGl_proc2601z00zz__openpgpzd2packetszd2, BGl_proc2600z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)8))); 
VECTOR_SET(BgL_v1413z00_458,((long)3),BgL_arg1890z00_495); } 
{ /* Llib/pgp_packets.scm 41 */
obj_t BgL_arg1895z00_505;
BgL_arg1895z00_505 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)17)), BGl_proc2603z00zz__openpgpzd2packetszd2, BGl_proc2602z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)18))); 
VECTOR_SET(BgL_v1413z00_458,((long)4),BgL_arg1895z00_505); } 
{ /* Llib/pgp_packets.scm 41 */
obj_t BgL_arg1900z00_515;
BgL_arg1900z00_515 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)35)), BGl_proc2605z00zz__openpgpzd2packetszd2, BGl_proc2604z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)10))); 
VECTOR_SET(BgL_v1413z00_458,((long)5),BgL_arg1900z00_515); } 
{ /* Llib/pgp_packets.scm 41 */
obj_t BgL_arg1905z00_525;
BgL_arg1905z00_525 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)36)), BGl_proc2607z00zz__openpgpzd2packetszd2, BGl_proc2606z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)10))); 
VECTOR_SET(BgL_v1413z00_458,((long)6),BgL_arg1905z00_525); } 
BgL_arg1864z00_440 = BgL_v1413z00_458; } 
{ /* Llib/pgp_packets.scm 41 */
obj_t BgL_v1414z00_535;
BgL_v1414z00_535 = 
create_vector(((long)0)); 
BgL_arg1865z00_441 = BgL_v1414z00_535; } 
BGl_PGPzd2Keyzd2Packetz00zz__openpgpzd2packetszd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)37)), 
CNST_TABLE_REF(((long)1)), BGl_PGPzd2Packetzd2zz__openpgpzd2packetszd2, ((long)23736), BGl_proc2610z00zz__openpgpzd2packetszd2, BGl_proc2609z00zz__openpgpzd2packetszd2, BFALSE, BGl_proc2608z00zz__openpgpzd2packetszd2, BFALSE, BgL_arg1864z00_440, BgL_arg1865z00_441); } 
{ /* Llib/pgp_packets.scm 49 */
obj_t BgL_arg1913z00_542;obj_t BgL_arg1914z00_543;
{ /* Llib/pgp_packets.scm 49 */
obj_t BgL_v1415z00_560;
BgL_v1415z00_560 = 
create_vector(((long)0)); 
BgL_arg1913z00_542 = BgL_v1415z00_560; } 
{ /* Llib/pgp_packets.scm 49 */
obj_t BgL_v1416z00_561;
BgL_v1416z00_561 = 
create_vector(((long)0)); 
BgL_arg1914z00_543 = BgL_v1416z00_561; } 
BGl_PGPzd2Publiczd2Keyzd2Packetzd2zz__openpgpzd2packetszd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)38)), 
CNST_TABLE_REF(((long)1)), BGl_PGPzd2Keyzd2Packetz00zz__openpgpzd2packetszd2, ((long)27376), BGl_proc2613z00zz__openpgpzd2packetszd2, BGl_proc2612z00zz__openpgpzd2packetszd2, BFALSE, BGl_proc2611z00zz__openpgpzd2packetszd2, BFALSE, BgL_arg1913z00_542, BgL_arg1914z00_543); } 
{ /* Llib/pgp_packets.scm 50 */
obj_t BgL_arg1923z00_568;obj_t BgL_arg1924z00_569;
{ /* Llib/pgp_packets.scm 50 */
obj_t BgL_v1417z00_587;
BgL_v1417z00_587 = 
create_vector(((long)1)); 
{ /* Llib/pgp_packets.scm 50 */
obj_t BgL_arg1930z00_588;
BgL_arg1930z00_588 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)39)), BGl_proc2615z00zz__openpgpzd2packetszd2, BGl_proc2614z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1417z00_587,((long)0),BgL_arg1930z00_588); } 
BgL_arg1923z00_568 = BgL_v1417z00_587; } 
{ /* Llib/pgp_packets.scm 50 */
obj_t BgL_v1418z00_598;
BgL_v1418z00_598 = 
create_vector(((long)0)); 
BgL_arg1924z00_569 = BgL_v1418z00_598; } 
BGl_PGPzd2Secretzd2Keyzd2Packetzd2zz__openpgpzd2packetszd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)40)), 
CNST_TABLE_REF(((long)1)), BGl_PGPzd2Keyzd2Packetz00zz__openpgpzd2packetszd2, ((long)21832), BGl_proc2618z00zz__openpgpzd2packetszd2, BGl_proc2617z00zz__openpgpzd2packetszd2, BFALSE, BGl_proc2616z00zz__openpgpzd2packetszd2, BFALSE, BgL_arg1923z00_568, BgL_arg1924z00_569); } 
{ /* Llib/pgp_packets.scm 52 */
obj_t BgL_arg1939z00_606;obj_t BgL_arg1940z00_607;
{ /* Llib/pgp_packets.scm 52 */
obj_t BgL_v1419z00_637;
BgL_v1419z00_637 = 
create_vector(((long)1)); 
{ /* Llib/pgp_packets.scm 52 */
obj_t BgL_arg1951z00_638;
BgL_arg1951z00_638 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)41)), BGl_proc2620z00zz__openpgpzd2packetszd2, BGl_proc2619z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)10))); 
VECTOR_SET(BgL_v1419z00_637,((long)0),BgL_arg1951z00_638); } 
BgL_arg1939z00_606 = BgL_v1419z00_637; } 
{ /* Llib/pgp_packets.scm 52 */
obj_t BgL_v1420z00_648;
BgL_v1420z00_648 = 
create_vector(((long)0)); 
BgL_arg1940z00_607 = BgL_v1420z00_648; } 
BGl_PGPzd2Secretzd2Keyzd2Decodedzd2Packetz00zz__openpgpzd2packetszd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)42)), 
CNST_TABLE_REF(((long)1)), BGl_PGPzd2Secretzd2Keyzd2Packetzd2zz__openpgpzd2packetszd2, ((long)13166), BGl_proc2624z00zz__openpgpzd2packetszd2, BGl_proc2623z00zz__openpgpzd2packetszd2, BFALSE, BGl_proc2622z00zz__openpgpzd2packetszd2, BGl_proc2621z00zz__openpgpzd2packetszd2, BgL_arg1939z00_606, BgL_arg1940z00_607); } 
{ /* Llib/pgp_packets.scm 54 */
obj_t BgL_arg1959z00_656;obj_t BgL_arg1960z00_657;
{ /* Llib/pgp_packets.scm 54 */
obj_t BgL_v1421z00_668;
BgL_v1421z00_668 = 
create_vector(((long)1)); 
{ /* Llib/pgp_packets.scm 54 */
obj_t BgL_arg1966z00_669;
BgL_arg1966z00_669 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)43)), BGl_proc2626z00zz__openpgpzd2packetszd2, BGl_proc2625z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)26))); 
VECTOR_SET(BgL_v1421z00_668,((long)0),BgL_arg1966z00_669); } 
BgL_arg1959z00_656 = BgL_v1421z00_668; } 
{ /* Llib/pgp_packets.scm 54 */
obj_t BgL_v1422z00_679;
BgL_v1422z00_679 = 
create_vector(((long)0)); 
BgL_arg1960z00_657 = BgL_v1422z00_679; } 
BGl_PGPzd2Compressedzd2Packetz00zz__openpgpzd2packetszd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)44)), 
CNST_TABLE_REF(((long)1)), BGl_PGPzd2Packetzd2zz__openpgpzd2packetszd2, ((long)40673), BGl_proc2629z00zz__openpgpzd2packetszd2, BGl_proc2628z00zz__openpgpzd2packetszd2, BFALSE, BGl_proc2627z00zz__openpgpzd2packetszd2, BFALSE, BgL_arg1959z00_656, BgL_arg1960z00_657); } 
{ /* Llib/pgp_packets.scm 56 */
obj_t BgL_arg1974z00_686;obj_t BgL_arg1975z00_687;
{ /* Llib/pgp_packets.scm 56 */
obj_t BgL_v1423z00_698;
BgL_v1423z00_698 = 
create_vector(((long)1)); 
{ /* Llib/pgp_packets.scm 56 */
obj_t BgL_arg1981z00_699;
BgL_arg1981z00_699 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)45)), BGl_proc2631z00zz__openpgpzd2packetszd2, BGl_proc2630z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1423z00_698,((long)0),BgL_arg1981z00_699); } 
BgL_arg1974z00_686 = BgL_v1423z00_698; } 
{ /* Llib/pgp_packets.scm 56 */
obj_t BgL_v1424z00_709;
BgL_v1424z00_709 = 
create_vector(((long)0)); 
BgL_arg1975z00_687 = BgL_v1424z00_709; } 
BGl_PGPzd2Symmetricallyzd2Encryptedzd2Packetzd2zz__openpgpzd2packetszd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)46)), 
CNST_TABLE_REF(((long)1)), BGl_PGPzd2Packetzd2zz__openpgpzd2packetszd2, ((long)29215), BGl_proc2634z00zz__openpgpzd2packetszd2, BGl_proc2633z00zz__openpgpzd2packetszd2, BFALSE, BGl_proc2632z00zz__openpgpzd2packetszd2, BFALSE, BgL_arg1974z00_686, BgL_arg1975z00_687); } 
{ /* Llib/pgp_packets.scm 58 */
obj_t BgL_arg1989z00_716;obj_t BgL_arg1990z00_717;
{ /* Llib/pgp_packets.scm 58 */
obj_t BgL_v1425z00_727;
BgL_v1425z00_727 = 
create_vector(((long)0)); 
BgL_arg1989z00_716 = BgL_v1425z00_727; } 
{ /* Llib/pgp_packets.scm 58 */
obj_t BgL_v1426z00_728;
BgL_v1426z00_728 = 
create_vector(((long)0)); 
BgL_arg1990z00_717 = BgL_v1426z00_728; } 
BGl_PGPzd2Markerzd2Packetz00zz__openpgpzd2packetszd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)47)), 
CNST_TABLE_REF(((long)1)), BGl_PGPzd2Packetzd2zz__openpgpzd2packetszd2, ((long)31195), BGl_proc2637z00zz__openpgpzd2packetszd2, BGl_proc2636z00zz__openpgpzd2packetszd2, BFALSE, BGl_proc2635z00zz__openpgpzd2packetszd2, BFALSE, BgL_arg1989z00_716, BgL_arg1990z00_717); } 
{ /* Llib/pgp_packets.scm 59 */
obj_t BgL_arg1999z00_735;obj_t BgL_arg2000z00_736;
{ /* Llib/pgp_packets.scm 59 */
obj_t BgL_v1427z00_751;
BgL_v1427z00_751 = 
create_vector(((long)5)); 
{ /* Llib/pgp_packets.scm 59 */
obj_t BgL_arg2006z00_752;
BgL_arg2006z00_752 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)48)), BGl_proc2639z00zz__openpgpzd2packetszd2, BGl_proc2638z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)8))); 
VECTOR_SET(BgL_v1427z00_751,((long)0),BgL_arg2006z00_752); } 
{ /* Llib/pgp_packets.scm 59 */
obj_t BgL_arg2011z00_762;
BgL_arg2011z00_762 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)49)), BGl_proc2641z00zz__openpgpzd2packetszd2, BGl_proc2640z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)32))); 
VECTOR_SET(BgL_v1427z00_751,((long)1),BgL_arg2011z00_762); } 
{ /* Llib/pgp_packets.scm 59 */
obj_t BgL_arg2016z00_772;
BgL_arg2016z00_772 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)50)), BGl_proc2643z00zz__openpgpzd2packetszd2, BGl_proc2642z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)10))); 
VECTOR_SET(BgL_v1427z00_751,((long)2),BgL_arg2016z00_772); } 
{ /* Llib/pgp_packets.scm 59 */
obj_t BgL_arg2021z00_782;
BgL_arg2021z00_782 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)17)), BGl_proc2645z00zz__openpgpzd2packetszd2, BGl_proc2644z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)18))); 
VECTOR_SET(BgL_v1427z00_751,((long)3),BgL_arg2021z00_782); } 
{ /* Llib/pgp_packets.scm 59 */
obj_t BgL_arg2026z00_792;
BgL_arg2026z00_792 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)45)), BGl_proc2647z00zz__openpgpzd2packetszd2, BGl_proc2646z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1427z00_751,((long)4),BgL_arg2026z00_792); } 
BgL_arg1999z00_735 = BgL_v1427z00_751; } 
{ /* Llib/pgp_packets.scm 59 */
obj_t BgL_v1428z00_802;
BgL_v1428z00_802 = 
create_vector(((long)0)); 
BgL_arg2000z00_736 = BgL_v1428z00_802; } 
BGl_PGPzd2Literalzd2Packetz00zz__openpgpzd2packetszd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)51)), 
CNST_TABLE_REF(((long)1)), BGl_PGPzd2Packetzd2zz__openpgpzd2packetszd2, ((long)26458), BGl_proc2650z00zz__openpgpzd2packetszd2, BGl_proc2649z00zz__openpgpzd2packetszd2, BFALSE, BGl_proc2648z00zz__openpgpzd2packetszd2, BFALSE, BgL_arg1999z00_735, BgL_arg2000z00_736); } 
{ /* Llib/pgp_packets.scm 65 */
obj_t BgL_arg2034z00_809;obj_t BgL_arg2035z00_810;
{ /* Llib/pgp_packets.scm 65 */
obj_t BgL_v1429z00_820;
BgL_v1429z00_820 = 
create_vector(((long)0)); 
BgL_arg2034z00_809 = BgL_v1429z00_820; } 
{ /* Llib/pgp_packets.scm 65 */
obj_t BgL_v1430z00_821;
BgL_v1430z00_821 = 
create_vector(((long)0)); 
BgL_arg2035z00_810 = BgL_v1430z00_821; } 
BGl_PGPzd2Trustzd2Packetz00zz__openpgpzd2packetszd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)52)), 
CNST_TABLE_REF(((long)1)), BGl_PGPzd2Packetzd2zz__openpgpzd2packetszd2, ((long)36763), BGl_proc2653z00zz__openpgpzd2packetszd2, BGl_proc2652z00zz__openpgpzd2packetszd2, BFALSE, BGl_proc2651z00zz__openpgpzd2packetszd2, BFALSE, BgL_arg2034z00_809, BgL_arg2035z00_810); } 
{ /* Llib/pgp_packets.scm 66 */
obj_t BgL_arg2044z00_828;obj_t BgL_arg2045z00_829;
{ /* Llib/pgp_packets.scm 66 */
obj_t BgL_v1431z00_840;
BgL_v1431z00_840 = 
create_vector(((long)1)); 
{ /* Llib/pgp_packets.scm 66 */
obj_t BgL_arg2051z00_841;
BgL_arg2051z00_841 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)45)), BGl_proc2655z00zz__openpgpzd2packetszd2, BGl_proc2654z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1431z00_840,((long)0),BgL_arg2051z00_841); } 
BgL_arg2044z00_828 = BgL_v1431z00_840; } 
{ /* Llib/pgp_packets.scm 66 */
obj_t BgL_v1432z00_851;
BgL_v1432z00_851 = 
create_vector(((long)0)); 
BgL_arg2045z00_829 = BgL_v1432z00_851; } 
BGl_PGPzd2IDzd2Packetz00zz__openpgpzd2packetszd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)53)), 
CNST_TABLE_REF(((long)1)), BGl_PGPzd2Packetzd2zz__openpgpzd2packetszd2, ((long)2773), BGl_proc2658z00zz__openpgpzd2packetszd2, BGl_proc2657z00zz__openpgpzd2packetszd2, BFALSE, BGl_proc2656z00zz__openpgpzd2packetszd2, BFALSE, BgL_arg2044z00_828, BgL_arg2045z00_829); } 
{ /* Llib/pgp_packets.scm 68 */
obj_t BgL_arg2059z00_858;obj_t BgL_arg2060z00_859;
{ /* Llib/pgp_packets.scm 68 */
obj_t BgL_v1433z00_870;
BgL_v1433z00_870 = 
create_vector(((long)1)); 
{ /* Llib/pgp_packets.scm 68 */
obj_t BgL_arg2066z00_871;
BgL_arg2066z00_871 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)45)), BGl_proc2660z00zz__openpgpzd2packetszd2, BGl_proc2659z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1433z00_870,((long)0),BgL_arg2066z00_871); } 
BgL_arg2059z00_858 = BgL_v1433z00_870; } 
{ /* Llib/pgp_packets.scm 68 */
obj_t BgL_v1434z00_881;
BgL_v1434z00_881 = 
create_vector(((long)0)); 
BgL_arg2060z00_859 = BgL_v1434z00_881; } 
BGl_PGPzd2Attributezd2Packetz00zz__openpgpzd2packetszd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)54)), 
CNST_TABLE_REF(((long)1)), BGl_PGPzd2Packetzd2zz__openpgpzd2packetszd2, ((long)42122), BGl_proc2663z00zz__openpgpzd2packetszd2, BGl_proc2662z00zz__openpgpzd2packetszd2, BFALSE, BGl_proc2661z00zz__openpgpzd2packetszd2, BFALSE, BgL_arg2059z00_858, BgL_arg2060z00_859); } 
{ /* Llib/pgp_packets.scm 70 */
obj_t BgL_arg2074z00_888;obj_t BgL_arg2075z00_889;
{ /* Llib/pgp_packets.scm 70 */
obj_t BgL_v1435z00_901;
BgL_v1435z00_901 = 
create_vector(((long)1)); 
{ /* Llib/pgp_packets.scm 70 */
obj_t BgL_arg2081z00_902;
BgL_arg2081z00_902 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)3)), BGl_proc2665z00zz__openpgpzd2packetszd2, BGl_proc2664z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)4))); 
VECTOR_SET(BgL_v1435z00_901,((long)0),BgL_arg2081z00_902); } 
BgL_arg2074z00_888 = BgL_v1435z00_901; } 
{ /* Llib/pgp_packets.scm 70 */
obj_t BgL_v1436z00_912;
BgL_v1436z00_912 = 
create_vector(((long)0)); 
BgL_arg2075z00_889 = BgL_v1436z00_912; } 
BGl_PGPzd2MDCzd2Symmetricallyzd2Encryptedzd2Packetz00zz__openpgpzd2packetszd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)55)), 
CNST_TABLE_REF(((long)1)), BGl_PGPzd2Symmetricallyzd2Encryptedzd2Packetzd2zz__openpgpzd2packetszd2, ((long)38853), BGl_proc2668z00zz__openpgpzd2packetszd2, BGl_proc2667z00zz__openpgpzd2packetszd2, BFALSE, BGl_proc2666z00zz__openpgpzd2packetszd2, BFALSE, BgL_arg2074z00_888, BgL_arg2075z00_889); } 
{ /* Llib/pgp_packets.scm 72 */
obj_t BgL_arg2089z00_919;obj_t BgL_arg2090z00_920;
{ /* Llib/pgp_packets.scm 72 */
obj_t BgL_v1437z00_931;
BgL_v1437z00_931 = 
create_vector(((long)1)); 
{ /* Llib/pgp_packets.scm 72 */
obj_t BgL_arg2096z00_932;
BgL_arg2096z00_932 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)56)), BGl_proc2670z00zz__openpgpzd2packetszd2, BGl_proc2669z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1437z00_931,((long)0),BgL_arg2096z00_932); } 
BgL_arg2089z00_919 = BgL_v1437z00_931; } 
{ /* Llib/pgp_packets.scm 72 */
obj_t BgL_v1438z00_942;
BgL_v1438z00_942 = 
create_vector(((long)0)); 
BgL_arg2090z00_920 = BgL_v1438z00_942; } 
BGl_PGPzd2MDCzd2Packetz00zz__openpgpzd2packetszd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)57)), 
CNST_TABLE_REF(((long)1)), BGl_PGPzd2Packetzd2zz__openpgpzd2packetszd2, ((long)20880), BGl_proc2673z00zz__openpgpzd2packetszd2, BGl_proc2672z00zz__openpgpzd2packetszd2, BFALSE, BGl_proc2671z00zz__openpgpzd2packetszd2, BFALSE, BgL_arg2089z00_919, BgL_arg2090z00_920); } 
{ /* Llib/pgp_packets.scm 75 */
obj_t BgL_arg2104z00_949;obj_t BgL_arg2105z00_950;
{ /* Llib/pgp_packets.scm 75 */
obj_t BgL_v1439z00_961;
BgL_v1439z00_961 = 
create_vector(((long)1)); 
{ /* Llib/pgp_packets.scm 75 */
obj_t BgL_arg2111z00_962;
BgL_arg2111z00_962 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)58)), BGl_proc2676z00zz__openpgpzd2packetszd2, BGl_proc2675z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2674z00zz__openpgpzd2packetszd2, 
CNST_TABLE_REF(((long)32))); 
VECTOR_SET(BgL_v1439z00_961,((long)0),BgL_arg2111z00_962); } 
BgL_arg2104z00_949 = BgL_v1439z00_961; } 
{ /* Llib/pgp_packets.scm 75 */
obj_t BgL_v1440z00_975;
BgL_v1440z00_975 = 
create_vector(((long)0)); 
BgL_arg2105z00_950 = BgL_v1440z00_975; } 
BGl_PGPzd2Signaturezd2Subzd2Packetzd2zz__openpgpzd2packetszd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)59)), 
CNST_TABLE_REF(((long)1)), BGl_objectz00zz__objectz00, ((long)40149), BGl_proc2679z00zz__openpgpzd2packetszd2, BGl_proc2678z00zz__openpgpzd2packetszd2, BFALSE, BGl_proc2677z00zz__openpgpzd2packetszd2, BFALSE, BgL_arg2104z00_949, BgL_arg2105z00_950); } 
{ /* Llib/pgp_packets.scm 79 */
obj_t BgL_arg2121z00_982;obj_t BgL_arg2122z00_983;
{ /* Llib/pgp_packets.scm 79 */
obj_t BgL_v1441z00_996;
BgL_v1441z00_996 = 
create_vector(((long)2)); 
{ /* Llib/pgp_packets.scm 79 */
obj_t BgL_arg2128z00_997;
BgL_arg2128z00_997 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)60)), BGl_proc2681z00zz__openpgpzd2packetszd2, BGl_proc2680z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)8))); 
VECTOR_SET(BgL_v1441z00_996,((long)0),BgL_arg2128z00_997); } 
{ /* Llib/pgp_packets.scm 79 */
obj_t BgL_arg2133z00_1007;
BgL_arg2133z00_1007 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)45)), BGl_proc2683z00zz__openpgpzd2packetszd2, BGl_proc2682z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1441z00_996,((long)1),BgL_arg2133z00_1007); } 
BgL_arg2121z00_982 = BgL_v1441z00_996; } 
{ /* Llib/pgp_packets.scm 79 */
obj_t BgL_v1442z00_1017;
BgL_v1442z00_1017 = 
create_vector(((long)0)); 
BgL_arg2122z00_983 = BgL_v1442z00_1017; } 
BGl_PGPzd2Signaturezd2Subzd2Genericzd2zz__openpgpzd2packetszd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)61)), 
CNST_TABLE_REF(((long)1)), BGl_PGPzd2Signaturezd2Subzd2Packetzd2zz__openpgpzd2packetszd2, ((long)31878), BGl_proc2686z00zz__openpgpzd2packetszd2, BGl_proc2685z00zz__openpgpzd2packetszd2, BFALSE, BGl_proc2684z00zz__openpgpzd2packetszd2, BFALSE, BgL_arg2121z00_982, BgL_arg2122z00_983); } 
{ /* Llib/pgp_packets.scm 82 */
obj_t BgL_arg2141z00_1024;obj_t BgL_arg2142z00_1025;
{ /* Llib/pgp_packets.scm 82 */
obj_t BgL_v1443z00_1037;
BgL_v1443z00_1037 = 
create_vector(((long)1)); 
{ /* Llib/pgp_packets.scm 82 */
obj_t BgL_arg2149z00_1038;
BgL_arg2149z00_1038 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)17)), BGl_proc2688z00zz__openpgpzd2packetszd2, BGl_proc2687z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)18))); 
VECTOR_SET(BgL_v1443z00_1037,((long)0),BgL_arg2149z00_1038); } 
BgL_arg2141z00_1024 = BgL_v1443z00_1037; } 
{ /* Llib/pgp_packets.scm 82 */
obj_t BgL_v1444z00_1048;
BgL_v1444z00_1048 = 
create_vector(((long)0)); 
BgL_arg2142z00_1025 = BgL_v1444z00_1048; } 
BGl_PGPzd2Signaturezd2Subzd2Creationzd2Timez00zz__openpgpzd2packetszd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)62)), 
CNST_TABLE_REF(((long)1)), BGl_PGPzd2Signaturezd2Subzd2Packetzd2zz__openpgpzd2packetszd2, ((long)33723), BGl_proc2691z00zz__openpgpzd2packetszd2, BGl_proc2690z00zz__openpgpzd2packetszd2, BFALSE, BGl_proc2689z00zz__openpgpzd2packetszd2, BFALSE, BgL_arg2141z00_1024, BgL_arg2142z00_1025); } 
{ /* Llib/pgp_packets.scm 84 */
obj_t BgL_arg2157z00_1055;obj_t BgL_arg2158z00_1056;
{ /* Llib/pgp_packets.scm 84 */
obj_t BgL_v1445z00_1068;
BgL_v1445z00_1068 = 
create_vector(((long)1)); 
{ /* Llib/pgp_packets.scm 84 */
obj_t BgL_arg2164z00_1069;
BgL_arg2164z00_1069 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)63)), BGl_proc2693z00zz__openpgpzd2packetszd2, BGl_proc2692z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)18))); 
VECTOR_SET(BgL_v1445z00_1068,((long)0),BgL_arg2164z00_1069); } 
BgL_arg2157z00_1055 = BgL_v1445z00_1068; } 
{ /* Llib/pgp_packets.scm 84 */
obj_t BgL_v1446z00_1079;
BgL_v1446z00_1079 = 
create_vector(((long)0)); 
BgL_arg2158z00_1056 = BgL_v1446z00_1079; } 
BGl_PGPzd2Signaturezd2Subzd2Expirationzd2Timez00zz__openpgpzd2packetszd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)64)), 
CNST_TABLE_REF(((long)1)), BGl_PGPzd2Signaturezd2Subzd2Packetzd2zz__openpgpzd2packetszd2, ((long)61111), BGl_proc2696z00zz__openpgpzd2packetszd2, BGl_proc2695z00zz__openpgpzd2packetszd2, BFALSE, BGl_proc2694z00zz__openpgpzd2packetszd2, BFALSE, BgL_arg2157z00_1055, BgL_arg2158z00_1056); } 
{ /* Llib/pgp_packets.scm 86 */
obj_t BgL_arg2172z00_1086;obj_t BgL_arg2173z00_1087;
{ /* Llib/pgp_packets.scm 86 */
obj_t BgL_v1447z00_1099;
BgL_v1447z00_1099 = 
create_vector(((long)1)); 
{ /* Llib/pgp_packets.scm 86 */
obj_t BgL_arg2179z00_1100;
BgL_arg2179z00_1100 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)65)), BGl_proc2698z00zz__openpgpzd2packetszd2, BGl_proc2697z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)32))); 
VECTOR_SET(BgL_v1447z00_1099,((long)0),BgL_arg2179z00_1100); } 
BgL_arg2172z00_1086 = BgL_v1447z00_1099; } 
{ /* Llib/pgp_packets.scm 86 */
obj_t BgL_v1448z00_1110;
BgL_v1448z00_1110 = 
create_vector(((long)0)); 
BgL_arg2173z00_1087 = BgL_v1448z00_1110; } 
BGl_PGPzd2Signaturezd2Subzd2Exportablezd2zz__openpgpzd2packetszd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)66)), 
CNST_TABLE_REF(((long)1)), BGl_PGPzd2Signaturezd2Subzd2Packetzd2zz__openpgpzd2packetszd2, ((long)3155), BGl_proc2701z00zz__openpgpzd2packetszd2, BGl_proc2700z00zz__openpgpzd2packetszd2, BFALSE, BGl_proc2699z00zz__openpgpzd2packetszd2, BFALSE, BgL_arg2172z00_1086, BgL_arg2173z00_1087); } 
{ /* Llib/pgp_packets.scm 88 */
obj_t BgL_arg2187z00_1117;obj_t BgL_arg2188z00_1118;
{ /* Llib/pgp_packets.scm 88 */
obj_t BgL_v1449z00_1131;
BgL_v1449z00_1131 = 
create_vector(((long)2)); 
{ /* Llib/pgp_packets.scm 88 */
obj_t BgL_arg2194z00_1132;
BgL_arg2194z00_1132 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)67)), BGl_proc2703z00zz__openpgpzd2packetszd2, BGl_proc2702z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)68))); 
VECTOR_SET(BgL_v1449z00_1131,((long)0),BgL_arg2194z00_1132); } 
{ /* Llib/pgp_packets.scm 88 */
obj_t BgL_arg2199z00_1142;
BgL_arg2199z00_1142 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)69)), BGl_proc2705z00zz__openpgpzd2packetszd2, BGl_proc2704z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)68))); 
VECTOR_SET(BgL_v1449z00_1131,((long)1),BgL_arg2199z00_1142); } 
BgL_arg2187z00_1117 = BgL_v1449z00_1131; } 
{ /* Llib/pgp_packets.scm 88 */
obj_t BgL_v1450z00_1152;
BgL_v1450z00_1152 = 
create_vector(((long)0)); 
BgL_arg2188z00_1118 = BgL_v1450z00_1152; } 
BGl_PGPzd2Signaturezd2Subzd2Trustzd2zz__openpgpzd2packetszd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)70)), 
CNST_TABLE_REF(((long)1)), BGl_PGPzd2Signaturezd2Subzd2Packetzd2zz__openpgpzd2packetszd2, ((long)24246), BGl_proc2708z00zz__openpgpzd2packetszd2, BGl_proc2707z00zz__openpgpzd2packetszd2, BFALSE, BGl_proc2706z00zz__openpgpzd2packetszd2, BFALSE, BgL_arg2187z00_1117, BgL_arg2188z00_1118); } 
{ /* Llib/pgp_packets.scm 91 */
obj_t BgL_arg2207z00_1159;obj_t BgL_arg2208z00_1160;
{ /* Llib/pgp_packets.scm 91 */
obj_t BgL_v1451z00_1172;
BgL_v1451z00_1172 = 
create_vector(((long)1)); 
{ /* Llib/pgp_packets.scm 91 */
obj_t BgL_arg2214z00_1173;
BgL_arg2214z00_1173 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)71)), BGl_proc2710z00zz__openpgpzd2packetszd2, BGl_proc2709z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)32))); 
VECTOR_SET(BgL_v1451z00_1172,((long)0),BgL_arg2214z00_1173); } 
BgL_arg2207z00_1159 = BgL_v1451z00_1172; } 
{ /* Llib/pgp_packets.scm 91 */
obj_t BgL_v1452z00_1183;
BgL_v1452z00_1183 = 
create_vector(((long)0)); 
BgL_arg2208z00_1160 = BgL_v1452z00_1183; } 
BGl_PGPzd2Signaturezd2Subzd2Revocablezd2zz__openpgpzd2packetszd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)72)), 
CNST_TABLE_REF(((long)1)), BGl_PGPzd2Signaturezd2Subzd2Packetzd2zz__openpgpzd2packetszd2, ((long)15541), BGl_proc2713z00zz__openpgpzd2packetszd2, BGl_proc2712z00zz__openpgpzd2packetszd2, BFALSE, BGl_proc2711z00zz__openpgpzd2packetszd2, BFALSE, BgL_arg2207z00_1159, BgL_arg2208z00_1160); } 
{ /* Llib/pgp_packets.scm 93 */
obj_t BgL_arg2222z00_1190;obj_t BgL_arg2223z00_1191;
{ /* Llib/pgp_packets.scm 93 */
obj_t BgL_v1453z00_1203;
BgL_v1453z00_1203 = 
create_vector(((long)1)); 
{ /* Llib/pgp_packets.scm 93 */
obj_t BgL_arg2229z00_1204;
BgL_arg2229z00_1204 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)73)), BGl_proc2715z00zz__openpgpzd2packetszd2, BGl_proc2714z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)4))); 
VECTOR_SET(BgL_v1453z00_1203,((long)0),BgL_arg2229z00_1204); } 
BgL_arg2222z00_1190 = BgL_v1453z00_1203; } 
{ /* Llib/pgp_packets.scm 93 */
obj_t BgL_v1454z00_1214;
BgL_v1454z00_1214 = 
create_vector(((long)0)); 
BgL_arg2223z00_1191 = BgL_v1454z00_1214; } 
BGl_PGPzd2Signaturezd2Subzd2Keyzd2Expirationzd2Timezd2zz__openpgpzd2packetszd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)74)), 
CNST_TABLE_REF(((long)1)), BGl_PGPzd2Signaturezd2Subzd2Packetzd2zz__openpgpzd2packetszd2, ((long)50790), BGl_proc2718z00zz__openpgpzd2packetszd2, BGl_proc2717z00zz__openpgpzd2packetszd2, BFALSE, BGl_proc2716z00zz__openpgpzd2packetszd2, BFALSE, BgL_arg2222z00_1190, BgL_arg2223z00_1191); } 
{ /* Llib/pgp_packets.scm 95 */
obj_t BgL_arg2237z00_1221;obj_t BgL_arg2238z00_1222;
{ /* Llib/pgp_packets.scm 95 */
obj_t BgL_v1455z00_1234;
BgL_v1455z00_1234 = 
create_vector(((long)1)); 
{ /* Llib/pgp_packets.scm 95 */
obj_t BgL_arg2244z00_1235;
BgL_arg2244z00_1235 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)75)), BGl_proc2720z00zz__openpgpzd2packetszd2, BGl_proc2719z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)26))); 
VECTOR_SET(BgL_v1455z00_1234,((long)0),BgL_arg2244z00_1235); } 
BgL_arg2237z00_1221 = BgL_v1455z00_1234; } 
{ /* Llib/pgp_packets.scm 95 */
obj_t BgL_v1456z00_1245;
BgL_v1456z00_1245 = 
create_vector(((long)0)); 
BgL_arg2238z00_1222 = BgL_v1456z00_1245; } 
BGl_PGPzd2Signaturezd2Subzd2Preferredzd2Symmetricz00zz__openpgpzd2packetszd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)76)), 
CNST_TABLE_REF(((long)1)), BGl_PGPzd2Signaturezd2Subzd2Packetzd2zz__openpgpzd2packetszd2, ((long)983), BGl_proc2723z00zz__openpgpzd2packetszd2, BGl_proc2722z00zz__openpgpzd2packetszd2, BFALSE, BGl_proc2721z00zz__openpgpzd2packetszd2, BFALSE, BgL_arg2237z00_1221, BgL_arg2238z00_1222); } 
{ /* Llib/pgp_packets.scm 97 */
obj_t BgL_arg2252z00_1252;obj_t BgL_arg2253z00_1253;
{ /* Llib/pgp_packets.scm 97 */
obj_t BgL_v1457z00_1268;
BgL_v1457z00_1268 = 
create_vector(((long)4)); 
{ /* Llib/pgp_packets.scm 97 */
obj_t BgL_arg2259z00_1269;
BgL_arg2259z00_1269 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)77)), BGl_proc2725z00zz__openpgpzd2packetszd2, BGl_proc2724z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)78))); 
VECTOR_SET(BgL_v1457z00_1268,((long)0),BgL_arg2259z00_1269); } 
{ /* Llib/pgp_packets.scm 97 */
obj_t BgL_arg2264z00_1279;
BgL_arg2264z00_1279 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)79)), BGl_proc2727z00zz__openpgpzd2packetszd2, BGl_proc2726z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)32))); 
VECTOR_SET(BgL_v1457z00_1268,((long)1),BgL_arg2264z00_1279); } 
{ /* Llib/pgp_packets.scm 97 */
obj_t BgL_arg2269z00_1289;
BgL_arg2269z00_1289 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)80)), BGl_proc2729z00zz__openpgpzd2packetszd2, BGl_proc2728z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)78))); 
VECTOR_SET(BgL_v1457z00_1268,((long)2),BgL_arg2269z00_1289); } 
{ /* Llib/pgp_packets.scm 97 */
obj_t BgL_arg2274z00_1299;
BgL_arg2274z00_1299 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)81)), BGl_proc2731z00zz__openpgpzd2packetszd2, BGl_proc2730z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1457z00_1268,((long)3),BgL_arg2274z00_1299); } 
BgL_arg2252z00_1252 = BgL_v1457z00_1268; } 
{ /* Llib/pgp_packets.scm 97 */
obj_t BgL_v1458z00_1309;
BgL_v1458z00_1309 = 
create_vector(((long)0)); 
BgL_arg2253z00_1253 = BgL_v1458z00_1309; } 
BGl_PGPzd2Signaturezd2Subzd2Revocationzd2zz__openpgpzd2packetszd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)82)), 
CNST_TABLE_REF(((long)1)), BGl_PGPzd2Signaturezd2Subzd2Packetzd2zz__openpgpzd2packetszd2, ((long)49123), BGl_proc2734z00zz__openpgpzd2packetszd2, BGl_proc2733z00zz__openpgpzd2packetszd2, BFALSE, BGl_proc2732z00zz__openpgpzd2packetszd2, BFALSE, BgL_arg2252z00_1252, BgL_arg2253z00_1253); } 
{ /* Llib/pgp_packets.scm 102 */
obj_t BgL_arg2282z00_1316;obj_t BgL_arg2283z00_1317;
{ /* Llib/pgp_packets.scm 102 */
obj_t BgL_v1459z00_1329;
BgL_v1459z00_1329 = 
create_vector(((long)1)); 
{ /* Llib/pgp_packets.scm 102 */
obj_t BgL_arg2289z00_1330;
BgL_arg2289z00_1330 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)83)), BGl_proc2736z00zz__openpgpzd2packetszd2, BGl_proc2735z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1459z00_1329,((long)0),BgL_arg2289z00_1330); } 
BgL_arg2282z00_1316 = BgL_v1459z00_1329; } 
{ /* Llib/pgp_packets.scm 102 */
obj_t BgL_v1460z00_1340;
BgL_v1460z00_1340 = 
create_vector(((long)0)); 
BgL_arg2283z00_1317 = BgL_v1460z00_1340; } 
BGl_PGPzd2Signaturezd2Subzd2IDzd2zz__openpgpzd2packetszd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)84)), 
CNST_TABLE_REF(((long)1)), BGl_PGPzd2Signaturezd2Subzd2Packetzd2zz__openpgpzd2packetszd2, ((long)31441), BGl_proc2739z00zz__openpgpzd2packetszd2, BGl_proc2738z00zz__openpgpzd2packetszd2, BFALSE, BGl_proc2737z00zz__openpgpzd2packetszd2, BFALSE, BgL_arg2282z00_1316, BgL_arg2283z00_1317); } 
{ /* Llib/pgp_packets.scm 104 */
obj_t BgL_arg2297z00_1347;obj_t BgL_arg2298z00_1348;
{ /* Llib/pgp_packets.scm 104 */
obj_t BgL_v1461z00_1362;
BgL_v1461z00_1362 = 
create_vector(((long)3)); 
{ /* Llib/pgp_packets.scm 104 */
obj_t BgL_arg2304z00_1363;
BgL_arg2304z00_1363 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)85)), BGl_proc2741z00zz__openpgpzd2packetszd2, BGl_proc2740z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1461z00_1362,((long)0),BgL_arg2304z00_1363); } 
{ /* Llib/pgp_packets.scm 104 */
obj_t BgL_arg2309z00_1373;
BgL_arg2309z00_1373 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)86)), BGl_proc2743z00zz__openpgpzd2packetszd2, BGl_proc2742z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1461z00_1362,((long)1),BgL_arg2309z00_1373); } 
{ /* Llib/pgp_packets.scm 104 */
obj_t BgL_arg2314z00_1383;
BgL_arg2314z00_1383 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)87)), BGl_proc2745z00zz__openpgpzd2packetszd2, BGl_proc2744z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1461z00_1362,((long)2),BgL_arg2314z00_1383); } 
BgL_arg2297z00_1347 = BgL_v1461z00_1362; } 
{ /* Llib/pgp_packets.scm 104 */
obj_t BgL_v1462z00_1393;
BgL_v1462z00_1393 = 
create_vector(((long)0)); 
BgL_arg2298z00_1348 = BgL_v1462z00_1393; } 
BGl_PGPzd2Signaturezd2Subzd2Notationzd2zz__openpgpzd2packetszd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)88)), 
CNST_TABLE_REF(((long)1)), BGl_PGPzd2Signaturezd2Subzd2Packetzd2zz__openpgpzd2packetszd2, ((long)11778), BGl_proc2748z00zz__openpgpzd2packetszd2, BGl_proc2747z00zz__openpgpzd2packetszd2, BFALSE, BGl_proc2746z00zz__openpgpzd2packetszd2, BFALSE, BgL_arg2297z00_1347, BgL_arg2298z00_1348); } 
{ /* Llib/pgp_packets.scm 107 */
obj_t BgL_arg2322z00_1400;obj_t BgL_arg2323z00_1401;
{ /* Llib/pgp_packets.scm 107 */
obj_t BgL_v1463z00_1413;
BgL_v1463z00_1413 = 
create_vector(((long)1)); 
{ /* Llib/pgp_packets.scm 107 */
obj_t BgL_arg2329z00_1414;
BgL_arg2329z00_1414 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)75)), BGl_proc2750z00zz__openpgpzd2packetszd2, BGl_proc2749z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)26))); 
VECTOR_SET(BgL_v1463z00_1413,((long)0),BgL_arg2329z00_1414); } 
BgL_arg2322z00_1400 = BgL_v1463z00_1413; } 
{ /* Llib/pgp_packets.scm 107 */
obj_t BgL_v1464z00_1424;
BgL_v1464z00_1424 = 
create_vector(((long)0)); 
BgL_arg2323z00_1401 = BgL_v1464z00_1424; } 
BGl_PGPzd2Signaturezd2Subzd2Preferredzd2Hashz00zz__openpgpzd2packetszd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)89)), 
CNST_TABLE_REF(((long)1)), BGl_PGPzd2Signaturezd2Subzd2Packetzd2zz__openpgpzd2packetszd2, ((long)29934), BGl_proc2753z00zz__openpgpzd2packetszd2, BGl_proc2752z00zz__openpgpzd2packetszd2, BFALSE, BGl_proc2751z00zz__openpgpzd2packetszd2, BFALSE, BgL_arg2322z00_1400, BgL_arg2323z00_1401); } 
{ /* Llib/pgp_packets.scm 109 */
obj_t BgL_arg2337z00_1431;obj_t BgL_arg2338z00_1432;
{ /* Llib/pgp_packets.scm 109 */
obj_t BgL_v1465z00_1444;
BgL_v1465z00_1444 = 
create_vector(((long)1)); 
{ /* Llib/pgp_packets.scm 109 */
obj_t BgL_arg2344z00_1445;
BgL_arg2344z00_1445 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)75)), BGl_proc2755z00zz__openpgpzd2packetszd2, BGl_proc2754z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)26))); 
VECTOR_SET(BgL_v1465z00_1444,((long)0),BgL_arg2344z00_1445); } 
BgL_arg2337z00_1431 = BgL_v1465z00_1444; } 
{ /* Llib/pgp_packets.scm 109 */
obj_t BgL_v1466z00_1455;
BgL_v1466z00_1455 = 
create_vector(((long)0)); 
BgL_arg2338z00_1432 = BgL_v1466z00_1455; } 
BGl_PGPzd2Signaturezd2Subzd2Preferredzd2Compressionz00zz__openpgpzd2packetszd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)90)), 
CNST_TABLE_REF(((long)1)), BGl_PGPzd2Signaturezd2Subzd2Packetzd2zz__openpgpzd2packetszd2, ((long)47196), BGl_proc2758z00zz__openpgpzd2packetszd2, BGl_proc2757z00zz__openpgpzd2packetszd2, BFALSE, BGl_proc2756z00zz__openpgpzd2packetszd2, BFALSE, BgL_arg2337z00_1431, BgL_arg2338z00_1432); } 
{ /* Llib/pgp_packets.scm 111 */
obj_t BgL_arg2352z00_1462;obj_t BgL_arg2353z00_1463;
{ /* Llib/pgp_packets.scm 111 */
obj_t BgL_v1467z00_1475;
BgL_v1467z00_1475 = 
create_vector(((long)1)); 
{ /* Llib/pgp_packets.scm 111 */
obj_t BgL_arg2359z00_1476;
BgL_arg2359z00_1476 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)91)), BGl_proc2760z00zz__openpgpzd2packetszd2, BGl_proc2759z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1467z00_1475,((long)0),BgL_arg2359z00_1476); } 
BgL_arg2352z00_1462 = BgL_v1467z00_1475; } 
{ /* Llib/pgp_packets.scm 111 */
obj_t BgL_v1468z00_1486;
BgL_v1468z00_1486 = 
create_vector(((long)0)); 
BgL_arg2353z00_1463 = BgL_v1468z00_1486; } 
BGl_PGPzd2Signaturezd2Subzd2Preferredzd2Keyzd2Serverzd2zz__openpgpzd2packetszd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)92)), 
CNST_TABLE_REF(((long)1)), BGl_PGPzd2Signaturezd2Subzd2Packetzd2zz__openpgpzd2packetszd2, ((long)10017), BGl_proc2763z00zz__openpgpzd2packetszd2, BGl_proc2762z00zz__openpgpzd2packetszd2, BFALSE, BGl_proc2761z00zz__openpgpzd2packetszd2, BFALSE, BgL_arg2352z00_1462, BgL_arg2353z00_1463); } 
{ /* Llib/pgp_packets.scm 113 */
obj_t BgL_arg2367z00_1493;obj_t BgL_arg2368z00_1494;
{ /* Llib/pgp_packets.scm 113 */
obj_t BgL_v1469z00_1506;
BgL_v1469z00_1506 = 
create_vector(((long)1)); 
{ /* Llib/pgp_packets.scm 113 */
obj_t BgL_arg2374z00_1507;
BgL_arg2374z00_1507 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)93)), BGl_proc2765z00zz__openpgpzd2packetszd2, BGl_proc2764z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)32))); 
VECTOR_SET(BgL_v1469z00_1506,((long)0),BgL_arg2374z00_1507); } 
BgL_arg2367z00_1493 = BgL_v1469z00_1506; } 
{ /* Llib/pgp_packets.scm 113 */
obj_t BgL_v1470z00_1517;
BgL_v1470z00_1517 = 
create_vector(((long)0)); 
BgL_arg2368z00_1494 = BgL_v1470z00_1517; } 
BGl_PGPzd2Signaturezd2Subzd2Primaryzd2IDz00zz__openpgpzd2packetszd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)94)), 
CNST_TABLE_REF(((long)1)), BGl_PGPzd2Signaturezd2Subzd2Packetzd2zz__openpgpzd2packetszd2, ((long)4569), BGl_proc2768z00zz__openpgpzd2packetszd2, BGl_proc2767z00zz__openpgpzd2packetszd2, BFALSE, BGl_proc2766z00zz__openpgpzd2packetszd2, BFALSE, BgL_arg2367z00_1493, BgL_arg2368z00_1494); } 
{ /* Llib/pgp_packets.scm 115 */
obj_t BgL_arg2382z00_1524;obj_t BgL_arg2383z00_1525;
{ /* Llib/pgp_packets.scm 115 */
obj_t BgL_v1471z00_1537;
BgL_v1471z00_1537 = 
create_vector(((long)1)); 
{ /* Llib/pgp_packets.scm 115 */
obj_t BgL_arg2389z00_1538;
BgL_arg2389z00_1538 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)95)), BGl_proc2770z00zz__openpgpzd2packetszd2, BGl_proc2769z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1471z00_1537,((long)0),BgL_arg2389z00_1538); } 
BgL_arg2382z00_1524 = BgL_v1471z00_1537; } 
{ /* Llib/pgp_packets.scm 115 */
obj_t BgL_v1472z00_1548;
BgL_v1472z00_1548 = 
create_vector(((long)0)); 
BgL_arg2383z00_1525 = BgL_v1472z00_1548; } 
BGl_PGPzd2Signaturezd2Subzd2Policyzd2zz__openpgpzd2packetszd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)96)), 
CNST_TABLE_REF(((long)1)), BGl_PGPzd2Signaturezd2Subzd2Packetzd2zz__openpgpzd2packetszd2, ((long)38148), BGl_proc2773z00zz__openpgpzd2packetszd2, BGl_proc2772z00zz__openpgpzd2packetszd2, BFALSE, BGl_proc2771z00zz__openpgpzd2packetszd2, BFALSE, BgL_arg2382z00_1524, BgL_arg2383z00_1525); } 
{ /* Llib/pgp_packets.scm 117 */
obj_t BgL_arg2397z00_1555;obj_t BgL_arg2398z00_1556;
{ /* Llib/pgp_packets.scm 117 */
obj_t BgL_v1473z00_1568;
BgL_v1473z00_1568 = 
create_vector(((long)1)); 
{ /* Llib/pgp_packets.scm 117 */
obj_t BgL_arg2404z00_1569;
BgL_arg2404z00_1569 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)5)), BGl_proc2775z00zz__openpgpzd2packetszd2, BGl_proc2774z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1473z00_1568,((long)0),BgL_arg2404z00_1569); } 
BgL_arg2397z00_1555 = BgL_v1473z00_1568; } 
{ /* Llib/pgp_packets.scm 117 */
obj_t BgL_v1474z00_1579;
BgL_v1474z00_1579 = 
create_vector(((long)0)); 
BgL_arg2398z00_1556 = BgL_v1474z00_1579; } 
BGl_PGPzd2Signaturezd2Subzd2Signerzd2IDz00zz__openpgpzd2packetszd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)97)), 
CNST_TABLE_REF(((long)1)), BGl_PGPzd2Signaturezd2Subzd2Packetzd2zz__openpgpzd2packetszd2, ((long)31644), BGl_proc2778z00zz__openpgpzd2packetszd2, BGl_proc2777z00zz__openpgpzd2packetszd2, BFALSE, BGl_proc2776z00zz__openpgpzd2packetszd2, BFALSE, BgL_arg2397z00_1555, BgL_arg2398z00_1556); } 
{ /* Llib/pgp_packets.scm 119 */
obj_t BgL_arg2412z00_1586;obj_t BgL_arg2413z00_1587;
{ /* Llib/pgp_packets.scm 119 */
obj_t BgL_v1475z00_1600;
BgL_v1475z00_1600 = 
create_vector(((long)2)); 
{ /* Llib/pgp_packets.scm 119 */
obj_t BgL_arg2419z00_1601;
BgL_arg2419z00_1601 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)98)), BGl_proc2780z00zz__openpgpzd2packetszd2, BGl_proc2779z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)8))); 
VECTOR_SET(BgL_v1475z00_1600,((long)0),BgL_arg2419z00_1601); } 
{ /* Llib/pgp_packets.scm 119 */
obj_t BgL_arg2424z00_1611;
BgL_arg2424z00_1611 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)99)), BGl_proc2782z00zz__openpgpzd2packetszd2, BGl_proc2781z00zz__openpgpzd2packetszd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1475z00_1600,((long)1),BgL_arg2424z00_1611); } 
BgL_arg2412z00_1586 = BgL_v1475z00_1600; } 
{ /* Llib/pgp_packets.scm 119 */
obj_t BgL_v1476z00_1621;
BgL_v1476z00_1621 = 
create_vector(((long)0)); 
BgL_arg2413z00_1587 = BgL_v1476z00_1621; } 
return ( 
BGl_PGPzd2Signaturezd2Subzd2Revocationzd2Reasonz00zz__openpgpzd2packetszd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)100)), 
CNST_TABLE_REF(((long)1)), BGl_PGPzd2Signaturezd2Subzd2Packetzd2zz__openpgpzd2packetszd2, ((long)45119), BGl_proc2785z00zz__openpgpzd2packetszd2, BGl_proc2784z00zz__openpgpzd2packetszd2, BFALSE, BGl_proc2783z00zz__openpgpzd2packetszd2, BFALSE, BgL_arg2412z00_1586, BgL_arg2413z00_1587), BUNSPEC) ;} } 

}



/* &<@anonymous:2418> */
obj_t BGl_z62zc3z04anonymousza32418ze3ze5zz__openpgpzd2packetszd2(obj_t BgL_envz00_2448, obj_t BgL_new1311z00_2449)
{
{ /* Llib/pgp_packets.scm 119 */
{ 
BgL_pgpzd2signaturezd2subzd2revocationzd2reasonz00_bglt BgL_auxz00_4285;
((((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)
((BgL_pgpzd2signaturezd2subzd2revocationzd2reasonz00_bglt)BgL_new1311z00_2449))))->BgL_criticalzf3zf3)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2revocationzd2reasonz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2revocationzd2reasonz00_bglt)BgL_new1311z00_2449)))->BgL_codez00)=((obj_t)
CNST_TABLE_REF(((long)101))),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2revocationzd2reasonz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2revocationzd2reasonz00_bglt)BgL_new1311z00_2449)))->BgL_reasonz00)=((obj_t)BGl_string2786z00zz__openpgpzd2packetszd2),BUNSPEC); 
BgL_auxz00_4285 = 
((BgL_pgpzd2signaturezd2subzd2revocationzd2reasonz00_bglt)BgL_new1311z00_2449); 
return 
((obj_t)BgL_auxz00_4285);} } 

}



/* &lambda2416 */
BgL_pgpzd2signaturezd2subzd2revocationzd2reasonz00_bglt BGl_z62lambda2416z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2450)
{
{ /* Llib/pgp_packets.scm 119 */
{ /* Llib/pgp_packets.scm 119 */
BgL_pgpzd2signaturezd2subzd2revocationzd2reasonz00_bglt BgL_new1310z00_3110;
BgL_new1310z00_3110 = 
((BgL_pgpzd2signaturezd2subzd2revocationzd2reasonz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2subzd2revocationzd2reasonz00_bgl) ))); 
{ /* Llib/pgp_packets.scm 119 */
long BgL_arg2417z00_3111;
{ /* Llib/pgp_packets.scm 119 */
long BgL_res2523z00_3112;
BgL_res2523z00_3112 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2Subzd2Revocationzd2Reasonz00zz__openpgpzd2packetszd2); 
BgL_arg2417z00_3111 = BgL_res2523z00_3112; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1310z00_3110), BgL_arg2417z00_3111); } 
{ /* Llib/pgp_packets.scm 119 */
BgL_objectz00_bglt BgL_tmpz00_4300;
BgL_tmpz00_4300 = 
((BgL_objectz00_bglt)BgL_new1310z00_3110); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4300, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1310z00_3110); 
return BgL_new1310z00_3110;} } 

}



/* &lambda2414 */
BgL_pgpzd2signaturezd2subzd2revocationzd2reasonz00_bglt BGl_z62lambda2414z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2451, obj_t BgL_criticalzf31307zf3_2452, obj_t BgL_code1308z00_2453, obj_t BgL_reason1309z00_2454)
{
{ /* Llib/pgp_packets.scm 119 */
{ /* Llib/pgp_packets.scm 119 */
bool_t BgL_criticalzf31307zf3_3113;
BgL_criticalzf31307zf3_3113 = 
CBOOL(BgL_criticalzf31307zf3_2452); 
{ /* Llib/pgp_packets.scm 119 */
BgL_pgpzd2signaturezd2subzd2revocationzd2reasonz00_bglt BgL_new1394z00_3116;
{ /* Llib/pgp_packets.scm 119 */
BgL_pgpzd2signaturezd2subzd2revocationzd2reasonz00_bglt BgL_new1393z00_3117;
BgL_new1393z00_3117 = 
((BgL_pgpzd2signaturezd2subzd2revocationzd2reasonz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2subzd2revocationzd2reasonz00_bgl) ))); 
{ /* Llib/pgp_packets.scm 119 */
long BgL_arg2415z00_3118;
{ /* Llib/pgp_packets.scm 119 */
long BgL_res2522z00_3119;
BgL_res2522z00_3119 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2Subzd2Revocationzd2Reasonz00zz__openpgpzd2packetszd2); 
BgL_arg2415z00_3118 = BgL_res2522z00_3119; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1393z00_3117), BgL_arg2415z00_3118); } 
{ /* Llib/pgp_packets.scm 119 */
BgL_objectz00_bglt BgL_tmpz00_4309;
BgL_tmpz00_4309 = 
((BgL_objectz00_bglt)BgL_new1393z00_3117); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4309, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1393z00_3117); 
BgL_new1394z00_3116 = BgL_new1393z00_3117; } 
((((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)BgL_new1394z00_3116)))->BgL_criticalzf3zf3)=((bool_t)BgL_criticalzf31307zf3_3113),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2revocationzd2reasonz00_bglt)COBJECT(BgL_new1394z00_3116))->BgL_codez00)=((obj_t)
((obj_t)BgL_code1308z00_2453)),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2revocationzd2reasonz00_bglt)COBJECT(BgL_new1394z00_3116))->BgL_reasonz00)=((obj_t)
((obj_t)BgL_reason1309z00_2454)),BUNSPEC); 
return BgL_new1394z00_3116;} } } 

}



/* &lambda2428 */
obj_t BGl_z62lambda2428z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2455, obj_t BgL_oz00_2456, obj_t BgL_vz00_2457)
{
{ /* Llib/pgp_packets.scm 119 */
return 
((((BgL_pgpzd2signaturezd2subzd2revocationzd2reasonz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2revocationzd2reasonz00_bglt)BgL_oz00_2456)))->BgL_reasonz00)=((obj_t)
((obj_t)BgL_vz00_2457)),BUNSPEC);} 

}



/* &lambda2427 */
obj_t BGl_z62lambda2427z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2458, obj_t BgL_oz00_2459)
{
{ /* Llib/pgp_packets.scm 119 */
return 
(((BgL_pgpzd2signaturezd2subzd2revocationzd2reasonz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2revocationzd2reasonz00_bglt)BgL_oz00_2459)))->BgL_reasonz00);} 

}



/* &lambda2423 */
obj_t BGl_z62lambda2423z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2460, obj_t BgL_oz00_2461, obj_t BgL_vz00_2462)
{
{ /* Llib/pgp_packets.scm 119 */
return 
((((BgL_pgpzd2signaturezd2subzd2revocationzd2reasonz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2revocationzd2reasonz00_bglt)BgL_oz00_2461)))->BgL_codez00)=((obj_t)
((obj_t)BgL_vz00_2462)),BUNSPEC);} 

}



/* &lambda2422 */
obj_t BGl_z62lambda2422z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2463, obj_t BgL_oz00_2464)
{
{ /* Llib/pgp_packets.scm 119 */
return 
(((BgL_pgpzd2signaturezd2subzd2revocationzd2reasonz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2revocationzd2reasonz00_bglt)BgL_oz00_2464)))->BgL_codez00);} 

}



/* &<@anonymous:2403> */
obj_t BGl_z62zc3z04anonymousza32403ze3ze5zz__openpgpzd2packetszd2(obj_t BgL_envz00_2465, obj_t BgL_new1305z00_2466)
{
{ /* Llib/pgp_packets.scm 117 */
{ 
BgL_pgpzd2signaturezd2subzd2signerzd2idz00_bglt BgL_auxz00_4329;
((((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)
((BgL_pgpzd2signaturezd2subzd2signerzd2idz00_bglt)BgL_new1305z00_2466))))->BgL_criticalzf3zf3)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2signerzd2idz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2signerzd2idz00_bglt)BgL_new1305z00_2466)))->BgL_idz00)=((obj_t)BGl_string2786z00zz__openpgpzd2packetszd2),BUNSPEC); 
BgL_auxz00_4329 = 
((BgL_pgpzd2signaturezd2subzd2signerzd2idz00_bglt)BgL_new1305z00_2466); 
return 
((obj_t)BgL_auxz00_4329);} } 

}



/* &lambda2401 */
BgL_pgpzd2signaturezd2subzd2signerzd2idz00_bglt BGl_z62lambda2401z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2467)
{
{ /* Llib/pgp_packets.scm 117 */
{ /* Llib/pgp_packets.scm 117 */
BgL_pgpzd2signaturezd2subzd2signerzd2idz00_bglt BgL_new1304z00_3127;
BgL_new1304z00_3127 = 
((BgL_pgpzd2signaturezd2subzd2signerzd2idz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2subzd2signerzd2idz00_bgl) ))); 
{ /* Llib/pgp_packets.scm 117 */
long BgL_arg2402z00_3128;
{ /* Llib/pgp_packets.scm 117 */
long BgL_res2521z00_3129;
BgL_res2521z00_3129 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2Subzd2Signerzd2IDz00zz__openpgpzd2packetszd2); 
BgL_arg2402z00_3128 = BgL_res2521z00_3129; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1304z00_3127), BgL_arg2402z00_3128); } 
{ /* Llib/pgp_packets.scm 117 */
BgL_objectz00_bglt BgL_tmpz00_4341;
BgL_tmpz00_4341 = 
((BgL_objectz00_bglt)BgL_new1304z00_3127); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4341, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1304z00_3127); 
return BgL_new1304z00_3127;} } 

}



/* &lambda2399 */
BgL_pgpzd2signaturezd2subzd2signerzd2idz00_bglt BGl_z62lambda2399z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2468, obj_t BgL_criticalzf31302zf3_2469, obj_t BgL_id1303z00_2470)
{
{ /* Llib/pgp_packets.scm 117 */
{ /* Llib/pgp_packets.scm 117 */
bool_t BgL_criticalzf31302zf3_3130;
BgL_criticalzf31302zf3_3130 = 
CBOOL(BgL_criticalzf31302zf3_2469); 
{ /* Llib/pgp_packets.scm 117 */
BgL_pgpzd2signaturezd2subzd2signerzd2idz00_bglt BgL_new1392z00_3132;
{ /* Llib/pgp_packets.scm 117 */
BgL_pgpzd2signaturezd2subzd2signerzd2idz00_bglt BgL_new1391z00_3133;
BgL_new1391z00_3133 = 
((BgL_pgpzd2signaturezd2subzd2signerzd2idz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2subzd2signerzd2idz00_bgl) ))); 
{ /* Llib/pgp_packets.scm 117 */
long BgL_arg2400z00_3134;
{ /* Llib/pgp_packets.scm 117 */
long BgL_res2520z00_3135;
BgL_res2520z00_3135 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2Subzd2Signerzd2IDz00zz__openpgpzd2packetszd2); 
BgL_arg2400z00_3134 = BgL_res2520z00_3135; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1391z00_3133), BgL_arg2400z00_3134); } 
{ /* Llib/pgp_packets.scm 117 */
BgL_objectz00_bglt BgL_tmpz00_4350;
BgL_tmpz00_4350 = 
((BgL_objectz00_bglt)BgL_new1391z00_3133); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4350, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1391z00_3133); 
BgL_new1392z00_3132 = BgL_new1391z00_3133; } 
((((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)BgL_new1392z00_3132)))->BgL_criticalzf3zf3)=((bool_t)BgL_criticalzf31302zf3_3130),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2signerzd2idz00_bglt)COBJECT(BgL_new1392z00_3132))->BgL_idz00)=((obj_t)
((obj_t)BgL_id1303z00_2470)),BUNSPEC); 
return BgL_new1392z00_3132;} } } 

}



/* &lambda2408 */
obj_t BGl_z62lambda2408z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2471, obj_t BgL_oz00_2472, obj_t BgL_vz00_2473)
{
{ /* Llib/pgp_packets.scm 117 */
return 
((((BgL_pgpzd2signaturezd2subzd2signerzd2idz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2signerzd2idz00_bglt)BgL_oz00_2472)))->BgL_idz00)=((obj_t)
((obj_t)BgL_vz00_2473)),BUNSPEC);} 

}



/* &lambda2407 */
obj_t BGl_z62lambda2407z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2474, obj_t BgL_oz00_2475)
{
{ /* Llib/pgp_packets.scm 117 */
return 
(((BgL_pgpzd2signaturezd2subzd2signerzd2idz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2signerzd2idz00_bglt)BgL_oz00_2475)))->BgL_idz00);} 

}



/* &<@anonymous:2388> */
obj_t BGl_z62zc3z04anonymousza32388ze3ze5zz__openpgpzd2packetszd2(obj_t BgL_envz00_2476, obj_t BgL_new1300z00_2477)
{
{ /* Llib/pgp_packets.scm 115 */
{ 
BgL_pgpzd2signaturezd2subzd2policyzd2_bglt BgL_auxz00_4363;
((((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)
((BgL_pgpzd2signaturezd2subzd2policyzd2_bglt)BgL_new1300z00_2477))))->BgL_criticalzf3zf3)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2policyzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2policyzd2_bglt)BgL_new1300z00_2477)))->BgL_urlz00)=((obj_t)BGl_string2786z00zz__openpgpzd2packetszd2),BUNSPEC); 
BgL_auxz00_4363 = 
((BgL_pgpzd2signaturezd2subzd2policyzd2_bglt)BgL_new1300z00_2477); 
return 
((obj_t)BgL_auxz00_4363);} } 

}



/* &lambda2386 */
BgL_pgpzd2signaturezd2subzd2policyzd2_bglt BGl_z62lambda2386z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2478)
{
{ /* Llib/pgp_packets.scm 115 */
{ /* Llib/pgp_packets.scm 115 */
BgL_pgpzd2signaturezd2subzd2policyzd2_bglt BgL_new1299z00_3140;
BgL_new1299z00_3140 = 
((BgL_pgpzd2signaturezd2subzd2policyzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2subzd2policyzd2_bgl) ))); 
{ /* Llib/pgp_packets.scm 115 */
long BgL_arg2387z00_3141;
{ /* Llib/pgp_packets.scm 115 */
long BgL_res2519z00_3142;
BgL_res2519z00_3142 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2Subzd2Policyzd2zz__openpgpzd2packetszd2); 
BgL_arg2387z00_3141 = BgL_res2519z00_3142; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1299z00_3140), BgL_arg2387z00_3141); } 
{ /* Llib/pgp_packets.scm 115 */
BgL_objectz00_bglt BgL_tmpz00_4375;
BgL_tmpz00_4375 = 
((BgL_objectz00_bglt)BgL_new1299z00_3140); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4375, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1299z00_3140); 
return BgL_new1299z00_3140;} } 

}



/* &lambda2384 */
BgL_pgpzd2signaturezd2subzd2policyzd2_bglt BGl_z62lambda2384z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2479, obj_t BgL_criticalzf31297zf3_2480, obj_t BgL_url1298z00_2481)
{
{ /* Llib/pgp_packets.scm 115 */
{ /* Llib/pgp_packets.scm 115 */
bool_t BgL_criticalzf31297zf3_3143;
BgL_criticalzf31297zf3_3143 = 
CBOOL(BgL_criticalzf31297zf3_2480); 
{ /* Llib/pgp_packets.scm 115 */
BgL_pgpzd2signaturezd2subzd2policyzd2_bglt BgL_new1390z00_3145;
{ /* Llib/pgp_packets.scm 115 */
BgL_pgpzd2signaturezd2subzd2policyzd2_bglt BgL_new1389z00_3146;
BgL_new1389z00_3146 = 
((BgL_pgpzd2signaturezd2subzd2policyzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2subzd2policyzd2_bgl) ))); 
{ /* Llib/pgp_packets.scm 115 */
long BgL_arg2385z00_3147;
{ /* Llib/pgp_packets.scm 115 */
long BgL_res2518z00_3148;
BgL_res2518z00_3148 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2Subzd2Policyzd2zz__openpgpzd2packetszd2); 
BgL_arg2385z00_3147 = BgL_res2518z00_3148; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1389z00_3146), BgL_arg2385z00_3147); } 
{ /* Llib/pgp_packets.scm 115 */
BgL_objectz00_bglt BgL_tmpz00_4384;
BgL_tmpz00_4384 = 
((BgL_objectz00_bglt)BgL_new1389z00_3146); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4384, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1389z00_3146); 
BgL_new1390z00_3145 = BgL_new1389z00_3146; } 
((((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)BgL_new1390z00_3145)))->BgL_criticalzf3zf3)=((bool_t)BgL_criticalzf31297zf3_3143),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2policyzd2_bglt)COBJECT(BgL_new1390z00_3145))->BgL_urlz00)=((obj_t)
((obj_t)BgL_url1298z00_2481)),BUNSPEC); 
return BgL_new1390z00_3145;} } } 

}



/* &lambda2393 */
obj_t BGl_z62lambda2393z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2482, obj_t BgL_oz00_2483, obj_t BgL_vz00_2484)
{
{ /* Llib/pgp_packets.scm 115 */
return 
((((BgL_pgpzd2signaturezd2subzd2policyzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2policyzd2_bglt)BgL_oz00_2483)))->BgL_urlz00)=((obj_t)
((obj_t)BgL_vz00_2484)),BUNSPEC);} 

}



/* &lambda2392 */
obj_t BGl_z62lambda2392z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2485, obj_t BgL_oz00_2486)
{
{ /* Llib/pgp_packets.scm 115 */
return 
(((BgL_pgpzd2signaturezd2subzd2policyzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2policyzd2_bglt)BgL_oz00_2486)))->BgL_urlz00);} 

}



/* &<@anonymous:2373> */
obj_t BGl_z62zc3z04anonymousza32373ze3ze5zz__openpgpzd2packetszd2(obj_t BgL_envz00_2487, obj_t BgL_new1295z00_2488)
{
{ /* Llib/pgp_packets.scm 113 */
{ 
BgL_pgpzd2signaturezd2subzd2primaryzd2idz00_bglt BgL_auxz00_4397;
((((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)
((BgL_pgpzd2signaturezd2subzd2primaryzd2idz00_bglt)BgL_new1295z00_2488))))->BgL_criticalzf3zf3)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2primaryzd2idz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2primaryzd2idz00_bglt)BgL_new1295z00_2488)))->BgL_primaryzf3zf3)=((bool_t)((bool_t)0)),BUNSPEC); 
BgL_auxz00_4397 = 
((BgL_pgpzd2signaturezd2subzd2primaryzd2idz00_bglt)BgL_new1295z00_2488); 
return 
((obj_t)BgL_auxz00_4397);} } 

}



/* &lambda2371 */
BgL_pgpzd2signaturezd2subzd2primaryzd2idz00_bglt BGl_z62lambda2371z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2489)
{
{ /* Llib/pgp_packets.scm 113 */
{ /* Llib/pgp_packets.scm 113 */
BgL_pgpzd2signaturezd2subzd2primaryzd2idz00_bglt BgL_new1294z00_3153;
BgL_new1294z00_3153 = 
((BgL_pgpzd2signaturezd2subzd2primaryzd2idz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2subzd2primaryzd2idz00_bgl) ))); 
{ /* Llib/pgp_packets.scm 113 */
long BgL_arg2372z00_3154;
{ /* Llib/pgp_packets.scm 113 */
long BgL_res2517z00_3155;
BgL_res2517z00_3155 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2Subzd2Primaryzd2IDz00zz__openpgpzd2packetszd2); 
BgL_arg2372z00_3154 = BgL_res2517z00_3155; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1294z00_3153), BgL_arg2372z00_3154); } 
{ /* Llib/pgp_packets.scm 113 */
BgL_objectz00_bglt BgL_tmpz00_4409;
BgL_tmpz00_4409 = 
((BgL_objectz00_bglt)BgL_new1294z00_3153); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4409, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1294z00_3153); 
return BgL_new1294z00_3153;} } 

}



/* &lambda2369 */
BgL_pgpzd2signaturezd2subzd2primaryzd2idz00_bglt BGl_z62lambda2369z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2490, obj_t BgL_criticalzf31292zf3_2491, obj_t BgL_primaryzf31293zf3_2492)
{
{ /* Llib/pgp_packets.scm 113 */
{ /* Llib/pgp_packets.scm 113 */
bool_t BgL_criticalzf31292zf3_3156;bool_t BgL_primaryzf31293zf3_3157;
BgL_criticalzf31292zf3_3156 = 
CBOOL(BgL_criticalzf31292zf3_2491); 
BgL_primaryzf31293zf3_3157 = 
CBOOL(BgL_primaryzf31293zf3_2492); 
{ /* Llib/pgp_packets.scm 113 */
BgL_pgpzd2signaturezd2subzd2primaryzd2idz00_bglt BgL_new1388z00_3158;
{ /* Llib/pgp_packets.scm 113 */
BgL_pgpzd2signaturezd2subzd2primaryzd2idz00_bglt BgL_new1387z00_3159;
BgL_new1387z00_3159 = 
((BgL_pgpzd2signaturezd2subzd2primaryzd2idz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2subzd2primaryzd2idz00_bgl) ))); 
{ /* Llib/pgp_packets.scm 113 */
long BgL_arg2370z00_3160;
{ /* Llib/pgp_packets.scm 113 */
long BgL_res2516z00_3161;
BgL_res2516z00_3161 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2Subzd2Primaryzd2IDz00zz__openpgpzd2packetszd2); 
BgL_arg2370z00_3160 = BgL_res2516z00_3161; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1387z00_3159), BgL_arg2370z00_3160); } 
{ /* Llib/pgp_packets.scm 113 */
BgL_objectz00_bglt BgL_tmpz00_4419;
BgL_tmpz00_4419 = 
((BgL_objectz00_bglt)BgL_new1387z00_3159); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4419, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1387z00_3159); 
BgL_new1388z00_3158 = BgL_new1387z00_3159; } 
((((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)BgL_new1388z00_3158)))->BgL_criticalzf3zf3)=((bool_t)BgL_criticalzf31292zf3_3156),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2primaryzd2idz00_bglt)COBJECT(BgL_new1388z00_3158))->BgL_primaryzf3zf3)=((bool_t)BgL_primaryzf31293zf3_3157),BUNSPEC); 
return BgL_new1388z00_3158;} } } 

}



/* &lambda2378 */
obj_t BGl_z62lambda2378z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2493, obj_t BgL_oz00_2494, obj_t BgL_vz00_2495)
{
{ /* Llib/pgp_packets.scm 113 */
{ /* Llib/pgp_packets.scm 113 */
bool_t BgL_vz00_3163;
BgL_vz00_3163 = 
CBOOL(BgL_vz00_2495); 
return 
((((BgL_pgpzd2signaturezd2subzd2primaryzd2idz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2primaryzd2idz00_bglt)BgL_oz00_2494)))->BgL_primaryzf3zf3)=((bool_t)BgL_vz00_3163),BUNSPEC);} } 

}



/* &lambda2377 */
obj_t BGl_z62lambda2377z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2496, obj_t BgL_oz00_2497)
{
{ /* Llib/pgp_packets.scm 113 */
return 
BBOOL(
(((BgL_pgpzd2signaturezd2subzd2primaryzd2idz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2primaryzd2idz00_bglt)BgL_oz00_2497)))->BgL_primaryzf3zf3));} 

}



/* &<@anonymous:2358> */
obj_t BGl_z62zc3z04anonymousza32358ze3ze5zz__openpgpzd2packetszd2(obj_t BgL_envz00_2498, obj_t BgL_new1290z00_2499)
{
{ /* Llib/pgp_packets.scm 111 */
{ 
BgL_pgpzd2signaturezd2subzd2preferredzd2keyzd2serverzd2_bglt BgL_auxz00_4432;
((((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)
((BgL_pgpzd2signaturezd2subzd2preferredzd2keyzd2serverzd2_bglt)BgL_new1290z00_2499))))->BgL_criticalzf3zf3)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2preferredzd2keyzd2serverzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2preferredzd2keyzd2serverzd2_bglt)BgL_new1290z00_2499)))->BgL_serverz00)=((obj_t)BGl_string2786z00zz__openpgpzd2packetszd2),BUNSPEC); 
BgL_auxz00_4432 = 
((BgL_pgpzd2signaturezd2subzd2preferredzd2keyzd2serverzd2_bglt)BgL_new1290z00_2499); 
return 
((obj_t)BgL_auxz00_4432);} } 

}



/* &lambda2356 */
BgL_pgpzd2signaturezd2subzd2preferredzd2keyzd2serverzd2_bglt BGl_z62lambda2356z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2500)
{
{ /* Llib/pgp_packets.scm 111 */
{ /* Llib/pgp_packets.scm 111 */
BgL_pgpzd2signaturezd2subzd2preferredzd2keyzd2serverzd2_bglt BgL_new1289z00_3166;
BgL_new1289z00_3166 = 
((BgL_pgpzd2signaturezd2subzd2preferredzd2keyzd2serverzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2subzd2preferredzd2keyzd2serverzd2_bgl) ))); 
{ /* Llib/pgp_packets.scm 111 */
long BgL_arg2357z00_3167;
{ /* Llib/pgp_packets.scm 111 */
long BgL_res2515z00_3168;
BgL_res2515z00_3168 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2Subzd2Preferredzd2Keyzd2Serverzd2zz__openpgpzd2packetszd2); 
BgL_arg2357z00_3167 = BgL_res2515z00_3168; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1289z00_3166), BgL_arg2357z00_3167); } 
{ /* Llib/pgp_packets.scm 111 */
BgL_objectz00_bglt BgL_tmpz00_4444;
BgL_tmpz00_4444 = 
((BgL_objectz00_bglt)BgL_new1289z00_3166); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4444, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1289z00_3166); 
return BgL_new1289z00_3166;} } 

}



/* &lambda2354 */
BgL_pgpzd2signaturezd2subzd2preferredzd2keyzd2serverzd2_bglt BGl_z62lambda2354z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2501, obj_t BgL_criticalzf31287zf3_2502, obj_t BgL_server1288z00_2503)
{
{ /* Llib/pgp_packets.scm 111 */
{ /* Llib/pgp_packets.scm 111 */
bool_t BgL_criticalzf31287zf3_3169;
BgL_criticalzf31287zf3_3169 = 
CBOOL(BgL_criticalzf31287zf3_2502); 
{ /* Llib/pgp_packets.scm 111 */
BgL_pgpzd2signaturezd2subzd2preferredzd2keyzd2serverzd2_bglt BgL_new1386z00_3171;
{ /* Llib/pgp_packets.scm 111 */
BgL_pgpzd2signaturezd2subzd2preferredzd2keyzd2serverzd2_bglt BgL_new1385z00_3172;
BgL_new1385z00_3172 = 
((BgL_pgpzd2signaturezd2subzd2preferredzd2keyzd2serverzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2subzd2preferredzd2keyzd2serverzd2_bgl) ))); 
{ /* Llib/pgp_packets.scm 111 */
long BgL_arg2355z00_3173;
{ /* Llib/pgp_packets.scm 111 */
long BgL_res2514z00_3174;
BgL_res2514z00_3174 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2Subzd2Preferredzd2Keyzd2Serverzd2zz__openpgpzd2packetszd2); 
BgL_arg2355z00_3173 = BgL_res2514z00_3174; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1385z00_3172), BgL_arg2355z00_3173); } 
{ /* Llib/pgp_packets.scm 111 */
BgL_objectz00_bglt BgL_tmpz00_4453;
BgL_tmpz00_4453 = 
((BgL_objectz00_bglt)BgL_new1385z00_3172); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4453, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1385z00_3172); 
BgL_new1386z00_3171 = BgL_new1385z00_3172; } 
((((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)BgL_new1386z00_3171)))->BgL_criticalzf3zf3)=((bool_t)BgL_criticalzf31287zf3_3169),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2preferredzd2keyzd2serverzd2_bglt)COBJECT(BgL_new1386z00_3171))->BgL_serverz00)=((obj_t)
((obj_t)BgL_server1288z00_2503)),BUNSPEC); 
return BgL_new1386z00_3171;} } } 

}



/* &lambda2363 */
obj_t BGl_z62lambda2363z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2504, obj_t BgL_oz00_2505, obj_t BgL_vz00_2506)
{
{ /* Llib/pgp_packets.scm 111 */
return 
((((BgL_pgpzd2signaturezd2subzd2preferredzd2keyzd2serverzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2preferredzd2keyzd2serverzd2_bglt)BgL_oz00_2505)))->BgL_serverz00)=((obj_t)
((obj_t)BgL_vz00_2506)),BUNSPEC);} 

}



/* &lambda2362 */
obj_t BGl_z62lambda2362z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2507, obj_t BgL_oz00_2508)
{
{ /* Llib/pgp_packets.scm 111 */
return 
(((BgL_pgpzd2signaturezd2subzd2preferredzd2keyzd2serverzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2preferredzd2keyzd2serverzd2_bglt)BgL_oz00_2508)))->BgL_serverz00);} 

}



/* &<@anonymous:2343> */
obj_t BGl_z62zc3z04anonymousza32343ze3ze5zz__openpgpzd2packetszd2(obj_t BgL_envz00_2509, obj_t BgL_new1285z00_2510)
{
{ /* Llib/pgp_packets.scm 109 */
{ 
BgL_pgpzd2signaturezd2subzd2preferredzd2compressionz00_bglt BgL_auxz00_4466;
((((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)
((BgL_pgpzd2signaturezd2subzd2preferredzd2compressionz00_bglt)BgL_new1285z00_2510))))->BgL_criticalzf3zf3)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2preferredzd2compressionz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2preferredzd2compressionz00_bglt)BgL_new1285z00_2510)))->BgL_algosz00)=((obj_t)BNIL),BUNSPEC); 
BgL_auxz00_4466 = 
((BgL_pgpzd2signaturezd2subzd2preferredzd2compressionz00_bglt)BgL_new1285z00_2510); 
return 
((obj_t)BgL_auxz00_4466);} } 

}



/* &lambda2341 */
BgL_pgpzd2signaturezd2subzd2preferredzd2compressionz00_bglt BGl_z62lambda2341z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2511)
{
{ /* Llib/pgp_packets.scm 109 */
{ /* Llib/pgp_packets.scm 109 */
BgL_pgpzd2signaturezd2subzd2preferredzd2compressionz00_bglt BgL_new1284z00_3179;
BgL_new1284z00_3179 = 
((BgL_pgpzd2signaturezd2subzd2preferredzd2compressionz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2subzd2preferredzd2compressionz00_bgl) ))); 
{ /* Llib/pgp_packets.scm 109 */
long BgL_arg2342z00_3180;
{ /* Llib/pgp_packets.scm 109 */
long BgL_res2513z00_3181;
BgL_res2513z00_3181 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2Subzd2Preferredzd2Compressionz00zz__openpgpzd2packetszd2); 
BgL_arg2342z00_3180 = BgL_res2513z00_3181; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1284z00_3179), BgL_arg2342z00_3180); } 
{ /* Llib/pgp_packets.scm 109 */
BgL_objectz00_bglt BgL_tmpz00_4478;
BgL_tmpz00_4478 = 
((BgL_objectz00_bglt)BgL_new1284z00_3179); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4478, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1284z00_3179); 
return BgL_new1284z00_3179;} } 

}



/* &lambda2339 */
BgL_pgpzd2signaturezd2subzd2preferredzd2compressionz00_bglt BGl_z62lambda2339z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2512, obj_t BgL_criticalzf31282zf3_2513, obj_t BgL_algos1283z00_2514)
{
{ /* Llib/pgp_packets.scm 109 */
{ /* Llib/pgp_packets.scm 109 */
bool_t BgL_criticalzf31282zf3_3182;
BgL_criticalzf31282zf3_3182 = 
CBOOL(BgL_criticalzf31282zf3_2513); 
{ /* Llib/pgp_packets.scm 109 */
BgL_pgpzd2signaturezd2subzd2preferredzd2compressionz00_bglt BgL_new1384z00_3184;
{ /* Llib/pgp_packets.scm 109 */
BgL_pgpzd2signaturezd2subzd2preferredzd2compressionz00_bglt BgL_new1383z00_3185;
BgL_new1383z00_3185 = 
((BgL_pgpzd2signaturezd2subzd2preferredzd2compressionz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2subzd2preferredzd2compressionz00_bgl) ))); 
{ /* Llib/pgp_packets.scm 109 */
long BgL_arg2340z00_3186;
{ /* Llib/pgp_packets.scm 109 */
long BgL_res2512z00_3187;
BgL_res2512z00_3187 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2Subzd2Preferredzd2Compressionz00zz__openpgpzd2packetszd2); 
BgL_arg2340z00_3186 = BgL_res2512z00_3187; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1383z00_3185), BgL_arg2340z00_3186); } 
{ /* Llib/pgp_packets.scm 109 */
BgL_objectz00_bglt BgL_tmpz00_4487;
BgL_tmpz00_4487 = 
((BgL_objectz00_bglt)BgL_new1383z00_3185); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4487, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1383z00_3185); 
BgL_new1384z00_3184 = BgL_new1383z00_3185; } 
((((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)BgL_new1384z00_3184)))->BgL_criticalzf3zf3)=((bool_t)BgL_criticalzf31282zf3_3182),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2preferredzd2compressionz00_bglt)COBJECT(BgL_new1384z00_3184))->BgL_algosz00)=((obj_t)
((obj_t)BgL_algos1283z00_2514)),BUNSPEC); 
return BgL_new1384z00_3184;} } } 

}



/* &lambda2348 */
obj_t BGl_z62lambda2348z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2515, obj_t BgL_oz00_2516, obj_t BgL_vz00_2517)
{
{ /* Llib/pgp_packets.scm 109 */
return 
((((BgL_pgpzd2signaturezd2subzd2preferredzd2compressionz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2preferredzd2compressionz00_bglt)BgL_oz00_2516)))->BgL_algosz00)=((obj_t)
((obj_t)BgL_vz00_2517)),BUNSPEC);} 

}



/* &lambda2347 */
obj_t BGl_z62lambda2347z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2518, obj_t BgL_oz00_2519)
{
{ /* Llib/pgp_packets.scm 109 */
return 
(((BgL_pgpzd2signaturezd2subzd2preferredzd2compressionz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2preferredzd2compressionz00_bglt)BgL_oz00_2519)))->BgL_algosz00);} 

}



/* &<@anonymous:2328> */
obj_t BGl_z62zc3z04anonymousza32328ze3ze5zz__openpgpzd2packetszd2(obj_t BgL_envz00_2520, obj_t BgL_new1280z00_2521)
{
{ /* Llib/pgp_packets.scm 107 */
{ 
BgL_pgpzd2signaturezd2subzd2preferredzd2hashz00_bglt BgL_auxz00_4500;
((((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)
((BgL_pgpzd2signaturezd2subzd2preferredzd2hashz00_bglt)BgL_new1280z00_2521))))->BgL_criticalzf3zf3)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2preferredzd2hashz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2preferredzd2hashz00_bglt)BgL_new1280z00_2521)))->BgL_algosz00)=((obj_t)BNIL),BUNSPEC); 
BgL_auxz00_4500 = 
((BgL_pgpzd2signaturezd2subzd2preferredzd2hashz00_bglt)BgL_new1280z00_2521); 
return 
((obj_t)BgL_auxz00_4500);} } 

}



/* &lambda2326 */
BgL_pgpzd2signaturezd2subzd2preferredzd2hashz00_bglt BGl_z62lambda2326z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2522)
{
{ /* Llib/pgp_packets.scm 107 */
{ /* Llib/pgp_packets.scm 107 */
BgL_pgpzd2signaturezd2subzd2preferredzd2hashz00_bglt BgL_new1279z00_3192;
BgL_new1279z00_3192 = 
((BgL_pgpzd2signaturezd2subzd2preferredzd2hashz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2subzd2preferredzd2hashz00_bgl) ))); 
{ /* Llib/pgp_packets.scm 107 */
long BgL_arg2327z00_3193;
{ /* Llib/pgp_packets.scm 107 */
long BgL_res2511z00_3194;
BgL_res2511z00_3194 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2Subzd2Preferredzd2Hashz00zz__openpgpzd2packetszd2); 
BgL_arg2327z00_3193 = BgL_res2511z00_3194; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1279z00_3192), BgL_arg2327z00_3193); } 
{ /* Llib/pgp_packets.scm 107 */
BgL_objectz00_bglt BgL_tmpz00_4512;
BgL_tmpz00_4512 = 
((BgL_objectz00_bglt)BgL_new1279z00_3192); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4512, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1279z00_3192); 
return BgL_new1279z00_3192;} } 

}



/* &lambda2324 */
BgL_pgpzd2signaturezd2subzd2preferredzd2hashz00_bglt BGl_z62lambda2324z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2523, obj_t BgL_criticalzf31277zf3_2524, obj_t BgL_algos1278z00_2525)
{
{ /* Llib/pgp_packets.scm 107 */
{ /* Llib/pgp_packets.scm 107 */
bool_t BgL_criticalzf31277zf3_3195;
BgL_criticalzf31277zf3_3195 = 
CBOOL(BgL_criticalzf31277zf3_2524); 
{ /* Llib/pgp_packets.scm 107 */
BgL_pgpzd2signaturezd2subzd2preferredzd2hashz00_bglt BgL_new1382z00_3197;
{ /* Llib/pgp_packets.scm 107 */
BgL_pgpzd2signaturezd2subzd2preferredzd2hashz00_bglt BgL_new1381z00_3198;
BgL_new1381z00_3198 = 
((BgL_pgpzd2signaturezd2subzd2preferredzd2hashz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2subzd2preferredzd2hashz00_bgl) ))); 
{ /* Llib/pgp_packets.scm 107 */
long BgL_arg2325z00_3199;
{ /* Llib/pgp_packets.scm 107 */
long BgL_res2510z00_3200;
BgL_res2510z00_3200 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2Subzd2Preferredzd2Hashz00zz__openpgpzd2packetszd2); 
BgL_arg2325z00_3199 = BgL_res2510z00_3200; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1381z00_3198), BgL_arg2325z00_3199); } 
{ /* Llib/pgp_packets.scm 107 */
BgL_objectz00_bglt BgL_tmpz00_4521;
BgL_tmpz00_4521 = 
((BgL_objectz00_bglt)BgL_new1381z00_3198); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4521, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1381z00_3198); 
BgL_new1382z00_3197 = BgL_new1381z00_3198; } 
((((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)BgL_new1382z00_3197)))->BgL_criticalzf3zf3)=((bool_t)BgL_criticalzf31277zf3_3195),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2preferredzd2hashz00_bglt)COBJECT(BgL_new1382z00_3197))->BgL_algosz00)=((obj_t)
((obj_t)BgL_algos1278z00_2525)),BUNSPEC); 
return BgL_new1382z00_3197;} } } 

}



/* &lambda2333 */
obj_t BGl_z62lambda2333z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2526, obj_t BgL_oz00_2527, obj_t BgL_vz00_2528)
{
{ /* Llib/pgp_packets.scm 107 */
return 
((((BgL_pgpzd2signaturezd2subzd2preferredzd2hashz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2preferredzd2hashz00_bglt)BgL_oz00_2527)))->BgL_algosz00)=((obj_t)
((obj_t)BgL_vz00_2528)),BUNSPEC);} 

}



/* &lambda2332 */
obj_t BGl_z62lambda2332z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2529, obj_t BgL_oz00_2530)
{
{ /* Llib/pgp_packets.scm 107 */
return 
(((BgL_pgpzd2signaturezd2subzd2preferredzd2hashz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2preferredzd2hashz00_bglt)BgL_oz00_2530)))->BgL_algosz00);} 

}



/* &<@anonymous:2303> */
obj_t BGl_z62zc3z04anonymousza32303ze3ze5zz__openpgpzd2packetszd2(obj_t BgL_envz00_2531, obj_t BgL_new1275z00_2532)
{
{ /* Llib/pgp_packets.scm 104 */
{ 
BgL_pgpzd2signaturezd2subzd2notationzd2_bglt BgL_auxz00_4534;
((((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)
((BgL_pgpzd2signaturezd2subzd2notationzd2_bglt)BgL_new1275z00_2532))))->BgL_criticalzf3zf3)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2notationzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2notationzd2_bglt)BgL_new1275z00_2532)))->BgL_flagsz00)=((obj_t)BGl_string2786z00zz__openpgpzd2packetszd2),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2notationzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2notationzd2_bglt)BgL_new1275z00_2532)))->BgL_namez00)=((obj_t)BGl_string2786z00zz__openpgpzd2packetszd2),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2notationzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2notationzd2_bglt)BgL_new1275z00_2532)))->BgL_valuez00)=((obj_t)BGl_string2786z00zz__openpgpzd2packetszd2),BUNSPEC); 
BgL_auxz00_4534 = 
((BgL_pgpzd2signaturezd2subzd2notationzd2_bglt)BgL_new1275z00_2532); 
return 
((obj_t)BgL_auxz00_4534);} } 

}



/* &lambda2301 */
BgL_pgpzd2signaturezd2subzd2notationzd2_bglt BGl_z62lambda2301z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2533)
{
{ /* Llib/pgp_packets.scm 104 */
{ /* Llib/pgp_packets.scm 104 */
BgL_pgpzd2signaturezd2subzd2notationzd2_bglt BgL_new1274z00_3205;
BgL_new1274z00_3205 = 
((BgL_pgpzd2signaturezd2subzd2notationzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2subzd2notationzd2_bgl) ))); 
{ /* Llib/pgp_packets.scm 104 */
long BgL_arg2302z00_3206;
{ /* Llib/pgp_packets.scm 104 */
long BgL_res2509z00_3207;
BgL_res2509z00_3207 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2Subzd2Notationzd2zz__openpgpzd2packetszd2); 
BgL_arg2302z00_3206 = BgL_res2509z00_3207; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1274z00_3205), BgL_arg2302z00_3206); } 
{ /* Llib/pgp_packets.scm 104 */
BgL_objectz00_bglt BgL_tmpz00_4550;
BgL_tmpz00_4550 = 
((BgL_objectz00_bglt)BgL_new1274z00_3205); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4550, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1274z00_3205); 
return BgL_new1274z00_3205;} } 

}



/* &lambda2299 */
BgL_pgpzd2signaturezd2subzd2notationzd2_bglt BGl_z62lambda2299z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2534, obj_t BgL_criticalzf31270zf3_2535, obj_t BgL_flags1271z00_2536, obj_t BgL_name1272z00_2537, obj_t BgL_value1273z00_2538)
{
{ /* Llib/pgp_packets.scm 104 */
{ /* Llib/pgp_packets.scm 104 */
bool_t BgL_criticalzf31270zf3_3208;
BgL_criticalzf31270zf3_3208 = 
CBOOL(BgL_criticalzf31270zf3_2535); 
{ /* Llib/pgp_packets.scm 104 */
BgL_pgpzd2signaturezd2subzd2notationzd2_bglt BgL_new1380z00_3212;
{ /* Llib/pgp_packets.scm 104 */
BgL_pgpzd2signaturezd2subzd2notationzd2_bglt BgL_new1379z00_3213;
BgL_new1379z00_3213 = 
((BgL_pgpzd2signaturezd2subzd2notationzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2subzd2notationzd2_bgl) ))); 
{ /* Llib/pgp_packets.scm 104 */
long BgL_arg2300z00_3214;
{ /* Llib/pgp_packets.scm 104 */
long BgL_res2508z00_3215;
BgL_res2508z00_3215 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2Subzd2Notationzd2zz__openpgpzd2packetszd2); 
BgL_arg2300z00_3214 = BgL_res2508z00_3215; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1379z00_3213), BgL_arg2300z00_3214); } 
{ /* Llib/pgp_packets.scm 104 */
BgL_objectz00_bglt BgL_tmpz00_4559;
BgL_tmpz00_4559 = 
((BgL_objectz00_bglt)BgL_new1379z00_3213); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4559, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1379z00_3213); 
BgL_new1380z00_3212 = BgL_new1379z00_3213; } 
((((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)BgL_new1380z00_3212)))->BgL_criticalzf3zf3)=((bool_t)BgL_criticalzf31270zf3_3208),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2notationzd2_bglt)COBJECT(BgL_new1380z00_3212))->BgL_flagsz00)=((obj_t)
((obj_t)BgL_flags1271z00_2536)),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2notationzd2_bglt)COBJECT(BgL_new1380z00_3212))->BgL_namez00)=((obj_t)
((obj_t)BgL_name1272z00_2537)),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2notationzd2_bglt)COBJECT(BgL_new1380z00_3212))->BgL_valuez00)=((obj_t)
((obj_t)BgL_value1273z00_2538)),BUNSPEC); 
return BgL_new1380z00_3212;} } } 

}



/* &lambda2318 */
obj_t BGl_z62lambda2318z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2539, obj_t BgL_oz00_2540, obj_t BgL_vz00_2541)
{
{ /* Llib/pgp_packets.scm 104 */
return 
((((BgL_pgpzd2signaturezd2subzd2notationzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2notationzd2_bglt)BgL_oz00_2540)))->BgL_valuez00)=((obj_t)
((obj_t)BgL_vz00_2541)),BUNSPEC);} 

}



/* &lambda2317 */
obj_t BGl_z62lambda2317z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2542, obj_t BgL_oz00_2543)
{
{ /* Llib/pgp_packets.scm 104 */
return 
(((BgL_pgpzd2signaturezd2subzd2notationzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2notationzd2_bglt)BgL_oz00_2543)))->BgL_valuez00);} 

}



/* &lambda2313 */
obj_t BGl_z62lambda2313z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2544, obj_t BgL_oz00_2545, obj_t BgL_vz00_2546)
{
{ /* Llib/pgp_packets.scm 104 */
return 
((((BgL_pgpzd2signaturezd2subzd2notationzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2notationzd2_bglt)BgL_oz00_2545)))->BgL_namez00)=((obj_t)
((obj_t)BgL_vz00_2546)),BUNSPEC);} 

}



/* &lambda2312 */
obj_t BGl_z62lambda2312z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2547, obj_t BgL_oz00_2548)
{
{ /* Llib/pgp_packets.scm 104 */
return 
(((BgL_pgpzd2signaturezd2subzd2notationzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2notationzd2_bglt)BgL_oz00_2548)))->BgL_namez00);} 

}



/* &lambda2308 */
obj_t BGl_z62lambda2308z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2549, obj_t BgL_oz00_2550, obj_t BgL_vz00_2551)
{
{ /* Llib/pgp_packets.scm 104 */
return 
((((BgL_pgpzd2signaturezd2subzd2notationzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2notationzd2_bglt)BgL_oz00_2550)))->BgL_flagsz00)=((obj_t)
((obj_t)BgL_vz00_2551)),BUNSPEC);} 

}



/* &lambda2307 */
obj_t BGl_z62lambda2307z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2552, obj_t BgL_oz00_2553)
{
{ /* Llib/pgp_packets.scm 104 */
return 
(((BgL_pgpzd2signaturezd2subzd2notationzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2notationzd2_bglt)BgL_oz00_2553)))->BgL_flagsz00);} 

}



/* &<@anonymous:2288> */
obj_t BGl_z62zc3z04anonymousza32288ze3ze5zz__openpgpzd2packetszd2(obj_t BgL_envz00_2554, obj_t BgL_new1268z00_2555)
{
{ /* Llib/pgp_packets.scm 102 */
{ 
BgL_pgpzd2signaturezd2subzd2idzd2_bglt BgL_auxz00_4586;
((((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)
((BgL_pgpzd2signaturezd2subzd2idzd2_bglt)BgL_new1268z00_2555))))->BgL_criticalzf3zf3)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2idzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2idzd2_bglt)BgL_new1268z00_2555)))->BgL_keyzd2idzd2)=((obj_t)BGl_string2786z00zz__openpgpzd2packetszd2),BUNSPEC); 
BgL_auxz00_4586 = 
((BgL_pgpzd2signaturezd2subzd2idzd2_bglt)BgL_new1268z00_2555); 
return 
((obj_t)BgL_auxz00_4586);} } 

}



/* &lambda2286 */
BgL_pgpzd2signaturezd2subzd2idzd2_bglt BGl_z62lambda2286z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2556)
{
{ /* Llib/pgp_packets.scm 102 */
{ /* Llib/pgp_packets.scm 102 */
BgL_pgpzd2signaturezd2subzd2idzd2_bglt BgL_new1267z00_3226;
BgL_new1267z00_3226 = 
((BgL_pgpzd2signaturezd2subzd2idzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2subzd2idzd2_bgl) ))); 
{ /* Llib/pgp_packets.scm 102 */
long BgL_arg2287z00_3227;
{ /* Llib/pgp_packets.scm 102 */
long BgL_res2507z00_3228;
BgL_res2507z00_3228 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2Subzd2IDzd2zz__openpgpzd2packetszd2); 
BgL_arg2287z00_3227 = BgL_res2507z00_3228; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1267z00_3226), BgL_arg2287z00_3227); } 
{ /* Llib/pgp_packets.scm 102 */
BgL_objectz00_bglt BgL_tmpz00_4598;
BgL_tmpz00_4598 = 
((BgL_objectz00_bglt)BgL_new1267z00_3226); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4598, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1267z00_3226); 
return BgL_new1267z00_3226;} } 

}



/* &lambda2284 */
BgL_pgpzd2signaturezd2subzd2idzd2_bglt BGl_z62lambda2284z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2557, obj_t BgL_criticalzf31265zf3_2558, obj_t BgL_keyzd2id1266zd2_2559)
{
{ /* Llib/pgp_packets.scm 102 */
{ /* Llib/pgp_packets.scm 102 */
bool_t BgL_criticalzf31265zf3_3229;
BgL_criticalzf31265zf3_3229 = 
CBOOL(BgL_criticalzf31265zf3_2558); 
{ /* Llib/pgp_packets.scm 102 */
BgL_pgpzd2signaturezd2subzd2idzd2_bglt BgL_new1378z00_3231;
{ /* Llib/pgp_packets.scm 102 */
BgL_pgpzd2signaturezd2subzd2idzd2_bglt BgL_new1377z00_3232;
BgL_new1377z00_3232 = 
((BgL_pgpzd2signaturezd2subzd2idzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2subzd2idzd2_bgl) ))); 
{ /* Llib/pgp_packets.scm 102 */
long BgL_arg2285z00_3233;
{ /* Llib/pgp_packets.scm 102 */
long BgL_res2506z00_3234;
BgL_res2506z00_3234 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2Subzd2IDzd2zz__openpgpzd2packetszd2); 
BgL_arg2285z00_3233 = BgL_res2506z00_3234; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1377z00_3232), BgL_arg2285z00_3233); } 
{ /* Llib/pgp_packets.scm 102 */
BgL_objectz00_bglt BgL_tmpz00_4607;
BgL_tmpz00_4607 = 
((BgL_objectz00_bglt)BgL_new1377z00_3232); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4607, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1377z00_3232); 
BgL_new1378z00_3231 = BgL_new1377z00_3232; } 
((((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)BgL_new1378z00_3231)))->BgL_criticalzf3zf3)=((bool_t)BgL_criticalzf31265zf3_3229),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2idzd2_bglt)COBJECT(BgL_new1378z00_3231))->BgL_keyzd2idzd2)=((obj_t)
((obj_t)BgL_keyzd2id1266zd2_2559)),BUNSPEC); 
return BgL_new1378z00_3231;} } } 

}



/* &lambda2293 */
obj_t BGl_z62lambda2293z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2560, obj_t BgL_oz00_2561, obj_t BgL_vz00_2562)
{
{ /* Llib/pgp_packets.scm 102 */
return 
((((BgL_pgpzd2signaturezd2subzd2idzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2idzd2_bglt)BgL_oz00_2561)))->BgL_keyzd2idzd2)=((obj_t)
((obj_t)BgL_vz00_2562)),BUNSPEC);} 

}



/* &lambda2292 */
obj_t BGl_z62lambda2292z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2563, obj_t BgL_oz00_2564)
{
{ /* Llib/pgp_packets.scm 102 */
return 
(((BgL_pgpzd2signaturezd2subzd2idzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2idzd2_bglt)BgL_oz00_2564)))->BgL_keyzd2idzd2);} 

}



/* &<@anonymous:2258> */
obj_t BGl_z62zc3z04anonymousza32258ze3ze5zz__openpgpzd2packetszd2(obj_t BgL_envz00_2565, obj_t BgL_new1263z00_2566)
{
{ /* Llib/pgp_packets.scm 97 */
{ 
BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt BgL_auxz00_4620;
((((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)
((BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt)BgL_new1263z00_2566))))->BgL_criticalzf3zf3)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt)BgL_new1263z00_2566)))->BgL_claza7za7z00)=((char)
(signed char)(((long)0))),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt)BgL_new1263z00_2566)))->BgL_sensitivezf3zf3)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt)BgL_new1263z00_2566)))->BgL_algidz00)=((char)
(signed char)(((long)0))),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt)BgL_new1263z00_2566)))->BgL_fingerprintz00)=((obj_t)BGl_string2786z00zz__openpgpzd2packetszd2),BUNSPEC); 
BgL_auxz00_4620 = 
((BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt)BgL_new1263z00_2566); 
return 
((obj_t)BgL_auxz00_4620);} } 

}



/* &lambda2256 */
BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt BGl_z62lambda2256z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2567)
{
{ /* Llib/pgp_packets.scm 97 */
{ /* Llib/pgp_packets.scm 97 */
BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt BgL_new1262z00_3239;
BgL_new1262z00_3239 = 
((BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2subzd2revocationzd2_bgl) ))); 
{ /* Llib/pgp_packets.scm 97 */
long BgL_arg2257z00_3240;
{ /* Llib/pgp_packets.scm 97 */
long BgL_res2505z00_3241;
BgL_res2505z00_3241 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2Subzd2Revocationzd2zz__openpgpzd2packetszd2); 
BgL_arg2257z00_3240 = BgL_res2505z00_3241; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1262z00_3239), BgL_arg2257z00_3240); } 
{ /* Llib/pgp_packets.scm 97 */
BgL_objectz00_bglt BgL_tmpz00_4640;
BgL_tmpz00_4640 = 
((BgL_objectz00_bglt)BgL_new1262z00_3239); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4640, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1262z00_3239); 
return BgL_new1262z00_3239;} } 

}



/* &lambda2254 */
BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt BGl_z62lambda2254z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2568, obj_t BgL_criticalzf31257zf3_2569, obj_t BgL_claza7za71258z00_2570, obj_t BgL_sensitivezf31259zf3_2571, obj_t BgL_algid1260z00_2572, obj_t BgL_fingerprint1261z00_2573)
{
{ /* Llib/pgp_packets.scm 97 */
{ /* Llib/pgp_packets.scm 97 */
bool_t BgL_criticalzf31257zf3_3242;char BgL_claza7za71258z00_3243;bool_t BgL_sensitivezf31259zf3_3244;char BgL_algid1260z00_3245;
BgL_criticalzf31257zf3_3242 = 
CBOOL(BgL_criticalzf31257zf3_2569); 
BgL_claza7za71258z00_3243 = 
(signed char)CINT(BgL_claza7za71258z00_2570); 
BgL_sensitivezf31259zf3_3244 = 
CBOOL(BgL_sensitivezf31259zf3_2571); 
BgL_algid1260z00_3245 = 
(signed char)CINT(BgL_algid1260z00_2572); 
{ /* Llib/pgp_packets.scm 97 */
BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt BgL_new1376z00_3247;
{ /* Llib/pgp_packets.scm 97 */
BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt BgL_new1375z00_3248;
BgL_new1375z00_3248 = 
((BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2subzd2revocationzd2_bgl) ))); 
{ /* Llib/pgp_packets.scm 97 */
long BgL_arg2255z00_3249;
{ /* Llib/pgp_packets.scm 97 */
long BgL_res2504z00_3250;
BgL_res2504z00_3250 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2Subzd2Revocationzd2zz__openpgpzd2packetszd2); 
BgL_arg2255z00_3249 = BgL_res2504z00_3250; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1375z00_3248), BgL_arg2255z00_3249); } 
{ /* Llib/pgp_packets.scm 97 */
BgL_objectz00_bglt BgL_tmpz00_4652;
BgL_tmpz00_4652 = 
((BgL_objectz00_bglt)BgL_new1375z00_3248); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4652, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1375z00_3248); 
BgL_new1376z00_3247 = BgL_new1375z00_3248; } 
((((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)BgL_new1376z00_3247)))->BgL_criticalzf3zf3)=((bool_t)BgL_criticalzf31257zf3_3242),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt)COBJECT(BgL_new1376z00_3247))->BgL_claza7za7z00)=((char)BgL_claza7za71258z00_3243),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt)COBJECT(BgL_new1376z00_3247))->BgL_sensitivezf3zf3)=((bool_t)BgL_sensitivezf31259zf3_3244),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt)COBJECT(BgL_new1376z00_3247))->BgL_algidz00)=((char)BgL_algid1260z00_3245),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt)COBJECT(BgL_new1376z00_3247))->BgL_fingerprintz00)=((obj_t)
((obj_t)BgL_fingerprint1261z00_2573)),BUNSPEC); 
return BgL_new1376z00_3247;} } } 

}



/* &lambda2278 */
obj_t BGl_z62lambda2278z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2574, obj_t BgL_oz00_2575, obj_t BgL_vz00_2576)
{
{ /* Llib/pgp_packets.scm 97 */
return 
((((BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt)BgL_oz00_2575)))->BgL_fingerprintz00)=((obj_t)
((obj_t)BgL_vz00_2576)),BUNSPEC);} 

}



/* &lambda2277 */
obj_t BGl_z62lambda2277z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2577, obj_t BgL_oz00_2578)
{
{ /* Llib/pgp_packets.scm 97 */
return 
(((BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt)BgL_oz00_2578)))->BgL_fingerprintz00);} 

}



/* &lambda2273 */
obj_t BGl_z62lambda2273z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2579, obj_t BgL_oz00_2580, obj_t BgL_vz00_2581)
{
{ /* Llib/pgp_packets.scm 97 */
{ /* Llib/pgp_packets.scm 97 */
char BgL_vz00_3255;
BgL_vz00_3255 = 
(signed char)CINT(BgL_vz00_2581); 
return 
((((BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt)BgL_oz00_2580)))->BgL_algidz00)=((char)BgL_vz00_3255),BUNSPEC);} } 

}



/* &lambda2272 */
obj_t BGl_z62lambda2272z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2582, obj_t BgL_oz00_2583)
{
{ /* Llib/pgp_packets.scm 97 */
return 
BINT(
(((BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt)BgL_oz00_2583)))->BgL_algidz00));} 

}



/* &lambda2268 */
obj_t BGl_z62lambda2268z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2584, obj_t BgL_oz00_2585, obj_t BgL_vz00_2586)
{
{ /* Llib/pgp_packets.scm 97 */
{ /* Llib/pgp_packets.scm 97 */
bool_t BgL_vz00_3258;
BgL_vz00_3258 = 
CBOOL(BgL_vz00_2586); 
return 
((((BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt)BgL_oz00_2585)))->BgL_sensitivezf3zf3)=((bool_t)BgL_vz00_3258),BUNSPEC);} } 

}



/* &lambda2267 */
obj_t BGl_z62lambda2267z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2587, obj_t BgL_oz00_2588)
{
{ /* Llib/pgp_packets.scm 97 */
return 
BBOOL(
(((BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt)BgL_oz00_2588)))->BgL_sensitivezf3zf3));} 

}



/* &lambda2263 */
obj_t BGl_z62lambda2263z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2589, obj_t BgL_oz00_2590, obj_t BgL_vz00_2591)
{
{ /* Llib/pgp_packets.scm 97 */
{ /* Llib/pgp_packets.scm 97 */
char BgL_vz00_3261;
BgL_vz00_3261 = 
(signed char)CINT(BgL_vz00_2591); 
return 
((((BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt)BgL_oz00_2590)))->BgL_claza7za7z00)=((char)BgL_vz00_3261),BUNSPEC);} } 

}



/* &lambda2262 */
obj_t BGl_z62lambda2262z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2592, obj_t BgL_oz00_2593)
{
{ /* Llib/pgp_packets.scm 97 */
return 
BINT(
(((BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2revocationzd2_bglt)BgL_oz00_2593)))->BgL_claza7za7z00));} 

}



/* &<@anonymous:2243> */
obj_t BGl_z62zc3z04anonymousza32243ze3ze5zz__openpgpzd2packetszd2(obj_t BgL_envz00_2594, obj_t BgL_new1255z00_2595)
{
{ /* Llib/pgp_packets.scm 95 */
{ 
BgL_pgpzd2signaturezd2subzd2preferredzd2symmetricz00_bglt BgL_auxz00_4686;
((((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)
((BgL_pgpzd2signaturezd2subzd2preferredzd2symmetricz00_bglt)BgL_new1255z00_2595))))->BgL_criticalzf3zf3)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2preferredzd2symmetricz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2preferredzd2symmetricz00_bglt)BgL_new1255z00_2595)))->BgL_algosz00)=((obj_t)BNIL),BUNSPEC); 
BgL_auxz00_4686 = 
((BgL_pgpzd2signaturezd2subzd2preferredzd2symmetricz00_bglt)BgL_new1255z00_2595); 
return 
((obj_t)BgL_auxz00_4686);} } 

}



/* &lambda2241 */
BgL_pgpzd2signaturezd2subzd2preferredzd2symmetricz00_bglt BGl_z62lambda2241z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2596)
{
{ /* Llib/pgp_packets.scm 95 */
{ /* Llib/pgp_packets.scm 95 */
BgL_pgpzd2signaturezd2subzd2preferredzd2symmetricz00_bglt BgL_new1254z00_3264;
BgL_new1254z00_3264 = 
((BgL_pgpzd2signaturezd2subzd2preferredzd2symmetricz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2subzd2preferredzd2symmetricz00_bgl) ))); 
{ /* Llib/pgp_packets.scm 95 */
long BgL_arg2242z00_3265;
{ /* Llib/pgp_packets.scm 95 */
long BgL_res2503z00_3266;
BgL_res2503z00_3266 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2Subzd2Preferredzd2Symmetricz00zz__openpgpzd2packetszd2); 
BgL_arg2242z00_3265 = BgL_res2503z00_3266; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1254z00_3264), BgL_arg2242z00_3265); } 
{ /* Llib/pgp_packets.scm 95 */
BgL_objectz00_bglt BgL_tmpz00_4698;
BgL_tmpz00_4698 = 
((BgL_objectz00_bglt)BgL_new1254z00_3264); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4698, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1254z00_3264); 
return BgL_new1254z00_3264;} } 

}



/* &lambda2239 */
BgL_pgpzd2signaturezd2subzd2preferredzd2symmetricz00_bglt BGl_z62lambda2239z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2597, obj_t BgL_criticalzf31252zf3_2598, obj_t BgL_algos1253z00_2599)
{
{ /* Llib/pgp_packets.scm 95 */
{ /* Llib/pgp_packets.scm 95 */
bool_t BgL_criticalzf31252zf3_3267;
BgL_criticalzf31252zf3_3267 = 
CBOOL(BgL_criticalzf31252zf3_2598); 
{ /* Llib/pgp_packets.scm 95 */
BgL_pgpzd2signaturezd2subzd2preferredzd2symmetricz00_bglt BgL_new1374z00_3269;
{ /* Llib/pgp_packets.scm 95 */
BgL_pgpzd2signaturezd2subzd2preferredzd2symmetricz00_bglt BgL_new1373z00_3270;
BgL_new1373z00_3270 = 
((BgL_pgpzd2signaturezd2subzd2preferredzd2symmetricz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2subzd2preferredzd2symmetricz00_bgl) ))); 
{ /* Llib/pgp_packets.scm 95 */
long BgL_arg2240z00_3271;
{ /* Llib/pgp_packets.scm 95 */
long BgL_res2502z00_3272;
BgL_res2502z00_3272 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2Subzd2Preferredzd2Symmetricz00zz__openpgpzd2packetszd2); 
BgL_arg2240z00_3271 = BgL_res2502z00_3272; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1373z00_3270), BgL_arg2240z00_3271); } 
{ /* Llib/pgp_packets.scm 95 */
BgL_objectz00_bglt BgL_tmpz00_4707;
BgL_tmpz00_4707 = 
((BgL_objectz00_bglt)BgL_new1373z00_3270); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4707, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1373z00_3270); 
BgL_new1374z00_3269 = BgL_new1373z00_3270; } 
((((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)BgL_new1374z00_3269)))->BgL_criticalzf3zf3)=((bool_t)BgL_criticalzf31252zf3_3267),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2preferredzd2symmetricz00_bglt)COBJECT(BgL_new1374z00_3269))->BgL_algosz00)=((obj_t)
((obj_t)BgL_algos1253z00_2599)),BUNSPEC); 
return BgL_new1374z00_3269;} } } 

}



/* &lambda2248 */
obj_t BGl_z62lambda2248z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2600, obj_t BgL_oz00_2601, obj_t BgL_vz00_2602)
{
{ /* Llib/pgp_packets.scm 95 */
return 
((((BgL_pgpzd2signaturezd2subzd2preferredzd2symmetricz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2preferredzd2symmetricz00_bglt)BgL_oz00_2601)))->BgL_algosz00)=((obj_t)
((obj_t)BgL_vz00_2602)),BUNSPEC);} 

}



/* &lambda2247 */
obj_t BGl_z62lambda2247z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2603, obj_t BgL_oz00_2604)
{
{ /* Llib/pgp_packets.scm 95 */
return 
(((BgL_pgpzd2signaturezd2subzd2preferredzd2symmetricz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2preferredzd2symmetricz00_bglt)BgL_oz00_2604)))->BgL_algosz00);} 

}



/* &<@anonymous:2228> */
obj_t BGl_z62zc3z04anonymousza32228ze3ze5zz__openpgpzd2packetszd2(obj_t BgL_envz00_2605, obj_t BgL_new1250z00_2606)
{
{ /* Llib/pgp_packets.scm 93 */
{ 
BgL_pgpzd2signaturezd2subzd2keyzd2expirationzd2timezd2_bglt BgL_auxz00_4720;
((((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)
((BgL_pgpzd2signaturezd2subzd2keyzd2expirationzd2timezd2_bglt)BgL_new1250z00_2606))))->BgL_criticalzf3zf3)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2keyzd2expirationzd2timezd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2keyzd2expirationzd2timezd2_bglt)BgL_new1250z00_2606)))->BgL_expirationzd2timezd2)=((long)((long)0)),BUNSPEC); 
BgL_auxz00_4720 = 
((BgL_pgpzd2signaturezd2subzd2keyzd2expirationzd2timezd2_bglt)BgL_new1250z00_2606); 
return 
((obj_t)BgL_auxz00_4720);} } 

}



/* &lambda2226 */
BgL_pgpzd2signaturezd2subzd2keyzd2expirationzd2timezd2_bglt BGl_z62lambda2226z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2607)
{
{ /* Llib/pgp_packets.scm 93 */
{ /* Llib/pgp_packets.scm 93 */
BgL_pgpzd2signaturezd2subzd2keyzd2expirationzd2timezd2_bglt BgL_new1249z00_3277;
BgL_new1249z00_3277 = 
((BgL_pgpzd2signaturezd2subzd2keyzd2expirationzd2timezd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2subzd2keyzd2expirationzd2timezd2_bgl) ))); 
{ /* Llib/pgp_packets.scm 93 */
long BgL_arg2227z00_3278;
{ /* Llib/pgp_packets.scm 93 */
long BgL_res2501z00_3279;
BgL_res2501z00_3279 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2Subzd2Keyzd2Expirationzd2Timezd2zz__openpgpzd2packetszd2); 
BgL_arg2227z00_3278 = BgL_res2501z00_3279; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1249z00_3277), BgL_arg2227z00_3278); } 
{ /* Llib/pgp_packets.scm 93 */
BgL_objectz00_bglt BgL_tmpz00_4732;
BgL_tmpz00_4732 = 
((BgL_objectz00_bglt)BgL_new1249z00_3277); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4732, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1249z00_3277); 
return BgL_new1249z00_3277;} } 

}



/* &lambda2224 */
BgL_pgpzd2signaturezd2subzd2keyzd2expirationzd2timezd2_bglt BGl_z62lambda2224z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2608, obj_t BgL_criticalzf31247zf3_2609, obj_t BgL_expirationzd2time1248zd2_2610)
{
{ /* Llib/pgp_packets.scm 93 */
{ /* Llib/pgp_packets.scm 93 */
bool_t BgL_criticalzf31247zf3_3280;long BgL_expirationzd2time1248zd2_3281;
BgL_criticalzf31247zf3_3280 = 
CBOOL(BgL_criticalzf31247zf3_2609); 
BgL_expirationzd2time1248zd2_3281 = 
(long)CINT(BgL_expirationzd2time1248zd2_2610); 
{ /* Llib/pgp_packets.scm 93 */
BgL_pgpzd2signaturezd2subzd2keyzd2expirationzd2timezd2_bglt BgL_new1372z00_3282;
{ /* Llib/pgp_packets.scm 93 */
BgL_pgpzd2signaturezd2subzd2keyzd2expirationzd2timezd2_bglt BgL_new1371z00_3283;
BgL_new1371z00_3283 = 
((BgL_pgpzd2signaturezd2subzd2keyzd2expirationzd2timezd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2subzd2keyzd2expirationzd2timezd2_bgl) ))); 
{ /* Llib/pgp_packets.scm 93 */
long BgL_arg2225z00_3284;
{ /* Llib/pgp_packets.scm 93 */
long BgL_res2500z00_3285;
BgL_res2500z00_3285 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2Subzd2Keyzd2Expirationzd2Timezd2zz__openpgpzd2packetszd2); 
BgL_arg2225z00_3284 = BgL_res2500z00_3285; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1371z00_3283), BgL_arg2225z00_3284); } 
{ /* Llib/pgp_packets.scm 93 */
BgL_objectz00_bglt BgL_tmpz00_4742;
BgL_tmpz00_4742 = 
((BgL_objectz00_bglt)BgL_new1371z00_3283); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4742, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1371z00_3283); 
BgL_new1372z00_3282 = BgL_new1371z00_3283; } 
((((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)BgL_new1372z00_3282)))->BgL_criticalzf3zf3)=((bool_t)BgL_criticalzf31247zf3_3280),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2keyzd2expirationzd2timezd2_bglt)COBJECT(BgL_new1372z00_3282))->BgL_expirationzd2timezd2)=((long)BgL_expirationzd2time1248zd2_3281),BUNSPEC); 
return BgL_new1372z00_3282;} } } 

}



/* &lambda2233 */
obj_t BGl_z62lambda2233z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2611, obj_t BgL_oz00_2612, obj_t BgL_vz00_2613)
{
{ /* Llib/pgp_packets.scm 93 */
{ /* Llib/pgp_packets.scm 93 */
long BgL_vz00_3287;
BgL_vz00_3287 = 
(long)CINT(BgL_vz00_2613); 
return 
((((BgL_pgpzd2signaturezd2subzd2keyzd2expirationzd2timezd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2keyzd2expirationzd2timezd2_bglt)BgL_oz00_2612)))->BgL_expirationzd2timezd2)=((long)BgL_vz00_3287),BUNSPEC);} } 

}



/* &lambda2232 */
obj_t BGl_z62lambda2232z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2614, obj_t BgL_oz00_2615)
{
{ /* Llib/pgp_packets.scm 93 */
return 
BINT(
(((BgL_pgpzd2signaturezd2subzd2keyzd2expirationzd2timezd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2keyzd2expirationzd2timezd2_bglt)BgL_oz00_2615)))->BgL_expirationzd2timezd2));} 

}



/* &<@anonymous:2213> */
obj_t BGl_z62zc3z04anonymousza32213ze3ze5zz__openpgpzd2packetszd2(obj_t BgL_envz00_2616, obj_t BgL_new1245z00_2617)
{
{ /* Llib/pgp_packets.scm 91 */
{ 
BgL_pgpzd2signaturezd2subzd2revocablezd2_bglt BgL_auxz00_4755;
((((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)
((BgL_pgpzd2signaturezd2subzd2revocablezd2_bglt)BgL_new1245z00_2617))))->BgL_criticalzf3zf3)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2revocablezd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2revocablezd2_bglt)BgL_new1245z00_2617)))->BgL_revocablezf3zf3)=((bool_t)((bool_t)0)),BUNSPEC); 
BgL_auxz00_4755 = 
((BgL_pgpzd2signaturezd2subzd2revocablezd2_bglt)BgL_new1245z00_2617); 
return 
((obj_t)BgL_auxz00_4755);} } 

}



/* &lambda2211 */
BgL_pgpzd2signaturezd2subzd2revocablezd2_bglt BGl_z62lambda2211z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2618)
{
{ /* Llib/pgp_packets.scm 91 */
{ /* Llib/pgp_packets.scm 91 */
BgL_pgpzd2signaturezd2subzd2revocablezd2_bglt BgL_new1244z00_3290;
BgL_new1244z00_3290 = 
((BgL_pgpzd2signaturezd2subzd2revocablezd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2subzd2revocablezd2_bgl) ))); 
{ /* Llib/pgp_packets.scm 91 */
long BgL_arg2212z00_3291;
{ /* Llib/pgp_packets.scm 91 */
long BgL_res2499z00_3292;
BgL_res2499z00_3292 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2Subzd2Revocablezd2zz__openpgpzd2packetszd2); 
BgL_arg2212z00_3291 = BgL_res2499z00_3292; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1244z00_3290), BgL_arg2212z00_3291); } 
{ /* Llib/pgp_packets.scm 91 */
BgL_objectz00_bglt BgL_tmpz00_4767;
BgL_tmpz00_4767 = 
((BgL_objectz00_bglt)BgL_new1244z00_3290); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4767, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1244z00_3290); 
return BgL_new1244z00_3290;} } 

}



/* &lambda2209 */
BgL_pgpzd2signaturezd2subzd2revocablezd2_bglt BGl_z62lambda2209z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2619, obj_t BgL_criticalzf31242zf3_2620, obj_t BgL_revocablezf31243zf3_2621)
{
{ /* Llib/pgp_packets.scm 91 */
{ /* Llib/pgp_packets.scm 91 */
bool_t BgL_criticalzf31242zf3_3293;bool_t BgL_revocablezf31243zf3_3294;
BgL_criticalzf31242zf3_3293 = 
CBOOL(BgL_criticalzf31242zf3_2620); 
BgL_revocablezf31243zf3_3294 = 
CBOOL(BgL_revocablezf31243zf3_2621); 
{ /* Llib/pgp_packets.scm 91 */
BgL_pgpzd2signaturezd2subzd2revocablezd2_bglt BgL_new1370z00_3295;
{ /* Llib/pgp_packets.scm 91 */
BgL_pgpzd2signaturezd2subzd2revocablezd2_bglt BgL_new1369z00_3296;
BgL_new1369z00_3296 = 
((BgL_pgpzd2signaturezd2subzd2revocablezd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2subzd2revocablezd2_bgl) ))); 
{ /* Llib/pgp_packets.scm 91 */
long BgL_arg2210z00_3297;
{ /* Llib/pgp_packets.scm 91 */
long BgL_res2498z00_3298;
BgL_res2498z00_3298 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2Subzd2Revocablezd2zz__openpgpzd2packetszd2); 
BgL_arg2210z00_3297 = BgL_res2498z00_3298; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1369z00_3296), BgL_arg2210z00_3297); } 
{ /* Llib/pgp_packets.scm 91 */
BgL_objectz00_bglt BgL_tmpz00_4777;
BgL_tmpz00_4777 = 
((BgL_objectz00_bglt)BgL_new1369z00_3296); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4777, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1369z00_3296); 
BgL_new1370z00_3295 = BgL_new1369z00_3296; } 
((((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)BgL_new1370z00_3295)))->BgL_criticalzf3zf3)=((bool_t)BgL_criticalzf31242zf3_3293),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2revocablezd2_bglt)COBJECT(BgL_new1370z00_3295))->BgL_revocablezf3zf3)=((bool_t)BgL_revocablezf31243zf3_3294),BUNSPEC); 
return BgL_new1370z00_3295;} } } 

}



/* &lambda2218 */
obj_t BGl_z62lambda2218z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2622, obj_t BgL_oz00_2623, obj_t BgL_vz00_2624)
{
{ /* Llib/pgp_packets.scm 91 */
{ /* Llib/pgp_packets.scm 91 */
bool_t BgL_vz00_3300;
BgL_vz00_3300 = 
CBOOL(BgL_vz00_2624); 
return 
((((BgL_pgpzd2signaturezd2subzd2revocablezd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2revocablezd2_bglt)BgL_oz00_2623)))->BgL_revocablezf3zf3)=((bool_t)BgL_vz00_3300),BUNSPEC);} } 

}



/* &lambda2217 */
obj_t BGl_z62lambda2217z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2625, obj_t BgL_oz00_2626)
{
{ /* Llib/pgp_packets.scm 91 */
return 
BBOOL(
(((BgL_pgpzd2signaturezd2subzd2revocablezd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2revocablezd2_bglt)BgL_oz00_2626)))->BgL_revocablezf3zf3));} 

}



/* &<@anonymous:2193> */
obj_t BGl_z62zc3z04anonymousza32193ze3ze5zz__openpgpzd2packetszd2(obj_t BgL_envz00_2627, obj_t BgL_new1240z00_2628)
{
{ /* Llib/pgp_packets.scm 88 */
{ 
BgL_pgpzd2signaturezd2subzd2trustzd2_bglt BgL_auxz00_4790;
((((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)
((BgL_pgpzd2signaturezd2subzd2trustzd2_bglt)BgL_new1240z00_2628))))->BgL_criticalzf3zf3)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2trustzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2trustzd2_bglt)BgL_new1240z00_2628)))->BgL_levelz00)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2trustzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2trustzd2_bglt)BgL_new1240z00_2628)))->BgL_amountz00)=((int)
(int)(((long)0))),BUNSPEC); 
BgL_auxz00_4790 = 
((BgL_pgpzd2signaturezd2subzd2trustzd2_bglt)BgL_new1240z00_2628); 
return 
((obj_t)BgL_auxz00_4790);} } 

}



/* &lambda2191 */
BgL_pgpzd2signaturezd2subzd2trustzd2_bglt BGl_z62lambda2191z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2629)
{
{ /* Llib/pgp_packets.scm 88 */
{ /* Llib/pgp_packets.scm 88 */
BgL_pgpzd2signaturezd2subzd2trustzd2_bglt BgL_new1239z00_3303;
BgL_new1239z00_3303 = 
((BgL_pgpzd2signaturezd2subzd2trustzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2subzd2trustzd2_bgl) ))); 
{ /* Llib/pgp_packets.scm 88 */
long BgL_arg2192z00_3304;
{ /* Llib/pgp_packets.scm 88 */
long BgL_res2497z00_3305;
BgL_res2497z00_3305 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2Subzd2Trustzd2zz__openpgpzd2packetszd2); 
BgL_arg2192z00_3304 = BgL_res2497z00_3305; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1239z00_3303), BgL_arg2192z00_3304); } 
{ /* Llib/pgp_packets.scm 88 */
BgL_objectz00_bglt BgL_tmpz00_4806;
BgL_tmpz00_4806 = 
((BgL_objectz00_bglt)BgL_new1239z00_3303); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4806, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1239z00_3303); 
return BgL_new1239z00_3303;} } 

}



/* &lambda2189 */
BgL_pgpzd2signaturezd2subzd2trustzd2_bglt BGl_z62lambda2189z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2630, obj_t BgL_criticalzf31236zf3_2631, obj_t BgL_level1237z00_2632, obj_t BgL_amount1238z00_2633)
{
{ /* Llib/pgp_packets.scm 88 */
{ /* Llib/pgp_packets.scm 88 */
bool_t BgL_criticalzf31236zf3_3306;int BgL_level1237z00_3307;int BgL_amount1238z00_3308;
BgL_criticalzf31236zf3_3306 = 
CBOOL(BgL_criticalzf31236zf3_2631); 
BgL_level1237z00_3307 = 
CINT(BgL_level1237z00_2632); 
BgL_amount1238z00_3308 = 
CINT(BgL_amount1238z00_2633); 
{ /* Llib/pgp_packets.scm 88 */
BgL_pgpzd2signaturezd2subzd2trustzd2_bglt BgL_new1368z00_3309;
{ /* Llib/pgp_packets.scm 88 */
BgL_pgpzd2signaturezd2subzd2trustzd2_bglt BgL_new1367z00_3310;
BgL_new1367z00_3310 = 
((BgL_pgpzd2signaturezd2subzd2trustzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2subzd2trustzd2_bgl) ))); 
{ /* Llib/pgp_packets.scm 88 */
long BgL_arg2190z00_3311;
{ /* Llib/pgp_packets.scm 88 */
long BgL_res2496z00_3312;
BgL_res2496z00_3312 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2Subzd2Trustzd2zz__openpgpzd2packetszd2); 
BgL_arg2190z00_3311 = BgL_res2496z00_3312; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1367z00_3310), BgL_arg2190z00_3311); } 
{ /* Llib/pgp_packets.scm 88 */
BgL_objectz00_bglt BgL_tmpz00_4817;
BgL_tmpz00_4817 = 
((BgL_objectz00_bglt)BgL_new1367z00_3310); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4817, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1367z00_3310); 
BgL_new1368z00_3309 = BgL_new1367z00_3310; } 
((((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)BgL_new1368z00_3309)))->BgL_criticalzf3zf3)=((bool_t)BgL_criticalzf31236zf3_3306),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2trustzd2_bglt)COBJECT(BgL_new1368z00_3309))->BgL_levelz00)=((int)BgL_level1237z00_3307),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2trustzd2_bglt)COBJECT(BgL_new1368z00_3309))->BgL_amountz00)=((int)BgL_amount1238z00_3308),BUNSPEC); 
return BgL_new1368z00_3309;} } } 

}



/* &lambda2203 */
obj_t BGl_z62lambda2203z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2634, obj_t BgL_oz00_2635, obj_t BgL_vz00_2636)
{
{ /* Llib/pgp_packets.scm 88 */
{ /* Llib/pgp_packets.scm 88 */
int BgL_vz00_3314;
BgL_vz00_3314 = 
CINT(BgL_vz00_2636); 
return 
((((BgL_pgpzd2signaturezd2subzd2trustzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2trustzd2_bglt)BgL_oz00_2635)))->BgL_amountz00)=((int)BgL_vz00_3314),BUNSPEC);} } 

}



/* &lambda2202 */
obj_t BGl_z62lambda2202z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2637, obj_t BgL_oz00_2638)
{
{ /* Llib/pgp_packets.scm 88 */
return 
BINT(
(((BgL_pgpzd2signaturezd2subzd2trustzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2trustzd2_bglt)BgL_oz00_2638)))->BgL_amountz00));} 

}



/* &lambda2198 */
obj_t BGl_z62lambda2198z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2639, obj_t BgL_oz00_2640, obj_t BgL_vz00_2641)
{
{ /* Llib/pgp_packets.scm 88 */
{ /* Llib/pgp_packets.scm 88 */
int BgL_vz00_3317;
BgL_vz00_3317 = 
CINT(BgL_vz00_2641); 
return 
((((BgL_pgpzd2signaturezd2subzd2trustzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2trustzd2_bglt)BgL_oz00_2640)))->BgL_levelz00)=((int)BgL_vz00_3317),BUNSPEC);} } 

}



/* &lambda2197 */
obj_t BGl_z62lambda2197z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2642, obj_t BgL_oz00_2643)
{
{ /* Llib/pgp_packets.scm 88 */
return 
BINT(
(((BgL_pgpzd2signaturezd2subzd2trustzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2trustzd2_bglt)BgL_oz00_2643)))->BgL_levelz00));} 

}



/* &<@anonymous:2178> */
obj_t BGl_z62zc3z04anonymousza32178ze3ze5zz__openpgpzd2packetszd2(obj_t BgL_envz00_2644, obj_t BgL_new1234z00_2645)
{
{ /* Llib/pgp_packets.scm 86 */
{ 
BgL_pgpzd2signaturezd2subzd2exportablezd2_bglt BgL_auxz00_4837;
((((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)
((BgL_pgpzd2signaturezd2subzd2exportablezd2_bglt)BgL_new1234z00_2645))))->BgL_criticalzf3zf3)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2exportablezd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2exportablezd2_bglt)BgL_new1234z00_2645)))->BgL_exportablezf3zf3)=((bool_t)((bool_t)0)),BUNSPEC); 
BgL_auxz00_4837 = 
((BgL_pgpzd2signaturezd2subzd2exportablezd2_bglt)BgL_new1234z00_2645); 
return 
((obj_t)BgL_auxz00_4837);} } 

}



/* &lambda2176 */
BgL_pgpzd2signaturezd2subzd2exportablezd2_bglt BGl_z62lambda2176z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2646)
{
{ /* Llib/pgp_packets.scm 86 */
{ /* Llib/pgp_packets.scm 86 */
BgL_pgpzd2signaturezd2subzd2exportablezd2_bglt BgL_new1233z00_3320;
BgL_new1233z00_3320 = 
((BgL_pgpzd2signaturezd2subzd2exportablezd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2subzd2exportablezd2_bgl) ))); 
{ /* Llib/pgp_packets.scm 86 */
long BgL_arg2177z00_3321;
{ /* Llib/pgp_packets.scm 86 */
long BgL_res2495z00_3322;
BgL_res2495z00_3322 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2Subzd2Exportablezd2zz__openpgpzd2packetszd2); 
BgL_arg2177z00_3321 = BgL_res2495z00_3322; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1233z00_3320), BgL_arg2177z00_3321); } 
{ /* Llib/pgp_packets.scm 86 */
BgL_objectz00_bglt BgL_tmpz00_4849;
BgL_tmpz00_4849 = 
((BgL_objectz00_bglt)BgL_new1233z00_3320); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4849, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1233z00_3320); 
return BgL_new1233z00_3320;} } 

}



/* &lambda2174 */
BgL_pgpzd2signaturezd2subzd2exportablezd2_bglt BGl_z62lambda2174z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2647, obj_t BgL_criticalzf31231zf3_2648, obj_t BgL_exportablezf31232zf3_2649)
{
{ /* Llib/pgp_packets.scm 86 */
{ /* Llib/pgp_packets.scm 86 */
bool_t BgL_criticalzf31231zf3_3323;bool_t BgL_exportablezf31232zf3_3324;
BgL_criticalzf31231zf3_3323 = 
CBOOL(BgL_criticalzf31231zf3_2648); 
BgL_exportablezf31232zf3_3324 = 
CBOOL(BgL_exportablezf31232zf3_2649); 
{ /* Llib/pgp_packets.scm 86 */
BgL_pgpzd2signaturezd2subzd2exportablezd2_bglt BgL_new1366z00_3325;
{ /* Llib/pgp_packets.scm 86 */
BgL_pgpzd2signaturezd2subzd2exportablezd2_bglt BgL_new1365z00_3326;
BgL_new1365z00_3326 = 
((BgL_pgpzd2signaturezd2subzd2exportablezd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2subzd2exportablezd2_bgl) ))); 
{ /* Llib/pgp_packets.scm 86 */
long BgL_arg2175z00_3327;
{ /* Llib/pgp_packets.scm 86 */
long BgL_res2494z00_3328;
BgL_res2494z00_3328 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2Subzd2Exportablezd2zz__openpgpzd2packetszd2); 
BgL_arg2175z00_3327 = BgL_res2494z00_3328; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1365z00_3326), BgL_arg2175z00_3327); } 
{ /* Llib/pgp_packets.scm 86 */
BgL_objectz00_bglt BgL_tmpz00_4859;
BgL_tmpz00_4859 = 
((BgL_objectz00_bglt)BgL_new1365z00_3326); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4859, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1365z00_3326); 
BgL_new1366z00_3325 = BgL_new1365z00_3326; } 
((((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)BgL_new1366z00_3325)))->BgL_criticalzf3zf3)=((bool_t)BgL_criticalzf31231zf3_3323),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2exportablezd2_bglt)COBJECT(BgL_new1366z00_3325))->BgL_exportablezf3zf3)=((bool_t)BgL_exportablezf31232zf3_3324),BUNSPEC); 
return BgL_new1366z00_3325;} } } 

}



/* &lambda2183 */
obj_t BGl_z62lambda2183z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2650, obj_t BgL_oz00_2651, obj_t BgL_vz00_2652)
{
{ /* Llib/pgp_packets.scm 86 */
{ /* Llib/pgp_packets.scm 86 */
bool_t BgL_vz00_3330;
BgL_vz00_3330 = 
CBOOL(BgL_vz00_2652); 
return 
((((BgL_pgpzd2signaturezd2subzd2exportablezd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2exportablezd2_bglt)BgL_oz00_2651)))->BgL_exportablezf3zf3)=((bool_t)BgL_vz00_3330),BUNSPEC);} } 

}



/* &lambda2182 */
obj_t BGl_z62lambda2182z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2653, obj_t BgL_oz00_2654)
{
{ /* Llib/pgp_packets.scm 86 */
return 
BBOOL(
(((BgL_pgpzd2signaturezd2subzd2exportablezd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2exportablezd2_bglt)BgL_oz00_2654)))->BgL_exportablezf3zf3));} 

}



/* &<@anonymous:2163> */
obj_t BGl_z62zc3z04anonymousza32163ze3ze5zz__openpgpzd2packetszd2(obj_t BgL_envz00_2655, obj_t BgL_new1229z00_2656)
{
{ /* Llib/pgp_packets.scm 84 */
{ 
BgL_pgpzd2signaturezd2subzd2expirationzd2timez00_bglt BgL_auxz00_4872;
((((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)
((BgL_pgpzd2signaturezd2subzd2expirationzd2timez00_bglt)BgL_new1229z00_2656))))->BgL_criticalzf3zf3)=((bool_t)((bool_t)0)),BUNSPEC); 
{ 
obj_t BgL_auxz00_4876;
{ /* Llib/pgp_packets.scm 84 */
obj_t BgL_res2493z00_3333;
{ /* Llib/pgp_packets.scm 84 */
BGL_LONGLONG_T BgL_arg1665z00_3334;
BgL_arg1665z00_3334 = 
bgl_current_nanoseconds(); 
BgL_res2493z00_3333 = 
bgl_nanoseconds_to_date(BgL_arg1665z00_3334); } 
BgL_auxz00_4876 = BgL_res2493z00_3333; } 
((((BgL_pgpzd2signaturezd2subzd2expirationzd2timez00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2expirationzd2timez00_bglt)BgL_new1229z00_2656)))->BgL_expirationzd2datezd2)=((obj_t)BgL_auxz00_4876),BUNSPEC); } 
BgL_auxz00_4872 = 
((BgL_pgpzd2signaturezd2subzd2expirationzd2timez00_bglt)BgL_new1229z00_2656); 
return 
((obj_t)BgL_auxz00_4872);} } 

}



/* &lambda2161 */
BgL_pgpzd2signaturezd2subzd2expirationzd2timez00_bglt BGl_z62lambda2161z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2657)
{
{ /* Llib/pgp_packets.scm 84 */
{ /* Llib/pgp_packets.scm 84 */
BgL_pgpzd2signaturezd2subzd2expirationzd2timez00_bglt BgL_new1228z00_3335;
BgL_new1228z00_3335 = 
((BgL_pgpzd2signaturezd2subzd2expirationzd2timez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2subzd2expirationzd2timez00_bgl) ))); 
{ /* Llib/pgp_packets.scm 84 */
long BgL_arg2162z00_3336;
{ /* Llib/pgp_packets.scm 84 */
long BgL_res2492z00_3337;
BgL_res2492z00_3337 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2Subzd2Expirationzd2Timez00zz__openpgpzd2packetszd2); 
BgL_arg2162z00_3336 = BgL_res2492z00_3337; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1228z00_3335), BgL_arg2162z00_3336); } 
{ /* Llib/pgp_packets.scm 84 */
BgL_objectz00_bglt BgL_tmpz00_4887;
BgL_tmpz00_4887 = 
((BgL_objectz00_bglt)BgL_new1228z00_3335); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4887, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1228z00_3335); 
return BgL_new1228z00_3335;} } 

}



/* &lambda2159 */
BgL_pgpzd2signaturezd2subzd2expirationzd2timez00_bglt BGl_z62lambda2159z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2658, obj_t BgL_criticalzf31226zf3_2659, obj_t BgL_expirationzd2date1227zd2_2660)
{
{ /* Llib/pgp_packets.scm 84 */
{ /* Llib/pgp_packets.scm 84 */
bool_t BgL_criticalzf31226zf3_3338;
BgL_criticalzf31226zf3_3338 = 
CBOOL(BgL_criticalzf31226zf3_2659); 
{ /* Llib/pgp_packets.scm 84 */
BgL_pgpzd2signaturezd2subzd2expirationzd2timez00_bglt BgL_new1364z00_3340;
{ /* Llib/pgp_packets.scm 84 */
BgL_pgpzd2signaturezd2subzd2expirationzd2timez00_bglt BgL_new1363z00_3341;
BgL_new1363z00_3341 = 
((BgL_pgpzd2signaturezd2subzd2expirationzd2timez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2subzd2expirationzd2timez00_bgl) ))); 
{ /* Llib/pgp_packets.scm 84 */
long BgL_arg2160z00_3342;
{ /* Llib/pgp_packets.scm 84 */
long BgL_res2491z00_3343;
BgL_res2491z00_3343 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2Subzd2Expirationzd2Timez00zz__openpgpzd2packetszd2); 
BgL_arg2160z00_3342 = BgL_res2491z00_3343; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1363z00_3341), BgL_arg2160z00_3342); } 
{ /* Llib/pgp_packets.scm 84 */
BgL_objectz00_bglt BgL_tmpz00_4896;
BgL_tmpz00_4896 = 
((BgL_objectz00_bglt)BgL_new1363z00_3341); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4896, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1363z00_3341); 
BgL_new1364z00_3340 = BgL_new1363z00_3341; } 
((((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)BgL_new1364z00_3340)))->BgL_criticalzf3zf3)=((bool_t)BgL_criticalzf31226zf3_3338),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2expirationzd2timez00_bglt)COBJECT(BgL_new1364z00_3340))->BgL_expirationzd2datezd2)=((obj_t)
((obj_t)BgL_expirationzd2date1227zd2_2660)),BUNSPEC); 
return BgL_new1364z00_3340;} } } 

}



/* &lambda2168 */
obj_t BGl_z62lambda2168z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2661, obj_t BgL_oz00_2662, obj_t BgL_vz00_2663)
{
{ /* Llib/pgp_packets.scm 84 */
return 
((((BgL_pgpzd2signaturezd2subzd2expirationzd2timez00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2expirationzd2timez00_bglt)BgL_oz00_2662)))->BgL_expirationzd2datezd2)=((obj_t)
((obj_t)BgL_vz00_2663)),BUNSPEC);} 

}



/* &lambda2167 */
obj_t BGl_z62lambda2167z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2664, obj_t BgL_oz00_2665)
{
{ /* Llib/pgp_packets.scm 84 */
return 
(((BgL_pgpzd2signaturezd2subzd2expirationzd2timez00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2expirationzd2timez00_bglt)BgL_oz00_2665)))->BgL_expirationzd2datezd2);} 

}



/* &<@anonymous:2148> */
obj_t BGl_z62zc3z04anonymousza32148ze3ze5zz__openpgpzd2packetszd2(obj_t BgL_envz00_2666, obj_t BgL_new1224z00_2667)
{
{ /* Llib/pgp_packets.scm 82 */
{ 
BgL_pgpzd2signaturezd2subzd2creationzd2timez00_bglt BgL_auxz00_4909;
((((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)
((BgL_pgpzd2signaturezd2subzd2creationzd2timez00_bglt)BgL_new1224z00_2667))))->BgL_criticalzf3zf3)=((bool_t)((bool_t)0)),BUNSPEC); 
{ 
obj_t BgL_auxz00_4913;
{ /* Llib/pgp_packets.scm 82 */
obj_t BgL_res2490z00_3348;
{ /* Llib/pgp_packets.scm 82 */
BGL_LONGLONG_T BgL_arg1665z00_3349;
BgL_arg1665z00_3349 = 
bgl_current_nanoseconds(); 
BgL_res2490z00_3348 = 
bgl_nanoseconds_to_date(BgL_arg1665z00_3349); } 
BgL_auxz00_4913 = BgL_res2490z00_3348; } 
((((BgL_pgpzd2signaturezd2subzd2creationzd2timez00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2creationzd2timez00_bglt)BgL_new1224z00_2667)))->BgL_creationzd2datezd2)=((obj_t)BgL_auxz00_4913),BUNSPEC); } 
BgL_auxz00_4909 = 
((BgL_pgpzd2signaturezd2subzd2creationzd2timez00_bglt)BgL_new1224z00_2667); 
return 
((obj_t)BgL_auxz00_4909);} } 

}



/* &lambda2146 */
BgL_pgpzd2signaturezd2subzd2creationzd2timez00_bglt BGl_z62lambda2146z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2668)
{
{ /* Llib/pgp_packets.scm 82 */
{ /* Llib/pgp_packets.scm 82 */
BgL_pgpzd2signaturezd2subzd2creationzd2timez00_bglt BgL_new1223z00_3350;
BgL_new1223z00_3350 = 
((BgL_pgpzd2signaturezd2subzd2creationzd2timez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2subzd2creationzd2timez00_bgl) ))); 
{ /* Llib/pgp_packets.scm 82 */
long BgL_arg2147z00_3351;
{ /* Llib/pgp_packets.scm 82 */
long BgL_res2489z00_3352;
BgL_res2489z00_3352 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2Subzd2Creationzd2Timez00zz__openpgpzd2packetszd2); 
BgL_arg2147z00_3351 = BgL_res2489z00_3352; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1223z00_3350), BgL_arg2147z00_3351); } 
{ /* Llib/pgp_packets.scm 82 */
BgL_objectz00_bglt BgL_tmpz00_4924;
BgL_tmpz00_4924 = 
((BgL_objectz00_bglt)BgL_new1223z00_3350); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4924, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1223z00_3350); 
return BgL_new1223z00_3350;} } 

}



/* &lambda2143 */
BgL_pgpzd2signaturezd2subzd2creationzd2timez00_bglt BGl_z62lambda2143z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2669, obj_t BgL_criticalzf31221zf3_2670, obj_t BgL_creationzd2date1222zd2_2671)
{
{ /* Llib/pgp_packets.scm 82 */
{ /* Llib/pgp_packets.scm 82 */
bool_t BgL_criticalzf31221zf3_3353;
BgL_criticalzf31221zf3_3353 = 
CBOOL(BgL_criticalzf31221zf3_2670); 
{ /* Llib/pgp_packets.scm 82 */
BgL_pgpzd2signaturezd2subzd2creationzd2timez00_bglt BgL_new1362z00_3355;
{ /* Llib/pgp_packets.scm 82 */
BgL_pgpzd2signaturezd2subzd2creationzd2timez00_bglt BgL_new1361z00_3356;
BgL_new1361z00_3356 = 
((BgL_pgpzd2signaturezd2subzd2creationzd2timez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2subzd2creationzd2timez00_bgl) ))); 
{ /* Llib/pgp_packets.scm 82 */
long BgL_arg2145z00_3357;
{ /* Llib/pgp_packets.scm 82 */
long BgL_res2488z00_3358;
BgL_res2488z00_3358 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2Subzd2Creationzd2Timez00zz__openpgpzd2packetszd2); 
BgL_arg2145z00_3357 = BgL_res2488z00_3358; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1361z00_3356), BgL_arg2145z00_3357); } 
{ /* Llib/pgp_packets.scm 82 */
BgL_objectz00_bglt BgL_tmpz00_4933;
BgL_tmpz00_4933 = 
((BgL_objectz00_bglt)BgL_new1361z00_3356); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4933, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1361z00_3356); 
BgL_new1362z00_3355 = BgL_new1361z00_3356; } 
((((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)BgL_new1362z00_3355)))->BgL_criticalzf3zf3)=((bool_t)BgL_criticalzf31221zf3_3353),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2creationzd2timez00_bglt)COBJECT(BgL_new1362z00_3355))->BgL_creationzd2datezd2)=((obj_t)
((obj_t)BgL_creationzd2date1222zd2_2671)),BUNSPEC); 
return BgL_new1362z00_3355;} } } 

}



/* &lambda2153 */
obj_t BGl_z62lambda2153z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2672, obj_t BgL_oz00_2673, obj_t BgL_vz00_2674)
{
{ /* Llib/pgp_packets.scm 82 */
return 
((((BgL_pgpzd2signaturezd2subzd2creationzd2timez00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2creationzd2timez00_bglt)BgL_oz00_2673)))->BgL_creationzd2datezd2)=((obj_t)
((obj_t)BgL_vz00_2674)),BUNSPEC);} 

}



/* &lambda2152 */
obj_t BGl_z62lambda2152z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2675, obj_t BgL_oz00_2676)
{
{ /* Llib/pgp_packets.scm 82 */
return 
(((BgL_pgpzd2signaturezd2subzd2creationzd2timez00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2creationzd2timez00_bglt)BgL_oz00_2676)))->BgL_creationzd2datezd2);} 

}



/* &<@anonymous:2127> */
obj_t BGl_z62zc3z04anonymousza32127ze3ze5zz__openpgpzd2packetszd2(obj_t BgL_envz00_2677, obj_t BgL_new1219z00_2678)
{
{ /* Llib/pgp_packets.scm 79 */
{ 
BgL_pgpzd2signaturezd2subzd2genericzd2_bglt BgL_auxz00_4946;
((((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)
((BgL_pgpzd2signaturezd2subzd2genericzd2_bglt)BgL_new1219z00_2678))))->BgL_criticalzf3zf3)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2genericzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2genericzd2_bglt)BgL_new1219z00_2678)))->BgL_typez00)=((obj_t)
CNST_TABLE_REF(((long)101))),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2genericzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2genericzd2_bglt)BgL_new1219z00_2678)))->BgL_dataz00)=((obj_t)BGl_string2786z00zz__openpgpzd2packetszd2),BUNSPEC); 
BgL_auxz00_4946 = 
((BgL_pgpzd2signaturezd2subzd2genericzd2_bglt)BgL_new1219z00_2678); 
return 
((obj_t)BgL_auxz00_4946);} } 

}



/* &lambda2125 */
BgL_pgpzd2signaturezd2subzd2genericzd2_bglt BGl_z62lambda2125z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2679)
{
{ /* Llib/pgp_packets.scm 79 */
{ /* Llib/pgp_packets.scm 79 */
BgL_pgpzd2signaturezd2subzd2genericzd2_bglt BgL_new1218z00_3363;
BgL_new1218z00_3363 = 
((BgL_pgpzd2signaturezd2subzd2genericzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2subzd2genericzd2_bgl) ))); 
{ /* Llib/pgp_packets.scm 79 */
long BgL_arg2126z00_3364;
{ /* Llib/pgp_packets.scm 79 */
long BgL_res2487z00_3365;
BgL_res2487z00_3365 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2Subzd2Genericzd2zz__openpgpzd2packetszd2); 
BgL_arg2126z00_3364 = BgL_res2487z00_3365; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1218z00_3363), BgL_arg2126z00_3364); } 
{ /* Llib/pgp_packets.scm 79 */
BgL_objectz00_bglt BgL_tmpz00_4961;
BgL_tmpz00_4961 = 
((BgL_objectz00_bglt)BgL_new1218z00_3363); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4961, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1218z00_3363); 
return BgL_new1218z00_3363;} } 

}



/* &lambda2123 */
BgL_pgpzd2signaturezd2subzd2genericzd2_bglt BGl_z62lambda2123z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2680, obj_t BgL_criticalzf31215zf3_2681, obj_t BgL_type1216z00_2682, obj_t BgL_data1217z00_2683)
{
{ /* Llib/pgp_packets.scm 79 */
{ /* Llib/pgp_packets.scm 79 */
bool_t BgL_criticalzf31215zf3_3366;
BgL_criticalzf31215zf3_3366 = 
CBOOL(BgL_criticalzf31215zf3_2681); 
{ /* Llib/pgp_packets.scm 79 */
BgL_pgpzd2signaturezd2subzd2genericzd2_bglt BgL_new1360z00_3369;
{ /* Llib/pgp_packets.scm 79 */
BgL_pgpzd2signaturezd2subzd2genericzd2_bglt BgL_new1359z00_3370;
BgL_new1359z00_3370 = 
((BgL_pgpzd2signaturezd2subzd2genericzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2subzd2genericzd2_bgl) ))); 
{ /* Llib/pgp_packets.scm 79 */
long BgL_arg2124z00_3371;
{ /* Llib/pgp_packets.scm 79 */
long BgL_res2486z00_3372;
BgL_res2486z00_3372 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2Subzd2Genericzd2zz__openpgpzd2packetszd2); 
BgL_arg2124z00_3371 = BgL_res2486z00_3372; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1359z00_3370), BgL_arg2124z00_3371); } 
{ /* Llib/pgp_packets.scm 79 */
BgL_objectz00_bglt BgL_tmpz00_4970;
BgL_tmpz00_4970 = 
((BgL_objectz00_bglt)BgL_new1359z00_3370); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4970, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1359z00_3370); 
BgL_new1360z00_3369 = BgL_new1359z00_3370; } 
((((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)BgL_new1360z00_3369)))->BgL_criticalzf3zf3)=((bool_t)BgL_criticalzf31215zf3_3366),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2genericzd2_bglt)COBJECT(BgL_new1360z00_3369))->BgL_typez00)=((obj_t)
((obj_t)BgL_type1216z00_2682)),BUNSPEC); 
((((BgL_pgpzd2signaturezd2subzd2genericzd2_bglt)COBJECT(BgL_new1360z00_3369))->BgL_dataz00)=((obj_t)
((obj_t)BgL_data1217z00_2683)),BUNSPEC); 
return BgL_new1360z00_3369;} } } 

}



/* &lambda2137 */
obj_t BGl_z62lambda2137z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2684, obj_t BgL_oz00_2685, obj_t BgL_vz00_2686)
{
{ /* Llib/pgp_packets.scm 79 */
return 
((((BgL_pgpzd2signaturezd2subzd2genericzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2genericzd2_bglt)BgL_oz00_2685)))->BgL_dataz00)=((obj_t)
((obj_t)BgL_vz00_2686)),BUNSPEC);} 

}



/* &lambda2136 */
obj_t BGl_z62lambda2136z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2687, obj_t BgL_oz00_2688)
{
{ /* Llib/pgp_packets.scm 79 */
return 
(((BgL_pgpzd2signaturezd2subzd2genericzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2genericzd2_bglt)BgL_oz00_2688)))->BgL_dataz00);} 

}



/* &lambda2132 */
obj_t BGl_z62lambda2132z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2689, obj_t BgL_oz00_2690, obj_t BgL_vz00_2691)
{
{ /* Llib/pgp_packets.scm 79 */
return 
((((BgL_pgpzd2signaturezd2subzd2genericzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2genericzd2_bglt)BgL_oz00_2690)))->BgL_typez00)=((obj_t)
((obj_t)BgL_vz00_2691)),BUNSPEC);} 

}



/* &lambda2131 */
obj_t BGl_z62lambda2131z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2692, obj_t BgL_oz00_2693)
{
{ /* Llib/pgp_packets.scm 79 */
return 
(((BgL_pgpzd2signaturezd2subzd2genericzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2genericzd2_bglt)BgL_oz00_2693)))->BgL_typez00);} 

}



/* &<@anonymous:2110> */
obj_t BGl_z62zc3z04anonymousza32110ze3ze5zz__openpgpzd2packetszd2(obj_t BgL_envz00_2694, obj_t BgL_new1213z00_2695)
{
{ /* Llib/pgp_packets.scm 75 */
{ 
BgL_pgpzd2signaturezd2subzd2packetzd2_bglt BgL_auxz00_4990;
((((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)BgL_new1213z00_2695)))->BgL_criticalzf3zf3)=((bool_t)((bool_t)0)),BUNSPEC); 
BgL_auxz00_4990 = 
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)BgL_new1213z00_2695); 
return 
((obj_t)BgL_auxz00_4990);} } 

}



/* &lambda2108 */
BgL_pgpzd2signaturezd2subzd2packetzd2_bglt BGl_z62lambda2108z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2696)
{
{ /* Llib/pgp_packets.scm 75 */
{ /* Llib/pgp_packets.scm 75 */
BgL_pgpzd2signaturezd2subzd2packetzd2_bglt BgL_new1212z00_3380;
BgL_new1212z00_3380 = 
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2subzd2packetzd2_bgl) ))); 
{ /* Llib/pgp_packets.scm 75 */
long BgL_arg2109z00_3381;
{ /* Llib/pgp_packets.scm 75 */
long BgL_res2485z00_3382;
BgL_res2485z00_3382 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2Subzd2Packetzd2zz__openpgpzd2packetszd2); 
BgL_arg2109z00_3381 = BgL_res2485z00_3382; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1212z00_3380), BgL_arg2109z00_3381); } 
return BgL_new1212z00_3380;} } 

}



/* &lambda2106 */
BgL_pgpzd2signaturezd2subzd2packetzd2_bglt BGl_z62lambda2106z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2697, obj_t BgL_criticalzf31211zf3_2698)
{
{ /* Llib/pgp_packets.scm 75 */
{ /* Llib/pgp_packets.scm 75 */
bool_t BgL_criticalzf31211zf3_3383;
BgL_criticalzf31211zf3_3383 = 
CBOOL(BgL_criticalzf31211zf3_2698); 
{ /* Llib/pgp_packets.scm 75 */
BgL_pgpzd2signaturezd2subzd2packetzd2_bglt BgL_new1358z00_3384;
{ /* Llib/pgp_packets.scm 75 */
BgL_pgpzd2signaturezd2subzd2packetzd2_bglt BgL_new1357z00_3385;
BgL_new1357z00_3385 = 
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2subzd2packetzd2_bgl) ))); 
{ /* Llib/pgp_packets.scm 75 */
long BgL_arg2107z00_3386;
{ /* Llib/pgp_packets.scm 75 */
long BgL_res2484z00_3387;
BgL_res2484z00_3387 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2Subzd2Packetzd2zz__openpgpzd2packetszd2); 
BgL_arg2107z00_3386 = BgL_res2484z00_3387; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1357z00_3385), BgL_arg2107z00_3386); } 
BgL_new1358z00_3384 = BgL_new1357z00_3385; } 
((((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(BgL_new1358z00_3384))->BgL_criticalzf3zf3)=((bool_t)BgL_criticalzf31211zf3_3383),BUNSPEC); 
return BgL_new1358z00_3384;} } } 

}



/* &<@anonymous:2117> */
obj_t BGl_z62zc3z04anonymousza32117ze3ze5zz__openpgpzd2packetszd2(obj_t BgL_envz00_2699)
{
{ /* Llib/pgp_packets.scm 75 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda2116 */
obj_t BGl_z62lambda2116z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2700, obj_t BgL_oz00_2701, obj_t BgL_vz00_2702)
{
{ /* Llib/pgp_packets.scm 75 */
{ /* Llib/pgp_packets.scm 75 */
bool_t BgL_vz00_3389;
BgL_vz00_3389 = 
CBOOL(BgL_vz00_2702); 
return 
((((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)BgL_oz00_2701)))->BgL_criticalzf3zf3)=((bool_t)BgL_vz00_3389),BUNSPEC);} } 

}



/* &lambda2115 */
obj_t BGl_z62lambda2115z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2703, obj_t BgL_oz00_2704)
{
{ /* Llib/pgp_packets.scm 75 */
return 
BBOOL(
(((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2subzd2packetzd2_bglt)BgL_oz00_2704)))->BgL_criticalzf3zf3));} 

}



/* &<@anonymous:2095> */
obj_t BGl_z62zc3z04anonymousza32095ze3ze5zz__openpgpzd2packetszd2(obj_t BgL_envz00_2705, obj_t BgL_new1209z00_2706)
{
{ /* Llib/pgp_packets.scm 72 */
{ 
BgL_pgpzd2mdczd2packetz00_bglt BgL_auxz00_5012;
((((BgL_pgpzd2mdczd2packetz00_bglt)COBJECT(
((BgL_pgpzd2mdczd2packetz00_bglt)BgL_new1209z00_2706)))->BgL_hashz00)=((obj_t)BGl_string2786z00zz__openpgpzd2packetszd2),BUNSPEC); 
BgL_auxz00_5012 = 
((BgL_pgpzd2mdczd2packetz00_bglt)BgL_new1209z00_2706); 
return 
((obj_t)BgL_auxz00_5012);} } 

}



/* &lambda2093 */
BgL_pgpzd2mdczd2packetz00_bglt BGl_z62lambda2093z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2707)
{
{ /* Llib/pgp_packets.scm 72 */
{ /* Llib/pgp_packets.scm 72 */
BgL_pgpzd2mdczd2packetz00_bglt BgL_new1208z00_3392;
BgL_new1208z00_3392 = 
((BgL_pgpzd2mdczd2packetz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2mdczd2packetz00_bgl) ))); 
{ /* Llib/pgp_packets.scm 72 */
long BgL_arg2094z00_3393;
{ /* Llib/pgp_packets.scm 72 */
long BgL_res2483z00_3394;
BgL_res2483z00_3394 = 
BGL_CLASS_INDEX(BGl_PGPzd2MDCzd2Packetz00zz__openpgpzd2packetszd2); 
BgL_arg2094z00_3393 = BgL_res2483z00_3394; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1208z00_3392), BgL_arg2094z00_3393); } 
{ /* Llib/pgp_packets.scm 72 */
BgL_objectz00_bglt BgL_tmpz00_5021;
BgL_tmpz00_5021 = 
((BgL_objectz00_bglt)BgL_new1208z00_3392); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_5021, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1208z00_3392); 
return BgL_new1208z00_3392;} } 

}



/* &lambda2091 */
BgL_pgpzd2mdczd2packetz00_bglt BGl_z62lambda2091z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2708, obj_t BgL_hash1207z00_2709)
{
{ /* Llib/pgp_packets.scm 72 */
{ /* Llib/pgp_packets.scm 72 */
BgL_pgpzd2mdczd2packetz00_bglt BgL_new1356z00_3396;
{ /* Llib/pgp_packets.scm 72 */
BgL_pgpzd2mdczd2packetz00_bglt BgL_new1355z00_3397;
BgL_new1355z00_3397 = 
((BgL_pgpzd2mdczd2packetz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2mdczd2packetz00_bgl) ))); 
{ /* Llib/pgp_packets.scm 72 */
long BgL_arg2092z00_3398;
{ /* Llib/pgp_packets.scm 72 */
long BgL_res2482z00_3399;
BgL_res2482z00_3399 = 
BGL_CLASS_INDEX(BGl_PGPzd2MDCzd2Packetz00zz__openpgpzd2packetszd2); 
BgL_arg2092z00_3398 = BgL_res2482z00_3399; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1355z00_3397), BgL_arg2092z00_3398); } 
{ /* Llib/pgp_packets.scm 72 */
BgL_objectz00_bglt BgL_tmpz00_5029;
BgL_tmpz00_5029 = 
((BgL_objectz00_bglt)BgL_new1355z00_3397); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_5029, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1355z00_3397); 
BgL_new1356z00_3396 = BgL_new1355z00_3397; } 
((((BgL_pgpzd2mdczd2packetz00_bglt)COBJECT(BgL_new1356z00_3396))->BgL_hashz00)=((obj_t)
((obj_t)BgL_hash1207z00_2709)),BUNSPEC); 
return BgL_new1356z00_3396;} } 

}



/* &lambda2100 */
obj_t BGl_z62lambda2100z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2710, obj_t BgL_oz00_2711, obj_t BgL_vz00_2712)
{
{ /* Llib/pgp_packets.scm 72 */
return 
((((BgL_pgpzd2mdczd2packetz00_bglt)COBJECT(
((BgL_pgpzd2mdczd2packetz00_bglt)BgL_oz00_2711)))->BgL_hashz00)=((obj_t)
((obj_t)BgL_vz00_2712)),BUNSPEC);} 

}



/* &lambda2099 */
obj_t BGl_z62lambda2099z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2713, obj_t BgL_oz00_2714)
{
{ /* Llib/pgp_packets.scm 72 */
return 
(((BgL_pgpzd2mdczd2packetz00_bglt)COBJECT(
((BgL_pgpzd2mdczd2packetz00_bglt)BgL_oz00_2714)))->BgL_hashz00);} 

}



/* &<@anonymous:2080> */
obj_t BGl_z62zc3z04anonymousza32080ze3ze5zz__openpgpzd2packetszd2(obj_t BgL_envz00_2715, obj_t BgL_new1205z00_2716)
{
{ /* Llib/pgp_packets.scm 70 */
{ 
BgL_pgpzd2mdczd2symmetricallyzd2encryptedzd2packetz00_bglt BgL_auxz00_5040;
((((BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt)
((BgL_pgpzd2mdczd2symmetricallyzd2encryptedzd2packetz00_bglt)BgL_new1205z00_2716))))->BgL_dataz00)=((obj_t)BGl_string2786z00zz__openpgpzd2packetszd2),BUNSPEC); 
((((BgL_pgpzd2mdczd2symmetricallyzd2encryptedzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2mdczd2symmetricallyzd2encryptedzd2packetz00_bglt)BgL_new1205z00_2716)))->BgL_versionz00)=((long)((long)0)),BUNSPEC); 
BgL_auxz00_5040 = 
((BgL_pgpzd2mdczd2symmetricallyzd2encryptedzd2packetz00_bglt)BgL_new1205z00_2716); 
return 
((obj_t)BgL_auxz00_5040);} } 

}



/* &lambda2078 */
BgL_pgpzd2mdczd2symmetricallyzd2encryptedzd2packetz00_bglt BGl_z62lambda2078z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2717)
{
{ /* Llib/pgp_packets.scm 70 */
{ /* Llib/pgp_packets.scm 70 */
BgL_pgpzd2mdczd2symmetricallyzd2encryptedzd2packetz00_bglt BgL_new1204z00_3404;
BgL_new1204z00_3404 = 
((BgL_pgpzd2mdczd2symmetricallyzd2encryptedzd2packetz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2mdczd2symmetricallyzd2encryptedzd2packetz00_bgl) ))); 
{ /* Llib/pgp_packets.scm 70 */
long BgL_arg2079z00_3405;
{ /* Llib/pgp_packets.scm 70 */
long BgL_res2481z00_3406;
BgL_res2481z00_3406 = 
BGL_CLASS_INDEX(BGl_PGPzd2MDCzd2Symmetricallyzd2Encryptedzd2Packetz00zz__openpgpzd2packetszd2); 
BgL_arg2079z00_3405 = BgL_res2481z00_3406; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1204z00_3404), BgL_arg2079z00_3405); } 
{ /* Llib/pgp_packets.scm 70 */
BgL_objectz00_bglt BgL_tmpz00_5052;
BgL_tmpz00_5052 = 
((BgL_objectz00_bglt)BgL_new1204z00_3404); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_5052, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1204z00_3404); 
return BgL_new1204z00_3404;} } 

}



/* &lambda2076 */
BgL_pgpzd2mdczd2symmetricallyzd2encryptedzd2packetz00_bglt BGl_z62lambda2076z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2718, obj_t BgL_data1202z00_2719, obj_t BgL_version1203z00_2720)
{
{ /* Llib/pgp_packets.scm 70 */
{ /* Llib/pgp_packets.scm 70 */
long BgL_version1203z00_3408;
BgL_version1203z00_3408 = 
(long)CINT(BgL_version1203z00_2720); 
{ /* Llib/pgp_packets.scm 70 */
BgL_pgpzd2mdczd2symmetricallyzd2encryptedzd2packetz00_bglt BgL_new1354z00_3409;
{ /* Llib/pgp_packets.scm 70 */
BgL_pgpzd2mdczd2symmetricallyzd2encryptedzd2packetz00_bglt BgL_new1353z00_3410;
BgL_new1353z00_3410 = 
((BgL_pgpzd2mdczd2symmetricallyzd2encryptedzd2packetz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2mdczd2symmetricallyzd2encryptedzd2packetz00_bgl) ))); 
{ /* Llib/pgp_packets.scm 70 */
long BgL_arg2077z00_3411;
{ /* Llib/pgp_packets.scm 70 */
long BgL_res2480z00_3412;
BgL_res2480z00_3412 = 
BGL_CLASS_INDEX(BGl_PGPzd2MDCzd2Symmetricallyzd2Encryptedzd2Packetz00zz__openpgpzd2packetszd2); 
BgL_arg2077z00_3411 = BgL_res2480z00_3412; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1353z00_3410), BgL_arg2077z00_3411); } 
{ /* Llib/pgp_packets.scm 70 */
BgL_objectz00_bglt BgL_tmpz00_5061;
BgL_tmpz00_5061 = 
((BgL_objectz00_bglt)BgL_new1353z00_3410); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_5061, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1353z00_3410); 
BgL_new1354z00_3409 = BgL_new1353z00_3410; } 
((((BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt)BgL_new1354z00_3409)))->BgL_dataz00)=((obj_t)
((obj_t)BgL_data1202z00_2719)),BUNSPEC); 
((((BgL_pgpzd2mdczd2symmetricallyzd2encryptedzd2packetz00_bglt)COBJECT(BgL_new1354z00_3409))->BgL_versionz00)=((long)BgL_version1203z00_3408),BUNSPEC); 
return BgL_new1354z00_3409;} } } 

}



/* &lambda2085 */
obj_t BGl_z62lambda2085z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2721, obj_t BgL_oz00_2722, obj_t BgL_vz00_2723)
{
{ /* Llib/pgp_packets.scm 70 */
{ /* Llib/pgp_packets.scm 70 */
long BgL_vz00_3414;
BgL_vz00_3414 = 
(long)CINT(BgL_vz00_2723); 
return 
((((BgL_pgpzd2mdczd2symmetricallyzd2encryptedzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2mdczd2symmetricallyzd2encryptedzd2packetz00_bglt)BgL_oz00_2722)))->BgL_versionz00)=((long)BgL_vz00_3414),BUNSPEC);} } 

}



/* &lambda2084 */
obj_t BGl_z62lambda2084z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2724, obj_t BgL_oz00_2725)
{
{ /* Llib/pgp_packets.scm 70 */
return 
BINT(
(((BgL_pgpzd2mdczd2symmetricallyzd2encryptedzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2mdczd2symmetricallyzd2encryptedzd2packetz00_bglt)BgL_oz00_2725)))->BgL_versionz00));} 

}



/* &<@anonymous:2065> */
obj_t BGl_z62zc3z04anonymousza32065ze3ze5zz__openpgpzd2packetszd2(obj_t BgL_envz00_2726, obj_t BgL_new1200z00_2727)
{
{ /* Llib/pgp_packets.scm 68 */
{ 
BgL_pgpzd2attributezd2packetz00_bglt BgL_auxz00_5075;
((((BgL_pgpzd2attributezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2attributezd2packetz00_bglt)BgL_new1200z00_2727)))->BgL_dataz00)=((obj_t)BGl_string2786z00zz__openpgpzd2packetszd2),BUNSPEC); 
BgL_auxz00_5075 = 
((BgL_pgpzd2attributezd2packetz00_bglt)BgL_new1200z00_2727); 
return 
((obj_t)BgL_auxz00_5075);} } 

}



/* &lambda2063 */
BgL_pgpzd2attributezd2packetz00_bglt BGl_z62lambda2063z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2728)
{
{ /* Llib/pgp_packets.scm 68 */
{ /* Llib/pgp_packets.scm 68 */
BgL_pgpzd2attributezd2packetz00_bglt BgL_new1199z00_3417;
BgL_new1199z00_3417 = 
((BgL_pgpzd2attributezd2packetz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2attributezd2packetz00_bgl) ))); 
{ /* Llib/pgp_packets.scm 68 */
long BgL_arg2064z00_3418;
{ /* Llib/pgp_packets.scm 68 */
long BgL_res2479z00_3419;
BgL_res2479z00_3419 = 
BGL_CLASS_INDEX(BGl_PGPzd2Attributezd2Packetz00zz__openpgpzd2packetszd2); 
BgL_arg2064z00_3418 = BgL_res2479z00_3419; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1199z00_3417), BgL_arg2064z00_3418); } 
{ /* Llib/pgp_packets.scm 68 */
BgL_objectz00_bglt BgL_tmpz00_5084;
BgL_tmpz00_5084 = 
((BgL_objectz00_bglt)BgL_new1199z00_3417); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_5084, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1199z00_3417); 
return BgL_new1199z00_3417;} } 

}



/* &lambda2061 */
BgL_pgpzd2attributezd2packetz00_bglt BGl_z62lambda2061z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2729, obj_t BgL_data1198z00_2730)
{
{ /* Llib/pgp_packets.scm 68 */
{ /* Llib/pgp_packets.scm 68 */
BgL_pgpzd2attributezd2packetz00_bglt BgL_new1352z00_3421;
{ /* Llib/pgp_packets.scm 68 */
BgL_pgpzd2attributezd2packetz00_bglt BgL_new1351z00_3422;
BgL_new1351z00_3422 = 
((BgL_pgpzd2attributezd2packetz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2attributezd2packetz00_bgl) ))); 
{ /* Llib/pgp_packets.scm 68 */
long BgL_arg2062z00_3423;
{ /* Llib/pgp_packets.scm 68 */
long BgL_res2478z00_3424;
BgL_res2478z00_3424 = 
BGL_CLASS_INDEX(BGl_PGPzd2Attributezd2Packetz00zz__openpgpzd2packetszd2); 
BgL_arg2062z00_3423 = BgL_res2478z00_3424; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1351z00_3422), BgL_arg2062z00_3423); } 
{ /* Llib/pgp_packets.scm 68 */
BgL_objectz00_bglt BgL_tmpz00_5092;
BgL_tmpz00_5092 = 
((BgL_objectz00_bglt)BgL_new1351z00_3422); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_5092, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1351z00_3422); 
BgL_new1352z00_3421 = BgL_new1351z00_3422; } 
((((BgL_pgpzd2attributezd2packetz00_bglt)COBJECT(BgL_new1352z00_3421))->BgL_dataz00)=((obj_t)
((obj_t)BgL_data1198z00_2730)),BUNSPEC); 
return BgL_new1352z00_3421;} } 

}



/* &lambda2070 */
obj_t BGl_z62lambda2070z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2731, obj_t BgL_oz00_2732, obj_t BgL_vz00_2733)
{
{ /* Llib/pgp_packets.scm 68 */
return 
((((BgL_pgpzd2attributezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2attributezd2packetz00_bglt)BgL_oz00_2732)))->BgL_dataz00)=((obj_t)
((obj_t)BgL_vz00_2733)),BUNSPEC);} 

}



/* &lambda2069 */
obj_t BGl_z62lambda2069z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2734, obj_t BgL_oz00_2735)
{
{ /* Llib/pgp_packets.scm 68 */
return 
(((BgL_pgpzd2attributezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2attributezd2packetz00_bglt)BgL_oz00_2735)))->BgL_dataz00);} 

}



/* &<@anonymous:2050> */
obj_t BGl_z62zc3z04anonymousza32050ze3ze5zz__openpgpzd2packetszd2(obj_t BgL_envz00_2736, obj_t BgL_new1196z00_2737)
{
{ /* Llib/pgp_packets.scm 66 */
{ 
BgL_pgpzd2idzd2packetz00_bglt BgL_auxz00_5103;
((((BgL_pgpzd2idzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2idzd2packetz00_bglt)BgL_new1196z00_2737)))->BgL_dataz00)=((obj_t)BGl_string2786z00zz__openpgpzd2packetszd2),BUNSPEC); 
BgL_auxz00_5103 = 
((BgL_pgpzd2idzd2packetz00_bglt)BgL_new1196z00_2737); 
return 
((obj_t)BgL_auxz00_5103);} } 

}



/* &lambda2048 */
BgL_pgpzd2idzd2packetz00_bglt BGl_z62lambda2048z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2738)
{
{ /* Llib/pgp_packets.scm 66 */
{ /* Llib/pgp_packets.scm 66 */
BgL_pgpzd2idzd2packetz00_bglt BgL_new1195z00_3429;
BgL_new1195z00_3429 = 
((BgL_pgpzd2idzd2packetz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2idzd2packetz00_bgl) ))); 
{ /* Llib/pgp_packets.scm 66 */
long BgL_arg2049z00_3430;
{ /* Llib/pgp_packets.scm 66 */
long BgL_res2477z00_3431;
BgL_res2477z00_3431 = 
BGL_CLASS_INDEX(BGl_PGPzd2IDzd2Packetz00zz__openpgpzd2packetszd2); 
BgL_arg2049z00_3430 = BgL_res2477z00_3431; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1195z00_3429), BgL_arg2049z00_3430); } 
{ /* Llib/pgp_packets.scm 66 */
BgL_objectz00_bglt BgL_tmpz00_5112;
BgL_tmpz00_5112 = 
((BgL_objectz00_bglt)BgL_new1195z00_3429); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_5112, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1195z00_3429); 
return BgL_new1195z00_3429;} } 

}



/* &lambda2046 */
BgL_pgpzd2idzd2packetz00_bglt BGl_z62lambda2046z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2739, obj_t BgL_data1194z00_2740)
{
{ /* Llib/pgp_packets.scm 66 */
{ /* Llib/pgp_packets.scm 66 */
BgL_pgpzd2idzd2packetz00_bglt BgL_new1350z00_3433;
{ /* Llib/pgp_packets.scm 66 */
BgL_pgpzd2idzd2packetz00_bglt BgL_new1349z00_3434;
BgL_new1349z00_3434 = 
((BgL_pgpzd2idzd2packetz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2idzd2packetz00_bgl) ))); 
{ /* Llib/pgp_packets.scm 66 */
long BgL_arg2047z00_3435;
{ /* Llib/pgp_packets.scm 66 */
long BgL_res2476z00_3436;
BgL_res2476z00_3436 = 
BGL_CLASS_INDEX(BGl_PGPzd2IDzd2Packetz00zz__openpgpzd2packetszd2); 
BgL_arg2047z00_3435 = BgL_res2476z00_3436; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1349z00_3434), BgL_arg2047z00_3435); } 
{ /* Llib/pgp_packets.scm 66 */
BgL_objectz00_bglt BgL_tmpz00_5120;
BgL_tmpz00_5120 = 
((BgL_objectz00_bglt)BgL_new1349z00_3434); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_5120, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1349z00_3434); 
BgL_new1350z00_3433 = BgL_new1349z00_3434; } 
((((BgL_pgpzd2idzd2packetz00_bglt)COBJECT(BgL_new1350z00_3433))->BgL_dataz00)=((obj_t)
((obj_t)BgL_data1194z00_2740)),BUNSPEC); 
return BgL_new1350z00_3433;} } 

}



/* &lambda2055 */
obj_t BGl_z62lambda2055z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2741, obj_t BgL_oz00_2742, obj_t BgL_vz00_2743)
{
{ /* Llib/pgp_packets.scm 66 */
return 
((((BgL_pgpzd2idzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2idzd2packetz00_bglt)BgL_oz00_2742)))->BgL_dataz00)=((obj_t)
((obj_t)BgL_vz00_2743)),BUNSPEC);} 

}



/* &lambda2054 */
obj_t BGl_z62lambda2054z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2744, obj_t BgL_oz00_2745)
{
{ /* Llib/pgp_packets.scm 66 */
return 
(((BgL_pgpzd2idzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2idzd2packetz00_bglt)BgL_oz00_2745)))->BgL_dataz00);} 

}



/* &<@anonymous:2040> */
obj_t BGl_z62zc3z04anonymousza32040ze3ze5zz__openpgpzd2packetszd2(obj_t BgL_envz00_2746, obj_t BgL_new1192z00_2747)
{
{ /* Llib/pgp_packets.scm 65 */
return 
((obj_t)
((BgL_pgpzd2trustzd2packetz00_bglt)BgL_new1192z00_2747));} 

}



/* &lambda2038 */
BgL_pgpzd2trustzd2packetz00_bglt BGl_z62lambda2038z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2748)
{
{ /* Llib/pgp_packets.scm 65 */
{ /* Llib/pgp_packets.scm 65 */
BgL_pgpzd2trustzd2packetz00_bglt BgL_new1191z00_3441;
BgL_new1191z00_3441 = 
((BgL_pgpzd2trustzd2packetz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2trustzd2packetz00_bgl) ))); 
{ /* Llib/pgp_packets.scm 65 */
long BgL_arg2039z00_3442;
{ /* Llib/pgp_packets.scm 65 */
long BgL_res2475z00_3443;
BgL_res2475z00_3443 = 
BGL_CLASS_INDEX(BGl_PGPzd2Trustzd2Packetz00zz__openpgpzd2packetszd2); 
BgL_arg2039z00_3442 = BgL_res2475z00_3443; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1191z00_3441), BgL_arg2039z00_3442); } 
{ /* Llib/pgp_packets.scm 65 */
BgL_objectz00_bglt BgL_tmpz00_5137;
BgL_tmpz00_5137 = 
((BgL_objectz00_bglt)BgL_new1191z00_3441); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_5137, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1191z00_3441); 
return BgL_new1191z00_3441;} } 

}



/* &lambda2036 */
BgL_pgpzd2trustzd2packetz00_bglt BGl_z62lambda2036z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2749)
{
{ /* Llib/pgp_packets.scm 65 */
{ /* Llib/pgp_packets.scm 65 */
BgL_pgpzd2trustzd2packetz00_bglt BgL_new1348z00_3444;
{ /* Llib/pgp_packets.scm 65 */
BgL_pgpzd2trustzd2packetz00_bglt BgL_new1347z00_3445;
BgL_new1347z00_3445 = 
((BgL_pgpzd2trustzd2packetz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2trustzd2packetz00_bgl) ))); 
{ /* Llib/pgp_packets.scm 65 */
long BgL_arg2037z00_3446;
{ /* Llib/pgp_packets.scm 65 */
long BgL_res2474z00_3447;
BgL_res2474z00_3447 = 
BGL_CLASS_INDEX(BGl_PGPzd2Trustzd2Packetz00zz__openpgpzd2packetszd2); 
BgL_arg2037z00_3446 = BgL_res2474z00_3447; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1347z00_3445), BgL_arg2037z00_3446); } 
{ /* Llib/pgp_packets.scm 65 */
BgL_objectz00_bglt BgL_tmpz00_5145;
BgL_tmpz00_5145 = 
((BgL_objectz00_bglt)BgL_new1347z00_3445); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_5145, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1347z00_3445); 
BgL_new1348z00_3444 = BgL_new1347z00_3445; } 
return BgL_new1348z00_3444;} } 

}



/* &<@anonymous:2005> */
obj_t BGl_z62zc3z04anonymousza32005ze3ze5zz__openpgpzd2packetszd2(obj_t BgL_envz00_2750, obj_t BgL_new1189z00_2751)
{
{ /* Llib/pgp_packets.scm 59 */
{ 
BgL_pgpzd2literalzd2packetz00_bglt BgL_auxz00_5149;
((((BgL_pgpzd2literalzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2literalzd2packetz00_bglt)BgL_new1189z00_2751)))->BgL_formatz00)=((obj_t)
CNST_TABLE_REF(((long)101))),BUNSPEC); 
((((BgL_pgpzd2literalzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2literalzd2packetz00_bglt)BgL_new1189z00_2751)))->BgL_forzd2yourzd2eyeszd2onlyzf3z21)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_pgpzd2literalzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2literalzd2packetz00_bglt)BgL_new1189z00_2751)))->BgL_filezd2namezd2)=((obj_t)BUNSPEC),BUNSPEC); 
{ 
obj_t BgL_auxz00_5157;
{ /* Llib/pgp_packets.scm 59 */
obj_t BgL_res2473z00_3449;
{ /* Llib/pgp_packets.scm 59 */
BGL_LONGLONG_T BgL_arg1665z00_3450;
BgL_arg1665z00_3450 = 
bgl_current_nanoseconds(); 
BgL_res2473z00_3449 = 
bgl_nanoseconds_to_date(BgL_arg1665z00_3450); } 
BgL_auxz00_5157 = BgL_res2473z00_3449; } 
((((BgL_pgpzd2literalzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2literalzd2packetz00_bglt)BgL_new1189z00_2751)))->BgL_creationzd2datezd2)=((obj_t)BgL_auxz00_5157),BUNSPEC); } 
((((BgL_pgpzd2literalzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2literalzd2packetz00_bglt)BgL_new1189z00_2751)))->BgL_dataz00)=((obj_t)BGl_string2786z00zz__openpgpzd2packetszd2),BUNSPEC); 
BgL_auxz00_5149 = 
((BgL_pgpzd2literalzd2packetz00_bglt)BgL_new1189z00_2751); 
return 
((obj_t)BgL_auxz00_5149);} } 

}



/* &lambda2003 */
BgL_pgpzd2literalzd2packetz00_bglt BGl_z62lambda2003z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2752)
{
{ /* Llib/pgp_packets.scm 59 */
{ /* Llib/pgp_packets.scm 59 */
BgL_pgpzd2literalzd2packetz00_bglt BgL_new1188z00_3451;
BgL_new1188z00_3451 = 
((BgL_pgpzd2literalzd2packetz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2literalzd2packetz00_bgl) ))); 
{ /* Llib/pgp_packets.scm 59 */
long BgL_arg2004z00_3452;
{ /* Llib/pgp_packets.scm 59 */
long BgL_res2472z00_3453;
BgL_res2472z00_3453 = 
BGL_CLASS_INDEX(BGl_PGPzd2Literalzd2Packetz00zz__openpgpzd2packetszd2); 
BgL_arg2004z00_3452 = BgL_res2472z00_3453; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1188z00_3451), BgL_arg2004z00_3452); } 
{ /* Llib/pgp_packets.scm 59 */
BgL_objectz00_bglt BgL_tmpz00_5170;
BgL_tmpz00_5170 = 
((BgL_objectz00_bglt)BgL_new1188z00_3451); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_5170, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1188z00_3451); 
return BgL_new1188z00_3451;} } 

}



/* &lambda2001 */
BgL_pgpzd2literalzd2packetz00_bglt BGl_z62lambda2001z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2753, obj_t BgL_format1183z00_2754, obj_t BgL_forzd2yourzd2eyeszd2onlyzf31184z21_2755, obj_t BgL_filezd2name1185zd2_2756, obj_t BgL_creationzd2date1186zd2_2757, obj_t BgL_data1187z00_2758)
{
{ /* Llib/pgp_packets.scm 59 */
{ /* Llib/pgp_packets.scm 59 */
bool_t BgL_forzd2yourzd2eyeszd2onlyzf31184z21_3455;
BgL_forzd2yourzd2eyeszd2onlyzf31184z21_3455 = 
CBOOL(BgL_forzd2yourzd2eyeszd2onlyzf31184z21_2755); 
{ /* Llib/pgp_packets.scm 59 */
BgL_pgpzd2literalzd2packetz00_bglt BgL_new1346z00_3458;
{ /* Llib/pgp_packets.scm 59 */
BgL_pgpzd2literalzd2packetz00_bglt BgL_new1345z00_3459;
BgL_new1345z00_3459 = 
((BgL_pgpzd2literalzd2packetz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2literalzd2packetz00_bgl) ))); 
{ /* Llib/pgp_packets.scm 59 */
long BgL_arg2002z00_3460;
{ /* Llib/pgp_packets.scm 59 */
long BgL_res2471z00_3461;
BgL_res2471z00_3461 = 
BGL_CLASS_INDEX(BGl_PGPzd2Literalzd2Packetz00zz__openpgpzd2packetszd2); 
BgL_arg2002z00_3460 = BgL_res2471z00_3461; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1345z00_3459), BgL_arg2002z00_3460); } 
{ /* Llib/pgp_packets.scm 59 */
BgL_objectz00_bglt BgL_tmpz00_5179;
BgL_tmpz00_5179 = 
((BgL_objectz00_bglt)BgL_new1345z00_3459); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_5179, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1345z00_3459); 
BgL_new1346z00_3458 = BgL_new1345z00_3459; } 
((((BgL_pgpzd2literalzd2packetz00_bglt)COBJECT(BgL_new1346z00_3458))->BgL_formatz00)=((obj_t)
((obj_t)BgL_format1183z00_2754)),BUNSPEC); 
((((BgL_pgpzd2literalzd2packetz00_bglt)COBJECT(BgL_new1346z00_3458))->BgL_forzd2yourzd2eyeszd2onlyzf3z21)=((bool_t)BgL_forzd2yourzd2eyeszd2onlyzf31184z21_3455),BUNSPEC); 
((((BgL_pgpzd2literalzd2packetz00_bglt)COBJECT(BgL_new1346z00_3458))->BgL_filezd2namezd2)=((obj_t)BgL_filezd2name1185zd2_2756),BUNSPEC); 
((((BgL_pgpzd2literalzd2packetz00_bglt)COBJECT(BgL_new1346z00_3458))->BgL_creationzd2datezd2)=((obj_t)
((obj_t)BgL_creationzd2date1186zd2_2757)),BUNSPEC); 
((((BgL_pgpzd2literalzd2packetz00_bglt)COBJECT(BgL_new1346z00_3458))->BgL_dataz00)=((obj_t)
((obj_t)BgL_data1187z00_2758)),BUNSPEC); 
return BgL_new1346z00_3458;} } } 

}



/* &lambda2030 */
obj_t BGl_z62lambda2030z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2759, obj_t BgL_oz00_2760, obj_t BgL_vz00_2761)
{
{ /* Llib/pgp_packets.scm 59 */
return 
((((BgL_pgpzd2literalzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2literalzd2packetz00_bglt)BgL_oz00_2760)))->BgL_dataz00)=((obj_t)
((obj_t)BgL_vz00_2761)),BUNSPEC);} 

}



/* &lambda2029 */
obj_t BGl_z62lambda2029z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2762, obj_t BgL_oz00_2763)
{
{ /* Llib/pgp_packets.scm 59 */
return 
(((BgL_pgpzd2literalzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2literalzd2packetz00_bglt)BgL_oz00_2763)))->BgL_dataz00);} 

}



/* &lambda2025 */
obj_t BGl_z62lambda2025z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2764, obj_t BgL_oz00_2765, obj_t BgL_vz00_2766)
{
{ /* Llib/pgp_packets.scm 59 */
return 
((((BgL_pgpzd2literalzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2literalzd2packetz00_bglt)BgL_oz00_2765)))->BgL_creationzd2datezd2)=((obj_t)
((obj_t)BgL_vz00_2766)),BUNSPEC);} 

}



/* &lambda2024 */
obj_t BGl_z62lambda2024z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2767, obj_t BgL_oz00_2768)
{
{ /* Llib/pgp_packets.scm 59 */
return 
(((BgL_pgpzd2literalzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2literalzd2packetz00_bglt)BgL_oz00_2768)))->BgL_creationzd2datezd2);} 

}



/* &lambda2020 */
obj_t BGl_z62lambda2020z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2769, obj_t BgL_oz00_2770, obj_t BgL_vz00_2771)
{
{ /* Llib/pgp_packets.scm 59 */
return 
((((BgL_pgpzd2literalzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2literalzd2packetz00_bglt)BgL_oz00_2770)))->BgL_filezd2namezd2)=((obj_t)BgL_vz00_2771),BUNSPEC);} 

}



/* &lambda2019 */
obj_t BGl_z62lambda2019z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2772, obj_t BgL_oz00_2773)
{
{ /* Llib/pgp_packets.scm 59 */
return 
(((BgL_pgpzd2literalzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2literalzd2packetz00_bglt)BgL_oz00_2773)))->BgL_filezd2namezd2);} 

}



/* &lambda2015 */
obj_t BGl_z62lambda2015z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2774, obj_t BgL_oz00_2775, obj_t BgL_vz00_2776)
{
{ /* Llib/pgp_packets.scm 59 */
{ /* Llib/pgp_packets.scm 59 */
bool_t BgL_vz00_3471;
BgL_vz00_3471 = 
CBOOL(BgL_vz00_2776); 
return 
((((BgL_pgpzd2literalzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2literalzd2packetz00_bglt)BgL_oz00_2775)))->BgL_forzd2yourzd2eyeszd2onlyzf3z21)=((bool_t)BgL_vz00_3471),BUNSPEC);} } 

}



/* &lambda2014 */
obj_t BGl_z62lambda2014z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2777, obj_t BgL_oz00_2778)
{
{ /* Llib/pgp_packets.scm 59 */
return 
BBOOL(
(((BgL_pgpzd2literalzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2literalzd2packetz00_bglt)BgL_oz00_2778)))->BgL_forzd2yourzd2eyeszd2onlyzf3z21));} 

}



/* &lambda2010 */
obj_t BGl_z62lambda2010z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2779, obj_t BgL_oz00_2780, obj_t BgL_vz00_2781)
{
{ /* Llib/pgp_packets.scm 59 */
return 
((((BgL_pgpzd2literalzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2literalzd2packetz00_bglt)BgL_oz00_2780)))->BgL_formatz00)=((obj_t)
((obj_t)BgL_vz00_2781)),BUNSPEC);} 

}



/* &lambda2009 */
obj_t BGl_z62lambda2009z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2782, obj_t BgL_oz00_2783)
{
{ /* Llib/pgp_packets.scm 59 */
return 
(((BgL_pgpzd2literalzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2literalzd2packetz00_bglt)BgL_oz00_2783)))->BgL_formatz00);} 

}



/* &<@anonymous:1995> */
obj_t BGl_z62zc3z04anonymousza31995ze3ze5zz__openpgpzd2packetszd2(obj_t BgL_envz00_2784, obj_t BgL_new1181z00_2785)
{
{ /* Llib/pgp_packets.scm 58 */
return 
((obj_t)
((BgL_pgpzd2markerzd2packetz00_bglt)BgL_new1181z00_2785));} 

}



/* &lambda1993 */
BgL_pgpzd2markerzd2packetz00_bglt BGl_z62lambda1993z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2786)
{
{ /* Llib/pgp_packets.scm 58 */
{ /* Llib/pgp_packets.scm 58 */
BgL_pgpzd2markerzd2packetz00_bglt BgL_new1180z00_3477;
BgL_new1180z00_3477 = 
((BgL_pgpzd2markerzd2packetz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2markerzd2packetz00_bgl) ))); 
{ /* Llib/pgp_packets.scm 58 */
long BgL_arg1994z00_3478;
{ /* Llib/pgp_packets.scm 58 */
long BgL_res2470z00_3479;
BgL_res2470z00_3479 = 
BGL_CLASS_INDEX(BGl_PGPzd2Markerzd2Packetz00zz__openpgpzd2packetszd2); 
BgL_arg1994z00_3478 = BgL_res2470z00_3479; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1180z00_3477), BgL_arg1994z00_3478); } 
{ /* Llib/pgp_packets.scm 58 */
BgL_objectz00_bglt BgL_tmpz00_5222;
BgL_tmpz00_5222 = 
((BgL_objectz00_bglt)BgL_new1180z00_3477); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_5222, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1180z00_3477); 
return BgL_new1180z00_3477;} } 

}



/* &lambda1991 */
BgL_pgpzd2markerzd2packetz00_bglt BGl_z62lambda1991z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2787)
{
{ /* Llib/pgp_packets.scm 58 */
{ /* Llib/pgp_packets.scm 58 */
BgL_pgpzd2markerzd2packetz00_bglt BgL_new1344z00_3480;
{ /* Llib/pgp_packets.scm 58 */
BgL_pgpzd2markerzd2packetz00_bglt BgL_new1343z00_3481;
BgL_new1343z00_3481 = 
((BgL_pgpzd2markerzd2packetz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2markerzd2packetz00_bgl) ))); 
{ /* Llib/pgp_packets.scm 58 */
long BgL_arg1992z00_3482;
{ /* Llib/pgp_packets.scm 58 */
long BgL_res2469z00_3483;
BgL_res2469z00_3483 = 
BGL_CLASS_INDEX(BGl_PGPzd2Markerzd2Packetz00zz__openpgpzd2packetszd2); 
BgL_arg1992z00_3482 = BgL_res2469z00_3483; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1343z00_3481), BgL_arg1992z00_3482); } 
{ /* Llib/pgp_packets.scm 58 */
BgL_objectz00_bglt BgL_tmpz00_5230;
BgL_tmpz00_5230 = 
((BgL_objectz00_bglt)BgL_new1343z00_3481); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_5230, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1343z00_3481); 
BgL_new1344z00_3480 = BgL_new1343z00_3481; } 
return BgL_new1344z00_3480;} } 

}



/* &<@anonymous:1980> */
obj_t BGl_z62zc3z04anonymousza31980ze3ze5zz__openpgpzd2packetszd2(obj_t BgL_envz00_2788, obj_t BgL_new1178z00_2789)
{
{ /* Llib/pgp_packets.scm 56 */
{ 
BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt BgL_auxz00_5234;
((((BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt)BgL_new1178z00_2789)))->BgL_dataz00)=((obj_t)BGl_string2786z00zz__openpgpzd2packetszd2),BUNSPEC); 
BgL_auxz00_5234 = 
((BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt)BgL_new1178z00_2789); 
return 
((obj_t)BgL_auxz00_5234);} } 

}



/* &lambda1978 */
BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt BGl_z62lambda1978z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2790)
{
{ /* Llib/pgp_packets.scm 56 */
{ /* Llib/pgp_packets.scm 56 */
BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt BgL_new1177z00_3485;
BgL_new1177z00_3485 = 
((BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bgl) ))); 
{ /* Llib/pgp_packets.scm 56 */
long BgL_arg1979z00_3486;
{ /* Llib/pgp_packets.scm 56 */
long BgL_res2468z00_3487;
BgL_res2468z00_3487 = 
BGL_CLASS_INDEX(BGl_PGPzd2Symmetricallyzd2Encryptedzd2Packetzd2zz__openpgpzd2packetszd2); 
BgL_arg1979z00_3486 = BgL_res2468z00_3487; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1177z00_3485), BgL_arg1979z00_3486); } 
return BgL_new1177z00_3485;} } 

}



/* &lambda1976 */
BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt BGl_z62lambda1976z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2791, obj_t BgL_data1176z00_2792)
{
{ /* Llib/pgp_packets.scm 56 */
{ /* Llib/pgp_packets.scm 56 */
BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt BgL_new1342z00_3489;
{ /* Llib/pgp_packets.scm 56 */
BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt BgL_new1341z00_3490;
BgL_new1341z00_3490 = 
((BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bgl) ))); 
{ /* Llib/pgp_packets.scm 56 */
long BgL_arg1977z00_3491;
{ /* Llib/pgp_packets.scm 56 */
long BgL_res2467z00_3492;
BgL_res2467z00_3492 = 
BGL_CLASS_INDEX(BGl_PGPzd2Symmetricallyzd2Encryptedzd2Packetzd2zz__openpgpzd2packetszd2); 
BgL_arg1977z00_3491 = BgL_res2467z00_3492; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1341z00_3490), BgL_arg1977z00_3491); } 
BgL_new1342z00_3489 = BgL_new1341z00_3490; } 
((((BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt)COBJECT(BgL_new1342z00_3489))->BgL_dataz00)=((obj_t)
((obj_t)BgL_data1176z00_2792)),BUNSPEC); 
return BgL_new1342z00_3489;} } 

}



/* &lambda1985 */
obj_t BGl_z62lambda1985z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2793, obj_t BgL_oz00_2794, obj_t BgL_vz00_2795)
{
{ /* Llib/pgp_packets.scm 56 */
return 
((((BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt)BgL_oz00_2794)))->BgL_dataz00)=((obj_t)
((obj_t)BgL_vz00_2795)),BUNSPEC);} 

}



/* &lambda1984 */
obj_t BGl_z62lambda1984z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2796, obj_t BgL_oz00_2797)
{
{ /* Llib/pgp_packets.scm 56 */
return 
(((BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt)BgL_oz00_2797)))->BgL_dataz00);} 

}



/* &<@anonymous:1965> */
obj_t BGl_z62zc3z04anonymousza31965ze3ze5zz__openpgpzd2packetszd2(obj_t BgL_envz00_2798, obj_t BgL_new1174z00_2799)
{
{ /* Llib/pgp_packets.scm 54 */
{ 
BgL_pgpzd2compressedzd2packetz00_bglt BgL_auxz00_5254;
((((BgL_pgpzd2compressedzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2compressedzd2packetz00_bglt)BgL_new1174z00_2799)))->BgL_packetsz00)=((obj_t)BNIL),BUNSPEC); 
BgL_auxz00_5254 = 
((BgL_pgpzd2compressedzd2packetz00_bglt)BgL_new1174z00_2799); 
return 
((obj_t)BgL_auxz00_5254);} } 

}



/* &lambda1963 */
BgL_pgpzd2compressedzd2packetz00_bglt BGl_z62lambda1963z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2800)
{
{ /* Llib/pgp_packets.scm 54 */
{ /* Llib/pgp_packets.scm 54 */
BgL_pgpzd2compressedzd2packetz00_bglt BgL_new1173z00_3497;
BgL_new1173z00_3497 = 
((BgL_pgpzd2compressedzd2packetz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2compressedzd2packetz00_bgl) ))); 
{ /* Llib/pgp_packets.scm 54 */
long BgL_arg1964z00_3498;
{ /* Llib/pgp_packets.scm 54 */
long BgL_res2466z00_3499;
BgL_res2466z00_3499 = 
BGL_CLASS_INDEX(BGl_PGPzd2Compressedzd2Packetz00zz__openpgpzd2packetszd2); 
BgL_arg1964z00_3498 = BgL_res2466z00_3499; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1173z00_3497), BgL_arg1964z00_3498); } 
{ /* Llib/pgp_packets.scm 54 */
BgL_objectz00_bglt BgL_tmpz00_5263;
BgL_tmpz00_5263 = 
((BgL_objectz00_bglt)BgL_new1173z00_3497); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_5263, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1173z00_3497); 
return BgL_new1173z00_3497;} } 

}



/* &lambda1961 */
BgL_pgpzd2compressedzd2packetz00_bglt BGl_z62lambda1961z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2801, obj_t BgL_packets1172z00_2802)
{
{ /* Llib/pgp_packets.scm 54 */
{ /* Llib/pgp_packets.scm 54 */
BgL_pgpzd2compressedzd2packetz00_bglt BgL_new1340z00_3501;
{ /* Llib/pgp_packets.scm 54 */
BgL_pgpzd2compressedzd2packetz00_bglt BgL_new1339z00_3502;
BgL_new1339z00_3502 = 
((BgL_pgpzd2compressedzd2packetz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2compressedzd2packetz00_bgl) ))); 
{ /* Llib/pgp_packets.scm 54 */
long BgL_arg1962z00_3503;
{ /* Llib/pgp_packets.scm 54 */
long BgL_res2465z00_3504;
BgL_res2465z00_3504 = 
BGL_CLASS_INDEX(BGl_PGPzd2Compressedzd2Packetz00zz__openpgpzd2packetszd2); 
BgL_arg1962z00_3503 = BgL_res2465z00_3504; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1339z00_3502), BgL_arg1962z00_3503); } 
{ /* Llib/pgp_packets.scm 54 */
BgL_objectz00_bglt BgL_tmpz00_5271;
BgL_tmpz00_5271 = 
((BgL_objectz00_bglt)BgL_new1339z00_3502); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_5271, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1339z00_3502); 
BgL_new1340z00_3501 = BgL_new1339z00_3502; } 
((((BgL_pgpzd2compressedzd2packetz00_bglt)COBJECT(BgL_new1340z00_3501))->BgL_packetsz00)=((obj_t)
((obj_t)BgL_packets1172z00_2802)),BUNSPEC); 
return BgL_new1340z00_3501;} } 

}



/* &lambda1970 */
obj_t BGl_z62lambda1970z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2803, obj_t BgL_oz00_2804, obj_t BgL_vz00_2805)
{
{ /* Llib/pgp_packets.scm 54 */
return 
((((BgL_pgpzd2compressedzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2compressedzd2packetz00_bglt)BgL_oz00_2804)))->BgL_packetsz00)=((obj_t)
((obj_t)BgL_vz00_2805)),BUNSPEC);} 

}



/* &lambda1969 */
obj_t BGl_z62lambda1969z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2806, obj_t BgL_oz00_2807)
{
{ /* Llib/pgp_packets.scm 54 */
return 
(((BgL_pgpzd2compressedzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2compressedzd2packetz00_bglt)BgL_oz00_2807)))->BgL_packetsz00);} 

}



/* &lambda1947 */
BgL_pgpzd2secretzd2keyzd2packetzd2_bglt BGl_z62lambda1947z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2808, obj_t BgL_o1170z00_2809)
{
{ /* Llib/pgp_packets.scm 52 */
{ /* Llib/pgp_packets.scm 52 */
long BgL_arg1948z00_3509;
{ /* Llib/pgp_packets.scm 52 */
obj_t BgL_arg1949z00_3510;
{ /* Llib/pgp_packets.scm 52 */
obj_t BgL_arg1950z00_3511;
{ /* Llib/pgp_packets.scm 52 */
long BgL_arg1748z00_3512;
{ /* Llib/pgp_packets.scm 52 */
long BgL_arg1749z00_3513;
{ /* Llib/pgp_packets.scm 52 */
long BgL_res2462z00_3514;
BgL_res2462z00_3514 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)
((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)BgL_o1170z00_2809))); 
BgL_arg1749z00_3513 = BgL_res2462z00_3514; } 
BgL_arg1748z00_3512 = 
(BgL_arg1749z00_3513-OBJECT_TYPE); } 
BgL_arg1950z00_3511 = 
VECTOR_REF(BGl_za2classesza2z00zz__objectz00,BgL_arg1748z00_3512); } 
BgL_arg1949z00_3510 = 
BGl_classzd2superzd2zz__objectz00(BgL_arg1950z00_3511); } 
{ /* Llib/pgp_packets.scm 52 */
long BgL_res2464z00_3515;
{ /* Llib/pgp_packets.scm 52 */
obj_t BgL_tmpz00_5288;
BgL_tmpz00_5288 = 
((obj_t)BgL_arg1949z00_3510); 
BgL_res2464z00_3515 = 
BGL_CLASS_INDEX(BgL_tmpz00_5288); } 
BgL_arg1948z00_3509 = BgL_res2464z00_3515; } } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)
((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)BgL_o1170z00_2809)), BgL_arg1948z00_3509); } 
{ /* Llib/pgp_packets.scm 52 */
BgL_objectz00_bglt BgL_tmpz00_5294;
BgL_tmpz00_5294 = 
((BgL_objectz00_bglt)
((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)BgL_o1170z00_2809)); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_5294, BFALSE); } 
((BgL_objectz00_bglt)
((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)BgL_o1170z00_2809)); 
return 
((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)
((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)BgL_o1170z00_2809));} 

}



/* &<@anonymous:1946> */
obj_t BGl_z62zc3z04anonymousza31946ze3ze5zz__openpgpzd2packetszd2(obj_t BgL_envz00_2810, obj_t BgL_new1169z00_2811)
{
{ /* Llib/pgp_packets.scm 52 */
{ 
BgL_pgpzd2secretzd2keyzd2packetzd2_bglt BgL_auxz00_5302;
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)
((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)BgL_new1169z00_2811))))->BgL_idz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)
((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)BgL_new1169z00_2811))))->BgL_versionz00)=((long)((long)0)),BUNSPEC); 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)
((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)BgL_new1169z00_2811))))->BgL_subkeyzf3zf3)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)
((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)BgL_new1169z00_2811))))->BgL_algoz00)=((obj_t)
CNST_TABLE_REF(((long)101))),BUNSPEC); 
{ 
obj_t BgL_auxz00_5316;
{ /* Llib/pgp_packets.scm 52 */
obj_t BgL_res2461z00_3517;
{ /* Llib/pgp_packets.scm 52 */
BGL_LONGLONG_T BgL_arg1665z00_3518;
BgL_arg1665z00_3518 = 
bgl_current_nanoseconds(); 
BgL_res2461z00_3517 = 
bgl_nanoseconds_to_date(BgL_arg1665z00_3518); } 
BgL_auxz00_5316 = BgL_res2461z00_3517; } 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)
((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)BgL_new1169z00_2811))))->BgL_creationzd2datezd2)=((obj_t)BgL_auxz00_5316),BUNSPEC); } 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)
((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)BgL_new1169z00_2811))))->BgL_validzd2dayszd2)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)
((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)BgL_new1169z00_2811))))->BgL_keyz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)
((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)BgL_new1169z00_2811))))->BgL_passwordzd2protectedzd2secretzd2keyzd2dataz00)=((obj_t)BGl_string2786z00zz__openpgpzd2packetszd2),BUNSPEC); 
{ 
BgL_pgpzd2secretzd2keyzd2decodedzd2packetz00_bglt BgL_auxz00_5331;
{ 
obj_t BgL_auxz00_5332;
{ /* Llib/pgp_packets.scm 52 */
BgL_objectz00_bglt BgL_tmpz00_5333;
BgL_tmpz00_5333 = 
((BgL_objectz00_bglt)
((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)BgL_new1169z00_2811)); 
BgL_auxz00_5332 = 
BGL_OBJECT_WIDENING(BgL_tmpz00_5333); } 
BgL_auxz00_5331 = 
((BgL_pgpzd2secretzd2keyzd2decodedzd2packetz00_bglt)BgL_auxz00_5332); } 
((((BgL_pgpzd2secretzd2keyzd2decodedzd2packetz00_bglt)COBJECT(BgL_auxz00_5331))->BgL_secretzd2keyzd2)=((obj_t)BUNSPEC),BUNSPEC); } 
BgL_auxz00_5302 = 
((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)BgL_new1169z00_2811); 
return 
((obj_t)BgL_auxz00_5302);} } 

}



/* &lambda1944 */
BgL_pgpzd2secretzd2keyzd2packetzd2_bglt BGl_z62lambda1944z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2812, obj_t BgL_o1166z00_2813)
{
{ /* Llib/pgp_packets.scm 52 */
{ /* Llib/pgp_packets.scm 52 */
BgL_pgpzd2secretzd2keyzd2decodedzd2packetz00_bglt BgL_wide1168z00_3520;
BgL_wide1168z00_3520 = 
((BgL_pgpzd2secretzd2keyzd2decodedzd2packetz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2secretzd2keyzd2decodedzd2packetz00_bgl) ))); 
{ /* Llib/pgp_packets.scm 52 */
obj_t BgL_auxz00_5346;BgL_objectz00_bglt BgL_tmpz00_5342;
BgL_auxz00_5346 = 
((obj_t)BgL_wide1168z00_3520); 
BgL_tmpz00_5342 = 
((BgL_objectz00_bglt)
((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)
((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)BgL_o1166z00_2813))); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_5342, BgL_auxz00_5346); } 
((BgL_objectz00_bglt)
((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)
((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)BgL_o1166z00_2813))); 
{ /* Llib/pgp_packets.scm 52 */
long BgL_arg1945z00_3521;
{ /* Llib/pgp_packets.scm 52 */
long BgL_res2460z00_3522;
BgL_res2460z00_3522 = 
BGL_CLASS_INDEX(BGl_PGPzd2Secretzd2Keyzd2Decodedzd2Packetz00zz__openpgpzd2packetszd2); 
BgL_arg1945z00_3521 = BgL_res2460z00_3522; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)
((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)
((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)BgL_o1166z00_2813))), BgL_arg1945z00_3521); } 
return 
((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)
((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)
((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)BgL_o1166z00_2813)));} } 

}



/* &lambda1941 */
BgL_pgpzd2secretzd2keyzd2packetzd2_bglt BGl_z62lambda1941z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2814, obj_t BgL_id1157z00_2815, obj_t BgL_version1158z00_2816, obj_t BgL_subkeyzf31159zf3_2817, obj_t BgL_algo1160z00_2818, obj_t BgL_creationzd2date1161zd2_2819, obj_t BgL_validzd2days1162zd2_2820, obj_t BgL_key1163z00_2821, obj_t BgL_passwordzd2protectedzd2s1164z00_2822, obj_t BgL_secretzd2key1165zd2_2823)
{
{ /* Llib/pgp_packets.scm 52 */
{ /* Llib/pgp_packets.scm 52 */
long BgL_version1158z00_3523;bool_t BgL_subkeyzf31159zf3_3524;
BgL_version1158z00_3523 = 
(long)CINT(BgL_version1158z00_2816); 
BgL_subkeyzf31159zf3_3524 = 
CBOOL(BgL_subkeyzf31159zf3_2817); 
{ /* Llib/pgp_packets.scm 52 */
BgL_pgpzd2secretzd2keyzd2packetzd2_bglt BgL_new1337z00_3528;
{ /* Llib/pgp_packets.scm 52 */
BgL_pgpzd2secretzd2keyzd2packetzd2_bglt BgL_tmp1335z00_3529;BgL_pgpzd2secretzd2keyzd2decodedzd2packetz00_bglt BgL_wide1336z00_3530;
{ 
BgL_pgpzd2secretzd2keyzd2packetzd2_bglt BgL_auxz00_5362;
{ /* Llib/pgp_packets.scm 52 */
BgL_pgpzd2secretzd2keyzd2packetzd2_bglt BgL_new1334z00_3531;
BgL_new1334z00_3531 = 
((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2secretzd2keyzd2packetzd2_bgl) ))); 
{ /* Llib/pgp_packets.scm 52 */
long BgL_arg1943z00_3532;
{ /* Llib/pgp_packets.scm 52 */
long BgL_res2458z00_3533;
BgL_res2458z00_3533 = 
BGL_CLASS_INDEX(BGl_PGPzd2Secretzd2Keyzd2Packetzd2zz__openpgpzd2packetszd2); 
BgL_arg1943z00_3532 = BgL_res2458z00_3533; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1334z00_3531), BgL_arg1943z00_3532); } 
{ /* Llib/pgp_packets.scm 52 */
BgL_objectz00_bglt BgL_tmpz00_5367;
BgL_tmpz00_5367 = 
((BgL_objectz00_bglt)BgL_new1334z00_3531); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_5367, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1334z00_3531); 
BgL_auxz00_5362 = BgL_new1334z00_3531; } 
BgL_tmp1335z00_3529 = 
((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)BgL_auxz00_5362); } 
BgL_wide1336z00_3530 = 
((BgL_pgpzd2secretzd2keyzd2decodedzd2packetz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2secretzd2keyzd2decodedzd2packetz00_bgl) ))); 
{ /* Llib/pgp_packets.scm 52 */
obj_t BgL_auxz00_5375;BgL_objectz00_bglt BgL_tmpz00_5373;
BgL_auxz00_5375 = 
((obj_t)BgL_wide1336z00_3530); 
BgL_tmpz00_5373 = 
((BgL_objectz00_bglt)BgL_tmp1335z00_3529); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_5373, BgL_auxz00_5375); } 
((BgL_objectz00_bglt)BgL_tmp1335z00_3529); 
{ /* Llib/pgp_packets.scm 52 */
long BgL_arg1942z00_3534;
{ /* Llib/pgp_packets.scm 52 */
long BgL_res2459z00_3535;
BgL_res2459z00_3535 = 
BGL_CLASS_INDEX(BGl_PGPzd2Secretzd2Keyzd2Decodedzd2Packetz00zz__openpgpzd2packetszd2); 
BgL_arg1942z00_3534 = BgL_res2459z00_3535; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_tmp1335z00_3529), BgL_arg1942z00_3534); } 
BgL_new1337z00_3528 = 
((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)BgL_tmp1335z00_3529); } 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_new1337z00_3528)))->BgL_idz00)=((obj_t)BgL_id1157z00_2815),BUNSPEC); 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_new1337z00_3528)))->BgL_versionz00)=((long)BgL_version1158z00_3523),BUNSPEC); 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_new1337z00_3528)))->BgL_subkeyzf3zf3)=((bool_t)BgL_subkeyzf31159zf3_3524),BUNSPEC); 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_new1337z00_3528)))->BgL_algoz00)=((obj_t)
((obj_t)BgL_algo1160z00_2818)),BUNSPEC); 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_new1337z00_3528)))->BgL_creationzd2datezd2)=((obj_t)
((obj_t)BgL_creationzd2date1161zd2_2819)),BUNSPEC); 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_new1337z00_3528)))->BgL_validzd2dayszd2)=((obj_t)BgL_validzd2days1162zd2_2820),BUNSPEC); 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_new1337z00_3528)))->BgL_keyz00)=((obj_t)BgL_key1163z00_2821),BUNSPEC); 
((((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)BgL_new1337z00_3528)))->BgL_passwordzd2protectedzd2secretzd2keyzd2dataz00)=((obj_t)
((obj_t)BgL_passwordzd2protectedzd2s1164z00_2822)),BUNSPEC); 
{ 
BgL_pgpzd2secretzd2keyzd2decodedzd2packetz00_bglt BgL_auxz00_5402;
{ 
obj_t BgL_auxz00_5403;
{ /* Llib/pgp_packets.scm 52 */
BgL_objectz00_bglt BgL_tmpz00_5404;
BgL_tmpz00_5404 = 
((BgL_objectz00_bglt)BgL_new1337z00_3528); 
BgL_auxz00_5403 = 
BGL_OBJECT_WIDENING(BgL_tmpz00_5404); } 
BgL_auxz00_5402 = 
((BgL_pgpzd2secretzd2keyzd2decodedzd2packetz00_bglt)BgL_auxz00_5403); } 
((((BgL_pgpzd2secretzd2keyzd2decodedzd2packetz00_bglt)COBJECT(BgL_auxz00_5402))->BgL_secretzd2keyzd2)=((obj_t)BgL_secretzd2key1165zd2_2823),BUNSPEC); } 
return BgL_new1337z00_3528;} } } 

}



/* &lambda1955 */
obj_t BGl_z62lambda1955z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2824, obj_t BgL_oz00_2825, obj_t BgL_vz00_2826)
{
{ /* Llib/pgp_packets.scm 52 */
{ 
BgL_pgpzd2secretzd2keyzd2decodedzd2packetz00_bglt BgL_auxz00_5409;
{ 
obj_t BgL_auxz00_5410;
{ /* Llib/pgp_packets.scm 52 */
BgL_objectz00_bglt BgL_tmpz00_5411;
BgL_tmpz00_5411 = 
((BgL_objectz00_bglt)
((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)BgL_oz00_2825)); 
BgL_auxz00_5410 = 
BGL_OBJECT_WIDENING(BgL_tmpz00_5411); } 
BgL_auxz00_5409 = 
((BgL_pgpzd2secretzd2keyzd2decodedzd2packetz00_bglt)BgL_auxz00_5410); } 
return 
((((BgL_pgpzd2secretzd2keyzd2decodedzd2packetz00_bglt)COBJECT(BgL_auxz00_5409))->BgL_secretzd2keyzd2)=((obj_t)BgL_vz00_2826),BUNSPEC);} } 

}



/* &lambda1954 */
obj_t BGl_z62lambda1954z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2827, obj_t BgL_oz00_2828)
{
{ /* Llib/pgp_packets.scm 52 */
{ 
BgL_pgpzd2secretzd2keyzd2decodedzd2packetz00_bglt BgL_auxz00_5417;
{ 
obj_t BgL_auxz00_5418;
{ /* Llib/pgp_packets.scm 52 */
BgL_objectz00_bglt BgL_tmpz00_5419;
BgL_tmpz00_5419 = 
((BgL_objectz00_bglt)
((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)BgL_oz00_2828)); 
BgL_auxz00_5418 = 
BGL_OBJECT_WIDENING(BgL_tmpz00_5419); } 
BgL_auxz00_5417 = 
((BgL_pgpzd2secretzd2keyzd2decodedzd2packetz00_bglt)BgL_auxz00_5418); } 
return 
(((BgL_pgpzd2secretzd2keyzd2decodedzd2packetz00_bglt)COBJECT(BgL_auxz00_5417))->BgL_secretzd2keyzd2);} } 

}



/* &<@anonymous:1929> */
obj_t BGl_z62zc3z04anonymousza31929ze3ze5zz__openpgpzd2packetszd2(obj_t BgL_envz00_2829, obj_t BgL_new1155z00_2830)
{
{ /* Llib/pgp_packets.scm 50 */
{ 
BgL_pgpzd2secretzd2keyzd2packetzd2_bglt BgL_auxz00_5425;
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)
((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)BgL_new1155z00_2830))))->BgL_idz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)
((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)BgL_new1155z00_2830))))->BgL_versionz00)=((long)((long)0)),BUNSPEC); 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)
((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)BgL_new1155z00_2830))))->BgL_subkeyzf3zf3)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)
((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)BgL_new1155z00_2830))))->BgL_algoz00)=((obj_t)
CNST_TABLE_REF(((long)101))),BUNSPEC); 
{ 
obj_t BgL_auxz00_5439;
{ /* Llib/pgp_packets.scm 50 */
obj_t BgL_res2457z00_3539;
{ /* Llib/pgp_packets.scm 50 */
BGL_LONGLONG_T BgL_arg1665z00_3540;
BgL_arg1665z00_3540 = 
bgl_current_nanoseconds(); 
BgL_res2457z00_3539 = 
bgl_nanoseconds_to_date(BgL_arg1665z00_3540); } 
BgL_auxz00_5439 = BgL_res2457z00_3539; } 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)
((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)BgL_new1155z00_2830))))->BgL_creationzd2datezd2)=((obj_t)BgL_auxz00_5439),BUNSPEC); } 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)
((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)BgL_new1155z00_2830))))->BgL_validzd2dayszd2)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)
((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)BgL_new1155z00_2830))))->BgL_keyz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)BgL_new1155z00_2830)))->BgL_passwordzd2protectedzd2secretzd2keyzd2dataz00)=((obj_t)BGl_string2786z00zz__openpgpzd2packetszd2),BUNSPEC); 
BgL_auxz00_5425 = 
((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)BgL_new1155z00_2830); 
return 
((obj_t)BgL_auxz00_5425);} } 

}



/* &lambda1927 */
BgL_pgpzd2secretzd2keyzd2packetzd2_bglt BGl_z62lambda1927z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2831)
{
{ /* Llib/pgp_packets.scm 50 */
{ /* Llib/pgp_packets.scm 50 */
BgL_pgpzd2secretzd2keyzd2packetzd2_bglt BgL_new1154z00_3541;
BgL_new1154z00_3541 = 
((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2secretzd2keyzd2packetzd2_bgl) ))); 
{ /* Llib/pgp_packets.scm 50 */
long BgL_arg1928z00_3542;
{ /* Llib/pgp_packets.scm 50 */
long BgL_res2456z00_3543;
BgL_res2456z00_3543 = 
BGL_CLASS_INDEX(BGl_PGPzd2Secretzd2Keyzd2Packetzd2zz__openpgpzd2packetszd2); 
BgL_arg1928z00_3542 = BgL_res2456z00_3543; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1154z00_3541), BgL_arg1928z00_3542); } 
{ /* Llib/pgp_packets.scm 50 */
BgL_objectz00_bglt BgL_tmpz00_5459;
BgL_tmpz00_5459 = 
((BgL_objectz00_bglt)BgL_new1154z00_3541); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_5459, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1154z00_3541); 
return BgL_new1154z00_3541;} } 

}



/* &lambda1925 */
BgL_pgpzd2secretzd2keyzd2packetzd2_bglt BGl_z62lambda1925z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2832, obj_t BgL_id1146z00_2833, obj_t BgL_version1147z00_2834, obj_t BgL_subkeyzf31148zf3_2835, obj_t BgL_algo1149z00_2836, obj_t BgL_creationzd2date1150zd2_2837, obj_t BgL_validzd2days1151zd2_2838, obj_t BgL_key1152z00_2839, obj_t BgL_passwordzd2protectedzd2s1153z00_2840)
{
{ /* Llib/pgp_packets.scm 50 */
{ /* Llib/pgp_packets.scm 50 */
long BgL_version1147z00_3544;bool_t BgL_subkeyzf31148zf3_3545;
BgL_version1147z00_3544 = 
(long)CINT(BgL_version1147z00_2834); 
BgL_subkeyzf31148zf3_3545 = 
CBOOL(BgL_subkeyzf31148zf3_2835); 
{ /* Llib/pgp_packets.scm 50 */
BgL_pgpzd2secretzd2keyzd2packetzd2_bglt BgL_new1333z00_3549;
{ /* Llib/pgp_packets.scm 50 */
BgL_pgpzd2secretzd2keyzd2packetzd2_bglt BgL_new1332z00_3550;
BgL_new1332z00_3550 = 
((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2secretzd2keyzd2packetzd2_bgl) ))); 
{ /* Llib/pgp_packets.scm 50 */
long BgL_arg1926z00_3551;
{ /* Llib/pgp_packets.scm 50 */
long BgL_res2455z00_3552;
BgL_res2455z00_3552 = 
BGL_CLASS_INDEX(BGl_PGPzd2Secretzd2Keyzd2Packetzd2zz__openpgpzd2packetszd2); 
BgL_arg1926z00_3551 = BgL_res2455z00_3552; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1332z00_3550), BgL_arg1926z00_3551); } 
{ /* Llib/pgp_packets.scm 50 */
BgL_objectz00_bglt BgL_tmpz00_5469;
BgL_tmpz00_5469 = 
((BgL_objectz00_bglt)BgL_new1332z00_3550); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_5469, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1332z00_3550); 
BgL_new1333z00_3549 = BgL_new1332z00_3550; } 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_new1333z00_3549)))->BgL_idz00)=((obj_t)BgL_id1146z00_2833),BUNSPEC); 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_new1333z00_3549)))->BgL_versionz00)=((long)BgL_version1147z00_3544),BUNSPEC); 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_new1333z00_3549)))->BgL_subkeyzf3zf3)=((bool_t)BgL_subkeyzf31148zf3_3545),BUNSPEC); 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_new1333z00_3549)))->BgL_algoz00)=((obj_t)
((obj_t)BgL_algo1149z00_2836)),BUNSPEC); 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_new1333z00_3549)))->BgL_creationzd2datezd2)=((obj_t)
((obj_t)BgL_creationzd2date1150zd2_2837)),BUNSPEC); 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_new1333z00_3549)))->BgL_validzd2dayszd2)=((obj_t)BgL_validzd2days1151zd2_2838),BUNSPEC); 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_new1333z00_3549)))->BgL_keyz00)=((obj_t)BgL_key1152z00_2839),BUNSPEC); 
((((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)COBJECT(BgL_new1333z00_3549))->BgL_passwordzd2protectedzd2secretzd2keyzd2dataz00)=((obj_t)
((obj_t)BgL_passwordzd2protectedzd2s1153z00_2840)),BUNSPEC); 
return BgL_new1333z00_3549;} } } 

}



/* &lambda1934 */
obj_t BGl_z62lambda1934z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2841, obj_t BgL_oz00_2842, obj_t BgL_vz00_2843)
{
{ /* Llib/pgp_packets.scm 50 */
return 
((((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)BgL_oz00_2842)))->BgL_passwordzd2protectedzd2secretzd2keyzd2dataz00)=((obj_t)
((obj_t)BgL_vz00_2843)),BUNSPEC);} 

}



/* &lambda1933 */
obj_t BGl_z62lambda1933z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2844, obj_t BgL_oz00_2845)
{
{ /* Llib/pgp_packets.scm 50 */
return 
(((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2secretzd2keyzd2packetzd2_bglt)BgL_oz00_2845)))->BgL_passwordzd2protectedzd2secretzd2keyzd2dataz00);} 

}



/* &<@anonymous:1919> */
obj_t BGl_z62zc3z04anonymousza31919ze3ze5zz__openpgpzd2packetszd2(obj_t BgL_envz00_2846, obj_t BgL_new1144z00_2847)
{
{ /* Llib/pgp_packets.scm 49 */
{ 
BgL_pgpzd2publiczd2keyzd2packetzd2_bglt BgL_auxz00_5496;
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)
((BgL_pgpzd2publiczd2keyzd2packetzd2_bglt)BgL_new1144z00_2847))))->BgL_idz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)
((BgL_pgpzd2publiczd2keyzd2packetzd2_bglt)BgL_new1144z00_2847))))->BgL_versionz00)=((long)((long)0)),BUNSPEC); 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)
((BgL_pgpzd2publiczd2keyzd2packetzd2_bglt)BgL_new1144z00_2847))))->BgL_subkeyzf3zf3)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)
((BgL_pgpzd2publiczd2keyzd2packetzd2_bglt)BgL_new1144z00_2847))))->BgL_algoz00)=((obj_t)
CNST_TABLE_REF(((long)101))),BUNSPEC); 
{ 
obj_t BgL_auxz00_5510;
{ /* Llib/pgp_packets.scm 49 */
obj_t BgL_res2454z00_3557;
{ /* Llib/pgp_packets.scm 49 */
BGL_LONGLONG_T BgL_arg1665z00_3558;
BgL_arg1665z00_3558 = 
bgl_current_nanoseconds(); 
BgL_res2454z00_3557 = 
bgl_nanoseconds_to_date(BgL_arg1665z00_3558); } 
BgL_auxz00_5510 = BgL_res2454z00_3557; } 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)
((BgL_pgpzd2publiczd2keyzd2packetzd2_bglt)BgL_new1144z00_2847))))->BgL_creationzd2datezd2)=((obj_t)BgL_auxz00_5510),BUNSPEC); } 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)
((BgL_pgpzd2publiczd2keyzd2packetzd2_bglt)BgL_new1144z00_2847))))->BgL_validzd2dayszd2)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)
((BgL_pgpzd2publiczd2keyzd2packetzd2_bglt)BgL_new1144z00_2847))))->BgL_keyz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_5496 = 
((BgL_pgpzd2publiczd2keyzd2packetzd2_bglt)BgL_new1144z00_2847); 
return 
((obj_t)BgL_auxz00_5496);} } 

}



/* &lambda1917 */
BgL_pgpzd2publiczd2keyzd2packetzd2_bglt BGl_z62lambda1917z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2848)
{
{ /* Llib/pgp_packets.scm 49 */
{ /* Llib/pgp_packets.scm 49 */
BgL_pgpzd2publiczd2keyzd2packetzd2_bglt BgL_new1143z00_3559;
BgL_new1143z00_3559 = 
((BgL_pgpzd2publiczd2keyzd2packetzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2publiczd2keyzd2packetzd2_bgl) ))); 
{ /* Llib/pgp_packets.scm 49 */
long BgL_arg1918z00_3560;
{ /* Llib/pgp_packets.scm 49 */
long BgL_res2453z00_3561;
BgL_res2453z00_3561 = 
BGL_CLASS_INDEX(BGl_PGPzd2Publiczd2Keyzd2Packetzd2zz__openpgpzd2packetszd2); 
BgL_arg1918z00_3560 = BgL_res2453z00_3561; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1143z00_3559), BgL_arg1918z00_3560); } 
{ /* Llib/pgp_packets.scm 49 */
BgL_objectz00_bglt BgL_tmpz00_5528;
BgL_tmpz00_5528 = 
((BgL_objectz00_bglt)BgL_new1143z00_3559); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_5528, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1143z00_3559); 
return BgL_new1143z00_3559;} } 

}



/* &lambda1915 */
BgL_pgpzd2publiczd2keyzd2packetzd2_bglt BGl_z62lambda1915z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2849, obj_t BgL_id1136z00_2850, obj_t BgL_version1137z00_2851, obj_t BgL_subkeyzf31138zf3_2852, obj_t BgL_algo1139z00_2853, obj_t BgL_creationzd2date1140zd2_2854, obj_t BgL_validzd2days1141zd2_2855, obj_t BgL_key1142z00_2856)
{
{ /* Llib/pgp_packets.scm 49 */
{ /* Llib/pgp_packets.scm 49 */
long BgL_version1137z00_3562;bool_t BgL_subkeyzf31138zf3_3563;
BgL_version1137z00_3562 = 
(long)CINT(BgL_version1137z00_2851); 
BgL_subkeyzf31138zf3_3563 = 
CBOOL(BgL_subkeyzf31138zf3_2852); 
{ /* Llib/pgp_packets.scm 49 */
BgL_pgpzd2publiczd2keyzd2packetzd2_bglt BgL_new1331z00_3566;
{ /* Llib/pgp_packets.scm 49 */
BgL_pgpzd2publiczd2keyzd2packetzd2_bglt BgL_new1330z00_3567;
BgL_new1330z00_3567 = 
((BgL_pgpzd2publiczd2keyzd2packetzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2publiczd2keyzd2packetzd2_bgl) ))); 
{ /* Llib/pgp_packets.scm 49 */
long BgL_arg1916z00_3568;
{ /* Llib/pgp_packets.scm 49 */
long BgL_res2452z00_3569;
BgL_res2452z00_3569 = 
BGL_CLASS_INDEX(BGl_PGPzd2Publiczd2Keyzd2Packetzd2zz__openpgpzd2packetszd2); 
BgL_arg1916z00_3568 = BgL_res2452z00_3569; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1330z00_3567), BgL_arg1916z00_3568); } 
{ /* Llib/pgp_packets.scm 49 */
BgL_objectz00_bglt BgL_tmpz00_5538;
BgL_tmpz00_5538 = 
((BgL_objectz00_bglt)BgL_new1330z00_3567); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_5538, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1330z00_3567); 
BgL_new1331z00_3566 = BgL_new1330z00_3567; } 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_new1331z00_3566)))->BgL_idz00)=((obj_t)BgL_id1136z00_2850),BUNSPEC); 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_new1331z00_3566)))->BgL_versionz00)=((long)BgL_version1137z00_3562),BUNSPEC); 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_new1331z00_3566)))->BgL_subkeyzf3zf3)=((bool_t)BgL_subkeyzf31138zf3_3563),BUNSPEC); 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_new1331z00_3566)))->BgL_algoz00)=((obj_t)
((obj_t)BgL_algo1139z00_2853)),BUNSPEC); 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_new1331z00_3566)))->BgL_creationzd2datezd2)=((obj_t)
((obj_t)BgL_creationzd2date1140zd2_2854)),BUNSPEC); 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_new1331z00_3566)))->BgL_validzd2dayszd2)=((obj_t)BgL_validzd2days1141zd2_2855),BUNSPEC); 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_new1331z00_3566)))->BgL_keyz00)=((obj_t)BgL_key1142z00_2856),BUNSPEC); 
return BgL_new1331z00_3566;} } } 

}



/* &<@anonymous:1870> */
obj_t BGl_z62zc3z04anonymousza31870ze3ze5zz__openpgpzd2packetszd2(obj_t BgL_envz00_2857, obj_t BgL_new1134z00_2858)
{
{ /* Llib/pgp_packets.scm 41 */
{ 
BgL_pgpzd2keyzd2packetz00_bglt BgL_auxz00_5558;
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_new1134z00_2858)))->BgL_idz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_new1134z00_2858)))->BgL_versionz00)=((long)((long)0)),BUNSPEC); 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_new1134z00_2858)))->BgL_subkeyzf3zf3)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_new1134z00_2858)))->BgL_algoz00)=((obj_t)
CNST_TABLE_REF(((long)101))),BUNSPEC); 
{ 
obj_t BgL_auxz00_5568;
{ /* Llib/pgp_packets.scm 41 */
obj_t BgL_res2451z00_3571;
{ /* Llib/pgp_packets.scm 41 */
BGL_LONGLONG_T BgL_arg1665z00_3572;
BgL_arg1665z00_3572 = 
bgl_current_nanoseconds(); 
BgL_res2451z00_3571 = 
bgl_nanoseconds_to_date(BgL_arg1665z00_3572); } 
BgL_auxz00_5568 = BgL_res2451z00_3571; } 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_new1134z00_2858)))->BgL_creationzd2datezd2)=((obj_t)BgL_auxz00_5568),BUNSPEC); } 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_new1134z00_2858)))->BgL_validzd2dayszd2)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_new1134z00_2858)))->BgL_keyz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_5558 = 
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_new1134z00_2858); 
return 
((obj_t)BgL_auxz00_5558);} } 

}



/* &lambda1868 */
BgL_pgpzd2keyzd2packetz00_bglt BGl_z62lambda1868z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2859)
{
{ /* Llib/pgp_packets.scm 41 */
{ /* Llib/pgp_packets.scm 41 */
BgL_pgpzd2keyzd2packetz00_bglt BgL_new1133z00_3573;
BgL_new1133z00_3573 = 
((BgL_pgpzd2keyzd2packetz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2keyzd2packetz00_bgl) ))); 
{ /* Llib/pgp_packets.scm 41 */
long BgL_arg1869z00_3574;
{ /* Llib/pgp_packets.scm 41 */
long BgL_res2450z00_3575;
BgL_res2450z00_3575 = 
BGL_CLASS_INDEX(BGl_PGPzd2Keyzd2Packetz00zz__openpgpzd2packetszd2); 
BgL_arg1869z00_3574 = BgL_res2450z00_3575; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1133z00_3573), BgL_arg1869z00_3574); } 
return BgL_new1133z00_3573;} } 

}



/* &lambda1866 */
BgL_pgpzd2keyzd2packetz00_bglt BGl_z62lambda1866z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2860, obj_t BgL_id1126z00_2861, obj_t BgL_version1127z00_2862, obj_t BgL_subkeyzf31128zf3_2863, obj_t BgL_algo1129z00_2864, obj_t BgL_creationzd2date1130zd2_2865, obj_t BgL_validzd2days1131zd2_2866, obj_t BgL_key1132z00_2867)
{
{ /* Llib/pgp_packets.scm 41 */
{ /* Llib/pgp_packets.scm 41 */
long BgL_version1127z00_3576;bool_t BgL_subkeyzf31128zf3_3577;
BgL_version1127z00_3576 = 
(long)CINT(BgL_version1127z00_2862); 
BgL_subkeyzf31128zf3_3577 = 
CBOOL(BgL_subkeyzf31128zf3_2863); 
{ /* Llib/pgp_packets.scm 41 */
BgL_pgpzd2keyzd2packetz00_bglt BgL_new1329z00_3580;
{ /* Llib/pgp_packets.scm 41 */
BgL_pgpzd2keyzd2packetz00_bglt BgL_new1328z00_3581;
BgL_new1328z00_3581 = 
((BgL_pgpzd2keyzd2packetz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2keyzd2packetz00_bgl) ))); 
{ /* Llib/pgp_packets.scm 41 */
long BgL_arg1867z00_3582;
{ /* Llib/pgp_packets.scm 41 */
long BgL_res2449z00_3583;
BgL_res2449z00_3583 = 
BGL_CLASS_INDEX(BGl_PGPzd2Keyzd2Packetz00zz__openpgpzd2packetszd2); 
BgL_arg1867z00_3582 = BgL_res2449z00_3583; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1328z00_3581), BgL_arg1867z00_3582); } 
BgL_new1329z00_3580 = BgL_new1328z00_3581; } 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(BgL_new1329z00_3580))->BgL_idz00)=((obj_t)BgL_id1126z00_2861),BUNSPEC); 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(BgL_new1329z00_3580))->BgL_versionz00)=((long)BgL_version1127z00_3576),BUNSPEC); 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(BgL_new1329z00_3580))->BgL_subkeyzf3zf3)=((bool_t)BgL_subkeyzf31128zf3_3577),BUNSPEC); 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(BgL_new1329z00_3580))->BgL_algoz00)=((obj_t)
((obj_t)BgL_algo1129z00_2864)),BUNSPEC); 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(BgL_new1329z00_3580))->BgL_creationzd2datezd2)=((obj_t)
((obj_t)BgL_creationzd2date1130zd2_2865)),BUNSPEC); 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(BgL_new1329z00_3580))->BgL_validzd2dayszd2)=((obj_t)BgL_validzd2days1131zd2_2866),BUNSPEC); 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(BgL_new1329z00_3580))->BgL_keyz00)=((obj_t)BgL_key1132z00_2867),BUNSPEC); 
return BgL_new1329z00_3580;} } } 

}



/* &lambda1909 */
obj_t BGl_z62lambda1909z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2868, obj_t BgL_oz00_2869, obj_t BgL_vz00_2870)
{
{ /* Llib/pgp_packets.scm 41 */
return 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_oz00_2869)))->BgL_keyz00)=((obj_t)BgL_vz00_2870),BUNSPEC);} 

}



/* &lambda1908 */
obj_t BGl_z62lambda1908z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2871, obj_t BgL_oz00_2872)
{
{ /* Llib/pgp_packets.scm 41 */
return 
(((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_oz00_2872)))->BgL_keyz00);} 

}



/* &lambda1904 */
obj_t BGl_z62lambda1904z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2873, obj_t BgL_oz00_2874, obj_t BgL_vz00_2875)
{
{ /* Llib/pgp_packets.scm 41 */
return 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_oz00_2874)))->BgL_validzd2dayszd2)=((obj_t)BgL_vz00_2875),BUNSPEC);} 

}



/* &lambda1903 */
obj_t BGl_z62lambda1903z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2876, obj_t BgL_oz00_2877)
{
{ /* Llib/pgp_packets.scm 41 */
return 
(((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_oz00_2877)))->BgL_validzd2dayszd2);} 

}



/* &lambda1899 */
obj_t BGl_z62lambda1899z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2878, obj_t BgL_oz00_2879, obj_t BgL_vz00_2880)
{
{ /* Llib/pgp_packets.scm 41 */
return 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_oz00_2879)))->BgL_creationzd2datezd2)=((obj_t)
((obj_t)BgL_vz00_2880)),BUNSPEC);} 

}



/* &lambda1898 */
obj_t BGl_z62lambda1898z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2881, obj_t BgL_oz00_2882)
{
{ /* Llib/pgp_packets.scm 41 */
return 
(((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_oz00_2882)))->BgL_creationzd2datezd2);} 

}



/* &lambda1894 */
obj_t BGl_z62lambda1894z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2883, obj_t BgL_oz00_2884, obj_t BgL_vz00_2885)
{
{ /* Llib/pgp_packets.scm 41 */
return 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_oz00_2884)))->BgL_algoz00)=((obj_t)
((obj_t)BgL_vz00_2885)),BUNSPEC);} 

}



/* &lambda1893 */
obj_t BGl_z62lambda1893z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2886, obj_t BgL_oz00_2887)
{
{ /* Llib/pgp_packets.scm 41 */
return 
(((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_oz00_2887)))->BgL_algoz00);} 

}



/* &<@anonymous:1889> */
obj_t BGl_z62zc3z04anonymousza31889ze3ze5zz__openpgpzd2packetszd2(obj_t BgL_envz00_2888)
{
{ /* Llib/pgp_packets.scm 41 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda1888 */
obj_t BGl_z62lambda1888z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2889, obj_t BgL_oz00_2890, obj_t BgL_vz00_2891)
{
{ /* Llib/pgp_packets.scm 41 */
{ /* Llib/pgp_packets.scm 41 */
bool_t BgL_vz00_3595;
BgL_vz00_3595 = 
CBOOL(BgL_vz00_2891); 
return 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_oz00_2890)))->BgL_subkeyzf3zf3)=((bool_t)BgL_vz00_3595),BUNSPEC);} } 

}



/* &lambda1887 */
obj_t BGl_z62lambda1887z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2892, obj_t BgL_oz00_2893)
{
{ /* Llib/pgp_packets.scm 41 */
return 
BBOOL(
(((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_oz00_2893)))->BgL_subkeyzf3zf3));} 

}



/* &lambda1882 */
obj_t BGl_z62lambda1882z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2894, obj_t BgL_oz00_2895, obj_t BgL_vz00_2896)
{
{ /* Llib/pgp_packets.scm 41 */
{ /* Llib/pgp_packets.scm 41 */
long BgL_vz00_3598;
BgL_vz00_3598 = 
(long)CINT(BgL_vz00_2896); 
return 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_oz00_2895)))->BgL_versionz00)=((long)BgL_vz00_3598),BUNSPEC);} } 

}



/* &lambda1881 */
obj_t BGl_z62lambda1881z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2897, obj_t BgL_oz00_2898)
{
{ /* Llib/pgp_packets.scm 41 */
return 
BINT(
(((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_oz00_2898)))->BgL_versionz00));} 

}



/* &<@anonymous:1877> */
obj_t BGl_z62zc3z04anonymousza31877ze3ze5zz__openpgpzd2packetszd2(obj_t BgL_envz00_2899)
{
{ /* Llib/pgp_packets.scm 41 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda1876 */
obj_t BGl_z62lambda1876z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2900, obj_t BgL_oz00_2901, obj_t BgL_vz00_2902)
{
{ /* Llib/pgp_packets.scm 41 */
return 
((((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_oz00_2901)))->BgL_idz00)=((obj_t)BgL_vz00_2902),BUNSPEC);} 

}



/* &lambda1875 */
obj_t BGl_z62lambda1875z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2903, obj_t BgL_oz00_2904)
{
{ /* Llib/pgp_packets.scm 41 */
return 
(((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_oz00_2904)))->BgL_idz00);} 

}



/* &<@anonymous:1855> */
obj_t BGl_z62zc3z04anonymousza31855ze3ze5zz__openpgpzd2packetszd2(obj_t BgL_envz00_2905, obj_t BgL_new1124z00_2906)
{
{ /* Llib/pgp_packets.scm 39 */
{ 
BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bglt BgL_auxz00_5634;
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bglt)BgL_new1124z00_2906))))->BgL_versionz00)=((long)((long)0)),BUNSPEC); 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bglt)BgL_new1124z00_2906))))->BgL_signaturezd2typezd2)=((obj_t)
CNST_TABLE_REF(((long)101))),BUNSPEC); 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bglt)BgL_new1124z00_2906))))->BgL_issuerz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bglt)BgL_new1124z00_2906))))->BgL_publiczd2keyzd2algoz00)=((obj_t)
CNST_TABLE_REF(((long)101))),BUNSPEC); 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bglt)BgL_new1124z00_2906))))->BgL_hashzd2algozd2)=((obj_t)
CNST_TABLE_REF(((long)101))),BUNSPEC); 
((((BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bglt)BgL_new1124z00_2906)))->BgL_containszd2nestedzd2sigzf3zf3)=((bool_t)((bool_t)0)),BUNSPEC); 
BgL_auxz00_5634 = 
((BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bglt)BgL_new1124z00_2906); 
return 
((obj_t)BgL_auxz00_5634);} } 

}



/* &lambda1853 */
BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bglt BGl_z62lambda1853z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2907)
{
{ /* Llib/pgp_packets.scm 39 */
{ /* Llib/pgp_packets.scm 39 */
BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bglt BgL_new1123z00_3603;
BgL_new1123z00_3603 = 
((BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bgl) ))); 
{ /* Llib/pgp_packets.scm 39 */
long BgL_arg1854z00_3604;
{ /* Llib/pgp_packets.scm 39 */
long BgL_res2448z00_3605;
BgL_res2448z00_3605 = 
BGL_CLASS_INDEX(BGl_PGPzd2Onezd2Passzd2Signaturezd2Packetz00zz__openpgpzd2packetszd2); 
BgL_arg1854z00_3604 = BgL_res2448z00_3605; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1123z00_3603), BgL_arg1854z00_3604); } 
{ /* Llib/pgp_packets.scm 39 */
BgL_objectz00_bglt BgL_tmpz00_5661;
BgL_tmpz00_5661 = 
((BgL_objectz00_bglt)BgL_new1123z00_3603); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_5661, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1123z00_3603); 
return BgL_new1123z00_3603;} } 

}



/* &lambda1851 */
BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bglt BGl_z62lambda1851z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2908, obj_t BgL_version1117z00_2909, obj_t BgL_signaturezd2type1118zd2_2910, obj_t BgL_issuer1119z00_2911, obj_t BgL_publiczd2keyzd2algo1120z00_2912, obj_t BgL_hashzd2algo1121zd2_2913, obj_t BgL_containszd2nestedzd2sigzf31122zf3_2914)
{
{ /* Llib/pgp_packets.scm 39 */
{ /* Llib/pgp_packets.scm 39 */
long BgL_version1117z00_3606;bool_t BgL_containszd2nestedzd2sigzf31122zf3_3610;
BgL_version1117z00_3606 = 
(long)CINT(BgL_version1117z00_2909); 
BgL_containszd2nestedzd2sigzf31122zf3_3610 = 
CBOOL(BgL_containszd2nestedzd2sigzf31122zf3_2914); 
{ /* Llib/pgp_packets.scm 39 */
BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bglt BgL_new1327z00_3611;
{ /* Llib/pgp_packets.scm 39 */
BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bglt BgL_new1326z00_3612;
BgL_new1326z00_3612 = 
((BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bgl) ))); 
{ /* Llib/pgp_packets.scm 39 */
long BgL_arg1852z00_3613;
{ /* Llib/pgp_packets.scm 39 */
long BgL_res2447z00_3614;
BgL_res2447z00_3614 = 
BGL_CLASS_INDEX(BGl_PGPzd2Onezd2Passzd2Signaturezd2Packetz00zz__openpgpzd2packetszd2); 
BgL_arg1852z00_3613 = BgL_res2447z00_3614; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1326z00_3612), BgL_arg1852z00_3613); } 
{ /* Llib/pgp_packets.scm 39 */
BgL_objectz00_bglt BgL_tmpz00_5671;
BgL_tmpz00_5671 = 
((BgL_objectz00_bglt)BgL_new1326z00_3612); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_5671, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1326z00_3612); 
BgL_new1327z00_3611 = BgL_new1326z00_3612; } 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)BgL_new1327z00_3611)))->BgL_versionz00)=((long)BgL_version1117z00_3606),BUNSPEC); 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)BgL_new1327z00_3611)))->BgL_signaturezd2typezd2)=((obj_t)
((obj_t)BgL_signaturezd2type1118zd2_2910)),BUNSPEC); 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)BgL_new1327z00_3611)))->BgL_issuerz00)=((obj_t)BgL_issuer1119z00_2911),BUNSPEC); 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)BgL_new1327z00_3611)))->BgL_publiczd2keyzd2algoz00)=((obj_t)
((obj_t)BgL_publiczd2keyzd2algo1120z00_2912)),BUNSPEC); 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)BgL_new1327z00_3611)))->BgL_hashzd2algozd2)=((obj_t)
((obj_t)BgL_hashzd2algo1121zd2_2913)),BUNSPEC); 
((((BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bglt)COBJECT(BgL_new1327z00_3611))->BgL_containszd2nestedzd2sigzf3zf3)=((bool_t)BgL_containszd2nestedzd2sigzf31122zf3_3610),BUNSPEC); 
return BgL_new1327z00_3611;} } } 

}



/* &lambda1860 */
obj_t BGl_z62lambda1860z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2915, obj_t BgL_oz00_2916, obj_t BgL_vz00_2917)
{
{ /* Llib/pgp_packets.scm 39 */
{ /* Llib/pgp_packets.scm 39 */
bool_t BgL_vz00_3616;
BgL_vz00_3616 = 
CBOOL(BgL_vz00_2917); 
return 
((((BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bglt)BgL_oz00_2916)))->BgL_containszd2nestedzd2sigzf3zf3)=((bool_t)BgL_vz00_3616),BUNSPEC);} } 

}



/* &lambda1859 */
obj_t BGl_z62lambda1859z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2918, obj_t BgL_oz00_2919)
{
{ /* Llib/pgp_packets.scm 39 */
return 
BBOOL(
(((BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bglt)BgL_oz00_2919)))->BgL_containszd2nestedzd2sigzf3zf3));} 

}



/* &<@anonymous:1825> */
obj_t BGl_z62zc3z04anonymousza31825ze3ze5zz__openpgpzd2packetszd2(obj_t BgL_envz00_2920, obj_t BgL_new1115z00_2921)
{
{ /* Llib/pgp_packets.scm 31 */
{ 
BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt BgL_auxz00_5695;
((((BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)BgL_new1115z00_2921)))->BgL_versionz00)=((long)((long)0)),BUNSPEC); 
((((BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)BgL_new1115z00_2921)))->BgL_algoz00)=((obj_t)
CNST_TABLE_REF(((long)101))),BUNSPEC); 
((((BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)BgL_new1115z00_2921)))->BgL_s2kz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)BgL_new1115z00_2921)))->BgL_encryptedzd2sessionzd2keyz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_5695 = 
((BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)BgL_new1115z00_2921); 
return 
((obj_t)BgL_auxz00_5695);} } 

}



/* &lambda1823 */
BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt BGl_z62lambda1823z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2922)
{
{ /* Llib/pgp_packets.scm 31 */
{ /* Llib/pgp_packets.scm 31 */
BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt BgL_new1114z00_3619;
BgL_new1114z00_3619 = 
((BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bgl) ))); 
{ /* Llib/pgp_packets.scm 31 */
long BgL_arg1824z00_3620;
{ /* Llib/pgp_packets.scm 31 */
long BgL_res2446z00_3621;
BgL_res2446z00_3621 = 
BGL_CLASS_INDEX(BGl_PGPzd2Symmetriczd2Keyzd2Encryptedzd2Sessionzd2Keyzd2Packetz00zz__openpgpzd2packetszd2); 
BgL_arg1824z00_3620 = BgL_res2446z00_3621; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1114z00_3619), BgL_arg1824z00_3620); } 
{ /* Llib/pgp_packets.scm 31 */
BgL_objectz00_bglt BgL_tmpz00_5711;
BgL_tmpz00_5711 = 
((BgL_objectz00_bglt)BgL_new1114z00_3619); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_5711, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1114z00_3619); 
return BgL_new1114z00_3619;} } 

}



/* &lambda1821 */
BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt BGl_z62lambda1821z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2923, obj_t BgL_version1110z00_2924, obj_t BgL_algo1111z00_2925, obj_t BgL_s2k1112z00_2926, obj_t BgL_encryptedzd2sessionzd2ke1113z00_2927)
{
{ /* Llib/pgp_packets.scm 31 */
{ /* Llib/pgp_packets.scm 31 */
long BgL_version1110z00_3622;
BgL_version1110z00_3622 = 
(long)CINT(BgL_version1110z00_2924); 
{ /* Llib/pgp_packets.scm 31 */
BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt BgL_new1325z00_3624;
{ /* Llib/pgp_packets.scm 31 */
BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt BgL_new1324z00_3625;
BgL_new1324z00_3625 = 
((BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bgl) ))); 
{ /* Llib/pgp_packets.scm 31 */
long BgL_arg1822z00_3626;
{ /* Llib/pgp_packets.scm 31 */
long BgL_res2445z00_3627;
BgL_res2445z00_3627 = 
BGL_CLASS_INDEX(BGl_PGPzd2Symmetriczd2Keyzd2Encryptedzd2Sessionzd2Keyzd2Packetz00zz__openpgpzd2packetszd2); 
BgL_arg1822z00_3626 = BgL_res2445z00_3627; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1324z00_3625), BgL_arg1822z00_3626); } 
{ /* Llib/pgp_packets.scm 31 */
BgL_objectz00_bglt BgL_tmpz00_5720;
BgL_tmpz00_5720 = 
((BgL_objectz00_bglt)BgL_new1324z00_3625); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_5720, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1324z00_3625); 
BgL_new1325z00_3624 = BgL_new1324z00_3625; } 
((((BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(BgL_new1325z00_3624))->BgL_versionz00)=((long)BgL_version1110z00_3622),BUNSPEC); 
((((BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(BgL_new1325z00_3624))->BgL_algoz00)=((obj_t)
((obj_t)BgL_algo1111z00_2925)),BUNSPEC); 
((((BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(BgL_new1325z00_3624))->BgL_s2kz00)=((obj_t)BgL_s2k1112z00_2926),BUNSPEC); 
((((BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(BgL_new1325z00_3624))->BgL_encryptedzd2sessionzd2keyz00)=((obj_t)BgL_encryptedzd2sessionzd2ke1113z00_2927),BUNSPEC); 
return BgL_new1325z00_3624;} } } 

}



/* &lambda1845 */
obj_t BGl_z62lambda1845z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2928, obj_t BgL_oz00_2929, obj_t BgL_vz00_2930)
{
{ /* Llib/pgp_packets.scm 31 */
return 
((((BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)BgL_oz00_2929)))->BgL_encryptedzd2sessionzd2keyz00)=((obj_t)BgL_vz00_2930),BUNSPEC);} 

}



/* &lambda1844 */
obj_t BGl_z62lambda1844z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2931, obj_t BgL_oz00_2932)
{
{ /* Llib/pgp_packets.scm 31 */
return 
(((BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)BgL_oz00_2932)))->BgL_encryptedzd2sessionzd2keyz00);} 

}



/* &lambda1840 */
obj_t BGl_z62lambda1840z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2933, obj_t BgL_oz00_2934, obj_t BgL_vz00_2935)
{
{ /* Llib/pgp_packets.scm 31 */
return 
((((BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)BgL_oz00_2934)))->BgL_s2kz00)=((obj_t)BgL_vz00_2935),BUNSPEC);} 

}



/* &lambda1839 */
obj_t BGl_z62lambda1839z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2936, obj_t BgL_oz00_2937)
{
{ /* Llib/pgp_packets.scm 31 */
return 
(((BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)BgL_oz00_2937)))->BgL_s2kz00);} 

}



/* &lambda1835 */
obj_t BGl_z62lambda1835z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2938, obj_t BgL_oz00_2939, obj_t BgL_vz00_2940)
{
{ /* Llib/pgp_packets.scm 31 */
return 
((((BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)BgL_oz00_2939)))->BgL_algoz00)=((obj_t)
((obj_t)BgL_vz00_2940)),BUNSPEC);} 

}



/* &lambda1834 */
obj_t BGl_z62lambda1834z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2941, obj_t BgL_oz00_2942)
{
{ /* Llib/pgp_packets.scm 31 */
return 
(((BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)BgL_oz00_2942)))->BgL_algoz00);} 

}



/* &lambda1830 */
obj_t BGl_z62lambda1830z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2943, obj_t BgL_oz00_2944, obj_t BgL_vz00_2945)
{
{ /* Llib/pgp_packets.scm 31 */
{ /* Llib/pgp_packets.scm 31 */
long BgL_vz00_3636;
BgL_vz00_3636 = 
(long)CINT(BgL_vz00_2945); 
return 
((((BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)BgL_oz00_2944)))->BgL_versionz00)=((long)BgL_vz00_3636),BUNSPEC);} } 

}



/* &lambda1829 */
obj_t BGl_z62lambda1829z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2946, obj_t BgL_oz00_2947)
{
{ /* Llib/pgp_packets.scm 31 */
return 
BINT(
(((BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2symmetriczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)BgL_oz00_2947)))->BgL_versionz00));} 

}



/* &<@anonymous:1805> */
obj_t BGl_z62zc3z04anonymousza31805ze3ze5zz__openpgpzd2packetszd2(obj_t BgL_envz00_2948, obj_t BgL_new1108z00_2949)
{
{ /* Llib/pgp_packets.scm 28 */
{ 
BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt BgL_auxz00_5748;
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt)BgL_new1108z00_2949))))->BgL_versionz00)=((long)((long)0)),BUNSPEC); 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt)BgL_new1108z00_2949))))->BgL_signaturezd2typezd2)=((obj_t)
CNST_TABLE_REF(((long)101))),BUNSPEC); 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt)BgL_new1108z00_2949))))->BgL_issuerz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt)BgL_new1108z00_2949))))->BgL_publiczd2keyzd2algoz00)=((obj_t)
CNST_TABLE_REF(((long)101))),BUNSPEC); 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt)BgL_new1108z00_2949))))->BgL_hashzd2algozd2)=((obj_t)
CNST_TABLE_REF(((long)101))),BUNSPEC); 
{ 
obj_t BgL_auxz00_5767;
{ /* Llib/pgp_packets.scm 28 */
obj_t BgL_res2444z00_3639;
{ /* Llib/pgp_packets.scm 28 */
BGL_LONGLONG_T BgL_arg1665z00_3640;
BgL_arg1665z00_3640 = 
bgl_current_nanoseconds(); 
BgL_res2444z00_3639 = 
bgl_nanoseconds_to_date(BgL_arg1665z00_3640); } 
BgL_auxz00_5767 = BgL_res2444z00_3639; } 
((((BgL_pgpzd2signaturezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2packetz00_bglt)
((BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt)BgL_new1108z00_2949))))->BgL_creationzd2datezd2)=((obj_t)BgL_auxz00_5767),BUNSPEC); } 
((((BgL_pgpzd2signaturezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2packetz00_bglt)
((BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt)BgL_new1108z00_2949))))->BgL_signaturez00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_pgpzd2signaturezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2packetz00_bglt)
((BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt)BgL_new1108z00_2949))))->BgL_signedzd2packetzd2prefixz00)=((obj_t)BGl_string2786z00zz__openpgpzd2packetszd2),BUNSPEC); 
((((BgL_pgpzd2signaturezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2packetz00_bglt)
((BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt)BgL_new1108z00_2949))))->BgL_hashzd2trailerzd2)=((obj_t)BGl_string2786z00zz__openpgpzd2packetszd2),BUNSPEC); 
((((BgL_pgpzd2signaturezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2packetz00_bglt)
((BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt)BgL_new1108z00_2949))))->BgL_leftzd2hashzd2)=((obj_t)BGl_string2786z00zz__openpgpzd2packetszd2),BUNSPEC); 
((((BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt)BgL_new1108z00_2949)))->BgL_securezd2subzd2packetsz00)=((obj_t)BNIL),BUNSPEC); 
((((BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt)BgL_new1108z00_2949)))->BgL_insecurezd2subzd2packetsz00)=((obj_t)BNIL),BUNSPEC); 
BgL_auxz00_5748 = 
((BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt)BgL_new1108z00_2949); 
return 
((obj_t)BgL_auxz00_5748);} } 

}



/* &lambda1803 */
BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt BGl_z62lambda1803z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2950)
{
{ /* Llib/pgp_packets.scm 28 */
{ /* Llib/pgp_packets.scm 28 */
BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt BgL_new1107z00_3641;
BgL_new1107z00_3641 = 
((BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2v4zd2packetzd2_bgl) ))); 
{ /* Llib/pgp_packets.scm 28 */
long BgL_arg1804z00_3642;
{ /* Llib/pgp_packets.scm 28 */
long BgL_res2443z00_3643;
BgL_res2443z00_3643 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2v4zd2Packetzd2zz__openpgpzd2packetszd2); 
BgL_arg1804z00_3642 = BgL_res2443z00_3643; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1107z00_3641), BgL_arg1804z00_3642); } 
{ /* Llib/pgp_packets.scm 28 */
BgL_objectz00_bglt BgL_tmpz00_5795;
BgL_tmpz00_5795 = 
((BgL_objectz00_bglt)BgL_new1107z00_3641); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_5795, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1107z00_3641); 
return BgL_new1107z00_3641;} } 

}



/* &lambda1801 */
BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt BGl_z62lambda1801z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2951, obj_t BgL_version1095z00_2952, obj_t BgL_signaturezd2type1096zd2_2953, obj_t BgL_issuer1097z00_2954, obj_t BgL_publiczd2keyzd2algo1098z00_2955, obj_t BgL_hashzd2algo1099zd2_2956, obj_t BgL_creationzd2date1100zd2_2957, obj_t BgL_signature1101z00_2958, obj_t BgL_signedzd2packetzd2prefix1102z00_2959, obj_t BgL_hashzd2trailer1103zd2_2960, obj_t BgL_leftzd2hash1104zd2_2961, obj_t BgL_securezd2subzd2packets1105z00_2962, obj_t BgL_insecurezd2subzd2packets1106z00_2963)
{
{ /* Llib/pgp_packets.scm 28 */
{ /* Llib/pgp_packets.scm 28 */
long BgL_version1095z00_3644;
BgL_version1095z00_3644 = 
(long)CINT(BgL_version1095z00_2952); 
{ /* Llib/pgp_packets.scm 28 */
BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt BgL_new1323z00_3654;
{ /* Llib/pgp_packets.scm 28 */
BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt BgL_new1322z00_3655;
BgL_new1322z00_3655 = 
((BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2v4zd2packetzd2_bgl) ))); 
{ /* Llib/pgp_packets.scm 28 */
long BgL_arg1802z00_3656;
{ /* Llib/pgp_packets.scm 28 */
long BgL_res2442z00_3657;
BgL_res2442z00_3657 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2v4zd2Packetzd2zz__openpgpzd2packetszd2); 
BgL_arg1802z00_3656 = BgL_res2442z00_3657; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1322z00_3655), BgL_arg1802z00_3656); } 
{ /* Llib/pgp_packets.scm 28 */
BgL_objectz00_bglt BgL_tmpz00_5804;
BgL_tmpz00_5804 = 
((BgL_objectz00_bglt)BgL_new1322z00_3655); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_5804, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1322z00_3655); 
BgL_new1323z00_3654 = BgL_new1322z00_3655; } 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)BgL_new1323z00_3654)))->BgL_versionz00)=((long)BgL_version1095z00_3644),BUNSPEC); 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)BgL_new1323z00_3654)))->BgL_signaturezd2typezd2)=((obj_t)
((obj_t)BgL_signaturezd2type1096zd2_2953)),BUNSPEC); 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)BgL_new1323z00_3654)))->BgL_issuerz00)=((obj_t)BgL_issuer1097z00_2954),BUNSPEC); 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)BgL_new1323z00_3654)))->BgL_publiczd2keyzd2algoz00)=((obj_t)
((obj_t)BgL_publiczd2keyzd2algo1098z00_2955)),BUNSPEC); 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)BgL_new1323z00_3654)))->BgL_hashzd2algozd2)=((obj_t)
((obj_t)BgL_hashzd2algo1099zd2_2956)),BUNSPEC); 
((((BgL_pgpzd2signaturezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2packetz00_bglt)BgL_new1323z00_3654)))->BgL_creationzd2datezd2)=((obj_t)
((obj_t)BgL_creationzd2date1100zd2_2957)),BUNSPEC); 
((((BgL_pgpzd2signaturezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2packetz00_bglt)BgL_new1323z00_3654)))->BgL_signaturez00)=((obj_t)BgL_signature1101z00_2958),BUNSPEC); 
((((BgL_pgpzd2signaturezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2packetz00_bglt)BgL_new1323z00_3654)))->BgL_signedzd2packetzd2prefixz00)=((obj_t)
((obj_t)BgL_signedzd2packetzd2prefix1102z00_2959)),BUNSPEC); 
((((BgL_pgpzd2signaturezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2packetz00_bglt)BgL_new1323z00_3654)))->BgL_hashzd2trailerzd2)=((obj_t)
((obj_t)BgL_hashzd2trailer1103zd2_2960)),BUNSPEC); 
((((BgL_pgpzd2signaturezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2packetz00_bglt)BgL_new1323z00_3654)))->BgL_leftzd2hashzd2)=((obj_t)
((obj_t)BgL_leftzd2hash1104zd2_2961)),BUNSPEC); 
((((BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt)COBJECT(BgL_new1323z00_3654))->BgL_securezd2subzd2packetsz00)=((obj_t)
((obj_t)BgL_securezd2subzd2packets1105z00_2962)),BUNSPEC); 
((((BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt)COBJECT(BgL_new1323z00_3654))->BgL_insecurezd2subzd2packetsz00)=((obj_t)
((obj_t)BgL_insecurezd2subzd2packets1106z00_2963)),BUNSPEC); 
return BgL_new1323z00_3654;} } } 

}



/* &lambda1815 */
obj_t BGl_z62lambda1815z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2964, obj_t BgL_oz00_2965, obj_t BgL_vz00_2966)
{
{ /* Llib/pgp_packets.scm 28 */
return 
((((BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt)BgL_oz00_2965)))->BgL_insecurezd2subzd2packetsz00)=((obj_t)
((obj_t)BgL_vz00_2966)),BUNSPEC);} 

}



/* &lambda1814 */
obj_t BGl_z62lambda1814z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2967, obj_t BgL_oz00_2968)
{
{ /* Llib/pgp_packets.scm 28 */
return 
(((BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt)BgL_oz00_2968)))->BgL_insecurezd2subzd2packetsz00);} 

}



/* &lambda1810 */
obj_t BGl_z62lambda1810z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2969, obj_t BgL_oz00_2970, obj_t BgL_vz00_2971)
{
{ /* Llib/pgp_packets.scm 28 */
return 
((((BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt)BgL_oz00_2970)))->BgL_securezd2subzd2packetsz00)=((obj_t)
((obj_t)BgL_vz00_2971)),BUNSPEC);} 

}



/* &lambda1809 */
obj_t BGl_z62lambda1809z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2972, obj_t BgL_oz00_2973)
{
{ /* Llib/pgp_packets.scm 28 */
return 
(((BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2v4zd2packetzd2_bglt)BgL_oz00_2973)))->BgL_securezd2subzd2packetsz00);} 

}



/* &<@anonymous:1795> */
obj_t BGl_z62zc3z04anonymousza31795ze3ze5zz__openpgpzd2packetszd2(obj_t BgL_envz00_2974, obj_t BgL_new1093z00_2975)
{
{ /* Llib/pgp_packets.scm 27 */
{ 
BgL_pgpzd2signaturezd2v3zd2packetzd2_bglt BgL_auxz00_5849;
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2signaturezd2v3zd2packetzd2_bglt)BgL_new1093z00_2975))))->BgL_versionz00)=((long)((long)0)),BUNSPEC); 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2signaturezd2v3zd2packetzd2_bglt)BgL_new1093z00_2975))))->BgL_signaturezd2typezd2)=((obj_t)
CNST_TABLE_REF(((long)101))),BUNSPEC); 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2signaturezd2v3zd2packetzd2_bglt)BgL_new1093z00_2975))))->BgL_issuerz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2signaturezd2v3zd2packetzd2_bglt)BgL_new1093z00_2975))))->BgL_publiczd2keyzd2algoz00)=((obj_t)
CNST_TABLE_REF(((long)101))),BUNSPEC); 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2signaturezd2v3zd2packetzd2_bglt)BgL_new1093z00_2975))))->BgL_hashzd2algozd2)=((obj_t)
CNST_TABLE_REF(((long)101))),BUNSPEC); 
{ 
obj_t BgL_auxz00_5868;
{ /* Llib/pgp_packets.scm 27 */
obj_t BgL_res2441z00_3665;
{ /* Llib/pgp_packets.scm 27 */
BGL_LONGLONG_T BgL_arg1665z00_3666;
BgL_arg1665z00_3666 = 
bgl_current_nanoseconds(); 
BgL_res2441z00_3665 = 
bgl_nanoseconds_to_date(BgL_arg1665z00_3666); } 
BgL_auxz00_5868 = BgL_res2441z00_3665; } 
((((BgL_pgpzd2signaturezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2packetz00_bglt)
((BgL_pgpzd2signaturezd2v3zd2packetzd2_bglt)BgL_new1093z00_2975))))->BgL_creationzd2datezd2)=((obj_t)BgL_auxz00_5868),BUNSPEC); } 
((((BgL_pgpzd2signaturezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2packetz00_bglt)
((BgL_pgpzd2signaturezd2v3zd2packetzd2_bglt)BgL_new1093z00_2975))))->BgL_signaturez00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_pgpzd2signaturezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2packetz00_bglt)
((BgL_pgpzd2signaturezd2v3zd2packetzd2_bglt)BgL_new1093z00_2975))))->BgL_signedzd2packetzd2prefixz00)=((obj_t)BGl_string2786z00zz__openpgpzd2packetszd2),BUNSPEC); 
((((BgL_pgpzd2signaturezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2packetz00_bglt)
((BgL_pgpzd2signaturezd2v3zd2packetzd2_bglt)BgL_new1093z00_2975))))->BgL_hashzd2trailerzd2)=((obj_t)BGl_string2786z00zz__openpgpzd2packetszd2),BUNSPEC); 
((((BgL_pgpzd2signaturezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2packetz00_bglt)
((BgL_pgpzd2signaturezd2v3zd2packetzd2_bglt)BgL_new1093z00_2975))))->BgL_leftzd2hashzd2)=((obj_t)BGl_string2786z00zz__openpgpzd2packetszd2),BUNSPEC); 
BgL_auxz00_5849 = 
((BgL_pgpzd2signaturezd2v3zd2packetzd2_bglt)BgL_new1093z00_2975); 
return 
((obj_t)BgL_auxz00_5849);} } 

}



/* &lambda1793 */
BgL_pgpzd2signaturezd2v3zd2packetzd2_bglt BGl_z62lambda1793z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2976)
{
{ /* Llib/pgp_packets.scm 27 */
{ /* Llib/pgp_packets.scm 27 */
BgL_pgpzd2signaturezd2v3zd2packetzd2_bglt BgL_new1092z00_3667;
BgL_new1092z00_3667 = 
((BgL_pgpzd2signaturezd2v3zd2packetzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2v3zd2packetzd2_bgl) ))); 
{ /* Llib/pgp_packets.scm 27 */
long BgL_arg1794z00_3668;
{ /* Llib/pgp_packets.scm 27 */
long BgL_res2440z00_3669;
BgL_res2440z00_3669 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2v3zd2Packetzd2zz__openpgpzd2packetszd2); 
BgL_arg1794z00_3668 = BgL_res2440z00_3669; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1092z00_3667), BgL_arg1794z00_3668); } 
{ /* Llib/pgp_packets.scm 27 */
BgL_objectz00_bglt BgL_tmpz00_5892;
BgL_tmpz00_5892 = 
((BgL_objectz00_bglt)BgL_new1092z00_3667); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_5892, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1092z00_3667); 
return BgL_new1092z00_3667;} } 

}



/* &lambda1791 */
BgL_pgpzd2signaturezd2v3zd2packetzd2_bglt BGl_z62lambda1791z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2977, obj_t BgL_version1082z00_2978, obj_t BgL_signaturezd2type1083zd2_2979, obj_t BgL_issuer1084z00_2980, obj_t BgL_publiczd2keyzd2algo1085z00_2981, obj_t BgL_hashzd2algo1086zd2_2982, obj_t BgL_creationzd2date1087zd2_2983, obj_t BgL_signature1088z00_2984, obj_t BgL_signedzd2packetzd2prefix1089z00_2985, obj_t BgL_hashzd2trailer1090zd2_2986, obj_t BgL_leftzd2hash1091zd2_2987)
{
{ /* Llib/pgp_packets.scm 27 */
{ /* Llib/pgp_packets.scm 27 */
long BgL_version1082z00_3670;
BgL_version1082z00_3670 = 
(long)CINT(BgL_version1082z00_2978); 
{ /* Llib/pgp_packets.scm 27 */
BgL_pgpzd2signaturezd2v3zd2packetzd2_bglt BgL_new1321z00_3678;
{ /* Llib/pgp_packets.scm 27 */
BgL_pgpzd2signaturezd2v3zd2packetzd2_bglt BgL_new1320z00_3679;
BgL_new1320z00_3679 = 
((BgL_pgpzd2signaturezd2v3zd2packetzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2v3zd2packetzd2_bgl) ))); 
{ /* Llib/pgp_packets.scm 27 */
long BgL_arg1792z00_3680;
{ /* Llib/pgp_packets.scm 27 */
long BgL_res2439z00_3681;
BgL_res2439z00_3681 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2v3zd2Packetzd2zz__openpgpzd2packetszd2); 
BgL_arg1792z00_3680 = BgL_res2439z00_3681; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1320z00_3679), BgL_arg1792z00_3680); } 
{ /* Llib/pgp_packets.scm 27 */
BgL_objectz00_bglt BgL_tmpz00_5901;
BgL_tmpz00_5901 = 
((BgL_objectz00_bglt)BgL_new1320z00_3679); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_5901, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1320z00_3679); 
BgL_new1321z00_3678 = BgL_new1320z00_3679; } 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)BgL_new1321z00_3678)))->BgL_versionz00)=((long)BgL_version1082z00_3670),BUNSPEC); 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)BgL_new1321z00_3678)))->BgL_signaturezd2typezd2)=((obj_t)
((obj_t)BgL_signaturezd2type1083zd2_2979)),BUNSPEC); 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)BgL_new1321z00_3678)))->BgL_issuerz00)=((obj_t)BgL_issuer1084z00_2980),BUNSPEC); 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)BgL_new1321z00_3678)))->BgL_publiczd2keyzd2algoz00)=((obj_t)
((obj_t)BgL_publiczd2keyzd2algo1085z00_2981)),BUNSPEC); 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)BgL_new1321z00_3678)))->BgL_hashzd2algozd2)=((obj_t)
((obj_t)BgL_hashzd2algo1086zd2_2982)),BUNSPEC); 
((((BgL_pgpzd2signaturezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2packetz00_bglt)BgL_new1321z00_3678)))->BgL_creationzd2datezd2)=((obj_t)
((obj_t)BgL_creationzd2date1087zd2_2983)),BUNSPEC); 
((((BgL_pgpzd2signaturezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2packetz00_bglt)BgL_new1321z00_3678)))->BgL_signaturez00)=((obj_t)BgL_signature1088z00_2984),BUNSPEC); 
((((BgL_pgpzd2signaturezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2packetz00_bglt)BgL_new1321z00_3678)))->BgL_signedzd2packetzd2prefixz00)=((obj_t)
((obj_t)BgL_signedzd2packetzd2prefix1089z00_2985)),BUNSPEC); 
((((BgL_pgpzd2signaturezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2packetz00_bglt)BgL_new1321z00_3678)))->BgL_hashzd2trailerzd2)=((obj_t)
((obj_t)BgL_hashzd2trailer1090zd2_2986)),BUNSPEC); 
((((BgL_pgpzd2signaturezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2packetz00_bglt)BgL_new1321z00_3678)))->BgL_leftzd2hashzd2)=((obj_t)
((obj_t)BgL_leftzd2hash1091zd2_2987)),BUNSPEC); 
return BgL_new1321z00_3678;} } } 

}



/* &<@anonymous:1760> */
obj_t BGl_z62zc3z04anonymousza31760ze3ze5zz__openpgpzd2packetszd2(obj_t BgL_envz00_2988, obj_t BgL_new1080z00_2989)
{
{ /* Llib/pgp_packets.scm 21 */
{ 
BgL_pgpzd2signaturezd2packetz00_bglt BgL_auxz00_5932;
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2signaturezd2packetz00_bglt)BgL_new1080z00_2989))))->BgL_versionz00)=((long)((long)0)),BUNSPEC); 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2signaturezd2packetz00_bglt)BgL_new1080z00_2989))))->BgL_signaturezd2typezd2)=((obj_t)
CNST_TABLE_REF(((long)101))),BUNSPEC); 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2signaturezd2packetz00_bglt)BgL_new1080z00_2989))))->BgL_issuerz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2signaturezd2packetz00_bglt)BgL_new1080z00_2989))))->BgL_publiczd2keyzd2algoz00)=((obj_t)
CNST_TABLE_REF(((long)101))),BUNSPEC); 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2signaturezd2packetz00_bglt)BgL_new1080z00_2989))))->BgL_hashzd2algozd2)=((obj_t)
CNST_TABLE_REF(((long)101))),BUNSPEC); 
{ 
obj_t BgL_auxz00_5951;
{ /* Llib/pgp_packets.scm 21 */
obj_t BgL_res2438z00_3683;
{ /* Llib/pgp_packets.scm 21 */
BGL_LONGLONG_T BgL_arg1665z00_3684;
BgL_arg1665z00_3684 = 
bgl_current_nanoseconds(); 
BgL_res2438z00_3683 = 
bgl_nanoseconds_to_date(BgL_arg1665z00_3684); } 
BgL_auxz00_5951 = BgL_res2438z00_3683; } 
((((BgL_pgpzd2signaturezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2packetz00_bglt)BgL_new1080z00_2989)))->BgL_creationzd2datezd2)=((obj_t)BgL_auxz00_5951),BUNSPEC); } 
((((BgL_pgpzd2signaturezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2packetz00_bglt)BgL_new1080z00_2989)))->BgL_signaturez00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_pgpzd2signaturezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2packetz00_bglt)BgL_new1080z00_2989)))->BgL_signedzd2packetzd2prefixz00)=((obj_t)BGl_string2786z00zz__openpgpzd2packetszd2),BUNSPEC); 
((((BgL_pgpzd2signaturezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2packetz00_bglt)BgL_new1080z00_2989)))->BgL_hashzd2trailerzd2)=((obj_t)BGl_string2786z00zz__openpgpzd2packetszd2),BUNSPEC); 
((((BgL_pgpzd2signaturezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2packetz00_bglt)BgL_new1080z00_2989)))->BgL_leftzd2hashzd2)=((obj_t)BGl_string2786z00zz__openpgpzd2packetszd2),BUNSPEC); 
BgL_auxz00_5932 = 
((BgL_pgpzd2signaturezd2packetz00_bglt)BgL_new1080z00_2989); 
return 
((obj_t)BgL_auxz00_5932);} } 

}



/* &lambda1758 */
BgL_pgpzd2signaturezd2packetz00_bglt BGl_z62lambda1758z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2990)
{
{ /* Llib/pgp_packets.scm 21 */
{ /* Llib/pgp_packets.scm 21 */
BgL_pgpzd2signaturezd2packetz00_bglt BgL_new1079z00_3685;
BgL_new1079z00_3685 = 
((BgL_pgpzd2signaturezd2packetz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2packetz00_bgl) ))); 
{ /* Llib/pgp_packets.scm 21 */
long BgL_arg1759z00_3686;
{ /* Llib/pgp_packets.scm 21 */
long BgL_res2437z00_3687;
BgL_res2437z00_3687 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2Packetz00zz__openpgpzd2packetszd2); 
BgL_arg1759z00_3686 = BgL_res2437z00_3687; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1079z00_3685), BgL_arg1759z00_3686); } 
return BgL_new1079z00_3685;} } 

}



/* &lambda1756 */
BgL_pgpzd2signaturezd2packetz00_bglt BGl_z62lambda1756z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_2991, obj_t BgL_version1069z00_2992, obj_t BgL_signaturezd2type1070zd2_2993, obj_t BgL_issuer1071z00_2994, obj_t BgL_publiczd2keyzd2algo1072z00_2995, obj_t BgL_hashzd2algo1073zd2_2996, obj_t BgL_creationzd2date1074zd2_2997, obj_t BgL_signature1075z00_2998, obj_t BgL_signedzd2packetzd2prefix1076z00_2999, obj_t BgL_hashzd2trailer1077zd2_3000, obj_t BgL_leftzd2hash1078zd2_3001)
{
{ /* Llib/pgp_packets.scm 21 */
{ /* Llib/pgp_packets.scm 21 */
long BgL_version1069z00_3688;
BgL_version1069z00_3688 = 
(long)CINT(BgL_version1069z00_2992); 
{ /* Llib/pgp_packets.scm 21 */
BgL_pgpzd2signaturezd2packetz00_bglt BgL_new1319z00_3696;
{ /* Llib/pgp_packets.scm 21 */
BgL_pgpzd2signaturezd2packetz00_bglt BgL_new1318z00_3697;
BgL_new1318z00_3697 = 
((BgL_pgpzd2signaturezd2packetz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2packetz00_bgl) ))); 
{ /* Llib/pgp_packets.scm 21 */
long BgL_arg1757z00_3698;
{ /* Llib/pgp_packets.scm 21 */
long BgL_res2436z00_3699;
BgL_res2436z00_3699 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2Packetz00zz__openpgpzd2packetszd2); 
BgL_arg1757z00_3698 = BgL_res2436z00_3699; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1318z00_3697), BgL_arg1757z00_3698); } 
BgL_new1319z00_3696 = BgL_new1318z00_3697; } 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)BgL_new1319z00_3696)))->BgL_versionz00)=((long)BgL_version1069z00_3688),BUNSPEC); 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)BgL_new1319z00_3696)))->BgL_signaturezd2typezd2)=((obj_t)
((obj_t)BgL_signaturezd2type1070zd2_2993)),BUNSPEC); 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)BgL_new1319z00_3696)))->BgL_issuerz00)=((obj_t)BgL_issuer1071z00_2994),BUNSPEC); 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)BgL_new1319z00_3696)))->BgL_publiczd2keyzd2algoz00)=((obj_t)
((obj_t)BgL_publiczd2keyzd2algo1072z00_2995)),BUNSPEC); 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)BgL_new1319z00_3696)))->BgL_hashzd2algozd2)=((obj_t)
((obj_t)BgL_hashzd2algo1073zd2_2996)),BUNSPEC); 
((((BgL_pgpzd2signaturezd2packetz00_bglt)COBJECT(BgL_new1319z00_3696))->BgL_creationzd2datezd2)=((obj_t)
((obj_t)BgL_creationzd2date1074zd2_2997)),BUNSPEC); 
((((BgL_pgpzd2signaturezd2packetz00_bglt)COBJECT(BgL_new1319z00_3696))->BgL_signaturez00)=((obj_t)BgL_signature1075z00_2998),BUNSPEC); 
((((BgL_pgpzd2signaturezd2packetz00_bglt)COBJECT(BgL_new1319z00_3696))->BgL_signedzd2packetzd2prefixz00)=((obj_t)
((obj_t)BgL_signedzd2packetzd2prefix1076z00_2999)),BUNSPEC); 
((((BgL_pgpzd2signaturezd2packetz00_bglt)COBJECT(BgL_new1319z00_3696))->BgL_hashzd2trailerzd2)=((obj_t)
((obj_t)BgL_hashzd2trailer1077zd2_3000)),BUNSPEC); 
((((BgL_pgpzd2signaturezd2packetz00_bglt)COBJECT(BgL_new1319z00_3696))->BgL_leftzd2hashzd2)=((obj_t)
((obj_t)BgL_leftzd2hash1078zd2_3001)),BUNSPEC); 
return BgL_new1319z00_3696;} } } 

}



/* &lambda1785 */
obj_t BGl_z62lambda1785z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_3002, obj_t BgL_oz00_3003, obj_t BgL_vz00_3004)
{
{ /* Llib/pgp_packets.scm 21 */
return 
((((BgL_pgpzd2signaturezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2packetz00_bglt)BgL_oz00_3003)))->BgL_leftzd2hashzd2)=((obj_t)
((obj_t)BgL_vz00_3004)),BUNSPEC);} 

}



/* &lambda1784 */
obj_t BGl_z62lambda1784z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_3005, obj_t BgL_oz00_3006)
{
{ /* Llib/pgp_packets.scm 21 */
return 
(((BgL_pgpzd2signaturezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2packetz00_bglt)BgL_oz00_3006)))->BgL_leftzd2hashzd2);} 

}



/* &lambda1780 */
obj_t BGl_z62lambda1780z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_3007, obj_t BgL_oz00_3008, obj_t BgL_vz00_3009)
{
{ /* Llib/pgp_packets.scm 21 */
return 
((((BgL_pgpzd2signaturezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2packetz00_bglt)BgL_oz00_3008)))->BgL_hashzd2trailerzd2)=((obj_t)
((obj_t)BgL_vz00_3009)),BUNSPEC);} 

}



/* &lambda1779 */
obj_t BGl_z62lambda1779z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_3010, obj_t BgL_oz00_3011)
{
{ /* Llib/pgp_packets.scm 21 */
return 
(((BgL_pgpzd2signaturezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2packetz00_bglt)BgL_oz00_3011)))->BgL_hashzd2trailerzd2);} 

}



/* &lambda1775 */
obj_t BGl_z62lambda1775z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_3012, obj_t BgL_oz00_3013, obj_t BgL_vz00_3014)
{
{ /* Llib/pgp_packets.scm 21 */
return 
((((BgL_pgpzd2signaturezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2packetz00_bglt)BgL_oz00_3013)))->BgL_signedzd2packetzd2prefixz00)=((obj_t)
((obj_t)BgL_vz00_3014)),BUNSPEC);} 

}



/* &lambda1774 */
obj_t BGl_z62lambda1774z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_3015, obj_t BgL_oz00_3016)
{
{ /* Llib/pgp_packets.scm 21 */
return 
(((BgL_pgpzd2signaturezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2packetz00_bglt)BgL_oz00_3016)))->BgL_signedzd2packetzd2prefixz00);} 

}



/* &lambda1770 */
obj_t BGl_z62lambda1770z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_3017, obj_t BgL_oz00_3018, obj_t BgL_vz00_3019)
{
{ /* Llib/pgp_packets.scm 21 */
return 
((((BgL_pgpzd2signaturezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2packetz00_bglt)BgL_oz00_3018)))->BgL_signaturez00)=((obj_t)BgL_vz00_3019),BUNSPEC);} 

}



/* &lambda1769 */
obj_t BGl_z62lambda1769z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_3020, obj_t BgL_oz00_3021)
{
{ /* Llib/pgp_packets.scm 21 */
return 
(((BgL_pgpzd2signaturezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2packetz00_bglt)BgL_oz00_3021)))->BgL_signaturez00);} 

}



/* &lambda1765 */
obj_t BGl_z62lambda1765z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_3022, obj_t BgL_oz00_3023, obj_t BgL_vz00_3024)
{
{ /* Llib/pgp_packets.scm 21 */
return 
((((BgL_pgpzd2signaturezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2packetz00_bglt)BgL_oz00_3023)))->BgL_creationzd2datezd2)=((obj_t)
((obj_t)BgL_vz00_3024)),BUNSPEC);} 

}



/* &lambda1764 */
obj_t BGl_z62lambda1764z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_3025, obj_t BgL_oz00_3026)
{
{ /* Llib/pgp_packets.scm 21 */
return 
(((BgL_pgpzd2signaturezd2packetz00_bglt)COBJECT(
((BgL_pgpzd2signaturezd2packetz00_bglt)BgL_oz00_3026)))->BgL_creationzd2datezd2);} 

}



/* &<@anonymous:1685> */
obj_t BGl_z62zc3z04anonymousza31685ze3ze5zz__openpgpzd2packetszd2(obj_t BgL_envz00_3027, obj_t BgL_new1067z00_3028)
{
{ /* Llib/pgp_packets.scm 15 */
{ 
BgL_pgpzd2sigzd2packetz00_bglt BgL_auxz00_6021;
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)BgL_new1067z00_3028)))->BgL_versionz00)=((long)((long)0)),BUNSPEC); 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)BgL_new1067z00_3028)))->BgL_signaturezd2typezd2)=((obj_t)
CNST_TABLE_REF(((long)101))),BUNSPEC); 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)BgL_new1067z00_3028)))->BgL_issuerz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)BgL_new1067z00_3028)))->BgL_publiczd2keyzd2algoz00)=((obj_t)
CNST_TABLE_REF(((long)101))),BUNSPEC); 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)BgL_new1067z00_3028)))->BgL_hashzd2algozd2)=((obj_t)
CNST_TABLE_REF(((long)101))),BUNSPEC); 
BgL_auxz00_6021 = 
((BgL_pgpzd2sigzd2packetz00_bglt)BgL_new1067z00_3028); 
return 
((obj_t)BgL_auxz00_6021);} } 

}



/* &lambda1683 */
BgL_pgpzd2sigzd2packetz00_bglt BGl_z62lambda1683z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_3029)
{
{ /* Llib/pgp_packets.scm 15 */
{ /* Llib/pgp_packets.scm 15 */
BgL_pgpzd2sigzd2packetz00_bglt BgL_new1066z00_3715;
BgL_new1066z00_3715 = 
((BgL_pgpzd2sigzd2packetz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2sigzd2packetz00_bgl) ))); 
{ /* Llib/pgp_packets.scm 15 */
long BgL_arg1684z00_3716;
{ /* Llib/pgp_packets.scm 15 */
long BgL_res2435z00_3717;
BgL_res2435z00_3717 = 
BGL_CLASS_INDEX(BGl_PGPzd2Sigzd2Packetz00zz__openpgpzd2packetszd2); 
BgL_arg1684z00_3716 = BgL_res2435z00_3717; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1066z00_3715), BgL_arg1684z00_3716); } 
return BgL_new1066z00_3715;} } 

}



/* &lambda1681 */
BgL_pgpzd2sigzd2packetz00_bglt BGl_z62lambda1681z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_3030, obj_t BgL_version1061z00_3031, obj_t BgL_signaturezd2type1062zd2_3032, obj_t BgL_issuer1063z00_3033, obj_t BgL_publiczd2keyzd2algo1064z00_3034, obj_t BgL_hashzd2algo1065zd2_3035)
{
{ /* Llib/pgp_packets.scm 15 */
{ /* Llib/pgp_packets.scm 15 */
long BgL_version1061z00_3718;
BgL_version1061z00_3718 = 
(long)CINT(BgL_version1061z00_3031); 
{ /* Llib/pgp_packets.scm 15 */
BgL_pgpzd2sigzd2packetz00_bglt BgL_new1317z00_3722;
{ /* Llib/pgp_packets.scm 15 */
BgL_pgpzd2sigzd2packetz00_bglt BgL_new1316z00_3723;
BgL_new1316z00_3723 = 
((BgL_pgpzd2sigzd2packetz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2sigzd2packetz00_bgl) ))); 
{ /* Llib/pgp_packets.scm 15 */
long BgL_arg1682z00_3724;
{ /* Llib/pgp_packets.scm 15 */
long BgL_res2434z00_3725;
BgL_res2434z00_3725 = 
BGL_CLASS_INDEX(BGl_PGPzd2Sigzd2Packetz00zz__openpgpzd2packetszd2); 
BgL_arg1682z00_3724 = BgL_res2434z00_3725; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1316z00_3723), BgL_arg1682z00_3724); } 
BgL_new1317z00_3722 = BgL_new1316z00_3723; } 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(BgL_new1317z00_3722))->BgL_versionz00)=((long)BgL_version1061z00_3718),BUNSPEC); 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(BgL_new1317z00_3722))->BgL_signaturezd2typezd2)=((obj_t)
((obj_t)BgL_signaturezd2type1062zd2_3032)),BUNSPEC); 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(BgL_new1317z00_3722))->BgL_issuerz00)=((obj_t)BgL_issuer1063z00_3033),BUNSPEC); 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(BgL_new1317z00_3722))->BgL_publiczd2keyzd2algoz00)=((obj_t)
((obj_t)BgL_publiczd2keyzd2algo1064z00_3034)),BUNSPEC); 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(BgL_new1317z00_3722))->BgL_hashzd2algozd2)=((obj_t)
((obj_t)BgL_hashzd2algo1065zd2_3035)),BUNSPEC); 
return BgL_new1317z00_3722;} } } 

}



/* &lambda1742 */
obj_t BGl_z62lambda1742z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_3036, obj_t BgL_oz00_3037, obj_t BgL_vz00_3038)
{
{ /* Llib/pgp_packets.scm 15 */
return 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)BgL_oz00_3037)))->BgL_hashzd2algozd2)=((obj_t)
((obj_t)BgL_vz00_3038)),BUNSPEC);} 

}



/* &lambda1741 */
obj_t BGl_z62lambda1741z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_3039, obj_t BgL_oz00_3040)
{
{ /* Llib/pgp_packets.scm 15 */
return 
(((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)BgL_oz00_3040)))->BgL_hashzd2algozd2);} 

}



/* &lambda1721 */
obj_t BGl_z62lambda1721z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_3041, obj_t BgL_oz00_3042, obj_t BgL_vz00_3043)
{
{ /* Llib/pgp_packets.scm 15 */
return 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)BgL_oz00_3042)))->BgL_publiczd2keyzd2algoz00)=((obj_t)
((obj_t)BgL_vz00_3043)),BUNSPEC);} 

}



/* &lambda1720 */
obj_t BGl_z62lambda1720z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_3044, obj_t BgL_oz00_3045)
{
{ /* Llib/pgp_packets.scm 15 */
return 
(((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)BgL_oz00_3045)))->BgL_publiczd2keyzd2algoz00);} 

}



/* &lambda1710 */
obj_t BGl_z62lambda1710z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_3046, obj_t BgL_oz00_3047, obj_t BgL_vz00_3048)
{
{ /* Llib/pgp_packets.scm 15 */
return 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)BgL_oz00_3047)))->BgL_issuerz00)=((obj_t)BgL_vz00_3048),BUNSPEC);} 

}



/* &lambda1709 */
obj_t BGl_z62lambda1709z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_3049, obj_t BgL_oz00_3050)
{
{ /* Llib/pgp_packets.scm 15 */
return 
(((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)BgL_oz00_3050)))->BgL_issuerz00);} 

}



/* &lambda1700 */
obj_t BGl_z62lambda1700z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_3051, obj_t BgL_oz00_3052, obj_t BgL_vz00_3053)
{
{ /* Llib/pgp_packets.scm 15 */
return 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)BgL_oz00_3052)))->BgL_signaturezd2typezd2)=((obj_t)
((obj_t)BgL_vz00_3053)),BUNSPEC);} 

}



/* &lambda1699 */
obj_t BGl_z62lambda1699z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_3054, obj_t BgL_oz00_3055)
{
{ /* Llib/pgp_packets.scm 15 */
return 
(((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)BgL_oz00_3055)))->BgL_signaturezd2typezd2);} 

}



/* &lambda1695 */
obj_t BGl_z62lambda1695z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_3056, obj_t BgL_oz00_3057, obj_t BgL_vz00_3058)
{
{ /* Llib/pgp_packets.scm 15 */
{ /* Llib/pgp_packets.scm 15 */
long BgL_vz00_3738;
BgL_vz00_3738 = 
(long)CINT(BgL_vz00_3058); 
return 
((((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)BgL_oz00_3057)))->BgL_versionz00)=((long)BgL_vz00_3738),BUNSPEC);} } 

}



/* &lambda1694 */
obj_t BGl_z62lambda1694z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_3059, obj_t BgL_oz00_3060)
{
{ /* Llib/pgp_packets.scm 15 */
return 
BINT(
(((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)BgL_oz00_3060)))->BgL_versionz00));} 

}



/* &<@anonymous:1622> */
obj_t BGl_z62zc3z04anonymousza31622ze3ze5zz__openpgpzd2packetszd2(obj_t BgL_envz00_3061, obj_t BgL_new1059z00_3062)
{
{ /* Llib/pgp_packets.scm 5 */
{ 
BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt BgL_auxz00_6079;
((((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)BgL_new1059z00_3062)))->BgL_versionz00)=((long)((long)0)),BUNSPEC); 
((((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)BgL_new1059z00_3062)))->BgL_idz00)=((obj_t)BGl_string2786z00zz__openpgpzd2packetszd2),BUNSPEC); 
((((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)BgL_new1059z00_3062)))->BgL_algoz00)=((obj_t)
CNST_TABLE_REF(((long)101))),BUNSPEC); 
((((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)BgL_new1059z00_3062)))->BgL_encryptedzd2sessionzd2keyz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_6079 = 
((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)BgL_new1059z00_3062); 
return 
((obj_t)BgL_auxz00_6079);} } 

}



/* &lambda1617 */
BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt BGl_z62lambda1617z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_3063)
{
{ /* Llib/pgp_packets.scm 5 */
{ /* Llib/pgp_packets.scm 5 */
BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt BgL_new1058z00_3741;
BgL_new1058z00_3741 = 
((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bgl) ))); 
{ /* Llib/pgp_packets.scm 5 */
long BgL_arg1621z00_3742;
{ /* Llib/pgp_packets.scm 5 */
long BgL_res2433z00_3743;
BgL_res2433z00_3743 = 
BGL_CLASS_INDEX(BGl_PGPzd2Publiczd2Keyzd2Encryptedzd2Sessionzd2Keyzd2Packetz00zz__openpgpzd2packetszd2); 
BgL_arg1621z00_3742 = BgL_res2433z00_3743; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1058z00_3741), BgL_arg1621z00_3742); } 
{ /* Llib/pgp_packets.scm 5 */
BgL_objectz00_bglt BgL_tmpz00_6095;
BgL_tmpz00_6095 = 
((BgL_objectz00_bglt)BgL_new1058z00_3741); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_6095, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1058z00_3741); 
return BgL_new1058z00_3741;} } 

}



/* &lambda1614 */
BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt BGl_z62lambda1614z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_3064, obj_t BgL_version1054z00_3065, obj_t BgL_id1055z00_3066, obj_t BgL_algo1056z00_3067, obj_t BgL_encryptedzd2sessionzd2ke1057z00_3068)
{
{ /* Llib/pgp_packets.scm 5 */
{ /* Llib/pgp_packets.scm 5 */
long BgL_version1054z00_3744;
BgL_version1054z00_3744 = 
(long)CINT(BgL_version1054z00_3065); 
{ /* Llib/pgp_packets.scm 5 */
BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt BgL_new1315z00_3747;
{ /* Llib/pgp_packets.scm 5 */
BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt BgL_new1314z00_3748;
BgL_new1314z00_3748 = 
((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bgl) ))); 
{ /* Llib/pgp_packets.scm 5 */
long BgL_arg1616z00_3749;
{ /* Llib/pgp_packets.scm 5 */
long BgL_res2432z00_3750;
BgL_res2432z00_3750 = 
BGL_CLASS_INDEX(BGl_PGPzd2Publiczd2Keyzd2Encryptedzd2Sessionzd2Keyzd2Packetz00zz__openpgpzd2packetszd2); 
BgL_arg1616z00_3749 = BgL_res2432z00_3750; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1314z00_3748), BgL_arg1616z00_3749); } 
{ /* Llib/pgp_packets.scm 5 */
BgL_objectz00_bglt BgL_tmpz00_6104;
BgL_tmpz00_6104 = 
((BgL_objectz00_bglt)BgL_new1314z00_3748); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_6104, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1314z00_3748); 
BgL_new1315z00_3747 = BgL_new1314z00_3748; } 
((((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(BgL_new1315z00_3747))->BgL_versionz00)=((long)BgL_version1054z00_3744),BUNSPEC); 
((((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(BgL_new1315z00_3747))->BgL_idz00)=((obj_t)
((obj_t)BgL_id1055z00_3066)),BUNSPEC); 
((((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(BgL_new1315z00_3747))->BgL_algoz00)=((obj_t)
((obj_t)BgL_algo1056z00_3067)),BUNSPEC); 
((((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(BgL_new1315z00_3747))->BgL_encryptedzd2sessionzd2keyz00)=((obj_t)BgL_encryptedzd2sessionzd2ke1057z00_3068),BUNSPEC); 
return BgL_new1315z00_3747;} } } 

}



/* &lambda1671 */
obj_t BGl_z62lambda1671z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_3069, obj_t BgL_oz00_3070, obj_t BgL_vz00_3071)
{
{ /* Llib/pgp_packets.scm 5 */
return 
((((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)BgL_oz00_3070)))->BgL_encryptedzd2sessionzd2keyz00)=((obj_t)BgL_vz00_3071),BUNSPEC);} 

}



/* &lambda1670 */
obj_t BGl_z62lambda1670z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_3072, obj_t BgL_oz00_3073)
{
{ /* Llib/pgp_packets.scm 5 */
return 
(((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)BgL_oz00_3073)))->BgL_encryptedzd2sessionzd2keyz00);} 

}



/* &lambda1664 */
obj_t BGl_z62lambda1664z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_3074, obj_t BgL_oz00_3075, obj_t BgL_vz00_3076)
{
{ /* Llib/pgp_packets.scm 5 */
return 
((((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)BgL_oz00_3075)))->BgL_algoz00)=((obj_t)
((obj_t)BgL_vz00_3076)),BUNSPEC);} 

}



/* &lambda1663 */
obj_t BGl_z62lambda1663z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_3077, obj_t BgL_oz00_3078)
{
{ /* Llib/pgp_packets.scm 5 */
return 
(((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)BgL_oz00_3078)))->BgL_algoz00);} 

}



/* &lambda1657 */
obj_t BGl_z62lambda1657z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_3079, obj_t BgL_oz00_3080, obj_t BgL_vz00_3081)
{
{ /* Llib/pgp_packets.scm 5 */
return 
((((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)BgL_oz00_3080)))->BgL_idz00)=((obj_t)
((obj_t)BgL_vz00_3081)),BUNSPEC);} 

}



/* &lambda1656 */
obj_t BGl_z62lambda1656z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_3082, obj_t BgL_oz00_3083)
{
{ /* Llib/pgp_packets.scm 5 */
return 
(((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)BgL_oz00_3083)))->BgL_idz00);} 

}



/* &lambda1647 */
obj_t BGl_z62lambda1647z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_3084, obj_t BgL_oz00_3085, obj_t BgL_vz00_3086)
{
{ /* Llib/pgp_packets.scm 5 */
{ /* Llib/pgp_packets.scm 5 */
long BgL_vz00_3760;
BgL_vz00_3760 = 
(long)CINT(BgL_vz00_3086); 
return 
((((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)BgL_oz00_3085)))->BgL_versionz00)=((long)BgL_vz00_3760),BUNSPEC);} } 

}



/* &lambda1646 */
obj_t BGl_z62lambda1646z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_3087, obj_t BgL_oz00_3088)
{
{ /* Llib/pgp_packets.scm 5 */
return 
BINT(
(((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2publiczd2keyzd2encryptedzd2sessionzd2keyzd2packetz00_bglt)BgL_oz00_3088)))->BgL_versionz00));} 

}



/* &<@anonymous:1580> */
obj_t BGl_z62zc3z04anonymousza31580ze3ze5zz__openpgpzd2packetszd2(obj_t BgL_envz00_3089, obj_t BgL_new1052z00_3090)
{
{ /* Llib/pgp_packets.scm 4 */
return 
((obj_t)
((BgL_pgpzd2sessionzd2keyzd2packetzd2_bglt)BgL_new1052z00_3090));} 

}



/* &lambda1578 */
BgL_pgpzd2sessionzd2keyzd2packetzd2_bglt BGl_z62lambda1578z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_3091)
{
{ /* Llib/pgp_packets.scm 4 */
{ /* Llib/pgp_packets.scm 4 */
BgL_pgpzd2sessionzd2keyzd2packetzd2_bglt BgL_new1051z00_3763;
BgL_new1051z00_3763 = 
((BgL_pgpzd2sessionzd2keyzd2packetzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2sessionzd2keyzd2packetzd2_bgl) ))); 
{ /* Llib/pgp_packets.scm 4 */
long BgL_arg1579z00_3764;
{ /* Llib/pgp_packets.scm 4 */
long BgL_res2431z00_3765;
BgL_res2431z00_3765 = 
BGL_CLASS_INDEX(BGl_PGPzd2Sessionzd2Keyzd2Packetzd2zz__openpgpzd2packetszd2); 
BgL_arg1579z00_3764 = BgL_res2431z00_3765; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1051z00_3763), BgL_arg1579z00_3764); } 
return BgL_new1051z00_3763;} } 

}



/* &<@anonymous:1548> */
obj_t BGl_z62zc3z04anonymousza31548ze3ze5zz__openpgpzd2packetszd2(obj_t BgL_envz00_3092, obj_t BgL_new1049z00_3093)
{
{ /* Llib/pgp_packets.scm 3 */
return 
((obj_t)
((BgL_pgpzd2packetzd2_bglt)BgL_new1049z00_3093));} 

}



/* &lambda1546 */
BgL_pgpzd2packetzd2_bglt BGl_z62lambda1546z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_3094)
{
{ /* Llib/pgp_packets.scm 3 */
{ /* Llib/pgp_packets.scm 3 */
BgL_pgpzd2packetzd2_bglt BgL_new1048z00_3767;
BgL_new1048z00_3767 = 
((BgL_pgpzd2packetzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2packetzd2_bgl) ))); 
{ /* Llib/pgp_packets.scm 3 */
long BgL_arg1547z00_3768;
{ /* Llib/pgp_packets.scm 3 */
long BgL_res2430z00_3769;
BgL_res2430z00_3769 = 
BGL_CLASS_INDEX(BGl_PGPzd2Packetzd2zz__openpgpzd2packetszd2); 
BgL_arg1547z00_3768 = BgL_res2430z00_3769; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1048z00_3767), BgL_arg1547z00_3768); } 
return BgL_new1048z00_3767;} } 

}



/* &lambda1538 */
BgL_pgpzd2packetzd2_bglt BGl_z62lambda1538z62zz__openpgpzd2packetszd2(obj_t BgL_envz00_3095)
{
{ /* Llib/pgp_packets.scm 3 */
{ /* Llib/pgp_packets.scm 3 */
BgL_pgpzd2packetzd2_bglt BgL_new1313z00_3770;
{ /* Llib/pgp_packets.scm 3 */
BgL_pgpzd2packetzd2_bglt BgL_new1312z00_3771;
BgL_new1312z00_3771 = 
((BgL_pgpzd2packetzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2packetzd2_bgl) ))); 
{ /* Llib/pgp_packets.scm 3 */
long BgL_arg1545z00_3772;
{ /* Llib/pgp_packets.scm 3 */
long BgL_res2429z00_3773;
BgL_res2429z00_3773 = 
BGL_CLASS_INDEX(BGl_PGPzd2Packetzd2zz__openpgpzd2packetszd2); 
BgL_arg1545z00_3772 = BgL_res2429z00_3773; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1312z00_3771), BgL_arg1545z00_3772); } 
BgL_new1313z00_3770 = BgL_new1312z00_3771; } 
return BgL_new1313z00_3770;} } 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__openpgpzd2packetszd2()
{
{ /* Llib/pgp_packets.scm 1 */
return BUNSPEC;} 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__openpgpzd2packetszd2()
{
{ /* Llib/pgp_packets.scm 1 */
return BUNSPEC;} 

}

#ifdef __cplusplus
}
#endif
