/*===========================================================================*/
/*   (Llib/ssl.scm)                                                          */
/*   Bigloo (4.3h)                                                           */
/*   Inria -- Sophia Antipolis (c)       Tue 12 May 2020 08:36:09 AM CEST    */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.3h/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.3h/lib/bigloo/4.3h -I Llib -lib-dir /builddir/build/BUILD/bigloo-4.3h/lib/bigloo/4.3h -unsafe -safee -copt -I. -copt -fPIC -copt -IC Llib/ssl.scm -o objs/ssl.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>
#include <bglssl.h>
#include <ssl_debug.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_certificatez00_bgl {
   header_t header;
   obj_t widening;
   void * BgL_z42nativez42;
} *BgL_certificatez00_bglt;

typedef struct BgL_privatezd2keyzd2_bgl {
   header_t header;
   obj_t widening;
   void * BgL_z42nativez42;
} *BgL_privatezd2keyzd2_bglt;

typedef struct BgL_securezd2contextzd2_bgl {
   header_t header;
   obj_t widening;
   void * BgL_z42nativez42;
   void * BgL_z42cazd2storez90;
   obj_t BgL_methodz00;
} *BgL_securezd2contextzd2_bglt;

typedef struct BgL_sslzd2connectionzd2_bgl {
   header_t header;
   obj_t widening;
   void * BgL_z42nativez42;
   void * BgL_z42biozd2readz90;
   void * BgL_z42biozd2writez90;
   void * BgL_z42nextzd2sessionz90;
   struct BgL_securezd2contextzd2_bgl * BgL_ctxz00;
   bool_t BgL_isserverz00;
   bool_t BgL_requestzd2certzd2;
   obj_t BgL_serverzd2namezd2;
   bool_t BgL_rejectzd2unauthoriza7edz75;
   obj_t BgL_infozd2callbackzd2;
   obj_t BgL_snizd2contextzd2callbackz00;
   obj_t BgL_newsessionzd2callbackzd2;
   obj_t BgL_selectedzd2npnzd2protosz00;
   obj_t BgL_npnzd2protoszd2;
   obj_t BgL_errz00;
   bool_t BgL_receivedzd2shutdownzd2;
   bool_t BgL_sentzd2shutdownzd2;
} *BgL_sslzd2connectionzd2_bglt;

typedef struct BgL_dhz00_bgl {
   header_t header;
   obj_t widening;
   void * BgL_z42nativez42;
   void * BgL_z52pz52;
   void * BgL_z52qz52;
   void * BgL_z52gz52;
   void * BgL_z52pubz52;
   void * BgL_z52privz52;
} *BgL_dhz00_bglt;

typedef struct BgL_sslzd2hashzd2_bgl {
   header_t header;
   obj_t widening;
   void * BgL_z42mdz42;
   void * BgL_z42mdzd2ctxz90;
   obj_t BgL_typez00;
} *BgL_sslzd2hashzd2_bglt;

typedef struct BgL_sslzd2hmaczd2_bgl {
   header_t header;
   obj_t widening;
   void * BgL_z42mdz42;
   void * BgL_z42mdzd2ctxz90;
} *BgL_sslzd2hmaczd2_bglt;

typedef struct BgL_sslzd2signzd2_bgl {
   header_t header;
   obj_t widening;
   void * BgL_z42mdz42;
   void * BgL_z42mdzd2ctxz90;
} *BgL_sslzd2signzd2_bglt;

typedef struct BgL_sslzd2verifyzd2_bgl {
   header_t header;
   obj_t widening;
   void * BgL_z42mdz42;
   void * BgL_z42mdzd2ctxz90;
} *BgL_sslzd2verifyzd2_bglt;

typedef struct BgL_sslzd2cipherzd2_bgl {
   header_t header;
   obj_t widening;
   void * BgL_z42cipherz42;
   void * BgL_z42cipherzd2ctxz90;
} *BgL_sslzd2cipherzd2_bglt;


static obj_t BGl_z62lambda1769z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62sslzd2hashzd2digest1323z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62dhzd2generatezd2keyz62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62sslzd2connectionzd2clearzd2inzb0zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62sslzd2cipherzd2updatez12z70zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t bgl_pkcs5_pbkdf2_hmac_sha1(obj_t, obj_t, int, int);
static obj_t BGl_z62lambda1770z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1932z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1933z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static BgL_privatezd2keyzd2_bglt BGl_z62lambda1776z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1939z62zz__ssl_sslz00(obj_t, obj_t);
static BgL_privatezd2keyzd2_bglt BGl_z62lambda1778z62zz__ssl_sslz00(obj_t);
static obj_t BGl_z62sslzd2connectionzd2setzd2s1289zb0zz__ssl_sslz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_certificatez00zz__ssl_sslz00 = BUNSPEC;
BGL_IMPORT obj_t BGl_classzd2nilzd2initz12z12zz__objectz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31952ze3ze5zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1940z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1784z62zz__ssl_sslz00(obj_t, obj_t);
extern obj_t bgl_make_ssl_server_socket(obj_t, int, int, obj_t, obj_t, obj_t, obj_t, int, bool_t);
static obj_t BGl_z62lambda1785z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static BgL_dhz00_bglt BGl_z62lambda1947z62zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_bnzd2newzd2zz__ssl_sslz00();
static obj_t BGl_z62sslzd2verifyzd2init1337z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_sanityzd2argszd2checksz00zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_sslzd2hashzd2digestz00zz__ssl_sslz00(BgL_sslzd2hashzd2_bglt);
static obj_t BGl_z62zc3z04anonymousza31880ze3ze5zz__ssl_sslz00(obj_t);
static BgL_dhz00_bglt BGl_z62lambda1950z62zz__ssl_sslz00(obj_t);
static obj_t BGl_z62sslzd2signzd2initz62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static BgL_securezd2contextzd2_bglt BGl_z62lambda1791z62zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_sslzd2connectionzd2setzd2sessionzd2zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt, obj_t);
static BgL_securezd2contextzd2_bglt BGl_z62lambda1794z62zz__ssl_sslz00(obj_t);
static obj_t BGl_z62lambda1957z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1958z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62sslzd2getzd2ciphersz62zz__ssl_sslz00(obj_t);
extern bool_t bgl_ssl_ctx_add_ca_cert(BgL_securezd2contextzd2_bglt, obj_t, long, long);
static obj_t BGl_z62zc3z04anonymousza32013ze3ze5zz__ssl_sslz00(obj_t, obj_t);
extern obj_t bgl_ssl_sign_sign(BgL_sslzd2signzd2_bglt, obj_t, long, long);
static obj_t BGl_z62sslzd2connectionzd2shutd1273z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31849ze3ze5zz__ssl_sslz00(obj_t);
static obj_t BGl_z62lambda1964z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1965z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32014ze3ze5zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62dhzd2generatezd2key1317z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl__clientzd2socketzd2usezd2sslz12zc0zz__ssl_sslz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_dhzd2generatezd2parameterszd2exzd2zz__ssl_sslz00(BgL_dhz00_bglt, int, obj_t);
static obj_t BGl_z62lambda1971z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1972z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1978z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1979z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62securezd2contextzd2setzd2o1265zb0zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62sslzd2clearzd2errorz62zz__ssl_sslz00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_dhzd2checkzd2zz__ssl_sslz00(BgL_dhz00_bglt);
static obj_t BGl_z62lambda1985z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1986z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62sslzd2connectionzd2getzd2peerzd2certificatez62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32105ze3ze5zz__ssl_sslz00(obj_t);
extern bool_t bgl_ssl_ctx_set_key(BgL_securezd2contextzd2_bglt, obj_t, long, long, obj_t);
BGL_EXPORTED_DEF obj_t BGl_privatezd2keyzd2zz__ssl_sslz00 = BUNSPEC;
extern obj_t bgl_ssl_error_string();
static obj_t BGl_z62sslzd2connectionzd2loadzd2sessionzb0zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62securezd2contextzd2setzd2sessionzd2idzd2contextz12za2zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31973ze3ze5zz__ssl_sslz00(obj_t);
static obj_t BGl_objectzd2initzd2zz__ssl_sslz00();
static obj_t BGl_z62lambda1992z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1993z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL bool_t BGl_securezd2contextzd2addzd2crlz12zc0zz__ssl_sslz00(BgL_securezd2contextzd2_bglt, obj_t, long, long);
BGL_EXPORTED_DECL obj_t BGl_pkcs5zd2pbkdf2zd2hmaczd2sha1zd2zz__ssl_sslz00(obj_t, obj_t, int, int);
static obj_t BGl_z62sslzd2connectionzd2read1275z62zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_sslzd2connectionzd2zz__ssl_sslz00 = BUNSPEC;
BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
static obj_t BGl_z62sslzd2connectionzd2verif1297z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31796ze3ze5zz__ssl_sslz00(obj_t, obj_t);
extern bool_t bgl_cipher_set_auto_padding(BgL_sslzd2cipherzd2_bglt, bool_t);
BGL_EXPORTED_DECL obj_t BGl_sslzd2hashzd2initz00zz__ssl_sslz00(BgL_sslzd2hashzd2_bglt);
BGL_EXPORTED_DECL bool_t BGl_sslzd2verifyzd2finalz00zz__ssl_sslz00(BgL_sslzd2verifyzd2_bglt, obj_t, long, long, obj_t, long, long);
BGL_EXPORTED_DECL BgL_certificatez00_bglt BGl_readzd2certificatezd2zz__ssl_sslz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32018ze3ze5zz__ssl_sslz00(obj_t, obj_t);
BGL_EXPORTED_DECL bool_t BGl_sslzd2randzd2statusz00zz__ssl_sslz00();
extern obj_t bgl_cipher_final(BgL_sslzd2cipherzd2_bglt);
static obj_t BGl_z62sslzd2hashzd2init1319z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62sslzd2connectionzd2getzd2currentzd2cipherz62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31959ze3ze5zz__ssl_sslz00(obj_t);
static obj_t BGl_z62bnzd2bin2bnzb0zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62evpzd2getzd2hashesz62zz__ssl_sslz00(obj_t);
BGL_IMPORT obj_t bstring_to_symbol(obj_t);
static obj_t BGl_z62sslzd2verifyzd2updatez12z70zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62sslzd2connectionzd2writez62zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32019ze3ze5zz__ssl_sslz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t bgl_make_certificate(void *);
static obj_t BGl_z62securezd2contextzd2setzd2ciphersz12za2zz__ssl_sslz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_sslzd2randzd2pseudozd2byteszd2zz__ssl_sslz00(int);
BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32141ze3ze5zz__ssl_sslz00(obj_t);
extern obj_t bgl_ssl_hmac_digest(BgL_sslzd2hmaczd2_bglt);
static obj_t BGl_z62zc3z04anonymousza32052ze3ze5zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32214ze3ze5zz__ssl_sslz00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_sslzd2connectionzd2getzd2sessionzd2zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt);
static obj_t BGl_z62sslzd2signzd2sign1335z62zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62securezd2contextzd2initz62zz__ssl_sslz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_dhzd2checkzd2pubzd2keyzd2zz__ssl_sslz00(BgL_dhz00_bglt, obj_t);
static obj_t BGl_methodzd2initzd2zz__ssl_sslz00();
static obj_t BGl_z62securezd2contextzd2loadzd21261zb0zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_sslzd2connectionzd2writez00zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt, obj_t, long, long);
BGL_EXPORTED_DECL int BGl_sslzd2opzd2cipherzd2serverzd2preferencez00zz__ssl_sslz00();
static obj_t BGl_z62zc3z04anonymousza31994ze3ze5zz__ssl_sslz00(obj_t);
static obj_t BGl_z62sslzd2connectionzd2clearzd2pendingzb0zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62sslzd2opzd2cipherzd2serverzd2preferencez62zz__ssl_sslz00(obj_t);
BGL_EXPORTED_DECL bool_t BGl_securezd2contextzd2addzd2cazd2certz12z12zz__ssl_sslz00(BgL_securezd2contextzd2_bglt, obj_t, long, long);
static obj_t BGl_z62sslzd2cipherzd2updatez121347z70zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62sslzd2connectionzd2enczd2pendingzb0zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32070ze3ze5zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32127ze3ze5zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32038ze3ze5zz__ssl_sslz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_bnzd2bin2bnzd2zz__ssl_sslz00(obj_t);
BGL_IMPORT obj_t make_string(long, unsigned char);
BGL_EXPORTED_DECL bool_t BGl_sslzd2socketzf3z21zz__ssl_sslz00(obj_t);
static obj_t BGl_z62securezd2contextzd2close1241z62zz__ssl_sslz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_makezd2sslzd2serverzd2socketzd2zz__ssl_sslz00(obj_t);
BGL_EXPORTED_DECL BgL_privatezd2keyzd2_bglt BGl_readzd2privatezd2keyz00zz__ssl_sslz00(obj_t);
static obj_t BGl_z62sslzd2randzd2pseudozd2byteszb0zz__ssl_sslz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_sslzd2cipherzd2updatez12z12zz__ssl_sslz00(BgL_sslzd2cipherzd2_bglt, obj_t, long, long);
static obj_t BGl_z62zc3z04anonymousza32056ze3ze5zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl__makezd2sslzd2clientzd2socketzd2zz__ssl_sslz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t bgl_make_private_key(void *);
BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
extern long bgl_ssl_connection_clear_in(BgL_sslzd2connectionzd2_bglt, char *, long, long);
extern bool_t bgl_load_pkcs12(BgL_securezd2contextzd2_bglt, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_sslzd2connectionzd2shutdownz00zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt);
static obj_t BGl_z62sslzd2verifyzd2initz62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31998ze3ze5zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62bnzd2bn2binzb0zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62sslzd2hashzd2updatez121321z70zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t bgl_ssl_load_pem(obj_t);
static obj_t BGl_z62sslzd2signzd2updatez12z70zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2103z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda2104z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62sslzd2hmaczd2updatez12z70zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62certificatezd2issuerzb0zz__ssl_sslz00(obj_t, obj_t);
BGL_EXPORTED_DECL bool_t BGl_sslzd2cipherzd2setzd2autozd2paddingz00zz__ssl_sslz00(BgL_sslzd2cipherzd2_bglt, bool_t);
static obj_t BGl_z62zc3z04anonymousza31999ze3ze5zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62sslzd2cipherzd2initivz62zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern void bgl_dh_pqg_set(void *, void *, void *, void *);
static obj_t BGl_z62bnzd2freezb0zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda2110z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda2111z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_dhzd2computezd2keyz00zz__ssl_sslz00(BgL_dhz00_bglt, obj_t);
static obj_t BGl_z62dhzd2checkzd2pubzd2key1313zb0zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2116z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda2117z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62pkcs5zd2pbkdf2zd2hmaczd2sha1zb0zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
extern bool_t bgl_ssl_sign_init(BgL_sslzd2signzd2_bglt, obj_t);
extern bool_t bgl_ssl_hash_update(BgL_sslzd2hashzd2_bglt, obj_t, long, long);
static obj_t BGl_z62sslzd2hmaczd2updatez121327z70zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t bgl_ssl_get_ciphers();
BGL_EXPORTED_DECL int BGl_bnzd2numzd2bytesz00zz__ssl_sslz00(obj_t);
static BgL_sslzd2hmaczd2_bglt BGl_z62lambda2123z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static BgL_sslzd2hmaczd2_bglt BGl_z62lambda2125z62zz__ssl_sslz00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_securezd2contextzd2initz00zz__ssl_sslz00(BgL_securezd2contextzd2_bglt);
BGL_EXPORTED_DECL obj_t BGl_sslzd2connectionzd2clearzd2outzd2zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt, obj_t, long, long);
static obj_t BGl_z62lambda2132z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda2133z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32166ze3ze5zz__ssl_sslz00(obj_t);
static obj_t BGl_z62lambda2139z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62securezd2contextzd2setzd2c1257zb0zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_bnzd2bn2binzd2zz__ssl_sslz00(obj_t);
extern int bgl_ssl_connection_set_session(BgL_sslzd2connectionzd2_bglt, obj_t);
static obj_t BGl_z62securezd2contextzd2setzd2s1259zb0zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31810ze3ze5zz__ssl_sslz00(obj_t);
static obj_t BGl_z62lambda2140z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32183ze3ze5zz__ssl_sslz00(obj_t);
static obj_t BGl_z62securezd2contextzd2setzd2c1263zb0zz__ssl_sslz00(obj_t, obj_t, obj_t);
static BgL_sslzd2signzd2_bglt BGl_z62lambda2148z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62sslzd2cipherzd2initz62zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62sslzd2connectionzd2start1269z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62dhzd2siza7e1307z17zz__ssl_sslz00(obj_t, obj_t);
extern obj_t bgl_ssl_connection_get_peer_certificate(BgL_sslzd2connectionzd2_bglt);
BGL_EXPORTED_DECL obj_t BGl_sslzd2connectionzd2getzd2negotiatedzd2protocolz00zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt);
static obj_t BGl_z62sslzd2socketzf3z43zz__ssl_sslz00(obj_t, obj_t);
static BgL_sslzd2signzd2_bglt BGl_z62lambda2150z62zz__ssl_sslz00(obj_t);
static obj_t BGl_z62dhzd2generatezd2paramete1309z62zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t);
extern int bgl_ssl_connection_load_session(BgL_sslzd2connectionzd2_bglt, obj_t);
BGL_IMPORT obj_t BGl_dssslzd2getzd2keyzd2argzd2zz__dssslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62sslzd2connectionzd2getzd2p1299zb0zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32079ze3ze5zz__ssl_sslz00(obj_t, obj_t);
extern bool_t bgl_ssl_ctx_add_root_certs(BgL_securezd2contextzd2_bglt);
static obj_t BGl_z62lambda2157z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda2158z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62evpzd2getzd2ciphersz62zz__ssl_sslz00(obj_t);
BGL_IMPORT bool_t BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(obj_t);
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__ssl_sslz00();
static obj_t BGl_z62securezd2contextzd2setzd2optionsz12za2zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2164z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda2165z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_sslzd2hmaczd2initz00zz__ssl_sslz00(BgL_sslzd2hmaczd2_bglt, obj_t, obj_t);
static obj_t BGl_z62securezd2contextzd2addzd2crlz12za2zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_sslzd2verifyzd2updatez12z12zz__ssl_sslz00(BgL_sslzd2verifyzd2_bglt, obj_t, long, long);
static BgL_sslzd2verifyzd2_bglt BGl_z62lambda2172z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static BgL_sslzd2verifyzd2_bglt BGl_z62lambda2174z62zz__ssl_sslz00(obj_t);
extern obj_t bgl_ssl_connection_get_current_cipher(BgL_sslzd2connectionzd2_bglt);
static obj_t BGl_z62sslzd2connectionzd2clear1279z62zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62makezd2sslzd2serverzd2socketzb0zz__ssl_sslz00(obj_t, obj_t);
extern void * bgl_bn_bin2bn(char *, int);
extern char * bgl_ssl_version();
static obj_t BGl_search1213ze70ze7zz__ssl_sslz00(long, obj_t, obj_t, long);
static obj_t BGl_z62sslzd2cipherzd2initiv1345z62zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern long bgl_ssl_connection_clear_out(BgL_sslzd2connectionzd2_bglt, char *, long, long);
static obj_t BGl_z62lambda2181z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda2182z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62sslzd2connectionzd2clear1281z62zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32098ze3ze5zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda2188z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62sslzd2connectionzd2clear1287z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda2189z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t void_star_to_obj(void *);
static obj_t BGl_z62zc3z04anonymousza31920ze3ze5zz__ssl_sslz00(obj_t);
static obj_t BGl_z62sslzd2cipherzd2finalz62zz__ssl_sslz00(obj_t, obj_t);
static BgL_sslzd2cipherzd2_bglt BGl_z62lambda2196z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static BgL_sslzd2cipherzd2_bglt BGl_z62lambda2198z62zz__ssl_sslz00(obj_t);
BGL_EXPORTED_DECL bool_t BGl_sslzd2connectionzd2reusedzf3zf3zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt);
BGL_EXPORTED_DECL obj_t BGl_sslzd2hmaczd2digestz00zz__ssl_sslz00(BgL_sslzd2hmaczd2_bglt);
static obj_t BGl_z62certificatezd2subjectzb0zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1801z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1802z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31906ze3ze5zz__ssl_sslz00(obj_t);
extern obj_t bgl_ssl_connection_get_session(BgL_sslzd2connectionzd2_bglt);
BGL_IMPORT obj_t blit_string(obj_t, long, obj_t, long, long);
static obj_t BGl_z62zc3z04anonymousza31817ze3ze5zz__ssl_sslz00(obj_t);
static obj_t BGl_z62lambda1808z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1809z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62sslzd2hashzd2initz62zz__ssl_sslz00(obj_t, obj_t);
BGL_EXPORTED_DECL bool_t BGl_securezd2contextzd2setzd2sessionzd2idzd2contextz12zc0zz__ssl_sslz00(BgL_securezd2contextzd2_bglt, obj_t, long, long);
extern int bgl_ssl_connection_start(BgL_sslzd2connectionzd2_bglt);
static obj_t BGl_z62lambda1815z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1816z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_sslzd2hashzd2zz__ssl_sslz00 = BUNSPEC;
static obj_t BGl_z62sslzd2connectionzd2enczd2p1285zb0zz__ssl_sslz00(obj_t, obj_t);
BGL_EXPORTED_DECL bool_t BGl_securezd2contextzd2setzd2certz12zc0zz__ssl_sslz00(BgL_securezd2contextzd2_bglt, obj_t, long, long);
extern bool_t bgl_ssl_verify_final(BgL_sslzd2verifyzd2_bglt, obj_t, long, long, obj_t, long, long);
static obj_t BGl_z62zc3z04anonymousza31835ze3ze5zz__ssl_sslz00(obj_t);
static BgL_sslzd2connectionzd2_bglt BGl_z62lambda1823z62zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_sslzd2connectionzd2clearzd2pendingzd2zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt);
static BgL_sslzd2connectionzd2_bglt BGl_z62lambda1826z62zz__ssl_sslz00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_certificatezd2issuerzd2zz__ssl_sslz00(BgL_certificatez00_bglt);
BGL_EXPORTED_DECL obj_t BGl_sslzd2connectionzd2loadzd2sessionzd2zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt, obj_t);
static obj_t BGl_z62zc3z04anonymousza31941ze3ze5zz__ssl_sslz00(obj_t);
static obj_t BGl_z62lambda1833z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1834z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
extern bool_t bgl_ssl_verify_init(BgL_sslzd2verifyzd2_bglt, obj_t);
static obj_t BGl_z62zc3z04anonymousza31780ze3ze5zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1840z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1841z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_sslzd2randzd2bytesz00zz__ssl_sslz00(int);
BGL_EXPORTED_DECL bool_t BGl_dhzd2generatezd2keyz00zz__ssl_sslz00(BgL_dhz00_bglt);
static obj_t BGl_z62lambda1847z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1848z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62sslzd2connectionzd2shutdownz62zz__ssl_sslz00(obj_t, obj_t);
extern bool_t bgl_ssl_cipher_initiv(BgL_sslzd2cipherzd2_bglt, obj_t, obj_t, long, long, obj_t, long, long, bool_t);
extern obj_t bgl_ssl_ctx_init(BgL_securezd2contextzd2_bglt);
static obj_t BGl_z62securezd2contextzd2closez62zz__ssl_sslz00(obj_t, obj_t);
extern obj_t bgl_ssl_load_private_key(obj_t);
static obj_t BGl_z62bnzd2numzd2bytesz62zz__ssl_sslz00(obj_t, obj_t);
extern obj_t bgl_dh_check_pub_key(void *, void *);
BGL_EXPORTED_DECL bool_t BGl_sslzd2randzd2pollz00zz__ssl_sslz00();
static obj_t BGl_z62sslzd2connectionzd2reuse1301z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62sslzd2cipherzd2init1343z62zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62securezd2contextzd2loadzd2pkcs12zb0zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_sslzd2signzd2signz00zz__ssl_sslz00(BgL_sslzd2signzd2_bglt, obj_t, long, long);
static obj_t BGl_z62dhzd2generatezd2parameterszd2exzb0zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31765ze3ze5zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31927ze3ze5zz__ssl_sslz00(obj_t);
extern int bgl_ssl_connection_close(BgL_sslzd2connectionzd2_bglt);
static obj_t BGl_z62lambda1854z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1855z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_bnzd2freezd2zz__ssl_sslz00(obj_t);
static obj_t BGl_z62sslzd2connectionzd2getzd2c1293zb0zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32003ze3ze5zz__ssl_sslz00(obj_t, obj_t);
BGL_EXPORTED_DECL bool_t BGl_securezd2contextzd2setzd2ciphersz12zc0zz__ssl_sslz00(BgL_securezd2contextzd2_bglt, obj_t);
static obj_t BGl_z62sslzd2connectionzd2getzd2s1291zb0zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zz__ssl_sslz00 = BUNSPEC;
static BgL_securezd2contextzd2_bglt BGl_z62lambda1860z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1861z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1865z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1866z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_securezd2contextzd2closez00zz__ssl_sslz00(BgL_securezd2contextzd2_bglt);
static obj_t BGl_z62sslzd2cipherzd2setzd2autozd21349z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32004ze3ze5zz__ssl_sslz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_sslzd2signzd2zz__ssl_sslz00 = BUNSPEC;
extern bool_t bgl_ssl_ctx_set_cert(BgL_securezd2contextzd2_bglt, obj_t, long, long);
static obj_t BGl_z62sslzd2hashzd2digestz62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31856ze3ze5zz__ssl_sslz00(obj_t);
static obj_t BGl_z62lambda1871z62zz__ssl_sslz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_sslzd2hmaczd2zz__ssl_sslz00 = BUNSPEC;
static obj_t BGl_z62lambda1872z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62sslzd2hashzd2updatez12z70zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_sslzd2getzd2ciphersz00zz__ssl_sslz00();
static obj_t BGl_z62lambda1878z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1879z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_certificatezd2subjectzd2zz__ssl_sslz00(BgL_certificatez00_bglt);
BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31873ze3ze5zz__ssl_sslz00(obj_t);
static obj_t BGl_z62lambda1884z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1885z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
extern bool_t bgl_ssl_cipher_init(BgL_sslzd2cipherzd2_bglt, obj_t, obj_t, long, long, bool_t);
static obj_t BGl_z62zc3z04anonymousza32200ze3ze5zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62sslzd2connectionzd2reusedzf3z91zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_toplevelzd2initzd2zz__ssl_sslz00();
static obj_t BGl_z62sslzd2connectionzd2verifyzd2errorzb0zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62dhzd2initzb0zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1890z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31696ze3ze5zz__ssl_sslz00(obj_t, obj_t);
extern obj_t bgl_evp_get_ciphers();
static obj_t BGl_z62lambda1891z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_sslzd2cipherzd2initivz00zz__ssl_sslz00(BgL_sslzd2cipherzd2_bglt, obj_t, obj_t, long, long, obj_t, long, long, bool_t);
BGL_EXPORTED_DECL obj_t BGl_sslzd2clearzd2errorz00zz__ssl_sslz00();
static obj_t BGl_z62sslzd2connectionzd2setzd2sessionzb0zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62sslzd2signzd2init1331z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1897z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1898z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32112ze3ze5zz__ssl_sslz00(obj_t);
BGL_IMPORT obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
static obj_t BGl_search1228ze70ze7zz__ssl_sslz00(long, obj_t, obj_t, long);
static obj_t BGl_z62zc3z04anonymousza31980ze3ze5zz__ssl_sslz00(obj_t);
static obj_t BGl_z62sslzd2connectionzd2write1277z62zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_genericzd2initzd2zz__ssl_sslz00();
static obj_t BGl_z62sslzd2connectionzd2getzd2n1303zb0zz__ssl_sslz00(obj_t, obj_t);
extern bool_t bgl_ssl_ctx_add_crl(BgL_securezd2contextzd2_bglt, obj_t, long, long);
BGL_EXPORTED_DECL char * BGl_sslzd2versionzd2zz__ssl_sslz00();
static obj_t BGl_z62sslzd2connectionzd2init1267z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32024ze3ze5zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32008ze3ze5zz__ssl_sslz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t, bool_t, bool_t, obj_t, obj_t, obj_t);
extern void * bgl_dh_public_key(void *);
static obj_t BGl_z62securezd2contextzd2addzd2rootzd2certsz12z70zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62sslzd2connectionzd2initz62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31892ze3ze5zz__ssl_sslz00(obj_t);
static obj_t BGl_z62sslzd2connectionzd2readz62zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL bool_t BGl_securezd2contextzd2setzd2keyz12zc0zz__ssl_sslz00(BgL_securezd2contextzd2_bglt, obj_t, long, long, obj_t);
static obj_t BGl_z62zc3z04anonymousza32009ze3ze5zz__ssl_sslz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_readzd2pemzd2filez00zz__ssl_sslz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31966ze3ze5zz__ssl_sslz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32042ze3ze5zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62sslzd2randzd2statusz62zz__ssl_sslz00(obj_t);
static obj_t BGl_z62sslzd2connectionzd2initzd2finishedzf3z43zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62sslzd2connectionzd2clearzd2outzb0zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
extern void * bgl_dh_private_key(void *);
static obj_t BGl_z62dhzd2siza7ez17zz__ssl_sslz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_sslzd2signzd2updatez12z12zz__ssl_sslz00(BgL_sslzd2signzd2_bglt, obj_t, long, long);
BGL_EXPORTED_DECL obj_t BGl_sslzd2connectionzd2enczd2pendingzd2zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt);
BGL_EXPORTED_DECL obj_t BGl_sslzd2hmaczd2updatez12z12zz__ssl_sslz00(BgL_sslzd2hmaczd2_bglt, obj_t, long, long);
static obj_t BGl_z62zc3z04anonymousza32028ze3ze5zz__ssl_sslz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL bool_t BGl_bnzd2setzd2wordz00zz__ssl_sslz00(obj_t, int);
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
extern obj_t bgl_dh_check(void *);
static obj_t BGl_z62sslzd2hmaczd2initz62zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t);
extern bool_t bgl_ssl_hash_init(BgL_sslzd2hashzd2_bglt);
static obj_t BGl_z62zc3z04anonymousza32134ze3ze5zz__ssl_sslz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32207ze3ze5zz__ssl_sslz00(obj_t);
static obj_t BGl_z62dhzd2computezd2keyz62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62sslzd2hmaczd2init1325z62zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62bnzd2newzb0zz__ssl_sslz00(obj_t);
BGL_EXPORTED_DECL bool_t BGl_securezd2contextzd2addzd2rootzd2certsz12z12zz__ssl_sslz00(BgL_securezd2contextzd2_bglt);
extern obj_t bgl_ssl_certificate_issuer(obj_t);
static obj_t BGl_z62sslzd2connectionzd2getzd2sessionzb0zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62sslzd2hmaczd2digest1329z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31987ze3ze5zz__ssl_sslz00(obj_t);
BGL_IMPORT obj_t BGl_dssslzd2getzd2keyzd2restzd2argz00zz__dssslz00(obj_t, obj_t);
extern void bgl_dh_pub_priv_key_set(void *, void *, void *);
static obj_t BGl_z62zc3z04anonymousza32152ze3ze5zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62sslzd2connectionzd2startz62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31899ze3ze5zz__ssl_sslz00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_sslzd2connectionzd2getzd2peerzd2certificatez00zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt);
static obj_t BGl_z62sslzd2versionzb0zz__ssl_sslz00(obj_t);
BGL_EXPORTED_DECL bool_t BGl_securezd2contextzd2setzd2optionsz12zc0zz__ssl_sslz00(BgL_securezd2contextzd2_bglt, int);
BGL_EXPORTED_DECL obj_t BGl_sslzd2connectionzd2initz00zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt);
static obj_t BGl_z62sslzd2verifyzd2finalz62zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_sslzd2signzd2initz00zz__ssl_sslz00(BgL_sslzd2signzd2_bglt, obj_t);
static BgL_certificatez00_bglt BGl_z62readzd2certificatezb0zz__ssl_sslz00(obj_t, obj_t);
extern obj_t bgl_ssl_connection_get_negotiated_protocol(BgL_sslzd2connectionzd2_bglt);
BGL_EXPORTED_DECL obj_t BGl_sslzd2connectionzd2readz00zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt, obj_t, long, long);
extern obj_t bgl_ssl_connection_shutdown(BgL_sslzd2connectionzd2_bglt);
BGL_EXPORTED_DECL obj_t BGl_evpzd2getzd2hashesz00zz__ssl_sslz00();
BGL_EXPORTED_DECL int BGl_sslzd2connectionzd2startz00zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt);
static obj_t BGl_z62securezd2contextzd2init1239z62zz__ssl_sslz00(obj_t, obj_t);
extern obj_t bgl_cipher_update(BgL_sslzd2cipherzd2_bglt, obj_t, long, long);
BGL_EXPORTED_DEF obj_t BGl_sslzd2verifyzd2zz__ssl_sslz00 = BUNSPEC;
BGL_IMPORT obj_t BGl_callzd2virtualzd2setterz00zz__objectz00(BgL_objectz00_bglt, int, obj_t);
BGL_EXPORTED_DECL obj_t BGl_sslzd2verifyzd2initz00zz__ssl_sslz00(BgL_sslzd2verifyzd2_bglt, obj_t);
BGL_IMPORT bool_t BGl_pairzd2orzd2nullzf3zf3zz__r4_pairs_and_lists_6_3z00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_sslzd2connectionzd2clearzd2inzd2zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt, obj_t, long, long);
static obj_t BGl_z62zc3z04anonymousza32066ze3ze5zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62dhzd2checkzd2pubzd2keyzb0zz__ssl_sslz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2constructorzd2zz__objectz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32083ze3ze5zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62z52privatezd2keyzd2z42nativez72zz__ssl_sslz00(obj_t, obj_t);
extern obj_t bgl_ssl_hash_digest(BgL_sslzd2hashzd2_bglt);
extern obj_t bgl_ssl_connection_init(BgL_sslzd2connectionzd2_bglt);
static obj_t BGl_z62sslzd2connectionzd2closez62zz__ssl_sslz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_applyz00zz__r4_control_features_6_9z00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_clientzd2socketzd2usezd2sslz12zc0zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2205z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62sslzd2signzd2updatez121333z70zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2206z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62bnzd2setzd2wordz62zz__ssl_sslz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__ssl_sslz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__socketz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__dssslz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
static obj_t BGl_z62securezd2contextzd2setzd2k1249zb0zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_callzd2virtualzd2getterz00zz__objectz00(BgL_objectz00_bglt, int);
static obj_t BGl_z62lambda2212z62zz__ssl_sslz00(obj_t, obj_t);
BGL_EXPORTED_DECL void * bgl_private_key_native(obj_t);
extern obj_t bgl_ssl_connection_verify_error(BgL_sslzd2connectionzd2_bglt);
static obj_t BGl_z62zc3z04anonymousza32190ze3ze5zz__ssl_sslz00(obj_t);
static obj_t BGl_z62lambda2213z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_sslzd2cipherzd2finalz00zz__ssl_sslz00(BgL_sslzd2cipherzd2_bglt);
BGL_EXPORTED_DECL int BGl_sslzd2connectionzd2closez00zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt);
static obj_t BGl_z62securezd2contextzd2setzd2certz12za2zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62dhzd2init1305zb0zz__ssl_sslz00(obj_t, obj_t);
static BgL_privatezd2keyzd2_bglt BGl_z62readzd2privatezd2keyz62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62securezd2contextzd2addzd2cazd2certz12z70zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62dhzd2check1311zb0zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62sslzd2randzd2pollz62zz__ssl_sslz00(obj_t);
BGL_IMPORT obj_t BGl_z52socketzd2initz12z92zz__socketz00();
static obj_t BGl_z62sslzd2signzd2signz62zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32159ze3ze5zz__ssl_sslz00(obj_t);
extern obj_t bgl_ssl_load_certificate(obj_t);
BGL_EXPORTED_DECL obj_t BGl_sslzd2cipherzd2initz00zz__ssl_sslz00(BgL_sslzd2cipherzd2_bglt, obj_t, obj_t, long, long, bool_t);
static obj_t BGl_sslzd2protocolszd2ze3integerze3zz__ssl_sslz00(obj_t);
extern obj_t bgl_ssl_certificate_subject(obj_t);
BGL_EXPORTED_DECL obj_t BGl_sslzd2connectionzd2initzd2finishedzf3z21zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt);
static obj_t BGl_z62zc3z04anonymousza31803ze3ze5zz__ssl_sslz00(obj_t);
extern obj_t bgl_client_socket_use_ssl(obj_t, int, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32176ze3ze5zz__ssl_sslz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_evpzd2getzd2ciphersz00zz__ssl_sslz00();
extern bool_t bgl_ssl_ctx_set_session_id_context(BgL_securezd2contextzd2_bglt, obj_t, long, long);
static obj_t BGl_cnstzd2initzd2zz__ssl_sslz00();
static obj_t BGl_z62z52makezd2certificateze2zz__ssl_sslz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_getzd2portzd2bufferz00zz__r4_ports_6_10_1z00(obj_t, obj_t, int);
static obj_t BGl_libraryzd2moduleszd2initz00zz__ssl_sslz00();
extern long bgl_ssl_connection_read(BgL_sslzd2connectionzd2_bglt, char *, long, long);
BGL_EXPORTED_DEF obj_t BGl_sslzd2cipherzd2zz__ssl_sslz00 = BUNSPEC;
static obj_t BGl_z62securezd2contextzd2addzd2r1243zb0zz__ssl_sslz00(obj_t, obj_t);
extern obj_t bgl_ssl_ctx_close(BgL_securezd2contextzd2_bglt);
static BgL_sslzd2hashzd2_bglt BGl_z62lambda2093z62zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_objectz00zz__objectz00;
static BgL_sslzd2hashzd2_bglt BGl_z62lambda2096z62zz__ssl_sslz00(obj_t);
static obj_t BGl_z62dhzd2computezd2key1315z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62sslzd2connectionzd2loadzd21295zb0zz__ssl_sslz00(obj_t, obj_t, obj_t);
extern obj_t bgl_evp_get_hashes();
static obj_t BGl__securezd2contextzd2setzd2keyz12zc0zz__ssl_sslz00(obj_t, obj_t);
extern bool_t bgl_ssl_verify_update(BgL_sslzd2verifyzd2_bglt, obj_t, long, long);
extern bool_t bgl_ssl_connection_init_finishedp(BgL_sslzd2connectionzd2_bglt);
extern long bgl_ssl_connection_write(BgL_sslzd2connectionzd2_bglt, char *, long, long);
static obj_t BGl_z62sslzd2connectionzd2initzd21283zb0zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62sslzd2cipherzd2setzd2autozd2paddingz62zz__ssl_sslz00(obj_t, obj_t, obj_t);
extern obj_t bgl_make_ssl_client_socket(obj_t, int, int, int, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL int BGl_dhzd2siza7ez75zz__ssl_sslz00(BgL_dhz00_bglt);
BGL_EXPORTED_DEF obj_t BGl_securezd2contextzd2zz__ssl_sslz00 = BUNSPEC;
static obj_t BGl_z62sslzd2verifyzd2final1341z62zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62sslzd2randzd2bytesz62zz__ssl_sslz00(obj_t, obj_t);
extern bool_t bgl_ssl_hmac_init(BgL_sslzd2hmaczd2_bglt, obj_t, obj_t);
static obj_t BGl_z62sslzd2connectionzd2close1271z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62securezd2contextzd2addzd2c1245zb0zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31913ze3ze5zz__ssl_sslz00(obj_t);
static obj_t BGl_z62securezd2contextzd2addzd2c1247zb0zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT long default_io_bufsiz;
extern int bgl_ssl_connection_clear_pending(BgL_sslzd2connectionzd2_bglt);
static obj_t BGl_z62z52makezd2privatezd2keyz30zz__ssl_sslz00(obj_t, obj_t);
extern int bgl_ssl_connection_enc_pending(BgL_sslzd2connectionzd2_bglt);
static obj_t BGl_z62sslzd2hmaczd2digestz62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62sslzd2verifyzd2updatez121339z70zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62dhzd2checkzb0zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62readzd2pemzd2filez62zz__ssl_sslz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_mapz00zz__r4_control_features_6_9z00(obj_t, obj_t);
static obj_t BGl_z62z52certificatezd2z42nativeza0zz__ssl_sslz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_sslzd2connectionzd2verifyzd2errorzd2zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt);
BGL_EXPORTED_DEF obj_t BGl_dhz00zz__ssl_sslz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31842ze3ze5zz__ssl_sslz00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_sslzd2hashzd2updatez12z12zz__ssl_sslz00(BgL_sslzd2hashzd2_bglt, obj_t, long, long);
BGL_EXPORTED_DECL obj_t BGl_sslzd2connectionzd2getzd2currentzd2cipherz00zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt);
BGL_EXPORTED_DECL obj_t BGl_makezd2sslzd2clientzd2socketzd2zz__ssl_sslz00(obj_t, int, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern void * bgl_dh_g(void *);
extern void * bgl_dh_p(void *);
extern void * bgl_dh_p(void *);
static obj_t BGl_z62lambda1904z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1905z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL void * bgl_certificate_native(obj_t);
static obj_t BGl_z62sslzd2cipherzd2final1351z62zz__ssl_sslz00(obj_t, obj_t);
BGL_EXPORTED_DECL bool_t BGl_securezd2contextzd2loadzd2pkcs12zd2zz__ssl_sslz00(BgL_securezd2contextzd2_bglt, obj_t, obj_t);
static obj_t BGl_z62lambda1911z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1912z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31828ze3ze5zz__ssl_sslz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_stringzd2downcasezd2zz__r4_strings_6_7z00(obj_t);
static obj_t BGl_z62lambda1918z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1919z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
extern bool_t bgl_ssl_sign_update(BgL_sslzd2signzd2_bglt, obj_t, long, long);
extern bool_t bgl_ssl_socketp(obj_t);
extern bool_t bgl_ssl_hmac_update(BgL_sslzd2hmaczd2_bglt, obj_t, long, long);
static obj_t BGl_z62sslzd2connectionzd2getzd2negotiatedzd2protocolz62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31934ze3ze5zz__ssl_sslz00(obj_t);
static BgL_certificatez00_bglt BGl_z62lambda1761z62zz__ssl_sslz00(obj_t, obj_t);
static BgL_certificatez00_bglt BGl_z62lambda1763z62zz__ssl_sslz00(obj_t);
static obj_t BGl_z62lambda1925z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1926z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t __cnst[ 91 ] ;


DEFINE_EXPORT_BGL_GENERIC( BGl_dhzd2checkzd2envz00zz__ssl_sslz00, BgL_bgl_za762dhza7d2checkza7b03756za7, BGl_z62dhzd2checkzb0zz__ssl_sslz00, 0L, BUNSPEC, 1 );
BGL_IMPORT obj_t BGl_listzd2envzd2zz__r4_pairs_and_lists_6_3z00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_certificatezd2subjectzd2envz00zz__ssl_sslz00, BgL_bgl_za762certificateza7d3757z00, BGl_z62certificatezd2subjectzb0zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_sslzd2opzd2cipherzd2serverzd2preferencezd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2opza7d2ci3758za7, BGl_z62sslzd2opzd2cipherzd2serverzd2preferencez62zz__ssl_sslz00, 0L, BUNSPEC, 0 );
BGL_IMPORT obj_t BGl_stringzd2appendzd2envz00zz__r4_strings_6_7z00;
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2connectionzd2reusedzf3zd2envz21zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect3759z00, BGl_z62sslzd2connectionzd2reusedzf3z91zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2connectionzd2setzd2sessionzd2envz00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect3760z00, BGl_z62sslzd2connectionzd2setzd2sessionzb0zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2connectionzd2writezd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect3761z00, BGl_z62sslzd2connectionzd2writez62zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_STRING( BGl_string3400z00zz__ssl_sslz00, BgL_bgl_string3400za700za7za7_3762za7, "&bn-set-word", 12 );
DEFINE_STRING( BGl_string3401z00zz__ssl_sslz00, BgL_bgl_string3401za700za7za7_3763za7, "&pkcs5-pbkdf2-hmac-sha1", 23 );
DEFINE_STATIC_BGL_GENERIC( BGl_dhzd2initzd2envz00zz__ssl_sslz00, BgL_bgl_za762dhza7d2initza7b0za73764z00, BGl_z62dhzd2initzb0zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_securezd2contextzd2addzd2rootzd2certsz12zd2envzc0zz__ssl_sslz00, BgL_bgl_za762secureza7d2cont3765z00, BGl_z62securezd2contextzd2addzd2rootzd2certsz12z70zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_sslzd2socketzf3zd2envzf3zz__ssl_sslz00, BgL_bgl_za762sslza7d2socketza73766za7, BGl_z62sslzd2socketzf3z43zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_makezd2sslzd2serverzd2socketzd2envz00zz__ssl_sslz00, BgL_bgl_za762makeza7d2sslza7d23767za7, va_generic_entry, BGl_z62makezd2sslzd2serverzd2socketzb0zz__ssl_sslz00, BUNSPEC, -1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2verifyzd2updatez12zd2envzc0zz__ssl_sslz00, BgL_bgl_za762sslza7d2verifyza73768za7, BGl_z62sslzd2verifyzd2updatez12z70zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3500z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo3769za7, BGl_z62zc3z04anonymousza32013ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3501z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo3770za7, BGl_z62zc3z04anonymousza32019ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3502z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo3771za7, BGl_z62zc3z04anonymousza32018ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3503z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo3772za7, BGl_z62zc3z04anonymousza32024ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3504z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo3773za7, BGl_z62zc3z04anonymousza32028ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3505z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo3774za7, BGl_z62zc3z04anonymousza32038ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3506z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo3775za7, BGl_z62zc3z04anonymousza32042ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3507z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo3776za7, BGl_z62zc3z04anonymousza32052ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3508z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo3777za7, BGl_z62zc3z04anonymousza32056ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52privatezd2keyzd2z42nativezd2envzc2zz__ssl_sslz00, BgL_bgl_za762za752privateza7d23778za7, BGl_z62z52privatezd2keyzd2z42nativez72zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3509z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo3779za7, BGl_z62zc3z04anonymousza32066ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3510z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo3780za7, BGl_z62zc3z04anonymousza32070ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3511z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo3781za7, BGl_z62zc3z04anonymousza32079ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3512z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo3782za7, BGl_z62zc3z04anonymousza32083ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3600z00zz__ssl_sslz00, BgL_bgl_string3600za700za7za7_3783za7, "ssl-connection-clear1279", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3513z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo3784za7, BGl_z62zc3z04anonymousza31952ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3514z00zz__ssl_sslz00, BgL_bgl_za762lambda1950za7623785z00, BGl_z62lambda1950z62zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3602z00zz__ssl_sslz00, BgL_bgl_string3602za700za7za7_3786za7, "ssl-connection-clear1281", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3515z00zz__ssl_sslz00, BgL_bgl_za762lambda1947za7623787z00, BGl_z62lambda1947z62zz__ssl_sslz00, 0L, BUNSPEC, 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3516z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo3788za7, BGl_z62zc3z04anonymousza32105ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3604z00zz__ssl_sslz00, BgL_bgl_string3604za700za7za7_3789za7, "ssl-connection-init-1283", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3517z00zz__ssl_sslz00, BgL_bgl_za762lambda2104za7623790z00, BGl_z62lambda2104z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3518z00zz__ssl_sslz00, BgL_bgl_za762lambda2103za7623791z00, BGl_z62lambda2103z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3606z00zz__ssl_sslz00, BgL_bgl_string3606za700za7za7_3792za7, "ssl-connection-enc-p1285", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3519z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo3793za7, BGl_z62zc3z04anonymousza32112ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3608z00zz__ssl_sslz00, BgL_bgl_string3608za700za7za7_3794za7, "ssl-connection-clear1287", 24 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_bnzd2bin2bnzd2envz00zz__ssl_sslz00, BgL_bgl_za762bnza7d2bin2bnza7b3795za7, BGl_z62bnzd2bin2bnzb0zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3520z00zz__ssl_sslz00, BgL_bgl_za762lambda2111za7623796z00, BGl_z62lambda2111z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3521z00zz__ssl_sslz00, BgL_bgl_za762lambda2110za7623797z00, BGl_z62lambda2110z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3522z00zz__ssl_sslz00, BgL_bgl_za762lambda2117za7623798z00, BGl_z62lambda2117z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3610z00zz__ssl_sslz00, BgL_bgl_string3610za700za7za7_3799za7, "ssl-connection-set-s1289", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3523z00zz__ssl_sslz00, BgL_bgl_za762lambda2116za7623800z00, BGl_z62lambda2116z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3524z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo3801za7, BGl_z62zc3z04anonymousza32098ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3612z00zz__ssl_sslz00, BgL_bgl_string3612za700za7za7_3802za7, "ssl-connection-get-s1291", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3525z00zz__ssl_sslz00, BgL_bgl_za762lambda2096za7623803z00, BGl_z62lambda2096z62zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3526z00zz__ssl_sslz00, BgL_bgl_za762lambda2093za7623804z00, BGl_z62lambda2093z62zz__ssl_sslz00, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string3614z00zz__ssl_sslz00, BgL_bgl_string3614za700za7za7_3805za7, "ssl-connection-get-c1293", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3527z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo3806za7, BGl_z62zc3z04anonymousza32134ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3528z00zz__ssl_sslz00, BgL_bgl_za762lambda2133za7623807z00, BGl_z62lambda2133z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3616z00zz__ssl_sslz00, BgL_bgl_string3616za700za7za7_3808za7, "ssl-connection-load-1295", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3529z00zz__ssl_sslz00, BgL_bgl_za762lambda2132za7623809z00, BGl_z62lambda2132z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3618z00zz__ssl_sslz00, BgL_bgl_string3618za700za7za7_3810za7, "ssl-connection-verif1297", 24 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2signzd2updatez12zd2envzc0zz__ssl_sslz00, BgL_bgl_za762sslza7d2signza7d23811za7, BGl_z62sslzd2signzd2updatez12z70zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3530z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo3812za7, BGl_z62zc3z04anonymousza32141ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3531z00zz__ssl_sslz00, BgL_bgl_za762lambda2140za7623813z00, BGl_z62lambda2140z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3532z00zz__ssl_sslz00, BgL_bgl_za762lambda2139za7623814z00, BGl_z62lambda2139z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3620z00zz__ssl_sslz00, BgL_bgl_string3620za700za7za7_3815za7, "ssl-connection-get-p1299", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3533z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo3816za7, BGl_z62zc3z04anonymousza32127ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3534z00zz__ssl_sslz00, BgL_bgl_za762lambda2125za7623817z00, BGl_z62lambda2125z62zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3622z00zz__ssl_sslz00, BgL_bgl_string3622za700za7za7_3818za7, "ssl-connection-reuse1301", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3535z00zz__ssl_sslz00, BgL_bgl_za762lambda2123za7623819z00, BGl_z62lambda2123z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3536z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo3820za7, BGl_z62zc3z04anonymousza32159ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_clientzd2socketzd2usezd2sslz12zd2envz12zz__ssl_sslz00, BgL_bgl__clientza7d2socket3821za7, opt_generic_entry, BGl__clientzd2socketzd2usezd2sslz12zc0zz__ssl_sslz00, BFALSE, -1 );
DEFINE_STRING( BGl_string3624z00zz__ssl_sslz00, BgL_bgl_string3624za700za7za7_3822za7, "ssl-connection-get-n1303", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3537z00zz__ssl_sslz00, BgL_bgl_za762lambda2158za7623823z00, BGl_z62lambda2158z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3375z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo3824za7, BGl_z62zc3z04anonymousza31696ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2connectionzd2initzd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect3825z00, BGl_z62sslzd2connectionzd2initz62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3538z00zz__ssl_sslz00, BgL_bgl_za762lambda2157za7623826z00, BGl_z62lambda2157z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3626z00zz__ssl_sslz00, BgL_bgl_string3626za700za7za7_3827za7, "dh-init1305", 11 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3539z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo3828za7, BGl_z62zc3z04anonymousza32166ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3628z00zz__ssl_sslz00, BgL_bgl_string3628za700za7za7_3829za7, "dh-size1307", 11 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2hmaczd2digestzd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2hmacza7d23830za7, BGl_z62sslzd2hmaczd2digestz62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3540z00zz__ssl_sslz00, BgL_bgl_za762lambda2165za7623831z00, BGl_z62lambda2165z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3541z00zz__ssl_sslz00, BgL_bgl_za762lambda2164za7623832z00, BGl_z62lambda2164z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3542z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo3833za7, BGl_z62zc3z04anonymousza32152ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3630z00zz__ssl_sslz00, BgL_bgl_string3630za700za7za7_3834za7, "dh-generate-paramete1309", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3543z00zz__ssl_sslz00, BgL_bgl_za762lambda2150za7623835z00, BGl_z62lambda2150z62zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3544z00zz__ssl_sslz00, BgL_bgl_za762lambda2148za7623836z00, BGl_z62lambda2148z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3632z00zz__ssl_sslz00, BgL_bgl_string3632za700za7za7_3837za7, "dh-check1311", 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3545z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo3838za7, BGl_z62zc3z04anonymousza32183ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3546z00zz__ssl_sslz00, BgL_bgl_za762lambda2182za7623839z00, BGl_z62lambda2182z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3634z00zz__ssl_sslz00, BgL_bgl_string3634za700za7za7_3840za7, "dh-check-pub-key1313", 20 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3547z00zz__ssl_sslz00, BgL_bgl_za762lambda2181za7623841z00, BGl_z62lambda2181z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3548z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo3842za7, BGl_z62zc3z04anonymousza32190ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3636z00zz__ssl_sslz00, BgL_bgl_string3636za700za7za7_3843za7, "dh-compute-key1315", 18 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3549z00zz__ssl_sslz00, BgL_bgl_za762lambda2189za7623844z00, BGl_z62lambda2189z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3638z00zz__ssl_sslz00, BgL_bgl_string3638za700za7za7_3845za7, "dh-generate-key1317", 19 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2connectionzd2shutdownzd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect3846z00, BGl_z62sslzd2connectionzd2shutdownz62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3550z00zz__ssl_sslz00, BgL_bgl_za762lambda2188za7623847z00, BGl_z62lambda2188z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3551z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo3848za7, BGl_z62zc3z04anonymousza32176ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3552z00zz__ssl_sslz00, BgL_bgl_za762lambda2174za7623849z00, BGl_z62lambda2174z62zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3640z00zz__ssl_sslz00, BgL_bgl_string3640za700za7za7_3850za7, "ssl-hash-init1319", 17 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3553z00zz__ssl_sslz00, BgL_bgl_za762lambda2172za7623851z00, BGl_z62lambda2172z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3554z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo3852za7, BGl_z62zc3z04anonymousza32207ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3642z00zz__ssl_sslz00, BgL_bgl_string3642za700za7za7_3853za7, "ssl-hash-update!1321", 20 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3555z00zz__ssl_sslz00, BgL_bgl_za762lambda2206za7623854z00, BGl_z62lambda2206z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3556z00zz__ssl_sslz00, BgL_bgl_za762lambda2205za7623855z00, BGl_z62lambda2205z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3644z00zz__ssl_sslz00, BgL_bgl_string3644za700za7za7_3856za7, "ssl-hash-digest1323", 19 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3557z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo3857za7, BGl_z62zc3z04anonymousza32214ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3558z00zz__ssl_sslz00, BgL_bgl_za762lambda2213za7623858z00, BGl_z62lambda2213z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3646z00zz__ssl_sslz00, BgL_bgl_string3646za700za7za7_3859za7, "ssl-hmac-init1325", 17 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3559z00zz__ssl_sslz00, BgL_bgl_za762lambda2212za7623860z00, BGl_z62lambda2212z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3648z00zz__ssl_sslz00, BgL_bgl_string3648za700za7za7_3861za7, "ssl-hmac-update!1327", 20 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3560z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo3862za7, BGl_z62zc3z04anonymousza32200ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3561z00zz__ssl_sslz00, BgL_bgl_za762lambda2198za7623863z00, BGl_z62lambda2198z62zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3562z00zz__ssl_sslz00, BgL_bgl_za762lambda2196za7623864z00, BGl_z62lambda2196z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3650z00zz__ssl_sslz00, BgL_bgl_string3650za700za7za7_3865za7, "ssl-hmac-digest1329", 19 );
DEFINE_STRING( BGl_string3652z00zz__ssl_sslz00, BgL_bgl_string3652za700za7za7_3866za7, "ssl-sign-init1331", 17 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3565z00zz__ssl_sslz00, BgL_bgl_za762secureza7d2cont3867z00, BGl_z62securezd2contextzd2init1239z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3654z00zz__ssl_sslz00, BgL_bgl_string3654za700za7za7_3868za7, "ssl-sign-update!1333", 20 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3567z00zz__ssl_sslz00, BgL_bgl_za762secureza7d2cont3869z00, BGl_z62securezd2contextzd2close1241z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3656z00zz__ssl_sslz00, BgL_bgl_string3656za700za7za7_3870za7, "ssl-sign-sign1335", 17 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3569z00zz__ssl_sslz00, BgL_bgl_za762secureza7d2cont3871z00, BGl_z62securezd2contextzd2addzd2r1243zb0zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2connectionzd2clearzd2pendingzd2envz00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect3872z00, BGl_z62sslzd2connectionzd2clearzd2pendingzb0zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3658z00zz__ssl_sslz00, BgL_bgl_string3658za700za7za7_3873za7, "ssl-verify-init1337", 19 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3571z00zz__ssl_sslz00, BgL_bgl_za762secureza7d2cont3874z00, BGl_z62securezd2contextzd2addzd2c1245zb0zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_STRING( BGl_string3660z00zz__ssl_sslz00, BgL_bgl_string3660za700za7za7_3875za7, "ssl-verify-update!1339", 22 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3573z00zz__ssl_sslz00, BgL_bgl_za762secureza7d2cont3876z00, BGl_z62securezd2contextzd2addzd2c1247zb0zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2signzd2initzd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2signza7d23877za7, BGl_z62sslzd2signzd2initz62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3662z00zz__ssl_sslz00, BgL_bgl_string3662za700za7za7_3878za7, "ssl-verify-final1341", 20 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3575z00zz__ssl_sslz00, BgL_bgl_za762secureza7d2cont3879z00, BGl_z62securezd2contextzd2setzd2k1249zb0zz__ssl_sslz00, 0L, BUNSPEC, 5 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_bnzd2setzd2wordzd2envzd2zz__ssl_sslz00, BgL_bgl_za762bnza7d2setza7d2wo3880za7, BGl_z62bnzd2setzd2wordz62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3664z00zz__ssl_sslz00, BgL_bgl_string3664za700za7za7_3881za7, "ssl-cipher-init1343", 19 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3577z00zz__ssl_sslz00, BgL_bgl_za762secureza7d2cont3882z00, BGl_z62securezd2contextzd2setzd2c1257zb0zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_STRING( BGl_string3666z00zz__ssl_sslz00, BgL_bgl_string3666za700za7za7_3883za7, "ssl-cipher-initiv1345", 21 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3579z00zz__ssl_sslz00, BgL_bgl_za762secureza7d2cont3884z00, BGl_z62securezd2contextzd2setzd2s1259zb0zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_STRING( BGl_string3668z00zz__ssl_sslz00, BgL_bgl_string3668za700za7za7_3885za7, "ssl-cipher-update!1347", 22 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_evpzd2getzd2hasheszd2envzd2zz__ssl_sslz00, BgL_bgl_za762evpza7d2getza7d2h3886za7, BGl_z62evpzd2getzd2hashesz62zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2connectionzd2clearzd2outzd2envz00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect3887z00, BGl_z62sslzd2connectionzd2clearzd2outzb0zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3581z00zz__ssl_sslz00, BgL_bgl_za762secureza7d2cont3888z00, BGl_z62securezd2contextzd2loadzd21261zb0zz__ssl_sslz00, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string3670z00zz__ssl_sslz00, BgL_bgl_string3670za700za7za7_3889za7, "ssl-cipher-set-auto-1349", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3583z00zz__ssl_sslz00, BgL_bgl_za762secureza7d2cont3890z00, BGl_z62securezd2contextzd2setzd2c1263zb0zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3672z00zz__ssl_sslz00, BgL_bgl_string3672za700za7za7_3891za7, "ssl-cipher-final1351", 20 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3585z00zz__ssl_sslz00, BgL_bgl_za762secureza7d2cont3892z00, BGl_z62securezd2contextzd2setzd2o1265zb0zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3673z00zz__ssl_sslz00, BgL_bgl_string3673za700za7za7_3893za7, "ssl-cipher-update!", 18 );
DEFINE_STRING( BGl_string3674z00zz__ssl_sslz00, BgL_bgl_string3674za700za7za7_3894za7, "cannot update", 13 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3587z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect3895z00, BGl_z62sslzd2connectionzd2init1267z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3675z00zz__ssl_sslz00, BgL_bgl_string3675za700za7za7_3896za7, "ssl-cipher-initiv", 17 );
DEFINE_STRING( BGl_string3676z00zz__ssl_sslz00, BgL_bgl_string3676za700za7za7_3897za7, "ssl-cipher-init", 15 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3589z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect3898z00, BGl_z62sslzd2connectionzd2start1269z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3677z00zz__ssl_sslz00, BgL_bgl_string3677za700za7za7_3899za7, "ssl-verify-update!", 18 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_bnzd2bn2binzd2envz00zz__ssl_sslz00, BgL_bgl_za762bnza7d2bn2binza7b3900za7, BGl_z62bnzd2bn2binzb0zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3678z00zz__ssl_sslz00, BgL_bgl_string3678za700za7za7_3901za7, "ssl-verify", 10 );
DEFINE_STRING( BGl_string3679z00zz__ssl_sslz00, BgL_bgl_string3679za700za7za7_3902za7, "Verify method not supported", 27 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2verifyzd2finalzd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2verifyza73903za7, BGl_z62sslzd2verifyzd2finalz62zz__ssl_sslz00, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3591z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect3904z00, BGl_z62sslzd2connectionzd2close1271z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3680z00zz__ssl_sslz00, BgL_bgl_string3680za700za7za7_3905za7, "ssl-sign-sign", 13 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3593z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect3906z00, BGl_z62sslzd2connectionzd2shutd1273z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3681z00zz__ssl_sslz00, BgL_bgl_string3681za700za7za7_3907za7, "cannot sign", 11 );
DEFINE_STRING( BGl_string3682z00zz__ssl_sslz00, BgL_bgl_string3682za700za7za7_3908za7, "ssl-sign-update!", 16 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3595z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect3909z00, BGl_z62sslzd2connectionzd2read1275z62zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_STRING( BGl_string3683z00zz__ssl_sslz00, BgL_bgl_string3683za700za7za7_3910za7, "ssl-sign", 8 );
DEFINE_STRING( BGl_string3684z00zz__ssl_sslz00, BgL_bgl_string3684za700za7za7_3911za7, "Sign method not supported", 25 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3597z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect3912z00, BGl_z62sslzd2connectionzd2write1277z62zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_STRING( BGl_string3685z00zz__ssl_sslz00, BgL_bgl_string3685za700za7za7_3913za7, "ssl-hmac-digest", 15 );
DEFINE_STRING( BGl_string3686z00zz__ssl_sslz00, BgL_bgl_string3686za700za7za7_3914za7, "cannot digest", 13 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3599z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect3915z00, BGl_z62sslzd2connectionzd2clear1279z62zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_STRING( BGl_string3687z00zz__ssl_sslz00, BgL_bgl_string3687za700za7za7_3916za7, "ssl-hmac-update!", 16 );
DEFINE_STRING( BGl_string3688z00zz__ssl_sslz00, BgL_bgl_string3688za700za7za7_3917za7, "ssl-hmac", 8 );
DEFINE_STRING( BGl_string3689z00zz__ssl_sslz00, BgL_bgl_string3689za700za7za7_3918za7, "Digest method not supported", 27 );
DEFINE_STRING( BGl_string3690z00zz__ssl_sslz00, BgL_bgl_string3690za700za7za7_3919za7, "ssl-hash-digest", 15 );
DEFINE_STRING( BGl_string3691z00zz__ssl_sslz00, BgL_bgl_string3691za700za7za7_3920za7, "ssl-hash-update!", 16 );
DEFINE_STRING( BGl_string3692z00zz__ssl_sslz00, BgL_bgl_string3692za700za7za7_3921za7, "ssl-hash", 8 );
DEFINE_STRING( BGl_string3693z00zz__ssl_sslz00, BgL_bgl_string3693za700za7za7_3922za7, "dh-generate-parameters-ex", 25 );
DEFINE_STRING( BGl_string3694z00zz__ssl_sslz00, BgL_bgl_string3694za700za7za7_3923za7, "Illegal generator", 17 );
DEFINE_STRING( BGl_string3695z00zz__ssl_sslz00, BgL_bgl_string3695za700za7za7_3924za7, "&secure-context-init", 20 );
DEFINE_STRING( BGl_string3696z00zz__ssl_sslz00, BgL_bgl_string3696za700za7za7_3925za7, "&secure-context-close", 21 );
DEFINE_STRING( BGl_string3697z00zz__ssl_sslz00, BgL_bgl_string3697za700za7za7_3926za7, "&secure-context-add-root-certs!", 31 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_readzd2privatezd2keyzd2envzd2zz__ssl_sslz00, BgL_bgl_za762readza7d2privat3927z00, BGl_z62readzd2privatezd2keyz62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3698z00zz__ssl_sslz00, BgL_bgl_string3698za700za7za7_3928za7, "&secure-context-add-ca-cert!", 28 );
DEFINE_STRING( BGl_string3699z00zz__ssl_sslz00, BgL_bgl_string3699za700za7za7_3929za7, "&secure-context-add-crl!", 24 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_pkcs5zd2pbkdf2zd2hmaczd2sha1zd2envz00zz__ssl_sslz00, BgL_bgl_za762pkcs5za7d2pbkdf3930z00, BGl_z62pkcs5zd2pbkdf2zd2hmaczd2sha1zb0zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2cipherzd2finalzd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2cipherza73931za7, BGl_z62sslzd2cipherzd2finalz62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_readzd2certificatezd2envz00zz__ssl_sslz00, BgL_bgl_za762readza7d2certif3932z00, BGl_z62readzd2certificatezb0zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_makezd2sslzd2clientzd2socketzd2envz00zz__ssl_sslz00, BgL_bgl__makeza7d2sslza7d2cl3933z00, opt_generic_entry, BGl__makezd2sslzd2clientzd2socketzd2zz__ssl_sslz00, BFALSE, -1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2connectionzd2enczd2pendingzd2envz00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect3934z00, BGl_z62sslzd2connectionzd2enczd2pendingzb0zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_sslzd2versionzd2envz00zz__ssl_sslz00, BgL_bgl_za762sslza7d2version3935z00, BGl_z62sslzd2versionzb0zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2cipherzd2updatez12zd2envzc0zz__ssl_sslz00, BgL_bgl_za762sslza7d2cipherza73936za7, BGl_z62sslzd2cipherzd2updatez12z70zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2hmaczd2initzd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2hmacza7d23937za7, BGl_z62sslzd2hmaczd2initz62zz__ssl_sslz00, 0L, BUNSPEC, 3 );
DEFINE_EXPORT_BGL_GENERIC( BGl_securezd2contextzd2initzd2envzd2zz__ssl_sslz00, BgL_bgl_za762secureza7d2cont3938z00, BGl_z62securezd2contextzd2initz62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2connectionzd2closezd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect3939z00, BGl_z62sslzd2connectionzd2closez62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_securezd2contextzd2addzd2cazd2certz12zd2envzc0zz__ssl_sslz00, BgL_bgl_za762secureza7d2cont3940z00, BGl_z62securezd2contextzd2addzd2cazd2certz12z70zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52certificatezd2z42nativezd2envz10zz__ssl_sslz00, BgL_bgl_za762za752certificat3941z00, BGl_z62z52certificatezd2z42nativeza0zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2connectionzd2getzd2sessionzd2envz00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect3942z00, BGl_z62sslzd2connectionzd2getzd2sessionzb0zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_securezd2contextzd2addzd2crlz12zd2envz12zz__ssl_sslz00, BgL_bgl_za762secureza7d2cont3943z00, BGl_z62securezd2contextzd2addzd2crlz12za2zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_sslzd2randzd2byteszd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2randza7d23944za7, BGl_z62sslzd2randzd2bytesz62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_sslzd2randzd2pollzd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2randza7d23945za7, BGl_z62sslzd2randzd2pollz62zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_GENERIC( BGl_dhzd2generatezd2parameterszd2exzd2envz00zz__ssl_sslz00, BgL_bgl_za762dhza7d2generate3946z00, BGl_z62dhzd2generatezd2parameterszd2exzb0zz__ssl_sslz00, 0L, BUNSPEC, 3 );
DEFINE_EXPORT_BGL_GENERIC( BGl_dhzd2computezd2keyzd2envzd2zz__ssl_sslz00, BgL_bgl_za762dhza7d2computeza73947za7, BGl_z62dhzd2computezd2keyz62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_evpzd2getzd2cipherszd2envzd2zz__ssl_sslz00, BgL_bgl_za762evpza7d2getza7d2c3948za7, BGl_z62evpzd2getzd2ciphersz62zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2connectionzd2getzd2peerzd2certificatezd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect3949z00, BGl_z62sslzd2connectionzd2getzd2peerzd2certificatez62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2hashzd2digestzd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2hashza7d23950za7, BGl_z62sslzd2hashzd2digestz62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2verifyzd2initzd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2verifyza73951za7, BGl_z62sslzd2verifyzd2initz62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2cipherzd2setzd2autozd2paddingzd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2cipherza73952za7, BGl_z62sslzd2cipherzd2setzd2autozd2paddingz62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2connectionzd2getzd2negotiatedzd2protocolzd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect3953z00, BGl_z62sslzd2connectionzd2getzd2negotiatedzd2protocolz62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_readzd2pemzd2filezd2envzd2zz__ssl_sslz00, BgL_bgl_za762readza7d2pemza7d23954za7, BGl_z62readzd2pemzd2filez62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_dhzd2generatezd2keyzd2envzd2zz__ssl_sslz00, BgL_bgl_za762dhza7d2generate3955z00, BGl_z62dhzd2generatezd2keyz62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3402z00zz__ssl_sslz00, BgL_bgl_za762lambda1770za7623956z00, BGl_z62lambda1770z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3403z00zz__ssl_sslz00, BgL_bgl_za762lambda1769za7623957z00, BGl_z62lambda1769z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3404z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo3958za7, BGl_z62zc3z04anonymousza31765ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3405z00zz__ssl_sslz00, BgL_bgl_za762lambda1763za7623959z00, BGl_z62lambda1763z62zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3406z00zz__ssl_sslz00, BgL_bgl_za762lambda1761za7623960z00, BGl_z62lambda1761z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3407z00zz__ssl_sslz00, BgL_bgl_za762lambda1785za7623961z00, BGl_z62lambda1785z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3408z00zz__ssl_sslz00, BgL_bgl_za762lambda1784za7623962z00, BGl_z62lambda1784z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3409z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo3963za7, BGl_z62zc3z04anonymousza31780ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_dhzd2siza7ezd2envza7zz__ssl_sslz00, BgL_bgl_za762dhza7d2siza7a7eza713964z00, BGl_z62dhzd2siza7ez17zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3410z00zz__ssl_sslz00, BgL_bgl_za762lambda1778za7623965z00, BGl_z62lambda1778z62zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3411z00zz__ssl_sslz00, BgL_bgl_za762lambda1776za7623966z00, BGl_z62lambda1776z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3412z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo3967za7, BGl_z62zc3z04anonymousza31803ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3413z00zz__ssl_sslz00, BgL_bgl_za762lambda1802za7623968z00, BGl_z62lambda1802z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3414z00zz__ssl_sslz00, BgL_bgl_za762lambda1801za7623969z00, BGl_z62lambda1801z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3415z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo3970za7, BGl_z62zc3z04anonymousza31810ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_certificatezd2issuerzd2envz00zz__ssl_sslz00, BgL_bgl_za762certificateza7d3971z00, BGl_z62certificatezd2issuerzb0zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3416z00zz__ssl_sslz00, BgL_bgl_za762lambda1809za7623972z00, BGl_z62lambda1809z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3417z00zz__ssl_sslz00, BgL_bgl_za762lambda1808za7623973z00, BGl_z62lambda1808z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3418z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo3974za7, BGl_z62zc3z04anonymousza31817ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3419z00zz__ssl_sslz00, BgL_bgl_za762lambda1816za7623975z00, BGl_z62lambda1816z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
BGL_IMPORT obj_t BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_sslzd2getzd2cipherszd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2getza7d2c3976za7, BGl_z62sslzd2getzd2ciphersz62zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3420z00zz__ssl_sslz00, BgL_bgl_za762lambda1815za7623977z00, BGl_z62lambda1815z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3421z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo3978za7, BGl_z62zc3z04anonymousza31796ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3422z00zz__ssl_sslz00, BgL_bgl_za762lambda1794za7623979z00, BGl_z62lambda1794z62zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_GENERIC( BGl_securezd2contextzd2setzd2keyz12zd2envz12zz__ssl_sslz00, BgL_bgl__secureza7d2contex3980za7, opt_generic_entry, BGl__securezd2contextzd2setzd2keyz12zc0zz__ssl_sslz00, BFALSE, -1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3423z00zz__ssl_sslz00, BgL_bgl_za762lambda1791za7623981z00, BGl_z62lambda1791z62zz__ssl_sslz00, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3424z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo3982za7, BGl_z62zc3z04anonymousza31835ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3425z00zz__ssl_sslz00, BgL_bgl_za762lambda1834za7623983z00, BGl_z62lambda1834z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3426z00zz__ssl_sslz00, BgL_bgl_za762lambda1833za7623984z00, BGl_z62lambda1833z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3427z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo3985za7, BGl_z62zc3z04anonymousza31842ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3428z00zz__ssl_sslz00, BgL_bgl_za762lambda1841za7623986z00, BGl_z62lambda1841z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3429z00zz__ssl_sslz00, BgL_bgl_za762lambda1840za7623987z00, BGl_z62lambda1840z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2connectionzd2clearzd2inzd2envz00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect3988z00, BGl_z62sslzd2connectionzd2clearzd2inzb0zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3430z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo3989za7, BGl_z62zc3z04anonymousza31849ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3431z00zz__ssl_sslz00, BgL_bgl_za762lambda1848za7623990z00, BGl_z62lambda1848z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3432z00zz__ssl_sslz00, BgL_bgl_za762lambda1847za7623991z00, BGl_z62lambda1847z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3433z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo3992za7, BGl_z62zc3z04anonymousza31856ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3434z00zz__ssl_sslz00, BgL_bgl_za762lambda1855za7623993z00, BGl_z62lambda1855z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3435z00zz__ssl_sslz00, BgL_bgl_za762lambda1854za7623994z00, BGl_z62lambda1854z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3360z00zz__ssl_sslz00, BgL_bgl_string3360za700za7za7_3995za7, "Invalid certificate", 19 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3436z00zz__ssl_sslz00, BgL_bgl_za762lambda1861za7623996z00, BGl_z62lambda1861z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3361z00zz__ssl_sslz00, BgL_bgl_string3361za700za7za7_3997za7, "Invalid private key", 19 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3437z00zz__ssl_sslz00, BgL_bgl_za762lambda1860za7623998z00, BGl_z62lambda1860z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3362z00zz__ssl_sslz00, BgL_bgl_string3362za700za7za7_3999za7, "Invalid CA list", 15 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3438z00zz__ssl_sslz00, BgL_bgl_za762lambda1866za7624000z00, BGl_z62lambda1866z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3363z00zz__ssl_sslz00, BgL_bgl_string3363za700za7za7_4001za7, "Invalid accepted-certs", 22 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3439z00zz__ssl_sslz00, BgL_bgl_za762lambda1865za7624002z00, BGl_z62lambda1865z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3364z00zz__ssl_sslz00, BgL_bgl_string3364za700za7za7_4003za7, "pkey and cert must be both #f or both set", 41 );
DEFINE_STRING( BGl_string3365z00zz__ssl_sslz00, BgL_bgl_string3365za700za7za7_4004za7, "Illegal keyword argument", 24 );
DEFINE_STRING( BGl_string3366z00zz__ssl_sslz00, BgL_bgl_string3366za700za7za7_4005za7, "/builddir/build/BUILD/bigloo-4.3h/api/ssl/src/Llib/ssl.scm", 58 );
DEFINE_STRING( BGl_string3367z00zz__ssl_sslz00, BgL_bgl_string3367za700za7za7_4006za7, "_make-ssl-client-socket", 23 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2hashzd2updatez12zd2envzc0zz__ssl_sslz00, BgL_bgl_za762sslza7d2hashza7d24007za7, BGl_z62sslzd2hashzd2updatez12z70zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2connectionzd2getzd2currentzd2cipherzd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4008z00, BGl_z62sslzd2connectionzd2getzd2currentzd2cipherz62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3368z00zz__ssl_sslz00, BgL_bgl_string3368za700za7za7_4009za7, "bint", 4 );
DEFINE_STRING( BGl_string3369z00zz__ssl_sslz00, BgL_bgl_string3369za700za7za7_4010za7, "bstring", 7 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2cipherzd2initivzd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2cipherza74011za7, BGl_z62sslzd2cipherzd2initivz62zz__ssl_sslz00, 0L, BUNSPEC, 9 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2connectionzd2initzd2finishedzf3zd2envzf3zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4012z00, BGl_z62sslzd2connectionzd2initzd2finishedzf3z43zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3601z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4013z00, BGl_z62sslzd2connectionzd2clear1281z62zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3440z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo4014za7, BGl_z62zc3z04anonymousza31873ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3603z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4015z00, BGl_z62sslzd2connectionzd2initzd21283zb0zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3441z00zz__ssl_sslz00, BgL_bgl_za762lambda1872za7624016z00, BGl_z62lambda1872z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3442z00zz__ssl_sslz00, BgL_bgl_za762lambda1871za7624017z00, BGl_z62lambda1871z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3605z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4018z00, BGl_z62sslzd2connectionzd2enczd2p1285zb0zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3443z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo4019za7, BGl_z62zc3z04anonymousza31880ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3444z00zz__ssl_sslz00, BgL_bgl_za762lambda1879za7624020z00, BGl_z62lambda1879z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3607z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4021z00, BGl_z62sslzd2connectionzd2clear1287z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3445z00zz__ssl_sslz00, BgL_bgl_za762lambda1878za7624022z00, BGl_z62lambda1878z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3370z00zz__ssl_sslz00, BgL_bgl_string3370za700za7za7_4023za7, "pair-nil", 8 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3446z00zz__ssl_sslz00, BgL_bgl_za762lambda1885za7624024z00, BGl_z62lambda1885z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3371z00zz__ssl_sslz00, BgL_bgl_string3371za700za7za7_4025za7, "wrong number of arguments: [2..10] expected, provided", 53 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3609z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4026z00, BGl_z62sslzd2connectionzd2setzd2s1289zb0zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3447z00zz__ssl_sslz00, BgL_bgl_za762lambda1884za7624027z00, BGl_z62lambda1884z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3372z00zz__ssl_sslz00, BgL_bgl_string3372za700za7za7_4028za7, "_client-socket-use-ssl!", 23 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3448z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo4029za7, BGl_z62zc3z04anonymousza31892ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3373z00zz__ssl_sslz00, BgL_bgl_string3373za700za7za7_4030za7, "socket", 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3449z00zz__ssl_sslz00, BgL_bgl_za762lambda1891za7624031z00, BGl_z62lambda1891z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3374z00zz__ssl_sslz00, BgL_bgl_string3374za700za7za7_4032za7, "wrong number of arguments: [1..6] expected, provided", 52 );
DEFINE_STRING( BGl_string3376z00zz__ssl_sslz00, BgL_bgl_string3376za700za7za7_4033za7, "Illegal extra key arguments: ", 29 );
DEFINE_STRING( BGl_string3377z00zz__ssl_sslz00, BgL_bgl_string3377za700za7za7_4034za7, "dsssl-get-key-arg", 17 );
DEFINE_STRING( BGl_string3378z00zz__ssl_sslz00, BgL_bgl_string3378za700za7za7_4035za7, "~a ", 3 );
DEFINE_STRING( BGl_string3379z00zz__ssl_sslz00, BgL_bgl_string3379za700za7za7_4036za7, "ssl", 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3611z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4037z00, BGl_z62sslzd2connectionzd2getzd2s1291zb0zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2hmaczd2updatez12zd2envzc0zz__ssl_sslz00, BgL_bgl_za762sslza7d2hmacza7d24038za7, BGl_z62sslzd2hmaczd2updatez12z70zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3450z00zz__ssl_sslz00, BgL_bgl_za762lambda1890za7624039z00, BGl_z62lambda1890z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3700z00zz__ssl_sslz00, BgL_bgl_string3700za700za7za7_4040za7, "&secure-context-set-cert!", 25 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3613z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4041z00, BGl_z62sslzd2connectionzd2getzd2c1293zb0zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3451z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo4042za7, BGl_z62zc3z04anonymousza31899ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3701z00zz__ssl_sslz00, BgL_bgl_string3701za700za7za7_4043za7, "&secure-context-set-session-id-context!", 39 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3452z00zz__ssl_sslz00, BgL_bgl_za762lambda1898za7624044z00, BGl_z62lambda1898z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3702z00zz__ssl_sslz00, BgL_bgl_string3702za700za7za7_4045za7, "&secure-context-load-pkcs12", 27 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3615z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4046z00, BGl_z62sslzd2connectionzd2loadzd21295zb0zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3453z00zz__ssl_sslz00, BgL_bgl_za762lambda1897za7624047z00, BGl_z62lambda1897z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3703z00zz__ssl_sslz00, BgL_bgl_string3703za700za7za7_4048za7, "&secure-context-set-ciphers!", 28 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3454z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo4049za7, BGl_z62zc3z04anonymousza31906ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3704z00zz__ssl_sslz00, BgL_bgl_string3704za700za7za7_4050za7, "&secure-context-set-options!", 28 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3617z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4051z00, BGl_z62sslzd2connectionzd2verif1297z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3455z00zz__ssl_sslz00, BgL_bgl_za762lambda1905za7624052z00, BGl_z62lambda1905z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3380z00zz__ssl_sslz00, BgL_bgl_string3380za700za7za7_4053za7, "Unknown protocols", 17 );
DEFINE_STRING( BGl_string3705z00zz__ssl_sslz00, BgL_bgl_string3705za700za7za7_4054za7, "&ssl-connection-init", 20 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3456z00zz__ssl_sslz00, BgL_bgl_za762lambda1904za7624055z00, BGl_z62lambda1904z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3381z00zz__ssl_sslz00, BgL_bgl_string3381za700za7za7_4056za7, "&read-private-key", 17 );
DEFINE_STRING( BGl_string3706z00zz__ssl_sslz00, BgL_bgl_string3706za700za7za7_4057za7, "ssl-connection", 14 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3619z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4058z00, BGl_z62sslzd2connectionzd2getzd2p1299zb0zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3457z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo4059za7, BGl_z62zc3z04anonymousza31913ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3382z00zz__ssl_sslz00, BgL_bgl_string3382za700za7za7_4060za7, "&read-certificate", 17 );
DEFINE_STRING( BGl_string3707z00zz__ssl_sslz00, BgL_bgl_string3707za700za7za7_4061za7, "&ssl-connection-start", 21 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3458z00zz__ssl_sslz00, BgL_bgl_za762lambda1912za7624062z00, BGl_z62lambda1912z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3383z00zz__ssl_sslz00, BgL_bgl_string3383za700za7za7_4063za7, "&read-pem-file", 14 );
DEFINE_STRING( BGl_string3708z00zz__ssl_sslz00, BgL_bgl_string3708za700za7za7_4064za7, "&ssl-connection-close", 21 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3459z00zz__ssl_sslz00, BgL_bgl_za762lambda1911za7624065z00, BGl_z62lambda1911z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3384z00zz__ssl_sslz00, BgL_bgl_string3384za700za7za7_4066za7, "&ssl-rand-bytes", 15 );
DEFINE_STRING( BGl_string3709z00zz__ssl_sslz00, BgL_bgl_string3709za700za7za7_4067za7, "&ssl-connection-shutdown", 24 );
DEFINE_STRING( BGl_string3385z00zz__ssl_sslz00, BgL_bgl_string3385za700za7za7_4068za7, "&ssl-rand-pseudo-bytes", 22 );
DEFINE_STRING( BGl_string3386z00zz__ssl_sslz00, BgL_bgl_string3386za700za7za7_4069za7, "&certificate-subject", 20 );
DEFINE_STRING( BGl_string3387z00zz__ssl_sslz00, BgL_bgl_string3387za700za7za7_4070za7, "certificate", 11 );
DEFINE_STRING( BGl_string3388z00zz__ssl_sslz00, BgL_bgl_string3388za700za7za7_4071za7, "&certificate-issuer", 19 );
DEFINE_STRING( BGl_string3389z00zz__ssl_sslz00, BgL_bgl_string3389za700za7za7_4072za7, "&%make-certificate", 18 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2connectionzd2readzd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4073z00, BGl_z62sslzd2connectionzd2readz62zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_EXPORT_BGL_GENERIC( BGl_dhzd2checkzd2pubzd2keyzd2envz00zz__ssl_sslz00, BgL_bgl_za762dhza7d2checkza7d24074za7, BGl_z62dhzd2checkzd2pubzd2keyzb0zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3621z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4075z00, BGl_z62sslzd2connectionzd2reuse1301z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3460z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo4076za7, BGl_z62zc3z04anonymousza31920ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3710z00zz__ssl_sslz00, BgL_bgl_string3710za700za7za7_4077za7, "&ssl-connection-read", 20 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3623z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4078z00, BGl_z62sslzd2connectionzd2getzd2n1303zb0zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3461z00zz__ssl_sslz00, BgL_bgl_za762lambda1919za7624079z00, BGl_z62lambda1919z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3711z00zz__ssl_sslz00, BgL_bgl_string3711za700za7za7_4080za7, "&ssl-connection-write", 21 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3462z00zz__ssl_sslz00, BgL_bgl_za762lambda1918za7624081z00, BGl_z62lambda1918z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3712z00zz__ssl_sslz00, BgL_bgl_string3712za700za7za7_4082za7, "&ssl-connection-clear-in", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3625z00zz__ssl_sslz00, BgL_bgl_za762dhza7d2init13054083z00, BGl_z62dhzd2init1305zb0zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3463z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo4084za7, BGl_z62zc3z04anonymousza31927ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3713z00zz__ssl_sslz00, BgL_bgl_string3713za700za7za7_4085za7, "&ssl-connection-clear-out", 25 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3464z00zz__ssl_sslz00, BgL_bgl_za762lambda1926za7624086z00, BGl_z62lambda1926z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3714z00zz__ssl_sslz00, BgL_bgl_string3714za700za7za7_4087za7, "&ssl-connection-init-finished?", 30 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3627z00zz__ssl_sslz00, BgL_bgl_za762dhza7d2siza7a7e134088za7, BGl_z62dhzd2siza7e1307z17zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3465z00zz__ssl_sslz00, BgL_bgl_za762lambda1925za7624089z00, BGl_z62lambda1925z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3390z00zz__ssl_sslz00, BgL_bgl_string3390za700za7za7_4090za7, "void*", 5 );
DEFINE_STRING( BGl_string3715z00zz__ssl_sslz00, BgL_bgl_string3715za700za7za7_4091za7, "&ssl-connection-enc-pending", 27 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3466z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo4092za7, BGl_z62zc3z04anonymousza31934ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3391z00zz__ssl_sslz00, BgL_bgl_string3391za700za7za7_4093za7, "&%make-private-key", 18 );
DEFINE_STRING( BGl_string3716z00zz__ssl_sslz00, BgL_bgl_string3716za700za7za7_4094za7, "&ssl-connection-clear-pending", 29 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3629z00zz__ssl_sslz00, BgL_bgl_za762dhza7d2generate4095z00, BGl_z62dhzd2generatezd2paramete1309z62zz__ssl_sslz00, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3467z00zz__ssl_sslz00, BgL_bgl_za762lambda1933za7624096z00, BGl_z62lambda1933z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3392z00zz__ssl_sslz00, BgL_bgl_string3392za700za7za7_4097za7, "_secure-context-set-key!", 24 );
DEFINE_STRING( BGl_string3717z00zz__ssl_sslz00, BgL_bgl_string3717za700za7za7_4098za7, "&ssl-connection-set-session", 27 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3468z00zz__ssl_sslz00, BgL_bgl_za762lambda1932za7624099z00, BGl_z62lambda1932z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3393z00zz__ssl_sslz00, BgL_bgl_string3393za700za7za7_4100za7, "vector", 6 );
DEFINE_STRING( BGl_string3718z00zz__ssl_sslz00, BgL_bgl_string3718za700za7za7_4101za7, "&ssl-connection-get-session", 27 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3469z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo4102za7, BGl_z62zc3z04anonymousza31941ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3394z00zz__ssl_sslz00, BgL_bgl_string3394za700za7za7_4103za7, "secure-context", 14 );
DEFINE_STRING( BGl_string3719z00zz__ssl_sslz00, BgL_bgl_string3719za700za7za7_4104za7, "&ssl-connection-get-current-cipher", 34 );
DEFINE_STRING( BGl_string3395z00zz__ssl_sslz00, BgL_bgl_string3395za700za7za7_4105za7, "&bn-bin2bn", 10 );
DEFINE_STRING( BGl_string3396z00zz__ssl_sslz00, BgL_bgl_string3396za700za7za7_4106za7, "&bn-bn2bin", 10 );
DEFINE_STRING( BGl_string3397z00zz__ssl_sslz00, BgL_bgl_string3397za700za7za7_4107za7, "foreign", 7 );
DEFINE_STRING( BGl_string3398z00zz__ssl_sslz00, BgL_bgl_string3398za700za7za7_4108za7, "&bn-num-bytes", 13 );
DEFINE_STRING( BGl_string3399z00zz__ssl_sslz00, BgL_bgl_string3399za700za7za7_4109za7, "&bn-free", 8 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3631z00zz__ssl_sslz00, BgL_bgl_za762dhza7d2check1314110z00, BGl_z62dhzd2check1311zb0zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3470z00zz__ssl_sslz00, BgL_bgl_za762lambda1940za7624111z00, BGl_z62lambda1940z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3720z00zz__ssl_sslz00, BgL_bgl_string3720za700za7za7_4112za7, "&ssl-connection-load-session", 28 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3633z00zz__ssl_sslz00, BgL_bgl_za762dhza7d2checkza7d24113za7, BGl_z62dhzd2checkzd2pubzd2key1313zb0zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3471z00zz__ssl_sslz00, BgL_bgl_za762lambda1939za7624114z00, BGl_z62lambda1939z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3721z00zz__ssl_sslz00, BgL_bgl_string3721za700za7za7_4115za7, "&ssl-connection-verify-error", 28 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3472z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo4116za7, BGl_z62zc3z04anonymousza31828ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3722z00zz__ssl_sslz00, BgL_bgl_string3722za700za7za7_4117za7, "&ssl-connection-get-peer-certificate", 36 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3635z00zz__ssl_sslz00, BgL_bgl_za762dhza7d2computeza74118za7, BGl_z62dhzd2computezd2key1315z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3473z00zz__ssl_sslz00, BgL_bgl_za762lambda1826za7624119z00, BGl_z62lambda1826z62zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3723z00zz__ssl_sslz00, BgL_bgl_string3723za700za7za7_4120za7, "&ssl-connection-reused?", 23 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3474z00zz__ssl_sslz00, BgL_bgl_za762lambda1823za7624121z00, BGl_z62lambda1823z62zz__ssl_sslz00, 0L, BUNSPEC, 17 );
DEFINE_STRING( BGl_string3724z00zz__ssl_sslz00, BgL_bgl_string3724za700za7za7_4122za7, "&ssl-connection-get-negotiated-protocol", 39 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3637z00zz__ssl_sslz00, BgL_bgl_za762dhza7d2generate4123z00, BGl_z62dhzd2generatezd2key1317z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3475z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo4124za7, BGl_z62zc3z04anonymousza31959ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3725z00zz__ssl_sslz00, BgL_bgl_string3725za700za7za7_4125za7, "&dh-init", 8 );
DEFINE_STRING( BGl_string3563z00zz__ssl_sslz00, BgL_bgl_string3563za700za7za7_4126za7, "", 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3476z00zz__ssl_sslz00, BgL_bgl_za762lambda1958za7624127z00, BGl_z62lambda1958z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3726z00zz__ssl_sslz00, BgL_bgl_string3726za700za7za7_4128za7, "dh", 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3639z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2hashza7d24129za7, BGl_z62sslzd2hashzd2init1319z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3564z00zz__ssl_sslz00, BgL_bgl_string3564za700za7za7_4130za7, "default", 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3477z00zz__ssl_sslz00, BgL_bgl_za762lambda1957za7624131z00, BGl_z62lambda1957z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3727z00zz__ssl_sslz00, BgL_bgl_string3727za700za7za7_4132za7, "&dh-size", 8 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3478z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo4133za7, BGl_z62zc3z04anonymousza31966ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3728z00zz__ssl_sslz00, BgL_bgl_string3728za700za7za7_4134za7, "&dh-generate-parameters-ex", 26 );
DEFINE_STRING( BGl_string3566z00zz__ssl_sslz00, BgL_bgl_string3566za700za7za7_4135za7, "secure-context-init1239", 23 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3479z00zz__ssl_sslz00, BgL_bgl_za762lambda1965za7624136z00, BGl_z62lambda1965z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3729z00zz__ssl_sslz00, BgL_bgl_string3729za700za7za7_4137za7, "symbol", 6 );
DEFINE_STRING( BGl_string3568z00zz__ssl_sslz00, BgL_bgl_string3568za700za7za7_4138za7, "secure-context-close1241", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3641z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2hashza7d24139za7, BGl_z62sslzd2hashzd2updatez121321z70zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3480z00zz__ssl_sslz00, BgL_bgl_za762lambda1964za7624140z00, BGl_z62lambda1964z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3730z00zz__ssl_sslz00, BgL_bgl_string3730za700za7za7_4141za7, "&dh-check", 9 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3643z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2hashza7d24142za7, BGl_z62sslzd2hashzd2digest1323z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3481z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo4143za7, BGl_z62zc3z04anonymousza31973ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3731z00zz__ssl_sslz00, BgL_bgl_string3731za700za7za7_4144za7, "&dh-check-pub-key", 17 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3482z00zz__ssl_sslz00, BgL_bgl_za762lambda1972za7624145z00, BGl_z62lambda1972z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3732z00zz__ssl_sslz00, BgL_bgl_string3732za700za7za7_4146za7, "&dh-compute-key", 15 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3645z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2hmacza7d24147za7, BGl_z62sslzd2hmaczd2init1325z62zz__ssl_sslz00, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string3570z00zz__ssl_sslz00, BgL_bgl_string3570za700za7za7_4148za7, "secure-context-add-r1243", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3483z00zz__ssl_sslz00, BgL_bgl_za762lambda1971za7624149z00, BGl_z62lambda1971z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3733z00zz__ssl_sslz00, BgL_bgl_string3733za700za7za7_4150za7, "&dh-generate-key", 16 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3484z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo4151za7, BGl_z62zc3z04anonymousza31980ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3734z00zz__ssl_sslz00, BgL_bgl_string3734za700za7za7_4152za7, "&ssl-hash-init", 14 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3647z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2hmacza7d24153za7, BGl_z62sslzd2hmaczd2updatez121327z70zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_STRING( BGl_string3572z00zz__ssl_sslz00, BgL_bgl_string3572za700za7za7_4154za7, "secure-context-add-c1245", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3485z00zz__ssl_sslz00, BgL_bgl_za762lambda1979za7624155z00, BGl_z62lambda1979z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3735z00zz__ssl_sslz00, BgL_bgl_string3735za700za7za7_4156za7, "&ssl-hash-update!", 17 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3486z00zz__ssl_sslz00, BgL_bgl_za762lambda1978za7624157z00, BGl_z62lambda1978z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3736z00zz__ssl_sslz00, BgL_bgl_string3736za700za7za7_4158za7, "&ssl-hash-digest", 16 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3649z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2hmacza7d24159za7, BGl_z62sslzd2hmaczd2digest1329z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3574z00zz__ssl_sslz00, BgL_bgl_string3574za700za7za7_4160za7, "secure-context-add-c1247", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3487z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo4161za7, BGl_z62zc3z04anonymousza31987ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3737z00zz__ssl_sslz00, BgL_bgl_string3737za700za7za7_4162za7, "&ssl-hmac-init", 14 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3488z00zz__ssl_sslz00, BgL_bgl_za762lambda1986za7624163z00, BGl_z62lambda1986z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3738z00zz__ssl_sslz00, BgL_bgl_string3738za700za7za7_4164za7, "&ssl-hmac-update!", 17 );
DEFINE_STRING( BGl_string3576z00zz__ssl_sslz00, BgL_bgl_string3576za700za7za7_4165za7, "secure-context-set-k1249", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3489z00zz__ssl_sslz00, BgL_bgl_za762lambda1985za7624166z00, BGl_z62lambda1985z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3739z00zz__ssl_sslz00, BgL_bgl_string3739za700za7za7_4167za7, "&ssl-hmac-digest", 16 );
DEFINE_STRING( BGl_string3578z00zz__ssl_sslz00, BgL_bgl_string3578za700za7za7_4168za7, "secure-context-set-c1257", 24 );
DEFINE_EXPORT_BGL_GENERIC( BGl_securezd2contextzd2closezd2envzd2zz__ssl_sslz00, BgL_bgl_za762secureza7d2cont4169z00, BGl_z62securezd2contextzd2closez62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3651z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2signza7d24170za7, BGl_z62sslzd2signzd2init1331z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2connectionzd2loadzd2sessionzd2envz00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4171z00, BGl_z62sslzd2connectionzd2loadzd2sessionzb0zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3490z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo4172za7, BGl_z62zc3z04anonymousza31994ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3740z00zz__ssl_sslz00, BgL_bgl_string3740za700za7za7_4173za7, "&ssl-sign-init", 14 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3653z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2signza7d24174za7, BGl_z62sslzd2signzd2updatez121333z70zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3491z00zz__ssl_sslz00, BgL_bgl_za762lambda1993za7624175z00, BGl_z62lambda1993z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3741z00zz__ssl_sslz00, BgL_bgl_string3741za700za7za7_4176za7, "&ssl-sign-update!", 17 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3492z00zz__ssl_sslz00, BgL_bgl_za762lambda1992za7624177z00, BGl_z62lambda1992z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3742z00zz__ssl_sslz00, BgL_bgl_string3742za700za7za7_4178za7, "&ssl-sign-sign", 14 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3655z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2signza7d24179za7, BGl_z62sslzd2signzd2sign1335z62zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_STRING( BGl_string3580z00zz__ssl_sslz00, BgL_bgl_string3580za700za7za7_4180za7, "secure-context-set-s1259", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3493z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo4181za7, BGl_z62zc3z04anonymousza31999ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3743z00zz__ssl_sslz00, BgL_bgl_string3743za700za7za7_4182za7, "&ssl-verify-init", 16 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3494z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo4183za7, BGl_z62zc3z04anonymousza31998ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3744z00zz__ssl_sslz00, BgL_bgl_string3744za700za7za7_4184za7, "&ssl-verify-update!", 19 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3657z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2verifyza74185za7, BGl_z62sslzd2verifyzd2init1337z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3582z00zz__ssl_sslz00, BgL_bgl_string3582za700za7za7_4186za7, "secure-context-load-1261", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3495z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo4187za7, BGl_z62zc3z04anonymousza32004ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3745z00zz__ssl_sslz00, BgL_bgl_string3745za700za7za7_4188za7, "&ssl-verify-final", 17 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3496z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo4189za7, BGl_z62zc3z04anonymousza32003ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3746z00zz__ssl_sslz00, BgL_bgl_string3746za700za7za7_4190za7, "&ssl-cipher-init", 16 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3659z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2verifyza74191za7, BGl_z62sslzd2verifyzd2updatez121339z70zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_STRING( BGl_string3584z00zz__ssl_sslz00, BgL_bgl_string3584za700za7za7_4192za7, "secure-context-set-c1263", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3497z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo4193za7, BGl_z62zc3z04anonymousza32009ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3747z00zz__ssl_sslz00, BgL_bgl_string3747za700za7za7_4194za7, "ssl-cipher", 10 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3498z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo4195za7, BGl_z62zc3z04anonymousza32008ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3748z00zz__ssl_sslz00, BgL_bgl_string3748za700za7za7_4196za7, "&ssl-cipher-initiv", 18 );
DEFINE_STRING( BGl_string3586z00zz__ssl_sslz00, BgL_bgl_string3586za700za7za7_4197za7, "secure-context-set-o1265", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3499z00zz__ssl_sslz00, BgL_bgl_za762za7c3za704anonymo4198za7, BGl_z62zc3z04anonymousza32014ze3ze5zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3749z00zz__ssl_sslz00, BgL_bgl_string3749za700za7za7_4199za7, "&ssl-cipher-update!", 19 );
DEFINE_STRING( BGl_string3588z00zz__ssl_sslz00, BgL_bgl_string3588za700za7za7_4200za7, "ssl-connection-init1267", 23 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52makezd2privatezd2keyzd2envz80zz__ssl_sslz00, BgL_bgl_za762za752makeza7d2pri4201za7, BGl_z62z52makezd2privatezd2keyz30zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3661z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2verifyza74202za7, BGl_z62sslzd2verifyzd2final1341z62zz__ssl_sslz00, 0L, BUNSPEC, 7 );
DEFINE_STRING( BGl_string3750z00zz__ssl_sslz00, BgL_bgl_string3750za700za7za7_4203za7, "&ssl-cipher-set-auto-padding", 28 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3663z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2cipherza74204za7, BGl_z62sslzd2cipherzd2init1343z62zz__ssl_sslz00, 0L, BUNSPEC, 6 );
DEFINE_STRING( BGl_string3751z00zz__ssl_sslz00, BgL_bgl_string3751za700za7za7_4205za7, "&ssl-cipher-final", 17 );
DEFINE_STRING( BGl_string3752z00zz__ssl_sslz00, BgL_bgl_string3752za700za7za7_4206za7, "DH-GENERATOR-2 ssl-cipher $ssl-cipher-ctx $cipher-ctx $ssl-cipher $cipher ssl-verify ssl-sign ssl-hmac $ssl-hmac-ctx ssl-hash type $ssl-evp-md-ctx $md-ctx $ssl-evp-md $md dh public-key g q p %priv %pub %g %q $bignum %p $dh ssl-connection sent-shutdown received-shutdown err npn-protos selected-npn-protos procedure newsession-callback sni-context-callback info-callback reject-unauthorized obj server-name request-cert bool isserver ctx $ssl-session $next-session $bio-write $bio $bio-read $ssl secure-context bstring method $X509-store $ca-store $ssl-ctx private-key $private-key __ssl_ssl certificate $certificate $native dtlsv1 dtls tlsv1_3 tlsv1_2 tlsv1_1 tlsv1 tls ssl sslv3 sslv2 make-ssl-server-socket :ipv6 :backlog :name (:ipv6 :backlog :accepted-certs :CAs :pkey :cert :protocol :name) client-socket-use-ssl! (:CAs :accepted-certs :cert :pkey :protocol) :timeout :protocol :pkey :outbuf :inbuf :cert :accepted-certs :CAs make-ssl-client-socket (:CAs :accepted-certs :cert :inbuf :outbuf :pkey :protocol :timeout) s"
"slv23 ", 1030 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3665z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2cipherza74207za7, BGl_z62sslzd2cipherzd2initiv1345z62zz__ssl_sslz00, 0L, BUNSPEC, 9 );
DEFINE_STRING( BGl_string3590z00zz__ssl_sslz00, BgL_bgl_string3590za700za7za7_4208za7, "ssl-connection-start1269", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3667z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2cipherza74209za7, BGl_z62sslzd2cipherzd2updatez121347z70zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_STRING( BGl_string3592z00zz__ssl_sslz00, BgL_bgl_string3592za700za7za7_4210za7, "ssl-connection-close1271", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3669z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2cipherza74211za7, BGl_z62sslzd2cipherzd2setzd2autozd21349z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3594z00zz__ssl_sslz00, BgL_bgl_string3594za700za7za7_4212za7, "ssl-connection-shutd1273", 24 );
DEFINE_STRING( BGl_string3596z00zz__ssl_sslz00, BgL_bgl_string3596za700za7za7_4213za7, "ssl-connection-read1275", 23 );
DEFINE_STRING( BGl_string3598z00zz__ssl_sslz00, BgL_bgl_string3598za700za7za7_4214za7, "ssl-connection-write1277", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3671z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2cipherza74215za7, BGl_z62sslzd2cipherzd2final1351z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_securezd2contextzd2setzd2certz12zd2envz12zz__ssl_sslz00, BgL_bgl_za762secureza7d2cont4216z00, BGl_z62securezd2contextzd2setzd2certz12za2zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52makezd2certificatezd2envz52zz__ssl_sslz00, BgL_bgl_za762za752makeza7d2cer4217za7, BGl_z62z52makezd2certificateze2zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_bnzd2numzd2byteszd2envzd2zz__ssl_sslz00, BgL_bgl_za762bnza7d2numza7d2by4218za7, BGl_z62bnzd2numzd2bytesz62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2connectionzd2startzd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4219z00, BGl_z62sslzd2connectionzd2startz62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2hashzd2initzd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2hashza7d24220za7, BGl_z62sslzd2hashzd2initz62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2signzd2signzd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2signza7d24221za7, BGl_z62sslzd2signzd2signz62zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_sslzd2clearzd2errorzd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2clearza7d4222za7, BGl_z62sslzd2clearzd2errorz62zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_GENERIC( BGl_securezd2contextzd2setzd2ciphersz12zd2envz12zz__ssl_sslz00, BgL_bgl_za762secureza7d2cont4223z00, BGl_z62securezd2contextzd2setzd2ciphersz12za2zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_GENERIC( BGl_securezd2contextzd2loadzd2pkcs12zd2envz00zz__ssl_sslz00, BgL_bgl_za762secureza7d2cont4224z00, BGl_z62securezd2contextzd2loadzd2pkcs12zb0zz__ssl_sslz00, 0L, BUNSPEC, 3 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2connectionzd2verifyzd2errorzd2envz00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4225z00, BGl_z62sslzd2connectionzd2verifyzd2errorzb0zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_securezd2contextzd2setzd2sessionzd2idzd2contextz12zd2envz12zz__ssl_sslz00, BgL_bgl_za762secureza7d2cont4226z00, BGl_z62securezd2contextzd2setzd2sessionzd2idzd2contextz12za2zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_sslzd2randzd2statuszd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2randza7d24227za7, BGl_z62sslzd2randzd2statusz62zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_bnzd2freezd2envz00zz__ssl_sslz00, BgL_bgl_za762bnza7d2freeza7b0za74228z00, BGl_z62bnzd2freezb0zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_sslzd2randzd2pseudozd2byteszd2envz00zz__ssl_sslz00, BgL_bgl_za762sslza7d2randza7d24229za7, BGl_z62sslzd2randzd2pseudozd2byteszb0zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_bnzd2newzd2envz00zz__ssl_sslz00, BgL_bgl_za762bnza7d2newza7b0za7za74230za7, BGl_z62bnzd2newzb0zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_GENERIC( BGl_securezd2contextzd2setzd2optionsz12zd2envz12zz__ssl_sslz00, BgL_bgl_za762secureza7d2cont4231z00, BGl_z62securezd2contextzd2setzd2optionsz12za2zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2cipherzd2initzd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2cipherza74232za7, BGl_z62sslzd2cipherzd2initz62zz__ssl_sslz00, 0L, BUNSPEC, 6 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_certificatez00zz__ssl_sslz00) );
ADD_ROOT( (void *)(&BGl_privatezd2keyzd2zz__ssl_sslz00) );
ADD_ROOT( (void *)(&BGl_sslzd2connectionzd2zz__ssl_sslz00) );
ADD_ROOT( (void *)(&BGl_sslzd2hashzd2zz__ssl_sslz00) );
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__ssl_sslz00) );
ADD_ROOT( (void *)(&BGl_sslzd2signzd2zz__ssl_sslz00) );
ADD_ROOT( (void *)(&BGl_sslzd2hmaczd2zz__ssl_sslz00) );
ADD_ROOT( (void *)(&BGl_sslzd2verifyzd2zz__ssl_sslz00) );
ADD_ROOT( (void *)(&BGl_sslzd2cipherzd2zz__ssl_sslz00) );
ADD_ROOT( (void *)(&BGl_securezd2contextzd2zz__ssl_sslz00) );
ADD_ROOT( (void *)(&BGl_dhz00zz__ssl_sslz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__ssl_sslz00(long BgL_checksumz00_6088, char * BgL_fromz00_6089)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__ssl_sslz00))
{ 
BGl_requirezd2initializa7ationz75zz__ssl_sslz00 = 
BBOOL(((bool_t)0)); 
BGL_GC_INIT(); 
BGl_gczd2rootszd2initz00zz__ssl_sslz00(); 
BGl_libraryzd2moduleszd2initz00zz__ssl_sslz00(); 
BGl_cnstzd2initzd2zz__ssl_sslz00(); 
BGl_objectzd2initzd2zz__ssl_sslz00(); 
BGl_genericzd2initzd2zz__ssl_sslz00(); 
return 
BGl_toplevelzd2initzd2zz__ssl_sslz00();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__ssl_sslz00()
{
{ /* Llib/ssl.scm 15 */
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__ssl_ssl"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__ssl_ssl"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__ssl_ssl"); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "__ssl_ssl"); 
BGl_modulezd2initializa7ationz75zz__dssslz00(((long)0), "__ssl_ssl"); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "__ssl_ssl"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__ssl_ssl"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__ssl_ssl"); 
BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)0), "__ssl_ssl"); 
BGl_modulezd2initializa7ationz75zz__socketz00(((long)0), "__ssl_ssl"); 
BGl_modulezd2initializa7ationz75zz__bitz00(((long)0), "__ssl_ssl"); 
BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)0), "__ssl_ssl"); 
BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long)0), "__ssl_ssl"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__ssl_ssl"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__ssl_ssl"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__ssl_sslz00()
{
{ /* Llib/ssl.scm 15 */
{ /* Llib/ssl.scm 15 */
obj_t BgL_cportz00_5656;
{ /* Llib/ssl.scm 15 */
obj_t BgL_stringz00_5664;
BgL_stringz00_5664 = BGl_string3752z00zz__ssl_sslz00; 
{ /* Llib/ssl.scm 15 */
obj_t BgL_startz00_5665;
BgL_startz00_5665 = 
BINT(((long)0)); 
{ /* Llib/ssl.scm 15 */
obj_t BgL_endz00_5666;
BgL_endz00_5666 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_5664))); 
{ /* Llib/ssl.scm 15 */

BgL_cportz00_5656 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_5664, BgL_startz00_5665, BgL_endz00_5666); } } } } 
{ 
long BgL_iz00_5657;
BgL_iz00_5657 = ((long)90); 
BgL_loopz00_5658:
if(
(BgL_iz00_5657==((long)-1)))
{ /* Llib/ssl.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/ssl.scm 15 */
{ /* Llib/ssl.scm 15 */
obj_t BgL_arg3754z00_5660;
{ /* Llib/ssl.scm 15 */

{ /* Llib/ssl.scm 15 */
obj_t BgL_locationz00_5662;
BgL_locationz00_5662 = 
BBOOL(((bool_t)0)); 
{ /* Llib/ssl.scm 15 */

BgL_arg3754z00_5660 = 
BGl_readz00zz__readerz00(BgL_cportz00_5656, BgL_locationz00_5662); } } } 
{ /* Llib/ssl.scm 15 */
int BgL_tmpz00_6124;
BgL_tmpz00_6124 = 
(int)(BgL_iz00_5657); 
CNST_TABLE_SET(BgL_tmpz00_6124, BgL_arg3754z00_5660); } } 
{ /* Llib/ssl.scm 15 */
int BgL_auxz00_5663;
BgL_auxz00_5663 = 
(int)(
(BgL_iz00_5657-((long)1))); 
{ 
long BgL_iz00_6129;
BgL_iz00_6129 = 
(long)(BgL_auxz00_5663); 
BgL_iz00_5657 = BgL_iz00_6129; 
goto BgL_loopz00_5658;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__ssl_sslz00()
{
{ /* Llib/ssl.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__ssl_sslz00()
{
{ /* Llib/ssl.scm 15 */
return BUNSPEC;} 

}



/* ssl-version */
BGL_EXPORTED_DEF char * BGl_sslzd2versionzd2zz__ssl_sslz00()
{
{ /* Llib/ssl.scm 570 */
return 
bgl_ssl_version();} 

}



/* &ssl-version */
obj_t BGl_z62sslzd2versionzb0zz__ssl_sslz00(obj_t BgL_envz00_4151)
{
{ /* Llib/ssl.scm 570 */
return 
string_to_bstring(
BGl_sslzd2versionzd2zz__ssl_sslz00());} 

}



/* ssl-clear-error */
BGL_EXPORTED_DEF obj_t BGl_sslzd2clearzd2errorz00zz__ssl_sslz00()
{
{ /* Llib/ssl.scm 578 */
ERR_clear_error(); BUNSPEC; 
return BTRUE;} 

}



/* &ssl-clear-error */
obj_t BGl_z62sslzd2clearzd2errorz62zz__ssl_sslz00(obj_t BgL_envz00_4152)
{
{ /* Llib/ssl.scm 578 */
return 
BGl_sslzd2clearzd2errorz00zz__ssl_sslz00();} 

}



/* sanity-args-checks */
obj_t BGl_sanityzd2argszd2checksz00zz__ssl_sslz00(obj_t BgL_funcz00_3, obj_t BgL_certz00_4, obj_t BgL_pkeyz00_5, obj_t BgL_casz00_6, obj_t BgL_acceptedzd2certszd2_7)
{
{ /* Llib/ssl.scm 586 */
{ /* Llib/ssl.scm 587 */
bool_t BgL_test4235z00_6137;
if(
CBOOL(BgL_certz00_4))
{ /* Llib/ssl.scm 587 */
BgL_test4235z00_6137 = 
BGl_isazf3zf3zz__objectz00(BgL_certz00_4, BGl_certificatez00zz__ssl_sslz00)
; }  else 
{ /* Llib/ssl.scm 587 */
BgL_test4235z00_6137 = ((bool_t)1)
; } 
if(BgL_test4235z00_6137)
{ /* Llib/ssl.scm 587 */BFALSE; }  else 
{ /* Llib/ssl.scm 587 */
BGl_errorz00zz__errorz00(BgL_funcz00_3, BGl_string3360z00zz__ssl_sslz00, BgL_certz00_4); } } 
{ /* Llib/ssl.scm 589 */
bool_t BgL_test4237z00_6142;
if(
CBOOL(BgL_pkeyz00_5))
{ /* Llib/ssl.scm 589 */
BgL_test4237z00_6142 = 
BGl_isazf3zf3zz__objectz00(BgL_pkeyz00_5, BGl_privatezd2keyzd2zz__ssl_sslz00)
; }  else 
{ /* Llib/ssl.scm 589 */
BgL_test4237z00_6142 = ((bool_t)1)
; } 
if(BgL_test4237z00_6142)
{ /* Llib/ssl.scm 589 */BFALSE; }  else 
{ /* Llib/ssl.scm 589 */
BGl_errorz00zz__errorz00(BgL_funcz00_3, BGl_string3361z00zz__ssl_sslz00, BgL_pkeyz00_5); } } 
{ /* Llib/ssl.scm 591 */
bool_t BgL_test4239z00_6147;
if(
BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_casz00_6))
{ 
obj_t BgL_l1180z00_211;
BgL_l1180z00_211 = BgL_casz00_6; 
BgL_zc3z04anonymousza31507ze3z87_212:
if(
NULLP(BgL_l1180z00_211))
{ /* Llib/ssl.scm 591 */
BgL_test4239z00_6147 = ((bool_t)1)
; }  else 
{ /* Llib/ssl.scm 591 */
bool_t BgL_test4242z00_6152;
{ /* Llib/ssl.scm 591 */
obj_t BgL_cz00_217;
BgL_cz00_217 = 
CAR(
((obj_t)BgL_l1180z00_211)); 
BgL_test4242z00_6152 = 
BGl_isazf3zf3zz__objectz00(BgL_cz00_217, BGl_certificatez00zz__ssl_sslz00); } 
if(BgL_test4242z00_6152)
{ 
obj_t BgL_l1180z00_6156;
BgL_l1180z00_6156 = 
CDR(
((obj_t)BgL_l1180z00_211)); 
BgL_l1180z00_211 = BgL_l1180z00_6156; 
goto BgL_zc3z04anonymousza31507ze3z87_212;}  else 
{ /* Llib/ssl.scm 591 */
BgL_test4239z00_6147 = ((bool_t)0)
; } } }  else 
{ /* Llib/ssl.scm 591 */
BgL_test4239z00_6147 = ((bool_t)0)
; } 
if(BgL_test4239z00_6147)
{ /* Llib/ssl.scm 591 */BFALSE; }  else 
{ /* Llib/ssl.scm 591 */
BGl_errorz00zz__errorz00(BgL_funcz00_3, BGl_string3362z00zz__ssl_sslz00, BgL_casz00_6); } } 
{ /* Llib/ssl.scm 593 */
bool_t BgL_test4243z00_6160;
if(
CBOOL(BgL_acceptedzd2certszd2_7))
{ /* Llib/ssl.scm 593 */
if(
BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_acceptedzd2certszd2_7))
{ 
obj_t BgL_l1183z00_232;
BgL_l1183z00_232 = BgL_acceptedzd2certszd2_7; 
BgL_zc3z04anonymousza31527ze3z87_233:
if(
NULLP(BgL_l1183z00_232))
{ /* Llib/ssl.scm 595 */
BgL_test4243z00_6160 = ((bool_t)1)
; }  else 
{ /* Llib/ssl.scm 595 */
bool_t BgL_test4247z00_6167;
{ /* Llib/ssl.scm 595 */
obj_t BgL_cz00_238;
BgL_cz00_238 = 
CAR(
((obj_t)BgL_l1183z00_232)); 
BgL_test4247z00_6167 = 
BGl_isazf3zf3zz__objectz00(BgL_cz00_238, BGl_certificatez00zz__ssl_sslz00); } 
if(BgL_test4247z00_6167)
{ 
obj_t BgL_l1183z00_6171;
BgL_l1183z00_6171 = 
CDR(
((obj_t)BgL_l1183z00_232)); 
BgL_l1183z00_232 = BgL_l1183z00_6171; 
goto BgL_zc3z04anonymousza31527ze3z87_233;}  else 
{ /* Llib/ssl.scm 595 */
BgL_test4243z00_6160 = ((bool_t)0)
; } } }  else 
{ /* Llib/ssl.scm 594 */
BgL_test4243z00_6160 = ((bool_t)0)
; } }  else 
{ /* Llib/ssl.scm 593 */
BgL_test4243z00_6160 = ((bool_t)1)
; } 
if(BgL_test4243z00_6160)
{ /* Llib/ssl.scm 593 */BFALSE; }  else 
{ /* Llib/ssl.scm 593 */
BGl_errorz00zz__errorz00(BgL_funcz00_3, BGl_string3363z00zz__ssl_sslz00, BgL_acceptedzd2certszd2_7); } } 
{ /* Llib/ssl.scm 597 */
bool_t BgL_test4248z00_6175;
{ /* Llib/ssl.scm 597 */
bool_t BgL_test4249z00_6176;
if(
BGl_isazf3zf3zz__objectz00(BgL_certz00_4, BGl_certificatez00zz__ssl_sslz00))
{ /* Llib/ssl.scm 597 */
if(
BGl_isazf3zf3zz__objectz00(BgL_pkeyz00_5, BGl_privatezd2keyzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 597 */
BgL_test4249z00_6176 = ((bool_t)0)
; }  else 
{ /* Llib/ssl.scm 597 */
BgL_test4249z00_6176 = ((bool_t)1)
; } }  else 
{ /* Llib/ssl.scm 597 */
BgL_test4249z00_6176 = ((bool_t)0)
; } 
if(BgL_test4249z00_6176)
{ /* Llib/ssl.scm 597 */
BgL_test4248z00_6175 = ((bool_t)1)
; }  else 
{ /* Llib/ssl.scm 597 */
if(
BGl_isazf3zf3zz__objectz00(BgL_pkeyz00_5, BGl_privatezd2keyzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 598 */
if(
BGl_isazf3zf3zz__objectz00(BgL_certz00_4, BGl_certificatez00zz__ssl_sslz00))
{ /* Llib/ssl.scm 598 */
BgL_test4248z00_6175 = ((bool_t)0)
; }  else 
{ /* Llib/ssl.scm 598 */
BgL_test4248z00_6175 = ((bool_t)1)
; } }  else 
{ /* Llib/ssl.scm 598 */
BgL_test4248z00_6175 = ((bool_t)0)
; } } } 
if(BgL_test4248z00_6175)
{ /* Llib/ssl.scm 601 */
obj_t BgL_arg1545z00_248;
{ /* Llib/ssl.scm 601 */
obj_t BgL_list1546z00_249;
{ /* Llib/ssl.scm 601 */
obj_t BgL_arg1547z00_250;
BgL_arg1547z00_250 = 
MAKE_YOUNG_PAIR(BgL_certz00_4, BNIL); 
BgL_list1546z00_249 = 
MAKE_YOUNG_PAIR(BgL_pkeyz00_5, BgL_arg1547z00_250); } 
BgL_arg1545z00_248 = BgL_list1546z00_249; } 
return 
BGl_errorz00zz__errorz00(BgL_funcz00_3, BGl_string3364z00zz__ssl_sslz00, BgL_arg1545z00_248);}  else 
{ /* Llib/ssl.scm 597 */
return BFALSE;} } } 

}



/* _make-ssl-client-socket */
obj_t BGl__makezd2sslzd2clientzd2socketzd2zz__ssl_sslz00(obj_t BgL_envz00_19, obj_t BgL_opt1211z00_18)
{
{ /* Llib/ssl.scm 606 */
{ /* Llib/ssl.scm 606 */
obj_t BgL_g1224z00_260;obj_t BgL_g1225z00_261;
BgL_g1224z00_260 = 
VECTOR_REF(BgL_opt1211z00_18,((long)0)); 
BgL_g1225z00_261 = 
VECTOR_REF(BgL_opt1211z00_18,((long)1)); 
{ /* Llib/ssl.scm 612 */
obj_t BgL_casz00_262;
BgL_casz00_262 = BNIL; 
{ /* Llib/ssl.scm 606 */
obj_t BgL_acceptedzd2certszd2_263;
BgL_acceptedzd2certszd2_263 = BFALSE; 
{ /* Llib/ssl.scm 606 */
obj_t BgL_certz00_264;
BgL_certz00_264 = BFALSE; 
{ /* Llib/ssl.scm 606 */
obj_t BgL_inbufz00_265;
BgL_inbufz00_265 = BTRUE; 
{ /* Llib/ssl.scm 606 */
obj_t BgL_outbufz00_266;
BgL_outbufz00_266 = BTRUE; 
{ /* Llib/ssl.scm 606 */
obj_t BgL_pkeyz00_267;
BgL_pkeyz00_267 = BFALSE; 
{ /* Llib/ssl.scm 610 */
obj_t BgL_protocolz00_268;
BgL_protocolz00_268 = 
CNST_TABLE_REF(((long)0)); 
{ /* Llib/ssl.scm 606 */
obj_t BgL_timeoutz00_269;
BgL_timeoutz00_269 = 
BINT(((long)0)); 
{ /* Llib/ssl.scm 606 */

{ 
long BgL_iz00_270;
BgL_iz00_270 = ((long)2); 
BgL_check1214z00_271:
if(
(BgL_iz00_270==
VECTOR_LENGTH(BgL_opt1211z00_18)))
{ /* Llib/ssl.scm 606 */BNIL; }  else 
{ /* Llib/ssl.scm 606 */
bool_t BgL_test4255z00_6195;
{ /* Llib/ssl.scm 606 */
obj_t BgL_arg1577z00_277;
BgL_arg1577z00_277 = 
VECTOR_REF(BgL_opt1211z00_18,BgL_iz00_270); 
BgL_test4255z00_6195 = 
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg1577z00_277, 
CNST_TABLE_REF(((long)1)))); } 
if(BgL_test4255z00_6195)
{ 
long BgL_iz00_6200;
BgL_iz00_6200 = 
(BgL_iz00_270+((long)2)); 
BgL_iz00_270 = BgL_iz00_6200; 
goto BgL_check1214z00_271;}  else 
{ /* Llib/ssl.scm 606 */
obj_t BgL_arg1563z00_276;
BgL_arg1563z00_276 = 
VECTOR_REF(BgL_opt1211z00_18,BgL_iz00_270); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)2)), BGl_string3365z00zz__ssl_sslz00, BgL_arg1563z00_276); } } } 
{ /* Llib/ssl.scm 606 */
obj_t BgL_index1216z00_278;
BgL_index1216z00_278 = 
BGl_search1213ze70ze7zz__ssl_sslz00(
VECTOR_LENGTH(BgL_opt1211z00_18), BgL_opt1211z00_18, 
CNST_TABLE_REF(((long)3)), ((long)2)); 
{ /* Llib/ssl.scm 606 */
bool_t BgL_test4256z00_6208;
{ /* Llib/ssl.scm 606 */
long BgL_n1z00_1793;
{ /* Llib/ssl.scm 606 */
obj_t BgL_tmpz00_6209;
if(
INTEGERP(BgL_index1216z00_278))
{ /* Llib/ssl.scm 606 */
BgL_tmpz00_6209 = BgL_index1216z00_278
; }  else 
{ 
obj_t BgL_auxz00_6212;
BgL_auxz00_6212 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)24776)), BGl_string3367z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_index1216z00_278); 
FAILURE(BgL_auxz00_6212,BFALSE,BFALSE);} 
BgL_n1z00_1793 = 
(long)CINT(BgL_tmpz00_6209); } 
BgL_test4256z00_6208 = 
(BgL_n1z00_1793>=((long)0)); } 
if(BgL_test4256z00_6208)
{ 
long BgL_auxz00_6218;
{ /* Llib/ssl.scm 606 */
obj_t BgL_tmpz00_6219;
if(
INTEGERP(BgL_index1216z00_278))
{ /* Llib/ssl.scm 606 */
BgL_tmpz00_6219 = BgL_index1216z00_278
; }  else 
{ 
obj_t BgL_auxz00_6222;
BgL_auxz00_6222 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)24776)), BGl_string3367z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_index1216z00_278); 
FAILURE(BgL_auxz00_6222,BFALSE,BFALSE);} 
BgL_auxz00_6218 = 
(long)CINT(BgL_tmpz00_6219); } 
BgL_casz00_262 = 
VECTOR_REF(BgL_opt1211z00_18,BgL_auxz00_6218); }  else 
{ /* Llib/ssl.scm 606 */BFALSE; } } } 
{ /* Llib/ssl.scm 606 */
obj_t BgL_index1217z00_280;
BgL_index1217z00_280 = 
BGl_search1213ze70ze7zz__ssl_sslz00(
VECTOR_LENGTH(BgL_opt1211z00_18), BgL_opt1211z00_18, 
CNST_TABLE_REF(((long)4)), ((long)2)); 
{ /* Llib/ssl.scm 606 */
bool_t BgL_test4259z00_6231;
{ /* Llib/ssl.scm 606 */
long BgL_n1z00_1795;
{ /* Llib/ssl.scm 606 */
obj_t BgL_tmpz00_6232;
if(
INTEGERP(BgL_index1217z00_280))
{ /* Llib/ssl.scm 606 */
BgL_tmpz00_6232 = BgL_index1217z00_280
; }  else 
{ 
obj_t BgL_auxz00_6235;
BgL_auxz00_6235 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)24776)), BGl_string3367z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_index1217z00_280); 
FAILURE(BgL_auxz00_6235,BFALSE,BFALSE);} 
BgL_n1z00_1795 = 
(long)CINT(BgL_tmpz00_6232); } 
BgL_test4259z00_6231 = 
(BgL_n1z00_1795>=((long)0)); } 
if(BgL_test4259z00_6231)
{ 
long BgL_auxz00_6241;
{ /* Llib/ssl.scm 606 */
obj_t BgL_tmpz00_6242;
if(
INTEGERP(BgL_index1217z00_280))
{ /* Llib/ssl.scm 606 */
BgL_tmpz00_6242 = BgL_index1217z00_280
; }  else 
{ 
obj_t BgL_auxz00_6245;
BgL_auxz00_6245 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)24776)), BGl_string3367z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_index1217z00_280); 
FAILURE(BgL_auxz00_6245,BFALSE,BFALSE);} 
BgL_auxz00_6241 = 
(long)CINT(BgL_tmpz00_6242); } 
BgL_acceptedzd2certszd2_263 = 
VECTOR_REF(BgL_opt1211z00_18,BgL_auxz00_6241); }  else 
{ /* Llib/ssl.scm 606 */BFALSE; } } } 
{ /* Llib/ssl.scm 606 */
obj_t BgL_index1218z00_282;
BgL_index1218z00_282 = 
BGl_search1213ze70ze7zz__ssl_sslz00(
VECTOR_LENGTH(BgL_opt1211z00_18), BgL_opt1211z00_18, 
CNST_TABLE_REF(((long)5)), ((long)2)); 
{ /* Llib/ssl.scm 606 */
bool_t BgL_test4262z00_6254;
{ /* Llib/ssl.scm 606 */
long BgL_n1z00_1797;
{ /* Llib/ssl.scm 606 */
obj_t BgL_tmpz00_6255;
if(
INTEGERP(BgL_index1218z00_282))
{ /* Llib/ssl.scm 606 */
BgL_tmpz00_6255 = BgL_index1218z00_282
; }  else 
{ 
obj_t BgL_auxz00_6258;
BgL_auxz00_6258 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)24776)), BGl_string3367z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_index1218z00_282); 
FAILURE(BgL_auxz00_6258,BFALSE,BFALSE);} 
BgL_n1z00_1797 = 
(long)CINT(BgL_tmpz00_6255); } 
BgL_test4262z00_6254 = 
(BgL_n1z00_1797>=((long)0)); } 
if(BgL_test4262z00_6254)
{ 
long BgL_auxz00_6264;
{ /* Llib/ssl.scm 606 */
obj_t BgL_tmpz00_6265;
if(
INTEGERP(BgL_index1218z00_282))
{ /* Llib/ssl.scm 606 */
BgL_tmpz00_6265 = BgL_index1218z00_282
; }  else 
{ 
obj_t BgL_auxz00_6268;
BgL_auxz00_6268 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)24776)), BGl_string3367z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_index1218z00_282); 
FAILURE(BgL_auxz00_6268,BFALSE,BFALSE);} 
BgL_auxz00_6264 = 
(long)CINT(BgL_tmpz00_6265); } 
BgL_certz00_264 = 
VECTOR_REF(BgL_opt1211z00_18,BgL_auxz00_6264); }  else 
{ /* Llib/ssl.scm 606 */BFALSE; } } } 
{ /* Llib/ssl.scm 606 */
obj_t BgL_index1219z00_284;
BgL_index1219z00_284 = 
BGl_search1213ze70ze7zz__ssl_sslz00(
VECTOR_LENGTH(BgL_opt1211z00_18), BgL_opt1211z00_18, 
CNST_TABLE_REF(((long)6)), ((long)2)); 
{ /* Llib/ssl.scm 606 */
bool_t BgL_test4265z00_6277;
{ /* Llib/ssl.scm 606 */
long BgL_n1z00_1799;
{ /* Llib/ssl.scm 606 */
obj_t BgL_tmpz00_6278;
if(
INTEGERP(BgL_index1219z00_284))
{ /* Llib/ssl.scm 606 */
BgL_tmpz00_6278 = BgL_index1219z00_284
; }  else 
{ 
obj_t BgL_auxz00_6281;
BgL_auxz00_6281 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)24776)), BGl_string3367z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_index1219z00_284); 
FAILURE(BgL_auxz00_6281,BFALSE,BFALSE);} 
BgL_n1z00_1799 = 
(long)CINT(BgL_tmpz00_6278); } 
BgL_test4265z00_6277 = 
(BgL_n1z00_1799>=((long)0)); } 
if(BgL_test4265z00_6277)
{ 
long BgL_auxz00_6287;
{ /* Llib/ssl.scm 606 */
obj_t BgL_tmpz00_6288;
if(
INTEGERP(BgL_index1219z00_284))
{ /* Llib/ssl.scm 606 */
BgL_tmpz00_6288 = BgL_index1219z00_284
; }  else 
{ 
obj_t BgL_auxz00_6291;
BgL_auxz00_6291 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)24776)), BGl_string3367z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_index1219z00_284); 
FAILURE(BgL_auxz00_6291,BFALSE,BFALSE);} 
BgL_auxz00_6287 = 
(long)CINT(BgL_tmpz00_6288); } 
BgL_inbufz00_265 = 
VECTOR_REF(BgL_opt1211z00_18,BgL_auxz00_6287); }  else 
{ /* Llib/ssl.scm 606 */BFALSE; } } } 
{ /* Llib/ssl.scm 606 */
obj_t BgL_index1220z00_286;
BgL_index1220z00_286 = 
BGl_search1213ze70ze7zz__ssl_sslz00(
VECTOR_LENGTH(BgL_opt1211z00_18), BgL_opt1211z00_18, 
CNST_TABLE_REF(((long)7)), ((long)2)); 
{ /* Llib/ssl.scm 606 */
bool_t BgL_test4268z00_6300;
{ /* Llib/ssl.scm 606 */
long BgL_n1z00_1801;
{ /* Llib/ssl.scm 606 */
obj_t BgL_tmpz00_6301;
if(
INTEGERP(BgL_index1220z00_286))
{ /* Llib/ssl.scm 606 */
BgL_tmpz00_6301 = BgL_index1220z00_286
; }  else 
{ 
obj_t BgL_auxz00_6304;
BgL_auxz00_6304 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)24776)), BGl_string3367z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_index1220z00_286); 
FAILURE(BgL_auxz00_6304,BFALSE,BFALSE);} 
BgL_n1z00_1801 = 
(long)CINT(BgL_tmpz00_6301); } 
BgL_test4268z00_6300 = 
(BgL_n1z00_1801>=((long)0)); } 
if(BgL_test4268z00_6300)
{ 
long BgL_auxz00_6310;
{ /* Llib/ssl.scm 606 */
obj_t BgL_tmpz00_6311;
if(
INTEGERP(BgL_index1220z00_286))
{ /* Llib/ssl.scm 606 */
BgL_tmpz00_6311 = BgL_index1220z00_286
; }  else 
{ 
obj_t BgL_auxz00_6314;
BgL_auxz00_6314 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)24776)), BGl_string3367z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_index1220z00_286); 
FAILURE(BgL_auxz00_6314,BFALSE,BFALSE);} 
BgL_auxz00_6310 = 
(long)CINT(BgL_tmpz00_6311); } 
BgL_outbufz00_266 = 
VECTOR_REF(BgL_opt1211z00_18,BgL_auxz00_6310); }  else 
{ /* Llib/ssl.scm 606 */BFALSE; } } } 
{ /* Llib/ssl.scm 606 */
obj_t BgL_index1221z00_288;
BgL_index1221z00_288 = 
BGl_search1213ze70ze7zz__ssl_sslz00(
VECTOR_LENGTH(BgL_opt1211z00_18), BgL_opt1211z00_18, 
CNST_TABLE_REF(((long)8)), ((long)2)); 
{ /* Llib/ssl.scm 606 */
bool_t BgL_test4271z00_6323;
{ /* Llib/ssl.scm 606 */
long BgL_n1z00_1803;
{ /* Llib/ssl.scm 606 */
obj_t BgL_tmpz00_6324;
if(
INTEGERP(BgL_index1221z00_288))
{ /* Llib/ssl.scm 606 */
BgL_tmpz00_6324 = BgL_index1221z00_288
; }  else 
{ 
obj_t BgL_auxz00_6327;
BgL_auxz00_6327 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)24776)), BGl_string3367z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_index1221z00_288); 
FAILURE(BgL_auxz00_6327,BFALSE,BFALSE);} 
BgL_n1z00_1803 = 
(long)CINT(BgL_tmpz00_6324); } 
BgL_test4271z00_6323 = 
(BgL_n1z00_1803>=((long)0)); } 
if(BgL_test4271z00_6323)
{ 
long BgL_auxz00_6333;
{ /* Llib/ssl.scm 606 */
obj_t BgL_tmpz00_6334;
if(
INTEGERP(BgL_index1221z00_288))
{ /* Llib/ssl.scm 606 */
BgL_tmpz00_6334 = BgL_index1221z00_288
; }  else 
{ 
obj_t BgL_auxz00_6337;
BgL_auxz00_6337 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)24776)), BGl_string3367z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_index1221z00_288); 
FAILURE(BgL_auxz00_6337,BFALSE,BFALSE);} 
BgL_auxz00_6333 = 
(long)CINT(BgL_tmpz00_6334); } 
BgL_pkeyz00_267 = 
VECTOR_REF(BgL_opt1211z00_18,BgL_auxz00_6333); }  else 
{ /* Llib/ssl.scm 606 */BFALSE; } } } 
{ /* Llib/ssl.scm 606 */
obj_t BgL_index1222z00_290;
BgL_index1222z00_290 = 
BGl_search1213ze70ze7zz__ssl_sslz00(
VECTOR_LENGTH(BgL_opt1211z00_18), BgL_opt1211z00_18, 
CNST_TABLE_REF(((long)9)), ((long)2)); 
{ /* Llib/ssl.scm 606 */
bool_t BgL_test4274z00_6346;
{ /* Llib/ssl.scm 606 */
long BgL_n1z00_1805;
{ /* Llib/ssl.scm 606 */
obj_t BgL_tmpz00_6347;
if(
INTEGERP(BgL_index1222z00_290))
{ /* Llib/ssl.scm 606 */
BgL_tmpz00_6347 = BgL_index1222z00_290
; }  else 
{ 
obj_t BgL_auxz00_6350;
BgL_auxz00_6350 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)24776)), BGl_string3367z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_index1222z00_290); 
FAILURE(BgL_auxz00_6350,BFALSE,BFALSE);} 
BgL_n1z00_1805 = 
(long)CINT(BgL_tmpz00_6347); } 
BgL_test4274z00_6346 = 
(BgL_n1z00_1805>=((long)0)); } 
if(BgL_test4274z00_6346)
{ 
long BgL_auxz00_6356;
{ /* Llib/ssl.scm 606 */
obj_t BgL_tmpz00_6357;
if(
INTEGERP(BgL_index1222z00_290))
{ /* Llib/ssl.scm 606 */
BgL_tmpz00_6357 = BgL_index1222z00_290
; }  else 
{ 
obj_t BgL_auxz00_6360;
BgL_auxz00_6360 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)24776)), BGl_string3367z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_index1222z00_290); 
FAILURE(BgL_auxz00_6360,BFALSE,BFALSE);} 
BgL_auxz00_6356 = 
(long)CINT(BgL_tmpz00_6357); } 
BgL_protocolz00_268 = 
VECTOR_REF(BgL_opt1211z00_18,BgL_auxz00_6356); }  else 
{ /* Llib/ssl.scm 606 */BFALSE; } } } 
{ /* Llib/ssl.scm 606 */
obj_t BgL_index1223z00_292;
BgL_index1223z00_292 = 
BGl_search1213ze70ze7zz__ssl_sslz00(
VECTOR_LENGTH(BgL_opt1211z00_18), BgL_opt1211z00_18, 
CNST_TABLE_REF(((long)10)), ((long)2)); 
{ /* Llib/ssl.scm 606 */
bool_t BgL_test4277z00_6369;
{ /* Llib/ssl.scm 606 */
long BgL_n1z00_1807;
{ /* Llib/ssl.scm 606 */
obj_t BgL_tmpz00_6370;
if(
INTEGERP(BgL_index1223z00_292))
{ /* Llib/ssl.scm 606 */
BgL_tmpz00_6370 = BgL_index1223z00_292
; }  else 
{ 
obj_t BgL_auxz00_6373;
BgL_auxz00_6373 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)24776)), BGl_string3367z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_index1223z00_292); 
FAILURE(BgL_auxz00_6373,BFALSE,BFALSE);} 
BgL_n1z00_1807 = 
(long)CINT(BgL_tmpz00_6370); } 
BgL_test4277z00_6369 = 
(BgL_n1z00_1807>=((long)0)); } 
if(BgL_test4277z00_6369)
{ 
long BgL_auxz00_6379;
{ /* Llib/ssl.scm 606 */
obj_t BgL_tmpz00_6380;
if(
INTEGERP(BgL_index1223z00_292))
{ /* Llib/ssl.scm 606 */
BgL_tmpz00_6380 = BgL_index1223z00_292
; }  else 
{ 
obj_t BgL_auxz00_6383;
BgL_auxz00_6383 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)24776)), BGl_string3367z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_index1223z00_292); 
FAILURE(BgL_auxz00_6383,BFALSE,BFALSE);} 
BgL_auxz00_6379 = 
(long)CINT(BgL_tmpz00_6380); } 
BgL_timeoutz00_269 = 
VECTOR_REF(BgL_opt1211z00_18,BgL_auxz00_6379); }  else 
{ /* Llib/ssl.scm 606 */BFALSE; } } } 
{ /* Llib/ssl.scm 606 */
obj_t BgL_arg1590z00_294;obj_t BgL_arg1591z00_295;
BgL_arg1590z00_294 = 
VECTOR_REF(BgL_opt1211z00_18,((long)0)); 
BgL_arg1591z00_295 = 
VECTOR_REF(BgL_opt1211z00_18,((long)1)); 
{ /* Llib/ssl.scm 606 */
obj_t BgL_casz00_296;
BgL_casz00_296 = BgL_casz00_262; 
{ /* Llib/ssl.scm 606 */
obj_t BgL_acceptedzd2certszd2_297;
BgL_acceptedzd2certszd2_297 = BgL_acceptedzd2certszd2_263; 
{ /* Llib/ssl.scm 606 */
obj_t BgL_certz00_298;
BgL_certz00_298 = BgL_certz00_264; 
{ /* Llib/ssl.scm 606 */
obj_t BgL_inbufz00_299;
BgL_inbufz00_299 = BgL_inbufz00_265; 
{ /* Llib/ssl.scm 606 */
obj_t BgL_outbufz00_300;
BgL_outbufz00_300 = BgL_outbufz00_266; 
{ /* Llib/ssl.scm 606 */
obj_t BgL_pkeyz00_301;
BgL_pkeyz00_301 = BgL_pkeyz00_267; 
{ /* Llib/ssl.scm 606 */
obj_t BgL_protocolz00_302;
BgL_protocolz00_302 = BgL_protocolz00_268; 
{ /* Llib/ssl.scm 606 */
obj_t BgL_timeoutz00_303;
BgL_timeoutz00_303 = BgL_timeoutz00_269; 
{ /* Llib/ssl.scm 606 */
obj_t BgL_hostnamez00_1809;int BgL_portz00_1810;
if(
STRINGP(BgL_arg1590z00_294))
{ /* Llib/ssl.scm 606 */
BgL_hostnamez00_1809 = BgL_arg1590z00_294; }  else 
{ 
obj_t BgL_auxz00_6393;
BgL_auxz00_6393 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)24776)), BGl_string3367z00zz__ssl_sslz00, BGl_string3369z00zz__ssl_sslz00, BgL_arg1590z00_294); 
FAILURE(BgL_auxz00_6393,BFALSE,BFALSE);} 
{ /* Llib/ssl.scm 606 */
obj_t BgL_tmpz00_6397;
if(
INTEGERP(BgL_arg1591z00_295))
{ /* Llib/ssl.scm 606 */
BgL_tmpz00_6397 = BgL_arg1591z00_295
; }  else 
{ 
obj_t BgL_auxz00_6400;
BgL_auxz00_6400 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)24776)), BGl_string3367z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_arg1591z00_295); 
FAILURE(BgL_auxz00_6400,BFALSE,BFALSE);} 
BgL_portz00_1810 = 
CINT(BgL_tmpz00_6397); } 
BGl_sanityzd2argszd2checksz00zz__ssl_sslz00(
CNST_TABLE_REF(((long)2)), BgL_certz00_298, BgL_pkeyz00_301, BgL_casz00_296, BgL_acceptedzd2certszd2_297); 
BGl_z52socketzd2initz12z92zz__socketz00(); 
{ /* Llib/ssl.scm 616 */
obj_t BgL_arg1624z00_1811;obj_t BgL_arg1645z00_1812;obj_t BgL_arg1646z00_1813;
BgL_arg1624z00_1811 = 
BGl_sslzd2protocolszd2ze3integerze3zz__ssl_sslz00(BgL_protocolz00_302); 
BgL_arg1645z00_1812 = 
BGl_getzd2portzd2bufferz00zz__r4_ports_6_10_1z00(
CNST_TABLE_REF(((long)2)), BgL_inbufz00_299, 
(int)(default_io_bufsiz)); 
BgL_arg1646z00_1813 = 
BGl_getzd2portzd2bufferz00zz__r4_ports_6_10_1z00(
CNST_TABLE_REF(((long)2)), BgL_outbufz00_300, 
(int)(default_io_bufsiz)); 
{ /* Llib/ssl.scm 615 */
obj_t BgL_auxz00_6433;int BgL_auxz00_6424;int BgL_tmpz00_6415;
if(
BGl_pairzd2orzd2nullzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_casz00_296))
{ /* Llib/ssl.scm 618 */
BgL_auxz00_6433 = BgL_casz00_296
; }  else 
{ 
obj_t BgL_auxz00_6436;
BgL_auxz00_6436 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)25165)), BGl_string3367z00zz__ssl_sslz00, BGl_string3370z00zz__ssl_sslz00, BgL_casz00_296); 
FAILURE(BgL_auxz00_6436,BFALSE,BFALSE);} 
{ /* Llib/ssl.scm 616 */
obj_t BgL_tmpz00_6425;
if(
INTEGERP(BgL_arg1624z00_1811))
{ /* Llib/ssl.scm 616 */
BgL_tmpz00_6425 = BgL_arg1624z00_1811
; }  else 
{ 
obj_t BgL_auxz00_6428;
BgL_auxz00_6428 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)25141)), BGl_string3367z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_arg1624z00_1811); 
FAILURE(BgL_auxz00_6428,BFALSE,BFALSE);} 
BgL_auxz00_6424 = 
CINT(BgL_tmpz00_6425); } 
{ /* Llib/ssl.scm 615 */
obj_t BgL_tmpz00_6416;
if(
INTEGERP(BgL_timeoutz00_303))
{ /* Llib/ssl.scm 615 */
BgL_tmpz00_6416 = BgL_timeoutz00_303
; }  else 
{ 
obj_t BgL_auxz00_6419;
BgL_auxz00_6419 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)25095)), BGl_string3367z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_timeoutz00_303); 
FAILURE(BgL_auxz00_6419,BFALSE,BFALSE);} 
BgL_tmpz00_6415 = 
CINT(BgL_tmpz00_6416); } 
return 
bgl_make_ssl_client_socket(BgL_hostnamez00_1809, BgL_portz00_1810, BgL_tmpz00_6415, BgL_auxz00_6424, BgL_certz00_298, BgL_pkeyz00_301, BgL_auxz00_6433, BgL_acceptedzd2certszd2_297, BgL_arg1645z00_1812, BgL_arg1646z00_1813);} } } } } } } } } } } } } } } } } } } } } } } 

}



/* search1213~0 */
obj_t BGl_search1213ze70ze7zz__ssl_sslz00(long BgL_l1212z00_5157, obj_t BgL_opt1211z00_5156, obj_t BgL_k1z00_257, long BgL_iz00_258)
{
{ /* Llib/ssl.scm 606 */
BGl_search1213ze70ze7zz__ssl_sslz00:
if(
(BgL_iz00_258==BgL_l1212z00_5157))
{ /* Llib/ssl.scm 606 */
return 
BINT(((long)-1));}  else 
{ /* Llib/ssl.scm 606 */
if(
(BgL_iz00_258==
(BgL_l1212z00_5157-((long)1))))
{ /* Llib/ssl.scm 606 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)2)), BGl_string3371z00zz__ssl_sslz00, 
BINT(
VECTOR_LENGTH(BgL_opt1211z00_5156)));}  else 
{ /* Llib/ssl.scm 606 */
obj_t BgL_vz00_308;
BgL_vz00_308 = 
VECTOR_REF(BgL_opt1211z00_5156,BgL_iz00_258); 
if(
(BgL_vz00_308==BgL_k1z00_257))
{ /* Llib/ssl.scm 606 */
return 
BINT(
(BgL_iz00_258+((long)1)));}  else 
{ 
long BgL_iz00_6456;
BgL_iz00_6456 = 
(BgL_iz00_258+((long)2)); 
BgL_iz00_258 = BgL_iz00_6456; 
goto BGl_search1213ze70ze7zz__ssl_sslz00;} } } } 

}



/* make-ssl-client-socket */
BGL_EXPORTED_DEF obj_t BGl_makezd2sslzd2clientzd2socketzd2zz__ssl_sslz00(obj_t BgL_hostnamez00_8, int BgL_portz00_9, obj_t BgL_casz00_10, obj_t BgL_acceptedzd2certszd2_11, obj_t BgL_certz00_12, obj_t BgL_inbufz00_13, obj_t BgL_outbufz00_14, obj_t BgL_pkeyz00_15, obj_t BgL_protocolz00_16, obj_t BgL_timeoutz00_17)
{
{ /* Llib/ssl.scm 606 */
BGl_sanityzd2argszd2checksz00zz__ssl_sslz00(
CNST_TABLE_REF(((long)2)), BgL_certz00_12, BgL_pkeyz00_15, BgL_casz00_10, BgL_acceptedzd2certszd2_11); 
BGl_z52socketzd2initz12z92zz__socketz00(); 
{ /* Llib/ssl.scm 616 */
obj_t BgL_arg1624z00_1814;obj_t BgL_arg1645z00_1815;obj_t BgL_arg1646z00_1816;
BgL_arg1624z00_1814 = 
BGl_sslzd2protocolszd2ze3integerze3zz__ssl_sslz00(BgL_protocolz00_16); 
BgL_arg1645z00_1815 = 
BGl_getzd2portzd2bufferz00zz__r4_ports_6_10_1z00(
CNST_TABLE_REF(((long)2)), BgL_inbufz00_13, 
(int)(default_io_bufsiz)); 
BgL_arg1646z00_1816 = 
BGl_getzd2portzd2bufferz00zz__r4_ports_6_10_1z00(
CNST_TABLE_REF(((long)2)), BgL_outbufz00_14, 
(int)(default_io_bufsiz)); 
return 
bgl_make_ssl_client_socket(BgL_hostnamez00_8, BgL_portz00_9, 
CINT(BgL_timeoutz00_17), 
CINT(BgL_arg1624z00_1814), BgL_certz00_12, BgL_pkeyz00_15, BgL_casz00_10, BgL_acceptedzd2certszd2_11, BgL_arg1645z00_1815, BgL_arg1646z00_1816);} } 

}



/* _client-socket-use-ssl! */
obj_t BGl__clientzd2socketzd2usezd2sslz12zc0zz__ssl_sslz00(obj_t BgL_envz00_27, obj_t BgL_opt1226z00_26)
{
{ /* Llib/ssl.scm 629 */
{ /* Llib/ssl.scm 629 */
obj_t BgL_g1236z00_319;
BgL_g1236z00_319 = 
VECTOR_REF(BgL_opt1226z00_26,((long)0)); 
{ /* Llib/ssl.scm 632 */
obj_t BgL_casz00_320;
BgL_casz00_320 = BNIL; 
{ /* Llib/ssl.scm 629 */
obj_t BgL_acceptedzd2certszd2_321;
BgL_acceptedzd2certszd2_321 = BFALSE; 
{ /* Llib/ssl.scm 629 */
obj_t BgL_certz00_322;
BgL_certz00_322 = BFALSE; 
{ /* Llib/ssl.scm 629 */
obj_t BgL_pkeyz00_323;
BgL_pkeyz00_323 = BFALSE; 
{ /* Llib/ssl.scm 630 */
obj_t BgL_protocolz00_324;
BgL_protocolz00_324 = 
CNST_TABLE_REF(((long)0)); 
{ /* Llib/ssl.scm 629 */

{ 
long BgL_iz00_325;
BgL_iz00_325 = ((long)1); 
BgL_check1229z00_326:
if(
(BgL_iz00_325==
VECTOR_LENGTH(BgL_opt1226z00_26)))
{ /* Llib/ssl.scm 629 */BNIL; }  else 
{ /* Llib/ssl.scm 629 */
bool_t BgL_test4289z00_6476;
{ /* Llib/ssl.scm 629 */
obj_t BgL_arg1661z00_332;
BgL_arg1661z00_332 = 
VECTOR_REF(BgL_opt1226z00_26,BgL_iz00_325); 
BgL_test4289z00_6476 = 
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg1661z00_332, 
CNST_TABLE_REF(((long)11)))); } 
if(BgL_test4289z00_6476)
{ 
long BgL_iz00_6481;
BgL_iz00_6481 = 
(BgL_iz00_325+((long)2)); 
BgL_iz00_325 = BgL_iz00_6481; 
goto BgL_check1229z00_326;}  else 
{ /* Llib/ssl.scm 629 */
obj_t BgL_arg1658z00_331;
BgL_arg1658z00_331 = 
VECTOR_REF(BgL_opt1226z00_26,BgL_iz00_325); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)12)), BGl_string3365z00zz__ssl_sslz00, BgL_arg1658z00_331); } } } 
{ /* Llib/ssl.scm 629 */
obj_t BgL_index1231z00_333;
BgL_index1231z00_333 = 
BGl_search1228ze70ze7zz__ssl_sslz00(
VECTOR_LENGTH(BgL_opt1226z00_26), BgL_opt1226z00_26, 
CNST_TABLE_REF(((long)3)), ((long)1)); 
{ /* Llib/ssl.scm 629 */
bool_t BgL_test4290z00_6489;
{ /* Llib/ssl.scm 629 */
long BgL_n1z00_1839;
{ /* Llib/ssl.scm 629 */
obj_t BgL_tmpz00_6490;
if(
INTEGERP(BgL_index1231z00_333))
{ /* Llib/ssl.scm 629 */
BgL_tmpz00_6490 = BgL_index1231z00_333
; }  else 
{ 
obj_t BgL_auxz00_6493;
BgL_auxz00_6493 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)25566)), BGl_string3372z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_index1231z00_333); 
FAILURE(BgL_auxz00_6493,BFALSE,BFALSE);} 
BgL_n1z00_1839 = 
(long)CINT(BgL_tmpz00_6490); } 
BgL_test4290z00_6489 = 
(BgL_n1z00_1839>=((long)0)); } 
if(BgL_test4290z00_6489)
{ 
long BgL_auxz00_6499;
{ /* Llib/ssl.scm 629 */
obj_t BgL_tmpz00_6500;
if(
INTEGERP(BgL_index1231z00_333))
{ /* Llib/ssl.scm 629 */
BgL_tmpz00_6500 = BgL_index1231z00_333
; }  else 
{ 
obj_t BgL_auxz00_6503;
BgL_auxz00_6503 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)25566)), BGl_string3372z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_index1231z00_333); 
FAILURE(BgL_auxz00_6503,BFALSE,BFALSE);} 
BgL_auxz00_6499 = 
(long)CINT(BgL_tmpz00_6500); } 
BgL_casz00_320 = 
VECTOR_REF(BgL_opt1226z00_26,BgL_auxz00_6499); }  else 
{ /* Llib/ssl.scm 629 */BFALSE; } } } 
{ /* Llib/ssl.scm 629 */
obj_t BgL_index1232z00_335;
BgL_index1232z00_335 = 
BGl_search1228ze70ze7zz__ssl_sslz00(
VECTOR_LENGTH(BgL_opt1226z00_26), BgL_opt1226z00_26, 
CNST_TABLE_REF(((long)4)), ((long)1)); 
{ /* Llib/ssl.scm 629 */
bool_t BgL_test4293z00_6512;
{ /* Llib/ssl.scm 629 */
long BgL_n1z00_1841;
{ /* Llib/ssl.scm 629 */
obj_t BgL_tmpz00_6513;
if(
INTEGERP(BgL_index1232z00_335))
{ /* Llib/ssl.scm 629 */
BgL_tmpz00_6513 = BgL_index1232z00_335
; }  else 
{ 
obj_t BgL_auxz00_6516;
BgL_auxz00_6516 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)25566)), BGl_string3372z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_index1232z00_335); 
FAILURE(BgL_auxz00_6516,BFALSE,BFALSE);} 
BgL_n1z00_1841 = 
(long)CINT(BgL_tmpz00_6513); } 
BgL_test4293z00_6512 = 
(BgL_n1z00_1841>=((long)0)); } 
if(BgL_test4293z00_6512)
{ 
long BgL_auxz00_6522;
{ /* Llib/ssl.scm 629 */
obj_t BgL_tmpz00_6523;
if(
INTEGERP(BgL_index1232z00_335))
{ /* Llib/ssl.scm 629 */
BgL_tmpz00_6523 = BgL_index1232z00_335
; }  else 
{ 
obj_t BgL_auxz00_6526;
BgL_auxz00_6526 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)25566)), BGl_string3372z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_index1232z00_335); 
FAILURE(BgL_auxz00_6526,BFALSE,BFALSE);} 
BgL_auxz00_6522 = 
(long)CINT(BgL_tmpz00_6523); } 
BgL_acceptedzd2certszd2_321 = 
VECTOR_REF(BgL_opt1226z00_26,BgL_auxz00_6522); }  else 
{ /* Llib/ssl.scm 629 */BFALSE; } } } 
{ /* Llib/ssl.scm 629 */
obj_t BgL_index1233z00_337;
BgL_index1233z00_337 = 
BGl_search1228ze70ze7zz__ssl_sslz00(
VECTOR_LENGTH(BgL_opt1226z00_26), BgL_opt1226z00_26, 
CNST_TABLE_REF(((long)5)), ((long)1)); 
{ /* Llib/ssl.scm 629 */
bool_t BgL_test4296z00_6535;
{ /* Llib/ssl.scm 629 */
long BgL_n1z00_1843;
{ /* Llib/ssl.scm 629 */
obj_t BgL_tmpz00_6536;
if(
INTEGERP(BgL_index1233z00_337))
{ /* Llib/ssl.scm 629 */
BgL_tmpz00_6536 = BgL_index1233z00_337
; }  else 
{ 
obj_t BgL_auxz00_6539;
BgL_auxz00_6539 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)25566)), BGl_string3372z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_index1233z00_337); 
FAILURE(BgL_auxz00_6539,BFALSE,BFALSE);} 
BgL_n1z00_1843 = 
(long)CINT(BgL_tmpz00_6536); } 
BgL_test4296z00_6535 = 
(BgL_n1z00_1843>=((long)0)); } 
if(BgL_test4296z00_6535)
{ 
long BgL_auxz00_6545;
{ /* Llib/ssl.scm 629 */
obj_t BgL_tmpz00_6546;
if(
INTEGERP(BgL_index1233z00_337))
{ /* Llib/ssl.scm 629 */
BgL_tmpz00_6546 = BgL_index1233z00_337
; }  else 
{ 
obj_t BgL_auxz00_6549;
BgL_auxz00_6549 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)25566)), BGl_string3372z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_index1233z00_337); 
FAILURE(BgL_auxz00_6549,BFALSE,BFALSE);} 
BgL_auxz00_6545 = 
(long)CINT(BgL_tmpz00_6546); } 
BgL_certz00_322 = 
VECTOR_REF(BgL_opt1226z00_26,BgL_auxz00_6545); }  else 
{ /* Llib/ssl.scm 629 */BFALSE; } } } 
{ /* Llib/ssl.scm 629 */
obj_t BgL_index1234z00_339;
BgL_index1234z00_339 = 
BGl_search1228ze70ze7zz__ssl_sslz00(
VECTOR_LENGTH(BgL_opt1226z00_26), BgL_opt1226z00_26, 
CNST_TABLE_REF(((long)8)), ((long)1)); 
{ /* Llib/ssl.scm 629 */
bool_t BgL_test4299z00_6558;
{ /* Llib/ssl.scm 629 */
long BgL_n1z00_1845;
{ /* Llib/ssl.scm 629 */
obj_t BgL_tmpz00_6559;
if(
INTEGERP(BgL_index1234z00_339))
{ /* Llib/ssl.scm 629 */
BgL_tmpz00_6559 = BgL_index1234z00_339
; }  else 
{ 
obj_t BgL_auxz00_6562;
BgL_auxz00_6562 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)25566)), BGl_string3372z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_index1234z00_339); 
FAILURE(BgL_auxz00_6562,BFALSE,BFALSE);} 
BgL_n1z00_1845 = 
(long)CINT(BgL_tmpz00_6559); } 
BgL_test4299z00_6558 = 
(BgL_n1z00_1845>=((long)0)); } 
if(BgL_test4299z00_6558)
{ 
long BgL_auxz00_6568;
{ /* Llib/ssl.scm 629 */
obj_t BgL_tmpz00_6569;
if(
INTEGERP(BgL_index1234z00_339))
{ /* Llib/ssl.scm 629 */
BgL_tmpz00_6569 = BgL_index1234z00_339
; }  else 
{ 
obj_t BgL_auxz00_6572;
BgL_auxz00_6572 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)25566)), BGl_string3372z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_index1234z00_339); 
FAILURE(BgL_auxz00_6572,BFALSE,BFALSE);} 
BgL_auxz00_6568 = 
(long)CINT(BgL_tmpz00_6569); } 
BgL_pkeyz00_323 = 
VECTOR_REF(BgL_opt1226z00_26,BgL_auxz00_6568); }  else 
{ /* Llib/ssl.scm 629 */BFALSE; } } } 
{ /* Llib/ssl.scm 629 */
obj_t BgL_index1235z00_341;
BgL_index1235z00_341 = 
BGl_search1228ze70ze7zz__ssl_sslz00(
VECTOR_LENGTH(BgL_opt1226z00_26), BgL_opt1226z00_26, 
CNST_TABLE_REF(((long)9)), ((long)1)); 
{ /* Llib/ssl.scm 629 */
bool_t BgL_test4302z00_6581;
{ /* Llib/ssl.scm 629 */
long BgL_n1z00_1847;
{ /* Llib/ssl.scm 629 */
obj_t BgL_tmpz00_6582;
if(
INTEGERP(BgL_index1235z00_341))
{ /* Llib/ssl.scm 629 */
BgL_tmpz00_6582 = BgL_index1235z00_341
; }  else 
{ 
obj_t BgL_auxz00_6585;
BgL_auxz00_6585 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)25566)), BGl_string3372z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_index1235z00_341); 
FAILURE(BgL_auxz00_6585,BFALSE,BFALSE);} 
BgL_n1z00_1847 = 
(long)CINT(BgL_tmpz00_6582); } 
BgL_test4302z00_6581 = 
(BgL_n1z00_1847>=((long)0)); } 
if(BgL_test4302z00_6581)
{ 
long BgL_auxz00_6591;
{ /* Llib/ssl.scm 629 */
obj_t BgL_tmpz00_6592;
if(
INTEGERP(BgL_index1235z00_341))
{ /* Llib/ssl.scm 629 */
BgL_tmpz00_6592 = BgL_index1235z00_341
; }  else 
{ 
obj_t BgL_auxz00_6595;
BgL_auxz00_6595 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)25566)), BGl_string3372z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_index1235z00_341); 
FAILURE(BgL_auxz00_6595,BFALSE,BFALSE);} 
BgL_auxz00_6591 = 
(long)CINT(BgL_tmpz00_6592); } 
BgL_protocolz00_324 = 
VECTOR_REF(BgL_opt1226z00_26,BgL_auxz00_6591); }  else 
{ /* Llib/ssl.scm 629 */BFALSE; } } } 
{ /* Llib/ssl.scm 629 */
obj_t BgL_arg1668z00_343;
BgL_arg1668z00_343 = 
VECTOR_REF(BgL_opt1226z00_26,((long)0)); 
{ /* Llib/ssl.scm 629 */
obj_t BgL_casz00_344;
BgL_casz00_344 = BgL_casz00_320; 
{ /* Llib/ssl.scm 629 */
obj_t BgL_acceptedzd2certszd2_345;
BgL_acceptedzd2certszd2_345 = BgL_acceptedzd2certszd2_321; 
{ /* Llib/ssl.scm 629 */
obj_t BgL_certz00_346;
BgL_certz00_346 = BgL_certz00_322; 
{ /* Llib/ssl.scm 629 */
obj_t BgL_pkeyz00_347;
BgL_pkeyz00_347 = BgL_pkeyz00_323; 
{ /* Llib/ssl.scm 629 */
obj_t BgL_protocolz00_348;
BgL_protocolz00_348 = BgL_protocolz00_324; 
{ /* Llib/ssl.scm 629 */
obj_t BgL_sz00_1849;
if(
SOCKETP(BgL_arg1668z00_343))
{ /* Llib/ssl.scm 629 */
BgL_sz00_1849 = BgL_arg1668z00_343; }  else 
{ 
obj_t BgL_auxz00_6604;
BgL_auxz00_6604 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)25566)), BGl_string3372z00zz__ssl_sslz00, BGl_string3373z00zz__ssl_sslz00, BgL_arg1668z00_343); 
FAILURE(BgL_auxz00_6604,BFALSE,BFALSE);} 
BGl_sanityzd2argszd2checksz00zz__ssl_sslz00(
CNST_TABLE_REF(((long)12)), BgL_certz00_346, BgL_pkeyz00_347, BgL_casz00_344, BgL_acceptedzd2certszd2_345); 
BGl_z52socketzd2initz12z92zz__socketz00(); 
{ /* Llib/ssl.scm 636 */
obj_t BgL_arg1680z00_1850;
BgL_arg1680z00_1850 = 
BGl_sslzd2protocolszd2ze3integerze3zz__ssl_sslz00(BgL_protocolz00_348); 
{ /* Llib/ssl.scm 635 */
obj_t BgL_auxz00_6621;int BgL_tmpz00_6612;
if(
BGl_pairzd2orzd2nullzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_casz00_344))
{ /* Llib/ssl.scm 638 */
BgL_auxz00_6621 = BgL_casz00_344
; }  else 
{ 
obj_t BgL_auxz00_6624;
BgL_auxz00_6624 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)25880)), BGl_string3372z00zz__ssl_sslz00, BGl_string3370z00zz__ssl_sslz00, BgL_casz00_344); 
FAILURE(BgL_auxz00_6624,BFALSE,BFALSE);} 
{ /* Llib/ssl.scm 636 */
obj_t BgL_tmpz00_6613;
if(
INTEGERP(BgL_arg1680z00_1850))
{ /* Llib/ssl.scm 636 */
BgL_tmpz00_6613 = BgL_arg1680z00_1850
; }  else 
{ 
obj_t BgL_auxz00_6616;
BgL_auxz00_6616 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)25856)), BGl_string3372z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_arg1680z00_1850); 
FAILURE(BgL_auxz00_6616,BFALSE,BFALSE);} 
BgL_tmpz00_6612 = 
CINT(BgL_tmpz00_6613); } 
return 
bgl_client_socket_use_ssl(BgL_sz00_1849, BgL_tmpz00_6612, BgL_certz00_346, BgL_pkeyz00_347, BgL_auxz00_6621, BgL_acceptedzd2certszd2_345);} } } } } } } } } } } } } } } } } 

}



/* search1228~0 */
obj_t BGl_search1228ze70ze7zz__ssl_sslz00(long BgL_l1227z00_5155, obj_t BgL_opt1226z00_5154, obj_t BgL_k1z00_316, long BgL_iz00_317)
{
{ /* Llib/ssl.scm 629 */
BGl_search1228ze70ze7zz__ssl_sslz00:
if(
(BgL_iz00_317==BgL_l1227z00_5155))
{ /* Llib/ssl.scm 629 */
return 
BINT(((long)-1));}  else 
{ /* Llib/ssl.scm 629 */
if(
(BgL_iz00_317==
(BgL_l1227z00_5155-((long)1))))
{ /* Llib/ssl.scm 629 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)12)), BGl_string3374z00zz__ssl_sslz00, 
BINT(
VECTOR_LENGTH(BgL_opt1226z00_5154)));}  else 
{ /* Llib/ssl.scm 629 */
obj_t BgL_vz00_353;
BgL_vz00_353 = 
VECTOR_REF(BgL_opt1226z00_5154,BgL_iz00_317); 
if(
(BgL_vz00_353==BgL_k1z00_316))
{ /* Llib/ssl.scm 629 */
return 
BINT(
(BgL_iz00_317+((long)1)));}  else 
{ 
long BgL_iz00_6644;
BgL_iz00_6644 = 
(BgL_iz00_317+((long)2)); 
BgL_iz00_317 = BgL_iz00_6644; 
goto BGl_search1228ze70ze7zz__ssl_sslz00;} } } } 

}



/* client-socket-use-ssl! */
BGL_EXPORTED_DEF obj_t BGl_clientzd2socketzd2usezd2sslz12zc0zz__ssl_sslz00(obj_t BgL_sz00_20, obj_t BgL_casz00_21, obj_t BgL_acceptedzd2certszd2_22, obj_t BgL_certz00_23, obj_t BgL_pkeyz00_24, obj_t BgL_protocolz00_25)
{
{ /* Llib/ssl.scm 629 */
BGl_sanityzd2argszd2checksz00zz__ssl_sslz00(
CNST_TABLE_REF(((long)12)), BgL_certz00_23, BgL_pkeyz00_24, BgL_casz00_21, BgL_acceptedzd2certszd2_22); 
BGl_z52socketzd2initz12z92zz__socketz00(); 
{ /* Llib/ssl.scm 636 */
obj_t BgL_arg1680z00_1851;
BgL_arg1680z00_1851 = 
BGl_sslzd2protocolszd2ze3integerze3zz__ssl_sslz00(BgL_protocolz00_25); 
return 
bgl_client_socket_use_ssl(BgL_sz00_20, 
CINT(BgL_arg1680z00_1851), BgL_certz00_23, BgL_pkeyz00_24, BgL_casz00_21, BgL_acceptedzd2certszd2_22);} } 

}



/* ssl-socket? */
BGL_EXPORTED_DEF bool_t BGl_sslzd2socketzf3z21zz__ssl_sslz00(obj_t BgL_objz00_28)
{
{ /* Llib/ssl.scm 643 */
return 
bgl_ssl_socketp(BgL_objz00_28);} 

}



/* &ssl-socket? */
obj_t BGl_z62sslzd2socketzf3z43zz__ssl_sslz00(obj_t BgL_envz00_4153, obj_t BgL_objz00_4154)
{
{ /* Llib/ssl.scm 643 */
return 
BBOOL(
BGl_sslzd2socketzf3z21zz__ssl_sslz00(BgL_objz00_4154));} 

}



/* make-ssl-server-socket */
BGL_EXPORTED_DEF obj_t BGl_makezd2sslzd2serverzd2socketzd2zz__ssl_sslz00(obj_t BgL_portz00_29)
{
{ /* Llib/ssl.scm 651 */
{ /* Llib/ssl.scm 336 */
obj_t BgL_dsssl1237z00_358;
BgL_dsssl1237z00_358 = BgL_portz00_29; 
{ /* Llib/ssl.scm 336 */
obj_t BgL_portz00_359;
{ /* Llib/ssl.scm 336 */
bool_t BgL_test4311z00_6655;
if(
NULLP(BgL_dsssl1237z00_358))
{ /* Llib/ssl.scm 336 */
BgL_test4311z00_6655 = ((bool_t)1)
; }  else 
{ /* Llib/ssl.scm 336 */
BgL_test4311z00_6655 = 
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(
CAR(BgL_dsssl1237z00_358), 
CNST_TABLE_REF(((long)13))))
; } 
if(BgL_test4311z00_6655)
{ /* Llib/ssl.scm 336 */
BgL_portz00_359 = 
BINT(((long)0)); }  else 
{ /* Llib/ssl.scm 336 */
obj_t BgL_tmp1238z00_385;
BgL_tmp1238z00_385 = 
CAR(BgL_dsssl1237z00_358); 
BgL_dsssl1237z00_358 = 
CDR(BgL_dsssl1237z00_358); 
BgL_portz00_359 = BgL_tmp1238z00_385; } } 
{ /* Llib/ssl.scm 336 */
obj_t BgL_namez00_360;
BgL_namez00_360 = 
BGl_dssslzd2getzd2keyzd2argzd2zz__dssslz00(BgL_dsssl1237z00_358, 
CNST_TABLE_REF(((long)14)), BFALSE); 
{ /* Llib/ssl.scm 336 */
obj_t BgL_protocolz00_361;
BgL_protocolz00_361 = 
BGl_dssslzd2getzd2keyzd2argzd2zz__dssslz00(BgL_dsssl1237z00_358, 
CNST_TABLE_REF(((long)9)), 
CNST_TABLE_REF(((long)0))); 
{ /* Llib/ssl.scm 336 */
obj_t BgL_certz00_362;
BgL_certz00_362 = 
BGl_dssslzd2getzd2keyzd2argzd2zz__dssslz00(BgL_dsssl1237z00_358, 
CNST_TABLE_REF(((long)5)), BFALSE); 
{ /* Llib/ssl.scm 336 */
obj_t BgL_pkeyz00_363;
BgL_pkeyz00_363 = 
BGl_dssslzd2getzd2keyzd2argzd2zz__dssslz00(BgL_dsssl1237z00_358, 
CNST_TABLE_REF(((long)8)), BFALSE); 
{ /* Llib/ssl.scm 336 */
obj_t BgL_casz00_364;
BgL_casz00_364 = 
BGl_dssslzd2getzd2keyzd2argzd2zz__dssslz00(BgL_dsssl1237z00_358, 
CNST_TABLE_REF(((long)3)), BNIL); 
{ /* Llib/ssl.scm 336 */
obj_t BgL_acceptedzd2certszd2_365;
BgL_acceptedzd2certszd2_365 = 
BGl_dssslzd2getzd2keyzd2argzd2zz__dssslz00(BgL_dsssl1237z00_358, 
CNST_TABLE_REF(((long)4)), BFALSE); 
{ /* Llib/ssl.scm 336 */
obj_t BgL_backlogz00_366;
BgL_backlogz00_366 = 
BGl_dssslzd2getzd2keyzd2argzd2zz__dssslz00(BgL_dsssl1237z00_358, 
CNST_TABLE_REF(((long)15)), 
BINT(((long)5))); 
{ /* Llib/ssl.scm 336 */
obj_t BgL_ipv6z00_367;
BgL_ipv6z00_367 = 
BGl_dssslzd2getzd2keyzd2argzd2zz__dssslz00(BgL_dsssl1237z00_358, 
CNST_TABLE_REF(((long)16)), BFALSE); 
if(
NULLP(
BGl_dssslzd2getzd2keyzd2restzd2argz00zz__dssslz00(BgL_dsssl1237z00_358, 
CNST_TABLE_REF(((long)13)))))
{ /* Llib/ssl.scm 336 */
BGl_sanityzd2argszd2checksz00zz__ssl_sslz00(
CNST_TABLE_REF(((long)17)), BgL_certz00_362, BgL_pkeyz00_363, BgL_casz00_364, BgL_acceptedzd2certszd2_365); 
BGl_z52socketzd2initz12z92zz__socketz00(); 
{ /* Llib/ssl.scm 659 */
obj_t BgL_arg1684z00_370;
BgL_arg1684z00_370 = 
BGl_sslzd2protocolszd2ze3integerze3zz__ssl_sslz00(BgL_protocolz00_361); 
return 
bgl_make_ssl_server_socket(BgL_namez00_360, 
CINT(BgL_portz00_359), 
CINT(BgL_arg1684z00_370), BgL_certz00_362, BgL_pkeyz00_363, BgL_casz00_364, BgL_acceptedzd2certszd2_365, 
CINT(BgL_backlogz00_366), 
CBOOL(BgL_ipv6z00_367));} }  else 
{ /* Llib/ssl.scm 336 */
obj_t BgL_arg1685z00_371;
{ /* Llib/ssl.scm 336 */
obj_t BgL_arg1686z00_372;
{ /* Llib/ssl.scm 336 */
obj_t BgL_arg1694z00_375;
BgL_arg1694z00_375 = 
BGl_dssslzd2getzd2keyzd2restzd2argz00zz__dssslz00(BgL_dsssl1237z00_358, 
CNST_TABLE_REF(((long)13))); 
{ /* Llib/ssl.scm 336 */
obj_t BgL_list1695z00_376;
BgL_list1695z00_376 = 
MAKE_YOUNG_PAIR(BgL_arg1694z00_375, BNIL); 
BgL_arg1686z00_372 = 
BGl_mapz00zz__r4_control_features_6_9z00(BGl_proc3375z00zz__ssl_sslz00, BgL_list1695z00_376); } } 
{ /* Llib/ssl.scm 336 */
obj_t BgL_list1687z00_373;
BgL_list1687z00_373 = 
MAKE_YOUNG_PAIR(BgL_arg1686z00_372, BNIL); 
BgL_arg1685z00_371 = 
BGl_applyz00zz__r4_control_features_6_9z00(BGl_stringzd2appendzd2envz00zz__r4_strings_6_7z00, BGl_string3376z00zz__ssl_sslz00, BgL_list1687z00_373); } } 
return 
BGl_errorz00zz__errorz00(BGl_string3377z00zz__ssl_sslz00, BgL_arg1685z00_371, BgL_dsssl1237z00_358);} } } } } } } } } } } } 

}



/* &make-ssl-server-socket */
obj_t BGl_z62makezd2sslzd2serverzd2socketzb0zz__ssl_sslz00(obj_t BgL_envz00_4156, obj_t BgL_portz00_4157)
{
{ /* Llib/ssl.scm 651 */
return 
BGl_makezd2sslzd2serverzd2socketzd2zz__ssl_sslz00(BgL_portz00_4157);} 

}



/* &<@anonymous:1696> */
obj_t BGl_z62zc3z04anonymousza31696ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4158, obj_t BgL_vz00_4159)
{
{ /* Llib/ssl.scm 336 */
{ /* Llib/ssl.scm 336 */
obj_t BgL_list1697z00_5669;
BgL_list1697z00_5669 = 
MAKE_YOUNG_PAIR(BgL_vz00_4159, BNIL); 
return 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string3378z00zz__ssl_sslz00, BgL_list1697z00_5669);} } 

}



/* ssl-protocols->integer */
obj_t BGl_sslzd2protocolszd2ze3integerze3zz__ssl_sslz00(obj_t BgL_protocolz00_30)
{
{ /* Llib/ssl.scm 666 */
{ /* Llib/ssl.scm 667 */
obj_t BgL_casezd2valuezd2_388;
{ /* Llib/ssl.scm 667 */
obj_t BgL_arg1718z00_403;
{ /* Llib/ssl.scm 667 */
obj_t BgL_arg1719z00_404;
{ /* Llib/ssl.scm 667 */
obj_t BgL_res2337z00_1860;
BgL_res2337z00_1860 = 
SYMBOL_TO_STRING(
((obj_t)BgL_protocolz00_30)); 
BgL_arg1719z00_404 = BgL_res2337z00_1860; } 
BgL_arg1718z00_403 = 
BGl_stringzd2downcasezd2zz__r4_strings_6_7z00(BgL_arg1719z00_404); } 
BgL_casezd2valuezd2_388 = 
bstring_to_symbol(BgL_arg1718z00_403); } 
if(
(BgL_casezd2valuezd2_388==
CNST_TABLE_REF(((long)18))))
{ /* Llib/ssl.scm 667 */
return 
BINT(BGLSSL_SSLV2);}  else 
{ /* Llib/ssl.scm 667 */
if(
(BgL_casezd2valuezd2_388==
CNST_TABLE_REF(((long)19))))
{ /* Llib/ssl.scm 667 */
return 
BINT(BGLSSL_SSLV3);}  else 
{ /* Llib/ssl.scm 667 */
bool_t BgL_test4316z00_6718;
{ /* Llib/ssl.scm 667 */
bool_t BgL__ortest_1123z00_402;
BgL__ortest_1123z00_402 = 
(BgL_casezd2valuezd2_388==
CNST_TABLE_REF(((long)20))); 
if(BgL__ortest_1123z00_402)
{ /* Llib/ssl.scm 667 */
BgL_test4316z00_6718 = BgL__ortest_1123z00_402
; }  else 
{ /* Llib/ssl.scm 667 */
BgL_test4316z00_6718 = 
(BgL_casezd2valuezd2_388==
CNST_TABLE_REF(((long)0)))
; } } 
if(BgL_test4316z00_6718)
{ /* Llib/ssl.scm 667 */
return 
BINT(BGLSSL_SSLV23);}  else 
{ /* Llib/ssl.scm 667 */
bool_t BgL_test4318z00_6725;
{ /* Llib/ssl.scm 667 */
bool_t BgL__ortest_1124z00_401;
BgL__ortest_1124z00_401 = 
(BgL_casezd2valuezd2_388==
CNST_TABLE_REF(((long)21))); 
if(BgL__ortest_1124z00_401)
{ /* Llib/ssl.scm 667 */
BgL_test4318z00_6725 = BgL__ortest_1124z00_401
; }  else 
{ /* Llib/ssl.scm 667 */
BgL_test4318z00_6725 = 
(BgL_casezd2valuezd2_388==
CNST_TABLE_REF(((long)22)))
; } } 
if(BgL_test4318z00_6725)
{ /* Llib/ssl.scm 667 */
return 
BINT(BGLSSL_TLSV1);}  else 
{ /* Llib/ssl.scm 667 */
if(
(BgL_casezd2valuezd2_388==
CNST_TABLE_REF(((long)23))))
{ /* Llib/ssl.scm 667 */
return 
BINT(BGLSSL_TLSV1_1);}  else 
{ /* Llib/ssl.scm 667 */
if(
(BgL_casezd2valuezd2_388==
CNST_TABLE_REF(((long)24))))
{ /* Llib/ssl.scm 667 */
return 
BINT(BGLSSL_TLSV1_2);}  else 
{ /* Llib/ssl.scm 667 */
if(
(BgL_casezd2valuezd2_388==
CNST_TABLE_REF(((long)25))))
{ /* Llib/ssl.scm 667 */
return 
BINT(BGLSSL_TLSV1_3);}  else 
{ /* Llib/ssl.scm 667 */
bool_t BgL_test4323z00_6744;
{ /* Llib/ssl.scm 667 */
bool_t BgL__ortest_1125z00_400;
BgL__ortest_1125z00_400 = 
(BgL_casezd2valuezd2_388==
CNST_TABLE_REF(((long)26))); 
if(BgL__ortest_1125z00_400)
{ /* Llib/ssl.scm 667 */
BgL_test4323z00_6744 = BgL__ortest_1125z00_400
; }  else 
{ /* Llib/ssl.scm 667 */
BgL_test4323z00_6744 = 
(BgL_casezd2valuezd2_388==
CNST_TABLE_REF(((long)27)))
; } } 
if(BgL_test4323z00_6744)
{ /* Llib/ssl.scm 667 */
return 
BINT(BGLSSL_DTLSV1);}  else 
{ /* Llib/ssl.scm 667 */
return 
BGl_errorz00zz__errorz00(BGl_string3379z00zz__ssl_sslz00, BGl_string3380z00zz__ssl_sslz00, BgL_protocolz00_30);} } } } } } } } } } 

}



/* read-private-key */
BGL_EXPORTED_DEF BgL_privatezd2keyzd2_bglt BGl_readzd2privatezd2keyz00zz__ssl_sslz00(obj_t BgL_filez00_31)
{
{ /* Llib/ssl.scm 681 */
return 
((BgL_privatezd2keyzd2_bglt)
bgl_ssl_load_private_key(BgL_filez00_31));} 

}



/* &read-private-key */
BgL_privatezd2keyzd2_bglt BGl_z62readzd2privatezd2keyz62zz__ssl_sslz00(obj_t BgL_envz00_4162, obj_t BgL_filez00_4163)
{
{ /* Llib/ssl.scm 681 */
{ /* Llib/ssl.scm 682 */
obj_t BgL_auxz00_6754;
if(
STRINGP(BgL_filez00_4163))
{ /* Llib/ssl.scm 682 */
BgL_auxz00_6754 = BgL_filez00_4163
; }  else 
{ 
obj_t BgL_auxz00_6757;
BgL_auxz00_6757 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)27886)), BGl_string3381z00zz__ssl_sslz00, BGl_string3369z00zz__ssl_sslz00, BgL_filez00_4163); 
FAILURE(BgL_auxz00_6757,BFALSE,BFALSE);} 
return 
BGl_readzd2privatezd2keyz00zz__ssl_sslz00(BgL_auxz00_6754);} } 

}



/* read-certificate */
BGL_EXPORTED_DEF BgL_certificatez00_bglt BGl_readzd2certificatezd2zz__ssl_sslz00(obj_t BgL_filez00_32)
{
{ /* Llib/ssl.scm 687 */
return 
((BgL_certificatez00_bglt)
bgl_ssl_load_certificate(BgL_filez00_32));} 

}



/* &read-certificate */
BgL_certificatez00_bglt BGl_z62readzd2certificatezb0zz__ssl_sslz00(obj_t BgL_envz00_4164, obj_t BgL_filez00_4165)
{
{ /* Llib/ssl.scm 687 */
{ /* Llib/ssl.scm 688 */
obj_t BgL_auxz00_6764;
if(
STRINGP(BgL_filez00_4165))
{ /* Llib/ssl.scm 688 */
BgL_auxz00_6764 = BgL_filez00_4165
; }  else 
{ 
obj_t BgL_auxz00_6767;
BgL_auxz00_6767 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)28192)), BGl_string3382z00zz__ssl_sslz00, BGl_string3369z00zz__ssl_sslz00, BgL_filez00_4165); 
FAILURE(BgL_auxz00_6767,BFALSE,BFALSE);} 
return 
BGl_readzd2certificatezd2zz__ssl_sslz00(BgL_auxz00_6764);} } 

}



/* read-pem-file */
BGL_EXPORTED_DEF obj_t BGl_readzd2pemzd2filez00zz__ssl_sslz00(obj_t BgL_filez00_33)
{
{ /* Llib/ssl.scm 693 */
return 
bgl_ssl_load_pem(BgL_filez00_33);} 

}



/* &read-pem-file */
obj_t BGl_z62readzd2pemzd2filez62zz__ssl_sslz00(obj_t BgL_envz00_4166, obj_t BgL_filez00_4167)
{
{ /* Llib/ssl.scm 693 */
{ /* Llib/ssl.scm 694 */
obj_t BgL_auxz00_6773;
if(
STRINGP(BgL_filez00_4167))
{ /* Llib/ssl.scm 694 */
BgL_auxz00_6773 = BgL_filez00_4167
; }  else 
{ 
obj_t BgL_auxz00_6776;
BgL_auxz00_6776 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)28492)), BGl_string3383z00zz__ssl_sslz00, BGl_string3369z00zz__ssl_sslz00, BgL_filez00_4167); 
FAILURE(BgL_auxz00_6776,BFALSE,BFALSE);} 
return 
BGl_readzd2pemzd2filez00zz__ssl_sslz00(BgL_auxz00_6773);} } 

}



/* ssl-rand-status */
BGL_EXPORTED_DEF bool_t BGl_sslzd2randzd2statusz00zz__ssl_sslz00()
{
{ /* Llib/ssl.scm 699 */
return 
RAND_status();} 

}



/* &ssl-rand-status */
obj_t BGl_z62sslzd2randzd2statusz62zz__ssl_sslz00(obj_t BgL_envz00_4168)
{
{ /* Llib/ssl.scm 699 */
return 
BBOOL(
BGl_sslzd2randzd2statusz00zz__ssl_sslz00());} 

}



/* ssl-rand-poll */
BGL_EXPORTED_DEF bool_t BGl_sslzd2randzd2pollz00zz__ssl_sslz00()
{
{ /* Llib/ssl.scm 707 */
return 
RAND_poll();} 

}



/* &ssl-rand-poll */
obj_t BGl_z62sslzd2randzd2pollz62zz__ssl_sslz00(obj_t BgL_envz00_4169)
{
{ /* Llib/ssl.scm 707 */
return 
BBOOL(
BGl_sslzd2randzd2pollz00zz__ssl_sslz00());} 

}



/* ssl-rand-bytes */
BGL_EXPORTED_DEF obj_t BGl_sslzd2randzd2bytesz00zz__ssl_sslz00(int BgL_sza7za7_34)
{
{ /* Llib/ssl.scm 715 */
{ /* Llib/ssl.scm 716 */
obj_t BgL_strz00_1873;
{ /* Llib/ssl.scm 716 */

BgL_strz00_1873 = 
make_string(
(long)(BgL_sza7za7_34), ((unsigned char)' ')); } 
{ /* Llib/ssl.scm 719 */
char * BgL_tmpz00_6789;
BgL_tmpz00_6789 = 
BSTRING_TO_STRING(BgL_strz00_1873); 
RAND_bytes(BgL_tmpz00_6789, BgL_sza7za7_34); } 
return BgL_strz00_1873;} } 

}



/* &ssl-rand-bytes */
obj_t BGl_z62sslzd2randzd2bytesz62zz__ssl_sslz00(obj_t BgL_envz00_4170, obj_t BgL_sza7za7_4171)
{
{ /* Llib/ssl.scm 715 */
{ /* Llib/ssl.scm 716 */
int BgL_auxz00_6792;
{ /* Llib/ssl.scm 716 */
obj_t BgL_tmpz00_6793;
if(
INTEGERP(BgL_sza7za7_4171))
{ /* Llib/ssl.scm 716 */
BgL_tmpz00_6793 = BgL_sza7za7_4171
; }  else 
{ 
obj_t BgL_auxz00_6796;
BgL_auxz00_6796 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)29415)), BGl_string3384z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_sza7za7_4171); 
FAILURE(BgL_auxz00_6796,BFALSE,BFALSE);} 
BgL_auxz00_6792 = 
CINT(BgL_tmpz00_6793); } 
return 
BGl_sslzd2randzd2bytesz00zz__ssl_sslz00(BgL_auxz00_6792);} } 

}



/* ssl-rand-pseudo-bytes */
BGL_EXPORTED_DEF obj_t BGl_sslzd2randzd2pseudozd2byteszd2zz__ssl_sslz00(int BgL_sza7za7_35)
{
{ /* Llib/ssl.scm 732 */
{ /* Llib/ssl.scm 733 */
obj_t BgL_strz00_1878;
{ /* Llib/ssl.scm 733 */

BgL_strz00_1878 = 
make_string(
(long)(BgL_sza7za7_35), ((unsigned char)' ')); } 
{ /* Llib/ssl.scm 736 */
char * BgL_tmpz00_6804;
BgL_tmpz00_6804 = 
BSTRING_TO_STRING(BgL_strz00_1878); 
RAND_pseudo_bytes(BgL_tmpz00_6804, BgL_sza7za7_35); } 
return BgL_strz00_1878;} } 

}



/* &ssl-rand-pseudo-bytes */
obj_t BGl_z62sslzd2randzd2pseudozd2byteszb0zz__ssl_sslz00(obj_t BgL_envz00_4172, obj_t BgL_sza7za7_4173)
{
{ /* Llib/ssl.scm 732 */
{ /* Llib/ssl.scm 733 */
int BgL_auxz00_6807;
{ /* Llib/ssl.scm 733 */
obj_t BgL_tmpz00_6808;
if(
INTEGERP(BgL_sza7za7_4173))
{ /* Llib/ssl.scm 733 */
BgL_tmpz00_6808 = BgL_sza7za7_4173
; }  else 
{ 
obj_t BgL_auxz00_6811;
BgL_auxz00_6811 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)29933)), BGl_string3385z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_sza7za7_4173); 
FAILURE(BgL_auxz00_6811,BFALSE,BFALSE);} 
BgL_auxz00_6807 = 
CINT(BgL_tmpz00_6808); } 
return 
BGl_sslzd2randzd2pseudozd2byteszd2zz__ssl_sslz00(BgL_auxz00_6807);} } 

}



/* certificate-subject */
BGL_EXPORTED_DEF obj_t BGl_certificatezd2subjectzd2zz__ssl_sslz00(BgL_certificatez00_bglt BgL_certz00_36)
{
{ /* Llib/ssl.scm 749 */
return 
bgl_ssl_certificate_subject(
((obj_t)BgL_certz00_36));} 

}



/* &certificate-subject */
obj_t BGl_z62certificatezd2subjectzb0zz__ssl_sslz00(obj_t BgL_envz00_4174, obj_t BgL_certz00_4175)
{
{ /* Llib/ssl.scm 749 */
{ /* Llib/ssl.scm 750 */
BgL_certificatez00_bglt BgL_auxz00_6819;
if(
BGl_isazf3zf3zz__objectz00(BgL_certz00_4175, BGl_certificatez00zz__ssl_sslz00))
{ /* Llib/ssl.scm 750 */
BgL_auxz00_6819 = 
((BgL_certificatez00_bglt)BgL_certz00_4175)
; }  else 
{ 
obj_t BgL_auxz00_6823;
BgL_auxz00_6823 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)30482)), BGl_string3386z00zz__ssl_sslz00, BGl_string3387z00zz__ssl_sslz00, BgL_certz00_4175); 
FAILURE(BgL_auxz00_6823,BFALSE,BFALSE);} 
return 
BGl_certificatezd2subjectzd2zz__ssl_sslz00(BgL_auxz00_6819);} } 

}



/* certificate-issuer */
BGL_EXPORTED_DEF obj_t BGl_certificatezd2issuerzd2zz__ssl_sslz00(BgL_certificatez00_bglt BgL_certz00_37)
{
{ /* Llib/ssl.scm 755 */
return 
bgl_ssl_certificate_issuer(
((obj_t)BgL_certz00_37));} 

}



/* &certificate-issuer */
obj_t BGl_z62certificatezd2issuerzb0zz__ssl_sslz00(obj_t BgL_envz00_4176, obj_t BgL_certz00_4177)
{
{ /* Llib/ssl.scm 755 */
{ /* Llib/ssl.scm 756 */
BgL_certificatez00_bglt BgL_auxz00_6830;
if(
BGl_isazf3zf3zz__objectz00(BgL_certz00_4177, BGl_certificatez00zz__ssl_sslz00))
{ /* Llib/ssl.scm 756 */
BgL_auxz00_6830 = 
((BgL_certificatez00_bglt)BgL_certz00_4177)
; }  else 
{ 
obj_t BgL_auxz00_6834;
BgL_auxz00_6834 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)30800)), BGl_string3388z00zz__ssl_sslz00, BGl_string3387z00zz__ssl_sslz00, BgL_certz00_4177); 
FAILURE(BgL_auxz00_6834,BFALSE,BFALSE);} 
return 
BGl_certificatezd2issuerzd2zz__ssl_sslz00(BgL_auxz00_6830);} } 

}



/* %make-certificate */
BGL_EXPORTED_DEF obj_t bgl_make_certificate(void * BgL_certz00_38)
{
{ /* Llib/ssl.scm 761 */
{ /* Llib/ssl.scm 762 */
BgL_certificatez00_bglt BgL_new1127z00_411;
{ /* Llib/ssl.scm 763 */
BgL_certificatez00_bglt BgL_new1126z00_412;
BgL_new1126z00_412 = 
((BgL_certificatez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_certificatez00_bgl) ))); 
{ /* Llib/ssl.scm 763 */
long BgL_arg1722z00_413;
{ /* Llib/ssl.scm 763 */
long BgL_res2346z00_1884;
BgL_res2346z00_1884 = 
BGL_CLASS_INDEX(BGl_certificatez00zz__ssl_sslz00); 
BgL_arg1722z00_413 = BgL_res2346z00_1884; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1126z00_412), BgL_arg1722z00_413); } 
BgL_new1127z00_411 = BgL_new1126z00_412; } 
((((BgL_certificatez00_bglt)COBJECT(BgL_new1127z00_411))->BgL_z42nativez42)=((void *)BgL_certz00_38),BUNSPEC); 
return 
((obj_t)BgL_new1127z00_411);} } 

}



/* &%make-certificate */
obj_t BGl_z62z52makezd2certificateze2zz__ssl_sslz00(obj_t BgL_envz00_4178, obj_t BgL_certz00_4179)
{
{ /* Llib/ssl.scm 761 */
{ /* Llib/ssl.scm 762 */
void * BgL_auxz00_6845;
if(
FOREIGNP(BgL_certz00_4179))
{ /* Llib/ssl.scm 762 */
BgL_auxz00_6845 = 
FOREIGN_TO_COBJ(BgL_certz00_4179)
; }  else 
{ 
obj_t BgL_auxz00_6849;
BgL_auxz00_6849 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)31087)), BGl_string3389z00zz__ssl_sslz00, BGl_string3390z00zz__ssl_sslz00, BgL_certz00_4179); 
FAILURE(BgL_auxz00_6849,BFALSE,BFALSE);} 
return 
bgl_make_certificate(BgL_auxz00_6845);} } 

}



/* %make-private-key */
BGL_EXPORTED_DEF obj_t bgl_make_private_key(void * BgL_pkeyz00_39)
{
{ /* Llib/ssl.scm 768 */
{ /* Llib/ssl.scm 769 */
BgL_privatezd2keyzd2_bglt BgL_new1129z00_414;
{ /* Llib/ssl.scm 770 */
BgL_privatezd2keyzd2_bglt BgL_new1128z00_415;
BgL_new1128z00_415 = 
((BgL_privatezd2keyzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_privatezd2keyzd2_bgl) ))); 
{ /* Llib/ssl.scm 770 */
long BgL_arg1728z00_416;
{ /* Llib/ssl.scm 770 */
long BgL_res2347z00_1888;
BgL_res2347z00_1888 = 
BGL_CLASS_INDEX(BGl_privatezd2keyzd2zz__ssl_sslz00); 
BgL_arg1728z00_416 = BgL_res2347z00_1888; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1128z00_415), BgL_arg1728z00_416); } 
BgL_new1129z00_414 = BgL_new1128z00_415; } 
((((BgL_privatezd2keyzd2_bglt)COBJECT(BgL_new1129z00_414))->BgL_z42nativez42)=((void *)BgL_pkeyz00_39),BUNSPEC); 
return 
((obj_t)BgL_new1129z00_414);} } 

}



/* &%make-private-key */
obj_t BGl_z62z52makezd2privatezd2keyz30zz__ssl_sslz00(obj_t BgL_envz00_4180, obj_t BgL_pkeyz00_4181)
{
{ /* Llib/ssl.scm 768 */
{ /* Llib/ssl.scm 769 */
void * BgL_auxz00_6860;
if(
FOREIGNP(BgL_pkeyz00_4181))
{ /* Llib/ssl.scm 769 */
BgL_auxz00_6860 = 
FOREIGN_TO_COBJ(BgL_pkeyz00_4181)
; }  else 
{ 
obj_t BgL_auxz00_6864;
BgL_auxz00_6864 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)31395)), BGl_string3391z00zz__ssl_sslz00, BGl_string3390z00zz__ssl_sslz00, BgL_pkeyz00_4181); 
FAILURE(BgL_auxz00_6864,BFALSE,BFALSE);} 
return 
bgl_make_private_key(BgL_auxz00_6860);} } 

}



/* %certificate-$native */
BGL_EXPORTED_DEF void * bgl_certificate_native(obj_t BgL_certz00_40)
{
{ /* Llib/ssl.scm 775 */
return 
(((BgL_certificatez00_bglt)COBJECT(
((BgL_certificatez00_bglt)BgL_certz00_40)))->BgL_z42nativez42);} 

}



/* &%certificate-$native */
obj_t BGl_z62z52certificatezd2z42nativeza0zz__ssl_sslz00(obj_t BgL_envz00_4182, obj_t BgL_certz00_4183)
{
{ /* Llib/ssl.scm 775 */
return 
void_star_to_obj(
bgl_certificate_native(BgL_certz00_4183));} 

}



/* %private-key-$native */
BGL_EXPORTED_DEF void * bgl_private_key_native(obj_t BgL_pkeyz00_41)
{
{ /* Llib/ssl.scm 782 */
return 
(((BgL_privatezd2keyzd2_bglt)COBJECT(
((BgL_privatezd2keyzd2_bglt)BgL_pkeyz00_41)))->BgL_z42nativez42);} 

}



/* &%private-key-$native */
obj_t BGl_z62z52privatezd2keyzd2z42nativez72zz__ssl_sslz00(obj_t BgL_envz00_4184, obj_t BgL_pkeyz00_4185)
{
{ /* Llib/ssl.scm 782 */
return 
void_star_to_obj(
bgl_private_key_native(BgL_pkeyz00_4185));} 

}



/* _secure-context-set-key! */
obj_t BGl__securezd2contextzd2setzd2keyz12zc0zz__ssl_sslz00(obj_t BgL_envz00_59, obj_t BgL_optz00_58)
{
{ /* Llib/ssl.scm 839 */
{ /* Llib/ssl.scm 839 */
obj_t BgL_g1251z00_419;obj_t BgL_g1252z00_420;obj_t BgL_g1253z00_421;obj_t BgL_g1254z00_422;
{ 
obj_t BgL_auxz00_6877;
if(
VECTORP(BgL_optz00_58))
{ /* Llib/ssl.scm 839 */
BgL_auxz00_6877 = BgL_optz00_58
; }  else 
{ 
obj_t BgL_auxz00_6880;
BgL_auxz00_6880 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)34315)), BGl_string3392z00zz__ssl_sslz00, BGl_string3393z00zz__ssl_sslz00, BgL_optz00_58); 
FAILURE(BgL_auxz00_6880,BFALSE,BFALSE);} 
BgL_g1251z00_419 = 
VECTOR_REF(BgL_auxz00_6877,((long)0)); } 
{ 
obj_t BgL_auxz00_6885;
if(
VECTORP(BgL_optz00_58))
{ /* Llib/ssl.scm 839 */
BgL_auxz00_6885 = BgL_optz00_58
; }  else 
{ 
obj_t BgL_auxz00_6888;
BgL_auxz00_6888 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)34315)), BGl_string3392z00zz__ssl_sslz00, BGl_string3393z00zz__ssl_sslz00, BgL_optz00_58); 
FAILURE(BgL_auxz00_6888,BFALSE,BFALSE);} 
BgL_g1252z00_420 = 
VECTOR_REF(BgL_auxz00_6885,((long)1)); } 
{ 
obj_t BgL_auxz00_6893;
if(
VECTORP(BgL_optz00_58))
{ /* Llib/ssl.scm 839 */
BgL_auxz00_6893 = BgL_optz00_58
; }  else 
{ 
obj_t BgL_auxz00_6896;
BgL_auxz00_6896 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)34315)), BGl_string3392z00zz__ssl_sslz00, BGl_string3393z00zz__ssl_sslz00, BgL_optz00_58); 
FAILURE(BgL_auxz00_6896,BFALSE,BFALSE);} 
BgL_g1253z00_421 = 
VECTOR_REF(BgL_auxz00_6893,((long)2)); } 
{ 
obj_t BgL_auxz00_6901;
if(
VECTORP(BgL_optz00_58))
{ /* Llib/ssl.scm 839 */
BgL_auxz00_6901 = BgL_optz00_58
; }  else 
{ 
obj_t BgL_auxz00_6904;
BgL_auxz00_6904 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)34315)), BGl_string3392z00zz__ssl_sslz00, BGl_string3393z00zz__ssl_sslz00, BgL_optz00_58); 
FAILURE(BgL_auxz00_6904,BFALSE,BFALSE);} 
BgL_g1254z00_422 = 
VECTOR_REF(BgL_auxz00_6901,((long)3)); } 
{ /* Llib/ssl.scm 839 */
long BgL_aux1256z00_424;
{ 
obj_t BgL_auxz00_6909;
if(
VECTORP(BgL_optz00_58))
{ /* Llib/ssl.scm 839 */
BgL_auxz00_6909 = BgL_optz00_58
; }  else 
{ 
obj_t BgL_auxz00_6912;
BgL_auxz00_6912 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)34315)), BGl_string3392z00zz__ssl_sslz00, BGl_string3393z00zz__ssl_sslz00, BgL_optz00_58); 
FAILURE(BgL_auxz00_6912,BFALSE,BFALSE);} 
BgL_aux1256z00_424 = 
VECTOR_LENGTH(BgL_auxz00_6909); } 
switch( BgL_aux1256z00_424) { case ((long)4) : 

{ /* Llib/ssl.scm 839 */

{ /* Llib/ssl.scm 839 */
bool_t BgL_tmpz00_6917;
{ /* Llib/ssl.scm 839 */
long BgL_auxz00_6942;long BgL_auxz00_6933;obj_t BgL_auxz00_6926;BgL_securezd2contextzd2_bglt BgL_auxz00_6918;
{ /* Llib/ssl.scm 839 */
obj_t BgL_tmpz00_6943;
if(
INTEGERP(BgL_g1254z00_422))
{ /* Llib/ssl.scm 839 */
BgL_tmpz00_6943 = BgL_g1254z00_422
; }  else 
{ 
obj_t BgL_auxz00_6946;
BgL_auxz00_6946 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)34315)), BGl_string3392z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_g1254z00_422); 
FAILURE(BgL_auxz00_6946,BFALSE,BFALSE);} 
BgL_auxz00_6942 = 
(long)CINT(BgL_tmpz00_6943); } 
{ /* Llib/ssl.scm 839 */
obj_t BgL_tmpz00_6934;
if(
INTEGERP(BgL_g1253z00_421))
{ /* Llib/ssl.scm 839 */
BgL_tmpz00_6934 = BgL_g1253z00_421
; }  else 
{ 
obj_t BgL_auxz00_6937;
BgL_auxz00_6937 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)34315)), BGl_string3392z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_g1253z00_421); 
FAILURE(BgL_auxz00_6937,BFALSE,BFALSE);} 
BgL_auxz00_6933 = 
(long)CINT(BgL_tmpz00_6934); } 
if(
STRINGP(BgL_g1252z00_420))
{ /* Llib/ssl.scm 839 */
BgL_auxz00_6926 = BgL_g1252z00_420
; }  else 
{ 
obj_t BgL_auxz00_6929;
BgL_auxz00_6929 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)34315)), BGl_string3392z00zz__ssl_sslz00, BGl_string3369z00zz__ssl_sslz00, BgL_g1252z00_420); 
FAILURE(BgL_auxz00_6929,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_g1251z00_419, BGl_securezd2contextzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 839 */
BgL_auxz00_6918 = 
((BgL_securezd2contextzd2_bglt)BgL_g1251z00_419)
; }  else 
{ 
obj_t BgL_auxz00_6922;
BgL_auxz00_6922 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)34315)), BGl_string3392z00zz__ssl_sslz00, BGl_string3394z00zz__ssl_sslz00, BgL_g1251z00_419); 
FAILURE(BgL_auxz00_6922,BFALSE,BFALSE);} 
BgL_tmpz00_6917 = 
BGl_securezd2contextzd2setzd2keyz12zc0zz__ssl_sslz00(BgL_auxz00_6918, BgL_auxz00_6926, BgL_auxz00_6933, BgL_auxz00_6942, BFALSE); } 
return 
BBOOL(BgL_tmpz00_6917);} } break;case ((long)5) : 

{ /* Llib/ssl.scm 839 */
obj_t BgL_passphrasez00_427;
{ 
obj_t BgL_auxz00_6953;
if(
VECTORP(BgL_optz00_58))
{ /* Llib/ssl.scm 839 */
BgL_auxz00_6953 = BgL_optz00_58
; }  else 
{ 
obj_t BgL_auxz00_6956;
BgL_auxz00_6956 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)34315)), BGl_string3392z00zz__ssl_sslz00, BGl_string3393z00zz__ssl_sslz00, BgL_optz00_58); 
FAILURE(BgL_auxz00_6956,BFALSE,BFALSE);} 
BgL_passphrasez00_427 = 
VECTOR_REF(BgL_auxz00_6953,((long)4)); } 
{ /* Llib/ssl.scm 839 */

{ /* Llib/ssl.scm 839 */
bool_t BgL_tmpz00_6961;
{ /* Llib/ssl.scm 839 */
long BgL_auxz00_6986;long BgL_auxz00_6977;obj_t BgL_auxz00_6970;BgL_securezd2contextzd2_bglt BgL_auxz00_6962;
{ /* Llib/ssl.scm 839 */
obj_t BgL_tmpz00_6987;
if(
INTEGERP(BgL_g1254z00_422))
{ /* Llib/ssl.scm 839 */
BgL_tmpz00_6987 = BgL_g1254z00_422
; }  else 
{ 
obj_t BgL_auxz00_6990;
BgL_auxz00_6990 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)34315)), BGl_string3392z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_g1254z00_422); 
FAILURE(BgL_auxz00_6990,BFALSE,BFALSE);} 
BgL_auxz00_6986 = 
(long)CINT(BgL_tmpz00_6987); } 
{ /* Llib/ssl.scm 839 */
obj_t BgL_tmpz00_6978;
if(
INTEGERP(BgL_g1253z00_421))
{ /* Llib/ssl.scm 839 */
BgL_tmpz00_6978 = BgL_g1253z00_421
; }  else 
{ 
obj_t BgL_auxz00_6981;
BgL_auxz00_6981 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)34315)), BGl_string3392z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_g1253z00_421); 
FAILURE(BgL_auxz00_6981,BFALSE,BFALSE);} 
BgL_auxz00_6977 = 
(long)CINT(BgL_tmpz00_6978); } 
if(
STRINGP(BgL_g1252z00_420))
{ /* Llib/ssl.scm 839 */
BgL_auxz00_6970 = BgL_g1252z00_420
; }  else 
{ 
obj_t BgL_auxz00_6973;
BgL_auxz00_6973 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)34315)), BGl_string3392z00zz__ssl_sslz00, BGl_string3369z00zz__ssl_sslz00, BgL_g1252z00_420); 
FAILURE(BgL_auxz00_6973,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_g1251z00_419, BGl_securezd2contextzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 839 */
BgL_auxz00_6962 = 
((BgL_securezd2contextzd2_bglt)BgL_g1251z00_419)
; }  else 
{ 
obj_t BgL_auxz00_6966;
BgL_auxz00_6966 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)34315)), BGl_string3392z00zz__ssl_sslz00, BGl_string3394z00zz__ssl_sslz00, BgL_g1251z00_419); 
FAILURE(BgL_auxz00_6966,BFALSE,BFALSE);} 
BgL_tmpz00_6961 = 
BGl_securezd2contextzd2setzd2keyz12zc0zz__ssl_sslz00(BgL_auxz00_6962, BgL_auxz00_6970, BgL_auxz00_6977, BgL_auxz00_6986, BgL_passphrasez00_427); } 
return 
BBOOL(BgL_tmpz00_6961);} } } break;
default: 
return BUNSPEC;} } } } 

}



/* bn-bin2bn */
BGL_EXPORTED_DEF obj_t BGl_bnzd2bin2bnzd2zz__ssl_sslz00(obj_t BgL_stringz00_178)
{
{ /* Llib/ssl.scm 1393 */
{ /* Llib/ssl.scm 1395 */
void * BgL_arg1740z00_1893;
{ /* Llib/ssl.scm 1395 */
long BgL_arg1741z00_1894;
BgL_arg1741z00_1894 = 
STRING_LENGTH(BgL_stringz00_178); 
BgL_arg1740z00_1893 = 
bgl_bn_bin2bn(
BSTRING_TO_STRING(BgL_stringz00_178), 
(int)(BgL_arg1741z00_1894)); } 
return 
void_star_to_obj(BgL_arg1740z00_1893);} } 

}



/* &bn-bin2bn */
obj_t BGl_z62bnzd2bin2bnzb0zz__ssl_sslz00(obj_t BgL_envz00_4186, obj_t BgL_stringz00_4187)
{
{ /* Llib/ssl.scm 1393 */
{ /* Llib/ssl.scm 1395 */
obj_t BgL_auxz00_7003;
if(
STRINGP(BgL_stringz00_4187))
{ /* Llib/ssl.scm 1395 */
BgL_auxz00_7003 = BgL_stringz00_4187
; }  else 
{ 
obj_t BgL_auxz00_7006;
BgL_auxz00_7006 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)56241)), BGl_string3395z00zz__ssl_sslz00, BGl_string3369z00zz__ssl_sslz00, BgL_stringz00_4187); 
FAILURE(BgL_auxz00_7006,BFALSE,BFALSE);} 
return 
BGl_bnzd2bin2bnzd2zz__ssl_sslz00(BgL_auxz00_7003);} } 

}



/* bn-bn2bin */
BGL_EXPORTED_DEF obj_t BGl_bnzd2bn2binzd2zz__ssl_sslz00(obj_t BgL_bnz00_179)
{
{ /* Llib/ssl.scm 1401 */
{ /* Llib/ssl.scm 1404 */
int BgL_sza7za7_430;
{ /* Llib/ssl.scm 1404 */
int BgL_res2349z00_1899;
{ /* Llib/ssl.scm 1415 */
void * BgL_arg1752z00_1898;
BgL_arg1752z00_1898 = 
(BIGNUM *)FOREIGN_TO_COBJ(BgL_bnz00_179); 
BgL_res2349z00_1899 = 
BN_num_bytes(BgL_arg1752z00_1898); } 
BgL_sza7za7_430 = BgL_res2349z00_1899; } 
{ /* Llib/ssl.scm 1404 */
obj_t BgL_stz00_431;
{ /* Llib/ssl.scm 1405 */

BgL_stz00_431 = 
make_string(
(long)(BgL_sza7za7_430), ((unsigned char)' ')); } 
{ /* Llib/ssl.scm 1405 */

{ /* Llib/ssl.scm 1406 */
void * BgL_arg1743z00_432;
BgL_arg1743z00_432 = 
(BIGNUM *)FOREIGN_TO_COBJ(BgL_bnz00_179); 
{ /* Llib/ssl.scm 1406 */
char * BgL_tmpz00_7016;
BgL_tmpz00_7016 = 
BSTRING_TO_STRING(BgL_stz00_431); 
BN_bn2bin(BgL_arg1743z00_432, BgL_tmpz00_7016); } } 
return BgL_stz00_431;} } } } 

}



/* &bn-bn2bin */
obj_t BGl_z62bnzd2bn2binzb0zz__ssl_sslz00(obj_t BgL_envz00_4188, obj_t BgL_bnz00_4189)
{
{ /* Llib/ssl.scm 1401 */
{ /* Llib/ssl.scm 1404 */
obj_t BgL_auxz00_7019;
if(
FOREIGNP(BgL_bnz00_4189))
{ /* Llib/ssl.scm 1404 */
BgL_auxz00_7019 = BgL_bnz00_4189
; }  else 
{ 
obj_t BgL_auxz00_7022;
BgL_auxz00_7022 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)56579)), BGl_string3396z00zz__ssl_sslz00, BGl_string3397z00zz__ssl_sslz00, BgL_bnz00_4189); 
FAILURE(BgL_auxz00_7022,BFALSE,BFALSE);} 
return 
BGl_bnzd2bn2binzd2zz__ssl_sslz00(BgL_auxz00_7019);} } 

}



/* bn-num-bytes */
BGL_EXPORTED_DEF int BGl_bnzd2numzd2bytesz00zz__ssl_sslz00(obj_t BgL_bnz00_180)
{
{ /* Llib/ssl.scm 1413 */
{ /* Llib/ssl.scm 1415 */
void * BgL_arg1752z00_1902;
BgL_arg1752z00_1902 = 
(BIGNUM *)FOREIGN_TO_COBJ(BgL_bnz00_180); 
return 
BN_num_bytes(BgL_arg1752z00_1902);} } 

}



/* &bn-num-bytes */
obj_t BGl_z62bnzd2numzd2bytesz62zz__ssl_sslz00(obj_t BgL_envz00_4190, obj_t BgL_bnz00_4191)
{
{ /* Llib/ssl.scm 1413 */
{ /* Llib/ssl.scm 1415 */
int BgL_tmpz00_7029;
{ /* Llib/ssl.scm 1415 */
obj_t BgL_auxz00_7030;
if(
FOREIGNP(BgL_bnz00_4191))
{ /* Llib/ssl.scm 1415 */
BgL_auxz00_7030 = BgL_bnz00_4191
; }  else 
{ 
obj_t BgL_auxz00_7033;
BgL_auxz00_7033 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)57001)), BGl_string3398z00zz__ssl_sslz00, BGl_string3397z00zz__ssl_sslz00, BgL_bnz00_4191); 
FAILURE(BgL_auxz00_7033,BFALSE,BFALSE);} 
BgL_tmpz00_7029 = 
BGl_bnzd2numzd2bytesz00zz__ssl_sslz00(BgL_auxz00_7030); } 
return 
BINT(BgL_tmpz00_7029);} } 

}



/* bn-free */
BGL_EXPORTED_DEF obj_t BGl_bnzd2freezd2zz__ssl_sslz00(obj_t BgL_bnz00_181)
{
{ /* Llib/ssl.scm 1421 */
{ /* Llib/ssl.scm 1423 */
void * BgL_arg1753z00_1903;
BgL_arg1753z00_1903 = 
(BIGNUM *)FOREIGN_TO_COBJ(BgL_bnz00_181); 
BN_free(BgL_arg1753z00_1903); BUNSPEC; } 
return BUNSPEC;} 

}



/* &bn-free */
obj_t BGl_z62bnzd2freezb0zz__ssl_sslz00(obj_t BgL_envz00_4192, obj_t BgL_bnz00_4193)
{
{ /* Llib/ssl.scm 1421 */
{ /* Llib/ssl.scm 1423 */
obj_t BgL_auxz00_7041;
if(
FOREIGNP(BgL_bnz00_4193))
{ /* Llib/ssl.scm 1423 */
BgL_auxz00_7041 = BgL_bnz00_4193
; }  else 
{ 
obj_t BgL_auxz00_7044;
BgL_auxz00_7044 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)57346)), BGl_string3399z00zz__ssl_sslz00, BGl_string3397z00zz__ssl_sslz00, BgL_bnz00_4193); 
FAILURE(BgL_auxz00_7044,BFALSE,BFALSE);} 
return 
BGl_bnzd2freezd2zz__ssl_sslz00(BgL_auxz00_7041);} } 

}



/* bn-new */
BGL_EXPORTED_DEF obj_t BGl_bnzd2newzd2zz__ssl_sslz00()
{
{ /* Llib/ssl.scm 1429 */
{ /* Llib/ssl.scm 1431 */
void * BgL_arg1754z00_1904;
BgL_arg1754z00_1904 = 
BN_new(); 
return 
void_star_to_obj(BgL_arg1754z00_1904);} } 

}



/* &bn-new */
obj_t BGl_z62bnzd2newzb0zz__ssl_sslz00(obj_t BgL_envz00_4194)
{
{ /* Llib/ssl.scm 1429 */
return 
BGl_bnzd2newzd2zz__ssl_sslz00();} 

}



/* bn-set-word */
BGL_EXPORTED_DEF bool_t BGl_bnzd2setzd2wordz00zz__ssl_sslz00(obj_t BgL_bnz00_182, int BgL_wz00_183)
{
{ /* Llib/ssl.scm 1437 */
{ /* Llib/ssl.scm 1439 */
void * BgL_arg1755z00_1905;
BgL_arg1755z00_1905 = 
(BIGNUM *)FOREIGN_TO_COBJ(BgL_bnz00_182); 
return 
BN_set_word(BgL_arg1755z00_1905, BgL_wz00_183);} } 

}



/* &bn-set-word */
obj_t BGl_z62bnzd2setzd2wordz62zz__ssl_sslz00(obj_t BgL_envz00_4195, obj_t BgL_bnz00_4196, obj_t BgL_wz00_4197)
{
{ /* Llib/ssl.scm 1437 */
{ /* Llib/ssl.scm 1439 */
bool_t BgL_tmpz00_7054;
{ /* Llib/ssl.scm 1439 */
int BgL_auxz00_7062;obj_t BgL_auxz00_7055;
{ /* Llib/ssl.scm 1439 */
obj_t BgL_tmpz00_7063;
if(
INTEGERP(BgL_wz00_4197))
{ /* Llib/ssl.scm 1439 */
BgL_tmpz00_7063 = BgL_wz00_4197
; }  else 
{ 
obj_t BgL_auxz00_7066;
BgL_auxz00_7066 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)57980)), BGl_string3400z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_wz00_4197); 
FAILURE(BgL_auxz00_7066,BFALSE,BFALSE);} 
BgL_auxz00_7062 = 
CINT(BgL_tmpz00_7063); } 
if(
FOREIGNP(BgL_bnz00_4196))
{ /* Llib/ssl.scm 1439 */
BgL_auxz00_7055 = BgL_bnz00_4196
; }  else 
{ 
obj_t BgL_auxz00_7058;
BgL_auxz00_7058 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)57980)), BGl_string3400z00zz__ssl_sslz00, BGl_string3397z00zz__ssl_sslz00, BgL_bnz00_4196); 
FAILURE(BgL_auxz00_7058,BFALSE,BFALSE);} 
BgL_tmpz00_7054 = 
BGl_bnzd2setzd2wordz00zz__ssl_sslz00(BgL_auxz00_7055, BgL_auxz00_7062); } 
return 
BBOOL(BgL_tmpz00_7054);} } 

}



/* ssl-get-ciphers */
BGL_EXPORTED_DEF obj_t BGl_sslzd2getzd2ciphersz00zz__ssl_sslz00()
{
{ /* Llib/ssl.scm 1445 */
return 
bgl_ssl_get_ciphers();} 

}



/* &ssl-get-ciphers */
obj_t BGl_z62sslzd2getzd2ciphersz62zz__ssl_sslz00(obj_t BgL_envz00_4198)
{
{ /* Llib/ssl.scm 1445 */
return 
BGl_sslzd2getzd2ciphersz00zz__ssl_sslz00();} 

}



/* evp-get-ciphers */
BGL_EXPORTED_DEF obj_t BGl_evpzd2getzd2ciphersz00zz__ssl_sslz00()
{
{ /* Llib/ssl.scm 1453 */
return 
bgl_evp_get_ciphers();} 

}



/* &evp-get-ciphers */
obj_t BGl_z62evpzd2getzd2ciphersz62zz__ssl_sslz00(obj_t BgL_envz00_4199)
{
{ /* Llib/ssl.scm 1453 */
return 
BGl_evpzd2getzd2ciphersz00zz__ssl_sslz00();} 

}



/* evp-get-hashes */
BGL_EXPORTED_DEF obj_t BGl_evpzd2getzd2hashesz00zz__ssl_sslz00()
{
{ /* Llib/ssl.scm 1461 */
return 
bgl_evp_get_hashes();} 

}



/* &evp-get-hashes */
obj_t BGl_z62evpzd2getzd2hashesz62zz__ssl_sslz00(obj_t BgL_envz00_4200)
{
{ /* Llib/ssl.scm 1461 */
return 
BGl_evpzd2getzd2hashesz00zz__ssl_sslz00();} 

}



/* pkcs5-pbkdf2-hmac-sha1 */
BGL_EXPORTED_DEF obj_t BGl_pkcs5zd2pbkdf2zd2hmaczd2sha1zd2zz__ssl_sslz00(obj_t BgL_passz00_184, obj_t BgL_saltz00_185, int BgL_iterz00_186, int BgL_keylenz00_187)
{
{ /* Llib/ssl.scm 1469 */
return 
bgl_pkcs5_pbkdf2_hmac_sha1(BgL_passz00_184, BgL_saltz00_185, BgL_iterz00_186, BgL_keylenz00_187);} 

}



/* &pkcs5-pbkdf2-hmac-sha1 */
obj_t BGl_z62pkcs5zd2pbkdf2zd2hmaczd2sha1zb0zz__ssl_sslz00(obj_t BgL_envz00_4201, obj_t BgL_passz00_4202, obj_t BgL_saltz00_4203, obj_t BgL_iterz00_4204, obj_t BgL_keylenz00_4205)
{
{ /* Llib/ssl.scm 1469 */
{ /* Llib/ssl.scm 1472 */
int BgL_auxz00_7103;int BgL_auxz00_7094;obj_t BgL_auxz00_7087;obj_t BgL_auxz00_7080;
{ /* Llib/ssl.scm 1472 */
obj_t BgL_tmpz00_7104;
if(
INTEGERP(BgL_keylenz00_4205))
{ /* Llib/ssl.scm 1472 */
BgL_tmpz00_7104 = BgL_keylenz00_4205
; }  else 
{ 
obj_t BgL_auxz00_7107;
BgL_auxz00_7107 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)59317)), BGl_string3401z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_keylenz00_4205); 
FAILURE(BgL_auxz00_7107,BFALSE,BFALSE);} 
BgL_auxz00_7103 = 
CINT(BgL_tmpz00_7104); } 
{ /* Llib/ssl.scm 1472 */
obj_t BgL_tmpz00_7095;
if(
INTEGERP(BgL_iterz00_4204))
{ /* Llib/ssl.scm 1472 */
BgL_tmpz00_7095 = BgL_iterz00_4204
; }  else 
{ 
obj_t BgL_auxz00_7098;
BgL_auxz00_7098 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)59317)), BGl_string3401z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_iterz00_4204); 
FAILURE(BgL_auxz00_7098,BFALSE,BFALSE);} 
BgL_auxz00_7094 = 
CINT(BgL_tmpz00_7095); } 
if(
STRINGP(BgL_saltz00_4203))
{ /* Llib/ssl.scm 1472 */
BgL_auxz00_7087 = BgL_saltz00_4203
; }  else 
{ 
obj_t BgL_auxz00_7090;
BgL_auxz00_7090 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)59317)), BGl_string3401z00zz__ssl_sslz00, BGl_string3369z00zz__ssl_sslz00, BgL_saltz00_4203); 
FAILURE(BgL_auxz00_7090,BFALSE,BFALSE);} 
if(
STRINGP(BgL_passz00_4202))
{ /* Llib/ssl.scm 1472 */
BgL_auxz00_7080 = BgL_passz00_4202
; }  else 
{ 
obj_t BgL_auxz00_7083;
BgL_auxz00_7083 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)59317)), BGl_string3401z00zz__ssl_sslz00, BGl_string3369z00zz__ssl_sslz00, BgL_passz00_4202); 
FAILURE(BgL_auxz00_7083,BFALSE,BFALSE);} 
return 
BGl_pkcs5zd2pbkdf2zd2hmaczd2sha1zd2zz__ssl_sslz00(BgL_auxz00_7080, BgL_auxz00_7087, BgL_auxz00_7094, BgL_auxz00_7103);} } 

}



/* ssl-op-cipher-server-preference */
BGL_EXPORTED_DEF int BGl_sslzd2opzd2cipherzd2serverzd2preferencez00zz__ssl_sslz00()
{
{ /* Llib/ssl.scm 1479 */
return SSL_OP_CIPHER_SERVER_PREFERENCE;} 

}



/* &ssl-op-cipher-server-preference */
obj_t BGl_z62sslzd2opzd2cipherzd2serverzd2preferencez62zz__ssl_sslz00(obj_t BgL_envz00_4206)
{
{ /* Llib/ssl.scm 1479 */
return 
BINT(
BGl_sslzd2opzd2cipherzd2serverzd2preferencez00zz__ssl_sslz00());} 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__ssl_sslz00()
{
{ /* Llib/ssl.scm 15 */
{ /* Llib/ssl.scm 299 */
obj_t BgL_arg1759z00_442;obj_t BgL_arg1760z00_443;
{ /* Llib/ssl.scm 299 */
obj_t BgL_v1191z00_454;
BgL_v1191z00_454 = 
create_vector(((long)1)); 
{ /* Llib/ssl.scm 299 */
obj_t BgL_arg1766z00_455;
BgL_arg1766z00_455 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)28)), BGl_proc3403z00zz__ssl_sslz00, BGl_proc3402z00zz__ssl_sslz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)29))); 
VECTOR_SET(BgL_v1191z00_454,((long)0),BgL_arg1766z00_455); } 
BgL_arg1759z00_442 = BgL_v1191z00_454; } 
{ /* Llib/ssl.scm 299 */
obj_t BgL_v1192z00_465;
BgL_v1192z00_465 = 
create_vector(((long)0)); 
BgL_arg1760z00_443 = BgL_v1192z00_465; } 
BGl_certificatez00zz__ssl_sslz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)30)), 
CNST_TABLE_REF(((long)31)), BGl_objectz00zz__objectz00, ((long)36719), BGl_proc3406z00zz__ssl_sslz00, BGl_proc3405z00zz__ssl_sslz00, BFALSE, BGl_proc3404z00zz__ssl_sslz00, BFALSE, BgL_arg1759z00_442, BgL_arg1760z00_443); } 
{ /* Llib/ssl.scm 302 */
obj_t BgL_arg1774z00_472;obj_t BgL_arg1775z00_473;
{ /* Llib/ssl.scm 302 */
obj_t BgL_v1193z00_484;
BgL_v1193z00_484 = 
create_vector(((long)1)); 
{ /* Llib/ssl.scm 302 */
obj_t BgL_arg1781z00_485;
BgL_arg1781z00_485 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)28)), BGl_proc3408z00zz__ssl_sslz00, BGl_proc3407z00zz__ssl_sslz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)32))); 
VECTOR_SET(BgL_v1193z00_484,((long)0),BgL_arg1781z00_485); } 
BgL_arg1774z00_472 = BgL_v1193z00_484; } 
{ /* Llib/ssl.scm 302 */
obj_t BgL_v1194z00_495;
BgL_v1194z00_495 = 
create_vector(((long)0)); 
BgL_arg1775z00_473 = BgL_v1194z00_495; } 
BGl_privatezd2keyzd2zz__ssl_sslz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)33)), 
CNST_TABLE_REF(((long)31)), BGl_objectz00zz__objectz00, ((long)36583), BGl_proc3411z00zz__ssl_sslz00, BGl_proc3410z00zz__ssl_sslz00, BFALSE, BGl_proc3409z00zz__ssl_sslz00, BFALSE, BgL_arg1774z00_472, BgL_arg1775z00_473); } 
{ /* Llib/ssl.scm 405 */
obj_t BgL_arg1789z00_502;obj_t BgL_arg1790z00_503;
{ /* Llib/ssl.scm 405 */
obj_t BgL_v1195z00_517;
BgL_v1195z00_517 = 
create_vector(((long)3)); 
{ /* Llib/ssl.scm 405 */
obj_t BgL_arg1797z00_518;
BgL_arg1797z00_518 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)28)), BGl_proc3414z00zz__ssl_sslz00, BGl_proc3413z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3412z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)34))); 
VECTOR_SET(BgL_v1195z00_517,((long)0),BgL_arg1797z00_518); } 
{ /* Llib/ssl.scm 405 */
obj_t BgL_arg1804z00_531;
BgL_arg1804z00_531 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)35)), BGl_proc3417z00zz__ssl_sslz00, BGl_proc3416z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3415z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)36))); 
VECTOR_SET(BgL_v1195z00_517,((long)1),BgL_arg1804z00_531); } 
{ /* Llib/ssl.scm 405 */
obj_t BgL_arg1811z00_544;
BgL_arg1811z00_544 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)37)), BGl_proc3420z00zz__ssl_sslz00, BGl_proc3419z00zz__ssl_sslz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3418z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)38))); 
VECTOR_SET(BgL_v1195z00_517,((long)2),BgL_arg1811z00_544); } 
BgL_arg1789z00_502 = BgL_v1195z00_517; } 
{ /* Llib/ssl.scm 405 */
obj_t BgL_v1196z00_557;
BgL_v1196z00_557 = 
create_vector(((long)0)); 
BgL_arg1790z00_503 = BgL_v1196z00_557; } 
BGl_securezd2contextzd2zz__ssl_sslz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)39)), 
CNST_TABLE_REF(((long)31)), BGl_objectz00zz__objectz00, ((long)52075), BGl_proc3423z00zz__ssl_sslz00, BGl_proc3422z00zz__ssl_sslz00, BGl_securezd2contextzd2initzd2envzd2zz__ssl_sslz00, BGl_proc3421z00zz__ssl_sslz00, BFALSE, BgL_arg1789z00_502, BgL_arg1790z00_503); } 
{ /* Llib/ssl.scm 411 */
obj_t BgL_arg1821z00_564;obj_t BgL_arg1822z00_565;
{ /* Llib/ssl.scm 411 */
obj_t BgL_v1197z00_593;
BgL_v1197z00_593 = 
create_vector(((long)17)); 
{ /* Llib/ssl.scm 411 */
obj_t BgL_arg1829z00_594;
BgL_arg1829z00_594 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)28)), BGl_proc3426z00zz__ssl_sslz00, BGl_proc3425z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3424z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)40))); 
VECTOR_SET(BgL_v1197z00_593,((long)0),BgL_arg1829z00_594); } 
{ /* Llib/ssl.scm 411 */
obj_t BgL_arg1836z00_607;
BgL_arg1836z00_607 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)41)), BGl_proc3429z00zz__ssl_sslz00, BGl_proc3428z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3427z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)42))); 
VECTOR_SET(BgL_v1197z00_593,((long)1),BgL_arg1836z00_607); } 
{ /* Llib/ssl.scm 411 */
obj_t BgL_arg1843z00_620;
BgL_arg1843z00_620 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)43)), BGl_proc3432z00zz__ssl_sslz00, BGl_proc3431z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3430z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)42))); 
VECTOR_SET(BgL_v1197z00_593,((long)2),BgL_arg1843z00_620); } 
{ /* Llib/ssl.scm 411 */
obj_t BgL_arg1850z00_633;
BgL_arg1850z00_633 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)44)), BGl_proc3435z00zz__ssl_sslz00, BGl_proc3434z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3433z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)45))); 
VECTOR_SET(BgL_v1197z00_593,((long)3),BgL_arg1850z00_633); } 
{ /* Llib/ssl.scm 411 */
obj_t BgL_arg1857z00_646;
BgL_arg1857z00_646 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)46)), BGl_proc3437z00zz__ssl_sslz00, BGl_proc3436z00zz__ssl_sslz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_securezd2contextzd2zz__ssl_sslz00); 
VECTOR_SET(BgL_v1197z00_593,((long)4),BgL_arg1857z00_646); } 
{ /* Llib/ssl.scm 411 */
obj_t BgL_arg1862z00_656;
BgL_arg1862z00_656 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)47)), BGl_proc3439z00zz__ssl_sslz00, BGl_proc3438z00zz__ssl_sslz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)48))); 
VECTOR_SET(BgL_v1197z00_593,((long)5),BgL_arg1862z00_656); } 
{ /* Llib/ssl.scm 411 */
obj_t BgL_arg1867z00_666;
BgL_arg1867z00_666 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)49)), BGl_proc3442z00zz__ssl_sslz00, BGl_proc3441z00zz__ssl_sslz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3440z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)48))); 
VECTOR_SET(BgL_v1197z00_593,((long)6),BgL_arg1867z00_666); } 
{ /* Llib/ssl.scm 411 */
obj_t BgL_arg1874z00_679;
BgL_arg1874z00_679 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)50)), BGl_proc3445z00zz__ssl_sslz00, BGl_proc3444z00zz__ssl_sslz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3443z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)51))); 
VECTOR_SET(BgL_v1197z00_593,((long)7),BgL_arg1874z00_679); } 
{ /* Llib/ssl.scm 411 */
obj_t BgL_arg1881z00_692;
BgL_arg1881z00_692 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)52)), BGl_proc3447z00zz__ssl_sslz00, BGl_proc3446z00zz__ssl_sslz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)48))); 
VECTOR_SET(BgL_v1197z00_593,((long)8),BgL_arg1881z00_692); } 
{ /* Llib/ssl.scm 411 */
obj_t BgL_arg1886z00_702;
BgL_arg1886z00_702 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)53)), BGl_proc3450z00zz__ssl_sslz00, BGl_proc3449z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3448z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)51))); 
VECTOR_SET(BgL_v1197z00_593,((long)9),BgL_arg1886z00_702); } 
{ /* Llib/ssl.scm 411 */
obj_t BgL_arg1893z00_715;
BgL_arg1893z00_715 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)54)), BGl_proc3453z00zz__ssl_sslz00, BGl_proc3452z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3451z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)51))); 
VECTOR_SET(BgL_v1197z00_593,((long)10),BgL_arg1893z00_715); } 
{ /* Llib/ssl.scm 411 */
obj_t BgL_arg1900z00_728;
BgL_arg1900z00_728 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)55)), BGl_proc3456z00zz__ssl_sslz00, BGl_proc3455z00zz__ssl_sslz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3454z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)56))); 
VECTOR_SET(BgL_v1197z00_593,((long)11),BgL_arg1900z00_728); } 
{ /* Llib/ssl.scm 411 */
obj_t BgL_arg1907z00_741;
BgL_arg1907z00_741 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)57)), BGl_proc3459z00zz__ssl_sslz00, BGl_proc3458z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3457z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)51))); 
VECTOR_SET(BgL_v1197z00_593,((long)12),BgL_arg1907z00_741); } 
{ /* Llib/ssl.scm 411 */
obj_t BgL_arg1914z00_754;
BgL_arg1914z00_754 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)58)), BGl_proc3462z00zz__ssl_sslz00, BGl_proc3461z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3460z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)51))); 
VECTOR_SET(BgL_v1197z00_593,((long)13),BgL_arg1914z00_754); } 
{ /* Llib/ssl.scm 411 */
obj_t BgL_arg1921z00_767;
BgL_arg1921z00_767 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)59)), BGl_proc3465z00zz__ssl_sslz00, BGl_proc3464z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3463z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)51))); 
VECTOR_SET(BgL_v1197z00_593,((long)14),BgL_arg1921z00_767); } 
{ /* Llib/ssl.scm 411 */
obj_t BgL_arg1928z00_780;
BgL_arg1928z00_780 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)60)), BGl_proc3468z00zz__ssl_sslz00, BGl_proc3467z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3466z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)48))); 
VECTOR_SET(BgL_v1197z00_593,((long)15),BgL_arg1928z00_780); } 
{ /* Llib/ssl.scm 411 */
obj_t BgL_arg1935z00_793;
BgL_arg1935z00_793 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)61)), BGl_proc3471z00zz__ssl_sslz00, BGl_proc3470z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3469z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)48))); 
VECTOR_SET(BgL_v1197z00_593,((long)16),BgL_arg1935z00_793); } 
BgL_arg1821z00_564 = BgL_v1197z00_593; } 
{ /* Llib/ssl.scm 411 */
obj_t BgL_v1198z00_806;
BgL_v1198z00_806 = 
create_vector(((long)0)); 
BgL_arg1822z00_565 = BgL_v1198z00_806; } 
BGl_sslzd2connectionzd2zz__ssl_sslz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)62)), 
CNST_TABLE_REF(((long)31)), BGl_objectz00zz__objectz00, ((long)46618), BGl_proc3474z00zz__ssl_sslz00, BGl_proc3473z00zz__ssl_sslz00, BGl_sslzd2connectionzd2initzd2envzd2zz__ssl_sslz00, BGl_proc3472z00zz__ssl_sslz00, BFALSE, BgL_arg1821z00_564, BgL_arg1822z00_565); } 
{ /* Llib/ssl.scm 431 */
obj_t BgL_arg1945z00_813;obj_t BgL_arg1946z00_814;
{ /* Llib/ssl.scm 431 */
obj_t BgL_v1199z00_831;
BgL_v1199z00_831 = 
create_vector(((long)11)); 
{ /* Llib/ssl.scm 431 */
obj_t BgL_arg1953z00_832;
BgL_arg1953z00_832 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)28)), BGl_proc3477z00zz__ssl_sslz00, BGl_proc3476z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3475z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)63))); 
VECTOR_SET(BgL_v1199z00_831,((long)0),BgL_arg1953z00_832); } 
{ /* Llib/ssl.scm 431 */
obj_t BgL_arg1960z00_845;
BgL_arg1960z00_845 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)64)), BGl_proc3480z00zz__ssl_sslz00, BGl_proc3479z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3478z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)65))); 
VECTOR_SET(BgL_v1199z00_831,((long)1),BgL_arg1960z00_845); } 
{ /* Llib/ssl.scm 431 */
obj_t BgL_arg1967z00_858;
BgL_arg1967z00_858 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)66)), BGl_proc3483z00zz__ssl_sslz00, BGl_proc3482z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3481z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)65))); 
VECTOR_SET(BgL_v1199z00_831,((long)2),BgL_arg1967z00_858); } 
{ /* Llib/ssl.scm 431 */
obj_t BgL_arg1974z00_871;
BgL_arg1974z00_871 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)67)), BGl_proc3486z00zz__ssl_sslz00, BGl_proc3485z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3484z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)65))); 
VECTOR_SET(BgL_v1199z00_831,((long)3),BgL_arg1974z00_871); } 
{ /* Llib/ssl.scm 431 */
obj_t BgL_arg1981z00_884;
BgL_arg1981z00_884 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)68)), BGl_proc3489z00zz__ssl_sslz00, BGl_proc3488z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3487z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)65))); 
VECTOR_SET(BgL_v1199z00_831,((long)4),BgL_arg1981z00_884); } 
{ /* Llib/ssl.scm 431 */
obj_t BgL_arg1988z00_897;
BgL_arg1988z00_897 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)69)), BGl_proc3492z00zz__ssl_sslz00, BGl_proc3491z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3490z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)65))); 
VECTOR_SET(BgL_v1199z00_831,((long)5),BgL_arg1988z00_897); } 
{ /* Llib/ssl.scm 431 */
obj_t BgL_arg1995z00_910;
BgL_arg1995z00_910 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)70)), BGl_proc3494z00zz__ssl_sslz00, BGl_proc3493z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)1), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)51))); 
VECTOR_SET(BgL_v1199z00_831,((long)6),BgL_arg1995z00_910); } 
{ /* Llib/ssl.scm 431 */
obj_t BgL_arg2000z00_920;
BgL_arg2000z00_920 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)71)), BGl_proc3496z00zz__ssl_sslz00, BGl_proc3495z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)1), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)51))); 
VECTOR_SET(BgL_v1199z00_831,((long)7),BgL_arg2000z00_920); } 
{ /* Llib/ssl.scm 431 */
obj_t BgL_arg2005z00_930;
BgL_arg2005z00_930 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)72)), BGl_proc3498z00zz__ssl_sslz00, BGl_proc3497z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)1), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)51))); 
VECTOR_SET(BgL_v1199z00_831,((long)8),BgL_arg2005z00_930); } 
{ /* Llib/ssl.scm 431 */
obj_t BgL_arg2010z00_940;
BgL_arg2010z00_940 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)33)), BGl_proc3500z00zz__ssl_sslz00, BGl_proc3499z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)1), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)51))); 
VECTOR_SET(BgL_v1199z00_831,((long)9),BgL_arg2010z00_940); } 
{ /* Llib/ssl.scm 431 */
obj_t BgL_arg2015z00_950;
BgL_arg2015z00_950 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)73)), BGl_proc3502z00zz__ssl_sslz00, BGl_proc3501z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)1), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)51))); 
VECTOR_SET(BgL_v1199z00_831,((long)10),BgL_arg2015z00_950); } 
BgL_arg1945z00_813 = BgL_v1199z00_831; } 
{ /* Llib/ssl.scm 431 */
obj_t BgL_v1200z00_960;
BgL_v1200z00_960 = 
create_vector(((long)5)); 
{ /* Llib/ssl.scm 441 */
obj_t BgL_arg2020z00_961;
{ /* Llib/ssl.scm 441 */
obj_t BgL_arg2021z00_962;
BgL_arg2021z00_962 = 
MAKE_YOUNG_PAIR(BGl_proc3503z00zz__ssl_sslz00, BGl_proc3504z00zz__ssl_sslz00); 
BgL_arg2020z00_961 = 
MAKE_YOUNG_PAIR(
BINT(((long)0)), BgL_arg2021z00_962); } 
VECTOR_SET(BgL_v1200z00_960,((long)0),BgL_arg2020z00_961); } 
{ /* Llib/ssl.scm 450 */
obj_t BgL_arg2034z00_989;
{ /* Llib/ssl.scm 450 */
obj_t BgL_arg2035z00_990;
BgL_arg2035z00_990 = 
MAKE_YOUNG_PAIR(BGl_proc3505z00zz__ssl_sslz00, BGl_proc3506z00zz__ssl_sslz00); 
BgL_arg2034z00_989 = 
MAKE_YOUNG_PAIR(
BINT(((long)1)), BgL_arg2035z00_990); } 
VECTOR_SET(BgL_v1200z00_960,((long)1),BgL_arg2034z00_989); } 
{ /* Llib/ssl.scm 459 */
obj_t BgL_arg2048z00_1017;
{ /* Llib/ssl.scm 459 */
obj_t BgL_arg2049z00_1018;
BgL_arg2049z00_1018 = 
MAKE_YOUNG_PAIR(BGl_proc3507z00zz__ssl_sslz00, BGl_proc3508z00zz__ssl_sslz00); 
BgL_arg2048z00_1017 = 
MAKE_YOUNG_PAIR(
BINT(((long)2)), BgL_arg2049z00_1018); } 
VECTOR_SET(BgL_v1200z00_960,((long)2),BgL_arg2048z00_1017); } 
{ /* Llib/ssl.scm 469 */
obj_t BgL_arg2062z00_1046;
{ /* Llib/ssl.scm 469 */
obj_t BgL_arg2063z00_1047;
BgL_arg2063z00_1047 = 
MAKE_YOUNG_PAIR(BGl_proc3509z00zz__ssl_sslz00, BGl_proc3510z00zz__ssl_sslz00); 
BgL_arg2062z00_1046 = 
MAKE_YOUNG_PAIR(
BINT(((long)3)), BgL_arg2063z00_1047); } 
VECTOR_SET(BgL_v1200z00_960,((long)3),BgL_arg2062z00_1046); } 
{ /* Llib/ssl.scm 478 */
obj_t BgL_arg2075z00_1073;
{ /* Llib/ssl.scm 478 */
obj_t BgL_arg2076z00_1074;
BgL_arg2076z00_1074 = 
MAKE_YOUNG_PAIR(BGl_proc3511z00zz__ssl_sslz00, BGl_proc3512z00zz__ssl_sslz00); 
BgL_arg2075z00_1073 = 
MAKE_YOUNG_PAIR(
BINT(((long)4)), BgL_arg2076z00_1074); } 
VECTOR_SET(BgL_v1200z00_960,((long)4),BgL_arg2075z00_1073); } 
BgL_arg1946z00_814 = BgL_v1200z00_960; } 
BGl_dhz00zz__ssl_sslz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)74)), 
CNST_TABLE_REF(((long)31)), BGl_objectz00zz__objectz00, ((long)13004), BGl_proc3515z00zz__ssl_sslz00, BGl_proc3514z00zz__ssl_sslz00, BGl_dhzd2initzd2envz00zz__ssl_sslz00, BGl_proc3513z00zz__ssl_sslz00, BFALSE, BgL_arg1945z00_813, BgL_arg1946z00_814); } 
{ /* Llib/ssl.scm 486 */
obj_t BgL_arg2091z00_1106;obj_t BgL_arg2092z00_1107;
{ /* Llib/ssl.scm 486 */
obj_t BgL_v1201z00_1121;
BgL_v1201z00_1121 = 
create_vector(((long)3)); 
{ /* Llib/ssl.scm 486 */
obj_t BgL_arg2099z00_1122;
BgL_arg2099z00_1122 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)75)), BGl_proc3518z00zz__ssl_sslz00, BGl_proc3517z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3516z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)76))); 
VECTOR_SET(BgL_v1201z00_1121,((long)0),BgL_arg2099z00_1122); } 
{ /* Llib/ssl.scm 486 */
obj_t BgL_arg2106z00_1135;
BgL_arg2106z00_1135 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)77)), BGl_proc3521z00zz__ssl_sslz00, BGl_proc3520z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3519z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)78))); 
VECTOR_SET(BgL_v1201z00_1121,((long)1),BgL_arg2106z00_1135); } 
{ /* Llib/ssl.scm 486 */
obj_t BgL_arg2113z00_1148;
BgL_arg2113z00_1148 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)79)), BGl_proc3523z00zz__ssl_sslz00, BGl_proc3522z00zz__ssl_sslz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)38))); 
VECTOR_SET(BgL_v1201z00_1121,((long)2),BgL_arg2113z00_1148); } 
BgL_arg2091z00_1106 = BgL_v1201z00_1121; } 
{ /* Llib/ssl.scm 486 */
obj_t BgL_v1202z00_1158;
BgL_v1202z00_1158 = 
create_vector(((long)0)); 
BgL_arg2092z00_1107 = BgL_v1202z00_1158; } 
BGl_sslzd2hashzd2zz__ssl_sslz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)80)), 
CNST_TABLE_REF(((long)31)), BGl_objectz00zz__objectz00, ((long)4072), BGl_proc3526z00zz__ssl_sslz00, BGl_proc3525z00zz__ssl_sslz00, BGl_sslzd2hashzd2initzd2envzd2zz__ssl_sslz00, BGl_proc3524z00zz__ssl_sslz00, BFALSE, BgL_arg2091z00_1106, BgL_arg2092z00_1107); } 
{ /* Llib/ssl.scm 496 */
obj_t BgL_arg2121z00_1165;obj_t BgL_arg2122z00_1166;
{ /* Llib/ssl.scm 496 */
obj_t BgL_v1203z00_1178;
BgL_v1203z00_1178 = 
create_vector(((long)2)); 
{ /* Llib/ssl.scm 496 */
obj_t BgL_arg2128z00_1179;
BgL_arg2128z00_1179 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)75)), BGl_proc3529z00zz__ssl_sslz00, BGl_proc3528z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3527z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)76))); 
VECTOR_SET(BgL_v1203z00_1178,((long)0),BgL_arg2128z00_1179); } 
{ /* Llib/ssl.scm 496 */
obj_t BgL_arg2135z00_1192;
BgL_arg2135z00_1192 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)77)), BGl_proc3532z00zz__ssl_sslz00, BGl_proc3531z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3530z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)81))); 
VECTOR_SET(BgL_v1203z00_1178,((long)1),BgL_arg2135z00_1192); } 
BgL_arg2121z00_1165 = BgL_v1203z00_1178; } 
{ /* Llib/ssl.scm 496 */
obj_t BgL_v1204z00_1205;
BgL_v1204z00_1205 = 
create_vector(((long)0)); 
BgL_arg2122z00_1166 = BgL_v1204z00_1205; } 
BGl_sslzd2hmaczd2zz__ssl_sslz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)82)), 
CNST_TABLE_REF(((long)31)), BGl_objectz00zz__objectz00, ((long)62191), BGl_proc3535z00zz__ssl_sslz00, BGl_proc3534z00zz__ssl_sslz00, BFALSE, BGl_proc3533z00zz__ssl_sslz00, BFALSE, BgL_arg2121z00_1165, BgL_arg2122z00_1166); } 
{ /* Llib/ssl.scm 504 */
obj_t BgL_arg2146z00_1212;obj_t BgL_arg2147z00_1213;
{ /* Llib/ssl.scm 504 */
obj_t BgL_v1205z00_1225;
BgL_v1205z00_1225 = 
create_vector(((long)2)); 
{ /* Llib/ssl.scm 504 */
obj_t BgL_arg2153z00_1226;
BgL_arg2153z00_1226 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)75)), BGl_proc3538z00zz__ssl_sslz00, BGl_proc3537z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3536z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)76))); 
VECTOR_SET(BgL_v1205z00_1225,((long)0),BgL_arg2153z00_1226); } 
{ /* Llib/ssl.scm 504 */
obj_t BgL_arg2160z00_1239;
BgL_arg2160z00_1239 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)77)), BGl_proc3541z00zz__ssl_sslz00, BGl_proc3540z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3539z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)81))); 
VECTOR_SET(BgL_v1205z00_1225,((long)1),BgL_arg2160z00_1239); } 
BgL_arg2146z00_1212 = BgL_v1205z00_1225; } 
{ /* Llib/ssl.scm 504 */
obj_t BgL_v1206z00_1252;
BgL_v1206z00_1252 = 
create_vector(((long)0)); 
BgL_arg2147z00_1213 = BgL_v1206z00_1252; } 
BGl_sslzd2signzd2zz__ssl_sslz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)83)), 
CNST_TABLE_REF(((long)31)), BGl_objectz00zz__objectz00, ((long)64231), BGl_proc3544z00zz__ssl_sslz00, BGl_proc3543z00zz__ssl_sslz00, BFALSE, BGl_proc3542z00zz__ssl_sslz00, BFALSE, BgL_arg2146z00_1212, BgL_arg2147z00_1213); } 
{ /* Llib/ssl.scm 512 */
obj_t BgL_arg2170z00_1259;obj_t BgL_arg2171z00_1260;
{ /* Llib/ssl.scm 512 */
obj_t BgL_v1207z00_1272;
BgL_v1207z00_1272 = 
create_vector(((long)2)); 
{ /* Llib/ssl.scm 512 */
obj_t BgL_arg2177z00_1273;
BgL_arg2177z00_1273 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)75)), BGl_proc3547z00zz__ssl_sslz00, BGl_proc3546z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3545z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)76))); 
VECTOR_SET(BgL_v1207z00_1272,((long)0),BgL_arg2177z00_1273); } 
{ /* Llib/ssl.scm 512 */
obj_t BgL_arg2184z00_1286;
BgL_arg2184z00_1286 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)77)), BGl_proc3550z00zz__ssl_sslz00, BGl_proc3549z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3548z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)81))); 
VECTOR_SET(BgL_v1207z00_1272,((long)1),BgL_arg2184z00_1286); } 
BgL_arg2170z00_1259 = BgL_v1207z00_1272; } 
{ /* Llib/ssl.scm 512 */
obj_t BgL_v1208z00_1299;
BgL_v1208z00_1299 = 
create_vector(((long)0)); 
BgL_arg2171z00_1260 = BgL_v1208z00_1299; } 
BGl_sslzd2verifyzd2zz__ssl_sslz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)84)), 
CNST_TABLE_REF(((long)31)), BGl_objectz00zz__objectz00, ((long)31563), BGl_proc3553z00zz__ssl_sslz00, BGl_proc3552z00zz__ssl_sslz00, BFALSE, BGl_proc3551z00zz__ssl_sslz00, BFALSE, BgL_arg2170z00_1259, BgL_arg2171z00_1260); } 
{ /* Llib/ssl.scm 520 */
obj_t BgL_arg2194z00_1306;obj_t BgL_arg2195z00_1307;
{ /* Llib/ssl.scm 520 */
obj_t BgL_v1209z00_1319;
BgL_v1209z00_1319 = 
create_vector(((long)2)); 
{ /* Llib/ssl.scm 520 */
obj_t BgL_arg2201z00_1320;
BgL_arg2201z00_1320 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)85)), BGl_proc3556z00zz__ssl_sslz00, BGl_proc3555z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3554z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)86))); 
VECTOR_SET(BgL_v1209z00_1319,((long)0),BgL_arg2201z00_1320); } 
{ /* Llib/ssl.scm 520 */
obj_t BgL_arg2208z00_1333;
BgL_arg2208z00_1333 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)87)), BGl_proc3559z00zz__ssl_sslz00, BGl_proc3558z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3557z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)88))); 
VECTOR_SET(BgL_v1209z00_1319,((long)1),BgL_arg2208z00_1333); } 
BgL_arg2194z00_1306 = BgL_v1209z00_1319; } 
{ /* Llib/ssl.scm 520 */
obj_t BgL_v1210z00_1346;
BgL_v1210z00_1346 = 
create_vector(((long)0)); 
BgL_arg2195z00_1307 = BgL_v1210z00_1346; } 
return ( 
BGl_sslzd2cipherzd2zz__ssl_sslz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)89)), 
CNST_TABLE_REF(((long)31)), BGl_objectz00zz__objectz00, ((long)23017), BGl_proc3562z00zz__ssl_sslz00, BGl_proc3561z00zz__ssl_sslz00, BFALSE, BGl_proc3560z00zz__ssl_sslz00, BFALSE, BgL_arg2194z00_1306, BgL_arg2195z00_1307), BUNSPEC) ;} } 

}



/* &<@anonymous:2200> */
obj_t BGl_z62zc3z04anonymousza32200ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4373, obj_t BgL_new1116z00_4374)
{
{ /* Llib/ssl.scm 520 */
{ 
BgL_sslzd2cipherzd2_bglt BgL_auxz00_7360;
((((BgL_sslzd2cipherzd2_bglt)COBJECT(
((BgL_sslzd2cipherzd2_bglt)BgL_new1116z00_4374)))->BgL_z42cipherz42)=((void *)
0L),BUNSPEC); 
((((BgL_sslzd2cipherzd2_bglt)COBJECT(
((BgL_sslzd2cipherzd2_bglt)BgL_new1116z00_4374)))->BgL_z42cipherzd2ctxz90)=((void *)
0L),BUNSPEC); 
BgL_auxz00_7360 = 
((BgL_sslzd2cipherzd2_bglt)BgL_new1116z00_4374); 
return 
((obj_t)BgL_auxz00_7360);} } 

}



/* &lambda2198 */
BgL_sslzd2cipherzd2_bglt BGl_z62lambda2198z62zz__ssl_sslz00(obj_t BgL_envz00_4375)
{
{ /* Llib/ssl.scm 520 */
{ /* Llib/ssl.scm 520 */
BgL_sslzd2cipherzd2_bglt BgL_new1115z00_5671;
BgL_new1115z00_5671 = 
((BgL_sslzd2cipherzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_sslzd2cipherzd2_bgl) ))); 
{ /* Llib/ssl.scm 520 */
long BgL_arg2199z00_5672;
{ /* Llib/ssl.scm 520 */
long BgL_res2370z00_5673;
BgL_res2370z00_5673 = 
BGL_CLASS_INDEX(BGl_sslzd2cipherzd2zz__ssl_sslz00); 
BgL_arg2199z00_5672 = BgL_res2370z00_5673; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1115z00_5671), BgL_arg2199z00_5672); } 
return BgL_new1115z00_5671;} } 

}



/* &lambda2196 */
BgL_sslzd2cipherzd2_bglt BGl_z62lambda2196z62zz__ssl_sslz00(obj_t BgL_envz00_4376, obj_t BgL_z42cipher1113z42_4377, obj_t BgL_z42cipherzd2ctx1114z90_4378)
{
{ /* Llib/ssl.scm 520 */
{ /* Llib/ssl.scm 520 */
void * BgL_z42cipher1113z42_5674;void * BgL_z42cipherzd2ctx1114z90_5675;
BgL_z42cipher1113z42_5674 = 
FOREIGN_TO_COBJ(BgL_z42cipher1113z42_4377); 
BgL_z42cipherzd2ctx1114z90_5675 = 
FOREIGN_TO_COBJ(BgL_z42cipherzd2ctx1114z90_4378); 
{ /* Llib/ssl.scm 520 */
BgL_sslzd2cipherzd2_bglt BgL_new1179z00_5676;
{ /* Llib/ssl.scm 520 */
BgL_sslzd2cipherzd2_bglt BgL_new1178z00_5677;
BgL_new1178z00_5677 = 
((BgL_sslzd2cipherzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_sslzd2cipherzd2_bgl) ))); 
{ /* Llib/ssl.scm 520 */
long BgL_arg2197z00_5678;
{ /* Llib/ssl.scm 520 */
long BgL_res2369z00_5679;
BgL_res2369z00_5679 = 
BGL_CLASS_INDEX(BGl_sslzd2cipherzd2zz__ssl_sslz00); 
BgL_arg2197z00_5678 = BgL_res2369z00_5679; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1178z00_5677), BgL_arg2197z00_5678); } 
BgL_new1179z00_5676 = BgL_new1178z00_5677; } 
((((BgL_sslzd2cipherzd2_bglt)COBJECT(BgL_new1179z00_5676))->BgL_z42cipherz42)=((void *)BgL_z42cipher1113z42_5674),BUNSPEC); 
((((BgL_sslzd2cipherzd2_bglt)COBJECT(BgL_new1179z00_5676))->BgL_z42cipherzd2ctxz90)=((void *)BgL_z42cipherzd2ctx1114z90_5675),BUNSPEC); 
return BgL_new1179z00_5676;} } } 

}



/* &<@anonymous:2214> */
obj_t BGl_z62zc3z04anonymousza32214ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4379)
{
{ /* Llib/ssl.scm 520 */
return 
void_star_to_obj(0L);} 

}



/* &lambda2213 */
obj_t BGl_z62lambda2213z62zz__ssl_sslz00(obj_t BgL_envz00_4380, obj_t BgL_oz00_4381, obj_t BgL_vz00_4382)
{
{ /* Llib/ssl.scm 520 */
{ /* Llib/ssl.scm 520 */
void * BgL_vz00_5681;
BgL_vz00_5681 = 
FOREIGN_TO_COBJ(BgL_vz00_4382); 
return 
((((BgL_sslzd2cipherzd2_bglt)COBJECT(
((BgL_sslzd2cipherzd2_bglt)BgL_oz00_4381)))->BgL_z42cipherzd2ctxz90)=((void *)BgL_vz00_5681),BUNSPEC);} } 

}



/* &lambda2212 */
obj_t BGl_z62lambda2212z62zz__ssl_sslz00(obj_t BgL_envz00_4383, obj_t BgL_oz00_4384)
{
{ /* Llib/ssl.scm 520 */
return 
void_star_to_obj(
(((BgL_sslzd2cipherzd2_bglt)COBJECT(
((BgL_sslzd2cipherzd2_bglt)BgL_oz00_4384)))->BgL_z42cipherzd2ctxz90));} 

}



/* &<@anonymous:2207> */
obj_t BGl_z62zc3z04anonymousza32207ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4385)
{
{ /* Llib/ssl.scm 520 */
return 
void_star_to_obj(0L);} 

}



/* &lambda2206 */
obj_t BGl_z62lambda2206z62zz__ssl_sslz00(obj_t BgL_envz00_4386, obj_t BgL_oz00_4387, obj_t BgL_vz00_4388)
{
{ /* Llib/ssl.scm 520 */
{ /* Llib/ssl.scm 520 */
void * BgL_vz00_5684;
BgL_vz00_5684 = 
FOREIGN_TO_COBJ(BgL_vz00_4388); 
return 
((((BgL_sslzd2cipherzd2_bglt)COBJECT(
((BgL_sslzd2cipherzd2_bglt)BgL_oz00_4387)))->BgL_z42cipherz42)=((void *)BgL_vz00_5684),BUNSPEC);} } 

}



/* &lambda2205 */
obj_t BGl_z62lambda2205z62zz__ssl_sslz00(obj_t BgL_envz00_4389, obj_t BgL_oz00_4390)
{
{ /* Llib/ssl.scm 520 */
return 
void_star_to_obj(
(((BgL_sslzd2cipherzd2_bglt)COBJECT(
((BgL_sslzd2cipherzd2_bglt)BgL_oz00_4390)))->BgL_z42cipherz42));} 

}



/* &<@anonymous:2176> */
obj_t BGl_z62zc3z04anonymousza32176ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4391, obj_t BgL_new1111z00_4392)
{
{ /* Llib/ssl.scm 512 */
{ 
BgL_sslzd2verifyzd2_bglt BgL_auxz00_7395;
((((BgL_sslzd2verifyzd2_bglt)COBJECT(
((BgL_sslzd2verifyzd2_bglt)BgL_new1111z00_4392)))->BgL_z42mdz42)=((void *)
0L),BUNSPEC); 
((((BgL_sslzd2verifyzd2_bglt)COBJECT(
((BgL_sslzd2verifyzd2_bglt)BgL_new1111z00_4392)))->BgL_z42mdzd2ctxz90)=((void *)
0L),BUNSPEC); 
BgL_auxz00_7395 = 
((BgL_sslzd2verifyzd2_bglt)BgL_new1111z00_4392); 
return 
((obj_t)BgL_auxz00_7395);} } 

}



/* &lambda2174 */
BgL_sslzd2verifyzd2_bglt BGl_z62lambda2174z62zz__ssl_sslz00(obj_t BgL_envz00_4393)
{
{ /* Llib/ssl.scm 512 */
{ /* Llib/ssl.scm 512 */
BgL_sslzd2verifyzd2_bglt BgL_new1110z00_5687;
BgL_new1110z00_5687 = 
((BgL_sslzd2verifyzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_sslzd2verifyzd2_bgl) ))); 
{ /* Llib/ssl.scm 512 */
long BgL_arg2175z00_5688;
{ /* Llib/ssl.scm 512 */
long BgL_res2368z00_5689;
BgL_res2368z00_5689 = 
BGL_CLASS_INDEX(BGl_sslzd2verifyzd2zz__ssl_sslz00); 
BgL_arg2175z00_5688 = BgL_res2368z00_5689; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1110z00_5687), BgL_arg2175z00_5688); } 
return BgL_new1110z00_5687;} } 

}



/* &lambda2172 */
BgL_sslzd2verifyzd2_bglt BGl_z62lambda2172z62zz__ssl_sslz00(obj_t BgL_envz00_4394, obj_t BgL_z42md1108z42_4395, obj_t BgL_z42mdzd2ctx1109z90_4396)
{
{ /* Llib/ssl.scm 512 */
{ /* Llib/ssl.scm 512 */
void * BgL_z42md1108z42_5690;void * BgL_z42mdzd2ctx1109z90_5691;
BgL_z42md1108z42_5690 = 
FOREIGN_TO_COBJ(BgL_z42md1108z42_4395); 
BgL_z42mdzd2ctx1109z90_5691 = 
FOREIGN_TO_COBJ(BgL_z42mdzd2ctx1109z90_4396); 
{ /* Llib/ssl.scm 512 */
BgL_sslzd2verifyzd2_bglt BgL_new1177z00_5692;
{ /* Llib/ssl.scm 512 */
BgL_sslzd2verifyzd2_bglt BgL_new1176z00_5693;
BgL_new1176z00_5693 = 
((BgL_sslzd2verifyzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_sslzd2verifyzd2_bgl) ))); 
{ /* Llib/ssl.scm 512 */
long BgL_arg2173z00_5694;
{ /* Llib/ssl.scm 512 */
long BgL_res2367z00_5695;
BgL_res2367z00_5695 = 
BGL_CLASS_INDEX(BGl_sslzd2verifyzd2zz__ssl_sslz00); 
BgL_arg2173z00_5694 = BgL_res2367z00_5695; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1176z00_5693), BgL_arg2173z00_5694); } 
BgL_new1177z00_5692 = BgL_new1176z00_5693; } 
((((BgL_sslzd2verifyzd2_bglt)COBJECT(BgL_new1177z00_5692))->BgL_z42mdz42)=((void *)BgL_z42md1108z42_5690),BUNSPEC); 
((((BgL_sslzd2verifyzd2_bglt)COBJECT(BgL_new1177z00_5692))->BgL_z42mdzd2ctxz90)=((void *)BgL_z42mdzd2ctx1109z90_5691),BUNSPEC); 
return BgL_new1177z00_5692;} } } 

}



/* &<@anonymous:2190> */
obj_t BGl_z62zc3z04anonymousza32190ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4397)
{
{ /* Llib/ssl.scm 512 */
return 
void_star_to_obj(0L);} 

}



/* &lambda2189 */
obj_t BGl_z62lambda2189z62zz__ssl_sslz00(obj_t BgL_envz00_4398, obj_t BgL_oz00_4399, obj_t BgL_vz00_4400)
{
{ /* Llib/ssl.scm 512 */
{ /* Llib/ssl.scm 512 */
void * BgL_vz00_5697;
BgL_vz00_5697 = 
FOREIGN_TO_COBJ(BgL_vz00_4400); 
return 
((((BgL_sslzd2verifyzd2_bglt)COBJECT(
((BgL_sslzd2verifyzd2_bglt)BgL_oz00_4399)))->BgL_z42mdzd2ctxz90)=((void *)BgL_vz00_5697),BUNSPEC);} } 

}



/* &lambda2188 */
obj_t BGl_z62lambda2188z62zz__ssl_sslz00(obj_t BgL_envz00_4401, obj_t BgL_oz00_4402)
{
{ /* Llib/ssl.scm 512 */
return 
void_star_to_obj(
(((BgL_sslzd2verifyzd2_bglt)COBJECT(
((BgL_sslzd2verifyzd2_bglt)BgL_oz00_4402)))->BgL_z42mdzd2ctxz90));} 

}



/* &<@anonymous:2183> */
obj_t BGl_z62zc3z04anonymousza32183ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4403)
{
{ /* Llib/ssl.scm 512 */
return 
void_star_to_obj(0L);} 

}



/* &lambda2182 */
obj_t BGl_z62lambda2182z62zz__ssl_sslz00(obj_t BgL_envz00_4404, obj_t BgL_oz00_4405, obj_t BgL_vz00_4406)
{
{ /* Llib/ssl.scm 512 */
{ /* Llib/ssl.scm 512 */
void * BgL_vz00_5700;
BgL_vz00_5700 = 
FOREIGN_TO_COBJ(BgL_vz00_4406); 
return 
((((BgL_sslzd2verifyzd2_bglt)COBJECT(
((BgL_sslzd2verifyzd2_bglt)BgL_oz00_4405)))->BgL_z42mdz42)=((void *)BgL_vz00_5700),BUNSPEC);} } 

}



/* &lambda2181 */
obj_t BGl_z62lambda2181z62zz__ssl_sslz00(obj_t BgL_envz00_4407, obj_t BgL_oz00_4408)
{
{ /* Llib/ssl.scm 512 */
return 
void_star_to_obj(
(((BgL_sslzd2verifyzd2_bglt)COBJECT(
((BgL_sslzd2verifyzd2_bglt)BgL_oz00_4408)))->BgL_z42mdz42));} 

}



/* &<@anonymous:2152> */
obj_t BGl_z62zc3z04anonymousza32152ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4409, obj_t BgL_new1106z00_4410)
{
{ /* Llib/ssl.scm 504 */
{ 
BgL_sslzd2signzd2_bglt BgL_auxz00_7430;
((((BgL_sslzd2signzd2_bglt)COBJECT(
((BgL_sslzd2signzd2_bglt)BgL_new1106z00_4410)))->BgL_z42mdz42)=((void *)
0L),BUNSPEC); 
((((BgL_sslzd2signzd2_bglt)COBJECT(
((BgL_sslzd2signzd2_bglt)BgL_new1106z00_4410)))->BgL_z42mdzd2ctxz90)=((void *)
0L),BUNSPEC); 
BgL_auxz00_7430 = 
((BgL_sslzd2signzd2_bglt)BgL_new1106z00_4410); 
return 
((obj_t)BgL_auxz00_7430);} } 

}



/* &lambda2150 */
BgL_sslzd2signzd2_bglt BGl_z62lambda2150z62zz__ssl_sslz00(obj_t BgL_envz00_4411)
{
{ /* Llib/ssl.scm 504 */
{ /* Llib/ssl.scm 504 */
BgL_sslzd2signzd2_bglt BgL_new1105z00_5703;
BgL_new1105z00_5703 = 
((BgL_sslzd2signzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_sslzd2signzd2_bgl) ))); 
{ /* Llib/ssl.scm 504 */
long BgL_arg2151z00_5704;
{ /* Llib/ssl.scm 504 */
long BgL_res2366z00_5705;
BgL_res2366z00_5705 = 
BGL_CLASS_INDEX(BGl_sslzd2signzd2zz__ssl_sslz00); 
BgL_arg2151z00_5704 = BgL_res2366z00_5705; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1105z00_5703), BgL_arg2151z00_5704); } 
return BgL_new1105z00_5703;} } 

}



/* &lambda2148 */
BgL_sslzd2signzd2_bglt BGl_z62lambda2148z62zz__ssl_sslz00(obj_t BgL_envz00_4412, obj_t BgL_z42md1103z42_4413, obj_t BgL_z42mdzd2ctx1104z90_4414)
{
{ /* Llib/ssl.scm 504 */
{ /* Llib/ssl.scm 504 */
void * BgL_z42md1103z42_5706;void * BgL_z42mdzd2ctx1104z90_5707;
BgL_z42md1103z42_5706 = 
FOREIGN_TO_COBJ(BgL_z42md1103z42_4413); 
BgL_z42mdzd2ctx1104z90_5707 = 
FOREIGN_TO_COBJ(BgL_z42mdzd2ctx1104z90_4414); 
{ /* Llib/ssl.scm 504 */
BgL_sslzd2signzd2_bglt BgL_new1175z00_5708;
{ /* Llib/ssl.scm 504 */
BgL_sslzd2signzd2_bglt BgL_new1174z00_5709;
BgL_new1174z00_5709 = 
((BgL_sslzd2signzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_sslzd2signzd2_bgl) ))); 
{ /* Llib/ssl.scm 504 */
long BgL_arg2149z00_5710;
{ /* Llib/ssl.scm 504 */
long BgL_res2365z00_5711;
BgL_res2365z00_5711 = 
BGL_CLASS_INDEX(BGl_sslzd2signzd2zz__ssl_sslz00); 
BgL_arg2149z00_5710 = BgL_res2365z00_5711; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1174z00_5709), BgL_arg2149z00_5710); } 
BgL_new1175z00_5708 = BgL_new1174z00_5709; } 
((((BgL_sslzd2signzd2_bglt)COBJECT(BgL_new1175z00_5708))->BgL_z42mdz42)=((void *)BgL_z42md1103z42_5706),BUNSPEC); 
((((BgL_sslzd2signzd2_bglt)COBJECT(BgL_new1175z00_5708))->BgL_z42mdzd2ctxz90)=((void *)BgL_z42mdzd2ctx1104z90_5707),BUNSPEC); 
return BgL_new1175z00_5708;} } } 

}



/* &<@anonymous:2166> */
obj_t BGl_z62zc3z04anonymousza32166ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4415)
{
{ /* Llib/ssl.scm 504 */
return 
void_star_to_obj(0L);} 

}



/* &lambda2165 */
obj_t BGl_z62lambda2165z62zz__ssl_sslz00(obj_t BgL_envz00_4416, obj_t BgL_oz00_4417, obj_t BgL_vz00_4418)
{
{ /* Llib/ssl.scm 504 */
{ /* Llib/ssl.scm 504 */
void * BgL_vz00_5713;
BgL_vz00_5713 = 
FOREIGN_TO_COBJ(BgL_vz00_4418); 
return 
((((BgL_sslzd2signzd2_bglt)COBJECT(
((BgL_sslzd2signzd2_bglt)BgL_oz00_4417)))->BgL_z42mdzd2ctxz90)=((void *)BgL_vz00_5713),BUNSPEC);} } 

}



/* &lambda2164 */
obj_t BGl_z62lambda2164z62zz__ssl_sslz00(obj_t BgL_envz00_4419, obj_t BgL_oz00_4420)
{
{ /* Llib/ssl.scm 504 */
return 
void_star_to_obj(
(((BgL_sslzd2signzd2_bglt)COBJECT(
((BgL_sslzd2signzd2_bglt)BgL_oz00_4420)))->BgL_z42mdzd2ctxz90));} 

}



/* &<@anonymous:2159> */
obj_t BGl_z62zc3z04anonymousza32159ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4421)
{
{ /* Llib/ssl.scm 504 */
return 
void_star_to_obj(0L);} 

}



/* &lambda2158 */
obj_t BGl_z62lambda2158z62zz__ssl_sslz00(obj_t BgL_envz00_4422, obj_t BgL_oz00_4423, obj_t BgL_vz00_4424)
{
{ /* Llib/ssl.scm 504 */
{ /* Llib/ssl.scm 504 */
void * BgL_vz00_5716;
BgL_vz00_5716 = 
FOREIGN_TO_COBJ(BgL_vz00_4424); 
return 
((((BgL_sslzd2signzd2_bglt)COBJECT(
((BgL_sslzd2signzd2_bglt)BgL_oz00_4423)))->BgL_z42mdz42)=((void *)BgL_vz00_5716),BUNSPEC);} } 

}



/* &lambda2157 */
obj_t BGl_z62lambda2157z62zz__ssl_sslz00(obj_t BgL_envz00_4425, obj_t BgL_oz00_4426)
{
{ /* Llib/ssl.scm 504 */
return 
void_star_to_obj(
(((BgL_sslzd2signzd2_bglt)COBJECT(
((BgL_sslzd2signzd2_bglt)BgL_oz00_4426)))->BgL_z42mdz42));} 

}



/* &<@anonymous:2127> */
obj_t BGl_z62zc3z04anonymousza32127ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4427, obj_t BgL_new1101z00_4428)
{
{ /* Llib/ssl.scm 496 */
{ 
BgL_sslzd2hmaczd2_bglt BgL_auxz00_7465;
((((BgL_sslzd2hmaczd2_bglt)COBJECT(
((BgL_sslzd2hmaczd2_bglt)BgL_new1101z00_4428)))->BgL_z42mdz42)=((void *)
0L),BUNSPEC); 
((((BgL_sslzd2hmaczd2_bglt)COBJECT(
((BgL_sslzd2hmaczd2_bglt)BgL_new1101z00_4428)))->BgL_z42mdzd2ctxz90)=((void *)
0L),BUNSPEC); 
BgL_auxz00_7465 = 
((BgL_sslzd2hmaczd2_bglt)BgL_new1101z00_4428); 
return 
((obj_t)BgL_auxz00_7465);} } 

}



/* &lambda2125 */
BgL_sslzd2hmaczd2_bglt BGl_z62lambda2125z62zz__ssl_sslz00(obj_t BgL_envz00_4429)
{
{ /* Llib/ssl.scm 496 */
{ /* Llib/ssl.scm 496 */
BgL_sslzd2hmaczd2_bglt BgL_new1100z00_5719;
BgL_new1100z00_5719 = 
((BgL_sslzd2hmaczd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_sslzd2hmaczd2_bgl) ))); 
{ /* Llib/ssl.scm 496 */
long BgL_arg2126z00_5720;
{ /* Llib/ssl.scm 496 */
long BgL_res2364z00_5721;
BgL_res2364z00_5721 = 
BGL_CLASS_INDEX(BGl_sslzd2hmaczd2zz__ssl_sslz00); 
BgL_arg2126z00_5720 = BgL_res2364z00_5721; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1100z00_5719), BgL_arg2126z00_5720); } 
return BgL_new1100z00_5719;} } 

}



/* &lambda2123 */
BgL_sslzd2hmaczd2_bglt BGl_z62lambda2123z62zz__ssl_sslz00(obj_t BgL_envz00_4430, obj_t BgL_z42md1098z42_4431, obj_t BgL_z42mdzd2ctx1099z90_4432)
{
{ /* Llib/ssl.scm 496 */
{ /* Llib/ssl.scm 496 */
void * BgL_z42md1098z42_5722;void * BgL_z42mdzd2ctx1099z90_5723;
BgL_z42md1098z42_5722 = 
FOREIGN_TO_COBJ(BgL_z42md1098z42_4431); 
BgL_z42mdzd2ctx1099z90_5723 = 
FOREIGN_TO_COBJ(BgL_z42mdzd2ctx1099z90_4432); 
{ /* Llib/ssl.scm 496 */
BgL_sslzd2hmaczd2_bglt BgL_new1173z00_5724;
{ /* Llib/ssl.scm 496 */
BgL_sslzd2hmaczd2_bglt BgL_new1172z00_5725;
BgL_new1172z00_5725 = 
((BgL_sslzd2hmaczd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_sslzd2hmaczd2_bgl) ))); 
{ /* Llib/ssl.scm 496 */
long BgL_arg2124z00_5726;
{ /* Llib/ssl.scm 496 */
long BgL_res2363z00_5727;
BgL_res2363z00_5727 = 
BGL_CLASS_INDEX(BGl_sslzd2hmaczd2zz__ssl_sslz00); 
BgL_arg2124z00_5726 = BgL_res2363z00_5727; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1172z00_5725), BgL_arg2124z00_5726); } 
BgL_new1173z00_5724 = BgL_new1172z00_5725; } 
((((BgL_sslzd2hmaczd2_bglt)COBJECT(BgL_new1173z00_5724))->BgL_z42mdz42)=((void *)BgL_z42md1098z42_5722),BUNSPEC); 
((((BgL_sslzd2hmaczd2_bglt)COBJECT(BgL_new1173z00_5724))->BgL_z42mdzd2ctxz90)=((void *)BgL_z42mdzd2ctx1099z90_5723),BUNSPEC); 
return BgL_new1173z00_5724;} } } 

}



/* &<@anonymous:2141> */
obj_t BGl_z62zc3z04anonymousza32141ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4433)
{
{ /* Llib/ssl.scm 496 */
return 
void_star_to_obj(0L);} 

}



/* &lambda2140 */
obj_t BGl_z62lambda2140z62zz__ssl_sslz00(obj_t BgL_envz00_4434, obj_t BgL_oz00_4435, obj_t BgL_vz00_4436)
{
{ /* Llib/ssl.scm 496 */
{ /* Llib/ssl.scm 496 */
void * BgL_vz00_5729;
BgL_vz00_5729 = 
FOREIGN_TO_COBJ(BgL_vz00_4436); 
return 
((((BgL_sslzd2hmaczd2_bglt)COBJECT(
((BgL_sslzd2hmaczd2_bglt)BgL_oz00_4435)))->BgL_z42mdzd2ctxz90)=((void *)BgL_vz00_5729),BUNSPEC);} } 

}



/* &lambda2139 */
obj_t BGl_z62lambda2139z62zz__ssl_sslz00(obj_t BgL_envz00_4437, obj_t BgL_oz00_4438)
{
{ /* Llib/ssl.scm 496 */
return 
void_star_to_obj(
(((BgL_sslzd2hmaczd2_bglt)COBJECT(
((BgL_sslzd2hmaczd2_bglt)BgL_oz00_4438)))->BgL_z42mdzd2ctxz90));} 

}



/* &<@anonymous:2134> */
obj_t BGl_z62zc3z04anonymousza32134ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4439)
{
{ /* Llib/ssl.scm 496 */
return 
void_star_to_obj(0L);} 

}



/* &lambda2133 */
obj_t BGl_z62lambda2133z62zz__ssl_sslz00(obj_t BgL_envz00_4440, obj_t BgL_oz00_4441, obj_t BgL_vz00_4442)
{
{ /* Llib/ssl.scm 496 */
{ /* Llib/ssl.scm 496 */
void * BgL_vz00_5732;
BgL_vz00_5732 = 
FOREIGN_TO_COBJ(BgL_vz00_4442); 
return 
((((BgL_sslzd2hmaczd2_bglt)COBJECT(
((BgL_sslzd2hmaczd2_bglt)BgL_oz00_4441)))->BgL_z42mdz42)=((void *)BgL_vz00_5732),BUNSPEC);} } 

}



/* &lambda2132 */
obj_t BGl_z62lambda2132z62zz__ssl_sslz00(obj_t BgL_envz00_4443, obj_t BgL_oz00_4444)
{
{ /* Llib/ssl.scm 496 */
return 
void_star_to_obj(
(((BgL_sslzd2hmaczd2_bglt)COBJECT(
((BgL_sslzd2hmaczd2_bglt)BgL_oz00_4444)))->BgL_z42mdz42));} 

}



/* &<@anonymous:2098> */
obj_t BGl_z62zc3z04anonymousza32098ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4445, obj_t BgL_new1096z00_4446)
{
{ /* Llib/ssl.scm 486 */
{ 
BgL_sslzd2hashzd2_bglt BgL_auxz00_7500;
((((BgL_sslzd2hashzd2_bglt)COBJECT(
((BgL_sslzd2hashzd2_bglt)BgL_new1096z00_4446)))->BgL_z42mdz42)=((void *)
0L),BUNSPEC); 
((((BgL_sslzd2hashzd2_bglt)COBJECT(
((BgL_sslzd2hashzd2_bglt)BgL_new1096z00_4446)))->BgL_z42mdzd2ctxz90)=((void *)
0L),BUNSPEC); 
((((BgL_sslzd2hashzd2_bglt)COBJECT(
((BgL_sslzd2hashzd2_bglt)BgL_new1096z00_4446)))->BgL_typez00)=((obj_t)BGl_string3563z00zz__ssl_sslz00),BUNSPEC); 
BgL_auxz00_7500 = 
((BgL_sslzd2hashzd2_bglt)BgL_new1096z00_4446); 
return 
((obj_t)BgL_auxz00_7500);} } 

}



/* &lambda2096 */
BgL_sslzd2hashzd2_bglt BGl_z62lambda2096z62zz__ssl_sslz00(obj_t BgL_envz00_4447)
{
{ /* Llib/ssl.scm 486 */
{ /* Llib/ssl.scm 486 */
BgL_sslzd2hashzd2_bglt BgL_new1095z00_5735;
BgL_new1095z00_5735 = 
((BgL_sslzd2hashzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_sslzd2hashzd2_bgl) ))); 
{ /* Llib/ssl.scm 486 */
long BgL_arg2097z00_5736;
{ /* Llib/ssl.scm 486 */
long BgL_res2362z00_5737;
BgL_res2362z00_5737 = 
BGL_CLASS_INDEX(BGl_sslzd2hashzd2zz__ssl_sslz00); 
BgL_arg2097z00_5736 = BgL_res2362z00_5737; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1095z00_5735), BgL_arg2097z00_5736); } 
return BgL_new1095z00_5735;} } 

}



/* &lambda2093 */
BgL_sslzd2hashzd2_bglt BGl_z62lambda2093z62zz__ssl_sslz00(obj_t BgL_envz00_4448, obj_t BgL_z42md1092z42_4449, obj_t BgL_z42mdzd2ctx1093z90_4450, obj_t BgL_type1094z00_4451)
{
{ /* Llib/ssl.scm 486 */
{ /* Llib/ssl.scm 486 */
void * BgL_z42md1092z42_5738;void * BgL_z42mdzd2ctx1093z90_5739;
BgL_z42md1092z42_5738 = 
FOREIGN_TO_COBJ(BgL_z42md1092z42_4449); 
BgL_z42mdzd2ctx1093z90_5739 = 
FOREIGN_TO_COBJ(BgL_z42mdzd2ctx1093z90_4450); 
{ /* Llib/ssl.scm 486 */
BgL_sslzd2hashzd2_bglt BgL_new1171z00_5741;
{ /* Llib/ssl.scm 486 */
BgL_sslzd2hashzd2_bglt BgL_new1170z00_5742;
BgL_new1170z00_5742 = 
((BgL_sslzd2hashzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_sslzd2hashzd2_bgl) ))); 
{ /* Llib/ssl.scm 486 */
long BgL_arg2095z00_5743;
{ /* Llib/ssl.scm 486 */
long BgL_res2361z00_5744;
BgL_res2361z00_5744 = 
BGL_CLASS_INDEX(BGl_sslzd2hashzd2zz__ssl_sslz00); 
BgL_arg2095z00_5743 = BgL_res2361z00_5744; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1170z00_5742), BgL_arg2095z00_5743); } 
BgL_new1171z00_5741 = BgL_new1170z00_5742; } 
((((BgL_sslzd2hashzd2_bglt)COBJECT(BgL_new1171z00_5741))->BgL_z42mdz42)=((void *)BgL_z42md1092z42_5738),BUNSPEC); 
((((BgL_sslzd2hashzd2_bglt)COBJECT(BgL_new1171z00_5741))->BgL_z42mdzd2ctxz90)=((void *)BgL_z42mdzd2ctx1093z90_5739),BUNSPEC); 
((((BgL_sslzd2hashzd2_bglt)COBJECT(BgL_new1171z00_5741))->BgL_typez00)=((obj_t)
((obj_t)BgL_type1094z00_4451)),BUNSPEC); 
{ /* Llib/ssl.scm 486 */
obj_t BgL_fun2094z00_5745;
BgL_fun2094z00_5745 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_sslzd2hashzd2zz__ssl_sslz00); 
PROCEDURE_ENTRY(BgL_fun2094z00_5745)(BgL_fun2094z00_5745, 
((obj_t)BgL_new1171z00_5741), BEOA); } 
return BgL_new1171z00_5741;} } } 

}



/* &lambda2117 */
obj_t BGl_z62lambda2117z62zz__ssl_sslz00(obj_t BgL_envz00_4452, obj_t BgL_oz00_4453, obj_t BgL_vz00_4454)
{
{ /* Llib/ssl.scm 486 */
return 
((((BgL_sslzd2hashzd2_bglt)COBJECT(
((BgL_sslzd2hashzd2_bglt)BgL_oz00_4453)))->BgL_typez00)=((obj_t)
((obj_t)BgL_vz00_4454)),BUNSPEC);} 

}



/* &lambda2116 */
obj_t BGl_z62lambda2116z62zz__ssl_sslz00(obj_t BgL_envz00_4455, obj_t BgL_oz00_4456)
{
{ /* Llib/ssl.scm 486 */
return 
(((BgL_sslzd2hashzd2_bglt)COBJECT(
((BgL_sslzd2hashzd2_bglt)BgL_oz00_4456)))->BgL_typez00);} 

}



/* &<@anonymous:2112> */
obj_t BGl_z62zc3z04anonymousza32112ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4457)
{
{ /* Llib/ssl.scm 486 */
return 
void_star_to_obj(0L);} 

}



/* &lambda2111 */
obj_t BGl_z62lambda2111z62zz__ssl_sslz00(obj_t BgL_envz00_4458, obj_t BgL_oz00_4459, obj_t BgL_vz00_4460)
{
{ /* Llib/ssl.scm 486 */
{ /* Llib/ssl.scm 486 */
void * BgL_vz00_5750;
BgL_vz00_5750 = 
FOREIGN_TO_COBJ(BgL_vz00_4460); 
return 
((((BgL_sslzd2hashzd2_bglt)COBJECT(
((BgL_sslzd2hashzd2_bglt)BgL_oz00_4459)))->BgL_z42mdzd2ctxz90)=((void *)BgL_vz00_5750),BUNSPEC);} } 

}



/* &lambda2110 */
obj_t BGl_z62lambda2110z62zz__ssl_sslz00(obj_t BgL_envz00_4461, obj_t BgL_oz00_4462)
{
{ /* Llib/ssl.scm 486 */
return 
void_star_to_obj(
(((BgL_sslzd2hashzd2_bglt)COBJECT(
((BgL_sslzd2hashzd2_bglt)BgL_oz00_4462)))->BgL_z42mdzd2ctxz90));} 

}



/* &<@anonymous:2105> */
obj_t BGl_z62zc3z04anonymousza32105ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4463)
{
{ /* Llib/ssl.scm 486 */
return 
void_star_to_obj(0L);} 

}



/* &lambda2104 */
obj_t BGl_z62lambda2104z62zz__ssl_sslz00(obj_t BgL_envz00_4464, obj_t BgL_oz00_4465, obj_t BgL_vz00_4466)
{
{ /* Llib/ssl.scm 486 */
{ /* Llib/ssl.scm 486 */
void * BgL_vz00_5753;
BgL_vz00_5753 = 
FOREIGN_TO_COBJ(BgL_vz00_4466); 
return 
((((BgL_sslzd2hashzd2_bglt)COBJECT(
((BgL_sslzd2hashzd2_bglt)BgL_oz00_4465)))->BgL_z42mdz42)=((void *)BgL_vz00_5753),BUNSPEC);} } 

}



/* &lambda2103 */
obj_t BGl_z62lambda2103z62zz__ssl_sslz00(obj_t BgL_envz00_4467, obj_t BgL_oz00_4468)
{
{ /* Llib/ssl.scm 486 */
return 
void_star_to_obj(
(((BgL_sslzd2hashzd2_bglt)COBJECT(
((BgL_sslzd2hashzd2_bglt)BgL_oz00_4468)))->BgL_z42mdz42));} 

}



/* &<@anonymous:1952> */
obj_t BGl_z62zc3z04anonymousza31952ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4469, obj_t BgL_new1090z00_4470)
{
{ /* Llib/ssl.scm 431 */
{ 
BgL_dhz00_bglt BgL_auxz00_7550;
((((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_new1090z00_4470)))->BgL_z42nativez42)=((void *)
0L),BUNSPEC); 
((((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_new1090z00_4470)))->BgL_z52pz52)=((void *)
0L),BUNSPEC); 
((((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_new1090z00_4470)))->BgL_z52qz52)=((void *)
0L),BUNSPEC); 
((((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_new1090z00_4470)))->BgL_z52gz52)=((void *)
0L),BUNSPEC); 
((((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_new1090z00_4470)))->BgL_z52pubz52)=((void *)
0L),BUNSPEC); 
((((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_new1090z00_4470)))->BgL_z52privz52)=((void *)
0L),BUNSPEC); 
BgL_auxz00_7550 = 
((BgL_dhz00_bglt)BgL_new1090z00_4470); 
return 
((obj_t)BgL_auxz00_7550);} } 

}



/* &lambda1950 */
BgL_dhz00_bglt BGl_z62lambda1950z62zz__ssl_sslz00(obj_t BgL_envz00_4471)
{
{ /* Llib/ssl.scm 431 */
{ /* Llib/ssl.scm 431 */
BgL_dhz00_bglt BgL_new1089z00_5756;
BgL_new1089z00_5756 = 
((BgL_dhz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_dhz00_bgl) ))); 
{ /* Llib/ssl.scm 431 */
long BgL_arg1951z00_5757;
{ /* Llib/ssl.scm 431 */
long BgL_res2360z00_5758;
BgL_res2360z00_5758 = 
BGL_CLASS_INDEX(BGl_dhz00zz__ssl_sslz00); 
BgL_arg1951z00_5757 = BgL_res2360z00_5758; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1089z00_5756), BgL_arg1951z00_5757); } 
return BgL_new1089z00_5756;} } 

}



/* &lambda1947 */
BgL_dhz00_bglt BGl_z62lambda1947z62zz__ssl_sslz00(obj_t BgL_envz00_4472, obj_t BgL_z42native1083z42_4473, obj_t BgL_z52p1084z52_4474, obj_t BgL_z52q1085z52_4475, obj_t BgL_z52g1086z52_4476, obj_t BgL_z52pub1087z52_4477, obj_t BgL_z52priv1088z52_4478)
{
{ /* Llib/ssl.scm 431 */
{ /* Llib/ssl.scm 431 */
void * BgL_z42native1083z42_5759;void * BgL_z52p1084z52_5760;void * BgL_z52q1085z52_5761;void * BgL_z52g1086z52_5762;void * BgL_z52pub1087z52_5763;void * BgL_z52priv1088z52_5764;
BgL_z42native1083z42_5759 = 
FOREIGN_TO_COBJ(BgL_z42native1083z42_4473); 
BgL_z52p1084z52_5760 = 
FOREIGN_TO_COBJ(BgL_z52p1084z52_4474); 
BgL_z52q1085z52_5761 = 
FOREIGN_TO_COBJ(BgL_z52q1085z52_4475); 
BgL_z52g1086z52_5762 = 
FOREIGN_TO_COBJ(BgL_z52g1086z52_4476); 
BgL_z52pub1087z52_5763 = 
FOREIGN_TO_COBJ(BgL_z52pub1087z52_4477); 
BgL_z52priv1088z52_5764 = 
FOREIGN_TO_COBJ(BgL_z52priv1088z52_4478); 
{ /* Llib/ssl.scm 431 */
BgL_dhz00_bglt BgL_new1158z00_5765;
{ /* Llib/ssl.scm 431 */
BgL_dhz00_bglt BgL_new1157z00_5766;
BgL_new1157z00_5766 = 
((BgL_dhz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_dhz00_bgl) ))); 
{ /* Llib/ssl.scm 431 */
long BgL_arg1949z00_5767;
{ /* Llib/ssl.scm 431 */
long BgL_res2359z00_5768;
BgL_res2359z00_5768 = 
BGL_CLASS_INDEX(BGl_dhz00zz__ssl_sslz00); 
BgL_arg1949z00_5767 = BgL_res2359z00_5768; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1157z00_5766), BgL_arg1949z00_5767); } 
BgL_new1158z00_5765 = BgL_new1157z00_5766; } 
((((BgL_dhz00_bglt)COBJECT(BgL_new1158z00_5765))->BgL_z42nativez42)=((void *)BgL_z42native1083z42_5759),BUNSPEC); 
((((BgL_dhz00_bglt)COBJECT(BgL_new1158z00_5765))->BgL_z52pz52)=((void *)BgL_z52p1084z52_5760),BUNSPEC); 
((((BgL_dhz00_bglt)COBJECT(BgL_new1158z00_5765))->BgL_z52qz52)=((void *)BgL_z52q1085z52_5761),BUNSPEC); 
((((BgL_dhz00_bglt)COBJECT(BgL_new1158z00_5765))->BgL_z52gz52)=((void *)BgL_z52g1086z52_5762),BUNSPEC); 
((((BgL_dhz00_bglt)COBJECT(BgL_new1158z00_5765))->BgL_z52pubz52)=((void *)BgL_z52pub1087z52_5763),BUNSPEC); 
((((BgL_dhz00_bglt)COBJECT(BgL_new1158z00_5765))->BgL_z52privz52)=((void *)BgL_z52priv1088z52_5764),BUNSPEC); 
{ /* Llib/ssl.scm 431 */
obj_t BgL_fun1948z00_5769;
BgL_fun1948z00_5769 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_dhz00zz__ssl_sslz00); 
PROCEDURE_ENTRY(BgL_fun1948z00_5769)(BgL_fun1948z00_5769, 
((obj_t)BgL_new1158z00_5765), BEOA); } 
return BgL_new1158z00_5765;} } } 

}



/* &<@anonymous:2083> */
obj_t BGl_z62zc3z04anonymousza32083ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4479, obj_t BgL_oz00_4480, obj_t BgL_vz00_4481)
{
{ /* Llib/ssl.scm 476 */
{ 
void * BgL_auxz00_7597;
{ /* Llib/ssl.scm 482 */
obj_t BgL_tmpz00_7599;
BgL_tmpz00_7599 = 
((obj_t)BgL_vz00_4481); 
BgL_auxz00_7597 = 
(BIGNUM *)FOREIGN_TO_COBJ(BgL_tmpz00_7599); } 
((((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4480)))->BgL_z52pubz52)=((void *)BgL_auxz00_7597),BUNSPEC); } 
{ /* Llib/ssl.scm 483 */
void * BgL_arg2084z00_5770;void * BgL_arg2085z00_5771;void * BgL_arg2086z00_5772;
BgL_arg2084z00_5770 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4480)))->BgL_z42nativez42); 
BgL_arg2085z00_5771 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4480)))->BgL_z52pubz52); 
BgL_arg2086z00_5772 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4480)))->BgL_z52privz52); 
bgl_dh_pub_priv_key_set(BgL_arg2084z00_5770, BgL_arg2085z00_5771, BgL_arg2086z00_5772); BUNSPEC; } 
return 
((obj_t)BgL_vz00_4481);} 

}



/* &<@anonymous:2079> */
obj_t BGl_z62zc3z04anonymousza32079ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4482, obj_t BgL_oz00_4483)
{
{ /* Llib/ssl.scm 476 */
{ /* Llib/ssl.scm 479 */
void * BgL_arg2080z00_5773;
{ /* Llib/ssl.scm 479 */
void * BgL_arg2081z00_5774;
BgL_arg2081z00_5774 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4483)))->BgL_z42nativez42); 
BgL_arg2080z00_5773 = 
bgl_dh_public_key(BgL_arg2081z00_5774); } 
return 
void_star_to_obj(BgL_arg2080z00_5773);} } 

}



/* &<@anonymous:2070> */
obj_t BGl_z62zc3z04anonymousza32070ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4484, obj_t BgL_oz00_4485, obj_t BgL_vz00_4486)
{
{ /* Llib/ssl.scm 467 */
{ 
void * BgL_auxz00_7615;
{ /* Llib/ssl.scm 473 */
obj_t BgL_tmpz00_7617;
BgL_tmpz00_7617 = 
((obj_t)BgL_vz00_4486); 
BgL_auxz00_7615 = 
(BIGNUM *)FOREIGN_TO_COBJ(BgL_tmpz00_7617); } 
((((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4485)))->BgL_z52privz52)=((void *)BgL_auxz00_7615),BUNSPEC); } 
{ /* Llib/ssl.scm 474 */
void * BgL_arg2071z00_5775;void * BgL_arg2072z00_5776;void * BgL_arg2073z00_5777;
BgL_arg2071z00_5775 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4485)))->BgL_z42nativez42); 
BgL_arg2072z00_5776 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4485)))->BgL_z52pubz52); 
BgL_arg2073z00_5777 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4485)))->BgL_z52privz52); 
bgl_dh_pub_priv_key_set(BgL_arg2071z00_5775, BgL_arg2072z00_5776, BgL_arg2073z00_5777); BUNSPEC; } 
return 
((obj_t)BgL_vz00_4486);} 

}



/* &<@anonymous:2066> */
obj_t BGl_z62zc3z04anonymousza32066ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4487, obj_t BgL_oz00_4488)
{
{ /* Llib/ssl.scm 467 */
{ /* Llib/ssl.scm 470 */
void * BgL_arg2067z00_5778;
{ /* Llib/ssl.scm 470 */
void * BgL_arg2068z00_5779;
BgL_arg2068z00_5779 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4488)))->BgL_z42nativez42); 
BgL_arg2067z00_5778 = 
bgl_dh_private_key(BgL_arg2068z00_5779); } 
return 
void_star_to_obj(BgL_arg2067z00_5778);} } 

}



/* &<@anonymous:2056> */
obj_t BGl_z62zc3z04anonymousza32056ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4489, obj_t BgL_oz00_4490, obj_t BgL_vz00_4491)
{
{ /* Llib/ssl.scm 457 */
{ 
void * BgL_auxz00_7633;
{ /* Llib/ssl.scm 464 */
obj_t BgL_tmpz00_7635;
BgL_tmpz00_7635 = 
((obj_t)BgL_vz00_4491); 
BgL_auxz00_7633 = 
(BIGNUM *)FOREIGN_TO_COBJ(BgL_tmpz00_7635); } 
((((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4490)))->BgL_z52gz52)=((void *)BgL_auxz00_7633),BUNSPEC); } 
{ /* Llib/ssl.scm 465 */
void * BgL_arg2057z00_5780;void * BgL_arg2058z00_5781;void * BgL_arg2059z00_5782;void * BgL_arg2060z00_5783;
BgL_arg2057z00_5780 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4490)))->BgL_z42nativez42); 
BgL_arg2058z00_5781 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4490)))->BgL_z52pz52); 
BgL_arg2059z00_5782 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4490)))->BgL_z52qz52); 
BgL_arg2060z00_5783 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4490)))->BgL_z52gz52); 
bgl_dh_pqg_set(BgL_arg2057z00_5780, BgL_arg2058z00_5781, BgL_arg2059z00_5782, BgL_arg2060z00_5783); BUNSPEC; } 
return 
((obj_t)BgL_vz00_4491);} 

}



/* &<@anonymous:2052> */
obj_t BGl_z62zc3z04anonymousza32052ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4492, obj_t BgL_oz00_4493)
{
{ /* Llib/ssl.scm 457 */
{ /* Llib/ssl.scm 460 */
void * BgL_arg2053z00_5784;
{ /* Llib/ssl.scm 460 */
void * BgL_arg2054z00_5785;
BgL_arg2054z00_5785 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4493)))->BgL_z42nativez42); 
BgL_arg2053z00_5784 = 
bgl_dh_g(BgL_arg2054z00_5785); } 
return 
void_star_to_obj(BgL_arg2053z00_5784);} } 

}



/* &<@anonymous:2042> */
obj_t BGl_z62zc3z04anonymousza32042ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4494, obj_t BgL_oz00_4495, obj_t BgL_vz00_4496)
{
{ /* Llib/ssl.scm 448 */
{ 
void * BgL_auxz00_7653;
{ /* Llib/ssl.scm 454 */
obj_t BgL_tmpz00_7655;
BgL_tmpz00_7655 = 
((obj_t)BgL_vz00_4496); 
BgL_auxz00_7653 = 
(BIGNUM *)FOREIGN_TO_COBJ(BgL_tmpz00_7655); } 
((((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4495)))->BgL_z52qz52)=((void *)BgL_auxz00_7653),BUNSPEC); } 
{ /* Llib/ssl.scm 455 */
void * BgL_arg2043z00_5786;void * BgL_arg2044z00_5787;void * BgL_arg2045z00_5788;void * BgL_arg2046z00_5789;
BgL_arg2043z00_5786 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4495)))->BgL_z42nativez42); 
BgL_arg2044z00_5787 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4495)))->BgL_z52pz52); 
BgL_arg2045z00_5788 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4495)))->BgL_z52qz52); 
BgL_arg2046z00_5789 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4495)))->BgL_z52gz52); 
bgl_dh_pqg_set(BgL_arg2043z00_5786, BgL_arg2044z00_5787, BgL_arg2045z00_5788, BgL_arg2046z00_5789); BUNSPEC; } 
return 
((obj_t)BgL_vz00_4496);} 

}



/* &<@anonymous:2038> */
obj_t BGl_z62zc3z04anonymousza32038ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4497, obj_t BgL_oz00_4498)
{
{ /* Llib/ssl.scm 448 */
{ /* Llib/ssl.scm 451 */
void * BgL_arg2039z00_5790;
{ /* Llib/ssl.scm 451 */
void * BgL_arg2040z00_5791;
BgL_arg2040z00_5791 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4498)))->BgL_z42nativez42); 
BgL_arg2039z00_5790 = 
bgl_dh_p(BgL_arg2040z00_5791); } 
return 
void_star_to_obj(BgL_arg2039z00_5790);} } 

}



/* &<@anonymous:2028> */
obj_t BGl_z62zc3z04anonymousza32028ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4499, obj_t BgL_oz00_4500, obj_t BgL_vz00_4501)
{
{ /* Llib/ssl.scm 439 */
{ 
void * BgL_auxz00_7673;
{ /* Llib/ssl.scm 445 */
obj_t BgL_tmpz00_7675;
BgL_tmpz00_7675 = 
((obj_t)BgL_vz00_4501); 
BgL_auxz00_7673 = 
(BIGNUM *)FOREIGN_TO_COBJ(BgL_tmpz00_7675); } 
((((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4500)))->BgL_z52pz52)=((void *)BgL_auxz00_7673),BUNSPEC); } 
{ /* Llib/ssl.scm 446 */
void * BgL_arg2029z00_5792;void * BgL_arg2030z00_5793;void * BgL_arg2031z00_5794;void * BgL_arg2032z00_5795;
BgL_arg2029z00_5792 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4500)))->BgL_z42nativez42); 
BgL_arg2030z00_5793 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4500)))->BgL_z52pz52); 
BgL_arg2031z00_5794 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4500)))->BgL_z52qz52); 
BgL_arg2032z00_5795 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4500)))->BgL_z52gz52); 
bgl_dh_pqg_set(BgL_arg2029z00_5792, BgL_arg2030z00_5793, BgL_arg2031z00_5794, BgL_arg2032z00_5795); BUNSPEC; } 
return 
((obj_t)BgL_vz00_4501);} 

}



/* &<@anonymous:2024> */
obj_t BGl_z62zc3z04anonymousza32024ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4502, obj_t BgL_oz00_4503)
{
{ /* Llib/ssl.scm 439 */
{ /* Llib/ssl.scm 442 */
void * BgL_arg2025z00_5796;
{ /* Llib/ssl.scm 442 */
void * BgL_arg2026z00_5797;
BgL_arg2026z00_5797 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4503)))->BgL_z42nativez42); 
BgL_arg2025z00_5796 = 
bgl_dh_p(BgL_arg2026z00_5797); } 
return 
void_star_to_obj(BgL_arg2025z00_5796);} } 

}



/* &<@anonymous:2019> */
obj_t BGl_z62zc3z04anonymousza32019ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4504, obj_t BgL_oz00_4505, obj_t BgL_vz00_4506)
{
{ /* Llib/ssl.scm 431 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_4505), 
(int)(((long)4)), BgL_vz00_4506);} 

}



/* &<@anonymous:2018> */
obj_t BGl_z62zc3z04anonymousza32018ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4507, obj_t BgL_oz00_4508)
{
{ /* Llib/ssl.scm 431 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_4508), 
(int)(((long)4)));} 

}



/* &<@anonymous:2014> */
obj_t BGl_z62zc3z04anonymousza32014ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4509, obj_t BgL_oz00_4510, obj_t BgL_vz00_4511)
{
{ /* Llib/ssl.scm 431 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_4510), 
(int)(((long)3)), BgL_vz00_4511);} 

}



/* &<@anonymous:2013> */
obj_t BGl_z62zc3z04anonymousza32013ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4512, obj_t BgL_oz00_4513)
{
{ /* Llib/ssl.scm 431 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_4513), 
(int)(((long)3)));} 

}



/* &<@anonymous:2009> */
obj_t BGl_z62zc3z04anonymousza32009ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4514, obj_t BgL_oz00_4515, obj_t BgL_vz00_4516)
{
{ /* Llib/ssl.scm 431 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_4515), 
(int)(((long)2)), BgL_vz00_4516);} 

}



/* &<@anonymous:2008> */
obj_t BGl_z62zc3z04anonymousza32008ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4517, obj_t BgL_oz00_4518)
{
{ /* Llib/ssl.scm 431 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_4518), 
(int)(((long)2)));} 

}



/* &<@anonymous:2004> */
obj_t BGl_z62zc3z04anonymousza32004ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4519, obj_t BgL_oz00_4520, obj_t BgL_vz00_4521)
{
{ /* Llib/ssl.scm 431 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_4520), 
(int)(((long)1)), BgL_vz00_4521);} 

}



/* &<@anonymous:2003> */
obj_t BGl_z62zc3z04anonymousza32003ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4522, obj_t BgL_oz00_4523)
{
{ /* Llib/ssl.scm 431 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_4523), 
(int)(((long)1)));} 

}



/* &<@anonymous:1999> */
obj_t BGl_z62zc3z04anonymousza31999ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4524, obj_t BgL_oz00_4525, obj_t BgL_vz00_4526)
{
{ /* Llib/ssl.scm 431 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_4525), 
(int)(((long)0)), BgL_vz00_4526);} 

}



/* &<@anonymous:1998> */
obj_t BGl_z62zc3z04anonymousza31998ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4527, obj_t BgL_oz00_4528)
{
{ /* Llib/ssl.scm 431 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_4528), 
(int)(((long)0)));} 

}



/* &<@anonymous:1994> */
obj_t BGl_z62zc3z04anonymousza31994ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4529)
{
{ /* Llib/ssl.scm 431 */
return 
void_star_to_obj(((BIGNUM *)0L));} 

}



/* &lambda1993 */
obj_t BGl_z62lambda1993z62zz__ssl_sslz00(obj_t BgL_envz00_4530, obj_t BgL_oz00_4531, obj_t BgL_vz00_4532)
{
{ /* Llib/ssl.scm 431 */
{ /* Llib/ssl.scm 431 */
void * BgL_vz00_5799;
BgL_vz00_5799 = 
FOREIGN_TO_COBJ(BgL_vz00_4532); 
return 
((((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4531)))->BgL_z52privz52)=((void *)BgL_vz00_5799),BUNSPEC);} } 

}



/* &lambda1992 */
obj_t BGl_z62lambda1992z62zz__ssl_sslz00(obj_t BgL_envz00_4533, obj_t BgL_oz00_4534)
{
{ /* Llib/ssl.scm 431 */
return 
void_star_to_obj(
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4534)))->BgL_z52privz52));} 

}



/* &<@anonymous:1987> */
obj_t BGl_z62zc3z04anonymousza31987ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4535)
{
{ /* Llib/ssl.scm 431 */
return 
void_star_to_obj(((BIGNUM *)0L));} 

}



/* &lambda1986 */
obj_t BGl_z62lambda1986z62zz__ssl_sslz00(obj_t BgL_envz00_4536, obj_t BgL_oz00_4537, obj_t BgL_vz00_4538)
{
{ /* Llib/ssl.scm 431 */
{ /* Llib/ssl.scm 431 */
void * BgL_vz00_5802;
BgL_vz00_5802 = 
FOREIGN_TO_COBJ(BgL_vz00_4538); 
return 
((((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4537)))->BgL_z52pubz52)=((void *)BgL_vz00_5802),BUNSPEC);} } 

}



/* &lambda1985 */
obj_t BGl_z62lambda1985z62zz__ssl_sslz00(obj_t BgL_envz00_4539, obj_t BgL_oz00_4540)
{
{ /* Llib/ssl.scm 431 */
return 
void_star_to_obj(
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4540)))->BgL_z52pubz52));} 

}



/* &<@anonymous:1980> */
obj_t BGl_z62zc3z04anonymousza31980ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4541)
{
{ /* Llib/ssl.scm 431 */
return 
void_star_to_obj(((BIGNUM *)0L));} 

}



/* &lambda1979 */
obj_t BGl_z62lambda1979z62zz__ssl_sslz00(obj_t BgL_envz00_4542, obj_t BgL_oz00_4543, obj_t BgL_vz00_4544)
{
{ /* Llib/ssl.scm 431 */
{ /* Llib/ssl.scm 431 */
void * BgL_vz00_5805;
BgL_vz00_5805 = 
FOREIGN_TO_COBJ(BgL_vz00_4544); 
return 
((((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4543)))->BgL_z52gz52)=((void *)BgL_vz00_5805),BUNSPEC);} } 

}



/* &lambda1978 */
obj_t BGl_z62lambda1978z62zz__ssl_sslz00(obj_t BgL_envz00_4545, obj_t BgL_oz00_4546)
{
{ /* Llib/ssl.scm 431 */
return 
void_star_to_obj(
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4546)))->BgL_z52gz52));} 

}



/* &<@anonymous:1973> */
obj_t BGl_z62zc3z04anonymousza31973ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4547)
{
{ /* Llib/ssl.scm 431 */
return 
void_star_to_obj(((BIGNUM *)0L));} 

}



/* &lambda1972 */
obj_t BGl_z62lambda1972z62zz__ssl_sslz00(obj_t BgL_envz00_4548, obj_t BgL_oz00_4549, obj_t BgL_vz00_4550)
{
{ /* Llib/ssl.scm 431 */
{ /* Llib/ssl.scm 431 */
void * BgL_vz00_5808;
BgL_vz00_5808 = 
FOREIGN_TO_COBJ(BgL_vz00_4550); 
return 
((((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4549)))->BgL_z52qz52)=((void *)BgL_vz00_5808),BUNSPEC);} } 

}



/* &lambda1971 */
obj_t BGl_z62lambda1971z62zz__ssl_sslz00(obj_t BgL_envz00_4551, obj_t BgL_oz00_4552)
{
{ /* Llib/ssl.scm 431 */
return 
void_star_to_obj(
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4552)))->BgL_z52qz52));} 

}



/* &<@anonymous:1966> */
obj_t BGl_z62zc3z04anonymousza31966ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4553)
{
{ /* Llib/ssl.scm 431 */
return 
void_star_to_obj(((BIGNUM *)0L));} 

}



/* &lambda1965 */
obj_t BGl_z62lambda1965z62zz__ssl_sslz00(obj_t BgL_envz00_4554, obj_t BgL_oz00_4555, obj_t BgL_vz00_4556)
{
{ /* Llib/ssl.scm 431 */
{ /* Llib/ssl.scm 431 */
void * BgL_vz00_5811;
BgL_vz00_5811 = 
FOREIGN_TO_COBJ(BgL_vz00_4556); 
return 
((((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4555)))->BgL_z52pz52)=((void *)BgL_vz00_5811),BUNSPEC);} } 

}



/* &lambda1964 */
obj_t BGl_z62lambda1964z62zz__ssl_sslz00(obj_t BgL_envz00_4557, obj_t BgL_oz00_4558)
{
{ /* Llib/ssl.scm 431 */
return 
void_star_to_obj(
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4558)))->BgL_z52pz52));} 

}



/* &<@anonymous:1959> */
obj_t BGl_z62zc3z04anonymousza31959ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4559)
{
{ /* Llib/ssl.scm 431 */
return 
void_star_to_obj(0L);} 

}



/* &lambda1958 */
obj_t BGl_z62lambda1958z62zz__ssl_sslz00(obj_t BgL_envz00_4560, obj_t BgL_oz00_4561, obj_t BgL_vz00_4562)
{
{ /* Llib/ssl.scm 431 */
{ /* Llib/ssl.scm 431 */
void * BgL_vz00_5814;
BgL_vz00_5814 = 
FOREIGN_TO_COBJ(BgL_vz00_4562); 
return 
((((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4561)))->BgL_z42nativez42)=((void *)BgL_vz00_5814),BUNSPEC);} } 

}



/* &lambda1957 */
obj_t BGl_z62lambda1957z62zz__ssl_sslz00(obj_t BgL_envz00_4563, obj_t BgL_oz00_4564)
{
{ /* Llib/ssl.scm 431 */
return 
void_star_to_obj(
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4564)))->BgL_z42nativez42));} 

}



/* &<@anonymous:1828> */
obj_t BGl_z62zc3z04anonymousza31828ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4565, obj_t BgL_new1081z00_4566)
{
{ /* Llib/ssl.scm 411 */
{ 
BgL_sslzd2connectionzd2_bglt BgL_auxz00_7765;
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_new1081z00_4566)))->BgL_z42nativez42)=((void *)
0L),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_new1081z00_4566)))->BgL_z42biozd2readz90)=((void *)
0L),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_new1081z00_4566)))->BgL_z42biozd2writez90)=((void *)
0L),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_new1081z00_4566)))->BgL_z42nextzd2sessionz90)=((void *)
0L),BUNSPEC); 
{ 
BgL_securezd2contextzd2_bglt BgL_auxz00_7778;
{ /* Llib/ssl.scm 411 */
obj_t BgL_classz00_5817;
BgL_classz00_5817 = BGl_securezd2contextzd2zz__ssl_sslz00; 
{ /* Llib/ssl.scm 411 */
obj_t BgL__ortest_1107z00_5818;
BgL__ortest_1107z00_5818 = 
BGL_CLASS_NIL(BgL_classz00_5817); 
if(
CBOOL(BgL__ortest_1107z00_5818))
{ /* Llib/ssl.scm 411 */
BgL_auxz00_7778 = 
((BgL_securezd2contextzd2_bglt)BgL__ortest_1107z00_5818)
; }  else 
{ /* Llib/ssl.scm 411 */
BgL_auxz00_7778 = 
((BgL_securezd2contextzd2_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_5817))
; } } } 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_new1081z00_4566)))->BgL_ctxz00)=((BgL_securezd2contextzd2_bglt)BgL_auxz00_7778),BUNSPEC); } 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_new1081z00_4566)))->BgL_isserverz00)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_new1081z00_4566)))->BgL_requestzd2certzd2)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_new1081z00_4566)))->BgL_serverzd2namezd2)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_new1081z00_4566)))->BgL_rejectzd2unauthoriza7edz75)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_new1081z00_4566)))->BgL_infozd2callbackzd2)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_new1081z00_4566)))->BgL_snizd2contextzd2callbackz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_new1081z00_4566)))->BgL_newsessionzd2callbackzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_new1081z00_4566)))->BgL_selectedzd2npnzd2protosz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_new1081z00_4566)))->BgL_npnzd2protoszd2)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_new1081z00_4566)))->BgL_errz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_new1081z00_4566)))->BgL_receivedzd2shutdownzd2)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_new1081z00_4566)))->BgL_sentzd2shutdownzd2)=((bool_t)((bool_t)0)),BUNSPEC); 
BgL_auxz00_7765 = 
((BgL_sslzd2connectionzd2_bglt)BgL_new1081z00_4566); 
return 
((obj_t)BgL_auxz00_7765);} } 

}



/* &lambda1826 */
BgL_sslzd2connectionzd2_bglt BGl_z62lambda1826z62zz__ssl_sslz00(obj_t BgL_envz00_4567)
{
{ /* Llib/ssl.scm 411 */
{ /* Llib/ssl.scm 411 */
BgL_sslzd2connectionzd2_bglt BgL_new1080z00_5819;
BgL_new1080z00_5819 = 
((BgL_sslzd2connectionzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_sslzd2connectionzd2_bgl) ))); 
{ /* Llib/ssl.scm 411 */
long BgL_arg1827z00_5820;
{ /* Llib/ssl.scm 411 */
long BgL_res2358z00_5821;
BgL_res2358z00_5821 = 
BGL_CLASS_INDEX(BGl_sslzd2connectionzd2zz__ssl_sslz00); 
BgL_arg1827z00_5820 = BgL_res2358z00_5821; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1080z00_5819), BgL_arg1827z00_5820); } 
return BgL_new1080z00_5819;} } 

}



/* &lambda1823 */
BgL_sslzd2connectionzd2_bglt BGl_z62lambda1823z62zz__ssl_sslz00(obj_t BgL_envz00_4568, obj_t BgL_z42native1063z42_4569, obj_t BgL_z42biozd2read1064z90_4570, obj_t BgL_z42biozd2write1065z90_4571, obj_t BgL_z42nextzd2session1066z90_4572, obj_t BgL_ctx1067z00_4573, obj_t BgL_isserver1068z00_4574, obj_t BgL_requestzd2cert1069zd2_4575, obj_t BgL_serverzd2name1070zd2_4576, obj_t BgL_rejectzd2unauthoriza7ed1071z75_4577, obj_t BgL_infozd2callback1072zd2_4578, obj_t BgL_snizd2contextzd2callback1073z00_4579, obj_t BgL_newsessionzd2callback1074zd2_4580, obj_t BgL_selectedzd2npnzd2protos1075z00_4581, obj_t BgL_npnzd2protos1076zd2_4582, obj_t BgL_err1077z00_4583, obj_t BgL_receivedzd2shutdown1078zd2_4584, obj_t BgL_sentzd2shutdown1079zd2_4585)
{
{ /* Llib/ssl.scm 411 */
{ /* Llib/ssl.scm 411 */
void * BgL_z42native1063z42_5822;void * BgL_z42biozd2read1064z90_5823;void * BgL_z42biozd2write1065z90_5824;void * BgL_z42nextzd2session1066z90_5825;bool_t BgL_isserver1068z00_5827;bool_t BgL_requestzd2cert1069zd2_5828;bool_t BgL_rejectzd2unauthoriza7ed1071z75_5829;bool_t BgL_receivedzd2shutdown1078zd2_5831;bool_t BgL_sentzd2shutdown1079zd2_5832;
BgL_z42native1063z42_5822 = 
FOREIGN_TO_COBJ(BgL_z42native1063z42_4569); 
BgL_z42biozd2read1064z90_5823 = 
FOREIGN_TO_COBJ(BgL_z42biozd2read1064z90_4570); 
BgL_z42biozd2write1065z90_5824 = 
FOREIGN_TO_COBJ(BgL_z42biozd2write1065z90_4571); 
BgL_z42nextzd2session1066z90_5825 = 
FOREIGN_TO_COBJ(BgL_z42nextzd2session1066z90_4572); 
BgL_isserver1068z00_5827 = 
CBOOL(BgL_isserver1068z00_4574); 
BgL_requestzd2cert1069zd2_5828 = 
CBOOL(BgL_requestzd2cert1069zd2_4575); 
BgL_rejectzd2unauthoriza7ed1071z75_5829 = 
CBOOL(BgL_rejectzd2unauthoriza7ed1071z75_4577); 
BgL_receivedzd2shutdown1078zd2_5831 = 
CBOOL(BgL_receivedzd2shutdown1078zd2_4584); 
BgL_sentzd2shutdown1079zd2_5832 = 
CBOOL(BgL_sentzd2shutdown1079zd2_4585); 
{ /* Llib/ssl.scm 411 */
BgL_sslzd2connectionzd2_bglt BgL_new1156z00_5833;
{ /* Llib/ssl.scm 411 */
BgL_sslzd2connectionzd2_bglt BgL_new1155z00_5834;
BgL_new1155z00_5834 = 
((BgL_sslzd2connectionzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_sslzd2connectionzd2_bgl) ))); 
{ /* Llib/ssl.scm 411 */
long BgL_arg1825z00_5835;
{ /* Llib/ssl.scm 411 */
long BgL_res2357z00_5836;
BgL_res2357z00_5836 = 
BGL_CLASS_INDEX(BGl_sslzd2connectionzd2zz__ssl_sslz00); 
BgL_arg1825z00_5835 = BgL_res2357z00_5836; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1155z00_5834), BgL_arg1825z00_5835); } 
BgL_new1156z00_5833 = BgL_new1155z00_5834; } 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(BgL_new1156z00_5833))->BgL_z42nativez42)=((void *)BgL_z42native1063z42_5822),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(BgL_new1156z00_5833))->BgL_z42biozd2readz90)=((void *)BgL_z42biozd2read1064z90_5823),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(BgL_new1156z00_5833))->BgL_z42biozd2writez90)=((void *)BgL_z42biozd2write1065z90_5824),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(BgL_new1156z00_5833))->BgL_z42nextzd2sessionz90)=((void *)BgL_z42nextzd2session1066z90_5825),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(BgL_new1156z00_5833))->BgL_ctxz00)=((BgL_securezd2contextzd2_bglt)
((BgL_securezd2contextzd2_bglt)BgL_ctx1067z00_4573)),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(BgL_new1156z00_5833))->BgL_isserverz00)=((bool_t)BgL_isserver1068z00_5827),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(BgL_new1156z00_5833))->BgL_requestzd2certzd2)=((bool_t)BgL_requestzd2cert1069zd2_5828),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(BgL_new1156z00_5833))->BgL_serverzd2namezd2)=((obj_t)BgL_serverzd2name1070zd2_4576),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(BgL_new1156z00_5833))->BgL_rejectzd2unauthoriza7edz75)=((bool_t)BgL_rejectzd2unauthoriza7ed1071z75_5829),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(BgL_new1156z00_5833))->BgL_infozd2callbackzd2)=((obj_t)BgL_infozd2callback1072zd2_4578),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(BgL_new1156z00_5833))->BgL_snizd2contextzd2callbackz00)=((obj_t)BgL_snizd2contextzd2callback1073z00_4579),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(BgL_new1156z00_5833))->BgL_newsessionzd2callbackzd2)=((obj_t)
((obj_t)BgL_newsessionzd2callback1074zd2_4580)),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(BgL_new1156z00_5833))->BgL_selectedzd2npnzd2protosz00)=((obj_t)BgL_selectedzd2npnzd2protos1075z00_4581),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(BgL_new1156z00_5833))->BgL_npnzd2protoszd2)=((obj_t)BgL_npnzd2protos1076zd2_4582),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(BgL_new1156z00_5833))->BgL_errz00)=((obj_t)BgL_err1077z00_4583),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(BgL_new1156z00_5833))->BgL_receivedzd2shutdownzd2)=((bool_t)BgL_receivedzd2shutdown1078zd2_5831),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(BgL_new1156z00_5833))->BgL_sentzd2shutdownzd2)=((bool_t)BgL_sentzd2shutdown1079zd2_5832),BUNSPEC); 
{ /* Llib/ssl.scm 411 */
obj_t BgL_fun1824z00_5837;
BgL_fun1824z00_5837 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_sslzd2connectionzd2zz__ssl_sslz00); 
PROCEDURE_ENTRY(BgL_fun1824z00_5837)(BgL_fun1824z00_5837, 
((obj_t)BgL_new1156z00_5833), BEOA); } 
return BgL_new1156z00_5833;} } } 

}



/* &<@anonymous:1941> */
obj_t BGl_z62zc3z04anonymousza31941ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4586)
{
{ /* Llib/ssl.scm 411 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda1940 */
obj_t BGl_z62lambda1940z62zz__ssl_sslz00(obj_t BgL_envz00_4587, obj_t BgL_oz00_4588, obj_t BgL_vz00_4589)
{
{ /* Llib/ssl.scm 411 */
{ /* Llib/ssl.scm 411 */
bool_t BgL_vz00_5839;
BgL_vz00_5839 = 
CBOOL(BgL_vz00_4589); 
return 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_4588)))->BgL_sentzd2shutdownzd2)=((bool_t)BgL_vz00_5839),BUNSPEC);} } 

}



/* &lambda1939 */
obj_t BGl_z62lambda1939z62zz__ssl_sslz00(obj_t BgL_envz00_4590, obj_t BgL_oz00_4591)
{
{ /* Llib/ssl.scm 411 */
return 
BBOOL(
(((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_4591)))->BgL_sentzd2shutdownzd2));} 

}



/* &<@anonymous:1934> */
obj_t BGl_z62zc3z04anonymousza31934ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4592)
{
{ /* Llib/ssl.scm 411 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda1933 */
obj_t BGl_z62lambda1933z62zz__ssl_sslz00(obj_t BgL_envz00_4593, obj_t BgL_oz00_4594, obj_t BgL_vz00_4595)
{
{ /* Llib/ssl.scm 411 */
{ /* Llib/ssl.scm 411 */
bool_t BgL_vz00_5842;
BgL_vz00_5842 = 
CBOOL(BgL_vz00_4595); 
return 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_4594)))->BgL_receivedzd2shutdownzd2)=((bool_t)BgL_vz00_5842),BUNSPEC);} } 

}



/* &lambda1932 */
obj_t BGl_z62lambda1932z62zz__ssl_sslz00(obj_t BgL_envz00_4596, obj_t BgL_oz00_4597)
{
{ /* Llib/ssl.scm 411 */
return 
BBOOL(
(((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_4597)))->BgL_receivedzd2shutdownzd2));} 

}



/* &<@anonymous:1927> */
obj_t BGl_z62zc3z04anonymousza31927ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4598)
{
{ /* Llib/ssl.scm 411 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda1926 */
obj_t BGl_z62lambda1926z62zz__ssl_sslz00(obj_t BgL_envz00_4599, obj_t BgL_oz00_4600, obj_t BgL_vz00_4601)
{
{ /* Llib/ssl.scm 411 */
return 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_4600)))->BgL_errz00)=((obj_t)BgL_vz00_4601),BUNSPEC);} 

}



/* &lambda1925 */
obj_t BGl_z62lambda1925z62zz__ssl_sslz00(obj_t BgL_envz00_4602, obj_t BgL_oz00_4603)
{
{ /* Llib/ssl.scm 411 */
return 
(((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_4603)))->BgL_errz00);} 

}



/* &<@anonymous:1920> */
obj_t BGl_z62zc3z04anonymousza31920ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4604)
{
{ /* Llib/ssl.scm 411 */
return BUNSPEC;} 

}



/* &lambda1919 */
obj_t BGl_z62lambda1919z62zz__ssl_sslz00(obj_t BgL_envz00_4605, obj_t BgL_oz00_4606, obj_t BgL_vz00_4607)
{
{ /* Llib/ssl.scm 411 */
return 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_4606)))->BgL_npnzd2protoszd2)=((obj_t)BgL_vz00_4607),BUNSPEC);} 

}



/* &lambda1918 */
obj_t BGl_z62lambda1918z62zz__ssl_sslz00(obj_t BgL_envz00_4608, obj_t BgL_oz00_4609)
{
{ /* Llib/ssl.scm 411 */
return 
(((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_4609)))->BgL_npnzd2protoszd2);} 

}



/* &<@anonymous:1913> */
obj_t BGl_z62zc3z04anonymousza31913ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4610)
{
{ /* Llib/ssl.scm 411 */
return BUNSPEC;} 

}



/* &lambda1912 */
obj_t BGl_z62lambda1912z62zz__ssl_sslz00(obj_t BgL_envz00_4611, obj_t BgL_oz00_4612, obj_t BgL_vz00_4613)
{
{ /* Llib/ssl.scm 411 */
return 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_4612)))->BgL_selectedzd2npnzd2protosz00)=((obj_t)BgL_vz00_4613),BUNSPEC);} 

}



/* &lambda1911 */
obj_t BGl_z62lambda1911z62zz__ssl_sslz00(obj_t BgL_envz00_4614, obj_t BgL_oz00_4615)
{
{ /* Llib/ssl.scm 411 */
return 
(((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_4615)))->BgL_selectedzd2npnzd2protosz00);} 

}



/* &<@anonymous:1906> */
obj_t BGl_z62zc3z04anonymousza31906ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4616)
{
{ /* Llib/ssl.scm 411 */
return BGl_listzd2envzd2zz__r4_pairs_and_lists_6_3z00;} 

}



/* &lambda1905 */
obj_t BGl_z62lambda1905z62zz__ssl_sslz00(obj_t BgL_envz00_4617, obj_t BgL_oz00_4618, obj_t BgL_vz00_4619)
{
{ /* Llib/ssl.scm 411 */
return 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_4618)))->BgL_newsessionzd2callbackzd2)=((obj_t)
((obj_t)BgL_vz00_4619)),BUNSPEC);} 

}



/* &lambda1904 */
obj_t BGl_z62lambda1904z62zz__ssl_sslz00(obj_t BgL_envz00_4620, obj_t BgL_oz00_4621)
{
{ /* Llib/ssl.scm 411 */
return 
(((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_4621)))->BgL_newsessionzd2callbackzd2);} 

}



/* &<@anonymous:1899> */
obj_t BGl_z62zc3z04anonymousza31899ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4622)
{
{ /* Llib/ssl.scm 411 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda1898 */
obj_t BGl_z62lambda1898z62zz__ssl_sslz00(obj_t BgL_envz00_4623, obj_t BgL_oz00_4624, obj_t BgL_vz00_4625)
{
{ /* Llib/ssl.scm 411 */
return 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_4624)))->BgL_snizd2contextzd2callbackz00)=((obj_t)BgL_vz00_4625),BUNSPEC);} 

}



/* &lambda1897 */
obj_t BGl_z62lambda1897z62zz__ssl_sslz00(obj_t BgL_envz00_4626, obj_t BgL_oz00_4627)
{
{ /* Llib/ssl.scm 411 */
return 
(((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_4627)))->BgL_snizd2contextzd2callbackz00);} 

}



/* &<@anonymous:1892> */
obj_t BGl_z62zc3z04anonymousza31892ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4628)
{
{ /* Llib/ssl.scm 411 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda1891 */
obj_t BGl_z62lambda1891z62zz__ssl_sslz00(obj_t BgL_envz00_4629, obj_t BgL_oz00_4630, obj_t BgL_vz00_4631)
{
{ /* Llib/ssl.scm 411 */
return 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_4630)))->BgL_infozd2callbackzd2)=((obj_t)BgL_vz00_4631),BUNSPEC);} 

}



/* &lambda1890 */
obj_t BGl_z62lambda1890z62zz__ssl_sslz00(obj_t BgL_envz00_4632, obj_t BgL_oz00_4633)
{
{ /* Llib/ssl.scm 411 */
return 
(((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_4633)))->BgL_infozd2callbackzd2);} 

}



/* &lambda1885 */
obj_t BGl_z62lambda1885z62zz__ssl_sslz00(obj_t BgL_envz00_4634, obj_t BgL_oz00_4635, obj_t BgL_vz00_4636)
{
{ /* Llib/ssl.scm 411 */
{ /* Llib/ssl.scm 411 */
bool_t BgL_vz00_5858;
BgL_vz00_5858 = 
CBOOL(BgL_vz00_4636); 
return 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_4635)))->BgL_rejectzd2unauthoriza7edz75)=((bool_t)BgL_vz00_5858),BUNSPEC);} } 

}



/* &lambda1884 */
obj_t BGl_z62lambda1884z62zz__ssl_sslz00(obj_t BgL_envz00_4637, obj_t BgL_oz00_4638)
{
{ /* Llib/ssl.scm 411 */
return 
BBOOL(
(((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_4638)))->BgL_rejectzd2unauthoriza7edz75));} 

}



/* &<@anonymous:1880> */
obj_t BGl_z62zc3z04anonymousza31880ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4639)
{
{ /* Llib/ssl.scm 411 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda1879 */
obj_t BGl_z62lambda1879z62zz__ssl_sslz00(obj_t BgL_envz00_4640, obj_t BgL_oz00_4641, obj_t BgL_vz00_4642)
{
{ /* Llib/ssl.scm 411 */
return 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_4641)))->BgL_serverzd2namezd2)=((obj_t)BgL_vz00_4642),BUNSPEC);} 

}



/* &lambda1878 */
obj_t BGl_z62lambda1878z62zz__ssl_sslz00(obj_t BgL_envz00_4643, obj_t BgL_oz00_4644)
{
{ /* Llib/ssl.scm 411 */
return 
(((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_4644)))->BgL_serverzd2namezd2);} 

}



/* &<@anonymous:1873> */
obj_t BGl_z62zc3z04anonymousza31873ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4645)
{
{ /* Llib/ssl.scm 411 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda1872 */
obj_t BGl_z62lambda1872z62zz__ssl_sslz00(obj_t BgL_envz00_4646, obj_t BgL_oz00_4647, obj_t BgL_vz00_4648)
{
{ /* Llib/ssl.scm 411 */
{ /* Llib/ssl.scm 411 */
bool_t BgL_vz00_5863;
BgL_vz00_5863 = 
CBOOL(BgL_vz00_4648); 
return 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_4647)))->BgL_requestzd2certzd2)=((bool_t)BgL_vz00_5863),BUNSPEC);} } 

}



/* &lambda1871 */
obj_t BGl_z62lambda1871z62zz__ssl_sslz00(obj_t BgL_envz00_4649, obj_t BgL_oz00_4650)
{
{ /* Llib/ssl.scm 411 */
return 
BBOOL(
(((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_4650)))->BgL_requestzd2certzd2));} 

}



/* &lambda1866 */
obj_t BGl_z62lambda1866z62zz__ssl_sslz00(obj_t BgL_envz00_4651, obj_t BgL_oz00_4652, obj_t BgL_vz00_4653)
{
{ /* Llib/ssl.scm 411 */
{ /* Llib/ssl.scm 411 */
bool_t BgL_vz00_5866;
BgL_vz00_5866 = 
CBOOL(BgL_vz00_4653); 
return 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_4652)))->BgL_isserverz00)=((bool_t)BgL_vz00_5866),BUNSPEC);} } 

}



/* &lambda1865 */
obj_t BGl_z62lambda1865z62zz__ssl_sslz00(obj_t BgL_envz00_4654, obj_t BgL_oz00_4655)
{
{ /* Llib/ssl.scm 411 */
return 
BBOOL(
(((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_4655)))->BgL_isserverz00));} 

}



/* &lambda1861 */
obj_t BGl_z62lambda1861z62zz__ssl_sslz00(obj_t BgL_envz00_4656, obj_t BgL_oz00_4657, obj_t BgL_vz00_4658)
{
{ /* Llib/ssl.scm 411 */
return 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_4657)))->BgL_ctxz00)=((BgL_securezd2contextzd2_bglt)
((BgL_securezd2contextzd2_bglt)BgL_vz00_4658)),BUNSPEC);} 

}



/* &lambda1860 */
BgL_securezd2contextzd2_bglt BGl_z62lambda1860z62zz__ssl_sslz00(obj_t BgL_envz00_4659, obj_t BgL_oz00_4660)
{
{ /* Llib/ssl.scm 411 */
return 
(((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_4660)))->BgL_ctxz00);} 

}



/* &<@anonymous:1856> */
obj_t BGl_z62zc3z04anonymousza31856ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4661)
{
{ /* Llib/ssl.scm 411 */
return 
void_star_to_obj(0L);} 

}



/* &lambda1855 */
obj_t BGl_z62lambda1855z62zz__ssl_sslz00(obj_t BgL_envz00_4662, obj_t BgL_oz00_4663, obj_t BgL_vz00_4664)
{
{ /* Llib/ssl.scm 411 */
{ /* Llib/ssl.scm 411 */
void * BgL_vz00_5872;
BgL_vz00_5872 = 
FOREIGN_TO_COBJ(BgL_vz00_4664); 
return 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_4663)))->BgL_z42nextzd2sessionz90)=((void *)BgL_vz00_5872),BUNSPEC);} } 

}



/* &lambda1854 */
obj_t BGl_z62lambda1854z62zz__ssl_sslz00(obj_t BgL_envz00_4665, obj_t BgL_oz00_4666)
{
{ /* Llib/ssl.scm 411 */
return 
void_star_to_obj(
(((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_4666)))->BgL_z42nextzd2sessionz90));} 

}



/* &<@anonymous:1849> */
obj_t BGl_z62zc3z04anonymousza31849ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4667)
{
{ /* Llib/ssl.scm 411 */
return 
void_star_to_obj(0L);} 

}



/* &lambda1848 */
obj_t BGl_z62lambda1848z62zz__ssl_sslz00(obj_t BgL_envz00_4668, obj_t BgL_oz00_4669, obj_t BgL_vz00_4670)
{
{ /* Llib/ssl.scm 411 */
{ /* Llib/ssl.scm 411 */
void * BgL_vz00_5875;
BgL_vz00_5875 = 
FOREIGN_TO_COBJ(BgL_vz00_4670); 
return 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_4669)))->BgL_z42biozd2writez90)=((void *)BgL_vz00_5875),BUNSPEC);} } 

}



/* &lambda1847 */
obj_t BGl_z62lambda1847z62zz__ssl_sslz00(obj_t BgL_envz00_4671, obj_t BgL_oz00_4672)
{
{ /* Llib/ssl.scm 411 */
return 
void_star_to_obj(
(((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_4672)))->BgL_z42biozd2writez90));} 

}



/* &<@anonymous:1842> */
obj_t BGl_z62zc3z04anonymousza31842ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4673)
{
{ /* Llib/ssl.scm 411 */
return 
void_star_to_obj(0L);} 

}



/* &lambda1841 */
obj_t BGl_z62lambda1841z62zz__ssl_sslz00(obj_t BgL_envz00_4674, obj_t BgL_oz00_4675, obj_t BgL_vz00_4676)
{
{ /* Llib/ssl.scm 411 */
{ /* Llib/ssl.scm 411 */
void * BgL_vz00_5878;
BgL_vz00_5878 = 
FOREIGN_TO_COBJ(BgL_vz00_4676); 
return 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_4675)))->BgL_z42biozd2readz90)=((void *)BgL_vz00_5878),BUNSPEC);} } 

}



/* &lambda1840 */
obj_t BGl_z62lambda1840z62zz__ssl_sslz00(obj_t BgL_envz00_4677, obj_t BgL_oz00_4678)
{
{ /* Llib/ssl.scm 411 */
return 
void_star_to_obj(
(((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_4678)))->BgL_z42biozd2readz90));} 

}



/* &<@anonymous:1835> */
obj_t BGl_z62zc3z04anonymousza31835ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4679)
{
{ /* Llib/ssl.scm 411 */
return 
void_star_to_obj(0L);} 

}



/* &lambda1834 */
obj_t BGl_z62lambda1834z62zz__ssl_sslz00(obj_t BgL_envz00_4680, obj_t BgL_oz00_4681, obj_t BgL_vz00_4682)
{
{ /* Llib/ssl.scm 411 */
{ /* Llib/ssl.scm 411 */
void * BgL_vz00_5881;
BgL_vz00_5881 = 
FOREIGN_TO_COBJ(BgL_vz00_4682); 
return 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_4681)))->BgL_z42nativez42)=((void *)BgL_vz00_5881),BUNSPEC);} } 

}



/* &lambda1833 */
obj_t BGl_z62lambda1833z62zz__ssl_sslz00(obj_t BgL_envz00_4683, obj_t BgL_oz00_4684)
{
{ /* Llib/ssl.scm 411 */
return 
void_star_to_obj(
(((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_4684)))->BgL_z42nativez42));} 

}



/* &<@anonymous:1796> */
obj_t BGl_z62zc3z04anonymousza31796ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4685, obj_t BgL_new1061z00_4686)
{
{ /* Llib/ssl.scm 405 */
{ 
BgL_securezd2contextzd2_bglt BgL_auxz00_7954;
((((BgL_securezd2contextzd2_bglt)COBJECT(
((BgL_securezd2contextzd2_bglt)BgL_new1061z00_4686)))->BgL_z42nativez42)=((void *)
0L),BUNSPEC); 
((((BgL_securezd2contextzd2_bglt)COBJECT(
((BgL_securezd2contextzd2_bglt)BgL_new1061z00_4686)))->BgL_z42cazd2storez90)=((void *)
0L),BUNSPEC); 
((((BgL_securezd2contextzd2_bglt)COBJECT(
((BgL_securezd2contextzd2_bglt)BgL_new1061z00_4686)))->BgL_methodz00)=((obj_t)BGl_string3563z00zz__ssl_sslz00),BUNSPEC); 
BgL_auxz00_7954 = 
((BgL_securezd2contextzd2_bglt)BgL_new1061z00_4686); 
return 
((obj_t)BgL_auxz00_7954);} } 

}



/* &lambda1794 */
BgL_securezd2contextzd2_bglt BGl_z62lambda1794z62zz__ssl_sslz00(obj_t BgL_envz00_4687)
{
{ /* Llib/ssl.scm 405 */
{ /* Llib/ssl.scm 405 */
BgL_securezd2contextzd2_bglt BgL_new1059z00_5884;
BgL_new1059z00_5884 = 
((BgL_securezd2contextzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_securezd2contextzd2_bgl) ))); 
{ /* Llib/ssl.scm 405 */
long BgL_arg1795z00_5885;
{ /* Llib/ssl.scm 405 */
long BgL_res2356z00_5886;
BgL_res2356z00_5886 = 
BGL_CLASS_INDEX(BGl_securezd2contextzd2zz__ssl_sslz00); 
BgL_arg1795z00_5885 = BgL_res2356z00_5886; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1059z00_5884), BgL_arg1795z00_5885); } 
return BgL_new1059z00_5884;} } 

}



/* &lambda1791 */
BgL_securezd2contextzd2_bglt BGl_z62lambda1791z62zz__ssl_sslz00(obj_t BgL_envz00_4688, obj_t BgL_z42native1056z42_4689, obj_t BgL_z42cazd2store1057z90_4690, obj_t BgL_method1058z00_4691)
{
{ /* Llib/ssl.scm 405 */
{ /* Llib/ssl.scm 405 */
void * BgL_z42native1056z42_5887;void * BgL_z42cazd2store1057z90_5888;
BgL_z42native1056z42_5887 = 
FOREIGN_TO_COBJ(BgL_z42native1056z42_4689); 
BgL_z42cazd2store1057z90_5888 = 
FOREIGN_TO_COBJ(BgL_z42cazd2store1057z90_4690); 
{ /* Llib/ssl.scm 405 */
BgL_securezd2contextzd2_bglt BgL_new1154z00_5890;
{ /* Llib/ssl.scm 405 */
BgL_securezd2contextzd2_bglt BgL_new1153z00_5891;
BgL_new1153z00_5891 = 
((BgL_securezd2contextzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_securezd2contextzd2_bgl) ))); 
{ /* Llib/ssl.scm 405 */
long BgL_arg1793z00_5892;
{ /* Llib/ssl.scm 405 */
long BgL_res2355z00_5893;
BgL_res2355z00_5893 = 
BGL_CLASS_INDEX(BGl_securezd2contextzd2zz__ssl_sslz00); 
BgL_arg1793z00_5892 = BgL_res2355z00_5893; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1153z00_5891), BgL_arg1793z00_5892); } 
BgL_new1154z00_5890 = BgL_new1153z00_5891; } 
((((BgL_securezd2contextzd2_bglt)COBJECT(BgL_new1154z00_5890))->BgL_z42nativez42)=((void *)BgL_z42native1056z42_5887),BUNSPEC); 
((((BgL_securezd2contextzd2_bglt)COBJECT(BgL_new1154z00_5890))->BgL_z42cazd2storez90)=((void *)BgL_z42cazd2store1057z90_5888),BUNSPEC); 
((((BgL_securezd2contextzd2_bglt)COBJECT(BgL_new1154z00_5890))->BgL_methodz00)=((obj_t)
((obj_t)BgL_method1058z00_4691)),BUNSPEC); 
{ /* Llib/ssl.scm 405 */
obj_t BgL_fun1792z00_5894;
BgL_fun1792z00_5894 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_securezd2contextzd2zz__ssl_sslz00); 
PROCEDURE_ENTRY(BgL_fun1792z00_5894)(BgL_fun1792z00_5894, 
((obj_t)BgL_new1154z00_5890), BEOA); } 
return BgL_new1154z00_5890;} } } 

}



/* &<@anonymous:1817> */
obj_t BGl_z62zc3z04anonymousza31817ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4692)
{
{ /* Llib/ssl.scm 405 */
return BGl_string3564z00zz__ssl_sslz00;} 

}



/* &lambda1816 */
obj_t BGl_z62lambda1816z62zz__ssl_sslz00(obj_t BgL_envz00_4693, obj_t BgL_oz00_4694, obj_t BgL_vz00_4695)
{
{ /* Llib/ssl.scm 405 */
return 
((((BgL_securezd2contextzd2_bglt)COBJECT(
((BgL_securezd2contextzd2_bglt)BgL_oz00_4694)))->BgL_methodz00)=((obj_t)
((obj_t)BgL_vz00_4695)),BUNSPEC);} 

}



/* &lambda1815 */
obj_t BGl_z62lambda1815z62zz__ssl_sslz00(obj_t BgL_envz00_4696, obj_t BgL_oz00_4697)
{
{ /* Llib/ssl.scm 405 */
return 
(((BgL_securezd2contextzd2_bglt)COBJECT(
((BgL_securezd2contextzd2_bglt)BgL_oz00_4697)))->BgL_methodz00);} 

}



/* &<@anonymous:1810> */
obj_t BGl_z62zc3z04anonymousza31810ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4698)
{
{ /* Llib/ssl.scm 405 */
return 
void_star_to_obj(0L);} 

}



/* &lambda1809 */
obj_t BGl_z62lambda1809z62zz__ssl_sslz00(obj_t BgL_envz00_4699, obj_t BgL_oz00_4700, obj_t BgL_vz00_4701)
{
{ /* Llib/ssl.scm 405 */
{ /* Llib/ssl.scm 405 */
void * BgL_vz00_5899;
BgL_vz00_5899 = 
FOREIGN_TO_COBJ(BgL_vz00_4701); 
return 
((((BgL_securezd2contextzd2_bglt)COBJECT(
((BgL_securezd2contextzd2_bglt)BgL_oz00_4700)))->BgL_z42cazd2storez90)=((void *)BgL_vz00_5899),BUNSPEC);} } 

}



/* &lambda1808 */
obj_t BGl_z62lambda1808z62zz__ssl_sslz00(obj_t BgL_envz00_4702, obj_t BgL_oz00_4703)
{
{ /* Llib/ssl.scm 405 */
return 
void_star_to_obj(
(((BgL_securezd2contextzd2_bglt)COBJECT(
((BgL_securezd2contextzd2_bglt)BgL_oz00_4703)))->BgL_z42cazd2storez90));} 

}



/* &<@anonymous:1803> */
obj_t BGl_z62zc3z04anonymousza31803ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4704)
{
{ /* Llib/ssl.scm 405 */
return 
void_star_to_obj(0L);} 

}



/* &lambda1802 */
obj_t BGl_z62lambda1802z62zz__ssl_sslz00(obj_t BgL_envz00_4705, obj_t BgL_oz00_4706, obj_t BgL_vz00_4707)
{
{ /* Llib/ssl.scm 405 */
{ /* Llib/ssl.scm 405 */
void * BgL_vz00_5902;
BgL_vz00_5902 = 
FOREIGN_TO_COBJ(BgL_vz00_4707); 
return 
((((BgL_securezd2contextzd2_bglt)COBJECT(
((BgL_securezd2contextzd2_bglt)BgL_oz00_4706)))->BgL_z42nativez42)=((void *)BgL_vz00_5902),BUNSPEC);} } 

}



/* &lambda1801 */
obj_t BGl_z62lambda1801z62zz__ssl_sslz00(obj_t BgL_envz00_4708, obj_t BgL_oz00_4709)
{
{ /* Llib/ssl.scm 405 */
return 
void_star_to_obj(
(((BgL_securezd2contextzd2_bglt)COBJECT(
((BgL_securezd2contextzd2_bglt)BgL_oz00_4709)))->BgL_z42nativez42));} 

}



/* &<@anonymous:1780> */
obj_t BGl_z62zc3z04anonymousza31780ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4710, obj_t BgL_new1054z00_4711)
{
{ /* Llib/ssl.scm 302 */
{ 
BgL_privatezd2keyzd2_bglt BgL_auxz00_8004;
((((BgL_privatezd2keyzd2_bglt)COBJECT(
((BgL_privatezd2keyzd2_bglt)BgL_new1054z00_4711)))->BgL_z42nativez42)=((void *)
0L),BUNSPEC); 
BgL_auxz00_8004 = 
((BgL_privatezd2keyzd2_bglt)BgL_new1054z00_4711); 
return 
((obj_t)BgL_auxz00_8004);} } 

}



/* &lambda1778 */
BgL_privatezd2keyzd2_bglt BGl_z62lambda1778z62zz__ssl_sslz00(obj_t BgL_envz00_4712)
{
{ /* Llib/ssl.scm 302 */
{ /* Llib/ssl.scm 302 */
BgL_privatezd2keyzd2_bglt BgL_new1053z00_5905;
BgL_new1053z00_5905 = 
((BgL_privatezd2keyzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_privatezd2keyzd2_bgl) ))); 
{ /* Llib/ssl.scm 302 */
long BgL_arg1779z00_5906;
{ /* Llib/ssl.scm 302 */
long BgL_res2354z00_5907;
BgL_res2354z00_5907 = 
BGL_CLASS_INDEX(BGl_privatezd2keyzd2zz__ssl_sslz00); 
BgL_arg1779z00_5906 = BgL_res2354z00_5907; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1053z00_5905), BgL_arg1779z00_5906); } 
return BgL_new1053z00_5905;} } 

}



/* &lambda1776 */
BgL_privatezd2keyzd2_bglt BGl_z62lambda1776z62zz__ssl_sslz00(obj_t BgL_envz00_4713, obj_t BgL_z42native1052z42_4714)
{
{ /* Llib/ssl.scm 302 */
{ /* Llib/ssl.scm 302 */
void * BgL_z42native1052z42_5908;
BgL_z42native1052z42_5908 = 
FOREIGN_TO_COBJ(BgL_z42native1052z42_4714); 
{ /* Llib/ssl.scm 302 */
BgL_privatezd2keyzd2_bglt BgL_new1152z00_5909;
{ /* Llib/ssl.scm 302 */
BgL_privatezd2keyzd2_bglt BgL_new1151z00_5910;
BgL_new1151z00_5910 = 
((BgL_privatezd2keyzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_privatezd2keyzd2_bgl) ))); 
{ /* Llib/ssl.scm 302 */
long BgL_arg1777z00_5911;
{ /* Llib/ssl.scm 302 */
long BgL_res2353z00_5912;
BgL_res2353z00_5912 = 
BGL_CLASS_INDEX(BGl_privatezd2keyzd2zz__ssl_sslz00); 
BgL_arg1777z00_5911 = BgL_res2353z00_5912; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1151z00_5910), BgL_arg1777z00_5911); } 
BgL_new1152z00_5909 = BgL_new1151z00_5910; } 
((((BgL_privatezd2keyzd2_bglt)COBJECT(BgL_new1152z00_5909))->BgL_z42nativez42)=((void *)BgL_z42native1052z42_5908),BUNSPEC); 
return BgL_new1152z00_5909;} } } 

}



/* &lambda1785 */
obj_t BGl_z62lambda1785z62zz__ssl_sslz00(obj_t BgL_envz00_4715, obj_t BgL_oz00_4716, obj_t BgL_vz00_4717)
{
{ /* Llib/ssl.scm 302 */
{ /* Llib/ssl.scm 302 */
void * BgL_vz00_5914;
BgL_vz00_5914 = 
FOREIGN_TO_COBJ(BgL_vz00_4717); 
return 
((((BgL_privatezd2keyzd2_bglt)COBJECT(
((BgL_privatezd2keyzd2_bglt)BgL_oz00_4716)))->BgL_z42nativez42)=((void *)BgL_vz00_5914),BUNSPEC);} } 

}



/* &lambda1784 */
obj_t BGl_z62lambda1784z62zz__ssl_sslz00(obj_t BgL_envz00_4718, obj_t BgL_oz00_4719)
{
{ /* Llib/ssl.scm 302 */
return 
void_star_to_obj(
(((BgL_privatezd2keyzd2_bglt)COBJECT(
((BgL_privatezd2keyzd2_bglt)BgL_oz00_4719)))->BgL_z42nativez42));} 

}



/* &<@anonymous:1765> */
obj_t BGl_z62zc3z04anonymousza31765ze3ze5zz__ssl_sslz00(obj_t BgL_envz00_4720, obj_t BgL_new1050z00_4721)
{
{ /* Llib/ssl.scm 299 */
{ 
BgL_certificatez00_bglt BgL_auxz00_8026;
((((BgL_certificatez00_bglt)COBJECT(
((BgL_certificatez00_bglt)BgL_new1050z00_4721)))->BgL_z42nativez42)=((void *)
0L),BUNSPEC); 
BgL_auxz00_8026 = 
((BgL_certificatez00_bglt)BgL_new1050z00_4721); 
return 
((obj_t)BgL_auxz00_8026);} } 

}



/* &lambda1763 */
BgL_certificatez00_bglt BGl_z62lambda1763z62zz__ssl_sslz00(obj_t BgL_envz00_4722)
{
{ /* Llib/ssl.scm 299 */
{ /* Llib/ssl.scm 299 */
BgL_certificatez00_bglt BgL_new1049z00_5917;
BgL_new1049z00_5917 = 
((BgL_certificatez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_certificatez00_bgl) ))); 
{ /* Llib/ssl.scm 299 */
long BgL_arg1764z00_5918;
{ /* Llib/ssl.scm 299 */
long BgL_res2352z00_5919;
BgL_res2352z00_5919 = 
BGL_CLASS_INDEX(BGl_certificatez00zz__ssl_sslz00); 
BgL_arg1764z00_5918 = BgL_res2352z00_5919; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1049z00_5917), BgL_arg1764z00_5918); } 
return BgL_new1049z00_5917;} } 

}



/* &lambda1761 */
BgL_certificatez00_bglt BGl_z62lambda1761z62zz__ssl_sslz00(obj_t BgL_envz00_4723, obj_t BgL_z42native1048z42_4724)
{
{ /* Llib/ssl.scm 299 */
{ /* Llib/ssl.scm 299 */
void * BgL_z42native1048z42_5920;
BgL_z42native1048z42_5920 = 
FOREIGN_TO_COBJ(BgL_z42native1048z42_4724); 
{ /* Llib/ssl.scm 299 */
BgL_certificatez00_bglt BgL_new1150z00_5921;
{ /* Llib/ssl.scm 299 */
BgL_certificatez00_bglt BgL_new1149z00_5922;
BgL_new1149z00_5922 = 
((BgL_certificatez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_certificatez00_bgl) ))); 
{ /* Llib/ssl.scm 299 */
long BgL_arg1762z00_5923;
{ /* Llib/ssl.scm 299 */
long BgL_res2351z00_5924;
BgL_res2351z00_5924 = 
BGL_CLASS_INDEX(BGl_certificatez00zz__ssl_sslz00); 
BgL_arg1762z00_5923 = BgL_res2351z00_5924; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1149z00_5922), BgL_arg1762z00_5923); } 
BgL_new1150z00_5921 = BgL_new1149z00_5922; } 
((((BgL_certificatez00_bglt)COBJECT(BgL_new1150z00_5921))->BgL_z42nativez42)=((void *)BgL_z42native1048z42_5920),BUNSPEC); 
return BgL_new1150z00_5921;} } } 

}



/* &lambda1770 */
obj_t BGl_z62lambda1770z62zz__ssl_sslz00(obj_t BgL_envz00_4725, obj_t BgL_oz00_4726, obj_t BgL_vz00_4727)
{
{ /* Llib/ssl.scm 299 */
{ /* Llib/ssl.scm 299 */
void * BgL_vz00_5926;
BgL_vz00_5926 = 
FOREIGN_TO_COBJ(BgL_vz00_4727); 
return 
((((BgL_certificatez00_bglt)COBJECT(
((BgL_certificatez00_bglt)BgL_oz00_4726)))->BgL_z42nativez42)=((void *)BgL_vz00_5926),BUNSPEC);} } 

}



/* &lambda1769 */
obj_t BGl_z62lambda1769z62zz__ssl_sslz00(obj_t BgL_envz00_4728, obj_t BgL_oz00_4729)
{
{ /* Llib/ssl.scm 299 */
return 
void_star_to_obj(
(((BgL_certificatez00_bglt)COBJECT(
((BgL_certificatez00_bglt)BgL_oz00_4729)))->BgL_z42nativez42));} 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__ssl_sslz00()
{
{ /* Llib/ssl.scm 15 */
BGl_registerzd2genericz12zc0zz__objectz00(BGl_securezd2contextzd2initzd2envzd2zz__ssl_sslz00, BGl_proc3565z00zz__ssl_sslz00, BGl_securezd2contextzd2zz__ssl_sslz00, BGl_string3566z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_securezd2contextzd2closezd2envzd2zz__ssl_sslz00, BGl_proc3567z00zz__ssl_sslz00, BGl_securezd2contextzd2zz__ssl_sslz00, BGl_string3568z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_securezd2contextzd2addzd2rootzd2certsz12zd2envzc0zz__ssl_sslz00, BGl_proc3569z00zz__ssl_sslz00, BGl_securezd2contextzd2zz__ssl_sslz00, BGl_string3570z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_securezd2contextzd2addzd2cazd2certz12zd2envzc0zz__ssl_sslz00, BGl_proc3571z00zz__ssl_sslz00, BGl_securezd2contextzd2zz__ssl_sslz00, BGl_string3572z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_securezd2contextzd2addzd2crlz12zd2envz12zz__ssl_sslz00, BGl_proc3573z00zz__ssl_sslz00, BGl_securezd2contextzd2zz__ssl_sslz00, BGl_string3574z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_securezd2contextzd2setzd2keyz12zd2envz12zz__ssl_sslz00, BGl_proc3575z00zz__ssl_sslz00, BGl_securezd2contextzd2zz__ssl_sslz00, BGl_string3576z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_securezd2contextzd2setzd2certz12zd2envz12zz__ssl_sslz00, BGl_proc3577z00zz__ssl_sslz00, BGl_securezd2contextzd2zz__ssl_sslz00, BGl_string3578z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_securezd2contextzd2setzd2sessionzd2idzd2contextz12zd2envz12zz__ssl_sslz00, BGl_proc3579z00zz__ssl_sslz00, BGl_securezd2contextzd2zz__ssl_sslz00, BGl_string3580z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_securezd2contextzd2loadzd2pkcs12zd2envz00zz__ssl_sslz00, BGl_proc3581z00zz__ssl_sslz00, BGl_securezd2contextzd2zz__ssl_sslz00, BGl_string3582z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_securezd2contextzd2setzd2ciphersz12zd2envz12zz__ssl_sslz00, BGl_proc3583z00zz__ssl_sslz00, BGl_securezd2contextzd2zz__ssl_sslz00, BGl_string3584z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_securezd2contextzd2setzd2optionsz12zd2envz12zz__ssl_sslz00, BGl_proc3585z00zz__ssl_sslz00, BGl_securezd2contextzd2zz__ssl_sslz00, BGl_string3586z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2connectionzd2initzd2envzd2zz__ssl_sslz00, BGl_proc3587z00zz__ssl_sslz00, BGl_sslzd2connectionzd2zz__ssl_sslz00, BGl_string3588z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2connectionzd2startzd2envzd2zz__ssl_sslz00, BGl_proc3589z00zz__ssl_sslz00, BGl_sslzd2connectionzd2zz__ssl_sslz00, BGl_string3590z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2connectionzd2closezd2envzd2zz__ssl_sslz00, BGl_proc3591z00zz__ssl_sslz00, BGl_sslzd2connectionzd2zz__ssl_sslz00, BGl_string3592z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2connectionzd2shutdownzd2envzd2zz__ssl_sslz00, BGl_proc3593z00zz__ssl_sslz00, BGl_sslzd2connectionzd2zz__ssl_sslz00, BGl_string3594z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2connectionzd2readzd2envzd2zz__ssl_sslz00, BGl_proc3595z00zz__ssl_sslz00, BGl_sslzd2connectionzd2zz__ssl_sslz00, BGl_string3596z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2connectionzd2writezd2envzd2zz__ssl_sslz00, BGl_proc3597z00zz__ssl_sslz00, BGl_sslzd2connectionzd2zz__ssl_sslz00, BGl_string3598z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2connectionzd2clearzd2inzd2envz00zz__ssl_sslz00, BGl_proc3599z00zz__ssl_sslz00, BGl_sslzd2connectionzd2zz__ssl_sslz00, BGl_string3600z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2connectionzd2clearzd2outzd2envz00zz__ssl_sslz00, BGl_proc3601z00zz__ssl_sslz00, BGl_sslzd2connectionzd2zz__ssl_sslz00, BGl_string3602z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2connectionzd2initzd2finishedzf3zd2envzf3zz__ssl_sslz00, BGl_proc3603z00zz__ssl_sslz00, BGl_sslzd2connectionzd2zz__ssl_sslz00, BGl_string3604z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2connectionzd2enczd2pendingzd2envz00zz__ssl_sslz00, BGl_proc3605z00zz__ssl_sslz00, BGl_sslzd2connectionzd2zz__ssl_sslz00, BGl_string3606z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2connectionzd2clearzd2pendingzd2envz00zz__ssl_sslz00, BGl_proc3607z00zz__ssl_sslz00, BGl_sslzd2connectionzd2zz__ssl_sslz00, BGl_string3608z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2connectionzd2setzd2sessionzd2envz00zz__ssl_sslz00, BGl_proc3609z00zz__ssl_sslz00, BGl_sslzd2connectionzd2zz__ssl_sslz00, BGl_string3610z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2connectionzd2getzd2sessionzd2envz00zz__ssl_sslz00, BGl_proc3611z00zz__ssl_sslz00, BGl_sslzd2connectionzd2zz__ssl_sslz00, BGl_string3612z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2connectionzd2getzd2currentzd2cipherzd2envzd2zz__ssl_sslz00, BGl_proc3613z00zz__ssl_sslz00, BGl_sslzd2connectionzd2zz__ssl_sslz00, BGl_string3614z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2connectionzd2loadzd2sessionzd2envz00zz__ssl_sslz00, BGl_proc3615z00zz__ssl_sslz00, BGl_sslzd2connectionzd2zz__ssl_sslz00, BGl_string3616z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2connectionzd2verifyzd2errorzd2envz00zz__ssl_sslz00, BGl_proc3617z00zz__ssl_sslz00, BGl_sslzd2connectionzd2zz__ssl_sslz00, BGl_string3618z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2connectionzd2getzd2peerzd2certificatezd2envzd2zz__ssl_sslz00, BGl_proc3619z00zz__ssl_sslz00, BGl_sslzd2connectionzd2zz__ssl_sslz00, BGl_string3620z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2connectionzd2reusedzf3zd2envz21zz__ssl_sslz00, BGl_proc3621z00zz__ssl_sslz00, BGl_sslzd2connectionzd2zz__ssl_sslz00, BGl_string3622z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2connectionzd2getzd2negotiatedzd2protocolzd2envzd2zz__ssl_sslz00, BGl_proc3623z00zz__ssl_sslz00, BGl_sslzd2connectionzd2zz__ssl_sslz00, BGl_string3624z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_dhzd2initzd2envz00zz__ssl_sslz00, BGl_proc3625z00zz__ssl_sslz00, BGl_dhz00zz__ssl_sslz00, BGl_string3626z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_dhzd2siza7ezd2envza7zz__ssl_sslz00, BGl_proc3627z00zz__ssl_sslz00, BGl_dhz00zz__ssl_sslz00, BGl_string3628z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_dhzd2generatezd2parameterszd2exzd2envz00zz__ssl_sslz00, BGl_proc3629z00zz__ssl_sslz00, BGl_dhz00zz__ssl_sslz00, BGl_string3630z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_dhzd2checkzd2envz00zz__ssl_sslz00, BGl_proc3631z00zz__ssl_sslz00, BGl_dhz00zz__ssl_sslz00, BGl_string3632z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_dhzd2checkzd2pubzd2keyzd2envz00zz__ssl_sslz00, BGl_proc3633z00zz__ssl_sslz00, BGl_dhz00zz__ssl_sslz00, BGl_string3634z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_dhzd2computezd2keyzd2envzd2zz__ssl_sslz00, BGl_proc3635z00zz__ssl_sslz00, BGl_dhz00zz__ssl_sslz00, BGl_string3636z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_dhzd2generatezd2keyzd2envzd2zz__ssl_sslz00, BGl_proc3637z00zz__ssl_sslz00, BGl_dhz00zz__ssl_sslz00, BGl_string3638z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2hashzd2initzd2envzd2zz__ssl_sslz00, BGl_proc3639z00zz__ssl_sslz00, BGl_sslzd2hashzd2zz__ssl_sslz00, BGl_string3640z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2hashzd2updatez12zd2envzc0zz__ssl_sslz00, BGl_proc3641z00zz__ssl_sslz00, BGl_sslzd2hashzd2zz__ssl_sslz00, BGl_string3642z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2hashzd2digestzd2envzd2zz__ssl_sslz00, BGl_proc3643z00zz__ssl_sslz00, BGl_sslzd2hashzd2zz__ssl_sslz00, BGl_string3644z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2hmaczd2initzd2envzd2zz__ssl_sslz00, BGl_proc3645z00zz__ssl_sslz00, BGl_sslzd2hmaczd2zz__ssl_sslz00, BGl_string3646z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2hmaczd2updatez12zd2envzc0zz__ssl_sslz00, BGl_proc3647z00zz__ssl_sslz00, BGl_sslzd2hmaczd2zz__ssl_sslz00, BGl_string3648z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2hmaczd2digestzd2envzd2zz__ssl_sslz00, BGl_proc3649z00zz__ssl_sslz00, BGl_sslzd2hmaczd2zz__ssl_sslz00, BGl_string3650z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2signzd2initzd2envzd2zz__ssl_sslz00, BGl_proc3651z00zz__ssl_sslz00, BGl_sslzd2signzd2zz__ssl_sslz00, BGl_string3652z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2signzd2updatez12zd2envzc0zz__ssl_sslz00, BGl_proc3653z00zz__ssl_sslz00, BGl_sslzd2signzd2zz__ssl_sslz00, BGl_string3654z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2signzd2signzd2envzd2zz__ssl_sslz00, BGl_proc3655z00zz__ssl_sslz00, BGl_sslzd2signzd2zz__ssl_sslz00, BGl_string3656z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2verifyzd2initzd2envzd2zz__ssl_sslz00, BGl_proc3657z00zz__ssl_sslz00, BGl_sslzd2verifyzd2zz__ssl_sslz00, BGl_string3658z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2verifyzd2updatez12zd2envzc0zz__ssl_sslz00, BGl_proc3659z00zz__ssl_sslz00, BGl_sslzd2verifyzd2zz__ssl_sslz00, BGl_string3660z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2verifyzd2finalzd2envzd2zz__ssl_sslz00, BGl_proc3661z00zz__ssl_sslz00, BGl_sslzd2verifyzd2zz__ssl_sslz00, BGl_string3662z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2cipherzd2initzd2envzd2zz__ssl_sslz00, BGl_proc3663z00zz__ssl_sslz00, BGl_sslzd2cipherzd2zz__ssl_sslz00, BGl_string3664z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2cipherzd2initivzd2envzd2zz__ssl_sslz00, BGl_proc3665z00zz__ssl_sslz00, BGl_sslzd2cipherzd2zz__ssl_sslz00, BGl_string3666z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2cipherzd2updatez12zd2envzc0zz__ssl_sslz00, BGl_proc3667z00zz__ssl_sslz00, BGl_sslzd2cipherzd2zz__ssl_sslz00, BGl_string3668z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2cipherzd2setzd2autozd2paddingzd2envzd2zz__ssl_sslz00, BGl_proc3669z00zz__ssl_sslz00, BGl_sslzd2cipherzd2zz__ssl_sslz00, BGl_string3670z00zz__ssl_sslz00); 
return 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2cipherzd2finalzd2envzd2zz__ssl_sslz00, BGl_proc3671z00zz__ssl_sslz00, BGl_sslzd2cipherzd2zz__ssl_sslz00, BGl_string3672z00zz__ssl_sslz00);} 

}



/* &ssl-cipher-final1351 */
obj_t BGl_z62sslzd2cipherzd2final1351z62zz__ssl_sslz00(obj_t BgL_envz00_4792, obj_t BgL_sslzd2cipherzd2_4793)
{
{ /* Llib/ssl.scm 1383 */
return 
bgl_cipher_final(
((BgL_sslzd2cipherzd2_bglt)BgL_sslzd2cipherzd2_4793));} 

}



/* &ssl-cipher-set-auto-1349 */
obj_t BGl_z62sslzd2cipherzd2setzd2autozd21349z62zz__ssl_sslz00(obj_t BgL_envz00_4794, obj_t BgL_sslzd2cipherzd2_4795, obj_t BgL_autozd2paddingzd2_4796)
{
{ /* Llib/ssl.scm 1373 */
{ /* Llib/ssl.scm 1376 */
bool_t BgL_tmpz00_8104;
{ /* Llib/ssl.scm 1376 */
bool_t BgL_autozd2paddingzd2_5930;
BgL_autozd2paddingzd2_5930 = 
CBOOL(BgL_autozd2paddingzd2_4796); 
BgL_tmpz00_8104 = 
bgl_cipher_set_auto_padding(
((BgL_sslzd2cipherzd2_bglt)BgL_sslzd2cipherzd2_4795), BgL_autozd2paddingzd2_5930); } 
return 
BBOOL(BgL_tmpz00_8104);} } 

}



/* &ssl-cipher-update!1347 */
obj_t BGl_z62sslzd2cipherzd2updatez121347z70zz__ssl_sslz00(obj_t BgL_envz00_4797, obj_t BgL_sslzd2cipherzd2_4798, obj_t BgL_dataz00_4799, obj_t BgL_offsetz00_4800, obj_t BgL_lenz00_4801)
{
{ /* Llib/ssl.scm 1362 */
{ /* Llib/ssl.scm 1365 */
long BgL_offsetz00_5933;long BgL_lenz00_5934;
BgL_offsetz00_5933 = 
(long)CINT(BgL_offsetz00_4800); 
BgL_lenz00_5934 = 
(long)CINT(BgL_lenz00_4801); 
{ /* Llib/ssl.scm 1365 */
obj_t BgL__ortest_1148z00_5935;
BgL__ortest_1148z00_5935 = 
bgl_cipher_update(
((BgL_sslzd2cipherzd2_bglt)BgL_sslzd2cipherzd2_4798), 
((obj_t)BgL_dataz00_4799), BgL_offsetz00_5933, BgL_lenz00_5934); 
if(
CBOOL(BgL__ortest_1148z00_5935))
{ /* Llib/ssl.scm 1365 */
return BgL__ortest_1148z00_5935;}  else 
{ /* Llib/ssl.scm 1365 */
return 
BGl_errorz00zz__errorz00(BGl_string3673z00zz__ssl_sslz00, BGl_string3674z00zz__ssl_sslz00, 
((obj_t)
((BgL_sslzd2cipherzd2_bglt)BgL_sslzd2cipherzd2_4798)));} } } } 

}



/* &ssl-cipher-initiv1345 */
obj_t BGl_z62sslzd2cipherzd2initiv1345z62zz__ssl_sslz00(obj_t BgL_envz00_4802, obj_t BgL_sslzd2cipherzd2_4803, obj_t BgL_cipherz00_4804, obj_t BgL_keyz00_4805, obj_t BgL_offsetz00_4806, obj_t BgL_lenz00_4807, obj_t BgL_ivz00_4808, obj_t BgL_ivoffsetz00_4809, obj_t BgL_ivlenz00_4810, obj_t BgL_encz00_4811)
{
{ /* Llib/ssl.scm 1345 */
{ /* Llib/ssl.scm 1351 */
long BgL_offsetz00_5939;long BgL_lenz00_5940;long BgL_ivoffsetz00_5942;long BgL_ivlenz00_5943;bool_t BgL_encz00_5944;
BgL_offsetz00_5939 = 
(long)CINT(BgL_offsetz00_4806); 
BgL_lenz00_5940 = 
(long)CINT(BgL_lenz00_4807); 
BgL_ivoffsetz00_5942 = 
(long)CINT(BgL_ivoffsetz00_4809); 
BgL_ivlenz00_5943 = 
(long)CINT(BgL_ivlenz00_4810); 
BgL_encz00_5944 = 
CBOOL(BgL_encz00_4811); 
if(
bgl_ssl_cipher_initiv(
((BgL_sslzd2cipherzd2_bglt)BgL_sslzd2cipherzd2_4803), 
((obj_t)BgL_cipherz00_4804), 
((obj_t)BgL_keyz00_4805), BgL_offsetz00_5939, BgL_lenz00_5940, 
((obj_t)BgL_ivz00_4808), BgL_ivoffsetz00_5942, BgL_ivlenz00_5943, BgL_encz00_5944))
{ /* Llib/ssl.scm 1351 */
return BFALSE;}  else 
{ /* Llib/ssl.scm 1355 */
obj_t BgL_arg2301z00_5945;
BgL_arg2301z00_5945 = 
bgl_ssl_error_string(); 
return 
BGl_errorz00zz__errorz00(BGl_string3675z00zz__ssl_sslz00, BgL_arg2301z00_5945, 
((obj_t)
((BgL_sslzd2cipherzd2_bglt)BgL_sslzd2cipherzd2_4803)));} } } 

}



/* &ssl-cipher-init1343 */
obj_t BGl_z62sslzd2cipherzd2init1343z62zz__ssl_sslz00(obj_t BgL_envz00_4812, obj_t BgL_sslzd2cipherzd2_4813, obj_t BgL_cipherz00_4814, obj_t BgL_keyz00_4815, obj_t BgL_offsetz00_4816, obj_t BgL_lenz00_4817, obj_t BgL_encz00_4818)
{
{ /* Llib/ssl.scm 1331 */
{ 
BgL_sslzd2cipherzd2_bglt BgL_auxz00_8134;
{ /* Llib/ssl.scm 1336 */
long BgL_offsetz00_5949;long BgL_lenz00_5950;bool_t BgL_encz00_5951;
BgL_offsetz00_5949 = 
(long)CINT(BgL_offsetz00_4816); 
BgL_lenz00_5950 = 
(long)CINT(BgL_lenz00_4817); 
BgL_encz00_5951 = 
CBOOL(BgL_encz00_4818); 
if(
bgl_ssl_cipher_init(
((BgL_sslzd2cipherzd2_bglt)BgL_sslzd2cipherzd2_4813), 
((obj_t)BgL_cipherz00_4814), 
((obj_t)BgL_keyz00_4815), BgL_offsetz00_5949, BgL_lenz00_5950, BgL_encz00_5951))
{ /* Llib/ssl.scm 1336 */BFALSE; }  else 
{ /* Llib/ssl.scm 1336 */
BGl_errorz00zz__errorz00(BGl_string3676z00zz__ssl_sslz00, 
bgl_ssl_error_string(), 
((obj_t)BgL_cipherz00_4814)); } 
BgL_auxz00_8134 = 
((BgL_sslzd2cipherzd2_bglt)BgL_sslzd2cipherzd2_4813); } 
return 
((obj_t)BgL_auxz00_8134);} } 

}



/* &ssl-verify-final1341 */
obj_t BGl_z62sslzd2verifyzd2final1341z62zz__ssl_sslz00(obj_t BgL_envz00_4819, obj_t BgL_sslzd2verifyzd2_4820, obj_t BgL_keyz00_4821, obj_t BgL_koffsetz00_4822, obj_t BgL_klenz00_4823, obj_t BgL_sigz00_4824, obj_t BgL_soffsetz00_4825, obj_t BgL_slenz00_4826)
{
{ /* Llib/ssl.scm 1317 */
{ /* Llib/ssl.scm 1322 */
bool_t BgL_tmpz00_8148;
{ /* Llib/ssl.scm 1322 */
long BgL_koffsetz00_5954;long BgL_klenz00_5955;long BgL_soffsetz00_5957;long BgL_slenz00_5958;
BgL_koffsetz00_5954 = 
(long)CINT(BgL_koffsetz00_4822); 
BgL_klenz00_5955 = 
(long)CINT(BgL_klenz00_4823); 
BgL_soffsetz00_5957 = 
(long)CINT(BgL_soffsetz00_4825); 
BgL_slenz00_5958 = 
(long)CINT(BgL_slenz00_4826); 
BgL_tmpz00_8148 = 
bgl_ssl_verify_final(
((BgL_sslzd2verifyzd2_bglt)BgL_sslzd2verifyzd2_4820), 
((obj_t)BgL_keyz00_4821), BgL_koffsetz00_5954, BgL_klenz00_5955, 
((obj_t)BgL_sigz00_4824), BgL_soffsetz00_5957, BgL_slenz00_5958); } 
return 
BBOOL(BgL_tmpz00_8148);} } 

}



/* &ssl-verify-update!1339 */
obj_t BGl_z62sslzd2verifyzd2updatez121339z70zz__ssl_sslz00(obj_t BgL_envz00_4827, obj_t BgL_sslzd2verifyzd2_4828, obj_t BgL_dataz00_4829, obj_t BgL_offsetz00_4830, obj_t BgL_lenz00_4831)
{
{ /* Llib/ssl.scm 1305 */
{ 
BgL_sslzd2verifyzd2_bglt BgL_auxz00_8158;
{ /* Llib/ssl.scm 1308 */
long BgL_offsetz00_5961;long BgL_lenz00_5962;
BgL_offsetz00_5961 = 
(long)CINT(BgL_offsetz00_4830); 
BgL_lenz00_5962 = 
(long)CINT(BgL_lenz00_4831); 
if(
bgl_ssl_verify_update(
((BgL_sslzd2verifyzd2_bglt)BgL_sslzd2verifyzd2_4828), 
((obj_t)BgL_dataz00_4829), BgL_offsetz00_5961, BgL_lenz00_5962))
{ /* Llib/ssl.scm 1308 */BFALSE; }  else 
{ /* Llib/ssl.scm 1308 */
BGl_errorz00zz__errorz00(BGl_string3677z00zz__ssl_sslz00, BGl_string3674z00zz__ssl_sslz00, 
((obj_t)
((BgL_sslzd2verifyzd2_bglt)BgL_sslzd2verifyzd2_4828))); } 
BgL_auxz00_8158 = 
((BgL_sslzd2verifyzd2_bglt)BgL_sslzd2verifyzd2_4828); } 
return 
((obj_t)BgL_auxz00_8158);} } 

}



/* &ssl-verify-init1337 */
obj_t BGl_z62sslzd2verifyzd2init1337z62zz__ssl_sslz00(obj_t BgL_envz00_4832, obj_t BgL_sslzd2verifyzd2_4833, obj_t BgL_verifyz00_4834)
{
{ /* Llib/ssl.scm 1293 */
{ 
BgL_sslzd2verifyzd2_bglt BgL_auxz00_8170;
if(
bgl_ssl_verify_init(
((BgL_sslzd2verifyzd2_bglt)BgL_sslzd2verifyzd2_4833), 
((obj_t)BgL_verifyz00_4834)))
{ /* Llib/ssl.scm 1296 */BFALSE; }  else 
{ /* Llib/ssl.scm 1296 */
BGl_errorz00zz__errorz00(BGl_string3678z00zz__ssl_sslz00, BGl_string3679z00zz__ssl_sslz00, 
((obj_t)
((BgL_sslzd2verifyzd2_bglt)BgL_sslzd2verifyzd2_4833))); } 
BgL_auxz00_8170 = 
((BgL_sslzd2verifyzd2_bglt)BgL_sslzd2verifyzd2_4833); 
return 
((obj_t)BgL_auxz00_8170);} } 

}



/* &ssl-sign-sign1335 */
obj_t BGl_z62sslzd2signzd2sign1335z62zz__ssl_sslz00(obj_t BgL_envz00_4835, obj_t BgL_sslzd2signzd2_4836, obj_t BgL_keyz00_4837, obj_t BgL_offsetz00_4838, obj_t BgL_lenz00_4839)
{
{ /* Llib/ssl.scm 1282 */
{ /* Llib/ssl.scm 1285 */
long BgL_offsetz00_5967;long BgL_lenz00_5968;
BgL_offsetz00_5967 = 
(long)CINT(BgL_offsetz00_4838); 
BgL_lenz00_5968 = 
(long)CINT(BgL_lenz00_4839); 
{ /* Llib/ssl.scm 1285 */
obj_t BgL_rz00_5969;
BgL_rz00_5969 = 
bgl_ssl_sign_sign(
((BgL_sslzd2signzd2_bglt)BgL_sslzd2signzd2_4836), 
((obj_t)BgL_keyz00_4837), BgL_offsetz00_5967, BgL_lenz00_5968); 
if(
CBOOL(BgL_rz00_5969))
{ /* Llib/ssl.scm 1286 */
return BgL_rz00_5969;}  else 
{ /* Llib/ssl.scm 1286 */
return 
BGl_errorz00zz__errorz00(BGl_string3680z00zz__ssl_sslz00, BGl_string3681z00zz__ssl_sslz00, 
((obj_t)
((BgL_sslzd2signzd2_bglt)BgL_sslzd2signzd2_4836)));} } } } 

}



/* &ssl-sign-update!1333 */
obj_t BGl_z62sslzd2signzd2updatez121333z70zz__ssl_sslz00(obj_t BgL_envz00_4840, obj_t BgL_sslzd2signzd2_4841, obj_t BgL_dataz00_4842, obj_t BgL_offsetz00_4843, obj_t BgL_lenz00_4844)
{
{ /* Llib/ssl.scm 1270 */
{ 
BgL_sslzd2signzd2_bglt BgL_auxz00_8190;
{ /* Llib/ssl.scm 1273 */
long BgL_offsetz00_5972;long BgL_lenz00_5973;
BgL_offsetz00_5972 = 
(long)CINT(BgL_offsetz00_4843); 
BgL_lenz00_5973 = 
(long)CINT(BgL_lenz00_4844); 
if(
bgl_ssl_sign_update(
((BgL_sslzd2signzd2_bglt)BgL_sslzd2signzd2_4841), 
((obj_t)BgL_dataz00_4842), BgL_offsetz00_5972, BgL_lenz00_5973))
{ /* Llib/ssl.scm 1273 */BFALSE; }  else 
{ /* Llib/ssl.scm 1273 */
BGl_errorz00zz__errorz00(BGl_string3682z00zz__ssl_sslz00, BGl_string3674z00zz__ssl_sslz00, 
((obj_t)
((BgL_sslzd2signzd2_bglt)BgL_sslzd2signzd2_4841))); } 
BgL_auxz00_8190 = 
((BgL_sslzd2signzd2_bglt)BgL_sslzd2signzd2_4841); } 
return 
((obj_t)BgL_auxz00_8190);} } 

}



/* &ssl-sign-init1331 */
obj_t BGl_z62sslzd2signzd2init1331z62zz__ssl_sslz00(obj_t BgL_envz00_4845, obj_t BgL_sslzd2signzd2_4846, obj_t BgL_signz00_4847)
{
{ /* Llib/ssl.scm 1258 */
{ 
BgL_sslzd2signzd2_bglt BgL_auxz00_8202;
if(
bgl_ssl_sign_init(
((BgL_sslzd2signzd2_bglt)BgL_sslzd2signzd2_4846), 
((obj_t)BgL_signz00_4847)))
{ /* Llib/ssl.scm 1261 */BFALSE; }  else 
{ /* Llib/ssl.scm 1261 */
BGl_errorz00zz__errorz00(BGl_string3683z00zz__ssl_sslz00, BGl_string3684z00zz__ssl_sslz00, 
((obj_t)
((BgL_sslzd2signzd2_bglt)BgL_sslzd2signzd2_4846))); } 
BgL_auxz00_8202 = 
((BgL_sslzd2signzd2_bglt)BgL_sslzd2signzd2_4846); 
return 
((obj_t)BgL_auxz00_8202);} } 

}



/* &ssl-hmac-digest1329 */
obj_t BGl_z62sslzd2hmaczd2digest1329z62zz__ssl_sslz00(obj_t BgL_envz00_4848, obj_t BgL_sslzd2hmaczd2_4849)
{
{ /* Llib/ssl.scm 1247 */
{ /* Llib/ssl.scm 1250 */
obj_t BgL_rz00_5977;
BgL_rz00_5977 = 
bgl_ssl_hmac_digest(
((BgL_sslzd2hmaczd2_bglt)BgL_sslzd2hmaczd2_4849)); 
if(
CBOOL(BgL_rz00_5977))
{ /* Llib/ssl.scm 1251 */
return BgL_rz00_5977;}  else 
{ /* Llib/ssl.scm 1251 */
return 
BGl_errorz00zz__errorz00(BGl_string3685z00zz__ssl_sslz00, BGl_string3686z00zz__ssl_sslz00, 
((obj_t)
((BgL_sslzd2hmaczd2_bglt)BgL_sslzd2hmaczd2_4849)));} } } 

}



/* &ssl-hmac-update!1327 */
obj_t BGl_z62sslzd2hmaczd2updatez121327z70zz__ssl_sslz00(obj_t BgL_envz00_4850, obj_t BgL_sslzd2hmaczd2_4851, obj_t BgL_dataz00_4852, obj_t BgL_offsetz00_4853, obj_t BgL_lenz00_4854)
{
{ /* Llib/ssl.scm 1235 */
{ 
BgL_sslzd2hmaczd2_bglt BgL_auxz00_8219;
{ /* Llib/ssl.scm 1238 */
long BgL_offsetz00_5980;long BgL_lenz00_5981;
BgL_offsetz00_5980 = 
(long)CINT(BgL_offsetz00_4853); 
BgL_lenz00_5981 = 
(long)CINT(BgL_lenz00_4854); 
if(
bgl_ssl_hmac_update(
((BgL_sslzd2hmaczd2_bglt)BgL_sslzd2hmaczd2_4851), 
((obj_t)BgL_dataz00_4852), BgL_offsetz00_5980, BgL_lenz00_5981))
{ /* Llib/ssl.scm 1238 */BFALSE; }  else 
{ /* Llib/ssl.scm 1238 */
BGl_errorz00zz__errorz00(BGl_string3687z00zz__ssl_sslz00, BGl_string3674z00zz__ssl_sslz00, 
((obj_t)
((BgL_sslzd2hmaczd2_bglt)BgL_sslzd2hmaczd2_4851))); } 
BgL_auxz00_8219 = 
((BgL_sslzd2hmaczd2_bglt)BgL_sslzd2hmaczd2_4851); } 
return 
((obj_t)BgL_auxz00_8219);} } 

}



/* &ssl-hmac-init1325 */
obj_t BGl_z62sslzd2hmaczd2init1325z62zz__ssl_sslz00(obj_t BgL_envz00_4855, obj_t BgL_sslzd2hmaczd2_4856, obj_t BgL_hmacz00_4857, obj_t BgL_keyz00_4858)
{
{ /* Llib/ssl.scm 1223 */
if(
bgl_ssl_hmac_init(
((BgL_sslzd2hmaczd2_bglt)BgL_sslzd2hmaczd2_4856), 
((obj_t)BgL_hmacz00_4857), 
((obj_t)BgL_keyz00_4858)))
{ /* Llib/ssl.scm 1226 */
return BFALSE;}  else 
{ /* Llib/ssl.scm 1226 */
BGl_errorz00zz__errorz00(BGl_string3688z00zz__ssl_sslz00, BGl_string3689z00zz__ssl_sslz00, 
((obj_t)
((BgL_sslzd2hmaczd2_bglt)BgL_sslzd2hmaczd2_4856))); 
return 
((obj_t)
((BgL_sslzd2hmaczd2_bglt)BgL_sslzd2hmaczd2_4856));} } 

}



/* &ssl-hash-digest1323 */
obj_t BGl_z62sslzd2hashzd2digest1323z62zz__ssl_sslz00(obj_t BgL_envz00_4859, obj_t BgL_sslzd2hashzd2_4860)
{
{ /* Llib/ssl.scm 1212 */
{ /* Llib/ssl.scm 1215 */
obj_t BgL_rz00_5986;
BgL_rz00_5986 = 
bgl_ssl_hash_digest(
((BgL_sslzd2hashzd2_bglt)BgL_sslzd2hashzd2_4860)); 
if(
CBOOL(BgL_rz00_5986))
{ /* Llib/ssl.scm 1216 */
return BgL_rz00_5986;}  else 
{ /* Llib/ssl.scm 1216 */
return 
BGl_errorz00zz__errorz00(BGl_string3690z00zz__ssl_sslz00, BGl_string3686z00zz__ssl_sslz00, 
((obj_t)
((BgL_sslzd2hashzd2_bglt)BgL_sslzd2hashzd2_4860)));} } } 

}



/* &ssl-hash-update!1321 */
obj_t BGl_z62sslzd2hashzd2updatez121321z70zz__ssl_sslz00(obj_t BgL_envz00_4861, obj_t BgL_sslzd2hashzd2_4862, obj_t BgL_dataz00_4863, obj_t BgL_offsetz00_4864, obj_t BgL_lenz00_4865)
{
{ /* Llib/ssl.scm 1200 */
{ 
BgL_sslzd2hashzd2_bglt BgL_auxz00_8248;
{ /* Llib/ssl.scm 1203 */
long BgL_offsetz00_5989;long BgL_lenz00_5990;
BgL_offsetz00_5989 = 
(long)CINT(BgL_offsetz00_4864); 
BgL_lenz00_5990 = 
(long)CINT(BgL_lenz00_4865); 
if(
bgl_ssl_hash_update(
((BgL_sslzd2hashzd2_bglt)BgL_sslzd2hashzd2_4862), 
((obj_t)BgL_dataz00_4863), BgL_offsetz00_5989, BgL_lenz00_5990))
{ /* Llib/ssl.scm 1203 */BFALSE; }  else 
{ /* Llib/ssl.scm 1203 */
BGl_errorz00zz__errorz00(BGl_string3691z00zz__ssl_sslz00, BGl_string3674z00zz__ssl_sslz00, 
((obj_t)
((BgL_sslzd2hashzd2_bglt)BgL_sslzd2hashzd2_4862))); } 
BgL_auxz00_8248 = 
((BgL_sslzd2hashzd2_bglt)BgL_sslzd2hashzd2_4862); } 
return 
((obj_t)BgL_auxz00_8248);} } 

}



/* &ssl-hash-init1319 */
obj_t BGl_z62sslzd2hashzd2init1319z62zz__ssl_sslz00(obj_t BgL_envz00_4866, obj_t BgL_sslzd2hashzd2_4867)
{
{ /* Llib/ssl.scm 1188 */
{ 
BgL_sslzd2hashzd2_bglt BgL_auxz00_8260;
if(
bgl_ssl_hash_init(
((BgL_sslzd2hashzd2_bglt)BgL_sslzd2hashzd2_4867)))
{ /* Llib/ssl.scm 1191 */BFALSE; }  else 
{ /* Llib/ssl.scm 1191 */
BGl_errorz00zz__errorz00(BGl_string3692z00zz__ssl_sslz00, BGl_string3689z00zz__ssl_sslz00, 
((obj_t)
((BgL_sslzd2hashzd2_bglt)BgL_sslzd2hashzd2_4867))); } 
BgL_auxz00_8260 = 
((BgL_sslzd2hashzd2_bglt)BgL_sslzd2hashzd2_4867); 
return 
((obj_t)BgL_auxz00_8260);} } 

}



/* &dh-generate-key1317 */
obj_t BGl_z62dhzd2generatezd2key1317z62zz__ssl_sslz00(obj_t BgL_envz00_4868, obj_t BgL_dhz00_4869)
{
{ /* Llib/ssl.scm 1177 */
{ /* Llib/ssl.scm 1180 */
bool_t BgL_tmpz00_8269;
{ /* Llib/ssl.scm 1181 */
bool_t BgL_test4373z00_8270;
{ /* Llib/ssl.scm 1181 */
int BgL_arg2274z00_5993;
{ /* Llib/ssl.scm 1181 */
void * BgL_tmpz00_8271;
BgL_tmpz00_8271 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_dhz00_4869)))->BgL_z42nativez42); 
BgL_arg2274z00_5993 = 
DH_generate_key(BgL_tmpz00_8271); } 
BgL_test4373z00_8270 = 
(
(long)(BgL_arg2274z00_5993)==((long)0)); } 
if(BgL_test4373z00_8270)
{ /* Llib/ssl.scm 1181 */
BgL_tmpz00_8269 = ((bool_t)0)
; }  else 
{ /* Llib/ssl.scm 1181 */
BgL_tmpz00_8269 = ((bool_t)1)
; } } 
return 
BBOOL(BgL_tmpz00_8269);} } 

}



/* &dh-compute-key1315 */
obj_t BGl_z62dhzd2computezd2key1315z62zz__ssl_sslz00(obj_t BgL_envz00_4870, obj_t BgL_dhz00_4871, obj_t BgL_keyz00_4872)
{
{ /* Llib/ssl.scm 1151 */
{ /* Llib/ssl.scm 1155 */
int BgL_siza7eza7_5996;
BgL_siza7eza7_5996 = 
BGl_dhzd2siza7ez75zz__ssl_sslz00(
((BgL_dhz00_bglt)BgL_dhz00_4871)); 
{ /* Llib/ssl.scm 1155 */
obj_t BgL_strz00_5997;
{ /* Llib/ssl.scm 1156 */

BgL_strz00_5997 = 
make_string(
(long)(BgL_siza7eza7_5996), ((unsigned char)' ')); } 
{ /* Llib/ssl.scm 1156 */

{ /* Llib/ssl.scm 1157 */
int BgL_sza7za7_5998;
{ /* Llib/ssl.scm 1157 */
void * BgL_arg2268z00_5999;void * BgL_arg2269z00_6000;
{ /* Llib/ssl.scm 1157 */
obj_t BgL_tmpz00_8282;
BgL_tmpz00_8282 = 
((obj_t)BgL_keyz00_4872); 
BgL_arg2268z00_5999 = 
(BIGNUM *)FOREIGN_TO_COBJ(BgL_tmpz00_8282); } 
BgL_arg2269z00_6000 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_dhz00_4871)))->BgL_z42nativez42); 
{ /* Llib/ssl.scm 1157 */
char * BgL_tmpz00_8287;
BgL_tmpz00_8287 = 
BSTRING_TO_STRING(BgL_strz00_5997); 
BgL_sza7za7_5998 = 
DH_compute_key(BgL_tmpz00_8287, BgL_arg2268z00_5999, BgL_arg2269z00_6000); } } 
if(
(
(long)(BgL_sza7za7_5998)==((long)-1)))
{ /* Llib/ssl.scm 1159 */
return BFALSE;}  else 
{ /* Llib/ssl.scm 1159 */
if(
(
(long)(BgL_sza7za7_5998)==
STRING_LENGTH(BgL_strz00_5997)))
{ /* Llib/ssl.scm 1161 */
return BgL_strz00_5997;}  else 
{ /* Llib/ssl.scm 1161 */
blit_string(BgL_strz00_5997, ((long)0), BgL_strz00_5997, 
(
(long)(BgL_siza7eza7_5996)-
(long)(BgL_sza7za7_5998)), 
(long)(BgL_sza7za7_5998)); 
{ /* Llib/ssl.scm 1165 */
long BgL_g1143z00_6002;
BgL_g1143z00_6002 = 
(
(long)(BgL_siza7eza7_5996)-
(long)(BgL_sza7za7_5998)); 
{ 
long BgL_iz00_6004;
BgL_iz00_6004 = BgL_g1143z00_6002; 
BgL_loopz00_6003:
if(
(BgL_iz00_6004>((long)0)))
{ /* Llib/ssl.scm 1167 */
long BgL_niz00_6005;
BgL_niz00_6005 = 
(BgL_iz00_6004-((long)1)); 
STRING_SET(BgL_strz00_5997, BgL_niz00_6005, ((unsigned char)'\000')); 
{ 
long BgL_iz00_8309;
BgL_iz00_8309 = BgL_niz00_6005; 
BgL_iz00_6004 = BgL_iz00_8309; 
goto BgL_loopz00_6003;} }  else 
{ /* Llib/ssl.scm 1166 */((bool_t)0); } } } 
return BgL_strz00_5997;} } } } } } } 

}



/* &dh-check-pub-key1313 */
obj_t BGl_z62dhzd2checkzd2pubzd2key1313zb0zz__ssl_sslz00(obj_t BgL_envz00_4873, obj_t BgL_dhz00_4874, obj_t BgL_keyz00_4875)
{
{ /* Llib/ssl.scm 1140 */
{ /* Llib/ssl.scm 1144 */
void * BgL_arg2258z00_6008;void * BgL_arg2259z00_6009;
BgL_arg2258z00_6008 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_dhz00_4874)))->BgL_z42nativez42); 
{ /* Llib/ssl.scm 1144 */
obj_t BgL_tmpz00_8312;
BgL_tmpz00_8312 = 
((obj_t)BgL_keyz00_4875); 
BgL_arg2259z00_6009 = 
(BIGNUM *)FOREIGN_TO_COBJ(BgL_tmpz00_8312); } 
return 
bgl_dh_check_pub_key(BgL_arg2258z00_6008, BgL_arg2259z00_6009);} } 

}



/* &dh-check1311 */
obj_t BGl_z62dhzd2check1311zb0zz__ssl_sslz00(obj_t BgL_envz00_4876, obj_t BgL_dhz00_4877)
{
{ /* Llib/ssl.scm 1129 */
return 
bgl_dh_check(
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_dhz00_4877)))->BgL_z42nativez42));} 

}



/* &dh-generate-paramete1309 */
obj_t BGl_z62dhzd2generatezd2paramete1309z62zz__ssl_sslz00(obj_t BgL_envz00_4878, obj_t BgL_dhz00_4879, obj_t BgL_lenz00_4880, obj_t BgL_generatorz00_4881)
{
{ /* Llib/ssl.scm 1113 */
{ /* Llib/ssl.scm 1116 */
int BgL_tmpz00_8319;
{ /* Llib/ssl.scm 1116 */
int BgL_lenz00_6012;
BgL_lenz00_6012 = 
CINT(BgL_lenz00_4880); 
{ /* Llib/ssl.scm 1117 */
void * BgL_arg2252z00_6014;obj_t BgL_arg2253z00_6015;
BgL_arg2252z00_6014 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_dhz00_4879)))->BgL_z42nativez42); 
if(
(
((obj_t)BgL_generatorz00_4881)==
CNST_TABLE_REF(((long)90))))
{ /* Llib/ssl.scm 1118 */
BgL_arg2253z00_6015 = 
BINT(DH_GENERATOR_2); }  else 
{ /* Llib/ssl.scm 1118 */
BgL_arg2253z00_6015 = 
BGl_errorz00zz__errorz00(BGl_string3693z00zz__ssl_sslz00, BGl_string3694z00zz__ssl_sslz00, 
((obj_t)BgL_generatorz00_4881)); } 
{ /* Llib/ssl.scm 1117 */
int BgL_tmpz00_8330;
BgL_tmpz00_8330 = 
CINT(BgL_arg2253z00_6015); 
BgL_tmpz00_8319 = 
DH_generate_parameters_ex(BgL_arg2252z00_6014, BgL_lenz00_6012, BgL_tmpz00_8330, ((long)0)); } } } 
return 
BINT(BgL_tmpz00_8319);} } 

}



/* &dh-size1307 */
obj_t BGl_z62dhzd2siza7e1307z17zz__ssl_sslz00(obj_t BgL_envz00_4882, obj_t BgL_dhz00_4883)
{
{ /* Llib/ssl.scm 1105 */
{ /* Llib/ssl.scm 1107 */
int BgL_tmpz00_8334;
{ /* Llib/ssl.scm 1107 */
void * BgL_tmpz00_8335;
BgL_tmpz00_8335 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_dhz00_4883)))->BgL_z42nativez42); 
BgL_tmpz00_8334 = 
DH_size(BgL_tmpz00_8335); } 
return 
BINT(BgL_tmpz00_8334);} } 

}



/* &dh-init1305 */
obj_t BGl_z62dhzd2init1305zb0zz__ssl_sslz00(obj_t BgL_envz00_4884, obj_t BgL_dhz00_4885)
{
{ /* Llib/ssl.scm 1094 */
return 
((((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_dhz00_4885)))->BgL_z42nativez42)=((void *)
DH_new()),BUNSPEC);} 

}



/* &ssl-connection-get-n1303 */
obj_t BGl_z62sslzd2connectionzd2getzd2n1303zb0zz__ssl_sslz00(obj_t BgL_envz00_4886, obj_t BgL_sslz00_4887)
{
{ /* Llib/ssl.scm 1084 */
return 
bgl_ssl_connection_get_negotiated_protocol(
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_4887));} 

}



/* &ssl-connection-reuse1301 */
obj_t BGl_z62sslzd2connectionzd2reuse1301z62zz__ssl_sslz00(obj_t BgL_envz00_4888, obj_t BgL_sslz00_4889)
{
{ /* Llib/ssl.scm 1073 */
{ /* Llib/ssl.scm 1076 */
bool_t BgL_tmpz00_8345;
{ /* Llib/ssl.scm 1077 */
void * BgL_tmpz00_8346;
BgL_tmpz00_8346 = 
(((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_4889)))->BgL_z42nativez42); 
BgL_tmpz00_8345 = 
SSL_session_reused(BgL_tmpz00_8346); } 
return 
BBOOL(BgL_tmpz00_8345);} } 

}



/* &ssl-connection-get-p1299 */
obj_t BGl_z62sslzd2connectionzd2getzd2p1299zb0zz__ssl_sslz00(obj_t BgL_envz00_4890, obj_t BgL_sslz00_4891)
{
{ /* Llib/ssl.scm 1063 */
return 
bgl_ssl_connection_get_peer_certificate(
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_4891));} 

}



/* &ssl-connection-verif1297 */
obj_t BGl_z62sslzd2connectionzd2verif1297z62zz__ssl_sslz00(obj_t BgL_envz00_4892, obj_t BgL_sslz00_4893)
{
{ /* Llib/ssl.scm 1053 */
return 
bgl_ssl_connection_verify_error(
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_4893));} 

}



/* &ssl-connection-load-1295 */
obj_t BGl_z62sslzd2connectionzd2loadzd21295zb0zz__ssl_sslz00(obj_t BgL_envz00_4894, obj_t BgL_sslz00_4895, obj_t BgL_bufz00_4896)
{
{ /* Llib/ssl.scm 1043 */
return 
BINT(
bgl_ssl_connection_load_session(
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_4895), 
((obj_t)BgL_bufz00_4896)));} 

}



/* &ssl-connection-get-c1293 */
obj_t BGl_z62sslzd2connectionzd2getzd2c1293zb0zz__ssl_sslz00(obj_t BgL_envz00_4897, obj_t BgL_sslz00_4898)
{
{ /* Llib/ssl.scm 1033 */
return 
bgl_ssl_connection_get_current_cipher(
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_4898));} 

}



/* &ssl-connection-get-s1291 */
obj_t BGl_z62sslzd2connectionzd2getzd2s1291zb0zz__ssl_sslz00(obj_t BgL_envz00_4899, obj_t BgL_sslz00_4900)
{
{ /* Llib/ssl.scm 1023 */
return 
bgl_ssl_connection_get_session(
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_4900));} 

}



/* &ssl-connection-set-s1289 */
obj_t BGl_z62sslzd2connectionzd2setzd2s1289zb0zz__ssl_sslz00(obj_t BgL_envz00_4901, obj_t BgL_sslz00_4902, obj_t BgL_bufz00_4903)
{
{ /* Llib/ssl.scm 1013 */
return 
BINT(
bgl_ssl_connection_set_session(
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_4902), 
((obj_t)BgL_bufz00_4903)));} 

}



/* &ssl-connection-clear1287 */
obj_t BGl_z62sslzd2connectionzd2clear1287z62zz__ssl_sslz00(obj_t BgL_envz00_4904, obj_t BgL_sslz00_4905)
{
{ /* Llib/ssl.scm 1003 */
return 
BINT(
bgl_ssl_connection_clear_pending(
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_4905)));} 

}



/* &ssl-connection-enc-p1285 */
obj_t BGl_z62sslzd2connectionzd2enczd2p1285zb0zz__ssl_sslz00(obj_t BgL_envz00_4906, obj_t BgL_sslz00_4907)
{
{ /* Llib/ssl.scm 993 */
return 
BINT(
bgl_ssl_connection_enc_pending(
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_4907)));} 

}



/* &ssl-connection-init-1283 */
obj_t BGl_z62sslzd2connectionzd2initzd21283zb0zz__ssl_sslz00(obj_t BgL_envz00_4908, obj_t BgL_sslz00_4909)
{
{ /* Llib/ssl.scm 983 */
return 
BBOOL(
bgl_ssl_connection_init_finishedp(
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_4909)));} 

}



/* &ssl-connection-clear1281 */
obj_t BGl_z62sslzd2connectionzd2clear1281z62zz__ssl_sslz00(obj_t BgL_envz00_4910, obj_t BgL_sslz00_4911, obj_t BgL_bufferz00_4912, obj_t BgL_offsetz00_4913, obj_t BgL_lenz00_4914)
{
{ /* Llib/ssl.scm 973 */
{ /* Llib/ssl.scm 976 */
long BgL_tmpz00_8376;
{ /* Llib/ssl.scm 976 */
long BgL_offsetz00_6033;long BgL_lenz00_6034;
BgL_offsetz00_6033 = 
(long)CINT(BgL_offsetz00_4913); 
BgL_lenz00_6034 = 
(long)CINT(BgL_lenz00_4914); 
BgL_tmpz00_8376 = 
bgl_ssl_connection_clear_out(
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_4911), 
BSTRING_TO_STRING(
((obj_t)BgL_bufferz00_4912)), BgL_offsetz00_6033, BgL_lenz00_6034); } 
return 
BINT(BgL_tmpz00_8376);} } 

}



/* &ssl-connection-clear1279 */
obj_t BGl_z62sslzd2connectionzd2clear1279z62zz__ssl_sslz00(obj_t BgL_envz00_4915, obj_t BgL_sslz00_4916, obj_t BgL_bufferz00_4917, obj_t BgL_offsetz00_4918, obj_t BgL_lenz00_4919)
{
{ /* Llib/ssl.scm 963 */
{ /* Llib/ssl.scm 966 */
long BgL_tmpz00_8384;
{ /* Llib/ssl.scm 966 */
long BgL_offsetz00_6037;long BgL_lenz00_6038;
BgL_offsetz00_6037 = 
(long)CINT(BgL_offsetz00_4918); 
BgL_lenz00_6038 = 
(long)CINT(BgL_lenz00_4919); 
BgL_tmpz00_8384 = 
bgl_ssl_connection_clear_in(
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_4916), 
BSTRING_TO_STRING(
((obj_t)BgL_bufferz00_4917)), BgL_offsetz00_6037, BgL_lenz00_6038); } 
return 
BINT(BgL_tmpz00_8384);} } 

}



/* &ssl-connection-write1277 */
obj_t BGl_z62sslzd2connectionzd2write1277z62zz__ssl_sslz00(obj_t BgL_envz00_4920, obj_t BgL_sslz00_4921, obj_t BgL_bufferz00_4922, obj_t BgL_offsetz00_4923, obj_t BgL_lenz00_4924)
{
{ /* Llib/ssl.scm 953 */
{ /* Llib/ssl.scm 956 */
long BgL_tmpz00_8392;
{ /* Llib/ssl.scm 956 */
long BgL_offsetz00_6041;long BgL_lenz00_6042;
BgL_offsetz00_6041 = 
(long)CINT(BgL_offsetz00_4923); 
BgL_lenz00_6042 = 
(long)CINT(BgL_lenz00_4924); 
BgL_tmpz00_8392 = 
bgl_ssl_connection_write(
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_4921), 
BSTRING_TO_STRING(
((obj_t)BgL_bufferz00_4922)), BgL_offsetz00_6041, BgL_lenz00_6042); } 
return 
BINT(BgL_tmpz00_8392);} } 

}



/* &ssl-connection-read1275 */
obj_t BGl_z62sslzd2connectionzd2read1275z62zz__ssl_sslz00(obj_t BgL_envz00_4925, obj_t BgL_sslz00_4926, obj_t BgL_bufferz00_4927, obj_t BgL_offsetz00_4928, obj_t BgL_lenz00_4929)
{
{ /* Llib/ssl.scm 943 */
{ /* Llib/ssl.scm 946 */
long BgL_tmpz00_8400;
{ /* Llib/ssl.scm 946 */
long BgL_offsetz00_6045;long BgL_lenz00_6046;
BgL_offsetz00_6045 = 
(long)CINT(BgL_offsetz00_4928); 
BgL_lenz00_6046 = 
(long)CINT(BgL_lenz00_4929); 
BgL_tmpz00_8400 = 
bgl_ssl_connection_read(
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_4926), 
BSTRING_TO_STRING(
((obj_t)BgL_bufferz00_4927)), BgL_offsetz00_6045, BgL_lenz00_6046); } 
return 
BINT(BgL_tmpz00_8400);} } 

}



/* &ssl-connection-shutd1273 */
obj_t BGl_z62sslzd2connectionzd2shutd1273z62zz__ssl_sslz00(obj_t BgL_envz00_4930, obj_t BgL_sslz00_4931)
{
{ /* Llib/ssl.scm 933 */
return 
bgl_ssl_connection_shutdown(
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_4931));} 

}



/* &ssl-connection-close1271 */
obj_t BGl_z62sslzd2connectionzd2close1271z62zz__ssl_sslz00(obj_t BgL_envz00_4932, obj_t BgL_sslz00_4933)
{
{ /* Llib/ssl.scm 923 */
return 
BINT(
bgl_ssl_connection_close(
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_4933)));} 

}



/* &ssl-connection-start1269 */
obj_t BGl_z62sslzd2connectionzd2start1269z62zz__ssl_sslz00(obj_t BgL_envz00_4934, obj_t BgL_sslz00_4935)
{
{ /* Llib/ssl.scm 913 */
return 
BINT(
bgl_ssl_connection_start(
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_4935)));} 

}



/* &ssl-connection-init1267 */
obj_t BGl_z62sslzd2connectionzd2init1267z62zz__ssl_sslz00(obj_t BgL_envz00_4936, obj_t BgL_sslz00_4937)
{
{ /* Llib/ssl.scm 903 */
return 
bgl_ssl_connection_init(
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_4937));} 

}



/* &secure-context-set-o1265 */
obj_t BGl_z62securezd2contextzd2setzd2o1265zb0zz__ssl_sslz00(obj_t BgL_envz00_4938, obj_t BgL_scz00_4939, obj_t BgL_optionsz00_4940)
{
{ /* Llib/ssl.scm 891 */
{ /* Llib/ssl.scm 894 */
bool_t BgL_tmpz00_8418;
{ /* Llib/ssl.scm 894 */
int BgL_optionsz00_6052;
BgL_optionsz00_6052 = 
CINT(BgL_optionsz00_4940); 
{ /* Llib/ssl.scm 895 */
void * BgL_arg2227z00_6053;
BgL_arg2227z00_6053 = 
(((BgL_securezd2contextzd2_bglt)COBJECT(
((BgL_securezd2contextzd2_bglt)BgL_scz00_4939)))->BgL_z42nativez42); 
SSL_CTX_set_options(BgL_arg2227z00_6053, BgL_optionsz00_6052); BUNSPEC; } 
BgL_tmpz00_8418 = ((bool_t)1); } 
return 
BBOOL(BgL_tmpz00_8418);} } 

}



/* &secure-context-set-c1263 */
obj_t BGl_z62securezd2contextzd2setzd2c1263zb0zz__ssl_sslz00(obj_t BgL_envz00_4941, obj_t BgL_scz00_4942, obj_t BgL_ciphersz00_4943)
{
{ /* Llib/ssl.scm 879 */
{ /* Llib/ssl.scm 882 */
bool_t BgL_tmpz00_8424;
{ /* Llib/ssl.scm 883 */
char * BgL_auxz00_8428;void * BgL_tmpz00_8425;
BgL_auxz00_8428 = 
BSTRING_TO_STRING(
((obj_t)BgL_ciphersz00_4943)); 
BgL_tmpz00_8425 = 
(((BgL_securezd2contextzd2_bglt)COBJECT(
((BgL_securezd2contextzd2_bglt)BgL_scz00_4942)))->BgL_z42nativez42); 
SSL_CTX_set_cipher_list(BgL_tmpz00_8425, BgL_auxz00_8428); } 
BgL_tmpz00_8424 = ((bool_t)1); 
return 
BBOOL(BgL_tmpz00_8424);} } 

}



/* &secure-context-load-1261 */
obj_t BGl_z62securezd2contextzd2loadzd21261zb0zz__ssl_sslz00(obj_t BgL_envz00_4944, obj_t BgL_scz00_4945, obj_t BgL_pfxz00_4946, obj_t BgL_passz00_4947)
{
{ /* Llib/ssl.scm 869 */
return 
BBOOL(
bgl_load_pkcs12(
((BgL_securezd2contextzd2_bglt)BgL_scz00_4945), 
((obj_t)BgL_pfxz00_4946), BgL_passz00_4947));} 

}



/* &secure-context-set-s1259 */
obj_t BGl_z62securezd2contextzd2setzd2s1259zb0zz__ssl_sslz00(obj_t BgL_envz00_4948, obj_t BgL_scz00_4949, obj_t BgL_sicz00_4950, obj_t BgL_offsetz00_4951, obj_t BgL_lenz00_4952)
{
{ /* Llib/ssl.scm 859 */
{ /* Llib/ssl.scm 862 */
bool_t BgL_tmpz00_8437;
{ /* Llib/ssl.scm 862 */
long BgL_offsetz00_6060;long BgL_lenz00_6061;
BgL_offsetz00_6060 = 
(long)CINT(BgL_offsetz00_4951); 
BgL_lenz00_6061 = 
(long)CINT(BgL_lenz00_4952); 
BgL_tmpz00_8437 = 
bgl_ssl_ctx_set_session_id_context(
((BgL_securezd2contextzd2_bglt)BgL_scz00_4949), 
((obj_t)BgL_sicz00_4950), BgL_offsetz00_6060, BgL_lenz00_6061); } 
return 
BBOOL(BgL_tmpz00_8437);} } 

}



/* &secure-context-set-c1257 */
obj_t BGl_z62securezd2contextzd2setzd2c1257zb0zz__ssl_sslz00(obj_t BgL_envz00_4953, obj_t BgL_scz00_4954, obj_t BgL_certz00_4955, obj_t BgL_offsetz00_4956, obj_t BgL_lenz00_4957)
{
{ /* Llib/ssl.scm 849 */
{ /* Llib/ssl.scm 852 */
bool_t BgL_tmpz00_8444;
{ /* Llib/ssl.scm 852 */
long BgL_offsetz00_6064;long BgL_lenz00_6065;
BgL_offsetz00_6064 = 
(long)CINT(BgL_offsetz00_4956); 
BgL_lenz00_6065 = 
(long)CINT(BgL_lenz00_4957); 
BgL_tmpz00_8444 = 
bgl_ssl_ctx_set_cert(
((BgL_securezd2contextzd2_bglt)BgL_scz00_4954), 
((obj_t)BgL_certz00_4955), BgL_offsetz00_6064, BgL_lenz00_6065); } 
return 
BBOOL(BgL_tmpz00_8444);} } 

}



/* &secure-context-set-k1249 */
obj_t BGl_z62securezd2contextzd2setzd2k1249zb0zz__ssl_sslz00(obj_t BgL_envz00_4958, obj_t BgL_scz00_4959, obj_t BgL_certz00_4960, obj_t BgL_offsetz00_4961, obj_t BgL_lenz00_4962, obj_t BgL_passphrasez00_4963)
{
{ /* Llib/ssl.scm 839 */
return 
BBOOL(
bgl_ssl_ctx_set_key(
((BgL_securezd2contextzd2_bglt)BgL_scz00_4959), BgL_certz00_4960, 
(long)CINT(BgL_offsetz00_4961), 
(long)CINT(BgL_lenz00_4962), BgL_passphrasez00_4963));} 

}



/* &secure-context-add-c1247 */
obj_t BGl_z62securezd2contextzd2addzd2c1247zb0zz__ssl_sslz00(obj_t BgL_envz00_4964, obj_t BgL_scz00_4965, obj_t BgL_certz00_4966, obj_t BgL_offsetz00_4967, obj_t BgL_lenz00_4968)
{
{ /* Llib/ssl.scm 829 */
{ /* Llib/ssl.scm 832 */
bool_t BgL_tmpz00_8456;
{ /* Llib/ssl.scm 832 */
long BgL_offsetz00_6068;long BgL_lenz00_6069;
BgL_offsetz00_6068 = 
(long)CINT(BgL_offsetz00_4967); 
BgL_lenz00_6069 = 
(long)CINT(BgL_lenz00_4968); 
BgL_tmpz00_8456 = 
bgl_ssl_ctx_add_crl(
((BgL_securezd2contextzd2_bglt)BgL_scz00_4965), 
((obj_t)BgL_certz00_4966), BgL_offsetz00_6068, BgL_lenz00_6069); } 
return 
BBOOL(BgL_tmpz00_8456);} } 

}



/* &secure-context-add-c1245 */
obj_t BGl_z62securezd2contextzd2addzd2c1245zb0zz__ssl_sslz00(obj_t BgL_envz00_4969, obj_t BgL_scz00_4970, obj_t BgL_certz00_4971, obj_t BgL_offsetz00_4972, obj_t BgL_lenz00_4973)
{
{ /* Llib/ssl.scm 819 */
{ /* Llib/ssl.scm 822 */
bool_t BgL_tmpz00_8463;
{ /* Llib/ssl.scm 822 */
long BgL_offsetz00_6072;long BgL_lenz00_6073;
BgL_offsetz00_6072 = 
(long)CINT(BgL_offsetz00_4972); 
BgL_lenz00_6073 = 
(long)CINT(BgL_lenz00_4973); 
BgL_tmpz00_8463 = 
bgl_ssl_ctx_add_ca_cert(
((BgL_securezd2contextzd2_bglt)BgL_scz00_4970), 
((obj_t)BgL_certz00_4971), BgL_offsetz00_6072, BgL_lenz00_6073); } 
return 
BBOOL(BgL_tmpz00_8463);} } 

}



/* &secure-context-add-r1243 */
obj_t BGl_z62securezd2contextzd2addzd2r1243zb0zz__ssl_sslz00(obj_t BgL_envz00_4974, obj_t BgL_scz00_4975)
{
{ /* Llib/ssl.scm 809 */
return 
BBOOL(
bgl_ssl_ctx_add_root_certs(
((BgL_securezd2contextzd2_bglt)BgL_scz00_4975)));} 

}



/* &secure-context-close1241 */
obj_t BGl_z62securezd2contextzd2close1241z62zz__ssl_sslz00(obj_t BgL_envz00_4976, obj_t BgL_scz00_4977)
{
{ /* Llib/ssl.scm 799 */
return 
bgl_ssl_ctx_close(
((BgL_securezd2contextzd2_bglt)BgL_scz00_4977));} 

}



/* &secure-context-init1239 */
obj_t BGl_z62securezd2contextzd2init1239z62zz__ssl_sslz00(obj_t BgL_envz00_4978, obj_t BgL_scz00_4979)
{
{ /* Llib/ssl.scm 789 */
return 
bgl_ssl_ctx_init(
((BgL_securezd2contextzd2_bglt)BgL_scz00_4979));} 

}



/* secure-context-init */
BGL_EXPORTED_DEF obj_t BGl_securezd2contextzd2initz00zz__ssl_sslz00(BgL_securezd2contextzd2_bglt BgL_scz00_42)
{
{ /* Llib/ssl.scm 789 */
{ /* Llib/ssl.scm 789 */
obj_t BgL_method1240z00_1710;
{ /* Llib/ssl.scm 789 */
obj_t BgL_res2391z00_2189;
{ /* Llib/ssl.scm 789 */
long BgL_objzd2classzd2numz00_2154;
{ /* Llib/ssl.scm 789 */
long BgL_res2381z00_2157;
BgL_res2381z00_2157 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_scz00_42)); 
BgL_objzd2classzd2numz00_2154 = BgL_res2381z00_2157; } 
{ /* Llib/ssl.scm 789 */
obj_t BgL_arg1745z00_2155;
BgL_arg1745z00_2155 = 
PROCEDURE_REF(BGl_securezd2contextzd2initzd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 789 */
int BgL_offsetz00_2159;
BgL_offsetz00_2159 = 
(int)(BgL_objzd2classzd2numz00_2154); 
{ /* Llib/ssl.scm 789 */
long BgL_offsetz00_2160;
BgL_offsetz00_2160 = 
(
(long)(BgL_offsetz00_2159)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 789 */
long BgL_modz00_2161;
BgL_modz00_2161 = 
(BgL_offsetz00_2160 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 789 */
long BgL_restz00_2163;
BgL_restz00_2163 = 
(BgL_offsetz00_2160 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 789 */

{ /* Llib/ssl.scm 789 */
obj_t BgL_bucketz00_2165;
BgL_bucketz00_2165 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_2155),BgL_modz00_2161); 
BgL_res2391z00_2189 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2165),BgL_restz00_2163); } } } } } } } } 
BgL_method1240z00_1710 = BgL_res2391z00_2189; } 
return 
PROCEDURE_ENTRY(BgL_method1240z00_1710)(BgL_method1240z00_1710, 
((obj_t)BgL_scz00_42), BEOA);} } 

}



/* &secure-context-init */
obj_t BGl_z62securezd2contextzd2initz62zz__ssl_sslz00(obj_t BgL_envz00_4730, obj_t BgL_scz00_4731)
{
{ /* Llib/ssl.scm 789 */
{ /* Llib/ssl.scm 789 */
BgL_securezd2contextzd2_bglt BgL_auxz00_8507;
if(
BGl_isazf3zf3zz__objectz00(BgL_scz00_4731, BGl_securezd2contextzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 789 */
BgL_auxz00_8507 = 
((BgL_securezd2contextzd2_bglt)BgL_scz00_4731)
; }  else 
{ 
obj_t BgL_auxz00_8511;
BgL_auxz00_8511 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)32305)), BGl_string3695z00zz__ssl_sslz00, BGl_string3394z00zz__ssl_sslz00, BgL_scz00_4731); 
FAILURE(BgL_auxz00_8511,BFALSE,BFALSE);} 
return 
BGl_securezd2contextzd2initz00zz__ssl_sslz00(BgL_auxz00_8507);} } 

}



/* secure-context-close */
BGL_EXPORTED_DEF obj_t BGl_securezd2contextzd2closez00zz__ssl_sslz00(BgL_securezd2contextzd2_bglt BgL_scz00_43)
{
{ /* Llib/ssl.scm 799 */
{ /* Llib/ssl.scm 799 */
obj_t BgL_method1242z00_1711;
{ /* Llib/ssl.scm 799 */
obj_t BgL_res2402z00_2226;
{ /* Llib/ssl.scm 799 */
long BgL_objzd2classzd2numz00_2191;
{ /* Llib/ssl.scm 799 */
long BgL_res2392z00_2194;
BgL_res2392z00_2194 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_scz00_43)); 
BgL_objzd2classzd2numz00_2191 = BgL_res2392z00_2194; } 
{ /* Llib/ssl.scm 799 */
obj_t BgL_arg1745z00_2192;
BgL_arg1745z00_2192 = 
PROCEDURE_REF(BGl_securezd2contextzd2closezd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 799 */
int BgL_offsetz00_2196;
BgL_offsetz00_2196 = 
(int)(BgL_objzd2classzd2numz00_2191); 
{ /* Llib/ssl.scm 799 */
long BgL_offsetz00_2197;
BgL_offsetz00_2197 = 
(
(long)(BgL_offsetz00_2196)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 799 */
long BgL_modz00_2198;
BgL_modz00_2198 = 
(BgL_offsetz00_2197 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 799 */
long BgL_restz00_2200;
BgL_restz00_2200 = 
(BgL_offsetz00_2197 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 799 */

{ /* Llib/ssl.scm 799 */
obj_t BgL_bucketz00_2202;
BgL_bucketz00_2202 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_2192),BgL_modz00_2198); 
BgL_res2402z00_2226 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2202),BgL_restz00_2200); } } } } } } } } 
BgL_method1242z00_1711 = BgL_res2402z00_2226; } 
return 
PROCEDURE_ENTRY(BgL_method1242z00_1711)(BgL_method1242z00_1711, 
((obj_t)BgL_scz00_43), BEOA);} } 

}



/* &secure-context-close */
obj_t BGl_z62securezd2contextzd2closez62zz__ssl_sslz00(obj_t BgL_envz00_4980, obj_t BgL_scz00_4981)
{
{ /* Llib/ssl.scm 799 */
{ /* Llib/ssl.scm 799 */
BgL_securezd2contextzd2_bglt BgL_auxz00_8546;
if(
BGl_isazf3zf3zz__objectz00(BgL_scz00_4981, BGl_securezd2contextzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 799 */
BgL_auxz00_8546 = 
((BgL_securezd2contextzd2_bglt)BgL_scz00_4981)
; }  else 
{ 
obj_t BgL_auxz00_8550;
BgL_auxz00_8550 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)32681)), BGl_string3696z00zz__ssl_sslz00, BGl_string3394z00zz__ssl_sslz00, BgL_scz00_4981); 
FAILURE(BgL_auxz00_8550,BFALSE,BFALSE);} 
return 
BGl_securezd2contextzd2closez00zz__ssl_sslz00(BgL_auxz00_8546);} } 

}



/* secure-context-add-root-certs! */
BGL_EXPORTED_DEF bool_t BGl_securezd2contextzd2addzd2rootzd2certsz12z12zz__ssl_sslz00(BgL_securezd2contextzd2_bglt BgL_scz00_44)
{
{ /* Llib/ssl.scm 809 */
{ /* Llib/ssl.scm 809 */
obj_t BgL_method1244z00_1712;
{ /* Llib/ssl.scm 809 */
obj_t BgL_res2413z00_2263;
{ /* Llib/ssl.scm 809 */
long BgL_objzd2classzd2numz00_2228;
{ /* Llib/ssl.scm 809 */
long BgL_res2403z00_2231;
BgL_res2403z00_2231 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_scz00_44)); 
BgL_objzd2classzd2numz00_2228 = BgL_res2403z00_2231; } 
{ /* Llib/ssl.scm 809 */
obj_t BgL_arg1745z00_2229;
BgL_arg1745z00_2229 = 
PROCEDURE_REF(BGl_securezd2contextzd2addzd2rootzd2certsz12zd2envzc0zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 809 */
int BgL_offsetz00_2233;
BgL_offsetz00_2233 = 
(int)(BgL_objzd2classzd2numz00_2228); 
{ /* Llib/ssl.scm 809 */
long BgL_offsetz00_2234;
BgL_offsetz00_2234 = 
(
(long)(BgL_offsetz00_2233)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 809 */
long BgL_modz00_2235;
BgL_modz00_2235 = 
(BgL_offsetz00_2234 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 809 */
long BgL_restz00_2237;
BgL_restz00_2237 = 
(BgL_offsetz00_2234 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 809 */

{ /* Llib/ssl.scm 809 */
obj_t BgL_bucketz00_2239;
BgL_bucketz00_2239 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_2229),BgL_modz00_2235); 
BgL_res2413z00_2263 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2239),BgL_restz00_2237); } } } } } } } } 
BgL_method1244z00_1712 = BgL_res2413z00_2263; } 
return 
CBOOL(
PROCEDURE_ENTRY(BgL_method1244z00_1712)(BgL_method1244z00_1712, 
((obj_t)BgL_scz00_44), BEOA));} } 

}



/* &secure-context-add-root-certs! */
obj_t BGl_z62securezd2contextzd2addzd2rootzd2certsz12z70zz__ssl_sslz00(obj_t BgL_envz00_4982, obj_t BgL_scz00_4983)
{
{ /* Llib/ssl.scm 809 */
{ /* Llib/ssl.scm 809 */
bool_t BgL_tmpz00_8586;
{ /* Llib/ssl.scm 809 */
BgL_securezd2contextzd2_bglt BgL_auxz00_8587;
if(
BGl_isazf3zf3zz__objectz00(BgL_scz00_4983, BGl_securezd2contextzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 809 */
BgL_auxz00_8587 = 
((BgL_securezd2contextzd2_bglt)BgL_scz00_4983)
; }  else 
{ 
obj_t BgL_auxz00_8591;
BgL_auxz00_8591 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)33059)), BGl_string3697z00zz__ssl_sslz00, BGl_string3394z00zz__ssl_sslz00, BgL_scz00_4983); 
FAILURE(BgL_auxz00_8591,BFALSE,BFALSE);} 
BgL_tmpz00_8586 = 
BGl_securezd2contextzd2addzd2rootzd2certsz12z12zz__ssl_sslz00(BgL_auxz00_8587); } 
return 
BBOOL(BgL_tmpz00_8586);} } 

}



/* secure-context-add-ca-cert! */
BGL_EXPORTED_DEF bool_t BGl_securezd2contextzd2addzd2cazd2certz12z12zz__ssl_sslz00(BgL_securezd2contextzd2_bglt BgL_scz00_45, obj_t BgL_certz00_46, long BgL_offsetz00_47, long BgL_lenz00_48)
{
{ /* Llib/ssl.scm 819 */
{ /* Llib/ssl.scm 819 */
obj_t BgL_method1246z00_1713;
{ /* Llib/ssl.scm 819 */
obj_t BgL_res2424z00_2300;
{ /* Llib/ssl.scm 819 */
long BgL_objzd2classzd2numz00_2265;
{ /* Llib/ssl.scm 819 */
long BgL_res2414z00_2268;
BgL_res2414z00_2268 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_scz00_45)); 
BgL_objzd2classzd2numz00_2265 = BgL_res2414z00_2268; } 
{ /* Llib/ssl.scm 819 */
obj_t BgL_arg1745z00_2266;
BgL_arg1745z00_2266 = 
PROCEDURE_REF(BGl_securezd2contextzd2addzd2cazd2certz12zd2envzc0zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 819 */
int BgL_offsetz00_2270;
BgL_offsetz00_2270 = 
(int)(BgL_objzd2classzd2numz00_2265); 
{ /* Llib/ssl.scm 819 */
long BgL_offsetz00_2271;
BgL_offsetz00_2271 = 
(
(long)(BgL_offsetz00_2270)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 819 */
long BgL_modz00_2272;
BgL_modz00_2272 = 
(BgL_offsetz00_2271 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 819 */
long BgL_restz00_2274;
BgL_restz00_2274 = 
(BgL_offsetz00_2271 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 819 */

{ /* Llib/ssl.scm 819 */
obj_t BgL_bucketz00_2276;
BgL_bucketz00_2276 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_2266),BgL_modz00_2272); 
BgL_res2424z00_2300 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2276),BgL_restz00_2274); } } } } } } } } 
BgL_method1246z00_1713 = BgL_res2424z00_2300; } 
return 
CBOOL(
PROCEDURE_ENTRY(BgL_method1246z00_1713)(BgL_method1246z00_1713, 
((obj_t)BgL_scz00_45), BgL_certz00_46, 
BINT(BgL_offsetz00_47), 
BINT(BgL_lenz00_48), BEOA));} } 

}



/* &secure-context-add-ca-cert! */
obj_t BGl_z62securezd2contextzd2addzd2cazd2certz12z70zz__ssl_sslz00(obj_t BgL_envz00_4984, obj_t BgL_scz00_4985, obj_t BgL_certz00_4986, obj_t BgL_offsetz00_4987, obj_t BgL_lenz00_4988)
{
{ /* Llib/ssl.scm 819 */
{ /* Llib/ssl.scm 819 */
bool_t BgL_tmpz00_8633;
{ /* Llib/ssl.scm 819 */
long BgL_auxz00_8658;long BgL_auxz00_8649;obj_t BgL_auxz00_8642;BgL_securezd2contextzd2_bglt BgL_auxz00_8634;
{ /* Llib/ssl.scm 819 */
obj_t BgL_tmpz00_8659;
if(
INTEGERP(BgL_lenz00_4988))
{ /* Llib/ssl.scm 819 */
BgL_tmpz00_8659 = BgL_lenz00_4988
; }  else 
{ 
obj_t BgL_auxz00_8662;
BgL_auxz00_8662 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)33456)), BGl_string3698z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_lenz00_4988); 
FAILURE(BgL_auxz00_8662,BFALSE,BFALSE);} 
BgL_auxz00_8658 = 
(long)CINT(BgL_tmpz00_8659); } 
{ /* Llib/ssl.scm 819 */
obj_t BgL_tmpz00_8650;
if(
INTEGERP(BgL_offsetz00_4987))
{ /* Llib/ssl.scm 819 */
BgL_tmpz00_8650 = BgL_offsetz00_4987
; }  else 
{ 
obj_t BgL_auxz00_8653;
BgL_auxz00_8653 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)33456)), BGl_string3698z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_offsetz00_4987); 
FAILURE(BgL_auxz00_8653,BFALSE,BFALSE);} 
BgL_auxz00_8649 = 
(long)CINT(BgL_tmpz00_8650); } 
if(
STRINGP(BgL_certz00_4986))
{ /* Llib/ssl.scm 819 */
BgL_auxz00_8642 = BgL_certz00_4986
; }  else 
{ 
obj_t BgL_auxz00_8645;
BgL_auxz00_8645 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)33456)), BGl_string3698z00zz__ssl_sslz00, BGl_string3369z00zz__ssl_sslz00, BgL_certz00_4986); 
FAILURE(BgL_auxz00_8645,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_scz00_4985, BGl_securezd2contextzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 819 */
BgL_auxz00_8634 = 
((BgL_securezd2contextzd2_bglt)BgL_scz00_4985)
; }  else 
{ 
obj_t BgL_auxz00_8638;
BgL_auxz00_8638 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)33456)), BGl_string3698z00zz__ssl_sslz00, BGl_string3394z00zz__ssl_sslz00, BgL_scz00_4985); 
FAILURE(BgL_auxz00_8638,BFALSE,BFALSE);} 
BgL_tmpz00_8633 = 
BGl_securezd2contextzd2addzd2cazd2certz12z12zz__ssl_sslz00(BgL_auxz00_8634, BgL_auxz00_8642, BgL_auxz00_8649, BgL_auxz00_8658); } 
return 
BBOOL(BgL_tmpz00_8633);} } 

}



/* secure-context-add-crl! */
BGL_EXPORTED_DEF bool_t BGl_securezd2contextzd2addzd2crlz12zc0zz__ssl_sslz00(BgL_securezd2contextzd2_bglt BgL_scz00_49, obj_t BgL_certz00_50, long BgL_offsetz00_51, long BgL_lenz00_52)
{
{ /* Llib/ssl.scm 829 */
{ /* Llib/ssl.scm 829 */
obj_t BgL_method1248z00_1714;
{ /* Llib/ssl.scm 829 */
obj_t BgL_res2435z00_2337;
{ /* Llib/ssl.scm 829 */
long BgL_objzd2classzd2numz00_2302;
{ /* Llib/ssl.scm 829 */
long BgL_res2425z00_2305;
BgL_res2425z00_2305 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_scz00_49)); 
BgL_objzd2classzd2numz00_2302 = BgL_res2425z00_2305; } 
{ /* Llib/ssl.scm 829 */
obj_t BgL_arg1745z00_2303;
BgL_arg1745z00_2303 = 
PROCEDURE_REF(BGl_securezd2contextzd2addzd2crlz12zd2envz12zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 829 */
int BgL_offsetz00_2307;
BgL_offsetz00_2307 = 
(int)(BgL_objzd2classzd2numz00_2302); 
{ /* Llib/ssl.scm 829 */
long BgL_offsetz00_2308;
BgL_offsetz00_2308 = 
(
(long)(BgL_offsetz00_2307)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 829 */
long BgL_modz00_2309;
BgL_modz00_2309 = 
(BgL_offsetz00_2308 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 829 */
long BgL_restz00_2311;
BgL_restz00_2311 = 
(BgL_offsetz00_2308 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 829 */

{ /* Llib/ssl.scm 829 */
obj_t BgL_bucketz00_2313;
BgL_bucketz00_2313 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_2303),BgL_modz00_2309); 
BgL_res2435z00_2337 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2313),BgL_restz00_2311); } } } } } } } } 
BgL_method1248z00_1714 = BgL_res2435z00_2337; } 
return 
CBOOL(
PROCEDURE_ENTRY(BgL_method1248z00_1714)(BgL_method1248z00_1714, 
((obj_t)BgL_scz00_49), BgL_certz00_50, 
BINT(BgL_offsetz00_51), 
BINT(BgL_lenz00_52), BEOA));} } 

}



/* &secure-context-add-crl! */
obj_t BGl_z62securezd2contextzd2addzd2crlz12za2zz__ssl_sslz00(obj_t BgL_envz00_4989, obj_t BgL_scz00_4990, obj_t BgL_certz00_4991, obj_t BgL_offsetz00_4992, obj_t BgL_lenz00_4993)
{
{ /* Llib/ssl.scm 829 */
{ /* Llib/ssl.scm 829 */
bool_t BgL_tmpz00_8705;
{ /* Llib/ssl.scm 829 */
long BgL_auxz00_8730;long BgL_auxz00_8721;obj_t BgL_auxz00_8714;BgL_securezd2contextzd2_bglt BgL_auxz00_8706;
{ /* Llib/ssl.scm 829 */
obj_t BgL_tmpz00_8731;
if(
INTEGERP(BgL_lenz00_4993))
{ /* Llib/ssl.scm 829 */
BgL_tmpz00_8731 = BgL_lenz00_4993
; }  else 
{ 
obj_t BgL_auxz00_8734;
BgL_auxz00_8734 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)33879)), BGl_string3699z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_lenz00_4993); 
FAILURE(BgL_auxz00_8734,BFALSE,BFALSE);} 
BgL_auxz00_8730 = 
(long)CINT(BgL_tmpz00_8731); } 
{ /* Llib/ssl.scm 829 */
obj_t BgL_tmpz00_8722;
if(
INTEGERP(BgL_offsetz00_4992))
{ /* Llib/ssl.scm 829 */
BgL_tmpz00_8722 = BgL_offsetz00_4992
; }  else 
{ 
obj_t BgL_auxz00_8725;
BgL_auxz00_8725 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)33879)), BGl_string3699z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_offsetz00_4992); 
FAILURE(BgL_auxz00_8725,BFALSE,BFALSE);} 
BgL_auxz00_8721 = 
(long)CINT(BgL_tmpz00_8722); } 
if(
STRINGP(BgL_certz00_4991))
{ /* Llib/ssl.scm 829 */
BgL_auxz00_8714 = BgL_certz00_4991
; }  else 
{ 
obj_t BgL_auxz00_8717;
BgL_auxz00_8717 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)33879)), BGl_string3699z00zz__ssl_sslz00, BGl_string3369z00zz__ssl_sslz00, BgL_certz00_4991); 
FAILURE(BgL_auxz00_8717,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_scz00_4990, BGl_securezd2contextzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 829 */
BgL_auxz00_8706 = 
((BgL_securezd2contextzd2_bglt)BgL_scz00_4990)
; }  else 
{ 
obj_t BgL_auxz00_8710;
BgL_auxz00_8710 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)33879)), BGl_string3699z00zz__ssl_sslz00, BGl_string3394z00zz__ssl_sslz00, BgL_scz00_4990); 
FAILURE(BgL_auxz00_8710,BFALSE,BFALSE);} 
BgL_tmpz00_8705 = 
BGl_securezd2contextzd2addzd2crlz12zc0zz__ssl_sslz00(BgL_auxz00_8706, BgL_auxz00_8714, BgL_auxz00_8721, BgL_auxz00_8730); } 
return 
BBOOL(BgL_tmpz00_8705);} } 

}



/* secure-context-set-key! */
BGL_EXPORTED_DEF bool_t BGl_securezd2contextzd2setzd2keyz12zc0zz__ssl_sslz00(BgL_securezd2contextzd2_bglt BgL_scz00_53, obj_t BgL_certz00_54, long BgL_offsetz00_55, long BgL_lenz00_56, obj_t BgL_passphrasez00_57)
{
{ /* Llib/ssl.scm 839 */
{ /* Llib/ssl.scm 353 */
obj_t BgL_method1250z00_1715;
{ /* Llib/ssl.scm 353 */
obj_t BgL_res2446z00_2374;
{ /* Llib/ssl.scm 353 */
long BgL_objzd2classzd2numz00_2339;
{ /* Llib/ssl.scm 353 */
long BgL_res2436z00_2342;
BgL_res2436z00_2342 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_scz00_53)); 
BgL_objzd2classzd2numz00_2339 = BgL_res2436z00_2342; } 
{ /* Llib/ssl.scm 353 */
obj_t BgL_arg1745z00_2340;
BgL_arg1745z00_2340 = 
PROCEDURE_REF(BGl_securezd2contextzd2setzd2keyz12zd2envz12zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 353 */
int BgL_offsetz00_2344;
BgL_offsetz00_2344 = 
(int)(BgL_objzd2classzd2numz00_2339); 
{ /* Llib/ssl.scm 353 */
long BgL_offsetz00_2345;
BgL_offsetz00_2345 = 
(
(long)(BgL_offsetz00_2344)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 353 */
long BgL_modz00_2346;
BgL_modz00_2346 = 
(BgL_offsetz00_2345 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 353 */
long BgL_restz00_2348;
BgL_restz00_2348 = 
(BgL_offsetz00_2345 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 353 */

{ /* Llib/ssl.scm 353 */
obj_t BgL_bucketz00_2350;
BgL_bucketz00_2350 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_2340),BgL_modz00_2346); 
BgL_res2446z00_2374 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2350),BgL_restz00_2348); } } } } } } } } 
BgL_method1250z00_1715 = BgL_res2446z00_2374; } 
return 
CBOOL(
PROCEDURE_ENTRY(BgL_method1250z00_1715)(BgL_method1250z00_1715, 
((obj_t)BgL_scz00_53), BgL_certz00_54, 
BINT(BgL_offsetz00_55), 
BINT(BgL_lenz00_56), BgL_passphrasez00_57, BEOA));} } 

}



/* secure-context-set-cert! */
BGL_EXPORTED_DEF bool_t BGl_securezd2contextzd2setzd2certz12zc0zz__ssl_sslz00(BgL_securezd2contextzd2_bglt BgL_scz00_60, obj_t BgL_certz00_61, long BgL_offsetz00_62, long BgL_lenz00_63)
{
{ /* Llib/ssl.scm 849 */
{ /* Llib/ssl.scm 849 */
obj_t BgL_method1258z00_1716;
{ /* Llib/ssl.scm 849 */
obj_t BgL_res2457z00_2411;
{ /* Llib/ssl.scm 849 */
long BgL_objzd2classzd2numz00_2376;
{ /* Llib/ssl.scm 849 */
long BgL_res2447z00_2379;
BgL_res2447z00_2379 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_scz00_60)); 
BgL_objzd2classzd2numz00_2376 = BgL_res2447z00_2379; } 
{ /* Llib/ssl.scm 849 */
obj_t BgL_arg1745z00_2377;
BgL_arg1745z00_2377 = 
PROCEDURE_REF(BGl_securezd2contextzd2setzd2certz12zd2envz12zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 849 */
int BgL_offsetz00_2381;
BgL_offsetz00_2381 = 
(int)(BgL_objzd2classzd2numz00_2376); 
{ /* Llib/ssl.scm 849 */
long BgL_offsetz00_2382;
BgL_offsetz00_2382 = 
(
(long)(BgL_offsetz00_2381)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 849 */
long BgL_modz00_2383;
BgL_modz00_2383 = 
(BgL_offsetz00_2382 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 849 */
long BgL_restz00_2385;
BgL_restz00_2385 = 
(BgL_offsetz00_2382 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 849 */

{ /* Llib/ssl.scm 849 */
obj_t BgL_bucketz00_2387;
BgL_bucketz00_2387 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_2377),BgL_modz00_2383); 
BgL_res2457z00_2411 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2387),BgL_restz00_2385); } } } } } } } } 
BgL_method1258z00_1716 = BgL_res2457z00_2411; } 
return 
CBOOL(
PROCEDURE_ENTRY(BgL_method1258z00_1716)(BgL_method1258z00_1716, 
((obj_t)BgL_scz00_60), BgL_certz00_61, 
BINT(BgL_offsetz00_62), 
BINT(BgL_lenz00_63), BEOA));} } 

}



/* &secure-context-set-cert! */
obj_t BGl_z62securezd2contextzd2setzd2certz12za2zz__ssl_sslz00(obj_t BgL_envz00_4994, obj_t BgL_scz00_4995, obj_t BgL_certz00_4996, obj_t BgL_offsetz00_4997, obj_t BgL_lenz00_4998)
{
{ /* Llib/ssl.scm 849 */
{ /* Llib/ssl.scm 849 */
bool_t BgL_tmpz00_8814;
{ /* Llib/ssl.scm 849 */
long BgL_auxz00_8839;long BgL_auxz00_8830;obj_t BgL_auxz00_8823;BgL_securezd2contextzd2_bglt BgL_auxz00_8815;
{ /* Llib/ssl.scm 849 */
obj_t BgL_tmpz00_8840;
if(
INTEGERP(BgL_lenz00_4998))
{ /* Llib/ssl.scm 849 */
BgL_tmpz00_8840 = BgL_lenz00_4998
; }  else 
{ 
obj_t BgL_auxz00_8843;
BgL_auxz00_8843 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)34763)), BGl_string3700z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_lenz00_4998); 
FAILURE(BgL_auxz00_8843,BFALSE,BFALSE);} 
BgL_auxz00_8839 = 
(long)CINT(BgL_tmpz00_8840); } 
{ /* Llib/ssl.scm 849 */
obj_t BgL_tmpz00_8831;
if(
INTEGERP(BgL_offsetz00_4997))
{ /* Llib/ssl.scm 849 */
BgL_tmpz00_8831 = BgL_offsetz00_4997
; }  else 
{ 
obj_t BgL_auxz00_8834;
BgL_auxz00_8834 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)34763)), BGl_string3700z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_offsetz00_4997); 
FAILURE(BgL_auxz00_8834,BFALSE,BFALSE);} 
BgL_auxz00_8830 = 
(long)CINT(BgL_tmpz00_8831); } 
if(
STRINGP(BgL_certz00_4996))
{ /* Llib/ssl.scm 849 */
BgL_auxz00_8823 = BgL_certz00_4996
; }  else 
{ 
obj_t BgL_auxz00_8826;
BgL_auxz00_8826 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)34763)), BGl_string3700z00zz__ssl_sslz00, BGl_string3369z00zz__ssl_sslz00, BgL_certz00_4996); 
FAILURE(BgL_auxz00_8826,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_scz00_4995, BGl_securezd2contextzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 849 */
BgL_auxz00_8815 = 
((BgL_securezd2contextzd2_bglt)BgL_scz00_4995)
; }  else 
{ 
obj_t BgL_auxz00_8819;
BgL_auxz00_8819 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)34763)), BGl_string3700z00zz__ssl_sslz00, BGl_string3394z00zz__ssl_sslz00, BgL_scz00_4995); 
FAILURE(BgL_auxz00_8819,BFALSE,BFALSE);} 
BgL_tmpz00_8814 = 
BGl_securezd2contextzd2setzd2certz12zc0zz__ssl_sslz00(BgL_auxz00_8815, BgL_auxz00_8823, BgL_auxz00_8830, BgL_auxz00_8839); } 
return 
BBOOL(BgL_tmpz00_8814);} } 

}



/* secure-context-set-session-id-context! */
BGL_EXPORTED_DEF bool_t BGl_securezd2contextzd2setzd2sessionzd2idzd2contextz12zc0zz__ssl_sslz00(BgL_securezd2contextzd2_bglt BgL_scz00_64, obj_t BgL_sicz00_65, long BgL_offsetz00_66, long BgL_lenz00_67)
{
{ /* Llib/ssl.scm 859 */
{ /* Llib/ssl.scm 859 */
obj_t BgL_method1260z00_1717;
{ /* Llib/ssl.scm 859 */
obj_t BgL_res2468z00_2448;
{ /* Llib/ssl.scm 859 */
long BgL_objzd2classzd2numz00_2413;
{ /* Llib/ssl.scm 859 */
long BgL_res2458z00_2416;
BgL_res2458z00_2416 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_scz00_64)); 
BgL_objzd2classzd2numz00_2413 = BgL_res2458z00_2416; } 
{ /* Llib/ssl.scm 859 */
obj_t BgL_arg1745z00_2414;
BgL_arg1745z00_2414 = 
PROCEDURE_REF(BGl_securezd2contextzd2setzd2sessionzd2idzd2contextz12zd2envz12zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 859 */
int BgL_offsetz00_2418;
BgL_offsetz00_2418 = 
(int)(BgL_objzd2classzd2numz00_2413); 
{ /* Llib/ssl.scm 859 */
long BgL_offsetz00_2419;
BgL_offsetz00_2419 = 
(
(long)(BgL_offsetz00_2418)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 859 */
long BgL_modz00_2420;
BgL_modz00_2420 = 
(BgL_offsetz00_2419 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 859 */
long BgL_restz00_2422;
BgL_restz00_2422 = 
(BgL_offsetz00_2419 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 859 */

{ /* Llib/ssl.scm 859 */
obj_t BgL_bucketz00_2424;
BgL_bucketz00_2424 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_2414),BgL_modz00_2420); 
BgL_res2468z00_2448 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2424),BgL_restz00_2422); } } } } } } } } 
BgL_method1260z00_1717 = BgL_res2468z00_2448; } 
return 
CBOOL(
PROCEDURE_ENTRY(BgL_method1260z00_1717)(BgL_method1260z00_1717, 
((obj_t)BgL_scz00_64), BgL_sicz00_65, 
BINT(BgL_offsetz00_66), 
BINT(BgL_lenz00_67), BEOA));} } 

}



/* &secure-context-set-session-id-context! */
obj_t BGl_z62securezd2contextzd2setzd2sessionzd2idzd2contextz12za2zz__ssl_sslz00(obj_t BgL_envz00_4999, obj_t BgL_scz00_5000, obj_t BgL_sicz00_5001, obj_t BgL_offsetz00_5002, obj_t BgL_lenz00_5003)
{
{ /* Llib/ssl.scm 859 */
{ /* Llib/ssl.scm 859 */
bool_t BgL_tmpz00_8886;
{ /* Llib/ssl.scm 859 */
long BgL_auxz00_8911;long BgL_auxz00_8902;obj_t BgL_auxz00_8895;BgL_securezd2contextzd2_bglt BgL_auxz00_8887;
{ /* Llib/ssl.scm 859 */
obj_t BgL_tmpz00_8912;
if(
INTEGERP(BgL_lenz00_5003))
{ /* Llib/ssl.scm 859 */
BgL_tmpz00_8912 = BgL_lenz00_5003
; }  else 
{ 
obj_t BgL_auxz00_8915;
BgL_auxz00_8915 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)35180)), BGl_string3701z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_lenz00_5003); 
FAILURE(BgL_auxz00_8915,BFALSE,BFALSE);} 
BgL_auxz00_8911 = 
(long)CINT(BgL_tmpz00_8912); } 
{ /* Llib/ssl.scm 859 */
obj_t BgL_tmpz00_8903;
if(
INTEGERP(BgL_offsetz00_5002))
{ /* Llib/ssl.scm 859 */
BgL_tmpz00_8903 = BgL_offsetz00_5002
; }  else 
{ 
obj_t BgL_auxz00_8906;
BgL_auxz00_8906 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)35180)), BGl_string3701z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_offsetz00_5002); 
FAILURE(BgL_auxz00_8906,BFALSE,BFALSE);} 
BgL_auxz00_8902 = 
(long)CINT(BgL_tmpz00_8903); } 
if(
STRINGP(BgL_sicz00_5001))
{ /* Llib/ssl.scm 859 */
BgL_auxz00_8895 = BgL_sicz00_5001
; }  else 
{ 
obj_t BgL_auxz00_8898;
BgL_auxz00_8898 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)35180)), BGl_string3701z00zz__ssl_sslz00, BGl_string3369z00zz__ssl_sslz00, BgL_sicz00_5001); 
FAILURE(BgL_auxz00_8898,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_scz00_5000, BGl_securezd2contextzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 859 */
BgL_auxz00_8887 = 
((BgL_securezd2contextzd2_bglt)BgL_scz00_5000)
; }  else 
{ 
obj_t BgL_auxz00_8891;
BgL_auxz00_8891 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)35180)), BGl_string3701z00zz__ssl_sslz00, BGl_string3394z00zz__ssl_sslz00, BgL_scz00_5000); 
FAILURE(BgL_auxz00_8891,BFALSE,BFALSE);} 
BgL_tmpz00_8886 = 
BGl_securezd2contextzd2setzd2sessionzd2idzd2contextz12zc0zz__ssl_sslz00(BgL_auxz00_8887, BgL_auxz00_8895, BgL_auxz00_8902, BgL_auxz00_8911); } 
return 
BBOOL(BgL_tmpz00_8886);} } 

}



/* secure-context-load-pkcs12 */
BGL_EXPORTED_DEF bool_t BGl_securezd2contextzd2loadzd2pkcs12zd2zz__ssl_sslz00(BgL_securezd2contextzd2_bglt BgL_scz00_68, obj_t BgL_pfxz00_69, obj_t BgL_passz00_70)
{
{ /* Llib/ssl.scm 869 */
{ /* Llib/ssl.scm 869 */
obj_t BgL_method1262z00_1718;
{ /* Llib/ssl.scm 869 */
obj_t BgL_res2479z00_2485;
{ /* Llib/ssl.scm 869 */
long BgL_objzd2classzd2numz00_2450;
{ /* Llib/ssl.scm 869 */
long BgL_res2469z00_2453;
BgL_res2469z00_2453 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_scz00_68)); 
BgL_objzd2classzd2numz00_2450 = BgL_res2469z00_2453; } 
{ /* Llib/ssl.scm 869 */
obj_t BgL_arg1745z00_2451;
BgL_arg1745z00_2451 = 
PROCEDURE_REF(BGl_securezd2contextzd2loadzd2pkcs12zd2envz00zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 869 */
int BgL_offsetz00_2455;
BgL_offsetz00_2455 = 
(int)(BgL_objzd2classzd2numz00_2450); 
{ /* Llib/ssl.scm 869 */
long BgL_offsetz00_2456;
BgL_offsetz00_2456 = 
(
(long)(BgL_offsetz00_2455)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 869 */
long BgL_modz00_2457;
BgL_modz00_2457 = 
(BgL_offsetz00_2456 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 869 */
long BgL_restz00_2459;
BgL_restz00_2459 = 
(BgL_offsetz00_2456 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 869 */

{ /* Llib/ssl.scm 869 */
obj_t BgL_bucketz00_2461;
BgL_bucketz00_2461 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_2451),BgL_modz00_2457); 
BgL_res2479z00_2485 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2461),BgL_restz00_2459); } } } } } } } } 
BgL_method1262z00_1718 = BgL_res2479z00_2485; } 
return 
CBOOL(
PROCEDURE_ENTRY(BgL_method1262z00_1718)(BgL_method1262z00_1718, 
((obj_t)BgL_scz00_68), BgL_pfxz00_69, BgL_passz00_70, BEOA));} } 

}



/* &secure-context-load-pkcs12 */
obj_t BGl_z62securezd2contextzd2loadzd2pkcs12zb0zz__ssl_sslz00(obj_t BgL_envz00_5004, obj_t BgL_scz00_5005, obj_t BgL_pfxz00_5006, obj_t BgL_passz00_5007)
{
{ /* Llib/ssl.scm 869 */
{ /* Llib/ssl.scm 869 */
bool_t BgL_tmpz00_8955;
{ /* Llib/ssl.scm 869 */
obj_t BgL_auxz00_8964;BgL_securezd2contextzd2_bglt BgL_auxz00_8956;
if(
STRINGP(BgL_pfxz00_5006))
{ /* Llib/ssl.scm 869 */
BgL_auxz00_8964 = BgL_pfxz00_5006
; }  else 
{ 
obj_t BgL_auxz00_8967;
BgL_auxz00_8967 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)35623)), BGl_string3702z00zz__ssl_sslz00, BGl_string3369z00zz__ssl_sslz00, BgL_pfxz00_5006); 
FAILURE(BgL_auxz00_8967,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_scz00_5005, BGl_securezd2contextzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 869 */
BgL_auxz00_8956 = 
((BgL_securezd2contextzd2_bglt)BgL_scz00_5005)
; }  else 
{ 
obj_t BgL_auxz00_8960;
BgL_auxz00_8960 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)35623)), BGl_string3702z00zz__ssl_sslz00, BGl_string3394z00zz__ssl_sslz00, BgL_scz00_5005); 
FAILURE(BgL_auxz00_8960,BFALSE,BFALSE);} 
BgL_tmpz00_8955 = 
BGl_securezd2contextzd2loadzd2pkcs12zd2zz__ssl_sslz00(BgL_auxz00_8956, BgL_auxz00_8964, BgL_passz00_5007); } 
return 
BBOOL(BgL_tmpz00_8955);} } 

}



/* secure-context-set-ciphers! */
BGL_EXPORTED_DEF bool_t BGl_securezd2contextzd2setzd2ciphersz12zc0zz__ssl_sslz00(BgL_securezd2contextzd2_bglt BgL_scz00_71, obj_t BgL_ciphersz00_72)
{
{ /* Llib/ssl.scm 879 */
{ /* Llib/ssl.scm 879 */
obj_t BgL_method1264z00_1719;
{ /* Llib/ssl.scm 879 */
obj_t BgL_res2490z00_2522;
{ /* Llib/ssl.scm 879 */
long BgL_objzd2classzd2numz00_2487;
{ /* Llib/ssl.scm 879 */
long BgL_res2480z00_2490;
BgL_res2480z00_2490 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_scz00_71)); 
BgL_objzd2classzd2numz00_2487 = BgL_res2480z00_2490; } 
{ /* Llib/ssl.scm 879 */
obj_t BgL_arg1745z00_2488;
BgL_arg1745z00_2488 = 
PROCEDURE_REF(BGl_securezd2contextzd2setzd2ciphersz12zd2envz12zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 879 */
int BgL_offsetz00_2492;
BgL_offsetz00_2492 = 
(int)(BgL_objzd2classzd2numz00_2487); 
{ /* Llib/ssl.scm 879 */
long BgL_offsetz00_2493;
BgL_offsetz00_2493 = 
(
(long)(BgL_offsetz00_2492)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 879 */
long BgL_modz00_2494;
BgL_modz00_2494 = 
(BgL_offsetz00_2493 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 879 */
long BgL_restz00_2496;
BgL_restz00_2496 = 
(BgL_offsetz00_2493 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 879 */

{ /* Llib/ssl.scm 879 */
obj_t BgL_bucketz00_2498;
BgL_bucketz00_2498 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_2488),BgL_modz00_2494); 
BgL_res2490z00_2522 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2498),BgL_restz00_2496); } } } } } } } } 
BgL_method1264z00_1719 = BgL_res2490z00_2522; } 
return 
CBOOL(
PROCEDURE_ENTRY(BgL_method1264z00_1719)(BgL_method1264z00_1719, 
((obj_t)BgL_scz00_71), BgL_ciphersz00_72, BEOA));} } 

}



/* &secure-context-set-ciphers! */
obj_t BGl_z62securezd2contextzd2setzd2ciphersz12za2zz__ssl_sslz00(obj_t BgL_envz00_5008, obj_t BgL_scz00_5009, obj_t BgL_ciphersz00_5010)
{
{ /* Llib/ssl.scm 879 */
{ /* Llib/ssl.scm 879 */
bool_t BgL_tmpz00_9005;
{ /* Llib/ssl.scm 879 */
obj_t BgL_auxz00_9014;BgL_securezd2contextzd2_bglt BgL_auxz00_9006;
if(
STRINGP(BgL_ciphersz00_5010))
{ /* Llib/ssl.scm 879 */
BgL_auxz00_9014 = BgL_ciphersz00_5010
; }  else 
{ 
obj_t BgL_auxz00_9017;
BgL_auxz00_9017 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)36030)), BGl_string3703z00zz__ssl_sslz00, BGl_string3369z00zz__ssl_sslz00, BgL_ciphersz00_5010); 
FAILURE(BgL_auxz00_9017,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_scz00_5009, BGl_securezd2contextzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 879 */
BgL_auxz00_9006 = 
((BgL_securezd2contextzd2_bglt)BgL_scz00_5009)
; }  else 
{ 
obj_t BgL_auxz00_9010;
BgL_auxz00_9010 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)36030)), BGl_string3703z00zz__ssl_sslz00, BGl_string3394z00zz__ssl_sslz00, BgL_scz00_5009); 
FAILURE(BgL_auxz00_9010,BFALSE,BFALSE);} 
BgL_tmpz00_9005 = 
BGl_securezd2contextzd2setzd2ciphersz12zc0zz__ssl_sslz00(BgL_auxz00_9006, BgL_auxz00_9014); } 
return 
BBOOL(BgL_tmpz00_9005);} } 

}



/* secure-context-set-options! */
BGL_EXPORTED_DEF bool_t BGl_securezd2contextzd2setzd2optionsz12zc0zz__ssl_sslz00(BgL_securezd2contextzd2_bglt BgL_scz00_73, int BgL_optionsz00_74)
{
{ /* Llib/ssl.scm 891 */
{ /* Llib/ssl.scm 891 */
obj_t BgL_method1266z00_1720;
{ /* Llib/ssl.scm 891 */
obj_t BgL_res2501z00_2559;
{ /* Llib/ssl.scm 891 */
long BgL_objzd2classzd2numz00_2524;
{ /* Llib/ssl.scm 891 */
long BgL_res2491z00_2527;
BgL_res2491z00_2527 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_scz00_73)); 
BgL_objzd2classzd2numz00_2524 = BgL_res2491z00_2527; } 
{ /* Llib/ssl.scm 891 */
obj_t BgL_arg1745z00_2525;
BgL_arg1745z00_2525 = 
PROCEDURE_REF(BGl_securezd2contextzd2setzd2optionsz12zd2envz12zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 891 */
int BgL_offsetz00_2529;
BgL_offsetz00_2529 = 
(int)(BgL_objzd2classzd2numz00_2524); 
{ /* Llib/ssl.scm 891 */
long BgL_offsetz00_2530;
BgL_offsetz00_2530 = 
(
(long)(BgL_offsetz00_2529)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 891 */
long BgL_modz00_2531;
BgL_modz00_2531 = 
(BgL_offsetz00_2530 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 891 */
long BgL_restz00_2533;
BgL_restz00_2533 = 
(BgL_offsetz00_2530 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 891 */

{ /* Llib/ssl.scm 891 */
obj_t BgL_bucketz00_2535;
BgL_bucketz00_2535 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_2525),BgL_modz00_2531); 
BgL_res2501z00_2559 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2535),BgL_restz00_2533); } } } } } } } } 
BgL_method1266z00_1720 = BgL_res2501z00_2559; } 
return 
CBOOL(
PROCEDURE_ENTRY(BgL_method1266z00_1720)(BgL_method1266z00_1720, 
((obj_t)BgL_scz00_73), 
BINT(BgL_optionsz00_74), BEOA));} } 

}



/* &secure-context-set-options! */
obj_t BGl_z62securezd2contextzd2setzd2optionsz12za2zz__ssl_sslz00(obj_t BgL_envz00_5011, obj_t BgL_scz00_5012, obj_t BgL_optionsz00_5013)
{
{ /* Llib/ssl.scm 891 */
{ /* Llib/ssl.scm 891 */
bool_t BgL_tmpz00_9056;
{ /* Llib/ssl.scm 891 */
int BgL_auxz00_9065;BgL_securezd2contextzd2_bglt BgL_auxz00_9057;
{ /* Llib/ssl.scm 891 */
obj_t BgL_tmpz00_9066;
if(
INTEGERP(BgL_optionsz00_5013))
{ /* Llib/ssl.scm 891 */
BgL_tmpz00_9066 = BgL_optionsz00_5013
; }  else 
{ 
obj_t BgL_auxz00_9069;
BgL_auxz00_9069 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)36490)), BGl_string3704z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_optionsz00_5013); 
FAILURE(BgL_auxz00_9069,BFALSE,BFALSE);} 
BgL_auxz00_9065 = 
CINT(BgL_tmpz00_9066); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_scz00_5012, BGl_securezd2contextzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 891 */
BgL_auxz00_9057 = 
((BgL_securezd2contextzd2_bglt)BgL_scz00_5012)
; }  else 
{ 
obj_t BgL_auxz00_9061;
BgL_auxz00_9061 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)36490)), BGl_string3704z00zz__ssl_sslz00, BGl_string3394z00zz__ssl_sslz00, BgL_scz00_5012); 
FAILURE(BgL_auxz00_9061,BFALSE,BFALSE);} 
BgL_tmpz00_9056 = 
BGl_securezd2contextzd2setzd2optionsz12zc0zz__ssl_sslz00(BgL_auxz00_9057, BgL_auxz00_9065); } 
return 
BBOOL(BgL_tmpz00_9056);} } 

}



/* ssl-connection-init */
BGL_EXPORTED_DEF obj_t BGl_sslzd2connectionzd2initz00zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt BgL_sslz00_75)
{
{ /* Llib/ssl.scm 903 */
{ /* Llib/ssl.scm 903 */
obj_t BgL_method1268z00_1721;
{ /* Llib/ssl.scm 903 */
obj_t BgL_res2512z00_2596;
{ /* Llib/ssl.scm 903 */
long BgL_objzd2classzd2numz00_2561;
{ /* Llib/ssl.scm 903 */
long BgL_res2502z00_2564;
BgL_res2502z00_2564 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslz00_75)); 
BgL_objzd2classzd2numz00_2561 = BgL_res2502z00_2564; } 
{ /* Llib/ssl.scm 903 */
obj_t BgL_arg1745z00_2562;
BgL_arg1745z00_2562 = 
PROCEDURE_REF(BGl_sslzd2connectionzd2initzd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 903 */
int BgL_offsetz00_2566;
BgL_offsetz00_2566 = 
(int)(BgL_objzd2classzd2numz00_2561); 
{ /* Llib/ssl.scm 903 */
long BgL_offsetz00_2567;
BgL_offsetz00_2567 = 
(
(long)(BgL_offsetz00_2566)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 903 */
long BgL_modz00_2568;
BgL_modz00_2568 = 
(BgL_offsetz00_2567 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 903 */
long BgL_restz00_2570;
BgL_restz00_2570 = 
(BgL_offsetz00_2567 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 903 */

{ /* Llib/ssl.scm 903 */
obj_t BgL_bucketz00_2572;
BgL_bucketz00_2572 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_2562),BgL_modz00_2568); 
BgL_res2512z00_2596 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2572),BgL_restz00_2570); } } } } } } } } 
BgL_method1268z00_1721 = BgL_res2512z00_2596; } 
return 
PROCEDURE_ENTRY(BgL_method1268z00_1721)(BgL_method1268z00_1721, 
((obj_t)BgL_sslz00_75), BEOA);} } 

}



/* &ssl-connection-init */
obj_t BGl_z62sslzd2connectionzd2initz62zz__ssl_sslz00(obj_t BgL_envz00_4732, obj_t BgL_sslz00_4733)
{
{ /* Llib/ssl.scm 903 */
{ /* Llib/ssl.scm 903 */
BgL_sslzd2connectionzd2_bglt BgL_auxz00_9106;
if(
BGl_isazf3zf3zz__objectz00(BgL_sslz00_4733, BGl_sslzd2connectionzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 903 */
BgL_auxz00_9106 = 
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_4733)
; }  else 
{ 
obj_t BgL_auxz00_9110;
BgL_auxz00_9110 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)36946)), BGl_string3705z00zz__ssl_sslz00, BGl_string3706z00zz__ssl_sslz00, BgL_sslz00_4733); 
FAILURE(BgL_auxz00_9110,BFALSE,BFALSE);} 
return 
BGl_sslzd2connectionzd2initz00zz__ssl_sslz00(BgL_auxz00_9106);} } 

}



/* ssl-connection-start */
BGL_EXPORTED_DEF int BGl_sslzd2connectionzd2startz00zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt BgL_sslz00_76)
{
{ /* Llib/ssl.scm 913 */
{ /* Llib/ssl.scm 913 */
obj_t BgL_method1270z00_1722;
{ /* Llib/ssl.scm 913 */
obj_t BgL_res2523z00_2633;
{ /* Llib/ssl.scm 913 */
long BgL_objzd2classzd2numz00_2598;
{ /* Llib/ssl.scm 913 */
long BgL_res2513z00_2601;
BgL_res2513z00_2601 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslz00_76)); 
BgL_objzd2classzd2numz00_2598 = BgL_res2513z00_2601; } 
{ /* Llib/ssl.scm 913 */
obj_t BgL_arg1745z00_2599;
BgL_arg1745z00_2599 = 
PROCEDURE_REF(BGl_sslzd2connectionzd2startzd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 913 */
int BgL_offsetz00_2603;
BgL_offsetz00_2603 = 
(int)(BgL_objzd2classzd2numz00_2598); 
{ /* Llib/ssl.scm 913 */
long BgL_offsetz00_2604;
BgL_offsetz00_2604 = 
(
(long)(BgL_offsetz00_2603)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 913 */
long BgL_modz00_2605;
BgL_modz00_2605 = 
(BgL_offsetz00_2604 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 913 */
long BgL_restz00_2607;
BgL_restz00_2607 = 
(BgL_offsetz00_2604 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 913 */

{ /* Llib/ssl.scm 913 */
obj_t BgL_bucketz00_2609;
BgL_bucketz00_2609 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_2599),BgL_modz00_2605); 
BgL_res2523z00_2633 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2609),BgL_restz00_2607); } } } } } } } } 
BgL_method1270z00_1722 = BgL_res2523z00_2633; } 
return 
CINT(
PROCEDURE_ENTRY(BgL_method1270z00_1722)(BgL_method1270z00_1722, 
((obj_t)BgL_sslz00_76), BEOA));} } 

}



/* &ssl-connection-start */
obj_t BGl_z62sslzd2connectionzd2startz62zz__ssl_sslz00(obj_t BgL_envz00_5014, obj_t BgL_sslz00_5015)
{
{ /* Llib/ssl.scm 913 */
{ /* Llib/ssl.scm 913 */
int BgL_tmpz00_9146;
{ /* Llib/ssl.scm 913 */
BgL_sslzd2connectionzd2_bglt BgL_auxz00_9147;
if(
BGl_isazf3zf3zz__objectz00(BgL_sslz00_5015, BGl_sslzd2connectionzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 913 */
BgL_auxz00_9147 = 
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5015)
; }  else 
{ 
obj_t BgL_auxz00_9151;
BgL_auxz00_9151 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)37325)), BGl_string3707z00zz__ssl_sslz00, BGl_string3706z00zz__ssl_sslz00, BgL_sslz00_5015); 
FAILURE(BgL_auxz00_9151,BFALSE,BFALSE);} 
BgL_tmpz00_9146 = 
BGl_sslzd2connectionzd2startz00zz__ssl_sslz00(BgL_auxz00_9147); } 
return 
BINT(BgL_tmpz00_9146);} } 

}



/* ssl-connection-close */
BGL_EXPORTED_DEF int BGl_sslzd2connectionzd2closez00zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt BgL_sslz00_77)
{
{ /* Llib/ssl.scm 923 */
{ /* Llib/ssl.scm 923 */
obj_t BgL_method1272z00_1723;
{ /* Llib/ssl.scm 923 */
obj_t BgL_res2534z00_2670;
{ /* Llib/ssl.scm 923 */
long BgL_objzd2classzd2numz00_2635;
{ /* Llib/ssl.scm 923 */
long BgL_res2524z00_2638;
BgL_res2524z00_2638 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslz00_77)); 
BgL_objzd2classzd2numz00_2635 = BgL_res2524z00_2638; } 
{ /* Llib/ssl.scm 923 */
obj_t BgL_arg1745z00_2636;
BgL_arg1745z00_2636 = 
PROCEDURE_REF(BGl_sslzd2connectionzd2closezd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 923 */
int BgL_offsetz00_2640;
BgL_offsetz00_2640 = 
(int)(BgL_objzd2classzd2numz00_2635); 
{ /* Llib/ssl.scm 923 */
long BgL_offsetz00_2641;
BgL_offsetz00_2641 = 
(
(long)(BgL_offsetz00_2640)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 923 */
long BgL_modz00_2642;
BgL_modz00_2642 = 
(BgL_offsetz00_2641 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 923 */
long BgL_restz00_2644;
BgL_restz00_2644 = 
(BgL_offsetz00_2641 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 923 */

{ /* Llib/ssl.scm 923 */
obj_t BgL_bucketz00_2646;
BgL_bucketz00_2646 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_2636),BgL_modz00_2642); 
BgL_res2534z00_2670 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2646),BgL_restz00_2644); } } } } } } } } 
BgL_method1272z00_1723 = BgL_res2534z00_2670; } 
return 
CINT(
PROCEDURE_ENTRY(BgL_method1272z00_1723)(BgL_method1272z00_1723, 
((obj_t)BgL_sslz00_77), BEOA));} } 

}



/* &ssl-connection-close */
obj_t BGl_z62sslzd2connectionzd2closez62zz__ssl_sslz00(obj_t BgL_envz00_5016, obj_t BgL_sslz00_5017)
{
{ /* Llib/ssl.scm 923 */
{ /* Llib/ssl.scm 923 */
int BgL_tmpz00_9188;
{ /* Llib/ssl.scm 923 */
BgL_sslzd2connectionzd2_bglt BgL_auxz00_9189;
if(
BGl_isazf3zf3zz__objectz00(BgL_sslz00_5017, BGl_sslzd2connectionzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 923 */
BgL_auxz00_9189 = 
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5017)
; }  else 
{ 
obj_t BgL_auxz00_9193;
BgL_auxz00_9193 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)37705)), BGl_string3708z00zz__ssl_sslz00, BGl_string3706z00zz__ssl_sslz00, BgL_sslz00_5017); 
FAILURE(BgL_auxz00_9193,BFALSE,BFALSE);} 
BgL_tmpz00_9188 = 
BGl_sslzd2connectionzd2closez00zz__ssl_sslz00(BgL_auxz00_9189); } 
return 
BINT(BgL_tmpz00_9188);} } 

}



/* ssl-connection-shutdown */
BGL_EXPORTED_DEF obj_t BGl_sslzd2connectionzd2shutdownz00zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt BgL_sslz00_78)
{
{ /* Llib/ssl.scm 933 */
{ /* Llib/ssl.scm 933 */
obj_t BgL_method1274z00_1724;
{ /* Llib/ssl.scm 933 */
obj_t BgL_res2545z00_2707;
{ /* Llib/ssl.scm 933 */
long BgL_objzd2classzd2numz00_2672;
{ /* Llib/ssl.scm 933 */
long BgL_res2535z00_2675;
BgL_res2535z00_2675 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslz00_78)); 
BgL_objzd2classzd2numz00_2672 = BgL_res2535z00_2675; } 
{ /* Llib/ssl.scm 933 */
obj_t BgL_arg1745z00_2673;
BgL_arg1745z00_2673 = 
PROCEDURE_REF(BGl_sslzd2connectionzd2shutdownzd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 933 */
int BgL_offsetz00_2677;
BgL_offsetz00_2677 = 
(int)(BgL_objzd2classzd2numz00_2672); 
{ /* Llib/ssl.scm 933 */
long BgL_offsetz00_2678;
BgL_offsetz00_2678 = 
(
(long)(BgL_offsetz00_2677)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 933 */
long BgL_modz00_2679;
BgL_modz00_2679 = 
(BgL_offsetz00_2678 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 933 */
long BgL_restz00_2681;
BgL_restz00_2681 = 
(BgL_offsetz00_2678 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 933 */

{ /* Llib/ssl.scm 933 */
obj_t BgL_bucketz00_2683;
BgL_bucketz00_2683 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_2673),BgL_modz00_2679); 
BgL_res2545z00_2707 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2683),BgL_restz00_2681); } } } } } } } } 
BgL_method1274z00_1724 = BgL_res2545z00_2707; } 
return 
PROCEDURE_ENTRY(BgL_method1274z00_1724)(BgL_method1274z00_1724, 
((obj_t)BgL_sslz00_78), BEOA);} } 

}



/* &ssl-connection-shutdown */
obj_t BGl_z62sslzd2connectionzd2shutdownz62zz__ssl_sslz00(obj_t BgL_envz00_5018, obj_t BgL_sslz00_5019)
{
{ /* Llib/ssl.scm 933 */
{ /* Llib/ssl.scm 933 */
BgL_sslzd2connectionzd2_bglt BgL_auxz00_9229;
if(
BGl_isazf3zf3zz__objectz00(BgL_sslz00_5019, BGl_sslzd2connectionzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 933 */
BgL_auxz00_9229 = 
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5019)
; }  else 
{ 
obj_t BgL_auxz00_9233;
BgL_auxz00_9233 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)38085)), BGl_string3709z00zz__ssl_sslz00, BGl_string3706z00zz__ssl_sslz00, BgL_sslz00_5019); 
FAILURE(BgL_auxz00_9233,BFALSE,BFALSE);} 
return 
BGl_sslzd2connectionzd2shutdownz00zz__ssl_sslz00(BgL_auxz00_9229);} } 

}



/* ssl-connection-read */
BGL_EXPORTED_DEF obj_t BGl_sslzd2connectionzd2readz00zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt BgL_sslz00_79, obj_t BgL_bufferz00_80, long BgL_offsetz00_81, long BgL_lenz00_82)
{
{ /* Llib/ssl.scm 943 */
{ /* Llib/ssl.scm 943 */
obj_t BgL_method1276z00_1725;
{ /* Llib/ssl.scm 943 */
obj_t BgL_res2556z00_2744;
{ /* Llib/ssl.scm 943 */
long BgL_objzd2classzd2numz00_2709;
{ /* Llib/ssl.scm 943 */
long BgL_res2546z00_2712;
BgL_res2546z00_2712 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslz00_79)); 
BgL_objzd2classzd2numz00_2709 = BgL_res2546z00_2712; } 
{ /* Llib/ssl.scm 943 */
obj_t BgL_arg1745z00_2710;
BgL_arg1745z00_2710 = 
PROCEDURE_REF(BGl_sslzd2connectionzd2readzd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 943 */
int BgL_offsetz00_2714;
BgL_offsetz00_2714 = 
(int)(BgL_objzd2classzd2numz00_2709); 
{ /* Llib/ssl.scm 943 */
long BgL_offsetz00_2715;
BgL_offsetz00_2715 = 
(
(long)(BgL_offsetz00_2714)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 943 */
long BgL_modz00_2716;
BgL_modz00_2716 = 
(BgL_offsetz00_2715 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 943 */
long BgL_restz00_2718;
BgL_restz00_2718 = 
(BgL_offsetz00_2715 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 943 */

{ /* Llib/ssl.scm 943 */
obj_t BgL_bucketz00_2720;
BgL_bucketz00_2720 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_2710),BgL_modz00_2716); 
BgL_res2556z00_2744 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2720),BgL_restz00_2718); } } } } } } } } 
BgL_method1276z00_1725 = BgL_res2556z00_2744; } 
return 
PROCEDURE_ENTRY(BgL_method1276z00_1725)(BgL_method1276z00_1725, 
((obj_t)BgL_sslz00_79), BgL_bufferz00_80, 
BINT(BgL_offsetz00_81), 
BINT(BgL_lenz00_82), BEOA);} } 

}



/* &ssl-connection-read */
obj_t BGl_z62sslzd2connectionzd2readz62zz__ssl_sslz00(obj_t BgL_envz00_5020, obj_t BgL_sslz00_5021, obj_t BgL_bufferz00_5022, obj_t BgL_offsetz00_5023, obj_t BgL_lenz00_5024)
{
{ /* Llib/ssl.scm 943 */
{ /* Llib/ssl.scm 943 */
long BgL_auxz00_9297;long BgL_auxz00_9288;obj_t BgL_auxz00_9281;BgL_sslzd2connectionzd2_bglt BgL_auxz00_9273;
{ /* Llib/ssl.scm 943 */
obj_t BgL_tmpz00_9298;
if(
INTEGERP(BgL_lenz00_5024))
{ /* Llib/ssl.scm 943 */
BgL_tmpz00_9298 = BgL_lenz00_5024
; }  else 
{ 
obj_t BgL_auxz00_9301;
BgL_auxz00_9301 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)38471)), BGl_string3710z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_lenz00_5024); 
FAILURE(BgL_auxz00_9301,BFALSE,BFALSE);} 
BgL_auxz00_9297 = 
(long)CINT(BgL_tmpz00_9298); } 
{ /* Llib/ssl.scm 943 */
obj_t BgL_tmpz00_9289;
if(
INTEGERP(BgL_offsetz00_5023))
{ /* Llib/ssl.scm 943 */
BgL_tmpz00_9289 = BgL_offsetz00_5023
; }  else 
{ 
obj_t BgL_auxz00_9292;
BgL_auxz00_9292 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)38471)), BGl_string3710z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_offsetz00_5023); 
FAILURE(BgL_auxz00_9292,BFALSE,BFALSE);} 
BgL_auxz00_9288 = 
(long)CINT(BgL_tmpz00_9289); } 
if(
STRINGP(BgL_bufferz00_5022))
{ /* Llib/ssl.scm 943 */
BgL_auxz00_9281 = BgL_bufferz00_5022
; }  else 
{ 
obj_t BgL_auxz00_9284;
BgL_auxz00_9284 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)38471)), BGl_string3710z00zz__ssl_sslz00, BGl_string3369z00zz__ssl_sslz00, BgL_bufferz00_5022); 
FAILURE(BgL_auxz00_9284,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_sslz00_5021, BGl_sslzd2connectionzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 943 */
BgL_auxz00_9273 = 
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5021)
; }  else 
{ 
obj_t BgL_auxz00_9277;
BgL_auxz00_9277 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)38471)), BGl_string3710z00zz__ssl_sslz00, BGl_string3706z00zz__ssl_sslz00, BgL_sslz00_5021); 
FAILURE(BgL_auxz00_9277,BFALSE,BFALSE);} 
return 
BGl_sslzd2connectionzd2readz00zz__ssl_sslz00(BgL_auxz00_9273, BgL_auxz00_9281, BgL_auxz00_9288, BgL_auxz00_9297);} } 

}



/* ssl-connection-write */
BGL_EXPORTED_DEF obj_t BGl_sslzd2connectionzd2writez00zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt BgL_sslz00_83, obj_t BgL_bufferz00_84, long BgL_offsetz00_85, long BgL_lenz00_86)
{
{ /* Llib/ssl.scm 953 */
{ /* Llib/ssl.scm 953 */
obj_t BgL_method1278z00_1726;
{ /* Llib/ssl.scm 953 */
obj_t BgL_res2567z00_2781;
{ /* Llib/ssl.scm 953 */
long BgL_objzd2classzd2numz00_2746;
{ /* Llib/ssl.scm 953 */
long BgL_res2557z00_2749;
BgL_res2557z00_2749 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslz00_83)); 
BgL_objzd2classzd2numz00_2746 = BgL_res2557z00_2749; } 
{ /* Llib/ssl.scm 953 */
obj_t BgL_arg1745z00_2747;
BgL_arg1745z00_2747 = 
PROCEDURE_REF(BGl_sslzd2connectionzd2writezd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 953 */
int BgL_offsetz00_2751;
BgL_offsetz00_2751 = 
(int)(BgL_objzd2classzd2numz00_2746); 
{ /* Llib/ssl.scm 953 */
long BgL_offsetz00_2752;
BgL_offsetz00_2752 = 
(
(long)(BgL_offsetz00_2751)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 953 */
long BgL_modz00_2753;
BgL_modz00_2753 = 
(BgL_offsetz00_2752 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 953 */
long BgL_restz00_2755;
BgL_restz00_2755 = 
(BgL_offsetz00_2752 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 953 */

{ /* Llib/ssl.scm 953 */
obj_t BgL_bucketz00_2757;
BgL_bucketz00_2757 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_2747),BgL_modz00_2753); 
BgL_res2567z00_2781 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2757),BgL_restz00_2755); } } } } } } } } 
BgL_method1278z00_1726 = BgL_res2567z00_2781; } 
return 
PROCEDURE_ENTRY(BgL_method1278z00_1726)(BgL_method1278z00_1726, 
((obj_t)BgL_sslz00_83), BgL_bufferz00_84, 
BINT(BgL_offsetz00_85), 
BINT(BgL_lenz00_86), BEOA);} } 

}



/* &ssl-connection-write */
obj_t BGl_z62sslzd2connectionzd2writez62zz__ssl_sslz00(obj_t BgL_envz00_5025, obj_t BgL_sslz00_5026, obj_t BgL_bufferz00_5027, obj_t BgL_offsetz00_5028, obj_t BgL_lenz00_5029)
{
{ /* Llib/ssl.scm 953 */
{ /* Llib/ssl.scm 953 */
long BgL_auxz00_9366;long BgL_auxz00_9357;obj_t BgL_auxz00_9350;BgL_sslzd2connectionzd2_bglt BgL_auxz00_9342;
{ /* Llib/ssl.scm 953 */
obj_t BgL_tmpz00_9367;
if(
INTEGERP(BgL_lenz00_5029))
{ /* Llib/ssl.scm 953 */
BgL_tmpz00_9367 = BgL_lenz00_5029
; }  else 
{ 
obj_t BgL_auxz00_9370;
BgL_auxz00_9370 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)38883)), BGl_string3711z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_lenz00_5029); 
FAILURE(BgL_auxz00_9370,BFALSE,BFALSE);} 
BgL_auxz00_9366 = 
(long)CINT(BgL_tmpz00_9367); } 
{ /* Llib/ssl.scm 953 */
obj_t BgL_tmpz00_9358;
if(
INTEGERP(BgL_offsetz00_5028))
{ /* Llib/ssl.scm 953 */
BgL_tmpz00_9358 = BgL_offsetz00_5028
; }  else 
{ 
obj_t BgL_auxz00_9361;
BgL_auxz00_9361 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)38883)), BGl_string3711z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_offsetz00_5028); 
FAILURE(BgL_auxz00_9361,BFALSE,BFALSE);} 
BgL_auxz00_9357 = 
(long)CINT(BgL_tmpz00_9358); } 
if(
STRINGP(BgL_bufferz00_5027))
{ /* Llib/ssl.scm 953 */
BgL_auxz00_9350 = BgL_bufferz00_5027
; }  else 
{ 
obj_t BgL_auxz00_9353;
BgL_auxz00_9353 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)38883)), BGl_string3711z00zz__ssl_sslz00, BGl_string3369z00zz__ssl_sslz00, BgL_bufferz00_5027); 
FAILURE(BgL_auxz00_9353,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_sslz00_5026, BGl_sslzd2connectionzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 953 */
BgL_auxz00_9342 = 
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5026)
; }  else 
{ 
obj_t BgL_auxz00_9346;
BgL_auxz00_9346 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)38883)), BGl_string3711z00zz__ssl_sslz00, BGl_string3706z00zz__ssl_sslz00, BgL_sslz00_5026); 
FAILURE(BgL_auxz00_9346,BFALSE,BFALSE);} 
return 
BGl_sslzd2connectionzd2writez00zz__ssl_sslz00(BgL_auxz00_9342, BgL_auxz00_9350, BgL_auxz00_9357, BgL_auxz00_9366);} } 

}



/* ssl-connection-clear-in */
BGL_EXPORTED_DEF obj_t BGl_sslzd2connectionzd2clearzd2inzd2zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt BgL_sslz00_87, obj_t BgL_bufferz00_88, long BgL_offsetz00_89, long BgL_lenz00_90)
{
{ /* Llib/ssl.scm 963 */
{ /* Llib/ssl.scm 963 */
obj_t BgL_method1280z00_1727;
{ /* Llib/ssl.scm 963 */
obj_t BgL_res2578z00_2818;
{ /* Llib/ssl.scm 963 */
long BgL_objzd2classzd2numz00_2783;
{ /* Llib/ssl.scm 963 */
long BgL_res2568z00_2786;
BgL_res2568z00_2786 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslz00_87)); 
BgL_objzd2classzd2numz00_2783 = BgL_res2568z00_2786; } 
{ /* Llib/ssl.scm 963 */
obj_t BgL_arg1745z00_2784;
BgL_arg1745z00_2784 = 
PROCEDURE_REF(BGl_sslzd2connectionzd2clearzd2inzd2envz00zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 963 */
int BgL_offsetz00_2788;
BgL_offsetz00_2788 = 
(int)(BgL_objzd2classzd2numz00_2783); 
{ /* Llib/ssl.scm 963 */
long BgL_offsetz00_2789;
BgL_offsetz00_2789 = 
(
(long)(BgL_offsetz00_2788)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 963 */
long BgL_modz00_2790;
BgL_modz00_2790 = 
(BgL_offsetz00_2789 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 963 */
long BgL_restz00_2792;
BgL_restz00_2792 = 
(BgL_offsetz00_2789 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 963 */

{ /* Llib/ssl.scm 963 */
obj_t BgL_bucketz00_2794;
BgL_bucketz00_2794 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_2784),BgL_modz00_2790); 
BgL_res2578z00_2818 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2794),BgL_restz00_2792); } } } } } } } } 
BgL_method1280z00_1727 = BgL_res2578z00_2818; } 
return 
PROCEDURE_ENTRY(BgL_method1280z00_1727)(BgL_method1280z00_1727, 
((obj_t)BgL_sslz00_87), BgL_bufferz00_88, 
BINT(BgL_offsetz00_89), 
BINT(BgL_lenz00_90), BEOA);} } 

}



/* &ssl-connection-clear-in */
obj_t BGl_z62sslzd2connectionzd2clearzd2inzb0zz__ssl_sslz00(obj_t BgL_envz00_5030, obj_t BgL_sslz00_5031, obj_t BgL_bufferz00_5032, obj_t BgL_offsetz00_5033, obj_t BgL_lenz00_5034)
{
{ /* Llib/ssl.scm 963 */
{ /* Llib/ssl.scm 963 */
long BgL_auxz00_9435;long BgL_auxz00_9426;obj_t BgL_auxz00_9419;BgL_sslzd2connectionzd2_bglt BgL_auxz00_9411;
{ /* Llib/ssl.scm 963 */
obj_t BgL_tmpz00_9436;
if(
INTEGERP(BgL_lenz00_5034))
{ /* Llib/ssl.scm 963 */
BgL_tmpz00_9436 = BgL_lenz00_5034
; }  else 
{ 
obj_t BgL_auxz00_9439;
BgL_auxz00_9439 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)39297)), BGl_string3712z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_lenz00_5034); 
FAILURE(BgL_auxz00_9439,BFALSE,BFALSE);} 
BgL_auxz00_9435 = 
(long)CINT(BgL_tmpz00_9436); } 
{ /* Llib/ssl.scm 963 */
obj_t BgL_tmpz00_9427;
if(
INTEGERP(BgL_offsetz00_5033))
{ /* Llib/ssl.scm 963 */
BgL_tmpz00_9427 = BgL_offsetz00_5033
; }  else 
{ 
obj_t BgL_auxz00_9430;
BgL_auxz00_9430 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)39297)), BGl_string3712z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_offsetz00_5033); 
FAILURE(BgL_auxz00_9430,BFALSE,BFALSE);} 
BgL_auxz00_9426 = 
(long)CINT(BgL_tmpz00_9427); } 
if(
STRINGP(BgL_bufferz00_5032))
{ /* Llib/ssl.scm 963 */
BgL_auxz00_9419 = BgL_bufferz00_5032
; }  else 
{ 
obj_t BgL_auxz00_9422;
BgL_auxz00_9422 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)39297)), BGl_string3712z00zz__ssl_sslz00, BGl_string3369z00zz__ssl_sslz00, BgL_bufferz00_5032); 
FAILURE(BgL_auxz00_9422,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_sslz00_5031, BGl_sslzd2connectionzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 963 */
BgL_auxz00_9411 = 
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5031)
; }  else 
{ 
obj_t BgL_auxz00_9415;
BgL_auxz00_9415 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)39297)), BGl_string3712z00zz__ssl_sslz00, BGl_string3706z00zz__ssl_sslz00, BgL_sslz00_5031); 
FAILURE(BgL_auxz00_9415,BFALSE,BFALSE);} 
return 
BGl_sslzd2connectionzd2clearzd2inzd2zz__ssl_sslz00(BgL_auxz00_9411, BgL_auxz00_9419, BgL_auxz00_9426, BgL_auxz00_9435);} } 

}



/* ssl-connection-clear-out */
BGL_EXPORTED_DEF obj_t BGl_sslzd2connectionzd2clearzd2outzd2zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt BgL_sslz00_91, obj_t BgL_bufferz00_92, long BgL_offsetz00_93, long BgL_lenz00_94)
{
{ /* Llib/ssl.scm 973 */
{ /* Llib/ssl.scm 973 */
obj_t BgL_method1282z00_1728;
{ /* Llib/ssl.scm 973 */
obj_t BgL_res2589z00_2855;
{ /* Llib/ssl.scm 973 */
long BgL_objzd2classzd2numz00_2820;
{ /* Llib/ssl.scm 973 */
long BgL_res2579z00_2823;
BgL_res2579z00_2823 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslz00_91)); 
BgL_objzd2classzd2numz00_2820 = BgL_res2579z00_2823; } 
{ /* Llib/ssl.scm 973 */
obj_t BgL_arg1745z00_2821;
BgL_arg1745z00_2821 = 
PROCEDURE_REF(BGl_sslzd2connectionzd2clearzd2outzd2envz00zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 973 */
int BgL_offsetz00_2825;
BgL_offsetz00_2825 = 
(int)(BgL_objzd2classzd2numz00_2820); 
{ /* Llib/ssl.scm 973 */
long BgL_offsetz00_2826;
BgL_offsetz00_2826 = 
(
(long)(BgL_offsetz00_2825)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 973 */
long BgL_modz00_2827;
BgL_modz00_2827 = 
(BgL_offsetz00_2826 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 973 */
long BgL_restz00_2829;
BgL_restz00_2829 = 
(BgL_offsetz00_2826 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 973 */

{ /* Llib/ssl.scm 973 */
obj_t BgL_bucketz00_2831;
BgL_bucketz00_2831 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_2821),BgL_modz00_2827); 
BgL_res2589z00_2855 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2831),BgL_restz00_2829); } } } } } } } } 
BgL_method1282z00_1728 = BgL_res2589z00_2855; } 
return 
PROCEDURE_ENTRY(BgL_method1282z00_1728)(BgL_method1282z00_1728, 
((obj_t)BgL_sslz00_91), BgL_bufferz00_92, 
BINT(BgL_offsetz00_93), 
BINT(BgL_lenz00_94), BEOA);} } 

}



/* &ssl-connection-clear-out */
obj_t BGl_z62sslzd2connectionzd2clearzd2outzb0zz__ssl_sslz00(obj_t BgL_envz00_5035, obj_t BgL_sslz00_5036, obj_t BgL_bufferz00_5037, obj_t BgL_offsetz00_5038, obj_t BgL_lenz00_5039)
{
{ /* Llib/ssl.scm 973 */
{ /* Llib/ssl.scm 973 */
long BgL_auxz00_9504;long BgL_auxz00_9495;obj_t BgL_auxz00_9488;BgL_sslzd2connectionzd2_bglt BgL_auxz00_9480;
{ /* Llib/ssl.scm 973 */
obj_t BgL_tmpz00_9505;
if(
INTEGERP(BgL_lenz00_5039))
{ /* Llib/ssl.scm 973 */
BgL_tmpz00_9505 = BgL_lenz00_5039
; }  else 
{ 
obj_t BgL_auxz00_9508;
BgL_auxz00_9508 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)39717)), BGl_string3713z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_lenz00_5039); 
FAILURE(BgL_auxz00_9508,BFALSE,BFALSE);} 
BgL_auxz00_9504 = 
(long)CINT(BgL_tmpz00_9505); } 
{ /* Llib/ssl.scm 973 */
obj_t BgL_tmpz00_9496;
if(
INTEGERP(BgL_offsetz00_5038))
{ /* Llib/ssl.scm 973 */
BgL_tmpz00_9496 = BgL_offsetz00_5038
; }  else 
{ 
obj_t BgL_auxz00_9499;
BgL_auxz00_9499 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)39717)), BGl_string3713z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_offsetz00_5038); 
FAILURE(BgL_auxz00_9499,BFALSE,BFALSE);} 
BgL_auxz00_9495 = 
(long)CINT(BgL_tmpz00_9496); } 
if(
STRINGP(BgL_bufferz00_5037))
{ /* Llib/ssl.scm 973 */
BgL_auxz00_9488 = BgL_bufferz00_5037
; }  else 
{ 
obj_t BgL_auxz00_9491;
BgL_auxz00_9491 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)39717)), BGl_string3713z00zz__ssl_sslz00, BGl_string3369z00zz__ssl_sslz00, BgL_bufferz00_5037); 
FAILURE(BgL_auxz00_9491,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_sslz00_5036, BGl_sslzd2connectionzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 973 */
BgL_auxz00_9480 = 
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5036)
; }  else 
{ 
obj_t BgL_auxz00_9484;
BgL_auxz00_9484 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)39717)), BGl_string3713z00zz__ssl_sslz00, BGl_string3706z00zz__ssl_sslz00, BgL_sslz00_5036); 
FAILURE(BgL_auxz00_9484,BFALSE,BFALSE);} 
return 
BGl_sslzd2connectionzd2clearzd2outzd2zz__ssl_sslz00(BgL_auxz00_9480, BgL_auxz00_9488, BgL_auxz00_9495, BgL_auxz00_9504);} } 

}



/* ssl-connection-init-finished? */
BGL_EXPORTED_DEF obj_t BGl_sslzd2connectionzd2initzd2finishedzf3z21zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt BgL_sslz00_95)
{
{ /* Llib/ssl.scm 983 */
{ /* Llib/ssl.scm 983 */
obj_t BgL_method1284z00_1729;
{ /* Llib/ssl.scm 983 */
obj_t BgL_res2600z00_2892;
{ /* Llib/ssl.scm 983 */
long BgL_objzd2classzd2numz00_2857;
{ /* Llib/ssl.scm 983 */
long BgL_res2590z00_2860;
BgL_res2590z00_2860 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslz00_95)); 
BgL_objzd2classzd2numz00_2857 = BgL_res2590z00_2860; } 
{ /* Llib/ssl.scm 983 */
obj_t BgL_arg1745z00_2858;
BgL_arg1745z00_2858 = 
PROCEDURE_REF(BGl_sslzd2connectionzd2initzd2finishedzf3zd2envzf3zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 983 */
int BgL_offsetz00_2862;
BgL_offsetz00_2862 = 
(int)(BgL_objzd2classzd2numz00_2857); 
{ /* Llib/ssl.scm 983 */
long BgL_offsetz00_2863;
BgL_offsetz00_2863 = 
(
(long)(BgL_offsetz00_2862)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 983 */
long BgL_modz00_2864;
BgL_modz00_2864 = 
(BgL_offsetz00_2863 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 983 */
long BgL_restz00_2866;
BgL_restz00_2866 = 
(BgL_offsetz00_2863 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 983 */

{ /* Llib/ssl.scm 983 */
obj_t BgL_bucketz00_2868;
BgL_bucketz00_2868 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_2858),BgL_modz00_2864); 
BgL_res2600z00_2892 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2868),BgL_restz00_2866); } } } } } } } } 
BgL_method1284z00_1729 = BgL_res2600z00_2892; } 
return 
PROCEDURE_ENTRY(BgL_method1284z00_1729)(BgL_method1284z00_1729, 
((obj_t)BgL_sslz00_95), BEOA);} } 

}



/* &ssl-connection-init-finished? */
obj_t BGl_z62sslzd2connectionzd2initzd2finishedzf3z43zz__ssl_sslz00(obj_t BgL_envz00_5040, obj_t BgL_sslz00_5041)
{
{ /* Llib/ssl.scm 983 */
{ /* Llib/ssl.scm 983 */
BgL_sslzd2connectionzd2_bglt BgL_auxz00_9544;
if(
BGl_isazf3zf3zz__objectz00(BgL_sslz00_5041, BGl_sslzd2connectionzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 983 */
BgL_auxz00_9544 = 
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5041)
; }  else 
{ 
obj_t BgL_auxz00_9548;
BgL_auxz00_9548 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)40139)), BGl_string3714z00zz__ssl_sslz00, BGl_string3706z00zz__ssl_sslz00, BgL_sslz00_5041); 
FAILURE(BgL_auxz00_9548,BFALSE,BFALSE);} 
return 
BGl_sslzd2connectionzd2initzd2finishedzf3z21zz__ssl_sslz00(BgL_auxz00_9544);} } 

}



/* ssl-connection-enc-pending */
BGL_EXPORTED_DEF obj_t BGl_sslzd2connectionzd2enczd2pendingzd2zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt BgL_sslz00_96)
{
{ /* Llib/ssl.scm 993 */
{ /* Llib/ssl.scm 993 */
obj_t BgL_method1286z00_1730;
{ /* Llib/ssl.scm 993 */
obj_t BgL_res2611z00_2929;
{ /* Llib/ssl.scm 993 */
long BgL_objzd2classzd2numz00_2894;
{ /* Llib/ssl.scm 993 */
long BgL_res2601z00_2897;
BgL_res2601z00_2897 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslz00_96)); 
BgL_objzd2classzd2numz00_2894 = BgL_res2601z00_2897; } 
{ /* Llib/ssl.scm 993 */
obj_t BgL_arg1745z00_2895;
BgL_arg1745z00_2895 = 
PROCEDURE_REF(BGl_sslzd2connectionzd2enczd2pendingzd2envz00zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 993 */
int BgL_offsetz00_2899;
BgL_offsetz00_2899 = 
(int)(BgL_objzd2classzd2numz00_2894); 
{ /* Llib/ssl.scm 993 */
long BgL_offsetz00_2900;
BgL_offsetz00_2900 = 
(
(long)(BgL_offsetz00_2899)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 993 */
long BgL_modz00_2901;
BgL_modz00_2901 = 
(BgL_offsetz00_2900 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 993 */
long BgL_restz00_2903;
BgL_restz00_2903 = 
(BgL_offsetz00_2900 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 993 */

{ /* Llib/ssl.scm 993 */
obj_t BgL_bucketz00_2905;
BgL_bucketz00_2905 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_2895),BgL_modz00_2901); 
BgL_res2611z00_2929 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2905),BgL_restz00_2903); } } } } } } } } 
BgL_method1286z00_1730 = BgL_res2611z00_2929; } 
return 
PROCEDURE_ENTRY(BgL_method1286z00_1730)(BgL_method1286z00_1730, 
((obj_t)BgL_sslz00_96), BEOA);} } 

}



/* &ssl-connection-enc-pending */
obj_t BGl_z62sslzd2connectionzd2enczd2pendingzb0zz__ssl_sslz00(obj_t BgL_envz00_5042, obj_t BgL_sslz00_5043)
{
{ /* Llib/ssl.scm 993 */
{ /* Llib/ssl.scm 993 */
BgL_sslzd2connectionzd2_bglt BgL_auxz00_9583;
if(
BGl_isazf3zf3zz__objectz00(BgL_sslz00_5043, BGl_sslzd2connectionzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 993 */
BgL_auxz00_9583 = 
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5043)
; }  else 
{ 
obj_t BgL_auxz00_9587;
BgL_auxz00_9587 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)40535)), BGl_string3715z00zz__ssl_sslz00, BGl_string3706z00zz__ssl_sslz00, BgL_sslz00_5043); 
FAILURE(BgL_auxz00_9587,BFALSE,BFALSE);} 
return 
BGl_sslzd2connectionzd2enczd2pendingzd2zz__ssl_sslz00(BgL_auxz00_9583);} } 

}



/* ssl-connection-clear-pending */
BGL_EXPORTED_DEF obj_t BGl_sslzd2connectionzd2clearzd2pendingzd2zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt BgL_sslz00_97)
{
{ /* Llib/ssl.scm 1003 */
{ /* Llib/ssl.scm 1003 */
obj_t BgL_method1288z00_1731;
{ /* Llib/ssl.scm 1003 */
obj_t BgL_res2622z00_2966;
{ /* Llib/ssl.scm 1003 */
long BgL_objzd2classzd2numz00_2931;
{ /* Llib/ssl.scm 1003 */
long BgL_res2612z00_2934;
BgL_res2612z00_2934 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslz00_97)); 
BgL_objzd2classzd2numz00_2931 = BgL_res2612z00_2934; } 
{ /* Llib/ssl.scm 1003 */
obj_t BgL_arg1745z00_2932;
BgL_arg1745z00_2932 = 
PROCEDURE_REF(BGl_sslzd2connectionzd2clearzd2pendingzd2envz00zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1003 */
int BgL_offsetz00_2936;
BgL_offsetz00_2936 = 
(int)(BgL_objzd2classzd2numz00_2931); 
{ /* Llib/ssl.scm 1003 */
long BgL_offsetz00_2937;
BgL_offsetz00_2937 = 
(
(long)(BgL_offsetz00_2936)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1003 */
long BgL_modz00_2938;
BgL_modz00_2938 = 
(BgL_offsetz00_2937 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 1003 */
long BgL_restz00_2940;
BgL_restz00_2940 = 
(BgL_offsetz00_2937 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 1003 */

{ /* Llib/ssl.scm 1003 */
obj_t BgL_bucketz00_2942;
BgL_bucketz00_2942 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_2932),BgL_modz00_2938); 
BgL_res2622z00_2966 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2942),BgL_restz00_2940); } } } } } } } } 
BgL_method1288z00_1731 = BgL_res2622z00_2966; } 
return 
PROCEDURE_ENTRY(BgL_method1288z00_1731)(BgL_method1288z00_1731, 
((obj_t)BgL_sslz00_97), BEOA);} } 

}



/* &ssl-connection-clear-pending */
obj_t BGl_z62sslzd2connectionzd2clearzd2pendingzb0zz__ssl_sslz00(obj_t BgL_envz00_5044, obj_t BgL_sslz00_5045)
{
{ /* Llib/ssl.scm 1003 */
{ /* Llib/ssl.scm 1003 */
BgL_sslzd2connectionzd2_bglt BgL_auxz00_9622;
if(
BGl_isazf3zf3zz__objectz00(BgL_sslz00_5045, BGl_sslzd2connectionzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1003 */
BgL_auxz00_9622 = 
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5045)
; }  else 
{ 
obj_t BgL_auxz00_9626;
BgL_auxz00_9626 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)40925)), BGl_string3716z00zz__ssl_sslz00, BGl_string3706z00zz__ssl_sslz00, BgL_sslz00_5045); 
FAILURE(BgL_auxz00_9626,BFALSE,BFALSE);} 
return 
BGl_sslzd2connectionzd2clearzd2pendingzd2zz__ssl_sslz00(BgL_auxz00_9622);} } 

}



/* ssl-connection-set-session */
BGL_EXPORTED_DEF obj_t BGl_sslzd2connectionzd2setzd2sessionzd2zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt BgL_sslz00_98, obj_t BgL_bufz00_99)
{
{ /* Llib/ssl.scm 1013 */
{ /* Llib/ssl.scm 1013 */
obj_t BgL_method1290z00_1732;
{ /* Llib/ssl.scm 1013 */
obj_t BgL_res2633z00_3003;
{ /* Llib/ssl.scm 1013 */
long BgL_objzd2classzd2numz00_2968;
{ /* Llib/ssl.scm 1013 */
long BgL_res2623z00_2971;
BgL_res2623z00_2971 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslz00_98)); 
BgL_objzd2classzd2numz00_2968 = BgL_res2623z00_2971; } 
{ /* Llib/ssl.scm 1013 */
obj_t BgL_arg1745z00_2969;
BgL_arg1745z00_2969 = 
PROCEDURE_REF(BGl_sslzd2connectionzd2setzd2sessionzd2envz00zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1013 */
int BgL_offsetz00_2973;
BgL_offsetz00_2973 = 
(int)(BgL_objzd2classzd2numz00_2968); 
{ /* Llib/ssl.scm 1013 */
long BgL_offsetz00_2974;
BgL_offsetz00_2974 = 
(
(long)(BgL_offsetz00_2973)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1013 */
long BgL_modz00_2975;
BgL_modz00_2975 = 
(BgL_offsetz00_2974 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 1013 */
long BgL_restz00_2977;
BgL_restz00_2977 = 
(BgL_offsetz00_2974 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 1013 */

{ /* Llib/ssl.scm 1013 */
obj_t BgL_bucketz00_2979;
BgL_bucketz00_2979 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_2969),BgL_modz00_2975); 
BgL_res2633z00_3003 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2979),BgL_restz00_2977); } } } } } } } } 
BgL_method1290z00_1732 = BgL_res2633z00_3003; } 
return 
PROCEDURE_ENTRY(BgL_method1290z00_1732)(BgL_method1290z00_1732, 
((obj_t)BgL_sslz00_98), BgL_bufz00_99, BEOA);} } 

}



/* &ssl-connection-set-session */
obj_t BGl_z62sslzd2connectionzd2setzd2sessionzb0zz__ssl_sslz00(obj_t BgL_envz00_5046, obj_t BgL_sslz00_5047, obj_t BgL_bufz00_5048)
{
{ /* Llib/ssl.scm 1013 */
{ /* Llib/ssl.scm 1013 */
obj_t BgL_auxz00_9670;BgL_sslzd2connectionzd2_bglt BgL_auxz00_9662;
if(
STRINGP(BgL_bufz00_5048))
{ /* Llib/ssl.scm 1013 */
BgL_auxz00_9670 = BgL_bufz00_5048
; }  else 
{ 
obj_t BgL_auxz00_9673;
BgL_auxz00_9673 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)41319)), BGl_string3717z00zz__ssl_sslz00, BGl_string3369z00zz__ssl_sslz00, BgL_bufz00_5048); 
FAILURE(BgL_auxz00_9673,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_sslz00_5047, BGl_sslzd2connectionzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1013 */
BgL_auxz00_9662 = 
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5047)
; }  else 
{ 
obj_t BgL_auxz00_9666;
BgL_auxz00_9666 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)41319)), BGl_string3717z00zz__ssl_sslz00, BGl_string3706z00zz__ssl_sslz00, BgL_sslz00_5047); 
FAILURE(BgL_auxz00_9666,BFALSE,BFALSE);} 
return 
BGl_sslzd2connectionzd2setzd2sessionzd2zz__ssl_sslz00(BgL_auxz00_9662, BgL_auxz00_9670);} } 

}



/* ssl-connection-get-session */
BGL_EXPORTED_DEF obj_t BGl_sslzd2connectionzd2getzd2sessionzd2zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt BgL_sslz00_100)
{
{ /* Llib/ssl.scm 1023 */
{ /* Llib/ssl.scm 1023 */
obj_t BgL_method1292z00_1733;
{ /* Llib/ssl.scm 1023 */
obj_t BgL_res2644z00_3040;
{ /* Llib/ssl.scm 1023 */
long BgL_objzd2classzd2numz00_3005;
{ /* Llib/ssl.scm 1023 */
long BgL_res2634z00_3008;
BgL_res2634z00_3008 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslz00_100)); 
BgL_objzd2classzd2numz00_3005 = BgL_res2634z00_3008; } 
{ /* Llib/ssl.scm 1023 */
obj_t BgL_arg1745z00_3006;
BgL_arg1745z00_3006 = 
PROCEDURE_REF(BGl_sslzd2connectionzd2getzd2sessionzd2envz00zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1023 */
int BgL_offsetz00_3010;
BgL_offsetz00_3010 = 
(int)(BgL_objzd2classzd2numz00_3005); 
{ /* Llib/ssl.scm 1023 */
long BgL_offsetz00_3011;
BgL_offsetz00_3011 = 
(
(long)(BgL_offsetz00_3010)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1023 */
long BgL_modz00_3012;
BgL_modz00_3012 = 
(BgL_offsetz00_3011 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 1023 */
long BgL_restz00_3014;
BgL_restz00_3014 = 
(BgL_offsetz00_3011 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 1023 */

{ /* Llib/ssl.scm 1023 */
obj_t BgL_bucketz00_3016;
BgL_bucketz00_3016 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_3006),BgL_modz00_3012); 
BgL_res2644z00_3040 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3016),BgL_restz00_3014); } } } } } } } } 
BgL_method1292z00_1733 = BgL_res2644z00_3040; } 
return 
PROCEDURE_ENTRY(BgL_method1292z00_1733)(BgL_method1292z00_1733, 
((obj_t)BgL_sslz00_100), BEOA);} } 

}



/* &ssl-connection-get-session */
obj_t BGl_z62sslzd2connectionzd2getzd2sessionzb0zz__ssl_sslz00(obj_t BgL_envz00_5049, obj_t BgL_sslz00_5050)
{
{ /* Llib/ssl.scm 1023 */
{ /* Llib/ssl.scm 1023 */
BgL_sslzd2connectionzd2_bglt BgL_auxz00_9708;
if(
BGl_isazf3zf3zz__objectz00(BgL_sslz00_5050, BGl_sslzd2connectionzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1023 */
BgL_auxz00_9708 = 
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5050)
; }  else 
{ 
obj_t BgL_auxz00_9712;
BgL_auxz00_9712 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)41727)), BGl_string3718z00zz__ssl_sslz00, BGl_string3706z00zz__ssl_sslz00, BgL_sslz00_5050); 
FAILURE(BgL_auxz00_9712,BFALSE,BFALSE);} 
return 
BGl_sslzd2connectionzd2getzd2sessionzd2zz__ssl_sslz00(BgL_auxz00_9708);} } 

}



/* ssl-connection-get-current-cipher */
BGL_EXPORTED_DEF obj_t BGl_sslzd2connectionzd2getzd2currentzd2cipherz00zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt BgL_sslz00_101)
{
{ /* Llib/ssl.scm 1033 */
{ /* Llib/ssl.scm 1033 */
obj_t BgL_method1294z00_1734;
{ /* Llib/ssl.scm 1033 */
obj_t BgL_res2655z00_3077;
{ /* Llib/ssl.scm 1033 */
long BgL_objzd2classzd2numz00_3042;
{ /* Llib/ssl.scm 1033 */
long BgL_res2645z00_3045;
BgL_res2645z00_3045 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslz00_101)); 
BgL_objzd2classzd2numz00_3042 = BgL_res2645z00_3045; } 
{ /* Llib/ssl.scm 1033 */
obj_t BgL_arg1745z00_3043;
BgL_arg1745z00_3043 = 
PROCEDURE_REF(BGl_sslzd2connectionzd2getzd2currentzd2cipherzd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1033 */
int BgL_offsetz00_3047;
BgL_offsetz00_3047 = 
(int)(BgL_objzd2classzd2numz00_3042); 
{ /* Llib/ssl.scm 1033 */
long BgL_offsetz00_3048;
BgL_offsetz00_3048 = 
(
(long)(BgL_offsetz00_3047)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1033 */
long BgL_modz00_3049;
BgL_modz00_3049 = 
(BgL_offsetz00_3048 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 1033 */
long BgL_restz00_3051;
BgL_restz00_3051 = 
(BgL_offsetz00_3048 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 1033 */

{ /* Llib/ssl.scm 1033 */
obj_t BgL_bucketz00_3053;
BgL_bucketz00_3053 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_3043),BgL_modz00_3049); 
BgL_res2655z00_3077 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3053),BgL_restz00_3051); } } } } } } } } 
BgL_method1294z00_1734 = BgL_res2655z00_3077; } 
return 
PROCEDURE_ENTRY(BgL_method1294z00_1734)(BgL_method1294z00_1734, 
((obj_t)BgL_sslz00_101), BEOA);} } 

}



/* &ssl-connection-get-current-cipher */
obj_t BGl_z62sslzd2connectionzd2getzd2currentzd2cipherz62zz__ssl_sslz00(obj_t BgL_envz00_5051, obj_t BgL_sslz00_5052)
{
{ /* Llib/ssl.scm 1033 */
{ /* Llib/ssl.scm 1033 */
BgL_sslzd2connectionzd2_bglt BgL_auxz00_9747;
if(
BGl_isazf3zf3zz__objectz00(BgL_sslz00_5052, BGl_sslzd2connectionzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1033 */
BgL_auxz00_9747 = 
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5052)
; }  else 
{ 
obj_t BgL_auxz00_9751;
BgL_auxz00_9751 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)42118)), BGl_string3719z00zz__ssl_sslz00, BGl_string3706z00zz__ssl_sslz00, BgL_sslz00_5052); 
FAILURE(BgL_auxz00_9751,BFALSE,BFALSE);} 
return 
BGl_sslzd2connectionzd2getzd2currentzd2cipherz00zz__ssl_sslz00(BgL_auxz00_9747);} } 

}



/* ssl-connection-load-session */
BGL_EXPORTED_DEF obj_t BGl_sslzd2connectionzd2loadzd2sessionzd2zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt BgL_sslz00_102, obj_t BgL_bufz00_103)
{
{ /* Llib/ssl.scm 1043 */
{ /* Llib/ssl.scm 1043 */
obj_t BgL_method1296z00_1735;
{ /* Llib/ssl.scm 1043 */
obj_t BgL_res2666z00_3114;
{ /* Llib/ssl.scm 1043 */
long BgL_objzd2classzd2numz00_3079;
{ /* Llib/ssl.scm 1043 */
long BgL_res2656z00_3082;
BgL_res2656z00_3082 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslz00_102)); 
BgL_objzd2classzd2numz00_3079 = BgL_res2656z00_3082; } 
{ /* Llib/ssl.scm 1043 */
obj_t BgL_arg1745z00_3080;
BgL_arg1745z00_3080 = 
PROCEDURE_REF(BGl_sslzd2connectionzd2loadzd2sessionzd2envz00zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1043 */
int BgL_offsetz00_3084;
BgL_offsetz00_3084 = 
(int)(BgL_objzd2classzd2numz00_3079); 
{ /* Llib/ssl.scm 1043 */
long BgL_offsetz00_3085;
BgL_offsetz00_3085 = 
(
(long)(BgL_offsetz00_3084)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1043 */
long BgL_modz00_3086;
BgL_modz00_3086 = 
(BgL_offsetz00_3085 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 1043 */
long BgL_restz00_3088;
BgL_restz00_3088 = 
(BgL_offsetz00_3085 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 1043 */

{ /* Llib/ssl.scm 1043 */
obj_t BgL_bucketz00_3090;
BgL_bucketz00_3090 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_3080),BgL_modz00_3086); 
BgL_res2666z00_3114 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3090),BgL_restz00_3088); } } } } } } } } 
BgL_method1296z00_1735 = BgL_res2666z00_3114; } 
return 
PROCEDURE_ENTRY(BgL_method1296z00_1735)(BgL_method1296z00_1735, 
((obj_t)BgL_sslz00_102), BgL_bufz00_103, BEOA);} } 

}



/* &ssl-connection-load-session */
obj_t BGl_z62sslzd2connectionzd2loadzd2sessionzb0zz__ssl_sslz00(obj_t BgL_envz00_5053, obj_t BgL_sslz00_5054, obj_t BgL_bufz00_5055)
{
{ /* Llib/ssl.scm 1043 */
{ /* Llib/ssl.scm 1043 */
obj_t BgL_auxz00_9795;BgL_sslzd2connectionzd2_bglt BgL_auxz00_9787;
if(
STRINGP(BgL_bufz00_5055))
{ /* Llib/ssl.scm 1043 */
BgL_auxz00_9795 = BgL_bufz00_5055
; }  else 
{ 
obj_t BgL_auxz00_9798;
BgL_auxz00_9798 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)42523)), BGl_string3720z00zz__ssl_sslz00, BGl_string3369z00zz__ssl_sslz00, BgL_bufz00_5055); 
FAILURE(BgL_auxz00_9798,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_sslz00_5054, BGl_sslzd2connectionzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1043 */
BgL_auxz00_9787 = 
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5054)
; }  else 
{ 
obj_t BgL_auxz00_9791;
BgL_auxz00_9791 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)42523)), BGl_string3720z00zz__ssl_sslz00, BGl_string3706z00zz__ssl_sslz00, BgL_sslz00_5054); 
FAILURE(BgL_auxz00_9791,BFALSE,BFALSE);} 
return 
BGl_sslzd2connectionzd2loadzd2sessionzd2zz__ssl_sslz00(BgL_auxz00_9787, BgL_auxz00_9795);} } 

}



/* ssl-connection-verify-error */
BGL_EXPORTED_DEF obj_t BGl_sslzd2connectionzd2verifyzd2errorzd2zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt BgL_sslz00_104)
{
{ /* Llib/ssl.scm 1053 */
{ /* Llib/ssl.scm 1053 */
obj_t BgL_method1298z00_1736;
{ /* Llib/ssl.scm 1053 */
obj_t BgL_res2677z00_3151;
{ /* Llib/ssl.scm 1053 */
long BgL_objzd2classzd2numz00_3116;
{ /* Llib/ssl.scm 1053 */
long BgL_res2667z00_3119;
BgL_res2667z00_3119 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslz00_104)); 
BgL_objzd2classzd2numz00_3116 = BgL_res2667z00_3119; } 
{ /* Llib/ssl.scm 1053 */
obj_t BgL_arg1745z00_3117;
BgL_arg1745z00_3117 = 
PROCEDURE_REF(BGl_sslzd2connectionzd2verifyzd2errorzd2envz00zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1053 */
int BgL_offsetz00_3121;
BgL_offsetz00_3121 = 
(int)(BgL_objzd2classzd2numz00_3116); 
{ /* Llib/ssl.scm 1053 */
long BgL_offsetz00_3122;
BgL_offsetz00_3122 = 
(
(long)(BgL_offsetz00_3121)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1053 */
long BgL_modz00_3123;
BgL_modz00_3123 = 
(BgL_offsetz00_3122 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 1053 */
long BgL_restz00_3125;
BgL_restz00_3125 = 
(BgL_offsetz00_3122 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 1053 */

{ /* Llib/ssl.scm 1053 */
obj_t BgL_bucketz00_3127;
BgL_bucketz00_3127 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_3117),BgL_modz00_3123); 
BgL_res2677z00_3151 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3127),BgL_restz00_3125); } } } } } } } } 
BgL_method1298z00_1736 = BgL_res2677z00_3151; } 
return 
PROCEDURE_ENTRY(BgL_method1298z00_1736)(BgL_method1298z00_1736, 
((obj_t)BgL_sslz00_104), BEOA);} } 

}



/* &ssl-connection-verify-error */
obj_t BGl_z62sslzd2connectionzd2verifyzd2errorzb0zz__ssl_sslz00(obj_t BgL_envz00_5056, obj_t BgL_sslz00_5057)
{
{ /* Llib/ssl.scm 1053 */
{ /* Llib/ssl.scm 1053 */
BgL_sslzd2connectionzd2_bglt BgL_auxz00_9833;
if(
BGl_isazf3zf3zz__objectz00(BgL_sslz00_5057, BGl_sslzd2connectionzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1053 */
BgL_auxz00_9833 = 
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5057)
; }  else 
{ 
obj_t BgL_auxz00_9837;
BgL_auxz00_9837 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)42933)), BGl_string3721z00zz__ssl_sslz00, BGl_string3706z00zz__ssl_sslz00, BgL_sslz00_5057); 
FAILURE(BgL_auxz00_9837,BFALSE,BFALSE);} 
return 
BGl_sslzd2connectionzd2verifyzd2errorzd2zz__ssl_sslz00(BgL_auxz00_9833);} } 

}



/* ssl-connection-get-peer-certificate */
BGL_EXPORTED_DEF obj_t BGl_sslzd2connectionzd2getzd2peerzd2certificatez00zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt BgL_sslz00_105)
{
{ /* Llib/ssl.scm 1063 */
{ /* Llib/ssl.scm 1063 */
obj_t BgL_method1300z00_1737;
{ /* Llib/ssl.scm 1063 */
obj_t BgL_res2688z00_3188;
{ /* Llib/ssl.scm 1063 */
long BgL_objzd2classzd2numz00_3153;
{ /* Llib/ssl.scm 1063 */
long BgL_res2678z00_3156;
BgL_res2678z00_3156 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslz00_105)); 
BgL_objzd2classzd2numz00_3153 = BgL_res2678z00_3156; } 
{ /* Llib/ssl.scm 1063 */
obj_t BgL_arg1745z00_3154;
BgL_arg1745z00_3154 = 
PROCEDURE_REF(BGl_sslzd2connectionzd2getzd2peerzd2certificatezd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1063 */
int BgL_offsetz00_3158;
BgL_offsetz00_3158 = 
(int)(BgL_objzd2classzd2numz00_3153); 
{ /* Llib/ssl.scm 1063 */
long BgL_offsetz00_3159;
BgL_offsetz00_3159 = 
(
(long)(BgL_offsetz00_3158)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1063 */
long BgL_modz00_3160;
BgL_modz00_3160 = 
(BgL_offsetz00_3159 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 1063 */
long BgL_restz00_3162;
BgL_restz00_3162 = 
(BgL_offsetz00_3159 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 1063 */

{ /* Llib/ssl.scm 1063 */
obj_t BgL_bucketz00_3164;
BgL_bucketz00_3164 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_3154),BgL_modz00_3160); 
BgL_res2688z00_3188 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3164),BgL_restz00_3162); } } } } } } } } 
BgL_method1300z00_1737 = BgL_res2688z00_3188; } 
return 
PROCEDURE_ENTRY(BgL_method1300z00_1737)(BgL_method1300z00_1737, 
((obj_t)BgL_sslz00_105), BEOA);} } 

}



/* &ssl-connection-get-peer-certificate */
obj_t BGl_z62sslzd2connectionzd2getzd2peerzd2certificatez62zz__ssl_sslz00(obj_t BgL_envz00_5058, obj_t BgL_sslz00_5059)
{
{ /* Llib/ssl.scm 1063 */
{ /* Llib/ssl.scm 1063 */
BgL_sslzd2connectionzd2_bglt BgL_auxz00_9872;
if(
BGl_isazf3zf3zz__objectz00(BgL_sslz00_5059, BGl_sslzd2connectionzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1063 */
BgL_auxz00_9872 = 
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5059)
; }  else 
{ 
obj_t BgL_auxz00_9876;
BgL_auxz00_9876 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)43326)), BGl_string3722z00zz__ssl_sslz00, BGl_string3706z00zz__ssl_sslz00, BgL_sslz00_5059); 
FAILURE(BgL_auxz00_9876,BFALSE,BFALSE);} 
return 
BGl_sslzd2connectionzd2getzd2peerzd2certificatez00zz__ssl_sslz00(BgL_auxz00_9872);} } 

}



/* ssl-connection-reused? */
BGL_EXPORTED_DEF bool_t BGl_sslzd2connectionzd2reusedzf3zf3zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt BgL_sslz00_106)
{
{ /* Llib/ssl.scm 1073 */
{ /* Llib/ssl.scm 1073 */
obj_t BgL_method1302z00_1738;
{ /* Llib/ssl.scm 1073 */
obj_t BgL_res2699z00_3225;
{ /* Llib/ssl.scm 1073 */
long BgL_objzd2classzd2numz00_3190;
{ /* Llib/ssl.scm 1073 */
long BgL_res2689z00_3193;
BgL_res2689z00_3193 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslz00_106)); 
BgL_objzd2classzd2numz00_3190 = BgL_res2689z00_3193; } 
{ /* Llib/ssl.scm 1073 */
obj_t BgL_arg1745z00_3191;
BgL_arg1745z00_3191 = 
PROCEDURE_REF(BGl_sslzd2connectionzd2reusedzf3zd2envz21zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1073 */
int BgL_offsetz00_3195;
BgL_offsetz00_3195 = 
(int)(BgL_objzd2classzd2numz00_3190); 
{ /* Llib/ssl.scm 1073 */
long BgL_offsetz00_3196;
BgL_offsetz00_3196 = 
(
(long)(BgL_offsetz00_3195)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1073 */
long BgL_modz00_3197;
BgL_modz00_3197 = 
(BgL_offsetz00_3196 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 1073 */
long BgL_restz00_3199;
BgL_restz00_3199 = 
(BgL_offsetz00_3196 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 1073 */

{ /* Llib/ssl.scm 1073 */
obj_t BgL_bucketz00_3201;
BgL_bucketz00_3201 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_3191),BgL_modz00_3197); 
BgL_res2699z00_3225 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3201),BgL_restz00_3199); } } } } } } } } 
BgL_method1302z00_1738 = BgL_res2699z00_3225; } 
return 
CBOOL(
PROCEDURE_ENTRY(BgL_method1302z00_1738)(BgL_method1302z00_1738, 
((obj_t)BgL_sslz00_106), BEOA));} } 

}



/* &ssl-connection-reused? */
obj_t BGl_z62sslzd2connectionzd2reusedzf3z91zz__ssl_sslz00(obj_t BgL_envz00_5060, obj_t BgL_sslz00_5061)
{
{ /* Llib/ssl.scm 1073 */
{ /* Llib/ssl.scm 1073 */
bool_t BgL_tmpz00_9912;
{ /* Llib/ssl.scm 1073 */
BgL_sslzd2connectionzd2_bglt BgL_auxz00_9913;
if(
BGl_isazf3zf3zz__objectz00(BgL_sslz00_5061, BGl_sslzd2connectionzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1073 */
BgL_auxz00_9913 = 
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5061)
; }  else 
{ 
obj_t BgL_auxz00_9917;
BgL_auxz00_9917 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)43735)), BGl_string3723z00zz__ssl_sslz00, BGl_string3706z00zz__ssl_sslz00, BgL_sslz00_5061); 
FAILURE(BgL_auxz00_9917,BFALSE,BFALSE);} 
BgL_tmpz00_9912 = 
BGl_sslzd2connectionzd2reusedzf3zf3zz__ssl_sslz00(BgL_auxz00_9913); } 
return 
BBOOL(BgL_tmpz00_9912);} } 

}



/* ssl-connection-get-negotiated-protocol */
BGL_EXPORTED_DEF obj_t BGl_sslzd2connectionzd2getzd2negotiatedzd2protocolz00zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt BgL_sslz00_107)
{
{ /* Llib/ssl.scm 1084 */
{ /* Llib/ssl.scm 1084 */
obj_t BgL_method1304z00_1739;
{ /* Llib/ssl.scm 1084 */
obj_t BgL_res2710z00_3262;
{ /* Llib/ssl.scm 1084 */
long BgL_objzd2classzd2numz00_3227;
{ /* Llib/ssl.scm 1084 */
long BgL_res2700z00_3230;
BgL_res2700z00_3230 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslz00_107)); 
BgL_objzd2classzd2numz00_3227 = BgL_res2700z00_3230; } 
{ /* Llib/ssl.scm 1084 */
obj_t BgL_arg1745z00_3228;
BgL_arg1745z00_3228 = 
PROCEDURE_REF(BGl_sslzd2connectionzd2getzd2negotiatedzd2protocolzd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1084 */
int BgL_offsetz00_3232;
BgL_offsetz00_3232 = 
(int)(BgL_objzd2classzd2numz00_3227); 
{ /* Llib/ssl.scm 1084 */
long BgL_offsetz00_3233;
BgL_offsetz00_3233 = 
(
(long)(BgL_offsetz00_3232)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1084 */
long BgL_modz00_3234;
BgL_modz00_3234 = 
(BgL_offsetz00_3233 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 1084 */
long BgL_restz00_3236;
BgL_restz00_3236 = 
(BgL_offsetz00_3233 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 1084 */

{ /* Llib/ssl.scm 1084 */
obj_t BgL_bucketz00_3238;
BgL_bucketz00_3238 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_3228),BgL_modz00_3234); 
BgL_res2710z00_3262 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3238),BgL_restz00_3236); } } } } } } } } 
BgL_method1304z00_1739 = BgL_res2710z00_3262; } 
return 
PROCEDURE_ENTRY(BgL_method1304z00_1739)(BgL_method1304z00_1739, 
((obj_t)BgL_sslz00_107), BEOA);} } 

}



/* &ssl-connection-get-negotiated-protocol */
obj_t BGl_z62sslzd2connectionzd2getzd2negotiatedzd2protocolz62zz__ssl_sslz00(obj_t BgL_envz00_5062, obj_t BgL_sslz00_5063)
{
{ /* Llib/ssl.scm 1084 */
{ /* Llib/ssl.scm 1084 */
BgL_sslzd2connectionzd2_bglt BgL_auxz00_9953;
if(
BGl_isazf3zf3zz__objectz00(BgL_sslz00_5063, BGl_sslzd2connectionzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1084 */
BgL_auxz00_9953 = 
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5063)
; }  else 
{ 
obj_t BgL_auxz00_9957;
BgL_auxz00_9957 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)44161)), BGl_string3724z00zz__ssl_sslz00, BGl_string3706z00zz__ssl_sslz00, BgL_sslz00_5063); 
FAILURE(BgL_auxz00_9957,BFALSE,BFALSE);} 
return 
BGl_sslzd2connectionzd2getzd2negotiatedzd2protocolz00zz__ssl_sslz00(BgL_auxz00_9953);} } 

}



/* &dh-init */
obj_t BGl_z62dhzd2initzb0zz__ssl_sslz00(obj_t BgL_envz00_4734, obj_t BgL_dhz00_4735)
{
{ /* Llib/ssl.scm 1094 */
{ /* Llib/ssl.scm 1094 */
BgL_dhz00_bglt BgL_dhz00_6077;
if(
BGl_isazf3zf3zz__objectz00(BgL_dhz00_4735, BGl_dhz00zz__ssl_sslz00))
{ /* Llib/ssl.scm 1094 */
BgL_dhz00_6077 = 
((BgL_dhz00_bglt)BgL_dhz00_4735); }  else 
{ 
obj_t BgL_auxz00_9965;
BgL_auxz00_9965 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)44576)), BGl_string3725z00zz__ssl_sslz00, BGl_string3726z00zz__ssl_sslz00, BgL_dhz00_4735); 
FAILURE(BgL_auxz00_9965,BFALSE,BFALSE);} 
{ /* Llib/ssl.scm 1094 */
obj_t BgL_method1306z00_6078;
{ /* Llib/ssl.scm 1094 */
obj_t BgL_res2721z00_6079;
{ /* Llib/ssl.scm 1094 */
long BgL_objzd2classzd2numz00_6080;
{ /* Llib/ssl.scm 1094 */
long BgL_res2711z00_6081;
BgL_res2711z00_6081 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_dhz00_6077)); 
BgL_objzd2classzd2numz00_6080 = BgL_res2711z00_6081; } 
{ /* Llib/ssl.scm 1094 */
obj_t BgL_arg1745z00_6082;
BgL_arg1745z00_6082 = 
PROCEDURE_REF(BGl_dhzd2initzd2envz00zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1094 */
int BgL_offsetz00_6083;
BgL_offsetz00_6083 = 
(int)(BgL_objzd2classzd2numz00_6080); 
{ /* Llib/ssl.scm 1094 */
long BgL_offsetz00_6084;
BgL_offsetz00_6084 = 
(
(long)(BgL_offsetz00_6083)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1094 */
long BgL_modz00_6085;
BgL_modz00_6085 = 
(BgL_offsetz00_6084 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 1094 */
long BgL_restz00_6086;
BgL_restz00_6086 = 
(BgL_offsetz00_6084 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 1094 */

{ /* Llib/ssl.scm 1094 */
obj_t BgL_bucketz00_6087;
BgL_bucketz00_6087 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_6082),BgL_modz00_6085); 
BgL_res2721z00_6079 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_6087),BgL_restz00_6086); } } } } } } } } 
BgL_method1306z00_6078 = BgL_res2721z00_6079; } 
return 
PROCEDURE_ENTRY(BgL_method1306z00_6078)(BgL_method1306z00_6078, 
((obj_t)BgL_dhz00_6077), BEOA);} } } 

}



/* dh-size */
BGL_EXPORTED_DEF int BGl_dhzd2siza7ez75zz__ssl_sslz00(BgL_dhz00_bglt BgL_dhz00_109)
{
{ /* Llib/ssl.scm 1105 */
{ /* Llib/ssl.scm 1105 */
obj_t BgL_method1308z00_1741;
{ /* Llib/ssl.scm 1105 */
obj_t BgL_res2732z00_3336;
{ /* Llib/ssl.scm 1105 */
long BgL_objzd2classzd2numz00_3301;
{ /* Llib/ssl.scm 1105 */
long BgL_res2722z00_3304;
BgL_res2722z00_3304 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_dhz00_109)); 
BgL_objzd2classzd2numz00_3301 = BgL_res2722z00_3304; } 
{ /* Llib/ssl.scm 1105 */
obj_t BgL_arg1745z00_3302;
BgL_arg1745z00_3302 = 
PROCEDURE_REF(BGl_dhzd2siza7ezd2envza7zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1105 */
int BgL_offsetz00_3306;
BgL_offsetz00_3306 = 
(int)(BgL_objzd2classzd2numz00_3301); 
{ /* Llib/ssl.scm 1105 */
long BgL_offsetz00_3307;
BgL_offsetz00_3307 = 
(
(long)(BgL_offsetz00_3306)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1105 */
long BgL_modz00_3308;
BgL_modz00_3308 = 
(BgL_offsetz00_3307 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 1105 */
long BgL_restz00_3310;
BgL_restz00_3310 = 
(BgL_offsetz00_3307 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 1105 */

{ /* Llib/ssl.scm 1105 */
obj_t BgL_bucketz00_3312;
BgL_bucketz00_3312 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_3302),BgL_modz00_3308); 
BgL_res2732z00_3336 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3312),BgL_restz00_3310); } } } } } } } } 
BgL_method1308z00_1741 = BgL_res2732z00_3336; } 
return 
CINT(
PROCEDURE_ENTRY(BgL_method1308z00_1741)(BgL_method1308z00_1741, 
((obj_t)BgL_dhz00_109), BEOA));} } 

}



/* &dh-size */
obj_t BGl_z62dhzd2siza7ez17zz__ssl_sslz00(obj_t BgL_envz00_5064, obj_t BgL_dhz00_5065)
{
{ /* Llib/ssl.scm 1105 */
{ /* Llib/ssl.scm 1105 */
int BgL_tmpz00_10030;
{ /* Llib/ssl.scm 1105 */
BgL_dhz00_bglt BgL_auxz00_10031;
if(
BGl_isazf3zf3zz__objectz00(BgL_dhz00_5065, BGl_dhz00zz__ssl_sslz00))
{ /* Llib/ssl.scm 1105 */
BgL_auxz00_10031 = 
((BgL_dhz00_bglt)BgL_dhz00_5065)
; }  else 
{ 
obj_t BgL_auxz00_10035;
BgL_auxz00_10035 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)44956)), BGl_string3727z00zz__ssl_sslz00, BGl_string3726z00zz__ssl_sslz00, BgL_dhz00_5065); 
FAILURE(BgL_auxz00_10035,BFALSE,BFALSE);} 
BgL_tmpz00_10030 = 
BGl_dhzd2siza7ez75zz__ssl_sslz00(BgL_auxz00_10031); } 
return 
BINT(BgL_tmpz00_10030);} } 

}



/* dh-generate-parameters-ex */
BGL_EXPORTED_DEF obj_t BGl_dhzd2generatezd2parameterszd2exzd2zz__ssl_sslz00(BgL_dhz00_bglt BgL_dhz00_110, int BgL_lenz00_111, obj_t BgL_generatorz00_112)
{
{ /* Llib/ssl.scm 1113 */
{ /* Llib/ssl.scm 1113 */
obj_t BgL_method1310z00_1742;
{ /* Llib/ssl.scm 1113 */
obj_t BgL_res2743z00_3373;
{ /* Llib/ssl.scm 1113 */
long BgL_objzd2classzd2numz00_3338;
{ /* Llib/ssl.scm 1113 */
long BgL_res2733z00_3341;
BgL_res2733z00_3341 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_dhz00_110)); 
BgL_objzd2classzd2numz00_3338 = BgL_res2733z00_3341; } 
{ /* Llib/ssl.scm 1113 */
obj_t BgL_arg1745z00_3339;
BgL_arg1745z00_3339 = 
PROCEDURE_REF(BGl_dhzd2generatezd2parameterszd2exzd2envz00zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1113 */
int BgL_offsetz00_3343;
BgL_offsetz00_3343 = 
(int)(BgL_objzd2classzd2numz00_3338); 
{ /* Llib/ssl.scm 1113 */
long BgL_offsetz00_3344;
BgL_offsetz00_3344 = 
(
(long)(BgL_offsetz00_3343)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1113 */
long BgL_modz00_3345;
BgL_modz00_3345 = 
(BgL_offsetz00_3344 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 1113 */
long BgL_restz00_3347;
BgL_restz00_3347 = 
(BgL_offsetz00_3344 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 1113 */

{ /* Llib/ssl.scm 1113 */
obj_t BgL_bucketz00_3349;
BgL_bucketz00_3349 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_3339),BgL_modz00_3345); 
BgL_res2743z00_3373 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3349),BgL_restz00_3347); } } } } } } } } 
BgL_method1310z00_1742 = BgL_res2743z00_3373; } 
return 
PROCEDURE_ENTRY(BgL_method1310z00_1742)(BgL_method1310z00_1742, 
((obj_t)BgL_dhz00_110), 
BINT(BgL_lenz00_111), BgL_generatorz00_112, BEOA);} } 

}



/* &dh-generate-parameters-ex */
obj_t BGl_z62dhzd2generatezd2parameterszd2exzb0zz__ssl_sslz00(obj_t BgL_envz00_5066, obj_t BgL_dhz00_5067, obj_t BgL_lenz00_5068, obj_t BgL_generatorz00_5069)
{
{ /* Llib/ssl.scm 1113 */
{ /* Llib/ssl.scm 1113 */
obj_t BgL_auxz00_10091;int BgL_auxz00_10082;BgL_dhz00_bglt BgL_auxz00_10074;
if(
SYMBOLP(BgL_generatorz00_5069))
{ /* Llib/ssl.scm 1113 */
BgL_auxz00_10091 = BgL_generatorz00_5069
; }  else 
{ 
obj_t BgL_auxz00_10094;
BgL_auxz00_10094 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)45320)), BGl_string3728z00zz__ssl_sslz00, BGl_string3729z00zz__ssl_sslz00, BgL_generatorz00_5069); 
FAILURE(BgL_auxz00_10094,BFALSE,BFALSE);} 
{ /* Llib/ssl.scm 1113 */
obj_t BgL_tmpz00_10083;
if(
INTEGERP(BgL_lenz00_5068))
{ /* Llib/ssl.scm 1113 */
BgL_tmpz00_10083 = BgL_lenz00_5068
; }  else 
{ 
obj_t BgL_auxz00_10086;
BgL_auxz00_10086 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)45320)), BGl_string3728z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_lenz00_5068); 
FAILURE(BgL_auxz00_10086,BFALSE,BFALSE);} 
BgL_auxz00_10082 = 
CINT(BgL_tmpz00_10083); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_dhz00_5067, BGl_dhz00zz__ssl_sslz00))
{ /* Llib/ssl.scm 1113 */
BgL_auxz00_10074 = 
((BgL_dhz00_bglt)BgL_dhz00_5067)
; }  else 
{ 
obj_t BgL_auxz00_10078;
BgL_auxz00_10078 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)45320)), BGl_string3728z00zz__ssl_sslz00, BGl_string3726z00zz__ssl_sslz00, BgL_dhz00_5067); 
FAILURE(BgL_auxz00_10078,BFALSE,BFALSE);} 
return 
BGl_dhzd2generatezd2parameterszd2exzd2zz__ssl_sslz00(BgL_auxz00_10074, BgL_auxz00_10082, BgL_auxz00_10091);} } 

}



/* dh-check */
BGL_EXPORTED_DEF obj_t BGl_dhzd2checkzd2zz__ssl_sslz00(BgL_dhz00_bglt BgL_dhz00_113)
{
{ /* Llib/ssl.scm 1129 */
{ /* Llib/ssl.scm 1129 */
obj_t BgL_method1312z00_1743;
{ /* Llib/ssl.scm 1129 */
obj_t BgL_res2754z00_3410;
{ /* Llib/ssl.scm 1129 */
long BgL_objzd2classzd2numz00_3375;
{ /* Llib/ssl.scm 1129 */
long BgL_res2744z00_3378;
BgL_res2744z00_3378 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_dhz00_113)); 
BgL_objzd2classzd2numz00_3375 = BgL_res2744z00_3378; } 
{ /* Llib/ssl.scm 1129 */
obj_t BgL_arg1745z00_3376;
BgL_arg1745z00_3376 = 
PROCEDURE_REF(BGl_dhzd2checkzd2envz00zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1129 */
int BgL_offsetz00_3380;
BgL_offsetz00_3380 = 
(int)(BgL_objzd2classzd2numz00_3375); 
{ /* Llib/ssl.scm 1129 */
long BgL_offsetz00_3381;
BgL_offsetz00_3381 = 
(
(long)(BgL_offsetz00_3380)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1129 */
long BgL_modz00_3382;
BgL_modz00_3382 = 
(BgL_offsetz00_3381 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 1129 */
long BgL_restz00_3384;
BgL_restz00_3384 = 
(BgL_offsetz00_3381 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 1129 */

{ /* Llib/ssl.scm 1129 */
obj_t BgL_bucketz00_3386;
BgL_bucketz00_3386 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_3376),BgL_modz00_3382); 
BgL_res2754z00_3410 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3386),BgL_restz00_3384); } } } } } } } } 
BgL_method1312z00_1743 = BgL_res2754z00_3410; } 
return 
PROCEDURE_ENTRY(BgL_method1312z00_1743)(BgL_method1312z00_1743, 
((obj_t)BgL_dhz00_113), BEOA);} } 

}



/* &dh-check */
obj_t BGl_z62dhzd2checkzb0zz__ssl_sslz00(obj_t BgL_envz00_5070, obj_t BgL_dhz00_5071)
{
{ /* Llib/ssl.scm 1129 */
{ /* Llib/ssl.scm 1129 */
BgL_dhz00_bglt BgL_auxz00_10129;
if(
BGl_isazf3zf3zz__objectz00(BgL_dhz00_5071, BGl_dhz00zz__ssl_sslz00))
{ /* Llib/ssl.scm 1129 */
BgL_auxz00_10129 = 
((BgL_dhz00_bglt)BgL_dhz00_5071)
; }  else 
{ 
obj_t BgL_auxz00_10133;
BgL_auxz00_10133 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)45908)), BGl_string3730z00zz__ssl_sslz00, BGl_string3726z00zz__ssl_sslz00, BgL_dhz00_5071); 
FAILURE(BgL_auxz00_10133,BFALSE,BFALSE);} 
return 
BGl_dhzd2checkzd2zz__ssl_sslz00(BgL_auxz00_10129);} } 

}



/* dh-check-pub-key */
BGL_EXPORTED_DEF obj_t BGl_dhzd2checkzd2pubzd2keyzd2zz__ssl_sslz00(BgL_dhz00_bglt BgL_dhz00_114, obj_t BgL_keyz00_115)
{
{ /* Llib/ssl.scm 1140 */
{ /* Llib/ssl.scm 1140 */
obj_t BgL_method1314z00_1744;
{ /* Llib/ssl.scm 1140 */
obj_t BgL_res2765z00_3447;
{ /* Llib/ssl.scm 1140 */
long BgL_objzd2classzd2numz00_3412;
{ /* Llib/ssl.scm 1140 */
long BgL_res2755z00_3415;
BgL_res2755z00_3415 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_dhz00_114)); 
BgL_objzd2classzd2numz00_3412 = BgL_res2755z00_3415; } 
{ /* Llib/ssl.scm 1140 */
obj_t BgL_arg1745z00_3413;
BgL_arg1745z00_3413 = 
PROCEDURE_REF(BGl_dhzd2checkzd2pubzd2keyzd2envz00zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1140 */
int BgL_offsetz00_3417;
BgL_offsetz00_3417 = 
(int)(BgL_objzd2classzd2numz00_3412); 
{ /* Llib/ssl.scm 1140 */
long BgL_offsetz00_3418;
BgL_offsetz00_3418 = 
(
(long)(BgL_offsetz00_3417)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1140 */
long BgL_modz00_3419;
BgL_modz00_3419 = 
(BgL_offsetz00_3418 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 1140 */
long BgL_restz00_3421;
BgL_restz00_3421 = 
(BgL_offsetz00_3418 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 1140 */

{ /* Llib/ssl.scm 1140 */
obj_t BgL_bucketz00_3423;
BgL_bucketz00_3423 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_3413),BgL_modz00_3419); 
BgL_res2765z00_3447 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3423),BgL_restz00_3421); } } } } } } } } 
BgL_method1314z00_1744 = BgL_res2765z00_3447; } 
return 
PROCEDURE_ENTRY(BgL_method1314z00_1744)(BgL_method1314z00_1744, 
((obj_t)BgL_dhz00_114), BgL_keyz00_115, BEOA);} } 

}



/* &dh-check-pub-key */
obj_t BGl_z62dhzd2checkzd2pubzd2keyzb0zz__ssl_sslz00(obj_t BgL_envz00_5072, obj_t BgL_dhz00_5073, obj_t BgL_keyz00_5074)
{
{ /* Llib/ssl.scm 1140 */
{ /* Llib/ssl.scm 1140 */
obj_t BgL_auxz00_10177;BgL_dhz00_bglt BgL_auxz00_10169;
if(
FOREIGNP(BgL_keyz00_5074))
{ /* Llib/ssl.scm 1140 */
BgL_auxz00_10177 = BgL_keyz00_5074
; }  else 
{ 
obj_t BgL_auxz00_10180;
BgL_auxz00_10180 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)46288)), BGl_string3731z00zz__ssl_sslz00, BGl_string3397z00zz__ssl_sslz00, BgL_keyz00_5074); 
FAILURE(BgL_auxz00_10180,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_dhz00_5073, BGl_dhz00zz__ssl_sslz00))
{ /* Llib/ssl.scm 1140 */
BgL_auxz00_10169 = 
((BgL_dhz00_bglt)BgL_dhz00_5073)
; }  else 
{ 
obj_t BgL_auxz00_10173;
BgL_auxz00_10173 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)46288)), BGl_string3731z00zz__ssl_sslz00, BGl_string3726z00zz__ssl_sslz00, BgL_dhz00_5073); 
FAILURE(BgL_auxz00_10173,BFALSE,BFALSE);} 
return 
BGl_dhzd2checkzd2pubzd2keyzd2zz__ssl_sslz00(BgL_auxz00_10169, BgL_auxz00_10177);} } 

}



/* dh-compute-key */
BGL_EXPORTED_DEF obj_t BGl_dhzd2computezd2keyz00zz__ssl_sslz00(BgL_dhz00_bglt BgL_dhz00_116, obj_t BgL_keyz00_117)
{
{ /* Llib/ssl.scm 1151 */
{ /* Llib/ssl.scm 1151 */
obj_t BgL_method1316z00_1745;
{ /* Llib/ssl.scm 1151 */
obj_t BgL_res2776z00_3484;
{ /* Llib/ssl.scm 1151 */
long BgL_objzd2classzd2numz00_3449;
{ /* Llib/ssl.scm 1151 */
long BgL_res2766z00_3452;
BgL_res2766z00_3452 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_dhz00_116)); 
BgL_objzd2classzd2numz00_3449 = BgL_res2766z00_3452; } 
{ /* Llib/ssl.scm 1151 */
obj_t BgL_arg1745z00_3450;
BgL_arg1745z00_3450 = 
PROCEDURE_REF(BGl_dhzd2computezd2keyzd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1151 */
int BgL_offsetz00_3454;
BgL_offsetz00_3454 = 
(int)(BgL_objzd2classzd2numz00_3449); 
{ /* Llib/ssl.scm 1151 */
long BgL_offsetz00_3455;
BgL_offsetz00_3455 = 
(
(long)(BgL_offsetz00_3454)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1151 */
long BgL_modz00_3456;
BgL_modz00_3456 = 
(BgL_offsetz00_3455 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 1151 */
long BgL_restz00_3458;
BgL_restz00_3458 = 
(BgL_offsetz00_3455 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 1151 */

{ /* Llib/ssl.scm 1151 */
obj_t BgL_bucketz00_3460;
BgL_bucketz00_3460 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_3450),BgL_modz00_3456); 
BgL_res2776z00_3484 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3460),BgL_restz00_3458); } } } } } } } } 
BgL_method1316z00_1745 = BgL_res2776z00_3484; } 
return 
PROCEDURE_ENTRY(BgL_method1316z00_1745)(BgL_method1316z00_1745, 
((obj_t)BgL_dhz00_116), BgL_keyz00_117, BEOA);} } 

}



/* &dh-compute-key */
obj_t BGl_z62dhzd2computezd2keyz62zz__ssl_sslz00(obj_t BgL_envz00_5075, obj_t BgL_dhz00_5076, obj_t BgL_keyz00_5077)
{
{ /* Llib/ssl.scm 1151 */
{ /* Llib/ssl.scm 1151 */
obj_t BgL_auxz00_10224;BgL_dhz00_bglt BgL_auxz00_10216;
if(
FOREIGNP(BgL_keyz00_5077))
{ /* Llib/ssl.scm 1151 */
BgL_auxz00_10224 = BgL_keyz00_5077
; }  else 
{ 
obj_t BgL_auxz00_10227;
BgL_auxz00_10227 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)46716)), BGl_string3732z00zz__ssl_sslz00, BGl_string3397z00zz__ssl_sslz00, BgL_keyz00_5077); 
FAILURE(BgL_auxz00_10227,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_dhz00_5076, BGl_dhz00zz__ssl_sslz00))
{ /* Llib/ssl.scm 1151 */
BgL_auxz00_10216 = 
((BgL_dhz00_bglt)BgL_dhz00_5076)
; }  else 
{ 
obj_t BgL_auxz00_10220;
BgL_auxz00_10220 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)46716)), BGl_string3732z00zz__ssl_sslz00, BGl_string3726z00zz__ssl_sslz00, BgL_dhz00_5076); 
FAILURE(BgL_auxz00_10220,BFALSE,BFALSE);} 
return 
BGl_dhzd2computezd2keyz00zz__ssl_sslz00(BgL_auxz00_10216, BgL_auxz00_10224);} } 

}



/* dh-generate-key */
BGL_EXPORTED_DEF bool_t BGl_dhzd2generatezd2keyz00zz__ssl_sslz00(BgL_dhz00_bglt BgL_dhz00_118)
{
{ /* Llib/ssl.scm 1177 */
{ /* Llib/ssl.scm 1177 */
obj_t BgL_method1318z00_1746;
{ /* Llib/ssl.scm 1177 */
obj_t BgL_res2787z00_3521;
{ /* Llib/ssl.scm 1177 */
long BgL_objzd2classzd2numz00_3486;
{ /* Llib/ssl.scm 1177 */
long BgL_res2777z00_3489;
BgL_res2777z00_3489 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_dhz00_118)); 
BgL_objzd2classzd2numz00_3486 = BgL_res2777z00_3489; } 
{ /* Llib/ssl.scm 1177 */
obj_t BgL_arg1745z00_3487;
BgL_arg1745z00_3487 = 
PROCEDURE_REF(BGl_dhzd2generatezd2keyzd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1177 */
int BgL_offsetz00_3491;
BgL_offsetz00_3491 = 
(int)(BgL_objzd2classzd2numz00_3486); 
{ /* Llib/ssl.scm 1177 */
long BgL_offsetz00_3492;
BgL_offsetz00_3492 = 
(
(long)(BgL_offsetz00_3491)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1177 */
long BgL_modz00_3493;
BgL_modz00_3493 = 
(BgL_offsetz00_3492 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 1177 */
long BgL_restz00_3495;
BgL_restz00_3495 = 
(BgL_offsetz00_3492 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 1177 */

{ /* Llib/ssl.scm 1177 */
obj_t BgL_bucketz00_3497;
BgL_bucketz00_3497 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_3487),BgL_modz00_3493); 
BgL_res2787z00_3521 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3497),BgL_restz00_3495); } } } } } } } } 
BgL_method1318z00_1746 = BgL_res2787z00_3521; } 
return 
CBOOL(
PROCEDURE_ENTRY(BgL_method1318z00_1746)(BgL_method1318z00_1746, 
((obj_t)BgL_dhz00_118), BEOA));} } 

}



/* &dh-generate-key */
obj_t BGl_z62dhzd2generatezd2keyz62zz__ssl_sslz00(obj_t BgL_envz00_5078, obj_t BgL_dhz00_5079)
{
{ /* Llib/ssl.scm 1177 */
{ /* Llib/ssl.scm 1177 */
bool_t BgL_tmpz00_10263;
{ /* Llib/ssl.scm 1177 */
BgL_dhz00_bglt BgL_auxz00_10264;
if(
BGl_isazf3zf3zz__objectz00(BgL_dhz00_5079, BGl_dhz00zz__ssl_sslz00))
{ /* Llib/ssl.scm 1177 */
BgL_auxz00_10264 = 
((BgL_dhz00_bglt)BgL_dhz00_5079)
; }  else 
{ 
obj_t BgL_auxz00_10268;
BgL_auxz00_10268 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)47513)), BGl_string3733z00zz__ssl_sslz00, BGl_string3726z00zz__ssl_sslz00, BgL_dhz00_5079); 
FAILURE(BgL_auxz00_10268,BFALSE,BFALSE);} 
BgL_tmpz00_10263 = 
BGl_dhzd2generatezd2keyz00zz__ssl_sslz00(BgL_auxz00_10264); } 
return 
BBOOL(BgL_tmpz00_10263);} } 

}



/* ssl-hash-init */
BGL_EXPORTED_DEF obj_t BGl_sslzd2hashzd2initz00zz__ssl_sslz00(BgL_sslzd2hashzd2_bglt BgL_sslzd2hashzd2_119)
{
{ /* Llib/ssl.scm 1188 */
{ /* Llib/ssl.scm 1188 */
obj_t BgL_method1320z00_1747;
{ /* Llib/ssl.scm 1188 */
obj_t BgL_res2798z00_3558;
{ /* Llib/ssl.scm 1188 */
long BgL_objzd2classzd2numz00_3523;
{ /* Llib/ssl.scm 1188 */
long BgL_res2788z00_3526;
BgL_res2788z00_3526 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslzd2hashzd2_119)); 
BgL_objzd2classzd2numz00_3523 = BgL_res2788z00_3526; } 
{ /* Llib/ssl.scm 1188 */
obj_t BgL_arg1745z00_3524;
BgL_arg1745z00_3524 = 
PROCEDURE_REF(BGl_sslzd2hashzd2initzd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1188 */
int BgL_offsetz00_3528;
BgL_offsetz00_3528 = 
(int)(BgL_objzd2classzd2numz00_3523); 
{ /* Llib/ssl.scm 1188 */
long BgL_offsetz00_3529;
BgL_offsetz00_3529 = 
(
(long)(BgL_offsetz00_3528)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1188 */
long BgL_modz00_3530;
BgL_modz00_3530 = 
(BgL_offsetz00_3529 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 1188 */
long BgL_restz00_3532;
BgL_restz00_3532 = 
(BgL_offsetz00_3529 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 1188 */

{ /* Llib/ssl.scm 1188 */
obj_t BgL_bucketz00_3534;
BgL_bucketz00_3534 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_3524),BgL_modz00_3530); 
BgL_res2798z00_3558 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3534),BgL_restz00_3532); } } } } } } } } 
BgL_method1320z00_1747 = BgL_res2798z00_3558; } 
return 
PROCEDURE_ENTRY(BgL_method1320z00_1747)(BgL_method1320z00_1747, 
((obj_t)BgL_sslzd2hashzd2_119), BEOA);} } 

}



/* &ssl-hash-init */
obj_t BGl_z62sslzd2hashzd2initz62zz__ssl_sslz00(obj_t BgL_envz00_4736, obj_t BgL_sslzd2hashzd2_4737)
{
{ /* Llib/ssl.scm 1188 */
{ /* Llib/ssl.scm 1188 */
BgL_sslzd2hashzd2_bglt BgL_auxz00_10304;
if(
BGl_isazf3zf3zz__objectz00(BgL_sslzd2hashzd2_4737, BGl_sslzd2hashzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1188 */
BgL_auxz00_10304 = 
((BgL_sslzd2hashzd2_bglt)BgL_sslzd2hashzd2_4737)
; }  else 
{ 
obj_t BgL_auxz00_10308;
BgL_auxz00_10308 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)47920)), BGl_string3734z00zz__ssl_sslz00, BGl_string3692z00zz__ssl_sslz00, BgL_sslzd2hashzd2_4737); 
FAILURE(BgL_auxz00_10308,BFALSE,BFALSE);} 
return 
BGl_sslzd2hashzd2initz00zz__ssl_sslz00(BgL_auxz00_10304);} } 

}



/* ssl-hash-update! */
BGL_EXPORTED_DEF obj_t BGl_sslzd2hashzd2updatez12z12zz__ssl_sslz00(BgL_sslzd2hashzd2_bglt BgL_sslzd2hashzd2_120, obj_t BgL_dataz00_121, long BgL_offsetz00_122, long BgL_lenz00_123)
{
{ /* Llib/ssl.scm 1200 */
{ /* Llib/ssl.scm 1200 */
obj_t BgL_method1322z00_1748;
{ /* Llib/ssl.scm 1200 */
obj_t BgL_res2809z00_3595;
{ /* Llib/ssl.scm 1200 */
long BgL_objzd2classzd2numz00_3560;
{ /* Llib/ssl.scm 1200 */
long BgL_res2799z00_3563;
BgL_res2799z00_3563 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslzd2hashzd2_120)); 
BgL_objzd2classzd2numz00_3560 = BgL_res2799z00_3563; } 
{ /* Llib/ssl.scm 1200 */
obj_t BgL_arg1745z00_3561;
BgL_arg1745z00_3561 = 
PROCEDURE_REF(BGl_sslzd2hashzd2updatez12zd2envzc0zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1200 */
int BgL_offsetz00_3565;
BgL_offsetz00_3565 = 
(int)(BgL_objzd2classzd2numz00_3560); 
{ /* Llib/ssl.scm 1200 */
long BgL_offsetz00_3566;
BgL_offsetz00_3566 = 
(
(long)(BgL_offsetz00_3565)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1200 */
long BgL_modz00_3567;
BgL_modz00_3567 = 
(BgL_offsetz00_3566 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 1200 */
long BgL_restz00_3569;
BgL_restz00_3569 = 
(BgL_offsetz00_3566 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 1200 */

{ /* Llib/ssl.scm 1200 */
obj_t BgL_bucketz00_3571;
BgL_bucketz00_3571 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_3561),BgL_modz00_3567); 
BgL_res2809z00_3595 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3571),BgL_restz00_3569); } } } } } } } } 
BgL_method1322z00_1748 = BgL_res2809z00_3595; } 
return 
PROCEDURE_ENTRY(BgL_method1322z00_1748)(BgL_method1322z00_1748, 
((obj_t)BgL_sslzd2hashzd2_120), BgL_dataz00_121, 
BINT(BgL_offsetz00_122), 
BINT(BgL_lenz00_123), BEOA);} } 

}



/* &ssl-hash-update! */
obj_t BGl_z62sslzd2hashzd2updatez12z70zz__ssl_sslz00(obj_t BgL_envz00_5080, obj_t BgL_sslzd2hashzd2_5081, obj_t BgL_dataz00_5082, obj_t BgL_offsetz00_5083, obj_t BgL_lenz00_5084)
{
{ /* Llib/ssl.scm 1200 */
{ /* Llib/ssl.scm 1200 */
long BgL_auxz00_10372;long BgL_auxz00_10363;obj_t BgL_auxz00_10356;BgL_sslzd2hashzd2_bglt BgL_auxz00_10348;
{ /* Llib/ssl.scm 1200 */
obj_t BgL_tmpz00_10373;
if(
INTEGERP(BgL_lenz00_5084))
{ /* Llib/ssl.scm 1200 */
BgL_tmpz00_10373 = BgL_lenz00_5084
; }  else 
{ 
obj_t BgL_auxz00_10376;
BgL_auxz00_10376 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)48375)), BGl_string3735z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_lenz00_5084); 
FAILURE(BgL_auxz00_10376,BFALSE,BFALSE);} 
BgL_auxz00_10372 = 
(long)CINT(BgL_tmpz00_10373); } 
{ /* Llib/ssl.scm 1200 */
obj_t BgL_tmpz00_10364;
if(
INTEGERP(BgL_offsetz00_5083))
{ /* Llib/ssl.scm 1200 */
BgL_tmpz00_10364 = BgL_offsetz00_5083
; }  else 
{ 
obj_t BgL_auxz00_10367;
BgL_auxz00_10367 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)48375)), BGl_string3735z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_offsetz00_5083); 
FAILURE(BgL_auxz00_10367,BFALSE,BFALSE);} 
BgL_auxz00_10363 = 
(long)CINT(BgL_tmpz00_10364); } 
if(
STRINGP(BgL_dataz00_5082))
{ /* Llib/ssl.scm 1200 */
BgL_auxz00_10356 = BgL_dataz00_5082
; }  else 
{ 
obj_t BgL_auxz00_10359;
BgL_auxz00_10359 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)48375)), BGl_string3735z00zz__ssl_sslz00, BGl_string3369z00zz__ssl_sslz00, BgL_dataz00_5082); 
FAILURE(BgL_auxz00_10359,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_sslzd2hashzd2_5081, BGl_sslzd2hashzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1200 */
BgL_auxz00_10348 = 
((BgL_sslzd2hashzd2_bglt)BgL_sslzd2hashzd2_5081)
; }  else 
{ 
obj_t BgL_auxz00_10352;
BgL_auxz00_10352 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)48375)), BGl_string3735z00zz__ssl_sslz00, BGl_string3692z00zz__ssl_sslz00, BgL_sslzd2hashzd2_5081); 
FAILURE(BgL_auxz00_10352,BFALSE,BFALSE);} 
return 
BGl_sslzd2hashzd2updatez12z12zz__ssl_sslz00(BgL_auxz00_10348, BgL_auxz00_10356, BgL_auxz00_10363, BgL_auxz00_10372);} } 

}



/* ssl-hash-digest */
BGL_EXPORTED_DEF obj_t BGl_sslzd2hashzd2digestz00zz__ssl_sslz00(BgL_sslzd2hashzd2_bglt BgL_sslzd2hashzd2_124)
{
{ /* Llib/ssl.scm 1212 */
{ /* Llib/ssl.scm 1212 */
obj_t BgL_method1324z00_1749;
{ /* Llib/ssl.scm 1212 */
obj_t BgL_res2820z00_3632;
{ /* Llib/ssl.scm 1212 */
long BgL_objzd2classzd2numz00_3597;
{ /* Llib/ssl.scm 1212 */
long BgL_res2810z00_3600;
BgL_res2810z00_3600 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslzd2hashzd2_124)); 
BgL_objzd2classzd2numz00_3597 = BgL_res2810z00_3600; } 
{ /* Llib/ssl.scm 1212 */
obj_t BgL_arg1745z00_3598;
BgL_arg1745z00_3598 = 
PROCEDURE_REF(BGl_sslzd2hashzd2digestzd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1212 */
int BgL_offsetz00_3602;
BgL_offsetz00_3602 = 
(int)(BgL_objzd2classzd2numz00_3597); 
{ /* Llib/ssl.scm 1212 */
long BgL_offsetz00_3603;
BgL_offsetz00_3603 = 
(
(long)(BgL_offsetz00_3602)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1212 */
long BgL_modz00_3604;
BgL_modz00_3604 = 
(BgL_offsetz00_3603 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 1212 */
long BgL_restz00_3606;
BgL_restz00_3606 = 
(BgL_offsetz00_3603 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 1212 */

{ /* Llib/ssl.scm 1212 */
obj_t BgL_bucketz00_3608;
BgL_bucketz00_3608 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_3598),BgL_modz00_3604); 
BgL_res2820z00_3632 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3608),BgL_restz00_3606); } } } } } } } } 
BgL_method1324z00_1749 = BgL_res2820z00_3632; } 
return 
PROCEDURE_ENTRY(BgL_method1324z00_1749)(BgL_method1324z00_1749, 
((obj_t)BgL_sslzd2hashzd2_124), BEOA);} } 

}



/* &ssl-hash-digest */
obj_t BGl_z62sslzd2hashzd2digestz62zz__ssl_sslz00(obj_t BgL_envz00_5085, obj_t BgL_sslzd2hashzd2_5086)
{
{ /* Llib/ssl.scm 1212 */
{ /* Llib/ssl.scm 1212 */
BgL_sslzd2hashzd2_bglt BgL_auxz00_10412;
if(
BGl_isazf3zf3zz__objectz00(BgL_sslzd2hashzd2_5086, BGl_sslzd2hashzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1212 */
BgL_auxz00_10412 = 
((BgL_sslzd2hashzd2_bglt)BgL_sslzd2hashzd2_5086)
; }  else 
{ 
obj_t BgL_auxz00_10416;
BgL_auxz00_10416 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)48871)), BGl_string3736z00zz__ssl_sslz00, BGl_string3692z00zz__ssl_sslz00, BgL_sslzd2hashzd2_5086); 
FAILURE(BgL_auxz00_10416,BFALSE,BFALSE);} 
return 
BGl_sslzd2hashzd2digestz00zz__ssl_sslz00(BgL_auxz00_10412);} } 

}



/* ssl-hmac-init */
BGL_EXPORTED_DEF obj_t BGl_sslzd2hmaczd2initz00zz__ssl_sslz00(BgL_sslzd2hmaczd2_bglt BgL_sslzd2hmaczd2_125, obj_t BgL_hmacz00_126, obj_t BgL_keyz00_127)
{
{ /* Llib/ssl.scm 1223 */
{ /* Llib/ssl.scm 1223 */
obj_t BgL_method1326z00_1750;
{ /* Llib/ssl.scm 1223 */
obj_t BgL_res2831z00_3669;
{ /* Llib/ssl.scm 1223 */
long BgL_objzd2classzd2numz00_3634;
{ /* Llib/ssl.scm 1223 */
long BgL_res2821z00_3637;
BgL_res2821z00_3637 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslzd2hmaczd2_125)); 
BgL_objzd2classzd2numz00_3634 = BgL_res2821z00_3637; } 
{ /* Llib/ssl.scm 1223 */
obj_t BgL_arg1745z00_3635;
BgL_arg1745z00_3635 = 
PROCEDURE_REF(BGl_sslzd2hmaczd2initzd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1223 */
int BgL_offsetz00_3639;
BgL_offsetz00_3639 = 
(int)(BgL_objzd2classzd2numz00_3634); 
{ /* Llib/ssl.scm 1223 */
long BgL_offsetz00_3640;
BgL_offsetz00_3640 = 
(
(long)(BgL_offsetz00_3639)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1223 */
long BgL_modz00_3641;
BgL_modz00_3641 = 
(BgL_offsetz00_3640 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 1223 */
long BgL_restz00_3643;
BgL_restz00_3643 = 
(BgL_offsetz00_3640 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 1223 */

{ /* Llib/ssl.scm 1223 */
obj_t BgL_bucketz00_3645;
BgL_bucketz00_3645 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_3635),BgL_modz00_3641); 
BgL_res2831z00_3669 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3645),BgL_restz00_3643); } } } } } } } } 
BgL_method1326z00_1750 = BgL_res2831z00_3669; } 
return 
PROCEDURE_ENTRY(BgL_method1326z00_1750)(BgL_method1326z00_1750, 
((obj_t)BgL_sslzd2hmaczd2_125), BgL_hmacz00_126, BgL_keyz00_127, BEOA);} } 

}



/* &ssl-hmac-init */
obj_t BGl_z62sslzd2hmaczd2initz62zz__ssl_sslz00(obj_t BgL_envz00_5087, obj_t BgL_sslzd2hmaczd2_5088, obj_t BgL_hmacz00_5089, obj_t BgL_keyz00_5090)
{
{ /* Llib/ssl.scm 1223 */
{ /* Llib/ssl.scm 1223 */
obj_t BgL_auxz00_10468;obj_t BgL_auxz00_10461;BgL_sslzd2hmaczd2_bglt BgL_auxz00_10453;
if(
STRINGP(BgL_keyz00_5090))
{ /* Llib/ssl.scm 1223 */
BgL_auxz00_10468 = BgL_keyz00_5090
; }  else 
{ 
obj_t BgL_auxz00_10471;
BgL_auxz00_10471 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)49317)), BGl_string3737z00zz__ssl_sslz00, BGl_string3369z00zz__ssl_sslz00, BgL_keyz00_5090); 
FAILURE(BgL_auxz00_10471,BFALSE,BFALSE);} 
if(
STRINGP(BgL_hmacz00_5089))
{ /* Llib/ssl.scm 1223 */
BgL_auxz00_10461 = BgL_hmacz00_5089
; }  else 
{ 
obj_t BgL_auxz00_10464;
BgL_auxz00_10464 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)49317)), BGl_string3737z00zz__ssl_sslz00, BGl_string3369z00zz__ssl_sslz00, BgL_hmacz00_5089); 
FAILURE(BgL_auxz00_10464,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_sslzd2hmaczd2_5088, BGl_sslzd2hmaczd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1223 */
BgL_auxz00_10453 = 
((BgL_sslzd2hmaczd2_bglt)BgL_sslzd2hmaczd2_5088)
; }  else 
{ 
obj_t BgL_auxz00_10457;
BgL_auxz00_10457 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)49317)), BGl_string3737z00zz__ssl_sslz00, BGl_string3688z00zz__ssl_sslz00, BgL_sslzd2hmaczd2_5088); 
FAILURE(BgL_auxz00_10457,BFALSE,BFALSE);} 
return 
BGl_sslzd2hmaczd2initz00zz__ssl_sslz00(BgL_auxz00_10453, BgL_auxz00_10461, BgL_auxz00_10468);} } 

}



/* ssl-hmac-update! */
BGL_EXPORTED_DEF obj_t BGl_sslzd2hmaczd2updatez12z12zz__ssl_sslz00(BgL_sslzd2hmaczd2_bglt BgL_sslzd2hmaczd2_128, obj_t BgL_dataz00_129, long BgL_offsetz00_130, long BgL_lenz00_131)
{
{ /* Llib/ssl.scm 1235 */
{ /* Llib/ssl.scm 1235 */
obj_t BgL_method1328z00_1751;
{ /* Llib/ssl.scm 1235 */
obj_t BgL_res2842z00_3706;
{ /* Llib/ssl.scm 1235 */
long BgL_objzd2classzd2numz00_3671;
{ /* Llib/ssl.scm 1235 */
long BgL_res2832z00_3674;
BgL_res2832z00_3674 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslzd2hmaczd2_128)); 
BgL_objzd2classzd2numz00_3671 = BgL_res2832z00_3674; } 
{ /* Llib/ssl.scm 1235 */
obj_t BgL_arg1745z00_3672;
BgL_arg1745z00_3672 = 
PROCEDURE_REF(BGl_sslzd2hmaczd2updatez12zd2envzc0zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1235 */
int BgL_offsetz00_3676;
BgL_offsetz00_3676 = 
(int)(BgL_objzd2classzd2numz00_3671); 
{ /* Llib/ssl.scm 1235 */
long BgL_offsetz00_3677;
BgL_offsetz00_3677 = 
(
(long)(BgL_offsetz00_3676)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1235 */
long BgL_modz00_3678;
BgL_modz00_3678 = 
(BgL_offsetz00_3677 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 1235 */
long BgL_restz00_3680;
BgL_restz00_3680 = 
(BgL_offsetz00_3677 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 1235 */

{ /* Llib/ssl.scm 1235 */
obj_t BgL_bucketz00_3682;
BgL_bucketz00_3682 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_3672),BgL_modz00_3678); 
BgL_res2842z00_3706 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3682),BgL_restz00_3680); } } } } } } } } 
BgL_method1328z00_1751 = BgL_res2842z00_3706; } 
return 
PROCEDURE_ENTRY(BgL_method1328z00_1751)(BgL_method1328z00_1751, 
((obj_t)BgL_sslzd2hmaczd2_128), BgL_dataz00_129, 
BINT(BgL_offsetz00_130), 
BINT(BgL_lenz00_131), BEOA);} } 

}



/* &ssl-hmac-update! */
obj_t BGl_z62sslzd2hmaczd2updatez12z70zz__ssl_sslz00(obj_t BgL_envz00_5091, obj_t BgL_sslzd2hmaczd2_5092, obj_t BgL_dataz00_5093, obj_t BgL_offsetz00_5094, obj_t BgL_lenz00_5095)
{
{ /* Llib/ssl.scm 1235 */
{ /* Llib/ssl.scm 1235 */
long BgL_auxz00_10535;long BgL_auxz00_10526;obj_t BgL_auxz00_10519;BgL_sslzd2hmaczd2_bglt BgL_auxz00_10511;
{ /* Llib/ssl.scm 1235 */
obj_t BgL_tmpz00_10536;
if(
INTEGERP(BgL_lenz00_5095))
{ /* Llib/ssl.scm 1235 */
BgL_tmpz00_10536 = BgL_lenz00_5095
; }  else 
{ 
obj_t BgL_auxz00_10539;
BgL_auxz00_10539 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)49786)), BGl_string3738z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_lenz00_5095); 
FAILURE(BgL_auxz00_10539,BFALSE,BFALSE);} 
BgL_auxz00_10535 = 
(long)CINT(BgL_tmpz00_10536); } 
{ /* Llib/ssl.scm 1235 */
obj_t BgL_tmpz00_10527;
if(
INTEGERP(BgL_offsetz00_5094))
{ /* Llib/ssl.scm 1235 */
BgL_tmpz00_10527 = BgL_offsetz00_5094
; }  else 
{ 
obj_t BgL_auxz00_10530;
BgL_auxz00_10530 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)49786)), BGl_string3738z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_offsetz00_5094); 
FAILURE(BgL_auxz00_10530,BFALSE,BFALSE);} 
BgL_auxz00_10526 = 
(long)CINT(BgL_tmpz00_10527); } 
if(
STRINGP(BgL_dataz00_5093))
{ /* Llib/ssl.scm 1235 */
BgL_auxz00_10519 = BgL_dataz00_5093
; }  else 
{ 
obj_t BgL_auxz00_10522;
BgL_auxz00_10522 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)49786)), BGl_string3738z00zz__ssl_sslz00, BGl_string3369z00zz__ssl_sslz00, BgL_dataz00_5093); 
FAILURE(BgL_auxz00_10522,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_sslzd2hmaczd2_5092, BGl_sslzd2hmaczd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1235 */
BgL_auxz00_10511 = 
((BgL_sslzd2hmaczd2_bglt)BgL_sslzd2hmaczd2_5092)
; }  else 
{ 
obj_t BgL_auxz00_10515;
BgL_auxz00_10515 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)49786)), BGl_string3738z00zz__ssl_sslz00, BGl_string3688z00zz__ssl_sslz00, BgL_sslzd2hmaczd2_5092); 
FAILURE(BgL_auxz00_10515,BFALSE,BFALSE);} 
return 
BGl_sslzd2hmaczd2updatez12z12zz__ssl_sslz00(BgL_auxz00_10511, BgL_auxz00_10519, BgL_auxz00_10526, BgL_auxz00_10535);} } 

}



/* ssl-hmac-digest */
BGL_EXPORTED_DEF obj_t BGl_sslzd2hmaczd2digestz00zz__ssl_sslz00(BgL_sslzd2hmaczd2_bglt BgL_sslzd2hmaczd2_132)
{
{ /* Llib/ssl.scm 1247 */
{ /* Llib/ssl.scm 1247 */
obj_t BgL_method1330z00_1752;
{ /* Llib/ssl.scm 1247 */
obj_t BgL_res2853z00_3743;
{ /* Llib/ssl.scm 1247 */
long BgL_objzd2classzd2numz00_3708;
{ /* Llib/ssl.scm 1247 */
long BgL_res2843z00_3711;
BgL_res2843z00_3711 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslzd2hmaczd2_132)); 
BgL_objzd2classzd2numz00_3708 = BgL_res2843z00_3711; } 
{ /* Llib/ssl.scm 1247 */
obj_t BgL_arg1745z00_3709;
BgL_arg1745z00_3709 = 
PROCEDURE_REF(BGl_sslzd2hmaczd2digestzd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1247 */
int BgL_offsetz00_3713;
BgL_offsetz00_3713 = 
(int)(BgL_objzd2classzd2numz00_3708); 
{ /* Llib/ssl.scm 1247 */
long BgL_offsetz00_3714;
BgL_offsetz00_3714 = 
(
(long)(BgL_offsetz00_3713)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1247 */
long BgL_modz00_3715;
BgL_modz00_3715 = 
(BgL_offsetz00_3714 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 1247 */
long BgL_restz00_3717;
BgL_restz00_3717 = 
(BgL_offsetz00_3714 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 1247 */

{ /* Llib/ssl.scm 1247 */
obj_t BgL_bucketz00_3719;
BgL_bucketz00_3719 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_3709),BgL_modz00_3715); 
BgL_res2853z00_3743 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3719),BgL_restz00_3717); } } } } } } } } 
BgL_method1330z00_1752 = BgL_res2853z00_3743; } 
return 
PROCEDURE_ENTRY(BgL_method1330z00_1752)(BgL_method1330z00_1752, 
((obj_t)BgL_sslzd2hmaczd2_132), BEOA);} } 

}



/* &ssl-hmac-digest */
obj_t BGl_z62sslzd2hmaczd2digestz62zz__ssl_sslz00(obj_t BgL_envz00_5096, obj_t BgL_sslzd2hmaczd2_5097)
{
{ /* Llib/ssl.scm 1247 */
{ /* Llib/ssl.scm 1247 */
BgL_sslzd2hmaczd2_bglt BgL_auxz00_10575;
if(
BGl_isazf3zf3zz__objectz00(BgL_sslzd2hmaczd2_5097, BGl_sslzd2hmaczd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1247 */
BgL_auxz00_10575 = 
((BgL_sslzd2hmaczd2_bglt)BgL_sslzd2hmaczd2_5097)
; }  else 
{ 
obj_t BgL_auxz00_10579;
BgL_auxz00_10579 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)50282)), BGl_string3739z00zz__ssl_sslz00, BGl_string3688z00zz__ssl_sslz00, BgL_sslzd2hmaczd2_5097); 
FAILURE(BgL_auxz00_10579,BFALSE,BFALSE);} 
return 
BGl_sslzd2hmaczd2digestz00zz__ssl_sslz00(BgL_auxz00_10575);} } 

}



/* ssl-sign-init */
BGL_EXPORTED_DEF obj_t BGl_sslzd2signzd2initz00zz__ssl_sslz00(BgL_sslzd2signzd2_bglt BgL_sslzd2signzd2_133, obj_t BgL_signz00_134)
{
{ /* Llib/ssl.scm 1258 */
{ /* Llib/ssl.scm 1258 */
obj_t BgL_method1332z00_1753;
{ /* Llib/ssl.scm 1258 */
obj_t BgL_res2864z00_3780;
{ /* Llib/ssl.scm 1258 */
long BgL_objzd2classzd2numz00_3745;
{ /* Llib/ssl.scm 1258 */
long BgL_res2854z00_3748;
BgL_res2854z00_3748 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslzd2signzd2_133)); 
BgL_objzd2classzd2numz00_3745 = BgL_res2854z00_3748; } 
{ /* Llib/ssl.scm 1258 */
obj_t BgL_arg1745z00_3746;
BgL_arg1745z00_3746 = 
PROCEDURE_REF(BGl_sslzd2signzd2initzd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1258 */
int BgL_offsetz00_3750;
BgL_offsetz00_3750 = 
(int)(BgL_objzd2classzd2numz00_3745); 
{ /* Llib/ssl.scm 1258 */
long BgL_offsetz00_3751;
BgL_offsetz00_3751 = 
(
(long)(BgL_offsetz00_3750)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1258 */
long BgL_modz00_3752;
BgL_modz00_3752 = 
(BgL_offsetz00_3751 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 1258 */
long BgL_restz00_3754;
BgL_restz00_3754 = 
(BgL_offsetz00_3751 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 1258 */

{ /* Llib/ssl.scm 1258 */
obj_t BgL_bucketz00_3756;
BgL_bucketz00_3756 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_3746),BgL_modz00_3752); 
BgL_res2864z00_3780 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3756),BgL_restz00_3754); } } } } } } } } 
BgL_method1332z00_1753 = BgL_res2864z00_3780; } 
return 
PROCEDURE_ENTRY(BgL_method1332z00_1753)(BgL_method1332z00_1753, 
((obj_t)BgL_sslzd2signzd2_133), BgL_signz00_134, BEOA);} } 

}



/* &ssl-sign-init */
obj_t BGl_z62sslzd2signzd2initz62zz__ssl_sslz00(obj_t BgL_envz00_5098, obj_t BgL_sslzd2signzd2_5099, obj_t BgL_signz00_5100)
{
{ /* Llib/ssl.scm 1258 */
{ /* Llib/ssl.scm 1258 */
obj_t BgL_auxz00_10623;BgL_sslzd2signzd2_bglt BgL_auxz00_10615;
if(
STRINGP(BgL_signz00_5100))
{ /* Llib/ssl.scm 1258 */
BgL_auxz00_10623 = BgL_signz00_5100
; }  else 
{ 
obj_t BgL_auxz00_10626;
BgL_auxz00_10626 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)50728)), BGl_string3740z00zz__ssl_sslz00, BGl_string3369z00zz__ssl_sslz00, BgL_signz00_5100); 
FAILURE(BgL_auxz00_10626,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_sslzd2signzd2_5099, BGl_sslzd2signzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1258 */
BgL_auxz00_10615 = 
((BgL_sslzd2signzd2_bglt)BgL_sslzd2signzd2_5099)
; }  else 
{ 
obj_t BgL_auxz00_10619;
BgL_auxz00_10619 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)50728)), BGl_string3740z00zz__ssl_sslz00, BGl_string3683z00zz__ssl_sslz00, BgL_sslzd2signzd2_5099); 
FAILURE(BgL_auxz00_10619,BFALSE,BFALSE);} 
return 
BGl_sslzd2signzd2initz00zz__ssl_sslz00(BgL_auxz00_10615, BgL_auxz00_10623);} } 

}



/* ssl-sign-update! */
BGL_EXPORTED_DEF obj_t BGl_sslzd2signzd2updatez12z12zz__ssl_sslz00(BgL_sslzd2signzd2_bglt BgL_sslzd2signzd2_135, obj_t BgL_dataz00_136, long BgL_offsetz00_137, long BgL_lenz00_138)
{
{ /* Llib/ssl.scm 1270 */
{ /* Llib/ssl.scm 1270 */
obj_t BgL_method1334z00_1754;
{ /* Llib/ssl.scm 1270 */
obj_t BgL_res2875z00_3817;
{ /* Llib/ssl.scm 1270 */
long BgL_objzd2classzd2numz00_3782;
{ /* Llib/ssl.scm 1270 */
long BgL_res2865z00_3785;
BgL_res2865z00_3785 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslzd2signzd2_135)); 
BgL_objzd2classzd2numz00_3782 = BgL_res2865z00_3785; } 
{ /* Llib/ssl.scm 1270 */
obj_t BgL_arg1745z00_3783;
BgL_arg1745z00_3783 = 
PROCEDURE_REF(BGl_sslzd2signzd2updatez12zd2envzc0zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1270 */
int BgL_offsetz00_3787;
BgL_offsetz00_3787 = 
(int)(BgL_objzd2classzd2numz00_3782); 
{ /* Llib/ssl.scm 1270 */
long BgL_offsetz00_3788;
BgL_offsetz00_3788 = 
(
(long)(BgL_offsetz00_3787)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1270 */
long BgL_modz00_3789;
BgL_modz00_3789 = 
(BgL_offsetz00_3788 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 1270 */
long BgL_restz00_3791;
BgL_restz00_3791 = 
(BgL_offsetz00_3788 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 1270 */

{ /* Llib/ssl.scm 1270 */
obj_t BgL_bucketz00_3793;
BgL_bucketz00_3793 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_3783),BgL_modz00_3789); 
BgL_res2875z00_3817 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3793),BgL_restz00_3791); } } } } } } } } 
BgL_method1334z00_1754 = BgL_res2875z00_3817; } 
return 
PROCEDURE_ENTRY(BgL_method1334z00_1754)(BgL_method1334z00_1754, 
((obj_t)BgL_sslzd2signzd2_135), BgL_dataz00_136, 
BINT(BgL_offsetz00_137), 
BINT(BgL_lenz00_138), BEOA);} } 

}



/* &ssl-sign-update! */
obj_t BGl_z62sslzd2signzd2updatez12z70zz__ssl_sslz00(obj_t BgL_envz00_5101, obj_t BgL_sslzd2signzd2_5102, obj_t BgL_dataz00_5103, obj_t BgL_offsetz00_5104, obj_t BgL_lenz00_5105)
{
{ /* Llib/ssl.scm 1270 */
{ /* Llib/ssl.scm 1270 */
long BgL_auxz00_10690;long BgL_auxz00_10681;obj_t BgL_auxz00_10674;BgL_sslzd2signzd2_bglt BgL_auxz00_10666;
{ /* Llib/ssl.scm 1270 */
obj_t BgL_tmpz00_10691;
if(
INTEGERP(BgL_lenz00_5105))
{ /* Llib/ssl.scm 1270 */
BgL_tmpz00_10691 = BgL_lenz00_5105
; }  else 
{ 
obj_t BgL_auxz00_10694;
BgL_auxz00_10694 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)51191)), BGl_string3741z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_lenz00_5105); 
FAILURE(BgL_auxz00_10694,BFALSE,BFALSE);} 
BgL_auxz00_10690 = 
(long)CINT(BgL_tmpz00_10691); } 
{ /* Llib/ssl.scm 1270 */
obj_t BgL_tmpz00_10682;
if(
INTEGERP(BgL_offsetz00_5104))
{ /* Llib/ssl.scm 1270 */
BgL_tmpz00_10682 = BgL_offsetz00_5104
; }  else 
{ 
obj_t BgL_auxz00_10685;
BgL_auxz00_10685 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)51191)), BGl_string3741z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_offsetz00_5104); 
FAILURE(BgL_auxz00_10685,BFALSE,BFALSE);} 
BgL_auxz00_10681 = 
(long)CINT(BgL_tmpz00_10682); } 
if(
STRINGP(BgL_dataz00_5103))
{ /* Llib/ssl.scm 1270 */
BgL_auxz00_10674 = BgL_dataz00_5103
; }  else 
{ 
obj_t BgL_auxz00_10677;
BgL_auxz00_10677 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)51191)), BGl_string3741z00zz__ssl_sslz00, BGl_string3369z00zz__ssl_sslz00, BgL_dataz00_5103); 
FAILURE(BgL_auxz00_10677,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_sslzd2signzd2_5102, BGl_sslzd2signzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1270 */
BgL_auxz00_10666 = 
((BgL_sslzd2signzd2_bglt)BgL_sslzd2signzd2_5102)
; }  else 
{ 
obj_t BgL_auxz00_10670;
BgL_auxz00_10670 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)51191)), BGl_string3741z00zz__ssl_sslz00, BGl_string3683z00zz__ssl_sslz00, BgL_sslzd2signzd2_5102); 
FAILURE(BgL_auxz00_10670,BFALSE,BFALSE);} 
return 
BGl_sslzd2signzd2updatez12z12zz__ssl_sslz00(BgL_auxz00_10666, BgL_auxz00_10674, BgL_auxz00_10681, BgL_auxz00_10690);} } 

}



/* ssl-sign-sign */
BGL_EXPORTED_DEF obj_t BGl_sslzd2signzd2signz00zz__ssl_sslz00(BgL_sslzd2signzd2_bglt BgL_sslzd2signzd2_139, obj_t BgL_keyz00_140, long BgL_offsetz00_141, long BgL_lenz00_142)
{
{ /* Llib/ssl.scm 1282 */
{ /* Llib/ssl.scm 1282 */
obj_t BgL_method1336z00_1755;
{ /* Llib/ssl.scm 1282 */
obj_t BgL_res2886z00_3854;
{ /* Llib/ssl.scm 1282 */
long BgL_objzd2classzd2numz00_3819;
{ /* Llib/ssl.scm 1282 */
long BgL_res2876z00_3822;
BgL_res2876z00_3822 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslzd2signzd2_139)); 
BgL_objzd2classzd2numz00_3819 = BgL_res2876z00_3822; } 
{ /* Llib/ssl.scm 1282 */
obj_t BgL_arg1745z00_3820;
BgL_arg1745z00_3820 = 
PROCEDURE_REF(BGl_sslzd2signzd2signzd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1282 */
int BgL_offsetz00_3824;
BgL_offsetz00_3824 = 
(int)(BgL_objzd2classzd2numz00_3819); 
{ /* Llib/ssl.scm 1282 */
long BgL_offsetz00_3825;
BgL_offsetz00_3825 = 
(
(long)(BgL_offsetz00_3824)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1282 */
long BgL_modz00_3826;
BgL_modz00_3826 = 
(BgL_offsetz00_3825 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 1282 */
long BgL_restz00_3828;
BgL_restz00_3828 = 
(BgL_offsetz00_3825 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 1282 */

{ /* Llib/ssl.scm 1282 */
obj_t BgL_bucketz00_3830;
BgL_bucketz00_3830 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_3820),BgL_modz00_3826); 
BgL_res2886z00_3854 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3830),BgL_restz00_3828); } } } } } } } } 
BgL_method1336z00_1755 = BgL_res2886z00_3854; } 
return 
PROCEDURE_ENTRY(BgL_method1336z00_1755)(BgL_method1336z00_1755, 
((obj_t)BgL_sslzd2signzd2_139), BgL_keyz00_140, 
BINT(BgL_offsetz00_141), 
BINT(BgL_lenz00_142), BEOA);} } 

}



/* &ssl-sign-sign */
obj_t BGl_z62sslzd2signzd2signz62zz__ssl_sslz00(obj_t BgL_envz00_5106, obj_t BgL_sslzd2signzd2_5107, obj_t BgL_keyz00_5108, obj_t BgL_offsetz00_5109, obj_t BgL_lenz00_5110)
{
{ /* Llib/ssl.scm 1282 */
{ /* Llib/ssl.scm 1282 */
long BgL_auxz00_10759;long BgL_auxz00_10750;obj_t BgL_auxz00_10743;BgL_sslzd2signzd2_bglt BgL_auxz00_10735;
{ /* Llib/ssl.scm 1282 */
obj_t BgL_tmpz00_10760;
if(
INTEGERP(BgL_lenz00_5110))
{ /* Llib/ssl.scm 1282 */
BgL_tmpz00_10760 = BgL_lenz00_5110
; }  else 
{ 
obj_t BgL_auxz00_10763;
BgL_auxz00_10763 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)51687)), BGl_string3742z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_lenz00_5110); 
FAILURE(BgL_auxz00_10763,BFALSE,BFALSE);} 
BgL_auxz00_10759 = 
(long)CINT(BgL_tmpz00_10760); } 
{ /* Llib/ssl.scm 1282 */
obj_t BgL_tmpz00_10751;
if(
INTEGERP(BgL_offsetz00_5109))
{ /* Llib/ssl.scm 1282 */
BgL_tmpz00_10751 = BgL_offsetz00_5109
; }  else 
{ 
obj_t BgL_auxz00_10754;
BgL_auxz00_10754 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)51687)), BGl_string3742z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_offsetz00_5109); 
FAILURE(BgL_auxz00_10754,BFALSE,BFALSE);} 
BgL_auxz00_10750 = 
(long)CINT(BgL_tmpz00_10751); } 
if(
STRINGP(BgL_keyz00_5108))
{ /* Llib/ssl.scm 1282 */
BgL_auxz00_10743 = BgL_keyz00_5108
; }  else 
{ 
obj_t BgL_auxz00_10746;
BgL_auxz00_10746 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)51687)), BGl_string3742z00zz__ssl_sslz00, BGl_string3369z00zz__ssl_sslz00, BgL_keyz00_5108); 
FAILURE(BgL_auxz00_10746,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_sslzd2signzd2_5107, BGl_sslzd2signzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1282 */
BgL_auxz00_10735 = 
((BgL_sslzd2signzd2_bglt)BgL_sslzd2signzd2_5107)
; }  else 
{ 
obj_t BgL_auxz00_10739;
BgL_auxz00_10739 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)51687)), BGl_string3742z00zz__ssl_sslz00, BGl_string3683z00zz__ssl_sslz00, BgL_sslzd2signzd2_5107); 
FAILURE(BgL_auxz00_10739,BFALSE,BFALSE);} 
return 
BGl_sslzd2signzd2signz00zz__ssl_sslz00(BgL_auxz00_10735, BgL_auxz00_10743, BgL_auxz00_10750, BgL_auxz00_10759);} } 

}



/* ssl-verify-init */
BGL_EXPORTED_DEF obj_t BGl_sslzd2verifyzd2initz00zz__ssl_sslz00(BgL_sslzd2verifyzd2_bglt BgL_sslzd2verifyzd2_143, obj_t BgL_verifyz00_144)
{
{ /* Llib/ssl.scm 1293 */
{ /* Llib/ssl.scm 1293 */
obj_t BgL_method1338z00_1756;
{ /* Llib/ssl.scm 1293 */
obj_t BgL_res2897z00_3891;
{ /* Llib/ssl.scm 1293 */
long BgL_objzd2classzd2numz00_3856;
{ /* Llib/ssl.scm 1293 */
long BgL_res2887z00_3859;
BgL_res2887z00_3859 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslzd2verifyzd2_143)); 
BgL_objzd2classzd2numz00_3856 = BgL_res2887z00_3859; } 
{ /* Llib/ssl.scm 1293 */
obj_t BgL_arg1745z00_3857;
BgL_arg1745z00_3857 = 
PROCEDURE_REF(BGl_sslzd2verifyzd2initzd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1293 */
int BgL_offsetz00_3861;
BgL_offsetz00_3861 = 
(int)(BgL_objzd2classzd2numz00_3856); 
{ /* Llib/ssl.scm 1293 */
long BgL_offsetz00_3862;
BgL_offsetz00_3862 = 
(
(long)(BgL_offsetz00_3861)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1293 */
long BgL_modz00_3863;
BgL_modz00_3863 = 
(BgL_offsetz00_3862 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 1293 */
long BgL_restz00_3865;
BgL_restz00_3865 = 
(BgL_offsetz00_3862 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 1293 */

{ /* Llib/ssl.scm 1293 */
obj_t BgL_bucketz00_3867;
BgL_bucketz00_3867 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_3857),BgL_modz00_3863); 
BgL_res2897z00_3891 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3867),BgL_restz00_3865); } } } } } } } } 
BgL_method1338z00_1756 = BgL_res2897z00_3891; } 
return 
PROCEDURE_ENTRY(BgL_method1338z00_1756)(BgL_method1338z00_1756, 
((obj_t)BgL_sslzd2verifyzd2_143), BgL_verifyz00_144, BEOA);} } 

}



/* &ssl-verify-init */
obj_t BGl_z62sslzd2verifyzd2initz62zz__ssl_sslz00(obj_t BgL_envz00_5111, obj_t BgL_sslzd2verifyzd2_5112, obj_t BgL_verifyz00_5113)
{
{ /* Llib/ssl.scm 1293 */
{ /* Llib/ssl.scm 1293 */
obj_t BgL_auxz00_10808;BgL_sslzd2verifyzd2_bglt BgL_auxz00_10800;
if(
STRINGP(BgL_verifyz00_5113))
{ /* Llib/ssl.scm 1293 */
BgL_auxz00_10808 = BgL_verifyz00_5113
; }  else 
{ 
obj_t BgL_auxz00_10811;
BgL_auxz00_10811 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)52164)), BGl_string3743z00zz__ssl_sslz00, BGl_string3369z00zz__ssl_sslz00, BgL_verifyz00_5113); 
FAILURE(BgL_auxz00_10811,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_sslzd2verifyzd2_5112, BGl_sslzd2verifyzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1293 */
BgL_auxz00_10800 = 
((BgL_sslzd2verifyzd2_bglt)BgL_sslzd2verifyzd2_5112)
; }  else 
{ 
obj_t BgL_auxz00_10804;
BgL_auxz00_10804 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)52164)), BGl_string3743z00zz__ssl_sslz00, BGl_string3678z00zz__ssl_sslz00, BgL_sslzd2verifyzd2_5112); 
FAILURE(BgL_auxz00_10804,BFALSE,BFALSE);} 
return 
BGl_sslzd2verifyzd2initz00zz__ssl_sslz00(BgL_auxz00_10800, BgL_auxz00_10808);} } 

}



/* ssl-verify-update! */
BGL_EXPORTED_DEF obj_t BGl_sslzd2verifyzd2updatez12z12zz__ssl_sslz00(BgL_sslzd2verifyzd2_bglt BgL_sslzd2verifyzd2_145, obj_t BgL_dataz00_146, long BgL_offsetz00_147, long BgL_lenz00_148)
{
{ /* Llib/ssl.scm 1305 */
{ /* Llib/ssl.scm 1305 */
obj_t BgL_method1340z00_1757;
{ /* Llib/ssl.scm 1305 */
obj_t BgL_res2908z00_3928;
{ /* Llib/ssl.scm 1305 */
long BgL_objzd2classzd2numz00_3893;
{ /* Llib/ssl.scm 1305 */
long BgL_res2898z00_3896;
BgL_res2898z00_3896 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslzd2verifyzd2_145)); 
BgL_objzd2classzd2numz00_3893 = BgL_res2898z00_3896; } 
{ /* Llib/ssl.scm 1305 */
obj_t BgL_arg1745z00_3894;
BgL_arg1745z00_3894 = 
PROCEDURE_REF(BGl_sslzd2verifyzd2updatez12zd2envzc0zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1305 */
int BgL_offsetz00_3898;
BgL_offsetz00_3898 = 
(int)(BgL_objzd2classzd2numz00_3893); 
{ /* Llib/ssl.scm 1305 */
long BgL_offsetz00_3899;
BgL_offsetz00_3899 = 
(
(long)(BgL_offsetz00_3898)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1305 */
long BgL_modz00_3900;
BgL_modz00_3900 = 
(BgL_offsetz00_3899 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 1305 */
long BgL_restz00_3902;
BgL_restz00_3902 = 
(BgL_offsetz00_3899 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 1305 */

{ /* Llib/ssl.scm 1305 */
obj_t BgL_bucketz00_3904;
BgL_bucketz00_3904 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_3894),BgL_modz00_3900); 
BgL_res2908z00_3928 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3904),BgL_restz00_3902); } } } } } } } } 
BgL_method1340z00_1757 = BgL_res2908z00_3928; } 
return 
PROCEDURE_ENTRY(BgL_method1340z00_1757)(BgL_method1340z00_1757, 
((obj_t)BgL_sslzd2verifyzd2_145), BgL_dataz00_146, 
BINT(BgL_offsetz00_147), 
BINT(BgL_lenz00_148), BEOA);} } 

}



/* &ssl-verify-update! */
obj_t BGl_z62sslzd2verifyzd2updatez12z70zz__ssl_sslz00(obj_t BgL_envz00_5114, obj_t BgL_sslzd2verifyzd2_5115, obj_t BgL_dataz00_5116, obj_t BgL_offsetz00_5117, obj_t BgL_lenz00_5118)
{
{ /* Llib/ssl.scm 1305 */
{ /* Llib/ssl.scm 1305 */
long BgL_auxz00_10875;long BgL_auxz00_10866;obj_t BgL_auxz00_10859;BgL_sslzd2verifyzd2_bglt BgL_auxz00_10851;
{ /* Llib/ssl.scm 1305 */
obj_t BgL_tmpz00_10876;
if(
INTEGERP(BgL_lenz00_5118))
{ /* Llib/ssl.scm 1305 */
BgL_tmpz00_10876 = BgL_lenz00_5118
; }  else 
{ 
obj_t BgL_auxz00_10879;
BgL_auxz00_10879 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)52649)), BGl_string3744z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_lenz00_5118); 
FAILURE(BgL_auxz00_10879,BFALSE,BFALSE);} 
BgL_auxz00_10875 = 
(long)CINT(BgL_tmpz00_10876); } 
{ /* Llib/ssl.scm 1305 */
obj_t BgL_tmpz00_10867;
if(
INTEGERP(BgL_offsetz00_5117))
{ /* Llib/ssl.scm 1305 */
BgL_tmpz00_10867 = BgL_offsetz00_5117
; }  else 
{ 
obj_t BgL_auxz00_10870;
BgL_auxz00_10870 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)52649)), BGl_string3744z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_offsetz00_5117); 
FAILURE(BgL_auxz00_10870,BFALSE,BFALSE);} 
BgL_auxz00_10866 = 
(long)CINT(BgL_tmpz00_10867); } 
if(
STRINGP(BgL_dataz00_5116))
{ /* Llib/ssl.scm 1305 */
BgL_auxz00_10859 = BgL_dataz00_5116
; }  else 
{ 
obj_t BgL_auxz00_10862;
BgL_auxz00_10862 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)52649)), BGl_string3744z00zz__ssl_sslz00, BGl_string3369z00zz__ssl_sslz00, BgL_dataz00_5116); 
FAILURE(BgL_auxz00_10862,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_sslzd2verifyzd2_5115, BGl_sslzd2verifyzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1305 */
BgL_auxz00_10851 = 
((BgL_sslzd2verifyzd2_bglt)BgL_sslzd2verifyzd2_5115)
; }  else 
{ 
obj_t BgL_auxz00_10855;
BgL_auxz00_10855 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)52649)), BGl_string3744z00zz__ssl_sslz00, BGl_string3678z00zz__ssl_sslz00, BgL_sslzd2verifyzd2_5115); 
FAILURE(BgL_auxz00_10855,BFALSE,BFALSE);} 
return 
BGl_sslzd2verifyzd2updatez12z12zz__ssl_sslz00(BgL_auxz00_10851, BgL_auxz00_10859, BgL_auxz00_10866, BgL_auxz00_10875);} } 

}



/* ssl-verify-final */
BGL_EXPORTED_DEF bool_t BGl_sslzd2verifyzd2finalz00zz__ssl_sslz00(BgL_sslzd2verifyzd2_bglt BgL_sslzd2verifyzd2_149, obj_t BgL_keyz00_150, long BgL_koffsetz00_151, long BgL_klenz00_152, obj_t BgL_sigz00_153, long BgL_soffsetz00_154, long BgL_slenz00_155)
{
{ /* Llib/ssl.scm 1317 */
{ /* Llib/ssl.scm 1317 */
obj_t BgL_method1342z00_1758;
{ /* Llib/ssl.scm 1317 */
obj_t BgL_res2919z00_3965;
{ /* Llib/ssl.scm 1317 */
long BgL_objzd2classzd2numz00_3930;
{ /* Llib/ssl.scm 1317 */
long BgL_res2909z00_3933;
BgL_res2909z00_3933 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslzd2verifyzd2_149)); 
BgL_objzd2classzd2numz00_3930 = BgL_res2909z00_3933; } 
{ /* Llib/ssl.scm 1317 */
obj_t BgL_arg1745z00_3931;
BgL_arg1745z00_3931 = 
PROCEDURE_REF(BGl_sslzd2verifyzd2finalzd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1317 */
int BgL_offsetz00_3935;
BgL_offsetz00_3935 = 
(int)(BgL_objzd2classzd2numz00_3930); 
{ /* Llib/ssl.scm 1317 */
long BgL_offsetz00_3936;
BgL_offsetz00_3936 = 
(
(long)(BgL_offsetz00_3935)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1317 */
long BgL_modz00_3937;
BgL_modz00_3937 = 
(BgL_offsetz00_3936 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 1317 */
long BgL_restz00_3939;
BgL_restz00_3939 = 
(BgL_offsetz00_3936 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 1317 */

{ /* Llib/ssl.scm 1317 */
obj_t BgL_bucketz00_3941;
BgL_bucketz00_3941 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_3931),BgL_modz00_3937); 
BgL_res2919z00_3965 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3941),BgL_restz00_3939); } } } } } } } } 
BgL_method1342z00_1758 = BgL_res2919z00_3965; } 
return 
CBOOL(
PROCEDURE_ENTRY(BgL_method1342z00_1758)(BgL_method1342z00_1758, 
((obj_t)BgL_sslzd2verifyzd2_149), BgL_keyz00_150, 
BINT(BgL_koffsetz00_151), 
BINT(BgL_klenz00_152), BgL_sigz00_153, 
BINT(BgL_soffsetz00_154), 
BINT(BgL_slenz00_155), BEOA));} } 

}



/* &ssl-verify-final */
obj_t BGl_z62sslzd2verifyzd2finalz62zz__ssl_sslz00(obj_t BgL_envz00_5119, obj_t BgL_sslzd2verifyzd2_5120, obj_t BgL_keyz00_5121, obj_t BgL_koffsetz00_5122, obj_t BgL_klenz00_5123, obj_t BgL_sigz00_5124, obj_t BgL_soffsetz00_5125, obj_t BgL_slenz00_5126)
{
{ /* Llib/ssl.scm 1317 */
{ /* Llib/ssl.scm 1317 */
bool_t BgL_tmpz00_10926;
{ /* Llib/ssl.scm 1317 */
long BgL_auxz00_10976;long BgL_auxz00_10967;obj_t BgL_auxz00_10960;long BgL_auxz00_10951;long BgL_auxz00_10942;obj_t BgL_auxz00_10935;BgL_sslzd2verifyzd2_bglt BgL_auxz00_10927;
{ /* Llib/ssl.scm 1317 */
obj_t BgL_tmpz00_10977;
if(
INTEGERP(BgL_slenz00_5126))
{ /* Llib/ssl.scm 1317 */
BgL_tmpz00_10977 = BgL_slenz00_5126
; }  else 
{ 
obj_t BgL_auxz00_10980;
BgL_auxz00_10980 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)53161)), BGl_string3745z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_slenz00_5126); 
FAILURE(BgL_auxz00_10980,BFALSE,BFALSE);} 
BgL_auxz00_10976 = 
(long)CINT(BgL_tmpz00_10977); } 
{ /* Llib/ssl.scm 1317 */
obj_t BgL_tmpz00_10968;
if(
INTEGERP(BgL_soffsetz00_5125))
{ /* Llib/ssl.scm 1317 */
BgL_tmpz00_10968 = BgL_soffsetz00_5125
; }  else 
{ 
obj_t BgL_auxz00_10971;
BgL_auxz00_10971 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)53161)), BGl_string3745z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_soffsetz00_5125); 
FAILURE(BgL_auxz00_10971,BFALSE,BFALSE);} 
BgL_auxz00_10967 = 
(long)CINT(BgL_tmpz00_10968); } 
if(
STRINGP(BgL_sigz00_5124))
{ /* Llib/ssl.scm 1317 */
BgL_auxz00_10960 = BgL_sigz00_5124
; }  else 
{ 
obj_t BgL_auxz00_10963;
BgL_auxz00_10963 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)53161)), BGl_string3745z00zz__ssl_sslz00, BGl_string3369z00zz__ssl_sslz00, BgL_sigz00_5124); 
FAILURE(BgL_auxz00_10963,BFALSE,BFALSE);} 
{ /* Llib/ssl.scm 1317 */
obj_t BgL_tmpz00_10952;
if(
INTEGERP(BgL_klenz00_5123))
{ /* Llib/ssl.scm 1317 */
BgL_tmpz00_10952 = BgL_klenz00_5123
; }  else 
{ 
obj_t BgL_auxz00_10955;
BgL_auxz00_10955 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)53161)), BGl_string3745z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_klenz00_5123); 
FAILURE(BgL_auxz00_10955,BFALSE,BFALSE);} 
BgL_auxz00_10951 = 
(long)CINT(BgL_tmpz00_10952); } 
{ /* Llib/ssl.scm 1317 */
obj_t BgL_tmpz00_10943;
if(
INTEGERP(BgL_koffsetz00_5122))
{ /* Llib/ssl.scm 1317 */
BgL_tmpz00_10943 = BgL_koffsetz00_5122
; }  else 
{ 
obj_t BgL_auxz00_10946;
BgL_auxz00_10946 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)53161)), BGl_string3745z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_koffsetz00_5122); 
FAILURE(BgL_auxz00_10946,BFALSE,BFALSE);} 
BgL_auxz00_10942 = 
(long)CINT(BgL_tmpz00_10943); } 
if(
STRINGP(BgL_keyz00_5121))
{ /* Llib/ssl.scm 1317 */
BgL_auxz00_10935 = BgL_keyz00_5121
; }  else 
{ 
obj_t BgL_auxz00_10938;
BgL_auxz00_10938 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)53161)), BGl_string3745z00zz__ssl_sslz00, BGl_string3369z00zz__ssl_sslz00, BgL_keyz00_5121); 
FAILURE(BgL_auxz00_10938,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_sslzd2verifyzd2_5120, BGl_sslzd2verifyzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1317 */
BgL_auxz00_10927 = 
((BgL_sslzd2verifyzd2_bglt)BgL_sslzd2verifyzd2_5120)
; }  else 
{ 
obj_t BgL_auxz00_10931;
BgL_auxz00_10931 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)53161)), BGl_string3745z00zz__ssl_sslz00, BGl_string3678z00zz__ssl_sslz00, BgL_sslzd2verifyzd2_5120); 
FAILURE(BgL_auxz00_10931,BFALSE,BFALSE);} 
BgL_tmpz00_10926 = 
BGl_sslzd2verifyzd2finalz00zz__ssl_sslz00(BgL_auxz00_10927, BgL_auxz00_10935, BgL_auxz00_10942, BgL_auxz00_10951, BgL_auxz00_10960, BgL_auxz00_10967, BgL_auxz00_10976); } 
return 
BBOOL(BgL_tmpz00_10926);} } 

}



/* ssl-cipher-init */
BGL_EXPORTED_DEF obj_t BGl_sslzd2cipherzd2initz00zz__ssl_sslz00(BgL_sslzd2cipherzd2_bglt BgL_sslzd2cipherzd2_156, obj_t BgL_cipherz00_157, obj_t BgL_keyz00_158, long BgL_offsetz00_159, long BgL_lenz00_160, bool_t BgL_encz00_161)
{
{ /* Llib/ssl.scm 1331 */
{ /* Llib/ssl.scm 1331 */
obj_t BgL_method1344z00_1759;
{ /* Llib/ssl.scm 1331 */
obj_t BgL_res2930z00_4002;
{ /* Llib/ssl.scm 1331 */
long BgL_objzd2classzd2numz00_3967;
{ /* Llib/ssl.scm 1331 */
long BgL_res2920z00_3970;
BgL_res2920z00_3970 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslzd2cipherzd2_156)); 
BgL_objzd2classzd2numz00_3967 = BgL_res2920z00_3970; } 
{ /* Llib/ssl.scm 1331 */
obj_t BgL_arg1745z00_3968;
BgL_arg1745z00_3968 = 
PROCEDURE_REF(BGl_sslzd2cipherzd2initzd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1331 */
int BgL_offsetz00_3972;
BgL_offsetz00_3972 = 
(int)(BgL_objzd2classzd2numz00_3967); 
{ /* Llib/ssl.scm 1331 */
long BgL_offsetz00_3973;
BgL_offsetz00_3973 = 
(
(long)(BgL_offsetz00_3972)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1331 */
long BgL_modz00_3974;
BgL_modz00_3974 = 
(BgL_offsetz00_3973 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 1331 */
long BgL_restz00_3976;
BgL_restz00_3976 = 
(BgL_offsetz00_3973 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 1331 */

{ /* Llib/ssl.scm 1331 */
obj_t BgL_bucketz00_3978;
BgL_bucketz00_3978 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_3968),BgL_modz00_3974); 
BgL_res2930z00_4002 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3978),BgL_restz00_3976); } } } } } } } } 
BgL_method1344z00_1759 = BgL_res2930z00_4002; } 
return 
PROCEDURE_ENTRY(BgL_method1344z00_1759)(BgL_method1344z00_1759, 
((obj_t)BgL_sslzd2cipherzd2_156), BgL_cipherz00_157, BgL_keyz00_158, 
BINT(BgL_offsetz00_159), 
BINT(BgL_lenz00_160), 
BBOOL(BgL_encz00_161), BEOA);} } 

}



/* &ssl-cipher-init */
obj_t BGl_z62sslzd2cipherzd2initz62zz__ssl_sslz00(obj_t BgL_envz00_5127, obj_t BgL_sslzd2cipherzd2_5128, obj_t BgL_cipherz00_5129, obj_t BgL_keyz00_5130, obj_t BgL_offsetz00_5131, obj_t BgL_lenz00_5132, obj_t BgL_encz00_5133)
{
{ /* Llib/ssl.scm 1331 */
{ /* Llib/ssl.scm 1331 */
long BgL_auxz00_11056;long BgL_auxz00_11047;obj_t BgL_auxz00_11040;obj_t BgL_auxz00_11033;BgL_sslzd2cipherzd2_bglt BgL_auxz00_11025;
{ /* Llib/ssl.scm 1331 */
obj_t BgL_tmpz00_11057;
if(
INTEGERP(BgL_lenz00_5132))
{ /* Llib/ssl.scm 1331 */
BgL_tmpz00_11057 = BgL_lenz00_5132
; }  else 
{ 
obj_t BgL_auxz00_11060;
BgL_auxz00_11060 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)53644)), BGl_string3746z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_lenz00_5132); 
FAILURE(BgL_auxz00_11060,BFALSE,BFALSE);} 
BgL_auxz00_11056 = 
(long)CINT(BgL_tmpz00_11057); } 
{ /* Llib/ssl.scm 1331 */
obj_t BgL_tmpz00_11048;
if(
INTEGERP(BgL_offsetz00_5131))
{ /* Llib/ssl.scm 1331 */
BgL_tmpz00_11048 = BgL_offsetz00_5131
; }  else 
{ 
obj_t BgL_auxz00_11051;
BgL_auxz00_11051 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)53644)), BGl_string3746z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_offsetz00_5131); 
FAILURE(BgL_auxz00_11051,BFALSE,BFALSE);} 
BgL_auxz00_11047 = 
(long)CINT(BgL_tmpz00_11048); } 
if(
STRINGP(BgL_keyz00_5130))
{ /* Llib/ssl.scm 1331 */
BgL_auxz00_11040 = BgL_keyz00_5130
; }  else 
{ 
obj_t BgL_auxz00_11043;
BgL_auxz00_11043 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)53644)), BGl_string3746z00zz__ssl_sslz00, BGl_string3369z00zz__ssl_sslz00, BgL_keyz00_5130); 
FAILURE(BgL_auxz00_11043,BFALSE,BFALSE);} 
if(
STRINGP(BgL_cipherz00_5129))
{ /* Llib/ssl.scm 1331 */
BgL_auxz00_11033 = BgL_cipherz00_5129
; }  else 
{ 
obj_t BgL_auxz00_11036;
BgL_auxz00_11036 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)53644)), BGl_string3746z00zz__ssl_sslz00, BGl_string3369z00zz__ssl_sslz00, BgL_cipherz00_5129); 
FAILURE(BgL_auxz00_11036,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_sslzd2cipherzd2_5128, BGl_sslzd2cipherzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1331 */
BgL_auxz00_11025 = 
((BgL_sslzd2cipherzd2_bglt)BgL_sslzd2cipherzd2_5128)
; }  else 
{ 
obj_t BgL_auxz00_11029;
BgL_auxz00_11029 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)53644)), BGl_string3746z00zz__ssl_sslz00, BGl_string3747z00zz__ssl_sslz00, BgL_sslzd2cipherzd2_5128); 
FAILURE(BgL_auxz00_11029,BFALSE,BFALSE);} 
return 
BGl_sslzd2cipherzd2initz00zz__ssl_sslz00(BgL_auxz00_11025, BgL_auxz00_11033, BgL_auxz00_11040, BgL_auxz00_11047, BgL_auxz00_11056, 
CBOOL(BgL_encz00_5133));} } 

}



/* ssl-cipher-initiv */
BGL_EXPORTED_DEF obj_t BGl_sslzd2cipherzd2initivz00zz__ssl_sslz00(BgL_sslzd2cipherzd2_bglt BgL_sslzd2cipherzd2_162, obj_t BgL_cipherz00_163, obj_t BgL_keyz00_164, long BgL_offsetz00_165, long BgL_lenz00_166, obj_t BgL_ivz00_167, long BgL_ivoffsetz00_168, long BgL_ivlenz00_169, bool_t BgL_encz00_170)
{
{ /* Llib/ssl.scm 1345 */
{ /* Llib/ssl.scm 1345 */
obj_t BgL_method1346z00_1760;
{ /* Llib/ssl.scm 1345 */
obj_t BgL_res2941z00_4039;
{ /* Llib/ssl.scm 1345 */
long BgL_objzd2classzd2numz00_4004;
{ /* Llib/ssl.scm 1345 */
long BgL_res2931z00_4007;
BgL_res2931z00_4007 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslzd2cipherzd2_162)); 
BgL_objzd2classzd2numz00_4004 = BgL_res2931z00_4007; } 
{ /* Llib/ssl.scm 1345 */
obj_t BgL_arg1745z00_4005;
BgL_arg1745z00_4005 = 
PROCEDURE_REF(BGl_sslzd2cipherzd2initivzd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1345 */
int BgL_offsetz00_4009;
BgL_offsetz00_4009 = 
(int)(BgL_objzd2classzd2numz00_4004); 
{ /* Llib/ssl.scm 1345 */
long BgL_offsetz00_4010;
BgL_offsetz00_4010 = 
(
(long)(BgL_offsetz00_4009)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1345 */
long BgL_modz00_4011;
BgL_modz00_4011 = 
(BgL_offsetz00_4010 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 1345 */
long BgL_restz00_4013;
BgL_restz00_4013 = 
(BgL_offsetz00_4010 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 1345 */

{ /* Llib/ssl.scm 1345 */
obj_t BgL_bucketz00_4015;
BgL_bucketz00_4015 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_4005),BgL_modz00_4011); 
BgL_res2941z00_4039 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4015),BgL_restz00_4013); } } } } } } } } 
BgL_method1346z00_1760 = BgL_res2941z00_4039; } 
return 
PROCEDURE_ENTRY(BgL_method1346z00_1760)(BgL_method1346z00_1760, 
((obj_t)BgL_sslzd2cipherzd2_162), BgL_cipherz00_163, BgL_keyz00_164, 
BINT(BgL_offsetz00_165), 
BINT(BgL_lenz00_166), BgL_ivz00_167, 
BINT(BgL_ivoffsetz00_168), 
BINT(BgL_ivlenz00_169), 
BBOOL(BgL_encz00_170), BEOA);} } 

}



/* &ssl-cipher-initiv */
obj_t BGl_z62sslzd2cipherzd2initivz62zz__ssl_sslz00(obj_t BgL_envz00_5134, obj_t BgL_sslzd2cipherzd2_5135, obj_t BgL_cipherz00_5136, obj_t BgL_keyz00_5137, obj_t BgL_offsetz00_5138, obj_t BgL_lenz00_5139, obj_t BgL_ivz00_5140, obj_t BgL_ivoffsetz00_5141, obj_t BgL_ivlenz00_5142, obj_t BgL_encz00_5143)
{
{ /* Llib/ssl.scm 1345 */
{ /* Llib/ssl.scm 1345 */
long BgL_auxz00_11166;long BgL_auxz00_11157;obj_t BgL_auxz00_11150;long BgL_auxz00_11141;long BgL_auxz00_11132;obj_t BgL_auxz00_11125;obj_t BgL_auxz00_11118;BgL_sslzd2cipherzd2_bglt BgL_auxz00_11110;
{ /* Llib/ssl.scm 1345 */
obj_t BgL_tmpz00_11167;
if(
INTEGERP(BgL_ivlenz00_5142))
{ /* Llib/ssl.scm 1345 */
BgL_tmpz00_11167 = BgL_ivlenz00_5142
; }  else 
{ 
obj_t BgL_auxz00_11170;
BgL_auxz00_11170 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)54168)), BGl_string3748z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_ivlenz00_5142); 
FAILURE(BgL_auxz00_11170,BFALSE,BFALSE);} 
BgL_auxz00_11166 = 
(long)CINT(BgL_tmpz00_11167); } 
{ /* Llib/ssl.scm 1345 */
obj_t BgL_tmpz00_11158;
if(
INTEGERP(BgL_ivoffsetz00_5141))
{ /* Llib/ssl.scm 1345 */
BgL_tmpz00_11158 = BgL_ivoffsetz00_5141
; }  else 
{ 
obj_t BgL_auxz00_11161;
BgL_auxz00_11161 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)54168)), BGl_string3748z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_ivoffsetz00_5141); 
FAILURE(BgL_auxz00_11161,BFALSE,BFALSE);} 
BgL_auxz00_11157 = 
(long)CINT(BgL_tmpz00_11158); } 
if(
STRINGP(BgL_ivz00_5140))
{ /* Llib/ssl.scm 1345 */
BgL_auxz00_11150 = BgL_ivz00_5140
; }  else 
{ 
obj_t BgL_auxz00_11153;
BgL_auxz00_11153 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)54168)), BGl_string3748z00zz__ssl_sslz00, BGl_string3369z00zz__ssl_sslz00, BgL_ivz00_5140); 
FAILURE(BgL_auxz00_11153,BFALSE,BFALSE);} 
{ /* Llib/ssl.scm 1345 */
obj_t BgL_tmpz00_11142;
if(
INTEGERP(BgL_lenz00_5139))
{ /* Llib/ssl.scm 1345 */
BgL_tmpz00_11142 = BgL_lenz00_5139
; }  else 
{ 
obj_t BgL_auxz00_11145;
BgL_auxz00_11145 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)54168)), BGl_string3748z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_lenz00_5139); 
FAILURE(BgL_auxz00_11145,BFALSE,BFALSE);} 
BgL_auxz00_11141 = 
(long)CINT(BgL_tmpz00_11142); } 
{ /* Llib/ssl.scm 1345 */
obj_t BgL_tmpz00_11133;
if(
INTEGERP(BgL_offsetz00_5138))
{ /* Llib/ssl.scm 1345 */
BgL_tmpz00_11133 = BgL_offsetz00_5138
; }  else 
{ 
obj_t BgL_auxz00_11136;
BgL_auxz00_11136 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)54168)), BGl_string3748z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_offsetz00_5138); 
FAILURE(BgL_auxz00_11136,BFALSE,BFALSE);} 
BgL_auxz00_11132 = 
(long)CINT(BgL_tmpz00_11133); } 
if(
STRINGP(BgL_keyz00_5137))
{ /* Llib/ssl.scm 1345 */
BgL_auxz00_11125 = BgL_keyz00_5137
; }  else 
{ 
obj_t BgL_auxz00_11128;
BgL_auxz00_11128 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)54168)), BGl_string3748z00zz__ssl_sslz00, BGl_string3369z00zz__ssl_sslz00, BgL_keyz00_5137); 
FAILURE(BgL_auxz00_11128,BFALSE,BFALSE);} 
if(
STRINGP(BgL_cipherz00_5136))
{ /* Llib/ssl.scm 1345 */
BgL_auxz00_11118 = BgL_cipherz00_5136
; }  else 
{ 
obj_t BgL_auxz00_11121;
BgL_auxz00_11121 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)54168)), BGl_string3748z00zz__ssl_sslz00, BGl_string3369z00zz__ssl_sslz00, BgL_cipherz00_5136); 
FAILURE(BgL_auxz00_11121,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_sslzd2cipherzd2_5135, BGl_sslzd2cipherzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1345 */
BgL_auxz00_11110 = 
((BgL_sslzd2cipherzd2_bglt)BgL_sslzd2cipherzd2_5135)
; }  else 
{ 
obj_t BgL_auxz00_11114;
BgL_auxz00_11114 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)54168)), BGl_string3748z00zz__ssl_sslz00, BGl_string3747z00zz__ssl_sslz00, BgL_sslzd2cipherzd2_5135); 
FAILURE(BgL_auxz00_11114,BFALSE,BFALSE);} 
return 
BGl_sslzd2cipherzd2initivz00zz__ssl_sslz00(BgL_auxz00_11110, BgL_auxz00_11118, BgL_auxz00_11125, BgL_auxz00_11132, BgL_auxz00_11141, BgL_auxz00_11150, BgL_auxz00_11157, BgL_auxz00_11166, 
CBOOL(BgL_encz00_5143));} } 

}



/* ssl-cipher-update! */
BGL_EXPORTED_DEF obj_t BGl_sslzd2cipherzd2updatez12z12zz__ssl_sslz00(BgL_sslzd2cipherzd2_bglt BgL_sslzd2cipherzd2_171, obj_t BgL_dataz00_172, long BgL_offsetz00_173, long BgL_lenz00_174)
{
{ /* Llib/ssl.scm 1362 */
{ /* Llib/ssl.scm 1362 */
obj_t BgL_method1348z00_1761;
{ /* Llib/ssl.scm 1362 */
obj_t BgL_res2952z00_4076;
{ /* Llib/ssl.scm 1362 */
long BgL_objzd2classzd2numz00_4041;
{ /* Llib/ssl.scm 1362 */
long BgL_res2942z00_4044;
BgL_res2942z00_4044 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslzd2cipherzd2_171)); 
BgL_objzd2classzd2numz00_4041 = BgL_res2942z00_4044; } 
{ /* Llib/ssl.scm 1362 */
obj_t BgL_arg1745z00_4042;
BgL_arg1745z00_4042 = 
PROCEDURE_REF(BGl_sslzd2cipherzd2updatez12zd2envzc0zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1362 */
int BgL_offsetz00_4046;
BgL_offsetz00_4046 = 
(int)(BgL_objzd2classzd2numz00_4041); 
{ /* Llib/ssl.scm 1362 */
long BgL_offsetz00_4047;
BgL_offsetz00_4047 = 
(
(long)(BgL_offsetz00_4046)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1362 */
long BgL_modz00_4048;
BgL_modz00_4048 = 
(BgL_offsetz00_4047 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 1362 */
long BgL_restz00_4050;
BgL_restz00_4050 = 
(BgL_offsetz00_4047 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 1362 */

{ /* Llib/ssl.scm 1362 */
obj_t BgL_bucketz00_4052;
BgL_bucketz00_4052 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_4042),BgL_modz00_4048); 
BgL_res2952z00_4076 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4052),BgL_restz00_4050); } } } } } } } } 
BgL_method1348z00_1761 = BgL_res2952z00_4076; } 
return 
PROCEDURE_ENTRY(BgL_method1348z00_1761)(BgL_method1348z00_1761, 
((obj_t)BgL_sslzd2cipherzd2_171), BgL_dataz00_172, 
BINT(BgL_offsetz00_173), 
BINT(BgL_lenz00_174), BEOA);} } 

}



/* &ssl-cipher-update! */
obj_t BGl_z62sslzd2cipherzd2updatez12z70zz__ssl_sslz00(obj_t BgL_envz00_5144, obj_t BgL_sslzd2cipherzd2_5145, obj_t BgL_dataz00_5146, obj_t BgL_offsetz00_5147, obj_t BgL_lenz00_5148)
{
{ /* Llib/ssl.scm 1362 */
{ /* Llib/ssl.scm 1362 */
long BgL_auxz00_11236;long BgL_auxz00_11227;obj_t BgL_auxz00_11220;BgL_sslzd2cipherzd2_bglt BgL_auxz00_11212;
{ /* Llib/ssl.scm 1362 */
obj_t BgL_tmpz00_11237;
if(
INTEGERP(BgL_lenz00_5148))
{ /* Llib/ssl.scm 1362 */
BgL_tmpz00_11237 = BgL_lenz00_5148
; }  else 
{ 
obj_t BgL_auxz00_11240;
BgL_auxz00_11240 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)54737)), BGl_string3749z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_lenz00_5148); 
FAILURE(BgL_auxz00_11240,BFALSE,BFALSE);} 
BgL_auxz00_11236 = 
(long)CINT(BgL_tmpz00_11237); } 
{ /* Llib/ssl.scm 1362 */
obj_t BgL_tmpz00_11228;
if(
INTEGERP(BgL_offsetz00_5147))
{ /* Llib/ssl.scm 1362 */
BgL_tmpz00_11228 = BgL_offsetz00_5147
; }  else 
{ 
obj_t BgL_auxz00_11231;
BgL_auxz00_11231 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)54737)), BGl_string3749z00zz__ssl_sslz00, BGl_string3368z00zz__ssl_sslz00, BgL_offsetz00_5147); 
FAILURE(BgL_auxz00_11231,BFALSE,BFALSE);} 
BgL_auxz00_11227 = 
(long)CINT(BgL_tmpz00_11228); } 
if(
STRINGP(BgL_dataz00_5146))
{ /* Llib/ssl.scm 1362 */
BgL_auxz00_11220 = BgL_dataz00_5146
; }  else 
{ 
obj_t BgL_auxz00_11223;
BgL_auxz00_11223 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)54737)), BGl_string3749z00zz__ssl_sslz00, BGl_string3369z00zz__ssl_sslz00, BgL_dataz00_5146); 
FAILURE(BgL_auxz00_11223,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_sslzd2cipherzd2_5145, BGl_sslzd2cipherzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1362 */
BgL_auxz00_11212 = 
((BgL_sslzd2cipherzd2_bglt)BgL_sslzd2cipherzd2_5145)
; }  else 
{ 
obj_t BgL_auxz00_11216;
BgL_auxz00_11216 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)54737)), BGl_string3749z00zz__ssl_sslz00, BGl_string3747z00zz__ssl_sslz00, BgL_sslzd2cipherzd2_5145); 
FAILURE(BgL_auxz00_11216,BFALSE,BFALSE);} 
return 
BGl_sslzd2cipherzd2updatez12z12zz__ssl_sslz00(BgL_auxz00_11212, BgL_auxz00_11220, BgL_auxz00_11227, BgL_auxz00_11236);} } 

}



/* ssl-cipher-set-auto-padding */
BGL_EXPORTED_DEF bool_t BGl_sslzd2cipherzd2setzd2autozd2paddingz00zz__ssl_sslz00(BgL_sslzd2cipherzd2_bglt BgL_sslzd2cipherzd2_175, bool_t BgL_autozd2paddingzd2_176)
{
{ /* Llib/ssl.scm 1373 */
{ /* Llib/ssl.scm 1373 */
obj_t BgL_method1350z00_1762;
{ /* Llib/ssl.scm 1373 */
obj_t BgL_res2963z00_4113;
{ /* Llib/ssl.scm 1373 */
long BgL_objzd2classzd2numz00_4078;
{ /* Llib/ssl.scm 1373 */
long BgL_res2953z00_4081;
BgL_res2953z00_4081 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslzd2cipherzd2_175)); 
BgL_objzd2classzd2numz00_4078 = BgL_res2953z00_4081; } 
{ /* Llib/ssl.scm 1373 */
obj_t BgL_arg1745z00_4079;
BgL_arg1745z00_4079 = 
PROCEDURE_REF(BGl_sslzd2cipherzd2setzd2autozd2paddingzd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1373 */
int BgL_offsetz00_4083;
BgL_offsetz00_4083 = 
(int)(BgL_objzd2classzd2numz00_4078); 
{ /* Llib/ssl.scm 1373 */
long BgL_offsetz00_4084;
BgL_offsetz00_4084 = 
(
(long)(BgL_offsetz00_4083)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1373 */
long BgL_modz00_4085;
BgL_modz00_4085 = 
(BgL_offsetz00_4084 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 1373 */
long BgL_restz00_4087;
BgL_restz00_4087 = 
(BgL_offsetz00_4084 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 1373 */

{ /* Llib/ssl.scm 1373 */
obj_t BgL_bucketz00_4089;
BgL_bucketz00_4089 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_4079),BgL_modz00_4085); 
BgL_res2963z00_4113 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4089),BgL_restz00_4087); } } } } } } } } 
BgL_method1350z00_1762 = BgL_res2963z00_4113; } 
return 
CBOOL(
PROCEDURE_ENTRY(BgL_method1350z00_1762)(BgL_method1350z00_1762, 
((obj_t)BgL_sslzd2cipherzd2_175), 
BBOOL(BgL_autozd2paddingzd2_176), BEOA));} } 

}



/* &ssl-cipher-set-auto-padding */
obj_t BGl_z62sslzd2cipherzd2setzd2autozd2paddingz62zz__ssl_sslz00(obj_t BgL_envz00_5149, obj_t BgL_sslzd2cipherzd2_5150, obj_t BgL_autozd2paddingzd2_5151)
{
{ /* Llib/ssl.scm 1373 */
{ /* Llib/ssl.scm 1373 */
bool_t BgL_tmpz00_11279;
{ /* Llib/ssl.scm 1373 */
BgL_sslzd2cipherzd2_bglt BgL_auxz00_11280;
if(
BGl_isazf3zf3zz__objectz00(BgL_sslzd2cipherzd2_5150, BGl_sslzd2cipherzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1373 */
BgL_auxz00_11280 = 
((BgL_sslzd2cipherzd2_bglt)BgL_sslzd2cipherzd2_5150)
; }  else 
{ 
obj_t BgL_auxz00_11284;
BgL_auxz00_11284 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)55279)), BGl_string3750z00zz__ssl_sslz00, BGl_string3747z00zz__ssl_sslz00, BgL_sslzd2cipherzd2_5150); 
FAILURE(BgL_auxz00_11284,BFALSE,BFALSE);} 
BgL_tmpz00_11279 = 
BGl_sslzd2cipherzd2setzd2autozd2paddingz00zz__ssl_sslz00(BgL_auxz00_11280, 
CBOOL(BgL_autozd2paddingzd2_5151)); } 
return 
BBOOL(BgL_tmpz00_11279);} } 

}



/* ssl-cipher-final */
BGL_EXPORTED_DEF obj_t BGl_sslzd2cipherzd2finalz00zz__ssl_sslz00(BgL_sslzd2cipherzd2_bglt BgL_sslzd2cipherzd2_177)
{
{ /* Llib/ssl.scm 1383 */
{ /* Llib/ssl.scm 1383 */
obj_t BgL_method1352z00_1763;
{ /* Llib/ssl.scm 1383 */
obj_t BgL_res2974z00_4150;
{ /* Llib/ssl.scm 1383 */
long BgL_objzd2classzd2numz00_4115;
{ /* Llib/ssl.scm 1383 */
long BgL_res2964z00_4118;
BgL_res2964z00_4118 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslzd2cipherzd2_177)); 
BgL_objzd2classzd2numz00_4115 = BgL_res2964z00_4118; } 
{ /* Llib/ssl.scm 1383 */
obj_t BgL_arg1745z00_4116;
BgL_arg1745z00_4116 = 
PROCEDURE_REF(BGl_sslzd2cipherzd2finalzd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1383 */
int BgL_offsetz00_4120;
BgL_offsetz00_4120 = 
(int)(BgL_objzd2classzd2numz00_4115); 
{ /* Llib/ssl.scm 1383 */
long BgL_offsetz00_4121;
BgL_offsetz00_4121 = 
(
(long)(BgL_offsetz00_4120)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1383 */
long BgL_modz00_4122;
BgL_modz00_4122 = 
(BgL_offsetz00_4121 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/ssl.scm 1383 */
long BgL_restz00_4124;
BgL_restz00_4124 = 
(BgL_offsetz00_4121 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/ssl.scm 1383 */

{ /* Llib/ssl.scm 1383 */
obj_t BgL_bucketz00_4126;
BgL_bucketz00_4126 = 
VECTOR_REF(
((obj_t)BgL_arg1745z00_4116),BgL_modz00_4122); 
BgL_res2974z00_4150 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4126),BgL_restz00_4124); } } } } } } } } 
BgL_method1352z00_1763 = BgL_res2974z00_4150; } 
return 
PROCEDURE_ENTRY(BgL_method1352z00_1763)(BgL_method1352z00_1763, 
((obj_t)BgL_sslzd2cipherzd2_177), BEOA);} } 

}



/* &ssl-cipher-final */
obj_t BGl_z62sslzd2cipherzd2finalz62zz__ssl_sslz00(obj_t BgL_envz00_5152, obj_t BgL_sslzd2cipherzd2_5153)
{
{ /* Llib/ssl.scm 1383 */
{ /* Llib/ssl.scm 1383 */
BgL_sslzd2cipherzd2_bglt BgL_auxz00_11321;
if(
BGl_isazf3zf3zz__objectz00(BgL_sslzd2cipherzd2_5153, BGl_sslzd2cipherzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1383 */
BgL_auxz00_11321 = 
((BgL_sslzd2cipherzd2_bglt)BgL_sslzd2cipherzd2_5153)
; }  else 
{ 
obj_t BgL_auxz00_11325;
BgL_auxz00_11325 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__ssl_sslz00, 
BINT(((long)55708)), BGl_string3751z00zz__ssl_sslz00, BGl_string3747z00zz__ssl_sslz00, BgL_sslzd2cipherzd2_5153); 
FAILURE(BgL_auxz00_11325,BFALSE,BFALSE);} 
return 
BGl_sslzd2cipherzd2finalz00zz__ssl_sslz00(BgL_auxz00_11321);} } 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__ssl_sslz00()
{
{ /* Llib/ssl.scm 15 */
return BUNSPEC;} 

}

#ifdef __cplusplus
}
#endif
