/*===========================================================================*/
/*   (Llib/json.scm)                                                         */
/*   Bigloo (4.3h)                                                           */
/*   Inria -- Sophia Antipolis (c)       Tue 12 May 2020 08:36:09 AM CEST    */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.3h/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.3h/lib/bigloo/4.3h -I Llib -lib-dir /builddir/build/BUILD/bigloo-4.3h/lib/bigloo/4.3h -unsafe -safee -copt -fPIC -copt -IPosix Llib/json.scm -o objs/json.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_z62errorz62_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_fnamez00;
   obj_t BgL_locationz00;
   obj_t BgL_stackz00;
   obj_t BgL_procz00;
   obj_t BgL_msgz00;
   obj_t BgL_objz00;
} *BgL_z62errorz62_bglt;

typedef struct BgL_z62exceptionz62_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_fnamez00;
   obj_t BgL_locationz00;
   obj_t BgL_stackz00;
} *BgL_z62exceptionz62_bglt;


BGL_IMPORT obj_t BGl_raisez00zz__errorz00(obj_t);
static obj_t BGl__jsonzd2parsezd2zz__web_jsonz00(obj_t, obj_t);
BGL_IMPORT ucs2_t BGl_integerzd2ze3ucs2z31zz__ucs2z00(int);
static obj_t BGl_search1083ze70ze7zz__web_jsonz00(long, obj_t, obj_t, long);
static obj_t BGl_objectzd2initzd2zz__web_jsonz00();
BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
BGL_IMPORT obj_t string_append_3(obj_t, obj_t, obj_t);
BGL_IMPORT double rgc_buffer_flonum(obj_t);
static obj_t BGl_methodzd2initzd2zz__web_jsonz00();
BGL_IMPORT obj_t rgc_buffer_substring(obj_t, long, long);
BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t ucs2_string_to_utf8_string(obj_t);
static obj_t BGl_z62zc3z04anonymousza31098ze3ze5zz__web_jsonz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_parsezd2textze70z35zz__web_jsonz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__web_jsonz00();
BGL_IMPORT obj_t c_substring(obj_t, long, long);
BGL_IMPORT obj_t rgc_buffer_symbol(obj_t);
BGL_IMPORT obj_t BGl_readzd2charszd2zz__r4_input_6_10_2z00(obj_t, obj_t);
static obj_t BGl_readzd2tokenze70z35zz__web_jsonz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_za2jsonzd2lexerza2zd2zz__web_jsonz00 = BUNSPEC;
static obj_t BGl_ucs2zd2ze3utf8z31zz__web_jsonz00(obj_t, long);
static obj_t BGl_requirezd2initializa7ationz75zz__web_jsonz00 = BUNSPEC;
BGL_IMPORT obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_jsonzd2parsezd2zz__web_jsonz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_toplevelzd2initzd2zz__web_jsonz00();
BGL_IMPORT obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
static obj_t BGl_genericzd2initzd2zz__web_jsonz00();
BGL_IMPORT obj_t rgc_buffer_integer(obj_t);
static obj_t BGl_parsezd2tokenzd2errorze70ze7zz__web_jsonz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t bgl_escape_C_string(char *, long, long);
static obj_t BGl_checkzd2procedureze70z35zz__web_jsonz00(obj_t, long, obj_t);
static long BGl_hexze70ze7zz__web_jsonz00(unsigned char);
static obj_t BGl_utf8ze70ze7zz__web_jsonz00(obj_t, long);
static obj_t BGl_z62zc3z04anonymousza32245ze3ze5zz__web_jsonz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__web_jsonz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_input_6_10_2z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__rgcz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__unicodez00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__ucs2z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
BGL_IMPORT obj_t BGl_z62errorz62zz__objectz00;
static obj_t BGl_z62zc3z04anonymousza32248ze3ze5zz__web_jsonz00(obj_t, obj_t);
static obj_t BGl_cnstzd2initzd2zz__web_jsonz00();
static obj_t BGl_libraryzd2moduleszd2initz00zz__web_jsonz00();
static obj_t BGl_za2eotza2z00zz__web_jsonz00 = BUNSPEC;
BGL_IMPORT obj_t BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(obj_t);
BGL_IMPORT obj_t make_ucs2_string(int, ucs2_t);
BGL_IMPORT bool_t rgc_fill_buffer(obj_t);
static obj_t __cnst[ 30 ] ;


DEFINE_EXPORT_BGL_PROCEDURE( BGl_jsonzd2parsezd2envz00zz__web_jsonz00, BgL_bgl__jsonza7d2parseza7d22931z00, opt_generic_entry, BGl__jsonzd2parsezd2zz__web_jsonz00, BFALSE, -1 );
DEFINE_STRING( BGl_string2906z00zz__web_jsonz00, BgL_bgl_string2906za700za7za7_2932za7, "<~a>~a", 6 );
DEFINE_STRING( BGl_string2907z00zz__web_jsonz00, BgL_bgl_string2907za700za7za7_2933za7, "regular-grammar", 15 );
DEFINE_STRING( BGl_string2908z00zz__web_jsonz00, BgL_bgl_string2908za700za7za7_2934za7, "Illegal match", 13 );
DEFINE_STRING( BGl_string2909z00zz__web_jsonz00, BgL_bgl_string2909za700za7za7_2935za7, "Illegal range `~a'", 18 );
DEFINE_STRING( BGl_string2910z00zz__web_jsonz00, BgL_bgl_string2910za700za7za7_2936za7, "the-substring", 13 );
DEFINE_STRING( BGl_string2911z00zz__web_jsonz00, BgL_bgl_string2911za700za7za7_2937za7, "Illegal keyword argument", 24 );
DEFINE_STRING( BGl_string2912z00zz__web_jsonz00, BgL_bgl_string2912za700za7za7_2938za7, "/builddir/build/BUILD/bigloo-4.3h/api/web/src/Llib/json.scm", 59 );
DEFINE_STRING( BGl_string2913z00zz__web_jsonz00, BgL_bgl_string2913za700za7za7_2939za7, "_json-parse", 11 );
DEFINE_STRING( BGl_string2914z00zz__web_jsonz00, BgL_bgl_string2914za700za7za7_2940za7, "bint", 4 );
DEFINE_STRING( BGl_string2915z00zz__web_jsonz00, BgL_bgl_string2915za700za7za7_2941za7, "input-port", 10 );
DEFINE_STRING( BGl_string2916z00zz__web_jsonz00, BgL_bgl_string2916za700za7za7_2942za7, "wrong number of arguments: [1..13] expected, provided", 53 );
DEFINE_STRING( BGl_string2919z00zz__web_jsonz00, BgL_bgl_string2919za700za7za7_2943za7, "Illegal JSON trailing ~a token: \"~a\"", 36 );
DEFINE_STRING( BGl_string2920z00zz__web_jsonz00, BgL_bgl_string2920za700za7za7_2944za7, "Illegal JSON trailing token: \"~a\"", 33 );
DEFINE_STRING( BGl_string2921z00zz__web_jsonz00, BgL_bgl_string2921za700za7za7_2945za7, "wrong token: \"~a\"", 17 );
DEFINE_STRING( BGl_string2922z00zz__web_jsonz00, BgL_bgl_string2922za700za7za7_2946za7, "wrong ~a token: \"~a\"", 20 );
DEFINE_STRING( BGl_string2923z00zz__web_jsonz00, BgL_bgl_string2923za700za7za7_2947za7, "json-parse", 10 );
DEFINE_STRING( BGl_string2924z00zz__web_jsonz00, BgL_bgl_string2924za700za7za7_2948za7, "wrong argument \"~s\"", 19 );
DEFINE_STRING( BGl_string2925z00zz__web_jsonz00, BgL_bgl_string2925za700za7za7_2949za7, "syntax error", 12 );
DEFINE_STRING( BGl_string2926z00zz__web_jsonz00, BgL_bgl_string2926za700za7za7_2950za7, "token \"~a\" expected", 19 );
DEFINE_STRING( BGl_string2927z00zz__web_jsonz00, BgL_bgl_string2927za700za7za7_2951za7, ":undefined :string-alloc :reviver :parse-error :object-set :object-return :object-alloc :expr :constant-alloc :array-set :array-return :array-alloc json-parse (:array-alloc :array-return :array-set :constant-alloc :expr :object-alloc :object-return :object-set :parse-error :reviver :string-alloc :undefined) COMMA COLON ANGLE-OPEN ANGLE-CLO PAR-OPEN PAR-CLO BRA-OPEN BRA-CLO STRING false true undefined CONSTANT null ERROR EOS ", 428 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2917z00zz__web_jsonz00, BgL_bgl_za762za7c3za704anonymo2952za7, BGl_z62zc3z04anonymousza32245ze3ze5zz__web_jsonz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2918z00zz__web_jsonz00, BgL_bgl_za762za7c3za704anonymo2953za7, BGl_z62zc3z04anonymousza32248ze3ze5zz__web_jsonz00, 0L, BUNSPEC, 1 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_za2jsonzd2lexerza2zd2zz__web_jsonz00) );
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__web_jsonz00) );
ADD_ROOT( (void *)(&BGl_za2eotza2z00zz__web_jsonz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__web_jsonz00(long BgL_checksumz00_3476, char * BgL_fromz00_3477)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__web_jsonz00))
{ 
BGl_requirezd2initializa7ationz75zz__web_jsonz00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__web_jsonz00(); 
BGl_libraryzd2moduleszd2initz00zz__web_jsonz00(); 
BGl_cnstzd2initzd2zz__web_jsonz00(); 
return 
BGl_toplevelzd2initzd2zz__web_jsonz00();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__web_jsonz00()
{
{ /* Llib/json.scm 15 */
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "__web_json"); 
BGl_modulezd2initializa7ationz75zz__ucs2z00(((long)0), "__web_json"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__web_json"); 
BGl_modulezd2initializa7ationz75zz__r4_input_6_10_2z00(((long)0), "__web_json"); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "__web_json"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__web_json"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__web_json"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__web_json"); 
BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)0), "__web_json"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__web_json"); 
BGl_modulezd2initializa7ationz75zz__unicodez00(((long)0), "__web_json"); 
BGl_modulezd2initializa7ationz75zz__bitz00(((long)0), "__web_json"); 
BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long)0), "__web_json"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__web_json"); 
BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)0), "__web_json"); 
BGl_modulezd2initializa7ationz75zz__rgcz00(((long)0), "__web_json"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__web_json"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__web_jsonz00()
{
{ /* Llib/json.scm 15 */
{ /* Llib/json.scm 15 */
obj_t BgL_cportz00_2856;
{ /* Llib/json.scm 15 */
obj_t BgL_stringz00_2864;
BgL_stringz00_2864 = BGl_string2927z00zz__web_jsonz00; 
{ /* Llib/json.scm 15 */
obj_t BgL_startz00_2865;
BgL_startz00_2865 = 
BINT(((long)0)); 
{ /* Llib/json.scm 15 */
obj_t BgL_endz00_2866;
BgL_endz00_2866 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_2864))); 
{ /* Llib/json.scm 15 */

BgL_cportz00_2856 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_2864, BgL_startz00_2865, BgL_endz00_2866); } } } } 
{ 
long BgL_iz00_2857;
BgL_iz00_2857 = ((long)29); 
BgL_loopz00_2858:
if(
(BgL_iz00_2857==((long)-1)))
{ /* Llib/json.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/json.scm 15 */
{ /* Llib/json.scm 15 */
obj_t BgL_arg2929z00_2860;
{ /* Llib/json.scm 15 */

{ /* Llib/json.scm 15 */
obj_t BgL_locationz00_2862;
BgL_locationz00_2862 = 
BBOOL(((bool_t)0)); 
{ /* Llib/json.scm 15 */

BgL_arg2929z00_2860 = 
BGl_readz00zz__readerz00(BgL_cportz00_2856, BgL_locationz00_2862); } } } 
{ /* Llib/json.scm 15 */
int BgL_tmpz00_3511;
BgL_tmpz00_3511 = 
(int)(BgL_iz00_2857); 
CNST_TABLE_SET(BgL_tmpz00_3511, BgL_arg2929z00_2860); } } 
{ /* Llib/json.scm 15 */
int BgL_auxz00_2863;
BgL_auxz00_2863 = 
(int)(
(BgL_iz00_2857-((long)1))); 
{ 
long BgL_iz00_3516;
BgL_iz00_3516 = 
(long)(BgL_auxz00_2863); 
BgL_iz00_2857 = BgL_iz00_3516; 
goto BgL_loopz00_2858;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__web_jsonz00()
{
{ /* Llib/json.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__web_jsonz00()
{
{ /* Llib/json.scm 15 */
{ /* Llib/json.scm 42 */
obj_t BgL_zc3z04anonymousza31098ze3z87_2770;
{ 
int BgL_tmpz00_3519;
BgL_tmpz00_3519 = 
(int)(((long)0)); 
BgL_zc3z04anonymousza31098ze3z87_2770 = 
MAKE_EL_PROCEDURE(BgL_tmpz00_3519); } 
BGl_za2jsonzd2lexerza2zd2zz__web_jsonz00 = BgL_zc3z04anonymousza31098ze3z87_2770; } 
return ( 
BGl_za2eotza2z00zz__web_jsonz00 = 
MAKE_YOUNG_PAIR(
BINT(((long)1)), 
BINT(((long)2))), BUNSPEC) ;} 

}



/* &<@anonymous:1098> */
obj_t BGl_z62zc3z04anonymousza31098ze3ze5zz__web_jsonz00(obj_t BgL_envz00_2771, obj_t BgL_iportz00_2772, obj_t BgL_undefinedz00_2773, obj_t BgL_constantzd2alloczd2_2774, obj_t BgL_stringzd2alloczd2_2775)
{
{ /* Llib/json.scm 42 */
{ 
obj_t BgL_iportz00_3465;long BgL_lastzd2matchzd2_3466;long BgL_forwardz00_3467;long BgL_bufposz00_3468;obj_t BgL_iportz00_3453;long BgL_lastzd2matchzd2_3454;long BgL_forwardz00_3455;long BgL_bufposz00_3456;obj_t BgL_iportz00_3443;long BgL_lastzd2matchzd2_3444;long BgL_forwardz00_3445;long BgL_bufposz00_3446;obj_t BgL_iportz00_3433;long BgL_lastzd2matchzd2_3434;long BgL_forwardz00_3435;long BgL_bufposz00_3436;obj_t BgL_iportz00_3423;long BgL_lastzd2matchzd2_3424;long BgL_forwardz00_3425;long BgL_bufposz00_3426;obj_t BgL_iportz00_3413;long BgL_lastzd2matchzd2_3414;long BgL_forwardz00_3415;long BgL_bufposz00_3416;obj_t BgL_iportz00_3403;long BgL_lastzd2matchzd2_3404;long BgL_forwardz00_3405;long BgL_bufposz00_3406;obj_t BgL_iportz00_3391;long BgL_lastzd2matchzd2_3392;long BgL_forwardz00_3393;long BgL_bufposz00_3394;obj_t BgL_iportz00_3378;long BgL_lastzd2matchzd2_3379;long BgL_forwardz00_3380;long BgL_bufposz00_3381;obj_t BgL_iportz00_3366;long BgL_lastzd2matchzd2_3367;long BgL_forwardz00_3368;long BgL_bufposz00_3369;obj_t BgL_iportz00_3354;long BgL_lastzd2matchzd2_3355;long BgL_forwardz00_3356;long BgL_bufposz00_3357;obj_t BgL_iportz00_3342;long BgL_lastzd2matchzd2_3343;long BgL_forwardz00_3344;long BgL_bufposz00_3345;obj_t BgL_iportz00_3330;long BgL_lastzd2matchzd2_3331;long BgL_forwardz00_3332;long BgL_bufposz00_3333;obj_t BgL_iportz00_3318;long BgL_lastzd2matchzd2_3319;long BgL_forwardz00_3320;long BgL_bufposz00_3321;obj_t BgL_iportz00_3306;long BgL_lastzd2matchzd2_3307;long BgL_forwardz00_3308;long BgL_bufposz00_3309;obj_t BgL_iportz00_3296;long BgL_lastzd2matchzd2_3297;long BgL_forwardz00_3298;long BgL_bufposz00_3299;obj_t BgL_iportz00_3259;long BgL_lastzd2matchzd2_3260;long BgL_forwardz00_3261;long BgL_bufposz00_3262;obj_t BgL_iportz00_3244;long BgL_lastzd2matchzd2_3245;long BgL_forwardz00_3246;long BgL_bufposz00_3247;obj_t BgL_iportz00_3234;long BgL_lastzd2matchzd2_3235;long BgL_forwardz00_3236;long BgL_bufposz00_3237;obj_t BgL_iportz00_3224;long BgL_lastzd2matchzd2_3225;long BgL_forwardz00_3226;long BgL_bufposz00_3227;obj_t BgL_iportz00_3209;long BgL_lastzd2matchzd2_3210;long BgL_forwardz00_3211;long BgL_bufposz00_3212;obj_t BgL_iportz00_3194;long BgL_lastzd2matchzd2_3195;long BgL_forwardz00_3196;long BgL_bufposz00_3197;obj_t BgL_iportz00_3184;long BgL_lastzd2matchzd2_3185;long BgL_forwardz00_3186;long BgL_bufposz00_3187;obj_t BgL_iportz00_3169;long BgL_lastzd2matchzd2_3170;long BgL_forwardz00_3171;long BgL_bufposz00_3172;obj_t BgL_iportz00_3154;long BgL_lastzd2matchzd2_3155;long BgL_forwardz00_3156;long BgL_bufposz00_3157;obj_t BgL_iportz00_3142;long BgL_lastzd2matchzd2_3143;long BgL_forwardz00_3144;long BgL_bufposz00_3145;obj_t BgL_iportz00_3130;long BgL_lastzd2matchzd2_3131;long BgL_forwardz00_3132;long BgL_bufposz00_3133;int BgL_minz00_3116;int BgL_maxz00_3117;
BgL_ignorez00_2870:
{ /* Llib/json.scm 42 */
long BgL_res2637z00_2900;
BgL_res2637z00_2900 = 
RGC_START_MATCH(BgL_iportz00_2772); BgL_res2637z00_2900; } 
{ /* Llib/json.scm 42 */
long BgL_matchz00_2901;
{ /* Llib/json.scm 42 */
long BgL_arg2106z00_2902;long BgL_arg2107z00_2903;
{ /* Llib/json.scm 42 */
long BgL_res2638z00_2904;
BgL_res2638z00_2904 = 
RGC_BUFFER_FORWARD(BgL_iportz00_2772); 
BgL_arg2106z00_2902 = BgL_res2638z00_2904; } 
{ /* Llib/json.scm 42 */
long BgL_res2639z00_2905;
BgL_res2639z00_2905 = 
RGC_BUFFER_BUFPOS(BgL_iportz00_2772); 
BgL_arg2107z00_2903 = BgL_res2639z00_2905; } 
BgL_iportz00_3259 = BgL_iportz00_2772; 
BgL_lastzd2matchzd2_3260 = ((long)13); 
BgL_forwardz00_3261 = BgL_arg2106z00_2902; 
BgL_bufposz00_3262 = BgL_arg2107z00_2903; 
BgL_statezd20zd21013z00_2883:
if(
(BgL_forwardz00_3261==BgL_bufposz00_3262))
{ /* Llib/json.scm 42 */
if(
rgc_fill_buffer(BgL_iportz00_3259))
{ /* Llib/json.scm 42 */
long BgL_arg1661z00_3263;long BgL_arg1662z00_3264;
{ /* Llib/json.scm 42 */
long BgL_res2465z00_3265;
BgL_res2465z00_3265 = 
RGC_BUFFER_FORWARD(BgL_iportz00_3259); 
BgL_arg1661z00_3263 = BgL_res2465z00_3265; } 
{ /* Llib/json.scm 42 */
long BgL_res2466z00_3266;
BgL_res2466z00_3266 = 
RGC_BUFFER_BUFPOS(BgL_iportz00_3259); 
BgL_arg1662z00_3264 = BgL_res2466z00_3266; } 
{ 
long BgL_bufposz00_3535;long BgL_forwardz00_3534;
BgL_forwardz00_3534 = BgL_arg1661z00_3263; 
BgL_bufposz00_3535 = BgL_arg1662z00_3264; 
BgL_bufposz00_3262 = BgL_bufposz00_3535; 
BgL_forwardz00_3261 = BgL_forwardz00_3534; 
goto BgL_statezd20zd21013z00_2883;} }  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_lastzd2matchzd2_3260; } }  else 
{ /* Llib/json.scm 42 */
int BgL_curz00_3267;
{ /* Llib/json.scm 42 */
int BgL_res2467z00_3268;
BgL_res2467z00_3268 = 
RGC_BUFFER_GET_CHAR(BgL_iportz00_3259, BgL_forwardz00_3261); 
BgL_curz00_3267 = BgL_res2467z00_3268; } 
{ /* Llib/json.scm 42 */

switch( 
(long)(BgL_curz00_3267)) { case ((long)125) : 

{ /* Llib/json.scm 42 */
long BgL_arg1667z00_3269;
BgL_arg1667z00_3269 = 
(((long)1)+BgL_forwardz00_3261); 
{ /* Llib/json.scm 42 */
long BgL_newzd2matchzd2_3270;
{ /* Llib/json.scm 42 */
long BgL_res2469z00_3271;
BgL_res2469z00_3271 = 
RGC_STOP_MATCH(BgL_iportz00_3259, BgL_arg1667z00_3269); BgL_res2469z00_3271; } 
BgL_newzd2matchzd2_3270 = ((long)8); 
BgL_matchz00_2901 = BgL_newzd2matchzd2_3270; } } break;case ((long)123) : 

{ /* Llib/json.scm 42 */
long BgL_arg1668z00_3272;
BgL_arg1668z00_3272 = 
(((long)1)+BgL_forwardz00_3261); 
{ /* Llib/json.scm 42 */
long BgL_newzd2matchzd2_3273;
{ /* Llib/json.scm 42 */
long BgL_res2471z00_3274;
BgL_res2471z00_3274 = 
RGC_STOP_MATCH(BgL_iportz00_3259, BgL_arg1668z00_3272); BgL_res2471z00_3274; } 
BgL_newzd2matchzd2_3273 = ((long)7); 
BgL_matchz00_2901 = BgL_newzd2matchzd2_3273; } } break;case ((long)93) : 

{ /* Llib/json.scm 42 */
long BgL_arg1669z00_3275;
BgL_arg1669z00_3275 = 
(((long)1)+BgL_forwardz00_3261); 
{ /* Llib/json.scm 42 */
long BgL_newzd2matchzd2_3276;
{ /* Llib/json.scm 42 */
long BgL_res2473z00_3277;
BgL_res2473z00_3277 = 
RGC_STOP_MATCH(BgL_iportz00_3259, BgL_arg1669z00_3275); BgL_res2473z00_3277; } 
BgL_newzd2matchzd2_3276 = ((long)4); 
BgL_matchz00_2901 = BgL_newzd2matchzd2_3276; } } break;case ((long)91) : 

{ /* Llib/json.scm 42 */
long BgL_arg1670z00_3278;
BgL_arg1670z00_3278 = 
(((long)1)+BgL_forwardz00_3261); 
{ /* Llib/json.scm 42 */
long BgL_newzd2matchzd2_3279;
{ /* Llib/json.scm 42 */
long BgL_res2475z00_3280;
BgL_res2475z00_3280 = 
RGC_STOP_MATCH(BgL_iportz00_3259, BgL_arg1670z00_3278); BgL_res2475z00_3280; } 
BgL_newzd2matchzd2_3279 = ((long)3); 
BgL_matchz00_2901 = BgL_newzd2matchzd2_3279; } } break;case ((long)122) : 
case ((long)121) : 
case ((long)120) : 
case ((long)119) : 
case ((long)118) : 
case ((long)117) : 
case ((long)116) : 
case ((long)115) : 
case ((long)114) : 
case ((long)113) : 
case ((long)112) : 
case ((long)111) : 
case ((long)110) : 
case ((long)109) : 
case ((long)108) : 
case ((long)107) : 
case ((long)106) : 
case ((long)105) : 
case ((long)104) : 
case ((long)103) : 
case ((long)102) : 
case ((long)101) : 
case ((long)100) : 
case ((long)99) : 
case ((long)98) : 
case ((long)97) : 
case ((long)95) : 
case ((long)90) : 
case ((long)89) : 
case ((long)88) : 
case ((long)87) : 
case ((long)86) : 
case ((long)85) : 
case ((long)84) : 
case ((long)83) : 
case ((long)82) : 
case ((long)81) : 
case ((long)80) : 
case ((long)79) : 
case ((long)78) : 
case ((long)77) : 
case ((long)76) : 
case ((long)75) : 
case ((long)74) : 
case ((long)73) : 
case ((long)72) : 
case ((long)71) : 
case ((long)70) : 
case ((long)69) : 
case ((long)68) : 
case ((long)67) : 
case ((long)66) : 
case ((long)65) : 

BgL_iportz00_3391 = BgL_iportz00_3259; 
BgL_lastzd2matchzd2_3392 = BgL_lastzd2matchzd2_3260; 
BgL_forwardz00_3393 = 
(((long)1)+BgL_forwardz00_3261); 
BgL_bufposz00_3394 = BgL_bufposz00_3262; 
BgL_statezd212zd21025z00_2892:
{ /* Llib/json.scm 42 */
long BgL_newzd2matchzd2_3395;
{ /* Llib/json.scm 42 */
long BgL_res2350z00_3396;
BgL_res2350z00_3396 = 
RGC_STOP_MATCH(BgL_iportz00_3391, BgL_forwardz00_3393); BgL_res2350z00_3396; } 
BgL_newzd2matchzd2_3395 = ((long)12); 
if(
(BgL_forwardz00_3393==BgL_bufposz00_3394))
{ /* Llib/json.scm 42 */
if(
rgc_fill_buffer(BgL_iportz00_3391))
{ /* Llib/json.scm 42 */
long BgL_arg1218z00_3397;long BgL_arg1230z00_3398;
{ /* Llib/json.scm 42 */
long BgL_res2353z00_3399;
BgL_res2353z00_3399 = 
RGC_BUFFER_FORWARD(BgL_iportz00_3391); 
BgL_arg1218z00_3397 = BgL_res2353z00_3399; } 
{ /* Llib/json.scm 42 */
long BgL_res2354z00_3400;
BgL_res2354z00_3400 = 
RGC_BUFFER_BUFPOS(BgL_iportz00_3391); 
BgL_arg1230z00_3398 = BgL_res2354z00_3400; } 
{ 
long BgL_bufposz00_3553;long BgL_forwardz00_3552;
BgL_forwardz00_3552 = BgL_arg1218z00_3397; 
BgL_bufposz00_3553 = BgL_arg1230z00_3398; 
BgL_bufposz00_3394 = BgL_bufposz00_3553; 
BgL_forwardz00_3393 = BgL_forwardz00_3552; 
goto BgL_statezd212zd21025z00_2892;} }  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_newzd2matchzd2_3395; } }  else 
{ /* Llib/json.scm 42 */
int BgL_curz00_3401;
{ /* Llib/json.scm 42 */
int BgL_res2355z00_3402;
BgL_res2355z00_3402 = 
RGC_BUFFER_GET_CHAR(BgL_iportz00_3391, BgL_forwardz00_3393); 
BgL_curz00_3401 = BgL_res2355z00_3402; } 
{ /* Llib/json.scm 42 */

{ /* Llib/json.scm 42 */
bool_t BgL_test2960z00_3555;
{ /* Llib/json.scm 42 */
bool_t BgL_test2961z00_3556;
if(
(
(long)(BgL_curz00_3401)>=((long)48)))
{ /* Llib/json.scm 42 */
BgL_test2961z00_3556 = 
(
(long)(BgL_curz00_3401)<((long)58))
; }  else 
{ /* Llib/json.scm 42 */
BgL_test2961z00_3556 = ((bool_t)0)
; } 
if(BgL_test2961z00_3556)
{ /* Llib/json.scm 42 */
BgL_test2960z00_3555 = ((bool_t)1)
; }  else 
{ /* Llib/json.scm 42 */
bool_t BgL_test2963z00_3562;
if(
(
(long)(BgL_curz00_3401)>=((long)65)))
{ /* Llib/json.scm 42 */
BgL_test2963z00_3562 = 
(
(long)(BgL_curz00_3401)<((long)91))
; }  else 
{ /* Llib/json.scm 42 */
BgL_test2963z00_3562 = ((bool_t)0)
; } 
if(BgL_test2963z00_3562)
{ /* Llib/json.scm 42 */
BgL_test2960z00_3555 = ((bool_t)1)
; }  else 
{ /* Llib/json.scm 42 */
if(
(
(long)(BgL_curz00_3401)==((long)95)))
{ /* Llib/json.scm 42 */
BgL_test2960z00_3555 = ((bool_t)1)
; }  else 
{ /* Llib/json.scm 42 */
if(
(
(long)(BgL_curz00_3401)>=((long)97)))
{ /* Llib/json.scm 42 */
BgL_test2960z00_3555 = 
(
(long)(BgL_curz00_3401)<((long)123))
; }  else 
{ /* Llib/json.scm 42 */
BgL_test2960z00_3555 = ((bool_t)0)
; } } } } } 
if(BgL_test2960z00_3555)
{ /* Llib/json.scm 42 */
BgL_iportz00_3306 = BgL_iportz00_3391; 
BgL_lastzd2matchzd2_3307 = BgL_newzd2matchzd2_3395; 
BgL_forwardz00_3308 = 
(((long)1)+BgL_forwardz00_3393); 
BgL_bufposz00_3309 = BgL_bufposz00_3394; 
BgL_statezd218zd21031z00_2885:
{ /* Llib/json.scm 42 */
long BgL_newzd2matchzd2_3310;
{ /* Llib/json.scm 42 */
long BgL_res2441z00_3311;
BgL_res2441z00_3311 = 
RGC_STOP_MATCH(BgL_iportz00_3306, BgL_forwardz00_3308); BgL_res2441z00_3311; } 
BgL_newzd2matchzd2_3310 = ((long)12); 
if(
(BgL_forwardz00_3308==BgL_bufposz00_3309))
{ /* Llib/json.scm 42 */
if(
rgc_fill_buffer(BgL_iportz00_3306))
{ /* Llib/json.scm 42 */
long BgL_arg1621z00_3312;long BgL_arg1623z00_3313;
{ /* Llib/json.scm 42 */
long BgL_res2444z00_3314;
BgL_res2444z00_3314 = 
RGC_BUFFER_FORWARD(BgL_iportz00_3306); 
BgL_arg1621z00_3312 = BgL_res2444z00_3314; } 
{ /* Llib/json.scm 42 */
long BgL_res2445z00_3315;
BgL_res2445z00_3315 = 
RGC_BUFFER_BUFPOS(BgL_iportz00_3306); 
BgL_arg1623z00_3313 = BgL_res2445z00_3315; } 
{ 
long BgL_bufposz00_3584;long BgL_forwardz00_3583;
BgL_forwardz00_3583 = BgL_arg1621z00_3312; 
BgL_bufposz00_3584 = BgL_arg1623z00_3313; 
BgL_bufposz00_3309 = BgL_bufposz00_3584; 
BgL_forwardz00_3308 = BgL_forwardz00_3583; 
goto BgL_statezd218zd21031z00_2885;} }  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_newzd2matchzd2_3310; } }  else 
{ /* Llib/json.scm 42 */
int BgL_curz00_3316;
{ /* Llib/json.scm 42 */
int BgL_res2446z00_3317;
BgL_res2446z00_3317 = 
RGC_BUFFER_GET_CHAR(BgL_iportz00_3306, BgL_forwardz00_3308); 
BgL_curz00_3316 = BgL_res2446z00_3317; } 
{ /* Llib/json.scm 42 */

{ /* Llib/json.scm 42 */
bool_t BgL_test2969z00_3586;
{ /* Llib/json.scm 42 */
bool_t BgL_test2970z00_3587;
if(
(
(long)(BgL_curz00_3316)>=((long)48)))
{ /* Llib/json.scm 42 */
BgL_test2970z00_3587 = 
(
(long)(BgL_curz00_3316)<((long)58))
; }  else 
{ /* Llib/json.scm 42 */
BgL_test2970z00_3587 = ((bool_t)0)
; } 
if(BgL_test2970z00_3587)
{ /* Llib/json.scm 42 */
BgL_test2969z00_3586 = ((bool_t)1)
; }  else 
{ /* Llib/json.scm 42 */
bool_t BgL_test2972z00_3593;
if(
(
(long)(BgL_curz00_3316)>=((long)65)))
{ /* Llib/json.scm 42 */
BgL_test2972z00_3593 = 
(
(long)(BgL_curz00_3316)<((long)91))
; }  else 
{ /* Llib/json.scm 42 */
BgL_test2972z00_3593 = ((bool_t)0)
; } 
if(BgL_test2972z00_3593)
{ /* Llib/json.scm 42 */
BgL_test2969z00_3586 = ((bool_t)1)
; }  else 
{ /* Llib/json.scm 42 */
if(
(
(long)(BgL_curz00_3316)==((long)95)))
{ /* Llib/json.scm 42 */
BgL_test2969z00_3586 = ((bool_t)1)
; }  else 
{ /* Llib/json.scm 42 */
if(
(
(long)(BgL_curz00_3316)>=((long)97)))
{ /* Llib/json.scm 42 */
BgL_test2969z00_3586 = 
(
(long)(BgL_curz00_3316)<((long)123))
; }  else 
{ /* Llib/json.scm 42 */
BgL_test2969z00_3586 = ((bool_t)0)
; } } } } } 
if(BgL_test2969z00_3586)
{ 
long BgL_forwardz00_3608;long BgL_lastzd2matchzd2_3607;
BgL_lastzd2matchzd2_3607 = BgL_newzd2matchzd2_3310; 
BgL_forwardz00_3608 = 
(((long)1)+BgL_forwardz00_3308); 
BgL_forwardz00_3308 = BgL_forwardz00_3608; 
BgL_lastzd2matchzd2_3307 = BgL_lastzd2matchzd2_3607; 
goto BgL_statezd218zd21031z00_2885;}  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_newzd2matchzd2_3310; } } } } } }  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_newzd2matchzd2_3395; } } } } } break;case ((long)58) : 

{ /* Llib/json.scm 42 */
long BgL_arg1673z00_3281;
BgL_arg1673z00_3281 = 
(((long)1)+BgL_forwardz00_3261); 
{ /* Llib/json.scm 42 */
long BgL_newzd2matchzd2_3282;
{ /* Llib/json.scm 42 */
long BgL_res2478z00_3283;
BgL_res2478z00_3283 = 
RGC_STOP_MATCH(BgL_iportz00_3259, BgL_arg1673z00_3281); BgL_res2478z00_3283; } 
BgL_newzd2matchzd2_3282 = ((long)2); 
BgL_matchz00_2901 = BgL_newzd2matchzd2_3282; } } break;case ((long)57) : 
case ((long)56) : 
case ((long)55) : 
case ((long)54) : 
case ((long)53) : 
case ((long)52) : 
case ((long)51) : 
case ((long)50) : 
case ((long)49) : 
case ((long)48) : 

BgL_iportz00_3318 = BgL_iportz00_3259; 
BgL_lastzd2matchzd2_3319 = BgL_lastzd2matchzd2_3260; 
BgL_forwardz00_3320 = 
(((long)1)+BgL_forwardz00_3261); 
BgL_bufposz00_3321 = BgL_bufposz00_3262; 
BgL_statezd210zd21023z00_2886:
{ /* Llib/json.scm 42 */
long BgL_newzd2matchzd2_3322;
{ /* Llib/json.scm 42 */
long BgL_res2427z00_3323;
BgL_res2427z00_3323 = 
RGC_STOP_MATCH(BgL_iportz00_3318, BgL_forwardz00_3320); BgL_res2427z00_3323; } 
BgL_newzd2matchzd2_3322 = ((long)9); 
if(
(BgL_forwardz00_3320==BgL_bufposz00_3321))
{ /* Llib/json.scm 42 */
if(
rgc_fill_buffer(BgL_iportz00_3318))
{ /* Llib/json.scm 42 */
long BgL_arg1577z00_3324;long BgL_arg1578z00_3325;
{ /* Llib/json.scm 42 */
long BgL_res2430z00_3326;
BgL_res2430z00_3326 = 
RGC_BUFFER_FORWARD(BgL_iportz00_3318); 
BgL_arg1577z00_3324 = BgL_res2430z00_3326; } 
{ /* Llib/json.scm 42 */
long BgL_res2431z00_3327;
BgL_res2431z00_3327 = 
RGC_BUFFER_BUFPOS(BgL_iportz00_3318); 
BgL_arg1578z00_3325 = BgL_res2431z00_3327; } 
{ 
long BgL_bufposz00_3622;long BgL_forwardz00_3621;
BgL_forwardz00_3621 = BgL_arg1577z00_3324; 
BgL_bufposz00_3622 = BgL_arg1578z00_3325; 
BgL_bufposz00_3321 = BgL_bufposz00_3622; 
BgL_forwardz00_3320 = BgL_forwardz00_3621; 
goto BgL_statezd210zd21023z00_2886;} }  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_newzd2matchzd2_3322; } }  else 
{ /* Llib/json.scm 42 */
int BgL_curz00_3328;
{ /* Llib/json.scm 42 */
int BgL_res2432z00_3329;
BgL_res2432z00_3329 = 
RGC_BUFFER_GET_CHAR(BgL_iportz00_3318, BgL_forwardz00_3320); 
BgL_curz00_3328 = BgL_res2432z00_3329; } 
{ /* Llib/json.scm 42 */

{ /* Llib/json.scm 42 */
bool_t BgL_test2978z00_3624;
if(
(
(long)(BgL_curz00_3328)==((long)69)))
{ /* Llib/json.scm 42 */
BgL_test2978z00_3624 = ((bool_t)1)
; }  else 
{ /* Llib/json.scm 42 */
BgL_test2978z00_3624 = 
(
(long)(BgL_curz00_3328)==((long)101))
; } 
if(BgL_test2978z00_3624)
{ /* Llib/json.scm 42 */
BgL_iportz00_3403 = BgL_iportz00_3318; 
BgL_lastzd2matchzd2_3404 = BgL_newzd2matchzd2_3322; 
BgL_forwardz00_3405 = 
(((long)1)+BgL_forwardz00_3320); 
BgL_bufposz00_3406 = BgL_bufposz00_3321; 
BgL_statezd221zd21034z00_2893:
if(
(BgL_forwardz00_3405==BgL_bufposz00_3406))
{ /* Llib/json.scm 42 */
if(
rgc_fill_buffer(BgL_iportz00_3403))
{ /* Llib/json.scm 42 */
long BgL_arg1200z00_3407;long BgL_arg1201z00_3408;
{ /* Llib/json.scm 42 */
long BgL_res2341z00_3409;
BgL_res2341z00_3409 = 
RGC_BUFFER_FORWARD(BgL_iportz00_3403); 
BgL_arg1200z00_3407 = BgL_res2341z00_3409; } 
{ /* Llib/json.scm 42 */
long BgL_res2342z00_3410;
BgL_res2342z00_3410 = 
RGC_BUFFER_BUFPOS(BgL_iportz00_3403); 
BgL_arg1201z00_3408 = BgL_res2342z00_3410; } 
{ 
long BgL_bufposz00_3637;long BgL_forwardz00_3636;
BgL_forwardz00_3636 = BgL_arg1200z00_3407; 
BgL_bufposz00_3637 = BgL_arg1201z00_3408; 
BgL_bufposz00_3406 = BgL_bufposz00_3637; 
BgL_forwardz00_3405 = BgL_forwardz00_3636; 
goto BgL_statezd221zd21034z00_2893;} }  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_lastzd2matchzd2_3404; } }  else 
{ /* Llib/json.scm 42 */
int BgL_curz00_3411;
{ /* Llib/json.scm 42 */
int BgL_res2343z00_3412;
BgL_res2343z00_3412 = 
RGC_BUFFER_GET_CHAR(BgL_iportz00_3403, BgL_forwardz00_3405); 
BgL_curz00_3411 = BgL_res2343z00_3412; } 
{ /* Llib/json.scm 42 */

{ /* Llib/json.scm 42 */
bool_t BgL_test2982z00_3639;
if(
(
(long)(BgL_curz00_3411)>=((long)48)))
{ /* Llib/json.scm 42 */
BgL_test2982z00_3639 = 
(
(long)(BgL_curz00_3411)<((long)58))
; }  else 
{ /* Llib/json.scm 42 */
BgL_test2982z00_3639 = ((bool_t)0)
; } 
if(BgL_test2982z00_3639)
{ /* Llib/json.scm 42 */
BgL_iportz00_3154 = BgL_iportz00_3403; 
BgL_lastzd2matchzd2_3155 = BgL_lastzd2matchzd2_3404; 
BgL_forwardz00_3156 = 
(((long)1)+BgL_forwardz00_3405); 
BgL_bufposz00_3157 = BgL_bufposz00_3406; 
BgL_statezd223zd21036z00_2875:
{ /* Llib/json.scm 42 */
long BgL_newzd2matchzd2_3158;
{ /* Llib/json.scm 42 */
long BgL_res2584z00_3159;
BgL_res2584z00_3159 = 
RGC_STOP_MATCH(BgL_iportz00_3154, BgL_forwardz00_3156); BgL_res2584z00_3159; } 
BgL_newzd2matchzd2_3158 = ((long)10); 
if(
(BgL_forwardz00_3156==BgL_bufposz00_3157))
{ /* Llib/json.scm 42 */
if(
rgc_fill_buffer(BgL_iportz00_3154))
{ /* Llib/json.scm 42 */
long BgL_arg1808z00_3160;long BgL_arg1809z00_3161;
{ /* Llib/json.scm 42 */
long BgL_res2587z00_3162;
BgL_res2587z00_3162 = 
RGC_BUFFER_FORWARD(BgL_iportz00_3154); 
BgL_arg1808z00_3160 = BgL_res2587z00_3162; } 
{ /* Llib/json.scm 42 */
long BgL_res2588z00_3163;
BgL_res2588z00_3163 = 
RGC_BUFFER_BUFPOS(BgL_iportz00_3154); 
BgL_arg1809z00_3161 = BgL_res2588z00_3163; } 
{ 
long BgL_bufposz00_3653;long BgL_forwardz00_3652;
BgL_forwardz00_3652 = BgL_arg1808z00_3160; 
BgL_bufposz00_3653 = BgL_arg1809z00_3161; 
BgL_bufposz00_3157 = BgL_bufposz00_3653; 
BgL_forwardz00_3156 = BgL_forwardz00_3652; 
goto BgL_statezd223zd21036z00_2875;} }  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_newzd2matchzd2_3158; } }  else 
{ /* Llib/json.scm 42 */
int BgL_curz00_3164;
{ /* Llib/json.scm 42 */
int BgL_res2589z00_3165;
BgL_res2589z00_3165 = 
RGC_BUFFER_GET_CHAR(BgL_iportz00_3154, BgL_forwardz00_3156); 
BgL_curz00_3164 = BgL_res2589z00_3165; } 
{ /* Llib/json.scm 42 */

{ /* Llib/json.scm 42 */
bool_t BgL_test2986z00_3655;
switch( 
(long)(BgL_curz00_3164)) { case ((long)70) : 

BgL_test2986z00_3655 = ((bool_t)1); break;case ((long)76) : 

BgL_test2986z00_3655 = ((bool_t)1); break;case ((long)102) : 

BgL_test2986z00_3655 = ((bool_t)1); break;
default: 
BgL_test2986z00_3655 = 
(
(long)(BgL_curz00_3164)==((long)108)); } 
if(BgL_test2986z00_3655)
{ /* Llib/json.scm 42 */
long BgL_arg1812z00_3166;
BgL_arg1812z00_3166 = 
(((long)1)+BgL_forwardz00_3156); 
{ /* Llib/json.scm 42 */
long BgL_newzd2matchzd2_3167;
{ /* Llib/json.scm 42 */
long BgL_res2594z00_3168;
BgL_res2594z00_3168 = 
RGC_STOP_MATCH(BgL_iportz00_3154, BgL_arg1812z00_3166); BgL_res2594z00_3168; } 
BgL_newzd2matchzd2_3167 = ((long)10); 
BgL_matchz00_2901 = BgL_newzd2matchzd2_3167; } }  else 
{ /* Llib/json.scm 42 */
bool_t BgL_test2987z00_3662;
if(
(
(long)(BgL_curz00_3164)>=((long)48)))
{ /* Llib/json.scm 42 */
BgL_test2987z00_3662 = 
(
(long)(BgL_curz00_3164)<((long)58))
; }  else 
{ /* Llib/json.scm 42 */
BgL_test2987z00_3662 = ((bool_t)0)
; } 
if(BgL_test2987z00_3662)
{ 
long BgL_forwardz00_3669;long BgL_lastzd2matchzd2_3668;
BgL_lastzd2matchzd2_3668 = BgL_newzd2matchzd2_3158; 
BgL_forwardz00_3669 = 
(((long)1)+BgL_forwardz00_3156); 
BgL_forwardz00_3156 = BgL_forwardz00_3669; 
BgL_lastzd2matchzd2_3155 = BgL_lastzd2matchzd2_3668; 
goto BgL_statezd223zd21036z00_2875;}  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_newzd2matchzd2_3158; } } } } } } }  else 
{ /* Llib/json.scm 42 */
bool_t BgL_test2989z00_3672;
if(
(
(long)(BgL_curz00_3411)==((long)43)))
{ /* Llib/json.scm 42 */
BgL_test2989z00_3672 = ((bool_t)1)
; }  else 
{ /* Llib/json.scm 42 */
BgL_test2989z00_3672 = 
(
(long)(BgL_curz00_3411)==((long)45))
; } 
if(BgL_test2989z00_3672)
{ /* Llib/json.scm 42 */
BgL_iportz00_3296 = BgL_iportz00_3403; 
BgL_lastzd2matchzd2_3297 = BgL_lastzd2matchzd2_3404; 
BgL_forwardz00_3298 = 
(((long)1)+BgL_forwardz00_3405); 
BgL_bufposz00_3299 = BgL_bufposz00_3406; 
BgL_statezd222zd21035z00_2884:
if(
(BgL_forwardz00_3298==BgL_bufposz00_3299))
{ /* Llib/json.scm 42 */
if(
rgc_fill_buffer(BgL_iportz00_3296))
{ /* Llib/json.scm 42 */
long BgL_arg1649z00_3300;long BgL_arg1650z00_3301;
{ /* Llib/json.scm 42 */
long BgL_res2457z00_3302;
BgL_res2457z00_3302 = 
RGC_BUFFER_FORWARD(BgL_iportz00_3296); 
BgL_arg1649z00_3300 = BgL_res2457z00_3302; } 
{ /* Llib/json.scm 42 */
long BgL_res2458z00_3303;
BgL_res2458z00_3303 = 
RGC_BUFFER_BUFPOS(BgL_iportz00_3296); 
BgL_arg1650z00_3301 = BgL_res2458z00_3303; } 
{ 
long BgL_bufposz00_3685;long BgL_forwardz00_3684;
BgL_forwardz00_3684 = BgL_arg1649z00_3300; 
BgL_bufposz00_3685 = BgL_arg1650z00_3301; 
BgL_bufposz00_3299 = BgL_bufposz00_3685; 
BgL_forwardz00_3298 = BgL_forwardz00_3684; 
goto BgL_statezd222zd21035z00_2884;} }  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_lastzd2matchzd2_3297; } }  else 
{ /* Llib/json.scm 42 */
int BgL_curz00_3304;
{ /* Llib/json.scm 42 */
int BgL_res2459z00_3305;
BgL_res2459z00_3305 = 
RGC_BUFFER_GET_CHAR(BgL_iportz00_3296, BgL_forwardz00_3298); 
BgL_curz00_3304 = BgL_res2459z00_3305; } 
{ /* Llib/json.scm 42 */

{ /* Llib/json.scm 42 */
bool_t BgL_test2993z00_3687;
if(
(
(long)(BgL_curz00_3304)>=((long)48)))
{ /* Llib/json.scm 42 */
BgL_test2993z00_3687 = 
(
(long)(BgL_curz00_3304)<((long)58))
; }  else 
{ /* Llib/json.scm 42 */
BgL_test2993z00_3687 = ((bool_t)0)
; } 
if(BgL_test2993z00_3687)
{ 
long BgL_bufposz00_3697;long BgL_forwardz00_3695;long BgL_lastzd2matchzd2_3694;obj_t BgL_iportz00_3693;
BgL_iportz00_3693 = BgL_iportz00_3296; 
BgL_lastzd2matchzd2_3694 = BgL_lastzd2matchzd2_3297; 
BgL_forwardz00_3695 = 
(((long)1)+BgL_forwardz00_3298); 
BgL_bufposz00_3697 = BgL_bufposz00_3299; 
BgL_bufposz00_3157 = BgL_bufposz00_3697; 
BgL_forwardz00_3156 = BgL_forwardz00_3695; 
BgL_lastzd2matchzd2_3155 = BgL_lastzd2matchzd2_3694; 
BgL_iportz00_3154 = BgL_iportz00_3693; 
goto BgL_statezd223zd21036z00_2875;}  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_lastzd2matchzd2_3297; } } } } }  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_lastzd2matchzd2_3404; } } } } } }  else 
{ /* Llib/json.scm 42 */
bool_t BgL_test2995z00_3700;
if(
(
(long)(BgL_curz00_3328)>=((long)48)))
{ /* Llib/json.scm 42 */
BgL_test2995z00_3700 = 
(
(long)(BgL_curz00_3328)<((long)58))
; }  else 
{ /* Llib/json.scm 42 */
BgL_test2995z00_3700 = ((bool_t)0)
; } 
if(BgL_test2995z00_3700)
{ /* Llib/json.scm 42 */
BgL_iportz00_3453 = BgL_iportz00_3318; 
BgL_lastzd2matchzd2_3454 = BgL_newzd2matchzd2_3322; 
BgL_forwardz00_3455 = 
(((long)1)+BgL_forwardz00_3320); 
BgL_bufposz00_3456 = BgL_bufposz00_3321; 
BgL_statezd220zd21033z00_2898:
{ /* Llib/json.scm 42 */
long BgL_newzd2matchzd2_3457;
{ /* Llib/json.scm 42 */
long BgL_res2277z00_3458;
BgL_res2277z00_3458 = 
RGC_STOP_MATCH(BgL_iportz00_3453, BgL_forwardz00_3455); BgL_res2277z00_3458; } 
BgL_newzd2matchzd2_3457 = ((long)9); 
if(
(BgL_forwardz00_3455==BgL_bufposz00_3456))
{ /* Llib/json.scm 42 */
if(
rgc_fill_buffer(BgL_iportz00_3453))
{ /* Llib/json.scm 42 */
long BgL_arg1117z00_3459;long BgL_arg1118z00_3460;
{ /* Llib/json.scm 42 */
long BgL_res2280z00_3461;
BgL_res2280z00_3461 = 
RGC_BUFFER_FORWARD(BgL_iportz00_3453); 
BgL_arg1117z00_3459 = BgL_res2280z00_3461; } 
{ /* Llib/json.scm 42 */
long BgL_res2281z00_3462;
BgL_res2281z00_3462 = 
RGC_BUFFER_BUFPOS(BgL_iportz00_3453); 
BgL_arg1118z00_3460 = BgL_res2281z00_3462; } 
{ 
long BgL_bufposz00_3714;long BgL_forwardz00_3713;
BgL_forwardz00_3713 = BgL_arg1117z00_3459; 
BgL_bufposz00_3714 = BgL_arg1118z00_3460; 
BgL_bufposz00_3456 = BgL_bufposz00_3714; 
BgL_forwardz00_3455 = BgL_forwardz00_3713; 
goto BgL_statezd220zd21033z00_2898;} }  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_newzd2matchzd2_3457; } }  else 
{ /* Llib/json.scm 42 */
int BgL_curz00_3463;
{ /* Llib/json.scm 42 */
int BgL_res2282z00_3464;
BgL_res2282z00_3464 = 
RGC_BUFFER_GET_CHAR(BgL_iportz00_3453, BgL_forwardz00_3455); 
BgL_curz00_3463 = BgL_res2282z00_3464; } 
{ /* Llib/json.scm 42 */

{ /* Llib/json.scm 42 */
bool_t BgL_test2999z00_3716;
if(
(
(long)(BgL_curz00_3463)==((long)69)))
{ /* Llib/json.scm 42 */
BgL_test2999z00_3716 = ((bool_t)1)
; }  else 
{ /* Llib/json.scm 42 */
BgL_test2999z00_3716 = 
(
(long)(BgL_curz00_3463)==((long)101))
; } 
if(BgL_test2999z00_3716)
{ 
long BgL_bufposz00_3726;long BgL_forwardz00_3724;long BgL_lastzd2matchzd2_3723;obj_t BgL_iportz00_3722;
BgL_iportz00_3722 = BgL_iportz00_3453; 
BgL_lastzd2matchzd2_3723 = BgL_newzd2matchzd2_3457; 
BgL_forwardz00_3724 = 
(((long)1)+BgL_forwardz00_3455); 
BgL_bufposz00_3726 = BgL_bufposz00_3456; 
BgL_bufposz00_3406 = BgL_bufposz00_3726; 
BgL_forwardz00_3405 = BgL_forwardz00_3724; 
BgL_lastzd2matchzd2_3404 = BgL_lastzd2matchzd2_3723; 
BgL_iportz00_3403 = BgL_iportz00_3722; 
goto BgL_statezd221zd21034z00_2893;}  else 
{ /* Llib/json.scm 42 */
bool_t BgL_test3001z00_3727;
if(
(
(long)(BgL_curz00_3463)>=((long)48)))
{ /* Llib/json.scm 42 */
BgL_test3001z00_3727 = 
(
(long)(BgL_curz00_3463)<((long)58))
; }  else 
{ /* Llib/json.scm 42 */
BgL_test3001z00_3727 = ((bool_t)0)
; } 
if(BgL_test3001z00_3727)
{ 
long BgL_forwardz00_3734;long BgL_lastzd2matchzd2_3733;
BgL_lastzd2matchzd2_3733 = BgL_newzd2matchzd2_3457; 
BgL_forwardz00_3734 = 
(((long)1)+BgL_forwardz00_3455); 
BgL_forwardz00_3455 = BgL_forwardz00_3734; 
BgL_lastzd2matchzd2_3454 = BgL_lastzd2matchzd2_3733; 
goto BgL_statezd220zd21033z00_2898;}  else 
{ /* Llib/json.scm 42 */
if(
(
(long)(BgL_curz00_3463)==((long)46)))
{ /* Llib/json.scm 42 */
BgL_iportz00_3169 = BgL_iportz00_3453; 
BgL_lastzd2matchzd2_3170 = BgL_newzd2matchzd2_3457; 
BgL_forwardz00_3171 = 
(((long)1)+BgL_forwardz00_3455); 
BgL_bufposz00_3172 = BgL_bufposz00_3456; 
BgL_statezd219zd21032z00_2876:
{ /* Llib/json.scm 42 */
long BgL_newzd2matchzd2_3173;
{ /* Llib/json.scm 42 */
long BgL_res2567z00_3174;
BgL_res2567z00_3174 = 
RGC_STOP_MATCH(BgL_iportz00_3169, BgL_forwardz00_3171); BgL_res2567z00_3174; } 
BgL_newzd2matchzd2_3173 = ((long)10); 
if(
(BgL_forwardz00_3171==BgL_bufposz00_3172))
{ /* Llib/json.scm 42 */
if(
rgc_fill_buffer(BgL_iportz00_3169))
{ /* Llib/json.scm 42 */
long BgL_arg1794z00_3175;long BgL_arg1795z00_3176;
{ /* Llib/json.scm 42 */
long BgL_res2570z00_3177;
BgL_res2570z00_3177 = 
RGC_BUFFER_FORWARD(BgL_iportz00_3169); 
BgL_arg1794z00_3175 = BgL_res2570z00_3177; } 
{ /* Llib/json.scm 42 */
long BgL_res2571z00_3178;
BgL_res2571z00_3178 = 
RGC_BUFFER_BUFPOS(BgL_iportz00_3169); 
BgL_arg1795z00_3176 = BgL_res2571z00_3178; } 
{ 
long BgL_bufposz00_3747;long BgL_forwardz00_3746;
BgL_forwardz00_3746 = BgL_arg1794z00_3175; 
BgL_bufposz00_3747 = BgL_arg1795z00_3176; 
BgL_bufposz00_3172 = BgL_bufposz00_3747; 
BgL_forwardz00_3171 = BgL_forwardz00_3746; 
goto BgL_statezd219zd21032z00_2876;} }  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_newzd2matchzd2_3173; } }  else 
{ /* Llib/json.scm 42 */
int BgL_curz00_3179;
{ /* Llib/json.scm 42 */
int BgL_res2572z00_3180;
BgL_res2572z00_3180 = 
RGC_BUFFER_GET_CHAR(BgL_iportz00_3169, BgL_forwardz00_3171); 
BgL_curz00_3179 = BgL_res2572z00_3180; } 
{ /* Llib/json.scm 42 */

{ /* Llib/json.scm 42 */
bool_t BgL_test3006z00_3749;
switch( 
(long)(BgL_curz00_3179)) { case ((long)70) : 

BgL_test3006z00_3749 = ((bool_t)1); break;case ((long)76) : 

BgL_test3006z00_3749 = ((bool_t)1); break;case ((long)102) : 

BgL_test3006z00_3749 = ((bool_t)1); break;
default: 
BgL_test3006z00_3749 = 
(
(long)(BgL_curz00_3179)==((long)108)); } 
if(BgL_test3006z00_3749)
{ /* Llib/json.scm 42 */
long BgL_arg1798z00_3181;
BgL_arg1798z00_3181 = 
(((long)1)+BgL_forwardz00_3171); 
{ /* Llib/json.scm 42 */
long BgL_newzd2matchzd2_3182;
{ /* Llib/json.scm 42 */
long BgL_res2577z00_3183;
BgL_res2577z00_3183 = 
RGC_STOP_MATCH(BgL_iportz00_3169, BgL_arg1798z00_3181); BgL_res2577z00_3183; } 
BgL_newzd2matchzd2_3182 = ((long)10); 
BgL_matchz00_2901 = BgL_newzd2matchzd2_3182; } }  else 
{ /* Llib/json.scm 42 */
bool_t BgL_test3007z00_3756;
if(
(
(long)(BgL_curz00_3179)==((long)69)))
{ /* Llib/json.scm 42 */
BgL_test3007z00_3756 = ((bool_t)1)
; }  else 
{ /* Llib/json.scm 42 */
BgL_test3007z00_3756 = 
(
(long)(BgL_curz00_3179)==((long)101))
; } 
if(BgL_test3007z00_3756)
{ /* Llib/json.scm 42 */
BgL_iportz00_3234 = BgL_iportz00_3169; 
BgL_lastzd2matchzd2_3235 = BgL_newzd2matchzd2_3173; 
BgL_forwardz00_3236 = 
(((long)1)+BgL_forwardz00_3171); 
BgL_bufposz00_3237 = BgL_bufposz00_3172; 
BgL_statezd225zd21038z00_2881:
if(
(BgL_forwardz00_3236==BgL_bufposz00_3237))
{ /* Llib/json.scm 42 */
if(
rgc_fill_buffer(BgL_iportz00_3234))
{ /* Llib/json.scm 42 */
long BgL_arg1718z00_3238;long BgL_arg1719z00_3239;
{ /* Llib/json.scm 42 */
long BgL_res2511z00_3240;
BgL_res2511z00_3240 = 
RGC_BUFFER_FORWARD(BgL_iportz00_3234); 
BgL_arg1718z00_3238 = BgL_res2511z00_3240; } 
{ /* Llib/json.scm 42 */
long BgL_res2512z00_3241;
BgL_res2512z00_3241 = 
RGC_BUFFER_BUFPOS(BgL_iportz00_3234); 
BgL_arg1719z00_3239 = BgL_res2512z00_3241; } 
{ 
long BgL_bufposz00_3769;long BgL_forwardz00_3768;
BgL_forwardz00_3768 = BgL_arg1718z00_3238; 
BgL_bufposz00_3769 = BgL_arg1719z00_3239; 
BgL_bufposz00_3237 = BgL_bufposz00_3769; 
BgL_forwardz00_3236 = BgL_forwardz00_3768; 
goto BgL_statezd225zd21038z00_2881;} }  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_lastzd2matchzd2_3235; } }  else 
{ /* Llib/json.scm 42 */
int BgL_curz00_3242;
{ /* Llib/json.scm 42 */
int BgL_res2513z00_3243;
BgL_res2513z00_3243 = 
RGC_BUFFER_GET_CHAR(BgL_iportz00_3234, BgL_forwardz00_3236); 
BgL_curz00_3242 = BgL_res2513z00_3243; } 
{ /* Llib/json.scm 42 */

{ /* Llib/json.scm 42 */
bool_t BgL_test3011z00_3771;
if(
(
(long)(BgL_curz00_3242)>=((long)48)))
{ /* Llib/json.scm 42 */
BgL_test3011z00_3771 = 
(
(long)(BgL_curz00_3242)<((long)58))
; }  else 
{ /* Llib/json.scm 42 */
BgL_test3011z00_3771 = ((bool_t)0)
; } 
if(BgL_test3011z00_3771)
{ /* Llib/json.scm 42 */
BgL_iportz00_3209 = BgL_iportz00_3234; 
BgL_lastzd2matchzd2_3210 = BgL_lastzd2matchzd2_3235; 
BgL_forwardz00_3211 = 
(((long)1)+BgL_forwardz00_3236); 
BgL_bufposz00_3212 = BgL_bufposz00_3237; 
BgL_statezd227zd21040z00_2879:
{ /* Llib/json.scm 42 */
long BgL_newzd2matchzd2_3213;
{ /* Llib/json.scm 42 */
long BgL_res2528z00_3214;
BgL_res2528z00_3214 = 
RGC_STOP_MATCH(BgL_iportz00_3209, BgL_forwardz00_3211); BgL_res2528z00_3214; } 
BgL_newzd2matchzd2_3213 = ((long)10); 
if(
(BgL_forwardz00_3211==BgL_bufposz00_3212))
{ /* Llib/json.scm 42 */
if(
rgc_fill_buffer(BgL_iportz00_3209))
{ /* Llib/json.scm 42 */
long BgL_arg1761z00_3215;long BgL_arg1762z00_3216;
{ /* Llib/json.scm 42 */
long BgL_res2531z00_3217;
BgL_res2531z00_3217 = 
RGC_BUFFER_FORWARD(BgL_iportz00_3209); 
BgL_arg1761z00_3215 = BgL_res2531z00_3217; } 
{ /* Llib/json.scm 42 */
long BgL_res2532z00_3218;
BgL_res2532z00_3218 = 
RGC_BUFFER_BUFPOS(BgL_iportz00_3209); 
BgL_arg1762z00_3216 = BgL_res2532z00_3218; } 
{ 
long BgL_bufposz00_3785;long BgL_forwardz00_3784;
BgL_forwardz00_3784 = BgL_arg1761z00_3215; 
BgL_bufposz00_3785 = BgL_arg1762z00_3216; 
BgL_bufposz00_3212 = BgL_bufposz00_3785; 
BgL_forwardz00_3211 = BgL_forwardz00_3784; 
goto BgL_statezd227zd21040z00_2879;} }  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_newzd2matchzd2_3213; } }  else 
{ /* Llib/json.scm 42 */
int BgL_curz00_3219;
{ /* Llib/json.scm 42 */
int BgL_res2533z00_3220;
BgL_res2533z00_3220 = 
RGC_BUFFER_GET_CHAR(BgL_iportz00_3209, BgL_forwardz00_3211); 
BgL_curz00_3219 = BgL_res2533z00_3220; } 
{ /* Llib/json.scm 42 */

{ /* Llib/json.scm 42 */
bool_t BgL_test3015z00_3787;
switch( 
(long)(BgL_curz00_3219)) { case ((long)70) : 

BgL_test3015z00_3787 = ((bool_t)1); break;case ((long)76) : 

BgL_test3015z00_3787 = ((bool_t)1); break;case ((long)102) : 

BgL_test3015z00_3787 = ((bool_t)1); break;
default: 
BgL_test3015z00_3787 = 
(
(long)(BgL_curz00_3219)==((long)108)); } 
if(BgL_test3015z00_3787)
{ /* Llib/json.scm 42 */
long BgL_arg1765z00_3221;
BgL_arg1765z00_3221 = 
(((long)1)+BgL_forwardz00_3211); 
{ /* Llib/json.scm 42 */
long BgL_newzd2matchzd2_3222;
{ /* Llib/json.scm 42 */
long BgL_res2538z00_3223;
BgL_res2538z00_3223 = 
RGC_STOP_MATCH(BgL_iportz00_3209, BgL_arg1765z00_3221); BgL_res2538z00_3223; } 
BgL_newzd2matchzd2_3222 = ((long)10); 
BgL_matchz00_2901 = BgL_newzd2matchzd2_3222; } }  else 
{ /* Llib/json.scm 42 */
bool_t BgL_test3016z00_3794;
if(
(
(long)(BgL_curz00_3219)>=((long)48)))
{ /* Llib/json.scm 42 */
BgL_test3016z00_3794 = 
(
(long)(BgL_curz00_3219)<((long)58))
; }  else 
{ /* Llib/json.scm 42 */
BgL_test3016z00_3794 = ((bool_t)0)
; } 
if(BgL_test3016z00_3794)
{ 
long BgL_forwardz00_3801;long BgL_lastzd2matchzd2_3800;
BgL_lastzd2matchzd2_3800 = BgL_newzd2matchzd2_3213; 
BgL_forwardz00_3801 = 
(((long)1)+BgL_forwardz00_3211); 
BgL_forwardz00_3211 = BgL_forwardz00_3801; 
BgL_lastzd2matchzd2_3210 = BgL_lastzd2matchzd2_3800; 
goto BgL_statezd227zd21040z00_2879;}  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_newzd2matchzd2_3213; } } } } } } }  else 
{ /* Llib/json.scm 42 */
bool_t BgL_test3018z00_3804;
if(
(
(long)(BgL_curz00_3242)==((long)43)))
{ /* Llib/json.scm 42 */
BgL_test3018z00_3804 = ((bool_t)1)
; }  else 
{ /* Llib/json.scm 42 */
BgL_test3018z00_3804 = 
(
(long)(BgL_curz00_3242)==((long)45))
; } 
if(BgL_test3018z00_3804)
{ /* Llib/json.scm 42 */
BgL_iportz00_3224 = BgL_iportz00_3234; 
BgL_lastzd2matchzd2_3225 = BgL_lastzd2matchzd2_3235; 
BgL_forwardz00_3226 = 
(((long)1)+BgL_forwardz00_3236); 
BgL_bufposz00_3227 = BgL_bufposz00_3237; 
BgL_statezd226zd21039z00_2880:
if(
(BgL_forwardz00_3226==BgL_bufposz00_3227))
{ /* Llib/json.scm 42 */
if(
rgc_fill_buffer(BgL_iportz00_3224))
{ /* Llib/json.scm 42 */
long BgL_arg1752z00_3228;long BgL_arg1753z00_3229;
{ /* Llib/json.scm 42 */
long BgL_res2522z00_3230;
BgL_res2522z00_3230 = 
RGC_BUFFER_FORWARD(BgL_iportz00_3224); 
BgL_arg1752z00_3228 = BgL_res2522z00_3230; } 
{ /* Llib/json.scm 42 */
long BgL_res2523z00_3231;
BgL_res2523z00_3231 = 
RGC_BUFFER_BUFPOS(BgL_iportz00_3224); 
BgL_arg1753z00_3229 = BgL_res2523z00_3231; } 
{ 
long BgL_bufposz00_3817;long BgL_forwardz00_3816;
BgL_forwardz00_3816 = BgL_arg1752z00_3228; 
BgL_bufposz00_3817 = BgL_arg1753z00_3229; 
BgL_bufposz00_3227 = BgL_bufposz00_3817; 
BgL_forwardz00_3226 = BgL_forwardz00_3816; 
goto BgL_statezd226zd21039z00_2880;} }  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_lastzd2matchzd2_3225; } }  else 
{ /* Llib/json.scm 42 */
int BgL_curz00_3232;
{ /* Llib/json.scm 42 */
int BgL_res2524z00_3233;
BgL_res2524z00_3233 = 
RGC_BUFFER_GET_CHAR(BgL_iportz00_3224, BgL_forwardz00_3226); 
BgL_curz00_3232 = BgL_res2524z00_3233; } 
{ /* Llib/json.scm 42 */

{ /* Llib/json.scm 42 */
bool_t BgL_test3022z00_3819;
if(
(
(long)(BgL_curz00_3232)>=((long)48)))
{ /* Llib/json.scm 42 */
BgL_test3022z00_3819 = 
(
(long)(BgL_curz00_3232)<((long)58))
; }  else 
{ /* Llib/json.scm 42 */
BgL_test3022z00_3819 = ((bool_t)0)
; } 
if(BgL_test3022z00_3819)
{ 
long BgL_bufposz00_3829;long BgL_forwardz00_3827;long BgL_lastzd2matchzd2_3826;obj_t BgL_iportz00_3825;
BgL_iportz00_3825 = BgL_iportz00_3224; 
BgL_lastzd2matchzd2_3826 = BgL_lastzd2matchzd2_3225; 
BgL_forwardz00_3827 = 
(((long)1)+BgL_forwardz00_3226); 
BgL_bufposz00_3829 = BgL_bufposz00_3227; 
BgL_bufposz00_3212 = BgL_bufposz00_3829; 
BgL_forwardz00_3211 = BgL_forwardz00_3827; 
BgL_lastzd2matchzd2_3210 = BgL_lastzd2matchzd2_3826; 
BgL_iportz00_3209 = BgL_iportz00_3825; 
goto BgL_statezd227zd21040z00_2879;}  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_lastzd2matchzd2_3225; } } } } }  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_lastzd2matchzd2_3235; } } } } } }  else 
{ /* Llib/json.scm 42 */
bool_t BgL_test3024z00_3832;
if(
(
(long)(BgL_curz00_3179)>=((long)48)))
{ /* Llib/json.scm 42 */
BgL_test3024z00_3832 = 
(
(long)(BgL_curz00_3179)<((long)58))
; }  else 
{ /* Llib/json.scm 42 */
BgL_test3024z00_3832 = ((bool_t)0)
; } 
if(BgL_test3024z00_3832)
{ 
long BgL_forwardz00_3839;long BgL_lastzd2matchzd2_3838;
BgL_lastzd2matchzd2_3838 = BgL_newzd2matchzd2_3173; 
BgL_forwardz00_3839 = 
(((long)1)+BgL_forwardz00_3171); 
BgL_forwardz00_3171 = BgL_forwardz00_3839; 
BgL_lastzd2matchzd2_3170 = BgL_lastzd2matchzd2_3838; 
goto BgL_statezd219zd21032z00_2876;}  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_newzd2matchzd2_3173; } } } } } } } }  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_newzd2matchzd2_3457; } } } } } } } }  else 
{ /* Llib/json.scm 42 */
if(
(
(long)(BgL_curz00_3328)==((long)46)))
{ 
long BgL_bufposz00_3850;long BgL_forwardz00_3848;long BgL_lastzd2matchzd2_3847;obj_t BgL_iportz00_3846;
BgL_iportz00_3846 = BgL_iportz00_3318; 
BgL_lastzd2matchzd2_3847 = BgL_newzd2matchzd2_3322; 
BgL_forwardz00_3848 = 
(((long)1)+BgL_forwardz00_3320); 
BgL_bufposz00_3850 = BgL_bufposz00_3321; 
BgL_bufposz00_3172 = BgL_bufposz00_3850; 
BgL_forwardz00_3171 = BgL_forwardz00_3848; 
BgL_lastzd2matchzd2_3170 = BgL_lastzd2matchzd2_3847; 
BgL_iportz00_3169 = BgL_iportz00_3846; 
goto BgL_statezd219zd21032z00_2876;}  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_newzd2matchzd2_3322; } } } } } } } break;case ((long)46) : 

BgL_iportz00_3354 = BgL_iportz00_3259; 
BgL_lastzd2matchzd2_3355 = BgL_lastzd2matchzd2_3260; 
BgL_forwardz00_3356 = 
(((long)1)+BgL_forwardz00_3261); 
BgL_bufposz00_3357 = BgL_bufposz00_3262; 
BgL_statezd29zd21022z00_2889:
{ /* Llib/json.scm 42 */
long BgL_newzd2matchzd2_3358;
{ /* Llib/json.scm 42 */
long BgL_res2387z00_3359;
BgL_res2387z00_3359 = 
RGC_STOP_MATCH(BgL_iportz00_3354, BgL_forwardz00_3356); BgL_res2387z00_3359; } 
BgL_newzd2matchzd2_3358 = ((long)13); 
if(
(BgL_forwardz00_3356==BgL_bufposz00_3357))
{ /* Llib/json.scm 42 */
if(
rgc_fill_buffer(BgL_iportz00_3354))
{ /* Llib/json.scm 42 */
long BgL_arg1383z00_3360;long BgL_arg1384z00_3361;
{ /* Llib/json.scm 42 */
long BgL_res2390z00_3362;
BgL_res2390z00_3362 = 
RGC_BUFFER_FORWARD(BgL_iportz00_3354); 
BgL_arg1383z00_3360 = BgL_res2390z00_3362; } 
{ /* Llib/json.scm 42 */
long BgL_res2391z00_3363;
BgL_res2391z00_3363 = 
RGC_BUFFER_BUFPOS(BgL_iportz00_3354); 
BgL_arg1384z00_3361 = BgL_res2391z00_3363; } 
{ 
long BgL_bufposz00_3860;long BgL_forwardz00_3859;
BgL_forwardz00_3859 = BgL_arg1383z00_3360; 
BgL_bufposz00_3860 = BgL_arg1384z00_3361; 
BgL_bufposz00_3357 = BgL_bufposz00_3860; 
BgL_forwardz00_3356 = BgL_forwardz00_3859; 
goto BgL_statezd29zd21022z00_2889;} }  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_newzd2matchzd2_3358; } }  else 
{ /* Llib/json.scm 42 */
int BgL_curz00_3364;
{ /* Llib/json.scm 42 */
int BgL_res2392z00_3365;
BgL_res2392z00_3365 = 
RGC_BUFFER_GET_CHAR(BgL_iportz00_3354, BgL_forwardz00_3356); 
BgL_curz00_3364 = BgL_res2392z00_3365; } 
{ /* Llib/json.scm 42 */

{ /* Llib/json.scm 42 */
bool_t BgL_test3029z00_3862;
if(
(
(long)(BgL_curz00_3364)>=((long)48)))
{ /* Llib/json.scm 42 */
BgL_test3029z00_3862 = 
(
(long)(BgL_curz00_3364)<((long)58))
; }  else 
{ /* Llib/json.scm 42 */
BgL_test3029z00_3862 = ((bool_t)0)
; } 
if(BgL_test3029z00_3862)
{ /* Llib/json.scm 42 */
BgL_iportz00_3194 = BgL_iportz00_3354; 
BgL_lastzd2matchzd2_3195 = BgL_newzd2matchzd2_3358; 
BgL_forwardz00_3196 = 
(((long)1)+BgL_forwardz00_3356); 
BgL_bufposz00_3197 = BgL_bufposz00_3357; 
BgL_statezd228zd21041z00_2878:
{ /* Llib/json.scm 42 */
long BgL_newzd2matchzd2_3198;
{ /* Llib/json.scm 42 */
long BgL_res2542z00_3199;
BgL_res2542z00_3199 = 
RGC_STOP_MATCH(BgL_iportz00_3194, BgL_forwardz00_3196); BgL_res2542z00_3199; } 
BgL_newzd2matchzd2_3198 = ((long)10); 
if(
(BgL_forwardz00_3196==BgL_bufposz00_3197))
{ /* Llib/json.scm 42 */
if(
rgc_fill_buffer(BgL_iportz00_3194))
{ /* Llib/json.scm 42 */
long BgL_arg1772z00_3200;long BgL_arg1773z00_3201;
{ /* Llib/json.scm 42 */
long BgL_res2545z00_3202;
BgL_res2545z00_3202 = 
RGC_BUFFER_FORWARD(BgL_iportz00_3194); 
BgL_arg1772z00_3200 = BgL_res2545z00_3202; } 
{ /* Llib/json.scm 42 */
long BgL_res2546z00_3203;
BgL_res2546z00_3203 = 
RGC_BUFFER_BUFPOS(BgL_iportz00_3194); 
BgL_arg1773z00_3201 = BgL_res2546z00_3203; } 
{ 
long BgL_bufposz00_3876;long BgL_forwardz00_3875;
BgL_forwardz00_3875 = BgL_arg1772z00_3200; 
BgL_bufposz00_3876 = BgL_arg1773z00_3201; 
BgL_bufposz00_3197 = BgL_bufposz00_3876; 
BgL_forwardz00_3196 = BgL_forwardz00_3875; 
goto BgL_statezd228zd21041z00_2878;} }  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_newzd2matchzd2_3198; } }  else 
{ /* Llib/json.scm 42 */
int BgL_curz00_3204;
{ /* Llib/json.scm 42 */
int BgL_res2547z00_3205;
BgL_res2547z00_3205 = 
RGC_BUFFER_GET_CHAR(BgL_iportz00_3194, BgL_forwardz00_3196); 
BgL_curz00_3204 = BgL_res2547z00_3205; } 
{ /* Llib/json.scm 42 */

{ /* Llib/json.scm 42 */
bool_t BgL_test3033z00_3878;
switch( 
(long)(BgL_curz00_3204)) { case ((long)70) : 

BgL_test3033z00_3878 = ((bool_t)1); break;case ((long)76) : 

BgL_test3033z00_3878 = ((bool_t)1); break;case ((long)102) : 

BgL_test3033z00_3878 = ((bool_t)1); break;
default: 
BgL_test3033z00_3878 = 
(
(long)(BgL_curz00_3204)==((long)108)); } 
if(BgL_test3033z00_3878)
{ /* Llib/json.scm 42 */
long BgL_arg1776z00_3206;
BgL_arg1776z00_3206 = 
(((long)1)+BgL_forwardz00_3196); 
{ /* Llib/json.scm 42 */
long BgL_newzd2matchzd2_3207;
{ /* Llib/json.scm 42 */
long BgL_res2552z00_3208;
BgL_res2552z00_3208 = 
RGC_STOP_MATCH(BgL_iportz00_3194, BgL_arg1776z00_3206); BgL_res2552z00_3208; } 
BgL_newzd2matchzd2_3207 = ((long)10); 
BgL_matchz00_2901 = BgL_newzd2matchzd2_3207; } }  else 
{ /* Llib/json.scm 42 */
bool_t BgL_test3034z00_3885;
if(
(
(long)(BgL_curz00_3204)==((long)69)))
{ /* Llib/json.scm 42 */
BgL_test3034z00_3885 = ((bool_t)1)
; }  else 
{ /* Llib/json.scm 42 */
BgL_test3034z00_3885 = 
(
(long)(BgL_curz00_3204)==((long)101))
; } 
if(BgL_test3034z00_3885)
{ 
long BgL_bufposz00_3895;long BgL_forwardz00_3893;long BgL_lastzd2matchzd2_3892;obj_t BgL_iportz00_3891;
BgL_iportz00_3891 = BgL_iportz00_3194; 
BgL_lastzd2matchzd2_3892 = BgL_newzd2matchzd2_3198; 
BgL_forwardz00_3893 = 
(((long)1)+BgL_forwardz00_3196); 
BgL_bufposz00_3895 = BgL_bufposz00_3197; 
BgL_bufposz00_3237 = BgL_bufposz00_3895; 
BgL_forwardz00_3236 = BgL_forwardz00_3893; 
BgL_lastzd2matchzd2_3235 = BgL_lastzd2matchzd2_3892; 
BgL_iportz00_3234 = BgL_iportz00_3891; 
goto BgL_statezd225zd21038z00_2881;}  else 
{ /* Llib/json.scm 42 */
bool_t BgL_test3036z00_3896;
if(
(
(long)(BgL_curz00_3204)>=((long)48)))
{ /* Llib/json.scm 42 */
BgL_test3036z00_3896 = 
(
(long)(BgL_curz00_3204)<((long)58))
; }  else 
{ /* Llib/json.scm 42 */
BgL_test3036z00_3896 = ((bool_t)0)
; } 
if(BgL_test3036z00_3896)
{ 
long BgL_forwardz00_3903;long BgL_lastzd2matchzd2_3902;
BgL_lastzd2matchzd2_3902 = BgL_newzd2matchzd2_3198; 
BgL_forwardz00_3903 = 
(((long)1)+BgL_forwardz00_3196); 
BgL_forwardz00_3196 = BgL_forwardz00_3903; 
BgL_lastzd2matchzd2_3195 = BgL_lastzd2matchzd2_3902; 
goto BgL_statezd228zd21041z00_2878;}  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_newzd2matchzd2_3198; } } } } } } } }  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_newzd2matchzd2_3358; } } } } } break;case ((long)45) : 

BgL_iportz00_3330 = BgL_iportz00_3259; 
BgL_lastzd2matchzd2_3331 = BgL_lastzd2matchzd2_3260; 
BgL_forwardz00_3332 = 
(((long)1)+BgL_forwardz00_3261); 
BgL_bufposz00_3333 = BgL_bufposz00_3262; 
BgL_statezd28zd21021z00_2887:
{ /* Llib/json.scm 42 */
long BgL_newzd2matchzd2_3334;
{ /* Llib/json.scm 42 */
long BgL_res2416z00_3335;
BgL_res2416z00_3335 = 
RGC_STOP_MATCH(BgL_iportz00_3330, BgL_forwardz00_3332); BgL_res2416z00_3335; } 
BgL_newzd2matchzd2_3334 = ((long)13); 
if(
(BgL_forwardz00_3332==BgL_bufposz00_3333))
{ /* Llib/json.scm 42 */
if(
rgc_fill_buffer(BgL_iportz00_3330))
{ /* Llib/json.scm 42 */
long BgL_arg1537z00_3336;long BgL_arg1545z00_3337;
{ /* Llib/json.scm 42 */
long BgL_res2419z00_3338;
BgL_res2419z00_3338 = 
RGC_BUFFER_FORWARD(BgL_iportz00_3330); 
BgL_arg1537z00_3336 = BgL_res2419z00_3338; } 
{ /* Llib/json.scm 42 */
long BgL_res2420z00_3339;
BgL_res2420z00_3339 = 
RGC_BUFFER_BUFPOS(BgL_iportz00_3330); 
BgL_arg1545z00_3337 = BgL_res2420z00_3339; } 
{ 
long BgL_bufposz00_3915;long BgL_forwardz00_3914;
BgL_forwardz00_3914 = BgL_arg1537z00_3336; 
BgL_bufposz00_3915 = BgL_arg1545z00_3337; 
BgL_bufposz00_3333 = BgL_bufposz00_3915; 
BgL_forwardz00_3332 = BgL_forwardz00_3914; 
goto BgL_statezd28zd21021z00_2887;} }  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_newzd2matchzd2_3334; } }  else 
{ /* Llib/json.scm 42 */
int BgL_curz00_3340;
{ /* Llib/json.scm 42 */
int BgL_res2421z00_3341;
BgL_res2421z00_3341 = 
RGC_BUFFER_GET_CHAR(BgL_iportz00_3330, BgL_forwardz00_3332); 
BgL_curz00_3340 = BgL_res2421z00_3341; } 
{ /* Llib/json.scm 42 */

{ /* Llib/json.scm 42 */
bool_t BgL_test3040z00_3917;
if(
(
(long)(BgL_curz00_3340)>=((long)48)))
{ /* Llib/json.scm 42 */
BgL_test3040z00_3917 = 
(
(long)(BgL_curz00_3340)<((long)58))
; }  else 
{ /* Llib/json.scm 42 */
BgL_test3040z00_3917 = ((bool_t)0)
; } 
if(BgL_test3040z00_3917)
{ 
long BgL_bufposz00_3927;long BgL_forwardz00_3925;long BgL_lastzd2matchzd2_3924;obj_t BgL_iportz00_3923;
BgL_iportz00_3923 = BgL_iportz00_3330; 
BgL_lastzd2matchzd2_3924 = BgL_newzd2matchzd2_3334; 
BgL_forwardz00_3925 = 
(((long)1)+BgL_forwardz00_3332); 
BgL_bufposz00_3927 = BgL_bufposz00_3333; 
BgL_bufposz00_3456 = BgL_bufposz00_3927; 
BgL_forwardz00_3455 = BgL_forwardz00_3925; 
BgL_lastzd2matchzd2_3454 = BgL_lastzd2matchzd2_3924; 
BgL_iportz00_3453 = BgL_iportz00_3923; 
goto BgL_statezd220zd21033z00_2898;}  else 
{ /* Llib/json.scm 42 */
if(
(
(long)(BgL_curz00_3340)==((long)46)))
{ /* Llib/json.scm 42 */
BgL_iportz00_3184 = BgL_iportz00_3330; 
BgL_lastzd2matchzd2_3185 = BgL_newzd2matchzd2_3334; 
BgL_forwardz00_3186 = 
(((long)1)+BgL_forwardz00_3332); 
BgL_bufposz00_3187 = BgL_bufposz00_3333; 
BgL_statezd229zd21042z00_2877:
if(
(BgL_forwardz00_3186==BgL_bufposz00_3187))
{ /* Llib/json.scm 42 */
if(
rgc_fill_buffer(BgL_iportz00_3184))
{ /* Llib/json.scm 42 */
long BgL_arg1786z00_3188;long BgL_arg1787z00_3189;
{ /* Llib/json.scm 42 */
long BgL_res2561z00_3190;
BgL_res2561z00_3190 = 
RGC_BUFFER_FORWARD(BgL_iportz00_3184); 
BgL_arg1786z00_3188 = BgL_res2561z00_3190; } 
{ /* Llib/json.scm 42 */
long BgL_res2562z00_3191;
BgL_res2562z00_3191 = 
RGC_BUFFER_BUFPOS(BgL_iportz00_3184); 
BgL_arg1787z00_3189 = BgL_res2562z00_3191; } 
{ 
long BgL_bufposz00_3938;long BgL_forwardz00_3937;
BgL_forwardz00_3937 = BgL_arg1786z00_3188; 
BgL_bufposz00_3938 = BgL_arg1787z00_3189; 
BgL_bufposz00_3187 = BgL_bufposz00_3938; 
BgL_forwardz00_3186 = BgL_forwardz00_3937; 
goto BgL_statezd229zd21042z00_2877;} }  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_lastzd2matchzd2_3185; } }  else 
{ /* Llib/json.scm 42 */
int BgL_curz00_3192;
{ /* Llib/json.scm 42 */
int BgL_res2563z00_3193;
BgL_res2563z00_3193 = 
RGC_BUFFER_GET_CHAR(BgL_iportz00_3184, BgL_forwardz00_3186); 
BgL_curz00_3192 = BgL_res2563z00_3193; } 
{ /* Llib/json.scm 42 */

{ /* Llib/json.scm 42 */
bool_t BgL_test3045z00_3940;
if(
(
(long)(BgL_curz00_3192)>=((long)48)))
{ /* Llib/json.scm 42 */
BgL_test3045z00_3940 = 
(
(long)(BgL_curz00_3192)<((long)58))
; }  else 
{ /* Llib/json.scm 42 */
BgL_test3045z00_3940 = ((bool_t)0)
; } 
if(BgL_test3045z00_3940)
{ 
long BgL_bufposz00_3950;long BgL_forwardz00_3948;long BgL_lastzd2matchzd2_3947;obj_t BgL_iportz00_3946;
BgL_iportz00_3946 = BgL_iportz00_3184; 
BgL_lastzd2matchzd2_3947 = BgL_lastzd2matchzd2_3185; 
BgL_forwardz00_3948 = 
(((long)1)+BgL_forwardz00_3186); 
BgL_bufposz00_3950 = BgL_bufposz00_3187; 
BgL_bufposz00_3197 = BgL_bufposz00_3950; 
BgL_forwardz00_3196 = BgL_forwardz00_3948; 
BgL_lastzd2matchzd2_3195 = BgL_lastzd2matchzd2_3947; 
BgL_iportz00_3194 = BgL_iportz00_3946; 
goto BgL_statezd228zd21041z00_2878;}  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_lastzd2matchzd2_3185; } } } } }  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_newzd2matchzd2_3334; } } } } } } break;case ((long)44) : 

{ /* Llib/json.scm 42 */
long BgL_arg1680z00_3284;
BgL_arg1680z00_3284 = 
(((long)1)+BgL_forwardz00_3261); 
{ /* Llib/json.scm 42 */
long BgL_newzd2matchzd2_3285;
{ /* Llib/json.scm 42 */
long BgL_res2483z00_3286;
BgL_res2483z00_3286 = 
RGC_STOP_MATCH(BgL_iportz00_3259, BgL_arg1680z00_3284); BgL_res2483z00_3286; } 
BgL_newzd2matchzd2_3285 = ((long)1); 
BgL_matchz00_2901 = BgL_newzd2matchzd2_3285; } } break;case ((long)43) : 

BgL_iportz00_3366 = BgL_iportz00_3259; 
BgL_lastzd2matchzd2_3367 = BgL_lastzd2matchzd2_3260; 
BgL_forwardz00_3368 = 
(((long)1)+BgL_forwardz00_3261); 
BgL_bufposz00_3369 = BgL_bufposz00_3262; 
BgL_statezd26zd21019z00_2890:
{ /* Llib/json.scm 42 */
long BgL_newzd2matchzd2_3370;
{ /* Llib/json.scm 42 */
long BgL_res2378z00_3371;
BgL_res2378z00_3371 = 
RGC_STOP_MATCH(BgL_iportz00_3366, BgL_forwardz00_3368); BgL_res2378z00_3371; } 
BgL_newzd2matchzd2_3370 = ((long)13); 
if(
(BgL_forwardz00_3368==BgL_bufposz00_3369))
{ /* Llib/json.scm 42 */
if(
rgc_fill_buffer(BgL_iportz00_3366))
{ /* Llib/json.scm 42 */
long BgL_arg1330z00_3372;long BgL_arg1333z00_3373;
{ /* Llib/json.scm 42 */
long BgL_res2381z00_3374;
BgL_res2381z00_3374 = 
RGC_BUFFER_FORWARD(BgL_iportz00_3366); 
BgL_arg1330z00_3372 = BgL_res2381z00_3374; } 
{ /* Llib/json.scm 42 */
long BgL_res2382z00_3375;
BgL_res2382z00_3375 = 
RGC_BUFFER_BUFPOS(BgL_iportz00_3366); 
BgL_arg1333z00_3373 = BgL_res2382z00_3375; } 
{ 
long BgL_bufposz00_3963;long BgL_forwardz00_3962;
BgL_forwardz00_3962 = BgL_arg1330z00_3372; 
BgL_bufposz00_3963 = BgL_arg1333z00_3373; 
BgL_bufposz00_3369 = BgL_bufposz00_3963; 
BgL_forwardz00_3368 = BgL_forwardz00_3962; 
goto BgL_statezd26zd21019z00_2890;} }  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_newzd2matchzd2_3370; } }  else 
{ /* Llib/json.scm 42 */
int BgL_curz00_3376;
{ /* Llib/json.scm 42 */
int BgL_res2383z00_3377;
BgL_res2383z00_3377 = 
RGC_BUFFER_GET_CHAR(BgL_iportz00_3366, BgL_forwardz00_3368); 
BgL_curz00_3376 = BgL_res2383z00_3377; } 
{ /* Llib/json.scm 42 */

{ /* Llib/json.scm 42 */
bool_t BgL_test3049z00_3965;
if(
(
(long)(BgL_curz00_3376)>=((long)48)))
{ /* Llib/json.scm 42 */
BgL_test3049z00_3965 = 
(
(long)(BgL_curz00_3376)<((long)58))
; }  else 
{ /* Llib/json.scm 42 */
BgL_test3049z00_3965 = ((bool_t)0)
; } 
if(BgL_test3049z00_3965)
{ /* Llib/json.scm 42 */
BgL_iportz00_3130 = BgL_iportz00_3366; 
BgL_lastzd2matchzd2_3131 = BgL_newzd2matchzd2_3370; 
BgL_forwardz00_3132 = 
(((long)1)+BgL_forwardz00_3368); 
BgL_bufposz00_3133 = BgL_bufposz00_3369; 
BgL_statezd230zd21043z00_2873:
{ /* Llib/json.scm 42 */
long BgL_newzd2matchzd2_3134;
{ /* Llib/json.scm 42 */
long BgL_res2609z00_3135;
BgL_res2609z00_3135 = 
RGC_STOP_MATCH(BgL_iportz00_3130, BgL_forwardz00_3132); BgL_res2609z00_3135; } 
BgL_newzd2matchzd2_3134 = ((long)9); 
if(
(BgL_forwardz00_3132==BgL_bufposz00_3133))
{ /* Llib/json.scm 42 */
if(
rgc_fill_buffer(BgL_iportz00_3130))
{ /* Llib/json.scm 42 */
long BgL_arg1829z00_3136;long BgL_arg1830z00_3137;
{ /* Llib/json.scm 42 */
long BgL_res2612z00_3138;
BgL_res2612z00_3138 = 
RGC_BUFFER_FORWARD(BgL_iportz00_3130); 
BgL_arg1829z00_3136 = BgL_res2612z00_3138; } 
{ /* Llib/json.scm 42 */
long BgL_res2613z00_3139;
BgL_res2613z00_3139 = 
RGC_BUFFER_BUFPOS(BgL_iportz00_3130); 
BgL_arg1830z00_3137 = BgL_res2613z00_3139; } 
{ 
long BgL_bufposz00_3979;long BgL_forwardz00_3978;
BgL_forwardz00_3978 = BgL_arg1829z00_3136; 
BgL_bufposz00_3979 = BgL_arg1830z00_3137; 
BgL_bufposz00_3133 = BgL_bufposz00_3979; 
BgL_forwardz00_3132 = BgL_forwardz00_3978; 
goto BgL_statezd230zd21043z00_2873;} }  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_newzd2matchzd2_3134; } }  else 
{ /* Llib/json.scm 42 */
int BgL_curz00_3140;
{ /* Llib/json.scm 42 */
int BgL_res2614z00_3141;
BgL_res2614z00_3141 = 
RGC_BUFFER_GET_CHAR(BgL_iportz00_3130, BgL_forwardz00_3132); 
BgL_curz00_3140 = BgL_res2614z00_3141; } 
{ /* Llib/json.scm 42 */

{ /* Llib/json.scm 42 */
bool_t BgL_test3053z00_3981;
if(
(
(long)(BgL_curz00_3140)>=((long)48)))
{ /* Llib/json.scm 42 */
BgL_test3053z00_3981 = 
(
(long)(BgL_curz00_3140)<((long)58))
; }  else 
{ /* Llib/json.scm 42 */
BgL_test3053z00_3981 = ((bool_t)0)
; } 
if(BgL_test3053z00_3981)
{ 
long BgL_forwardz00_3988;long BgL_lastzd2matchzd2_3987;
BgL_lastzd2matchzd2_3987 = BgL_newzd2matchzd2_3134; 
BgL_forwardz00_3988 = 
(((long)1)+BgL_forwardz00_3132); 
BgL_forwardz00_3132 = BgL_forwardz00_3988; 
BgL_lastzd2matchzd2_3131 = BgL_lastzd2matchzd2_3987; 
goto BgL_statezd230zd21043z00_2873;}  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_newzd2matchzd2_3134; } } } } } }  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_newzd2matchzd2_3370; } } } } } break;case ((long)41) : 

{ /* Llib/json.scm 42 */
long BgL_arg1682z00_3287;
BgL_arg1682z00_3287 = 
(((long)1)+BgL_forwardz00_3261); 
{ /* Llib/json.scm 42 */
long BgL_newzd2matchzd2_3288;
{ /* Llib/json.scm 42 */
long BgL_res2486z00_3289;
BgL_res2486z00_3289 = 
RGC_STOP_MATCH(BgL_iportz00_3259, BgL_arg1682z00_3287); BgL_res2486z00_3289; } 
BgL_newzd2matchzd2_3288 = ((long)6); 
BgL_matchz00_2901 = BgL_newzd2matchzd2_3288; } } break;case ((long)40) : 

{ /* Llib/json.scm 42 */
long BgL_arg1683z00_3290;
BgL_arg1683z00_3290 = 
(((long)1)+BgL_forwardz00_3261); 
{ /* Llib/json.scm 42 */
long BgL_newzd2matchzd2_3291;
{ /* Llib/json.scm 42 */
long BgL_res2488z00_3292;
BgL_res2488z00_3292 = 
RGC_STOP_MATCH(BgL_iportz00_3259, BgL_arg1683z00_3290); BgL_res2488z00_3292; } 
BgL_newzd2matchzd2_3291 = ((long)5); 
BgL_matchz00_2901 = BgL_newzd2matchzd2_3291; } } break;case ((long)34) : 

BgL_iportz00_3244 = BgL_iportz00_3259; 
BgL_lastzd2matchzd2_3245 = BgL_lastzd2matchzd2_3260; 
BgL_forwardz00_3246 = 
(((long)1)+BgL_forwardz00_3261); 
BgL_bufposz00_3247 = BgL_bufposz00_3262; 
BgL_statezd23zd21016z00_2882:
{ /* Llib/json.scm 42 */
long BgL_newzd2matchzd2_3248;
{ /* Llib/json.scm 42 */
long BgL_res2493z00_3249;
BgL_res2493z00_3249 = 
RGC_STOP_MATCH(BgL_iportz00_3244, BgL_forwardz00_3246); BgL_res2493z00_3249; } 
BgL_newzd2matchzd2_3248 = ((long)13); 
if(
(BgL_forwardz00_3246==BgL_bufposz00_3247))
{ /* Llib/json.scm 42 */
if(
rgc_fill_buffer(BgL_iportz00_3244))
{ /* Llib/json.scm 42 */
long BgL_arg1693z00_3250;long BgL_arg1694z00_3251;
{ /* Llib/json.scm 42 */
long BgL_res2496z00_3252;
BgL_res2496z00_3252 = 
RGC_BUFFER_FORWARD(BgL_iportz00_3244); 
BgL_arg1693z00_3250 = BgL_res2496z00_3252; } 
{ /* Llib/json.scm 42 */
long BgL_res2497z00_3253;
BgL_res2497z00_3253 = 
RGC_BUFFER_BUFPOS(BgL_iportz00_3244); 
BgL_arg1694z00_3251 = BgL_res2497z00_3253; } 
{ 
long BgL_bufposz00_4004;long BgL_forwardz00_4003;
BgL_forwardz00_4003 = BgL_arg1693z00_3250; 
BgL_bufposz00_4004 = BgL_arg1694z00_3251; 
BgL_bufposz00_3247 = BgL_bufposz00_4004; 
BgL_forwardz00_3246 = BgL_forwardz00_4003; 
goto BgL_statezd23zd21016z00_2882;} }  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_newzd2matchzd2_3248; } }  else 
{ /* Llib/json.scm 42 */
int BgL_curz00_3254;
{ /* Llib/json.scm 42 */
int BgL_res2498z00_3255;
BgL_res2498z00_3255 = 
RGC_BUFFER_GET_CHAR(BgL_iportz00_3244, BgL_forwardz00_3246); 
BgL_curz00_3254 = BgL_res2498z00_3255; } 
{ /* Llib/json.scm 42 */

if(
(
(long)(BgL_curz00_3254)==((long)92)))
{ /* Llib/json.scm 42 */
BgL_iportz00_3443 = BgL_iportz00_3244; 
BgL_lastzd2matchzd2_3444 = BgL_newzd2matchzd2_3248; 
BgL_forwardz00_3445 = 
(((long)1)+BgL_forwardz00_3246); 
BgL_bufposz00_3446 = BgL_bufposz00_3247; 
BgL_statezd233zd21046z00_2897:
if(
(BgL_forwardz00_3445==BgL_bufposz00_3446))
{ /* Llib/json.scm 42 */
if(
rgc_fill_buffer(BgL_iportz00_3443))
{ /* Llib/json.scm 42 */
long BgL_arg1142z00_3447;long BgL_arg1143z00_3448;
{ /* Llib/json.scm 42 */
long BgL_res2293z00_3449;
BgL_res2293z00_3449 = 
RGC_BUFFER_FORWARD(BgL_iportz00_3443); 
BgL_arg1142z00_3447 = BgL_res2293z00_3449; } 
{ /* Llib/json.scm 42 */
long BgL_res2294z00_3450;
BgL_res2294z00_3450 = 
RGC_BUFFER_BUFPOS(BgL_iportz00_3443); 
BgL_arg1143z00_3448 = BgL_res2294z00_3450; } 
{ 
long BgL_bufposz00_4016;long BgL_forwardz00_4015;
BgL_forwardz00_4015 = BgL_arg1142z00_3447; 
BgL_bufposz00_4016 = BgL_arg1143z00_3448; 
BgL_bufposz00_3446 = BgL_bufposz00_4016; 
BgL_forwardz00_3445 = BgL_forwardz00_4015; 
goto BgL_statezd233zd21046z00_2897;} }  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_lastzd2matchzd2_3444; } }  else 
{ /* Llib/json.scm 42 */
int BgL_curz00_3451;
{ /* Llib/json.scm 42 */
int BgL_res2295z00_3452;
BgL_res2295z00_3452 = 
RGC_BUFFER_GET_CHAR(BgL_iportz00_3443, BgL_forwardz00_3445); 
BgL_curz00_3451 = BgL_res2295z00_3452; } 
{ /* Llib/json.scm 42 */

if(
(
(long)(BgL_curz00_3451)==((long)117)))
{ /* Llib/json.scm 42 */
BgL_iportz00_3423 = BgL_iportz00_3443; 
BgL_lastzd2matchzd2_3424 = BgL_lastzd2matchzd2_3444; 
BgL_forwardz00_3425 = 
(((long)1)+BgL_forwardz00_3445); 
BgL_bufposz00_3426 = BgL_bufposz00_3446; 
BgL_statezd234zd21047z00_2895:
if(
(BgL_forwardz00_3425==BgL_bufposz00_3426))
{ /* Llib/json.scm 42 */
if(
rgc_fill_buffer(BgL_iportz00_3423))
{ /* Llib/json.scm 42 */
long BgL_arg1165z00_3427;long BgL_arg1166z00_3428;
{ /* Llib/json.scm 42 */
long BgL_res2317z00_3429;
BgL_res2317z00_3429 = 
RGC_BUFFER_FORWARD(BgL_iportz00_3423); 
BgL_arg1165z00_3427 = BgL_res2317z00_3429; } 
{ /* Llib/json.scm 42 */
long BgL_res2318z00_3430;
BgL_res2318z00_3430 = 
RGC_BUFFER_BUFPOS(BgL_iportz00_3423); 
BgL_arg1166z00_3428 = BgL_res2318z00_3430; } 
{ 
long BgL_bufposz00_4028;long BgL_forwardz00_4027;
BgL_forwardz00_4027 = BgL_arg1165z00_3427; 
BgL_bufposz00_4028 = BgL_arg1166z00_3428; 
BgL_bufposz00_3426 = BgL_bufposz00_4028; 
BgL_forwardz00_3425 = BgL_forwardz00_4027; 
goto BgL_statezd234zd21047z00_2895;} }  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_lastzd2matchzd2_3424; } }  else 
{ /* Llib/json.scm 42 */
int BgL_curz00_3431;
{ /* Llib/json.scm 42 */
int BgL_res2319z00_3432;
BgL_res2319z00_3432 = 
RGC_BUFFER_GET_CHAR(BgL_iportz00_3423, BgL_forwardz00_3425); 
BgL_curz00_3431 = BgL_res2319z00_3432; } 
{ /* Llib/json.scm 42 */

{ /* Llib/json.scm 42 */
bool_t BgL_test3063z00_4030;
{ /* Llib/json.scm 42 */
bool_t BgL_test3064z00_4031;
if(
(
(long)(BgL_curz00_3431)>=((long)48)))
{ /* Llib/json.scm 42 */
BgL_test3064z00_4031 = 
(
(long)(BgL_curz00_3431)<((long)58))
; }  else 
{ /* Llib/json.scm 42 */
BgL_test3064z00_4031 = ((bool_t)0)
; } 
if(BgL_test3064z00_4031)
{ /* Llib/json.scm 42 */
BgL_test3063z00_4030 = ((bool_t)1)
; }  else 
{ /* Llib/json.scm 42 */
bool_t BgL_test3066z00_4037;
if(
(
(long)(BgL_curz00_3431)>=((long)65)))
{ /* Llib/json.scm 42 */
BgL_test3066z00_4037 = 
(
(long)(BgL_curz00_3431)<((long)71))
; }  else 
{ /* Llib/json.scm 42 */
BgL_test3066z00_4037 = ((bool_t)0)
; } 
if(BgL_test3066z00_4037)
{ /* Llib/json.scm 42 */
BgL_test3063z00_4030 = ((bool_t)1)
; }  else 
{ /* Llib/json.scm 42 */
if(
(
(long)(BgL_curz00_3431)>=((long)97)))
{ /* Llib/json.scm 42 */
BgL_test3063z00_4030 = 
(
(long)(BgL_curz00_3431)<((long)103))
; }  else 
{ /* Llib/json.scm 42 */
BgL_test3063z00_4030 = ((bool_t)0)
; } } } } 
if(BgL_test3063z00_4030)
{ /* Llib/json.scm 42 */
BgL_iportz00_3465 = BgL_iportz00_3423; 
BgL_lastzd2matchzd2_3466 = BgL_lastzd2matchzd2_3424; 
BgL_forwardz00_3467 = 
(((long)1)+BgL_forwardz00_3425); 
BgL_bufposz00_3468 = BgL_bufposz00_3426; 
BgL_statezd235zd21048z00_2899:
if(
(BgL_forwardz00_3467==BgL_bufposz00_3468))
{ /* Llib/json.scm 42 */
if(
rgc_fill_buffer(BgL_iportz00_3465))
{ /* Llib/json.scm 42 */
long BgL_arg1103z00_3469;long BgL_arg1104z00_3470;
{ /* Llib/json.scm 42 */
long BgL_res2267z00_3471;
BgL_res2267z00_3471 = 
RGC_BUFFER_FORWARD(BgL_iportz00_3465); 
BgL_arg1103z00_3469 = BgL_res2267z00_3471; } 
{ /* Llib/json.scm 42 */
long BgL_res2268z00_3472;
BgL_res2268z00_3472 = 
RGC_BUFFER_BUFPOS(BgL_iportz00_3465); 
BgL_arg1104z00_3470 = BgL_res2268z00_3472; } 
{ 
long BgL_bufposz00_4055;long BgL_forwardz00_4054;
BgL_forwardz00_4054 = BgL_arg1103z00_3469; 
BgL_bufposz00_4055 = BgL_arg1104z00_3470; 
BgL_bufposz00_3468 = BgL_bufposz00_4055; 
BgL_forwardz00_3467 = BgL_forwardz00_4054; 
goto BgL_statezd235zd21048z00_2899;} }  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_lastzd2matchzd2_3466; } }  else 
{ /* Llib/json.scm 42 */
int BgL_curz00_3473;
{ /* Llib/json.scm 42 */
int BgL_res2269z00_3474;
BgL_res2269z00_3474 = 
RGC_BUFFER_GET_CHAR(BgL_iportz00_3465, BgL_forwardz00_3467); 
BgL_curz00_3473 = BgL_res2269z00_3474; } 
{ /* Llib/json.scm 42 */

{ /* Llib/json.scm 42 */
bool_t BgL_test3071z00_4057;
{ /* Llib/json.scm 42 */
bool_t BgL_test3072z00_4058;
if(
(
(long)(BgL_curz00_3473)>=((long)48)))
{ /* Llib/json.scm 42 */
BgL_test3072z00_4058 = 
(
(long)(BgL_curz00_3473)<((long)58))
; }  else 
{ /* Llib/json.scm 42 */
BgL_test3072z00_4058 = ((bool_t)0)
; } 
if(BgL_test3072z00_4058)
{ /* Llib/json.scm 42 */
BgL_test3071z00_4057 = ((bool_t)1)
; }  else 
{ /* Llib/json.scm 42 */
bool_t BgL_test3074z00_4064;
if(
(
(long)(BgL_curz00_3473)>=((long)65)))
{ /* Llib/json.scm 42 */
BgL_test3074z00_4064 = 
(
(long)(BgL_curz00_3473)<((long)71))
; }  else 
{ /* Llib/json.scm 42 */
BgL_test3074z00_4064 = ((bool_t)0)
; } 
if(BgL_test3074z00_4064)
{ /* Llib/json.scm 42 */
BgL_test3071z00_4057 = ((bool_t)1)
; }  else 
{ /* Llib/json.scm 42 */
if(
(
(long)(BgL_curz00_3473)>=((long)97)))
{ /* Llib/json.scm 42 */
BgL_test3071z00_4057 = 
(
(long)(BgL_curz00_3473)<((long)103))
; }  else 
{ /* Llib/json.scm 42 */
BgL_test3071z00_4057 = ((bool_t)0)
; } } } } 
if(BgL_test3071z00_4057)
{ /* Llib/json.scm 42 */
BgL_iportz00_3413 = BgL_iportz00_3465; 
BgL_lastzd2matchzd2_3414 = BgL_lastzd2matchzd2_3466; 
BgL_forwardz00_3415 = 
(((long)1)+BgL_forwardz00_3467); 
BgL_bufposz00_3416 = BgL_bufposz00_3468; 
BgL_statezd236zd21049z00_2894:
if(
(BgL_forwardz00_3415==BgL_bufposz00_3416))
{ /* Llib/json.scm 42 */
if(
rgc_fill_buffer(BgL_iportz00_3413))
{ /* Llib/json.scm 42 */
long BgL_arg1179z00_3417;long BgL_arg1182z00_3418;
{ /* Llib/json.scm 42 */
long BgL_res2329z00_3419;
BgL_res2329z00_3419 = 
RGC_BUFFER_FORWARD(BgL_iportz00_3413); 
BgL_arg1179z00_3417 = BgL_res2329z00_3419; } 
{ /* Llib/json.scm 42 */
long BgL_res2330z00_3420;
BgL_res2330z00_3420 = 
RGC_BUFFER_BUFPOS(BgL_iportz00_3413); 
BgL_arg1182z00_3418 = BgL_res2330z00_3420; } 
{ 
long BgL_bufposz00_4082;long BgL_forwardz00_4081;
BgL_forwardz00_4081 = BgL_arg1179z00_3417; 
BgL_bufposz00_4082 = BgL_arg1182z00_3418; 
BgL_bufposz00_3416 = BgL_bufposz00_4082; 
BgL_forwardz00_3415 = BgL_forwardz00_4081; 
goto BgL_statezd236zd21049z00_2894;} }  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_lastzd2matchzd2_3414; } }  else 
{ /* Llib/json.scm 42 */
int BgL_curz00_3421;
{ /* Llib/json.scm 42 */
int BgL_res2331z00_3422;
BgL_res2331z00_3422 = 
RGC_BUFFER_GET_CHAR(BgL_iportz00_3413, BgL_forwardz00_3415); 
BgL_curz00_3421 = BgL_res2331z00_3422; } 
{ /* Llib/json.scm 42 */

{ /* Llib/json.scm 42 */
bool_t BgL_test3079z00_4084;
{ /* Llib/json.scm 42 */
bool_t BgL_test3080z00_4085;
if(
(
(long)(BgL_curz00_3421)>=((long)48)))
{ /* Llib/json.scm 42 */
BgL_test3080z00_4085 = 
(
(long)(BgL_curz00_3421)<((long)58))
; }  else 
{ /* Llib/json.scm 42 */
BgL_test3080z00_4085 = ((bool_t)0)
; } 
if(BgL_test3080z00_4085)
{ /* Llib/json.scm 42 */
BgL_test3079z00_4084 = ((bool_t)1)
; }  else 
{ /* Llib/json.scm 42 */
bool_t BgL_test3082z00_4091;
if(
(
(long)(BgL_curz00_3421)>=((long)65)))
{ /* Llib/json.scm 42 */
BgL_test3082z00_4091 = 
(
(long)(BgL_curz00_3421)<((long)71))
; }  else 
{ /* Llib/json.scm 42 */
BgL_test3082z00_4091 = ((bool_t)0)
; } 
if(BgL_test3082z00_4091)
{ /* Llib/json.scm 42 */
BgL_test3079z00_4084 = ((bool_t)1)
; }  else 
{ /* Llib/json.scm 42 */
if(
(
(long)(BgL_curz00_3421)>=((long)97)))
{ /* Llib/json.scm 42 */
BgL_test3079z00_4084 = 
(
(long)(BgL_curz00_3421)<((long)103))
; }  else 
{ /* Llib/json.scm 42 */
BgL_test3079z00_4084 = ((bool_t)0)
; } } } } 
if(BgL_test3079z00_4084)
{ /* Llib/json.scm 42 */
BgL_iportz00_3433 = BgL_iportz00_3413; 
BgL_lastzd2matchzd2_3434 = BgL_lastzd2matchzd2_3414; 
BgL_forwardz00_3435 = 
(((long)1)+BgL_forwardz00_3415); 
BgL_bufposz00_3436 = BgL_bufposz00_3416; 
BgL_statezd237zd21050z00_2896:
if(
(BgL_forwardz00_3435==BgL_bufposz00_3436))
{ /* Llib/json.scm 42 */
if(
rgc_fill_buffer(BgL_iportz00_3433))
{ /* Llib/json.scm 42 */
long BgL_arg1153z00_3437;long BgL_arg1154z00_3438;
{ /* Llib/json.scm 42 */
long BgL_res2305z00_3439;
BgL_res2305z00_3439 = 
RGC_BUFFER_FORWARD(BgL_iportz00_3433); 
BgL_arg1153z00_3437 = BgL_res2305z00_3439; } 
{ /* Llib/json.scm 42 */
long BgL_res2306z00_3440;
BgL_res2306z00_3440 = 
RGC_BUFFER_BUFPOS(BgL_iportz00_3433); 
BgL_arg1154z00_3438 = BgL_res2306z00_3440; } 
{ 
long BgL_bufposz00_4109;long BgL_forwardz00_4108;
BgL_forwardz00_4108 = BgL_arg1153z00_3437; 
BgL_bufposz00_4109 = BgL_arg1154z00_3438; 
BgL_bufposz00_3436 = BgL_bufposz00_4109; 
BgL_forwardz00_3435 = BgL_forwardz00_4108; 
goto BgL_statezd237zd21050z00_2896;} }  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_lastzd2matchzd2_3434; } }  else 
{ /* Llib/json.scm 42 */
int BgL_curz00_3441;
{ /* Llib/json.scm 42 */
int BgL_res2307z00_3442;
BgL_res2307z00_3442 = 
RGC_BUFFER_GET_CHAR(BgL_iportz00_3433, BgL_forwardz00_3435); 
BgL_curz00_3441 = BgL_res2307z00_3442; } 
{ /* Llib/json.scm 42 */

{ /* Llib/json.scm 42 */
bool_t BgL_test3087z00_4111;
{ /* Llib/json.scm 42 */
bool_t BgL_test3088z00_4112;
if(
(
(long)(BgL_curz00_3441)>=((long)48)))
{ /* Llib/json.scm 42 */
BgL_test3088z00_4112 = 
(
(long)(BgL_curz00_3441)<((long)58))
; }  else 
{ /* Llib/json.scm 42 */
BgL_test3088z00_4112 = ((bool_t)0)
; } 
if(BgL_test3088z00_4112)
{ /* Llib/json.scm 42 */
BgL_test3087z00_4111 = ((bool_t)1)
; }  else 
{ /* Llib/json.scm 42 */
bool_t BgL_test3090z00_4118;
if(
(
(long)(BgL_curz00_3441)>=((long)65)))
{ /* Llib/json.scm 42 */
BgL_test3090z00_4118 = 
(
(long)(BgL_curz00_3441)<((long)71))
; }  else 
{ /* Llib/json.scm 42 */
BgL_test3090z00_4118 = ((bool_t)0)
; } 
if(BgL_test3090z00_4118)
{ /* Llib/json.scm 42 */
BgL_test3087z00_4111 = ((bool_t)1)
; }  else 
{ /* Llib/json.scm 42 */
if(
(
(long)(BgL_curz00_3441)>=((long)97)))
{ /* Llib/json.scm 42 */
BgL_test3087z00_4111 = 
(
(long)(BgL_curz00_3441)<((long)103))
; }  else 
{ /* Llib/json.scm 42 */
BgL_test3087z00_4111 = ((bool_t)0)
; } } } } 
if(BgL_test3087z00_4111)
{ /* Llib/json.scm 42 */
BgL_iportz00_3378 = BgL_iportz00_3433; 
BgL_lastzd2matchzd2_3379 = BgL_lastzd2matchzd2_3434; 
BgL_forwardz00_3380 = 
(((long)1)+BgL_forwardz00_3435); 
BgL_bufposz00_3381 = BgL_bufposz00_3436; 
BgL_statezd231zd21044z00_2891:
if(
(BgL_forwardz00_3380==BgL_bufposz00_3381))
{ /* Llib/json.scm 42 */
if(
rgc_fill_buffer(BgL_iportz00_3378))
{ /* Llib/json.scm 42 */
long BgL_arg1265z00_3382;long BgL_arg1266z00_3383;
{ /* Llib/json.scm 42 */
long BgL_res2366z00_3384;
BgL_res2366z00_3384 = 
RGC_BUFFER_FORWARD(BgL_iportz00_3378); 
BgL_arg1265z00_3382 = BgL_res2366z00_3384; } 
{ /* Llib/json.scm 42 */
long BgL_res2367z00_3385;
BgL_res2367z00_3385 = 
RGC_BUFFER_BUFPOS(BgL_iportz00_3378); 
BgL_arg1266z00_3383 = BgL_res2367z00_3385; } 
{ 
long BgL_bufposz00_4136;long BgL_forwardz00_4135;
BgL_forwardz00_4135 = BgL_arg1265z00_3382; 
BgL_bufposz00_4136 = BgL_arg1266z00_3383; 
BgL_bufposz00_3381 = BgL_bufposz00_4136; 
BgL_forwardz00_3380 = BgL_forwardz00_4135; 
goto BgL_statezd231zd21044z00_2891;} }  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_lastzd2matchzd2_3379; } }  else 
{ /* Llib/json.scm 42 */
int BgL_curz00_3386;
{ /* Llib/json.scm 42 */
int BgL_res2368z00_3387;
BgL_res2368z00_3387 = 
RGC_BUFFER_GET_CHAR(BgL_iportz00_3378, BgL_forwardz00_3380); 
BgL_curz00_3386 = BgL_res2368z00_3387; } 
{ /* Llib/json.scm 42 */

if(
(
(long)(BgL_curz00_3386)==((long)92)))
{ 
long BgL_bufposz00_4145;long BgL_forwardz00_4143;long BgL_lastzd2matchzd2_4142;obj_t BgL_iportz00_4141;
BgL_iportz00_4141 = BgL_iportz00_3378; 
BgL_lastzd2matchzd2_4142 = BgL_lastzd2matchzd2_3379; 
BgL_forwardz00_4143 = 
(((long)1)+BgL_forwardz00_3380); 
BgL_bufposz00_4145 = BgL_bufposz00_3381; 
BgL_bufposz00_3446 = BgL_bufposz00_4145; 
BgL_forwardz00_3445 = BgL_forwardz00_4143; 
BgL_lastzd2matchzd2_3444 = BgL_lastzd2matchzd2_4142; 
BgL_iportz00_3443 = BgL_iportz00_4141; 
goto BgL_statezd233zd21046z00_2897;}  else 
{ /* Llib/json.scm 42 */
if(
(
(long)(BgL_curz00_3386)==((long)34)))
{ /* Llib/json.scm 42 */
long BgL_arg1300z00_3388;
BgL_arg1300z00_3388 = 
(((long)1)+BgL_forwardz00_3380); 
{ /* Llib/json.scm 42 */
long BgL_newzd2matchzd2_3389;
{ /* Llib/json.scm 42 */
long BgL_res2373z00_3390;
BgL_res2373z00_3390 = 
RGC_STOP_MATCH(BgL_iportz00_3378, BgL_arg1300z00_3388); BgL_res2373z00_3390; } 
BgL_newzd2matchzd2_3389 = ((long)11); 
BgL_matchz00_2901 = BgL_newzd2matchzd2_3389; } }  else 
{ /* Llib/json.scm 42 */
bool_t BgL_test3097z00_4151;
if(
(
(long)(BgL_curz00_3386)<((long)32)))
{ /* Llib/json.scm 42 */
BgL_test3097z00_4151 = ((bool_t)1)
; }  else 
{ /* Llib/json.scm 42 */
if(
(
(long)(BgL_curz00_3386)==((long)34)))
{ /* Llib/json.scm 42 */
BgL_test3097z00_4151 = ((bool_t)1)
; }  else 
{ /* Llib/json.scm 42 */
BgL_test3097z00_4151 = 
(
(long)(BgL_curz00_3386)==((long)92))
; } } 
if(BgL_test3097z00_4151)
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_lastzd2matchzd2_3379; }  else 
{ 
long BgL_forwardz00_4160;
BgL_forwardz00_4160 = 
(((long)1)+BgL_forwardz00_3380); 
BgL_forwardz00_3380 = BgL_forwardz00_4160; 
goto BgL_statezd231zd21044z00_2891;} } } } } }  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_lastzd2matchzd2_3434; } } } } }  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_lastzd2matchzd2_3414; } } } } }  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_lastzd2matchzd2_3466; } } } } }  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_lastzd2matchzd2_3424; } } } } }  else 
{ /* Llib/json.scm 42 */
bool_t BgL_test3100z00_4167;
switch( 
(long)(BgL_curz00_3451)) { case ((long)34) : 

BgL_test3100z00_4167 = ((bool_t)1); break;case ((long)47) : 

BgL_test3100z00_4167 = ((bool_t)1); break;case ((long)92) : 

BgL_test3100z00_4167 = ((bool_t)1); break;case ((long)98) : 

BgL_test3100z00_4167 = ((bool_t)1); break;case ((long)102) : 

BgL_test3100z00_4167 = ((bool_t)1); break;case ((long)110) : 

BgL_test3100z00_4167 = ((bool_t)1); break;case ((long)114) : 

BgL_test3100z00_4167 = ((bool_t)1); break;
default: 
BgL_test3100z00_4167 = 
(
(long)(BgL_curz00_3451)==((long)116)); } 
if(BgL_test3100z00_4167)
{ 
long BgL_bufposz00_4176;long BgL_forwardz00_4174;long BgL_lastzd2matchzd2_4173;obj_t BgL_iportz00_4172;
BgL_iportz00_4172 = BgL_iportz00_3443; 
BgL_lastzd2matchzd2_4173 = BgL_lastzd2matchzd2_3444; 
BgL_forwardz00_4174 = 
(((long)1)+BgL_forwardz00_3445); 
BgL_bufposz00_4176 = BgL_bufposz00_3446; 
BgL_bufposz00_3381 = BgL_bufposz00_4176; 
BgL_forwardz00_3380 = BgL_forwardz00_4174; 
BgL_lastzd2matchzd2_3379 = BgL_lastzd2matchzd2_4173; 
BgL_iportz00_3378 = BgL_iportz00_4172; 
goto BgL_statezd231zd21044z00_2891;}  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_lastzd2matchzd2_3444; } } } } }  else 
{ /* Llib/json.scm 42 */
if(
(
(long)(BgL_curz00_3254)==((long)34)))
{ /* Llib/json.scm 42 */
long BgL_arg1698z00_3256;
BgL_arg1698z00_3256 = 
(((long)1)+BgL_forwardz00_3246); 
{ /* Llib/json.scm 42 */
long BgL_newzd2matchzd2_3257;
{ /* Llib/json.scm 42 */
long BgL_res2503z00_3258;
BgL_res2503z00_3258 = 
RGC_STOP_MATCH(BgL_iportz00_3244, BgL_arg1698z00_3256); BgL_res2503z00_3258; } 
BgL_newzd2matchzd2_3257 = ((long)11); 
BgL_matchz00_2901 = BgL_newzd2matchzd2_3257; } }  else 
{ /* Llib/json.scm 42 */
bool_t BgL_test3102z00_4183;
if(
(
(long)(BgL_curz00_3254)<((long)32)))
{ /* Llib/json.scm 42 */
BgL_test3102z00_4183 = ((bool_t)1)
; }  else 
{ /* Llib/json.scm 42 */
if(
(
(long)(BgL_curz00_3254)==((long)34)))
{ /* Llib/json.scm 42 */
BgL_test3102z00_4183 = ((bool_t)1)
; }  else 
{ /* Llib/json.scm 42 */
BgL_test3102z00_4183 = 
(
(long)(BgL_curz00_3254)==((long)92))
; } } 
if(BgL_test3102z00_4183)
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_newzd2matchzd2_3248; }  else 
{ 
long BgL_bufposz00_4196;long BgL_forwardz00_4194;long BgL_lastzd2matchzd2_4193;obj_t BgL_iportz00_4192;
BgL_iportz00_4192 = BgL_iportz00_3244; 
BgL_lastzd2matchzd2_4193 = BgL_newzd2matchzd2_3248; 
BgL_forwardz00_4194 = 
(((long)1)+BgL_forwardz00_3246); 
BgL_bufposz00_4196 = BgL_bufposz00_3247; 
BgL_bufposz00_3381 = BgL_bufposz00_4196; 
BgL_forwardz00_3380 = BgL_forwardz00_4194; 
BgL_lastzd2matchzd2_3379 = BgL_lastzd2matchzd2_4193; 
BgL_iportz00_3378 = BgL_iportz00_4192; 
goto BgL_statezd231zd21044z00_2891;} } } } } } break;case ((long)32) : 
case ((long)13) : 
case ((long)10) : 
case ((long)9) : 

BgL_iportz00_3342 = BgL_iportz00_3259; 
BgL_lastzd2matchzd2_3343 = BgL_lastzd2matchzd2_3260; 
BgL_forwardz00_3344 = 
(((long)1)+BgL_forwardz00_3261); 
BgL_bufposz00_3345 = BgL_bufposz00_3262; 
BgL_statezd22zd21015z00_2888:
{ /* Llib/json.scm 42 */
long BgL_newzd2matchzd2_3346;
{ /* Llib/json.scm 42 */
long BgL_res2396z00_3347;
BgL_res2396z00_3347 = 
RGC_STOP_MATCH(BgL_iportz00_3342, BgL_forwardz00_3344); BgL_res2396z00_3347; } 
BgL_newzd2matchzd2_3346 = ((long)0); 
if(
(BgL_forwardz00_3344==BgL_bufposz00_3345))
{ /* Llib/json.scm 42 */
if(
rgc_fill_buffer(BgL_iportz00_3342))
{ /* Llib/json.scm 42 */
long BgL_arg1517z00_3348;long BgL_arg1518z00_3349;
{ /* Llib/json.scm 42 */
long BgL_res2399z00_3350;
BgL_res2399z00_3350 = 
RGC_BUFFER_FORWARD(BgL_iportz00_3342); 
BgL_arg1517z00_3348 = BgL_res2399z00_3350; } 
{ /* Llib/json.scm 42 */
long BgL_res2400z00_3351;
BgL_res2400z00_3351 = 
RGC_BUFFER_BUFPOS(BgL_iportz00_3342); 
BgL_arg1518z00_3349 = BgL_res2400z00_3351; } 
{ 
long BgL_bufposz00_4206;long BgL_forwardz00_4205;
BgL_forwardz00_4205 = BgL_arg1517z00_3348; 
BgL_bufposz00_4206 = BgL_arg1518z00_3349; 
BgL_bufposz00_3345 = BgL_bufposz00_4206; 
BgL_forwardz00_3344 = BgL_forwardz00_4205; 
goto BgL_statezd22zd21015z00_2888;} }  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_newzd2matchzd2_3346; } }  else 
{ /* Llib/json.scm 42 */
int BgL_curz00_3352;
{ /* Llib/json.scm 42 */
int BgL_res2401z00_3353;
BgL_res2401z00_3353 = 
RGC_BUFFER_GET_CHAR(BgL_iportz00_3342, BgL_forwardz00_3344); 
BgL_curz00_3352 = BgL_res2401z00_3353; } 
{ /* Llib/json.scm 42 */

{ /* Llib/json.scm 42 */
bool_t BgL_test3107z00_4208;
{ /* Llib/json.scm 42 */
bool_t BgL_test3108z00_4209;
if(
(
(long)(BgL_curz00_3352)==((long)10)))
{ /* Llib/json.scm 42 */
BgL_test3108z00_4209 = ((bool_t)1)
; }  else 
{ /* Llib/json.scm 42 */
BgL_test3108z00_4209 = 
(
(long)(BgL_curz00_3352)==((long)9))
; } 
if(BgL_test3108z00_4209)
{ /* Llib/json.scm 42 */
BgL_test3107z00_4208 = ((bool_t)1)
; }  else 
{ /* Llib/json.scm 42 */
if(
(
(long)(BgL_curz00_3352)==((long)13)))
{ /* Llib/json.scm 42 */
BgL_test3107z00_4208 = ((bool_t)1)
; }  else 
{ /* Llib/json.scm 42 */
BgL_test3107z00_4208 = 
(
(long)(BgL_curz00_3352)==((long)32))
; } } } 
if(BgL_test3107z00_4208)
{ /* Llib/json.scm 42 */
BgL_iportz00_3142 = BgL_iportz00_3342; 
BgL_lastzd2matchzd2_3143 = BgL_newzd2matchzd2_3346; 
BgL_forwardz00_3144 = 
(((long)1)+BgL_forwardz00_3344); 
BgL_bufposz00_3145 = BgL_bufposz00_3345; 
BgL_statezd238zd21051z00_2874:
{ /* Llib/json.scm 42 */
long BgL_newzd2matchzd2_3146;
{ /* Llib/json.scm 42 */
long BgL_res2598z00_3147;
BgL_res2598z00_3147 = 
RGC_STOP_MATCH(BgL_iportz00_3142, BgL_forwardz00_3144); BgL_res2598z00_3147; } 
BgL_newzd2matchzd2_3146 = ((long)0); 
if(
(BgL_forwardz00_3144==BgL_bufposz00_3145))
{ /* Llib/json.scm 42 */
if(
rgc_fill_buffer(BgL_iportz00_3142))
{ /* Llib/json.scm 42 */
long BgL_arg1819z00_3148;long BgL_arg1820z00_3149;
{ /* Llib/json.scm 42 */
long BgL_res2601z00_3150;
BgL_res2601z00_3150 = 
RGC_BUFFER_FORWARD(BgL_iportz00_3142); 
BgL_arg1819z00_3148 = BgL_res2601z00_3150; } 
{ /* Llib/json.scm 42 */
long BgL_res2602z00_3151;
BgL_res2602z00_3151 = 
RGC_BUFFER_BUFPOS(BgL_iportz00_3142); 
BgL_arg1820z00_3149 = BgL_res2602z00_3151; } 
{ 
long BgL_bufposz00_4228;long BgL_forwardz00_4227;
BgL_forwardz00_4227 = BgL_arg1819z00_3148; 
BgL_bufposz00_4228 = BgL_arg1820z00_3149; 
BgL_bufposz00_3145 = BgL_bufposz00_4228; 
BgL_forwardz00_3144 = BgL_forwardz00_4227; 
goto BgL_statezd238zd21051z00_2874;} }  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_newzd2matchzd2_3146; } }  else 
{ /* Llib/json.scm 42 */
int BgL_curz00_3152;
{ /* Llib/json.scm 42 */
int BgL_res2603z00_3153;
BgL_res2603z00_3153 = 
RGC_BUFFER_GET_CHAR(BgL_iportz00_3142, BgL_forwardz00_3144); 
BgL_curz00_3152 = BgL_res2603z00_3153; } 
{ /* Llib/json.scm 42 */

{ /* Llib/json.scm 42 */
bool_t BgL_test3113z00_4230;
{ /* Llib/json.scm 42 */
bool_t BgL_test3114z00_4231;
if(
(
(long)(BgL_curz00_3152)==((long)10)))
{ /* Llib/json.scm 42 */
BgL_test3114z00_4231 = ((bool_t)1)
; }  else 
{ /* Llib/json.scm 42 */
BgL_test3114z00_4231 = 
(
(long)(BgL_curz00_3152)==((long)9))
; } 
if(BgL_test3114z00_4231)
{ /* Llib/json.scm 42 */
BgL_test3113z00_4230 = ((bool_t)1)
; }  else 
{ /* Llib/json.scm 42 */
if(
(
(long)(BgL_curz00_3152)==((long)13)))
{ /* Llib/json.scm 42 */
BgL_test3113z00_4230 = ((bool_t)1)
; }  else 
{ /* Llib/json.scm 42 */
BgL_test3113z00_4230 = 
(
(long)(BgL_curz00_3152)==((long)32))
; } } } 
if(BgL_test3113z00_4230)
{ 
long BgL_forwardz00_4243;long BgL_lastzd2matchzd2_4242;
BgL_lastzd2matchzd2_4242 = BgL_newzd2matchzd2_3146; 
BgL_forwardz00_4243 = 
(((long)1)+BgL_forwardz00_3144); 
BgL_forwardz00_3144 = BgL_forwardz00_4243; 
BgL_lastzd2matchzd2_3143 = BgL_lastzd2matchzd2_4242; 
goto BgL_statezd238zd21051z00_2874;}  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_newzd2matchzd2_3146; } } } } } }  else 
{ /* Llib/json.scm 42 */
BgL_matchz00_2901 = BgL_newzd2matchzd2_3346; } } } } } break;case ((long)255) : 
case ((long)254) : 
case ((long)253) : 
case ((long)252) : 
case ((long)251) : 
case ((long)250) : 
case ((long)249) : 
case ((long)248) : 
case ((long)247) : 
case ((long)246) : 
case ((long)245) : 
case ((long)244) : 
case ((long)243) : 
case ((long)242) : 
case ((long)241) : 
case ((long)240) : 
case ((long)239) : 
case ((long)238) : 
case ((long)237) : 
case ((long)236) : 
case ((long)235) : 
case ((long)234) : 
case ((long)233) : 
case ((long)232) : 
case ((long)231) : 
case ((long)230) : 
case ((long)229) : 
case ((long)228) : 
case ((long)227) : 
case ((long)226) : 
case ((long)225) : 
case ((long)224) : 
case ((long)223) : 
case ((long)222) : 
case ((long)221) : 
case ((long)220) : 
case ((long)219) : 
case ((long)218) : 
case ((long)217) : 
case ((long)216) : 
case ((long)215) : 
case ((long)214) : 
case ((long)213) : 
case ((long)212) : 
case ((long)211) : 
case ((long)210) : 
case ((long)209) : 
case ((long)208) : 
case ((long)207) : 
case ((long)206) : 
case ((long)205) : 
case ((long)204) : 
case ((long)203) : 
case ((long)202) : 
case ((long)201) : 
case ((long)200) : 
case ((long)199) : 
case ((long)198) : 
case ((long)197) : 
case ((long)196) : 
case ((long)195) : 
case ((long)194) : 
case ((long)193) : 
case ((long)192) : 
case ((long)191) : 
case ((long)190) : 
case ((long)189) : 
case ((long)188) : 
case ((long)187) : 
case ((long)186) : 
case ((long)185) : 
case ((long)184) : 
case ((long)183) : 
case ((long)182) : 
case ((long)181) : 
case ((long)180) : 
case ((long)179) : 
case ((long)178) : 
case ((long)177) : 
case ((long)176) : 
case ((long)175) : 
case ((long)174) : 
case ((long)173) : 
case ((long)172) : 
case ((long)171) : 
case ((long)170) : 
case ((long)169) : 
case ((long)168) : 
case ((long)167) : 
case ((long)166) : 
case ((long)165) : 
case ((long)164) : 
case ((long)163) : 
case ((long)162) : 
case ((long)161) : 
case ((long)160) : 
case ((long)159) : 
case ((long)158) : 
case ((long)157) : 
case ((long)156) : 
case ((long)155) : 
case ((long)154) : 
case ((long)153) : 
case ((long)152) : 
case ((long)151) : 
case ((long)150) : 
case ((long)149) : 
case ((long)148) : 
case ((long)147) : 
case ((long)146) : 
case ((long)145) : 
case ((long)144) : 
case ((long)143) : 
case ((long)142) : 
case ((long)141) : 
case ((long)140) : 
case ((long)139) : 
case ((long)138) : 
case ((long)137) : 
case ((long)136) : 
case ((long)135) : 
case ((long)134) : 
case ((long)133) : 
case ((long)132) : 
case ((long)131) : 
case ((long)130) : 
case ((long)129) : 
case ((long)128) : 
case ((long)127) : 
case ((long)126) : 
case ((long)124) : 
case ((long)96) : 
case ((long)94) : 
case ((long)92) : 
case ((long)64) : 
case ((long)63) : 
case ((long)62) : 
case ((long)61) : 
case ((long)60) : 
case ((long)59) : 
case ((long)47) : 
case ((long)42) : 
case ((long)39) : 
case ((long)38) : 
case ((long)37) : 
case ((long)36) : 
case ((long)35) : 
case ((long)33) : 
case ((long)31) : 
case ((long)30) : 
case ((long)29) : 
case ((long)28) : 
case ((long)27) : 
case ((long)26) : 
case ((long)25) : 
case ((long)24) : 
case ((long)23) : 
case ((long)22) : 
case ((long)21) : 
case ((long)20) : 
case ((long)19) : 
case ((long)18) : 
case ((long)17) : 
case ((long)16) : 
case ((long)15) : 
case ((long)14) : 
case ((long)12) : 
case ((long)11) : 
case ((long)8) : 
case ((long)7) : 
case ((long)6) : 
case ((long)5) : 
case ((long)4) : 
case ((long)3) : 
case ((long)2) : 
case ((long)1) : 
case ((long)0) : 

{ /* Llib/json.scm 42 */
long BgL_arg1686z00_3293;
BgL_arg1686z00_3293 = 
(((long)1)+BgL_forwardz00_3261); 
{ /* Llib/json.scm 42 */
long BgL_newzd2matchzd2_3294;
{ /* Llib/json.scm 42 */
long BgL_res2492z00_3295;
BgL_res2492z00_3295 = 
RGC_STOP_MATCH(BgL_iportz00_3259, BgL_arg1686z00_3293); BgL_res2492z00_3295; } 
BgL_newzd2matchzd2_3294 = ((long)13); 
BgL_matchz00_2901 = BgL_newzd2matchzd2_3294; } } break;
default: 
BgL_matchz00_2901 = BgL_lastzd2matchzd2_3260; } } } } 
RGC_SET_FILEPOS(BgL_iportz00_2772); 
switch( BgL_matchz00_2901) { case ((long)13) : 

{ /* Llib/json.scm 110 */
obj_t BgL_cz00_2906;
{ /* Llib/json.scm 42 */
bool_t BgL_test3117z00_4252;
{ /* Llib/json.scm 42 */
long BgL_arg1914z00_3113;
{ /* Llib/json.scm 42 */
long BgL_res2634z00_3114;
BgL_res2634z00_3114 = 
RGC_BUFFER_MATCH_LENGTH(BgL_iportz00_2772); 
BgL_arg1914z00_3113 = BgL_res2634z00_3114; } 
BgL_test3117z00_4252 = 
(BgL_arg1914z00_3113==((long)0)); } 
if(BgL_test3117z00_4252)
{ /* Llib/json.scm 42 */
BgL_cz00_2906 = BEOF; }  else 
{ /* Llib/json.scm 42 */
unsigned char BgL_res2636z00_3115;
BgL_res2636z00_3115 = 
RGC_BUFFER_CHARACTER(BgL_iportz00_2772); 
BgL_cz00_2906 = 
BCHAR(BgL_res2636z00_3115); } } 
{ /* Llib/json.scm 111 */
bool_t BgL_test3118z00_4257;
{ /* Llib/json.scm 111 */
bool_t BgL_res2640z00_2907;
BgL_res2640z00_2907 = 
EOF_OBJECTP(BgL_cz00_2906); 
BgL_test3118z00_4257 = BgL_res2640z00_2907; } 
if(BgL_test3118z00_4257)
{ /* Llib/json.scm 112 */
obj_t BgL_arg1923z00_2908;long BgL_arg1924z00_2909;
{ /* Llib/json.scm 112 */
obj_t BgL_res2642z00_2910;
BgL_res2642z00_2910 = 
INPUT_PORT_NAME(BgL_iportz00_2772); 
BgL_arg1923z00_2908 = BgL_res2642z00_2910; } 
{ /* Llib/json.scm 112 */
long BgL_res2644z00_2911;
BgL_res2644z00_2911 = 
INPUT_PORT_FILEPOS(BgL_iportz00_2772); 
BgL_arg1924z00_2909 = BgL_res2644z00_2911; } 
{ /* Llib/json.scm 112 */
obj_t BgL_list1925z00_2912;
{ /* Llib/json.scm 112 */
obj_t BgL_arg1926z00_2913;
{ /* Llib/json.scm 112 */
obj_t BgL_arg1927z00_2914;
{ /* Llib/json.scm 112 */
obj_t BgL_arg1928z00_2915;
BgL_arg1928z00_2915 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1924z00_2909), BNIL); 
BgL_arg1927z00_2914 = 
MAKE_YOUNG_PAIR(BgL_arg1923z00_2908, BgL_arg1928z00_2915); } 
BgL_arg1926z00_2913 = 
MAKE_YOUNG_PAIR(BgL_cz00_2906, BgL_arg1927z00_2914); } 
BgL_list1925z00_2912 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)0)), BgL_arg1926z00_2913); } 
return BgL_list1925z00_2912;} }  else 
{ /* Llib/json.scm 113 */
obj_t BgL_arg1931z00_2916;obj_t BgL_arg1932z00_2917;long BgL_arg1933z00_2918;
{ /* Llib/json.scm 113 */
obj_t BgL_arg1938z00_2919;
BgL_arg1938z00_2919 = 
BGl_readzd2charszd2zz__r4_input_6_10_2z00(
BINT(((long)10)), BgL_iportz00_2772); 
{ /* Llib/json.scm 113 */
obj_t BgL_list1939z00_2920;
{ /* Llib/json.scm 113 */
obj_t BgL_arg1940z00_2921;
BgL_arg1940z00_2921 = 
MAKE_YOUNG_PAIR(BgL_arg1938z00_2919, BNIL); 
BgL_list1939z00_2920 = 
MAKE_YOUNG_PAIR(BgL_cz00_2906, BgL_arg1940z00_2921); } 
BgL_arg1931z00_2916 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string2906z00zz__web_jsonz00, BgL_list1939z00_2920); } } 
{ /* Llib/json.scm 113 */
obj_t BgL_res2648z00_2922;
BgL_res2648z00_2922 = 
INPUT_PORT_NAME(BgL_iportz00_2772); 
BgL_arg1932z00_2917 = BgL_res2648z00_2922; } 
{ /* Llib/json.scm 113 */
long BgL_res2650z00_2923;
BgL_res2650z00_2923 = 
INPUT_PORT_FILEPOS(BgL_iportz00_2772); 
BgL_arg1933z00_2918 = BgL_res2650z00_2923; } 
{ /* Llib/json.scm 113 */
obj_t BgL_list1934z00_2924;
{ /* Llib/json.scm 113 */
obj_t BgL_arg1935z00_2925;
{ /* Llib/json.scm 113 */
obj_t BgL_arg1936z00_2926;
{ /* Llib/json.scm 113 */
obj_t BgL_arg1937z00_2927;
BgL_arg1937z00_2927 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1933z00_2918), BNIL); 
BgL_arg1936z00_2926 = 
MAKE_YOUNG_PAIR(BgL_arg1932z00_2917, BgL_arg1937z00_2927); } 
BgL_arg1935z00_2925 = 
MAKE_YOUNG_PAIR(BgL_arg1931z00_2916, BgL_arg1936z00_2926); } 
BgL_list1934z00_2924 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)1)), BgL_arg1935z00_2925); } 
return BgL_list1934z00_2924;} } } } break;case ((long)12) : 

{ /* Llib/json.scm 100 */
obj_t BgL_casezd2valuezd2_2928;
BgL_casezd2valuezd2_2928 = 
rgc_buffer_symbol(BgL_iportz00_2772); 
if(
(BgL_casezd2valuezd2_2928==
CNST_TABLE_REF(((long)2))))
{ /* Llib/json.scm 101 */
obj_t BgL_arg1945z00_2929;obj_t BgL_arg1946z00_2930;long BgL_arg1947z00_2931;
BgL_arg1945z00_2929 = 
PROCEDURE_ENTRY(BgL_constantzd2alloczd2_2774)(BgL_constantzd2alloczd2_2774, BNIL, BEOA); 
{ /* Llib/json.scm 101 */
obj_t BgL_res2656z00_2932;
BgL_res2656z00_2932 = 
INPUT_PORT_NAME(BgL_iportz00_2772); 
BgL_arg1946z00_2930 = BgL_res2656z00_2932; } 
{ /* Llib/json.scm 101 */
long BgL_res2658z00_2933;
BgL_res2658z00_2933 = 
INPUT_PORT_FILEPOS(BgL_iportz00_2772); 
BgL_arg1947z00_2931 = BgL_res2658z00_2933; } 
{ /* Llib/json.scm 101 */
obj_t BgL_list1948z00_2934;
{ /* Llib/json.scm 101 */
obj_t BgL_arg1949z00_2935;
{ /* Llib/json.scm 101 */
obj_t BgL_arg1950z00_2936;
{ /* Llib/json.scm 101 */
obj_t BgL_arg1951z00_2937;
BgL_arg1951z00_2937 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1947z00_2931), BNIL); 
BgL_arg1950z00_2936 = 
MAKE_YOUNG_PAIR(BgL_arg1946z00_2930, BgL_arg1951z00_2937); } 
BgL_arg1949z00_2935 = 
MAKE_YOUNG_PAIR(BgL_arg1945z00_2929, BgL_arg1950z00_2936); } 
BgL_list1948z00_2934 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)3)), BgL_arg1949z00_2935); } 
return BgL_list1948z00_2934;} }  else 
{ /* Llib/json.scm 100 */
if(
(BgL_casezd2valuezd2_2928==
CNST_TABLE_REF(((long)4))))
{ /* Llib/json.scm 100 */
if(
CBOOL(BgL_undefinedz00_2773))
{ /* Llib/json.scm 103 */
obj_t BgL_arg1955z00_2938;obj_t BgL_arg1956z00_2939;long BgL_arg1957z00_2940;
BgL_arg1955z00_2938 = 
PROCEDURE_ENTRY(BgL_constantzd2alloczd2_2774)(BgL_constantzd2alloczd2_2774, BUNSPEC, BEOA); 
{ /* Llib/json.scm 103 */
obj_t BgL_res2662z00_2941;
BgL_res2662z00_2941 = 
INPUT_PORT_NAME(BgL_iportz00_2772); 
BgL_arg1956z00_2939 = BgL_res2662z00_2941; } 
{ /* Llib/json.scm 103 */
long BgL_res2664z00_2942;
BgL_res2664z00_2942 = 
INPUT_PORT_FILEPOS(BgL_iportz00_2772); 
BgL_arg1957z00_2940 = BgL_res2664z00_2942; } 
{ /* Llib/json.scm 103 */
obj_t BgL_list1958z00_2943;
{ /* Llib/json.scm 103 */
obj_t BgL_arg1959z00_2944;
{ /* Llib/json.scm 103 */
obj_t BgL_arg1960z00_2945;
{ /* Llib/json.scm 103 */
obj_t BgL_arg1961z00_2946;
BgL_arg1961z00_2946 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1957z00_2940), BNIL); 
BgL_arg1960z00_2945 = 
MAKE_YOUNG_PAIR(BgL_arg1956z00_2939, BgL_arg1961z00_2946); } 
BgL_arg1959z00_2944 = 
MAKE_YOUNG_PAIR(BgL_arg1955z00_2938, BgL_arg1960z00_2945); } 
BgL_list1958z00_2943 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)3)), BgL_arg1959z00_2944); } 
return BgL_list1958z00_2943;} }  else 
{ /* Llib/json.scm 104 */
obj_t BgL_arg1964z00_2947;long BgL_arg1965z00_2948;
{ /* Llib/json.scm 104 */
obj_t BgL_res2667z00_2949;
BgL_res2667z00_2949 = 
INPUT_PORT_NAME(BgL_iportz00_2772); 
BgL_arg1964z00_2947 = BgL_res2667z00_2949; } 
{ /* Llib/json.scm 104 */
long BgL_res2669z00_2950;
BgL_res2669z00_2950 = 
INPUT_PORT_FILEPOS(BgL_iportz00_2772); 
BgL_arg1965z00_2948 = BgL_res2669z00_2950; } 
{ /* Llib/json.scm 104 */
obj_t BgL_list1966z00_2951;
{ /* Llib/json.scm 104 */
obj_t BgL_arg1967z00_2952;
{ /* Llib/json.scm 104 */
obj_t BgL_arg1968z00_2953;
{ /* Llib/json.scm 104 */
obj_t BgL_arg1969z00_2954;
BgL_arg1969z00_2954 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1965z00_2948), BNIL); 
BgL_arg1968z00_2953 = 
MAKE_YOUNG_PAIR(BgL_arg1964z00_2947, BgL_arg1969z00_2954); } 
BgL_arg1967z00_2952 = 
MAKE_YOUNG_PAIR(BUNSPEC, BgL_arg1968z00_2953); } 
BgL_list1966z00_2951 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)1)), BgL_arg1967z00_2952); } 
return BgL_list1966z00_2951;} } }  else 
{ /* Llib/json.scm 100 */
if(
(BgL_casezd2valuezd2_2928==
CNST_TABLE_REF(((long)5))))
{ /* Llib/json.scm 105 */
obj_t BgL_arg1973z00_2955;obj_t BgL_arg1974z00_2956;long BgL_arg1975z00_2957;
BgL_arg1973z00_2955 = 
PROCEDURE_ENTRY(BgL_constantzd2alloczd2_2774)(BgL_constantzd2alloczd2_2774, BTRUE, BEOA); 
{ /* Llib/json.scm 105 */
obj_t BgL_res2673z00_2958;
BgL_res2673z00_2958 = 
INPUT_PORT_NAME(BgL_iportz00_2772); 
BgL_arg1974z00_2956 = BgL_res2673z00_2958; } 
{ /* Llib/json.scm 105 */
long BgL_res2675z00_2959;
BgL_res2675z00_2959 = 
INPUT_PORT_FILEPOS(BgL_iportz00_2772); 
BgL_arg1975z00_2957 = BgL_res2675z00_2959; } 
{ /* Llib/json.scm 105 */
obj_t BgL_list1976z00_2960;
{ /* Llib/json.scm 105 */
obj_t BgL_arg1977z00_2961;
{ /* Llib/json.scm 105 */
obj_t BgL_arg1978z00_2962;
{ /* Llib/json.scm 105 */
obj_t BgL_arg1979z00_2963;
BgL_arg1979z00_2963 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1975z00_2957), BNIL); 
BgL_arg1978z00_2962 = 
MAKE_YOUNG_PAIR(BgL_arg1974z00_2956, BgL_arg1979z00_2963); } 
BgL_arg1977z00_2961 = 
MAKE_YOUNG_PAIR(BgL_arg1973z00_2955, BgL_arg1978z00_2962); } 
BgL_list1976z00_2960 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)3)), BgL_arg1977z00_2961); } 
return BgL_list1976z00_2960;} }  else 
{ /* Llib/json.scm 100 */
if(
(BgL_casezd2valuezd2_2928==
CNST_TABLE_REF(((long)6))))
{ /* Llib/json.scm 106 */
obj_t BgL_arg1983z00_2964;obj_t BgL_arg1984z00_2965;long BgL_arg1985z00_2966;
BgL_arg1983z00_2964 = 
PROCEDURE_ENTRY(BgL_constantzd2alloczd2_2774)(BgL_constantzd2alloczd2_2774, BFALSE, BEOA); 
{ /* Llib/json.scm 106 */
obj_t BgL_res2679z00_2967;
BgL_res2679z00_2967 = 
INPUT_PORT_NAME(BgL_iportz00_2772); 
BgL_arg1984z00_2965 = BgL_res2679z00_2967; } 
{ /* Llib/json.scm 106 */
long BgL_res2681z00_2968;
BgL_res2681z00_2968 = 
INPUT_PORT_FILEPOS(BgL_iportz00_2772); 
BgL_arg1985z00_2966 = BgL_res2681z00_2968; } 
{ /* Llib/json.scm 106 */
obj_t BgL_list1986z00_2969;
{ /* Llib/json.scm 106 */
obj_t BgL_arg1987z00_2970;
{ /* Llib/json.scm 106 */
obj_t BgL_arg1988z00_2971;
{ /* Llib/json.scm 106 */
obj_t BgL_arg1989z00_2972;
BgL_arg1989z00_2972 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1985z00_2966), BNIL); 
BgL_arg1988z00_2971 = 
MAKE_YOUNG_PAIR(BgL_arg1984z00_2965, BgL_arg1989z00_2972); } 
BgL_arg1987z00_2970 = 
MAKE_YOUNG_PAIR(BgL_arg1983z00_2964, BgL_arg1988z00_2971); } 
BgL_list1986z00_2969 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)3)), BgL_arg1987z00_2970); } 
return BgL_list1986z00_2969;} }  else 
{ /* Llib/json.scm 107 */
obj_t BgL_arg1992z00_2973;obj_t BgL_arg1993z00_2974;long BgL_arg1994z00_2975;
BgL_arg1992z00_2973 = 
rgc_buffer_symbol(BgL_iportz00_2772); 
{ /* Llib/json.scm 107 */
obj_t BgL_res2686z00_2976;
BgL_res2686z00_2976 = 
INPUT_PORT_NAME(BgL_iportz00_2772); 
BgL_arg1993z00_2974 = BgL_res2686z00_2976; } 
{ /* Llib/json.scm 107 */
long BgL_res2688z00_2977;
BgL_res2688z00_2977 = 
INPUT_PORT_FILEPOS(BgL_iportz00_2772); 
BgL_arg1994z00_2975 = BgL_res2688z00_2977; } 
{ /* Llib/json.scm 107 */
obj_t BgL_list1995z00_2978;
{ /* Llib/json.scm 107 */
obj_t BgL_arg1996z00_2979;
{ /* Llib/json.scm 107 */
obj_t BgL_arg1997z00_2980;
{ /* Llib/json.scm 107 */
obj_t BgL_arg1998z00_2981;
BgL_arg1998z00_2981 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1994z00_2975), BNIL); 
BgL_arg1997z00_2980 = 
MAKE_YOUNG_PAIR(BgL_arg1993z00_2974, BgL_arg1998z00_2981); } 
BgL_arg1996z00_2979 = 
MAKE_YOUNG_PAIR(BgL_arg1992z00_2973, BgL_arg1997z00_2980); } 
BgL_list1995z00_2978 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)1)), BgL_arg1996z00_2979); } 
return BgL_list1995z00_2978;} } } } } } break;case ((long)11) : 

{ /* Llib/json.scm 95 */
obj_t BgL_strz00_2982;
{ /* Llib/json.scm 95 */
obj_t BgL_arg2011z00_2983;
{ /* Llib/json.scm 95 */
long BgL_arg2012z00_2984;
{ /* Llib/json.scm 95 */
long BgL_arg2013z00_2985;
{ /* Llib/json.scm 42 */
long BgL_res2690z00_2986;
BgL_res2690z00_2986 = 
RGC_BUFFER_MATCH_LENGTH(BgL_iportz00_2772); 
BgL_arg2013z00_2985 = BgL_res2690z00_2986; } 
BgL_arg2012z00_2984 = 
(BgL_arg2013z00_2985-((long)1)); } 
BgL_minz00_3116 = 
(int)(((long)1)); 
BgL_maxz00_3117 = 
(int)(BgL_arg2012z00_2984); 
if(
(
(long)(BgL_maxz00_3117)<
(long)(BgL_minz00_3116)))
{ /* Llib/json.scm 42 */
long BgL_arg1843z00_3118;
{ /* Llib/json.scm 42 */
long BgL_res2621z00_3119;
BgL_res2621z00_3119 = 
RGC_BUFFER_MATCH_LENGTH(BgL_iportz00_2772); 
BgL_arg1843z00_3118 = BgL_res2621z00_3119; } 
{ /* Llib/json.scm 42 */
long BgL_za72za7_3120;
BgL_za72za7_3120 = 
(long)(BgL_maxz00_3117); 
BgL_maxz00_3117 = 
(int)(
(BgL_arg1843z00_3118+BgL_za72za7_3120)); } }  else 
{ /* Llib/json.scm 42 */BFALSE; } 
{ /* Llib/json.scm 42 */
bool_t BgL_test3125z00_4370;
if(
(
(long)(BgL_minz00_3116)>=((long)0)))
{ /* Llib/json.scm 42 */
if(
(
(long)(BgL_maxz00_3117)>=
(long)(BgL_minz00_3116)))
{ /* Llib/json.scm 42 */
long BgL_arg1852z00_3121;
{ /* Llib/json.scm 42 */
long BgL_res2625z00_3122;
BgL_res2625z00_3122 = 
RGC_BUFFER_MATCH_LENGTH(BgL_iportz00_2772); 
BgL_arg1852z00_3121 = BgL_res2625z00_3122; } 
BgL_test3125z00_4370 = 
(
(long)(BgL_maxz00_3117)<=BgL_arg1852z00_3121); }  else 
{ /* Llib/json.scm 42 */
BgL_test3125z00_4370 = ((bool_t)0)
; } }  else 
{ /* Llib/json.scm 42 */
BgL_test3125z00_4370 = ((bool_t)0)
; } 
if(BgL_test3125z00_4370)
{ /* Llib/json.scm 42 */
BgL_arg2011z00_2983 = 
rgc_buffer_substring(BgL_iportz00_2772, 
(long)(BgL_minz00_3116), 
(long)(BgL_maxz00_3117)); }  else 
{ /* Llib/json.scm 42 */
obj_t BgL_arg1848z00_3123;obj_t BgL_arg1849z00_3124;
{ /* Llib/json.scm 42 */
obj_t BgL_arg1850z00_3125;
{ /* Llib/json.scm 42 */
obj_t BgL_res2630z00_3126;
{ /* Llib/json.scm 42 */
long BgL_arg1840z00_3127;
{ /* Llib/json.scm 42 */
long BgL_res2628z00_3128;
BgL_res2628z00_3128 = 
RGC_BUFFER_MATCH_LENGTH(BgL_iportz00_2772); 
BgL_arg1840z00_3127 = BgL_res2628z00_3128; } 
BgL_res2630z00_3126 = 
rgc_buffer_substring(BgL_iportz00_2772, ((long)0), BgL_arg1840z00_3127); } 
BgL_arg1850z00_3125 = BgL_res2630z00_3126; } 
{ /* Llib/json.scm 42 */
obj_t BgL_list1851z00_3129;
BgL_list1851z00_3129 = 
MAKE_YOUNG_PAIR(BgL_arg1850z00_3125, BNIL); 
BgL_arg1848z00_3123 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string2909z00zz__web_jsonz00, BgL_list1851z00_3129); } } 
BgL_arg1849z00_3124 = 
MAKE_YOUNG_PAIR(
BINT(BgL_minz00_3116), 
BINT(BgL_maxz00_3117)); 
BgL_arg2011z00_2983 = 
BGl_errorz00zz__errorz00(BGl_string2910z00zz__web_jsonz00, BgL_arg1848z00_3123, BgL_arg1849z00_3124); } } } 
BgL_strz00_2982 = 
BGl_ucs2zd2ze3utf8z31zz__web_jsonz00(BgL_arg2011z00_2983, ((long)0)); } 
{ /* Llib/json.scm 96 */
obj_t BgL_arg2001z00_2987;obj_t BgL_arg2002z00_2988;long BgL_arg2003z00_2989;
{ /* Llib/json.scm 96 */
obj_t BgL_arg2008z00_2990;
BgL_arg2008z00_2990 = 
bgl_escape_C_string(
BSTRING_TO_STRING(BgL_strz00_2982), ((long)0), 
STRING_LENGTH(BgL_strz00_2982)); 
BgL_arg2001z00_2987 = 
PROCEDURE_ENTRY(BgL_stringzd2alloczd2_2775)(BgL_stringzd2alloczd2_2775, BgL_arg2008z00_2990, BEOA); } 
{ /* Llib/json.scm 96 */
obj_t BgL_res2695z00_2991;
BgL_res2695z00_2991 = 
INPUT_PORT_NAME(BgL_iportz00_2772); 
BgL_arg2002z00_2988 = BgL_res2695z00_2991; } 
{ /* Llib/json.scm 96 */
long BgL_res2697z00_2992;
BgL_res2697z00_2992 = 
INPUT_PORT_FILEPOS(BgL_iportz00_2772); 
BgL_arg2003z00_2989 = BgL_res2697z00_2992; } 
{ /* Llib/json.scm 96 */
obj_t BgL_list2004z00_2993;
{ /* Llib/json.scm 96 */
obj_t BgL_arg2005z00_2994;
{ /* Llib/json.scm 96 */
obj_t BgL_arg2006z00_2995;
{ /* Llib/json.scm 96 */
obj_t BgL_arg2007z00_2996;
BgL_arg2007z00_2996 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2003z00_2989), BNIL); 
BgL_arg2006z00_2995 = 
MAKE_YOUNG_PAIR(BgL_arg2002z00_2988, BgL_arg2007z00_2996); } 
BgL_arg2005z00_2994 = 
MAKE_YOUNG_PAIR(BgL_arg2001z00_2987, BgL_arg2006z00_2995); } 
BgL_list2004z00_2993 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)7)), BgL_arg2005z00_2994); } 
return BgL_list2004z00_2993;} } } break;case ((long)10) : 

{ /* Llib/json.scm 83 */
obj_t BgL_arg2014z00_2997;obj_t BgL_arg2015z00_2998;long BgL_arg2016z00_2999;
{ /* Llib/json.scm 83 */
double BgL_arg2021z00_3000;
BgL_arg2021z00_3000 = 
rgc_buffer_flonum(BgL_iportz00_2772); 
BgL_arg2014z00_2997 = 
PROCEDURE_ENTRY(BgL_constantzd2alloczd2_2774)(BgL_constantzd2alloczd2_2774, 
DOUBLE_TO_REAL(BgL_arg2021z00_3000), BEOA); } 
{ /* Llib/json.scm 83 */
obj_t BgL_res2701z00_3001;
BgL_res2701z00_3001 = 
INPUT_PORT_NAME(BgL_iportz00_2772); 
BgL_arg2015z00_2998 = BgL_res2701z00_3001; } 
{ /* Llib/json.scm 83 */
long BgL_res2703z00_3002;
BgL_res2703z00_3002 = 
INPUT_PORT_FILEPOS(BgL_iportz00_2772); 
BgL_arg2016z00_2999 = BgL_res2703z00_3002; } 
{ /* Llib/json.scm 83 */
obj_t BgL_list2017z00_3003;
{ /* Llib/json.scm 83 */
obj_t BgL_arg2018z00_3004;
{ /* Llib/json.scm 83 */
obj_t BgL_arg2019z00_3005;
{ /* Llib/json.scm 83 */
obj_t BgL_arg2020z00_3006;
BgL_arg2020z00_3006 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2016z00_2999), BNIL); 
BgL_arg2019z00_3005 = 
MAKE_YOUNG_PAIR(BgL_arg2015z00_2998, BgL_arg2020z00_3006); } 
BgL_arg2018z00_3004 = 
MAKE_YOUNG_PAIR(BgL_arg2014z00_2997, BgL_arg2019z00_3005); } 
BgL_list2017z00_3003 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)3)), BgL_arg2018z00_3004); } 
return BgL_list2017z00_3003;} } break;case ((long)9) : 

{ /* Llib/json.scm 74 */
obj_t BgL_arg2024z00_3007;obj_t BgL_arg2025z00_3008;long BgL_arg2026z00_3009;
{ /* Llib/json.scm 74 */
obj_t BgL_arg2031z00_3010;
BgL_arg2031z00_3010 = 
rgc_buffer_integer(BgL_iportz00_2772); 
BgL_arg2024z00_3007 = 
PROCEDURE_ENTRY(BgL_constantzd2alloczd2_2774)(BgL_constantzd2alloczd2_2774, BgL_arg2031z00_3010, BEOA); } 
{ /* Llib/json.scm 74 */
obj_t BgL_res2706z00_3011;
BgL_res2706z00_3011 = 
INPUT_PORT_NAME(BgL_iportz00_2772); 
BgL_arg2025z00_3008 = BgL_res2706z00_3011; } 
{ /* Llib/json.scm 74 */
long BgL_res2708z00_3012;
BgL_res2708z00_3012 = 
INPUT_PORT_FILEPOS(BgL_iportz00_2772); 
BgL_arg2026z00_3009 = BgL_res2708z00_3012; } 
{ /* Llib/json.scm 74 */
obj_t BgL_list2027z00_3013;
{ /* Llib/json.scm 74 */
obj_t BgL_arg2028z00_3014;
{ /* Llib/json.scm 74 */
obj_t BgL_arg2029z00_3015;
{ /* Llib/json.scm 74 */
obj_t BgL_arg2030z00_3016;
BgL_arg2030z00_3016 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2026z00_3009), BNIL); 
BgL_arg2029z00_3015 = 
MAKE_YOUNG_PAIR(BgL_arg2025z00_3008, BgL_arg2030z00_3016); } 
BgL_arg2028z00_3014 = 
MAKE_YOUNG_PAIR(BgL_arg2024z00_3007, BgL_arg2029z00_3015); } 
BgL_list2027z00_3013 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)3)), BgL_arg2028z00_3014); } 
return BgL_list2027z00_3013;} } break;case ((long)8) : 

{ /* Llib/json.scm 31 */
obj_t BgL_arg2034z00_3017;obj_t BgL_arg2035z00_3018;long BgL_arg2036z00_3019;
{ /* Llib/json.scm 31 */
obj_t BgL_res2712z00_3020;
{ /* Llib/json.scm 42 */
long BgL_arg1840z00_3021;
{ /* Llib/json.scm 42 */
long BgL_res2710z00_3022;
BgL_res2710z00_3022 = 
RGC_BUFFER_MATCH_LENGTH(BgL_iportz00_2772); 
BgL_arg1840z00_3021 = BgL_res2710z00_3022; } 
BgL_res2712z00_3020 = 
rgc_buffer_substring(BgL_iportz00_2772, ((long)0), BgL_arg1840z00_3021); } 
BgL_arg2034z00_3017 = BgL_res2712z00_3020; } 
{ /* Llib/json.scm 70 */
obj_t BgL_res2714z00_3023;
BgL_res2714z00_3023 = 
INPUT_PORT_NAME(BgL_iportz00_2772); 
BgL_arg2035z00_3018 = BgL_res2714z00_3023; } 
{ /* Llib/json.scm 70 */
long BgL_res2716z00_3024;
BgL_res2716z00_3024 = 
INPUT_PORT_FILEPOS(BgL_iportz00_2772); 
BgL_arg2036z00_3019 = BgL_res2716z00_3024; } 
{ /* Llib/json.scm 70 */
obj_t BgL_list2037z00_3025;
{ /* Llib/json.scm 70 */
obj_t BgL_arg2038z00_3026;
{ /* Llib/json.scm 70 */
obj_t BgL_arg2039z00_3027;
{ /* Llib/json.scm 70 */
obj_t BgL_arg2040z00_3028;
BgL_arg2040z00_3028 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2036z00_3019), BNIL); 
BgL_arg2039z00_3027 = 
MAKE_YOUNG_PAIR(BgL_arg2035z00_3018, BgL_arg2040z00_3028); } 
BgL_arg2038z00_3026 = 
MAKE_YOUNG_PAIR(BgL_arg2034z00_3017, BgL_arg2039z00_3027); } 
BgL_list2037z00_3025 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)8)), BgL_arg2038z00_3026); } 
return BgL_list2037z00_3025;} } break;case ((long)7) : 

{ /* Llib/json.scm 31 */
obj_t BgL_arg2043z00_3029;obj_t BgL_arg2044z00_3030;long BgL_arg2045z00_3031;
{ /* Llib/json.scm 31 */
obj_t BgL_res2720z00_3032;
{ /* Llib/json.scm 42 */
long BgL_arg1840z00_3033;
{ /* Llib/json.scm 42 */
long BgL_res2718z00_3034;
BgL_res2718z00_3034 = 
RGC_BUFFER_MATCH_LENGTH(BgL_iportz00_2772); 
BgL_arg1840z00_3033 = BgL_res2718z00_3034; } 
BgL_res2720z00_3032 = 
rgc_buffer_substring(BgL_iportz00_2772, ((long)0), BgL_arg1840z00_3033); } 
BgL_arg2043z00_3029 = BgL_res2720z00_3032; } 
{ /* Llib/json.scm 68 */
obj_t BgL_res2722z00_3035;
BgL_res2722z00_3035 = 
INPUT_PORT_NAME(BgL_iportz00_2772); 
BgL_arg2044z00_3030 = BgL_res2722z00_3035; } 
{ /* Llib/json.scm 68 */
long BgL_res2724z00_3036;
BgL_res2724z00_3036 = 
INPUT_PORT_FILEPOS(BgL_iportz00_2772); 
BgL_arg2045z00_3031 = BgL_res2724z00_3036; } 
{ /* Llib/json.scm 68 */
obj_t BgL_list2046z00_3037;
{ /* Llib/json.scm 68 */
obj_t BgL_arg2047z00_3038;
{ /* Llib/json.scm 68 */
obj_t BgL_arg2048z00_3039;
{ /* Llib/json.scm 68 */
obj_t BgL_arg2049z00_3040;
BgL_arg2049z00_3040 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2045z00_3031), BNIL); 
BgL_arg2048z00_3039 = 
MAKE_YOUNG_PAIR(BgL_arg2044z00_3030, BgL_arg2049z00_3040); } 
BgL_arg2047z00_3038 = 
MAKE_YOUNG_PAIR(BgL_arg2043z00_3029, BgL_arg2048z00_3039); } 
BgL_list2046z00_3037 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)9)), BgL_arg2047z00_3038); } 
return BgL_list2046z00_3037;} } break;case ((long)6) : 

{ /* Llib/json.scm 31 */
obj_t BgL_arg2052z00_3041;obj_t BgL_arg2053z00_3042;long BgL_arg2054z00_3043;
{ /* Llib/json.scm 31 */
obj_t BgL_res2728z00_3044;
{ /* Llib/json.scm 42 */
long BgL_arg1840z00_3045;
{ /* Llib/json.scm 42 */
long BgL_res2726z00_3046;
BgL_res2726z00_3046 = 
RGC_BUFFER_MATCH_LENGTH(BgL_iportz00_2772); 
BgL_arg1840z00_3045 = BgL_res2726z00_3046; } 
BgL_res2728z00_3044 = 
rgc_buffer_substring(BgL_iportz00_2772, ((long)0), BgL_arg1840z00_3045); } 
BgL_arg2052z00_3041 = BgL_res2728z00_3044; } 
{ /* Llib/json.scm 64 */
obj_t BgL_res2730z00_3047;
BgL_res2730z00_3047 = 
INPUT_PORT_NAME(BgL_iportz00_2772); 
BgL_arg2053z00_3042 = BgL_res2730z00_3047; } 
{ /* Llib/json.scm 64 */
long BgL_res2732z00_3048;
BgL_res2732z00_3048 = 
INPUT_PORT_FILEPOS(BgL_iportz00_2772); 
BgL_arg2054z00_3043 = BgL_res2732z00_3048; } 
{ /* Llib/json.scm 64 */
obj_t BgL_list2055z00_3049;
{ /* Llib/json.scm 64 */
obj_t BgL_arg2056z00_3050;
{ /* Llib/json.scm 64 */
obj_t BgL_arg2057z00_3051;
{ /* Llib/json.scm 64 */
obj_t BgL_arg2058z00_3052;
BgL_arg2058z00_3052 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2054z00_3043), BNIL); 
BgL_arg2057z00_3051 = 
MAKE_YOUNG_PAIR(BgL_arg2053z00_3042, BgL_arg2058z00_3052); } 
BgL_arg2056z00_3050 = 
MAKE_YOUNG_PAIR(BgL_arg2052z00_3041, BgL_arg2057z00_3051); } 
BgL_list2055z00_3049 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)10)), BgL_arg2056z00_3050); } 
return BgL_list2055z00_3049;} } break;case ((long)5) : 

{ /* Llib/json.scm 31 */
obj_t BgL_arg2061z00_3053;obj_t BgL_arg2062z00_3054;long BgL_arg2063z00_3055;
{ /* Llib/json.scm 31 */
obj_t BgL_res2736z00_3056;
{ /* Llib/json.scm 42 */
long BgL_arg1840z00_3057;
{ /* Llib/json.scm 42 */
long BgL_res2734z00_3058;
BgL_res2734z00_3058 = 
RGC_BUFFER_MATCH_LENGTH(BgL_iportz00_2772); 
BgL_arg1840z00_3057 = BgL_res2734z00_3058; } 
BgL_res2736z00_3056 = 
rgc_buffer_substring(BgL_iportz00_2772, ((long)0), BgL_arg1840z00_3057); } 
BgL_arg2061z00_3053 = BgL_res2736z00_3056; } 
{ /* Llib/json.scm 62 */
obj_t BgL_res2738z00_3059;
BgL_res2738z00_3059 = 
INPUT_PORT_NAME(BgL_iportz00_2772); 
BgL_arg2062z00_3054 = BgL_res2738z00_3059; } 
{ /* Llib/json.scm 62 */
long BgL_res2740z00_3060;
BgL_res2740z00_3060 = 
INPUT_PORT_FILEPOS(BgL_iportz00_2772); 
BgL_arg2063z00_3055 = BgL_res2740z00_3060; } 
{ /* Llib/json.scm 62 */
obj_t BgL_list2064z00_3061;
{ /* Llib/json.scm 62 */
obj_t BgL_arg2065z00_3062;
{ /* Llib/json.scm 62 */
obj_t BgL_arg2066z00_3063;
{ /* Llib/json.scm 62 */
obj_t BgL_arg2067z00_3064;
BgL_arg2067z00_3064 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2063z00_3055), BNIL); 
BgL_arg2066z00_3063 = 
MAKE_YOUNG_PAIR(BgL_arg2062z00_3054, BgL_arg2067z00_3064); } 
BgL_arg2065z00_3062 = 
MAKE_YOUNG_PAIR(BgL_arg2061z00_3053, BgL_arg2066z00_3063); } 
BgL_list2064z00_3061 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)11)), BgL_arg2065z00_3062); } 
return BgL_list2064z00_3061;} } break;case ((long)4) : 

{ /* Llib/json.scm 31 */
obj_t BgL_arg2070z00_3065;obj_t BgL_arg2071z00_3066;long BgL_arg2072z00_3067;
{ /* Llib/json.scm 31 */
obj_t BgL_res2744z00_3068;
{ /* Llib/json.scm 42 */
long BgL_arg1840z00_3069;
{ /* Llib/json.scm 42 */
long BgL_res2742z00_3070;
BgL_res2742z00_3070 = 
RGC_BUFFER_MATCH_LENGTH(BgL_iportz00_2772); 
BgL_arg1840z00_3069 = BgL_res2742z00_3070; } 
BgL_res2744z00_3068 = 
rgc_buffer_substring(BgL_iportz00_2772, ((long)0), BgL_arg1840z00_3069); } 
BgL_arg2070z00_3065 = BgL_res2744z00_3068; } 
{ /* Llib/json.scm 58 */
obj_t BgL_res2746z00_3071;
BgL_res2746z00_3071 = 
INPUT_PORT_NAME(BgL_iportz00_2772); 
BgL_arg2071z00_3066 = BgL_res2746z00_3071; } 
{ /* Llib/json.scm 58 */
long BgL_res2748z00_3072;
BgL_res2748z00_3072 = 
INPUT_PORT_FILEPOS(BgL_iportz00_2772); 
BgL_arg2072z00_3067 = BgL_res2748z00_3072; } 
{ /* Llib/json.scm 58 */
obj_t BgL_list2073z00_3073;
{ /* Llib/json.scm 58 */
obj_t BgL_arg2074z00_3074;
{ /* Llib/json.scm 58 */
obj_t BgL_arg2075z00_3075;
{ /* Llib/json.scm 58 */
obj_t BgL_arg2076z00_3076;
BgL_arg2076z00_3076 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2072z00_3067), BNIL); 
BgL_arg2075z00_3075 = 
MAKE_YOUNG_PAIR(BgL_arg2071z00_3066, BgL_arg2076z00_3076); } 
BgL_arg2074z00_3074 = 
MAKE_YOUNG_PAIR(BgL_arg2070z00_3065, BgL_arg2075z00_3075); } 
BgL_list2073z00_3073 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)12)), BgL_arg2074z00_3074); } 
return BgL_list2073z00_3073;} } break;case ((long)3) : 

{ /* Llib/json.scm 31 */
obj_t BgL_arg2079z00_3077;obj_t BgL_arg2080z00_3078;long BgL_arg2081z00_3079;
{ /* Llib/json.scm 31 */
obj_t BgL_res2752z00_3080;
{ /* Llib/json.scm 42 */
long BgL_arg1840z00_3081;
{ /* Llib/json.scm 42 */
long BgL_res2750z00_3082;
BgL_res2750z00_3082 = 
RGC_BUFFER_MATCH_LENGTH(BgL_iportz00_2772); 
BgL_arg1840z00_3081 = BgL_res2750z00_3082; } 
BgL_res2752z00_3080 = 
rgc_buffer_substring(BgL_iportz00_2772, ((long)0), BgL_arg1840z00_3081); } 
BgL_arg2079z00_3077 = BgL_res2752z00_3080; } 
{ /* Llib/json.scm 56 */
obj_t BgL_res2754z00_3083;
BgL_res2754z00_3083 = 
INPUT_PORT_NAME(BgL_iportz00_2772); 
BgL_arg2080z00_3078 = BgL_res2754z00_3083; } 
{ /* Llib/json.scm 56 */
long BgL_res2756z00_3084;
BgL_res2756z00_3084 = 
INPUT_PORT_FILEPOS(BgL_iportz00_2772); 
BgL_arg2081z00_3079 = BgL_res2756z00_3084; } 
{ /* Llib/json.scm 56 */
obj_t BgL_list2082z00_3085;
{ /* Llib/json.scm 56 */
obj_t BgL_arg2083z00_3086;
{ /* Llib/json.scm 56 */
obj_t BgL_arg2084z00_3087;
{ /* Llib/json.scm 56 */
obj_t BgL_arg2085z00_3088;
BgL_arg2085z00_3088 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2081z00_3079), BNIL); 
BgL_arg2084z00_3087 = 
MAKE_YOUNG_PAIR(BgL_arg2080z00_3078, BgL_arg2085z00_3088); } 
BgL_arg2083z00_3086 = 
MAKE_YOUNG_PAIR(BgL_arg2079z00_3077, BgL_arg2084z00_3087); } 
BgL_list2082z00_3085 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)13)), BgL_arg2083z00_3086); } 
return BgL_list2082z00_3085;} } break;case ((long)2) : 

{ /* Llib/json.scm 31 */
obj_t BgL_arg2088z00_3089;obj_t BgL_arg2089z00_3090;long BgL_arg2090z00_3091;
{ /* Llib/json.scm 31 */
obj_t BgL_res2760z00_3092;
{ /* Llib/json.scm 42 */
long BgL_arg1840z00_3093;
{ /* Llib/json.scm 42 */
long BgL_res2758z00_3094;
BgL_res2758z00_3094 = 
RGC_BUFFER_MATCH_LENGTH(BgL_iportz00_2772); 
BgL_arg1840z00_3093 = BgL_res2758z00_3094; } 
BgL_res2760z00_3092 = 
rgc_buffer_substring(BgL_iportz00_2772, ((long)0), BgL_arg1840z00_3093); } 
BgL_arg2088z00_3089 = BgL_res2760z00_3092; } 
{ /* Llib/json.scm 52 */
obj_t BgL_res2762z00_3095;
BgL_res2762z00_3095 = 
INPUT_PORT_NAME(BgL_iportz00_2772); 
BgL_arg2089z00_3090 = BgL_res2762z00_3095; } 
{ /* Llib/json.scm 52 */
long BgL_res2764z00_3096;
BgL_res2764z00_3096 = 
INPUT_PORT_FILEPOS(BgL_iportz00_2772); 
BgL_arg2090z00_3091 = BgL_res2764z00_3096; } 
{ /* Llib/json.scm 52 */
obj_t BgL_list2091z00_3097;
{ /* Llib/json.scm 52 */
obj_t BgL_arg2092z00_3098;
{ /* Llib/json.scm 52 */
obj_t BgL_arg2093z00_3099;
{ /* Llib/json.scm 52 */
obj_t BgL_arg2094z00_3100;
BgL_arg2094z00_3100 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2090z00_3091), BNIL); 
BgL_arg2093z00_3099 = 
MAKE_YOUNG_PAIR(BgL_arg2089z00_3090, BgL_arg2094z00_3100); } 
BgL_arg2092z00_3098 = 
MAKE_YOUNG_PAIR(BgL_arg2088z00_3089, BgL_arg2093z00_3099); } 
BgL_list2091z00_3097 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)14)), BgL_arg2092z00_3098); } 
return BgL_list2091z00_3097;} } break;case ((long)1) : 

{ /* Llib/json.scm 31 */
obj_t BgL_arg2097z00_3101;obj_t BgL_arg2098z00_3102;long BgL_arg2099z00_3103;
{ /* Llib/json.scm 31 */
obj_t BgL_res2768z00_3104;
{ /* Llib/json.scm 42 */
long BgL_arg1840z00_3105;
{ /* Llib/json.scm 42 */
long BgL_res2766z00_3106;
BgL_res2766z00_3106 = 
RGC_BUFFER_MATCH_LENGTH(BgL_iportz00_2772); 
BgL_arg1840z00_3105 = BgL_res2766z00_3106; } 
BgL_res2768z00_3104 = 
rgc_buffer_substring(BgL_iportz00_2772, ((long)0), BgL_arg1840z00_3105); } 
BgL_arg2097z00_3101 = BgL_res2768z00_3104; } 
{ /* Llib/json.scm 50 */
obj_t BgL_res2770z00_3107;
BgL_res2770z00_3107 = 
INPUT_PORT_NAME(BgL_iportz00_2772); 
BgL_arg2098z00_3102 = BgL_res2770z00_3107; } 
{ /* Llib/json.scm 50 */
long BgL_res2772z00_3108;
BgL_res2772z00_3108 = 
INPUT_PORT_FILEPOS(BgL_iportz00_2772); 
BgL_arg2099z00_3103 = BgL_res2772z00_3108; } 
{ /* Llib/json.scm 50 */
obj_t BgL_list2100z00_3109;
{ /* Llib/json.scm 50 */
obj_t BgL_arg2101z00_3110;
{ /* Llib/json.scm 50 */
obj_t BgL_arg2102z00_3111;
{ /* Llib/json.scm 50 */
obj_t BgL_arg2103z00_3112;
BgL_arg2103z00_3112 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2099z00_3103), BNIL); 
BgL_arg2102z00_3111 = 
MAKE_YOUNG_PAIR(BgL_arg2098z00_3102, BgL_arg2103z00_3112); } 
BgL_arg2101z00_3110 = 
MAKE_YOUNG_PAIR(BgL_arg2097z00_3101, BgL_arg2102z00_3111); } 
BgL_list2100z00_3109 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)15)), BgL_arg2101z00_3110); } 
return BgL_list2100z00_3109;} } break;case ((long)0) : 

goto BgL_ignorez00_2870;break;
default: 
return 
BGl_errorz00zz__errorz00(BGl_string2907z00zz__web_jsonz00, BGl_string2908z00zz__web_jsonz00, 
BINT(BgL_matchz00_2901));} } } } 

}



/* ucs2->utf8 */
obj_t BGl_ucs2zd2ze3utf8z31zz__web_jsonz00(obj_t BgL_strz00_3, long BgL_startz00_4)
{
{ /* Llib/json.scm 118 */
{ /* Llib/json.scm 140 */
long BgL_lenz00_1106;
BgL_lenz00_1106 = 
STRING_LENGTH(BgL_strz00_3); 
{ 
long BgL_iz00_1108;
BgL_iz00_1108 = BgL_startz00_4; 
BgL_zc3z04anonymousza32111ze3z87_1109:
if(
(BgL_iz00_1108==BgL_lenz00_1106))
{ /* Llib/json.scm 143 */
if(
(BgL_startz00_4==((long)0)))
{ /* Llib/json.scm 144 */
return BgL_strz00_3;}  else 
{ /* Llib/json.scm 144 */
return 
c_substring(BgL_strz00_3, BgL_startz00_4, BgL_lenz00_1106);} }  else 
{ /* Llib/json.scm 147 */
bool_t BgL_test3130z00_4526;
if(
(
STRING_REF(BgL_strz00_3, BgL_iz00_1108)==((unsigned char)'\\')))
{ /* Llib/json.scm 147 */
if(
(
(BgL_iz00_1108+((long)6))<=BgL_lenz00_1106))
{ /* Llib/json.scm 148 */
BgL_test3130z00_4526 = 
(
STRING_REF(BgL_strz00_3, 
(BgL_iz00_1108+((long)1)))==((unsigned char)'u'))
; }  else 
{ /* Llib/json.scm 148 */
BgL_test3130z00_4526 = ((bool_t)0)
; } }  else 
{ /* Llib/json.scm 147 */
BgL_test3130z00_4526 = ((bool_t)0)
; } 
if(BgL_test3130z00_4526)
{ /* Llib/json.scm 147 */
if(
(BgL_iz00_1108>BgL_startz00_4))
{ /* Llib/json.scm 150 */
return 
string_append_3(
c_substring(BgL_strz00_3, BgL_startz00_4, BgL_iz00_1108), 
BGl_utf8ze70ze7zz__web_jsonz00(BgL_strz00_3, 
(BgL_iz00_1108+((long)2))), 
BGl_ucs2zd2ze3utf8z31zz__web_jsonz00(BgL_strz00_3, 
(BgL_iz00_1108+((long)6))));}  else 
{ /* Llib/json.scm 150 */
return 
string_append_3(
c_substring(BgL_strz00_3, BgL_startz00_4, BgL_iz00_1108), 
BGl_utf8ze70ze7zz__web_jsonz00(BgL_strz00_3, 
(BgL_iz00_1108+((long)2))), 
BGl_ucs2zd2ze3utf8z31zz__web_jsonz00(BgL_strz00_3, 
(BgL_iz00_1108+((long)6))));} }  else 
{ 
long BgL_iz00_4550;
BgL_iz00_4550 = 
(BgL_iz00_1108+((long)1)); 
BgL_iz00_1108 = BgL_iz00_4550; 
goto BgL_zc3z04anonymousza32111ze3z87_1109;} } } } } 

}



/* hex~0 */
long BGl_hexze70ze7zz__web_jsonz00(unsigned char BgL_nz00_1140)
{
{ /* Llib/json.scm 129 */
{ /* Llib/json.scm 122 */
bool_t BgL_test3134z00_4552;
if(
(BgL_nz00_1140>=((unsigned char)'0')))
{ /* Llib/json.scm 122 */
BgL_test3134z00_4552 = 
(BgL_nz00_1140<=((unsigned char)'9'))
; }  else 
{ /* Llib/json.scm 122 */
BgL_test3134z00_4552 = ((bool_t)0)
; } 
if(BgL_test3134z00_4552)
{ /* Llib/json.scm 122 */
return 
(
(BgL_nz00_1140)-((long)48));}  else 
{ /* Llib/json.scm 124 */
bool_t BgL_test3136z00_4558;
if(
(BgL_nz00_1140>=((unsigned char)'a')))
{ /* Llib/json.scm 124 */
BgL_test3136z00_4558 = 
(BgL_nz00_1140<=((unsigned char)'f'))
; }  else 
{ /* Llib/json.scm 124 */
BgL_test3136z00_4558 = ((bool_t)0)
; } 
if(BgL_test3136z00_4558)
{ /* Llib/json.scm 124 */
return 
(((long)10)+
(
(BgL_nz00_1140)-((long)97)));}  else 
{ /* Llib/json.scm 126 */
bool_t BgL_test3138z00_4565;
if(
(BgL_nz00_1140>=((unsigned char)'A')))
{ /* Llib/json.scm 126 */
BgL_test3138z00_4565 = 
(BgL_nz00_1140<=((unsigned char)'F'))
; }  else 
{ /* Llib/json.scm 126 */
BgL_test3138z00_4565 = ((bool_t)0)
; } 
if(BgL_test3138z00_4565)
{ /* Llib/json.scm 126 */
return 
(((long)10)+
(
(BgL_nz00_1140)-((long)65)));}  else 
{ /* Llib/json.scm 126 */
return ((long)0);} } } } } 

}



/* utf8~0 */
obj_t BGl_utf8ze70ze7zz__web_jsonz00(obj_t BgL_strz00_1156, long BgL_iz00_1157)
{
{ /* Llib/json.scm 138 */
{ /* Llib/json.scm 132 */
long BgL_c0z00_1159;
BgL_c0z00_1159 = 
BGl_hexze70ze7zz__web_jsonz00(
STRING_REF(BgL_strz00_1156, BgL_iz00_1157)); 
{ /* Llib/json.scm 132 */
long BgL_c1z00_1160;
BgL_c1z00_1160 = 
BGl_hexze70ze7zz__web_jsonz00(
STRING_REF(BgL_strz00_1156, 
(BgL_iz00_1157+((long)1)))); 
{ /* Llib/json.scm 133 */
long BgL_c2z00_1161;
BgL_c2z00_1161 = 
BGl_hexze70ze7zz__web_jsonz00(
STRING_REF(BgL_strz00_1156, 
(BgL_iz00_1157+((long)2)))); 
{ /* Llib/json.scm 134 */
long BgL_c3z00_1162;
BgL_c3z00_1162 = 
BGl_hexze70ze7zz__web_jsonz00(
STRING_REF(BgL_strz00_1156, 
(BgL_iz00_1157+((long)3)))); 
{ /* Llib/json.scm 135 */
long BgL_nz00_1163;
BgL_nz00_1163 = 
(
(
(
(BgL_c0z00_1159*((long)16))+BgL_c1z00_1160) << 
(int)(((long)8)))+
(
(BgL_c2z00_1161*((long)16))+BgL_c3z00_1162)); 
{ /* Llib/json.scm 136 */
ucs2_t BgL_uz00_1164;
BgL_uz00_1164 = 
BGl_integerzd2ze3ucs2z31zz__ucs2z00(
(int)(BgL_nz00_1163)); 
{ /* Llib/json.scm 137 */

return 
ucs2_string_to_utf8_string(
make_ucs2_string(
(int)(((long)1)), BgL_uz00_1164));} } } } } } } } 

}



/* _json-parse */
obj_t BGl__jsonzd2parsezd2zz__web_jsonz00(obj_t BgL_envz00_19, obj_t BgL_opt1081z00_18)
{
{ /* Llib/json.scm 168 */
{ /* Llib/json.scm 168 */
obj_t BgL_oz00_1184;
BgL_oz00_1184 = 
VECTOR_REF(BgL_opt1081z00_18,((long)0)); 
{ /* Llib/json.scm 168 */
obj_t BgL_arrayzd2alloczd2_1185;
BgL_arrayzd2alloczd2_1185 = BFALSE; 
{ /* Llib/json.scm 168 */
obj_t BgL_arrayzd2returnzd2_1186;
BgL_arrayzd2returnzd2_1186 = BFALSE; 
{ /* Llib/json.scm 168 */
obj_t BgL_arrayzd2setzd2_1187;
BgL_arrayzd2setzd2_1187 = BFALSE; 
{ /* Llib/json.scm 168 */
obj_t BgL_constantzd2alloczd2_1188;
BgL_constantzd2alloczd2_1188 = BFALSE; 
{ /* Llib/json.scm 168 */
obj_t BgL_exprz00_1189;
BgL_exprz00_1189 = BFALSE; 
{ /* Llib/json.scm 168 */
obj_t BgL_objectzd2alloczd2_1190;
BgL_objectzd2alloczd2_1190 = BFALSE; 
{ /* Llib/json.scm 168 */
obj_t BgL_objectzd2returnzd2_1191;
BgL_objectzd2returnzd2_1191 = BFALSE; 
{ /* Llib/json.scm 168 */
obj_t BgL_objectzd2setzd2_1192;
BgL_objectzd2setzd2_1192 = BFALSE; 
{ /* Llib/json.scm 168 */
obj_t BgL_parsezd2errorzd2_1193;
BgL_parsezd2errorzd2_1193 = BFALSE; 
{ /* Llib/json.scm 168 */
obj_t BgL_reviverz00_1194;
BgL_reviverz00_1194 = BFALSE; 
{ /* Llib/json.scm 168 */
obj_t BgL_stringzd2alloczd2_1195;
BgL_stringzd2alloczd2_1195 = BFALSE; 
{ /* Llib/json.scm 168 */
obj_t BgL_undefinedz00_1196;
BgL_undefinedz00_1196 = BTRUE; 
{ /* Llib/json.scm 168 */

{ 
long BgL_iz00_1197;
BgL_iz00_1197 = ((long)1); 
BgL_check1084z00_1198:
if(
(BgL_iz00_1197==
VECTOR_LENGTH(BgL_opt1081z00_18)))
{ /* Llib/json.scm 168 */BNIL; }  else 
{ /* Llib/json.scm 168 */
bool_t BgL_test3141z00_4599;
{ /* Llib/json.scm 168 */
obj_t BgL_arg2170z00_1204;
BgL_arg2170z00_1204 = 
VECTOR_REF(BgL_opt1081z00_18,BgL_iz00_1197); 
BgL_test3141z00_4599 = 
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg2170z00_1204, 
CNST_TABLE_REF(((long)16)))); } 
if(BgL_test3141z00_4599)
{ 
long BgL_iz00_4604;
BgL_iz00_4604 = 
(BgL_iz00_1197+((long)2)); 
BgL_iz00_1197 = BgL_iz00_4604; 
goto BgL_check1084z00_1198;}  else 
{ /* Llib/json.scm 168 */
obj_t BgL_arg2169z00_1203;
BgL_arg2169z00_1203 = 
VECTOR_REF(BgL_opt1081z00_18,BgL_iz00_1197); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)17)), BGl_string2911z00zz__web_jsonz00, BgL_arg2169z00_1203); } } } 
{ /* Llib/json.scm 168 */
obj_t BgL_index1086z00_1205;
BgL_index1086z00_1205 = 
BGl_search1083ze70ze7zz__web_jsonz00(
VECTOR_LENGTH(BgL_opt1081z00_18), BgL_opt1081z00_18, 
CNST_TABLE_REF(((long)18)), ((long)1)); 
{ /* Llib/json.scm 168 */
bool_t BgL_test3142z00_4612;
{ /* Llib/json.scm 168 */
long BgL_n1z00_2623;
{ /* Llib/json.scm 168 */
obj_t BgL_tmpz00_4613;
if(
INTEGERP(BgL_index1086z00_1205))
{ /* Llib/json.scm 168 */
BgL_tmpz00_4613 = BgL_index1086z00_1205
; }  else 
{ 
obj_t BgL_auxz00_4616;
BgL_auxz00_4616 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2912z00zz__web_jsonz00, 
BINT(((long)6153)), BGl_string2913z00zz__web_jsonz00, BGl_string2914z00zz__web_jsonz00, BgL_index1086z00_1205); 
FAILURE(BgL_auxz00_4616,BFALSE,BFALSE);} 
BgL_n1z00_2623 = 
(long)CINT(BgL_tmpz00_4613); } 
BgL_test3142z00_4612 = 
(BgL_n1z00_2623>=((long)0)); } 
if(BgL_test3142z00_4612)
{ 
long BgL_auxz00_4622;
{ /* Llib/json.scm 168 */
obj_t BgL_tmpz00_4623;
if(
INTEGERP(BgL_index1086z00_1205))
{ /* Llib/json.scm 168 */
BgL_tmpz00_4623 = BgL_index1086z00_1205
; }  else 
{ 
obj_t BgL_auxz00_4626;
BgL_auxz00_4626 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2912z00zz__web_jsonz00, 
BINT(((long)6153)), BGl_string2913z00zz__web_jsonz00, BGl_string2914z00zz__web_jsonz00, BgL_index1086z00_1205); 
FAILURE(BgL_auxz00_4626,BFALSE,BFALSE);} 
BgL_auxz00_4622 = 
(long)CINT(BgL_tmpz00_4623); } 
BgL_arrayzd2alloczd2_1185 = 
VECTOR_REF(BgL_opt1081z00_18,BgL_auxz00_4622); }  else 
{ /* Llib/json.scm 168 */BFALSE; } } } 
{ /* Llib/json.scm 168 */
obj_t BgL_index1087z00_1207;
BgL_index1087z00_1207 = 
BGl_search1083ze70ze7zz__web_jsonz00(
VECTOR_LENGTH(BgL_opt1081z00_18), BgL_opt1081z00_18, 
CNST_TABLE_REF(((long)19)), ((long)1)); 
{ /* Llib/json.scm 168 */
bool_t BgL_test3145z00_4635;
{ /* Llib/json.scm 168 */
long BgL_n1z00_2625;
{ /* Llib/json.scm 168 */
obj_t BgL_tmpz00_4636;
if(
INTEGERP(BgL_index1087z00_1207))
{ /* Llib/json.scm 168 */
BgL_tmpz00_4636 = BgL_index1087z00_1207
; }  else 
{ 
obj_t BgL_auxz00_4639;
BgL_auxz00_4639 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2912z00zz__web_jsonz00, 
BINT(((long)6153)), BGl_string2913z00zz__web_jsonz00, BGl_string2914z00zz__web_jsonz00, BgL_index1087z00_1207); 
FAILURE(BgL_auxz00_4639,BFALSE,BFALSE);} 
BgL_n1z00_2625 = 
(long)CINT(BgL_tmpz00_4636); } 
BgL_test3145z00_4635 = 
(BgL_n1z00_2625>=((long)0)); } 
if(BgL_test3145z00_4635)
{ 
long BgL_auxz00_4645;
{ /* Llib/json.scm 168 */
obj_t BgL_tmpz00_4646;
if(
INTEGERP(BgL_index1087z00_1207))
{ /* Llib/json.scm 168 */
BgL_tmpz00_4646 = BgL_index1087z00_1207
; }  else 
{ 
obj_t BgL_auxz00_4649;
BgL_auxz00_4649 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2912z00zz__web_jsonz00, 
BINT(((long)6153)), BGl_string2913z00zz__web_jsonz00, BGl_string2914z00zz__web_jsonz00, BgL_index1087z00_1207); 
FAILURE(BgL_auxz00_4649,BFALSE,BFALSE);} 
BgL_auxz00_4645 = 
(long)CINT(BgL_tmpz00_4646); } 
BgL_arrayzd2returnzd2_1186 = 
VECTOR_REF(BgL_opt1081z00_18,BgL_auxz00_4645); }  else 
{ /* Llib/json.scm 168 */BFALSE; } } } 
{ /* Llib/json.scm 168 */
obj_t BgL_index1088z00_1209;
BgL_index1088z00_1209 = 
BGl_search1083ze70ze7zz__web_jsonz00(
VECTOR_LENGTH(BgL_opt1081z00_18), BgL_opt1081z00_18, 
CNST_TABLE_REF(((long)20)), ((long)1)); 
{ /* Llib/json.scm 168 */
bool_t BgL_test3148z00_4658;
{ /* Llib/json.scm 168 */
long BgL_n1z00_2627;
{ /* Llib/json.scm 168 */
obj_t BgL_tmpz00_4659;
if(
INTEGERP(BgL_index1088z00_1209))
{ /* Llib/json.scm 168 */
BgL_tmpz00_4659 = BgL_index1088z00_1209
; }  else 
{ 
obj_t BgL_auxz00_4662;
BgL_auxz00_4662 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2912z00zz__web_jsonz00, 
BINT(((long)6153)), BGl_string2913z00zz__web_jsonz00, BGl_string2914z00zz__web_jsonz00, BgL_index1088z00_1209); 
FAILURE(BgL_auxz00_4662,BFALSE,BFALSE);} 
BgL_n1z00_2627 = 
(long)CINT(BgL_tmpz00_4659); } 
BgL_test3148z00_4658 = 
(BgL_n1z00_2627>=((long)0)); } 
if(BgL_test3148z00_4658)
{ 
long BgL_auxz00_4668;
{ /* Llib/json.scm 168 */
obj_t BgL_tmpz00_4669;
if(
INTEGERP(BgL_index1088z00_1209))
{ /* Llib/json.scm 168 */
BgL_tmpz00_4669 = BgL_index1088z00_1209
; }  else 
{ 
obj_t BgL_auxz00_4672;
BgL_auxz00_4672 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2912z00zz__web_jsonz00, 
BINT(((long)6153)), BGl_string2913z00zz__web_jsonz00, BGl_string2914z00zz__web_jsonz00, BgL_index1088z00_1209); 
FAILURE(BgL_auxz00_4672,BFALSE,BFALSE);} 
BgL_auxz00_4668 = 
(long)CINT(BgL_tmpz00_4669); } 
BgL_arrayzd2setzd2_1187 = 
VECTOR_REF(BgL_opt1081z00_18,BgL_auxz00_4668); }  else 
{ /* Llib/json.scm 168 */BFALSE; } } } 
{ /* Llib/json.scm 168 */
obj_t BgL_index1089z00_1211;
BgL_index1089z00_1211 = 
BGl_search1083ze70ze7zz__web_jsonz00(
VECTOR_LENGTH(BgL_opt1081z00_18), BgL_opt1081z00_18, 
CNST_TABLE_REF(((long)21)), ((long)1)); 
{ /* Llib/json.scm 168 */
bool_t BgL_test3151z00_4681;
{ /* Llib/json.scm 168 */
long BgL_n1z00_2629;
{ /* Llib/json.scm 168 */
obj_t BgL_tmpz00_4682;
if(
INTEGERP(BgL_index1089z00_1211))
{ /* Llib/json.scm 168 */
BgL_tmpz00_4682 = BgL_index1089z00_1211
; }  else 
{ 
obj_t BgL_auxz00_4685;
BgL_auxz00_4685 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2912z00zz__web_jsonz00, 
BINT(((long)6153)), BGl_string2913z00zz__web_jsonz00, BGl_string2914z00zz__web_jsonz00, BgL_index1089z00_1211); 
FAILURE(BgL_auxz00_4685,BFALSE,BFALSE);} 
BgL_n1z00_2629 = 
(long)CINT(BgL_tmpz00_4682); } 
BgL_test3151z00_4681 = 
(BgL_n1z00_2629>=((long)0)); } 
if(BgL_test3151z00_4681)
{ 
long BgL_auxz00_4691;
{ /* Llib/json.scm 168 */
obj_t BgL_tmpz00_4692;
if(
INTEGERP(BgL_index1089z00_1211))
{ /* Llib/json.scm 168 */
BgL_tmpz00_4692 = BgL_index1089z00_1211
; }  else 
{ 
obj_t BgL_auxz00_4695;
BgL_auxz00_4695 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2912z00zz__web_jsonz00, 
BINT(((long)6153)), BGl_string2913z00zz__web_jsonz00, BGl_string2914z00zz__web_jsonz00, BgL_index1089z00_1211); 
FAILURE(BgL_auxz00_4695,BFALSE,BFALSE);} 
BgL_auxz00_4691 = 
(long)CINT(BgL_tmpz00_4692); } 
BgL_constantzd2alloczd2_1188 = 
VECTOR_REF(BgL_opt1081z00_18,BgL_auxz00_4691); }  else 
{ /* Llib/json.scm 168 */BFALSE; } } } 
{ /* Llib/json.scm 168 */
obj_t BgL_index1090z00_1213;
BgL_index1090z00_1213 = 
BGl_search1083ze70ze7zz__web_jsonz00(
VECTOR_LENGTH(BgL_opt1081z00_18), BgL_opt1081z00_18, 
CNST_TABLE_REF(((long)22)), ((long)1)); 
{ /* Llib/json.scm 168 */
bool_t BgL_test3154z00_4704;
{ /* Llib/json.scm 168 */
long BgL_n1z00_2631;
{ /* Llib/json.scm 168 */
obj_t BgL_tmpz00_4705;
if(
INTEGERP(BgL_index1090z00_1213))
{ /* Llib/json.scm 168 */
BgL_tmpz00_4705 = BgL_index1090z00_1213
; }  else 
{ 
obj_t BgL_auxz00_4708;
BgL_auxz00_4708 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2912z00zz__web_jsonz00, 
BINT(((long)6153)), BGl_string2913z00zz__web_jsonz00, BGl_string2914z00zz__web_jsonz00, BgL_index1090z00_1213); 
FAILURE(BgL_auxz00_4708,BFALSE,BFALSE);} 
BgL_n1z00_2631 = 
(long)CINT(BgL_tmpz00_4705); } 
BgL_test3154z00_4704 = 
(BgL_n1z00_2631>=((long)0)); } 
if(BgL_test3154z00_4704)
{ 
long BgL_auxz00_4714;
{ /* Llib/json.scm 168 */
obj_t BgL_tmpz00_4715;
if(
INTEGERP(BgL_index1090z00_1213))
{ /* Llib/json.scm 168 */
BgL_tmpz00_4715 = BgL_index1090z00_1213
; }  else 
{ 
obj_t BgL_auxz00_4718;
BgL_auxz00_4718 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2912z00zz__web_jsonz00, 
BINT(((long)6153)), BGl_string2913z00zz__web_jsonz00, BGl_string2914z00zz__web_jsonz00, BgL_index1090z00_1213); 
FAILURE(BgL_auxz00_4718,BFALSE,BFALSE);} 
BgL_auxz00_4714 = 
(long)CINT(BgL_tmpz00_4715); } 
BgL_exprz00_1189 = 
VECTOR_REF(BgL_opt1081z00_18,BgL_auxz00_4714); }  else 
{ /* Llib/json.scm 168 */BFALSE; } } } 
{ /* Llib/json.scm 168 */
obj_t BgL_index1091z00_1215;
BgL_index1091z00_1215 = 
BGl_search1083ze70ze7zz__web_jsonz00(
VECTOR_LENGTH(BgL_opt1081z00_18), BgL_opt1081z00_18, 
CNST_TABLE_REF(((long)23)), ((long)1)); 
{ /* Llib/json.scm 168 */
bool_t BgL_test3157z00_4727;
{ /* Llib/json.scm 168 */
long BgL_n1z00_2633;
{ /* Llib/json.scm 168 */
obj_t BgL_tmpz00_4728;
if(
INTEGERP(BgL_index1091z00_1215))
{ /* Llib/json.scm 168 */
BgL_tmpz00_4728 = BgL_index1091z00_1215
; }  else 
{ 
obj_t BgL_auxz00_4731;
BgL_auxz00_4731 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2912z00zz__web_jsonz00, 
BINT(((long)6153)), BGl_string2913z00zz__web_jsonz00, BGl_string2914z00zz__web_jsonz00, BgL_index1091z00_1215); 
FAILURE(BgL_auxz00_4731,BFALSE,BFALSE);} 
BgL_n1z00_2633 = 
(long)CINT(BgL_tmpz00_4728); } 
BgL_test3157z00_4727 = 
(BgL_n1z00_2633>=((long)0)); } 
if(BgL_test3157z00_4727)
{ 
long BgL_auxz00_4737;
{ /* Llib/json.scm 168 */
obj_t BgL_tmpz00_4738;
if(
INTEGERP(BgL_index1091z00_1215))
{ /* Llib/json.scm 168 */
BgL_tmpz00_4738 = BgL_index1091z00_1215
; }  else 
{ 
obj_t BgL_auxz00_4741;
BgL_auxz00_4741 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2912z00zz__web_jsonz00, 
BINT(((long)6153)), BGl_string2913z00zz__web_jsonz00, BGl_string2914z00zz__web_jsonz00, BgL_index1091z00_1215); 
FAILURE(BgL_auxz00_4741,BFALSE,BFALSE);} 
BgL_auxz00_4737 = 
(long)CINT(BgL_tmpz00_4738); } 
BgL_objectzd2alloczd2_1190 = 
VECTOR_REF(BgL_opt1081z00_18,BgL_auxz00_4737); }  else 
{ /* Llib/json.scm 168 */BFALSE; } } } 
{ /* Llib/json.scm 168 */
obj_t BgL_index1092z00_1217;
BgL_index1092z00_1217 = 
BGl_search1083ze70ze7zz__web_jsonz00(
VECTOR_LENGTH(BgL_opt1081z00_18), BgL_opt1081z00_18, 
CNST_TABLE_REF(((long)24)), ((long)1)); 
{ /* Llib/json.scm 168 */
bool_t BgL_test3160z00_4750;
{ /* Llib/json.scm 168 */
long BgL_n1z00_2635;
{ /* Llib/json.scm 168 */
obj_t BgL_tmpz00_4751;
if(
INTEGERP(BgL_index1092z00_1217))
{ /* Llib/json.scm 168 */
BgL_tmpz00_4751 = BgL_index1092z00_1217
; }  else 
{ 
obj_t BgL_auxz00_4754;
BgL_auxz00_4754 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2912z00zz__web_jsonz00, 
BINT(((long)6153)), BGl_string2913z00zz__web_jsonz00, BGl_string2914z00zz__web_jsonz00, BgL_index1092z00_1217); 
FAILURE(BgL_auxz00_4754,BFALSE,BFALSE);} 
BgL_n1z00_2635 = 
(long)CINT(BgL_tmpz00_4751); } 
BgL_test3160z00_4750 = 
(BgL_n1z00_2635>=((long)0)); } 
if(BgL_test3160z00_4750)
{ 
long BgL_auxz00_4760;
{ /* Llib/json.scm 168 */
obj_t BgL_tmpz00_4761;
if(
INTEGERP(BgL_index1092z00_1217))
{ /* Llib/json.scm 168 */
BgL_tmpz00_4761 = BgL_index1092z00_1217
; }  else 
{ 
obj_t BgL_auxz00_4764;
BgL_auxz00_4764 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2912z00zz__web_jsonz00, 
BINT(((long)6153)), BGl_string2913z00zz__web_jsonz00, BGl_string2914z00zz__web_jsonz00, BgL_index1092z00_1217); 
FAILURE(BgL_auxz00_4764,BFALSE,BFALSE);} 
BgL_auxz00_4760 = 
(long)CINT(BgL_tmpz00_4761); } 
BgL_objectzd2returnzd2_1191 = 
VECTOR_REF(BgL_opt1081z00_18,BgL_auxz00_4760); }  else 
{ /* Llib/json.scm 168 */BFALSE; } } } 
{ /* Llib/json.scm 168 */
obj_t BgL_index1093z00_1219;
BgL_index1093z00_1219 = 
BGl_search1083ze70ze7zz__web_jsonz00(
VECTOR_LENGTH(BgL_opt1081z00_18), BgL_opt1081z00_18, 
CNST_TABLE_REF(((long)25)), ((long)1)); 
{ /* Llib/json.scm 168 */
bool_t BgL_test3163z00_4773;
{ /* Llib/json.scm 168 */
long BgL_n1z00_2637;
{ /* Llib/json.scm 168 */
obj_t BgL_tmpz00_4774;
if(
INTEGERP(BgL_index1093z00_1219))
{ /* Llib/json.scm 168 */
BgL_tmpz00_4774 = BgL_index1093z00_1219
; }  else 
{ 
obj_t BgL_auxz00_4777;
BgL_auxz00_4777 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2912z00zz__web_jsonz00, 
BINT(((long)6153)), BGl_string2913z00zz__web_jsonz00, BGl_string2914z00zz__web_jsonz00, BgL_index1093z00_1219); 
FAILURE(BgL_auxz00_4777,BFALSE,BFALSE);} 
BgL_n1z00_2637 = 
(long)CINT(BgL_tmpz00_4774); } 
BgL_test3163z00_4773 = 
(BgL_n1z00_2637>=((long)0)); } 
if(BgL_test3163z00_4773)
{ 
long BgL_auxz00_4783;
{ /* Llib/json.scm 168 */
obj_t BgL_tmpz00_4784;
if(
INTEGERP(BgL_index1093z00_1219))
{ /* Llib/json.scm 168 */
BgL_tmpz00_4784 = BgL_index1093z00_1219
; }  else 
{ 
obj_t BgL_auxz00_4787;
BgL_auxz00_4787 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2912z00zz__web_jsonz00, 
BINT(((long)6153)), BGl_string2913z00zz__web_jsonz00, BGl_string2914z00zz__web_jsonz00, BgL_index1093z00_1219); 
FAILURE(BgL_auxz00_4787,BFALSE,BFALSE);} 
BgL_auxz00_4783 = 
(long)CINT(BgL_tmpz00_4784); } 
BgL_objectzd2setzd2_1192 = 
VECTOR_REF(BgL_opt1081z00_18,BgL_auxz00_4783); }  else 
{ /* Llib/json.scm 168 */BFALSE; } } } 
{ /* Llib/json.scm 168 */
obj_t BgL_index1094z00_1221;
BgL_index1094z00_1221 = 
BGl_search1083ze70ze7zz__web_jsonz00(
VECTOR_LENGTH(BgL_opt1081z00_18), BgL_opt1081z00_18, 
CNST_TABLE_REF(((long)26)), ((long)1)); 
{ /* Llib/json.scm 168 */
bool_t BgL_test3166z00_4796;
{ /* Llib/json.scm 168 */
long BgL_n1z00_2639;
{ /* Llib/json.scm 168 */
obj_t BgL_tmpz00_4797;
if(
INTEGERP(BgL_index1094z00_1221))
{ /* Llib/json.scm 168 */
BgL_tmpz00_4797 = BgL_index1094z00_1221
; }  else 
{ 
obj_t BgL_auxz00_4800;
BgL_auxz00_4800 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2912z00zz__web_jsonz00, 
BINT(((long)6153)), BGl_string2913z00zz__web_jsonz00, BGl_string2914z00zz__web_jsonz00, BgL_index1094z00_1221); 
FAILURE(BgL_auxz00_4800,BFALSE,BFALSE);} 
BgL_n1z00_2639 = 
(long)CINT(BgL_tmpz00_4797); } 
BgL_test3166z00_4796 = 
(BgL_n1z00_2639>=((long)0)); } 
if(BgL_test3166z00_4796)
{ 
long BgL_auxz00_4806;
{ /* Llib/json.scm 168 */
obj_t BgL_tmpz00_4807;
if(
INTEGERP(BgL_index1094z00_1221))
{ /* Llib/json.scm 168 */
BgL_tmpz00_4807 = BgL_index1094z00_1221
; }  else 
{ 
obj_t BgL_auxz00_4810;
BgL_auxz00_4810 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2912z00zz__web_jsonz00, 
BINT(((long)6153)), BGl_string2913z00zz__web_jsonz00, BGl_string2914z00zz__web_jsonz00, BgL_index1094z00_1221); 
FAILURE(BgL_auxz00_4810,BFALSE,BFALSE);} 
BgL_auxz00_4806 = 
(long)CINT(BgL_tmpz00_4807); } 
BgL_parsezd2errorzd2_1193 = 
VECTOR_REF(BgL_opt1081z00_18,BgL_auxz00_4806); }  else 
{ /* Llib/json.scm 168 */BFALSE; } } } 
{ /* Llib/json.scm 168 */
obj_t BgL_index1095z00_1223;
BgL_index1095z00_1223 = 
BGl_search1083ze70ze7zz__web_jsonz00(
VECTOR_LENGTH(BgL_opt1081z00_18), BgL_opt1081z00_18, 
CNST_TABLE_REF(((long)27)), ((long)1)); 
{ /* Llib/json.scm 168 */
bool_t BgL_test3169z00_4819;
{ /* Llib/json.scm 168 */
long BgL_n1z00_2641;
{ /* Llib/json.scm 168 */
obj_t BgL_tmpz00_4820;
if(
INTEGERP(BgL_index1095z00_1223))
{ /* Llib/json.scm 168 */
BgL_tmpz00_4820 = BgL_index1095z00_1223
; }  else 
{ 
obj_t BgL_auxz00_4823;
BgL_auxz00_4823 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2912z00zz__web_jsonz00, 
BINT(((long)6153)), BGl_string2913z00zz__web_jsonz00, BGl_string2914z00zz__web_jsonz00, BgL_index1095z00_1223); 
FAILURE(BgL_auxz00_4823,BFALSE,BFALSE);} 
BgL_n1z00_2641 = 
(long)CINT(BgL_tmpz00_4820); } 
BgL_test3169z00_4819 = 
(BgL_n1z00_2641>=((long)0)); } 
if(BgL_test3169z00_4819)
{ 
long BgL_auxz00_4829;
{ /* Llib/json.scm 168 */
obj_t BgL_tmpz00_4830;
if(
INTEGERP(BgL_index1095z00_1223))
{ /* Llib/json.scm 168 */
BgL_tmpz00_4830 = BgL_index1095z00_1223
; }  else 
{ 
obj_t BgL_auxz00_4833;
BgL_auxz00_4833 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2912z00zz__web_jsonz00, 
BINT(((long)6153)), BGl_string2913z00zz__web_jsonz00, BGl_string2914z00zz__web_jsonz00, BgL_index1095z00_1223); 
FAILURE(BgL_auxz00_4833,BFALSE,BFALSE);} 
BgL_auxz00_4829 = 
(long)CINT(BgL_tmpz00_4830); } 
BgL_reviverz00_1194 = 
VECTOR_REF(BgL_opt1081z00_18,BgL_auxz00_4829); }  else 
{ /* Llib/json.scm 168 */BFALSE; } } } 
{ /* Llib/json.scm 168 */
obj_t BgL_index1096z00_1225;
BgL_index1096z00_1225 = 
BGl_search1083ze70ze7zz__web_jsonz00(
VECTOR_LENGTH(BgL_opt1081z00_18), BgL_opt1081z00_18, 
CNST_TABLE_REF(((long)28)), ((long)1)); 
{ /* Llib/json.scm 168 */
bool_t BgL_test3172z00_4842;
{ /* Llib/json.scm 168 */
long BgL_n1z00_2643;
{ /* Llib/json.scm 168 */
obj_t BgL_tmpz00_4843;
if(
INTEGERP(BgL_index1096z00_1225))
{ /* Llib/json.scm 168 */
BgL_tmpz00_4843 = BgL_index1096z00_1225
; }  else 
{ 
obj_t BgL_auxz00_4846;
BgL_auxz00_4846 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2912z00zz__web_jsonz00, 
BINT(((long)6153)), BGl_string2913z00zz__web_jsonz00, BGl_string2914z00zz__web_jsonz00, BgL_index1096z00_1225); 
FAILURE(BgL_auxz00_4846,BFALSE,BFALSE);} 
BgL_n1z00_2643 = 
(long)CINT(BgL_tmpz00_4843); } 
BgL_test3172z00_4842 = 
(BgL_n1z00_2643>=((long)0)); } 
if(BgL_test3172z00_4842)
{ 
long BgL_auxz00_4852;
{ /* Llib/json.scm 168 */
obj_t BgL_tmpz00_4853;
if(
INTEGERP(BgL_index1096z00_1225))
{ /* Llib/json.scm 168 */
BgL_tmpz00_4853 = BgL_index1096z00_1225
; }  else 
{ 
obj_t BgL_auxz00_4856;
BgL_auxz00_4856 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2912z00zz__web_jsonz00, 
BINT(((long)6153)), BGl_string2913z00zz__web_jsonz00, BGl_string2914z00zz__web_jsonz00, BgL_index1096z00_1225); 
FAILURE(BgL_auxz00_4856,BFALSE,BFALSE);} 
BgL_auxz00_4852 = 
(long)CINT(BgL_tmpz00_4853); } 
BgL_stringzd2alloczd2_1195 = 
VECTOR_REF(BgL_opt1081z00_18,BgL_auxz00_4852); }  else 
{ /* Llib/json.scm 168 */BFALSE; } } } 
{ /* Llib/json.scm 168 */
obj_t BgL_index1097z00_1227;
BgL_index1097z00_1227 = 
BGl_search1083ze70ze7zz__web_jsonz00(
VECTOR_LENGTH(BgL_opt1081z00_18), BgL_opt1081z00_18, 
CNST_TABLE_REF(((long)29)), ((long)1)); 
{ /* Llib/json.scm 168 */
bool_t BgL_test3175z00_4865;
{ /* Llib/json.scm 168 */
long BgL_n1z00_2645;
{ /* Llib/json.scm 168 */
obj_t BgL_tmpz00_4866;
if(
INTEGERP(BgL_index1097z00_1227))
{ /* Llib/json.scm 168 */
BgL_tmpz00_4866 = BgL_index1097z00_1227
; }  else 
{ 
obj_t BgL_auxz00_4869;
BgL_auxz00_4869 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2912z00zz__web_jsonz00, 
BINT(((long)6153)), BGl_string2913z00zz__web_jsonz00, BGl_string2914z00zz__web_jsonz00, BgL_index1097z00_1227); 
FAILURE(BgL_auxz00_4869,BFALSE,BFALSE);} 
BgL_n1z00_2645 = 
(long)CINT(BgL_tmpz00_4866); } 
BgL_test3175z00_4865 = 
(BgL_n1z00_2645>=((long)0)); } 
if(BgL_test3175z00_4865)
{ 
long BgL_auxz00_4875;
{ /* Llib/json.scm 168 */
obj_t BgL_tmpz00_4876;
if(
INTEGERP(BgL_index1097z00_1227))
{ /* Llib/json.scm 168 */
BgL_tmpz00_4876 = BgL_index1097z00_1227
; }  else 
{ 
obj_t BgL_auxz00_4879;
BgL_auxz00_4879 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2912z00zz__web_jsonz00, 
BINT(((long)6153)), BGl_string2913z00zz__web_jsonz00, BGl_string2914z00zz__web_jsonz00, BgL_index1097z00_1227); 
FAILURE(BgL_auxz00_4879,BFALSE,BFALSE);} 
BgL_auxz00_4875 = 
(long)CINT(BgL_tmpz00_4876); } 
BgL_undefinedz00_1196 = 
VECTOR_REF(BgL_opt1081z00_18,BgL_auxz00_4875); }  else 
{ /* Llib/json.scm 168 */BFALSE; } } } 
{ /* Llib/json.scm 168 */
obj_t BgL_arg2183z00_1229;
BgL_arg2183z00_1229 = 
VECTOR_REF(BgL_opt1081z00_18,((long)0)); 
{ /* Llib/json.scm 168 */
obj_t BgL_arrayzd2alloczd2_1230;
BgL_arrayzd2alloczd2_1230 = BgL_arrayzd2alloczd2_1185; 
{ /* Llib/json.scm 168 */
obj_t BgL_arrayzd2returnzd2_1231;
BgL_arrayzd2returnzd2_1231 = BgL_arrayzd2returnzd2_1186; 
{ /* Llib/json.scm 168 */
obj_t BgL_arrayzd2setzd2_1232;
BgL_arrayzd2setzd2_1232 = BgL_arrayzd2setzd2_1187; 
{ /* Llib/json.scm 168 */
obj_t BgL_constantzd2alloczd2_1233;
BgL_constantzd2alloczd2_1233 = BgL_constantzd2alloczd2_1188; 
{ /* Llib/json.scm 168 */
obj_t BgL_exprz00_1234;
BgL_exprz00_1234 = BgL_exprz00_1189; 
{ /* Llib/json.scm 168 */
obj_t BgL_objectzd2alloczd2_1235;
BgL_objectzd2alloczd2_1235 = BgL_objectzd2alloczd2_1190; 
{ /* Llib/json.scm 168 */
obj_t BgL_objectzd2returnzd2_1236;
BgL_objectzd2returnzd2_1236 = BgL_objectzd2returnzd2_1191; 
{ /* Llib/json.scm 168 */
obj_t BgL_objectzd2setzd2_1237;
BgL_objectzd2setzd2_1237 = BgL_objectzd2setzd2_1192; 
{ /* Llib/json.scm 168 */
obj_t BgL_parsezd2errorzd2_1238;
BgL_parsezd2errorzd2_1238 = BgL_parsezd2errorzd2_1193; 
{ /* Llib/json.scm 168 */
obj_t BgL_reviverz00_1239;
BgL_reviverz00_1239 = BgL_reviverz00_1194; 
{ /* Llib/json.scm 168 */
obj_t BgL_stringzd2alloczd2_1240;
BgL_stringzd2alloczd2_1240 = BgL_stringzd2alloczd2_1195; 
{ /* Llib/json.scm 168 */
obj_t BgL_undefinedz00_1241;
BgL_undefinedz00_1241 = BgL_undefinedz00_1196; 
{ /* Llib/json.scm 168 */
obj_t BgL_auxz00_4886;
if(
INPUT_PORTP(BgL_arg2183z00_1229))
{ /* Llib/json.scm 168 */
BgL_auxz00_4886 = BgL_arg2183z00_1229
; }  else 
{ 
obj_t BgL_auxz00_4889;
BgL_auxz00_4889 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2912z00zz__web_jsonz00, 
BINT(((long)6153)), BGl_string2913z00zz__web_jsonz00, BGl_string2915z00zz__web_jsonz00, BgL_arg2183z00_1229); 
FAILURE(BgL_auxz00_4889,BFALSE,BFALSE);} 
return 
BGl_jsonzd2parsezd2zz__web_jsonz00(BgL_auxz00_4886, BgL_arrayzd2alloczd2_1230, BgL_arrayzd2returnzd2_1231, BgL_arrayzd2setzd2_1232, BgL_constantzd2alloczd2_1233, BgL_exprz00_1234, BgL_objectzd2alloczd2_1235, BgL_objectzd2returnzd2_1236, BgL_objectzd2setzd2_1237, BgL_parsezd2errorzd2_1238, BgL_reviverz00_1239, BgL_stringzd2alloczd2_1240, BgL_undefinedz00_1241);} } } } } } } } } } } } } } } } } } } } } } } } } } } } } 

}



/* search1083~0 */
obj_t BGl_search1083ze70ze7zz__web_jsonz00(long BgL_l1082z00_2805, obj_t BgL_opt1081z00_2804, obj_t BgL_k1z00_1181, long BgL_iz00_1182)
{
{ /* Llib/json.scm 168 */
BGl_search1083ze70ze7zz__web_jsonz00:
if(
(BgL_iz00_1182==BgL_l1082z00_2805))
{ /* Llib/json.scm 168 */
return 
BINT(((long)-1));}  else 
{ /* Llib/json.scm 168 */
if(
(BgL_iz00_1182==
(BgL_l1082z00_2805-((long)1))))
{ /* Llib/json.scm 168 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)17)), BGl_string2916z00zz__web_jsonz00, 
BINT(
VECTOR_LENGTH(BgL_opt1081z00_2804)));}  else 
{ /* Llib/json.scm 168 */
obj_t BgL_vz00_1246;
BgL_vz00_1246 = 
VECTOR_REF(BgL_opt1081z00_2804,BgL_iz00_1182); 
if(
(BgL_vz00_1246==BgL_k1z00_1181))
{ /* Llib/json.scm 168 */
return 
BINT(
(BgL_iz00_1182+((long)1)));}  else 
{ 
long BgL_iz00_4909;
BgL_iz00_4909 = 
(BgL_iz00_1182+((long)2)); 
BgL_iz00_1182 = BgL_iz00_4909; 
goto BGl_search1083ze70ze7zz__web_jsonz00;} } } } 

}



/* json-parse */
BGL_EXPORTED_DEF obj_t BGl_jsonzd2parsezd2zz__web_jsonz00(obj_t BgL_oz00_5, obj_t BgL_arrayzd2alloczd2_6, obj_t BgL_arrayzd2returnzd2_7, obj_t BgL_arrayzd2setzd2_8, obj_t BgL_constantzd2alloczd2_9, obj_t BgL_exprz00_10, obj_t BgL_objectzd2alloczd2_11, obj_t BgL_objectzd2returnzd2_12, obj_t BgL_objectzd2setzd2_13, obj_t BgL_parsezd2errorzd2_14, obj_t BgL_reviverz00_15, obj_t BgL_stringzd2alloczd2_16, obj_t BgL_undefinedz00_17)
{
{ /* Llib/json.scm 168 */
{ /* Llib/json.scm 20 */
obj_t BgL_lastzd2tokenzd2_2802;
BgL_lastzd2tokenzd2_2802 = 
MAKE_CELL(BFALSE); 
{ /* Llib/json.scm 180 */
obj_t BgL_cnstzd2alloczd2_1252;obj_t BgL_strzd2alloczd2_1253;
{ /* Llib/json.scm 185 */
bool_t BgL_test3182z00_4911;
if(
PROCEDUREP(BgL_constantzd2alloczd2_9))
{ /* Llib/json.scm 185 */
BgL_test3182z00_4911 = 
PROCEDURE_CORRECT_ARITYP(BgL_constantzd2alloczd2_9, 
(int)(((long)1)))
; }  else 
{ /* Llib/json.scm 185 */
BgL_test3182z00_4911 = ((bool_t)0)
; } 
if(BgL_test3182z00_4911)
{ /* Llib/json.scm 185 */
BgL_cnstzd2alloczd2_1252 = BgL_constantzd2alloczd2_9; }  else 
{ /* Llib/json.scm 185 */
BgL_cnstzd2alloczd2_1252 = BGl_proc2917z00zz__web_jsonz00; } } 
{ /* Llib/json.scm 190 */
bool_t BgL_test3184z00_4916;
if(
PROCEDUREP(BgL_stringzd2alloczd2_16))
{ /* Llib/json.scm 190 */
BgL_test3184z00_4916 = 
PROCEDURE_CORRECT_ARITYP(BgL_stringzd2alloczd2_16, 
(int)(((long)1)))
; }  else 
{ /* Llib/json.scm 190 */
BgL_test3184z00_4916 = ((bool_t)0)
; } 
if(BgL_test3184z00_4916)
{ /* Llib/json.scm 190 */
BgL_strzd2alloczd2_1253 = BgL_stringzd2alloczd2_16; }  else 
{ /* Llib/json.scm 190 */
BgL_strzd2alloczd2_1253 = BGl_proc2918z00zz__web_jsonz00; } } 
BGl_checkzd2procedureze70z35zz__web_jsonz00(BgL_arrayzd2alloczd2_6, ((long)0), 
CNST_TABLE_REF(((long)18))); 
BGl_checkzd2procedureze70z35zz__web_jsonz00(BgL_arrayzd2setzd2_8, ((long)3), 
CNST_TABLE_REF(((long)20))); 
BGl_checkzd2procedureze70z35zz__web_jsonz00(BgL_arrayzd2returnzd2_7, ((long)2), 
CNST_TABLE_REF(((long)19))); 
BGl_checkzd2procedureze70z35zz__web_jsonz00(BgL_objectzd2alloczd2_11, ((long)0), 
CNST_TABLE_REF(((long)23))); 
BGl_checkzd2procedureze70z35zz__web_jsonz00(BgL_objectzd2setzd2_13, ((long)3), 
CNST_TABLE_REF(((long)25))); 
BGl_checkzd2procedureze70z35zz__web_jsonz00(BgL_objectzd2returnzd2_12, ((long)1), 
CNST_TABLE_REF(((long)24))); 
BGl_checkzd2procedureze70z35zz__web_jsonz00(BgL_parsezd2errorzd2_14, ((long)3), 
CNST_TABLE_REF(((long)26))); 
if(
CBOOL(BgL_reviverz00_15))
{ /* Llib/json.scm 280 */
BGl_checkzd2procedureze70z35zz__web_jsonz00(BgL_reviverz00_15, ((long)3), 
CNST_TABLE_REF(((long)27))); }  else 
{ /* Llib/json.scm 280 */BFALSE; } 
{ /* Llib/json.scm 282 */
obj_t BgL_valz00_1260;
BgL_valz00_1260 = 
BGl_parsezd2textze70z35zz__web_jsonz00(BgL_arrayzd2alloczd2_6, BgL_objectzd2alloczd2_11, BgL_arrayzd2returnzd2_7, BgL_parsezd2errorzd2_14, BgL_arrayzd2setzd2_8, BgL_reviverz00_15, BgL_objectzd2setzd2_13, BgL_objectzd2returnzd2_12, BgL_lastzd2tokenzd2_2802, BgL_strzd2alloczd2_1253, BgL_cnstzd2alloczd2_1252, BgL_undefinedz00_17, BgL_oz00_5, BFALSE); 
if(
CBOOL(BgL_exprz00_10))
{ /* Llib/json.scm 283 */BFALSE; }  else 
{ /* Llib/json.scm 284 */
obj_t BgL_tokenz00_1261;
BgL_tokenz00_1261 = 
BGl_parsezd2textze70z35zz__web_jsonz00(BgL_arrayzd2alloczd2_6, BgL_objectzd2alloczd2_11, BgL_arrayzd2returnzd2_7, BgL_parsezd2errorzd2_14, BgL_arrayzd2setzd2_8, BgL_reviverz00_15, BgL_objectzd2setzd2_13, BgL_objectzd2returnzd2_12, BgL_lastzd2tokenzd2_2802, BgL_strzd2alloczd2_1253, BgL_cnstzd2alloczd2_1252, BgL_undefinedz00_17, BgL_oz00_5, 
CNST_TABLE_REF(((long)0))); 
if(
(BgL_tokenz00_1261==BGl_za2eotza2z00zz__web_jsonz00))
{ /* Llib/json.scm 285 */BFALSE; }  else 
{ /* Llib/json.scm 285 */
if(
PAIRP(BgL_tokenz00_1261))
{ /* Llib/json.scm 288 */
obj_t BgL_arg2193z00_1264;obj_t BgL_arg2194z00_1265;obj_t BgL_arg2195z00_1266;
{ /* Llib/json.scm 288 */
obj_t BgL_arg2196z00_1267;obj_t BgL_arg2197z00_1268;
BgL_arg2196z00_1267 = 
CAR(BgL_tokenz00_1261); 
BgL_arg2197z00_1268 = 
CAR(
CDR(BgL_tokenz00_1261)); 
{ /* Llib/json.scm 287 */
obj_t BgL_list2198z00_1269;
{ /* Llib/json.scm 287 */
obj_t BgL_arg2199z00_1270;
BgL_arg2199z00_1270 = 
MAKE_YOUNG_PAIR(BgL_arg2197z00_1268, BNIL); 
BgL_list2198z00_1269 = 
MAKE_YOUNG_PAIR(BgL_arg2196z00_1267, BgL_arg2199z00_1270); } 
BgL_arg2193z00_1264 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string2919z00zz__web_jsonz00, BgL_list2198z00_1269); } } 
{ /* Llib/json.scm 289 */
obj_t BgL_pairz00_2760;
BgL_pairz00_2760 = 
CELL_REF(BgL_lastzd2tokenzd2_2802); 
BgL_arg2194z00_1265 = 
CAR(
CDR(BgL_pairz00_2760)); } 
{ /* Llib/json.scm 289 */
obj_t BgL_pairz00_2764;
BgL_pairz00_2764 = 
CELL_REF(BgL_lastzd2tokenzd2_2802); 
BgL_arg2195z00_1266 = 
CAR(
CDR(
CDR(BgL_pairz00_2764))); } 
PROCEDURE_ENTRY(BgL_parsezd2errorzd2_14)(BgL_parsezd2errorzd2_14, BgL_arg2193z00_1264, BgL_arg2194z00_1265, BgL_arg2195z00_1266, BEOA); }  else 
{ /* Llib/json.scm 290 */
obj_t BgL_arg2200z00_1271;
{ /* Llib/json.scm 290 */
obj_t BgL_list2201z00_1272;
BgL_list2201z00_1272 = 
MAKE_YOUNG_PAIR(BgL_tokenz00_1261, BNIL); 
BgL_arg2200z00_1271 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string2920z00zz__web_jsonz00, BgL_list2201z00_1272); } 
PROCEDURE_ENTRY(BgL_parsezd2errorzd2_14)(BgL_parsezd2errorzd2_14, BgL_arg2200z00_1271, BFALSE, BFALSE, BEOA); } } } 
return BgL_valz00_1260;} } } } 

}



/* read-token~0 */
obj_t BGl_readzd2tokenze70z35zz__web_jsonz00(obj_t BgL_lastzd2tokenzd2_2786, obj_t BgL_strzd2alloczd2_2785, obj_t BgL_cnstzd2alloczd2_2784, obj_t BgL_undefinedz00_2783, obj_t BgL_oz00_2782)
{
{ /* Llib/json.scm 197 */
{ /* Llib/json.scm 195 */
obj_t BgL_tz00_1274;
BgL_tz00_1274 = 
BGl_z62zc3z04anonymousza31098ze3ze5zz__web_jsonz00(BGl_za2jsonzd2lexerza2zd2zz__web_jsonz00, BgL_oz00_2782, BgL_undefinedz00_2783, BgL_cnstzd2alloczd2_2784, BgL_strzd2alloczd2_2785); 
CELL_SET(BgL_lastzd2tokenzd2_2786, BgL_tz00_1274); 
return BgL_tz00_1274;} } 

}



/* parse-token-error~0 */
obj_t BGl_parsezd2tokenzd2errorze70ze7zz__web_jsonz00(obj_t BgL_parsezd2errorzd2_2788, obj_t BgL_tokenz00_1361)
{
{ /* Llib/json.scm 214 */
if(
(
CAR(
((obj_t)BgL_tokenz00_1361))==
CNST_TABLE_REF(((long)1))))
{ /* Llib/json.scm 210 */
obj_t BgL_arg2252z00_1365;obj_t BgL_arg2253z00_1366;obj_t BgL_arg2254z00_1367;
{ /* Llib/json.scm 210 */
obj_t BgL_arg2255z00_1368;
{ /* Llib/json.scm 210 */
obj_t BgL_pairz00_2661;
BgL_pairz00_2661 = 
CDR(
((obj_t)BgL_tokenz00_1361)); 
BgL_arg2255z00_1368 = 
CAR(BgL_pairz00_2661); } 
{ /* Llib/json.scm 210 */
obj_t BgL_list2256z00_1369;
BgL_list2256z00_1369 = 
MAKE_YOUNG_PAIR(BgL_arg2255z00_1368, BNIL); 
BgL_arg2252z00_1365 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string2921z00zz__web_jsonz00, BgL_list2256z00_1369); } } 
{ /* Llib/json.scm 211 */
obj_t BgL_pairz00_2667;
{ /* Llib/json.scm 211 */
obj_t BgL_pairz00_2666;
BgL_pairz00_2666 = 
CDR(
((obj_t)BgL_tokenz00_1361)); 
BgL_pairz00_2667 = 
CDR(BgL_pairz00_2666); } 
BgL_arg2253z00_1366 = 
CAR(BgL_pairz00_2667); } 
{ /* Llib/json.scm 211 */
obj_t BgL_pairz00_2675;
{ /* Llib/json.scm 211 */
obj_t BgL_pairz00_2674;
{ /* Llib/json.scm 211 */
obj_t BgL_pairz00_2673;
BgL_pairz00_2673 = 
CDR(
((obj_t)BgL_tokenz00_1361)); 
BgL_pairz00_2674 = 
CDR(BgL_pairz00_2673); } 
BgL_pairz00_2675 = 
CDR(BgL_pairz00_2674); } 
BgL_arg2254z00_1367 = 
CAR(BgL_pairz00_2675); } 
return 
PROCEDURE_ENTRY(BgL_parsezd2errorzd2_2788)(BgL_parsezd2errorzd2_2788, BgL_arg2252z00_1365, BgL_arg2253z00_1366, BgL_arg2254z00_1367, BEOA);}  else 
{ /* Llib/json.scm 213 */
obj_t BgL_arg2257z00_1370;obj_t BgL_arg2258z00_1371;obj_t BgL_arg2259z00_1372;
{ /* Llib/json.scm 213 */
obj_t BgL_arg2260z00_1373;obj_t BgL_arg2261z00_1374;
BgL_arg2260z00_1373 = 
CAR(
((obj_t)BgL_tokenz00_1361)); 
{ /* Llib/json.scm 213 */
obj_t BgL_pairz00_2680;
BgL_pairz00_2680 = 
CDR(
((obj_t)BgL_tokenz00_1361)); 
BgL_arg2261z00_1374 = 
CAR(BgL_pairz00_2680); } 
{ /* Llib/json.scm 213 */
obj_t BgL_list2262z00_1375;
{ /* Llib/json.scm 213 */
obj_t BgL_arg2263z00_1376;
BgL_arg2263z00_1376 = 
MAKE_YOUNG_PAIR(BgL_arg2261z00_1374, BNIL); 
BgL_list2262z00_1375 = 
MAKE_YOUNG_PAIR(BgL_arg2260z00_1373, BgL_arg2263z00_1376); } 
BgL_arg2257z00_1370 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string2922z00zz__web_jsonz00, BgL_list2262z00_1375); } } 
{ /* Llib/json.scm 214 */
obj_t BgL_pairz00_2686;
{ /* Llib/json.scm 214 */
obj_t BgL_pairz00_2685;
BgL_pairz00_2685 = 
CDR(
((obj_t)BgL_tokenz00_1361)); 
BgL_pairz00_2686 = 
CDR(BgL_pairz00_2685); } 
BgL_arg2258z00_1371 = 
CAR(BgL_pairz00_2686); } 
{ /* Llib/json.scm 214 */
obj_t BgL_pairz00_2694;
{ /* Llib/json.scm 214 */
obj_t BgL_pairz00_2693;
{ /* Llib/json.scm 214 */
obj_t BgL_pairz00_2692;
BgL_pairz00_2692 = 
CDR(
((obj_t)BgL_tokenz00_1361)); 
BgL_pairz00_2693 = 
CDR(BgL_pairz00_2692); } 
BgL_pairz00_2694 = 
CDR(BgL_pairz00_2693); } 
BgL_arg2259z00_1372 = 
CAR(BgL_pairz00_2694); } 
return 
PROCEDURE_ENTRY(BgL_parsezd2errorzd2_2788)(BgL_parsezd2errorzd2_2788, BgL_arg2257z00_1370, BgL_arg2258z00_1371, BgL_arg2259z00_1372, BEOA);} } 

}



/* check-procedure~0 */
obj_t BGl_checkzd2procedureze70z35zz__web_jsonz00(obj_t BgL_procz00_1337, long BgL_arityz00_1338, obj_t BgL_namez00_1339)
{
{ /* Llib/json.scm 180 */
{ /* Llib/json.scm 175 */
bool_t BgL_test3191z00_5028;
if(
PROCEDUREP(BgL_procz00_1337))
{ /* Llib/json.scm 175 */
BgL_test3191z00_5028 = 
PROCEDURE_CORRECT_ARITYP(BgL_procz00_1337, 
(int)(BgL_arityz00_1338))
; }  else 
{ /* Llib/json.scm 175 */
BgL_test3191z00_5028 = ((bool_t)0)
; } 
if(BgL_test3191z00_5028)
{ /* Llib/json.scm 175 */
return BFALSE;}  else 
{ /* Llib/json.scm 177 */
BgL_z62errorz62_bglt BgL_arg2238z00_1343;
{ /* Llib/json.scm 177 */
BgL_z62errorz62_bglt BgL_new1074z00_1344;
{ /* Llib/json.scm 177 */
BgL_z62errorz62_bglt BgL_new1073z00_1348;
BgL_new1073z00_1348 = 
((BgL_z62errorz62_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62errorz62_bgl) ))); 
{ /* Llib/json.scm 177 */
long BgL_arg2242z00_1349;
{ /* Llib/json.scm 177 */
long BgL_res2844z00_2651;
BgL_res2844z00_2651 = 
BGL_CLASS_INDEX(BGl_z62errorz62zz__objectz00); 
BgL_arg2242z00_1349 = BgL_res2844z00_2651; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1073z00_1348), BgL_arg2242z00_1349); } 
BgL_new1074z00_1344 = BgL_new1073z00_1348; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1074z00_1344)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1074z00_1344)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_5041;
{ /* Llib/json.scm 177 */
obj_t BgL_arg2239z00_1345;
{ /* Llib/json.scm 177 */
obj_t BgL_arg2240z00_1346;
{ /* Llib/json.scm 177 */
obj_t BgL_res2845z00_2655;
{ /* Llib/json.scm 177 */
obj_t BgL_classz00_2654;
BgL_classz00_2654 = BGl_z62errorz62zz__objectz00; 
BgL_res2845z00_2655 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_2654); } 
BgL_arg2240z00_1346 = BgL_res2845z00_2655; } 
BgL_arg2239z00_1345 = 
VECTOR_REF(BgL_arg2240z00_1346,((long)2)); } 
BgL_auxz00_5041 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg2239z00_1345); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1074z00_1344)))->BgL_stackz00)=((obj_t)BgL_auxz00_5041),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(BgL_new1074z00_1344))->BgL_procz00)=((obj_t)BGl_string2923z00zz__web_jsonz00),BUNSPEC); 
{ 
obj_t BgL_auxz00_5048;
{ /* Llib/json.scm 179 */
obj_t BgL_list2241z00_1347;
BgL_list2241z00_1347 = 
MAKE_YOUNG_PAIR(BgL_namez00_1339, BNIL); 
BgL_auxz00_5048 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string2924z00zz__web_jsonz00, BgL_list2241z00_1347); } 
((((BgL_z62errorz62_bglt)COBJECT(BgL_new1074z00_1344))->BgL_msgz00)=((obj_t)BgL_auxz00_5048),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(BgL_new1074z00_1344))->BgL_objz00)=((obj_t)BgL_procz00_1337),BUNSPEC); 
BgL_arg2238z00_1343 = BgL_new1074z00_1344; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg2238z00_1343));} } } 

}



/* parse-text~0 */
obj_t BGl_parsezd2textze70z35zz__web_jsonz00(obj_t BgL_arrayzd2alloczd2_2801, obj_t BgL_objectzd2alloczd2_2800, obj_t BgL_arrayzd2returnzd2_2799, obj_t BgL_parsezd2errorzd2_2798, obj_t BgL_arrayzd2setzd2_2797, obj_t BgL_reviverz00_2796, obj_t BgL_objectzd2setzd2_2795, obj_t BgL_objectzd2returnzd2_2794, obj_t BgL_lastzd2tokenzd2_2793, obj_t BgL_strzd2alloczd2_2792, obj_t BgL_cnstzd2alloczd2_2791, obj_t BgL_undefinedz00_2790, obj_t BgL_oz00_2789, obj_t BgL_endz00_1314)
{
{ /* Llib/json.scm 271 */
{ 
obj_t BgL_typez00_1275;obj_t BgL_arrayz00_1285;obj_t BgL_objectz00_1301;
{ 

{ /* Llib/json.scm 258 */
obj_t BgL_tokenz00_1318;
BgL_tokenz00_1318 = 
BGl_readzd2tokenze70z35zz__web_jsonz00(BgL_lastzd2tokenzd2_2793, BgL_strzd2alloczd2_2792, BgL_cnstzd2alloczd2_2791, BgL_undefinedz00_2790, BgL_oz00_2789); 
{ /* Llib/json.scm 259 */
obj_t BgL_casezd2valuezd2_1319;
BgL_casezd2valuezd2_1319 = 
CAR(
((obj_t)BgL_tokenz00_1318)); 
if(
(BgL_casezd2valuezd2_1319==
CNST_TABLE_REF(((long)13))))
{ /* Llib/json.scm 261 */
obj_t BgL_arg2227z00_1321;
BgL_arg2227z00_1321 = 
PROCEDURE_ENTRY(BgL_arrayzd2alloczd2_2801)(BgL_arrayzd2alloczd2_2801, BEOA); 
BgL_arrayz00_1285 = BgL_arg2227z00_1321; 
{ /* Llib/json.scm 217 */
obj_t BgL_valz00_1287;
BgL_valz00_1287 = 
BGl_parsezd2textze70z35zz__web_jsonz00(BgL_arrayzd2alloczd2_2801, BgL_objectzd2alloczd2_2800, BgL_arrayzd2returnzd2_2799, BgL_parsezd2errorzd2_2798, BgL_arrayzd2setzd2_2797, BgL_reviverz00_2796, BgL_objectzd2setzd2_2795, BgL_objectzd2returnzd2_2794, BgL_lastzd2tokenzd2_2793, BgL_strzd2alloczd2_2792, BgL_cnstzd2alloczd2_2791, BgL_undefinedz00_2790, BgL_oz00_2789, 
CNST_TABLE_REF(((long)12))); 
if(
(BgL_valz00_1287==BGl_za2eotza2z00zz__web_jsonz00))
{ /* Llib/json.scm 218 */
return 
PROCEDURE_ENTRY(BgL_arrayzd2returnzd2_2799)(BgL_arrayzd2returnzd2_2799, BgL_arrayz00_1285, 
BINT(((long)0)), BEOA);}  else 
{ /* Llib/json.scm 218 */
PROCEDURE_ENTRY(BgL_arrayzd2setzd2_2797)(BgL_arrayzd2setzd2_2797, BgL_arrayz00_1285, 
BINT(((long)0)), BgL_valz00_1287, BEOA); 
{ 
long BgL_iz00_1290;
BgL_iz00_1290 = ((long)1); 
BgL_zc3z04anonymousza32213ze3z87_1291:
{ /* Llib/json.scm 223 */
obj_t BgL_tokenz00_1292;
BgL_tokenz00_1292 = 
BGl_readzd2tokenze70z35zz__web_jsonz00(BgL_lastzd2tokenzd2_2793, BgL_strzd2alloczd2_2792, BgL_cnstzd2alloczd2_2791, BgL_undefinedz00_2790, BgL_oz00_2789); 
{ /* Llib/json.scm 224 */
obj_t BgL_casezd2valuezd2_1293;
BgL_casezd2valuezd2_1293 = 
CAR(
((obj_t)BgL_tokenz00_1292)); 
if(
(BgL_casezd2valuezd2_1293==
CNST_TABLE_REF(((long)12))))
{ /* Llib/json.scm 224 */
return 
PROCEDURE_ENTRY(BgL_arrayzd2returnzd2_2799)(BgL_arrayzd2returnzd2_2799, BgL_arrayz00_1285, 
BINT(BgL_iz00_1290), BEOA);}  else 
{ /* Llib/json.scm 224 */
if(
(BgL_casezd2valuezd2_1293==
CNST_TABLE_REF(((long)15))))
{ /* Llib/json.scm 228 */
obj_t BgL_valz00_1296;
BgL_valz00_1296 = 
BGl_parsezd2textze70z35zz__web_jsonz00(BgL_arrayzd2alloczd2_2801, BgL_objectzd2alloczd2_2800, BgL_arrayzd2returnzd2_2799, BgL_parsezd2errorzd2_2798, BgL_arrayzd2setzd2_2797, BgL_reviverz00_2796, BgL_objectzd2setzd2_2795, BgL_objectzd2returnzd2_2794, BgL_lastzd2tokenzd2_2793, BgL_strzd2alloczd2_2792, BgL_cnstzd2alloczd2_2791, BgL_undefinedz00_2790, BgL_oz00_2789, BFALSE); 
PROCEDURE_ENTRY(BgL_arrayzd2setzd2_2797)(BgL_arrayzd2setzd2_2797, BgL_arrayz00_1285, 
BINT(BgL_iz00_1290), BgL_valz00_1296, BEOA); 
{ 
long BgL_iz00_5104;
BgL_iz00_5104 = 
(BgL_iz00_1290+((long)1)); 
BgL_iz00_1290 = BgL_iz00_5104; 
goto BgL_zc3z04anonymousza32213ze3z87_1291;} }  else 
{ /* Llib/json.scm 233 */
obj_t BgL_arg2217z00_1298;obj_t BgL_arg2218z00_1299;
{ /* Llib/json.scm 233 */
obj_t BgL_pairz00_2722;
{ /* Llib/json.scm 233 */
obj_t BgL_pairz00_2721;
BgL_pairz00_2721 = 
CDR(
((obj_t)BgL_tokenz00_1292)); 
BgL_pairz00_2722 = 
CDR(BgL_pairz00_2721); } 
BgL_arg2217z00_1298 = 
CAR(BgL_pairz00_2722); } 
{ /* Llib/json.scm 233 */
obj_t BgL_pairz00_2730;
{ /* Llib/json.scm 233 */
obj_t BgL_pairz00_2729;
{ /* Llib/json.scm 233 */
obj_t BgL_pairz00_2728;
BgL_pairz00_2728 = 
CDR(
((obj_t)BgL_tokenz00_1292)); 
BgL_pairz00_2729 = 
CDR(BgL_pairz00_2728); } 
BgL_pairz00_2730 = 
CDR(BgL_pairz00_2729); } 
BgL_arg2218z00_1299 = 
CAR(BgL_pairz00_2730); } 
return 
PROCEDURE_ENTRY(BgL_parsezd2errorzd2_2798)(BgL_parsezd2errorzd2_2798, BGl_string2925z00zz__web_jsonz00, BgL_arg2217z00_1298, BgL_arg2218z00_1299, BEOA);} } } } } } } }  else 
{ /* Llib/json.scm 259 */
if(
(BgL_casezd2valuezd2_1319==
CNST_TABLE_REF(((long)9))))
{ /* Llib/json.scm 263 */
obj_t BgL_arg2229z00_1323;
BgL_arg2229z00_1323 = 
PROCEDURE_ENTRY(BgL_objectzd2alloczd2_2800)(BgL_objectzd2alloczd2_2800, BEOA); 
BgL_objectz00_1301 = BgL_arg2229z00_1323; 
{ 

BgL_zc3z04anonymousza32220ze3z87_1304:
{ /* Llib/json.scm 237 */
obj_t BgL_tokenz00_1305;
BgL_tokenz00_1305 = 
BGl_readzd2tokenze70z35zz__web_jsonz00(BgL_lastzd2tokenzd2_2793, BgL_strzd2alloczd2_2792, BgL_cnstzd2alloczd2_2791, BgL_undefinedz00_2790, BgL_oz00_2789); 
{ /* Llib/json.scm 238 */
obj_t BgL_casezd2valuezd2_1306;
BgL_casezd2valuezd2_1306 = 
CAR(
((obj_t)BgL_tokenz00_1305)); 
if(
(BgL_casezd2valuezd2_1306==
CNST_TABLE_REF(((long)7))))
{ /* Llib/json.scm 238 */
BgL_typez00_1275 = 
CNST_TABLE_REF(((long)14)); 
{ /* Llib/json.scm 200 */
obj_t BgL_tokenz00_1277;
BgL_tokenz00_1277 = 
BGl_readzd2tokenze70z35zz__web_jsonz00(BgL_lastzd2tokenzd2_2793, BgL_strzd2alloczd2_2792, BgL_cnstzd2alloczd2_2791, BgL_undefinedz00_2790, BgL_oz00_2789); 
if(
(
CAR(
((obj_t)BgL_tokenz00_1277))==BgL_typez00_1275))
{ /* Llib/json.scm 201 */BgL_tokenz00_1277; }  else 
{ /* Llib/json.scm 203 */
obj_t BgL_arg2206z00_1280;obj_t BgL_arg2207z00_1281;obj_t BgL_arg2208z00_1282;
{ /* Llib/json.scm 203 */
obj_t BgL_list2209z00_1283;
BgL_list2209z00_1283 = 
MAKE_YOUNG_PAIR(BgL_typez00_1275, BNIL); 
BgL_arg2206z00_1280 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string2926z00zz__web_jsonz00, BgL_list2209z00_1283); } 
{ /* Llib/json.scm 204 */
obj_t BgL_pairz00_2701;
{ /* Llib/json.scm 204 */
obj_t BgL_pairz00_2700;
BgL_pairz00_2700 = 
CDR(
((obj_t)BgL_tokenz00_1277)); 
BgL_pairz00_2701 = 
CDR(BgL_pairz00_2700); } 
BgL_arg2207z00_1281 = 
CAR(BgL_pairz00_2701); } 
{ /* Llib/json.scm 205 */
obj_t BgL_pairz00_2709;
{ /* Llib/json.scm 205 */
obj_t BgL_pairz00_2708;
{ /* Llib/json.scm 205 */
obj_t BgL_pairz00_2707;
BgL_pairz00_2707 = 
CDR(
((obj_t)BgL_tokenz00_1277)); 
BgL_pairz00_2708 = 
CDR(BgL_pairz00_2707); } 
BgL_pairz00_2709 = 
CDR(BgL_pairz00_2708); } 
BgL_arg2208z00_1282 = 
CAR(BgL_pairz00_2709); } 
PROCEDURE_ENTRY(BgL_parsezd2errorzd2_2798)(BgL_parsezd2errorzd2_2798, BgL_arg2206z00_1280, BgL_arg2207z00_1281, BgL_arg2208z00_1282, BEOA); } } 
{ /* Llib/json.scm 241 */
obj_t BgL_keyz00_1308;
{ /* Llib/json.scm 241 */
obj_t BgL_pairz00_2737;
BgL_pairz00_2737 = 
CDR(
((obj_t)BgL_tokenz00_1305)); 
BgL_keyz00_1308 = 
CAR(BgL_pairz00_2737); } 
{ /* Llib/json.scm 241 */
obj_t BgL_valz00_1309;
BgL_valz00_1309 = 
BGl_parsezd2textze70z35zz__web_jsonz00(BgL_arrayzd2alloczd2_2801, BgL_objectzd2alloczd2_2800, BgL_arrayzd2returnzd2_2799, BgL_parsezd2errorzd2_2798, BgL_arrayzd2setzd2_2797, BgL_reviverz00_2796, BgL_objectzd2setzd2_2795, BgL_objectzd2returnzd2_2794, BgL_lastzd2tokenzd2_2793, BgL_strzd2alloczd2_2792, BgL_cnstzd2alloczd2_2791, BgL_undefinedz00_2790, BgL_oz00_2789, BFALSE); 
{ /* Llib/json.scm 242 */

if(
CBOOL(BgL_reviverz00_2796))
{ /* Llib/json.scm 244 */
obj_t BgL_resz00_1310;
BgL_resz00_1310 = 
PROCEDURE_ENTRY(BgL_reviverz00_2796)(BgL_reviverz00_2796, BgL_objectz00_1301, BgL_keyz00_1308, BgL_valz00_1309, BEOA); 
if(
CBOOL(BgL_resz00_1310))
{ /* Llib/json.scm 245 */
PROCEDURE_ENTRY(BgL_objectzd2setzd2_2795)(BgL_objectzd2setzd2_2795, BgL_objectz00_1301, BgL_keyz00_1308, BgL_resz00_1310, BEOA); }  else 
{ /* Llib/json.scm 245 */BFALSE; } }  else 
{ /* Llib/json.scm 243 */
PROCEDURE_ENTRY(BgL_objectzd2setzd2_2795)(BgL_objectzd2setzd2_2795, BgL_objectz00_1301, BgL_keyz00_1308, BgL_valz00_1309, BEOA); } 
goto BgL_zc3z04anonymousza32220ze3z87_1304;} } } }  else 
{ /* Llib/json.scm 238 */
if(
(BgL_casezd2valuezd2_1306==
CNST_TABLE_REF(((long)15))))
{ /* Llib/json.scm 238 */
goto BgL_zc3z04anonymousza32220ze3z87_1304;}  else 
{ /* Llib/json.scm 238 */
if(
(BgL_casezd2valuezd2_1306==
CNST_TABLE_REF(((long)8))))
{ /* Llib/json.scm 238 */
return 
PROCEDURE_ENTRY(BgL_objectzd2returnzd2_2794)(BgL_objectzd2returnzd2_2794, BgL_objectz00_1301, BEOA);}  else 
{ /* Llib/json.scm 238 */
return 
BGl_parsezd2tokenzd2errorze70ze7zz__web_jsonz00(BgL_parsezd2errorzd2_2798, BgL_tokenz00_1305);} } } } } } }  else 
{ /* Llib/json.scm 259 */
bool_t BgL_test3204z00_5193;
{ /* Llib/json.scm 259 */
bool_t BgL__ortest_1079z00_1330;
BgL__ortest_1079z00_1330 = 
(BgL_casezd2valuezd2_1319==
CNST_TABLE_REF(((long)3))); 
if(BgL__ortest_1079z00_1330)
{ /* Llib/json.scm 259 */
BgL_test3204z00_5193 = BgL__ortest_1079z00_1330
; }  else 
{ /* Llib/json.scm 259 */
BgL_test3204z00_5193 = 
(BgL_casezd2valuezd2_1319==
CNST_TABLE_REF(((long)7)))
; } } 
if(BgL_test3204z00_5193)
{ /* Llib/json.scm 265 */
obj_t BgL_pairz00_2750;
BgL_pairz00_2750 = 
CDR(
((obj_t)BgL_tokenz00_1318)); 
return 
CAR(BgL_pairz00_2750);}  else 
{ /* Llib/json.scm 259 */
if(
(BgL_casezd2valuezd2_1319==
CNST_TABLE_REF(((long)1))))
{ /* Llib/json.scm 259 */
return 
BGl_parsezd2tokenzd2errorze70ze7zz__web_jsonz00(BgL_parsezd2errorzd2_2798, BgL_tokenz00_1318);}  else 
{ /* Llib/json.scm 259 */
if(
(BgL_casezd2valuezd2_1319==BgL_endz00_1314))
{ /* Llib/json.scm 269 */BFALSE; }  else 
{ /* Llib/json.scm 269 */
BGl_parsezd2tokenzd2errorze70ze7zz__web_jsonz00(BgL_parsezd2errorzd2_2798, BgL_tokenz00_1318); } 
return BGl_za2eotza2z00zz__web_jsonz00;} } } } } } } } } 

}



/* &<@anonymous:2248> */
obj_t BGl_z62zc3z04anonymousza32248ze3ze5zz__web_jsonz00(obj_t BgL_envz00_2778, obj_t BgL_xz00_2779)
{
{ /* Llib/json.scm 192 */
return BgL_xz00_2779;} 

}



/* &<@anonymous:2245> */
obj_t BGl_z62zc3z04anonymousza32245ze3ze5zz__web_jsonz00(obj_t BgL_envz00_2780, obj_t BgL_xz00_2781)
{
{ /* Llib/json.scm 187 */
return BgL_xz00_2781;} 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__web_jsonz00()
{
{ /* Llib/json.scm 15 */
return BUNSPEC;} 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__web_jsonz00()
{
{ /* Llib/json.scm 15 */
return BUNSPEC;} 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__web_jsonz00()
{
{ /* Llib/json.scm 15 */
return BUNSPEC;} 

}

#ifdef __cplusplus
}
#endif
