/*===========================================================================*/
/*   (Ast/sexp.scm)                                                          */
/*   Bigloo (4.3h)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 11 May 2020 12:14:39 PM CEST    */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.3h -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Ast/sexp.scm) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_backendz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_languagez00;
		obj_t BgL_srfi0z00;
		obj_t BgL_namez00;
		obj_t BgL_externzd2variableszd2;
		obj_t BgL_externzd2functionszd2;
		obj_t BgL_externzd2typeszd2;
		obj_t BgL_variablesz00;
		obj_t BgL_functionsz00;
		obj_t BgL_typesz00;
		bool_t BgL_typedz00;
		obj_t BgL_heapzd2suffixzd2;
		obj_t BgL_heapzd2compatiblezd2;
		bool_t BgL_callccz00;
		bool_t BgL_qualifiedzd2typeszd2;
		bool_t BgL_effectzb2zb2;
		bool_t BgL_removezd2emptyzd2letz00;
		bool_t BgL_foreignzd2closurezd2;
		bool_t BgL_typedzd2eqzd2;
		bool_t BgL_tracezd2supportzd2;
		obj_t BgL_foreignzd2clausezd2supportz00;
		obj_t BgL_debugzd2supportzd2;
		bool_t BgL_pragmazd2supportzd2;
		bool_t BgL_tvectorzd2descrzd2supportz00;
		bool_t BgL_requirezd2tailczd2;
		obj_t BgL_registersz00;
		obj_t BgL_pregistersz00;
		bool_t BgL_boundzd2checkzd2;
		bool_t BgL_typezd2checkzd2;
		bool_t BgL_typedzd2funcallzd2;
	}                 *BgL_backendz00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		bool_t BgL_evalzf3zf3;
		obj_t BgL_libraryz00;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
		obj_t BgL_initz00;
		obj_t BgL_aliasz00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_localz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		long BgL_keyz00;
	}               *BgL_localz00_bglt;

	typedef struct BgL_feffectz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_readz00;
		obj_t BgL_writez00;
	}                 *BgL_feffectz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_nodezf2effectzf2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
	}                       *BgL_nodezf2effectzf2_bglt;

	typedef struct BgL_atomz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}              *BgL_atomz00_bglt;

	typedef struct BgL_literalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}                 *BgL_literalz00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_closurez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}                 *BgL_closurez00_bglt;

	typedef struct BgL_kwotez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}               *BgL_kwotez00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
		bool_t BgL_unsafez00;
		obj_t BgL_metaz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_externz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
	}                *BgL_externz00_bglt;

	typedef struct BgL_castz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}              *BgL_castz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_switchz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_switchz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;

	typedef struct BgL_syncz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_mutexz00;
		struct BgL_nodez00_bgl *BgL_prelockz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}              *BgL_syncz00_bglt;


	extern obj_t BGl_normaliza7ezd2prognz75zztools_prognz00(obj_t);
	BGL_IMPORT obj_t BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_stringzd2replacezd2zz__r4_strings_6_7z00(obj_t,
		unsigned char, unsigned char);
	extern obj_t BGl_closurez00zzast_nodez00;
	extern obj_t BGl_findzd2locationzf2locz20zztools_locationz00(obj_t, obj_t);
	BGL_IMPORT bool_t BGl_equalzf3zf3zz__r4_equivalence_6_2z00(obj_t, obj_t);
	extern obj_t BGl_syncz00zzast_nodez00;
	extern BgL_nodez00_bglt BGl_applicationzd2ze3nodez31zzast_appz00(obj_t, obj_t,
		obj_t, obj_t);
	extern BgL_nodez00_bglt BGl_applycationzd2ze3nodez31zzast_applyz00(obj_t,
		obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_ifzd2symzd2zzast_sexpz00();
	extern obj_t BGl_sequencez00zzast_nodez00;
	extern obj_t BGl_failz00zzast_nodez00;
	extern obj_t BGl_addzd2staticzd2pragmaz12z12zzast_pragmaz00(BgL_nodez00_bglt);
	static obj_t BGl_objectzd2initzd2zzast_sexpz00();
	extern obj_t BGl_privatezd2nodezd2zzast_privatez00(obj_t, obj_t, obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	BGL_IMPORT obj_t string_append_3(obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_stringzd2containszd2zz__r4_strings_6_7z00(obj_t, obj_t,
		int);
	extern obj_t BGl_castzd2sexpzd2typez00zzast_privatez00(obj_t);
	static BgL_nodez00_bglt
		BGl_z62definezd2primopzd2refzd2ze3nodez53zzast_sexpz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_za2magicza2z00zztype_cachez00;
	static obj_t BGl_zc3z04exitza31511ze3ze70z60zzast_sexpz00(obj_t, obj_t);
	BGL_IMPORT obj_t bstring_to_symbol(obj_t);
	extern obj_t BGl_thezd2backendzd2zzbackend_backendz00();
	BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	extern obj_t BGl_letzd2symzf3z21zzast_letz00(obj_t);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_definezd2primopzd2refzf2srczd2ze3nodezc3zzast_sexpz00
		(BgL_globalz00_bglt, BgL_nodez00_bglt, obj_t);
	static obj_t BGl_methodzd2initzd2zzast_sexpz00();
	extern obj_t BGl_externz00zzast_nodez00;
	extern obj_t BGl_za2bdbzd2debugza2zd2zzengine_paramz00;
	extern obj_t BGl_za2compilerzd2debugza2zd2zzengine_paramz00;
	extern obj_t BGl_za2_za2z00zztype_cachez00;
	extern BgL_typez00_bglt
		BGl_strictzd2nodezd2typez00zzast_nodez00(BgL_typez00_bglt,
		BgL_typez00_bglt);
	extern obj_t BGl_za2objza2z00zztype_cachez00;
	BGL_IMPORT obj_t BGl_exceptionzd2notifyzd2zz__objectz00(obj_t);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_locationzd2ze3nodez31zzast_sexpz00(BgL_globalz00_bglt);
	static BgL_nodez00_bglt BGl_variablezd2ze3nodez31zzast_sexpz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_cfunz00zzast_varz00;
	BGL_IMPORT obj_t BGl_unwindzd2untilz12zc0zz__bexitz00(obj_t, obj_t);
	extern BgL_nodez00_bglt BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00(bool_t,
		obj_t, BgL_typez00_bglt, obj_t, obj_t, obj_t, obj_t);
	BGL_IMPORT bool_t BGl_numberzf3zf3zz__r4_numbers_6_5z00(obj_t);
	extern BgL_jumpzd2exzd2itz00_bglt
		BGl_jumpzd2exitzd2ze3nodeze3zzast_exitz00(obj_t, obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_makezd2dssslzd2functionzd2preludezd2zz__dssslz00(obj_t,
		obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_findzd2localzd2zzast_sexpz00(obj_t, obj_t);
	BGL_IMPORT bool_t BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(obj_t);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(obj_t, obj_t, obj_t);
	static obj_t BGl_gczd2rootszd2initz00zzast_sexpz00();
	extern obj_t BGl_parsezd2idzd2zzast_identz00(obj_t, obj_t);
	static obj_t BGl_za2sitesza2z00zzast_sexpz00 = BUNSPEC;
	static obj_t BGl_notzd2testzd2zzast_sexpz00(obj_t);
	extern obj_t BGl_currentzd2functionzd2zztools_errorz00();
	static obj_t BGl_z62findzd2localzb0zzast_sexpz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_epairifyzd2reczd2zztools_miscz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza36866ze3ze5zzast_sexpz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_dssslzd2findzd2firstzd2formalzd2zztools_dssslz00(obj_t);
	BGL_IMPORT obj_t c_substring(obj_t, long, long);
	BGL_IMPORT obj_t BGl_gensymz00zz__r4_symbols_6_4z00(obj_t);
	BGL_EXPORTED_DECL obj_t BGl_sexpza2zd2ze3nodez93zzast_sexpz00(obj_t, obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_usezd2variablez12zc0zzast_sexpz00(BgL_variablez00_bglt, obj_t, obj_t);
	static obj_t BGl_za2ifza2z00zzast_sexpz00 = BUNSPEC;
	static BgL_nodez00_bglt BGl_callzd2ze3nodez31zzast_sexpz00(obj_t, obj_t,
		obj_t, obj_t);
	extern BgL_typez00_bglt BGl_usezd2typez12zc0zztype_envz00(obj_t, obj_t);
	static obj_t BGl_loopze70ze7zzast_sexpz00(obj_t, obj_t, obj_t, obj_t);
	extern bool_t BGl_bigloozd2typezf3z21zztype_typez00(BgL_typez00_bglt);
	static bool_t BGl_usedzd2inzf3z21zzast_sexpz00(obj_t, obj_t);
	extern obj_t BGl_conditionalz00zzast_nodez00;
	extern BgL_nodez00_bglt BGl_letrecza2zd2ze3nodez93zzast_letz00(obj_t, obj_t,
		obj_t, obj_t);
	BGL_IMPORT bool_t BGl_dssslzd2namedzd2constantzf3zf3zz__dssslz00(obj_t);
	BGL_IMPORT obj_t BGl_numberzd2ze3stringz31zz__r4_numbers_6_5z00(obj_t, obj_t);
	static BgL_nodez00_bglt BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
	extern obj_t BGl_setqz00zzast_nodez00;
	extern BgL_nodez00_bglt BGl_fieldzd2refzd2ze3nodeze3zzast_objectz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	extern obj_t BGl_locationzd2fullzd2fnamez00zztools_locationz00(obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzast_sexpz00 = BUNSPEC;
	static BgL_nodez00_bglt BGl_lambdazd2ze3nodez31zzast_sexpz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_makezd2typedzd2identz00zzast_identz00(obj_t, obj_t);
	extern obj_t BGl_userzd2errorzf2locationz20zztools_errorz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_funz00zzast_varz00;
	static bool_t BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(obj_t);
	static obj_t BGl_za2cachezd2nameza2zd2zzast_sexpz00 = BUNSPEC;
	static obj_t BGl_z62sexpza2zd2ze3nodezf1zzast_sexpz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_atomz00zzast_nodez00;
	static obj_t BGl_toplevelzd2initzd2zzast_sexpz00();
	extern obj_t BGl_epairifyz00zztools_miscz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
	static obj_t BGl_genericzd2initzd2zzast_sexpz00();
	BGL_IMPORT obj_t BGl_stringzd2copyzd2zz__r4_strings_6_7z00(obj_t);
	extern bool_t BGl_privatezd2sexpzf3z21zzast_privatez00(obj_t);
	extern obj_t BGl_castz00zzast_nodez00;
	extern obj_t BGl_shapez00zztools_shapez00(obj_t);
	extern obj_t BGl_labelszd2symzf3z21zzast_labelsz00(obj_t);
	extern obj_t BGl_labelszd2symzd2zzast_labelsz00();
	BGL_IMPORT obj_t bgl_reverse_bang(obj_t);
	static obj_t BGl_za2cachezd2resza2zd2zzast_sexpz00 = BUNSPEC;
	static BgL_nodez00_bglt
		BGl_z62definezd2primopzd2ze3nodez81zzast_sexpz00(obj_t, obj_t);
	static obj_t BGl_z62makezd2anonymouszd2namez62zzast_sexpz00(obj_t, obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62topzd2levelzd2sexpzd2ze3nodez53zzast_sexpz00(obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62locationzd2ze3nodez53zzast_sexpz00(obj_t,
		obj_t);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00(obj_t, obj_t);
	extern obj_t BGl_findzd2globalzd2zzast_envz00(obj_t, obj_t);
	static obj_t BGl_z62ifzd2symzb0zzast_sexpz00(obj_t);
	BGL_IMPORT obj_t string_append(obj_t, obj_t);
	extern obj_t BGl_varz00zzast_nodez00;
	BGL_IMPORT bool_t bigloo_strncmp(obj_t, obj_t, long);
	static obj_t BGl_z62usezd2variablez12za2zzast_sexpz00(obj_t, obj_t, obj_t,
		obj_t);
	extern BgL_typez00_bglt BGl_getzd2typezd2atomz00zztype_typeofz00(obj_t);
	extern BgL_nodez00_bglt BGl_letzd2ze3nodez31zzast_letz00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_za2procedureza2z00zztype_cachez00;
	static obj_t BGl_z62zc3z04anonymousza31515ze3ze5zzast_sexpz00(obj_t, obj_t);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_definezd2primopzd2ze3nodeze3zzast_sexpz00(BgL_globalz00_bglt);
	BGL_EXPORTED_DECL obj_t BGl_makezd2anonymouszd2namez00zzast_sexpz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza31516ze3ze5zzast_sexpz00(obj_t);
	static obj_t BGl_liipze70ze7zzast_sexpz00(obj_t);
	extern obj_t BGl_replacez12z12zztools_miscz00(obj_t, obj_t);
	extern BgL_letzd2funzd2_bglt BGl_setzd2exitzd2ze3nodeze3zzast_exitz00(obj_t,
		obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zzast_sexpz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzeffect_feffectz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_dumpz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_objectz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_privatez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_applyz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_appz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_exitz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_letz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_labelsz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_pragmaz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_buildz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_identz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typeofz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_classz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_miscz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_dssslz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_miscz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_locationz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_prognz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__srfi4z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__dssslz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__structurez00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
	extern obj_t BGl_appz00zzast_nodez00;
	static BgL_nodez00_bglt
		BGl_z62definezd2primopzd2refzf2srczd2ze3nodeza1zzast_sexpz00(obj_t, obj_t,
		obj_t, obj_t);
	extern bool_t BGl_globalzd2readzd2onlyzf3zf3zzast_varz00(BgL_globalz00_bglt);
	BGL_IMPORT obj_t BGl_stringzd2appendzd2zz__r4_strings_6_7z00(obj_t);
	extern bool_t BGl_castzd2sexpzf3z21zzast_privatez00(obj_t);
	extern obj_t BGl_nodez00zzast_nodez00;
	extern obj_t BGl_kwotez00zzast_nodez00;
	extern obj_t BGl_localz00zzast_varz00;
	static obj_t BGl_cnstzd2initzd2zzast_sexpz00();
	static obj_t BGl_libraryzd2moduleszd2initz00zzast_sexpz00();
	static obj_t BGl_importedzd2moduleszd2initz00zzast_sexpz00();
	extern obj_t BGl_findzd2globalzf2modulez20zzast_envz00(obj_t, obj_t);
	extern obj_t BGl_za2bnilza2z00zztype_cachez00;
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00(BgL_globalz00_bglt,
		BgL_nodez00_bglt);
	extern obj_t BGl_letzd2symzd2zzast_letz00();
	BGL_EXPORTED_DECL BgL_nodez00_bglt BGl_sexpzd2ze3nodez31zzast_sexpz00(obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_za2unspecza2z00zztype_cachez00;
	static BgL_nodez00_bglt BGl_z62sexpzd2ze3nodez53zzast_sexpz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern BgL_letzd2funzd2_bglt BGl_labelszd2ze3nodez31zzast_labelsz00(obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_literalz00zzast_nodez00;
	extern obj_t BGl_switchz00zzast_nodez00;
	extern obj_t BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00(obj_t);
	static BgL_nodez00_bglt BGl_z62errorzd2sexpzd2ze3nodez81zzast_sexpz00(obj_t,
		obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_withzd2exceptionzd2handlerz00zz__errorz00(obj_t, obj_t);
	extern BgL_typez00_bglt BGl_getzd2typezd2kwotez00zztype_typeofz00(obj_t);
	extern BgL_nodez00_bglt BGl_fieldzd2setzd2ze3nodeze3zzast_objectz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t);
	extern obj_t BGl_globalz00zzast_varz00;
	extern BgL_feffectz00_bglt BGl_parsezd2effectzd2zzeffect_feffectz00(obj_t);
	static obj_t BGl_za2cachezd2stackza2zd2zzast_sexpz00 = BUNSPEC;
	static obj_t __cnst[49];


	   
		 
		DEFINE_STRING(BGl_string7996z00zzast_sexpz00,
		BgL_bgl_string7996za700za7za7a8034za7, "Illegal `application' form", 26);
	      DEFINE_STRING(BGl_string7997z00zzast_sexpz00,
		BgL_bgl_string7997za700za7za7a8035za7, "Illegal `case' form", 19);
	      DEFINE_STRING(BGl_string7998z00zzast_sexpz00,
		BgL_bgl_string7998za700za7za7a8036za7, "Illegal `failure' form", 22);
	      DEFINE_STRING(BGl_string7999z00zzast_sexpz00,
		BgL_bgl_string7999za700za7za7a8037za7, "Illegal `static-pragma' expression",
		34);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_definezd2primopzd2ze3nodezd2envz31zzast_sexpz00,
		BgL_bgl_za762defineza7d2prim8038z00,
		BGl_z62definezd2primopzd2ze3nodez81zzast_sexpz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_errorzd2sexpzd2ze3nodezd2envz31zzast_sexpz00,
		BgL_bgl_za762errorza7d2sexpza78039za7,
		BGl_z62errorzd2sexpzd2ze3nodez81zzast_sexpz00, 0L, BUNSPEC, 3);
	BGL_IMPORT obj_t BGl_expzd2envzd2zz__r4_numbers_6_5z00;
	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_makezd2anonymouszd2namezd2envzd2zzast_sexpz00,
		BgL_bgl_za762makeza7d2anonym8040z00, va_generic_entry,
		BGl_z62makezd2anonymouszd2namez62zzast_sexpz00, BUNSPEC, -2);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_findzd2localzd2envz00zzast_sexpz00,
		BgL_bgl_za762findza7d2localza78041za7, BGl_z62findzd2localzb0zzast_sexpz00,
		0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_locationzd2ze3nodezd2envze3zzast_sexpz00,
		BgL_bgl_za762locationza7d2za7e8042za7,
		BGl_z62locationzd2ze3nodez53zzast_sexpz00, 0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_sexpzd2ze3nodezd2envze3zzast_sexpz00,
		BgL_bgl_za762sexpza7d2za7e3nod8043za7,
		BGl_z62sexpzd2ze3nodez53zzast_sexpz00, 0L, BUNSPEC, 4);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_topzd2levelzd2sexpzd2ze3nodezd2envze3zzast_sexpz00,
		BgL_bgl_za762topza7d2levelza7d8044za7,
		BGl_z62topzd2levelzd2sexpzd2ze3nodez53zzast_sexpz00, 0L, BUNSPEC, 2);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_sexpza2zd2ze3nodezd2envz41zzast_sexpz00,
		BgL_bgl_za762sexpza7a2za7d2za7e38045z00,
		BGl_z62sexpza2zd2ze3nodezf1zzast_sexpz00, 0L, BUNSPEC, 4);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_definezd2primopzd2refzf2srczd2ze3nodezd2envz11zzast_sexpz00,
		BgL_bgl_za762defineza7d2prim8046z00,
		BGl_z62definezd2primopzd2refzf2srczd2ze3nodeza1zzast_sexpz00, 0L, BUNSPEC,
		3);
	      DEFINE_STRING(BGl_string8000z00zzast_sexpz00,
		BgL_bgl_string8000za700za7za7a8047za7, "anonymous", 9);
	      DEFINE_STRING(BGl_string8001z00zzast_sexpz00,
		BgL_bgl_string8001za700za7za7a8048za7, "Illegal `define' form", 21);
	      DEFINE_STRING(BGl_string8002z00zzast_sexpz00,
		BgL_bgl_string8002za700za7za7a8049za7, "illegal `define' expression", 27);
	      DEFINE_STRING(BGl_string8003z00zzast_sexpz00,
		BgL_bgl_string8003za700za7za7a8050za7, "Illegal `set!' form", 19);
	      DEFINE_STRING(BGl_string8004z00zzast_sexpz00,
		BgL_bgl_string8004za700za7za7a8051za7, "Read-only variable", 18);
	      DEFINE_STRING(BGl_string8005z00zzast_sexpz00,
		BgL_bgl_string8005za700za7za7a8052za7, "illegal `set!' expression", 25);
	      DEFINE_STRING(BGl_string8006z00zzast_sexpz00,
		BgL_bgl_string8006za700za7za7a8053za7, "Illegal ->", 10);
	      DEFINE_STRING(BGl_string8007z00zzast_sexpz00,
		BgL_bgl_string8007za700za7za7a8054za7, "Illegal `if' form", 17);
	      DEFINE_STRING(BGl_string8008z00zzast_sexpz00,
		BgL_bgl_string8008za700za7za7a8055za7, "Illegal `quote' expression", 26);
	      DEFINE_STRING(BGl_string8009z00zzast_sexpz00,
		BgL_bgl_string8009za700za7za7a8056za7, "Illegal `@' expression", 22);
	      DEFINE_STRING(BGl_string8010z00zzast_sexpz00,
		BgL_bgl_string8010za700za7za7a8057za7, "Unbound variable", 16);
	      DEFINE_STRING(BGl_string8011z00zzast_sexpz00,
		BgL_bgl_string8011za700za7za7a8058za7, "Illegal atom in s-expression", 28);
	      DEFINE_STRING(BGl_string8012z00zzast_sexpz00,
		BgL_bgl_string8012za700za7za7a8059za7, "Illegal `()' expression", 23);
	      DEFINE_STRING(BGl_string8013z00zzast_sexpz00,
		BgL_bgl_string8013za700za7za7a8060za7, "wrong number of argument", 24);
	      DEFINE_STRING(BGl_string8014z00zzast_sexpz00,
		BgL_bgl_string8014za700za7za7a8061za7, "Illegal formal argument", 23);
	      DEFINE_STRING(BGl_string8015z00zzast_sexpz00,
		BgL_bgl_string8015za700za7za7a8062za7, "Illegal `lambda' form", 21);
	      DEFINE_STRING(BGl_string8016z00zzast_sexpz00,
		BgL_bgl_string8016za700za7za7a8063za7,
		"Backend (~a) does not support external first class function", 59);
	      DEFINE_STRING(BGl_string8017z00zzast_sexpz00,
		BgL_bgl_string8017za700za7za7a8064za7, "Illegal pragma/effect", 21);
	      DEFINE_STRING(BGl_string8018z00zzast_sexpz00,
		BgL_bgl_string8018za700za7za7a8065za7, "Illegal free-pragma/effect", 26);
	      DEFINE_STRING(BGl_string8019z00zzast_sexpz00,
		BgL_bgl_string8019za700za7za7a8066za7, "Illegal lambda", 14);
	      DEFINE_STRING(BGl_string8020z00zzast_sexpz00,
		BgL_bgl_string8020za700za7za7a8067za7, "Illegal empty sequence", 22);
	      DEFINE_STRING(BGl_string8021z00zzast_sexpz00,
		BgL_bgl_string8021za700za7za7a8068za7, "Illegal mutation", 16);
	      DEFINE_STRING(BGl_string8022z00zzast_sexpz00,
		BgL_bgl_string8022za700za7za7a8069za7, "($1)", 4);
	      DEFINE_STRING(BGl_string8023z00zzast_sexpz00,
		BgL_bgl_string8023za700za7za7a8070za7, "<@", 2);
	      DEFINE_STRING(BGl_string8024z00zzast_sexpz00,
		BgL_bgl_string8024za700za7za7a8071za7, ":", 1);
	      DEFINE_STRING(BGl_string8025z00zzast_sexpz00,
		BgL_bgl_string8025za700za7za7a8072za7, "./", 2);
	      DEFINE_STRING(BGl_string8026z00zzast_sexpz00,
		BgL_bgl_string8026za700za7za7a8073za7, "@>", 2);
	      DEFINE_STRING(BGl_string8027z00zzast_sexpz00,
		BgL_bgl_string8027za700za7za7a8074za7, ">", 1);
	      DEFINE_STRING(BGl_string8028z00zzast_sexpz00,
		BgL_bgl_string8028za700za7za7a8075za7, "-", 1);
	      DEFINE_STRING(BGl_string8029z00zzast_sexpz00,
		BgL_bgl_string8029za700za7za7a8076za7, "ast_sexp", 8);
	      DEFINE_STRING(BGl_string8030z00zzast_sexpz00,
		BgL_bgl_string8030za700za7za7a8077za7,
		"not mutex @> bdb anonymous location pragma::obj (@ __evmeaning_address foreign) (@ define-primop! __evenv) at (@ define-primop-ref/loc! __evenv) (@ define-primop-ref! __evenv) write car exp app cons :prelock apply synchronize jump-exit set-exit case failure free-pragma/effect static-pragma free-pragma pragma/effect letrec* labels letrec let define begin -> __r4_control_features_6_9 quote @ eval bool test set! pragma else (quote ()) lambda value if (value apply app set! test) ",
		480);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_ifzd2symzd2envz00zzast_sexpz00,
		BgL_bgl_za762ifza7d2symza7b0za7za78078za7, BGl_z62ifzd2symzb0zzast_sexpz00,
		0L, BUNSPEC, 0);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_usezd2variablez12zd2envz12zzast_sexpz00,
		BgL_bgl_za762useza7d2variabl8079z00,
		BGl_z62usezd2variablez12za2zzast_sexpz00, 0L, BUNSPEC, 3);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_definezd2primopzd2refzd2ze3nodezd2envze3zzast_sexpz00,
		BgL_bgl_za762defineza7d2prim8080z00,
		BGl_z62definezd2primopzd2refzd2ze3nodez53zzast_sexpz00, 0L, BUNSPEC, 2);

/* GC roots registration */
	static obj_t bgl_gc_roots_register()
	{
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
		void *roots_min = (void *) ULONG_MAX, *roots_max = 0;
		     ADD_ROOT((void *) (&BGl_za2sitesza2z00zzast_sexpz00));
		     ADD_ROOT((void *) (&BGl_za2ifza2z00zzast_sexpz00));
		     ADD_ROOT((void *) (&BGl_requirezd2initializa7ationz75zzast_sexpz00));
		     ADD_ROOT((void *) (&BGl_za2cachezd2nameza2zd2zzast_sexpz00));
		     ADD_ROOT((void *) (&BGl_za2cachezd2resza2zd2zzast_sexpz00));
		     ADD_ROOT((void *) (&BGl_za2cachezd2stackza2zd2zzast_sexpz00));
#undef ADD_ROOT
		if   (roots_max > 0)
			     GC_add_roots(roots_min, ((void **) roots_max) + 1);
#endif
		     return BUNSPEC;
	}



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzast_sexpz00(long
		BgL_checksumz00_13870, char *BgL_fromz00_13871)
	{
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzast_sexpz00))
				{
					BGl_requirezd2initializa7ationz75zzast_sexpz00 = BBOOL(((bool_t) 0));
					BGl_gczd2rootszd2initz00zzast_sexpz00();
					BGl_libraryzd2moduleszd2initz00zzast_sexpz00();
					BGl_cnstzd2initzd2zzast_sexpz00();
					BGl_importedzd2moduleszd2initz00zzast_sexpz00();
					return BGl_toplevelzd2initzd2zzast_sexpz00();
				}
			else
				{
					return BUNSPEC;
				}
		}

	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzast_sexpz00()
	{
		{	/* Ast/sexp.scm 14 */
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__bexitz00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__dssslz00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__srfi4z00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__structurez00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__biglooz00(((long) 0), "ast_sexp");
			return BUNSPEC;
		}

	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzast_sexpz00()
	{
		{	/* Ast/sexp.scm 14 */
			{	/* Ast/sexp.scm 14 */
				obj_t BgL_cportz00_13857;

				{	/* Ast/sexp.scm 14 */
					obj_t BgL_stringz00_13865;

					BgL_stringz00_13865 = BGl_string8030z00zzast_sexpz00;
					{	/* Ast/sexp.scm 14 */
						obj_t BgL_startz00_13866;

						BgL_startz00_13866 = BINT(((long) 0));
						{	/* Ast/sexp.scm 14 */
							obj_t BgL_endz00_13867;

							BgL_endz00_13867 =
								BINT(STRING_LENGTH(((obj_t) BgL_stringz00_13865)));
							{	/* Ast/sexp.scm 14 */

								BgL_cportz00_13857 =
									BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00
									(BgL_stringz00_13865, BgL_startz00_13866, BgL_endz00_13867);
				}}}}
				{
					long BgL_iz00_13858;

					BgL_iz00_13858 = ((long) 48);
				BgL_loopz00_13859:
					if ((BgL_iz00_13858 == ((long) -1)))
						{	/* Ast/sexp.scm 14 */
							return BUNSPEC;
						}
					else
						{	/* Ast/sexp.scm 14 */
							{	/* Ast/sexp.scm 14 */
								obj_t BgL_arg8032z00_13861;

								{	/* Ast/sexp.scm 14 */

									{	/* Ast/sexp.scm 14 */
										obj_t BgL_locationz00_13863;

										BgL_locationz00_13863 = BBOOL(((bool_t) 0));
										{	/* Ast/sexp.scm 14 */

											BgL_arg8032z00_13861 =
												BGl_readz00zz__readerz00(BgL_cportz00_13857,
												BgL_locationz00_13863);
										}
									}
								}
								{	/* Ast/sexp.scm 14 */
									int BgL_tmpz00_13909;

									BgL_tmpz00_13909 = (int) (BgL_iz00_13858);
									CNST_TABLE_SET(BgL_tmpz00_13909, BgL_arg8032z00_13861);
							}}
							{	/* Ast/sexp.scm 14 */
								int BgL_auxz00_13864;

								BgL_auxz00_13864 = (int) ((BgL_iz00_13858 - ((long) 1)));
								{
									long BgL_iz00_13914;

									BgL_iz00_13914 = (long) (BgL_auxz00_13864);
									BgL_iz00_13858 = BgL_iz00_13914;
									goto BgL_loopz00_13859;
								}
							}
						}
				}
			}
		}

	}



/* gc-roots-init */
	obj_t BGl_gczd2rootszd2initz00zzast_sexpz00()
	{
		{	/* Ast/sexp.scm 14 */
			return bgl_gc_roots_register();
		}

	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzast_sexpz00()
	{
		{	/* Ast/sexp.scm 14 */
			BGl_za2sitesza2z00zzast_sexpz00 = CNST_TABLE_REF(((long) 0));
			BGl_za2ifza2z00zzast_sexpz00 =
				BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 1)));
			BGl_za2cachezd2nameza2zd2zzast_sexpz00 = BFALSE;
			BGl_za2cachezd2stackza2zd2zzast_sexpz00 = BFALSE;
			return (BGl_za2cachezd2resza2zd2zzast_sexpz00 = BFALSE, BUNSPEC);
		}

	}



/* top-level-sexp->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00(obj_t BgL_expz00_17,
		obj_t BgL_locz00_18)
	{
		{	/* Ast/sexp.scm 66 */
			return
				((BgL_nodez00_bglt)
				BGl_zc3z04exitza31511ze3ze70z60zzast_sexpz00(BgL_locz00_18,
					BgL_expz00_17));
		}

	}



/* <@exit:1511>~0 */
	obj_t BGl_zc3z04exitza31511ze3ze70z60zzast_sexpz00(obj_t BgL_locz00_13855,
		obj_t BgL_expz00_13854)
	{
		{	/* Ast/sexp.scm 67 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1108z00_1683;

			if (SET_EXIT(BgL_an_exit1108z00_1683))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1108z00_1683 = (void *) jmpbuf;
					{	/* Ast/sexp.scm 67 */

						PUSH_EXIT(BgL_an_exit1108z00_1683, ((long) 1));
						{	/* Ast/sexp.scm 67 */
							obj_t BgL_an_exitd1109z00_1684;

							BgL_an_exitd1109z00_1684 = ((obj_t) (&exitd));
							{	/* Ast/sexp.scm 67 */
								obj_t BgL_res1111z00_1687;

								{	/* Ast/sexp.scm 70 */
									obj_t BgL_zc3z04anonymousza31516ze3z87_13797;
									obj_t BgL_zc3z04anonymousza31515ze3z87_13798;

									BgL_zc3z04anonymousza31516ze3z87_13797 =
										MAKE_FX_PROCEDURE
										(BGl_z62zc3z04anonymousza31516ze3ze5zzast_sexpz00,
										(int) (((long) 0)), (int) (((long) 2)));
									BgL_zc3z04anonymousza31515ze3z87_13798 =
										MAKE_FX_PROCEDURE
										(BGl_z62zc3z04anonymousza31515ze3ze5zzast_sexpz00,
										(int) (((long) 1)), (int) (((long) 1)));
									PROCEDURE_SET(BgL_zc3z04anonymousza31516ze3z87_13797,
										(int) (((long) 0)), BgL_expz00_13854);
									PROCEDURE_SET(BgL_zc3z04anonymousza31516ze3z87_13797,
										(int) (((long) 1)), BgL_locz00_13855);
									PROCEDURE_SET(BgL_zc3z04anonymousza31515ze3z87_13798,
										(int) (((long) 0)), BgL_an_exitd1109z00_1684);
									BgL_res1111z00_1687 =
										BGl_withzd2exceptionzd2handlerz00zz__errorz00
										(BgL_zc3z04anonymousza31515ze3z87_13798,
										BgL_zc3z04anonymousza31516ze3z87_13797);
								}
								POP_EXIT();
								return BgL_res1111z00_1687;
							}
						}
					}
				}
		}

	}



/* &top-level-sexp->node */
	BgL_nodez00_bglt BGl_z62topzd2levelzd2sexpzd2ze3nodez53zzast_sexpz00(obj_t
		BgL_envz00_13799, obj_t BgL_expz00_13800, obj_t BgL_locz00_13801)
	{
		{	/* Ast/sexp.scm 66 */
			return
				BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00(BgL_expz00_13800,
				BgL_locz00_13801);
		}

	}



/* &<@anonymous:1516> */
	obj_t BGl_z62zc3z04anonymousza31516ze3ze5zzast_sexpz00(obj_t BgL_envz00_13802)
	{
		{	/* Ast/sexp.scm 72 */
			{	/* Ast/sexp.scm 73 */
				obj_t BgL_expz00_13803;
				obj_t BgL_locz00_13804;

				BgL_expz00_13803 = PROCEDURE_REF(BgL_envz00_13802, (int) (((long) 0)));
				BgL_locz00_13804 = PROCEDURE_REF(BgL_envz00_13802, (int) (((long) 1)));
				return
					((obj_t)
					BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_expz00_13803, BNIL,
						BgL_locz00_13804, CNST_TABLE_REF(((long) 2))));
		}}

	}



/* &<@anonymous:1515> */
	obj_t BGl_z62zc3z04anonymousza31515ze3ze5zzast_sexpz00(obj_t BgL_envz00_13805,
		obj_t BgL_ez00_13807)
	{
		{	/* Ast/sexp.scm 69 */
			{	/* Ast/sexp.scm 70 */
				obj_t BgL_an_exitd1109z00_13806;

				BgL_an_exitd1109z00_13806 =
					PROCEDURE_REF(BgL_envz00_13805, (int) (((long) 0)));
				BGl_exceptionzd2notifyzd2zz__objectz00(BgL_ez00_13807);
				return
					BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1109z00_13806,
					BUNSPEC);
			}
		}

	}



/* if-sym */
	BGL_EXPORTED_DEF obj_t BGl_ifzd2symzd2zzast_sexpz00()
	{
		{	/* Ast/sexp.scm 88 */
			return BGl_za2ifza2z00zzast_sexpz00;
		}

	}



/* &if-sym */
	obj_t BGl_z62ifzd2symzb0zzast_sexpz00(obj_t BgL_envz00_13808)
	{
		{	/* Ast/sexp.scm 88 */
			return BGl_ifzd2symzd2zzast_sexpz00();
		}

	}



/* proc-or-lambda? */
	bool_t BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(obj_t BgL_ez00_20)
	{
		{	/* Ast/sexp.scm 100 */
			if (SYMBOLP(BgL_ez00_20))
				{	/* Ast/sexp.scm 101 */
					return ((bool_t) 1);
				}
			else
				{	/* Ast/sexp.scm 101 */
					if (PAIRP(BgL_ez00_20))
						{	/* Ast/sexp.scm 101 */
							if ((CAR(BgL_ez00_20) == CNST_TABLE_REF(((long) 3))))
								{	/* Ast/sexp.scm 101 */
									obj_t BgL_tmpz00_13960;

									BgL_tmpz00_13960 = CDR(BgL_ez00_20);
									return PAIRP(BgL_tmpz00_13960);
								}
							else
								{	/* Ast/sexp.scm 101 */
									return ((bool_t) 0);
								}
						}
					else
						{	/* Ast/sexp.scm 101 */
							return ((bool_t) 0);
						}
				}
		}

	}



/* sexp->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt BGl_sexpzd2ze3nodez31zzast_sexpz00(obj_t
		BgL_expz00_21, obj_t BgL_stackz00_22, obj_t BgL_locz00_23,
		obj_t BgL_sitez00_24)
	{
		{	/* Ast/sexp.scm 114 */
		BGl_sexpzd2ze3nodez31zzast_sexpz00:
			{
				obj_t BgL_atomz00_1709;
				obj_t BgL_lz00_1714;
				obj_t BgL_bodyz00_1718;
				obj_t BgL_lz00_1723;
				obj_t BgL_valz00_1724;
				obj_t BgL_bodyz00_1728;
				obj_t BgL_argsz00_1729;
				obj_t BgL_bindingsz00_1731;
				obj_t BgL_exprz00_1732;
				obj_t BgL_varz00_1736;
				obj_t BgL_bodyz00_1737;
				obj_t BgL_argz00_1738;
				obj_t BgL_varsz00_1740;
				obj_t BgL_bodyz00_1741;
				obj_t BgL_argsz00_1742;
				obj_t BgL_testz00_1744;
				obj_t BgL_proc1z00_1745;
				obj_t BgL_proc2z00_1746;
				obj_t BgL_argsz00_1747;
				obj_t BgL_testz00_1749;
				obj_t BgL_proc1z00_1750;
				obj_t BgL_proc2z00_1751;
				obj_t BgL_argsz00_1752;
				obj_t BgL_effectz00_1756;
				obj_t BgL_restz00_1757;
				obj_t BgL_effectz00_1761;
				obj_t BgL_restz00_1762;

				if (NULLP(BgL_expz00_21))
					{	/* Ast/sexp.scm 119 */
						{	/* Ast/sexp.scm 122 */
							BgL_nodez00_bglt BgL_res7304z00_9621;

							{	/* Ast/sexp.scm 723 */
								obj_t BgL_arg7080z00_9617;
								BgL_nodez00_bglt BgL_arg7081z00_9618;

								BgL_arg7080z00_9617 =
									BGl_shapez00zztools_shapez00
									(BGl_currentzd2functionzd2zztools_errorz00());
								BgL_arg7081z00_9618 =
									BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 4)),
									BNIL, BgL_locz00_23, CNST_TABLE_REF(((long) 2)));
								{	/* Ast/sexp.scm 722 */
									obj_t BgL_list7082z00_9620;

									BgL_list7082z00_9620 =
										MAKE_YOUNG_PAIR(((obj_t) BgL_arg7081z00_9618), BNIL);
									BgL_res7304z00_9621 =
										((BgL_nodez00_bglt)
										BGl_userzd2errorzf2locationz20zztools_errorz00
										(BgL_locz00_23, BgL_arg7080z00_9617,
											BGl_string8012z00zzast_sexpz00, BgL_expz00_21,
											BgL_list7082z00_9620));
							}}
							return BgL_res7304z00_9621;
						}
					}
				else
					{	/* Ast/sexp.scm 119 */
						if (BGl_isazf3zf3zz__objectz00(BgL_expz00_21,
								BGl_nodez00zzast_nodez00))
							{
								obj_t BgL_auxz00_13976;

								if (BGl_isazf3zf3zz__objectz00(BgL_expz00_21,
										BGl_externz00zzast_nodez00))
									{	/* Ast/sexp.scm 127 */
										obj_t BgL_l01343z00_8338;

										BgL_l01343z00_8338 =
											(((BgL_externz00_bglt) COBJECT(
													((BgL_externz00_bglt) BgL_expz00_21)))->
											BgL_exprza2za2);
										{
											obj_t BgL_l1342z00_8340;

											BgL_l1342z00_8340 = BgL_l01343z00_8338;
										BgL_zc3z04anonymousza36586ze3z87_8341:
											if (NULLP(BgL_l1342z00_8340))
												{	/* Ast/sexp.scm 127 */
													BgL_l01343z00_8338;
												}
											else
												{	/* Ast/sexp.scm 127 */
													{	/* Ast/sexp.scm 127 */
														BgL_nodez00_bglt BgL_arg6588z00_8343;

														{	/* Ast/sexp.scm 127 */
															obj_t BgL_ez00_8344;

															BgL_ez00_8344 = CAR(((obj_t) BgL_l1342z00_8340));
															{	/* Ast/sexp.scm 127 */
																obj_t BgL_arg6589z00_8345;

																BgL_arg6589z00_8345 =
																	(((BgL_nodez00_bglt) COBJECT(
																			((BgL_nodez00_bglt)
																				((BgL_externz00_bglt)
																					BgL_expz00_21))))->BgL_locz00);
																BgL_arg6588z00_8343 =
																	BGl_sexpzd2ze3nodez31zzast_sexpz00
																	(BgL_ez00_8344, BgL_stackz00_22,
																	BgL_arg6589z00_8345,
																	CNST_TABLE_REF(((long) 2)));
														}}
														{	/* Ast/sexp.scm 127 */
															obj_t BgL_auxz00_13992;
															obj_t BgL_tmpz00_13990;

															BgL_auxz00_13992 = ((obj_t) BgL_arg6588z00_8343);
															BgL_tmpz00_13990 = ((obj_t) BgL_l1342z00_8340);
															SET_CAR(BgL_tmpz00_13990, BgL_auxz00_13992);
													}}
													{	/* Ast/sexp.scm 127 */
														obj_t BgL_arg6590z00_8346;

														BgL_arg6590z00_8346 =
															CDR(((obj_t) BgL_l1342z00_8340));
														{
															obj_t BgL_l1342z00_13997;

															BgL_l1342z00_13997 = BgL_arg6590z00_8346;
															BgL_l1342z00_8340 = BgL_l1342z00_13997;
															goto BgL_zc3z04anonymousza36586ze3z87_8341;
														}
													}
												}
										}
									}
								else
									{	/* Ast/sexp.scm 125 */
										BFALSE;
									}
								if (BGl_isazf3zf3zz__objectz00(BgL_expz00_21,
										BGl_appz00zzast_nodez00))
									{	/* Ast/sexp.scm 130 */
										obj_t BgL_l01346z00_8350;

										BgL_l01346z00_8350 =
											(((BgL_appz00_bglt) COBJECT(
													((BgL_appz00_bglt) BgL_expz00_21)))->BgL_argsz00);
										{
											obj_t BgL_l1345z00_8352;

											BgL_l1345z00_8352 = BgL_l01346z00_8350;
										BgL_zc3z04anonymousza36592ze3z87_8353:
											if (NULLP(BgL_l1345z00_8352))
												{	/* Ast/sexp.scm 130 */
													BgL_l01346z00_8350;
												}
											else
												{	/* Ast/sexp.scm 130 */
													{	/* Ast/sexp.scm 130 */
														BgL_nodez00_bglt BgL_arg6594z00_8355;

														{	/* Ast/sexp.scm 130 */
															obj_t BgL_ez00_8356;

															BgL_ez00_8356 = CAR(((obj_t) BgL_l1345z00_8352));
															{	/* Ast/sexp.scm 130 */
																obj_t BgL_arg6595z00_8357;

																BgL_arg6595z00_8357 =
																	(((BgL_nodez00_bglt) COBJECT(
																			((BgL_nodez00_bglt)
																				((BgL_appz00_bglt) BgL_expz00_21))))->
																	BgL_locz00);
																BgL_arg6594z00_8355 =
																	BGl_sexpzd2ze3nodez31zzast_sexpz00
																	(BgL_ez00_8356, BgL_stackz00_22,
																	BgL_arg6595z00_8357,
																	CNST_TABLE_REF(((long) 2)));
														}}
														{	/* Ast/sexp.scm 130 */
															obj_t BgL_auxz00_14013;
															obj_t BgL_tmpz00_14011;

															BgL_auxz00_14013 = ((obj_t) BgL_arg6594z00_8355);
															BgL_tmpz00_14011 = ((obj_t) BgL_l1345z00_8352);
															SET_CAR(BgL_tmpz00_14011, BgL_auxz00_14013);
													}}
													{	/* Ast/sexp.scm 130 */
														obj_t BgL_arg6596z00_8358;

														BgL_arg6596z00_8358 =
															CDR(((obj_t) BgL_l1345z00_8352));
														{
															obj_t BgL_l1345z00_14018;

															BgL_l1345z00_14018 = BgL_arg6596z00_8358;
															BgL_l1345z00_8352 = BgL_l1345z00_14018;
															goto BgL_zc3z04anonymousza36592ze3z87_8353;
														}
													}
												}
										}
									}
								else
									{	/* Ast/sexp.scm 128 */
										BFALSE;
									}
								BgL_auxz00_13976 = BgL_expz00_21;
								return ((BgL_nodez00_bglt) BgL_auxz00_13976);
							}
						else
							{	/* Ast/sexp.scm 119 */
								if (PAIRP(BgL_expz00_21))
									{	/* Ast/sexp.scm 119 */
										obj_t BgL_carzd2478zd2_1783;

										BgL_carzd2478zd2_1783 = CAR(BgL_expz00_21);
										if (SYMBOLP(BgL_carzd2478zd2_1783))
											{	/* Ast/sexp.scm 119 */
												bool_t BgL_test8094z00_14025;

												{	/* Ast/sexp.scm 119 */
													obj_t BgL__ortest_1144z00_5063;

													BgL__ortest_1144z00_5063 =
														BGl_findzd2localzd2zzast_sexpz00
														(BgL_carzd2478zd2_1783, BgL_stackz00_22);
													if (CBOOL(BgL__ortest_1144z00_5063))
														{	/* Ast/sexp.scm 119 */
															BgL_test8094z00_14025 =
																CBOOL(BgL__ortest_1144z00_5063);
														}
													else
														{	/* Ast/sexp.scm 119 */
															obj_t BgL_gz00_5064;

															BgL_gz00_5064 =
																BGl_findzd2globalzd2zzast_envz00
																(BgL_carzd2478zd2_1783, BNIL);
															if (CBOOL(BgL_gz00_5064))
																{	/* Ast/sexp.scm 119 */
																	if (
																		((((BgL_globalz00_bglt) COBJECT(
																						((BgL_globalz00_bglt)
																							BgL_gz00_5064)))->
																				BgL_modulez00) ==
																			CNST_TABLE_REF(((long) 13))))
																		{	/* Ast/sexp.scm 119 */
																			BgL_test8094z00_14025 = ((bool_t) 0);
																		}
																	else
																		{	/* Ast/sexp.scm 119 */
																			BgL_test8094z00_14025 = ((bool_t) 1);
																		}
																}
															else
																{	/* Ast/sexp.scm 119 */
																	BgL_test8094z00_14025 = ((bool_t) 0);
																}
														}
												}
												if (BgL_test8094z00_14025)
													{	/* Ast/sexp.scm 119 */
														return
															BGl_callzd2ze3nodez31zzast_sexpz00(BgL_expz00_21,
															BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
													}
												else
													{	/* Ast/sexp.scm 119 */
														if (
															(CAR(BgL_expz00_21) ==
																CNST_TABLE_REF(((long) 11))))
															{	/* Ast/sexp.scm 119 */
															BgL_tagzd2371zd2_1713:
																{	/* Ast/sexp.scm 171 */
																	obj_t BgL_locz00_8388;

																	BgL_locz00_8388 =
																		BGl_findzd2locationzf2locz20zztools_locationz00
																		(BgL_expz00_21, BgL_locz00_23);
																	{
																		obj_t BgL_namez00_8389;
																		obj_t BgL_modulez00_8390;

																		if (PAIRP(BgL_expz00_21))
																			{	/* Ast/sexp.scm 172 */
																				obj_t BgL_cdrzd262164zd2_8395;

																				BgL_cdrzd262164zd2_8395 =
																					CDR(BgL_expz00_21);
																				if (
																					(CAR(BgL_expz00_21) ==
																						CNST_TABLE_REF(((long) 11))))
																					{	/* Ast/sexp.scm 172 */
																						if (PAIRP(BgL_cdrzd262164zd2_8395))
																							{	/* Ast/sexp.scm 172 */
																								obj_t BgL_carzd262167zd2_8399;
																								obj_t BgL_cdrzd262168zd2_8400;

																								BgL_carzd262167zd2_8399 =
																									CAR(BgL_cdrzd262164zd2_8395);
																								BgL_cdrzd262168zd2_8400 =
																									CDR(BgL_cdrzd262164zd2_8395);
																								if (SYMBOLP
																									(BgL_carzd262167zd2_8399))
																									{	/* Ast/sexp.scm 172 */
																										if (PAIRP
																											(BgL_cdrzd262168zd2_8400))
																											{	/* Ast/sexp.scm 172 */
																												obj_t
																													BgL_carzd262173zd2_8403;
																												BgL_carzd262173zd2_8403
																													=
																													CAR
																													(BgL_cdrzd262168zd2_8400);
																												if (SYMBOLP
																													(BgL_carzd262173zd2_8403))
																													{	/* Ast/sexp.scm 172 */
																														if (NULLP(CDR
																																(BgL_cdrzd262168zd2_8400)))
																															{	/* Ast/sexp.scm 172 */
																																BgL_namez00_8389
																																	=
																																	BgL_carzd262167zd2_8399;
																																BgL_modulez00_8390
																																	=
																																	BgL_carzd262173zd2_8403;
																																{	/* Ast/sexp.scm 174 */
																																	obj_t
																																		BgL_globalz00_8409;
																																	obj_t
																																		BgL_locz00_8410;
																																	BgL_globalz00_8409
																																		=
																																		BGl_findzd2globalzf2modulez20zzast_envz00
																																		(BgL_namez00_8389,
																																		BgL_modulez00_8390);
																																	BgL_locz00_8410
																																		=
																																		BGl_findzd2locationzf2locz20zztools_locationz00
																																		(BgL_namez00_8389,
																																		BgL_locz00_8388);
																																	if (BGl_isazf3zf3zz__objectz00(BgL_globalz00_8409, BGl_globalz00zzast_varz00))
																																		{	/* Ast/sexp.scm 177 */
																																			if (
																																				((((BgL_globalz00_bglt) COBJECT(((BgL_globalz00_bglt) BgL_globalz00_8409)))->BgL_importz00) == CNST_TABLE_REF(((long) 10))))
																																				{	/* Ast/sexp.scm 180 */
																																					obj_t
																																						BgL_arg6628z00_8414;
																																					{	/* Ast/sexp.scm 180 */
																																						obj_t
																																							BgL_arg6629z00_8415;
																																						BgL_arg6629z00_8415
																																							=
																																							MAKE_YOUNG_PAIR
																																							(BGl_atomz00zzast_nodez00,
																																							BNIL);
																																						BgL_arg6628z00_8414
																																							=
																																							MAKE_YOUNG_PAIR
																																							(CNST_TABLE_REF
																																							(((long) 10)), BgL_arg6629z00_8415);
																																					}
																																					{
																																						obj_t
																																							BgL_locz00_14078;
																																						obj_t
																																							BgL_expz00_14077;
																																						BgL_expz00_14077
																																							=
																																							BgL_arg6628z00_8414;
																																						BgL_locz00_14078
																																							=
																																							BgL_locz00_8410;
																																						BgL_locz00_23
																																							=
																																							BgL_locz00_14078;
																																						BgL_expz00_21
																																							=
																																							BgL_expz00_14077;
																																						goto
																																							BGl_sexpzd2ze3nodez31zzast_sexpz00;
																																					}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 179 */
																																					return
																																						BGl_variablezd2ze3nodez31zzast_sexpz00
																																						(BgL_globalz00_8409,
																																						BgL_locz00_8410,
																																						BgL_sitez00_24);
																																				}
																																		}
																																	else
																																		{	/* Ast/sexp.scm 178 */
																																			BgL_nodez00_bglt
																																				BgL_res7321z00_9665;
																																			{	/* Ast/sexp.scm 723 */
																																				obj_t
																																					BgL_arg7080z00_9661;
																																				BgL_nodez00_bglt
																																					BgL_arg7081z00_9662;
																																				BgL_arg7080z00_9661
																																					=
																																					BGl_shapez00zztools_shapez00
																																					(BGl_currentzd2functionzd2zztools_errorz00
																																					());
																																				BgL_arg7081z00_9662
																																					=
																																					BGl_sexpzd2ze3nodez31zzast_sexpz00
																																					(CNST_TABLE_REF
																																					(((long) 4)), BNIL, BgL_locz00_8410, CNST_TABLE_REF(((long) 2)));
																																				{	/* Ast/sexp.scm 722 */
																																					obj_t
																																						BgL_list7082z00_9664;
																																					BgL_list7082z00_9664
																																						=
																																						MAKE_YOUNG_PAIR
																																						(((obj_t) BgL_arg7081z00_9662), BNIL);
																																					BgL_res7321z00_9665
																																						=
																																						(
																																						(BgL_nodez00_bglt)
																																						BGl_userzd2errorzf2locationz20zztools_errorz00
																																						(BgL_locz00_8410,
																																							BgL_arg7080z00_9661,
																																							BGl_string8010z00zzast_sexpz00,
																																							BgL_expz00_21,
																																							BgL_list7082z00_9664));
																																			}}
																																			return
																																				BgL_res7321z00_9665;
																																		}
																																}
																															}
																														else
																															{	/* Ast/sexp.scm 172 */
																															BgL_tagzd262157zd2_8392:
																																{	/* Ast/sexp.scm 184 */
																																	BgL_nodez00_bglt
																																		BgL_res7322z00_9671;
																																	{	/* Ast/sexp.scm 723 */
																																		obj_t
																																			BgL_arg7080z00_9667;
																																		BgL_nodez00_bglt
																																			BgL_arg7081z00_9668;
																																		BgL_arg7080z00_9667
																																			=
																																			BGl_shapez00zztools_shapez00
																																			(BGl_currentzd2functionzd2zztools_errorz00
																																			());
																																		BgL_arg7081z00_9668
																																			=
																																			BGl_sexpzd2ze3nodez31zzast_sexpz00
																																			(CNST_TABLE_REF
																																			(((long)
																																					4)),
																																			BNIL,
																																			BgL_locz00_8388,
																																			CNST_TABLE_REF
																																			(((long)
																																					2)));
																																		{	/* Ast/sexp.scm 722 */
																																			obj_t
																																				BgL_list7082z00_9670;
																																			BgL_list7082z00_9670
																																				=
																																				MAKE_YOUNG_PAIR
																																				(((obj_t) BgL_arg7081z00_9668), BNIL);
																																			BgL_res7322z00_9671
																																				=
																																				(
																																				(BgL_nodez00_bglt)
																																				BGl_userzd2errorzf2locationz20zztools_errorz00
																																				(BgL_locz00_8388,
																																					BgL_arg7080z00_9667,
																																					BGl_string8009z00zzast_sexpz00,
																																					BgL_expz00_21,
																																					BgL_list7082z00_9670));
																																	}}
																																	return
																																		BgL_res7322z00_9671;
																																}
																															}
																													}
																												else
																													{	/* Ast/sexp.scm 172 */
																														goto
																															BgL_tagzd262157zd2_8392;
																													}
																											}
																										else
																											{	/* Ast/sexp.scm 172 */
																												goto
																													BgL_tagzd262157zd2_8392;
																											}
																									}
																								else
																									{	/* Ast/sexp.scm 172 */
																										goto
																											BgL_tagzd262157zd2_8392;
																									}
																							}
																						else
																							{	/* Ast/sexp.scm 172 */
																								goto BgL_tagzd262157zd2_8392;
																							}
																					}
																				else
																					{	/* Ast/sexp.scm 172 */
																						goto BgL_tagzd262157zd2_8392;
																					}
																			}
																		else
																			{	/* Ast/sexp.scm 172 */
																				goto BgL_tagzd262157zd2_8392;
																			}
																	}
																}
															}
														else
															{	/* Ast/sexp.scm 119 */
																if (
																	(CAR(BgL_expz00_21) ==
																		CNST_TABLE_REF(((long) 14))))
																	{	/* Ast/sexp.scm 119 */
																		BgL_lz00_1714 = CDR(BgL_expz00_21);
																	BgL_tagzd2372zd2_1715:
																		{	/* Ast/sexp.scm 187 */
																			bool_t BgL_test8109z00_14102;

																			if (PAIRP(BgL_lz00_1714))
																				{	/* Ast/sexp.scm 187 */
																					bool_t BgL_test8111z00_14105;

																					{	/* Ast/sexp.scm 187 */
																						obj_t BgL_tmpz00_14106;

																						BgL_tmpz00_14106 =
																							CDR(BgL_lz00_1714);
																						BgL_test8111z00_14105 =
																							PAIRP(BgL_tmpz00_14106);
																					}
																					if (BgL_test8111z00_14105)
																						{
																							obj_t BgL_l1347z00_8434;

																							BgL_l1347z00_8434 = BgL_lz00_1714;
																						BgL_zc3z04anonymousza36640ze3z87_8435:
																							if (NULLP
																								(BgL_l1347z00_8434))
																								{	/* Ast/sexp.scm 187 */
																									BgL_test8109z00_14102 =
																										((bool_t) 1);
																								}
																							else
																								{	/* Ast/sexp.scm 187 */
																									bool_t BgL_test8113z00_14111;

																									{	/* Ast/sexp.scm 187 */
																										obj_t BgL_tmpz00_14112;

																										BgL_tmpz00_14112 =
																											CAR(
																											((obj_t)
																												BgL_l1347z00_8434));
																										BgL_test8113z00_14111 =
																											SYMBOLP(BgL_tmpz00_14112);
																									}
																									if (BgL_test8113z00_14111)
																										{
																											obj_t BgL_l1347z00_14116;

																											BgL_l1347z00_14116 =
																												CDR(
																												((obj_t)
																													BgL_l1347z00_8434));
																											BgL_l1347z00_8434 =
																												BgL_l1347z00_14116;
																											goto
																												BgL_zc3z04anonymousza36640ze3z87_8435;
																										}
																									else
																										{	/* Ast/sexp.scm 187 */
																											BgL_test8109z00_14102 =
																												((bool_t) 0);
																										}
																								}
																						}
																					else
																						{	/* Ast/sexp.scm 187 */
																							BgL_test8109z00_14102 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Ast/sexp.scm 187 */
																					BgL_test8109z00_14102 = ((bool_t) 0);
																				}
																			if (BgL_test8109z00_14102)
																				{	/* Ast/sexp.scm 187 */
																					return
																						BGl_fieldzd2refzd2ze3nodeze3zzast_objectz00
																						(BgL_lz00_1714, BgL_expz00_21,
																						BgL_stackz00_22, BgL_locz00_23,
																						BgL_sitez00_24);
																				}
																			else
																				{	/* Ast/sexp.scm 189 */
																					BgL_nodez00_bglt BgL_res7333z00_9696;

																					{	/* Ast/sexp.scm 723 */
																						obj_t BgL_arg7080z00_9692;
																						BgL_nodez00_bglt
																							BgL_arg7081z00_9693;
																						BgL_arg7080z00_9692 =
																							BGl_shapez00zztools_shapez00
																							(BGl_currentzd2functionzd2zztools_errorz00
																							());
																						BgL_arg7081z00_9693 =
																							BGl_sexpzd2ze3nodez31zzast_sexpz00
																							(CNST_TABLE_REF(((long) 4)), BNIL,
																							BgL_locz00_23,
																							CNST_TABLE_REF(((long) 2)));
																						{	/* Ast/sexp.scm 722 */
																							obj_t BgL_list7082z00_9695;

																							BgL_list7082z00_9695 =
																								MAKE_YOUNG_PAIR(
																								((obj_t) BgL_arg7081z00_9693),
																								BNIL);
																							BgL_res7333z00_9696 =
																								((BgL_nodez00_bglt)
																								BGl_userzd2errorzf2locationz20zztools_errorz00
																								(BgL_locz00_23,
																									BgL_arg7080z00_9692,
																									BGl_string8006z00zzast_sexpz00,
																									BgL_expz00_21,
																									BgL_list7082z00_9695));
																					}}
																					return BgL_res7333z00_9696;
																				}
																		}
																	}
																else
																	{	/* Ast/sexp.scm 119 */
																		if (
																			(CAR(BgL_expz00_21) ==
																				CNST_TABLE_REF(((long) 12))))
																			{	/* Ast/sexp.scm 119 */
																			BgL_tagzd2373zd2_1716:
																				{
																					obj_t BgL_valuez00_8443;

																					if (PAIRP(BgL_expz00_21))
																						{	/* Ast/sexp.scm 119 */
																							obj_t BgL_cdrzd262184zd2_8448;

																							BgL_cdrzd262184zd2_8448 =
																								CDR(BgL_expz00_21);
																							if (PAIRP
																								(BgL_cdrzd262184zd2_8448))
																								{	/* Ast/sexp.scm 119 */
																									if (NULLP(CDR
																											(BgL_cdrzd262184zd2_8448)))
																										{	/* Ast/sexp.scm 119 */
																											BgL_valuez00_8443 =
																												CAR
																												(BgL_cdrzd262184zd2_8448);
																											{	/* Ast/sexp.scm 194 */
																												obj_t BgL_locz00_8454;

																												BgL_locz00_8454 =
																													BGl_findzd2locationzf2locz20zztools_locationz00
																													(BgL_expz00_21,
																													BgL_locz00_23);
																												if (NULLP
																													(BgL_valuez00_8443))
																													{	/* Ast/sexp.scm 197 */
																														BgL_literalz00_bglt
																															BgL_new1120z00_8456;
																														{	/* Ast/sexp.scm 198 */
																															BgL_literalz00_bglt
																																BgL_new1119z00_8458;
																															BgL_new1119z00_8458
																																=
																																(
																																(BgL_literalz00_bglt)
																																BOBJECT
																																(GC_MALLOC
																																	(sizeof(struct
																																			BgL_literalz00_bgl))));
																															{	/* Ast/sexp.scm 198 */
																																long
																																	BgL_arg6652z00_8459;
																																{	/* Ast/sexp.scm 198 */
																																	long
																																		BgL_res7335z00_9699;
																																	BgL_res7335z00_9699
																																		=
																																		BGL_CLASS_INDEX
																																		(BGl_literalz00zzast_nodez00);
																																	BgL_arg6652z00_8459
																																		=
																																		BgL_res7335z00_9699;
																																}
																																BGL_OBJECT_CLASS_NUM_SET
																																	(((BgL_objectz00_bglt) BgL_new1119z00_8458), BgL_arg6652z00_8459);
																															}
																															{	/* Ast/sexp.scm 198 */
																																BgL_objectz00_bglt
																																	BgL_tmpz00_14149;
																																BgL_tmpz00_14149
																																	=
																																	(
																																	(BgL_objectz00_bglt)
																																	BgL_new1119z00_8458);
																																BGL_OBJECT_WIDENING_SET
																																	(BgL_tmpz00_14149,
																																	BFALSE);
																															}
																															((BgL_objectz00_bglt) BgL_new1119z00_8458);
																															BgL_new1120z00_8456
																																=
																																BgL_new1119z00_8458;
																														}
																														((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1120z00_8456)))->BgL_locz00) = ((obj_t) BgL_locz00_8454), BUNSPEC);
																														{
																															BgL_typez00_bglt
																																BgL_auxz00_14155;
																															{	/* Ast/sexp.scm 199 */
																																BgL_typez00_bglt
																																	BgL_arg6651z00_8457;
																																BgL_arg6651z00_8457
																																	=
																																	BGl_getzd2typezd2kwotez00zztype_typeofz00
																																	(BgL_valuez00_8443);
																																BgL_auxz00_14155
																																	=
																																	BGl_strictzd2nodezd2typez00zzast_nodez00
																																	(BgL_arg6651z00_8457,
																																	((BgL_typez00_bglt) BGl_za2bnilza2z00zztype_cachez00));
																															}
																															((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1120z00_8456)))->BgL_typez00) = ((BgL_typez00_bglt) BgL_auxz00_14155), BUNSPEC);
																														}
																														((((BgL_atomz00_bglt) COBJECT(((BgL_atomz00_bglt) BgL_new1120z00_8456)))->BgL_valuez00) = ((obj_t) BNIL), BUNSPEC);
																														return
																															(
																															(BgL_nodez00_bglt)
																															BgL_new1120z00_8456);
																													}
																												else
																													{	/* Ast/sexp.scm 201 */
																														bool_t
																															BgL_test8119z00_14164;
																														if (PAIRP
																															(BgL_valuez00_8443))
																															{	/* Ast/sexp.scm 201 */
																																BgL_test8119z00_14164
																																	=
																																	((bool_t) 1);
																															}
																														else
																															{	/* Ast/sexp.scm 201 */
																																if (VECTORP
																																	(BgL_valuez00_8443))
																																	{	/* Ast/sexp.scm 202 */
																																		BgL_test8119z00_14164
																																			=
																																			((bool_t)
																																			1);
																																	}
																																else
																																	{	/* Ast/sexp.scm 202 */
																																		if (BGL_HVECTORP(BgL_valuez00_8443))
																																			{	/* Ast/sexp.scm 203 */
																																				BgL_test8119z00_14164
																																					=
																																					(
																																					(bool_t)
																																					1);
																																			}
																																		else
																																			{	/* Ast/sexp.scm 203 */
																																				if (STRUCTP(BgL_valuez00_8443))
																																					{	/* Ast/sexp.scm 204 */
																																						BgL_test8119z00_14164
																																							=
																																							(
																																							(bool_t)
																																							1);
																																					}
																																				else
																																					{	/* Ast/sexp.scm 204 */
																																						if (SYMBOLP(BgL_valuez00_8443))
																																							{	/* Ast/sexp.scm 205 */
																																								BgL_test8119z00_14164
																																									=
																																									(
																																									(bool_t)
																																									1);
																																							}
																																						else
																																							{	/* Ast/sexp.scm 205 */
																																								BgL_test8119z00_14164
																																									=
																																									KEYWORDP
																																									(BgL_valuez00_8443);
																																							}
																																					}
																																			}
																																	}
																															}
																														if (BgL_test8119z00_14164)
																															{	/* Ast/sexp.scm 207 */
																																BgL_kwotez00_bglt
																																	BgL_new1122z00_8466;
																																{	/* Ast/sexp.scm 208 */
																																	BgL_kwotez00_bglt
																																		BgL_new1121z00_8468;
																																	BgL_new1121z00_8468
																																		=
																																		(
																																		(BgL_kwotez00_bglt)
																																		BOBJECT
																																		(GC_MALLOC
																																			(sizeof
																																				(struct
																																					BgL_kwotez00_bgl))));
																																	{	/* Ast/sexp.scm 208 */
																																		long
																																			BgL_arg6660z00_8469;
																																		{	/* Ast/sexp.scm 208 */
																																			long
																																				BgL_res7341z00_9709;
																																			BgL_res7341z00_9709
																																				=
																																				BGL_CLASS_INDEX
																																				(BGl_kwotez00zzast_nodez00);
																																			BgL_arg6660z00_8469
																																				=
																																				BgL_res7341z00_9709;
																																		}
																																		BGL_OBJECT_CLASS_NUM_SET
																																			(((BgL_objectz00_bglt) BgL_new1121z00_8468), BgL_arg6660z00_8469);
																																	}
																																	{	/* Ast/sexp.scm 208 */
																																		BgL_objectz00_bglt
																																			BgL_tmpz00_14180;
																																		BgL_tmpz00_14180
																																			=
																																			(
																																			(BgL_objectz00_bglt)
																																			BgL_new1121z00_8468);
																																		BGL_OBJECT_WIDENING_SET
																																			(BgL_tmpz00_14180,
																																			BFALSE);
																																	}
																																	((BgL_objectz00_bglt) BgL_new1121z00_8468);
																																	BgL_new1122z00_8466
																																		=
																																		BgL_new1121z00_8468;
																																}
																																((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1122z00_8466)))->BgL_locz00) = ((obj_t) BgL_locz00_8454), BUNSPEC);
																																{
																																	BgL_typez00_bglt
																																		BgL_auxz00_14186;
																																	{	/* Ast/sexp.scm 209 */
																																		BgL_typez00_bglt
																																			BgL_arg6659z00_8467;
																																		BgL_arg6659z00_8467
																																			=
																																			BGl_getzd2typezd2kwotez00zztype_typeofz00
																																			(BgL_valuez00_8443);
																																		BgL_auxz00_14186
																																			=
																																			BGl_strictzd2nodezd2typez00zzast_nodez00
																																			(BgL_arg6659z00_8467,
																																			((BgL_typez00_bglt) BGl_za2_za2z00zztype_cachez00));
																																	}
																																	((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1122z00_8466)))->BgL_typez00) = ((BgL_typez00_bglt) BgL_auxz00_14186), BUNSPEC);
																																}
																																((((BgL_kwotez00_bglt) COBJECT(BgL_new1122z00_8466))->BgL_valuez00) = ((obj_t) BgL_valuez00_8443), BUNSPEC);
																																return
																																	(
																																	(BgL_nodez00_bglt)
																																	BgL_new1122z00_8466);
																															}
																														else
																															{	/* Ast/sexp.scm 211 */
																																bool_t
																																	BgL_test8125z00_14194;
																																if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_valuez00_8443))
																																	{	/* Ast/sexp.scm 211 */
																																		BgL_test8125z00_14194
																																			=
																																			((bool_t)
																																			1);
																																	}
																																else
																																	{	/* Ast/sexp.scm 211 */
																																		if (STRINGP
																																			(BgL_valuez00_8443))
																																			{	/* Ast/sexp.scm 212 */
																																				BgL_test8125z00_14194
																																					=
																																					(
																																					(bool_t)
																																					1);
																																			}
																																		else
																																			{	/* Ast/sexp.scm 212 */
																																				if (CNSTP(BgL_valuez00_8443))
																																					{	/* Ast/sexp.scm 213 */
																																						BgL_test8125z00_14194
																																							=
																																							(
																																							(bool_t)
																																							1);
																																					}
																																				else
																																					{	/* Ast/sexp.scm 213 */
																																						if (CHARP(BgL_valuez00_8443))
																																							{	/* Ast/sexp.scm 217 */
																																								BgL_test8125z00_14194
																																									=
																																									(
																																									(bool_t)
																																									1);
																																							}
																																						else
																																							{	/* Ast/sexp.scm 217 */
																																								BgL_test8125z00_14194
																																									=
																																									BOOLEANP
																																									(BgL_valuez00_8443);
																																							}
																																					}
																																			}
																																	}
																																if (BgL_test8125z00_14194)
																																	{
																																		obj_t
																																			BgL_locz00_14205;
																																		obj_t
																																			BgL_expz00_14204;
																																		BgL_expz00_14204
																																			=
																																			BgL_valuez00_8443;
																																		BgL_locz00_14205
																																			=
																																			BgL_locz00_8454;
																																		BgL_locz00_23
																																			=
																																			BgL_locz00_14205;
																																		BgL_expz00_21
																																			=
																																			BgL_expz00_14204;
																																		goto
																																			BGl_sexpzd2ze3nodez31zzast_sexpz00;
																																	}
																																else
																																	{	/* Ast/sexp.scm 221 */
																																		BgL_nodez00_bglt
																																			BgL_res7346z00_9722;
																																		{	/* Ast/sexp.scm 723 */
																																			obj_t
																																				BgL_arg7080z00_9718;
																																			BgL_nodez00_bglt
																																				BgL_arg7081z00_9719;
																																			BgL_arg7080z00_9718
																																				=
																																				BGl_shapez00zztools_shapez00
																																				(BGl_currentzd2functionzd2zztools_errorz00
																																				());
																																			BgL_arg7081z00_9719
																																				=
																																				BGl_sexpzd2ze3nodez31zzast_sexpz00
																																				(CNST_TABLE_REF
																																				(((long)
																																						4)),
																																				BNIL,
																																				BgL_locz00_8454,
																																				CNST_TABLE_REF
																																				(((long)
																																						2)));
																																			{	/* Ast/sexp.scm 722 */
																																				obj_t
																																					BgL_list7082z00_9721;
																																				BgL_list7082z00_9721
																																					=
																																					MAKE_YOUNG_PAIR
																																					(((obj_t) BgL_arg7081z00_9719), BNIL);
																																				BgL_res7346z00_9722
																																					=
																																					(
																																					(BgL_nodez00_bglt)
																																					BGl_userzd2errorzf2locationz20zztools_errorz00
																																					(BgL_locz00_8454,
																																						BgL_arg7080z00_9718,
																																						BGl_string8008z00zzast_sexpz00,
																																						BgL_expz00_21,
																																						BgL_list7082z00_9721));
																																		}}
																																		return
																																			BgL_res7346z00_9722;
																																	}
																															}
																													}
																											}
																										}
																									else
																										{	/* Ast/sexp.scm 119 */
																										BgL_tagzd262179zd2_8445:
																											{	/* Ast/sexp.scm 223 */
																												BgL_nodez00_bglt
																													BgL_res7347z00_9728;
																												{	/* Ast/sexp.scm 723 */
																													obj_t
																														BgL_arg7080z00_9724;
																													BgL_nodez00_bglt
																														BgL_arg7081z00_9725;
																													BgL_arg7080z00_9724 =
																														BGl_shapez00zztools_shapez00
																														(BGl_currentzd2functionzd2zztools_errorz00
																														());
																													BgL_arg7081z00_9725 =
																														BGl_sexpzd2ze3nodez31zzast_sexpz00
																														(CNST_TABLE_REF((
																																(long) 4)),
																														BNIL, BgL_locz00_23,
																														CNST_TABLE_REF((
																																(long) 2)));
																													{	/* Ast/sexp.scm 722 */
																														obj_t
																															BgL_list7082z00_9727;
																														BgL_list7082z00_9727
																															=
																															MAKE_YOUNG_PAIR((
																																(obj_t)
																																BgL_arg7081z00_9725),
																															BNIL);
																														BgL_res7347z00_9728
																															=
																															(
																															(BgL_nodez00_bglt)
																															BGl_userzd2errorzf2locationz20zztools_errorz00
																															(BgL_locz00_23,
																																BgL_arg7080z00_9724,
																																BGl_string8008z00zzast_sexpz00,
																																BgL_expz00_21,
																																BgL_list7082z00_9727));
																												}}
																												return
																													BgL_res7347z00_9728;
																											}
																										}
																								}
																							else
																								{	/* Ast/sexp.scm 119 */
																									goto BgL_tagzd262179zd2_8445;
																								}
																						}
																					else
																						{	/* Ast/sexp.scm 119 */
																							goto BgL_tagzd262179zd2_8445;
																						}
																				}
																			}
																		else
																			{	/* Ast/sexp.scm 119 */
																				if (
																					(CAR(BgL_expz00_21) ==
																						CNST_TABLE_REF(((long) 15))))
																					{	/* Ast/sexp.scm 119 */
																						if (NULLP(CDR(BgL_expz00_21)))
																							{	/* Ast/sexp.scm 119 */
																							BgL_tagzd2374zd2_1717:
																								{
																									obj_t BgL_locz00_14233;
																									obj_t BgL_expz00_14232;

																									BgL_expz00_14232 = BUNSPEC;
																									BgL_locz00_14233 =
																										BGl_findzd2locationzf2locz20zztools_locationz00
																										(BgL_expz00_21,
																										BgL_locz00_23);
																									BgL_locz00_23 =
																										BgL_locz00_14233;
																									BgL_expz00_21 =
																										BgL_expz00_14232;
																									goto
																										BGl_sexpzd2ze3nodez31zzast_sexpz00;
																								}
																							}
																						else
																							{	/* Ast/sexp.scm 119 */
																								obj_t BgL_arg1578z00_1805;

																								BgL_arg1578z00_1805 =
																									CDR(BgL_expz00_21);
																								{
																									BgL_sequencez00_bglt
																										BgL_auxz00_14236;
																									BgL_bodyz00_1718 =
																										BgL_arg1578z00_1805;
																								BgL_tagzd2375zd2_1719:
																									{	/* Ast/sexp.scm 228 */
																										obj_t BgL_locz00_8485;

																										BgL_locz00_8485 =
																											BGl_findzd2locationzf2locz20zztools_locationz00
																											(BgL_expz00_21,
																											BgL_locz00_23);
																										{	/* Ast/sexp.scm 228 */
																											obj_t BgL_nodesz00_8486;

																											BgL_nodesz00_8486 =
																												BGl_sexpza2zd2ze3nodez93zzast_sexpz00
																												(BgL_bodyz00_1718,
																												BgL_stackz00_22,
																												BgL_locz00_8485,
																												BgL_sitez00_24);
																											{	/* Ast/sexp.scm 229 */

																												{	/* Ast/sexp.scm 230 */
																													BgL_sequencez00_bglt
																														BgL_new1125z00_8487;
																													{	/* Ast/sexp.scm 231 */
																														BgL_sequencez00_bglt
																															BgL_new1123z00_8488;
																														BgL_new1123z00_8488
																															=
																															(
																															(BgL_sequencez00_bglt)
																															BOBJECT(GC_MALLOC
																																(sizeof(struct
																																		BgL_sequencez00_bgl))));
																														{	/* Ast/sexp.scm 231 */
																															long
																																BgL_arg6667z00_8489;
																															{	/* Ast/sexp.scm 231 */
																																long
																																	BgL_res7351z00_9736;
																																BgL_res7351z00_9736
																																	=
																																	BGL_CLASS_INDEX
																																	(BGl_sequencez00zzast_nodez00);
																																BgL_arg6667z00_8489
																																	=
																																	BgL_res7351z00_9736;
																															}
																															BGL_OBJECT_CLASS_NUM_SET
																																(((BgL_objectz00_bglt) BgL_new1123z00_8488), BgL_arg6667z00_8489);
																														}
																														{	/* Ast/sexp.scm 231 */
																															BgL_objectz00_bglt
																																BgL_tmpz00_14243;
																															BgL_tmpz00_14243 =
																																(
																																(BgL_objectz00_bglt)
																																BgL_new1123z00_8488);
																															BGL_OBJECT_WIDENING_SET
																																(BgL_tmpz00_14243,
																																BFALSE);
																														}
																														((BgL_objectz00_bglt) BgL_new1123z00_8488);
																														BgL_new1125z00_8487
																															=
																															BgL_new1123z00_8488;
																													}
																													((((BgL_nodez00_bglt)
																																COBJECT((
																																		(BgL_nodez00_bglt)
																																		BgL_new1125z00_8487)))->
																															BgL_locz00) =
																														((obj_t)
																															BgL_locz00_8485),
																														BUNSPEC);
																													((((BgL_nodez00_bglt)
																																COBJECT((
																																		(BgL_nodez00_bglt)
																																		BgL_new1125z00_8487)))->
																															BgL_typez00) =
																														((BgL_typez00_bglt)
																															((BgL_typez00_bglt) BGl_za2_za2z00zztype_cachez00)), BUNSPEC);
																													((((BgL_nodezf2effectzf2_bglt) COBJECT(((BgL_nodezf2effectzf2_bglt) BgL_new1125z00_8487)))->BgL_sidezd2effectzd2) = ((obj_t) BUNSPEC), BUNSPEC);
																													((((BgL_nodezf2effectzf2_bglt) COBJECT(((BgL_nodezf2effectzf2_bglt) BgL_new1125z00_8487)))->BgL_keyz00) = ((obj_t) BINT(((long) -1))), BUNSPEC);
																													((((BgL_sequencez00_bglt) COBJECT(BgL_new1125z00_8487))->BgL_nodesz00) = ((obj_t) BgL_nodesz00_8486), BUNSPEC);
																													((((BgL_sequencez00_bglt) COBJECT(BgL_new1125z00_8487))->BgL_unsafez00) = ((bool_t) ((bool_t) 0)), BUNSPEC);
																													((((BgL_sequencez00_bglt) COBJECT(BgL_new1125z00_8487))->BgL_metaz00) = ((obj_t) BNIL), BUNSPEC);
																													BgL_auxz00_14236 =
																														BgL_new1125z00_8487;
																									}}}}
																									return
																										((BgL_nodez00_bglt)
																										BgL_auxz00_14236);
																								}
																							}
																					}
																				else
																					{	/* Ast/sexp.scm 119 */
																						obj_t BgL_carzd2610zd2_1807;
																						obj_t BgL_cdrzd2611zd2_1808;

																						BgL_carzd2610zd2_1807 =
																							CAR(BgL_expz00_21);
																						BgL_cdrzd2611zd2_1808 =
																							CDR(BgL_expz00_21);
																						{

																							if (
																								(BgL_carzd2610zd2_1807 ==
																									CNST_TABLE_REF(((long) 1))))
																								{
																									obj_t BgL_auxz00_14266;

																								BgL_kapzd2612zd2_1809:
																									if (PAIRP
																										(BgL_cdrzd2611zd2_1808))
																										{	/* Ast/sexp.scm 119 */
																											obj_t
																												BgL_cdrzd2615zd2_2556;
																											BgL_cdrzd2615zd2_2556 =
																												CDR
																												(BgL_cdrzd2611zd2_1808);
																											if (PAIRP
																												(BgL_cdrzd2615zd2_2556))
																												{	/* Ast/sexp.scm 119 */
																													obj_t
																														BgL_cdrzd2618zd2_2558;
																													BgL_cdrzd2618zd2_2558
																														=
																														CDR
																														(BgL_cdrzd2615zd2_2556);
																													if ((CAR
																															(BgL_cdrzd2615zd2_2556)
																															== BTRUE))
																														{	/* Ast/sexp.scm 119 */
																															if (PAIRP
																																(BgL_cdrzd2618zd2_2558))
																																{	/* Ast/sexp.scm 119 */
																																	if (
																																		(CAR
																																			(BgL_cdrzd2618zd2_2558)
																																			==
																																			BFALSE))
																																		{	/* Ast/sexp.scm 119 */
																																			if (NULLP
																																				(CDR
																																					(BgL_cdrzd2618zd2_2558)))
																																				{	/* Ast/sexp.scm 119 */
																																					if (
																																						(BgL_sitez00_24
																																							==
																																							CNST_TABLE_REF
																																							(((long) 8))))
																																						{	/* Ast/sexp.scm 119 */
																																							obj_t
																																								BgL_arg2228z00_2568;
																																							BgL_arg2228z00_2568
																																								=
																																								CAR
																																								(BgL_cdrzd2611zd2_1808);
																																							BgL_auxz00_14266
																																								=
																																								(
																																								(obj_t)
																																								BGl_sexpzd2ze3nodez31zzast_sexpz00
																																								(BgL_arg2228z00_2568,
																																									BgL_stackz00_22,
																																									BgL_locz00_23,
																																									BgL_sitez00_24));
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							obj_t
																																								BgL_carzd2637zd2_2569;
																																							BgL_carzd2637zd2_2569
																																								=
																																								CAR
																																								(
																																								((obj_t) BgL_expz00_21));
																																							if ((BgL_carzd2637zd2_2569 == CNST_TABLE_REF(((long) 1))))
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_14295;
																																								BgL_tagzd2377zd2_1722:
																																									{
																																										obj_t
																																											BgL_siz00_8490;
																																										obj_t
																																											BgL_alorsz00_8491;
																																										obj_t
																																											BgL_sinonz00_8492;
																																										obj_t
																																											BgL_siz00_8494;
																																										obj_t
																																											BgL_alorsz00_8495;
																																										if (PAIRP(BgL_expz00_21))
																																											{	/* Ast/sexp.scm 119 */
																																												obj_t
																																													BgL_cdrzd262200zd2_8500;
																																												BgL_cdrzd262200zd2_8500
																																													=
																																													CDR
																																													(BgL_expz00_21);
																																												if (PAIRP(BgL_cdrzd262200zd2_8500))
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_cdrzd262205zd2_8502;
																																														BgL_cdrzd262205zd2_8502
																																															=
																																															CDR
																																															(BgL_cdrzd262200zd2_8500);
																																														if (PAIRP(BgL_cdrzd262205zd2_8502))
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_cdrzd262210zd2_8504;
																																																BgL_cdrzd262210zd2_8504
																																																	=
																																																	CDR
																																																	(BgL_cdrzd262205zd2_8502);
																																																if (PAIRP(BgL_cdrzd262210zd2_8504))
																																																	{	/* Ast/sexp.scm 119 */
																																																		if (NULLP(CDR(BgL_cdrzd262210zd2_8504)))
																																																			{	/* Ast/sexp.scm 119 */
																																																				BgL_siz00_8490
																																																					=
																																																					CAR
																																																					(BgL_cdrzd262200zd2_8500);
																																																				BgL_alorsz00_8491
																																																					=
																																																					CAR
																																																					(BgL_cdrzd262205zd2_8502);
																																																				BgL_sinonz00_8492
																																																					=
																																																					CAR
																																																					(BgL_cdrzd262210zd2_8504);
																																																				{	/* Ast/sexp.scm 241 */
																																																					obj_t
																																																						BgL_ntz00_8519;
																																																					BgL_ntz00_8519
																																																						=
																																																						BGl_notzd2testzd2zzast_sexpz00
																																																						(BgL_siz00_8490);
																																																					if (CBOOL(BgL_ntz00_8519))
																																																						{	/* Ast/sexp.scm 242 */
																																																							{	/* Ast/sexp.scm 244 */
																																																								obj_t
																																																									BgL_arg6683z00_8520;
																																																								BgL_arg6683z00_8520
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{	/* Ast/sexp.scm 244 */
																																																									obj_t
																																																										BgL_tmpz00_14315;
																																																									BgL_tmpz00_14315
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_arg6683z00_8520);
																																																									SET_CAR
																																																										(BgL_tmpz00_14315,
																																																										BgL_ntz00_8519);
																																																								}
																																																							}
																																																							{	/* Ast/sexp.scm 245 */
																																																								obj_t
																																																									BgL_arg6684z00_8521;
																																																								{	/* Ast/sexp.scm 245 */
																																																									obj_t
																																																										BgL_pairz00_9745;
																																																									BgL_pairz00_9745
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									BgL_arg6684z00_8521
																																																										=
																																																										CDR
																																																										(BgL_pairz00_9745);
																																																								}
																																																								{	/* Ast/sexp.scm 245 */
																																																									obj_t
																																																										BgL_tmpz00_14321;
																																																									BgL_tmpz00_14321
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_arg6684z00_8521);
																																																									SET_CAR
																																																										(BgL_tmpz00_14321,
																																																										BgL_sinonz00_8492);
																																																								}
																																																							}
																																																							{	/* Ast/sexp.scm 246 */
																																																								obj_t
																																																									BgL_arg6685z00_8522;
																																																								{	/* Ast/sexp.scm 246 */
																																																									obj_t
																																																										BgL_pairz00_9752;
																																																									{	/* Ast/sexp.scm 246 */
																																																										obj_t
																																																											BgL_pairz00_9751;
																																																										BgL_pairz00_9751
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_pairz00_9752
																																																											=
																																																											CDR
																																																											(BgL_pairz00_9751);
																																																									}
																																																									BgL_arg6685z00_8522
																																																										=
																																																										CDR
																																																										(BgL_pairz00_9752);
																																																								}
																																																								{	/* Ast/sexp.scm 246 */
																																																									obj_t
																																																										BgL_tmpz00_14328;
																																																									BgL_tmpz00_14328
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_arg6685z00_8522);
																																																									SET_CAR
																																																										(BgL_tmpz00_14328,
																																																										BgL_alorsz00_8491);
																																																								}
																																																							}
																																																							BgL_auxz00_14295
																																																								=
																																																								BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																								(BgL_expz00_21,
																																																								BgL_stackz00_22,
																																																								BgL_locz00_23,
																																																								BgL_sitez00_24);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 248 */
																																																							obj_t
																																																								BgL_locz00_8523;
																																																							BgL_locz00_8523
																																																								=
																																																								BGl_findzd2locationzf2locz20zztools_locationz00
																																																								(BgL_expz00_21,
																																																								BgL_locz00_23);
																																																							{	/* Ast/sexp.scm 248 */
																																																								obj_t
																																																									BgL_cdlocz00_8524;
																																																								{	/* Ast/sexp.scm 249 */
																																																									obj_t
																																																										BgL_arg6705z00_8558;
																																																									BgL_arg6705z00_8558
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									BgL_cdlocz00_8524
																																																										=
																																																										BGl_findzd2locationzf2locz20zztools_locationz00
																																																										(BgL_arg6705z00_8558,
																																																										BgL_locz00_8523);
																																																								}
																																																								{	/* Ast/sexp.scm 249 */
																																																									obj_t
																																																										BgL_cddlocz00_8525;
																																																									{	/* Ast/sexp.scm 250 */
																																																										obj_t
																																																											BgL_arg6704z00_8557;
																																																										{	/* Ast/sexp.scm 250 */
																																																											obj_t
																																																												BgL_pairz00_9758;
																																																											BgL_pairz00_9758
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											BgL_arg6704z00_8557
																																																												=
																																																												CDR
																																																												(BgL_pairz00_9758);
																																																										}
																																																										BgL_cddlocz00_8525
																																																											=
																																																											BGl_findzd2locationzf2locz20zztools_locationz00
																																																											(BgL_arg6704z00_8557,
																																																											BgL_locz00_8523);
																																																									}
																																																									{	/* Ast/sexp.scm 250 */
																																																										obj_t
																																																											BgL_cdddlocz00_8526;
																																																										{	/* Ast/sexp.scm 251 */
																																																											obj_t
																																																												BgL_arg6703z00_8556;
																																																											{	/* Ast/sexp.scm 251 */
																																																												obj_t
																																																													BgL_pairz00_9764;
																																																												{	/* Ast/sexp.scm 251 */
																																																													obj_t
																																																														BgL_pairz00_9763;
																																																													BgL_pairz00_9763
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													BgL_pairz00_9764
																																																														=
																																																														CDR
																																																														(BgL_pairz00_9763);
																																																												}
																																																												BgL_arg6703z00_8556
																																																													=
																																																													CDR
																																																													(BgL_pairz00_9764);
																																																											}
																																																											BgL_cdddlocz00_8526
																																																												=
																																																												BGl_findzd2locationzf2locz20zztools_locationz00
																																																												(BgL_arg6703z00_8556,
																																																												BgL_locz00_8523);
																																																										}
																																																										{	/* Ast/sexp.scm 251 */
																																																											obj_t
																																																												BgL_lzd2sizd2_8527;
																																																											BgL_lzd2sizd2_8527
																																																												=
																																																												BGl_findzd2locationzf2locz20zztools_locationz00
																																																												(BgL_siz00_8490,
																																																												BgL_cdlocz00_8524);
																																																											{	/* Ast/sexp.scm 252 */
																																																												obj_t
																																																													BgL_lzd2alorszd2_8528;
																																																												BgL_lzd2alorszd2_8528
																																																													=
																																																													BGl_findzd2locationzf2locz20zztools_locationz00
																																																													(BgL_alorsz00_8491,
																																																													BgL_cddlocz00_8525);
																																																												{	/* Ast/sexp.scm 253 */
																																																													obj_t
																																																														BgL_lzd2sinonzd2_8529;
																																																													BgL_lzd2sinonzd2_8529
																																																														=
																																																														BGl_findzd2locationzf2locz20zztools_locationz00
																																																														(BgL_sinonz00_8492,
																																																														BgL_cdddlocz00_8526);
																																																													{	/* Ast/sexp.scm 254 */
																																																														BgL_nodez00_bglt
																																																															BgL_testz00_8530;
																																																														BgL_testz00_8530
																																																															=
																																																															BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																															(BgL_siz00_8490,
																																																															BgL_stackz00_22,
																																																															BgL_locz00_8523,
																																																															CNST_TABLE_REF
																																																															(((long) 8)));
																																																														{	/* Ast/sexp.scm 255 */

																																																															{	/* Ast/sexp.scm 257 */
																																																																bool_t
																																																																	BgL_test8147z00_14350;
																																																																{	/* Ast/sexp.scm 257 */
																																																																	bool_t
																																																																		BgL_res7352z00_9765;
																																																																	BgL_res7352z00_9765
																																																																		=
																																																																		BGl_isazf3zf3zz__objectz00
																																																																		(
																																																																		((obj_t) BgL_testz00_8530), BGl_atomz00zzast_nodez00);
																																																																	BgL_test8147z00_14350
																																																																		=
																																																																		BgL_res7352z00_9765;
																																																																}
																																																																if (BgL_test8147z00_14350)
																																																																	{	/* Ast/sexp.scm 257 */
																																																																		if (CBOOL((((BgL_atomz00_bglt) COBJECT(((BgL_atomz00_bglt) BgL_testz00_8530)))->BgL_valuez00)))
																																																																			{	/* Ast/sexp.scm 259 */
																																																																				BgL_auxz00_14295
																																																																					=
																																																																					BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																					(BgL_alorsz00_8491,
																																																																					BgL_stackz00_22,
																																																																					BgL_lzd2alorszd2_8528,
																																																																					CNST_TABLE_REF
																																																																					(((long) 2)));
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 259 */
																																																																				BgL_auxz00_14295
																																																																					=
																																																																					BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																					(BgL_sinonz00_8492,
																																																																					BgL_stackz00_22,
																																																																					BgL_lzd2sinonzd2_8529,
																																																																					CNST_TABLE_REF
																																																																					(((long) 2)));
																																																																	}}
																																																																else
																																																																	{	/* Ast/sexp.scm 262 */
																																																																		bool_t
																																																																			BgL_test8149z00_14361;
																																																																		{	/* Ast/sexp.scm 262 */
																																																																			bool_t
																																																																				BgL_res7353z00_9766;
																																																																			BgL_res7353z00_9766
																																																																				=
																																																																				BGl_isazf3zf3zz__objectz00
																																																																				(
																																																																				((obj_t) BgL_testz00_8530), BGl_kwotez00zzast_nodez00);
																																																																			BgL_test8149z00_14361
																																																																				=
																																																																				BgL_res7353z00_9766;
																																																																		}
																																																																		if (BgL_test8149z00_14361)
																																																																			{	/* Ast/sexp.scm 262 */
																																																																				BgL_auxz00_14295
																																																																					=
																																																																					BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																					(BgL_alorsz00_8491,
																																																																					BgL_stackz00_22,
																																																																					BgL_lzd2alorszd2_8528,
																																																																					CNST_TABLE_REF
																																																																					(((long) 2)));
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 264 */
																																																																				bool_t
																																																																					BgL_test8150z00_14366;
																																																																				{	/* Ast/sexp.scm 264 */
																																																																					bool_t
																																																																						BgL_res7354z00_9767;
																																																																					BgL_res7354z00_9767
																																																																						=
																																																																						BGl_isazf3zf3zz__objectz00
																																																																						(
																																																																						((obj_t) BgL_testz00_8530), BGl_varz00zzast_nodez00);
																																																																					BgL_test8150z00_14366
																																																																						=
																																																																						BgL_res7354z00_9767;
																																																																				}
																																																																				if (BgL_test8150z00_14366)
																																																																					{	/* Ast/sexp.scm 265 */
																																																																						BgL_nodez00_bglt
																																																																							BgL_alorsz00_8536;
																																																																						BgL_nodez00_bglt
																																																																							BgL_sinonz00_8537;
																																																																						BgL_alorsz00_8536
																																																																							=
																																																																							BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																							(BgL_alorsz00_8491,
																																																																							BgL_stackz00_22,
																																																																							BgL_lzd2alorszd2_8528,
																																																																							CNST_TABLE_REF
																																																																							(((long) 2)));
																																																																						BgL_sinonz00_8537
																																																																							=
																																																																							BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																							(BgL_sinonz00_8492,
																																																																							BgL_stackz00_22,
																																																																							BgL_lzd2sinonzd2_8529,
																																																																							CNST_TABLE_REF
																																																																							(((long) 2)));
																																																																						{	/* Ast/sexp.scm 267 */
																																																																							BgL_conditionalz00_bglt
																																																																								BgL_new1130z00_8538;
																																																																							{	/* Ast/sexp.scm 268 */
																																																																								BgL_conditionalz00_bglt
																																																																									BgL_new1129z00_8539;
																																																																								BgL_new1129z00_8539
																																																																									=
																																																																									(
																																																																									(BgL_conditionalz00_bglt)
																																																																									BOBJECT
																																																																									(GC_MALLOC
																																																																										(sizeof
																																																																											(struct
																																																																												BgL_conditionalz00_bgl))));
																																																																								{	/* Ast/sexp.scm 268 */
																																																																									long
																																																																										BgL_arg6690z00_8540;
																																																																									{	/* Ast/sexp.scm 268 */
																																																																										long
																																																																											BgL_res7355z00_9769;
																																																																										BgL_res7355z00_9769
																																																																											=
																																																																											BGL_CLASS_INDEX
																																																																											(BGl_conditionalz00zzast_nodez00);
																																																																										BgL_arg6690z00_8540
																																																																											=
																																																																											BgL_res7355z00_9769;
																																																																									}
																																																																									BGL_OBJECT_CLASS_NUM_SET
																																																																										(
																																																																										((BgL_objectz00_bglt) BgL_new1129z00_8539), BgL_arg6690z00_8540);
																																																																								}
																																																																								{	/* Ast/sexp.scm 268 */
																																																																									BgL_objectz00_bglt
																																																																										BgL_tmpz00_14377;
																																																																									BgL_tmpz00_14377
																																																																										=
																																																																										(
																																																																										(BgL_objectz00_bglt)
																																																																										BgL_new1129z00_8539);
																																																																									BGL_OBJECT_WIDENING_SET
																																																																										(BgL_tmpz00_14377,
																																																																										BFALSE);
																																																																								}
																																																																								((BgL_objectz00_bglt) BgL_new1129z00_8539);
																																																																								BgL_new1130z00_8538
																																																																									=
																																																																									BgL_new1129z00_8539;
																																																																							}
																																																																							((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1130z00_8538)))->BgL_locz00) = ((obj_t) BgL_locz00_8523), BUNSPEC);
																																																																							((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1130z00_8538)))->BgL_typez00) = ((BgL_typez00_bglt) ((BgL_typez00_bglt) BGl_za2_za2z00zztype_cachez00)), BUNSPEC);
																																																																							((((BgL_nodezf2effectzf2_bglt) COBJECT(((BgL_nodezf2effectzf2_bglt) BgL_new1130z00_8538)))->BgL_sidezd2effectzd2) = ((obj_t) BUNSPEC), BUNSPEC);
																																																																							((((BgL_nodezf2effectzf2_bglt) COBJECT(((BgL_nodezf2effectzf2_bglt) BgL_new1130z00_8538)))->BgL_keyz00) = ((obj_t) BINT(((long) -1))), BUNSPEC);
																																																																							((((BgL_conditionalz00_bglt) COBJECT(BgL_new1130z00_8538))->BgL_testz00) = ((BgL_nodez00_bglt) BgL_testz00_8530), BUNSPEC);
																																																																							((((BgL_conditionalz00_bglt) COBJECT(BgL_new1130z00_8538))->BgL_truez00) = ((BgL_nodez00_bglt) BgL_alorsz00_8536), BUNSPEC);
																																																																							((((BgL_conditionalz00_bglt) COBJECT(BgL_new1130z00_8538))->BgL_falsez00) = ((BgL_nodez00_bglt) BgL_sinonz00_8537), BUNSPEC);
																																																																							BgL_auxz00_14295
																																																																								=
																																																																								(
																																																																								(BgL_nodez00_bglt)
																																																																								BgL_new1130z00_8538);
																																																																					}}
																																																																				else
																																																																					{	/* Ast/sexp.scm 274 */
																																																																						obj_t
																																																																							BgL_vz00_8541;
																																																																						BgL_vz00_8541
																																																																							=
																																																																							BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
																																																																							(BGl_gensymz00zz__r4_symbols_6_4z00
																																																																							(CNST_TABLE_REF
																																																																								(((long) 8))));
																																																																						{	/* Ast/sexp.scm 274 */
																																																																							obj_t
																																																																								BgL_varz00_8542;
																																																																							BgL_varz00_8542
																																																																								=
																																																																								BGl_makezd2typedzd2identz00zzast_identz00
																																																																								(BgL_vz00_8541,
																																																																								CNST_TABLE_REF
																																																																								(((long) 9)));
																																																																							{	/* Ast/sexp.scm 275 */
																																																																								obj_t
																																																																									BgL_nexpz00_8543;
																																																																								{	/* Ast/sexp.scm 276 */
																																																																									obj_t
																																																																										BgL_arg6698z00_8551;
																																																																									{	/* Ast/sexp.scm 276 */
																																																																										obj_t
																																																																											BgL_arg6699z00_8552;
																																																																										{	/* Ast/sexp.scm 276 */
																																																																											obj_t
																																																																												BgL_arg6700z00_8553;
																																																																											{	/* Ast/sexp.scm 276 */
																																																																												obj_t
																																																																													BgL_arg6701z00_8554;
																																																																												BgL_arg6701z00_8554
																																																																													=
																																																																													MAKE_YOUNG_PAIR
																																																																													(BgL_sinonz00_8492,
																																																																													BNIL);
																																																																												BgL_arg6700z00_8553
																																																																													=
																																																																													MAKE_YOUNG_PAIR
																																																																													(BgL_alorsz00_8491,
																																																																													BgL_arg6701z00_8554);
																																																																											}
																																																																											BgL_arg6699z00_8552
																																																																												=
																																																																												MAKE_YOUNG_PAIR
																																																																												(BgL_vz00_8541,
																																																																												BgL_arg6700z00_8553);
																																																																										}
																																																																										BgL_arg6698z00_8551
																																																																											=
																																																																											MAKE_YOUNG_PAIR
																																																																											(CNST_TABLE_REF
																																																																											(((long) 1)), BgL_arg6699z00_8552);
																																																																									}
																																																																									BgL_nexpz00_8543
																																																																										=
																																																																										BGl_epairifyzd2reczd2zztools_miscz00
																																																																										(BgL_arg6698z00_8551,
																																																																										BgL_expz00_21);
																																																																								}
																																																																								{	/* Ast/sexp.scm 276 */

																																																																									{	/* Ast/sexp.scm 277 */
																																																																										obj_t
																																																																											BgL_arg6691z00_8544;
																																																																										{	/* Ast/sexp.scm 277 */
																																																																											obj_t
																																																																												BgL_arg6692z00_8545;
																																																																											obj_t
																																																																												BgL_arg6693z00_8546;
																																																																											BgL_arg6692z00_8545
																																																																												=
																																																																												BGl_letzd2symzd2zzast_letz00
																																																																												();
																																																																											{	/* Ast/sexp.scm 277 */
																																																																												obj_t
																																																																													BgL_arg6694z00_8547;
																																																																												obj_t
																																																																													BgL_arg6695z00_8548;
																																																																												{	/* Ast/sexp.scm 277 */
																																																																													obj_t
																																																																														BgL_arg6696z00_8549;
																																																																													{	/* Ast/sexp.scm 277 */
																																																																														obj_t
																																																																															BgL_arg6697z00_8550;
																																																																														BgL_arg6697z00_8550
																																																																															=
																																																																															MAKE_YOUNG_PAIR
																																																																															(BgL_siz00_8490,
																																																																															BNIL);
																																																																														BgL_arg6696z00_8549
																																																																															=
																																																																															MAKE_YOUNG_PAIR
																																																																															(BgL_varz00_8542,
																																																																															BgL_arg6697z00_8550);
																																																																													}
																																																																													BgL_arg6694z00_8547
																																																																														=
																																																																														MAKE_YOUNG_PAIR
																																																																														(BgL_arg6696z00_8549,
																																																																														BNIL);
																																																																												}
																																																																												BgL_arg6695z00_8548
																																																																													=
																																																																													MAKE_YOUNG_PAIR
																																																																													(BgL_nexpz00_8543,
																																																																													BNIL);
																																																																												BgL_arg6693z00_8546
																																																																													=
																																																																													MAKE_YOUNG_PAIR
																																																																													(BgL_arg6694z00_8547,
																																																																													BgL_arg6695z00_8548);
																																																																											}
																																																																											BgL_arg6691z00_8544
																																																																												=
																																																																												MAKE_YOUNG_PAIR
																																																																												(BgL_arg6692z00_8545,
																																																																												BgL_arg6693z00_8546);
																																																																										}
																																																																										BGl_replacez12z12zztools_miscz00
																																																																											(BgL_expz00_21,
																																																																											BgL_arg6691z00_8544);
																																																																									}
																																																																									BgL_auxz00_14295
																																																																										=
																																																																										BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																										(BgL_expz00_21,
																																																																										BgL_stackz00_22,
																																																																										BgL_locz00_8523,
																																																																										BgL_sitez00_24);
																																																			}}}}}}}}}}}}}}}}}}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																			BgL_tagzd262191zd2_8497:
																																																				{	/* Ast/sexp.scm 283 */
																																																					BgL_nodez00_bglt
																																																						BgL_res7357z00_9784;
																																																					{	/* Ast/sexp.scm 723 */
																																																						obj_t
																																																							BgL_arg7080z00_9780;
																																																						BgL_nodez00_bglt
																																																							BgL_arg7081z00_9781;
																																																						BgL_arg7080z00_9780
																																																							=
																																																							BGl_shapez00zztools_shapez00
																																																							(BGl_currentzd2functionzd2zztools_errorz00
																																																							());
																																																						BgL_arg7081z00_9781
																																																							=
																																																							BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																							(CNST_TABLE_REF
																																																							(((long) 4)), BNIL, BgL_locz00_23, CNST_TABLE_REF(((long) 2)));
																																																						{	/* Ast/sexp.scm 722 */
																																																							obj_t
																																																								BgL_list7082z00_9783;
																																																							BgL_list7082z00_9783
																																																								=
																																																								MAKE_YOUNG_PAIR
																																																								(
																																																								((obj_t) BgL_arg7081z00_9781), BNIL);
																																																							BgL_res7357z00_9784
																																																								=
																																																								(
																																																								(BgL_nodez00_bglt)
																																																								BGl_userzd2errorzf2locationz20zztools_errorz00
																																																								(BgL_locz00_23,
																																																									BgL_arg7080z00_9780,
																																																									BGl_string8007z00zzast_sexpz00,
																																																									BgL_expz00_21,
																																																									BgL_list7082z00_9783));
																																																					}}
																																																					BgL_auxz00_14295
																																																						=
																																																						BgL_res7357z00_9784;
																																																	}}}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_cdrzd262235zd2_8513;
																																																		BgL_cdrzd262235zd2_8513
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_cdrzd262200zd2_8500));
																																																		if (NULLP(CDR(((obj_t) BgL_cdrzd262235zd2_8513))))
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg6680z00_8516;
																																																				obj_t
																																																					BgL_arg6681z00_8517;
																																																				BgL_arg6680z00_8516
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_cdrzd262200zd2_8500));
																																																				BgL_arg6681z00_8517
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_cdrzd262235zd2_8513));
																																																				BgL_siz00_8494
																																																					=
																																																					BgL_arg6680z00_8516;
																																																				BgL_alorsz00_8495
																																																					=
																																																					BgL_arg6681z00_8517;
																																																				{	/* Ast/sexp.scm 280 */
																																																					obj_t
																																																						BgL_arg6706z00_8559;
																																																					obj_t
																																																						BgL_arg6707z00_8560;
																																																					{	/* Ast/sexp.scm 280 */
																																																						obj_t
																																																							BgL_pairz00_9776;
																																																						BgL_pairz00_9776
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_arg6706z00_8559
																																																							=
																																																							CDR
																																																							(BgL_pairz00_9776);
																																																					}
																																																					{	/* Ast/sexp.scm 280 */
																																																						obj_t
																																																							BgL_list6708z00_8561;
																																																						BgL_list6708z00_8561
																																																							=
																																																							MAKE_YOUNG_PAIR
																																																							(BUNSPEC,
																																																							BNIL);
																																																						BgL_arg6707z00_8560
																																																							=
																																																							BgL_list6708z00_8561;
																																																					}
																																																					{	/* Ast/sexp.scm 280 */
																																																						obj_t
																																																							BgL_tmpz00_14441;
																																																						BgL_tmpz00_14441
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_arg6706z00_8559);
																																																						SET_CDR
																																																							(BgL_tmpz00_14441,
																																																							BgL_arg6707z00_8560);
																																																					}
																																																				}
																																																				BgL_auxz00_14295
																																																					=
																																																					BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																					(BgL_expz00_21,
																																																					BgL_stackz00_22,
																																																					BgL_locz00_23,
																																																					BgL_sitez00_24);
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				goto
																																																					BgL_tagzd262191zd2_8497;
																																																			}
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																goto
																																																	BgL_tagzd262191zd2_8497;
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														goto
																																															BgL_tagzd262191zd2_8497;
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												goto
																																													BgL_tagzd262191zd2_8497;
																																											}
																																									}
																																									BgL_auxz00_14266
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_14295);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									if ((BgL_carzd2637zd2_2569 == BGl_za2ifza2z00zzast_sexpz00))
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_14448;
																																											goto
																																												BgL_tagzd2377zd2_1722;
																																											BgL_auxz00_14266
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_14448);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 7))))
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_14455;
																																												BgL_tagzd2379zd2_1726:
																																													{
																																														obj_t
																																															BgL_varz00_8588;
																																														obj_t
																																															BgL_valz00_8589;
																																														if (PAIRP(BgL_expz00_21))
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_cdrzd262265zd2_8594;
																																																BgL_cdrzd262265zd2_8594
																																																	=
																																																	CDR
																																																	(BgL_expz00_21);
																																																if (PAIRP(BgL_cdrzd262265zd2_8594))
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_cdrzd262269zd2_8596;
																																																		BgL_cdrzd262269zd2_8596
																																																			=
																																																			CDR
																																																			(BgL_cdrzd262265zd2_8594);
																																																		if (PAIRP(BgL_cdrzd262269zd2_8596))
																																																			{	/* Ast/sexp.scm 119 */
																																																				if (NULLP(CDR(BgL_cdrzd262269zd2_8596)))
																																																					{	/* Ast/sexp.scm 119 */
																																																						BgL_varz00_8588
																																																							=
																																																							CAR
																																																							(BgL_cdrzd262265zd2_8594);
																																																						BgL_valz00_8589
																																																							=
																																																							CAR
																																																							(BgL_cdrzd262269zd2_8596);
																																																						{	/* Ast/sexp.scm 292 */
																																																							obj_t
																																																								BgL_locz00_8603;
																																																							BgL_locz00_8603
																																																								=
																																																								BGl_findzd2locationzf2locz20zztools_locationz00
																																																								(BgL_expz00_21,
																																																								BgL_locz00_23);
																																																							{	/* Ast/sexp.scm 292 */
																																																								obj_t
																																																									BgL_cdlocz00_8604;
																																																								{	/* Ast/sexp.scm 293 */
																																																									obj_t
																																																										BgL_arg6745z00_8631;
																																																									BgL_arg6745z00_8631
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									BgL_cdlocz00_8604
																																																										=
																																																										BGl_findzd2locationzf2locz20zztools_locationz00
																																																										(BgL_arg6745z00_8631,
																																																										BgL_locz00_8603);
																																																								}
																																																								{	/* Ast/sexp.scm 293 */
																																																									obj_t
																																																										BgL_cddlocz00_8605;
																																																									{	/* Ast/sexp.scm 294 */
																																																										obj_t
																																																											BgL_arg6744z00_8630;
																																																										{	/* Ast/sexp.scm 294 */
																																																											obj_t
																																																												BgL_pairz00_9820;
																																																											BgL_pairz00_9820
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											BgL_arg6744z00_8630
																																																												=
																																																												CDR
																																																												(BgL_pairz00_9820);
																																																										}
																																																										BgL_cddlocz00_8605
																																																											=
																																																											BGl_findzd2locationzf2locz20zztools_locationz00
																																																											(BgL_arg6744z00_8630,
																																																											BgL_locz00_8603);
																																																									}
																																																									{	/* Ast/sexp.scm 294 */
																																																										obj_t
																																																											BgL_valzd2loczd2_8606;
																																																										BgL_valzd2loczd2_8606
																																																											=
																																																											BGl_findzd2locationzf2locz20zztools_locationz00
																																																											(BgL_valz00_8589,
																																																											BgL_cddlocz00_8605);
																																																										{	/* Ast/sexp.scm 295 */
																																																											BgL_nodez00_bglt
																																																												BgL_valz00_8607;
																																																											{

																																																												if (PAIRP(BgL_valz00_8589))
																																																													{	/* Ast/sexp.scm 296 */
																																																														if ((CAR(BgL_valz00_8589) == CNST_TABLE_REF(((long) 3))))
																																																															{	/* Ast/sexp.scm 296 */
																																																																{	/* Ast/sexp.scm 299 */
																																																																	obj_t
																																																																		BgL_arg6743z00_8629;
																																																																	{	/* Ast/sexp.scm 299 */
																																																																		obj_t
																																																																			BgL_res7369z00_9823;
																																																																		{	/* Ast/sexp.scm 299 */
																																																																			obj_t
																																																																				BgL_arg1412z00_9822;
																																																																			BgL_arg1412z00_9822
																																																																				=
																																																																				SYMBOL_TO_STRING
																																																																				(
																																																																				((obj_t) BgL_varz00_8588));
																																																																			BgL_res7369z00_9823
																																																																				=
																																																																				BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																																																																				(BgL_arg1412z00_9822);
																																																																		}
																																																																		BgL_arg6743z00_8629
																																																																			=
																																																																			BgL_res7369z00_9823;
																																																																	}
																																																																	BgL_valz00_8607
																																																																		=
																																																																		BGl_lambdazd2ze3nodez31zzast_sexpz00
																																																																		(BgL_valz00_8589,
																																																																		BgL_stackz00_22,
																																																																		BgL_valzd2loczd2_8606,
																																																																		CNST_TABLE_REF
																																																																		(((long) 2)), BgL_arg6743z00_8629);
																																																															}}
																																																														else
																																																															{	/* Ast/sexp.scm 296 */
																																																															BgL_tagzd262276zd2_8623:
																																																																BgL_valz00_8607 = BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_valz00_8589, BgL_stackz00_22, BgL_valzd2loczd2_8606, CNST_TABLE_REF(((long) 2)));
																																																													}}
																																																												else
																																																													{	/* Ast/sexp.scm 296 */
																																																														goto
																																																															BgL_tagzd262276zd2_8623;
																																																													}
																																																											}
																																																											{	/* Ast/sexp.scm 296 */

																																																												{	/* Ast/sexp.scm 302 */
																																																													BgL_nodez00_bglt
																																																														BgL_astz00_8608;
																																																													BgL_astz00_8608
																																																														=
																																																														BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																														(BgL_varz00_8588,
																																																														BgL_stackz00_22,
																																																														BgL_cdlocz00_8604,
																																																														CNST_TABLE_REF
																																																														(((long) 7)));
																																																													{	/* Ast/sexp.scm 303 */
																																																														bool_t
																																																															BgL_test8160z00_14491;
																																																														{	/* Ast/sexp.scm 303 */
																																																															bool_t
																																																																BgL_res7371z00_9826;
																																																															BgL_res7371z00_9826
																																																																=
																																																																BGl_isazf3zf3zz__objectz00
																																																																(
																																																																((obj_t) BgL_astz00_8608), BGl_varz00zzast_nodez00);
																																																															BgL_test8160z00_14491
																																																																=
																																																																BgL_res7371z00_9826;
																																																														}
																																																														if (BgL_test8160z00_14491)
																																																															{	/* Ast/sexp.scm 305 */
																																																																bool_t
																																																																	BgL_test8161z00_14494;
																																																																{	/* Ast/sexp.scm 305 */
																																																																	bool_t
																																																																		BgL_test8162z00_14495;
																																																																	{	/* Ast/sexp.scm 305 */
																																																																		BgL_variablez00_bglt
																																																																			BgL_arg6738z00_8621;
																																																																		BgL_arg6738z00_8621
																																																																			=
																																																																			(
																																																																			((BgL_varz00_bglt) COBJECT(((BgL_varz00_bglt) BgL_astz00_8608)))->BgL_variablez00);
																																																																		{	/* Ast/sexp.scm 305 */
																																																																			bool_t
																																																																				BgL_res7372z00_9827;
																																																																			BgL_res7372z00_9827
																																																																				=
																																																																				BGl_isazf3zf3zz__objectz00
																																																																				(
																																																																				((obj_t) BgL_arg6738z00_8621), BGl_globalz00zzast_varz00);
																																																																			BgL_test8162z00_14495
																																																																				=
																																																																				BgL_res7372z00_9827;
																																																																		}
																																																																	}
																																																																	if (BgL_test8162z00_14495)
																																																																		{	/* Ast/sexp.scm 306 */
																																																																			BgL_variablez00_bglt
																																																																				BgL_arg6737z00_8620;
																																																																			BgL_arg6737z00_8620
																																																																				=
																																																																				(
																																																																				((BgL_varz00_bglt) COBJECT(((BgL_varz00_bglt) BgL_astz00_8608)))->BgL_variablez00);
																																																																			BgL_test8161z00_14494
																																																																				=
																																																																				BGl_globalzd2readzd2onlyzf3zf3zzast_varz00
																																																																				(
																																																																				((BgL_globalz00_bglt) BgL_arg6737z00_8620));
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 305 */
																																																																			BgL_test8161z00_14494
																																																																				=
																																																																				(
																																																																				(bool_t)
																																																																				0);
																																																																		}
																																																																}
																																																																if (BgL_test8161z00_14494)
																																																																	{	/* Ast/sexp.scm 307 */
																																																																		BgL_nodez00_bglt
																																																																			BgL_res7373z00_9833;
																																																																		{	/* Ast/sexp.scm 723 */
																																																																			obj_t
																																																																				BgL_arg7080z00_9829;
																																																																			BgL_nodez00_bglt
																																																																				BgL_arg7081z00_9830;
																																																																			BgL_arg7080z00_9829
																																																																				=
																																																																				BGl_shapez00zztools_shapez00
																																																																				(BGl_currentzd2functionzd2zztools_errorz00
																																																																				());
																																																																			BgL_arg7081z00_9830
																																																																				=
																																																																				BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																				(CNST_TABLE_REF
																																																																				(((long) 4)), BNIL, BgL_cdlocz00_8604, CNST_TABLE_REF(((long) 2)));
																																																																			{	/* Ast/sexp.scm 722 */
																																																																				obj_t
																																																																					BgL_list7082z00_9832;
																																																																				BgL_list7082z00_9832
																																																																					=
																																																																					MAKE_YOUNG_PAIR
																																																																					(
																																																																					((obj_t) BgL_arg7081z00_9830), BNIL);
																																																																				BgL_res7373z00_9833
																																																																					=
																																																																					(
																																																																					(BgL_nodez00_bglt)
																																																																					BGl_userzd2errorzf2locationz20zztools_errorz00
																																																																					(BgL_cdlocz00_8604,
																																																																						BgL_arg7080z00_9829,
																																																																						BGl_string8004z00zzast_sexpz00,
																																																																						BgL_expz00_21,
																																																																						BgL_list7082z00_9832));
																																																																		}}
																																																																		BgL_auxz00_14455
																																																																			=
																																																																			BgL_res7373z00_9833;
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 309 */
																																																																		BgL_setqz00_bglt
																																																																			BgL_new1133z00_8616;
																																																																		{	/* Ast/sexp.scm 310 */
																																																																			BgL_setqz00_bglt
																																																																				BgL_new1132z00_8617;
																																																																			BgL_new1132z00_8617
																																																																				=
																																																																				(
																																																																				(BgL_setqz00_bglt)
																																																																				BOBJECT
																																																																				(GC_MALLOC
																																																																					(sizeof
																																																																						(struct
																																																																							BgL_setqz00_bgl))));
																																																																			{	/* Ast/sexp.scm 310 */
																																																																				long
																																																																					BgL_arg6736z00_8618;
																																																																				{	/* Ast/sexp.scm 310 */
																																																																					long
																																																																						BgL_res7374z00_9835;
																																																																					BgL_res7374z00_9835
																																																																						=
																																																																						BGL_CLASS_INDEX
																																																																						(BGl_setqz00zzast_nodez00);
																																																																					BgL_arg6736z00_8618
																																																																						=
																																																																						BgL_res7374z00_9835;
																																																																				}
																																																																				BGL_OBJECT_CLASS_NUM_SET
																																																																					(
																																																																					((BgL_objectz00_bglt) BgL_new1132z00_8617), BgL_arg6736z00_8618);
																																																																			}
																																																																			{	/* Ast/sexp.scm 310 */
																																																																				BgL_objectz00_bglt
																																																																					BgL_tmpz00_14517;
																																																																				BgL_tmpz00_14517
																																																																					=
																																																																					(
																																																																					(BgL_objectz00_bglt)
																																																																					BgL_new1132z00_8617);
																																																																				BGL_OBJECT_WIDENING_SET
																																																																					(BgL_tmpz00_14517,
																																																																					BFALSE);
																																																																			}
																																																																			((BgL_objectz00_bglt) BgL_new1132z00_8617);
																																																																			BgL_new1133z00_8616
																																																																				=
																																																																				BgL_new1132z00_8617;
																																																																		}
																																																																		((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1133z00_8616)))->BgL_locz00) = ((obj_t) BgL_locz00_8603), BUNSPEC);
																																																																		((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1133z00_8616)))->BgL_typez00) = ((BgL_typez00_bglt) ((BgL_typez00_bglt) BGl_za2unspecza2z00zztype_cachez00)), BUNSPEC);
																																																																		((((BgL_setqz00_bglt) COBJECT(BgL_new1133z00_8616))->BgL_varz00) = ((BgL_varz00_bglt) ((BgL_varz00_bglt) BgL_astz00_8608)), BUNSPEC);
																																																																		((((BgL_setqz00_bglt) COBJECT(BgL_new1133z00_8616))->BgL_valuez00) = ((BgL_nodez00_bglt) BgL_valz00_8607), BUNSPEC);
																																																																		BgL_auxz00_14455
																																																																			=
																																																																			(
																																																																			(BgL_nodez00_bglt)
																																																																			BgL_new1133z00_8616);
																																																															}}
																																																														else
																																																															{	/* Ast/sexp.scm 314 */
																																																																BgL_nodez00_bglt
																																																																	BgL_res7375z00_9844;
																																																																{	/* Ast/sexp.scm 723 */
																																																																	obj_t
																																																																		BgL_arg7080z00_9840;
																																																																	BgL_nodez00_bglt
																																																																		BgL_arg7081z00_9841;
																																																																	BgL_arg7080z00_9840
																																																																		=
																																																																		BGl_shapez00zztools_shapez00
																																																																		(BGl_currentzd2functionzd2zztools_errorz00
																																																																		());
																																																																	BgL_arg7081z00_9841
																																																																		=
																																																																		BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																		(CNST_TABLE_REF
																																																																		(((long) 4)), BNIL, BgL_locz00_8603, CNST_TABLE_REF(((long) 2)));
																																																																	{	/* Ast/sexp.scm 722 */
																																																																		obj_t
																																																																			BgL_list7082z00_9843;
																																																																		BgL_list7082z00_9843
																																																																			=
																																																																			MAKE_YOUNG_PAIR
																																																																			(
																																																																			((obj_t) BgL_arg7081z00_9841), BNIL);
																																																																		BgL_res7375z00_9844
																																																																			=
																																																																			(
																																																																			(BgL_nodez00_bglt)
																																																																			BGl_userzd2errorzf2locationz20zztools_errorz00
																																																																			(BgL_locz00_8603,
																																																																				BgL_arg7080z00_9840,
																																																																				BGl_string8005z00zzast_sexpz00,
																																																																				BgL_expz00_21,
																																																																				BgL_list7082z00_9843));
																																																																}}
																																																																BgL_auxz00_14455
																																																																	=
																																																																	BgL_res7375z00_9844;
																																																					}}}}}}}}}}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																					BgL_tagzd262258zd2_8591:
																																																						{	/* Ast/sexp.scm 318 */
																																																							obj_t
																																																								BgL_arg6746z00_8632;
																																																							BgL_arg6746z00_8632
																																																								=
																																																								BGl_findzd2locationzf2locz20zztools_locationz00
																																																								(BgL_expz00_21,
																																																								BgL_locz00_23);
																																																							{	/* Ast/sexp.scm 317 */
																																																								BgL_nodez00_bglt
																																																									BgL_res7376z00_9850;
																																																								{	/* Ast/sexp.scm 723 */
																																																									obj_t
																																																										BgL_arg7080z00_9846;
																																																									BgL_nodez00_bglt
																																																										BgL_arg7081z00_9847;
																																																									BgL_arg7080z00_9846
																																																										=
																																																										BGl_shapez00zztools_shapez00
																																																										(BGl_currentzd2functionzd2zztools_errorz00
																																																										());
																																																									BgL_arg7081z00_9847
																																																										=
																																																										BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																										(CNST_TABLE_REF
																																																										(((long) 4)), BNIL, BgL_arg6746z00_8632, CNST_TABLE_REF(((long) 2)));
																																																									{	/* Ast/sexp.scm 722 */
																																																										obj_t
																																																											BgL_list7082z00_9849;
																																																										BgL_list7082z00_9849
																																																											=
																																																											MAKE_YOUNG_PAIR
																																																											(
																																																											((obj_t) BgL_arg7081z00_9847), BNIL);
																																																										BgL_res7376z00_9850
																																																											=
																																																											(
																																																											(BgL_nodez00_bglt)
																																																											BGl_userzd2errorzf2locationz20zztools_errorz00
																																																											(BgL_arg6746z00_8632,
																																																												BgL_arg7080z00_9846,
																																																												BGl_string8003z00zzast_sexpz00,
																																																												BgL_expz00_21,
																																																												BgL_list7082z00_9849));
																																																								}}
																																																								BgL_auxz00_14455
																																																									=
																																																									BgL_res7376z00_9850;
																																																			}}}}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				goto
																																																					BgL_tagzd262258zd2_8591;
																																																			}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		goto
																																																			BgL_tagzd262258zd2_8591;
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																goto
																																																	BgL_tagzd262258zd2_8591;
																																															}
																																													}
																																													BgL_auxz00_14266
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_14455);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_14557;
																																														BgL_tagzd2380zd2_1727:
																																															{
																																																obj_t
																																																	BgL_varz00_8633;
																																																obj_t
																																																	BgL_valz00_8634;
																																																if (PAIRP(BgL_expz00_21))
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_cdrzd262288zd2_8639;
																																																		BgL_cdrzd262288zd2_8639
																																																			=
																																																			CDR
																																																			(BgL_expz00_21);
																																																		if (PAIRP(BgL_cdrzd262288zd2_8639))
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd262292zd2_8641;
																																																				BgL_cdrzd262292zd2_8641
																																																					=
																																																					CDR
																																																					(BgL_cdrzd262288zd2_8639);
																																																				if (PAIRP(BgL_cdrzd262292zd2_8641))
																																																					{	/* Ast/sexp.scm 119 */
																																																						if (NULLP(CDR(BgL_cdrzd262292zd2_8641)))
																																																							{	/* Ast/sexp.scm 119 */
																																																								BgL_varz00_8633
																																																									=
																																																									CAR
																																																									(BgL_cdrzd262288zd2_8639);
																																																								BgL_valz00_8634
																																																									=
																																																									CAR
																																																									(BgL_cdrzd262292zd2_8641);
																																																								{	/* Ast/sexp.scm 325 */
																																																									obj_t
																																																										BgL_locz00_8648;
																																																									BgL_locz00_8648
																																																										=
																																																										BGl_findzd2locationzf2locz20zztools_locationz00
																																																										(BgL_expz00_21,
																																																										BgL_locz00_23);
																																																									{	/* Ast/sexp.scm 325 */
																																																										obj_t
																																																											BgL_cdlocz00_8649;
																																																										{	/* Ast/sexp.scm 326 */
																																																											obj_t
																																																												BgL_arg6762z00_8664;
																																																											BgL_arg6762z00_8664
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											BgL_cdlocz00_8649
																																																												=
																																																												BGl_findzd2locationzf2locz20zztools_locationz00
																																																												(BgL_arg6762z00_8664,
																																																												BgL_locz00_8648);
																																																										}
																																																										{	/* Ast/sexp.scm 326 */
																																																											obj_t
																																																												BgL_cddlocz00_8650;
																																																											{	/* Ast/sexp.scm 327 */
																																																												obj_t
																																																													BgL_arg6761z00_8663;
																																																												{	/* Ast/sexp.scm 327 */
																																																													obj_t
																																																														BgL_pairz00_9864;
																																																													BgL_pairz00_9864
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													BgL_arg6761z00_8663
																																																														=
																																																														CDR
																																																														(BgL_pairz00_9864);
																																																												}
																																																												BgL_cddlocz00_8650
																																																													=
																																																													BGl_findzd2locationzf2locz20zztools_locationz00
																																																													(BgL_arg6761z00_8663,
																																																													BgL_locz00_8648);
																																																											}
																																																											{	/* Ast/sexp.scm 327 */
																																																												obj_t
																																																													BgL_valzd2loczd2_8651;
																																																												BgL_valzd2loczd2_8651
																																																													=
																																																													BGl_findzd2locationzf2locz20zztools_locationz00
																																																													(BgL_valz00_8634,
																																																													BgL_cddlocz00_8650);
																																																												{	/* Ast/sexp.scm 328 */
																																																													BgL_nodez00_bglt
																																																														BgL_valz00_8652;
																																																													BgL_valz00_8652
																																																														=
																																																														BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																														(BgL_valz00_8634,
																																																														BgL_stackz00_22,
																																																														BgL_valzd2loczd2_8651,
																																																														CNST_TABLE_REF
																																																														(((long) 2)));
																																																													{	/* Ast/sexp.scm 329 */

																																																														{	/* Ast/sexp.scm 330 */
																																																															BgL_nodez00_bglt
																																																																BgL_astz00_8653;
																																																															BgL_astz00_8653
																																																																=
																																																																BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																(BgL_varz00_8633,
																																																																BgL_stackz00_22,
																																																																BgL_cdlocz00_8649,
																																																																CNST_TABLE_REF
																																																																(((long) 2)));
																																																															{	/* Ast/sexp.scm 331 */
																																																																bool_t
																																																																	BgL_test8168z00_14582;
																																																																{	/* Ast/sexp.scm 331 */
																																																																	bool_t
																																																																		BgL_test8169z00_14583;
																																																																	{	/* Ast/sexp.scm 331 */
																																																																		bool_t
																																																																			BgL_res7381z00_9865;
																																																																		BgL_res7381z00_9865
																																																																			=
																																																																			BGl_isazf3zf3zz__objectz00
																																																																			(
																																																																			((obj_t) BgL_astz00_8653), BGl_varz00zzast_nodez00);
																																																																		BgL_test8169z00_14583
																																																																			=
																																																																			BgL_res7381z00_9865;
																																																																	}
																																																																	if (BgL_test8169z00_14583)
																																																																		{	/* Ast/sexp.scm 331 */
																																																																			BgL_variablez00_bglt
																																																																				BgL_arg6760z00_8662;
																																																																			BgL_arg6760z00_8662
																																																																				=
																																																																				(
																																																																				((BgL_varz00_bglt) COBJECT(((BgL_varz00_bglt) BgL_astz00_8653)))->BgL_variablez00);
																																																																			{	/* Ast/sexp.scm 331 */
																																																																				bool_t
																																																																					BgL_res7382z00_9867;
																																																																				BgL_res7382z00_9867
																																																																					=
																																																																					BGl_isazf3zf3zz__objectz00
																																																																					(
																																																																					((obj_t) BgL_arg6760z00_8662), BGl_globalz00zzast_varz00);
																																																																				BgL_test8168z00_14582
																																																																					=
																																																																					BgL_res7382z00_9867;
																																																																			}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 331 */
																																																																			BgL_test8168z00_14582
																																																																				=
																																																																				(
																																																																				(bool_t)
																																																																				0);
																																																																		}
																																																																}
																																																																if (BgL_test8168z00_14582)
																																																																	{	/* Ast/sexp.scm 331 */
																																																																		{	/* Ast/sexp.scm 333 */
																																																																			BgL_variablez00_bglt
																																																																				BgL_arg6758z00_8657;
																																																																			BgL_arg6758z00_8657
																																																																				=
																																																																				(
																																																																				((BgL_varz00_bglt) COBJECT(((BgL_varz00_bglt) BgL_astz00_8653)))->BgL_variablez00);
																																																																			((((BgL_globalz00_bglt) COBJECT(((BgL_globalz00_bglt) BgL_arg6758z00_8657)))->BgL_srcz00) = ((obj_t) ((obj_t) BgL_valz00_8652)), BUNSPEC);
																																																																		}
																																																																		{	/* Ast/sexp.scm 334 */
																																																																			BgL_setqz00_bglt
																																																																				BgL_new1135z00_8658;
																																																																			{	/* Ast/sexp.scm 335 */
																																																																				BgL_setqz00_bglt
																																																																					BgL_new1134z00_8659;
																																																																				BgL_new1134z00_8659
																																																																					=
																																																																					(
																																																																					(BgL_setqz00_bglt)
																																																																					BOBJECT
																																																																					(GC_MALLOC
																																																																						(sizeof
																																																																							(struct
																																																																								BgL_setqz00_bgl))));
																																																																				{	/* Ast/sexp.scm 335 */
																																																																					long
																																																																						BgL_arg6759z00_8660;
																																																																					{	/* Ast/sexp.scm 335 */
																																																																						long
																																																																							BgL_res7383z00_9871;
																																																																						BgL_res7383z00_9871
																																																																							=
																																																																							BGL_CLASS_INDEX
																																																																							(BGl_setqz00zzast_nodez00);
																																																																						BgL_arg6759z00_8660
																																																																							=
																																																																							BgL_res7383z00_9871;
																																																																					}
																																																																					BGL_OBJECT_CLASS_NUM_SET
																																																																						(
																																																																						((BgL_objectz00_bglt) BgL_new1134z00_8659), BgL_arg6759z00_8660);
																																																																				}
																																																																				{	/* Ast/sexp.scm 335 */
																																																																					BgL_objectz00_bglt
																																																																						BgL_tmpz00_14599;
																																																																					BgL_tmpz00_14599
																																																																						=
																																																																						(
																																																																						(BgL_objectz00_bglt)
																																																																						BgL_new1134z00_8659);
																																																																					BGL_OBJECT_WIDENING_SET
																																																																						(BgL_tmpz00_14599,
																																																																						BFALSE);
																																																																				}
																																																																				((BgL_objectz00_bglt) BgL_new1134z00_8659);
																																																																				BgL_new1135z00_8658
																																																																					=
																																																																					BgL_new1134z00_8659;
																																																																			}
																																																																			((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1135z00_8658)))->BgL_locz00) = ((obj_t) BgL_locz00_8648), BUNSPEC);
																																																																			((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1135z00_8658)))->BgL_typez00) = ((BgL_typez00_bglt) ((BgL_typez00_bglt) BGl_za2unspecza2z00zztype_cachez00)), BUNSPEC);
																																																																			((((BgL_setqz00_bglt) COBJECT(BgL_new1135z00_8658))->BgL_varz00) = ((BgL_varz00_bglt) ((BgL_varz00_bglt) BgL_astz00_8653)), BUNSPEC);
																																																																			((((BgL_setqz00_bglt) COBJECT(BgL_new1135z00_8658))->BgL_valuez00) = ((BgL_nodez00_bglt) BgL_valz00_8652), BUNSPEC);
																																																																			BgL_auxz00_14557
																																																																				=
																																																																				(
																																																																				(BgL_nodez00_bglt)
																																																																				BgL_new1135z00_8658);
																																																																	}}
																																																																else
																																																																	{	/* Ast/sexp.scm 339 */
																																																																		BgL_nodez00_bglt
																																																																			BgL_res7384z00_9880;
																																																																		{	/* Ast/sexp.scm 723 */
																																																																			obj_t
																																																																				BgL_arg7080z00_9876;
																																																																			BgL_nodez00_bglt
																																																																				BgL_arg7081z00_9877;
																																																																			BgL_arg7080z00_9876
																																																																				=
																																																																				BGl_shapez00zztools_shapez00
																																																																				(BGl_currentzd2functionzd2zztools_errorz00
																																																																				());
																																																																			BgL_arg7081z00_9877
																																																																				=
																																																																				BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																				(CNST_TABLE_REF
																																																																				(((long) 4)), BNIL, BgL_locz00_8648, CNST_TABLE_REF(((long) 2)));
																																																																			{	/* Ast/sexp.scm 722 */
																																																																				obj_t
																																																																					BgL_list7082z00_9879;
																																																																				BgL_list7082z00_9879
																																																																					=
																																																																					MAKE_YOUNG_PAIR
																																																																					(
																																																																					((obj_t) BgL_arg7081z00_9877), BNIL);
																																																																				BgL_res7384z00_9880
																																																																					=
																																																																					(
																																																																					(BgL_nodez00_bglt)
																																																																					BGl_userzd2errorzf2locationz20zztools_errorz00
																																																																					(BgL_locz00_8648,
																																																																						BgL_arg7080z00_9876,
																																																																						BGl_string8002z00zzast_sexpz00,
																																																																						BgL_expz00_21,
																																																																						BgL_list7082z00_9879));
																																																																		}}
																																																																		BgL_auxz00_14557
																																																																			=
																																																																			BgL_res7384z00_9880;
																																																							}}}}}}}}}}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																							BgL_tagzd262281zd2_8636:
																																																								{	/* Ast/sexp.scm 343 */
																																																									obj_t
																																																										BgL_arg6763z00_8665;
																																																									BgL_arg6763z00_8665
																																																										=
																																																										BGl_findzd2locationzf2locz20zztools_locationz00
																																																										(BgL_expz00_21,
																																																										BgL_locz00_23);
																																																									{	/* Ast/sexp.scm 342 */
																																																										BgL_nodez00_bglt
																																																											BgL_res7385z00_9886;
																																																										{	/* Ast/sexp.scm 723 */
																																																											obj_t
																																																												BgL_arg7080z00_9882;
																																																											BgL_nodez00_bglt
																																																												BgL_arg7081z00_9883;
																																																											BgL_arg7080z00_9882
																																																												=
																																																												BGl_shapez00zztools_shapez00
																																																												(BGl_currentzd2functionzd2zztools_errorz00
																																																												());
																																																											BgL_arg7081z00_9883
																																																												=
																																																												BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																												(CNST_TABLE_REF
																																																												(((long) 4)), BNIL, BgL_arg6763z00_8665, CNST_TABLE_REF(((long) 2)));
																																																											{	/* Ast/sexp.scm 722 */
																																																												obj_t
																																																													BgL_list7082z00_9885;
																																																												BgL_list7082z00_9885
																																																													=
																																																													MAKE_YOUNG_PAIR
																																																													(
																																																													((obj_t) BgL_arg7081z00_9883), BNIL);
																																																												BgL_res7385z00_9886
																																																													=
																																																													(
																																																													(BgL_nodez00_bglt)
																																																													BGl_userzd2errorzf2locationz20zztools_errorz00
																																																													(BgL_arg6763z00_8665,
																																																														BgL_arg7080z00_9882,
																																																														BGl_string8001z00zzast_sexpz00,
																																																														BgL_expz00_21,
																																																														BgL_list7082z00_9885));
																																																										}}
																																																										BgL_auxz00_14557
																																																											=
																																																											BgL_res7385z00_9886;
																																																					}}}}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						goto
																																																							BgL_tagzd262281zd2_8636;
																																																					}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				goto
																																																					BgL_tagzd262281zd2_8636;
																																																			}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		goto
																																																			BgL_tagzd262281zd2_8636;
																																																	}
																																															}
																																															BgL_auxz00_14266
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_14557);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_carzd2706zd2_2576;
																																															BgL_carzd2706zd2_2576
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															if (PAIRP(BgL_carzd2706zd2_2576))
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_carzd2709zd2_2578;
																																																	obj_t
																																																		BgL_cdrzd2710zd2_2579;
																																																	BgL_carzd2709zd2_2578
																																																		=
																																																		CAR
																																																		(BgL_carzd2706zd2_2576);
																																																	BgL_cdrzd2710zd2_2579
																																																		=
																																																		CDR
																																																		(BgL_carzd2706zd2_2576);
																																																	{

																																																		if ((BgL_carzd2709zd2_2578 == CNST_TABLE_REF(((long) 17))))
																																																			{	/* Ast/sexp.scm 119 */
																																																			BgL_kapzd2711zd2_2580:
																																																				if (PAIRP(BgL_cdrzd2710zd2_2579))
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd2714zd2_2705;
																																																						BgL_cdrzd2714zd2_2705
																																																							=
																																																							CDR
																																																							(BgL_cdrzd2710zd2_2579);
																																																						if (PAIRP(BgL_cdrzd2714zd2_2705))
																																																							{	/* Ast/sexp.scm 119 */
																																																								if (NULLP(CDR(BgL_cdrzd2714zd2_2705)))
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg2323z00_2709;
																																																										obj_t
																																																											BgL_arg2325z00_2710;
																																																										BgL_arg2323z00_2709
																																																											=
																																																											CAR
																																																											(BgL_cdrzd2714zd2_2705);
																																																										BgL_arg2325z00_2710
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_14654;
																																																											BgL_bodyz00_1728
																																																												=
																																																												BgL_arg2323z00_2709;
																																																											BgL_argsz00_1729
																																																												=
																																																												BgL_arg2325z00_2710;
																																																										BgL_tagzd2381zd2_1730:
																																																											{	/* Ast/sexp.scm 346 */
																																																												obj_t
																																																													BgL_letzd2partzd2_8666;
																																																												BgL_letzd2partzd2_8666
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{	/* Ast/sexp.scm 346 */
																																																													obj_t
																																																														BgL_nexpz00_8667;
																																																													{	/* Ast/sexp.scm 347 */
																																																														obj_t
																																																															BgL_arg6764z00_8668;
																																																														obj_t
																																																															BgL_arg6765z00_8669;
																																																														BgL_arg6764z00_8668
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_letzd2partzd2_8666));
																																																														{	/* Ast/sexp.scm 347 */
																																																															obj_t
																																																																BgL_arg6766z00_8670;
																																																															obj_t
																																																																BgL_arg6767z00_8671;
																																																															{	/* Ast/sexp.scm 347 */
																																																																obj_t
																																																																	BgL_pairz00_9901;
																																																																BgL_pairz00_9901
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_letzd2partzd2_8666));
																																																																BgL_arg6766z00_8670
																																																																	=
																																																																	CAR
																																																																	(BgL_pairz00_9901);
																																																															}
																																																															{	/* Ast/sexp.scm 347 */
																																																																obj_t
																																																																	BgL_arg6768z00_8672;
																																																																BgL_arg6768z00_8672
																																																																	=
																																																																	MAKE_YOUNG_PAIR
																																																																	(BgL_bodyz00_1728,
																																																																	BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																																																	(BgL_argsz00_1729,
																																																																		BNIL));
																																																																BgL_arg6767z00_8671
																																																																	=
																																																																	MAKE_YOUNG_PAIR
																																																																	(BgL_arg6768z00_8672,
																																																																	BNIL);
																																																															}
																																																															BgL_arg6765z00_8669
																																																																=
																																																																MAKE_YOUNG_PAIR
																																																																(BgL_arg6766z00_8670,
																																																																BgL_arg6767z00_8671);
																																																														}
																																																														BgL_nexpz00_8667
																																																															=
																																																															MAKE_YOUNG_PAIR
																																																															(BgL_arg6764z00_8668,
																																																															BgL_arg6765z00_8669);
																																																													}
																																																													{	/* Ast/sexp.scm 347 */

																																																														BgL_auxz00_14654
																																																															=
																																																															BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																															(BgL_nexpz00_8667,
																																																															BgL_stackz00_22,
																																																															BgL_locz00_23,
																																																															BgL_sitez00_24);
																																																													}
																																																												}
																																																											}
																																																											BgL_auxz00_14266
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_14654);
																																																										}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd2738zd2_2711;
																																																										BgL_cdrzd2738zd2_2711
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{	/* Ast/sexp.scm 119 */
																																																											bool_t
																																																												BgL_test8175z00_14671;
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_arg2397z00_2822;
																																																												BgL_arg2397z00_2822
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												BgL_test8175z00_14671
																																																													=
																																																													CBOOL
																																																													(BGl_letzd2symzf3z21zzast_letz00
																																																													(BgL_arg2397z00_2822));
																																																											}
																																																											if (BgL_test8175z00_14671)
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_arg2328z00_2714;
																																																													obj_t
																																																														BgL_arg2329z00_2715;
																																																													BgL_arg2328z00_2714
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_cdrzd2738zd2_2711));
																																																													BgL_arg2329z00_2715
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd2738zd2_2711));
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_14680;
																																																														BgL_bindingsz00_1731
																																																															=
																																																															BgL_arg2328z00_2714;
																																																														BgL_exprz00_1732
																																																															=
																																																															BgL_arg2329z00_2715;
																																																													BgL_tagzd2382zd2_1733:
																																																														{	/* Ast/sexp.scm 351 */
																																																															bool_t
																																																																BgL_test8176z00_14681;
																																																															if (PAIRP(BgL_bindingsz00_1731))
																																																																{	/* Ast/sexp.scm 351 */
																																																																	if (NULLP(CDR(BgL_bindingsz00_1731)))
																																																																		{	/* Ast/sexp.scm 351 */
																																																																			if (PAIRP(BgL_exprz00_1732))
																																																																				{	/* Ast/sexp.scm 352 */
																																																																					BgL_test8176z00_14681
																																																																						=
																																																																						NULLP
																																																																						(CDR
																																																																						(BgL_exprz00_1732));
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 352 */
																																																																					BgL_test8176z00_14681
																																																																						=
																																																																						(
																																																																						(bool_t)
																																																																						0);
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 351 */
																																																																			BgL_test8176z00_14681
																																																																				=
																																																																				(
																																																																				(bool_t)
																																																																				0);
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 351 */
																																																																	BgL_test8176z00_14681
																																																																		=
																																																																		(
																																																																		(bool_t)
																																																																		0);
																																																																}
																																																															if (BgL_test8176z00_14681)
																																																																{
																																																																	obj_t
																																																																		BgL_varz00_8681;
																																																																	obj_t
																																																																		BgL_exprz00_8682;
																																																																	obj_t
																																																																		BgL_idz00_8683;
																																																																	obj_t
																																																																		BgL_thenz00_8684;
																																																																	obj_t
																																																																		BgL_otherwisez00_8685;
																																																																	if (PAIRP(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 353 */
																																																																			obj_t
																																																																				BgL_cdrzd262311zd2_8689;
																																																																			BgL_cdrzd262311zd2_8689
																																																																				=
																																																																				CDR
																																																																				(BgL_expz00_21);
																																																																			if (PAIRP(BgL_cdrzd262311zd2_8689))
																																																																				{	/* Ast/sexp.scm 353 */
																																																																					obj_t
																																																																						BgL_carzd262317zd2_8691;
																																																																					obj_t
																																																																						BgL_cdrzd262318zd2_8692;
																																																																					BgL_carzd262317zd2_8691
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd262311zd2_8689);
																																																																					BgL_cdrzd262318zd2_8692
																																																																						=
																																																																						CDR
																																																																						(BgL_cdrzd262311zd2_8689);
																																																																					if (PAIRP(BgL_carzd262317zd2_8691))
																																																																						{	/* Ast/sexp.scm 353 */
																																																																							obj_t
																																																																								BgL_carzd262321zd2_8694;
																																																																							BgL_carzd262321zd2_8694
																																																																								=
																																																																								CAR
																																																																								(BgL_carzd262317zd2_8691);
																																																																							if (PAIRP(BgL_carzd262321zd2_8694))
																																																																								{	/* Ast/sexp.scm 353 */
																																																																									obj_t
																																																																										BgL_cdrzd262326zd2_8696;
																																																																									BgL_cdrzd262326zd2_8696
																																																																										=
																																																																										CDR
																																																																										(BgL_carzd262321zd2_8694);
																																																																									if (PAIRP(BgL_cdrzd262326zd2_8696))
																																																																										{	/* Ast/sexp.scm 353 */
																																																																											if (NULLP(CDR(BgL_cdrzd262326zd2_8696)))
																																																																												{	/* Ast/sexp.scm 353 */
																																																																													if (NULLP(CDR(BgL_carzd262317zd2_8691)))
																																																																														{	/* Ast/sexp.scm 353 */
																																																																															if (PAIRP(BgL_cdrzd262318zd2_8692))
																																																																																{	/* Ast/sexp.scm 353 */
																																																																																	obj_t
																																																																																		BgL_carzd262335zd2_8703;
																																																																																	BgL_carzd262335zd2_8703
																																																																																		=
																																																																																		CAR
																																																																																		(BgL_cdrzd262318zd2_8692);
																																																																																	if (PAIRP(BgL_carzd262335zd2_8703))
																																																																																		{	/* Ast/sexp.scm 353 */
																																																																																			obj_t
																																																																																				BgL_cdrzd262341zd2_8705;
																																																																																			BgL_cdrzd262341zd2_8705
																																																																																				=
																																																																																				CDR
																																																																																				(BgL_carzd262335zd2_8703);
																																																																																			if ((CAR(BgL_carzd262335zd2_8703) == CNST_TABLE_REF(((long) 1))))
																																																																																				{	/* Ast/sexp.scm 353 */
																																																																																					if (PAIRP(BgL_cdrzd262341zd2_8705))
																																																																																						{	/* Ast/sexp.scm 353 */
																																																																																							obj_t
																																																																																								BgL_carzd262345zd2_8709;
																																																																																							obj_t
																																																																																								BgL_cdrzd262346zd2_8710;
																																																																																							BgL_carzd262345zd2_8709
																																																																																								=
																																																																																								CAR
																																																																																								(BgL_cdrzd262341zd2_8705);
																																																																																							BgL_cdrzd262346zd2_8710
																																																																																								=
																																																																																								CDR
																																																																																								(BgL_cdrzd262341zd2_8705);
																																																																																							if (SYMBOLP(BgL_carzd262345zd2_8709))
																																																																																								{	/* Ast/sexp.scm 353 */
																																																																																									if (PAIRP(BgL_cdrzd262346zd2_8710))
																																																																																										{	/* Ast/sexp.scm 353 */
																																																																																											obj_t
																																																																																												BgL_cdrzd262353zd2_8713;
																																																																																											BgL_cdrzd262353zd2_8713
																																																																																												=
																																																																																												CDR
																																																																																												(BgL_cdrzd262346zd2_8710);
																																																																																											if (PAIRP(BgL_cdrzd262353zd2_8713))
																																																																																												{	/* Ast/sexp.scm 353 */
																																																																																													if (NULLP(CDR(BgL_cdrzd262353zd2_8713)))
																																																																																														{	/* Ast/sexp.scm 353 */
																																																																																															if (NULLP(CDR(BgL_cdrzd262318zd2_8692)))
																																																																																																{	/* Ast/sexp.scm 353 */
																																																																																																	BgL_varz00_8681
																																																																																																		=
																																																																																																		CAR
																																																																																																		(BgL_carzd262321zd2_8694);
																																																																																																	BgL_exprz00_8682
																																																																																																		=
																																																																																																		CAR
																																																																																																		(BgL_cdrzd262326zd2_8696);
																																																																																																	BgL_idz00_8683
																																																																																																		=
																																																																																																		BgL_carzd262345zd2_8709;
																																																																																																	BgL_thenz00_8684
																																																																																																		=
																																																																																																		CAR
																																																																																																		(BgL_cdrzd262346zd2_8710);
																																																																																																	BgL_otherwisez00_8685
																																																																																																		=
																																																																																																		CAR
																																																																																																		(BgL_cdrzd262353zd2_8713);
																																																																																																	{	/* Ast/sexp.scm 358 */
																																																																																																		obj_t
																																																																																																			BgL_ntz00_8728;
																																																																																																		BgL_ntz00_8728
																																																																																																			=
																																																																																																			BGl_notzd2testzd2zzast_sexpz00
																																																																																																			(BgL_exprz00_8682);
																																																																																																		{	/* Ast/sexp.scm 359 */
																																																																																																			bool_t
																																																																																																				BgL_test8196z00_14740;
																																																																																																			if (CBOOL(BgL_ntz00_8728))
																																																																																																				{	/* Ast/sexp.scm 359 */
																																																																																																					if (BGl_usedzd2inzf3z21zzast_sexpz00(BgL_idz00_8683, BgL_otherwisez00_8685))
																																																																																																						{	/* Ast/sexp.scm 360 */
																																																																																																							BgL_test8196z00_14740
																																																																																																								=
																																																																																																								(
																																																																																																								(bool_t)
																																																																																																								0);
																																																																																																						}
																																																																																																					else
																																																																																																						{	/* Ast/sexp.scm 360 */
																																																																																																							if (BGl_usedzd2inzf3z21zzast_sexpz00(BgL_idz00_8683, BgL_thenz00_8684))
																																																																																																								{	/* Ast/sexp.scm 361 */
																																																																																																									BgL_test8196z00_14740
																																																																																																										=
																																																																																																										(
																																																																																																										(bool_t)
																																																																																																										0);
																																																																																																								}
																																																																																																							else
																																																																																																								{	/* Ast/sexp.scm 361 */
																																																																																																									BgL_test8196z00_14740
																																																																																																										=
																																																																																																										(
																																																																																																										(bool_t)
																																																																																																										1);
																																																																																																								}
																																																																																																						}
																																																																																																				}
																																																																																																			else
																																																																																																				{	/* Ast/sexp.scm 359 */
																																																																																																					BgL_test8196z00_14740
																																																																																																						=
																																																																																																						(
																																																																																																						(bool_t)
																																																																																																						0);
																																																																																																				}
																																																																																																			if (BgL_test8196z00_14740)
																																																																																																				{	/* Ast/sexp.scm 362 */
																																																																																																					obj_t
																																																																																																						BgL_bindingz00_8732;
																																																																																																					obj_t
																																																																																																						BgL_bodyz00_8733;
																																																																																																					BgL_bindingz00_8732
																																																																																																						=
																																																																																																						CAR
																																																																																																						(
																																																																																																						((obj_t) BgL_bindingsz00_1731));
																																																																																																					{	/* Ast/sexp.scm 363 */
																																																																																																						obj_t
																																																																																																							BgL_pairz00_9914;
																																																																																																						{	/* Ast/sexp.scm 363 */
																																																																																																							obj_t
																																																																																																								BgL_pairz00_9913;
																																																																																																							BgL_pairz00_9913
																																																																																																								=
																																																																																																								CDR
																																																																																																								(
																																																																																																								((obj_t) BgL_expz00_21));
																																																																																																							BgL_pairz00_9914
																																																																																																								=
																																																																																																								CDR
																																																																																																								(BgL_pairz00_9913);
																																																																																																						}
																																																																																																						BgL_bodyz00_8733
																																																																																																							=
																																																																																																							CAR
																																																																																																							(BgL_pairz00_9914);
																																																																																																					}
																																																																																																					{	/* Ast/sexp.scm 364 */
																																																																																																						obj_t
																																																																																																							BgL_arg6809z00_8734;
																																																																																																						BgL_arg6809z00_8734
																																																																																																							=
																																																																																																							CDR
																																																																																																							(
																																																																																																							((obj_t) BgL_bindingz00_8732));
																																																																																																						{	/* Ast/sexp.scm 364 */
																																																																																																							obj_t
																																																																																																								BgL_tmpz00_14755;
																																																																																																							BgL_tmpz00_14755
																																																																																																								=
																																																																																																								(
																																																																																																								(obj_t)
																																																																																																								BgL_arg6809z00_8734);
																																																																																																							SET_CAR
																																																																																																								(BgL_tmpz00_14755,
																																																																																																								BgL_ntz00_8728);
																																																																																																						}
																																																																																																					}
																																																																																																					{	/* Ast/sexp.scm 365 */
																																																																																																						obj_t
																																																																																																							BgL_arg6810z00_8735;
																																																																																																						{	/* Ast/sexp.scm 365 */
																																																																																																							obj_t
																																																																																																								BgL_pairz00_9920;
																																																																																																							BgL_pairz00_9920
																																																																																																								=
																																																																																																								CDR
																																																																																																								(
																																																																																																								((obj_t) BgL_bodyz00_8733));
																																																																																																							BgL_arg6810z00_8735
																																																																																																								=
																																																																																																								CDR
																																																																																																								(BgL_pairz00_9920);
																																																																																																						}
																																																																																																						{	/* Ast/sexp.scm 365 */
																																																																																																							obj_t
																																																																																																								BgL_tmpz00_14761;
																																																																																																							BgL_tmpz00_14761
																																																																																																								=
																																																																																																								(
																																																																																																								(obj_t)
																																																																																																								BgL_arg6810z00_8735);
																																																																																																							SET_CAR
																																																																																																								(BgL_tmpz00_14761,
																																																																																																								BgL_otherwisez00_8685);
																																																																																																						}
																																																																																																					}
																																																																																																					{	/* Ast/sexp.scm 366 */
																																																																																																						obj_t
																																																																																																							BgL_arg6811z00_8736;
																																																																																																						{	/* Ast/sexp.scm 366 */
																																																																																																							obj_t
																																																																																																								BgL_pairz00_9927;
																																																																																																							{	/* Ast/sexp.scm 366 */
																																																																																																								obj_t
																																																																																																									BgL_pairz00_9926;
																																																																																																								BgL_pairz00_9926
																																																																																																									=
																																																																																																									CDR
																																																																																																									(
																																																																																																									((obj_t) BgL_bodyz00_8733));
																																																																																																								BgL_pairz00_9927
																																																																																																									=
																																																																																																									CDR
																																																																																																									(BgL_pairz00_9926);
																																																																																																							}
																																																																																																							BgL_arg6811z00_8736
																																																																																																								=
																																																																																																								CDR
																																																																																																								(BgL_pairz00_9927);
																																																																																																						}
																																																																																																						{	/* Ast/sexp.scm 366 */
																																																																																																							obj_t
																																																																																																								BgL_tmpz00_14768;
																																																																																																							BgL_tmpz00_14768
																																																																																																								=
																																																																																																								(
																																																																																																								(obj_t)
																																																																																																								BgL_arg6811z00_8736);
																																																																																																							SET_CAR
																																																																																																								(BgL_tmpz00_14768,
																																																																																																								BgL_thenz00_8684);
																																																																																																						}
																																																																																																					}
																																																																																																				}
																																																																																																			else
																																																																																																				{	/* Ast/sexp.scm 359 */
																																																																																																					BFALSE;
																																																																																																				}
																																																																																																		}
																																																																																																	}
																																																																																																}
																																																																																															else
																																																																																																{	/* Ast/sexp.scm 353 */
																																																																																																	BFALSE;
																																																																																																}
																																																																																														}
																																																																																													else
																																																																																														{	/* Ast/sexp.scm 353 */
																																																																																															BFALSE;
																																																																																														}
																																																																																												}
																																																																																											else
																																																																																												{	/* Ast/sexp.scm 353 */
																																																																																													BFALSE;
																																																																																												}
																																																																																										}
																																																																																									else
																																																																																										{	/* Ast/sexp.scm 353 */
																																																																																											BFALSE;
																																																																																										}
																																																																																								}
																																																																																							else
																																																																																								{	/* Ast/sexp.scm 353 */
																																																																																									BFALSE;
																																																																																								}
																																																																																						}
																																																																																					else
																																																																																						{	/* Ast/sexp.scm 353 */
																																																																																							BFALSE;
																																																																																						}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 353 */
																																																																																					BFALSE;
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 353 */
																																																																																			BFALSE;
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 353 */
																																																																																	BFALSE;
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 353 */
																																																																															BFALSE;
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 353 */
																																																																													BFALSE;
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 353 */
																																																																											BFALSE;
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 353 */
																																																																									BFALSE;
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 353 */
																																																																							BFALSE;
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 353 */
																																																																					BFALSE;
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 353 */
																																																																			BFALSE;
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 351 */
																																																																	BFALSE;
																																																																}
																																																														}
																																																														BgL_auxz00_14680
																																																															=
																																																															BGl_letzd2ze3nodez31zzast_letz00
																																																															(BgL_expz00_21,
																																																															BgL_stackz00_22,
																																																															BgL_locz00_23,
																																																															CNST_TABLE_REF
																																																															(((long) 2)));
																																																														BgL_auxz00_14266
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_14680);
																																																												}}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													bool_t
																																																														BgL_test8200z00_14778;
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_arg2395z00_2821;
																																																														BgL_arg2395z00_2821
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														BgL_test8200z00_14778
																																																															=
																																																															CBOOL
																																																															(BGl_labelszd2symzf3z21zzast_labelsz00
																																																															(BgL_arg2395z00_2821));
																																																													}
																																																													if (BgL_test8200z00_14778)
																																																														{
																																																															BgL_letzd2funzd2_bglt
																																																																BgL_auxz00_14783;
																																																														BgL_tagzd2384zd2_1735:
																																																															BgL_auxz00_14783 = BGl_labelszd2ze3nodez31zzast_labelsz00(BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, CNST_TABLE_REF(((long) 2)));
																																																															BgL_auxz00_14266
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_14783);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_carzd2805zd2_2718;
																																																															BgL_carzd2805zd2_2718
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd2810zd2_2719;
																																																																BgL_cdrzd2810zd2_2719
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_carzd2805zd2_2718));
																																																																if ((CAR(((obj_t) BgL_carzd2805zd2_2718)) == CNST_TABLE_REF(((long) 3))))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_arg2334z00_2722;
																																																																		obj_t
																																																																			BgL_arg2335z00_2723;
																																																																		obj_t
																																																																			BgL_arg2336z00_2724;
																																																																		BgL_arg2334z00_2722
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd2810zd2_2719));
																																																																		BgL_arg2335z00_2723
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd2810zd2_2719));
																																																																		BgL_arg2336z00_2724
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_14802;
																																																																			BgL_varsz00_1740
																																																																				=
																																																																				BgL_arg2334z00_2722;
																																																																			BgL_bodyz00_1741
																																																																				=
																																																																				BgL_arg2335z00_2723;
																																																																			BgL_argsz00_1742
																																																																				=
																																																																				BgL_arg2336z00_2724;
																																																																		BgL_tagzd2386zd2_1743:
																																																																			{	/* Ast/sexp.scm 380 */
																																																																				obj_t
																																																																					BgL_locz00_8748;
																																																																				obj_t
																																																																					BgL_nexpz00_8749;
																																																																				BgL_locz00_8748
																																																																					=
																																																																					BGl_findzd2locationzf2locz20zztools_locationz00
																																																																					(BgL_expz00_21,
																																																																					BgL_locz00_23);
																																																																				{	/* Ast/sexp.scm 381 */
																																																																					obj_t
																																																																						BgL_arg6816z00_8750;
																																																																					obj_t
																																																																						BgL_arg6817z00_8751;
																																																																					BgL_arg6816z00_8750
																																																																						=
																																																																						BGl_letzd2symzd2zzast_letz00
																																																																						();
																																																																					{	/* Ast/sexp.scm 384 */
																																																																						obj_t
																																																																							BgL_arg6818z00_8752;
																																																																						obj_t
																																																																							BgL_arg6819z00_8753;
																																																																						BgL_arg6818z00_8752
																																																																							=
																																																																							BGl_loopze70ze7zzast_sexpz00
																																																																							(BgL_expz00_21,
																																																																							BgL_locz00_23,
																																																																							BgL_varsz00_1740,
																																																																							BgL_argsz00_1742);
																																																																						{	/* Ast/sexp.scm 423 */
																																																																							obj_t
																																																																								BgL_arg6861z00_8803;
																																																																							{	/* Ast/sexp.scm 423 */
																																																																								obj_t
																																																																									BgL_arg6862z00_8804;
																																																																								obj_t
																																																																									BgL_arg6863z00_8805;
																																																																								BgL_arg6862z00_8804
																																																																									=
																																																																									BGl_shapez00zztools_shapez00
																																																																									(BGl_currentzd2functionzd2zztools_errorz00
																																																																									());
																																																																								BgL_arg6863z00_8805
																																																																									=
																																																																									BGl_normaliza7ezd2prognz75zztools_prognz00
																																																																									(BgL_bodyz00_1741);
																																																																								{	/* Ast/sexp.scm 427 */
																																																																									obj_t
																																																																										BgL_zc3z04anonymousza36866ze3z87_13809;
																																																																									BgL_zc3z04anonymousza36866ze3z87_13809
																																																																										=
																																																																										MAKE_FX_PROCEDURE
																																																																										(BGl_z62zc3z04anonymousza36866ze3ze5zzast_sexpz00,
																																																																										(int)
																																																																										(((long) 3)), (int) (((long) 1)));
																																																																									PROCEDURE_SET
																																																																										(BgL_zc3z04anonymousza36866ze3z87_13809,
																																																																										(int)
																																																																										(((long) 0)), BgL_locz00_23);
																																																																									BgL_arg6861z00_8803
																																																																										=
																																																																										BGl_makezd2dssslzd2functionzd2preludezd2zz__dssslz00
																																																																										(BgL_arg6862z00_8804,
																																																																										BgL_varsz00_1740,
																																																																										BgL_arg6863z00_8805,
																																																																										BgL_zc3z04anonymousza36866ze3z87_13809);
																																																																							}}
																																																																							BgL_arg6819z00_8753
																																																																								=
																																																																								MAKE_YOUNG_PAIR
																																																																								(BgL_arg6861z00_8803,
																																																																								BNIL);
																																																																						}
																																																																						BgL_arg6817z00_8751
																																																																							=
																																																																							MAKE_YOUNG_PAIR
																																																																							(BgL_arg6818z00_8752,
																																																																							BgL_arg6819z00_8753);
																																																																					}
																																																																					BgL_nexpz00_8749
																																																																						=
																																																																						MAKE_YOUNG_PAIR
																																																																						(BgL_arg6816z00_8750,
																																																																						BgL_arg6817z00_8751);
																																																																				}
																																																																				BgL_auxz00_14802
																																																																					=
																																																																					BGl_letzd2ze3nodez31zzast_letz00
																																																																					(BgL_nexpz00_8749,
																																																																					BgL_stackz00_22,
																																																																					BgL_locz00_8748,
																																																																					CNST_TABLE_REF
																																																																					(((long) 2)));
																																																																			}
																																																																			BgL_auxz00_14266
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_14802);
																																																																	}}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd2833zd2_2726;
																																																																		BgL_cdrzd2833zd2_2726
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd2839zd2_2727;
																																																																			BgL_cdrzd2839zd2_2727
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_carzd2805zd2_2718));
																																																																			if ((CAR(((obj_t) BgL_carzd2805zd2_2718)) == CNST_TABLE_REF(((long) 1))))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd2845zd2_2730;
																																																																					BgL_cdrzd2845zd2_2730
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd2839zd2_2727));
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_carzd2850zd2_2731;
																																																																						obj_t
																																																																							BgL_cdrzd2851zd2_2732;
																																																																						BgL_carzd2850zd2_2731
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd2845zd2_2730));
																																																																						BgL_cdrzd2851zd2_2732
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd2845zd2_2730));
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd2850zd2_2731))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (PAIRP(BgL_cdrzd2851zd2_2732))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_carzd2858zd2_2735;
																																																																										BgL_carzd2858zd2_2735
																																																																											=
																																																																											CAR
																																																																											(BgL_cdrzd2851zd2_2732);
																																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd2858zd2_2735))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (NULLP(CDR(BgL_cdrzd2851zd2_2732)))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														bool_t
																																																																															BgL_test8207z00_14846;
																																																																														{
																																																																															obj_t
																																																																																BgL_l1366z00_2768;
																																																																															BgL_l1366z00_2768
																																																																																=
																																																																																BgL_cdrzd2833zd2_2726;
																																																																														BgL_zc3z04anonymousza32359ze3z87_2769:
																																																																															if (NULLP(BgL_l1366z00_2768))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	BgL_test8207z00_14846
																																																																																		=
																																																																																		(
																																																																																		(bool_t)
																																																																																		1);
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	bool_t
																																																																																		BgL_test8209z00_14849;
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		bool_t
																																																																																			BgL_test8210z00_14850;
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_tmpz00_14851;
																																																																																			BgL_tmpz00_14851
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_l1366z00_2768));
																																																																																			BgL_test8210z00_14850
																																																																																				=
																																																																																				PAIRP
																																																																																				(BgL_tmpz00_14851);
																																																																																		}
																																																																																		if (BgL_test8210z00_14850)
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				BgL_test8209z00_14849
																																																																																					=
																																																																																					(
																																																																																					(bool_t)
																																																																																					0);
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				BgL_test8209z00_14849
																																																																																					=
																																																																																					(
																																																																																					(bool_t)
																																																																																					1);
																																																																																			}
																																																																																	}
																																																																																	if (BgL_test8209z00_14849)
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_l1366z00_14855;
																																																																																			BgL_l1366z00_14855
																																																																																				=
																																																																																				CDR
																																																																																				(
																																																																																				((obj_t) BgL_l1366z00_2768));
																																																																																			BgL_l1366z00_2768
																																																																																				=
																																																																																				BgL_l1366z00_14855;
																																																																																			goto
																																																																																				BgL_zc3z04anonymousza32359ze3z87_2769;
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			BgL_test8207z00_14846
																																																																																				=
																																																																																				(
																																																																																				(bool_t)
																																																																																				0);
																																																																																		}
																																																																																}
																																																																														}
																																																																														if (BgL_test8207z00_14846)
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_arg2349z00_2751;
																																																																																BgL_arg2349z00_2751
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd2839zd2_2727));
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_14860;
																																																																																	BgL_testz00_1744
																																																																																		=
																																																																																		BgL_arg2349z00_2751;
																																																																																	BgL_proc1z00_1745
																																																																																		=
																																																																																		BgL_carzd2850zd2_2731;
																																																																																	BgL_proc2z00_1746
																																																																																		=
																																																																																		BgL_carzd2858zd2_2735;
																																																																																	BgL_argsz00_1747
																																																																																		=
																																																																																		BgL_cdrzd2833zd2_2726;
																																																																																BgL_tagzd2387zd2_1748:
																																																																																	{	/* Ast/sexp.scm 434 */
																																																																																		obj_t
																																																																																			BgL_nexpz00_8814;
																																																																																		{	/* Ast/sexp.scm 434 */
																																																																																			obj_t
																																																																																				BgL_arg6869z00_8816;
																																																																																			{	/* Ast/sexp.scm 434 */
																																																																																				obj_t
																																																																																					BgL_arg6870z00_8817;
																																																																																				{	/* Ast/sexp.scm 434 */
																																																																																					obj_t
																																																																																						BgL_arg6871z00_8818;
																																																																																					obj_t
																																																																																						BgL_arg6872z00_8819;
																																																																																					BgL_arg6871z00_8818
																																																																																						=
																																																																																						MAKE_YOUNG_PAIR
																																																																																						(BgL_proc1z00_1745,
																																																																																						BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																																																																						(BgL_argsz00_1747,
																																																																																							BNIL));
																																																																																					{	/* Ast/sexp.scm 434 */
																																																																																						obj_t
																																																																																							BgL_arg6874z00_8821;
																																																																																						BgL_arg6874z00_8821
																																																																																							=
																																																																																							MAKE_YOUNG_PAIR
																																																																																							(BgL_proc2z00_1746,
																																																																																							BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																																																																							(BgL_argsz00_1747,
																																																																																								BNIL));
																																																																																						BgL_arg6872z00_8819
																																																																																							=
																																																																																							MAKE_YOUNG_PAIR
																																																																																							(BgL_arg6874z00_8821,
																																																																																							BNIL);
																																																																																					}
																																																																																					BgL_arg6870z00_8817
																																																																																						=
																																																																																						MAKE_YOUNG_PAIR
																																																																																						(BgL_arg6871z00_8818,
																																																																																						BgL_arg6872z00_8819);
																																																																																				}
																																																																																				BgL_arg6869z00_8816
																																																																																					=
																																																																																					MAKE_YOUNG_PAIR
																																																																																					(BgL_testz00_1744,
																																																																																					BgL_arg6870z00_8817);
																																																																																			}
																																																																																			BgL_nexpz00_8814
																																																																																				=
																																																																																				MAKE_YOUNG_PAIR
																																																																																				(CNST_TABLE_REF
																																																																																				(((long) 1)), BgL_arg6869z00_8816);
																																																																																		}
																																																																																		BgL_auxz00_14860
																																																																																			=
																																																																																			BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																																			(BgL_nexpz00_8814,
																																																																																			BgL_stackz00_22,
																																																																																			BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																			(BgL_expz00_21,
																																																																																				BgL_locz00_23),
																																																																																			BgL_sitez00_24);
																																																																																	}
																																																																																	BgL_auxz00_14266
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_14860);
																																																																															}}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_cdrzd2882zd2_2752;
																																																																																BgL_cdrzd2882zd2_2752
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_expz00_21));
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_cdrzd2889zd2_2753;
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_pairz00_10164;
																																																																																		BgL_pairz00_10164
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_expz00_21));
																																																																																		BgL_cdrzd2889zd2_2753
																																																																																			=
																																																																																			CDR
																																																																																			(BgL_pairz00_10164);
																																																																																	}
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_cdrzd2896zd2_2754;
																																																																																		BgL_cdrzd2896zd2_2754
																																																																																			=
																																																																																			CDR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd2889zd2_2753));
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_carzd2902zd2_2755;
																																																																																			BgL_carzd2902zd2_2755
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd2896zd2_2754));
																																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd2902zd2_2755))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					obj_t
																																																																																						BgL_carzd2909zd2_2757;
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						obj_t
																																																																																							BgL_pairz00_10168;
																																																																																						BgL_pairz00_10168
																																																																																							=
																																																																																							CDR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd2896zd2_2754));
																																																																																						BgL_carzd2909zd2_2757
																																																																																							=
																																																																																							CAR
																																																																																							(BgL_pairz00_10168);
																																																																																					}
																																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd2909zd2_2757))
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd2882zd2_2752))
																																																																																								{	/* Ast/sexp.scm 119 */
																																																																																									obj_t
																																																																																										BgL_arg2353z00_2760;
																																																																																									BgL_arg2353z00_2760
																																																																																										=
																																																																																										CAR
																																																																																										(
																																																																																										((obj_t) BgL_cdrzd2889zd2_2753));
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_14893;
																																																																																										BgL_testz00_1749
																																																																																											=
																																																																																											BgL_arg2353z00_2760;
																																																																																										BgL_proc1z00_1750
																																																																																											=
																																																																																											BgL_carzd2902zd2_2755;
																																																																																										BgL_proc2z00_1751
																																																																																											=
																																																																																											BgL_carzd2909zd2_2757;
																																																																																										BgL_argsz00_1752
																																																																																											=
																																																																																											BgL_cdrzd2882zd2_2752;
																																																																																									BgL_tagzd2388zd2_1753:
																																																																																										{	/* Ast/sexp.scm 440 */
																																																																																											obj_t
																																																																																												BgL_tmpsz00_8823;
																																																																																											if (NULLP(BgL_argsz00_1752))
																																																																																												{	/* Ast/sexp.scm 440 */
																																																																																													BgL_tmpsz00_8823
																																																																																														=
																																																																																														BNIL;
																																																																																												}
																																																																																											else
																																																																																												{	/* Ast/sexp.scm 440 */
																																																																																													obj_t
																																																																																														BgL_head1355z00_8867;
																																																																																													{	/* Ast/sexp.scm 440 */
																																																																																														obj_t
																																																																																															BgL_res7420z00_9988;
																																																																																														BgL_res7420z00_9988
																																																																																															=
																																																																																															MAKE_YOUNG_PAIR
																																																																																															(BNIL,
																																																																																															BNIL);
																																																																																														BgL_head1355z00_8867
																																																																																															=
																																																																																															BgL_res7420z00_9988;
																																																																																													}
																																																																																													{
																																																																																														obj_t
																																																																																															BgL_l1353z00_8869;
																																																																																														obj_t
																																																																																															BgL_tail1356z00_8870;
																																																																																														BgL_l1353z00_8869
																																																																																															=
																																																																																															BgL_argsz00_1752;
																																																																																														BgL_tail1356z00_8870
																																																																																															=
																																																																																															BgL_head1355z00_8867;
																																																																																													BgL_zc3z04anonymousza36905ze3z87_8871:
																																																																																														if (NULLP(BgL_l1353z00_8869))
																																																																																															{	/* Ast/sexp.scm 440 */
																																																																																																BgL_tmpsz00_8823
																																																																																																	=
																																																																																																	CDR
																																																																																																	(BgL_head1355z00_8867);
																																																																																															}
																																																																																														else
																																																																																															{	/* Ast/sexp.scm 440 */
																																																																																																obj_t
																																																																																																	BgL_newtail1357z00_8873;
																																																																																																{	/* Ast/sexp.scm 440 */
																																																																																																	obj_t
																																																																																																		BgL_arg6908z00_8875;
																																																																																																	{	/* Ast/sexp.scm 440 */

																																																																																																		{	/* Ast/sexp.scm 440 */

																																																																																																			BgL_arg6908z00_8875
																																																																																																				=
																																																																																																				BGl_gensymz00zz__r4_symbols_6_4z00
																																																																																																				(BFALSE);
																																																																																																		}
																																																																																																	}
																																																																																																	{	/* Ast/sexp.scm 440 */
																																																																																																		obj_t
																																																																																																			BgL_res7422z00_9992;
																																																																																																		BgL_res7422z00_9992
																																																																																																			=
																																																																																																			MAKE_YOUNG_PAIR
																																																																																																			(BgL_arg6908z00_8875,
																																																																																																			BNIL);
																																																																																																		BgL_newtail1357z00_8873
																																																																																																			=
																																																																																																			BgL_res7422z00_9992;
																																																																																																	}
																																																																																																}
																																																																																																SET_CDR
																																																																																																	(BgL_tail1356z00_8870,
																																																																																																	BgL_newtail1357z00_8873);
																																																																																																{	/* Ast/sexp.scm 440 */
																																																																																																	obj_t
																																																																																																		BgL_arg6907z00_8874;
																																																																																																	BgL_arg6907z00_8874
																																																																																																		=
																																																																																																		CDR
																																																																																																		(
																																																																																																		((obj_t) BgL_l1353z00_8869));
																																																																																																	{
																																																																																																		obj_t
																																																																																																			BgL_tail1356z00_14906;
																																																																																																		obj_t
																																																																																																			BgL_l1353z00_14905;
																																																																																																		BgL_l1353z00_14905
																																																																																																			=
																																																																																																			BgL_arg6907z00_8874;
																																																																																																		BgL_tail1356z00_14906
																																																																																																			=
																																																																																																			BgL_newtail1357z00_8873;
																																																																																																		BgL_tail1356z00_8870
																																																																																																			=
																																																																																																			BgL_tail1356z00_14906;
																																																																																																		BgL_l1353z00_8869
																																																																																																			=
																																																																																																			BgL_l1353z00_14905;
																																																																																																		goto
																																																																																																			BgL_zc3z04anonymousza36905ze3z87_8871;
																																																																																																	}
																																																																																																}
																																																																																															}
																																																																																													}
																																																																																												}
																																																																																											{	/* Ast/sexp.scm 440 */
																																																																																												obj_t
																																																																																													BgL_locz00_8824;
																																																																																												BgL_locz00_8824
																																																																																													=
																																																																																													BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																													(BgL_expz00_21,
																																																																																													BgL_locz00_23);
																																																																																												{	/* Ast/sexp.scm 441 */
																																																																																													obj_t
																																																																																														BgL_nexpz00_8825;
																																																																																													{	/* Ast/sexp.scm 442 */
																																																																																														obj_t
																																																																																															BgL_arg6877z00_8827;
																																																																																														obj_t
																																																																																															BgL_arg6878z00_8828;
																																																																																														BgL_arg6877z00_8827
																																																																																															=
																																																																																															BGl_letzd2symzd2zzast_letz00
																																																																																															();
																																																																																														{	/* Ast/sexp.scm 442 */
																																																																																															obj_t
																																																																																																BgL_arg6879z00_8829;
																																																																																															obj_t
																																																																																																BgL_arg6880z00_8830;
																																																																																															if (NULLP(BgL_tmpsz00_8823))
																																																																																																{	/* Ast/sexp.scm 442 */
																																																																																																	BgL_arg6879z00_8829
																																																																																																		=
																																																																																																		BNIL;
																																																																																																}
																																																																																															else
																																																																																																{	/* Ast/sexp.scm 442 */
																																																																																																	obj_t
																																																																																																		BgL_head1360z00_8834;
																																																																																																	{	/* Ast/sexp.scm 442 */
																																																																																																		obj_t
																																																																																																			BgL_arg6891z00_8852;
																																																																																																		{	/* Ast/sexp.scm 442 */
																																																																																																			obj_t
																																																																																																				BgL_arg6892z00_8853;
																																																																																																			obj_t
																																																																																																				BgL_arg6893z00_8854;
																																																																																																			BgL_arg6892z00_8853
																																																																																																				=
																																																																																																				CAR
																																																																																																				(
																																																																																																				((obj_t) BgL_tmpsz00_8823));
																																																																																																			BgL_arg6893z00_8854
																																																																																																				=
																																																																																																				CAR
																																																																																																				(
																																																																																																				((obj_t) BgL_argsz00_1752));
																																																																																																			{	/* Ast/sexp.scm 442 */
																																																																																																				obj_t
																																																																																																					BgL_list6894z00_8855;
																																																																																																				{	/* Ast/sexp.scm 442 */
																																																																																																					obj_t
																																																																																																						BgL_arg6895z00_8856;
																																																																																																					BgL_arg6895z00_8856
																																																																																																						=
																																																																																																						MAKE_YOUNG_PAIR
																																																																																																						(BgL_arg6893z00_8854,
																																																																																																						BNIL);
																																																																																																					BgL_list6894z00_8855
																																																																																																						=
																																																																																																						MAKE_YOUNG_PAIR
																																																																																																						(BgL_arg6892z00_8853,
																																																																																																						BgL_arg6895z00_8856);
																																																																																																				}
																																																																																																				BgL_arg6891z00_8852
																																																																																																					=
																																																																																																					BgL_list6894z00_8855;
																																																																																																			}
																																																																																																		}
																																																																																																		{	/* Ast/sexp.scm 442 */
																																																																																																			obj_t
																																																																																																				BgL_res7425z00_9999;
																																																																																																			BgL_res7425z00_9999
																																																																																																				=
																																																																																																				MAKE_YOUNG_PAIR
																																																																																																				(BgL_arg6891z00_8852,
																																																																																																				BNIL);
																																																																																																			BgL_head1360z00_8834
																																																																																																				=
																																																																																																				BgL_res7425z00_9999;
																																																																																																		}
																																																																																																	}
																																																																																																	{	/* Ast/sexp.scm 442 */
																																																																																																		obj_t
																																																																																																			BgL_g1364z00_8835;
																																																																																																		obj_t
																																																																																																			BgL_g1365z00_8836;
																																																																																																		BgL_g1364z00_8835
																																																																																																			=
																																																																																																			CDR
																																																																																																			(
																																																																																																			((obj_t) BgL_tmpsz00_8823));
																																																																																																		BgL_g1365z00_8836
																																																																																																			=
																																																																																																			CDR
																																																																																																			(
																																																																																																			((obj_t) BgL_argsz00_1752));
																																																																																																		{
																																																																																																			obj_t
																																																																																																				BgL_ll1358z00_8838;
																																																																																																			obj_t
																																																																																																				BgL_ll1359z00_8839;
																																																																																																			obj_t
																																																																																																				BgL_tail1361z00_8840;
																																																																																																			BgL_ll1358z00_8838
																																																																																																				=
																																																																																																				BgL_g1364z00_8835;
																																																																																																			BgL_ll1359z00_8839
																																																																																																				=
																																																																																																				BgL_g1365z00_8836;
																																																																																																			BgL_tail1361z00_8840
																																																																																																				=
																																																																																																				BgL_head1360z00_8834;
																																																																																																		BgL_zc3z04anonymousza36882ze3z87_8841:
																																																																																																			if (NULLP(BgL_ll1358z00_8838))
																																																																																																				{	/* Ast/sexp.scm 442 */
																																																																																																					BgL_arg6879z00_8829
																																																																																																						=
																																																																																																						BgL_head1360z00_8834;
																																																																																																				}
																																																																																																			else
																																																																																																				{	/* Ast/sexp.scm 442 */
																																																																																																					obj_t
																																																																																																						BgL_newtail1362z00_8843;
																																																																																																					{	/* Ast/sexp.scm 442 */
																																																																																																						obj_t
																																																																																																							BgL_arg6886z00_8846;
																																																																																																						{	/* Ast/sexp.scm 442 */
																																																																																																							obj_t
																																																																																																								BgL_arg6887z00_8847;
																																																																																																							obj_t
																																																																																																								BgL_arg6888z00_8848;
																																																																																																							BgL_arg6887z00_8847
																																																																																																								=
																																																																																																								CAR
																																																																																																								(
																																																																																																								((obj_t) BgL_ll1358z00_8838));
																																																																																																							BgL_arg6888z00_8848
																																																																																																								=
																																																																																																								CAR
																																																																																																								(
																																																																																																								((obj_t) BgL_ll1359z00_8839));
																																																																																																							{	/* Ast/sexp.scm 442 */
																																																																																																								obj_t
																																																																																																									BgL_list6889z00_8849;
																																																																																																								{	/* Ast/sexp.scm 442 */
																																																																																																									obj_t
																																																																																																										BgL_arg6890z00_8850;
																																																																																																									BgL_arg6890z00_8850
																																																																																																										=
																																																																																																										MAKE_YOUNG_PAIR
																																																																																																										(BgL_arg6888z00_8848,
																																																																																																										BNIL);
																																																																																																									BgL_list6889z00_8849
																																																																																																										=
																																																																																																										MAKE_YOUNG_PAIR
																																																																																																										(BgL_arg6887z00_8847,
																																																																																																										BgL_arg6890z00_8850);
																																																																																																								}
																																																																																																								BgL_arg6886z00_8846
																																																																																																									=
																																																																																																									BgL_list6889z00_8849;
																																																																																																							}
																																																																																																						}
																																																																																																						{	/* Ast/sexp.scm 442 */
																																																																																																							obj_t
																																																																																																								BgL_res7428z00_10006;
																																																																																																							BgL_res7428z00_10006
																																																																																																								=
																																																																																																								MAKE_YOUNG_PAIR
																																																																																																								(BgL_arg6886z00_8846,
																																																																																																								BNIL);
																																																																																																							BgL_newtail1362z00_8843
																																																																																																								=
																																																																																																								BgL_res7428z00_10006;
																																																																																																						}
																																																																																																					}
																																																																																																					SET_CDR
																																																																																																						(BgL_tail1361z00_8840,
																																																																																																						BgL_newtail1362z00_8843);
																																																																																																					{	/* Ast/sexp.scm 442 */
																																																																																																						obj_t
																																																																																																							BgL_arg6884z00_8844;
																																																																																																						obj_t
																																																																																																							BgL_arg6885z00_8845;
																																																																																																						BgL_arg6884z00_8844
																																																																																																							=
																																																																																																							CDR
																																																																																																							(
																																																																																																							((obj_t) BgL_ll1358z00_8838));
																																																																																																						BgL_arg6885z00_8845
																																																																																																							=
																																																																																																							CDR
																																																																																																							(
																																																																																																							((obj_t) BgL_ll1359z00_8839));
																																																																																																						{
																																																																																																							obj_t
																																																																																																								BgL_tail1361z00_14938;
																																																																																																							obj_t
																																																																																																								BgL_ll1359z00_14937;
																																																																																																							obj_t
																																																																																																								BgL_ll1358z00_14936;
																																																																																																							BgL_ll1358z00_14936
																																																																																																								=
																																																																																																								BgL_arg6884z00_8844;
																																																																																																							BgL_ll1359z00_14937
																																																																																																								=
																																																																																																								BgL_arg6885z00_8845;
																																																																																																							BgL_tail1361z00_14938
																																																																																																								=
																																																																																																								BgL_newtail1362z00_8843;
																																																																																																							BgL_tail1361z00_8840
																																																																																																								=
																																																																																																								BgL_tail1361z00_14938;
																																																																																																							BgL_ll1359z00_8839
																																																																																																								=
																																																																																																								BgL_ll1359z00_14937;
																																																																																																							BgL_ll1358z00_8838
																																																																																																								=
																																																																																																								BgL_ll1358z00_14936;
																																																																																																							goto
																																																																																																								BgL_zc3z04anonymousza36882ze3z87_8841;
																																																																																																						}
																																																																																																					}
																																																																																																				}
																																																																																																		}
																																																																																																	}
																																																																																																}
																																																																																															{	/* Ast/sexp.scm 443 */
																																																																																																obj_t
																																																																																																	BgL_arg6896z00_8857;
																																																																																																{	/* Ast/sexp.scm 443 */
																																																																																																	obj_t
																																																																																																		BgL_arg6897z00_8858;
																																																																																																	{	/* Ast/sexp.scm 443 */
																																																																																																		obj_t
																																																																																																			BgL_arg6898z00_8859;
																																																																																																		{	/* Ast/sexp.scm 443 */
																																																																																																			obj_t
																																																																																																				BgL_arg6899z00_8860;
																																																																																																			obj_t
																																																																																																				BgL_arg6900z00_8861;
																																																																																																			BgL_arg6899z00_8860
																																																																																																				=
																																																																																																				MAKE_YOUNG_PAIR
																																																																																																				(BgL_proc1z00_1750,
																																																																																																				BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																																																																																				(BgL_tmpsz00_8823,
																																																																																																					BNIL));
																																																																																																			{	/* Ast/sexp.scm 443 */
																																																																																																				obj_t
																																																																																																					BgL_arg6902z00_8863;
																																																																																																				BgL_arg6902z00_8863
																																																																																																					=
																																																																																																					MAKE_YOUNG_PAIR
																																																																																																					(BgL_proc2z00_1751,
																																																																																																					BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																																																																																					(BgL_tmpsz00_8823,
																																																																																																						BNIL));
																																																																																																				BgL_arg6900z00_8861
																																																																																																					=
																																																																																																					MAKE_YOUNG_PAIR
																																																																																																					(BgL_arg6902z00_8863,
																																																																																																					BNIL);
																																																																																																			}
																																																																																																			BgL_arg6898z00_8859
																																																																																																				=
																																																																																																				MAKE_YOUNG_PAIR
																																																																																																				(BgL_arg6899z00_8860,
																																																																																																				BgL_arg6900z00_8861);
																																																																																																		}
																																																																																																		BgL_arg6897z00_8858
																																																																																																			=
																																																																																																			MAKE_YOUNG_PAIR
																																																																																																			(BgL_testz00_1749,
																																																																																																			BgL_arg6898z00_8859);
																																																																																																	}
																																																																																																	BgL_arg6896z00_8857
																																																																																																		=
																																																																																																		MAKE_YOUNG_PAIR
																																																																																																		(CNST_TABLE_REF
																																																																																																		(((long) 1)), BgL_arg6897z00_8858);
																																																																																																}
																																																																																																BgL_arg6880z00_8830
																																																																																																	=
																																																																																																	MAKE_YOUNG_PAIR
																																																																																																	(BgL_arg6896z00_8857,
																																																																																																	BNIL);
																																																																																															}
																																																																																															BgL_arg6878z00_8828
																																																																																																=
																																																																																																MAKE_YOUNG_PAIR
																																																																																																(BgL_arg6879z00_8829,
																																																																																																BgL_arg6880z00_8830);
																																																																																														}
																																																																																														BgL_nexpz00_8825
																																																																																															=
																																																																																															MAKE_YOUNG_PAIR
																																																																																															(BgL_arg6877z00_8827,
																																																																																															BgL_arg6878z00_8828);
																																																																																													}
																																																																																													{	/* Ast/sexp.scm 442 */

																																																																																														BgL_auxz00_14893
																																																																																															=
																																																																																															BGl_letzd2ze3nodez31zzast_letz00
																																																																																															(BgL_nexpz00_8825,
																																																																																															BgL_stackz00_22,
																																																																																															BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																															(BgL_expz00_21,
																																																																																																BgL_locz00_8824),
																																																																																															BgL_sitez00_24);
																																																																																										}}}}
																																																																																										BgL_auxz00_14266
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_14893);
																																																																																								}}
																																																																																							else
																																																																																								{	/* Ast/sexp.scm 119 */
																																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																										{	/* Ast/sexp.scm 119 */
																																																																																										BgL_tagzd2403zd2_1777:
																																																																																											BgL_auxz00_14266 = BGl_privatezd2nodezd2zzast_privatez00(BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																																										}
																																																																																									else
																																																																																										{
																																																																																											BgL_nodez00_bglt
																																																																																												BgL_auxz00_14957;
																																																																																										BgL_tagzd2404zd2_1778:
																																																																																											BgL_auxz00_14957 = BGl_callzd2ze3nodez31zzast_sexpz00(BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																																											BgL_auxz00_14266
																																																																																												=
																																																																																												(
																																																																																												(obj_t)
																																																																																												BgL_auxz00_14957);
																																																																																										}
																																																																																								}
																																																																																						}
																																																																																					else
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																								{	/* Ast/sexp.scm 119 */
																																																																																									goto
																																																																																										BgL_tagzd2403zd2_1777;
																																																																																								}
																																																																																							else
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_14962;
																																																																																									goto
																																																																																										BgL_tagzd2404zd2_1778;
																																																																																									BgL_auxz00_14266
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_14962);
																																																																																								}
																																																																																						}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							goto
																																																																																								BgL_tagzd2403zd2_1777;
																																																																																						}
																																																																																					else
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_14966;
																																																																																							goto
																																																																																								BgL_tagzd2404zd2_1778;
																																																																																							BgL_auxz00_14266
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_14966);
																																																																																						}
																																																																																				}
																																																																																		}
																																																																																	}
																																																																																}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1777;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_14970;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1778;
																																																																																BgL_auxz00_14266
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_14970);
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_cdrzd21185zd2_2779;
																																																																												BgL_cdrzd21185zd2_2779
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd21191zd2_2780;
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_pairz00_10172;
																																																																														BgL_pairz00_10172
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_expz00_21));
																																																																														BgL_cdrzd21191zd2_2780
																																																																															=
																																																																															CDR
																																																																															(BgL_pairz00_10172);
																																																																													}
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_cdrzd21197zd2_2781;
																																																																														BgL_cdrzd21197zd2_2781
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd21191zd2_2780));
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_carzd21202zd2_2782;
																																																																															obj_t
																																																																																BgL_cdrzd21203zd2_2783;
																																																																															BgL_carzd21202zd2_2782
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd21197zd2_2781));
																																																																															BgL_cdrzd21203zd2_2783
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_cdrzd21197zd2_2781));
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd21202zd2_2782))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_carzd21208zd2_2785;
																																																																																	BgL_carzd21208zd2_2785
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd21203zd2_2783));
																																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd21208zd2_2785))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (NULLP(CDR(((obj_t) BgL_cdrzd21203zd2_2783))))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd21185zd2_2779))
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							obj_t
																																																																																								BgL_arg2368z00_2790;
																																																																																							BgL_arg2368z00_2790
																																																																																								=
																																																																																								CAR
																																																																																								(
																																																																																								((obj_t) BgL_cdrzd21191zd2_2780));
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_14997;
																																																																																								{
																																																																																									obj_t
																																																																																										BgL_argsz00_15001;
																																																																																									obj_t
																																																																																										BgL_proc2z00_15000;
																																																																																									obj_t
																																																																																										BgL_proc1z00_14999;
																																																																																									obj_t
																																																																																										BgL_testz00_14998;
																																																																																									BgL_testz00_14998
																																																																																										=
																																																																																										BgL_arg2368z00_2790;
																																																																																									BgL_proc1z00_14999
																																																																																										=
																																																																																										BgL_carzd21202zd2_2782;
																																																																																									BgL_proc2z00_15000
																																																																																										=
																																																																																										BgL_carzd21208zd2_2785;
																																																																																									BgL_argsz00_15001
																																																																																										=
																																																																																										BgL_cdrzd21185zd2_2779;
																																																																																									BgL_argsz00_1752
																																																																																										=
																																																																																										BgL_argsz00_15001;
																																																																																									BgL_proc2z00_1751
																																																																																										=
																																																																																										BgL_proc2z00_15000;
																																																																																									BgL_proc1z00_1750
																																																																																										=
																																																																																										BgL_proc1z00_14999;
																																																																																									BgL_testz00_1749
																																																																																										=
																																																																																										BgL_testz00_14998;
																																																																																									goto
																																																																																										BgL_tagzd2388zd2_1753;
																																																																																								}
																																																																																								BgL_auxz00_14266
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_14997);
																																																																																							}
																																																																																						}
																																																																																					else
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																								{	/* Ast/sexp.scm 119 */
																																																																																									goto
																																																																																										BgL_tagzd2403zd2_1777;
																																																																																								}
																																																																																							else
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_15005;
																																																																																									goto
																																																																																										BgL_tagzd2404zd2_1778;
																																																																																									BgL_auxz00_14266
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_15005);
																																																																																								}
																																																																																						}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							goto
																																																																																								BgL_tagzd2403zd2_1777;
																																																																																						}
																																																																																					else
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_15009;
																																																																																							goto
																																																																																								BgL_tagzd2404zd2_1778;
																																																																																							BgL_auxz00_14266
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_15009);
																																																																																						}
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1777;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_15013;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1778;
																																																																																					BgL_auxz00_14266
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_15013);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1777;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_15017;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1778;
																																																																																			BgL_auxz00_14266
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_15017);
																																																																																		}
																																																																																}
																																																																														}
																																																																													}
																																																																												}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1777;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_15021;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1778;
																																																																												BgL_auxz00_14266
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_15021);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd21541zd2_2798;
																																																																								BgL_cdrzd21541zd2_2798
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd21548zd2_2799;
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_pairz00_10182;
																																																																										BgL_pairz00_10182
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										BgL_cdrzd21548zd2_2799
																																																																											=
																																																																											CDR
																																																																											(BgL_pairz00_10182);
																																																																									}
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd21555zd2_2800;
																																																																										BgL_cdrzd21555zd2_2800
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd21548zd2_2799));
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd21561zd2_2801;
																																																																											obj_t
																																																																												BgL_cdrzd21562zd2_2802;
																																																																											BgL_carzd21561zd2_2801
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd21555zd2_2800));
																																																																											BgL_cdrzd21562zd2_2802
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd21555zd2_2800));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd21561zd2_2801))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (PAIRP(BgL_cdrzd21562zd2_2802))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_carzd21569zd2_2805;
																																																																															BgL_carzd21569zd2_2805
																																																																																=
																																																																																CAR
																																																																																(BgL_cdrzd21562zd2_2802);
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd21569zd2_2805))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (NULLP(CDR(BgL_cdrzd21562zd2_2802)))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd21541zd2_2798))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					obj_t
																																																																																						BgL_arg2383z00_2810;
																																																																																					BgL_arg2383z00_2810
																																																																																						=
																																																																																						CAR
																																																																																						(
																																																																																						((obj_t) BgL_cdrzd21548zd2_2799));
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_15048;
																																																																																						{
																																																																																							obj_t
																																																																																								BgL_argsz00_15052;
																																																																																							obj_t
																																																																																								BgL_proc2z00_15051;
																																																																																							obj_t
																																																																																								BgL_proc1z00_15050;
																																																																																							obj_t
																																																																																								BgL_testz00_15049;
																																																																																							BgL_testz00_15049
																																																																																								=
																																																																																								BgL_arg2383z00_2810;
																																																																																							BgL_proc1z00_15050
																																																																																								=
																																																																																								BgL_carzd21561zd2_2801;
																																																																																							BgL_proc2z00_15051
																																																																																								=
																																																																																								BgL_carzd21569zd2_2805;
																																																																																							BgL_argsz00_15052
																																																																																								=
																																																																																								BgL_cdrzd21541zd2_2798;
																																																																																							BgL_argsz00_1752
																																																																																								=
																																																																																								BgL_argsz00_15052;
																																																																																							BgL_proc2z00_1751
																																																																																								=
																																																																																								BgL_proc2z00_15051;
																																																																																							BgL_proc1z00_1750
																																																																																								=
																																																																																								BgL_proc1z00_15050;
																																																																																							BgL_testz00_1749
																																																																																								=
																																																																																								BgL_testz00_15049;
																																																																																							goto
																																																																																								BgL_tagzd2388zd2_1753;
																																																																																						}
																																																																																						BgL_auxz00_14266
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_15048);
																																																																																					}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							goto
																																																																																								BgL_tagzd2403zd2_1777;
																																																																																						}
																																																																																					else
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_15056;
																																																																																							goto
																																																																																								BgL_tagzd2404zd2_1778;
																																																																																							BgL_auxz00_14266
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_15056);
																																																																																						}
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1777;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_15060;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1778;
																																																																																					BgL_auxz00_14266
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_15060);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1777;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_15064;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1778;
																																																																																			BgL_auxz00_14266
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_15064);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1777;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_15068;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1778;
																																																																																	BgL_auxz00_14266
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_15068);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1777;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_15072;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1778;
																																																																															BgL_auxz00_14266
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_15072);
																																																																														}
																																																																												}
																																																																										}
																																																																									}
																																																																								}
																																																																							}
																																																																					}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1777;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_15076;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1778;
																																																																							BgL_auxz00_14266
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_15076);
																																																																						}
																																																																				}
																																																																		}
																																																																	}
																																																															}
																																																														}
																																																												}
																																																										}
																																																									}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd21962zd2_2824;
																																																								BgL_cdrzd21962zd2_2824
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{	/* Ast/sexp.scm 119 */
																																																									bool_t
																																																										BgL_test8242z00_15080;
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg2417z00_2841;
																																																										BgL_arg2417z00_2841
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_test8242z00_15080
																																																											=
																																																											CBOOL
																																																											(BGl_letzd2symzf3z21zzast_letz00
																																																											(BgL_arg2417z00_2841));
																																																									}
																																																									if (BgL_test8242z00_15080)
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_arg2403z00_2827;
																																																											obj_t
																																																												BgL_arg2404z00_2828;
																																																											BgL_arg2403z00_2827
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_cdrzd21962zd2_2824));
																																																											BgL_arg2404z00_2828
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd21962zd2_2824));
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_15089;
																																																												{
																																																													obj_t
																																																														BgL_exprz00_15091;
																																																													obj_t
																																																														BgL_bindingsz00_15090;
																																																													BgL_bindingsz00_15090
																																																														=
																																																														BgL_arg2403z00_2827;
																																																													BgL_exprz00_15091
																																																														=
																																																														BgL_arg2404z00_2828;
																																																													BgL_exprz00_1732
																																																														=
																																																														BgL_exprz00_15091;
																																																													BgL_bindingsz00_1731
																																																														=
																																																														BgL_bindingsz00_15090;
																																																													goto
																																																														BgL_tagzd2382zd2_1733;
																																																												}
																																																												BgL_auxz00_14266
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_15089);
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											bool_t
																																																												BgL_test8243z00_15093;
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_arg2416z00_2840;
																																																												BgL_arg2416z00_2840
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												BgL_test8243z00_15093
																																																													=
																																																													CBOOL
																																																													(BGl_labelszd2symzf3z21zzast_labelsz00
																																																													(BgL_arg2416z00_2840));
																																																											}
																																																											if (BgL_test8243z00_15093)
																																																												{
																																																													BgL_letzd2funzd2_bglt
																																																														BgL_auxz00_15098;
																																																													goto
																																																														BgL_tagzd2384zd2_1735;
																																																													BgL_auxz00_14266
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_15098);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_carzd22028zd2_2831;
																																																													BgL_carzd22028zd2_2831
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd22033zd2_2832;
																																																														BgL_cdrzd22033zd2_2832
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_carzd22028zd2_2831));
																																																														if ((CAR(((obj_t) BgL_carzd22028zd2_2831)) == CNST_TABLE_REF(((long) 3))))
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_arg2410z00_2835;
																																																																obj_t
																																																																	BgL_arg2411z00_2836;
																																																																obj_t
																																																																	BgL_arg2412z00_2837;
																																																																BgL_arg2410z00_2835
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd22033zd2_2832));
																																																																BgL_arg2411z00_2836
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd22033zd2_2832));
																																																																BgL_arg2412z00_2837
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_15115;
																																																																	{
																																																																		obj_t
																																																																			BgL_argsz00_15118;
																																																																		obj_t
																																																																			BgL_bodyz00_15117;
																																																																		obj_t
																																																																			BgL_varsz00_15116;
																																																																		BgL_varsz00_15116
																																																																			=
																																																																			BgL_arg2410z00_2835;
																																																																		BgL_bodyz00_15117
																																																																			=
																																																																			BgL_arg2411z00_2836;
																																																																		BgL_argsz00_15118
																																																																			=
																																																																			BgL_arg2412z00_2837;
																																																																		BgL_argsz00_1742
																																																																			=
																																																																			BgL_argsz00_15118;
																																																																		BgL_bodyz00_1741
																																																																			=
																																																																			BgL_bodyz00_15117;
																																																																		BgL_varsz00_1740
																																																																			=
																																																																			BgL_varsz00_15116;
																																																																		goto
																																																																			BgL_tagzd2386zd2_1743;
																																																																	}
																																																																	BgL_auxz00_14266
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_15115);
																																																																}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1777;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_15122;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1778;
																																																																		BgL_auxz00_14266
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_15122);
																																																																	}
																																																															}
																																																													}
																																																												}
																																																										}
																																																								}
																																																							}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd22144zd2_2842;
																																																						BgL_cdrzd22144zd2_2842
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{	/* Ast/sexp.scm 119 */
																																																							bool_t
																																																								BgL_test8246z00_15126;
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg2427z00_2851;
																																																								BgL_arg2427z00_2851
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test8246z00_15126
																																																									=
																																																									CBOOL
																																																									(BGl_letzd2symzf3z21zzast_letz00
																																																									(BgL_arg2427z00_2851));
																																																							}
																																																							if (BgL_test8246z00_15126)
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_arg2421z00_2845;
																																																									obj_t
																																																										BgL_arg2422z00_2846;
																																																									BgL_arg2421z00_2845
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd22144zd2_2842));
																																																									BgL_arg2422z00_2846
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd22144zd2_2842));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_15135;
																																																										{
																																																											obj_t
																																																												BgL_exprz00_15137;
																																																											obj_t
																																																												BgL_bindingsz00_15136;
																																																											BgL_bindingsz00_15136
																																																												=
																																																												BgL_arg2421z00_2845;
																																																											BgL_exprz00_15137
																																																												=
																																																												BgL_arg2422z00_2846;
																																																											BgL_exprz00_1732
																																																												=
																																																												BgL_exprz00_15137;
																																																											BgL_bindingsz00_1731
																																																												=
																																																												BgL_bindingsz00_15136;
																																																											goto
																																																												BgL_tagzd2382zd2_1733;
																																																										}
																																																										BgL_auxz00_14266
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_15135);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									bool_t
																																																										BgL_test8247z00_15139;
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg2426z00_2850;
																																																										BgL_arg2426z00_2850
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_test8247z00_15139
																																																											=
																																																											CBOOL
																																																											(BGl_labelszd2symzf3z21zzast_labelsz00
																																																											(BgL_arg2426z00_2850));
																																																									}
																																																									if (BgL_test8247z00_15139)
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_15144;
																																																											goto
																																																												BgL_tagzd2384zd2_1735;
																																																											BgL_auxz00_14266
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_15144);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{	/* Ast/sexp.scm 119 */
																																																													goto
																																																														BgL_tagzd2403zd2_1777;
																																																												}
																																																											else
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_15148;
																																																													goto
																																																														BgL_tagzd2404zd2_1778;
																																																													BgL_auxz00_14266
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_15148);
																																																												}
																																																										}
																																																								}
																																																						}
																																																					}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd2709zd2_2578)))
																																																					{	/* Ast/sexp.scm 119 */
																																																						goto
																																																							BgL_kapzd2711zd2_2580;
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						if ((BgL_carzd2709zd2_2578 == CNST_TABLE_REF(((long) 18))))
																																																							{	/* Ast/sexp.scm 119 */
																																																								goto
																																																									BgL_kapzd2711zd2_2580;
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								if ((BgL_carzd2709zd2_2578 == CNST_TABLE_REF(((long) 19))))
																																																									{	/* Ast/sexp.scm 119 */
																																																										goto
																																																											BgL_kapzd2711zd2_2580;
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 119 */
																																																										if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd2709zd2_2578)))
																																																											{	/* Ast/sexp.scm 119 */
																																																												goto
																																																													BgL_kapzd2711zd2_2580;
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd22316zd2_2586;
																																																												BgL_cdrzd22316zd2_2586
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{	/* Ast/sexp.scm 119 */
																																																													bool_t
																																																														BgL_test8253z00_15164;
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_arg2318z00_2703;
																																																														BgL_arg2318z00_2703
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														BgL_test8253z00_15164
																																																															=
																																																															CBOOL
																																																															(BGl_letzd2symzf3z21zzast_letz00
																																																															(BgL_arg2318z00_2703));
																																																													}
																																																													if (BgL_test8253z00_15164)
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_arg2243z00_2589;
																																																															obj_t
																																																																BgL_arg2245z00_2590;
																																																															BgL_arg2243z00_2589
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd22316zd2_2586));
																																																															BgL_arg2245z00_2590
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd22316zd2_2586));
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_15173;
																																																																{
																																																																	obj_t
																																																																		BgL_exprz00_15175;
																																																																	obj_t
																																																																		BgL_bindingsz00_15174;
																																																																	BgL_bindingsz00_15174
																																																																		=
																																																																		BgL_arg2243z00_2589;
																																																																	BgL_exprz00_15175
																																																																		=
																																																																		BgL_arg2245z00_2590;
																																																																	BgL_exprz00_1732
																																																																		=
																																																																		BgL_exprz00_15175;
																																																																	BgL_bindingsz00_1731
																																																																		=
																																																																		BgL_bindingsz00_15174;
																																																																	goto
																																																																		BgL_tagzd2382zd2_1733;
																																																																}
																																																																BgL_auxz00_14266
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_15173);
																																																															}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															bool_t
																																																																BgL_test8254z00_15177;
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_arg2317z00_2702;
																																																																BgL_arg2317z00_2702
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																BgL_test8254z00_15177
																																																																	=
																																																																	CBOOL
																																																																	(BGl_labelszd2symzf3z21zzast_labelsz00
																																																																	(BgL_arg2317z00_2702));
																																																															}
																																																															if (BgL_test8254z00_15177)
																																																																{
																																																																	BgL_letzd2funzd2_bglt
																																																																		BgL_auxz00_15182;
																																																																	goto
																																																																		BgL_tagzd2384zd2_1735;
																																																																	BgL_auxz00_14266
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_15182);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_carzd22382zd2_2593;
																																																																	BgL_carzd22382zd2_2593
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd22387zd2_2594;
																																																																		BgL_cdrzd22387zd2_2594
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_carzd22382zd2_2593));
																																																																		if ((CAR(((obj_t) BgL_carzd22382zd2_2593)) == CNST_TABLE_REF(((long) 3))))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (PAIRP(BgL_cdrzd22387zd2_2594))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_arg2251z00_2598;
																																																																						obj_t
																																																																							BgL_arg2252z00_2599;
																																																																						obj_t
																																																																							BgL_arg2253z00_2600;
																																																																						BgL_arg2251z00_2598
																																																																							=
																																																																							CAR
																																																																							(BgL_cdrzd22387zd2_2594);
																																																																						BgL_arg2252z00_2599
																																																																							=
																																																																							CDR
																																																																							(BgL_cdrzd22387zd2_2594);
																																																																						BgL_arg2253z00_2600
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_15199;
																																																																							{
																																																																								obj_t
																																																																									BgL_argsz00_15202;
																																																																								obj_t
																																																																									BgL_bodyz00_15201;
																																																																								obj_t
																																																																									BgL_varsz00_15200;
																																																																								BgL_varsz00_15200
																																																																									=
																																																																									BgL_arg2251z00_2598;
																																																																								BgL_bodyz00_15201
																																																																									=
																																																																									BgL_arg2252z00_2599;
																																																																								BgL_argsz00_15202
																																																																									=
																																																																									BgL_arg2253z00_2600;
																																																																								BgL_argsz00_1742
																																																																									=
																																																																									BgL_argsz00_15202;
																																																																								BgL_bodyz00_1741
																																																																									=
																																																																									BgL_bodyz00_15201;
																																																																								BgL_varsz00_1740
																																																																									=
																																																																									BgL_varsz00_15200;
																																																																								goto
																																																																									BgL_tagzd2386zd2_1743;
																																																																							}
																																																																							BgL_auxz00_14266
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_15199);
																																																																						}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1777;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_15206;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1778;
																																																																								BgL_auxz00_14266
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_15206);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd22494zd2_2603;
																																																																				BgL_cdrzd22494zd2_2603
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd22499zd2_2604;
																																																																					BgL_cdrzd22499zd2_2604
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_carzd22382zd2_2593));
																																																																					if ((CAR(((obj_t) BgL_carzd22382zd2_2593)) == CNST_TABLE_REF(((long) 1))))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (PAIRP(BgL_cdrzd22499zd2_2604))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd22504zd2_2608;
																																																																									BgL_cdrzd22504zd2_2608
																																																																										=
																																																																										CDR
																																																																										(BgL_cdrzd22499zd2_2604);
																																																																									if (PAIRP(BgL_cdrzd22504zd2_2608))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd22508zd2_2610;
																																																																											obj_t
																																																																												BgL_cdrzd22509zd2_2611;
																																																																											BgL_carzd22508zd2_2610
																																																																												=
																																																																												CAR
																																																																												(BgL_cdrzd22504zd2_2608);
																																																																											BgL_cdrzd22509zd2_2611
																																																																												=
																																																																												CDR
																																																																												(BgL_cdrzd22504zd2_2608);
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd22508zd2_2610))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (PAIRP(BgL_cdrzd22509zd2_2611))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_carzd22514zd2_2614;
																																																																															BgL_carzd22514zd2_2614
																																																																																=
																																																																																CAR
																																																																																(BgL_cdrzd22509zd2_2611);
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd22514zd2_2614))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (NULLP(CDR(BgL_cdrzd22509zd2_2611)))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			bool_t
																																																																																				BgL_test8265z00_15234;
																																																																																			{
																																																																																				obj_t
																																																																																					BgL_l1369z00_2647;
																																																																																				BgL_l1369z00_2647
																																																																																					=
																																																																																					BgL_cdrzd22494zd2_2603;
																																																																																			BgL_zc3z04anonymousza32279ze3z87_2648:
																																																																																				if (NULLP(BgL_l1369z00_2647))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						BgL_test8265z00_15234
																																																																																							=
																																																																																							(
																																																																																							(bool_t)
																																																																																							1);
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						bool_t
																																																																																							BgL_test8267z00_15237;
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							bool_t
																																																																																								BgL_test8268z00_15238;
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								obj_t
																																																																																									BgL_tmpz00_15239;
																																																																																								BgL_tmpz00_15239
																																																																																									=
																																																																																									CAR
																																																																																									(
																																																																																									((obj_t) BgL_l1369z00_2647));
																																																																																								BgL_test8268z00_15238
																																																																																									=
																																																																																									PAIRP
																																																																																									(BgL_tmpz00_15239);
																																																																																							}
																																																																																							if (BgL_test8268z00_15238)
																																																																																								{	/* Ast/sexp.scm 119 */
																																																																																									BgL_test8267z00_15237
																																																																																										=
																																																																																										(
																																																																																										(bool_t)
																																																																																										0);
																																																																																								}
																																																																																							else
																																																																																								{	/* Ast/sexp.scm 119 */
																																																																																									BgL_test8267z00_15237
																																																																																										=
																																																																																										(
																																																																																										(bool_t)
																																																																																										1);
																																																																																								}
																																																																																						}
																																																																																						if (BgL_test8267z00_15237)
																																																																																							{
																																																																																								obj_t
																																																																																									BgL_l1369z00_15243;
																																																																																								BgL_l1369z00_15243
																																																																																									=
																																																																																									CDR
																																																																																									(
																																																																																									((obj_t) BgL_l1369z00_2647));
																																																																																								BgL_l1369z00_2647
																																																																																									=
																																																																																									BgL_l1369z00_15243;
																																																																																								goto
																																																																																									BgL_zc3z04anonymousza32279ze3z87_2648;
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								BgL_test8265z00_15234
																																																																																									=
																																																																																									(
																																																																																									(bool_t)
																																																																																									0);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																			if (BgL_test8265z00_15234)
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					obj_t
																																																																																						BgL_arg2269z00_2630;
																																																																																					BgL_arg2269z00_2630
																																																																																						=
																																																																																						CAR
																																																																																						(BgL_cdrzd22499zd2_2604);
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_15247;
																																																																																						{
																																																																																							obj_t
																																																																																								BgL_argsz00_15251;
																																																																																							obj_t
																																																																																								BgL_proc2z00_15250;
																																																																																							obj_t
																																																																																								BgL_proc1z00_15249;
																																																																																							obj_t
																																																																																								BgL_testz00_15248;
																																																																																							BgL_testz00_15248
																																																																																								=
																																																																																								BgL_arg2269z00_2630;
																																																																																							BgL_proc1z00_15249
																																																																																								=
																																																																																								BgL_carzd22508zd2_2610;
																																																																																							BgL_proc2z00_15250
																																																																																								=
																																																																																								BgL_carzd22514zd2_2614;
																																																																																							BgL_argsz00_15251
																																																																																								=
																																																																																								BgL_cdrzd22494zd2_2603;
																																																																																							BgL_argsz00_1747
																																																																																								=
																																																																																								BgL_argsz00_15251;
																																																																																							BgL_proc2z00_1746
																																																																																								=
																																																																																								BgL_proc2z00_15250;
																																																																																							BgL_proc1z00_1745
																																																																																								=
																																																																																								BgL_proc1z00_15249;
																																																																																							BgL_testz00_1744
																																																																																								=
																																																																																								BgL_testz00_15248;
																																																																																							goto
																																																																																								BgL_tagzd2387zd2_1748;
																																																																																						}
																																																																																						BgL_auxz00_14266
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_15247);
																																																																																					}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					obj_t
																																																																																						BgL_cdrzd22539zd2_2631;
																																																																																					BgL_cdrzd22539zd2_2631
																																																																																						=
																																																																																						CDR
																																																																																						(
																																																																																						((obj_t) BgL_expz00_21));
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						obj_t
																																																																																							BgL_cdrzd22547zd2_2632;
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							obj_t
																																																																																								BgL_pairz00_10239;
																																																																																							BgL_pairz00_10239
																																																																																								=
																																																																																								CAR
																																																																																								(
																																																																																								((obj_t) BgL_expz00_21));
																																																																																							BgL_cdrzd22547zd2_2632
																																																																																								=
																																																																																								CDR
																																																																																								(BgL_pairz00_10239);
																																																																																						}
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							obj_t
																																																																																								BgL_cdrzd22555zd2_2633;
																																																																																							BgL_cdrzd22555zd2_2633
																																																																																								=
																																																																																								CDR
																																																																																								(
																																																																																								((obj_t) BgL_cdrzd22547zd2_2632));
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								obj_t
																																																																																									BgL_carzd22562zd2_2634;
																																																																																								BgL_carzd22562zd2_2634
																																																																																									=
																																																																																									CAR
																																																																																									(
																																																																																									((obj_t) BgL_cdrzd22555zd2_2633));
																																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd22562zd2_2634))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										obj_t
																																																																																											BgL_carzd22571zd2_2636;
																																																																																										{	/* Ast/sexp.scm 119 */
																																																																																											obj_t
																																																																																												BgL_pairz00_10243;
																																																																																											BgL_pairz00_10243
																																																																																												=
																																																																																												CDR
																																																																																												(
																																																																																												((obj_t) BgL_cdrzd22555zd2_2633));
																																																																																											BgL_carzd22571zd2_2636
																																																																																												=
																																																																																												CAR
																																																																																												(BgL_pairz00_10243);
																																																																																										}
																																																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd22571zd2_2636))
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd22539zd2_2631))
																																																																																													{	/* Ast/sexp.scm 119 */
																																																																																														obj_t
																																																																																															BgL_arg2273z00_2639;
																																																																																														BgL_arg2273z00_2639
																																																																																															=
																																																																																															CAR
																																																																																															(
																																																																																															((obj_t) BgL_cdrzd22547zd2_2632));
																																																																																														{
																																																																																															BgL_nodez00_bglt
																																																																																																BgL_auxz00_15273;
																																																																																															{
																																																																																																obj_t
																																																																																																	BgL_argsz00_15277;
																																																																																																obj_t
																																																																																																	BgL_proc2z00_15276;
																																																																																																obj_t
																																																																																																	BgL_proc1z00_15275;
																																																																																																obj_t
																																																																																																	BgL_testz00_15274;
																																																																																																BgL_testz00_15274
																																																																																																	=
																																																																																																	BgL_arg2273z00_2639;
																																																																																																BgL_proc1z00_15275
																																																																																																	=
																																																																																																	BgL_carzd22562zd2_2634;
																																																																																																BgL_proc2z00_15276
																																																																																																	=
																																																																																																	BgL_carzd22571zd2_2636;
																																																																																																BgL_argsz00_15277
																																																																																																	=
																																																																																																	BgL_cdrzd22539zd2_2631;
																																																																																																BgL_argsz00_1752
																																																																																																	=
																																																																																																	BgL_argsz00_15277;
																																																																																																BgL_proc2z00_1751
																																																																																																	=
																																																																																																	BgL_proc2z00_15276;
																																																																																																BgL_proc1z00_1750
																																																																																																	=
																																																																																																	BgL_proc1z00_15275;
																																																																																																BgL_testz00_1749
																																																																																																	=
																																																																																																	BgL_testz00_15274;
																																																																																																goto
																																																																																																	BgL_tagzd2388zd2_1753;
																																																																																															}
																																																																																															BgL_auxz00_14266
																																																																																																=
																																																																																																(
																																																																																																(obj_t)
																																																																																																BgL_auxz00_15273);
																																																																																														}
																																																																																													}
																																																																																												else
																																																																																													{	/* Ast/sexp.scm 119 */
																																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																															{	/* Ast/sexp.scm 119 */
																																																																																																goto
																																																																																																	BgL_tagzd2403zd2_1777;
																																																																																															}
																																																																																														else
																																																																																															{
																																																																																																BgL_nodez00_bglt
																																																																																																	BgL_auxz00_15281;
																																																																																																goto
																																																																																																	BgL_tagzd2404zd2_1778;
																																																																																																BgL_auxz00_14266
																																																																																																	=
																																																																																																	(
																																																																																																	(obj_t)
																																																																																																	BgL_auxz00_15281);
																																																																																															}
																																																																																													}
																																																																																											}
																																																																																										else
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																													{	/* Ast/sexp.scm 119 */
																																																																																														goto
																																																																																															BgL_tagzd2403zd2_1777;
																																																																																													}
																																																																																												else
																																																																																													{
																																																																																														BgL_nodez00_bglt
																																																																																															BgL_auxz00_15285;
																																																																																														goto
																																																																																															BgL_tagzd2404zd2_1778;
																																																																																														BgL_auxz00_14266
																																																																																															=
																																																																																															(
																																																																																															(obj_t)
																																																																																															BgL_auxz00_15285);
																																																																																													}
																																																																																											}
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												goto
																																																																																													BgL_tagzd2403zd2_1777;
																																																																																											}
																																																																																										else
																																																																																											{
																																																																																												BgL_nodez00_bglt
																																																																																													BgL_auxz00_15289;
																																																																																												goto
																																																																																													BgL_tagzd2404zd2_1778;
																																																																																												BgL_auxz00_14266
																																																																																													=
																																																																																													(
																																																																																													(obj_t)
																																																																																													BgL_auxz00_15289);
																																																																																											}
																																																																																									}
																																																																																							}
																																																																																						}
																																																																																					}
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1777;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_15293;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1778;
																																																																																					BgL_auxz00_14266
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_15293);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_cdrzd22849zd2_2658;
																																																																																	BgL_cdrzd22849zd2_2658
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_expz00_21));
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_cdrzd22856zd2_2659;
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_pairz00_10247;
																																																																																			BgL_pairz00_10247
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_expz00_21));
																																																																																			BgL_cdrzd22856zd2_2659
																																																																																				=
																																																																																				CDR
																																																																																				(BgL_pairz00_10247);
																																																																																		}
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_cdrzd22863zd2_2660;
																																																																																			BgL_cdrzd22863zd2_2660
																																																																																				=
																																																																																				CDR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd22856zd2_2659));
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_carzd22869zd2_2661;
																																																																																				obj_t
																																																																																					BgL_cdrzd22870zd2_2662;
																																																																																				BgL_carzd22869zd2_2661
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd22863zd2_2660));
																																																																																				BgL_cdrzd22870zd2_2662
																																																																																					=
																																																																																					CDR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd22863zd2_2660));
																																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd22869zd2_2661))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						obj_t
																																																																																							BgL_carzd22877zd2_2664;
																																																																																						BgL_carzd22877zd2_2664
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd22870zd2_2662));
																																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd22877zd2_2664))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (NULLP(CDR(((obj_t) BgL_cdrzd22870zd2_2662))))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd22849zd2_2658))
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												obj_t
																																																																																													BgL_arg2288z00_2669;
																																																																																												BgL_arg2288z00_2669
																																																																																													=
																																																																																													CAR
																																																																																													(
																																																																																													((obj_t) BgL_cdrzd22856zd2_2659));
																																																																																												{
																																																																																													BgL_nodez00_bglt
																																																																																														BgL_auxz00_15320;
																																																																																													{
																																																																																														obj_t
																																																																																															BgL_argsz00_15324;
																																																																																														obj_t
																																																																																															BgL_proc2z00_15323;
																																																																																														obj_t
																																																																																															BgL_proc1z00_15322;
																																																																																														obj_t
																																																																																															BgL_testz00_15321;
																																																																																														BgL_testz00_15321
																																																																																															=
																																																																																															BgL_arg2288z00_2669;
																																																																																														BgL_proc1z00_15322
																																																																																															=
																																																																																															BgL_carzd22869zd2_2661;
																																																																																														BgL_proc2z00_15323
																																																																																															=
																																																																																															BgL_carzd22877zd2_2664;
																																																																																														BgL_argsz00_15324
																																																																																															=
																																																																																															BgL_cdrzd22849zd2_2658;
																																																																																														BgL_argsz00_1752
																																																																																															=
																																																																																															BgL_argsz00_15324;
																																																																																														BgL_proc2z00_1751
																																																																																															=
																																																																																															BgL_proc2z00_15323;
																																																																																														BgL_proc1z00_1750
																																																																																															=
																																																																																															BgL_proc1z00_15322;
																																																																																														BgL_testz00_1749
																																																																																															=
																																																																																															BgL_testz00_15321;
																																																																																														goto
																																																																																															BgL_tagzd2388zd2_1753;
																																																																																													}
																																																																																													BgL_auxz00_14266
																																																																																														=
																																																																																														(
																																																																																														(obj_t)
																																																																																														BgL_auxz00_15320);
																																																																																												}
																																																																																											}
																																																																																										else
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																													{	/* Ast/sexp.scm 119 */
																																																																																														goto
																																																																																															BgL_tagzd2403zd2_1777;
																																																																																													}
																																																																																												else
																																																																																													{
																																																																																														BgL_nodez00_bglt
																																																																																															BgL_auxz00_15328;
																																																																																														goto
																																																																																															BgL_tagzd2404zd2_1778;
																																																																																														BgL_auxz00_14266
																																																																																															=
																																																																																															(
																																																																																															(obj_t)
																																																																																															BgL_auxz00_15328);
																																																																																													}
																																																																																											}
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												goto
																																																																																													BgL_tagzd2403zd2_1777;
																																																																																											}
																																																																																										else
																																																																																											{
																																																																																												BgL_nodez00_bglt
																																																																																													BgL_auxz00_15332;
																																																																																												goto
																																																																																													BgL_tagzd2404zd2_1778;
																																																																																												BgL_auxz00_14266
																																																																																													=
																																																																																													(
																																																																																													(obj_t)
																																																																																													BgL_auxz00_15332);
																																																																																											}
																																																																																									}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1777;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_15336;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1778;
																																																																																										BgL_auxz00_14266
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_15336);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1777;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_15340;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1778;
																																																																																								BgL_auxz00_14266
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_15340);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		}
																																																																																	}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1777;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_15344;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1778;
																																																																																	BgL_auxz00_14266
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_15344);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd23210zd2_2677;
																																																																													BgL_cdrzd23210zd2_2677
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_cdrzd23216zd2_2678;
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_pairz00_10257;
																																																																															BgL_pairz00_10257
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															BgL_cdrzd23216zd2_2678
																																																																																=
																																																																																CDR
																																																																																(BgL_pairz00_10257);
																																																																														}
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_cdrzd23222zd2_2679;
																																																																															BgL_cdrzd23222zd2_2679
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_cdrzd23216zd2_2678));
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_carzd23227zd2_2680;
																																																																																obj_t
																																																																																	BgL_cdrzd23228zd2_2681;
																																																																																BgL_carzd23227zd2_2680
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd23222zd2_2679));
																																																																																BgL_cdrzd23228zd2_2681
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd23222zd2_2679));
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd23227zd2_2680))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (PAIRP(BgL_cdrzd23228zd2_2681))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_carzd23233zd2_2684;
																																																																																				BgL_carzd23233zd2_2684
																																																																																					=
																																																																																					CAR
																																																																																					(BgL_cdrzd23228zd2_2681);
																																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd23233zd2_2684))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (NULLP(CDR(BgL_cdrzd23228zd2_2681)))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd23210zd2_2677))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										obj_t
																																																																																											BgL_arg2302z00_2689;
																																																																																										BgL_arg2302z00_2689
																																																																																											=
																																																																																											CAR
																																																																																											(
																																																																																											((obj_t) BgL_cdrzd23216zd2_2678));
																																																																																										{
																																																																																											BgL_nodez00_bglt
																																																																																												BgL_auxz00_15371;
																																																																																											{
																																																																																												obj_t
																																																																																													BgL_argsz00_15375;
																																																																																												obj_t
																																																																																													BgL_proc2z00_15374;
																																																																																												obj_t
																																																																																													BgL_proc1z00_15373;
																																																																																												obj_t
																																																																																													BgL_testz00_15372;
																																																																																												BgL_testz00_15372
																																																																																													=
																																																																																													BgL_arg2302z00_2689;
																																																																																												BgL_proc1z00_15373
																																																																																													=
																																																																																													BgL_carzd23227zd2_2680;
																																																																																												BgL_proc2z00_15374
																																																																																													=
																																																																																													BgL_carzd23233zd2_2684;
																																																																																												BgL_argsz00_15375
																																																																																													=
																																																																																													BgL_cdrzd23210zd2_2677;
																																																																																												BgL_argsz00_1752
																																																																																													=
																																																																																													BgL_argsz00_15375;
																																																																																												BgL_proc2z00_1751
																																																																																													=
																																																																																													BgL_proc2z00_15374;
																																																																																												BgL_proc1z00_1750
																																																																																													=
																																																																																													BgL_proc1z00_15373;
																																																																																												BgL_testz00_1749
																																																																																													=
																																																																																													BgL_testz00_15372;
																																																																																												goto
																																																																																													BgL_tagzd2388zd2_1753;
																																																																																											}
																																																																																											BgL_auxz00_14266
																																																																																												=
																																																																																												(
																																																																																												(obj_t)
																																																																																												BgL_auxz00_15371);
																																																																																										}
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												goto
																																																																																													BgL_tagzd2403zd2_1777;
																																																																																											}
																																																																																										else
																																																																																											{
																																																																																												BgL_nodez00_bglt
																																																																																													BgL_auxz00_15379;
																																																																																												goto
																																																																																													BgL_tagzd2404zd2_1778;
																																																																																												BgL_auxz00_14266
																																																																																													=
																																																																																													(
																																																																																													(obj_t)
																																																																																													BgL_auxz00_15379);
																																																																																											}
																																																																																									}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1777;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_15383;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1778;
																																																																																										BgL_auxz00_14266
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_15383);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1777;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_15387;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1778;
																																																																																								BgL_auxz00_14266
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_15387);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1777;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_15391;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1778;
																																																																																						BgL_auxz00_14266
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_15391);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1777;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_15395;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1778;
																																																																																				BgL_auxz00_14266
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_15395);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														}
																																																																													}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1777;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_15399;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1778;
																																																																													BgL_auxz00_14266
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_15399);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1777;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_15403;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1778;
																																																																											BgL_auxz00_14266
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_15403);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1777;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_15407;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1778;
																																																																									BgL_auxz00_14266
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_15407);
																																																																								}
																																																																						}
																																																																				}
																																																																			}
																																																																	}
																																																																}
																																																														}
																																																												}
																																																											}
																																																									}
																																																							}
																																																					}
																																																			}
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_cdrzd23771zd2_2853;
																																																	BgL_cdrzd23771zd2_2853
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	if ((BgL_carzd2706zd2_2576 == CNST_TABLE_REF(((long) 17))))
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg2430z00_2855;
																																																			obj_t
																																																				BgL_arg2431z00_2856;
																																																			BgL_arg2430z00_2855
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd23771zd2_2853));
																																																			BgL_arg2431z00_2856
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd23771zd2_2853));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_15418;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_15420;
																																																					obj_t
																																																						BgL_bindingsz00_15419;
																																																					BgL_bindingsz00_15419
																																																						=
																																																						BgL_arg2430z00_2855;
																																																					BgL_exprz00_15420
																																																						=
																																																						BgL_arg2431z00_2856;
																																																					BgL_exprz00_1732
																																																						=
																																																						BgL_exprz00_15420;
																																																					BgL_bindingsz00_1731
																																																						=
																																																						BgL_bindingsz00_15419;
																																																					goto
																																																						BgL_tagzd2382zd2_1733;
																																																				}
																																																				BgL_auxz00_14266
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_15418);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd2706zd2_2576)))
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_arg2433z00_2858;
																																																					obj_t
																																																						BgL_arg2434z00_2859;
																																																					BgL_arg2433z00_2858
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd23771zd2_2853));
																																																					BgL_arg2434z00_2859
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd23771zd2_2853));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_15429;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_15431;
																																																							obj_t
																																																								BgL_bindingsz00_15430;
																																																							BgL_bindingsz00_15430
																																																								=
																																																								BgL_arg2433z00_2858;
																																																							BgL_exprz00_15431
																																																								=
																																																								BgL_arg2434z00_2859;
																																																							BgL_exprz00_1732
																																																								=
																																																								BgL_exprz00_15431;
																																																							BgL_bindingsz00_1731
																																																								=
																																																								BgL_bindingsz00_15430;
																																																							goto
																																																								BgL_tagzd2382zd2_1733;
																																																						}
																																																						BgL_auxz00_14266
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_15429);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if ((BgL_carzd2706zd2_2576 == CNST_TABLE_REF(((long) 18))))
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_arg2436z00_2861;
																																																							obj_t
																																																								BgL_arg2437z00_2862;
																																																							BgL_arg2436z00_2861
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd23771zd2_2853));
																																																							BgL_arg2437z00_2862
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd23771zd2_2853));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_15440;
																																																								{
																																																									obj_t
																																																										BgL_exprz00_15442;
																																																									obj_t
																																																										BgL_bindingsz00_15441;
																																																									BgL_bindingsz00_15441
																																																										=
																																																										BgL_arg2436z00_2861;
																																																									BgL_exprz00_15442
																																																										=
																																																										BgL_arg2437z00_2862;
																																																									BgL_exprz00_1732
																																																										=
																																																										BgL_exprz00_15442;
																																																									BgL_bindingsz00_1731
																																																										=
																																																										BgL_bindingsz00_15441;
																																																									goto
																																																										BgL_tagzd2382zd2_1733;
																																																								}
																																																								BgL_auxz00_14266
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_15440);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_15449;
																																																								BgL_tagzd2383zd2_1734:
																																																									BgL_auxz00_15449 = BGl_letrecza2zd2ze3nodez93zzast_letz00(BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, CNST_TABLE_REF(((long) 2)));
																																																									BgL_auxz00_14266
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_15449);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_carzd23808zd2_2865;
																																																									BgL_carzd23808zd2_2865
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									if ((BgL_carzd23808zd2_2865 == CNST_TABLE_REF(((long) 19))))
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_15458;
																																																											goto
																																																												BgL_tagzd2384zd2_1735;
																																																											BgL_auxz00_14266
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_15458);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd23808zd2_2865)))
																																																												{
																																																													BgL_letzd2funzd2_bglt
																																																														BgL_auxz00_15463;
																																																													goto
																																																														BgL_tagzd2384zd2_1735;
																																																													BgL_auxz00_14266
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_15463);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_15470;
																																																														BgL_tagzd2389zd2_1754:
																																																															BgL_auxz00_15470 = BGl_lambdazd2ze3nodez31zzast_sexpz00(BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24, BGl_string8000z00zzast_sexpz00);
																																																															BgL_auxz00_14266
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_15470);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_15478;
																																																																BgL_tagzd2390zd2_1755:
																																																																	BgL_auxz00_15478 = BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00(((bool_t) 0), BFALSE, ((BgL_typez00_bglt) BGl_za2unspecza2z00zztype_cachez00), BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																	BgL_auxz00_14266
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_15478);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd23888zd2_2872;
																																																																	BgL_cdrzd23888zd2_2872
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_arg2449z00_2875;
																																																																			obj_t
																																																																				BgL_arg2450z00_2876;
																																																																			BgL_arg2449z00_2875
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd23888zd2_2872));
																																																																			BgL_arg2450z00_2876
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd23888zd2_2872));
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_15493;
																																																																				BgL_effectz00_1756
																																																																					=
																																																																					BgL_arg2449z00_2875;
																																																																				BgL_restz00_1757
																																																																					=
																																																																					BgL_arg2450z00_2876;
																																																																			BgL_tagzd2391zd2_1758:
																																																																				{	/* Ast/sexp.scm 455 */
																																																																					BgL_feffectz00_bglt
																																																																						BgL_arg6909z00_8879;
																																																																					obj_t
																																																																						BgL_arg6910z00_8880;
																																																																					BgL_arg6909z00_8879
																																																																						=
																																																																						BGl_parsezd2effectzd2zzeffect_feffectz00
																																																																						(BgL_effectz00_1756);
																																																																					{	/* Ast/sexp.scm 456 */
																																																																						obj_t
																																																																							BgL_arg6911z00_8881;
																																																																						BgL_arg6911z00_8881
																																																																							=
																																																																							BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																																																							(BgL_restz00_1757,
																																																																							BNIL);
																																																																						BgL_arg6910z00_8880
																																																																							=
																																																																							MAKE_YOUNG_PAIR
																																																																							(CNST_TABLE_REF
																																																																							(((long) 6)), BgL_arg6911z00_8881);
																																																																					}
																																																																					BgL_auxz00_15493
																																																																						=
																																																																						BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00
																																																																						(
																																																																						((bool_t) 0), ((obj_t) BgL_arg6909z00_8879), ((BgL_typez00_bglt) BGl_za2unspecza2z00zztype_cachez00), BgL_arg6910z00_8880, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																				}
																																																																				BgL_auxz00_14266
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_15493);
																																																																		}}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_15507;
																																																																				BgL_tagzd2392zd2_1759:
																																																																					BgL_auxz00_15507 = BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00(((bool_t) 1), BFALSE, ((BgL_typez00_bglt) BGl_za2unspecza2z00zztype_cachez00), BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																					BgL_auxz00_14266
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_15507);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_15516;
																																																																						BgL_tagzd2393zd2_1760:
																																																																							{	/* Ast/sexp.scm 462 */
																																																																								bool_t
																																																																									BgL_test8309z00_15517;
																																																																								if (NULLP(BgL_stackz00_22))
																																																																									{	/* Ast/sexp.scm 462 */
																																																																										BgL_test8309z00_15517
																																																																											=
																																																																											(BgL_sitez00_24
																																																																											==
																																																																											CNST_TABLE_REF
																																																																											(((long) 2)));
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 462 */
																																																																										BgL_test8309z00_15517
																																																																											=
																																																																											(
																																																																											(bool_t)
																																																																											0);
																																																																									}
																																																																								if (BgL_test8309z00_15517)
																																																																									{	/* Ast/sexp.scm 462 */
																																																																										{	/* Ast/sexp.scm 466 */
																																																																											BgL_nodez00_bglt
																																																																												BgL_arg6914z00_8884;
																																																																											BgL_arg6914z00_8884
																																																																												=
																																																																												BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00
																																																																												(
																																																																												((bool_t) 1), BFALSE, ((BgL_typez00_bglt) BGl_za2unspecza2z00zztype_cachez00), BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																											BGl_addzd2staticzd2pragmaz12z12zzast_pragmaz00
																																																																												(BgL_arg6914z00_8884);
																																																																										}
																																																																										BgL_auxz00_15516
																																																																											=
																																																																											BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																											(BUNSPEC,
																																																																											BgL_stackz00_22,
																																																																											BgL_locz00_23,
																																																																											BgL_sitez00_24);
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 463 */
																																																																										BgL_nodez00_bglt
																																																																											BgL_res7430z00_10016;
																																																																										{	/* Ast/sexp.scm 723 */
																																																																											obj_t
																																																																												BgL_arg7080z00_10012;
																																																																											BgL_nodez00_bglt
																																																																												BgL_arg7081z00_10013;
																																																																											BgL_arg7080z00_10012
																																																																												=
																																																																												BGl_shapez00zztools_shapez00
																																																																												(BGl_currentzd2functionzd2zztools_errorz00
																																																																												());
																																																																											BgL_arg7081z00_10013
																																																																												=
																																																																												BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																												(CNST_TABLE_REF
																																																																												(((long) 4)), BNIL, BgL_locz00_23, CNST_TABLE_REF(((long) 2)));
																																																																											{	/* Ast/sexp.scm 722 */
																																																																												obj_t
																																																																													BgL_list7082z00_10015;
																																																																												BgL_list7082z00_10015
																																																																													=
																																																																													MAKE_YOUNG_PAIR
																																																																													(
																																																																													((obj_t) BgL_arg7081z00_10013), BNIL);
																																																																												BgL_res7430z00_10016
																																																																													=
																																																																													(
																																																																													(BgL_nodez00_bglt)
																																																																													BGl_userzd2errorzf2locationz20zztools_errorz00
																																																																													(BgL_locz00_23,
																																																																														BgL_arg7080z00_10012,
																																																																														BGl_string7999z00zzast_sexpz00,
																																																																														BgL_expz00_21,
																																																																														BgL_list7082z00_10015));
																																																																										}}
																																																																										BgL_auxz00_15516
																																																																											=
																																																																											BgL_res7430z00_10016;
																																																																							}}
																																																																							BgL_auxz00_14266
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_15516);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_arg2458z00_2884;
																																																																									obj_t
																																																																										BgL_arg2461z00_2885;
																																																																									BgL_arg2458z00_2884
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd23888zd2_2872));
																																																																									BgL_arg2461z00_2885
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd23888zd2_2872));
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_15545;
																																																																										BgL_effectz00_1761
																																																																											=
																																																																											BgL_arg2458z00_2884;
																																																																										BgL_restz00_1762
																																																																											=
																																																																											BgL_arg2461z00_2885;
																																																																									BgL_tagzd2394zd2_1763:
																																																																										{	/* Ast/sexp.scm 471 */
																																																																											BgL_feffectz00_bglt
																																																																												BgL_arg6915z00_8886;
																																																																											obj_t
																																																																												BgL_arg6916z00_8887;
																																																																											BgL_arg6915z00_8886
																																																																												=
																																																																												BGl_parsezd2effectzd2zzeffect_feffectz00
																																																																												(BgL_effectz00_1761);
																																																																											{	/* Ast/sexp.scm 472 */
																																																																												obj_t
																																																																													BgL_arg6917z00_8888;
																																																																												BgL_arg6917z00_8888
																																																																													=
																																																																													BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																																																													(BgL_restz00_1762,
																																																																													BNIL);
																																																																												BgL_arg6916z00_8887
																																																																													=
																																																																													MAKE_YOUNG_PAIR
																																																																													(CNST_TABLE_REF
																																																																													(((long) 6)), BgL_arg6917z00_8888);
																																																																											}
																																																																											BgL_auxz00_15545
																																																																												=
																																																																												BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00
																																																																												(
																																																																												((bool_t) 1), ((obj_t) BgL_arg6915z00_8886), ((BgL_typez00_bglt) BGl_za2unspecza2z00zztype_cachez00), BgL_arg6916z00_8887, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																										}
																																																																										BgL_auxz00_14266
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_15545);
																																																																								}}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_15559;
																																																																										BgL_tagzd2395zd2_1764:
																																																																											{
																																																																												obj_t
																																																																													BgL_procz00_8889;
																																																																												obj_t
																																																																													BgL_msgz00_8890;
																																																																												obj_t
																																																																													BgL_objz00_8891;
																																																																												if (PAIRP(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_cdrzd262369zd2_8896;
																																																																														BgL_cdrzd262369zd2_8896
																																																																															=
																																																																															CDR
																																																																															(BgL_expz00_21);
																																																																														if (PAIRP(BgL_cdrzd262369zd2_8896))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_cdrzd262374zd2_8898;
																																																																																BgL_cdrzd262374zd2_8898
																																																																																	=
																																																																																	CDR
																																																																																	(BgL_cdrzd262369zd2_8896);
																																																																																if (PAIRP(BgL_cdrzd262374zd2_8898))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_cdrzd262379zd2_8900;
																																																																																		BgL_cdrzd262379zd2_8900
																																																																																			=
																																																																																			CDR
																																																																																			(BgL_cdrzd262374zd2_8898);
																																																																																		if (PAIRP(BgL_cdrzd262379zd2_8900))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (NULLP(CDR(BgL_cdrzd262379zd2_8900)))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						obj_t
																																																																																							BgL_arg6924z00_8904;
																																																																																						obj_t
																																																																																							BgL_arg6925z00_8905;
																																																																																						obj_t
																																																																																							BgL_arg6926z00_8906;
																																																																																						BgL_arg6924z00_8904
																																																																																							=
																																																																																							CAR
																																																																																							(BgL_cdrzd262369zd2_8896);
																																																																																						BgL_arg6925z00_8905
																																																																																							=
																																																																																							CAR
																																																																																							(BgL_cdrzd262374zd2_8898);
																																																																																						BgL_arg6926z00_8906
																																																																																							=
																																																																																							CAR
																																																																																							(BgL_cdrzd262379zd2_8900);
																																																																																						{
																																																																																							BgL_failz00_bglt
																																																																																								BgL_auxz00_15577;
																																																																																							BgL_procz00_8889
																																																																																								=
																																																																																								BgL_arg6924z00_8904;
																																																																																							BgL_msgz00_8890
																																																																																								=
																																																																																								BgL_arg6925z00_8905;
																																																																																							BgL_objz00_8891
																																																																																								=
																																																																																								BgL_arg6926z00_8906;
																																																																																							{	/* Ast/sexp.scm 477 */
																																																																																								obj_t
																																																																																									BgL_locz00_8908;
																																																																																								BgL_locz00_8908
																																																																																									=
																																																																																									BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																									(BgL_expz00_21,
																																																																																									BgL_locz00_23);
																																																																																								{	/* Ast/sexp.scm 477 */
																																																																																									obj_t
																																																																																										BgL_cdlocz00_8909;
																																																																																									{	/* Ast/sexp.scm 478 */
																																																																																										obj_t
																																																																																											BgL_arg6931z00_8923;
																																																																																										BgL_arg6931z00_8923
																																																																																											=
																																																																																											CDR
																																																																																											(
																																																																																											((obj_t) BgL_expz00_21));
																																																																																										BgL_cdlocz00_8909
																																																																																											=
																																																																																											BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																											(BgL_arg6931z00_8923,
																																																																																											BgL_locz00_8908);
																																																																																									}
																																																																																									{	/* Ast/sexp.scm 478 */
																																																																																										obj_t
																																																																																											BgL_cddlocz00_8910;
																																																																																										{	/* Ast/sexp.scm 479 */
																																																																																											obj_t
																																																																																												BgL_arg6930z00_8922;
																																																																																											{	/* Ast/sexp.scm 479 */
																																																																																												obj_t
																																																																																													BgL_pairz00_10021;
																																																																																												BgL_pairz00_10021
																																																																																													=
																																																																																													CDR
																																																																																													(
																																																																																													((obj_t) BgL_expz00_21));
																																																																																												BgL_arg6930z00_8922
																																																																																													=
																																																																																													CDR
																																																																																													(BgL_pairz00_10021);
																																																																																											}
																																																																																											BgL_cddlocz00_8910
																																																																																												=
																																																																																												BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																												(BgL_arg6930z00_8922,
																																																																																												BgL_locz00_8908);
																																																																																										}
																																																																																										{	/* Ast/sexp.scm 479 */
																																																																																											obj_t
																																																																																												BgL_cdddlocz00_8911;
																																																																																											{	/* Ast/sexp.scm 480 */
																																																																																												obj_t
																																																																																													BgL_arg6929z00_8921;
																																																																																												{	/* Ast/sexp.scm 480 */
																																																																																													obj_t
																																																																																														BgL_pairz00_10027;
																																																																																													{	/* Ast/sexp.scm 480 */
																																																																																														obj_t
																																																																																															BgL_pairz00_10026;
																																																																																														BgL_pairz00_10026
																																																																																															=
																																																																																															CDR
																																																																																															(
																																																																																															((obj_t) BgL_expz00_21));
																																																																																														BgL_pairz00_10027
																																																																																															=
																																																																																															CDR
																																																																																															(BgL_pairz00_10026);
																																																																																													}
																																																																																													BgL_arg6929z00_8921
																																																																																														=
																																																																																														CDR
																																																																																														(BgL_pairz00_10027);
																																																																																												}
																																																																																												BgL_cdddlocz00_8911
																																																																																													=
																																																																																													BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																													(BgL_arg6929z00_8921,
																																																																																													BgL_locz00_8908);
																																																																																											}
																																																																																											{	/* Ast/sexp.scm 480 */
																																																																																												obj_t
																																																																																													BgL_loczd2proczd2_8912;
																																																																																												BgL_loczd2proczd2_8912
																																																																																													=
																																																																																													BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																													(BgL_procz00_8889,
																																																																																													BgL_cdlocz00_8909);
																																																																																												{	/* Ast/sexp.scm 481 */
																																																																																													obj_t
																																																																																														BgL_loczd2msgzd2_8913;
																																																																																													BgL_loczd2msgzd2_8913
																																																																																														=
																																																																																														BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																														(BgL_msgz00_8890,
																																																																																														BgL_cddlocz00_8910);
																																																																																													{	/* Ast/sexp.scm 482 */
																																																																																														obj_t
																																																																																															BgL_loczd2objzd2_8914;
																																																																																														BgL_loczd2objzd2_8914
																																																																																															=
																																																																																															BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																															(BgL_objz00_8891,
																																																																																															BgL_cdddlocz00_8911);
																																																																																														{	/* Ast/sexp.scm 483 */
																																																																																															BgL_nodez00_bglt
																																																																																																BgL_procz00_8915;
																																																																																															BgL_procz00_8915
																																																																																																=
																																																																																																BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																																																(BgL_procz00_8889,
																																																																																																BgL_stackz00_22,
																																																																																																BgL_loczd2proczd2_8912,
																																																																																																CNST_TABLE_REF
																																																																																																(((long) 2)));
																																																																																															{	/* Ast/sexp.scm 484 */
																																																																																																BgL_nodez00_bglt
																																																																																																	BgL_msgz00_8916;
																																																																																																BgL_msgz00_8916
																																																																																																	=
																																																																																																	BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																																																	(BgL_msgz00_8890,
																																																																																																	BgL_stackz00_22,
																																																																																																	BgL_loczd2msgzd2_8913,
																																																																																																	CNST_TABLE_REF
																																																																																																	(((long) 2)));
																																																																																																{	/* Ast/sexp.scm 485 */
																																																																																																	BgL_nodez00_bglt
																																																																																																		BgL_objz00_8917;
																																																																																																	BgL_objz00_8917
																																																																																																		=
																																																																																																		BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																																																		(BgL_objz00_8891,
																																																																																																		BgL_stackz00_22,
																																																																																																		BgL_loczd2objzd2_8914,
																																																																																																		CNST_TABLE_REF
																																																																																																		(((long) 2)));
																																																																																																	{	/* Ast/sexp.scm 486 */

																																																																																																		{	/* Ast/sexp.scm 487 */
																																																																																																			BgL_failz00_bglt
																																																																																																				BgL_new1140z00_8918;
																																																																																																			{	/* Ast/sexp.scm 488 */
																																																																																																				BgL_failz00_bglt
																																																																																																					BgL_new1139z00_8919;
																																																																																																				BgL_new1139z00_8919
																																																																																																					=
																																																																																																					(
																																																																																																					(BgL_failz00_bglt)
																																																																																																					BOBJECT
																																																																																																					(GC_MALLOC
																																																																																																						(sizeof
																																																																																																							(struct
																																																																																																								BgL_failz00_bgl))));
																																																																																																				{	/* Ast/sexp.scm 488 */
																																																																																																					long
																																																																																																						BgL_arg6928z00_8920;
																																																																																																					{	/* Ast/sexp.scm 488 */
																																																																																																						long
																																																																																																							BgL_res7431z00_10029;
																																																																																																						BgL_res7431z00_10029
																																																																																																							=
																																																																																																							BGL_CLASS_INDEX
																																																																																																							(BGl_failz00zzast_nodez00);
																																																																																																						BgL_arg6928z00_8920
																																																																																																							=
																																																																																																							BgL_res7431z00_10029;
																																																																																																					}
																																																																																																					BGL_OBJECT_CLASS_NUM_SET
																																																																																																						(
																																																																																																						((BgL_objectz00_bglt) BgL_new1139z00_8919), BgL_arg6928z00_8920);
																																																																																																				}
																																																																																																				{	/* Ast/sexp.scm 488 */
																																																																																																					BgL_objectz00_bglt
																																																																																																						BgL_tmpz00_15604;
																																																																																																					BgL_tmpz00_15604
																																																																																																						=
																																																																																																						(
																																																																																																						(BgL_objectz00_bglt)
																																																																																																						BgL_new1139z00_8919);
																																																																																																					BGL_OBJECT_WIDENING_SET
																																																																																																						(BgL_tmpz00_15604,
																																																																																																						BFALSE);
																																																																																																				}
																																																																																																				((BgL_objectz00_bglt) BgL_new1139z00_8919);
																																																																																																				BgL_new1140z00_8918
																																																																																																					=
																																																																																																					BgL_new1139z00_8919;
																																																																																																			}
																																																																																																			((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1140z00_8918)))->BgL_locz00) = ((obj_t) BgL_locz00_8908), BUNSPEC);
																																																																																																			((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1140z00_8918)))->BgL_typez00) = ((BgL_typez00_bglt) ((BgL_typez00_bglt) BGl_za2magicza2z00zztype_cachez00)), BUNSPEC);
																																																																																																			((((BgL_failz00_bglt) COBJECT(BgL_new1140z00_8918))->BgL_procz00) = ((BgL_nodez00_bglt) BgL_procz00_8915), BUNSPEC);
																																																																																																			((((BgL_failz00_bglt) COBJECT(BgL_new1140z00_8918))->BgL_msgz00) = ((BgL_nodez00_bglt) BgL_msgz00_8916), BUNSPEC);
																																																																																																			((((BgL_failz00_bglt) COBJECT(BgL_new1140z00_8918))->BgL_objz00) = ((BgL_nodez00_bglt) BgL_objz00_8917), BUNSPEC);
																																																																																																			BgL_auxz00_15577
																																																																																																				=
																																																																																																				BgL_new1140z00_8918;
																																																																																							}}}}}}}}}}}}
																																																																																							BgL_auxz00_15559
																																																																																								=
																																																																																								(
																																																																																								(BgL_nodez00_bglt)
																																																																																								BgL_auxz00_15577);
																																																																																					}}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																					BgL_tagzd262360zd2_8893:
																																																																																						{	/* Ast/sexp.scm 495 */
																																																																																							obj_t
																																																																																								BgL_arg6932z00_8924;
																																																																																							BgL_arg6932z00_8924
																																																																																								=
																																																																																								BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																								(BgL_expz00_21,
																																																																																								BgL_locz00_23);
																																																																																							{	/* Ast/sexp.scm 494 */
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_res7432z00_10038;
																																																																																								{	/* Ast/sexp.scm 723 */
																																																																																									obj_t
																																																																																										BgL_arg7080z00_10034;
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_arg7081z00_10035;
																																																																																									BgL_arg7080z00_10034
																																																																																										=
																																																																																										BGl_shapez00zztools_shapez00
																																																																																										(BGl_currentzd2functionzd2zztools_errorz00
																																																																																										());
																																																																																									BgL_arg7081z00_10035
																																																																																										=
																																																																																										BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																																										(CNST_TABLE_REF
																																																																																										(((long) 4)), BNIL, BgL_arg6932z00_8924, CNST_TABLE_REF(((long) 2)));
																																																																																									{	/* Ast/sexp.scm 722 */
																																																																																										obj_t
																																																																																											BgL_list7082z00_10037;
																																																																																										BgL_list7082z00_10037
																																																																																											=
																																																																																											MAKE_YOUNG_PAIR
																																																																																											(
																																																																																											((obj_t) BgL_arg7081z00_10035), BNIL);
																																																																																										BgL_res7432z00_10038
																																																																																											=
																																																																																											(
																																																																																											(BgL_nodez00_bglt)
																																																																																											BGl_userzd2errorzf2locationz20zztools_errorz00
																																																																																											(BgL_arg6932z00_8924,
																																																																																												BgL_arg7080z00_10034,
																																																																																												BGl_string7998z00zzast_sexpz00,
																																																																																												BgL_expz00_21,
																																																																																												BgL_list7082z00_10037));
																																																																																								}}
																																																																																								BgL_auxz00_15559
																																																																																									=
																																																																																									BgL_res7432z00_10038;
																																																																																			}}}}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd262360zd2_8893;
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd262360zd2_8893;
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd262360zd2_8893;
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd262360zd2_8893;
																																																																													}
																																																																											}
																																																																											BgL_auxz00_14266
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_15559);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_15633;
																																																																												BgL_tagzd2396zd2_1765:
																																																																													{
																																																																														obj_t
																																																																															BgL_testz00_8925;
																																																																														obj_t
																																																																															BgL_clausesz00_8926;
																																																																														if (PAIRP(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_cdrzd262393zd2_8931;
																																																																																BgL_cdrzd262393zd2_8931
																																																																																	=
																																																																																	CDR
																																																																																	(BgL_expz00_21);
																																																																																if (PAIRP(BgL_cdrzd262393zd2_8931))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		BgL_testz00_8925
																																																																																			=
																																																																																			CAR
																																																																																			(BgL_cdrzd262393zd2_8931);
																																																																																		BgL_clausesz00_8926
																																																																																			=
																																																																																			CDR
																																																																																			(BgL_cdrzd262393zd2_8931);
																																																																																		{	/* Ast/sexp.scm 506 */
																																																																																			obj_t
																																																																																				BgL_locz00_8935;
																																																																																			BgL_locz00_8935
																																																																																				=
																																																																																				BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																				(BgL_expz00_21,
																																																																																				BgL_locz00_23);
																																																																																			{	/* Ast/sexp.scm 506 */
																																																																																				obj_t
																																																																																					BgL_cdlocz00_8936;
																																																																																				{	/* Ast/sexp.scm 507 */
																																																																																					obj_t
																																																																																						BgL_arg6962z00_8976;
																																																																																					BgL_arg6962z00_8976
																																																																																						=
																																																																																						CDR
																																																																																						(
																																																																																						((obj_t) BgL_expz00_21));
																																																																																					BgL_cdlocz00_8936
																																																																																						=
																																																																																						BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																						(BgL_arg6962z00_8976,
																																																																																						BgL_locz00_8935);
																																																																																				}
																																																																																				{	/* Ast/sexp.scm 507 */
																																																																																					obj_t
																																																																																						BgL_cddlocz00_8937;
																																																																																					{	/* Ast/sexp.scm 508 */
																																																																																						obj_t
																																																																																							BgL_arg6961z00_8975;
																																																																																						BgL_arg6961z00_8975
																																																																																							=
																																																																																							CDR
																																																																																							(
																																																																																							((obj_t) BgL_expz00_21));
																																																																																						BgL_cddlocz00_8937
																																																																																							=
																																																																																							BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																							(BgL_arg6961z00_8975,
																																																																																							BgL_locz00_8935);
																																																																																					}
																																																																																					{	/* Ast/sexp.scm 508 */
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_testz00_8938;
																																																																																						{	/* Ast/sexp.scm 511 */
																																																																																							obj_t
																																																																																								BgL_arg6960z00_8974;
																																																																																							BgL_arg6960z00_8974
																																																																																								=
																																																																																								BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																								(BgL_testz00_8925,
																																																																																								BgL_cdlocz00_8936);
																																																																																							BgL_testz00_8938
																																																																																								=
																																																																																								BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																																								(BgL_testz00_8925,
																																																																																								BgL_stackz00_22,
																																																																																								BgL_arg6960z00_8974,
																																																																																								CNST_TABLE_REF
																																																																																								(((long) 2)));
																																																																																						}
																																																																																						{	/* Ast/sexp.scm 509 */

																																																																																							{
																																																																																								obj_t
																																																																																									BgL_clsz00_8941;
																																																																																								obj_t
																																																																																									BgL_nclausesz00_8942;
																																																																																								BgL_clsz00_8941
																																																																																									=
																																																																																									BgL_clausesz00_8926;
																																																																																								BgL_nclausesz00_8942
																																																																																									=
																																																																																									BNIL;
																																																																																							BgL_zc3z04anonymousza36937ze3z87_8943:
																																																																																								if (NULLP(BgL_clsz00_8941))
																																																																																									{	/* Ast/sexp.scm 516 */
																																																																																										BgL_switchz00_bglt
																																																																																											BgL_new1143z00_8945;
																																																																																										{	/* Ast/sexp.scm 517 */
																																																																																											BgL_switchz00_bglt
																																																																																												BgL_new1142z00_8949;
																																																																																											BgL_new1142z00_8949
																																																																																												=
																																																																																												(
																																																																																												(BgL_switchz00_bglt)
																																																																																												BOBJECT
																																																																																												(GC_MALLOC
																																																																																													(sizeof
																																																																																														(struct
																																																																																															BgL_switchz00_bgl))));
																																																																																											{	/* Ast/sexp.scm 517 */
																																																																																												long
																																																																																													BgL_arg6942z00_8950;
																																																																																												{	/* Ast/sexp.scm 517 */
																																																																																													long
																																																																																														BgL_res7439z00_10055;
																																																																																													BgL_res7439z00_10055
																																																																																														=
																																																																																														BGL_CLASS_INDEX
																																																																																														(BGl_switchz00zzast_nodez00);
																																																																																													BgL_arg6942z00_8950
																																																																																														=
																																																																																														BgL_res7439z00_10055;
																																																																																												}
																																																																																												BGL_OBJECT_CLASS_NUM_SET
																																																																																													(
																																																																																													((BgL_objectz00_bglt) BgL_new1142z00_8949), BgL_arg6942z00_8950);
																																																																																											}
																																																																																											{	/* Ast/sexp.scm 517 */
																																																																																												BgL_objectz00_bglt
																																																																																													BgL_tmpz00_15655;
																																																																																												BgL_tmpz00_15655
																																																																																													=
																																																																																													(
																																																																																													(BgL_objectz00_bglt)
																																																																																													BgL_new1142z00_8949);
																																																																																												BGL_OBJECT_WIDENING_SET
																																																																																													(BgL_tmpz00_15655,
																																																																																													BFALSE);
																																																																																											}
																																																																																											((BgL_objectz00_bglt) BgL_new1142z00_8949);
																																																																																											BgL_new1143z00_8945
																																																																																												=
																																																																																												BgL_new1142z00_8949;
																																																																																										}
																																																																																										((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1143z00_8945)))->BgL_locz00) = ((obj_t) BgL_locz00_8935), BUNSPEC);
																																																																																										((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1143z00_8945)))->BgL_typez00) = ((BgL_typez00_bglt) ((BgL_typez00_bglt) BGl_za2_za2z00zztype_cachez00)), BUNSPEC);
																																																																																										((((BgL_nodezf2effectzf2_bglt) COBJECT(((BgL_nodezf2effectzf2_bglt) BgL_new1143z00_8945)))->BgL_sidezd2effectzd2) = ((obj_t) BUNSPEC), BUNSPEC);
																																																																																										((((BgL_nodezf2effectzf2_bglt) COBJECT(((BgL_nodezf2effectzf2_bglt) BgL_new1143z00_8945)))->BgL_keyz00) = ((obj_t) BINT(((long) -1))), BUNSPEC);
																																																																																										((((BgL_switchz00_bglt) COBJECT(BgL_new1143z00_8945))->BgL_testz00) = ((BgL_nodez00_bglt) BgL_testz00_8938), BUNSPEC);
																																																																																										((((BgL_switchz00_bglt) COBJECT(BgL_new1143z00_8945))->BgL_clausesz00) = ((obj_t) bgl_reverse_bang(BgL_nclausesz00_8942)), BUNSPEC);
																																																																																										{
																																																																																											BgL_typez00_bglt
																																																																																												BgL_auxz00_15672;
																																																																																											{	/* Ast/sexp.scm 520 */
																																																																																												obj_t
																																																																																													BgL_arg6939z00_8946;
																																																																																												{	/* Ast/sexp.scm 520 */
																																																																																													obj_t
																																																																																														BgL_pairz00_10061;
																																																																																													{	/* Ast/sexp.scm 520 */
																																																																																														obj_t
																																																																																															BgL_pairz00_10060;
																																																																																														BgL_pairz00_10060
																																																																																															=
																																																																																															CAR
																																																																																															(
																																																																																															((obj_t) BgL_clausesz00_8926));
																																																																																														BgL_pairz00_10061
																																																																																															=
																																																																																															CAR
																																																																																															(BgL_pairz00_10060);
																																																																																													}
																																																																																													BgL_arg6939z00_8946
																																																																																														=
																																																																																														CAR
																																																																																														(BgL_pairz00_10061);
																																																																																												}
																																																																																												BgL_auxz00_15672
																																																																																													=
																																																																																													BGl_getzd2typezd2atomz00zztype_typeofz00
																																																																																													(BgL_arg6939z00_8946);
																																																																																											}
																																																																																											((((BgL_switchz00_bglt) COBJECT(BgL_new1143z00_8945))->BgL_itemzd2typezd2) = ((BgL_typez00_bglt) BgL_auxz00_15672), BUNSPEC);
																																																																																										}
																																																																																										BgL_auxz00_15633
																																																																																											=
																																																																																											(
																																																																																											(BgL_nodez00_bglt)
																																																																																											BgL_new1143z00_8945);
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 522 */
																																																																																										obj_t
																																																																																											BgL_clausez00_8951;
																																																																																										BgL_clausez00_8951
																																																																																											=
																																																																																											CAR
																																																																																											(
																																																																																											((obj_t) BgL_clsz00_8941));
																																																																																										{	/* Ast/sexp.scm 522 */
																																																																																											BgL_nodez00_bglt
																																																																																												BgL_bodyz00_8952;
																																																																																											{	/* Ast/sexp.scm 523 */
																																																																																												obj_t
																																																																																													BgL_arg6957z00_8970;
																																																																																												obj_t
																																																																																													BgL_arg6958z00_8971;
																																																																																												{	/* Ast/sexp.scm 523 */
																																																																																													obj_t
																																																																																														BgL_arg6959z00_8972;
																																																																																													BgL_arg6959z00_8972
																																																																																														=
																																																																																														CDR
																																																																																														(
																																																																																														((obj_t) BgL_clausez00_8951));
																																																																																													BgL_arg6957z00_8970
																																																																																														=
																																																																																														BGl_normaliza7ezd2prognz75zztools_prognz00
																																																																																														(BgL_arg6959z00_8972);
																																																																																												}
																																																																																												BgL_arg6958z00_8971
																																																																																													=
																																																																																													BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																													(BgL_clausez00_8951,
																																																																																													BgL_cddlocz00_8937);
																																																																																												BgL_bodyz00_8952
																																																																																													=
																																																																																													BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																																													(BgL_arg6957z00_8970,
																																																																																													BgL_stackz00_22,
																																																																																													BgL_arg6958z00_8971,
																																																																																													CNST_TABLE_REF
																																																																																													(((long) 2)));
																																																																																											}
																																																																																											{	/* Ast/sexp.scm 523 */
																																																																																												obj_t
																																																																																													BgL_nclausez00_8953;
																																																																																												{	/* Ast/sexp.scm 527 */
																																																																																													obj_t
																																																																																														BgL_arg6956z00_8969;
																																																																																													BgL_arg6956z00_8969
																																																																																														=
																																																																																														CAR
																																																																																														(
																																																																																														((obj_t) BgL_clausez00_8951));
																																																																																													BgL_nclausez00_8953
																																																																																														=
																																																																																														MAKE_YOUNG_PAIR
																																																																																														(BgL_arg6956z00_8969,
																																																																																														((obj_t) BgL_bodyz00_8952));
																																																																																												}
																																																																																												{	/* Ast/sexp.scm 527 */

																																																																																													{	/* Ast/sexp.scm 529 */
																																																																																														bool_t
																																																																																															BgL_test8322z00_15692;
																																																																																														if ((CAR(((obj_t) BgL_clausez00_8951)) == CNST_TABLE_REF(((long) 5))))
																																																																																															{	/* Ast/sexp.scm 529 */
																																																																																																if (NULLP(CDR(((obj_t) BgL_clsz00_8941))))
																																																																																																	{	/* Ast/sexp.scm 530 */
																																																																																																		BgL_test8322z00_15692
																																																																																																			=
																																																																																																			(
																																																																																																			(bool_t)
																																																																																																			0);
																																																																																																	}
																																																																																																else
																																																																																																	{	/* Ast/sexp.scm 530 */
																																																																																																		BgL_test8322z00_15692
																																																																																																			=
																																																																																																			(
																																																																																																			(bool_t)
																																																																																																			1);
																																																																																																	}
																																																																																															}
																																																																																														else
																																																																																															{	/* Ast/sexp.scm 529 */
																																																																																																BgL_test8322z00_15692
																																																																																																	=
																																																																																																	(
																																																																																																	(bool_t)
																																																																																																	0);
																																																																																															}
																																																																																														if (BgL_test8322z00_15692)
																																																																																															{	/* Ast/sexp.scm 532 */
																																																																																																obj_t
																																																																																																	BgL_arg6950z00_8961;
																																																																																																BgL_arg6950z00_8961
																																																																																																	=
																																																																																																	BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																																	(BgL_expz00_21,
																																																																																																	BgL_locz00_8935);
																																																																																																{	/* Ast/sexp.scm 531 */
																																																																																																	BgL_nodez00_bglt
																																																																																																		BgL_res7441z00_10073;
																																																																																																	{	/* Ast/sexp.scm 723 */
																																																																																																		obj_t
																																																																																																			BgL_arg7080z00_10069;
																																																																																																		BgL_nodez00_bglt
																																																																																																			BgL_arg7081z00_10070;
																																																																																																		BgL_arg7080z00_10069
																																																																																																			=
																																																																																																			BGl_shapez00zztools_shapez00
																																																																																																			(BGl_currentzd2functionzd2zztools_errorz00
																																																																																																			());
																																																																																																		BgL_arg7081z00_10070
																																																																																																			=
																																																																																																			BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																																																			(CNST_TABLE_REF
																																																																																																			(((long) 4)), BNIL, BgL_arg6950z00_8961, CNST_TABLE_REF(((long) 2)));
																																																																																																		{	/* Ast/sexp.scm 722 */
																																																																																																			obj_t
																																																																																																				BgL_list7082z00_10072;
																																																																																																			BgL_list7082z00_10072
																																																																																																				=
																																																																																																				MAKE_YOUNG_PAIR
																																																																																																				(
																																																																																																				((obj_t) BgL_arg7081z00_10070), BNIL);
																																																																																																			BgL_res7441z00_10073
																																																																																																				=
																																																																																																				(
																																																																																																				(BgL_nodez00_bglt)
																																																																																																				BGl_userzd2errorzf2locationz20zztools_errorz00
																																																																																																				(BgL_arg6950z00_8961,
																																																																																																					BgL_arg7080z00_10069,
																																																																																																					BGl_string7997z00zzast_sexpz00,
																																																																																																					BgL_expz00_21,
																																																																																																					BgL_list7082z00_10072));
																																																																																																	}}
																																																																																																	BgL_auxz00_15633
																																																																																																		=
																																																																																																		BgL_res7441z00_10073;
																																																																																															}}
																																																																																														else
																																																																																															{	/* Ast/sexp.scm 533 */
																																																																																																obj_t
																																																																																																	BgL_arg6951z00_8962;
																																																																																																obj_t
																																																																																																	BgL_arg6952z00_8963;
																																																																																																BgL_arg6951z00_8962
																																																																																																	=
																																																																																																	CDR
																																																																																																	(
																																																																																																	((obj_t) BgL_clsz00_8941));
																																																																																																BgL_arg6952z00_8963
																																																																																																	=
																																																																																																	MAKE_YOUNG_PAIR
																																																																																																	(BGl_epairifyz00zztools_miscz00
																																																																																																	(BgL_nclausez00_8953,
																																																																																																		BgL_clausez00_8951),
																																																																																																	BgL_nclausesz00_8942);
																																																																																																{
																																																																																																	obj_t
																																																																																																		BgL_nclausesz00_15717;
																																																																																																	obj_t
																																																																																																		BgL_clsz00_15716;
																																																																																																	BgL_clsz00_15716
																																																																																																		=
																																																																																																		BgL_arg6951z00_8962;
																																																																																																	BgL_nclausesz00_15717
																																																																																																		=
																																																																																																		BgL_arg6952z00_8963;
																																																																																																	BgL_nclausesz00_8942
																																																																																																		=
																																																																																																		BgL_nclausesz00_15717;
																																																																																																	BgL_clsz00_8941
																																																																																																		=
																																																																																																		BgL_clsz00_15716;
																																																																																																	goto
																																																																																																		BgL_zc3z04anonymousza36937ze3z87_8943;
																																																																																																}
																																																																																															}
																																																																																													}
																																																																																												}
																																																																																											}
																																																																																										}
																																																																																									}
																																																																																							}
																																																																																						}
																																																																																					}
																																																																																				}
																																																																																			}
																																																																																		}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																	BgL_tagzd262386zd2_8928:
																																																																																		{	/* Ast/sexp.scm 538 */
																																																																																			obj_t
																																																																																				BgL_arg6963z00_8977;
																																																																																			BgL_arg6963z00_8977
																																																																																				=
																																																																																				BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																				(BgL_expz00_21,
																																																																																				BgL_locz00_23);
																																																																																			{	/* Ast/sexp.scm 537 */
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_res7442z00_10080;
																																																																																				{	/* Ast/sexp.scm 723 */
																																																																																					obj_t
																																																																																						BgL_arg7080z00_10076;
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_arg7081z00_10077;
																																																																																					BgL_arg7080z00_10076
																																																																																						=
																																																																																						BGl_shapez00zztools_shapez00
																																																																																						(BGl_currentzd2functionzd2zztools_errorz00
																																																																																						());
																																																																																					BgL_arg7081z00_10077
																																																																																						=
																																																																																						BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																																						(CNST_TABLE_REF
																																																																																						(((long) 4)), BNIL, BgL_arg6963z00_8977, CNST_TABLE_REF(((long) 2)));
																																																																																					{	/* Ast/sexp.scm 722 */
																																																																																						obj_t
																																																																																							BgL_list7082z00_10079;
																																																																																						BgL_list7082z00_10079
																																																																																							=
																																																																																							MAKE_YOUNG_PAIR
																																																																																							(
																																																																																							((obj_t) BgL_arg7081z00_10077), BNIL);
																																																																																						BgL_res7442z00_10080
																																																																																							=
																																																																																							(
																																																																																							(BgL_nodez00_bglt)
																																																																																							BGl_userzd2errorzf2locationz20zztools_errorz00
																																																																																							(BgL_arg6963z00_8977,
																																																																																								BgL_arg7080z00_10076,
																																																																																								BGl_string7997z00zzast_sexpz00,
																																																																																								BgL_expz00_21,
																																																																																								BgL_list7082z00_10079));
																																																																																				}}
																																																																																				BgL_auxz00_15633
																																																																																					=
																																																																																					BgL_res7442z00_10080;
																																																																															}}}}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd262386zd2_8928;
																																																																															}
																																																																													}
																																																																													BgL_auxz00_14266
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_15633);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																														{
																																																																															BgL_letzd2funzd2_bglt
																																																																																BgL_auxz00_15736;
																																																																														BgL_tagzd2397zd2_1766:
																																																																															BgL_auxz00_15736 = BGl_setzd2exitzd2ze3nodeze3zzast_exitz00(BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																															BgL_auxz00_14266
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_15736);
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																																{
																																																																																	BgL_jumpzd2exzd2itz00_bglt
																																																																																		BgL_auxz00_15744;
																																																																																BgL_tagzd2398zd2_1767:
																																																																																	BgL_auxz00_15744 = BGl_jumpzd2exitzd2ze3nodeze3zzast_exitz00(BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																																	BgL_auxz00_14266
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_15744);
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_cdrzd23965zd2_2894;
																																																																																	BgL_cdrzd23965zd2_2894
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_expz00_21));
																																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_arg2474z00_2897;
																																																																																			obj_t
																																																																																				BgL_arg2475z00_2898;
																																																																																			BgL_arg2474z00_2897
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd23965zd2_2894));
																																																																																			BgL_arg2475z00_2898
																																																																																				=
																																																																																				CDR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd23965zd2_2894));
																																																																																			{	/* Ast/sexp.scm 552 */
																																																																																				obj_t
																																																																																					BgL_arg6965z00_10296;
																																																																																				BgL_arg6965z00_10296
																																																																																					=
																																																																																					BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																					(BgL_expz00_21,
																																																																																					BgL_locz00_23);
																																																																																				BgL_auxz00_14266
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																					(BgL_expz00_21,
																																																																																						BgL_arg2474z00_2897,
																																																																																						CNST_TABLE_REF
																																																																																						(((long) 4)), BgL_arg2475z00_2898, BgL_stackz00_22, BgL_arg6965z00_10296, BgL_sitez00_24));
																																																																																		}}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1777;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_15764;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1778;
																																																																																					BgL_auxz00_14266
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_15764);
																																																																																				}
																																																																																		}
																																																																																}
																																																																														}
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					obj_t
																																						BgL_carzd23990zd2_2915;
																																					BgL_carzd23990zd2_2915
																																						=
																																						CAR(
																																						((obj_t) BgL_expz00_21));
																																					if (
																																						(BgL_carzd23990zd2_2915
																																							==
																																							CNST_TABLE_REF
																																							(((long) 1))))
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_15771;
																																							goto
																																								BgL_tagzd2377zd2_1722;
																																							BgL_auxz00_14266
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_15771);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							if ((BgL_carzd23990zd2_2915 == BGl_za2ifza2z00zzast_sexpz00))
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_15775;
																																									goto
																																										BgL_tagzd2377zd2_1722;
																																									BgL_auxz00_14266
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_15775);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 7))))
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_15782;
																																											goto
																																												BgL_tagzd2379zd2_1726;
																																											BgL_auxz00_14266
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_15782);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_15789;
																																													goto
																																														BgL_tagzd2380zd2_1727;
																																													BgL_auxz00_14266
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_15789);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_carzd24059zd2_2922;
																																													BgL_carzd24059zd2_2922
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													if (PAIRP(BgL_carzd24059zd2_2922))
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_carzd24062zd2_2924;
																																															obj_t
																																																BgL_cdrzd24063zd2_2925;
																																															BgL_carzd24062zd2_2924
																																																=
																																																CAR
																																																(BgL_carzd24059zd2_2922);
																																															BgL_cdrzd24063zd2_2925
																																																=
																																																CDR
																																																(BgL_carzd24059zd2_2922);
																																															{

																																																if ((BgL_carzd24062zd2_2924 == CNST_TABLE_REF(((long) 17))))
																																																	{	/* Ast/sexp.scm 119 */
																																																	BgL_kapzd24064zd2_2926:
																																																		if (PAIRP(BgL_cdrzd24063zd2_2925))
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd24067zd2_3051;
																																																				BgL_cdrzd24067zd2_3051
																																																					=
																																																					CDR
																																																					(BgL_cdrzd24063zd2_2925);
																																																				if (PAIRP(BgL_cdrzd24067zd2_3051))
																																																					{	/* Ast/sexp.scm 119 */
																																																						if (NULLP(CDR(BgL_cdrzd24067zd2_3051)))
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg2613z00_3055;
																																																								obj_t
																																																									BgL_arg2614z00_3056;
																																																								BgL_arg2613z00_3055
																																																									=
																																																									CAR
																																																									(BgL_cdrzd24067zd2_3051);
																																																								BgL_arg2614z00_3056
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_15811;
																																																									{
																																																										obj_t
																																																											BgL_argsz00_15813;
																																																										obj_t
																																																											BgL_bodyz00_15812;
																																																										BgL_bodyz00_15812
																																																											=
																																																											BgL_arg2613z00_3055;
																																																										BgL_argsz00_15813
																																																											=
																																																											BgL_arg2614z00_3056;
																																																										BgL_argsz00_1729
																																																											=
																																																											BgL_argsz00_15813;
																																																										BgL_bodyz00_1728
																																																											=
																																																											BgL_bodyz00_15812;
																																																										goto
																																																											BgL_tagzd2381zd2_1730;
																																																									}
																																																									BgL_auxz00_14266
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_15811);
																																																								}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd24091zd2_3057;
																																																								BgL_cdrzd24091zd2_3057
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{	/* Ast/sexp.scm 119 */
																																																									bool_t
																																																										BgL_test8338z00_15817;
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg2690z00_3168;
																																																										BgL_arg2690z00_3168
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_test8338z00_15817
																																																											=
																																																											CBOOL
																																																											(BGl_letzd2symzf3z21zzast_letz00
																																																											(BgL_arg2690z00_3168));
																																																									}
																																																									if (BgL_test8338z00_15817)
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_arg2617z00_3060;
																																																											obj_t
																																																												BgL_arg2619z00_3061;
																																																											BgL_arg2617z00_3060
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_cdrzd24091zd2_3057));
																																																											BgL_arg2619z00_3061
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd24091zd2_3057));
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_15826;
																																																												{
																																																													obj_t
																																																														BgL_exprz00_15828;
																																																													obj_t
																																																														BgL_bindingsz00_15827;
																																																													BgL_bindingsz00_15827
																																																														=
																																																														BgL_arg2617z00_3060;
																																																													BgL_exprz00_15828
																																																														=
																																																														BgL_arg2619z00_3061;
																																																													BgL_exprz00_1732
																																																														=
																																																														BgL_exprz00_15828;
																																																													BgL_bindingsz00_1731
																																																														=
																																																														BgL_bindingsz00_15827;
																																																													goto
																																																														BgL_tagzd2382zd2_1733;
																																																												}
																																																												BgL_auxz00_14266
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_15826);
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											bool_t
																																																												BgL_test8339z00_15830;
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_arg2689z00_3167;
																																																												BgL_arg2689z00_3167
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												BgL_test8339z00_15830
																																																													=
																																																													CBOOL
																																																													(BGl_labelszd2symzf3z21zzast_labelsz00
																																																													(BgL_arg2689z00_3167));
																																																											}
																																																											if (BgL_test8339z00_15830)
																																																												{
																																																													BgL_letzd2funzd2_bglt
																																																														BgL_auxz00_15835;
																																																													goto
																																																														BgL_tagzd2384zd2_1735;
																																																													BgL_auxz00_14266
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_15835);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_carzd24158zd2_3064;
																																																													BgL_carzd24158zd2_3064
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd24163zd2_3065;
																																																														BgL_cdrzd24163zd2_3065
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_carzd24158zd2_3064));
																																																														if ((CAR(((obj_t) BgL_carzd24158zd2_3064)) == CNST_TABLE_REF(((long) 3))))
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_arg2624z00_3068;
																																																																obj_t
																																																																	BgL_arg2625z00_3069;
																																																																obj_t
																																																																	BgL_arg2626z00_3070;
																																																																BgL_arg2624z00_3068
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd24163zd2_3065));
																																																																BgL_arg2625z00_3069
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd24163zd2_3065));
																																																																BgL_arg2626z00_3070
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_15852;
																																																																	{
																																																																		obj_t
																																																																			BgL_argsz00_15855;
																																																																		obj_t
																																																																			BgL_bodyz00_15854;
																																																																		obj_t
																																																																			BgL_varsz00_15853;
																																																																		BgL_varsz00_15853
																																																																			=
																																																																			BgL_arg2624z00_3068;
																																																																		BgL_bodyz00_15854
																																																																			=
																																																																			BgL_arg2625z00_3069;
																																																																		BgL_argsz00_15855
																																																																			=
																																																																			BgL_arg2626z00_3070;
																																																																		BgL_argsz00_1742
																																																																			=
																																																																			BgL_argsz00_15855;
																																																																		BgL_bodyz00_1741
																																																																			=
																																																																			BgL_bodyz00_15854;
																																																																		BgL_varsz00_1740
																																																																			=
																																																																			BgL_varsz00_15853;
																																																																		goto
																																																																			BgL_tagzd2386zd2_1743;
																																																																	}
																																																																	BgL_auxz00_14266
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_15852);
																																																																}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd24186zd2_3072;
																																																																BgL_cdrzd24186zd2_3072
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd24192zd2_3073;
																																																																	BgL_cdrzd24192zd2_3073
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_carzd24158zd2_3064));
																																																																	if ((CAR(((obj_t) BgL_carzd24158zd2_3064)) == CNST_TABLE_REF(((long) 1))))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd24198zd2_3076;
																																																																			BgL_cdrzd24198zd2_3076
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd24192zd2_3073));
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_carzd24203zd2_3077;
																																																																				obj_t
																																																																					BgL_cdrzd24204zd2_3078;
																																																																				BgL_carzd24203zd2_3077
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd24198zd2_3076));
																																																																				BgL_cdrzd24204zd2_3078
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd24198zd2_3076));
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd24203zd2_3077))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (PAIRP(BgL_cdrzd24204zd2_3078))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_carzd24211zd2_3081;
																																																																								BgL_carzd24211zd2_3081
																																																																									=
																																																																									CAR
																																																																									(BgL_cdrzd24204zd2_3078);
																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd24211zd2_3081))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (NULLP(CDR(BgL_cdrzd24204zd2_3078)))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												bool_t
																																																																													BgL_test8346z00_15882;
																																																																												{
																																																																													obj_t
																																																																														BgL_l1372z00_3114;
																																																																													BgL_l1372z00_3114
																																																																														=
																																																																														BgL_cdrzd24186zd2_3072;
																																																																												BgL_zc3z04anonymousza32649ze3z87_3115:
																																																																													if (NULLP(BgL_l1372z00_3114))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															BgL_test8346z00_15882
																																																																																=
																																																																																(
																																																																																(bool_t)
																																																																																1);
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															bool_t
																																																																																BgL_test8348z00_15885;
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																bool_t
																																																																																	BgL_test8349z00_15886;
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_tmpz00_15887;
																																																																																	BgL_tmpz00_15887
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_l1372z00_3114));
																																																																																	BgL_test8349z00_15886
																																																																																		=
																																																																																		PAIRP
																																																																																		(BgL_tmpz00_15887);
																																																																																}
																																																																																if (BgL_test8349z00_15886)
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		BgL_test8348z00_15885
																																																																																			=
																																																																																			(
																																																																																			(bool_t)
																																																																																			0);
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		BgL_test8348z00_15885
																																																																																			=
																																																																																			(
																																																																																			(bool_t)
																																																																																			1);
																																																																																	}
																																																																															}
																																																																															if (BgL_test8348z00_15885)
																																																																																{
																																																																																	obj_t
																																																																																		BgL_l1372z00_15891;
																																																																																	BgL_l1372z00_15891
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_l1372z00_3114));
																																																																																	BgL_l1372z00_3114
																																																																																		=
																																																																																		BgL_l1372z00_15891;
																																																																																	goto
																																																																																		BgL_zc3z04anonymousza32649ze3z87_3115;
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	BgL_test8346z00_15882
																																																																																		=
																																																																																		(
																																																																																		(bool_t)
																																																																																		0);
																																																																																}
																																																																														}
																																																																												}
																																																																												if (BgL_test8346z00_15882)
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_arg2639z00_3097;
																																																																														BgL_arg2639z00_3097
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd24192zd2_3073));
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_15896;
																																																																															{
																																																																																obj_t
																																																																																	BgL_argsz00_15900;
																																																																																obj_t
																																																																																	BgL_proc2z00_15899;
																																																																																obj_t
																																																																																	BgL_proc1z00_15898;
																																																																																obj_t
																																																																																	BgL_testz00_15897;
																																																																																BgL_testz00_15897
																																																																																	=
																																																																																	BgL_arg2639z00_3097;
																																																																																BgL_proc1z00_15898
																																																																																	=
																																																																																	BgL_carzd24203zd2_3077;
																																																																																BgL_proc2z00_15899
																																																																																	=
																																																																																	BgL_carzd24211zd2_3081;
																																																																																BgL_argsz00_15900
																																																																																	=
																																																																																	BgL_cdrzd24186zd2_3072;
																																																																																BgL_argsz00_1747
																																																																																	=
																																																																																	BgL_argsz00_15900;
																																																																																BgL_proc2z00_1746
																																																																																	=
																																																																																	BgL_proc2z00_15899;
																																																																																BgL_proc1z00_1745
																																																																																	=
																																																																																	BgL_proc1z00_15898;
																																																																																BgL_testz00_1744
																																																																																	=
																																																																																	BgL_testz00_15897;
																																																																																goto
																																																																																	BgL_tagzd2387zd2_1748;
																																																																															}
																																																																															BgL_auxz00_14266
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_15896);
																																																																														}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_cdrzd24235zd2_3098;
																																																																														BgL_cdrzd24235zd2_3098
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_expz00_21));
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_cdrzd24242zd2_3099;
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_pairz00_10340;
																																																																																BgL_pairz00_10340
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_expz00_21));
																																																																																BgL_cdrzd24242zd2_3099
																																																																																	=
																																																																																	CDR
																																																																																	(BgL_pairz00_10340);
																																																																															}
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_cdrzd24249zd2_3100;
																																																																																BgL_cdrzd24249zd2_3100
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd24242zd2_3099));
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_carzd24255zd2_3101;
																																																																																	BgL_carzd24255zd2_3101
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd24249zd2_3100));
																																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd24255zd2_3101))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_carzd24262zd2_3103;
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_pairz00_10344;
																																																																																				BgL_pairz00_10344
																																																																																					=
																																																																																					CDR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd24249zd2_3100));
																																																																																				BgL_carzd24262zd2_3103
																																																																																					=
																																																																																					CAR
																																																																																					(BgL_pairz00_10344);
																																																																																			}
																																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd24262zd2_3103))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd24235zd2_3098))
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							obj_t
																																																																																								BgL_arg2643z00_3106;
																																																																																							BgL_arg2643z00_3106
																																																																																								=
																																																																																								CAR
																																																																																								(
																																																																																								((obj_t) BgL_cdrzd24242zd2_3099));
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_15922;
																																																																																								{
																																																																																									obj_t
																																																																																										BgL_argsz00_15926;
																																																																																									obj_t
																																																																																										BgL_proc2z00_15925;
																																																																																									obj_t
																																																																																										BgL_proc1z00_15924;
																																																																																									obj_t
																																																																																										BgL_testz00_15923;
																																																																																									BgL_testz00_15923
																																																																																										=
																																																																																										BgL_arg2643z00_3106;
																																																																																									BgL_proc1z00_15924
																																																																																										=
																																																																																										BgL_carzd24255zd2_3101;
																																																																																									BgL_proc2z00_15925
																																																																																										=
																																																																																										BgL_carzd24262zd2_3103;
																																																																																									BgL_argsz00_15926
																																																																																										=
																																																																																										BgL_cdrzd24235zd2_3098;
																																																																																									BgL_argsz00_1752
																																																																																										=
																																																																																										BgL_argsz00_15926;
																																																																																									BgL_proc2z00_1751
																																																																																										=
																																																																																										BgL_proc2z00_15925;
																																																																																									BgL_proc1z00_1750
																																																																																										=
																																																																																										BgL_proc1z00_15924;
																																																																																									BgL_testz00_1749
																																																																																										=
																																																																																										BgL_testz00_15923;
																																																																																									goto
																																																																																										BgL_tagzd2388zd2_1753;
																																																																																								}
																																																																																								BgL_auxz00_14266
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_15922);
																																																																																							}
																																																																																						}
																																																																																					else
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																								{	/* Ast/sexp.scm 119 */
																																																																																									goto
																																																																																										BgL_tagzd2403zd2_1777;
																																																																																								}
																																																																																							else
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_15930;
																																																																																									goto
																																																																																										BgL_tagzd2404zd2_1778;
																																																																																									BgL_auxz00_14266
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_15930);
																																																																																								}
																																																																																						}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							goto
																																																																																								BgL_tagzd2403zd2_1777;
																																																																																						}
																																																																																					else
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_15934;
																																																																																							goto
																																																																																								BgL_tagzd2404zd2_1778;
																																																																																							BgL_auxz00_14266
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_15934);
																																																																																						}
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1777;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_15938;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1778;
																																																																																					BgL_auxz00_14266
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_15938);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															}
																																																																														}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1777;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_15942;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1778;
																																																																														BgL_auxz00_14266
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_15942);
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd24538zd2_3125;
																																																																										BgL_cdrzd24538zd2_3125
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd24544zd2_3126;
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_pairz00_10348;
																																																																												BgL_pairz00_10348
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												BgL_cdrzd24544zd2_3126
																																																																													=
																																																																													CDR
																																																																													(BgL_pairz00_10348);
																																																																											}
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_cdrzd24550zd2_3127;
																																																																												BgL_cdrzd24550zd2_3127
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd24544zd2_3126));
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_carzd24555zd2_3128;
																																																																													obj_t
																																																																														BgL_cdrzd24556zd2_3129;
																																																																													BgL_carzd24555zd2_3128
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd24550zd2_3127));
																																																																													BgL_cdrzd24556zd2_3129
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd24550zd2_3127));
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd24555zd2_3128))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_carzd24561zd2_3131;
																																																																															BgL_carzd24561zd2_3131
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd24556zd2_3129));
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd24561zd2_3131))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (NULLP(CDR(((obj_t) BgL_cdrzd24556zd2_3129))))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd24538zd2_3125))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					obj_t
																																																																																						BgL_arg2663z00_3136;
																																																																																					BgL_arg2663z00_3136
																																																																																						=
																																																																																						CAR
																																																																																						(
																																																																																						((obj_t) BgL_cdrzd24544zd2_3126));
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_15969;
																																																																																						{
																																																																																							obj_t
																																																																																								BgL_argsz00_15973;
																																																																																							obj_t
																																																																																								BgL_proc2z00_15972;
																																																																																							obj_t
																																																																																								BgL_proc1z00_15971;
																																																																																							obj_t
																																																																																								BgL_testz00_15970;
																																																																																							BgL_testz00_15970
																																																																																								=
																																																																																								BgL_arg2663z00_3136;
																																																																																							BgL_proc1z00_15971
																																																																																								=
																																																																																								BgL_carzd24555zd2_3128;
																																																																																							BgL_proc2z00_15972
																																																																																								=
																																																																																								BgL_carzd24561zd2_3131;
																																																																																							BgL_argsz00_15973
																																																																																								=
																																																																																								BgL_cdrzd24538zd2_3125;
																																																																																							BgL_argsz00_1752
																																																																																								=
																																																																																								BgL_argsz00_15973;
																																																																																							BgL_proc2z00_1751
																																																																																								=
																																																																																								BgL_proc2z00_15972;
																																																																																							BgL_proc1z00_1750
																																																																																								=
																																																																																								BgL_proc1z00_15971;
																																																																																							BgL_testz00_1749
																																																																																								=
																																																																																								BgL_testz00_15970;
																																																																																							goto
																																																																																								BgL_tagzd2388zd2_1753;
																																																																																						}
																																																																																						BgL_auxz00_14266
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_15969);
																																																																																					}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							goto
																																																																																								BgL_tagzd2403zd2_1777;
																																																																																						}
																																																																																					else
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_15977;
																																																																																							goto
																																																																																								BgL_tagzd2404zd2_1778;
																																																																																							BgL_auxz00_14266
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_15977);
																																																																																						}
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1777;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_15981;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1778;
																																																																																					BgL_auxz00_14266
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_15981);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1777;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_15985;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1778;
																																																																																			BgL_auxz00_14266
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_15985);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1777;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_15989;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1778;
																																																																																	BgL_auxz00_14266
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_15989);
																																																																																}
																																																																														}
																																																																												}
																																																																											}
																																																																										}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1777;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_15993;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1778;
																																																																										BgL_auxz00_14266
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_15993);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd24894zd2_3144;
																																																																						BgL_cdrzd24894zd2_3144
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd24901zd2_3145;
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_pairz00_10358;
																																																																								BgL_pairz00_10358
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								BgL_cdrzd24901zd2_3145
																																																																									=
																																																																									CDR
																																																																									(BgL_pairz00_10358);
																																																																							}
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd24908zd2_3146;
																																																																								BgL_cdrzd24908zd2_3146
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd24901zd2_3145));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd24914zd2_3147;
																																																																									obj_t
																																																																										BgL_cdrzd24915zd2_3148;
																																																																									BgL_carzd24914zd2_3147
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd24908zd2_3146));
																																																																									BgL_cdrzd24915zd2_3148
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd24908zd2_3146));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd24914zd2_3147))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (PAIRP(BgL_cdrzd24915zd2_3148))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_carzd24922zd2_3151;
																																																																													BgL_carzd24922zd2_3151
																																																																														=
																																																																														CAR
																																																																														(BgL_cdrzd24915zd2_3148);
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd24922zd2_3151))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (NULLP(CDR(BgL_cdrzd24915zd2_3148)))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd24894zd2_3144))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_arg2677z00_3156;
																																																																																			BgL_arg2677z00_3156
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd24901zd2_3145));
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_16020;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_16024;
																																																																																					obj_t
																																																																																						BgL_proc2z00_16023;
																																																																																					obj_t
																																																																																						BgL_proc1z00_16022;
																																																																																					obj_t
																																																																																						BgL_testz00_16021;
																																																																																					BgL_testz00_16021
																																																																																						=
																																																																																						BgL_arg2677z00_3156;
																																																																																					BgL_proc1z00_16022
																																																																																						=
																																																																																						BgL_carzd24914zd2_3147;
																																																																																					BgL_proc2z00_16023
																																																																																						=
																																																																																						BgL_carzd24922zd2_3151;
																																																																																					BgL_argsz00_16024
																																																																																						=
																																																																																						BgL_cdrzd24894zd2_3144;
																																																																																					BgL_argsz00_1752
																																																																																						=
																																																																																						BgL_argsz00_16024;
																																																																																					BgL_proc2z00_1751
																																																																																						=
																																																																																						BgL_proc2z00_16023;
																																																																																					BgL_proc1z00_1750
																																																																																						=
																																																																																						BgL_proc1z00_16022;
																																																																																					BgL_testz00_1749
																																																																																						=
																																																																																						BgL_testz00_16021;
																																																																																					goto
																																																																																						BgL_tagzd2388zd2_1753;
																																																																																				}
																																																																																				BgL_auxz00_14266
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_16020);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1777;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_16028;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1778;
																																																																																					BgL_auxz00_14266
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_16028);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1777;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_16032;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1778;
																																																																																			BgL_auxz00_14266
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_16032);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1777;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_16036;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1778;
																																																																																	BgL_auxz00_14266
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_16036);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1777;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_16040;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1778;
																																																																															BgL_auxz00_14266
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_16040);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1777;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_16044;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1778;
																																																																													BgL_auxz00_14266
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_16044);
																																																																												}
																																																																										}
																																																																								}
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1777;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_16048;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1778;
																																																																					BgL_auxz00_14266
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_16048);
																																																																				}
																																																																		}
																																																																}
																																																															}
																																																													}
																																																												}
																																																										}
																																																								}
																																																							}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd25315zd2_3170;
																																																						BgL_cdrzd25315zd2_3170
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{	/* Ast/sexp.scm 119 */
																																																							bool_t
																																																								BgL_test8377z00_16052;
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg2706z00_3187;
																																																								BgL_arg2706z00_3187
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test8377z00_16052
																																																									=
																																																									CBOOL
																																																									(BGl_letzd2symzf3z21zzast_letz00
																																																									(BgL_arg2706z00_3187));
																																																							}
																																																							if (BgL_test8377z00_16052)
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_arg2694z00_3173;
																																																									obj_t
																																																										BgL_arg2695z00_3174;
																																																									BgL_arg2694z00_3173
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd25315zd2_3170));
																																																									BgL_arg2695z00_3174
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd25315zd2_3170));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_16061;
																																																										{
																																																											obj_t
																																																												BgL_exprz00_16063;
																																																											obj_t
																																																												BgL_bindingsz00_16062;
																																																											BgL_bindingsz00_16062
																																																												=
																																																												BgL_arg2694z00_3173;
																																																											BgL_exprz00_16063
																																																												=
																																																												BgL_arg2695z00_3174;
																																																											BgL_exprz00_1732
																																																												=
																																																												BgL_exprz00_16063;
																																																											BgL_bindingsz00_1731
																																																												=
																																																												BgL_bindingsz00_16062;
																																																											goto
																																																												BgL_tagzd2382zd2_1733;
																																																										}
																																																										BgL_auxz00_14266
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_16061);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									bool_t
																																																										BgL_test8378z00_16065;
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg2705z00_3186;
																																																										BgL_arg2705z00_3186
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_test8378z00_16065
																																																											=
																																																											CBOOL
																																																											(BGl_labelszd2symzf3z21zzast_labelsz00
																																																											(BgL_arg2705z00_3186));
																																																									}
																																																									if (BgL_test8378z00_16065)
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_16070;
																																																											goto
																																																												BgL_tagzd2384zd2_1735;
																																																											BgL_auxz00_14266
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_16070);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_carzd25381zd2_3177;
																																																											BgL_carzd25381zd2_3177
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd25386zd2_3178;
																																																												BgL_cdrzd25386zd2_3178
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_carzd25381zd2_3177));
																																																												if ((CAR(((obj_t) BgL_carzd25381zd2_3177)) == CNST_TABLE_REF(((long) 3))))
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_arg2700z00_3181;
																																																														obj_t
																																																															BgL_arg2701z00_3182;
																																																														obj_t
																																																															BgL_arg2702z00_3183;
																																																														BgL_arg2700z00_3181
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd25386zd2_3178));
																																																														BgL_arg2701z00_3182
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd25386zd2_3178));
																																																														BgL_arg2702z00_3183
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_16087;
																																																															{
																																																																obj_t
																																																																	BgL_argsz00_16090;
																																																																obj_t
																																																																	BgL_bodyz00_16089;
																																																																obj_t
																																																																	BgL_varsz00_16088;
																																																																BgL_varsz00_16088
																																																																	=
																																																																	BgL_arg2700z00_3181;
																																																																BgL_bodyz00_16089
																																																																	=
																																																																	BgL_arg2701z00_3182;
																																																																BgL_argsz00_16090
																																																																	=
																																																																	BgL_arg2702z00_3183;
																																																																BgL_argsz00_1742
																																																																	=
																																																																	BgL_argsz00_16090;
																																																																BgL_bodyz00_1741
																																																																	=
																																																																	BgL_bodyz00_16089;
																																																																BgL_varsz00_1740
																																																																	=
																																																																	BgL_varsz00_16088;
																																																																goto
																																																																	BgL_tagzd2386zd2_1743;
																																																															}
																																																															BgL_auxz00_14266
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_16087);
																																																														}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 119 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1777;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_16094;
																																																																goto
																																																																	BgL_tagzd2404zd2_1778;
																																																																BgL_auxz00_14266
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_16094);
																																																															}
																																																													}
																																																											}
																																																										}
																																																								}
																																																						}
																																																					}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd25497zd2_3188;
																																																				BgL_cdrzd25497zd2_3188
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 119 */
																																																					bool_t
																																																						BgL_test8381z00_16098;
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg2715z00_3197;
																																																						BgL_arg2715z00_3197
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test8381z00_16098
																																																							=
																																																							CBOOL
																																																							(BGl_letzd2symzf3z21zzast_letz00
																																																							(BgL_arg2715z00_3197));
																																																					}
																																																					if (BgL_test8381z00_16098)
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_arg2709z00_3191;
																																																							obj_t
																																																								BgL_arg2710z00_3192;
																																																							BgL_arg2709z00_3191
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd25497zd2_3188));
																																																							BgL_arg2710z00_3192
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd25497zd2_3188));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_16107;
																																																								{
																																																									obj_t
																																																										BgL_exprz00_16109;
																																																									obj_t
																																																										BgL_bindingsz00_16108;
																																																									BgL_bindingsz00_16108
																																																										=
																																																										BgL_arg2709z00_3191;
																																																									BgL_exprz00_16109
																																																										=
																																																										BgL_arg2710z00_3192;
																																																									BgL_exprz00_1732
																																																										=
																																																										BgL_exprz00_16109;
																																																									BgL_bindingsz00_1731
																																																										=
																																																										BgL_bindingsz00_16108;
																																																									goto
																																																										BgL_tagzd2382zd2_1733;
																																																								}
																																																								BgL_auxz00_14266
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_16107);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							bool_t
																																																								BgL_test8382z00_16111;
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg2714z00_3196;
																																																								BgL_arg2714z00_3196
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test8382z00_16111
																																																									=
																																																									CBOOL
																																																									(BGl_labelszd2symzf3z21zzast_labelsz00
																																																									(BgL_arg2714z00_3196));
																																																							}
																																																							if (BgL_test8382z00_16111)
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_16116;
																																																									goto
																																																										BgL_tagzd2384zd2_1735;
																																																									BgL_auxz00_14266
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_16116);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																										{	/* Ast/sexp.scm 119 */
																																																											goto
																																																												BgL_tagzd2403zd2_1777;
																																																										}
																																																									else
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_16120;
																																																											goto
																																																												BgL_tagzd2404zd2_1778;
																																																											BgL_auxz00_14266
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_16120);
																																																										}
																																																								}
																																																						}
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd24062zd2_2924)))
																																																			{	/* Ast/sexp.scm 119 */
																																																				goto
																																																					BgL_kapzd24064zd2_2926;
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				if ((BgL_carzd24062zd2_2924 == CNST_TABLE_REF(((long) 18))))
																																																					{	/* Ast/sexp.scm 119 */
																																																						goto
																																																							BgL_kapzd24064zd2_2926;
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						if ((BgL_carzd24062zd2_2924 == CNST_TABLE_REF(((long) 19))))
																																																							{	/* Ast/sexp.scm 119 */
																																																								goto
																																																									BgL_kapzd24064zd2_2926;
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd24062zd2_2924)))
																																																									{	/* Ast/sexp.scm 119 */
																																																										goto
																																																											BgL_kapzd24064zd2_2926;
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd25669zd2_2932;
																																																										BgL_cdrzd25669zd2_2932
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{	/* Ast/sexp.scm 119 */
																																																											bool_t
																																																												BgL_test8388z00_16136;
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_arg2608z00_3049;
																																																												BgL_arg2608z00_3049
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												BgL_test8388z00_16136
																																																													=
																																																													CBOOL
																																																													(BGl_letzd2symzf3z21zzast_letz00
																																																													(BgL_arg2608z00_3049));
																																																											}
																																																											if (BgL_test8388z00_16136)
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_arg2515z00_2935;
																																																													obj_t
																																																														BgL_arg2516z00_2936;
																																																													BgL_arg2515z00_2935
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_cdrzd25669zd2_2932));
																																																													BgL_arg2516z00_2936
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd25669zd2_2932));
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_16145;
																																																														{
																																																															obj_t
																																																																BgL_exprz00_16147;
																																																															obj_t
																																																																BgL_bindingsz00_16146;
																																																															BgL_bindingsz00_16146
																																																																=
																																																																BgL_arg2515z00_2935;
																																																															BgL_exprz00_16147
																																																																=
																																																																BgL_arg2516z00_2936;
																																																															BgL_exprz00_1732
																																																																=
																																																																BgL_exprz00_16147;
																																																															BgL_bindingsz00_1731
																																																																=
																																																																BgL_bindingsz00_16146;
																																																															goto
																																																																BgL_tagzd2382zd2_1733;
																																																														}
																																																														BgL_auxz00_14266
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_16145);
																																																													}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													bool_t
																																																														BgL_test8389z00_16149;
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_arg2607z00_3048;
																																																														BgL_arg2607z00_3048
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														BgL_test8389z00_16149
																																																															=
																																																															CBOOL
																																																															(BGl_labelszd2symzf3z21zzast_labelsz00
																																																															(BgL_arg2607z00_3048));
																																																													}
																																																													if (BgL_test8389z00_16149)
																																																														{
																																																															BgL_letzd2funzd2_bglt
																																																																BgL_auxz00_16154;
																																																															goto
																																																																BgL_tagzd2384zd2_1735;
																																																															BgL_auxz00_14266
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_16154);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_carzd25735zd2_2939;
																																																															BgL_carzd25735zd2_2939
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd25740zd2_2940;
																																																																BgL_cdrzd25740zd2_2940
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_carzd25735zd2_2939));
																																																																if ((CAR(((obj_t) BgL_carzd25735zd2_2939)) == CNST_TABLE_REF(((long) 3))))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (PAIRP(BgL_cdrzd25740zd2_2940))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_arg2524z00_2944;
																																																																				obj_t
																																																																					BgL_arg2528z00_2945;
																																																																				obj_t
																																																																					BgL_arg2533z00_2946;
																																																																				BgL_arg2524z00_2944
																																																																					=
																																																																					CAR
																																																																					(BgL_cdrzd25740zd2_2940);
																																																																				BgL_arg2528z00_2945
																																																																					=
																																																																					CDR
																																																																					(BgL_cdrzd25740zd2_2940);
																																																																				BgL_arg2533z00_2946
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_16171;
																																																																					{
																																																																						obj_t
																																																																							BgL_argsz00_16174;
																																																																						obj_t
																																																																							BgL_bodyz00_16173;
																																																																						obj_t
																																																																							BgL_varsz00_16172;
																																																																						BgL_varsz00_16172
																																																																							=
																																																																							BgL_arg2524z00_2944;
																																																																						BgL_bodyz00_16173
																																																																							=
																																																																							BgL_arg2528z00_2945;
																																																																						BgL_argsz00_16174
																																																																							=
																																																																							BgL_arg2533z00_2946;
																																																																						BgL_argsz00_1742
																																																																							=
																																																																							BgL_argsz00_16174;
																																																																						BgL_bodyz00_1741
																																																																							=
																																																																							BgL_bodyz00_16173;
																																																																						BgL_varsz00_1740
																																																																							=
																																																																							BgL_varsz00_16172;
																																																																						goto
																																																																							BgL_tagzd2386zd2_1743;
																																																																					}
																																																																					BgL_auxz00_14266
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_16171);
																																																																				}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1777;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_16178;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1778;
																																																																						BgL_auxz00_14266
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_16178);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd25847zd2_2949;
																																																																		BgL_cdrzd25847zd2_2949
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd25852zd2_2950;
																																																																			BgL_cdrzd25852zd2_2950
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_carzd25735zd2_2939));
																																																																			if ((CAR(((obj_t) BgL_carzd25735zd2_2939)) == CNST_TABLE_REF(((long) 1))))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (PAIRP(BgL_cdrzd25852zd2_2950))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd25857zd2_2954;
																																																																							BgL_cdrzd25857zd2_2954
																																																																								=
																																																																								CDR
																																																																								(BgL_cdrzd25852zd2_2950);
																																																																							if (PAIRP(BgL_cdrzd25857zd2_2954))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd25861zd2_2956;
																																																																									obj_t
																																																																										BgL_cdrzd25862zd2_2957;
																																																																									BgL_carzd25861zd2_2956
																																																																										=
																																																																										CAR
																																																																										(BgL_cdrzd25857zd2_2954);
																																																																									BgL_cdrzd25862zd2_2957
																																																																										=
																																																																										CDR
																																																																										(BgL_cdrzd25857zd2_2954);
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd25861zd2_2956))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (PAIRP(BgL_cdrzd25862zd2_2957))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_carzd25867zd2_2960;
																																																																													BgL_carzd25867zd2_2960
																																																																														=
																																																																														CAR
																																																																														(BgL_cdrzd25862zd2_2957);
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd25867zd2_2960))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (NULLP(CDR(BgL_cdrzd25862zd2_2957)))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	bool_t
																																																																																		BgL_test8400z00_16206;
																																																																																	{
																																																																																		obj_t
																																																																																			BgL_l1375z00_2993;
																																																																																		BgL_l1375z00_2993
																																																																																			=
																																																																																			BgL_cdrzd25847zd2_2949;
																																																																																	BgL_zc3z04anonymousza32567ze3z87_2994:
																																																																																		if (NULLP(BgL_l1375z00_2993))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				BgL_test8400z00_16206
																																																																																					=
																																																																																					(
																																																																																					(bool_t)
																																																																																					1);
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				bool_t
																																																																																					BgL_test8402z00_16209;
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					bool_t
																																																																																						BgL_test8403z00_16210;
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						obj_t
																																																																																							BgL_tmpz00_16211;
																																																																																						BgL_tmpz00_16211
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_l1375z00_2993));
																																																																																						BgL_test8403z00_16210
																																																																																							=
																																																																																							PAIRP
																																																																																							(BgL_tmpz00_16211);
																																																																																					}
																																																																																					if (BgL_test8403z00_16210)
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							BgL_test8402z00_16209
																																																																																								=
																																																																																								(
																																																																																								(bool_t)
																																																																																								0);
																																																																																						}
																																																																																					else
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							BgL_test8402z00_16209
																																																																																								=
																																																																																								(
																																																																																								(bool_t)
																																																																																								1);
																																																																																						}
																																																																																				}
																																																																																				if (BgL_test8402z00_16209)
																																																																																					{
																																																																																						obj_t
																																																																																							BgL_l1375z00_16215;
																																																																																						BgL_l1375z00_16215
																																																																																							=
																																																																																							CDR
																																																																																							(
																																																																																							((obj_t) BgL_l1375z00_2993));
																																																																																						BgL_l1375z00_2993
																																																																																							=
																																																																																							BgL_l1375z00_16215;
																																																																																						goto
																																																																																							BgL_zc3z04anonymousza32567ze3z87_2994;
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						BgL_test8400z00_16206
																																																																																							=
																																																																																							(
																																																																																							(bool_t)
																																																																																							0);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																	if (BgL_test8400z00_16206)
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_arg2555z00_2976;
																																																																																			BgL_arg2555z00_2976
																																																																																				=
																																																																																				CAR
																																																																																				(BgL_cdrzd25852zd2_2950);
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_16219;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_16223;
																																																																																					obj_t
																																																																																						BgL_proc2z00_16222;
																																																																																					obj_t
																																																																																						BgL_proc1z00_16221;
																																																																																					obj_t
																																																																																						BgL_testz00_16220;
																																																																																					BgL_testz00_16220
																																																																																						=
																																																																																						BgL_arg2555z00_2976;
																																																																																					BgL_proc1z00_16221
																																																																																						=
																																																																																						BgL_carzd25861zd2_2956;
																																																																																					BgL_proc2z00_16222
																																																																																						=
																																																																																						BgL_carzd25867zd2_2960;
																																																																																					BgL_argsz00_16223
																																																																																						=
																																																																																						BgL_cdrzd25847zd2_2949;
																																																																																					BgL_argsz00_1747
																																																																																						=
																																																																																						BgL_argsz00_16223;
																																																																																					BgL_proc2z00_1746
																																																																																						=
																																																																																						BgL_proc2z00_16222;
																																																																																					BgL_proc1z00_1745
																																																																																						=
																																																																																						BgL_proc1z00_16221;
																																																																																					BgL_testz00_1744
																																																																																						=
																																																																																						BgL_testz00_16220;
																																																																																					goto
																																																																																						BgL_tagzd2387zd2_1748;
																																																																																				}
																																																																																				BgL_auxz00_14266
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_16219);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_cdrzd25892zd2_2977;
																																																																																			BgL_cdrzd25892zd2_2977
																																																																																				=
																																																																																				CDR
																																																																																				(
																																																																																				((obj_t) BgL_expz00_21));
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_cdrzd25900zd2_2978;
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					obj_t
																																																																																						BgL_pairz00_10415;
																																																																																					BgL_pairz00_10415
																																																																																						=
																																																																																						CAR
																																																																																						(
																																																																																						((obj_t) BgL_expz00_21));
																																																																																					BgL_cdrzd25900zd2_2978
																																																																																						=
																																																																																						CDR
																																																																																						(BgL_pairz00_10415);
																																																																																				}
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					obj_t
																																																																																						BgL_cdrzd25908zd2_2979;
																																																																																					BgL_cdrzd25908zd2_2979
																																																																																						=
																																																																																						CDR
																																																																																						(
																																																																																						((obj_t) BgL_cdrzd25900zd2_2978));
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						obj_t
																																																																																							BgL_carzd25915zd2_2980;
																																																																																						BgL_carzd25915zd2_2980
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd25908zd2_2979));
																																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd25915zd2_2980))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								obj_t
																																																																																									BgL_carzd25924zd2_2982;
																																																																																								{	/* Ast/sexp.scm 119 */
																																																																																									obj_t
																																																																																										BgL_pairz00_10419;
																																																																																									BgL_pairz00_10419
																																																																																										=
																																																																																										CDR
																																																																																										(
																																																																																										((obj_t) BgL_cdrzd25908zd2_2979));
																																																																																									BgL_carzd25924zd2_2982
																																																																																										=
																																																																																										CAR
																																																																																										(BgL_pairz00_10419);
																																																																																								}
																																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd25924zd2_2982))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd25892zd2_2977))
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												obj_t
																																																																																													BgL_arg2559z00_2985;
																																																																																												BgL_arg2559z00_2985
																																																																																													=
																																																																																													CAR
																																																																																													(
																																																																																													((obj_t) BgL_cdrzd25900zd2_2978));
																																																																																												{
																																																																																													BgL_nodez00_bglt
																																																																																														BgL_auxz00_16245;
																																																																																													{
																																																																																														obj_t
																																																																																															BgL_argsz00_16249;
																																																																																														obj_t
																																																																																															BgL_proc2z00_16248;
																																																																																														obj_t
																																																																																															BgL_proc1z00_16247;
																																																																																														obj_t
																																																																																															BgL_testz00_16246;
																																																																																														BgL_testz00_16246
																																																																																															=
																																																																																															BgL_arg2559z00_2985;
																																																																																														BgL_proc1z00_16247
																																																																																															=
																																																																																															BgL_carzd25915zd2_2980;
																																																																																														BgL_proc2z00_16248
																																																																																															=
																																																																																															BgL_carzd25924zd2_2982;
																																																																																														BgL_argsz00_16249
																																																																																															=
																																																																																															BgL_cdrzd25892zd2_2977;
																																																																																														BgL_argsz00_1752
																																																																																															=
																																																																																															BgL_argsz00_16249;
																																																																																														BgL_proc2z00_1751
																																																																																															=
																																																																																															BgL_proc2z00_16248;
																																																																																														BgL_proc1z00_1750
																																																																																															=
																																																																																															BgL_proc1z00_16247;
																																																																																														BgL_testz00_1749
																																																																																															=
																																																																																															BgL_testz00_16246;
																																																																																														goto
																																																																																															BgL_tagzd2388zd2_1753;
																																																																																													}
																																																																																													BgL_auxz00_14266
																																																																																														=
																																																																																														(
																																																																																														(obj_t)
																																																																																														BgL_auxz00_16245);
																																																																																												}
																																																																																											}
																																																																																										else
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																													{	/* Ast/sexp.scm 119 */
																																																																																														goto
																																																																																															BgL_tagzd2403zd2_1777;
																																																																																													}
																																																																																												else
																																																																																													{
																																																																																														BgL_nodez00_bglt
																																																																																															BgL_auxz00_16253;
																																																																																														goto
																																																																																															BgL_tagzd2404zd2_1778;
																																																																																														BgL_auxz00_14266
																																																																																															=
																																																																																															(
																																																																																															(obj_t)
																																																																																															BgL_auxz00_16253);
																																																																																													}
																																																																																											}
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												goto
																																																																																													BgL_tagzd2403zd2_1777;
																																																																																											}
																																																																																										else
																																																																																											{
																																																																																												BgL_nodez00_bglt
																																																																																													BgL_auxz00_16257;
																																																																																												goto
																																																																																													BgL_tagzd2404zd2_1778;
																																																																																												BgL_auxz00_14266
																																																																																													=
																																																																																													(
																																																																																													(obj_t)
																																																																																													BgL_auxz00_16257);
																																																																																											}
																																																																																									}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1777;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_16261;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1778;
																																																																																										BgL_auxz00_14266
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_16261);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				}
																																																																																			}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1777;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_16265;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1778;
																																																																																			BgL_auxz00_14266
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_16265);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_cdrzd26202zd2_3004;
																																																																															BgL_cdrzd26202zd2_3004
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_cdrzd26209zd2_3005;
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_pairz00_10423;
																																																																																	BgL_pairz00_10423
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_expz00_21));
																																																																																	BgL_cdrzd26209zd2_3005
																																																																																		=
																																																																																		CDR
																																																																																		(BgL_pairz00_10423);
																																																																																}
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_cdrzd26216zd2_3006;
																																																																																	BgL_cdrzd26216zd2_3006
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd26209zd2_3005));
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_carzd26222zd2_3007;
																																																																																		obj_t
																																																																																			BgL_cdrzd26223zd2_3008;
																																																																																		BgL_carzd26222zd2_3007
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd26216zd2_3006));
																																																																																		BgL_cdrzd26223zd2_3008
																																																																																			=
																																																																																			CDR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd26216zd2_3006));
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd26222zd2_3007))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_carzd26230zd2_3010;
																																																																																				BgL_carzd26230zd2_3010
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd26223zd2_3008));
																																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd26230zd2_3010))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (NULLP(CDR(((obj_t) BgL_cdrzd26223zd2_3008))))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd26202zd2_3004))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										obj_t
																																																																																											BgL_arg2580z00_3015;
																																																																																										BgL_arg2580z00_3015
																																																																																											=
																																																																																											CAR
																																																																																											(
																																																																																											((obj_t) BgL_cdrzd26209zd2_3005));
																																																																																										{
																																																																																											BgL_nodez00_bglt
																																																																																												BgL_auxz00_16292;
																																																																																											{
																																																																																												obj_t
																																																																																													BgL_argsz00_16296;
																																																																																												obj_t
																																																																																													BgL_proc2z00_16295;
																																																																																												obj_t
																																																																																													BgL_proc1z00_16294;
																																																																																												obj_t
																																																																																													BgL_testz00_16293;
																																																																																												BgL_testz00_16293
																																																																																													=
																																																																																													BgL_arg2580z00_3015;
																																																																																												BgL_proc1z00_16294
																																																																																													=
																																																																																													BgL_carzd26222zd2_3007;
																																																																																												BgL_proc2z00_16295
																																																																																													=
																																																																																													BgL_carzd26230zd2_3010;
																																																																																												BgL_argsz00_16296
																																																																																													=
																																																																																													BgL_cdrzd26202zd2_3004;
																																																																																												BgL_argsz00_1752
																																																																																													=
																																																																																													BgL_argsz00_16296;
																																																																																												BgL_proc2z00_1751
																																																																																													=
																																																																																													BgL_proc2z00_16295;
																																																																																												BgL_proc1z00_1750
																																																																																													=
																																																																																													BgL_proc1z00_16294;
																																																																																												BgL_testz00_1749
																																																																																													=
																																																																																													BgL_testz00_16293;
																																																																																												goto
																																																																																													BgL_tagzd2388zd2_1753;
																																																																																											}
																																																																																											BgL_auxz00_14266
																																																																																												=
																																																																																												(
																																																																																												(obj_t)
																																																																																												BgL_auxz00_16292);
																																																																																										}
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												goto
																																																																																													BgL_tagzd2403zd2_1777;
																																																																																											}
																																																																																										else
																																																																																											{
																																																																																												BgL_nodez00_bglt
																																																																																													BgL_auxz00_16300;
																																																																																												goto
																																																																																													BgL_tagzd2404zd2_1778;
																																																																																												BgL_auxz00_14266
																																																																																													=
																																																																																													(
																																																																																													(obj_t)
																																																																																													BgL_auxz00_16300);
																																																																																											}
																																																																																									}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1777;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_16304;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1778;
																																																																																										BgL_auxz00_14266
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_16304);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1777;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_16308;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1778;
																																																																																								BgL_auxz00_14266
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_16308);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1777;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_16312;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1778;
																																																																																						BgL_auxz00_14266
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_16312);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																}
																																																																															}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1777;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_16316;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1778;
																																																																															BgL_auxz00_14266
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_16316);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd26563zd2_3023;
																																																																											BgL_cdrzd26563zd2_3023
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_cdrzd26569zd2_3024;
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_pairz00_10433;
																																																																													BgL_pairz00_10433
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													BgL_cdrzd26569zd2_3024
																																																																														=
																																																																														CDR
																																																																														(BgL_pairz00_10433);
																																																																												}
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd26575zd2_3025;
																																																																													BgL_cdrzd26575zd2_3025
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd26569zd2_3024));
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_carzd26580zd2_3026;
																																																																														obj_t
																																																																															BgL_cdrzd26581zd2_3027;
																																																																														BgL_carzd26580zd2_3026
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd26575zd2_3025));
																																																																														BgL_cdrzd26581zd2_3027
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd26575zd2_3025));
																																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd26580zd2_3026))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (PAIRP(BgL_cdrzd26581zd2_3027))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_carzd26586zd2_3030;
																																																																																		BgL_carzd26586zd2_3030
																																																																																			=
																																																																																			CAR
																																																																																			(BgL_cdrzd26581zd2_3027);
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd26586zd2_3030))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (NULLP(CDR(BgL_cdrzd26581zd2_3027)))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd26563zd2_3023))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								obj_t
																																																																																									BgL_arg2594z00_3035;
																																																																																								BgL_arg2594z00_3035
																																																																																									=
																																																																																									CAR
																																																																																									(
																																																																																									((obj_t) BgL_cdrzd26569zd2_3024));
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_16343;
																																																																																									{
																																																																																										obj_t
																																																																																											BgL_argsz00_16347;
																																																																																										obj_t
																																																																																											BgL_proc2z00_16346;
																																																																																										obj_t
																																																																																											BgL_proc1z00_16345;
																																																																																										obj_t
																																																																																											BgL_testz00_16344;
																																																																																										BgL_testz00_16344
																																																																																											=
																																																																																											BgL_arg2594z00_3035;
																																																																																										BgL_proc1z00_16345
																																																																																											=
																																																																																											BgL_carzd26580zd2_3026;
																																																																																										BgL_proc2z00_16346
																																																																																											=
																																																																																											BgL_carzd26586zd2_3030;
																																																																																										BgL_argsz00_16347
																																																																																											=
																																																																																											BgL_cdrzd26563zd2_3023;
																																																																																										BgL_argsz00_1752
																																																																																											=
																																																																																											BgL_argsz00_16347;
																																																																																										BgL_proc2z00_1751
																																																																																											=
																																																																																											BgL_proc2z00_16346;
																																																																																										BgL_proc1z00_1750
																																																																																											=
																																																																																											BgL_proc1z00_16345;
																																																																																										BgL_testz00_1749
																																																																																											=
																																																																																											BgL_testz00_16344;
																																																																																										goto
																																																																																											BgL_tagzd2388zd2_1753;
																																																																																									}
																																																																																									BgL_auxz00_14266
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_16343);
																																																																																								}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1777;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_16351;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1778;
																																																																																										BgL_auxz00_14266
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_16351);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1777;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_16355;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1778;
																																																																																								BgL_auxz00_14266
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_16355);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1777;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_16359;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1778;
																																																																																						BgL_auxz00_14266
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_16359);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1777;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_16363;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1778;
																																																																																				BgL_auxz00_14266
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_16363);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1777;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_16367;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1778;
																																																																																		BgL_auxz00_14266
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_16367);
																																																																																	}
																																																																															}
																																																																													}
																																																																												}
																																																																											}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1777;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_16371;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1778;
																																																																											BgL_auxz00_14266
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_16371);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1777;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_16375;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1778;
																																																																									BgL_auxz00_14266
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_16375);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1777;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_16379;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1778;
																																																																							BgL_auxz00_14266
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_16379);
																																																																						}
																																																																				}
																																																																		}
																																																																	}
																																																															}
																																																														}
																																																												}
																																																										}
																																																									}
																																																							}
																																																					}
																																																			}
																																																	}
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_cdrzd27124zd2_3199;
																																															BgL_cdrzd27124zd2_3199
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															if ((BgL_carzd24059zd2_2922 == CNST_TABLE_REF(((long) 17))))
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg2717z00_3201;
																																																	obj_t
																																																		BgL_arg2718z00_3202;
																																																	BgL_arg2717z00_3201
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd27124zd2_3199));
																																																	BgL_arg2718z00_3202
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd27124zd2_3199));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_16390;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_16392;
																																																			obj_t
																																																				BgL_bindingsz00_16391;
																																																			BgL_bindingsz00_16391
																																																				=
																																																				BgL_arg2717z00_3201;
																																																			BgL_exprz00_16392
																																																				=
																																																				BgL_arg2718z00_3202;
																																																			BgL_exprz00_1732
																																																				=
																																																				BgL_exprz00_16392;
																																																			BgL_bindingsz00_1731
																																																				=
																																																				BgL_bindingsz00_16391;
																																																			goto
																																																				BgL_tagzd2382zd2_1733;
																																																		}
																																																		BgL_auxz00_14266
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_16390);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd24059zd2_2922)))
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg2720z00_3204;
																																																			obj_t
																																																				BgL_arg2722z00_3205;
																																																			BgL_arg2720z00_3204
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd27124zd2_3199));
																																																			BgL_arg2722z00_3205
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd27124zd2_3199));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_16401;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_16403;
																																																					obj_t
																																																						BgL_bindingsz00_16402;
																																																					BgL_bindingsz00_16402
																																																						=
																																																						BgL_arg2720z00_3204;
																																																					BgL_exprz00_16403
																																																						=
																																																						BgL_arg2722z00_3205;
																																																					BgL_exprz00_1732
																																																						=
																																																						BgL_exprz00_16403;
																																																					BgL_bindingsz00_1731
																																																						=
																																																						BgL_bindingsz00_16402;
																																																					goto
																																																						BgL_tagzd2382zd2_1733;
																																																				}
																																																				BgL_auxz00_14266
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_16401);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if ((BgL_carzd24059zd2_2922 == CNST_TABLE_REF(((long) 18))))
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_arg2724z00_3207;
																																																					obj_t
																																																						BgL_arg2726z00_3208;
																																																					BgL_arg2724z00_3207
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd27124zd2_3199));
																																																					BgL_arg2726z00_3208
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd27124zd2_3199));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_16412;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_16414;
																																																							obj_t
																																																								BgL_bindingsz00_16413;
																																																							BgL_bindingsz00_16413
																																																								=
																																																								BgL_arg2724z00_3207;
																																																							BgL_exprz00_16414
																																																								=
																																																								BgL_arg2726z00_3208;
																																																							BgL_exprz00_1732
																																																								=
																																																								BgL_exprz00_16414;
																																																							BgL_bindingsz00_1731
																																																								=
																																																								BgL_bindingsz00_16413;
																																																							goto
																																																								BgL_tagzd2382zd2_1733;
																																																						}
																																																						BgL_auxz00_14266
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_16412);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_16421;
																																																							goto
																																																								BgL_tagzd2383zd2_1734;
																																																							BgL_auxz00_14266
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_16421);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_carzd27161zd2_3211;
																																																							BgL_carzd27161zd2_3211
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							if ((BgL_carzd27161zd2_3211 == CNST_TABLE_REF(((long) 19))))
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_16428;
																																																									goto
																																																										BgL_tagzd2384zd2_1735;
																																																									BgL_auxz00_14266
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_16428);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd27161zd2_3211)))
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_16433;
																																																											goto
																																																												BgL_tagzd2384zd2_1735;
																																																											BgL_auxz00_14266
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_16433);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_16440;
																																																													goto
																																																														BgL_tagzd2389zd2_1754;
																																																													BgL_auxz00_14266
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_16440);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_16447;
																																																															goto
																																																																BgL_tagzd2390zd2_1755;
																																																															BgL_auxz00_14266
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_16447);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd27241zd2_3218;
																																																															BgL_cdrzd27241zd2_3218
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_arg2741z00_3221;
																																																																	obj_t
																																																																		BgL_arg2742z00_3222;
																																																																	BgL_arg2741z00_3221
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd27241zd2_3218));
																																																																	BgL_arg2742z00_3222
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd27241zd2_3218));
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_16460;
																																																																		{
																																																																			obj_t
																																																																				BgL_restz00_16462;
																																																																			obj_t
																																																																				BgL_effectz00_16461;
																																																																			BgL_effectz00_16461
																																																																				=
																																																																				BgL_arg2741z00_3221;
																																																																			BgL_restz00_16462
																																																																				=
																																																																				BgL_arg2742z00_3222;
																																																																			BgL_restz00_1757
																																																																				=
																																																																				BgL_restz00_16462;
																																																																			BgL_effectz00_1756
																																																																				=
																																																																				BgL_effectz00_16461;
																																																																			goto
																																																																				BgL_tagzd2391zd2_1758;
																																																																		}
																																																																		BgL_auxz00_14266
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_16460);
																																																																	}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_16469;
																																																																			goto
																																																																				BgL_tagzd2392zd2_1759;
																																																																			BgL_auxz00_14266
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_16469);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_16476;
																																																																					goto
																																																																						BgL_tagzd2393zd2_1760;
																																																																					BgL_auxz00_14266
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_16476);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_arg2751z00_3230;
																																																																							obj_t
																																																																								BgL_arg2752z00_3231;
																																																																							BgL_arg2751z00_3230
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd27241zd2_3218));
																																																																							BgL_arg2752z00_3231
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd27241zd2_3218));
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_16487;
																																																																								{
																																																																									obj_t
																																																																										BgL_restz00_16489;
																																																																									obj_t
																																																																										BgL_effectz00_16488;
																																																																									BgL_effectz00_16488
																																																																										=
																																																																										BgL_arg2751z00_3230;
																																																																									BgL_restz00_16489
																																																																										=
																																																																										BgL_arg2752z00_3231;
																																																																									BgL_restz00_1762
																																																																										=
																																																																										BgL_restz00_16489;
																																																																									BgL_effectz00_1761
																																																																										=
																																																																										BgL_effectz00_16488;
																																																																									goto
																																																																										BgL_tagzd2394zd2_1763;
																																																																								}
																																																																								BgL_auxz00_14266
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_16487);
																																																																							}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_16496;
																																																																									goto
																																																																										BgL_tagzd2395zd2_1764;
																																																																									BgL_auxz00_14266
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_16496);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_16503;
																																																																											goto
																																																																												BgL_tagzd2396zd2_1765;
																																																																											BgL_auxz00_14266
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_16503);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																												{
																																																																													BgL_letzd2funzd2_bglt
																																																																														BgL_auxz00_16510;
																																																																													goto
																																																																														BgL_tagzd2397zd2_1766;
																																																																													BgL_auxz00_14266
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_16510);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																														{
																																																																															BgL_jumpzd2exzd2itz00_bglt
																																																																																BgL_auxz00_16517;
																																																																															goto
																																																																																BgL_tagzd2398zd2_1767;
																																																																															BgL_auxz00_14266
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_16517);
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_cdrzd27318zd2_3240;
																																																																															BgL_cdrzd27318zd2_3240
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_arg2767z00_3243;
																																																																																	obj_t
																																																																																		BgL_arg2768z00_3244;
																																																																																	BgL_arg2767z00_3243
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd27318zd2_3240));
																																																																																	BgL_arg2768z00_3244
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd27318zd2_3240));
																																																																																	{	/* Ast/sexp.scm 552 */
																																																																																		obj_t
																																																																																			BgL_arg6965z00_10472;
																																																																																		BgL_arg6965z00_10472
																																																																																			=
																																																																																			BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																			(BgL_expz00_21,
																																																																																			BgL_locz00_23);
																																																																																		BgL_auxz00_14266
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																			(BgL_expz00_21,
																																																																																				BgL_arg2767z00_3243,
																																																																																				CNST_TABLE_REF
																																																																																				(((long) 4)), BgL_arg2768z00_3244, BgL_stackz00_22, BgL_arg6965z00_10472, BgL_sitez00_24));
																																																																																}}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1777;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_16536;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1778;
																																																																																			BgL_auxz00_14266
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_16536);
																																																																																		}
																																																																																}
																																																																														}
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																	else
																																		{	/* Ast/sexp.scm 119 */
																																			obj_t
																																				BgL_carzd27343zd2_3261;
																																			BgL_carzd27343zd2_3261
																																				=
																																				CAR((
																																					(obj_t)
																																					BgL_expz00_21));
																																			if (
																																				(BgL_carzd27343zd2_3261
																																					==
																																					CNST_TABLE_REF
																																					(((long) 1))))
																																				{
																																					BgL_nodez00_bglt
																																						BgL_auxz00_16543;
																																					goto
																																						BgL_tagzd2377zd2_1722;
																																					BgL_auxz00_14266
																																						=
																																						(
																																						(obj_t)
																																						BgL_auxz00_16543);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					if (
																																						(BgL_carzd27343zd2_3261
																																							==
																																							BGl_za2ifza2z00zzast_sexpz00))
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_16547;
																																							goto
																																								BgL_tagzd2377zd2_1722;
																																							BgL_auxz00_14266
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_16547);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 7))))
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_16554;
																																									goto
																																										BgL_tagzd2379zd2_1726;
																																									BgL_auxz00_14266
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_16554);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_16561;
																																											goto
																																												BgL_tagzd2380zd2_1727;
																																											BgL_auxz00_14266
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_16561);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_carzd27412zd2_3268;
																																											BgL_carzd27412zd2_3268
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_expz00_21));
																																											if (PAIRP(BgL_carzd27412zd2_3268))
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_carzd27415zd2_3270;
																																													obj_t
																																														BgL_cdrzd27416zd2_3271;
																																													BgL_carzd27415zd2_3270
																																														=
																																														CAR
																																														(BgL_carzd27412zd2_3268);
																																													BgL_cdrzd27416zd2_3271
																																														=
																																														CDR
																																														(BgL_carzd27412zd2_3268);
																																													{

																																														if ((BgL_carzd27415zd2_3270 == CNST_TABLE_REF(((long) 17))))
																																															{	/* Ast/sexp.scm 119 */
																																															BgL_kapzd27417zd2_3272:
																																																if (PAIRP(BgL_cdrzd27416zd2_3271))
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_cdrzd27420zd2_3397;
																																																		BgL_cdrzd27420zd2_3397
																																																			=
																																																			CDR
																																																			(BgL_cdrzd27416zd2_3271);
																																																		if (PAIRP(BgL_cdrzd27420zd2_3397))
																																																			{	/* Ast/sexp.scm 119 */
																																																				if (NULLP(CDR(BgL_cdrzd27420zd2_3397)))
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg2909z00_3401;
																																																						obj_t
																																																							BgL_arg2910z00_3402;
																																																						BgL_arg2909z00_3401
																																																							=
																																																							CAR
																																																							(BgL_cdrzd27420zd2_3397);
																																																						BgL_arg2910z00_3402
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_16583;
																																																							{
																																																								obj_t
																																																									BgL_argsz00_16585;
																																																								obj_t
																																																									BgL_bodyz00_16584;
																																																								BgL_bodyz00_16584
																																																									=
																																																									BgL_arg2909z00_3401;
																																																								BgL_argsz00_16585
																																																									=
																																																									BgL_arg2910z00_3402;
																																																								BgL_argsz00_1729
																																																									=
																																																									BgL_argsz00_16585;
																																																								BgL_bodyz00_1728
																																																									=
																																																									BgL_bodyz00_16584;
																																																								goto
																																																									BgL_tagzd2381zd2_1730;
																																																							}
																																																							BgL_auxz00_14266
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_16583);
																																																						}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd27444zd2_3403;
																																																						BgL_cdrzd27444zd2_3403
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{	/* Ast/sexp.scm 119 */
																																																							bool_t
																																																								BgL_test8460z00_16589;
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg3017z00_3514;
																																																								BgL_arg3017z00_3514
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test8460z00_16589
																																																									=
																																																									CBOOL
																																																									(BGl_letzd2symzf3z21zzast_letz00
																																																									(BgL_arg3017z00_3514));
																																																							}
																																																							if (BgL_test8460z00_16589)
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_arg2913z00_3406;
																																																									obj_t
																																																										BgL_arg2914z00_3407;
																																																									BgL_arg2913z00_3406
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd27444zd2_3403));
																																																									BgL_arg2914z00_3407
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd27444zd2_3403));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_16598;
																																																										{
																																																											obj_t
																																																												BgL_exprz00_16600;
																																																											obj_t
																																																												BgL_bindingsz00_16599;
																																																											BgL_bindingsz00_16599
																																																												=
																																																												BgL_arg2913z00_3406;
																																																											BgL_exprz00_16600
																																																												=
																																																												BgL_arg2914z00_3407;
																																																											BgL_exprz00_1732
																																																												=
																																																												BgL_exprz00_16600;
																																																											BgL_bindingsz00_1731
																																																												=
																																																												BgL_bindingsz00_16599;
																																																											goto
																																																												BgL_tagzd2382zd2_1733;
																																																										}
																																																										BgL_auxz00_14266
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_16598);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									bool_t
																																																										BgL_test8461z00_16602;
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg3016z00_3513;
																																																										BgL_arg3016z00_3513
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_test8461z00_16602
																																																											=
																																																											CBOOL
																																																											(BGl_labelszd2symzf3z21zzast_labelsz00
																																																											(BgL_arg3016z00_3513));
																																																									}
																																																									if (BgL_test8461z00_16602)
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_16607;
																																																											goto
																																																												BgL_tagzd2384zd2_1735;
																																																											BgL_auxz00_14266
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_16607);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_carzd27511zd2_3410;
																																																											BgL_carzd27511zd2_3410
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd27516zd2_3411;
																																																												BgL_cdrzd27516zd2_3411
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_carzd27511zd2_3410));
																																																												if ((CAR(((obj_t) BgL_carzd27511zd2_3410)) == CNST_TABLE_REF(((long) 3))))
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_arg2936z00_3414;
																																																														obj_t
																																																															BgL_arg2937z00_3415;
																																																														obj_t
																																																															BgL_arg2938z00_3416;
																																																														BgL_arg2936z00_3414
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd27516zd2_3411));
																																																														BgL_arg2937z00_3415
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd27516zd2_3411));
																																																														BgL_arg2938z00_3416
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_16624;
																																																															{
																																																																obj_t
																																																																	BgL_argsz00_16627;
																																																																obj_t
																																																																	BgL_bodyz00_16626;
																																																																obj_t
																																																																	BgL_varsz00_16625;
																																																																BgL_varsz00_16625
																																																																	=
																																																																	BgL_arg2936z00_3414;
																																																																BgL_bodyz00_16626
																																																																	=
																																																																	BgL_arg2937z00_3415;
																																																																BgL_argsz00_16627
																																																																	=
																																																																	BgL_arg2938z00_3416;
																																																																BgL_argsz00_1742
																																																																	=
																																																																	BgL_argsz00_16627;
																																																																BgL_bodyz00_1741
																																																																	=
																																																																	BgL_bodyz00_16626;
																																																																BgL_varsz00_1740
																																																																	=
																																																																	BgL_varsz00_16625;
																																																																goto
																																																																	BgL_tagzd2386zd2_1743;
																																																															}
																																																															BgL_auxz00_14266
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_16624);
																																																														}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd27539zd2_3418;
																																																														BgL_cdrzd27539zd2_3418
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd27545zd2_3419;
																																																															BgL_cdrzd27545zd2_3419
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_carzd27511zd2_3410));
																																																															if ((CAR(((obj_t) BgL_carzd27511zd2_3410)) == CNST_TABLE_REF(((long) 1))))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd27551zd2_3422;
																																																																	BgL_cdrzd27551zd2_3422
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd27545zd2_3419));
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_carzd27556zd2_3423;
																																																																		obj_t
																																																																			BgL_cdrzd27557zd2_3424;
																																																																		BgL_carzd27556zd2_3423
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd27551zd2_3422));
																																																																		BgL_cdrzd27557zd2_3424
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd27551zd2_3422));
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd27556zd2_3423))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (PAIRP(BgL_cdrzd27557zd2_3424))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_carzd27564zd2_3427;
																																																																						BgL_carzd27564zd2_3427
																																																																							=
																																																																							CAR
																																																																							(BgL_cdrzd27557zd2_3424);
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd27564zd2_3427))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (NULLP(CDR(BgL_cdrzd27557zd2_3424)))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										bool_t
																																																																											BgL_test8468z00_16654;
																																																																										{
																																																																											obj_t
																																																																												BgL_l1378z00_3460;
																																																																											BgL_l1378z00_3460
																																																																												=
																																																																												BgL_cdrzd27539zd2_3418;
																																																																										BgL_zc3z04anonymousza32965ze3z87_3461:
																																																																											if (NULLP(BgL_l1378z00_3460))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													BgL_test8468z00_16654
																																																																														=
																																																																														(
																																																																														(bool_t)
																																																																														1);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													bool_t
																																																																														BgL_test8470z00_16657;
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														bool_t
																																																																															BgL_test8471z00_16658;
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_tmpz00_16659;
																																																																															BgL_tmpz00_16659
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_l1378z00_3460));
																																																																															BgL_test8471z00_16658
																																																																																=
																																																																																PAIRP
																																																																																(BgL_tmpz00_16659);
																																																																														}
																																																																														if (BgL_test8471z00_16658)
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																BgL_test8470z00_16657
																																																																																	=
																																																																																	(
																																																																																	(bool_t)
																																																																																	0);
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																BgL_test8470z00_16657
																																																																																	=
																																																																																	(
																																																																																	(bool_t)
																																																																																	1);
																																																																															}
																																																																													}
																																																																													if (BgL_test8470z00_16657)
																																																																														{
																																																																															obj_t
																																																																																BgL_l1378z00_16663;
																																																																															BgL_l1378z00_16663
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_l1378z00_3460));
																																																																															BgL_l1378z00_3460
																																																																																=
																																																																																BgL_l1378z00_16663;
																																																																															goto
																																																																																BgL_zc3z04anonymousza32965ze3z87_3461;
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															BgL_test8468z00_16654
																																																																																=
																																																																																(
																																																																																(bool_t)
																																																																																0);
																																																																														}
																																																																												}
																																																																										}
																																																																										if (BgL_test8468z00_16654)
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_arg2952z00_3443;
																																																																												BgL_arg2952z00_3443
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd27545zd2_3419));
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_16668;
																																																																													{
																																																																														obj_t
																																																																															BgL_argsz00_16672;
																																																																														obj_t
																																																																															BgL_proc2z00_16671;
																																																																														obj_t
																																																																															BgL_proc1z00_16670;
																																																																														obj_t
																																																																															BgL_testz00_16669;
																																																																														BgL_testz00_16669
																																																																															=
																																																																															BgL_arg2952z00_3443;
																																																																														BgL_proc1z00_16670
																																																																															=
																																																																															BgL_carzd27556zd2_3423;
																																																																														BgL_proc2z00_16671
																																																																															=
																																																																															BgL_carzd27564zd2_3427;
																																																																														BgL_argsz00_16672
																																																																															=
																																																																															BgL_cdrzd27539zd2_3418;
																																																																														BgL_argsz00_1747
																																																																															=
																																																																															BgL_argsz00_16672;
																																																																														BgL_proc2z00_1746
																																																																															=
																																																																															BgL_proc2z00_16671;
																																																																														BgL_proc1z00_1745
																																																																															=
																																																																															BgL_proc1z00_16670;
																																																																														BgL_testz00_1744
																																																																															=
																																																																															BgL_testz00_16669;
																																																																														goto
																																																																															BgL_tagzd2387zd2_1748;
																																																																													}
																																																																													BgL_auxz00_14266
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_16668);
																																																																												}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_cdrzd27588zd2_3444;
																																																																												BgL_cdrzd27588zd2_3444
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd27595zd2_3445;
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_pairz00_10516;
																																																																														BgL_pairz00_10516
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_expz00_21));
																																																																														BgL_cdrzd27595zd2_3445
																																																																															=
																																																																															CDR
																																																																															(BgL_pairz00_10516);
																																																																													}
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_cdrzd27602zd2_3446;
																																																																														BgL_cdrzd27602zd2_3446
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd27595zd2_3445));
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_carzd27608zd2_3447;
																																																																															BgL_carzd27608zd2_3447
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd27602zd2_3446));
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd27608zd2_3447))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_carzd27615zd2_3449;
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_pairz00_10520;
																																																																																		BgL_pairz00_10520
																																																																																			=
																																																																																			CDR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd27602zd2_3446));
																																																																																		BgL_carzd27615zd2_3449
																																																																																			=
																																																																																			CAR
																																																																																			(BgL_pairz00_10520);
																																																																																	}
																																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd27615zd2_3449))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd27588zd2_3444))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					obj_t
																																																																																						BgL_arg2956z00_3452;
																																																																																					BgL_arg2956z00_3452
																																																																																						=
																																																																																						CAR
																																																																																						(
																																																																																						((obj_t) BgL_cdrzd27595zd2_3445));
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_16694;
																																																																																						{
																																																																																							obj_t
																																																																																								BgL_argsz00_16698;
																																																																																							obj_t
																																																																																								BgL_proc2z00_16697;
																																																																																							obj_t
																																																																																								BgL_proc1z00_16696;
																																																																																							obj_t
																																																																																								BgL_testz00_16695;
																																																																																							BgL_testz00_16695
																																																																																								=
																																																																																								BgL_arg2956z00_3452;
																																																																																							BgL_proc1z00_16696
																																																																																								=
																																																																																								BgL_carzd27608zd2_3447;
																																																																																							BgL_proc2z00_16697
																																																																																								=
																																																																																								BgL_carzd27615zd2_3449;
																																																																																							BgL_argsz00_16698
																																																																																								=
																																																																																								BgL_cdrzd27588zd2_3444;
																																																																																							BgL_argsz00_1752
																																																																																								=
																																																																																								BgL_argsz00_16698;
																																																																																							BgL_proc2z00_1751
																																																																																								=
																																																																																								BgL_proc2z00_16697;
																																																																																							BgL_proc1z00_1750
																																																																																								=
																																																																																								BgL_proc1z00_16696;
																																																																																							BgL_testz00_1749
																																																																																								=
																																																																																								BgL_testz00_16695;
																																																																																							goto
																																																																																								BgL_tagzd2388zd2_1753;
																																																																																						}
																																																																																						BgL_auxz00_14266
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_16694);
																																																																																					}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							goto
																																																																																								BgL_tagzd2403zd2_1777;
																																																																																						}
																																																																																					else
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_16702;
																																																																																							goto
																																																																																								BgL_tagzd2404zd2_1778;
																																																																																							BgL_auxz00_14266
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_16702);
																																																																																						}
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1777;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_16706;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1778;
																																																																																					BgL_auxz00_14266
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_16706);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1777;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_16710;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1778;
																																																																																			BgL_auxz00_14266
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_16710);
																																																																																		}
																																																																																}
																																																																														}
																																																																													}
																																																																												}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1777;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_16714;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1778;
																																																																												BgL_auxz00_14266
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_16714);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd27891zd2_3471;
																																																																								BgL_cdrzd27891zd2_3471
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd27897zd2_3472;
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_pairz00_10524;
																																																																										BgL_pairz00_10524
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										BgL_cdrzd27897zd2_3472
																																																																											=
																																																																											CDR
																																																																											(BgL_pairz00_10524);
																																																																									}
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd27903zd2_3473;
																																																																										BgL_cdrzd27903zd2_3473
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd27897zd2_3472));
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd27908zd2_3474;
																																																																											obj_t
																																																																												BgL_cdrzd27909zd2_3475;
																																																																											BgL_carzd27908zd2_3474
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd27903zd2_3473));
																																																																											BgL_cdrzd27909zd2_3475
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd27903zd2_3473));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd27908zd2_3474))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_carzd27914zd2_3477;
																																																																													BgL_carzd27914zd2_3477
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd27909zd2_3475));
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd27914zd2_3477))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (NULLP(CDR(((obj_t) BgL_cdrzd27909zd2_3475))))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd27891zd2_3471))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_arg2976z00_3482;
																																																																																			BgL_arg2976z00_3482
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd27897zd2_3472));
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_16741;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_16745;
																																																																																					obj_t
																																																																																						BgL_proc2z00_16744;
																																																																																					obj_t
																																																																																						BgL_proc1z00_16743;
																																																																																					obj_t
																																																																																						BgL_testz00_16742;
																																																																																					BgL_testz00_16742
																																																																																						=
																																																																																						BgL_arg2976z00_3482;
																																																																																					BgL_proc1z00_16743
																																																																																						=
																																																																																						BgL_carzd27908zd2_3474;
																																																																																					BgL_proc2z00_16744
																																																																																						=
																																																																																						BgL_carzd27914zd2_3477;
																																																																																					BgL_argsz00_16745
																																																																																						=
																																																																																						BgL_cdrzd27891zd2_3471;
																																																																																					BgL_argsz00_1752
																																																																																						=
																																																																																						BgL_argsz00_16745;
																																																																																					BgL_proc2z00_1751
																																																																																						=
																																																																																						BgL_proc2z00_16744;
																																																																																					BgL_proc1z00_1750
																																																																																						=
																																																																																						BgL_proc1z00_16743;
																																																																																					BgL_testz00_1749
																																																																																						=
																																																																																						BgL_testz00_16742;
																																																																																					goto
																																																																																						BgL_tagzd2388zd2_1753;
																																																																																				}
																																																																																				BgL_auxz00_14266
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_16741);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1777;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_16749;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1778;
																																																																																					BgL_auxz00_14266
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_16749);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1777;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_16753;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1778;
																																																																																			BgL_auxz00_14266
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_16753);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1777;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_16757;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1778;
																																																																																	BgL_auxz00_14266
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_16757);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1777;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_16761;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1778;
																																																																															BgL_auxz00_14266
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_16761);
																																																																														}
																																																																												}
																																																																										}
																																																																									}
																																																																								}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1777;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_16765;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1778;
																																																																								BgL_auxz00_14266
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_16765);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd28247zd2_3490;
																																																																				BgL_cdrzd28247zd2_3490
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd28254zd2_3491;
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_pairz00_10534;
																																																																						BgL_pairz00_10534
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						BgL_cdrzd28254zd2_3491
																																																																							=
																																																																							CDR
																																																																							(BgL_pairz00_10534);
																																																																					}
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd28261zd2_3492;
																																																																						BgL_cdrzd28261zd2_3492
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd28254zd2_3491));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd28267zd2_3493;
																																																																							obj_t
																																																																								BgL_cdrzd28268zd2_3494;
																																																																							BgL_carzd28267zd2_3493
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd28261zd2_3492));
																																																																							BgL_cdrzd28268zd2_3494
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd28261zd2_3492));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd28267zd2_3493))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (PAIRP(BgL_cdrzd28268zd2_3494))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd28275zd2_3497;
																																																																											BgL_carzd28275zd2_3497
																																																																												=
																																																																												CAR
																																																																												(BgL_cdrzd28268zd2_3494);
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd28275zd2_3497))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (NULLP(CDR(BgL_cdrzd28268zd2_3494)))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd28247zd2_3490))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_arg2995z00_3502;
																																																																																	BgL_arg2995z00_3502
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd28254zd2_3491));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_16792;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_16796;
																																																																																			obj_t
																																																																																				BgL_proc2z00_16795;
																																																																																			obj_t
																																																																																				BgL_proc1z00_16794;
																																																																																			obj_t
																																																																																				BgL_testz00_16793;
																																																																																			BgL_testz00_16793
																																																																																				=
																																																																																				BgL_arg2995z00_3502;
																																																																																			BgL_proc1z00_16794
																																																																																				=
																																																																																				BgL_carzd28267zd2_3493;
																																																																																			BgL_proc2z00_16795
																																																																																				=
																																																																																				BgL_carzd28275zd2_3497;
																																																																																			BgL_argsz00_16796
																																																																																				=
																																																																																				BgL_cdrzd28247zd2_3490;
																																																																																			BgL_argsz00_1752
																																																																																				=
																																																																																				BgL_argsz00_16796;
																																																																																			BgL_proc2z00_1751
																																																																																				=
																																																																																				BgL_proc2z00_16795;
																																																																																			BgL_proc1z00_1750
																																																																																				=
																																																																																				BgL_proc1z00_16794;
																																																																																			BgL_testz00_1749
																																																																																				=
																																																																																				BgL_testz00_16793;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1753;
																																																																																		}
																																																																																		BgL_auxz00_14266
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_16792);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1777;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_16800;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1778;
																																																																																			BgL_auxz00_14266
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_16800);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1777;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_16804;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1778;
																																																																																	BgL_auxz00_14266
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_16804);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1777;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_16808;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1778;
																																																																															BgL_auxz00_14266
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_16808);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1777;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_16812;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1778;
																																																																													BgL_auxz00_14266
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_16812);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1777;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_16816;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1778;
																																																																											BgL_auxz00_14266
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_16816);
																																																																										}
																																																																								}
																																																																						}
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1777;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_16820;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1778;
																																																																			BgL_auxz00_14266
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_16820);
																																																																		}
																																																																}
																																																														}
																																																													}
																																																											}
																																																										}
																																																								}
																																																						}
																																																					}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd28668zd2_3516;
																																																				BgL_cdrzd28668zd2_3516
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 119 */
																																																					bool_t
																																																						BgL_test8499z00_16824;
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg3037z00_3533;
																																																						BgL_arg3037z00_3533
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test8499z00_16824
																																																							=
																																																							CBOOL
																																																							(BGl_letzd2symzf3z21zzast_letz00
																																																							(BgL_arg3037z00_3533));
																																																					}
																																																					if (BgL_test8499z00_16824)
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_arg3022z00_3519;
																																																							obj_t
																																																								BgL_arg3023z00_3520;
																																																							BgL_arg3022z00_3519
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd28668zd2_3516));
																																																							BgL_arg3023z00_3520
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd28668zd2_3516));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_16833;
																																																								{
																																																									obj_t
																																																										BgL_exprz00_16835;
																																																									obj_t
																																																										BgL_bindingsz00_16834;
																																																									BgL_bindingsz00_16834
																																																										=
																																																										BgL_arg3022z00_3519;
																																																									BgL_exprz00_16835
																																																										=
																																																										BgL_arg3023z00_3520;
																																																									BgL_exprz00_1732
																																																										=
																																																										BgL_exprz00_16835;
																																																									BgL_bindingsz00_1731
																																																										=
																																																										BgL_bindingsz00_16834;
																																																									goto
																																																										BgL_tagzd2382zd2_1733;
																																																								}
																																																								BgL_auxz00_14266
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_16833);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							bool_t
																																																								BgL_test8500z00_16837;
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg3035z00_3532;
																																																								BgL_arg3035z00_3532
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test8500z00_16837
																																																									=
																																																									CBOOL
																																																									(BGl_labelszd2symzf3z21zzast_labelsz00
																																																									(BgL_arg3035z00_3532));
																																																							}
																																																							if (BgL_test8500z00_16837)
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_16842;
																																																									goto
																																																										BgL_tagzd2384zd2_1735;
																																																									BgL_auxz00_14266
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_16842);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_carzd28734zd2_3523;
																																																									BgL_carzd28734zd2_3523
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd28739zd2_3524;
																																																										BgL_cdrzd28739zd2_3524
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_carzd28734zd2_3523));
																																																										if ((CAR(((obj_t) BgL_carzd28734zd2_3523)) == CNST_TABLE_REF(((long) 3))))
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_arg3030z00_3527;
																																																												obj_t
																																																													BgL_arg3031z00_3528;
																																																												obj_t
																																																													BgL_arg3032z00_3529;
																																																												BgL_arg3030z00_3527
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd28739zd2_3524));
																																																												BgL_arg3031z00_3528
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd28739zd2_3524));
																																																												BgL_arg3032z00_3529
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_16859;
																																																													{
																																																														obj_t
																																																															BgL_argsz00_16862;
																																																														obj_t
																																																															BgL_bodyz00_16861;
																																																														obj_t
																																																															BgL_varsz00_16860;
																																																														BgL_varsz00_16860
																																																															=
																																																															BgL_arg3030z00_3527;
																																																														BgL_bodyz00_16861
																																																															=
																																																															BgL_arg3031z00_3528;
																																																														BgL_argsz00_16862
																																																															=
																																																															BgL_arg3032z00_3529;
																																																														BgL_argsz00_1742
																																																															=
																																																															BgL_argsz00_16862;
																																																														BgL_bodyz00_1741
																																																															=
																																																															BgL_bodyz00_16861;
																																																														BgL_varsz00_1740
																																																															=
																																																															BgL_varsz00_16860;
																																																														goto
																																																															BgL_tagzd2386zd2_1743;
																																																													}
																																																													BgL_auxz00_14266
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_16859);
																																																												}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 119 */
																																																														goto
																																																															BgL_tagzd2403zd2_1777;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_16866;
																																																														goto
																																																															BgL_tagzd2404zd2_1778;
																																																														BgL_auxz00_14266
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_16866);
																																																													}
																																																											}
																																																									}
																																																								}
																																																						}
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_cdrzd28850zd2_3534;
																																																		BgL_cdrzd28850zd2_3534
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 119 */
																																																			bool_t
																																																				BgL_test8503z00_16870;
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg3054z00_3543;
																																																				BgL_arg3054z00_3543
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test8503z00_16870
																																																					=
																																																					CBOOL
																																																					(BGl_letzd2symzf3z21zzast_letz00
																																																					(BgL_arg3054z00_3543));
																																																			}
																																																			if (BgL_test8503z00_16870)
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_arg3042z00_3537;
																																																					obj_t
																																																						BgL_arg3045z00_3538;
																																																					BgL_arg3042z00_3537
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd28850zd2_3534));
																																																					BgL_arg3045z00_3538
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd28850zd2_3534));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_16879;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_16881;
																																																							obj_t
																																																								BgL_bindingsz00_16880;
																																																							BgL_bindingsz00_16880
																																																								=
																																																								BgL_arg3042z00_3537;
																																																							BgL_exprz00_16881
																																																								=
																																																								BgL_arg3045z00_3538;
																																																							BgL_exprz00_1732
																																																								=
																																																								BgL_exprz00_16881;
																																																							BgL_bindingsz00_1731
																																																								=
																																																								BgL_bindingsz00_16880;
																																																							goto
																																																								BgL_tagzd2382zd2_1733;
																																																						}
																																																						BgL_auxz00_14266
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_16879);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					bool_t
																																																						BgL_test8504z00_16883;
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg3053z00_3542;
																																																						BgL_arg3053z00_3542
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test8504z00_16883
																																																							=
																																																							CBOOL
																																																							(BGl_labelszd2symzf3z21zzast_labelsz00
																																																							(BgL_arg3053z00_3542));
																																																					}
																																																					if (BgL_test8504z00_16883)
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_16888;
																																																							goto
																																																								BgL_tagzd2384zd2_1735;
																																																							BgL_auxz00_14266
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_16888);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																								{	/* Ast/sexp.scm 119 */
																																																									goto
																																																										BgL_tagzd2403zd2_1777;
																																																								}
																																																							else
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_16892;
																																																									goto
																																																										BgL_tagzd2404zd2_1778;
																																																									BgL_auxz00_14266
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_16892);
																																																								}
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd27415zd2_3270)))
																																																	{	/* Ast/sexp.scm 119 */
																																																		goto
																																																			BgL_kapzd27417zd2_3272;
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		if ((BgL_carzd27415zd2_3270 == CNST_TABLE_REF(((long) 18))))
																																																			{	/* Ast/sexp.scm 119 */
																																																				goto
																																																					BgL_kapzd27417zd2_3272;
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				if ((BgL_carzd27415zd2_3270 == CNST_TABLE_REF(((long) 19))))
																																																					{	/* Ast/sexp.scm 119 */
																																																						goto
																																																							BgL_kapzd27417zd2_3272;
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd27415zd2_3270)))
																																																							{	/* Ast/sexp.scm 119 */
																																																								goto
																																																									BgL_kapzd27417zd2_3272;
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd29022zd2_3278;
																																																								BgL_cdrzd29022zd2_3278
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{	/* Ast/sexp.scm 119 */
																																																									bool_t
																																																										BgL_test8510z00_16908;
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg2904z00_3395;
																																																										BgL_arg2904z00_3395
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_test8510z00_16908
																																																											=
																																																											CBOOL
																																																											(BGl_letzd2symzf3z21zzast_letz00
																																																											(BgL_arg2904z00_3395));
																																																									}
																																																									if (BgL_test8510z00_16908)
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_arg2812z00_3281;
																																																											obj_t
																																																												BgL_arg2813z00_3282;
																																																											BgL_arg2812z00_3281
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_cdrzd29022zd2_3278));
																																																											BgL_arg2813z00_3282
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd29022zd2_3278));
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_16917;
																																																												{
																																																													obj_t
																																																														BgL_exprz00_16919;
																																																													obj_t
																																																														BgL_bindingsz00_16918;
																																																													BgL_bindingsz00_16918
																																																														=
																																																														BgL_arg2812z00_3281;
																																																													BgL_exprz00_16919
																																																														=
																																																														BgL_arg2813z00_3282;
																																																													BgL_exprz00_1732
																																																														=
																																																														BgL_exprz00_16919;
																																																													BgL_bindingsz00_1731
																																																														=
																																																														BgL_bindingsz00_16918;
																																																													goto
																																																														BgL_tagzd2382zd2_1733;
																																																												}
																																																												BgL_auxz00_14266
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_16917);
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											bool_t
																																																												BgL_test8511z00_16921;
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_arg2903z00_3394;
																																																												BgL_arg2903z00_3394
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												BgL_test8511z00_16921
																																																													=
																																																													CBOOL
																																																													(BGl_labelszd2symzf3z21zzast_labelsz00
																																																													(BgL_arg2903z00_3394));
																																																											}
																																																											if (BgL_test8511z00_16921)
																																																												{
																																																													BgL_letzd2funzd2_bglt
																																																														BgL_auxz00_16926;
																																																													goto
																																																														BgL_tagzd2384zd2_1735;
																																																													BgL_auxz00_14266
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_16926);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_carzd29088zd2_3285;
																																																													BgL_carzd29088zd2_3285
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd29093zd2_3286;
																																																														BgL_cdrzd29093zd2_3286
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_carzd29088zd2_3285));
																																																														if ((CAR(((obj_t) BgL_carzd29088zd2_3285)) == CNST_TABLE_REF(((long) 3))))
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (PAIRP(BgL_cdrzd29093zd2_3286))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_arg2819z00_3290;
																																																																		obj_t
																																																																			BgL_arg2820z00_3291;
																																																																		obj_t
																																																																			BgL_arg2821z00_3292;
																																																																		BgL_arg2819z00_3290
																																																																			=
																																																																			CAR
																																																																			(BgL_cdrzd29093zd2_3286);
																																																																		BgL_arg2820z00_3291
																																																																			=
																																																																			CDR
																																																																			(BgL_cdrzd29093zd2_3286);
																																																																		BgL_arg2821z00_3292
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_16943;
																																																																			{
																																																																				obj_t
																																																																					BgL_argsz00_16946;
																																																																				obj_t
																																																																					BgL_bodyz00_16945;
																																																																				obj_t
																																																																					BgL_varsz00_16944;
																																																																				BgL_varsz00_16944
																																																																					=
																																																																					BgL_arg2819z00_3290;
																																																																				BgL_bodyz00_16945
																																																																					=
																																																																					BgL_arg2820z00_3291;
																																																																				BgL_argsz00_16946
																																																																					=
																																																																					BgL_arg2821z00_3292;
																																																																				BgL_argsz00_1742
																																																																					=
																																																																					BgL_argsz00_16946;
																																																																				BgL_bodyz00_1741
																																																																					=
																																																																					BgL_bodyz00_16945;
																																																																				BgL_varsz00_1740
																																																																					=
																																																																					BgL_varsz00_16944;
																																																																				goto
																																																																					BgL_tagzd2386zd2_1743;
																																																																			}
																																																																			BgL_auxz00_14266
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_16943);
																																																																		}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1777;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_16950;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1778;
																																																																				BgL_auxz00_14266
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_16950);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd29200zd2_3295;
																																																																BgL_cdrzd29200zd2_3295
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd29205zd2_3296;
																																																																	BgL_cdrzd29205zd2_3296
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_carzd29088zd2_3285));
																																																																	if ((CAR(((obj_t) BgL_carzd29088zd2_3285)) == CNST_TABLE_REF(((long) 1))))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (PAIRP(BgL_cdrzd29205zd2_3296))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd29210zd2_3300;
																																																																					BgL_cdrzd29210zd2_3300
																																																																						=
																																																																						CDR
																																																																						(BgL_cdrzd29205zd2_3296);
																																																																					if (PAIRP(BgL_cdrzd29210zd2_3300))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd29214zd2_3302;
																																																																							obj_t
																																																																								BgL_cdrzd29215zd2_3303;
																																																																							BgL_carzd29214zd2_3302
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd29210zd2_3300);
																																																																							BgL_cdrzd29215zd2_3303
																																																																								=
																																																																								CDR
																																																																								(BgL_cdrzd29210zd2_3300);
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd29214zd2_3302))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (PAIRP(BgL_cdrzd29215zd2_3303))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd29220zd2_3306;
																																																																											BgL_carzd29220zd2_3306
																																																																												=
																																																																												CAR
																																																																												(BgL_cdrzd29215zd2_3303);
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd29220zd2_3306))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (NULLP(CDR(BgL_cdrzd29215zd2_3303)))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															bool_t
																																																																																BgL_test8522z00_16978;
																																																																															{
																																																																																obj_t
																																																																																	BgL_l1381z00_3339;
																																																																																BgL_l1381z00_3339
																																																																																	=
																																																																																	BgL_cdrzd29200zd2_3295;
																																																																															BgL_zc3z04anonymousza32860ze3z87_3340:
																																																																																if (NULLP(BgL_l1381z00_3339))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		BgL_test8522z00_16978
																																																																																			=
																																																																																			(
																																																																																			(bool_t)
																																																																																			1);
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		bool_t
																																																																																			BgL_test8524z00_16981;
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			bool_t
																																																																																				BgL_test8525z00_16982;
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_tmpz00_16983;
																																																																																				BgL_tmpz00_16983
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_l1381z00_3339));
																																																																																				BgL_test8525z00_16982
																																																																																					=
																																																																																					PAIRP
																																																																																					(BgL_tmpz00_16983);
																																																																																			}
																																																																																			if (BgL_test8525z00_16982)
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					BgL_test8524z00_16981
																																																																																						=
																																																																																						(
																																																																																						(bool_t)
																																																																																						0);
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					BgL_test8524z00_16981
																																																																																						=
																																																																																						(
																																																																																						(bool_t)
																																																																																						1);
																																																																																				}
																																																																																		}
																																																																																		if (BgL_test8524z00_16981)
																																																																																			{
																																																																																				obj_t
																																																																																					BgL_l1381z00_16987;
																																																																																				BgL_l1381z00_16987
																																																																																					=
																																																																																					CDR
																																																																																					(
																																																																																					((obj_t) BgL_l1381z00_3339));
																																																																																				BgL_l1381z00_3339
																																																																																					=
																																																																																					BgL_l1381z00_16987;
																																																																																				goto
																																																																																					BgL_zc3z04anonymousza32860ze3z87_3340;
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				BgL_test8522z00_16978
																																																																																					=
																																																																																					(
																																																																																					(bool_t)
																																																																																					0);
																																																																																			}
																																																																																	}
																																																																															}
																																																																															if (BgL_test8522z00_16978)
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_arg2849z00_3322;
																																																																																	BgL_arg2849z00_3322
																																																																																		=
																																																																																		CAR
																																																																																		(BgL_cdrzd29205zd2_3296);
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_16991;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_16995;
																																																																																			obj_t
																																																																																				BgL_proc2z00_16994;
																																																																																			obj_t
																																																																																				BgL_proc1z00_16993;
																																																																																			obj_t
																																																																																				BgL_testz00_16992;
																																																																																			BgL_testz00_16992
																																																																																				=
																																																																																				BgL_arg2849z00_3322;
																																																																																			BgL_proc1z00_16993
																																																																																				=
																																																																																				BgL_carzd29214zd2_3302;
																																																																																			BgL_proc2z00_16994
																																																																																				=
																																																																																				BgL_carzd29220zd2_3306;
																																																																																			BgL_argsz00_16995
																																																																																				=
																																																																																				BgL_cdrzd29200zd2_3295;
																																																																																			BgL_argsz00_1747
																																																																																				=
																																																																																				BgL_argsz00_16995;
																																																																																			BgL_proc2z00_1746
																																																																																				=
																																																																																				BgL_proc2z00_16994;
																																																																																			BgL_proc1z00_1745
																																																																																				=
																																																																																				BgL_proc1z00_16993;
																																																																																			BgL_testz00_1744
																																																																																				=
																																																																																				BgL_testz00_16992;
																																																																																			goto
																																																																																				BgL_tagzd2387zd2_1748;
																																																																																		}
																																																																																		BgL_auxz00_14266
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_16991);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_cdrzd29245zd2_3323;
																																																																																	BgL_cdrzd29245zd2_3323
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_expz00_21));
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_cdrzd29253zd2_3324;
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_pairz00_10591;
																																																																																			BgL_pairz00_10591
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_expz00_21));
																																																																																			BgL_cdrzd29253zd2_3324
																																																																																				=
																																																																																				CDR
																																																																																				(BgL_pairz00_10591);
																																																																																		}
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_cdrzd29261zd2_3325;
																																																																																			BgL_cdrzd29261zd2_3325
																																																																																				=
																																																																																				CDR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd29253zd2_3324));
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_carzd29268zd2_3326;
																																																																																				BgL_carzd29268zd2_3326
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd29261zd2_3325));
																																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd29268zd2_3326))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						obj_t
																																																																																							BgL_carzd29277zd2_3328;
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							obj_t
																																																																																								BgL_pairz00_10595;
																																																																																							BgL_pairz00_10595
																																																																																								=
																																																																																								CDR
																																																																																								(
																																																																																								((obj_t) BgL_cdrzd29261zd2_3325));
																																																																																							BgL_carzd29277zd2_3328
																																																																																								=
																																																																																								CAR
																																																																																								(BgL_pairz00_10595);
																																																																																						}
																																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd29277zd2_3328))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd29245zd2_3323))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										obj_t
																																																																																											BgL_arg2853z00_3331;
																																																																																										BgL_arg2853z00_3331
																																																																																											=
																																																																																											CAR
																																																																																											(
																																																																																											((obj_t) BgL_cdrzd29253zd2_3324));
																																																																																										{
																																																																																											BgL_nodez00_bglt
																																																																																												BgL_auxz00_17017;
																																																																																											{
																																																																																												obj_t
																																																																																													BgL_argsz00_17021;
																																																																																												obj_t
																																																																																													BgL_proc2z00_17020;
																																																																																												obj_t
																																																																																													BgL_proc1z00_17019;
																																																																																												obj_t
																																																																																													BgL_testz00_17018;
																																																																																												BgL_testz00_17018
																																																																																													=
																																																																																													BgL_arg2853z00_3331;
																																																																																												BgL_proc1z00_17019
																																																																																													=
																																																																																													BgL_carzd29268zd2_3326;
																																																																																												BgL_proc2z00_17020
																																																																																													=
																																																																																													BgL_carzd29277zd2_3328;
																																																																																												BgL_argsz00_17021
																																																																																													=
																																																																																													BgL_cdrzd29245zd2_3323;
																																																																																												BgL_argsz00_1752
																																																																																													=
																																																																																													BgL_argsz00_17021;
																																																																																												BgL_proc2z00_1751
																																																																																													=
																																																																																													BgL_proc2z00_17020;
																																																																																												BgL_proc1z00_1750
																																																																																													=
																																																																																													BgL_proc1z00_17019;
																																																																																												BgL_testz00_1749
																																																																																													=
																																																																																													BgL_testz00_17018;
																																																																																												goto
																																																																																													BgL_tagzd2388zd2_1753;
																																																																																											}
																																																																																											BgL_auxz00_14266
																																																																																												=
																																																																																												(
																																																																																												(obj_t)
																																																																																												BgL_auxz00_17017);
																																																																																										}
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												goto
																																																																																													BgL_tagzd2403zd2_1777;
																																																																																											}
																																																																																										else
																																																																																											{
																																																																																												BgL_nodez00_bglt
																																																																																													BgL_auxz00_17025;
																																																																																												goto
																																																																																													BgL_tagzd2404zd2_1778;
																																																																																												BgL_auxz00_14266
																																																																																													=
																																																																																													(
																																																																																													(obj_t)
																																																																																													BgL_auxz00_17025);
																																																																																											}
																																																																																									}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1777;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_17029;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1778;
																																																																																										BgL_auxz00_14266
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_17029);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1777;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_17033;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1778;
																																																																																								BgL_auxz00_14266
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_17033);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		}
																																																																																	}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1777;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_17037;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1778;
																																																																																	BgL_auxz00_14266
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_17037);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd29555zd2_3350;
																																																																													BgL_cdrzd29555zd2_3350
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_cdrzd29562zd2_3351;
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_pairz00_10599;
																																																																															BgL_pairz00_10599
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															BgL_cdrzd29562zd2_3351
																																																																																=
																																																																																CDR
																																																																																(BgL_pairz00_10599);
																																																																														}
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_cdrzd29569zd2_3352;
																																																																															BgL_cdrzd29569zd2_3352
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_cdrzd29562zd2_3351));
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_carzd29575zd2_3353;
																																																																																obj_t
																																																																																	BgL_cdrzd29576zd2_3354;
																																																																																BgL_carzd29575zd2_3353
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd29569zd2_3352));
																																																																																BgL_cdrzd29576zd2_3354
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd29569zd2_3352));
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd29575zd2_3353))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_carzd29583zd2_3356;
																																																																																		BgL_carzd29583zd2_3356
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd29576zd2_3354));
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd29583zd2_3356))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (NULLP(CDR(((obj_t) BgL_cdrzd29576zd2_3354))))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd29555zd2_3350))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								obj_t
																																																																																									BgL_arg2870z00_3361;
																																																																																								BgL_arg2870z00_3361
																																																																																									=
																																																																																									CAR
																																																																																									(
																																																																																									((obj_t) BgL_cdrzd29562zd2_3351));
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_17064;
																																																																																									{
																																																																																										obj_t
																																																																																											BgL_argsz00_17068;
																																																																																										obj_t
																																																																																											BgL_proc2z00_17067;
																																																																																										obj_t
																																																																																											BgL_proc1z00_17066;
																																																																																										obj_t
																																																																																											BgL_testz00_17065;
																																																																																										BgL_testz00_17065
																																																																																											=
																																																																																											BgL_arg2870z00_3361;
																																																																																										BgL_proc1z00_17066
																																																																																											=
																																																																																											BgL_carzd29575zd2_3353;
																																																																																										BgL_proc2z00_17067
																																																																																											=
																																																																																											BgL_carzd29583zd2_3356;
																																																																																										BgL_argsz00_17068
																																																																																											=
																																																																																											BgL_cdrzd29555zd2_3350;
																																																																																										BgL_argsz00_1752
																																																																																											=
																																																																																											BgL_argsz00_17068;
																																																																																										BgL_proc2z00_1751
																																																																																											=
																																																																																											BgL_proc2z00_17067;
																																																																																										BgL_proc1z00_1750
																																																																																											=
																																																																																											BgL_proc1z00_17066;
																																																																																										BgL_testz00_1749
																																																																																											=
																																																																																											BgL_testz00_17065;
																																																																																										goto
																																																																																											BgL_tagzd2388zd2_1753;
																																																																																									}
																																																																																									BgL_auxz00_14266
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_17064);
																																																																																								}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1777;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_17072;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1778;
																																																																																										BgL_auxz00_14266
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_17072);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1777;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_17076;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1778;
																																																																																								BgL_auxz00_14266
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_17076);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1777;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_17080;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1778;
																																																																																						BgL_auxz00_14266
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_17080);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1777;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_17084;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1778;
																																																																																				BgL_auxz00_14266
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_17084);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														}
																																																																													}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1777;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_17088;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1778;
																																																																													BgL_auxz00_14266
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_17088);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd29916zd2_3369;
																																																																									BgL_cdrzd29916zd2_3369
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd29922zd2_3370;
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_pairz00_10609;
																																																																											BgL_pairz00_10609
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											BgL_cdrzd29922zd2_3370
																																																																												=
																																																																												CDR
																																																																												(BgL_pairz00_10609);
																																																																										}
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd29928zd2_3371;
																																																																											BgL_cdrzd29928zd2_3371
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd29922zd2_3370));
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_carzd29933zd2_3372;
																																																																												obj_t
																																																																													BgL_cdrzd29934zd2_3373;
																																																																												BgL_carzd29933zd2_3372
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd29928zd2_3371));
																																																																												BgL_cdrzd29934zd2_3373
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd29928zd2_3371));
																																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd29933zd2_3372))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (PAIRP(BgL_cdrzd29934zd2_3373))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_carzd29939zd2_3376;
																																																																																BgL_carzd29939zd2_3376
																																																																																	=
																																																																																	CAR
																																																																																	(BgL_cdrzd29934zd2_3373);
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd29939zd2_3376))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (NULLP(CDR(BgL_cdrzd29934zd2_3373)))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd29916zd2_3369))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						obj_t
																																																																																							BgL_arg2884z00_3381;
																																																																																						BgL_arg2884z00_3381
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd29922zd2_3370));
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_17115;
																																																																																							{
																																																																																								obj_t
																																																																																									BgL_argsz00_17119;
																																																																																								obj_t
																																																																																									BgL_proc2z00_17118;
																																																																																								obj_t
																																																																																									BgL_proc1z00_17117;
																																																																																								obj_t
																																																																																									BgL_testz00_17116;
																																																																																								BgL_testz00_17116
																																																																																									=
																																																																																									BgL_arg2884z00_3381;
																																																																																								BgL_proc1z00_17117
																																																																																									=
																																																																																									BgL_carzd29933zd2_3372;
																																																																																								BgL_proc2z00_17118
																																																																																									=
																																																																																									BgL_carzd29939zd2_3376;
																																																																																								BgL_argsz00_17119
																																																																																									=
																																																																																									BgL_cdrzd29916zd2_3369;
																																																																																								BgL_argsz00_1752
																																																																																									=
																																																																																									BgL_argsz00_17119;
																																																																																								BgL_proc2z00_1751
																																																																																									=
																																																																																									BgL_proc2z00_17118;
																																																																																								BgL_proc1z00_1750
																																																																																									=
																																																																																									BgL_proc1z00_17117;
																																																																																								BgL_testz00_1749
																																																																																									=
																																																																																									BgL_testz00_17116;
																																																																																								goto
																																																																																									BgL_tagzd2388zd2_1753;
																																																																																							}
																																																																																							BgL_auxz00_14266
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_17115);
																																																																																						}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1777;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_17123;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1778;
																																																																																								BgL_auxz00_14266
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_17123);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1777;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_17127;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1778;
																																																																																						BgL_auxz00_14266
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_17127);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1777;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_17131;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1778;
																																																																																				BgL_auxz00_14266
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_17131);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1777;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_17135;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1778;
																																																																																		BgL_auxz00_14266
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_17135);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1777;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_17139;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1778;
																																																																																BgL_auxz00_14266
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_17139);
																																																																															}
																																																																													}
																																																																											}
																																																																										}
																																																																									}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1777;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_17143;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1778;
																																																																									BgL_auxz00_14266
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_17143);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1777;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_17147;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1778;
																																																																							BgL_auxz00_14266
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_17147);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1777;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_17151;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1778;
																																																																					BgL_auxz00_14266
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_17151);
																																																																				}
																																																																		}
																																																																}
																																																															}
																																																													}
																																																												}
																																																										}
																																																								}
																																																							}
																																																					}
																																																			}
																																																	}
																																															}
																																													}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_cdrzd210477zd2_3545;
																																													BgL_cdrzd210477zd2_3545
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													if ((BgL_carzd27412zd2_3268 == CNST_TABLE_REF(((long) 17))))
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg3056z00_3547;
																																															obj_t
																																																BgL_arg3057z00_3548;
																																															BgL_arg3056z00_3547
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd210477zd2_3545));
																																															BgL_arg3057z00_3548
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd210477zd2_3545));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_17162;
																																																{
																																																	obj_t
																																																		BgL_exprz00_17164;
																																																	obj_t
																																																		BgL_bindingsz00_17163;
																																																	BgL_bindingsz00_17163
																																																		=
																																																		BgL_arg3056z00_3547;
																																																	BgL_exprz00_17164
																																																		=
																																																		BgL_arg3057z00_3548;
																																																	BgL_exprz00_1732
																																																		=
																																																		BgL_exprz00_17164;
																																																	BgL_bindingsz00_1731
																																																		=
																																																		BgL_bindingsz00_17163;
																																																	goto
																																																		BgL_tagzd2382zd2_1733;
																																																}
																																																BgL_auxz00_14266
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_17162);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd27412zd2_3268)))
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg3061z00_3550;
																																																	obj_t
																																																		BgL_arg3063z00_3551;
																																																	BgL_arg3061z00_3550
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd210477zd2_3545));
																																																	BgL_arg3063z00_3551
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd210477zd2_3545));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_17173;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_17175;
																																																			obj_t
																																																				BgL_bindingsz00_17174;
																																																			BgL_bindingsz00_17174
																																																				=
																																																				BgL_arg3061z00_3550;
																																																			BgL_exprz00_17175
																																																				=
																																																				BgL_arg3063z00_3551;
																																																			BgL_exprz00_1732
																																																				=
																																																				BgL_exprz00_17175;
																																																			BgL_bindingsz00_1731
																																																				=
																																																				BgL_bindingsz00_17174;
																																																			goto
																																																				BgL_tagzd2382zd2_1733;
																																																		}
																																																		BgL_auxz00_14266
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_17173);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if ((BgL_carzd27412zd2_3268 == CNST_TABLE_REF(((long) 18))))
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg3066z00_3553;
																																																			obj_t
																																																				BgL_arg3067z00_3554;
																																																			BgL_arg3066z00_3553
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd210477zd2_3545));
																																																			BgL_arg3067z00_3554
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd210477zd2_3545));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_17184;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_17186;
																																																					obj_t
																																																						BgL_bindingsz00_17185;
																																																					BgL_bindingsz00_17185
																																																						=
																																																						BgL_arg3066z00_3553;
																																																					BgL_exprz00_17186
																																																						=
																																																						BgL_arg3067z00_3554;
																																																					BgL_exprz00_1732
																																																						=
																																																						BgL_exprz00_17186;
																																																					BgL_bindingsz00_1731
																																																						=
																																																						BgL_bindingsz00_17185;
																																																					goto
																																																						BgL_tagzd2382zd2_1733;
																																																				}
																																																				BgL_auxz00_14266
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_17184);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_17193;
																																																					goto
																																																						BgL_tagzd2383zd2_1734;
																																																					BgL_auxz00_14266
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_17193);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_carzd210514zd2_3557;
																																																					BgL_carzd210514zd2_3557
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					if ((BgL_carzd210514zd2_3557 == CNST_TABLE_REF(((long) 19))))
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_17200;
																																																							goto
																																																								BgL_tagzd2384zd2_1735;
																																																							BgL_auxz00_14266
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_17200);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd210514zd2_3557)))
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_17205;
																																																									goto
																																																										BgL_tagzd2384zd2_1735;
																																																									BgL_auxz00_14266
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_17205);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_17212;
																																																											goto
																																																												BgL_tagzd2389zd2_1754;
																																																											BgL_auxz00_14266
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_17212);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_17219;
																																																													goto
																																																														BgL_tagzd2390zd2_1755;
																																																													BgL_auxz00_14266
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_17219);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd210594zd2_3564;
																																																													BgL_cdrzd210594zd2_3564
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_arg3079z00_3567;
																																																															obj_t
																																																																BgL_arg3080z00_3568;
																																																															BgL_arg3079z00_3567
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd210594zd2_3564));
																																																															BgL_arg3080z00_3568
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd210594zd2_3564));
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_17232;
																																																																{
																																																																	obj_t
																																																																		BgL_restz00_17234;
																																																																	obj_t
																																																																		BgL_effectz00_17233;
																																																																	BgL_effectz00_17233
																																																																		=
																																																																		BgL_arg3079z00_3567;
																																																																	BgL_restz00_17234
																																																																		=
																																																																		BgL_arg3080z00_3568;
																																																																	BgL_restz00_1757
																																																																		=
																																																																		BgL_restz00_17234;
																																																																	BgL_effectz00_1756
																																																																		=
																																																																		BgL_effectz00_17233;
																																																																	goto
																																																																		BgL_tagzd2391zd2_1758;
																																																																}
																																																																BgL_auxz00_14266
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_17232);
																																																															}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_17241;
																																																																	goto
																																																																		BgL_tagzd2392zd2_1759;
																																																																	BgL_auxz00_14266
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_17241);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_17248;
																																																																			goto
																																																																				BgL_tagzd2393zd2_1760;
																																																																			BgL_auxz00_14266
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_17248);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_arg3092z00_3576;
																																																																					obj_t
																																																																						BgL_arg3093z00_3577;
																																																																					BgL_arg3092z00_3576
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd210594zd2_3564));
																																																																					BgL_arg3093z00_3577
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd210594zd2_3564));
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_17259;
																																																																						{
																																																																							obj_t
																																																																								BgL_restz00_17261;
																																																																							obj_t
																																																																								BgL_effectz00_17260;
																																																																							BgL_effectz00_17260
																																																																								=
																																																																								BgL_arg3092z00_3576;
																																																																							BgL_restz00_17261
																																																																								=
																																																																								BgL_arg3093z00_3577;
																																																																							BgL_restz00_1762
																																																																								=
																																																																								BgL_restz00_17261;
																																																																							BgL_effectz00_1761
																																																																								=
																																																																								BgL_effectz00_17260;
																																																																							goto
																																																																								BgL_tagzd2394zd2_1763;
																																																																						}
																																																																						BgL_auxz00_14266
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_17259);
																																																																					}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_17268;
																																																																							goto
																																																																								BgL_tagzd2395zd2_1764;
																																																																							BgL_auxz00_14266
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_17268);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_17275;
																																																																									goto
																																																																										BgL_tagzd2396zd2_1765;
																																																																									BgL_auxz00_14266
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_17275);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																										{
																																																																											BgL_letzd2funzd2_bglt
																																																																												BgL_auxz00_17282;
																																																																											goto
																																																																												BgL_tagzd2397zd2_1766;
																																																																											BgL_auxz00_14266
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_17282);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																												{
																																																																													BgL_jumpzd2exzd2itz00_bglt
																																																																														BgL_auxz00_17289;
																																																																													goto
																																																																														BgL_tagzd2398zd2_1767;
																																																																													BgL_auxz00_14266
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_17289);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd210671zd2_3586;
																																																																													BgL_cdrzd210671zd2_3586
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg3109z00_3589;
																																																																															obj_t
																																																																																BgL_arg3111z00_3590;
																																																																															BgL_arg3109z00_3589
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd210671zd2_3586));
																																																																															BgL_arg3111z00_3590
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_cdrzd210671zd2_3586));
																																																																															{	/* Ast/sexp.scm 552 */
																																																																																obj_t
																																																																																	BgL_arg6965z00_10648;
																																																																																BgL_arg6965z00_10648
																																																																																	=
																																																																																	BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																	(BgL_expz00_21,
																																																																																	BgL_locz00_23);
																																																																																BgL_auxz00_14266
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																	(BgL_expz00_21,
																																																																																		BgL_arg3109z00_3589,
																																																																																		CNST_TABLE_REF
																																																																																		(((long) 4)), BgL_arg3111z00_3590, BgL_stackz00_22, BgL_arg6965z00_10648, BgL_sitez00_24));
																																																																														}}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1777;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_17308;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1778;
																																																																																	BgL_auxz00_14266
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_17308);
																																																																																}
																																																																														}
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																															else
																																{	/* Ast/sexp.scm 119 */
																																	obj_t
																																		BgL_carzd210696zd2_3607;
																																	BgL_carzd210696zd2_3607
																																		=
																																		CAR(((obj_t)
																																			BgL_expz00_21));
																																	if (
																																		(BgL_carzd210696zd2_3607
																																			==
																																			CNST_TABLE_REF
																																			(((long)
																																					1))))
																																		{
																																			BgL_nodez00_bglt
																																				BgL_auxz00_17315;
																																			goto
																																				BgL_tagzd2377zd2_1722;
																																			BgL_auxz00_14266
																																				=
																																				((obj_t)
																																				BgL_auxz00_17315);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 119 */
																																			if (
																																				(BgL_carzd210696zd2_3607
																																					==
																																					BGl_za2ifza2z00zzast_sexpz00))
																																				{
																																					BgL_nodez00_bglt
																																						BgL_auxz00_17319;
																																					goto
																																						BgL_tagzd2377zd2_1722;
																																					BgL_auxz00_14266
																																						=
																																						(
																																						(obj_t)
																																						BgL_auxz00_17319);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					obj_t
																																						BgL_cdrzd210718zd2_3610;
																																					BgL_cdrzd210718zd2_3610
																																						=
																																						CDR(
																																						((obj_t) BgL_expz00_21));
																																					if (
																																						(CAR
																																							(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 7))))
																																						{	/* Ast/sexp.scm 119 */
																																							obj_t
																																								BgL_carzd210721zd2_3613;
																																							obj_t
																																								BgL_cdrzd210722zd2_3614;
																																							BgL_carzd210721zd2_3613
																																								=
																																								CAR
																																								(
																																								((obj_t) BgL_cdrzd210718zd2_3610));
																																							BgL_cdrzd210722zd2_3614
																																								=
																																								CDR
																																								(
																																								((obj_t) BgL_cdrzd210718zd2_3610));
																																							if (PAIRP(BgL_carzd210721zd2_3613))
																																								{	/* Ast/sexp.scm 119 */
																																									if ((CAR(BgL_carzd210721zd2_3613) == CNST_TABLE_REF(((long) 14))))
																																										{	/* Ast/sexp.scm 119 */
																																											if (NULLP(CDR(((obj_t) BgL_cdrzd210722zd2_3614))))
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_arg3149z00_3620;
																																													obj_t
																																														BgL_arg3150z00_3621;
																																													BgL_arg3149z00_3620
																																														=
																																														CDR
																																														(BgL_carzd210721zd2_3613);
																																													BgL_arg3150z00_3621
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_cdrzd210722zd2_3614));
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_17345;
																																														BgL_lz00_1723
																																															=
																																															BgL_arg3149z00_3620;
																																														BgL_valz00_1724
																																															=
																																															BgL_arg3150z00_3621;
																																													BgL_tagzd2378zd2_1725:
																																														{	/* Ast/sexp.scm 286 */
																																															bool_t
																																																BgL_test8579z00_17346;
																																															if (PAIRP(BgL_lz00_1723))
																																																{	/* Ast/sexp.scm 286 */
																																																	bool_t
																																																		BgL_test8581z00_17349;
																																																	{	/* Ast/sexp.scm 286 */
																																																		obj_t
																																																			BgL_tmpz00_17350;
																																																		BgL_tmpz00_17350
																																																			=
																																																			CDR
																																																			(BgL_lz00_1723);
																																																		BgL_test8581z00_17349
																																																			=
																																																			PAIRP
																																																			(BgL_tmpz00_17350);
																																																	}
																																																	if (BgL_test8581z00_17349)
																																																		{
																																																			obj_t
																																																				BgL_l1350z00_8579;
																																																			BgL_l1350z00_8579
																																																				=
																																																				BgL_lz00_1723;
																																																		BgL_zc3z04anonymousza36718ze3z87_8580:
																																																			if (NULLP(BgL_l1350z00_8579))
																																																				{	/* Ast/sexp.scm 286 */
																																																					BgL_test8579z00_17346
																																																						=
																																																						(
																																																						(bool_t)
																																																						1);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 286 */
																																																					bool_t
																																																						BgL_test8583z00_17355;
																																																					{	/* Ast/sexp.scm 286 */
																																																						obj_t
																																																							BgL_tmpz00_17356;
																																																						BgL_tmpz00_17356
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_l1350z00_8579));
																																																						BgL_test8583z00_17355
																																																							=
																																																							SYMBOLP
																																																							(BgL_tmpz00_17356);
																																																					}
																																																					if (BgL_test8583z00_17355)
																																																						{
																																																							obj_t
																																																								BgL_l1350z00_17360;
																																																							BgL_l1350z00_17360
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_l1350z00_8579));
																																																							BgL_l1350z00_8579
																																																								=
																																																								BgL_l1350z00_17360;
																																																							goto
																																																								BgL_zc3z04anonymousza36718ze3z87_8580;
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 286 */
																																																							BgL_test8579z00_17346
																																																								=
																																																								(
																																																								(bool_t)
																																																								0);
																																																						}
																																																				}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 286 */
																																																			BgL_test8579z00_17346
																																																				=
																																																				(
																																																				(bool_t)
																																																				0);
																																																		}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 286 */
																																																	BgL_test8579z00_17346
																																																		=
																																																		(
																																																		(bool_t)
																																																		0);
																																																}
																																															if (BgL_test8579z00_17346)
																																																{	/* Ast/sexp.scm 286 */
																																																	BgL_auxz00_17345
																																																		=
																																																		BGl_fieldzd2setzd2ze3nodeze3zzast_objectz00
																																																		(BgL_lz00_1723,
																																																		BgL_valz00_1724,
																																																		BgL_expz00_21,
																																																		BgL_stackz00_22,
																																																		BgL_locz00_23,
																																																		BgL_sitez00_24);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 288 */
																																																	BgL_nodez00_bglt
																																																		BgL_res7368z00_9815;
																																																	{	/* Ast/sexp.scm 723 */
																																																		obj_t
																																																			BgL_arg7080z00_9811;
																																																		BgL_nodez00_bglt
																																																			BgL_arg7081z00_9812;
																																																		BgL_arg7080z00_9811
																																																			=
																																																			BGl_shapez00zztools_shapez00
																																																			(BGl_currentzd2functionzd2zztools_errorz00
																																																			());
																																																		BgL_arg7081z00_9812
																																																			=
																																																			BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																			(CNST_TABLE_REF
																																																			(((long) 4)), BNIL, BgL_locz00_23, CNST_TABLE_REF(((long) 2)));
																																																		{	/* Ast/sexp.scm 722 */
																																																			obj_t
																																																				BgL_list7082z00_9814;
																																																			BgL_list7082z00_9814
																																																				=
																																																				MAKE_YOUNG_PAIR
																																																				(
																																																				((obj_t) BgL_arg7081z00_9812), BNIL);
																																																			BgL_res7368z00_9815
																																																				=
																																																				(
																																																				(BgL_nodez00_bglt)
																																																				BGl_userzd2errorzf2locationz20zztools_errorz00
																																																				(BgL_locz00_23,
																																																					BgL_arg7080z00_9811,
																																																					BGl_string8006z00zzast_sexpz00,
																																																					BgL_expz00_21,
																																																					BgL_list7082z00_9814));
																																																	}}
																																																	BgL_auxz00_17345
																																																		=
																																																		BgL_res7368z00_9815;
																																														}}
																																														BgL_auxz00_14266
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_17345);
																																												}}
																																											else
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_17374;
																																													goto
																																														BgL_tagzd2379zd2_1726;
																																													BgL_auxz00_14266
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_17374);
																																												}
																																										}
																																									else
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_17376;
																																											goto
																																												BgL_tagzd2379zd2_1726;
																																											BgL_auxz00_14266
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_17376);
																																										}
																																								}
																																							else
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_17378;
																																									goto
																																										BgL_tagzd2379zd2_1726;
																																									BgL_auxz00_14266
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_17378);
																																								}
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_17385;
																																									goto
																																										BgL_tagzd2380zd2_1727;
																																									BgL_auxz00_14266
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_17385);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									obj_t
																																										BgL_carzd210819zd2_3626;
																																									BgL_carzd210819zd2_3626
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_expz00_21));
																																									if (PAIRP(BgL_carzd210819zd2_3626))
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_carzd210822zd2_3628;
																																											obj_t
																																												BgL_cdrzd210823zd2_3629;
																																											BgL_carzd210822zd2_3628
																																												=
																																												CAR
																																												(BgL_carzd210819zd2_3626);
																																											BgL_cdrzd210823zd2_3629
																																												=
																																												CDR
																																												(BgL_carzd210819zd2_3626);
																																											{

																																												if ((BgL_carzd210822zd2_3628 == CNST_TABLE_REF(((long) 17))))
																																													{	/* Ast/sexp.scm 119 */
																																													BgL_kapzd210824zd2_3630:
																																														if (PAIRP(BgL_cdrzd210823zd2_3629))
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_cdrzd210827zd2_3755;
																																																BgL_cdrzd210827zd2_3755
																																																	=
																																																	CDR
																																																	(BgL_cdrzd210823zd2_3629);
																																																if (PAIRP(BgL_cdrzd210827zd2_3755))
																																																	{	/* Ast/sexp.scm 119 */
																																																		if (NULLP(CDR(BgL_cdrzd210827zd2_3755)))
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg3264z00_3759;
																																																				obj_t
																																																					BgL_arg3265z00_3760;
																																																				BgL_arg3264z00_3759
																																																					=
																																																					CAR
																																																					(BgL_cdrzd210827zd2_3755);
																																																				BgL_arg3265z00_3760
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_17407;
																																																					{
																																																						obj_t
																																																							BgL_argsz00_17409;
																																																						obj_t
																																																							BgL_bodyz00_17408;
																																																						BgL_bodyz00_17408
																																																							=
																																																							BgL_arg3264z00_3759;
																																																						BgL_argsz00_17409
																																																							=
																																																							BgL_arg3265z00_3760;
																																																						BgL_argsz00_1729
																																																							=
																																																							BgL_argsz00_17409;
																																																						BgL_bodyz00_1728
																																																							=
																																																							BgL_bodyz00_17408;
																																																						goto
																																																							BgL_tagzd2381zd2_1730;
																																																					}
																																																					BgL_auxz00_14266
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_17407);
																																																				}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd210851zd2_3761;
																																																				BgL_cdrzd210851zd2_3761
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 119 */
																																																					bool_t
																																																						BgL_test8590z00_17413;
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg3362z00_3872;
																																																						BgL_arg3362z00_3872
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test8590z00_17413
																																																							=
																																																							CBOOL
																																																							(BGl_letzd2symzf3z21zzast_letz00
																																																							(BgL_arg3362z00_3872));
																																																					}
																																																					if (BgL_test8590z00_17413)
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_arg3272z00_3764;
																																																							obj_t
																																																								BgL_arg3273z00_3765;
																																																							BgL_arg3272z00_3764
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd210851zd2_3761));
																																																							BgL_arg3273z00_3765
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd210851zd2_3761));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_17422;
																																																								{
																																																									obj_t
																																																										BgL_exprz00_17424;
																																																									obj_t
																																																										BgL_bindingsz00_17423;
																																																									BgL_bindingsz00_17423
																																																										=
																																																										BgL_arg3272z00_3764;
																																																									BgL_exprz00_17424
																																																										=
																																																										BgL_arg3273z00_3765;
																																																									BgL_exprz00_1732
																																																										=
																																																										BgL_exprz00_17424;
																																																									BgL_bindingsz00_1731
																																																										=
																																																										BgL_bindingsz00_17423;
																																																									goto
																																																										BgL_tagzd2382zd2_1733;
																																																								}
																																																								BgL_auxz00_14266
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_17422);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							bool_t
																																																								BgL_test8591z00_17426;
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg3361z00_3871;
																																																								BgL_arg3361z00_3871
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test8591z00_17426
																																																									=
																																																									CBOOL
																																																									(BGl_labelszd2symzf3z21zzast_labelsz00
																																																									(BgL_arg3361z00_3871));
																																																							}
																																																							if (BgL_test8591z00_17426)
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_17431;
																																																									goto
																																																										BgL_tagzd2384zd2_1735;
																																																									BgL_auxz00_14266
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_17431);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_carzd210918zd2_3768;
																																																									BgL_carzd210918zd2_3768
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd210923zd2_3769;
																																																										BgL_cdrzd210923zd2_3769
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_carzd210918zd2_3768));
																																																										if ((CAR(((obj_t) BgL_carzd210918zd2_3768)) == CNST_TABLE_REF(((long) 3))))
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_arg3278z00_3772;
																																																												obj_t
																																																													BgL_arg3281z00_3773;
																																																												obj_t
																																																													BgL_arg3282z00_3774;
																																																												BgL_arg3278z00_3772
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd210923zd2_3769));
																																																												BgL_arg3281z00_3773
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd210923zd2_3769));
																																																												BgL_arg3282z00_3774
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_17448;
																																																													{
																																																														obj_t
																																																															BgL_argsz00_17451;
																																																														obj_t
																																																															BgL_bodyz00_17450;
																																																														obj_t
																																																															BgL_varsz00_17449;
																																																														BgL_varsz00_17449
																																																															=
																																																															BgL_arg3278z00_3772;
																																																														BgL_bodyz00_17450
																																																															=
																																																															BgL_arg3281z00_3773;
																																																														BgL_argsz00_17451
																																																															=
																																																															BgL_arg3282z00_3774;
																																																														BgL_argsz00_1742
																																																															=
																																																															BgL_argsz00_17451;
																																																														BgL_bodyz00_1741
																																																															=
																																																															BgL_bodyz00_17450;
																																																														BgL_varsz00_1740
																																																															=
																																																															BgL_varsz00_17449;
																																																														goto
																																																															BgL_tagzd2386zd2_1743;
																																																													}
																																																													BgL_auxz00_14266
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_17448);
																																																												}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd210946zd2_3776;
																																																												BgL_cdrzd210946zd2_3776
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd210952zd2_3777;
																																																													BgL_cdrzd210952zd2_3777
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_carzd210918zd2_3768));
																																																													if ((CAR(((obj_t) BgL_carzd210918zd2_3768)) == CNST_TABLE_REF(((long) 1))))
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd210958zd2_3780;
																																																															BgL_cdrzd210958zd2_3780
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd210952zd2_3777));
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_carzd210963zd2_3781;
																																																																obj_t
																																																																	BgL_cdrzd210964zd2_3782;
																																																																BgL_carzd210963zd2_3781
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd210958zd2_3780));
																																																																BgL_cdrzd210964zd2_3782
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd210958zd2_3780));
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd210963zd2_3781))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (PAIRP(BgL_cdrzd210964zd2_3782))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_carzd210971zd2_3785;
																																																																				BgL_carzd210971zd2_3785
																																																																					=
																																																																					CAR
																																																																					(BgL_cdrzd210964zd2_3782);
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd210971zd2_3785))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (NULLP(CDR(BgL_cdrzd210964zd2_3782)))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								bool_t
																																																																									BgL_test8598z00_17478;
																																																																								{
																																																																									obj_t
																																																																										BgL_l1384z00_3818;
																																																																									BgL_l1384z00_3818
																																																																										=
																																																																										BgL_cdrzd210946zd2_3776;
																																																																								BgL_zc3z04anonymousza33315ze3z87_3819:
																																																																									if (NULLP(BgL_l1384z00_3818))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											BgL_test8598z00_17478
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												1);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											bool_t
																																																																												BgL_test8600z00_17481;
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												bool_t
																																																																													BgL_test8601z00_17482;
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_tmpz00_17483;
																																																																													BgL_tmpz00_17483
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_l1384z00_3818));
																																																																													BgL_test8601z00_17482
																																																																														=
																																																																														PAIRP
																																																																														(BgL_tmpz00_17483);
																																																																												}
																																																																												if (BgL_test8601z00_17482)
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														BgL_test8600z00_17481
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															0);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														BgL_test8600z00_17481
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															1);
																																																																													}
																																																																											}
																																																																											if (BgL_test8600z00_17481)
																																																																												{
																																																																													obj_t
																																																																														BgL_l1384z00_17487;
																																																																													BgL_l1384z00_17487
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_l1384z00_3818));
																																																																													BgL_l1384z00_3818
																																																																														=
																																																																														BgL_l1384z00_17487;
																																																																													goto
																																																																														BgL_zc3z04anonymousza33315ze3z87_3819;
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													BgL_test8598z00_17478
																																																																														=
																																																																														(
																																																																														(bool_t)
																																																																														0);
																																																																												}
																																																																										}
																																																																								}
																																																																								if (BgL_test8598z00_17478)
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_arg3303z00_3801;
																																																																										BgL_arg3303z00_3801
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd210952zd2_3777));
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_17492;
																																																																											{
																																																																												obj_t
																																																																													BgL_argsz00_17496;
																																																																												obj_t
																																																																													BgL_proc2z00_17495;
																																																																												obj_t
																																																																													BgL_proc1z00_17494;
																																																																												obj_t
																																																																													BgL_testz00_17493;
																																																																												BgL_testz00_17493
																																																																													=
																																																																													BgL_arg3303z00_3801;
																																																																												BgL_proc1z00_17494
																																																																													=
																																																																													BgL_carzd210963zd2_3781;
																																																																												BgL_proc2z00_17495
																																																																													=
																																																																													BgL_carzd210971zd2_3785;
																																																																												BgL_argsz00_17496
																																																																													=
																																																																													BgL_cdrzd210946zd2_3776;
																																																																												BgL_argsz00_1747
																																																																													=
																																																																													BgL_argsz00_17496;
																																																																												BgL_proc2z00_1746
																																																																													=
																																																																													BgL_proc2z00_17495;
																																																																												BgL_proc1z00_1745
																																																																													=
																																																																													BgL_proc1z00_17494;
																																																																												BgL_testz00_1744
																																																																													=
																																																																													BgL_testz00_17493;
																																																																												goto
																																																																													BgL_tagzd2387zd2_1748;
																																																																											}
																																																																											BgL_auxz00_14266
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_17492);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd210995zd2_3802;
																																																																										BgL_cdrzd210995zd2_3802
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd211002zd2_3803;
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_pairz00_10701;
																																																																												BgL_pairz00_10701
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												BgL_cdrzd211002zd2_3803
																																																																													=
																																																																													CDR
																																																																													(BgL_pairz00_10701);
																																																																											}
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_cdrzd211009zd2_3804;
																																																																												BgL_cdrzd211009zd2_3804
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd211002zd2_3803));
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_carzd211015zd2_3805;
																																																																													BgL_carzd211015zd2_3805
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd211009zd2_3804));
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd211015zd2_3805))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_carzd211022zd2_3807;
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_pairz00_10705;
																																																																																BgL_pairz00_10705
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd211009zd2_3804));
																																																																																BgL_carzd211022zd2_3807
																																																																																	=
																																																																																	CAR
																																																																																	(BgL_pairz00_10705);
																																																																															}
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd211022zd2_3807))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd210995zd2_3802))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_arg3308z00_3810;
																																																																																			BgL_arg3308z00_3810
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd211002zd2_3803));
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_17518;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_17522;
																																																																																					obj_t
																																																																																						BgL_proc2z00_17521;
																																																																																					obj_t
																																																																																						BgL_proc1z00_17520;
																																																																																					obj_t
																																																																																						BgL_testz00_17519;
																																																																																					BgL_testz00_17519
																																																																																						=
																																																																																						BgL_arg3308z00_3810;
																																																																																					BgL_proc1z00_17520
																																																																																						=
																																																																																						BgL_carzd211015zd2_3805;
																																																																																					BgL_proc2z00_17521
																																																																																						=
																																																																																						BgL_carzd211022zd2_3807;
																																																																																					BgL_argsz00_17522
																																																																																						=
																																																																																						BgL_cdrzd210995zd2_3802;
																																																																																					BgL_argsz00_1752
																																																																																						=
																																																																																						BgL_argsz00_17522;
																																																																																					BgL_proc2z00_1751
																																																																																						=
																																																																																						BgL_proc2z00_17521;
																																																																																					BgL_proc1z00_1750
																																																																																						=
																																																																																						BgL_proc1z00_17520;
																																																																																					BgL_testz00_1749
																																																																																						=
																																																																																						BgL_testz00_17519;
																																																																																					goto
																																																																																						BgL_tagzd2388zd2_1753;
																																																																																				}
																																																																																				BgL_auxz00_14266
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_17518);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1777;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_17526;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1778;
																																																																																					BgL_auxz00_14266
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_17526);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1777;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_17530;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1778;
																																																																																			BgL_auxz00_14266
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_17530);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1777;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_17534;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1778;
																																																																																	BgL_auxz00_14266
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_17534);
																																																																																}
																																																																														}
																																																																												}
																																																																											}
																																																																										}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1777;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_17538;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1778;
																																																																										BgL_auxz00_14266
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_17538);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd211298zd2_3829;
																																																																						BgL_cdrzd211298zd2_3829
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd211304zd2_3830;
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_pairz00_10709;
																																																																								BgL_pairz00_10709
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								BgL_cdrzd211304zd2_3830
																																																																									=
																																																																									CDR
																																																																									(BgL_pairz00_10709);
																																																																							}
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd211310zd2_3831;
																																																																								BgL_cdrzd211310zd2_3831
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd211304zd2_3830));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd211315zd2_3832;
																																																																									obj_t
																																																																										BgL_cdrzd211316zd2_3833;
																																																																									BgL_carzd211315zd2_3832
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd211310zd2_3831));
																																																																									BgL_cdrzd211316zd2_3833
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd211310zd2_3831));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd211315zd2_3832))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd211321zd2_3835;
																																																																											BgL_carzd211321zd2_3835
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd211316zd2_3833));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd211321zd2_3835))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (NULLP(CDR(((obj_t) BgL_cdrzd211316zd2_3833))))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd211298zd2_3829))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_arg3327z00_3840;
																																																																																	BgL_arg3327z00_3840
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd211304zd2_3830));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_17565;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_17569;
																																																																																			obj_t
																																																																																				BgL_proc2z00_17568;
																																																																																			obj_t
																																																																																				BgL_proc1z00_17567;
																																																																																			obj_t
																																																																																				BgL_testz00_17566;
																																																																																			BgL_testz00_17566
																																																																																				=
																																																																																				BgL_arg3327z00_3840;
																																																																																			BgL_proc1z00_17567
																																																																																				=
																																																																																				BgL_carzd211315zd2_3832;
																																																																																			BgL_proc2z00_17568
																																																																																				=
																																																																																				BgL_carzd211321zd2_3835;
																																																																																			BgL_argsz00_17569
																																																																																				=
																																																																																				BgL_cdrzd211298zd2_3829;
																																																																																			BgL_argsz00_1752
																																																																																				=
																																																																																				BgL_argsz00_17569;
																																																																																			BgL_proc2z00_1751
																																																																																				=
																																																																																				BgL_proc2z00_17568;
																																																																																			BgL_proc1z00_1750
																																																																																				=
																																																																																				BgL_proc1z00_17567;
																																																																																			BgL_testz00_1749
																																																																																				=
																																																																																				BgL_testz00_17566;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1753;
																																																																																		}
																																																																																		BgL_auxz00_14266
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_17565);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1777;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_17573;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1778;
																																																																																			BgL_auxz00_14266
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_17573);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1777;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_17577;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1778;
																																																																																	BgL_auxz00_14266
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_17577);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1777;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_17581;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1778;
																																																																															BgL_auxz00_14266
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_17581);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1777;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_17585;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1778;
																																																																													BgL_auxz00_14266
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_17585);
																																																																												}
																																																																										}
																																																																								}
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1777;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_17589;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1778;
																																																																						BgL_auxz00_14266
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_17589);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd211654zd2_3848;
																																																																		BgL_cdrzd211654zd2_3848
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd211661zd2_3849;
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_pairz00_10719;
																																																																				BgL_pairz00_10719
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				BgL_cdrzd211661zd2_3849
																																																																					=
																																																																					CDR
																																																																					(BgL_pairz00_10719);
																																																																			}
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd211668zd2_3850;
																																																																				BgL_cdrzd211668zd2_3850
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd211661zd2_3849));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_carzd211674zd2_3851;
																																																																					obj_t
																																																																						BgL_cdrzd211675zd2_3852;
																																																																					BgL_carzd211674zd2_3851
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd211668zd2_3850));
																																																																					BgL_cdrzd211675zd2_3852
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd211668zd2_3850));
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd211674zd2_3851))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (PAIRP(BgL_cdrzd211675zd2_3852))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd211682zd2_3855;
																																																																									BgL_carzd211682zd2_3855
																																																																										=
																																																																										CAR
																																																																										(BgL_cdrzd211675zd2_3852);
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd211682zd2_3855))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (NULLP(CDR(BgL_cdrzd211675zd2_3852)))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd211654zd2_3848))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg3342z00_3860;
																																																																															BgL_arg3342z00_3860
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd211661zd2_3849));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_17616;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_17620;
																																																																																	obj_t
																																																																																		BgL_proc2z00_17619;
																																																																																	obj_t
																																																																																		BgL_proc1z00_17618;
																																																																																	obj_t
																																																																																		BgL_testz00_17617;
																																																																																	BgL_testz00_17617
																																																																																		=
																																																																																		BgL_arg3342z00_3860;
																																																																																	BgL_proc1z00_17618
																																																																																		=
																																																																																		BgL_carzd211674zd2_3851;
																																																																																	BgL_proc2z00_17619
																																																																																		=
																																																																																		BgL_carzd211682zd2_3855;
																																																																																	BgL_argsz00_17620
																																																																																		=
																																																																																		BgL_cdrzd211654zd2_3848;
																																																																																	BgL_argsz00_1752
																																																																																		=
																																																																																		BgL_argsz00_17620;
																																																																																	BgL_proc2z00_1751
																																																																																		=
																																																																																		BgL_proc2z00_17619;
																																																																																	BgL_proc1z00_1750
																																																																																		=
																																																																																		BgL_proc1z00_17618;
																																																																																	BgL_testz00_1749
																																																																																		=
																																																																																		BgL_testz00_17617;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1753;
																																																																																}
																																																																																BgL_auxz00_14266
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_17616);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1777;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_17624;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1778;
																																																																																	BgL_auxz00_14266
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_17624);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1777;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_17628;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1778;
																																																																															BgL_auxz00_14266
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_17628);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1777;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_17632;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1778;
																																																																													BgL_auxz00_14266
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_17632);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1777;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_17636;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1778;
																																																																											BgL_auxz00_14266
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_17636);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1777;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_17640;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1778;
																																																																									BgL_auxz00_14266
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_17640);
																																																																								}
																																																																						}
																																																																				}
																																																																			}
																																																																		}
																																																																	}
																																																															}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1777;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_17644;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1778;
																																																																	BgL_auxz00_14266
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_17644);
																																																																}
																																																														}
																																																												}
																																																											}
																																																									}
																																																								}
																																																						}
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_cdrzd212075zd2_3874;
																																																		BgL_cdrzd212075zd2_3874
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 119 */
																																																			bool_t
																																																				BgL_test8629z00_17648;
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg3384z00_3891;
																																																				BgL_arg3384z00_3891
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test8629z00_17648
																																																					=
																																																					CBOOL
																																																					(BGl_letzd2symzf3z21zzast_letz00
																																																					(BgL_arg3384z00_3891));
																																																			}
																																																			if (BgL_test8629z00_17648)
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_arg3368z00_3877;
																																																					obj_t
																																																						BgL_arg3369z00_3878;
																																																					BgL_arg3368z00_3877
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd212075zd2_3874));
																																																					BgL_arg3369z00_3878
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd212075zd2_3874));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_17657;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_17659;
																																																							obj_t
																																																								BgL_bindingsz00_17658;
																																																							BgL_bindingsz00_17658
																																																								=
																																																								BgL_arg3368z00_3877;
																																																							BgL_exprz00_17659
																																																								=
																																																								BgL_arg3369z00_3878;
																																																							BgL_exprz00_1732
																																																								=
																																																								BgL_exprz00_17659;
																																																							BgL_bindingsz00_1731
																																																								=
																																																								BgL_bindingsz00_17658;
																																																							goto
																																																								BgL_tagzd2382zd2_1733;
																																																						}
																																																						BgL_auxz00_14266
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_17657);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					bool_t
																																																						BgL_test8630z00_17661;
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg3383z00_3890;
																																																						BgL_arg3383z00_3890
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test8630z00_17661
																																																							=
																																																							CBOOL
																																																							(BGl_labelszd2symzf3z21zzast_labelsz00
																																																							(BgL_arg3383z00_3890));
																																																					}
																																																					if (BgL_test8630z00_17661)
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_17666;
																																																							goto
																																																								BgL_tagzd2384zd2_1735;
																																																							BgL_auxz00_14266
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_17666);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_carzd212141zd2_3881;
																																																							BgL_carzd212141zd2_3881
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd212146zd2_3882;
																																																								BgL_cdrzd212146zd2_3882
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_carzd212141zd2_3881));
																																																								if ((CAR(((obj_t) BgL_carzd212141zd2_3881)) == CNST_TABLE_REF(((long) 3))))
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg3374z00_3885;
																																																										obj_t
																																																											BgL_arg3375z00_3886;
																																																										obj_t
																																																											BgL_arg3379z00_3887;
																																																										BgL_arg3374z00_3885
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_cdrzd212146zd2_3882));
																																																										BgL_arg3375z00_3886
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_cdrzd212146zd2_3882));
																																																										BgL_arg3379z00_3887
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_17683;
																																																											{
																																																												obj_t
																																																													BgL_argsz00_17686;
																																																												obj_t
																																																													BgL_bodyz00_17685;
																																																												obj_t
																																																													BgL_varsz00_17684;
																																																												BgL_varsz00_17684
																																																													=
																																																													BgL_arg3374z00_3885;
																																																												BgL_bodyz00_17685
																																																													=
																																																													BgL_arg3375z00_3886;
																																																												BgL_argsz00_17686
																																																													=
																																																													BgL_arg3379z00_3887;
																																																												BgL_argsz00_1742
																																																													=
																																																													BgL_argsz00_17686;
																																																												BgL_bodyz00_1741
																																																													=
																																																													BgL_bodyz00_17685;
																																																												BgL_varsz00_1740
																																																													=
																																																													BgL_varsz00_17684;
																																																												goto
																																																													BgL_tagzd2386zd2_1743;
																																																											}
																																																											BgL_auxz00_14266
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_17683);
																																																										}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 119 */
																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																											{	/* Ast/sexp.scm 119 */
																																																												goto
																																																													BgL_tagzd2403zd2_1777;
																																																											}
																																																										else
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_17690;
																																																												goto
																																																													BgL_tagzd2404zd2_1778;
																																																												BgL_auxz00_14266
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_17690);
																																																											}
																																																									}
																																																							}
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_cdrzd212257zd2_3892;
																																																BgL_cdrzd212257zd2_3892
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 119 */
																																																	bool_t
																																																		BgL_test8633z00_17694;
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_arg3396z00_3901;
																																																		BgL_arg3396z00_3901
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_test8633z00_17694
																																																			=
																																																			CBOOL
																																																			(BGl_letzd2symzf3z21zzast_letz00
																																																			(BgL_arg3396z00_3901));
																																																	}
																																																	if (BgL_test8633z00_17694)
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg3389z00_3895;
																																																			obj_t
																																																				BgL_arg3390z00_3896;
																																																			BgL_arg3389z00_3895
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd212257zd2_3892));
																																																			BgL_arg3390z00_3896
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd212257zd2_3892));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_17703;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_17705;
																																																					obj_t
																																																						BgL_bindingsz00_17704;
																																																					BgL_bindingsz00_17704
																																																						=
																																																						BgL_arg3389z00_3895;
																																																					BgL_exprz00_17705
																																																						=
																																																						BgL_arg3390z00_3896;
																																																					BgL_exprz00_1732
																																																						=
																																																						BgL_exprz00_17705;
																																																					BgL_bindingsz00_1731
																																																						=
																																																						BgL_bindingsz00_17704;
																																																					goto
																																																						BgL_tagzd2382zd2_1733;
																																																				}
																																																				BgL_auxz00_14266
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_17703);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			bool_t
																																																				BgL_test8634z00_17707;
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg3395z00_3900;
																																																				BgL_arg3395z00_3900
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test8634z00_17707
																																																					=
																																																					CBOOL
																																																					(BGl_labelszd2symzf3z21zzast_labelsz00
																																																					(BgL_arg3395z00_3900));
																																																			}
																																																			if (BgL_test8634z00_17707)
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_17712;
																																																					goto
																																																						BgL_tagzd2384zd2_1735;
																																																					BgL_auxz00_14266
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_17712);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																						{	/* Ast/sexp.scm 119 */
																																																							goto
																																																								BgL_tagzd2403zd2_1777;
																																																						}
																																																					else
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_17716;
																																																							goto
																																																								BgL_tagzd2404zd2_1778;
																																																							BgL_auxz00_14266
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_17716);
																																																						}
																																																				}
																																																		}
																																																}
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd210822zd2_3628)))
																																															{	/* Ast/sexp.scm 119 */
																																																goto
																																																	BgL_kapzd210824zd2_3630;
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																if ((BgL_carzd210822zd2_3628 == CNST_TABLE_REF(((long) 18))))
																																																	{	/* Ast/sexp.scm 119 */
																																																		goto
																																																			BgL_kapzd210824zd2_3630;
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		if ((BgL_carzd210822zd2_3628 == CNST_TABLE_REF(((long) 19))))
																																																			{	/* Ast/sexp.scm 119 */
																																																				goto
																																																					BgL_kapzd210824zd2_3630;
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd210822zd2_3628)))
																																																					{	/* Ast/sexp.scm 119 */
																																																						goto
																																																							BgL_kapzd210824zd2_3630;
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd212429zd2_3636;
																																																						BgL_cdrzd212429zd2_3636
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{	/* Ast/sexp.scm 119 */
																																																							bool_t
																																																								BgL_test8640z00_17732;
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg3258z00_3753;
																																																								BgL_arg3258z00_3753
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test8640z00_17732
																																																									=
																																																									CBOOL
																																																									(BGl_letzd2symzf3z21zzast_letz00
																																																									(BgL_arg3258z00_3753));
																																																							}
																																																							if (BgL_test8640z00_17732)
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_arg3168z00_3639;
																																																									obj_t
																																																										BgL_arg3169z00_3640;
																																																									BgL_arg3168z00_3639
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd212429zd2_3636));
																																																									BgL_arg3169z00_3640
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd212429zd2_3636));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_17741;
																																																										{
																																																											obj_t
																																																												BgL_exprz00_17743;
																																																											obj_t
																																																												BgL_bindingsz00_17742;
																																																											BgL_bindingsz00_17742
																																																												=
																																																												BgL_arg3168z00_3639;
																																																											BgL_exprz00_17743
																																																												=
																																																												BgL_arg3169z00_3640;
																																																											BgL_exprz00_1732
																																																												=
																																																												BgL_exprz00_17743;
																																																											BgL_bindingsz00_1731
																																																												=
																																																												BgL_bindingsz00_17742;
																																																											goto
																																																												BgL_tagzd2382zd2_1733;
																																																										}
																																																										BgL_auxz00_14266
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_17741);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									bool_t
																																																										BgL_test8641z00_17745;
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg3257z00_3752;
																																																										BgL_arg3257z00_3752
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_test8641z00_17745
																																																											=
																																																											CBOOL
																																																											(BGl_labelszd2symzf3z21zzast_labelsz00
																																																											(BgL_arg3257z00_3752));
																																																									}
																																																									if (BgL_test8641z00_17745)
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_17750;
																																																											goto
																																																												BgL_tagzd2384zd2_1735;
																																																											BgL_auxz00_14266
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_17750);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_carzd212495zd2_3643;
																																																											BgL_carzd212495zd2_3643
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd212500zd2_3644;
																																																												BgL_cdrzd212500zd2_3644
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_carzd212495zd2_3643));
																																																												if ((CAR(((obj_t) BgL_carzd212495zd2_3643)) == CNST_TABLE_REF(((long) 3))))
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (PAIRP(BgL_cdrzd212500zd2_3644))
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_arg3177z00_3648;
																																																																obj_t
																																																																	BgL_arg3178z00_3649;
																																																																obj_t
																																																																	BgL_arg3179z00_3650;
																																																																BgL_arg3177z00_3648
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd212500zd2_3644);
																																																																BgL_arg3178z00_3649
																																																																	=
																																																																	CDR
																																																																	(BgL_cdrzd212500zd2_3644);
																																																																BgL_arg3179z00_3650
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_17767;
																																																																	{
																																																																		obj_t
																																																																			BgL_argsz00_17770;
																																																																		obj_t
																																																																			BgL_bodyz00_17769;
																																																																		obj_t
																																																																			BgL_varsz00_17768;
																																																																		BgL_varsz00_17768
																																																																			=
																																																																			BgL_arg3177z00_3648;
																																																																		BgL_bodyz00_17769
																																																																			=
																																																																			BgL_arg3178z00_3649;
																																																																		BgL_argsz00_17770
																																																																			=
																																																																			BgL_arg3179z00_3650;
																																																																		BgL_argsz00_1742
																																																																			=
																																																																			BgL_argsz00_17770;
																																																																		BgL_bodyz00_1741
																																																																			=
																																																																			BgL_bodyz00_17769;
																																																																		BgL_varsz00_1740
																																																																			=
																																																																			BgL_varsz00_17768;
																																																																		goto
																																																																			BgL_tagzd2386zd2_1743;
																																																																	}
																																																																	BgL_auxz00_14266
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_17767);
																																																																}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1777;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_17774;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1778;
																																																																		BgL_auxz00_14266
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_17774);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd212607zd2_3653;
																																																														BgL_cdrzd212607zd2_3653
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd212612zd2_3654;
																																																															BgL_cdrzd212612zd2_3654
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_carzd212495zd2_3643));
																																																															if ((CAR(((obj_t) BgL_carzd212495zd2_3643)) == CNST_TABLE_REF(((long) 1))))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (PAIRP(BgL_cdrzd212612zd2_3654))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd212617zd2_3658;
																																																																			BgL_cdrzd212617zd2_3658
																																																																				=
																																																																				CDR
																																																																				(BgL_cdrzd212612zd2_3654);
																																																																			if (PAIRP(BgL_cdrzd212617zd2_3658))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_carzd212621zd2_3660;
																																																																					obj_t
																																																																						BgL_cdrzd212622zd2_3661;
																																																																					BgL_carzd212621zd2_3660
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd212617zd2_3658);
																																																																					BgL_cdrzd212622zd2_3661
																																																																						=
																																																																						CDR
																																																																						(BgL_cdrzd212617zd2_3658);
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd212621zd2_3660))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (PAIRP(BgL_cdrzd212622zd2_3661))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd212627zd2_3664;
																																																																									BgL_carzd212627zd2_3664
																																																																										=
																																																																										CAR
																																																																										(BgL_cdrzd212622zd2_3661);
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd212627zd2_3664))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (NULLP(CDR(BgL_cdrzd212622zd2_3661)))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													bool_t
																																																																														BgL_test8652z00_17802;
																																																																													{
																																																																														obj_t
																																																																															BgL_l1387z00_3697;
																																																																														BgL_l1387z00_3697
																																																																															=
																																																																															BgL_cdrzd212607zd2_3653;
																																																																													BgL_zc3z04anonymousza33213ze3z87_3698:
																																																																														if (NULLP(BgL_l1387z00_3697))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																BgL_test8652z00_17802
																																																																																	=
																																																																																	(
																																																																																	(bool_t)
																																																																																	1);
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																bool_t
																																																																																	BgL_test8654z00_17805;
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	bool_t
																																																																																		BgL_test8655z00_17806;
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_tmpz00_17807;
																																																																																		BgL_tmpz00_17807
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_l1387z00_3697));
																																																																																		BgL_test8655z00_17806
																																																																																			=
																																																																																			PAIRP
																																																																																			(BgL_tmpz00_17807);
																																																																																	}
																																																																																	if (BgL_test8655z00_17806)
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			BgL_test8654z00_17805
																																																																																				=
																																																																																				(
																																																																																				(bool_t)
																																																																																				0);
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			BgL_test8654z00_17805
																																																																																				=
																																																																																				(
																																																																																				(bool_t)
																																																																																				1);
																																																																																		}
																																																																																}
																																																																																if (BgL_test8654z00_17805)
																																																																																	{
																																																																																		obj_t
																																																																																			BgL_l1387z00_17811;
																																																																																		BgL_l1387z00_17811
																																																																																			=
																																																																																			CDR
																																																																																			(
																																																																																			((obj_t) BgL_l1387z00_3697));
																																																																																		BgL_l1387z00_3697
																																																																																			=
																																																																																			BgL_l1387z00_17811;
																																																																																		goto
																																																																																			BgL_zc3z04anonymousza33213ze3z87_3698;
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		BgL_test8652z00_17802
																																																																																			=
																																																																																			(
																																																																																			(bool_t)
																																																																																			0);
																																																																																	}
																																																																															}
																																																																													}
																																																																													if (BgL_test8652z00_17802)
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg3202z00_3680;
																																																																															BgL_arg3202z00_3680
																																																																																=
																																																																																CAR
																																																																																(BgL_cdrzd212612zd2_3654);
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_17815;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_17819;
																																																																																	obj_t
																																																																																		BgL_proc2z00_17818;
																																																																																	obj_t
																																																																																		BgL_proc1z00_17817;
																																																																																	obj_t
																																																																																		BgL_testz00_17816;
																																																																																	BgL_testz00_17816
																																																																																		=
																																																																																		BgL_arg3202z00_3680;
																																																																																	BgL_proc1z00_17817
																																																																																		=
																																																																																		BgL_carzd212621zd2_3660;
																																																																																	BgL_proc2z00_17818
																																																																																		=
																																																																																		BgL_carzd212627zd2_3664;
																																																																																	BgL_argsz00_17819
																																																																																		=
																																																																																		BgL_cdrzd212607zd2_3653;
																																																																																	BgL_argsz00_1747
																																																																																		=
																																																																																		BgL_argsz00_17819;
																																																																																	BgL_proc2z00_1746
																																																																																		=
																																																																																		BgL_proc2z00_17818;
																																																																																	BgL_proc1z00_1745
																																																																																		=
																																																																																		BgL_proc1z00_17817;
																																																																																	BgL_testz00_1744
																																																																																		=
																																																																																		BgL_testz00_17816;
																																																																																	goto
																																																																																		BgL_tagzd2387zd2_1748;
																																																																																}
																																																																																BgL_auxz00_14266
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_17815);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_cdrzd212652zd2_3681;
																																																																															BgL_cdrzd212652zd2_3681
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_cdrzd212660zd2_3682;
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_pairz00_10776;
																																																																																	BgL_pairz00_10776
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_expz00_21));
																																																																																	BgL_cdrzd212660zd2_3682
																																																																																		=
																																																																																		CDR
																																																																																		(BgL_pairz00_10776);
																																																																																}
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_cdrzd212668zd2_3683;
																																																																																	BgL_cdrzd212668zd2_3683
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd212660zd2_3682));
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_carzd212675zd2_3684;
																																																																																		BgL_carzd212675zd2_3684
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd212668zd2_3683));
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd212675zd2_3684))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_carzd212684zd2_3686;
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					obj_t
																																																																																						BgL_pairz00_10780;
																																																																																					BgL_pairz00_10780
																																																																																						=
																																																																																						CDR
																																																																																						(
																																																																																						((obj_t) BgL_cdrzd212668zd2_3683));
																																																																																					BgL_carzd212684zd2_3686
																																																																																						=
																																																																																						CAR
																																																																																						(BgL_pairz00_10780);
																																																																																				}
																																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd212684zd2_3686))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd212652zd2_3681))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								obj_t
																																																																																									BgL_arg3206z00_3689;
																																																																																								BgL_arg3206z00_3689
																																																																																									=
																																																																																									CAR
																																																																																									(
																																																																																									((obj_t) BgL_cdrzd212660zd2_3682));
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_17841;
																																																																																									{
																																																																																										obj_t
																																																																																											BgL_argsz00_17845;
																																																																																										obj_t
																																																																																											BgL_proc2z00_17844;
																																																																																										obj_t
																																																																																											BgL_proc1z00_17843;
																																																																																										obj_t
																																																																																											BgL_testz00_17842;
																																																																																										BgL_testz00_17842
																																																																																											=
																																																																																											BgL_arg3206z00_3689;
																																																																																										BgL_proc1z00_17843
																																																																																											=
																																																																																											BgL_carzd212675zd2_3684;
																																																																																										BgL_proc2z00_17844
																																																																																											=
																																																																																											BgL_carzd212684zd2_3686;
																																																																																										BgL_argsz00_17845
																																																																																											=
																																																																																											BgL_cdrzd212652zd2_3681;
																																																																																										BgL_argsz00_1752
																																																																																											=
																																																																																											BgL_argsz00_17845;
																																																																																										BgL_proc2z00_1751
																																																																																											=
																																																																																											BgL_proc2z00_17844;
																																																																																										BgL_proc1z00_1750
																																																																																											=
																																																																																											BgL_proc1z00_17843;
																																																																																										BgL_testz00_1749
																																																																																											=
																																																																																											BgL_testz00_17842;
																																																																																										goto
																																																																																											BgL_tagzd2388zd2_1753;
																																																																																									}
																																																																																									BgL_auxz00_14266
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_17841);
																																																																																								}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1777;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_17849;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1778;
																																																																																										BgL_auxz00_14266
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_17849);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1777;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_17853;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1778;
																																																																																								BgL_auxz00_14266
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_17853);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1777;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_17857;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1778;
																																																																																						BgL_auxz00_14266
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_17857);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																}
																																																																															}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1777;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_17861;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1778;
																																																																															BgL_auxz00_14266
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_17861);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd212962zd2_3708;
																																																																											BgL_cdrzd212962zd2_3708
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_cdrzd212969zd2_3709;
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_pairz00_10784;
																																																																													BgL_pairz00_10784
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													BgL_cdrzd212969zd2_3709
																																																																														=
																																																																														CDR
																																																																														(BgL_pairz00_10784);
																																																																												}
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd212976zd2_3710;
																																																																													BgL_cdrzd212976zd2_3710
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd212969zd2_3709));
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_carzd212982zd2_3711;
																																																																														obj_t
																																																																															BgL_cdrzd212983zd2_3712;
																																																																														BgL_carzd212982zd2_3711
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd212976zd2_3710));
																																																																														BgL_cdrzd212983zd2_3712
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd212976zd2_3710));
																																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd212982zd2_3711))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_carzd212990zd2_3714;
																																																																																BgL_carzd212990zd2_3714
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd212983zd2_3712));
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd212990zd2_3714))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (NULLP(CDR(((obj_t) BgL_cdrzd212983zd2_3712))))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd212962zd2_3708))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						obj_t
																																																																																							BgL_arg3227z00_3719;
																																																																																						BgL_arg3227z00_3719
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd212969zd2_3709));
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_17888;
																																																																																							{
																																																																																								obj_t
																																																																																									BgL_argsz00_17892;
																																																																																								obj_t
																																																																																									BgL_proc2z00_17891;
																																																																																								obj_t
																																																																																									BgL_proc1z00_17890;
																																																																																								obj_t
																																																																																									BgL_testz00_17889;
																																																																																								BgL_testz00_17889
																																																																																									=
																																																																																									BgL_arg3227z00_3719;
																																																																																								BgL_proc1z00_17890
																																																																																									=
																																																																																									BgL_carzd212982zd2_3711;
																																																																																								BgL_proc2z00_17891
																																																																																									=
																																																																																									BgL_carzd212990zd2_3714;
																																																																																								BgL_argsz00_17892
																																																																																									=
																																																																																									BgL_cdrzd212962zd2_3708;
																																																																																								BgL_argsz00_1752
																																																																																									=
																																																																																									BgL_argsz00_17892;
																																																																																								BgL_proc2z00_1751
																																																																																									=
																																																																																									BgL_proc2z00_17891;
																																																																																								BgL_proc1z00_1750
																																																																																									=
																																																																																									BgL_proc1z00_17890;
																																																																																								BgL_testz00_1749
																																																																																									=
																																																																																									BgL_testz00_17889;
																																																																																								goto
																																																																																									BgL_tagzd2388zd2_1753;
																																																																																							}
																																																																																							BgL_auxz00_14266
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_17888);
																																																																																						}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1777;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_17896;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1778;
																																																																																								BgL_auxz00_14266
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_17896);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1777;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_17900;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1778;
																																																																																						BgL_auxz00_14266
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_17900);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1777;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_17904;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1778;
																																																																																				BgL_auxz00_14266
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_17904);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1777;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_17908;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1778;
																																																																																		BgL_auxz00_14266
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_17908);
																																																																																	}
																																																																															}
																																																																													}
																																																																												}
																																																																											}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1777;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_17912;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1778;
																																																																											BgL_auxz00_14266
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_17912);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd213323zd2_3727;
																																																																							BgL_cdrzd213323zd2_3727
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd213329zd2_3728;
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_pairz00_10794;
																																																																									BgL_pairz00_10794
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									BgL_cdrzd213329zd2_3728
																																																																										=
																																																																										CDR
																																																																										(BgL_pairz00_10794);
																																																																								}
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd213335zd2_3729;
																																																																									BgL_cdrzd213335zd2_3729
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd213329zd2_3728));
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_carzd213340zd2_3730;
																																																																										obj_t
																																																																											BgL_cdrzd213341zd2_3731;
																																																																										BgL_carzd213340zd2_3730
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd213335zd2_3729));
																																																																										BgL_cdrzd213341zd2_3731
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd213335zd2_3729));
																																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd213340zd2_3730))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (PAIRP(BgL_cdrzd213341zd2_3731))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_carzd213346zd2_3734;
																																																																														BgL_carzd213346zd2_3734
																																																																															=
																																																																															CAR
																																																																															(BgL_cdrzd213341zd2_3731);
																																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd213346zd2_3734))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (NULLP(CDR(BgL_cdrzd213341zd2_3731)))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd213323zd2_3727))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_arg3241z00_3739;
																																																																																				BgL_arg3241z00_3739
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd213329zd2_3728));
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_17939;
																																																																																					{
																																																																																						obj_t
																																																																																							BgL_argsz00_17943;
																																																																																						obj_t
																																																																																							BgL_proc2z00_17942;
																																																																																						obj_t
																																																																																							BgL_proc1z00_17941;
																																																																																						obj_t
																																																																																							BgL_testz00_17940;
																																																																																						BgL_testz00_17940
																																																																																							=
																																																																																							BgL_arg3241z00_3739;
																																																																																						BgL_proc1z00_17941
																																																																																							=
																																																																																							BgL_carzd213340zd2_3730;
																																																																																						BgL_proc2z00_17942
																																																																																							=
																																																																																							BgL_carzd213346zd2_3734;
																																																																																						BgL_argsz00_17943
																																																																																							=
																																																																																							BgL_cdrzd213323zd2_3727;
																																																																																						BgL_argsz00_1752
																																																																																							=
																																																																																							BgL_argsz00_17943;
																																																																																						BgL_proc2z00_1751
																																																																																							=
																																																																																							BgL_proc2z00_17942;
																																																																																						BgL_proc1z00_1750
																																																																																							=
																																																																																							BgL_proc1z00_17941;
																																																																																						BgL_testz00_1749
																																																																																							=
																																																																																							BgL_testz00_17940;
																																																																																						goto
																																																																																							BgL_tagzd2388zd2_1753;
																																																																																					}
																																																																																					BgL_auxz00_14266
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_17939);
																																																																																				}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1777;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_17947;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1778;
																																																																																						BgL_auxz00_14266
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_17947);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1777;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_17951;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1778;
																																																																																				BgL_auxz00_14266
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_17951);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1777;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_17955;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1778;
																																																																																		BgL_auxz00_14266
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_17955);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1777;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_17959;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1778;
																																																																																BgL_auxz00_14266
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_17959);
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1777;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_17963;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1778;
																																																																														BgL_auxz00_14266
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_17963);
																																																																													}
																																																																											}
																																																																									}
																																																																								}
																																																																							}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1777;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_17967;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1778;
																																																																							BgL_auxz00_14266
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_17967);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1777;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_17971;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1778;
																																																																					BgL_auxz00_14266
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_17971);
																																																																				}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1777;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_17975;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1778;
																																																																			BgL_auxz00_14266
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_17975);
																																																																		}
																																																																}
																																																														}
																																																													}
																																																											}
																																																										}
																																																								}
																																																						}
																																																					}
																																																			}
																																																	}
																																															}
																																													}
																																											}
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											if ((BgL_carzd210819zd2_3626 == CNST_TABLE_REF(((long) 17))))
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_arg3398z00_3905;
																																													obj_t
																																														BgL_arg3399z00_3906;
																																													BgL_arg3398z00_3905
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_cdrzd210718zd2_3610));
																																													BgL_arg3399z00_3906
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_cdrzd210718zd2_3610));
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_17984;
																																														{
																																															obj_t
																																																BgL_exprz00_17986;
																																															obj_t
																																																BgL_bindingsz00_17985;
																																															BgL_bindingsz00_17985
																																																=
																																																BgL_arg3398z00_3905;
																																															BgL_exprz00_17986
																																																=
																																																BgL_arg3399z00_3906;
																																															BgL_exprz00_1732
																																																=
																																																BgL_exprz00_17986;
																																															BgL_bindingsz00_1731
																																																=
																																																BgL_bindingsz00_17985;
																																															goto
																																																BgL_tagzd2382zd2_1733;
																																														}
																																														BgL_auxz00_14266
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_17984);
																																													}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd210819zd2_3626)))
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg3401z00_3908;
																																															obj_t
																																																BgL_arg3402z00_3909;
																																															BgL_arg3401z00_3908
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd210718zd2_3610));
																																															BgL_arg3402z00_3909
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd210718zd2_3610));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_17995;
																																																{
																																																	obj_t
																																																		BgL_exprz00_17997;
																																																	obj_t
																																																		BgL_bindingsz00_17996;
																																																	BgL_bindingsz00_17996
																																																		=
																																																		BgL_arg3401z00_3908;
																																																	BgL_exprz00_17997
																																																		=
																																																		BgL_arg3402z00_3909;
																																																	BgL_exprz00_1732
																																																		=
																																																		BgL_exprz00_17997;
																																																	BgL_bindingsz00_1731
																																																		=
																																																		BgL_bindingsz00_17996;
																																																	goto
																																																		BgL_tagzd2382zd2_1733;
																																																}
																																																BgL_auxz00_14266
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_17995);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															if ((BgL_carzd210819zd2_3626 == CNST_TABLE_REF(((long) 18))))
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg3404z00_3911;
																																																	obj_t
																																																		BgL_arg3405z00_3912;
																																																	BgL_arg3404z00_3911
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd210718zd2_3610));
																																																	BgL_arg3405z00_3912
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd210718zd2_3610));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_18006;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_18008;
																																																			obj_t
																																																				BgL_bindingsz00_18007;
																																																			BgL_bindingsz00_18007
																																																				=
																																																				BgL_arg3404z00_3911;
																																																			BgL_exprz00_18008
																																																				=
																																																				BgL_arg3405z00_3912;
																																																			BgL_exprz00_1732
																																																				=
																																																				BgL_exprz00_18008;
																																																			BgL_bindingsz00_1731
																																																				=
																																																				BgL_bindingsz00_18007;
																																																			goto
																																																				BgL_tagzd2382zd2_1733;
																																																		}
																																																		BgL_auxz00_14266
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_18006);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_18015;
																																																			goto
																																																				BgL_tagzd2383zd2_1734;
																																																			BgL_auxz00_14266
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_18015);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_carzd213921zd2_3915;
																																																			BgL_carzd213921zd2_3915
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			if ((BgL_carzd213921zd2_3915 == CNST_TABLE_REF(((long) 19))))
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_18022;
																																																					goto
																																																						BgL_tagzd2384zd2_1735;
																																																					BgL_auxz00_14266
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_18022);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd213921zd2_3915)))
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_18027;
																																																							goto
																																																								BgL_tagzd2384zd2_1735;
																																																							BgL_auxz00_14266
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_18027);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_18034;
																																																									goto
																																																										BgL_tagzd2389zd2_1754;
																																																									BgL_auxz00_14266
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_18034);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_18041;
																																																											goto
																																																												BgL_tagzd2390zd2_1755;
																																																											BgL_auxz00_14266
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_18041);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_cdrzd214001zd2_3922;
																																																											BgL_cdrzd214001zd2_3922
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_arg3416z00_3925;
																																																													obj_t
																																																														BgL_arg3418z00_3926;
																																																													BgL_arg3416z00_3925
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_cdrzd214001zd2_3922));
																																																													BgL_arg3418z00_3926
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd214001zd2_3922));
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_18054;
																																																														{
																																																															obj_t
																																																																BgL_restz00_18056;
																																																															obj_t
																																																																BgL_effectz00_18055;
																																																															BgL_effectz00_18055
																																																																=
																																																																BgL_arg3416z00_3925;
																																																															BgL_restz00_18056
																																																																=
																																																																BgL_arg3418z00_3926;
																																																															BgL_restz00_1757
																																																																=
																																																																BgL_restz00_18056;
																																																															BgL_effectz00_1756
																																																																=
																																																																BgL_effectz00_18055;
																																																															goto
																																																																BgL_tagzd2391zd2_1758;
																																																														}
																																																														BgL_auxz00_14266
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_18054);
																																																													}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_18063;
																																																															goto
																																																																BgL_tagzd2392zd2_1759;
																																																															BgL_auxz00_14266
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_18063);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_18070;
																																																																	goto
																																																																		BgL_tagzd2393zd2_1760;
																																																																	BgL_auxz00_14266
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_18070);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_arg3426z00_3934;
																																																																			obj_t
																																																																				BgL_arg3427z00_3935;
																																																																			BgL_arg3426z00_3934
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd214001zd2_3922));
																																																																			BgL_arg3427z00_3935
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd214001zd2_3922));
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_18081;
																																																																				{
																																																																					obj_t
																																																																						BgL_restz00_18083;
																																																																					obj_t
																																																																						BgL_effectz00_18082;
																																																																					BgL_effectz00_18082
																																																																						=
																																																																						BgL_arg3426z00_3934;
																																																																					BgL_restz00_18083
																																																																						=
																																																																						BgL_arg3427z00_3935;
																																																																					BgL_restz00_1762
																																																																						=
																																																																						BgL_restz00_18083;
																																																																					BgL_effectz00_1761
																																																																						=
																																																																						BgL_effectz00_18082;
																																																																					goto
																																																																						BgL_tagzd2394zd2_1763;
																																																																				}
																																																																				BgL_auxz00_14266
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_18081);
																																																																			}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_18090;
																																																																					goto
																																																																						BgL_tagzd2395zd2_1764;
																																																																					BgL_auxz00_14266
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_18090);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_18097;
																																																																							goto
																																																																								BgL_tagzd2396zd2_1765;
																																																																							BgL_auxz00_14266
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_18097);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																								{
																																																																									BgL_letzd2funzd2_bglt
																																																																										BgL_auxz00_18104;
																																																																									goto
																																																																										BgL_tagzd2397zd2_1766;
																																																																									BgL_auxz00_14266
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_18104);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																										{
																																																																											BgL_jumpzd2exzd2itz00_bglt
																																																																												BgL_auxz00_18111;
																																																																											goto
																																																																												BgL_tagzd2398zd2_1767;
																																																																											BgL_auxz00_14266
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_18111);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 30))))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													bool_t
																																																																														BgL_test8702z00_18118;
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_tmpz00_18119;
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_pairz00_10832;
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_pairz00_10831;
																																																																																BgL_pairz00_10831
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_expz00_21));
																																																																																BgL_pairz00_10832
																																																																																	=
																																																																																	CDR
																																																																																	(BgL_pairz00_10831);
																																																																															}
																																																																															BgL_tmpz00_18119
																																																																																=
																																																																																CDR
																																																																																(BgL_pairz00_10832);
																																																																														}
																																																																														BgL_test8702z00_18118
																																																																															=
																																																																															NULLP
																																																																															(BgL_tmpz00_18119);
																																																																													}
																																																																													if (BgL_test8702z00_18118)
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_18125;
																																																																														BgL_tagzd2399zd2_1768:
																																																																															BgL_auxz00_18125 = BGl_applycationzd2ze3nodez31zzast_applyz00(BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																															BgL_auxz00_14266
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_18125);
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1777;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_18130;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1778;
																																																																																	BgL_auxz00_14266
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_18130);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd214094zd2_3954;
																																																																													BgL_cdrzd214094zd2_3954
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg3454z00_3957;
																																																																															obj_t
																																																																																BgL_arg3455z00_3958;
																																																																															BgL_arg3454z00_3957
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd214094zd2_3954));
																																																																															BgL_arg3455z00_3958
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_cdrzd214094zd2_3954));
																																																																															{	/* Ast/sexp.scm 552 */
																																																																																obj_t
																																																																																	BgL_arg6965z00_10838;
																																																																																BgL_arg6965z00_10838
																																																																																	=
																																																																																	BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																	(BgL_expz00_21,
																																																																																	BgL_locz00_23);
																																																																																BgL_auxz00_14266
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																	(BgL_expz00_21,
																																																																																		BgL_arg3454z00_3957,
																																																																																		CNST_TABLE_REF
																																																																																		(((long) 4)), BgL_arg3455z00_3958, BgL_stackz00_22, BgL_arg6965z00_10838, BgL_sitez00_24));
																																																																														}}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1777;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_18149;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1778;
																																																																																	BgL_auxz00_14266
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_18149);
																																																																																}
																																																																														}
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																													else
																														{	/* Ast/sexp.scm 119 */
																															obj_t
																																BgL_carzd214119zd2_3975;
																															BgL_carzd214119zd2_3975
																																=
																																CAR(((obj_t)
																																	BgL_expz00_21));
																															if (
																																(BgL_carzd214119zd2_3975
																																	==
																																	CNST_TABLE_REF
																																	(((long) 1))))
																																{
																																	BgL_nodez00_bglt
																																		BgL_auxz00_18156;
																																	goto
																																		BgL_tagzd2377zd2_1722;
																																	BgL_auxz00_14266
																																		=
																																		((obj_t)
																																		BgL_auxz00_18156);
																																}
																															else
																																{	/* Ast/sexp.scm 119 */
																																	if (
																																		(BgL_carzd214119zd2_3975
																																			==
																																			BGl_za2ifza2z00zzast_sexpz00))
																																		{
																																			BgL_nodez00_bglt
																																				BgL_auxz00_18160;
																																			goto
																																				BgL_tagzd2377zd2_1722;
																																			BgL_auxz00_14266
																																				=
																																				((obj_t)
																																				BgL_auxz00_18160);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 119 */
																																			obj_t
																																				BgL_cdrzd214141zd2_3978;
																																			BgL_cdrzd214141zd2_3978
																																				=
																																				CDR((
																																					(obj_t)
																																					BgL_expz00_21));
																																			if ((CAR((
																																							(obj_t)
																																							BgL_expz00_21))
																																					==
																																					CNST_TABLE_REF
																																					(((long) 7))))
																																				{	/* Ast/sexp.scm 119 */
																																					obj_t
																																						BgL_carzd214144zd2_3981;
																																					obj_t
																																						BgL_cdrzd214145zd2_3982;
																																					BgL_carzd214144zd2_3981
																																						=
																																						CAR(
																																						((obj_t) BgL_cdrzd214141zd2_3978));
																																					BgL_cdrzd214145zd2_3982
																																						=
																																						CDR(
																																						((obj_t) BgL_cdrzd214141zd2_3978));
																																					if (PAIRP(BgL_carzd214144zd2_3981))
																																						{	/* Ast/sexp.scm 119 */
																																							if ((CAR(BgL_carzd214144zd2_3981) == CNST_TABLE_REF(((long) 14))))
																																								{	/* Ast/sexp.scm 119 */
																																									if (NULLP(CDR(((obj_t) BgL_cdrzd214145zd2_3982))))
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_arg3485z00_3988;
																																											obj_t
																																												BgL_arg3486z00_3989;
																																											BgL_arg3485z00_3988
																																												=
																																												CDR
																																												(BgL_carzd214144zd2_3981);
																																											BgL_arg3486z00_3989
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_cdrzd214145zd2_3982));
																																											{
																																												BgL_nodez00_bglt
																																													BgL_auxz00_18186;
																																												{
																																													obj_t
																																														BgL_valz00_18188;
																																													obj_t
																																														BgL_lz00_18187;
																																													BgL_lz00_18187
																																														=
																																														BgL_arg3485z00_3988;
																																													BgL_valz00_18188
																																														=
																																														BgL_arg3486z00_3989;
																																													BgL_valz00_1724
																																														=
																																														BgL_valz00_18188;
																																													BgL_lz00_1723
																																														=
																																														BgL_lz00_18187;
																																													goto
																																														BgL_tagzd2378zd2_1725;
																																												}
																																												BgL_auxz00_14266
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_18186);
																																											}
																																										}
																																									else
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_18190;
																																											goto
																																												BgL_tagzd2379zd2_1726;
																																											BgL_auxz00_14266
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_18190);
																																										}
																																								}
																																							else
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_18192;
																																									goto
																																										BgL_tagzd2379zd2_1726;
																																									BgL_auxz00_14266
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_18192);
																																								}
																																						}
																																					else
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_18194;
																																							goto
																																								BgL_tagzd2379zd2_1726;
																																							BgL_auxz00_14266
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_18194);
																																						}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					if (
																																						(CAR
																																							(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_18201;
																																							goto
																																								BgL_tagzd2380zd2_1727;
																																							BgL_auxz00_14266
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_18201);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							obj_t
																																								BgL_carzd214242zd2_3994;
																																							BgL_carzd214242zd2_3994
																																								=
																																								CAR
																																								(
																																								((obj_t) BgL_expz00_21));
																																							if (PAIRP(BgL_carzd214242zd2_3994))
																																								{	/* Ast/sexp.scm 119 */
																																									obj_t
																																										BgL_carzd214245zd2_3996;
																																									obj_t
																																										BgL_cdrzd214246zd2_3997;
																																									BgL_carzd214245zd2_3996
																																										=
																																										CAR
																																										(BgL_carzd214242zd2_3994);
																																									BgL_cdrzd214246zd2_3997
																																										=
																																										CDR
																																										(BgL_carzd214242zd2_3994);
																																									{

																																										if ((BgL_carzd214245zd2_3996 == CNST_TABLE_REF(((long) 17))))
																																											{	/* Ast/sexp.scm 119 */
																																											BgL_kapzd214247zd2_3998:
																																												if (PAIRP(BgL_cdrzd214246zd2_3997))
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_cdrzd214250zd2_4123;
																																														BgL_cdrzd214250zd2_4123
																																															=
																																															CDR
																																															(BgL_cdrzd214246zd2_3997);
																																														if (PAIRP(BgL_cdrzd214250zd2_4123))
																																															{	/* Ast/sexp.scm 119 */
																																																if (NULLP(CDR(BgL_cdrzd214250zd2_4123)))
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_arg3584z00_4127;
																																																		obj_t
																																																			BgL_arg3585z00_4128;
																																																		BgL_arg3584z00_4127
																																																			=
																																																			CAR
																																																			(BgL_cdrzd214250zd2_4123);
																																																		BgL_arg3585z00_4128
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_18223;
																																																			{
																																																				obj_t
																																																					BgL_argsz00_18225;
																																																				obj_t
																																																					BgL_bodyz00_18224;
																																																				BgL_bodyz00_18224
																																																					=
																																																					BgL_arg3584z00_4127;
																																																				BgL_argsz00_18225
																																																					=
																																																					BgL_arg3585z00_4128;
																																																				BgL_argsz00_1729
																																																					=
																																																					BgL_argsz00_18225;
																																																				BgL_bodyz00_1728
																																																					=
																																																					BgL_bodyz00_18224;
																																																				goto
																																																					BgL_tagzd2381zd2_1730;
																																																			}
																																																			BgL_auxz00_14266
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_18223);
																																																		}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_cdrzd214274zd2_4129;
																																																		BgL_cdrzd214274zd2_4129
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 119 */
																																																			bool_t
																																																				BgL_test8718z00_18229;
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg3659z00_4240;
																																																				BgL_arg3659z00_4240
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test8718z00_18229
																																																					=
																																																					CBOOL
																																																					(BGl_letzd2symzf3z21zzast_letz00
																																																					(BgL_arg3659z00_4240));
																																																			}
																																																			if (BgL_test8718z00_18229)
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_arg3589z00_4132;
																																																					obj_t
																																																						BgL_arg3590z00_4133;
																																																					BgL_arg3589z00_4132
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd214274zd2_4129));
																																																					BgL_arg3590z00_4133
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd214274zd2_4129));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_18238;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_18240;
																																																							obj_t
																																																								BgL_bindingsz00_18239;
																																																							BgL_bindingsz00_18239
																																																								=
																																																								BgL_arg3589z00_4132;
																																																							BgL_exprz00_18240
																																																								=
																																																								BgL_arg3590z00_4133;
																																																							BgL_exprz00_1732
																																																								=
																																																								BgL_exprz00_18240;
																																																							BgL_bindingsz00_1731
																																																								=
																																																								BgL_bindingsz00_18239;
																																																							goto
																																																								BgL_tagzd2382zd2_1733;
																																																						}
																																																						BgL_auxz00_14266
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_18238);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					bool_t
																																																						BgL_test8719z00_18242;
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg3658z00_4239;
																																																						BgL_arg3658z00_4239
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test8719z00_18242
																																																							=
																																																							CBOOL
																																																							(BGl_labelszd2symzf3z21zzast_labelsz00
																																																							(BgL_arg3658z00_4239));
																																																					}
																																																					if (BgL_test8719z00_18242)
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_18247;
																																																							goto
																																																								BgL_tagzd2384zd2_1735;
																																																							BgL_auxz00_14266
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_18247);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_carzd214341zd2_4136;
																																																							BgL_carzd214341zd2_4136
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd214346zd2_4137;
																																																								BgL_cdrzd214346zd2_4137
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_carzd214341zd2_4136));
																																																								if ((CAR(((obj_t) BgL_carzd214341zd2_4136)) == CNST_TABLE_REF(((long) 3))))
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg3595z00_4140;
																																																										obj_t
																																																											BgL_arg3596z00_4141;
																																																										obj_t
																																																											BgL_arg3598z00_4142;
																																																										BgL_arg3595z00_4140
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_cdrzd214346zd2_4137));
																																																										BgL_arg3596z00_4141
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_cdrzd214346zd2_4137));
																																																										BgL_arg3598z00_4142
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_18264;
																																																											{
																																																												obj_t
																																																													BgL_argsz00_18267;
																																																												obj_t
																																																													BgL_bodyz00_18266;
																																																												obj_t
																																																													BgL_varsz00_18265;
																																																												BgL_varsz00_18265
																																																													=
																																																													BgL_arg3595z00_4140;
																																																												BgL_bodyz00_18266
																																																													=
																																																													BgL_arg3596z00_4141;
																																																												BgL_argsz00_18267
																																																													=
																																																													BgL_arg3598z00_4142;
																																																												BgL_argsz00_1742
																																																													=
																																																													BgL_argsz00_18267;
																																																												BgL_bodyz00_1741
																																																													=
																																																													BgL_bodyz00_18266;
																																																												BgL_varsz00_1740
																																																													=
																																																													BgL_varsz00_18265;
																																																												goto
																																																													BgL_tagzd2386zd2_1743;
																																																											}
																																																											BgL_auxz00_14266
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_18264);
																																																										}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd214369zd2_4144;
																																																										BgL_cdrzd214369zd2_4144
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_cdrzd214375zd2_4145;
																																																											BgL_cdrzd214375zd2_4145
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_carzd214341zd2_4136));
																																																											if ((CAR(((obj_t) BgL_carzd214341zd2_4136)) == CNST_TABLE_REF(((long) 1))))
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd214381zd2_4148;
																																																													BgL_cdrzd214381zd2_4148
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd214375zd2_4145));
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_carzd214386zd2_4149;
																																																														obj_t
																																																															BgL_cdrzd214387zd2_4150;
																																																														BgL_carzd214386zd2_4149
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd214381zd2_4148));
																																																														BgL_cdrzd214387zd2_4150
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd214381zd2_4148));
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd214386zd2_4149))
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (PAIRP(BgL_cdrzd214387zd2_4150))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_carzd214394zd2_4153;
																																																																		BgL_carzd214394zd2_4153
																																																																			=
																																																																			CAR
																																																																			(BgL_cdrzd214387zd2_4150);
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd214394zd2_4153))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (NULLP(CDR(BgL_cdrzd214387zd2_4150)))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						bool_t
																																																																							BgL_test8726z00_18294;
																																																																						{
																																																																							obj_t
																																																																								BgL_l1390z00_4186;
																																																																							BgL_l1390z00_4186
																																																																								=
																																																																								BgL_cdrzd214369zd2_4144;
																																																																						BgL_zc3z04anonymousza33621ze3z87_4187:
																																																																							if (NULLP(BgL_l1390z00_4186))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									BgL_test8726z00_18294
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										1);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									bool_t
																																																																										BgL_test8728z00_18297;
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										bool_t
																																																																											BgL_test8729z00_18298;
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_tmpz00_18299;
																																																																											BgL_tmpz00_18299
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_l1390z00_4186));
																																																																											BgL_test8729z00_18298
																																																																												=
																																																																												PAIRP
																																																																												(BgL_tmpz00_18299);
																																																																										}
																																																																										if (BgL_test8729z00_18298)
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												BgL_test8728z00_18297
																																																																													=
																																																																													(
																																																																													(bool_t)
																																																																													0);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												BgL_test8728z00_18297
																																																																													=
																																																																													(
																																																																													(bool_t)
																																																																													1);
																																																																											}
																																																																									}
																																																																									if (BgL_test8728z00_18297)
																																																																										{
																																																																											obj_t
																																																																												BgL_l1390z00_18303;
																																																																											BgL_l1390z00_18303
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_l1390z00_4186));
																																																																											BgL_l1390z00_4186
																																																																												=
																																																																												BgL_l1390z00_18303;
																																																																											goto
																																																																												BgL_zc3z04anonymousza33621ze3z87_4187;
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											BgL_test8726z00_18294
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												0);
																																																																										}
																																																																								}
																																																																						}
																																																																						if (BgL_test8726z00_18294)
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_arg3611z00_4169;
																																																																								BgL_arg3611z00_4169
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd214375zd2_4145));
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_18308;
																																																																									{
																																																																										obj_t
																																																																											BgL_argsz00_18312;
																																																																										obj_t
																																																																											BgL_proc2z00_18311;
																																																																										obj_t
																																																																											BgL_proc1z00_18310;
																																																																										obj_t
																																																																											BgL_testz00_18309;
																																																																										BgL_testz00_18309
																																																																											=
																																																																											BgL_arg3611z00_4169;
																																																																										BgL_proc1z00_18310
																																																																											=
																																																																											BgL_carzd214386zd2_4149;
																																																																										BgL_proc2z00_18311
																																																																											=
																																																																											BgL_carzd214394zd2_4153;
																																																																										BgL_argsz00_18312
																																																																											=
																																																																											BgL_cdrzd214369zd2_4144;
																																																																										BgL_argsz00_1747
																																																																											=
																																																																											BgL_argsz00_18312;
																																																																										BgL_proc2z00_1746
																																																																											=
																																																																											BgL_proc2z00_18311;
																																																																										BgL_proc1z00_1745
																																																																											=
																																																																											BgL_proc1z00_18310;
																																																																										BgL_testz00_1744
																																																																											=
																																																																											BgL_testz00_18309;
																																																																										goto
																																																																											BgL_tagzd2387zd2_1748;
																																																																									}
																																																																									BgL_auxz00_14266
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_18308);
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd214418zd2_4170;
																																																																								BgL_cdrzd214418zd2_4170
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd214425zd2_4171;
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_pairz00_10891;
																																																																										BgL_pairz00_10891
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										BgL_cdrzd214425zd2_4171
																																																																											=
																																																																											CDR
																																																																											(BgL_pairz00_10891);
																																																																									}
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd214432zd2_4172;
																																																																										BgL_cdrzd214432zd2_4172
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd214425zd2_4171));
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd214438zd2_4173;
																																																																											BgL_carzd214438zd2_4173
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd214432zd2_4172));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd214438zd2_4173))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_carzd214445zd2_4175;
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_pairz00_10895;
																																																																														BgL_pairz00_10895
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd214432zd2_4172));
																																																																														BgL_carzd214445zd2_4175
																																																																															=
																																																																															CAR
																																																																															(BgL_pairz00_10895);
																																																																													}
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd214445zd2_4175))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd214418zd2_4170))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_arg3615z00_4178;
																																																																																	BgL_arg3615z00_4178
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd214425zd2_4171));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_18334;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_18338;
																																																																																			obj_t
																																																																																				BgL_proc2z00_18337;
																																																																																			obj_t
																																																																																				BgL_proc1z00_18336;
																																																																																			obj_t
																																																																																				BgL_testz00_18335;
																																																																																			BgL_testz00_18335
																																																																																				=
																																																																																				BgL_arg3615z00_4178;
																																																																																			BgL_proc1z00_18336
																																																																																				=
																																																																																				BgL_carzd214438zd2_4173;
																																																																																			BgL_proc2z00_18337
																																																																																				=
																																																																																				BgL_carzd214445zd2_4175;
																																																																																			BgL_argsz00_18338
																																																																																				=
																																																																																				BgL_cdrzd214418zd2_4170;
																																																																																			BgL_argsz00_1752
																																																																																				=
																																																																																				BgL_argsz00_18338;
																																																																																			BgL_proc2z00_1751
																																																																																				=
																																																																																				BgL_proc2z00_18337;
																																																																																			BgL_proc1z00_1750
																																																																																				=
																																																																																				BgL_proc1z00_18336;
																																																																																			BgL_testz00_1749
																																																																																				=
																																																																																				BgL_testz00_18335;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1753;
																																																																																		}
																																																																																		BgL_auxz00_14266
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_18334);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1777;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_18342;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1778;
																																																																																			BgL_auxz00_14266
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_18342);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1777;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_18346;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1778;
																																																																																	BgL_auxz00_14266
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_18346);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1777;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_18350;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1778;
																																																																															BgL_auxz00_14266
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_18350);
																																																																														}
																																																																												}
																																																																										}
																																																																									}
																																																																								}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1777;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_18354;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1778;
																																																																								BgL_auxz00_14266
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_18354);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd214721zd2_4197;
																																																																				BgL_cdrzd214721zd2_4197
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd214727zd2_4198;
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_pairz00_10899;
																																																																						BgL_pairz00_10899
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						BgL_cdrzd214727zd2_4198
																																																																							=
																																																																							CDR
																																																																							(BgL_pairz00_10899);
																																																																					}
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd214733zd2_4199;
																																																																						BgL_cdrzd214733zd2_4199
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd214727zd2_4198));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd214738zd2_4200;
																																																																							obj_t
																																																																								BgL_cdrzd214739zd2_4201;
																																																																							BgL_carzd214738zd2_4200
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd214733zd2_4199));
																																																																							BgL_cdrzd214739zd2_4201
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd214733zd2_4199));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd214738zd2_4200))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd214744zd2_4203;
																																																																									BgL_carzd214744zd2_4203
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd214739zd2_4201));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd214744zd2_4203))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (NULLP(CDR(((obj_t) BgL_cdrzd214739zd2_4201))))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd214721zd2_4197))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg3631z00_4208;
																																																																															BgL_arg3631z00_4208
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd214727zd2_4198));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_18381;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_18385;
																																																																																	obj_t
																																																																																		BgL_proc2z00_18384;
																																																																																	obj_t
																																																																																		BgL_proc1z00_18383;
																																																																																	obj_t
																																																																																		BgL_testz00_18382;
																																																																																	BgL_testz00_18382
																																																																																		=
																																																																																		BgL_arg3631z00_4208;
																																																																																	BgL_proc1z00_18383
																																																																																		=
																																																																																		BgL_carzd214738zd2_4200;
																																																																																	BgL_proc2z00_18384
																																																																																		=
																																																																																		BgL_carzd214744zd2_4203;
																																																																																	BgL_argsz00_18385
																																																																																		=
																																																																																		BgL_cdrzd214721zd2_4197;
																																																																																	BgL_argsz00_1752
																																																																																		=
																																																																																		BgL_argsz00_18385;
																																																																																	BgL_proc2z00_1751
																																																																																		=
																																																																																		BgL_proc2z00_18384;
																																																																																	BgL_proc1z00_1750
																																																																																		=
																																																																																		BgL_proc1z00_18383;
																																																																																	BgL_testz00_1749
																																																																																		=
																																																																																		BgL_testz00_18382;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1753;
																																																																																}
																																																																																BgL_auxz00_14266
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_18381);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1777;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_18389;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1778;
																																																																																	BgL_auxz00_14266
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_18389);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1777;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_18393;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1778;
																																																																															BgL_auxz00_14266
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_18393);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1777;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_18397;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1778;
																																																																													BgL_auxz00_14266
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_18397);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1777;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_18401;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1778;
																																																																											BgL_auxz00_14266
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_18401);
																																																																										}
																																																																								}
																																																																						}
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1777;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_18405;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1778;
																																																																				BgL_auxz00_14266
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_18405);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd215077zd2_4216;
																																																																BgL_cdrzd215077zd2_4216
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd215084zd2_4217;
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_pairz00_10909;
																																																																		BgL_pairz00_10909
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		BgL_cdrzd215084zd2_4217
																																																																			=
																																																																			CDR
																																																																			(BgL_pairz00_10909);
																																																																	}
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd215091zd2_4218;
																																																																		BgL_cdrzd215091zd2_4218
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd215084zd2_4217));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_carzd215097zd2_4219;
																																																																			obj_t
																																																																				BgL_cdrzd215098zd2_4220;
																																																																			BgL_carzd215097zd2_4219
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd215091zd2_4218));
																																																																			BgL_cdrzd215098zd2_4220
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd215091zd2_4218));
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd215097zd2_4219))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (PAIRP(BgL_cdrzd215098zd2_4220))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd215105zd2_4223;
																																																																							BgL_carzd215105zd2_4223
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd215098zd2_4220);
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd215105zd2_4223))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (NULLP(CDR(BgL_cdrzd215098zd2_4220)))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd215077zd2_4216))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_arg3645z00_4228;
																																																																													BgL_arg3645z00_4228
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd215084zd2_4217));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_18432;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_18436;
																																																																															obj_t
																																																																																BgL_proc2z00_18435;
																																																																															obj_t
																																																																																BgL_proc1z00_18434;
																																																																															obj_t
																																																																																BgL_testz00_18433;
																																																																															BgL_testz00_18433
																																																																																=
																																																																																BgL_arg3645z00_4228;
																																																																															BgL_proc1z00_18434
																																																																																=
																																																																																BgL_carzd215097zd2_4219;
																																																																															BgL_proc2z00_18435
																																																																																=
																																																																																BgL_carzd215105zd2_4223;
																																																																															BgL_argsz00_18436
																																																																																=
																																																																																BgL_cdrzd215077zd2_4216;
																																																																															BgL_argsz00_1752
																																																																																=
																																																																																BgL_argsz00_18436;
																																																																															BgL_proc2z00_1751
																																																																																=
																																																																																BgL_proc2z00_18435;
																																																																															BgL_proc1z00_1750
																																																																																=
																																																																																BgL_proc1z00_18434;
																																																																															BgL_testz00_1749
																																																																																=
																																																																																BgL_testz00_18433;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1753;
																																																																														}
																																																																														BgL_auxz00_14266
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_18432);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1777;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_18440;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1778;
																																																																															BgL_auxz00_14266
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_18440);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1777;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_18444;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1778;
																																																																													BgL_auxz00_14266
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_18444);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1777;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_18448;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1778;
																																																																											BgL_auxz00_14266
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_18448);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1777;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_18452;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1778;
																																																																									BgL_auxz00_14266
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_18452);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1777;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_18456;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1778;
																																																																							BgL_auxz00_14266
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_18456);
																																																																						}
																																																																				}
																																																																		}
																																																																	}
																																																																}
																																																															}
																																																													}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{	/* Ast/sexp.scm 119 */
																																																															goto
																																																																BgL_tagzd2403zd2_1777;
																																																														}
																																																													else
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_18460;
																																																															goto
																																																																BgL_tagzd2404zd2_1778;
																																																															BgL_auxz00_14266
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_18460);
																																																														}
																																																												}
																																																										}
																																																									}
																																																							}
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_cdrzd215498zd2_4242;
																																																BgL_cdrzd215498zd2_4242
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 119 */
																																																	bool_t
																																																		BgL_test8757z00_18464;
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_arg3678z00_4259;
																																																		BgL_arg3678z00_4259
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_test8757z00_18464
																																																			=
																																																			CBOOL
																																																			(BGl_letzd2symzf3z21zzast_letz00
																																																			(BgL_arg3678z00_4259));
																																																	}
																																																	if (BgL_test8757z00_18464)
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg3663z00_4245;
																																																			obj_t
																																																				BgL_arg3664z00_4246;
																																																			BgL_arg3663z00_4245
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd215498zd2_4242));
																																																			BgL_arg3664z00_4246
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd215498zd2_4242));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_18473;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_18475;
																																																					obj_t
																																																						BgL_bindingsz00_18474;
																																																					BgL_bindingsz00_18474
																																																						=
																																																						BgL_arg3663z00_4245;
																																																					BgL_exprz00_18475
																																																						=
																																																						BgL_arg3664z00_4246;
																																																					BgL_exprz00_1732
																																																						=
																																																						BgL_exprz00_18475;
																																																					BgL_bindingsz00_1731
																																																						=
																																																						BgL_bindingsz00_18474;
																																																					goto
																																																						BgL_tagzd2382zd2_1733;
																																																				}
																																																				BgL_auxz00_14266
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_18473);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			bool_t
																																																				BgL_test8758z00_18477;
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg3676z00_4258;
																																																				BgL_arg3676z00_4258
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test8758z00_18477
																																																					=
																																																					CBOOL
																																																					(BGl_labelszd2symzf3z21zzast_labelsz00
																																																					(BgL_arg3676z00_4258));
																																																			}
																																																			if (BgL_test8758z00_18477)
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_18482;
																																																					goto
																																																						BgL_tagzd2384zd2_1735;
																																																					BgL_auxz00_14266
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_18482);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_carzd215564zd2_4249;
																																																					BgL_carzd215564zd2_4249
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd215569zd2_4250;
																																																						BgL_cdrzd215569zd2_4250
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_carzd215564zd2_4249));
																																																						if ((CAR(((obj_t) BgL_carzd215564zd2_4249)) == CNST_TABLE_REF(((long) 3))))
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg3670z00_4253;
																																																								obj_t
																																																									BgL_arg3671z00_4254;
																																																								obj_t
																																																									BgL_arg3672z00_4255;
																																																								BgL_arg3670z00_4253
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_cdrzd215569zd2_4250));
																																																								BgL_arg3671z00_4254
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_cdrzd215569zd2_4250));
																																																								BgL_arg3672z00_4255
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_18499;
																																																									{
																																																										obj_t
																																																											BgL_argsz00_18502;
																																																										obj_t
																																																											BgL_bodyz00_18501;
																																																										obj_t
																																																											BgL_varsz00_18500;
																																																										BgL_varsz00_18500
																																																											=
																																																											BgL_arg3670z00_4253;
																																																										BgL_bodyz00_18501
																																																											=
																																																											BgL_arg3671z00_4254;
																																																										BgL_argsz00_18502
																																																											=
																																																											BgL_arg3672z00_4255;
																																																										BgL_argsz00_1742
																																																											=
																																																											BgL_argsz00_18502;
																																																										BgL_bodyz00_1741
																																																											=
																																																											BgL_bodyz00_18501;
																																																										BgL_varsz00_1740
																																																											=
																																																											BgL_varsz00_18500;
																																																										goto
																																																											BgL_tagzd2386zd2_1743;
																																																									}
																																																									BgL_auxz00_14266
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_18499);
																																																								}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																									{	/* Ast/sexp.scm 119 */
																																																										goto
																																																											BgL_tagzd2403zd2_1777;
																																																									}
																																																								else
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_18506;
																																																										goto
																																																											BgL_tagzd2404zd2_1778;
																																																										BgL_auxz00_14266
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_18506);
																																																									}
																																																							}
																																																					}
																																																				}
																																																		}
																																																}
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_cdrzd215680zd2_4260;
																																														BgL_cdrzd215680zd2_4260
																																															=
																																															CDR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{	/* Ast/sexp.scm 119 */
																																															bool_t
																																																BgL_test8761z00_18510;
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_arg3687z00_4269;
																																																BgL_arg3687z00_4269
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																BgL_test8761z00_18510
																																																	=
																																																	CBOOL
																																																	(BGl_letzd2symzf3z21zzast_letz00
																																																	(BgL_arg3687z00_4269));
																																															}
																																															if (BgL_test8761z00_18510)
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg3681z00_4263;
																																																	obj_t
																																																		BgL_arg3682z00_4264;
																																																	BgL_arg3681z00_4263
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd215680zd2_4260));
																																																	BgL_arg3682z00_4264
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd215680zd2_4260));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_18519;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_18521;
																																																			obj_t
																																																				BgL_bindingsz00_18520;
																																																			BgL_bindingsz00_18520
																																																				=
																																																				BgL_arg3681z00_4263;
																																																			BgL_exprz00_18521
																																																				=
																																																				BgL_arg3682z00_4264;
																																																			BgL_exprz00_1732
																																																				=
																																																				BgL_exprz00_18521;
																																																			BgL_bindingsz00_1731
																																																				=
																																																				BgL_bindingsz00_18520;
																																																			goto
																																																				BgL_tagzd2382zd2_1733;
																																																		}
																																																		BgL_auxz00_14266
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_18519);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	bool_t
																																																		BgL_test8762z00_18523;
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_arg3686z00_4268;
																																																		BgL_arg3686z00_4268
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_test8762z00_18523
																																																			=
																																																			CBOOL
																																																			(BGl_labelszd2symzf3z21zzast_labelsz00
																																																			(BgL_arg3686z00_4268));
																																																	}
																																																	if (BgL_test8762z00_18523)
																																																		{
																																																			BgL_letzd2funzd2_bglt
																																																				BgL_auxz00_18528;
																																																			goto
																																																				BgL_tagzd2384zd2_1735;
																																																			BgL_auxz00_14266
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_18528);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																				{	/* Ast/sexp.scm 119 */
																																																					goto
																																																						BgL_tagzd2403zd2_1777;
																																																				}
																																																			else
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_18532;
																																																					goto
																																																						BgL_tagzd2404zd2_1778;
																																																					BgL_auxz00_14266
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_18532);
																																																				}
																																																		}
																																																}
																																														}
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd214245zd2_3996)))
																																													{	/* Ast/sexp.scm 119 */
																																														goto
																																															BgL_kapzd214247zd2_3998;
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														if ((BgL_carzd214245zd2_3996 == CNST_TABLE_REF(((long) 18))))
																																															{	/* Ast/sexp.scm 119 */
																																																goto
																																																	BgL_kapzd214247zd2_3998;
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																if ((BgL_carzd214245zd2_3996 == CNST_TABLE_REF(((long) 19))))
																																																	{	/* Ast/sexp.scm 119 */
																																																		goto
																																																			BgL_kapzd214247zd2_3998;
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd214245zd2_3996)))
																																																			{	/* Ast/sexp.scm 119 */
																																																				goto
																																																					BgL_kapzd214247zd2_3998;
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd215852zd2_4004;
																																																				BgL_cdrzd215852zd2_4004
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 119 */
																																																					bool_t
																																																						BgL_test8768z00_18548;
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg3578z00_4121;
																																																						BgL_arg3578z00_4121
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test8768z00_18548
																																																							=
																																																							CBOOL
																																																							(BGl_letzd2symzf3z21zzast_letz00
																																																							(BgL_arg3578z00_4121));
																																																					}
																																																					if (BgL_test8768z00_18548)
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_arg3500z00_4007;
																																																							obj_t
																																																								BgL_arg3501z00_4008;
																																																							BgL_arg3500z00_4007
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd215852zd2_4004));
																																																							BgL_arg3501z00_4008
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd215852zd2_4004));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_18557;
																																																								{
																																																									obj_t
																																																										BgL_exprz00_18559;
																																																									obj_t
																																																										BgL_bindingsz00_18558;
																																																									BgL_bindingsz00_18558
																																																										=
																																																										BgL_arg3500z00_4007;
																																																									BgL_exprz00_18559
																																																										=
																																																										BgL_arg3501z00_4008;
																																																									BgL_exprz00_1732
																																																										=
																																																										BgL_exprz00_18559;
																																																									BgL_bindingsz00_1731
																																																										=
																																																										BgL_bindingsz00_18558;
																																																									goto
																																																										BgL_tagzd2382zd2_1733;
																																																								}
																																																								BgL_auxz00_14266
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_18557);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							bool_t
																																																								BgL_test8769z00_18561;
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg3577z00_4120;
																																																								BgL_arg3577z00_4120
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test8769z00_18561
																																																									=
																																																									CBOOL
																																																									(BGl_labelszd2symzf3z21zzast_labelsz00
																																																									(BgL_arg3577z00_4120));
																																																							}
																																																							if (BgL_test8769z00_18561)
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_18566;
																																																									goto
																																																										BgL_tagzd2384zd2_1735;
																																																									BgL_auxz00_14266
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_18566);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_carzd215918zd2_4011;
																																																									BgL_carzd215918zd2_4011
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd215923zd2_4012;
																																																										BgL_cdrzd215923zd2_4012
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_carzd215918zd2_4011));
																																																										if ((CAR(((obj_t) BgL_carzd215918zd2_4011)) == CNST_TABLE_REF(((long) 3))))
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (PAIRP(BgL_cdrzd215923zd2_4012))
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_arg3507z00_4016;
																																																														obj_t
																																																															BgL_arg3509z00_4017;
																																																														obj_t
																																																															BgL_arg3510z00_4018;
																																																														BgL_arg3507z00_4016
																																																															=
																																																															CAR
																																																															(BgL_cdrzd215923zd2_4012);
																																																														BgL_arg3509z00_4017
																																																															=
																																																															CDR
																																																															(BgL_cdrzd215923zd2_4012);
																																																														BgL_arg3510z00_4018
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_18583;
																																																															{
																																																																obj_t
																																																																	BgL_argsz00_18586;
																																																																obj_t
																																																																	BgL_bodyz00_18585;
																																																																obj_t
																																																																	BgL_varsz00_18584;
																																																																BgL_varsz00_18584
																																																																	=
																																																																	BgL_arg3507z00_4016;
																																																																BgL_bodyz00_18585
																																																																	=
																																																																	BgL_arg3509z00_4017;
																																																																BgL_argsz00_18586
																																																																	=
																																																																	BgL_arg3510z00_4018;
																																																																BgL_argsz00_1742
																																																																	=
																																																																	BgL_argsz00_18586;
																																																																BgL_bodyz00_1741
																																																																	=
																																																																	BgL_bodyz00_18585;
																																																																BgL_varsz00_1740
																																																																	=
																																																																	BgL_varsz00_18584;
																																																																goto
																																																																	BgL_tagzd2386zd2_1743;
																																																															}
																																																															BgL_auxz00_14266
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_18583);
																																																														}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 119 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1777;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_18590;
																																																																goto
																																																																	BgL_tagzd2404zd2_1778;
																																																																BgL_auxz00_14266
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_18590);
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd216030zd2_4021;
																																																												BgL_cdrzd216030zd2_4021
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd216035zd2_4022;
																																																													BgL_cdrzd216035zd2_4022
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_carzd215918zd2_4011));
																																																													if ((CAR(((obj_t) BgL_carzd215918zd2_4011)) == CNST_TABLE_REF(((long) 1))))
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (PAIRP(BgL_cdrzd216035zd2_4022))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd216040zd2_4026;
																																																																	BgL_cdrzd216040zd2_4026
																																																																		=
																																																																		CDR
																																																																		(BgL_cdrzd216035zd2_4022);
																																																																	if (PAIRP(BgL_cdrzd216040zd2_4026))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_carzd216044zd2_4028;
																																																																			obj_t
																																																																				BgL_cdrzd216045zd2_4029;
																																																																			BgL_carzd216044zd2_4028
																																																																				=
																																																																				CAR
																																																																				(BgL_cdrzd216040zd2_4026);
																																																																			BgL_cdrzd216045zd2_4029
																																																																				=
																																																																				CDR
																																																																				(BgL_cdrzd216040zd2_4026);
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd216044zd2_4028))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (PAIRP(BgL_cdrzd216045zd2_4029))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd216050zd2_4032;
																																																																							BgL_carzd216050zd2_4032
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd216045zd2_4029);
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd216050zd2_4032))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (NULLP(CDR(BgL_cdrzd216045zd2_4029)))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											bool_t
																																																																												BgL_test8780z00_18618;
																																																																											{
																																																																												obj_t
																																																																													BgL_l1393z00_4065;
																																																																												BgL_l1393z00_4065
																																																																													=
																																																																													BgL_cdrzd216030zd2_4021;
																																																																											BgL_zc3z04anonymousza33538ze3z87_4066:
																																																																												if (NULLP(BgL_l1393z00_4065))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														BgL_test8780z00_18618
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															1);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														bool_t
																																																																															BgL_test8782z00_18621;
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															bool_t
																																																																																BgL_test8783z00_18622;
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_tmpz00_18623;
																																																																																BgL_tmpz00_18623
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_l1393z00_4065));
																																																																																BgL_test8783z00_18622
																																																																																	=
																																																																																	PAIRP
																																																																																	(BgL_tmpz00_18623);
																																																																															}
																																																																															if (BgL_test8783z00_18622)
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	BgL_test8782z00_18621
																																																																																		=
																																																																																		(
																																																																																		(bool_t)
																																																																																		0);
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	BgL_test8782z00_18621
																																																																																		=
																																																																																		(
																																																																																		(bool_t)
																																																																																		1);
																																																																																}
																																																																														}
																																																																														if (BgL_test8782z00_18621)
																																																																															{
																																																																																obj_t
																																																																																	BgL_l1393z00_18627;
																																																																																BgL_l1393z00_18627
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_l1393z00_4065));
																																																																																BgL_l1393z00_4065
																																																																																	=
																																																																																	BgL_l1393z00_18627;
																																																																																goto
																																																																																	BgL_zc3z04anonymousza33538ze3z87_4066;
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																BgL_test8780z00_18618
																																																																																	=
																																																																																	(
																																																																																	(bool_t)
																																																																																	0);
																																																																															}
																																																																													}
																																																																											}
																																																																											if (BgL_test8780z00_18618)
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_arg3527z00_4048;
																																																																													BgL_arg3527z00_4048
																																																																														=
																																																																														CAR
																																																																														(BgL_cdrzd216035zd2_4022);
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_18631;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_18635;
																																																																															obj_t
																																																																																BgL_proc2z00_18634;
																																																																															obj_t
																																																																																BgL_proc1z00_18633;
																																																																															obj_t
																																																																																BgL_testz00_18632;
																																																																															BgL_testz00_18632
																																																																																=
																																																																																BgL_arg3527z00_4048;
																																																																															BgL_proc1z00_18633
																																																																																=
																																																																																BgL_carzd216044zd2_4028;
																																																																															BgL_proc2z00_18634
																																																																																=
																																																																																BgL_carzd216050zd2_4032;
																																																																															BgL_argsz00_18635
																																																																																=
																																																																																BgL_cdrzd216030zd2_4021;
																																																																															BgL_argsz00_1747
																																																																																=
																																																																																BgL_argsz00_18635;
																																																																															BgL_proc2z00_1746
																																																																																=
																																																																																BgL_proc2z00_18634;
																																																																															BgL_proc1z00_1745
																																																																																=
																																																																																BgL_proc1z00_18633;
																																																																															BgL_testz00_1744
																																																																																=
																																																																																BgL_testz00_18632;
																																																																															goto
																																																																																BgL_tagzd2387zd2_1748;
																																																																														}
																																																																														BgL_auxz00_14266
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_18631);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd216075zd2_4049;
																																																																													BgL_cdrzd216075zd2_4049
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_cdrzd216083zd2_4050;
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_pairz00_10966;
																																																																															BgL_pairz00_10966
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															BgL_cdrzd216083zd2_4050
																																																																																=
																																																																																CDR
																																																																																(BgL_pairz00_10966);
																																																																														}
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_cdrzd216091zd2_4051;
																																																																															BgL_cdrzd216091zd2_4051
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_cdrzd216083zd2_4050));
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_carzd216098zd2_4052;
																																																																																BgL_carzd216098zd2_4052
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd216091zd2_4051));
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd216098zd2_4052))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_carzd216107zd2_4054;
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_pairz00_10970;
																																																																																			BgL_pairz00_10970
																																																																																				=
																																																																																				CDR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd216091zd2_4051));
																																																																																			BgL_carzd216107zd2_4054
																																																																																				=
																																																																																				CAR
																																																																																				(BgL_pairz00_10970);
																																																																																		}
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd216107zd2_4054))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd216075zd2_4049))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						obj_t
																																																																																							BgL_arg3531z00_4057;
																																																																																						BgL_arg3531z00_4057
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd216083zd2_4050));
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_18657;
																																																																																							{
																																																																																								obj_t
																																																																																									BgL_argsz00_18661;
																																																																																								obj_t
																																																																																									BgL_proc2z00_18660;
																																																																																								obj_t
																																																																																									BgL_proc1z00_18659;
																																																																																								obj_t
																																																																																									BgL_testz00_18658;
																																																																																								BgL_testz00_18658
																																																																																									=
																																																																																									BgL_arg3531z00_4057;
																																																																																								BgL_proc1z00_18659
																																																																																									=
																																																																																									BgL_carzd216098zd2_4052;
																																																																																								BgL_proc2z00_18660
																																																																																									=
																																																																																									BgL_carzd216107zd2_4054;
																																																																																								BgL_argsz00_18661
																																																																																									=
																																																																																									BgL_cdrzd216075zd2_4049;
																																																																																								BgL_argsz00_1752
																																																																																									=
																																																																																									BgL_argsz00_18661;
																																																																																								BgL_proc2z00_1751
																																																																																									=
																																																																																									BgL_proc2z00_18660;
																																																																																								BgL_proc1z00_1750
																																																																																									=
																																																																																									BgL_proc1z00_18659;
																																																																																								BgL_testz00_1749
																																																																																									=
																																																																																									BgL_testz00_18658;
																																																																																								goto
																																																																																									BgL_tagzd2388zd2_1753;
																																																																																							}
																																																																																							BgL_auxz00_14266
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_18657);
																																																																																						}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1777;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_18665;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1778;
																																																																																								BgL_auxz00_14266
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_18665);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1777;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_18669;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1778;
																																																																																						BgL_auxz00_14266
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_18669);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1777;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_18673;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1778;
																																																																																				BgL_auxz00_14266
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_18673);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														}
																																																																													}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1777;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_18677;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1778;
																																																																													BgL_auxz00_14266
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_18677);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd216385zd2_4076;
																																																																									BgL_cdrzd216385zd2_4076
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd216392zd2_4077;
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_pairz00_10974;
																																																																											BgL_pairz00_10974
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											BgL_cdrzd216392zd2_4077
																																																																												=
																																																																												CDR
																																																																												(BgL_pairz00_10974);
																																																																										}
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd216399zd2_4078;
																																																																											BgL_cdrzd216399zd2_4078
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd216392zd2_4077));
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_carzd216405zd2_4079;
																																																																												obj_t
																																																																													BgL_cdrzd216406zd2_4080;
																																																																												BgL_carzd216405zd2_4079
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd216399zd2_4078));
																																																																												BgL_cdrzd216406zd2_4080
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd216399zd2_4078));
																																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd216405zd2_4079))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_carzd216413zd2_4082;
																																																																														BgL_carzd216413zd2_4082
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd216406zd2_4080));
																																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd216413zd2_4082))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (NULLP(CDR(((obj_t) BgL_cdrzd216406zd2_4080))))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd216385zd2_4076))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_arg3547z00_4087;
																																																																																				BgL_arg3547z00_4087
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd216392zd2_4077));
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_18704;
																																																																																					{
																																																																																						obj_t
																																																																																							BgL_argsz00_18708;
																																																																																						obj_t
																																																																																							BgL_proc2z00_18707;
																																																																																						obj_t
																																																																																							BgL_proc1z00_18706;
																																																																																						obj_t
																																																																																							BgL_testz00_18705;
																																																																																						BgL_testz00_18705
																																																																																							=
																																																																																							BgL_arg3547z00_4087;
																																																																																						BgL_proc1z00_18706
																																																																																							=
																																																																																							BgL_carzd216405zd2_4079;
																																																																																						BgL_proc2z00_18707
																																																																																							=
																																																																																							BgL_carzd216413zd2_4082;
																																																																																						BgL_argsz00_18708
																																																																																							=
																																																																																							BgL_cdrzd216385zd2_4076;
																																																																																						BgL_argsz00_1752
																																																																																							=
																																																																																							BgL_argsz00_18708;
																																																																																						BgL_proc2z00_1751
																																																																																							=
																																																																																							BgL_proc2z00_18707;
																																																																																						BgL_proc1z00_1750
																																																																																							=
																																																																																							BgL_proc1z00_18706;
																																																																																						BgL_testz00_1749
																																																																																							=
																																																																																							BgL_testz00_18705;
																																																																																						goto
																																																																																							BgL_tagzd2388zd2_1753;
																																																																																					}
																																																																																					BgL_auxz00_14266
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_18704);
																																																																																				}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1777;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_18712;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1778;
																																																																																						BgL_auxz00_14266
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_18712);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1777;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_18716;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1778;
																																																																																				BgL_auxz00_14266
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_18716);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1777;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_18720;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1778;
																																																																																		BgL_auxz00_14266
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_18720);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1777;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_18724;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1778;
																																																																																BgL_auxz00_14266
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_18724);
																																																																															}
																																																																													}
																																																																											}
																																																																										}
																																																																									}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1777;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_18728;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1778;
																																																																									BgL_auxz00_14266
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_18728);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd216746zd2_4095;
																																																																					BgL_cdrzd216746zd2_4095
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd216752zd2_4096;
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_pairz00_10984;
																																																																							BgL_pairz00_10984
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							BgL_cdrzd216752zd2_4096
																																																																								=
																																																																								CDR
																																																																								(BgL_pairz00_10984);
																																																																						}
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd216758zd2_4097;
																																																																							BgL_cdrzd216758zd2_4097
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd216752zd2_4096));
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_carzd216763zd2_4098;
																																																																								obj_t
																																																																									BgL_cdrzd216764zd2_4099;
																																																																								BgL_carzd216763zd2_4098
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd216758zd2_4097));
																																																																								BgL_cdrzd216764zd2_4099
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd216758zd2_4097));
																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd216763zd2_4098))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (PAIRP(BgL_cdrzd216764zd2_4099))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_carzd216769zd2_4102;
																																																																												BgL_carzd216769zd2_4102
																																																																													=
																																																																													CAR
																																																																													(BgL_cdrzd216764zd2_4099);
																																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd216769zd2_4102))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (NULLP(CDR(BgL_cdrzd216764zd2_4099)))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd216746zd2_4095))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_arg3563z00_4107;
																																																																																		BgL_arg3563z00_4107
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd216752zd2_4096));
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_18755;
																																																																																			{
																																																																																				obj_t
																																																																																					BgL_argsz00_18759;
																																																																																				obj_t
																																																																																					BgL_proc2z00_18758;
																																																																																				obj_t
																																																																																					BgL_proc1z00_18757;
																																																																																				obj_t
																																																																																					BgL_testz00_18756;
																																																																																				BgL_testz00_18756
																																																																																					=
																																																																																					BgL_arg3563z00_4107;
																																																																																				BgL_proc1z00_18757
																																																																																					=
																																																																																					BgL_carzd216763zd2_4098;
																																																																																				BgL_proc2z00_18758
																																																																																					=
																																																																																					BgL_carzd216769zd2_4102;
																																																																																				BgL_argsz00_18759
																																																																																					=
																																																																																					BgL_cdrzd216746zd2_4095;
																																																																																				BgL_argsz00_1752
																																																																																					=
																																																																																					BgL_argsz00_18759;
																																																																																				BgL_proc2z00_1751
																																																																																					=
																																																																																					BgL_proc2z00_18758;
																																																																																				BgL_proc1z00_1750
																																																																																					=
																																																																																					BgL_proc1z00_18757;
																																																																																				BgL_testz00_1749
																																																																																					=
																																																																																					BgL_testz00_18756;
																																																																																				goto
																																																																																					BgL_tagzd2388zd2_1753;
																																																																																			}
																																																																																			BgL_auxz00_14266
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_18755);
																																																																																		}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1777;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_18763;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1778;
																																																																																				BgL_auxz00_14266
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_18763);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1777;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_18767;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1778;
																																																																																		BgL_auxz00_14266
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_18767);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1777;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_18771;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1778;
																																																																																BgL_auxz00_14266
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_18771);
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1777;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_18775;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1778;
																																																																														BgL_auxz00_14266
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_18775);
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1777;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_18779;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1778;
																																																																												BgL_auxz00_14266
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_18779);
																																																																											}
																																																																									}
																																																																							}
																																																																						}
																																																																					}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1777;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_18783;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1778;
																																																																					BgL_auxz00_14266
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_18783);
																																																																				}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1777;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_18787;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1778;
																																																																			BgL_auxz00_14266
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_18787);
																																																																		}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1777;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_18791;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1778;
																																																																	BgL_auxz00_14266
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_18791);
																																																																}
																																																														}
																																																												}
																																																											}
																																																									}
																																																								}
																																																						}
																																																				}
																																																			}
																																																	}
																																															}
																																													}
																																											}
																																									}
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									if ((BgL_carzd214242zd2_3994 == CNST_TABLE_REF(((long) 17))))
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_arg3689z00_4273;
																																											obj_t
																																												BgL_arg3690z00_4274;
																																											BgL_arg3689z00_4273
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_cdrzd214141zd2_3978));
																																											BgL_arg3690z00_4274
																																												=
																																												CDR
																																												(
																																												((obj_t) BgL_cdrzd214141zd2_3978));
																																											{
																																												BgL_nodez00_bglt
																																													BgL_auxz00_18800;
																																												{
																																													obj_t
																																														BgL_exprz00_18802;
																																													obj_t
																																														BgL_bindingsz00_18801;
																																													BgL_bindingsz00_18801
																																														=
																																														BgL_arg3689z00_4273;
																																													BgL_exprz00_18802
																																														=
																																														BgL_arg3690z00_4274;
																																													BgL_exprz00_1732
																																														=
																																														BgL_exprz00_18802;
																																													BgL_bindingsz00_1731
																																														=
																																														BgL_bindingsz00_18801;
																																													goto
																																														BgL_tagzd2382zd2_1733;
																																												}
																																												BgL_auxz00_14266
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_18800);
																																											}
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd214242zd2_3994)))
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_arg3692z00_4276;
																																													obj_t
																																														BgL_arg3693z00_4277;
																																													BgL_arg3692z00_4276
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_cdrzd214141zd2_3978));
																																													BgL_arg3693z00_4277
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_cdrzd214141zd2_3978));
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_18811;
																																														{
																																															obj_t
																																																BgL_exprz00_18813;
																																															obj_t
																																																BgL_bindingsz00_18812;
																																															BgL_bindingsz00_18812
																																																=
																																																BgL_arg3692z00_4276;
																																															BgL_exprz00_18813
																																																=
																																																BgL_arg3693z00_4277;
																																															BgL_exprz00_1732
																																																=
																																																BgL_exprz00_18813;
																																															BgL_bindingsz00_1731
																																																=
																																																BgL_bindingsz00_18812;
																																															goto
																																																BgL_tagzd2382zd2_1733;
																																														}
																																														BgL_auxz00_14266
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_18811);
																																													}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													if ((BgL_carzd214242zd2_3994 == CNST_TABLE_REF(((long) 18))))
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg3696z00_4279;
																																															obj_t
																																																BgL_arg3697z00_4280;
																																															BgL_arg3696z00_4279
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd214141zd2_3978));
																																															BgL_arg3697z00_4280
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd214141zd2_3978));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_18822;
																																																{
																																																	obj_t
																																																		BgL_exprz00_18824;
																																																	obj_t
																																																		BgL_bindingsz00_18823;
																																																	BgL_bindingsz00_18823
																																																		=
																																																		BgL_arg3696z00_4279;
																																																	BgL_exprz00_18824
																																																		=
																																																		BgL_arg3697z00_4280;
																																																	BgL_exprz00_1732
																																																		=
																																																		BgL_exprz00_18824;
																																																	BgL_bindingsz00_1731
																																																		=
																																																		BgL_bindingsz00_18823;
																																																	goto
																																																		BgL_tagzd2382zd2_1733;
																																																}
																																																BgL_auxz00_14266
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_18822);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_18831;
																																																	goto
																																																		BgL_tagzd2383zd2_1734;
																																																	BgL_auxz00_14266
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_18831);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_carzd217344zd2_4283;
																																																	BgL_carzd217344zd2_4283
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	if ((BgL_carzd217344zd2_4283 == CNST_TABLE_REF(((long) 19))))
																																																		{
																																																			BgL_letzd2funzd2_bglt
																																																				BgL_auxz00_18838;
																																																			goto
																																																				BgL_tagzd2384zd2_1735;
																																																			BgL_auxz00_14266
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_18838);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd217344zd2_4283)))
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_18843;
																																																					goto
																																																						BgL_tagzd2384zd2_1735;
																																																					BgL_auxz00_14266
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_18843);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_18850;
																																																							goto
																																																								BgL_tagzd2389zd2_1754;
																																																							BgL_auxz00_14266
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_18850);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_18857;
																																																									goto
																																																										BgL_tagzd2390zd2_1755;
																																																									BgL_auxz00_14266
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_18857);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_cdrzd217424zd2_4290;
																																																									BgL_cdrzd217424zd2_4290
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_arg3709z00_4293;
																																																											obj_t
																																																												BgL_arg3711z00_4294;
																																																											BgL_arg3709z00_4293
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_cdrzd217424zd2_4290));
																																																											BgL_arg3711z00_4294
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd217424zd2_4290));
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_18870;
																																																												{
																																																													obj_t
																																																														BgL_restz00_18872;
																																																													obj_t
																																																														BgL_effectz00_18871;
																																																													BgL_effectz00_18871
																																																														=
																																																														BgL_arg3709z00_4293;
																																																													BgL_restz00_18872
																																																														=
																																																														BgL_arg3711z00_4294;
																																																													BgL_restz00_1757
																																																														=
																																																														BgL_restz00_18872;
																																																													BgL_effectz00_1756
																																																														=
																																																														BgL_effectz00_18871;
																																																													goto
																																																														BgL_tagzd2391zd2_1758;
																																																												}
																																																												BgL_auxz00_14266
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_18870);
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_18879;
																																																													goto
																																																														BgL_tagzd2392zd2_1759;
																																																													BgL_auxz00_14266
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_18879);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_18886;
																																																															goto
																																																																BgL_tagzd2393zd2_1760;
																																																															BgL_auxz00_14266
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_18886);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_arg3718z00_4302;
																																																																	obj_t
																																																																		BgL_arg3719z00_4303;
																																																																	BgL_arg3718z00_4302
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd217424zd2_4290));
																																																																	BgL_arg3719z00_4303
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd217424zd2_4290));
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_18897;
																																																																		{
																																																																			obj_t
																																																																				BgL_restz00_18899;
																																																																			obj_t
																																																																				BgL_effectz00_18898;
																																																																			BgL_effectz00_18898
																																																																				=
																																																																				BgL_arg3718z00_4302;
																																																																			BgL_restz00_18899
																																																																				=
																																																																				BgL_arg3719z00_4303;
																																																																			BgL_restz00_1762
																																																																				=
																																																																				BgL_restz00_18899;
																																																																			BgL_effectz00_1761
																																																																				=
																																																																				BgL_effectz00_18898;
																																																																			goto
																																																																				BgL_tagzd2394zd2_1763;
																																																																		}
																																																																		BgL_auxz00_14266
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_18897);
																																																																	}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_18906;
																																																																			goto
																																																																				BgL_tagzd2395zd2_1764;
																																																																			BgL_auxz00_14266
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_18906);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_18913;
																																																																					goto
																																																																						BgL_tagzd2396zd2_1765;
																																																																					BgL_auxz00_14266
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_18913);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																						{
																																																																							BgL_letzd2funzd2_bglt
																																																																								BgL_auxz00_18920;
																																																																							goto
																																																																								BgL_tagzd2397zd2_1766;
																																																																							BgL_auxz00_14266
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_18920);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																								{
																																																																									BgL_jumpzd2exzd2itz00_bglt
																																																																										BgL_auxz00_18927;
																																																																									goto
																																																																										BgL_tagzd2398zd2_1767;
																																																																									BgL_auxz00_14266
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_18927);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 30))))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											bool_t
																																																																												BgL_test8830z00_18934;
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_tmpz00_18935;
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_pairz00_11022;
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_pairz00_11021;
																																																																														BgL_pairz00_11021
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_expz00_21));
																																																																														BgL_pairz00_11022
																																																																															=
																																																																															CDR
																																																																															(BgL_pairz00_11021);
																																																																													}
																																																																													BgL_tmpz00_18935
																																																																														=
																																																																														CDR
																																																																														(BgL_pairz00_11022);
																																																																												}
																																																																												BgL_test8830z00_18934
																																																																													=
																																																																													NULLP
																																																																													(BgL_tmpz00_18935);
																																																																											}
																																																																											if (BgL_test8830z00_18934)
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_18941;
																																																																													goto
																																																																														BgL_tagzd2399zd2_1768;
																																																																													BgL_auxz00_14266
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_18941);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1777;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_18945;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1778;
																																																																															BgL_auxz00_14266
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_18945);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd217512zd2_4322;
																																																																											BgL_cdrzd217512zd2_4322
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd217518zd2_4325;
																																																																													BgL_cdrzd217518zd2_4325
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd217512zd2_4322));
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_cdrzd217524zd2_4326;
																																																																														BgL_cdrzd217524zd2_4326
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd217518zd2_4325));
																																																																														if ((CAR(((obj_t) BgL_cdrzd217518zd2_4325)) == CNST_TABLE_REF(((long) 31))))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (PAIRP(BgL_cdrzd217524zd2_4326))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_arg3743z00_4330;
																																																																																		obj_t
																																																																																			BgL_arg3744z00_4331;
																																																																																		obj_t
																																																																																			BgL_arg3745z00_4332;
																																																																																		BgL_arg3743z00_4330
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd217512zd2_4322));
																																																																																		BgL_arg3744z00_4331
																																																																																			=
																																																																																			CAR
																																																																																			(BgL_cdrzd217524zd2_4326);
																																																																																		BgL_arg3745z00_4332
																																																																																			=
																																																																																			CDR
																																																																																			(BgL_cdrzd217524zd2_4326);
																																																																																		{	/* Ast/sexp.scm 550 */
																																																																																			obj_t
																																																																																				BgL_arg6964z00_11033;
																																																																																			BgL_arg6964z00_11033
																																																																																				=
																																																																																				BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																				(BgL_expz00_21,
																																																																																				BgL_locz00_23);
																																																																																			BgL_auxz00_14266
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																				(BgL_expz00_21,
																																																																																					BgL_arg3743z00_4330,
																																																																																					BgL_arg3744z00_4331,
																																																																																					BgL_arg3745z00_4332,
																																																																																					BgL_stackz00_22,
																																																																																					BgL_arg6964z00_11033,
																																																																																					BgL_sitez00_24));
																																																																																		}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_arg3746z00_4334;
																																																																																		obj_t
																																																																																			BgL_arg3747z00_4335;
																																																																																		BgL_arg3746z00_4334
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd217512zd2_4322));
																																																																																		BgL_arg3747z00_4335
																																																																																			=
																																																																																			CDR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd217512zd2_4322));
																																																																																		{	/* Ast/sexp.scm 552 */
																																																																																			obj_t
																																																																																				BgL_arg6965z00_11037;
																																																																																			BgL_arg6965z00_11037
																																																																																				=
																																																																																				BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																				(BgL_expz00_21,
																																																																																				BgL_locz00_23);
																																																																																			BgL_auxz00_14266
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																				(BgL_expz00_21,
																																																																																					BgL_arg3746z00_4334,
																																																																																					CNST_TABLE_REF
																																																																																					(((long) 4)), BgL_arg3747z00_4335, BgL_stackz00_22, BgL_arg6965z00_11037, BgL_sitez00_24));
																																																																															}}}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_arg3748z00_4337;
																																																																																obj_t
																																																																																	BgL_arg3749z00_4338;
																																																																																BgL_arg3748z00_4337
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd217512zd2_4322));
																																																																																BgL_arg3749z00_4338
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd217512zd2_4322));
																																																																																{	/* Ast/sexp.scm 552 */
																																																																																	obj_t
																																																																																		BgL_arg6965z00_11041;
																																																																																	BgL_arg6965z00_11041
																																																																																		=
																																																																																		BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																		(BgL_expz00_21,
																																																																																		BgL_locz00_23);
																																																																																	BgL_auxz00_14266
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																		(BgL_expz00_21,
																																																																																			BgL_arg3748z00_4337,
																																																																																			CNST_TABLE_REF
																																																																																			(((long) 4)), BgL_arg3749z00_4338, BgL_stackz00_22, BgL_arg6965z00_11041, BgL_sitez00_24));
																																																																												}}}}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1777;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_18990;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1778;
																																																																															BgL_auxz00_14266
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_18990);
																																																																														}
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																											else
																												{	/* Ast/sexp.scm 119 */
																													obj_t
																														BgL_carzd217575zd2_4357;
																													BgL_carzd217575zd2_4357
																														=
																														CAR(((obj_t)
																															BgL_expz00_21));
																													if (
																														(BgL_carzd217575zd2_4357
																															==
																															CNST_TABLE_REF((
																																	(long) 1))))
																														{
																															BgL_nodez00_bglt
																																BgL_auxz00_18997;
																															goto
																																BgL_tagzd2377zd2_1722;
																															BgL_auxz00_14266 =
																																((obj_t)
																																BgL_auxz00_18997);
																														}
																													else
																														{	/* Ast/sexp.scm 119 */
																															if (
																																(BgL_carzd217575zd2_4357
																																	==
																																	BGl_za2ifza2z00zzast_sexpz00))
																																{
																																	BgL_nodez00_bglt
																																		BgL_auxz00_19001;
																																	goto
																																		BgL_tagzd2377zd2_1722;
																																	BgL_auxz00_14266
																																		=
																																		((obj_t)
																																		BgL_auxz00_19001);
																																}
																															else
																																{	/* Ast/sexp.scm 119 */
																																	if (
																																		(CAR(
																																				((obj_t)
																																					BgL_expz00_21))
																																			==
																																			CNST_TABLE_REF
																																			(((long)
																																					7))))
																																		{
																																			BgL_nodez00_bglt
																																				BgL_auxz00_19008;
																																			goto
																																				BgL_tagzd2379zd2_1726;
																																			BgL_auxz00_14266
																																				=
																																				((obj_t)
																																				BgL_auxz00_19008);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 119 */
																																			if (
																																				(CAR(
																																						((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																				{
																																					BgL_nodez00_bglt
																																						BgL_auxz00_19015;
																																					goto
																																						BgL_tagzd2380zd2_1727;
																																					BgL_auxz00_14266
																																						=
																																						(
																																						(obj_t)
																																						BgL_auxz00_19015);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					obj_t
																																						BgL_carzd217644zd2_4364;
																																					BgL_carzd217644zd2_4364
																																						=
																																						CAR(
																																						((obj_t) BgL_expz00_21));
																																					if (PAIRP(BgL_carzd217644zd2_4364))
																																						{	/* Ast/sexp.scm 119 */
																																							obj_t
																																								BgL_carzd217647zd2_4366;
																																							obj_t
																																								BgL_cdrzd217648zd2_4367;
																																							BgL_carzd217647zd2_4366
																																								=
																																								CAR
																																								(BgL_carzd217644zd2_4364);
																																							BgL_cdrzd217648zd2_4367
																																								=
																																								CDR
																																								(BgL_carzd217644zd2_4364);
																																							{

																																								if ((BgL_carzd217647zd2_4366 == CNST_TABLE_REF(((long) 17))))
																																									{	/* Ast/sexp.scm 119 */
																																									BgL_kapzd217649zd2_4368:
																																										if (PAIRP(BgL_cdrzd217648zd2_4367))
																																											{	/* Ast/sexp.scm 119 */
																																												obj_t
																																													BgL_cdrzd217652zd2_4550;
																																												BgL_cdrzd217652zd2_4550
																																													=
																																													CDR
																																													(BgL_cdrzd217648zd2_4367);
																																												if (PAIRP(BgL_cdrzd217652zd2_4550))
																																													{	/* Ast/sexp.scm 119 */
																																														if (NULLP(CDR(BgL_cdrzd217652zd2_4550)))
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_arg3903z00_4554;
																																																obj_t
																																																	BgL_arg3904z00_4555;
																																																BgL_arg3903z00_4554
																																																	=
																																																	CAR
																																																	(BgL_cdrzd217652zd2_4550);
																																																BgL_arg3904z00_4555
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_19037;
																																																	{
																																																		obj_t
																																																			BgL_argsz00_19039;
																																																		obj_t
																																																			BgL_bodyz00_19038;
																																																		BgL_bodyz00_19038
																																																			=
																																																			BgL_arg3903z00_4554;
																																																		BgL_argsz00_19039
																																																			=
																																																			BgL_arg3904z00_4555;
																																																		BgL_argsz00_1729
																																																			=
																																																			BgL_argsz00_19039;
																																																		BgL_bodyz00_1728
																																																			=
																																																			BgL_bodyz00_19038;
																																																		goto
																																																			BgL_tagzd2381zd2_1730;
																																																	}
																																																	BgL_auxz00_14266
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_19037);
																																																}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_cdrzd217676zd2_4556;
																																																BgL_cdrzd217676zd2_4556
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 119 */
																																																	bool_t
																																																		BgL_test8845z00_19043;
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_arg3973z00_4667;
																																																		BgL_arg3973z00_4667
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_test8845z00_19043
																																																			=
																																																			CBOOL
																																																			(BGl_letzd2symzf3z21zzast_letz00
																																																			(BgL_arg3973z00_4667));
																																																	}
																																																	if (BgL_test8845z00_19043)
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg3907z00_4559;
																																																			obj_t
																																																				BgL_arg3908z00_4560;
																																																			BgL_arg3907z00_4559
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd217676zd2_4556));
																																																			BgL_arg3908z00_4560
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd217676zd2_4556));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_19052;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_19054;
																																																					obj_t
																																																						BgL_bindingsz00_19053;
																																																					BgL_bindingsz00_19053
																																																						=
																																																						BgL_arg3907z00_4559;
																																																					BgL_exprz00_19054
																																																						=
																																																						BgL_arg3908z00_4560;
																																																					BgL_exprz00_1732
																																																						=
																																																						BgL_exprz00_19054;
																																																					BgL_bindingsz00_1731
																																																						=
																																																						BgL_bindingsz00_19053;
																																																					goto
																																																						BgL_tagzd2382zd2_1733;
																																																				}
																																																				BgL_auxz00_14266
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_19052);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			bool_t
																																																				BgL_test8846z00_19056;
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg3972z00_4666;
																																																				BgL_arg3972z00_4666
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test8846z00_19056
																																																					=
																																																					CBOOL
																																																					(BGl_labelszd2symzf3z21zzast_labelsz00
																																																					(BgL_arg3972z00_4666));
																																																			}
																																																			if (BgL_test8846z00_19056)
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_19061;
																																																					goto
																																																						BgL_tagzd2384zd2_1735;
																																																					BgL_auxz00_14266
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_19061);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_carzd217743zd2_4563;
																																																					BgL_carzd217743zd2_4563
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd217748zd2_4564;
																																																						BgL_cdrzd217748zd2_4564
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_carzd217743zd2_4563));
																																																						if ((CAR(((obj_t) BgL_carzd217743zd2_4563)) == CNST_TABLE_REF(((long) 3))))
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg3913z00_4567;
																																																								obj_t
																																																									BgL_arg3914z00_4568;
																																																								obj_t
																																																									BgL_arg3915z00_4569;
																																																								BgL_arg3913z00_4567
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_cdrzd217748zd2_4564));
																																																								BgL_arg3914z00_4568
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_cdrzd217748zd2_4564));
																																																								BgL_arg3915z00_4569
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_19078;
																																																									{
																																																										obj_t
																																																											BgL_argsz00_19081;
																																																										obj_t
																																																											BgL_bodyz00_19080;
																																																										obj_t
																																																											BgL_varsz00_19079;
																																																										BgL_varsz00_19079
																																																											=
																																																											BgL_arg3913z00_4567;
																																																										BgL_bodyz00_19080
																																																											=
																																																											BgL_arg3914z00_4568;
																																																										BgL_argsz00_19081
																																																											=
																																																											BgL_arg3915z00_4569;
																																																										BgL_argsz00_1742
																																																											=
																																																											BgL_argsz00_19081;
																																																										BgL_bodyz00_1741
																																																											=
																																																											BgL_bodyz00_19080;
																																																										BgL_varsz00_1740
																																																											=
																																																											BgL_varsz00_19079;
																																																										goto
																																																											BgL_tagzd2386zd2_1743;
																																																									}
																																																									BgL_auxz00_14266
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_19078);
																																																								}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd217771zd2_4571;
																																																								BgL_cdrzd217771zd2_4571
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_cdrzd217777zd2_4572;
																																																									BgL_cdrzd217777zd2_4572
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_carzd217743zd2_4563));
																																																									if ((CAR(((obj_t) BgL_carzd217743zd2_4563)) == CNST_TABLE_REF(((long) 1))))
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_cdrzd217783zd2_4575;
																																																											BgL_cdrzd217783zd2_4575
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd217777zd2_4572));
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_carzd217788zd2_4576;
																																																												obj_t
																																																													BgL_cdrzd217789zd2_4577;
																																																												BgL_carzd217788zd2_4576
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd217783zd2_4575));
																																																												BgL_cdrzd217789zd2_4577
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd217783zd2_4575));
																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd217788zd2_4576))
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (PAIRP(BgL_cdrzd217789zd2_4577))
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_carzd217796zd2_4580;
																																																																BgL_carzd217796zd2_4580
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd217789zd2_4577);
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd217796zd2_4580))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (NULLP(CDR(BgL_cdrzd217789zd2_4577)))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				bool_t
																																																																					BgL_test8853z00_19108;
																																																																				{
																																																																					obj_t
																																																																						BgL_l1396z00_4613;
																																																																					BgL_l1396z00_4613
																																																																						=
																																																																						BgL_cdrzd217771zd2_4571;
																																																																				BgL_zc3z04anonymousza33938ze3z87_4614:
																																																																					if (NULLP(BgL_l1396z00_4613))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							BgL_test8853z00_19108
																																																																								=
																																																																								(
																																																																								(bool_t)
																																																																								1);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							bool_t
																																																																								BgL_test8855z00_19111;
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								bool_t
																																																																									BgL_test8856z00_19112;
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_tmpz00_19113;
																																																																									BgL_tmpz00_19113
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_l1396z00_4613));
																																																																									BgL_test8856z00_19112
																																																																										=
																																																																										PAIRP
																																																																										(BgL_tmpz00_19113);
																																																																								}
																																																																								if (BgL_test8856z00_19112)
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										BgL_test8855z00_19111
																																																																											=
																																																																											(
																																																																											(bool_t)
																																																																											0);
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										BgL_test8855z00_19111
																																																																											=
																																																																											(
																																																																											(bool_t)
																																																																											1);
																																																																									}
																																																																							}
																																																																							if (BgL_test8855z00_19111)
																																																																								{
																																																																									obj_t
																																																																										BgL_l1396z00_19117;
																																																																									BgL_l1396z00_19117
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_l1396z00_4613));
																																																																									BgL_l1396z00_4613
																																																																										=
																																																																										BgL_l1396z00_19117;
																																																																									goto
																																																																										BgL_zc3z04anonymousza33938ze3z87_4614;
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									BgL_test8853z00_19108
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										0);
																																																																								}
																																																																						}
																																																																				}
																																																																				if (BgL_test8853z00_19108)
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_arg3928z00_4596;
																																																																						BgL_arg3928z00_4596
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd217777zd2_4572));
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_19122;
																																																																							{
																																																																								obj_t
																																																																									BgL_argsz00_19126;
																																																																								obj_t
																																																																									BgL_proc2z00_19125;
																																																																								obj_t
																																																																									BgL_proc1z00_19124;
																																																																								obj_t
																																																																									BgL_testz00_19123;
																																																																								BgL_testz00_19123
																																																																									=
																																																																									BgL_arg3928z00_4596;
																																																																								BgL_proc1z00_19124
																																																																									=
																																																																									BgL_carzd217788zd2_4576;
																																																																								BgL_proc2z00_19125
																																																																									=
																																																																									BgL_carzd217796zd2_4580;
																																																																								BgL_argsz00_19126
																																																																									=
																																																																									BgL_cdrzd217771zd2_4571;
																																																																								BgL_argsz00_1747
																																																																									=
																																																																									BgL_argsz00_19126;
																																																																								BgL_proc2z00_1746
																																																																									=
																																																																									BgL_proc2z00_19125;
																																																																								BgL_proc1z00_1745
																																																																									=
																																																																									BgL_proc1z00_19124;
																																																																								BgL_testz00_1744
																																																																									=
																																																																									BgL_testz00_19123;
																																																																								goto
																																																																									BgL_tagzd2387zd2_1748;
																																																																							}
																																																																							BgL_auxz00_14266
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_19122);
																																																																						}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd217820zd2_4597;
																																																																						BgL_cdrzd217820zd2_4597
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd217827zd2_4598;
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_pairz00_11085;
																																																																								BgL_pairz00_11085
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								BgL_cdrzd217827zd2_4598
																																																																									=
																																																																									CDR
																																																																									(BgL_pairz00_11085);
																																																																							}
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd217834zd2_4599;
																																																																								BgL_cdrzd217834zd2_4599
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd217827zd2_4598));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd217840zd2_4600;
																																																																									BgL_carzd217840zd2_4600
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd217834zd2_4599));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd217840zd2_4600))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd217847zd2_4602;
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_pairz00_11089;
																																																																												BgL_pairz00_11089
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd217834zd2_4599));
																																																																												BgL_carzd217847zd2_4602
																																																																													=
																																																																													CAR
																																																																													(BgL_pairz00_11089);
																																																																											}
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd217847zd2_4602))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd217820zd2_4597))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg3932z00_4605;
																																																																															BgL_arg3932z00_4605
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd217827zd2_4598));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_19148;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_19152;
																																																																																	obj_t
																																																																																		BgL_proc2z00_19151;
																																																																																	obj_t
																																																																																		BgL_proc1z00_19150;
																																																																																	obj_t
																																																																																		BgL_testz00_19149;
																																																																																	BgL_testz00_19149
																																																																																		=
																																																																																		BgL_arg3932z00_4605;
																																																																																	BgL_proc1z00_19150
																																																																																		=
																																																																																		BgL_carzd217840zd2_4600;
																																																																																	BgL_proc2z00_19151
																																																																																		=
																																																																																		BgL_carzd217847zd2_4602;
																																																																																	BgL_argsz00_19152
																																																																																		=
																																																																																		BgL_cdrzd217820zd2_4597;
																																																																																	BgL_argsz00_1752
																																																																																		=
																																																																																		BgL_argsz00_19152;
																																																																																	BgL_proc2z00_1751
																																																																																		=
																																																																																		BgL_proc2z00_19151;
																																																																																	BgL_proc1z00_1750
																																																																																		=
																																																																																		BgL_proc1z00_19150;
																																																																																	BgL_testz00_1749
																																																																																		=
																																																																																		BgL_testz00_19149;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1753;
																																																																																}
																																																																																BgL_auxz00_14266
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_19148);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1777;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_19156;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1778;
																																																																																	BgL_auxz00_14266
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_19156);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1777;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_19160;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1778;
																																																																															BgL_auxz00_14266
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_19160);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1777;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_19164;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1778;
																																																																													BgL_auxz00_14266
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_19164);
																																																																												}
																																																																										}
																																																																								}
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1777;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_19168;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1778;
																																																																						BgL_auxz00_14266
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_19168);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd218123zd2_4624;
																																																																		BgL_cdrzd218123zd2_4624
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd218129zd2_4625;
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_pairz00_11093;
																																																																				BgL_pairz00_11093
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				BgL_cdrzd218129zd2_4625
																																																																					=
																																																																					CDR
																																																																					(BgL_pairz00_11093);
																																																																			}
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd218135zd2_4626;
																																																																				BgL_cdrzd218135zd2_4626
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd218129zd2_4625));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_carzd218140zd2_4627;
																																																																					obj_t
																																																																						BgL_cdrzd218141zd2_4628;
																																																																					BgL_carzd218140zd2_4627
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd218135zd2_4626));
																																																																					BgL_cdrzd218141zd2_4628
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd218135zd2_4626));
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd218140zd2_4627))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd218146zd2_4630;
																																																																							BgL_carzd218146zd2_4630
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd218141zd2_4628));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd218146zd2_4630))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (NULLP(CDR(((obj_t) BgL_cdrzd218141zd2_4628))))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd218123zd2_4624))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_arg3947z00_4635;
																																																																													BgL_arg3947z00_4635
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd218129zd2_4625));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_19195;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_19199;
																																																																															obj_t
																																																																																BgL_proc2z00_19198;
																																																																															obj_t
																																																																																BgL_proc1z00_19197;
																																																																															obj_t
																																																																																BgL_testz00_19196;
																																																																															BgL_testz00_19196
																																																																																=
																																																																																BgL_arg3947z00_4635;
																																																																															BgL_proc1z00_19197
																																																																																=
																																																																																BgL_carzd218140zd2_4627;
																																																																															BgL_proc2z00_19198
																																																																																=
																																																																																BgL_carzd218146zd2_4630;
																																																																															BgL_argsz00_19199
																																																																																=
																																																																																BgL_cdrzd218123zd2_4624;
																																																																															BgL_argsz00_1752
																																																																																=
																																																																																BgL_argsz00_19199;
																																																																															BgL_proc2z00_1751
																																																																																=
																																																																																BgL_proc2z00_19198;
																																																																															BgL_proc1z00_1750
																																																																																=
																																																																																BgL_proc1z00_19197;
																																																																															BgL_testz00_1749
																																																																																=
																																																																																BgL_testz00_19196;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1753;
																																																																														}
																																																																														BgL_auxz00_14266
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_19195);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1777;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_19203;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1778;
																																																																															BgL_auxz00_14266
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_19203);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1777;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_19207;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1778;
																																																																													BgL_auxz00_14266
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_19207);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1777;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_19211;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1778;
																																																																											BgL_auxz00_14266
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_19211);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1777;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_19215;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1778;
																																																																									BgL_auxz00_14266
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_19215);
																																																																								}
																																																																						}
																																																																				}
																																																																			}
																																																																		}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1777;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_19219;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1778;
																																																																		BgL_auxz00_14266
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_19219);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd218479zd2_4643;
																																																														BgL_cdrzd218479zd2_4643
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd218486zd2_4644;
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_pairz00_11103;
																																																																BgL_pairz00_11103
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																BgL_cdrzd218486zd2_4644
																																																																	=
																																																																	CDR
																																																																	(BgL_pairz00_11103);
																																																															}
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd218493zd2_4645;
																																																																BgL_cdrzd218493zd2_4645
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd218486zd2_4644));
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_carzd218499zd2_4646;
																																																																	obj_t
																																																																		BgL_cdrzd218500zd2_4647;
																																																																	BgL_carzd218499zd2_4646
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd218493zd2_4645));
																																																																	BgL_cdrzd218500zd2_4647
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd218493zd2_4645));
																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd218499zd2_4646))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (PAIRP(BgL_cdrzd218500zd2_4647))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_carzd218507zd2_4650;
																																																																					BgL_carzd218507zd2_4650
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd218500zd2_4647);
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd218507zd2_4650))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (NULLP(CDR(BgL_cdrzd218500zd2_4647)))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd218479zd2_4643))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_arg3961z00_4655;
																																																																											BgL_arg3961z00_4655
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd218486zd2_4644));
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_19246;
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_19250;
																																																																													obj_t
																																																																														BgL_proc2z00_19249;
																																																																													obj_t
																																																																														BgL_proc1z00_19248;
																																																																													obj_t
																																																																														BgL_testz00_19247;
																																																																													BgL_testz00_19247
																																																																														=
																																																																														BgL_arg3961z00_4655;
																																																																													BgL_proc1z00_19248
																																																																														=
																																																																														BgL_carzd218499zd2_4646;
																																																																													BgL_proc2z00_19249
																																																																														=
																																																																														BgL_carzd218507zd2_4650;
																																																																													BgL_argsz00_19250
																																																																														=
																																																																														BgL_cdrzd218479zd2_4643;
																																																																													BgL_argsz00_1752
																																																																														=
																																																																														BgL_argsz00_19250;
																																																																													BgL_proc2z00_1751
																																																																														=
																																																																														BgL_proc2z00_19249;
																																																																													BgL_proc1z00_1750
																																																																														=
																																																																														BgL_proc1z00_19248;
																																																																													BgL_testz00_1749
																																																																														=
																																																																														BgL_testz00_19247;
																																																																													goto
																																																																														BgL_tagzd2388zd2_1753;
																																																																												}
																																																																												BgL_auxz00_14266
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_19246);
																																																																											}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1777;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_19254;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1778;
																																																																													BgL_auxz00_14266
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_19254);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1777;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_19258;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1778;
																																																																											BgL_auxz00_14266
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_19258);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1777;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_19262;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1778;
																																																																									BgL_auxz00_14266
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_19262);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1777;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_19266;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1778;
																																																																							BgL_auxz00_14266
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_19266);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1777;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_19270;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1778;
																																																																					BgL_auxz00_14266
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_19270);
																																																																				}
																																																																		}
																																																																}
																																																															}
																																																														}
																																																													}
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{	/* Ast/sexp.scm 119 */
																																																													goto
																																																														BgL_tagzd2403zd2_1777;
																																																												}
																																																											else
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_19274;
																																																													goto
																																																														BgL_tagzd2404zd2_1778;
																																																													BgL_auxz00_14266
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_19274);
																																																												}
																																																										}
																																																								}
																																																							}
																																																					}
																																																				}
																																																		}
																																																}
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_cdrzd218900zd2_4669;
																																														BgL_cdrzd218900zd2_4669
																																															=
																																															CDR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{	/* Ast/sexp.scm 119 */
																																															bool_t
																																																BgL_test8884z00_19278;
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_arg3989z00_4686;
																																																BgL_arg3989z00_4686
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																BgL_test8884z00_19278
																																																	=
																																																	CBOOL
																																																	(BGl_letzd2symzf3z21zzast_letz00
																																																	(BgL_arg3989z00_4686));
																																															}
																																															if (BgL_test8884z00_19278)
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg3977z00_4672;
																																																	obj_t
																																																		BgL_arg3978z00_4673;
																																																	BgL_arg3977z00_4672
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd218900zd2_4669));
																																																	BgL_arg3978z00_4673
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd218900zd2_4669));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_19287;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_19289;
																																																			obj_t
																																																				BgL_bindingsz00_19288;
																																																			BgL_bindingsz00_19288
																																																				=
																																																				BgL_arg3977z00_4672;
																																																			BgL_exprz00_19289
																																																				=
																																																				BgL_arg3978z00_4673;
																																																			BgL_exprz00_1732
																																																				=
																																																				BgL_exprz00_19289;
																																																			BgL_bindingsz00_1731
																																																				=
																																																				BgL_bindingsz00_19288;
																																																			goto
																																																				BgL_tagzd2382zd2_1733;
																																																		}
																																																		BgL_auxz00_14266
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_19287);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	bool_t
																																																		BgL_test8885z00_19291;
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_arg3988z00_4685;
																																																		BgL_arg3988z00_4685
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_test8885z00_19291
																																																			=
																																																			CBOOL
																																																			(BGl_labelszd2symzf3z21zzast_labelsz00
																																																			(BgL_arg3988z00_4685));
																																																	}
																																																	if (BgL_test8885z00_19291)
																																																		{
																																																			BgL_letzd2funzd2_bglt
																																																				BgL_auxz00_19296;
																																																			goto
																																																				BgL_tagzd2384zd2_1735;
																																																			BgL_auxz00_14266
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_19296);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_carzd218966zd2_4676;
																																																			BgL_carzd218966zd2_4676
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd218971zd2_4677;
																																																				BgL_cdrzd218971zd2_4677
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_carzd218966zd2_4676));
																																																				if ((CAR(((obj_t) BgL_carzd218966zd2_4676)) == CNST_TABLE_REF(((long) 3))))
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg3983z00_4680;
																																																						obj_t
																																																							BgL_arg3984z00_4681;
																																																						obj_t
																																																							BgL_arg3985z00_4682;
																																																						BgL_arg3983z00_4680
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_cdrzd218971zd2_4677));
																																																						BgL_arg3984z00_4681
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_cdrzd218971zd2_4677));
																																																						BgL_arg3985z00_4682
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_19313;
																																																							{
																																																								obj_t
																																																									BgL_argsz00_19316;
																																																								obj_t
																																																									BgL_bodyz00_19315;
																																																								obj_t
																																																									BgL_varsz00_19314;
																																																								BgL_varsz00_19314
																																																									=
																																																									BgL_arg3983z00_4680;
																																																								BgL_bodyz00_19315
																																																									=
																																																									BgL_arg3984z00_4681;
																																																								BgL_argsz00_19316
																																																									=
																																																									BgL_arg3985z00_4682;
																																																								BgL_argsz00_1742
																																																									=
																																																									BgL_argsz00_19316;
																																																								BgL_bodyz00_1741
																																																									=
																																																									BgL_bodyz00_19315;
																																																								BgL_varsz00_1740
																																																									=
																																																									BgL_varsz00_19314;
																																																								goto
																																																									BgL_tagzd2386zd2_1743;
																																																							}
																																																							BgL_auxz00_14266
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_19313);
																																																						}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																							{	/* Ast/sexp.scm 119 */
																																																								goto
																																																									BgL_tagzd2403zd2_1777;
																																																							}
																																																						else
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_19320;
																																																								goto
																																																									BgL_tagzd2404zd2_1778;
																																																								BgL_auxz00_14266
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_19320);
																																																							}
																																																					}
																																																			}
																																																		}
																																																}
																																														}
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												obj_t
																																													BgL_cdrzd219082zd2_4687;
																																												BgL_cdrzd219082zd2_4687
																																													=
																																													CDR
																																													(
																																													((obj_t) BgL_expz00_21));
																																												{	/* Ast/sexp.scm 119 */
																																													bool_t
																																														BgL_test8888z00_19324;
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_arg3998z00_4696;
																																														BgL_arg3998z00_4696
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														BgL_test8888z00_19324
																																															=
																																															CBOOL
																																															(BGl_letzd2symzf3z21zzast_letz00
																																															(BgL_arg3998z00_4696));
																																													}
																																													if (BgL_test8888z00_19324)
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg3992z00_4690;
																																															obj_t
																																																BgL_arg3993z00_4691;
																																															BgL_arg3992z00_4690
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd219082zd2_4687));
																																															BgL_arg3993z00_4691
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd219082zd2_4687));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_19333;
																																																{
																																																	obj_t
																																																		BgL_exprz00_19335;
																																																	obj_t
																																																		BgL_bindingsz00_19334;
																																																	BgL_bindingsz00_19334
																																																		=
																																																		BgL_arg3992z00_4690;
																																																	BgL_exprz00_19335
																																																		=
																																																		BgL_arg3993z00_4691;
																																																	BgL_exprz00_1732
																																																		=
																																																		BgL_exprz00_19335;
																																																	BgL_bindingsz00_1731
																																																		=
																																																		BgL_bindingsz00_19334;
																																																	goto
																																																		BgL_tagzd2382zd2_1733;
																																																}
																																																BgL_auxz00_14266
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_19333);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															bool_t
																																																BgL_test8889z00_19337;
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_arg3997z00_4695;
																																																BgL_arg3997z00_4695
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																BgL_test8889z00_19337
																																																	=
																																																	CBOOL
																																																	(BGl_labelszd2symzf3z21zzast_labelsz00
																																																	(BgL_arg3997z00_4695));
																																															}
																																															if (BgL_test8889z00_19337)
																																																{
																																																	BgL_letzd2funzd2_bglt
																																																		BgL_auxz00_19342;
																																																	goto
																																																		BgL_tagzd2384zd2_1735;
																																																	BgL_auxz00_14266
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_19342);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																		{	/* Ast/sexp.scm 119 */
																																																			goto
																																																				BgL_tagzd2403zd2_1777;
																																																		}
																																																	else
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_19346;
																																																			goto
																																																				BgL_tagzd2404zd2_1778;
																																																			BgL_auxz00_14266
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_19346);
																																																		}
																																																}
																																														}
																																												}
																																											}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 119 */
																																										if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd217647zd2_4366)))
																																											{	/* Ast/sexp.scm 119 */
																																												goto
																																													BgL_kapzd217649zd2_4368;
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												if ((BgL_carzd217647zd2_4366 == CNST_TABLE_REF(((long) 18))))
																																													{	/* Ast/sexp.scm 119 */
																																														goto
																																															BgL_kapzd217649zd2_4368;
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														if ((BgL_carzd217647zd2_4366 == CNST_TABLE_REF(((long) 19))))
																																															{	/* Ast/sexp.scm 119 */
																																																goto
																																																	BgL_kapzd217649zd2_4368;
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd217647zd2_4366)))
																																																	{	/* Ast/sexp.scm 119 */
																																																		goto
																																																			BgL_kapzd217649zd2_4368;
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_cdrzd219254zd2_4374;
																																																		BgL_cdrzd219254zd2_4374
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 119 */
																																																			bool_t
																																																				BgL_test8895z00_19362;
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg3898z00_4548;
																																																				BgL_arg3898z00_4548
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test8895z00_19362
																																																					=
																																																					CBOOL
																																																					(BGl_letzd2symzf3z21zzast_letz00
																																																					(BgL_arg3898z00_4548));
																																																			}
																																																			if (BgL_test8895z00_19362)
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_arg3782z00_4377;
																																																					obj_t
																																																						BgL_arg3783z00_4378;
																																																					BgL_arg3782z00_4377
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd219254zd2_4374));
																																																					BgL_arg3783z00_4378
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd219254zd2_4374));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_19371;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_19373;
																																																							obj_t
																																																								BgL_bindingsz00_19372;
																																																							BgL_bindingsz00_19372
																																																								=
																																																								BgL_arg3782z00_4377;
																																																							BgL_exprz00_19373
																																																								=
																																																								BgL_arg3783z00_4378;
																																																							BgL_exprz00_1732
																																																								=
																																																								BgL_exprz00_19373;
																																																							BgL_bindingsz00_1731
																																																								=
																																																								BgL_bindingsz00_19372;
																																																							goto
																																																								BgL_tagzd2382zd2_1733;
																																																						}
																																																						BgL_auxz00_14266
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_19371);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					bool_t
																																																						BgL_test8896z00_19375;
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg3897z00_4547;
																																																						BgL_arg3897z00_4547
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test8896z00_19375
																																																							=
																																																							CBOOL
																																																							(BGl_labelszd2symzf3z21zzast_labelsz00
																																																							(BgL_arg3897z00_4547));
																																																					}
																																																					if (BgL_test8896z00_19375)
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_19380;
																																																							goto
																																																								BgL_tagzd2384zd2_1735;
																																																							BgL_auxz00_14266
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_19380);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_carzd219307zd2_4381;
																																																							obj_t
																																																								BgL_cdrzd219308zd2_4382;
																																																							BgL_carzd219307zd2_4381
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							BgL_cdrzd219308zd2_4382
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd219312zd2_4383;
																																																								BgL_cdrzd219312zd2_4383
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_carzd219307zd2_4381));
																																																								if ((CAR(((obj_t) BgL_carzd219307zd2_4381)) == CNST_TABLE_REF(((long) 3))))
																																																									{	/* Ast/sexp.scm 119 */
																																																										if (PAIRP(BgL_cdrzd219312zd2_4383))
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_carzd219315zd2_4387;
																																																												obj_t
																																																													BgL_cdrzd219316zd2_4388;
																																																												BgL_carzd219315zd2_4387
																																																													=
																																																													CAR
																																																													(BgL_cdrzd219312zd2_4383);
																																																												BgL_cdrzd219316zd2_4388
																																																													=
																																																													CDR
																																																													(BgL_cdrzd219312zd2_4383);
																																																												if (PAIRP(BgL_carzd219315zd2_4387))
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (NULLP(CDR(BgL_carzd219315zd2_4387)))
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (PAIRP(BgL_cdrzd219316zd2_4388))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_carzd219322zd2_4393;
																																																																		BgL_carzd219322zd2_4393
																																																																			=
																																																																			CAR
																																																																			(BgL_cdrzd219316zd2_4388);
																																																																		if (PAIRP(BgL_carzd219322zd2_4393))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_castzd2sexpzf3z21zzast_privatez00(BgL_carzd219322zd2_4393))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (NULLP(CDR(BgL_cdrzd219316zd2_4388)))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_carzd219329zd2_4398;
																																																																								BgL_carzd219329zd2_4398
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd219308zd2_4382));
																																																																								if (PAIRP(BgL_carzd219329zd2_4398))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd219354zd2_4400;
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_pairz00_11151;
																																																																											BgL_pairz00_11151
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											BgL_cdrzd219354zd2_4400
																																																																												=
																																																																												CDR
																																																																												(BgL_pairz00_11151);
																																																																										}
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_arg3798z00_4401;
																																																																											obj_t
																																																																												BgL_arg3799z00_4402;
																																																																											obj_t
																																																																												BgL_arg3800z00_4403;
																																																																											BgL_arg3798z00_4401
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd219354zd2_4400));
																																																																											BgL_arg3799z00_4402
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd219354zd2_4400));
																																																																											BgL_arg3800z00_4403
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_19425;
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_19428;
																																																																													obj_t
																																																																														BgL_bodyz00_19427;
																																																																													obj_t
																																																																														BgL_varsz00_19426;
																																																																													BgL_varsz00_19426
																																																																														=
																																																																														BgL_arg3798z00_4401;
																																																																													BgL_bodyz00_19427
																																																																														=
																																																																														BgL_arg3799z00_4402;
																																																																													BgL_argsz00_19428
																																																																														=
																																																																														BgL_arg3800z00_4403;
																																																																													BgL_argsz00_1742
																																																																														=
																																																																														BgL_argsz00_19428;
																																																																													BgL_bodyz00_1741
																																																																														=
																																																																														BgL_bodyz00_19427;
																																																																													BgL_varsz00_1740
																																																																														=
																																																																														BgL_varsz00_19426;
																																																																													goto
																																																																														BgL_tagzd2386zd2_1743;
																																																																												}
																																																																												BgL_auxz00_14266
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_19425);
																																																																											}
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (NULLP(CDR(((obj_t) BgL_cdrzd219308zd2_4382))))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_arg3804z00_4407;
																																																																												BgL_arg3804z00_4407
																																																																													=
																																																																													CAR
																																																																													(BgL_carzd219315zd2_4387);
																																																																												{
																																																																													BgL_castz00_bglt
																																																																														BgL_auxz00_19435;
																																																																													BgL_varz00_1736
																																																																														=
																																																																														BgL_arg3804z00_4407;
																																																																													BgL_bodyz00_1737
																																																																														=
																																																																														BgL_carzd219322zd2_4393;
																																																																													BgL_argz00_1738
																																																																														=
																																																																														BgL_carzd219329zd2_4398;
																																																																												BgL_tagzd2385zd2_1739:
																																																																													{	/* Ast/sexp.scm 375 */
																																																																														BgL_castz00_bglt
																																																																															BgL_new1138z00_8744;
																																																																														{	/* Ast/sexp.scm 376 */
																																																																															BgL_castz00_bglt
																																																																																BgL_new1137z00_8746;
																																																																															BgL_new1137z00_8746
																																																																																=
																																																																																(
																																																																																(BgL_castz00_bglt)
																																																																																BOBJECT
																																																																																(GC_MALLOC
																																																																																	(sizeof
																																																																																		(struct
																																																																																			BgL_castz00_bgl))));
																																																																															{	/* Ast/sexp.scm 376 */
																																																																																long
																																																																																	BgL_arg6815z00_8747;
																																																																																{	/* Ast/sexp.scm 376 */
																																																																																	long
																																																																																		BgL_res7409z00_9964;
																																																																																	BgL_res7409z00_9964
																																																																																		=
																																																																																		BGL_CLASS_INDEX
																																																																																		(BGl_castz00zzast_nodez00);
																																																																																	BgL_arg6815z00_8747
																																																																																		=
																																																																																		BgL_res7409z00_9964;
																																																																																}
																																																																																BGL_OBJECT_CLASS_NUM_SET
																																																																																	(
																																																																																	((BgL_objectz00_bglt) BgL_new1137z00_8746), BgL_arg6815z00_8747);
																																																																															}
																																																																															{	/* Ast/sexp.scm 376 */
																																																																																BgL_objectz00_bglt
																																																																																	BgL_tmpz00_19440;
																																																																																BgL_tmpz00_19440
																																																																																	=
																																																																																	(
																																																																																	(BgL_objectz00_bglt)
																																																																																	BgL_new1137z00_8746);
																																																																																BGL_OBJECT_WIDENING_SET
																																																																																	(BgL_tmpz00_19440,
																																																																																	BFALSE);
																																																																															}
																																																																															((BgL_objectz00_bglt) BgL_new1137z00_8746);
																																																																															BgL_new1138z00_8744
																																																																																=
																																																																																BgL_new1137z00_8746;
																																																																														}
																																																																														((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1138z00_8744)))->BgL_locz00) = ((obj_t) BgL_locz00_23), BUNSPEC);
																																																																														{
																																																																															BgL_typez00_bglt
																																																																																BgL_auxz00_19446;
																																																																															{	/* Ast/sexp.scm 377 */
																																																																																obj_t
																																																																																	BgL_arg6814z00_8745;
																																																																																BgL_arg6814z00_8745
																																																																																	=
																																																																																	BGl_castzd2sexpzd2typez00zzast_privatez00
																																																																																	(BgL_bodyz00_1737);
																																																																																BgL_auxz00_19446
																																																																																	=
																																																																																	BGl_usezd2typez12zc0zztype_envz00
																																																																																	(BgL_arg6814z00_8745,
																																																																																	BgL_locz00_23);
																																																																															}
																																																																															((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1138z00_8744)))->BgL_typez00) = ((BgL_typez00_bglt) BgL_auxz00_19446), BUNSPEC);
																																																																														}
																																																																														((((BgL_castz00_bglt) COBJECT(BgL_new1138z00_8744))->BgL_argz00) = ((BgL_nodez00_bglt) BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_argz00_1738, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24)), BUNSPEC);
																																																																														BgL_auxz00_19435
																																																																															=
																																																																															BgL_new1138z00_8744;
																																																																													}
																																																																													BgL_auxz00_14266
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_19435);
																																																																											}}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_cdrzd219382zd2_4408;
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_pairz00_11159;
																																																																													BgL_pairz00_11159
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													BgL_cdrzd219382zd2_4408
																																																																														=
																																																																														CDR
																																																																														(BgL_pairz00_11159);
																																																																												}
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_arg3805z00_4409;
																																																																													obj_t
																																																																														BgL_arg3806z00_4410;
																																																																													obj_t
																																																																														BgL_arg3807z00_4411;
																																																																													BgL_arg3805z00_4409
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd219382zd2_4408));
																																																																													BgL_arg3806z00_4410
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd219382zd2_4408));
																																																																													BgL_arg3807z00_4411
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_19463;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_19466;
																																																																															obj_t
																																																																																BgL_bodyz00_19465;
																																																																															obj_t
																																																																																BgL_varsz00_19464;
																																																																															BgL_varsz00_19464
																																																																																=
																																																																																BgL_arg3805z00_4409;
																																																																															BgL_bodyz00_19465
																																																																																=
																																																																																BgL_arg3806z00_4410;
																																																																															BgL_argsz00_19466
																																																																																=
																																																																																BgL_arg3807z00_4411;
																																																																															BgL_argsz00_1742
																																																																																=
																																																																																BgL_argsz00_19466;
																																																																															BgL_bodyz00_1741
																																																																																=
																																																																																BgL_bodyz00_19465;
																																																																															BgL_varsz00_1740
																																																																																=
																																																																																BgL_varsz00_19464;
																																																																															goto
																																																																																BgL_tagzd2386zd2_1743;
																																																																														}
																																																																														BgL_auxz00_14266
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_19463);
																																																																													}
																																																																												}
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd219408zd2_4414;
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_pairz00_11164;
																																																																									BgL_pairz00_11164
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									BgL_cdrzd219408zd2_4414
																																																																										=
																																																																										CDR
																																																																										(BgL_pairz00_11164);
																																																																								}
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_arg3810z00_4415;
																																																																									obj_t
																																																																										BgL_arg3811z00_4416;
																																																																									obj_t
																																																																										BgL_arg3812z00_4417;
																																																																									BgL_arg3810z00_4415
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd219408zd2_4414));
																																																																									BgL_arg3811z00_4416
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd219408zd2_4414));
																																																																									BgL_arg3812z00_4417
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_19477;
																																																																										{
																																																																											obj_t
																																																																												BgL_argsz00_19480;
																																																																											obj_t
																																																																												BgL_bodyz00_19479;
																																																																											obj_t
																																																																												BgL_varsz00_19478;
																																																																											BgL_varsz00_19478
																																																																												=
																																																																												BgL_arg3810z00_4415;
																																																																											BgL_bodyz00_19479
																																																																												=
																																																																												BgL_arg3811z00_4416;
																																																																											BgL_argsz00_19480
																																																																												=
																																																																												BgL_arg3812z00_4417;
																																																																											BgL_argsz00_1742
																																																																												=
																																																																												BgL_argsz00_19480;
																																																																											BgL_bodyz00_1741
																																																																												=
																																																																												BgL_bodyz00_19479;
																																																																											BgL_varsz00_1740
																																																																												=
																																																																												BgL_varsz00_19478;
																																																																											goto
																																																																												BgL_tagzd2386zd2_1743;
																																																																										}
																																																																										BgL_auxz00_14266
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_19477);
																																																																									}
																																																																								}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd219434zd2_4420;
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_pairz00_11169;
																																																																							BgL_pairz00_11169
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							BgL_cdrzd219434zd2_4420
																																																																								=
																																																																								CDR
																																																																								(BgL_pairz00_11169);
																																																																						}
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_arg3815z00_4421;
																																																																							obj_t
																																																																								BgL_arg3816z00_4422;
																																																																							obj_t
																																																																								BgL_arg3817z00_4423;
																																																																							BgL_arg3815z00_4421
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd219434zd2_4420));
																																																																							BgL_arg3816z00_4422
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd219434zd2_4420));
																																																																							BgL_arg3817z00_4423
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_19491;
																																																																								{
																																																																									obj_t
																																																																										BgL_argsz00_19494;
																																																																									obj_t
																																																																										BgL_bodyz00_19493;
																																																																									obj_t
																																																																										BgL_varsz00_19492;
																																																																									BgL_varsz00_19492
																																																																										=
																																																																										BgL_arg3815z00_4421;
																																																																									BgL_bodyz00_19493
																																																																										=
																																																																										BgL_arg3816z00_4422;
																																																																									BgL_argsz00_19494
																																																																										=
																																																																										BgL_arg3817z00_4423;
																																																																									BgL_argsz00_1742
																																																																										=
																																																																										BgL_argsz00_19494;
																																																																									BgL_bodyz00_1741
																																																																										=
																																																																										BgL_bodyz00_19493;
																																																																									BgL_varsz00_1740
																																																																										=
																																																																										BgL_varsz00_19492;
																																																																									goto
																																																																										BgL_tagzd2386zd2_1743;
																																																																								}
																																																																								BgL_auxz00_14266
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_19491);
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd219460zd2_4425;
																																																																				BgL_cdrzd219460zd2_4425
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_carzd219307zd2_4381));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_arg3819z00_4426;
																																																																					obj_t
																																																																						BgL_arg3820z00_4427;
																																																																					obj_t
																																																																						BgL_arg3821z00_4428;
																																																																					BgL_arg3819z00_4426
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd219460zd2_4425));
																																																																					BgL_arg3820z00_4427
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd219460zd2_4425));
																																																																					BgL_arg3821z00_4428
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_19504;
																																																																						{
																																																																							obj_t
																																																																								BgL_argsz00_19507;
																																																																							obj_t
																																																																								BgL_bodyz00_19506;
																																																																							obj_t
																																																																								BgL_varsz00_19505;
																																																																							BgL_varsz00_19505
																																																																								=
																																																																								BgL_arg3819z00_4426;
																																																																							BgL_bodyz00_19506
																																																																								=
																																																																								BgL_arg3820z00_4427;
																																																																							BgL_argsz00_19507
																																																																								=
																																																																								BgL_arg3821z00_4428;
																																																																							BgL_argsz00_1742
																																																																								=
																																																																								BgL_argsz00_19507;
																																																																							BgL_bodyz00_1741
																																																																								=
																																																																								BgL_bodyz00_19506;
																																																																							BgL_varsz00_1740
																																																																								=
																																																																								BgL_varsz00_19505;
																																																																							goto
																																																																								BgL_tagzd2386zd2_1743;
																																																																						}
																																																																						BgL_auxz00_14266
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_19504);
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd219486zd2_4430;
																																																																		BgL_cdrzd219486zd2_4430
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_carzd219307zd2_4381));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_arg3823z00_4431;
																																																																			obj_t
																																																																				BgL_arg3824z00_4432;
																																																																			obj_t
																																																																				BgL_arg3825z00_4433;
																																																																			BgL_arg3823z00_4431
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd219486zd2_4430));
																																																																			BgL_arg3824z00_4432
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd219486zd2_4430));
																																																																			BgL_arg3825z00_4433
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_expz00_21));
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_19517;
																																																																				{
																																																																					obj_t
																																																																						BgL_argsz00_19520;
																																																																					obj_t
																																																																						BgL_bodyz00_19519;
																																																																					obj_t
																																																																						BgL_varsz00_19518;
																																																																					BgL_varsz00_19518
																																																																						=
																																																																						BgL_arg3823z00_4431;
																																																																					BgL_bodyz00_19519
																																																																						=
																																																																						BgL_arg3824z00_4432;
																																																																					BgL_argsz00_19520
																																																																						=
																																																																						BgL_arg3825z00_4433;
																																																																					BgL_argsz00_1742
																																																																						=
																																																																						BgL_argsz00_19520;
																																																																					BgL_bodyz00_1741
																																																																						=
																																																																						BgL_bodyz00_19519;
																																																																					BgL_varsz00_1740
																																																																						=
																																																																						BgL_varsz00_19518;
																																																																					goto
																																																																						BgL_tagzd2386zd2_1743;
																																																																				}
																																																																				BgL_auxz00_14266
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_19517);
																																																																			}
																																																																		}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd219512zd2_4435;
																																																																BgL_cdrzd219512zd2_4435
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_carzd219307zd2_4381));
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_arg3827z00_4436;
																																																																	obj_t
																																																																		BgL_arg3828z00_4437;
																																																																	obj_t
																																																																		BgL_arg3829z00_4438;
																																																																	BgL_arg3827z00_4436
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd219512zd2_4435));
																																																																	BgL_arg3828z00_4437
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd219512zd2_4435));
																																																																	BgL_arg3829z00_4438
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_19530;
																																																																		{
																																																																			obj_t
																																																																				BgL_argsz00_19533;
																																																																			obj_t
																																																																				BgL_bodyz00_19532;
																																																																			obj_t
																																																																				BgL_varsz00_19531;
																																																																			BgL_varsz00_19531
																																																																				=
																																																																				BgL_arg3827z00_4436;
																																																																			BgL_bodyz00_19532
																																																																				=
																																																																				BgL_arg3828z00_4437;
																																																																			BgL_argsz00_19533
																																																																				=
																																																																				BgL_arg3829z00_4438;
																																																																			BgL_argsz00_1742
																																																																				=
																																																																				BgL_argsz00_19533;
																																																																			BgL_bodyz00_1741
																																																																				=
																																																																				BgL_bodyz00_19532;
																																																																			BgL_varsz00_1740
																																																																				=
																																																																				BgL_varsz00_19531;
																																																																			goto
																																																																				BgL_tagzd2386zd2_1743;
																																																																		}
																																																																		BgL_auxz00_14266
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_19530);
																																																																	}
																																																																}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd219538zd2_4441;
																																																														BgL_cdrzd219538zd2_4441
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_carzd219307zd2_4381));
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_arg3832z00_4442;
																																																															obj_t
																																																																BgL_arg3833z00_4443;
																																																															obj_t
																																																																BgL_arg3834z00_4444;
																																																															BgL_arg3832z00_4442
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd219538zd2_4441));
																																																															BgL_arg3833z00_4443
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd219538zd2_4441));
																																																															BgL_arg3834z00_4444
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_19543;
																																																																{
																																																																	obj_t
																																																																		BgL_argsz00_19546;
																																																																	obj_t
																																																																		BgL_bodyz00_19545;
																																																																	obj_t
																																																																		BgL_varsz00_19544;
																																																																	BgL_varsz00_19544
																																																																		=
																																																																		BgL_arg3832z00_4442;
																																																																	BgL_bodyz00_19545
																																																																		=
																																																																		BgL_arg3833z00_4443;
																																																																	BgL_argsz00_19546
																																																																		=
																																																																		BgL_arg3834z00_4444;
																																																																	BgL_argsz00_1742
																																																																		=
																																																																		BgL_argsz00_19546;
																																																																	BgL_bodyz00_1741
																																																																		=
																																																																		BgL_bodyz00_19545;
																																																																	BgL_varsz00_1740
																																																																		=
																																																																		BgL_varsz00_19544;
																																																																	goto
																																																																		BgL_tagzd2386zd2_1743;
																																																																}
																																																																BgL_auxz00_14266
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_19543);
																																																															}
																																																														}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 119 */
																																																														goto
																																																															BgL_tagzd2403zd2_1777;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_19550;
																																																														goto
																																																															BgL_tagzd2404zd2_1778;
																																																														BgL_auxz00_14266
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_19550);
																																																													}
																																																											}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd219676zd2_4449;
																																																										BgL_cdrzd219676zd2_4449
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_carzd219307zd2_4381));
																																																										if ((CAR(((obj_t) BgL_carzd219307zd2_4381)) == CNST_TABLE_REF(((long) 1))))
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (PAIRP(BgL_cdrzd219676zd2_4449))
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd219681zd2_4453;
																																																														BgL_cdrzd219681zd2_4453
																																																															=
																																																															CDR
																																																															(BgL_cdrzd219676zd2_4449);
																																																														if (PAIRP(BgL_cdrzd219681zd2_4453))
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_carzd219685zd2_4455;
																																																																obj_t
																																																																	BgL_cdrzd219686zd2_4456;
																																																																BgL_carzd219685zd2_4455
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd219681zd2_4453);
																																																																BgL_cdrzd219686zd2_4456
																																																																	=
																																																																	CDR
																																																																	(BgL_cdrzd219681zd2_4453);
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd219685zd2_4455))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (PAIRP(BgL_cdrzd219686zd2_4456))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_carzd219691zd2_4459;
																																																																				BgL_carzd219691zd2_4459
																																																																					=
																																																																					CAR
																																																																					(BgL_cdrzd219686zd2_4456);
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd219691zd2_4459))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (NULLP(CDR(BgL_cdrzd219686zd2_4456)))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								bool_t
																																																																									BgL_test8915z00_19576;
																																																																								{
																																																																									obj_t
																																																																										BgL_l1399z00_4492;
																																																																									BgL_l1399z00_4492
																																																																										=
																																																																										BgL_cdrzd219308zd2_4382;
																																																																								BgL_zc3z04anonymousza33861ze3z87_4493:
																																																																									if (NULLP(BgL_l1399z00_4492))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											BgL_test8915z00_19576
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												1);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											bool_t
																																																																												BgL_test8917z00_19579;
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												bool_t
																																																																													BgL_test8918z00_19580;
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_tmpz00_19581;
																																																																													BgL_tmpz00_19581
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_l1399z00_4492));
																																																																													BgL_test8918z00_19580
																																																																														=
																																																																														PAIRP
																																																																														(BgL_tmpz00_19581);
																																																																												}
																																																																												if (BgL_test8918z00_19580)
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														BgL_test8917z00_19579
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															0);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														BgL_test8917z00_19579
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															1);
																																																																													}
																																																																											}
																																																																											if (BgL_test8917z00_19579)
																																																																												{
																																																																													obj_t
																																																																														BgL_l1399z00_19585;
																																																																													BgL_l1399z00_19585
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_l1399z00_4492));
																																																																													BgL_l1399z00_4492
																																																																														=
																																																																														BgL_l1399z00_19585;
																																																																													goto
																																																																														BgL_zc3z04anonymousza33861ze3z87_4493;
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													BgL_test8915z00_19576
																																																																														=
																																																																														(
																																																																														(bool_t)
																																																																														0);
																																																																												}
																																																																										}
																																																																								}
																																																																								if (BgL_test8915z00_19576)
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_arg3851z00_4475;
																																																																										BgL_arg3851z00_4475
																																																																											=
																																																																											CAR
																																																																											(BgL_cdrzd219676zd2_4449);
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_19589;
																																																																											{
																																																																												obj_t
																																																																													BgL_argsz00_19593;
																																																																												obj_t
																																																																													BgL_proc2z00_19592;
																																																																												obj_t
																																																																													BgL_proc1z00_19591;
																																																																												obj_t
																																																																													BgL_testz00_19590;
																																																																												BgL_testz00_19590
																																																																													=
																																																																													BgL_arg3851z00_4475;
																																																																												BgL_proc1z00_19591
																																																																													=
																																																																													BgL_carzd219685zd2_4455;
																																																																												BgL_proc2z00_19592
																																																																													=
																																																																													BgL_carzd219691zd2_4459;
																																																																												BgL_argsz00_19593
																																																																													=
																																																																													BgL_cdrzd219308zd2_4382;
																																																																												BgL_argsz00_1747
																																																																													=
																																																																													BgL_argsz00_19593;
																																																																												BgL_proc2z00_1746
																																																																													=
																																																																													BgL_proc2z00_19592;
																																																																												BgL_proc1z00_1745
																																																																													=
																																																																													BgL_proc1z00_19591;
																																																																												BgL_testz00_1744
																																																																													=
																																																																													BgL_testz00_19590;
																																																																												goto
																																																																													BgL_tagzd2387zd2_1748;
																																																																											}
																																																																											BgL_auxz00_14266
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_19589);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd219716zd2_4476;
																																																																										BgL_cdrzd219716zd2_4476
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd219724zd2_4477;
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_pairz00_11213;
																																																																												BgL_pairz00_11213
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												BgL_cdrzd219724zd2_4477
																																																																													=
																																																																													CDR
																																																																													(BgL_pairz00_11213);
																																																																											}
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_cdrzd219732zd2_4478;
																																																																												BgL_cdrzd219732zd2_4478
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd219724zd2_4477));
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_carzd219739zd2_4479;
																																																																													BgL_carzd219739zd2_4479
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd219732zd2_4478));
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd219739zd2_4479))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_carzd219748zd2_4481;
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_pairz00_11217;
																																																																																BgL_pairz00_11217
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd219732zd2_4478));
																																																																																BgL_carzd219748zd2_4481
																																																																																	=
																																																																																	CAR
																																																																																	(BgL_pairz00_11217);
																																																																															}
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd219748zd2_4481))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd219716zd2_4476))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_arg3855z00_4484;
																																																																																			BgL_arg3855z00_4484
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd219724zd2_4477));
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_19615;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_19619;
																																																																																					obj_t
																																																																																						BgL_proc2z00_19618;
																																																																																					obj_t
																																																																																						BgL_proc1z00_19617;
																																																																																					obj_t
																																																																																						BgL_testz00_19616;
																																																																																					BgL_testz00_19616
																																																																																						=
																																																																																						BgL_arg3855z00_4484;
																																																																																					BgL_proc1z00_19617
																																																																																						=
																																																																																						BgL_carzd219739zd2_4479;
																																																																																					BgL_proc2z00_19618
																																																																																						=
																																																																																						BgL_carzd219748zd2_4481;
																																																																																					BgL_argsz00_19619
																																																																																						=
																																																																																						BgL_cdrzd219716zd2_4476;
																																																																																					BgL_argsz00_1752
																																																																																						=
																																																																																						BgL_argsz00_19619;
																																																																																					BgL_proc2z00_1751
																																																																																						=
																																																																																						BgL_proc2z00_19618;
																																																																																					BgL_proc1z00_1750
																																																																																						=
																																																																																						BgL_proc1z00_19617;
																																																																																					BgL_testz00_1749
																																																																																						=
																																																																																						BgL_testz00_19616;
																																																																																					goto
																																																																																						BgL_tagzd2388zd2_1753;
																																																																																				}
																																																																																				BgL_auxz00_14266
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_19615);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1777;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_19623;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1778;
																																																																																					BgL_auxz00_14266
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_19623);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1777;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_19627;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1778;
																																																																																			BgL_auxz00_14266
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_19627);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1777;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_19631;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1778;
																																																																																	BgL_auxz00_14266
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_19631);
																																																																																}
																																																																														}
																																																																												}
																																																																											}
																																																																										}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1777;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_19635;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1778;
																																																																										BgL_auxz00_14266
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_19635);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd220026zd2_4503;
																																																																						BgL_cdrzd220026zd2_4503
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd220033zd2_4504;
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_pairz00_11221;
																																																																								BgL_pairz00_11221
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								BgL_cdrzd220033zd2_4504
																																																																									=
																																																																									CDR
																																																																									(BgL_pairz00_11221);
																																																																							}
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd220040zd2_4505;
																																																																								BgL_cdrzd220040zd2_4505
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd220033zd2_4504));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd220046zd2_4506;
																																																																									obj_t
																																																																										BgL_cdrzd220047zd2_4507;
																																																																									BgL_carzd220046zd2_4506
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd220040zd2_4505));
																																																																									BgL_cdrzd220047zd2_4507
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd220040zd2_4505));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd220046zd2_4506))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd220054zd2_4509;
																																																																											BgL_carzd220054zd2_4509
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd220047zd2_4507));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd220054zd2_4509))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (NULLP(CDR(((obj_t) BgL_cdrzd220047zd2_4507))))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd220026zd2_4503))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_arg3870z00_4514;
																																																																																	BgL_arg3870z00_4514
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd220033zd2_4504));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_19662;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_19666;
																																																																																			obj_t
																																																																																				BgL_proc2z00_19665;
																																																																																			obj_t
																																																																																				BgL_proc1z00_19664;
																																																																																			obj_t
																																																																																				BgL_testz00_19663;
																																																																																			BgL_testz00_19663
																																																																																				=
																																																																																				BgL_arg3870z00_4514;
																																																																																			BgL_proc1z00_19664
																																																																																				=
																																																																																				BgL_carzd220046zd2_4506;
																																																																																			BgL_proc2z00_19665
																																																																																				=
																																																																																				BgL_carzd220054zd2_4509;
																																																																																			BgL_argsz00_19666
																																																																																				=
																																																																																				BgL_cdrzd220026zd2_4503;
																																																																																			BgL_argsz00_1752
																																																																																				=
																																																																																				BgL_argsz00_19666;
																																																																																			BgL_proc2z00_1751
																																																																																				=
																																																																																				BgL_proc2z00_19665;
																																																																																			BgL_proc1z00_1750
																																																																																				=
																																																																																				BgL_proc1z00_19664;
																																																																																			BgL_testz00_1749
																																																																																				=
																																																																																				BgL_testz00_19663;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1753;
																																																																																		}
																																																																																		BgL_auxz00_14266
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_19662);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1777;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_19670;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1778;
																																																																																			BgL_auxz00_14266
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_19670);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1777;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_19674;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1778;
																																																																																	BgL_auxz00_14266
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_19674);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1777;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_19678;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1778;
																																																																															BgL_auxz00_14266
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_19678);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1777;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_19682;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1778;
																																																																													BgL_auxz00_14266
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_19682);
																																																																												}
																																																																										}
																																																																								}
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1777;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_19686;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1778;
																																																																						BgL_auxz00_14266
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_19686);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd220387zd2_4522;
																																																																		BgL_cdrzd220387zd2_4522
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd220393zd2_4523;
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_pairz00_11231;
																																																																				BgL_pairz00_11231
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				BgL_cdrzd220393zd2_4523
																																																																					=
																																																																					CDR
																																																																					(BgL_pairz00_11231);
																																																																			}
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd220399zd2_4524;
																																																																				BgL_cdrzd220399zd2_4524
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd220393zd2_4523));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_carzd220404zd2_4525;
																																																																					obj_t
																																																																						BgL_cdrzd220405zd2_4526;
																																																																					BgL_carzd220404zd2_4525
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd220399zd2_4524));
																																																																					BgL_cdrzd220405zd2_4526
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd220399zd2_4524));
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd220404zd2_4525))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (PAIRP(BgL_cdrzd220405zd2_4526))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd220410zd2_4529;
																																																																									BgL_carzd220410zd2_4529
																																																																										=
																																																																										CAR
																																																																										(BgL_cdrzd220405zd2_4526);
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd220410zd2_4529))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (NULLP(CDR(BgL_cdrzd220405zd2_4526)))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd220387zd2_4522))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg3884z00_4534;
																																																																															BgL_arg3884z00_4534
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd220393zd2_4523));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_19713;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_19717;
																																																																																	obj_t
																																																																																		BgL_proc2z00_19716;
																																																																																	obj_t
																																																																																		BgL_proc1z00_19715;
																																																																																	obj_t
																																																																																		BgL_testz00_19714;
																																																																																	BgL_testz00_19714
																																																																																		=
																																																																																		BgL_arg3884z00_4534;
																																																																																	BgL_proc1z00_19715
																																																																																		=
																																																																																		BgL_carzd220404zd2_4525;
																																																																																	BgL_proc2z00_19716
																																																																																		=
																																																																																		BgL_carzd220410zd2_4529;
																																																																																	BgL_argsz00_19717
																																																																																		=
																																																																																		BgL_cdrzd220387zd2_4522;
																																																																																	BgL_argsz00_1752
																																																																																		=
																																																																																		BgL_argsz00_19717;
																																																																																	BgL_proc2z00_1751
																																																																																		=
																																																																																		BgL_proc2z00_19716;
																																																																																	BgL_proc1z00_1750
																																																																																		=
																																																																																		BgL_proc1z00_19715;
																																																																																	BgL_testz00_1749
																																																																																		=
																																																																																		BgL_testz00_19714;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1753;
																																																																																}
																																																																																BgL_auxz00_14266
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_19713);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1777;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_19721;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1778;
																																																																																	BgL_auxz00_14266
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_19721);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1777;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_19725;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1778;
																																																																															BgL_auxz00_14266
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_19725);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1777;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_19729;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1778;
																																																																													BgL_auxz00_14266
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_19729);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1777;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_19733;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1778;
																																																																											BgL_auxz00_14266
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_19733);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1777;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_19737;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1778;
																																																																									BgL_auxz00_14266
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_19737);
																																																																								}
																																																																						}
																																																																				}
																																																																			}
																																																																		}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1777;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_19741;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1778;
																																																																		BgL_auxz00_14266
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_19741);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 119 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1777;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_19745;
																																																																goto
																																																																	BgL_tagzd2404zd2_1778;
																																																																BgL_auxz00_14266
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_19745);
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 119 */
																																																														goto
																																																															BgL_tagzd2403zd2_1777;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_19749;
																																																														goto
																																																															BgL_tagzd2404zd2_1778;
																																																														BgL_auxz00_14266
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_19749);
																																																													}
																																																											}
																																																									}
																																																							}
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																													}
																																											}
																																									}
																																							}
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							obj_t
																																								BgL_cdrzd220948zd2_4698;
																																							BgL_cdrzd220948zd2_4698
																																								=
																																								CDR
																																								(
																																								((obj_t) BgL_expz00_21));
																																							if ((BgL_carzd217644zd2_4364 == CNST_TABLE_REF(((long) 17))))
																																								{	/* Ast/sexp.scm 119 */
																																									obj_t
																																										BgL_arg4000z00_4700;
																																									obj_t
																																										BgL_arg4001z00_4701;
																																									BgL_arg4000z00_4700
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_cdrzd220948zd2_4698));
																																									BgL_arg4001z00_4701
																																										=
																																										CDR
																																										(
																																										((obj_t) BgL_cdrzd220948zd2_4698));
																																									{
																																										BgL_nodez00_bglt
																																											BgL_auxz00_19760;
																																										{
																																											obj_t
																																												BgL_exprz00_19762;
																																											obj_t
																																												BgL_bindingsz00_19761;
																																											BgL_bindingsz00_19761
																																												=
																																												BgL_arg4000z00_4700;
																																											BgL_exprz00_19762
																																												=
																																												BgL_arg4001z00_4701;
																																											BgL_exprz00_1732
																																												=
																																												BgL_exprz00_19762;
																																											BgL_bindingsz00_1731
																																												=
																																												BgL_bindingsz00_19761;
																																											goto
																																												BgL_tagzd2382zd2_1733;
																																										}
																																										BgL_auxz00_14266
																																											=
																																											(
																																											(obj_t)
																																											BgL_auxz00_19760);
																																									}
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd217644zd2_4364)))
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_arg4003z00_4703;
																																											obj_t
																																												BgL_arg4004z00_4704;
																																											BgL_arg4003z00_4703
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_cdrzd220948zd2_4698));
																																											BgL_arg4004z00_4704
																																												=
																																												CDR
																																												(
																																												((obj_t) BgL_cdrzd220948zd2_4698));
																																											{
																																												BgL_nodez00_bglt
																																													BgL_auxz00_19771;
																																												{
																																													obj_t
																																														BgL_exprz00_19773;
																																													obj_t
																																														BgL_bindingsz00_19772;
																																													BgL_bindingsz00_19772
																																														=
																																														BgL_arg4003z00_4703;
																																													BgL_exprz00_19773
																																														=
																																														BgL_arg4004z00_4704;
																																													BgL_exprz00_1732
																																														=
																																														BgL_exprz00_19773;
																																													BgL_bindingsz00_1731
																																														=
																																														BgL_bindingsz00_19772;
																																													goto
																																														BgL_tagzd2382zd2_1733;
																																												}
																																												BgL_auxz00_14266
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_19771);
																																											}
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											if ((BgL_carzd217644zd2_4364 == CNST_TABLE_REF(((long) 18))))
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_arg4006z00_4706;
																																													obj_t
																																														BgL_arg4007z00_4707;
																																													BgL_arg4006z00_4706
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_cdrzd220948zd2_4698));
																																													BgL_arg4007z00_4707
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_cdrzd220948zd2_4698));
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_19782;
																																														{
																																															obj_t
																																																BgL_exprz00_19784;
																																															obj_t
																																																BgL_bindingsz00_19783;
																																															BgL_bindingsz00_19783
																																																=
																																																BgL_arg4006z00_4706;
																																															BgL_exprz00_19784
																																																=
																																																BgL_arg4007z00_4707;
																																															BgL_exprz00_1732
																																																=
																																																BgL_exprz00_19784;
																																															BgL_bindingsz00_1731
																																																=
																																																BgL_bindingsz00_19783;
																																															goto
																																																BgL_tagzd2382zd2_1733;
																																														}
																																														BgL_auxz00_14266
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_19782);
																																													}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_19791;
																																															goto
																																																BgL_tagzd2383zd2_1734;
																																															BgL_auxz00_14266
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_19791);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_carzd220985zd2_4710;
																																															BgL_carzd220985zd2_4710
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															if ((BgL_carzd220985zd2_4710 == CNST_TABLE_REF(((long) 19))))
																																																{
																																																	BgL_letzd2funzd2_bglt
																																																		BgL_auxz00_19798;
																																																	goto
																																																		BgL_tagzd2384zd2_1735;
																																																	BgL_auxz00_14266
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_19798);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd220985zd2_4710)))
																																																		{
																																																			BgL_letzd2funzd2_bglt
																																																				BgL_auxz00_19803;
																																																			goto
																																																				BgL_tagzd2384zd2_1735;
																																																			BgL_auxz00_14266
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_19803);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_19810;
																																																					goto
																																																						BgL_tagzd2389zd2_1754;
																																																					BgL_auxz00_14266
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_19810);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_19817;
																																																							goto
																																																								BgL_tagzd2390zd2_1755;
																																																							BgL_auxz00_14266
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_19817);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_cdrzd221065zd2_4717;
																																																							BgL_cdrzd221065zd2_4717
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_arg4018z00_4720;
																																																									obj_t
																																																										BgL_arg4019z00_4721;
																																																									BgL_arg4018z00_4720
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd221065zd2_4717));
																																																									BgL_arg4019z00_4721
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd221065zd2_4717));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_19830;
																																																										{
																																																											obj_t
																																																												BgL_restz00_19832;
																																																											obj_t
																																																												BgL_effectz00_19831;
																																																											BgL_effectz00_19831
																																																												=
																																																												BgL_arg4018z00_4720;
																																																											BgL_restz00_19832
																																																												=
																																																												BgL_arg4019z00_4721;
																																																											BgL_restz00_1757
																																																												=
																																																												BgL_restz00_19832;
																																																											BgL_effectz00_1756
																																																												=
																																																												BgL_effectz00_19831;
																																																											goto
																																																												BgL_tagzd2391zd2_1758;
																																																										}
																																																										BgL_auxz00_14266
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_19830);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_19839;
																																																											goto
																																																												BgL_tagzd2392zd2_1759;
																																																											BgL_auxz00_14266
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_19839);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_19846;
																																																													goto
																																																														BgL_tagzd2393zd2_1760;
																																																													BgL_auxz00_14266
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_19846);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_arg4026z00_4729;
																																																															obj_t
																																																																BgL_arg4027z00_4730;
																																																															BgL_arg4026z00_4729
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd221065zd2_4717));
																																																															BgL_arg4027z00_4730
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd221065zd2_4717));
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_19857;
																																																																{
																																																																	obj_t
																																																																		BgL_restz00_19859;
																																																																	obj_t
																																																																		BgL_effectz00_19858;
																																																																	BgL_effectz00_19858
																																																																		=
																																																																		BgL_arg4026z00_4729;
																																																																	BgL_restz00_19859
																																																																		=
																																																																		BgL_arg4027z00_4730;
																																																																	BgL_restz00_1762
																																																																		=
																																																																		BgL_restz00_19859;
																																																																	BgL_effectz00_1761
																																																																		=
																																																																		BgL_effectz00_19858;
																																																																	goto
																																																																		BgL_tagzd2394zd2_1763;
																																																																}
																																																																BgL_auxz00_14266
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_19857);
																																																															}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_19866;
																																																																	goto
																																																																		BgL_tagzd2395zd2_1764;
																																																																	BgL_auxz00_14266
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_19866);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_19873;
																																																																			goto
																																																																				BgL_tagzd2396zd2_1765;
																																																																			BgL_auxz00_14266
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_19873);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																				{
																																																																					BgL_letzd2funzd2_bglt
																																																																						BgL_auxz00_19880;
																																																																					goto
																																																																						BgL_tagzd2397zd2_1766;
																																																																					BgL_auxz00_14266
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_19880);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																						{
																																																																							BgL_jumpzd2exzd2itz00_bglt
																																																																								BgL_auxz00_19887;
																																																																							goto
																																																																								BgL_tagzd2398zd2_1767;
																																																																							BgL_auxz00_14266
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_19887);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd221142zd2_4739;
																																																																							BgL_cdrzd221142zd2_4739
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_arg4038z00_4742;
																																																																									obj_t
																																																																										BgL_arg4039z00_4743;
																																																																									BgL_arg4038z00_4742
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd221142zd2_4739));
																																																																									BgL_arg4039z00_4743
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd221142zd2_4739));
																																																																									{	/* Ast/sexp.scm 552 */
																																																																										obj_t
																																																																											BgL_arg6965z00_11270;
																																																																										BgL_arg6965z00_11270
																																																																											=
																																																																											BGl_findzd2locationzf2locz20zztools_locationz00
																																																																											(BgL_expz00_21,
																																																																											BgL_locz00_23);
																																																																										BgL_auxz00_14266
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																											(BgL_expz00_21,
																																																																												BgL_arg4038z00_4742,
																																																																												CNST_TABLE_REF
																																																																												(((long) 4)), BgL_arg4039z00_4743, BgL_stackz00_22, BgL_arg6965z00_11270, BgL_sitez00_24));
																																																																								}}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1777;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_19906;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1778;
																																																																											BgL_auxz00_14266
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_19906);
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																										}
																									else
																										{	/* Ast/sexp.scm 119 */
																											obj_t
																												BgL_carzd221167zd2_4759;
																											BgL_carzd221167zd2_4759 =
																												CAR(((obj_t)
																													BgL_expz00_21));
																											if (
																												(BgL_carzd221167zd2_4759
																													==
																													CNST_TABLE_REF(((long)
																															1))))
																												{
																													BgL_nodez00_bglt
																														BgL_auxz00_19913;
																													goto
																														BgL_tagzd2377zd2_1722;
																													BgL_auxz00_14266 =
																														((obj_t)
																														BgL_auxz00_19913);
																												}
																											else
																												{	/* Ast/sexp.scm 119 */
																													if (
																														(BgL_carzd221167zd2_4759
																															==
																															BGl_za2ifza2z00zzast_sexpz00))
																														{
																															BgL_nodez00_bglt
																																BgL_auxz00_19917;
																															goto
																																BgL_tagzd2377zd2_1722;
																															BgL_auxz00_14266 =
																																((obj_t)
																																BgL_auxz00_19917);
																														}
																													else
																														{	/* Ast/sexp.scm 119 */
																															if (
																																(CAR(
																																		((obj_t)
																																			BgL_expz00_21))
																																	==
																																	CNST_TABLE_REF
																																	(((long) 7))))
																																{
																																	BgL_nodez00_bglt
																																		BgL_auxz00_19924;
																																	goto
																																		BgL_tagzd2379zd2_1726;
																																	BgL_auxz00_14266
																																		=
																																		((obj_t)
																																		BgL_auxz00_19924);
																																}
																															else
																																{	/* Ast/sexp.scm 119 */
																																	if (
																																		(CAR(
																																				((obj_t)
																																					BgL_expz00_21))
																																			==
																																			CNST_TABLE_REF
																																			(((long)
																																					16))))
																																		{
																																			BgL_nodez00_bglt
																																				BgL_auxz00_19931;
																																			goto
																																				BgL_tagzd2380zd2_1727;
																																			BgL_auxz00_14266
																																				=
																																				((obj_t)
																																				BgL_auxz00_19931);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 119 */
																																			obj_t
																																				BgL_carzd221236zd2_4766;
																																			BgL_carzd221236zd2_4766
																																				=
																																				CAR((
																																					(obj_t)
																																					BgL_expz00_21));
																																			if (PAIRP
																																				(BgL_carzd221236zd2_4766))
																																				{	/* Ast/sexp.scm 119 */
																																					obj_t
																																						BgL_carzd221239zd2_4768;
																																					obj_t
																																						BgL_cdrzd221240zd2_4769;
																																					BgL_carzd221239zd2_4768
																																						=
																																						CAR
																																						(BgL_carzd221236zd2_4766);
																																					BgL_cdrzd221240zd2_4769
																																						=
																																						CDR
																																						(BgL_carzd221236zd2_4766);
																																					{

																																						if (
																																							(BgL_carzd221239zd2_4768
																																								==
																																								CNST_TABLE_REF
																																								(((long) 17))))
																																							{	/* Ast/sexp.scm 119 */
																																							BgL_kapzd221241zd2_4770:
																																								if (PAIRP(BgL_cdrzd221240zd2_4769))
																																									{	/* Ast/sexp.scm 119 */
																																										obj_t
																																											BgL_cdrzd221244zd2_4889;
																																										BgL_cdrzd221244zd2_4889
																																											=
																																											CDR
																																											(BgL_cdrzd221240zd2_4769);
																																										if (PAIRP(BgL_cdrzd221244zd2_4889))
																																											{	/* Ast/sexp.scm 119 */
																																												if (NULLP(CDR(BgL_cdrzd221244zd2_4889)))
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_arg4142z00_4893;
																																														obj_t
																																															BgL_arg4143z00_4894;
																																														BgL_arg4142z00_4893
																																															=
																																															CAR
																																															(BgL_cdrzd221244zd2_4889);
																																														BgL_arg4143z00_4894
																																															=
																																															CDR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_19953;
																																															{
																																																obj_t
																																																	BgL_argsz00_19955;
																																																obj_t
																																																	BgL_bodyz00_19954;
																																																BgL_bodyz00_19954
																																																	=
																																																	BgL_arg4142z00_4893;
																																																BgL_argsz00_19955
																																																	=
																																																	BgL_arg4143z00_4894;
																																																BgL_argsz00_1729
																																																	=
																																																	BgL_argsz00_19955;
																																																BgL_bodyz00_1728
																																																	=
																																																	BgL_bodyz00_19954;
																																																goto
																																																	BgL_tagzd2381zd2_1730;
																																															}
																																															BgL_auxz00_14266
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_19953);
																																														}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														bool_t
																																															BgL_test8975z00_19957;
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg4207z00_5000;
																																															BgL_arg4207z00_5000
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															BgL_test8975z00_19957
																																																=
																																																CBOOL
																																																(BGl_labelszd2symzf3z21zzast_labelsz00
																																																(BgL_arg4207z00_5000));
																																														}
																																														if (BgL_test8975z00_19957)
																																															{
																																																BgL_letzd2funzd2_bglt
																																																	BgL_auxz00_19962;
																																																goto
																																																	BgL_tagzd2384zd2_1735;
																																																BgL_auxz00_14266
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_19962);
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_carzd221322zd2_4897;
																																																BgL_carzd221322zd2_4897
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_cdrzd221327zd2_4898;
																																																	BgL_cdrzd221327zd2_4898
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_carzd221322zd2_4897));
																																																	if ((CAR(((obj_t) BgL_carzd221322zd2_4897)) == CNST_TABLE_REF(((long) 3))))
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg4148z00_4901;
																																																			obj_t
																																																				BgL_arg4149z00_4902;
																																																			obj_t
																																																				BgL_arg4150z00_4903;
																																																			BgL_arg4148z00_4901
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd221327zd2_4898));
																																																			BgL_arg4149z00_4902
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd221327zd2_4898));
																																																			BgL_arg4150z00_4903
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_19979;
																																																				{
																																																					obj_t
																																																						BgL_argsz00_19982;
																																																					obj_t
																																																						BgL_bodyz00_19981;
																																																					obj_t
																																																						BgL_varsz00_19980;
																																																					BgL_varsz00_19980
																																																						=
																																																						BgL_arg4148z00_4901;
																																																					BgL_bodyz00_19981
																																																						=
																																																						BgL_arg4149z00_4902;
																																																					BgL_argsz00_19982
																																																						=
																																																						BgL_arg4150z00_4903;
																																																					BgL_argsz00_1742
																																																						=
																																																						BgL_argsz00_19982;
																																																					BgL_bodyz00_1741
																																																						=
																																																						BgL_bodyz00_19981;
																																																					BgL_varsz00_1740
																																																						=
																																																						BgL_varsz00_19980;
																																																					goto
																																																						BgL_tagzd2386zd2_1743;
																																																				}
																																																				BgL_auxz00_14266
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_19979);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_cdrzd221350zd2_4905;
																																																			BgL_cdrzd221350zd2_4905
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd221356zd2_4906;
																																																				BgL_cdrzd221356zd2_4906
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_carzd221322zd2_4897));
																																																				if ((CAR(((obj_t) BgL_carzd221322zd2_4897)) == CNST_TABLE_REF(((long) 1))))
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd221362zd2_4909;
																																																						BgL_cdrzd221362zd2_4909
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_cdrzd221356zd2_4906));
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_carzd221367zd2_4910;
																																																							obj_t
																																																								BgL_cdrzd221368zd2_4911;
																																																							BgL_carzd221367zd2_4910
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd221362zd2_4909));
																																																							BgL_cdrzd221368zd2_4911
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd221362zd2_4909));
																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd221367zd2_4910))
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (PAIRP(BgL_cdrzd221368zd2_4911))
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_carzd221375zd2_4914;
																																																											BgL_carzd221375zd2_4914
																																																												=
																																																												CAR
																																																												(BgL_cdrzd221368zd2_4911);
																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd221375zd2_4914))
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (NULLP(CDR(BgL_cdrzd221368zd2_4911)))
																																																														{	/* Ast/sexp.scm 119 */
																																																															bool_t
																																																																BgL_test8982z00_20009;
																																																															{
																																																																obj_t
																																																																	BgL_l1402z00_4947;
																																																																BgL_l1402z00_4947
																																																																	=
																																																																	BgL_cdrzd221350zd2_4905;
																																																															BgL_zc3z04anonymousza34173ze3z87_4948:
																																																																if (NULLP(BgL_l1402z00_4947))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		BgL_test8982z00_20009
																																																																			=
																																																																			(
																																																																			(bool_t)
																																																																			1);
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		bool_t
																																																																			BgL_test8984z00_20012;
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			bool_t
																																																																				BgL_test8985z00_20013;
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_tmpz00_20014;
																																																																				BgL_tmpz00_20014
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_l1402z00_4947));
																																																																				BgL_test8985z00_20013
																																																																					=
																																																																					PAIRP
																																																																					(BgL_tmpz00_20014);
																																																																			}
																																																																			if (BgL_test8985z00_20013)
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					BgL_test8984z00_20012
																																																																						=
																																																																						(
																																																																						(bool_t)
																																																																						0);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					BgL_test8984z00_20012
																																																																						=
																																																																						(
																																																																						(bool_t)
																																																																						1);
																																																																				}
																																																																		}
																																																																		if (BgL_test8984z00_20012)
																																																																			{
																																																																				obj_t
																																																																					BgL_l1402z00_20018;
																																																																				BgL_l1402z00_20018
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_l1402z00_4947));
																																																																				BgL_l1402z00_4947
																																																																					=
																																																																					BgL_l1402z00_20018;
																																																																				goto
																																																																					BgL_zc3z04anonymousza34173ze3z87_4948;
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				BgL_test8982z00_20009
																																																																					=
																																																																					(
																																																																					(bool_t)
																																																																					0);
																																																																			}
																																																																	}
																																																															}
																																																															if (BgL_test8982z00_20009)
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_arg4163z00_4930;
																																																																	BgL_arg4163z00_4930
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd221356zd2_4906));
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_20023;
																																																																		{
																																																																			obj_t
																																																																				BgL_argsz00_20027;
																																																																			obj_t
																																																																				BgL_proc2z00_20026;
																																																																			obj_t
																																																																				BgL_proc1z00_20025;
																																																																			obj_t
																																																																				BgL_testz00_20024;
																																																																			BgL_testz00_20024
																																																																				=
																																																																				BgL_arg4163z00_4930;
																																																																			BgL_proc1z00_20025
																																																																				=
																																																																				BgL_carzd221367zd2_4910;
																																																																			BgL_proc2z00_20026
																																																																				=
																																																																				BgL_carzd221375zd2_4914;
																																																																			BgL_argsz00_20027
																																																																				=
																																																																				BgL_cdrzd221350zd2_4905;
																																																																			BgL_argsz00_1747
																																																																				=
																																																																				BgL_argsz00_20027;
																																																																			BgL_proc2z00_1746
																																																																				=
																																																																				BgL_proc2z00_20026;
																																																																			BgL_proc1z00_1745
																																																																				=
																																																																				BgL_proc1z00_20025;
																																																																			BgL_testz00_1744
																																																																				=
																																																																				BgL_testz00_20024;
																																																																			goto
																																																																				BgL_tagzd2387zd2_1748;
																																																																		}
																																																																		BgL_auxz00_14266
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_20023);
																																																																	}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd221399zd2_4931;
																																																																	BgL_cdrzd221399zd2_4931
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd221406zd2_4932;
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_pairz00_11310;
																																																																			BgL_pairz00_11310
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_expz00_21));
																																																																			BgL_cdrzd221406zd2_4932
																																																																				=
																																																																				CDR
																																																																				(BgL_pairz00_11310);
																																																																		}
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd221413zd2_4933;
																																																																			BgL_cdrzd221413zd2_4933
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd221406zd2_4932));
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_carzd221419zd2_4934;
																																																																				BgL_carzd221419zd2_4934
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd221413zd2_4933));
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd221419zd2_4934))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_carzd221426zd2_4936;
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_pairz00_11314;
																																																																							BgL_pairz00_11314
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd221413zd2_4933));
																																																																							BgL_carzd221426zd2_4936
																																																																								=
																																																																								CAR
																																																																								(BgL_pairz00_11314);
																																																																						}
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd221426zd2_4936))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd221399zd2_4931))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_arg4167z00_4939;
																																																																										BgL_arg4167z00_4939
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd221406zd2_4932));
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_20049;
																																																																											{
																																																																												obj_t
																																																																													BgL_argsz00_20053;
																																																																												obj_t
																																																																													BgL_proc2z00_20052;
																																																																												obj_t
																																																																													BgL_proc1z00_20051;
																																																																												obj_t
																																																																													BgL_testz00_20050;
																																																																												BgL_testz00_20050
																																																																													=
																																																																													BgL_arg4167z00_4939;
																																																																												BgL_proc1z00_20051
																																																																													=
																																																																													BgL_carzd221419zd2_4934;
																																																																												BgL_proc2z00_20052
																																																																													=
																																																																													BgL_carzd221426zd2_4936;
																																																																												BgL_argsz00_20053
																																																																													=
																																																																													BgL_cdrzd221399zd2_4931;
																																																																												BgL_argsz00_1752
																																																																													=
																																																																													BgL_argsz00_20053;
																																																																												BgL_proc2z00_1751
																																																																													=
																																																																													BgL_proc2z00_20052;
																																																																												BgL_proc1z00_1750
																																																																													=
																																																																													BgL_proc1z00_20051;
																																																																												BgL_testz00_1749
																																																																													=
																																																																													BgL_testz00_20050;
																																																																												goto
																																																																													BgL_tagzd2388zd2_1753;
																																																																											}
																																																																											BgL_auxz00_14266
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_20049);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1777;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_20057;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1778;
																																																																												BgL_auxz00_14266
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_20057);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1777;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_20061;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1778;
																																																																										BgL_auxz00_14266
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_20061);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1777;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_20065;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1778;
																																																																								BgL_auxz00_14266
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_20065);
																																																																							}
																																																																					}
																																																																			}
																																																																		}
																																																																	}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1777;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_20069;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1778;
																																																																	BgL_auxz00_14266
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_20069);
																																																																}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd221702zd2_4958;
																																																													BgL_cdrzd221702zd2_4958
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd221708zd2_4959;
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_pairz00_11318;
																																																															BgL_pairz00_11318
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															BgL_cdrzd221708zd2_4959
																																																																=
																																																																CDR
																																																																(BgL_pairz00_11318);
																																																														}
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd221714zd2_4960;
																																																															BgL_cdrzd221714zd2_4960
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd221708zd2_4959));
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_carzd221719zd2_4961;
																																																																obj_t
																																																																	BgL_cdrzd221720zd2_4962;
																																																																BgL_carzd221719zd2_4961
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd221714zd2_4960));
																																																																BgL_cdrzd221720zd2_4962
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd221714zd2_4960));
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd221719zd2_4961))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_carzd221725zd2_4964;
																																																																		BgL_carzd221725zd2_4964
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd221720zd2_4962));
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd221725zd2_4964))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (NULLP(CDR(((obj_t) BgL_cdrzd221720zd2_4962))))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd221702zd2_4958))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_arg4182z00_4969;
																																																																								BgL_arg4182z00_4969
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd221708zd2_4959));
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_20096;
																																																																									{
																																																																										obj_t
																																																																											BgL_argsz00_20100;
																																																																										obj_t
																																																																											BgL_proc2z00_20099;
																																																																										obj_t
																																																																											BgL_proc1z00_20098;
																																																																										obj_t
																																																																											BgL_testz00_20097;
																																																																										BgL_testz00_20097
																																																																											=
																																																																											BgL_arg4182z00_4969;
																																																																										BgL_proc1z00_20098
																																																																											=
																																																																											BgL_carzd221719zd2_4961;
																																																																										BgL_proc2z00_20099
																																																																											=
																																																																											BgL_carzd221725zd2_4964;
																																																																										BgL_argsz00_20100
																																																																											=
																																																																											BgL_cdrzd221702zd2_4958;
																																																																										BgL_argsz00_1752
																																																																											=
																																																																											BgL_argsz00_20100;
																																																																										BgL_proc2z00_1751
																																																																											=
																																																																											BgL_proc2z00_20099;
																																																																										BgL_proc1z00_1750
																																																																											=
																																																																											BgL_proc1z00_20098;
																																																																										BgL_testz00_1749
																																																																											=
																																																																											BgL_testz00_20097;
																																																																										goto
																																																																											BgL_tagzd2388zd2_1753;
																																																																									}
																																																																									BgL_auxz00_14266
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_20096);
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1777;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_20104;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1778;
																																																																										BgL_auxz00_14266
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_20104);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1777;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_20108;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1778;
																																																																								BgL_auxz00_14266
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_20108);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1777;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_20112;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1778;
																																																																						BgL_auxz00_14266
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_20112);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1777;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_20116;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1778;
																																																																				BgL_auxz00_14266
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_20116);
																																																																			}
																																																																	}
																																																															}
																																																														}
																																																													}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{	/* Ast/sexp.scm 119 */
																																																													goto
																																																														BgL_tagzd2403zd2_1777;
																																																												}
																																																											else
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_20120;
																																																													goto
																																																														BgL_tagzd2404zd2_1778;
																																																													BgL_auxz00_14266
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_20120);
																																																												}
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_cdrzd222058zd2_4977;
																																																									BgL_cdrzd222058zd2_4977
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd222065zd2_4978;
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_pairz00_11328;
																																																											BgL_pairz00_11328
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											BgL_cdrzd222065zd2_4978
																																																												=
																																																												CDR
																																																												(BgL_pairz00_11328);
																																																										}
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_cdrzd222072zd2_4979;
																																																											BgL_cdrzd222072zd2_4979
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd222065zd2_4978));
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_carzd222078zd2_4980;
																																																												obj_t
																																																													BgL_cdrzd222079zd2_4981;
																																																												BgL_carzd222078zd2_4980
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd222072zd2_4979));
																																																												BgL_cdrzd222079zd2_4981
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd222072zd2_4979));
																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd222078zd2_4980))
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (PAIRP(BgL_cdrzd222079zd2_4981))
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_carzd222086zd2_4984;
																																																																BgL_carzd222086zd2_4984
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd222079zd2_4981);
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd222086zd2_4984))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (NULLP(CDR(BgL_cdrzd222079zd2_4981)))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd222058zd2_4977))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_arg4196z00_4989;
																																																																						BgL_arg4196z00_4989
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd222065zd2_4978));
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_20147;
																																																																							{
																																																																								obj_t
																																																																									BgL_argsz00_20151;
																																																																								obj_t
																																																																									BgL_proc2z00_20150;
																																																																								obj_t
																																																																									BgL_proc1z00_20149;
																																																																								obj_t
																																																																									BgL_testz00_20148;
																																																																								BgL_testz00_20148
																																																																									=
																																																																									BgL_arg4196z00_4989;
																																																																								BgL_proc1z00_20149
																																																																									=
																																																																									BgL_carzd222078zd2_4980;
																																																																								BgL_proc2z00_20150
																																																																									=
																																																																									BgL_carzd222086zd2_4984;
																																																																								BgL_argsz00_20151
																																																																									=
																																																																									BgL_cdrzd222058zd2_4977;
																																																																								BgL_argsz00_1752
																																																																									=
																																																																									BgL_argsz00_20151;
																																																																								BgL_proc2z00_1751
																																																																									=
																																																																									BgL_proc2z00_20150;
																																																																								BgL_proc1z00_1750
																																																																									=
																																																																									BgL_proc1z00_20149;
																																																																								BgL_testz00_1749
																																																																									=
																																																																									BgL_testz00_20148;
																																																																								goto
																																																																									BgL_tagzd2388zd2_1753;
																																																																							}
																																																																							BgL_auxz00_14266
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_20147);
																																																																						}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1777;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_20155;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1778;
																																																																								BgL_auxz00_14266
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_20155);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1777;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_20159;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1778;
																																																																						BgL_auxz00_14266
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_20159);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1777;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_20163;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1778;
																																																																				BgL_auxz00_14266
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_20163);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1777;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_20167;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1778;
																																																																		BgL_auxz00_14266
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_20167);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 119 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1777;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_20171;
																																																																goto
																																																																	BgL_tagzd2404zd2_1778;
																																																																BgL_auxz00_14266
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_20171);
																																																															}
																																																													}
																																																											}
																																																										}
																																																									}
																																																								}
																																																						}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																							{	/* Ast/sexp.scm 119 */
																																																								goto
																																																									BgL_tagzd2403zd2_1777;
																																																							}
																																																						else
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_20175;
																																																								goto
																																																									BgL_tagzd2404zd2_1778;
																																																								BgL_auxz00_14266
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_20175);
																																																							}
																																																					}
																																																			}
																																																		}
																																																}
																																															}
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												bool_t
																																													BgL_test9013z00_20177;
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_arg4218z00_5013;
																																													BgL_arg4218z00_5013
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													BgL_test9013z00_20177
																																														=
																																														CBOOL
																																														(BGl_labelszd2symzf3z21zzast_labelsz00
																																														(BgL_arg4218z00_5013));
																																												}
																																												if (BgL_test9013z00_20177)
																																													{
																																														BgL_letzd2funzd2_bglt
																																															BgL_auxz00_20182;
																																														goto
																																															BgL_tagzd2384zd2_1735;
																																														BgL_auxz00_14266
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_20182);
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_carzd222532zd2_5004;
																																														BgL_carzd222532zd2_5004
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_cdrzd222537zd2_5005;
																																															BgL_cdrzd222537zd2_5005
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_carzd222532zd2_5004));
																																															if ((CAR(((obj_t) BgL_carzd222532zd2_5004)) == CNST_TABLE_REF(((long) 3))))
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg4213z00_5008;
																																																	obj_t
																																																		BgL_arg4214z00_5009;
																																																	obj_t
																																																		BgL_arg4215z00_5010;
																																																	BgL_arg4213z00_5008
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd222537zd2_5005));
																																																	BgL_arg4214z00_5009
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd222537zd2_5005));
																																																	BgL_arg4215z00_5010
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_20199;
																																																		{
																																																			obj_t
																																																				BgL_argsz00_20202;
																																																			obj_t
																																																				BgL_bodyz00_20201;
																																																			obj_t
																																																				BgL_varsz00_20200;
																																																			BgL_varsz00_20200
																																																				=
																																																				BgL_arg4213z00_5008;
																																																			BgL_bodyz00_20201
																																																				=
																																																				BgL_arg4214z00_5009;
																																																			BgL_argsz00_20202
																																																				=
																																																				BgL_arg4215z00_5010;
																																																			BgL_argsz00_1742
																																																				=
																																																				BgL_argsz00_20202;
																																																			BgL_bodyz00_1741
																																																				=
																																																				BgL_bodyz00_20201;
																																																			BgL_varsz00_1740
																																																				=
																																																				BgL_varsz00_20200;
																																																			goto
																																																				BgL_tagzd2386zd2_1743;
																																																		}
																																																		BgL_auxz00_14266
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_20199);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																		{	/* Ast/sexp.scm 119 */
																																																			goto
																																																				BgL_tagzd2403zd2_1777;
																																																		}
																																																	else
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_20206;
																																																			goto
																																																				BgL_tagzd2404zd2_1778;
																																																			BgL_auxz00_14266
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_20206);
																																																		}
																																																}
																																														}
																																													}
																																											}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 119 */
																																										bool_t
																																											BgL_test9016z00_20208;
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_arg4222z00_5017;
																																											BgL_arg4222z00_5017
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_expz00_21));
																																											BgL_test9016z00_20208
																																												=
																																												CBOOL
																																												(BGl_labelszd2symzf3z21zzast_labelsz00
																																												(BgL_arg4222z00_5017));
																																										}
																																										if (BgL_test9016z00_20208)
																																											{
																																												BgL_letzd2funzd2_bglt
																																													BgL_auxz00_20213;
																																												goto
																																													BgL_tagzd2384zd2_1735;
																																												BgL_auxz00_14266
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_20213);
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																													{	/* Ast/sexp.scm 119 */
																																														goto
																																															BgL_tagzd2403zd2_1777;
																																													}
																																												else
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_20217;
																																														goto
																																															BgL_tagzd2404zd2_1778;
																																														BgL_auxz00_14266
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_20217);
																																													}
																																											}
																																									}
																																							}
																																						else
																																							{	/* Ast/sexp.scm 119 */
																																								if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd221239zd2_4768)))
																																									{	/* Ast/sexp.scm 119 */
																																										goto
																																											BgL_kapzd221241zd2_4770;
																																									}
																																								else
																																									{	/* Ast/sexp.scm 119 */
																																										if ((BgL_carzd221239zd2_4768 == CNST_TABLE_REF(((long) 18))))
																																											{	/* Ast/sexp.scm 119 */
																																												goto
																																													BgL_kapzd221241zd2_4770;
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												if ((BgL_carzd221239zd2_4768 == CNST_TABLE_REF(((long) 19))))
																																													{	/* Ast/sexp.scm 119 */
																																														goto
																																															BgL_kapzd221241zd2_4770;
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd221239zd2_4768)))
																																															{	/* Ast/sexp.scm 119 */
																																																goto
																																																	BgL_kapzd221241zd2_4770;
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																bool_t
																																																	BgL_test9022z00_20231;
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg4137z00_4887;
																																																	BgL_arg4137z00_4887
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	BgL_test9022z00_20231
																																																		=
																																																		CBOOL
																																																		(BGl_labelszd2symzf3z21zzast_labelsz00
																																																		(BgL_arg4137z00_4887));
																																																}
																																																if (BgL_test9022z00_20231)
																																																	{
																																																		BgL_letzd2funzd2_bglt
																																																			BgL_auxz00_20236;
																																																		goto
																																																			BgL_tagzd2384zd2_1735;
																																																		BgL_auxz00_14266
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_20236);
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_carzd222860zd2_4778;
																																																		BgL_carzd222860zd2_4778
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_cdrzd222865zd2_4779;
																																																			BgL_cdrzd222865zd2_4779
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_carzd222860zd2_4778));
																																																			if ((CAR(((obj_t) BgL_carzd222860zd2_4778)) == CNST_TABLE_REF(((long) 3))))
																																																				{	/* Ast/sexp.scm 119 */
																																																					if (PAIRP(BgL_cdrzd222865zd2_4779))
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_arg4072z00_4783;
																																																							obj_t
																																																								BgL_arg4073z00_4784;
																																																							obj_t
																																																								BgL_arg4074z00_4785;
																																																							BgL_arg4072z00_4783
																																																								=
																																																								CAR
																																																								(BgL_cdrzd222865zd2_4779);
																																																							BgL_arg4073z00_4784
																																																								=
																																																								CDR
																																																								(BgL_cdrzd222865zd2_4779);
																																																							BgL_arg4074z00_4785
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_20253;
																																																								{
																																																									obj_t
																																																										BgL_argsz00_20256;
																																																									obj_t
																																																										BgL_bodyz00_20255;
																																																									obj_t
																																																										BgL_varsz00_20254;
																																																									BgL_varsz00_20254
																																																										=
																																																										BgL_arg4072z00_4783;
																																																									BgL_bodyz00_20255
																																																										=
																																																										BgL_arg4073z00_4784;
																																																									BgL_argsz00_20256
																																																										=
																																																										BgL_arg4074z00_4785;
																																																									BgL_argsz00_1742
																																																										=
																																																										BgL_argsz00_20256;
																																																									BgL_bodyz00_1741
																																																										=
																																																										BgL_bodyz00_20255;
																																																									BgL_varsz00_1740
																																																										=
																																																										BgL_varsz00_20254;
																																																									goto
																																																										BgL_tagzd2386zd2_1743;
																																																								}
																																																								BgL_auxz00_14266
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_20253);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																								{	/* Ast/sexp.scm 119 */
																																																									goto
																																																										BgL_tagzd2403zd2_1777;
																																																								}
																																																							else
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_20260;
																																																									goto
																																																										BgL_tagzd2404zd2_1778;
																																																									BgL_auxz00_14266
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_20260);
																																																								}
																																																						}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_cdrzd222972zd2_4788;
																																																					BgL_cdrzd222972zd2_4788
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd222977zd2_4789;
																																																						BgL_cdrzd222977zd2_4789
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_carzd222860zd2_4778));
																																																						if ((CAR(((obj_t) BgL_carzd222860zd2_4778)) == CNST_TABLE_REF(((long) 1))))
																																																							{	/* Ast/sexp.scm 119 */
																																																								if (PAIRP(BgL_cdrzd222977zd2_4789))
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd222982zd2_4793;
																																																										BgL_cdrzd222982zd2_4793
																																																											=
																																																											CDR
																																																											(BgL_cdrzd222977zd2_4789);
																																																										if (PAIRP(BgL_cdrzd222982zd2_4793))
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_carzd222986zd2_4795;
																																																												obj_t
																																																													BgL_cdrzd222987zd2_4796;
																																																												BgL_carzd222986zd2_4795
																																																													=
																																																													CAR
																																																													(BgL_cdrzd222982zd2_4793);
																																																												BgL_cdrzd222987zd2_4796
																																																													=
																																																													CDR
																																																													(BgL_cdrzd222982zd2_4793);
																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd222986zd2_4795))
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (PAIRP(BgL_cdrzd222987zd2_4796))
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_carzd222992zd2_4799;
																																																																BgL_carzd222992zd2_4799
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd222987zd2_4796);
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd222992zd2_4799))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (NULLP(CDR(BgL_cdrzd222987zd2_4796)))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				bool_t
																																																																					BgL_test9033z00_20288;
																																																																				{
																																																																					obj_t
																																																																						BgL_l1405z00_4832;
																																																																					BgL_l1405z00_4832
																																																																						=
																																																																						BgL_cdrzd222972zd2_4788;
																																																																				BgL_zc3z04anonymousza34100ze3z87_4833:
																																																																					if (NULLP(BgL_l1405z00_4832))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							BgL_test9033z00_20288
																																																																								=
																																																																								(
																																																																								(bool_t)
																																																																								1);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							bool_t
																																																																								BgL_test9035z00_20291;
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								bool_t
																																																																									BgL_test9036z00_20292;
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_tmpz00_20293;
																																																																									BgL_tmpz00_20293
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_l1405z00_4832));
																																																																									BgL_test9036z00_20292
																																																																										=
																																																																										PAIRP
																																																																										(BgL_tmpz00_20293);
																																																																								}
																																																																								if (BgL_test9036z00_20292)
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										BgL_test9035z00_20291
																																																																											=
																																																																											(
																																																																											(bool_t)
																																																																											0);
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										BgL_test9035z00_20291
																																																																											=
																																																																											(
																																																																											(bool_t)
																																																																											1);
																																																																									}
																																																																							}
																																																																							if (BgL_test9035z00_20291)
																																																																								{
																																																																									obj_t
																																																																										BgL_l1405z00_20297;
																																																																									BgL_l1405z00_20297
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_l1405z00_4832));
																																																																									BgL_l1405z00_4832
																																																																										=
																																																																										BgL_l1405z00_20297;
																																																																									goto
																																																																										BgL_zc3z04anonymousza34100ze3z87_4833;
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									BgL_test9033z00_20288
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										0);
																																																																								}
																																																																						}
																																																																				}
																																																																				if (BgL_test9033z00_20288)
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_arg4090z00_4815;
																																																																						BgL_arg4090z00_4815
																																																																							=
																																																																							CAR
																																																																							(BgL_cdrzd222977zd2_4789);
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_20301;
																																																																							{
																																																																								obj_t
																																																																									BgL_argsz00_20305;
																																																																								obj_t
																																																																									BgL_proc2z00_20304;
																																																																								obj_t
																																																																									BgL_proc1z00_20303;
																																																																								obj_t
																																																																									BgL_testz00_20302;
																																																																								BgL_testz00_20302
																																																																									=
																																																																									BgL_arg4090z00_4815;
																																																																								BgL_proc1z00_20303
																																																																									=
																																																																									BgL_carzd222986zd2_4795;
																																																																								BgL_proc2z00_20304
																																																																									=
																																																																									BgL_carzd222992zd2_4799;
																																																																								BgL_argsz00_20305
																																																																									=
																																																																									BgL_cdrzd222972zd2_4788;
																																																																								BgL_argsz00_1747
																																																																									=
																																																																									BgL_argsz00_20305;
																																																																								BgL_proc2z00_1746
																																																																									=
																																																																									BgL_proc2z00_20304;
																																																																								BgL_proc1z00_1745
																																																																									=
																																																																									BgL_proc1z00_20303;
																																																																								BgL_testz00_1744
																																																																									=
																																																																									BgL_testz00_20302;
																																																																								goto
																																																																									BgL_tagzd2387zd2_1748;
																																																																							}
																																																																							BgL_auxz00_14266
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_20301);
																																																																						}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd223017zd2_4816;
																																																																						BgL_cdrzd223017zd2_4816
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd223025zd2_4817;
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_pairz00_11373;
																																																																								BgL_pairz00_11373
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								BgL_cdrzd223025zd2_4817
																																																																									=
																																																																									CDR
																																																																									(BgL_pairz00_11373);
																																																																							}
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd223033zd2_4818;
																																																																								BgL_cdrzd223033zd2_4818
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd223025zd2_4817));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd223040zd2_4819;
																																																																									BgL_carzd223040zd2_4819
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd223033zd2_4818));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd223040zd2_4819))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd223049zd2_4821;
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_pairz00_11377;
																																																																												BgL_pairz00_11377
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd223033zd2_4818));
																																																																												BgL_carzd223049zd2_4821
																																																																													=
																																																																													CAR
																																																																													(BgL_pairz00_11377);
																																																																											}
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd223049zd2_4821))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd223017zd2_4816))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg4094z00_4824;
																																																																															BgL_arg4094z00_4824
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd223025zd2_4817));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_20327;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_20331;
																																																																																	obj_t
																																																																																		BgL_proc2z00_20330;
																																																																																	obj_t
																																																																																		BgL_proc1z00_20329;
																																																																																	obj_t
																																																																																		BgL_testz00_20328;
																																																																																	BgL_testz00_20328
																																																																																		=
																																																																																		BgL_arg4094z00_4824;
																																																																																	BgL_proc1z00_20329
																																																																																		=
																																																																																		BgL_carzd223040zd2_4819;
																																																																																	BgL_proc2z00_20330
																																																																																		=
																																																																																		BgL_carzd223049zd2_4821;
																																																																																	BgL_argsz00_20331
																																																																																		=
																																																																																		BgL_cdrzd223017zd2_4816;
																																																																																	BgL_argsz00_1752
																																																																																		=
																																																																																		BgL_argsz00_20331;
																																																																																	BgL_proc2z00_1751
																																																																																		=
																																																																																		BgL_proc2z00_20330;
																																																																																	BgL_proc1z00_1750
																																																																																		=
																																																																																		BgL_proc1z00_20329;
																																																																																	BgL_testz00_1749
																																																																																		=
																																																																																		BgL_testz00_20328;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1753;
																																																																																}
																																																																																BgL_auxz00_14266
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_20327);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1777;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_20335;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1778;
																																																																																	BgL_auxz00_14266
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_20335);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1777;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_20339;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1778;
																																																																															BgL_auxz00_14266
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_20339);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1777;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_20343;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1778;
																																																																													BgL_auxz00_14266
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_20343);
																																																																												}
																																																																										}
																																																																								}
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1777;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_20347;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1778;
																																																																						BgL_auxz00_14266
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_20347);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd223327zd2_4843;
																																																																		BgL_cdrzd223327zd2_4843
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd223334zd2_4844;
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_pairz00_11381;
																																																																				BgL_pairz00_11381
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				BgL_cdrzd223334zd2_4844
																																																																					=
																																																																					CDR
																																																																					(BgL_pairz00_11381);
																																																																			}
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd223341zd2_4845;
																																																																				BgL_cdrzd223341zd2_4845
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd223334zd2_4844));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_carzd223347zd2_4846;
																																																																					obj_t
																																																																						BgL_cdrzd223348zd2_4847;
																																																																					BgL_carzd223347zd2_4846
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd223341zd2_4845));
																																																																					BgL_cdrzd223348zd2_4847
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd223341zd2_4845));
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd223347zd2_4846))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd223355zd2_4849;
																																																																							BgL_carzd223355zd2_4849
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd223348zd2_4847));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd223355zd2_4849))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (NULLP(CDR(((obj_t) BgL_cdrzd223348zd2_4847))))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd223327zd2_4843))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_arg4109z00_4854;
																																																																													BgL_arg4109z00_4854
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd223334zd2_4844));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_20374;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_20378;
																																																																															obj_t
																																																																																BgL_proc2z00_20377;
																																																																															obj_t
																																																																																BgL_proc1z00_20376;
																																																																															obj_t
																																																																																BgL_testz00_20375;
																																																																															BgL_testz00_20375
																																																																																=
																																																																																BgL_arg4109z00_4854;
																																																																															BgL_proc1z00_20376
																																																																																=
																																																																																BgL_carzd223347zd2_4846;
																																																																															BgL_proc2z00_20377
																																																																																=
																																																																																BgL_carzd223355zd2_4849;
																																																																															BgL_argsz00_20378
																																																																																=
																																																																																BgL_cdrzd223327zd2_4843;
																																																																															BgL_argsz00_1752
																																																																																=
																																																																																BgL_argsz00_20378;
																																																																															BgL_proc2z00_1751
																																																																																=
																																																																																BgL_proc2z00_20377;
																																																																															BgL_proc1z00_1750
																																																																																=
																																																																																BgL_proc1z00_20376;
																																																																															BgL_testz00_1749
																																																																																=
																																																																																BgL_testz00_20375;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1753;
																																																																														}
																																																																														BgL_auxz00_14266
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_20374);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1777;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_20382;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1778;
																																																																															BgL_auxz00_14266
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_20382);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1777;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_20386;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1778;
																																																																													BgL_auxz00_14266
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_20386);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1777;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_20390;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1778;
																																																																											BgL_auxz00_14266
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_20390);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1777;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_20394;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1778;
																																																																									BgL_auxz00_14266
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_20394);
																																																																								}
																																																																						}
																																																																				}
																																																																			}
																																																																		}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1777;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_20398;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1778;
																																																																		BgL_auxz00_14266
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_20398);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd223688zd2_4862;
																																																														BgL_cdrzd223688zd2_4862
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd223694zd2_4863;
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_pairz00_11391;
																																																																BgL_pairz00_11391
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																BgL_cdrzd223694zd2_4863
																																																																	=
																																																																	CDR
																																																																	(BgL_pairz00_11391);
																																																															}
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd223700zd2_4864;
																																																																BgL_cdrzd223700zd2_4864
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd223694zd2_4863));
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_carzd223705zd2_4865;
																																																																	obj_t
																																																																		BgL_cdrzd223706zd2_4866;
																																																																	BgL_carzd223705zd2_4865
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd223700zd2_4864));
																																																																	BgL_cdrzd223706zd2_4866
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd223700zd2_4864));
																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd223705zd2_4865))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (PAIRP(BgL_cdrzd223706zd2_4866))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_carzd223711zd2_4869;
																																																																					BgL_carzd223711zd2_4869
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd223706zd2_4866);
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd223711zd2_4869))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (NULLP(CDR(BgL_cdrzd223706zd2_4866)))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd223688zd2_4862))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_arg4123z00_4874;
																																																																											BgL_arg4123z00_4874
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd223694zd2_4863));
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_20425;
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_20429;
																																																																													obj_t
																																																																														BgL_proc2z00_20428;
																																																																													obj_t
																																																																														BgL_proc1z00_20427;
																																																																													obj_t
																																																																														BgL_testz00_20426;
																																																																													BgL_testz00_20426
																																																																														=
																																																																														BgL_arg4123z00_4874;
																																																																													BgL_proc1z00_20427
																																																																														=
																																																																														BgL_carzd223705zd2_4865;
																																																																													BgL_proc2z00_20428
																																																																														=
																																																																														BgL_carzd223711zd2_4869;
																																																																													BgL_argsz00_20429
																																																																														=
																																																																														BgL_cdrzd223688zd2_4862;
																																																																													BgL_argsz00_1752
																																																																														=
																																																																														BgL_argsz00_20429;
																																																																													BgL_proc2z00_1751
																																																																														=
																																																																														BgL_proc2z00_20428;
																																																																													BgL_proc1z00_1750
																																																																														=
																																																																														BgL_proc1z00_20427;
																																																																													BgL_testz00_1749
																																																																														=
																																																																														BgL_testz00_20426;
																																																																													goto
																																																																														BgL_tagzd2388zd2_1753;
																																																																												}
																																																																												BgL_auxz00_14266
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_20425);
																																																																											}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1777;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_20433;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1778;
																																																																													BgL_auxz00_14266
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_20433);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1777;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_20437;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1778;
																																																																											BgL_auxz00_14266
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_20437);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1777;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_20441;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1778;
																																																																									BgL_auxz00_14266
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_20441);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1777;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_20445;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1778;
																																																																							BgL_auxz00_14266
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_20445);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1777;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_20449;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1778;
																																																																					BgL_auxz00_14266
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_20449);
																																																																				}
																																																																		}
																																																																}
																																																															}
																																																														}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 119 */
																																																														goto
																																																															BgL_tagzd2403zd2_1777;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_20453;
																																																														goto
																																																															BgL_tagzd2404zd2_1778;
																																																														BgL_auxz00_14266
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_20453);
																																																													}
																																																											}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 119 */
																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																											{	/* Ast/sexp.scm 119 */
																																																												goto
																																																													BgL_tagzd2403zd2_1777;
																																																											}
																																																										else
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_20457;
																																																												goto
																																																													BgL_tagzd2404zd2_1778;
																																																												BgL_auxz00_14266
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_20457);
																																																											}
																																																									}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																									{	/* Ast/sexp.scm 119 */
																																																										goto
																																																											BgL_tagzd2403zd2_1777;
																																																									}
																																																								else
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_20461;
																																																										goto
																																																											BgL_tagzd2404zd2_1778;
																																																										BgL_auxz00_14266
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_20461);
																																																									}
																																																							}
																																																					}
																																																				}
																																																		}
																																																	}
																																															}
																																													}
																																											}
																																									}
																																							}
																																					}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					if (
																																						(BgL_carzd221236zd2_4766
																																							==
																																							CNST_TABLE_REF
																																							(((long) 20))))
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_20466;
																																							goto
																																								BgL_tagzd2383zd2_1734;
																																							BgL_auxz00_14266
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_20466);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							obj_t
																																								BgL_carzd224273zd2_5020;
																																							BgL_carzd224273zd2_5020
																																								=
																																								CAR
																																								(
																																								((obj_t) BgL_expz00_21));
																																							if ((BgL_carzd224273zd2_5020 == CNST_TABLE_REF(((long) 19))))
																																								{
																																									BgL_letzd2funzd2_bglt
																																										BgL_auxz00_20473;
																																									goto
																																										BgL_tagzd2384zd2_1735;
																																									BgL_auxz00_14266
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_20473);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd224273zd2_5020)))
																																										{
																																											BgL_letzd2funzd2_bglt
																																												BgL_auxz00_20478;
																																											goto
																																												BgL_tagzd2384zd2_1735;
																																											BgL_auxz00_14266
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_20478);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_20485;
																																													goto
																																														BgL_tagzd2389zd2_1754;
																																													BgL_auxz00_14266
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_20485);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_20492;
																																															goto
																																																BgL_tagzd2390zd2_1755;
																																															BgL_auxz00_14266
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_20492);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_20499;
																																																	goto
																																																		BgL_tagzd2392zd2_1759;
																																																	BgL_auxz00_14266
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_20499);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_20506;
																																																			goto
																																																				BgL_tagzd2393zd2_1760;
																																																			BgL_auxz00_14266
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_20506);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_20513;
																																																					goto
																																																						BgL_tagzd2395zd2_1764;
																																																					BgL_auxz00_14266
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_20513);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_20520;
																																																							goto
																																																								BgL_tagzd2396zd2_1765;
																																																							BgL_auxz00_14266
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_20520);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_20527;
																																																									goto
																																																										BgL_tagzd2397zd2_1766;
																																																									BgL_auxz00_14266
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_20527);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																										{
																																																											BgL_jumpzd2exzd2itz00_bglt
																																																												BgL_auxz00_20534;
																																																											goto
																																																												BgL_tagzd2398zd2_1767;
																																																											BgL_auxz00_14266
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_20534);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (BGl_equalzf3zf3zz__r4_equivalence_6_2z00(CAR(((obj_t) BgL_expz00_21)), BUNSPEC))
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (NULLP(CDR(((obj_t) BgL_expz00_21))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_20544;
																																																														BgL_tagzd2402zd2_1776:
																																																															{	/* Ast/sexp.scm 556 */
																																																																obj_t
																																																																	BgL_arg6966z00_8980;
																																																																BgL_arg6966z00_8980
																																																																	=
																																																																	BGl_findzd2locationzf2locz20zztools_locationz00
																																																																	(BgL_expz00_21,
																																																																	BgL_locz00_23);
																																																																{	/* Ast/sexp.scm 555 */
																																																																	BgL_nodez00_bglt
																																																																		BgL_res7445z00_10093;
																																																																	{	/* Ast/sexp.scm 723 */
																																																																		obj_t
																																																																			BgL_arg7080z00_10089;
																																																																		BgL_nodez00_bglt
																																																																			BgL_arg7081z00_10090;
																																																																		BgL_arg7080z00_10089
																																																																			=
																																																																			BGl_shapez00zztools_shapez00
																																																																			(BGl_currentzd2functionzd2zztools_errorz00
																																																																			());
																																																																		BgL_arg7081z00_10090
																																																																			=
																																																																			BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																			(CNST_TABLE_REF
																																																																			(((long) 4)), BNIL, BgL_arg6966z00_8980, CNST_TABLE_REF(((long) 2)));
																																																																		{	/* Ast/sexp.scm 722 */
																																																																			obj_t
																																																																				BgL_list7082z00_10092;
																																																																			BgL_list7082z00_10092
																																																																				=
																																																																				MAKE_YOUNG_PAIR
																																																																				(
																																																																				((obj_t) BgL_arg7081z00_10090), BNIL);
																																																																			BgL_res7445z00_10093
																																																																				=
																																																																				(
																																																																				(BgL_nodez00_bglt)
																																																																				BGl_userzd2errorzf2locationz20zztools_errorz00
																																																																				(BgL_arg6966z00_8980,
																																																																					BgL_arg7080z00_10089,
																																																																					BGl_string7996z00zzast_sexpz00,
																																																																					BgL_expz00_21,
																																																																					BgL_list7082z00_10092));
																																																																	}}
																																																																	BgL_auxz00_20544
																																																																		=
																																																																		BgL_res7445z00_10093;
																																																															}}
																																																															BgL_auxz00_14266
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_20544);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1777;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_20558;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1778;
																																																																	BgL_auxz00_14266
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_20558);
																																																																}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{	/* Ast/sexp.scm 119 */
																																																															goto
																																																																BgL_tagzd2403zd2_1777;
																																																														}
																																																													else
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_20562;
																																																															goto
																																																																BgL_tagzd2404zd2_1778;
																																																															BgL_auxz00_14266
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_20562);
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																										}
																									return
																										((BgL_nodez00_bglt)
																										BgL_auxz00_14266);
																								}
																							else
																								{	/* Ast/sexp.scm 119 */
																									if (
																										(BgL_carzd2610zd2_1807 ==
																											BGl_za2ifza2z00zzast_sexpz00))
																										{
																											obj_t BgL_auxz00_20567;

																											goto
																												BgL_kapzd2612zd2_1809;
																											return ((BgL_nodez00_bglt)
																												BgL_auxz00_20567);
																										}
																									else
																										{	/* Ast/sexp.scm 119 */
																											bool_t
																												BgL_test9082z00_20569;
																											{	/* Ast/sexp.scm 119 */
																												obj_t
																													BgL_arg2217z00_2554;
																												BgL_arg2217z00_2554 =
																													CAR(BgL_expz00_21);
																												BgL_test9082z00_20569 =
																													(BgL_arg2217z00_2554
																													==
																													BGl_za2ifza2z00zzast_sexpz00);
																											}
																											if (BgL_test9082z00_20569)
																												{	/* Ast/sexp.scm 119 */
																													goto
																														BgL_tagzd2377zd2_1722;
																												}
																											else
																												{	/* Ast/sexp.scm 119 */
																													obj_t
																														BgL_cdrzd224445zd2_1814;
																													BgL_cdrzd224445zd2_1814
																														=
																														CDR(BgL_expz00_21);
																													if ((CAR
																															(BgL_expz00_21) ==
																															CNST_TABLE_REF((
																																	(long) 7))))
																														{	/* Ast/sexp.scm 119 */
																															if (PAIRP
																																(BgL_cdrzd224445zd2_1814))
																																{	/* Ast/sexp.scm 119 */
																																	obj_t
																																		BgL_carzd224448zd2_1818;
																																	obj_t
																																		BgL_cdrzd224449zd2_1819;
																																	BgL_carzd224448zd2_1818
																																		=
																																		CAR
																																		(BgL_cdrzd224445zd2_1814);
																																	BgL_cdrzd224449zd2_1819
																																		=
																																		CDR
																																		(BgL_cdrzd224445zd2_1814);
																																	if (PAIRP
																																		(BgL_carzd224448zd2_1818))
																																		{	/* Ast/sexp.scm 119 */
																																			if (
																																				(CAR
																																					(BgL_carzd224448zd2_1818)
																																					==
																																					CNST_TABLE_REF
																																					(((long) 14))))
																																				{	/* Ast/sexp.scm 119 */
																																					if (PAIRP(BgL_cdrzd224449zd2_1819))
																																						{	/* Ast/sexp.scm 119 */
																																							if (NULLP(CDR(BgL_cdrzd224449zd2_1819)))
																																								{
																																									obj_t
																																										BgL_valz00_20594;
																																									obj_t
																																										BgL_lz00_20592;
																																									BgL_lz00_20592
																																										=
																																										CDR
																																										(BgL_carzd224448zd2_1818);
																																									BgL_valz00_20594
																																										=
																																										CAR
																																										(BgL_cdrzd224449zd2_1819);
																																									BgL_valz00_1724
																																										=
																																										BgL_valz00_20594;
																																									BgL_lz00_1723
																																										=
																																										BgL_lz00_20592;
																																									goto
																																										BgL_tagzd2378zd2_1725;
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									goto
																																										BgL_tagzd2379zd2_1726;
																																								}
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							goto
																																								BgL_tagzd2379zd2_1726;
																																						}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					goto
																																						BgL_tagzd2379zd2_1726;
																																				}
																																		}
																																	else
																																		{	/* Ast/sexp.scm 119 */
																																			goto
																																				BgL_tagzd2379zd2_1726;
																																		}
																																}
																															else
																																{	/* Ast/sexp.scm 119 */
																																	goto
																																		BgL_tagzd2379zd2_1726;
																																}
																														}
																													else
																														{	/* Ast/sexp.scm 119 */
																															if (
																																(CAR
																																	(BgL_expz00_21)
																																	==
																																	CNST_TABLE_REF
																																	(((long)
																																			16))))
																																{	/* Ast/sexp.scm 119 */
																																	goto
																																		BgL_tagzd2380zd2_1727;
																																}
																															else
																																{	/* Ast/sexp.scm 119 */
																																	obj_t
																																		BgL_carzd224574zd2_1832;
																																	BgL_carzd224574zd2_1832
																																		=
																																		CAR
																																		(BgL_expz00_21);
																																	if (PAIRP
																																		(BgL_carzd224574zd2_1832))
																																		{	/* Ast/sexp.scm 119 */
																																			obj_t
																																				BgL_carzd224577zd2_1834;
																																			obj_t
																																				BgL_cdrzd224578zd2_1835;
																																			BgL_carzd224577zd2_1834
																																				=
																																				CAR
																																				(BgL_carzd224574zd2_1832);
																																			BgL_cdrzd224578zd2_1835
																																				=
																																				CDR
																																				(BgL_carzd224574zd2_1832);
																																			{

																																				if (
																																					(BgL_carzd224577zd2_1834
																																						==
																																						CNST_TABLE_REF
																																						(((long) 17))))
																																					{
																																						obj_t
																																							BgL_auxz00_20608;
																																					BgL_kapzd224579zd2_1836:
																																						if (PAIRP(BgL_cdrzd224578zd2_1835))
																																							{	/* Ast/sexp.scm 119 */
																																								obj_t
																																									BgL_cdrzd224582zd2_2138;
																																								BgL_cdrzd224582zd2_2138
																																									=
																																									CDR
																																									(BgL_cdrzd224578zd2_1835);
																																								if (PAIRP(BgL_cdrzd224582zd2_2138))
																																									{	/* Ast/sexp.scm 119 */
																																										if (NULLP(CDR(BgL_cdrzd224582zd2_2138)))
																																											{	/* Ast/sexp.scm 119 */
																																												obj_t
																																													BgL_arg1903z00_2142;
																																												obj_t
																																													BgL_arg1904z00_2143;
																																												BgL_arg1903z00_2142
																																													=
																																													CAR
																																													(BgL_cdrzd224582zd2_2138);
																																												BgL_arg1904z00_2143
																																													=
																																													CDR
																																													(
																																													((obj_t) BgL_expz00_21));
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_20620;
																																													{
																																														obj_t
																																															BgL_argsz00_20622;
																																														obj_t
																																															BgL_bodyz00_20621;
																																														BgL_bodyz00_20621
																																															=
																																															BgL_arg1903z00_2142;
																																														BgL_argsz00_20622
																																															=
																																															BgL_arg1904z00_2143;
																																														BgL_argsz00_1729
																																															=
																																															BgL_argsz00_20622;
																																														BgL_bodyz00_1728
																																															=
																																															BgL_bodyz00_20621;
																																														goto
																																															BgL_tagzd2381zd2_1730;
																																													}
																																													BgL_auxz00_20608
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_20620);
																																												}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												obj_t
																																													BgL_cdrzd224605zd2_2144;
																																												BgL_cdrzd224605zd2_2144
																																													=
																																													CDR
																																													(
																																													((obj_t) BgL_expz00_21));
																																												{

																																													{	/* Ast/sexp.scm 119 */
																																														bool_t
																																															BgL_test9095z00_20626;
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg1972z00_2254;
																																															BgL_arg1972z00_2254
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															BgL_test9095z00_20626
																																																=
																																																CBOOL
																																																(BGl_letzd2symzf3z21zzast_letz00
																																																(BgL_arg1972z00_2254));
																																														}
																																														if (BgL_test9095z00_20626)
																																															{	/* Ast/sexp.scm 119 */
																																																if (PAIRP(BgL_cdrzd224605zd2_2144))
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_arg1974z00_2256;
																																																		obj_t
																																																			BgL_arg1975z00_2257;
																																																		BgL_arg1974z00_2256
																																																			=
																																																			CAR
																																																			(BgL_cdrzd224605zd2_2144);
																																																		BgL_arg1975z00_2257
																																																			=
																																																			CDR
																																																			(BgL_cdrzd224605zd2_2144);
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_20635;
																																																			{
																																																				obj_t
																																																					BgL_exprz00_20637;
																																																				obj_t
																																																					BgL_bindingsz00_20636;
																																																				BgL_bindingsz00_20636
																																																					=
																																																					BgL_arg1974z00_2256;
																																																				BgL_exprz00_20637
																																																					=
																																																					BgL_arg1975z00_2257;
																																																				BgL_exprz00_1732
																																																					=
																																																					BgL_exprz00_20637;
																																																				BgL_bindingsz00_1731
																																																					=
																																																					BgL_bindingsz00_20636;
																																																				goto
																																																					BgL_tagzd2382zd2_1733;
																																																			}
																																																			BgL_auxz00_20608
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_20635);
																																																		}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		bool_t
																																																			BgL_test9097z00_20639;
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg2043z00_2363;
																																																			BgL_arg2043z00_2363
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			BgL_test9097z00_20639
																																																				=
																																																				CBOOL
																																																				(BGl_labelszd2symzf3z21zzast_labelsz00
																																																				(BgL_arg2043z00_2363));
																																																		}
																																																		if (BgL_test9097z00_20639)
																																																			{
																																																				BgL_letzd2funzd2_bglt
																																																					BgL_auxz00_20644;
																																																				goto
																																																					BgL_tagzd2384zd2_1735;
																																																				BgL_auxz00_20608
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_20644);
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_carzd224669zd2_2260;
																																																				BgL_carzd224669zd2_2260
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_cdrzd224674zd2_2261;
																																																					BgL_cdrzd224674zd2_2261
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_carzd224669zd2_2260));
																																																					if ((CAR(((obj_t) BgL_carzd224669zd2_2260)) == CNST_TABLE_REF(((long) 3))))
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_arg1980z00_2264;
																																																							obj_t
																																																								BgL_arg1981z00_2265;
																																																							obj_t
																																																								BgL_arg1982z00_2266;
																																																							BgL_arg1980z00_2264
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd224674zd2_2261));
																																																							BgL_arg1981z00_2265
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd224674zd2_2261));
																																																							BgL_arg1982z00_2266
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_20661;
																																																								{
																																																									obj_t
																																																										BgL_argsz00_20664;
																																																									obj_t
																																																										BgL_bodyz00_20663;
																																																									obj_t
																																																										BgL_varsz00_20662;
																																																									BgL_varsz00_20662
																																																										=
																																																										BgL_arg1980z00_2264;
																																																									BgL_bodyz00_20663
																																																										=
																																																										BgL_arg1981z00_2265;
																																																									BgL_argsz00_20664
																																																										=
																																																										BgL_arg1982z00_2266;
																																																									BgL_argsz00_1742
																																																										=
																																																										BgL_argsz00_20664;
																																																									BgL_bodyz00_1741
																																																										=
																																																										BgL_bodyz00_20663;
																																																									BgL_varsz00_1740
																																																										=
																																																										BgL_varsz00_20662;
																																																									goto
																																																										BgL_tagzd2386zd2_1743;
																																																								}
																																																								BgL_auxz00_20608
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_20661);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_cdrzd224697zd2_2268;
																																																							BgL_cdrzd224697zd2_2268
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd224703zd2_2269;
																																																								BgL_cdrzd224703zd2_2269
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_carzd224669zd2_2260));
																																																								if ((CAR(((obj_t) BgL_carzd224669zd2_2260)) == CNST_TABLE_REF(((long) 1))))
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd224709zd2_2272;
																																																										BgL_cdrzd224709zd2_2272
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_cdrzd224703zd2_2269));
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_carzd224714zd2_2273;
																																																											obj_t
																																																												BgL_cdrzd224715zd2_2274;
																																																											BgL_carzd224714zd2_2273
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_cdrzd224709zd2_2272));
																																																											BgL_cdrzd224715zd2_2274
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd224709zd2_2272));
																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd224714zd2_2273))
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (PAIRP(BgL_cdrzd224715zd2_2274))
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_carzd224722zd2_2277;
																																																															BgL_carzd224722zd2_2277
																																																																=
																																																																CAR
																																																																(BgL_cdrzd224715zd2_2274);
																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd224722zd2_2277))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (NULLP(CDR(BgL_cdrzd224715zd2_2274)))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			bool_t
																																																																				BgL_test9104z00_20691;
																																																																			{
																																																																				obj_t
																																																																					BgL_l1408z00_2310;
																																																																				BgL_l1408z00_2310
																																																																					=
																																																																					BgL_cdrzd224697zd2_2268;
																																																																			BgL_zc3z04anonymousza32007ze3z87_2311:
																																																																				if (NULLP(BgL_l1408z00_2310))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						BgL_test9104z00_20691
																																																																							=
																																																																							(
																																																																							(bool_t)
																																																																							1);
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						bool_t
																																																																							BgL_test9106z00_20694;
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							bool_t
																																																																								BgL_test9107z00_20695;
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_tmpz00_20696;
																																																																								BgL_tmpz00_20696
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_l1408z00_2310));
																																																																								BgL_test9107z00_20695
																																																																									=
																																																																									PAIRP
																																																																									(BgL_tmpz00_20696);
																																																																							}
																																																																							if (BgL_test9107z00_20695)
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									BgL_test9106z00_20694
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										0);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									BgL_test9106z00_20694
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										1);
																																																																								}
																																																																						}
																																																																						if (BgL_test9106z00_20694)
																																																																							{
																																																																								obj_t
																																																																									BgL_l1408z00_20700;
																																																																								BgL_l1408z00_20700
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_l1408z00_2310));
																																																																								BgL_l1408z00_2310
																																																																									=
																																																																									BgL_l1408z00_20700;
																																																																								goto
																																																																									BgL_zc3z04anonymousza32007ze3z87_2311;
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								BgL_test9104z00_20691
																																																																									=
																																																																									(
																																																																									(bool_t)
																																																																									0);
																																																																							}
																																																																					}
																																																																			}
																																																																			if (BgL_test9104z00_20691)
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_arg1996z00_2293;
																																																																					BgL_arg1996z00_2293
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd224703zd2_2269));
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_20705;
																																																																						{
																																																																							obj_t
																																																																								BgL_argsz00_20709;
																																																																							obj_t
																																																																								BgL_proc2z00_20708;
																																																																							obj_t
																																																																								BgL_proc1z00_20707;
																																																																							obj_t
																																																																								BgL_testz00_20706;
																																																																							BgL_testz00_20706
																																																																								=
																																																																								BgL_arg1996z00_2293;
																																																																							BgL_proc1z00_20707
																																																																								=
																																																																								BgL_carzd224714zd2_2273;
																																																																							BgL_proc2z00_20708
																																																																								=
																																																																								BgL_carzd224722zd2_2277;
																																																																							BgL_argsz00_20709
																																																																								=
																																																																								BgL_cdrzd224697zd2_2268;
																																																																							BgL_argsz00_1747
																																																																								=
																																																																								BgL_argsz00_20709;
																																																																							BgL_proc2z00_1746
																																																																								=
																																																																								BgL_proc2z00_20708;
																																																																							BgL_proc1z00_1745
																																																																								=
																																																																								BgL_proc1z00_20707;
																																																																							BgL_testz00_1744
																																																																								=
																																																																								BgL_testz00_20706;
																																																																							goto
																																																																								BgL_tagzd2387zd2_1748;
																																																																						}
																																																																						BgL_auxz00_20608
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_20705);
																																																																					}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd224746zd2_2294;
																																																																					BgL_cdrzd224746zd2_2294
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd224753zd2_2295;
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_pairz00_11467;
																																																																							BgL_pairz00_11467
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							BgL_cdrzd224753zd2_2295
																																																																								=
																																																																								CDR
																																																																								(BgL_pairz00_11467);
																																																																						}
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd224760zd2_2296;
																																																																							BgL_cdrzd224760zd2_2296
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd224753zd2_2295));
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_carzd224766zd2_2297;
																																																																								BgL_carzd224766zd2_2297
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd224760zd2_2296));
																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd224766zd2_2297))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_carzd224773zd2_2299;
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_pairz00_11471;
																																																																											BgL_pairz00_11471
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd224760zd2_2296));
																																																																											BgL_carzd224773zd2_2299
																																																																												=
																																																																												CAR
																																																																												(BgL_pairz00_11471);
																																																																										}
																																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd224773zd2_2299))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd224746zd2_2294))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_arg2001z00_2302;
																																																																														BgL_arg2001z00_2302
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd224753zd2_2295));
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_20731;
																																																																															{
																																																																																obj_t
																																																																																	BgL_argsz00_20735;
																																																																																obj_t
																																																																																	BgL_proc2z00_20734;
																																																																																obj_t
																																																																																	BgL_proc1z00_20733;
																																																																																obj_t
																																																																																	BgL_testz00_20732;
																																																																																BgL_testz00_20732
																																																																																	=
																																																																																	BgL_arg2001z00_2302;
																																																																																BgL_proc1z00_20733
																																																																																	=
																																																																																	BgL_carzd224766zd2_2297;
																																																																																BgL_proc2z00_20734
																																																																																	=
																																																																																	BgL_carzd224773zd2_2299;
																																																																																BgL_argsz00_20735
																																																																																	=
																																																																																	BgL_cdrzd224746zd2_2294;
																																																																																BgL_argsz00_1752
																																																																																	=
																																																																																	BgL_argsz00_20735;
																																																																																BgL_proc2z00_1751
																																																																																	=
																																																																																	BgL_proc2z00_20734;
																																																																																BgL_proc1z00_1750
																																																																																	=
																																																																																	BgL_proc1z00_20733;
																																																																																BgL_testz00_1749
																																																																																	=
																																																																																	BgL_testz00_20732;
																																																																																goto
																																																																																	BgL_tagzd2388zd2_1753;
																																																																															}
																																																																															BgL_auxz00_20608
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_20731);
																																																																														}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1777;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_20739;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1778;
																																																																																BgL_auxz00_20608
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_20739);
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1777;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_20743;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1778;
																																																																														BgL_auxz00_20608
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_20743);
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1777;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_20747;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1778;
																																																																												BgL_auxz00_20608
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_20747);
																																																																											}
																																																																									}
																																																																							}
																																																																						}
																																																																					}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1777;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_20751;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1778;
																																																																					BgL_auxz00_20608
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_20751);
																																																																				}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd225049zd2_2321;
																																																																	BgL_cdrzd225049zd2_2321
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd225055zd2_2322;
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_pairz00_11475;
																																																																			BgL_pairz00_11475
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_expz00_21));
																																																																			BgL_cdrzd225055zd2_2322
																																																																				=
																																																																				CDR
																																																																				(BgL_pairz00_11475);
																																																																		}
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd225061zd2_2323;
																																																																			BgL_cdrzd225061zd2_2323
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd225055zd2_2322));
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_carzd225066zd2_2324;
																																																																				obj_t
																																																																					BgL_cdrzd225067zd2_2325;
																																																																				BgL_carzd225066zd2_2324
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd225061zd2_2323));
																																																																				BgL_cdrzd225067zd2_2325
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd225061zd2_2323));
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd225066zd2_2324))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_carzd225072zd2_2327;
																																																																						BgL_carzd225072zd2_2327
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd225067zd2_2325));
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd225072zd2_2327))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (NULLP(CDR(((obj_t) BgL_cdrzd225067zd2_2325))))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd225049zd2_2321))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_arg2018z00_2332;
																																																																												BgL_arg2018z00_2332
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd225055zd2_2322));
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_20778;
																																																																													{
																																																																														obj_t
																																																																															BgL_argsz00_20782;
																																																																														obj_t
																																																																															BgL_proc2z00_20781;
																																																																														obj_t
																																																																															BgL_proc1z00_20780;
																																																																														obj_t
																																																																															BgL_testz00_20779;
																																																																														BgL_testz00_20779
																																																																															=
																																																																															BgL_arg2018z00_2332;
																																																																														BgL_proc1z00_20780
																																																																															=
																																																																															BgL_carzd225066zd2_2324;
																																																																														BgL_proc2z00_20781
																																																																															=
																																																																															BgL_carzd225072zd2_2327;
																																																																														BgL_argsz00_20782
																																																																															=
																																																																															BgL_cdrzd225049zd2_2321;
																																																																														BgL_argsz00_1752
																																																																															=
																																																																															BgL_argsz00_20782;
																																																																														BgL_proc2z00_1751
																																																																															=
																																																																															BgL_proc2z00_20781;
																																																																														BgL_proc1z00_1750
																																																																															=
																																																																															BgL_proc1z00_20780;
																																																																														BgL_testz00_1749
																																																																															=
																																																																															BgL_testz00_20779;
																																																																														goto
																																																																															BgL_tagzd2388zd2_1753;
																																																																													}
																																																																													BgL_auxz00_20608
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_20778);
																																																																												}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1777;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_20786;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1778;
																																																																														BgL_auxz00_20608
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_20786);
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1777;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_20790;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1778;
																																																																												BgL_auxz00_20608
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_20790);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1777;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_20794;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1778;
																																																																										BgL_auxz00_20608
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_20794);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1777;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_20798;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1778;
																																																																								BgL_auxz00_20608
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_20798);
																																																																							}
																																																																					}
																																																																			}
																																																																		}
																																																																	}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1777;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_20802;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1778;
																																																																	BgL_auxz00_20608
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_20802);
																																																																}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd225405zd2_2340;
																																																													BgL_cdrzd225405zd2_2340
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd225412zd2_2341;
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_pairz00_11485;
																																																															BgL_pairz00_11485
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															BgL_cdrzd225412zd2_2341
																																																																=
																																																																CDR
																																																																(BgL_pairz00_11485);
																																																														}
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd225419zd2_2342;
																																																															BgL_cdrzd225419zd2_2342
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd225412zd2_2341));
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_carzd225425zd2_2343;
																																																																obj_t
																																																																	BgL_cdrzd225426zd2_2344;
																																																																BgL_carzd225425zd2_2343
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd225419zd2_2342));
																																																																BgL_cdrzd225426zd2_2344
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd225419zd2_2342));
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd225425zd2_2343))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (PAIRP(BgL_cdrzd225426zd2_2344))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_carzd225433zd2_2347;
																																																																				BgL_carzd225433zd2_2347
																																																																					=
																																																																					CAR
																																																																					(BgL_cdrzd225426zd2_2344);
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd225433zd2_2347))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (NULLP(CDR(BgL_cdrzd225426zd2_2344)))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd225405zd2_2340))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_arg2032z00_2352;
																																																																										BgL_arg2032z00_2352
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd225412zd2_2341));
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_20829;
																																																																											{
																																																																												obj_t
																																																																													BgL_argsz00_20833;
																																																																												obj_t
																																																																													BgL_proc2z00_20832;
																																																																												obj_t
																																																																													BgL_proc1z00_20831;
																																																																												obj_t
																																																																													BgL_testz00_20830;
																																																																												BgL_testz00_20830
																																																																													=
																																																																													BgL_arg2032z00_2352;
																																																																												BgL_proc1z00_20831
																																																																													=
																																																																													BgL_carzd225425zd2_2343;
																																																																												BgL_proc2z00_20832
																																																																													=
																																																																													BgL_carzd225433zd2_2347;
																																																																												BgL_argsz00_20833
																																																																													=
																																																																													BgL_cdrzd225405zd2_2340;
																																																																												BgL_argsz00_1752
																																																																													=
																																																																													BgL_argsz00_20833;
																																																																												BgL_proc2z00_1751
																																																																													=
																																																																													BgL_proc2z00_20832;
																																																																												BgL_proc1z00_1750
																																																																													=
																																																																													BgL_proc1z00_20831;
																																																																												BgL_testz00_1749
																																																																													=
																																																																													BgL_testz00_20830;
																																																																												goto
																																																																													BgL_tagzd2388zd2_1753;
																																																																											}
																																																																											BgL_auxz00_20608
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_20829);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1777;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_20837;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1778;
																																																																												BgL_auxz00_20608
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_20837);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1777;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_20841;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1778;
																																																																										BgL_auxz00_20608
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_20841);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1777;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_20845;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1778;
																																																																								BgL_auxz00_20608
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_20845);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1777;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_20849;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1778;
																																																																						BgL_auxz00_20608
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_20849);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1777;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_20853;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1778;
																																																																				BgL_auxz00_20608
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_20853);
																																																																			}
																																																																	}
																																																															}
																																																														}
																																																													}
																																																												}
																																																										}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 119 */
																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																											{	/* Ast/sexp.scm 119 */
																																																												goto
																																																													BgL_tagzd2403zd2_1777;
																																																											}
																																																										else
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_20857;
																																																												goto
																																																													BgL_tagzd2404zd2_1778;
																																																												BgL_auxz00_20608
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_20857);
																																																											}
																																																									}
																																																							}
																																																						}
																																																				}
																																																			}
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																bool_t
																																																	BgL_test9135z00_20859;
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg1970z00_2253;
																																																	BgL_arg1970z00_2253
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	BgL_test9135z00_20859
																																																		=
																																																		CBOOL
																																																		(BGl_labelszd2symzf3z21zzast_labelsz00
																																																		(BgL_arg1970z00_2253));
																																																}
																																																if (BgL_test9135z00_20859)
																																																	{
																																																		BgL_letzd2funzd2_bglt
																																																			BgL_auxz00_20864;
																																																		goto
																																																			BgL_tagzd2384zd2_1735;
																																																		BgL_auxz00_20608
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_20864);
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_carzd225865zd2_2150;
																																																		BgL_carzd225865zd2_2150
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_cdrzd225870zd2_2151;
																																																			BgL_cdrzd225870zd2_2151
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_carzd225865zd2_2150));
																																																			if ((CAR(((obj_t) BgL_carzd225865zd2_2150)) == CNST_TABLE_REF(((long) 3))))
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_arg1911z00_2154;
																																																					obj_t
																																																						BgL_arg1912z00_2155;
																																																					obj_t
																																																						BgL_arg1913z00_2156;
																																																					BgL_arg1911z00_2154
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd225870zd2_2151));
																																																					BgL_arg1912z00_2155
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd225870zd2_2151));
																																																					BgL_arg1913z00_2156
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_20881;
																																																						{
																																																							obj_t
																																																								BgL_argsz00_20884;
																																																							obj_t
																																																								BgL_bodyz00_20883;
																																																							obj_t
																																																								BgL_varsz00_20882;
																																																							BgL_varsz00_20882
																																																								=
																																																								BgL_arg1911z00_2154;
																																																							BgL_bodyz00_20883
																																																								=
																																																								BgL_arg1912z00_2155;
																																																							BgL_argsz00_20884
																																																								=
																																																								BgL_arg1913z00_2156;
																																																							BgL_argsz00_1742
																																																								=
																																																								BgL_argsz00_20884;
																																																							BgL_bodyz00_1741
																																																								=
																																																								BgL_bodyz00_20883;
																																																							BgL_varsz00_1740
																																																								=
																																																								BgL_varsz00_20882;
																																																							goto
																																																								BgL_tagzd2386zd2_1743;
																																																						}
																																																						BgL_auxz00_20608
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_20881);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_cdrzd225893zd2_2158;
																																																					BgL_cdrzd225893zd2_2158
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd225899zd2_2159;
																																																						BgL_cdrzd225899zd2_2159
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_carzd225865zd2_2150));
																																																						if ((CAR(((obj_t) BgL_carzd225865zd2_2150)) == CNST_TABLE_REF(((long) 1))))
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd225905zd2_2162;
																																																								BgL_cdrzd225905zd2_2162
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_cdrzd225899zd2_2159));
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_carzd225910zd2_2163;
																																																									obj_t
																																																										BgL_cdrzd225911zd2_2164;
																																																									BgL_carzd225910zd2_2163
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd225905zd2_2162));
																																																									BgL_cdrzd225911zd2_2164
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd225905zd2_2162));
																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd225910zd2_2163))
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (PAIRP(BgL_cdrzd225911zd2_2164))
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_carzd225918zd2_2167;
																																																													BgL_carzd225918zd2_2167
																																																														=
																																																														CAR
																																																														(BgL_cdrzd225911zd2_2164);
																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd225918zd2_2167))
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (NULLP(CDR(BgL_cdrzd225911zd2_2164)))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	bool_t
																																																																		BgL_test9142z00_20911;
																																																																	{
																																																																		obj_t
																																																																			BgL_l1411z00_2200;
																																																																		BgL_l1411z00_2200
																																																																			=
																																																																			BgL_cdrzd225893zd2_2158;
																																																																	BgL_zc3z04anonymousza31936ze3z87_2201:
																																																																		if (NULLP(BgL_l1411z00_2200))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				BgL_test9142z00_20911
																																																																					=
																																																																					(
																																																																					(bool_t)
																																																																					1);
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				bool_t
																																																																					BgL_test9144z00_20914;
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					bool_t
																																																																						BgL_test9145z00_20915;
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_tmpz00_20916;
																																																																						BgL_tmpz00_20916
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_l1411z00_2200));
																																																																						BgL_test9145z00_20915
																																																																							=
																																																																							PAIRP
																																																																							(BgL_tmpz00_20916);
																																																																					}
																																																																					if (BgL_test9145z00_20915)
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							BgL_test9144z00_20914
																																																																								=
																																																																								(
																																																																								(bool_t)
																																																																								0);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							BgL_test9144z00_20914
																																																																								=
																																																																								(
																																																																								(bool_t)
																																																																								1);
																																																																						}
																																																																				}
																																																																				if (BgL_test9144z00_20914)
																																																																					{
																																																																						obj_t
																																																																							BgL_l1411z00_20920;
																																																																						BgL_l1411z00_20920
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_l1411z00_2200));
																																																																						BgL_l1411z00_2200
																																																																							=
																																																																							BgL_l1411z00_20920;
																																																																						goto
																																																																							BgL_zc3z04anonymousza31936ze3z87_2201;
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						BgL_test9142z00_20911
																																																																							=
																																																																							(
																																																																							(bool_t)
																																																																							0);
																																																																					}
																																																																			}
																																																																	}
																																																																	if (BgL_test9142z00_20911)
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_arg1926z00_2183;
																																																																			BgL_arg1926z00_2183
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd225899zd2_2159));
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_20925;
																																																																				{
																																																																					obj_t
																																																																						BgL_argsz00_20929;
																																																																					obj_t
																																																																						BgL_proc2z00_20928;
																																																																					obj_t
																																																																						BgL_proc1z00_20927;
																																																																					obj_t
																																																																						BgL_testz00_20926;
																																																																					BgL_testz00_20926
																																																																						=
																																																																						BgL_arg1926z00_2183;
																																																																					BgL_proc1z00_20927
																																																																						=
																																																																						BgL_carzd225910zd2_2163;
																																																																					BgL_proc2z00_20928
																																																																						=
																																																																						BgL_carzd225918zd2_2167;
																																																																					BgL_argsz00_20929
																																																																						=
																																																																						BgL_cdrzd225893zd2_2158;
																																																																					BgL_argsz00_1747
																																																																						=
																																																																						BgL_argsz00_20929;
																																																																					BgL_proc2z00_1746
																																																																						=
																																																																						BgL_proc2z00_20928;
																																																																					BgL_proc1z00_1745
																																																																						=
																																																																						BgL_proc1z00_20927;
																																																																					BgL_testz00_1744
																																																																						=
																																																																						BgL_testz00_20926;
																																																																					goto
																																																																						BgL_tagzd2387zd2_1748;
																																																																				}
																																																																				BgL_auxz00_20608
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_20925);
																																																																			}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd225942zd2_2184;
																																																																			BgL_cdrzd225942zd2_2184
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_expz00_21));
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd225949zd2_2185;
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_pairz00_11520;
																																																																					BgL_pairz00_11520
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					BgL_cdrzd225949zd2_2185
																																																																						=
																																																																						CDR
																																																																						(BgL_pairz00_11520);
																																																																				}
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd225956zd2_2186;
																																																																					BgL_cdrzd225956zd2_2186
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd225949zd2_2185));
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_carzd225962zd2_2187;
																																																																						BgL_carzd225962zd2_2187
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd225956zd2_2186));
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd225962zd2_2187))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_carzd225969zd2_2189;
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_pairz00_11524;
																																																																									BgL_pairz00_11524
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd225956zd2_2186));
																																																																									BgL_carzd225969zd2_2189
																																																																										=
																																																																										CAR
																																																																										(BgL_pairz00_11524);
																																																																								}
																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd225969zd2_2189))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd225942zd2_2184))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_arg1930z00_2192;
																																																																												BgL_arg1930z00_2192
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd225949zd2_2185));
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_20951;
																																																																													{
																																																																														obj_t
																																																																															BgL_argsz00_20955;
																																																																														obj_t
																																																																															BgL_proc2z00_20954;
																																																																														obj_t
																																																																															BgL_proc1z00_20953;
																																																																														obj_t
																																																																															BgL_testz00_20952;
																																																																														BgL_testz00_20952
																																																																															=
																																																																															BgL_arg1930z00_2192;
																																																																														BgL_proc1z00_20953
																																																																															=
																																																																															BgL_carzd225962zd2_2187;
																																																																														BgL_proc2z00_20954
																																																																															=
																																																																															BgL_carzd225969zd2_2189;
																																																																														BgL_argsz00_20955
																																																																															=
																																																																															BgL_cdrzd225942zd2_2184;
																																																																														BgL_argsz00_1752
																																																																															=
																																																																															BgL_argsz00_20955;
																																																																														BgL_proc2z00_1751
																																																																															=
																																																																															BgL_proc2z00_20954;
																																																																														BgL_proc1z00_1750
																																																																															=
																																																																															BgL_proc1z00_20953;
																																																																														BgL_testz00_1749
																																																																															=
																																																																															BgL_testz00_20952;
																																																																														goto
																																																																															BgL_tagzd2388zd2_1753;
																																																																													}
																																																																													BgL_auxz00_20608
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_20951);
																																																																												}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1777;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_20959;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1778;
																																																																														BgL_auxz00_20608
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_20959);
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1777;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_20963;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1778;
																																																																												BgL_auxz00_20608
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_20963);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1777;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_20967;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1778;
																																																																										BgL_auxz00_20608
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_20967);
																																																																									}
																																																																							}
																																																																					}
																																																																				}
																																																																			}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1777;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_20971;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1778;
																																																																			BgL_auxz00_20608
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_20971);
																																																																		}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd226245zd2_2211;
																																																															BgL_cdrzd226245zd2_2211
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd226251zd2_2212;
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_pairz00_11528;
																																																																	BgL_pairz00_11528
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	BgL_cdrzd226251zd2_2212
																																																																		=
																																																																		CDR
																																																																		(BgL_pairz00_11528);
																																																																}
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd226257zd2_2213;
																																																																	BgL_cdrzd226257zd2_2213
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd226251zd2_2212));
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_carzd226262zd2_2214;
																																																																		obj_t
																																																																			BgL_cdrzd226263zd2_2215;
																																																																		BgL_carzd226262zd2_2214
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd226257zd2_2213));
																																																																		BgL_cdrzd226263zd2_2215
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd226257zd2_2213));
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd226262zd2_2214))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_carzd226268zd2_2217;
																																																																				BgL_carzd226268zd2_2217
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd226263zd2_2215));
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd226268zd2_2217))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (NULLP(CDR(((obj_t) BgL_cdrzd226263zd2_2215))))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd226245zd2_2211))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_arg1945z00_2222;
																																																																										BgL_arg1945z00_2222
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd226251zd2_2212));
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_20998;
																																																																											{
																																																																												obj_t
																																																																													BgL_argsz00_21002;
																																																																												obj_t
																																																																													BgL_proc2z00_21001;
																																																																												obj_t
																																																																													BgL_proc1z00_21000;
																																																																												obj_t
																																																																													BgL_testz00_20999;
																																																																												BgL_testz00_20999
																																																																													=
																																																																													BgL_arg1945z00_2222;
																																																																												BgL_proc1z00_21000
																																																																													=
																																																																													BgL_carzd226262zd2_2214;
																																																																												BgL_proc2z00_21001
																																																																													=
																																																																													BgL_carzd226268zd2_2217;
																																																																												BgL_argsz00_21002
																																																																													=
																																																																													BgL_cdrzd226245zd2_2211;
																																																																												BgL_argsz00_1752
																																																																													=
																																																																													BgL_argsz00_21002;
																																																																												BgL_proc2z00_1751
																																																																													=
																																																																													BgL_proc2z00_21001;
																																																																												BgL_proc1z00_1750
																																																																													=
																																																																													BgL_proc1z00_21000;
																																																																												BgL_testz00_1749
																																																																													=
																																																																													BgL_testz00_20999;
																																																																												goto
																																																																													BgL_tagzd2388zd2_1753;
																																																																											}
																																																																											BgL_auxz00_20608
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_20998);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1777;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_21006;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1778;
																																																																												BgL_auxz00_20608
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_21006);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1777;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_21010;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1778;
																																																																										BgL_auxz00_20608
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_21010);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1777;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_21014;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1778;
																																																																								BgL_auxz00_20608
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_21014);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1777;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_21018;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1778;
																																																																						BgL_auxz00_20608
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_21018);
																																																																					}
																																																																			}
																																																																	}
																																																																}
																																																															}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{	/* Ast/sexp.scm 119 */
																																																															goto
																																																																BgL_tagzd2403zd2_1777;
																																																														}
																																																													else
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_21022;
																																																															goto
																																																																BgL_tagzd2404zd2_1778;
																																																															BgL_auxz00_20608
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_21022);
																																																														}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_cdrzd226601zd2_2230;
																																																											BgL_cdrzd226601zd2_2230
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd226608zd2_2231;
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_pairz00_11538;
																																																													BgL_pairz00_11538
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													BgL_cdrzd226608zd2_2231
																																																														=
																																																														CDR
																																																														(BgL_pairz00_11538);
																																																												}
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd226615zd2_2232;
																																																													BgL_cdrzd226615zd2_2232
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd226608zd2_2231));
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_carzd226621zd2_2233;
																																																														obj_t
																																																															BgL_cdrzd226622zd2_2234;
																																																														BgL_carzd226621zd2_2233
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd226615zd2_2232));
																																																														BgL_cdrzd226622zd2_2234
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd226615zd2_2232));
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd226621zd2_2233))
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (PAIRP(BgL_cdrzd226622zd2_2234))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_carzd226629zd2_2237;
																																																																		BgL_carzd226629zd2_2237
																																																																			=
																																																																			CAR
																																																																			(BgL_cdrzd226622zd2_2234);
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd226629zd2_2237))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (NULLP(CDR(BgL_cdrzd226622zd2_2234)))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd226601zd2_2230))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_arg1959z00_2242;
																																																																								BgL_arg1959z00_2242
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd226608zd2_2231));
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_21049;
																																																																									{
																																																																										obj_t
																																																																											BgL_argsz00_21053;
																																																																										obj_t
																																																																											BgL_proc2z00_21052;
																																																																										obj_t
																																																																											BgL_proc1z00_21051;
																																																																										obj_t
																																																																											BgL_testz00_21050;
																																																																										BgL_testz00_21050
																																																																											=
																																																																											BgL_arg1959z00_2242;
																																																																										BgL_proc1z00_21051
																																																																											=
																																																																											BgL_carzd226621zd2_2233;
																																																																										BgL_proc2z00_21052
																																																																											=
																																																																											BgL_carzd226629zd2_2237;
																																																																										BgL_argsz00_21053
																																																																											=
																																																																											BgL_cdrzd226601zd2_2230;
																																																																										BgL_argsz00_1752
																																																																											=
																																																																											BgL_argsz00_21053;
																																																																										BgL_proc2z00_1751
																																																																											=
																																																																											BgL_proc2z00_21052;
																																																																										BgL_proc1z00_1750
																																																																											=
																																																																											BgL_proc1z00_21051;
																																																																										BgL_testz00_1749
																																																																											=
																																																																											BgL_testz00_21050;
																																																																										goto
																																																																											BgL_tagzd2388zd2_1753;
																																																																									}
																																																																									BgL_auxz00_20608
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_21049);
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1777;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_21057;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1778;
																																																																										BgL_auxz00_20608
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_21057);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1777;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_21061;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1778;
																																																																								BgL_auxz00_20608
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_21061);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1777;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_21065;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1778;
																																																																						BgL_auxz00_20608
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_21065);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1777;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_21069;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1778;
																																																																				BgL_auxz00_20608
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_21069);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1777;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_21073;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1778;
																																																																		BgL_auxz00_20608
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_21073);
																																																																	}
																																																															}
																																																													}
																																																												}
																																																											}
																																																										}
																																																								}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																									{	/* Ast/sexp.scm 119 */
																																																										goto
																																																											BgL_tagzd2403zd2_1777;
																																																									}
																																																								else
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_21077;
																																																										goto
																																																											BgL_tagzd2404zd2_1778;
																																																										BgL_auxz00_20608
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_21077);
																																																									}
																																																							}
																																																					}
																																																				}
																																																		}
																																																	}
																																															}
																																													}
																																												}
																																											}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 119 */
																																										obj_t
																																											BgL_cdrzd227021zd2_2365;
																																										BgL_cdrzd227021zd2_2365
																																											=
																																											CDR
																																											(
																																											((obj_t) BgL_expz00_21));
																																										{

																																											{	/* Ast/sexp.scm 119 */
																																												bool_t
																																													BgL_test9173z00_21081;
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_arg2058z00_2381;
																																													BgL_arg2058z00_2381
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													BgL_test9173z00_21081
																																														=
																																														CBOOL
																																														(BGl_letzd2symzf3z21zzast_letz00
																																														(BgL_arg2058z00_2381));
																																												}
																																												if (BgL_test9173z00_21081)
																																													{	/* Ast/sexp.scm 119 */
																																														if (PAIRP(BgL_cdrzd227021zd2_2365))
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_arg2060z00_2383;
																																																obj_t
																																																	BgL_arg2061z00_2384;
																																																BgL_arg2060z00_2383
																																																	=
																																																	CAR
																																																	(BgL_cdrzd227021zd2_2365);
																																																BgL_arg2061z00_2384
																																																	=
																																																	CDR
																																																	(BgL_cdrzd227021zd2_2365);
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_21090;
																																																	{
																																																		obj_t
																																																			BgL_exprz00_21092;
																																																		obj_t
																																																			BgL_bindingsz00_21091;
																																																		BgL_bindingsz00_21091
																																																			=
																																																			BgL_arg2060z00_2383;
																																																		BgL_exprz00_21092
																																																			=
																																																			BgL_arg2061z00_2384;
																																																		BgL_exprz00_1732
																																																			=
																																																			BgL_exprz00_21092;
																																																		BgL_bindingsz00_1731
																																																			=
																																																			BgL_bindingsz00_21091;
																																																		goto
																																																			BgL_tagzd2382zd2_1733;
																																																	}
																																																	BgL_auxz00_20608
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_21090);
																																																}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																bool_t
																																																	BgL_test9175z00_21094;
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg2072z00_2396;
																																																	BgL_arg2072z00_2396
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	BgL_test9175z00_21094
																																																		=
																																																		CBOOL
																																																		(BGl_labelszd2symzf3z21zzast_labelsz00
																																																		(BgL_arg2072z00_2396));
																																																}
																																																if (BgL_test9175z00_21094)
																																																	{
																																																		BgL_letzd2funzd2_bglt
																																																			BgL_auxz00_21099;
																																																		goto
																																																			BgL_tagzd2384zd2_1735;
																																																		BgL_auxz00_20608
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_21099);
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_carzd227084zd2_2387;
																																																		BgL_carzd227084zd2_2387
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_cdrzd227089zd2_2388;
																																																			BgL_cdrzd227089zd2_2388
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_carzd227084zd2_2387));
																																																			if ((CAR(((obj_t) BgL_carzd227084zd2_2387)) == CNST_TABLE_REF(((long) 3))))
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_arg2066z00_2391;
																																																					obj_t
																																																						BgL_arg2067z00_2392;
																																																					obj_t
																																																						BgL_arg2068z00_2393;
																																																					BgL_arg2066z00_2391
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd227089zd2_2388));
																																																					BgL_arg2067z00_2392
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd227089zd2_2388));
																																																					BgL_arg2068z00_2393
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_21116;
																																																						{
																																																							obj_t
																																																								BgL_argsz00_21119;
																																																							obj_t
																																																								BgL_bodyz00_21118;
																																																							obj_t
																																																								BgL_varsz00_21117;
																																																							BgL_varsz00_21117
																																																								=
																																																								BgL_arg2066z00_2391;
																																																							BgL_bodyz00_21118
																																																								=
																																																								BgL_arg2067z00_2392;
																																																							BgL_argsz00_21119
																																																								=
																																																								BgL_arg2068z00_2393;
																																																							BgL_argsz00_1742
																																																								=
																																																								BgL_argsz00_21119;
																																																							BgL_bodyz00_1741
																																																								=
																																																								BgL_bodyz00_21118;
																																																							BgL_varsz00_1740
																																																								=
																																																								BgL_varsz00_21117;
																																																							goto
																																																								BgL_tagzd2386zd2_1743;
																																																						}
																																																						BgL_auxz00_20608
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_21116);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																						{	/* Ast/sexp.scm 119 */
																																																							goto
																																																								BgL_tagzd2403zd2_1777;
																																																						}
																																																					else
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_21123;
																																																							goto
																																																								BgL_tagzd2404zd2_1778;
																																																							BgL_auxz00_20608
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_21123);
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														bool_t
																																															BgL_test9178z00_21125;
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg2057z00_2380;
																																															BgL_arg2057z00_2380
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															BgL_test9178z00_21125
																																																=
																																																CBOOL
																																																(BGl_labelszd2symzf3z21zzast_labelsz00
																																																(BgL_arg2057z00_2380));
																																														}
																																														if (BgL_test9178z00_21125)
																																															{
																																																BgL_letzd2funzd2_bglt
																																																	BgL_auxz00_21130;
																																																goto
																																																	BgL_tagzd2384zd2_1735;
																																																BgL_auxz00_20608
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_21130);
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_carzd227238zd2_2371;
																																																BgL_carzd227238zd2_2371
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_cdrzd227243zd2_2372;
																																																	BgL_cdrzd227243zd2_2372
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_carzd227238zd2_2371));
																																																	if ((CAR(((obj_t) BgL_carzd227238zd2_2371)) == CNST_TABLE_REF(((long) 3))))
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg2051z00_2375;
																																																			obj_t
																																																				BgL_arg2052z00_2376;
																																																			obj_t
																																																				BgL_arg2053z00_2377;
																																																			BgL_arg2051z00_2375
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd227243zd2_2372));
																																																			BgL_arg2052z00_2376
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd227243zd2_2372));
																																																			BgL_arg2053z00_2377
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_21147;
																																																				{
																																																					obj_t
																																																						BgL_argsz00_21150;
																																																					obj_t
																																																						BgL_bodyz00_21149;
																																																					obj_t
																																																						BgL_varsz00_21148;
																																																					BgL_varsz00_21148
																																																						=
																																																						BgL_arg2051z00_2375;
																																																					BgL_bodyz00_21149
																																																						=
																																																						BgL_arg2052z00_2376;
																																																					BgL_argsz00_21150
																																																						=
																																																						BgL_arg2053z00_2377;
																																																					BgL_argsz00_1742
																																																						=
																																																						BgL_argsz00_21150;
																																																					BgL_bodyz00_1741
																																																						=
																																																						BgL_bodyz00_21149;
																																																					BgL_varsz00_1740
																																																						=
																																																						BgL_varsz00_21148;
																																																					goto
																																																						BgL_tagzd2386zd2_1743;
																																																				}
																																																				BgL_auxz00_20608
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_21147);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																				{	/* Ast/sexp.scm 119 */
																																																					goto
																																																						BgL_tagzd2403zd2_1777;
																																																				}
																																																			else
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_21154;
																																																					goto
																																																						BgL_tagzd2404zd2_1778;
																																																					BgL_auxz00_20608
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_21154);
																																																				}
																																																		}
																																																}
																																															}
																																													}
																																											}
																																										}
																																									}
																																							}
																																						else
																																							{	/* Ast/sexp.scm 119 */
																																								obj_t
																																									BgL_cdrzd227353zd2_2397;
																																								BgL_cdrzd227353zd2_2397
																																									=
																																									CDR
																																									(
																																									((obj_t) BgL_expz00_21));
																																								{

																																									{	/* Ast/sexp.scm 119 */
																																										bool_t
																																											BgL_test9181z00_21158;
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_arg2079z00_2405;
																																											BgL_arg2079z00_2405
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_expz00_21));
																																											BgL_test9181z00_21158
																																												=
																																												CBOOL
																																												(BGl_letzd2symzf3z21zzast_letz00
																																												(BgL_arg2079z00_2405));
																																										}
																																										if (BgL_test9181z00_21158)
																																											{	/* Ast/sexp.scm 119 */
																																												if (PAIRP(BgL_cdrzd227353zd2_2397))
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_arg2081z00_2407;
																																														obj_t
																																															BgL_arg2083z00_2408;
																																														BgL_arg2081z00_2407
																																															=
																																															CAR
																																															(BgL_cdrzd227353zd2_2397);
																																														BgL_arg2083z00_2408
																																															=
																																															CDR
																																															(BgL_cdrzd227353zd2_2397);
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_21167;
																																															{
																																																obj_t
																																																	BgL_exprz00_21169;
																																																obj_t
																																																	BgL_bindingsz00_21168;
																																																BgL_bindingsz00_21168
																																																	=
																																																	BgL_arg2081z00_2407;
																																																BgL_exprz00_21169
																																																	=
																																																	BgL_arg2083z00_2408;
																																																BgL_exprz00_1732
																																																	=
																																																	BgL_exprz00_21169;
																																																BgL_bindingsz00_1731
																																																	=
																																																	BgL_bindingsz00_21168;
																																																goto
																																																	BgL_tagzd2382zd2_1733;
																																															}
																																															BgL_auxz00_20608
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_21167);
																																														}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														bool_t
																																															BgL_test9183z00_21171;
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg2087z00_2412;
																																															BgL_arg2087z00_2412
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															BgL_test9183z00_21171
																																																=
																																																CBOOL
																																																(BGl_labelszd2symzf3z21zzast_labelsz00
																																																(BgL_arg2087z00_2412));
																																														}
																																														if (BgL_test9183z00_21171)
																																															{
																																																BgL_letzd2funzd2_bglt
																																																	BgL_auxz00_21176;
																																																goto
																																																	BgL_tagzd2384zd2_1735;
																																																BgL_auxz00_20608
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_21176);
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																	{	/* Ast/sexp.scm 119 */
																																																		goto
																																																			BgL_tagzd2403zd2_1777;
																																																	}
																																																else
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_21180;
																																																		goto
																																																			BgL_tagzd2404zd2_1778;
																																																		BgL_auxz00_20608
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_21180);
																																																	}
																																															}
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												bool_t
																																													BgL_test9185z00_21182;
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_arg2078z00_2404;
																																													BgL_arg2078z00_2404
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													BgL_test9185z00_21182
																																														=
																																														CBOOL
																																														(BGl_labelszd2symzf3z21zzast_labelsz00
																																														(BgL_arg2078z00_2404));
																																												}
																																												if (BgL_test9185z00_21182)
																																													{
																																														BgL_letzd2funzd2_bglt
																																															BgL_auxz00_21187;
																																														goto
																																															BgL_tagzd2384zd2_1735;
																																														BgL_auxz00_20608
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_21187);
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																															{	/* Ast/sexp.scm 119 */
																																																goto
																																																	BgL_tagzd2403zd2_1777;
																																															}
																																														else
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_21191;
																																																goto
																																																	BgL_tagzd2404zd2_1778;
																																																BgL_auxz00_20608
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_21191);
																																															}
																																													}
																																											}
																																									}
																																								}
																																							}
																																						return
																																							(
																																							(BgL_nodez00_bglt)
																																							BgL_auxz00_20608);
																																					}
																																				else
																																					{	/* Ast/sexp.scm 119 */
																																						if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd224577zd2_1834)))
																																							{
																																								obj_t
																																									BgL_auxz00_21197;
																																								goto
																																									BgL_kapzd224579zd2_1836;
																																								return
																																									(
																																									(BgL_nodez00_bglt)
																																									BgL_auxz00_21197);
																																							}
																																						else
																																							{	/* Ast/sexp.scm 119 */
																																								if ((BgL_carzd224577zd2_1834 == CNST_TABLE_REF(((long) 18))))
																																									{
																																										obj_t
																																											BgL_auxz00_21202;
																																										goto
																																											BgL_kapzd224579zd2_1836;
																																										return
																																											(
																																											(BgL_nodez00_bglt)
																																											BgL_auxz00_21202);
																																									}
																																								else
																																									{	/* Ast/sexp.scm 119 */
																																										if ((BgL_carzd224577zd2_1834 == CNST_TABLE_REF(((long) 19))))
																																											{
																																												obj_t
																																													BgL_auxz00_21207;
																																												goto
																																													BgL_kapzd224579zd2_1836;
																																												return
																																													(
																																													(BgL_nodez00_bglt)
																																													BgL_auxz00_21207);
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd224577zd2_1834)))
																																													{
																																														obj_t
																																															BgL_auxz00_21212;
																																														goto
																																															BgL_kapzd224579zd2_1836;
																																														return
																																															(
																																															(BgL_nodez00_bglt)
																																															BgL_auxz00_21212);
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_cdrzd227662zd2_1842;
																																														BgL_cdrzd227662zd2_1842
																																															=
																																															CDR
																																															(BgL_expz00_21);
																																														{

																																															{	/* Ast/sexp.scm 119 */
																																																bool_t
																																																	BgL_test9191z00_21215;
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg1822z00_2021;
																																																	BgL_arg1822z00_2021
																																																		=
																																																		CAR
																																																		(BgL_expz00_21);
																																																	BgL_test9191z00_21215
																																																		=
																																																		CBOOL
																																																		(BGl_letzd2symzf3z21zzast_letz00
																																																		(BgL_arg1822z00_2021));
																																																}
																																																if (BgL_test9191z00_21215)
																																																	{
																																																		obj_t
																																																			BgL_auxz00_21219;
																																																		if (PAIRP(BgL_cdrzd227662zd2_1842))
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg1825z00_2023;
																																																				obj_t
																																																					BgL_arg1826z00_2024;
																																																				BgL_arg1825z00_2023
																																																					=
																																																					CAR
																																																					(BgL_cdrzd227662zd2_1842);
																																																				BgL_arg1826z00_2024
																																																					=
																																																					CDR
																																																					(BgL_cdrzd227662zd2_1842);
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_21224;
																																																					{
																																																						obj_t
																																																							BgL_exprz00_21226;
																																																						obj_t
																																																							BgL_bindingsz00_21225;
																																																						BgL_bindingsz00_21225
																																																							=
																																																							BgL_arg1825z00_2023;
																																																						BgL_exprz00_21226
																																																							=
																																																							BgL_arg1826z00_2024;
																																																						BgL_exprz00_1732
																																																							=
																																																							BgL_exprz00_21226;
																																																						BgL_bindingsz00_1731
																																																							=
																																																							BgL_bindingsz00_21225;
																																																						goto
																																																							BgL_tagzd2382zd2_1733;
																																																					}
																																																					BgL_auxz00_21219
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_21224);
																																																				}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				bool_t
																																																					BgL_test9193z00_21228;
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_arg1898z00_2136;
																																																					BgL_arg1898z00_2136
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					BgL_test9193z00_21228
																																																						=
																																																						CBOOL
																																																						(BGl_labelszd2symzf3z21zzast_labelsz00
																																																						(BgL_arg1898z00_2136));
																																																				}
																																																				if (BgL_test9193z00_21228)
																																																					{
																																																						BgL_letzd2funzd2_bglt
																																																							BgL_auxz00_21233;
																																																						goto
																																																							BgL_tagzd2384zd2_1735;
																																																						BgL_auxz00_21219
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_21233);
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_carzd227725zd2_2027;
																																																						BgL_carzd227725zd2_2027
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_cdrzd227730zd2_2028;
																																																							BgL_cdrzd227730zd2_2028
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_carzd227725zd2_2027));
																																																							if ((CAR(((obj_t) BgL_carzd227725zd2_2027)) == CNST_TABLE_REF(((long) 3))))
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (PAIRP(BgL_cdrzd227730zd2_2028))
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_arg1833z00_2032;
																																																											obj_t
																																																												BgL_arg1834z00_2033;
																																																											obj_t
																																																												BgL_arg1835z00_2034;
																																																											BgL_arg1833z00_2032
																																																												=
																																																												CAR
																																																												(BgL_cdrzd227730zd2_2028);
																																																											BgL_arg1834z00_2033
																																																												=
																																																												CDR
																																																												(BgL_cdrzd227730zd2_2028);
																																																											BgL_arg1835z00_2034
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_21250;
																																																												{
																																																													obj_t
																																																														BgL_argsz00_21253;
																																																													obj_t
																																																														BgL_bodyz00_21252;
																																																													obj_t
																																																														BgL_varsz00_21251;
																																																													BgL_varsz00_21251
																																																														=
																																																														BgL_arg1833z00_2032;
																																																													BgL_bodyz00_21252
																																																														=
																																																														BgL_arg1834z00_2033;
																																																													BgL_argsz00_21253
																																																														=
																																																														BgL_arg1835z00_2034;
																																																													BgL_argsz00_1742
																																																														=
																																																														BgL_argsz00_21253;
																																																													BgL_bodyz00_1741
																																																														=
																																																														BgL_bodyz00_21252;
																																																													BgL_varsz00_1740
																																																														=
																																																														BgL_varsz00_21251;
																																																													goto
																																																														BgL_tagzd2386zd2_1743;
																																																												}
																																																												BgL_auxz00_21219
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_21250);
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{	/* Ast/sexp.scm 119 */
																																																													goto
																																																														BgL_tagzd2403zd2_1777;
																																																												}
																																																											else
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_21257;
																																																													goto
																																																														BgL_tagzd2404zd2_1778;
																																																													BgL_auxz00_21219
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_21257);
																																																												}
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_cdrzd227837zd2_2037;
																																																									BgL_cdrzd227837zd2_2037
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd227842zd2_2038;
																																																										BgL_cdrzd227842zd2_2038
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_carzd227725zd2_2027));
																																																										if ((CAR(((obj_t) BgL_carzd227725zd2_2027)) == CNST_TABLE_REF(((long) 1))))
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (PAIRP(BgL_cdrzd227842zd2_2038))
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd227847zd2_2042;
																																																														BgL_cdrzd227847zd2_2042
																																																															=
																																																															CDR
																																																															(BgL_cdrzd227842zd2_2038);
																																																														if (PAIRP(BgL_cdrzd227847zd2_2042))
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_carzd227851zd2_2044;
																																																																obj_t
																																																																	BgL_cdrzd227852zd2_2045;
																																																																BgL_carzd227851zd2_2044
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd227847zd2_2042);
																																																																BgL_cdrzd227852zd2_2045
																																																																	=
																																																																	CDR
																																																																	(BgL_cdrzd227847zd2_2042);
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd227851zd2_2044))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (PAIRP(BgL_cdrzd227852zd2_2045))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_carzd227857zd2_2048;
																																																																				BgL_carzd227857zd2_2048
																																																																					=
																																																																					CAR
																																																																					(BgL_cdrzd227852zd2_2045);
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd227857zd2_2048))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (NULLP(CDR(BgL_cdrzd227852zd2_2045)))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								bool_t
																																																																									BgL_test9204z00_21285;
																																																																								{
																																																																									obj_t
																																																																										BgL_l1414z00_2081;
																																																																									BgL_l1414z00_2081
																																																																										=
																																																																										BgL_cdrzd227837zd2_2037;
																																																																								BgL_zc3z04anonymousza31862ze3z87_2082:
																																																																									if (NULLP(BgL_l1414z00_2081))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											BgL_test9204z00_21285
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												1);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											bool_t
																																																																												BgL_test9206z00_21288;
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												bool_t
																																																																													BgL_test9207z00_21289;
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_tmpz00_21290;
																																																																													BgL_tmpz00_21290
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_l1414z00_2081));
																																																																													BgL_test9207z00_21289
																																																																														=
																																																																														PAIRP
																																																																														(BgL_tmpz00_21290);
																																																																												}
																																																																												if (BgL_test9207z00_21289)
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														BgL_test9206z00_21288
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															0);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														BgL_test9206z00_21288
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															1);
																																																																													}
																																																																											}
																																																																											if (BgL_test9206z00_21288)
																																																																												{
																																																																													obj_t
																																																																														BgL_l1414z00_21294;
																																																																													BgL_l1414z00_21294
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_l1414z00_2081));
																																																																													BgL_l1414z00_2081
																																																																														=
																																																																														BgL_l1414z00_21294;
																																																																													goto
																																																																														BgL_zc3z04anonymousza31862ze3z87_2082;
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													BgL_test9204z00_21285
																																																																														=
																																																																														(
																																																																														(bool_t)
																																																																														0);
																																																																												}
																																																																										}
																																																																								}
																																																																								if (BgL_test9204z00_21285)
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_arg1852z00_2064;
																																																																										BgL_arg1852z00_2064
																																																																											=
																																																																											CAR
																																																																											(BgL_cdrzd227842zd2_2038);
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_21298;
																																																																											{
																																																																												obj_t
																																																																													BgL_argsz00_21302;
																																																																												obj_t
																																																																													BgL_proc2z00_21301;
																																																																												obj_t
																																																																													BgL_proc1z00_21300;
																																																																												obj_t
																																																																													BgL_testz00_21299;
																																																																												BgL_testz00_21299
																																																																													=
																																																																													BgL_arg1852z00_2064;
																																																																												BgL_proc1z00_21300
																																																																													=
																																																																													BgL_carzd227851zd2_2044;
																																																																												BgL_proc2z00_21301
																																																																													=
																																																																													BgL_carzd227857zd2_2048;
																																																																												BgL_argsz00_21302
																																																																													=
																																																																													BgL_cdrzd227837zd2_2037;
																																																																												BgL_argsz00_1747
																																																																													=
																																																																													BgL_argsz00_21302;
																																																																												BgL_proc2z00_1746
																																																																													=
																																																																													BgL_proc2z00_21301;
																																																																												BgL_proc1z00_1745
																																																																													=
																																																																													BgL_proc1z00_21300;
																																																																												BgL_testz00_1744
																																																																													=
																																																																													BgL_testz00_21299;
																																																																												goto
																																																																													BgL_tagzd2387zd2_1748;
																																																																											}
																																																																											BgL_auxz00_21219
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_21298);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd227882zd2_2065;
																																																																										BgL_cdrzd227882zd2_2065
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd227890zd2_2066;
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_pairz00_11605;
																																																																												BgL_pairz00_11605
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												BgL_cdrzd227890zd2_2066
																																																																													=
																																																																													CDR
																																																																													(BgL_pairz00_11605);
																																																																											}
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_cdrzd227898zd2_2067;
																																																																												BgL_cdrzd227898zd2_2067
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd227890zd2_2066));
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_carzd227905zd2_2068;
																																																																													BgL_carzd227905zd2_2068
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd227898zd2_2067));
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd227905zd2_2068))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_carzd227914zd2_2070;
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_pairz00_11609;
																																																																																BgL_pairz00_11609
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd227898zd2_2067));
																																																																																BgL_carzd227914zd2_2070
																																																																																	=
																																																																																	CAR
																																																																																	(BgL_pairz00_11609);
																																																																															}
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd227914zd2_2070))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd227882zd2_2065))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_arg1856z00_2073;
																																																																																			BgL_arg1856z00_2073
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd227890zd2_2066));
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_21324;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_21328;
																																																																																					obj_t
																																																																																						BgL_proc2z00_21327;
																																																																																					obj_t
																																																																																						BgL_proc1z00_21326;
																																																																																					obj_t
																																																																																						BgL_testz00_21325;
																																																																																					BgL_testz00_21325
																																																																																						=
																																																																																						BgL_arg1856z00_2073;
																																																																																					BgL_proc1z00_21326
																																																																																						=
																																																																																						BgL_carzd227905zd2_2068;
																																																																																					BgL_proc2z00_21327
																																																																																						=
																																																																																						BgL_carzd227914zd2_2070;
																																																																																					BgL_argsz00_21328
																																																																																						=
																																																																																						BgL_cdrzd227882zd2_2065;
																																																																																					BgL_argsz00_1752
																																																																																						=
																																																																																						BgL_argsz00_21328;
																																																																																					BgL_proc2z00_1751
																																																																																						=
																																																																																						BgL_proc2z00_21327;
																																																																																					BgL_proc1z00_1750
																																																																																						=
																																																																																						BgL_proc1z00_21326;
																																																																																					BgL_testz00_1749
																																																																																						=
																																																																																						BgL_testz00_21325;
																																																																																					goto
																																																																																						BgL_tagzd2388zd2_1753;
																																																																																				}
																																																																																				BgL_auxz00_21219
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_21324);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1777;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_21332;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1778;
																																																																																					BgL_auxz00_21219
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_21332);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1777;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_21336;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1778;
																																																																																			BgL_auxz00_21219
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_21336);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1777;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_21340;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1778;
																																																																																	BgL_auxz00_21219
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_21340);
																																																																																}
																																																																														}
																																																																												}
																																																																											}
																																																																										}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1777;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_21344;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1778;
																																																																										BgL_auxz00_21219
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_21344);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd228192zd2_2092;
																																																																						BgL_cdrzd228192zd2_2092
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd228199zd2_2093;
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_pairz00_11613;
																																																																								BgL_pairz00_11613
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								BgL_cdrzd228199zd2_2093
																																																																									=
																																																																									CDR
																																																																									(BgL_pairz00_11613);
																																																																							}
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd228206zd2_2094;
																																																																								BgL_cdrzd228206zd2_2094
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd228199zd2_2093));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd228212zd2_2095;
																																																																									obj_t
																																																																										BgL_cdrzd228213zd2_2096;
																																																																									BgL_carzd228212zd2_2095
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd228206zd2_2094));
																																																																									BgL_cdrzd228213zd2_2096
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd228206zd2_2094));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd228212zd2_2095))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd228220zd2_2098;
																																																																											BgL_carzd228220zd2_2098
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd228213zd2_2096));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd228220zd2_2098))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (NULLP(CDR(((obj_t) BgL_cdrzd228213zd2_2096))))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd228192zd2_2092))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_arg1871z00_2103;
																																																																																	BgL_arg1871z00_2103
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd228199zd2_2093));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_21371;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_21375;
																																																																																			obj_t
																																																																																				BgL_proc2z00_21374;
																																																																																			obj_t
																																																																																				BgL_proc1z00_21373;
																																																																																			obj_t
																																																																																				BgL_testz00_21372;
																																																																																			BgL_testz00_21372
																																																																																				=
																																																																																				BgL_arg1871z00_2103;
																																																																																			BgL_proc1z00_21373
																																																																																				=
																																																																																				BgL_carzd228212zd2_2095;
																																																																																			BgL_proc2z00_21374
																																																																																				=
																																																																																				BgL_carzd228220zd2_2098;
																																																																																			BgL_argsz00_21375
																																																																																				=
																																																																																				BgL_cdrzd228192zd2_2092;
																																																																																			BgL_argsz00_1752
																																																																																				=
																																																																																				BgL_argsz00_21375;
																																																																																			BgL_proc2z00_1751
																																																																																				=
																																																																																				BgL_proc2z00_21374;
																																																																																			BgL_proc1z00_1750
																																																																																				=
																																																																																				BgL_proc1z00_21373;
																																																																																			BgL_testz00_1749
																																																																																				=
																																																																																				BgL_testz00_21372;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1753;
																																																																																		}
																																																																																		BgL_auxz00_21219
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_21371);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1777;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_21379;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1778;
																																																																																			BgL_auxz00_21219
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_21379);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1777;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_21383;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1778;
																																																																																	BgL_auxz00_21219
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_21383);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1777;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_21387;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1778;
																																																																															BgL_auxz00_21219
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_21387);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1777;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_21391;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1778;
																																																																													BgL_auxz00_21219
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_21391);
																																																																												}
																																																																										}
																																																																								}
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1777;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_21395;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1778;
																																																																						BgL_auxz00_21219
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_21395);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd228553zd2_2111;
																																																																		BgL_cdrzd228553zd2_2111
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd228559zd2_2112;
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_pairz00_11623;
																																																																				BgL_pairz00_11623
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				BgL_cdrzd228559zd2_2112
																																																																					=
																																																																					CDR
																																																																					(BgL_pairz00_11623);
																																																																			}
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd228565zd2_2113;
																																																																				BgL_cdrzd228565zd2_2113
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd228559zd2_2112));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_carzd228570zd2_2114;
																																																																					obj_t
																																																																						BgL_cdrzd228571zd2_2115;
																																																																					BgL_carzd228570zd2_2114
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd228565zd2_2113));
																																																																					BgL_cdrzd228571zd2_2115
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd228565zd2_2113));
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd228570zd2_2114))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (PAIRP(BgL_cdrzd228571zd2_2115))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd228576zd2_2118;
																																																																									BgL_carzd228576zd2_2118
																																																																										=
																																																																										CAR
																																																																										(BgL_cdrzd228571zd2_2115);
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd228576zd2_2118))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (NULLP(CDR(BgL_cdrzd228571zd2_2115)))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd228553zd2_2111))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg1885z00_2123;
																																																																															BgL_arg1885z00_2123
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd228559zd2_2112));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_21422;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_21426;
																																																																																	obj_t
																																																																																		BgL_proc2z00_21425;
																																																																																	obj_t
																																																																																		BgL_proc1z00_21424;
																																																																																	obj_t
																																																																																		BgL_testz00_21423;
																																																																																	BgL_testz00_21423
																																																																																		=
																																																																																		BgL_arg1885z00_2123;
																																																																																	BgL_proc1z00_21424
																																																																																		=
																																																																																		BgL_carzd228570zd2_2114;
																																																																																	BgL_proc2z00_21425
																																																																																		=
																																																																																		BgL_carzd228576zd2_2118;
																																																																																	BgL_argsz00_21426
																																																																																		=
																																																																																		BgL_cdrzd228553zd2_2111;
																																																																																	BgL_argsz00_1752
																																																																																		=
																																																																																		BgL_argsz00_21426;
																																																																																	BgL_proc2z00_1751
																																																																																		=
																																																																																		BgL_proc2z00_21425;
																																																																																	BgL_proc1z00_1750
																																																																																		=
																																																																																		BgL_proc1z00_21424;
																																																																																	BgL_testz00_1749
																																																																																		=
																																																																																		BgL_testz00_21423;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1753;
																																																																																}
																																																																																BgL_auxz00_21219
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_21422);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1777;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_21430;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1778;
																																																																																	BgL_auxz00_21219
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_21430);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1777;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_21434;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1778;
																																																																															BgL_auxz00_21219
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_21434);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1777;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_21438;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1778;
																																																																													BgL_auxz00_21219
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_21438);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1777;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_21442;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1778;
																																																																											BgL_auxz00_21219
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_21442);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1777;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_21446;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1778;
																																																																									BgL_auxz00_21219
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_21446);
																																																																								}
																																																																						}
																																																																				}
																																																																			}
																																																																		}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1777;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_21450;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1778;
																																																																		BgL_auxz00_21219
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_21450);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 119 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1777;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_21454;
																																																																goto
																																																																	BgL_tagzd2404zd2_1778;
																																																																BgL_auxz00_21219
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_21454);
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 119 */
																																																														goto
																																																															BgL_tagzd2403zd2_1777;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_21458;
																																																														goto
																																																															BgL_tagzd2404zd2_1778;
																																																														BgL_auxz00_21219
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_21458);
																																																													}
																																																											}
																																																									}
																																																								}
																																																						}
																																																					}
																																																			}
																																																		return
																																																			(
																																																			(BgL_nodez00_bglt)
																																																			BgL_auxz00_21219);
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		bool_t
																																																			BgL_test9237z00_21461;
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg1821z00_2020;
																																																			BgL_arg1821z00_2020
																																																				=
																																																				CAR
																																																				(BgL_expz00_21);
																																																			BgL_test9237z00_21461
																																																				=
																																																				CBOOL
																																																				(BGl_labelszd2symzf3z21zzast_labelsz00
																																																				(BgL_arg1821z00_2020));
																																																		}
																																																		if (BgL_test9237z00_21461)
																																																			{
																																																				BgL_letzd2funzd2_bglt
																																																					BgL_auxz00_21465;
																																																				goto
																																																					BgL_tagzd2384zd2_1735;
																																																				return
																																																					(
																																																					(BgL_nodez00_bglt)
																																																					BgL_auxz00_21465);
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_carzd229139zd2_1848;
																																																				obj_t
																																																					BgL_cdrzd229140zd2_1849;
																																																				BgL_carzd229139zd2_1848
																																																					=
																																																					CAR
																																																					(BgL_expz00_21);
																																																				BgL_cdrzd229140zd2_1849
																																																					=
																																																					CDR
																																																					(BgL_expz00_21);
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_cdrzd229144zd2_1850;
																																																					BgL_cdrzd229144zd2_1850
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_carzd229139zd2_1848));
																																																					if ((CAR(((obj_t) BgL_carzd229139zd2_1848)) == CNST_TABLE_REF(((long) 3))))
																																																						{	/* Ast/sexp.scm 119 */
																																																							if (PAIRP(BgL_cdrzd229144zd2_1850))
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_carzd229147zd2_1854;
																																																									obj_t
																																																										BgL_cdrzd229148zd2_1855;
																																																									BgL_carzd229147zd2_1854
																																																										=
																																																										CAR
																																																										(BgL_cdrzd229144zd2_1850);
																																																									BgL_cdrzd229148zd2_1855
																																																										=
																																																										CDR
																																																										(BgL_cdrzd229144zd2_1850);
																																																									if (PAIRP(BgL_carzd229147zd2_1854))
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (NULLP(CDR(BgL_carzd229147zd2_1854)))
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (PAIRP(BgL_cdrzd229148zd2_1855))
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_carzd229154zd2_1860;
																																																															BgL_carzd229154zd2_1860
																																																																=
																																																																CAR
																																																																(BgL_cdrzd229148zd2_1855);
																																																															if (PAIRP(BgL_carzd229154zd2_1860))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (BGl_castzd2sexpzf3z21zzast_privatez00(BgL_carzd229154zd2_1860))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (NULLP(CDR(BgL_cdrzd229148zd2_1855)))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (PAIRP(BgL_cdrzd229140zd2_1849))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd229161zd2_1866;
																																																																							BgL_carzd229161zd2_1866
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd229140zd2_1849);
																																																																							if (PAIRP(BgL_carzd229161zd2_1866))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd229185zd2_1868;
																																																																									BgL_cdrzd229185zd2_1868
																																																																										=
																																																																										CDR
																																																																										(CAR
																																																																										(BgL_expz00_21));
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_arg1658z00_1869;
																																																																										obj_t
																																																																											BgL_arg1659z00_1870;
																																																																										obj_t
																																																																											BgL_arg1660z00_1871;
																																																																										BgL_arg1658z00_1869
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd229185zd2_1868));
																																																																										BgL_arg1659z00_1870
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd229185zd2_1868));
																																																																										BgL_arg1660z00_1871
																																																																											=
																																																																											CDR
																																																																											(BgL_expz00_21);
																																																																										{
																																																																											obj_t
																																																																												BgL_argsz00_21509;
																																																																											obj_t
																																																																												BgL_bodyz00_21508;
																																																																											obj_t
																																																																												BgL_varsz00_21507;
																																																																											BgL_varsz00_21507
																																																																												=
																																																																												BgL_arg1658z00_1869;
																																																																											BgL_bodyz00_21508
																																																																												=
																																																																												BgL_arg1659z00_1870;
																																																																											BgL_argsz00_21509
																																																																												=
																																																																												BgL_arg1660z00_1871;
																																																																											BgL_argsz00_1742
																																																																												=
																																																																												BgL_argsz00_21509;
																																																																											BgL_bodyz00_1741
																																																																												=
																																																																												BgL_bodyz00_21508;
																																																																											BgL_varsz00_1740
																																																																												=
																																																																												BgL_varsz00_21507;
																																																																											goto
																																																																												BgL_tagzd2386zd2_1743;
																																																																										}
																																																																									}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (NULLP(CDR(BgL_cdrzd229140zd2_1849)))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_arg1666z00_1875;
																																																																											BgL_arg1666z00_1875
																																																																												=
																																																																												CAR
																																																																												(BgL_carzd229147zd2_1854);
																																																																											{
																																																																												BgL_castz00_bglt
																																																																													BgL_auxz00_21514;
																																																																												{
																																																																													obj_t
																																																																														BgL_argz00_21517;
																																																																													obj_t
																																																																														BgL_bodyz00_21516;
																																																																													obj_t
																																																																														BgL_varz00_21515;
																																																																													BgL_varz00_21515
																																																																														=
																																																																														BgL_arg1666z00_1875;
																																																																													BgL_bodyz00_21516
																																																																														=
																																																																														BgL_carzd229154zd2_1860;
																																																																													BgL_argz00_21517
																																																																														=
																																																																														BgL_carzd229161zd2_1866;
																																																																													BgL_argz00_1738
																																																																														=
																																																																														BgL_argz00_21517;
																																																																													BgL_bodyz00_1737
																																																																														=
																																																																														BgL_bodyz00_21516;
																																																																													BgL_varz00_1736
																																																																														=
																																																																														BgL_varz00_21515;
																																																																													goto
																																																																														BgL_tagzd2385zd2_1739;
																																																																												}
																																																																												return
																																																																													(
																																																																													(BgL_nodez00_bglt)
																																																																													BgL_auxz00_21514);
																																																																											}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd229212zd2_1876;
																																																																											BgL_cdrzd229212zd2_1876
																																																																												=
																																																																												CDR
																																																																												(CAR
																																																																												(BgL_expz00_21));
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_arg1668z00_1877;
																																																																												obj_t
																																																																													BgL_arg1669z00_1878;
																																																																												obj_t
																																																																													BgL_arg1671z00_1879;
																																																																												BgL_arg1668z00_1877
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd229212zd2_1876));
																																																																												BgL_arg1669z00_1878
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd229212zd2_1876));
																																																																												BgL_arg1671z00_1879
																																																																													=
																																																																													CDR
																																																																													(BgL_expz00_21);
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_21528;
																																																																													obj_t
																																																																														BgL_bodyz00_21527;
																																																																													obj_t
																																																																														BgL_varsz00_21526;
																																																																													BgL_varsz00_21526
																																																																														=
																																																																														BgL_arg1668z00_1877;
																																																																													BgL_bodyz00_21527
																																																																														=
																																																																														BgL_arg1669z00_1878;
																																																																													BgL_argsz00_21528
																																																																														=
																																																																														BgL_arg1671z00_1879;
																																																																													BgL_argsz00_1742
																																																																														=
																																																																														BgL_argsz00_21528;
																																																																													BgL_bodyz00_1741
																																																																														=
																																																																														BgL_bodyz00_21527;
																																																																													BgL_varsz00_1740
																																																																														=
																																																																														BgL_varsz00_21526;
																																																																													goto
																																																																														BgL_tagzd2386zd2_1743;
																																																																												}
																																																																											}
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd229238zd2_1882;
																																																																							BgL_cdrzd229238zd2_1882
																																																																								=
																																																																								CDR
																																																																								(CAR
																																																																								(BgL_expz00_21));
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_arg1677z00_1883;
																																																																								obj_t
																																																																									BgL_arg1679z00_1884;
																																																																								obj_t
																																																																									BgL_arg1680z00_1885;
																																																																								BgL_arg1677z00_1883
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd229238zd2_1882));
																																																																								BgL_arg1679z00_1884
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd229238zd2_1882));
																																																																								BgL_arg1680z00_1885
																																																																									=
																																																																									CDR
																																																																									(BgL_expz00_21);
																																																																								{
																																																																									obj_t
																																																																										BgL_argsz00_21538;
																																																																									obj_t
																																																																										BgL_bodyz00_21537;
																																																																									obj_t
																																																																										BgL_varsz00_21536;
																																																																									BgL_varsz00_21536
																																																																										=
																																																																										BgL_arg1677z00_1883;
																																																																									BgL_bodyz00_21537
																																																																										=
																																																																										BgL_arg1679z00_1884;
																																																																									BgL_argsz00_21538
																																																																										=
																																																																										BgL_arg1680z00_1885;
																																																																									BgL_argsz00_1742
																																																																										=
																																																																										BgL_argsz00_21538;
																																																																									BgL_bodyz00_1741
																																																																										=
																																																																										BgL_bodyz00_21537;
																																																																									BgL_varsz00_1740
																																																																										=
																																																																										BgL_varsz00_21536;
																																																																									goto
																																																																										BgL_tagzd2386zd2_1743;
																																																																								}
																																																																							}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd229264zd2_1887;
																																																																					BgL_cdrzd229264zd2_1887
																																																																						=
																																																																						CDR
																																																																						(CAR
																																																																						(BgL_expz00_21));
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_arg1682z00_1888;
																																																																						obj_t
																																																																							BgL_arg1689z00_1889;
																																																																						obj_t
																																																																							BgL_arg1692z00_1890;
																																																																						BgL_arg1682z00_1888
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd229264zd2_1887));
																																																																						BgL_arg1689z00_1889
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd229264zd2_1887));
																																																																						BgL_arg1692z00_1890
																																																																							=
																																																																							CDR
																																																																							(BgL_expz00_21);
																																																																						{
																																																																							obj_t
																																																																								BgL_argsz00_21548;
																																																																							obj_t
																																																																								BgL_bodyz00_21547;
																																																																							obj_t
																																																																								BgL_varsz00_21546;
																																																																							BgL_varsz00_21546
																																																																								=
																																																																								BgL_arg1682z00_1888;
																																																																							BgL_bodyz00_21547
																																																																								=
																																																																								BgL_arg1689z00_1889;
																																																																							BgL_argsz00_21548
																																																																								=
																																																																								BgL_arg1692z00_1890;
																																																																							BgL_argsz00_1742
																																																																								=
																																																																								BgL_argsz00_21548;
																																																																							BgL_bodyz00_1741
																																																																								=
																																																																								BgL_bodyz00_21547;
																																																																							BgL_varsz00_1740
																																																																								=
																																																																								BgL_varsz00_21546;
																																																																							goto
																																																																								BgL_tagzd2386zd2_1743;
																																																																						}
																																																																					}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd229290zd2_1893;
																																																																			BgL_cdrzd229290zd2_1893
																																																																				=
																																																																				CDR
																																																																				(CAR
																																																																				(BgL_expz00_21));
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_arg1695z00_1894;
																																																																				obj_t
																																																																					BgL_arg1696z00_1895;
																																																																				obj_t
																																																																					BgL_arg1702z00_1896;
																																																																				BgL_arg1695z00_1894
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd229290zd2_1893));
																																																																				BgL_arg1696z00_1895
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd229290zd2_1893));
																																																																				BgL_arg1702z00_1896
																																																																					=
																																																																					CDR
																																																																					(BgL_expz00_21);
																																																																				{
																																																																					obj_t
																																																																						BgL_argsz00_21558;
																																																																					obj_t
																																																																						BgL_bodyz00_21557;
																																																																					obj_t
																																																																						BgL_varsz00_21556;
																																																																					BgL_varsz00_21556
																																																																						=
																																																																						BgL_arg1695z00_1894;
																																																																					BgL_bodyz00_21557
																																																																						=
																																																																						BgL_arg1696z00_1895;
																																																																					BgL_argsz00_21558
																																																																						=
																																																																						BgL_arg1702z00_1896;
																																																																					BgL_argsz00_1742
																																																																						=
																																																																						BgL_argsz00_21558;
																																																																					BgL_bodyz00_1741
																																																																						=
																																																																						BgL_bodyz00_21557;
																																																																					BgL_varsz00_1740
																																																																						=
																																																																						BgL_varsz00_21556;
																																																																					goto
																																																																						BgL_tagzd2386zd2_1743;
																																																																				}
																																																																			}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd229316zd2_1898;
																																																																	BgL_cdrzd229316zd2_1898
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_carzd229139zd2_1848));
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_arg1705z00_1899;
																																																																		obj_t
																																																																			BgL_arg1706z00_1900;
																																																																		obj_t
																																																																			BgL_arg1708z00_1901;
																																																																		BgL_arg1705z00_1899
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd229316zd2_1898));
																																																																		BgL_arg1706z00_1900
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd229316zd2_1898));
																																																																		BgL_arg1708z00_1901
																																																																			=
																																																																			CDR
																																																																			(BgL_expz00_21);
																																																																		{
																																																																			obj_t
																																																																				BgL_argsz00_21568;
																																																																			obj_t
																																																																				BgL_bodyz00_21567;
																																																																			obj_t
																																																																				BgL_varsz00_21566;
																																																																			BgL_varsz00_21566
																																																																				=
																																																																				BgL_arg1705z00_1899;
																																																																			BgL_bodyz00_21567
																																																																				=
																																																																				BgL_arg1706z00_1900;
																																																																			BgL_argsz00_21568
																																																																				=
																																																																				BgL_arg1708z00_1901;
																																																																			BgL_argsz00_1742
																																																																				=
																																																																				BgL_argsz00_21568;
																																																																			BgL_bodyz00_1741
																																																																				=
																																																																				BgL_bodyz00_21567;
																																																																			BgL_varsz00_1740
																																																																				=
																																																																				BgL_varsz00_21566;
																																																																			goto
																																																																				BgL_tagzd2386zd2_1743;
																																																																		}
																																																																	}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd229342zd2_1903;
																																																															BgL_cdrzd229342zd2_1903
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_carzd229139zd2_1848));
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_arg1715z00_1904;
																																																																obj_t
																																																																	BgL_arg1716z00_1905;
																																																																obj_t
																																																																	BgL_arg1719z00_1906;
																																																																BgL_arg1715z00_1904
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd229342zd2_1903));
																																																																BgL_arg1716z00_1905
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd229342zd2_1903));
																																																																BgL_arg1719z00_1906
																																																																	=
																																																																	CDR
																																																																	(BgL_expz00_21);
																																																																{
																																																																	obj_t
																																																																		BgL_argsz00_21578;
																																																																	obj_t
																																																																		BgL_bodyz00_21577;
																																																																	obj_t
																																																																		BgL_varsz00_21576;
																																																																	BgL_varsz00_21576
																																																																		=
																																																																		BgL_arg1715z00_1904;
																																																																	BgL_bodyz00_21577
																																																																		=
																																																																		BgL_arg1716z00_1905;
																																																																	BgL_argsz00_21578
																																																																		=
																																																																		BgL_arg1719z00_1906;
																																																																	BgL_argsz00_1742
																																																																		=
																																																																		BgL_argsz00_21578;
																																																																	BgL_bodyz00_1741
																																																																		=
																																																																		BgL_bodyz00_21577;
																																																																	BgL_varsz00_1740
																																																																		=
																																																																		BgL_varsz00_21576;
																																																																	goto
																																																																		BgL_tagzd2386zd2_1743;
																																																																}
																																																															}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd229368zd2_1908;
																																																													BgL_cdrzd229368zd2_1908
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_carzd229139zd2_1848));
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_arg1737z00_1909;
																																																														obj_t
																																																															BgL_arg1738z00_1910;
																																																														obj_t
																																																															BgL_arg1749z00_1911;
																																																														BgL_arg1737z00_1909
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd229368zd2_1908));
																																																														BgL_arg1738z00_1910
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd229368zd2_1908));
																																																														BgL_arg1749z00_1911
																																																															=
																																																															CDR
																																																															(BgL_expz00_21);
																																																														{
																																																															obj_t
																																																																BgL_argsz00_21588;
																																																															obj_t
																																																																BgL_bodyz00_21587;
																																																															obj_t
																																																																BgL_varsz00_21586;
																																																															BgL_varsz00_21586
																																																																=
																																																																BgL_arg1737z00_1909;
																																																															BgL_bodyz00_21587
																																																																=
																																																																BgL_arg1738z00_1910;
																																																															BgL_argsz00_21588
																																																																=
																																																																BgL_arg1749z00_1911;
																																																															BgL_argsz00_1742
																																																																=
																																																																BgL_argsz00_21588;
																																																															BgL_bodyz00_1741
																																																																=
																																																																BgL_bodyz00_21587;
																																																															BgL_varsz00_1740
																																																																=
																																																																BgL_varsz00_21586;
																																																															goto
																																																																BgL_tagzd2386zd2_1743;
																																																														}
																																																													}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_cdrzd229394zd2_1914;
																																																											BgL_cdrzd229394zd2_1914
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_carzd229139zd2_1848));
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_arg1752z00_1915;
																																																												obj_t
																																																													BgL_arg1753z00_1916;
																																																												obj_t
																																																													BgL_arg1754z00_1917;
																																																												BgL_arg1752z00_1915
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd229394zd2_1914));
																																																												BgL_arg1753z00_1916
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd229394zd2_1914));
																																																												BgL_arg1754z00_1917
																																																													=
																																																													CDR
																																																													(BgL_expz00_21);
																																																												{
																																																													obj_t
																																																														BgL_argsz00_21598;
																																																													obj_t
																																																														BgL_bodyz00_21597;
																																																													obj_t
																																																														BgL_varsz00_21596;
																																																													BgL_varsz00_21596
																																																														=
																																																														BgL_arg1752z00_1915;
																																																													BgL_bodyz00_21597
																																																														=
																																																														BgL_arg1753z00_1916;
																																																													BgL_argsz00_21598
																																																														=
																																																														BgL_arg1754z00_1917;
																																																													BgL_argsz00_1742
																																																														=
																																																														BgL_argsz00_21598;
																																																													BgL_bodyz00_1741
																																																														=
																																																														BgL_bodyz00_21597;
																																																													BgL_varsz00_1740
																																																														=
																																																														BgL_varsz00_21596;
																																																													goto
																																																														BgL_tagzd2386zd2_1743;
																																																												}
																																																											}
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																										{
																																																											obj_t
																																																												BgL_auxz00_21601;
																																																											goto
																																																												BgL_tagzd2403zd2_1777;
																																																											return
																																																												(
																																																												(BgL_nodez00_bglt)
																																																												BgL_auxz00_21601);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											goto
																																																												BgL_tagzd2404zd2_1778;
																																																										}
																																																								}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_cdrzd229532zd2_1922;
																																																							BgL_cdrzd229532zd2_1922
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_carzd229139zd2_1848));
																																																							if ((CAR(((obj_t) BgL_carzd229139zd2_1848)) == CNST_TABLE_REF(((long) 1))))
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (PAIRP(BgL_cdrzd229532zd2_1922))
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_cdrzd229537zd2_1926;
																																																											BgL_cdrzd229537zd2_1926
																																																												=
																																																												CDR
																																																												(BgL_cdrzd229532zd2_1922);
																																																											if (PAIRP(BgL_cdrzd229537zd2_1926))
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_carzd229541zd2_1928;
																																																													obj_t
																																																														BgL_cdrzd229542zd2_1929;
																																																													BgL_carzd229541zd2_1928
																																																														=
																																																														CAR
																																																														(BgL_cdrzd229537zd2_1926);
																																																													BgL_cdrzd229542zd2_1929
																																																														=
																																																														CDR
																																																														(BgL_cdrzd229537zd2_1926);
																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd229541zd2_1928))
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (PAIRP(BgL_cdrzd229542zd2_1929))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_carzd229547zd2_1932;
																																																																	BgL_carzd229547zd2_1932
																																																																		=
																																																																		CAR
																																																																		(BgL_cdrzd229542zd2_1929);
																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd229547zd2_1932))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (NULLP(CDR(BgL_cdrzd229542zd2_1929)))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					bool_t
																																																																						BgL_test9257z00_21627;
																																																																					{
																																																																						obj_t
																																																																							BgL_l1417z00_1965;
																																																																						BgL_l1417z00_1965
																																																																							=
																																																																							BgL_cdrzd229140zd2_1849;
																																																																					BgL_zc3z04anonymousza31783ze3z87_1966:
																																																																						if (NULLP(BgL_l1417z00_1965))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								BgL_test9257z00_21627
																																																																									=
																																																																									(
																																																																									(bool_t)
																																																																									1);
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								bool_t
																																																																									BgL_test9259z00_21630;
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									bool_t
																																																																										BgL_test9260z00_21631;
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_tmpz00_21632;
																																																																										BgL_tmpz00_21632
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_l1417z00_1965));
																																																																										BgL_test9260z00_21631
																																																																											=
																																																																											PAIRP
																																																																											(BgL_tmpz00_21632);
																																																																									}
																																																																									if (BgL_test9260z00_21631)
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											BgL_test9259z00_21630
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												0);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											BgL_test9259z00_21630
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												1);
																																																																										}
																																																																								}
																																																																								if (BgL_test9259z00_21630)
																																																																									{
																																																																										obj_t
																																																																											BgL_l1417z00_21636;
																																																																										BgL_l1417z00_21636
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_l1417z00_1965));
																																																																										BgL_l1417z00_1965
																																																																											=
																																																																											BgL_l1417z00_21636;
																																																																										goto
																																																																											BgL_zc3z04anonymousza31783ze3z87_1966;
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										BgL_test9257z00_21627
																																																																											=
																																																																											(
																																																																											(bool_t)
																																																																											0);
																																																																									}
																																																																							}
																																																																					}
																																																																					if (BgL_test9257z00_21627)
																																																																						{
																																																																							obj_t
																																																																								BgL_argsz00_21643;
																																																																							obj_t
																																																																								BgL_proc2z00_21642;
																																																																							obj_t
																																																																								BgL_proc1z00_21641;
																																																																							obj_t
																																																																								BgL_testz00_21639;
																																																																							BgL_testz00_21639
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd229532zd2_1922);
																																																																							BgL_proc1z00_21641
																																																																								=
																																																																								BgL_carzd229541zd2_1928;
																																																																							BgL_proc2z00_21642
																																																																								=
																																																																								BgL_carzd229547zd2_1932;
																																																																							BgL_argsz00_21643
																																																																								=
																																																																								BgL_cdrzd229140zd2_1849;
																																																																							BgL_argsz00_1747
																																																																								=
																																																																								BgL_argsz00_21643;
																																																																							BgL_proc2z00_1746
																																																																								=
																																																																								BgL_proc2z00_21642;
																																																																							BgL_proc1z00_1745
																																																																								=
																																																																								BgL_proc1z00_21641;
																																																																							BgL_testz00_1744
																																																																								=
																																																																								BgL_testz00_21639;
																																																																							goto
																																																																								BgL_tagzd2387zd2_1748;
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd229572zd2_1949;
																																																																							BgL_cdrzd229572zd2_1949
																																																																								=
																																																																								CDR
																																																																								(BgL_expz00_21);
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd229580zd2_1950;
																																																																								BgL_cdrzd229580zd2_1950
																																																																									=
																																																																									CDR
																																																																									(CAR
																																																																									(BgL_expz00_21));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd229588zd2_1951;
																																																																									BgL_cdrzd229588zd2_1951
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd229580zd2_1950));
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_carzd229595zd2_1952;
																																																																										BgL_carzd229595zd2_1952
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd229588zd2_1951));
																																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd229595zd2_1952))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_carzd229604zd2_1954;
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_pairz00_11724;
																																																																													BgL_pairz00_11724
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd229588zd2_1951));
																																																																													BgL_carzd229604zd2_1954
																																																																														=
																																																																														CAR
																																																																														(BgL_pairz00_11724);
																																																																												}
																																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd229604zd2_1954))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd229572zd2_1949))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_arg1775z00_1957;
																																																																																BgL_arg1775z00_1957
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd229580zd2_1950));
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_21665;
																																																																																	obj_t
																																																																																		BgL_proc2z00_21664;
																																																																																	obj_t
																																																																																		BgL_proc1z00_21663;
																																																																																	obj_t
																																																																																		BgL_testz00_21662;
																																																																																	BgL_testz00_21662
																																																																																		=
																																																																																		BgL_arg1775z00_1957;
																																																																																	BgL_proc1z00_21663
																																																																																		=
																																																																																		BgL_carzd229595zd2_1952;
																																																																																	BgL_proc2z00_21664
																																																																																		=
																																																																																		BgL_carzd229604zd2_1954;
																																																																																	BgL_argsz00_21665
																																																																																		=
																																																																																		BgL_cdrzd229572zd2_1949;
																																																																																	BgL_argsz00_1752
																																																																																		=
																																																																																		BgL_argsz00_21665;
																																																																																	BgL_proc2z00_1751
																																																																																		=
																																																																																		BgL_proc2z00_21664;
																																																																																	BgL_proc1z00_1750
																																																																																		=
																																																																																		BgL_proc1z00_21663;
																																																																																	BgL_testz00_1749
																																																																																		=
																																																																																		BgL_testz00_21662;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1753;
																																																																																}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{
																																																																																		obj_t
																																																																																			BgL_auxz00_21668;
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1777;
																																																																																		return
																																																																																			(
																																																																																			(BgL_nodez00_bglt)
																																																																																			BgL_auxz00_21668);
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1778;
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{
																																																																																obj_t
																																																																																	BgL_auxz00_21672;
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1777;
																																																																																return
																																																																																	(
																																																																																	(BgL_nodez00_bglt)
																																																																																	BgL_auxz00_21672);
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1778;
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{
																																																																														obj_t
																																																																															BgL_auxz00_21676;
																																																																														goto
																																																																															BgL_tagzd2403zd2_1777;
																																																																														return
																																																																															(
																																																																															(BgL_nodez00_bglt)
																																																																															BgL_auxz00_21676);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2404zd2_1778;
																																																																													}
																																																																											}
																																																																									}
																																																																								}
																																																																							}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{
																																																																							obj_t
																																																																								BgL_auxz00_21680;
																																																																							goto
																																																																								BgL_tagzd2403zd2_1777;
																																																																							return
																																																																								(
																																																																								(BgL_nodez00_bglt)
																																																																								BgL_auxz00_21680);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2404zd2_1778;
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd229882zd2_1976;
																																																																			BgL_cdrzd229882zd2_1976
																																																																				=
																																																																				CDR
																																																																				(BgL_expz00_21);
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd229889zd2_1977;
																																																																				BgL_cdrzd229889zd2_1977
																																																																					=
																																																																					CDR
																																																																					(CAR
																																																																					(BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd229896zd2_1978;
																																																																					BgL_cdrzd229896zd2_1978
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd229889zd2_1977));
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_carzd229902zd2_1979;
																																																																						obj_t
																																																																							BgL_cdrzd229903zd2_1980;
																																																																						BgL_carzd229902zd2_1979
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd229896zd2_1978));
																																																																						BgL_cdrzd229903zd2_1980
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd229896zd2_1978));
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd229902zd2_1979))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_carzd229910zd2_1982;
																																																																								BgL_carzd229910zd2_1982
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd229903zd2_1980));
																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd229910zd2_1982))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (NULLP(CDR(((obj_t) BgL_cdrzd229903zd2_1980))))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd229882zd2_1976))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_arg1792z00_1987;
																																																																														BgL_arg1792z00_1987
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd229889zd2_1977));
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_21708;
																																																																															obj_t
																																																																																BgL_proc2z00_21707;
																																																																															obj_t
																																																																																BgL_proc1z00_21706;
																																																																															obj_t
																																																																																BgL_testz00_21705;
																																																																															BgL_testz00_21705
																																																																																=
																																																																																BgL_arg1792z00_1987;
																																																																															BgL_proc1z00_21706
																																																																																=
																																																																																BgL_carzd229902zd2_1979;
																																																																															BgL_proc2z00_21707
																																																																																=
																																																																																BgL_carzd229910zd2_1982;
																																																																															BgL_argsz00_21708
																																																																																=
																																																																																BgL_cdrzd229882zd2_1976;
																																																																															BgL_argsz00_1752
																																																																																=
																																																																																BgL_argsz00_21708;
																																																																															BgL_proc2z00_1751
																																																																																=
																																																																																BgL_proc2z00_21707;
																																																																															BgL_proc1z00_1750
																																																																																=
																																																																																BgL_proc1z00_21706;
																																																																															BgL_testz00_1749
																																																																																=
																																																																																BgL_testz00_21705;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1753;
																																																																														}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{
																																																																																obj_t
																																																																																	BgL_auxz00_21711;
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1777;
																																																																																return
																																																																																	(
																																																																																	(BgL_nodez00_bglt)
																																																																																	BgL_auxz00_21711);
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1778;
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{
																																																																														obj_t
																																																																															BgL_auxz00_21715;
																																																																														goto
																																																																															BgL_tagzd2403zd2_1777;
																																																																														return
																																																																															(
																																																																															(BgL_nodez00_bglt)
																																																																															BgL_auxz00_21715);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2404zd2_1778;
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{
																																																																												obj_t
																																																																													BgL_auxz00_21719;
																																																																												goto
																																																																													BgL_tagzd2403zd2_1777;
																																																																												return
																																																																													(
																																																																													(BgL_nodez00_bglt)
																																																																													BgL_auxz00_21719);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2404zd2_1778;
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{
																																																																										obj_t
																																																																											BgL_auxz00_21723;
																																																																										goto
																																																																											BgL_tagzd2403zd2_1777;
																																																																										return
																																																																											(
																																																																											(BgL_nodez00_bglt)
																																																																											BgL_auxz00_21723);
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2404zd2_1778;
																																																																									}
																																																																							}
																																																																					}
																																																																				}
																																																																			}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{
																																																																			obj_t
																																																																				BgL_auxz00_21727;
																																																																			goto
																																																																				BgL_tagzd2403zd2_1777;
																																																																			return
																																																																				(
																																																																				(BgL_nodez00_bglt)
																																																																				BgL_auxz00_21727);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			goto
																																																																				BgL_tagzd2404zd2_1778;
																																																																		}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd230243zd2_1995;
																																																															BgL_cdrzd230243zd2_1995
																																																																=
																																																																CDR
																																																																(BgL_expz00_21);
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd230249zd2_1996;
																																																																BgL_cdrzd230249zd2_1996
																																																																	=
																																																																	CDR
																																																																	(CAR
																																																																	(BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd230255zd2_1997;
																																																																	BgL_cdrzd230255zd2_1997
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd230249zd2_1996));
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_carzd230260zd2_1998;
																																																																		obj_t
																																																																			BgL_cdrzd230261zd2_1999;
																																																																		BgL_carzd230260zd2_1998
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd230255zd2_1997));
																																																																		BgL_cdrzd230261zd2_1999
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd230255zd2_1997));
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd230260zd2_1998))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (PAIRP(BgL_cdrzd230261zd2_1999))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_carzd230266zd2_2002;
																																																																						BgL_carzd230266zd2_2002
																																																																							=
																																																																							CAR
																																																																							(BgL_cdrzd230261zd2_1999);
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd230266zd2_2002))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (NULLP(CDR(BgL_cdrzd230261zd2_1999)))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd230243zd2_1995))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_arg1808z00_2007;
																																																																												BgL_arg1808z00_2007
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd230249zd2_1996));
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_21755;
																																																																													obj_t
																																																																														BgL_proc2z00_21754;
																																																																													obj_t
																																																																														BgL_proc1z00_21753;
																																																																													obj_t
																																																																														BgL_testz00_21752;
																																																																													BgL_testz00_21752
																																																																														=
																																																																														BgL_arg1808z00_2007;
																																																																													BgL_proc1z00_21753
																																																																														=
																																																																														BgL_carzd230260zd2_1998;
																																																																													BgL_proc2z00_21754
																																																																														=
																																																																														BgL_carzd230266zd2_2002;
																																																																													BgL_argsz00_21755
																																																																														=
																																																																														BgL_cdrzd230243zd2_1995;
																																																																													BgL_argsz00_1752
																																																																														=
																																																																														BgL_argsz00_21755;
																																																																													BgL_proc2z00_1751
																																																																														=
																																																																														BgL_proc2z00_21754;
																																																																													BgL_proc1z00_1750
																																																																														=
																																																																														BgL_proc1z00_21753;
																																																																													BgL_testz00_1749
																																																																														=
																																																																														BgL_testz00_21752;
																																																																													goto
																																																																														BgL_tagzd2388zd2_1753;
																																																																												}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{
																																																																														obj_t
																																																																															BgL_auxz00_21758;
																																																																														goto
																																																																															BgL_tagzd2403zd2_1777;
																																																																														return
																																																																															(
																																																																															(BgL_nodez00_bglt)
																																																																															BgL_auxz00_21758);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2404zd2_1778;
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{
																																																																												obj_t
																																																																													BgL_auxz00_21762;
																																																																												goto
																																																																													BgL_tagzd2403zd2_1777;
																																																																												return
																																																																													(
																																																																													(BgL_nodez00_bglt)
																																																																													BgL_auxz00_21762);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2404zd2_1778;
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{
																																																																										obj_t
																																																																											BgL_auxz00_21766;
																																																																										goto
																																																																											BgL_tagzd2403zd2_1777;
																																																																										return
																																																																											(
																																																																											(BgL_nodez00_bglt)
																																																																											BgL_auxz00_21766);
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2404zd2_1778;
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{
																																																																								obj_t
																																																																									BgL_auxz00_21770;
																																																																								goto
																																																																									BgL_tagzd2403zd2_1777;
																																																																								return
																																																																									(
																																																																									(BgL_nodez00_bglt)
																																																																									BgL_auxz00_21770);
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2404zd2_1778;
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{
																																																																						obj_t
																																																																							BgL_auxz00_21774;
																																																																						goto
																																																																							BgL_tagzd2403zd2_1777;
																																																																						return
																																																																							(
																																																																							(BgL_nodez00_bglt)
																																																																							BgL_auxz00_21774);
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2404zd2_1778;
																																																																					}
																																																																			}
																																																																	}
																																																																}
																																																															}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{
																																																															obj_t
																																																																BgL_auxz00_21778;
																																																															goto
																																																																BgL_tagzd2403zd2_1777;
																																																															return
																																																																(
																																																																(BgL_nodez00_bglt)
																																																																BgL_auxz00_21778);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															goto
																																																																BgL_tagzd2404zd2_1778;
																																																														}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{
																																																													obj_t
																																																														BgL_auxz00_21782;
																																																													goto
																																																														BgL_tagzd2403zd2_1777;
																																																													return
																																																														(
																																																														(BgL_nodez00_bglt)
																																																														BgL_auxz00_21782);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													goto
																																																														BgL_tagzd2404zd2_1778;
																																																												}
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																										{
																																																											obj_t
																																																												BgL_auxz00_21786;
																																																											goto
																																																												BgL_tagzd2403zd2_1777;
																																																											return
																																																												(
																																																												(BgL_nodez00_bglt)
																																																												BgL_auxz00_21786);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											goto
																																																												BgL_tagzd2404zd2_1778;
																																																										}
																																																								}
																																																						}
																																																				}
																																																			}
																																																	}
																																															}
																																														}
																																													}
																																											}
																																									}
																																							}
																																					}
																																			}
																																		}
																																	else
																																		{

																																			if (
																																				(BgL_carzd224574zd2_1832
																																					==
																																					CNST_TABLE_REF
																																					(((long) 17))))
																																				{
																																					obj_t
																																						BgL_auxz00_21791;
																																				BgL_kapzd230804zd2_2415:
																																					if (PAIRP(BgL_cdrzd224445zd2_1814))
																																						{	/* Ast/sexp.scm 119 */
																																							obj_t
																																								BgL_arg2176z00_2512;
																																							obj_t
																																								BgL_arg2177z00_2513;
																																							BgL_arg2176z00_2512
																																								=
																																								CAR
																																								(BgL_cdrzd224445zd2_1814);
																																							BgL_arg2177z00_2513
																																								=
																																								CDR
																																								(BgL_cdrzd224445zd2_1814);
																																							{
																																								BgL_nodez00_bglt
																																									BgL_auxz00_21796;
																																								{
																																									obj_t
																																										BgL_exprz00_21798;
																																									obj_t
																																										BgL_bindingsz00_21797;
																																									BgL_bindingsz00_21797
																																										=
																																										BgL_arg2176z00_2512;
																																									BgL_exprz00_21798
																																										=
																																										BgL_arg2177z00_2513;
																																									BgL_exprz00_1732
																																										=
																																										BgL_exprz00_21798;
																																									BgL_bindingsz00_1731
																																										=
																																										BgL_bindingsz00_21797;
																																									goto
																																										BgL_tagzd2382zd2_1733;
																																								}
																																								BgL_auxz00_21791
																																									=
																																									(
																																									(obj_t)
																																									BgL_auxz00_21796);
																																							}
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_21805;
																																									goto
																																										BgL_tagzd2383zd2_1734;
																																									BgL_auxz00_21791
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_21805);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									obj_t
																																										BgL_carzd230837zd2_2516;
																																									BgL_carzd230837zd2_2516
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_expz00_21));
																																									if ((BgL_carzd230837zd2_2516 == CNST_TABLE_REF(((long) 19))))
																																										{
																																											BgL_letzd2funzd2_bglt
																																												BgL_auxz00_21812;
																																											goto
																																												BgL_tagzd2384zd2_1735;
																																											BgL_auxz00_21791
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_21812);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd230837zd2_2516)))
																																												{
																																													BgL_letzd2funzd2_bglt
																																														BgL_auxz00_21817;
																																													goto
																																														BgL_tagzd2384zd2_1735;
																																													BgL_auxz00_21791
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_21817);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_21824;
																																															goto
																																																BgL_tagzd2389zd2_1754;
																																															BgL_auxz00_21791
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_21824);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_21831;
																																																	goto
																																																		BgL_tagzd2390zd2_1755;
																																																	BgL_auxz00_21791
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_21831);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_21838;
																																																			goto
																																																				BgL_tagzd2392zd2_1759;
																																																			BgL_auxz00_21791
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_21838);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_21845;
																																																					goto
																																																						BgL_tagzd2393zd2_1760;
																																																					BgL_auxz00_21791
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_21845);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_21852;
																																																							goto
																																																								BgL_tagzd2395zd2_1764;
																																																							BgL_auxz00_21791
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_21852);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_21859;
																																																									goto
																																																										BgL_tagzd2396zd2_1765;
																																																									BgL_auxz00_21791
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_21859);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_21866;
																																																											goto
																																																												BgL_tagzd2397zd2_1766;
																																																											BgL_auxz00_21791
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_21866);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																												{
																																																													BgL_jumpzd2exzd2itz00_bglt
																																																														BgL_auxz00_21873;
																																																													goto
																																																														BgL_tagzd2398zd2_1767;
																																																													BgL_auxz00_21791
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_21873);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (BGl_equalzf3zf3zz__r4_equivalence_6_2z00(CAR(((obj_t) BgL_expz00_21)), BUNSPEC))
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (NULLP(CDR(((obj_t) BgL_expz00_21))))
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_21883;
																																																																	goto
																																																																		BgL_tagzd2402zd2_1776;
																																																																	BgL_auxz00_21791
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_21883);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1777;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_21887;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1778;
																																																																			BgL_auxz00_21791
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_21887);
																																																																		}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1777;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_21891;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1778;
																																																																	BgL_auxz00_21791
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_21891);
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																					return
																																						(
																																						(BgL_nodez00_bglt)
																																						BgL_auxz00_21791);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd224574zd2_1832)))
																																						{
																																							obj_t
																																								BgL_auxz00_21897;
																																							goto
																																								BgL_kapzd230804zd2_2415;
																																							return
																																								(
																																								(BgL_nodez00_bglt)
																																								BgL_auxz00_21897);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							if ((BgL_carzd224574zd2_1832 == CNST_TABLE_REF(((long) 18))))
																																								{
																																									obj_t
																																										BgL_auxz00_21902;
																																									goto
																																										BgL_kapzd230804zd2_2415;
																																									return
																																										(
																																										(BgL_nodez00_bglt)
																																										BgL_auxz00_21902);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 20))))
																																										{	/* Ast/sexp.scm 119 */
																																											goto
																																												BgL_tagzd2383zd2_1734;
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_carzd230998zd2_2421;
																																											BgL_carzd230998zd2_2421
																																												=
																																												CAR
																																												(BgL_expz00_21);
																																											if ((BgL_carzd230998zd2_2421 == CNST_TABLE_REF(((long) 19))))
																																												{
																																													BgL_letzd2funzd2_bglt
																																														BgL_auxz00_21912;
																																													goto
																																														BgL_tagzd2384zd2_1735;
																																													return
																																														(
																																														(BgL_nodez00_bglt)
																																														BgL_auxz00_21912);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd230998zd2_2421)))
																																														{
																																															BgL_letzd2funzd2_bglt
																																																BgL_auxz00_21917;
																																															goto
																																																BgL_tagzd2384zd2_1735;
																																															return
																																																(
																																																(BgL_nodez00_bglt)
																																																BgL_auxz00_21917);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 3))))
																																																{	/* Ast/sexp.scm 119 */
																																																	goto
																																																		BgL_tagzd2389zd2_1754;
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 6))))
																																																		{	/* Ast/sexp.scm 119 */
																																																			goto
																																																				BgL_tagzd2390zd2_1755;
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_cdrzd231077zd2_2428;
																																																			BgL_cdrzd231077zd2_2428
																																																				=
																																																				CDR
																																																				(BgL_expz00_21);
																																																			if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 21))))
																																																				{	/* Ast/sexp.scm 119 */
																																																					if (PAIRP(BgL_cdrzd231077zd2_2428))
																																																						{
																																																							obj_t
																																																								BgL_restz00_21936;
																																																							obj_t
																																																								BgL_effectz00_21934;
																																																							BgL_effectz00_21934
																																																								=
																																																								CAR
																																																								(BgL_cdrzd231077zd2_2428);
																																																							BgL_restz00_21936
																																																								=
																																																								CDR
																																																								(BgL_cdrzd231077zd2_2428);
																																																							BgL_restz00_1757
																																																								=
																																																								BgL_restz00_21936;
																																																							BgL_effectz00_1756
																																																								=
																																																								BgL_effectz00_21934;
																																																							goto
																																																								BgL_tagzd2391zd2_1758;
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																								{
																																																									obj_t
																																																										BgL_auxz00_21940;
																																																									goto
																																																										BgL_tagzd2403zd2_1777;
																																																									return
																																																										(
																																																										(BgL_nodez00_bglt)
																																																										BgL_auxz00_21940);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									goto
																																																										BgL_tagzd2404zd2_1778;
																																																								}
																																																						}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 22))))
																																																						{	/* Ast/sexp.scm 119 */
																																																							goto
																																																								BgL_tagzd2392zd2_1759;
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 23))))
																																																								{	/* Ast/sexp.scm 119 */
																																																									goto
																																																										BgL_tagzd2393zd2_1760;
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 24))))
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (PAIRP(BgL_cdrzd231077zd2_2428))
																																																												{
																																																													obj_t
																																																														BgL_restz00_21958;
																																																													obj_t
																																																														BgL_effectz00_21956;
																																																													BgL_effectz00_21956
																																																														=
																																																														CAR
																																																														(BgL_cdrzd231077zd2_2428);
																																																													BgL_restz00_21958
																																																														=
																																																														CDR
																																																														(BgL_cdrzd231077zd2_2428);
																																																													BgL_restz00_1762
																																																														=
																																																														BgL_restz00_21958;
																																																													BgL_effectz00_1761
																																																														=
																																																														BgL_effectz00_21956;
																																																													goto
																																																														BgL_tagzd2394zd2_1763;
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{
																																																															obj_t
																																																																BgL_auxz00_21962;
																																																															goto
																																																																BgL_tagzd2403zd2_1777;
																																																															return
																																																																(
																																																																(BgL_nodez00_bglt)
																																																																BgL_auxz00_21962);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															goto
																																																																BgL_tagzd2404zd2_1778;
																																																														}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 25))))
																																																												{	/* Ast/sexp.scm 119 */
																																																													goto
																																																														BgL_tagzd2395zd2_1764;
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 26))))
																																																														{	/* Ast/sexp.scm 119 */
																																																															goto
																																																																BgL_tagzd2396zd2_1765;
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 27))))
																																																																{
																																																																	BgL_letzd2funzd2_bglt
																																																																		BgL_auxz00_21976;
																																																																	goto
																																																																		BgL_tagzd2397zd2_1766;
																																																																	return
																																																																		(
																																																																		(BgL_nodez00_bglt)
																																																																		BgL_auxz00_21976);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 28))))
																																																																		{
																																																																			BgL_jumpzd2exzd2itz00_bglt
																																																																				BgL_auxz00_21982;
																																																																			goto
																																																																				BgL_tagzd2398zd2_1767;
																																																																			return
																																																																				(
																																																																				(BgL_nodez00_bglt)
																																																																				BgL_auxz00_21982);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd231204zd2_2454;
																																																																			BgL_cdrzd231204zd2_2454
																																																																				=
																																																																				CDR
																																																																				(BgL_expz00_21);
																																																																			if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 30))))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (PAIRP(BgL_cdrzd231204zd2_2454))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd231206zd2_2458;
																																																																							BgL_cdrzd231206zd2_2458
																																																																								=
																																																																								CDR
																																																																								(BgL_cdrzd231204zd2_2454);
																																																																							if (PAIRP(BgL_cdrzd231206zd2_2458))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (NULLP(CDR(BgL_cdrzd231206zd2_2458)))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2399zd2_1768;
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{
																																																																													obj_t
																																																																														BgL_auxz00_21999;
																																																																													goto
																																																																														BgL_tagzd2403zd2_1777;
																																																																													return
																																																																														(
																																																																														(BgL_nodez00_bglt)
																																																																														BgL_auxz00_21999);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2404zd2_1778;
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{
																																																																											obj_t
																																																																												BgL_auxz00_22003;
																																																																											goto
																																																																												BgL_tagzd2403zd2_1777;
																																																																											return
																																																																												(
																																																																												(BgL_nodez00_bglt)
																																																																												BgL_auxz00_22003);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2404zd2_1778;
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{
																																																																									obj_t
																																																																										BgL_auxz00_22007;
																																																																									goto
																																																																										BgL_tagzd2403zd2_1777;
																																																																									return
																																																																										(
																																																																										(BgL_nodez00_bglt)
																																																																										BgL_auxz00_22007);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2404zd2_1778;
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 29))))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (PAIRP(BgL_cdrzd231204zd2_2454))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd231251zd2_2470;
																																																																									BgL_cdrzd231251zd2_2470
																																																																										=
																																																																										CDR
																																																																										(BgL_cdrzd231204zd2_2454);
																																																																									if (PAIRP(BgL_cdrzd231251zd2_2470))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd231256zd2_2472;
																																																																											BgL_cdrzd231256zd2_2472
																																																																												=
																																																																												CDR
																																																																												(BgL_cdrzd231251zd2_2470);
																																																																											if ((CAR(BgL_cdrzd231251zd2_2470) == CNST_TABLE_REF(((long) 31))))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (PAIRP(BgL_cdrzd231256zd2_2472))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg2143z00_2476;
																																																																															obj_t
																																																																																BgL_arg2144z00_2477;
																																																																															obj_t
																																																																																BgL_arg2145z00_2478;
																																																																															BgL_arg2143z00_2476
																																																																																=
																																																																																CAR
																																																																																(BgL_cdrzd231204zd2_2454);
																																																																															BgL_arg2144z00_2477
																																																																																=
																																																																																CAR
																																																																																(BgL_cdrzd231256zd2_2472);
																																																																															BgL_arg2145z00_2478
																																																																																=
																																																																																CDR
																																																																																(BgL_cdrzd231256zd2_2472);
																																																																															return
																																																																																BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																(BgL_expz00_21,
																																																																																BgL_arg2143z00_2476,
																																																																																BgL_arg2144z00_2477,
																																																																																BgL_arg2145z00_2478,
																																																																																BgL_stackz00_22,
																																																																																BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																(BgL_expz00_21,
																																																																																	BgL_locz00_23),
																																																																																BgL_sitez00_24);
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_cdrzd231269zd2_2479;
																																																																															BgL_cdrzd231269zd2_2479
																																																																																=
																																																																																CDR
																																																																																(BgL_expz00_21);
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_arg2146z00_2480;
																																																																																obj_t
																																																																																	BgL_arg2147z00_2481;
																																																																																BgL_arg2146z00_2480
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd231269zd2_2479));
																																																																																BgL_arg2147z00_2481
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd231269zd2_2479));
																																																																																{	/* Ast/sexp.scm 552 */
																																																																																	obj_t
																																																																																		BgL_arg6965z00_11807;
																																																																																	BgL_arg6965z00_11807
																																																																																		=
																																																																																		BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																		(BgL_expz00_21,
																																																																																		BgL_locz00_23);
																																																																																	return
																																																																																		BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																		(BgL_expz00_21,
																																																																																		BgL_arg2146z00_2480,
																																																																																		CNST_TABLE_REF
																																																																																		(((long) 4)), BgL_arg2147z00_2481, BgL_stackz00_22, BgL_arg6965z00_11807, BgL_sitez00_24);
																																																																												}}}}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd231284zd2_2482;
																																																																													BgL_cdrzd231284zd2_2482
																																																																														=
																																																																														CDR
																																																																														(BgL_expz00_21);
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_arg2148z00_2483;
																																																																														obj_t
																																																																															BgL_arg2149z00_2484;
																																																																														BgL_arg2148z00_2483
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd231284zd2_2482));
																																																																														BgL_arg2149z00_2484
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd231284zd2_2482));
																																																																														{	/* Ast/sexp.scm 552 */
																																																																															obj_t
																																																																																BgL_arg6965z00_11811;
																																																																															BgL_arg6965z00_11811
																																																																																=
																																																																																BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																(BgL_expz00_21,
																																																																																BgL_locz00_23);
																																																																															return
																																																																																BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																(BgL_expz00_21,
																																																																																BgL_arg2148z00_2483,
																																																																																CNST_TABLE_REF
																																																																																(((long) 4)), BgL_arg2149z00_2484, BgL_stackz00_22, BgL_arg6965z00_11811, BgL_sitez00_24);
																																																																										}}}}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd231299zd2_2486;
																																																																											BgL_cdrzd231299zd2_2486
																																																																												=
																																																																												CDR
																																																																												(BgL_expz00_21);
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_arg2151z00_2487;
																																																																												obj_t
																																																																													BgL_arg2152z00_2488;
																																																																												BgL_arg2151z00_2487
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd231299zd2_2486));
																																																																												BgL_arg2152z00_2488
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd231299zd2_2486));
																																																																												{	/* Ast/sexp.scm 552 */
																																																																													obj_t
																																																																														BgL_arg6965z00_11815;
																																																																													BgL_arg6965z00_11815
																																																																														=
																																																																														BGl_findzd2locationzf2locz20zztools_locationz00
																																																																														(BgL_expz00_21,
																																																																														BgL_locz00_23);
																																																																													return
																																																																														BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																														(BgL_expz00_21,
																																																																														BgL_arg2151z00_2487,
																																																																														CNST_TABLE_REF
																																																																														(((long) 4)), BgL_arg2152z00_2488, BgL_stackz00_22, BgL_arg6965z00_11815, BgL_sitez00_24);
																																																																								}}}}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{
																																																																											obj_t
																																																																												BgL_auxz00_22056;
																																																																											goto
																																																																												BgL_tagzd2403zd2_1777;
																																																																											return
																																																																												(
																																																																												(BgL_nodez00_bglt)
																																																																												BgL_auxz00_22056);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2404zd2_1778;
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_equalzf3zf3zz__r4_equivalence_6_2z00(CAR(BgL_expz00_21), BUNSPEC))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (NULLP(CDR(BgL_expz00_21)))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2402zd2_1776;
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{
																																																																													obj_t
																																																																														BgL_auxz00_22066;
																																																																													goto
																																																																														BgL_tagzd2403zd2_1777;
																																																																													return
																																																																														(
																																																																														(BgL_nodez00_bglt)
																																																																														BgL_auxz00_22066);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2404zd2_1778;
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{
																																																																											obj_t
																																																																												BgL_auxz00_22070;
																																																																											goto
																																																																												BgL_tagzd2403zd2_1777;
																																																																											return
																																																																												(
																																																																												(BgL_nodez00_bglt)
																																																																												BgL_auxz00_22070);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2404zd2_1778;
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																										}
																								}
																						}
																					}
																			}
																	}
															}
													}
											}
										else
											{	/* Ast/sexp.scm 119 */
												if (
													(BgL_carzd2478zd2_1783 ==
														CNST_TABLE_REF(((long) 11))))
													{	/* Ast/sexp.scm 119 */
														goto BgL_tagzd2371zd2_1713;
													}
												else
													{	/* Ast/sexp.scm 119 */
														if (
															(CAR(BgL_expz00_21) ==
																CNST_TABLE_REF(((long) 14))))
															{
																obj_t BgL_lz00_22079;

																BgL_lz00_22079 = CDR(BgL_expz00_21);
																BgL_lz00_1714 = BgL_lz00_22079;
																goto BgL_tagzd2372zd2_1715;
															}
														else
															{	/* Ast/sexp.scm 119 */
																if (
																	(CAR(BgL_expz00_21) ==
																		CNST_TABLE_REF(((long) 12))))
																	{	/* Ast/sexp.scm 119 */
																		goto BgL_tagzd2373zd2_1716;
																	}
																else
																	{	/* Ast/sexp.scm 119 */
																		if (
																			(CAR(BgL_expz00_21) ==
																				CNST_TABLE_REF(((long) 15))))
																			{	/* Ast/sexp.scm 119 */
																				if (NULLP(CDR(BgL_expz00_21)))
																					{	/* Ast/sexp.scm 119 */
																						goto BgL_tagzd2374zd2_1717;
																					}
																				else
																					{	/* Ast/sexp.scm 119 */
																						obj_t BgL_arg4279z00_5079;

																						BgL_arg4279z00_5079 =
																							CDR(BgL_expz00_21);
																						{
																							BgL_sequencez00_bglt
																								BgL_auxz00_22093;
																							{
																								obj_t BgL_bodyz00_22094;

																								BgL_bodyz00_22094 =
																									BgL_arg4279z00_5079;
																								BgL_bodyz00_1718 =
																									BgL_bodyz00_22094;
																								goto BgL_tagzd2375zd2_1719;
																							}
																							return
																								((BgL_nodez00_bglt)
																								BgL_auxz00_22093);
																						}
																					}
																			}
																		else
																			{	/* Ast/sexp.scm 119 */
																				obj_t BgL_carzd231447zd2_5081;
																				obj_t BgL_cdrzd231448zd2_5082;

																				BgL_carzd231447zd2_5081 =
																					CAR(BgL_expz00_21);
																				BgL_cdrzd231448zd2_5082 =
																					CDR(BgL_expz00_21);
																				{

																					if (
																						(BgL_carzd231447zd2_5081 ==
																							CNST_TABLE_REF(((long) 1))))
																						{
																							obj_t BgL_auxz00_22101;

																						BgL_kapzd231449zd2_5083:
																							if (PAIRP
																								(BgL_cdrzd231448zd2_5082))
																								{	/* Ast/sexp.scm 119 */
																									obj_t BgL_cdrzd231452zd2_5830;

																									BgL_cdrzd231452zd2_5830 =
																										CDR
																										(BgL_cdrzd231448zd2_5082);
																									if (PAIRP
																										(BgL_cdrzd231452zd2_5830))
																										{	/* Ast/sexp.scm 119 */
																											obj_t
																												BgL_cdrzd231455zd2_5832;
																											BgL_cdrzd231455zd2_5832 =
																												CDR
																												(BgL_cdrzd231452zd2_5830);
																											if ((CAR
																													(BgL_cdrzd231452zd2_5830)
																													== BTRUE))
																												{	/* Ast/sexp.scm 119 */
																													if (PAIRP
																														(BgL_cdrzd231455zd2_5832))
																														{	/* Ast/sexp.scm 119 */
																															if (
																																(CAR
																																	(BgL_cdrzd231455zd2_5832)
																																	== BFALSE))
																																{	/* Ast/sexp.scm 119 */
																																	if (NULLP(CDR
																																			(BgL_cdrzd231455zd2_5832)))
																																		{	/* Ast/sexp.scm 119 */
																																			if (
																																				(BgL_sitez00_24
																																					==
																																					CNST_TABLE_REF
																																					(((long) 8))))
																																				{	/* Ast/sexp.scm 119 */
																																					obj_t
																																						BgL_arg4819z00_5842;
																																					BgL_arg4819z00_5842
																																						=
																																						CAR
																																						(BgL_cdrzd231448zd2_5082);
																																					BgL_auxz00_22101
																																						=
																																						(
																																						(obj_t)
																																						BGl_sexpzd2ze3nodez31zzast_sexpz00
																																						(BgL_arg4819z00_5842,
																																							BgL_stackz00_22,
																																							BgL_locz00_23,
																																							BgL_sitez00_24));
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					obj_t
																																						BgL_carzd231474zd2_5843;
																																					BgL_carzd231474zd2_5843
																																						=
																																						CAR(
																																						((obj_t) BgL_expz00_21));
																																					if (
																																						(BgL_carzd231474zd2_5843
																																							==
																																							CNST_TABLE_REF
																																							(((long) 1))))
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_22130;
																																							goto
																																								BgL_tagzd2377zd2_1722;
																																							BgL_auxz00_22101
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_22130);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							if ((BgL_carzd231474zd2_5843 == BGl_za2ifza2z00zzast_sexpz00))
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_22134;
																																									goto
																																										BgL_tagzd2377zd2_1722;
																																									BgL_auxz00_22101
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_22134);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 7))))
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_22141;
																																											goto
																																												BgL_tagzd2379zd2_1726;
																																											BgL_auxz00_22101
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_22141);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_22148;
																																													goto
																																														BgL_tagzd2380zd2_1727;
																																													BgL_auxz00_22101
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_22148);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_carzd231543zd2_5850;
																																													BgL_carzd231543zd2_5850
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													if (PAIRP(BgL_carzd231543zd2_5850))
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_carzd231546zd2_5852;
																																															obj_t
																																																BgL_cdrzd231547zd2_5853;
																																															BgL_carzd231546zd2_5852
																																																=
																																																CAR
																																																(BgL_carzd231543zd2_5850);
																																															BgL_cdrzd231547zd2_5853
																																																=
																																																CDR
																																																(BgL_carzd231543zd2_5850);
																																															{

																																																if ((BgL_carzd231546zd2_5852 == CNST_TABLE_REF(((long) 17))))
																																																	{	/* Ast/sexp.scm 119 */
																																																	BgL_kapzd231548zd2_5854:
																																																		if (PAIRP(BgL_cdrzd231547zd2_5853))
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd231551zd2_5979;
																																																				BgL_cdrzd231551zd2_5979
																																																					=
																																																					CDR
																																																					(BgL_cdrzd231547zd2_5853);
																																																				if (PAIRP(BgL_cdrzd231551zd2_5979))
																																																					{	/* Ast/sexp.scm 119 */
																																																						if (NULLP(CDR(BgL_cdrzd231551zd2_5979)))
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg4911z00_5983;
																																																								obj_t
																																																									BgL_arg4912z00_5984;
																																																								BgL_arg4911z00_5983
																																																									=
																																																									CAR
																																																									(BgL_cdrzd231551zd2_5979);
																																																								BgL_arg4912z00_5984
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_22170;
																																																									{
																																																										obj_t
																																																											BgL_argsz00_22172;
																																																										obj_t
																																																											BgL_bodyz00_22171;
																																																										BgL_bodyz00_22171
																																																											=
																																																											BgL_arg4911z00_5983;
																																																										BgL_argsz00_22172
																																																											=
																																																											BgL_arg4912z00_5984;
																																																										BgL_argsz00_1729
																																																											=
																																																											BgL_argsz00_22172;
																																																										BgL_bodyz00_1728
																																																											=
																																																											BgL_bodyz00_22171;
																																																										goto
																																																											BgL_tagzd2381zd2_1730;
																																																									}
																																																									BgL_auxz00_22101
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_22170);
																																																								}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd231575zd2_5985;
																																																								BgL_cdrzd231575zd2_5985
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{	/* Ast/sexp.scm 119 */
																																																									bool_t
																																																										BgL_test9365z00_22176;
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg4981z00_6096;
																																																										BgL_arg4981z00_6096
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_test9365z00_22176
																																																											=
																																																											CBOOL
																																																											(BGl_letzd2symzf3z21zzast_letz00
																																																											(BgL_arg4981z00_6096));
																																																									}
																																																									if (BgL_test9365z00_22176)
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_arg4915z00_5988;
																																																											obj_t
																																																												BgL_arg4916z00_5989;
																																																											BgL_arg4915z00_5988
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_cdrzd231575zd2_5985));
																																																											BgL_arg4916z00_5989
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd231575zd2_5985));
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_22185;
																																																												{
																																																													obj_t
																																																														BgL_exprz00_22187;
																																																													obj_t
																																																														BgL_bindingsz00_22186;
																																																													BgL_bindingsz00_22186
																																																														=
																																																														BgL_arg4915z00_5988;
																																																													BgL_exprz00_22187
																																																														=
																																																														BgL_arg4916z00_5989;
																																																													BgL_exprz00_1732
																																																														=
																																																														BgL_exprz00_22187;
																																																													BgL_bindingsz00_1731
																																																														=
																																																														BgL_bindingsz00_22186;
																																																													goto
																																																														BgL_tagzd2382zd2_1733;
																																																												}
																																																												BgL_auxz00_22101
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_22185);
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											bool_t
																																																												BgL_test9366z00_22189;
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_arg4980z00_6095;
																																																												BgL_arg4980z00_6095
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												BgL_test9366z00_22189
																																																													=
																																																													CBOOL
																																																													(BGl_labelszd2symzf3z21zzast_labelsz00
																																																													(BgL_arg4980z00_6095));
																																																											}
																																																											if (BgL_test9366z00_22189)
																																																												{
																																																													BgL_letzd2funzd2_bglt
																																																														BgL_auxz00_22194;
																																																													goto
																																																														BgL_tagzd2384zd2_1735;
																																																													BgL_auxz00_22101
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_22194);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_carzd231642zd2_5992;
																																																													BgL_carzd231642zd2_5992
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd231647zd2_5993;
																																																														BgL_cdrzd231647zd2_5993
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_carzd231642zd2_5992));
																																																														if ((CAR(((obj_t) BgL_carzd231642zd2_5992)) == CNST_TABLE_REF(((long) 3))))
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_arg4921z00_5996;
																																																																obj_t
																																																																	BgL_arg4922z00_5997;
																																																																obj_t
																																																																	BgL_arg4923z00_5998;
																																																																BgL_arg4921z00_5996
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd231647zd2_5993));
																																																																BgL_arg4922z00_5997
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd231647zd2_5993));
																																																																BgL_arg4923z00_5998
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_22211;
																																																																	{
																																																																		obj_t
																																																																			BgL_argsz00_22214;
																																																																		obj_t
																																																																			BgL_bodyz00_22213;
																																																																		obj_t
																																																																			BgL_varsz00_22212;
																																																																		BgL_varsz00_22212
																																																																			=
																																																																			BgL_arg4921z00_5996;
																																																																		BgL_bodyz00_22213
																																																																			=
																																																																			BgL_arg4922z00_5997;
																																																																		BgL_argsz00_22214
																																																																			=
																																																																			BgL_arg4923z00_5998;
																																																																		BgL_argsz00_1742
																																																																			=
																																																																			BgL_argsz00_22214;
																																																																		BgL_bodyz00_1741
																																																																			=
																																																																			BgL_bodyz00_22213;
																																																																		BgL_varsz00_1740
																																																																			=
																																																																			BgL_varsz00_22212;
																																																																		goto
																																																																			BgL_tagzd2386zd2_1743;
																																																																	}
																																																																	BgL_auxz00_22101
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_22211);
																																																																}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd231670zd2_6000;
																																																																BgL_cdrzd231670zd2_6000
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd231676zd2_6001;
																																																																	BgL_cdrzd231676zd2_6001
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_carzd231642zd2_5992));
																																																																	if ((CAR(((obj_t) BgL_carzd231642zd2_5992)) == CNST_TABLE_REF(((long) 1))))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd231682zd2_6004;
																																																																			BgL_cdrzd231682zd2_6004
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd231676zd2_6001));
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_carzd231687zd2_6005;
																																																																				obj_t
																																																																					BgL_cdrzd231688zd2_6006;
																																																																				BgL_carzd231687zd2_6005
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd231682zd2_6004));
																																																																				BgL_cdrzd231688zd2_6006
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd231682zd2_6004));
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd231687zd2_6005))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (PAIRP(BgL_cdrzd231688zd2_6006))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_carzd231695zd2_6009;
																																																																								BgL_carzd231695zd2_6009
																																																																									=
																																																																									CAR
																																																																									(BgL_cdrzd231688zd2_6006);
																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd231695zd2_6009))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (NULLP(CDR(BgL_cdrzd231688zd2_6006)))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												bool_t
																																																																													BgL_test9373z00_22241;
																																																																												{
																																																																													obj_t
																																																																														BgL_l1420z00_6042;
																																																																													BgL_l1420z00_6042
																																																																														=
																																																																														BgL_cdrzd231670zd2_6000;
																																																																												BgL_zc3z04anonymousza34946ze3z87_6043:
																																																																													if (NULLP(BgL_l1420z00_6042))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															BgL_test9373z00_22241
																																																																																=
																																																																																(
																																																																																(bool_t)
																																																																																1);
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															bool_t
																																																																																BgL_test9375z00_22244;
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																bool_t
																																																																																	BgL_test9376z00_22245;
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_tmpz00_22246;
																																																																																	BgL_tmpz00_22246
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_l1420z00_6042));
																																																																																	BgL_test9376z00_22245
																																																																																		=
																																																																																		PAIRP
																																																																																		(BgL_tmpz00_22246);
																																																																																}
																																																																																if (BgL_test9376z00_22245)
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		BgL_test9375z00_22244
																																																																																			=
																																																																																			(
																																																																																			(bool_t)
																																																																																			0);
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		BgL_test9375z00_22244
																																																																																			=
																																																																																			(
																																																																																			(bool_t)
																																																																																			1);
																																																																																	}
																																																																															}
																																																																															if (BgL_test9375z00_22244)
																																																																																{
																																																																																	obj_t
																																																																																		BgL_l1420z00_22250;
																																																																																	BgL_l1420z00_22250
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_l1420z00_6042));
																																																																																	BgL_l1420z00_6042
																																																																																		=
																																																																																		BgL_l1420z00_22250;
																																																																																	goto
																																																																																		BgL_zc3z04anonymousza34946ze3z87_6043;
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	BgL_test9373z00_22241
																																																																																		=
																																																																																		(
																																																																																		(bool_t)
																																																																																		0);
																																																																																}
																																																																														}
																																																																												}
																																																																												if (BgL_test9373z00_22241)
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_arg4936z00_6025;
																																																																														BgL_arg4936z00_6025
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd231676zd2_6001));
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_22255;
																																																																															{
																																																																																obj_t
																																																																																	BgL_argsz00_22259;
																																																																																obj_t
																																																																																	BgL_proc2z00_22258;
																																																																																obj_t
																																																																																	BgL_proc1z00_22257;
																																																																																obj_t
																																																																																	BgL_testz00_22256;
																																																																																BgL_testz00_22256
																																																																																	=
																																																																																	BgL_arg4936z00_6025;
																																																																																BgL_proc1z00_22257
																																																																																	=
																																																																																	BgL_carzd231687zd2_6005;
																																																																																BgL_proc2z00_22258
																																																																																	=
																																																																																	BgL_carzd231695zd2_6009;
																																																																																BgL_argsz00_22259
																																																																																	=
																																																																																	BgL_cdrzd231670zd2_6000;
																																																																																BgL_argsz00_1747
																																																																																	=
																																																																																	BgL_argsz00_22259;
																																																																																BgL_proc2z00_1746
																																																																																	=
																																																																																	BgL_proc2z00_22258;
																																																																																BgL_proc1z00_1745
																																																																																	=
																																																																																	BgL_proc1z00_22257;
																																																																																BgL_testz00_1744
																																																																																	=
																																																																																	BgL_testz00_22256;
																																																																																goto
																																																																																	BgL_tagzd2387zd2_1748;
																																																																															}
																																																																															BgL_auxz00_22101
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_22255);
																																																																														}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_cdrzd231719zd2_6026;
																																																																														BgL_cdrzd231719zd2_6026
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_expz00_21));
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_cdrzd231726zd2_6027;
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_pairz00_11882;
																																																																																BgL_pairz00_11882
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_expz00_21));
																																																																																BgL_cdrzd231726zd2_6027
																																																																																	=
																																																																																	CDR
																																																																																	(BgL_pairz00_11882);
																																																																															}
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_cdrzd231733zd2_6028;
																																																																																BgL_cdrzd231733zd2_6028
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd231726zd2_6027));
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_carzd231739zd2_6029;
																																																																																	BgL_carzd231739zd2_6029
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd231733zd2_6028));
																																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd231739zd2_6029))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_carzd231746zd2_6031;
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_pairz00_11886;
																																																																																				BgL_pairz00_11886
																																																																																					=
																																																																																					CDR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd231733zd2_6028));
																																																																																				BgL_carzd231746zd2_6031
																																																																																					=
																																																																																					CAR
																																																																																					(BgL_pairz00_11886);
																																																																																			}
																																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd231746zd2_6031))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd231719zd2_6026))
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							obj_t
																																																																																								BgL_arg4940z00_6034;
																																																																																							BgL_arg4940z00_6034
																																																																																								=
																																																																																								CAR
																																																																																								(
																																																																																								((obj_t) BgL_cdrzd231726zd2_6027));
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_22281;
																																																																																								{
																																																																																									obj_t
																																																																																										BgL_argsz00_22285;
																																																																																									obj_t
																																																																																										BgL_proc2z00_22284;
																																																																																									obj_t
																																																																																										BgL_proc1z00_22283;
																																																																																									obj_t
																																																																																										BgL_testz00_22282;
																																																																																									BgL_testz00_22282
																																																																																										=
																																																																																										BgL_arg4940z00_6034;
																																																																																									BgL_proc1z00_22283
																																																																																										=
																																																																																										BgL_carzd231739zd2_6029;
																																																																																									BgL_proc2z00_22284
																																																																																										=
																																																																																										BgL_carzd231746zd2_6031;
																																																																																									BgL_argsz00_22285
																																																																																										=
																																																																																										BgL_cdrzd231719zd2_6026;
																																																																																									BgL_argsz00_1752
																																																																																										=
																																																																																										BgL_argsz00_22285;
																																																																																									BgL_proc2z00_1751
																																																																																										=
																																																																																										BgL_proc2z00_22284;
																																																																																									BgL_proc1z00_1750
																																																																																										=
																																																																																										BgL_proc1z00_22283;
																																																																																									BgL_testz00_1749
																																																																																										=
																																																																																										BgL_testz00_22282;
																																																																																									goto
																																																																																										BgL_tagzd2388zd2_1753;
																																																																																								}
																																																																																								BgL_auxz00_22101
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_22281);
																																																																																							}
																																																																																						}
																																																																																					else
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																								{	/* Ast/sexp.scm 119 */
																																																																																									goto
																																																																																										BgL_tagzd2403zd2_1777;
																																																																																								}
																																																																																							else
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_22289;
																																																																																									goto
																																																																																										BgL_tagzd2404zd2_1778;
																																																																																									BgL_auxz00_22101
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_22289);
																																																																																								}
																																																																																						}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							goto
																																																																																								BgL_tagzd2403zd2_1777;
																																																																																						}
																																																																																					else
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_22293;
																																																																																							goto
																																																																																								BgL_tagzd2404zd2_1778;
																																																																																							BgL_auxz00_22101
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_22293);
																																																																																						}
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1777;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_22297;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1778;
																																																																																					BgL_auxz00_22101
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_22297);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															}
																																																																														}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1777;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_22301;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1778;
																																																																														BgL_auxz00_22101
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_22301);
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd232022zd2_6053;
																																																																										BgL_cdrzd232022zd2_6053
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd232028zd2_6054;
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_pairz00_11890;
																																																																												BgL_pairz00_11890
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												BgL_cdrzd232028zd2_6054
																																																																													=
																																																																													CDR
																																																																													(BgL_pairz00_11890);
																																																																											}
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_cdrzd232034zd2_6055;
																																																																												BgL_cdrzd232034zd2_6055
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd232028zd2_6054));
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_carzd232039zd2_6056;
																																																																													obj_t
																																																																														BgL_cdrzd232040zd2_6057;
																																																																													BgL_carzd232039zd2_6056
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd232034zd2_6055));
																																																																													BgL_cdrzd232040zd2_6057
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd232034zd2_6055));
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd232039zd2_6056))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_carzd232045zd2_6059;
																																																																															BgL_carzd232045zd2_6059
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd232040zd2_6057));
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd232045zd2_6059))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (NULLP(CDR(((obj_t) BgL_cdrzd232040zd2_6057))))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd232022zd2_6053))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					obj_t
																																																																																						BgL_arg4955z00_6064;
																																																																																					BgL_arg4955z00_6064
																																																																																						=
																																																																																						CAR
																																																																																						(
																																																																																						((obj_t) BgL_cdrzd232028zd2_6054));
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_22328;
																																																																																						{
																																																																																							obj_t
																																																																																								BgL_argsz00_22332;
																																																																																							obj_t
																																																																																								BgL_proc2z00_22331;
																																																																																							obj_t
																																																																																								BgL_proc1z00_22330;
																																																																																							obj_t
																																																																																								BgL_testz00_22329;
																																																																																							BgL_testz00_22329
																																																																																								=
																																																																																								BgL_arg4955z00_6064;
																																																																																							BgL_proc1z00_22330
																																																																																								=
																																																																																								BgL_carzd232039zd2_6056;
																																																																																							BgL_proc2z00_22331
																																																																																								=
																																																																																								BgL_carzd232045zd2_6059;
																																																																																							BgL_argsz00_22332
																																																																																								=
																																																																																								BgL_cdrzd232022zd2_6053;
																																																																																							BgL_argsz00_1752
																																																																																								=
																																																																																								BgL_argsz00_22332;
																																																																																							BgL_proc2z00_1751
																																																																																								=
																																																																																								BgL_proc2z00_22331;
																																																																																							BgL_proc1z00_1750
																																																																																								=
																																																																																								BgL_proc1z00_22330;
																																																																																							BgL_testz00_1749
																																																																																								=
																																																																																								BgL_testz00_22329;
																																																																																							goto
																																																																																								BgL_tagzd2388zd2_1753;
																																																																																						}
																																																																																						BgL_auxz00_22101
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_22328);
																																																																																					}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							goto
																																																																																								BgL_tagzd2403zd2_1777;
																																																																																						}
																																																																																					else
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_22336;
																																																																																							goto
																																																																																								BgL_tagzd2404zd2_1778;
																																																																																							BgL_auxz00_22101
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_22336);
																																																																																						}
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1777;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_22340;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1778;
																																																																																					BgL_auxz00_22101
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_22340);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1777;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_22344;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1778;
																																																																																			BgL_auxz00_22101
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_22344);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1777;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_22348;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1778;
																																																																																	BgL_auxz00_22101
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_22348);
																																																																																}
																																																																														}
																																																																												}
																																																																											}
																																																																										}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1777;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_22352;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1778;
																																																																										BgL_auxz00_22101
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_22352);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd232378zd2_6072;
																																																																						BgL_cdrzd232378zd2_6072
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd232385zd2_6073;
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_pairz00_11900;
																																																																								BgL_pairz00_11900
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								BgL_cdrzd232385zd2_6073
																																																																									=
																																																																									CDR
																																																																									(BgL_pairz00_11900);
																																																																							}
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd232392zd2_6074;
																																																																								BgL_cdrzd232392zd2_6074
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd232385zd2_6073));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd232398zd2_6075;
																																																																									obj_t
																																																																										BgL_cdrzd232399zd2_6076;
																																																																									BgL_carzd232398zd2_6075
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd232392zd2_6074));
																																																																									BgL_cdrzd232399zd2_6076
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd232392zd2_6074));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd232398zd2_6075))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (PAIRP(BgL_cdrzd232399zd2_6076))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_carzd232406zd2_6079;
																																																																													BgL_carzd232406zd2_6079
																																																																														=
																																																																														CAR
																																																																														(BgL_cdrzd232399zd2_6076);
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd232406zd2_6079))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (NULLP(CDR(BgL_cdrzd232399zd2_6076)))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd232378zd2_6072))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_arg4969z00_6084;
																																																																																			BgL_arg4969z00_6084
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd232385zd2_6073));
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_22379;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_22383;
																																																																																					obj_t
																																																																																						BgL_proc2z00_22382;
																																																																																					obj_t
																																																																																						BgL_proc1z00_22381;
																																																																																					obj_t
																																																																																						BgL_testz00_22380;
																																																																																					BgL_testz00_22380
																																																																																						=
																																																																																						BgL_arg4969z00_6084;
																																																																																					BgL_proc1z00_22381
																																																																																						=
																																																																																						BgL_carzd232398zd2_6075;
																																																																																					BgL_proc2z00_22382
																																																																																						=
																																																																																						BgL_carzd232406zd2_6079;
																																																																																					BgL_argsz00_22383
																																																																																						=
																																																																																						BgL_cdrzd232378zd2_6072;
																																																																																					BgL_argsz00_1752
																																																																																						=
																																																																																						BgL_argsz00_22383;
																																																																																					BgL_proc2z00_1751
																																																																																						=
																																																																																						BgL_proc2z00_22382;
																																																																																					BgL_proc1z00_1750
																																																																																						=
																																																																																						BgL_proc1z00_22381;
																																																																																					BgL_testz00_1749
																																																																																						=
																																																																																						BgL_testz00_22380;
																																																																																					goto
																																																																																						BgL_tagzd2388zd2_1753;
																																																																																				}
																																																																																				BgL_auxz00_22101
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_22379);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1777;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_22387;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1778;
																																																																																					BgL_auxz00_22101
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_22387);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1777;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_22391;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1778;
																																																																																			BgL_auxz00_22101
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_22391);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1777;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_22395;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1778;
																																																																																	BgL_auxz00_22101
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_22395);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1777;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_22399;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1778;
																																																																															BgL_auxz00_22101
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_22399);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1777;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_22403;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1778;
																																																																													BgL_auxz00_22101
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_22403);
																																																																												}
																																																																										}
																																																																								}
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1777;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_22407;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1778;
																																																																					BgL_auxz00_22101
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_22407);
																																																																				}
																																																																		}
																																																																}
																																																															}
																																																													}
																																																												}
																																																										}
																																																								}
																																																							}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd232799zd2_6098;
																																																						BgL_cdrzd232799zd2_6098
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{	/* Ast/sexp.scm 119 */
																																																							bool_t
																																																								BgL_test9404z00_22411;
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg4997z00_6115;
																																																								BgL_arg4997z00_6115
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test9404z00_22411
																																																									=
																																																									CBOOL
																																																									(BGl_letzd2symzf3z21zzast_letz00
																																																									(BgL_arg4997z00_6115));
																																																							}
																																																							if (BgL_test9404z00_22411)
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_arg4985z00_6101;
																																																									obj_t
																																																										BgL_arg4986z00_6102;
																																																									BgL_arg4985z00_6101
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd232799zd2_6098));
																																																									BgL_arg4986z00_6102
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd232799zd2_6098));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_22420;
																																																										{
																																																											obj_t
																																																												BgL_exprz00_22422;
																																																											obj_t
																																																												BgL_bindingsz00_22421;
																																																											BgL_bindingsz00_22421
																																																												=
																																																												BgL_arg4985z00_6101;
																																																											BgL_exprz00_22422
																																																												=
																																																												BgL_arg4986z00_6102;
																																																											BgL_exprz00_1732
																																																												=
																																																												BgL_exprz00_22422;
																																																											BgL_bindingsz00_1731
																																																												=
																																																												BgL_bindingsz00_22421;
																																																											goto
																																																												BgL_tagzd2382zd2_1733;
																																																										}
																																																										BgL_auxz00_22101
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_22420);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									bool_t
																																																										BgL_test9405z00_22424;
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg4996z00_6114;
																																																										BgL_arg4996z00_6114
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_test9405z00_22424
																																																											=
																																																											CBOOL
																																																											(BGl_labelszd2symzf3z21zzast_labelsz00
																																																											(BgL_arg4996z00_6114));
																																																									}
																																																									if (BgL_test9405z00_22424)
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_22429;
																																																											goto
																																																												BgL_tagzd2384zd2_1735;
																																																											BgL_auxz00_22101
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_22429);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_carzd232865zd2_6105;
																																																											BgL_carzd232865zd2_6105
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd232870zd2_6106;
																																																												BgL_cdrzd232870zd2_6106
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_carzd232865zd2_6105));
																																																												if ((CAR(((obj_t) BgL_carzd232865zd2_6105)) == CNST_TABLE_REF(((long) 3))))
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_arg4991z00_6109;
																																																														obj_t
																																																															BgL_arg4992z00_6110;
																																																														obj_t
																																																															BgL_arg4993z00_6111;
																																																														BgL_arg4991z00_6109
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd232870zd2_6106));
																																																														BgL_arg4992z00_6110
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd232870zd2_6106));
																																																														BgL_arg4993z00_6111
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_22446;
																																																															{
																																																																obj_t
																																																																	BgL_argsz00_22449;
																																																																obj_t
																																																																	BgL_bodyz00_22448;
																																																																obj_t
																																																																	BgL_varsz00_22447;
																																																																BgL_varsz00_22447
																																																																	=
																																																																	BgL_arg4991z00_6109;
																																																																BgL_bodyz00_22448
																																																																	=
																																																																	BgL_arg4992z00_6110;
																																																																BgL_argsz00_22449
																																																																	=
																																																																	BgL_arg4993z00_6111;
																																																																BgL_argsz00_1742
																																																																	=
																																																																	BgL_argsz00_22449;
																																																																BgL_bodyz00_1741
																																																																	=
																																																																	BgL_bodyz00_22448;
																																																																BgL_varsz00_1740
																																																																	=
																																																																	BgL_varsz00_22447;
																																																																goto
																																																																	BgL_tagzd2386zd2_1743;
																																																															}
																																																															BgL_auxz00_22101
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_22446);
																																																														}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 119 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1777;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_22453;
																																																																goto
																																																																	BgL_tagzd2404zd2_1778;
																																																																BgL_auxz00_22101
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_22453);
																																																															}
																																																													}
																																																											}
																																																										}
																																																								}
																																																						}
																																																					}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd232981zd2_6116;
																																																				BgL_cdrzd232981zd2_6116
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 119 */
																																																					bool_t
																																																						BgL_test9408z00_22457;
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg5006z00_6125;
																																																						BgL_arg5006z00_6125
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test9408z00_22457
																																																							=
																																																							CBOOL
																																																							(BGl_letzd2symzf3z21zzast_letz00
																																																							(BgL_arg5006z00_6125));
																																																					}
																																																					if (BgL_test9408z00_22457)
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_arg5000z00_6119;
																																																							obj_t
																																																								BgL_arg5001z00_6120;
																																																							BgL_arg5000z00_6119
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd232981zd2_6116));
																																																							BgL_arg5001z00_6120
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd232981zd2_6116));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_22466;
																																																								{
																																																									obj_t
																																																										BgL_exprz00_22468;
																																																									obj_t
																																																										BgL_bindingsz00_22467;
																																																									BgL_bindingsz00_22467
																																																										=
																																																										BgL_arg5000z00_6119;
																																																									BgL_exprz00_22468
																																																										=
																																																										BgL_arg5001z00_6120;
																																																									BgL_exprz00_1732
																																																										=
																																																										BgL_exprz00_22468;
																																																									BgL_bindingsz00_1731
																																																										=
																																																										BgL_bindingsz00_22467;
																																																									goto
																																																										BgL_tagzd2382zd2_1733;
																																																								}
																																																								BgL_auxz00_22101
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_22466);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							bool_t
																																																								BgL_test9409z00_22470;
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg5005z00_6124;
																																																								BgL_arg5005z00_6124
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test9409z00_22470
																																																									=
																																																									CBOOL
																																																									(BGl_labelszd2symzf3z21zzast_labelsz00
																																																									(BgL_arg5005z00_6124));
																																																							}
																																																							if (BgL_test9409z00_22470)
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_22475;
																																																									goto
																																																										BgL_tagzd2384zd2_1735;
																																																									BgL_auxz00_22101
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_22475);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																										{	/* Ast/sexp.scm 119 */
																																																											goto
																																																												BgL_tagzd2403zd2_1777;
																																																										}
																																																									else
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_22479;
																																																											goto
																																																												BgL_tagzd2404zd2_1778;
																																																											BgL_auxz00_22101
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_22479);
																																																										}
																																																								}
																																																						}
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd231546zd2_5852)))
																																																			{	/* Ast/sexp.scm 119 */
																																																				goto
																																																					BgL_kapzd231548zd2_5854;
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				if ((BgL_carzd231546zd2_5852 == CNST_TABLE_REF(((long) 18))))
																																																					{	/* Ast/sexp.scm 119 */
																																																						goto
																																																							BgL_kapzd231548zd2_5854;
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						if ((BgL_carzd231546zd2_5852 == CNST_TABLE_REF(((long) 19))))
																																																							{	/* Ast/sexp.scm 119 */
																																																								goto
																																																									BgL_kapzd231548zd2_5854;
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd231546zd2_5852)))
																																																									{	/* Ast/sexp.scm 119 */
																																																										goto
																																																											BgL_kapzd231548zd2_5854;
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd233153zd2_5860;
																																																										BgL_cdrzd233153zd2_5860
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{	/* Ast/sexp.scm 119 */
																																																											bool_t
																																																												BgL_test9415z00_22495;
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_arg4906z00_5977;
																																																												BgL_arg4906z00_5977
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												BgL_test9415z00_22495
																																																													=
																																																													CBOOL
																																																													(BGl_letzd2symzf3z21zzast_letz00
																																																													(BgL_arg4906z00_5977));
																																																											}
																																																											if (BgL_test9415z00_22495)
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_arg4834z00_5863;
																																																													obj_t
																																																														BgL_arg4835z00_5864;
																																																													BgL_arg4834z00_5863
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_cdrzd233153zd2_5860));
																																																													BgL_arg4835z00_5864
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd233153zd2_5860));
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_22504;
																																																														{
																																																															obj_t
																																																																BgL_exprz00_22506;
																																																															obj_t
																																																																BgL_bindingsz00_22505;
																																																															BgL_bindingsz00_22505
																																																																=
																																																																BgL_arg4834z00_5863;
																																																															BgL_exprz00_22506
																																																																=
																																																																BgL_arg4835z00_5864;
																																																															BgL_exprz00_1732
																																																																=
																																																																BgL_exprz00_22506;
																																																															BgL_bindingsz00_1731
																																																																=
																																																																BgL_bindingsz00_22505;
																																																															goto
																																																																BgL_tagzd2382zd2_1733;
																																																														}
																																																														BgL_auxz00_22101
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_22504);
																																																													}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													bool_t
																																																														BgL_test9416z00_22508;
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_arg4905z00_5976;
																																																														BgL_arg4905z00_5976
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														BgL_test9416z00_22508
																																																															=
																																																															CBOOL
																																																															(BGl_labelszd2symzf3z21zzast_labelsz00
																																																															(BgL_arg4905z00_5976));
																																																													}
																																																													if (BgL_test9416z00_22508)
																																																														{
																																																															BgL_letzd2funzd2_bglt
																																																																BgL_auxz00_22513;
																																																															goto
																																																																BgL_tagzd2384zd2_1735;
																																																															BgL_auxz00_22101
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_22513);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_carzd233219zd2_5867;
																																																															BgL_carzd233219zd2_5867
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd233224zd2_5868;
																																																																BgL_cdrzd233224zd2_5868
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_carzd233219zd2_5867));
																																																																if ((CAR(((obj_t) BgL_carzd233219zd2_5867)) == CNST_TABLE_REF(((long) 3))))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (PAIRP(BgL_cdrzd233224zd2_5868))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_arg4841z00_5872;
																																																																				obj_t
																																																																					BgL_arg4842z00_5873;
																																																																				obj_t
																																																																					BgL_arg4843z00_5874;
																																																																				BgL_arg4841z00_5872
																																																																					=
																																																																					CAR
																																																																					(BgL_cdrzd233224zd2_5868);
																																																																				BgL_arg4842z00_5873
																																																																					=
																																																																					CDR
																																																																					(BgL_cdrzd233224zd2_5868);
																																																																				BgL_arg4843z00_5874
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_22530;
																																																																					{
																																																																						obj_t
																																																																							BgL_argsz00_22533;
																																																																						obj_t
																																																																							BgL_bodyz00_22532;
																																																																						obj_t
																																																																							BgL_varsz00_22531;
																																																																						BgL_varsz00_22531
																																																																							=
																																																																							BgL_arg4841z00_5872;
																																																																						BgL_bodyz00_22532
																																																																							=
																																																																							BgL_arg4842z00_5873;
																																																																						BgL_argsz00_22533
																																																																							=
																																																																							BgL_arg4843z00_5874;
																																																																						BgL_argsz00_1742
																																																																							=
																																																																							BgL_argsz00_22533;
																																																																						BgL_bodyz00_1741
																																																																							=
																																																																							BgL_bodyz00_22532;
																																																																						BgL_varsz00_1740
																																																																							=
																																																																							BgL_varsz00_22531;
																																																																						goto
																																																																							BgL_tagzd2386zd2_1743;
																																																																					}
																																																																					BgL_auxz00_22101
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_22530);
																																																																				}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1777;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_22537;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1778;
																																																																						BgL_auxz00_22101
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_22537);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd233331zd2_5877;
																																																																		BgL_cdrzd233331zd2_5877
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd233336zd2_5878;
																																																																			BgL_cdrzd233336zd2_5878
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_carzd233219zd2_5867));
																																																																			if ((CAR(((obj_t) BgL_carzd233219zd2_5867)) == CNST_TABLE_REF(((long) 1))))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (PAIRP(BgL_cdrzd233336zd2_5878))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd233341zd2_5882;
																																																																							BgL_cdrzd233341zd2_5882
																																																																								=
																																																																								CDR
																																																																								(BgL_cdrzd233336zd2_5878);
																																																																							if (PAIRP(BgL_cdrzd233341zd2_5882))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd233345zd2_5884;
																																																																									obj_t
																																																																										BgL_cdrzd233346zd2_5885;
																																																																									BgL_carzd233345zd2_5884
																																																																										=
																																																																										CAR
																																																																										(BgL_cdrzd233341zd2_5882);
																																																																									BgL_cdrzd233346zd2_5885
																																																																										=
																																																																										CDR
																																																																										(BgL_cdrzd233341zd2_5882);
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd233345zd2_5884))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (PAIRP(BgL_cdrzd233346zd2_5885))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_carzd233351zd2_5888;
																																																																													BgL_carzd233351zd2_5888
																																																																														=
																																																																														CAR
																																																																														(BgL_cdrzd233346zd2_5885);
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd233351zd2_5888))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (NULLP(CDR(BgL_cdrzd233346zd2_5885)))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	bool_t
																																																																																		BgL_test9427z00_22565;
																																																																																	{
																																																																																		obj_t
																																																																																			BgL_l1423z00_5921;
																																																																																		BgL_l1423z00_5921
																																																																																			=
																																																																																			BgL_cdrzd233331zd2_5877;
																																																																																	BgL_zc3z04anonymousza34869ze3z87_5922:
																																																																																		if (NULLP(BgL_l1423z00_5921))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				BgL_test9427z00_22565
																																																																																					=
																																																																																					(
																																																																																					(bool_t)
																																																																																					1);
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				bool_t
																																																																																					BgL_test9429z00_22568;
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					bool_t
																																																																																						BgL_test9430z00_22569;
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						obj_t
																																																																																							BgL_tmpz00_22570;
																																																																																						BgL_tmpz00_22570
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_l1423z00_5921));
																																																																																						BgL_test9430z00_22569
																																																																																							=
																																																																																							PAIRP
																																																																																							(BgL_tmpz00_22570);
																																																																																					}
																																																																																					if (BgL_test9430z00_22569)
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							BgL_test9429z00_22568
																																																																																								=
																																																																																								(
																																																																																								(bool_t)
																																																																																								0);
																																																																																						}
																																																																																					else
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							BgL_test9429z00_22568
																																																																																								=
																																																																																								(
																																																																																								(bool_t)
																																																																																								1);
																																																																																						}
																																																																																				}
																																																																																				if (BgL_test9429z00_22568)
																																																																																					{
																																																																																						obj_t
																																																																																							BgL_l1423z00_22574;
																																																																																						BgL_l1423z00_22574
																																																																																							=
																																																																																							CDR
																																																																																							(
																																																																																							((obj_t) BgL_l1423z00_5921));
																																																																																						BgL_l1423z00_5921
																																																																																							=
																																																																																							BgL_l1423z00_22574;
																																																																																						goto
																																																																																							BgL_zc3z04anonymousza34869ze3z87_5922;
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						BgL_test9427z00_22565
																																																																																							=
																																																																																							(
																																																																																							(bool_t)
																																																																																							0);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																	if (BgL_test9427z00_22565)
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_arg4859z00_5904;
																																																																																			BgL_arg4859z00_5904
																																																																																				=
																																																																																				CAR
																																																																																				(BgL_cdrzd233336zd2_5878);
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_22578;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_22582;
																																																																																					obj_t
																																																																																						BgL_proc2z00_22581;
																																																																																					obj_t
																																																																																						BgL_proc1z00_22580;
																																																																																					obj_t
																																																																																						BgL_testz00_22579;
																																																																																					BgL_testz00_22579
																																																																																						=
																																																																																						BgL_arg4859z00_5904;
																																																																																					BgL_proc1z00_22580
																																																																																						=
																																																																																						BgL_carzd233345zd2_5884;
																																																																																					BgL_proc2z00_22581
																																																																																						=
																																																																																						BgL_carzd233351zd2_5888;
																																																																																					BgL_argsz00_22582
																																																																																						=
																																																																																						BgL_cdrzd233331zd2_5877;
																																																																																					BgL_argsz00_1747
																																																																																						=
																																																																																						BgL_argsz00_22582;
																																																																																					BgL_proc2z00_1746
																																																																																						=
																																																																																						BgL_proc2z00_22581;
																																																																																					BgL_proc1z00_1745
																																																																																						=
																																																																																						BgL_proc1z00_22580;
																																																																																					BgL_testz00_1744
																																																																																						=
																																																																																						BgL_testz00_22579;
																																																																																					goto
																																																																																						BgL_tagzd2387zd2_1748;
																																																																																				}
																																																																																				BgL_auxz00_22101
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_22578);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_cdrzd233376zd2_5905;
																																																																																			BgL_cdrzd233376zd2_5905
																																																																																				=
																																																																																				CDR
																																																																																				(
																																																																																				((obj_t) BgL_expz00_21));
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_cdrzd233384zd2_5906;
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					obj_t
																																																																																						BgL_pairz00_11957;
																																																																																					BgL_pairz00_11957
																																																																																						=
																																																																																						CAR
																																																																																						(
																																																																																						((obj_t) BgL_expz00_21));
																																																																																					BgL_cdrzd233384zd2_5906
																																																																																						=
																																																																																						CDR
																																																																																						(BgL_pairz00_11957);
																																																																																				}
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					obj_t
																																																																																						BgL_cdrzd233392zd2_5907;
																																																																																					BgL_cdrzd233392zd2_5907
																																																																																						=
																																																																																						CDR
																																																																																						(
																																																																																						((obj_t) BgL_cdrzd233384zd2_5906));
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						obj_t
																																																																																							BgL_carzd233399zd2_5908;
																																																																																						BgL_carzd233399zd2_5908
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd233392zd2_5907));
																																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd233399zd2_5908))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								obj_t
																																																																																									BgL_carzd233408zd2_5910;
																																																																																								{	/* Ast/sexp.scm 119 */
																																																																																									obj_t
																																																																																										BgL_pairz00_11961;
																																																																																									BgL_pairz00_11961
																																																																																										=
																																																																																										CDR
																																																																																										(
																																																																																										((obj_t) BgL_cdrzd233392zd2_5907));
																																																																																									BgL_carzd233408zd2_5910
																																																																																										=
																																																																																										CAR
																																																																																										(BgL_pairz00_11961);
																																																																																								}
																																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd233408zd2_5910))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd233376zd2_5905))
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												obj_t
																																																																																													BgL_arg4863z00_5913;
																																																																																												BgL_arg4863z00_5913
																																																																																													=
																																																																																													CAR
																																																																																													(
																																																																																													((obj_t) BgL_cdrzd233384zd2_5906));
																																																																																												{
																																																																																													BgL_nodez00_bglt
																																																																																														BgL_auxz00_22604;
																																																																																													{
																																																																																														obj_t
																																																																																															BgL_argsz00_22608;
																																																																																														obj_t
																																																																																															BgL_proc2z00_22607;
																																																																																														obj_t
																																																																																															BgL_proc1z00_22606;
																																																																																														obj_t
																																																																																															BgL_testz00_22605;
																																																																																														BgL_testz00_22605
																																																																																															=
																																																																																															BgL_arg4863z00_5913;
																																																																																														BgL_proc1z00_22606
																																																																																															=
																																																																																															BgL_carzd233399zd2_5908;
																																																																																														BgL_proc2z00_22607
																																																																																															=
																																																																																															BgL_carzd233408zd2_5910;
																																																																																														BgL_argsz00_22608
																																																																																															=
																																																																																															BgL_cdrzd233376zd2_5905;
																																																																																														BgL_argsz00_1752
																																																																																															=
																																																																																															BgL_argsz00_22608;
																																																																																														BgL_proc2z00_1751
																																																																																															=
																																																																																															BgL_proc2z00_22607;
																																																																																														BgL_proc1z00_1750
																																																																																															=
																																																																																															BgL_proc1z00_22606;
																																																																																														BgL_testz00_1749
																																																																																															=
																																																																																															BgL_testz00_22605;
																																																																																														goto
																																																																																															BgL_tagzd2388zd2_1753;
																																																																																													}
																																																																																													BgL_auxz00_22101
																																																																																														=
																																																																																														(
																																																																																														(obj_t)
																																																																																														BgL_auxz00_22604);
																																																																																												}
																																																																																											}
																																																																																										else
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																													{	/* Ast/sexp.scm 119 */
																																																																																														goto
																																																																																															BgL_tagzd2403zd2_1777;
																																																																																													}
																																																																																												else
																																																																																													{
																																																																																														BgL_nodez00_bglt
																																																																																															BgL_auxz00_22612;
																																																																																														goto
																																																																																															BgL_tagzd2404zd2_1778;
																																																																																														BgL_auxz00_22101
																																																																																															=
																																																																																															(
																																																																																															(obj_t)
																																																																																															BgL_auxz00_22612);
																																																																																													}
																																																																																											}
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												goto
																																																																																													BgL_tagzd2403zd2_1777;
																																																																																											}
																																																																																										else
																																																																																											{
																																																																																												BgL_nodez00_bglt
																																																																																													BgL_auxz00_22616;
																																																																																												goto
																																																																																													BgL_tagzd2404zd2_1778;
																																																																																												BgL_auxz00_22101
																																																																																													=
																																																																																													(
																																																																																													(obj_t)
																																																																																													BgL_auxz00_22616);
																																																																																											}
																																																																																									}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1777;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_22620;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1778;
																																																																																										BgL_auxz00_22101
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_22620);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				}
																																																																																			}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1777;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_22624;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1778;
																																																																																			BgL_auxz00_22101
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_22624);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_cdrzd233686zd2_5932;
																																																																															BgL_cdrzd233686zd2_5932
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_cdrzd233693zd2_5933;
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_pairz00_11965;
																																																																																	BgL_pairz00_11965
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_expz00_21));
																																																																																	BgL_cdrzd233693zd2_5933
																																																																																		=
																																																																																		CDR
																																																																																		(BgL_pairz00_11965);
																																																																																}
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_cdrzd233700zd2_5934;
																																																																																	BgL_cdrzd233700zd2_5934
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd233693zd2_5933));
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_carzd233706zd2_5935;
																																																																																		obj_t
																																																																																			BgL_cdrzd233707zd2_5936;
																																																																																		BgL_carzd233706zd2_5935
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd233700zd2_5934));
																																																																																		BgL_cdrzd233707zd2_5936
																																																																																			=
																																																																																			CDR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd233700zd2_5934));
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd233706zd2_5935))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_carzd233714zd2_5938;
																																																																																				BgL_carzd233714zd2_5938
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd233707zd2_5936));
																																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd233714zd2_5938))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (NULLP(CDR(((obj_t) BgL_cdrzd233707zd2_5936))))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd233686zd2_5932))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										obj_t
																																																																																											BgL_arg4878z00_5943;
																																																																																										BgL_arg4878z00_5943
																																																																																											=
																																																																																											CAR
																																																																																											(
																																																																																											((obj_t) BgL_cdrzd233693zd2_5933));
																																																																																										{
																																																																																											BgL_nodez00_bglt
																																																																																												BgL_auxz00_22651;
																																																																																											{
																																																																																												obj_t
																																																																																													BgL_argsz00_22655;
																																																																																												obj_t
																																																																																													BgL_proc2z00_22654;
																																																																																												obj_t
																																																																																													BgL_proc1z00_22653;
																																																																																												obj_t
																																																																																													BgL_testz00_22652;
																																																																																												BgL_testz00_22652
																																																																																													=
																																																																																													BgL_arg4878z00_5943;
																																																																																												BgL_proc1z00_22653
																																																																																													=
																																																																																													BgL_carzd233706zd2_5935;
																																																																																												BgL_proc2z00_22654
																																																																																													=
																																																																																													BgL_carzd233714zd2_5938;
																																																																																												BgL_argsz00_22655
																																																																																													=
																																																																																													BgL_cdrzd233686zd2_5932;
																																																																																												BgL_argsz00_1752
																																																																																													=
																																																																																													BgL_argsz00_22655;
																																																																																												BgL_proc2z00_1751
																																																																																													=
																																																																																													BgL_proc2z00_22654;
																																																																																												BgL_proc1z00_1750
																																																																																													=
																																																																																													BgL_proc1z00_22653;
																																																																																												BgL_testz00_1749
																																																																																													=
																																																																																													BgL_testz00_22652;
																																																																																												goto
																																																																																													BgL_tagzd2388zd2_1753;
																																																																																											}
																																																																																											BgL_auxz00_22101
																																																																																												=
																																																																																												(
																																																																																												(obj_t)
																																																																																												BgL_auxz00_22651);
																																																																																										}
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												goto
																																																																																													BgL_tagzd2403zd2_1777;
																																																																																											}
																																																																																										else
																																																																																											{
																																																																																												BgL_nodez00_bglt
																																																																																													BgL_auxz00_22659;
																																																																																												goto
																																																																																													BgL_tagzd2404zd2_1778;
																																																																																												BgL_auxz00_22101
																																																																																													=
																																																																																													(
																																																																																													(obj_t)
																																																																																													BgL_auxz00_22659);
																																																																																											}
																																																																																									}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1777;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_22663;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1778;
																																																																																										BgL_auxz00_22101
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_22663);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1777;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_22667;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1778;
																																																																																								BgL_auxz00_22101
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_22667);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1777;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_22671;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1778;
																																																																																						BgL_auxz00_22101
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_22671);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																}
																																																																															}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1777;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_22675;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1778;
																																																																															BgL_auxz00_22101
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_22675);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd234047zd2_5951;
																																																																											BgL_cdrzd234047zd2_5951
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_cdrzd234053zd2_5952;
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_pairz00_11975;
																																																																													BgL_pairz00_11975
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													BgL_cdrzd234053zd2_5952
																																																																														=
																																																																														CDR
																																																																														(BgL_pairz00_11975);
																																																																												}
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd234059zd2_5953;
																																																																													BgL_cdrzd234059zd2_5953
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd234053zd2_5952));
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_carzd234064zd2_5954;
																																																																														obj_t
																																																																															BgL_cdrzd234065zd2_5955;
																																																																														BgL_carzd234064zd2_5954
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd234059zd2_5953));
																																																																														BgL_cdrzd234065zd2_5955
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd234059zd2_5953));
																																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd234064zd2_5954))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (PAIRP(BgL_cdrzd234065zd2_5955))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_carzd234070zd2_5958;
																																																																																		BgL_carzd234070zd2_5958
																																																																																			=
																																																																																			CAR
																																																																																			(BgL_cdrzd234065zd2_5955);
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd234070zd2_5958))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (NULLP(CDR(BgL_cdrzd234065zd2_5955)))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd234047zd2_5951))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								obj_t
																																																																																									BgL_arg4892z00_5963;
																																																																																								BgL_arg4892z00_5963
																																																																																									=
																																																																																									CAR
																																																																																									(
																																																																																									((obj_t) BgL_cdrzd234053zd2_5952));
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_22702;
																																																																																									{
																																																																																										obj_t
																																																																																											BgL_argsz00_22706;
																																																																																										obj_t
																																																																																											BgL_proc2z00_22705;
																																																																																										obj_t
																																																																																											BgL_proc1z00_22704;
																																																																																										obj_t
																																																																																											BgL_testz00_22703;
																																																																																										BgL_testz00_22703
																																																																																											=
																																																																																											BgL_arg4892z00_5963;
																																																																																										BgL_proc1z00_22704
																																																																																											=
																																																																																											BgL_carzd234064zd2_5954;
																																																																																										BgL_proc2z00_22705
																																																																																											=
																																																																																											BgL_carzd234070zd2_5958;
																																																																																										BgL_argsz00_22706
																																																																																											=
																																																																																											BgL_cdrzd234047zd2_5951;
																																																																																										BgL_argsz00_1752
																																																																																											=
																																																																																											BgL_argsz00_22706;
																																																																																										BgL_proc2z00_1751
																																																																																											=
																																																																																											BgL_proc2z00_22705;
																																																																																										BgL_proc1z00_1750
																																																																																											=
																																																																																											BgL_proc1z00_22704;
																																																																																										BgL_testz00_1749
																																																																																											=
																																																																																											BgL_testz00_22703;
																																																																																										goto
																																																																																											BgL_tagzd2388zd2_1753;
																																																																																									}
																																																																																									BgL_auxz00_22101
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_22702);
																																																																																								}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1777;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_22710;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1778;
																																																																																										BgL_auxz00_22101
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_22710);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1777;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_22714;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1778;
																																																																																								BgL_auxz00_22101
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_22714);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1777;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_22718;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1778;
																																																																																						BgL_auxz00_22101
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_22718);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1777;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_22722;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1778;
																																																																																				BgL_auxz00_22101
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_22722);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1777;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_22726;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1778;
																																																																																		BgL_auxz00_22101
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_22726);
																																																																																	}
																																																																															}
																																																																													}
																																																																												}
																																																																											}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1777;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_22730;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1778;
																																																																											BgL_auxz00_22101
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_22730);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1777;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_22734;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1778;
																																																																									BgL_auxz00_22101
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_22734);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1777;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_22738;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1778;
																																																																							BgL_auxz00_22101
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_22738);
																																																																						}
																																																																				}
																																																																		}
																																																																	}
																																																															}
																																																														}
																																																												}
																																																										}
																																																									}
																																																							}
																																																					}
																																																			}
																																																	}
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_cdrzd234608zd2_6127;
																																															BgL_cdrzd234608zd2_6127
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															if ((BgL_carzd231543zd2_5850 == CNST_TABLE_REF(((long) 17))))
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg5008z00_6129;
																																																	obj_t
																																																		BgL_arg5009z00_6130;
																																																	BgL_arg5008z00_6129
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd234608zd2_6127));
																																																	BgL_arg5009z00_6130
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd234608zd2_6127));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_22749;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_22751;
																																																			obj_t
																																																				BgL_bindingsz00_22750;
																																																			BgL_bindingsz00_22750
																																																				=
																																																				BgL_arg5008z00_6129;
																																																			BgL_exprz00_22751
																																																				=
																																																				BgL_arg5009z00_6130;
																																																			BgL_exprz00_1732
																																																				=
																																																				BgL_exprz00_22751;
																																																			BgL_bindingsz00_1731
																																																				=
																																																				BgL_bindingsz00_22750;
																																																			goto
																																																				BgL_tagzd2382zd2_1733;
																																																		}
																																																		BgL_auxz00_22101
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_22749);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd231543zd2_5850)))
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg5011z00_6132;
																																																			obj_t
																																																				BgL_arg5012z00_6133;
																																																			BgL_arg5011z00_6132
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd234608zd2_6127));
																																																			BgL_arg5012z00_6133
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd234608zd2_6127));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_22760;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_22762;
																																																					obj_t
																																																						BgL_bindingsz00_22761;
																																																					BgL_bindingsz00_22761
																																																						=
																																																						BgL_arg5011z00_6132;
																																																					BgL_exprz00_22762
																																																						=
																																																						BgL_arg5012z00_6133;
																																																					BgL_exprz00_1732
																																																						=
																																																						BgL_exprz00_22762;
																																																					BgL_bindingsz00_1731
																																																						=
																																																						BgL_bindingsz00_22761;
																																																					goto
																																																						BgL_tagzd2382zd2_1733;
																																																				}
																																																				BgL_auxz00_22101
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_22760);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if ((BgL_carzd231543zd2_5850 == CNST_TABLE_REF(((long) 18))))
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_arg5014z00_6135;
																																																					obj_t
																																																						BgL_arg5015z00_6136;
																																																					BgL_arg5014z00_6135
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd234608zd2_6127));
																																																					BgL_arg5015z00_6136
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd234608zd2_6127));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_22771;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_22773;
																																																							obj_t
																																																								BgL_bindingsz00_22772;
																																																							BgL_bindingsz00_22772
																																																								=
																																																								BgL_arg5014z00_6135;
																																																							BgL_exprz00_22773
																																																								=
																																																								BgL_arg5015z00_6136;
																																																							BgL_exprz00_1732
																																																								=
																																																								BgL_exprz00_22773;
																																																							BgL_bindingsz00_1731
																																																								=
																																																								BgL_bindingsz00_22772;
																																																							goto
																																																								BgL_tagzd2382zd2_1733;
																																																						}
																																																						BgL_auxz00_22101
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_22771);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_22780;
																																																							goto
																																																								BgL_tagzd2383zd2_1734;
																																																							BgL_auxz00_22101
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_22780);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_carzd234645zd2_6139;
																																																							BgL_carzd234645zd2_6139
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							if ((BgL_carzd234645zd2_6139 == CNST_TABLE_REF(((long) 19))))
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_22787;
																																																									goto
																																																										BgL_tagzd2384zd2_1735;
																																																									BgL_auxz00_22101
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_22787);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd234645zd2_6139)))
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_22792;
																																																											goto
																																																												BgL_tagzd2384zd2_1735;
																																																											BgL_auxz00_22101
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_22792);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_22799;
																																																													goto
																																																														BgL_tagzd2389zd2_1754;
																																																													BgL_auxz00_22101
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_22799);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_22806;
																																																															goto
																																																																BgL_tagzd2390zd2_1755;
																																																															BgL_auxz00_22101
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_22806);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd234725zd2_6146;
																																																															BgL_cdrzd234725zd2_6146
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_arg5026z00_6149;
																																																																	obj_t
																																																																		BgL_arg5027z00_6150;
																																																																	BgL_arg5026z00_6149
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd234725zd2_6146));
																																																																	BgL_arg5027z00_6150
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd234725zd2_6146));
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_22819;
																																																																		{
																																																																			obj_t
																																																																				BgL_restz00_22821;
																																																																			obj_t
																																																																				BgL_effectz00_22820;
																																																																			BgL_effectz00_22820
																																																																				=
																																																																				BgL_arg5026z00_6149;
																																																																			BgL_restz00_22821
																																																																				=
																																																																				BgL_arg5027z00_6150;
																																																																			BgL_restz00_1757
																																																																				=
																																																																				BgL_restz00_22821;
																																																																			BgL_effectz00_1756
																																																																				=
																																																																				BgL_effectz00_22820;
																																																																			goto
																																																																				BgL_tagzd2391zd2_1758;
																																																																		}
																																																																		BgL_auxz00_22101
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_22819);
																																																																	}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_22828;
																																																																			goto
																																																																				BgL_tagzd2392zd2_1759;
																																																																			BgL_auxz00_22101
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_22828);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_22835;
																																																																					goto
																																																																						BgL_tagzd2393zd2_1760;
																																																																					BgL_auxz00_22101
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_22835);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_arg5034z00_6158;
																																																																							obj_t
																																																																								BgL_arg5035z00_6159;
																																																																							BgL_arg5034z00_6158
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd234725zd2_6146));
																																																																							BgL_arg5035z00_6159
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd234725zd2_6146));
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_22846;
																																																																								{
																																																																									obj_t
																																																																										BgL_restz00_22848;
																																																																									obj_t
																																																																										BgL_effectz00_22847;
																																																																									BgL_effectz00_22847
																																																																										=
																																																																										BgL_arg5034z00_6158;
																																																																									BgL_restz00_22848
																																																																										=
																																																																										BgL_arg5035z00_6159;
																																																																									BgL_restz00_1762
																																																																										=
																																																																										BgL_restz00_22848;
																																																																									BgL_effectz00_1761
																																																																										=
																																																																										BgL_effectz00_22847;
																																																																									goto
																																																																										BgL_tagzd2394zd2_1763;
																																																																								}
																																																																								BgL_auxz00_22101
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_22846);
																																																																							}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_22855;
																																																																									goto
																																																																										BgL_tagzd2395zd2_1764;
																																																																									BgL_auxz00_22101
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_22855);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_22862;
																																																																											goto
																																																																												BgL_tagzd2396zd2_1765;
																																																																											BgL_auxz00_22101
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_22862);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																												{
																																																																													BgL_letzd2funzd2_bglt
																																																																														BgL_auxz00_22869;
																																																																													goto
																																																																														BgL_tagzd2397zd2_1766;
																																																																													BgL_auxz00_22101
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_22869);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																														{
																																																																															BgL_jumpzd2exzd2itz00_bglt
																																																																																BgL_auxz00_22876;
																																																																															goto
																																																																																BgL_tagzd2398zd2_1767;
																																																																															BgL_auxz00_22101
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_22876);
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_cdrzd234802zd2_6168;
																																																																															BgL_cdrzd234802zd2_6168
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_arg5046z00_6171;
																																																																																	obj_t
																																																																																		BgL_arg5047z00_6172;
																																																																																	BgL_arg5046z00_6171
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd234802zd2_6168));
																																																																																	BgL_arg5047z00_6172
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd234802zd2_6168));
																																																																																	{	/* Ast/sexp.scm 552 */
																																																																																		obj_t
																																																																																			BgL_arg6965z00_12014;
																																																																																		BgL_arg6965z00_12014
																																																																																			=
																																																																																			BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																			(BgL_expz00_21,
																																																																																			BgL_locz00_23);
																																																																																		BgL_auxz00_22101
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																			(BgL_expz00_21,
																																																																																				BgL_arg5046z00_6171,
																																																																																				CNST_TABLE_REF
																																																																																				(((long) 4)), BgL_arg5047z00_6172, BgL_stackz00_22, BgL_arg6965z00_12014, BgL_sitez00_24));
																																																																																}}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1777;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_22895;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1778;
																																																																																			BgL_auxz00_22101
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_22895);
																																																																																		}
																																																																																}
																																																																														}
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																	else
																																		{	/* Ast/sexp.scm 119 */
																																			obj_t
																																				BgL_carzd234827zd2_6189;
																																			BgL_carzd234827zd2_6189
																																				=
																																				CAR((
																																					(obj_t)
																																					BgL_expz00_21));
																																			if (
																																				(BgL_carzd234827zd2_6189
																																					==
																																					CNST_TABLE_REF
																																					(((long) 1))))
																																				{
																																					BgL_nodez00_bglt
																																						BgL_auxz00_22902;
																																					goto
																																						BgL_tagzd2377zd2_1722;
																																					BgL_auxz00_22101
																																						=
																																						(
																																						(obj_t)
																																						BgL_auxz00_22902);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					if (
																																						(BgL_carzd234827zd2_6189
																																							==
																																							BGl_za2ifza2z00zzast_sexpz00))
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_22906;
																																							goto
																																								BgL_tagzd2377zd2_1722;
																																							BgL_auxz00_22101
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_22906);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 7))))
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_22913;
																																									goto
																																										BgL_tagzd2379zd2_1726;
																																									BgL_auxz00_22101
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_22913);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_22920;
																																											goto
																																												BgL_tagzd2380zd2_1727;
																																											BgL_auxz00_22101
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_22920);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_carzd234896zd2_6196;
																																											BgL_carzd234896zd2_6196
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_expz00_21));
																																											if (PAIRP(BgL_carzd234896zd2_6196))
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_carzd234899zd2_6198;
																																													obj_t
																																														BgL_cdrzd234900zd2_6199;
																																													BgL_carzd234899zd2_6198
																																														=
																																														CAR
																																														(BgL_carzd234896zd2_6196);
																																													BgL_cdrzd234900zd2_6199
																																														=
																																														CDR
																																														(BgL_carzd234896zd2_6196);
																																													{

																																														if ((BgL_carzd234899zd2_6198 == CNST_TABLE_REF(((long) 17))))
																																															{	/* Ast/sexp.scm 119 */
																																															BgL_kapzd234901zd2_6200:
																																																if (PAIRP(BgL_cdrzd234900zd2_6199))
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_cdrzd234904zd2_6325;
																																																		BgL_cdrzd234904zd2_6325
																																																			=
																																																			CDR
																																																			(BgL_cdrzd234900zd2_6199);
																																																		if (PAIRP(BgL_cdrzd234904zd2_6325))
																																																			{	/* Ast/sexp.scm 119 */
																																																				if (NULLP(CDR(BgL_cdrzd234904zd2_6325)))
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg5154z00_6329;
																																																						obj_t
																																																							BgL_arg5155z00_6330;
																																																						BgL_arg5154z00_6329
																																																							=
																																																							CAR
																																																							(BgL_cdrzd234904zd2_6325);
																																																						BgL_arg5155z00_6330
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_22942;
																																																							{
																																																								obj_t
																																																									BgL_argsz00_22944;
																																																								obj_t
																																																									BgL_bodyz00_22943;
																																																								BgL_bodyz00_22943
																																																									=
																																																									BgL_arg5154z00_6329;
																																																								BgL_argsz00_22944
																																																									=
																																																									BgL_arg5155z00_6330;
																																																								BgL_argsz00_1729
																																																									=
																																																									BgL_argsz00_22944;
																																																								BgL_bodyz00_1728
																																																									=
																																																									BgL_bodyz00_22943;
																																																								goto
																																																									BgL_tagzd2381zd2_1730;
																																																							}
																																																							BgL_auxz00_22101
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_22942);
																																																						}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd234928zd2_6331;
																																																						BgL_cdrzd234928zd2_6331
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{	/* Ast/sexp.scm 119 */
																																																							bool_t
																																																								BgL_test9487z00_22948;
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg5224z00_6442;
																																																								BgL_arg5224z00_6442
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test9487z00_22948
																																																									=
																																																									CBOOL
																																																									(BGl_letzd2symzf3z21zzast_letz00
																																																									(BgL_arg5224z00_6442));
																																																							}
																																																							if (BgL_test9487z00_22948)
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_arg5158z00_6334;
																																																									obj_t
																																																										BgL_arg5159z00_6335;
																																																									BgL_arg5158z00_6334
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd234928zd2_6331));
																																																									BgL_arg5159z00_6335
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd234928zd2_6331));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_22957;
																																																										{
																																																											obj_t
																																																												BgL_exprz00_22959;
																																																											obj_t
																																																												BgL_bindingsz00_22958;
																																																											BgL_bindingsz00_22958
																																																												=
																																																												BgL_arg5158z00_6334;
																																																											BgL_exprz00_22959
																																																												=
																																																												BgL_arg5159z00_6335;
																																																											BgL_exprz00_1732
																																																												=
																																																												BgL_exprz00_22959;
																																																											BgL_bindingsz00_1731
																																																												=
																																																												BgL_bindingsz00_22958;
																																																											goto
																																																												BgL_tagzd2382zd2_1733;
																																																										}
																																																										BgL_auxz00_22101
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_22957);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									bool_t
																																																										BgL_test9488z00_22961;
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg5223z00_6441;
																																																										BgL_arg5223z00_6441
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_test9488z00_22961
																																																											=
																																																											CBOOL
																																																											(BGl_labelszd2symzf3z21zzast_labelsz00
																																																											(BgL_arg5223z00_6441));
																																																									}
																																																									if (BgL_test9488z00_22961)
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_22966;
																																																											goto
																																																												BgL_tagzd2384zd2_1735;
																																																											BgL_auxz00_22101
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_22966);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_carzd234995zd2_6338;
																																																											BgL_carzd234995zd2_6338
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd235000zd2_6339;
																																																												BgL_cdrzd235000zd2_6339
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_carzd234995zd2_6338));
																																																												if ((CAR(((obj_t) BgL_carzd234995zd2_6338)) == CNST_TABLE_REF(((long) 3))))
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_arg5164z00_6342;
																																																														obj_t
																																																															BgL_arg5165z00_6343;
																																																														obj_t
																																																															BgL_arg5166z00_6344;
																																																														BgL_arg5164z00_6342
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd235000zd2_6339));
																																																														BgL_arg5165z00_6343
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd235000zd2_6339));
																																																														BgL_arg5166z00_6344
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_22983;
																																																															{
																																																																obj_t
																																																																	BgL_argsz00_22986;
																																																																obj_t
																																																																	BgL_bodyz00_22985;
																																																																obj_t
																																																																	BgL_varsz00_22984;
																																																																BgL_varsz00_22984
																																																																	=
																																																																	BgL_arg5164z00_6342;
																																																																BgL_bodyz00_22985
																																																																	=
																																																																	BgL_arg5165z00_6343;
																																																																BgL_argsz00_22986
																																																																	=
																																																																	BgL_arg5166z00_6344;
																																																																BgL_argsz00_1742
																																																																	=
																																																																	BgL_argsz00_22986;
																																																																BgL_bodyz00_1741
																																																																	=
																																																																	BgL_bodyz00_22985;
																																																																BgL_varsz00_1740
																																																																	=
																																																																	BgL_varsz00_22984;
																																																																goto
																																																																	BgL_tagzd2386zd2_1743;
																																																															}
																																																															BgL_auxz00_22101
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_22983);
																																																														}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd235023zd2_6346;
																																																														BgL_cdrzd235023zd2_6346
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd235029zd2_6347;
																																																															BgL_cdrzd235029zd2_6347
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_carzd234995zd2_6338));
																																																															if ((CAR(((obj_t) BgL_carzd234995zd2_6338)) == CNST_TABLE_REF(((long) 1))))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd235035zd2_6350;
																																																																	BgL_cdrzd235035zd2_6350
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd235029zd2_6347));
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_carzd235040zd2_6351;
																																																																		obj_t
																																																																			BgL_cdrzd235041zd2_6352;
																																																																		BgL_carzd235040zd2_6351
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd235035zd2_6350));
																																																																		BgL_cdrzd235041zd2_6352
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd235035zd2_6350));
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd235040zd2_6351))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (PAIRP(BgL_cdrzd235041zd2_6352))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_carzd235048zd2_6355;
																																																																						BgL_carzd235048zd2_6355
																																																																							=
																																																																							CAR
																																																																							(BgL_cdrzd235041zd2_6352);
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd235048zd2_6355))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (NULLP(CDR(BgL_cdrzd235041zd2_6352)))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										bool_t
																																																																											BgL_test9495z00_23013;
																																																																										{
																																																																											obj_t
																																																																												BgL_l1426z00_6388;
																																																																											BgL_l1426z00_6388
																																																																												=
																																																																												BgL_cdrzd235023zd2_6346;
																																																																										BgL_zc3z04anonymousza35189ze3z87_6389:
																																																																											if (NULLP(BgL_l1426z00_6388))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													BgL_test9495z00_23013
																																																																														=
																																																																														(
																																																																														(bool_t)
																																																																														1);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													bool_t
																																																																														BgL_test9497z00_23016;
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														bool_t
																																																																															BgL_test9498z00_23017;
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_tmpz00_23018;
																																																																															BgL_tmpz00_23018
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_l1426z00_6388));
																																																																															BgL_test9498z00_23017
																																																																																=
																																																																																PAIRP
																																																																																(BgL_tmpz00_23018);
																																																																														}
																																																																														if (BgL_test9498z00_23017)
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																BgL_test9497z00_23016
																																																																																	=
																																																																																	(
																																																																																	(bool_t)
																																																																																	0);
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																BgL_test9497z00_23016
																																																																																	=
																																																																																	(
																																																																																	(bool_t)
																																																																																	1);
																																																																															}
																																																																													}
																																																																													if (BgL_test9497z00_23016)
																																																																														{
																																																																															obj_t
																																																																																BgL_l1426z00_23022;
																																																																															BgL_l1426z00_23022
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_l1426z00_6388));
																																																																															BgL_l1426z00_6388
																																																																																=
																																																																																BgL_l1426z00_23022;
																																																																															goto
																																																																																BgL_zc3z04anonymousza35189ze3z87_6389;
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															BgL_test9495z00_23013
																																																																																=
																																																																																(
																																																																																(bool_t)
																																																																																0);
																																																																														}
																																																																												}
																																																																										}
																																																																										if (BgL_test9495z00_23013)
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_arg5179z00_6371;
																																																																												BgL_arg5179z00_6371
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd235029zd2_6347));
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_23027;
																																																																													{
																																																																														obj_t
																																																																															BgL_argsz00_23031;
																																																																														obj_t
																																																																															BgL_proc2z00_23030;
																																																																														obj_t
																																																																															BgL_proc1z00_23029;
																																																																														obj_t
																																																																															BgL_testz00_23028;
																																																																														BgL_testz00_23028
																																																																															=
																																																																															BgL_arg5179z00_6371;
																																																																														BgL_proc1z00_23029
																																																																															=
																																																																															BgL_carzd235040zd2_6351;
																																																																														BgL_proc2z00_23030
																																																																															=
																																																																															BgL_carzd235048zd2_6355;
																																																																														BgL_argsz00_23031
																																																																															=
																																																																															BgL_cdrzd235023zd2_6346;
																																																																														BgL_argsz00_1747
																																																																															=
																																																																															BgL_argsz00_23031;
																																																																														BgL_proc2z00_1746
																																																																															=
																																																																															BgL_proc2z00_23030;
																																																																														BgL_proc1z00_1745
																																																																															=
																																																																															BgL_proc1z00_23029;
																																																																														BgL_testz00_1744
																																																																															=
																																																																															BgL_testz00_23028;
																																																																														goto
																																																																															BgL_tagzd2387zd2_1748;
																																																																													}
																																																																													BgL_auxz00_22101
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_23027);
																																																																												}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_cdrzd235072zd2_6372;
																																																																												BgL_cdrzd235072zd2_6372
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd235079zd2_6373;
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_pairz00_12058;
																																																																														BgL_pairz00_12058
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_expz00_21));
																																																																														BgL_cdrzd235079zd2_6373
																																																																															=
																																																																															CDR
																																																																															(BgL_pairz00_12058);
																																																																													}
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_cdrzd235086zd2_6374;
																																																																														BgL_cdrzd235086zd2_6374
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd235079zd2_6373));
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_carzd235092zd2_6375;
																																																																															BgL_carzd235092zd2_6375
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd235086zd2_6374));
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd235092zd2_6375))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_carzd235099zd2_6377;
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_pairz00_12062;
																																																																																		BgL_pairz00_12062
																																																																																			=
																																																																																			CDR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd235086zd2_6374));
																																																																																		BgL_carzd235099zd2_6377
																																																																																			=
																																																																																			CAR
																																																																																			(BgL_pairz00_12062);
																																																																																	}
																																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd235099zd2_6377))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd235072zd2_6372))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					obj_t
																																																																																						BgL_arg5183z00_6380;
																																																																																					BgL_arg5183z00_6380
																																																																																						=
																																																																																						CAR
																																																																																						(
																																																																																						((obj_t) BgL_cdrzd235079zd2_6373));
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_23053;
																																																																																						{
																																																																																							obj_t
																																																																																								BgL_argsz00_23057;
																																																																																							obj_t
																																																																																								BgL_proc2z00_23056;
																																																																																							obj_t
																																																																																								BgL_proc1z00_23055;
																																																																																							obj_t
																																																																																								BgL_testz00_23054;
																																																																																							BgL_testz00_23054
																																																																																								=
																																																																																								BgL_arg5183z00_6380;
																																																																																							BgL_proc1z00_23055
																																																																																								=
																																																																																								BgL_carzd235092zd2_6375;
																																																																																							BgL_proc2z00_23056
																																																																																								=
																																																																																								BgL_carzd235099zd2_6377;
																																																																																							BgL_argsz00_23057
																																																																																								=
																																																																																								BgL_cdrzd235072zd2_6372;
																																																																																							BgL_argsz00_1752
																																																																																								=
																																																																																								BgL_argsz00_23057;
																																																																																							BgL_proc2z00_1751
																																																																																								=
																																																																																								BgL_proc2z00_23056;
																																																																																							BgL_proc1z00_1750
																																																																																								=
																																																																																								BgL_proc1z00_23055;
																																																																																							BgL_testz00_1749
																																																																																								=
																																																																																								BgL_testz00_23054;
																																																																																							goto
																																																																																								BgL_tagzd2388zd2_1753;
																																																																																						}
																																																																																						BgL_auxz00_22101
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_23053);
																																																																																					}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							goto
																																																																																								BgL_tagzd2403zd2_1777;
																																																																																						}
																																																																																					else
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_23061;
																																																																																							goto
																																																																																								BgL_tagzd2404zd2_1778;
																																																																																							BgL_auxz00_22101
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_23061);
																																																																																						}
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1777;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_23065;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1778;
																																																																																					BgL_auxz00_22101
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_23065);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1777;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_23069;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1778;
																																																																																			BgL_auxz00_22101
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_23069);
																																																																																		}
																																																																																}
																																																																														}
																																																																													}
																																																																												}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1777;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_23073;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1778;
																																																																												BgL_auxz00_22101
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_23073);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd235375zd2_6399;
																																																																								BgL_cdrzd235375zd2_6399
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd235381zd2_6400;
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_pairz00_12066;
																																																																										BgL_pairz00_12066
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										BgL_cdrzd235381zd2_6400
																																																																											=
																																																																											CDR
																																																																											(BgL_pairz00_12066);
																																																																									}
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd235387zd2_6401;
																																																																										BgL_cdrzd235387zd2_6401
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd235381zd2_6400));
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd235392zd2_6402;
																																																																											obj_t
																																																																												BgL_cdrzd235393zd2_6403;
																																																																											BgL_carzd235392zd2_6402
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd235387zd2_6401));
																																																																											BgL_cdrzd235393zd2_6403
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd235387zd2_6401));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd235392zd2_6402))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_carzd235398zd2_6405;
																																																																													BgL_carzd235398zd2_6405
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd235393zd2_6403));
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd235398zd2_6405))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (NULLP(CDR(((obj_t) BgL_cdrzd235393zd2_6403))))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd235375zd2_6399))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_arg5198z00_6410;
																																																																																			BgL_arg5198z00_6410
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd235381zd2_6400));
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_23100;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_23104;
																																																																																					obj_t
																																																																																						BgL_proc2z00_23103;
																																																																																					obj_t
																																																																																						BgL_proc1z00_23102;
																																																																																					obj_t
																																																																																						BgL_testz00_23101;
																																																																																					BgL_testz00_23101
																																																																																						=
																																																																																						BgL_arg5198z00_6410;
																																																																																					BgL_proc1z00_23102
																																																																																						=
																																																																																						BgL_carzd235392zd2_6402;
																																																																																					BgL_proc2z00_23103
																																																																																						=
																																																																																						BgL_carzd235398zd2_6405;
																																																																																					BgL_argsz00_23104
																																																																																						=
																																																																																						BgL_cdrzd235375zd2_6399;
																																																																																					BgL_argsz00_1752
																																																																																						=
																																																																																						BgL_argsz00_23104;
																																																																																					BgL_proc2z00_1751
																																																																																						=
																																																																																						BgL_proc2z00_23103;
																																																																																					BgL_proc1z00_1750
																																																																																						=
																																																																																						BgL_proc1z00_23102;
																																																																																					BgL_testz00_1749
																																																																																						=
																																																																																						BgL_testz00_23101;
																																																																																					goto
																																																																																						BgL_tagzd2388zd2_1753;
																																																																																				}
																																																																																				BgL_auxz00_22101
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_23100);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1777;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_23108;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1778;
																																																																																					BgL_auxz00_22101
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_23108);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1777;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_23112;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1778;
																																																																																			BgL_auxz00_22101
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_23112);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1777;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_23116;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1778;
																																																																																	BgL_auxz00_22101
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_23116);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1777;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_23120;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1778;
																																																																															BgL_auxz00_22101
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_23120);
																																																																														}
																																																																												}
																																																																										}
																																																																									}
																																																																								}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1777;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_23124;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1778;
																																																																								BgL_auxz00_22101
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_23124);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd235731zd2_6418;
																																																																				BgL_cdrzd235731zd2_6418
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd235738zd2_6419;
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_pairz00_12076;
																																																																						BgL_pairz00_12076
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						BgL_cdrzd235738zd2_6419
																																																																							=
																																																																							CDR
																																																																							(BgL_pairz00_12076);
																																																																					}
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd235745zd2_6420;
																																																																						BgL_cdrzd235745zd2_6420
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd235738zd2_6419));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd235751zd2_6421;
																																																																							obj_t
																																																																								BgL_cdrzd235752zd2_6422;
																																																																							BgL_carzd235751zd2_6421
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd235745zd2_6420));
																																																																							BgL_cdrzd235752zd2_6422
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd235745zd2_6420));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd235751zd2_6421))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (PAIRP(BgL_cdrzd235752zd2_6422))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd235759zd2_6425;
																																																																											BgL_carzd235759zd2_6425
																																																																												=
																																																																												CAR
																																																																												(BgL_cdrzd235752zd2_6422);
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd235759zd2_6425))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (NULLP(CDR(BgL_cdrzd235752zd2_6422)))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd235731zd2_6418))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_arg5212z00_6430;
																																																																																	BgL_arg5212z00_6430
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd235738zd2_6419));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_23151;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_23155;
																																																																																			obj_t
																																																																																				BgL_proc2z00_23154;
																																																																																			obj_t
																																																																																				BgL_proc1z00_23153;
																																																																																			obj_t
																																																																																				BgL_testz00_23152;
																																																																																			BgL_testz00_23152
																																																																																				=
																																																																																				BgL_arg5212z00_6430;
																																																																																			BgL_proc1z00_23153
																																																																																				=
																																																																																				BgL_carzd235751zd2_6421;
																																																																																			BgL_proc2z00_23154
																																																																																				=
																																																																																				BgL_carzd235759zd2_6425;
																																																																																			BgL_argsz00_23155
																																																																																				=
																																																																																				BgL_cdrzd235731zd2_6418;
																																																																																			BgL_argsz00_1752
																																																																																				=
																																																																																				BgL_argsz00_23155;
																																																																																			BgL_proc2z00_1751
																																																																																				=
																																																																																				BgL_proc2z00_23154;
																																																																																			BgL_proc1z00_1750
																																																																																				=
																																																																																				BgL_proc1z00_23153;
																																																																																			BgL_testz00_1749
																																																																																				=
																																																																																				BgL_testz00_23152;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1753;
																																																																																		}
																																																																																		BgL_auxz00_22101
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_23151);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1777;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_23159;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1778;
																																																																																			BgL_auxz00_22101
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_23159);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1777;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_23163;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1778;
																																																																																	BgL_auxz00_22101
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_23163);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1777;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_23167;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1778;
																																																																															BgL_auxz00_22101
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_23167);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1777;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_23171;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1778;
																																																																													BgL_auxz00_22101
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_23171);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1777;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_23175;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1778;
																																																																											BgL_auxz00_22101
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_23175);
																																																																										}
																																																																								}
																																																																						}
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1777;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_23179;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1778;
																																																																			BgL_auxz00_22101
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_23179);
																																																																		}
																																																																}
																																																														}
																																																													}
																																																											}
																																																										}
																																																								}
																																																						}
																																																					}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd236152zd2_6444;
																																																				BgL_cdrzd236152zd2_6444
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 119 */
																																																					bool_t
																																																						BgL_test9526z00_23183;
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg5240z00_6461;
																																																						BgL_arg5240z00_6461
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test9526z00_23183
																																																							=
																																																							CBOOL
																																																							(BGl_letzd2symzf3z21zzast_letz00
																																																							(BgL_arg5240z00_6461));
																																																					}
																																																					if (BgL_test9526z00_23183)
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_arg5228z00_6447;
																																																							obj_t
																																																								BgL_arg5229z00_6448;
																																																							BgL_arg5228z00_6447
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd236152zd2_6444));
																																																							BgL_arg5229z00_6448
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd236152zd2_6444));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_23192;
																																																								{
																																																									obj_t
																																																										BgL_exprz00_23194;
																																																									obj_t
																																																										BgL_bindingsz00_23193;
																																																									BgL_bindingsz00_23193
																																																										=
																																																										BgL_arg5228z00_6447;
																																																									BgL_exprz00_23194
																																																										=
																																																										BgL_arg5229z00_6448;
																																																									BgL_exprz00_1732
																																																										=
																																																										BgL_exprz00_23194;
																																																									BgL_bindingsz00_1731
																																																										=
																																																										BgL_bindingsz00_23193;
																																																									goto
																																																										BgL_tagzd2382zd2_1733;
																																																								}
																																																								BgL_auxz00_22101
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_23192);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							bool_t
																																																								BgL_test9527z00_23196;
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg5239z00_6460;
																																																								BgL_arg5239z00_6460
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test9527z00_23196
																																																									=
																																																									CBOOL
																																																									(BGl_labelszd2symzf3z21zzast_labelsz00
																																																									(BgL_arg5239z00_6460));
																																																							}
																																																							if (BgL_test9527z00_23196)
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_23201;
																																																									goto
																																																										BgL_tagzd2384zd2_1735;
																																																									BgL_auxz00_22101
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_23201);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_carzd236218zd2_6451;
																																																									BgL_carzd236218zd2_6451
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd236223zd2_6452;
																																																										BgL_cdrzd236223zd2_6452
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_carzd236218zd2_6451));
																																																										if ((CAR(((obj_t) BgL_carzd236218zd2_6451)) == CNST_TABLE_REF(((long) 3))))
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_arg5234z00_6455;
																																																												obj_t
																																																													BgL_arg5235z00_6456;
																																																												obj_t
																																																													BgL_arg5236z00_6457;
																																																												BgL_arg5234z00_6455
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd236223zd2_6452));
																																																												BgL_arg5235z00_6456
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd236223zd2_6452));
																																																												BgL_arg5236z00_6457
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_23218;
																																																													{
																																																														obj_t
																																																															BgL_argsz00_23221;
																																																														obj_t
																																																															BgL_bodyz00_23220;
																																																														obj_t
																																																															BgL_varsz00_23219;
																																																														BgL_varsz00_23219
																																																															=
																																																															BgL_arg5234z00_6455;
																																																														BgL_bodyz00_23220
																																																															=
																																																															BgL_arg5235z00_6456;
																																																														BgL_argsz00_23221
																																																															=
																																																															BgL_arg5236z00_6457;
																																																														BgL_argsz00_1742
																																																															=
																																																															BgL_argsz00_23221;
																																																														BgL_bodyz00_1741
																																																															=
																																																															BgL_bodyz00_23220;
																																																														BgL_varsz00_1740
																																																															=
																																																															BgL_varsz00_23219;
																																																														goto
																																																															BgL_tagzd2386zd2_1743;
																																																													}
																																																													BgL_auxz00_22101
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_23218);
																																																												}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 119 */
																																																														goto
																																																															BgL_tagzd2403zd2_1777;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_23225;
																																																														goto
																																																															BgL_tagzd2404zd2_1778;
																																																														BgL_auxz00_22101
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_23225);
																																																													}
																																																											}
																																																									}
																																																								}
																																																						}
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_cdrzd236334zd2_6462;
																																																		BgL_cdrzd236334zd2_6462
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 119 */
																																																			bool_t
																																																				BgL_test9530z00_23229;
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg5249z00_6471;
																																																				BgL_arg5249z00_6471
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test9530z00_23229
																																																					=
																																																					CBOOL
																																																					(BGl_letzd2symzf3z21zzast_letz00
																																																					(BgL_arg5249z00_6471));
																																																			}
																																																			if (BgL_test9530z00_23229)
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_arg5243z00_6465;
																																																					obj_t
																																																						BgL_arg5244z00_6466;
																																																					BgL_arg5243z00_6465
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd236334zd2_6462));
																																																					BgL_arg5244z00_6466
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd236334zd2_6462));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_23238;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_23240;
																																																							obj_t
																																																								BgL_bindingsz00_23239;
																																																							BgL_bindingsz00_23239
																																																								=
																																																								BgL_arg5243z00_6465;
																																																							BgL_exprz00_23240
																																																								=
																																																								BgL_arg5244z00_6466;
																																																							BgL_exprz00_1732
																																																								=
																																																								BgL_exprz00_23240;
																																																							BgL_bindingsz00_1731
																																																								=
																																																								BgL_bindingsz00_23239;
																																																							goto
																																																								BgL_tagzd2382zd2_1733;
																																																						}
																																																						BgL_auxz00_22101
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_23238);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					bool_t
																																																						BgL_test9531z00_23242;
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg5248z00_6470;
																																																						BgL_arg5248z00_6470
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test9531z00_23242
																																																							=
																																																							CBOOL
																																																							(BGl_labelszd2symzf3z21zzast_labelsz00
																																																							(BgL_arg5248z00_6470));
																																																					}
																																																					if (BgL_test9531z00_23242)
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_23247;
																																																							goto
																																																								BgL_tagzd2384zd2_1735;
																																																							BgL_auxz00_22101
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_23247);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																								{	/* Ast/sexp.scm 119 */
																																																									goto
																																																										BgL_tagzd2403zd2_1777;
																																																								}
																																																							else
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_23251;
																																																									goto
																																																										BgL_tagzd2404zd2_1778;
																																																									BgL_auxz00_22101
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_23251);
																																																								}
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd234899zd2_6198)))
																																																	{	/* Ast/sexp.scm 119 */
																																																		goto
																																																			BgL_kapzd234901zd2_6200;
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		if ((BgL_carzd234899zd2_6198 == CNST_TABLE_REF(((long) 18))))
																																																			{	/* Ast/sexp.scm 119 */
																																																				goto
																																																					BgL_kapzd234901zd2_6200;
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				if ((BgL_carzd234899zd2_6198 == CNST_TABLE_REF(((long) 19))))
																																																					{	/* Ast/sexp.scm 119 */
																																																						goto
																																																							BgL_kapzd234901zd2_6200;
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd234899zd2_6198)))
																																																							{	/* Ast/sexp.scm 119 */
																																																								goto
																																																									BgL_kapzd234901zd2_6200;
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd236506zd2_6206;
																																																								BgL_cdrzd236506zd2_6206
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{	/* Ast/sexp.scm 119 */
																																																									bool_t
																																																										BgL_test9537z00_23267;
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg5149z00_6323;
																																																										BgL_arg5149z00_6323
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_test9537z00_23267
																																																											=
																																																											CBOOL
																																																											(BGl_letzd2symzf3z21zzast_letz00
																																																											(BgL_arg5149z00_6323));
																																																									}
																																																									if (BgL_test9537z00_23267)
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_arg5077z00_6209;
																																																											obj_t
																																																												BgL_arg5078z00_6210;
																																																											BgL_arg5077z00_6209
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_cdrzd236506zd2_6206));
																																																											BgL_arg5078z00_6210
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd236506zd2_6206));
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_23276;
																																																												{
																																																													obj_t
																																																														BgL_exprz00_23278;
																																																													obj_t
																																																														BgL_bindingsz00_23277;
																																																													BgL_bindingsz00_23277
																																																														=
																																																														BgL_arg5077z00_6209;
																																																													BgL_exprz00_23278
																																																														=
																																																														BgL_arg5078z00_6210;
																																																													BgL_exprz00_1732
																																																														=
																																																														BgL_exprz00_23278;
																																																													BgL_bindingsz00_1731
																																																														=
																																																														BgL_bindingsz00_23277;
																																																													goto
																																																														BgL_tagzd2382zd2_1733;
																																																												}
																																																												BgL_auxz00_22101
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_23276);
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											bool_t
																																																												BgL_test9538z00_23280;
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_arg5148z00_6322;
																																																												BgL_arg5148z00_6322
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												BgL_test9538z00_23280
																																																													=
																																																													CBOOL
																																																													(BGl_labelszd2symzf3z21zzast_labelsz00
																																																													(BgL_arg5148z00_6322));
																																																											}
																																																											if (BgL_test9538z00_23280)
																																																												{
																																																													BgL_letzd2funzd2_bglt
																																																														BgL_auxz00_23285;
																																																													goto
																																																														BgL_tagzd2384zd2_1735;
																																																													BgL_auxz00_22101
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_23285);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_carzd236572zd2_6213;
																																																													BgL_carzd236572zd2_6213
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd236577zd2_6214;
																																																														BgL_cdrzd236577zd2_6214
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_carzd236572zd2_6213));
																																																														if ((CAR(((obj_t) BgL_carzd236572zd2_6213)) == CNST_TABLE_REF(((long) 3))))
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (PAIRP(BgL_cdrzd236577zd2_6214))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_arg5084z00_6218;
																																																																		obj_t
																																																																			BgL_arg5085z00_6219;
																																																																		obj_t
																																																																			BgL_arg5086z00_6220;
																																																																		BgL_arg5084z00_6218
																																																																			=
																																																																			CAR
																																																																			(BgL_cdrzd236577zd2_6214);
																																																																		BgL_arg5085z00_6219
																																																																			=
																																																																			CDR
																																																																			(BgL_cdrzd236577zd2_6214);
																																																																		BgL_arg5086z00_6220
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_23302;
																																																																			{
																																																																				obj_t
																																																																					BgL_argsz00_23305;
																																																																				obj_t
																																																																					BgL_bodyz00_23304;
																																																																				obj_t
																																																																					BgL_varsz00_23303;
																																																																				BgL_varsz00_23303
																																																																					=
																																																																					BgL_arg5084z00_6218;
																																																																				BgL_bodyz00_23304
																																																																					=
																																																																					BgL_arg5085z00_6219;
																																																																				BgL_argsz00_23305
																																																																					=
																																																																					BgL_arg5086z00_6220;
																																																																				BgL_argsz00_1742
																																																																					=
																																																																					BgL_argsz00_23305;
																																																																				BgL_bodyz00_1741
																																																																					=
																																																																					BgL_bodyz00_23304;
																																																																				BgL_varsz00_1740
																																																																					=
																																																																					BgL_varsz00_23303;
																																																																				goto
																																																																					BgL_tagzd2386zd2_1743;
																																																																			}
																																																																			BgL_auxz00_22101
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_23302);
																																																																		}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1777;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_23309;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1778;
																																																																				BgL_auxz00_22101
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_23309);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd236684zd2_6223;
																																																																BgL_cdrzd236684zd2_6223
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd236689zd2_6224;
																																																																	BgL_cdrzd236689zd2_6224
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_carzd236572zd2_6213));
																																																																	if ((CAR(((obj_t) BgL_carzd236572zd2_6213)) == CNST_TABLE_REF(((long) 1))))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (PAIRP(BgL_cdrzd236689zd2_6224))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd236694zd2_6228;
																																																																					BgL_cdrzd236694zd2_6228
																																																																						=
																																																																						CDR
																																																																						(BgL_cdrzd236689zd2_6224);
																																																																					if (PAIRP(BgL_cdrzd236694zd2_6228))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd236698zd2_6230;
																																																																							obj_t
																																																																								BgL_cdrzd236699zd2_6231;
																																																																							BgL_carzd236698zd2_6230
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd236694zd2_6228);
																																																																							BgL_cdrzd236699zd2_6231
																																																																								=
																																																																								CDR
																																																																								(BgL_cdrzd236694zd2_6228);
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd236698zd2_6230))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (PAIRP(BgL_cdrzd236699zd2_6231))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd236704zd2_6234;
																																																																											BgL_carzd236704zd2_6234
																																																																												=
																																																																												CAR
																																																																												(BgL_cdrzd236699zd2_6231);
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd236704zd2_6234))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (NULLP(CDR(BgL_cdrzd236699zd2_6231)))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															bool_t
																																																																																BgL_test9549z00_23337;
																																																																															{
																																																																																obj_t
																																																																																	BgL_l1429z00_6267;
																																																																																BgL_l1429z00_6267
																																																																																	=
																																																																																	BgL_cdrzd236684zd2_6223;
																																																																															BgL_zc3z04anonymousza35112ze3z87_6268:
																																																																																if (NULLP(BgL_l1429z00_6267))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		BgL_test9549z00_23337
																																																																																			=
																																																																																			(
																																																																																			(bool_t)
																																																																																			1);
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		bool_t
																																																																																			BgL_test9551z00_23340;
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			bool_t
																																																																																				BgL_test9552z00_23341;
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_tmpz00_23342;
																																																																																				BgL_tmpz00_23342
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_l1429z00_6267));
																																																																																				BgL_test9552z00_23341
																																																																																					=
																																																																																					PAIRP
																																																																																					(BgL_tmpz00_23342);
																																																																																			}
																																																																																			if (BgL_test9552z00_23341)
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					BgL_test9551z00_23340
																																																																																						=
																																																																																						(
																																																																																						(bool_t)
																																																																																						0);
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					BgL_test9551z00_23340
																																																																																						=
																																																																																						(
																																																																																						(bool_t)
																																																																																						1);
																																																																																				}
																																																																																		}
																																																																																		if (BgL_test9551z00_23340)
																																																																																			{
																																																																																				obj_t
																																																																																					BgL_l1429z00_23346;
																																																																																				BgL_l1429z00_23346
																																																																																					=
																																																																																					CDR
																																																																																					(
																																																																																					((obj_t) BgL_l1429z00_6267));
																																																																																				BgL_l1429z00_6267
																																																																																					=
																																																																																					BgL_l1429z00_23346;
																																																																																				goto
																																																																																					BgL_zc3z04anonymousza35112ze3z87_6268;
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				BgL_test9549z00_23337
																																																																																					=
																																																																																					(
																																																																																					(bool_t)
																																																																																					0);
																																																																																			}
																																																																																	}
																																																																															}
																																																																															if (BgL_test9549z00_23337)
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_arg5102z00_6250;
																																																																																	BgL_arg5102z00_6250
																																																																																		=
																																																																																		CAR
																																																																																		(BgL_cdrzd236689zd2_6224);
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_23350;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_23354;
																																																																																			obj_t
																																																																																				BgL_proc2z00_23353;
																																																																																			obj_t
																																																																																				BgL_proc1z00_23352;
																																																																																			obj_t
																																																																																				BgL_testz00_23351;
																																																																																			BgL_testz00_23351
																																																																																				=
																																																																																				BgL_arg5102z00_6250;
																																																																																			BgL_proc1z00_23352
																																																																																				=
																																																																																				BgL_carzd236698zd2_6230;
																																																																																			BgL_proc2z00_23353
																																																																																				=
																																																																																				BgL_carzd236704zd2_6234;
																																																																																			BgL_argsz00_23354
																																																																																				=
																																																																																				BgL_cdrzd236684zd2_6223;
																																																																																			BgL_argsz00_1747
																																																																																				=
																																																																																				BgL_argsz00_23354;
																																																																																			BgL_proc2z00_1746
																																																																																				=
																																																																																				BgL_proc2z00_23353;
																																																																																			BgL_proc1z00_1745
																																																																																				=
																																																																																				BgL_proc1z00_23352;
																																																																																			BgL_testz00_1744
																																																																																				=
																																																																																				BgL_testz00_23351;
																																																																																			goto
																																																																																				BgL_tagzd2387zd2_1748;
																																																																																		}
																																																																																		BgL_auxz00_22101
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_23350);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_cdrzd236729zd2_6251;
																																																																																	BgL_cdrzd236729zd2_6251
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_expz00_21));
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_cdrzd236737zd2_6252;
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_pairz00_12133;
																																																																																			BgL_pairz00_12133
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_expz00_21));
																																																																																			BgL_cdrzd236737zd2_6252
																																																																																				=
																																																																																				CDR
																																																																																				(BgL_pairz00_12133);
																																																																																		}
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_cdrzd236745zd2_6253;
																																																																																			BgL_cdrzd236745zd2_6253
																																																																																				=
																																																																																				CDR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd236737zd2_6252));
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_carzd236752zd2_6254;
																																																																																				BgL_carzd236752zd2_6254
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd236745zd2_6253));
																																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd236752zd2_6254))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						obj_t
																																																																																							BgL_carzd236761zd2_6256;
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							obj_t
																																																																																								BgL_pairz00_12137;
																																																																																							BgL_pairz00_12137
																																																																																								=
																																																																																								CDR
																																																																																								(
																																																																																								((obj_t) BgL_cdrzd236745zd2_6253));
																																																																																							BgL_carzd236761zd2_6256
																																																																																								=
																																																																																								CAR
																																																																																								(BgL_pairz00_12137);
																																																																																						}
																																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd236761zd2_6256))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd236729zd2_6251))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										obj_t
																																																																																											BgL_arg5106z00_6259;
																																																																																										BgL_arg5106z00_6259
																																																																																											=
																																																																																											CAR
																																																																																											(
																																																																																											((obj_t) BgL_cdrzd236737zd2_6252));
																																																																																										{
																																																																																											BgL_nodez00_bglt
																																																																																												BgL_auxz00_23376;
																																																																																											{
																																																																																												obj_t
																																																																																													BgL_argsz00_23380;
																																																																																												obj_t
																																																																																													BgL_proc2z00_23379;
																																																																																												obj_t
																																																																																													BgL_proc1z00_23378;
																																																																																												obj_t
																																																																																													BgL_testz00_23377;
																																																																																												BgL_testz00_23377
																																																																																													=
																																																																																													BgL_arg5106z00_6259;
																																																																																												BgL_proc1z00_23378
																																																																																													=
																																																																																													BgL_carzd236752zd2_6254;
																																																																																												BgL_proc2z00_23379
																																																																																													=
																																																																																													BgL_carzd236761zd2_6256;
																																																																																												BgL_argsz00_23380
																																																																																													=
																																																																																													BgL_cdrzd236729zd2_6251;
																																																																																												BgL_argsz00_1752
																																																																																													=
																																																																																													BgL_argsz00_23380;
																																																																																												BgL_proc2z00_1751
																																																																																													=
																																																																																													BgL_proc2z00_23379;
																																																																																												BgL_proc1z00_1750
																																																																																													=
																																																																																													BgL_proc1z00_23378;
																																																																																												BgL_testz00_1749
																																																																																													=
																																																																																													BgL_testz00_23377;
																																																																																												goto
																																																																																													BgL_tagzd2388zd2_1753;
																																																																																											}
																																																																																											BgL_auxz00_22101
																																																																																												=
																																																																																												(
																																																																																												(obj_t)
																																																																																												BgL_auxz00_23376);
																																																																																										}
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												goto
																																																																																													BgL_tagzd2403zd2_1777;
																																																																																											}
																																																																																										else
																																																																																											{
																																																																																												BgL_nodez00_bglt
																																																																																													BgL_auxz00_23384;
																																																																																												goto
																																																																																													BgL_tagzd2404zd2_1778;
																																																																																												BgL_auxz00_22101
																																																																																													=
																																																																																													(
																																																																																													(obj_t)
																																																																																													BgL_auxz00_23384);
																																																																																											}
																																																																																									}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1777;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_23388;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1778;
																																																																																										BgL_auxz00_22101
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_23388);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1777;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_23392;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1778;
																																																																																								BgL_auxz00_22101
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_23392);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		}
																																																																																	}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1777;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_23396;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1778;
																																																																																	BgL_auxz00_22101
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_23396);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd237039zd2_6278;
																																																																													BgL_cdrzd237039zd2_6278
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_cdrzd237046zd2_6279;
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_pairz00_12141;
																																																																															BgL_pairz00_12141
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															BgL_cdrzd237046zd2_6279
																																																																																=
																																																																																CDR
																																																																																(BgL_pairz00_12141);
																																																																														}
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_cdrzd237053zd2_6280;
																																																																															BgL_cdrzd237053zd2_6280
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_cdrzd237046zd2_6279));
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_carzd237059zd2_6281;
																																																																																obj_t
																																																																																	BgL_cdrzd237060zd2_6282;
																																																																																BgL_carzd237059zd2_6281
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd237053zd2_6280));
																																																																																BgL_cdrzd237060zd2_6282
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd237053zd2_6280));
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd237059zd2_6281))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_carzd237067zd2_6284;
																																																																																		BgL_carzd237067zd2_6284
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd237060zd2_6282));
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd237067zd2_6284))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (NULLP(CDR(((obj_t) BgL_cdrzd237060zd2_6282))))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd237039zd2_6278))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								obj_t
																																																																																									BgL_arg5121z00_6289;
																																																																																								BgL_arg5121z00_6289
																																																																																									=
																																																																																									CAR
																																																																																									(
																																																																																									((obj_t) BgL_cdrzd237046zd2_6279));
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_23423;
																																																																																									{
																																																																																										obj_t
																																																																																											BgL_argsz00_23427;
																																																																																										obj_t
																																																																																											BgL_proc2z00_23426;
																																																																																										obj_t
																																																																																											BgL_proc1z00_23425;
																																																																																										obj_t
																																																																																											BgL_testz00_23424;
																																																																																										BgL_testz00_23424
																																																																																											=
																																																																																											BgL_arg5121z00_6289;
																																																																																										BgL_proc1z00_23425
																																																																																											=
																																																																																											BgL_carzd237059zd2_6281;
																																																																																										BgL_proc2z00_23426
																																																																																											=
																																																																																											BgL_carzd237067zd2_6284;
																																																																																										BgL_argsz00_23427
																																																																																											=
																																																																																											BgL_cdrzd237039zd2_6278;
																																																																																										BgL_argsz00_1752
																																																																																											=
																																																																																											BgL_argsz00_23427;
																																																																																										BgL_proc2z00_1751
																																																																																											=
																																																																																											BgL_proc2z00_23426;
																																																																																										BgL_proc1z00_1750
																																																																																											=
																																																																																											BgL_proc1z00_23425;
																																																																																										BgL_testz00_1749
																																																																																											=
																																																																																											BgL_testz00_23424;
																																																																																										goto
																																																																																											BgL_tagzd2388zd2_1753;
																																																																																									}
																																																																																									BgL_auxz00_22101
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_23423);
																																																																																								}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1777;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_23431;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1778;
																																																																																										BgL_auxz00_22101
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_23431);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1777;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_23435;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1778;
																																																																																								BgL_auxz00_22101
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_23435);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1777;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_23439;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1778;
																																																																																						BgL_auxz00_22101
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_23439);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1777;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_23443;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1778;
																																																																																				BgL_auxz00_22101
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_23443);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														}
																																																																													}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1777;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_23447;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1778;
																																																																													BgL_auxz00_22101
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_23447);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd237400zd2_6297;
																																																																									BgL_cdrzd237400zd2_6297
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd237406zd2_6298;
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_pairz00_12151;
																																																																											BgL_pairz00_12151
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											BgL_cdrzd237406zd2_6298
																																																																												=
																																																																												CDR
																																																																												(BgL_pairz00_12151);
																																																																										}
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd237412zd2_6299;
																																																																											BgL_cdrzd237412zd2_6299
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd237406zd2_6298));
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_carzd237417zd2_6300;
																																																																												obj_t
																																																																													BgL_cdrzd237418zd2_6301;
																																																																												BgL_carzd237417zd2_6300
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd237412zd2_6299));
																																																																												BgL_cdrzd237418zd2_6301
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd237412zd2_6299));
																																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd237417zd2_6300))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (PAIRP(BgL_cdrzd237418zd2_6301))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_carzd237423zd2_6304;
																																																																																BgL_carzd237423zd2_6304
																																																																																	=
																																																																																	CAR
																																																																																	(BgL_cdrzd237418zd2_6301);
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd237423zd2_6304))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (NULLP(CDR(BgL_cdrzd237418zd2_6301)))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd237400zd2_6297))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						obj_t
																																																																																							BgL_arg5135z00_6309;
																																																																																						BgL_arg5135z00_6309
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd237406zd2_6298));
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_23474;
																																																																																							{
																																																																																								obj_t
																																																																																									BgL_argsz00_23478;
																																																																																								obj_t
																																																																																									BgL_proc2z00_23477;
																																																																																								obj_t
																																																																																									BgL_proc1z00_23476;
																																																																																								obj_t
																																																																																									BgL_testz00_23475;
																																																																																								BgL_testz00_23475
																																																																																									=
																																																																																									BgL_arg5135z00_6309;
																																																																																								BgL_proc1z00_23476
																																																																																									=
																																																																																									BgL_carzd237417zd2_6300;
																																																																																								BgL_proc2z00_23477
																																																																																									=
																																																																																									BgL_carzd237423zd2_6304;
																																																																																								BgL_argsz00_23478
																																																																																									=
																																																																																									BgL_cdrzd237400zd2_6297;
																																																																																								BgL_argsz00_1752
																																																																																									=
																																																																																									BgL_argsz00_23478;
																																																																																								BgL_proc2z00_1751
																																																																																									=
																																																																																									BgL_proc2z00_23477;
																																																																																								BgL_proc1z00_1750
																																																																																									=
																																																																																									BgL_proc1z00_23476;
																																																																																								BgL_testz00_1749
																																																																																									=
																																																																																									BgL_testz00_23475;
																																																																																								goto
																																																																																									BgL_tagzd2388zd2_1753;
																																																																																							}
																																																																																							BgL_auxz00_22101
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_23474);
																																																																																						}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1777;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_23482;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1778;
																																																																																								BgL_auxz00_22101
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_23482);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1777;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_23486;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1778;
																																																																																						BgL_auxz00_22101
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_23486);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1777;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_23490;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1778;
																																																																																				BgL_auxz00_22101
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_23490);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1777;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_23494;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1778;
																																																																																		BgL_auxz00_22101
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_23494);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1777;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_23498;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1778;
																																																																																BgL_auxz00_22101
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_23498);
																																																																															}
																																																																													}
																																																																											}
																																																																										}
																																																																									}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1777;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_23502;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1778;
																																																																									BgL_auxz00_22101
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_23502);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1777;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_23506;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1778;
																																																																							BgL_auxz00_22101
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_23506);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1777;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_23510;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1778;
																																																																					BgL_auxz00_22101
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_23510);
																																																																				}
																																																																		}
																																																																}
																																																															}
																																																													}
																																																												}
																																																										}
																																																								}
																																																							}
																																																					}
																																																			}
																																																	}
																																															}
																																													}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_cdrzd237961zd2_6473;
																																													BgL_cdrzd237961zd2_6473
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													if ((BgL_carzd234896zd2_6196 == CNST_TABLE_REF(((long) 17))))
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg5251z00_6475;
																																															obj_t
																																																BgL_arg5252z00_6476;
																																															BgL_arg5251z00_6475
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd237961zd2_6473));
																																															BgL_arg5252z00_6476
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd237961zd2_6473));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_23521;
																																																{
																																																	obj_t
																																																		BgL_exprz00_23523;
																																																	obj_t
																																																		BgL_bindingsz00_23522;
																																																	BgL_bindingsz00_23522
																																																		=
																																																		BgL_arg5251z00_6475;
																																																	BgL_exprz00_23523
																																																		=
																																																		BgL_arg5252z00_6476;
																																																	BgL_exprz00_1732
																																																		=
																																																		BgL_exprz00_23523;
																																																	BgL_bindingsz00_1731
																																																		=
																																																		BgL_bindingsz00_23522;
																																																	goto
																																																		BgL_tagzd2382zd2_1733;
																																																}
																																																BgL_auxz00_22101
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_23521);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd234896zd2_6196)))
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg5254z00_6478;
																																																	obj_t
																																																		BgL_arg5255z00_6479;
																																																	BgL_arg5254z00_6478
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd237961zd2_6473));
																																																	BgL_arg5255z00_6479
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd237961zd2_6473));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_23532;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_23534;
																																																			obj_t
																																																				BgL_bindingsz00_23533;
																																																			BgL_bindingsz00_23533
																																																				=
																																																				BgL_arg5254z00_6478;
																																																			BgL_exprz00_23534
																																																				=
																																																				BgL_arg5255z00_6479;
																																																			BgL_exprz00_1732
																																																				=
																																																				BgL_exprz00_23534;
																																																			BgL_bindingsz00_1731
																																																				=
																																																				BgL_bindingsz00_23533;
																																																			goto
																																																				BgL_tagzd2382zd2_1733;
																																																		}
																																																		BgL_auxz00_22101
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_23532);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if ((BgL_carzd234896zd2_6196 == CNST_TABLE_REF(((long) 18))))
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg5257z00_6481;
																																																			obj_t
																																																				BgL_arg5258z00_6482;
																																																			BgL_arg5257z00_6481
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd237961zd2_6473));
																																																			BgL_arg5258z00_6482
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd237961zd2_6473));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_23543;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_23545;
																																																					obj_t
																																																						BgL_bindingsz00_23544;
																																																					BgL_bindingsz00_23544
																																																						=
																																																						BgL_arg5257z00_6481;
																																																					BgL_exprz00_23545
																																																						=
																																																						BgL_arg5258z00_6482;
																																																					BgL_exprz00_1732
																																																						=
																																																						BgL_exprz00_23545;
																																																					BgL_bindingsz00_1731
																																																						=
																																																						BgL_bindingsz00_23544;
																																																					goto
																																																						BgL_tagzd2382zd2_1733;
																																																				}
																																																				BgL_auxz00_22101
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_23543);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_23552;
																																																					goto
																																																						BgL_tagzd2383zd2_1734;
																																																					BgL_auxz00_22101
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_23552);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_carzd237998zd2_6485;
																																																					BgL_carzd237998zd2_6485
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					if ((BgL_carzd237998zd2_6485 == CNST_TABLE_REF(((long) 19))))
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_23559;
																																																							goto
																																																								BgL_tagzd2384zd2_1735;
																																																							BgL_auxz00_22101
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_23559);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd237998zd2_6485)))
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_23564;
																																																									goto
																																																										BgL_tagzd2384zd2_1735;
																																																									BgL_auxz00_22101
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_23564);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_23571;
																																																											goto
																																																												BgL_tagzd2389zd2_1754;
																																																											BgL_auxz00_22101
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_23571);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_23578;
																																																													goto
																																																														BgL_tagzd2390zd2_1755;
																																																													BgL_auxz00_22101
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_23578);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd238078zd2_6492;
																																																													BgL_cdrzd238078zd2_6492
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_arg5269z00_6495;
																																																															obj_t
																																																																BgL_arg5270z00_6496;
																																																															BgL_arg5269z00_6495
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd238078zd2_6492));
																																																															BgL_arg5270z00_6496
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd238078zd2_6492));
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_23591;
																																																																{
																																																																	obj_t
																																																																		BgL_restz00_23593;
																																																																	obj_t
																																																																		BgL_effectz00_23592;
																																																																	BgL_effectz00_23592
																																																																		=
																																																																		BgL_arg5269z00_6495;
																																																																	BgL_restz00_23593
																																																																		=
																																																																		BgL_arg5270z00_6496;
																																																																	BgL_restz00_1757
																																																																		=
																																																																		BgL_restz00_23593;
																																																																	BgL_effectz00_1756
																																																																		=
																																																																		BgL_effectz00_23592;
																																																																	goto
																																																																		BgL_tagzd2391zd2_1758;
																																																																}
																																																																BgL_auxz00_22101
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_23591);
																																																															}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_23600;
																																																																	goto
																																																																		BgL_tagzd2392zd2_1759;
																																																																	BgL_auxz00_22101
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_23600);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_23607;
																																																																			goto
																																																																				BgL_tagzd2393zd2_1760;
																																																																			BgL_auxz00_22101
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_23607);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_arg5277z00_6504;
																																																																					obj_t
																																																																						BgL_arg5278z00_6505;
																																																																					BgL_arg5277z00_6504
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd238078zd2_6492));
																																																																					BgL_arg5278z00_6505
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd238078zd2_6492));
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_23618;
																																																																						{
																																																																							obj_t
																																																																								BgL_restz00_23620;
																																																																							obj_t
																																																																								BgL_effectz00_23619;
																																																																							BgL_effectz00_23619
																																																																								=
																																																																								BgL_arg5277z00_6504;
																																																																							BgL_restz00_23620
																																																																								=
																																																																								BgL_arg5278z00_6505;
																																																																							BgL_restz00_1762
																																																																								=
																																																																								BgL_restz00_23620;
																																																																							BgL_effectz00_1761
																																																																								=
																																																																								BgL_effectz00_23619;
																																																																							goto
																																																																								BgL_tagzd2394zd2_1763;
																																																																						}
																																																																						BgL_auxz00_22101
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_23618);
																																																																					}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_23627;
																																																																							goto
																																																																								BgL_tagzd2395zd2_1764;
																																																																							BgL_auxz00_22101
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_23627);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_23634;
																																																																									goto
																																																																										BgL_tagzd2396zd2_1765;
																																																																									BgL_auxz00_22101
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_23634);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																										{
																																																																											BgL_letzd2funzd2_bglt
																																																																												BgL_auxz00_23641;
																																																																											goto
																																																																												BgL_tagzd2397zd2_1766;
																																																																											BgL_auxz00_22101
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_23641);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																												{
																																																																													BgL_jumpzd2exzd2itz00_bglt
																																																																														BgL_auxz00_23648;
																																																																													goto
																																																																														BgL_tagzd2398zd2_1767;
																																																																													BgL_auxz00_22101
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_23648);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd238155zd2_6514;
																																																																													BgL_cdrzd238155zd2_6514
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg5289z00_6517;
																																																																															obj_t
																																																																																BgL_arg5290z00_6518;
																																																																															BgL_arg5289z00_6517
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd238155zd2_6514));
																																																																															BgL_arg5290z00_6518
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_cdrzd238155zd2_6514));
																																																																															{	/* Ast/sexp.scm 552 */
																																																																																obj_t
																																																																																	BgL_arg6965z00_12190;
																																																																																BgL_arg6965z00_12190
																																																																																	=
																																																																																	BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																	(BgL_expz00_21,
																																																																																	BgL_locz00_23);
																																																																																BgL_auxz00_22101
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																	(BgL_expz00_21,
																																																																																		BgL_arg5289z00_6517,
																																																																																		CNST_TABLE_REF
																																																																																		(((long) 4)), BgL_arg5290z00_6518, BgL_stackz00_22, BgL_arg6965z00_12190, BgL_sitez00_24));
																																																																														}}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1777;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_23667;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1778;
																																																																																	BgL_auxz00_22101
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_23667);
																																																																																}
																																																																														}
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																															else
																																{	/* Ast/sexp.scm 119 */
																																	obj_t
																																		BgL_carzd238180zd2_6535;
																																	BgL_carzd238180zd2_6535
																																		=
																																		CAR(((obj_t)
																																			BgL_expz00_21));
																																	if (
																																		(BgL_carzd238180zd2_6535
																																			==
																																			CNST_TABLE_REF
																																			(((long)
																																					1))))
																																		{
																																			BgL_nodez00_bglt
																																				BgL_auxz00_23674;
																																			goto
																																				BgL_tagzd2377zd2_1722;
																																			BgL_auxz00_22101
																																				=
																																				((obj_t)
																																				BgL_auxz00_23674);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 119 */
																																			if (
																																				(BgL_carzd238180zd2_6535
																																					==
																																					BGl_za2ifza2z00zzast_sexpz00))
																																				{
																																					BgL_nodez00_bglt
																																						BgL_auxz00_23678;
																																					goto
																																						BgL_tagzd2377zd2_1722;
																																					BgL_auxz00_22101
																																						=
																																						(
																																						(obj_t)
																																						BgL_auxz00_23678);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					if (
																																						(CAR
																																							(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 7))))
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_23685;
																																							goto
																																								BgL_tagzd2379zd2_1726;
																																							BgL_auxz00_22101
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_23685);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_23692;
																																									goto
																																										BgL_tagzd2380zd2_1727;
																																									BgL_auxz00_22101
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_23692);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									obj_t
																																										BgL_carzd238249zd2_6542;
																																									BgL_carzd238249zd2_6542
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_expz00_21));
																																									if (PAIRP(BgL_carzd238249zd2_6542))
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_carzd238252zd2_6544;
																																											obj_t
																																												BgL_cdrzd238253zd2_6545;
																																											BgL_carzd238252zd2_6544
																																												=
																																												CAR
																																												(BgL_carzd238249zd2_6542);
																																											BgL_cdrzd238253zd2_6545
																																												=
																																												CDR
																																												(BgL_carzd238249zd2_6542);
																																											{

																																												if ((BgL_carzd238252zd2_6544 == CNST_TABLE_REF(((long) 17))))
																																													{	/* Ast/sexp.scm 119 */
																																													BgL_kapzd238254zd2_6546:
																																														if (PAIRP(BgL_cdrzd238253zd2_6545))
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_cdrzd238257zd2_6671;
																																																BgL_cdrzd238257zd2_6671
																																																	=
																																																	CDR
																																																	(BgL_cdrzd238253zd2_6545);
																																																if (PAIRP(BgL_cdrzd238257zd2_6671))
																																																	{	/* Ast/sexp.scm 119 */
																																																		if (NULLP(CDR(BgL_cdrzd238257zd2_6671)))
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg5398z00_6675;
																																																				obj_t
																																																					BgL_arg5399z00_6676;
																																																				BgL_arg5398z00_6675
																																																					=
																																																					CAR
																																																					(BgL_cdrzd238257zd2_6671);
																																																				BgL_arg5399z00_6676
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_23714;
																																																					{
																																																						obj_t
																																																							BgL_argsz00_23716;
																																																						obj_t
																																																							BgL_bodyz00_23715;
																																																						BgL_bodyz00_23715
																																																							=
																																																							BgL_arg5398z00_6675;
																																																						BgL_argsz00_23716
																																																							=
																																																							BgL_arg5399z00_6676;
																																																						BgL_argsz00_1729
																																																							=
																																																							BgL_argsz00_23716;
																																																						BgL_bodyz00_1728
																																																							=
																																																							BgL_bodyz00_23715;
																																																						goto
																																																							BgL_tagzd2381zd2_1730;
																																																					}
																																																					BgL_auxz00_22101
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_23714);
																																																				}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd238281zd2_6677;
																																																				BgL_cdrzd238281zd2_6677
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 119 */
																																																					bool_t
																																																						BgL_test9609z00_23720;
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg5469z00_6788;
																																																						BgL_arg5469z00_6788
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test9609z00_23720
																																																							=
																																																							CBOOL
																																																							(BGl_letzd2symzf3z21zzast_letz00
																																																							(BgL_arg5469z00_6788));
																																																					}
																																																					if (BgL_test9609z00_23720)
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_arg5402z00_6680;
																																																							obj_t
																																																								BgL_arg5403z00_6681;
																																																							BgL_arg5402z00_6680
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd238281zd2_6677));
																																																							BgL_arg5403z00_6681
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd238281zd2_6677));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_23729;
																																																								{
																																																									obj_t
																																																										BgL_exprz00_23731;
																																																									obj_t
																																																										BgL_bindingsz00_23730;
																																																									BgL_bindingsz00_23730
																																																										=
																																																										BgL_arg5402z00_6680;
																																																									BgL_exprz00_23731
																																																										=
																																																										BgL_arg5403z00_6681;
																																																									BgL_exprz00_1732
																																																										=
																																																										BgL_exprz00_23731;
																																																									BgL_bindingsz00_1731
																																																										=
																																																										BgL_bindingsz00_23730;
																																																									goto
																																																										BgL_tagzd2382zd2_1733;
																																																								}
																																																								BgL_auxz00_22101
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_23729);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							bool_t
																																																								BgL_test9610z00_23733;
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg5468z00_6787;
																																																								BgL_arg5468z00_6787
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test9610z00_23733
																																																									=
																																																									CBOOL
																																																									(BGl_labelszd2symzf3z21zzast_labelsz00
																																																									(BgL_arg5468z00_6787));
																																																							}
																																																							if (BgL_test9610z00_23733)
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_23738;
																																																									goto
																																																										BgL_tagzd2384zd2_1735;
																																																									BgL_auxz00_22101
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_23738);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_carzd238348zd2_6684;
																																																									BgL_carzd238348zd2_6684
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd238353zd2_6685;
																																																										BgL_cdrzd238353zd2_6685
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_carzd238348zd2_6684));
																																																										if ((CAR(((obj_t) BgL_carzd238348zd2_6684)) == CNST_TABLE_REF(((long) 3))))
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_arg5408z00_6688;
																																																												obj_t
																																																													BgL_arg5409z00_6689;
																																																												obj_t
																																																													BgL_arg5410z00_6690;
																																																												BgL_arg5408z00_6688
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd238353zd2_6685));
																																																												BgL_arg5409z00_6689
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd238353zd2_6685));
																																																												BgL_arg5410z00_6690
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_23755;
																																																													{
																																																														obj_t
																																																															BgL_argsz00_23758;
																																																														obj_t
																																																															BgL_bodyz00_23757;
																																																														obj_t
																																																															BgL_varsz00_23756;
																																																														BgL_varsz00_23756
																																																															=
																																																															BgL_arg5408z00_6688;
																																																														BgL_bodyz00_23757
																																																															=
																																																															BgL_arg5409z00_6689;
																																																														BgL_argsz00_23758
																																																															=
																																																															BgL_arg5410z00_6690;
																																																														BgL_argsz00_1742
																																																															=
																																																															BgL_argsz00_23758;
																																																														BgL_bodyz00_1741
																																																															=
																																																															BgL_bodyz00_23757;
																																																														BgL_varsz00_1740
																																																															=
																																																															BgL_varsz00_23756;
																																																														goto
																																																															BgL_tagzd2386zd2_1743;
																																																													}
																																																													BgL_auxz00_22101
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_23755);
																																																												}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd238376zd2_6692;
																																																												BgL_cdrzd238376zd2_6692
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd238382zd2_6693;
																																																													BgL_cdrzd238382zd2_6693
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_carzd238348zd2_6684));
																																																													if ((CAR(((obj_t) BgL_carzd238348zd2_6684)) == CNST_TABLE_REF(((long) 1))))
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd238388zd2_6696;
																																																															BgL_cdrzd238388zd2_6696
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd238382zd2_6693));
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_carzd238393zd2_6697;
																																																																obj_t
																																																																	BgL_cdrzd238394zd2_6698;
																																																																BgL_carzd238393zd2_6697
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd238388zd2_6696));
																																																																BgL_cdrzd238394zd2_6698
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd238388zd2_6696));
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd238393zd2_6697))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (PAIRP(BgL_cdrzd238394zd2_6698))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_carzd238401zd2_6701;
																																																																				BgL_carzd238401zd2_6701
																																																																					=
																																																																					CAR
																																																																					(BgL_cdrzd238394zd2_6698);
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd238401zd2_6701))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (NULLP(CDR(BgL_cdrzd238394zd2_6698)))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								bool_t
																																																																									BgL_test9617z00_23785;
																																																																								{
																																																																									obj_t
																																																																										BgL_l1432z00_6734;
																																																																									BgL_l1432z00_6734
																																																																										=
																																																																										BgL_cdrzd238376zd2_6692;
																																																																								BgL_zc3z04anonymousza35433ze3z87_6735:
																																																																									if (NULLP(BgL_l1432z00_6734))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											BgL_test9617z00_23785
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												1);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											bool_t
																																																																												BgL_test9619z00_23788;
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												bool_t
																																																																													BgL_test9620z00_23789;
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_tmpz00_23790;
																																																																													BgL_tmpz00_23790
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_l1432z00_6734));
																																																																													BgL_test9620z00_23789
																																																																														=
																																																																														PAIRP
																																																																														(BgL_tmpz00_23790);
																																																																												}
																																																																												if (BgL_test9620z00_23789)
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														BgL_test9619z00_23788
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															0);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														BgL_test9619z00_23788
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															1);
																																																																													}
																																																																											}
																																																																											if (BgL_test9619z00_23788)
																																																																												{
																																																																													obj_t
																																																																														BgL_l1432z00_23794;
																																																																													BgL_l1432z00_23794
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_l1432z00_6734));
																																																																													BgL_l1432z00_6734
																																																																														=
																																																																														BgL_l1432z00_23794;
																																																																													goto
																																																																														BgL_zc3z04anonymousza35433ze3z87_6735;
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													BgL_test9617z00_23785
																																																																														=
																																																																														(
																																																																														(bool_t)
																																																																														0);
																																																																												}
																																																																										}
																																																																								}
																																																																								if (BgL_test9617z00_23785)
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_arg5423z00_6717;
																																																																										BgL_arg5423z00_6717
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd238382zd2_6693));
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_23799;
																																																																											{
																																																																												obj_t
																																																																													BgL_argsz00_23803;
																																																																												obj_t
																																																																													BgL_proc2z00_23802;
																																																																												obj_t
																																																																													BgL_proc1z00_23801;
																																																																												obj_t
																																																																													BgL_testz00_23800;
																																																																												BgL_testz00_23800
																																																																													=
																																																																													BgL_arg5423z00_6717;
																																																																												BgL_proc1z00_23801
																																																																													=
																																																																													BgL_carzd238393zd2_6697;
																																																																												BgL_proc2z00_23802
																																																																													=
																																																																													BgL_carzd238401zd2_6701;
																																																																												BgL_argsz00_23803
																																																																													=
																																																																													BgL_cdrzd238376zd2_6692;
																																																																												BgL_argsz00_1747
																																																																													=
																																																																													BgL_argsz00_23803;
																																																																												BgL_proc2z00_1746
																																																																													=
																																																																													BgL_proc2z00_23802;
																																																																												BgL_proc1z00_1745
																																																																													=
																																																																													BgL_proc1z00_23801;
																																																																												BgL_testz00_1744
																																																																													=
																																																																													BgL_testz00_23800;
																																																																												goto
																																																																													BgL_tagzd2387zd2_1748;
																																																																											}
																																																																											BgL_auxz00_22101
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_23799);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd238425zd2_6718;
																																																																										BgL_cdrzd238425zd2_6718
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd238432zd2_6719;
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_pairz00_12234;
																																																																												BgL_pairz00_12234
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												BgL_cdrzd238432zd2_6719
																																																																													=
																																																																													CDR
																																																																													(BgL_pairz00_12234);
																																																																											}
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_cdrzd238439zd2_6720;
																																																																												BgL_cdrzd238439zd2_6720
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd238432zd2_6719));
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_carzd238445zd2_6721;
																																																																													BgL_carzd238445zd2_6721
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd238439zd2_6720));
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd238445zd2_6721))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_carzd238452zd2_6723;
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_pairz00_12238;
																																																																																BgL_pairz00_12238
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd238439zd2_6720));
																																																																																BgL_carzd238452zd2_6723
																																																																																	=
																																																																																	CAR
																																																																																	(BgL_pairz00_12238);
																																																																															}
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd238452zd2_6723))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd238425zd2_6718))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_arg5427z00_6726;
																																																																																			BgL_arg5427z00_6726
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd238432zd2_6719));
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_23825;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_23829;
																																																																																					obj_t
																																																																																						BgL_proc2z00_23828;
																																																																																					obj_t
																																																																																						BgL_proc1z00_23827;
																																																																																					obj_t
																																																																																						BgL_testz00_23826;
																																																																																					BgL_testz00_23826
																																																																																						=
																																																																																						BgL_arg5427z00_6726;
																																																																																					BgL_proc1z00_23827
																																																																																						=
																																																																																						BgL_carzd238445zd2_6721;
																																																																																					BgL_proc2z00_23828
																																																																																						=
																																																																																						BgL_carzd238452zd2_6723;
																																																																																					BgL_argsz00_23829
																																																																																						=
																																																																																						BgL_cdrzd238425zd2_6718;
																																																																																					BgL_argsz00_1752
																																																																																						=
																																																																																						BgL_argsz00_23829;
																																																																																					BgL_proc2z00_1751
																																																																																						=
																																																																																						BgL_proc2z00_23828;
																																																																																					BgL_proc1z00_1750
																																																																																						=
																																																																																						BgL_proc1z00_23827;
																																																																																					BgL_testz00_1749
																																																																																						=
																																																																																						BgL_testz00_23826;
																																																																																					goto
																																																																																						BgL_tagzd2388zd2_1753;
																																																																																				}
																																																																																				BgL_auxz00_22101
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_23825);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1777;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_23833;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1778;
																																																																																					BgL_auxz00_22101
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_23833);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1777;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_23837;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1778;
																																																																																			BgL_auxz00_22101
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_23837);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1777;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_23841;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1778;
																																																																																	BgL_auxz00_22101
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_23841);
																																																																																}
																																																																														}
																																																																												}
																																																																											}
																																																																										}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1777;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_23845;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1778;
																																																																										BgL_auxz00_22101
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_23845);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd238728zd2_6745;
																																																																						BgL_cdrzd238728zd2_6745
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd238734zd2_6746;
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_pairz00_12242;
																																																																								BgL_pairz00_12242
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								BgL_cdrzd238734zd2_6746
																																																																									=
																																																																									CDR
																																																																									(BgL_pairz00_12242);
																																																																							}
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd238740zd2_6747;
																																																																								BgL_cdrzd238740zd2_6747
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd238734zd2_6746));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd238745zd2_6748;
																																																																									obj_t
																																																																										BgL_cdrzd238746zd2_6749;
																																																																									BgL_carzd238745zd2_6748
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd238740zd2_6747));
																																																																									BgL_cdrzd238746zd2_6749
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd238740zd2_6747));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd238745zd2_6748))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd238751zd2_6751;
																																																																											BgL_carzd238751zd2_6751
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd238746zd2_6749));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd238751zd2_6751))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (NULLP(CDR(((obj_t) BgL_cdrzd238746zd2_6749))))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd238728zd2_6745))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_arg5442z00_6756;
																																																																																	BgL_arg5442z00_6756
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd238734zd2_6746));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_23872;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_23876;
																																																																																			obj_t
																																																																																				BgL_proc2z00_23875;
																																																																																			obj_t
																																																																																				BgL_proc1z00_23874;
																																																																																			obj_t
																																																																																				BgL_testz00_23873;
																																																																																			BgL_testz00_23873
																																																																																				=
																																																																																				BgL_arg5442z00_6756;
																																																																																			BgL_proc1z00_23874
																																																																																				=
																																																																																				BgL_carzd238745zd2_6748;
																																																																																			BgL_proc2z00_23875
																																																																																				=
																																																																																				BgL_carzd238751zd2_6751;
																																																																																			BgL_argsz00_23876
																																																																																				=
																																																																																				BgL_cdrzd238728zd2_6745;
																																																																																			BgL_argsz00_1752
																																																																																				=
																																																																																				BgL_argsz00_23876;
																																																																																			BgL_proc2z00_1751
																																																																																				=
																																																																																				BgL_proc2z00_23875;
																																																																																			BgL_proc1z00_1750
																																																																																				=
																																																																																				BgL_proc1z00_23874;
																																																																																			BgL_testz00_1749
																																																																																				=
																																																																																				BgL_testz00_23873;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1753;
																																																																																		}
																																																																																		BgL_auxz00_22101
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_23872);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1777;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_23880;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1778;
																																																																																			BgL_auxz00_22101
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_23880);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1777;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_23884;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1778;
																																																																																	BgL_auxz00_22101
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_23884);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1777;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_23888;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1778;
																																																																															BgL_auxz00_22101
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_23888);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1777;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_23892;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1778;
																																																																													BgL_auxz00_22101
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_23892);
																																																																												}
																																																																										}
																																																																								}
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1777;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_23896;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1778;
																																																																						BgL_auxz00_22101
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_23896);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd239084zd2_6764;
																																																																		BgL_cdrzd239084zd2_6764
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd239091zd2_6765;
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_pairz00_12252;
																																																																				BgL_pairz00_12252
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				BgL_cdrzd239091zd2_6765
																																																																					=
																																																																					CDR
																																																																					(BgL_pairz00_12252);
																																																																			}
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd239098zd2_6766;
																																																																				BgL_cdrzd239098zd2_6766
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd239091zd2_6765));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_carzd239104zd2_6767;
																																																																					obj_t
																																																																						BgL_cdrzd239105zd2_6768;
																																																																					BgL_carzd239104zd2_6767
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd239098zd2_6766));
																																																																					BgL_cdrzd239105zd2_6768
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd239098zd2_6766));
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd239104zd2_6767))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (PAIRP(BgL_cdrzd239105zd2_6768))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd239112zd2_6771;
																																																																									BgL_carzd239112zd2_6771
																																																																										=
																																																																										CAR
																																																																										(BgL_cdrzd239105zd2_6768);
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd239112zd2_6771))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (NULLP(CDR(BgL_cdrzd239105zd2_6768)))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd239084zd2_6764))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg5457z00_6776;
																																																																															BgL_arg5457z00_6776
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd239091zd2_6765));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_23923;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_23927;
																																																																																	obj_t
																																																																																		BgL_proc2z00_23926;
																																																																																	obj_t
																																																																																		BgL_proc1z00_23925;
																																																																																	obj_t
																																																																																		BgL_testz00_23924;
																																																																																	BgL_testz00_23924
																																																																																		=
																																																																																		BgL_arg5457z00_6776;
																																																																																	BgL_proc1z00_23925
																																																																																		=
																																																																																		BgL_carzd239104zd2_6767;
																																																																																	BgL_proc2z00_23926
																																																																																		=
																																																																																		BgL_carzd239112zd2_6771;
																																																																																	BgL_argsz00_23927
																																																																																		=
																																																																																		BgL_cdrzd239084zd2_6764;
																																																																																	BgL_argsz00_1752
																																																																																		=
																																																																																		BgL_argsz00_23927;
																																																																																	BgL_proc2z00_1751
																																																																																		=
																																																																																		BgL_proc2z00_23926;
																																																																																	BgL_proc1z00_1750
																																																																																		=
																																																																																		BgL_proc1z00_23925;
																																																																																	BgL_testz00_1749
																																																																																		=
																																																																																		BgL_testz00_23924;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1753;
																																																																																}
																																																																																BgL_auxz00_22101
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_23923);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1777;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_23931;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1778;
																																																																																	BgL_auxz00_22101
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_23931);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1777;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_23935;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1778;
																																																																															BgL_auxz00_22101
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_23935);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1777;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_23939;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1778;
																																																																													BgL_auxz00_22101
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_23939);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1777;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_23943;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1778;
																																																																											BgL_auxz00_22101
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_23943);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1777;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_23947;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1778;
																																																																									BgL_auxz00_22101
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_23947);
																																																																								}
																																																																						}
																																																																				}
																																																																			}
																																																																		}
																																																																	}
																																																															}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1777;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_23951;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1778;
																																																																	BgL_auxz00_22101
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_23951);
																																																																}
																																																														}
																																																												}
																																																											}
																																																									}
																																																								}
																																																						}
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_cdrzd239505zd2_6790;
																																																		BgL_cdrzd239505zd2_6790
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 119 */
																																																			bool_t
																																																				BgL_test9648z00_23955;
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg5485z00_6807;
																																																				BgL_arg5485z00_6807
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test9648z00_23955
																																																					=
																																																					CBOOL
																																																					(BGl_letzd2symzf3z21zzast_letz00
																																																					(BgL_arg5485z00_6807));
																																																			}
																																																			if (BgL_test9648z00_23955)
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_arg5473z00_6793;
																																																					obj_t
																																																						BgL_arg5474z00_6794;
																																																					BgL_arg5473z00_6793
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd239505zd2_6790));
																																																					BgL_arg5474z00_6794
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd239505zd2_6790));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_23964;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_23966;
																																																							obj_t
																																																								BgL_bindingsz00_23965;
																																																							BgL_bindingsz00_23965
																																																								=
																																																								BgL_arg5473z00_6793;
																																																							BgL_exprz00_23966
																																																								=
																																																								BgL_arg5474z00_6794;
																																																							BgL_exprz00_1732
																																																								=
																																																								BgL_exprz00_23966;
																																																							BgL_bindingsz00_1731
																																																								=
																																																								BgL_bindingsz00_23965;
																																																							goto
																																																								BgL_tagzd2382zd2_1733;
																																																						}
																																																						BgL_auxz00_22101
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_23964);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					bool_t
																																																						BgL_test9649z00_23968;
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg5484z00_6806;
																																																						BgL_arg5484z00_6806
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test9649z00_23968
																																																							=
																																																							CBOOL
																																																							(BGl_labelszd2symzf3z21zzast_labelsz00
																																																							(BgL_arg5484z00_6806));
																																																					}
																																																					if (BgL_test9649z00_23968)
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_23973;
																																																							goto
																																																								BgL_tagzd2384zd2_1735;
																																																							BgL_auxz00_22101
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_23973);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_carzd239571zd2_6797;
																																																							BgL_carzd239571zd2_6797
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd239576zd2_6798;
																																																								BgL_cdrzd239576zd2_6798
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_carzd239571zd2_6797));
																																																								if ((CAR(((obj_t) BgL_carzd239571zd2_6797)) == CNST_TABLE_REF(((long) 3))))
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg5479z00_6801;
																																																										obj_t
																																																											BgL_arg5480z00_6802;
																																																										obj_t
																																																											BgL_arg5481z00_6803;
																																																										BgL_arg5479z00_6801
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_cdrzd239576zd2_6798));
																																																										BgL_arg5480z00_6802
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_cdrzd239576zd2_6798));
																																																										BgL_arg5481z00_6803
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_23990;
																																																											{
																																																												obj_t
																																																													BgL_argsz00_23993;
																																																												obj_t
																																																													BgL_bodyz00_23992;
																																																												obj_t
																																																													BgL_varsz00_23991;
																																																												BgL_varsz00_23991
																																																													=
																																																													BgL_arg5479z00_6801;
																																																												BgL_bodyz00_23992
																																																													=
																																																													BgL_arg5480z00_6802;
																																																												BgL_argsz00_23993
																																																													=
																																																													BgL_arg5481z00_6803;
																																																												BgL_argsz00_1742
																																																													=
																																																													BgL_argsz00_23993;
																																																												BgL_bodyz00_1741
																																																													=
																																																													BgL_bodyz00_23992;
																																																												BgL_varsz00_1740
																																																													=
																																																													BgL_varsz00_23991;
																																																												goto
																																																													BgL_tagzd2386zd2_1743;
																																																											}
																																																											BgL_auxz00_22101
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_23990);
																																																										}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 119 */
																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																											{	/* Ast/sexp.scm 119 */
																																																												goto
																																																													BgL_tagzd2403zd2_1777;
																																																											}
																																																										else
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_23997;
																																																												goto
																																																													BgL_tagzd2404zd2_1778;
																																																												BgL_auxz00_22101
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_23997);
																																																											}
																																																									}
																																																							}
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_cdrzd239687zd2_6808;
																																																BgL_cdrzd239687zd2_6808
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 119 */
																																																	bool_t
																																																		BgL_test9652z00_24001;
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_arg5494z00_6817;
																																																		BgL_arg5494z00_6817
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_test9652z00_24001
																																																			=
																																																			CBOOL
																																																			(BGl_letzd2symzf3z21zzast_letz00
																																																			(BgL_arg5494z00_6817));
																																																	}
																																																	if (BgL_test9652z00_24001)
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg5488z00_6811;
																																																			obj_t
																																																				BgL_arg5489z00_6812;
																																																			BgL_arg5488z00_6811
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd239687zd2_6808));
																																																			BgL_arg5489z00_6812
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd239687zd2_6808));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_24010;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_24012;
																																																					obj_t
																																																						BgL_bindingsz00_24011;
																																																					BgL_bindingsz00_24011
																																																						=
																																																						BgL_arg5488z00_6811;
																																																					BgL_exprz00_24012
																																																						=
																																																						BgL_arg5489z00_6812;
																																																					BgL_exprz00_1732
																																																						=
																																																						BgL_exprz00_24012;
																																																					BgL_bindingsz00_1731
																																																						=
																																																						BgL_bindingsz00_24011;
																																																					goto
																																																						BgL_tagzd2382zd2_1733;
																																																				}
																																																				BgL_auxz00_22101
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_24010);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			bool_t
																																																				BgL_test9653z00_24014;
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg5493z00_6816;
																																																				BgL_arg5493z00_6816
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test9653z00_24014
																																																					=
																																																					CBOOL
																																																					(BGl_labelszd2symzf3z21zzast_labelsz00
																																																					(BgL_arg5493z00_6816));
																																																			}
																																																			if (BgL_test9653z00_24014)
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_24019;
																																																					goto
																																																						BgL_tagzd2384zd2_1735;
																																																					BgL_auxz00_22101
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_24019);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																						{	/* Ast/sexp.scm 119 */
																																																							goto
																																																								BgL_tagzd2403zd2_1777;
																																																						}
																																																					else
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_24023;
																																																							goto
																																																								BgL_tagzd2404zd2_1778;
																																																							BgL_auxz00_22101
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_24023);
																																																						}
																																																				}
																																																		}
																																																}
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd238252zd2_6544)))
																																															{	/* Ast/sexp.scm 119 */
																																																goto
																																																	BgL_kapzd238254zd2_6546;
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																if ((BgL_carzd238252zd2_6544 == CNST_TABLE_REF(((long) 18))))
																																																	{	/* Ast/sexp.scm 119 */
																																																		goto
																																																			BgL_kapzd238254zd2_6546;
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		if ((BgL_carzd238252zd2_6544 == CNST_TABLE_REF(((long) 19))))
																																																			{	/* Ast/sexp.scm 119 */
																																																				goto
																																																					BgL_kapzd238254zd2_6546;
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd238252zd2_6544)))
																																																					{	/* Ast/sexp.scm 119 */
																																																						goto
																																																							BgL_kapzd238254zd2_6546;
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd239859zd2_6552;
																																																						BgL_cdrzd239859zd2_6552
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{	/* Ast/sexp.scm 119 */
																																																							bool_t
																																																								BgL_test9659z00_24039;
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg5393z00_6669;
																																																								BgL_arg5393z00_6669
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test9659z00_24039
																																																									=
																																																									CBOOL
																																																									(BGl_letzd2symzf3z21zzast_letz00
																																																									(BgL_arg5393z00_6669));
																																																							}
																																																							if (BgL_test9659z00_24039)
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_arg5321z00_6555;
																																																									obj_t
																																																										BgL_arg5322z00_6556;
																																																									BgL_arg5321z00_6555
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd239859zd2_6552));
																																																									BgL_arg5322z00_6556
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd239859zd2_6552));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_24048;
																																																										{
																																																											obj_t
																																																												BgL_exprz00_24050;
																																																											obj_t
																																																												BgL_bindingsz00_24049;
																																																											BgL_bindingsz00_24049
																																																												=
																																																												BgL_arg5321z00_6555;
																																																											BgL_exprz00_24050
																																																												=
																																																												BgL_arg5322z00_6556;
																																																											BgL_exprz00_1732
																																																												=
																																																												BgL_exprz00_24050;
																																																											BgL_bindingsz00_1731
																																																												=
																																																												BgL_bindingsz00_24049;
																																																											goto
																																																												BgL_tagzd2382zd2_1733;
																																																										}
																																																										BgL_auxz00_22101
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_24048);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									bool_t
																																																										BgL_test9660z00_24052;
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg5392z00_6668;
																																																										BgL_arg5392z00_6668
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_test9660z00_24052
																																																											=
																																																											CBOOL
																																																											(BGl_labelszd2symzf3z21zzast_labelsz00
																																																											(BgL_arg5392z00_6668));
																																																									}
																																																									if (BgL_test9660z00_24052)
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_24057;
																																																											goto
																																																												BgL_tagzd2384zd2_1735;
																																																											BgL_auxz00_22101
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_24057);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_carzd239925zd2_6559;
																																																											BgL_carzd239925zd2_6559
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd239930zd2_6560;
																																																												BgL_cdrzd239930zd2_6560
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_carzd239925zd2_6559));
																																																												if ((CAR(((obj_t) BgL_carzd239925zd2_6559)) == CNST_TABLE_REF(((long) 3))))
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (PAIRP(BgL_cdrzd239930zd2_6560))
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_arg5328z00_6564;
																																																																obj_t
																																																																	BgL_arg5329z00_6565;
																																																																obj_t
																																																																	BgL_arg5330z00_6566;
																																																																BgL_arg5328z00_6564
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd239930zd2_6560);
																																																																BgL_arg5329z00_6565
																																																																	=
																																																																	CDR
																																																																	(BgL_cdrzd239930zd2_6560);
																																																																BgL_arg5330z00_6566
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_24074;
																																																																	{
																																																																		obj_t
																																																																			BgL_argsz00_24077;
																																																																		obj_t
																																																																			BgL_bodyz00_24076;
																																																																		obj_t
																																																																			BgL_varsz00_24075;
																																																																		BgL_varsz00_24075
																																																																			=
																																																																			BgL_arg5328z00_6564;
																																																																		BgL_bodyz00_24076
																																																																			=
																																																																			BgL_arg5329z00_6565;
																																																																		BgL_argsz00_24077
																																																																			=
																																																																			BgL_arg5330z00_6566;
																																																																		BgL_argsz00_1742
																																																																			=
																																																																			BgL_argsz00_24077;
																																																																		BgL_bodyz00_1741
																																																																			=
																																																																			BgL_bodyz00_24076;
																																																																		BgL_varsz00_1740
																																																																			=
																																																																			BgL_varsz00_24075;
																																																																		goto
																																																																			BgL_tagzd2386zd2_1743;
																																																																	}
																																																																	BgL_auxz00_22101
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_24074);
																																																																}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1777;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_24081;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1778;
																																																																		BgL_auxz00_22101
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_24081);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd240037zd2_6569;
																																																														BgL_cdrzd240037zd2_6569
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd240042zd2_6570;
																																																															BgL_cdrzd240042zd2_6570
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_carzd239925zd2_6559));
																																																															if ((CAR(((obj_t) BgL_carzd239925zd2_6559)) == CNST_TABLE_REF(((long) 1))))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (PAIRP(BgL_cdrzd240042zd2_6570))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd240047zd2_6574;
																																																																			BgL_cdrzd240047zd2_6574
																																																																				=
																																																																				CDR
																																																																				(BgL_cdrzd240042zd2_6570);
																																																																			if (PAIRP(BgL_cdrzd240047zd2_6574))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_carzd240051zd2_6576;
																																																																					obj_t
																																																																						BgL_cdrzd240052zd2_6577;
																																																																					BgL_carzd240051zd2_6576
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd240047zd2_6574);
																																																																					BgL_cdrzd240052zd2_6577
																																																																						=
																																																																						CDR
																																																																						(BgL_cdrzd240047zd2_6574);
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd240051zd2_6576))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (PAIRP(BgL_cdrzd240052zd2_6577))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd240057zd2_6580;
																																																																									BgL_carzd240057zd2_6580
																																																																										=
																																																																										CAR
																																																																										(BgL_cdrzd240052zd2_6577);
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd240057zd2_6580))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (NULLP(CDR(BgL_cdrzd240052zd2_6577)))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													bool_t
																																																																														BgL_test9671z00_24109;
																																																																													{
																																																																														obj_t
																																																																															BgL_l1435z00_6613;
																																																																														BgL_l1435z00_6613
																																																																															=
																																																																															BgL_cdrzd240037zd2_6569;
																																																																													BgL_zc3z04anonymousza35356ze3z87_6614:
																																																																														if (NULLP(BgL_l1435z00_6613))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																BgL_test9671z00_24109
																																																																																	=
																																																																																	(
																																																																																	(bool_t)
																																																																																	1);
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																bool_t
																																																																																	BgL_test9673z00_24112;
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	bool_t
																																																																																		BgL_test9674z00_24113;
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_tmpz00_24114;
																																																																																		BgL_tmpz00_24114
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_l1435z00_6613));
																																																																																		BgL_test9674z00_24113
																																																																																			=
																																																																																			PAIRP
																																																																																			(BgL_tmpz00_24114);
																																																																																	}
																																																																																	if (BgL_test9674z00_24113)
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			BgL_test9673z00_24112
																																																																																				=
																																																																																				(
																																																																																				(bool_t)
																																																																																				0);
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			BgL_test9673z00_24112
																																																																																				=
																																																																																				(
																																																																																				(bool_t)
																																																																																				1);
																																																																																		}
																																																																																}
																																																																																if (BgL_test9673z00_24112)
																																																																																	{
																																																																																		obj_t
																																																																																			BgL_l1435z00_24118;
																																																																																		BgL_l1435z00_24118
																																																																																			=
																																																																																			CDR
																																																																																			(
																																																																																			((obj_t) BgL_l1435z00_6613));
																																																																																		BgL_l1435z00_6613
																																																																																			=
																																																																																			BgL_l1435z00_24118;
																																																																																		goto
																																																																																			BgL_zc3z04anonymousza35356ze3z87_6614;
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		BgL_test9671z00_24109
																																																																																			=
																																																																																			(
																																																																																			(bool_t)
																																																																																			0);
																																																																																	}
																																																																															}
																																																																													}
																																																																													if (BgL_test9671z00_24109)
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg5346z00_6596;
																																																																															BgL_arg5346z00_6596
																																																																																=
																																																																																CAR
																																																																																(BgL_cdrzd240042zd2_6570);
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_24122;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_24126;
																																																																																	obj_t
																																																																																		BgL_proc2z00_24125;
																																																																																	obj_t
																																																																																		BgL_proc1z00_24124;
																																																																																	obj_t
																																																																																		BgL_testz00_24123;
																																																																																	BgL_testz00_24123
																																																																																		=
																																																																																		BgL_arg5346z00_6596;
																																																																																	BgL_proc1z00_24124
																																																																																		=
																																																																																		BgL_carzd240051zd2_6576;
																																																																																	BgL_proc2z00_24125
																																																																																		=
																																																																																		BgL_carzd240057zd2_6580;
																																																																																	BgL_argsz00_24126
																																																																																		=
																																																																																		BgL_cdrzd240037zd2_6569;
																																																																																	BgL_argsz00_1747
																																																																																		=
																																																																																		BgL_argsz00_24126;
																																																																																	BgL_proc2z00_1746
																																																																																		=
																																																																																		BgL_proc2z00_24125;
																																																																																	BgL_proc1z00_1745
																																																																																		=
																																																																																		BgL_proc1z00_24124;
																																																																																	BgL_testz00_1744
																																																																																		=
																																																																																		BgL_testz00_24123;
																																																																																	goto
																																																																																		BgL_tagzd2387zd2_1748;
																																																																																}
																																																																																BgL_auxz00_22101
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_24122);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_cdrzd240082zd2_6597;
																																																																															BgL_cdrzd240082zd2_6597
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_cdrzd240090zd2_6598;
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_pairz00_12309;
																																																																																	BgL_pairz00_12309
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_expz00_21));
																																																																																	BgL_cdrzd240090zd2_6598
																																																																																		=
																																																																																		CDR
																																																																																		(BgL_pairz00_12309);
																																																																																}
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_cdrzd240098zd2_6599;
																																																																																	BgL_cdrzd240098zd2_6599
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd240090zd2_6598));
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_carzd240105zd2_6600;
																																																																																		BgL_carzd240105zd2_6600
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd240098zd2_6599));
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd240105zd2_6600))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_carzd240114zd2_6602;
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					obj_t
																																																																																						BgL_pairz00_12313;
																																																																																					BgL_pairz00_12313
																																																																																						=
																																																																																						CDR
																																																																																						(
																																																																																						((obj_t) BgL_cdrzd240098zd2_6599));
																																																																																					BgL_carzd240114zd2_6602
																																																																																						=
																																																																																						CAR
																																																																																						(BgL_pairz00_12313);
																																																																																				}
																																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd240114zd2_6602))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd240082zd2_6597))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								obj_t
																																																																																									BgL_arg5350z00_6605;
																																																																																								BgL_arg5350z00_6605
																																																																																									=
																																																																																									CAR
																																																																																									(
																																																																																									((obj_t) BgL_cdrzd240090zd2_6598));
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_24148;
																																																																																									{
																																																																																										obj_t
																																																																																											BgL_argsz00_24152;
																																																																																										obj_t
																																																																																											BgL_proc2z00_24151;
																																																																																										obj_t
																																																																																											BgL_proc1z00_24150;
																																																																																										obj_t
																																																																																											BgL_testz00_24149;
																																																																																										BgL_testz00_24149
																																																																																											=
																																																																																											BgL_arg5350z00_6605;
																																																																																										BgL_proc1z00_24150
																																																																																											=
																																																																																											BgL_carzd240105zd2_6600;
																																																																																										BgL_proc2z00_24151
																																																																																											=
																																																																																											BgL_carzd240114zd2_6602;
																																																																																										BgL_argsz00_24152
																																																																																											=
																																																																																											BgL_cdrzd240082zd2_6597;
																																																																																										BgL_argsz00_1752
																																																																																											=
																																																																																											BgL_argsz00_24152;
																																																																																										BgL_proc2z00_1751
																																																																																											=
																																																																																											BgL_proc2z00_24151;
																																																																																										BgL_proc1z00_1750
																																																																																											=
																																																																																											BgL_proc1z00_24150;
																																																																																										BgL_testz00_1749
																																																																																											=
																																																																																											BgL_testz00_24149;
																																																																																										goto
																																																																																											BgL_tagzd2388zd2_1753;
																																																																																									}
																																																																																									BgL_auxz00_22101
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_24148);
																																																																																								}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1777;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_24156;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1778;
																																																																																										BgL_auxz00_22101
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_24156);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1777;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_24160;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1778;
																																																																																								BgL_auxz00_22101
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_24160);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1777;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_24164;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1778;
																																																																																						BgL_auxz00_22101
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_24164);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																}
																																																																															}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1777;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_24168;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1778;
																																																																															BgL_auxz00_22101
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_24168);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd240392zd2_6624;
																																																																											BgL_cdrzd240392zd2_6624
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_cdrzd240399zd2_6625;
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_pairz00_12317;
																																																																													BgL_pairz00_12317
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													BgL_cdrzd240399zd2_6625
																																																																														=
																																																																														CDR
																																																																														(BgL_pairz00_12317);
																																																																												}
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd240406zd2_6626;
																																																																													BgL_cdrzd240406zd2_6626
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd240399zd2_6625));
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_carzd240412zd2_6627;
																																																																														obj_t
																																																																															BgL_cdrzd240413zd2_6628;
																																																																														BgL_carzd240412zd2_6627
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd240406zd2_6626));
																																																																														BgL_cdrzd240413zd2_6628
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd240406zd2_6626));
																																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd240412zd2_6627))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_carzd240420zd2_6630;
																																																																																BgL_carzd240420zd2_6630
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd240413zd2_6628));
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd240420zd2_6630))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (NULLP(CDR(((obj_t) BgL_cdrzd240413zd2_6628))))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd240392zd2_6624))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						obj_t
																																																																																							BgL_arg5365z00_6635;
																																																																																						BgL_arg5365z00_6635
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd240399zd2_6625));
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_24195;
																																																																																							{
																																																																																								obj_t
																																																																																									BgL_argsz00_24199;
																																																																																								obj_t
																																																																																									BgL_proc2z00_24198;
																																																																																								obj_t
																																																																																									BgL_proc1z00_24197;
																																																																																								obj_t
																																																																																									BgL_testz00_24196;
																																																																																								BgL_testz00_24196
																																																																																									=
																																																																																									BgL_arg5365z00_6635;
																																																																																								BgL_proc1z00_24197
																																																																																									=
																																																																																									BgL_carzd240412zd2_6627;
																																																																																								BgL_proc2z00_24198
																																																																																									=
																																																																																									BgL_carzd240420zd2_6630;
																																																																																								BgL_argsz00_24199
																																																																																									=
																																																																																									BgL_cdrzd240392zd2_6624;
																																																																																								BgL_argsz00_1752
																																																																																									=
																																																																																									BgL_argsz00_24199;
																																																																																								BgL_proc2z00_1751
																																																																																									=
																																																																																									BgL_proc2z00_24198;
																																																																																								BgL_proc1z00_1750
																																																																																									=
																																																																																									BgL_proc1z00_24197;
																																																																																								BgL_testz00_1749
																																																																																									=
																																																																																									BgL_testz00_24196;
																																																																																								goto
																																																																																									BgL_tagzd2388zd2_1753;
																																																																																							}
																																																																																							BgL_auxz00_22101
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_24195);
																																																																																						}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1777;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_24203;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1778;
																																																																																								BgL_auxz00_22101
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_24203);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1777;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_24207;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1778;
																																																																																						BgL_auxz00_22101
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_24207);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1777;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_24211;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1778;
																																																																																				BgL_auxz00_22101
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_24211);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1777;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_24215;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1778;
																																																																																		BgL_auxz00_22101
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_24215);
																																																																																	}
																																																																															}
																																																																													}
																																																																												}
																																																																											}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1777;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_24219;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1778;
																																																																											BgL_auxz00_22101
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_24219);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd240753zd2_6643;
																																																																							BgL_cdrzd240753zd2_6643
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd240759zd2_6644;
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_pairz00_12327;
																																																																									BgL_pairz00_12327
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									BgL_cdrzd240759zd2_6644
																																																																										=
																																																																										CDR
																																																																										(BgL_pairz00_12327);
																																																																								}
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd240765zd2_6645;
																																																																									BgL_cdrzd240765zd2_6645
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd240759zd2_6644));
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_carzd240770zd2_6646;
																																																																										obj_t
																																																																											BgL_cdrzd240771zd2_6647;
																																																																										BgL_carzd240770zd2_6646
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd240765zd2_6645));
																																																																										BgL_cdrzd240771zd2_6647
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd240765zd2_6645));
																																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd240770zd2_6646))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (PAIRP(BgL_cdrzd240771zd2_6647))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_carzd240776zd2_6650;
																																																																														BgL_carzd240776zd2_6650
																																																																															=
																																																																															CAR
																																																																															(BgL_cdrzd240771zd2_6647);
																																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd240776zd2_6650))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (NULLP(CDR(BgL_cdrzd240771zd2_6647)))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd240753zd2_6643))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_arg5379z00_6655;
																																																																																				BgL_arg5379z00_6655
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd240759zd2_6644));
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_24246;
																																																																																					{
																																																																																						obj_t
																																																																																							BgL_argsz00_24250;
																																																																																						obj_t
																																																																																							BgL_proc2z00_24249;
																																																																																						obj_t
																																																																																							BgL_proc1z00_24248;
																																																																																						obj_t
																																																																																							BgL_testz00_24247;
																																																																																						BgL_testz00_24247
																																																																																							=
																																																																																							BgL_arg5379z00_6655;
																																																																																						BgL_proc1z00_24248
																																																																																							=
																																																																																							BgL_carzd240770zd2_6646;
																																																																																						BgL_proc2z00_24249
																																																																																							=
																																																																																							BgL_carzd240776zd2_6650;
																																																																																						BgL_argsz00_24250
																																																																																							=
																																																																																							BgL_cdrzd240753zd2_6643;
																																																																																						BgL_argsz00_1752
																																																																																							=
																																																																																							BgL_argsz00_24250;
																																																																																						BgL_proc2z00_1751
																																																																																							=
																																																																																							BgL_proc2z00_24249;
																																																																																						BgL_proc1z00_1750
																																																																																							=
																																																																																							BgL_proc1z00_24248;
																																																																																						BgL_testz00_1749
																																																																																							=
																																																																																							BgL_testz00_24247;
																																																																																						goto
																																																																																							BgL_tagzd2388zd2_1753;
																																																																																					}
																																																																																					BgL_auxz00_22101
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_24246);
																																																																																				}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1777;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_24254;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1778;
																																																																																						BgL_auxz00_22101
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_24254);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1777;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_24258;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1778;
																																																																																				BgL_auxz00_22101
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_24258);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1777;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_24262;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1778;
																																																																																		BgL_auxz00_22101
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_24262);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1777;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_24266;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1778;
																																																																																BgL_auxz00_22101
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_24266);
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1777;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_24270;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1778;
																																																																														BgL_auxz00_22101
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_24270);
																																																																													}
																																																																											}
																																																																									}
																																																																								}
																																																																							}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1777;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_24274;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1778;
																																																																							BgL_auxz00_22101
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_24274);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1777;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_24278;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1778;
																																																																					BgL_auxz00_22101
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_24278);
																																																																				}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1777;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_24282;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1778;
																																																																			BgL_auxz00_22101
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_24282);
																																																																		}
																																																																}
																																																														}
																																																													}
																																																											}
																																																										}
																																																								}
																																																						}
																																																					}
																																																			}
																																																	}
																																															}
																																													}
																																											}
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_cdrzd241314zd2_6819;
																																											BgL_cdrzd241314zd2_6819
																																												=
																																												CDR
																																												(
																																												((obj_t) BgL_expz00_21));
																																											if ((BgL_carzd238249zd2_6542 == CNST_TABLE_REF(((long) 17))))
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_arg5496z00_6821;
																																													obj_t
																																														BgL_arg5497z00_6822;
																																													BgL_arg5496z00_6821
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_cdrzd241314zd2_6819));
																																													BgL_arg5497z00_6822
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_cdrzd241314zd2_6819));
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_24293;
																																														{
																																															obj_t
																																																BgL_exprz00_24295;
																																															obj_t
																																																BgL_bindingsz00_24294;
																																															BgL_bindingsz00_24294
																																																=
																																																BgL_arg5496z00_6821;
																																															BgL_exprz00_24295
																																																=
																																																BgL_arg5497z00_6822;
																																															BgL_exprz00_1732
																																																=
																																																BgL_exprz00_24295;
																																															BgL_bindingsz00_1731
																																																=
																																																BgL_bindingsz00_24294;
																																															goto
																																																BgL_tagzd2382zd2_1733;
																																														}
																																														BgL_auxz00_22101
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_24293);
																																													}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd238249zd2_6542)))
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg5499z00_6824;
																																															obj_t
																																																BgL_arg5500z00_6825;
																																															BgL_arg5499z00_6824
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd241314zd2_6819));
																																															BgL_arg5500z00_6825
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd241314zd2_6819));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_24304;
																																																{
																																																	obj_t
																																																		BgL_exprz00_24306;
																																																	obj_t
																																																		BgL_bindingsz00_24305;
																																																	BgL_bindingsz00_24305
																																																		=
																																																		BgL_arg5499z00_6824;
																																																	BgL_exprz00_24306
																																																		=
																																																		BgL_arg5500z00_6825;
																																																	BgL_exprz00_1732
																																																		=
																																																		BgL_exprz00_24306;
																																																	BgL_bindingsz00_1731
																																																		=
																																																		BgL_bindingsz00_24305;
																																																	goto
																																																		BgL_tagzd2382zd2_1733;
																																																}
																																																BgL_auxz00_22101
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_24304);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															if ((BgL_carzd238249zd2_6542 == CNST_TABLE_REF(((long) 18))))
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg5502z00_6827;
																																																	obj_t
																																																		BgL_arg5503z00_6828;
																																																	BgL_arg5502z00_6827
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd241314zd2_6819));
																																																	BgL_arg5503z00_6828
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd241314zd2_6819));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_24315;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_24317;
																																																			obj_t
																																																				BgL_bindingsz00_24316;
																																																			BgL_bindingsz00_24316
																																																				=
																																																				BgL_arg5502z00_6827;
																																																			BgL_exprz00_24317
																																																				=
																																																				BgL_arg5503z00_6828;
																																																			BgL_exprz00_1732
																																																				=
																																																				BgL_exprz00_24317;
																																																			BgL_bindingsz00_1731
																																																				=
																																																				BgL_bindingsz00_24316;
																																																			goto
																																																				BgL_tagzd2382zd2_1733;
																																																		}
																																																		BgL_auxz00_22101
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_24315);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_24324;
																																																			goto
																																																				BgL_tagzd2383zd2_1734;
																																																			BgL_auxz00_22101
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_24324);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_carzd241351zd2_6831;
																																																			BgL_carzd241351zd2_6831
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			if ((BgL_carzd241351zd2_6831 == CNST_TABLE_REF(((long) 19))))
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_24331;
																																																					goto
																																																						BgL_tagzd2384zd2_1735;
																																																					BgL_auxz00_22101
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_24331);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd241351zd2_6831)))
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_24336;
																																																							goto
																																																								BgL_tagzd2384zd2_1735;
																																																							BgL_auxz00_22101
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_24336);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_24343;
																																																									goto
																																																										BgL_tagzd2389zd2_1754;
																																																									BgL_auxz00_22101
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_24343);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_24350;
																																																											goto
																																																												BgL_tagzd2390zd2_1755;
																																																											BgL_auxz00_22101
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_24350);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_cdrzd241431zd2_6838;
																																																											BgL_cdrzd241431zd2_6838
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_arg5514z00_6841;
																																																													obj_t
																																																														BgL_arg5515z00_6842;
																																																													BgL_arg5514z00_6841
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_cdrzd241431zd2_6838));
																																																													BgL_arg5515z00_6842
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd241431zd2_6838));
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_24363;
																																																														{
																																																															obj_t
																																																																BgL_restz00_24365;
																																																															obj_t
																																																																BgL_effectz00_24364;
																																																															BgL_effectz00_24364
																																																																=
																																																																BgL_arg5514z00_6841;
																																																															BgL_restz00_24365
																																																																=
																																																																BgL_arg5515z00_6842;
																																																															BgL_restz00_1757
																																																																=
																																																																BgL_restz00_24365;
																																																															BgL_effectz00_1756
																																																																=
																																																																BgL_effectz00_24364;
																																																															goto
																																																																BgL_tagzd2391zd2_1758;
																																																														}
																																																														BgL_auxz00_22101
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_24363);
																																																													}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_24372;
																																																															goto
																																																																BgL_tagzd2392zd2_1759;
																																																															BgL_auxz00_22101
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_24372);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_24379;
																																																																	goto
																																																																		BgL_tagzd2393zd2_1760;
																																																																	BgL_auxz00_22101
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_24379);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_arg5522z00_6850;
																																																																			obj_t
																																																																				BgL_arg5523z00_6851;
																																																																			BgL_arg5522z00_6850
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd241431zd2_6838));
																																																																			BgL_arg5523z00_6851
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd241431zd2_6838));
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_24390;
																																																																				{
																																																																					obj_t
																																																																						BgL_restz00_24392;
																																																																					obj_t
																																																																						BgL_effectz00_24391;
																																																																					BgL_effectz00_24391
																																																																						=
																																																																						BgL_arg5522z00_6850;
																																																																					BgL_restz00_24392
																																																																						=
																																																																						BgL_arg5523z00_6851;
																																																																					BgL_restz00_1762
																																																																						=
																																																																						BgL_restz00_24392;
																																																																					BgL_effectz00_1761
																																																																						=
																																																																						BgL_effectz00_24391;
																																																																					goto
																																																																						BgL_tagzd2394zd2_1763;
																																																																				}
																																																																				BgL_auxz00_22101
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_24390);
																																																																			}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_24399;
																																																																					goto
																																																																						BgL_tagzd2395zd2_1764;
																																																																					BgL_auxz00_22101
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_24399);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_24406;
																																																																							goto
																																																																								BgL_tagzd2396zd2_1765;
																																																																							BgL_auxz00_22101
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_24406);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																								{
																																																																									BgL_letzd2funzd2_bglt
																																																																										BgL_auxz00_24413;
																																																																									goto
																																																																										BgL_tagzd2397zd2_1766;
																																																																									BgL_auxz00_22101
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_24413);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																										{
																																																																											BgL_jumpzd2exzd2itz00_bglt
																																																																												BgL_auxz00_24420;
																																																																											goto
																																																																												BgL_tagzd2398zd2_1767;
																																																																											BgL_auxz00_22101
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_24420);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd241508zd2_6860;
																																																																											BgL_cdrzd241508zd2_6860
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_arg5534z00_6863;
																																																																													obj_t
																																																																														BgL_arg5535z00_6864;
																																																																													BgL_arg5534z00_6863
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd241508zd2_6860));
																																																																													BgL_arg5535z00_6864
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd241508zd2_6860));
																																																																													{	/* Ast/sexp.scm 552 */
																																																																														obj_t
																																																																															BgL_arg6965z00_12366;
																																																																														BgL_arg6965z00_12366
																																																																															=
																																																																															BGl_findzd2locationzf2locz20zztools_locationz00
																																																																															(BgL_expz00_21,
																																																																															BgL_locz00_23);
																																																																														BgL_auxz00_22101
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																															(BgL_expz00_21,
																																																																																BgL_arg5534z00_6863,
																																																																																CNST_TABLE_REF
																																																																																(((long) 4)), BgL_arg5535z00_6864, BgL_stackz00_22, BgL_arg6965z00_12366, BgL_sitez00_24));
																																																																												}}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1777;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_24439;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1778;
																																																																															BgL_auxz00_22101
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_24439);
																																																																														}
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																													else
																														{	/* Ast/sexp.scm 119 */
																															obj_t
																																BgL_carzd241533zd2_6881;
																															BgL_carzd241533zd2_6881
																																=
																																CAR(((obj_t)
																																	BgL_expz00_21));
																															if (
																																(BgL_carzd241533zd2_6881
																																	==
																																	CNST_TABLE_REF
																																	(((long) 1))))
																																{
																																	BgL_nodez00_bglt
																																		BgL_auxz00_24446;
																																	goto
																																		BgL_tagzd2377zd2_1722;
																																	BgL_auxz00_22101
																																		=
																																		((obj_t)
																																		BgL_auxz00_24446);
																																}
																															else
																																{	/* Ast/sexp.scm 119 */
																																	if (
																																		(BgL_carzd241533zd2_6881
																																			==
																																			BGl_za2ifza2z00zzast_sexpz00))
																																		{
																																			BgL_nodez00_bglt
																																				BgL_auxz00_24450;
																																			goto
																																				BgL_tagzd2377zd2_1722;
																																			BgL_auxz00_22101
																																				=
																																				((obj_t)
																																				BgL_auxz00_24450);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 119 */
																																			obj_t
																																				BgL_cdrzd241555zd2_6884;
																																			BgL_cdrzd241555zd2_6884
																																				=
																																				CDR((
																																					(obj_t)
																																					BgL_expz00_21));
																																			if ((CAR((
																																							(obj_t)
																																							BgL_expz00_21))
																																					==
																																					CNST_TABLE_REF
																																					(((long) 7))))
																																				{	/* Ast/sexp.scm 119 */
																																					obj_t
																																						BgL_carzd241558zd2_6887;
																																					obj_t
																																						BgL_cdrzd241559zd2_6888;
																																					BgL_carzd241558zd2_6887
																																						=
																																						CAR(
																																						((obj_t) BgL_cdrzd241555zd2_6884));
																																					BgL_cdrzd241559zd2_6888
																																						=
																																						CDR(
																																						((obj_t) BgL_cdrzd241555zd2_6884));
																																					if (PAIRP(BgL_carzd241558zd2_6887))
																																						{	/* Ast/sexp.scm 119 */
																																							if ((CAR(BgL_carzd241558zd2_6887) == CNST_TABLE_REF(((long) 14))))
																																								{	/* Ast/sexp.scm 119 */
																																									if (NULLP(CDR(((obj_t) BgL_cdrzd241559zd2_6888))))
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_arg5561z00_6894;
																																											obj_t
																																												BgL_arg5562z00_6895;
																																											BgL_arg5561z00_6894
																																												=
																																												CDR
																																												(BgL_carzd241558zd2_6887);
																																											BgL_arg5562z00_6895
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_cdrzd241559zd2_6888));
																																											{
																																												BgL_nodez00_bglt
																																													BgL_auxz00_24476;
																																												{
																																													obj_t
																																														BgL_valz00_24478;
																																													obj_t
																																														BgL_lz00_24477;
																																													BgL_lz00_24477
																																														=
																																														BgL_arg5561z00_6894;
																																													BgL_valz00_24478
																																														=
																																														BgL_arg5562z00_6895;
																																													BgL_valz00_1724
																																														=
																																														BgL_valz00_24478;
																																													BgL_lz00_1723
																																														=
																																														BgL_lz00_24477;
																																													goto
																																														BgL_tagzd2378zd2_1725;
																																												}
																																												BgL_auxz00_22101
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_24476);
																																											}
																																										}
																																									else
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_24480;
																																											goto
																																												BgL_tagzd2379zd2_1726;
																																											BgL_auxz00_22101
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_24480);
																																										}
																																								}
																																							else
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_24482;
																																									goto
																																										BgL_tagzd2379zd2_1726;
																																									BgL_auxz00_22101
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_24482);
																																								}
																																						}
																																					else
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_24484;
																																							goto
																																								BgL_tagzd2379zd2_1726;
																																							BgL_auxz00_22101
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_24484);
																																						}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					if (
																																						(CAR
																																							(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_24491;
																																							goto
																																								BgL_tagzd2380zd2_1727;
																																							BgL_auxz00_22101
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_24491);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							obj_t
																																								BgL_carzd241656zd2_6900;
																																							BgL_carzd241656zd2_6900
																																								=
																																								CAR
																																								(
																																								((obj_t) BgL_expz00_21));
																																							if (PAIRP(BgL_carzd241656zd2_6900))
																																								{	/* Ast/sexp.scm 119 */
																																									obj_t
																																										BgL_carzd241659zd2_6902;
																																									obj_t
																																										BgL_cdrzd241660zd2_6903;
																																									BgL_carzd241659zd2_6902
																																										=
																																										CAR
																																										(BgL_carzd241656zd2_6900);
																																									BgL_cdrzd241660zd2_6903
																																										=
																																										CDR
																																										(BgL_carzd241656zd2_6900);
																																									{

																																										if ((BgL_carzd241659zd2_6902 == CNST_TABLE_REF(((long) 17))))
																																											{	/* Ast/sexp.scm 119 */
																																											BgL_kapzd241661zd2_6904:
																																												if (PAIRP(BgL_cdrzd241660zd2_6903))
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_cdrzd241664zd2_7029;
																																														BgL_cdrzd241664zd2_7029
																																															=
																																															CDR
																																															(BgL_cdrzd241660zd2_6903);
																																														if (PAIRP(BgL_cdrzd241664zd2_7029))
																																															{	/* Ast/sexp.scm 119 */
																																																if (NULLP(CDR(BgL_cdrzd241664zd2_7029)))
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_arg5652z00_7033;
																																																		obj_t
																																																			BgL_arg5653z00_7034;
																																																		BgL_arg5652z00_7033
																																																			=
																																																			CAR
																																																			(BgL_cdrzd241664zd2_7029);
																																																		BgL_arg5653z00_7034
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_24513;
																																																			{
																																																				obj_t
																																																					BgL_argsz00_24515;
																																																				obj_t
																																																					BgL_bodyz00_24514;
																																																				BgL_bodyz00_24514
																																																					=
																																																					BgL_arg5652z00_7033;
																																																				BgL_argsz00_24515
																																																					=
																																																					BgL_arg5653z00_7034;
																																																				BgL_argsz00_1729
																																																					=
																																																					BgL_argsz00_24515;
																																																				BgL_bodyz00_1728
																																																					=
																																																					BgL_bodyz00_24514;
																																																				goto
																																																					BgL_tagzd2381zd2_1730;
																																																			}
																																																			BgL_auxz00_22101
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_24513);
																																																		}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_cdrzd241688zd2_7035;
																																																		BgL_cdrzd241688zd2_7035
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 119 */
																																																			bool_t
																																																				BgL_test9734z00_24519;
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg5722z00_7146;
																																																				BgL_arg5722z00_7146
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test9734z00_24519
																																																					=
																																																					CBOOL
																																																					(BGl_letzd2symzf3z21zzast_letz00
																																																					(BgL_arg5722z00_7146));
																																																			}
																																																			if (BgL_test9734z00_24519)
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_arg5656z00_7038;
																																																					obj_t
																																																						BgL_arg5657z00_7039;
																																																					BgL_arg5656z00_7038
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd241688zd2_7035));
																																																					BgL_arg5657z00_7039
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd241688zd2_7035));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_24528;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_24530;
																																																							obj_t
																																																								BgL_bindingsz00_24529;
																																																							BgL_bindingsz00_24529
																																																								=
																																																								BgL_arg5656z00_7038;
																																																							BgL_exprz00_24530
																																																								=
																																																								BgL_arg5657z00_7039;
																																																							BgL_exprz00_1732
																																																								=
																																																								BgL_exprz00_24530;
																																																							BgL_bindingsz00_1731
																																																								=
																																																								BgL_bindingsz00_24529;
																																																							goto
																																																								BgL_tagzd2382zd2_1733;
																																																						}
																																																						BgL_auxz00_22101
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_24528);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					bool_t
																																																						BgL_test9735z00_24532;
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg5721z00_7145;
																																																						BgL_arg5721z00_7145
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test9735z00_24532
																																																							=
																																																							CBOOL
																																																							(BGl_labelszd2symzf3z21zzast_labelsz00
																																																							(BgL_arg5721z00_7145));
																																																					}
																																																					if (BgL_test9735z00_24532)
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_24537;
																																																							goto
																																																								BgL_tagzd2384zd2_1735;
																																																							BgL_auxz00_22101
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_24537);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_carzd241755zd2_7042;
																																																							BgL_carzd241755zd2_7042
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd241760zd2_7043;
																																																								BgL_cdrzd241760zd2_7043
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_carzd241755zd2_7042));
																																																								if ((CAR(((obj_t) BgL_carzd241755zd2_7042)) == CNST_TABLE_REF(((long) 3))))
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg5662z00_7046;
																																																										obj_t
																																																											BgL_arg5663z00_7047;
																																																										obj_t
																																																											BgL_arg5664z00_7048;
																																																										BgL_arg5662z00_7046
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_cdrzd241760zd2_7043));
																																																										BgL_arg5663z00_7047
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_cdrzd241760zd2_7043));
																																																										BgL_arg5664z00_7048
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_24554;
																																																											{
																																																												obj_t
																																																													BgL_argsz00_24557;
																																																												obj_t
																																																													BgL_bodyz00_24556;
																																																												obj_t
																																																													BgL_varsz00_24555;
																																																												BgL_varsz00_24555
																																																													=
																																																													BgL_arg5662z00_7046;
																																																												BgL_bodyz00_24556
																																																													=
																																																													BgL_arg5663z00_7047;
																																																												BgL_argsz00_24557
																																																													=
																																																													BgL_arg5664z00_7048;
																																																												BgL_argsz00_1742
																																																													=
																																																													BgL_argsz00_24557;
																																																												BgL_bodyz00_1741
																																																													=
																																																													BgL_bodyz00_24556;
																																																												BgL_varsz00_1740
																																																													=
																																																													BgL_varsz00_24555;
																																																												goto
																																																													BgL_tagzd2386zd2_1743;
																																																											}
																																																											BgL_auxz00_22101
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_24554);
																																																										}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd241783zd2_7050;
																																																										BgL_cdrzd241783zd2_7050
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_cdrzd241789zd2_7051;
																																																											BgL_cdrzd241789zd2_7051
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_carzd241755zd2_7042));
																																																											if ((CAR(((obj_t) BgL_carzd241755zd2_7042)) == CNST_TABLE_REF(((long) 1))))
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd241795zd2_7054;
																																																													BgL_cdrzd241795zd2_7054
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd241789zd2_7051));
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_carzd241800zd2_7055;
																																																														obj_t
																																																															BgL_cdrzd241801zd2_7056;
																																																														BgL_carzd241800zd2_7055
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd241795zd2_7054));
																																																														BgL_cdrzd241801zd2_7056
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd241795zd2_7054));
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd241800zd2_7055))
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (PAIRP(BgL_cdrzd241801zd2_7056))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_carzd241808zd2_7059;
																																																																		BgL_carzd241808zd2_7059
																																																																			=
																																																																			CAR
																																																																			(BgL_cdrzd241801zd2_7056);
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd241808zd2_7059))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (NULLP(CDR(BgL_cdrzd241801zd2_7056)))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						bool_t
																																																																							BgL_test9742z00_24584;
																																																																						{
																																																																							obj_t
																																																																								BgL_l1438z00_7092;
																																																																							BgL_l1438z00_7092
																																																																								=
																																																																								BgL_cdrzd241783zd2_7050;
																																																																						BgL_zc3z04anonymousza35687ze3z87_7093:
																																																																							if (NULLP(BgL_l1438z00_7092))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									BgL_test9742z00_24584
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										1);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									bool_t
																																																																										BgL_test9744z00_24587;
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										bool_t
																																																																											BgL_test9745z00_24588;
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_tmpz00_24589;
																																																																											BgL_tmpz00_24589
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_l1438z00_7092));
																																																																											BgL_test9745z00_24588
																																																																												=
																																																																												PAIRP
																																																																												(BgL_tmpz00_24589);
																																																																										}
																																																																										if (BgL_test9745z00_24588)
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												BgL_test9744z00_24587
																																																																													=
																																																																													(
																																																																													(bool_t)
																																																																													0);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												BgL_test9744z00_24587
																																																																													=
																																																																													(
																																																																													(bool_t)
																																																																													1);
																																																																											}
																																																																									}
																																																																									if (BgL_test9744z00_24587)
																																																																										{
																																																																											obj_t
																																																																												BgL_l1438z00_24593;
																																																																											BgL_l1438z00_24593
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_l1438z00_7092));
																																																																											BgL_l1438z00_7092
																																																																												=
																																																																												BgL_l1438z00_24593;
																																																																											goto
																																																																												BgL_zc3z04anonymousza35687ze3z87_7093;
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											BgL_test9742z00_24584
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												0);
																																																																										}
																																																																								}
																																																																						}
																																																																						if (BgL_test9742z00_24584)
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_arg5677z00_7075;
																																																																								BgL_arg5677z00_7075
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd241789zd2_7051));
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_24598;
																																																																									{
																																																																										obj_t
																																																																											BgL_argsz00_24602;
																																																																										obj_t
																																																																											BgL_proc2z00_24601;
																																																																										obj_t
																																																																											BgL_proc1z00_24600;
																																																																										obj_t
																																																																											BgL_testz00_24599;
																																																																										BgL_testz00_24599
																																																																											=
																																																																											BgL_arg5677z00_7075;
																																																																										BgL_proc1z00_24600
																																																																											=
																																																																											BgL_carzd241800zd2_7055;
																																																																										BgL_proc2z00_24601
																																																																											=
																																																																											BgL_carzd241808zd2_7059;
																																																																										BgL_argsz00_24602
																																																																											=
																																																																											BgL_cdrzd241783zd2_7050;
																																																																										BgL_argsz00_1747
																																																																											=
																																																																											BgL_argsz00_24602;
																																																																										BgL_proc2z00_1746
																																																																											=
																																																																											BgL_proc2z00_24601;
																																																																										BgL_proc1z00_1745
																																																																											=
																																																																											BgL_proc1z00_24600;
																																																																										BgL_testz00_1744
																																																																											=
																																																																											BgL_testz00_24599;
																																																																										goto
																																																																											BgL_tagzd2387zd2_1748;
																																																																									}
																																																																									BgL_auxz00_22101
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_24598);
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd241832zd2_7076;
																																																																								BgL_cdrzd241832zd2_7076
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd241839zd2_7077;
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_pairz00_12419;
																																																																										BgL_pairz00_12419
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										BgL_cdrzd241839zd2_7077
																																																																											=
																																																																											CDR
																																																																											(BgL_pairz00_12419);
																																																																									}
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd241846zd2_7078;
																																																																										BgL_cdrzd241846zd2_7078
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd241839zd2_7077));
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd241852zd2_7079;
																																																																											BgL_carzd241852zd2_7079
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd241846zd2_7078));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd241852zd2_7079))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_carzd241859zd2_7081;
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_pairz00_12423;
																																																																														BgL_pairz00_12423
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd241846zd2_7078));
																																																																														BgL_carzd241859zd2_7081
																																																																															=
																																																																															CAR
																																																																															(BgL_pairz00_12423);
																																																																													}
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd241859zd2_7081))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd241832zd2_7076))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_arg5681z00_7084;
																																																																																	BgL_arg5681z00_7084
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd241839zd2_7077));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_24624;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_24628;
																																																																																			obj_t
																																																																																				BgL_proc2z00_24627;
																																																																																			obj_t
																																																																																				BgL_proc1z00_24626;
																																																																																			obj_t
																																																																																				BgL_testz00_24625;
																																																																																			BgL_testz00_24625
																																																																																				=
																																																																																				BgL_arg5681z00_7084;
																																																																																			BgL_proc1z00_24626
																																																																																				=
																																																																																				BgL_carzd241852zd2_7079;
																																																																																			BgL_proc2z00_24627
																																																																																				=
																																																																																				BgL_carzd241859zd2_7081;
																																																																																			BgL_argsz00_24628
																																																																																				=
																																																																																				BgL_cdrzd241832zd2_7076;
																																																																																			BgL_argsz00_1752
																																																																																				=
																																																																																				BgL_argsz00_24628;
																																																																																			BgL_proc2z00_1751
																																																																																				=
																																																																																				BgL_proc2z00_24627;
																																																																																			BgL_proc1z00_1750
																																																																																				=
																																																																																				BgL_proc1z00_24626;
																																																																																			BgL_testz00_1749
																																																																																				=
																																																																																				BgL_testz00_24625;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1753;
																																																																																		}
																																																																																		BgL_auxz00_22101
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_24624);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1777;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_24632;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1778;
																																																																																			BgL_auxz00_22101
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_24632);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1777;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_24636;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1778;
																																																																																	BgL_auxz00_22101
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_24636);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1777;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_24640;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1778;
																																																																															BgL_auxz00_22101
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_24640);
																																																																														}
																																																																												}
																																																																										}
																																																																									}
																																																																								}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1777;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_24644;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1778;
																																																																								BgL_auxz00_22101
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_24644);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd242135zd2_7103;
																																																																				BgL_cdrzd242135zd2_7103
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd242141zd2_7104;
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_pairz00_12427;
																																																																						BgL_pairz00_12427
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						BgL_cdrzd242141zd2_7104
																																																																							=
																																																																							CDR
																																																																							(BgL_pairz00_12427);
																																																																					}
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd242147zd2_7105;
																																																																						BgL_cdrzd242147zd2_7105
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd242141zd2_7104));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd242152zd2_7106;
																																																																							obj_t
																																																																								BgL_cdrzd242153zd2_7107;
																																																																							BgL_carzd242152zd2_7106
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd242147zd2_7105));
																																																																							BgL_cdrzd242153zd2_7107
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd242147zd2_7105));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd242152zd2_7106))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd242158zd2_7109;
																																																																									BgL_carzd242158zd2_7109
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd242153zd2_7107));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd242158zd2_7109))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (NULLP(CDR(((obj_t) BgL_cdrzd242153zd2_7107))))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd242135zd2_7103))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg5696z00_7114;
																																																																															BgL_arg5696z00_7114
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd242141zd2_7104));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_24671;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_24675;
																																																																																	obj_t
																																																																																		BgL_proc2z00_24674;
																																																																																	obj_t
																																																																																		BgL_proc1z00_24673;
																																																																																	obj_t
																																																																																		BgL_testz00_24672;
																																																																																	BgL_testz00_24672
																																																																																		=
																																																																																		BgL_arg5696z00_7114;
																																																																																	BgL_proc1z00_24673
																																																																																		=
																																																																																		BgL_carzd242152zd2_7106;
																																																																																	BgL_proc2z00_24674
																																																																																		=
																																																																																		BgL_carzd242158zd2_7109;
																																																																																	BgL_argsz00_24675
																																																																																		=
																																																																																		BgL_cdrzd242135zd2_7103;
																																																																																	BgL_argsz00_1752
																																																																																		=
																																																																																		BgL_argsz00_24675;
																																																																																	BgL_proc2z00_1751
																																																																																		=
																																																																																		BgL_proc2z00_24674;
																																																																																	BgL_proc1z00_1750
																																																																																		=
																																																																																		BgL_proc1z00_24673;
																																																																																	BgL_testz00_1749
																																																																																		=
																																																																																		BgL_testz00_24672;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1753;
																																																																																}
																																																																																BgL_auxz00_22101
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_24671);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1777;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_24679;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1778;
																																																																																	BgL_auxz00_22101
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_24679);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1777;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_24683;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1778;
																																																																															BgL_auxz00_22101
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_24683);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1777;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_24687;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1778;
																																																																													BgL_auxz00_22101
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_24687);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1777;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_24691;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1778;
																																																																											BgL_auxz00_22101
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_24691);
																																																																										}
																																																																								}
																																																																						}
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1777;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_24695;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1778;
																																																																				BgL_auxz00_22101
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_24695);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd242491zd2_7122;
																																																																BgL_cdrzd242491zd2_7122
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd242498zd2_7123;
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_pairz00_12437;
																																																																		BgL_pairz00_12437
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		BgL_cdrzd242498zd2_7123
																																																																			=
																																																																			CDR
																																																																			(BgL_pairz00_12437);
																																																																	}
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd242505zd2_7124;
																																																																		BgL_cdrzd242505zd2_7124
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd242498zd2_7123));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_carzd242511zd2_7125;
																																																																			obj_t
																																																																				BgL_cdrzd242512zd2_7126;
																																																																			BgL_carzd242511zd2_7125
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd242505zd2_7124));
																																																																			BgL_cdrzd242512zd2_7126
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd242505zd2_7124));
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd242511zd2_7125))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (PAIRP(BgL_cdrzd242512zd2_7126))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd242519zd2_7129;
																																																																							BgL_carzd242519zd2_7129
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd242512zd2_7126);
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd242519zd2_7129))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (NULLP(CDR(BgL_cdrzd242512zd2_7126)))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd242491zd2_7122))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_arg5710z00_7134;
																																																																													BgL_arg5710z00_7134
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd242498zd2_7123));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_24722;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_24726;
																																																																															obj_t
																																																																																BgL_proc2z00_24725;
																																																																															obj_t
																																																																																BgL_proc1z00_24724;
																																																																															obj_t
																																																																																BgL_testz00_24723;
																																																																															BgL_testz00_24723
																																																																																=
																																																																																BgL_arg5710z00_7134;
																																																																															BgL_proc1z00_24724
																																																																																=
																																																																																BgL_carzd242511zd2_7125;
																																																																															BgL_proc2z00_24725
																																																																																=
																																																																																BgL_carzd242519zd2_7129;
																																																																															BgL_argsz00_24726
																																																																																=
																																																																																BgL_cdrzd242491zd2_7122;
																																																																															BgL_argsz00_1752
																																																																																=
																																																																																BgL_argsz00_24726;
																																																																															BgL_proc2z00_1751
																																																																																=
																																																																																BgL_proc2z00_24725;
																																																																															BgL_proc1z00_1750
																																																																																=
																																																																																BgL_proc1z00_24724;
																																																																															BgL_testz00_1749
																																																																																=
																																																																																BgL_testz00_24723;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1753;
																																																																														}
																																																																														BgL_auxz00_22101
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_24722);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1777;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_24730;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1778;
																																																																															BgL_auxz00_22101
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_24730);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1777;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_24734;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1778;
																																																																													BgL_auxz00_22101
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_24734);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1777;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_24738;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1778;
																																																																											BgL_auxz00_22101
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_24738);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1777;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_24742;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1778;
																																																																									BgL_auxz00_22101
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_24742);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1777;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_24746;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1778;
																																																																							BgL_auxz00_22101
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_24746);
																																																																						}
																																																																				}
																																																																		}
																																																																	}
																																																																}
																																																															}
																																																													}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{	/* Ast/sexp.scm 119 */
																																																															goto
																																																																BgL_tagzd2403zd2_1777;
																																																														}
																																																													else
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_24750;
																																																															goto
																																																																BgL_tagzd2404zd2_1778;
																																																															BgL_auxz00_22101
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_24750);
																																																														}
																																																												}
																																																										}
																																																									}
																																																							}
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_cdrzd242912zd2_7148;
																																																BgL_cdrzd242912zd2_7148
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 119 */
																																																	bool_t
																																																		BgL_test9773z00_24754;
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_arg5738z00_7165;
																																																		BgL_arg5738z00_7165
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_test9773z00_24754
																																																			=
																																																			CBOOL
																																																			(BGl_letzd2symzf3z21zzast_letz00
																																																			(BgL_arg5738z00_7165));
																																																	}
																																																	if (BgL_test9773z00_24754)
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg5726z00_7151;
																																																			obj_t
																																																				BgL_arg5727z00_7152;
																																																			BgL_arg5726z00_7151
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd242912zd2_7148));
																																																			BgL_arg5727z00_7152
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd242912zd2_7148));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_24763;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_24765;
																																																					obj_t
																																																						BgL_bindingsz00_24764;
																																																					BgL_bindingsz00_24764
																																																						=
																																																						BgL_arg5726z00_7151;
																																																					BgL_exprz00_24765
																																																						=
																																																						BgL_arg5727z00_7152;
																																																					BgL_exprz00_1732
																																																						=
																																																						BgL_exprz00_24765;
																																																					BgL_bindingsz00_1731
																																																						=
																																																						BgL_bindingsz00_24764;
																																																					goto
																																																						BgL_tagzd2382zd2_1733;
																																																				}
																																																				BgL_auxz00_22101
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_24763);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			bool_t
																																																				BgL_test9774z00_24767;
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg5737z00_7164;
																																																				BgL_arg5737z00_7164
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test9774z00_24767
																																																					=
																																																					CBOOL
																																																					(BGl_labelszd2symzf3z21zzast_labelsz00
																																																					(BgL_arg5737z00_7164));
																																																			}
																																																			if (BgL_test9774z00_24767)
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_24772;
																																																					goto
																																																						BgL_tagzd2384zd2_1735;
																																																					BgL_auxz00_22101
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_24772);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_carzd242978zd2_7155;
																																																					BgL_carzd242978zd2_7155
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd242983zd2_7156;
																																																						BgL_cdrzd242983zd2_7156
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_carzd242978zd2_7155));
																																																						if ((CAR(((obj_t) BgL_carzd242978zd2_7155)) == CNST_TABLE_REF(((long) 3))))
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg5732z00_7159;
																																																								obj_t
																																																									BgL_arg5733z00_7160;
																																																								obj_t
																																																									BgL_arg5734z00_7161;
																																																								BgL_arg5732z00_7159
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_cdrzd242983zd2_7156));
																																																								BgL_arg5733z00_7160
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_cdrzd242983zd2_7156));
																																																								BgL_arg5734z00_7161
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_24789;
																																																									{
																																																										obj_t
																																																											BgL_argsz00_24792;
																																																										obj_t
																																																											BgL_bodyz00_24791;
																																																										obj_t
																																																											BgL_varsz00_24790;
																																																										BgL_varsz00_24790
																																																											=
																																																											BgL_arg5732z00_7159;
																																																										BgL_bodyz00_24791
																																																											=
																																																											BgL_arg5733z00_7160;
																																																										BgL_argsz00_24792
																																																											=
																																																											BgL_arg5734z00_7161;
																																																										BgL_argsz00_1742
																																																											=
																																																											BgL_argsz00_24792;
																																																										BgL_bodyz00_1741
																																																											=
																																																											BgL_bodyz00_24791;
																																																										BgL_varsz00_1740
																																																											=
																																																											BgL_varsz00_24790;
																																																										goto
																																																											BgL_tagzd2386zd2_1743;
																																																									}
																																																									BgL_auxz00_22101
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_24789);
																																																								}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																									{	/* Ast/sexp.scm 119 */
																																																										goto
																																																											BgL_tagzd2403zd2_1777;
																																																									}
																																																								else
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_24796;
																																																										goto
																																																											BgL_tagzd2404zd2_1778;
																																																										BgL_auxz00_22101
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_24796);
																																																									}
																																																							}
																																																					}
																																																				}
																																																		}
																																																}
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_cdrzd243094zd2_7166;
																																														BgL_cdrzd243094zd2_7166
																																															=
																																															CDR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{	/* Ast/sexp.scm 119 */
																																															bool_t
																																																BgL_test9777z00_24800;
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_arg5747z00_7175;
																																																BgL_arg5747z00_7175
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																BgL_test9777z00_24800
																																																	=
																																																	CBOOL
																																																	(BGl_letzd2symzf3z21zzast_letz00
																																																	(BgL_arg5747z00_7175));
																																															}
																																															if (BgL_test9777z00_24800)
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg5741z00_7169;
																																																	obj_t
																																																		BgL_arg5742z00_7170;
																																																	BgL_arg5741z00_7169
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd243094zd2_7166));
																																																	BgL_arg5742z00_7170
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd243094zd2_7166));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_24809;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_24811;
																																																			obj_t
																																																				BgL_bindingsz00_24810;
																																																			BgL_bindingsz00_24810
																																																				=
																																																				BgL_arg5741z00_7169;
																																																			BgL_exprz00_24811
																																																				=
																																																				BgL_arg5742z00_7170;
																																																			BgL_exprz00_1732
																																																				=
																																																				BgL_exprz00_24811;
																																																			BgL_bindingsz00_1731
																																																				=
																																																				BgL_bindingsz00_24810;
																																																			goto
																																																				BgL_tagzd2382zd2_1733;
																																																		}
																																																		BgL_auxz00_22101
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_24809);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	bool_t
																																																		BgL_test9778z00_24813;
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_arg5746z00_7174;
																																																		BgL_arg5746z00_7174
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_test9778z00_24813
																																																			=
																																																			CBOOL
																																																			(BGl_labelszd2symzf3z21zzast_labelsz00
																																																			(BgL_arg5746z00_7174));
																																																	}
																																																	if (BgL_test9778z00_24813)
																																																		{
																																																			BgL_letzd2funzd2_bglt
																																																				BgL_auxz00_24818;
																																																			goto
																																																				BgL_tagzd2384zd2_1735;
																																																			BgL_auxz00_22101
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_24818);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																				{	/* Ast/sexp.scm 119 */
																																																					goto
																																																						BgL_tagzd2403zd2_1777;
																																																				}
																																																			else
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_24822;
																																																					goto
																																																						BgL_tagzd2404zd2_1778;
																																																					BgL_auxz00_22101
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_24822);
																																																				}
																																																		}
																																																}
																																														}
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd241659zd2_6902)))
																																													{	/* Ast/sexp.scm 119 */
																																														goto
																																															BgL_kapzd241661zd2_6904;
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														if ((BgL_carzd241659zd2_6902 == CNST_TABLE_REF(((long) 18))))
																																															{	/* Ast/sexp.scm 119 */
																																																goto
																																																	BgL_kapzd241661zd2_6904;
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																if ((BgL_carzd241659zd2_6902 == CNST_TABLE_REF(((long) 19))))
																																																	{	/* Ast/sexp.scm 119 */
																																																		goto
																																																			BgL_kapzd241661zd2_6904;
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd241659zd2_6902)))
																																																			{	/* Ast/sexp.scm 119 */
																																																				goto
																																																					BgL_kapzd241661zd2_6904;
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd243266zd2_6910;
																																																				BgL_cdrzd243266zd2_6910
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 119 */
																																																					bool_t
																																																						BgL_test9784z00_24838;
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg5647z00_7027;
																																																						BgL_arg5647z00_7027
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test9784z00_24838
																																																							=
																																																							CBOOL
																																																							(BGl_letzd2symzf3z21zzast_letz00
																																																							(BgL_arg5647z00_7027));
																																																					}
																																																					if (BgL_test9784z00_24838)
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_arg5575z00_6913;
																																																							obj_t
																																																								BgL_arg5576z00_6914;
																																																							BgL_arg5575z00_6913
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd243266zd2_6910));
																																																							BgL_arg5576z00_6914
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd243266zd2_6910));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_24847;
																																																								{
																																																									obj_t
																																																										BgL_exprz00_24849;
																																																									obj_t
																																																										BgL_bindingsz00_24848;
																																																									BgL_bindingsz00_24848
																																																										=
																																																										BgL_arg5575z00_6913;
																																																									BgL_exprz00_24849
																																																										=
																																																										BgL_arg5576z00_6914;
																																																									BgL_exprz00_1732
																																																										=
																																																										BgL_exprz00_24849;
																																																									BgL_bindingsz00_1731
																																																										=
																																																										BgL_bindingsz00_24848;
																																																									goto
																																																										BgL_tagzd2382zd2_1733;
																																																								}
																																																								BgL_auxz00_22101
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_24847);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							bool_t
																																																								BgL_test9785z00_24851;
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg5646z00_7026;
																																																								BgL_arg5646z00_7026
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test9785z00_24851
																																																									=
																																																									CBOOL
																																																									(BGl_labelszd2symzf3z21zzast_labelsz00
																																																									(BgL_arg5646z00_7026));
																																																							}
																																																							if (BgL_test9785z00_24851)
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_24856;
																																																									goto
																																																										BgL_tagzd2384zd2_1735;
																																																									BgL_auxz00_22101
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_24856);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_carzd243332zd2_6917;
																																																									BgL_carzd243332zd2_6917
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd243337zd2_6918;
																																																										BgL_cdrzd243337zd2_6918
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_carzd243332zd2_6917));
																																																										if ((CAR(((obj_t) BgL_carzd243332zd2_6917)) == CNST_TABLE_REF(((long) 3))))
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (PAIRP(BgL_cdrzd243337zd2_6918))
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_arg5582z00_6922;
																																																														obj_t
																																																															BgL_arg5583z00_6923;
																																																														obj_t
																																																															BgL_arg5584z00_6924;
																																																														BgL_arg5582z00_6922
																																																															=
																																																															CAR
																																																															(BgL_cdrzd243337zd2_6918);
																																																														BgL_arg5583z00_6923
																																																															=
																																																															CDR
																																																															(BgL_cdrzd243337zd2_6918);
																																																														BgL_arg5584z00_6924
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_24873;
																																																															{
																																																																obj_t
																																																																	BgL_argsz00_24876;
																																																																obj_t
																																																																	BgL_bodyz00_24875;
																																																																obj_t
																																																																	BgL_varsz00_24874;
																																																																BgL_varsz00_24874
																																																																	=
																																																																	BgL_arg5582z00_6922;
																																																																BgL_bodyz00_24875
																																																																	=
																																																																	BgL_arg5583z00_6923;
																																																																BgL_argsz00_24876
																																																																	=
																																																																	BgL_arg5584z00_6924;
																																																																BgL_argsz00_1742
																																																																	=
																																																																	BgL_argsz00_24876;
																																																																BgL_bodyz00_1741
																																																																	=
																																																																	BgL_bodyz00_24875;
																																																																BgL_varsz00_1740
																																																																	=
																																																																	BgL_varsz00_24874;
																																																																goto
																																																																	BgL_tagzd2386zd2_1743;
																																																															}
																																																															BgL_auxz00_22101
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_24873);
																																																														}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 119 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1777;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_24880;
																																																																goto
																																																																	BgL_tagzd2404zd2_1778;
																																																																BgL_auxz00_22101
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_24880);
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd243444zd2_6927;
																																																												BgL_cdrzd243444zd2_6927
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd243449zd2_6928;
																																																													BgL_cdrzd243449zd2_6928
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_carzd243332zd2_6917));
																																																													if ((CAR(((obj_t) BgL_carzd243332zd2_6917)) == CNST_TABLE_REF(((long) 1))))
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (PAIRP(BgL_cdrzd243449zd2_6928))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd243454zd2_6932;
																																																																	BgL_cdrzd243454zd2_6932
																																																																		=
																																																																		CDR
																																																																		(BgL_cdrzd243449zd2_6928);
																																																																	if (PAIRP(BgL_cdrzd243454zd2_6932))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_carzd243458zd2_6934;
																																																																			obj_t
																																																																				BgL_cdrzd243459zd2_6935;
																																																																			BgL_carzd243458zd2_6934
																																																																				=
																																																																				CAR
																																																																				(BgL_cdrzd243454zd2_6932);
																																																																			BgL_cdrzd243459zd2_6935
																																																																				=
																																																																				CDR
																																																																				(BgL_cdrzd243454zd2_6932);
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd243458zd2_6934))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (PAIRP(BgL_cdrzd243459zd2_6935))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd243464zd2_6938;
																																																																							BgL_carzd243464zd2_6938
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd243459zd2_6935);
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd243464zd2_6938))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (NULLP(CDR(BgL_cdrzd243459zd2_6935)))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											bool_t
																																																																												BgL_test9796z00_24908;
																																																																											{
																																																																												obj_t
																																																																													BgL_l1441z00_6971;
																																																																												BgL_l1441z00_6971
																																																																													=
																																																																													BgL_cdrzd243444zd2_6927;
																																																																											BgL_zc3z04anonymousza35610ze3z87_6972:
																																																																												if (NULLP(BgL_l1441z00_6971))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														BgL_test9796z00_24908
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															1);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														bool_t
																																																																															BgL_test9798z00_24911;
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															bool_t
																																																																																BgL_test9799z00_24912;
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_tmpz00_24913;
																																																																																BgL_tmpz00_24913
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_l1441z00_6971));
																																																																																BgL_test9799z00_24912
																																																																																	=
																																																																																	PAIRP
																																																																																	(BgL_tmpz00_24913);
																																																																															}
																																																																															if (BgL_test9799z00_24912)
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	BgL_test9798z00_24911
																																																																																		=
																																																																																		(
																																																																																		(bool_t)
																																																																																		0);
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	BgL_test9798z00_24911
																																																																																		=
																																																																																		(
																																																																																		(bool_t)
																																																																																		1);
																																																																																}
																																																																														}
																																																																														if (BgL_test9798z00_24911)
																																																																															{
																																																																																obj_t
																																																																																	BgL_l1441z00_24917;
																																																																																BgL_l1441z00_24917
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_l1441z00_6971));
																																																																																BgL_l1441z00_6971
																																																																																	=
																																																																																	BgL_l1441z00_24917;
																																																																																goto
																																																																																	BgL_zc3z04anonymousza35610ze3z87_6972;
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																BgL_test9796z00_24908
																																																																																	=
																																																																																	(
																																																																																	(bool_t)
																																																																																	0);
																																																																															}
																																																																													}
																																																																											}
																																																																											if (BgL_test9796z00_24908)
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_arg5600z00_6954;
																																																																													BgL_arg5600z00_6954
																																																																														=
																																																																														CAR
																																																																														(BgL_cdrzd243449zd2_6928);
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_24921;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_24925;
																																																																															obj_t
																																																																																BgL_proc2z00_24924;
																																																																															obj_t
																																																																																BgL_proc1z00_24923;
																																																																															obj_t
																																																																																BgL_testz00_24922;
																																																																															BgL_testz00_24922
																																																																																=
																																																																																BgL_arg5600z00_6954;
																																																																															BgL_proc1z00_24923
																																																																																=
																																																																																BgL_carzd243458zd2_6934;
																																																																															BgL_proc2z00_24924
																																																																																=
																																																																																BgL_carzd243464zd2_6938;
																																																																															BgL_argsz00_24925
																																																																																=
																																																																																BgL_cdrzd243444zd2_6927;
																																																																															BgL_argsz00_1747
																																																																																=
																																																																																BgL_argsz00_24925;
																																																																															BgL_proc2z00_1746
																																																																																=
																																																																																BgL_proc2z00_24924;
																																																																															BgL_proc1z00_1745
																																																																																=
																																																																																BgL_proc1z00_24923;
																																																																															BgL_testz00_1744
																																																																																=
																																																																																BgL_testz00_24922;
																																																																															goto
																																																																																BgL_tagzd2387zd2_1748;
																																																																														}
																																																																														BgL_auxz00_22101
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_24921);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd243489zd2_6955;
																																																																													BgL_cdrzd243489zd2_6955
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_cdrzd243497zd2_6956;
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_pairz00_12494;
																																																																															BgL_pairz00_12494
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															BgL_cdrzd243497zd2_6956
																																																																																=
																																																																																CDR
																																																																																(BgL_pairz00_12494);
																																																																														}
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_cdrzd243505zd2_6957;
																																																																															BgL_cdrzd243505zd2_6957
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_cdrzd243497zd2_6956));
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_carzd243512zd2_6958;
																																																																																BgL_carzd243512zd2_6958
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd243505zd2_6957));
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd243512zd2_6958))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_carzd243521zd2_6960;
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_pairz00_12498;
																																																																																			BgL_pairz00_12498
																																																																																				=
																																																																																				CDR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd243505zd2_6957));
																																																																																			BgL_carzd243521zd2_6960
																																																																																				=
																																																																																				CAR
																																																																																				(BgL_pairz00_12498);
																																																																																		}
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd243521zd2_6960))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd243489zd2_6955))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						obj_t
																																																																																							BgL_arg5604z00_6963;
																																																																																						BgL_arg5604z00_6963
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd243497zd2_6956));
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_24947;
																																																																																							{
																																																																																								obj_t
																																																																																									BgL_argsz00_24951;
																																																																																								obj_t
																																																																																									BgL_proc2z00_24950;
																																																																																								obj_t
																																																																																									BgL_proc1z00_24949;
																																																																																								obj_t
																																																																																									BgL_testz00_24948;
																																																																																								BgL_testz00_24948
																																																																																									=
																																																																																									BgL_arg5604z00_6963;
																																																																																								BgL_proc1z00_24949
																																																																																									=
																																																																																									BgL_carzd243512zd2_6958;
																																																																																								BgL_proc2z00_24950
																																																																																									=
																																																																																									BgL_carzd243521zd2_6960;
																																																																																								BgL_argsz00_24951
																																																																																									=
																																																																																									BgL_cdrzd243489zd2_6955;
																																																																																								BgL_argsz00_1752
																																																																																									=
																																																																																									BgL_argsz00_24951;
																																																																																								BgL_proc2z00_1751
																																																																																									=
																																																																																									BgL_proc2z00_24950;
																																																																																								BgL_proc1z00_1750
																																																																																									=
																																																																																									BgL_proc1z00_24949;
																																																																																								BgL_testz00_1749
																																																																																									=
																																																																																									BgL_testz00_24948;
																																																																																								goto
																																																																																									BgL_tagzd2388zd2_1753;
																																																																																							}
																																																																																							BgL_auxz00_22101
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_24947);
																																																																																						}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1777;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_24955;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1778;
																																																																																								BgL_auxz00_22101
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_24955);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1777;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_24959;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1778;
																																																																																						BgL_auxz00_22101
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_24959);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1777;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_24963;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1778;
																																																																																				BgL_auxz00_22101
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_24963);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														}
																																																																													}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1777;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_24967;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1778;
																																																																													BgL_auxz00_22101
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_24967);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd243799zd2_6982;
																																																																									BgL_cdrzd243799zd2_6982
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd243806zd2_6983;
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_pairz00_12502;
																																																																											BgL_pairz00_12502
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											BgL_cdrzd243806zd2_6983
																																																																												=
																																																																												CDR
																																																																												(BgL_pairz00_12502);
																																																																										}
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd243813zd2_6984;
																																																																											BgL_cdrzd243813zd2_6984
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd243806zd2_6983));
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_carzd243819zd2_6985;
																																																																												obj_t
																																																																													BgL_cdrzd243820zd2_6986;
																																																																												BgL_carzd243819zd2_6985
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd243813zd2_6984));
																																																																												BgL_cdrzd243820zd2_6986
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd243813zd2_6984));
																																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd243819zd2_6985))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_carzd243827zd2_6988;
																																																																														BgL_carzd243827zd2_6988
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd243820zd2_6986));
																																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd243827zd2_6988))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (NULLP(CDR(((obj_t) BgL_cdrzd243820zd2_6986))))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd243799zd2_6982))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_arg5619z00_6993;
																																																																																				BgL_arg5619z00_6993
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd243806zd2_6983));
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_24994;
																																																																																					{
																																																																																						obj_t
																																																																																							BgL_argsz00_24998;
																																																																																						obj_t
																																																																																							BgL_proc2z00_24997;
																																																																																						obj_t
																																																																																							BgL_proc1z00_24996;
																																																																																						obj_t
																																																																																							BgL_testz00_24995;
																																																																																						BgL_testz00_24995
																																																																																							=
																																																																																							BgL_arg5619z00_6993;
																																																																																						BgL_proc1z00_24996
																																																																																							=
																																																																																							BgL_carzd243819zd2_6985;
																																																																																						BgL_proc2z00_24997
																																																																																							=
																																																																																							BgL_carzd243827zd2_6988;
																																																																																						BgL_argsz00_24998
																																																																																							=
																																																																																							BgL_cdrzd243799zd2_6982;
																																																																																						BgL_argsz00_1752
																																																																																							=
																																																																																							BgL_argsz00_24998;
																																																																																						BgL_proc2z00_1751
																																																																																							=
																																																																																							BgL_proc2z00_24997;
																																																																																						BgL_proc1z00_1750
																																																																																							=
																																																																																							BgL_proc1z00_24996;
																																																																																						BgL_testz00_1749
																																																																																							=
																																																																																							BgL_testz00_24995;
																																																																																						goto
																																																																																							BgL_tagzd2388zd2_1753;
																																																																																					}
																																																																																					BgL_auxz00_22101
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_24994);
																																																																																				}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1777;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_25002;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1778;
																																																																																						BgL_auxz00_22101
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_25002);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1777;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_25006;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1778;
																																																																																				BgL_auxz00_22101
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_25006);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1777;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_25010;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1778;
																																																																																		BgL_auxz00_22101
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_25010);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1777;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_25014;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1778;
																																																																																BgL_auxz00_22101
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_25014);
																																																																															}
																																																																													}
																																																																											}
																																																																										}
																																																																									}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1777;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_25018;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1778;
																																																																									BgL_auxz00_22101
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_25018);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd244160zd2_7001;
																																																																					BgL_cdrzd244160zd2_7001
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd244166zd2_7002;
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_pairz00_12512;
																																																																							BgL_pairz00_12512
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							BgL_cdrzd244166zd2_7002
																																																																								=
																																																																								CDR
																																																																								(BgL_pairz00_12512);
																																																																						}
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd244172zd2_7003;
																																																																							BgL_cdrzd244172zd2_7003
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd244166zd2_7002));
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_carzd244177zd2_7004;
																																																																								obj_t
																																																																									BgL_cdrzd244178zd2_7005;
																																																																								BgL_carzd244177zd2_7004
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd244172zd2_7003));
																																																																								BgL_cdrzd244178zd2_7005
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd244172zd2_7003));
																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd244177zd2_7004))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (PAIRP(BgL_cdrzd244178zd2_7005))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_carzd244183zd2_7008;
																																																																												BgL_carzd244183zd2_7008
																																																																													=
																																																																													CAR
																																																																													(BgL_cdrzd244178zd2_7005);
																																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd244183zd2_7008))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (NULLP(CDR(BgL_cdrzd244178zd2_7005)))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd244160zd2_7001))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_arg5633z00_7013;
																																																																																		BgL_arg5633z00_7013
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd244166zd2_7002));
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_25045;
																																																																																			{
																																																																																				obj_t
																																																																																					BgL_argsz00_25049;
																																																																																				obj_t
																																																																																					BgL_proc2z00_25048;
																																																																																				obj_t
																																																																																					BgL_proc1z00_25047;
																																																																																				obj_t
																																																																																					BgL_testz00_25046;
																																																																																				BgL_testz00_25046
																																																																																					=
																																																																																					BgL_arg5633z00_7013;
																																																																																				BgL_proc1z00_25047
																																																																																					=
																																																																																					BgL_carzd244177zd2_7004;
																																																																																				BgL_proc2z00_25048
																																																																																					=
																																																																																					BgL_carzd244183zd2_7008;
																																																																																				BgL_argsz00_25049
																																																																																					=
																																																																																					BgL_cdrzd244160zd2_7001;
																																																																																				BgL_argsz00_1752
																																																																																					=
																																																																																					BgL_argsz00_25049;
																																																																																				BgL_proc2z00_1751
																																																																																					=
																																																																																					BgL_proc2z00_25048;
																																																																																				BgL_proc1z00_1750
																																																																																					=
																																																																																					BgL_proc1z00_25047;
																																																																																				BgL_testz00_1749
																																																																																					=
																																																																																					BgL_testz00_25046;
																																																																																				goto
																																																																																					BgL_tagzd2388zd2_1753;
																																																																																			}
																																																																																			BgL_auxz00_22101
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_25045);
																																																																																		}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1777;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_25053;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1778;
																																																																																				BgL_auxz00_22101
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_25053);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1777;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_25057;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1778;
																																																																																		BgL_auxz00_22101
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_25057);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1777;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_25061;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1778;
																																																																																BgL_auxz00_22101
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_25061);
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1777;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_25065;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1778;
																																																																														BgL_auxz00_22101
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_25065);
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1777;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_25069;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1778;
																																																																												BgL_auxz00_22101
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_25069);
																																																																											}
																																																																									}
																																																																							}
																																																																						}
																																																																					}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1777;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_25073;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1778;
																																																																					BgL_auxz00_22101
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_25073);
																																																																				}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1777;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_25077;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1778;
																																																																			BgL_auxz00_22101
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_25077);
																																																																		}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1777;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_25081;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1778;
																																																																	BgL_auxz00_22101
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_25081);
																																																																}
																																																														}
																																																												}
																																																											}
																																																									}
																																																								}
																																																						}
																																																				}
																																																			}
																																																	}
																																															}
																																													}
																																											}
																																									}
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									if ((BgL_carzd241656zd2_6900 == CNST_TABLE_REF(((long) 17))))
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_arg5749z00_7179;
																																											obj_t
																																												BgL_arg5750z00_7180;
																																											BgL_arg5749z00_7179
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_cdrzd241555zd2_6884));
																																											BgL_arg5750z00_7180
																																												=
																																												CDR
																																												(
																																												((obj_t) BgL_cdrzd241555zd2_6884));
																																											{
																																												BgL_nodez00_bglt
																																													BgL_auxz00_25090;
																																												{
																																													obj_t
																																														BgL_exprz00_25092;
																																													obj_t
																																														BgL_bindingsz00_25091;
																																													BgL_bindingsz00_25091
																																														=
																																														BgL_arg5749z00_7179;
																																													BgL_exprz00_25092
																																														=
																																														BgL_arg5750z00_7180;
																																													BgL_exprz00_1732
																																														=
																																														BgL_exprz00_25092;
																																													BgL_bindingsz00_1731
																																														=
																																														BgL_bindingsz00_25091;
																																													goto
																																														BgL_tagzd2382zd2_1733;
																																												}
																																												BgL_auxz00_22101
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_25090);
																																											}
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd241656zd2_6900)))
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_arg5752z00_7182;
																																													obj_t
																																														BgL_arg5753z00_7183;
																																													BgL_arg5752z00_7182
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_cdrzd241555zd2_6884));
																																													BgL_arg5753z00_7183
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_cdrzd241555zd2_6884));
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_25101;
																																														{
																																															obj_t
																																																BgL_exprz00_25103;
																																															obj_t
																																																BgL_bindingsz00_25102;
																																															BgL_bindingsz00_25102
																																																=
																																																BgL_arg5752z00_7182;
																																															BgL_exprz00_25103
																																																=
																																																BgL_arg5753z00_7183;
																																															BgL_exprz00_1732
																																																=
																																																BgL_exprz00_25103;
																																															BgL_bindingsz00_1731
																																																=
																																																BgL_bindingsz00_25102;
																																															goto
																																																BgL_tagzd2382zd2_1733;
																																														}
																																														BgL_auxz00_22101
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_25101);
																																													}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													if ((BgL_carzd241656zd2_6900 == CNST_TABLE_REF(((long) 18))))
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg5755z00_7185;
																																															obj_t
																																																BgL_arg5756z00_7186;
																																															BgL_arg5755z00_7185
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd241555zd2_6884));
																																															BgL_arg5756z00_7186
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd241555zd2_6884));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_25112;
																																																{
																																																	obj_t
																																																		BgL_exprz00_25114;
																																																	obj_t
																																																		BgL_bindingsz00_25113;
																																																	BgL_bindingsz00_25113
																																																		=
																																																		BgL_arg5755z00_7185;
																																																	BgL_exprz00_25114
																																																		=
																																																		BgL_arg5756z00_7186;
																																																	BgL_exprz00_1732
																																																		=
																																																		BgL_exprz00_25114;
																																																	BgL_bindingsz00_1731
																																																		=
																																																		BgL_bindingsz00_25113;
																																																	goto
																																																		BgL_tagzd2382zd2_1733;
																																																}
																																																BgL_auxz00_22101
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_25112);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_25121;
																																																	goto
																																																		BgL_tagzd2383zd2_1734;
																																																	BgL_auxz00_22101
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_25121);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_carzd244758zd2_7189;
																																																	BgL_carzd244758zd2_7189
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	if ((BgL_carzd244758zd2_7189 == CNST_TABLE_REF(((long) 19))))
																																																		{
																																																			BgL_letzd2funzd2_bglt
																																																				BgL_auxz00_25128;
																																																			goto
																																																				BgL_tagzd2384zd2_1735;
																																																			BgL_auxz00_22101
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_25128);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd244758zd2_7189)))
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_25133;
																																																					goto
																																																						BgL_tagzd2384zd2_1735;
																																																					BgL_auxz00_22101
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_25133);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_25140;
																																																							goto
																																																								BgL_tagzd2389zd2_1754;
																																																							BgL_auxz00_22101
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_25140);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_25147;
																																																									goto
																																																										BgL_tagzd2390zd2_1755;
																																																									BgL_auxz00_22101
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_25147);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_cdrzd244838zd2_7196;
																																																									BgL_cdrzd244838zd2_7196
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_arg5767z00_7199;
																																																											obj_t
																																																												BgL_arg5768z00_7200;
																																																											BgL_arg5767z00_7199
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_cdrzd244838zd2_7196));
																																																											BgL_arg5768z00_7200
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd244838zd2_7196));
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_25160;
																																																												{
																																																													obj_t
																																																														BgL_restz00_25162;
																																																													obj_t
																																																														BgL_effectz00_25161;
																																																													BgL_effectz00_25161
																																																														=
																																																														BgL_arg5767z00_7199;
																																																													BgL_restz00_25162
																																																														=
																																																														BgL_arg5768z00_7200;
																																																													BgL_restz00_1757
																																																														=
																																																														BgL_restz00_25162;
																																																													BgL_effectz00_1756
																																																														=
																																																														BgL_effectz00_25161;
																																																													goto
																																																														BgL_tagzd2391zd2_1758;
																																																												}
																																																												BgL_auxz00_22101
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_25160);
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_25169;
																																																													goto
																																																														BgL_tagzd2392zd2_1759;
																																																													BgL_auxz00_22101
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_25169);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_25176;
																																																															goto
																																																																BgL_tagzd2393zd2_1760;
																																																															BgL_auxz00_22101
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_25176);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_arg5775z00_7208;
																																																																	obj_t
																																																																		BgL_arg5776z00_7209;
																																																																	BgL_arg5775z00_7208
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd244838zd2_7196));
																																																																	BgL_arg5776z00_7209
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd244838zd2_7196));
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_25187;
																																																																		{
																																																																			obj_t
																																																																				BgL_restz00_25189;
																																																																			obj_t
																																																																				BgL_effectz00_25188;
																																																																			BgL_effectz00_25188
																																																																				=
																																																																				BgL_arg5775z00_7208;
																																																																			BgL_restz00_25189
																																																																				=
																																																																				BgL_arg5776z00_7209;
																																																																			BgL_restz00_1762
																																																																				=
																																																																				BgL_restz00_25189;
																																																																			BgL_effectz00_1761
																																																																				=
																																																																				BgL_effectz00_25188;
																																																																			goto
																																																																				BgL_tagzd2394zd2_1763;
																																																																		}
																																																																		BgL_auxz00_22101
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_25187);
																																																																	}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_25196;
																																																																			goto
																																																																				BgL_tagzd2395zd2_1764;
																																																																			BgL_auxz00_22101
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_25196);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_25203;
																																																																					goto
																																																																						BgL_tagzd2396zd2_1765;
																																																																					BgL_auxz00_22101
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_25203);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																						{
																																																																							BgL_letzd2funzd2_bglt
																																																																								BgL_auxz00_25210;
																																																																							goto
																																																																								BgL_tagzd2397zd2_1766;
																																																																							BgL_auxz00_22101
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_25210);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																								{
																																																																									BgL_jumpzd2exzd2itz00_bglt
																																																																										BgL_auxz00_25217;
																																																																									goto
																																																																										BgL_tagzd2398zd2_1767;
																																																																									BgL_auxz00_22101
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_25217);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 30))))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											bool_t
																																																																												BgL_test9846z00_25224;
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_tmpz00_25225;
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_pairz00_12550;
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_pairz00_12549;
																																																																														BgL_pairz00_12549
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_expz00_21));
																																																																														BgL_pairz00_12550
																																																																															=
																																																																															CDR
																																																																															(BgL_pairz00_12549);
																																																																													}
																																																																													BgL_tmpz00_25225
																																																																														=
																																																																														CDR
																																																																														(BgL_pairz00_12550);
																																																																												}
																																																																												BgL_test9846z00_25224
																																																																													=
																																																																													NULLP
																																																																													(BgL_tmpz00_25225);
																																																																											}
																																																																											if (BgL_test9846z00_25224)
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_25231;
																																																																													goto
																																																																														BgL_tagzd2399zd2_1768;
																																																																													BgL_auxz00_22101
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_25231);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1777;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_25235;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1778;
																																																																															BgL_auxz00_22101
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_25235);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd244931zd2_7228;
																																																																											BgL_cdrzd244931zd2_7228
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_arg5797z00_7231;
																																																																													obj_t
																																																																														BgL_arg5798z00_7232;
																																																																													BgL_arg5797z00_7231
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd244931zd2_7228));
																																																																													BgL_arg5798z00_7232
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd244931zd2_7228));
																																																																													{	/* Ast/sexp.scm 552 */
																																																																														obj_t
																																																																															BgL_arg6965z00_12556;
																																																																														BgL_arg6965z00_12556
																																																																															=
																																																																															BGl_findzd2locationzf2locz20zztools_locationz00
																																																																															(BgL_expz00_21,
																																																																															BgL_locz00_23);
																																																																														BgL_auxz00_22101
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																															(BgL_expz00_21,
																																																																																BgL_arg5797z00_7231,
																																																																																CNST_TABLE_REF
																																																																																(((long) 4)), BgL_arg5798z00_7232, BgL_stackz00_22, BgL_arg6965z00_12556, BgL_sitez00_24));
																																																																												}}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1777;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_25254;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1778;
																																																																															BgL_auxz00_22101
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_25254);
																																																																														}
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																											else
																												{	/* Ast/sexp.scm 119 */
																													obj_t
																														BgL_carzd244956zd2_7249;
																													BgL_carzd244956zd2_7249
																														=
																														CAR(((obj_t)
																															BgL_expz00_21));
																													if (
																														(BgL_carzd244956zd2_7249
																															==
																															CNST_TABLE_REF((
																																	(long) 1))))
																														{
																															BgL_nodez00_bglt
																																BgL_auxz00_25261;
																															goto
																																BgL_tagzd2377zd2_1722;
																															BgL_auxz00_22101 =
																																((obj_t)
																																BgL_auxz00_25261);
																														}
																													else
																														{	/* Ast/sexp.scm 119 */
																															if (
																																(BgL_carzd244956zd2_7249
																																	==
																																	BGl_za2ifza2z00zzast_sexpz00))
																																{
																																	BgL_nodez00_bglt
																																		BgL_auxz00_25265;
																																	goto
																																		BgL_tagzd2377zd2_1722;
																																	BgL_auxz00_22101
																																		=
																																		((obj_t)
																																		BgL_auxz00_25265);
																																}
																															else
																																{	/* Ast/sexp.scm 119 */
																																	obj_t
																																		BgL_cdrzd244978zd2_7252;
																																	BgL_cdrzd244978zd2_7252
																																		=
																																		CDR(((obj_t)
																																			BgL_expz00_21));
																																	if ((CAR((
																																					(obj_t)
																																					BgL_expz00_21))
																																			==
																																			CNST_TABLE_REF
																																			(((long)
																																					7))))
																																		{	/* Ast/sexp.scm 119 */
																																			obj_t
																																				BgL_carzd244981zd2_7255;
																																			obj_t
																																				BgL_cdrzd244982zd2_7256;
																																			BgL_carzd244981zd2_7255
																																				=
																																				CAR((
																																					(obj_t)
																																					BgL_cdrzd244978zd2_7252));
																																			BgL_cdrzd244982zd2_7256
																																				=
																																				CDR((
																																					(obj_t)
																																					BgL_cdrzd244978zd2_7252));
																																			if (PAIRP
																																				(BgL_carzd244981zd2_7255))
																																				{	/* Ast/sexp.scm 119 */
																																					if (
																																						(CAR
																																							(BgL_carzd244981zd2_7255)
																																							==
																																							CNST_TABLE_REF
																																							(((long) 14))))
																																						{	/* Ast/sexp.scm 119 */
																																							if (NULLP(CDR(((obj_t) BgL_cdrzd244982zd2_7256))))
																																								{	/* Ast/sexp.scm 119 */
																																									obj_t
																																										BgL_arg5824z00_7262;
																																									obj_t
																																										BgL_arg5825z00_7263;
																																									BgL_arg5824z00_7262
																																										=
																																										CDR
																																										(BgL_carzd244981zd2_7255);
																																									BgL_arg5825z00_7263
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_cdrzd244982zd2_7256));
																																									{
																																										BgL_nodez00_bglt
																																											BgL_auxz00_25291;
																																										{
																																											obj_t
																																												BgL_valz00_25293;
																																											obj_t
																																												BgL_lz00_25292;
																																											BgL_lz00_25292
																																												=
																																												BgL_arg5824z00_7262;
																																											BgL_valz00_25293
																																												=
																																												BgL_arg5825z00_7263;
																																											BgL_valz00_1724
																																												=
																																												BgL_valz00_25293;
																																											BgL_lz00_1723
																																												=
																																												BgL_lz00_25292;
																																											goto
																																												BgL_tagzd2378zd2_1725;
																																										}
																																										BgL_auxz00_22101
																																											=
																																											(
																																											(obj_t)
																																											BgL_auxz00_25291);
																																									}
																																								}
																																							else
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_25295;
																																									goto
																																										BgL_tagzd2379zd2_1726;
																																									BgL_auxz00_22101
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_25295);
																																								}
																																						}
																																					else
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_25297;
																																							goto
																																								BgL_tagzd2379zd2_1726;
																																							BgL_auxz00_22101
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_25297);
																																						}
																																				}
																																			else
																																				{
																																					BgL_nodez00_bglt
																																						BgL_auxz00_25299;
																																					goto
																																						BgL_tagzd2379zd2_1726;
																																					BgL_auxz00_22101
																																						=
																																						(
																																						(obj_t)
																																						BgL_auxz00_25299);
																																				}
																																		}
																																	else
																																		{	/* Ast/sexp.scm 119 */
																																			if (
																																				(CAR(
																																						((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																				{
																																					BgL_nodez00_bglt
																																						BgL_auxz00_25306;
																																					goto
																																						BgL_tagzd2380zd2_1727;
																																					BgL_auxz00_22101
																																						=
																																						(
																																						(obj_t)
																																						BgL_auxz00_25306);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					obj_t
																																						BgL_carzd245079zd2_7268;
																																					BgL_carzd245079zd2_7268
																																						=
																																						CAR(
																																						((obj_t) BgL_expz00_21));
																																					if (PAIRP(BgL_carzd245079zd2_7268))
																																						{	/* Ast/sexp.scm 119 */
																																							obj_t
																																								BgL_carzd245082zd2_7270;
																																							obj_t
																																								BgL_cdrzd245083zd2_7271;
																																							BgL_carzd245082zd2_7270
																																								=
																																								CAR
																																								(BgL_carzd245079zd2_7268);
																																							BgL_cdrzd245083zd2_7271
																																								=
																																								CDR
																																								(BgL_carzd245079zd2_7268);
																																							{

																																								if ((BgL_carzd245082zd2_7270 == CNST_TABLE_REF(((long) 17))))
																																									{	/* Ast/sexp.scm 119 */
																																									BgL_kapzd245084zd2_7272:
																																										if (PAIRP(BgL_cdrzd245083zd2_7271))
																																											{	/* Ast/sexp.scm 119 */
																																												obj_t
																																													BgL_cdrzd245087zd2_7397;
																																												BgL_cdrzd245087zd2_7397
																																													=
																																													CDR
																																													(BgL_cdrzd245083zd2_7271);
																																												if (PAIRP(BgL_cdrzd245087zd2_7397))
																																													{	/* Ast/sexp.scm 119 */
																																														if (NULLP(CDR(BgL_cdrzd245087zd2_7397)))
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_arg5915z00_7401;
																																																obj_t
																																																	BgL_arg5916z00_7402;
																																																BgL_arg5915z00_7401
																																																	=
																																																	CAR
																																																	(BgL_cdrzd245087zd2_7397);
																																																BgL_arg5916z00_7402
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_25328;
																																																	{
																																																		obj_t
																																																			BgL_argsz00_25330;
																																																		obj_t
																																																			BgL_bodyz00_25329;
																																																		BgL_bodyz00_25329
																																																			=
																																																			BgL_arg5915z00_7401;
																																																		BgL_argsz00_25330
																																																			=
																																																			BgL_arg5916z00_7402;
																																																		BgL_argsz00_1729
																																																			=
																																																			BgL_argsz00_25330;
																																																		BgL_bodyz00_1728
																																																			=
																																																			BgL_bodyz00_25329;
																																																		goto
																																																			BgL_tagzd2381zd2_1730;
																																																	}
																																																	BgL_auxz00_22101
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_25328);
																																																}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_cdrzd245111zd2_7403;
																																																BgL_cdrzd245111zd2_7403
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 119 */
																																																	bool_t
																																																		BgL_test9862z00_25334;
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_arg5985z00_7514;
																																																		BgL_arg5985z00_7514
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_test9862z00_25334
																																																			=
																																																			CBOOL
																																																			(BGl_letzd2symzf3z21zzast_letz00
																																																			(BgL_arg5985z00_7514));
																																																	}
																																																	if (BgL_test9862z00_25334)
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg5919z00_7406;
																																																			obj_t
																																																				BgL_arg5920z00_7407;
																																																			BgL_arg5919z00_7406
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd245111zd2_7403));
																																																			BgL_arg5920z00_7407
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd245111zd2_7403));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_25343;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_25345;
																																																					obj_t
																																																						BgL_bindingsz00_25344;
																																																					BgL_bindingsz00_25344
																																																						=
																																																						BgL_arg5919z00_7406;
																																																					BgL_exprz00_25345
																																																						=
																																																						BgL_arg5920z00_7407;
																																																					BgL_exprz00_1732
																																																						=
																																																						BgL_exprz00_25345;
																																																					BgL_bindingsz00_1731
																																																						=
																																																						BgL_bindingsz00_25344;
																																																					goto
																																																						BgL_tagzd2382zd2_1733;
																																																				}
																																																				BgL_auxz00_22101
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_25343);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			bool_t
																																																				BgL_test9863z00_25347;
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg5984z00_7513;
																																																				BgL_arg5984z00_7513
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test9863z00_25347
																																																					=
																																																					CBOOL
																																																					(BGl_labelszd2symzf3z21zzast_labelsz00
																																																					(BgL_arg5984z00_7513));
																																																			}
																																																			if (BgL_test9863z00_25347)
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_25352;
																																																					goto
																																																						BgL_tagzd2384zd2_1735;
																																																					BgL_auxz00_22101
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_25352);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_carzd245178zd2_7410;
																																																					BgL_carzd245178zd2_7410
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd245183zd2_7411;
																																																						BgL_cdrzd245183zd2_7411
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_carzd245178zd2_7410));
																																																						if ((CAR(((obj_t) BgL_carzd245178zd2_7410)) == CNST_TABLE_REF(((long) 3))))
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg5925z00_7414;
																																																								obj_t
																																																									BgL_arg5926z00_7415;
																																																								obj_t
																																																									BgL_arg5927z00_7416;
																																																								BgL_arg5925z00_7414
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_cdrzd245183zd2_7411));
																																																								BgL_arg5926z00_7415
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_cdrzd245183zd2_7411));
																																																								BgL_arg5927z00_7416
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_25369;
																																																									{
																																																										obj_t
																																																											BgL_argsz00_25372;
																																																										obj_t
																																																											BgL_bodyz00_25371;
																																																										obj_t
																																																											BgL_varsz00_25370;
																																																										BgL_varsz00_25370
																																																											=
																																																											BgL_arg5925z00_7414;
																																																										BgL_bodyz00_25371
																																																											=
																																																											BgL_arg5926z00_7415;
																																																										BgL_argsz00_25372
																																																											=
																																																											BgL_arg5927z00_7416;
																																																										BgL_argsz00_1742
																																																											=
																																																											BgL_argsz00_25372;
																																																										BgL_bodyz00_1741
																																																											=
																																																											BgL_bodyz00_25371;
																																																										BgL_varsz00_1740
																																																											=
																																																											BgL_varsz00_25370;
																																																										goto
																																																											BgL_tagzd2386zd2_1743;
																																																									}
																																																									BgL_auxz00_22101
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_25369);
																																																								}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd245206zd2_7418;
																																																								BgL_cdrzd245206zd2_7418
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_cdrzd245212zd2_7419;
																																																									BgL_cdrzd245212zd2_7419
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_carzd245178zd2_7410));
																																																									if ((CAR(((obj_t) BgL_carzd245178zd2_7410)) == CNST_TABLE_REF(((long) 1))))
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_cdrzd245218zd2_7422;
																																																											BgL_cdrzd245218zd2_7422
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd245212zd2_7419));
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_carzd245223zd2_7423;
																																																												obj_t
																																																													BgL_cdrzd245224zd2_7424;
																																																												BgL_carzd245223zd2_7423
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd245218zd2_7422));
																																																												BgL_cdrzd245224zd2_7424
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd245218zd2_7422));
																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd245223zd2_7423))
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (PAIRP(BgL_cdrzd245224zd2_7424))
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_carzd245231zd2_7427;
																																																																BgL_carzd245231zd2_7427
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd245224zd2_7424);
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd245231zd2_7427))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (NULLP(CDR(BgL_cdrzd245224zd2_7424)))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				bool_t
																																																																					BgL_test9870z00_25399;
																																																																				{
																																																																					obj_t
																																																																						BgL_l1444z00_7460;
																																																																					BgL_l1444z00_7460
																																																																						=
																																																																						BgL_cdrzd245206zd2_7418;
																																																																				BgL_zc3z04anonymousza35950ze3z87_7461:
																																																																					if (NULLP(BgL_l1444z00_7460))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							BgL_test9870z00_25399
																																																																								=
																																																																								(
																																																																								(bool_t)
																																																																								1);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							bool_t
																																																																								BgL_test9872z00_25402;
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								bool_t
																																																																									BgL_test9873z00_25403;
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_tmpz00_25404;
																																																																									BgL_tmpz00_25404
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_l1444z00_7460));
																																																																									BgL_test9873z00_25403
																																																																										=
																																																																										PAIRP
																																																																										(BgL_tmpz00_25404);
																																																																								}
																																																																								if (BgL_test9873z00_25403)
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										BgL_test9872z00_25402
																																																																											=
																																																																											(
																																																																											(bool_t)
																																																																											0);
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										BgL_test9872z00_25402
																																																																											=
																																																																											(
																																																																											(bool_t)
																																																																											1);
																																																																									}
																																																																							}
																																																																							if (BgL_test9872z00_25402)
																																																																								{
																																																																									obj_t
																																																																										BgL_l1444z00_25408;
																																																																									BgL_l1444z00_25408
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_l1444z00_7460));
																																																																									BgL_l1444z00_7460
																																																																										=
																																																																										BgL_l1444z00_25408;
																																																																									goto
																																																																										BgL_zc3z04anonymousza35950ze3z87_7461;
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									BgL_test9870z00_25399
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										0);
																																																																								}
																																																																						}
																																																																				}
																																																																				if (BgL_test9870z00_25399)
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_arg5940z00_7443;
																																																																						BgL_arg5940z00_7443
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd245212zd2_7419));
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_25413;
																																																																							{
																																																																								obj_t
																																																																									BgL_argsz00_25417;
																																																																								obj_t
																																																																									BgL_proc2z00_25416;
																																																																								obj_t
																																																																									BgL_proc1z00_25415;
																																																																								obj_t
																																																																									BgL_testz00_25414;
																																																																								BgL_testz00_25414
																																																																									=
																																																																									BgL_arg5940z00_7443;
																																																																								BgL_proc1z00_25415
																																																																									=
																																																																									BgL_carzd245223zd2_7423;
																																																																								BgL_proc2z00_25416
																																																																									=
																																																																									BgL_carzd245231zd2_7427;
																																																																								BgL_argsz00_25417
																																																																									=
																																																																									BgL_cdrzd245206zd2_7418;
																																																																								BgL_argsz00_1747
																																																																									=
																																																																									BgL_argsz00_25417;
																																																																								BgL_proc2z00_1746
																																																																									=
																																																																									BgL_proc2z00_25416;
																																																																								BgL_proc1z00_1745
																																																																									=
																																																																									BgL_proc1z00_25415;
																																																																								BgL_testz00_1744
																																																																									=
																																																																									BgL_testz00_25414;
																																																																								goto
																																																																									BgL_tagzd2387zd2_1748;
																																																																							}
																																																																							BgL_auxz00_22101
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_25413);
																																																																						}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd245255zd2_7444;
																																																																						BgL_cdrzd245255zd2_7444
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd245262zd2_7445;
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_pairz00_12609;
																																																																								BgL_pairz00_12609
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								BgL_cdrzd245262zd2_7445
																																																																									=
																																																																									CDR
																																																																									(BgL_pairz00_12609);
																																																																							}
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd245269zd2_7446;
																																																																								BgL_cdrzd245269zd2_7446
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd245262zd2_7445));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd245275zd2_7447;
																																																																									BgL_carzd245275zd2_7447
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd245269zd2_7446));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd245275zd2_7447))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd245282zd2_7449;
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_pairz00_12613;
																																																																												BgL_pairz00_12613
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd245269zd2_7446));
																																																																												BgL_carzd245282zd2_7449
																																																																													=
																																																																													CAR
																																																																													(BgL_pairz00_12613);
																																																																											}
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd245282zd2_7449))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd245255zd2_7444))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg5944z00_7452;
																																																																															BgL_arg5944z00_7452
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd245262zd2_7445));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_25439;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_25443;
																																																																																	obj_t
																																																																																		BgL_proc2z00_25442;
																																																																																	obj_t
																																																																																		BgL_proc1z00_25441;
																																																																																	obj_t
																																																																																		BgL_testz00_25440;
																																																																																	BgL_testz00_25440
																																																																																		=
																																																																																		BgL_arg5944z00_7452;
																																																																																	BgL_proc1z00_25441
																																																																																		=
																																																																																		BgL_carzd245275zd2_7447;
																																																																																	BgL_proc2z00_25442
																																																																																		=
																																																																																		BgL_carzd245282zd2_7449;
																																																																																	BgL_argsz00_25443
																																																																																		=
																																																																																		BgL_cdrzd245255zd2_7444;
																																																																																	BgL_argsz00_1752
																																																																																		=
																																																																																		BgL_argsz00_25443;
																																																																																	BgL_proc2z00_1751
																																																																																		=
																																																																																		BgL_proc2z00_25442;
																																																																																	BgL_proc1z00_1750
																																																																																		=
																																																																																		BgL_proc1z00_25441;
																																																																																	BgL_testz00_1749
																																																																																		=
																																																																																		BgL_testz00_25440;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1753;
																																																																																}
																																																																																BgL_auxz00_22101
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_25439);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1777;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_25447;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1778;
																																																																																	BgL_auxz00_22101
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_25447);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1777;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_25451;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1778;
																																																																															BgL_auxz00_22101
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_25451);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1777;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_25455;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1778;
																																																																													BgL_auxz00_22101
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_25455);
																																																																												}
																																																																										}
																																																																								}
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1777;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_25459;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1778;
																																																																						BgL_auxz00_22101
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_25459);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd245558zd2_7471;
																																																																		BgL_cdrzd245558zd2_7471
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd245564zd2_7472;
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_pairz00_12617;
																																																																				BgL_pairz00_12617
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				BgL_cdrzd245564zd2_7472
																																																																					=
																																																																					CDR
																																																																					(BgL_pairz00_12617);
																																																																			}
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd245570zd2_7473;
																																																																				BgL_cdrzd245570zd2_7473
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd245564zd2_7472));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_carzd245575zd2_7474;
																																																																					obj_t
																																																																						BgL_cdrzd245576zd2_7475;
																																																																					BgL_carzd245575zd2_7474
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd245570zd2_7473));
																																																																					BgL_cdrzd245576zd2_7475
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd245570zd2_7473));
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd245575zd2_7474))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd245581zd2_7477;
																																																																							BgL_carzd245581zd2_7477
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd245576zd2_7475));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd245581zd2_7477))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (NULLP(CDR(((obj_t) BgL_cdrzd245576zd2_7475))))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd245558zd2_7471))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_arg5959z00_7482;
																																																																													BgL_arg5959z00_7482
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd245564zd2_7472));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_25486;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_25490;
																																																																															obj_t
																																																																																BgL_proc2z00_25489;
																																																																															obj_t
																																																																																BgL_proc1z00_25488;
																																																																															obj_t
																																																																																BgL_testz00_25487;
																																																																															BgL_testz00_25487
																																																																																=
																																																																																BgL_arg5959z00_7482;
																																																																															BgL_proc1z00_25488
																																																																																=
																																																																																BgL_carzd245575zd2_7474;
																																																																															BgL_proc2z00_25489
																																																																																=
																																																																																BgL_carzd245581zd2_7477;
																																																																															BgL_argsz00_25490
																																																																																=
																																																																																BgL_cdrzd245558zd2_7471;
																																																																															BgL_argsz00_1752
																																																																																=
																																																																																BgL_argsz00_25490;
																																																																															BgL_proc2z00_1751
																																																																																=
																																																																																BgL_proc2z00_25489;
																																																																															BgL_proc1z00_1750
																																																																																=
																																																																																BgL_proc1z00_25488;
																																																																															BgL_testz00_1749
																																																																																=
																																																																																BgL_testz00_25487;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1753;
																																																																														}
																																																																														BgL_auxz00_22101
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_25486);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1777;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_25494;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1778;
																																																																															BgL_auxz00_22101
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_25494);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1777;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_25498;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1778;
																																																																													BgL_auxz00_22101
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_25498);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1777;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_25502;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1778;
																																																																											BgL_auxz00_22101
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_25502);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1777;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_25506;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1778;
																																																																									BgL_auxz00_22101
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_25506);
																																																																								}
																																																																						}
																																																																				}
																																																																			}
																																																																		}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1777;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_25510;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1778;
																																																																		BgL_auxz00_22101
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_25510);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd245914zd2_7490;
																																																														BgL_cdrzd245914zd2_7490
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd245921zd2_7491;
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_pairz00_12627;
																																																																BgL_pairz00_12627
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																BgL_cdrzd245921zd2_7491
																																																																	=
																																																																	CDR
																																																																	(BgL_pairz00_12627);
																																																															}
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd245928zd2_7492;
																																																																BgL_cdrzd245928zd2_7492
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd245921zd2_7491));
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_carzd245934zd2_7493;
																																																																	obj_t
																																																																		BgL_cdrzd245935zd2_7494;
																																																																	BgL_carzd245934zd2_7493
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd245928zd2_7492));
																																																																	BgL_cdrzd245935zd2_7494
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd245928zd2_7492));
																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd245934zd2_7493))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (PAIRP(BgL_cdrzd245935zd2_7494))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_carzd245942zd2_7497;
																																																																					BgL_carzd245942zd2_7497
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd245935zd2_7494);
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd245942zd2_7497))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (NULLP(CDR(BgL_cdrzd245935zd2_7494)))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd245914zd2_7490))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_arg5973z00_7502;
																																																																											BgL_arg5973z00_7502
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd245921zd2_7491));
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_25537;
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_25541;
																																																																													obj_t
																																																																														BgL_proc2z00_25540;
																																																																													obj_t
																																																																														BgL_proc1z00_25539;
																																																																													obj_t
																																																																														BgL_testz00_25538;
																																																																													BgL_testz00_25538
																																																																														=
																																																																														BgL_arg5973z00_7502;
																																																																													BgL_proc1z00_25539
																																																																														=
																																																																														BgL_carzd245934zd2_7493;
																																																																													BgL_proc2z00_25540
																																																																														=
																																																																														BgL_carzd245942zd2_7497;
																																																																													BgL_argsz00_25541
																																																																														=
																																																																														BgL_cdrzd245914zd2_7490;
																																																																													BgL_argsz00_1752
																																																																														=
																																																																														BgL_argsz00_25541;
																																																																													BgL_proc2z00_1751
																																																																														=
																																																																														BgL_proc2z00_25540;
																																																																													BgL_proc1z00_1750
																																																																														=
																																																																														BgL_proc1z00_25539;
																																																																													BgL_testz00_1749
																																																																														=
																																																																														BgL_testz00_25538;
																																																																													goto
																																																																														BgL_tagzd2388zd2_1753;
																																																																												}
																																																																												BgL_auxz00_22101
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_25537);
																																																																											}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1777;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_25545;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1778;
																																																																													BgL_auxz00_22101
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_25545);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1777;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_25549;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1778;
																																																																											BgL_auxz00_22101
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_25549);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1777;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_25553;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1778;
																																																																									BgL_auxz00_22101
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_25553);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1777;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_25557;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1778;
																																																																							BgL_auxz00_22101
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_25557);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1777;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_25561;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1778;
																																																																					BgL_auxz00_22101
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_25561);
																																																																				}
																																																																		}
																																																																}
																																																															}
																																																														}
																																																													}
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{	/* Ast/sexp.scm 119 */
																																																													goto
																																																														BgL_tagzd2403zd2_1777;
																																																												}
																																																											else
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_25565;
																																																													goto
																																																														BgL_tagzd2404zd2_1778;
																																																													BgL_auxz00_22101
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_25565);
																																																												}
																																																										}
																																																								}
																																																							}
																																																					}
																																																				}
																																																		}
																																																}
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_cdrzd246335zd2_7516;
																																														BgL_cdrzd246335zd2_7516
																																															=
																																															CDR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{	/* Ast/sexp.scm 119 */
																																															bool_t
																																																BgL_test9901z00_25569;
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_arg6001z00_7533;
																																																BgL_arg6001z00_7533
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																BgL_test9901z00_25569
																																																	=
																																																	CBOOL
																																																	(BGl_letzd2symzf3z21zzast_letz00
																																																	(BgL_arg6001z00_7533));
																																															}
																																															if (BgL_test9901z00_25569)
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg5989z00_7519;
																																																	obj_t
																																																		BgL_arg5990z00_7520;
																																																	BgL_arg5989z00_7519
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd246335zd2_7516));
																																																	BgL_arg5990z00_7520
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd246335zd2_7516));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_25578;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_25580;
																																																			obj_t
																																																				BgL_bindingsz00_25579;
																																																			BgL_bindingsz00_25579
																																																				=
																																																				BgL_arg5989z00_7519;
																																																			BgL_exprz00_25580
																																																				=
																																																				BgL_arg5990z00_7520;
																																																			BgL_exprz00_1732
																																																				=
																																																				BgL_exprz00_25580;
																																																			BgL_bindingsz00_1731
																																																				=
																																																				BgL_bindingsz00_25579;
																																																			goto
																																																				BgL_tagzd2382zd2_1733;
																																																		}
																																																		BgL_auxz00_22101
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_25578);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	bool_t
																																																		BgL_test9902z00_25582;
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_arg6000z00_7532;
																																																		BgL_arg6000z00_7532
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_test9902z00_25582
																																																			=
																																																			CBOOL
																																																			(BGl_labelszd2symzf3z21zzast_labelsz00
																																																			(BgL_arg6000z00_7532));
																																																	}
																																																	if (BgL_test9902z00_25582)
																																																		{
																																																			BgL_letzd2funzd2_bglt
																																																				BgL_auxz00_25587;
																																																			goto
																																																				BgL_tagzd2384zd2_1735;
																																																			BgL_auxz00_22101
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_25587);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_carzd246401zd2_7523;
																																																			BgL_carzd246401zd2_7523
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd246406zd2_7524;
																																																				BgL_cdrzd246406zd2_7524
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_carzd246401zd2_7523));
																																																				if ((CAR(((obj_t) BgL_carzd246401zd2_7523)) == CNST_TABLE_REF(((long) 3))))
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg5995z00_7527;
																																																						obj_t
																																																							BgL_arg5996z00_7528;
																																																						obj_t
																																																							BgL_arg5997z00_7529;
																																																						BgL_arg5995z00_7527
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_cdrzd246406zd2_7524));
																																																						BgL_arg5996z00_7528
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_cdrzd246406zd2_7524));
																																																						BgL_arg5997z00_7529
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_25604;
																																																							{
																																																								obj_t
																																																									BgL_argsz00_25607;
																																																								obj_t
																																																									BgL_bodyz00_25606;
																																																								obj_t
																																																									BgL_varsz00_25605;
																																																								BgL_varsz00_25605
																																																									=
																																																									BgL_arg5995z00_7527;
																																																								BgL_bodyz00_25606
																																																									=
																																																									BgL_arg5996z00_7528;
																																																								BgL_argsz00_25607
																																																									=
																																																									BgL_arg5997z00_7529;
																																																								BgL_argsz00_1742
																																																									=
																																																									BgL_argsz00_25607;
																																																								BgL_bodyz00_1741
																																																									=
																																																									BgL_bodyz00_25606;
																																																								BgL_varsz00_1740
																																																									=
																																																									BgL_varsz00_25605;
																																																								goto
																																																									BgL_tagzd2386zd2_1743;
																																																							}
																																																							BgL_auxz00_22101
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_25604);
																																																						}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																							{	/* Ast/sexp.scm 119 */
																																																								goto
																																																									BgL_tagzd2403zd2_1777;
																																																							}
																																																						else
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_25611;
																																																								goto
																																																									BgL_tagzd2404zd2_1778;
																																																								BgL_auxz00_22101
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_25611);
																																																							}
																																																					}
																																																			}
																																																		}
																																																}
																																														}
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												obj_t
																																													BgL_cdrzd246517zd2_7534;
																																												BgL_cdrzd246517zd2_7534
																																													=
																																													CDR
																																													(
																																													((obj_t) BgL_expz00_21));
																																												{	/* Ast/sexp.scm 119 */
																																													bool_t
																																														BgL_test9905z00_25615;
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_arg6010z00_7543;
																																														BgL_arg6010z00_7543
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														BgL_test9905z00_25615
																																															=
																																															CBOOL
																																															(BGl_letzd2symzf3z21zzast_letz00
																																															(BgL_arg6010z00_7543));
																																													}
																																													if (BgL_test9905z00_25615)
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg6004z00_7537;
																																															obj_t
																																																BgL_arg6005z00_7538;
																																															BgL_arg6004z00_7537
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd246517zd2_7534));
																																															BgL_arg6005z00_7538
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd246517zd2_7534));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_25624;
																																																{
																																																	obj_t
																																																		BgL_exprz00_25626;
																																																	obj_t
																																																		BgL_bindingsz00_25625;
																																																	BgL_bindingsz00_25625
																																																		=
																																																		BgL_arg6004z00_7537;
																																																	BgL_exprz00_25626
																																																		=
																																																		BgL_arg6005z00_7538;
																																																	BgL_exprz00_1732
																																																		=
																																																		BgL_exprz00_25626;
																																																	BgL_bindingsz00_1731
																																																		=
																																																		BgL_bindingsz00_25625;
																																																	goto
																																																		BgL_tagzd2382zd2_1733;
																																																}
																																																BgL_auxz00_22101
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_25624);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															bool_t
																																																BgL_test9906z00_25628;
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_arg6009z00_7542;
																																																BgL_arg6009z00_7542
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																BgL_test9906z00_25628
																																																	=
																																																	CBOOL
																																																	(BGl_labelszd2symzf3z21zzast_labelsz00
																																																	(BgL_arg6009z00_7542));
																																															}
																																															if (BgL_test9906z00_25628)
																																																{
																																																	BgL_letzd2funzd2_bglt
																																																		BgL_auxz00_25633;
																																																	goto
																																																		BgL_tagzd2384zd2_1735;
																																																	BgL_auxz00_22101
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_25633);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																		{	/* Ast/sexp.scm 119 */
																																																			goto
																																																				BgL_tagzd2403zd2_1777;
																																																		}
																																																	else
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_25637;
																																																			goto
																																																				BgL_tagzd2404zd2_1778;
																																																			BgL_auxz00_22101
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_25637);
																																																		}
																																																}
																																														}
																																												}
																																											}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 119 */
																																										if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd245082zd2_7270)))
																																											{	/* Ast/sexp.scm 119 */
																																												goto
																																													BgL_kapzd245084zd2_7272;
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												if ((BgL_carzd245082zd2_7270 == CNST_TABLE_REF(((long) 18))))
																																													{	/* Ast/sexp.scm 119 */
																																														goto
																																															BgL_kapzd245084zd2_7272;
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														if ((BgL_carzd245082zd2_7270 == CNST_TABLE_REF(((long) 19))))
																																															{	/* Ast/sexp.scm 119 */
																																																goto
																																																	BgL_kapzd245084zd2_7272;
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd245082zd2_7270)))
																																																	{	/* Ast/sexp.scm 119 */
																																																		goto
																																																			BgL_kapzd245084zd2_7272;
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_cdrzd246689zd2_7278;
																																																		BgL_cdrzd246689zd2_7278
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 119 */
																																																			bool_t
																																																				BgL_test9912z00_25653;
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg5910z00_7395;
																																																				BgL_arg5910z00_7395
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test9912z00_25653
																																																					=
																																																					CBOOL
																																																					(BGl_letzd2symzf3z21zzast_letz00
																																																					(BgL_arg5910z00_7395));
																																																			}
																																																			if (BgL_test9912z00_25653)
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_arg5838z00_7281;
																																																					obj_t
																																																						BgL_arg5839z00_7282;
																																																					BgL_arg5838z00_7281
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd246689zd2_7278));
																																																					BgL_arg5839z00_7282
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd246689zd2_7278));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_25662;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_25664;
																																																							obj_t
																																																								BgL_bindingsz00_25663;
																																																							BgL_bindingsz00_25663
																																																								=
																																																								BgL_arg5838z00_7281;
																																																							BgL_exprz00_25664
																																																								=
																																																								BgL_arg5839z00_7282;
																																																							BgL_exprz00_1732
																																																								=
																																																								BgL_exprz00_25664;
																																																							BgL_bindingsz00_1731
																																																								=
																																																								BgL_bindingsz00_25663;
																																																							goto
																																																								BgL_tagzd2382zd2_1733;
																																																						}
																																																						BgL_auxz00_22101
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_25662);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					bool_t
																																																						BgL_test9913z00_25666;
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg5909z00_7394;
																																																						BgL_arg5909z00_7394
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test9913z00_25666
																																																							=
																																																							CBOOL
																																																							(BGl_labelszd2symzf3z21zzast_labelsz00
																																																							(BgL_arg5909z00_7394));
																																																					}
																																																					if (BgL_test9913z00_25666)
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_25671;
																																																							goto
																																																								BgL_tagzd2384zd2_1735;
																																																							BgL_auxz00_22101
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_25671);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_carzd246755zd2_7285;
																																																							BgL_carzd246755zd2_7285
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd246760zd2_7286;
																																																								BgL_cdrzd246760zd2_7286
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_carzd246755zd2_7285));
																																																								if ((CAR(((obj_t) BgL_carzd246755zd2_7285)) == CNST_TABLE_REF(((long) 3))))
																																																									{	/* Ast/sexp.scm 119 */
																																																										if (PAIRP(BgL_cdrzd246760zd2_7286))
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_arg5845z00_7290;
																																																												obj_t
																																																													BgL_arg5846z00_7291;
																																																												obj_t
																																																													BgL_arg5847z00_7292;
																																																												BgL_arg5845z00_7290
																																																													=
																																																													CAR
																																																													(BgL_cdrzd246760zd2_7286);
																																																												BgL_arg5846z00_7291
																																																													=
																																																													CDR
																																																													(BgL_cdrzd246760zd2_7286);
																																																												BgL_arg5847z00_7292
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_25688;
																																																													{
																																																														obj_t
																																																															BgL_argsz00_25691;
																																																														obj_t
																																																															BgL_bodyz00_25690;
																																																														obj_t
																																																															BgL_varsz00_25689;
																																																														BgL_varsz00_25689
																																																															=
																																																															BgL_arg5845z00_7290;
																																																														BgL_bodyz00_25690
																																																															=
																																																															BgL_arg5846z00_7291;
																																																														BgL_argsz00_25691
																																																															=
																																																															BgL_arg5847z00_7292;
																																																														BgL_argsz00_1742
																																																															=
																																																															BgL_argsz00_25691;
																																																														BgL_bodyz00_1741
																																																															=
																																																															BgL_bodyz00_25690;
																																																														BgL_varsz00_1740
																																																															=
																																																															BgL_varsz00_25689;
																																																														goto
																																																															BgL_tagzd2386zd2_1743;
																																																													}
																																																													BgL_auxz00_22101
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_25688);
																																																												}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 119 */
																																																														goto
																																																															BgL_tagzd2403zd2_1777;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_25695;
																																																														goto
																																																															BgL_tagzd2404zd2_1778;
																																																														BgL_auxz00_22101
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_25695);
																																																													}
																																																											}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd246867zd2_7295;
																																																										BgL_cdrzd246867zd2_7295
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_cdrzd246872zd2_7296;
																																																											BgL_cdrzd246872zd2_7296
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_carzd246755zd2_7285));
																																																											if ((CAR(((obj_t) BgL_carzd246755zd2_7285)) == CNST_TABLE_REF(((long) 1))))
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (PAIRP(BgL_cdrzd246872zd2_7296))
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd246877zd2_7300;
																																																															BgL_cdrzd246877zd2_7300
																																																																=
																																																																CDR
																																																																(BgL_cdrzd246872zd2_7296);
																																																															if (PAIRP(BgL_cdrzd246877zd2_7300))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_carzd246881zd2_7302;
																																																																	obj_t
																																																																		BgL_cdrzd246882zd2_7303;
																																																																	BgL_carzd246881zd2_7302
																																																																		=
																																																																		CAR
																																																																		(BgL_cdrzd246877zd2_7300);
																																																																	BgL_cdrzd246882zd2_7303
																																																																		=
																																																																		CDR
																																																																		(BgL_cdrzd246877zd2_7300);
																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd246881zd2_7302))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (PAIRP(BgL_cdrzd246882zd2_7303))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_carzd246887zd2_7306;
																																																																					BgL_carzd246887zd2_7306
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd246882zd2_7303);
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd246887zd2_7306))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (NULLP(CDR(BgL_cdrzd246882zd2_7303)))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									bool_t
																																																																										BgL_test9924z00_25723;
																																																																									{
																																																																										obj_t
																																																																											BgL_l1447z00_7339;
																																																																										BgL_l1447z00_7339
																																																																											=
																																																																											BgL_cdrzd246867zd2_7295;
																																																																									BgL_zc3z04anonymousza35873ze3z87_7340:
																																																																										if (NULLP(BgL_l1447z00_7339))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												BgL_test9924z00_25723
																																																																													=
																																																																													(
																																																																													(bool_t)
																																																																													1);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												bool_t
																																																																													BgL_test9926z00_25726;
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													bool_t
																																																																														BgL_test9927z00_25727;
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_tmpz00_25728;
																																																																														BgL_tmpz00_25728
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_l1447z00_7339));
																																																																														BgL_test9927z00_25727
																																																																															=
																																																																															PAIRP
																																																																															(BgL_tmpz00_25728);
																																																																													}
																																																																													if (BgL_test9927z00_25727)
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															BgL_test9926z00_25726
																																																																																=
																																																																																(
																																																																																(bool_t)
																																																																																0);
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															BgL_test9926z00_25726
																																																																																=
																																																																																(
																																																																																(bool_t)
																																																																																1);
																																																																														}
																																																																												}
																																																																												if (BgL_test9926z00_25726)
																																																																													{
																																																																														obj_t
																																																																															BgL_l1447z00_25732;
																																																																														BgL_l1447z00_25732
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_l1447z00_7339));
																																																																														BgL_l1447z00_7339
																																																																															=
																																																																															BgL_l1447z00_25732;
																																																																														goto
																																																																															BgL_zc3z04anonymousza35873ze3z87_7340;
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														BgL_test9924z00_25723
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															0);
																																																																													}
																																																																											}
																																																																									}
																																																																									if (BgL_test9924z00_25723)
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_arg5863z00_7322;
																																																																											BgL_arg5863z00_7322
																																																																												=
																																																																												CAR
																																																																												(BgL_cdrzd246872zd2_7296);
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_25736;
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_25740;
																																																																													obj_t
																																																																														BgL_proc2z00_25739;
																																																																													obj_t
																																																																														BgL_proc1z00_25738;
																																																																													obj_t
																																																																														BgL_testz00_25737;
																																																																													BgL_testz00_25737
																																																																														=
																																																																														BgL_arg5863z00_7322;
																																																																													BgL_proc1z00_25738
																																																																														=
																																																																														BgL_carzd246881zd2_7302;
																																																																													BgL_proc2z00_25739
																																																																														=
																																																																														BgL_carzd246887zd2_7306;
																																																																													BgL_argsz00_25740
																																																																														=
																																																																														BgL_cdrzd246867zd2_7295;
																																																																													BgL_argsz00_1747
																																																																														=
																																																																														BgL_argsz00_25740;
																																																																													BgL_proc2z00_1746
																																																																														=
																																																																														BgL_proc2z00_25739;
																																																																													BgL_proc1z00_1745
																																																																														=
																																																																														BgL_proc1z00_25738;
																																																																													BgL_testz00_1744
																																																																														=
																																																																														BgL_testz00_25737;
																																																																													goto
																																																																														BgL_tagzd2387zd2_1748;
																																																																												}
																																																																												BgL_auxz00_22101
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_25736);
																																																																											}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd246912zd2_7323;
																																																																											BgL_cdrzd246912zd2_7323
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_cdrzd246920zd2_7324;
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_pairz00_12684;
																																																																													BgL_pairz00_12684
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													BgL_cdrzd246920zd2_7324
																																																																														=
																																																																														CDR
																																																																														(BgL_pairz00_12684);
																																																																												}
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd246928zd2_7325;
																																																																													BgL_cdrzd246928zd2_7325
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd246920zd2_7324));
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_carzd246935zd2_7326;
																																																																														BgL_carzd246935zd2_7326
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd246928zd2_7325));
																																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd246935zd2_7326))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_carzd246944zd2_7328;
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_pairz00_12688;
																																																																																	BgL_pairz00_12688
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd246928zd2_7325));
																																																																																	BgL_carzd246944zd2_7328
																																																																																		=
																																																																																		CAR
																																																																																		(BgL_pairz00_12688);
																																																																																}
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd246944zd2_7328))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd246912zd2_7323))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_arg5867z00_7331;
																																																																																				BgL_arg5867z00_7331
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd246920zd2_7324));
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_25762;
																																																																																					{
																																																																																						obj_t
																																																																																							BgL_argsz00_25766;
																																																																																						obj_t
																																																																																							BgL_proc2z00_25765;
																																																																																						obj_t
																																																																																							BgL_proc1z00_25764;
																																																																																						obj_t
																																																																																							BgL_testz00_25763;
																																																																																						BgL_testz00_25763
																																																																																							=
																																																																																							BgL_arg5867z00_7331;
																																																																																						BgL_proc1z00_25764
																																																																																							=
																																																																																							BgL_carzd246935zd2_7326;
																																																																																						BgL_proc2z00_25765
																																																																																							=
																																																																																							BgL_carzd246944zd2_7328;
																																																																																						BgL_argsz00_25766
																																																																																							=
																																																																																							BgL_cdrzd246912zd2_7323;
																																																																																						BgL_argsz00_1752
																																																																																							=
																																																																																							BgL_argsz00_25766;
																																																																																						BgL_proc2z00_1751
																																																																																							=
																																																																																							BgL_proc2z00_25765;
																																																																																						BgL_proc1z00_1750
																																																																																							=
																																																																																							BgL_proc1z00_25764;
																																																																																						BgL_testz00_1749
																																																																																							=
																																																																																							BgL_testz00_25763;
																																																																																						goto
																																																																																							BgL_tagzd2388zd2_1753;
																																																																																					}
																																																																																					BgL_auxz00_22101
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_25762);
																																																																																				}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1777;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_25770;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1778;
																																																																																						BgL_auxz00_22101
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_25770);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1777;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_25774;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1778;
																																																																																				BgL_auxz00_22101
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_25774);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1777;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_25778;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1778;
																																																																																		BgL_auxz00_22101
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_25778);
																																																																																	}
																																																																															}
																																																																													}
																																																																												}
																																																																											}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1777;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_25782;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1778;
																																																																											BgL_auxz00_22101
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_25782);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd247222zd2_7350;
																																																																							BgL_cdrzd247222zd2_7350
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd247229zd2_7351;
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_pairz00_12692;
																																																																									BgL_pairz00_12692
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									BgL_cdrzd247229zd2_7351
																																																																										=
																																																																										CDR
																																																																										(BgL_pairz00_12692);
																																																																								}
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd247236zd2_7352;
																																																																									BgL_cdrzd247236zd2_7352
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd247229zd2_7351));
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_carzd247242zd2_7353;
																																																																										obj_t
																																																																											BgL_cdrzd247243zd2_7354;
																																																																										BgL_carzd247242zd2_7353
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd247236zd2_7352));
																																																																										BgL_cdrzd247243zd2_7354
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd247236zd2_7352));
																																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd247242zd2_7353))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_carzd247250zd2_7356;
																																																																												BgL_carzd247250zd2_7356
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd247243zd2_7354));
																																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd247250zd2_7356))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (NULLP(CDR(((obj_t) BgL_cdrzd247243zd2_7354))))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd247222zd2_7350))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_arg5882z00_7361;
																																																																																		BgL_arg5882z00_7361
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd247229zd2_7351));
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_25809;
																																																																																			{
																																																																																				obj_t
																																																																																					BgL_argsz00_25813;
																																																																																				obj_t
																																																																																					BgL_proc2z00_25812;
																																																																																				obj_t
																																																																																					BgL_proc1z00_25811;
																																																																																				obj_t
																																																																																					BgL_testz00_25810;
																																																																																				BgL_testz00_25810
																																																																																					=
																																																																																					BgL_arg5882z00_7361;
																																																																																				BgL_proc1z00_25811
																																																																																					=
																																																																																					BgL_carzd247242zd2_7353;
																																																																																				BgL_proc2z00_25812
																																																																																					=
																																																																																					BgL_carzd247250zd2_7356;
																																																																																				BgL_argsz00_25813
																																																																																					=
																																																																																					BgL_cdrzd247222zd2_7350;
																																																																																				BgL_argsz00_1752
																																																																																					=
																																																																																					BgL_argsz00_25813;
																																																																																				BgL_proc2z00_1751
																																																																																					=
																																																																																					BgL_proc2z00_25812;
																																																																																				BgL_proc1z00_1750
																																																																																					=
																																																																																					BgL_proc1z00_25811;
																																																																																				BgL_testz00_1749
																																																																																					=
																																																																																					BgL_testz00_25810;
																																																																																				goto
																																																																																					BgL_tagzd2388zd2_1753;
																																																																																			}
																																																																																			BgL_auxz00_22101
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_25809);
																																																																																		}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1777;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_25817;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1778;
																																																																																				BgL_auxz00_22101
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_25817);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1777;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_25821;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1778;
																																																																																		BgL_auxz00_22101
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_25821);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1777;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_25825;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1778;
																																																																																BgL_auxz00_22101
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_25825);
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1777;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_25829;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1778;
																																																																														BgL_auxz00_22101
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_25829);
																																																																													}
																																																																											}
																																																																									}
																																																																								}
																																																																							}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1777;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_25833;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1778;
																																																																							BgL_auxz00_22101
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_25833);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd247583zd2_7369;
																																																																			BgL_cdrzd247583zd2_7369
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_expz00_21));
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd247589zd2_7370;
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_pairz00_12702;
																																																																					BgL_pairz00_12702
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					BgL_cdrzd247589zd2_7370
																																																																						=
																																																																						CDR
																																																																						(BgL_pairz00_12702);
																																																																				}
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd247595zd2_7371;
																																																																					BgL_cdrzd247595zd2_7371
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd247589zd2_7370));
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_carzd247600zd2_7372;
																																																																						obj_t
																																																																							BgL_cdrzd247601zd2_7373;
																																																																						BgL_carzd247600zd2_7372
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd247595zd2_7371));
																																																																						BgL_cdrzd247601zd2_7373
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd247595zd2_7371));
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd247600zd2_7372))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (PAIRP(BgL_cdrzd247601zd2_7373))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_carzd247606zd2_7376;
																																																																										BgL_carzd247606zd2_7376
																																																																											=
																																																																											CAR
																																																																											(BgL_cdrzd247601zd2_7373);
																																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd247606zd2_7376))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (NULLP(CDR(BgL_cdrzd247601zd2_7373)))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd247583zd2_7369))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_arg5896z00_7381;
																																																																																BgL_arg5896z00_7381
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd247589zd2_7370));
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_25860;
																																																																																	{
																																																																																		obj_t
																																																																																			BgL_argsz00_25864;
																																																																																		obj_t
																																																																																			BgL_proc2z00_25863;
																																																																																		obj_t
																																																																																			BgL_proc1z00_25862;
																																																																																		obj_t
																																																																																			BgL_testz00_25861;
																																																																																		BgL_testz00_25861
																																																																																			=
																																																																																			BgL_arg5896z00_7381;
																																																																																		BgL_proc1z00_25862
																																																																																			=
																																																																																			BgL_carzd247600zd2_7372;
																																																																																		BgL_proc2z00_25863
																																																																																			=
																																																																																			BgL_carzd247606zd2_7376;
																																																																																		BgL_argsz00_25864
																																																																																			=
																																																																																			BgL_cdrzd247583zd2_7369;
																																																																																		BgL_argsz00_1752
																																																																																			=
																																																																																			BgL_argsz00_25864;
																																																																																		BgL_proc2z00_1751
																																																																																			=
																																																																																			BgL_proc2z00_25863;
																																																																																		BgL_proc1z00_1750
																																																																																			=
																																																																																			BgL_proc1z00_25862;
																																																																																		BgL_testz00_1749
																																																																																			=
																																																																																			BgL_testz00_25861;
																																																																																		goto
																																																																																			BgL_tagzd2388zd2_1753;
																																																																																	}
																																																																																	BgL_auxz00_22101
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_25860);
																																																																																}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1777;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_25868;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1778;
																																																																																		BgL_auxz00_22101
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_25868);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1777;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_25872;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1778;
																																																																																BgL_auxz00_22101
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_25872);
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1777;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_25876;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1778;
																																																																														BgL_auxz00_22101
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_25876);
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1777;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_25880;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1778;
																																																																												BgL_auxz00_22101
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_25880);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1777;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_25884;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1778;
																																																																										BgL_auxz00_22101
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_25884);
																																																																									}
																																																																							}
																																																																					}
																																																																				}
																																																																			}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1777;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_25888;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1778;
																																																																			BgL_auxz00_22101
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_25888);
																																																																		}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1777;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_25892;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1778;
																																																																	BgL_auxz00_22101
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_25892);
																																																																}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{	/* Ast/sexp.scm 119 */
																																																															goto
																																																																BgL_tagzd2403zd2_1777;
																																																														}
																																																													else
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_25896;
																																																															goto
																																																																BgL_tagzd2404zd2_1778;
																																																															BgL_auxz00_22101
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_25896);
																																																														}
																																																												}
																																																										}
																																																									}
																																																							}
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																													}
																																											}
																																									}
																																							}
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							if ((BgL_carzd245079zd2_7268 == CNST_TABLE_REF(((long) 17))))
																																								{	/* Ast/sexp.scm 119 */
																																									obj_t
																																										BgL_arg6012z00_7547;
																																									obj_t
																																										BgL_arg6013z00_7548;
																																									BgL_arg6012z00_7547
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_cdrzd244978zd2_7252));
																																									BgL_arg6013z00_7548
																																										=
																																										CDR
																																										(
																																										((obj_t) BgL_cdrzd244978zd2_7252));
																																									{
																																										BgL_nodez00_bglt
																																											BgL_auxz00_25905;
																																										{
																																											obj_t
																																												BgL_exprz00_25907;
																																											obj_t
																																												BgL_bindingsz00_25906;
																																											BgL_bindingsz00_25906
																																												=
																																												BgL_arg6012z00_7547;
																																											BgL_exprz00_25907
																																												=
																																												BgL_arg6013z00_7548;
																																											BgL_exprz00_1732
																																												=
																																												BgL_exprz00_25907;
																																											BgL_bindingsz00_1731
																																												=
																																												BgL_bindingsz00_25906;
																																											goto
																																												BgL_tagzd2382zd2_1733;
																																										}
																																										BgL_auxz00_22101
																																											=
																																											(
																																											(obj_t)
																																											BgL_auxz00_25905);
																																									}
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd245079zd2_7268)))
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_arg6015z00_7550;
																																											obj_t
																																												BgL_arg6016z00_7551;
																																											BgL_arg6015z00_7550
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_cdrzd244978zd2_7252));
																																											BgL_arg6016z00_7551
																																												=
																																												CDR
																																												(
																																												((obj_t) BgL_cdrzd244978zd2_7252));
																																											{
																																												BgL_nodez00_bglt
																																													BgL_auxz00_25916;
																																												{
																																													obj_t
																																														BgL_exprz00_25918;
																																													obj_t
																																														BgL_bindingsz00_25917;
																																													BgL_bindingsz00_25917
																																														=
																																														BgL_arg6015z00_7550;
																																													BgL_exprz00_25918
																																														=
																																														BgL_arg6016z00_7551;
																																													BgL_exprz00_1732
																																														=
																																														BgL_exprz00_25918;
																																													BgL_bindingsz00_1731
																																														=
																																														BgL_bindingsz00_25917;
																																													goto
																																														BgL_tagzd2382zd2_1733;
																																												}
																																												BgL_auxz00_22101
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_25916);
																																											}
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											if ((BgL_carzd245079zd2_7268 == CNST_TABLE_REF(((long) 18))))
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_arg6018z00_7553;
																																													obj_t
																																														BgL_arg6019z00_7554;
																																													BgL_arg6018z00_7553
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_cdrzd244978zd2_7252));
																																													BgL_arg6019z00_7554
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_cdrzd244978zd2_7252));
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_25927;
																																														{
																																															obj_t
																																																BgL_exprz00_25929;
																																															obj_t
																																																BgL_bindingsz00_25928;
																																															BgL_bindingsz00_25928
																																																=
																																																BgL_arg6018z00_7553;
																																															BgL_exprz00_25929
																																																=
																																																BgL_arg6019z00_7554;
																																															BgL_exprz00_1732
																																																=
																																																BgL_exprz00_25929;
																																															BgL_bindingsz00_1731
																																																=
																																																BgL_bindingsz00_25928;
																																															goto
																																																BgL_tagzd2382zd2_1733;
																																														}
																																														BgL_auxz00_22101
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_25927);
																																													}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_25936;
																																															goto
																																																BgL_tagzd2383zd2_1734;
																																															BgL_auxz00_22101
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_25936);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_carzd248181zd2_7557;
																																															BgL_carzd248181zd2_7557
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															if ((BgL_carzd248181zd2_7557 == CNST_TABLE_REF(((long) 19))))
																																																{
																																																	BgL_letzd2funzd2_bglt
																																																		BgL_auxz00_25943;
																																																	goto
																																																		BgL_tagzd2384zd2_1735;
																																																	BgL_auxz00_22101
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_25943);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd248181zd2_7557)))
																																																		{
																																																			BgL_letzd2funzd2_bglt
																																																				BgL_auxz00_25948;
																																																			goto
																																																				BgL_tagzd2384zd2_1735;
																																																			BgL_auxz00_22101
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_25948);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_25955;
																																																					goto
																																																						BgL_tagzd2389zd2_1754;
																																																					BgL_auxz00_22101
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_25955);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_25962;
																																																							goto
																																																								BgL_tagzd2390zd2_1755;
																																																							BgL_auxz00_22101
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_25962);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_cdrzd248261zd2_7564;
																																																							BgL_cdrzd248261zd2_7564
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_arg6030z00_7567;
																																																									obj_t
																																																										BgL_arg6031z00_7568;
																																																									BgL_arg6030z00_7567
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd248261zd2_7564));
																																																									BgL_arg6031z00_7568
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd248261zd2_7564));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_25975;
																																																										{
																																																											obj_t
																																																												BgL_restz00_25977;
																																																											obj_t
																																																												BgL_effectz00_25976;
																																																											BgL_effectz00_25976
																																																												=
																																																												BgL_arg6030z00_7567;
																																																											BgL_restz00_25977
																																																												=
																																																												BgL_arg6031z00_7568;
																																																											BgL_restz00_1757
																																																												=
																																																												BgL_restz00_25977;
																																																											BgL_effectz00_1756
																																																												=
																																																												BgL_effectz00_25976;
																																																											goto
																																																												BgL_tagzd2391zd2_1758;
																																																										}
																																																										BgL_auxz00_22101
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_25975);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_25984;
																																																											goto
																																																												BgL_tagzd2392zd2_1759;
																																																											BgL_auxz00_22101
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_25984);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_25991;
																																																													goto
																																																														BgL_tagzd2393zd2_1760;
																																																													BgL_auxz00_22101
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_25991);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_arg6038z00_7576;
																																																															obj_t
																																																																BgL_arg6039z00_7577;
																																																															BgL_arg6038z00_7576
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd248261zd2_7564));
																																																															BgL_arg6039z00_7577
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd248261zd2_7564));
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_26002;
																																																																{
																																																																	obj_t
																																																																		BgL_restz00_26004;
																																																																	obj_t
																																																																		BgL_effectz00_26003;
																																																																	BgL_effectz00_26003
																																																																		=
																																																																		BgL_arg6038z00_7576;
																																																																	BgL_restz00_26004
																																																																		=
																																																																		BgL_arg6039z00_7577;
																																																																	BgL_restz00_1762
																																																																		=
																																																																		BgL_restz00_26004;
																																																																	BgL_effectz00_1761
																																																																		=
																																																																		BgL_effectz00_26003;
																																																																	goto
																																																																		BgL_tagzd2394zd2_1763;
																																																																}
																																																																BgL_auxz00_22101
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_26002);
																																																															}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_26011;
																																																																	goto
																																																																		BgL_tagzd2395zd2_1764;
																																																																	BgL_auxz00_22101
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_26011);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_26018;
																																																																			goto
																																																																				BgL_tagzd2396zd2_1765;
																																																																			BgL_auxz00_22101
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_26018);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																				{
																																																																					BgL_letzd2funzd2_bglt
																																																																						BgL_auxz00_26025;
																																																																					goto
																																																																						BgL_tagzd2397zd2_1766;
																																																																					BgL_auxz00_22101
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_26025);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																						{
																																																																							BgL_jumpzd2exzd2itz00_bglt
																																																																								BgL_auxz00_26032;
																																																																							goto
																																																																								BgL_tagzd2398zd2_1767;
																																																																							BgL_auxz00_22101
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_26032);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 30))))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									bool_t
																																																																										BgL_test9974z00_26039;
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_tmpz00_26040;
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_pairz00_12740;
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_pairz00_12739;
																																																																												BgL_pairz00_12739
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												BgL_pairz00_12740
																																																																													=
																																																																													CDR
																																																																													(BgL_pairz00_12739);
																																																																											}
																																																																											BgL_tmpz00_26040
																																																																												=
																																																																												CDR
																																																																												(BgL_pairz00_12740);
																																																																										}
																																																																										BgL_test9974z00_26039
																																																																											=
																																																																											NULLP
																																																																											(BgL_tmpz00_26040);
																																																																									}
																																																																									if (BgL_test9974z00_26039)
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_26046;
																																																																											goto
																																																																												BgL_tagzd2399zd2_1768;
																																																																											BgL_auxz00_22101
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_26046);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1777;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_26050;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1778;
																																																																													BgL_auxz00_22101
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_26050);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd248349zd2_7596;
																																																																									BgL_cdrzd248349zd2_7596
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd248355zd2_7599;
																																																																											BgL_cdrzd248355zd2_7599
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd248349zd2_7596));
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_cdrzd248361zd2_7600;
																																																																												BgL_cdrzd248361zd2_7600
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd248355zd2_7599));
																																																																												if ((CAR(((obj_t) BgL_cdrzd248355zd2_7599)) == CNST_TABLE_REF(((long) 31))))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (PAIRP(BgL_cdrzd248361zd2_7600))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_arg6063z00_7604;
																																																																																obj_t
																																																																																	BgL_arg6064z00_7605;
																																																																																obj_t
																																																																																	BgL_arg6065z00_7606;
																																																																																BgL_arg6063z00_7604
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd248349zd2_7596));
																																																																																BgL_arg6064z00_7605
																																																																																	=
																																																																																	CAR
																																																																																	(BgL_cdrzd248361zd2_7600);
																																																																																BgL_arg6065z00_7606
																																																																																	=
																																																																																	CDR
																																																																																	(BgL_cdrzd248361zd2_7600);
																																																																																{	/* Ast/sexp.scm 550 */
																																																																																	obj_t
																																																																																		BgL_arg6964z00_12751;
																																																																																	BgL_arg6964z00_12751
																																																																																		=
																																																																																		BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																		(BgL_expz00_21,
																																																																																		BgL_locz00_23);
																																																																																	BgL_auxz00_22101
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																		(BgL_expz00_21,
																																																																																			BgL_arg6063z00_7604,
																																																																																			BgL_arg6064z00_7605,
																																																																																			BgL_arg6065z00_7606,
																																																																																			BgL_stackz00_22,
																																																																																			BgL_arg6964z00_12751,
																																																																																			BgL_sitez00_24));
																																																																																}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_arg6066z00_7608;
																																																																																obj_t
																																																																																	BgL_arg6067z00_7609;
																																																																																BgL_arg6066z00_7608
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd248349zd2_7596));
																																																																																BgL_arg6067z00_7609
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd248349zd2_7596));
																																																																																{	/* Ast/sexp.scm 552 */
																																																																																	obj_t
																																																																																		BgL_arg6965z00_12755;
																																																																																	BgL_arg6965z00_12755
																																																																																		=
																																																																																		BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																		(BgL_expz00_21,
																																																																																		BgL_locz00_23);
																																																																																	BgL_auxz00_22101
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																		(BgL_expz00_21,
																																																																																			BgL_arg6066z00_7608,
																																																																																			CNST_TABLE_REF
																																																																																			(((long) 4)), BgL_arg6067z00_7609, BgL_stackz00_22, BgL_arg6965z00_12755, BgL_sitez00_24));
																																																																													}}}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_arg6068z00_7611;
																																																																														obj_t
																																																																															BgL_arg6069z00_7612;
																																																																														BgL_arg6068z00_7611
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd248349zd2_7596));
																																																																														BgL_arg6069z00_7612
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd248349zd2_7596));
																																																																														{	/* Ast/sexp.scm 552 */
																																																																															obj_t
																																																																																BgL_arg6965z00_12759;
																																																																															BgL_arg6965z00_12759
																																																																																=
																																																																																BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																(BgL_expz00_21,
																																																																																BgL_locz00_23);
																																																																															BgL_auxz00_22101
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																(BgL_expz00_21,
																																																																																	BgL_arg6068z00_7611,
																																																																																	CNST_TABLE_REF
																																																																																	(((long) 4)), BgL_arg6069z00_7612, BgL_stackz00_22, BgL_arg6965z00_12759, BgL_sitez00_24));
																																																																										}}}}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1777;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_26095;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1778;
																																																																													BgL_auxz00_22101
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_26095);
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																										}
																									else
																										{	/* Ast/sexp.scm 119 */
																											obj_t
																												BgL_carzd248412zd2_7631;
																											BgL_carzd248412zd2_7631 =
																												CAR(((obj_t)
																													BgL_expz00_21));
																											if (
																												(BgL_carzd248412zd2_7631
																													==
																													CNST_TABLE_REF(((long)
																															1))))
																												{
																													BgL_nodez00_bglt
																														BgL_auxz00_26102;
																													goto
																														BgL_tagzd2377zd2_1722;
																													BgL_auxz00_22101 =
																														((obj_t)
																														BgL_auxz00_26102);
																												}
																											else
																												{	/* Ast/sexp.scm 119 */
																													if (
																														(BgL_carzd248412zd2_7631
																															==
																															BGl_za2ifza2z00zzast_sexpz00))
																														{
																															BgL_nodez00_bglt
																																BgL_auxz00_26106;
																															goto
																																BgL_tagzd2377zd2_1722;
																															BgL_auxz00_22101 =
																																((obj_t)
																																BgL_auxz00_26106);
																														}
																													else
																														{	/* Ast/sexp.scm 119 */
																															if (
																																(CAR(
																																		((obj_t)
																																			BgL_expz00_21))
																																	==
																																	CNST_TABLE_REF
																																	(((long) 7))))
																																{
																																	BgL_nodez00_bglt
																																		BgL_auxz00_26113;
																																	goto
																																		BgL_tagzd2379zd2_1726;
																																	BgL_auxz00_22101
																																		=
																																		((obj_t)
																																		BgL_auxz00_26113);
																																}
																															else
																																{	/* Ast/sexp.scm 119 */
																																	if (
																																		(CAR(
																																				((obj_t)
																																					BgL_expz00_21))
																																			==
																																			CNST_TABLE_REF
																																			(((long)
																																					16))))
																																		{
																																			BgL_nodez00_bglt
																																				BgL_auxz00_26120;
																																			goto
																																				BgL_tagzd2380zd2_1727;
																																			BgL_auxz00_22101
																																				=
																																				((obj_t)
																																				BgL_auxz00_26120);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 119 */
																																			obj_t
																																				BgL_carzd248481zd2_7638;
																																			BgL_carzd248481zd2_7638
																																				=
																																				CAR((
																																					(obj_t)
																																					BgL_expz00_21));
																																			if (PAIRP
																																				(BgL_carzd248481zd2_7638))
																																				{	/* Ast/sexp.scm 119 */
																																					obj_t
																																						BgL_carzd248484zd2_7640;
																																					obj_t
																																						BgL_cdrzd248485zd2_7641;
																																					BgL_carzd248484zd2_7640
																																						=
																																						CAR
																																						(BgL_carzd248481zd2_7638);
																																					BgL_cdrzd248485zd2_7641
																																						=
																																						CDR
																																						(BgL_carzd248481zd2_7638);
																																					{

																																						if (
																																							(BgL_carzd248484zd2_7640
																																								==
																																								CNST_TABLE_REF
																																								(((long) 17))))
																																							{	/* Ast/sexp.scm 119 */
																																							BgL_kapzd248486zd2_7642:
																																								if (PAIRP(BgL_cdrzd248485zd2_7641))
																																									{	/* Ast/sexp.scm 119 */
																																										obj_t
																																											BgL_cdrzd248489zd2_7824;
																																										BgL_cdrzd248489zd2_7824
																																											=
																																											CDR
																																											(BgL_cdrzd248485zd2_7641);
																																										if (PAIRP(BgL_cdrzd248489zd2_7824))
																																											{	/* Ast/sexp.scm 119 */
																																												if (NULLP(CDR(BgL_cdrzd248489zd2_7824)))
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_arg6223z00_7828;
																																														obj_t
																																															BgL_arg6224z00_7829;
																																														BgL_arg6223z00_7828
																																															=
																																															CAR
																																															(BgL_cdrzd248489zd2_7824);
																																														BgL_arg6224z00_7829
																																															=
																																															CDR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_26142;
																																															{
																																																obj_t
																																																	BgL_argsz00_26144;
																																																obj_t
																																																	BgL_bodyz00_26143;
																																																BgL_bodyz00_26143
																																																	=
																																																	BgL_arg6223z00_7828;
																																																BgL_argsz00_26144
																																																	=
																																																	BgL_arg6224z00_7829;
																																																BgL_argsz00_1729
																																																	=
																																																	BgL_argsz00_26144;
																																																BgL_bodyz00_1728
																																																	=
																																																	BgL_bodyz00_26143;
																																																goto
																																																	BgL_tagzd2381zd2_1730;
																																															}
																																															BgL_auxz00_22101
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_26142);
																																														}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_cdrzd248513zd2_7830;
																																														BgL_cdrzd248513zd2_7830
																																															=
																																															CDR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{	/* Ast/sexp.scm 119 */
																																															bool_t
																																																BgL_test9989z00_26148;
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_arg6293z00_7941;
																																																BgL_arg6293z00_7941
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																BgL_test9989z00_26148
																																																	=
																																																	CBOOL
																																																	(BGl_letzd2symzf3z21zzast_letz00
																																																	(BgL_arg6293z00_7941));
																																															}
																																															if (BgL_test9989z00_26148)
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg6227z00_7833;
																																																	obj_t
																																																		BgL_arg6228z00_7834;
																																																	BgL_arg6227z00_7833
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd248513zd2_7830));
																																																	BgL_arg6228z00_7834
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd248513zd2_7830));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_26157;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_26159;
																																																			obj_t
																																																				BgL_bindingsz00_26158;
																																																			BgL_bindingsz00_26158
																																																				=
																																																				BgL_arg6227z00_7833;
																																																			BgL_exprz00_26159
																																																				=
																																																				BgL_arg6228z00_7834;
																																																			BgL_exprz00_1732
																																																				=
																																																				BgL_exprz00_26159;
																																																			BgL_bindingsz00_1731
																																																				=
																																																				BgL_bindingsz00_26158;
																																																			goto
																																																				BgL_tagzd2382zd2_1733;
																																																		}
																																																		BgL_auxz00_22101
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_26157);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	bool_t
																																																		BgL_test9990z00_26161;
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_arg6292z00_7940;
																																																		BgL_arg6292z00_7940
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_test9990z00_26161
																																																			=
																																																			CBOOL
																																																			(BGl_labelszd2symzf3z21zzast_labelsz00
																																																			(BgL_arg6292z00_7940));
																																																	}
																																																	if (BgL_test9990z00_26161)
																																																		{
																																																			BgL_letzd2funzd2_bglt
																																																				BgL_auxz00_26166;
																																																			goto
																																																				BgL_tagzd2384zd2_1735;
																																																			BgL_auxz00_22101
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_26166);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_carzd248580zd2_7837;
																																																			BgL_carzd248580zd2_7837
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd248585zd2_7838;
																																																				BgL_cdrzd248585zd2_7838
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_carzd248580zd2_7837));
																																																				if ((CAR(((obj_t) BgL_carzd248580zd2_7837)) == CNST_TABLE_REF(((long) 3))))
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg6233z00_7841;
																																																						obj_t
																																																							BgL_arg6234z00_7842;
																																																						obj_t
																																																							BgL_arg6235z00_7843;
																																																						BgL_arg6233z00_7841
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_cdrzd248585zd2_7838));
																																																						BgL_arg6234z00_7842
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_cdrzd248585zd2_7838));
																																																						BgL_arg6235z00_7843
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_26183;
																																																							{
																																																								obj_t
																																																									BgL_argsz00_26186;
																																																								obj_t
																																																									BgL_bodyz00_26185;
																																																								obj_t
																																																									BgL_varsz00_26184;
																																																								BgL_varsz00_26184
																																																									=
																																																									BgL_arg6233z00_7841;
																																																								BgL_bodyz00_26185
																																																									=
																																																									BgL_arg6234z00_7842;
																																																								BgL_argsz00_26186
																																																									=
																																																									BgL_arg6235z00_7843;
																																																								BgL_argsz00_1742
																																																									=
																																																									BgL_argsz00_26186;
																																																								BgL_bodyz00_1741
																																																									=
																																																									BgL_bodyz00_26185;
																																																								BgL_varsz00_1740
																																																									=
																																																									BgL_varsz00_26184;
																																																								goto
																																																									BgL_tagzd2386zd2_1743;
																																																							}
																																																							BgL_auxz00_22101
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_26183);
																																																						}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd248608zd2_7845;
																																																						BgL_cdrzd248608zd2_7845
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_cdrzd248614zd2_7846;
																																																							BgL_cdrzd248614zd2_7846
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_carzd248580zd2_7837));
																																																							if ((CAR(((obj_t) BgL_carzd248580zd2_7837)) == CNST_TABLE_REF(((long) 1))))
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_cdrzd248620zd2_7849;
																																																									BgL_cdrzd248620zd2_7849
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd248614zd2_7846));
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_carzd248625zd2_7850;
																																																										obj_t
																																																											BgL_cdrzd248626zd2_7851;
																																																										BgL_carzd248625zd2_7850
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_cdrzd248620zd2_7849));
																																																										BgL_cdrzd248626zd2_7851
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_cdrzd248620zd2_7849));
																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd248625zd2_7850))
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (PAIRP(BgL_cdrzd248626zd2_7851))
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_carzd248633zd2_7854;
																																																														BgL_carzd248633zd2_7854
																																																															=
																																																															CAR
																																																															(BgL_cdrzd248626zd2_7851);
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd248633zd2_7854))
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (NULLP(CDR(BgL_cdrzd248626zd2_7851)))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		bool_t
																																																																			BgL_test9997z00_26213;
																																																																		{
																																																																			obj_t
																																																																				BgL_l1450z00_7887;
																																																																			BgL_l1450z00_7887
																																																																				=
																																																																				BgL_cdrzd248608zd2_7845;
																																																																		BgL_zc3z04anonymousza36258ze3z87_7888:
																																																																			if (NULLP(BgL_l1450z00_7887))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					BgL_test9997z00_26213
																																																																						=
																																																																						(
																																																																						(bool_t)
																																																																						1);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					bool_t
																																																																						BgL_test9999z00_26216;
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						bool_t
																																																																							BgL_test10000z00_26217;
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_tmpz00_26218;
																																																																							BgL_tmpz00_26218
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_l1450z00_7887));
																																																																							BgL_test10000z00_26217
																																																																								=
																																																																								PAIRP
																																																																								(BgL_tmpz00_26218);
																																																																						}
																																																																						if (BgL_test10000z00_26217)
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								BgL_test9999z00_26216
																																																																									=
																																																																									(
																																																																									(bool_t)
																																																																									0);
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								BgL_test9999z00_26216
																																																																									=
																																																																									(
																																																																									(bool_t)
																																																																									1);
																																																																							}
																																																																					}
																																																																					if (BgL_test9999z00_26216)
																																																																						{
																																																																							obj_t
																																																																								BgL_l1450z00_26222;
																																																																							BgL_l1450z00_26222
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_l1450z00_7887));
																																																																							BgL_l1450z00_7887
																																																																								=
																																																																								BgL_l1450z00_26222;
																																																																							goto
																																																																								BgL_zc3z04anonymousza36258ze3z87_7888;
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							BgL_test9997z00_26213
																																																																								=
																																																																								(
																																																																								(bool_t)
																																																																								0);
																																																																						}
																																																																				}
																																																																		}
																																																																		if (BgL_test9997z00_26213)
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_arg6248z00_7870;
																																																																				BgL_arg6248z00_7870
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd248614zd2_7846));
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_26227;
																																																																					{
																																																																						obj_t
																																																																							BgL_argsz00_26231;
																																																																						obj_t
																																																																							BgL_proc2z00_26230;
																																																																						obj_t
																																																																							BgL_proc1z00_26229;
																																																																						obj_t
																																																																							BgL_testz00_26228;
																																																																						BgL_testz00_26228
																																																																							=
																																																																							BgL_arg6248z00_7870;
																																																																						BgL_proc1z00_26229
																																																																							=
																																																																							BgL_carzd248625zd2_7850;
																																																																						BgL_proc2z00_26230
																																																																							=
																																																																							BgL_carzd248633zd2_7854;
																																																																						BgL_argsz00_26231
																																																																							=
																																																																							BgL_cdrzd248608zd2_7845;
																																																																						BgL_argsz00_1747
																																																																							=
																																																																							BgL_argsz00_26231;
																																																																						BgL_proc2z00_1746
																																																																							=
																																																																							BgL_proc2z00_26230;
																																																																						BgL_proc1z00_1745
																																																																							=
																																																																							BgL_proc1z00_26229;
																																																																						BgL_testz00_1744
																																																																							=
																																																																							BgL_testz00_26228;
																																																																						goto
																																																																							BgL_tagzd2387zd2_1748;
																																																																					}
																																																																					BgL_auxz00_22101
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_26227);
																																																																				}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd248657zd2_7871;
																																																																				BgL_cdrzd248657zd2_7871
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd248664zd2_7872;
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_pairz00_12803;
																																																																						BgL_pairz00_12803
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						BgL_cdrzd248664zd2_7872
																																																																							=
																																																																							CDR
																																																																							(BgL_pairz00_12803);
																																																																					}
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd248671zd2_7873;
																																																																						BgL_cdrzd248671zd2_7873
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd248664zd2_7872));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd248677zd2_7874;
																																																																							BgL_carzd248677zd2_7874
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd248671zd2_7873));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd248677zd2_7874))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd248684zd2_7876;
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_pairz00_12807;
																																																																										BgL_pairz00_12807
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd248671zd2_7873));
																																																																										BgL_carzd248684zd2_7876
																																																																											=
																																																																											CAR
																																																																											(BgL_pairz00_12807);
																																																																									}
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd248684zd2_7876))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd248657zd2_7871))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_arg6252z00_7879;
																																																																													BgL_arg6252z00_7879
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd248664zd2_7872));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_26253;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_26257;
																																																																															obj_t
																																																																																BgL_proc2z00_26256;
																																																																															obj_t
																																																																																BgL_proc1z00_26255;
																																																																															obj_t
																																																																																BgL_testz00_26254;
																																																																															BgL_testz00_26254
																																																																																=
																																																																																BgL_arg6252z00_7879;
																																																																															BgL_proc1z00_26255
																																																																																=
																																																																																BgL_carzd248677zd2_7874;
																																																																															BgL_proc2z00_26256
																																																																																=
																																																																																BgL_carzd248684zd2_7876;
																																																																															BgL_argsz00_26257
																																																																																=
																																																																																BgL_cdrzd248657zd2_7871;
																																																																															BgL_argsz00_1752
																																																																																=
																																																																																BgL_argsz00_26257;
																																																																															BgL_proc2z00_1751
																																																																																=
																																																																																BgL_proc2z00_26256;
																																																																															BgL_proc1z00_1750
																																																																																=
																																																																																BgL_proc1z00_26255;
																																																																															BgL_testz00_1749
																																																																																=
																																																																																BgL_testz00_26254;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1753;
																																																																														}
																																																																														BgL_auxz00_22101
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_26253);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1777;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_26261;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1778;
																																																																															BgL_auxz00_22101
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_26261);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1777;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_26265;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1778;
																																																																													BgL_auxz00_22101
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_26265);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1777;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_26269;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1778;
																																																																											BgL_auxz00_22101
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_26269);
																																																																										}
																																																																								}
																																																																						}
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1777;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_26273;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1778;
																																																																				BgL_auxz00_22101
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_26273);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd248960zd2_7898;
																																																																BgL_cdrzd248960zd2_7898
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd248966zd2_7899;
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_pairz00_12811;
																																																																		BgL_pairz00_12811
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		BgL_cdrzd248966zd2_7899
																																																																			=
																																																																			CDR
																																																																			(BgL_pairz00_12811);
																																																																	}
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd248972zd2_7900;
																																																																		BgL_cdrzd248972zd2_7900
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd248966zd2_7899));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_carzd248977zd2_7901;
																																																																			obj_t
																																																																				BgL_cdrzd248978zd2_7902;
																																																																			BgL_carzd248977zd2_7901
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd248972zd2_7900));
																																																																			BgL_cdrzd248978zd2_7902
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd248972zd2_7900));
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd248977zd2_7901))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_carzd248983zd2_7904;
																																																																					BgL_carzd248983zd2_7904
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd248978zd2_7902));
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd248983zd2_7904))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (NULLP(CDR(((obj_t) BgL_cdrzd248978zd2_7902))))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd248960zd2_7898))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_arg6267z00_7909;
																																																																											BgL_arg6267z00_7909
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd248966zd2_7899));
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_26300;
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_26304;
																																																																													obj_t
																																																																														BgL_proc2z00_26303;
																																																																													obj_t
																																																																														BgL_proc1z00_26302;
																																																																													obj_t
																																																																														BgL_testz00_26301;
																																																																													BgL_testz00_26301
																																																																														=
																																																																														BgL_arg6267z00_7909;
																																																																													BgL_proc1z00_26302
																																																																														=
																																																																														BgL_carzd248977zd2_7901;
																																																																													BgL_proc2z00_26303
																																																																														=
																																																																														BgL_carzd248983zd2_7904;
																																																																													BgL_argsz00_26304
																																																																														=
																																																																														BgL_cdrzd248960zd2_7898;
																																																																													BgL_argsz00_1752
																																																																														=
																																																																														BgL_argsz00_26304;
																																																																													BgL_proc2z00_1751
																																																																														=
																																																																														BgL_proc2z00_26303;
																																																																													BgL_proc1z00_1750
																																																																														=
																																																																														BgL_proc1z00_26302;
																																																																													BgL_testz00_1749
																																																																														=
																																																																														BgL_testz00_26301;
																																																																													goto
																																																																														BgL_tagzd2388zd2_1753;
																																																																												}
																																																																												BgL_auxz00_22101
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_26300);
																																																																											}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1777;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_26308;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1778;
																																																																													BgL_auxz00_22101
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_26308);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1777;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_26312;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1778;
																																																																											BgL_auxz00_22101
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_26312);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1777;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_26316;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1778;
																																																																									BgL_auxz00_22101
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_26316);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1777;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_26320;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1778;
																																																																							BgL_auxz00_22101
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_26320);
																																																																						}
																																																																				}
																																																																		}
																																																																	}
																																																																}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 119 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1777;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_26324;
																																																																goto
																																																																	BgL_tagzd2404zd2_1778;
																																																																BgL_auxz00_22101
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_26324);
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd249316zd2_7917;
																																																												BgL_cdrzd249316zd2_7917
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd249323zd2_7918;
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_pairz00_12821;
																																																														BgL_pairz00_12821
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														BgL_cdrzd249323zd2_7918
																																																															=
																																																															CDR
																																																															(BgL_pairz00_12821);
																																																													}
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd249330zd2_7919;
																																																														BgL_cdrzd249330zd2_7919
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd249323zd2_7918));
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_carzd249336zd2_7920;
																																																															obj_t
																																																																BgL_cdrzd249337zd2_7921;
																																																															BgL_carzd249336zd2_7920
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd249330zd2_7919));
																																																															BgL_cdrzd249337zd2_7921
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd249330zd2_7919));
																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd249336zd2_7920))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (PAIRP(BgL_cdrzd249337zd2_7921))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_carzd249344zd2_7924;
																																																																			BgL_carzd249344zd2_7924
																																																																				=
																																																																				CAR
																																																																				(BgL_cdrzd249337zd2_7921);
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd249344zd2_7924))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (NULLP(CDR(BgL_cdrzd249337zd2_7921)))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd249316zd2_7917))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_arg6281z00_7929;
																																																																									BgL_arg6281z00_7929
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd249323zd2_7918));
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_26351;
																																																																										{
																																																																											obj_t
																																																																												BgL_argsz00_26355;
																																																																											obj_t
																																																																												BgL_proc2z00_26354;
																																																																											obj_t
																																																																												BgL_proc1z00_26353;
																																																																											obj_t
																																																																												BgL_testz00_26352;
																																																																											BgL_testz00_26352
																																																																												=
																																																																												BgL_arg6281z00_7929;
																																																																											BgL_proc1z00_26353
																																																																												=
																																																																												BgL_carzd249336zd2_7920;
																																																																											BgL_proc2z00_26354
																																																																												=
																																																																												BgL_carzd249344zd2_7924;
																																																																											BgL_argsz00_26355
																																																																												=
																																																																												BgL_cdrzd249316zd2_7917;
																																																																											BgL_argsz00_1752
																																																																												=
																																																																												BgL_argsz00_26355;
																																																																											BgL_proc2z00_1751
																																																																												=
																																																																												BgL_proc2z00_26354;
																																																																											BgL_proc1z00_1750
																																																																												=
																																																																												BgL_proc1z00_26353;
																																																																											BgL_testz00_1749
																																																																												=
																																																																												BgL_testz00_26352;
																																																																											goto
																																																																												BgL_tagzd2388zd2_1753;
																																																																										}
																																																																										BgL_auxz00_22101
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_26351);
																																																																									}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1777;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_26359;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1778;
																																																																											BgL_auxz00_22101
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_26359);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1777;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_26363;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1778;
																																																																									BgL_auxz00_22101
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_26363);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1777;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_26367;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1778;
																																																																							BgL_auxz00_22101
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_26367);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1777;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_26371;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1778;
																																																																					BgL_auxz00_22101
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_26371);
																																																																				}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1777;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_26375;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1778;
																																																																			BgL_auxz00_22101
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_26375);
																																																																		}
																																																																}
																																																														}
																																																													}
																																																												}
																																																											}
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																										{	/* Ast/sexp.scm 119 */
																																																											goto
																																																												BgL_tagzd2403zd2_1777;
																																																										}
																																																									else
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_26379;
																																																											goto
																																																												BgL_tagzd2404zd2_1778;
																																																											BgL_auxz00_22101
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_26379);
																																																										}
																																																								}
																																																						}
																																																					}
																																																			}
																																																		}
																																																}
																																														}
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												obj_t
																																													BgL_cdrzd249737zd2_7943;
																																												BgL_cdrzd249737zd2_7943
																																													=
																																													CDR
																																													(
																																													((obj_t) BgL_expz00_21));
																																												{	/* Ast/sexp.scm 119 */
																																													bool_t
																																														BgL_test10028z00_26383;
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_arg6309z00_7960;
																																														BgL_arg6309z00_7960
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														BgL_test10028z00_26383
																																															=
																																															CBOOL
																																															(BGl_letzd2symzf3z21zzast_letz00
																																															(BgL_arg6309z00_7960));
																																													}
																																													if (BgL_test10028z00_26383)
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg6297z00_7946;
																																															obj_t
																																																BgL_arg6298z00_7947;
																																															BgL_arg6297z00_7946
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd249737zd2_7943));
																																															BgL_arg6298z00_7947
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd249737zd2_7943));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_26392;
																																																{
																																																	obj_t
																																																		BgL_exprz00_26394;
																																																	obj_t
																																																		BgL_bindingsz00_26393;
																																																	BgL_bindingsz00_26393
																																																		=
																																																		BgL_arg6297z00_7946;
																																																	BgL_exprz00_26394
																																																		=
																																																		BgL_arg6298z00_7947;
																																																	BgL_exprz00_1732
																																																		=
																																																		BgL_exprz00_26394;
																																																	BgL_bindingsz00_1731
																																																		=
																																																		BgL_bindingsz00_26393;
																																																	goto
																																																		BgL_tagzd2382zd2_1733;
																																																}
																																																BgL_auxz00_22101
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_26392);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															bool_t
																																																BgL_test10029z00_26396;
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_arg6308z00_7959;
																																																BgL_arg6308z00_7959
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																BgL_test10029z00_26396
																																																	=
																																																	CBOOL
																																																	(BGl_labelszd2symzf3z21zzast_labelsz00
																																																	(BgL_arg6308z00_7959));
																																															}
																																															if (BgL_test10029z00_26396)
																																																{
																																																	BgL_letzd2funzd2_bglt
																																																		BgL_auxz00_26401;
																																																	goto
																																																		BgL_tagzd2384zd2_1735;
																																																	BgL_auxz00_22101
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_26401);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_carzd249803zd2_7950;
																																																	BgL_carzd249803zd2_7950
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_cdrzd249808zd2_7951;
																																																		BgL_cdrzd249808zd2_7951
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_carzd249803zd2_7950));
																																																		if ((CAR(((obj_t) BgL_carzd249803zd2_7950)) == CNST_TABLE_REF(((long) 3))))
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg6303z00_7954;
																																																				obj_t
																																																					BgL_arg6304z00_7955;
																																																				obj_t
																																																					BgL_arg6305z00_7956;
																																																				BgL_arg6303z00_7954
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_cdrzd249808zd2_7951));
																																																				BgL_arg6304z00_7955
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_cdrzd249808zd2_7951));
																																																				BgL_arg6305z00_7956
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_26418;
																																																					{
																																																						obj_t
																																																							BgL_argsz00_26421;
																																																						obj_t
																																																							BgL_bodyz00_26420;
																																																						obj_t
																																																							BgL_varsz00_26419;
																																																						BgL_varsz00_26419
																																																							=
																																																							BgL_arg6303z00_7954;
																																																						BgL_bodyz00_26420
																																																							=
																																																							BgL_arg6304z00_7955;
																																																						BgL_argsz00_26421
																																																							=
																																																							BgL_arg6305z00_7956;
																																																						BgL_argsz00_1742
																																																							=
																																																							BgL_argsz00_26421;
																																																						BgL_bodyz00_1741
																																																							=
																																																							BgL_bodyz00_26420;
																																																						BgL_varsz00_1740
																																																							=
																																																							BgL_varsz00_26419;
																																																						goto
																																																							BgL_tagzd2386zd2_1743;
																																																					}
																																																					BgL_auxz00_22101
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_26418);
																																																				}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																					{	/* Ast/sexp.scm 119 */
																																																						goto
																																																							BgL_tagzd2403zd2_1777;
																																																					}
																																																				else
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_26425;
																																																						goto
																																																							BgL_tagzd2404zd2_1778;
																																																						BgL_auxz00_22101
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_26425);
																																																					}
																																																			}
																																																	}
																																																}
																																														}
																																												}
																																											}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 119 */
																																										obj_t
																																											BgL_cdrzd249919zd2_7961;
																																										BgL_cdrzd249919zd2_7961
																																											=
																																											CDR
																																											(
																																											((obj_t) BgL_expz00_21));
																																										{	/* Ast/sexp.scm 119 */
																																											bool_t
																																												BgL_test10032z00_26429;
																																											{	/* Ast/sexp.scm 119 */
																																												obj_t
																																													BgL_arg6318z00_7970;
																																												BgL_arg6318z00_7970
																																													=
																																													CAR
																																													(
																																													((obj_t) BgL_expz00_21));
																																												BgL_test10032z00_26429
																																													=
																																													CBOOL
																																													(BGl_letzd2symzf3z21zzast_letz00
																																													(BgL_arg6318z00_7970));
																																											}
																																											if (BgL_test10032z00_26429)
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_arg6312z00_7964;
																																													obj_t
																																														BgL_arg6313z00_7965;
																																													BgL_arg6312z00_7964
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_cdrzd249919zd2_7961));
																																													BgL_arg6313z00_7965
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_cdrzd249919zd2_7961));
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_26438;
																																														{
																																															obj_t
																																																BgL_exprz00_26440;
																																															obj_t
																																																BgL_bindingsz00_26439;
																																															BgL_bindingsz00_26439
																																																=
																																																BgL_arg6312z00_7964;
																																															BgL_exprz00_26440
																																																=
																																																BgL_arg6313z00_7965;
																																															BgL_exprz00_1732
																																																=
																																																BgL_exprz00_26440;
																																															BgL_bindingsz00_1731
																																																=
																																																BgL_bindingsz00_26439;
																																															goto
																																																BgL_tagzd2382zd2_1733;
																																														}
																																														BgL_auxz00_22101
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_26438);
																																													}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													bool_t
																																														BgL_test10033z00_26442;
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_arg6317z00_7969;
																																														BgL_arg6317z00_7969
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														BgL_test10033z00_26442
																																															=
																																															CBOOL
																																															(BGl_labelszd2symzf3z21zzast_labelsz00
																																															(BgL_arg6317z00_7969));
																																													}
																																													if (BgL_test10033z00_26442)
																																														{
																																															BgL_letzd2funzd2_bglt
																																																BgL_auxz00_26447;
																																															goto
																																																BgL_tagzd2384zd2_1735;
																																															BgL_auxz00_22101
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_26447);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																{	/* Ast/sexp.scm 119 */
																																																	goto
																																																		BgL_tagzd2403zd2_1777;
																																																}
																																															else
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_26451;
																																																	goto
																																																		BgL_tagzd2404zd2_1778;
																																																	BgL_auxz00_22101
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_26451);
																																																}
																																														}
																																												}
																																										}
																																									}
																																							}
																																						else
																																							{	/* Ast/sexp.scm 119 */
																																								if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd248484zd2_7640)))
																																									{	/* Ast/sexp.scm 119 */
																																										goto
																																											BgL_kapzd248486zd2_7642;
																																									}
																																								else
																																									{	/* Ast/sexp.scm 119 */
																																										if ((BgL_carzd248484zd2_7640 == CNST_TABLE_REF(((long) 18))))
																																											{	/* Ast/sexp.scm 119 */
																																												goto
																																													BgL_kapzd248486zd2_7642;
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												if ((BgL_carzd248484zd2_7640 == CNST_TABLE_REF(((long) 19))))
																																													{	/* Ast/sexp.scm 119 */
																																														goto
																																															BgL_kapzd248486zd2_7642;
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd248484zd2_7640)))
																																															{	/* Ast/sexp.scm 119 */
																																																goto
																																																	BgL_kapzd248486zd2_7642;
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_cdrzd250091zd2_7648;
																																																BgL_cdrzd250091zd2_7648
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 119 */
																																																	bool_t
																																																		BgL_test10039z00_26467;
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_arg6218z00_7822;
																																																		BgL_arg6218z00_7822
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_test10039z00_26467
																																																			=
																																																			CBOOL
																																																			(BGl_letzd2symzf3z21zzast_letz00
																																																			(BgL_arg6218z00_7822));
																																																	}
																																																	if (BgL_test10039z00_26467)
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg6102z00_7651;
																																																			obj_t
																																																				BgL_arg6103z00_7652;
																																																			BgL_arg6102z00_7651
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd250091zd2_7648));
																																																			BgL_arg6103z00_7652
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd250091zd2_7648));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_26476;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_26478;
																																																					obj_t
																																																						BgL_bindingsz00_26477;
																																																					BgL_bindingsz00_26477
																																																						=
																																																						BgL_arg6102z00_7651;
																																																					BgL_exprz00_26478
																																																						=
																																																						BgL_arg6103z00_7652;
																																																					BgL_exprz00_1732
																																																						=
																																																						BgL_exprz00_26478;
																																																					BgL_bindingsz00_1731
																																																						=
																																																						BgL_bindingsz00_26477;
																																																					goto
																																																						BgL_tagzd2382zd2_1733;
																																																				}
																																																				BgL_auxz00_22101
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_26476);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			bool_t
																																																				BgL_test10040z00_26480;
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg6217z00_7821;
																																																				BgL_arg6217z00_7821
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test10040z00_26480
																																																					=
																																																					CBOOL
																																																					(BGl_labelszd2symzf3z21zzast_labelsz00
																																																					(BgL_arg6217z00_7821));
																																																			}
																																																			if (BgL_test10040z00_26480)
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_26485;
																																																					goto
																																																						BgL_tagzd2384zd2_1735;
																																																					BgL_auxz00_22101
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_26485);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_carzd250144zd2_7655;
																																																					obj_t
																																																						BgL_cdrzd250145zd2_7656;
																																																					BgL_carzd250144zd2_7655
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					BgL_cdrzd250145zd2_7656
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd250149zd2_7657;
																																																						BgL_cdrzd250149zd2_7657
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_carzd250144zd2_7655));
																																																						if ((CAR(((obj_t) BgL_carzd250144zd2_7655)) == CNST_TABLE_REF(((long) 3))))
																																																							{	/* Ast/sexp.scm 119 */
																																																								if (PAIRP(BgL_cdrzd250149zd2_7657))
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_carzd250152zd2_7661;
																																																										obj_t
																																																											BgL_cdrzd250153zd2_7662;
																																																										BgL_carzd250152zd2_7661
																																																											=
																																																											CAR
																																																											(BgL_cdrzd250149zd2_7657);
																																																										BgL_cdrzd250153zd2_7662
																																																											=
																																																											CDR
																																																											(BgL_cdrzd250149zd2_7657);
																																																										if (PAIRP(BgL_carzd250152zd2_7661))
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (NULLP(CDR(BgL_carzd250152zd2_7661)))
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (PAIRP(BgL_cdrzd250153zd2_7662))
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_carzd250159zd2_7667;
																																																																BgL_carzd250159zd2_7667
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd250153zd2_7662);
																																																																if (PAIRP(BgL_carzd250159zd2_7667))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_castzd2sexpzf3z21zzast_privatez00(BgL_carzd250159zd2_7667))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (NULLP(CDR(BgL_cdrzd250153zd2_7662)))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_carzd250166zd2_7672;
																																																																						BgL_carzd250166zd2_7672
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd250145zd2_7656));
																																																																						if (PAIRP(BgL_carzd250166zd2_7672))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd250191zd2_7674;
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_pairz00_12869;
																																																																									BgL_pairz00_12869
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									BgL_cdrzd250191zd2_7674
																																																																										=
																																																																										CDR
																																																																										(BgL_pairz00_12869);
																																																																								}
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_arg6118z00_7675;
																																																																									obj_t
																																																																										BgL_arg6119z00_7676;
																																																																									obj_t
																																																																										BgL_arg6120z00_7677;
																																																																									BgL_arg6118z00_7675
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd250191zd2_7674));
																																																																									BgL_arg6119z00_7676
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd250191zd2_7674));
																																																																									BgL_arg6120z00_7677
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_26530;
																																																																										{
																																																																											obj_t
																																																																												BgL_argsz00_26533;
																																																																											obj_t
																																																																												BgL_bodyz00_26532;
																																																																											obj_t
																																																																												BgL_varsz00_26531;
																																																																											BgL_varsz00_26531
																																																																												=
																																																																												BgL_arg6118z00_7675;
																																																																											BgL_bodyz00_26532
																																																																												=
																																																																												BgL_arg6119z00_7676;
																																																																											BgL_argsz00_26533
																																																																												=
																																																																												BgL_arg6120z00_7677;
																																																																											BgL_argsz00_1742
																																																																												=
																																																																												BgL_argsz00_26533;
																																																																											BgL_bodyz00_1741
																																																																												=
																																																																												BgL_bodyz00_26532;
																																																																											BgL_varsz00_1740
																																																																												=
																																																																												BgL_varsz00_26531;
																																																																											goto
																																																																												BgL_tagzd2386zd2_1743;
																																																																										}
																																																																										BgL_auxz00_22101
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_26530);
																																																																									}
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (NULLP(CDR(((obj_t) BgL_cdrzd250145zd2_7656))))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_arg6124z00_7681;
																																																																										BgL_arg6124z00_7681
																																																																											=
																																																																											CAR
																																																																											(BgL_carzd250152zd2_7661);
																																																																										{
																																																																											BgL_castz00_bglt
																																																																												BgL_auxz00_26540;
																																																																											{
																																																																												obj_t
																																																																													BgL_argz00_26543;
																																																																												obj_t
																																																																													BgL_bodyz00_26542;
																																																																												obj_t
																																																																													BgL_varz00_26541;
																																																																												BgL_varz00_26541
																																																																													=
																																																																													BgL_arg6124z00_7681;
																																																																												BgL_bodyz00_26542
																																																																													=
																																																																													BgL_carzd250159zd2_7667;
																																																																												BgL_argz00_26543
																																																																													=
																																																																													BgL_carzd250166zd2_7672;
																																																																												BgL_argz00_1738
																																																																													=
																																																																													BgL_argz00_26543;
																																																																												BgL_bodyz00_1737
																																																																													=
																																																																													BgL_bodyz00_26542;
																																																																												BgL_varz00_1736
																																																																													=
																																																																													BgL_varz00_26541;
																																																																												goto
																																																																													BgL_tagzd2385zd2_1739;
																																																																											}
																																																																											BgL_auxz00_22101
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_26540);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd250219zd2_7682;
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_pairz00_12877;
																																																																											BgL_pairz00_12877
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											BgL_cdrzd250219zd2_7682
																																																																												=
																																																																												CDR
																																																																												(BgL_pairz00_12877);
																																																																										}
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_arg6125z00_7683;
																																																																											obj_t
																																																																												BgL_arg6126z00_7684;
																																																																											obj_t
																																																																												BgL_arg6127z00_7685;
																																																																											BgL_arg6125z00_7683
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd250219zd2_7682));
																																																																											BgL_arg6126z00_7684
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd250219zd2_7682));
																																																																											BgL_arg6127z00_7685
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_26554;
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_26557;
																																																																													obj_t
																																																																														BgL_bodyz00_26556;
																																																																													obj_t
																																																																														BgL_varsz00_26555;
																																																																													BgL_varsz00_26555
																																																																														=
																																																																														BgL_arg6125z00_7683;
																																																																													BgL_bodyz00_26556
																																																																														=
																																																																														BgL_arg6126z00_7684;
																																																																													BgL_argsz00_26557
																																																																														=
																																																																														BgL_arg6127z00_7685;
																																																																													BgL_argsz00_1742
																																																																														=
																																																																														BgL_argsz00_26557;
																																																																													BgL_bodyz00_1741
																																																																														=
																																																																														BgL_bodyz00_26556;
																																																																													BgL_varsz00_1740
																																																																														=
																																																																														BgL_varsz00_26555;
																																																																													goto
																																																																														BgL_tagzd2386zd2_1743;
																																																																												}
																																																																												BgL_auxz00_22101
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_26554);
																																																																											}
																																																																										}
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd250245zd2_7688;
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_pairz00_12882;
																																																																							BgL_pairz00_12882
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							BgL_cdrzd250245zd2_7688
																																																																								=
																																																																								CDR
																																																																								(BgL_pairz00_12882);
																																																																						}
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_arg6130z00_7689;
																																																																							obj_t
																																																																								BgL_arg6131z00_7690;
																																																																							obj_t
																																																																								BgL_arg6132z00_7691;
																																																																							BgL_arg6130z00_7689
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd250245zd2_7688));
																																																																							BgL_arg6131z00_7690
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd250245zd2_7688));
																																																																							BgL_arg6132z00_7691
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_26568;
																																																																								{
																																																																									obj_t
																																																																										BgL_argsz00_26571;
																																																																									obj_t
																																																																										BgL_bodyz00_26570;
																																																																									obj_t
																																																																										BgL_varsz00_26569;
																																																																									BgL_varsz00_26569
																																																																										=
																																																																										BgL_arg6130z00_7689;
																																																																									BgL_bodyz00_26570
																																																																										=
																																																																										BgL_arg6131z00_7690;
																																																																									BgL_argsz00_26571
																																																																										=
																																																																										BgL_arg6132z00_7691;
																																																																									BgL_argsz00_1742
																																																																										=
																																																																										BgL_argsz00_26571;
																																																																									BgL_bodyz00_1741
																																																																										=
																																																																										BgL_bodyz00_26570;
																																																																									BgL_varsz00_1740
																																																																										=
																																																																										BgL_varsz00_26569;
																																																																									goto
																																																																										BgL_tagzd2386zd2_1743;
																																																																								}
																																																																								BgL_auxz00_22101
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_26568);
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd250271zd2_7694;
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_pairz00_12887;
																																																																					BgL_pairz00_12887
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					BgL_cdrzd250271zd2_7694
																																																																						=
																																																																						CDR
																																																																						(BgL_pairz00_12887);
																																																																				}
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_arg6135z00_7695;
																																																																					obj_t
																																																																						BgL_arg6136z00_7696;
																																																																					obj_t
																																																																						BgL_arg6137z00_7697;
																																																																					BgL_arg6135z00_7695
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd250271zd2_7694));
																																																																					BgL_arg6136z00_7696
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd250271zd2_7694));
																																																																					BgL_arg6137z00_7697
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_26582;
																																																																						{
																																																																							obj_t
																																																																								BgL_argsz00_26585;
																																																																							obj_t
																																																																								BgL_bodyz00_26584;
																																																																							obj_t
																																																																								BgL_varsz00_26583;
																																																																							BgL_varsz00_26583
																																																																								=
																																																																								BgL_arg6135z00_7695;
																																																																							BgL_bodyz00_26584
																																																																								=
																																																																								BgL_arg6136z00_7696;
																																																																							BgL_argsz00_26585
																																																																								=
																																																																								BgL_arg6137z00_7697;
																																																																							BgL_argsz00_1742
																																																																								=
																																																																								BgL_argsz00_26585;
																																																																							BgL_bodyz00_1741
																																																																								=
																																																																								BgL_bodyz00_26584;
																																																																							BgL_varsz00_1740
																																																																								=
																																																																								BgL_varsz00_26583;
																																																																							goto
																																																																								BgL_tagzd2386zd2_1743;
																																																																						}
																																																																						BgL_auxz00_22101
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_26582);
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd250297zd2_7699;
																																																																		BgL_cdrzd250297zd2_7699
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_carzd250144zd2_7655));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_arg6139z00_7700;
																																																																			obj_t
																																																																				BgL_arg6140z00_7701;
																																																																			obj_t
																																																																				BgL_arg6141z00_7702;
																																																																			BgL_arg6139z00_7700
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd250297zd2_7699));
																																																																			BgL_arg6140z00_7701
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd250297zd2_7699));
																																																																			BgL_arg6141z00_7702
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_expz00_21));
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_26595;
																																																																				{
																																																																					obj_t
																																																																						BgL_argsz00_26598;
																																																																					obj_t
																																																																						BgL_bodyz00_26597;
																																																																					obj_t
																																																																						BgL_varsz00_26596;
																																																																					BgL_varsz00_26596
																																																																						=
																																																																						BgL_arg6139z00_7700;
																																																																					BgL_bodyz00_26597
																																																																						=
																																																																						BgL_arg6140z00_7701;
																																																																					BgL_argsz00_26598
																																																																						=
																																																																						BgL_arg6141z00_7702;
																																																																					BgL_argsz00_1742
																																																																						=
																																																																						BgL_argsz00_26598;
																																																																					BgL_bodyz00_1741
																																																																						=
																																																																						BgL_bodyz00_26597;
																																																																					BgL_varsz00_1740
																																																																						=
																																																																						BgL_varsz00_26596;
																																																																					goto
																																																																						BgL_tagzd2386zd2_1743;
																																																																				}
																																																																				BgL_auxz00_22101
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_26595);
																																																																			}
																																																																		}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd250323zd2_7704;
																																																																BgL_cdrzd250323zd2_7704
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_carzd250144zd2_7655));
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_arg6143z00_7705;
																																																																	obj_t
																																																																		BgL_arg6144z00_7706;
																																																																	obj_t
																																																																		BgL_arg6145z00_7707;
																																																																	BgL_arg6143z00_7705
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd250323zd2_7704));
																																																																	BgL_arg6144z00_7706
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd250323zd2_7704));
																																																																	BgL_arg6145z00_7707
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_26608;
																																																																		{
																																																																			obj_t
																																																																				BgL_argsz00_26611;
																																																																			obj_t
																																																																				BgL_bodyz00_26610;
																																																																			obj_t
																																																																				BgL_varsz00_26609;
																																																																			BgL_varsz00_26609
																																																																				=
																																																																				BgL_arg6143z00_7705;
																																																																			BgL_bodyz00_26610
																																																																				=
																																																																				BgL_arg6144z00_7706;
																																																																			BgL_argsz00_26611
																																																																				=
																																																																				BgL_arg6145z00_7707;
																																																																			BgL_argsz00_1742
																																																																				=
																																																																				BgL_argsz00_26611;
																																																																			BgL_bodyz00_1741
																																																																				=
																																																																				BgL_bodyz00_26610;
																																																																			BgL_varsz00_1740
																																																																				=
																																																																				BgL_varsz00_26609;
																																																																			goto
																																																																				BgL_tagzd2386zd2_1743;
																																																																		}
																																																																		BgL_auxz00_22101
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_26608);
																																																																	}
																																																																}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd250349zd2_7709;
																																																														BgL_cdrzd250349zd2_7709
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_carzd250144zd2_7655));
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_arg6147z00_7710;
																																																															obj_t
																																																																BgL_arg6148z00_7711;
																																																															obj_t
																																																																BgL_arg6149z00_7712;
																																																															BgL_arg6147z00_7710
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd250349zd2_7709));
																																																															BgL_arg6148z00_7711
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd250349zd2_7709));
																																																															BgL_arg6149z00_7712
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_26621;
																																																																{
																																																																	obj_t
																																																																		BgL_argsz00_26624;
																																																																	obj_t
																																																																		BgL_bodyz00_26623;
																																																																	obj_t
																																																																		BgL_varsz00_26622;
																																																																	BgL_varsz00_26622
																																																																		=
																																																																		BgL_arg6147z00_7710;
																																																																	BgL_bodyz00_26623
																																																																		=
																																																																		BgL_arg6148z00_7711;
																																																																	BgL_argsz00_26624
																																																																		=
																																																																		BgL_arg6149z00_7712;
																																																																	BgL_argsz00_1742
																																																																		=
																																																																		BgL_argsz00_26624;
																																																																	BgL_bodyz00_1741
																																																																		=
																																																																		BgL_bodyz00_26623;
																																																																	BgL_varsz00_1740
																																																																		=
																																																																		BgL_varsz00_26622;
																																																																	goto
																																																																		BgL_tagzd2386zd2_1743;
																																																																}
																																																																BgL_auxz00_22101
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_26621);
																																																															}
																																																														}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd250375zd2_7715;
																																																												BgL_cdrzd250375zd2_7715
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_carzd250144zd2_7655));
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_arg6152z00_7716;
																																																													obj_t
																																																														BgL_arg6153z00_7717;
																																																													obj_t
																																																														BgL_arg6154z00_7718;
																																																													BgL_arg6152z00_7716
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_cdrzd250375zd2_7715));
																																																													BgL_arg6153z00_7717
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd250375zd2_7715));
																																																													BgL_arg6154z00_7718
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_26634;
																																																														{
																																																															obj_t
																																																																BgL_argsz00_26637;
																																																															obj_t
																																																																BgL_bodyz00_26636;
																																																															obj_t
																																																																BgL_varsz00_26635;
																																																															BgL_varsz00_26635
																																																																=
																																																																BgL_arg6152z00_7716;
																																																															BgL_bodyz00_26636
																																																																=
																																																																BgL_arg6153z00_7717;
																																																															BgL_argsz00_26637
																																																																=
																																																																BgL_arg6154z00_7718;
																																																															BgL_argsz00_1742
																																																																=
																																																																BgL_argsz00_26637;
																																																															BgL_bodyz00_1741
																																																																=
																																																																BgL_bodyz00_26636;
																																																															BgL_varsz00_1740
																																																																=
																																																																BgL_varsz00_26635;
																																																															goto
																																																																BgL_tagzd2386zd2_1743;
																																																														}
																																																														BgL_auxz00_22101
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_26634);
																																																													}
																																																												}
																																																											}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 119 */
																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																											{	/* Ast/sexp.scm 119 */
																																																												goto
																																																													BgL_tagzd2403zd2_1777;
																																																											}
																																																										else
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_26641;
																																																												goto
																																																													BgL_tagzd2404zd2_1778;
																																																												BgL_auxz00_22101
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_26641);
																																																											}
																																																									}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd250513zd2_7723;
																																																								BgL_cdrzd250513zd2_7723
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_carzd250144zd2_7655));
																																																								if ((CAR(((obj_t) BgL_carzd250144zd2_7655)) == CNST_TABLE_REF(((long) 1))))
																																																									{	/* Ast/sexp.scm 119 */
																																																										if (PAIRP(BgL_cdrzd250513zd2_7723))
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd250518zd2_7727;
																																																												BgL_cdrzd250518zd2_7727
																																																													=
																																																													CDR
																																																													(BgL_cdrzd250513zd2_7723);
																																																												if (PAIRP(BgL_cdrzd250518zd2_7727))
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_carzd250522zd2_7729;
																																																														obj_t
																																																															BgL_cdrzd250523zd2_7730;
																																																														BgL_carzd250522zd2_7729
																																																															=
																																																															CAR
																																																															(BgL_cdrzd250518zd2_7727);
																																																														BgL_cdrzd250523zd2_7730
																																																															=
																																																															CDR
																																																															(BgL_cdrzd250518zd2_7727);
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd250522zd2_7729))
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (PAIRP(BgL_cdrzd250523zd2_7730))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_carzd250528zd2_7733;
																																																																		BgL_carzd250528zd2_7733
																																																																			=
																																																																			CAR
																																																																			(BgL_cdrzd250523zd2_7730);
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd250528zd2_7733))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (NULLP(CDR(BgL_cdrzd250523zd2_7730)))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						bool_t
																																																																							BgL_test10059z00_26667;
																																																																						{
																																																																							obj_t
																																																																								BgL_l1453z00_7766;
																																																																							BgL_l1453z00_7766
																																																																								=
																																																																								BgL_cdrzd250145zd2_7656;
																																																																						BgL_zc3z04anonymousza36181ze3z87_7767:
																																																																							if (NULLP(BgL_l1453z00_7766))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									BgL_test10059z00_26667
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										1);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									bool_t
																																																																										BgL_test10061z00_26670;
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										bool_t
																																																																											BgL_test10062z00_26671;
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_tmpz00_26672;
																																																																											BgL_tmpz00_26672
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_l1453z00_7766));
																																																																											BgL_test10062z00_26671
																																																																												=
																																																																												PAIRP
																																																																												(BgL_tmpz00_26672);
																																																																										}
																																																																										if (BgL_test10062z00_26671)
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												BgL_test10061z00_26670
																																																																													=
																																																																													(
																																																																													(bool_t)
																																																																													0);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												BgL_test10061z00_26670
																																																																													=
																																																																													(
																																																																													(bool_t)
																																																																													1);
																																																																											}
																																																																									}
																																																																									if (BgL_test10061z00_26670)
																																																																										{
																																																																											obj_t
																																																																												BgL_l1453z00_26676;
																																																																											BgL_l1453z00_26676
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_l1453z00_7766));
																																																																											BgL_l1453z00_7766
																																																																												=
																																																																												BgL_l1453z00_26676;
																																																																											goto
																																																																												BgL_zc3z04anonymousza36181ze3z87_7767;
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											BgL_test10059z00_26667
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												0);
																																																																										}
																																																																								}
																																																																						}
																																																																						if (BgL_test10059z00_26667)
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_arg6171z00_7749;
																																																																								BgL_arg6171z00_7749
																																																																									=
																																																																									CAR
																																																																									(BgL_cdrzd250513zd2_7723);
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_26680;
																																																																									{
																																																																										obj_t
																																																																											BgL_argsz00_26684;
																																																																										obj_t
																																																																											BgL_proc2z00_26683;
																																																																										obj_t
																																																																											BgL_proc1z00_26682;
																																																																										obj_t
																																																																											BgL_testz00_26681;
																																																																										BgL_testz00_26681
																																																																											=
																																																																											BgL_arg6171z00_7749;
																																																																										BgL_proc1z00_26682
																																																																											=
																																																																											BgL_carzd250522zd2_7729;
																																																																										BgL_proc2z00_26683
																																																																											=
																																																																											BgL_carzd250528zd2_7733;
																																																																										BgL_argsz00_26684
																																																																											=
																																																																											BgL_cdrzd250145zd2_7656;
																																																																										BgL_argsz00_1747
																																																																											=
																																																																											BgL_argsz00_26684;
																																																																										BgL_proc2z00_1746
																																																																											=
																																																																											BgL_proc2z00_26683;
																																																																										BgL_proc1z00_1745
																																																																											=
																																																																											BgL_proc1z00_26682;
																																																																										BgL_testz00_1744
																																																																											=
																																																																											BgL_testz00_26681;
																																																																										goto
																																																																											BgL_tagzd2387zd2_1748;
																																																																									}
																																																																									BgL_auxz00_22101
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_26680);
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd250553zd2_7750;
																																																																								BgL_cdrzd250553zd2_7750
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd250561zd2_7751;
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_pairz00_12931;
																																																																										BgL_pairz00_12931
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										BgL_cdrzd250561zd2_7751
																																																																											=
																																																																											CDR
																																																																											(BgL_pairz00_12931);
																																																																									}
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd250569zd2_7752;
																																																																										BgL_cdrzd250569zd2_7752
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd250561zd2_7751));
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd250576zd2_7753;
																																																																											BgL_carzd250576zd2_7753
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd250569zd2_7752));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd250576zd2_7753))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_carzd250585zd2_7755;
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_pairz00_12935;
																																																																														BgL_pairz00_12935
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd250569zd2_7752));
																																																																														BgL_carzd250585zd2_7755
																																																																															=
																																																																															CAR
																																																																															(BgL_pairz00_12935);
																																																																													}
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd250585zd2_7755))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd250553zd2_7750))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_arg6175z00_7758;
																																																																																	BgL_arg6175z00_7758
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd250561zd2_7751));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_26706;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_26710;
																																																																																			obj_t
																																																																																				BgL_proc2z00_26709;
																																																																																			obj_t
																																																																																				BgL_proc1z00_26708;
																																																																																			obj_t
																																																																																				BgL_testz00_26707;
																																																																																			BgL_testz00_26707
																																																																																				=
																																																																																				BgL_arg6175z00_7758;
																																																																																			BgL_proc1z00_26708
																																																																																				=
																																																																																				BgL_carzd250576zd2_7753;
																																																																																			BgL_proc2z00_26709
																																																																																				=
																																																																																				BgL_carzd250585zd2_7755;
																																																																																			BgL_argsz00_26710
																																																																																				=
																																																																																				BgL_cdrzd250553zd2_7750;
																																																																																			BgL_argsz00_1752
																																																																																				=
																																																																																				BgL_argsz00_26710;
																																																																																			BgL_proc2z00_1751
																																																																																				=
																																																																																				BgL_proc2z00_26709;
																																																																																			BgL_proc1z00_1750
																																																																																				=
																																																																																				BgL_proc1z00_26708;
																																																																																			BgL_testz00_1749
																																																																																				=
																																																																																				BgL_testz00_26707;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1753;
																																																																																		}
																																																																																		BgL_auxz00_22101
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_26706);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1777;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_26714;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1778;
																																																																																			BgL_auxz00_22101
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_26714);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1777;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_26718;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1778;
																																																																																	BgL_auxz00_22101
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_26718);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1777;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_26722;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1778;
																																																																															BgL_auxz00_22101
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_26722);
																																																																														}
																																																																												}
																																																																										}
																																																																									}
																																																																								}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1777;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_26726;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1778;
																																																																								BgL_auxz00_22101
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_26726);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd250863zd2_7777;
																																																																				BgL_cdrzd250863zd2_7777
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd250870zd2_7778;
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_pairz00_12939;
																																																																						BgL_pairz00_12939
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						BgL_cdrzd250870zd2_7778
																																																																							=
																																																																							CDR
																																																																							(BgL_pairz00_12939);
																																																																					}
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd250877zd2_7779;
																																																																						BgL_cdrzd250877zd2_7779
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd250870zd2_7778));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd250883zd2_7780;
																																																																							obj_t
																																																																								BgL_cdrzd250884zd2_7781;
																																																																							BgL_carzd250883zd2_7780
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd250877zd2_7779));
																																																																							BgL_cdrzd250884zd2_7781
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd250877zd2_7779));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd250883zd2_7780))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd250891zd2_7783;
																																																																									BgL_carzd250891zd2_7783
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd250884zd2_7781));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd250891zd2_7783))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (NULLP(CDR(((obj_t) BgL_cdrzd250884zd2_7781))))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd250863zd2_7777))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg6190z00_7788;
																																																																															BgL_arg6190z00_7788
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd250870zd2_7778));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_26753;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_26757;
																																																																																	obj_t
																																																																																		BgL_proc2z00_26756;
																																																																																	obj_t
																																																																																		BgL_proc1z00_26755;
																																																																																	obj_t
																																																																																		BgL_testz00_26754;
																																																																																	BgL_testz00_26754
																																																																																		=
																																																																																		BgL_arg6190z00_7788;
																																																																																	BgL_proc1z00_26755
																																																																																		=
																																																																																		BgL_carzd250883zd2_7780;
																																																																																	BgL_proc2z00_26756
																																																																																		=
																																																																																		BgL_carzd250891zd2_7783;
																																																																																	BgL_argsz00_26757
																																																																																		=
																																																																																		BgL_cdrzd250863zd2_7777;
																																																																																	BgL_argsz00_1752
																																																																																		=
																																																																																		BgL_argsz00_26757;
																																																																																	BgL_proc2z00_1751
																																																																																		=
																																																																																		BgL_proc2z00_26756;
																																																																																	BgL_proc1z00_1750
																																																																																		=
																																																																																		BgL_proc1z00_26755;
																																																																																	BgL_testz00_1749
																																																																																		=
																																																																																		BgL_testz00_26754;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1753;
																																																																																}
																																																																																BgL_auxz00_22101
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_26753);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1777;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_26761;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1778;
																																																																																	BgL_auxz00_22101
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_26761);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1777;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_26765;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1778;
																																																																															BgL_auxz00_22101
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_26765);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1777;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_26769;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1778;
																																																																													BgL_auxz00_22101
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_26769);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1777;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_26773;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1778;
																																																																											BgL_auxz00_22101
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_26773);
																																																																										}
																																																																								}
																																																																						}
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1777;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_26777;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1778;
																																																																				BgL_auxz00_22101
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_26777);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd251224zd2_7796;
																																																																BgL_cdrzd251224zd2_7796
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd251230zd2_7797;
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_pairz00_12949;
																																																																		BgL_pairz00_12949
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		BgL_cdrzd251230zd2_7797
																																																																			=
																																																																			CDR
																																																																			(BgL_pairz00_12949);
																																																																	}
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd251236zd2_7798;
																																																																		BgL_cdrzd251236zd2_7798
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd251230zd2_7797));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_carzd251241zd2_7799;
																																																																			obj_t
																																																																				BgL_cdrzd251242zd2_7800;
																																																																			BgL_carzd251241zd2_7799
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd251236zd2_7798));
																																																																			BgL_cdrzd251242zd2_7800
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd251236zd2_7798));
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd251241zd2_7799))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (PAIRP(BgL_cdrzd251242zd2_7800))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd251247zd2_7803;
																																																																							BgL_carzd251247zd2_7803
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd251242zd2_7800);
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd251247zd2_7803))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (NULLP(CDR(BgL_cdrzd251242zd2_7800)))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd251224zd2_7796))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_arg6204z00_7808;
																																																																													BgL_arg6204z00_7808
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd251230zd2_7797));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_26804;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_26808;
																																																																															obj_t
																																																																																BgL_proc2z00_26807;
																																																																															obj_t
																																																																																BgL_proc1z00_26806;
																																																																															obj_t
																																																																																BgL_testz00_26805;
																																																																															BgL_testz00_26805
																																																																																=
																																																																																BgL_arg6204z00_7808;
																																																																															BgL_proc1z00_26806
																																																																																=
																																																																																BgL_carzd251241zd2_7799;
																																																																															BgL_proc2z00_26807
																																																																																=
																																																																																BgL_carzd251247zd2_7803;
																																																																															BgL_argsz00_26808
																																																																																=
																																																																																BgL_cdrzd251224zd2_7796;
																																																																															BgL_argsz00_1752
																																																																																=
																																																																																BgL_argsz00_26808;
																																																																															BgL_proc2z00_1751
																																																																																=
																																																																																BgL_proc2z00_26807;
																																																																															BgL_proc1z00_1750
																																																																																=
																																																																																BgL_proc1z00_26806;
																																																																															BgL_testz00_1749
																																																																																=
																																																																																BgL_testz00_26805;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1753;
																																																																														}
																																																																														BgL_auxz00_22101
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_26804);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1777;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_26812;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1778;
																																																																															BgL_auxz00_22101
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_26812);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1777;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_26816;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1778;
																																																																													BgL_auxz00_22101
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_26816);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1777;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_26820;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1778;
																																																																											BgL_auxz00_22101
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_26820);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1777;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_26824;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1778;
																																																																									BgL_auxz00_22101
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_26824);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1777;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_26828;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1778;
																																																																							BgL_auxz00_22101
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_26828);
																																																																						}
																																																																				}
																																																																		}
																																																																	}
																																																																}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 119 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1777;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_26832;
																																																																goto
																																																																	BgL_tagzd2404zd2_1778;
																																																																BgL_auxz00_22101
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_26832);
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 119 */
																																																														goto
																																																															BgL_tagzd2403zd2_1777;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_26836;
																																																														goto
																																																															BgL_tagzd2404zd2_1778;
																																																														BgL_auxz00_22101
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_26836);
																																																													}
																																																											}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 119 */
																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																											{	/* Ast/sexp.scm 119 */
																																																												goto
																																																													BgL_tagzd2403zd2_1777;
																																																											}
																																																										else
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_26840;
																																																												goto
																																																													BgL_tagzd2404zd2_1778;
																																																												BgL_auxz00_22101
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_26840);
																																																											}
																																																									}
																																																							}
																																																					}
																																																				}
																																																		}
																																																}
																																															}
																																													}
																																											}
																																									}
																																							}
																																					}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					obj_t
																																						BgL_cdrzd251785zd2_7972;
																																					BgL_cdrzd251785zd2_7972
																																						=
																																						CDR(
																																						((obj_t) BgL_expz00_21));
																																					if (
																																						(BgL_carzd248481zd2_7638
																																							==
																																							CNST_TABLE_REF
																																							(((long) 17))))
																																						{	/* Ast/sexp.scm 119 */
																																							obj_t
																																								BgL_arg6320z00_7974;
																																							obj_t
																																								BgL_arg6321z00_7975;
																																							BgL_arg6320z00_7974
																																								=
																																								CAR
																																								(
																																								((obj_t) BgL_cdrzd251785zd2_7972));
																																							BgL_arg6321z00_7975
																																								=
																																								CDR
																																								(
																																								((obj_t) BgL_cdrzd251785zd2_7972));
																																							{
																																								BgL_nodez00_bglt
																																									BgL_auxz00_26851;
																																								{
																																									obj_t
																																										BgL_exprz00_26853;
																																									obj_t
																																										BgL_bindingsz00_26852;
																																									BgL_bindingsz00_26852
																																										=
																																										BgL_arg6320z00_7974;
																																									BgL_exprz00_26853
																																										=
																																										BgL_arg6321z00_7975;
																																									BgL_exprz00_1732
																																										=
																																										BgL_exprz00_26853;
																																									BgL_bindingsz00_1731
																																										=
																																										BgL_bindingsz00_26852;
																																									goto
																																										BgL_tagzd2382zd2_1733;
																																								}
																																								BgL_auxz00_22101
																																									=
																																									(
																																									(obj_t)
																																									BgL_auxz00_26851);
																																							}
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd248481zd2_7638)))
																																								{	/* Ast/sexp.scm 119 */
																																									obj_t
																																										BgL_arg6323z00_7977;
																																									obj_t
																																										BgL_arg6324z00_7978;
																																									BgL_arg6323z00_7977
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_cdrzd251785zd2_7972));
																																									BgL_arg6324z00_7978
																																										=
																																										CDR
																																										(
																																										((obj_t) BgL_cdrzd251785zd2_7972));
																																									{
																																										BgL_nodez00_bglt
																																											BgL_auxz00_26862;
																																										{
																																											obj_t
																																												BgL_exprz00_26864;
																																											obj_t
																																												BgL_bindingsz00_26863;
																																											BgL_bindingsz00_26863
																																												=
																																												BgL_arg6323z00_7977;
																																											BgL_exprz00_26864
																																												=
																																												BgL_arg6324z00_7978;
																																											BgL_exprz00_1732
																																												=
																																												BgL_exprz00_26864;
																																											BgL_bindingsz00_1731
																																												=
																																												BgL_bindingsz00_26863;
																																											goto
																																												BgL_tagzd2382zd2_1733;
																																										}
																																										BgL_auxz00_22101
																																											=
																																											(
																																											(obj_t)
																																											BgL_auxz00_26862);
																																									}
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									if ((BgL_carzd248481zd2_7638 == CNST_TABLE_REF(((long) 18))))
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_arg6326z00_7980;
																																											obj_t
																																												BgL_arg6327z00_7981;
																																											BgL_arg6326z00_7980
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_cdrzd251785zd2_7972));
																																											BgL_arg6327z00_7981
																																												=
																																												CDR
																																												(
																																												((obj_t) BgL_cdrzd251785zd2_7972));
																																											{
																																												BgL_nodez00_bglt
																																													BgL_auxz00_26873;
																																												{
																																													obj_t
																																														BgL_exprz00_26875;
																																													obj_t
																																														BgL_bindingsz00_26874;
																																													BgL_bindingsz00_26874
																																														=
																																														BgL_arg6326z00_7980;
																																													BgL_exprz00_26875
																																														=
																																														BgL_arg6327z00_7981;
																																													BgL_exprz00_1732
																																														=
																																														BgL_exprz00_26875;
																																													BgL_bindingsz00_1731
																																														=
																																														BgL_bindingsz00_26874;
																																													goto
																																														BgL_tagzd2382zd2_1733;
																																												}
																																												BgL_auxz00_22101
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_26873);
																																											}
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_26882;
																																													goto
																																														BgL_tagzd2383zd2_1734;
																																													BgL_auxz00_22101
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_26882);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_carzd251822zd2_7984;
																																													BgL_carzd251822zd2_7984
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													if ((BgL_carzd251822zd2_7984 == CNST_TABLE_REF(((long) 19))))
																																														{
																																															BgL_letzd2funzd2_bglt
																																																BgL_auxz00_26889;
																																															goto
																																																BgL_tagzd2384zd2_1735;
																																															BgL_auxz00_22101
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_26889);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd251822zd2_7984)))
																																																{
																																																	BgL_letzd2funzd2_bglt
																																																		BgL_auxz00_26894;
																																																	goto
																																																		BgL_tagzd2384zd2_1735;
																																																	BgL_auxz00_22101
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_26894);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_26901;
																																																			goto
																																																				BgL_tagzd2389zd2_1754;
																																																			BgL_auxz00_22101
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_26901);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_26908;
																																																					goto
																																																						BgL_tagzd2390zd2_1755;
																																																					BgL_auxz00_22101
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_26908);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_cdrzd251902zd2_7991;
																																																					BgL_cdrzd251902zd2_7991
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_arg6338z00_7994;
																																																							obj_t
																																																								BgL_arg6339z00_7995;
																																																							BgL_arg6338z00_7994
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd251902zd2_7991));
																																																							BgL_arg6339z00_7995
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd251902zd2_7991));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_26921;
																																																								{
																																																									obj_t
																																																										BgL_restz00_26923;
																																																									obj_t
																																																										BgL_effectz00_26922;
																																																									BgL_effectz00_26922
																																																										=
																																																										BgL_arg6338z00_7994;
																																																									BgL_restz00_26923
																																																										=
																																																										BgL_arg6339z00_7995;
																																																									BgL_restz00_1757
																																																										=
																																																										BgL_restz00_26923;
																																																									BgL_effectz00_1756
																																																										=
																																																										BgL_effectz00_26922;
																																																									goto
																																																										BgL_tagzd2391zd2_1758;
																																																								}
																																																								BgL_auxz00_22101
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_26921);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_26930;
																																																									goto
																																																										BgL_tagzd2392zd2_1759;
																																																									BgL_auxz00_22101
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_26930);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_26937;
																																																											goto
																																																												BgL_tagzd2393zd2_1760;
																																																											BgL_auxz00_22101
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_26937);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_arg6346z00_8003;
																																																													obj_t
																																																														BgL_arg6347z00_8004;
																																																													BgL_arg6346z00_8003
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_cdrzd251902zd2_7991));
																																																													BgL_arg6347z00_8004
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd251902zd2_7991));
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_26948;
																																																														{
																																																															obj_t
																																																																BgL_restz00_26950;
																																																															obj_t
																																																																BgL_effectz00_26949;
																																																															BgL_effectz00_26949
																																																																=
																																																																BgL_arg6346z00_8003;
																																																															BgL_restz00_26950
																																																																=
																																																																BgL_arg6347z00_8004;
																																																															BgL_restz00_1762
																																																																=
																																																																BgL_restz00_26950;
																																																															BgL_effectz00_1761
																																																																=
																																																																BgL_effectz00_26949;
																																																															goto
																																																																BgL_tagzd2394zd2_1763;
																																																														}
																																																														BgL_auxz00_22101
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_26948);
																																																													}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_26957;
																																																															goto
																																																																BgL_tagzd2395zd2_1764;
																																																															BgL_auxz00_22101
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_26957);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_26964;
																																																																	goto
																																																																		BgL_tagzd2396zd2_1765;
																																																																	BgL_auxz00_22101
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_26964);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																		{
																																																																			BgL_letzd2funzd2_bglt
																																																																				BgL_auxz00_26971;
																																																																			goto
																																																																				BgL_tagzd2397zd2_1766;
																																																																			BgL_auxz00_22101
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_26971);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																				{
																																																																					BgL_jumpzd2exzd2itz00_bglt
																																																																						BgL_auxz00_26978;
																																																																					goto
																																																																						BgL_tagzd2398zd2_1767;
																																																																					BgL_auxz00_22101
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_26978);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd251979zd2_8013;
																																																																					BgL_cdrzd251979zd2_8013
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_arg6358z00_8016;
																																																																							obj_t
																																																																								BgL_arg6359z00_8017;
																																																																							BgL_arg6358z00_8016
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd251979zd2_8013));
																																																																							BgL_arg6359z00_8017
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd251979zd2_8013));
																																																																							{	/* Ast/sexp.scm 552 */
																																																																								obj_t
																																																																									BgL_arg6965z00_12988;
																																																																								BgL_arg6965z00_12988
																																																																									=
																																																																									BGl_findzd2locationzf2locz20zztools_locationz00
																																																																									(BgL_expz00_21,
																																																																									BgL_locz00_23);
																																																																								BgL_auxz00_22101
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																									(BgL_expz00_21,
																																																																										BgL_arg6358z00_8016,
																																																																										CNST_TABLE_REF
																																																																										(((long) 4)), BgL_arg6359z00_8017, BgL_stackz00_22, BgL_arg6965z00_12988, BgL_sitez00_24));
																																																																						}}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1777;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_26997;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1778;
																																																																									BgL_auxz00_22101
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_26997);
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																										}
																								}
																							else
																								{	/* Ast/sexp.scm 119 */
																									obj_t BgL_carzd252004zd2_8033;

																									BgL_carzd252004zd2_8033 =
																										CAR(
																										((obj_t) BgL_expz00_21));
																									if (
																										(BgL_carzd252004zd2_8033 ==
																											CNST_TABLE_REF(((long)
																													1))))
																										{
																											BgL_nodez00_bglt
																												BgL_auxz00_27004;
																											goto
																												BgL_tagzd2377zd2_1722;
																											BgL_auxz00_22101 =
																												((obj_t)
																												BgL_auxz00_27004);
																										}
																									else
																										{	/* Ast/sexp.scm 119 */
																											if (
																												(BgL_carzd252004zd2_8033
																													==
																													BGl_za2ifza2z00zzast_sexpz00))
																												{
																													BgL_nodez00_bglt
																														BgL_auxz00_27008;
																													goto
																														BgL_tagzd2377zd2_1722;
																													BgL_auxz00_22101 =
																														((obj_t)
																														BgL_auxz00_27008);
																												}
																											else
																												{	/* Ast/sexp.scm 119 */
																													if (
																														(CAR(
																																((obj_t)
																																	BgL_expz00_21))
																															==
																															CNST_TABLE_REF((
																																	(long) 7))))
																														{
																															BgL_nodez00_bglt
																																BgL_auxz00_27015;
																															goto
																																BgL_tagzd2379zd2_1726;
																															BgL_auxz00_22101 =
																																((obj_t)
																																BgL_auxz00_27015);
																														}
																													else
																														{	/* Ast/sexp.scm 119 */
																															if (
																																(CAR(
																																		((obj_t)
																																			BgL_expz00_21))
																																	==
																																	CNST_TABLE_REF
																																	(((long)
																																			16))))
																																{
																																	BgL_nodez00_bglt
																																		BgL_auxz00_27022;
																																	goto
																																		BgL_tagzd2380zd2_1727;
																																	BgL_auxz00_22101
																																		=
																																		((obj_t)
																																		BgL_auxz00_27022);
																																}
																															else
																																{	/* Ast/sexp.scm 119 */
																																	obj_t
																																		BgL_carzd252073zd2_8040;
																																	BgL_carzd252073zd2_8040
																																		=
																																		CAR(((obj_t)
																																			BgL_expz00_21));
																																	if (PAIRP
																																		(BgL_carzd252073zd2_8040))
																																		{	/* Ast/sexp.scm 119 */
																																			obj_t
																																				BgL_carzd252076zd2_8042;
																																			obj_t
																																				BgL_cdrzd252077zd2_8043;
																																			BgL_carzd252076zd2_8042
																																				=
																																				CAR
																																				(BgL_carzd252073zd2_8040);
																																			BgL_cdrzd252077zd2_8043
																																				=
																																				CDR
																																				(BgL_carzd252073zd2_8040);
																																			{

																																				if (
																																					(BgL_carzd252076zd2_8042
																																						==
																																						CNST_TABLE_REF
																																						(((long) 17))))
																																					{	/* Ast/sexp.scm 119 */
																																					BgL_kapzd252078zd2_8044:
																																						if (PAIRP(BgL_cdrzd252077zd2_8043))
																																							{	/* Ast/sexp.scm 119 */
																																								obj_t
																																									BgL_cdrzd252081zd2_8163;
																																								BgL_cdrzd252081zd2_8163
																																									=
																																									CDR
																																									(BgL_cdrzd252077zd2_8043);
																																								if (PAIRP(BgL_cdrzd252081zd2_8163))
																																									{	/* Ast/sexp.scm 119 */
																																										if (NULLP(CDR(BgL_cdrzd252081zd2_8163)))
																																											{	/* Ast/sexp.scm 119 */
																																												obj_t
																																													BgL_arg6461z00_8167;
																																												obj_t
																																													BgL_arg6462z00_8168;
																																												BgL_arg6461z00_8167
																																													=
																																													CAR
																																													(BgL_cdrzd252081zd2_8163);
																																												BgL_arg6462z00_8168
																																													=
																																													CDR
																																													(
																																													((obj_t) BgL_expz00_21));
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_27044;
																																													{
																																														obj_t
																																															BgL_argsz00_27046;
																																														obj_t
																																															BgL_bodyz00_27045;
																																														BgL_bodyz00_27045
																																															=
																																															BgL_arg6461z00_8167;
																																														BgL_argsz00_27046
																																															=
																																															BgL_arg6462z00_8168;
																																														BgL_argsz00_1729
																																															=
																																															BgL_argsz00_27046;
																																														BgL_bodyz00_1728
																																															=
																																															BgL_bodyz00_27045;
																																														goto
																																															BgL_tagzd2381zd2_1730;
																																													}
																																													BgL_auxz00_22101
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_27044);
																																												}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												bool_t
																																													BgL_test10119z00_27048;
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_arg6526z00_8274;
																																													BgL_arg6526z00_8274
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													BgL_test10119z00_27048
																																														=
																																														CBOOL
																																														(BGl_labelszd2symzf3z21zzast_labelsz00
																																														(BgL_arg6526z00_8274));
																																												}
																																												if (BgL_test10119z00_27048)
																																													{
																																														BgL_letzd2funzd2_bglt
																																															BgL_auxz00_27053;
																																														goto
																																															BgL_tagzd2384zd2_1735;
																																														BgL_auxz00_22101
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_27053);
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_carzd252159zd2_8171;
																																														BgL_carzd252159zd2_8171
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_cdrzd252164zd2_8172;
																																															BgL_cdrzd252164zd2_8172
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_carzd252159zd2_8171));
																																															if ((CAR(((obj_t) BgL_carzd252159zd2_8171)) == CNST_TABLE_REF(((long) 3))))
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg6467z00_8175;
																																																	obj_t
																																																		BgL_arg6468z00_8176;
																																																	obj_t
																																																		BgL_arg6469z00_8177;
																																																	BgL_arg6467z00_8175
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd252164zd2_8172));
																																																	BgL_arg6468z00_8176
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd252164zd2_8172));
																																																	BgL_arg6469z00_8177
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_27070;
																																																		{
																																																			obj_t
																																																				BgL_argsz00_27073;
																																																			obj_t
																																																				BgL_bodyz00_27072;
																																																			obj_t
																																																				BgL_varsz00_27071;
																																																			BgL_varsz00_27071
																																																				=
																																																				BgL_arg6467z00_8175;
																																																			BgL_bodyz00_27072
																																																				=
																																																				BgL_arg6468z00_8176;
																																																			BgL_argsz00_27073
																																																				=
																																																				BgL_arg6469z00_8177;
																																																			BgL_argsz00_1742
																																																				=
																																																				BgL_argsz00_27073;
																																																			BgL_bodyz00_1741
																																																				=
																																																				BgL_bodyz00_27072;
																																																			BgL_varsz00_1740
																																																				=
																																																				BgL_varsz00_27071;
																																																			goto
																																																				BgL_tagzd2386zd2_1743;
																																																		}
																																																		BgL_auxz00_22101
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_27070);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_cdrzd252187zd2_8179;
																																																	BgL_cdrzd252187zd2_8179
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_cdrzd252193zd2_8180;
																																																		BgL_cdrzd252193zd2_8180
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_carzd252159zd2_8171));
																																																		if ((CAR(((obj_t) BgL_carzd252159zd2_8171)) == CNST_TABLE_REF(((long) 1))))
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd252199zd2_8183;
																																																				BgL_cdrzd252199zd2_8183
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_cdrzd252193zd2_8180));
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_carzd252204zd2_8184;
																																																					obj_t
																																																						BgL_cdrzd252205zd2_8185;
																																																					BgL_carzd252204zd2_8184
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd252199zd2_8183));
																																																					BgL_cdrzd252205zd2_8185
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd252199zd2_8183));
																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd252204zd2_8184))
																																																						{	/* Ast/sexp.scm 119 */
																																																							if (PAIRP(BgL_cdrzd252205zd2_8185))
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_carzd252212zd2_8188;
																																																									BgL_carzd252212zd2_8188
																																																										=
																																																										CAR
																																																										(BgL_cdrzd252205zd2_8185);
																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd252212zd2_8188))
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (NULLP(CDR(BgL_cdrzd252205zd2_8185)))
																																																												{	/* Ast/sexp.scm 119 */
																																																													bool_t
																																																														BgL_test10126z00_27100;
																																																													{
																																																														obj_t
																																																															BgL_l1456z00_8221;
																																																														BgL_l1456z00_8221
																																																															=
																																																															BgL_cdrzd252187zd2_8179;
																																																													BgL_zc3z04anonymousza36492ze3z87_8222:
																																																														if (NULLP(BgL_l1456z00_8221))
																																																															{	/* Ast/sexp.scm 119 */
																																																																BgL_test10126z00_27100
																																																																	=
																																																																	(
																																																																	(bool_t)
																																																																	1);
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																bool_t
																																																																	BgL_test10128z00_27103;
																																																																{	/* Ast/sexp.scm 119 */
																																																																	bool_t
																																																																		BgL_test10129z00_27104;
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_tmpz00_27105;
																																																																		BgL_tmpz00_27105
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_l1456z00_8221));
																																																																		BgL_test10129z00_27104
																																																																			=
																																																																			PAIRP
																																																																			(BgL_tmpz00_27105);
																																																																	}
																																																																	if (BgL_test10129z00_27104)
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			BgL_test10128z00_27103
																																																																				=
																																																																				(
																																																																				(bool_t)
																																																																				0);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			BgL_test10128z00_27103
																																																																				=
																																																																				(
																																																																				(bool_t)
																																																																				1);
																																																																		}
																																																																}
																																																																if (BgL_test10128z00_27103)
																																																																	{
																																																																		obj_t
																																																																			BgL_l1456z00_27109;
																																																																		BgL_l1456z00_27109
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_l1456z00_8221));
																																																																		BgL_l1456z00_8221
																																																																			=
																																																																			BgL_l1456z00_27109;
																																																																		goto
																																																																			BgL_zc3z04anonymousza36492ze3z87_8222;
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		BgL_test10126z00_27100
																																																																			=
																																																																			(
																																																																			(bool_t)
																																																																			0);
																																																																	}
																																																															}
																																																													}
																																																													if (BgL_test10126z00_27100)
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_arg6482z00_8204;
																																																															BgL_arg6482z00_8204
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd252193zd2_8180));
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_27114;
																																																																{
																																																																	obj_t
																																																																		BgL_argsz00_27118;
																																																																	obj_t
																																																																		BgL_proc2z00_27117;
																																																																	obj_t
																																																																		BgL_proc1z00_27116;
																																																																	obj_t
																																																																		BgL_testz00_27115;
																																																																	BgL_testz00_27115
																																																																		=
																																																																		BgL_arg6482z00_8204;
																																																																	BgL_proc1z00_27116
																																																																		=
																																																																		BgL_carzd252204zd2_8184;
																																																																	BgL_proc2z00_27117
																																																																		=
																																																																		BgL_carzd252212zd2_8188;
																																																																	BgL_argsz00_27118
																																																																		=
																																																																		BgL_cdrzd252187zd2_8179;
																																																																	BgL_argsz00_1747
																																																																		=
																																																																		BgL_argsz00_27118;
																																																																	BgL_proc2z00_1746
																																																																		=
																																																																		BgL_proc2z00_27117;
																																																																	BgL_proc1z00_1745
																																																																		=
																																																																		BgL_proc1z00_27116;
																																																																	BgL_testz00_1744
																																																																		=
																																																																		BgL_testz00_27115;
																																																																	goto
																																																																		BgL_tagzd2387zd2_1748;
																																																																}
																																																																BgL_auxz00_22101
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_27114);
																																																															}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd252236zd2_8205;
																																																															BgL_cdrzd252236zd2_8205
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd252243zd2_8206;
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_pairz00_13028;
																																																																	BgL_pairz00_13028
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	BgL_cdrzd252243zd2_8206
																																																																		=
																																																																		CDR
																																																																		(BgL_pairz00_13028);
																																																																}
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd252250zd2_8207;
																																																																	BgL_cdrzd252250zd2_8207
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd252243zd2_8206));
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_carzd252256zd2_8208;
																																																																		BgL_carzd252256zd2_8208
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd252250zd2_8207));
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd252256zd2_8208))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_carzd252263zd2_8210;
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_pairz00_13032;
																																																																					BgL_pairz00_13032
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd252250zd2_8207));
																																																																					BgL_carzd252263zd2_8210
																																																																						=
																																																																						CAR
																																																																						(BgL_pairz00_13032);
																																																																				}
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd252263zd2_8210))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd252236zd2_8205))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_arg6486z00_8213;
																																																																								BgL_arg6486z00_8213
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd252243zd2_8206));
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_27140;
																																																																									{
																																																																										obj_t
																																																																											BgL_argsz00_27144;
																																																																										obj_t
																																																																											BgL_proc2z00_27143;
																																																																										obj_t
																																																																											BgL_proc1z00_27142;
																																																																										obj_t
																																																																											BgL_testz00_27141;
																																																																										BgL_testz00_27141
																																																																											=
																																																																											BgL_arg6486z00_8213;
																																																																										BgL_proc1z00_27142
																																																																											=
																																																																											BgL_carzd252256zd2_8208;
																																																																										BgL_proc2z00_27143
																																																																											=
																																																																											BgL_carzd252263zd2_8210;
																																																																										BgL_argsz00_27144
																																																																											=
																																																																											BgL_cdrzd252236zd2_8205;
																																																																										BgL_argsz00_1752
																																																																											=
																																																																											BgL_argsz00_27144;
																																																																										BgL_proc2z00_1751
																																																																											=
																																																																											BgL_proc2z00_27143;
																																																																										BgL_proc1z00_1750
																																																																											=
																																																																											BgL_proc1z00_27142;
																																																																										BgL_testz00_1749
																																																																											=
																																																																											BgL_testz00_27141;
																																																																										goto
																																																																											BgL_tagzd2388zd2_1753;
																																																																									}
																																																																									BgL_auxz00_22101
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_27140);
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1777;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_27148;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1778;
																																																																										BgL_auxz00_22101
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_27148);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1777;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_27152;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1778;
																																																																								BgL_auxz00_22101
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_27152);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1777;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_27156;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1778;
																																																																						BgL_auxz00_22101
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_27156);
																																																																					}
																																																																			}
																																																																	}
																																																																}
																																																															}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{	/* Ast/sexp.scm 119 */
																																																															goto
																																																																BgL_tagzd2403zd2_1777;
																																																														}
																																																													else
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_27160;
																																																															goto
																																																																BgL_tagzd2404zd2_1778;
																																																															BgL_auxz00_22101
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_27160);
																																																														}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_cdrzd252539zd2_8232;
																																																											BgL_cdrzd252539zd2_8232
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd252545zd2_8233;
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_pairz00_13036;
																																																													BgL_pairz00_13036
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													BgL_cdrzd252545zd2_8233
																																																														=
																																																														CDR
																																																														(BgL_pairz00_13036);
																																																												}
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd252551zd2_8234;
																																																													BgL_cdrzd252551zd2_8234
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd252545zd2_8233));
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_carzd252556zd2_8235;
																																																														obj_t
																																																															BgL_cdrzd252557zd2_8236;
																																																														BgL_carzd252556zd2_8235
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd252551zd2_8234));
																																																														BgL_cdrzd252557zd2_8236
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd252551zd2_8234));
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd252556zd2_8235))
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_carzd252562zd2_8238;
																																																																BgL_carzd252562zd2_8238
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd252557zd2_8236));
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd252562zd2_8238))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (NULLP(CDR(((obj_t) BgL_cdrzd252557zd2_8236))))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd252539zd2_8232))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_arg6501z00_8243;
																																																																						BgL_arg6501z00_8243
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd252545zd2_8233));
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_27187;
																																																																							{
																																																																								obj_t
																																																																									BgL_argsz00_27191;
																																																																								obj_t
																																																																									BgL_proc2z00_27190;
																																																																								obj_t
																																																																									BgL_proc1z00_27189;
																																																																								obj_t
																																																																									BgL_testz00_27188;
																																																																								BgL_testz00_27188
																																																																									=
																																																																									BgL_arg6501z00_8243;
																																																																								BgL_proc1z00_27189
																																																																									=
																																																																									BgL_carzd252556zd2_8235;
																																																																								BgL_proc2z00_27190
																																																																									=
																																																																									BgL_carzd252562zd2_8238;
																																																																								BgL_argsz00_27191
																																																																									=
																																																																									BgL_cdrzd252539zd2_8232;
																																																																								BgL_argsz00_1752
																																																																									=
																																																																									BgL_argsz00_27191;
																																																																								BgL_proc2z00_1751
																																																																									=
																																																																									BgL_proc2z00_27190;
																																																																								BgL_proc1z00_1750
																																																																									=
																																																																									BgL_proc1z00_27189;
																																																																								BgL_testz00_1749
																																																																									=
																																																																									BgL_testz00_27188;
																																																																								goto
																																																																									BgL_tagzd2388zd2_1753;
																																																																							}
																																																																							BgL_auxz00_22101
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_27187);
																																																																						}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1777;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_27195;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1778;
																																																																								BgL_auxz00_22101
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_27195);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1777;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_27199;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1778;
																																																																						BgL_auxz00_22101
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_27199);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1777;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_27203;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1778;
																																																																				BgL_auxz00_22101
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_27203);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1777;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_27207;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1778;
																																																																		BgL_auxz00_22101
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_27207);
																																																																	}
																																																															}
																																																													}
																																																												}
																																																											}
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																										{	/* Ast/sexp.scm 119 */
																																																											goto
																																																												BgL_tagzd2403zd2_1777;
																																																										}
																																																									else
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_27211;
																																																											goto
																																																												BgL_tagzd2404zd2_1778;
																																																											BgL_auxz00_22101
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_27211);
																																																										}
																																																								}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_cdrzd252895zd2_8251;
																																																							BgL_cdrzd252895zd2_8251
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd252902zd2_8252;
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_pairz00_13046;
																																																									BgL_pairz00_13046
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									BgL_cdrzd252902zd2_8252
																																																										=
																																																										CDR
																																																										(BgL_pairz00_13046);
																																																								}
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_cdrzd252909zd2_8253;
																																																									BgL_cdrzd252909zd2_8253
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd252902zd2_8252));
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_carzd252915zd2_8254;
																																																										obj_t
																																																											BgL_cdrzd252916zd2_8255;
																																																										BgL_carzd252915zd2_8254
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_cdrzd252909zd2_8253));
																																																										BgL_cdrzd252916zd2_8255
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_cdrzd252909zd2_8253));
																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd252915zd2_8254))
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (PAIRP(BgL_cdrzd252916zd2_8255))
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_carzd252923zd2_8258;
																																																														BgL_carzd252923zd2_8258
																																																															=
																																																															CAR
																																																															(BgL_cdrzd252916zd2_8255);
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd252923zd2_8258))
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (NULLP(CDR(BgL_cdrzd252916zd2_8255)))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd252895zd2_8251))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_arg6515z00_8263;
																																																																				BgL_arg6515z00_8263
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd252902zd2_8252));
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_27238;
																																																																					{
																																																																						obj_t
																																																																							BgL_argsz00_27242;
																																																																						obj_t
																																																																							BgL_proc2z00_27241;
																																																																						obj_t
																																																																							BgL_proc1z00_27240;
																																																																						obj_t
																																																																							BgL_testz00_27239;
																																																																						BgL_testz00_27239
																																																																							=
																																																																							BgL_arg6515z00_8263;
																																																																						BgL_proc1z00_27240
																																																																							=
																																																																							BgL_carzd252915zd2_8254;
																																																																						BgL_proc2z00_27241
																																																																							=
																																																																							BgL_carzd252923zd2_8258;
																																																																						BgL_argsz00_27242
																																																																							=
																																																																							BgL_cdrzd252895zd2_8251;
																																																																						BgL_argsz00_1752
																																																																							=
																																																																							BgL_argsz00_27242;
																																																																						BgL_proc2z00_1751
																																																																							=
																																																																							BgL_proc2z00_27241;
																																																																						BgL_proc1z00_1750
																																																																							=
																																																																							BgL_proc1z00_27240;
																																																																						BgL_testz00_1749
																																																																							=
																																																																							BgL_testz00_27239;
																																																																						goto
																																																																							BgL_tagzd2388zd2_1753;
																																																																					}
																																																																					BgL_auxz00_22101
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_27238);
																																																																				}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1777;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_27246;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1778;
																																																																						BgL_auxz00_22101
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_27246);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1777;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_27250;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1778;
																																																																				BgL_auxz00_22101
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_27250);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1777;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_27254;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1778;
																																																																		BgL_auxz00_22101
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_27254);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 119 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1777;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_27258;
																																																																goto
																																																																	BgL_tagzd2404zd2_1778;
																																																																BgL_auxz00_22101
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_27258);
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 119 */
																																																														goto
																																																															BgL_tagzd2403zd2_1777;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_27262;
																																																														goto
																																																															BgL_tagzd2404zd2_1778;
																																																														BgL_auxz00_22101
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_27262);
																																																													}
																																																											}
																																																									}
																																																								}
																																																							}
																																																						}
																																																				}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																					{	/* Ast/sexp.scm 119 */
																																																						goto
																																																							BgL_tagzd2403zd2_1777;
																																																					}
																																																				else
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_27266;
																																																						goto
																																																							BgL_tagzd2404zd2_1778;
																																																						BgL_auxz00_22101
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_27266);
																																																					}
																																																			}
																																																	}
																																																}
																																														}
																																													}
																																											}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 119 */
																																										bool_t
																																											BgL_test10157z00_27268;
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_arg6537z00_8287;
																																											BgL_arg6537z00_8287
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_expz00_21));
																																											BgL_test10157z00_27268
																																												=
																																												CBOOL
																																												(BGl_labelszd2symzf3z21zzast_labelsz00
																																												(BgL_arg6537z00_8287));
																																										}
																																										if (BgL_test10157z00_27268)
																																											{
																																												BgL_letzd2funzd2_bglt
																																													BgL_auxz00_27273;
																																												goto
																																													BgL_tagzd2384zd2_1735;
																																												BgL_auxz00_22101
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_27273);
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												obj_t
																																													BgL_carzd253369zd2_8278;
																																												BgL_carzd253369zd2_8278
																																													=
																																													CAR
																																													(
																																													((obj_t) BgL_expz00_21));
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_cdrzd253374zd2_8279;
																																													BgL_cdrzd253374zd2_8279
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_carzd253369zd2_8278));
																																													if ((CAR(((obj_t) BgL_carzd253369zd2_8278)) == CNST_TABLE_REF(((long) 3))))
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg6532z00_8282;
																																															obj_t
																																																BgL_arg6533z00_8283;
																																															obj_t
																																																BgL_arg6534z00_8284;
																																															BgL_arg6532z00_8282
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd253374zd2_8279));
																																															BgL_arg6533z00_8283
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd253374zd2_8279));
																																															BgL_arg6534z00_8284
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_27290;
																																																{
																																																	obj_t
																																																		BgL_argsz00_27293;
																																																	obj_t
																																																		BgL_bodyz00_27292;
																																																	obj_t
																																																		BgL_varsz00_27291;
																																																	BgL_varsz00_27291
																																																		=
																																																		BgL_arg6532z00_8282;
																																																	BgL_bodyz00_27292
																																																		=
																																																		BgL_arg6533z00_8283;
																																																	BgL_argsz00_27293
																																																		=
																																																		BgL_arg6534z00_8284;
																																																	BgL_argsz00_1742
																																																		=
																																																		BgL_argsz00_27293;
																																																	BgL_bodyz00_1741
																																																		=
																																																		BgL_bodyz00_27292;
																																																	BgL_varsz00_1740
																																																		=
																																																		BgL_varsz00_27291;
																																																	goto
																																																		BgL_tagzd2386zd2_1743;
																																																}
																																																BgL_auxz00_22101
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_27290);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																{	/* Ast/sexp.scm 119 */
																																																	goto
																																																		BgL_tagzd2403zd2_1777;
																																																}
																																															else
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_27297;
																																																	goto
																																																		BgL_tagzd2404zd2_1778;
																																																	BgL_auxz00_22101
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_27297);
																																																}
																																														}
																																												}
																																											}
																																									}
																																							}
																																						else
																																							{	/* Ast/sexp.scm 119 */
																																								bool_t
																																									BgL_test10160z00_27299;
																																								{	/* Ast/sexp.scm 119 */
																																									obj_t
																																										BgL_arg6541z00_8291;
																																									BgL_arg6541z00_8291
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_expz00_21));
																																									BgL_test10160z00_27299
																																										=
																																										CBOOL
																																										(BGl_labelszd2symzf3z21zzast_labelsz00
																																										(BgL_arg6541z00_8291));
																																								}
																																								if (BgL_test10160z00_27299)
																																									{
																																										BgL_letzd2funzd2_bglt
																																											BgL_auxz00_27304;
																																										goto
																																											BgL_tagzd2384zd2_1735;
																																										BgL_auxz00_22101
																																											=
																																											(
																																											(obj_t)
																																											BgL_auxz00_27304);
																																									}
																																								else
																																									{	/* Ast/sexp.scm 119 */
																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																											{	/* Ast/sexp.scm 119 */
																																												goto
																																													BgL_tagzd2403zd2_1777;
																																											}
																																										else
																																											{
																																												BgL_nodez00_bglt
																																													BgL_auxz00_27308;
																																												goto
																																													BgL_tagzd2404zd2_1778;
																																												BgL_auxz00_22101
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_27308);
																																											}
																																									}
																																							}
																																					}
																																				else
																																					{	/* Ast/sexp.scm 119 */
																																						if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd252076zd2_8042)))
																																							{	/* Ast/sexp.scm 119 */
																																								goto
																																									BgL_kapzd252078zd2_8044;
																																							}
																																						else
																																							{	/* Ast/sexp.scm 119 */
																																								if ((BgL_carzd252076zd2_8042 == CNST_TABLE_REF(((long) 18))))
																																									{	/* Ast/sexp.scm 119 */
																																										goto
																																											BgL_kapzd252078zd2_8044;
																																									}
																																								else
																																									{	/* Ast/sexp.scm 119 */
																																										if ((BgL_carzd252076zd2_8042 == CNST_TABLE_REF(((long) 19))))
																																											{	/* Ast/sexp.scm 119 */
																																												goto
																																													BgL_kapzd252078zd2_8044;
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd252076zd2_8042)))
																																													{	/* Ast/sexp.scm 119 */
																																														goto
																																															BgL_kapzd252078zd2_8044;
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														bool_t
																																															BgL_test10166z00_27322;
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg6456z00_8161;
																																															BgL_arg6456z00_8161
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															BgL_test10166z00_27322
																																																=
																																																CBOOL
																																																(BGl_labelszd2symzf3z21zzast_labelsz00
																																																(BgL_arg6456z00_8161));
																																														}
																																														if (BgL_test10166z00_27322)
																																															{
																																																BgL_letzd2funzd2_bglt
																																																	BgL_auxz00_27327;
																																																goto
																																																	BgL_tagzd2384zd2_1735;
																																																BgL_auxz00_22101
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_27327);
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_carzd253697zd2_8052;
																																																BgL_carzd253697zd2_8052
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_cdrzd253702zd2_8053;
																																																	BgL_cdrzd253702zd2_8053
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_carzd253697zd2_8052));
																																																	if ((CAR(((obj_t) BgL_carzd253697zd2_8052)) == CNST_TABLE_REF(((long) 3))))
																																																		{	/* Ast/sexp.scm 119 */
																																																			if (PAIRP(BgL_cdrzd253702zd2_8053))
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_arg6392z00_8057;
																																																					obj_t
																																																						BgL_arg6393z00_8058;
																																																					obj_t
																																																						BgL_arg6394z00_8059;
																																																					BgL_arg6392z00_8057
																																																						=
																																																						CAR
																																																						(BgL_cdrzd253702zd2_8053);
																																																					BgL_arg6393z00_8058
																																																						=
																																																						CDR
																																																						(BgL_cdrzd253702zd2_8053);
																																																					BgL_arg6394z00_8059
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_27344;
																																																						{
																																																							obj_t
																																																								BgL_argsz00_27347;
																																																							obj_t
																																																								BgL_bodyz00_27346;
																																																							obj_t
																																																								BgL_varsz00_27345;
																																																							BgL_varsz00_27345
																																																								=
																																																								BgL_arg6392z00_8057;
																																																							BgL_bodyz00_27346
																																																								=
																																																								BgL_arg6393z00_8058;
																																																							BgL_argsz00_27347
																																																								=
																																																								BgL_arg6394z00_8059;
																																																							BgL_argsz00_1742
																																																								=
																																																								BgL_argsz00_27347;
																																																							BgL_bodyz00_1741
																																																								=
																																																								BgL_bodyz00_27346;
																																																							BgL_varsz00_1740
																																																								=
																																																								BgL_varsz00_27345;
																																																							goto
																																																								BgL_tagzd2386zd2_1743;
																																																						}
																																																						BgL_auxz00_22101
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_27344);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																						{	/* Ast/sexp.scm 119 */
																																																							goto
																																																								BgL_tagzd2403zd2_1777;
																																																						}
																																																					else
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_27351;
																																																							goto
																																																								BgL_tagzd2404zd2_1778;
																																																							BgL_auxz00_22101
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_27351);
																																																						}
																																																				}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_cdrzd253809zd2_8062;
																																																			BgL_cdrzd253809zd2_8062
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd253814zd2_8063;
																																																				BgL_cdrzd253814zd2_8063
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_carzd253697zd2_8052));
																																																				if ((CAR(((obj_t) BgL_carzd253697zd2_8052)) == CNST_TABLE_REF(((long) 1))))
																																																					{	/* Ast/sexp.scm 119 */
																																																						if (PAIRP(BgL_cdrzd253814zd2_8063))
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd253819zd2_8067;
																																																								BgL_cdrzd253819zd2_8067
																																																									=
																																																									CDR
																																																									(BgL_cdrzd253814zd2_8063);
																																																								if (PAIRP(BgL_cdrzd253819zd2_8067))
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_carzd253823zd2_8069;
																																																										obj_t
																																																											BgL_cdrzd253824zd2_8070;
																																																										BgL_carzd253823zd2_8069
																																																											=
																																																											CAR
																																																											(BgL_cdrzd253819zd2_8067);
																																																										BgL_cdrzd253824zd2_8070
																																																											=
																																																											CDR
																																																											(BgL_cdrzd253819zd2_8067);
																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd253823zd2_8069))
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (PAIRP(BgL_cdrzd253824zd2_8070))
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_carzd253829zd2_8073;
																																																														BgL_carzd253829zd2_8073
																																																															=
																																																															CAR
																																																															(BgL_cdrzd253824zd2_8070);
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd253829zd2_8073))
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (NULLP(CDR(BgL_cdrzd253824zd2_8070)))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		bool_t
																																																																			BgL_test10177z00_27379;
																																																																		{
																																																																			obj_t
																																																																				BgL_l1459z00_8106;
																																																																			BgL_l1459z00_8106
																																																																				=
																																																																				BgL_cdrzd253809zd2_8062;
																																																																		BgL_zc3z04anonymousza36420ze3z87_8107:
																																																																			if (NULLP(BgL_l1459z00_8106))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					BgL_test10177z00_27379
																																																																						=
																																																																						(
																																																																						(bool_t)
																																																																						1);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					bool_t
																																																																						BgL_test10179z00_27382;
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						bool_t
																																																																							BgL_test10180z00_27383;
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_tmpz00_27384;
																																																																							BgL_tmpz00_27384
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_l1459z00_8106));
																																																																							BgL_test10180z00_27383
																																																																								=
																																																																								PAIRP
																																																																								(BgL_tmpz00_27384);
																																																																						}
																																																																						if (BgL_test10180z00_27383)
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								BgL_test10179z00_27382
																																																																									=
																																																																									(
																																																																									(bool_t)
																																																																									0);
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								BgL_test10179z00_27382
																																																																									=
																																																																									(
																																																																									(bool_t)
																																																																									1);
																																																																							}
																																																																					}
																																																																					if (BgL_test10179z00_27382)
																																																																						{
																																																																							obj_t
																																																																								BgL_l1459z00_27388;
																																																																							BgL_l1459z00_27388
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_l1459z00_8106));
																																																																							BgL_l1459z00_8106
																																																																								=
																																																																								BgL_l1459z00_27388;
																																																																							goto
																																																																								BgL_zc3z04anonymousza36420ze3z87_8107;
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							BgL_test10177z00_27379
																																																																								=
																																																																								(
																																																																								(bool_t)
																																																																								0);
																																																																						}
																																																																				}
																																																																		}
																																																																		if (BgL_test10177z00_27379)
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_arg6410z00_8089;
																																																																				BgL_arg6410z00_8089
																																																																					=
																																																																					CAR
																																																																					(BgL_cdrzd253814zd2_8063);
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_27392;
																																																																					{
																																																																						obj_t
																																																																							BgL_argsz00_27396;
																																																																						obj_t
																																																																							BgL_proc2z00_27395;
																																																																						obj_t
																																																																							BgL_proc1z00_27394;
																																																																						obj_t
																																																																							BgL_testz00_27393;
																																																																						BgL_testz00_27393
																																																																							=
																																																																							BgL_arg6410z00_8089;
																																																																						BgL_proc1z00_27394
																																																																							=
																																																																							BgL_carzd253823zd2_8069;
																																																																						BgL_proc2z00_27395
																																																																							=
																																																																							BgL_carzd253829zd2_8073;
																																																																						BgL_argsz00_27396
																																																																							=
																																																																							BgL_cdrzd253809zd2_8062;
																																																																						BgL_argsz00_1747
																																																																							=
																																																																							BgL_argsz00_27396;
																																																																						BgL_proc2z00_1746
																																																																							=
																																																																							BgL_proc2z00_27395;
																																																																						BgL_proc1z00_1745
																																																																							=
																																																																							BgL_proc1z00_27394;
																																																																						BgL_testz00_1744
																																																																							=
																																																																							BgL_testz00_27393;
																																																																						goto
																																																																							BgL_tagzd2387zd2_1748;
																																																																					}
																																																																					BgL_auxz00_22101
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_27392);
																																																																				}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd253854zd2_8090;
																																																																				BgL_cdrzd253854zd2_8090
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd253862zd2_8091;
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_pairz00_13091;
																																																																						BgL_pairz00_13091
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						BgL_cdrzd253862zd2_8091
																																																																							=
																																																																							CDR
																																																																							(BgL_pairz00_13091);
																																																																					}
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd253870zd2_8092;
																																																																						BgL_cdrzd253870zd2_8092
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd253862zd2_8091));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd253877zd2_8093;
																																																																							BgL_carzd253877zd2_8093
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd253870zd2_8092));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd253877zd2_8093))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd253886zd2_8095;
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_pairz00_13095;
																																																																										BgL_pairz00_13095
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd253870zd2_8092));
																																																																										BgL_carzd253886zd2_8095
																																																																											=
																																																																											CAR
																																																																											(BgL_pairz00_13095);
																																																																									}
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd253886zd2_8095))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd253854zd2_8090))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_arg6414z00_8098;
																																																																													BgL_arg6414z00_8098
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd253862zd2_8091));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_27418;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_27422;
																																																																															obj_t
																																																																																BgL_proc2z00_27421;
																																																																															obj_t
																																																																																BgL_proc1z00_27420;
																																																																															obj_t
																																																																																BgL_testz00_27419;
																																																																															BgL_testz00_27419
																																																																																=
																																																																																BgL_arg6414z00_8098;
																																																																															BgL_proc1z00_27420
																																																																																=
																																																																																BgL_carzd253877zd2_8093;
																																																																															BgL_proc2z00_27421
																																																																																=
																																																																																BgL_carzd253886zd2_8095;
																																																																															BgL_argsz00_27422
																																																																																=
																																																																																BgL_cdrzd253854zd2_8090;
																																																																															BgL_argsz00_1752
																																																																																=
																																																																																BgL_argsz00_27422;
																																																																															BgL_proc2z00_1751
																																																																																=
																																																																																BgL_proc2z00_27421;
																																																																															BgL_proc1z00_1750
																																																																																=
																																																																																BgL_proc1z00_27420;
																																																																															BgL_testz00_1749
																																																																																=
																																																																																BgL_testz00_27419;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1753;
																																																																														}
																																																																														BgL_auxz00_22101
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_27418);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1777;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_27426;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1778;
																																																																															BgL_auxz00_22101
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_27426);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1777;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_27430;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1778;
																																																																													BgL_auxz00_22101
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_27430);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1777;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_27434;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1778;
																																																																											BgL_auxz00_22101
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_27434);
																																																																										}
																																																																								}
																																																																						}
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1777;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_27438;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1778;
																																																																				BgL_auxz00_22101
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_27438);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd254164zd2_8117;
																																																																BgL_cdrzd254164zd2_8117
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd254171zd2_8118;
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_pairz00_13099;
																																																																		BgL_pairz00_13099
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		BgL_cdrzd254171zd2_8118
																																																																			=
																																																																			CDR
																																																																			(BgL_pairz00_13099);
																																																																	}
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd254178zd2_8119;
																																																																		BgL_cdrzd254178zd2_8119
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd254171zd2_8118));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_carzd254184zd2_8120;
																																																																			obj_t
																																																																				BgL_cdrzd254185zd2_8121;
																																																																			BgL_carzd254184zd2_8120
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd254178zd2_8119));
																																																																			BgL_cdrzd254185zd2_8121
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd254178zd2_8119));
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd254184zd2_8120))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_carzd254192zd2_8123;
																																																																					BgL_carzd254192zd2_8123
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd254185zd2_8121));
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd254192zd2_8123))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (NULLP(CDR(((obj_t) BgL_cdrzd254185zd2_8121))))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd254164zd2_8117))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_arg6429z00_8128;
																																																																											BgL_arg6429z00_8128
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd254171zd2_8118));
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_27465;
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_27469;
																																																																													obj_t
																																																																														BgL_proc2z00_27468;
																																																																													obj_t
																																																																														BgL_proc1z00_27467;
																																																																													obj_t
																																																																														BgL_testz00_27466;
																																																																													BgL_testz00_27466
																																																																														=
																																																																														BgL_arg6429z00_8128;
																																																																													BgL_proc1z00_27467
																																																																														=
																																																																														BgL_carzd254184zd2_8120;
																																																																													BgL_proc2z00_27468
																																																																														=
																																																																														BgL_carzd254192zd2_8123;
																																																																													BgL_argsz00_27469
																																																																														=
																																																																														BgL_cdrzd254164zd2_8117;
																																																																													BgL_argsz00_1752
																																																																														=
																																																																														BgL_argsz00_27469;
																																																																													BgL_proc2z00_1751
																																																																														=
																																																																														BgL_proc2z00_27468;
																																																																													BgL_proc1z00_1750
																																																																														=
																																																																														BgL_proc1z00_27467;
																																																																													BgL_testz00_1749
																																																																														=
																																																																														BgL_testz00_27466;
																																																																													goto
																																																																														BgL_tagzd2388zd2_1753;
																																																																												}
																																																																												BgL_auxz00_22101
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_27465);
																																																																											}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1777;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_27473;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1778;
																																																																													BgL_auxz00_22101
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_27473);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1777;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_27477;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1778;
																																																																											BgL_auxz00_22101
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_27477);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1777;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_27481;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1778;
																																																																									BgL_auxz00_22101
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_27481);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1777;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_27485;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1778;
																																																																							BgL_auxz00_22101
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_27485);
																																																																						}
																																																																				}
																																																																		}
																																																																	}
																																																																}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 119 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1777;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_27489;
																																																																goto
																																																																	BgL_tagzd2404zd2_1778;
																																																																BgL_auxz00_22101
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_27489);
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd254525zd2_8136;
																																																												BgL_cdrzd254525zd2_8136
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd254531zd2_8137;
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_pairz00_13109;
																																																														BgL_pairz00_13109
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														BgL_cdrzd254531zd2_8137
																																																															=
																																																															CDR
																																																															(BgL_pairz00_13109);
																																																													}
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd254537zd2_8138;
																																																														BgL_cdrzd254537zd2_8138
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd254531zd2_8137));
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_carzd254542zd2_8139;
																																																															obj_t
																																																																BgL_cdrzd254543zd2_8140;
																																																															BgL_carzd254542zd2_8139
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd254537zd2_8138));
																																																															BgL_cdrzd254543zd2_8140
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd254537zd2_8138));
																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd254542zd2_8139))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (PAIRP(BgL_cdrzd254543zd2_8140))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_carzd254548zd2_8143;
																																																																			BgL_carzd254548zd2_8143
																																																																				=
																																																																				CAR
																																																																				(BgL_cdrzd254543zd2_8140);
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd254548zd2_8143))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (NULLP(CDR(BgL_cdrzd254543zd2_8140)))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd254525zd2_8136))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_arg6443z00_8148;
																																																																									BgL_arg6443z00_8148
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd254531zd2_8137));
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_27516;
																																																																										{
																																																																											obj_t
																																																																												BgL_argsz00_27520;
																																																																											obj_t
																																																																												BgL_proc2z00_27519;
																																																																											obj_t
																																																																												BgL_proc1z00_27518;
																																																																											obj_t
																																																																												BgL_testz00_27517;
																																																																											BgL_testz00_27517
																																																																												=
																																																																												BgL_arg6443z00_8148;
																																																																											BgL_proc1z00_27518
																																																																												=
																																																																												BgL_carzd254542zd2_8139;
																																																																											BgL_proc2z00_27519
																																																																												=
																																																																												BgL_carzd254548zd2_8143;
																																																																											BgL_argsz00_27520
																																																																												=
																																																																												BgL_cdrzd254525zd2_8136;
																																																																											BgL_argsz00_1752
																																																																												=
																																																																												BgL_argsz00_27520;
																																																																											BgL_proc2z00_1751
																																																																												=
																																																																												BgL_proc2z00_27519;
																																																																											BgL_proc1z00_1750
																																																																												=
																																																																												BgL_proc1z00_27518;
																																																																											BgL_testz00_1749
																																																																												=
																																																																												BgL_testz00_27517;
																																																																											goto
																																																																												BgL_tagzd2388zd2_1753;
																																																																										}
																																																																										BgL_auxz00_22101
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_27516);
																																																																									}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1777;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_27524;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1778;
																																																																											BgL_auxz00_22101
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_27524);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1777;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_27528;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1778;
																																																																									BgL_auxz00_22101
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_27528);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1777;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_27532;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1778;
																																																																							BgL_auxz00_22101
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_27532);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1777;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_27536;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1778;
																																																																					BgL_auxz00_22101
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_27536);
																																																																				}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1777;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_27540;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1778;
																																																																			BgL_auxz00_22101
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_27540);
																																																																		}
																																																																}
																																																														}
																																																													}
																																																												}
																																																											}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 119 */
																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																											{	/* Ast/sexp.scm 119 */
																																																												goto
																																																													BgL_tagzd2403zd2_1777;
																																																											}
																																																										else
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_27544;
																																																												goto
																																																													BgL_tagzd2404zd2_1778;
																																																												BgL_auxz00_22101
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_27544);
																																																											}
																																																									}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																									{	/* Ast/sexp.scm 119 */
																																																										goto
																																																											BgL_tagzd2403zd2_1777;
																																																									}
																																																								else
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_27548;
																																																										goto
																																																											BgL_tagzd2404zd2_1778;
																																																										BgL_auxz00_22101
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_27548);
																																																									}
																																																							}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																							{	/* Ast/sexp.scm 119 */
																																																								goto
																																																									BgL_tagzd2403zd2_1777;
																																																							}
																																																						else
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_27552;
																																																								goto
																																																									BgL_tagzd2404zd2_1778;
																																																								BgL_auxz00_22101
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_27552);
																																																							}
																																																					}
																																																			}
																																																		}
																																																}
																																															}
																																													}
																																											}
																																									}
																																							}
																																					}
																																			}
																																		}
																																	else
																																		{	/* Ast/sexp.scm 119 */
																																			if (
																																				(BgL_carzd252073zd2_8040
																																					==
																																					CNST_TABLE_REF
																																					(((long) 20))))
																																				{
																																					BgL_nodez00_bglt
																																						BgL_auxz00_27557;
																																					goto
																																						BgL_tagzd2383zd2_1734;
																																					BgL_auxz00_22101
																																						=
																																						(
																																						(obj_t)
																																						BgL_auxz00_27557);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					obj_t
																																						BgL_carzd255110zd2_8294;
																																					BgL_carzd255110zd2_8294
																																						=
																																						CAR(
																																						((obj_t) BgL_expz00_21));
																																					if (
																																						(BgL_carzd255110zd2_8294
																																							==
																																							CNST_TABLE_REF
																																							(((long) 19))))
																																						{
																																							BgL_letzd2funzd2_bglt
																																								BgL_auxz00_27564;
																																							goto
																																								BgL_tagzd2384zd2_1735;
																																							BgL_auxz00_22101
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_27564);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd255110zd2_8294)))
																																								{
																																									BgL_letzd2funzd2_bglt
																																										BgL_auxz00_27569;
																																									goto
																																										BgL_tagzd2384zd2_1735;
																																									BgL_auxz00_22101
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_27569);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_27576;
																																											goto
																																												BgL_tagzd2389zd2_1754;
																																											BgL_auxz00_22101
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_27576);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_27583;
																																													goto
																																														BgL_tagzd2390zd2_1755;
																																													BgL_auxz00_22101
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_27583);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_27590;
																																															goto
																																																BgL_tagzd2392zd2_1759;
																																															BgL_auxz00_22101
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_27590);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_27597;
																																																	goto
																																																		BgL_tagzd2393zd2_1760;
																																																	BgL_auxz00_22101
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_27597);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_27604;
																																																			goto
																																																				BgL_tagzd2395zd2_1764;
																																																			BgL_auxz00_22101
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_27604);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_27611;
																																																					goto
																																																						BgL_tagzd2396zd2_1765;
																																																					BgL_auxz00_22101
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_27611);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_27618;
																																																							goto
																																																								BgL_tagzd2397zd2_1766;
																																																							BgL_auxz00_22101
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_27618);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																								{
																																																									BgL_jumpzd2exzd2itz00_bglt
																																																										BgL_auxz00_27625;
																																																									goto
																																																										BgL_tagzd2398zd2_1767;
																																																									BgL_auxz00_22101
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_27625);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (BGl_equalzf3zf3zz__r4_equivalence_6_2z00(CAR(((obj_t) BgL_expz00_21)), BUNSPEC))
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (NULLP(CDR(((obj_t) BgL_expz00_21))))
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_27635;
																																																													goto
																																																														BgL_tagzd2402zd2_1776;
																																																													BgL_auxz00_22101
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_27635);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{	/* Ast/sexp.scm 119 */
																																																															goto
																																																																BgL_tagzd2403zd2_1777;
																																																														}
																																																													else
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_27639;
																																																															goto
																																																																BgL_tagzd2404zd2_1778;
																																																															BgL_auxz00_22101
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_27639);
																																																														}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{	/* Ast/sexp.scm 119 */
																																																													goto
																																																														BgL_tagzd2403zd2_1777;
																																																												}
																																																											else
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_27643;
																																																													goto
																																																														BgL_tagzd2404zd2_1778;
																																																													BgL_auxz00_22101
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_27643);
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																										}
																								}
																							return
																								((BgL_nodez00_bglt)
																								BgL_auxz00_22101);
																						}
																					else
																						{	/* Ast/sexp.scm 119 */
																							if (
																								(BgL_carzd231447zd2_5081 ==
																									BGl_za2ifza2z00zzast_sexpz00))
																								{
																									obj_t BgL_auxz00_27648;

																									goto BgL_kapzd231449zd2_5083;
																									return
																										((BgL_nodez00_bglt)
																										BgL_auxz00_27648);
																								}
																							else
																								{	/* Ast/sexp.scm 119 */
																									bool_t BgL_test10226z00_27650;

																									{	/* Ast/sexp.scm 119 */
																										obj_t BgL_arg4808z00_5828;

																										BgL_arg4808z00_5828 =
																											CAR(BgL_expz00_21);
																										BgL_test10226z00_27650 =
																											(BgL_arg4808z00_5828 ==
																											BGl_za2ifza2z00zzast_sexpz00);
																									}
																									if (BgL_test10226z00_27650)
																										{	/* Ast/sexp.scm 119 */
																											goto
																												BgL_tagzd2377zd2_1722;
																										}
																									else
																										{	/* Ast/sexp.scm 119 */
																											obj_t
																												BgL_cdrzd255282zd2_5088;
																											BgL_cdrzd255282zd2_5088 =
																												CDR(BgL_expz00_21);
																											if ((CAR(BgL_expz00_21) ==
																													CNST_TABLE_REF(((long)
																															7))))
																												{	/* Ast/sexp.scm 119 */
																													if (PAIRP
																														(BgL_cdrzd255282zd2_5088))
																														{	/* Ast/sexp.scm 119 */
																															obj_t
																																BgL_carzd255285zd2_5092;
																															obj_t
																																BgL_cdrzd255286zd2_5093;
																															BgL_carzd255285zd2_5092
																																=
																																CAR
																																(BgL_cdrzd255282zd2_5088);
																															BgL_cdrzd255286zd2_5093
																																=
																																CDR
																																(BgL_cdrzd255282zd2_5088);
																															if (PAIRP
																																(BgL_carzd255285zd2_5092))
																																{	/* Ast/sexp.scm 119 */
																																	if (
																																		(CAR
																																			(BgL_carzd255285zd2_5092)
																																			==
																																			CNST_TABLE_REF
																																			(((long)
																																					14))))
																																		{	/* Ast/sexp.scm 119 */
																																			if (PAIRP
																																				(BgL_cdrzd255286zd2_5093))
																																				{	/* Ast/sexp.scm 119 */
																																					if (NULLP(CDR(BgL_cdrzd255286zd2_5093)))
																																						{
																																							obj_t
																																								BgL_valz00_27675;
																																							obj_t
																																								BgL_lz00_27673;
																																							BgL_lz00_27673
																																								=
																																								CDR
																																								(BgL_carzd255285zd2_5092);
																																							BgL_valz00_27675
																																								=
																																								CAR
																																								(BgL_cdrzd255286zd2_5093);
																																							BgL_valz00_1724
																																								=
																																								BgL_valz00_27675;
																																							BgL_lz00_1723
																																								=
																																								BgL_lz00_27673;
																																							goto
																																								BgL_tagzd2378zd2_1725;
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							goto
																																								BgL_tagzd2379zd2_1726;
																																						}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					goto
																																						BgL_tagzd2379zd2_1726;
																																				}
																																		}
																																	else
																																		{	/* Ast/sexp.scm 119 */
																																			goto
																																				BgL_tagzd2379zd2_1726;
																																		}
																																}
																															else
																																{	/* Ast/sexp.scm 119 */
																																	goto
																																		BgL_tagzd2379zd2_1726;
																																}
																														}
																													else
																														{	/* Ast/sexp.scm 119 */
																															goto
																																BgL_tagzd2379zd2_1726;
																														}
																												}
																											else
																												{	/* Ast/sexp.scm 119 */
																													if (
																														(CAR(BgL_expz00_21)
																															==
																															CNST_TABLE_REF((
																																	(long) 16))))
																														{	/* Ast/sexp.scm 119 */
																															goto
																																BgL_tagzd2380zd2_1727;
																														}
																													else
																														{	/* Ast/sexp.scm 119 */
																															obj_t
																																BgL_carzd255411zd2_5106;
																															BgL_carzd255411zd2_5106
																																=
																																CAR
																																(BgL_expz00_21);
																															if (PAIRP
																																(BgL_carzd255411zd2_5106))
																																{	/* Ast/sexp.scm 119 */
																																	obj_t
																																		BgL_carzd255414zd2_5108;
																																	obj_t
																																		BgL_cdrzd255415zd2_5109;
																																	BgL_carzd255414zd2_5108
																																		=
																																		CAR
																																		(BgL_carzd255411zd2_5106);
																																	BgL_cdrzd255415zd2_5109
																																		=
																																		CDR
																																		(BgL_carzd255411zd2_5106);
																																	{

																																		if (
																																			(BgL_carzd255414zd2_5108
																																				==
																																				CNST_TABLE_REF
																																				(((long)
																																						17))))
																																			{
																																				obj_t
																																					BgL_auxz00_27689;
																																			BgL_kapzd255416zd2_5110:
																																				if (PAIRP(BgL_cdrzd255415zd2_5109))
																																					{	/* Ast/sexp.scm 119 */
																																						obj_t
																																							BgL_cdrzd255419zd2_5412;
																																						BgL_cdrzd255419zd2_5412
																																							=
																																							CDR
																																							(BgL_cdrzd255415zd2_5109);
																																						if (PAIRP(BgL_cdrzd255419zd2_5412))
																																							{	/* Ast/sexp.scm 119 */
																																								if (NULLP(CDR(BgL_cdrzd255419zd2_5412)))
																																									{	/* Ast/sexp.scm 119 */
																																										obj_t
																																											BgL_arg4505z00_5416;
																																										obj_t
																																											BgL_arg4506z00_5417;
																																										BgL_arg4505z00_5416
																																											=
																																											CAR
																																											(BgL_cdrzd255419zd2_5412);
																																										BgL_arg4506z00_5417
																																											=
																																											CDR
																																											(
																																											((obj_t) BgL_expz00_21));
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_27701;
																																											{
																																												obj_t
																																													BgL_argsz00_27703;
																																												obj_t
																																													BgL_bodyz00_27702;
																																												BgL_bodyz00_27702
																																													=
																																													BgL_arg4505z00_5416;
																																												BgL_argsz00_27703
																																													=
																																													BgL_arg4506z00_5417;
																																												BgL_argsz00_1729
																																													=
																																													BgL_argsz00_27703;
																																												BgL_bodyz00_1728
																																													=
																																													BgL_bodyz00_27702;
																																												goto
																																													BgL_tagzd2381zd2_1730;
																																											}
																																											BgL_auxz00_27689
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_27701);
																																										}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 119 */
																																										obj_t
																																											BgL_cdrzd255442zd2_5418;
																																										BgL_cdrzd255442zd2_5418
																																											=
																																											CDR
																																											(
																																											((obj_t) BgL_expz00_21));
																																										{

																																											{	/* Ast/sexp.scm 119 */
																																												bool_t
																																													BgL_test10239z00_27707;
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_arg4573z00_5528;
																																													BgL_arg4573z00_5528
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													BgL_test10239z00_27707
																																														=
																																														CBOOL
																																														(BGl_letzd2symzf3z21zzast_letz00
																																														(BgL_arg4573z00_5528));
																																												}
																																												if (BgL_test10239z00_27707)
																																													{	/* Ast/sexp.scm 119 */
																																														if (PAIRP(BgL_cdrzd255442zd2_5418))
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_arg4575z00_5530;
																																																obj_t
																																																	BgL_arg4576z00_5531;
																																																BgL_arg4575z00_5530
																																																	=
																																																	CAR
																																																	(BgL_cdrzd255442zd2_5418);
																																																BgL_arg4576z00_5531
																																																	=
																																																	CDR
																																																	(BgL_cdrzd255442zd2_5418);
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_27716;
																																																	{
																																																		obj_t
																																																			BgL_exprz00_27718;
																																																		obj_t
																																																			BgL_bindingsz00_27717;
																																																		BgL_bindingsz00_27717
																																																			=
																																																			BgL_arg4575z00_5530;
																																																		BgL_exprz00_27718
																																																			=
																																																			BgL_arg4576z00_5531;
																																																		BgL_exprz00_1732
																																																			=
																																																			BgL_exprz00_27718;
																																																		BgL_bindingsz00_1731
																																																			=
																																																			BgL_bindingsz00_27717;
																																																		goto
																																																			BgL_tagzd2382zd2_1733;
																																																	}
																																																	BgL_auxz00_27689
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_27716);
																																																}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																bool_t
																																																	BgL_test10241z00_27720;
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg4640z00_5637;
																																																	BgL_arg4640z00_5637
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	BgL_test10241z00_27720
																																																		=
																																																		CBOOL
																																																		(BGl_labelszd2symzf3z21zzast_labelsz00
																																																		(BgL_arg4640z00_5637));
																																																}
																																																if (BgL_test10241z00_27720)
																																																	{
																																																		BgL_letzd2funzd2_bglt
																																																			BgL_auxz00_27725;
																																																		goto
																																																			BgL_tagzd2384zd2_1735;
																																																		BgL_auxz00_27689
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_27725);
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_carzd255506zd2_5534;
																																																		BgL_carzd255506zd2_5534
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_cdrzd255511zd2_5535;
																																																			BgL_cdrzd255511zd2_5535
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_carzd255506zd2_5534));
																																																			if ((CAR(((obj_t) BgL_carzd255506zd2_5534)) == CNST_TABLE_REF(((long) 3))))
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_arg4581z00_5538;
																																																					obj_t
																																																						BgL_arg4582z00_5539;
																																																					obj_t
																																																						BgL_arg4583z00_5540;
																																																					BgL_arg4581z00_5538
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd255511zd2_5535));
																																																					BgL_arg4582z00_5539
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd255511zd2_5535));
																																																					BgL_arg4583z00_5540
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_27742;
																																																						{
																																																							obj_t
																																																								BgL_argsz00_27745;
																																																							obj_t
																																																								BgL_bodyz00_27744;
																																																							obj_t
																																																								BgL_varsz00_27743;
																																																							BgL_varsz00_27743
																																																								=
																																																								BgL_arg4581z00_5538;
																																																							BgL_bodyz00_27744
																																																								=
																																																								BgL_arg4582z00_5539;
																																																							BgL_argsz00_27745
																																																								=
																																																								BgL_arg4583z00_5540;
																																																							BgL_argsz00_1742
																																																								=
																																																								BgL_argsz00_27745;
																																																							BgL_bodyz00_1741
																																																								=
																																																								BgL_bodyz00_27744;
																																																							BgL_varsz00_1740
																																																								=
																																																								BgL_varsz00_27743;
																																																							goto
																																																								BgL_tagzd2386zd2_1743;
																																																						}
																																																						BgL_auxz00_27689
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_27742);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_cdrzd255534zd2_5542;
																																																					BgL_cdrzd255534zd2_5542
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd255540zd2_5543;
																																																						BgL_cdrzd255540zd2_5543
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_carzd255506zd2_5534));
																																																						if ((CAR(((obj_t) BgL_carzd255506zd2_5534)) == CNST_TABLE_REF(((long) 1))))
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd255546zd2_5546;
																																																								BgL_cdrzd255546zd2_5546
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_cdrzd255540zd2_5543));
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_carzd255551zd2_5547;
																																																									obj_t
																																																										BgL_cdrzd255552zd2_5548;
																																																									BgL_carzd255551zd2_5547
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd255546zd2_5546));
																																																									BgL_cdrzd255552zd2_5548
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd255546zd2_5546));
																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd255551zd2_5547))
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (PAIRP(BgL_cdrzd255552zd2_5548))
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_carzd255559zd2_5551;
																																																													BgL_carzd255559zd2_5551
																																																														=
																																																														CAR
																																																														(BgL_cdrzd255552zd2_5548);
																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd255559zd2_5551))
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (NULLP(CDR(BgL_cdrzd255552zd2_5548)))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	bool_t
																																																																		BgL_test10248z00_27772;
																																																																	{
																																																																		obj_t
																																																																			BgL_l1462z00_5584;
																																																																		BgL_l1462z00_5584
																																																																			=
																																																																			BgL_cdrzd255534zd2_5542;
																																																																	BgL_zc3z04anonymousza34606ze3z87_5585:
																																																																		if (NULLP(BgL_l1462z00_5584))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				BgL_test10248z00_27772
																																																																					=
																																																																					(
																																																																					(bool_t)
																																																																					1);
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				bool_t
																																																																					BgL_test10250z00_27775;
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					bool_t
																																																																						BgL_test10251z00_27776;
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_tmpz00_27777;
																																																																						BgL_tmpz00_27777
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_l1462z00_5584));
																																																																						BgL_test10251z00_27776
																																																																							=
																																																																							PAIRP
																																																																							(BgL_tmpz00_27777);
																																																																					}
																																																																					if (BgL_test10251z00_27776)
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							BgL_test10250z00_27775
																																																																								=
																																																																								(
																																																																								(bool_t)
																																																																								0);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							BgL_test10250z00_27775
																																																																								=
																																																																								(
																																																																								(bool_t)
																																																																								1);
																																																																						}
																																																																				}
																																																																				if (BgL_test10250z00_27775)
																																																																					{
																																																																						obj_t
																																																																							BgL_l1462z00_27781;
																																																																						BgL_l1462z00_27781
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_l1462z00_5584));
																																																																						BgL_l1462z00_5584
																																																																							=
																																																																							BgL_l1462z00_27781;
																																																																						goto
																																																																							BgL_zc3z04anonymousza34606ze3z87_5585;
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						BgL_test10248z00_27772
																																																																							=
																																																																							(
																																																																							(bool_t)
																																																																							0);
																																																																					}
																																																																			}
																																																																	}
																																																																	if (BgL_test10248z00_27772)
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_arg4596z00_5567;
																																																																			BgL_arg4596z00_5567
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd255540zd2_5543));
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_27786;
																																																																				{
																																																																					obj_t
																																																																						BgL_argsz00_27790;
																																																																					obj_t
																																																																						BgL_proc2z00_27789;
																																																																					obj_t
																																																																						BgL_proc1z00_27788;
																																																																					obj_t
																																																																						BgL_testz00_27787;
																																																																					BgL_testz00_27787
																																																																						=
																																																																						BgL_arg4596z00_5567;
																																																																					BgL_proc1z00_27788
																																																																						=
																																																																						BgL_carzd255551zd2_5547;
																																																																					BgL_proc2z00_27789
																																																																						=
																																																																						BgL_carzd255559zd2_5551;
																																																																					BgL_argsz00_27790
																																																																						=
																																																																						BgL_cdrzd255534zd2_5542;
																																																																					BgL_argsz00_1747
																																																																						=
																																																																						BgL_argsz00_27790;
																																																																					BgL_proc2z00_1746
																																																																						=
																																																																						BgL_proc2z00_27789;
																																																																					BgL_proc1z00_1745
																																																																						=
																																																																						BgL_proc1z00_27788;
																																																																					BgL_testz00_1744
																																																																						=
																																																																						BgL_testz00_27787;
																																																																					goto
																																																																						BgL_tagzd2387zd2_1748;
																																																																				}
																																																																				BgL_auxz00_27689
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_27786);
																																																																			}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd255583zd2_5568;
																																																																			BgL_cdrzd255583zd2_5568
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_expz00_21));
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd255590zd2_5569;
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_pairz00_13185;
																																																																					BgL_pairz00_13185
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					BgL_cdrzd255590zd2_5569
																																																																						=
																																																																						CDR
																																																																						(BgL_pairz00_13185);
																																																																				}
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd255597zd2_5570;
																																																																					BgL_cdrzd255597zd2_5570
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd255590zd2_5569));
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_carzd255603zd2_5571;
																																																																						BgL_carzd255603zd2_5571
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd255597zd2_5570));
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd255603zd2_5571))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_carzd255610zd2_5573;
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_pairz00_13189;
																																																																									BgL_pairz00_13189
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd255597zd2_5570));
																																																																									BgL_carzd255610zd2_5573
																																																																										=
																																																																										CAR
																																																																										(BgL_pairz00_13189);
																																																																								}
																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd255610zd2_5573))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd255583zd2_5568))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_arg4600z00_5576;
																																																																												BgL_arg4600z00_5576
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd255590zd2_5569));
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_27812;
																																																																													{
																																																																														obj_t
																																																																															BgL_argsz00_27816;
																																																																														obj_t
																																																																															BgL_proc2z00_27815;
																																																																														obj_t
																																																																															BgL_proc1z00_27814;
																																																																														obj_t
																																																																															BgL_testz00_27813;
																																																																														BgL_testz00_27813
																																																																															=
																																																																															BgL_arg4600z00_5576;
																																																																														BgL_proc1z00_27814
																																																																															=
																																																																															BgL_carzd255603zd2_5571;
																																																																														BgL_proc2z00_27815
																																																																															=
																																																																															BgL_carzd255610zd2_5573;
																																																																														BgL_argsz00_27816
																																																																															=
																																																																															BgL_cdrzd255583zd2_5568;
																																																																														BgL_argsz00_1752
																																																																															=
																																																																															BgL_argsz00_27816;
																																																																														BgL_proc2z00_1751
																																																																															=
																																																																															BgL_proc2z00_27815;
																																																																														BgL_proc1z00_1750
																																																																															=
																																																																															BgL_proc1z00_27814;
																																																																														BgL_testz00_1749
																																																																															=
																																																																															BgL_testz00_27813;
																																																																														goto
																																																																															BgL_tagzd2388zd2_1753;
																																																																													}
																																																																													BgL_auxz00_27689
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_27812);
																																																																												}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1777;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_27820;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1778;
																																																																														BgL_auxz00_27689
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_27820);
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1777;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_27824;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1778;
																																																																												BgL_auxz00_27689
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_27824);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1777;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_27828;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1778;
																																																																										BgL_auxz00_27689
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_27828);
																																																																									}
																																																																							}
																																																																					}
																																																																				}
																																																																			}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1777;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_27832;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1778;
																																																																			BgL_auxz00_27689
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_27832);
																																																																		}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd255886zd2_5595;
																																																															BgL_cdrzd255886zd2_5595
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd255892zd2_5596;
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_pairz00_13193;
																																																																	BgL_pairz00_13193
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	BgL_cdrzd255892zd2_5596
																																																																		=
																																																																		CDR
																																																																		(BgL_pairz00_13193);
																																																																}
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd255898zd2_5597;
																																																																	BgL_cdrzd255898zd2_5597
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd255892zd2_5596));
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_carzd255903zd2_5598;
																																																																		obj_t
																																																																			BgL_cdrzd255904zd2_5599;
																																																																		BgL_carzd255903zd2_5598
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd255898zd2_5597));
																																																																		BgL_cdrzd255904zd2_5599
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd255898zd2_5597));
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd255903zd2_5598))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_carzd255909zd2_5601;
																																																																				BgL_carzd255909zd2_5601
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd255904zd2_5599));
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd255909zd2_5601))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (NULLP(CDR(((obj_t) BgL_cdrzd255904zd2_5599))))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd255886zd2_5595))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_arg4615z00_5606;
																																																																										BgL_arg4615z00_5606
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd255892zd2_5596));
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_27859;
																																																																											{
																																																																												obj_t
																																																																													BgL_argsz00_27863;
																																																																												obj_t
																																																																													BgL_proc2z00_27862;
																																																																												obj_t
																																																																													BgL_proc1z00_27861;
																																																																												obj_t
																																																																													BgL_testz00_27860;
																																																																												BgL_testz00_27860
																																																																													=
																																																																													BgL_arg4615z00_5606;
																																																																												BgL_proc1z00_27861
																																																																													=
																																																																													BgL_carzd255903zd2_5598;
																																																																												BgL_proc2z00_27862
																																																																													=
																																																																													BgL_carzd255909zd2_5601;
																																																																												BgL_argsz00_27863
																																																																													=
																																																																													BgL_cdrzd255886zd2_5595;
																																																																												BgL_argsz00_1752
																																																																													=
																																																																													BgL_argsz00_27863;
																																																																												BgL_proc2z00_1751
																																																																													=
																																																																													BgL_proc2z00_27862;
																																																																												BgL_proc1z00_1750
																																																																													=
																																																																													BgL_proc1z00_27861;
																																																																												BgL_testz00_1749
																																																																													=
																																																																													BgL_testz00_27860;
																																																																												goto
																																																																													BgL_tagzd2388zd2_1753;
																																																																											}
																																																																											BgL_auxz00_27689
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_27859);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1777;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_27867;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1778;
																																																																												BgL_auxz00_27689
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_27867);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1777;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_27871;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1778;
																																																																										BgL_auxz00_27689
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_27871);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1777;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_27875;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1778;
																																																																								BgL_auxz00_27689
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_27875);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1777;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_27879;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1778;
																																																																						BgL_auxz00_27689
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_27879);
																																																																					}
																																																																			}
																																																																	}
																																																																}
																																																															}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{	/* Ast/sexp.scm 119 */
																																																															goto
																																																																BgL_tagzd2403zd2_1777;
																																																														}
																																																													else
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_27883;
																																																															goto
																																																																BgL_tagzd2404zd2_1778;
																																																															BgL_auxz00_27689
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_27883);
																																																														}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_cdrzd256242zd2_5614;
																																																											BgL_cdrzd256242zd2_5614
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd256249zd2_5615;
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_pairz00_13203;
																																																													BgL_pairz00_13203
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													BgL_cdrzd256249zd2_5615
																																																														=
																																																														CDR
																																																														(BgL_pairz00_13203);
																																																												}
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd256256zd2_5616;
																																																													BgL_cdrzd256256zd2_5616
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd256249zd2_5615));
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_carzd256262zd2_5617;
																																																														obj_t
																																																															BgL_cdrzd256263zd2_5618;
																																																														BgL_carzd256262zd2_5617
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd256256zd2_5616));
																																																														BgL_cdrzd256263zd2_5618
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd256256zd2_5616));
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd256262zd2_5617))
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (PAIRP(BgL_cdrzd256263zd2_5618))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_carzd256270zd2_5621;
																																																																		BgL_carzd256270zd2_5621
																																																																			=
																																																																			CAR
																																																																			(BgL_cdrzd256263zd2_5618);
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd256270zd2_5621))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (NULLP(CDR(BgL_cdrzd256263zd2_5618)))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd256242zd2_5614))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_arg4629z00_5626;
																																																																								BgL_arg4629z00_5626
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd256249zd2_5615));
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_27910;
																																																																									{
																																																																										obj_t
																																																																											BgL_argsz00_27914;
																																																																										obj_t
																																																																											BgL_proc2z00_27913;
																																																																										obj_t
																																																																											BgL_proc1z00_27912;
																																																																										obj_t
																																																																											BgL_testz00_27911;
																																																																										BgL_testz00_27911
																																																																											=
																																																																											BgL_arg4629z00_5626;
																																																																										BgL_proc1z00_27912
																																																																											=
																																																																											BgL_carzd256262zd2_5617;
																																																																										BgL_proc2z00_27913
																																																																											=
																																																																											BgL_carzd256270zd2_5621;
																																																																										BgL_argsz00_27914
																																																																											=
																																																																											BgL_cdrzd256242zd2_5614;
																																																																										BgL_argsz00_1752
																																																																											=
																																																																											BgL_argsz00_27914;
																																																																										BgL_proc2z00_1751
																																																																											=
																																																																											BgL_proc2z00_27913;
																																																																										BgL_proc1z00_1750
																																																																											=
																																																																											BgL_proc1z00_27912;
																																																																										BgL_testz00_1749
																																																																											=
																																																																											BgL_testz00_27911;
																																																																										goto
																																																																											BgL_tagzd2388zd2_1753;
																																																																									}
																																																																									BgL_auxz00_27689
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_27910);
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1777;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_27918;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1778;
																																																																										BgL_auxz00_27689
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_27918);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1777;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_27922;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1778;
																																																																								BgL_auxz00_27689
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_27922);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1777;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_27926;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1778;
																																																																						BgL_auxz00_27689
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_27926);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1777;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_27930;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1778;
																																																																				BgL_auxz00_27689
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_27930);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1777;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_27934;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1778;
																																																																		BgL_auxz00_27689
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_27934);
																																																																	}
																																																															}
																																																													}
																																																												}
																																																											}
																																																										}
																																																								}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																									{	/* Ast/sexp.scm 119 */
																																																										goto
																																																											BgL_tagzd2403zd2_1777;
																																																									}
																																																								else
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_27938;
																																																										goto
																																																											BgL_tagzd2404zd2_1778;
																																																										BgL_auxz00_27689
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_27938);
																																																									}
																																																							}
																																																					}
																																																				}
																																																		}
																																																	}
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														bool_t
																																															BgL_test10279z00_27940;
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg4572z00_5527;
																																															BgL_arg4572z00_5527
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															BgL_test10279z00_27940
																																																=
																																																CBOOL
																																																(BGl_labelszd2symzf3z21zzast_labelsz00
																																																(BgL_arg4572z00_5527));
																																														}
																																														if (BgL_test10279z00_27940)
																																															{
																																																BgL_letzd2funzd2_bglt
																																																	BgL_auxz00_27945;
																																																goto
																																																	BgL_tagzd2384zd2_1735;
																																																BgL_auxz00_27689
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_27945);
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_carzd256702zd2_5424;
																																																BgL_carzd256702zd2_5424
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_cdrzd256707zd2_5425;
																																																	BgL_cdrzd256707zd2_5425
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_carzd256702zd2_5424));
																																																	if ((CAR(((obj_t) BgL_carzd256702zd2_5424)) == CNST_TABLE_REF(((long) 3))))
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg4513z00_5428;
																																																			obj_t
																																																				BgL_arg4514z00_5429;
																																																			obj_t
																																																				BgL_arg4515z00_5430;
																																																			BgL_arg4513z00_5428
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd256707zd2_5425));
																																																			BgL_arg4514z00_5429
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd256707zd2_5425));
																																																			BgL_arg4515z00_5430
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_27962;
																																																				{
																																																					obj_t
																																																						BgL_argsz00_27965;
																																																					obj_t
																																																						BgL_bodyz00_27964;
																																																					obj_t
																																																						BgL_varsz00_27963;
																																																					BgL_varsz00_27963
																																																						=
																																																						BgL_arg4513z00_5428;
																																																					BgL_bodyz00_27964
																																																						=
																																																						BgL_arg4514z00_5429;
																																																					BgL_argsz00_27965
																																																						=
																																																						BgL_arg4515z00_5430;
																																																					BgL_argsz00_1742
																																																						=
																																																						BgL_argsz00_27965;
																																																					BgL_bodyz00_1741
																																																						=
																																																						BgL_bodyz00_27964;
																																																					BgL_varsz00_1740
																																																						=
																																																						BgL_varsz00_27963;
																																																					goto
																																																						BgL_tagzd2386zd2_1743;
																																																				}
																																																				BgL_auxz00_27689
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_27962);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_cdrzd256730zd2_5432;
																																																			BgL_cdrzd256730zd2_5432
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd256736zd2_5433;
																																																				BgL_cdrzd256736zd2_5433
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_carzd256702zd2_5424));
																																																				if ((CAR(((obj_t) BgL_carzd256702zd2_5424)) == CNST_TABLE_REF(((long) 1))))
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd256742zd2_5436;
																																																						BgL_cdrzd256742zd2_5436
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_cdrzd256736zd2_5433));
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_carzd256747zd2_5437;
																																																							obj_t
																																																								BgL_cdrzd256748zd2_5438;
																																																							BgL_carzd256747zd2_5437
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd256742zd2_5436));
																																																							BgL_cdrzd256748zd2_5438
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd256742zd2_5436));
																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd256747zd2_5437))
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (PAIRP(BgL_cdrzd256748zd2_5438))
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_carzd256755zd2_5441;
																																																											BgL_carzd256755zd2_5441
																																																												=
																																																												CAR
																																																												(BgL_cdrzd256748zd2_5438);
																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd256755zd2_5441))
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (NULLP(CDR(BgL_cdrzd256748zd2_5438)))
																																																														{	/* Ast/sexp.scm 119 */
																																																															bool_t
																																																																BgL_test10286z00_27992;
																																																															{
																																																																obj_t
																																																																	BgL_l1465z00_5474;
																																																																BgL_l1465z00_5474
																																																																	=
																																																																	BgL_cdrzd256730zd2_5432;
																																																															BgL_zc3z04anonymousza34538ze3z87_5475:
																																																																if (NULLP(BgL_l1465z00_5474))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		BgL_test10286z00_27992
																																																																			=
																																																																			(
																																																																			(bool_t)
																																																																			1);
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		bool_t
																																																																			BgL_test10288z00_27995;
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			bool_t
																																																																				BgL_test10289z00_27996;
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_tmpz00_27997;
																																																																				BgL_tmpz00_27997
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_l1465z00_5474));
																																																																				BgL_test10289z00_27996
																																																																					=
																																																																					PAIRP
																																																																					(BgL_tmpz00_27997);
																																																																			}
																																																																			if (BgL_test10289z00_27996)
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					BgL_test10288z00_27995
																																																																						=
																																																																						(
																																																																						(bool_t)
																																																																						0);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					BgL_test10288z00_27995
																																																																						=
																																																																						(
																																																																						(bool_t)
																																																																						1);
																																																																				}
																																																																		}
																																																																		if (BgL_test10288z00_27995)
																																																																			{
																																																																				obj_t
																																																																					BgL_l1465z00_28001;
																																																																				BgL_l1465z00_28001
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_l1465z00_5474));
																																																																				BgL_l1465z00_5474
																																																																					=
																																																																					BgL_l1465z00_28001;
																																																																				goto
																																																																					BgL_zc3z04anonymousza34538ze3z87_5475;
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				BgL_test10286z00_27992
																																																																					=
																																																																					(
																																																																					(bool_t)
																																																																					0);
																																																																			}
																																																																	}
																																																															}
																																																															if (BgL_test10286z00_27992)
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_arg4528z00_5457;
																																																																	BgL_arg4528z00_5457
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd256736zd2_5433));
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_28006;
																																																																		{
																																																																			obj_t
																																																																				BgL_argsz00_28010;
																																																																			obj_t
																																																																				BgL_proc2z00_28009;
																																																																			obj_t
																																																																				BgL_proc1z00_28008;
																																																																			obj_t
																																																																				BgL_testz00_28007;
																																																																			BgL_testz00_28007
																																																																				=
																																																																				BgL_arg4528z00_5457;
																																																																			BgL_proc1z00_28008
																																																																				=
																																																																				BgL_carzd256747zd2_5437;
																																																																			BgL_proc2z00_28009
																																																																				=
																																																																				BgL_carzd256755zd2_5441;
																																																																			BgL_argsz00_28010
																																																																				=
																																																																				BgL_cdrzd256730zd2_5432;
																																																																			BgL_argsz00_1747
																																																																				=
																																																																				BgL_argsz00_28010;
																																																																			BgL_proc2z00_1746
																																																																				=
																																																																				BgL_proc2z00_28009;
																																																																			BgL_proc1z00_1745
																																																																				=
																																																																				BgL_proc1z00_28008;
																																																																			BgL_testz00_1744
																																																																				=
																																																																				BgL_testz00_28007;
																																																																			goto
																																																																				BgL_tagzd2387zd2_1748;
																																																																		}
																																																																		BgL_auxz00_27689
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_28006);
																																																																	}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd256779zd2_5458;
																																																																	BgL_cdrzd256779zd2_5458
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd256786zd2_5459;
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_pairz00_13238;
																																																																			BgL_pairz00_13238
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_expz00_21));
																																																																			BgL_cdrzd256786zd2_5459
																																																																				=
																																																																				CDR
																																																																				(BgL_pairz00_13238);
																																																																		}
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd256793zd2_5460;
																																																																			BgL_cdrzd256793zd2_5460
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd256786zd2_5459));
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_carzd256799zd2_5461;
																																																																				BgL_carzd256799zd2_5461
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd256793zd2_5460));
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd256799zd2_5461))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_carzd256806zd2_5463;
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_pairz00_13242;
																																																																							BgL_pairz00_13242
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd256793zd2_5460));
																																																																							BgL_carzd256806zd2_5463
																																																																								=
																																																																								CAR
																																																																								(BgL_pairz00_13242);
																																																																						}
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd256806zd2_5463))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd256779zd2_5458))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_arg4532z00_5466;
																																																																										BgL_arg4532z00_5466
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd256786zd2_5459));
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_28032;
																																																																											{
																																																																												obj_t
																																																																													BgL_argsz00_28036;
																																																																												obj_t
																																																																													BgL_proc2z00_28035;
																																																																												obj_t
																																																																													BgL_proc1z00_28034;
																																																																												obj_t
																																																																													BgL_testz00_28033;
																																																																												BgL_testz00_28033
																																																																													=
																																																																													BgL_arg4532z00_5466;
																																																																												BgL_proc1z00_28034
																																																																													=
																																																																													BgL_carzd256799zd2_5461;
																																																																												BgL_proc2z00_28035
																																																																													=
																																																																													BgL_carzd256806zd2_5463;
																																																																												BgL_argsz00_28036
																																																																													=
																																																																													BgL_cdrzd256779zd2_5458;
																																																																												BgL_argsz00_1752
																																																																													=
																																																																													BgL_argsz00_28036;
																																																																												BgL_proc2z00_1751
																																																																													=
																																																																													BgL_proc2z00_28035;
																																																																												BgL_proc1z00_1750
																																																																													=
																																																																													BgL_proc1z00_28034;
																																																																												BgL_testz00_1749
																																																																													=
																																																																													BgL_testz00_28033;
																																																																												goto
																																																																													BgL_tagzd2388zd2_1753;
																																																																											}
																																																																											BgL_auxz00_27689
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_28032);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1777;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_28040;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1778;
																																																																												BgL_auxz00_27689
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_28040);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1777;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_28044;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1778;
																																																																										BgL_auxz00_27689
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_28044);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1777;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_28048;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1778;
																																																																								BgL_auxz00_27689
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_28048);
																																																																							}
																																																																					}
																																																																			}
																																																																		}
																																																																	}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1777;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_28052;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1778;
																																																																	BgL_auxz00_27689
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_28052);
																																																																}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd257082zd2_5485;
																																																													BgL_cdrzd257082zd2_5485
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd257088zd2_5486;
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_pairz00_13246;
																																																															BgL_pairz00_13246
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															BgL_cdrzd257088zd2_5486
																																																																=
																																																																CDR
																																																																(BgL_pairz00_13246);
																																																														}
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd257094zd2_5487;
																																																															BgL_cdrzd257094zd2_5487
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd257088zd2_5486));
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_carzd257099zd2_5488;
																																																																obj_t
																																																																	BgL_cdrzd257100zd2_5489;
																																																																BgL_carzd257099zd2_5488
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd257094zd2_5487));
																																																																BgL_cdrzd257100zd2_5489
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd257094zd2_5487));
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd257099zd2_5488))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_carzd257105zd2_5491;
																																																																		BgL_carzd257105zd2_5491
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd257100zd2_5489));
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd257105zd2_5491))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (NULLP(CDR(((obj_t) BgL_cdrzd257100zd2_5489))))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd257082zd2_5485))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_arg4547z00_5496;
																																																																								BgL_arg4547z00_5496
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd257088zd2_5486));
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_28079;
																																																																									{
																																																																										obj_t
																																																																											BgL_argsz00_28083;
																																																																										obj_t
																																																																											BgL_proc2z00_28082;
																																																																										obj_t
																																																																											BgL_proc1z00_28081;
																																																																										obj_t
																																																																											BgL_testz00_28080;
																																																																										BgL_testz00_28080
																																																																											=
																																																																											BgL_arg4547z00_5496;
																																																																										BgL_proc1z00_28081
																																																																											=
																																																																											BgL_carzd257099zd2_5488;
																																																																										BgL_proc2z00_28082
																																																																											=
																																																																											BgL_carzd257105zd2_5491;
																																																																										BgL_argsz00_28083
																																																																											=
																																																																											BgL_cdrzd257082zd2_5485;
																																																																										BgL_argsz00_1752
																																																																											=
																																																																											BgL_argsz00_28083;
																																																																										BgL_proc2z00_1751
																																																																											=
																																																																											BgL_proc2z00_28082;
																																																																										BgL_proc1z00_1750
																																																																											=
																																																																											BgL_proc1z00_28081;
																																																																										BgL_testz00_1749
																																																																											=
																																																																											BgL_testz00_28080;
																																																																										goto
																																																																											BgL_tagzd2388zd2_1753;
																																																																									}
																																																																									BgL_auxz00_27689
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_28079);
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1777;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_28087;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1778;
																																																																										BgL_auxz00_27689
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_28087);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1777;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_28091;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1778;
																																																																								BgL_auxz00_27689
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_28091);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1777;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_28095;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1778;
																																																																						BgL_auxz00_27689
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_28095);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1777;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_28099;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1778;
																																																																				BgL_auxz00_27689
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_28099);
																																																																			}
																																																																	}
																																																															}
																																																														}
																																																													}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{	/* Ast/sexp.scm 119 */
																																																													goto
																																																														BgL_tagzd2403zd2_1777;
																																																												}
																																																											else
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_28103;
																																																													goto
																																																														BgL_tagzd2404zd2_1778;
																																																													BgL_auxz00_27689
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_28103);
																																																												}
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_cdrzd257438zd2_5504;
																																																									BgL_cdrzd257438zd2_5504
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd257445zd2_5505;
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_pairz00_13256;
																																																											BgL_pairz00_13256
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											BgL_cdrzd257445zd2_5505
																																																												=
																																																												CDR
																																																												(BgL_pairz00_13256);
																																																										}
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_cdrzd257452zd2_5506;
																																																											BgL_cdrzd257452zd2_5506
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd257445zd2_5505));
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_carzd257458zd2_5507;
																																																												obj_t
																																																													BgL_cdrzd257459zd2_5508;
																																																												BgL_carzd257458zd2_5507
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd257452zd2_5506));
																																																												BgL_cdrzd257459zd2_5508
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd257452zd2_5506));
																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd257458zd2_5507))
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (PAIRP(BgL_cdrzd257459zd2_5508))
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_carzd257466zd2_5511;
																																																																BgL_carzd257466zd2_5511
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd257459zd2_5508);
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd257466zd2_5511))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (NULLP(CDR(BgL_cdrzd257459zd2_5508)))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd257438zd2_5504))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_arg4561z00_5516;
																																																																						BgL_arg4561z00_5516
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd257445zd2_5505));
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_28130;
																																																																							{
																																																																								obj_t
																																																																									BgL_argsz00_28134;
																																																																								obj_t
																																																																									BgL_proc2z00_28133;
																																																																								obj_t
																																																																									BgL_proc1z00_28132;
																																																																								obj_t
																																																																									BgL_testz00_28131;
																																																																								BgL_testz00_28131
																																																																									=
																																																																									BgL_arg4561z00_5516;
																																																																								BgL_proc1z00_28132
																																																																									=
																																																																									BgL_carzd257458zd2_5507;
																																																																								BgL_proc2z00_28133
																																																																									=
																																																																									BgL_carzd257466zd2_5511;
																																																																								BgL_argsz00_28134
																																																																									=
																																																																									BgL_cdrzd257438zd2_5504;
																																																																								BgL_argsz00_1752
																																																																									=
																																																																									BgL_argsz00_28134;
																																																																								BgL_proc2z00_1751
																																																																									=
																																																																									BgL_proc2z00_28133;
																																																																								BgL_proc1z00_1750
																																																																									=
																																																																									BgL_proc1z00_28132;
																																																																								BgL_testz00_1749
																																																																									=
																																																																									BgL_testz00_28131;
																																																																								goto
																																																																									BgL_tagzd2388zd2_1753;
																																																																							}
																																																																							BgL_auxz00_27689
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_28130);
																																																																						}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1777;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_28138;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1778;
																																																																								BgL_auxz00_27689
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_28138);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1777;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_28142;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1778;
																																																																						BgL_auxz00_27689
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_28142);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1777;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_28146;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1778;
																																																																				BgL_auxz00_27689
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_28146);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1777;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_28150;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1778;
																																																																		BgL_auxz00_27689
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_28150);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 119 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1777;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_28154;
																																																																goto
																																																																	BgL_tagzd2404zd2_1778;
																																																																BgL_auxz00_27689
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_28154);
																																																															}
																																																													}
																																																											}
																																																										}
																																																									}
																																																								}
																																																						}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																							{	/* Ast/sexp.scm 119 */
																																																								goto
																																																									BgL_tagzd2403zd2_1777;
																																																							}
																																																						else
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_28158;
																																																								goto
																																																									BgL_tagzd2404zd2_1778;
																																																								BgL_auxz00_27689
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_28158);
																																																							}
																																																					}
																																																			}
																																																		}
																																																}
																																															}
																																													}
																																											}
																																										}
																																									}
																																							}
																																						else
																																							{	/* Ast/sexp.scm 119 */
																																								obj_t
																																									BgL_cdrzd257858zd2_5639;
																																								BgL_cdrzd257858zd2_5639
																																									=
																																									CDR
																																									(
																																									((obj_t) BgL_expz00_21));
																																								{

																																									{	/* Ast/sexp.scm 119 */
																																										bool_t
																																											BgL_test10317z00_28162;
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_arg4654z00_5655;
																																											BgL_arg4654z00_5655
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_expz00_21));
																																											BgL_test10317z00_28162
																																												=
																																												CBOOL
																																												(BGl_letzd2symzf3z21zzast_letz00
																																												(BgL_arg4654z00_5655));
																																										}
																																										if (BgL_test10317z00_28162)
																																											{	/* Ast/sexp.scm 119 */
																																												if (PAIRP(BgL_cdrzd257858zd2_5639))
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_arg4656z00_5657;
																																														obj_t
																																															BgL_arg4657z00_5658;
																																														BgL_arg4656z00_5657
																																															=
																																															CAR
																																															(BgL_cdrzd257858zd2_5639);
																																														BgL_arg4657z00_5658
																																															=
																																															CDR
																																															(BgL_cdrzd257858zd2_5639);
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_28171;
																																															{
																																																obj_t
																																																	BgL_exprz00_28173;
																																																obj_t
																																																	BgL_bindingsz00_28172;
																																																BgL_bindingsz00_28172
																																																	=
																																																	BgL_arg4656z00_5657;
																																																BgL_exprz00_28173
																																																	=
																																																	BgL_arg4657z00_5658;
																																																BgL_exprz00_1732
																																																	=
																																																	BgL_exprz00_28173;
																																																BgL_bindingsz00_1731
																																																	=
																																																	BgL_bindingsz00_28172;
																																																goto
																																																	BgL_tagzd2382zd2_1733;
																																															}
																																															BgL_auxz00_27689
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_28171);
																																														}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														bool_t
																																															BgL_test10319z00_28175;
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg4667z00_5670;
																																															BgL_arg4667z00_5670
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															BgL_test10319z00_28175
																																																=
																																																CBOOL
																																																(BGl_labelszd2symzf3z21zzast_labelsz00
																																																(BgL_arg4667z00_5670));
																																														}
																																														if (BgL_test10319z00_28175)
																																															{
																																																BgL_letzd2funzd2_bglt
																																																	BgL_auxz00_28180;
																																																goto
																																																	BgL_tagzd2384zd2_1735;
																																																BgL_auxz00_27689
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_28180);
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_carzd257921zd2_5661;
																																																BgL_carzd257921zd2_5661
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_cdrzd257926zd2_5662;
																																																	BgL_cdrzd257926zd2_5662
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_carzd257921zd2_5661));
																																																	if ((CAR(((obj_t) BgL_carzd257921zd2_5661)) == CNST_TABLE_REF(((long) 3))))
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg4662z00_5665;
																																																			obj_t
																																																				BgL_arg4663z00_5666;
																																																			obj_t
																																																				BgL_arg4664z00_5667;
																																																			BgL_arg4662z00_5665
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd257926zd2_5662));
																																																			BgL_arg4663z00_5666
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd257926zd2_5662));
																																																			BgL_arg4664z00_5667
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_28197;
																																																				{
																																																					obj_t
																																																						BgL_argsz00_28200;
																																																					obj_t
																																																						BgL_bodyz00_28199;
																																																					obj_t
																																																						BgL_varsz00_28198;
																																																					BgL_varsz00_28198
																																																						=
																																																						BgL_arg4662z00_5665;
																																																					BgL_bodyz00_28199
																																																						=
																																																						BgL_arg4663z00_5666;
																																																					BgL_argsz00_28200
																																																						=
																																																						BgL_arg4664z00_5667;
																																																					BgL_argsz00_1742
																																																						=
																																																						BgL_argsz00_28200;
																																																					BgL_bodyz00_1741
																																																						=
																																																						BgL_bodyz00_28199;
																																																					BgL_varsz00_1740
																																																						=
																																																						BgL_varsz00_28198;
																																																					goto
																																																						BgL_tagzd2386zd2_1743;
																																																				}
																																																				BgL_auxz00_27689
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_28197);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																				{	/* Ast/sexp.scm 119 */
																																																					goto
																																																						BgL_tagzd2403zd2_1777;
																																																				}
																																																			else
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_28204;
																																																					goto
																																																						BgL_tagzd2404zd2_1778;
																																																					BgL_auxz00_27689
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_28204);
																																																				}
																																																		}
																																																}
																																															}
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												bool_t
																																													BgL_test10322z00_28206;
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_arg4653z00_5654;
																																													BgL_arg4653z00_5654
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													BgL_test10322z00_28206
																																														=
																																														CBOOL
																																														(BGl_labelszd2symzf3z21zzast_labelsz00
																																														(BgL_arg4653z00_5654));
																																												}
																																												if (BgL_test10322z00_28206)
																																													{
																																														BgL_letzd2funzd2_bglt
																																															BgL_auxz00_28211;
																																														goto
																																															BgL_tagzd2384zd2_1735;
																																														BgL_auxz00_27689
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_28211);
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_carzd258075zd2_5645;
																																														BgL_carzd258075zd2_5645
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_cdrzd258080zd2_5646;
																																															BgL_cdrzd258080zd2_5646
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_carzd258075zd2_5645));
																																															if ((CAR(((obj_t) BgL_carzd258075zd2_5645)) == CNST_TABLE_REF(((long) 3))))
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg4648z00_5649;
																																																	obj_t
																																																		BgL_arg4649z00_5650;
																																																	obj_t
																																																		BgL_arg4650z00_5651;
																																																	BgL_arg4648z00_5649
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd258080zd2_5646));
																																																	BgL_arg4649z00_5650
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd258080zd2_5646));
																																																	BgL_arg4650z00_5651
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_28228;
																																																		{
																																																			obj_t
																																																				BgL_argsz00_28231;
																																																			obj_t
																																																				BgL_bodyz00_28230;
																																																			obj_t
																																																				BgL_varsz00_28229;
																																																			BgL_varsz00_28229
																																																				=
																																																				BgL_arg4648z00_5649;
																																																			BgL_bodyz00_28230
																																																				=
																																																				BgL_arg4649z00_5650;
																																																			BgL_argsz00_28231
																																																				=
																																																				BgL_arg4650z00_5651;
																																																			BgL_argsz00_1742
																																																				=
																																																				BgL_argsz00_28231;
																																																			BgL_bodyz00_1741
																																																				=
																																																				BgL_bodyz00_28230;
																																																			BgL_varsz00_1740
																																																				=
																																																				BgL_varsz00_28229;
																																																			goto
																																																				BgL_tagzd2386zd2_1743;
																																																		}
																																																		BgL_auxz00_27689
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_28228);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																		{	/* Ast/sexp.scm 119 */
																																																			goto
																																																				BgL_tagzd2403zd2_1777;
																																																		}
																																																	else
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_28235;
																																																			goto
																																																				BgL_tagzd2404zd2_1778;
																																																			BgL_auxz00_27689
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_28235);
																																																		}
																																																}
																																														}
																																													}
																																											}
																																									}
																																								}
																																							}
																																					}
																																				else
																																					{	/* Ast/sexp.scm 119 */
																																						obj_t
																																							BgL_cdrzd258190zd2_5671;
																																						BgL_cdrzd258190zd2_5671
																																							=
																																							CDR
																																							(((obj_t) BgL_expz00_21));
																																						{

																																							{	/* Ast/sexp.scm 119 */
																																								bool_t
																																									BgL_test10325z00_28239;
																																								{	/* Ast/sexp.scm 119 */
																																									obj_t
																																										BgL_arg4674z00_5679;
																																									BgL_arg4674z00_5679
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_expz00_21));
																																									BgL_test10325z00_28239
																																										=
																																										CBOOL
																																										(BGl_letzd2symzf3z21zzast_letz00
																																										(BgL_arg4674z00_5679));
																																								}
																																								if (BgL_test10325z00_28239)
																																									{	/* Ast/sexp.scm 119 */
																																										if (PAIRP(BgL_cdrzd258190zd2_5671))
																																											{	/* Ast/sexp.scm 119 */
																																												obj_t
																																													BgL_arg4676z00_5681;
																																												obj_t
																																													BgL_arg4677z00_5682;
																																												BgL_arg4676z00_5681
																																													=
																																													CAR
																																													(BgL_cdrzd258190zd2_5671);
																																												BgL_arg4677z00_5682
																																													=
																																													CDR
																																													(BgL_cdrzd258190zd2_5671);
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_28248;
																																													{
																																														obj_t
																																															BgL_exprz00_28250;
																																														obj_t
																																															BgL_bindingsz00_28249;
																																														BgL_bindingsz00_28249
																																															=
																																															BgL_arg4676z00_5681;
																																														BgL_exprz00_28250
																																															=
																																															BgL_arg4677z00_5682;
																																														BgL_exprz00_1732
																																															=
																																															BgL_exprz00_28250;
																																														BgL_bindingsz00_1731
																																															=
																																															BgL_bindingsz00_28249;
																																														goto
																																															BgL_tagzd2382zd2_1733;
																																													}
																																													BgL_auxz00_27689
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_28248);
																																												}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												bool_t
																																													BgL_test10327z00_28252;
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_arg4681z00_5686;
																																													BgL_arg4681z00_5686
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													BgL_test10327z00_28252
																																														=
																																														CBOOL
																																														(BGl_labelszd2symzf3z21zzast_labelsz00
																																														(BgL_arg4681z00_5686));
																																												}
																																												if (BgL_test10327z00_28252)
																																													{
																																														BgL_letzd2funzd2_bglt
																																															BgL_auxz00_28257;
																																														goto
																																															BgL_tagzd2384zd2_1735;
																																														BgL_auxz00_27689
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_28257);
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																															{	/* Ast/sexp.scm 119 */
																																																goto
																																																	BgL_tagzd2403zd2_1777;
																																															}
																																														else
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_28261;
																																																goto
																																																	BgL_tagzd2404zd2_1778;
																																																BgL_auxz00_27689
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_28261);
																																															}
																																													}
																																											}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 119 */
																																										bool_t
																																											BgL_test10329z00_28263;
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_arg4673z00_5678;
																																											BgL_arg4673z00_5678
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_expz00_21));
																																											BgL_test10329z00_28263
																																												=
																																												CBOOL
																																												(BGl_labelszd2symzf3z21zzast_labelsz00
																																												(BgL_arg4673z00_5678));
																																										}
																																										if (BgL_test10329z00_28263)
																																											{
																																												BgL_letzd2funzd2_bglt
																																													BgL_auxz00_28268;
																																												goto
																																													BgL_tagzd2384zd2_1735;
																																												BgL_auxz00_27689
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_28268);
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																													{	/* Ast/sexp.scm 119 */
																																														goto
																																															BgL_tagzd2403zd2_1777;
																																													}
																																												else
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_28272;
																																														goto
																																															BgL_tagzd2404zd2_1778;
																																														BgL_auxz00_27689
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_28272);
																																													}
																																											}
																																									}
																																							}
																																						}
																																					}
																																				return
																																					(
																																					(BgL_nodez00_bglt)
																																					BgL_auxz00_27689);
																																			}
																																		else
																																			{	/* Ast/sexp.scm 119 */
																																				if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd255414zd2_5108)))
																																					{
																																						obj_t
																																							BgL_auxz00_28278;
																																						goto
																																							BgL_kapzd255416zd2_5110;
																																						return
																																							(
																																							(BgL_nodez00_bglt)
																																							BgL_auxz00_28278);
																																					}
																																				else
																																					{	/* Ast/sexp.scm 119 */
																																						if (
																																							(BgL_carzd255414zd2_5108
																																								==
																																								CNST_TABLE_REF
																																								(((long) 18))))
																																							{
																																								obj_t
																																									BgL_auxz00_28283;
																																								goto
																																									BgL_kapzd255416zd2_5110;
																																								return
																																									(
																																									(BgL_nodez00_bglt)
																																									BgL_auxz00_28283);
																																							}
																																						else
																																							{	/* Ast/sexp.scm 119 */
																																								if ((BgL_carzd255414zd2_5108 == CNST_TABLE_REF(((long) 19))))
																																									{
																																										obj_t
																																											BgL_auxz00_28288;
																																										goto
																																											BgL_kapzd255416zd2_5110;
																																										return
																																											(
																																											(BgL_nodez00_bglt)
																																											BgL_auxz00_28288);
																																									}
																																								else
																																									{	/* Ast/sexp.scm 119 */
																																										if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd255414zd2_5108)))
																																											{
																																												obj_t
																																													BgL_auxz00_28293;
																																												goto
																																													BgL_kapzd255416zd2_5110;
																																												return
																																													(
																																													(BgL_nodez00_bglt)
																																													BgL_auxz00_28293);
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												obj_t
																																													BgL_cdrzd258499zd2_5116;
																																												BgL_cdrzd258499zd2_5116
																																													=
																																													CDR
																																													(BgL_expz00_21);
																																												{

																																													{	/* Ast/sexp.scm 119 */
																																														bool_t
																																															BgL_test10335z00_28296;
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg4427z00_5295;
																																															BgL_arg4427z00_5295
																																																=
																																																CAR
																																																(BgL_expz00_21);
																																															BgL_test10335z00_28296
																																																=
																																																CBOOL
																																																(BGl_letzd2symzf3z21zzast_letz00
																																																(BgL_arg4427z00_5295));
																																														}
																																														if (BgL_test10335z00_28296)
																																															{
																																																obj_t
																																																	BgL_auxz00_28300;
																																																if (PAIRP(BgL_cdrzd258499zd2_5116))
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_arg4429z00_5297;
																																																		obj_t
																																																			BgL_arg4430z00_5298;
																																																		BgL_arg4429z00_5297
																																																			=
																																																			CAR
																																																			(BgL_cdrzd258499zd2_5116);
																																																		BgL_arg4430z00_5298
																																																			=
																																																			CDR
																																																			(BgL_cdrzd258499zd2_5116);
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_28305;
																																																			{
																																																				obj_t
																																																					BgL_exprz00_28307;
																																																				obj_t
																																																					BgL_bindingsz00_28306;
																																																				BgL_bindingsz00_28306
																																																					=
																																																					BgL_arg4429z00_5297;
																																																				BgL_exprz00_28307
																																																					=
																																																					BgL_arg4430z00_5298;
																																																				BgL_exprz00_1732
																																																					=
																																																					BgL_exprz00_28307;
																																																				BgL_bindingsz00_1731
																																																					=
																																																					BgL_bindingsz00_28306;
																																																				goto
																																																					BgL_tagzd2382zd2_1733;
																																																			}
																																																			BgL_auxz00_28300
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_28305);
																																																		}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		bool_t
																																																			BgL_test10337z00_28309;
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg4500z00_5410;
																																																			BgL_arg4500z00_5410
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			BgL_test10337z00_28309
																																																				=
																																																				CBOOL
																																																				(BGl_labelszd2symzf3z21zzast_labelsz00
																																																				(BgL_arg4500z00_5410));
																																																		}
																																																		if (BgL_test10337z00_28309)
																																																			{
																																																				BgL_letzd2funzd2_bglt
																																																					BgL_auxz00_28314;
																																																				goto
																																																					BgL_tagzd2384zd2_1735;
																																																				BgL_auxz00_28300
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_28314);
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_carzd258562zd2_5301;
																																																				BgL_carzd258562zd2_5301
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_cdrzd258567zd2_5302;
																																																					BgL_cdrzd258567zd2_5302
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_carzd258562zd2_5301));
																																																					if ((CAR(((obj_t) BgL_carzd258562zd2_5301)) == CNST_TABLE_REF(((long) 3))))
																																																						{	/* Ast/sexp.scm 119 */
																																																							if (PAIRP(BgL_cdrzd258567zd2_5302))
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_arg4436z00_5306;
																																																									obj_t
																																																										BgL_arg4437z00_5307;
																																																									obj_t
																																																										BgL_arg4438z00_5308;
																																																									BgL_arg4436z00_5306
																																																										=
																																																										CAR
																																																										(BgL_cdrzd258567zd2_5302);
																																																									BgL_arg4437z00_5307
																																																										=
																																																										CDR
																																																										(BgL_cdrzd258567zd2_5302);
																																																									BgL_arg4438z00_5308
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_28331;
																																																										{
																																																											obj_t
																																																												BgL_argsz00_28334;
																																																											obj_t
																																																												BgL_bodyz00_28333;
																																																											obj_t
																																																												BgL_varsz00_28332;
																																																											BgL_varsz00_28332
																																																												=
																																																												BgL_arg4436z00_5306;
																																																											BgL_bodyz00_28333
																																																												=
																																																												BgL_arg4437z00_5307;
																																																											BgL_argsz00_28334
																																																												=
																																																												BgL_arg4438z00_5308;
																																																											BgL_argsz00_1742
																																																												=
																																																												BgL_argsz00_28334;
																																																											BgL_bodyz00_1741
																																																												=
																																																												BgL_bodyz00_28333;
																																																											BgL_varsz00_1740
																																																												=
																																																												BgL_varsz00_28332;
																																																											goto
																																																												BgL_tagzd2386zd2_1743;
																																																										}
																																																										BgL_auxz00_28300
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_28331);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																										{	/* Ast/sexp.scm 119 */
																																																											goto
																																																												BgL_tagzd2403zd2_1777;
																																																										}
																																																									else
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_28338;
																																																											goto
																																																												BgL_tagzd2404zd2_1778;
																																																											BgL_auxz00_28300
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_28338);
																																																										}
																																																								}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_cdrzd258674zd2_5311;
																																																							BgL_cdrzd258674zd2_5311
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd258679zd2_5312;
																																																								BgL_cdrzd258679zd2_5312
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_carzd258562zd2_5301));
																																																								if ((CAR(((obj_t) BgL_carzd258562zd2_5301)) == CNST_TABLE_REF(((long) 1))))
																																																									{	/* Ast/sexp.scm 119 */
																																																										if (PAIRP(BgL_cdrzd258679zd2_5312))
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd258684zd2_5316;
																																																												BgL_cdrzd258684zd2_5316
																																																													=
																																																													CDR
																																																													(BgL_cdrzd258679zd2_5312);
																																																												if (PAIRP(BgL_cdrzd258684zd2_5316))
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_carzd258688zd2_5318;
																																																														obj_t
																																																															BgL_cdrzd258689zd2_5319;
																																																														BgL_carzd258688zd2_5318
																																																															=
																																																															CAR
																																																															(BgL_cdrzd258684zd2_5316);
																																																														BgL_cdrzd258689zd2_5319
																																																															=
																																																															CDR
																																																															(BgL_cdrzd258684zd2_5316);
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd258688zd2_5318))
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (PAIRP(BgL_cdrzd258689zd2_5319))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_carzd258694zd2_5322;
																																																																		BgL_carzd258694zd2_5322
																																																																			=
																																																																			CAR
																																																																			(BgL_cdrzd258689zd2_5319);
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd258694zd2_5322))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (NULLP(CDR(BgL_cdrzd258689zd2_5319)))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						bool_t
																																																																							BgL_test10348z00_28366;
																																																																						{
																																																																							obj_t
																																																																								BgL_l1468z00_5355;
																																																																							BgL_l1468z00_5355
																																																																								=
																																																																								BgL_cdrzd258674zd2_5311;
																																																																						BgL_zc3z04anonymousza34464ze3z87_5356:
																																																																							if (NULLP(BgL_l1468z00_5355))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									BgL_test10348z00_28366
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										1);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									bool_t
																																																																										BgL_test10350z00_28369;
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										bool_t
																																																																											BgL_test10351z00_28370;
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_tmpz00_28371;
																																																																											BgL_tmpz00_28371
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_l1468z00_5355));
																																																																											BgL_test10351z00_28370
																																																																												=
																																																																												PAIRP
																																																																												(BgL_tmpz00_28371);
																																																																										}
																																																																										if (BgL_test10351z00_28370)
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												BgL_test10350z00_28369
																																																																													=
																																																																													(
																																																																													(bool_t)
																																																																													0);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												BgL_test10350z00_28369
																																																																													=
																																																																													(
																																																																													(bool_t)
																																																																													1);
																																																																											}
																																																																									}
																																																																									if (BgL_test10350z00_28369)
																																																																										{
																																																																											obj_t
																																																																												BgL_l1468z00_28375;
																																																																											BgL_l1468z00_28375
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_l1468z00_5355));
																																																																											BgL_l1468z00_5355
																																																																												=
																																																																												BgL_l1468z00_28375;
																																																																											goto
																																																																												BgL_zc3z04anonymousza34464ze3z87_5356;
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											BgL_test10348z00_28366
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												0);
																																																																										}
																																																																								}
																																																																						}
																																																																						if (BgL_test10348z00_28366)
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_arg4454z00_5338;
																																																																								BgL_arg4454z00_5338
																																																																									=
																																																																									CAR
																																																																									(BgL_cdrzd258679zd2_5312);
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_28379;
																																																																									{
																																																																										obj_t
																																																																											BgL_argsz00_28383;
																																																																										obj_t
																																																																											BgL_proc2z00_28382;
																																																																										obj_t
																																																																											BgL_proc1z00_28381;
																																																																										obj_t
																																																																											BgL_testz00_28380;
																																																																										BgL_testz00_28380
																																																																											=
																																																																											BgL_arg4454z00_5338;
																																																																										BgL_proc1z00_28381
																																																																											=
																																																																											BgL_carzd258688zd2_5318;
																																																																										BgL_proc2z00_28382
																																																																											=
																																																																											BgL_carzd258694zd2_5322;
																																																																										BgL_argsz00_28383
																																																																											=
																																																																											BgL_cdrzd258674zd2_5311;
																																																																										BgL_argsz00_1747
																																																																											=
																																																																											BgL_argsz00_28383;
																																																																										BgL_proc2z00_1746
																																																																											=
																																																																											BgL_proc2z00_28382;
																																																																										BgL_proc1z00_1745
																																																																											=
																																																																											BgL_proc1z00_28381;
																																																																										BgL_testz00_1744
																																																																											=
																																																																											BgL_testz00_28380;
																																																																										goto
																																																																											BgL_tagzd2387zd2_1748;
																																																																									}
																																																																									BgL_auxz00_28300
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_28379);
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd258719zd2_5339;
																																																																								BgL_cdrzd258719zd2_5339
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd258727zd2_5340;
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_pairz00_13323;
																																																																										BgL_pairz00_13323
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										BgL_cdrzd258727zd2_5340
																																																																											=
																																																																											CDR
																																																																											(BgL_pairz00_13323);
																																																																									}
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd258735zd2_5341;
																																																																										BgL_cdrzd258735zd2_5341
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd258727zd2_5340));
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd258742zd2_5342;
																																																																											BgL_carzd258742zd2_5342
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd258735zd2_5341));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd258742zd2_5342))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_carzd258751zd2_5344;
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_pairz00_13327;
																																																																														BgL_pairz00_13327
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd258735zd2_5341));
																																																																														BgL_carzd258751zd2_5344
																																																																															=
																																																																															CAR
																																																																															(BgL_pairz00_13327);
																																																																													}
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd258751zd2_5344))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd258719zd2_5339))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_arg4458z00_5347;
																																																																																	BgL_arg4458z00_5347
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd258727zd2_5340));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_28405;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_28409;
																																																																																			obj_t
																																																																																				BgL_proc2z00_28408;
																																																																																			obj_t
																																																																																				BgL_proc1z00_28407;
																																																																																			obj_t
																																																																																				BgL_testz00_28406;
																																																																																			BgL_testz00_28406
																																																																																				=
																																																																																				BgL_arg4458z00_5347;
																																																																																			BgL_proc1z00_28407
																																																																																				=
																																																																																				BgL_carzd258742zd2_5342;
																																																																																			BgL_proc2z00_28408
																																																																																				=
																																																																																				BgL_carzd258751zd2_5344;
																																																																																			BgL_argsz00_28409
																																																																																				=
																																																																																				BgL_cdrzd258719zd2_5339;
																																																																																			BgL_argsz00_1752
																																																																																				=
																																																																																				BgL_argsz00_28409;
																																																																																			BgL_proc2z00_1751
																																																																																				=
																																																																																				BgL_proc2z00_28408;
																																																																																			BgL_proc1z00_1750
																																																																																				=
																																																																																				BgL_proc1z00_28407;
																																																																																			BgL_testz00_1749
																																																																																				=
																																																																																				BgL_testz00_28406;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1753;
																																																																																		}
																																																																																		BgL_auxz00_28300
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_28405);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1777;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_28413;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1778;
																																																																																			BgL_auxz00_28300
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_28413);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1777;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_28417;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1778;
																																																																																	BgL_auxz00_28300
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_28417);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1777;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_28421;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1778;
																																																																															BgL_auxz00_28300
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_28421);
																																																																														}
																																																																												}
																																																																										}
																																																																									}
																																																																								}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1777;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_28425;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1778;
																																																																								BgL_auxz00_28300
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_28425);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd259029zd2_5366;
																																																																				BgL_cdrzd259029zd2_5366
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd259036zd2_5367;
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_pairz00_13331;
																																																																						BgL_pairz00_13331
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						BgL_cdrzd259036zd2_5367
																																																																							=
																																																																							CDR
																																																																							(BgL_pairz00_13331);
																																																																					}
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd259043zd2_5368;
																																																																						BgL_cdrzd259043zd2_5368
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd259036zd2_5367));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd259049zd2_5369;
																																																																							obj_t
																																																																								BgL_cdrzd259050zd2_5370;
																																																																							BgL_carzd259049zd2_5369
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd259043zd2_5368));
																																																																							BgL_cdrzd259050zd2_5370
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd259043zd2_5368));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd259049zd2_5369))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd259057zd2_5372;
																																																																									BgL_carzd259057zd2_5372
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd259050zd2_5370));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd259057zd2_5372))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (NULLP(CDR(((obj_t) BgL_cdrzd259050zd2_5370))))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd259029zd2_5366))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg4473z00_5377;
																																																																															BgL_arg4473z00_5377
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd259036zd2_5367));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_28452;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_28456;
																																																																																	obj_t
																																																																																		BgL_proc2z00_28455;
																																																																																	obj_t
																																																																																		BgL_proc1z00_28454;
																																																																																	obj_t
																																																																																		BgL_testz00_28453;
																																																																																	BgL_testz00_28453
																																																																																		=
																																																																																		BgL_arg4473z00_5377;
																																																																																	BgL_proc1z00_28454
																																																																																		=
																																																																																		BgL_carzd259049zd2_5369;
																																																																																	BgL_proc2z00_28455
																																																																																		=
																																																																																		BgL_carzd259057zd2_5372;
																																																																																	BgL_argsz00_28456
																																																																																		=
																																																																																		BgL_cdrzd259029zd2_5366;
																																																																																	BgL_argsz00_1752
																																																																																		=
																																																																																		BgL_argsz00_28456;
																																																																																	BgL_proc2z00_1751
																																																																																		=
																																																																																		BgL_proc2z00_28455;
																																																																																	BgL_proc1z00_1750
																																																																																		=
																																																																																		BgL_proc1z00_28454;
																																																																																	BgL_testz00_1749
																																																																																		=
																																																																																		BgL_testz00_28453;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1753;
																																																																																}
																																																																																BgL_auxz00_28300
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_28452);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1777;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_28460;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1778;
																																																																																	BgL_auxz00_28300
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_28460);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1777;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_28464;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1778;
																																																																															BgL_auxz00_28300
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_28464);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1777;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_28468;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1778;
																																																																													BgL_auxz00_28300
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_28468);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1777;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_28472;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1778;
																																																																											BgL_auxz00_28300
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_28472);
																																																																										}
																																																																								}
																																																																						}
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1777;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_28476;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1778;
																																																																				BgL_auxz00_28300
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_28476);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd259390zd2_5385;
																																																																BgL_cdrzd259390zd2_5385
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd259396zd2_5386;
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_pairz00_13341;
																																																																		BgL_pairz00_13341
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		BgL_cdrzd259396zd2_5386
																																																																			=
																																																																			CDR
																																																																			(BgL_pairz00_13341);
																																																																	}
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd259402zd2_5387;
																																																																		BgL_cdrzd259402zd2_5387
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd259396zd2_5386));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_carzd259407zd2_5388;
																																																																			obj_t
																																																																				BgL_cdrzd259408zd2_5389;
																																																																			BgL_carzd259407zd2_5388
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd259402zd2_5387));
																																																																			BgL_cdrzd259408zd2_5389
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd259402zd2_5387));
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd259407zd2_5388))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (PAIRP(BgL_cdrzd259408zd2_5389))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd259413zd2_5392;
																																																																							BgL_carzd259413zd2_5392
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd259408zd2_5389);
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd259413zd2_5392))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (NULLP(CDR(BgL_cdrzd259408zd2_5389)))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd259390zd2_5385))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_arg4487z00_5397;
																																																																													BgL_arg4487z00_5397
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd259396zd2_5386));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_28503;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_28507;
																																																																															obj_t
																																																																																BgL_proc2z00_28506;
																																																																															obj_t
																																																																																BgL_proc1z00_28505;
																																																																															obj_t
																																																																																BgL_testz00_28504;
																																																																															BgL_testz00_28504
																																																																																=
																																																																																BgL_arg4487z00_5397;
																																																																															BgL_proc1z00_28505
																																																																																=
																																																																																BgL_carzd259407zd2_5388;
																																																																															BgL_proc2z00_28506
																																																																																=
																																																																																BgL_carzd259413zd2_5392;
																																																																															BgL_argsz00_28507
																																																																																=
																																																																																BgL_cdrzd259390zd2_5385;
																																																																															BgL_argsz00_1752
																																																																																=
																																																																																BgL_argsz00_28507;
																																																																															BgL_proc2z00_1751
																																																																																=
																																																																																BgL_proc2z00_28506;
																																																																															BgL_proc1z00_1750
																																																																																=
																																																																																BgL_proc1z00_28505;
																																																																															BgL_testz00_1749
																																																																																=
																																																																																BgL_testz00_28504;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1753;
																																																																														}
																																																																														BgL_auxz00_28300
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_28503);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1777;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_28511;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1778;
																																																																															BgL_auxz00_28300
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_28511);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1777;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_28515;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1778;
																																																																													BgL_auxz00_28300
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_28515);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1777;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_28519;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1778;
																																																																											BgL_auxz00_28300
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_28519);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1777;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_28523;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1778;
																																																																									BgL_auxz00_28300
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_28523);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1777;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_28527;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1778;
																																																																							BgL_auxz00_28300
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_28527);
																																																																						}
																																																																				}
																																																																		}
																																																																	}
																																																																}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 119 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1777;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_28531;
																																																																goto
																																																																	BgL_tagzd2404zd2_1778;
																																																																BgL_auxz00_28300
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_28531);
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 119 */
																																																														goto
																																																															BgL_tagzd2403zd2_1777;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_28535;
																																																														goto
																																																															BgL_tagzd2404zd2_1778;
																																																														BgL_auxz00_28300
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_28535);
																																																													}
																																																											}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 119 */
																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																											{	/* Ast/sexp.scm 119 */
																																																												goto
																																																													BgL_tagzd2403zd2_1777;
																																																											}
																																																										else
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_28539;
																																																												goto
																																																													BgL_tagzd2404zd2_1778;
																																																												BgL_auxz00_28300
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_28539);
																																																											}
																																																									}
																																																							}
																																																						}
																																																				}
																																																			}
																																																	}
																																																return
																																																	(
																																																	(BgL_nodez00_bglt)
																																																	BgL_auxz00_28300);
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																bool_t
																																																	BgL_test10381z00_28542;
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg4426z00_5294;
																																																	BgL_arg4426z00_5294
																																																		=
																																																		CAR
																																																		(BgL_expz00_21);
																																																	BgL_test10381z00_28542
																																																		=
																																																		CBOOL
																																																		(BGl_labelszd2symzf3z21zzast_labelsz00
																																																		(BgL_arg4426z00_5294));
																																																}
																																																if (BgL_test10381z00_28542)
																																																	{
																																																		BgL_letzd2funzd2_bglt
																																																			BgL_auxz00_28546;
																																																		goto
																																																			BgL_tagzd2384zd2_1735;
																																																		return
																																																			(
																																																			(BgL_nodez00_bglt)
																																																			BgL_auxz00_28546);
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_carzd259976zd2_5122;
																																																		obj_t
																																																			BgL_cdrzd259977zd2_5123;
																																																		BgL_carzd259976zd2_5122
																																																			=
																																																			CAR
																																																			(BgL_expz00_21);
																																																		BgL_cdrzd259977zd2_5123
																																																			=
																																																			CDR
																																																			(BgL_expz00_21);
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_cdrzd259981zd2_5124;
																																																			BgL_cdrzd259981zd2_5124
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_carzd259976zd2_5122));
																																																			if ((CAR(((obj_t) BgL_carzd259976zd2_5122)) == CNST_TABLE_REF(((long) 3))))
																																																				{	/* Ast/sexp.scm 119 */
																																																					if (PAIRP(BgL_cdrzd259981zd2_5124))
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_carzd259984zd2_5128;
																																																							obj_t
																																																								BgL_cdrzd259985zd2_5129;
																																																							BgL_carzd259984zd2_5128
																																																								=
																																																								CAR
																																																								(BgL_cdrzd259981zd2_5124);
																																																							BgL_cdrzd259985zd2_5129
																																																								=
																																																								CDR
																																																								(BgL_cdrzd259981zd2_5124);
																																																							if (PAIRP(BgL_carzd259984zd2_5128))
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (NULLP(CDR(BgL_carzd259984zd2_5128)))
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (PAIRP(BgL_cdrzd259985zd2_5129))
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_carzd259991zd2_5134;
																																																													BgL_carzd259991zd2_5134
																																																														=
																																																														CAR
																																																														(BgL_cdrzd259985zd2_5129);
																																																													if (PAIRP(BgL_carzd259991zd2_5134))
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (BGl_castzd2sexpzf3z21zzast_privatez00(BgL_carzd259991zd2_5134))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (NULLP(CDR(BgL_cdrzd259985zd2_5129)))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (PAIRP(BgL_cdrzd259977zd2_5123))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_carzd259998zd2_5140;
																																																																					BgL_carzd259998zd2_5140
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd259977zd2_5123);
																																																																					if (PAIRP(BgL_carzd259998zd2_5140))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd260022zd2_5142;
																																																																							BgL_cdrzd260022zd2_5142
																																																																								=
																																																																								CDR
																																																																								(CAR
																																																																								(BgL_expz00_21));
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_arg4323z00_5143;
																																																																								obj_t
																																																																									BgL_arg4324z00_5144;
																																																																								obj_t
																																																																									BgL_arg4325z00_5145;
																																																																								BgL_arg4323z00_5143
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd260022zd2_5142));
																																																																								BgL_arg4324z00_5144
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd260022zd2_5142));
																																																																								BgL_arg4325z00_5145
																																																																									=
																																																																									CDR
																																																																									(BgL_expz00_21);
																																																																								{
																																																																									obj_t
																																																																										BgL_argsz00_28590;
																																																																									obj_t
																																																																										BgL_bodyz00_28589;
																																																																									obj_t
																																																																										BgL_varsz00_28588;
																																																																									BgL_varsz00_28588
																																																																										=
																																																																										BgL_arg4323z00_5143;
																																																																									BgL_bodyz00_28589
																																																																										=
																																																																										BgL_arg4324z00_5144;
																																																																									BgL_argsz00_28590
																																																																										=
																																																																										BgL_arg4325z00_5145;
																																																																									BgL_argsz00_1742
																																																																										=
																																																																										BgL_argsz00_28590;
																																																																									BgL_bodyz00_1741
																																																																										=
																																																																										BgL_bodyz00_28589;
																																																																									BgL_varsz00_1740
																																																																										=
																																																																										BgL_varsz00_28588;
																																																																									goto
																																																																										BgL_tagzd2386zd2_1743;
																																																																								}
																																																																							}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (NULLP(CDR(BgL_cdrzd259977zd2_5123)))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_arg4329z00_5149;
																																																																									BgL_arg4329z00_5149
																																																																										=
																																																																										CAR
																																																																										(BgL_carzd259984zd2_5128);
																																																																									{
																																																																										BgL_castz00_bglt
																																																																											BgL_auxz00_28595;
																																																																										{
																																																																											obj_t
																																																																												BgL_argz00_28598;
																																																																											obj_t
																																																																												BgL_bodyz00_28597;
																																																																											obj_t
																																																																												BgL_varz00_28596;
																																																																											BgL_varz00_28596
																																																																												=
																																																																												BgL_arg4329z00_5149;
																																																																											BgL_bodyz00_28597
																																																																												=
																																																																												BgL_carzd259991zd2_5134;
																																																																											BgL_argz00_28598
																																																																												=
																																																																												BgL_carzd259998zd2_5140;
																																																																											BgL_argz00_1738
																																																																												=
																																																																												BgL_argz00_28598;
																																																																											BgL_bodyz00_1737
																																																																												=
																																																																												BgL_bodyz00_28597;
																																																																											BgL_varz00_1736
																																																																												=
																																																																												BgL_varz00_28596;
																																																																											goto
																																																																												BgL_tagzd2385zd2_1739;
																																																																										}
																																																																										return
																																																																											(
																																																																											(BgL_nodez00_bglt)
																																																																											BgL_auxz00_28595);
																																																																									}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd260049zd2_5150;
																																																																									BgL_cdrzd260049zd2_5150
																																																																										=
																																																																										CDR
																																																																										(CAR
																																																																										(BgL_expz00_21));
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_arg4330z00_5151;
																																																																										obj_t
																																																																											BgL_arg4331z00_5152;
																																																																										obj_t
																																																																											BgL_arg4332z00_5153;
																																																																										BgL_arg4330z00_5151
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd260049zd2_5150));
																																																																										BgL_arg4331z00_5152
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd260049zd2_5150));
																																																																										BgL_arg4332z00_5153
																																																																											=
																																																																											CDR
																																																																											(BgL_expz00_21);
																																																																										{
																																																																											obj_t
																																																																												BgL_argsz00_28609;
																																																																											obj_t
																																																																												BgL_bodyz00_28608;
																																																																											obj_t
																																																																												BgL_varsz00_28607;
																																																																											BgL_varsz00_28607
																																																																												=
																																																																												BgL_arg4330z00_5151;
																																																																											BgL_bodyz00_28608
																																																																												=
																																																																												BgL_arg4331z00_5152;
																																																																											BgL_argsz00_28609
																																																																												=
																																																																												BgL_arg4332z00_5153;
																																																																											BgL_argsz00_1742
																																																																												=
																																																																												BgL_argsz00_28609;
																																																																											BgL_bodyz00_1741
																																																																												=
																																																																												BgL_bodyz00_28608;
																																																																											BgL_varsz00_1740
																																																																												=
																																																																												BgL_varsz00_28607;
																																																																											goto
																																																																												BgL_tagzd2386zd2_1743;
																																																																										}
																																																																									}
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd260075zd2_5156;
																																																																					BgL_cdrzd260075zd2_5156
																																																																						=
																																																																						CDR
																																																																						(CAR
																																																																						(BgL_expz00_21));
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_arg4335z00_5157;
																																																																						obj_t
																																																																							BgL_arg4336z00_5158;
																																																																						obj_t
																																																																							BgL_arg4337z00_5159;
																																																																						BgL_arg4335z00_5157
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd260075zd2_5156));
																																																																						BgL_arg4336z00_5158
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd260075zd2_5156));
																																																																						BgL_arg4337z00_5159
																																																																							=
																																																																							CDR
																																																																							(BgL_expz00_21);
																																																																						{
																																																																							obj_t
																																																																								BgL_argsz00_28619;
																																																																							obj_t
																																																																								BgL_bodyz00_28618;
																																																																							obj_t
																																																																								BgL_varsz00_28617;
																																																																							BgL_varsz00_28617
																																																																								=
																																																																								BgL_arg4335z00_5157;
																																																																							BgL_bodyz00_28618
																																																																								=
																																																																								BgL_arg4336z00_5158;
																																																																							BgL_argsz00_28619
																																																																								=
																																																																								BgL_arg4337z00_5159;
																																																																							BgL_argsz00_1742
																																																																								=
																																																																								BgL_argsz00_28619;
																																																																							BgL_bodyz00_1741
																																																																								=
																																																																								BgL_bodyz00_28618;
																																																																							BgL_varsz00_1740
																																																																								=
																																																																								BgL_varsz00_28617;
																																																																							goto
																																																																								BgL_tagzd2386zd2_1743;
																																																																						}
																																																																					}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd260101zd2_5161;
																																																																			BgL_cdrzd260101zd2_5161
																																																																				=
																																																																				CDR
																																																																				(CAR
																																																																				(BgL_expz00_21));
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_arg4339z00_5162;
																																																																				obj_t
																																																																					BgL_arg4340z00_5163;
																																																																				obj_t
																																																																					BgL_arg4341z00_5164;
																																																																				BgL_arg4339z00_5162
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd260101zd2_5161));
																																																																				BgL_arg4340z00_5163
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd260101zd2_5161));
																																																																				BgL_arg4341z00_5164
																																																																					=
																																																																					CDR
																																																																					(BgL_expz00_21);
																																																																				{
																																																																					obj_t
																																																																						BgL_argsz00_28629;
																																																																					obj_t
																																																																						BgL_bodyz00_28628;
																																																																					obj_t
																																																																						BgL_varsz00_28627;
																																																																					BgL_varsz00_28627
																																																																						=
																																																																						BgL_arg4339z00_5162;
																																																																					BgL_bodyz00_28628
																																																																						=
																																																																						BgL_arg4340z00_5163;
																																																																					BgL_argsz00_28629
																																																																						=
																																																																						BgL_arg4341z00_5164;
																																																																					BgL_argsz00_1742
																																																																						=
																																																																						BgL_argsz00_28629;
																																																																					BgL_bodyz00_1741
																																																																						=
																																																																						BgL_bodyz00_28628;
																																																																					BgL_varsz00_1740
																																																																						=
																																																																						BgL_varsz00_28627;
																																																																					goto
																																																																						BgL_tagzd2386zd2_1743;
																																																																				}
																																																																			}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd260127zd2_5167;
																																																																	BgL_cdrzd260127zd2_5167
																																																																		=
																																																																		CDR
																																																																		(CAR
																																																																		(BgL_expz00_21));
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_arg4344z00_5168;
																																																																		obj_t
																																																																			BgL_arg4345z00_5169;
																																																																		obj_t
																																																																			BgL_arg4346z00_5170;
																																																																		BgL_arg4344z00_5168
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd260127zd2_5167));
																																																																		BgL_arg4345z00_5169
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd260127zd2_5167));
																																																																		BgL_arg4346z00_5170
																																																																			=
																																																																			CDR
																																																																			(BgL_expz00_21);
																																																																		{
																																																																			obj_t
																																																																				BgL_argsz00_28639;
																																																																			obj_t
																																																																				BgL_bodyz00_28638;
																																																																			obj_t
																																																																				BgL_varsz00_28637;
																																																																			BgL_varsz00_28637
																																																																				=
																																																																				BgL_arg4344z00_5168;
																																																																			BgL_bodyz00_28638
																																																																				=
																																																																				BgL_arg4345z00_5169;
																																																																			BgL_argsz00_28639
																																																																				=
																																																																				BgL_arg4346z00_5170;
																																																																			BgL_argsz00_1742
																																																																				=
																																																																				BgL_argsz00_28639;
																																																																			BgL_bodyz00_1741
																																																																				=
																																																																				BgL_bodyz00_28638;
																																																																			BgL_varsz00_1740
																																																																				=
																																																																				BgL_varsz00_28637;
																																																																			goto
																																																																				BgL_tagzd2386zd2_1743;
																																																																		}
																																																																	}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd260153zd2_5172;
																																																															BgL_cdrzd260153zd2_5172
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_carzd259976zd2_5122));
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_arg4348z00_5173;
																																																																obj_t
																																																																	BgL_arg4349z00_5174;
																																																																obj_t
																																																																	BgL_arg4350z00_5175;
																																																																BgL_arg4348z00_5173
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd260153zd2_5172));
																																																																BgL_arg4349z00_5174
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd260153zd2_5172));
																																																																BgL_arg4350z00_5175
																																																																	=
																																																																	CDR
																																																																	(BgL_expz00_21);
																																																																{
																																																																	obj_t
																																																																		BgL_argsz00_28649;
																																																																	obj_t
																																																																		BgL_bodyz00_28648;
																																																																	obj_t
																																																																		BgL_varsz00_28647;
																																																																	BgL_varsz00_28647
																																																																		=
																																																																		BgL_arg4348z00_5173;
																																																																	BgL_bodyz00_28648
																																																																		=
																																																																		BgL_arg4349z00_5174;
																																																																	BgL_argsz00_28649
																																																																		=
																																																																		BgL_arg4350z00_5175;
																																																																	BgL_argsz00_1742
																																																																		=
																																																																		BgL_argsz00_28649;
																																																																	BgL_bodyz00_1741
																																																																		=
																																																																		BgL_bodyz00_28648;
																																																																	BgL_varsz00_1740
																																																																		=
																																																																		BgL_varsz00_28647;
																																																																	goto
																																																																		BgL_tagzd2386zd2_1743;
																																																																}
																																																															}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd260179zd2_5177;
																																																													BgL_cdrzd260179zd2_5177
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_carzd259976zd2_5122));
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_arg4352z00_5178;
																																																														obj_t
																																																															BgL_arg4353z00_5179;
																																																														obj_t
																																																															BgL_arg4354z00_5180;
																																																														BgL_arg4352z00_5178
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd260179zd2_5177));
																																																														BgL_arg4353z00_5179
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd260179zd2_5177));
																																																														BgL_arg4354z00_5180
																																																															=
																																																															CDR
																																																															(BgL_expz00_21);
																																																														{
																																																															obj_t
																																																																BgL_argsz00_28659;
																																																															obj_t
																																																																BgL_bodyz00_28658;
																																																															obj_t
																																																																BgL_varsz00_28657;
																																																															BgL_varsz00_28657
																																																																=
																																																																BgL_arg4352z00_5178;
																																																															BgL_bodyz00_28658
																																																																=
																																																																BgL_arg4353z00_5179;
																																																															BgL_argsz00_28659
																																																																=
																																																																BgL_arg4354z00_5180;
																																																															BgL_argsz00_1742
																																																																=
																																																																BgL_argsz00_28659;
																																																															BgL_bodyz00_1741
																																																																=
																																																																BgL_bodyz00_28658;
																																																															BgL_varsz00_1740
																																																																=
																																																																BgL_varsz00_28657;
																																																															goto
																																																																BgL_tagzd2386zd2_1743;
																																																														}
																																																													}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_cdrzd260205zd2_5182;
																																																											BgL_cdrzd260205zd2_5182
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_carzd259976zd2_5122));
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_arg4356z00_5183;
																																																												obj_t
																																																													BgL_arg4357z00_5184;
																																																												obj_t
																																																													BgL_arg4358z00_5185;
																																																												BgL_arg4356z00_5183
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd260205zd2_5182));
																																																												BgL_arg4357z00_5184
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd260205zd2_5182));
																																																												BgL_arg4358z00_5185
																																																													=
																																																													CDR
																																																													(BgL_expz00_21);
																																																												{
																																																													obj_t
																																																														BgL_argsz00_28669;
																																																													obj_t
																																																														BgL_bodyz00_28668;
																																																													obj_t
																																																														BgL_varsz00_28667;
																																																													BgL_varsz00_28667
																																																														=
																																																														BgL_arg4356z00_5183;
																																																													BgL_bodyz00_28668
																																																														=
																																																														BgL_arg4357z00_5184;
																																																													BgL_argsz00_28669
																																																														=
																																																														BgL_arg4358z00_5185;
																																																													BgL_argsz00_1742
																																																														=
																																																														BgL_argsz00_28669;
																																																													BgL_bodyz00_1741
																																																														=
																																																														BgL_bodyz00_28668;
																																																													BgL_varsz00_1740
																																																														=
																																																														BgL_varsz00_28667;
																																																													goto
																																																														BgL_tagzd2386zd2_1743;
																																																												}
																																																											}
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_cdrzd260231zd2_5188;
																																																									BgL_cdrzd260231zd2_5188
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_carzd259976zd2_5122));
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg4361z00_5189;
																																																										obj_t
																																																											BgL_arg4362z00_5190;
																																																										obj_t
																																																											BgL_arg4363z00_5191;
																																																										BgL_arg4361z00_5189
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_cdrzd260231zd2_5188));
																																																										BgL_arg4362z00_5190
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_cdrzd260231zd2_5188));
																																																										BgL_arg4363z00_5191
																																																											=
																																																											CDR
																																																											(BgL_expz00_21);
																																																										{
																																																											obj_t
																																																												BgL_argsz00_28679;
																																																											obj_t
																																																												BgL_bodyz00_28678;
																																																											obj_t
																																																												BgL_varsz00_28677;
																																																											BgL_varsz00_28677
																																																												=
																																																												BgL_arg4361z00_5189;
																																																											BgL_bodyz00_28678
																																																												=
																																																												BgL_arg4362z00_5190;
																																																											BgL_argsz00_28679
																																																												=
																																																												BgL_arg4363z00_5191;
																																																											BgL_argsz00_1742
																																																												=
																																																												BgL_argsz00_28679;
																																																											BgL_bodyz00_1741
																																																												=
																																																												BgL_bodyz00_28678;
																																																											BgL_varsz00_1740
																																																												=
																																																												BgL_varsz00_28677;
																																																											goto
																																																												BgL_tagzd2386zd2_1743;
																																																										}
																																																									}
																																																								}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																								{
																																																									obj_t
																																																										BgL_auxz00_28682;
																																																									goto
																																																										BgL_tagzd2403zd2_1777;
																																																									return
																																																										(
																																																										(BgL_nodez00_bglt)
																																																										BgL_auxz00_28682);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									goto
																																																										BgL_tagzd2404zd2_1778;
																																																								}
																																																						}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_cdrzd260369zd2_5196;
																																																					BgL_cdrzd260369zd2_5196
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_carzd259976zd2_5122));
																																																					if ((CAR(((obj_t) BgL_carzd259976zd2_5122)) == CNST_TABLE_REF(((long) 1))))
																																																						{	/* Ast/sexp.scm 119 */
																																																							if (PAIRP(BgL_cdrzd260369zd2_5196))
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_cdrzd260374zd2_5200;
																																																									BgL_cdrzd260374zd2_5200
																																																										=
																																																										CDR
																																																										(BgL_cdrzd260369zd2_5196);
																																																									if (PAIRP(BgL_cdrzd260374zd2_5200))
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_carzd260378zd2_5202;
																																																											obj_t
																																																												BgL_cdrzd260379zd2_5203;
																																																											BgL_carzd260378zd2_5202
																																																												=
																																																												CAR
																																																												(BgL_cdrzd260374zd2_5200);
																																																											BgL_cdrzd260379zd2_5203
																																																												=
																																																												CDR
																																																												(BgL_cdrzd260374zd2_5200);
																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd260378zd2_5202))
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (PAIRP(BgL_cdrzd260379zd2_5203))
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_carzd260384zd2_5206;
																																																															BgL_carzd260384zd2_5206
																																																																=
																																																																CAR
																																																																(BgL_cdrzd260379zd2_5203);
																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd260384zd2_5206))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (NULLP(CDR(BgL_cdrzd260379zd2_5203)))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			bool_t
																																																																				BgL_test10401z00_28708;
																																																																			{
																																																																				obj_t
																																																																					BgL_l1471z00_5239;
																																																																				BgL_l1471z00_5239
																																																																					=
																																																																					BgL_cdrzd259977zd2_5123;
																																																																			BgL_zc3z04anonymousza34390ze3z87_5240:
																																																																				if (NULLP(BgL_l1471z00_5239))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						BgL_test10401z00_28708
																																																																							=
																																																																							(
																																																																							(bool_t)
																																																																							1);
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						bool_t
																																																																							BgL_test10403z00_28711;
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							bool_t
																																																																								BgL_test10404z00_28712;
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_tmpz00_28713;
																																																																								BgL_tmpz00_28713
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_l1471z00_5239));
																																																																								BgL_test10404z00_28712
																																																																									=
																																																																									PAIRP
																																																																									(BgL_tmpz00_28713);
																																																																							}
																																																																							if (BgL_test10404z00_28712)
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									BgL_test10403z00_28711
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										0);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									BgL_test10403z00_28711
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										1);
																																																																								}
																																																																						}
																																																																						if (BgL_test10403z00_28711)
																																																																							{
																																																																								obj_t
																																																																									BgL_l1471z00_28717;
																																																																								BgL_l1471z00_28717
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_l1471z00_5239));
																																																																								BgL_l1471z00_5239
																																																																									=
																																																																									BgL_l1471z00_28717;
																																																																								goto
																																																																									BgL_zc3z04anonymousza34390ze3z87_5240;
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								BgL_test10401z00_28708
																																																																									=
																																																																									(
																																																																									(bool_t)
																																																																									0);
																																																																							}
																																																																					}
																																																																			}
																																																																			if (BgL_test10401z00_28708)
																																																																				{
																																																																					obj_t
																																																																						BgL_argsz00_28724;
																																																																					obj_t
																																																																						BgL_proc2z00_28723;
																																																																					obj_t
																																																																						BgL_proc1z00_28722;
																																																																					obj_t
																																																																						BgL_testz00_28720;
																																																																					BgL_testz00_28720
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd260369zd2_5196);
																																																																					BgL_proc1z00_28722
																																																																						=
																																																																						BgL_carzd260378zd2_5202;
																																																																					BgL_proc2z00_28723
																																																																						=
																																																																						BgL_carzd260384zd2_5206;
																																																																					BgL_argsz00_28724
																																																																						=
																																																																						BgL_cdrzd259977zd2_5123;
																																																																					BgL_argsz00_1747
																																																																						=
																																																																						BgL_argsz00_28724;
																																																																					BgL_proc2z00_1746
																																																																						=
																																																																						BgL_proc2z00_28723;
																																																																					BgL_proc1z00_1745
																																																																						=
																																																																						BgL_proc1z00_28722;
																																																																					BgL_testz00_1744
																																																																						=
																																																																						BgL_testz00_28720;
																																																																					goto
																																																																						BgL_tagzd2387zd2_1748;
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd260409zd2_5223;
																																																																					BgL_cdrzd260409zd2_5223
																																																																						=
																																																																						CDR
																																																																						(BgL_expz00_21);
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd260417zd2_5224;
																																																																						BgL_cdrzd260417zd2_5224
																																																																							=
																																																																							CDR
																																																																							(CAR
																																																																							(BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd260425zd2_5225;
																																																																							BgL_cdrzd260425zd2_5225
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd260417zd2_5224));
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_carzd260432zd2_5226;
																																																																								BgL_carzd260432zd2_5226
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd260425zd2_5225));
																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd260432zd2_5226))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_carzd260441zd2_5228;
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_pairz00_13442;
																																																																											BgL_pairz00_13442
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd260425zd2_5225));
																																																																											BgL_carzd260441zd2_5228
																																																																												=
																																																																												CAR
																																																																												(BgL_pairz00_13442);
																																																																										}
																																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd260441zd2_5228))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd260409zd2_5223))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_arg4384z00_5231;
																																																																														BgL_arg4384z00_5231
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd260417zd2_5224));
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_28746;
																																																																															obj_t
																																																																																BgL_proc2z00_28745;
																																																																															obj_t
																																																																																BgL_proc1z00_28744;
																																																																															obj_t
																																																																																BgL_testz00_28743;
																																																																															BgL_testz00_28743
																																																																																=
																																																																																BgL_arg4384z00_5231;
																																																																															BgL_proc1z00_28744
																																																																																=
																																																																																BgL_carzd260432zd2_5226;
																																																																															BgL_proc2z00_28745
																																																																																=
																																																																																BgL_carzd260441zd2_5228;
																																																																															BgL_argsz00_28746
																																																																																=
																																																																																BgL_cdrzd260409zd2_5223;
																																																																															BgL_argsz00_1752
																																																																																=
																																																																																BgL_argsz00_28746;
																																																																															BgL_proc2z00_1751
																																																																																=
																																																																																BgL_proc2z00_28745;
																																																																															BgL_proc1z00_1750
																																																																																=
																																																																																BgL_proc1z00_28744;
																																																																															BgL_testz00_1749
																																																																																=
																																																																																BgL_testz00_28743;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1753;
																																																																														}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{
																																																																																obj_t
																																																																																	BgL_auxz00_28749;
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1777;
																																																																																return
																																																																																	(
																																																																																	(BgL_nodez00_bglt)
																																																																																	BgL_auxz00_28749);
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1778;
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{
																																																																														obj_t
																																																																															BgL_auxz00_28753;
																																																																														goto
																																																																															BgL_tagzd2403zd2_1777;
																																																																														return
																																																																															(
																																																																															(BgL_nodez00_bglt)
																																																																															BgL_auxz00_28753);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2404zd2_1778;
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{
																																																																												obj_t
																																																																													BgL_auxz00_28757;
																																																																												goto
																																																																													BgL_tagzd2403zd2_1777;
																																																																												return
																																																																													(
																																																																													(BgL_nodez00_bglt)
																																																																													BgL_auxz00_28757);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2404zd2_1778;
																																																																											}
																																																																									}
																																																																							}
																																																																						}
																																																																					}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{
																																																																					obj_t
																																																																						BgL_auxz00_28761;
																																																																					goto
																																																																						BgL_tagzd2403zd2_1777;
																																																																					return
																																																																						(
																																																																						(BgL_nodez00_bglt)
																																																																						BgL_auxz00_28761);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					goto
																																																																						BgL_tagzd2404zd2_1778;
																																																																				}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd260719zd2_5250;
																																																																	BgL_cdrzd260719zd2_5250
																																																																		=
																																																																		CDR
																																																																		(BgL_expz00_21);
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd260726zd2_5251;
																																																																		BgL_cdrzd260726zd2_5251
																																																																			=
																																																																			CDR
																																																																			(CAR
																																																																			(BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd260733zd2_5252;
																																																																			BgL_cdrzd260733zd2_5252
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd260726zd2_5251));
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_carzd260739zd2_5253;
																																																																				obj_t
																																																																					BgL_cdrzd260740zd2_5254;
																																																																				BgL_carzd260739zd2_5253
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd260733zd2_5252));
																																																																				BgL_cdrzd260740zd2_5254
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd260733zd2_5252));
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd260739zd2_5253))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_carzd260747zd2_5256;
																																																																						BgL_carzd260747zd2_5256
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd260740zd2_5254));
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd260747zd2_5256))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (NULLP(CDR(((obj_t) BgL_cdrzd260740zd2_5254))))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd260719zd2_5250))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_arg4399z00_5261;
																																																																												BgL_arg4399z00_5261
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd260726zd2_5251));
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_28789;
																																																																													obj_t
																																																																														BgL_proc2z00_28788;
																																																																													obj_t
																																																																														BgL_proc1z00_28787;
																																																																													obj_t
																																																																														BgL_testz00_28786;
																																																																													BgL_testz00_28786
																																																																														=
																																																																														BgL_arg4399z00_5261;
																																																																													BgL_proc1z00_28787
																																																																														=
																																																																														BgL_carzd260739zd2_5253;
																																																																													BgL_proc2z00_28788
																																																																														=
																																																																														BgL_carzd260747zd2_5256;
																																																																													BgL_argsz00_28789
																																																																														=
																																																																														BgL_cdrzd260719zd2_5250;
																																																																													BgL_argsz00_1752
																																																																														=
																																																																														BgL_argsz00_28789;
																																																																													BgL_proc2z00_1751
																																																																														=
																																																																														BgL_proc2z00_28788;
																																																																													BgL_proc1z00_1750
																																																																														=
																																																																														BgL_proc1z00_28787;
																																																																													BgL_testz00_1749
																																																																														=
																																																																														BgL_testz00_28786;
																																																																													goto
																																																																														BgL_tagzd2388zd2_1753;
																																																																												}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{
																																																																														obj_t
																																																																															BgL_auxz00_28792;
																																																																														goto
																																																																															BgL_tagzd2403zd2_1777;
																																																																														return
																																																																															(
																																																																															(BgL_nodez00_bglt)
																																																																															BgL_auxz00_28792);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2404zd2_1778;
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{
																																																																												obj_t
																																																																													BgL_auxz00_28796;
																																																																												goto
																																																																													BgL_tagzd2403zd2_1777;
																																																																												return
																																																																													(
																																																																													(BgL_nodez00_bglt)
																																																																													BgL_auxz00_28796);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2404zd2_1778;
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{
																																																																										obj_t
																																																																											BgL_auxz00_28800;
																																																																										goto
																																																																											BgL_tagzd2403zd2_1777;
																																																																										return
																																																																											(
																																																																											(BgL_nodez00_bglt)
																																																																											BgL_auxz00_28800);
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2404zd2_1778;
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{
																																																																								obj_t
																																																																									BgL_auxz00_28804;
																																																																								goto
																																																																									BgL_tagzd2403zd2_1777;
																																																																								return
																																																																									(
																																																																									(BgL_nodez00_bglt)
																																																																									BgL_auxz00_28804);
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2404zd2_1778;
																																																																							}
																																																																					}
																																																																			}
																																																																		}
																																																																	}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{
																																																																	obj_t
																																																																		BgL_auxz00_28808;
																																																																	goto
																																																																		BgL_tagzd2403zd2_1777;
																																																																	return
																																																																		(
																																																																		(BgL_nodez00_bglt)
																																																																		BgL_auxz00_28808);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	goto
																																																																		BgL_tagzd2404zd2_1778;
																																																																}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd261080zd2_5269;
																																																													BgL_cdrzd261080zd2_5269
																																																														=
																																																														CDR
																																																														(BgL_expz00_21);
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd261086zd2_5270;
																																																														BgL_cdrzd261086zd2_5270
																																																															=
																																																															CDR
																																																															(CAR
																																																															(BgL_expz00_21));
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd261092zd2_5271;
																																																															BgL_cdrzd261092zd2_5271
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd261086zd2_5270));
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_carzd261097zd2_5272;
																																																																obj_t
																																																																	BgL_cdrzd261098zd2_5273;
																																																																BgL_carzd261097zd2_5272
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd261092zd2_5271));
																																																																BgL_cdrzd261098zd2_5273
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd261092zd2_5271));
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd261097zd2_5272))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (PAIRP(BgL_cdrzd261098zd2_5273))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_carzd261103zd2_5276;
																																																																				BgL_carzd261103zd2_5276
																																																																					=
																																																																					CAR
																																																																					(BgL_cdrzd261098zd2_5273);
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd261103zd2_5276))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (NULLP(CDR(BgL_cdrzd261098zd2_5273)))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd261080zd2_5269))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_arg4413z00_5281;
																																																																										BgL_arg4413z00_5281
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd261086zd2_5270));
																																																																										{
																																																																											obj_t
																																																																												BgL_argsz00_28836;
																																																																											obj_t
																																																																												BgL_proc2z00_28835;
																																																																											obj_t
																																																																												BgL_proc1z00_28834;
																																																																											obj_t
																																																																												BgL_testz00_28833;
																																																																											BgL_testz00_28833
																																																																												=
																																																																												BgL_arg4413z00_5281;
																																																																											BgL_proc1z00_28834
																																																																												=
																																																																												BgL_carzd261097zd2_5272;
																																																																											BgL_proc2z00_28835
																																																																												=
																																																																												BgL_carzd261103zd2_5276;
																																																																											BgL_argsz00_28836
																																																																												=
																																																																												BgL_cdrzd261080zd2_5269;
																																																																											BgL_argsz00_1752
																																																																												=
																																																																												BgL_argsz00_28836;
																																																																											BgL_proc2z00_1751
																																																																												=
																																																																												BgL_proc2z00_28835;
																																																																											BgL_proc1z00_1750
																																																																												=
																																																																												BgL_proc1z00_28834;
																																																																											BgL_testz00_1749
																																																																												=
																																																																												BgL_testz00_28833;
																																																																											goto
																																																																												BgL_tagzd2388zd2_1753;
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{
																																																																												obj_t
																																																																													BgL_auxz00_28839;
																																																																												goto
																																																																													BgL_tagzd2403zd2_1777;
																																																																												return
																																																																													(
																																																																													(BgL_nodez00_bglt)
																																																																													BgL_auxz00_28839);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2404zd2_1778;
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{
																																																																										obj_t
																																																																											BgL_auxz00_28843;
																																																																										goto
																																																																											BgL_tagzd2403zd2_1777;
																																																																										return
																																																																											(
																																																																											(BgL_nodez00_bglt)
																																																																											BgL_auxz00_28843);
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2404zd2_1778;
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{
																																																																								obj_t
																																																																									BgL_auxz00_28847;
																																																																								goto
																																																																									BgL_tagzd2403zd2_1777;
																																																																								return
																																																																									(
																																																																									(BgL_nodez00_bglt)
																																																																									BgL_auxz00_28847);
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2404zd2_1778;
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{
																																																																						obj_t
																																																																							BgL_auxz00_28851;
																																																																						goto
																																																																							BgL_tagzd2403zd2_1777;
																																																																						return
																																																																							(
																																																																							(BgL_nodez00_bglt)
																																																																							BgL_auxz00_28851);
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2404zd2_1778;
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{
																																																																				obj_t
																																																																					BgL_auxz00_28855;
																																																																				goto
																																																																					BgL_tagzd2403zd2_1777;
																																																																				return
																																																																					(
																																																																					(BgL_nodez00_bglt)
																																																																					BgL_auxz00_28855);
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2404zd2_1778;
																																																																			}
																																																																	}
																																																															}
																																																														}
																																																													}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{
																																																													obj_t
																																																														BgL_auxz00_28859;
																																																													goto
																																																														BgL_tagzd2403zd2_1777;
																																																													return
																																																														(
																																																														(BgL_nodez00_bglt)
																																																														BgL_auxz00_28859);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													goto
																																																														BgL_tagzd2404zd2_1778;
																																																												}
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																										{
																																																											obj_t
																																																												BgL_auxz00_28863;
																																																											goto
																																																												BgL_tagzd2403zd2_1777;
																																																											return
																																																												(
																																																												(BgL_nodez00_bglt)
																																																												BgL_auxz00_28863);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											goto
																																																												BgL_tagzd2404zd2_1778;
																																																										}
																																																								}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																								{
																																																									obj_t
																																																										BgL_auxz00_28867;
																																																									goto
																																																										BgL_tagzd2403zd2_1777;
																																																									return
																																																										(
																																																										(BgL_nodez00_bglt)
																																																										BgL_auxz00_28867);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									goto
																																																										BgL_tagzd2404zd2_1778;
																																																								}
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																													}
																																												}
																																											}
																																									}
																																							}
																																					}
																																			}
																																	}
																																}
																															else
																																{

																																	if (
																																		(BgL_carzd255411zd2_5106
																																			==
																																			CNST_TABLE_REF
																																			(((long)
																																					17))))
																																		{
																																			obj_t
																																				BgL_auxz00_28872;
																																		BgL_kapzd261641zd2_5689:
																																			if (PAIRP
																																				(BgL_cdrzd255282zd2_5088))
																																				{	/* Ast/sexp.scm 119 */
																																					obj_t
																																						BgL_arg4767z00_5786;
																																					obj_t
																																						BgL_arg4768z00_5787;
																																					BgL_arg4767z00_5786
																																						=
																																						CAR
																																						(BgL_cdrzd255282zd2_5088);
																																					BgL_arg4768z00_5787
																																						=
																																						CDR
																																						(BgL_cdrzd255282zd2_5088);
																																					{
																																						BgL_nodez00_bglt
																																							BgL_auxz00_28877;
																																						{
																																							obj_t
																																								BgL_exprz00_28879;
																																							obj_t
																																								BgL_bindingsz00_28878;
																																							BgL_bindingsz00_28878
																																								=
																																								BgL_arg4767z00_5786;
																																							BgL_exprz00_28879
																																								=
																																								BgL_arg4768z00_5787;
																																							BgL_exprz00_1732
																																								=
																																								BgL_exprz00_28879;
																																							BgL_bindingsz00_1731
																																								=
																																								BgL_bindingsz00_28878;
																																							goto
																																								BgL_tagzd2382zd2_1733;
																																						}
																																						BgL_auxz00_28872
																																							=
																																							(
																																							(obj_t)
																																							BgL_auxz00_28877);
																																					}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					if (
																																						(CAR
																																							(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_28886;
																																							goto
																																								BgL_tagzd2383zd2_1734;
																																							BgL_auxz00_28872
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_28886);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							obj_t
																																								BgL_carzd261674zd2_5790;
																																							BgL_carzd261674zd2_5790
																																								=
																																								CAR
																																								(
																																								((obj_t) BgL_expz00_21));
																																							if ((BgL_carzd261674zd2_5790 == CNST_TABLE_REF(((long) 19))))
																																								{
																																									BgL_letzd2funzd2_bglt
																																										BgL_auxz00_28893;
																																									goto
																																										BgL_tagzd2384zd2_1735;
																																									BgL_auxz00_28872
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_28893);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd261674zd2_5790)))
																																										{
																																											BgL_letzd2funzd2_bglt
																																												BgL_auxz00_28898;
																																											goto
																																												BgL_tagzd2384zd2_1735;
																																											BgL_auxz00_28872
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_28898);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_28905;
																																													goto
																																														BgL_tagzd2389zd2_1754;
																																													BgL_auxz00_28872
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_28905);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_28912;
																																															goto
																																																BgL_tagzd2390zd2_1755;
																																															BgL_auxz00_28872
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_28912);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_28919;
																																																	goto
																																																		BgL_tagzd2392zd2_1759;
																																																	BgL_auxz00_28872
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_28919);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_28926;
																																																			goto
																																																				BgL_tagzd2393zd2_1760;
																																																			BgL_auxz00_28872
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_28926);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_28933;
																																																					goto
																																																						BgL_tagzd2395zd2_1764;
																																																					BgL_auxz00_28872
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_28933);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_28940;
																																																							goto
																																																								BgL_tagzd2396zd2_1765;
																																																							BgL_auxz00_28872
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_28940);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_28947;
																																																									goto
																																																										BgL_tagzd2397zd2_1766;
																																																									BgL_auxz00_28872
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_28947);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																										{
																																																											BgL_jumpzd2exzd2itz00_bglt
																																																												BgL_auxz00_28954;
																																																											goto
																																																												BgL_tagzd2398zd2_1767;
																																																											BgL_auxz00_28872
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_28954);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (BGl_equalzf3zf3zz__r4_equivalence_6_2z00(CAR(((obj_t) BgL_expz00_21)), BUNSPEC))
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (NULLP(CDR(((obj_t) BgL_expz00_21))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_28964;
																																																															goto
																																																																BgL_tagzd2402zd2_1776;
																																																															BgL_auxz00_28872
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_28964);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1777;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_28968;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1778;
																																																																	BgL_auxz00_28872
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_28968);
																																																																}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{	/* Ast/sexp.scm 119 */
																																																															goto
																																																																BgL_tagzd2403zd2_1777;
																																																														}
																																																													else
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_28972;
																																																															goto
																																																																BgL_tagzd2404zd2_1778;
																																																															BgL_auxz00_28872
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_28972);
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																			return
																																				(
																																				(BgL_nodez00_bglt)
																																				BgL_auxz00_28872);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 119 */
																																			if (CBOOL
																																				(BGl_letzd2symzf3z21zzast_letz00
																																					(BgL_carzd255411zd2_5106)))
																																				{
																																					obj_t
																																						BgL_auxz00_28978;
																																					goto
																																						BgL_kapzd261641zd2_5689;
																																					return
																																						(
																																						(BgL_nodez00_bglt)
																																						BgL_auxz00_28978);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					if (
																																						(BgL_carzd255411zd2_5106
																																							==
																																							CNST_TABLE_REF
																																							(((long) 18))))
																																						{
																																							obj_t
																																								BgL_auxz00_28983;
																																							goto
																																								BgL_kapzd261641zd2_5689;
																																							return
																																								(
																																								(BgL_nodez00_bglt)
																																								BgL_auxz00_28983);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 20))))
																																								{	/* Ast/sexp.scm 119 */
																																									goto
																																										BgL_tagzd2383zd2_1734;
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									obj_t
																																										BgL_carzd261835zd2_5695;
																																									BgL_carzd261835zd2_5695
																																										=
																																										CAR
																																										(BgL_expz00_21);
																																									if ((BgL_carzd261835zd2_5695 == CNST_TABLE_REF(((long) 19))))
																																										{
																																											BgL_letzd2funzd2_bglt
																																												BgL_auxz00_28993;
																																											goto
																																												BgL_tagzd2384zd2_1735;
																																											return
																																												(
																																												(BgL_nodez00_bglt)
																																												BgL_auxz00_28993);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd261835zd2_5695)))
																																												{
																																													BgL_letzd2funzd2_bglt
																																														BgL_auxz00_28998;
																																													goto
																																														BgL_tagzd2384zd2_1735;
																																													return
																																														(
																																														(BgL_nodez00_bglt)
																																														BgL_auxz00_28998);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 3))))
																																														{	/* Ast/sexp.scm 119 */
																																															goto
																																																BgL_tagzd2389zd2_1754;
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 6))))
																																																{	/* Ast/sexp.scm 119 */
																																																	goto
																																																		BgL_tagzd2390zd2_1755;
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_cdrzd261914zd2_5702;
																																																	BgL_cdrzd261914zd2_5702
																																																		=
																																																		CDR
																																																		(BgL_expz00_21);
																																																	if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 21))))
																																																		{	/* Ast/sexp.scm 119 */
																																																			if (PAIRP(BgL_cdrzd261914zd2_5702))
																																																				{
																																																					obj_t
																																																						BgL_restz00_29017;
																																																					obj_t
																																																						BgL_effectz00_29015;
																																																					BgL_effectz00_29015
																																																						=
																																																						CAR
																																																						(BgL_cdrzd261914zd2_5702);
																																																					BgL_restz00_29017
																																																						=
																																																						CDR
																																																						(BgL_cdrzd261914zd2_5702);
																																																					BgL_restz00_1757
																																																						=
																																																						BgL_restz00_29017;
																																																					BgL_effectz00_1756
																																																						=
																																																						BgL_effectz00_29015;
																																																					goto
																																																						BgL_tagzd2391zd2_1758;
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																						{
																																																							obj_t
																																																								BgL_auxz00_29021;
																																																							goto
																																																								BgL_tagzd2403zd2_1777;
																																																							return
																																																								(
																																																								(BgL_nodez00_bglt)
																																																								BgL_auxz00_29021);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							goto
																																																								BgL_tagzd2404zd2_1778;
																																																						}
																																																				}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 22))))
																																																				{	/* Ast/sexp.scm 119 */
																																																					goto
																																																						BgL_tagzd2392zd2_1759;
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 23))))
																																																						{	/* Ast/sexp.scm 119 */
																																																							goto
																																																								BgL_tagzd2393zd2_1760;
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 24))))
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (PAIRP(BgL_cdrzd261914zd2_5702))
																																																										{
																																																											obj_t
																																																												BgL_restz00_29039;
																																																											obj_t
																																																												BgL_effectz00_29037;
																																																											BgL_effectz00_29037
																																																												=
																																																												CAR
																																																												(BgL_cdrzd261914zd2_5702);
																																																											BgL_restz00_29039
																																																												=
																																																												CDR
																																																												(BgL_cdrzd261914zd2_5702);
																																																											BgL_restz00_1762
																																																												=
																																																												BgL_restz00_29039;
																																																											BgL_effectz00_1761
																																																												=
																																																												BgL_effectz00_29037;
																																																											goto
																																																												BgL_tagzd2394zd2_1763;
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{
																																																													obj_t
																																																														BgL_auxz00_29043;
																																																													goto
																																																														BgL_tagzd2403zd2_1777;
																																																													return
																																																														(
																																																														(BgL_nodez00_bglt)
																																																														BgL_auxz00_29043);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													goto
																																																														BgL_tagzd2404zd2_1778;
																																																												}
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 25))))
																																																										{	/* Ast/sexp.scm 119 */
																																																											goto
																																																												BgL_tagzd2395zd2_1764;
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 26))))
																																																												{	/* Ast/sexp.scm 119 */
																																																													goto
																																																														BgL_tagzd2396zd2_1765;
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 27))))
																																																														{
																																																															BgL_letzd2funzd2_bglt
																																																																BgL_auxz00_29057;
																																																															goto
																																																																BgL_tagzd2397zd2_1766;
																																																															return
																																																																(
																																																																(BgL_nodez00_bglt)
																																																																BgL_auxz00_29057);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 28))))
																																																																{
																																																																	BgL_jumpzd2exzd2itz00_bglt
																																																																		BgL_auxz00_29063;
																																																																	goto
																																																																		BgL_tagzd2398zd2_1767;
																																																																	return
																																																																		(
																																																																		(BgL_nodez00_bglt)
																																																																		BgL_auxz00_29063);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd262041zd2_5728;
																																																																	BgL_cdrzd262041zd2_5728
																																																																		=
																																																																		CDR
																																																																		(BgL_expz00_21);
																																																																	if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 30))))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (PAIRP(BgL_cdrzd262041zd2_5728))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd262043zd2_5732;
																																																																					BgL_cdrzd262043zd2_5732
																																																																						=
																																																																						CDR
																																																																						(BgL_cdrzd262041zd2_5728);
																																																																					if (PAIRP(BgL_cdrzd262043zd2_5732))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (NULLP(CDR(BgL_cdrzd262043zd2_5732)))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2399zd2_1768;
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{
																																																																											obj_t
																																																																												BgL_auxz00_29080;
																																																																											goto
																																																																												BgL_tagzd2403zd2_1777;
																																																																											return
																																																																												(
																																																																												(BgL_nodez00_bglt)
																																																																												BgL_auxz00_29080);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2404zd2_1778;
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{
																																																																									obj_t
																																																																										BgL_auxz00_29084;
																																																																									goto
																																																																										BgL_tagzd2403zd2_1777;
																																																																									return
																																																																										(
																																																																										(BgL_nodez00_bglt)
																																																																										BgL_auxz00_29084);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2404zd2_1778;
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{
																																																																							obj_t
																																																																								BgL_auxz00_29088;
																																																																							goto
																																																																								BgL_tagzd2403zd2_1777;
																																																																							return
																																																																								(
																																																																								(BgL_nodez00_bglt)
																																																																								BgL_auxz00_29088);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2404zd2_1778;
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 29))))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (PAIRP(BgL_cdrzd262041zd2_5728))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd262088zd2_5744;
																																																																							BgL_cdrzd262088zd2_5744
																																																																								=
																																																																								CDR
																																																																								(BgL_cdrzd262041zd2_5728);
																																																																							if (PAIRP(BgL_cdrzd262088zd2_5744))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd262093zd2_5746;
																																																																									BgL_cdrzd262093zd2_5746
																																																																										=
																																																																										CDR
																																																																										(BgL_cdrzd262088zd2_5744);
																																																																									if ((CAR(BgL_cdrzd262088zd2_5744) == CNST_TABLE_REF(((long) 31))))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (PAIRP(BgL_cdrzd262093zd2_5746))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_arg4734z00_5750;
																																																																													obj_t
																																																																														BgL_arg4735z00_5751;
																																																																													obj_t
																																																																														BgL_arg4736z00_5752;
																																																																													BgL_arg4734z00_5750
																																																																														=
																																																																														CAR
																																																																														(BgL_cdrzd262041zd2_5728);
																																																																													BgL_arg4735z00_5751
																																																																														=
																																																																														CAR
																																																																														(BgL_cdrzd262093zd2_5746);
																																																																													BgL_arg4736z00_5752
																																																																														=
																																																																														CDR
																																																																														(BgL_cdrzd262093zd2_5746);
																																																																													return
																																																																														BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																														(BgL_expz00_21,
																																																																														BgL_arg4734z00_5750,
																																																																														BgL_arg4735z00_5751,
																																																																														BgL_arg4736z00_5752,
																																																																														BgL_stackz00_22,
																																																																														BGl_findzd2locationzf2locz20zztools_locationz00
																																																																														(BgL_expz00_21,
																																																																															BgL_locz00_23),
																																																																														BgL_sitez00_24);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd262106zd2_5753;
																																																																													BgL_cdrzd262106zd2_5753
																																																																														=
																																																																														CDR
																																																																														(BgL_expz00_21);
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_arg4737z00_5754;
																																																																														obj_t
																																																																															BgL_arg4738z00_5755;
																																																																														BgL_arg4737z00_5754
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd262106zd2_5753));
																																																																														BgL_arg4738z00_5755
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd262106zd2_5753));
																																																																														{	/* Ast/sexp.scm 552 */
																																																																															obj_t
																																																																																BgL_arg6965z00_13525;
																																																																															BgL_arg6965z00_13525
																																																																																=
																																																																																BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																(BgL_expz00_21,
																																																																																BgL_locz00_23);
																																																																															return
																																																																																BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																(BgL_expz00_21,
																																																																																BgL_arg4737z00_5754,
																																																																																CNST_TABLE_REF
																																																																																(((long) 4)), BgL_arg4738z00_5755, BgL_stackz00_22, BgL_arg6965z00_13525, BgL_sitez00_24);
																																																																										}}}}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd262121zd2_5756;
																																																																											BgL_cdrzd262121zd2_5756
																																																																												=
																																																																												CDR
																																																																												(BgL_expz00_21);
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_arg4739z00_5757;
																																																																												obj_t
																																																																													BgL_arg4740z00_5758;
																																																																												BgL_arg4739z00_5757
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd262121zd2_5756));
																																																																												BgL_arg4740z00_5758
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd262121zd2_5756));
																																																																												{	/* Ast/sexp.scm 552 */
																																																																													obj_t
																																																																														BgL_arg6965z00_13529;
																																																																													BgL_arg6965z00_13529
																																																																														=
																																																																														BGl_findzd2locationzf2locz20zztools_locationz00
																																																																														(BgL_expz00_21,
																																																																														BgL_locz00_23);
																																																																													return
																																																																														BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																														(BgL_expz00_21,
																																																																														BgL_arg4739z00_5757,
																																																																														CNST_TABLE_REF
																																																																														(((long) 4)), BgL_arg4740z00_5758, BgL_stackz00_22, BgL_arg6965z00_13529, BgL_sitez00_24);
																																																																								}}}}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd262136zd2_5760;
																																																																									BgL_cdrzd262136zd2_5760
																																																																										=
																																																																										CDR
																																																																										(BgL_expz00_21);
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_arg4742z00_5761;
																																																																										obj_t
																																																																											BgL_arg4743z00_5762;
																																																																										BgL_arg4742z00_5761
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd262136zd2_5760));
																																																																										BgL_arg4743z00_5762
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd262136zd2_5760));
																																																																										{	/* Ast/sexp.scm 552 */
																																																																											obj_t
																																																																												BgL_arg6965z00_13533;
																																																																											BgL_arg6965z00_13533
																																																																												=
																																																																												BGl_findzd2locationzf2locz20zztools_locationz00
																																																																												(BgL_expz00_21,
																																																																												BgL_locz00_23);
																																																																											return
																																																																												BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																												(BgL_expz00_21,
																																																																												BgL_arg4742z00_5761,
																																																																												CNST_TABLE_REF
																																																																												(((long) 4)), BgL_arg4743z00_5762, BgL_stackz00_22, BgL_arg6965z00_13533, BgL_sitez00_24);
																																																																						}}}}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{
																																																																									obj_t
																																																																										BgL_auxz00_29137;
																																																																									goto
																																																																										BgL_tagzd2403zd2_1777;
																																																																									return
																																																																										(
																																																																										(BgL_nodez00_bglt)
																																																																										BgL_auxz00_29137);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2404zd2_1778;
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_equalzf3zf3zz__r4_equivalence_6_2z00(CAR(BgL_expz00_21), BUNSPEC))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (NULLP(CDR(BgL_expz00_21)))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2402zd2_1776;
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{
																																																																											obj_t
																																																																												BgL_auxz00_29147;
																																																																											goto
																																																																												BgL_tagzd2403zd2_1777;
																																																																											return
																																																																												(
																																																																												(BgL_nodez00_bglt)
																																																																												BgL_auxz00_29147);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2404zd2_1778;
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{
																																																																									obj_t
																																																																										BgL_auxz00_29151;
																																																																									goto
																																																																										BgL_tagzd2403zd2_1777;
																																																																									return
																																																																										(
																																																																										(BgL_nodez00_bglt)
																																																																										BgL_auxz00_29151);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2404zd2_1778;
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																										}
																								}
																						}
																				}
																			}
																	}
															}
													}
											}
									}
								else
									{	/* Ast/sexp.scm 119 */
										BgL_atomz00_1709 = BgL_expz00_21;
										{	/* Ast/sexp.scm 135 */
											bool_t BgL_test10487z00_29153;

											if (BGl_isazf3zf3zz__objectz00(BgL_atomz00_1709,
													BGl_localz00zzast_varz00))
												{	/* Ast/sexp.scm 135 */
													BgL_test10487z00_29153 = ((bool_t) 1);
												}
											else
												{	/* Ast/sexp.scm 135 */
													BgL_test10487z00_29153 =
														BGl_isazf3zf3zz__objectz00(BgL_atomz00_1709,
														BGl_globalz00zzast_varz00);
												}
											if (BgL_test10487z00_29153)
												{	/* Ast/sexp.scm 135 */
													return
														BGl_variablezd2ze3nodez31zzast_sexpz00
														(BgL_atomz00_1709, BgL_locz00_23, BgL_sitez00_24);
												}
											else
												{	/* Ast/sexp.scm 137 */
													bool_t BgL_test10489z00_29158;

													if (STRUCTP(BgL_atomz00_1709))
														{	/* Ast/sexp.scm 137 */
															BgL_test10489z00_29158 = ((bool_t) 1);
														}
													else
														{	/* Ast/sexp.scm 137 */
															if (VECTORP(BgL_atomz00_1709))
																{	/* Ast/sexp.scm 137 */
																	BgL_test10489z00_29158 = ((bool_t) 1);
																}
															else
																{	/* Ast/sexp.scm 137 */
																	if (BGL_OBJECTP(BgL_atomz00_1709))
																		{	/* Ast/sexp.scm 137 */
																			BgL_test10489z00_29158 = ((bool_t) 1);
																		}
																	else
																		{	/* Ast/sexp.scm 137 */
																			BgL_test10489z00_29158 =
																				PROCEDUREP(BgL_atomz00_1709);
																		}
																}
														}
													if (BgL_test10489z00_29158)
														{	/* Ast/sexp.scm 138 */
															BgL_nodez00_bglt BgL_res7315z00_9643;

															{	/* Ast/sexp.scm 723 */
																obj_t BgL_arg7080z00_9639;
																BgL_nodez00_bglt BgL_arg7081z00_9640;

																BgL_arg7080z00_9639 =
																	BGl_shapez00zztools_shapez00
																	(BGl_currentzd2functionzd2zztools_errorz00());
																BgL_arg7081z00_9640 =
																	BGl_sexpzd2ze3nodez31zzast_sexpz00
																	(CNST_TABLE_REF(((long) 4)), BNIL,
																	BgL_locz00_23, CNST_TABLE_REF(((long) 2)));
																{	/* Ast/sexp.scm 722 */
																	obj_t BgL_list7082z00_9642;

																	BgL_list7082z00_9642 =
																		MAKE_YOUNG_PAIR(
																		((obj_t) BgL_arg7081z00_9640), BNIL);
																	BgL_res7315z00_9643 =
																		((BgL_nodez00_bglt)
																		BGl_userzd2errorzf2locationz20zztools_errorz00
																		(BgL_locz00_23, BgL_arg7080z00_9639,
																			BGl_string8011z00zzast_sexpz00,
																			BgL_expz00_21, BgL_list7082z00_9642));
															}}
															return BgL_res7315z00_9643;
														}
													else
														{	/* Ast/sexp.scm 137 */
															if (SYMBOLP(BgL_atomz00_1709))
																{	/* Ast/sexp.scm 144 */
																	obj_t BgL_g1116z00_8367;

																	BgL_g1116z00_8367 =
																		BGl_findzd2localzd2zzast_sexpz00
																		(BgL_atomz00_1709, BgL_stackz00_22);
																	if (CBOOL(BgL_g1116z00_8367))
																		{	/* Ast/sexp.scm 144 */
																			return
																				BGl_variablezd2ze3nodez31zzast_sexpz00
																				(BgL_g1116z00_8367, BgL_locz00_23,
																				BgL_sitez00_24);
																		}
																	else
																		{	/* Ast/sexp.scm 148 */
																			obj_t BgL_globalz00_8370;
																			obj_t BgL_locz00_8371;

																			BgL_globalz00_8370 =
																				BGl_findzd2globalzd2zzast_envz00
																				(BgL_atomz00_1709, BNIL);
																			BgL_locz00_8371 =
																				BGl_findzd2locationzf2locz20zztools_locationz00
																				(BgL_atomz00_1709, BgL_locz00_23);
																			if (BGl_isazf3zf3zz__objectz00
																				(BgL_globalz00_8370,
																					BGl_globalz00zzast_varz00))
																				{	/* Ast/sexp.scm 151 */
																					if (
																						((((BgL_globalz00_bglt) COBJECT(
																										((BgL_globalz00_bglt)
																											BgL_globalz00_8370)))->
																								BgL_importz00) ==
																							CNST_TABLE_REF(((long) 10))))
																						{	/* Ast/sexp.scm 154 */
																							obj_t BgL_arg6607z00_8375;

																							{	/* Ast/sexp.scm 154 */
																								obj_t BgL_arg6608z00_8376;

																								{	/* Ast/sexp.scm 154 */
																									obj_t BgL_arg6609z00_8377;

																									{	/* Ast/sexp.scm 154 */
																										obj_t BgL_arg6610z00_8378;

																										BgL_arg6610z00_8378 =
																											MAKE_YOUNG_PAIR
																											(BgL_atomz00_1709, BNIL);
																										BgL_arg6609z00_8377 =
																											MAKE_YOUNG_PAIR
																											(CNST_TABLE_REF(((long)
																													12)),
																											BgL_arg6610z00_8378);
																									}
																									BgL_arg6608z00_8376 =
																										MAKE_YOUNG_PAIR
																										(BgL_arg6609z00_8377, BNIL);
																								}
																								BgL_arg6607z00_8375 =
																									MAKE_YOUNG_PAIR(CNST_TABLE_REF
																									(((long) 10)),
																									BgL_arg6608z00_8376);
																							}
																							{
																								obj_t BgL_locz00_29197;
																								obj_t BgL_expz00_29196;

																								BgL_expz00_29196 =
																									BgL_arg6607z00_8375;
																								BgL_locz00_29197 =
																									BgL_locz00_8371;
																								BgL_locz00_23 =
																									BgL_locz00_29197;
																								BgL_expz00_21 =
																									BgL_expz00_29196;
																								goto
																									BGl_sexpzd2ze3nodez31zzast_sexpz00;
																							}
																						}
																					else
																						{	/* Ast/sexp.scm 153 */
																							return
																								BGl_variablezd2ze3nodez31zzast_sexpz00
																								(BgL_globalz00_8370,
																								BgL_locz00_8371,
																								BgL_sitez00_24);
																						}
																				}
																			else
																				{	/* Ast/sexp.scm 152 */
																					BgL_nodez00_bglt BgL_res7318z00_9652;

																					{	/* Ast/sexp.scm 723 */
																						obj_t BgL_arg7080z00_9648;
																						BgL_nodez00_bglt
																							BgL_arg7081z00_9649;
																						BgL_arg7080z00_9648 =
																							BGl_shapez00zztools_shapez00
																							(BGl_currentzd2functionzd2zztools_errorz00
																							());
																						BgL_arg7081z00_9649 =
																							BGl_sexpzd2ze3nodez31zzast_sexpz00
																							(CNST_TABLE_REF(((long) 4)), BNIL,
																							BgL_locz00_8371,
																							CNST_TABLE_REF(((long) 2)));
																						{	/* Ast/sexp.scm 722 */
																							obj_t BgL_list7082z00_9651;

																							BgL_list7082z00_9651 =
																								MAKE_YOUNG_PAIR(
																								((obj_t) BgL_arg7081z00_9649),
																								BNIL);
																							BgL_res7318z00_9652 =
																								((BgL_nodez00_bglt)
																								BGl_userzd2errorzf2locationz20zztools_errorz00
																								(BgL_locz00_8371,
																									BgL_arg7080z00_9648,
																									BGl_string8010z00zzast_sexpz00,
																									BgL_expz00_21,
																									BgL_list7082z00_9651));
																					}}
																					return BgL_res7318z00_9652;
																				}
																		}
																}
															else
																{	/* Ast/sexp.scm 140 */
																	BgL_literalz00_bglt BgL_new1115z00_8381;

																	{	/* Ast/sexp.scm 141 */
																		BgL_literalz00_bglt BgL_new1114z00_8382;

																		BgL_new1114z00_8382 =
																			((BgL_literalz00_bglt)
																			BOBJECT(GC_MALLOC(sizeof(struct
																						BgL_literalz00_bgl))));
																		{	/* Ast/sexp.scm 141 */
																			long BgL_arg6613z00_8383;

																			{	/* Ast/sexp.scm 141 */
																				long BgL_res7319z00_9654;

																				BgL_res7319z00_9654 =
																					BGL_CLASS_INDEX
																					(BGl_literalz00zzast_nodez00);
																				BgL_arg6613z00_8383 =
																					BgL_res7319z00_9654;
																			}
																			BGL_OBJECT_CLASS_NUM_SET(
																				((BgL_objectz00_bglt)
																					BgL_new1114z00_8382),
																				BgL_arg6613z00_8383);
																		}
																		{	/* Ast/sexp.scm 141 */
																			BgL_objectz00_bglt BgL_tmpz00_29212;

																			BgL_tmpz00_29212 =
																				((BgL_objectz00_bglt)
																				BgL_new1114z00_8382);
																			BGL_OBJECT_WIDENING_SET(BgL_tmpz00_29212,
																				BFALSE);
																		}
																		((BgL_objectz00_bglt) BgL_new1114z00_8382);
																		BgL_new1115z00_8381 = BgL_new1114z00_8382;
																	}
																	((((BgL_nodez00_bglt) COBJECT(
																					((BgL_nodez00_bglt)
																						BgL_new1115z00_8381)))->
																			BgL_locz00) =
																		((obj_t) BgL_locz00_23), BUNSPEC);
																	((((BgL_nodez00_bglt)
																				COBJECT(((BgL_nodez00_bglt)
																						BgL_new1115z00_8381)))->
																			BgL_typez00) =
																		((BgL_typez00_bglt)
																			BGl_getzd2typezd2atomz00zztype_typeofz00
																			(BgL_atomz00_1709)), BUNSPEC);
																	((((BgL_atomz00_bglt)
																				COBJECT(((BgL_atomz00_bglt)
																						BgL_new1115z00_8381)))->
																			BgL_valuez00) =
																		((obj_t) BgL_atomz00_1709), BUNSPEC);
																	return ((BgL_nodez00_bglt)
																		BgL_new1115z00_8381);
																}
														}
												}
										}
									}
							}
					}
			}
		}

	}



/* liip~0 */
	obj_t BGl_liipze70ze7zzast_sexpz00(obj_t BgL_argsz00_8793)
	{
		{	/* Ast/sexp.scm 396 */
			if (NULLP(BgL_argsz00_8793))
				{	/* Ast/sexp.scm 397 */
					return CNST_TABLE_REF(((long) 4));
				}
			else
				{	/* Ast/sexp.scm 399 */
					obj_t BgL_arg6856z00_8796;

					{	/* Ast/sexp.scm 399 */
						obj_t BgL_arg6857z00_8797;
						obj_t BgL_arg6858z00_8798;

						BgL_arg6857z00_8797 = CAR(((obj_t) BgL_argsz00_8793));
						{	/* Ast/sexp.scm 400 */
							obj_t BgL_arg6859z00_8799;

							{	/* Ast/sexp.scm 400 */
								obj_t BgL_arg6860z00_8800;

								BgL_arg6860z00_8800 = CDR(((obj_t) BgL_argsz00_8793));
								BgL_arg6859z00_8799 =
									BGl_liipze70ze7zzast_sexpz00(BgL_arg6860z00_8800);
							}
							BgL_arg6858z00_8798 = MAKE_YOUNG_PAIR(BgL_arg6859z00_8799, BNIL);
						}
						BgL_arg6856z00_8796 =
							MAKE_YOUNG_PAIR(BgL_arg6857z00_8797, BgL_arg6858z00_8798);
					}
					return
						MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 32)), BgL_arg6856z00_8796);
		}}

	}



/* loop~0 */
	obj_t BGl_loopze70ze7zzast_sexpz00(obj_t BgL_expz00_13853,
		obj_t BgL_locz00_13852, obj_t BgL_varsz00_8755, obj_t BgL_argsz00_8756)
	{
		{	/* Ast/sexp.scm 381 */
		BGl_loopze70ze7zzast_sexpz00:
			if (NULLP(BgL_varsz00_8755))
				{	/* Ast/sexp.scm 384 */
					if (NULLP(BgL_argsz00_8756))
						{	/* Ast/sexp.scm 385 */
							return BNIL;
						}
					else
						{	/* Ast/sexp.scm 385 */
							return
								BGl_userzd2errorzf2locationz20zztools_errorz00(BgL_locz00_13852,
								BGl_shapez00zztools_shapez00
								(BGl_currentzd2functionzd2zztools_errorz00()),
								BGl_string8013z00zzast_sexpz00, BgL_expz00_13853, BNIL);
						}
				}
			else
				{	/* Ast/sexp.scm 384 */
					if (PAIRP(BgL_varsz00_8755))
						{	/* Ast/sexp.scm 392 */
							if (BGl_dssslzd2namedzd2constantzf3zf3zz__dssslz00(CAR
									(BgL_varsz00_8755)))
								{	/* Ast/sexp.scm 402 */
									obj_t BgL_argz00_8766;

									BgL_argz00_8766 =
										BGl_dssslzd2findzd2firstzd2formalzd2zztools_dssslz00(CDR
										(BgL_varsz00_8755));
									if (CBOOL(BgL_argz00_8766))
										{
											obj_t BgL_varsz00_29252;

											BgL_varsz00_29252 = BgL_argz00_8766;
											BgL_varsz00_8755 = BgL_varsz00_29252;
											goto BGl_loopze70ze7zzast_sexpz00;
										}
									else
										{
											obj_t BgL_varsz00_29253;

											BgL_varsz00_29253 = BNIL;
											BgL_varsz00_8755 = BgL_varsz00_29253;
											goto BGl_loopze70ze7zzast_sexpz00;
										}
								}
							else
								{	/* Ast/sexp.scm 407 */
									bool_t BgL_test10503z00_29254;

									{	/* Ast/sexp.scm 407 */
										obj_t BgL_tmpz00_29255;

										BgL_tmpz00_29255 = CAR(BgL_varsz00_8755);
										BgL_test10503z00_29254 = SYMBOLP(BgL_tmpz00_29255);
									}
									if (BgL_test10503z00_29254)
										{	/* Ast/sexp.scm 407 */
											if (NULLP(BgL_argsz00_8756))
												{	/* Ast/sexp.scm 413 */
													return
														BGl_userzd2errorzf2locationz20zztools_errorz00
														(BgL_locz00_13852,
														BGl_shapez00zztools_shapez00
														(BGl_currentzd2functionzd2zztools_errorz00()),
														BGl_string8013z00zzast_sexpz00, BgL_expz00_13853,
														BNIL);
												}
											else
												{	/* Ast/sexp.scm 420 */
													obj_t BgL_arg6836z00_8774;
													obj_t BgL_arg6837z00_8775;

													{	/* Ast/sexp.scm 420 */
														obj_t BgL_arg6838z00_8776;
														obj_t BgL_arg6839z00_8777;

														BgL_arg6838z00_8776 = CAR(BgL_varsz00_8755);
														BgL_arg6839z00_8777 =
															CAR(((obj_t) BgL_argsz00_8756));
														{	/* Ast/sexp.scm 420 */
															obj_t BgL_list6840z00_8778;

															{	/* Ast/sexp.scm 420 */
																obj_t BgL_arg6841z00_8779;

																BgL_arg6841z00_8779 =
																	MAKE_YOUNG_PAIR(BgL_arg6839z00_8777, BNIL);
																BgL_list6840z00_8778 =
																	MAKE_YOUNG_PAIR(BgL_arg6838z00_8776,
																	BgL_arg6841z00_8779);
															}
															BgL_arg6836z00_8774 = BgL_list6840z00_8778;
														}
													}
													{	/* Ast/sexp.scm 421 */
														obj_t BgL_arg6842z00_8780;
														obj_t BgL_arg6843z00_8781;

														BgL_arg6842z00_8780 = CDR(BgL_varsz00_8755);
														BgL_arg6843z00_8781 =
															CDR(((obj_t) BgL_argsz00_8756));
														BgL_arg6837z00_8775 =
															BGl_loopze70ze7zzast_sexpz00(BgL_expz00_13853,
															BgL_locz00_13852, BgL_arg6842z00_8780,
															BgL_arg6843z00_8781);
													}
													return
														MAKE_YOUNG_PAIR(BgL_arg6836z00_8774,
														BgL_arg6837z00_8775);
												}
										}
									else
										{	/* Ast/sexp.scm 407 */
											return
												BGl_userzd2errorzf2locationz20zztools_errorz00
												(BgL_locz00_13852,
												BGl_shapez00zztools_shapez00
												(BGl_currentzd2functionzd2zztools_errorz00()),
												BGl_string8014z00zzast_sexpz00, BgL_expz00_13853, BNIL);
										}
								}
						}
					else
						{	/* Ast/sexp.scm 397 */
							obj_t BgL_arg6849z00_8787;

							{	/* Ast/sexp.scm 397 */
								obj_t BgL_arg6851z00_8789;

								BgL_arg6851z00_8789 =
									BGl_liipze70ze7zzast_sexpz00(BgL_argsz00_8756);
								{	/* Ast/sexp.scm 394 */
									obj_t BgL_list6852z00_8790;

									{	/* Ast/sexp.scm 394 */
										obj_t BgL_arg6853z00_8791;

										BgL_arg6853z00_8791 =
											MAKE_YOUNG_PAIR(BgL_arg6851z00_8789, BNIL);
										BgL_list6852z00_8790 =
											MAKE_YOUNG_PAIR(BgL_varsz00_8755, BgL_arg6853z00_8791);
									}
									BgL_arg6849z00_8787 = BgL_list6852z00_8790;
								}
							}
							{	/* Ast/sexp.scm 393 */
								obj_t BgL_list6850z00_8788;

								BgL_list6850z00_8788 =
									MAKE_YOUNG_PAIR(BgL_arg6849z00_8787, BNIL);
								return BgL_list6850z00_8788;
							}
						}
				}
		}

	}



/* &sexp->node */
	BgL_nodez00_bglt BGl_z62sexpzd2ze3nodez53zzast_sexpz00(obj_t BgL_envz00_13810,
		obj_t BgL_expz00_13811, obj_t BgL_stackz00_13812, obj_t BgL_locz00_13813,
		obj_t BgL_sitez00_13814)
	{
		{	/* Ast/sexp.scm 114 */
			return
				BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_expz00_13811, BgL_stackz00_13812,
				BgL_locz00_13813, BgL_sitez00_13814);
		}

	}



/* &<@anonymous:6866> */
	obj_t BGl_z62zc3z04anonymousza36866ze3ze5zzast_sexpz00(obj_t BgL_envz00_13815,
		obj_t BgL_objz00_13817, obj_t BgL_procz00_13818, obj_t BgL_msgz00_13819)
	{
		{	/* Ast/sexp.scm 426 */
			return
				BGl_userzd2errorzf2locationz20zztools_errorz00(PROCEDURE_REF
				(BgL_envz00_13815, (int) (((long) 0))), BgL_objz00_13817,
				BgL_procz00_13818, BgL_msgz00_13819, BNIL);
		}

	}



/* lambda->node */
	BgL_nodez00_bglt BGl_lambdazd2ze3nodez31zzast_sexpz00(obj_t BgL_expz00_25,
		obj_t BgL_stackz00_26, obj_t BgL_locz00_27, obj_t BgL_sitez00_28,
		obj_t BgL_prefnamez00_29)
	{
		{	/* Ast/sexp.scm 571 */
			{
				obj_t BgL_argsz00_8981;
				obj_t BgL_bodyz00_8982;

				if (PAIRP(BgL_expz00_25))
					{	/* Ast/sexp.scm 572 */
						obj_t BgL_cdrzd262408zd2_8987;

						BgL_cdrzd262408zd2_8987 = CDR(BgL_expz00_25);
						if (PAIRP(BgL_cdrzd262408zd2_8987))
							{	/* Ast/sexp.scm 572 */
								BgL_argsz00_8981 = CAR(BgL_cdrzd262408zd2_8987);
								BgL_bodyz00_8982 = CDR(BgL_cdrzd262408zd2_8987);
								{	/* Ast/sexp.scm 574 */
									obj_t BgL_locz00_8991;
									obj_t BgL_funz00_8992;

									BgL_locz00_8991 =
										BGl_findzd2locationzf2locz20zztools_locationz00
										(BgL_expz00_25, BgL_locz00_27);
									{	/* Ast/sexp.scm 575 */
										obj_t BgL_list6980z00_9002;

										BgL_list6980z00_9002 =
											MAKE_YOUNG_PAIR(BgL_prefnamez00_29, BNIL);
										BgL_funz00_8992 =
											BGl_makezd2anonymouszd2namez00zzast_sexpz00(BgL_locz00_27,
											BgL_list6980z00_9002);
									}
									{	/* Ast/sexp.scm 576 */
										obj_t BgL_arg6971z00_8993;

										{	/* Ast/sexp.scm 576 */
											obj_t BgL_arg6972z00_8994;
											obj_t BgL_arg6973z00_8995;

											BgL_arg6972z00_8994 =
												BGl_labelszd2symzd2zzast_labelsz00();
											{	/* Ast/sexp.scm 576 */
												obj_t BgL_arg6974z00_8996;
												obj_t BgL_arg6975z00_8997;

												{	/* Ast/sexp.scm 576 */
													obj_t BgL_arg6976z00_8998;

													{	/* Ast/sexp.scm 576 */
														obj_t BgL_arg6977z00_8999;

														{	/* Ast/sexp.scm 576 */
															obj_t BgL_arg6978z00_9000;

															BgL_arg6978z00_9000 =
																MAKE_YOUNG_PAIR
																(BGl_normaliza7ezd2prognz75zztools_prognz00
																(BgL_bodyz00_8982), BNIL);
															BgL_arg6977z00_8999 =
																MAKE_YOUNG_PAIR(BgL_argsz00_8981,
																BgL_arg6978z00_9000);
														}
														BgL_arg6976z00_8998 =
															MAKE_YOUNG_PAIR(BgL_funz00_8992,
															BgL_arg6977z00_8999);
													}
													BgL_arg6974z00_8996 =
														MAKE_YOUNG_PAIR(BgL_arg6976z00_8998, BNIL);
												}
												BgL_arg6975z00_8997 =
													MAKE_YOUNG_PAIR(BgL_funz00_8992, BNIL);
												BgL_arg6973z00_8995 =
													MAKE_YOUNG_PAIR(BgL_arg6974z00_8996,
													BgL_arg6975z00_8997);
											}
											BgL_arg6971z00_8993 =
												MAKE_YOUNG_PAIR(BgL_arg6972z00_8994,
												BgL_arg6973z00_8995);
										}
										return
											BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg6971z00_8993,
											BgL_stackz00_26, BgL_locz00_8991, BgL_sitez00_28);
									}
								}
							}
						else
							{	/* Ast/sexp.scm 572 */
							BgL_tagzd262401zd2_8984:
								{	/* Ast/sexp.scm 583 */
									obj_t BgL_arg6981z00_9003;

									BgL_arg6981z00_9003 =
										BGl_findzd2locationzf2locz20zztools_locationz00
										(BgL_expz00_25, BgL_locz00_27);
									{	/* Ast/sexp.scm 581 */
										BgL_nodez00_bglt BgL_res7914z00_13542;

										{	/* Ast/sexp.scm 723 */
											obj_t BgL_arg7080z00_13538;
											BgL_nodez00_bglt BgL_arg7081z00_13539;

											BgL_arg7080z00_13538 =
												BGl_shapez00zztools_shapez00
												(BGl_currentzd2functionzd2zztools_errorz00());
											BgL_arg7081z00_13539 =
												BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF((
														(long) 4)), BNIL, BgL_arg6981z00_9003,
												CNST_TABLE_REF(((long) 2)));
											{	/* Ast/sexp.scm 722 */
												obj_t BgL_list7082z00_13541;

												BgL_list7082z00_13541 =
													MAKE_YOUNG_PAIR(((obj_t) BgL_arg7081z00_13539), BNIL);
												BgL_res7914z00_13542 =
													((BgL_nodez00_bglt)
													BGl_userzd2errorzf2locationz20zztools_errorz00
													(BgL_arg6981z00_9003, BgL_arg7080z00_13538,
														BGl_string8015z00zzast_sexpz00, BgL_expz00_25,
														BgL_list7082z00_13541));
										}}
										return BgL_res7914z00_13542;
									}
								}
							}
					}
				else
					{	/* Ast/sexp.scm 572 */
						goto BgL_tagzd262401zd2_8984;
					}
			}
		}

	}



/* variable->node */
	BgL_nodez00_bglt BGl_variablezd2ze3nodez31zzast_sexpz00(obj_t BgL_vz00_30,
		obj_t BgL_locz00_31, obj_t BgL_sitez00_32)
	{
		{	/* Ast/sexp.scm 588 */
			BGl_usezd2variablez12zc0zzast_sexpz00(
				((BgL_variablez00_bglt) BgL_vz00_30), BgL_locz00_31, BgL_sitez00_32);
			{	/* Ast/sexp.scm 590 */
				bool_t BgL_test10507z00_29316;

				if ((BgL_sitez00_32 == CNST_TABLE_REF(((long) 33))))
					{	/* Ast/sexp.scm 590 */
						BgL_test10507z00_29316 = ((bool_t) 0);
					}
				else
					{	/* Ast/sexp.scm 590 */
						BgL_valuez00_bglt BgL_arg7004z00_9035;

						BgL_arg7004z00_9035 =
							(((BgL_variablez00_bglt) COBJECT(
									((BgL_variablez00_bglt) BgL_vz00_30)))->BgL_valuez00);
						{	/* Ast/sexp.scm 590 */
							bool_t BgL_res7917z00_13549;

							BgL_res7917z00_13549 =
								BGl_isazf3zf3zz__objectz00(
								((obj_t) BgL_arg7004z00_9035), BGl_funz00zzast_varz00);
							BgL_test10507z00_29316 = BgL_res7917z00_13549;
						}
					}
				if (BgL_test10507z00_29316)
					{	/* Ast/sexp.scm 591 */
						bool_t BgL_test10509z00_29324;

						if (BGl_isazf3zf3zz__objectz00(BgL_vz00_30,
								BGl_globalz00zzast_varz00))
							{	/* Ast/sexp.scm 592 */
								bool_t BgL_test10511z00_29327;

								{	/* Ast/sexp.scm 592 */
									BgL_valuez00_bglt BgL_arg7001z00_9029;

									BgL_arg7001z00_9029 =
										(((BgL_variablez00_bglt) COBJECT(
												((BgL_variablez00_bglt)
													((BgL_globalz00_bglt) BgL_vz00_30))))->BgL_valuez00);
									{	/* Ast/sexp.scm 592 */
										bool_t BgL_res7919z00_13552;

										BgL_res7919z00_13552 =
											BGl_isazf3zf3zz__objectz00(
											((obj_t) BgL_arg7001z00_9029), BGl_cfunz00zzast_varz00);
										BgL_test10511z00_29327 = BgL_res7919z00_13552;
									}
								}
								if (BgL_test10511z00_29327)
									{	/* Ast/sexp.scm 593 */
										bool_t BgL_test10512z00_29333;

										{	/* Ast/sexp.scm 593 */
											obj_t BgL_arg7000z00_9028;

											BgL_arg7000z00_9028 =
												BGl_thezd2backendzd2zzbackend_backendz00();
											BgL_test10512z00_29333 =
												(((BgL_backendz00_bglt) COBJECT(
														((BgL_backendz00_bglt) BgL_arg7000z00_9028)))->
												BgL_foreignzd2closurezd2);
										}
										if (BgL_test10512z00_29333)
											{	/* Ast/sexp.scm 593 */
												BgL_test10509z00_29324 = ((bool_t) 0);
											}
										else
											{	/* Ast/sexp.scm 593 */
												if ((BgL_sitez00_32 == CNST_TABLE_REF(((long) 30))))
													{	/* Ast/sexp.scm 594 */
														BgL_test10509z00_29324 = ((bool_t) 0);
													}
												else
													{	/* Ast/sexp.scm 594 */
														BgL_test10509z00_29324 = ((bool_t) 1);
													}
											}
									}
								else
									{	/* Ast/sexp.scm 592 */
										BgL_test10509z00_29324 = ((bool_t) 0);
									}
							}
						else
							{	/* Ast/sexp.scm 591 */
								BgL_test10509z00_29324 = ((bool_t) 0);
							}
						if (BgL_test10509z00_29324)
							{	/* Ast/sexp.scm 596 */
								obj_t BgL_arg6994z00_9016;

								{	/* Ast/sexp.scm 596 */
									obj_t BgL_arg6995z00_9017;

									{	/* Ast/sexp.scm 596 */
										obj_t BgL_arg6997z00_9019;

										BgL_arg6997z00_9019 =
											BGl_thezd2backendzd2zzbackend_backendz00();
										BgL_arg6995z00_9017 =
											(((BgL_backendz00_bglt) COBJECT(
													((BgL_backendz00_bglt) BgL_arg6997z00_9019)))->
											BgL_namez00);
									}
									{	/* Ast/sexp.scm 596 */
										obj_t BgL_list6996z00_9018;

										BgL_list6996z00_9018 =
											MAKE_YOUNG_PAIR(BgL_arg6995z00_9017, BNIL);
										BgL_arg6994z00_9016 =
											BGl_formatz00zz__r4_output_6_10_3z00
											(BGl_string8016z00zzast_sexpz00, BgL_list6996z00_9018);
									}
								}
								return
									BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
									(BgL_arg6994z00_9016, BGl_expzd2envzd2zz__r4_numbers_6_5z00,
									BgL_locz00_31);
							}
						else
							{	/* Ast/sexp.scm 597 */
								BgL_closurez00_bglt BgL_new1146z00_9020;

								{	/* Ast/sexp.scm 598 */
									BgL_closurez00_bglt BgL_new1145z00_9022;

									BgL_new1145z00_9022 =
										((BgL_closurez00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
													BgL_closurez00_bgl))));
									{	/* Ast/sexp.scm 598 */
										long BgL_arg6999z00_9023;

										{	/* Ast/sexp.scm 598 */
											long BgL_res7922z00_13560;

											BgL_res7922z00_13560 =
												BGL_CLASS_INDEX(BGl_closurez00zzast_nodez00);
											BgL_arg6999z00_9023 = BgL_res7922z00_13560;
										}
										BGL_OBJECT_CLASS_NUM_SET(
											((BgL_objectz00_bglt) BgL_new1145z00_9022),
											BgL_arg6999z00_9023);
									}
									BgL_new1146z00_9020 = BgL_new1145z00_9022;
								}
								((((BgL_nodez00_bglt) COBJECT(
												((BgL_nodez00_bglt) BgL_new1146z00_9020)))->
										BgL_locz00) = ((obj_t) BgL_locz00_31), BUNSPEC);
								{
									BgL_typez00_bglt BgL_auxz00_29352;

									{	/* Ast/sexp.scm 599 */
										BgL_typez00_bglt BgL_arg6998z00_9021;

										BgL_arg6998z00_9021 =
											(((BgL_variablez00_bglt) COBJECT(
													((BgL_variablez00_bglt) BgL_vz00_30)))->BgL_typez00);
										BgL_auxz00_29352 =
											BGl_strictzd2nodezd2typez00zzast_nodez00(
											((BgL_typez00_bglt)
												BGl_za2procedureza2z00zztype_cachez00),
											BgL_arg6998z00_9021);
									}
									((((BgL_nodez00_bglt) COBJECT(
													((BgL_nodez00_bglt) BgL_new1146z00_9020)))->
											BgL_typez00) =
										((BgL_typez00_bglt) BgL_auxz00_29352), BUNSPEC);
								}
								((((BgL_varz00_bglt) COBJECT(
												((BgL_varz00_bglt) BgL_new1146z00_9020)))->
										BgL_variablez00) =
									((BgL_variablez00_bglt) ((BgL_variablez00_bglt) BgL_vz00_30)),
									BUNSPEC);
								return ((BgL_nodez00_bglt) BgL_new1146z00_9020);
							}
					}
				else
					{	/* Ast/sexp.scm 601 */
						BgL_varz00_bglt BgL_new1148z00_9030;

						{	/* Ast/sexp.scm 602 */
							BgL_varz00_bglt BgL_new1147z00_9032;

							BgL_new1147z00_9032 =
								((BgL_varz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
											BgL_varz00_bgl))));
							{	/* Ast/sexp.scm 602 */
								long BgL_arg7003z00_9033;

								{	/* Ast/sexp.scm 602 */
									long BgL_res7923z00_13565;

									BgL_res7923z00_13565 =
										BGL_CLASS_INDEX(BGl_varz00zzast_nodez00);
									BgL_arg7003z00_9033 = BgL_res7923z00_13565;
								}
								BGL_OBJECT_CLASS_NUM_SET(
									((BgL_objectz00_bglt) BgL_new1147z00_9032),
									BgL_arg7003z00_9033);
							}
							BgL_new1148z00_9030 = BgL_new1147z00_9032;
						}
						((((BgL_nodez00_bglt) COBJECT(
										((BgL_nodez00_bglt) BgL_new1148z00_9030)))->BgL_locz00) =
							((obj_t) BgL_locz00_31), BUNSPEC);
						{
							BgL_typez00_bglt BgL_auxz00_29369;

							{	/* Ast/sexp.scm 603 */
								BgL_typez00_bglt BgL_arg7002z00_9031;

								BgL_arg7002z00_9031 =
									(((BgL_variablez00_bglt) COBJECT(
											((BgL_variablez00_bglt) BgL_vz00_30)))->BgL_typez00);
								BgL_auxz00_29369 =
									BGl_strictzd2nodezd2typez00zzast_nodez00(
									((BgL_typez00_bglt) BGl_za2_za2z00zztype_cachez00),
									BgL_arg7002z00_9031);
							}
							((((BgL_nodez00_bglt) COBJECT(
											((BgL_nodez00_bglt) BgL_new1148z00_9030)))->BgL_typez00) =
								((BgL_typez00_bglt) BgL_auxz00_29369), BUNSPEC);
						}
						((((BgL_varz00_bglt) COBJECT(BgL_new1148z00_9030))->
								BgL_variablez00) =
							((BgL_variablez00_bglt) ((BgL_variablez00_bglt) BgL_vz00_30)),
							BUNSPEC);
						return ((BgL_nodez00_bglt) BgL_new1148z00_9030);
					}
			}
		}

	}



/* call->node */
	BgL_nodez00_bglt BGl_callzd2ze3nodez31zzast_sexpz00(obj_t BgL_expz00_33,
		obj_t BgL_stackz00_34, obj_t BgL_locz00_35, obj_t BgL_sitez00_36)
	{
		{	/* Ast/sexp.scm 609 */
			{	/* Ast/sexp.scm 610 */
				obj_t BgL_callerz00_9036;
				obj_t BgL_locz00_9037;

				BgL_callerz00_9036 = CAR(((obj_t) BgL_expz00_33));
				BgL_locz00_9037 =
					BGl_findzd2locationzf2locz20zztools_locationz00(BgL_expz00_33,
					BgL_locz00_35);
				if (SYMBOLP(BgL_callerz00_9036))
					{	/* Ast/sexp.scm 614 */
						obj_t BgL_pidz00_9039;

						BgL_pidz00_9039 =
							BGl_parsezd2idzd2zzast_identz00(BgL_callerz00_9036,
							BgL_locz00_9037);
						{	/* Ast/sexp.scm 614 */
							obj_t BgL_idz00_9040;

							BgL_idz00_9040 = CAR(BgL_pidz00_9039);
							{	/* Ast/sexp.scm 615 */
								obj_t BgL_typez00_9041;

								BgL_typez00_9041 = CDR(BgL_pidz00_9039);
								{	/* Ast/sexp.scm 616 */

									if ((BgL_idz00_9040 == CNST_TABLE_REF(((long) 6))))
										{	/* Ast/sexp.scm 617 */
											return
												BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00(((bool_t)
													0), BFALSE, ((BgL_typez00_bglt) BgL_typez00_9041),
												BgL_expz00_33, BgL_stackz00_34, BgL_locz00_9037,
												BgL_sitez00_36);
										}
									else
										{	/* Ast/sexp.scm 617 */
											if ((BgL_idz00_9040 == CNST_TABLE_REF(((long) 21))))
												{	/* Ast/sexp.scm 621 */
													bool_t BgL_test10517z00_29395;

													{	/* Ast/sexp.scm 621 */
														obj_t BgL_tmpz00_29396;

														BgL_tmpz00_29396 = CDR(((obj_t) BgL_expz00_33));
														BgL_test10517z00_29395 = PAIRP(BgL_tmpz00_29396);
													}
													if (BgL_test10517z00_29395)
														{	/* Ast/sexp.scm 625 */
															BgL_feffectz00_bglt BgL_arg7010z00_9047;
															obj_t BgL_arg7011z00_9048;

															{	/* Ast/sexp.scm 625 */
																obj_t BgL_arg7012z00_9049;

																{	/* Ast/sexp.scm 625 */
																	obj_t BgL_pairz00_13582;

																	BgL_pairz00_13582 =
																		CDR(((obj_t) BgL_expz00_33));
																	BgL_arg7012z00_9049 = CAR(BgL_pairz00_13582);
																}
																BgL_arg7010z00_9047 =
																	BGl_parsezd2effectzd2zzeffect_feffectz00
																	(BgL_arg7012z00_9049);
															}
															{	/* Ast/sexp.scm 626 */
																obj_t BgL_arg7013z00_9050;
																obj_t BgL_arg7014z00_9051;

																{	/* Ast/sexp.scm 626 */
																	obj_t BgL_arg7015z00_9052;

																	BgL_arg7015z00_9052 =
																		MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 34)),
																		BNIL);
																	BgL_arg7013z00_9050 =
																		MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 35)),
																		BgL_arg7015z00_9052);
																}
																{	/* Ast/sexp.scm 626 */
																	obj_t BgL_auxz00_29408;

																	{	/* Ast/sexp.scm 626 */
																		obj_t BgL_pairz00_13586;

																		BgL_pairz00_13586 =
																			CDR(((obj_t) BgL_expz00_33));
																		BgL_auxz00_29408 = CDR(BgL_pairz00_13586);
																	}
																	BgL_arg7014z00_9051 =
																		BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																		(BgL_auxz00_29408, BNIL);
																}
																BgL_arg7011z00_9048 =
																	MAKE_YOUNG_PAIR(BgL_arg7013z00_9050,
																	BgL_arg7014z00_9051);
															}
															return
																BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00((
																	(bool_t) 0), ((obj_t) BgL_arg7010z00_9047),
																((BgL_typez00_bglt) BgL_typez00_9041),
																BgL_arg7011z00_9048, BgL_stackz00_34,
																BgL_locz00_9037, BgL_sitez00_36);
														}
													else
														{	/* Ast/sexp.scm 624 */
															obj_t BgL_arg7017z00_9054;

															BgL_arg7017z00_9054 =
																BGl_findzd2locationzf2locz20zztools_locationz00
																(BgL_expz00_33, BgL_locz00_9037);
															{	/* Ast/sexp.scm 622 */
																BgL_nodez00_bglt BgL_res7928z00_13592;

																{	/* Ast/sexp.scm 723 */
																	obj_t BgL_arg7080z00_13588;
																	BgL_nodez00_bglt BgL_arg7081z00_13589;

																	BgL_arg7080z00_13588 =
																		BGl_shapez00zztools_shapez00
																		(BGl_currentzd2functionzd2zztools_errorz00
																		());
																	BgL_arg7081z00_13589 =
																		BGl_sexpzd2ze3nodez31zzast_sexpz00
																		(CNST_TABLE_REF(((long) 4)), BNIL,
																		BgL_arg7017z00_9054,
																		CNST_TABLE_REF(((long) 2)));
																	{	/* Ast/sexp.scm 722 */
																		obj_t BgL_list7082z00_13591;

																		BgL_list7082z00_13591 =
																			MAKE_YOUNG_PAIR(
																			((obj_t) BgL_arg7081z00_13589), BNIL);
																		BgL_res7928z00_13592 =
																			((BgL_nodez00_bglt)
																			BGl_userzd2errorzf2locationz20zztools_errorz00
																			(BgL_arg7017z00_9054,
																				BgL_arg7080z00_13588,
																				BGl_string8017z00zzast_sexpz00,
																				BgL_expz00_33, BgL_list7082z00_13591));
																}}
																return BgL_res7928z00_13592;
															}
														}
												}
											else
												{	/* Ast/sexp.scm 617 */
													if ((BgL_idz00_9040 == CNST_TABLE_REF(((long) 22))))
														{	/* Ast/sexp.scm 617 */
															return
																BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00((
																	(bool_t) 1), BFALSE,
																((BgL_typez00_bglt) BgL_typez00_9041),
																BgL_expz00_33, BgL_stackz00_34, BgL_locz00_9037,
																BgL_sitez00_36);
														}
													else
														{	/* Ast/sexp.scm 617 */
															if (
																(BgL_idz00_9040 == CNST_TABLE_REF(((long) 24))))
																{	/* Ast/sexp.scm 631 */
																	bool_t BgL_test10520z00_29435;

																	{	/* Ast/sexp.scm 631 */
																		obj_t BgL_tmpz00_29436;

																		BgL_tmpz00_29436 =
																			CDR(((obj_t) BgL_expz00_33));
																		BgL_test10520z00_29435 =
																			PAIRP(BgL_tmpz00_29436);
																	}
																	if (BgL_test10520z00_29435)
																		{	/* Ast/sexp.scm 635 */
																			BgL_feffectz00_bglt BgL_arg7023z00_9060;
																			obj_t BgL_arg7024z00_9061;

																			{	/* Ast/sexp.scm 635 */
																				obj_t BgL_arg7025z00_9062;

																				{	/* Ast/sexp.scm 635 */
																					obj_t BgL_pairz00_13602;

																					BgL_pairz00_13602 =
																						CDR(((obj_t) BgL_expz00_33));
																					BgL_arg7025z00_9062 =
																						CAR(BgL_pairz00_13602);
																				}
																				BgL_arg7023z00_9060 =
																					BGl_parsezd2effectzd2zzeffect_feffectz00
																					(BgL_arg7025z00_9062);
																			}
																			{	/* Ast/sexp.scm 636 */
																				obj_t BgL_arg7026z00_9063;
																				obj_t BgL_arg7027z00_9064;

																				{	/* Ast/sexp.scm 636 */
																					obj_t BgL_arg7028z00_9065;

																					BgL_arg7028z00_9065 =
																						MAKE_YOUNG_PAIR(CNST_TABLE_REF((
																								(long) 34)), BNIL);
																					BgL_arg7026z00_9063 =
																						MAKE_YOUNG_PAIR(CNST_TABLE_REF((
																								(long) 35)),
																						BgL_arg7028z00_9065);
																				}
																				{	/* Ast/sexp.scm 636 */
																					obj_t BgL_auxz00_29448;

																					{	/* Ast/sexp.scm 636 */
																						obj_t BgL_pairz00_13606;

																						BgL_pairz00_13606 =
																							CDR(((obj_t) BgL_expz00_33));
																						BgL_auxz00_29448 =
																							CDR(BgL_pairz00_13606);
																					}
																					BgL_arg7027z00_9064 =
																						BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																						(BgL_auxz00_29448, BNIL);
																				}
																				BgL_arg7024z00_9061 =
																					MAKE_YOUNG_PAIR(BgL_arg7026z00_9063,
																					BgL_arg7027z00_9064);
																			}
																			return
																				BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00
																				(((bool_t) 1),
																				((obj_t) BgL_arg7023z00_9060),
																				((BgL_typez00_bglt) BgL_typez00_9041),
																				BgL_arg7024z00_9061, BgL_stackz00_34,
																				BgL_locz00_9037, BgL_sitez00_36);
																		}
																	else
																		{	/* Ast/sexp.scm 634 */
																			obj_t BgL_arg7030z00_9067;

																			BgL_arg7030z00_9067 =
																				BGl_findzd2locationzf2locz20zztools_locationz00
																				(BgL_expz00_33, BgL_locz00_9037);
																			{	/* Ast/sexp.scm 632 */
																				BgL_nodez00_bglt BgL_res7932z00_13612;

																				{	/* Ast/sexp.scm 723 */
																					obj_t BgL_arg7080z00_13608;
																					BgL_nodez00_bglt BgL_arg7081z00_13609;

																					BgL_arg7080z00_13608 =
																						BGl_shapez00zztools_shapez00
																						(BGl_currentzd2functionzd2zztools_errorz00
																						());
																					BgL_arg7081z00_13609 =
																						BGl_sexpzd2ze3nodez31zzast_sexpz00
																						(CNST_TABLE_REF(((long) 4)), BNIL,
																						BgL_arg7030z00_9067,
																						CNST_TABLE_REF(((long) 2)));
																					{	/* Ast/sexp.scm 722 */
																						obj_t BgL_list7082z00_13611;

																						BgL_list7082z00_13611 =
																							MAKE_YOUNG_PAIR(
																							((obj_t) BgL_arg7081z00_13609),
																							BNIL);
																						BgL_res7932z00_13612 =
																							((BgL_nodez00_bglt)
																							BGl_userzd2errorzf2locationz20zztools_errorz00
																							(BgL_arg7030z00_9067,
																								BgL_arg7080z00_13608,
																								BGl_string8018z00zzast_sexpz00,
																								BgL_expz00_33,
																								BgL_list7082z00_13611));
																				}}
																				return BgL_res7932z00_13612;
																			}
																		}
																}
															else
																{	/* Ast/sexp.scm 617 */
																	if (
																		(BgL_idz00_9040 ==
																			CNST_TABLE_REF(((long) 3))))
																		{
																			obj_t BgL_argsz00_9070;
																			obj_t BgL_bodyz00_9071;

																			if (PAIRP(BgL_expz00_33))
																				{	/* Ast/sexp.scm 639 */
																					obj_t BgL_cdrzd262423zd2_9076;

																					BgL_cdrzd262423zd2_9076 =
																						CDR(BgL_expz00_33);
																					if (PAIRP(BgL_cdrzd262423zd2_9076))
																						{	/* Ast/sexp.scm 639 */
																							BgL_argsz00_9070 =
																								CAR(BgL_cdrzd262423zd2_9076);
																							BgL_bodyz00_9071 =
																								CDR(BgL_cdrzd262423zd2_9076);
																							{	/* Ast/sexp.scm 641 */
																								obj_t BgL_locz00_9080;

																								BgL_locz00_9080 =
																									BGl_findzd2locationzf2locz20zztools_locationz00
																									(BgL_expz00_33,
																									BgL_locz00_9037);
																								{	/* Ast/sexp.scm 641 */
																									obj_t BgL_funz00_9081;

																									BgL_funz00_9081 =
																										BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
																										(BGl_gensymz00zz__r4_symbols_6_4z00
																										(CNST_TABLE_REF(((long)
																													3))));
																									{	/* Ast/sexp.scm 642 */
																										obj_t BgL_tfunz00_9082;

																										if (BGl_bigloozd2typezf3z21zztype_typez00(((BgL_typez00_bglt) BgL_typez00_9041)))
																											{	/* Ast/sexp.scm 644 */
																												obj_t
																													BgL_arg7047z00_9093;
																												BgL_arg7047z00_9093 =
																													(((BgL_typez00_bglt)
																														COBJECT((
																																(BgL_typez00_bglt)
																																BgL_typez00_9041)))->
																													BgL_idz00);
																												BgL_tfunz00_9082 =
																													BGl_makezd2typedzd2identz00zzast_identz00
																													(BgL_funz00_9081,
																													BgL_arg7047z00_9093);
																											}
																										else
																											{	/* Ast/sexp.scm 643 */
																												BgL_tfunz00_9082 =
																													BgL_funz00_9081;
																											}
																										{	/* Ast/sexp.scm 643 */

																											{	/* Ast/sexp.scm 647 */
																												obj_t
																													BgL_arg7037z00_9083;
																												{	/* Ast/sexp.scm 647 */
																													obj_t
																														BgL_arg7038z00_9084;
																													obj_t
																														BgL_arg7039z00_9085;
																													BgL_arg7038z00_9084 =
																														BGl_labelszd2symzd2zzast_labelsz00
																														();
																													{	/* Ast/sexp.scm 647 */
																														obj_t
																															BgL_arg7040z00_9086;
																														obj_t
																															BgL_arg7041z00_9087;
																														{	/* Ast/sexp.scm 647 */
																															obj_t
																																BgL_arg7042z00_9088;
																															{	/* Ast/sexp.scm 647 */
																																obj_t
																																	BgL_arg7043z00_9089;
																																{	/* Ast/sexp.scm 647 */
																																	obj_t
																																		BgL_arg7044z00_9090;
																																	BgL_arg7044z00_9090
																																		=
																																		MAKE_YOUNG_PAIR
																																		(BGl_normaliza7ezd2prognz75zztools_prognz00
																																		(BgL_bodyz00_9071),
																																		BNIL);
																																	BgL_arg7043z00_9089
																																		=
																																		MAKE_YOUNG_PAIR
																																		(BgL_argsz00_9070,
																																		BgL_arg7044z00_9090);
																																}
																																BgL_arg7042z00_9088
																																	=
																																	MAKE_YOUNG_PAIR
																																	(BgL_tfunz00_9082,
																																	BgL_arg7043z00_9089);
																															}
																															BgL_arg7040z00_9086
																																=
																																MAKE_YOUNG_PAIR
																																(BgL_arg7042z00_9088,
																																BNIL);
																														}
																														BgL_arg7041z00_9087
																															=
																															MAKE_YOUNG_PAIR
																															(BgL_funz00_9081,
																															BNIL);
																														BgL_arg7039z00_9085
																															=
																															MAKE_YOUNG_PAIR
																															(BgL_arg7040z00_9086,
																															BgL_arg7041z00_9087);
																													}
																													BgL_arg7037z00_9083 =
																														MAKE_YOUNG_PAIR
																														(BgL_arg7038z00_9084,
																														BgL_arg7039z00_9085);
																												}
																												return
																													BGl_sexpzd2ze3nodez31zzast_sexpz00
																													(BgL_arg7037z00_9083,
																													BgL_stackz00_34,
																													BgL_locz00_9080,
																													BgL_sitez00_36);
																											}
																										}
																									}
																								}
																							}
																						}
																					else
																						{	/* Ast/sexp.scm 639 */
																						BgL_tagzd262416zd2_9073:
																							{	/* Ast/sexp.scm 653 */
																								BgL_nodez00_bglt
																									BgL_res7934z00_13621;
																								{	/* Ast/sexp.scm 723 */
																									obj_t BgL_arg7080z00_13617;
																									BgL_nodez00_bglt
																										BgL_arg7081z00_13618;
																									BgL_arg7080z00_13617 =
																										BGl_shapez00zztools_shapez00
																										(BGl_currentzd2functionzd2zztools_errorz00
																										());
																									BgL_arg7081z00_13618 =
																										BGl_sexpzd2ze3nodez31zzast_sexpz00
																										(CNST_TABLE_REF(((long) 4)),
																										BNIL, BgL_locz00_9037,
																										CNST_TABLE_REF(((long) 2)));
																									{	/* Ast/sexp.scm 722 */
																										obj_t BgL_list7082z00_13620;

																										BgL_list7082z00_13620 =
																											MAKE_YOUNG_PAIR(
																											((obj_t)
																												BgL_arg7081z00_13618),
																											BNIL);
																										BgL_res7934z00_13621 =
																											((BgL_nodez00_bglt)
																											BGl_userzd2errorzf2locationz20zztools_errorz00
																											(BgL_locz00_9037,
																												BgL_arg7080z00_13617,
																												BGl_string8019z00zzast_sexpz00,
																												BgL_expz00_33,
																												BgL_list7082z00_13620));
																								}}
																								return BgL_res7934z00_13621;
																							}
																						}
																				}
																			else
																				{	/* Ast/sexp.scm 639 */
																					goto BgL_tagzd262416zd2_9073;
																				}
																		}
																	else
																		{	/* Ast/sexp.scm 617 */
																			return
																				BGl_applicationzd2ze3nodez31zzast_appz00
																				(BgL_expz00_33, BgL_stackz00_34,
																				BgL_locz00_9037, BgL_sitez00_36);
																		}
																}
														}
												}
										}
								}
							}
						}
					}
				else
					{	/* Ast/sexp.scm 612 */
						return
							BGl_applicationzd2ze3nodez31zzast_appz00(BgL_expz00_33,
							BgL_stackz00_34, BgL_locz00_9037, BgL_sitez00_36);
					}
			}
		}

	}



/* sexp*->node */
	BGL_EXPORTED_DEF obj_t BGl_sexpza2zd2ze3nodez93zzast_sexpz00(obj_t
		BgL_expza2za2_37, obj_t BgL_stackz00_38, obj_t BgL_locz00_39,
		obj_t BgL_sitez00_40)
	{
		{	/* Ast/sexp.scm 661 */
			{
				obj_t BgL_expsz00_9097;
				obj_t BgL_resz00_9098;
				obj_t BgL_locz00_9099;

				BgL_expsz00_9097 = BgL_expza2za2_37;
				BgL_resz00_9098 = BNIL;
				BgL_locz00_9099 = BgL_locz00_39;
			BgL_zc3z04anonymousza37049ze3z87_9100:
				if (NULLP(BgL_expsz00_9097))
					{	/* Ast/sexp.scm 667 */
						BgL_nodez00_bglt BgL_res7938z00_13633;

						{	/* Ast/sexp.scm 723 */
							obj_t BgL_arg7080z00_13629;
							BgL_nodez00_bglt BgL_arg7081z00_13630;

							BgL_arg7080z00_13629 =
								BGl_shapez00zztools_shapez00
								(BGl_currentzd2functionzd2zztools_errorz00());
							BgL_arg7081z00_13630 =
								BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 4)),
								BNIL, BgL_locz00_9099, CNST_TABLE_REF(((long) 2)));
							{	/* Ast/sexp.scm 722 */
								obj_t BgL_list7082z00_13632;

								BgL_list7082z00_13632 =
									MAKE_YOUNG_PAIR(((obj_t) BgL_arg7081z00_13630), BNIL);
								BgL_res7938z00_13633 =
									((BgL_nodez00_bglt)
									BGl_userzd2errorzf2locationz20zztools_errorz00
									(BgL_locz00_9099, BgL_arg7080z00_13629,
										BGl_string8020z00zzast_sexpz00, BgL_expsz00_9097,
										BgL_list7082z00_13632));
						}}
						return ((obj_t) BgL_res7938z00_13633);
					}
				else
					{	/* Ast/sexp.scm 666 */
						if (NULLP(CDR(((obj_t) BgL_expsz00_9097))))
							{	/* Ast/sexp.scm 669 */
								obj_t BgL_locz00_9104;
								obj_t BgL_nsitez00_9105;

								{	/* Ast/sexp.scm 669 */
									obj_t BgL_arg7056z00_9109;
									obj_t BgL_arg7057z00_9110;

									BgL_arg7056z00_9109 = CAR(((obj_t) BgL_expsz00_9097));
									BgL_arg7057z00_9110 =
										BGl_findzd2locationzf2locz20zztools_locationz00
										(BgL_expsz00_9097, BgL_locz00_9099);
									BgL_locz00_9104 =
										BGl_findzd2locationzf2locz20zztools_locationz00
										(BgL_arg7056z00_9109, BgL_arg7057z00_9110);
								}
								if ((BgL_sitez00_40 == CNST_TABLE_REF(((long) 33))))
									{	/* Ast/sexp.scm 671 */
										BgL_nsitez00_9105 = CNST_TABLE_REF(((long) 2));
									}
								else
									{	/* Ast/sexp.scm 671 */
										BgL_nsitez00_9105 = BgL_sitez00_40;
									}
								{	/* Ast/sexp.scm 672 */
									obj_t BgL_arg7053z00_9106;

									{	/* Ast/sexp.scm 672 */
										BgL_nodez00_bglt BgL_arg7054z00_9107;

										{	/* Ast/sexp.scm 672 */
											obj_t BgL_arg7055z00_9108;

											BgL_arg7055z00_9108 = CAR(((obj_t) BgL_expsz00_9097));
											BgL_arg7054z00_9107 =
												BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg7055z00_9108,
												BgL_stackz00_38, BgL_locz00_9104, BgL_nsitez00_9105);
										}
										BgL_arg7053z00_9106 =
											MAKE_YOUNG_PAIR(
											((obj_t) BgL_arg7054z00_9107), BgL_resz00_9098);
									}
									return bgl_reverse_bang(BgL_arg7053z00_9106);
								}
							}
						else
							{	/* Ast/sexp.scm 674 */
								obj_t BgL_locz00_9112;

								{	/* Ast/sexp.scm 674 */
									obj_t BgL_arg7063z00_9117;
									obj_t BgL_arg7064z00_9118;

									BgL_arg7063z00_9117 = CAR(((obj_t) BgL_expsz00_9097));
									BgL_arg7064z00_9118 =
										BGl_findzd2locationzf2locz20zztools_locationz00
										(BgL_expsz00_9097, BgL_locz00_9099);
									BgL_locz00_9112 =
										BGl_findzd2locationzf2locz20zztools_locationz00
										(BgL_arg7063z00_9117, BgL_arg7064z00_9118);
								}
								{	/* Ast/sexp.scm 676 */
									obj_t BgL_arg7059z00_9113;
									obj_t BgL_arg7060z00_9114;

									BgL_arg7059z00_9113 = CDR(((obj_t) BgL_expsz00_9097));
									{	/* Ast/sexp.scm 677 */
										BgL_nodez00_bglt BgL_arg7061z00_9115;

										{	/* Ast/sexp.scm 677 */
											obj_t BgL_arg7062z00_9116;

											BgL_arg7062z00_9116 = CAR(((obj_t) BgL_expsz00_9097));
											BgL_arg7061z00_9115 =
												BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg7062z00_9116,
												BgL_stackz00_38, BgL_locz00_9112,
												CNST_TABLE_REF(((long) 2)));
										}
										BgL_arg7060z00_9114 =
											MAKE_YOUNG_PAIR(
											((obj_t) BgL_arg7061z00_9115), BgL_resz00_9098);
									}
									{
										obj_t BgL_locz00_29552;
										obj_t BgL_resz00_29551;
										obj_t BgL_expsz00_29550;

										BgL_expsz00_29550 = BgL_arg7059z00_9113;
										BgL_resz00_29551 = BgL_arg7060z00_9114;
										BgL_locz00_29552 = BgL_locz00_9112;
										BgL_locz00_9099 = BgL_locz00_29552;
										BgL_resz00_9098 = BgL_resz00_29551;
										BgL_expsz00_9097 = BgL_expsz00_29550;
										goto BgL_zc3z04anonymousza37049ze3z87_9100;
									}
								}
							}
					}
			}
		}

	}



/* &sexp*->node */
	obj_t BGl_z62sexpza2zd2ze3nodezf1zzast_sexpz00(obj_t BgL_envz00_13822,
		obj_t BgL_expza2za2_13823, obj_t BgL_stackz00_13824, obj_t BgL_locz00_13825,
		obj_t BgL_sitez00_13826)
	{
		{	/* Ast/sexp.scm 661 */
			return
				BGl_sexpza2zd2ze3nodez93zzast_sexpz00(BgL_expza2za2_13823,
				BgL_stackz00_13824, BgL_locz00_13825, BgL_sitez00_13826);
		}

	}



/* find-local */
	BGL_EXPORTED_DEF obj_t BGl_findzd2localzd2zzast_sexpz00(obj_t BgL_namez00_41,
		obj_t BgL_stackz00_42)
	{
		{	/* Ast/sexp.scm 690 */
			{	/* Ast/sexp.scm 691 */
				bool_t BgL_test10528z00_29554;

				if ((BgL_namez00_41 == BGl_za2cachezd2nameza2zd2zzast_sexpz00))
					{	/* Ast/sexp.scm 691 */
						BgL_test10528z00_29554 =
							(BgL_stackz00_42 == BGl_za2cachezd2stackza2zd2zzast_sexpz00);
					}
				else
					{	/* Ast/sexp.scm 691 */
						BgL_test10528z00_29554 = ((bool_t) 0);
					}
				if (BgL_test10528z00_29554)
					{	/* Ast/sexp.scm 691 */
						return BGl_za2cachezd2resza2zd2zzast_sexpz00;
					}
				else
					{	/* Ast/sexp.scm 691 */
						BGl_za2cachezd2nameza2zd2zzast_sexpz00 = BgL_namez00_41;
						BGl_za2cachezd2stackza2zd2zzast_sexpz00 = BgL_stackz00_42;
						{
							obj_t BgL_stackz00_9124;

							BgL_stackz00_9124 = BgL_stackz00_42;
						BgL_zc3z04anonymousza37068ze3z87_9125:
							if (NULLP(BgL_stackz00_9124))
								{	/* Ast/sexp.scm 698 */
									BGl_za2cachezd2resza2zd2zzast_sexpz00 = BFALSE;
									return BFALSE;
								}
							else
								{	/* Ast/sexp.scm 698 */
									if (
										((((BgL_variablez00_bglt) COBJECT(
														((BgL_variablez00_bglt)
															((BgL_localz00_bglt)
																CAR(
																	((obj_t) BgL_stackz00_9124))))))->
												BgL_idz00) == BgL_namez00_41))
										{	/* Ast/sexp.scm 701 */
											BGl_za2cachezd2resza2zd2zzast_sexpz00 =
												CAR(((obj_t) BgL_stackz00_9124));
											return CAR(((obj_t) BgL_stackz00_9124));
										}
									else
										{	/* Ast/sexp.scm 705 */
											obj_t BgL_arg7073z00_9130;

											BgL_arg7073z00_9130 = CDR(((obj_t) BgL_stackz00_9124));
											{
												obj_t BgL_stackz00_29573;

												BgL_stackz00_29573 = BgL_arg7073z00_9130;
												BgL_stackz00_9124 = BgL_stackz00_29573;
												goto BgL_zc3z04anonymousza37068ze3z87_9125;
											}
										}
								}
						}
					}
			}
		}

	}



/* &find-local */
	obj_t BGl_z62findzd2localzb0zzast_sexpz00(obj_t BgL_envz00_13827,
		obj_t BgL_namez00_13828, obj_t BgL_stackz00_13829)
	{
		{	/* Ast/sexp.scm 690 */
			return
				BGl_findzd2localzd2zzast_sexpz00(BgL_namez00_13828, BgL_stackz00_13829);
		}

	}



/* use-variable! */
	BGL_EXPORTED_DEF obj_t
		BGl_usezd2variablez12zc0zzast_sexpz00(BgL_variablez00_bglt BgL_varz00_43,
		obj_t BgL_locz00_44, obj_t BgL_sitez00_45)
	{
		{	/* Ast/sexp.scm 710 */
			if ((BgL_sitez00_45 == CNST_TABLE_REF(((long) 7))))
				{	/* Ast/sexp.scm 713 */
					obj_t BgL_vz00_13648;

					BgL_vz00_13648 = CNST_TABLE_REF(((long) 36));
					((((BgL_variablez00_bglt) COBJECT(BgL_varz00_43))->BgL_accessz00) =
						((obj_t) BgL_vz00_13648), BUNSPEC);
				}
			else
				{	/* Ast/sexp.scm 712 */
					BFALSE;
				}
			{	/* Ast/sexp.scm 714 */
				BgL_valuez00_bglt BgL_valz00_9136;

				BgL_valz00_9136 =
					(((BgL_variablez00_bglt) COBJECT(BgL_varz00_43))->BgL_valuez00);
				{	/* Ast/sexp.scm 715 */
					bool_t BgL_test10533z00_29581;

					if ((BgL_sitez00_45 == CNST_TABLE_REF(((long) 7))))
						{	/* Ast/sexp.scm 715 */
							bool_t BgL_res7941z00_13650;

							BgL_res7941z00_13650 =
								BGl_isazf3zf3zz__objectz00(
								((obj_t) BgL_valz00_9136), BGl_funz00zzast_varz00);
							BgL_test10533z00_29581 = BgL_res7941z00_13650;
						}
					else
						{	/* Ast/sexp.scm 715 */
							BgL_test10533z00_29581 = ((bool_t) 0);
						}
					if (BgL_test10533z00_29581)
						{	/* Ast/sexp.scm 716 */
							obj_t BgL_arg7079z00_9139;

							BgL_arg7079z00_9139 =
								BGl_shapez00zztools_shapez00(((obj_t) BgL_varz00_43));
							{	/* Ast/sexp.scm 716 */
								BgL_nodez00_bglt BgL_res7942z00_13656;

								{	/* Ast/sexp.scm 723 */
									obj_t BgL_arg7080z00_13652;
									BgL_nodez00_bglt BgL_arg7081z00_13653;

									BgL_arg7080z00_13652 =
										BGl_shapez00zztools_shapez00
										(BGl_currentzd2functionzd2zztools_errorz00());
									BgL_arg7081z00_13653 =
										BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long)
												4)), BNIL, BgL_locz00_44, CNST_TABLE_REF(((long) 2)));
									{	/* Ast/sexp.scm 722 */
										obj_t BgL_list7082z00_13655;

										BgL_list7082z00_13655 =
											MAKE_YOUNG_PAIR(((obj_t) BgL_arg7081z00_13653), BNIL);
										BgL_res7942z00_13656 =
											((BgL_nodez00_bglt)
											BGl_userzd2errorzf2locationz20zztools_errorz00
											(BgL_locz00_44, BgL_arg7080z00_13652,
												BGl_string8021z00zzast_sexpz00, BgL_arg7079z00_9139,
												BgL_list7082z00_13655));
								}}
								return ((obj_t) BgL_res7942z00_13656);
							}
						}
					else
						{	/* Ast/sexp.scm 715 */
							return BFALSE;
						}
				}
			}
		}

	}



/* &use-variable! */
	obj_t BGl_z62usezd2variablez12za2zzast_sexpz00(obj_t BgL_envz00_13830,
		obj_t BgL_varz00_13831, obj_t BgL_locz00_13832, obj_t BgL_sitez00_13833)
	{
		{	/* Ast/sexp.scm 710 */
			return
				BGl_usezd2variablez12zc0zzast_sexpz00(
				((BgL_variablez00_bglt) BgL_varz00_13831), BgL_locz00_13832,
				BgL_sitez00_13833);
		}

	}



/* error-sexp->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(obj_t BgL_msgz00_46,
		obj_t BgL_expz00_47, obj_t BgL_locz00_48)
	{
		{	/* Ast/sexp.scm 721 */
			{	/* Ast/sexp.scm 723 */
				obj_t BgL_arg7080z00_9141;
				BgL_nodez00_bglt BgL_arg7081z00_9142;

				BgL_arg7080z00_9141 =
					BGl_shapez00zztools_shapez00(BGl_currentzd2functionzd2zztools_errorz00
					());
				BgL_arg7081z00_9142 =
					BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 4)), BNIL,
					BgL_locz00_48, CNST_TABLE_REF(((long) 2)));
				{	/* Ast/sexp.scm 722 */
					obj_t BgL_list7082z00_9143;

					BgL_list7082z00_9143 =
						MAKE_YOUNG_PAIR(((obj_t) BgL_arg7081z00_9142), BNIL);
					return
						((BgL_nodez00_bglt)
						BGl_userzd2errorzf2locationz20zztools_errorz00(BgL_locz00_48,
							BgL_arg7080z00_9141, BgL_msgz00_46, BgL_expz00_47,
							BgL_list7082z00_9143));
				}
			}
		}

	}



/* &error-sexp->node */
	BgL_nodez00_bglt BGl_z62errorzd2sexpzd2ze3nodez81zzast_sexpz00(obj_t
		BgL_envz00_13834, obj_t BgL_msgz00_13835, obj_t BgL_expz00_13836,
		obj_t BgL_locz00_13837)
	{
		{	/* Ast/sexp.scm 721 */
			return
				BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(BgL_msgz00_13835,
				BgL_expz00_13836, BgL_locz00_13837);
		}

	}



/* define-primop-ref->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00(BgL_globalz00_bglt
		BgL_globalz00_49, BgL_nodez00_bglt BgL_refz00_50)
	{
		{	/* Ast/sexp.scm 731 */
			{	/* Ast/sexp.scm 732 */
				BgL_nodez00_bglt BgL_funz00_9145;

				BgL_funz00_9145 =
					BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 37)), BNIL,
					BFALSE, CNST_TABLE_REF(((long) 33)));
				{	/* Ast/sexp.scm 733 */
					bool_t BgL_test10535z00_29614;

					{	/* Ast/sexp.scm 733 */
						bool_t BgL_res7943z00_13657;

						BgL_res7943z00_13657 =
							BGl_isazf3zf3zz__objectz00(
							((obj_t) BgL_funz00_9145), BGl_varz00zzast_nodez00);
						BgL_test10535z00_29614 = BgL_res7943z00_13657;
					}
					if (BgL_test10535z00_29614)
						{	/* Ast/sexp.scm 734 */
							BgL_appz00_bglt BgL_new1152z00_9147;

							{	/* Ast/sexp.scm 734 */
								BgL_appz00_bglt BgL_new1151z00_9154;

								BgL_new1151z00_9154 =
									((BgL_appz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
												BgL_appz00_bgl))));
								{	/* Ast/sexp.scm 734 */
									long BgL_arg7091z00_9155;

									{	/* Ast/sexp.scm 734 */
										long BgL_res7944z00_13659;

										BgL_res7944z00_13659 =
											BGL_CLASS_INDEX(BGl_appz00zzast_nodez00);
										BgL_arg7091z00_9155 = BgL_res7944z00_13659;
									}
									BGL_OBJECT_CLASS_NUM_SET(
										((BgL_objectz00_bglt) BgL_new1151z00_9154),
										BgL_arg7091z00_9155);
								}
								{	/* Ast/sexp.scm 734 */
									BgL_objectz00_bglt BgL_tmpz00_29621;

									BgL_tmpz00_29621 = ((BgL_objectz00_bglt) BgL_new1151z00_9154);
									BGL_OBJECT_WIDENING_SET(BgL_tmpz00_29621, BFALSE);
								}
								((BgL_objectz00_bglt) BgL_new1151z00_9154);
								BgL_new1152z00_9147 = BgL_new1151z00_9154;
							}
							((((BgL_nodez00_bglt) COBJECT(
											((BgL_nodez00_bglt) BgL_new1152z00_9147)))->BgL_locz00) =
								((obj_t) BFALSE), BUNSPEC);
							((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
												BgL_new1152z00_9147)))->BgL_typez00) =
								((BgL_typez00_bglt) ((BgL_typez00_bglt)
										BGl_za2_za2z00zztype_cachez00)), BUNSPEC);
							((((BgL_nodezf2effectzf2_bglt)
										COBJECT(((BgL_nodezf2effectzf2_bglt)
												BgL_new1152z00_9147)))->BgL_sidezd2effectzd2) =
								((obj_t) BUNSPEC), BUNSPEC);
							((((BgL_nodezf2effectzf2_bglt)
										COBJECT(((BgL_nodezf2effectzf2_bglt)
												BgL_new1152z00_9147)))->BgL_keyz00) =
								((obj_t) BINT(((long) -1))), BUNSPEC);
							((((BgL_appz00_bglt) COBJECT(BgL_new1152z00_9147))->BgL_funz00) =
								((BgL_varz00_bglt) ((BgL_varz00_bglt) BgL_funz00_9145)),
								BUNSPEC);
							{
								obj_t BgL_auxz00_29637;

								{	/* Ast/sexp.scm 737 */
									BgL_nodez00_bglt BgL_arg7085z00_9148;

									{	/* Ast/sexp.scm 737 */
										obj_t BgL_arg7088z00_9151;

										{	/* Ast/sexp.scm 737 */
											obj_t BgL_arg7089z00_9152;

											{	/* Ast/sexp.scm 737 */
												obj_t BgL_arg7090z00_9153;

												BgL_arg7090z00_9153 =
													(((BgL_variablez00_bglt) COBJECT(
															((BgL_variablez00_bglt) BgL_globalz00_49)))->
													BgL_idz00);
												BgL_arg7089z00_9152 =
													MAKE_YOUNG_PAIR(BgL_arg7090z00_9153, BNIL);
											}
											BgL_arg7088z00_9151 =
												MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 12)),
												BgL_arg7089z00_9152);
										}
										BgL_arg7085z00_9148 =
											BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg7088z00_9151,
											BNIL, BFALSE, CNST_TABLE_REF(((long) 2)));
									}
									{	/* Ast/sexp.scm 737 */
										obj_t BgL_list7086z00_9149;

										{	/* Ast/sexp.scm 737 */
											obj_t BgL_arg7087z00_9150;

											BgL_arg7087z00_9150 =
												MAKE_YOUNG_PAIR(((obj_t) BgL_refz00_50), BNIL);
											BgL_list7086z00_9149 =
												MAKE_YOUNG_PAIR(
												((obj_t) BgL_arg7085z00_9148), BgL_arg7087z00_9150);
										}
										BgL_auxz00_29637 = BgL_list7086z00_9149;
								}}
								((((BgL_appz00_bglt) COBJECT(BgL_new1152z00_9147))->
										BgL_argsz00) = ((obj_t) BgL_auxz00_29637), BUNSPEC);
							}
							return ((BgL_nodez00_bglt) BgL_new1152z00_9147);
						}
					else
						{	/* Ast/sexp.scm 733 */
							return BgL_funz00_9145;
						}
				}
			}
		}

	}



/* &define-primop-ref->node */
	BgL_nodez00_bglt BGl_z62definezd2primopzd2refzd2ze3nodez53zzast_sexpz00(obj_t
		BgL_envz00_13838, obj_t BgL_globalz00_13839, obj_t BgL_refz00_13840)
	{
		{	/* Ast/sexp.scm 731 */
			return
				BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00(
				((BgL_globalz00_bglt) BgL_globalz00_13839),
				((BgL_nodez00_bglt) BgL_refz00_13840));
		}

	}



/* define-primop-ref/src->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_definezd2primopzd2refzf2srczd2ze3nodezc3zzast_sexpz00(BgL_globalz00_bglt
		BgL_globalz00_51, BgL_nodez00_bglt BgL_refz00_52, obj_t BgL_srcz00_53)
	{
		{	/* Ast/sexp.scm 743 */
			{	/* Ast/sexp.scm 744 */
				bool_t BgL_test10536z00_29654;

				{	/* Ast/sexp.scm 744 */
					bool_t BgL_res7946z00_13665;

					BgL_res7946z00_13665 = EPAIRP(BgL_srcz00_53);
					BgL_test10536z00_29654 = BgL_res7946z00_13665;
				}
				if (BgL_test10536z00_29654)
					{
						obj_t BgL_fnamez00_9157;
						obj_t BgL_locz00_9158;

						{	/* Ast/sexp.scm 746 */
							obj_t BgL_ezd262432zd2_9161;

							BgL_ezd262432zd2_9161 = CER(((obj_t) BgL_srcz00_53));
							if (PAIRP(BgL_ezd262432zd2_9161))
								{	/* Ast/sexp.scm 746 */
									obj_t BgL_cdrzd262438zd2_9163;

									BgL_cdrzd262438zd2_9163 = CDR(BgL_ezd262432zd2_9161);
									if (
										(CAR(BgL_ezd262432zd2_9161) == CNST_TABLE_REF(((long) 39))))
										{	/* Ast/sexp.scm 746 */
											if (PAIRP(BgL_cdrzd262438zd2_9163))
												{	/* Ast/sexp.scm 746 */
													obj_t BgL_cdrzd262442zd2_9167;

													BgL_cdrzd262442zd2_9167 =
														CDR(BgL_cdrzd262438zd2_9163);
													if (PAIRP(BgL_cdrzd262442zd2_9167))
														{	/* Ast/sexp.scm 746 */
															if (NULLP(CDR(BgL_cdrzd262442zd2_9167)))
																{	/* Ast/sexp.scm 746 */
																	BgL_fnamez00_9157 =
																		CAR(BgL_cdrzd262438zd2_9163);
																	BgL_locz00_9158 =
																		CAR(BgL_cdrzd262442zd2_9167);
																	{	/* Ast/sexp.scm 748 */
																		BgL_nodez00_bglt BgL_funz00_9175;

																		BgL_funz00_9175 =
																			BGl_sexpzd2ze3nodez31zzast_sexpz00
																			(CNST_TABLE_REF(((long) 38)), BNIL,
																			BFALSE, CNST_TABLE_REF(((long) 33)));
																		{	/* Ast/sexp.scm 749 */
																			bool_t BgL_test10542z00_29676;

																			{	/* Ast/sexp.scm 749 */
																				bool_t BgL_res7947z00_13666;

																				BgL_res7947z00_13666 =
																					BGl_isazf3zf3zz__objectz00(
																					((obj_t) BgL_funz00_9175),
																					BGl_varz00zzast_nodez00);
																				BgL_test10542z00_29676 =
																					BgL_res7947z00_13666;
																			}
																			if (BgL_test10542z00_29676)
																				{	/* Ast/sexp.scm 750 */
																					BgL_appz00_bglt BgL_new1155z00_9177;

																					{	/* Ast/sexp.scm 750 */
																						BgL_appz00_bglt BgL_new1153z00_9188;

																						BgL_new1153z00_9188 =
																							((BgL_appz00_bglt)
																							BOBJECT(GC_MALLOC(sizeof(struct
																										BgL_appz00_bgl))));
																						{	/* Ast/sexp.scm 750 */
																							long BgL_arg7115z00_9189;

																							{	/* Ast/sexp.scm 750 */
																								long BgL_res7948z00_13668;

																								BgL_res7948z00_13668 =
																									BGL_CLASS_INDEX
																									(BGl_appz00zzast_nodez00);
																								BgL_arg7115z00_9189 =
																									BgL_res7948z00_13668;
																							}
																							BGL_OBJECT_CLASS_NUM_SET(
																								((BgL_objectz00_bglt)
																									BgL_new1153z00_9188),
																								BgL_arg7115z00_9189);
																						}
																						{	/* Ast/sexp.scm 750 */
																							BgL_objectz00_bglt
																								BgL_tmpz00_29683;
																							BgL_tmpz00_29683 =
																								((BgL_objectz00_bglt)
																								BgL_new1153z00_9188);
																							BGL_OBJECT_WIDENING_SET
																								(BgL_tmpz00_29683, BFALSE);
																						}
																						((BgL_objectz00_bglt)
																							BgL_new1153z00_9188);
																						BgL_new1155z00_9177 =
																							BgL_new1153z00_9188;
																					}
																					((((BgL_nodez00_bglt) COBJECT(
																									((BgL_nodez00_bglt)
																										BgL_new1155z00_9177)))->
																							BgL_locz00) =
																						((obj_t) BFALSE), BUNSPEC);
																					((((BgL_nodez00_bglt)
																								COBJECT(((BgL_nodez00_bglt)
																										BgL_new1155z00_9177)))->
																							BgL_typez00) =
																						((BgL_typez00_bglt) (
																								(BgL_typez00_bglt)
																								BGl_za2_za2z00zztype_cachez00)),
																						BUNSPEC);
																					((((BgL_nodezf2effectzf2_bglt)
																								COBJECT((
																										(BgL_nodezf2effectzf2_bglt)
																										BgL_new1155z00_9177)))->
																							BgL_sidezd2effectzd2) =
																						((obj_t) BUNSPEC), BUNSPEC);
																					((((BgL_nodezf2effectzf2_bglt)
																								COBJECT((
																										(BgL_nodezf2effectzf2_bglt)
																										BgL_new1155z00_9177)))->
																							BgL_keyz00) =
																						((obj_t) BINT(((long) -1))),
																						BUNSPEC);
																					((((BgL_appz00_bglt)
																								COBJECT(BgL_new1155z00_9177))->
																							BgL_funz00) =
																						((BgL_varz00_bglt) (
																								(BgL_varz00_bglt)
																								BgL_funz00_9175)), BUNSPEC);
																					{
																						obj_t BgL_auxz00_29699;

																						{	/* Ast/sexp.scm 754 */
																							BgL_nodez00_bglt
																								BgL_arg7105z00_9178;
																							BgL_nodez00_bglt
																								BgL_arg7106z00_9179;
																							BgL_nodez00_bglt
																								BgL_arg7107z00_9180;
																							{	/* Ast/sexp.scm 754 */
																								obj_t BgL_arg7112z00_9185;

																								{	/* Ast/sexp.scm 754 */
																									obj_t BgL_arg7113z00_9186;

																									{	/* Ast/sexp.scm 754 */
																										obj_t BgL_arg7114z00_9187;

																										BgL_arg7114z00_9187 =
																											(((BgL_variablez00_bglt)
																												COBJECT((
																														(BgL_variablez00_bglt)
																														BgL_globalz00_51)))->
																											BgL_idz00);
																										BgL_arg7113z00_9186 =
																											MAKE_YOUNG_PAIR
																											(BgL_arg7114z00_9187,
																											BNIL);
																									}
																									BgL_arg7112z00_9185 =
																										MAKE_YOUNG_PAIR
																										(CNST_TABLE_REF(((long)
																												12)),
																										BgL_arg7113z00_9186);
																								}
																								BgL_arg7105z00_9178 =
																									BGl_sexpzd2ze3nodez31zzast_sexpz00
																									(BgL_arg7112z00_9185, BNIL,
																									BFALSE,
																									CNST_TABLE_REF(((long) 2)));
																							}
																							BgL_arg7106z00_9179 =
																								BGl_sexpzd2ze3nodez31zzast_sexpz00
																								(BgL_fnamez00_9157, BNIL,
																								BFALSE,
																								CNST_TABLE_REF(((long) 2)));
																							BgL_arg7107z00_9180 =
																								BGl_sexpzd2ze3nodez31zzast_sexpz00
																								(BgL_locz00_9158, BNIL, BFALSE,
																								CNST_TABLE_REF(((long) 2)));
																							{	/* Ast/sexp.scm 753 */
																								obj_t BgL_list7108z00_9181;

																								{	/* Ast/sexp.scm 753 */
																									obj_t BgL_arg7109z00_9182;

																									{	/* Ast/sexp.scm 753 */
																										obj_t BgL_arg7110z00_9183;

																										{	/* Ast/sexp.scm 753 */
																											obj_t BgL_arg7111z00_9184;

																											BgL_arg7111z00_9184 =
																												MAKE_YOUNG_PAIR(
																												((obj_t)
																													BgL_arg7107z00_9180),
																												BNIL);
																											BgL_arg7110z00_9183 =
																												MAKE_YOUNG_PAIR(((obj_t)
																													BgL_arg7106z00_9179),
																												BgL_arg7111z00_9184);
																										}
																										BgL_arg7109z00_9182 =
																											MAKE_YOUNG_PAIR(
																											((obj_t) BgL_refz00_52),
																											BgL_arg7110z00_9183);
																									}
																									BgL_list7108z00_9181 =
																										MAKE_YOUNG_PAIR(
																										((obj_t)
																											BgL_arg7105z00_9178),
																										BgL_arg7109z00_9182);
																								}
																								BgL_auxz00_29699 =
																									BgL_list7108z00_9181;
																						}}
																						((((BgL_appz00_bglt)
																									COBJECT
																									(BgL_new1155z00_9177))->
																								BgL_argsz00) =
																							((obj_t) BgL_auxz00_29699),
																							BUNSPEC);
																					}
																					return
																						((BgL_nodez00_bglt)
																						BgL_new1155z00_9177);
																				}
																			else
																				{	/* Ast/sexp.scm 749 */
																					return BgL_funz00_9175;
																				}
																		}
																	}
																}
															else
																{	/* Ast/sexp.scm 746 */
																	return
																		BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00
																		(BgL_globalz00_51, BgL_refz00_52);
																}
														}
													else
														{	/* Ast/sexp.scm 746 */
															return
																BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00
																(BgL_globalz00_51, BgL_refz00_52);
														}
												}
											else
												{	/* Ast/sexp.scm 746 */
													return
														BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00
														(BgL_globalz00_51, BgL_refz00_52);
												}
										}
									else
										{	/* Ast/sexp.scm 746 */
											return
												BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00
												(BgL_globalz00_51, BgL_refz00_52);
										}
								}
							else
								{	/* Ast/sexp.scm 746 */
									return
										BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00
										(BgL_globalz00_51, BgL_refz00_52);
								}
						}
					}
				else
					{	/* Ast/sexp.scm 744 */
						return
							BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00
							(BgL_globalz00_51, BgL_refz00_52);
					}
			}
		}

	}



/* &define-primop-ref/src->node */
	BgL_nodez00_bglt
		BGl_z62definezd2primopzd2refzf2srczd2ze3nodeza1zzast_sexpz00(obj_t
		BgL_envz00_13841, obj_t BgL_globalz00_13842, obj_t BgL_refz00_13843,
		obj_t BgL_srcz00_13844)
	{
		{	/* Ast/sexp.scm 743 */
			return
				BGl_definezd2primopzd2refzf2srczd2ze3nodezc3zzast_sexpz00(
				((BgL_globalz00_bglt) BgL_globalz00_13842),
				((BgL_nodez00_bglt) BgL_refz00_13843), BgL_srcz00_13844);
		}

	}



/* define-primop->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_definezd2primopzd2ze3nodeze3zzast_sexpz00(BgL_globalz00_bglt
		BgL_globalz00_54)
	{
		{	/* Ast/sexp.scm 765 */
			BGl_usezd2variablez12zc0zzast_sexpz00(
				((BgL_variablez00_bglt) BgL_globalz00_54), BFALSE,
				CNST_TABLE_REF(((long) 2)));
			{	/* Ast/sexp.scm 767 */
				BgL_nodez00_bglt BgL_funz00_9190;

				BgL_funz00_9190 =
					BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 40)), BNIL,
					BFALSE, CNST_TABLE_REF(((long) 33)));
				{	/* Ast/sexp.scm 768 */
					bool_t BgL_test10543z00_29738;

					{	/* Ast/sexp.scm 768 */
						bool_t BgL_res7954z00_13685;

						BgL_res7954z00_13685 =
							BGl_isazf3zf3zz__objectz00(
							((obj_t) BgL_funz00_9190), BGl_varz00zzast_nodez00);
						BgL_test10543z00_29738 = BgL_res7954z00_13685;
					}
					if (BgL_test10543z00_29738)
						{	/* Ast/sexp.scm 769 */
							BgL_appz00_bglt BgL_new1157z00_9192;

							{	/* Ast/sexp.scm 769 */
								BgL_appz00_bglt BgL_new1156z00_9200;

								BgL_new1156z00_9200 =
									((BgL_appz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
												BgL_appz00_bgl))));
								{	/* Ast/sexp.scm 769 */
									long BgL_arg7124z00_9201;

									{	/* Ast/sexp.scm 769 */
										long BgL_res7955z00_13687;

										BgL_res7955z00_13687 =
											BGL_CLASS_INDEX(BGl_appz00zzast_nodez00);
										BgL_arg7124z00_9201 = BgL_res7955z00_13687;
									}
									BGL_OBJECT_CLASS_NUM_SET(
										((BgL_objectz00_bglt) BgL_new1156z00_9200),
										BgL_arg7124z00_9201);
								}
								{	/* Ast/sexp.scm 769 */
									BgL_objectz00_bglt BgL_tmpz00_29745;

									BgL_tmpz00_29745 = ((BgL_objectz00_bglt) BgL_new1156z00_9200);
									BGL_OBJECT_WIDENING_SET(BgL_tmpz00_29745, BFALSE);
								}
								((BgL_objectz00_bglt) BgL_new1156z00_9200);
								BgL_new1157z00_9192 = BgL_new1156z00_9200;
							}
							((((BgL_nodez00_bglt) COBJECT(
											((BgL_nodez00_bglt) BgL_new1157z00_9192)))->BgL_locz00) =
								((obj_t) BFALSE), BUNSPEC);
							((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
												BgL_new1157z00_9192)))->BgL_typez00) =
								((BgL_typez00_bglt) ((BgL_typez00_bglt)
										BGl_za2_za2z00zztype_cachez00)), BUNSPEC);
							((((BgL_nodezf2effectzf2_bglt)
										COBJECT(((BgL_nodezf2effectzf2_bglt)
												BgL_new1157z00_9192)))->BgL_sidezd2effectzd2) =
								((obj_t) BUNSPEC), BUNSPEC);
							((((BgL_nodezf2effectzf2_bglt)
										COBJECT(((BgL_nodezf2effectzf2_bglt)
												BgL_new1157z00_9192)))->BgL_keyz00) =
								((obj_t) BINT(((long) -1))), BUNSPEC);
							((((BgL_appz00_bglt) COBJECT(BgL_new1157z00_9192))->BgL_funz00) =
								((BgL_varz00_bglt) ((BgL_varz00_bglt) BgL_funz00_9190)),
								BUNSPEC);
							{
								obj_t BgL_auxz00_29761;

								{	/* Ast/sexp.scm 772 */
									BgL_nodez00_bglt BgL_arg7117z00_9193;
									BgL_nodez00_bglt BgL_arg7118z00_9194;

									{	/* Ast/sexp.scm 772 */
										obj_t BgL_arg7121z00_9197;

										{	/* Ast/sexp.scm 772 */
											obj_t BgL_arg7122z00_9198;

											{	/* Ast/sexp.scm 772 */
												obj_t BgL_arg7123z00_9199;

												BgL_arg7123z00_9199 =
													(((BgL_variablez00_bglt) COBJECT(
															((BgL_variablez00_bglt) BgL_globalz00_54)))->
													BgL_idz00);
												BgL_arg7122z00_9198 =
													MAKE_YOUNG_PAIR(BgL_arg7123z00_9199, BNIL);
											}
											BgL_arg7121z00_9197 =
												MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 12)),
												BgL_arg7122z00_9198);
										}
										BgL_arg7117z00_9193 =
											BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg7121z00_9197,
											BNIL, BFALSE, CNST_TABLE_REF(((long) 2)));
									}
									BgL_arg7118z00_9194 =
										BGl_sexpzd2ze3nodez31zzast_sexpz00(
										((obj_t) BgL_globalz00_54), BNIL, BFALSE,
										CNST_TABLE_REF(((long) 2)));
									{	/* Ast/sexp.scm 772 */
										obj_t BgL_list7119z00_9195;

										{	/* Ast/sexp.scm 772 */
											obj_t BgL_arg7120z00_9196;

											BgL_arg7120z00_9196 =
												MAKE_YOUNG_PAIR(((obj_t) BgL_arg7118z00_9194), BNIL);
											BgL_list7119z00_9195 =
												MAKE_YOUNG_PAIR(
												((obj_t) BgL_arg7117z00_9193), BgL_arg7120z00_9196);
										}
										BgL_auxz00_29761 = BgL_list7119z00_9195;
								}}
								((((BgL_appz00_bglt) COBJECT(BgL_new1157z00_9192))->
										BgL_argsz00) = ((obj_t) BgL_auxz00_29761), BUNSPEC);
							}
							return ((BgL_nodez00_bglt) BgL_new1157z00_9192);
						}
					else
						{	/* Ast/sexp.scm 768 */
							return BgL_funz00_9190;
						}
				}
			}
		}

	}



/* &define-primop->node */
	BgL_nodez00_bglt BGl_z62definezd2primopzd2ze3nodez81zzast_sexpz00(obj_t
		BgL_envz00_13845, obj_t BgL_globalz00_13846)
	{
		{	/* Ast/sexp.scm 765 */
			return
				BGl_definezd2primopzd2ze3nodeze3zzast_sexpz00(
				((BgL_globalz00_bglt) BgL_globalz00_13846));
		}

	}



/* location->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_locationzd2ze3nodez31zzast_sexpz00(BgL_globalz00_bglt BgL_globalz00_55)
	{
		{	/* Ast/sexp.scm 779 */
			BGl_usezd2variablez12zc0zzast_sexpz00(
				((BgL_variablez00_bglt) BgL_globalz00_55), BFALSE,
				CNST_TABLE_REF(((long) 2)));
			{	/* Ast/sexp.scm 781 */
				BgL_nodez00_bglt BgL_funz00_9202;

				BgL_funz00_9202 =
					BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 41)), BNIL,
					BFALSE, CNST_TABLE_REF(((long) 33)));
				{	/* Ast/sexp.scm 782 */
					bool_t BgL_test10544z00_29786;

					{	/* Ast/sexp.scm 782 */
						bool_t BgL_res7957z00_13693;

						BgL_res7957z00_13693 =
							BGl_isazf3zf3zz__objectz00(
							((obj_t) BgL_funz00_9202), BGl_varz00zzast_nodez00);
						BgL_test10544z00_29786 = BgL_res7957z00_13693;
					}
					if (BgL_test10544z00_29786)
						{	/* Ast/sexp.scm 783 */
							obj_t BgL_exprz00_9204;

							{	/* Ast/sexp.scm 783 */
								bool_t BgL_test10545z00_29789;

								{	/* Ast/sexp.scm 783 */
									obj_t BgL_arg7133z00_9214;

									BgL_arg7133z00_9214 =
										BGl_thezd2backendzd2zzbackend_backendz00();
									BgL_test10545z00_29789 =
										(((BgL_backendz00_bglt) COBJECT(
												((BgL_backendz00_bglt) BgL_arg7133z00_9214)))->
										BgL_pragmazd2supportzd2);
								}
								if (BgL_test10545z00_29789)
									{	/* Ast/sexp.scm 784 */
										obj_t BgL_arg7131z00_9212;

										{	/* Ast/sexp.scm 784 */
											obj_t BgL_arg7132z00_9213;

											BgL_arg7132z00_9213 =
												MAKE_YOUNG_PAIR(((obj_t) BgL_globalz00_55), BNIL);
											BgL_arg7131z00_9212 =
												MAKE_YOUNG_PAIR(BGl_string8022z00zzast_sexpz00,
												BgL_arg7132z00_9213);
										}
										BgL_exprz00_9204 =
											MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 42)),
											BgL_arg7131z00_9212);
									}
								else
									{	/* Ast/sexp.scm 783 */
										BgL_exprz00_9204 = ((obj_t) BgL_globalz00_55);
									}
							}
							{	/* Ast/sexp.scm 786 */
								BgL_appz00_bglt BgL_new1159z00_9205;

								{	/* Ast/sexp.scm 786 */
									BgL_appz00_bglt BgL_new1158z00_9208;

									BgL_new1158z00_9208 =
										((BgL_appz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
													BgL_appz00_bgl))));
									{	/* Ast/sexp.scm 786 */
										long BgL_arg7128z00_9209;

										{	/* Ast/sexp.scm 786 */
											long BgL_res7959z00_13698;

											BgL_res7959z00_13698 =
												BGL_CLASS_INDEX(BGl_appz00zzast_nodez00);
											BgL_arg7128z00_9209 = BgL_res7959z00_13698;
										}
										BGL_OBJECT_CLASS_NUM_SET(
											((BgL_objectz00_bglt) BgL_new1158z00_9208),
											BgL_arg7128z00_9209);
									}
									{	/* Ast/sexp.scm 786 */
										BgL_objectz00_bglt BgL_tmpz00_29803;

										BgL_tmpz00_29803 =
											((BgL_objectz00_bglt) BgL_new1158z00_9208);
										BGL_OBJECT_WIDENING_SET(BgL_tmpz00_29803, BFALSE);
									}
									((BgL_objectz00_bglt) BgL_new1158z00_9208);
									BgL_new1159z00_9205 = BgL_new1158z00_9208;
								}
								((((BgL_nodez00_bglt) COBJECT(
												((BgL_nodez00_bglt) BgL_new1159z00_9205)))->
										BgL_locz00) = ((obj_t) BFALSE), BUNSPEC);
								((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
													BgL_new1159z00_9205)))->BgL_typez00) =
									((BgL_typez00_bglt)
										BGl_strictzd2nodezd2typez00zzast_nodez00(((BgL_typez00_bglt)
												BGl_za2_za2z00zztype_cachez00),
											((BgL_typez00_bglt) BGl_za2objza2z00zztype_cachez00))),
									BUNSPEC);
								((((BgL_nodezf2effectzf2_bglt)
											COBJECT(((BgL_nodezf2effectzf2_bglt)
													BgL_new1159z00_9205)))->BgL_sidezd2effectzd2) =
									((obj_t) BUNSPEC), BUNSPEC);
								((((BgL_nodezf2effectzf2_bglt)
											COBJECT(((BgL_nodezf2effectzf2_bglt)
													BgL_new1159z00_9205)))->BgL_keyz00) =
									((obj_t) BINT(((long) -1))), BUNSPEC);
								((((BgL_appz00_bglt) COBJECT(BgL_new1159z00_9205))->
										BgL_funz00) =
									((BgL_varz00_bglt) ((BgL_varz00_bglt) BgL_funz00_9202)),
									BUNSPEC);
								{
									obj_t BgL_auxz00_29821;

									{	/* Ast/sexp.scm 789 */
										BgL_nodez00_bglt BgL_arg7126z00_9206;

										BgL_arg7126z00_9206 =
											BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_exprz00_9204, BNIL,
											BFALSE, CNST_TABLE_REF(((long) 2)));
										{	/* Ast/sexp.scm 789 */
											obj_t BgL_list7127z00_9207;

											BgL_list7127z00_9207 =
												MAKE_YOUNG_PAIR(((obj_t) BgL_arg7126z00_9206), BNIL);
											BgL_auxz00_29821 = BgL_list7127z00_9207;
									}}
									((((BgL_appz00_bglt) COBJECT(BgL_new1159z00_9205))->
											BgL_argsz00) = ((obj_t) BgL_auxz00_29821), BUNSPEC);
								}
								return ((BgL_nodez00_bglt) BgL_new1159z00_9205);
							}
						}
					else
						{	/* Ast/sexp.scm 782 */
							return BgL_funz00_9202;
						}
				}
			}
		}

	}



/* &location->node */
	BgL_nodez00_bglt BGl_z62locationzd2ze3nodez53zzast_sexpz00(obj_t
		BgL_envz00_13847, obj_t BgL_globalz00_13848)
	{
		{	/* Ast/sexp.scm 779 */
			return
				BGl_locationzd2ze3nodez31zzast_sexpz00(
				((BgL_globalz00_bglt) BgL_globalz00_13848));
		}

	}



/* make-anonymous-name */
	BGL_EXPORTED_DEF obj_t BGl_makezd2anonymouszd2namez00zzast_sexpz00(obj_t
		BgL_locz00_56, obj_t BgL_prefz00_57)
	{
		{	/* Ast/sexp.scm 795 */
			{	/* Ast/sexp.scm 796 */
				obj_t BgL_prefz00_9215;

				{	/* Ast/sexp.scm 796 */
					bool_t BgL_test10546z00_29830;

					if (PAIRP(BgL_prefz00_57))
						{	/* Ast/sexp.scm 796 */
							obj_t BgL_tmpz00_29833;

							BgL_tmpz00_29833 = CAR(BgL_prefz00_57);
							BgL_test10546z00_29830 = STRINGP(BgL_tmpz00_29833);
						}
					else
						{	/* Ast/sexp.scm 796 */
							BgL_test10546z00_29830 = ((bool_t) 0);
						}
					if (BgL_test10546z00_29830)
						{	/* Ast/sexp.scm 796 */
							BgL_prefz00_9215 = CAR(BgL_prefz00_57);
						}
					else
						{	/* Ast/sexp.scm 796 */
							BgL_prefz00_9215 = BGl_string8000z00zzast_sexpz00;
						}
				}
				{	/* Ast/sexp.scm 799 */
					bool_t BgL_test10548z00_29837;

					if (STRUCTP(BgL_locz00_56))
						{	/* Ast/sexp.scm 799 */
							BgL_test10548z00_29837 =
								(STRUCT_KEY(BgL_locz00_56) == CNST_TABLE_REF(((long) 43)));
						}
					else
						{	/* Ast/sexp.scm 799 */
							BgL_test10548z00_29837 = ((bool_t) 0);
						}
					if (BgL_test10548z00_29837)
						{	/* Ast/sexp.scm 800 */
							obj_t BgL_filez00_9217;
							obj_t BgL_linez00_9218;
							obj_t BgL_basez00_9219;

							BgL_filez00_9217 =
								BGl_locationzd2fullzd2fnamez00zztools_locationz00
								(BgL_locz00_56);
							BgL_linez00_9218 = STRUCT_REF(BgL_locz00_56, (int) (((long) 2)));
							{	/* Ast/sexp.scm 802 */
								obj_t BgL_arg7163z00_9260;

								BgL_arg7163z00_9260 =
									BGl_gensymz00zz__r4_symbols_6_4z00(string_append_3
									(BGl_string8023z00zzast_sexpz00, BgL_prefz00_9215,
										BGl_string8024z00zzast_sexpz00));
								{	/* Ast/sexp.scm 802 */
									obj_t BgL_res7965z00_13715;

									{	/* Ast/sexp.scm 802 */
										obj_t BgL_arg1412z00_13714;

										BgL_arg1412z00_13714 =
											SYMBOL_TO_STRING(BgL_arg7163z00_9260);
										BgL_res7965z00_13715 =
											BGl_stringzd2copyzd2zz__r4_strings_6_7z00
											(BgL_arg1412z00_13714);
									}
									BgL_basez00_9219 = BgL_res7965z00_13715;
							}}
							{	/* Ast/sexp.scm 804 */
								bool_t BgL_test10550z00_29850;

								{	/* Ast/sexp.scm 804 */

									BgL_test10550z00_29850 =
										CBOOL(BGl_stringzd2containszd2zz__r4_strings_6_7z00
										(BgL_prefz00_9215, BGl_string8023z00zzast_sexpz00,
											(int) (((long) 0))));
								}
								if (BgL_test10550z00_29850)
									{	/* Ast/sexp.scm 805 */
										obj_t BgL_arg7136z00_9224;

										{	/* Ast/sexp.scm 805 */
											obj_t BgL_arg7137z00_9225;
											obj_t BgL_arg7138z00_9226;

											{	/* Ast/sexp.scm 805 */
												obj_t BgL_arg7139z00_9227;

												{	/* Ast/sexp.scm 805 */
													obj_t BgL_res7966z00_13717;

													BgL_res7966z00_13717 =
														bstring_to_symbol(((obj_t) BgL_prefz00_9215));
													BgL_arg7139z00_9227 = BgL_res7966z00_13717;
												}
												{	/* Ast/sexp.scm 805 */
													obj_t BgL_res7967z00_13720;

													{	/* Ast/sexp.scm 805 */
														obj_t BgL_arg1412z00_13719;

														BgL_arg1412z00_13719 =
															SYMBOL_TO_STRING(BgL_arg7139z00_9227);
														BgL_res7967z00_13720 =
															BGl_stringzd2copyzd2zz__r4_strings_6_7z00
															(BgL_arg1412z00_13719);
													}
													BgL_arg7137z00_9225 = BgL_res7967z00_13720;
												}
											}
											{	/* Ast/sexp.scm 805 */
												obj_t BgL_arg7140z00_9228;

												BgL_arg7140z00_9228 =
													BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF((
															(long) 44)));
												{	/* Ast/sexp.scm 805 */
													obj_t BgL_res7968z00_13723;

													{	/* Ast/sexp.scm 805 */
														obj_t BgL_arg1412z00_13722;

														BgL_arg1412z00_13722 =
															SYMBOL_TO_STRING(BgL_arg7140z00_9228);
														BgL_res7968z00_13723 =
															BGl_stringzd2copyzd2zz__r4_strings_6_7z00
															(BgL_arg1412z00_13722);
													}
													BgL_arg7138z00_9226 = BgL_res7968z00_13723;
											}}
											BgL_arg7136z00_9224 =
												string_append(BgL_arg7137z00_9225, BgL_arg7138z00_9226);
										}
										return bstring_to_symbol(BgL_arg7136z00_9224);
									}
								else
									{	/* Ast/sexp.scm 806 */
										bool_t BgL_test10551z00_29864;

										{	/* Ast/sexp.scm 806 */
											bool_t BgL_test10552z00_29865;

											if (
												((long) CINT(BGl_za2bdbzd2debugza2zd2zzengine_paramz00)
													>= ((long) 1)))
												{	/* Ast/sexp.scm 807 */
													obj_t BgL_arg7161z00_9255;

													{	/* Ast/sexp.scm 807 */
														obj_t BgL_arg7162z00_9256;

														BgL_arg7162z00_9256 =
															BGl_thezd2backendzd2zzbackend_backendz00();
														BgL_arg7161z00_9255 =
															(((BgL_backendz00_bglt) COBJECT(
																	((BgL_backendz00_bglt)
																		BgL_arg7162z00_9256)))->
															BgL_debugzd2supportzd2);
													}
													BgL_test10552z00_29865 =
														CBOOL(BGl_memqz00zz__r4_pairs_and_lists_6_3z00
														(CNST_TABLE_REF(((long) 45)), BgL_arg7161z00_9255));
												}
											else
												{	/* Ast/sexp.scm 806 */
													BgL_test10552z00_29865 = ((bool_t) 0);
												}
											if (BgL_test10552z00_29865)
												{	/* Ast/sexp.scm 806 */
													BgL_test10551z00_29864 = ((bool_t) 1);
												}
											else
												{	/* Ast/sexp.scm 806 */
													BgL_test10551z00_29864 =
														(
														(long)
														CINT(BGl_za2compilerzd2debugza2zd2zzengine_paramz00)
														>= ((long) 1));
										}}
										if (BgL_test10551z00_29864)
											{	/* Ast/sexp.scm 809 */
												obj_t BgL_filez00_9237;

												if (bigloo_strncmp(BgL_filez00_9217,
														BGl_string8025z00zzast_sexpz00, ((long) 2)))
													{	/* Ast/sexp.scm 809 */
														BgL_filez00_9237 =
															c_substring(BgL_filez00_9217, ((long) 2),
															STRING_LENGTH(BgL_filez00_9217));
													}
												else
													{	/* Ast/sexp.scm 809 */
														BgL_filez00_9237 = BgL_filez00_9217;
													}
												{	/* Ast/sexp.scm 814 */
													obj_t BgL_arg7148z00_9238;

													{	/* Ast/sexp.scm 814 */
														obj_t BgL_arg7149z00_9239;
														obj_t BgL_arg7150z00_9240;

														BgL_arg7149z00_9239 =
															BGl_stringzd2replacezd2zz__r4_strings_6_7z00
															(BgL_filez00_9237, (char) (((unsigned char) '.')),
															(char) (((unsigned char) ',')));
														{	/* Ast/sexp.scm 815 */

															BgL_arg7150z00_9240 =
																BGl_numberzd2ze3stringz31zz__r4_numbers_6_5z00
																(BgL_linez00_9218, BINT(((long) 10)));
														}
														{	/* Ast/sexp.scm 813 */
															obj_t BgL_list7151z00_9241;

															{	/* Ast/sexp.scm 813 */
																obj_t BgL_arg7152z00_9242;

																{	/* Ast/sexp.scm 813 */
																	obj_t BgL_arg7153z00_9243;

																	{	/* Ast/sexp.scm 813 */
																		obj_t BgL_arg7154z00_9244;

																		{	/* Ast/sexp.scm 813 */
																			obj_t BgL_arg7155z00_9245;

																			{	/* Ast/sexp.scm 813 */
																				obj_t BgL_arg7156z00_9246;

																				BgL_arg7156z00_9246 =
																					MAKE_YOUNG_PAIR
																					(BGl_string8026z00zzast_sexpz00,
																					BNIL);
																				BgL_arg7155z00_9245 =
																					MAKE_YOUNG_PAIR(BgL_arg7150z00_9240,
																					BgL_arg7156z00_9246);
																			}
																			BgL_arg7154z00_9244 =
																				MAKE_YOUNG_PAIR
																				(BGl_string8024z00zzast_sexpz00,
																				BgL_arg7155z00_9245);
																		}
																		BgL_arg7153z00_9243 =
																			MAKE_YOUNG_PAIR(BgL_arg7149z00_9239,
																			BgL_arg7154z00_9244);
																	}
																	BgL_arg7152z00_9242 =
																		MAKE_YOUNG_PAIR
																		(BGl_string8024z00zzast_sexpz00,
																		BgL_arg7153z00_9243);
																}
																BgL_list7151z00_9241 =
																	MAKE_YOUNG_PAIR(BgL_basez00_9219,
																	BgL_arg7152z00_9242);
															}
															BgL_arg7148z00_9238 =
																BGl_stringzd2appendzd2zz__r4_strings_6_7z00
																(BgL_list7151z00_9241);
													}}
													return bstring_to_symbol(BgL_arg7148z00_9238);
												}
											}
										else
											{	/* Ast/sexp.scm 818 */
												obj_t BgL_arg7159z00_9251;

												BgL_arg7159z00_9251 =
													BGl_stringzd2replacezd2zz__r4_strings_6_7z00
													(string_append(BgL_basez00_9219,
														BGl_string8027z00zzast_sexpz00),
													(char) (((unsigned char) '.')),
													(char) (((unsigned char) ',')));
												{	/* Ast/sexp.scm 818 */
													obj_t BgL_res7977z00_13744;

													BgL_res7977z00_13744 =
														bstring_to_symbol(((obj_t) BgL_arg7159z00_9251));
													return BgL_res7977z00_13744;
												}
											}
									}
							}
						}
					else
						{	/* Ast/sexp.scm 819 */
							obj_t BgL_arg7165z00_9262;

							{	/* Ast/sexp.scm 819 */
								obj_t BgL_arg7166z00_9263;
								obj_t BgL_arg7167z00_9264;

								{	/* Ast/sexp.scm 819 */
									obj_t BgL_arg7168z00_9265;

									BgL_arg7168z00_9265 =
										BGl_gensymz00zz__r4_symbols_6_4z00(string_append_3
										(BGl_string8023z00zzast_sexpz00, BgL_prefz00_9215,
											BGl_string8028z00zzast_sexpz00));
									{	/* Ast/sexp.scm 819 */
										obj_t BgL_res7978z00_13747;

										{	/* Ast/sexp.scm 819 */
											obj_t BgL_arg1412z00_13746;

											BgL_arg1412z00_13746 =
												SYMBOL_TO_STRING(BgL_arg7168z00_9265);
											BgL_res7978z00_13747 =
												BGl_stringzd2copyzd2zz__r4_strings_6_7z00
												(BgL_arg1412z00_13746);
										}
										BgL_arg7166z00_9263 = BgL_res7978z00_13747;
									}
								}
								{	/* Ast/sexp.scm 819 */
									obj_t BgL_res7979z00_13750;

									{	/* Ast/sexp.scm 819 */
										obj_t BgL_symbolz00_13748;

										BgL_symbolz00_13748 = CNST_TABLE_REF(((long) 46));
										{	/* Ast/sexp.scm 819 */
											obj_t BgL_arg1412z00_13749;

											BgL_arg1412z00_13749 =
												SYMBOL_TO_STRING(BgL_symbolz00_13748);
											BgL_res7979z00_13750 =
												BGl_stringzd2copyzd2zz__r4_strings_6_7z00
												(BgL_arg1412z00_13749);
									}}
									BgL_arg7167z00_9264 = BgL_res7979z00_13750;
								}
								BgL_arg7165z00_9262 =
									string_append(BgL_arg7166z00_9263, BgL_arg7167z00_9264);
							}
							return bstring_to_symbol(BgL_arg7165z00_9262);
						}
				}
			}
		}

	}



/* &make-anonymous-name */
	obj_t BGl_z62makezd2anonymouszd2namez62zzast_sexpz00(obj_t BgL_envz00_13849,
		obj_t BgL_locz00_13850, obj_t BgL_prefz00_13851)
	{
		{	/* Ast/sexp.scm 795 */
			return
				BGl_makezd2anonymouszd2namez00zzast_sexpz00(BgL_locz00_13850,
				BgL_prefz00_13851);
		}

	}



/* synchronize->node */
	BgL_nodez00_bglt BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00(obj_t
		BgL_expz00_58, obj_t BgL_mutexz00_59, obj_t BgL_prelockz00_60,
		obj_t BgL_bodyz00_61, obj_t BgL_stackz00_62, obj_t BgL_locz00_63,
		obj_t BgL_sitez00_64)
	{
		{	/* Ast/sexp.scm 824 */
			if (SYMBOLP(BgL_mutexz00_59))
				{	/* Ast/sexp.scm 826 */
					BgL_syncz00_bglt BgL_new1161z00_9273;

					{	/* Ast/sexp.scm 827 */
						BgL_syncz00_bglt BgL_new1160z00_9275;

						BgL_new1160z00_9275 =
							((BgL_syncz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
										BgL_syncz00_bgl))));
						{	/* Ast/sexp.scm 827 */
							long BgL_arg7176z00_9276;

							{	/* Ast/sexp.scm 827 */
								long BgL_res7982z00_13755;

								BgL_res7982z00_13755 =
									BGL_CLASS_INDEX(BGl_syncz00zzast_nodez00);
								BgL_arg7176z00_9276 = BgL_res7982z00_13755;
							}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt) BgL_new1160z00_9275),
								BgL_arg7176z00_9276);
						}
						{	/* Ast/sexp.scm 827 */
							BgL_objectz00_bglt BgL_tmpz00_29916;

							BgL_tmpz00_29916 = ((BgL_objectz00_bglt) BgL_new1160z00_9275);
							BGL_OBJECT_WIDENING_SET(BgL_tmpz00_29916, BFALSE);
						}
						((BgL_objectz00_bglt) BgL_new1160z00_9275);
						BgL_new1161z00_9273 = BgL_new1160z00_9275;
					}
					((((BgL_nodez00_bglt) COBJECT(
									((BgL_nodez00_bglt) BgL_new1161z00_9273)))->BgL_locz00) =
						((obj_t) BgL_locz00_63), BUNSPEC);
					((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
										BgL_new1161z00_9273)))->BgL_typez00) =
						((BgL_typez00_bglt) ((BgL_typez00_bglt)
								BGl_za2_za2z00zztype_cachez00)), BUNSPEC);
					((((BgL_syncz00_bglt) COBJECT(BgL_new1161z00_9273))->BgL_mutexz00) =
						((BgL_nodez00_bglt)
							BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_mutexz00_59,
								BgL_stackz00_62, BgL_locz00_63, CNST_TABLE_REF(((long) 2)))),
						BUNSPEC);
					((((BgL_syncz00_bglt) COBJECT(BgL_new1161z00_9273))->BgL_prelockz00) =
						((BgL_nodez00_bglt)
							BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_prelockz00_60,
								BgL_stackz00_62, BgL_locz00_63, CNST_TABLE_REF(((long) 2)))),
						BUNSPEC);
					{
						BgL_nodez00_bglt BgL_auxz00_29931;

						{	/* Ast/sexp.scm 831 */
							obj_t BgL_arg7175z00_9274;

							BgL_arg7175z00_9274 =
								BGl_normaliza7ezd2prognz75zztools_prognz00(BgL_bodyz00_61);
							BgL_auxz00_29931 =
								BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg7175z00_9274,
								BgL_stackz00_62, BgL_locz00_63, BgL_sitez00_64);
						}
						((((BgL_syncz00_bglt) COBJECT(BgL_new1161z00_9273))->BgL_bodyz00) =
							((BgL_nodez00_bglt) BgL_auxz00_29931), BUNSPEC);
					}
					return ((BgL_nodez00_bglt) BgL_new1161z00_9273);
				}
			else
				{	/* Ast/sexp.scm 832 */
					obj_t BgL_vz00_9277;

					BgL_vz00_9277 =
						BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
						(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 47))));
					{	/* Ast/sexp.scm 832 */
						obj_t BgL_varz00_9278;

						BgL_varz00_9278 =
							BGl_makezd2typedzd2identz00zzast_identz00(BgL_vz00_9277,
							CNST_TABLE_REF(((long) 47)));
						{	/* Ast/sexp.scm 833 */
							obj_t BgL_nexpz00_9279;

							{	/* Ast/sexp.scm 834 */
								obj_t BgL_arg7184z00_9287;

								{	/* Ast/sexp.scm 834 */
									obj_t BgL_arg7185z00_9288;

									BgL_arg7185z00_9288 =
										MAKE_YOUNG_PAIR(BgL_vz00_9277,
										BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
										(BgL_bodyz00_61, BNIL));
									BgL_arg7184z00_9287 =
										MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 29)),
										BgL_arg7185z00_9288);
								}
								BgL_nexpz00_9279 =
									BGl_epairifyzd2reczd2zztools_miscz00(BgL_arg7184z00_9287,
									BgL_expz00_58);
							}
							{	/* Ast/sexp.scm 834 */

								{	/* Ast/sexp.scm 835 */
									obj_t BgL_arg7177z00_9280;

									{	/* Ast/sexp.scm 835 */
										obj_t BgL_arg7178z00_9281;
										obj_t BgL_arg7179z00_9282;

										BgL_arg7178z00_9281 = BGl_letzd2symzd2zzast_letz00();
										{	/* Ast/sexp.scm 835 */
											obj_t BgL_arg7180z00_9283;
											obj_t BgL_arg7181z00_9284;

											{	/* Ast/sexp.scm 835 */
												obj_t BgL_arg7182z00_9285;

												{	/* Ast/sexp.scm 835 */
													obj_t BgL_arg7183z00_9286;

													BgL_arg7183z00_9286 =
														MAKE_YOUNG_PAIR(BgL_mutexz00_59, BNIL);
													BgL_arg7182z00_9285 =
														MAKE_YOUNG_PAIR(BgL_varz00_9278,
														BgL_arg7183z00_9286);
												}
												BgL_arg7180z00_9283 =
													MAKE_YOUNG_PAIR(BgL_arg7182z00_9285, BNIL);
											}
											BgL_arg7181z00_9284 =
												MAKE_YOUNG_PAIR(BgL_nexpz00_9279, BNIL);
											BgL_arg7179z00_9282 =
												MAKE_YOUNG_PAIR(BgL_arg7180z00_9283,
												BgL_arg7181z00_9284);
										}
										BgL_arg7177z00_9280 =
											MAKE_YOUNG_PAIR(BgL_arg7178z00_9281, BgL_arg7179z00_9282);
									}
									BGl_replacez12z12zztools_miscz00(BgL_expz00_58,
										BgL_arg7177z00_9280);
								}
								return
									BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_expz00_58,
									BgL_stackz00_62, BgL_locz00_63, BgL_sitez00_64);
							}
						}
					}
				}
		}

	}



/* not-test */
	obj_t BGl_notzd2testzd2zzast_sexpz00(obj_t BgL_testz00_65)
	{
		{	/* Ast/sexp.scm 844 */
			{
				obj_t BgL_bindingsz00_9295;
				obj_t BgL_exprz00_9296;

				if (PAIRP(BgL_testz00_65))
					{	/* Ast/sexp.scm 845 */
						obj_t BgL_cdrzd262458zd2_9301;

						BgL_cdrzd262458zd2_9301 = CDR(BgL_testz00_65);
						if ((CAR(BgL_testz00_65) == CNST_TABLE_REF(((long) 1))))
							{	/* Ast/sexp.scm 845 */
								if (PAIRP(BgL_cdrzd262458zd2_9301))
									{	/* Ast/sexp.scm 845 */
										obj_t BgL_cdrzd262461zd2_9305;

										BgL_cdrzd262461zd2_9305 = CDR(BgL_cdrzd262458zd2_9301);
										if (PAIRP(BgL_cdrzd262461zd2_9305))
											{	/* Ast/sexp.scm 845 */
												obj_t BgL_cdrzd262464zd2_9307;

												BgL_cdrzd262464zd2_9307 = CDR(BgL_cdrzd262461zd2_9305);
												if ((CAR(BgL_cdrzd262461zd2_9305) == BFALSE))
													{	/* Ast/sexp.scm 845 */
														if (PAIRP(BgL_cdrzd262464zd2_9307))
															{	/* Ast/sexp.scm 845 */
																if ((CAR(BgL_cdrzd262464zd2_9307) == BTRUE))
																	{	/* Ast/sexp.scm 845 */
																		if (NULLP(CDR(BgL_cdrzd262464zd2_9307)))
																			{	/* Ast/sexp.scm 845 */
																				return CAR(BgL_cdrzd262458zd2_9301);
																			}
																		else
																			{	/* Ast/sexp.scm 845 */
																				return BFALSE;
																			}
																	}
																else
																	{	/* Ast/sexp.scm 845 */
																		return BFALSE;
																	}
															}
														else
															{	/* Ast/sexp.scm 845 */
																return BFALSE;
															}
													}
												else
													{	/* Ast/sexp.scm 845 */
														return BFALSE;
													}
											}
										else
											{	/* Ast/sexp.scm 845 */
												return BFALSE;
											}
									}
								else
									{	/* Ast/sexp.scm 845 */
										return BFALSE;
									}
							}
						else
							{	/* Ast/sexp.scm 845 */
								if ((CAR(BgL_testz00_65) == CNST_TABLE_REF(((long) 48))))
									{	/* Ast/sexp.scm 845 */
										if (PAIRP(BgL_cdrzd262458zd2_9301))
											{	/* Ast/sexp.scm 845 */
												if (NULLP(CDR(BgL_cdrzd262458zd2_9301)))
													{	/* Ast/sexp.scm 845 */
														return CAR(BgL_cdrzd262458zd2_9301);
													}
												else
													{	/* Ast/sexp.scm 845 */
														return BFALSE;
													}
											}
										else
											{	/* Ast/sexp.scm 845 */
												return BFALSE;
											}
									}
								else
									{	/* Ast/sexp.scm 845 */
										obj_t BgL_cdrzd262538zd2_9327;

										BgL_cdrzd262538zd2_9327 = CDR(BgL_testz00_65);
										if ((CAR(BgL_testz00_65) == CNST_TABLE_REF(((long) 17))))
											{	/* Ast/sexp.scm 845 */
												if (PAIRP(BgL_cdrzd262538zd2_9327))
													{	/* Ast/sexp.scm 845 */
														obj_t BgL_cdrzd262542zd2_9331;

														BgL_cdrzd262542zd2_9331 =
															CDR(BgL_cdrzd262538zd2_9327);
														if (PAIRP(BgL_cdrzd262542zd2_9331))
															{	/* Ast/sexp.scm 845 */
																if (NULLP(CDR(BgL_cdrzd262542zd2_9331)))
																	{	/* Ast/sexp.scm 845 */
																		BgL_bindingsz00_9295 =
																			CAR(BgL_cdrzd262538zd2_9327);
																		BgL_exprz00_9296 =
																			CAR(BgL_cdrzd262542zd2_9331);
																		{	/* Ast/sexp.scm 851 */
																			obj_t BgL_ntz00_9341;

																			BgL_ntz00_9341 =
																				BGl_notzd2testzd2zzast_sexpz00
																				(BgL_exprz00_9296);
																			if (CBOOL(BgL_ntz00_9341))
																				{	/* Ast/sexp.scm 853 */
																					obj_t BgL_arg7223z00_9342;

																					{	/* Ast/sexp.scm 853 */
																						obj_t BgL_arg7224z00_9343;

																						{	/* Ast/sexp.scm 853 */
																							obj_t BgL_arg7225z00_9344;

																							BgL_arg7225z00_9344 =
																								MAKE_YOUNG_PAIR(BgL_ntz00_9341,
																								BNIL);
																							BgL_arg7224z00_9343 =
																								MAKE_YOUNG_PAIR
																								(BgL_bindingsz00_9295,
																								BgL_arg7225z00_9344);
																						}
																						BgL_arg7223z00_9342 =
																							MAKE_YOUNG_PAIR(CNST_TABLE_REF((
																									(long) 17)),
																							BgL_arg7224z00_9343);
																					}
																					return
																						BGl_epairifyzd2reczd2zztools_miscz00
																						(BgL_arg7223z00_9342,
																						BgL_testz00_65);
																				}
																			else
																				{	/* Ast/sexp.scm 852 */
																					return BFALSE;
																				}
																		}
																	}
																else
																	{	/* Ast/sexp.scm 845 */
																		return BFALSE;
																	}
															}
														else
															{	/* Ast/sexp.scm 845 */
																return BFALSE;
															}
													}
												else
													{	/* Ast/sexp.scm 845 */
														return BFALSE;
													}
											}
										else
											{	/* Ast/sexp.scm 845 */
												return BFALSE;
											}
									}
							}
					}
				else
					{	/* Ast/sexp.scm 845 */
						return BFALSE;
					}
			}
		}

	}



/* used-in? */
	bool_t BGl_usedzd2inzf3z21zzast_sexpz00(obj_t BgL_idz00_66,
		obj_t BgL_exprz00_67)
	{
		{	/* Ast/sexp.scm 862 */
			if ((BgL_idz00_66 == BgL_exprz00_67))
				{	/* Ast/sexp.scm 864 */
					return ((bool_t) 1);
				}
			else
				{	/* Ast/sexp.scm 864 */
					if (PAIRP(BgL_exprz00_67))
						{	/* Ast/sexp.scm 865 */
							if ((CAR(BgL_exprz00_67) == CNST_TABLE_REF(((long) 12))))
								{	/* Ast/sexp.scm 866 */
									return ((bool_t) 0);
								}
							else
								{	/* Ast/sexp.scm 866 */
									if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00
										(BgL_exprz00_67))
										{
											obj_t BgL_list1476z00_9361;

											{	/* Ast/sexp.scm 868 */
												obj_t BgL_tmpz00_30023;

												BgL_list1476z00_9361 = BgL_exprz00_67;
											BgL_zc3z04anonymousza37236ze3z87_9362:
												if (PAIRP(BgL_list1476z00_9361))
													{	/* Ast/sexp.scm 868 */
														if (BGl_usedzd2inzf3z21zzast_sexpz00(BgL_idz00_66,
																CAR(BgL_list1476z00_9361)))
															{	/* Ast/sexp.scm 868 */
																BgL_tmpz00_30023 = CAR(BgL_list1476z00_9361);
															}
														else
															{
																obj_t BgL_list1476z00_30030;

																BgL_list1476z00_30030 =
																	CDR(BgL_list1476z00_9361);
																BgL_list1476z00_9361 = BgL_list1476z00_30030;
																goto BgL_zc3z04anonymousza37236ze3z87_9362;
															}
													}
												else
													{	/* Ast/sexp.scm 868 */
														BgL_tmpz00_30023 = BFALSE;
													}
												return CBOOL(BgL_tmpz00_30023);
											}
										}
									else
										{	/* Ast/sexp.scm 867 */
											return ((bool_t) 0);
										}
								}
						}
					else
						{	/* Ast/sexp.scm 865 */
							return ((bool_t) 0);
						}
				}
		}

	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzast_sexpz00()
	{
		{	/* Ast/sexp.scm 14 */
			return BUNSPEC;
		}

	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzast_sexpz00()
	{
		{	/* Ast/sexp.scm 14 */
			return BUNSPEC;
		}

	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzast_sexpz00()
	{
		{	/* Ast/sexp.scm 14 */
			return BUNSPEC;
		}

	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzast_sexpz00()
	{
		{	/* Ast/sexp.scm 14 */
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 54713316),
				BSTRING_TO_STRING(BGl_string8029z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 300504031),
				BSTRING_TO_STRING(BGl_string8029z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 365925558),
				BSTRING_TO_STRING(BGl_string8029z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_prognz00(((long) 301998274),
				BSTRING_TO_STRING(BGl_string8029z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_locationz00(((long) 462333240),
				BSTRING_TO_STRING(BGl_string8029z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_miscz00(((long) 9470071),
				BSTRING_TO_STRING(BGl_string8029z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_dssslz00(((long) 275867955),
				BSTRING_TO_STRING(BGl_string8029z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 515343395),
				BSTRING_TO_STRING(BGl_string8029z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztype_envz00(((long) 296457443),
				BSTRING_TO_STRING(BGl_string8029z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztype_miscz00(((long) 49975086),
				BSTRING_TO_STRING(BGl_string8029z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 346491734),
				BSTRING_TO_STRING(BGl_string8029z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzobject_classz00(((long) 502007119),
				BSTRING_TO_STRING(BGl_string8029z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztype_typeofz00(((long) 398780265),
				BSTRING_TO_STRING(BGl_string8029z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 476633989),
				BSTRING_TO_STRING(BGl_string8029z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 216206620),
				BSTRING_TO_STRING(BGl_string8029z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_identz00(((long) 174885617),
				BSTRING_TO_STRING(BGl_string8029z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_envz00(((long) 146730773),
				BSTRING_TO_STRING(BGl_string8029z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 90839984),
				BSTRING_TO_STRING(BGl_string8029z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 506185397),
				BSTRING_TO_STRING(BGl_string8029z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_buildz00(((long) 428035925),
				BSTRING_TO_STRING(BGl_string8029z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_pragmaz00(((long) 156774043),
				BSTRING_TO_STRING(BGl_string8029z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_labelsz00(((long) 129879154),
				BSTRING_TO_STRING(BGl_string8029z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_letz00(((long) 469204197),
				BSTRING_TO_STRING(BGl_string8029z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_exitz00(((long) 419066125),
				BSTRING_TO_STRING(BGl_string8029z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_appz00(((long) 449859288),
				BSTRING_TO_STRING(BGl_string8029z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_applyz00(((long) 277780830),
				BSTRING_TO_STRING(BGl_string8029z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_privatez00(((long) 135263837),
				BSTRING_TO_STRING(BGl_string8029z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_objectz00(((long) 520121776),
				BSTRING_TO_STRING(BGl_string8029z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_dumpz00(((long) 271707717),
				BSTRING_TO_STRING(BGl_string8029z00zzast_sexpz00));
			return
				BGl_modulezd2initializa7ationz75zzeffect_feffectz00(((long) 516374368),
				BSTRING_TO_STRING(BGl_string8029z00zzast_sexpz00));
		}

	}

#ifdef __cplusplus
}
#endif
