/*===========================================================================*/
/*   (Eval/evaluate.scm)                                                     */
/*   Bigloo (4.3h)                                                           */
/*   Inria -- Sophia Antipolis (c)       Tue 12 May 2020 08:36:09 AM CEST    */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.3h/bin/bigloo -srfi enable-resolv -srfi enable-unistring -srfi enable-pcre -srfi enable-gmp -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.3h/lib/bigloo/4.3h -rm -copt -w -lib-dir /builddir/build/BUILD/bigloo-4.3h/lib/bigloo/4.3h -O4 -mklib -unsafe -safee -cc gcc -fsharing -q -no-hello -p -srfi bigloo-profile -c Eval/evaluate.scm -o objs/obj_p/Eval/evaluate.o) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_ev_exprz00_bgl {
   header_t header;
   obj_t widening;
} *BgL_ev_exprz00_bglt;

typedef struct BgL_ev_varz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_effz00;
   obj_t BgL_typez00;
} *BgL_ev_varz00_bglt;

typedef struct BgL_ev_globalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   obj_t BgL_namez00;
   obj_t BgL_modz00;
} *BgL_ev_globalz00_bglt;

typedef struct BgL_ev_littz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_valuez00;
} *BgL_ev_littz00_bglt;

typedef struct BgL_ev_ifz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_pz00;
   struct BgL_ev_exprz00_bgl * BgL_tz00;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
} *BgL_ev_ifz00_bglt;

typedef struct BgL_ev_listz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_argsz00;
} *BgL_ev_listz00_bglt;

typedef struct BgL_ev_orz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_argsz00;
} *BgL_ev_orz00_bglt;

typedef struct BgL_ev_andz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_argsz00;
} *BgL_ev_andz00_bglt;

typedef struct BgL_ev_prog2z00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_e1z00;
   struct BgL_ev_exprz00_bgl * BgL_e2z00;
} *BgL_ev_prog2z00_bglt;

typedef struct BgL_ev_hookz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
} *BgL_ev_hookz00_bglt;

typedef struct BgL_ev_trapz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
} *BgL_ev_trapz00_bglt;

typedef struct BgL_ev_setlocalz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
   struct BgL_ev_varz00_bgl * BgL_vz00;
} *BgL_ev_setlocalz00_bglt;

typedef struct BgL_ev_setglobalz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
   obj_t BgL_locz00;
   obj_t BgL_namez00;
   obj_t BgL_modz00;
} *BgL_ev_setglobalz00_bglt;

typedef struct BgL_ev_defglobalz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
   obj_t BgL_locz00;
   obj_t BgL_namez00;
   obj_t BgL_modz00;
} *BgL_ev_defglobalz00_bglt;

typedef struct BgL_ev_bindzd2exitzd2_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_varz00_bgl * BgL_varz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_bindzd2exitzd2_bglt;

typedef struct BgL_ev_unwindzd2protectzd2_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_unwindzd2protectzd2_bglt;

typedef struct BgL_ev_withzd2handlerzd2_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_handlerz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_withzd2handlerzd2_bglt;

typedef struct BgL_ev_synchroniza7eza7_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_ev_exprz00_bgl * BgL_mutexz00;
   struct BgL_ev_exprz00_bgl * BgL_prelockz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_synchroniza7eza7_bglt;

typedef struct BgL_ev_binderz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_binderz00_bglt;

typedef struct BgL_ev_letz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
   obj_t BgL_boxesz00;
} *BgL_ev_letz00_bglt;

typedef struct BgL_ev_letza2za2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
   obj_t BgL_boxesz00;
} *BgL_ev_letza2za2_bglt;

typedef struct BgL_ev_letrecz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_letrecz00_bglt;

typedef struct BgL_ev_appz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_ev_exprz00_bgl * BgL_funz00;
   obj_t BgL_argsz00;
   obj_t BgL_tailzf3zf3;
} *BgL_ev_appz00_bglt;

typedef struct BgL_ev_absz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   obj_t BgL_wherez00;
   obj_t BgL_arityz00;
   obj_t BgL_varsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
   int BgL_siza7eza7;
   obj_t BgL_bindz00;
   obj_t BgL_freez00;
   obj_t BgL_innerz00;
   obj_t BgL_boxesz00;
} *BgL_ev_absz00_bglt;


extern obj_t BGl_compilez00zz__evaluate_compz00(BgL_ev_exprz00_bglt);
extern bool_t BGl_classzd2fieldzf3z21zz__objectz00(obj_t);
static BgL_ev_absz00_bglt BGl_convzd2lambdaze70z35zz__evaluatez00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern BgL_ev_exprz00_bglt BGl_extractzd2loopszd2zz__evaluate_fsiza7eza7(BgL_ev_exprz00_bglt);
BGL_EXPORTED_DECL obj_t BGl_setzd2evaluationzd2contextz12z12zz__evaluatez00(obj_t);
static obj_t BGl_getzd2locationzd2zz__evaluatez00(obj_t, obj_t);
extern obj_t BGl_ev_letrecz00zz__evaluate_typesz00;
extern obj_t BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(obj_t);
extern obj_t BGl_ev_letz00zz__evaluate_typesz00;
extern obj_t BGl_classzd2existszd2zz__objectz00(obj_t);
extern int BGl_framezd2siza7ez75zz__evaluate_fsiza7eza7(BgL_ev_exprz00_bglt);
static obj_t BGl_objectzd2initzd2zz__evaluatez00();
extern bool_t BGl_classzd2fieldzd2mutablezf3zf3zz__objectz00(obj_t);
static obj_t BGl_z62getzd2evaluationzd2contextz62zz__evaluatez00(obj_t);
extern obj_t bstring_to_symbol(obj_t);
extern bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
static obj_t BGl_convzd2fieldzd2setz00zz__evaluatez00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, bool_t);
extern obj_t make_vector(long, obj_t);
static obj_t BGl_z62evaluate2zd2restorezd2statez12z70zz__evaluatez00(obj_t, obj_t);
static obj_t BGl_appendzd221010zd2zz__evaluatez00(obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__evaluatez00();
static obj_t BGl_symbol2992z00zz__evaluatez00 = BUNSPEC;
extern obj_t BGl_ev_absz00zz__evaluate_typesz00;
extern obj_t BGl_classzd2fieldzd2accessorz00zz__objectz00(obj_t);
extern obj_t BGl_ev_ifz00zz__evaluate_typesz00;
extern obj_t BGl_analysezd2varszd2zz__evaluate_avarz00(BgL_ev_exprz00_bglt);
static obj_t BGl_z62zc3z04anonymousza31360ze3ze5zz__evaluatez00(obj_t);
static obj_t BGl_keyword3105z00zz__evaluatez00 = BUNSPEC;
extern obj_t BGl_evmodulez00zz__evmodulez00(obj_t, obj_t);
extern obj_t BGl_classzd2fieldzd2typez00zz__objectz00(obj_t);
static obj_t BGl_evepairifyz00zz__evaluatez00(obj_t, obj_t);
static obj_t BGl_z62setzd2evaluationzd2contextz12z70zz__evaluatez00(obj_t, obj_t);
extern bool_t BGl_classzf3zf3zz__objectz00(obj_t);
extern int bgl_debug();
static obj_t BGl_symbol3101z00zz__evaluatez00 = BUNSPEC;
extern obj_t BGl_ev_orz00zz__evaluate_typesz00;
static obj_t BGl_symbol3103z00zz__evaluatez00 = BUNSPEC;
extern obj_t BGl_ev_varz00zz__evaluate_typesz00;
extern obj_t BGl_makezd2dssslzd2functionzd2preludezd2zz__dssslz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_convertz00zz__evaluatez00(obj_t, obj_t, obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__evaluatez00();
extern obj_t BGl_ev_andz00zz__evaluate_typesz00;
extern obj_t BGl_ev_appz00zz__evaluate_typesz00;
extern obj_t BGl_dssslzd2formalszd2ze3schemezd2typedzd2formalsze3zz__dssslz00(obj_t, obj_t, bool_t);
extern obj_t c_substring(obj_t, long, long);
extern obj_t BGl_gensymz00zz__r4_symbols_6_4z00(obj_t);
extern obj_t BGl_evcompilezd2errorzd2zz__evcompilez00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_exitdzd2popzd2protectz12z12zz__bexitz00(obj_t);
extern obj_t BGl_ev_synchroniza7eza7zz__evaluate_typesz00;
static obj_t BGl_profzd2initzd2zz__evaluatez00();
static obj_t BGl_loopze70ze7zz__evaluatez00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_loopze71ze7zz__evaluatez00(obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_ev_appz00_bglt BGl_makezd2classzd2fieldzd2setzd2zz__evaluatez00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_ev_defglobalz00zz__evaluate_typesz00;
static obj_t BGl_convzd2beginzd2zz__evaluatez00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, bool_t);
static obj_t BGl_requirezd2initializa7ationz75zz__evaluatez00 = BUNSPEC;
extern obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_ev_globalz00_bglt BGl_convzd2globalzd2zz__evaluatez00(obj_t, obj_t, obj_t);
extern obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
extern obj_t BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(obj_t, obj_t);
extern obj_t bgl_reverse(obj_t);
static obj_t BGl_genericzd2initzd2zz__evaluatez00();
extern obj_t BGl_stringzd2copyzd2zz__r4_strings_6_7z00(obj_t);
extern obj_t BGl_ev_prog2z00zz__evaluate_typesz00;
extern obj_t BGl_ev_bindzd2exitzd2zz__evaluate_typesz00;
static obj_t BGl_convzd2fieldzd2refz00zz__evaluatez00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, bool_t);
extern obj_t bgl_reverse_bang(obj_t);
extern obj_t BGl_findzd2classzd2fieldz00zz__objectz00(obj_t, obj_t);
extern obj_t BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00;
extern obj_t BGl_classzd2fieldzd2mutatorz00zz__objectz00(obj_t);
extern obj_t BGl_ev_letza2za2zz__evaluate_typesz00;
static obj_t BGl_convzd2varzd2zz__evaluatez00(obj_t, obj_t);
static obj_t BGl_typezd2checkszd2zz__evaluatez00(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_ev_trapz00zz__evaluate_typesz00;
extern obj_t BGl_ev_setglobalz00zz__evaluate_typesz00;
extern obj_t string_append(obj_t, obj_t);
static obj_t BGl_getzd2location3zd2zz__evaluatez00(obj_t, obj_t, obj_t);
extern obj_t BGl_substringz00zz__r4_strings_6_7z00(obj_t, long, long);
extern obj_t BGl_findzd2statezd2zz__evaluate_compz00();
static obj_t BGl_untypezd2identzd2zz__evaluatez00(obj_t);
static obj_t BGl_symbol3000z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3002z00zz__evaluatez00 = BUNSPEC;
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__evaluatez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_compz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_uncompz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_fsiza7eza7(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_avarz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__evmodulez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__everrorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__evcompilez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__evenvz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__expandz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__prognz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ppz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__dssslz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__bignumz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__structurez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__tvectorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__typez00(long, char *);
static obj_t BGl_symbol3004z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3005z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3007z00zz__evaluatez00 = BUNSPEC;
extern obj_t BGl_expandz00zz__expandz00(obj_t);
static obj_t BGl_symbol3009z00zz__evaluatez00 = BUNSPEC;
extern obj_t BGl_ev_globalz00zz__evaluate_typesz00;
static obj_t BGl_symbol3011z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3013z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3015z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3017z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3018z00zz__evaluatez00 = BUNSPEC;
BGL_EXPORTED_DECL obj_t BGl_evaluate2zd2restorezd2statez12z12zz__evaluatez00(obj_t);
extern obj_t BGl_ev_littz00zz__evaluate_typesz00;
static obj_t BGl_symbol3020z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3022z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3024z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3026z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3028z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_typezd2checkzd2zz__evaluatez00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62evaluate2z62zz__evaluatez00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_cnstzd2initzd2zz__evaluatez00();
static obj_t BGl_symbol3030z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3032z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3034z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3036z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3038z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_importedzd2moduleszd2initz00zz__evaluatez00();
static obj_t BGl_symbol3040z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3042z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3044z00zz__evaluatez00 = BUNSPEC;
extern obj_t BGl_ev_withzd2handlerzd2zz__evaluate_typesz00;
static obj_t BGl_symbol3046z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3048z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3050z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3052z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3054z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3056z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3058z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_uconvzf2locze70z15zz__evaluatez00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_convzd2valsze70z35zz__evaluatez00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_symbol3060z00zz__evaluatez00 = BUNSPEC;
extern bool_t BGl_evmodulezf3zf3zz__evmodulez00(obj_t);
static obj_t BGl_symbol3062z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3064z00zz__evaluatez00 = BUNSPEC;
extern obj_t BGl_getzd2sourcezd2locationz00zz__readerz00(obj_t);
static obj_t BGl_symbol3066z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3069z00zz__evaluatez00 = BUNSPEC;
BGL_EXPORTED_DECL obj_t BGl_evaluate2z00zz__evaluatez00(obj_t, obj_t, obj_t);
static obj_t BGl_symbol3072z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_rconvzf2locze70z15zz__evaluatez00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_symbol3074z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3077z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3079z00zz__evaluatez00 = BUNSPEC;
extern obj_t BGl_evalzd2findzd2modulez00zz__evmodulez00(obj_t);
static obj_t BGl_typezd2resultzd2zz__evaluatez00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_evaluate2zd2restorezd2bpz12z12zz__evaluatez00(int);
static obj_t BGl_symbol3081z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3083z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3085z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3087z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3089z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3091z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3093z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3095z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3097z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3099z00zz__evaluatez00 = BUNSPEC;
extern obj_t bstring_to_keyword(obj_t);
BGL_EXPORTED_DECL obj_t BGl_getzd2evaluationzd2contextz00zz__evaluatez00();
static BgL_ev_appz00_bglt BGl_makezd2classzd2fieldzd2refzd2zz__evaluatez00(obj_t, BgL_ev_exprz00_bglt, obj_t, obj_t);
extern obj_t BGl_ev_setlocalz00zz__evaluate_typesz00;
static obj_t BGl_convz00zz__evaluatez00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, bool_t);
static obj_t BGl_uconvze70ze7zz__evaluatez00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62evaluate2zd2restorezd2bpz12z70zz__evaluatez00(obj_t, obj_t);
static obj_t *__cnst;


DEFINE_STRING( BGl_string3010z00zz__evaluatez00, BgL_bgl_string3010za700za7za7_3108za7, "symbol?", 7 );
DEFINE_STRING( BGl_string3012z00zz__evaluatez00, BgL_bgl_string3012za700za7za7_3109za7, "char", 4 );
DEFINE_STRING( BGl_string3014z00zz__evaluatez00, BgL_bgl_string3014za700za7za7_3110za7, "char?", 5 );
DEFINE_STRING( BGl_string3016z00zz__evaluatez00, BgL_bgl_string3016za700za7za7_3111za7, "int", 3 );
DEFINE_STRING( BGl_string3019z00zz__evaluatez00, BgL_bgl_string3019za700za7za7_3112za7, "integer?", 8 );
DEFINE_STRING( BGl_string3021z00zz__evaluatez00, BgL_bgl_string3021za700za7za7_3113za7, "real", 4 );
DEFINE_STRING( BGl_string3023z00zz__evaluatez00, BgL_bgl_string3023za700za7za7_3114za7, "breal", 5 );
DEFINE_STRING( BGl_string3025z00zz__evaluatez00, BgL_bgl_string3025za700za7za7_3115za7, "real?", 5 );
DEFINE_STRING( BGl_string3027z00zz__evaluatez00, BgL_bgl_string3027za700za7za7_3116za7, "bool", 4 );
DEFINE_STRING( BGl_string3029z00zz__evaluatez00, BgL_bgl_string3029za700za7za7_3117za7, "boolean?", 8 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_evaluate2zd2restorezd2bpz12zd2envzc0zz__evaluatez00, BgL_bgl_za762evaluate2za7d2r3118z00, BGl_z62evaluate2zd2restorezd2bpz12z70zz__evaluatez00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3031z00zz__evaluatez00, BgL_bgl_string3031za700za7za7_3119za7, "struct", 6 );
DEFINE_STRING( BGl_string3033z00zz__evaluatez00, BgL_bgl_string3033za700za7za7_3120za7, "struct?", 7 );
DEFINE_STRING( BGl_string3035z00zz__evaluatez00, BgL_bgl_string3035za700za7za7_3121za7, "class", 5 );
DEFINE_STRING( BGl_string3037z00zz__evaluatez00, BgL_bgl_string3037za700za7za7_3122za7, "class?", 6 );
DEFINE_STRING( BGl_string3039z00zz__evaluatez00, BgL_bgl_string3039za700za7za7_3123za7, "string", 6 );
DEFINE_STRING( BGl_string3041z00zz__evaluatez00, BgL_bgl_string3041za700za7za7_3124za7, "bstring", 7 );
DEFINE_STRING( BGl_string3043z00zz__evaluatez00, BgL_bgl_string3043za700za7za7_3125za7, "string?", 7 );
DEFINE_STRING( BGl_string3045z00zz__evaluatez00, BgL_bgl_string3045za700za7za7_3126za7, "o", 1 );
DEFINE_STRING( BGl_string3047z00zz__evaluatez00, BgL_bgl_string3047za700za7za7_3127za7, "quote", 5 );
DEFINE_STRING( BGl_string3049z00zz__evaluatez00, BgL_bgl_string3049za700za7za7_3128za7, "class-exists", 12 );
DEFINE_STRING( BGl_string3051z00zz__evaluatez00, BgL_bgl_string3051za700za7za7_3129za7, "c", 1 );
DEFINE_STRING( BGl_string3053z00zz__evaluatez00, BgL_bgl_string3053za700za7za7_3130za7, "isa?", 4 );
DEFINE_STRING( BGl_string3055z00zz__evaluatez00, BgL_bgl_string3055za700za7za7_3131za7, "if", 2 );
DEFINE_STRING( BGl_string3057z00zz__evaluatez00, BgL_bgl_string3057za700za7za7_3132za7, "let", 3 );
DEFINE_STRING( BGl_string3059z00zz__evaluatez00, BgL_bgl_string3059za700za7za7_3133za7, "lambda", 6 );
DEFINE_STRING( BGl_string3061z00zz__evaluatez00, BgL_bgl_string3061za700za7za7_3134za7, "bigloo-type-error/location", 26 );
DEFINE_STRING( BGl_string3063z00zz__evaluatez00, BgL_bgl_string3063za700za7za7_3135za7, "bigloo-type-error", 17 );
DEFINE_STRING( BGl_string3065z00zz__evaluatez00, BgL_bgl_string3065za700za7za7_3136za7, "at", 2 );
DEFINE_STRING( BGl_string3067z00zz__evaluatez00, BgL_bgl_string3067za700za7za7_3137za7, "tmp", 3 );
DEFINE_STRING( BGl_string3068z00zz__evaluatez00, BgL_bgl_string3068za700za7za7_3138za7, "~a::~a", 6 );
DEFINE_STRING( BGl_string3070z00zz__evaluatez00, BgL_bgl_string3070za700za7za7_3139za7, "\\@", 2 );
DEFINE_STRING( BGl_string3071z00zz__evaluatez00, BgL_bgl_string3071za700za7za7_3140za7, "Illegal form", 12 );
DEFINE_STRING( BGl_string3073z00zz__evaluatez00, BgL_bgl_string3073za700za7za7_3141za7, "begin", 5 );
DEFINE_STRING( BGl_string3075z00zz__evaluatez00, BgL_bgl_string3075za700za7za7_3142za7, " ", 1 );
DEFINE_STRING( BGl_string3076z00zz__evaluatez00, BgL_bgl_string3076za700za7za7_3143za7, "Illegal non toplevel module declaration", 39 );
DEFINE_STRING( BGl_string3078z00zz__evaluatez00, BgL_bgl_string3078za700za7za7_3144za7, "module", 6 );
DEFINE_STRING( BGl_string3080z00zz__evaluatez00, BgL_bgl_string3080za700za7za7_3145za7, "@", 1 );
DEFINE_STRING( BGl_string3082z00zz__evaluatez00, BgL_bgl_string3082za700za7za7_3146za7, "->", 2 );
DEFINE_STRING( BGl_string3084z00zz__evaluatez00, BgL_bgl_string3084za700za7za7_3147za7, "trap", 4 );
DEFINE_STRING( BGl_string3086z00zz__evaluatez00, BgL_bgl_string3086za700za7za7_3148za7, "or", 2 );
DEFINE_STRING( BGl_string3088z00zz__evaluatez00, BgL_bgl_string3088za700za7za7_3149za7, "and", 3 );
DEFINE_STRING( BGl_string3090z00zz__evaluatez00, BgL_bgl_string3090za700za7za7_3150za7, "let*", 4 );
DEFINE_STRING( BGl_string3092z00zz__evaluatez00, BgL_bgl_string3092za700za7za7_3151za7, "letrec", 6 );
DEFINE_STRING( BGl_string3094z00zz__evaluatez00, BgL_bgl_string3094za700za7za7_3152za7, "set!", 4 );
DEFINE_STRING( BGl_string3096z00zz__evaluatez00, BgL_bgl_string3096za700za7za7_3153za7, "define", 6 );
DEFINE_STRING( BGl_string3098z00zz__evaluatez00, BgL_bgl_string3098za700za7za7_3154za7, "bind-exit", 9 );
extern obj_t BGl_errorzd2envzd2zz__errorz00;
DEFINE_STRING( BGl_string2986z00zz__evaluatez00, BgL_bgl_string2986za700za7za7_3155za7, "", 0 );
DEFINE_STRING( BGl_string2987z00zz__evaluatez00, BgL_bgl_string2987za700za7za7_3156za7, "/builddir/build/BUILD/bigloo-4.3h/runtime/Eval/evaluate.scm", 59 );
DEFINE_STRING( BGl_string2988z00zz__evaluatez00, BgL_bgl_string2988za700za7za7_3157za7, "&evaluate2-restore-bp!", 22 );
DEFINE_STRING( BGl_string2989z00zz__evaluatez00, BgL_bgl_string2989za700za7za7_3158za7, "bint", 4 );
DEFINE_STRING( BGl_string2990z00zz__evaluatez00, BgL_bgl_string2990za700za7za7_3159za7, "&evaluate2-restore-state!", 25 );
DEFINE_STRING( BGl_string2991z00zz__evaluatez00, BgL_bgl_string2991za700za7za7_3160za7, "vector", 6 );
DEFINE_STRING( BGl_string2993z00zz__evaluatez00, BgL_bgl_string2993za700za7za7_3161za7, "toplevel", 8 );
DEFINE_STRING( BGl_string2994z00zz__evaluatez00, BgL_bgl_string2994za700za7za7_3162za7, "eval", 4 );
DEFINE_STRING( BGl_string2995z00zz__evaluatez00, BgL_bgl_string2995za700za7za7_3163za7, "Bad syntax", 10 );
DEFINE_STRING( BGl_string2996z00zz__evaluatez00, BgL_bgl_string2996za700za7za7_3164za7, "Class \"~a\" has no field \"~a\"", 28 );
DEFINE_STRING( BGl_string2997z00zz__evaluatez00, BgL_bgl_string2997za700za7za7_3165za7, "Static type not a class", 23 );
DEFINE_STRING( BGl_string2998z00zz__evaluatez00, BgL_bgl_string2998za700za7za7_3166za7, "Variable unbound", 16 );
DEFINE_STRING( BGl_string2999z00zz__evaluatez00, BgL_bgl_string2999za700za7za7_3167za7, "Field read-only", 15 );
DEFINE_STRING( BGl_string3100z00zz__evaluatez00, BgL_bgl_string3100za700za7za7_3168za7, "unwind-protect", 14 );
DEFINE_STRING( BGl_string3102z00zz__evaluatez00, BgL_bgl_string3102za700za7za7_3169za7, "with-handler", 12 );
DEFINE_STRING( BGl_string3104z00zz__evaluatez00, BgL_bgl_string3104za700za7za7_3170za7, "synchronize", 11 );
DEFINE_STRING( BGl_string3106z00zz__evaluatez00, BgL_bgl_string3106za700za7za7_3171za7, "prelock", 7 );
DEFINE_STRING( BGl_string3107z00zz__evaluatez00, BgL_bgl_string3107za700za7za7_3172za7, "__evaluate", 10 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_setzd2evaluationzd2contextz12zd2envzc0zz__evaluatez00, BgL_bgl_za762setza7d2evaluat3173z00, BGl_z62setzd2evaluationzd2contextz12z70zz__evaluatez00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_evaluate2zd2restorezd2statez12zd2envzc0zz__evaluatez00, BgL_bgl_za762evaluate2za7d2r3174z00, BGl_z62evaluate2zd2restorezd2statez12z70zz__evaluatez00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_getzd2evaluationzd2contextzd2envzd2zz__evaluatez00, BgL_bgl_za762getza7d2evaluat3175z00, BGl_z62getzd2evaluationzd2contextz62zz__evaluatez00, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_evaluate2zd2envzd2zz__evaluatez00, BgL_bgl_za762evaluate2za762za73176za7, BGl_z62evaluate2z62zz__evaluatez00, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string3001z00zz__evaluatez00, BgL_bgl_string3001za700za7za7_3177za7, "pair", 4 );
DEFINE_STRING( BGl_string3003z00zz__evaluatez00, BgL_bgl_string3003za700za7za7_3178za7, "pair?", 5 );
DEFINE_STRING( BGl_string3006z00zz__evaluatez00, BgL_bgl_string3006za700za7za7_3179za7, "vector?", 7 );
DEFINE_STRING( BGl_string3008z00zz__evaluatez00, BgL_bgl_string3008za700za7za7_3180za7, "symbol", 6 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_symbol2992z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_keyword3105z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3101z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3103z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3000z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3002z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3004z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3005z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3007z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3009z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3011z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3013z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3015z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3017z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3018z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3020z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3022z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3024z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3026z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3028z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3030z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3032z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3034z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3036z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3038z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3040z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3042z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3044z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3046z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3048z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3050z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3052z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3054z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3056z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3058z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3060z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3062z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3064z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3066z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3069z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3072z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3074z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3077z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3079z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3081z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3083z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3085z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3087z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3089z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3091z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3093z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3095z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3097z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3099z00zz__evaluatez00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* prof association table */
static obj_t write_bprof_table() {
   extern obj_t bprof_port;
   if( bprof_port == BUNSPEC ) bprof_port = (obj_t)fopen( "bmon.out", "w" );
   if( bprof_port ) {
      fputs( "(\"module-initialization\" \"BGl_modulezd2initializa7ationz75zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "(\"append-21010\" \"BGl_appendzd221010zd2zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"untype-ident\" \"Eval/evaluate.scm\" 2232) \"BGl_untypezd2identzd2zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"get-evaluation-context\" \"Eval/evaluate.scm\" 2931) \"BGl_getzd2evaluationzd2contextz00zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"&get-evaluation-context\" \"Eval/evaluate.scm\" 2931) \"BGl_z62getzd2evaluationzd2contextz62zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"set-evaluation-context!\" \"Eval/evaluate.scm\" 3411) \"BGl_setzd2evaluationzd2contextz12z12zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"&set-evaluation-context!\" \"Eval/evaluate.scm\" 3411) \"BGl_z62setzd2evaluationzd2contextz12z70zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"evaluate2-restore-bp!\" \"Eval/evaluate.scm\" 3852) \"BGl_evaluate2zd2restorezd2bpz12z12zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"&evaluate2-restore-bp!\" \"Eval/evaluate.scm\" 3852) \"BGl_z62evaluate2zd2restorezd2bpz12z70zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"evaluate2-restore-state!\" \"Eval/evaluate.scm\" 4196) \"BGl_evaluate2zd2restorezd2statez12z12zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"&evaluate2-restore-state!\" \"Eval/evaluate.scm\" 4196) \"BGl_z62evaluate2zd2restorezd2statez12z70zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"evaluate2\" \"Eval/evaluate.scm\" 4542) \"BGl_evaluate2z00zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"&evaluate2\" \"Eval/evaluate.scm\" 4542) \"BGl_z62evaluate2z62zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1360>\" \"Eval/evaluate.scm\" 4796) \"BGl_z62zc3z04anonymousza31360ze3ze5zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"get-location\" \"Eval/evaluate.scm\" 5084) \"BGl_getzd2locationzd2zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"get-location3\" \"Eval/evaluate.scm\" 5377) \"BGl_getzd2location3zd2zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"convert\" \"Eval/evaluate.scm\" 5715) \"BGl_convertz00zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"conv-var\" \"Eval/evaluate.scm\" 6016) \"BGl_convzd2varzd2zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"conv-begin\" \"Eval/evaluate.scm\" 6437) \"BGl_convzd2beginzd2zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"conv-global\" \"Eval/evaluate.scm\" 7149) \"BGl_convzd2globalzd2zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"conv-field-ref\" \"Eval/evaluate.scm\" 7530) \"BGl_convzd2fieldzd2refz00zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"conv-field-set\" \"Eval/evaluate.scm\" 8597) \"BGl_convzd2fieldzd2setz00zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"make-class-field-ref\" \"Eval/evaluate.scm\" 9944) \"BGl_makezd2classzd2fieldzd2refzd2zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"make-class-field-set\" \"Eval/evaluate.scm\" 10386) \"BGl_makezd2classzd2fieldzd2setzd2zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"evepairify\" \"Eval/evaluate.scm\" 10822) \"BGl_evepairifyz00zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"type-check\" \"Eval/evaluate.scm\" 11104) \"BGl_typezd2checkzd2zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"type-checks\" \"Eval/evaluate.scm\" 12230) \"BGl_typezd2checkszd2zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"loop~1\" \"Eval/evaluate.scm\" 12330) \"BGl_loopze71ze7zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"type-result\" \"Eval/evaluate.scm\" 12883) \"BGl_typezd2resultzd2zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"conv\" \"Eval/evaluate.scm\" 13355) \"BGl_convz00zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"loop~0\" \"Eval/evaluate.scm\" 13921) \"BGl_loopze70ze7zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"rconv/loc~0\" \"Eval/evaluate.scm\" 13488) \"BGl_rconvzf2locze70z15zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"uconv/loc~0\" \"Eval/evaluate.scm\" 13727) \"BGl_uconvzf2locze70z15zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"conv-vals~0\" \"Eval/evaluate.scm\" 17675) \"BGl_convzd2valsze70z35zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"conv-lambda~0\" \"Eval/evaluate.scm\" 14468) \"BGl_convzd2lambdaze70z35zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"uconv~0\" \"Eval/evaluate.scm\" 13794) \"BGl_uconvze70ze7zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "(\"CONS\" \"make_pair\")\n", (FILE *)bprof_port );
      fputs( "(\"%STRING->SYMBOL\" \"make_symbol\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-STRING\" \"string_to_bstring_len\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-OUTPUT-PORT\" \"bgl_make_output_port\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-INPUT-PORT\" \"bgl_make_input_port\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-ERROR-PORT\" \"make_error_port\")\n", (FILE *)bprof_port );
   }
   return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__evaluatez00(long BgL_checksumz00_4483, char * BgL_fromz00_4484)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__evaluatez00))
{ 
BGl_requirezd2initializa7ationz75zz__evaluatez00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__evaluatez00(); 
BGl_cnstzd2initzd2zz__evaluatez00(); 
BGl_importedzd2moduleszd2initz00zz__evaluatez00(); 
return 
BGl_profzd2initzd2zz__evaluatez00();}  else 
{ 
return BUNSPEC;} } 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__evaluatez00()
{
{ /* Eval/evaluate.scm 15 */
BGl_symbol2992z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string2993z00zz__evaluatez00); 
BGl_symbol3000z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3001z00zz__evaluatez00); 
BGl_symbol3002z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3003z00zz__evaluatez00); 
BGl_symbol3004z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string2991z00zz__evaluatez00); 
BGl_symbol3005z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3006z00zz__evaluatez00); 
BGl_symbol3007z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3008z00zz__evaluatez00); 
BGl_symbol3009z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3010z00zz__evaluatez00); 
BGl_symbol3011z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3012z00zz__evaluatez00); 
BGl_symbol3013z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3014z00zz__evaluatez00); 
BGl_symbol3015z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3016z00zz__evaluatez00); 
BGl_symbol3017z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string2989z00zz__evaluatez00); 
BGl_symbol3018z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3019z00zz__evaluatez00); 
BGl_symbol3020z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3021z00zz__evaluatez00); 
BGl_symbol3022z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3023z00zz__evaluatez00); 
BGl_symbol3024z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3025z00zz__evaluatez00); 
BGl_symbol3026z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3027z00zz__evaluatez00); 
BGl_symbol3028z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3029z00zz__evaluatez00); 
BGl_symbol3030z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3031z00zz__evaluatez00); 
BGl_symbol3032z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3033z00zz__evaluatez00); 
BGl_symbol3034z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3035z00zz__evaluatez00); 
BGl_symbol3036z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3037z00zz__evaluatez00); 
BGl_symbol3038z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3039z00zz__evaluatez00); 
BGl_symbol3040z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3041z00zz__evaluatez00); 
BGl_symbol3042z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3043z00zz__evaluatez00); 
BGl_symbol3044z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3045z00zz__evaluatez00); 
BGl_symbol3046z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3047z00zz__evaluatez00); 
BGl_symbol3048z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3049z00zz__evaluatez00); 
BGl_symbol3050z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3051z00zz__evaluatez00); 
BGl_symbol3052z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3053z00zz__evaluatez00); 
BGl_symbol3054z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3055z00zz__evaluatez00); 
BGl_symbol3056z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3057z00zz__evaluatez00); 
BGl_symbol3058z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3059z00zz__evaluatez00); 
BGl_symbol3060z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3061z00zz__evaluatez00); 
BGl_symbol3062z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3063z00zz__evaluatez00); 
BGl_symbol3064z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3065z00zz__evaluatez00); 
BGl_symbol3066z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3067z00zz__evaluatez00); 
BGl_symbol3069z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3070z00zz__evaluatez00); 
BGl_symbol3072z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3073z00zz__evaluatez00); 
BGl_symbol3074z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3075z00zz__evaluatez00); 
BGl_symbol3077z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3078z00zz__evaluatez00); 
BGl_symbol3079z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3080z00zz__evaluatez00); 
BGl_symbol3081z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3082z00zz__evaluatez00); 
BGl_symbol3083z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3084z00zz__evaluatez00); 
BGl_symbol3085z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3086z00zz__evaluatez00); 
BGl_symbol3087z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3088z00zz__evaluatez00); 
BGl_symbol3089z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3090z00zz__evaluatez00); 
BGl_symbol3091z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3092z00zz__evaluatez00); 
BGl_symbol3093z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3094z00zz__evaluatez00); 
BGl_symbol3095z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3096z00zz__evaluatez00); 
BGl_symbol3097z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3098z00zz__evaluatez00); 
BGl_symbol3099z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3100z00zz__evaluatez00); 
BGl_symbol3101z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3102z00zz__evaluatez00); 
BGl_symbol3103z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3104z00zz__evaluatez00); 
return ( 
BGl_keyword3105z00zz__evaluatez00 = 
bstring_to_keyword(BGl_string3106z00zz__evaluatez00), BUNSPEC) ;} 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__evaluatez00()
{
{ /* Eval/evaluate.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* prof-init */
obj_t BGl_profzd2initzd2zz__evaluatez00()
{
{ /* Eval/evaluate.scm 15 */
return 
write_bprof_table();} 

}



/* append-21010 */
obj_t BGl_appendzd221010zd2zz__evaluatez00(obj_t BgL_l1z00_1, obj_t BgL_l2z00_2)
{
{ 
{ 
obj_t BgL_headz00_1137;
BgL_headz00_1137 = 
MAKE_YOUNG_PAIR(BNIL, BgL_l2z00_2); 
{ 
obj_t BgL_prevz00_1138;obj_t BgL_tailz00_1139;
BgL_prevz00_1138 = BgL_headz00_1137; 
BgL_tailz00_1139 = BgL_l1z00_1; 
BgL_loopz00_1140:
if(
PAIRP(BgL_tailz00_1139))
{ 
obj_t BgL_newzd2prevzd2_1142;
BgL_newzd2prevzd2_1142 = 
MAKE_YOUNG_PAIR(
CAR(BgL_tailz00_1139), BgL_l2z00_2); 
SET_CDR(BgL_prevz00_1138, BgL_newzd2prevzd2_1142); 
{ 
obj_t BgL_tailz00_4555;obj_t BgL_prevz00_4554;
BgL_prevz00_4554 = BgL_newzd2prevzd2_1142; 
BgL_tailz00_4555 = 
CDR(BgL_tailz00_1139); 
BgL_tailz00_1139 = BgL_tailz00_4555; 
BgL_prevz00_1138 = BgL_prevz00_4554; 
goto BgL_loopz00_1140;} }  else 
{ BNIL; } 
return 
CDR(BgL_headz00_1137);} } } 

}



/* untype-ident */
obj_t BGl_untypezd2identzd2zz__evaluatez00(obj_t BgL_idz00_3)
{
{ /* Eval/evaluate.scm 73 */
{ /* Eval/evaluate.scm 74 */
obj_t BgL_stringz00_1145;
{ /* Eval/evaluate.scm 74 */
obj_t BgL_res2650z00_3119;
{ /* Eval/evaluate.scm 74 */
obj_t BgL_arg2496z00_3118;
BgL_arg2496z00_3118 = 
SYMBOL_TO_STRING(BgL_idz00_3); 
BgL_res2650z00_3119 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg2496z00_3118); } 
BgL_stringz00_1145 = BgL_res2650z00_3119; } 
{ /* Eval/evaluate.scm 74 */
long BgL_lenz00_1146;
BgL_lenz00_1146 = 
STRING_LENGTH(BgL_stringz00_1145); 
{ /* Eval/evaluate.scm 75 */

{ 
long BgL_walkerz00_1148;
BgL_walkerz00_1148 = ((long)0); 
BgL_zc3z04anonymousza31326ze3z87_1149:
if(
(BgL_walkerz00_1148==BgL_lenz00_1146))
{ /* Eval/evaluate.scm 78 */
return 
MAKE_YOUNG_PAIR(BgL_idz00_3, BFALSE);}  else 
{ /* Eval/evaluate.scm 80 */
bool_t BgL_test3184z00_4564;
if(
(
STRING_REF(BgL_stringz00_1145, BgL_walkerz00_1148)==((unsigned char)':')))
{ /* Eval/evaluate.scm 80 */
if(
(BgL_walkerz00_1148<
(BgL_lenz00_1146-((long)1))))
{ /* Eval/evaluate.scm 81 */
BgL_test3184z00_4564 = 
(
STRING_REF(BgL_stringz00_1145, 
(BgL_walkerz00_1148+((long)1)))==((unsigned char)':'))
; }  else 
{ /* Eval/evaluate.scm 81 */
BgL_test3184z00_4564 = ((bool_t)0)
; } }  else 
{ /* Eval/evaluate.scm 80 */
BgL_test3184z00_4564 = ((bool_t)0)
; } 
if(BgL_test3184z00_4564)
{ /* Eval/evaluate.scm 83 */
obj_t BgL_arg1339z00_1160;obj_t BgL_arg1340z00_1161;
BgL_arg1339z00_1160 = 
bstring_to_symbol(
c_substring(BgL_stringz00_1145, ((long)0), BgL_walkerz00_1148)); 
{ /* Eval/evaluate.scm 84 */
obj_t BgL_arg1342z00_1163;
{ /* Eval/evaluate.scm 84 */
long BgL_arg1343z00_1164;
BgL_arg1343z00_1164 = 
(BgL_walkerz00_1148+((long)2)); 
{ /* Ieee/string.scm 189 */
long BgL_endz00_1167;
BgL_endz00_1167 = 
STRING_LENGTH(BgL_stringz00_1145); 
{ /* Ieee/string.scm 189 */

BgL_arg1342z00_1163 = 
BGl_substringz00zz__r4_strings_6_7z00(BgL_stringz00_1145, BgL_arg1343z00_1164, BgL_endz00_1167); } } } 
BgL_arg1340z00_1161 = 
bstring_to_symbol(BgL_arg1342z00_1163); } 
return 
MAKE_YOUNG_PAIR(BgL_arg1339z00_1160, BgL_arg1340z00_1161);}  else 
{ 
long BgL_walkerz00_4581;
BgL_walkerz00_4581 = 
(BgL_walkerz00_1148+((long)1)); 
BgL_walkerz00_1148 = BgL_walkerz00_4581; 
goto BgL_zc3z04anonymousza31326ze3z87_1149;} } } } } } } 

}



/* get-evaluation-context */
BGL_EXPORTED_DEF obj_t BGl_getzd2evaluationzd2contextz00zz__evaluatez00()
{
{ /* Eval/evaluate.scm 91 */
{ /* Eval/evaluate.scm 92 */
obj_t BgL_sz00_1176;
BgL_sz00_1176 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate.scm 93 */
obj_t BgL_bpz00_1177;
BgL_bpz00_1177 = 
VECTOR_REF(
((obj_t)BgL_sz00_1176),((long)0)); 
{ /* Eval/evaluate.scm 94 */
obj_t BgL_rz00_1178;
BgL_rz00_1178 = 
make_vector(
(long)CINT(BgL_bpz00_1177), BGl_string2986z00zz__evaluatez00); 
{ 
long BgL_iz00_1180;
BgL_iz00_1180 = ((long)0); 
BgL_zc3z04anonymousza31350ze3z87_1181:
if(
(BgL_iz00_1180<
(long)CINT(BgL_bpz00_1177)))
{ /* Eval/evaluate.scm 96 */
{ /* Eval/evaluate.scm 97 */
obj_t BgL_arg1352z00_1183;
BgL_arg1352z00_1183 = 
VECTOR_REF(
((obj_t)BgL_sz00_1176),BgL_iz00_1180); 
VECTOR_SET(BgL_rz00_1178,BgL_iz00_1180,BgL_arg1352z00_1183); } 
{ 
long BgL_iz00_4594;
BgL_iz00_4594 = 
(BgL_iz00_1180+((long)1)); 
BgL_iz00_1180 = BgL_iz00_4594; 
goto BgL_zc3z04anonymousza31350ze3z87_1181;} }  else 
{ /* Eval/evaluate.scm 96 */((bool_t)0); } } 
return BgL_rz00_1178;} } } } 

}



/* &get-evaluation-context */
obj_t BGl_z62getzd2evaluationzd2contextz62zz__evaluatez00(obj_t BgL_envz00_4432)
{
{ /* Eval/evaluate.scm 91 */
return 
BGl_getzd2evaluationzd2contextz00zz__evaluatez00();} 

}



/* set-evaluation-context! */
BGL_EXPORTED_DEF obj_t BGl_setzd2evaluationzd2contextz12z12zz__evaluatez00(obj_t BgL_vz00_4)
{
{ /* Eval/evaluate.scm 104 */
{ /* Eval/evaluate.scm 105 */
obj_t BgL_sz00_1186;
BgL_sz00_1186 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate.scm 106 */
obj_t BgL_bpz00_1187;
BgL_bpz00_1187 = 
VECTOR_REF(
((obj_t)BgL_vz00_4),((long)0)); 
{ 
long BgL_iz00_1189;
{ /* Eval/evaluate.scm 107 */
bool_t BgL_tmpz00_4600;
BgL_iz00_1189 = ((long)0); 
BgL_zc3z04anonymousza31354ze3z87_1190:
if(
(BgL_iz00_1189<
(long)CINT(BgL_bpz00_1187)))
{ /* Eval/evaluate.scm 108 */
{ /* Eval/evaluate.scm 109 */
obj_t BgL_arg1357z00_1192;
BgL_arg1357z00_1192 = 
VECTOR_REF(
((obj_t)BgL_vz00_4),BgL_iz00_1189); 
VECTOR_SET(
((obj_t)BgL_sz00_1186),BgL_iz00_1189,BgL_arg1357z00_1192); } 
{ 
long BgL_iz00_4608;
BgL_iz00_4608 = 
(BgL_iz00_1189+((long)1)); 
BgL_iz00_1189 = BgL_iz00_4608; 
goto BgL_zc3z04anonymousza31354ze3z87_1190;} }  else 
{ /* Eval/evaluate.scm 108 */
BgL_tmpz00_4600 = ((bool_t)0)
; } 
return 
BBOOL(BgL_tmpz00_4600);} } } } } 

}



/* &set-evaluation-context! */
obj_t BGl_z62setzd2evaluationzd2contextz12z70zz__evaluatez00(obj_t BgL_envz00_4433, obj_t BgL_vz00_4434)
{
{ /* Eval/evaluate.scm 104 */
return 
BGl_setzd2evaluationzd2contextz12z12zz__evaluatez00(BgL_vz00_4434);} 

}



/* evaluate2-restore-bp! */
BGL_EXPORTED_DEF obj_t BGl_evaluate2zd2restorezd2bpz12z12zz__evaluatez00(int BgL_bpz00_5)
{
{ /* Eval/evaluate.scm 115 */
{ /* Eval/evaluate.scm 116 */
obj_t BgL_sz00_1195;
{ /* Eval/evaluate.scm 116 */
obj_t BgL_tmpz00_4612;
BgL_tmpz00_4612 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_sz00_1195 = 
BGL_ENV_EVSTATE(BgL_tmpz00_4612); } 
return 
VECTOR_SET(
((obj_t)BgL_sz00_1195),((long)0),
BINT(BgL_bpz00_5));} } 

}



/* &evaluate2-restore-bp! */
obj_t BGl_z62evaluate2zd2restorezd2bpz12z70zz__evaluatez00(obj_t BgL_envz00_4435, obj_t BgL_bpz00_4436)
{
{ /* Eval/evaluate.scm 115 */
{ /* Eval/evaluate.scm 116 */
int BgL_auxz00_4618;
{ /* Eval/evaluate.scm 116 */
obj_t BgL_tmpz00_4619;
if(
INTEGERP(BgL_bpz00_4436))
{ /* Eval/evaluate.scm 116 */
BgL_tmpz00_4619 = BgL_bpz00_4436
; }  else 
{ 
obj_t BgL_auxz00_4622;
BgL_auxz00_4622 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2987z00zz__evaluatez00, 
BINT(((long)3890)), BGl_string2988z00zz__evaluatez00, BGl_string2989z00zz__evaluatez00, BgL_bpz00_4436); 
FAILURE(BgL_auxz00_4622,BFALSE,BFALSE);} 
BgL_auxz00_4618 = 
CINT(BgL_tmpz00_4619); } 
return 
BGl_evaluate2zd2restorezd2bpz12z12zz__evaluatez00(BgL_auxz00_4618);} } 

}



/* evaluate2-restore-state! */
BGL_EXPORTED_DEF obj_t BGl_evaluate2zd2restorezd2statez12z12zz__evaluatez00(obj_t BgL_statez00_6)
{
{ /* Eval/evaluate.scm 122 */
{ /* Eval/evaluate.scm 124 */
obj_t BgL_tmpz00_4628;
BgL_tmpz00_4628 = 
BGL_CURRENT_DYNAMIC_ENV(); 
return 
BGL_ENV_EVSTATE_SET(BgL_tmpz00_4628, BgL_statez00_6);} } 

}



/* &evaluate2-restore-state! */
obj_t BGl_z62evaluate2zd2restorezd2statez12z70zz__evaluatez00(obj_t BgL_envz00_4437, obj_t BgL_statez00_4438)
{
{ /* Eval/evaluate.scm 122 */
{ /* Eval/evaluate.scm 123 */
obj_t BgL_auxz00_4631;
if(
VECTORP(BgL_statez00_4438))
{ /* Eval/evaluate.scm 123 */
BgL_auxz00_4631 = BgL_statez00_4438
; }  else 
{ 
obj_t BgL_auxz00_4634;
BgL_auxz00_4634 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2987z00zz__evaluatez00, 
BINT(((long)4240)), BGl_string2990z00zz__evaluatez00, BGl_string2991z00zz__evaluatez00, BgL_statez00_4438); 
FAILURE(BgL_auxz00_4634,BFALSE,BFALSE);} 
return 
BGl_evaluate2zd2restorezd2statez12z12zz__evaluatez00(BgL_auxz00_4631);} } 

}



/* evaluate2 */
BGL_EXPORTED_DEF obj_t BGl_evaluate2z00zz__evaluatez00(obj_t BgL_sexpz00_7, obj_t BgL_envz00_8, obj_t BgL_locz00_9)
{
{ /* Eval/evaluate.scm 129 */
{ /* Eval/evaluate.scm 130 */
BgL_ev_exprz00_bglt BgL_astz00_1198;
{ /* Eval/evaluate.scm 130 */
obj_t BgL_arg1361z00_1208;
BgL_arg1361z00_1208 = 
BGl_convertz00zz__evaluatez00(BgL_sexpz00_7, BgL_envz00_8, BgL_locz00_9); 
BgL_astz00_1198 = 
BGl_extractzd2loopszd2zz__evaluate_fsiza7eza7(
((BgL_ev_exprz00_bglt)BgL_arg1361z00_1208)); } 
BGl_analysezd2varszd2zz__evaluate_avarz00(BgL_astz00_1198); 
{ /* Eval/evaluate.scm 132 */
int BgL_nz00_1199;
BgL_nz00_1199 = 
BGl_framezd2siza7ez75zz__evaluate_fsiza7eza7(BgL_astz00_1198); 
{ /* Eval/evaluate.scm 133 */
obj_t BgL_fz00_1200;
BgL_fz00_1200 = 
BGl_compilez00zz__evaluate_compz00(BgL_astz00_1198); 
{ /* Eval/evaluate.scm 134 */
obj_t BgL_sz00_1201;
BgL_sz00_1201 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate.scm 135 */
obj_t BgL_bpz00_1202;
BgL_bpz00_1202 = 
VECTOR_REF(
((obj_t)BgL_sz00_1201),((long)0)); 
{ /* Eval/evaluate.scm 136 */
obj_t BgL_exitd1064z00_1203;
BgL_exitd1064z00_1203 = 
BGL_EXITD_TOP_AS_OBJ(); 
{ /* Eval/evaluate.scm 138 */
obj_t BgL_zc3z04anonymousza31360ze3z87_4439;
BgL_zc3z04anonymousza31360ze3z87_4439 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31360ze3ze5zz__evaluatez00, 
(int)(((long)0)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31360ze3z87_4439, 
(int)(((long)0)), BgL_sz00_1201); 
PROCEDURE_SET(BgL_zc3z04anonymousza31360ze3z87_4439, 
(int)(((long)1)), BgL_bpz00_1202); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1064z00_1203, BgL_zc3z04anonymousza31360ze3z87_4439); 
{ /* Eval/evaluate.scm 137 */
obj_t BgL_tmp1066z00_1205;
BgL_tmp1066z00_1205 = 
PROCEDURE_ENTRY(BgL_fz00_1200)(BgL_fz00_1200, BgL_sz00_1201, BEOA); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1064z00_1203); 
BGl_z62zc3z04anonymousza31360ze3ze5zz__evaluatez00(BgL_zc3z04anonymousza31360ze3z87_4439); 
return BgL_tmp1066z00_1205;} } } } } } } } } 

}



/* &evaluate2 */
obj_t BGl_z62evaluate2z62zz__evaluatez00(obj_t BgL_envz00_4440, obj_t BgL_sexpz00_4441, obj_t BgL_envz00_4442, obj_t BgL_locz00_4443)
{
{ /* Eval/evaluate.scm 129 */
return 
BGl_evaluate2z00zz__evaluatez00(BgL_sexpz00_4441, BgL_envz00_4442, BgL_locz00_4443);} 

}



/* &<@anonymous:1360> */
obj_t BGl_z62zc3z04anonymousza31360ze3ze5zz__evaluatez00(obj_t BgL_envz00_4444)
{
{ /* Eval/evaluate.scm 136 */
{ /* Eval/evaluate.scm 138 */
obj_t BgL_sz00_4445;obj_t BgL_bpz00_4446;
BgL_sz00_4445 = 
PROCEDURE_REF(BgL_envz00_4444, 
(int)(((long)0))); 
BgL_bpz00_4446 = 
PROCEDURE_REF(BgL_envz00_4444, 
(int)(((long)1))); 
return 
VECTOR_SET(
((obj_t)BgL_sz00_4445),((long)0),BgL_bpz00_4446);} } 

}



/* get-location */
obj_t BGl_getzd2locationzd2zz__evaluatez00(obj_t BgL_expz00_10, obj_t BgL_locz00_11)
{
{ /* Eval/evaluate.scm 143 */
{ /* Eval/evaluate.scm 144 */
obj_t BgL__ortest_1067z00_1209;
BgL__ortest_1067z00_1209 = 
BGl_getzd2sourcezd2locationz00zz__readerz00(BgL_expz00_10); 
if(
CBOOL(BgL__ortest_1067z00_1209))
{ /* Eval/evaluate.scm 144 */
return BgL__ortest_1067z00_1209;}  else 
{ /* Eval/evaluate.scm 144 */
return BgL_locz00_11;} } } 

}



/* get-location3 */
obj_t BGl_getzd2location3zd2zz__evaluatez00(obj_t BgL_expz00_12, obj_t BgL_lstz00_13, obj_t BgL_locz00_14)
{
{ /* Eval/evaluate.scm 149 */
{ /* Eval/evaluate.scm 150 */
obj_t BgL__ortest_1068z00_1210;
BgL__ortest_1068z00_1210 = 
BGl_getzd2sourcezd2locationz00zz__readerz00(BgL_expz00_12); 
if(
CBOOL(BgL__ortest_1068z00_1210))
{ /* Eval/evaluate.scm 150 */
return BgL__ortest_1068z00_1210;}  else 
{ /* Eval/evaluate.scm 151 */
obj_t BgL__ortest_1069z00_1211;
BgL__ortest_1069z00_1211 = 
BGl_getzd2sourcezd2locationz00zz__readerz00(BgL_lstz00_13); 
if(
CBOOL(BgL__ortest_1069z00_1211))
{ /* Eval/evaluate.scm 151 */
return BgL__ortest_1069z00_1211;}  else 
{ /* Eval/evaluate.scm 151 */
return BgL_locz00_14;} } } } 

}



/* convert */
obj_t BGl_convertz00zz__evaluatez00(obj_t BgL_ez00_15, obj_t BgL_globalsz00_16, obj_t BgL_locz00_17)
{
{ /* Eval/evaluate.scm 157 */
return 
BGl_convz00zz__evaluatez00(BgL_ez00_15, BNIL, BgL_globalsz00_16, BFALSE, BGl_symbol2992z00zz__evaluatez00, BgL_locz00_17, ((bool_t)1));} 

}



/* conv-var */
obj_t BGl_convzd2varzd2zz__evaluatez00(obj_t BgL_vz00_18, obj_t BgL_localsz00_19)
{
{ /* Eval/evaluate.scm 163 */
{ 
obj_t BgL_lz00_1213;
BgL_lz00_1213 = BgL_localsz00_19; 
BgL_zc3z04anonymousza31362ze3z87_1214:
if(
NULLP(BgL_lz00_1213))
{ /* Eval/evaluate.scm 165 */
return BFALSE;}  else 
{ /* Eval/evaluate.scm 167 */
obj_t BgL_rvz00_1216;
BgL_rvz00_1216 = 
CAR(
((obj_t)BgL_lz00_1213)); 
if(
(BgL_vz00_18==
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_rvz00_1216)))->BgL_namez00)))
{ /* Eval/evaluate.scm 169 */
return BgL_rvz00_1216;}  else 
{ 
obj_t BgL_lz00_4688;
BgL_lz00_4688 = 
CDR(
((obj_t)BgL_lz00_1213)); 
BgL_lz00_1213 = BgL_lz00_4688; 
goto BgL_zc3z04anonymousza31362ze3z87_1214;} } } } 

}



/* conv-begin */
obj_t BGl_convzd2beginzd2zz__evaluatez00(obj_t BgL_lz00_20, obj_t BgL_localsz00_21, obj_t BgL_globalsz00_22, obj_t BgL_tailzf3zf3_23, obj_t BgL_wherez00_24, obj_t BgL_locz00_25, bool_t BgL_topzf3zf3_26)
{
{ /* Eval/evaluate.scm 176 */
{ /* Eval/evaluate.scm 177 */
obj_t BgL_locz00_1223;
BgL_locz00_1223 = 
BGl_getzd2locationzd2zz__evaluatez00(BgL_lz00_20, BgL_locz00_25); 
{ 
obj_t BgL_e1z00_1227;obj_t BgL_rz00_1228;obj_t BgL_ez00_1225;
if(
NULLP(BgL_lz00_20))
{ 
BgL_ev_littz00_bglt BgL_auxz00_4694;
{ /* Eval/evaluate.scm 180 */
BgL_ev_littz00_bglt BgL_new1072z00_1240;
{ /* Eval/evaluate.scm 181 */
BgL_ev_littz00_bglt BgL_new1071z00_1241;
BgL_new1071z00_1241 = 
((BgL_ev_littz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_littz00_bgl) ))); 
{ /* Eval/evaluate.scm 181 */
long BgL_arg1377z00_1242;
{ /* Eval/evaluate.scm 181 */
long BgL_res2673z00_3186;
BgL_res2673z00_3186 = 
BGL_CLASS_INDEX(BGl_ev_littz00zz__evaluate_typesz00); 
BgL_arg1377z00_1242 = BgL_res2673z00_3186; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1071z00_1241), BgL_arg1377z00_1242); } 
BgL_new1072z00_1240 = BgL_new1071z00_1241; } 
((((BgL_ev_littz00_bglt)COBJECT(BgL_new1072z00_1240))->BgL_valuez00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_4694 = BgL_new1072z00_1240; } 
return 
((obj_t)BgL_auxz00_4694);}  else 
{ /* Eval/evaluate.scm 178 */
if(
PAIRP(BgL_lz00_20))
{ /* Eval/evaluate.scm 178 */
if(
NULLP(
CDR(BgL_lz00_20)))
{ /* Eval/evaluate.scm 178 */
BgL_ez00_1225 = 
CAR(BgL_lz00_20); 
return 
BGl_convz00zz__evaluatez00(BgL_ez00_1225, BgL_localsz00_21, BgL_globalsz00_22, BgL_tailzf3zf3_23, BgL_wherez00_24, 
BGl_getzd2locationzd2zz__evaluatez00(BgL_ez00_1225, BgL_locz00_1223), BgL_topzf3zf3_26);}  else 
{ /* Eval/evaluate.scm 178 */
obj_t BgL_arg1374z00_1237;obj_t BgL_arg1375z00_1238;
BgL_arg1374z00_1237 = 
CAR(BgL_lz00_20); 
BgL_arg1375z00_1238 = 
CDR(BgL_lz00_20); 
{ 
BgL_ev_prog2z00_bglt BgL_auxz00_4711;
BgL_e1z00_1227 = BgL_arg1374z00_1237; 
BgL_rz00_1228 = BgL_arg1375z00_1238; 
{ /* Eval/evaluate.scm 185 */
BgL_ev_prog2z00_bglt BgL_new1074z00_1244;
{ /* Eval/evaluate.scm 186 */
BgL_ev_prog2z00_bglt BgL_new1073z00_1246;
BgL_new1073z00_1246 = 
((BgL_ev_prog2z00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_prog2z00_bgl) ))); 
{ /* Eval/evaluate.scm 186 */
long BgL_arg1380z00_1247;
{ /* Eval/evaluate.scm 186 */
long BgL_res2674z00_3190;
BgL_res2674z00_3190 = 
BGL_CLASS_INDEX(BGl_ev_prog2z00zz__evaluate_typesz00); 
BgL_arg1380z00_1247 = BgL_res2674z00_3190; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1073z00_1246), BgL_arg1380z00_1247); } 
BgL_new1074z00_1244 = BgL_new1073z00_1246; } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_4716;
{ /* Eval/evaluate.scm 186 */
obj_t BgL_arg1379z00_1245;
BgL_arg1379z00_1245 = 
BGl_getzd2locationzd2zz__evaluatez00(BgL_e1z00_1227, BgL_locz00_1223); 
BgL_auxz00_4716 = 
((BgL_ev_exprz00_bglt)
BGl_convz00zz__evaluatez00(BgL_e1z00_1227, BgL_localsz00_21, BgL_globalsz00_22, BFALSE, BgL_wherez00_24, BgL_arg1379z00_1245, BgL_topzf3zf3_26)); } 
((((BgL_ev_prog2z00_bglt)COBJECT(BgL_new1074z00_1244))->BgL_e1z00)=((BgL_ev_exprz00_bglt)BgL_auxz00_4716),BUNSPEC); } 
((((BgL_ev_prog2z00_bglt)COBJECT(BgL_new1074z00_1244))->BgL_e2z00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)
BGl_convzd2beginzd2zz__evaluatez00(BgL_rz00_1228, BgL_localsz00_21, BgL_globalsz00_22, BgL_tailzf3zf3_23, BgL_wherez00_24, BgL_locz00_1223, BgL_topzf3zf3_26))),BUNSPEC); 
BgL_auxz00_4711 = BgL_new1074z00_1244; } 
return 
((obj_t)BgL_auxz00_4711);} } }  else 
{ /* Eval/evaluate.scm 178 */
return 
BGl_evcompilezd2errorzd2zz__evcompilez00(BgL_locz00_1223, BGl_string2994z00zz__evaluatez00, BGl_string2995z00zz__evaluatez00, BgL_lz00_20);} } } } } 

}



/* conv-global */
BgL_ev_globalz00_bglt BGl_convzd2globalzd2zz__evaluatez00(obj_t BgL_locz00_27, obj_t BgL_idz00_28, obj_t BgL_globalsz00_29)
{
{ /* Eval/evaluate.scm 194 */
{ /* Eval/evaluate.scm 195 */
BgL_ev_globalz00_bglt BgL_new1076z00_1248;
{ /* Eval/evaluate.scm 196 */
BgL_ev_globalz00_bglt BgL_new1075z00_1250;
BgL_new1075z00_1250 = 
((BgL_ev_globalz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_globalz00_bgl) ))); 
{ /* Eval/evaluate.scm 196 */
long BgL_arg1382z00_1251;
{ /* Eval/evaluate.scm 196 */
long BgL_res2678z00_3201;
BgL_res2678z00_3201 = 
BGL_CLASS_INDEX(BGl_ev_globalz00zz__evaluate_typesz00); 
BgL_arg1382z00_1251 = BgL_res2678z00_3201; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1075z00_1250), BgL_arg1382z00_1251); } 
BgL_new1076z00_1248 = BgL_new1075z00_1250; } 
((((BgL_ev_globalz00_bglt)COBJECT(BgL_new1076z00_1248))->BgL_locz00)=((obj_t)BgL_locz00_27),BUNSPEC); 
((((BgL_ev_globalz00_bglt)COBJECT(BgL_new1076z00_1248))->BgL_namez00)=((obj_t)BgL_idz00_28),BUNSPEC); 
{ 
obj_t BgL_auxz00_4732;
if(
BGl_evmodulezf3zf3zz__evmodulez00(BgL_globalsz00_29))
{ /* Eval/evaluate.scm 198 */
BgL_auxz00_4732 = BgL_globalsz00_29
; }  else 
{ /* Eval/evaluate.scm 198 */
BgL_auxz00_4732 = 
BGL_MODULE()
; } 
((((BgL_ev_globalz00_bglt)COBJECT(BgL_new1076z00_1248))->BgL_modz00)=((obj_t)BgL_auxz00_4732),BUNSPEC); } 
return BgL_new1076z00_1248;} } 

}



/* conv-field-ref */
obj_t BGl_convzd2fieldzd2refz00zz__evaluatez00(obj_t BgL_ez00_30, obj_t BgL_localsz00_31, obj_t BgL_globalsz00_32, obj_t BgL_tailzf3zf3_33, obj_t BgL_wherez00_34, obj_t BgL_locz00_35, bool_t BgL_topzf3zf3_36)
{
{ /* Eval/evaluate.scm 203 */
{ /* Eval/evaluate.scm 204 */
obj_t BgL_lz00_1252;
BgL_lz00_1252 = 
CDR(
((obj_t)BgL_ez00_30)); 
{ /* Eval/evaluate.scm 204 */
obj_t BgL_vz00_1253;
BgL_vz00_1253 = 
BGl_convzd2varzd2zz__evaluatez00(
CAR(
((obj_t)BgL_lz00_1252)), BgL_localsz00_31); 
{ /* Eval/evaluate.scm 205 */

if(
BGl_isazf3zf3zz__objectz00(BgL_vz00_1253, BGl_ev_varz00zz__evaluate_typesz00))
{ /* Eval/evaluate.scm 208 */
obj_t BgL_g1078z00_1256;obj_t BgL_g1079z00_1257;
{ /* Eval/evaluate.scm 209 */
obj_t BgL_arg1399z00_1280;
BgL_arg1399z00_1280 = 
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_vz00_1253)))->BgL_typez00); 
BgL_g1078z00_1256 = 
BGl_classzd2existszd2zz__objectz00(BgL_arg1399z00_1280); } 
BgL_g1079z00_1257 = 
CDR(
((obj_t)BgL_lz00_1252)); 
{ 
BgL_ev_exprz00_bglt BgL_nodez00_1259;obj_t BgL_klassz00_1260;obj_t BgL_fieldsz00_1261;
BgL_nodez00_1259 = 
((BgL_ev_exprz00_bglt)
((BgL_ev_varz00_bglt)BgL_vz00_1253)); 
BgL_klassz00_1260 = BgL_g1078z00_1256; 
BgL_fieldsz00_1261 = BgL_g1079z00_1257; 
BgL_zc3z04anonymousza31384ze3z87_1262:
if(
NULLP(BgL_fieldsz00_1261))
{ /* Eval/evaluate.scm 212 */
return 
((obj_t)BgL_nodez00_1259);}  else 
{ /* Eval/evaluate.scm 212 */
if(
BGl_classzf3zf3zz__objectz00(BgL_klassz00_1260))
{ /* Eval/evaluate.scm 215 */
obj_t BgL_fieldz00_1265;
{ /* Eval/evaluate.scm 215 */
obj_t BgL_arg1397z00_1276;
BgL_arg1397z00_1276 = 
CAR(
((obj_t)BgL_fieldsz00_1261)); 
BgL_fieldz00_1265 = 
BGl_findzd2classzd2fieldz00zz__objectz00(BgL_klassz00_1260, BgL_arg1397z00_1276); } 
if(
BGl_classzd2fieldzf3z21zz__objectz00(BgL_fieldz00_1265))
{ /* Eval/evaluate.scm 217 */
BgL_ev_appz00_bglt BgL_nodez00_1267;
BgL_nodez00_1267 = 
BGl_makezd2classzd2fieldzd2refzd2zz__evaluatez00(BgL_fieldz00_1265, BgL_nodez00_1259, BgL_locz00_35, BgL_tailzf3zf3_33); 
{ /* Eval/evaluate.scm 220 */
obj_t BgL_arg1388z00_1268;obj_t BgL_arg1389z00_1269;
BgL_arg1388z00_1268 = 
BGl_classzd2fieldzd2typez00zz__objectz00(BgL_fieldz00_1265); 
BgL_arg1389z00_1269 = 
CDR(
((obj_t)BgL_fieldsz00_1261)); 
{ 
obj_t BgL_fieldsz00_4766;obj_t BgL_klassz00_4765;BgL_ev_exprz00_bglt BgL_nodez00_4763;
BgL_nodez00_4763 = 
((BgL_ev_exprz00_bglt)BgL_nodez00_1267); 
BgL_klassz00_4765 = BgL_arg1388z00_1268; 
BgL_fieldsz00_4766 = BgL_arg1389z00_1269; 
BgL_fieldsz00_1261 = BgL_fieldsz00_4766; 
BgL_klassz00_1260 = BgL_klassz00_4765; 
BgL_nodez00_1259 = BgL_nodez00_4763; 
goto BgL_zc3z04anonymousza31384ze3z87_1262;} } }  else 
{ /* Eval/evaluate.scm 222 */
obj_t BgL_arg1390z00_1270;obj_t BgL_arg1391z00_1271;
BgL_arg1390z00_1270 = 
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_vz00_1253)))->BgL_typez00); 
{ /* Eval/evaluate.scm 223 */
obj_t BgL_arg1392z00_1272;obj_t BgL_arg1393z00_1273;
BgL_arg1392z00_1272 = 
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_vz00_1253)))->BgL_typez00); 
BgL_arg1393z00_1273 = 
CAR(
((obj_t)BgL_fieldsz00_1261)); 
{ /* Eval/evaluate.scm 223 */
obj_t BgL_list1394z00_1274;
{ /* Eval/evaluate.scm 223 */
obj_t BgL_arg1396z00_1275;
BgL_arg1396z00_1275 = 
MAKE_YOUNG_PAIR(BgL_arg1393z00_1273, BNIL); 
BgL_list1394z00_1274 = 
MAKE_YOUNG_PAIR(BgL_arg1392z00_1272, BgL_arg1396z00_1275); } 
BgL_arg1391z00_1271 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string2996z00zz__evaluatez00, BgL_list1394z00_1274); } } 
return 
BGl_evcompilezd2errorzd2zz__evcompilez00(BgL_locz00_35, BgL_arg1390z00_1270, BgL_arg1391z00_1271, BgL_ez00_30);} }  else 
{ /* Eval/evaluate.scm 226 */
obj_t BgL_arg1398z00_1277;
{ /* Eval/evaluate.scm 226 */
obj_t BgL__ortest_1080z00_1278;
BgL__ortest_1080z00_1278 = 
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_vz00_1253)))->BgL_typez00); 
if(
CBOOL(BgL__ortest_1080z00_1278))
{ /* Eval/evaluate.scm 226 */
BgL_arg1398z00_1277 = BgL__ortest_1080z00_1278; }  else 
{ /* Eval/evaluate.scm 226 */
BgL_arg1398z00_1277 = 
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_vz00_1253)))->BgL_namez00); } } 
return 
BGl_evcompilezd2errorzd2zz__evcompilez00(BgL_locz00_35, BgL_arg1398z00_1277, BGl_string2997z00zz__evaluatez00, BgL_ez00_30);} } } }  else 
{ /* Eval/evaluate.scm 228 */
obj_t BgL_arg1400z00_1281;
{ /* Eval/evaluate.scm 228 */
obj_t BgL_pairz00_3214;
BgL_pairz00_3214 = 
CDR(
((obj_t)BgL_ez00_30)); 
BgL_arg1400z00_1281 = 
CAR(BgL_pairz00_3214); } 
return 
BGl_evcompilezd2errorzd2zz__evcompilez00(BgL_locz00_35, BgL_arg1400z00_1281, BGl_string2998z00zz__evaluatez00, BgL_ez00_30);} } } } } 

}



/* conv-field-set */
obj_t BGl_convzd2fieldzd2setz00zz__evaluatez00(obj_t BgL_lz00_37, obj_t BgL_e2z00_38, obj_t BgL_ez00_39, obj_t BgL_localsz00_40, obj_t BgL_globalsz00_41, obj_t BgL_tailzf3zf3_42, obj_t BgL_wherez00_43, obj_t BgL_locz00_44, bool_t BgL_topzf3zf3_45)
{
{ /* Eval/evaluate.scm 233 */
{ /* Eval/evaluate.scm 234 */
obj_t BgL_vz00_1283;
BgL_vz00_1283 = 
BGl_convzd2varzd2zz__evaluatez00(
CAR(BgL_lz00_37), BgL_localsz00_40); 
{ /* Eval/evaluate.scm 234 */
obj_t BgL_e2z00_1284;
BgL_e2z00_1284 = 
BGl_convz00zz__evaluatez00(BgL_e2z00_38, BgL_localsz00_40, BgL_globalsz00_41, BFALSE, BgL_wherez00_43, BgL_locz00_44, ((bool_t)0)); 
{ /* Eval/evaluate.scm 235 */

if(
BGl_isazf3zf3zz__objectz00(BgL_vz00_1283, BGl_ev_varz00zz__evaluate_typesz00))
{ /* Eval/evaluate.scm 238 */
obj_t BgL_g1082z00_1287;obj_t BgL_g1083z00_1288;
{ /* Eval/evaluate.scm 239 */
obj_t BgL_arg1429z00_1319;
BgL_arg1429z00_1319 = 
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_vz00_1283)))->BgL_typez00); 
BgL_g1082z00_1287 = 
BGl_classzd2existszd2zz__objectz00(BgL_arg1429z00_1319); } 
BgL_g1083z00_1288 = 
CDR(BgL_lz00_37); 
{ 
BgL_ev_exprz00_bglt BgL_nodez00_1290;obj_t BgL_klassz00_1291;obj_t BgL_fieldsz00_1292;
BgL_nodez00_1290 = 
((BgL_ev_exprz00_bglt)
((BgL_ev_varz00_bglt)BgL_vz00_1283)); 
BgL_klassz00_1291 = BgL_g1082z00_1287; 
BgL_fieldsz00_1292 = BgL_g1083z00_1288; 
BgL_zc3z04anonymousza31403ze3z87_1293:
if(
NULLP(BgL_fieldsz00_1292))
{ /* Eval/evaluate.scm 242 */
return 
((obj_t)BgL_nodez00_1290);}  else 
{ /* Eval/evaluate.scm 242 */
if(
BGl_classzf3zf3zz__objectz00(BgL_klassz00_1291))
{ /* Eval/evaluate.scm 245 */
obj_t BgL_fieldz00_1296;
{ /* Eval/evaluate.scm 245 */
obj_t BgL_arg1425z00_1315;
BgL_arg1425z00_1315 = 
CAR(
((obj_t)BgL_fieldsz00_1292)); 
BgL_fieldz00_1296 = 
BGl_findzd2classzd2fieldz00zz__objectz00(BgL_klassz00_1291, BgL_arg1425z00_1315); } 
if(
BGl_classzd2fieldzf3z21zz__objectz00(BgL_fieldz00_1296))
{ /* Eval/evaluate.scm 246 */
if(
NULLP(
CDR(
((obj_t)BgL_fieldsz00_1292))))
{ /* Eval/evaluate.scm 247 */
if(
BGl_classzd2fieldzd2mutablezf3zf3zz__objectz00(BgL_fieldz00_1296))
{ /* Eval/evaluate.scm 250 */
obj_t BgL_arg1410z00_1301;
{ /* Eval/evaluate.scm 250 */
obj_t BgL_list1411z00_1302;
{ /* Eval/evaluate.scm 250 */
obj_t BgL_arg1412z00_1303;
BgL_arg1412z00_1303 = 
MAKE_YOUNG_PAIR(BgL_e2z00_1284, BNIL); 
BgL_list1411z00_1302 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_nodez00_1290), BgL_arg1412z00_1303); } 
BgL_arg1410z00_1301 = BgL_list1411z00_1302; } 
return 
((obj_t)
BGl_makezd2classzd2fieldzd2setzd2zz__evaluatez00(BgL_fieldz00_1296, BgL_arg1410z00_1301, BgL_locz00_44, BgL_tailzf3zf3_42));}  else 
{ /* Eval/evaluate.scm 251 */
obj_t BgL_arg1413z00_1304;
BgL_arg1413z00_1304 = 
CAR(
((obj_t)BgL_fieldsz00_1292)); 
return 
BGl_evcompilezd2errorzd2zz__evcompilez00(BgL_locz00_44, BgL_arg1413z00_1304, BGl_string2999z00zz__evaluatez00, BgL_ez00_39);} }  else 
{ /* Eval/evaluate.scm 254 */
BgL_ev_appz00_bglt BgL_nodez00_1305;
BgL_nodez00_1305 = 
BGl_makezd2classzd2fieldzd2refzd2zz__evaluatez00(BgL_fieldz00_1296, BgL_nodez00_1290, BgL_locz00_44, BgL_tailzf3zf3_42); 
{ /* Eval/evaluate.scm 257 */
obj_t BgL_arg1414z00_1306;obj_t BgL_arg1415z00_1307;
BgL_arg1414z00_1306 = 
BGl_classzd2fieldzd2typez00zz__objectz00(BgL_fieldz00_1296); 
BgL_arg1415z00_1307 = 
CDR(
((obj_t)BgL_fieldsz00_1292)); 
{ 
obj_t BgL_fieldsz00_4830;obj_t BgL_klassz00_4829;BgL_ev_exprz00_bglt BgL_nodez00_4827;
BgL_nodez00_4827 = 
((BgL_ev_exprz00_bglt)BgL_nodez00_1305); 
BgL_klassz00_4829 = BgL_arg1414z00_1306; 
BgL_fieldsz00_4830 = BgL_arg1415z00_1307; 
BgL_fieldsz00_1292 = BgL_fieldsz00_4830; 
BgL_klassz00_1291 = BgL_klassz00_4829; 
BgL_nodez00_1290 = BgL_nodez00_4827; 
goto BgL_zc3z04anonymousza31403ze3z87_1293;} } } }  else 
{ /* Eval/evaluate.scm 259 */
obj_t BgL_arg1417z00_1309;obj_t BgL_arg1418z00_1310;
BgL_arg1417z00_1309 = 
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_vz00_1283)))->BgL_typez00); 
{ /* Eval/evaluate.scm 260 */
obj_t BgL_arg1421z00_1311;obj_t BgL_arg1422z00_1312;
BgL_arg1421z00_1311 = 
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_vz00_1283)))->BgL_typez00); 
BgL_arg1422z00_1312 = 
CAR(
((obj_t)BgL_fieldsz00_1292)); 
{ /* Eval/evaluate.scm 260 */
obj_t BgL_list1423z00_1313;
{ /* Eval/evaluate.scm 260 */
obj_t BgL_arg1424z00_1314;
BgL_arg1424z00_1314 = 
MAKE_YOUNG_PAIR(BgL_arg1422z00_1312, BNIL); 
BgL_list1423z00_1313 = 
MAKE_YOUNG_PAIR(BgL_arg1421z00_1311, BgL_arg1424z00_1314); } 
BgL_arg1418z00_1310 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string2996z00zz__evaluatez00, BgL_list1423z00_1313); } } 
return 
BGl_evcompilezd2errorzd2zz__evcompilez00(BgL_locz00_44, BgL_arg1417z00_1309, BgL_arg1418z00_1310, BgL_ez00_39);} }  else 
{ /* Eval/evaluate.scm 264 */
obj_t BgL_arg1426z00_1316;
{ /* Eval/evaluate.scm 264 */
obj_t BgL__ortest_1084z00_1317;
BgL__ortest_1084z00_1317 = 
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_vz00_1283)))->BgL_typez00); 
if(
CBOOL(BgL__ortest_1084z00_1317))
{ /* Eval/evaluate.scm 264 */
BgL_arg1426z00_1316 = BgL__ortest_1084z00_1317; }  else 
{ /* Eval/evaluate.scm 264 */
BgL_arg1426z00_1316 = 
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_vz00_1283)))->BgL_namez00); } } 
return 
BGl_evcompilezd2errorzd2zz__evcompilez00(BgL_locz00_44, BgL_arg1426z00_1316, BGl_string2997z00zz__evaluatez00, BgL_ez00_39);} } } }  else 
{ /* Eval/evaluate.scm 236 */
return 
BGl_evcompilezd2errorzd2zz__evcompilez00(BgL_locz00_44, 
CAR(BgL_lz00_37), BGl_string2998z00zz__evaluatez00, BgL_ez00_39);} } } } } 

}



/* make-class-field-ref */
BgL_ev_appz00_bglt BGl_makezd2classzd2fieldzd2refzd2zz__evaluatez00(obj_t BgL_fieldz00_46, BgL_ev_exprz00_bglt BgL_argz00_47, obj_t BgL_locz00_48, obj_t BgL_tailzf3zf3_49)
{
{ /* Eval/evaluate.scm 270 */
{ /* Eval/evaluate.scm 271 */
obj_t BgL_getz00_1322;
BgL_getz00_1322 = 
BGl_classzd2fieldzd2accessorz00zz__objectz00(BgL_fieldz00_46); 
{ /* Eval/evaluate.scm 272 */
BgL_ev_appz00_bglt BgL_new1086z00_1323;
{ /* Eval/evaluate.scm 273 */
BgL_ev_appz00_bglt BgL_new1085z00_1328;
BgL_new1085z00_1328 = 
((BgL_ev_appz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_appz00_bgl) ))); 
{ /* Eval/evaluate.scm 273 */
long BgL_arg1434z00_1329;
{ /* Eval/evaluate.scm 273 */
long BgL_res2683z00_3227;
BgL_res2683z00_3227 = 
BGL_CLASS_INDEX(BGl_ev_appz00zz__evaluate_typesz00); 
BgL_arg1434z00_1329 = BgL_res2683z00_3227; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1085z00_1328), BgL_arg1434z00_1329); } 
BgL_new1086z00_1323 = BgL_new1085z00_1328; } 
((((BgL_ev_appz00_bglt)COBJECT(BgL_new1086z00_1323))->BgL_locz00)=((obj_t)BgL_locz00_48),BUNSPEC); 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_4858;
{ /* Eval/evaluate.scm 274 */
BgL_ev_littz00_bglt BgL_new1088z00_1324;
{ /* Eval/evaluate.scm 274 */
BgL_ev_littz00_bglt BgL_new1087z00_1325;
BgL_new1087z00_1325 = 
((BgL_ev_littz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_littz00_bgl) ))); 
{ /* Eval/evaluate.scm 274 */
long BgL_arg1432z00_1326;
{ /* Eval/evaluate.scm 274 */
long BgL_res2684z00_3231;
{ /* Eval/evaluate.scm 274 */
obj_t BgL_classz00_3230;
BgL_classz00_3230 = BGl_ev_littz00zz__evaluate_typesz00; 
BgL_res2684z00_3231 = 
BGL_CLASS_INDEX(BgL_classz00_3230); } 
BgL_arg1432z00_1326 = BgL_res2684z00_3231; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1087z00_1325), BgL_arg1432z00_1326); } 
BgL_new1088z00_1324 = BgL_new1087z00_1325; } 
((((BgL_ev_littz00_bglt)COBJECT(BgL_new1088z00_1324))->BgL_valuez00)=((obj_t)BgL_getz00_1322),BUNSPEC); 
BgL_auxz00_4858 = 
((BgL_ev_exprz00_bglt)BgL_new1088z00_1324); } 
((((BgL_ev_appz00_bglt)COBJECT(BgL_new1086z00_1323))->BgL_funz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_4858),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4866;
{ /* Eval/evaluate.scm 275 */
obj_t BgL_list1433z00_1327;
BgL_list1433z00_1327 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_argz00_47), BNIL); 
BgL_auxz00_4866 = BgL_list1433z00_1327; } 
((((BgL_ev_appz00_bglt)COBJECT(BgL_new1086z00_1323))->BgL_argsz00)=((obj_t)BgL_auxz00_4866),BUNSPEC); } 
((((BgL_ev_appz00_bglt)COBJECT(BgL_new1086z00_1323))->BgL_tailzf3zf3)=((obj_t)BgL_tailzf3zf3_49),BUNSPEC); 
return BgL_new1086z00_1323;} } } 

}



/* make-class-field-set */
BgL_ev_appz00_bglt BGl_makezd2classzd2fieldzd2setzd2zz__evaluatez00(obj_t BgL_fieldz00_50, obj_t BgL_argsz00_51, obj_t BgL_locz00_52, obj_t BgL_tailzf3zf3_53)
{
{ /* Eval/evaluate.scm 281 */
{ /* Eval/evaluate.scm 282 */
obj_t BgL_setz00_1330;
BgL_setz00_1330 = 
BGl_classzd2fieldzd2mutatorz00zz__objectz00(BgL_fieldz00_50); 
{ /* Eval/evaluate.scm 283 */
BgL_ev_appz00_bglt BgL_new1090z00_1331;
{ /* Eval/evaluate.scm 284 */
BgL_ev_appz00_bglt BgL_new1089z00_1335;
BgL_new1089z00_1335 = 
((BgL_ev_appz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_appz00_bgl) ))); 
{ /* Eval/evaluate.scm 284 */
long BgL_arg1436z00_1336;
{ /* Eval/evaluate.scm 284 */
long BgL_res2686z00_3236;
BgL_res2686z00_3236 = 
BGL_CLASS_INDEX(BGl_ev_appz00zz__evaluate_typesz00); 
BgL_arg1436z00_1336 = BgL_res2686z00_3236; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1089z00_1335), BgL_arg1436z00_1336); } 
BgL_new1090z00_1331 = BgL_new1089z00_1335; } 
((((BgL_ev_appz00_bglt)COBJECT(BgL_new1090z00_1331))->BgL_locz00)=((obj_t)BgL_locz00_52),BUNSPEC); 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_4877;
{ /* Eval/evaluate.scm 285 */
BgL_ev_littz00_bglt BgL_new1092z00_1332;
{ /* Eval/evaluate.scm 285 */
BgL_ev_littz00_bglt BgL_new1091z00_1333;
BgL_new1091z00_1333 = 
((BgL_ev_littz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_littz00_bgl) ))); 
{ /* Eval/evaluate.scm 285 */
long BgL_arg1435z00_1334;
{ /* Eval/evaluate.scm 285 */
long BgL_res2687z00_3240;
{ /* Eval/evaluate.scm 285 */
obj_t BgL_classz00_3239;
BgL_classz00_3239 = BGl_ev_littz00zz__evaluate_typesz00; 
BgL_res2687z00_3240 = 
BGL_CLASS_INDEX(BgL_classz00_3239); } 
BgL_arg1435z00_1334 = BgL_res2687z00_3240; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1091z00_1333), BgL_arg1435z00_1334); } 
BgL_new1092z00_1332 = BgL_new1091z00_1333; } 
((((BgL_ev_littz00_bglt)COBJECT(BgL_new1092z00_1332))->BgL_valuez00)=((obj_t)BgL_setz00_1330),BUNSPEC); 
BgL_auxz00_4877 = 
((BgL_ev_exprz00_bglt)BgL_new1092z00_1332); } 
((((BgL_ev_appz00_bglt)COBJECT(BgL_new1090z00_1331))->BgL_funz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_4877),BUNSPEC); } 
((((BgL_ev_appz00_bglt)COBJECT(BgL_new1090z00_1331))->BgL_argsz00)=((obj_t)BgL_argsz00_51),BUNSPEC); 
((((BgL_ev_appz00_bglt)COBJECT(BgL_new1090z00_1331))->BgL_tailzf3zf3)=((obj_t)BgL_tailzf3zf3_53),BUNSPEC); 
return BgL_new1090z00_1331;} } } 

}



/* evepairify */
obj_t BGl_evepairifyz00zz__evaluatez00(obj_t BgL_pz00_54, obj_t BgL_locz00_55)
{
{ /* Eval/evaluate.scm 292 */
{ /* Eval/evaluate.scm 293 */
obj_t BgL_arg1437z00_1337;obj_t BgL_arg1438z00_1338;
BgL_arg1437z00_1337 = 
CAR(BgL_pz00_54); 
BgL_arg1438z00_1338 = 
CDR(BgL_pz00_54); 
{ /* Eval/evaluate.scm 293 */
obj_t BgL_res2688z00_3245;
BgL_res2688z00_3245 = 
MAKE_YOUNG_EPAIR(BgL_arg1437z00_1337, BgL_arg1438z00_1338, BgL_locz00_55); 
return BgL_res2688z00_3245;} } } 

}



/* type-check */
obj_t BGl_typezd2checkzd2zz__evaluatez00(obj_t BgL_varz00_56, obj_t BgL_tnamez00_57, obj_t BgL_locz00_58, obj_t BgL_procnamez00_59, obj_t BgL_bodyz00_60)
{
{ /* Eval/evaluate.scm 298 */
if(
SYMBOLP(BgL_tnamez00_57))
{ /* Eval/evaluate.scm 301 */
obj_t BgL_predz00_1340;
if(
(BgL_tnamez00_57==BGl_symbol3000z00zz__evaluatez00))
{ /* Eval/evaluate.scm 301 */
BgL_predz00_1340 = BGl_symbol3002z00zz__evaluatez00; }  else 
{ /* Eval/evaluate.scm 301 */
if(
(BgL_tnamez00_57==BGl_symbol3004z00zz__evaluatez00))
{ /* Eval/evaluate.scm 301 */
BgL_predz00_1340 = BGl_symbol3005z00zz__evaluatez00; }  else 
{ /* Eval/evaluate.scm 301 */
if(
(BgL_tnamez00_57==BGl_symbol3007z00zz__evaluatez00))
{ /* Eval/evaluate.scm 301 */
BgL_predz00_1340 = BGl_symbol3009z00zz__evaluatez00; }  else 
{ /* Eval/evaluate.scm 301 */
if(
(BgL_tnamez00_57==BGl_symbol3011z00zz__evaluatez00))
{ /* Eval/evaluate.scm 301 */
BgL_predz00_1340 = BGl_symbol3013z00zz__evaluatez00; }  else 
{ /* Eval/evaluate.scm 301 */
bool_t BgL_test3217z00_4900;
{ /* Eval/evaluate.scm 301 */
bool_t BgL__ortest_1093z00_1416;
BgL__ortest_1093z00_1416 = 
(BgL_tnamez00_57==BGl_symbol3015z00zz__evaluatez00); 
if(BgL__ortest_1093z00_1416)
{ /* Eval/evaluate.scm 301 */
BgL_test3217z00_4900 = BgL__ortest_1093z00_1416
; }  else 
{ /* Eval/evaluate.scm 301 */
BgL_test3217z00_4900 = 
(BgL_tnamez00_57==BGl_symbol3017z00zz__evaluatez00)
; } } 
if(BgL_test3217z00_4900)
{ /* Eval/evaluate.scm 301 */
BgL_predz00_1340 = BGl_symbol3018z00zz__evaluatez00; }  else 
{ /* Eval/evaluate.scm 301 */
bool_t BgL_test3219z00_4904;
{ /* Eval/evaluate.scm 301 */
bool_t BgL__ortest_1094z00_1415;
BgL__ortest_1094z00_1415 = 
(BgL_tnamez00_57==BGl_symbol3020z00zz__evaluatez00); 
if(BgL__ortest_1094z00_1415)
{ /* Eval/evaluate.scm 301 */
BgL_test3219z00_4904 = BgL__ortest_1094z00_1415
; }  else 
{ /* Eval/evaluate.scm 301 */
BgL_test3219z00_4904 = 
(BgL_tnamez00_57==BGl_symbol3022z00zz__evaluatez00)
; } } 
if(BgL_test3219z00_4904)
{ /* Eval/evaluate.scm 301 */
BgL_predz00_1340 = BGl_symbol3024z00zz__evaluatez00; }  else 
{ /* Eval/evaluate.scm 301 */
if(
(BgL_tnamez00_57==BGl_symbol3026z00zz__evaluatez00))
{ /* Eval/evaluate.scm 301 */
BgL_predz00_1340 = BGl_symbol3028z00zz__evaluatez00; }  else 
{ /* Eval/evaluate.scm 301 */
if(
(BgL_tnamez00_57==BGl_symbol3030z00zz__evaluatez00))
{ /* Eval/evaluate.scm 301 */
BgL_predz00_1340 = BGl_symbol3032z00zz__evaluatez00; }  else 
{ /* Eval/evaluate.scm 301 */
if(
(BgL_tnamez00_57==BGl_symbol3034z00zz__evaluatez00))
{ /* Eval/evaluate.scm 301 */
BgL_predz00_1340 = BGl_symbol3036z00zz__evaluatez00; }  else 
{ /* Eval/evaluate.scm 301 */
bool_t BgL_test3224z00_4914;
{ /* Eval/evaluate.scm 301 */
bool_t BgL__ortest_1095z00_1414;
BgL__ortest_1095z00_1414 = 
(BgL_tnamez00_57==BGl_symbol3038z00zz__evaluatez00); 
if(BgL__ortest_1095z00_1414)
{ /* Eval/evaluate.scm 301 */
BgL_test3224z00_4914 = BgL__ortest_1095z00_1414
; }  else 
{ /* Eval/evaluate.scm 301 */
BgL_test3224z00_4914 = 
(BgL_tnamez00_57==BGl_symbol3040z00zz__evaluatez00)
; } } 
if(BgL_test3224z00_4914)
{ /* Eval/evaluate.scm 301 */
BgL_predz00_1340 = BGl_symbol3042z00zz__evaluatez00; }  else 
{ /* Eval/evaluate.scm 312 */
obj_t BgL_arg1486z00_1394;
{ /* Eval/evaluate.scm 312 */
obj_t BgL_arg1488z00_1395;obj_t BgL_arg1489z00_1396;
BgL_arg1488z00_1395 = 
MAKE_YOUNG_PAIR(BGl_symbol3044z00zz__evaluatez00, BNIL); 
{ /* Eval/evaluate.scm 313 */
obj_t BgL_arg1490z00_1397;
{ /* Eval/evaluate.scm 313 */
obj_t BgL_arg1491z00_1398;
{ /* Eval/evaluate.scm 313 */
obj_t BgL_arg1492z00_1399;obj_t BgL_arg1493z00_1400;
{ /* Eval/evaluate.scm 313 */
obj_t BgL_arg1494z00_1401;
{ /* Eval/evaluate.scm 313 */
obj_t BgL_arg1495z00_1402;
{ /* Eval/evaluate.scm 313 */
obj_t BgL_arg1496z00_1403;
{ /* Eval/evaluate.scm 313 */
obj_t BgL_arg1497z00_1404;
{ /* Eval/evaluate.scm 313 */
obj_t BgL_arg1498z00_1405;
{ /* Eval/evaluate.scm 313 */
obj_t BgL_arg1499z00_1406;
BgL_arg1499z00_1406 = 
MAKE_YOUNG_PAIR(BgL_tnamez00_57, BNIL); 
BgL_arg1498z00_1405 = 
MAKE_YOUNG_PAIR(BGl_symbol3046z00zz__evaluatez00, BgL_arg1499z00_1406); } 
BgL_arg1497z00_1404 = 
MAKE_YOUNG_PAIR(BgL_arg1498z00_1405, BNIL); } 
BgL_arg1496z00_1403 = 
MAKE_YOUNG_PAIR(BGl_symbol3048z00zz__evaluatez00, BgL_arg1497z00_1404); } 
BgL_arg1495z00_1402 = 
MAKE_YOUNG_PAIR(BgL_arg1496z00_1403, BNIL); } 
BgL_arg1494z00_1401 = 
MAKE_YOUNG_PAIR(BGl_symbol3050z00zz__evaluatez00, BgL_arg1495z00_1402); } 
BgL_arg1492z00_1399 = 
MAKE_YOUNG_PAIR(BgL_arg1494z00_1401, BNIL); } 
{ /* Eval/evaluate.scm 314 */
obj_t BgL_arg1500z00_1407;
{ /* Eval/evaluate.scm 314 */
obj_t BgL_arg1501z00_1408;
{ /* Eval/evaluate.scm 314 */
obj_t BgL_arg1502z00_1409;
{ /* Eval/evaluate.scm 314 */
obj_t BgL_arg1503z00_1410;obj_t BgL_arg1504z00_1411;
{ /* Eval/evaluate.scm 314 */
obj_t BgL_arg1505z00_1412;
{ /* Eval/evaluate.scm 314 */
obj_t BgL_arg1506z00_1413;
BgL_arg1506z00_1413 = 
MAKE_YOUNG_PAIR(BGl_symbol3050z00zz__evaluatez00, BNIL); 
BgL_arg1505z00_1412 = 
MAKE_YOUNG_PAIR(BGl_symbol3044z00zz__evaluatez00, BgL_arg1506z00_1413); } 
BgL_arg1503z00_1410 = 
MAKE_YOUNG_PAIR(BGl_symbol3052z00zz__evaluatez00, BgL_arg1505z00_1412); } 
BgL_arg1504z00_1411 = 
MAKE_YOUNG_PAIR(BTRUE, BNIL); 
BgL_arg1502z00_1409 = 
MAKE_YOUNG_PAIR(BgL_arg1503z00_1410, BgL_arg1504z00_1411); } 
BgL_arg1501z00_1408 = 
MAKE_YOUNG_PAIR(BGl_symbol3050z00zz__evaluatez00, BgL_arg1502z00_1409); } 
BgL_arg1500z00_1407 = 
MAKE_YOUNG_PAIR(BGl_symbol3054z00zz__evaluatez00, BgL_arg1501z00_1408); } 
BgL_arg1493z00_1400 = 
MAKE_YOUNG_PAIR(BgL_arg1500z00_1407, BNIL); } 
BgL_arg1491z00_1398 = 
MAKE_YOUNG_PAIR(BgL_arg1492z00_1399, BgL_arg1493z00_1400); } 
BgL_arg1490z00_1397 = 
MAKE_YOUNG_PAIR(BGl_symbol3056z00zz__evaluatez00, BgL_arg1491z00_1398); } 
BgL_arg1489z00_1396 = 
MAKE_YOUNG_PAIR(BgL_arg1490z00_1397, BNIL); } 
BgL_arg1486z00_1394 = 
MAKE_YOUNG_PAIR(BgL_arg1488z00_1395, BgL_arg1489z00_1396); } 
BgL_predz00_1340 = 
MAKE_YOUNG_PAIR(BGl_symbol3058z00zz__evaluatez00, BgL_arg1486z00_1394); } } } } } } } } } } 
{ /* Eval/evaluate.scm 316 */
obj_t BgL_arg1442z00_1341;
{ /* Eval/evaluate.scm 316 */
obj_t BgL_arg1443z00_1342;
{ /* Eval/evaluate.scm 316 */
obj_t BgL_arg1444z00_1343;obj_t BgL_arg1445z00_1344;
{ /* Eval/evaluate.scm 316 */
obj_t BgL_arg1446z00_1345;
BgL_arg1446z00_1345 = 
MAKE_YOUNG_PAIR(BgL_varz00_56, BNIL); 
BgL_arg1444z00_1343 = 
MAKE_YOUNG_PAIR(BgL_predz00_1340, BgL_arg1446z00_1345); } 
{ /* Eval/evaluate.scm 316 */
obj_t BgL_arg1447z00_1346;
{ /* Eval/evaluate.scm 316 */
obj_t BgL_arg1448z00_1347;
{ 
obj_t BgL_fnamez00_1348;obj_t BgL_posz00_1349;
if(
PAIRP(BgL_locz00_58))
{ /* Eval/evaluate.scm 316 */
obj_t BgL_cdrzd2138zd2_1354;
BgL_cdrzd2138zd2_1354 = 
CDR(BgL_locz00_58); 
if(
(
CAR(BgL_locz00_58)==BGl_symbol3064z00zz__evaluatez00))
{ /* Eval/evaluate.scm 316 */
if(
PAIRP(BgL_cdrzd2138zd2_1354))
{ /* Eval/evaluate.scm 316 */
obj_t BgL_cdrzd2142zd2_1358;
BgL_cdrzd2142zd2_1358 = 
CDR(BgL_cdrzd2138zd2_1354); 
if(
PAIRP(BgL_cdrzd2142zd2_1358))
{ /* Eval/evaluate.scm 316 */
if(
NULLP(
CDR(BgL_cdrzd2142zd2_1358)))
{ /* Eval/evaluate.scm 316 */
BgL_fnamez00_1348 = 
CAR(BgL_cdrzd2138zd2_1354); 
BgL_posz00_1349 = 
CAR(BgL_cdrzd2142zd2_1358); 
{ /* Eval/evaluate.scm 321 */
obj_t BgL_arg1461z00_1366;
{ /* Eval/evaluate.scm 321 */
obj_t BgL_arg1462z00_1367;obj_t BgL_arg1463z00_1368;
if(
SYMBOLP(BgL_procnamez00_59))
{ /* Eval/evaluate.scm 321 */
obj_t BgL_res2698z00_3264;
{ /* Eval/evaluate.scm 321 */
obj_t BgL_arg2496z00_3263;
BgL_arg2496z00_3263 = 
SYMBOL_TO_STRING(BgL_procnamez00_59); 
BgL_res2698z00_3264 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg2496z00_3263); } 
BgL_arg1462z00_1367 = BgL_res2698z00_3264; }  else 
{ /* Eval/evaluate.scm 321 */
BgL_arg1462z00_1367 = BFALSE; } 
{ /* Eval/evaluate.scm 322 */
obj_t BgL_arg1465z00_1370;obj_t BgL_arg1466z00_1371;
{ /* Eval/evaluate.scm 322 */
obj_t BgL_res2699z00_3267;
{ /* Eval/evaluate.scm 322 */
obj_t BgL_arg2496z00_3266;
BgL_arg2496z00_3266 = 
SYMBOL_TO_STRING(
((obj_t)BgL_tnamez00_57)); 
BgL_res2699z00_3267 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg2496z00_3266); } 
BgL_arg1465z00_1370 = BgL_res2699z00_3267; } 
{ /* Eval/evaluate.scm 320 */
obj_t BgL_arg1467z00_1372;
{ /* Eval/evaluate.scm 320 */
obj_t BgL_arg1469z00_1373;
BgL_arg1469z00_1373 = 
MAKE_YOUNG_PAIR(BgL_posz00_1349, BNIL); 
BgL_arg1467z00_1372 = 
MAKE_YOUNG_PAIR(BgL_fnamez00_1348, BgL_arg1469z00_1373); } 
BgL_arg1466z00_1371 = 
MAKE_YOUNG_PAIR(BgL_varz00_56, BgL_arg1467z00_1372); } 
BgL_arg1463z00_1368 = 
MAKE_YOUNG_PAIR(BgL_arg1465z00_1370, BgL_arg1466z00_1371); } 
BgL_arg1461z00_1366 = 
MAKE_YOUNG_PAIR(BgL_arg1462z00_1367, BgL_arg1463z00_1368); } 
BgL_arg1448z00_1347 = 
MAKE_YOUNG_PAIR(BGl_symbol3060z00zz__evaluatez00, BgL_arg1461z00_1366); } }  else 
{ /* Eval/evaluate.scm 316 */
BgL_tagzd2131zd2_1351:
{ /* Eval/evaluate.scm 326 */
obj_t BgL_arg1470z00_1374;
{ /* Eval/evaluate.scm 326 */
obj_t BgL_arg1471z00_1375;obj_t BgL_arg1472z00_1376;
if(
SYMBOLP(BgL_procnamez00_59))
{ /* Eval/evaluate.scm 326 */
obj_t BgL_res2701z00_3271;
{ /* Eval/evaluate.scm 326 */
obj_t BgL_arg2496z00_3270;
BgL_arg2496z00_3270 = 
SYMBOL_TO_STRING(BgL_procnamez00_59); 
BgL_res2701z00_3271 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg2496z00_3270); } 
BgL_arg1471z00_1375 = BgL_res2701z00_3271; }  else 
{ /* Eval/evaluate.scm 326 */
BgL_arg1471z00_1375 = BFALSE; } 
{ /* Eval/evaluate.scm 327 */
obj_t BgL_arg1474z00_1378;obj_t BgL_arg1475z00_1379;
{ /* Eval/evaluate.scm 327 */
obj_t BgL_res2702z00_3274;
{ /* Eval/evaluate.scm 327 */
obj_t BgL_arg2496z00_3273;
BgL_arg2496z00_3273 = 
SYMBOL_TO_STRING(
((obj_t)BgL_tnamez00_57)); 
BgL_res2702z00_3274 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg2496z00_3273); } 
BgL_arg1474z00_1378 = BgL_res2702z00_3274; } 
BgL_arg1475z00_1379 = 
MAKE_YOUNG_PAIR(BgL_varz00_56, BNIL); 
BgL_arg1472z00_1376 = 
MAKE_YOUNG_PAIR(BgL_arg1474z00_1378, BgL_arg1475z00_1379); } 
BgL_arg1470z00_1374 = 
MAKE_YOUNG_PAIR(BgL_arg1471z00_1375, BgL_arg1472z00_1376); } 
BgL_arg1448z00_1347 = 
MAKE_YOUNG_PAIR(BGl_symbol3062z00zz__evaluatez00, BgL_arg1470z00_1374); } } }  else 
{ /* Eval/evaluate.scm 316 */
goto BgL_tagzd2131zd2_1351;} }  else 
{ /* Eval/evaluate.scm 316 */
goto BgL_tagzd2131zd2_1351;} }  else 
{ /* Eval/evaluate.scm 316 */
goto BgL_tagzd2131zd2_1351;} }  else 
{ /* Eval/evaluate.scm 316 */
goto BgL_tagzd2131zd2_1351;} } 
BgL_arg1447z00_1346 = 
MAKE_YOUNG_PAIR(BgL_arg1448z00_1347, BNIL); } 
BgL_arg1445z00_1344 = 
MAKE_YOUNG_PAIR(BgL_bodyz00_60, BgL_arg1447z00_1346); } 
BgL_arg1443z00_1342 = 
MAKE_YOUNG_PAIR(BgL_arg1444z00_1343, BgL_arg1445z00_1344); } 
BgL_arg1442z00_1341 = 
MAKE_YOUNG_PAIR(BGl_symbol3054z00zz__evaluatez00, BgL_arg1443z00_1342); } 
return 
BGl_evepairifyz00zz__evaluatez00(BgL_arg1442z00_1341, BgL_locz00_58);} }  else 
{ /* Eval/evaluate.scm 300 */
return BgL_bodyz00_60;} } 

}



/* type-checks */
obj_t BGl_typezd2checkszd2zz__evaluatez00(obj_t BgL_varsz00_61, obj_t BgL_srcsz00_62, obj_t BgL_bodyz00_63, obj_t BgL_locz00_64, obj_t BgL_procnamez00_65)
{
{ /* Eval/evaluate.scm 334 */
{ /* Eval/evaluate.scm 335 */
bool_t BgL_test3233z00_4986;
{ /* Eval/evaluate.scm 335 */
int BgL_arg1519z00_1435;
BgL_arg1519z00_1435 = 
bgl_debug(); 
BgL_test3233z00_4986 = 
(
(long)(BgL_arg1519z00_1435)<=((long)0)); } 
if(BgL_test3233z00_4986)
{ /* Eval/evaluate.scm 335 */
return BgL_bodyz00_63;}  else 
{ /* Eval/evaluate.scm 335 */
return 
BGl_loopze71ze7zz__evaluatez00(BgL_bodyz00_63, BgL_procnamez00_65, BgL_locz00_64, BgL_varsz00_61, BgL_srcsz00_62);} } } 

}



/* loop~1 */
obj_t BGl_loopze71ze7zz__evaluatez00(obj_t BgL_bodyz00_4478, obj_t BgL_procnamez00_4477, obj_t BgL_locz00_4476, obj_t BgL_varsz00_1420, obj_t BgL_srcsz00_1421)
{
{ /* Eval/evaluate.scm 337 */
BGl_loopze71ze7zz__evaluatez00:
if(
NULLP(BgL_varsz00_1420))
{ /* Eval/evaluate.scm 339 */
return BgL_bodyz00_4478;}  else 
{ /* Eval/evaluate.scm 341 */
obj_t BgL_vz00_1424;
BgL_vz00_1424 = 
CAR(
((obj_t)BgL_varsz00_1420)); 
{ /* Eval/evaluate.scm 341 */
obj_t BgL_idz00_1425;
BgL_idz00_1425 = 
CAR(
((obj_t)BgL_vz00_1424)); 
{ /* Eval/evaluate.scm 342 */
obj_t BgL_tnamez00_1426;
BgL_tnamez00_1426 = 
CDR(
((obj_t)BgL_vz00_1424)); 
{ /* Eval/evaluate.scm 343 */

if(
CBOOL(BgL_tnamez00_1426))
{ /* Eval/evaluate.scm 345 */
obj_t BgL_locz00_1427;
{ /* Eval/evaluate.scm 345 */
obj_t BgL_arg1516z00_1431;
BgL_arg1516z00_1431 = 
CAR(
((obj_t)BgL_srcsz00_1421)); 
BgL_locz00_1427 = 
BGl_getzd2location3zd2zz__evaluatez00(BgL_arg1516z00_1431, BgL_srcsz00_1421, BgL_locz00_4476); } 
{ /* Eval/evaluate.scm 347 */
obj_t BgL_arg1511z00_1428;
{ /* Eval/evaluate.scm 347 */
obj_t BgL_arg1513z00_1429;obj_t BgL_arg1514z00_1430;
BgL_arg1513z00_1429 = 
CDR(
((obj_t)BgL_varsz00_1420)); 
BgL_arg1514z00_1430 = 
CDR(
((obj_t)BgL_srcsz00_1421)); 
BgL_arg1511z00_1428 = 
BGl_loopze71ze7zz__evaluatez00(BgL_bodyz00_4478, BgL_procnamez00_4477, BgL_locz00_4476, BgL_arg1513z00_1429, BgL_arg1514z00_1430); } 
return 
BGl_typezd2checkzd2zz__evaluatez00(BgL_idz00_1425, BgL_tnamez00_1426, BgL_locz00_1427, BgL_procnamez00_4477, BgL_arg1511z00_1428);} }  else 
{ /* Eval/evaluate.scm 348 */
obj_t BgL_arg1517z00_1432;obj_t BgL_arg1518z00_1433;
BgL_arg1517z00_1432 = 
CDR(
((obj_t)BgL_varsz00_1420)); 
BgL_arg1518z00_1433 = 
CDR(
((obj_t)BgL_srcsz00_1421)); 
{ 
obj_t BgL_srcsz00_5015;obj_t BgL_varsz00_5014;
BgL_varsz00_5014 = BgL_arg1517z00_1432; 
BgL_srcsz00_5015 = BgL_arg1518z00_1433; 
BgL_srcsz00_1421 = BgL_srcsz00_5015; 
BgL_varsz00_1420 = BgL_varsz00_5014; 
goto BGl_loopze71ze7zz__evaluatez00;} } } } } } } 

}



/* type-result */
obj_t BGl_typezd2resultzd2zz__evaluatez00(obj_t BgL_typez00_66, obj_t BgL_bodyz00_67, obj_t BgL_locz00_68)
{
{ /* Eval/evaluate.scm 353 */
{ /* Eval/evaluate.scm 354 */
bool_t BgL_test3236z00_5016;
if(
CBOOL(BgL_typez00_66))
{ /* Eval/evaluate.scm 354 */
int BgL_arg1538z00_1450;
BgL_arg1538z00_1450 = 
bgl_debug(); 
BgL_test3236z00_5016 = 
(
(long)(BgL_arg1538z00_1450)>=((long)1)); }  else 
{ /* Eval/evaluate.scm 354 */
BgL_test3236z00_5016 = ((bool_t)0)
; } 
if(BgL_test3236z00_5016)
{ /* Eval/evaluate.scm 355 */
obj_t BgL_tmpz00_1438;
BgL_tmpz00_1438 = 
BGl_gensymz00zz__r4_symbols_6_4z00(BGl_symbol3066z00zz__evaluatez00); 
{ /* Eval/evaluate.scm 357 */
obj_t BgL_arg1522z00_1439;obj_t BgL_arg1523z00_1440;
{ /* Eval/evaluate.scm 357 */
obj_t BgL_arg1524z00_1441;
{ /* Eval/evaluate.scm 357 */
obj_t BgL_arg1525z00_1442;obj_t BgL_arg1526z00_1443;
{ /* Eval/evaluate.scm 357 */
obj_t BgL_arg1527z00_1444;
{ /* Eval/evaluate.scm 357 */
obj_t BgL_arg1532z00_1445;obj_t BgL_arg1534z00_1446;
{ /* Eval/evaluate.scm 357 */
obj_t BgL_arg1535z00_1447;
{ /* Eval/evaluate.scm 357 */
obj_t BgL_list1536z00_1448;
{ /* Eval/evaluate.scm 357 */
obj_t BgL_arg1537z00_1449;
BgL_arg1537z00_1449 = 
MAKE_YOUNG_PAIR(BgL_typez00_66, BNIL); 
BgL_list1536z00_1448 = 
MAKE_YOUNG_PAIR(BgL_tmpz00_1438, BgL_arg1537z00_1449); } 
BgL_arg1535z00_1447 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string3068z00zz__evaluatez00, BgL_list1536z00_1448); } 
BgL_arg1532z00_1445 = 
bstring_to_symbol(BgL_arg1535z00_1447); } 
BgL_arg1534z00_1446 = 
MAKE_YOUNG_PAIR(BgL_bodyz00_67, BNIL); 
BgL_arg1527z00_1444 = 
MAKE_YOUNG_PAIR(BgL_arg1532z00_1445, BgL_arg1534z00_1446); } 
BgL_arg1525z00_1442 = 
MAKE_YOUNG_PAIR(BgL_arg1527z00_1444, BNIL); } 
BgL_arg1526z00_1443 = 
MAKE_YOUNG_PAIR(BgL_tmpz00_1438, BNIL); 
BgL_arg1524z00_1441 = 
MAKE_YOUNG_PAIR(BgL_arg1525z00_1442, BgL_arg1526z00_1443); } 
BgL_arg1522z00_1439 = 
MAKE_YOUNG_PAIR(BGl_symbol3056z00zz__evaluatez00, BgL_arg1524z00_1441); } 
BgL_arg1523z00_1440 = 
BGl_getzd2locationzd2zz__evaluatez00(BgL_bodyz00_67, BgL_locz00_68); 
return 
BGl_evepairifyz00zz__evaluatez00(BgL_arg1522z00_1439, BgL_arg1523z00_1440);} }  else 
{ /* Eval/evaluate.scm 354 */
return BgL_bodyz00_67;} } } 

}



/* conv */
obj_t BGl_convz00zz__evaluatez00(obj_t BgL_ez00_69, obj_t BgL_localsz00_70, obj_t BgL_globalsz00_71, obj_t BgL_tailzf3zf3_72, obj_t BgL_wherez00_73, obj_t BgL_locz00_74, bool_t BgL_topzf3zf3_75)
{
{ /* Eval/evaluate.scm 365 */
BGl_convz00zz__evaluatez00:
{ 
obj_t BgL_ez00_2629;obj_t BgL_locz00_2630;obj_t BgL_wherez00_2631;obj_t BgL_ez00_2639;obj_t BgL_wherez00_2640;
{ 
obj_t BgL_xz00_1459;obj_t BgL_bahz00_1461;obj_t BgL_idz00_1463;obj_t BgL_modnamez00_1464;obj_t BgL_lz00_1466;obj_t BgL_funz00_1468;obj_t BgL_argsz00_1469;obj_t BgL_ez00_1471;obj_t BgL_vz00_1473;obj_t BgL_pz00_1475;obj_t BgL_tz00_1476;obj_t BgL_oz00_1477;obj_t BgL_pz00_1479;obj_t BgL_tz00_1480;obj_t BgL_argsz00_1482;obj_t BgL_argsz00_1484;obj_t BgL_lz00_1486;obj_t BgL_bindsz00_1488;obj_t BgL_bodyz00_1489;obj_t BgL_bindsz00_1491;obj_t BgL_bodyz00_1492;obj_t BgL_bindsz00_1494;obj_t BgL_bodyz00_1495;obj_t BgL_idz00_1497;obj_t BgL_modnamez00_1498;obj_t BgL_ez00_1499;obj_t BgL_lz00_1501;obj_t BgL_e2z00_1502;obj_t BgL_vz00_1504;obj_t BgL_ez00_1505;obj_t BgL_gvz00_1508;obj_t BgL_formalsz00_1509;obj_t BgL_bodyz00_1510;obj_t BgL_gvz00_1512;obj_t BgL_gez00_1513;obj_t BgL_vz00_1515;obj_t BgL_bodyz00_1516;obj_t BgL_ez00_1518;obj_t BgL_bodyz00_1519;obj_t BgL_hz00_1521;obj_t BgL_bodyz00_1522;obj_t BgL_mz00_1524;obj_t BgL_pz00_1525;obj_t BgL_bodyz00_1526;obj_t BgL_mz00_1528;obj_t BgL_bodyz00_1529;obj_t BgL_formalsz00_1531;obj_t BgL_bodyz00_1532;obj_t BgL_fz00_1534;obj_t BgL_argsz00_1535;
if(
PAIRP(BgL_ez00_69))
{ /* Eval/evaluate.scm 424 */
if(
(
CAR(BgL_ez00_69)==BGl_symbol3077z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
BgL_bahz00_1461 = 
CDR(BgL_ez00_69); 
if(BgL_topzf3zf3_75)
{ /* Eval/evaluate.scm 432 */
obj_t BgL_formsz00_2319;
BgL_formsz00_2319 = 
BGl_evmodulez00zz__evmodulez00(BgL_ez00_69, 
BGl_getzd2locationzd2zz__evaluatez00(BgL_ez00_69, BgL_locz00_74)); 
{ /* Eval/evaluate.scm 433 */
obj_t BgL_arg2193z00_2320;obj_t BgL_arg2194z00_2321;
BgL_arg2193z00_2320 = 
BGl_expandz00zz__expandz00(BgL_formsz00_2319); 
BgL_arg2194z00_2321 = 
BGL_MODULE(); 
{ 
bool_t BgL_topzf3zf3_5049;obj_t BgL_wherez00_5048;obj_t BgL_tailzf3zf3_5047;obj_t BgL_globalsz00_5046;obj_t BgL_ez00_5045;
BgL_ez00_5045 = BgL_arg2193z00_2320; 
BgL_globalsz00_5046 = BgL_arg2194z00_2321; 
BgL_tailzf3zf3_5047 = BgL_wherez00_73; 
BgL_wherez00_5048 = BFALSE; 
BgL_topzf3zf3_5049 = ((bool_t)1); 
BgL_topzf3zf3_75 = BgL_topzf3zf3_5049; 
BgL_wherez00_73 = BgL_wherez00_5048; 
BgL_tailzf3zf3_72 = BgL_tailzf3zf3_5047; 
BgL_globalsz00_71 = BgL_globalsz00_5046; 
BgL_ez00_69 = BgL_ez00_5045; 
goto BGl_convz00zz__evaluatez00;} } }  else 
{ /* Eval/evaluate.scm 431 */
return 
BGl_evcompilezd2errorzd2zz__evcompilez00(BgL_locz00_74, BGl_string2994z00zz__evaluatez00, BGl_string3076z00zz__evaluatez00, BgL_ez00_69);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd2249zd2_1543;
BgL_cdrzd2249zd2_1543 = 
CDR(BgL_ez00_69); 
if(
(
CAR(BgL_ez00_69)==BGl_symbol3079z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd2249zd2_1543))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_carzd2252zd2_1547;obj_t BgL_cdrzd2253zd2_1548;
BgL_carzd2252zd2_1547 = 
CAR(BgL_cdrzd2249zd2_1543); 
BgL_cdrzd2253zd2_1548 = 
CDR(BgL_cdrzd2249zd2_1543); 
if(
SYMBOLP(BgL_carzd2252zd2_1547))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd2253zd2_1548))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_carzd2257zd2_1551;
BgL_carzd2257zd2_1551 = 
CAR(BgL_cdrzd2253zd2_1548); 
if(
SYMBOLP(BgL_carzd2257zd2_1551))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd2253zd2_1548)))
{ 
BgL_ev_globalz00_bglt BgL_auxz00_5070;
BgL_idz00_1463 = BgL_carzd2252zd2_1547; 
BgL_modnamez00_1464 = BgL_carzd2257zd2_1551; 
{ /* Eval/evaluate.scm 437 */
BgL_ev_globalz00_bglt BgL_new1106z00_2323;
{ /* Eval/evaluate.scm 438 */
BgL_ev_globalz00_bglt BgL_new1105z00_2324;
BgL_new1105z00_2324 = 
((BgL_ev_globalz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_globalz00_bgl) ))); 
{ /* Eval/evaluate.scm 438 */
long BgL_arg2196z00_2325;
{ /* Eval/evaluate.scm 438 */
long BgL_res2726z00_3337;
BgL_res2726z00_3337 = 
BGL_CLASS_INDEX(BGl_ev_globalz00zz__evaluate_typesz00); 
BgL_arg2196z00_2325 = BgL_res2726z00_3337; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1105z00_2324), BgL_arg2196z00_2325); } 
BgL_new1106z00_2323 = BgL_new1105z00_2324; } 
((((BgL_ev_globalz00_bglt)COBJECT(BgL_new1106z00_2323))->BgL_locz00)=((obj_t)BgL_locz00_74),BUNSPEC); 
((((BgL_ev_globalz00_bglt)COBJECT(BgL_new1106z00_2323))->BgL_namez00)=((obj_t)BgL_idz00_1463),BUNSPEC); 
((((BgL_ev_globalz00_bglt)COBJECT(BgL_new1106z00_2323))->BgL_modz00)=((obj_t)
BGl_evalzd2findzd2modulez00zz__evmodulez00(BgL_modnamez00_1464)),BUNSPEC); 
BgL_auxz00_5070 = BgL_new1106z00_2323; } 
return 
((obj_t)BgL_auxz00_5070);}  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_carzd2302zd2_1555;
BgL_carzd2302zd2_1555 = 
CAR(BgL_ez00_69); 
if(
SYMBOLP(BgL_carzd2302zd2_1555))
{ /* Eval/evaluate.scm 424 */
if(
CBOOL(
BGl_convzd2varzd2zz__evaluatez00(BgL_carzd2302zd2_1555, BgL_localsz00_70)))
{ 
BgL_ev_appz00_bglt BgL_auxz00_5086;
BgL_funz00_1468 = BgL_carzd2302zd2_1555; 
BgL_argsz00_1469 = BgL_cdrzd2249zd2_1543; 
BgL_tagzd2152zd2_1470:
{ /* Eval/evaluate.scm 449 */
obj_t BgL_funz00_2352;obj_t BgL_argsz00_2353;
BgL_funz00_2352 = 
BGl_uconvze70ze7zz__evaluatez00(BgL_locz00_74, BgL_wherez00_73, BgL_globalsz00_71, BgL_localsz00_70, BgL_funz00_1468); 
BgL_argsz00_2353 = 
BGl_loopze70ze7zz__evaluatez00(BgL_wherez00_73, BgL_globalsz00_71, BgL_localsz00_70, BgL_locz00_74, BgL_argsz00_1469); 
{ /* Eval/evaluate.scm 450 */
BgL_ev_appz00_bglt BgL_new1108z00_2354;
{ /* Eval/evaluate.scm 451 */
BgL_ev_appz00_bglt BgL_new1107z00_2355;
BgL_new1107z00_2355 = 
((BgL_ev_appz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_appz00_bgl) ))); 
{ /* Eval/evaluate.scm 451 */
long BgL_arg2210z00_2356;
{ /* Eval/evaluate.scm 451 */
long BgL_res2731z00_3348;
BgL_res2731z00_3348 = 
BGL_CLASS_INDEX(BGl_ev_appz00zz__evaluate_typesz00); 
BgL_arg2210z00_2356 = BgL_res2731z00_3348; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1107z00_2355), BgL_arg2210z00_2356); } 
BgL_new1108z00_2354 = BgL_new1107z00_2355; } 
((((BgL_ev_appz00_bglt)COBJECT(BgL_new1108z00_2354))->BgL_locz00)=((obj_t)BgL_locz00_74),BUNSPEC); 
((((BgL_ev_appz00_bglt)COBJECT(BgL_new1108z00_2354))->BgL_funz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_funz00_2352)),BUNSPEC); 
((((BgL_ev_appz00_bglt)COBJECT(BgL_new1108z00_2354))->BgL_argsz00)=((obj_t)BgL_argsz00_2353),BUNSPEC); 
((((BgL_ev_appz00_bglt)COBJECT(BgL_new1108z00_2354))->BgL_tailzf3zf3)=((obj_t)BgL_tailzf3zf3_72),BUNSPEC); 
BgL_auxz00_5086 = BgL_new1108z00_2354; } } 
return 
((obj_t)BgL_auxz00_5086);}  else 
{ 
BgL_ev_appz00_bglt BgL_auxz00_5099;
BgL_fz00_1534 = BgL_carzd2302zd2_1555; 
BgL_argsz00_1535 = BgL_cdrzd2249zd2_1543; 
BgL_tagzd2175zd2_1536:
{ /* Eval/evaluate.scm 597 */
obj_t BgL_funz00_2618;obj_t BgL_argsz00_2619;
BgL_funz00_2618 = 
BGl_uconvze70ze7zz__evaluatez00(BgL_locz00_74, BgL_wherez00_73, BgL_globalsz00_71, BgL_localsz00_70, BgL_fz00_1534); 
BgL_argsz00_2619 = 
BGl_loopze70ze7zz__evaluatez00(BgL_wherez00_73, BgL_globalsz00_71, BgL_localsz00_70, BgL_locz00_74, BgL_argsz00_1535); 
{ /* Eval/evaluate.scm 598 */
BgL_ev_appz00_bglt BgL_new1156z00_2620;
{ /* Eval/evaluate.scm 599 */
BgL_ev_appz00_bglt BgL_new1155z00_2621;
BgL_new1155z00_2621 = 
((BgL_ev_appz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_appz00_bgl) ))); 
{ /* Eval/evaluate.scm 599 */
long BgL_arg2330z00_2622;
{ /* Eval/evaluate.scm 599 */
long BgL_res2795z00_3558;
BgL_res2795z00_3558 = 
BGL_CLASS_INDEX(BGl_ev_appz00zz__evaluate_typesz00); 
BgL_arg2330z00_2622 = BgL_res2795z00_3558; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1155z00_2621), BgL_arg2330z00_2622); } 
BgL_new1156z00_2620 = BgL_new1155z00_2621; } 
((((BgL_ev_appz00_bglt)COBJECT(BgL_new1156z00_2620))->BgL_locz00)=((obj_t)BgL_locz00_74),BUNSPEC); 
((((BgL_ev_appz00_bglt)COBJECT(BgL_new1156z00_2620))->BgL_funz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_funz00_2618)),BUNSPEC); 
((((BgL_ev_appz00_bglt)COBJECT(BgL_new1156z00_2620))->BgL_argsz00)=((obj_t)BgL_argsz00_2619),BUNSPEC); 
((((BgL_ev_appz00_bglt)COBJECT(BgL_new1156z00_2620))->BgL_tailzf3zf3)=((obj_t)BgL_tailzf3zf3_72),BUNSPEC); 
BgL_auxz00_5099 = BgL_new1156z00_2620; } } 
return 
((obj_t)BgL_auxz00_5099);} }  else 
{ 
BgL_ev_appz00_bglt BgL_auxz00_5112;
{ 
obj_t BgL_argsz00_5114;obj_t BgL_fz00_5113;
BgL_fz00_5113 = BgL_carzd2302zd2_1555; 
BgL_argsz00_5114 = BgL_cdrzd2249zd2_1543; 
BgL_argsz00_1535 = BgL_argsz00_5114; 
BgL_fz00_1534 = BgL_fz00_5113; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_5112);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_carzd21005zd2_1566;
BgL_carzd21005zd2_1566 = 
CAR(BgL_ez00_69); 
if(
SYMBOLP(BgL_carzd21005zd2_1566))
{ /* Eval/evaluate.scm 424 */
if(
CBOOL(
BGl_convzd2varzd2zz__evaluatez00(BgL_carzd21005zd2_1566, BgL_localsz00_70)))
{ 
BgL_ev_appz00_bglt BgL_auxz00_5122;
{ 
obj_t BgL_argsz00_5124;obj_t BgL_funz00_5123;
BgL_funz00_5123 = BgL_carzd21005zd2_1566; 
BgL_argsz00_5124 = BgL_cdrzd2249zd2_1543; 
BgL_argsz00_1469 = BgL_argsz00_5124; 
BgL_funz00_1468 = BgL_funz00_5123; 
goto BgL_tagzd2152zd2_1470;} 
return 
((obj_t)BgL_auxz00_5122);}  else 
{ 
BgL_ev_appz00_bglt BgL_auxz00_5126;
{ 
obj_t BgL_argsz00_5128;obj_t BgL_fz00_5127;
BgL_fz00_5127 = BgL_carzd21005zd2_1566; 
BgL_argsz00_5128 = BgL_cdrzd2249zd2_1543; 
BgL_argsz00_1535 = BgL_argsz00_5128; 
BgL_fz00_1534 = BgL_fz00_5127; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_5126);} }  else 
{ 
BgL_ev_appz00_bglt BgL_auxz00_5130;
{ 
obj_t BgL_argsz00_5132;obj_t BgL_fz00_5131;
BgL_fz00_5131 = BgL_carzd21005zd2_1566; 
BgL_argsz00_5132 = BgL_cdrzd2249zd2_1543; 
BgL_argsz00_1535 = BgL_argsz00_5132; 
BgL_fz00_1534 = BgL_fz00_5131; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_5130);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_carzd21708zd2_1576;
BgL_carzd21708zd2_1576 = 
CAR(BgL_ez00_69); 
if(
SYMBOLP(BgL_carzd21708zd2_1576))
{ /* Eval/evaluate.scm 424 */
if(
CBOOL(
BGl_convzd2varzd2zz__evaluatez00(BgL_carzd21708zd2_1576, BgL_localsz00_70)))
{ 
BgL_ev_appz00_bglt BgL_auxz00_5140;
{ 
obj_t BgL_argsz00_5142;obj_t BgL_funz00_5141;
BgL_funz00_5141 = BgL_carzd21708zd2_1576; 
BgL_argsz00_5142 = BgL_cdrzd2249zd2_1543; 
BgL_argsz00_1469 = BgL_argsz00_5142; 
BgL_funz00_1468 = BgL_funz00_5141; 
goto BgL_tagzd2152zd2_1470;} 
return 
((obj_t)BgL_auxz00_5140);}  else 
{ 
BgL_ev_appz00_bglt BgL_auxz00_5144;
{ 
obj_t BgL_argsz00_5146;obj_t BgL_fz00_5145;
BgL_fz00_5145 = BgL_carzd21708zd2_1576; 
BgL_argsz00_5146 = BgL_cdrzd2249zd2_1543; 
BgL_argsz00_1535 = BgL_argsz00_5146; 
BgL_fz00_1534 = BgL_fz00_5145; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_5144);} }  else 
{ 
BgL_ev_appz00_bglt BgL_auxz00_5148;
{ 
obj_t BgL_argsz00_5150;obj_t BgL_fz00_5149;
BgL_fz00_5149 = BgL_carzd21708zd2_1576; 
BgL_argsz00_5150 = BgL_cdrzd2249zd2_1543; 
BgL_argsz00_1535 = BgL_argsz00_5150; 
BgL_fz00_1534 = BgL_fz00_5149; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_5148);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_carzd22411zd2_1586;
BgL_carzd22411zd2_1586 = 
CAR(BgL_ez00_69); 
if(
SYMBOLP(BgL_carzd22411zd2_1586))
{ /* Eval/evaluate.scm 424 */
if(
CBOOL(
BGl_convzd2varzd2zz__evaluatez00(BgL_carzd22411zd2_1586, BgL_localsz00_70)))
{ 
BgL_ev_appz00_bglt BgL_auxz00_5158;
{ 
obj_t BgL_argsz00_5160;obj_t BgL_funz00_5159;
BgL_funz00_5159 = BgL_carzd22411zd2_1586; 
BgL_argsz00_5160 = BgL_cdrzd2249zd2_1543; 
BgL_argsz00_1469 = BgL_argsz00_5160; 
BgL_funz00_1468 = BgL_funz00_5159; 
goto BgL_tagzd2152zd2_1470;} 
return 
((obj_t)BgL_auxz00_5158);}  else 
{ 
BgL_ev_appz00_bglt BgL_auxz00_5162;
{ 
obj_t BgL_argsz00_5164;obj_t BgL_fz00_5163;
BgL_fz00_5163 = BgL_carzd22411zd2_1586; 
BgL_argsz00_5164 = BgL_cdrzd2249zd2_1543; 
BgL_argsz00_1535 = BgL_argsz00_5164; 
BgL_fz00_1534 = BgL_fz00_5163; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_5162);} }  else 
{ 
BgL_ev_appz00_bglt BgL_auxz00_5166;
{ 
obj_t BgL_argsz00_5168;obj_t BgL_fz00_5167;
BgL_fz00_5167 = BgL_carzd22411zd2_1586; 
BgL_argsz00_5168 = BgL_cdrzd2249zd2_1543; 
BgL_argsz00_1535 = BgL_argsz00_5168; 
BgL_fz00_1534 = BgL_fz00_5167; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_5166);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_carzd23114zd2_1596;
BgL_carzd23114zd2_1596 = 
CAR(BgL_ez00_69); 
if(
SYMBOLP(BgL_carzd23114zd2_1596))
{ /* Eval/evaluate.scm 424 */
if(
CBOOL(
BGl_convzd2varzd2zz__evaluatez00(BgL_carzd23114zd2_1596, BgL_localsz00_70)))
{ 
BgL_ev_appz00_bglt BgL_auxz00_5176;
{ 
obj_t BgL_argsz00_5178;obj_t BgL_funz00_5177;
BgL_funz00_5177 = BgL_carzd23114zd2_1596; 
BgL_argsz00_5178 = BgL_cdrzd2249zd2_1543; 
BgL_argsz00_1469 = BgL_argsz00_5178; 
BgL_funz00_1468 = BgL_funz00_5177; 
goto BgL_tagzd2152zd2_1470;} 
return 
((obj_t)BgL_auxz00_5176);}  else 
{ 
BgL_ev_appz00_bglt BgL_auxz00_5180;
{ 
obj_t BgL_argsz00_5182;obj_t BgL_fz00_5181;
BgL_fz00_5181 = BgL_carzd23114zd2_1596; 
BgL_argsz00_5182 = BgL_cdrzd2249zd2_1543; 
BgL_argsz00_1535 = BgL_argsz00_5182; 
BgL_fz00_1534 = BgL_fz00_5181; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_5180);} }  else 
{ 
BgL_ev_appz00_bglt BgL_auxz00_5184;
{ 
obj_t BgL_argsz00_5186;obj_t BgL_fz00_5185;
BgL_fz00_5185 = BgL_carzd23114zd2_1596; 
BgL_argsz00_5186 = BgL_cdrzd2249zd2_1543; 
BgL_argsz00_1535 = BgL_argsz00_5186; 
BgL_fz00_1534 = BgL_fz00_5185; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_5184);} } }  else 
{ /* Eval/evaluate.scm 424 */
if(
(
CAR(BgL_ez00_69)==BGl_symbol3081z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
BgL_lz00_1466 = BgL_cdrzd2249zd2_1543; 
{ /* Eval/evaluate.scm 442 */
bool_t BgL_test3258z00_5191;
if(
PAIRP(BgL_lz00_1466))
{ /* Eval/evaluate.scm 442 */
bool_t BgL_test3260z00_5194;
{ /* Eval/evaluate.scm 442 */
obj_t BgL_tmpz00_5195;
BgL_tmpz00_5195 = 
CDR(BgL_lz00_1466); 
BgL_test3260z00_5194 = 
PAIRP(BgL_tmpz00_5195); } 
if(BgL_test3260z00_5194)
{ 
obj_t BgL_l1205z00_2343;
BgL_l1205z00_2343 = BgL_lz00_1466; 
BgL_zc3z04anonymousza32206ze3z87_2344:
if(
NULLP(BgL_l1205z00_2343))
{ /* Eval/evaluate.scm 442 */
BgL_test3258z00_5191 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate.scm 442 */
bool_t BgL_test3262z00_5200;
{ /* Eval/evaluate.scm 442 */
obj_t BgL_tmpz00_5201;
BgL_tmpz00_5201 = 
CAR(
((obj_t)BgL_l1205z00_2343)); 
BgL_test3262z00_5200 = 
SYMBOLP(BgL_tmpz00_5201); } 
if(BgL_test3262z00_5200)
{ 
obj_t BgL_l1205z00_5205;
BgL_l1205z00_5205 = 
CDR(
((obj_t)BgL_l1205z00_2343)); 
BgL_l1205z00_2343 = BgL_l1205z00_5205; 
goto BgL_zc3z04anonymousza32206ze3z87_2344;}  else 
{ /* Eval/evaluate.scm 442 */
BgL_test3258z00_5191 = ((bool_t)0)
; } } }  else 
{ /* Eval/evaluate.scm 442 */
BgL_test3258z00_5191 = ((bool_t)0)
; } }  else 
{ /* Eval/evaluate.scm 442 */
BgL_test3258z00_5191 = ((bool_t)0)
; } 
if(BgL_test3258z00_5191)
{ /* Eval/evaluate.scm 442 */
return 
BGl_convzd2fieldzd2refz00zz__evaluatez00(BgL_ez00_69, BgL_localsz00_70, BgL_globalsz00_71, BgL_tailzf3zf3_72, BgL_wherez00_73, BgL_locz00_74, BgL_topzf3zf3_75);}  else 
{ /* Eval/evaluate.scm 442 */
return 
BGl_evcompilezd2errorzd2zz__evcompilez00(BgL_locz00_74, BGl_string2994z00zz__evaluatez00, BGl_string3071z00zz__evaluatez00, BgL_ez00_69);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_carzd23820zd2_1609;
BgL_carzd23820zd2_1609 = 
CAR(BgL_ez00_69); 
if(
SYMBOLP(BgL_carzd23820zd2_1609))
{ /* Eval/evaluate.scm 424 */
if(
CBOOL(
BGl_convzd2varzd2zz__evaluatez00(BgL_carzd23820zd2_1609, BgL_localsz00_70)))
{ 
BgL_ev_appz00_bglt BgL_auxz00_5216;
{ 
obj_t BgL_argsz00_5218;obj_t BgL_funz00_5217;
BgL_funz00_5217 = BgL_carzd23820zd2_1609; 
BgL_argsz00_5218 = BgL_cdrzd2249zd2_1543; 
BgL_argsz00_1469 = BgL_argsz00_5218; 
BgL_funz00_1468 = BgL_funz00_5217; 
goto BgL_tagzd2152zd2_1470;} 
return 
((obj_t)BgL_auxz00_5216);}  else 
{ /* Eval/evaluate.scm 424 */
if(
(BgL_carzd23820zd2_1609==BGl_symbol3083z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd2249zd2_1543))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd2249zd2_1543)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1605z00_1620;
BgL_arg1605z00_1620 = 
CAR(BgL_cdrzd2249zd2_1543); 
{ 
BgL_ev_trapz00_bglt BgL_auxz00_5228;
BgL_ez00_1471 = BgL_arg1605z00_1620; 
BgL_tagzd2153zd2_1472:
{ /* Eval/evaluate.scm 456 */
BgL_ev_trapz00_bglt BgL_new1110z00_2357;
{ /* Eval/evaluate.scm 457 */
BgL_ev_trapz00_bglt BgL_new1109z00_2358;
BgL_new1109z00_2358 = 
((BgL_ev_trapz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_trapz00_bgl) ))); 
{ /* Eval/evaluate.scm 457 */
long BgL_arg2211z00_2359;
{ /* Eval/evaluate.scm 457 */
long BgL_res2732z00_3352;
BgL_res2732z00_3352 = 
BGL_CLASS_INDEX(BGl_ev_trapz00zz__evaluate_typesz00); 
BgL_arg2211z00_2359 = BgL_res2732z00_3352; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1109z00_2358), BgL_arg2211z00_2359); } 
BgL_new1110z00_2357 = BgL_new1109z00_2358; } 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)BgL_new1110z00_2357)))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)
BGl_uconvze70ze7zz__evaluatez00(BgL_locz00_74, BgL_wherez00_73, BgL_globalsz00_71, BgL_localsz00_70, BgL_ez00_1471))),BUNSPEC); 
BgL_auxz00_5228 = BgL_new1110z00_2357; } 
return 
((obj_t)BgL_auxz00_5228);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1606z00_1621;obj_t BgL_arg1607z00_1622;
BgL_arg1606z00_1621 = 
CAR(BgL_ez00_69); 
BgL_arg1607z00_1622 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_5240;
{ 
obj_t BgL_argsz00_5242;obj_t BgL_fz00_5241;
BgL_fz00_5241 = BgL_arg1606z00_1621; 
BgL_argsz00_5242 = BgL_arg1607z00_1622; 
BgL_argsz00_1535 = BgL_argsz00_5242; 
BgL_fz00_1534 = BgL_fz00_5241; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_5240);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1611z00_1624;obj_t BgL_arg1612z00_1625;
BgL_arg1611z00_1624 = 
CAR(BgL_ez00_69); 
BgL_arg1612z00_1625 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_5246;
{ 
obj_t BgL_argsz00_5248;obj_t BgL_fz00_5247;
BgL_fz00_5247 = BgL_arg1611z00_1624; 
BgL_argsz00_5248 = BgL_arg1612z00_1625; 
BgL_argsz00_1535 = BgL_argsz00_5248; 
BgL_fz00_1534 = BgL_fz00_5247; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_5246);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd24489zd2_1626;
BgL_cdrzd24489zd2_1626 = 
CDR(BgL_ez00_69); 
if(
(
CAR(BgL_ez00_69)==BGl_symbol3046z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd24489zd2_1626))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd24489zd2_1626)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1618z00_1632;
BgL_arg1618z00_1632 = 
CAR(BgL_cdrzd24489zd2_1626); 
{ 
BgL_ev_littz00_bglt BgL_auxz00_5260;
BgL_vz00_1473 = BgL_arg1618z00_1632; 
BgL_tagzd2154zd2_1474:
{ /* Eval/evaluate.scm 459 */
BgL_ev_littz00_bglt BgL_new1112z00_2360;
{ /* Eval/evaluate.scm 460 */
BgL_ev_littz00_bglt BgL_new1111z00_2361;
BgL_new1111z00_2361 = 
((BgL_ev_littz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_littz00_bgl) ))); 
{ /* Eval/evaluate.scm 460 */
long BgL_arg2212z00_2362;
{ /* Eval/evaluate.scm 460 */
long BgL_res2733z00_3356;
BgL_res2733z00_3356 = 
BGL_CLASS_INDEX(BGl_ev_littz00zz__evaluate_typesz00); 
BgL_arg2212z00_2362 = BgL_res2733z00_3356; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1111z00_2361), BgL_arg2212z00_2362); } 
BgL_new1112z00_2360 = BgL_new1111z00_2361; } 
((((BgL_ev_littz00_bglt)COBJECT(BgL_new1112z00_2360))->BgL_valuez00)=((obj_t)BgL_vz00_1473),BUNSPEC); 
BgL_auxz00_5260 = BgL_new1112z00_2360; } 
return 
((obj_t)BgL_auxz00_5260);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1619z00_1633;
BgL_arg1619z00_1633 = 
CAR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_5268;
{ 
obj_t BgL_argsz00_5270;obj_t BgL_fz00_5269;
BgL_fz00_5269 = BgL_arg1619z00_1633; 
BgL_argsz00_5270 = BgL_cdrzd24489zd2_1626; 
BgL_argsz00_1535 = BgL_argsz00_5270; 
BgL_fz00_1534 = BgL_fz00_5269; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_5268);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1622z00_1636;
BgL_arg1622z00_1636 = 
CAR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_5273;
{ 
obj_t BgL_argsz00_5275;obj_t BgL_fz00_5274;
BgL_fz00_5274 = BgL_arg1622z00_1636; 
BgL_argsz00_5275 = BgL_cdrzd24489zd2_1626; 
BgL_argsz00_1535 = BgL_argsz00_5275; 
BgL_fz00_1534 = BgL_fz00_5274; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_5273);} } }  else 
{ /* Eval/evaluate.scm 424 */
if(
(
CAR(BgL_ez00_69)==BGl_symbol3054z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd24489zd2_1626))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd25099zd2_1642;
BgL_cdrzd25099zd2_1642 = 
CDR(BgL_cdrzd24489zd2_1626); 
if(
PAIRP(BgL_cdrzd25099zd2_1642))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd25104zd2_1644;
BgL_cdrzd25104zd2_1644 = 
CDR(BgL_cdrzd25099zd2_1642); 
if(
PAIRP(BgL_cdrzd25104zd2_1644))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd25104zd2_1644)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1633z00_1648;obj_t BgL_arg1634z00_1649;obj_t BgL_arg1638z00_1650;
BgL_arg1633z00_1648 = 
CAR(BgL_cdrzd24489zd2_1626); 
BgL_arg1634z00_1649 = 
CAR(BgL_cdrzd25099zd2_1642); 
BgL_arg1638z00_1650 = 
CAR(BgL_cdrzd25104zd2_1644); 
{ 
BgL_ev_ifz00_bglt BgL_auxz00_5294;
BgL_pz00_1475 = BgL_arg1633z00_1648; 
BgL_tz00_1476 = BgL_arg1634z00_1649; 
BgL_oz00_1477 = BgL_arg1638z00_1650; 
BgL_tagzd2155zd2_1478:
{ /* Eval/evaluate.scm 462 */
BgL_ev_ifz00_bglt BgL_new1114z00_2363;
{ /* Eval/evaluate.scm 463 */
BgL_ev_ifz00_bglt BgL_new1113z00_2367;
BgL_new1113z00_2367 = 
((BgL_ev_ifz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_ifz00_bgl) ))); 
{ /* Eval/evaluate.scm 463 */
long BgL_arg2216z00_2368;
{ /* Eval/evaluate.scm 463 */
long BgL_res2734z00_3360;
BgL_res2734z00_3360 = 
BGL_CLASS_INDEX(BGl_ev_ifz00zz__evaluate_typesz00); 
BgL_arg2216z00_2368 = BgL_res2734z00_3360; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1113z00_2367), BgL_arg2216z00_2368); } 
BgL_new1114z00_2363 = BgL_new1113z00_2367; } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5299;
{ /* Eval/evaluate.scm 463 */
obj_t BgL_arg2213z00_2364;
BgL_arg2213z00_2364 = 
BGl_getzd2locationzd2zz__evaluatez00(BgL_pz00_1475, BgL_locz00_74); 
BgL_auxz00_5299 = 
((BgL_ev_exprz00_bglt)
BGl_uconvzf2locze70z15zz__evaluatez00(BgL_wherez00_73, BgL_globalsz00_71, BgL_localsz00_70, BgL_pz00_1475, BgL_arg2213z00_2364)); } 
((((BgL_ev_ifz00_bglt)COBJECT(BgL_new1114z00_2363))->BgL_pz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5299),BUNSPEC); } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5304;
{ /* Eval/evaluate.scm 464 */
obj_t BgL_arg2214z00_2365;
BgL_arg2214z00_2365 = 
BGl_getzd2locationzd2zz__evaluatez00(BgL_tz00_1476, BgL_locz00_74); 
BgL_auxz00_5304 = 
((BgL_ev_exprz00_bglt)
BGl_rconvzf2locze70z15zz__evaluatez00(BgL_wherez00_73, BgL_tailzf3zf3_72, BgL_globalsz00_71, BgL_localsz00_70, BgL_tz00_1476, BgL_arg2214z00_2365)); } 
((((BgL_ev_ifz00_bglt)COBJECT(BgL_new1114z00_2363))->BgL_tz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5304),BUNSPEC); } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5309;
{ /* Eval/evaluate.scm 465 */
obj_t BgL_arg2215z00_2366;
BgL_arg2215z00_2366 = 
BGl_getzd2locationzd2zz__evaluatez00(BgL_oz00_1477, BgL_locz00_74); 
BgL_auxz00_5309 = 
((BgL_ev_exprz00_bglt)
BGl_rconvzf2locze70z15zz__evaluatez00(BgL_wherez00_73, BgL_tailzf3zf3_72, BgL_globalsz00_71, BgL_localsz00_70, BgL_oz00_1477, BgL_arg2215z00_2366)); } 
((((BgL_ev_ifz00_bglt)COBJECT(BgL_new1114z00_2363))->BgL_ez00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5309),BUNSPEC); } 
BgL_auxz00_5294 = BgL_new1114z00_2363; } 
return 
((obj_t)BgL_auxz00_5294);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1639z00_1651;obj_t BgL_arg1640z00_1652;
BgL_arg1639z00_1651 = 
CAR(BgL_ez00_69); 
BgL_arg1640z00_1652 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_5317;
{ 
obj_t BgL_argsz00_5319;obj_t BgL_fz00_5318;
BgL_fz00_5318 = BgL_arg1639z00_1651; 
BgL_argsz00_5319 = BgL_arg1640z00_1652; 
BgL_argsz00_1535 = BgL_argsz00_5319; 
BgL_fz00_1534 = BgL_fz00_5318; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_5317);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd25402zd2_1654;
BgL_cdrzd25402zd2_1654 = 
CDR(BgL_ez00_69); 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd25408zd2_1655;
BgL_cdrzd25408zd2_1655 = 
CDR(
((obj_t)BgL_cdrzd25402zd2_1654)); 
if(
NULLP(
CDR(
((obj_t)BgL_cdrzd25408zd2_1655))))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1646z00_1658;obj_t BgL_arg1647z00_1659;
BgL_arg1646z00_1658 = 
CAR(
((obj_t)BgL_cdrzd25402zd2_1654)); 
BgL_arg1647z00_1659 = 
CAR(
((obj_t)BgL_cdrzd25408zd2_1655)); 
{ 
BgL_ev_ifz00_bglt BgL_auxz00_5332;
BgL_pz00_1479 = BgL_arg1646z00_1658; 
BgL_tz00_1480 = BgL_arg1647z00_1659; 
BgL_tagzd2156zd2_1481:
{ /* Eval/evaluate.scm 467 */
BgL_ev_ifz00_bglt BgL_new1116z00_2369;
{ /* Eval/evaluate.scm 468 */
BgL_ev_ifz00_bglt BgL_new1115z00_2373;
BgL_new1115z00_2373 = 
((BgL_ev_ifz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_ifz00_bgl) ))); 
{ /* Eval/evaluate.scm 468 */
long BgL_arg2220z00_2374;
{ /* Eval/evaluate.scm 468 */
long BgL_res2735z00_3364;
BgL_res2735z00_3364 = 
BGL_CLASS_INDEX(BGl_ev_ifz00zz__evaluate_typesz00); 
BgL_arg2220z00_2374 = BgL_res2735z00_3364; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1115z00_2373), BgL_arg2220z00_2374); } 
BgL_new1116z00_2369 = BgL_new1115z00_2373; } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5337;
{ /* Eval/evaluate.scm 468 */
obj_t BgL_arg2217z00_2370;
BgL_arg2217z00_2370 = 
BGl_getzd2locationzd2zz__evaluatez00(BgL_pz00_1479, BgL_locz00_74); 
BgL_auxz00_5337 = 
((BgL_ev_exprz00_bglt)
BGl_uconvzf2locze70z15zz__evaluatez00(BgL_wherez00_73, BgL_globalsz00_71, BgL_localsz00_70, BgL_pz00_1479, BgL_arg2217z00_2370)); } 
((((BgL_ev_ifz00_bglt)COBJECT(BgL_new1116z00_2369))->BgL_pz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5337),BUNSPEC); } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5342;
{ /* Eval/evaluate.scm 469 */
obj_t BgL_arg2218z00_2371;
BgL_arg2218z00_2371 = 
BGl_getzd2locationzd2zz__evaluatez00(BgL_tz00_1480, BgL_locz00_74); 
BgL_auxz00_5342 = 
((BgL_ev_exprz00_bglt)
BGl_rconvzf2locze70z15zz__evaluatez00(BgL_wherez00_73, BgL_tailzf3zf3_72, BgL_globalsz00_71, BgL_localsz00_70, BgL_tz00_1480, BgL_arg2218z00_2371)); } 
((((BgL_ev_ifz00_bglt)COBJECT(BgL_new1116z00_2369))->BgL_tz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5342),BUNSPEC); } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5347;
{ /* Eval/evaluate.scm 470 */
obj_t BgL_arg2219z00_2372;
BgL_arg2219z00_2372 = 
BGl_getzd2locationzd2zz__evaluatez00(BFALSE, BgL_locz00_74); 
BgL_auxz00_5347 = 
((BgL_ev_exprz00_bglt)
BGl_rconvzf2locze70z15zz__evaluatez00(BgL_wherez00_73, BgL_tailzf3zf3_72, BgL_globalsz00_71, BgL_localsz00_70, BgL_ez00_69, BgL_arg2219z00_2372)); } 
((((BgL_ev_ifz00_bglt)COBJECT(BgL_new1116z00_2369))->BgL_ez00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5347),BUNSPEC); } 
BgL_auxz00_5332 = BgL_new1116z00_2369; } 
return 
((obj_t)BgL_auxz00_5332);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1648z00_1660;
BgL_arg1648z00_1660 = 
CAR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_5354;
{ 
obj_t BgL_argsz00_5356;obj_t BgL_fz00_5355;
BgL_fz00_5355 = BgL_arg1648z00_1660; 
BgL_argsz00_5356 = BgL_cdrzd25402zd2_1654; 
BgL_argsz00_1535 = BgL_argsz00_5356; 
BgL_fz00_1534 = BgL_fz00_5355; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_5354);} } } } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1652z00_1663;obj_t BgL_arg1653z00_1664;
BgL_arg1652z00_1663 = 
CAR(BgL_ez00_69); 
BgL_arg1653z00_1664 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_5360;
{ 
obj_t BgL_argsz00_5362;obj_t BgL_fz00_5361;
BgL_fz00_5361 = BgL_arg1652z00_1663; 
BgL_argsz00_5362 = BgL_arg1653z00_1664; 
BgL_argsz00_1535 = BgL_argsz00_5362; 
BgL_fz00_1534 = BgL_fz00_5361; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_5360);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1655z00_1665;obj_t BgL_arg1656z00_1666;
BgL_arg1655z00_1665 = 
CAR(BgL_ez00_69); 
BgL_arg1656z00_1666 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_5366;
{ 
obj_t BgL_argsz00_5368;obj_t BgL_fz00_5367;
BgL_fz00_5367 = BgL_arg1655z00_1665; 
BgL_argsz00_5368 = BgL_arg1656z00_1666; 
BgL_argsz00_1535 = BgL_argsz00_5368; 
BgL_fz00_1534 = BgL_fz00_5367; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_5366);} } }  else 
{ /* Eval/evaluate.scm 424 */
if(
(
CAR(BgL_ez00_69)==BGl_symbol3085z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1659z00_1669;
BgL_arg1659z00_1669 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_orz00_bglt BgL_auxz00_5374;
BgL_argsz00_1482 = BgL_arg1659z00_1669; 
BgL_tagzd2157zd2_1483:
{ /* Eval/evaluate.scm 472 */
BgL_ev_orz00_bglt BgL_new1118z00_2375;
{ /* Eval/evaluate.scm 473 */
BgL_ev_orz00_bglt BgL_new1117z00_2376;
BgL_new1117z00_2376 = 
((BgL_ev_orz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_orz00_bgl) ))); 
{ /* Eval/evaluate.scm 473 */
long BgL_arg2221z00_2377;
{ /* Eval/evaluate.scm 473 */
long BgL_res2736z00_3368;
BgL_res2736z00_3368 = 
BGL_CLASS_INDEX(BGl_ev_orz00zz__evaluate_typesz00); 
BgL_arg2221z00_2377 = BgL_res2736z00_3368; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1117z00_2376), BgL_arg2221z00_2377); } 
BgL_new1118z00_2375 = BgL_new1117z00_2376; } 
((((BgL_ev_listz00_bglt)COBJECT(
((BgL_ev_listz00_bglt)BgL_new1118z00_2375)))->BgL_argsz00)=((obj_t)
BGl_loopze70ze7zz__evaluatez00(BgL_wherez00_73, BgL_globalsz00_71, BgL_localsz00_70, BgL_locz00_74, BgL_argsz00_1482)),BUNSPEC); 
BgL_auxz00_5374 = BgL_new1118z00_2375; } 
return 
((obj_t)BgL_auxz00_5374);} }  else 
{ /* Eval/evaluate.scm 424 */
if(
(
CAR(BgL_ez00_69)==BGl_symbol3087z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1662z00_1672;
BgL_arg1662z00_1672 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_andz00_bglt BgL_auxz00_5387;
BgL_argsz00_1484 = BgL_arg1662z00_1672; 
BgL_tagzd2158zd2_1485:
{ /* Eval/evaluate.scm 475 */
BgL_ev_andz00_bglt BgL_new1120z00_2378;
{ /* Eval/evaluate.scm 476 */
BgL_ev_andz00_bglt BgL_new1119z00_2379;
BgL_new1119z00_2379 = 
((BgL_ev_andz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_andz00_bgl) ))); 
{ /* Eval/evaluate.scm 476 */
long BgL_arg2222z00_2380;
{ /* Eval/evaluate.scm 476 */
long BgL_res2737z00_3372;
BgL_res2737z00_3372 = 
BGL_CLASS_INDEX(BGl_ev_andz00zz__evaluate_typesz00); 
BgL_arg2222z00_2380 = BgL_res2737z00_3372; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1119z00_2379), BgL_arg2222z00_2380); } 
BgL_new1120z00_2378 = BgL_new1119z00_2379; } 
((((BgL_ev_listz00_bglt)COBJECT(
((BgL_ev_listz00_bglt)BgL_new1120z00_2378)))->BgL_argsz00)=((obj_t)
BGl_loopze70ze7zz__evaluatez00(BgL_wherez00_73, BgL_globalsz00_71, BgL_localsz00_70, BgL_locz00_74, BgL_argsz00_1484)),BUNSPEC); 
BgL_auxz00_5387 = BgL_new1120z00_2378; } 
return 
((obj_t)BgL_auxz00_5387);} }  else 
{ /* Eval/evaluate.scm 424 */
if(
(
CAR(BgL_ez00_69)==BGl_symbol3072z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
BgL_lz00_1486 = 
CDR(BgL_ez00_69); 
BgL_tagzd2159zd2_1487:
return 
BGl_convzd2beginzd2zz__evaluatez00(BgL_lz00_1486, BgL_localsz00_70, BgL_globalsz00_71, BgL_tailzf3zf3_72, BgL_wherez00_73, BgL_locz00_74, BgL_topzf3zf3_75);}  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd26301zd2_1676;
BgL_cdrzd26301zd2_1676 = 
CDR(BgL_ez00_69); 
if(
(
CAR(BgL_ez00_69)==BGl_symbol3056z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd26301zd2_1676))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1669z00_1680;obj_t BgL_arg1670z00_1681;
BgL_arg1669z00_1680 = 
CAR(BgL_cdrzd26301zd2_1676); 
BgL_arg1670z00_1681 = 
CDR(BgL_cdrzd26301zd2_1676); 
{ 
BgL_ev_letz00_bglt BgL_auxz00_5409;
BgL_bindsz00_1488 = BgL_arg1669z00_1680; 
BgL_bodyz00_1489 = BgL_arg1670z00_1681; 
BgL_tagzd2160zd2_1490:
{ /* Eval/evaluate.scm 480 */
obj_t BgL_ubindsz00_2381;
if(
NULLP(BgL_bindsz00_1488))
{ /* Eval/evaluate.scm 480 */
BgL_ubindsz00_2381 = BNIL; }  else 
{ /* Eval/evaluate.scm 480 */
obj_t BgL_head1210z00_2426;
{ /* Eval/evaluate.scm 480 */
obj_t BgL_res2739z00_3376;
BgL_res2739z00_3376 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1210z00_2426 = BgL_res2739z00_3376; } 
{ 
obj_t BgL_l1208z00_2428;obj_t BgL_tail1211z00_2429;
BgL_l1208z00_2428 = BgL_bindsz00_1488; 
BgL_tail1211z00_2429 = BgL_head1210z00_2426; 
BgL_zc3z04anonymousza32241ze3z87_2430:
if(
NULLP(BgL_l1208z00_2428))
{ /* Eval/evaluate.scm 480 */
BgL_ubindsz00_2381 = 
CDR(BgL_head1210z00_2426); }  else 
{ /* Eval/evaluate.scm 480 */
obj_t BgL_newtail1212z00_2432;
{ /* Eval/evaluate.scm 480 */
obj_t BgL_arg2244z00_2434;
{ /* Eval/evaluate.scm 480 */
obj_t BgL_bz00_2435;
BgL_bz00_2435 = 
CAR(
((obj_t)BgL_l1208z00_2428)); 
{ /* Eval/evaluate.scm 480 */
obj_t BgL_arg2245z00_2436;
BgL_arg2245z00_2436 = 
CAR(
((obj_t)BgL_bz00_2435)); 
BgL_arg2244z00_2434 = 
BGl_untypezd2identzd2zz__evaluatez00(BgL_arg2245z00_2436); } } 
{ /* Eval/evaluate.scm 480 */
obj_t BgL_res2741z00_3381;
BgL_res2741z00_3381 = 
MAKE_YOUNG_PAIR(BgL_arg2244z00_2434, BNIL); 
BgL_newtail1212z00_2432 = BgL_res2741z00_3381; } } 
SET_CDR(BgL_tail1211z00_2429, BgL_newtail1212z00_2432); 
{ /* Eval/evaluate.scm 480 */
obj_t BgL_arg2243z00_2433;
BgL_arg2243z00_2433 = 
CDR(
((obj_t)BgL_l1208z00_2428)); 
{ 
obj_t BgL_tail1211z00_5426;obj_t BgL_l1208z00_5425;
BgL_l1208z00_5425 = BgL_arg2243z00_2433; 
BgL_tail1211z00_5426 = BgL_newtail1212z00_2432; 
BgL_tail1211z00_2429 = BgL_tail1211z00_5426; 
BgL_l1208z00_2428 = BgL_l1208z00_5425; 
goto BgL_zc3z04anonymousza32241ze3z87_2430;} } } } } 
{ /* Eval/evaluate.scm 480 */
obj_t BgL_varsz00_2382;
if(
NULLP(BgL_ubindsz00_2381))
{ /* Eval/evaluate.scm 481 */
BgL_varsz00_2382 = BNIL; }  else 
{ /* Eval/evaluate.scm 481 */
obj_t BgL_head1215z00_2410;
{ /* Eval/evaluate.scm 481 */
obj_t BgL_res2743z00_3385;
BgL_res2743z00_3385 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1215z00_2410 = BgL_res2743z00_3385; } 
{ 
obj_t BgL_l1213z00_2412;obj_t BgL_tail1216z00_2413;
BgL_l1213z00_2412 = BgL_ubindsz00_2381; 
BgL_tail1216z00_2413 = BgL_head1215z00_2410; 
BgL_zc3z04anonymousza32235ze3z87_2414:
if(
NULLP(BgL_l1213z00_2412))
{ /* Eval/evaluate.scm 481 */
BgL_varsz00_2382 = 
CDR(BgL_head1215z00_2410); }  else 
{ /* Eval/evaluate.scm 481 */
obj_t BgL_newtail1217z00_2416;
{ /* Eval/evaluate.scm 481 */
BgL_ev_varz00_bglt BgL_arg2238z00_2418;
{ /* Eval/evaluate.scm 481 */
obj_t BgL_iz00_2419;
BgL_iz00_2419 = 
CAR(
((obj_t)BgL_l1213z00_2412)); 
{ /* Eval/evaluate.scm 482 */
BgL_ev_varz00_bglt BgL_new1122z00_2420;
{ /* Eval/evaluate.scm 484 */
BgL_ev_varz00_bglt BgL_new1121z00_2421;
BgL_new1121z00_2421 = 
((BgL_ev_varz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_varz00_bgl) ))); 
{ /* Eval/evaluate.scm 484 */
long BgL_arg2239z00_2422;
{ /* Eval/evaluate.scm 484 */
long BgL_res2745z00_3390;
BgL_res2745z00_3390 = 
BGL_CLASS_INDEX(BGl_ev_varz00zz__evaluate_typesz00); 
BgL_arg2239z00_2422 = BgL_res2745z00_3390; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1121z00_2421), BgL_arg2239z00_2422); } 
BgL_new1122z00_2420 = BgL_new1121z00_2421; } 
((((BgL_ev_varz00_bglt)COBJECT(BgL_new1122z00_2420))->BgL_namez00)=((obj_t)
CAR(
((obj_t)BgL_iz00_2419))),BUNSPEC); 
((((BgL_ev_varz00_bglt)COBJECT(BgL_new1122z00_2420))->BgL_effz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_ev_varz00_bglt)COBJECT(BgL_new1122z00_2420))->BgL_typez00)=((obj_t)
CDR(
((obj_t)BgL_iz00_2419))),BUNSPEC); 
BgL_arg2238z00_2418 = BgL_new1122z00_2420; } } 
{ /* Eval/evaluate.scm 481 */
obj_t BgL_res2746z00_3395;
BgL_res2746z00_3395 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg2238z00_2418), BNIL); 
BgL_newtail1217z00_2416 = BgL_res2746z00_3395; } } 
SET_CDR(BgL_tail1216z00_2413, BgL_newtail1217z00_2416); 
{ /* Eval/evaluate.scm 481 */
obj_t BgL_arg2237z00_2417;
BgL_arg2237z00_2417 = 
CDR(
((obj_t)BgL_l1213z00_2412)); 
{ 
obj_t BgL_tail1216z00_5452;obj_t BgL_l1213z00_5451;
BgL_l1213z00_5451 = BgL_arg2237z00_2417; 
BgL_tail1216z00_5452 = BgL_newtail1217z00_2416; 
BgL_tail1216z00_2413 = BgL_tail1216z00_5452; 
BgL_l1213z00_2412 = BgL_l1213z00_5451; 
goto BgL_zc3z04anonymousza32235ze3z87_2414;} } } } } 
{ /* Eval/evaluate.scm 481 */
obj_t BgL_bodyz00_2383;
{ /* Eval/evaluate.scm 486 */
bool_t BgL_test3286z00_5453;
{ /* Eval/evaluate.scm 486 */
obj_t BgL_tmpz00_5454;
BgL_tmpz00_5454 = 
CDR(
((obj_t)BgL_bodyz00_1489)); 
BgL_test3286z00_5453 = 
PAIRP(BgL_tmpz00_5454); } 
if(BgL_test3286z00_5453)
{ /* Eval/evaluate.scm 486 */
obj_t BgL_res2748z00_3401;
BgL_res2748z00_3401 = 
MAKE_YOUNG_EPAIR(BGl_symbol3072z00zz__evaluatez00, BgL_bodyz00_1489, BgL_locz00_74); 
BgL_bodyz00_2383 = BgL_res2748z00_3401; }  else 
{ /* Eval/evaluate.scm 486 */
BgL_bodyz00_2383 = 
CAR(
((obj_t)BgL_bodyz00_1489)); } } 
{ /* Eval/evaluate.scm 486 */
obj_t BgL_tbodyz00_2384;
BgL_tbodyz00_2384 = 
BGl_typezd2checkszd2zz__evaluatez00(BgL_ubindsz00_2381, BgL_bindsz00_1488, BgL_bodyz00_2383, BgL_locz00_74, BgL_wherez00_73); 
{ /* Eval/evaluate.scm 487 */

{ /* Eval/evaluate.scm 488 */
obj_t BgL_blocz00_2385;
BgL_blocz00_2385 = 
BGl_getzd2locationzd2zz__evaluatez00(BgL_bindsz00_1488, BgL_locz00_74); 
{ /* Eval/evaluate.scm 489 */
BgL_ev_letz00_bglt BgL_new1124z00_2386;
{ /* Eval/evaluate.scm 490 */
BgL_ev_letz00_bglt BgL_new1123z00_2403;
BgL_new1123z00_2403 = 
((BgL_ev_letz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_letz00_bgl) ))); 
{ /* Eval/evaluate.scm 490 */
long BgL_arg2230z00_2404;
{ /* Eval/evaluate.scm 490 */
long BgL_res2749z00_3404;
BgL_res2749z00_3404 = 
BGL_CLASS_INDEX(BGl_ev_letz00zz__evaluate_typesz00); 
BgL_arg2230z00_2404 = BgL_res2749z00_3404; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1123z00_2403), BgL_arg2230z00_2404); } 
BgL_new1124z00_2386 = BgL_new1123z00_2403; } 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1124z00_2386)))->BgL_varsz00)=((obj_t)BgL_varsz00_2382),BUNSPEC); 
{ 
obj_t BgL_auxz00_5469;
if(
NULLP(BgL_bindsz00_1488))
{ /* Eval/evaluate.scm 491 */
BgL_auxz00_5469 = BNIL
; }  else 
{ /* Eval/evaluate.scm 491 */
obj_t BgL_head1220z00_2389;
{ /* Eval/evaluate.scm 491 */
obj_t BgL_res2751z00_3408;
BgL_res2751z00_3408 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1220z00_2389 = BgL_res2751z00_3408; } 
{ 
obj_t BgL_l1218z00_2391;obj_t BgL_tail1221z00_2392;
BgL_l1218z00_2391 = BgL_bindsz00_1488; 
BgL_tail1221z00_2392 = BgL_head1220z00_2389; 
BgL_zc3z04anonymousza32224ze3z87_2393:
if(
NULLP(BgL_l1218z00_2391))
{ /* Eval/evaluate.scm 491 */
BgL_auxz00_5469 = 
CDR(BgL_head1220z00_2389)
; }  else 
{ /* Eval/evaluate.scm 491 */
obj_t BgL_newtail1222z00_2395;
{ /* Eval/evaluate.scm 491 */
obj_t BgL_arg2227z00_2397;
{ /* Eval/evaluate.scm 491 */
obj_t BgL_bz00_2398;
BgL_bz00_2398 = 
CAR(
((obj_t)BgL_l1218z00_2391)); 
{ /* Eval/evaluate.scm 492 */
obj_t BgL_locz00_2399;
BgL_locz00_2399 = 
BGl_getzd2locationzd2zz__evaluatez00(BgL_bz00_2398, BgL_blocz00_2385); 
{ /* Eval/evaluate.scm 493 */
obj_t BgL_arg2228z00_2400;
{ /* Eval/evaluate.scm 493 */
obj_t BgL_pairz00_3415;
BgL_pairz00_3415 = 
CDR(
((obj_t)BgL_bz00_2398)); 
BgL_arg2228z00_2400 = 
CAR(BgL_pairz00_3415); } 
BgL_arg2227z00_2397 = 
BGl_uconvzf2locze70z15zz__evaluatez00(BgL_wherez00_73, BgL_globalsz00_71, BgL_localsz00_70, BgL_arg2228z00_2400, BgL_locz00_2399); } } } 
{ /* Eval/evaluate.scm 491 */
obj_t BgL_res2753z00_3416;
BgL_res2753z00_3416 = 
MAKE_YOUNG_PAIR(BgL_arg2227z00_2397, BNIL); 
BgL_newtail1222z00_2395 = BgL_res2753z00_3416; } } 
SET_CDR(BgL_tail1221z00_2392, BgL_newtail1222z00_2395); 
{ /* Eval/evaluate.scm 491 */
obj_t BgL_arg2226z00_2396;
BgL_arg2226z00_2396 = 
CDR(
((obj_t)BgL_l1218z00_2391)); 
{ 
obj_t BgL_tail1221z00_5489;obj_t BgL_l1218z00_5488;
BgL_l1218z00_5488 = BgL_arg2226z00_2396; 
BgL_tail1221z00_5489 = BgL_newtail1222z00_2395; 
BgL_tail1221z00_2392 = BgL_tail1221z00_5489; 
BgL_l1218z00_2391 = BgL_l1218z00_5488; 
goto BgL_zc3z04anonymousza32224ze3z87_2393;} } } } } 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1124z00_2386)))->BgL_valsz00)=((obj_t)BgL_auxz00_5469),BUNSPEC); } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5491;
{ /* Eval/evaluate.scm 495 */
obj_t BgL_arg2229z00_2402;
BgL_arg2229z00_2402 = 
BGl_appendzd221010zd2zz__evaluatez00(BgL_varsz00_2382, BgL_localsz00_70); 
BgL_auxz00_5491 = 
((BgL_ev_exprz00_bglt)
BGl_convz00zz__evaluatez00(BgL_tbodyz00_2384, BgL_arg2229z00_2402, BgL_globalsz00_71, BgL_tailzf3zf3_72, BgL_wherez00_73, BgL_locz00_74, ((bool_t)0))); } 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1124z00_2386)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5491),BUNSPEC); } 
((((BgL_ev_letz00_bglt)COBJECT(BgL_new1124z00_2386))->BgL_boxesz00)=((obj_t)BNIL),BUNSPEC); 
BgL_auxz00_5409 = BgL_new1124z00_2386; } } } } } } } 
return 
((obj_t)BgL_auxz00_5409);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1671z00_1682;
BgL_arg1671z00_1682 = 
CAR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_5500;
{ 
obj_t BgL_argsz00_5502;obj_t BgL_fz00_5501;
BgL_fz00_5501 = BgL_arg1671z00_1682; 
BgL_argsz00_5502 = BgL_cdrzd26301zd2_1676; 
BgL_argsz00_1535 = BgL_argsz00_5502; 
BgL_fz00_1534 = BgL_fz00_5501; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_5500);} } }  else 
{ /* Eval/evaluate.scm 424 */
if(
(
CAR(BgL_ez00_69)==BGl_symbol3089z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd26301zd2_1676))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1676z00_1688;obj_t BgL_arg1677z00_1689;
BgL_arg1676z00_1688 = 
CAR(BgL_cdrzd26301zd2_1676); 
BgL_arg1677z00_1689 = 
CDR(BgL_cdrzd26301zd2_1676); 
{ 
BgL_ev_letza2za2_bglt BgL_auxz00_5511;
BgL_bindsz00_1491 = BgL_arg1676z00_1688; 
BgL_bodyz00_1492 = BgL_arg1677z00_1689; 
BgL_tagzd2161zd2_1493:
{ /* Eval/evaluate.scm 503 */
obj_t BgL_varsz00_2439;obj_t BgL_blocz00_2440;
if(
NULLP(BgL_bindsz00_1491))
{ /* Eval/evaluate.scm 503 */
BgL_varsz00_2439 = BNIL; }  else 
{ /* Eval/evaluate.scm 503 */
obj_t BgL_head1225z00_2448;
{ /* Eval/evaluate.scm 503 */
obj_t BgL_res2756z00_3431;
BgL_res2756z00_3431 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1225z00_2448 = BgL_res2756z00_3431; } 
{ 
obj_t BgL_l1223z00_2450;obj_t BgL_tail1226z00_2451;
BgL_l1223z00_2450 = BgL_bindsz00_1491; 
BgL_tail1226z00_2451 = BgL_head1225z00_2448; 
BgL_zc3z04anonymousza32250ze3z87_2452:
if(
NULLP(BgL_l1223z00_2450))
{ /* Eval/evaluate.scm 503 */
BgL_varsz00_2439 = 
CDR(BgL_head1225z00_2448); }  else 
{ /* Eval/evaluate.scm 503 */
obj_t BgL_newtail1227z00_2454;
{ /* Eval/evaluate.scm 503 */
BgL_ev_varz00_bglt BgL_arg2253z00_2456;
{ /* Eval/evaluate.scm 503 */
obj_t BgL_bz00_2457;
BgL_bz00_2457 = 
CAR(
((obj_t)BgL_l1223z00_2450)); 
{ /* Eval/evaluate.scm 504 */
obj_t BgL_iz00_2458;
{ /* Eval/evaluate.scm 504 */
obj_t BgL_arg2255z00_2462;
BgL_arg2255z00_2462 = 
CAR(
((obj_t)BgL_bz00_2457)); 
BgL_iz00_2458 = 
BGl_untypezd2identzd2zz__evaluatez00(BgL_arg2255z00_2462); } 
{ /* Eval/evaluate.scm 505 */
BgL_ev_varz00_bglt BgL_new1126z00_2459;
{ /* Eval/evaluate.scm 507 */
BgL_ev_varz00_bglt BgL_new1125z00_2460;
BgL_new1125z00_2460 = 
((BgL_ev_varz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_varz00_bgl) ))); 
{ /* Eval/evaluate.scm 507 */
long BgL_arg2254z00_2461;
{ /* Eval/evaluate.scm 507 */
long BgL_res2758z00_3437;
BgL_res2758z00_3437 = 
BGL_CLASS_INDEX(BGl_ev_varz00zz__evaluate_typesz00); 
BgL_arg2254z00_2461 = BgL_res2758z00_3437; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1125z00_2460), BgL_arg2254z00_2461); } 
BgL_new1126z00_2459 = BgL_new1125z00_2460; } 
((((BgL_ev_varz00_bglt)COBJECT(BgL_new1126z00_2459))->BgL_namez00)=((obj_t)
CAR(BgL_iz00_2458)),BUNSPEC); 
((((BgL_ev_varz00_bglt)COBJECT(BgL_new1126z00_2459))->BgL_effz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_ev_varz00_bglt)COBJECT(BgL_new1126z00_2459))->BgL_typez00)=((obj_t)
CDR(BgL_iz00_2458)),BUNSPEC); 
BgL_arg2253z00_2456 = BgL_new1126z00_2459; } } } 
{ /* Eval/evaluate.scm 503 */
obj_t BgL_res2759z00_3442;
BgL_res2759z00_3442 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg2253z00_2456), BNIL); 
BgL_newtail1227z00_2454 = BgL_res2759z00_3442; } } 
SET_CDR(BgL_tail1226z00_2451, BgL_newtail1227z00_2454); 
{ /* Eval/evaluate.scm 503 */
obj_t BgL_arg2252z00_2455;
BgL_arg2252z00_2455 = 
CDR(
((obj_t)BgL_l1223z00_2450)); 
{ 
obj_t BgL_tail1226z00_5538;obj_t BgL_l1223z00_5537;
BgL_l1223z00_5537 = BgL_arg2252z00_2455; 
BgL_tail1226z00_5538 = BgL_newtail1227z00_2454; 
BgL_tail1226z00_2451 = BgL_tail1226z00_5538; 
BgL_l1223z00_2450 = BgL_l1223z00_5537; 
goto BgL_zc3z04anonymousza32250ze3z87_2452;} } } } } 
BgL_blocz00_2440 = 
BGl_getzd2locationzd2zz__evaluatez00(BgL_bindsz00_1491, BgL_locz00_74); 
{ /* Eval/evaluate.scm 510 */
BgL_ev_letza2za2_bglt BgL_new1128z00_2441;
{ /* Eval/evaluate.scm 511 */
BgL_ev_letza2za2_bglt BgL_new1127z00_2444;
BgL_new1127z00_2444 = 
((BgL_ev_letza2za2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_letza2za2_bgl) ))); 
{ /* Eval/evaluate.scm 511 */
long BgL_arg2248z00_2445;
{ /* Eval/evaluate.scm 511 */
long BgL_res2760z00_3446;
BgL_res2760z00_3446 = 
BGL_CLASS_INDEX(BGl_ev_letza2za2zz__evaluate_typesz00); 
BgL_arg2248z00_2445 = BgL_res2760z00_3446; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1127z00_2444), BgL_arg2248z00_2445); } 
BgL_new1128z00_2441 = BgL_new1127z00_2444; } 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1128z00_2441)))->BgL_varsz00)=((obj_t)BgL_varsz00_2439),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1128z00_2441)))->BgL_valsz00)=((obj_t)
BGl_convzd2valsze70z35zz__evaluatez00(BgL_wherez00_73, BgL_globalsz00_71, BgL_bindsz00_1491, BgL_varsz00_2439, BgL_localsz00_70, BgL_blocz00_2440)),BUNSPEC); 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5549;
{ /* Eval/evaluate.scm 513 */
obj_t BgL_arg2246z00_2442;
{ /* Eval/evaluate.scm 513 */
obj_t BgL_arg2247z00_2443;
BgL_arg2247z00_2443 = 
bgl_reverse(BgL_varsz00_2439); 
BgL_arg2246z00_2442 = 
BGl_appendzd221010zd2zz__evaluatez00(BgL_arg2247z00_2443, BgL_localsz00_70); } 
BgL_auxz00_5549 = 
((BgL_ev_exprz00_bglt)
BGl_convzd2beginzd2zz__evaluatez00(BgL_bodyz00_1492, BgL_arg2246z00_2442, BgL_globalsz00_71, BgL_tailzf3zf3_72, BgL_wherez00_73, BgL_locz00_74, ((bool_t)0))); } 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1128z00_2441)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5549),BUNSPEC); } 
((((BgL_ev_letza2za2_bglt)COBJECT(BgL_new1128z00_2441))->BgL_boxesz00)=((obj_t)BNIL),BUNSPEC); 
BgL_auxz00_5511 = BgL_new1128z00_2441; } } 
return 
((obj_t)BgL_auxz00_5511);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1678z00_1690;obj_t BgL_arg1679z00_1691;
BgL_arg1678z00_1690 = 
CAR(BgL_ez00_69); 
BgL_arg1679z00_1691 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_5560;
{ 
obj_t BgL_argsz00_5562;obj_t BgL_fz00_5561;
BgL_fz00_5561 = BgL_arg1678z00_1690; 
BgL_argsz00_5562 = BgL_arg1679z00_1691; 
BgL_argsz00_1535 = BgL_argsz00_5562; 
BgL_fz00_1534 = BgL_fz00_5561; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_5560);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd26695zd2_1692;
BgL_cdrzd26695zd2_1692 = 
CDR(BgL_ez00_69); 
if(
(
CAR(BgL_ez00_69)==BGl_symbol3091z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd26695zd2_1692))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1683z00_1696;obj_t BgL_arg1684z00_1697;
BgL_arg1683z00_1696 = 
CAR(BgL_cdrzd26695zd2_1692); 
BgL_arg1684z00_1697 = 
CDR(BgL_cdrzd26695zd2_1692); 
{ 
BgL_ev_letrecz00_bglt BgL_auxz00_5572;
BgL_bindsz00_1494 = BgL_arg1683z00_1696; 
BgL_bodyz00_1495 = BgL_arg1684z00_1697; 
BgL_tagzd2162zd2_1496:
{ /* Eval/evaluate.scm 515 */
obj_t BgL_ubindsz00_2480;
if(
NULLP(BgL_bindsz00_1494))
{ /* Eval/evaluate.scm 515 */
BgL_ubindsz00_2480 = BNIL; }  else 
{ /* Eval/evaluate.scm 515 */
obj_t BgL_head1230z00_2530;
{ /* Eval/evaluate.scm 515 */
obj_t BgL_res2762z00_3450;
BgL_res2762z00_3450 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1230z00_2530 = BgL_res2762z00_3450; } 
{ 
obj_t BgL_l1228z00_2532;obj_t BgL_tail1231z00_2533;
BgL_l1228z00_2532 = BgL_bindsz00_1494; 
BgL_tail1231z00_2533 = BgL_head1230z00_2530; 
BgL_zc3z04anonymousza32289ze3z87_2534:
if(
NULLP(BgL_l1228z00_2532))
{ /* Eval/evaluate.scm 515 */
BgL_ubindsz00_2480 = 
CDR(BgL_head1230z00_2530); }  else 
{ /* Eval/evaluate.scm 515 */
obj_t BgL_newtail1232z00_2536;
{ /* Eval/evaluate.scm 515 */
obj_t BgL_arg2292z00_2538;
{ /* Eval/evaluate.scm 515 */
obj_t BgL_bz00_2539;
BgL_bz00_2539 = 
CAR(
((obj_t)BgL_l1228z00_2532)); 
{ /* Eval/evaluate.scm 515 */
obj_t BgL_arg2293z00_2540;
BgL_arg2293z00_2540 = 
CAR(
((obj_t)BgL_bz00_2539)); 
BgL_arg2292z00_2538 = 
BGl_untypezd2identzd2zz__evaluatez00(BgL_arg2293z00_2540); } } 
{ /* Eval/evaluate.scm 515 */
obj_t BgL_res2764z00_3455;
BgL_res2764z00_3455 = 
MAKE_YOUNG_PAIR(BgL_arg2292z00_2538, BNIL); 
BgL_newtail1232z00_2536 = BgL_res2764z00_3455; } } 
SET_CDR(BgL_tail1231z00_2533, BgL_newtail1232z00_2536); 
{ /* Eval/evaluate.scm 515 */
obj_t BgL_arg2291z00_2537;
BgL_arg2291z00_2537 = 
CDR(
((obj_t)BgL_l1228z00_2532)); 
{ 
obj_t BgL_tail1231z00_5589;obj_t BgL_l1228z00_5588;
BgL_l1228z00_5588 = BgL_arg2291z00_2537; 
BgL_tail1231z00_5589 = BgL_newtail1232z00_2536; 
BgL_tail1231z00_2533 = BgL_tail1231z00_5589; 
BgL_l1228z00_2532 = BgL_l1228z00_5588; 
goto BgL_zc3z04anonymousza32289ze3z87_2534;} } } } } 
{ /* Eval/evaluate.scm 515 */
obj_t BgL_varsz00_2481;
if(
NULLP(BgL_ubindsz00_2480))
{ /* Eval/evaluate.scm 516 */
BgL_varsz00_2481 = BNIL; }  else 
{ /* Eval/evaluate.scm 516 */
obj_t BgL_head1235z00_2514;
{ /* Eval/evaluate.scm 516 */
obj_t BgL_res2766z00_3459;
BgL_res2766z00_3459 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1235z00_2514 = BgL_res2766z00_3459; } 
{ 
obj_t BgL_l1233z00_2516;obj_t BgL_tail1236z00_2517;
BgL_l1233z00_2516 = BgL_ubindsz00_2480; 
BgL_tail1236z00_2517 = BgL_head1235z00_2514; 
BgL_zc3z04anonymousza32283ze3z87_2518:
if(
NULLP(BgL_l1233z00_2516))
{ /* Eval/evaluate.scm 516 */
BgL_varsz00_2481 = 
CDR(BgL_head1235z00_2514); }  else 
{ /* Eval/evaluate.scm 516 */
obj_t BgL_newtail1237z00_2520;
{ /* Eval/evaluate.scm 516 */
BgL_ev_varz00_bglt BgL_arg2286z00_2522;
{ /* Eval/evaluate.scm 516 */
obj_t BgL_iz00_2523;
BgL_iz00_2523 = 
CAR(
((obj_t)BgL_l1233z00_2516)); 
{ /* Eval/evaluate.scm 517 */
BgL_ev_varz00_bglt BgL_new1130z00_2524;
{ /* Eval/evaluate.scm 519 */
BgL_ev_varz00_bglt BgL_new1129z00_2525;
BgL_new1129z00_2525 = 
((BgL_ev_varz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_varz00_bgl) ))); 
{ /* Eval/evaluate.scm 519 */
long BgL_arg2287z00_2526;
{ /* Eval/evaluate.scm 519 */
long BgL_res2768z00_3464;
BgL_res2768z00_3464 = 
BGL_CLASS_INDEX(BGl_ev_varz00zz__evaluate_typesz00); 
BgL_arg2287z00_2526 = BgL_res2768z00_3464; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1129z00_2525), BgL_arg2287z00_2526); } 
BgL_new1130z00_2524 = BgL_new1129z00_2525; } 
((((BgL_ev_varz00_bglt)COBJECT(BgL_new1130z00_2524))->BgL_namez00)=((obj_t)
CAR(
((obj_t)BgL_iz00_2523))),BUNSPEC); 
((((BgL_ev_varz00_bglt)COBJECT(BgL_new1130z00_2524))->BgL_effz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_ev_varz00_bglt)COBJECT(BgL_new1130z00_2524))->BgL_typez00)=((obj_t)
CDR(
((obj_t)BgL_iz00_2523))),BUNSPEC); 
BgL_arg2286z00_2522 = BgL_new1130z00_2524; } } 
{ /* Eval/evaluate.scm 516 */
obj_t BgL_res2769z00_3469;
BgL_res2769z00_3469 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg2286z00_2522), BNIL); 
BgL_newtail1237z00_2520 = BgL_res2769z00_3469; } } 
SET_CDR(BgL_tail1236z00_2517, BgL_newtail1237z00_2520); 
{ /* Eval/evaluate.scm 516 */
obj_t BgL_arg2285z00_2521;
BgL_arg2285z00_2521 = 
CDR(
((obj_t)BgL_l1233z00_2516)); 
{ 
obj_t BgL_tail1236z00_5615;obj_t BgL_l1233z00_5614;
BgL_l1233z00_5614 = BgL_arg2285z00_2521; 
BgL_tail1236z00_5615 = BgL_newtail1237z00_2520; 
BgL_tail1236z00_2517 = BgL_tail1236z00_5615; 
BgL_l1233z00_2516 = BgL_l1233z00_5614; 
goto BgL_zc3z04anonymousza32283ze3z87_2518;} } } } } 
{ /* Eval/evaluate.scm 516 */
obj_t BgL_localsz00_2482;
BgL_localsz00_2482 = 
BGl_appendzd221010zd2zz__evaluatez00(BgL_varsz00_2481, BgL_localsz00_70); 
{ /* Eval/evaluate.scm 521 */
obj_t BgL_bodyz00_2483;
{ /* Eval/evaluate.scm 522 */
bool_t BgL_test3299z00_5617;
{ /* Eval/evaluate.scm 522 */
obj_t BgL_tmpz00_5618;
BgL_tmpz00_5618 = 
CDR(
((obj_t)BgL_bodyz00_1495)); 
BgL_test3299z00_5617 = 
PAIRP(BgL_tmpz00_5618); } 
if(BgL_test3299z00_5617)
{ /* Eval/evaluate.scm 522 */
obj_t BgL_res2771z00_3475;
BgL_res2771z00_3475 = 
MAKE_YOUNG_EPAIR(BGl_symbol3072z00zz__evaluatez00, BgL_bodyz00_1495, BgL_locz00_74); 
BgL_bodyz00_2483 = BgL_res2771z00_3475; }  else 
{ /* Eval/evaluate.scm 522 */
BgL_bodyz00_2483 = 
CAR(
((obj_t)BgL_bodyz00_1495)); } } 
{ /* Eval/evaluate.scm 522 */
obj_t BgL_tbodyz00_2484;
BgL_tbodyz00_2484 = 
BGl_typezd2checkszd2zz__evaluatez00(BgL_ubindsz00_2480, BgL_bindsz00_1494, BgL_bodyz00_2483, BgL_locz00_74, BgL_wherez00_73); 
{ /* Eval/evaluate.scm 523 */
obj_t BgL_blocz00_2485;
BgL_blocz00_2485 = 
BGl_getzd2locationzd2zz__evaluatez00(BgL_bindsz00_1494, BgL_locz00_74); 
{ /* Eval/evaluate.scm 524 */

{ /* Eval/evaluate.scm 525 */
BgL_ev_letrecz00_bglt BgL_new1132z00_2486;
{ /* Eval/evaluate.scm 526 */
BgL_ev_letrecz00_bglt BgL_new1131z00_2507;
BgL_new1131z00_2507 = 
((BgL_ev_letrecz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_letrecz00_bgl) ))); 
{ /* Eval/evaluate.scm 526 */
long BgL_arg2278z00_2508;
{ /* Eval/evaluate.scm 526 */
long BgL_res2772z00_3478;
BgL_res2772z00_3478 = 
BGL_CLASS_INDEX(BGl_ev_letrecz00zz__evaluate_typesz00); 
BgL_arg2278z00_2508 = BgL_res2772z00_3478; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1131z00_2507), BgL_arg2278z00_2508); } 
BgL_new1132z00_2486 = BgL_new1131z00_2507; } 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1132z00_2486)))->BgL_varsz00)=((obj_t)BgL_varsz00_2481),BUNSPEC); 
{ 
obj_t BgL_auxz00_5633;
if(
NULLP(BgL_bindsz00_1494))
{ /* Eval/evaluate.scm 527 */
BgL_auxz00_5633 = BNIL
; }  else 
{ /* Eval/evaluate.scm 527 */
obj_t BgL_head1240z00_2489;
{ /* Eval/evaluate.scm 527 */
obj_t BgL_res2774z00_3482;
BgL_res2774z00_3482 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1240z00_2489 = BgL_res2774z00_3482; } 
{ 
obj_t BgL_l1238z00_2491;obj_t BgL_tail1241z00_2492;
BgL_l1238z00_2491 = BgL_bindsz00_1494; 
BgL_tail1241z00_2492 = BgL_head1240z00_2489; 
BgL_zc3z04anonymousza32267ze3z87_2493:
if(
NULLP(BgL_l1238z00_2491))
{ /* Eval/evaluate.scm 527 */
BgL_auxz00_5633 = 
CDR(BgL_head1240z00_2489)
; }  else 
{ /* Eval/evaluate.scm 527 */
obj_t BgL_newtail1242z00_2495;
{ /* Eval/evaluate.scm 527 */
obj_t BgL_arg2270z00_2497;
{ /* Eval/evaluate.scm 527 */
obj_t BgL_bz00_2498;
BgL_bz00_2498 = 
CAR(
((obj_t)BgL_l1238z00_2491)); 
{ /* Eval/evaluate.scm 528 */
obj_t BgL_arg2271z00_2499;obj_t BgL_arg2272z00_2500;obj_t BgL_arg2273z00_2501;
{ /* Eval/evaluate.scm 528 */
obj_t BgL_pairz00_3489;
BgL_pairz00_3489 = 
CDR(
((obj_t)BgL_bz00_2498)); 
BgL_arg2271z00_2499 = 
CAR(BgL_pairz00_3489); } 
{ /* Eval/evaluate.scm 528 */
obj_t BgL_arg2274z00_2502;
BgL_arg2274z00_2502 = 
CAR(
((obj_t)BgL_bz00_2498)); 
{ /* Eval/evaluate.scm 528 */
obj_t BgL_list2275z00_2503;
{ /* Eval/evaluate.scm 528 */
obj_t BgL_arg2276z00_2504;
{ /* Eval/evaluate.scm 528 */
obj_t BgL_arg2277z00_2505;
BgL_arg2277z00_2505 = 
MAKE_YOUNG_PAIR(BgL_wherez00_73, BNIL); 
BgL_arg2276z00_2504 = 
MAKE_YOUNG_PAIR(BGl_symbol3074z00zz__evaluatez00, BgL_arg2277z00_2505); } 
BgL_list2275z00_2503 = 
MAKE_YOUNG_PAIR(BgL_arg2274z00_2502, BgL_arg2276z00_2504); } 
BgL_arg2272z00_2500 = 
BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list2275z00_2503); } } 
BgL_arg2273z00_2501 = 
BGl_getzd2locationzd2zz__evaluatez00(BgL_bz00_2498, BgL_blocz00_2485); 
BgL_arg2270z00_2497 = 
BGl_convz00zz__evaluatez00(BgL_arg2271z00_2499, BgL_localsz00_2482, BgL_globalsz00_71, BFALSE, BgL_arg2272z00_2500, BgL_arg2273z00_2501, ((bool_t)0)); } } 
{ /* Eval/evaluate.scm 527 */
obj_t BgL_res2776z00_3491;
BgL_res2776z00_3491 = 
MAKE_YOUNG_PAIR(BgL_arg2270z00_2497, BNIL); 
BgL_newtail1242z00_2495 = BgL_res2776z00_3491; } } 
SET_CDR(BgL_tail1241z00_2492, BgL_newtail1242z00_2495); 
{ /* Eval/evaluate.scm 527 */
obj_t BgL_arg2269z00_2496;
BgL_arg2269z00_2496 = 
CDR(
((obj_t)BgL_l1238z00_2491)); 
{ 
obj_t BgL_tail1241z00_5659;obj_t BgL_l1238z00_5658;
BgL_l1238z00_5658 = BgL_arg2269z00_2496; 
BgL_tail1241z00_5659 = BgL_newtail1242z00_2495; 
BgL_tail1241z00_2492 = BgL_tail1241z00_5659; 
BgL_l1238z00_2491 = BgL_l1238z00_5658; 
goto BgL_zc3z04anonymousza32267ze3z87_2493;} } } } } 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1132z00_2486)))->BgL_valsz00)=((obj_t)BgL_auxz00_5633),BUNSPEC); } 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1132z00_2486)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)
BGl_convz00zz__evaluatez00(BgL_tbodyz00_2484, BgL_localsz00_2482, BgL_globalsz00_71, BgL_tailzf3zf3_72, BgL_wherez00_73, BgL_locz00_74, ((bool_t)0)))),BUNSPEC); 
BgL_auxz00_5572 = BgL_new1132z00_2486; } } } } } } } } 
return 
((obj_t)BgL_auxz00_5572);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1685z00_1698;
BgL_arg1685z00_1698 = 
CAR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_5667;
{ 
obj_t BgL_argsz00_5669;obj_t BgL_fz00_5668;
BgL_fz00_5668 = BgL_arg1685z00_1698; 
BgL_argsz00_5669 = BgL_cdrzd26695zd2_1692; 
BgL_argsz00_1535 = BgL_argsz00_5669; 
BgL_fz00_1534 = BgL_fz00_5668; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_5667);} } }  else 
{ /* Eval/evaluate.scm 424 */
if(
(
CAR(BgL_ez00_69)==BGl_symbol3093z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd26695zd2_1692))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_carzd26869zd2_1704;obj_t BgL_cdrzd26870zd2_1705;
BgL_carzd26869zd2_1704 = 
CAR(BgL_cdrzd26695zd2_1692); 
BgL_cdrzd26870zd2_1705 = 
CDR(BgL_cdrzd26695zd2_1692); 
if(
PAIRP(BgL_carzd26869zd2_1704))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd26874zd2_1707;
BgL_cdrzd26874zd2_1707 = 
CDR(BgL_carzd26869zd2_1704); 
if(
(
CAR(BgL_carzd26869zd2_1704)==BGl_symbol3079z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd26874zd2_1707))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_carzd26877zd2_1711;obj_t BgL_cdrzd26878zd2_1712;
BgL_carzd26877zd2_1711 = 
CAR(BgL_cdrzd26874zd2_1707); 
BgL_cdrzd26878zd2_1712 = 
CDR(BgL_cdrzd26874zd2_1707); 
if(
SYMBOLP(BgL_carzd26877zd2_1711))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd26878zd2_1712))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_carzd26882zd2_1715;
BgL_carzd26882zd2_1715 = 
CAR(BgL_cdrzd26878zd2_1712); 
if(
SYMBOLP(BgL_carzd26882zd2_1715))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd26878zd2_1712)))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd26870zd2_1705))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd26870zd2_1705)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1702z00_1722;
BgL_arg1702z00_1722 = 
CAR(BgL_cdrzd26870zd2_1705); 
{ 
BgL_ev_setglobalz00_bglt BgL_auxz00_5704;
BgL_idz00_1497 = BgL_carzd26877zd2_1711; 
BgL_modnamez00_1498 = BgL_carzd26882zd2_1715; 
BgL_ez00_1499 = BgL_arg1702z00_1722; 
BgL_tagzd2163zd2_1500:
{ /* Eval/evaluate.scm 531 */
BgL_ev_setglobalz00_bglt BgL_new1134z00_2542;
{ /* Eval/evaluate.scm 535 */
BgL_ev_setglobalz00_bglt BgL_new1133z00_2543;
BgL_new1133z00_2543 = 
((BgL_ev_setglobalz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_setglobalz00_bgl) ))); 
{ /* Eval/evaluate.scm 535 */
long BgL_arg2294z00_2544;
{ /* Eval/evaluate.scm 535 */
long BgL_res2777z00_3495;
BgL_res2777z00_3495 = 
BGL_CLASS_INDEX(BGl_ev_setglobalz00zz__evaluate_typesz00); 
BgL_arg2294z00_2544 = BgL_res2777z00_3495; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1133z00_2543), BgL_arg2294z00_2544); } 
BgL_new1134z00_2542 = BgL_new1133z00_2543; } 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)BgL_new1134z00_2542)))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)
BGl_uconvze70ze7zz__evaluatez00(BgL_locz00_74, BgL_wherez00_73, BgL_globalsz00_71, BgL_localsz00_70, BgL_ez00_1499))),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(BgL_new1134z00_2542))->BgL_locz00)=((obj_t)BgL_locz00_74),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(BgL_new1134z00_2542))->BgL_namez00)=((obj_t)BgL_idz00_1497),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(BgL_new1134z00_2542))->BgL_modz00)=((obj_t)
BGl_evalzd2findzd2modulez00zz__evmodulez00(BgL_modnamez00_1498)),BUNSPEC); 
BgL_auxz00_5704 = BgL_new1134z00_2542; } 
return 
((obj_t)BgL_auxz00_5704);} }  else 
{ /* Eval/evaluate.scm 424 */
BgL_tagzd2166zd2_1507:
return 
BGl_evcompilezd2errorzd2zz__evcompilez00(BgL_locz00_74, BGl_string2994z00zz__evaluatez00, BGl_string3071z00zz__evaluatez00, BgL_ez00_69);} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd26998zd2_1724;
BgL_cdrzd26998zd2_1724 = 
CDR(BgL_ez00_69); 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd27002zd2_1725;
BgL_cdrzd27002zd2_1725 = 
CDR(
((obj_t)BgL_cdrzd26998zd2_1724)); 
if(
PAIRP(BgL_cdrzd27002zd2_1725))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd27002zd2_1725)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1707z00_1729;obj_t BgL_arg1708z00_1730;
BgL_arg1707z00_1729 = 
CAR(
((obj_t)BgL_cdrzd26998zd2_1724)); 
BgL_arg1708z00_1730 = 
CAR(BgL_cdrzd27002zd2_1725); 
{ 
BgL_ev_hookz00_bglt BgL_auxz00_5730;
BgL_vz00_1504 = BgL_arg1707z00_1729; 
BgL_ez00_1505 = BgL_arg1708z00_1730; 
BgL_tagzd2165zd2_1506:
{ /* Eval/evaluate.scm 541 */
obj_t BgL_cvz00_2571;obj_t BgL_ez00_2572;
BgL_cvz00_2571 = 
BGl_convzd2varzd2zz__evaluatez00(BgL_vz00_1504, BgL_localsz00_70); 
BgL_ez00_2572 = 
BGl_uconvze70ze7zz__evaluatez00(BgL_locz00_74, BgL_wherez00_73, BgL_globalsz00_71, BgL_localsz00_70, BgL_ez00_1505); 
if(
CBOOL(BgL_cvz00_2571))
{ /* Eval/evaluate.scm 543 */
BgL_ev_setlocalz00_bglt BgL_new1136z00_2573;
{ /* Eval/evaluate.scm 545 */
BgL_ev_setlocalz00_bglt BgL_new1135z00_2574;
BgL_new1135z00_2574 = 
((BgL_ev_setlocalz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_setlocalz00_bgl) ))); 
{ /* Eval/evaluate.scm 545 */
long BgL_arg2308z00_2575;
{ /* Eval/evaluate.scm 545 */
long BgL_res2782z00_3506;
BgL_res2782z00_3506 = 
BGL_CLASS_INDEX(BGl_ev_setlocalz00zz__evaluate_typesz00); 
BgL_arg2308z00_2575 = BgL_res2782z00_3506; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1135z00_2574), BgL_arg2308z00_2575); } 
BgL_new1136z00_2573 = BgL_new1135z00_2574; } 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)BgL_new1136z00_2573)))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_ez00_2572)),BUNSPEC); 
((((BgL_ev_setlocalz00_bglt)COBJECT(BgL_new1136z00_2573))->BgL_vz00)=((BgL_ev_varz00_bglt)
((BgL_ev_varz00_bglt)BgL_cvz00_2571)),BUNSPEC); 
BgL_auxz00_5730 = 
((BgL_ev_hookz00_bglt)BgL_new1136z00_2573); }  else 
{ /* Eval/evaluate.scm 546 */
BgL_ev_setglobalz00_bglt BgL_new1138z00_2576;
{ /* Eval/evaluate.scm 550 */
BgL_ev_setglobalz00_bglt BgL_new1137z00_2578;
BgL_new1137z00_2578 = 
((BgL_ev_setglobalz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_setglobalz00_bgl) ))); 
{ /* Eval/evaluate.scm 550 */
long BgL_arg2310z00_2579;
{ /* Eval/evaluate.scm 550 */
long BgL_res2783z00_3510;
BgL_res2783z00_3510 = 
BGL_CLASS_INDEX(BGl_ev_setglobalz00zz__evaluate_typesz00); 
BgL_arg2310z00_2579 = BgL_res2783z00_3510; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1137z00_2578), BgL_arg2310z00_2579); } 
BgL_new1138z00_2576 = BgL_new1137z00_2578; } 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)BgL_new1138z00_2576)))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_ez00_2572)),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(BgL_new1138z00_2576))->BgL_locz00)=((obj_t)BgL_locz00_74),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(BgL_new1138z00_2576))->BgL_namez00)=((obj_t)BgL_vz00_1504),BUNSPEC); 
{ 
obj_t BgL_auxz00_5754;
if(
BGl_evmodulezf3zf3zz__evmodulez00(BgL_globalsz00_71))
{ /* Eval/evaluate.scm 549 */
BgL_auxz00_5754 = BgL_globalsz00_71
; }  else 
{ /* Eval/evaluate.scm 549 */
BgL_auxz00_5754 = 
BGL_MODULE()
; } 
((((BgL_ev_setglobalz00_bglt)COBJECT(BgL_new1138z00_2576))->BgL_modz00)=((obj_t)BgL_auxz00_5754),BUNSPEC); } 
BgL_auxz00_5730 = 
((BgL_ev_hookz00_bglt)BgL_new1138z00_2576); } } 
return 
((obj_t)BgL_auxz00_5730);} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} } } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd27059zd2_1733;
BgL_cdrzd27059zd2_1733 = 
CDR(BgL_ez00_69); 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd27063zd2_1734;
BgL_cdrzd27063zd2_1734 = 
CDR(
((obj_t)BgL_cdrzd27059zd2_1733)); 
if(
PAIRP(BgL_cdrzd27063zd2_1734))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd27063zd2_1734)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1714z00_1738;obj_t BgL_arg1716z00_1739;
BgL_arg1714z00_1738 = 
CAR(
((obj_t)BgL_cdrzd27059zd2_1733)); 
BgL_arg1716z00_1739 = 
CAR(BgL_cdrzd27063zd2_1734); 
{ 
BgL_ev_hookz00_bglt BgL_auxz00_5772;
{ 
obj_t BgL_ez00_5774;obj_t BgL_vz00_5773;
BgL_vz00_5773 = BgL_arg1714z00_1738; 
BgL_ez00_5774 = BgL_arg1716z00_1739; 
BgL_ez00_1505 = BgL_ez00_5774; 
BgL_vz00_1504 = BgL_vz00_5773; 
goto BgL_tagzd2165zd2_1506;} 
return 
((obj_t)BgL_auxz00_5772);} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} } } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd27120zd2_1741;
BgL_cdrzd27120zd2_1741 = 
CDR(BgL_ez00_69); 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd27124zd2_1742;
BgL_cdrzd27124zd2_1742 = 
CDR(
((obj_t)BgL_cdrzd27120zd2_1741)); 
if(
PAIRP(BgL_cdrzd27124zd2_1742))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd27124zd2_1742)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1722z00_1746;obj_t BgL_arg1723z00_1747;
BgL_arg1722z00_1746 = 
CAR(
((obj_t)BgL_cdrzd27120zd2_1741)); 
BgL_arg1723z00_1747 = 
CAR(BgL_cdrzd27124zd2_1742); 
{ 
BgL_ev_hookz00_bglt BgL_auxz00_5787;
{ 
obj_t BgL_ez00_5789;obj_t BgL_vz00_5788;
BgL_vz00_5788 = BgL_arg1722z00_1746; 
BgL_ez00_5789 = BgL_arg1723z00_1747; 
BgL_ez00_1505 = BgL_ez00_5789; 
BgL_vz00_1504 = BgL_vz00_5788; 
goto BgL_tagzd2165zd2_1506;} 
return 
((obj_t)BgL_auxz00_5787);} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} } } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd27181zd2_1749;
BgL_cdrzd27181zd2_1749 = 
CDR(BgL_ez00_69); 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd27185zd2_1750;
BgL_cdrzd27185zd2_1750 = 
CDR(
((obj_t)BgL_cdrzd27181zd2_1749)); 
if(
PAIRP(BgL_cdrzd27185zd2_1750))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd27185zd2_1750)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1728z00_1754;obj_t BgL_arg1729z00_1755;
BgL_arg1728z00_1754 = 
CAR(
((obj_t)BgL_cdrzd27181zd2_1749)); 
BgL_arg1729z00_1755 = 
CAR(BgL_cdrzd27185zd2_1750); 
{ 
BgL_ev_hookz00_bglt BgL_auxz00_5802;
{ 
obj_t BgL_ez00_5804;obj_t BgL_vz00_5803;
BgL_vz00_5803 = BgL_arg1728z00_1754; 
BgL_ez00_5804 = BgL_arg1729z00_1755; 
BgL_ez00_1505 = BgL_ez00_5804; 
BgL_vz00_1504 = BgL_vz00_5803; 
goto BgL_tagzd2165zd2_1506;} 
return 
((obj_t)BgL_auxz00_5802);} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} } } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd27242zd2_1757;
BgL_cdrzd27242zd2_1757 = 
CDR(BgL_ez00_69); 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd27246zd2_1758;
BgL_cdrzd27246zd2_1758 = 
CDR(
((obj_t)BgL_cdrzd27242zd2_1757)); 
if(
PAIRP(BgL_cdrzd27246zd2_1758))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd27246zd2_1758)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1734z00_1762;obj_t BgL_arg1735z00_1763;
BgL_arg1734z00_1762 = 
CAR(
((obj_t)BgL_cdrzd27242zd2_1757)); 
BgL_arg1735z00_1763 = 
CAR(BgL_cdrzd27246zd2_1758); 
{ 
BgL_ev_hookz00_bglt BgL_auxz00_5817;
{ 
obj_t BgL_ez00_5819;obj_t BgL_vz00_5818;
BgL_vz00_5818 = BgL_arg1734z00_1762; 
BgL_ez00_5819 = BgL_arg1735z00_1763; 
BgL_ez00_1505 = BgL_ez00_5819; 
BgL_vz00_1504 = BgL_vz00_5818; 
goto BgL_tagzd2165zd2_1506;} 
return 
((obj_t)BgL_auxz00_5817);} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} } } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd27290zd2_1765;
BgL_cdrzd27290zd2_1765 = 
CDR(BgL_ez00_69); 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_carzd27293zd2_1766;obj_t BgL_cdrzd27294zd2_1767;
BgL_carzd27293zd2_1766 = 
CAR(
((obj_t)BgL_cdrzd27290zd2_1765)); 
BgL_cdrzd27294zd2_1767 = 
CDR(
((obj_t)BgL_cdrzd27290zd2_1765)); 
if(
(
CAR(
((obj_t)BgL_carzd27293zd2_1766))==BGl_symbol3081z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd27294zd2_1767))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd27294zd2_1767)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1742z00_1773;obj_t BgL_arg1743z00_1774;
BgL_arg1742z00_1773 = 
CDR(
((obj_t)BgL_carzd27293zd2_1766)); 
BgL_arg1743z00_1774 = 
CAR(BgL_cdrzd27294zd2_1767); 
BgL_lz00_1501 = BgL_arg1742z00_1773; 
BgL_e2z00_1502 = BgL_arg1743z00_1774; 
BgL_tagzd2164zd2_1503:
{ /* Eval/evaluate.scm 537 */
bool_t BgL_test3328z00_5838;
if(
PAIRP(BgL_lz00_1501))
{ /* Eval/evaluate.scm 537 */
bool_t BgL_test3330z00_5841;
{ /* Eval/evaluate.scm 537 */
obj_t BgL_tmpz00_5842;
BgL_tmpz00_5842 = 
CDR(BgL_lz00_1501); 
BgL_test3330z00_5841 = 
PAIRP(BgL_tmpz00_5842); } 
if(BgL_test3330z00_5841)
{ 
obj_t BgL_l1243z00_2562;
BgL_l1243z00_2562 = BgL_lz00_1501; 
BgL_zc3z04anonymousza32304ze3z87_2563:
if(
NULLP(BgL_l1243z00_2562))
{ /* Eval/evaluate.scm 537 */
BgL_test3328z00_5838 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate.scm 537 */
bool_t BgL_test3332z00_5847;
{ /* Eval/evaluate.scm 537 */
obj_t BgL_tmpz00_5848;
BgL_tmpz00_5848 = 
CAR(
((obj_t)BgL_l1243z00_2562)); 
BgL_test3332z00_5847 = 
SYMBOLP(BgL_tmpz00_5848); } 
if(BgL_test3332z00_5847)
{ 
obj_t BgL_l1243z00_5852;
BgL_l1243z00_5852 = 
CDR(
((obj_t)BgL_l1243z00_2562)); 
BgL_l1243z00_2562 = BgL_l1243z00_5852; 
goto BgL_zc3z04anonymousza32304ze3z87_2563;}  else 
{ /* Eval/evaluate.scm 537 */
BgL_test3328z00_5838 = ((bool_t)0)
; } } }  else 
{ /* Eval/evaluate.scm 537 */
BgL_test3328z00_5838 = ((bool_t)0)
; } }  else 
{ /* Eval/evaluate.scm 537 */
BgL_test3328z00_5838 = ((bool_t)0)
; } 
if(BgL_test3328z00_5838)
{ /* Eval/evaluate.scm 537 */
return 
BGl_convzd2fieldzd2setz00zz__evaluatez00(BgL_lz00_1501, BgL_e2z00_1502, BgL_ez00_69, BgL_localsz00_70, BgL_globalsz00_71, BgL_tailzf3zf3_72, BgL_wherez00_73, BgL_locz00_74, BgL_topzf3zf3_75);}  else 
{ /* Eval/evaluate.scm 537 */
return 
BGl_evcompilezd2errorzd2zz__evcompilez00(BgL_locz00_74, BGl_string2994z00zz__evaluatez00, BGl_string3071z00zz__evaluatez00, BgL_ez00_69);} } }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd27370zd2_1777;
BgL_cdrzd27370zd2_1777 = 
CDR(
((obj_t)BgL_cdrzd27290zd2_1765)); 
if(
PAIRP(BgL_cdrzd27370zd2_1777))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd27370zd2_1777)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1748z00_1781;obj_t BgL_arg1749z00_1782;
BgL_arg1748z00_1781 = 
CAR(
((obj_t)BgL_cdrzd27290zd2_1765)); 
BgL_arg1749z00_1782 = 
CAR(BgL_cdrzd27370zd2_1777); 
{ 
BgL_ev_hookz00_bglt BgL_auxz00_5867;
{ 
obj_t BgL_ez00_5869;obj_t BgL_vz00_5868;
BgL_vz00_5868 = BgL_arg1748z00_1781; 
BgL_ez00_5869 = BgL_arg1749z00_1782; 
BgL_ez00_1505 = BgL_ez00_5869; 
BgL_vz00_1504 = BgL_vz00_5868; 
goto BgL_tagzd2165zd2_1506;} 
return 
((obj_t)BgL_auxz00_5867);} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} } } } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd27427zd2_1786;
BgL_cdrzd27427zd2_1786 = 
CDR(BgL_ez00_69); 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd27431zd2_1787;
BgL_cdrzd27431zd2_1787 = 
CDR(
((obj_t)BgL_cdrzd27427zd2_1786)); 
if(
PAIRP(BgL_cdrzd27431zd2_1787))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd27431zd2_1787)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1756z00_1791;obj_t BgL_arg1757z00_1792;
BgL_arg1756z00_1791 = 
CAR(
((obj_t)BgL_cdrzd27427zd2_1786)); 
BgL_arg1757z00_1792 = 
CAR(BgL_cdrzd27431zd2_1787); 
{ 
BgL_ev_hookz00_bglt BgL_auxz00_5882;
{ 
obj_t BgL_ez00_5884;obj_t BgL_vz00_5883;
BgL_vz00_5883 = BgL_arg1756z00_1791; 
BgL_ez00_5884 = BgL_arg1757z00_1792; 
BgL_ez00_1505 = BgL_ez00_5884; 
BgL_vz00_1504 = BgL_vz00_5883; 
goto BgL_tagzd2165zd2_1506;} 
return 
((obj_t)BgL_auxz00_5882);} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} } } }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd27552zd2_1794;
BgL_cdrzd27552zd2_1794 = 
CDR(BgL_ez00_69); 
if(
(
CAR(BgL_ez00_69)==BGl_symbol3095z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd27552zd2_1794))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd27557zd2_1798;
BgL_cdrzd27557zd2_1798 = 
CDR(BgL_cdrzd27552zd2_1794); 
if(
PAIRP(BgL_cdrzd27557zd2_1798))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_carzd27561zd2_1800;
BgL_carzd27561zd2_1800 = 
CAR(BgL_cdrzd27557zd2_1798); 
if(
PAIRP(BgL_carzd27561zd2_1800))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd27566zd2_1802;
BgL_cdrzd27566zd2_1802 = 
CDR(BgL_carzd27561zd2_1800); 
if(
(
CAR(BgL_carzd27561zd2_1800)==BGl_symbol3058z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd27566zd2_1802))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd27570zd2_1806;
BgL_cdrzd27570zd2_1806 = 
CDR(BgL_cdrzd27566zd2_1802); 
if(
PAIRP(BgL_cdrzd27570zd2_1806))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd27570zd2_1806)))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd27557zd2_1798)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1772z00_1812;obj_t BgL_arg1773z00_1813;obj_t BgL_arg1774z00_1814;
BgL_arg1772z00_1812 = 
CAR(BgL_cdrzd27552zd2_1794); 
BgL_arg1773z00_1813 = 
CAR(BgL_cdrzd27566zd2_1802); 
BgL_arg1774z00_1814 = 
CAR(BgL_cdrzd27570zd2_1806); 
{ 
BgL_ev_defglobalz00_bglt BgL_auxz00_5916;
BgL_gvz00_1508 = BgL_arg1772z00_1812; 
BgL_formalsz00_1509 = BgL_arg1773z00_1813; 
BgL_bodyz00_1510 = BgL_arg1774z00_1814; 
BgL_tagzd2167zd2_1511:
{ /* Eval/evaluate.scm 554 */
obj_t BgL_tidz00_2580;
BgL_tidz00_2580 = 
BGl_untypezd2identzd2zz__evaluatez00(BgL_gvz00_1508); 
{ /* Eval/evaluate.scm 555 */
BgL_ev_defglobalz00_bglt BgL_new1140z00_2581;
{ /* Eval/evaluate.scm 559 */
BgL_ev_defglobalz00_bglt BgL_new1139z00_2584;
BgL_new1139z00_2584 = 
((BgL_ev_defglobalz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_defglobalz00_bgl) ))); 
{ /* Eval/evaluate.scm 559 */
long BgL_arg2313z00_2585;
{ /* Eval/evaluate.scm 559 */
long BgL_res2784z00_3514;
BgL_res2784z00_3514 = 
BGL_CLASS_INDEX(BGl_ev_defglobalz00zz__evaluate_typesz00); 
BgL_arg2313z00_2585 = BgL_res2784z00_3514; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1139z00_2584), BgL_arg2313z00_2585); } 
BgL_new1140z00_2581 = BgL_new1139z00_2584; } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5922;
{ /* Eval/evaluate.scm 559 */
obj_t BgL_arg2311z00_2582;
BgL_arg2311z00_2582 = 
CDR(BgL_tidz00_2580); 
BgL_auxz00_5922 = 
((BgL_ev_exprz00_bglt)
BGl_convzd2lambdaze70z35zz__evaluatez00(BgL_globalsz00_71, BgL_localsz00_70, BgL_ez00_69, BgL_locz00_74, BgL_formalsz00_1509, BgL_bodyz00_1510, BgL_gvz00_1508, BgL_arg2311z00_2582)); } 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)BgL_new1140z00_2581)))->BgL_ez00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5922),BUNSPEC); } 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_new1140z00_2581)))->BgL_locz00)=((obj_t)BgL_locz00_74),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_new1140z00_2581)))->BgL_namez00)=((obj_t)
CAR(BgL_tidz00_2580)),BUNSPEC); 
{ 
obj_t BgL_auxz00_5933;
if(
BGl_evmodulezf3zf3zz__evmodulez00(BgL_globalsz00_71))
{ /* Eval/evaluate.scm 558 */
BgL_auxz00_5933 = BgL_globalsz00_71
; }  else 
{ /* Eval/evaluate.scm 558 */
BgL_auxz00_5933 = 
BGL_MODULE()
; } 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_new1140z00_2581)))->BgL_modz00)=((obj_t)BgL_auxz00_5933),BUNSPEC); } 
BgL_auxz00_5916 = BgL_new1140z00_2581; } } 
return 
((obj_t)BgL_auxz00_5916);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1775z00_1815;
BgL_arg1775z00_1815 = 
CAR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_5941;
{ 
obj_t BgL_argsz00_5943;obj_t BgL_fz00_5942;
BgL_fz00_5942 = BgL_arg1775z00_1815; 
BgL_argsz00_5943 = BgL_cdrzd27552zd2_1794; 
BgL_argsz00_1535 = BgL_argsz00_5943; 
BgL_fz00_1534 = BgL_fz00_5942; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_5941);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd27670zd2_1819;
BgL_cdrzd27670zd2_1819 = 
CDR(
((obj_t)BgL_cdrzd27552zd2_1794)); 
if(
NULLP(
CDR(
((obj_t)BgL_cdrzd27670zd2_1819))))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1780z00_1822;obj_t BgL_arg1781z00_1823;
BgL_arg1780z00_1822 = 
CAR(
((obj_t)BgL_cdrzd27552zd2_1794)); 
BgL_arg1781z00_1823 = 
CAR(
((obj_t)BgL_cdrzd27670zd2_1819)); 
{ 
BgL_ev_defglobalz00_bglt BgL_auxz00_5955;
BgL_gvz00_1512 = BgL_arg1780z00_1822; 
BgL_gez00_1513 = BgL_arg1781z00_1823; 
BgL_tagzd2168zd2_1514:
{ /* Eval/evaluate.scm 561 */
obj_t BgL_tidz00_2586;
BgL_tidz00_2586 = 
BGl_untypezd2identzd2zz__evaluatez00(BgL_gvz00_1512); 
{ /* Eval/evaluate.scm 562 */
BgL_ev_defglobalz00_bglt BgL_new1142z00_2587;
{ /* Eval/evaluate.scm 566 */
BgL_ev_defglobalz00_bglt BgL_new1141z00_2592;
BgL_new1141z00_2592 = 
((BgL_ev_defglobalz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_defglobalz00_bgl) ))); 
{ /* Eval/evaluate.scm 566 */
long BgL_arg2318z00_2593;
{ /* Eval/evaluate.scm 566 */
long BgL_res2785z00_3520;
BgL_res2785z00_3520 = 
BGL_CLASS_INDEX(BGl_ev_defglobalz00zz__evaluate_typesz00); 
BgL_arg2318z00_2593 = BgL_res2785z00_3520; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1141z00_2592), BgL_arg2318z00_2593); } 
BgL_new1142z00_2587 = BgL_new1141z00_2592; } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5961;
{ /* Eval/evaluate.scm 567 */
obj_t BgL_arg2314z00_2588;
{ /* Eval/evaluate.scm 567 */
obj_t BgL_arg2316z00_2590;
BgL_arg2316z00_2590 = 
CDR(BgL_tidz00_2586); 
BgL_arg2314z00_2588 = 
BGl_typezd2resultzd2zz__evaluatez00(BgL_arg2316z00_2590, BgL_gez00_1513, BgL_locz00_74); } 
{ 
obj_t BgL_auxz00_5965;
BgL_ez00_2639 = BgL_arg2314z00_2588; 
if(BgL_topzf3zf3_75)
{ /* Eval/evaluate.scm 568 */
BgL_wherez00_2640 = BgL_gvz00_1512; }  else 
{ /* Eval/evaluate.scm 568 */
BgL_wherez00_2640 = BgL_wherez00_73; } 
BgL_ez00_2629 = BgL_ez00_2639; 
BgL_locz00_2630 = 
BGl_getzd2locationzd2zz__evaluatez00(BgL_ez00_2639, BgL_locz00_74); 
BgL_wherez00_2631 = BgL_wherez00_2640; 
BgL_auxz00_5965 = 
BGl_convz00zz__evaluatez00(BgL_ez00_2629, BgL_localsz00_70, BgL_globalsz00_71, BFALSE, BgL_wherez00_2631, BgL_locz00_2630, ((bool_t)0)); 
BgL_auxz00_5961 = 
((BgL_ev_exprz00_bglt)BgL_auxz00_5965); } } 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)BgL_new1142z00_2587)))->BgL_ez00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5961),BUNSPEC); } 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_new1142z00_2587)))->BgL_locz00)=((obj_t)BgL_locz00_74),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_new1142z00_2587)))->BgL_namez00)=((obj_t)
CAR(BgL_tidz00_2586)),BUNSPEC); 
{ 
obj_t BgL_auxz00_5976;
if(
BGl_evmodulezf3zf3zz__evmodulez00(BgL_globalsz00_71))
{ /* Eval/evaluate.scm 565 */
BgL_auxz00_5976 = BgL_globalsz00_71
; }  else 
{ /* Eval/evaluate.scm 565 */
BgL_auxz00_5976 = 
BGL_MODULE()
; } 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_new1142z00_2587)))->BgL_modz00)=((obj_t)BgL_auxz00_5976),BUNSPEC); } 
BgL_auxz00_5955 = BgL_new1142z00_2587; } } 
return 
((obj_t)BgL_auxz00_5955);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1782z00_1824;obj_t BgL_arg1783z00_1825;
BgL_arg1782z00_1824 = 
CAR(BgL_ez00_69); 
BgL_arg1783z00_1825 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_5985;
{ 
obj_t BgL_argsz00_5987;obj_t BgL_fz00_5986;
BgL_fz00_5986 = BgL_arg1782z00_1824; 
BgL_argsz00_5987 = BgL_arg1783z00_1825; 
BgL_argsz00_1535 = BgL_argsz00_5987; 
BgL_fz00_1534 = BgL_fz00_5986; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_5985);} } } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd27757zd2_1829;
BgL_cdrzd27757zd2_1829 = 
CDR(
((obj_t)BgL_cdrzd27552zd2_1794)); 
if(
NULLP(
CDR(
((obj_t)BgL_cdrzd27757zd2_1829))))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1788z00_1832;obj_t BgL_arg1789z00_1833;
BgL_arg1788z00_1832 = 
CAR(
((obj_t)BgL_cdrzd27552zd2_1794)); 
BgL_arg1789z00_1833 = 
CAR(
((obj_t)BgL_cdrzd27757zd2_1829)); 
{ 
BgL_ev_defglobalz00_bglt BgL_auxz00_5999;
{ 
obj_t BgL_gez00_6001;obj_t BgL_gvz00_6000;
BgL_gvz00_6000 = BgL_arg1788z00_1832; 
BgL_gez00_6001 = BgL_arg1789z00_1833; 
BgL_gez00_1513 = BgL_gez00_6001; 
BgL_gvz00_1512 = BgL_gvz00_6000; 
goto BgL_tagzd2168zd2_1514;} 
return 
((obj_t)BgL_auxz00_5999);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1790z00_1834;obj_t BgL_arg1791z00_1835;
BgL_arg1790z00_1834 = 
CAR(BgL_ez00_69); 
BgL_arg1791z00_1835 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6005;
{ 
obj_t BgL_argsz00_6007;obj_t BgL_fz00_6006;
BgL_fz00_6006 = BgL_arg1790z00_1834; 
BgL_argsz00_6007 = BgL_arg1791z00_1835; 
BgL_argsz00_1535 = BgL_argsz00_6007; 
BgL_fz00_1534 = BgL_fz00_6006; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_6005);} } } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd27844zd2_1838;
BgL_cdrzd27844zd2_1838 = 
CDR(
((obj_t)BgL_cdrzd27552zd2_1794)); 
if(
NULLP(
CDR(
((obj_t)BgL_cdrzd27844zd2_1838))))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1795z00_1841;obj_t BgL_arg1796z00_1842;
BgL_arg1795z00_1841 = 
CAR(
((obj_t)BgL_cdrzd27552zd2_1794)); 
BgL_arg1796z00_1842 = 
CAR(
((obj_t)BgL_cdrzd27844zd2_1838)); 
{ 
BgL_ev_defglobalz00_bglt BgL_auxz00_6019;
{ 
obj_t BgL_gez00_6021;obj_t BgL_gvz00_6020;
BgL_gvz00_6020 = BgL_arg1795z00_1841; 
BgL_gez00_6021 = BgL_arg1796z00_1842; 
BgL_gez00_1513 = BgL_gez00_6021; 
BgL_gvz00_1512 = BgL_gvz00_6020; 
goto BgL_tagzd2168zd2_1514;} 
return 
((obj_t)BgL_auxz00_6019);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1797z00_1843;obj_t BgL_arg1798z00_1844;
BgL_arg1797z00_1843 = 
CAR(BgL_ez00_69); 
BgL_arg1798z00_1844 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6025;
{ 
obj_t BgL_argsz00_6027;obj_t BgL_fz00_6026;
BgL_fz00_6026 = BgL_arg1797z00_1843; 
BgL_argsz00_6027 = BgL_arg1798z00_1844; 
BgL_argsz00_1535 = BgL_argsz00_6027; 
BgL_fz00_1534 = BgL_fz00_6026; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_6025);} } } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd27931zd2_1847;
BgL_cdrzd27931zd2_1847 = 
CDR(
((obj_t)BgL_cdrzd27552zd2_1794)); 
if(
NULLP(
CDR(
((obj_t)BgL_cdrzd27931zd2_1847))))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1802z00_1850;obj_t BgL_arg1803z00_1851;
BgL_arg1802z00_1850 = 
CAR(
((obj_t)BgL_cdrzd27552zd2_1794)); 
BgL_arg1803z00_1851 = 
CAR(
((obj_t)BgL_cdrzd27931zd2_1847)); 
{ 
BgL_ev_defglobalz00_bglt BgL_auxz00_6039;
{ 
obj_t BgL_gez00_6041;obj_t BgL_gvz00_6040;
BgL_gvz00_6040 = BgL_arg1802z00_1850; 
BgL_gez00_6041 = BgL_arg1803z00_1851; 
BgL_gez00_1513 = BgL_gez00_6041; 
BgL_gvz00_1512 = BgL_gvz00_6040; 
goto BgL_tagzd2168zd2_1514;} 
return 
((obj_t)BgL_auxz00_6039);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1804z00_1852;obj_t BgL_arg1805z00_1853;
BgL_arg1804z00_1852 = 
CAR(BgL_ez00_69); 
BgL_arg1805z00_1853 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6045;
{ 
obj_t BgL_argsz00_6047;obj_t BgL_fz00_6046;
BgL_fz00_6046 = BgL_arg1804z00_1852; 
BgL_argsz00_6047 = BgL_arg1805z00_1853; 
BgL_argsz00_1535 = BgL_argsz00_6047; 
BgL_fz00_1534 = BgL_fz00_6046; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_6045);} } } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd28018zd2_1857;
BgL_cdrzd28018zd2_1857 = 
CDR(
((obj_t)BgL_cdrzd27552zd2_1794)); 
if(
NULLP(
CDR(
((obj_t)BgL_cdrzd28018zd2_1857))))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1810z00_1860;obj_t BgL_arg1811z00_1861;
BgL_arg1810z00_1860 = 
CAR(
((obj_t)BgL_cdrzd27552zd2_1794)); 
BgL_arg1811z00_1861 = 
CAR(
((obj_t)BgL_cdrzd28018zd2_1857)); 
{ 
BgL_ev_defglobalz00_bglt BgL_auxz00_6059;
{ 
obj_t BgL_gez00_6061;obj_t BgL_gvz00_6060;
BgL_gvz00_6060 = BgL_arg1810z00_1860; 
BgL_gez00_6061 = BgL_arg1811z00_1861; 
BgL_gez00_1513 = BgL_gez00_6061; 
BgL_gvz00_1512 = BgL_gvz00_6060; 
goto BgL_tagzd2168zd2_1514;} 
return 
((obj_t)BgL_auxz00_6059);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1812z00_1862;obj_t BgL_arg1813z00_1863;
BgL_arg1812z00_1862 = 
CAR(BgL_ez00_69); 
BgL_arg1813z00_1863 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6065;
{ 
obj_t BgL_argsz00_6067;obj_t BgL_fz00_6066;
BgL_fz00_6066 = BgL_arg1812z00_1862; 
BgL_argsz00_6067 = BgL_arg1813z00_1863; 
BgL_argsz00_1535 = BgL_argsz00_6067; 
BgL_fz00_1534 = BgL_fz00_6066; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_6065);} } } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1815z00_1865;
BgL_arg1815z00_1865 = 
CAR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6070;
{ 
obj_t BgL_argsz00_6072;obj_t BgL_fz00_6071;
BgL_fz00_6071 = BgL_arg1815z00_1865; 
BgL_argsz00_6072 = BgL_cdrzd27552zd2_1794; 
BgL_argsz00_1535 = BgL_argsz00_6072; 
BgL_fz00_1534 = BgL_fz00_6071; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_6070);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1817z00_1867;
BgL_arg1817z00_1867 = 
CAR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6075;
{ 
obj_t BgL_argsz00_6077;obj_t BgL_fz00_6076;
BgL_fz00_6076 = BgL_arg1817z00_1867; 
BgL_argsz00_6077 = BgL_cdrzd27552zd2_1794; 
BgL_argsz00_1535 = BgL_argsz00_6077; 
BgL_fz00_1534 = BgL_fz00_6076; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_6075);} } }  else 
{ /* Eval/evaluate.scm 424 */
if(
(
CAR(BgL_ez00_69)==BGl_symbol3097z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd27552zd2_1794))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_carzd28260zd2_1873;
BgL_carzd28260zd2_1873 = 
CAR(BgL_cdrzd27552zd2_1794); 
if(
PAIRP(BgL_carzd28260zd2_1873))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_carzd28260zd2_1873)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1825z00_1877;obj_t BgL_arg1826z00_1878;
BgL_arg1825z00_1877 = 
CAR(BgL_carzd28260zd2_1873); 
BgL_arg1826z00_1878 = 
CDR(BgL_cdrzd27552zd2_1794); 
{ 
BgL_ev_bindzd2exitzd2_bglt BgL_auxz00_6092;
BgL_vz00_1515 = BgL_arg1825z00_1877; 
BgL_bodyz00_1516 = BgL_arg1826z00_1878; 
BgL_tagzd2169zd2_1517:
{ /* Eval/evaluate.scm 570 */
BgL_ev_varz00_bglt BgL_varz00_2594;
{ /* Eval/evaluate.scm 570 */
BgL_ev_varz00_bglt BgL_new1144z00_2599;
{ /* Eval/evaluate.scm 570 */
BgL_ev_varz00_bglt BgL_new1143z00_2600;
BgL_new1143z00_2600 = 
((BgL_ev_varz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_varz00_bgl) ))); 
{ /* Eval/evaluate.scm 570 */
long BgL_arg2321z00_2601;
{ /* Eval/evaluate.scm 570 */
long BgL_res2786z00_3526;
BgL_res2786z00_3526 = 
BGL_CLASS_INDEX(BGl_ev_varz00zz__evaluate_typesz00); 
BgL_arg2321z00_2601 = BgL_res2786z00_3526; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1143z00_2600), BgL_arg2321z00_2601); } 
BgL_new1144z00_2599 = BgL_new1143z00_2600; } 
((((BgL_ev_varz00_bglt)COBJECT(BgL_new1144z00_2599))->BgL_namez00)=((obj_t)BgL_vz00_1515),BUNSPEC); 
((((BgL_ev_varz00_bglt)COBJECT(BgL_new1144z00_2599))->BgL_effz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_ev_varz00_bglt)COBJECT(BgL_new1144z00_2599))->BgL_typez00)=((obj_t)BFALSE),BUNSPEC); 
BgL_varz00_2594 = BgL_new1144z00_2599; } 
{ /* Eval/evaluate.scm 571 */
BgL_ev_bindzd2exitzd2_bglt BgL_new1146z00_2595;
{ /* Eval/evaluate.scm 572 */
BgL_ev_bindzd2exitzd2_bglt BgL_new1145z00_2597;
BgL_new1145z00_2597 = 
((BgL_ev_bindzd2exitzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_bindzd2exitzd2_bgl) ))); 
{ /* Eval/evaluate.scm 572 */
long BgL_arg2320z00_2598;
{ /* Eval/evaluate.scm 572 */
long BgL_res2787z00_3530;
BgL_res2787z00_3530 = 
BGL_CLASS_INDEX(BGl_ev_bindzd2exitzd2zz__evaluate_typesz00); 
BgL_arg2320z00_2598 = BgL_res2787z00_3530; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1145z00_2597), BgL_arg2320z00_2598); } 
BgL_new1146z00_2595 = BgL_new1145z00_2597; } 
((((BgL_ev_bindzd2exitzd2_bglt)COBJECT(BgL_new1146z00_2595))->BgL_varz00)=((BgL_ev_varz00_bglt)BgL_varz00_2594),BUNSPEC); 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_6105;
{ /* Eval/evaluate.scm 573 */
obj_t BgL_arg2319z00_2596;
BgL_arg2319z00_2596 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_varz00_2594), BgL_localsz00_70); 
BgL_auxz00_6105 = 
((BgL_ev_exprz00_bglt)
BGl_convzd2beginzd2zz__evaluatez00(BgL_bodyz00_1516, BgL_arg2319z00_2596, BgL_globalsz00_71, BFALSE, BgL_wherez00_73, BgL_locz00_74, ((bool_t)0))); } 
((((BgL_ev_bindzd2exitzd2_bglt)COBJECT(BgL_new1146z00_2595))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_6105),BUNSPEC); } 
BgL_auxz00_6092 = BgL_new1146z00_2595; } } 
return 
((obj_t)BgL_auxz00_6092);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1827z00_1879;obj_t BgL_arg1828z00_1880;
BgL_arg1827z00_1879 = 
CAR(BgL_ez00_69); 
BgL_arg1828z00_1880 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6114;
{ 
obj_t BgL_argsz00_6116;obj_t BgL_fz00_6115;
BgL_fz00_6115 = BgL_arg1827z00_1879; 
BgL_argsz00_6116 = BgL_arg1828z00_1880; 
BgL_argsz00_1535 = BgL_argsz00_6116; 
BgL_fz00_1534 = BgL_fz00_6115; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_6114);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1830z00_1882;obj_t BgL_arg1831z00_1883;
BgL_arg1830z00_1882 = 
CAR(BgL_ez00_69); 
BgL_arg1831z00_1883 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6120;
{ 
obj_t BgL_argsz00_6122;obj_t BgL_fz00_6121;
BgL_fz00_6121 = BgL_arg1830z00_1882; 
BgL_argsz00_6122 = BgL_arg1831z00_1883; 
BgL_argsz00_1535 = BgL_argsz00_6122; 
BgL_fz00_1534 = BgL_fz00_6121; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_6120);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1832z00_1884;obj_t BgL_arg1833z00_1885;
BgL_arg1832z00_1884 = 
CAR(BgL_ez00_69); 
BgL_arg1833z00_1885 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6126;
{ 
obj_t BgL_argsz00_6128;obj_t BgL_fz00_6127;
BgL_fz00_6127 = BgL_arg1832z00_1884; 
BgL_argsz00_6128 = BgL_arg1833z00_1885; 
BgL_argsz00_1535 = BgL_argsz00_6128; 
BgL_fz00_1534 = BgL_fz00_6127; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_6126);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd28425zd2_1886;
BgL_cdrzd28425zd2_1886 = 
CDR(BgL_ez00_69); 
if(
(
CAR(BgL_ez00_69)==BGl_symbol3099z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd28425zd2_1886))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1837z00_1890;obj_t BgL_arg1838z00_1891;
BgL_arg1837z00_1890 = 
CAR(BgL_cdrzd28425zd2_1886); 
BgL_arg1838z00_1891 = 
CDR(BgL_cdrzd28425zd2_1886); 
{ 
BgL_ev_unwindzd2protectzd2_bglt BgL_auxz00_6138;
BgL_ez00_1518 = BgL_arg1837z00_1890; 
BgL_bodyz00_1519 = BgL_arg1838z00_1891; 
BgL_tagzd2170zd2_1520:
{ /* Eval/evaluate.scm 575 */
BgL_ev_unwindzd2protectzd2_bglt BgL_new1148z00_2602;
{ /* Eval/evaluate.scm 576 */
BgL_ev_unwindzd2protectzd2_bglt BgL_new1147z00_2603;
BgL_new1147z00_2603 = 
((BgL_ev_unwindzd2protectzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_unwindzd2protectzd2_bgl) ))); 
{ /* Eval/evaluate.scm 576 */
long BgL_arg2322z00_2604;
{ /* Eval/evaluate.scm 576 */
long BgL_res2788z00_3534;
BgL_res2788z00_3534 = 
BGL_CLASS_INDEX(BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00); 
BgL_arg2322z00_2604 = BgL_res2788z00_3534; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1147z00_2603), BgL_arg2322z00_2604); } 
BgL_new1148z00_2602 = BgL_new1147z00_2603; } 
((((BgL_ev_unwindzd2protectzd2_bglt)COBJECT(BgL_new1148z00_2602))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)
BGl_uconvze70ze7zz__evaluatez00(BgL_locz00_74, BgL_wherez00_73, BgL_globalsz00_71, BgL_localsz00_70, BgL_ez00_1518))),BUNSPEC); 
((((BgL_ev_unwindzd2protectzd2_bglt)COBJECT(BgL_new1148z00_2602))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)
BGl_convzd2beginzd2zz__evaluatez00(BgL_bodyz00_1519, BgL_localsz00_70, BgL_globalsz00_71, BFALSE, BgL_wherez00_73, BgL_locz00_74, ((bool_t)0)))),BUNSPEC); 
BgL_auxz00_6138 = BgL_new1148z00_2602; } 
return 
((obj_t)BgL_auxz00_6138);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1839z00_1892;
BgL_arg1839z00_1892 = 
CAR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6151;
{ 
obj_t BgL_argsz00_6153;obj_t BgL_fz00_6152;
BgL_fz00_6152 = BgL_arg1839z00_1892; 
BgL_argsz00_6153 = BgL_cdrzd28425zd2_1886; 
BgL_argsz00_1535 = BgL_argsz00_6153; 
BgL_fz00_1534 = BgL_fz00_6152; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_6151);} } }  else 
{ /* Eval/evaluate.scm 424 */
if(
(
CAR(BgL_ez00_69)==BGl_symbol3101z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd28425zd2_1886))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1844z00_1898;obj_t BgL_arg1845z00_1899;
BgL_arg1844z00_1898 = 
CAR(BgL_cdrzd28425zd2_1886); 
BgL_arg1845z00_1899 = 
CDR(BgL_cdrzd28425zd2_1886); 
{ 
BgL_ev_withzd2handlerzd2_bglt BgL_auxz00_6162;
BgL_hz00_1521 = BgL_arg1844z00_1898; 
BgL_bodyz00_1522 = BgL_arg1845z00_1899; 
BgL_tagzd2171zd2_1523:
{ /* Eval/evaluate.scm 579 */
BgL_ev_withzd2handlerzd2_bglt BgL_new1150z00_2605;
{ /* Eval/evaluate.scm 580 */
BgL_ev_withzd2handlerzd2_bglt BgL_new1149z00_2606;
BgL_new1149z00_2606 = 
((BgL_ev_withzd2handlerzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_withzd2handlerzd2_bgl) ))); 
{ /* Eval/evaluate.scm 580 */
long BgL_arg2323z00_2607;
{ /* Eval/evaluate.scm 580 */
long BgL_res2789z00_3538;
BgL_res2789z00_3538 = 
BGL_CLASS_INDEX(BGl_ev_withzd2handlerzd2zz__evaluate_typesz00); 
BgL_arg2323z00_2607 = BgL_res2789z00_3538; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1149z00_2606), BgL_arg2323z00_2607); } 
BgL_new1150z00_2605 = BgL_new1149z00_2606; } 
((((BgL_ev_withzd2handlerzd2_bglt)COBJECT(BgL_new1150z00_2605))->BgL_handlerz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)
BGl_uconvze70ze7zz__evaluatez00(BgL_locz00_74, BgL_wherez00_73, BgL_globalsz00_71, BgL_localsz00_70, BgL_hz00_1521))),BUNSPEC); 
((((BgL_ev_withzd2handlerzd2_bglt)COBJECT(BgL_new1150z00_2605))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)
BGl_convzd2beginzd2zz__evaluatez00(BgL_bodyz00_1522, BgL_localsz00_70, BgL_globalsz00_71, BFALSE, BgL_wherez00_73, BgL_locz00_74, ((bool_t)0)))),BUNSPEC); 
BgL_auxz00_6162 = BgL_new1150z00_2605; } 
return 
((obj_t)BgL_auxz00_6162);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1846z00_1900;obj_t BgL_arg1847z00_1901;
BgL_arg1846z00_1900 = 
CAR(BgL_ez00_69); 
BgL_arg1847z00_1901 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6176;
{ 
obj_t BgL_argsz00_6178;obj_t BgL_fz00_6177;
BgL_fz00_6177 = BgL_arg1846z00_1900; 
BgL_argsz00_6178 = BgL_arg1847z00_1901; 
BgL_argsz00_1535 = BgL_argsz00_6178; 
BgL_fz00_1534 = BgL_fz00_6177; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_6176);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd28528zd2_1902;
BgL_cdrzd28528zd2_1902 = 
CDR(BgL_ez00_69); 
if(
(
CAR(BgL_ez00_69)==BGl_symbol3103z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd28528zd2_1902))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd28533zd2_1906;
BgL_cdrzd28533zd2_1906 = 
CDR(BgL_cdrzd28528zd2_1902); 
if(
PAIRP(BgL_cdrzd28533zd2_1906))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd28538zd2_1908;
BgL_cdrzd28538zd2_1908 = 
CDR(BgL_cdrzd28533zd2_1906); 
if(
(
CAR(BgL_cdrzd28533zd2_1906)==BGl_keyword3105z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd28538zd2_1908))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1855z00_1912;obj_t BgL_arg1856z00_1913;obj_t BgL_arg1857z00_1914;
BgL_arg1855z00_1912 = 
CAR(BgL_cdrzd28528zd2_1902); 
BgL_arg1856z00_1913 = 
CAR(BgL_cdrzd28538zd2_1908); 
BgL_arg1857z00_1914 = 
CDR(BgL_cdrzd28538zd2_1908); 
{ 
BgL_ev_synchroniza7eza7_bglt BgL_auxz00_6198;
BgL_mz00_1524 = BgL_arg1855z00_1912; 
BgL_pz00_1525 = BgL_arg1856z00_1913; 
BgL_bodyz00_1526 = BgL_arg1857z00_1914; 
BgL_tagzd2172zd2_1527:
{ /* Eval/evaluate.scm 583 */
BgL_ev_synchroniza7eza7_bglt BgL_new1152z00_2608;
{ /* Eval/evaluate.scm 584 */
BgL_ev_synchroniza7eza7_bglt BgL_new1151z00_2609;
BgL_new1151z00_2609 = 
((BgL_ev_synchroniza7eza7_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_synchroniza7eza7_bgl) ))); 
{ /* Eval/evaluate.scm 584 */
long BgL_arg2324z00_2610;
{ /* Eval/evaluate.scm 584 */
long BgL_res2790z00_3542;
BgL_res2790z00_3542 = 
BGL_CLASS_INDEX(BGl_ev_synchroniza7eza7zz__evaluate_typesz00); 
BgL_arg2324z00_2610 = BgL_res2790z00_3542; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1151z00_2609), BgL_arg2324z00_2610); } 
BgL_new1152z00_2608 = BgL_new1151z00_2609; } 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(BgL_new1152z00_2608))->BgL_locz00)=((obj_t)BgL_locz00_74),BUNSPEC); 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(BgL_new1152z00_2608))->BgL_mutexz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)
BGl_uconvze70ze7zz__evaluatez00(BgL_locz00_74, BgL_wherez00_73, BgL_globalsz00_71, BgL_localsz00_70, BgL_mz00_1524))),BUNSPEC); 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(BgL_new1152z00_2608))->BgL_prelockz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)
BGl_uconvze70ze7zz__evaluatez00(BgL_locz00_74, BgL_wherez00_73, BgL_globalsz00_71, BgL_localsz00_70, BgL_pz00_1525))),BUNSPEC); 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(BgL_new1152z00_2608))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)
BGl_convzd2beginzd2zz__evaluatez00(BgL_bodyz00_1526, BgL_localsz00_70, BgL_globalsz00_71, BFALSE, BgL_wherez00_73, BgL_locz00_74, ((bool_t)0)))),BUNSPEC); 
BgL_auxz00_6198 = BgL_new1152z00_2608; } 
return 
((obj_t)BgL_auxz00_6198);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1858z00_1916;obj_t BgL_arg1859z00_1917;
BgL_arg1858z00_1916 = 
CAR(
((obj_t)BgL_cdrzd28528zd2_1902)); 
BgL_arg1859z00_1917 = 
CDR(
((obj_t)BgL_cdrzd28528zd2_1902)); 
{ 
BgL_ev_synchroniza7eza7_bglt BgL_auxz00_6218;
BgL_mz00_1528 = BgL_arg1858z00_1916; 
BgL_bodyz00_1529 = BgL_arg1859z00_1917; 
BgL_tagzd2173zd2_1530:
{ /* Eval/evaluate.scm 589 */
BgL_ev_synchroniza7eza7_bglt BgL_new1154z00_2611;
{ /* Eval/evaluate.scm 590 */
BgL_ev_synchroniza7eza7_bglt BgL_new1153z00_2612;
BgL_new1153z00_2612 = 
((BgL_ev_synchroniza7eza7_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_synchroniza7eza7_bgl) ))); 
{ /* Eval/evaluate.scm 590 */
long BgL_arg2325z00_2613;
{ /* Eval/evaluate.scm 590 */
long BgL_res2791z00_3546;
BgL_res2791z00_3546 = 
BGL_CLASS_INDEX(BGl_ev_synchroniza7eza7zz__evaluate_typesz00); 
BgL_arg2325z00_2613 = BgL_res2791z00_3546; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1153z00_2612), BgL_arg2325z00_2613); } 
BgL_new1154z00_2611 = BgL_new1153z00_2612; } 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(BgL_new1154z00_2611))->BgL_locz00)=((obj_t)BgL_locz00_74),BUNSPEC); 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(BgL_new1154z00_2611))->BgL_mutexz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)
BGl_uconvze70ze7zz__evaluatez00(BgL_locz00_74, BgL_wherez00_73, BgL_globalsz00_71, BgL_localsz00_70, BgL_mz00_1528))),BUNSPEC); 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(BgL_new1154z00_2611))->BgL_prelockz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)
BGl_uconvze70ze7zz__evaluatez00(BgL_locz00_74, BgL_wherez00_73, BgL_globalsz00_71, BgL_localsz00_70, BNIL))),BUNSPEC); 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(BgL_new1154z00_2611))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)
BGl_convzd2beginzd2zz__evaluatez00(BgL_bodyz00_1529, BgL_localsz00_70, BgL_globalsz00_71, BFALSE, BgL_wherez00_73, BgL_locz00_74, ((bool_t)0)))),BUNSPEC); 
BgL_auxz00_6218 = BgL_new1154z00_2611; } 
return 
((obj_t)BgL_auxz00_6218);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1860z00_1919;obj_t BgL_arg1861z00_1920;
BgL_arg1860z00_1919 = 
CAR(
((obj_t)BgL_cdrzd28528zd2_1902)); 
BgL_arg1861z00_1920 = 
CDR(
((obj_t)BgL_cdrzd28528zd2_1902)); 
{ 
BgL_ev_synchroniza7eza7_bglt BgL_auxz00_6238;
{ 
obj_t BgL_bodyz00_6240;obj_t BgL_mz00_6239;
BgL_mz00_6239 = BgL_arg1860z00_1919; 
BgL_bodyz00_6240 = BgL_arg1861z00_1920; 
BgL_bodyz00_1529 = BgL_bodyz00_6240; 
BgL_mz00_1528 = BgL_mz00_6239; 
goto BgL_tagzd2173zd2_1530;} 
return 
((obj_t)BgL_auxz00_6238);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1863z00_1923;obj_t BgL_arg1864z00_1924;
BgL_arg1863z00_1923 = 
CAR(
((obj_t)BgL_cdrzd28528zd2_1902)); 
BgL_arg1864z00_1924 = 
CDR(
((obj_t)BgL_cdrzd28528zd2_1902)); 
{ 
BgL_ev_synchroniza7eza7_bglt BgL_auxz00_6246;
{ 
obj_t BgL_bodyz00_6248;obj_t BgL_mz00_6247;
BgL_mz00_6247 = BgL_arg1863z00_1923; 
BgL_bodyz00_6248 = BgL_arg1864z00_1924; 
BgL_bodyz00_1529 = BgL_bodyz00_6248; 
BgL_mz00_1528 = BgL_mz00_6247; 
goto BgL_tagzd2173zd2_1530;} 
return 
((obj_t)BgL_auxz00_6246);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1865z00_1925;
BgL_arg1865z00_1925 = 
CAR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6251;
{ 
obj_t BgL_argsz00_6253;obj_t BgL_fz00_6252;
BgL_fz00_6252 = BgL_arg1865z00_1925; 
BgL_argsz00_6253 = BgL_cdrzd28528zd2_1902; 
BgL_argsz00_1535 = BgL_argsz00_6253; 
BgL_fz00_1534 = BgL_fz00_6252; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_6251);} } }  else 
{ /* Eval/evaluate.scm 424 */
if(
(
CAR(BgL_ez00_69)==BGl_symbol3058z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd28528zd2_1902))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd28638zd2_1931;
BgL_cdrzd28638zd2_1931 = 
CDR(BgL_cdrzd28528zd2_1902); 
if(
PAIRP(BgL_cdrzd28638zd2_1931))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd28638zd2_1931)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1873z00_1935;obj_t BgL_arg1874z00_1936;
BgL_arg1873z00_1935 = 
CAR(BgL_cdrzd28528zd2_1902); 
BgL_arg1874z00_1936 = 
CAR(BgL_cdrzd28638zd2_1931); 
{ 
BgL_ev_absz00_bglt BgL_auxz00_6268;
BgL_formalsz00_1531 = BgL_arg1873z00_1935; 
BgL_bodyz00_1532 = BgL_arg1874z00_1936; 
BgL_tagzd2174zd2_1533:
{ /* Eval/evaluate.scm 595 */
obj_t BgL_arg2326z00_2614;
{ /* Eval/evaluate.scm 595 */
obj_t BgL_arg2327z00_2615;
{ /* Eval/evaluate.scm 595 */
obj_t BgL_arg2328z00_2616;obj_t BgL_arg2329z00_2617;
{ /* Eval/evaluate.scm 595 */
obj_t BgL_res2792z00_3551;
{ /* Eval/evaluate.scm 595 */
obj_t BgL_symbolz00_3549;
BgL_symbolz00_3549 = BGl_symbol3069z00zz__evaluatez00; 
{ /* Eval/evaluate.scm 595 */
obj_t BgL_arg2496z00_3550;
BgL_arg2496z00_3550 = 
SYMBOL_TO_STRING(BgL_symbolz00_3549); 
BgL_res2792z00_3551 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg2496z00_3550); } } 
BgL_arg2328z00_2616 = BgL_res2792z00_3551; } 
{ /* Eval/evaluate.scm 595 */
obj_t BgL_res2793z00_3554;
{ /* Eval/evaluate.scm 595 */
obj_t BgL_arg2496z00_3553;
BgL_arg2496z00_3553 = 
SYMBOL_TO_STRING(
((obj_t)BgL_wherez00_73)); 
BgL_res2793z00_3554 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg2496z00_3553); } 
BgL_arg2329z00_2617 = BgL_res2793z00_3554; } 
BgL_arg2327z00_2615 = 
string_append(BgL_arg2328z00_2616, BgL_arg2329z00_2617); } 
BgL_arg2326z00_2614 = 
bstring_to_symbol(BgL_arg2327z00_2615); } 
BgL_auxz00_6268 = 
BGl_convzd2lambdaze70z35zz__evaluatez00(BgL_globalsz00_71, BgL_localsz00_70, BgL_ez00_69, BgL_locz00_74, BgL_formalsz00_1531, BgL_bodyz00_1532, BgL_arg2326z00_2614, BFALSE); } 
return 
((obj_t)BgL_auxz00_6268);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1875z00_1937;obj_t BgL_arg1876z00_1938;
BgL_arg1875z00_1937 = 
CAR(BgL_ez00_69); 
BgL_arg1876z00_1938 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6280;
{ 
obj_t BgL_argsz00_6282;obj_t BgL_fz00_6281;
BgL_fz00_6281 = BgL_arg1875z00_1937; 
BgL_argsz00_6282 = BgL_arg1876z00_1938; 
BgL_argsz00_1535 = BgL_argsz00_6282; 
BgL_fz00_1534 = BgL_fz00_6281; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_6280);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1878z00_1940;obj_t BgL_arg1879z00_1941;
BgL_arg1878z00_1940 = 
CAR(BgL_ez00_69); 
BgL_arg1879z00_1941 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6286;
{ 
obj_t BgL_argsz00_6288;obj_t BgL_fz00_6287;
BgL_fz00_6287 = BgL_arg1878z00_1940; 
BgL_argsz00_6288 = BgL_arg1879z00_1941; 
BgL_argsz00_1535 = BgL_argsz00_6288; 
BgL_fz00_1534 = BgL_fz00_6287; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_6286);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1880z00_1942;obj_t BgL_arg1881z00_1943;
BgL_arg1880z00_1942 = 
CAR(BgL_ez00_69); 
BgL_arg1881z00_1943 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6292;
{ 
obj_t BgL_argsz00_6294;obj_t BgL_fz00_6293;
BgL_fz00_6293 = BgL_arg1880z00_1942; 
BgL_argsz00_6294 = BgL_arg1881z00_1943; 
BgL_argsz00_1535 = BgL_argsz00_6294; 
BgL_fz00_1534 = BgL_fz00_6293; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_6292);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1882z00_1944;obj_t BgL_arg1883z00_1945;
BgL_arg1882z00_1944 = 
CAR(BgL_ez00_69); 
BgL_arg1883z00_1945 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6298;
{ 
obj_t BgL_argsz00_6300;obj_t BgL_fz00_6299;
BgL_fz00_6299 = BgL_arg1882z00_1944; 
BgL_argsz00_6300 = BgL_arg1883z00_1945; 
BgL_argsz00_1535 = BgL_argsz00_6300; 
BgL_fz00_1534 = BgL_fz00_6299; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_6298);} } } } } } } } } } } } } } } } } } }  else 
{ /* Eval/evaluate.scm 424 */
if(
(BgL_carzd23820zd2_1609==BGl_symbol3083z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd2249zd2_1543))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd2249zd2_1543)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1905z00_1969;
BgL_arg1905z00_1969 = 
CAR(BgL_cdrzd2249zd2_1543); 
{ 
BgL_ev_trapz00_bglt BgL_auxz00_6310;
{ 
obj_t BgL_ez00_6311;
BgL_ez00_6311 = BgL_arg1905z00_1969; 
BgL_ez00_1471 = BgL_ez00_6311; 
goto BgL_tagzd2153zd2_1472;} 
return 
((obj_t)BgL_auxz00_6310);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1906z00_1970;obj_t BgL_arg1907z00_1971;
BgL_arg1906z00_1970 = 
CAR(BgL_ez00_69); 
BgL_arg1907z00_1971 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6315;
{ 
obj_t BgL_argsz00_6317;obj_t BgL_fz00_6316;
BgL_fz00_6316 = BgL_arg1906z00_1970; 
BgL_argsz00_6317 = BgL_arg1907z00_1971; 
BgL_argsz00_1535 = BgL_argsz00_6317; 
BgL_fz00_1534 = BgL_fz00_6316; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_6315);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1909z00_1973;obj_t BgL_arg1910z00_1974;
BgL_arg1909z00_1973 = 
CAR(BgL_ez00_69); 
BgL_arg1910z00_1974 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6321;
{ 
obj_t BgL_argsz00_6323;obj_t BgL_fz00_6322;
BgL_fz00_6322 = BgL_arg1909z00_1973; 
BgL_argsz00_6323 = BgL_arg1910z00_1974; 
BgL_argsz00_1535 = BgL_argsz00_6323; 
BgL_fz00_1534 = BgL_fz00_6322; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_6321);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd29337zd2_1975;
BgL_cdrzd29337zd2_1975 = 
CDR(BgL_ez00_69); 
if(
(
CAR(BgL_ez00_69)==BGl_symbol3046z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd29337zd2_1975))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd29337zd2_1975)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1916z00_1981;
BgL_arg1916z00_1981 = 
CAR(BgL_cdrzd29337zd2_1975); 
{ 
BgL_ev_littz00_bglt BgL_auxz00_6335;
{ 
obj_t BgL_vz00_6336;
BgL_vz00_6336 = BgL_arg1916z00_1981; 
BgL_vz00_1473 = BgL_vz00_6336; 
goto BgL_tagzd2154zd2_1474;} 
return 
((obj_t)BgL_auxz00_6335);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1917z00_1982;
BgL_arg1917z00_1982 = 
CAR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6339;
{ 
obj_t BgL_argsz00_6341;obj_t BgL_fz00_6340;
BgL_fz00_6340 = BgL_arg1917z00_1982; 
BgL_argsz00_6341 = BgL_cdrzd29337zd2_1975; 
BgL_argsz00_1535 = BgL_argsz00_6341; 
BgL_fz00_1534 = BgL_fz00_6340; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_6339);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1920z00_1985;
BgL_arg1920z00_1985 = 
CAR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6344;
{ 
obj_t BgL_argsz00_6346;obj_t BgL_fz00_6345;
BgL_fz00_6345 = BgL_arg1920z00_1985; 
BgL_argsz00_6346 = BgL_cdrzd29337zd2_1975; 
BgL_argsz00_1535 = BgL_argsz00_6346; 
BgL_fz00_1534 = BgL_fz00_6345; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_6344);} } }  else 
{ /* Eval/evaluate.scm 424 */
if(
(
CAR(BgL_ez00_69)==BGl_symbol3054z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd29337zd2_1975))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd29947zd2_1991;
BgL_cdrzd29947zd2_1991 = 
CDR(BgL_cdrzd29337zd2_1975); 
if(
PAIRP(BgL_cdrzd29947zd2_1991))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd29952zd2_1993;
BgL_cdrzd29952zd2_1993 = 
CDR(BgL_cdrzd29947zd2_1991); 
if(
PAIRP(BgL_cdrzd29952zd2_1993))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd29952zd2_1993)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1929z00_1997;obj_t BgL_arg1930z00_1998;obj_t BgL_arg1931z00_1999;
BgL_arg1929z00_1997 = 
CAR(BgL_cdrzd29337zd2_1975); 
BgL_arg1930z00_1998 = 
CAR(BgL_cdrzd29947zd2_1991); 
BgL_arg1931z00_1999 = 
CAR(BgL_cdrzd29952zd2_1993); 
{ 
BgL_ev_ifz00_bglt BgL_auxz00_6365;
{ 
obj_t BgL_oz00_6368;obj_t BgL_tz00_6367;obj_t BgL_pz00_6366;
BgL_pz00_6366 = BgL_arg1929z00_1997; 
BgL_tz00_6367 = BgL_arg1930z00_1998; 
BgL_oz00_6368 = BgL_arg1931z00_1999; 
BgL_oz00_1477 = BgL_oz00_6368; 
BgL_tz00_1476 = BgL_tz00_6367; 
BgL_pz00_1475 = BgL_pz00_6366; 
goto BgL_tagzd2155zd2_1478;} 
return 
((obj_t)BgL_auxz00_6365);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1932z00_2000;obj_t BgL_arg1933z00_2001;
BgL_arg1932z00_2000 = 
CAR(BgL_ez00_69); 
BgL_arg1933z00_2001 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6372;
{ 
obj_t BgL_argsz00_6374;obj_t BgL_fz00_6373;
BgL_fz00_6373 = BgL_arg1932z00_2000; 
BgL_argsz00_6374 = BgL_arg1933z00_2001; 
BgL_argsz00_1535 = BgL_argsz00_6374; 
BgL_fz00_1534 = BgL_fz00_6373; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_6372);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd210250zd2_2003;
BgL_cdrzd210250zd2_2003 = 
CDR(BgL_ez00_69); 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd210256zd2_2004;
BgL_cdrzd210256zd2_2004 = 
CDR(
((obj_t)BgL_cdrzd210250zd2_2003)); 
if(
NULLP(
CDR(
((obj_t)BgL_cdrzd210256zd2_2004))))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1937z00_2007;obj_t BgL_arg1938z00_2008;
BgL_arg1937z00_2007 = 
CAR(
((obj_t)BgL_cdrzd210250zd2_2003)); 
BgL_arg1938z00_2008 = 
CAR(
((obj_t)BgL_cdrzd210256zd2_2004)); 
{ 
BgL_ev_ifz00_bglt BgL_auxz00_6387;
{ 
obj_t BgL_tz00_6389;obj_t BgL_pz00_6388;
BgL_pz00_6388 = BgL_arg1937z00_2007; 
BgL_tz00_6389 = BgL_arg1938z00_2008; 
BgL_tz00_1480 = BgL_tz00_6389; 
BgL_pz00_1479 = BgL_pz00_6388; 
goto BgL_tagzd2156zd2_1481;} 
return 
((obj_t)BgL_auxz00_6387);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1939z00_2009;
BgL_arg1939z00_2009 = 
CAR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6392;
{ 
obj_t BgL_argsz00_6394;obj_t BgL_fz00_6393;
BgL_fz00_6393 = BgL_arg1939z00_2009; 
BgL_argsz00_6394 = BgL_cdrzd210250zd2_2003; 
BgL_argsz00_1535 = BgL_argsz00_6394; 
BgL_fz00_1534 = BgL_fz00_6393; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_6392);} } } } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1942z00_2012;obj_t BgL_arg1943z00_2013;
BgL_arg1942z00_2012 = 
CAR(BgL_ez00_69); 
BgL_arg1943z00_2013 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6398;
{ 
obj_t BgL_argsz00_6400;obj_t BgL_fz00_6399;
BgL_fz00_6399 = BgL_arg1942z00_2012; 
BgL_argsz00_6400 = BgL_arg1943z00_2013; 
BgL_argsz00_1535 = BgL_argsz00_6400; 
BgL_fz00_1534 = BgL_fz00_6399; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_6398);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1944z00_2014;obj_t BgL_arg1945z00_2015;
BgL_arg1944z00_2014 = 
CAR(BgL_ez00_69); 
BgL_arg1945z00_2015 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6404;
{ 
obj_t BgL_argsz00_6406;obj_t BgL_fz00_6405;
BgL_fz00_6405 = BgL_arg1944z00_2014; 
BgL_argsz00_6406 = BgL_arg1945z00_2015; 
BgL_argsz00_1535 = BgL_argsz00_6406; 
BgL_fz00_1534 = BgL_fz00_6405; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_6404);} } }  else 
{ /* Eval/evaluate.scm 424 */
if(
(
CAR(BgL_ez00_69)==BGl_symbol3085z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1948z00_2018;
BgL_arg1948z00_2018 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_orz00_bglt BgL_auxz00_6412;
{ 
obj_t BgL_argsz00_6413;
BgL_argsz00_6413 = BgL_arg1948z00_2018; 
BgL_argsz00_1482 = BgL_argsz00_6413; 
goto BgL_tagzd2157zd2_1483;} 
return 
((obj_t)BgL_auxz00_6412);} }  else 
{ /* Eval/evaluate.scm 424 */
if(
(
CAR(BgL_ez00_69)==BGl_symbol3087z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1951z00_2021;
BgL_arg1951z00_2021 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_andz00_bglt BgL_auxz00_6419;
{ 
obj_t BgL_argsz00_6420;
BgL_argsz00_6420 = BgL_arg1951z00_2021; 
BgL_argsz00_1484 = BgL_argsz00_6420; 
goto BgL_tagzd2158zd2_1485;} 
return 
((obj_t)BgL_auxz00_6419);} }  else 
{ /* Eval/evaluate.scm 424 */
if(
(
CAR(BgL_ez00_69)==BGl_symbol3072z00zz__evaluatez00))
{ 
obj_t BgL_lz00_6425;
BgL_lz00_6425 = 
CDR(BgL_ez00_69); 
BgL_lz00_1486 = BgL_lz00_6425; 
goto BgL_tagzd2159zd2_1487;}  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd211149zd2_2025;
BgL_cdrzd211149zd2_2025 = 
CDR(BgL_ez00_69); 
if(
(
CAR(BgL_ez00_69)==BGl_symbol3056z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd211149zd2_2025))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1958z00_2029;obj_t BgL_arg1959z00_2030;
BgL_arg1958z00_2029 = 
CAR(BgL_cdrzd211149zd2_2025); 
BgL_arg1959z00_2030 = 
CDR(BgL_cdrzd211149zd2_2025); 
{ 
BgL_ev_letz00_bglt BgL_auxz00_6435;
{ 
obj_t BgL_bodyz00_6437;obj_t BgL_bindsz00_6436;
BgL_bindsz00_6436 = BgL_arg1958z00_2029; 
BgL_bodyz00_6437 = BgL_arg1959z00_2030; 
BgL_bodyz00_1489 = BgL_bodyz00_6437; 
BgL_bindsz00_1488 = BgL_bindsz00_6436; 
goto BgL_tagzd2160zd2_1490;} 
return 
((obj_t)BgL_auxz00_6435);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1960z00_2031;
BgL_arg1960z00_2031 = 
CAR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6440;
{ 
obj_t BgL_argsz00_6442;obj_t BgL_fz00_6441;
BgL_fz00_6441 = BgL_arg1960z00_2031; 
BgL_argsz00_6442 = BgL_cdrzd211149zd2_2025; 
BgL_argsz00_1535 = BgL_argsz00_6442; 
BgL_fz00_1534 = BgL_fz00_6441; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_6440);} } }  else 
{ /* Eval/evaluate.scm 424 */
if(
(
CAR(BgL_ez00_69)==BGl_symbol3089z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd211149zd2_2025))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1965z00_2037;obj_t BgL_arg1966z00_2038;
BgL_arg1965z00_2037 = 
CAR(BgL_cdrzd211149zd2_2025); 
BgL_arg1966z00_2038 = 
CDR(BgL_cdrzd211149zd2_2025); 
{ 
BgL_ev_letza2za2_bglt BgL_auxz00_6451;
{ 
obj_t BgL_bodyz00_6453;obj_t BgL_bindsz00_6452;
BgL_bindsz00_6452 = BgL_arg1965z00_2037; 
BgL_bodyz00_6453 = BgL_arg1966z00_2038; 
BgL_bodyz00_1492 = BgL_bodyz00_6453; 
BgL_bindsz00_1491 = BgL_bindsz00_6452; 
goto BgL_tagzd2161zd2_1493;} 
return 
((obj_t)BgL_auxz00_6451);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1967z00_2039;obj_t BgL_arg1968z00_2040;
BgL_arg1967z00_2039 = 
CAR(BgL_ez00_69); 
BgL_arg1968z00_2040 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6457;
{ 
obj_t BgL_argsz00_6459;obj_t BgL_fz00_6458;
BgL_fz00_6458 = BgL_arg1967z00_2039; 
BgL_argsz00_6459 = BgL_arg1968z00_2040; 
BgL_argsz00_1535 = BgL_argsz00_6459; 
BgL_fz00_1534 = BgL_fz00_6458; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_6457);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd211543zd2_2041;
BgL_cdrzd211543zd2_2041 = 
CDR(BgL_ez00_69); 
if(
(
CAR(BgL_ez00_69)==BGl_symbol3091z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd211543zd2_2041))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1972z00_2045;obj_t BgL_arg1973z00_2046;
BgL_arg1972z00_2045 = 
CAR(BgL_cdrzd211543zd2_2041); 
BgL_arg1973z00_2046 = 
CDR(BgL_cdrzd211543zd2_2041); 
{ 
BgL_ev_letrecz00_bglt BgL_auxz00_6469;
{ 
obj_t BgL_bodyz00_6471;obj_t BgL_bindsz00_6470;
BgL_bindsz00_6470 = BgL_arg1972z00_2045; 
BgL_bodyz00_6471 = BgL_arg1973z00_2046; 
BgL_bodyz00_1495 = BgL_bodyz00_6471; 
BgL_bindsz00_1494 = BgL_bindsz00_6470; 
goto BgL_tagzd2162zd2_1496;} 
return 
((obj_t)BgL_auxz00_6469);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1974z00_2047;
BgL_arg1974z00_2047 = 
CAR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6474;
{ 
obj_t BgL_argsz00_6476;obj_t BgL_fz00_6475;
BgL_fz00_6475 = BgL_arg1974z00_2047; 
BgL_argsz00_6476 = BgL_cdrzd211543zd2_2041; 
BgL_argsz00_1535 = BgL_argsz00_6476; 
BgL_fz00_1534 = BgL_fz00_6475; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_6474);} } }  else 
{ /* Eval/evaluate.scm 424 */
if(
(
CAR(BgL_ez00_69)==BGl_symbol3093z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd211543zd2_2041))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_carzd211717zd2_2053;obj_t BgL_cdrzd211718zd2_2054;
BgL_carzd211717zd2_2053 = 
CAR(BgL_cdrzd211543zd2_2041); 
BgL_cdrzd211718zd2_2054 = 
CDR(BgL_cdrzd211543zd2_2041); 
if(
PAIRP(BgL_carzd211717zd2_2053))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd211722zd2_2056;
BgL_cdrzd211722zd2_2056 = 
CDR(BgL_carzd211717zd2_2053); 
if(
(
CAR(BgL_carzd211717zd2_2053)==BGl_symbol3079z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd211722zd2_2056))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_carzd211725zd2_2060;obj_t BgL_cdrzd211726zd2_2061;
BgL_carzd211725zd2_2060 = 
CAR(BgL_cdrzd211722zd2_2056); 
BgL_cdrzd211726zd2_2061 = 
CDR(BgL_cdrzd211722zd2_2056); 
if(
SYMBOLP(BgL_carzd211725zd2_2060))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd211726zd2_2061))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_carzd211730zd2_2064;
BgL_carzd211730zd2_2064 = 
CAR(BgL_cdrzd211726zd2_2061); 
if(
SYMBOLP(BgL_carzd211730zd2_2064))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd211726zd2_2061)))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd211718zd2_2054))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd211718zd2_2054)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1991z00_2071;
BgL_arg1991z00_2071 = 
CAR(BgL_cdrzd211718zd2_2054); 
{ 
BgL_ev_setglobalz00_bglt BgL_auxz00_6511;
{ 
obj_t BgL_ez00_6514;obj_t BgL_modnamez00_6513;obj_t BgL_idz00_6512;
BgL_idz00_6512 = BgL_carzd211725zd2_2060; 
BgL_modnamez00_6513 = BgL_carzd211730zd2_2064; 
BgL_ez00_6514 = BgL_arg1991z00_2071; 
BgL_ez00_1499 = BgL_ez00_6514; 
BgL_modnamez00_1498 = BgL_modnamez00_6513; 
BgL_idz00_1497 = BgL_idz00_6512; 
goto BgL_tagzd2163zd2_1500;} 
return 
((obj_t)BgL_auxz00_6511);} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd211846zd2_2073;
BgL_cdrzd211846zd2_2073 = 
CDR(BgL_ez00_69); 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd211850zd2_2074;
BgL_cdrzd211850zd2_2074 = 
CDR(
((obj_t)BgL_cdrzd211846zd2_2073)); 
if(
PAIRP(BgL_cdrzd211850zd2_2074))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd211850zd2_2074)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1996z00_2078;obj_t BgL_arg1997z00_2079;
BgL_arg1996z00_2078 = 
CAR(
((obj_t)BgL_cdrzd211846zd2_2073)); 
BgL_arg1997z00_2079 = 
CAR(BgL_cdrzd211850zd2_2074); 
{ 
BgL_ev_hookz00_bglt BgL_auxz00_6527;
{ 
obj_t BgL_ez00_6529;obj_t BgL_vz00_6528;
BgL_vz00_6528 = BgL_arg1996z00_2078; 
BgL_ez00_6529 = BgL_arg1997z00_2079; 
BgL_ez00_1505 = BgL_ez00_6529; 
BgL_vz00_1504 = BgL_vz00_6528; 
goto BgL_tagzd2165zd2_1506;} 
return 
((obj_t)BgL_auxz00_6527);} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} } } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd211907zd2_2082;
BgL_cdrzd211907zd2_2082 = 
CDR(BgL_ez00_69); 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd211911zd2_2083;
BgL_cdrzd211911zd2_2083 = 
CDR(
((obj_t)BgL_cdrzd211907zd2_2082)); 
if(
PAIRP(BgL_cdrzd211911zd2_2083))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd211911zd2_2083)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2003z00_2087;obj_t BgL_arg2004z00_2088;
BgL_arg2003z00_2087 = 
CAR(
((obj_t)BgL_cdrzd211907zd2_2082)); 
BgL_arg2004z00_2088 = 
CAR(BgL_cdrzd211911zd2_2083); 
{ 
BgL_ev_hookz00_bglt BgL_auxz00_6542;
{ 
obj_t BgL_ez00_6544;obj_t BgL_vz00_6543;
BgL_vz00_6543 = BgL_arg2003z00_2087; 
BgL_ez00_6544 = BgL_arg2004z00_2088; 
BgL_ez00_1505 = BgL_ez00_6544; 
BgL_vz00_1504 = BgL_vz00_6543; 
goto BgL_tagzd2165zd2_1506;} 
return 
((obj_t)BgL_auxz00_6542);} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} } } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd211968zd2_2090;
BgL_cdrzd211968zd2_2090 = 
CDR(BgL_ez00_69); 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd211972zd2_2091;
BgL_cdrzd211972zd2_2091 = 
CDR(
((obj_t)BgL_cdrzd211968zd2_2090)); 
if(
PAIRP(BgL_cdrzd211972zd2_2091))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd211972zd2_2091)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2009z00_2095;obj_t BgL_arg2010z00_2096;
BgL_arg2009z00_2095 = 
CAR(
((obj_t)BgL_cdrzd211968zd2_2090)); 
BgL_arg2010z00_2096 = 
CAR(BgL_cdrzd211972zd2_2091); 
{ 
BgL_ev_hookz00_bglt BgL_auxz00_6557;
{ 
obj_t BgL_ez00_6559;obj_t BgL_vz00_6558;
BgL_vz00_6558 = BgL_arg2009z00_2095; 
BgL_ez00_6559 = BgL_arg2010z00_2096; 
BgL_ez00_1505 = BgL_ez00_6559; 
BgL_vz00_1504 = BgL_vz00_6558; 
goto BgL_tagzd2165zd2_1506;} 
return 
((obj_t)BgL_auxz00_6557);} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} } } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd212029zd2_2098;
BgL_cdrzd212029zd2_2098 = 
CDR(BgL_ez00_69); 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd212033zd2_2099;
BgL_cdrzd212033zd2_2099 = 
CDR(
((obj_t)BgL_cdrzd212029zd2_2098)); 
if(
PAIRP(BgL_cdrzd212033zd2_2099))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd212033zd2_2099)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2015z00_2103;obj_t BgL_arg2016z00_2104;
BgL_arg2015z00_2103 = 
CAR(
((obj_t)BgL_cdrzd212029zd2_2098)); 
BgL_arg2016z00_2104 = 
CAR(BgL_cdrzd212033zd2_2099); 
{ 
BgL_ev_hookz00_bglt BgL_auxz00_6572;
{ 
obj_t BgL_ez00_6574;obj_t BgL_vz00_6573;
BgL_vz00_6573 = BgL_arg2015z00_2103; 
BgL_ez00_6574 = BgL_arg2016z00_2104; 
BgL_ez00_1505 = BgL_ez00_6574; 
BgL_vz00_1504 = BgL_vz00_6573; 
goto BgL_tagzd2165zd2_1506;} 
return 
((obj_t)BgL_auxz00_6572);} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} } } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd212090zd2_2106;
BgL_cdrzd212090zd2_2106 = 
CDR(BgL_ez00_69); 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd212094zd2_2107;
BgL_cdrzd212094zd2_2107 = 
CDR(
((obj_t)BgL_cdrzd212090zd2_2106)); 
if(
PAIRP(BgL_cdrzd212094zd2_2107))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd212094zd2_2107)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2021z00_2111;obj_t BgL_arg2022z00_2112;
BgL_arg2021z00_2111 = 
CAR(
((obj_t)BgL_cdrzd212090zd2_2106)); 
BgL_arg2022z00_2112 = 
CAR(BgL_cdrzd212094zd2_2107); 
{ 
BgL_ev_hookz00_bglt BgL_auxz00_6587;
{ 
obj_t BgL_ez00_6589;obj_t BgL_vz00_6588;
BgL_vz00_6588 = BgL_arg2021z00_2111; 
BgL_ez00_6589 = BgL_arg2022z00_2112; 
BgL_ez00_1505 = BgL_ez00_6589; 
BgL_vz00_1504 = BgL_vz00_6588; 
goto BgL_tagzd2165zd2_1506;} 
return 
((obj_t)BgL_auxz00_6587);} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} } } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd212138zd2_2114;
BgL_cdrzd212138zd2_2114 = 
CDR(BgL_ez00_69); 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_carzd212141zd2_2115;obj_t BgL_cdrzd212142zd2_2116;
BgL_carzd212141zd2_2115 = 
CAR(
((obj_t)BgL_cdrzd212138zd2_2114)); 
BgL_cdrzd212142zd2_2116 = 
CDR(
((obj_t)BgL_cdrzd212138zd2_2114)); 
if(
(
CAR(
((obj_t)BgL_carzd212141zd2_2115))==BGl_symbol3081z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd212142zd2_2116))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd212142zd2_2116)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2029z00_2122;obj_t BgL_arg2030z00_2123;
BgL_arg2029z00_2122 = 
CDR(
((obj_t)BgL_carzd212141zd2_2115)); 
BgL_arg2030z00_2123 = 
CAR(BgL_cdrzd212142zd2_2116); 
{ 
obj_t BgL_e2z00_6609;obj_t BgL_lz00_6608;
BgL_lz00_6608 = BgL_arg2029z00_2122; 
BgL_e2z00_6609 = BgL_arg2030z00_2123; 
BgL_e2z00_1502 = BgL_e2z00_6609; 
BgL_lz00_1501 = BgL_lz00_6608; 
goto BgL_tagzd2164zd2_1503;} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd212218zd2_2126;
BgL_cdrzd212218zd2_2126 = 
CDR(
((obj_t)BgL_cdrzd212138zd2_2114)); 
if(
PAIRP(BgL_cdrzd212218zd2_2126))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd212218zd2_2126)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2035z00_2130;obj_t BgL_arg2036z00_2131;
BgL_arg2035z00_2130 = 
CAR(
((obj_t)BgL_cdrzd212138zd2_2114)); 
BgL_arg2036z00_2131 = 
CAR(BgL_cdrzd212218zd2_2126); 
{ 
BgL_ev_hookz00_bglt BgL_auxz00_6620;
{ 
obj_t BgL_ez00_6622;obj_t BgL_vz00_6621;
BgL_vz00_6621 = BgL_arg2035z00_2130; 
BgL_ez00_6622 = BgL_arg2036z00_2131; 
BgL_ez00_1505 = BgL_ez00_6622; 
BgL_vz00_1504 = BgL_vz00_6621; 
goto BgL_tagzd2165zd2_1506;} 
return 
((obj_t)BgL_auxz00_6620);} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} } } } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd212275zd2_2135;
BgL_cdrzd212275zd2_2135 = 
CDR(BgL_ez00_69); 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd212279zd2_2136;
BgL_cdrzd212279zd2_2136 = 
CDR(
((obj_t)BgL_cdrzd212275zd2_2135)); 
if(
PAIRP(BgL_cdrzd212279zd2_2136))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd212279zd2_2136)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2043z00_2140;obj_t BgL_arg2044z00_2141;
BgL_arg2043z00_2140 = 
CAR(
((obj_t)BgL_cdrzd212275zd2_2135)); 
BgL_arg2044z00_2141 = 
CAR(BgL_cdrzd212279zd2_2136); 
{ 
BgL_ev_hookz00_bglt BgL_auxz00_6635;
{ 
obj_t BgL_ez00_6637;obj_t BgL_vz00_6636;
BgL_vz00_6636 = BgL_arg2043z00_2140; 
BgL_ez00_6637 = BgL_arg2044z00_2141; 
BgL_ez00_1505 = BgL_ez00_6637; 
BgL_vz00_1504 = BgL_vz00_6636; 
goto BgL_tagzd2165zd2_1506;} 
return 
((obj_t)BgL_auxz00_6635);} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} } } }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd212400zd2_2143;
BgL_cdrzd212400zd2_2143 = 
CDR(BgL_ez00_69); 
if(
(
CAR(BgL_ez00_69)==BGl_symbol3095z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd212400zd2_2143))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd212405zd2_2147;
BgL_cdrzd212405zd2_2147 = 
CDR(BgL_cdrzd212400zd2_2143); 
if(
PAIRP(BgL_cdrzd212405zd2_2147))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_carzd212409zd2_2149;
BgL_carzd212409zd2_2149 = 
CAR(BgL_cdrzd212405zd2_2147); 
if(
PAIRP(BgL_carzd212409zd2_2149))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd212414zd2_2151;
BgL_cdrzd212414zd2_2151 = 
CDR(BgL_carzd212409zd2_2149); 
if(
(
CAR(BgL_carzd212409zd2_2149)==BGl_symbol3058z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd212414zd2_2151))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd212418zd2_2155;
BgL_cdrzd212418zd2_2155 = 
CDR(BgL_cdrzd212414zd2_2151); 
if(
PAIRP(BgL_cdrzd212418zd2_2155))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd212418zd2_2155)))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd212405zd2_2147)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2059z00_2161;obj_t BgL_arg2060z00_2162;obj_t BgL_arg2061z00_2163;
BgL_arg2059z00_2161 = 
CAR(BgL_cdrzd212400zd2_2143); 
BgL_arg2060z00_2162 = 
CAR(BgL_cdrzd212414zd2_2151); 
BgL_arg2061z00_2163 = 
CAR(BgL_cdrzd212418zd2_2155); 
{ 
BgL_ev_defglobalz00_bglt BgL_auxz00_6669;
{ 
obj_t BgL_bodyz00_6672;obj_t BgL_formalsz00_6671;obj_t BgL_gvz00_6670;
BgL_gvz00_6670 = BgL_arg2059z00_2161; 
BgL_formalsz00_6671 = BgL_arg2060z00_2162; 
BgL_bodyz00_6672 = BgL_arg2061z00_2163; 
BgL_bodyz00_1510 = BgL_bodyz00_6672; 
BgL_formalsz00_1509 = BgL_formalsz00_6671; 
BgL_gvz00_1508 = BgL_gvz00_6670; 
goto BgL_tagzd2167zd2_1511;} 
return 
((obj_t)BgL_auxz00_6669);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2062z00_2164;
BgL_arg2062z00_2164 = 
CAR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6675;
{ 
obj_t BgL_argsz00_6677;obj_t BgL_fz00_6676;
BgL_fz00_6676 = BgL_arg2062z00_2164; 
BgL_argsz00_6677 = BgL_cdrzd212400zd2_2143; 
BgL_argsz00_1535 = BgL_argsz00_6677; 
BgL_fz00_1534 = BgL_fz00_6676; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_6675);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd212518zd2_2168;
BgL_cdrzd212518zd2_2168 = 
CDR(
((obj_t)BgL_cdrzd212400zd2_2143)); 
if(
NULLP(
CDR(
((obj_t)BgL_cdrzd212518zd2_2168))))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2067z00_2171;obj_t BgL_arg2068z00_2172;
BgL_arg2067z00_2171 = 
CAR(
((obj_t)BgL_cdrzd212400zd2_2143)); 
BgL_arg2068z00_2172 = 
CAR(
((obj_t)BgL_cdrzd212518zd2_2168)); 
{ 
BgL_ev_defglobalz00_bglt BgL_auxz00_6689;
{ 
obj_t BgL_gez00_6691;obj_t BgL_gvz00_6690;
BgL_gvz00_6690 = BgL_arg2067z00_2171; 
BgL_gez00_6691 = BgL_arg2068z00_2172; 
BgL_gez00_1513 = BgL_gez00_6691; 
BgL_gvz00_1512 = BgL_gvz00_6690; 
goto BgL_tagzd2168zd2_1514;} 
return 
((obj_t)BgL_auxz00_6689);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2069z00_2173;obj_t BgL_arg2070z00_2174;
BgL_arg2069z00_2173 = 
CAR(BgL_ez00_69); 
BgL_arg2070z00_2174 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6695;
{ 
obj_t BgL_argsz00_6697;obj_t BgL_fz00_6696;
BgL_fz00_6696 = BgL_arg2069z00_2173; 
BgL_argsz00_6697 = BgL_arg2070z00_2174; 
BgL_argsz00_1535 = BgL_argsz00_6697; 
BgL_fz00_1534 = BgL_fz00_6696; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_6695);} } } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd212605zd2_2178;
BgL_cdrzd212605zd2_2178 = 
CDR(
((obj_t)BgL_cdrzd212400zd2_2143)); 
if(
NULLP(
CDR(
((obj_t)BgL_cdrzd212605zd2_2178))))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2075z00_2181;obj_t BgL_arg2076z00_2182;
BgL_arg2075z00_2181 = 
CAR(
((obj_t)BgL_cdrzd212400zd2_2143)); 
BgL_arg2076z00_2182 = 
CAR(
((obj_t)BgL_cdrzd212605zd2_2178)); 
{ 
BgL_ev_defglobalz00_bglt BgL_auxz00_6709;
{ 
obj_t BgL_gez00_6711;obj_t BgL_gvz00_6710;
BgL_gvz00_6710 = BgL_arg2075z00_2181; 
BgL_gez00_6711 = BgL_arg2076z00_2182; 
BgL_gez00_1513 = BgL_gez00_6711; 
BgL_gvz00_1512 = BgL_gvz00_6710; 
goto BgL_tagzd2168zd2_1514;} 
return 
((obj_t)BgL_auxz00_6709);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2077z00_2183;obj_t BgL_arg2078z00_2184;
BgL_arg2077z00_2183 = 
CAR(BgL_ez00_69); 
BgL_arg2078z00_2184 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6715;
{ 
obj_t BgL_argsz00_6717;obj_t BgL_fz00_6716;
BgL_fz00_6716 = BgL_arg2077z00_2183; 
BgL_argsz00_6717 = BgL_arg2078z00_2184; 
BgL_argsz00_1535 = BgL_argsz00_6717; 
BgL_fz00_1534 = BgL_fz00_6716; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_6715);} } } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd212692zd2_2187;
BgL_cdrzd212692zd2_2187 = 
CDR(
((obj_t)BgL_cdrzd212400zd2_2143)); 
if(
NULLP(
CDR(
((obj_t)BgL_cdrzd212692zd2_2187))))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2082z00_2190;obj_t BgL_arg2083z00_2191;
BgL_arg2082z00_2190 = 
CAR(
((obj_t)BgL_cdrzd212400zd2_2143)); 
BgL_arg2083z00_2191 = 
CAR(
((obj_t)BgL_cdrzd212692zd2_2187)); 
{ 
BgL_ev_defglobalz00_bglt BgL_auxz00_6729;
{ 
obj_t BgL_gez00_6731;obj_t BgL_gvz00_6730;
BgL_gvz00_6730 = BgL_arg2082z00_2190; 
BgL_gez00_6731 = BgL_arg2083z00_2191; 
BgL_gez00_1513 = BgL_gez00_6731; 
BgL_gvz00_1512 = BgL_gvz00_6730; 
goto BgL_tagzd2168zd2_1514;} 
return 
((obj_t)BgL_auxz00_6729);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2084z00_2192;obj_t BgL_arg2085z00_2193;
BgL_arg2084z00_2192 = 
CAR(BgL_ez00_69); 
BgL_arg2085z00_2193 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6735;
{ 
obj_t BgL_argsz00_6737;obj_t BgL_fz00_6736;
BgL_fz00_6736 = BgL_arg2084z00_2192; 
BgL_argsz00_6737 = BgL_arg2085z00_2193; 
BgL_argsz00_1535 = BgL_argsz00_6737; 
BgL_fz00_1534 = BgL_fz00_6736; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_6735);} } } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd212779zd2_2196;
BgL_cdrzd212779zd2_2196 = 
CDR(
((obj_t)BgL_cdrzd212400zd2_2143)); 
if(
NULLP(
CDR(
((obj_t)BgL_cdrzd212779zd2_2196))))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2089z00_2199;obj_t BgL_arg2090z00_2200;
BgL_arg2089z00_2199 = 
CAR(
((obj_t)BgL_cdrzd212400zd2_2143)); 
BgL_arg2090z00_2200 = 
CAR(
((obj_t)BgL_cdrzd212779zd2_2196)); 
{ 
BgL_ev_defglobalz00_bglt BgL_auxz00_6749;
{ 
obj_t BgL_gez00_6751;obj_t BgL_gvz00_6750;
BgL_gvz00_6750 = BgL_arg2089z00_2199; 
BgL_gez00_6751 = BgL_arg2090z00_2200; 
BgL_gez00_1513 = BgL_gez00_6751; 
BgL_gvz00_1512 = BgL_gvz00_6750; 
goto BgL_tagzd2168zd2_1514;} 
return 
((obj_t)BgL_auxz00_6749);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2091z00_2201;obj_t BgL_arg2092z00_2202;
BgL_arg2091z00_2201 = 
CAR(BgL_ez00_69); 
BgL_arg2092z00_2202 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6755;
{ 
obj_t BgL_argsz00_6757;obj_t BgL_fz00_6756;
BgL_fz00_6756 = BgL_arg2091z00_2201; 
BgL_argsz00_6757 = BgL_arg2092z00_2202; 
BgL_argsz00_1535 = BgL_argsz00_6757; 
BgL_fz00_1534 = BgL_fz00_6756; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_6755);} } } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd212866zd2_2206;
BgL_cdrzd212866zd2_2206 = 
CDR(
((obj_t)BgL_cdrzd212400zd2_2143)); 
if(
NULLP(
CDR(
((obj_t)BgL_cdrzd212866zd2_2206))))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2097z00_2209;obj_t BgL_arg2098z00_2210;
BgL_arg2097z00_2209 = 
CAR(
((obj_t)BgL_cdrzd212400zd2_2143)); 
BgL_arg2098z00_2210 = 
CAR(
((obj_t)BgL_cdrzd212866zd2_2206)); 
{ 
BgL_ev_defglobalz00_bglt BgL_auxz00_6769;
{ 
obj_t BgL_gez00_6771;obj_t BgL_gvz00_6770;
BgL_gvz00_6770 = BgL_arg2097z00_2209; 
BgL_gez00_6771 = BgL_arg2098z00_2210; 
BgL_gez00_1513 = BgL_gez00_6771; 
BgL_gvz00_1512 = BgL_gvz00_6770; 
goto BgL_tagzd2168zd2_1514;} 
return 
((obj_t)BgL_auxz00_6769);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2099z00_2211;obj_t BgL_arg2100z00_2212;
BgL_arg2099z00_2211 = 
CAR(BgL_ez00_69); 
BgL_arg2100z00_2212 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6775;
{ 
obj_t BgL_argsz00_6777;obj_t BgL_fz00_6776;
BgL_fz00_6776 = BgL_arg2099z00_2211; 
BgL_argsz00_6777 = BgL_arg2100z00_2212; 
BgL_argsz00_1535 = BgL_argsz00_6777; 
BgL_fz00_1534 = BgL_fz00_6776; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_6775);} } } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2102z00_2214;
BgL_arg2102z00_2214 = 
CAR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6780;
{ 
obj_t BgL_argsz00_6782;obj_t BgL_fz00_6781;
BgL_fz00_6781 = BgL_arg2102z00_2214; 
BgL_argsz00_6782 = BgL_cdrzd212400zd2_2143; 
BgL_argsz00_1535 = BgL_argsz00_6782; 
BgL_fz00_1534 = BgL_fz00_6781; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_6780);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2104z00_2216;
BgL_arg2104z00_2216 = 
CAR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6785;
{ 
obj_t BgL_argsz00_6787;obj_t BgL_fz00_6786;
BgL_fz00_6786 = BgL_arg2104z00_2216; 
BgL_argsz00_6787 = BgL_cdrzd212400zd2_2143; 
BgL_argsz00_1535 = BgL_argsz00_6787; 
BgL_fz00_1534 = BgL_fz00_6786; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_6785);} } }  else 
{ /* Eval/evaluate.scm 424 */
if(
(
CAR(BgL_ez00_69)==BGl_symbol3097z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd212400zd2_2143))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_carzd213108zd2_2222;
BgL_carzd213108zd2_2222 = 
CAR(BgL_cdrzd212400zd2_2143); 
if(
PAIRP(BgL_carzd213108zd2_2222))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_carzd213108zd2_2222)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2112z00_2226;obj_t BgL_arg2113z00_2227;
BgL_arg2112z00_2226 = 
CAR(BgL_carzd213108zd2_2222); 
BgL_arg2113z00_2227 = 
CDR(BgL_cdrzd212400zd2_2143); 
{ 
BgL_ev_bindzd2exitzd2_bglt BgL_auxz00_6802;
{ 
obj_t BgL_bodyz00_6804;obj_t BgL_vz00_6803;
BgL_vz00_6803 = BgL_arg2112z00_2226; 
BgL_bodyz00_6804 = BgL_arg2113z00_2227; 
BgL_bodyz00_1516 = BgL_bodyz00_6804; 
BgL_vz00_1515 = BgL_vz00_6803; 
goto BgL_tagzd2169zd2_1517;} 
return 
((obj_t)BgL_auxz00_6802);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2114z00_2228;obj_t BgL_arg2115z00_2229;
BgL_arg2114z00_2228 = 
CAR(BgL_ez00_69); 
BgL_arg2115z00_2229 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6808;
{ 
obj_t BgL_argsz00_6810;obj_t BgL_fz00_6809;
BgL_fz00_6809 = BgL_arg2114z00_2228; 
BgL_argsz00_6810 = BgL_arg2115z00_2229; 
BgL_argsz00_1535 = BgL_argsz00_6810; 
BgL_fz00_1534 = BgL_fz00_6809; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_6808);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2117z00_2231;obj_t BgL_arg2118z00_2232;
BgL_arg2117z00_2231 = 
CAR(BgL_ez00_69); 
BgL_arg2118z00_2232 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6814;
{ 
obj_t BgL_argsz00_6816;obj_t BgL_fz00_6815;
BgL_fz00_6815 = BgL_arg2117z00_2231; 
BgL_argsz00_6816 = BgL_arg2118z00_2232; 
BgL_argsz00_1535 = BgL_argsz00_6816; 
BgL_fz00_1534 = BgL_fz00_6815; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_6814);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2119z00_2233;obj_t BgL_arg2120z00_2234;
BgL_arg2119z00_2233 = 
CAR(BgL_ez00_69); 
BgL_arg2120z00_2234 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6820;
{ 
obj_t BgL_argsz00_6822;obj_t BgL_fz00_6821;
BgL_fz00_6821 = BgL_arg2119z00_2233; 
BgL_argsz00_6822 = BgL_arg2120z00_2234; 
BgL_argsz00_1535 = BgL_argsz00_6822; 
BgL_fz00_1534 = BgL_fz00_6821; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_6820);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd213273zd2_2235;
BgL_cdrzd213273zd2_2235 = 
CDR(BgL_ez00_69); 
if(
(
CAR(BgL_ez00_69)==BGl_symbol3099z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd213273zd2_2235))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2124z00_2239;obj_t BgL_arg2125z00_2240;
BgL_arg2124z00_2239 = 
CAR(BgL_cdrzd213273zd2_2235); 
BgL_arg2125z00_2240 = 
CDR(BgL_cdrzd213273zd2_2235); 
{ 
BgL_ev_unwindzd2protectzd2_bglt BgL_auxz00_6832;
{ 
obj_t BgL_bodyz00_6834;obj_t BgL_ez00_6833;
BgL_ez00_6833 = BgL_arg2124z00_2239; 
BgL_bodyz00_6834 = BgL_arg2125z00_2240; 
BgL_bodyz00_1519 = BgL_bodyz00_6834; 
BgL_ez00_1518 = BgL_ez00_6833; 
goto BgL_tagzd2170zd2_1520;} 
return 
((obj_t)BgL_auxz00_6832);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2126z00_2241;
BgL_arg2126z00_2241 = 
CAR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6837;
{ 
obj_t BgL_argsz00_6839;obj_t BgL_fz00_6838;
BgL_fz00_6838 = BgL_arg2126z00_2241; 
BgL_argsz00_6839 = BgL_cdrzd213273zd2_2235; 
BgL_argsz00_1535 = BgL_argsz00_6839; 
BgL_fz00_1534 = BgL_fz00_6838; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_6837);} } }  else 
{ /* Eval/evaluate.scm 424 */
if(
(
CAR(BgL_ez00_69)==BGl_symbol3101z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd213273zd2_2235))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2131z00_2247;obj_t BgL_arg2132z00_2248;
BgL_arg2131z00_2247 = 
CAR(BgL_cdrzd213273zd2_2235); 
BgL_arg2132z00_2248 = 
CDR(BgL_cdrzd213273zd2_2235); 
{ 
BgL_ev_withzd2handlerzd2_bglt BgL_auxz00_6848;
{ 
obj_t BgL_bodyz00_6850;obj_t BgL_hz00_6849;
BgL_hz00_6849 = BgL_arg2131z00_2247; 
BgL_bodyz00_6850 = BgL_arg2132z00_2248; 
BgL_bodyz00_1522 = BgL_bodyz00_6850; 
BgL_hz00_1521 = BgL_hz00_6849; 
goto BgL_tagzd2171zd2_1523;} 
return 
((obj_t)BgL_auxz00_6848);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2133z00_2249;obj_t BgL_arg2134z00_2250;
BgL_arg2133z00_2249 = 
CAR(BgL_ez00_69); 
BgL_arg2134z00_2250 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6854;
{ 
obj_t BgL_argsz00_6856;obj_t BgL_fz00_6855;
BgL_fz00_6855 = BgL_arg2133z00_2249; 
BgL_argsz00_6856 = BgL_arg2134z00_2250; 
BgL_argsz00_1535 = BgL_argsz00_6856; 
BgL_fz00_1534 = BgL_fz00_6855; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_6854);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd213376zd2_2251;
BgL_cdrzd213376zd2_2251 = 
CDR(BgL_ez00_69); 
if(
(
CAR(BgL_ez00_69)==BGl_symbol3103z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd213376zd2_2251))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd213381zd2_2255;
BgL_cdrzd213381zd2_2255 = 
CDR(BgL_cdrzd213376zd2_2251); 
if(
PAIRP(BgL_cdrzd213381zd2_2255))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd213386zd2_2257;
BgL_cdrzd213386zd2_2257 = 
CDR(BgL_cdrzd213381zd2_2255); 
if(
(
CAR(BgL_cdrzd213381zd2_2255)==BGl_keyword3105z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd213386zd2_2257))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2142z00_2261;obj_t BgL_arg2143z00_2262;obj_t BgL_arg2145z00_2263;
BgL_arg2142z00_2261 = 
CAR(BgL_cdrzd213376zd2_2251); 
BgL_arg2143z00_2262 = 
CAR(BgL_cdrzd213386zd2_2257); 
BgL_arg2145z00_2263 = 
CDR(BgL_cdrzd213386zd2_2257); 
{ 
BgL_ev_synchroniza7eza7_bglt BgL_auxz00_6876;
{ 
obj_t BgL_bodyz00_6879;obj_t BgL_pz00_6878;obj_t BgL_mz00_6877;
BgL_mz00_6877 = BgL_arg2142z00_2261; 
BgL_pz00_6878 = BgL_arg2143z00_2262; 
BgL_bodyz00_6879 = BgL_arg2145z00_2263; 
BgL_bodyz00_1526 = BgL_bodyz00_6879; 
BgL_pz00_1525 = BgL_pz00_6878; 
BgL_mz00_1524 = BgL_mz00_6877; 
goto BgL_tagzd2172zd2_1527;} 
return 
((obj_t)BgL_auxz00_6876);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2146z00_2265;obj_t BgL_arg2147z00_2266;
BgL_arg2146z00_2265 = 
CAR(
((obj_t)BgL_cdrzd213376zd2_2251)); 
BgL_arg2147z00_2266 = 
CDR(
((obj_t)BgL_cdrzd213376zd2_2251)); 
{ 
BgL_ev_synchroniza7eza7_bglt BgL_auxz00_6885;
{ 
obj_t BgL_bodyz00_6887;obj_t BgL_mz00_6886;
BgL_mz00_6886 = BgL_arg2146z00_2265; 
BgL_bodyz00_6887 = BgL_arg2147z00_2266; 
BgL_bodyz00_1529 = BgL_bodyz00_6887; 
BgL_mz00_1528 = BgL_mz00_6886; 
goto BgL_tagzd2173zd2_1530;} 
return 
((obj_t)BgL_auxz00_6885);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2148z00_2268;obj_t BgL_arg2149z00_2269;
BgL_arg2148z00_2268 = 
CAR(
((obj_t)BgL_cdrzd213376zd2_2251)); 
BgL_arg2149z00_2269 = 
CDR(
((obj_t)BgL_cdrzd213376zd2_2251)); 
{ 
BgL_ev_synchroniza7eza7_bglt BgL_auxz00_6893;
{ 
obj_t BgL_bodyz00_6895;obj_t BgL_mz00_6894;
BgL_mz00_6894 = BgL_arg2148z00_2268; 
BgL_bodyz00_6895 = BgL_arg2149z00_2269; 
BgL_bodyz00_1529 = BgL_bodyz00_6895; 
BgL_mz00_1528 = BgL_mz00_6894; 
goto BgL_tagzd2173zd2_1530;} 
return 
((obj_t)BgL_auxz00_6893);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2151z00_2272;obj_t BgL_arg2152z00_2273;
BgL_arg2151z00_2272 = 
CAR(
((obj_t)BgL_cdrzd213376zd2_2251)); 
BgL_arg2152z00_2273 = 
CDR(
((obj_t)BgL_cdrzd213376zd2_2251)); 
{ 
BgL_ev_synchroniza7eza7_bglt BgL_auxz00_6901;
{ 
obj_t BgL_bodyz00_6903;obj_t BgL_mz00_6902;
BgL_mz00_6902 = BgL_arg2151z00_2272; 
BgL_bodyz00_6903 = BgL_arg2152z00_2273; 
BgL_bodyz00_1529 = BgL_bodyz00_6903; 
BgL_mz00_1528 = BgL_mz00_6902; 
goto BgL_tagzd2173zd2_1530;} 
return 
((obj_t)BgL_auxz00_6901);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2153z00_2274;
BgL_arg2153z00_2274 = 
CAR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6906;
{ 
obj_t BgL_argsz00_6908;obj_t BgL_fz00_6907;
BgL_fz00_6907 = BgL_arg2153z00_2274; 
BgL_argsz00_6908 = BgL_cdrzd213376zd2_2251; 
BgL_argsz00_1535 = BgL_argsz00_6908; 
BgL_fz00_1534 = BgL_fz00_6907; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_6906);} } }  else 
{ /* Eval/evaluate.scm 424 */
if(
(
CAR(BgL_ez00_69)==BGl_symbol3058z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd213376zd2_2251))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd213486zd2_2280;
BgL_cdrzd213486zd2_2280 = 
CDR(BgL_cdrzd213376zd2_2251); 
if(
PAIRP(BgL_cdrzd213486zd2_2280))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd213486zd2_2280)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2161z00_2284;obj_t BgL_arg2162z00_2285;
BgL_arg2161z00_2284 = 
CAR(BgL_cdrzd213376zd2_2251); 
BgL_arg2162z00_2285 = 
CAR(BgL_cdrzd213486zd2_2280); 
{ 
BgL_ev_absz00_bglt BgL_auxz00_6923;
{ 
obj_t BgL_bodyz00_6925;obj_t BgL_formalsz00_6924;
BgL_formalsz00_6924 = BgL_arg2161z00_2284; 
BgL_bodyz00_6925 = BgL_arg2162z00_2285; 
BgL_bodyz00_1532 = BgL_bodyz00_6925; 
BgL_formalsz00_1531 = BgL_formalsz00_6924; 
goto BgL_tagzd2174zd2_1533;} 
return 
((obj_t)BgL_auxz00_6923);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2163z00_2286;obj_t BgL_arg2164z00_2287;
BgL_arg2163z00_2286 = 
CAR(BgL_ez00_69); 
BgL_arg2164z00_2287 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6929;
{ 
obj_t BgL_argsz00_6931;obj_t BgL_fz00_6930;
BgL_fz00_6930 = BgL_arg2163z00_2286; 
BgL_argsz00_6931 = BgL_arg2164z00_2287; 
BgL_argsz00_1535 = BgL_argsz00_6931; 
BgL_fz00_1534 = BgL_fz00_6930; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_6929);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2166z00_2289;obj_t BgL_arg2167z00_2290;
BgL_arg2166z00_2289 = 
CAR(BgL_ez00_69); 
BgL_arg2167z00_2290 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6935;
{ 
obj_t BgL_argsz00_6937;obj_t BgL_fz00_6936;
BgL_fz00_6936 = BgL_arg2166z00_2289; 
BgL_argsz00_6937 = BgL_arg2167z00_2290; 
BgL_argsz00_1535 = BgL_argsz00_6937; 
BgL_fz00_1534 = BgL_fz00_6936; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_6935);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2168z00_2291;obj_t BgL_arg2169z00_2292;
BgL_arg2168z00_2291 = 
CAR(BgL_ez00_69); 
BgL_arg2169z00_2292 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6941;
{ 
obj_t BgL_argsz00_6943;obj_t BgL_fz00_6942;
BgL_fz00_6942 = BgL_arg2168z00_2291; 
BgL_argsz00_6943 = BgL_arg2169z00_2292; 
BgL_argsz00_1535 = BgL_argsz00_6943; 
BgL_fz00_1534 = BgL_fz00_6942; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_6941);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2170z00_2293;obj_t BgL_arg2171z00_2294;
BgL_arg2170z00_2293 = 
CAR(BgL_ez00_69); 
BgL_arg2171z00_2294 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6947;
{ 
obj_t BgL_argsz00_6949;obj_t BgL_fz00_6948;
BgL_fz00_6948 = BgL_arg2170z00_2293; 
BgL_argsz00_6949 = BgL_arg2171z00_2294; 
BgL_argsz00_1535 = BgL_argsz00_6949; 
BgL_fz00_1534 = BgL_fz00_6948; 
goto BgL_tagzd2175zd2_1536;} 
return 
((obj_t)BgL_auxz00_6947);} } } } } } } } } } } } } } } } } } } } } }  else 
{ /* Eval/evaluate.scm 424 */
BgL_xz00_1459 = BgL_ez00_69; 
if(
SYMBOLP(BgL_xz00_1459))
{ /* Eval/evaluate.scm 427 */
obj_t BgL__ortest_1101z00_2315;
BgL__ortest_1101z00_2315 = 
BGl_convzd2varzd2zz__evaluatez00(BgL_xz00_1459, BgL_localsz00_70); 
if(
CBOOL(BgL__ortest_1101z00_2315))
{ /* Eval/evaluate.scm 427 */
return BgL__ortest_1101z00_2315;}  else 
{ /* Eval/evaluate.scm 427 */
return 
((obj_t)
BGl_convzd2globalzd2zz__evaluatez00(BgL_locz00_74, BgL_xz00_1459, BgL_globalsz00_71));} }  else 
{ /* Eval/evaluate.scm 428 */
BgL_ev_littz00_bglt BgL_new1103z00_2316;
{ /* Eval/evaluate.scm 429 */
BgL_ev_littz00_bglt BgL_new1102z00_2317;
BgL_new1102z00_2317 = 
((BgL_ev_littz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_littz00_bgl) ))); 
{ /* Eval/evaluate.scm 429 */
long BgL_arg2192z00_2318;
{ /* Eval/evaluate.scm 429 */
long BgL_res2725z00_3333;
BgL_res2725z00_3333 = 
BGL_CLASS_INDEX(BGl_ev_littz00zz__evaluate_typesz00); 
BgL_arg2192z00_2318 = BgL_res2725z00_3333; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1102z00_2317), BgL_arg2192z00_2318); } 
BgL_new1103z00_2316 = BgL_new1102z00_2317; } 
((((BgL_ev_littz00_bglt)COBJECT(BgL_new1103z00_2316))->BgL_valuez00)=((obj_t)BgL_xz00_1459),BUNSPEC); 
return 
((obj_t)BgL_new1103z00_2316);} } } } } 

}



/* loop~0 */
obj_t BGl_loopze70ze7zz__evaluatez00(obj_t BgL_wherez00_4454, obj_t BgL_globalsz00_4453, obj_t BgL_localsz00_4452, obj_t BgL_locz00_4451, obj_t BgL_esz00_2646)
{
{ /* Eval/evaluate.scm 386 */
if(
NULLP(BgL_esz00_2646))
{ /* Eval/evaluate.scm 387 */
return BNIL;}  else 
{ /* Eval/evaluate.scm 389 */
obj_t BgL_ez00_2649;
BgL_ez00_2649 = 
CAR(
((obj_t)BgL_esz00_2646)); 
{ /* Eval/evaluate.scm 390 */
obj_t BgL_arg2343z00_2650;obj_t BgL_arg2344z00_2651;
BgL_arg2343z00_2650 = 
BGl_convz00zz__evaluatez00(BgL_ez00_2649, BgL_localsz00_4452, BgL_globalsz00_4453, BFALSE, BgL_wherez00_4454, 
BGl_getzd2location3zd2zz__evaluatez00(BgL_ez00_2649, BgL_esz00_2646, BgL_locz00_4451), ((bool_t)0)); 
{ /* Eval/evaluate.scm 391 */
obj_t BgL_arg2346z00_2653;
BgL_arg2346z00_2653 = 
CDR(
((obj_t)BgL_esz00_2646)); 
BgL_arg2344z00_2651 = 
BGl_loopze70ze7zz__evaluatez00(BgL_wherez00_4454, BgL_globalsz00_4453, BgL_localsz00_4452, BgL_locz00_4451, BgL_arg2346z00_2653); } 
return 
MAKE_YOUNG_PAIR(BgL_arg2343z00_2650, BgL_arg2344z00_2651);} } } 

}



/* rconv/loc~0 */
obj_t BGl_rconvzf2locze70z15zz__evaluatez00(obj_t BgL_wherez00_4458, obj_t BgL_tailzf3zf3_4457, obj_t BgL_globalsz00_4456, obj_t BgL_localsz00_4455, obj_t BgL_ez00_2623, obj_t BgL_locz00_2624)
{
{ /* Eval/evaluate.scm 368 */
return 
BGl_convz00zz__evaluatez00(BgL_ez00_2623, BgL_localsz00_4455, BgL_globalsz00_4456, BgL_tailzf3zf3_4457, BgL_wherez00_4458, BgL_locz00_2624, ((bool_t)0));} 

}



/* uconv/loc~0 */
obj_t BGl_uconvzf2locze70z15zz__evaluatez00(obj_t BgL_wherez00_4461, obj_t BgL_globalsz00_4460, obj_t BgL_localsz00_4459, obj_t BgL_ez00_2633, obj_t BgL_locz00_2634)
{
{ /* Eval/evaluate.scm 377 */
return 
BGl_convz00zz__evaluatez00(BgL_ez00_2633, BgL_localsz00_4459, BgL_globalsz00_4460, BFALSE, BgL_wherez00_4461, BgL_locz00_2634, ((bool_t)0));} 

}



/* conv-vals~0 */
obj_t BGl_convzd2valsze70z35zz__evaluatez00(obj_t BgL_wherez00_4463, obj_t BgL_globalsz00_4462, obj_t BgL_lz00_2464, obj_t BgL_varsz00_2465, obj_t BgL_localsz00_2466, obj_t BgL_locz00_2467)
{
{ /* Eval/evaluate.scm 502 */
if(
NULLP(BgL_lz00_2464))
{ /* Eval/evaluate.scm 498 */
return BNIL;}  else 
{ /* Eval/evaluate.scm 500 */
obj_t BgL_locz00_2470;
{ /* Eval/evaluate.scm 500 */
obj_t BgL_arg2265z00_2478;
BgL_arg2265z00_2478 = 
CAR(
((obj_t)BgL_lz00_2464)); 
BgL_locz00_2470 = 
BGl_getzd2locationzd2zz__evaluatez00(BgL_arg2265z00_2478, BgL_locz00_2467); } 
{ /* Eval/evaluate.scm 501 */
obj_t BgL_arg2258z00_2471;obj_t BgL_arg2259z00_2472;
{ /* Eval/evaluate.scm 501 */
obj_t BgL_arg2260z00_2473;
{ /* Eval/evaluate.scm 501 */
obj_t BgL_pairz00_3426;
{ /* Eval/evaluate.scm 501 */
obj_t BgL_pairz00_3425;
BgL_pairz00_3425 = 
CAR(
((obj_t)BgL_lz00_2464)); 
BgL_pairz00_3426 = 
CDR(BgL_pairz00_3425); } 
BgL_arg2260z00_2473 = 
CAR(BgL_pairz00_3426); } 
BgL_arg2258z00_2471 = 
BGl_convz00zz__evaluatez00(BgL_arg2260z00_2473, BgL_localsz00_2466, BgL_globalsz00_4462, BFALSE, BgL_wherez00_4463, BgL_locz00_2470, ((bool_t)0)); } 
{ /* Eval/evaluate.scm 502 */
obj_t BgL_arg2261z00_2474;obj_t BgL_arg2262z00_2475;obj_t BgL_arg2263z00_2476;
BgL_arg2261z00_2474 = 
CDR(
((obj_t)BgL_lz00_2464)); 
BgL_arg2262z00_2475 = 
CDR(
((obj_t)BgL_varsz00_2465)); 
{ /* Eval/evaluate.scm 502 */
obj_t BgL_arg2264z00_2477;
BgL_arg2264z00_2477 = 
CAR(
((obj_t)BgL_varsz00_2465)); 
BgL_arg2263z00_2476 = 
MAKE_YOUNG_PAIR(BgL_arg2264z00_2477, BgL_localsz00_2466); } 
BgL_arg2259z00_2472 = 
BGl_convzd2valsze70z35zz__evaluatez00(BgL_wherez00_4463, BgL_globalsz00_4462, BgL_arg2261z00_2474, BgL_arg2262z00_2475, BgL_arg2263z00_2476, BgL_locz00_2470); } 
return 
MAKE_YOUNG_PAIR(BgL_arg2258z00_2471, BgL_arg2259z00_2472);} } } 

}



/* conv-lambda~0 */
BgL_ev_absz00_bglt BGl_convzd2lambdaze70z35zz__evaluatez00(obj_t BgL_globalsz00_4467, obj_t BgL_localsz00_4466, obj_t BgL_ez00_4465, obj_t BgL_locz00_4464, obj_t BgL_formalsz00_2655, obj_t BgL_bodyz00_2656, obj_t BgL_wherez00_2657, obj_t BgL_typez00_2658)
{
{ /* Eval/evaluate.scm 404 */
{ 
obj_t BgL_lz00_2689;
{ /* Eval/evaluate.scm 406 */
obj_t BgL_argsz00_2661;
BgL_lz00_2689 = 
BGl_dssslzd2formalszd2ze3schemezd2typedzd2formalsze3zz__dssslz00(BgL_formalsz00_2655, BGl_errorzd2envzd2zz__errorz00, ((bool_t)1)); 
{ 
obj_t BgL_rz00_2693;obj_t BgL_flatz00_2694;long BgL_arityz00_2695;
BgL_rz00_2693 = BgL_lz00_2689; 
BgL_flatz00_2694 = BNIL; 
BgL_arityz00_2695 = ((long)0); 
BgL_zc3z04anonymousza32360ze3z87_2696:
if(
NULLP(BgL_rz00_2693))
{ /* Eval/evaluate.scm 399 */
obj_t BgL_val0_1196z00_2698;
BgL_val0_1196z00_2698 = 
bgl_reverse_bang(BgL_flatz00_2694); 
{ /* Eval/evaluate.scm 399 */
int BgL_res2713z00_3304;
{ /* Eval/evaluate.scm 399 */
int BgL_tmpz00_6998;
BgL_tmpz00_6998 = 
(int)(((long)2)); 
BgL_res2713z00_3304 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_6998); } BgL_res2713z00_3304; } 
{ /* Eval/evaluate.scm 399 */
obj_t BgL_auxz00_7003;int BgL_tmpz00_7001;
BgL_auxz00_7003 = 
BINT(BgL_arityz00_2695); 
BgL_tmpz00_7001 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_7001, BgL_auxz00_7003); } 
BgL_argsz00_2661 = BgL_val0_1196z00_2698; }  else 
{ /* Eval/evaluate.scm 398 */
if(
PAIRP(BgL_rz00_2693))
{ /* Eval/evaluate.scm 403 */
obj_t BgL_arg2363z00_2701;obj_t BgL_arg2364z00_2702;long BgL_arg2365z00_2703;
BgL_arg2363z00_2701 = 
CDR(BgL_rz00_2693); 
BgL_arg2364z00_2702 = 
MAKE_YOUNG_PAIR(
BGl_untypezd2identzd2zz__evaluatez00(
CAR(BgL_rz00_2693)), BgL_flatz00_2694); 
BgL_arg2365z00_2703 = 
(BgL_arityz00_2695+((long)1)); 
{ 
long BgL_arityz00_7015;obj_t BgL_flatz00_7014;obj_t BgL_rz00_7013;
BgL_rz00_7013 = BgL_arg2363z00_2701; 
BgL_flatz00_7014 = BgL_arg2364z00_2702; 
BgL_arityz00_7015 = BgL_arg2365z00_2703; 
BgL_arityz00_2695 = BgL_arityz00_7015; 
BgL_flatz00_2694 = BgL_flatz00_7014; 
BgL_rz00_2693 = BgL_rz00_7013; 
goto BgL_zc3z04anonymousza32360ze3z87_2696;} }  else 
{ /* Eval/evaluate.scm 401 */
obj_t BgL_val0_1198z00_2706;long BgL_val1_1199z00_2707;
{ /* Eval/evaluate.scm 401 */
obj_t BgL_arg2368z00_2708;
BgL_arg2368z00_2708 = 
MAKE_YOUNG_PAIR(
BGl_untypezd2identzd2zz__evaluatez00(BgL_rz00_2693), BgL_flatz00_2694); 
BgL_val0_1198z00_2706 = 
bgl_reverse_bang(BgL_arg2368z00_2708); } 
BgL_val1_1199z00_2707 = 
(((long)-1)-BgL_arityz00_2695); 
{ /* Eval/evaluate.scm 401 */
int BgL_res2717z00_3312;
{ /* Eval/evaluate.scm 401 */
int BgL_tmpz00_7020;
BgL_tmpz00_7020 = 
(int)(((long)2)); 
BgL_res2717z00_3312 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_7020); } BgL_res2717z00_3312; } 
{ /* Eval/evaluate.scm 401 */
obj_t BgL_auxz00_7025;int BgL_tmpz00_7023;
BgL_auxz00_7025 = 
BINT(BgL_val1_1199z00_2707); 
BgL_tmpz00_7023 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_7023, BgL_auxz00_7025); } 
BgL_argsz00_2661 = BgL_val0_1198z00_2706; } } } 
{ /* Eval/evaluate.scm 407 */
obj_t BgL_arityz00_2662;
{ /* Eval/evaluate.scm 408 */
int BgL_tmpz00_7029;
BgL_tmpz00_7029 = 
(int)(((long)1)); 
BgL_arityz00_2662 = 
BGL_MVALUES_VAL(BgL_tmpz00_7029); } 
{ /* Eval/evaluate.scm 408 */
obj_t BgL_varsz00_2663;obj_t BgL_bodyz00_2664;obj_t BgL_nlocz00_2665;
if(
NULLP(BgL_argsz00_2661))
{ /* Eval/evaluate.scm 408 */
BgL_varsz00_2663 = BNIL; }  else 
{ /* Eval/evaluate.scm 408 */
obj_t BgL_head1202z00_2672;
{ /* Eval/evaluate.scm 408 */
obj_t BgL_res2719z00_3314;
BgL_res2719z00_3314 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1202z00_2672 = BgL_res2719z00_3314; } 
{ 
obj_t BgL_l1200z00_2674;obj_t BgL_tail1203z00_2675;
BgL_l1200z00_2674 = BgL_argsz00_2661; 
BgL_tail1203z00_2675 = BgL_head1202z00_2672; 
BgL_zc3z04anonymousza32351ze3z87_2676:
if(
NULLP(BgL_l1200z00_2674))
{ /* Eval/evaluate.scm 408 */
BgL_varsz00_2663 = 
CDR(BgL_head1202z00_2672); }  else 
{ /* Eval/evaluate.scm 408 */
obj_t BgL_newtail1204z00_2678;
{ /* Eval/evaluate.scm 408 */
BgL_ev_varz00_bglt BgL_arg2354z00_2680;
{ /* Eval/evaluate.scm 408 */
obj_t BgL_vz00_2681;
BgL_vz00_2681 = 
CAR(
((obj_t)BgL_l1200z00_2674)); 
{ /* Eval/evaluate.scm 409 */
BgL_ev_varz00_bglt BgL_new1098z00_2682;
{ /* Eval/evaluate.scm 411 */
BgL_ev_varz00_bglt BgL_new1097z00_2683;
BgL_new1097z00_2683 = 
((BgL_ev_varz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_varz00_bgl) ))); 
{ /* Eval/evaluate.scm 411 */
long BgL_arg2355z00_2684;
{ /* Eval/evaluate.scm 411 */
long BgL_res2721z00_3319;
BgL_res2721z00_3319 = 
BGL_CLASS_INDEX(BGl_ev_varz00zz__evaluate_typesz00); 
BgL_arg2355z00_2684 = BgL_res2721z00_3319; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1097z00_2683), BgL_arg2355z00_2684); } 
BgL_new1098z00_2682 = BgL_new1097z00_2683; } 
((((BgL_ev_varz00_bglt)COBJECT(BgL_new1098z00_2682))->BgL_namez00)=((obj_t)
CAR(
((obj_t)BgL_vz00_2681))),BUNSPEC); 
((((BgL_ev_varz00_bglt)COBJECT(BgL_new1098z00_2682))->BgL_effz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_ev_varz00_bglt)COBJECT(BgL_new1098z00_2682))->BgL_typez00)=((obj_t)
CDR(
((obj_t)BgL_vz00_2681))),BUNSPEC); 
BgL_arg2354z00_2680 = BgL_new1098z00_2682; } } 
{ /* Eval/evaluate.scm 408 */
obj_t BgL_res2722z00_3324;
BgL_res2722z00_3324 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg2354z00_2680), BNIL); 
BgL_newtail1204z00_2678 = BgL_res2722z00_3324; } } 
SET_CDR(BgL_tail1203z00_2675, BgL_newtail1204z00_2678); 
{ /* Eval/evaluate.scm 408 */
obj_t BgL_arg2353z00_2679;
BgL_arg2353z00_2679 = 
CDR(
((obj_t)BgL_l1200z00_2674)); 
{ 
obj_t BgL_tail1203z00_7057;obj_t BgL_l1200z00_7056;
BgL_l1200z00_7056 = BgL_arg2353z00_2679; 
BgL_tail1203z00_7057 = BgL_newtail1204z00_2678; 
BgL_tail1203z00_2675 = BgL_tail1203z00_7057; 
BgL_l1200z00_2674 = BgL_l1200z00_7056; 
goto BgL_zc3z04anonymousza32351ze3z87_2676;} } } } } 
BgL_bodyz00_2664 = 
BGl_makezd2dssslzd2functionzd2preludezd2zz__dssslz00(BgL_ez00_4465, BgL_formalsz00_2655, 
BGl_typezd2checkszd2zz__evaluatez00(BgL_argsz00_2661, BgL_argsz00_2661, 
BGl_typezd2resultzd2zz__evaluatez00(BgL_typez00_2658, BgL_bodyz00_2656, BgL_locz00_4464), BgL_locz00_4464, BgL_wherez00_2657), BGl_errorzd2envzd2zz__errorz00); 
BgL_nlocz00_2665 = 
BGl_getzd2locationzd2zz__evaluatez00(BgL_bodyz00_2656, BgL_locz00_4464); 
{ /* Eval/evaluate.scm 417 */
BgL_ev_absz00_bglt BgL_new1100z00_2666;
{ /* Eval/evaluate.scm 418 */
BgL_ev_absz00_bglt BgL_new1099z00_2668;
BgL_new1099z00_2668 = 
((BgL_ev_absz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_absz00_bgl) ))); 
{ /* Eval/evaluate.scm 418 */
long BgL_arg2349z00_2669;
{ /* Eval/evaluate.scm 418 */
long BgL_res2723z00_3328;
BgL_res2723z00_3328 = 
BGL_CLASS_INDEX(BGl_ev_absz00zz__evaluate_typesz00); 
BgL_arg2349z00_2669 = BgL_res2723z00_3328; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1099z00_2668), BgL_arg2349z00_2669); } 
BgL_new1100z00_2666 = BgL_new1099z00_2668; } 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1100z00_2666))->BgL_locz00)=((obj_t)BgL_locz00_4464),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1100z00_2666))->BgL_wherez00)=((obj_t)BgL_wherez00_2657),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1100z00_2666))->BgL_arityz00)=((obj_t)BgL_arityz00_2662),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1100z00_2666))->BgL_varsz00)=((obj_t)BgL_varsz00_2663),BUNSPEC); 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_7070;
{ /* Eval/evaluate.scm 422 */
obj_t BgL_arg2348z00_2667;
BgL_arg2348z00_2667 = 
BGl_appendzd221010zd2zz__evaluatez00(BgL_varsz00_2663, BgL_localsz00_4466); 
BgL_auxz00_7070 = 
((BgL_ev_exprz00_bglt)
BGl_convz00zz__evaluatez00(BgL_bodyz00_2664, BgL_arg2348z00_2667, BgL_globalsz00_4467, BTRUE, BgL_wherez00_2657, BgL_nlocz00_2665, ((bool_t)0))); } 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1100z00_2666))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_7070),BUNSPEC); } 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1100z00_2666))->BgL_siza7eza7)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1100z00_2666))->BgL_bindz00)=((obj_t)BNIL),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1100z00_2666))->BgL_freez00)=((obj_t)BNIL),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1100z00_2666))->BgL_innerz00)=((obj_t)BNIL),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1100z00_2666))->BgL_boxesz00)=((obj_t)BNIL),BUNSPEC); 
return BgL_new1100z00_2666;} } } } } } 

}



/* uconv~0 */
obj_t BGl_uconvze70ze7zz__evaluatez00(obj_t BgL_locz00_4471, obj_t BgL_wherez00_4470, obj_t BgL_globalsz00_4469, obj_t BgL_localsz00_4468, obj_t BgL_ez00_2636)
{
{ /* Eval/evaluate.scm 380 */
return 
BGl_uconvzf2locze70z15zz__evaluatez00(BgL_wherez00_4470, BgL_globalsz00_4469, BgL_localsz00_4468, BgL_ez00_2636, 
BGl_getzd2locationzd2zz__evaluatez00(BgL_ez00_2636, BgL_locz00_4471));} 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__evaluatez00()
{
{ /* Eval/evaluate.scm 15 */
return BUNSPEC;} 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__evaluatez00()
{
{ /* Eval/evaluate.scm 15 */
return BUNSPEC;} 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__evaluatez00()
{
{ /* Eval/evaluate.scm 15 */
return BUNSPEC;} 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__evaluatez00()
{
{ /* Eval/evaluate.scm 15 */
BGl_modulezd2initializa7ationz75zz__typez00(((long)121046086), 
BSTRING_TO_STRING(BGl_string3107z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)330490148), 
BSTRING_TO_STRING(BGl_string3107z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__biglooz00(((long)180158922), 
BSTRING_TO_STRING(BGl_string3107z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__tvectorz00(((long)135276775), 
BSTRING_TO_STRING(BGl_string3107z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__structurez00(((long)128218210), 
BSTRING_TO_STRING(BGl_string3107z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__bexitz00(((long)340267792), 
BSTRING_TO_STRING(BGl_string3107z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__bignumz00(((long)6519932), 
BSTRING_TO_STRING(BGl_string3107z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__osz00(((long)251314740), 
BSTRING_TO_STRING(BGl_string3107z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__dssslz00(((long)443936801), 
BSTRING_TO_STRING(BGl_string3107z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__bitz00(((long)439353001), 
BSTRING_TO_STRING(BGl_string3107z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__paramz00(((long)453939141), 
BSTRING_TO_STRING(BGl_string3107z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)193422112), 
BSTRING_TO_STRING(BGl_string3107z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__threadz00(((long)224967693), 
BSTRING_TO_STRING(BGl_string3107z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long)68574988), 
BSTRING_TO_STRING(BGl_string3107z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)93454137), 
BSTRING_TO_STRING(BGl_string3107z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(((long)437057797), 
BSTRING_TO_STRING(BGl_string3107z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(((long)268155843), 
BSTRING_TO_STRING(BGl_string3107z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long)198620800), 
BSTRING_TO_STRING(BGl_string3107z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)473309430), 
BSTRING_TO_STRING(BGl_string3107z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(((long)459519430), 
BSTRING_TO_STRING(BGl_string3107z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long)460262918), 
BSTRING_TO_STRING(BGl_string3107z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)-400105135), 
BSTRING_TO_STRING(BGl_string3107z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)9614678), 
BSTRING_TO_STRING(BGl_string3107z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)376927882), 
BSTRING_TO_STRING(BGl_string3107z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)127905250), 
BSTRING_TO_STRING(BGl_string3107z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)331540577), 
BSTRING_TO_STRING(BGl_string3107z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)86988580), 
BSTRING_TO_STRING(BGl_string3107z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)228151370), 
BSTRING_TO_STRING(BGl_string3107z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__ppz00(((long)233942021), 
BSTRING_TO_STRING(BGl_string3107z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)220648206), 
BSTRING_TO_STRING(BGl_string3107z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__prognz00(((long)177147622), 
BSTRING_TO_STRING(BGl_string3107z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__expandz00(((long)414007149), 
BSTRING_TO_STRING(BGl_string3107z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__evenvz00(((long)528345299), 
BSTRING_TO_STRING(BGl_string3107z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__evcompilez00(((long)492754569), 
BSTRING_TO_STRING(BGl_string3107z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__everrorz00(((long)375872221), 
BSTRING_TO_STRING(BGl_string3107z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__evmodulez00(((long)505897955), 
BSTRING_TO_STRING(BGl_string3107z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(((long)0), 
BSTRING_TO_STRING(BGl_string3107z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__evaluate_avarz00(((long)483789130), 
BSTRING_TO_STRING(BGl_string3107z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__evaluate_fsiza7eza7(((long)121298760), 
BSTRING_TO_STRING(BGl_string3107z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__evaluate_uncompz00(((long)193509656), 
BSTRING_TO_STRING(BGl_string3107z00zz__evaluatez00)); 
return 
BGl_modulezd2initializa7ationz75zz__evaluate_compz00(((long)444000678), 
BSTRING_TO_STRING(BGl_string3107z00zz__evaluatez00));} 

}

#ifdef __cplusplus
}
#endif
