/*===========================================================================*/
/*   (Eval/evaluate_comp.scm)                                                */
/*   Bigloo (4.3h)                                                           */
/*   Inria -- Sophia Antipolis (c)       Tue 12 May 2020 08:36:09 AM CEST    */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.3h/bin/bigloo -srfi enable-resolv -srfi enable-unistring -srfi enable-pcre -srfi enable-gmp -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.3h/lib/bigloo/4.3h -rm -copt -w -lib-dir /builddir/build/BUILD/bigloo-4.3h/lib/bigloo/4.3h -O4 -mklib -unsafe -safee -cc gcc -fsharing -q -no-hello -p -srfi bigloo-profile -c Eval/evaluate_comp.scm -o objs/obj_p/Eval/evaluate_comp.o) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_ev_exprz00_bgl {
   header_t header;
   obj_t widening;
} *BgL_ev_exprz00_bglt;

typedef struct BgL_ev_varz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_effz00;
   obj_t BgL_typez00;
} *BgL_ev_varz00_bglt;

typedef struct BgL_ev_globalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   obj_t BgL_namez00;
   obj_t BgL_modz00;
} *BgL_ev_globalz00_bglt;

typedef struct BgL_ev_littz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_valuez00;
} *BgL_ev_littz00_bglt;

typedef struct BgL_ev_ifz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_pz00;
   struct BgL_ev_exprz00_bgl * BgL_tz00;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
} *BgL_ev_ifz00_bglt;

typedef struct BgL_ev_listz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_argsz00;
} *BgL_ev_listz00_bglt;

typedef struct BgL_ev_orz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_argsz00;
} *BgL_ev_orz00_bglt;

typedef struct BgL_ev_andz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_argsz00;
} *BgL_ev_andz00_bglt;

typedef struct BgL_ev_prog2z00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_e1z00;
   struct BgL_ev_exprz00_bgl * BgL_e2z00;
} *BgL_ev_prog2z00_bglt;

typedef struct BgL_ev_hookz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
} *BgL_ev_hookz00_bglt;

typedef struct BgL_ev_trapz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
} *BgL_ev_trapz00_bglt;

typedef struct BgL_ev_setlocalz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
   struct BgL_ev_varz00_bgl * BgL_vz00;
} *BgL_ev_setlocalz00_bglt;

typedef struct BgL_ev_setglobalz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
   obj_t BgL_locz00;
   obj_t BgL_namez00;
   obj_t BgL_modz00;
} *BgL_ev_setglobalz00_bglt;

typedef struct BgL_ev_defglobalz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
   obj_t BgL_locz00;
   obj_t BgL_namez00;
   obj_t BgL_modz00;
} *BgL_ev_defglobalz00_bglt;

typedef struct BgL_ev_bindzd2exitzd2_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_varz00_bgl * BgL_varz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_bindzd2exitzd2_bglt;

typedef struct BgL_ev_unwindzd2protectzd2_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_unwindzd2protectzd2_bglt;

typedef struct BgL_ev_withzd2handlerzd2_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_handlerz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_withzd2handlerzd2_bglt;

typedef struct BgL_ev_synchroniza7eza7_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_ev_exprz00_bgl * BgL_mutexz00;
   struct BgL_ev_exprz00_bgl * BgL_prelockz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_synchroniza7eza7_bglt;

typedef struct BgL_ev_binderz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_binderz00_bglt;

typedef struct BgL_ev_letz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
   obj_t BgL_boxesz00;
} *BgL_ev_letz00_bglt;

typedef struct BgL_ev_letza2za2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
   obj_t BgL_boxesz00;
} *BgL_ev_letza2za2_bglt;

typedef struct BgL_ev_letrecz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_letrecz00_bglt;

typedef struct BgL_ev_labelsz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   obj_t BgL_envz00;
   obj_t BgL_stkz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
   obj_t BgL_boxesz00;
} *BgL_ev_labelsz00_bglt;

typedef struct BgL_ev_gotoz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_ev_varz00_bgl * BgL_labelz00;
   struct BgL_ev_labelsz00_bgl * BgL_labelsz00;
   obj_t BgL_argsz00;
} *BgL_ev_gotoz00_bglt;

typedef struct BgL_ev_appz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_ev_exprz00_bgl * BgL_funz00;
   obj_t BgL_argsz00;
   obj_t BgL_tailzf3zf3;
} *BgL_ev_appz00_bglt;

typedef struct BgL_ev_absz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   obj_t BgL_wherez00;
   obj_t BgL_arityz00;
   obj_t BgL_varsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
   int BgL_siza7eza7;
   obj_t BgL_bindz00;
   obj_t BgL_freez00;
   obj_t BgL_innerz00;
   obj_t BgL_boxesz00;
} *BgL_ev_absz00_bglt;


static obj_t BGl_symbol5230z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5232z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5234z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5236z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5238z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5240z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5242z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5244z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5246z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5248z00zz__evaluate_compz00 = BUNSPEC;
BGL_EXPORTED_DECL obj_t BGl_compilez00zz__evaluate_compz00(BgL_ev_exprz00_bglt);
static obj_t BGl_z62zc3z04anonymousza32738ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_symbol5250z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5252z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5254z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5256z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5258z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31775ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_symbol5260z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_compzd2oldzd2callz00zz__evaluate_compz00(BgL_ev_appz00_bglt, obj_t);
static obj_t BGl_symbol5262z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5264z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5266z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32013ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_symbol5268z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32845ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32683ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31954ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32667ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_ev_letrecz00zz__evaluate_typesz00;
static obj_t BGl_symbol5270z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5272z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5274z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5276z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5278z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31882ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_ev_letz00zz__evaluate_typesz00;
static obj_t BGl_symbol5280z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5282z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32120ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_symbol5284z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_subzd2stkzd2zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_symbol5286z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5288z00zz__evaluate_compz00 = BUNSPEC;
extern bool_t BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32952ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_assqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
static obj_t BGl_symbol5290z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5292z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5294z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_Eze70ze7zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32791ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31973ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31884ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_objectzd2initzd2zz__evaluate_compz00();
static obj_t BGl_z62zc3z04anonymousza33577ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_cadrerrvz00zz__evaluate_compz00(obj_t);
extern obj_t BGl_2za2za2zz__r4_numbers_6_5z00(obj_t, obj_t);
extern obj_t BGl_2zb2zb2zz__r4_numbers_6_5z00(obj_t, obj_t);
extern obj_t BGl_2zd2zd2zz__r4_numbers_6_5z00(obj_t, obj_t);
extern obj_t BGl_2zf2zf2zz__r4_numbers_6_5z00(obj_t, obj_t);
static obj_t BGl_z62compzd2ev_or1405zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32300ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern bool_t BGl_2zc3zc3zz__r4_numbers_6_5z00(obj_t, obj_t);
extern bool_t BGl_2zd3zd3zz__r4_numbers_6_5z00(obj_t, obj_t);
extern bool_t BGl_2ze3ze3zz__r4_numbers_6_5z00(obj_t, obj_t);
extern obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32687ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33489ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32034ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33595ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32939ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32302ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t bstring_to_symbol(obj_t);
static obj_t BGl_z62zc3z04anonymousza32794ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31798ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
extern obj_t make_vector(long, obj_t);
extern obj_t BGl_ev_labelsz00zz__evaluate_typesz00;
static obj_t BGl_z62zc3z04anonymousza32036ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static long BGl_correctz00zz__evaluate_compz00(obj_t, long);
static obj_t BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_bindzd2framezd2zz__evaluate_compz00(obj_t, obj_t, long, long, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32973ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_appendzd221010zd2zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31888ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__evaluate_compz00();
static obj_t BGl_z62run5111z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5113z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5115z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_recze70ze7zz__evaluate_compz00(obj_t, obj_t, long);
static bool_t BGl_recze71ze7zz__evaluate_compz00(obj_t);
static obj_t BGl_z62run5117z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5119z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33033ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_ev_absz00zz__evaluate_typesz00;
static obj_t BGl_z62zc3z04anonymousza31994ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5121z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_zc3z04exitza33051ze3ze70z60zz__evaluate_compz00(obj_t, obj_t, obj_t);
extern obj_t BGl_everrorz00zz__everrorz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62run5123z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5125z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5127z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33301ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5129z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32797ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5131z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5133z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5135z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5137z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5139z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32306ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_reset_profilez00zz__evaluate_compz00();
static obj_t BGl_freezd2collectzd2zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62run5141z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5143z62zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_ev_ifz00zz__evaluate_typesz00;
static obj_t BGl_z62run5145z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5147z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5149z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62compzd2ev_labels1426zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32888ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5151z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5153z62zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62run5155z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33320ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5157z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5159z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32994ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(obj_t, long, obj_t, obj_t, obj_t);
static obj_t BGl_z62exitz62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5161z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5163z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5165z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5167z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33054ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5169z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5171z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5173z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_catchzd2trampolinezd2zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62run5175z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33160ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5177z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33055ze3ze5zz__evaluate_compz00(obj_t);
static obj_t BGl_z62run5179z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5110z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_ev_gotoz00zz__evaluate_typesz00;
static obj_t BGl_z62main5112z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62main5114z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3lexintza1zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62main5116z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62main5118z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62run5181z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5183z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33412ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5185z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5187z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33145ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5189z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5120z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32149ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5122z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62main5124z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62main5126z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_ozd2ze3sze70zd6zz__evaluate_compz00(obj_t);
static obj_t BGl_z62main5128z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62runz62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5191z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5193z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5195z62zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_unwindzd2untilz12zc0zz__bexitz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33219ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5130z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62main5132z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62main5134z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62main5136z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62main5138z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t);
extern bool_t BGl_numberzf3zf3zz__r4_numbers_6_5z00(obj_t);
static obj_t BGl_z62compzd2ev_bindzd2exit1418z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33090ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static double BGl_evalzd2floatzd2arithz00zz__evaluate_compz00(obj_t, obj_t);
extern int bgl_debug();
static obj_t BGl_z62zc3z04anonymousza33236ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33309ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32094ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33058ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5140z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62main5142z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62main5144z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62main5146z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_ev_orz00zz__evaluate_typesz00;
static obj_t BGl_z62main5148z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62compzd2ev_global1395zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_pushzd2boxeszd2argszd2onzd2spz00zz__evaluate_compz00(obj_t, obj_t, obj_t, long, obj_t);
extern obj_t BGl_ev_varz00zz__evaluate_typesz00;
extern obj_t create_struct(obj_t, int);
static obj_t BGl_z62zc3z04anonymousza33180ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_get_profilez00zz__evaluate_compz00();
static obj_t BGl_z62main5150z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62main5152z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62main5154z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
extern obj_t BGl_evarityzd2errorzd2zz__everrorz00(obj_t, obj_t, int, int);
static obj_t BGl_z62main5156z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62main5158z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
extern long bgl_list_length(obj_t);
static obj_t BGl_z62zc3z04anonymousza32703ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__evaluate_compz00();
extern obj_t BGl_evwarningz00zz__everrorz00(obj_t, obj_t);
static obj_t BGl_z62main5160z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62main5162z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62main5164z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5166z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5168z62zz__evaluate_compz00(obj_t, obj_t);
static bool_t BGl_needzd2shiftzd2zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62compzd2ev_withzd2handler1422z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
extern obj_t BGl_evmodulezd2findzd2globalz00zz__evmodulez00(obj_t, obj_t);
extern obj_t BGl_ev_andz00zz__evaluate_typesz00;
static obj_t BGl_z62zc3z04anonymousza32631ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31902ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33344ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32615ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5170z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5172z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5174z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5176z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5178z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33523ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33329ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33167ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5180z62zz__evaluate_compz00(obj_t);
static bool_t BGl_cadrzf3zf3zz__evaluate_compz00(obj_t);
static obj_t BGl_z62main5182z62zz__evaluate_compz00(obj_t);
static obj_t BGl_z62main5184z62zz__evaluate_compz00(obj_t);
static obj_t BGl_z62main5186z62zz__evaluate_compz00(obj_t);
static obj_t BGl_z62main5188z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mainz62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33540ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62compzd2ev_letza21414z12zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33079ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5190z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_ev_appz00zz__evaluate_typesz00;
static obj_t BGl_z62main5192z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62main5194z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_lnamez00zz__evaluate_compz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32812ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32723ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32707ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33258ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62compzd2ev_litt1401zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
extern obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_bigloozd2typezd2errorz00zz__errorz00(obj_t, obj_t, obj_t);
extern obj_t BGl_exitdzd2popzd2protectz12z12zz__bexitz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32651ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33615ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32635ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62compz62zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32619ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_ev_synchroniza7eza7zz__evaluate_typesz00;
static obj_t BGl_profzd2initzd2zz__evaluate_compz00();
extern obj_t BGl_uncompilez00zz__evaluate_uncompz00(BgL_ev_exprz00_bglt);
static obj_t BGl_z62zc3z04anonymousza33365ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33438ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31818ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33187ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32815ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33277ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_evmodulezd2bindzd2globalz12z12zz__evmodulez00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_usez00zz__evaluate_usez00(BgL_ev_exprz00_bglt, obj_t);
static obj_t BGl_z62zc3z04anonymousza32832ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33472ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32727ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32671ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static bool_t BGl_pushzd2argszd2onzd2spzd2zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32655ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_za2za2azd2labelza2za2zd2zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32639ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62compzd2ev_trap1389zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_ev_exprz00_bglt, long, obj_t, obj_t);
static obj_t BGl_makezd2statezd2zz__evaluate_compz00();
static obj_t BGl_z62zc3z04anonymousza32923ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32834ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32818ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32729ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_ev_defglobalz00zz__evaluate_typesz00;
static obj_t BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_symbol5325z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_requirezd2initializa7ationz75zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32924ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31839ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_symbol5333z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza33565ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33638ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_symbol5344z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5346z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5348z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_z62compzd2ev_prog21410zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
extern obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32691ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32675ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32659ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_listzd2ze3vectorz31zz__r4_vectors_6_8z00(obj_t);
static obj_t BGl_symbol5350z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_toplevelzd2initzd2zz__evaluate_compz00();
static obj_t BGl_z62compzd2ev_defglobal1399zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
extern obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
static obj_t BGl_z62compzd2ev_setglobal1397zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_catchzd2gotozd2trampolinez00zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32782ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31948ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31859ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(obj_t, obj_t);
static obj_t BGl_genericzd2initzd2zz__evaluate_compz00();
extern obj_t BGl_stringzd2copyzd2zz__r4_strings_6_7z00(obj_t);
extern obj_t BGl_ev_prog2z00zz__evaluate_typesz00;
static obj_t BGl_z62zc3z04anonymousza32040ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_evtypezd2errorzd2zz__everrorz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32872ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32929ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_ev_bindzd2exitzd2zz__evaluate_typesz00;
static obj_t BGl_z62zc3z04anonymousza32695ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33659ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32679ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t bgl_reverse_bang(obj_t);
static long BGl_za2za2siza7ezd2stackza2za2z75zz__evaluate_compz00;
extern obj_t BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00;
static obj_t BGl_z62zc3z04anonymousza33007ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33499ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62compzd2ev_goto1428zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62compzd2ev_let1412zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32400ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_ev_letza2za2zz__evaluate_typesz00;
static obj_t BGl_z62zc3z04anonymousza33040ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_evmodulezd2namezd2zz__evmodulez00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32949ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33041ze3ze5zz__evaluate_compz00(obj_t);
extern obj_t BGl_ev_trapz00zz__evaluate_typesz00;
static obj_t BGl_z62zc3z04anonymousza32877ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32699ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32151ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static bool_t BGl_makezd2boxeszd2zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_indexz00zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_zc3z04exitza33034ze3ze70z60zz__evaluate_compz00(obj_t, obj_t, obj_t, long, obj_t);
static obj_t BGl_z62zc3z04anonymousza33205ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_globalzd2funzd2valuez00zz__evaluate_compz00(BgL_ev_exprz00_bglt);
static bool_t BGl_freezd2restorezd2zz__evaluate_compz00(obj_t, obj_t, long);
extern obj_t BGl_ev_setglobalz00zz__evaluate_typesz00;
static obj_t BGl_z62compzd2ev_synchroniza7e1424z17zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33400ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33044ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl__indexz00zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32897ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_inlinezd2callzd2zz__evaluate_compz00(obj_t, BgL_ev_exprz00_bglt, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33151ze3ze5zz__evaluate_compz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_findzd2statezd2zz__evaluate_compz00();
static obj_t BGl_z62zc3z04anonymousza32155ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32228ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32066ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62compzd2ev_var1391zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62compzd2ev_app1430zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_compzd2withzd2pushz00zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62compilez62zz__evaluate_compz00(obj_t, obj_t);
extern bool_t bigloo_string_lt(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33226ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_z62findzd2statezb0zz__evaluate_compz00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__evaluate_compz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_usez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_uncompz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__evmodulez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__everrorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__evcompilez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__evenvz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__expandz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__prognz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ppz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__srfi4z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__dssslz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__bignumz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__structurez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__tvectorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__typez00(long, char *);
extern obj_t BGl_sortz00zz__r4_vectors_6_8z00(obj_t, obj_t);
extern obj_t BGl_ev_globalz00zz__evaluate_typesz00;
static obj_t BGl_z62zc3z04anonymousza32352ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32263ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62compzd2ev_and1407zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static bool_t BGl_checkzd2stackzd2zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33422ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33244ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32191ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_integerzd2ze3stringz31zz__r4_numbers_6_5_fixnumz00(long, long);
extern obj_t BGl_ev_littz00zz__evaluate_typesz00;
static obj_t BGl_loczd2typezd2errorz00zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33512ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_cnstzd2initzd2zz__evaluate_compz00();
static obj_t BGl_importedzd2moduleszd2initz00zz__evaluate_compz00();
static obj_t BGl_z62zc3z04anonymousza32800ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32711ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33084ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62compzd2ev_abs1432zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
extern obj_t BGl_ev_withzd2handlerzd2zz__evaluate_typesz00;
static obj_t BGl_z62compzd2ev_letrec1416zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32623ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33353ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62compzd2ev_if1403zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32446ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern bool_t BGl_evmodulezf3zf3zz__evmodulez00(obj_t);
static obj_t BGl_compzd2call0zd2zz__evaluate_compz00(obj_t, BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long);
static obj_t BGl_compzd2call1zd2zz__evaluate_compz00(obj_t, BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long, obj_t);
static obj_t BGl_compzd2call2zd2zz__evaluate_compz00(obj_t, BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long, obj_t, obj_t);
static obj_t BGl_compzd2call3zd2zz__evaluate_compz00(obj_t, BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t);
static obj_t BGl_compzd2call4zd2zz__evaluate_compz00(obj_t, BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32803ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_ev_exprz00zz__evaluate_typesz00;
static obj_t BGl_z62zc3z04anonymousza32715ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33266ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62comp1386z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32821ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33461ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32732ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32643ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31752ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32627ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62compzd2ev_setlocal1393zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
extern bool_t BGl_2zc3zd3z10zz__r4_numbers_6_5z00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33551ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32806ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_symbol5200z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5202z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5204z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_z62compzd2ev_unwindzd2prote1420z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_compz00zz__evaluate_compz00(BgL_ev_exprz00_bglt, obj_t);
static obj_t BGl_z62zc3z04anonymousza31932ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_symbol5210z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5218z00zz__evaluate_compz00 = BUNSPEC;
extern bool_t BGl_2ze3zd3z30zz__r4_numbers_6_5z00(obj_t, obj_t);
extern obj_t BGl_ev_setlocalz00zz__evaluate_typesz00;
static obj_t BGl_z62zc3z04anonymousza33391ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32735ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33375ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_arithzd2expressionzd2zz__evaluate_compz00(BgL_ev_appz00_bglt, obj_t);
static obj_t BGl_z62zc3z04anonymousza33448ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33286ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32719ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33197ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_symbol5220z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5222z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5225z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5228z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31950ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32825ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32663ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32809ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32647ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31918ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t *__cnst;


DEFINE_STATIC_BGL_PROCEDURE( BGl_zc3lexintzd2envz11zz__evaluate_compz00, BgL_bgl_za762za7c3lexintza7a1za75354z00, BGl_z62zc3lexintza1zz__evaluate_compz00, 0L, BUNSPEC, 2 );
extern obj_t BGl_zd2zd2envz00zz__r4_numbers_6_5z00;
extern obj_t BGl_zd3zd2envz01zz__r4_numbers_6_5z00;
extern obj_t BGl_f64vectorzd2refzd2envz00zz__srfi4z00;
extern obj_t BGl_ze3zd3fxzd2envze2zz__r4_numbers_6_5_fixnumz00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_compilezd2envzd2zz__evaluate_compz00, BgL_bgl_za762compileza762za7za7_5355z00, BGl_z62compilez62zz__evaluate_compz00, 0L, BUNSPEC, 1 );
extern obj_t BGl_zc3fxzd2envz11zz__r4_numbers_6_5_fixnumz00;
extern obj_t BGl_zc3zd3flzd2envzc2zz__r4_numbers_6_5_flonumz00;
extern obj_t BGl_ze3zd2envz31zz__r4_numbers_6_5z00;
DEFINE_STRING( BGl_string5201z00zz__evaluate_compz00, BgL_bgl_string5201za700za7za7_5356za7, "all", 3 );
DEFINE_STRING( BGl_string5203z00zz__evaluate_compz00, BgL_bgl_string5203za700za7za7_5357za7, "label-tag", 9 );
DEFINE_STRING( BGl_string5205z00zz__evaluate_compz00, BgL_bgl_string5205za700za7za7_5358za7, "bounce", 6 );
DEFINE_STRING( BGl_string5206z00zz__evaluate_compz00, BgL_bgl_string5206za700za7za7_5359za7, "non non non", 11 );
DEFINE_STRING( BGl_string5207z00zz__evaluate_compz00, BgL_bgl_string5207za700za7za7_5360za7, " in ", 4 );
extern obj_t BGl_zf2zd2envz20zz__r4_numbers_6_5z00;
DEFINE_STRING( BGl_string5208z00zz__evaluate_compz00, BgL_bgl_string5208za700za7za7_5361za7, "eval", 4 );
DEFINE_STRING( BGl_string5209z00zz__evaluate_compz00, BgL_bgl_string5209za700za7za7_5362za7, "internal error: not found", 25 );
DEFINE_STRING( BGl_string5211z00zz__evaluate_compz00, BgL_bgl_string5211za700za7za7_5363za7, "at", 2 );
DEFINE_STRING( BGl_string5212z00zz__evaluate_compz00, BgL_bgl_string5212za700za7za7_5364za7, "", 0 );
extern obj_t BGl_zd2fxzd2envz00zz__r4_numbers_6_5_fixnumz00;
DEFINE_STRING( BGl_string5213z00zz__evaluate_compz00, BgL_bgl_string5213za700za7za7_5365za7, "/builddir/build/BUILD/bigloo-4.3h/runtime/Eval/evaluate_comp.scm", 64 );
DEFINE_STRING( BGl_string5214z00zz__evaluate_compz00, BgL_bgl_string5214za700za7za7_5366za7, "&compile", 8 );
DEFINE_STRING( BGl_string5215z00zz__evaluate_compz00, BgL_bgl_string5215za700za7za7_5367za7, "ev_expr", 7 );
DEFINE_STRING( BGl_string5216z00zz__evaluate_compz00, BgL_bgl_string5216za700za7za7_5368za7, "expecting ~a, got ~a", 20 );
DEFINE_STRING( BGl_string5217z00zz__evaluate_compz00, BgL_bgl_string5217za700za7za7_5369za7, "wrong number of argument", 24 );
DEFINE_STRING( BGl_string5219z00zz__evaluate_compz00, BgL_bgl_string5219za700za7za7_5370za7, "mcell", 5 );
DEFINE_STRING( BGl_string5221z00zz__evaluate_compz00, BgL_bgl_string5221za700za7za7_5371za7, "internal", 8 );
DEFINE_STRING( BGl_string5223z00zz__evaluate_compz00, BgL_bgl_string5223za700za7za7_5372za7, "impossible", 10 );
DEFINE_STRING( BGl_string5224z00zz__evaluate_compz00, BgL_bgl_string5224za700za7za7_5373za7, "procedure", 9 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_findzd2statezd2envz00zz__evaluate_compz00, BgL_bgl_za762findza7d2stateza75374za7, BGl_z62findzd2statezb0zz__evaluate_compz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string5226z00zz__evaluate_compz00, BgL_bgl_string5226za700za7za7_5375za7, "user", 4 );
DEFINE_STRING( BGl_string5227z00zz__evaluate_compz00, BgL_bgl_string5227za700za7za7_5376za7, "invalid byte code", 17 );
DEFINE_STRING( BGl_string5229z00zz__evaluate_compz00, BgL_bgl_string5229za700za7za7_5377za7, "+", 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5300z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_tra5378z00, BGl_z62compzd2ev_trap1389zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5302z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_var5379z00, BGl_z62compzd2ev_var1391zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5303z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_set5380z00, BGl_z62compzd2ev_setlocal1393zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5304z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_glo5381z00, BGl_z62compzd2ev_global1395zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5305z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_set5382z00, BGl_z62compzd2ev_setglobal1397zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5306z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_def5383z00, BGl_z62compzd2ev_defglobal1399zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string5231z00zz__evaluate_compz00, BgL_bgl_string5231za700za7za7_5384za7, "number", 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5307z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_lit5385z00, BGl_z62compzd2ev_litt1401zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5308z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_if15386z00, BGl_z62compzd2ev_if1403zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string5233z00zz__evaluate_compz00, BgL_bgl_string5233za700za7za7_5387za7, "-", 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5309z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_or15388z00, BGl_z62compzd2ev_or1405zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string5235z00zz__evaluate_compz00, BgL_bgl_string5235za700za7za7_5389za7, "*", 1 );
DEFINE_STRING( BGl_string5237z00zz__evaluate_compz00, BgL_bgl_string5237za700za7za7_5390za7, "/", 1 );
DEFINE_STRING( BGl_string5239z00zz__evaluate_compz00, BgL_bgl_string5239za700za7za7_5391za7, "<", 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5310z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_and5392z00, BGl_z62compzd2ev_and1407zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5311z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_pro5393z00, BGl_z62compzd2ev_prog21410zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5312z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_let5394z00, BGl_z62compzd2ev_let1412zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5313z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_let5395z00, BGl_z62compzd2ev_letza21414z12zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5314z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_let5396z00, BGl_z62compzd2ev_letrec1416zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5315z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_bin5397z00, BGl_z62compzd2ev_bindzd2exit1418z62zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5316z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_unw5398z00, BGl_z62compzd2ev_unwindzd2prote1420z62zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string5241z00zz__evaluate_compz00, BgL_bgl_string5241za700za7za7_5399za7, ">", 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5317z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_wit5400z00, BGl_z62compzd2ev_withzd2handler1422z62zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5318z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_syn5401z00, BGl_z62compzd2ev_synchroniza7e1424z17zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string5243z00zz__evaluate_compz00, BgL_bgl_string5243za700za7za7_5402za7, "<=", 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5319z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_lab5403z00, BGl_z62compzd2ev_labels1426zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string5245z00zz__evaluate_compz00, BgL_bgl_string5245za700za7za7_5404za7, ">=", 2 );
DEFINE_STRING( BGl_string5247z00zz__evaluate_compz00, BgL_bgl_string5247za700za7za7_5405za7, "=", 1 );
DEFINE_STRING( BGl_string5249z00zz__evaluate_compz00, BgL_bgl_string5249za700za7za7_5406za7, "+fx", 3 );
extern obj_t BGl_zb2flzd2envz60zz__r4_numbers_6_5_flonumz00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5320z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_got5407z00, BGl_z62compzd2ev_goto1428zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5321z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_app5408z00, BGl_z62compzd2ev_app1430zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5322z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_abs5409z00, BGl_z62compzd2ev_abs1432zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string5251z00zz__evaluate_compz00, BgL_bgl_string5251za700za7za7_5410za7, "fixnum", 6 );
DEFINE_STRING( BGl_string5253z00zz__evaluate_compz00, BgL_bgl_string5253za700za7za7_5411za7, "-fx", 3 );
DEFINE_STRING( BGl_string5255z00zz__evaluate_compz00, BgL_bgl_string5255za700za7za7_5412za7, "*fx", 3 );
DEFINE_STRING( BGl_string5257z00zz__evaluate_compz00, BgL_bgl_string5257za700za7za7_5413za7, "/fx", 3 );
DEFINE_STRING( BGl_string5259z00zz__evaluate_compz00, BgL_bgl_string5259za700za7za7_5414za7, "<fx", 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5336z00zz__evaluate_compz00, BgL_bgl_za762za7c3za704anonymo5415za7, BGl_z62zc3z04anonymousza32791ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string5261z00zz__evaluate_compz00, BgL_bgl_string5261za700za7za7_5416za7, ">fx", 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5337z00zz__evaluate_compz00, BgL_bgl_za762za7c3za704anonymo5417za7, BGl_z62zc3z04anonymousza32794ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5338z00zz__evaluate_compz00, BgL_bgl_za762za7c3za704anonymo5418za7, BGl_z62zc3z04anonymousza32797ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string5263z00zz__evaluate_compz00, BgL_bgl_string5263za700za7za7_5419za7, "<=fx", 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5339z00zz__evaluate_compz00, BgL_bgl_za762za7c3za704anonymo5420za7, BGl_z62zc3z04anonymousza32800ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string5265z00zz__evaluate_compz00, BgL_bgl_string5265za700za7za7_5421za7, ">=fx", 4 );
DEFINE_STRING( BGl_string5267z00zz__evaluate_compz00, BgL_bgl_string5267za700za7za7_5422za7, "=fx", 3 );
DEFINE_STRING( BGl_string5269z00zz__evaluate_compz00, BgL_bgl_string5269za700za7za7_5423za7, "+fl", 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5340z00zz__evaluate_compz00, BgL_bgl_za762za7c3za704anonymo5424za7, BGl_z62zc3z04anonymousza32803ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5341z00zz__evaluate_compz00, BgL_bgl_za762za7c3za704anonymo5425za7, BGl_z62zc3z04anonymousza32806ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5342z00zz__evaluate_compz00, BgL_bgl_za762za7c3za704anonymo5426za7, BGl_z62zc3z04anonymousza32809ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5343z00zz__evaluate_compz00, BgL_bgl_za762za7c3za704anonymo5427za7, BGl_z62zc3z04anonymousza32812ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string5271z00zz__evaluate_compz00, BgL_bgl_string5271za700za7za7_5428za7, "flonum", 6 );
DEFINE_STRING( BGl_string5273z00zz__evaluate_compz00, BgL_bgl_string5273za700za7za7_5429za7, "-fl", 3 );
DEFINE_STRING( BGl_string5275z00zz__evaluate_compz00, BgL_bgl_string5275za700za7za7_5430za7, "*fl", 3 );
DEFINE_STRING( BGl_string5277z00zz__evaluate_compz00, BgL_bgl_string5277za700za7za7_5431za7, "/fl", 3 );
DEFINE_STRING( BGl_string5279z00zz__evaluate_compz00, BgL_bgl_string5279za700za7za7_5432za7, "<fl", 3 );
extern obj_t BGl_ze3fxzd2envz31zz__r4_numbers_6_5_fixnumz00;
DEFINE_STRING( BGl_string5281z00zz__evaluate_compz00, BgL_bgl_string5281za700za7za7_5433za7, ">fl", 3 );
DEFINE_STRING( BGl_string5283z00zz__evaluate_compz00, BgL_bgl_string5283za700za7za7_5434za7, "<=fl", 4 );
DEFINE_STRING( BGl_string5285z00zz__evaluate_compz00, BgL_bgl_string5285za700za7za7_5435za7, ">=fl", 4 );
DEFINE_STRING( BGl_string5287z00zz__evaluate_compz00, BgL_bgl_string5287za700za7za7_5436za7, "=fl", 3 );
DEFINE_STRING( BGl_string5289z00zz__evaluate_compz00, BgL_bgl_string5289za700za7za7_5437za7, "car", 3 );
DEFINE_STRING( BGl_string5291z00zz__evaluate_compz00, BgL_bgl_string5291za700za7za7_5438za7, "pair", 4 );
DEFINE_STRING( BGl_string5293z00zz__evaluate_compz00, BgL_bgl_string5293za700za7za7_5439za7, "cdr", 3 );
DEFINE_STRING( BGl_string5295z00zz__evaluate_compz00, BgL_bgl_string5295za700za7za7_5440za7, "cadr", 4 );
DEFINE_STRING( BGl_string5297z00zz__evaluate_compz00, BgL_bgl_string5297za700za7za7_5441za7, "comp1386", 8 );
DEFINE_STRING( BGl_string5298z00zz__evaluate_compz00, BgL_bgl_string5298za700za7za7_5442za7, "internal error: not defined for", 31 );
DEFINE_STRING( BGl_string5299z00zz__evaluate_compz00, BgL_bgl_string5299za700za7za7_5443za7, "&comp", 5 );
extern obj_t BGl_ze3zd3flzd2envze2zz__r4_numbers_6_5_flonumz00;
extern obj_t BGl_zc3flzd2envz11zz__r4_numbers_6_5_flonumz00;
extern obj_t BGl_zc3zd3zd2envzc2zz__r4_numbers_6_5z00;
extern obj_t BGl_zf2fxzd2envz20zz__r4_numbers_6_5_fixnumz00;
extern obj_t BGl_za2fxzd2envz70zz__r4_numbers_6_5_fixnumz00;
DEFINE_STATIC_BGL_GENERIC( BGl_compzd2envzd2zz__evaluate_compz00, BgL_bgl_za762compza762za7za7__ev5444z00, BGl_z62compz62zz__evaluate_compz00, 0L, BUNSPEC, 2 );
extern obj_t BGl_zd2flzd2envz00zz__r4_numbers_6_5_flonumz00;
extern obj_t BGl_carzd2envzd2zz__r4_pairs_and_lists_6_3z00;
extern obj_t BGl_cadrzd2envzd2zz__r4_pairs_and_lists_6_3z00;
extern obj_t BGl_ze3zd3zd2envze2zz__r4_numbers_6_5z00;
extern obj_t BGl_ze3flzd2envz31zz__r4_numbers_6_5_flonumz00;
extern obj_t BGl_zf2flzd2envz20zz__r4_numbers_6_5_flonumz00;
extern obj_t BGl_za2flzd2envz70zz__r4_numbers_6_5_flonumz00;
extern obj_t BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00;
extern obj_t BGl_zd3fxzd2envz01zz__r4_numbers_6_5_fixnumz00;
DEFINE_STRING( BGl_string5301z00zz__evaluate_compz00, BgL_bgl_string5301za700za7za7_5445za7, "comp", 4 );
DEFINE_STRING( BGl_string5323z00zz__evaluate_compz00, BgL_bgl_string5323za700za7za7_5446za7, "internal error", 14 );
DEFINE_STRING( BGl_string5324z00zz__evaluate_compz00, BgL_bgl_string5324za700za7za7_5447za7, "must be dead code", 17 );
DEFINE_STRING( BGl_string5326z00zz__evaluate_compz00, BgL_bgl_string5326za700za7za7_5448za7, "notyet", 6 );
DEFINE_STRING( BGl_string5327z00zz__evaluate_compz00, BgL_bgl_string5327za700za7za7_5449za7, "synchronize", 11 );
DEFINE_STRING( BGl_string5328z00zz__evaluate_compz00, BgL_bgl_string5328za700za7za7_5450za7, "mutex", 5 );
DEFINE_STRING( BGl_string5329z00zz__evaluate_compz00, BgL_bgl_string5329za700za7za7_5451za7, "set!", 4 );
extern obj_t BGl_eqzf3zd2envz21zz__r4_equivalence_6_2z00;
extern obj_t BGl_cdrzd2envzd2zz__r4_pairs_and_lists_6_3z00;
DEFINE_STRING( BGl_string5330z00zz__evaluate_compz00, BgL_bgl_string5330za700za7za7_5452za7, "read-only variable", 18 );
DEFINE_STRING( BGl_string5331z00zz__evaluate_compz00, BgL_bgl_string5331za700za7za7_5453za7, "\nRedefinition of compiled variable -- ", 38 );
DEFINE_STRING( BGl_string5332z00zz__evaluate_compz00, BgL_bgl_string5332za700za7za7_5454za7, "Unbound variable", 16 );
DEFINE_STRING( BGl_string5334z00zz__evaluate_compz00, BgL_bgl_string5334za700za7za7_5455za7, "@", 1 );
DEFINE_STRING( BGl_string5335z00zz__evaluate_compz00, BgL_bgl_string5335za700za7za7_5456za7, "Uninitialized variable", 22 );
DEFINE_STRING( BGl_string5345z00zz__evaluate_compz00, BgL_bgl_string5345za700za7za7_5457za7, "get_sp", 6 );
DEFINE_STRING( BGl_string5347z00zz__evaluate_compz00, BgL_bgl_string5347za700za7za7_5458za7, "reset_profile", 13 );
DEFINE_STRING( BGl_string5349z00zz__evaluate_compz00, BgL_bgl_string5349za700za7za7_5459za7, "get_profile", 11 );
DEFINE_STRING( BGl_string5351z00zz__evaluate_compz00, BgL_bgl_string5351za700za7za7_5460za7, "reset_stack", 11 );
DEFINE_STRING( BGl_string5352z00zz__evaluate_compz00, BgL_bgl_string5352za700za7za7_5461za7, "internal error: unknown command", 31 );
DEFINE_STRING( BGl_string5353z00zz__evaluate_compz00, BgL_bgl_string5353za700za7za7_5462za7, "__evaluate_comp", 15 );
extern obj_t BGl_fixnumzd2ze3flonumzd2envze3zz__r4_numbers_6_5z00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5296z00zz__evaluate_compz00, BgL_bgl_za762comp1386za762za7za75463z00, BGl_z62comp1386z62zz__evaluate_compz00, 0L, BUNSPEC, 2 );
extern obj_t BGl_za2zd2envz70zz__r4_numbers_6_5z00;
extern obj_t BGl_zc3zd3fxzd2envzc2zz__r4_numbers_6_5_fixnumz00;
extern obj_t BGl_zb2zd2envz60zz__r4_numbers_6_5z00;
extern obj_t BGl_zd3flzd2envz01zz__r4_numbers_6_5_flonumz00;
extern obj_t BGl_zc3zd2envz11zz__r4_numbers_6_5z00;
extern obj_t BGl_zb2fxzd2envz60zz__r4_numbers_6_5_fixnumz00;

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_symbol5230z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5232z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5234z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5236z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5238z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5240z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5242z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5244z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5246z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5248z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5250z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5252z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5254z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5256z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5258z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5260z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5262z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5264z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5266z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5268z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5270z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5272z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5274z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5276z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5278z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5280z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5282z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5284z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5286z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5288z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5290z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5292z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5294z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_za2za2azd2labelza2za2zd2zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5325z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5333z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5344z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5346z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5348z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5350z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5200z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5202z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5204z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5210z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5218z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5220z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5222z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5225z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5228z00zz__evaluate_compz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* prof association table */
static obj_t write_bprof_table() {
   extern obj_t bprof_port;
   if( bprof_port == BUNSPEC ) bprof_port = (obj_t)fopen( "bmon.out", "w" );
   if( bprof_port ) {
      fputs( "(\"module-initialization\" \"BGl_modulezd2initializa7ationz75zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"toplevel-init\" \"Eval/evaluate_comp.scm\" 963) \"BGl_toplevelzd2initzd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "(\"append-21010\" \"BGl_appendzd221010zd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"reset_profile\" \"Eval/evaluate_comp.scm\" 3738) \"BGl_reset_profilez00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"o->s~0\" \"Eval/evaluate_comp.scm\" 3991) \"BGl_ozd2ze3sze70zd6zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<lexint\" \"Eval/evaluate_comp.scm\" 3822) \"BGl_z62zc3lexintza1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"get_profile\" \"Eval/evaluate_comp.scm\" 4130) \"BGl_get_profilez00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"rec~1\" \"Eval/evaluate_comp.scm\" 4155) \"BGl_recze71ze7zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"index\" \"Eval/evaluate_comp.scm\" 4323) \"BGl_indexz00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"_index\" \"Eval/evaluate_comp.scm\" 4474) \"BGl__indexz00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"lname\" \"Eval/evaluate_comp.scm\" 5060) \"BGl_lnamez00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"loc-type-error\" \"Eval/evaluate_comp.scm\" 5157) \"BGl_loczd2typezd2errorz00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"make-state\" \"Eval/evaluate_comp.scm\" 5415) \"BGl_makezd2statezd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"find-state\" \"Eval/evaluate_comp.scm\" 5531) \"BGl_findzd2statezd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&find-state\" \"Eval/evaluate_comp.scm\" 5531) \"BGl_z62findzd2statezb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"compile\" \"Eval/evaluate_comp.scm\" 6974) \"BGl_compilez00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&compile\" \"Eval/evaluate_comp.scm\" 6974) \"BGl_z62compilez62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"global-fun-value\" \"Eval/evaluate_comp.scm\" 8623) \"BGl_globalzd2funzd2valuez00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"catch-goto-trampoline\" \"Eval/evaluate_comp.scm\" 17544) \"BGl_catchzd2gotozd2trampolinez00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"push-boxes-args-on-sp\" \"Eval/evaluate_comp.scm\" 18918) \"BGl_pushzd2boxeszd2argszd2onzd2spz00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"sub-stk\" \"Eval/evaluate_comp.scm\" 19526) \"BGl_subzd2stkzd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"catch-trampoline\" \"Eval/evaluate_comp.scm\" 20027) \"BGl_catchzd2trampolinezd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"check-stack\" \"Eval/evaluate_comp.scm\" 20362) \"BGl_checkzd2stackzd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"comp-with-push\" \"Eval/evaluate_comp.scm\" 20432) \"BGl_compzd2withzd2pushz00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"rec~0\" \"Eval/evaluate_comp.scm\" 20677) \"BGl_recze70ze7zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"subr-call-with-push\" \"Eval/evaluate_comp.scm\" 20840) \"BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"push-args-on-sp\" \"Eval/evaluate_comp.scm\" 21077) \"BGl_pushzd2argszd2onzd2spzd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"push-nargs-on-sp\" \"Eval/evaluate_comp.scm\" 21237) \"BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"need-shift\" \"Eval/evaluate_comp.scm\" 23383) \"BGl_needzd2shiftzd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"comp-old-call\" \"Eval/evaluate_comp.scm\" 23648) \"BGl_compzd2oldzd2callz00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1752>\" \"Eval/evaluate_comp.scm\" 24088) \"BGl_z62zc3z04anonymousza31752ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1775>\" \"Eval/evaluate_comp.scm\" 24088) \"BGl_z62zc3z04anonymousza31775ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1798>\" \"Eval/evaluate_comp.scm\" 24429) \"BGl_z62zc3z04anonymousza31798ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1818>\" \"Eval/evaluate_comp.scm\" 24429) \"BGl_z62zc3z04anonymousza31818ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1839>\" \"Eval/evaluate_comp.scm\" 23861) \"BGl_z62zc3z04anonymousza31839ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1859>\" \"Eval/evaluate_comp.scm\" 23861) \"BGl_z62zc3z04anonymousza31859ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"comp-call0\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_compzd2call0zd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1882>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza31882ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1884>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza31884ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1888>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza31888ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1902>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza31902ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1918>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza31918ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1932>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza31932ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"comp-call1\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_compzd2call1zd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1948>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza31948ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1950>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza31950ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1954>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza31954ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1973>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza31973ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1994>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza31994ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2013>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32013ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"comp-call2\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_compzd2call2zd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2034>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32034ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2036>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32036ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2040>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32040ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2066>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32066ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2094>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32094ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2120>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32120ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"comp-call3\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_compzd2call3zd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2149>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32149ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2151>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32151ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2155>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32155ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2191>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32191ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2228>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32228ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2263>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32263ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"comp-call4\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_compzd2call4zd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2300>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32300ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2302>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32302ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2306>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32306ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2352>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32352ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2400>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32400ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2446>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32446ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"is-constant-fun?\" \"Eval/evaluate_comp.scm\" 28599) \"BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"compile-float-arith\" \"Eval/evaluate_comp.scm\" 29243) \"BGl_compilezd2floatzd2arithz00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"eval-float-arith\" \"Eval/evaluate_comp.scm\" 30631) \"BGl_evalzd2floatzd2arithz00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"E~0\" \"Eval/evaluate_comp.scm\" 31463) \"BGl_Eze70ze7zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"arith-expression\" \"Eval/evaluate_comp.scm\" 31480) \"BGl_arithzd2expressionzd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2615>\" \"Eval/evaluate_comp.scm\" 31744) \"BGl_z62zc3z04anonymousza32615ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"inline-call\" \"Eval/evaluate_comp.scm\" 32671) \"BGl_inlinezd2callzd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2619>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32619ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2623>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32623ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2627>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32627ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2631>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32631ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2635>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32635ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2639>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32639ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2643>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32643ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2647>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32647ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2651>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32651ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2655>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32655ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2659>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32659ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2663>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32663ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2667>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32667ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2671>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32671ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2675>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32675ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2679>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32679ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2683>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32683ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2687>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32687ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2691>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32691ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2695>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32695ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2699>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32699ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2703>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32703ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2707>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32707ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2711>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32711ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2715>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32715ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2719>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32719ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2723>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32723ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2727>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32727ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2729>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32729ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2732>\" \"Eval/evaluate_comp.scm\" 32860) \"BGl_z62zc3z04anonymousza32732ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2735>\" \"Eval/evaluate_comp.scm\" 32860) \"BGl_z62zc3z04anonymousza32735ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2738>\" \"Eval/evaluate_comp.scm\" 32860) \"BGl_z62zc3z04anonymousza32738ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"cadr?\" \"Eval/evaluate_comp.scm\" 33248) \"BGl_cadrzf3zf3zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"cadrerrv\" \"Eval/evaluate_comp.scm\" 33304) \"BGl_cadrerrvz00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"correct\" \"Eval/evaluate_comp.scm\" 34318) \"BGl_correctz00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"bind-frame\" \"Eval/evaluate_comp.scm\" 34404) \"BGl_bindzd2framezd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"make-boxes\" \"Eval/evaluate_comp.scm\" 38731) \"BGl_makezd2boxeszd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"free-collect\" \"Eval/evaluate_comp.scm\" 38987) \"BGl_freezd2collectzd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"free-restore\" \"Eval/evaluate_comp.scm\" 39257) \"BGl_freezd2restorezd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp1386\" \"Eval/evaluate_comp.scm\" 7022) \"BGl_z62comp1386z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"comp\" \"Eval/evaluate_comp.scm\" 7022) \"BGl_compz00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp\" \"Eval/evaluate_comp.scm\" 7022) \"BGl_z62compz62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_abs1432\" \"Eval/evaluate_comp.scm\" 38257) \"BGl_z62compzd2ev_abs1432zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3540>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33540ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62mainz62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62runz62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3551>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33551ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5110\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5110z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5111\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5111z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3565>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33565ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5112\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5112z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5113\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5113z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3577>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33577ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5114\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5114z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5115\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5115z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3489>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33489ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5116\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5116z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5117\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5117z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3499>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33499ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5118\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5118z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5119\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5119z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3512>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33512ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5120\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5120z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5121\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5121z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3523>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33523ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5122\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5122z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5123\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5123z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3438>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33438ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5124\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5124z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5125\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5125z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3448>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33448ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5126\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5126z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5127\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5127z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3461>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33461ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5128\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5128z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5129\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5129z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3472>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33472ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5130\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5130z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5131\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5131z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3391>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33391ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5132\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5132z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5133\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5133z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3400>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33400ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5134\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5134z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5135\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5135z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3412>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33412ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5136\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5136z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5137\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5137z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3422>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33422ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5138\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5138z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5139\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5139z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3344>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33344ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5140\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5140z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5141\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5141z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3353>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33353ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5142\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5142z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5143\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5143z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3365>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33365ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5144\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5144z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5145\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5145z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3375>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33375ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5146\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5146z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5147\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5147z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3301>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33301ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5148\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5148z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5149\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5149z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3309>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33309ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5150\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5150z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5151\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5151z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3320>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33320ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5152\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5152z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5153\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5153z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3329>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33329ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5154\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5154z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5155\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5155z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3258>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33258ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5156\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5156z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5157\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5157z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3266>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33266ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5158\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5158z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5159\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5159z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3277>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33277ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5160\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5160z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5161\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5161z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3286>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33286ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5162\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5162z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5163\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5163z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3219>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33219ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5164\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5164z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5165\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5165z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3226>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33226ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5166\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5166z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5167\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5167z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3236>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33236ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5168\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5168z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5169\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5169z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3244>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33244ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5170\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5170z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5171\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5171z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3180>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33180ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5172\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5172z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5173\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5173z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3187>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33187ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5174\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5174z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5175\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5175z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3197>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33197ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5176\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5176z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5177\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5177z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3205>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33205ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5178\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5178z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5179\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5179z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3145>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33145ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5180\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5180z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5181\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5181z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3151>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33151ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5182\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5182z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5183\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5183z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3160>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33160ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5184\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5184z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5185\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5185z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3167>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33167ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5186\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5186z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5187\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5187z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3595>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33595ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5188\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5188z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5189\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5189z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3615>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33615ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5190\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5190z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5191\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5191z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3638>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33638ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5192\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5192z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5193\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5193z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3659>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33659ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5194\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5194z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5195\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5195z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_app1430\" \"Eval/evaluate_comp.scm\" 33872) \"BGl_z62compzd2ev_app1430zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_goto1428\" \"Eval/evaluate_comp.scm\" 17884) \"BGl_z62compzd2ev_goto1428zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3084>\" \"Eval/evaluate_comp.scm\" 18509) \"BGl_z62zc3z04anonymousza33084ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3090>\" \"Eval/evaluate_comp.scm\" 18790) \"BGl_z62zc3z04anonymousza33090ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_labels1426\" \"Eval/evaluate_comp.scm\" 16809) \"BGl_z62compzd2ev_labels1426zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3079>\" \"Eval/evaluate_comp.scm\" 17482) \"BGl_z62zc3z04anonymousza33079ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_synchronize1424\" \"Eval/evaluate_comp.scm\" 16182) \"BGl_z62compzd2ev_synchroniza7e1424z17zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3058>\" \"Eval/evaluate_comp.scm\" 16392) \"BGl_z62zc3z04anonymousza33058ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_with-handler1422\" \"Eval/evaluate_comp.scm\" 15840) \"BGl_z62compzd2ev_withzd2handler1422z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3044>\" \"Eval/evaluate_comp.scm\" 16005) \"BGl_z62zc3z04anonymousza33044ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"<@exit:3051>~0\" \"Eval/evaluate_comp.scm\" 16112) \"BGl_zc3z04exitza33051ze3ze70z60zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3054>\" \"Eval/evaluate_comp.scm\" 16112) \"BGl_z62zc3z04anonymousza33054ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3055>\" \"Eval/evaluate_comp.scm\" 16112) \"BGl_z62zc3z04anonymousza33055ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_unwind-prote1420\" \"Eval/evaluate_comp.scm\" 15532) \"BGl_z62compzd2ev_unwindzd2prote1420z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3040>\" \"Eval/evaluate_comp.scm\" 15683) \"BGl_z62zc3z04anonymousza33040ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3041>\" \"Eval/evaluate_comp.scm\" 15752) \"BGl_z62zc3z04anonymousza33041ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_bind-exit1418\" \"Eval/evaluate_comp.scm\" 15077) \"BGl_z62compzd2ev_bindzd2exit1418z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3033>\" \"Eval/evaluate_comp.scm\" 15316) \"BGl_z62zc3z04anonymousza33033ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"<@exit:3034>~0\" \"Eval/evaluate_comp.scm\" 15383) \"BGl_zc3z04exitza33034ze3ze70z60zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&exit\" \"Eval/evaluate_comp.scm\" 15383) \"BGl_z62exitz62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_letrec1416\" \"Eval/evaluate_comp.scm\" 14024) \"BGl_z62compzd2ev_letrec1416zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2994>\" \"Eval/evaluate_comp.scm\" 14306) \"BGl_z62zc3z04anonymousza32994ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3007>\" \"Eval/evaluate_comp.scm\" 14662) \"BGl_z62zc3z04anonymousza33007ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_let*1414\" \"Eval/evaluate_comp.scm\" 13529) \"BGl_z62compzd2ev_letza21414z12zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2973>\" \"Eval/evaluate_comp.scm\" 13764) \"BGl_z62zc3z04anonymousza32973ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_let1412\" \"Eval/evaluate_comp.scm\" 12849) \"BGl_z62compzd2ev_let1412zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2952>\" \"Eval/evaluate_comp.scm\" 13176) \"BGl_z62zc3z04anonymousza32952ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_prog21410\" \"Eval/evaluate_comp.scm\" 12655) \"BGl_z62compzd2ev_prog21410zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2949>\" \"Eval/evaluate_comp.scm\" 12785) \"BGl_z62zc3z04anonymousza32949ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_and1407\" \"Eval/evaluate_comp.scm\" 12369) \"BGl_z62compzd2ev_and1407zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2939>\" \"Eval/evaluate_comp.scm\" 12500) \"BGl_z62zc3z04anonymousza32939ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_or1405\" \"Eval/evaluate_comp.scm\" 12111) \"BGl_z62compzd2ev_or1405zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2929>\" \"Eval/evaluate_comp.scm\" 12240) \"BGl_z62zc3z04anonymousza32929ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_if1403\" \"Eval/evaluate_comp.scm\" 11907) \"BGl_z62compzd2ev_if1403zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2924>\" \"Eval/evaluate_comp.scm\" 12044) \"BGl_z62zc3z04anonymousza32924ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_litt1401\" \"Eval/evaluate_comp.scm\" 11788) \"BGl_z62compzd2ev_litt1401zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2923>\" \"Eval/evaluate_comp.scm\" 11867) \"BGl_z62zc3z04anonymousza32923ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_defglobal1399\" \"Eval/evaluate_comp.scm\" 10831) \"BGl_z62compzd2ev_defglobal1399zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2897>\" \"Eval/evaluate_comp.scm\" 10957) \"BGl_z62zc3z04anonymousza32897ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_setglobal1397\" \"Eval/evaluate_comp.scm\" 9970) \"BGl_z62compzd2ev_setglobal1397zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2872>\" \"Eval/evaluate_comp.scm\" 10180) \"BGl_z62zc3z04anonymousza32872ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2877>\" \"Eval/evaluate_comp.scm\" 10353) \"BGl_z62zc3z04anonymousza32877ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2888>\" \"Eval/evaluate_comp.scm\" 10613) \"BGl_z62zc3z04anonymousza32888ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_global1395\" \"Eval/evaluate_comp.scm\" 8830) \"BGl_z62compzd2ev_global1395zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2832>\" \"Eval/evaluate_comp.scm\" 9018) \"BGl_z62zc3z04anonymousza32832ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2834>\" \"Eval/evaluate_comp.scm\" 9111) \"BGl_z62zc3z04anonymousza32834ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2845>\" \"Eval/evaluate_comp.scm\" 9364) \"BGl_z62zc3z04anonymousza32845ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_setlocal1393\" \"Eval/evaluate_comp.scm\" 8242) \"BGl_z62compzd2ev_setlocal1393zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2821>\" \"Eval/evaluate_comp.scm\" 8418) \"BGl_z62zc3z04anonymousza32821ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2825>\" \"Eval/evaluate_comp.scm\" 8525) \"BGl_z62zc3z04anonymousza32825ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_var1391\" \"Eval/evaluate_comp.scm\" 8097) \"BGl_z62compzd2ev_var1391zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2809>\" \"Eval/evaluate_comp.scm\" 8208) \"BGl_z62zc3z04anonymousza32809ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2812>\" \"Eval/evaluate_comp.scm\" 8208) \"BGl_z62zc3z04anonymousza32812ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2803>\" \"Eval/evaluate_comp.scm\" 8208) \"BGl_z62zc3z04anonymousza32803ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2806>\" \"Eval/evaluate_comp.scm\" 8208) \"BGl_z62zc3z04anonymousza32806ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2797>\" \"Eval/evaluate_comp.scm\" 8208) \"BGl_z62zc3z04anonymousza32797ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2800>\" \"Eval/evaluate_comp.scm\" 8208) \"BGl_z62zc3z04anonymousza32800ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2791>\" \"Eval/evaluate_comp.scm\" 8208) \"BGl_z62zc3z04anonymousza32791ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2794>\" \"Eval/evaluate_comp.scm\" 8208) \"BGl_z62zc3z04anonymousza32794ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2815>\" \"Eval/evaluate_comp.scm\" 8208) \"BGl_z62zc3z04anonymousza32815ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2818>\" \"Eval/evaluate_comp.scm\" 8208) \"BGl_z62zc3z04anonymousza32818ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_trap1389\" \"Eval/evaluate_comp.scm\" 7340) \"BGl_z62compzd2ev_trap1389zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2782>\" \"Eval/evaluate_comp.scm\" 7442) \"BGl_z62zc3z04anonymousza32782ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "(\"CONS\" \"make_pair\")\n", (FILE *)bprof_port );
      fputs( "(\"%STRING->SYMBOL\" \"make_symbol\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-STRING\" \"string_to_bstring_len\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-OUTPUT-PORT\" \"bgl_make_output_port\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-INPUT-PORT\" \"bgl_make_input_port\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-ERROR-PORT\" \"make_error_port\")\n", (FILE *)bprof_port );
   }
   return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__evaluate_compz00(long BgL_checksumz00_15063, char * BgL_fromz00_15064)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__evaluate_compz00))
{ 
BGl_requirezd2initializa7ationz75zz__evaluate_compz00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__evaluate_compz00(); 
BGl_cnstzd2initzd2zz__evaluate_compz00(); 
BGl_importedzd2moduleszd2initz00zz__evaluate_compz00(); 
BGl_genericzd2initzd2zz__evaluate_compz00(); 
BGl_methodzd2initzd2zz__evaluate_compz00(); 
BGl_toplevelzd2initzd2zz__evaluate_compz00(); 
return 
BGl_profzd2initzd2zz__evaluate_compz00();}  else 
{ 
return BUNSPEC;} } 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__evaluate_compz00()
{
{ /* Eval/evaluate_comp.scm 15 */
BGl_symbol5200z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5201z00zz__evaluate_compz00); 
BGl_symbol5202z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5203z00zz__evaluate_compz00); 
BGl_symbol5204z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5205z00zz__evaluate_compz00); 
BGl_symbol5210z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5211z00zz__evaluate_compz00); 
BGl_symbol5218z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5219z00zz__evaluate_compz00); 
BGl_symbol5220z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5221z00zz__evaluate_compz00); 
BGl_symbol5222z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5223z00zz__evaluate_compz00); 
BGl_symbol5225z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5226z00zz__evaluate_compz00); 
BGl_symbol5228z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5229z00zz__evaluate_compz00); 
BGl_symbol5230z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5231z00zz__evaluate_compz00); 
BGl_symbol5232z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5233z00zz__evaluate_compz00); 
BGl_symbol5234z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5235z00zz__evaluate_compz00); 
BGl_symbol5236z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5237z00zz__evaluate_compz00); 
BGl_symbol5238z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5239z00zz__evaluate_compz00); 
BGl_symbol5240z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5241z00zz__evaluate_compz00); 
BGl_symbol5242z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5243z00zz__evaluate_compz00); 
BGl_symbol5244z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5245z00zz__evaluate_compz00); 
BGl_symbol5246z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5247z00zz__evaluate_compz00); 
BGl_symbol5248z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5249z00zz__evaluate_compz00); 
BGl_symbol5250z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5251z00zz__evaluate_compz00); 
BGl_symbol5252z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5253z00zz__evaluate_compz00); 
BGl_symbol5254z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5255z00zz__evaluate_compz00); 
BGl_symbol5256z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5257z00zz__evaluate_compz00); 
BGl_symbol5258z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5259z00zz__evaluate_compz00); 
BGl_symbol5260z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5261z00zz__evaluate_compz00); 
BGl_symbol5262z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5263z00zz__evaluate_compz00); 
BGl_symbol5264z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5265z00zz__evaluate_compz00); 
BGl_symbol5266z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5267z00zz__evaluate_compz00); 
BGl_symbol5268z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5269z00zz__evaluate_compz00); 
BGl_symbol5270z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5271z00zz__evaluate_compz00); 
BGl_symbol5272z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5273z00zz__evaluate_compz00); 
BGl_symbol5274z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5275z00zz__evaluate_compz00); 
BGl_symbol5276z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5277z00zz__evaluate_compz00); 
BGl_symbol5278z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5279z00zz__evaluate_compz00); 
BGl_symbol5280z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5281z00zz__evaluate_compz00); 
BGl_symbol5282z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5283z00zz__evaluate_compz00); 
BGl_symbol5284z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5285z00zz__evaluate_compz00); 
BGl_symbol5286z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5287z00zz__evaluate_compz00); 
BGl_symbol5288z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5289z00zz__evaluate_compz00); 
BGl_symbol5290z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5291z00zz__evaluate_compz00); 
BGl_symbol5292z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5293z00zz__evaluate_compz00); 
BGl_symbol5294z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5295z00zz__evaluate_compz00); 
BGl_symbol5325z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5326z00zz__evaluate_compz00); 
BGl_symbol5333z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5334z00zz__evaluate_compz00); 
BGl_symbol5344z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5345z00zz__evaluate_compz00); 
BGl_symbol5346z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5347z00zz__evaluate_compz00); 
BGl_symbol5348z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5349z00zz__evaluate_compz00); 
return ( 
BGl_symbol5350z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5351z00zz__evaluate_compz00), BUNSPEC) ;} 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__evaluate_compz00()
{
{ /* Eval/evaluate_comp.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* prof-init */
obj_t BGl_profzd2initzd2zz__evaluate_compz00()
{
{ /* Eval/evaluate_comp.scm 15 */
return 
write_bprof_table();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__evaluate_compz00()
{
{ /* Eval/evaluate_comp.scm 15 */
{ /* Eval/evaluate_comp.scm 114 */
BGL_LONGLONG_T BgL_arg1476z00_1352;
{ /* Eval/evaluate_comp.scm 114 */
BGL_LONGLONG_T BgL_res3982z00_6412;
BgL_res3982z00_6412 = 
LONG_TO_LLONG(((long)0)); 
BgL_arg1476z00_1352 = BgL_res3982z00_6412; } 
{ /* Eval/evaluate_comp.scm 114 */
obj_t BgL_list1477z00_1353;
{ /* Eval/evaluate_comp.scm 114 */
obj_t BgL_arg1478z00_1354;
BgL_arg1478z00_1354 = 
MAKE_YOUNG_PAIR(
make_bllong(BgL_arg1476z00_1352), BNIL); 
BgL_list1477z00_1353 = 
MAKE_YOUNG_PAIR(BGl_symbol5200z00zz__evaluate_compz00, BgL_arg1478z00_1354); } 
BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00 = BgL_list1477z00_1353; } } 
BGl_za2za2siza7ezd2stackza2za2z75zz__evaluate_compz00 = ((long)8192); 
BGl_za2za2azd2labelza2za2zd2zz__evaluate_compz00 = 
create_struct(BGl_symbol5202z00zz__evaluate_compz00, 
(int)(((long)0))); 
BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00 = 
create_struct(BGl_symbol5204z00zz__evaluate_compz00, 
(int)(((long)0))); 
return BUNSPEC;} 

}



/* append-21010 */
obj_t BGl_appendzd221010zd2zz__evaluate_compz00(obj_t BgL_l1z00_1, obj_t BgL_l2z00_2)
{
{ 
{ 
obj_t BgL_headz00_1355;
BgL_headz00_1355 = 
MAKE_YOUNG_PAIR(BNIL, BgL_l2z00_2); 
{ 
obj_t BgL_prevz00_1356;obj_t BgL_tailz00_1357;
BgL_prevz00_1356 = BgL_headz00_1355; 
BgL_tailz00_1357 = BgL_l1z00_1; 
BgL_loopz00_1358:
if(
PAIRP(BgL_tailz00_1357))
{ 
obj_t BgL_newzd2prevzd2_1360;
BgL_newzd2prevzd2_1360 = 
MAKE_YOUNG_PAIR(
CAR(BgL_tailz00_1357), BgL_l2z00_2); 
SET_CDR(BgL_prevz00_1356, BgL_newzd2prevzd2_1360); 
{ 
obj_t BgL_tailz00_15140;obj_t BgL_prevz00_15139;
BgL_prevz00_15139 = BgL_newzd2prevzd2_1360; 
BgL_tailz00_15140 = 
CDR(BgL_tailz00_1357); 
BgL_tailz00_1357 = BgL_tailz00_15140; 
BgL_prevz00_1356 = BgL_prevz00_15139; 
goto BgL_loopz00_1358;} }  else 
{ BNIL; } 
return 
CDR(BgL_headz00_1355);} } } 

}



/* reset_profile */
obj_t BGl_reset_profilez00zz__evaluate_compz00()
{
{ /* Eval/evaluate_comp.scm 132 */
{ /* Eval/evaluate_comp.scm 133 */
BGL_LONGLONG_T BgL_arg1498z00_1383;
{ /* Eval/evaluate_comp.scm 133 */
BGL_LONGLONG_T BgL_res3989z00_6425;
BgL_res3989z00_6425 = 
LONG_TO_LLONG(((long)0)); 
BgL_arg1498z00_1383 = BgL_res3989z00_6425; } 
{ /* Eval/evaluate_comp.scm 133 */
obj_t BgL_list1499z00_1384;
{ /* Eval/evaluate_comp.scm 133 */
obj_t BgL_arg1500z00_1385;
BgL_arg1500z00_1385 = 
MAKE_YOUNG_PAIR(
make_bllong(BgL_arg1498z00_1383), BNIL); 
BgL_list1499z00_1384 = 
MAKE_YOUNG_PAIR(BGl_symbol5200z00zz__evaluate_compz00, BgL_arg1500z00_1385); } 
return ( 
BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00 = BgL_list1499z00_1384, BUNSPEC) ;} } } 

}



/* o->s~0 */
obj_t BGl_ozd2ze3sze70zd6zz__evaluate_compz00(obj_t BgL_vz00_1394)
{
{ /* Eval/evaluate_comp.scm 141 */
if(
BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(BgL_vz00_1394))
{ /* Ieee/fixnum.scm 979 */

return 
BGl_integerzd2ze3stringz31zz__r4_numbers_6_5_fixnumz00(
(long)CINT(BgL_vz00_1394), ((long)10));}  else 
{ /* Eval/evaluate_comp.scm 138 */
if(
SYMBOLP(BgL_vz00_1394))
{ /* Eval/evaluate_comp.scm 139 */
obj_t BgL_res3992z00_6430;
{ /* Eval/evaluate_comp.scm 139 */
obj_t BgL_arg3829z00_6429;
BgL_arg3829z00_6429 = 
SYMBOL_TO_STRING(BgL_vz00_1394); 
BgL_res3992z00_6430 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg3829z00_6429); } 
return BgL_res3992z00_6430;}  else 
{ /* Eval/evaluate_comp.scm 139 */
if(
STRINGP(BgL_vz00_1394))
{ /* Eval/evaluate_comp.scm 140 */
return BgL_vz00_1394;}  else 
{ /* Eval/evaluate_comp.scm 140 */
return BGl_string5206z00zz__evaluate_compz00;} } } } 

}



/* &<lexint */
obj_t BGl_z62zc3lexintza1zz__evaluate_compz00(obj_t BgL_envz00_10632, obj_t BgL_t1z00_10633, obj_t BgL_t2z00_10634)
{
{ /* Eval/evaluate_comp.scm 135 */
{ /* Eval/evaluate_comp.scm 138 */
bool_t BgL_tmpz00_15157;
{ /* Eval/evaluate_comp.scm 142 */
obj_t BgL_v1z00_12624;obj_t BgL_v2z00_12625;
BgL_v1z00_12624 = 
CAR(
((obj_t)BgL_t1z00_10633)); 
BgL_v2z00_12625 = 
CAR(
((obj_t)BgL_t2z00_10634)); 
{ /* Eval/evaluate_comp.scm 143 */
bool_t BgL_test5469z00_15162;
if(
BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(BgL_v1z00_12624))
{ /* Eval/evaluate_comp.scm 143 */
BgL_test5469z00_15162 = 
BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(BgL_v2z00_12625)
; }  else 
{ /* Eval/evaluate_comp.scm 143 */
BgL_test5469z00_15162 = ((bool_t)0)
; } 
if(BgL_test5469z00_15162)
{ /* Eval/evaluate_comp.scm 143 */
BgL_tmpz00_15157 = 
BGl_2zc3zc3zz__r4_numbers_6_5z00(BgL_v1z00_12624, BgL_v2z00_12625)
; }  else 
{ /* Eval/evaluate_comp.scm 143 */
BgL_tmpz00_15157 = 
bigloo_string_lt(
BGl_ozd2ze3sze70zd6zz__evaluate_compz00(BgL_v1z00_12624), 
BGl_ozd2ze3sze70zd6zz__evaluate_compz00(BgL_v2z00_12625))
; } } } 
return 
BBOOL(BgL_tmpz00_15157);} } 

}



/* get_profile */
obj_t BGl_get_profilez00zz__evaluate_compz00()
{
{ /* Eval/evaluate_comp.scm 147 */
BGl_recze71ze7zz__evaluate_compz00(BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00); 
return BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00;} 

}



/* rec~1 */
bool_t BGl_recze71ze7zz__evaluate_compz00(obj_t BgL_tz00_1403)
{
{ /* Eval/evaluate_comp.scm 148 */
{ /* Eval/evaluate_comp.scm 149 */
obj_t BgL_arg1511z00_1405;obj_t BgL_arg1513z00_1406;
BgL_arg1511z00_1405 = 
CDR(
((obj_t)BgL_tz00_1403)); 
{ /* Eval/evaluate_comp.scm 149 */
obj_t BgL_arg1514z00_1407;
{ /* Eval/evaluate_comp.scm 149 */
obj_t BgL_pairz00_6441;
BgL_pairz00_6441 = 
CDR(
((obj_t)BgL_tz00_1403)); 
BgL_arg1514z00_1407 = 
CDR(BgL_pairz00_6441); } 
BgL_arg1513z00_1406 = 
BGl_sortz00zz__r4_vectors_6_8z00(BGl_zc3lexintzd2envz11zz__evaluate_compz00, BgL_arg1514z00_1407); } 
{ /* Eval/evaluate_comp.scm 149 */
obj_t BgL_tmpz00_15178;
BgL_tmpz00_15178 = 
((obj_t)BgL_arg1511z00_1405); 
SET_CDR(BgL_tmpz00_15178, BgL_arg1513z00_1406); } } 
{ /* Eval/evaluate_comp.scm 150 */
obj_t BgL_g1288z00_1408;
{ /* Eval/evaluate_comp.scm 150 */
obj_t BgL_pairz00_6446;
BgL_pairz00_6446 = 
CDR(
((obj_t)BgL_tz00_1403)); 
BgL_g1288z00_1408 = 
CDR(BgL_pairz00_6446); } 
{ 
obj_t BgL_l1286z00_1410;
BgL_l1286z00_1410 = BgL_g1288z00_1408; 
BgL_zc3z04anonymousza31515ze3z87_1411:
if(
PAIRP(BgL_l1286z00_1410))
{ /* Eval/evaluate_comp.scm 150 */
BGl_recze71ze7zz__evaluate_compz00(
CAR(BgL_l1286z00_1410)); 
{ 
obj_t BgL_l1286z00_15188;
BgL_l1286z00_15188 = 
CDR(BgL_l1286z00_1410); 
BgL_l1286z00_1410 = BgL_l1286z00_15188; 
goto BgL_zc3z04anonymousza31515ze3z87_1411;} }  else 
{ /* Eval/evaluate_comp.scm 150 */
return ((bool_t)1);} } } } 

}



/* index */
obj_t BGl_indexz00zz__evaluate_compz00(obj_t BgL_xz00_6, obj_t BgL_lz00_7)
{
{ /* Eval/evaluate_comp.scm 156 */
{ 
obj_t BgL_lz00_1418;long BgL_nz00_1419;
BgL_lz00_1418 = BgL_lz00_7; 
BgL_nz00_1419 = ((long)0); 
BgL_zc3z04anonymousza31518ze3z87_1420:
if(
NULLP(BgL_lz00_1418))
{ /* Eval/evaluate_comp.scm 158 */
return BFALSE;}  else 
{ /* Eval/evaluate_comp.scm 158 */
if(
(BgL_xz00_6==
CAR(
((obj_t)BgL_lz00_1418))))
{ /* Eval/evaluate_comp.scm 159 */
return 
BINT(BgL_nz00_1419);}  else 
{ 
long BgL_nz00_15200;obj_t BgL_lz00_15197;
BgL_lz00_15197 = 
CDR(
((obj_t)BgL_lz00_1418)); 
BgL_nz00_15200 = 
(BgL_nz00_1419+((long)1)); 
BgL_nz00_1419 = BgL_nz00_15200; 
BgL_lz00_1418 = BgL_lz00_15197; 
goto BgL_zc3z04anonymousza31518ze3z87_1420;} } } } 

}



/* _index */
obj_t BGl__indexz00zz__evaluate_compz00(obj_t BgL_xz00_8, obj_t BgL_lz00_9)
{
{ /* Eval/evaluate_comp.scm 163 */
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL__ortest_1077z00_1428;
BgL__ortest_1077z00_1428 = 
BGl_indexz00zz__evaluate_compz00(BgL_xz00_8, BgL_lz00_9); 
if(
CBOOL(BgL__ortest_1077z00_1428))
{ /* Eval/evaluate_comp.scm 164 */
return BgL__ortest_1077z00_1428;}  else 
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_arg1525z00_1429;
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_arg1526z00_1430;
if(
NULLP(BgL_lz00_9))
{ /* Eval/evaluate_comp.scm 164 */
BgL_arg1526z00_1430 = BNIL; }  else 
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_head1291z00_1436;
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_arg1544z00_1448;
BgL_arg1544z00_1448 = 
BGl_lnamez00zz__evaluate_compz00(
CAR(
((obj_t)BgL_lz00_9))); 
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_res3999z00_6457;
BgL_res3999z00_6457 = 
MAKE_YOUNG_PAIR(BgL_arg1544z00_1448, BNIL); 
BgL_head1291z00_1436 = BgL_res3999z00_6457; } } 
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_g1294z00_1437;
BgL_g1294z00_1437 = 
CDR(
((obj_t)BgL_lz00_9)); 
{ 
obj_t BgL_l1289z00_1439;obj_t BgL_tail1292z00_1440;
BgL_l1289z00_1439 = BgL_g1294z00_1437; 
BgL_tail1292z00_1440 = BgL_head1291z00_1436; 
BgL_zc3z04anonymousza31536ze3z87_1441:
if(
NULLP(BgL_l1289z00_1439))
{ /* Eval/evaluate_comp.scm 164 */
BgL_arg1526z00_1430 = BgL_head1291z00_1436; }  else 
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_newtail1293z00_1443;
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_arg1541z00_1445;
BgL_arg1541z00_1445 = 
BGl_lnamez00zz__evaluate_compz00(
CAR(
((obj_t)BgL_l1289z00_1439))); 
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_res4001z00_6461;
BgL_res4001z00_6461 = 
MAKE_YOUNG_PAIR(BgL_arg1541z00_1445, BNIL); 
BgL_newtail1293z00_1443 = BgL_res4001z00_6461; } } 
SET_CDR(BgL_tail1292z00_1440, BgL_newtail1293z00_1443); 
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_arg1538z00_1444;
BgL_arg1538z00_1444 = 
CDR(
((obj_t)BgL_l1289z00_1439)); 
{ 
obj_t BgL_tail1292z00_15223;obj_t BgL_l1289z00_15222;
BgL_l1289z00_15222 = BgL_arg1538z00_1444; 
BgL_tail1292z00_15223 = BgL_newtail1293z00_1443; 
BgL_tail1292z00_1440 = BgL_tail1292z00_15223; 
BgL_l1289z00_1439 = BgL_l1289z00_15222; 
goto BgL_zc3z04anonymousza31536ze3z87_1441;} } } } } } 
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_list1527z00_1431;
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_arg1532z00_1432;
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_arg1534z00_1433;
BgL_arg1534z00_1433 = 
MAKE_YOUNG_PAIR(BgL_arg1526z00_1430, BNIL); 
BgL_arg1532z00_1432 = 
MAKE_YOUNG_PAIR(BGl_string5207z00zz__evaluate_compz00, BgL_arg1534z00_1433); } 
BgL_list1527z00_1431 = 
MAKE_YOUNG_PAIR(BgL_xz00_8, BgL_arg1532z00_1432); } 
BgL_arg1525z00_1429 = BgL_list1527z00_1431; } } 
return 
BGl_errorz00zz__errorz00(BGl_string5208z00zz__evaluate_compz00, BGl_string5209z00zz__evaluate_compz00, BgL_arg1525z00_1429);} } } 

}



/* lname */
obj_t BGl_lnamez00zz__evaluate_compz00(obj_t BgL_vz00_16)
{
{ /* Eval/evaluate_comp.scm 188 */
if(
BGl_isazf3zf3zz__objectz00(BgL_vz00_16, BGl_ev_varz00zz__evaluate_typesz00))
{ /* Eval/evaluate_comp.scm 189 */
return 
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_vz00_16)))->BgL_namez00);}  else 
{ /* Eval/evaluate_comp.scm 189 */
return BgL_vz00_16;} } 

}



/* loc-type-error */
obj_t BGl_loczd2typezd2errorz00zz__evaluate_compz00(obj_t BgL_fz00_17, obj_t BgL_mz00_18, obj_t BgL_vz00_19, obj_t BgL_locz00_20)
{
{ /* Eval/evaluate_comp.scm 193 */
{ 
obj_t BgL_fnamez00_1469;obj_t BgL_locz00_1470;
if(
PAIRP(BgL_locz00_20))
{ /* Eval/evaluate_comp.scm 194 */
obj_t BgL_cdrzd2194zd2_1475;
BgL_cdrzd2194zd2_1475 = 
CDR(BgL_locz00_20); 
if(
(
CAR(BgL_locz00_20)==BGl_symbol5210z00zz__evaluate_compz00))
{ /* Eval/evaluate_comp.scm 194 */
if(
PAIRP(BgL_cdrzd2194zd2_1475))
{ /* Eval/evaluate_comp.scm 194 */
obj_t BgL_cdrzd2198zd2_1479;
BgL_cdrzd2198zd2_1479 = 
CDR(BgL_cdrzd2194zd2_1475); 
if(
PAIRP(BgL_cdrzd2198zd2_1479))
{ /* Eval/evaluate_comp.scm 194 */
if(
NULLP(
CDR(BgL_cdrzd2198zd2_1479)))
{ /* Eval/evaluate_comp.scm 194 */
BgL_fnamez00_1469 = 
CAR(BgL_cdrzd2194zd2_1475); 
BgL_locz00_1470 = 
CAR(BgL_cdrzd2198zd2_1479); 
return 
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BgL_fz00_17, BgL_mz00_18, BgL_vz00_19, BgL_fnamez00_1469, BgL_locz00_1470);}  else 
{ /* Eval/evaluate_comp.scm 194 */
BgL_tagzd2187zd2_1472:
return 
BGl_bigloozd2typezd2errorz00zz__errorz00(BgL_fz00_17, BgL_mz00_18, BgL_vz00_19);} }  else 
{ /* Eval/evaluate_comp.scm 194 */
goto BgL_tagzd2187zd2_1472;} }  else 
{ /* Eval/evaluate_comp.scm 194 */
goto BgL_tagzd2187zd2_1472;} }  else 
{ /* Eval/evaluate_comp.scm 194 */
goto BgL_tagzd2187zd2_1472;} }  else 
{ /* Eval/evaluate_comp.scm 194 */
goto BgL_tagzd2187zd2_1472;} } } 

}



/* make-state */
obj_t BGl_makezd2statezd2zz__evaluate_compz00()
{
{ /* Eval/evaluate_comp.scm 206 */
{ /* Eval/evaluate_comp.scm 207 */
obj_t BgL_stkz00_1495;
BgL_stkz00_1495 = 
make_vector(((long)8192), BGl_string5212z00zz__evaluate_compz00); 
VECTOR_SET(BgL_stkz00_1495,((long)0),
BINT(((long)2))); 
return BgL_stkz00_1495;} } 

}



/* find-state */
BGL_EXPORTED_DEF obj_t BGl_findzd2statezd2zz__evaluate_compz00()
{
{ /* Eval/evaluate_comp.scm 211 */
{ /* Eval/evaluate_comp.scm 212 */
obj_t BgL_sz00_1496;
{ /* Eval/evaluate_comp.scm 212 */
obj_t BgL_tmpz00_15253;
BgL_tmpz00_15253 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_sz00_1496 = 
BGL_ENV_EVSTATE(BgL_tmpz00_15253); } 
if(
VECTORP(BgL_sz00_1496))
{ /* Eval/evaluate_comp.scm 213 */
return BgL_sz00_1496;}  else 
{ /* Eval/evaluate_comp.scm 214 */
obj_t BgL_statez00_1498;
BgL_statez00_1498 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 215 */
obj_t BgL_tmpz00_15259;
BgL_tmpz00_15259 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_tmpz00_15259, BgL_statez00_1498); } 
return BgL_statez00_1498;} } } 

}



/* &find-state */
obj_t BGl_z62findzd2statezb0zz__evaluate_compz00(obj_t BgL_envz00_10635)
{
{ /* Eval/evaluate_comp.scm 211 */
return 
BGl_findzd2statezd2zz__evaluate_compz00();} 

}



/* compile */
BGL_EXPORTED_DEF obj_t BGl_compilez00zz__evaluate_compz00(BgL_ev_exprz00_bglt BgL_ez00_34)
{
{ /* Eval/evaluate_comp.scm 273 */
return 
BGl_compz00zz__evaluate_compz00(BgL_ez00_34, BNIL);} 

}



/* &compile */
obj_t BGl_z62compilez62zz__evaluate_compz00(obj_t BgL_envz00_10636, obj_t BgL_ez00_10637)
{
{ /* Eval/evaluate_comp.scm 273 */
{ /* Eval/evaluate_comp.scm 274 */
BgL_ev_exprz00_bglt BgL_auxz00_15264;
if(
BGl_isazf3zf3zz__objectz00(BgL_ez00_10637, BGl_ev_exprz00zz__evaluate_typesz00))
{ /* Eval/evaluate_comp.scm 274 */
BgL_auxz00_15264 = 
((BgL_ev_exprz00_bglt)BgL_ez00_10637)
; }  else 
{ 
obj_t BgL_auxz00_15268;
BgL_auxz00_15268 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string5213z00zz__evaluate_compz00, 
BINT(((long)7006)), BGl_string5214z00zz__evaluate_compz00, BGl_string5215z00zz__evaluate_compz00, BgL_ez00_10637); 
FAILURE(BgL_auxz00_15268,BFALSE,BFALSE);} 
return 
BGl_compilez00zz__evaluate_compz00(BgL_auxz00_15264);} } 

}



/* global-fun-value */
obj_t BGl_globalzd2funzd2valuez00zz__evaluate_compz00(BgL_ev_exprz00_bglt BgL_ez00_43)
{
{ /* Eval/evaluate_comp.scm 332 */
if(
BGl_isazf3zf3zz__objectz00(
((obj_t)BgL_ez00_43), BGl_ev_globalz00zz__evaluate_typesz00))
{ /* Eval/evaluate_comp.scm 335 */
obj_t BgL_gz00_1554;
{ /* Eval/evaluate_comp.scm 335 */
obj_t BgL_arg1624z00_1555;obj_t BgL_arg1625z00_1556;
BgL_arg1624z00_1555 = 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_ez00_43)))->BgL_modz00); 
BgL_arg1625z00_1556 = 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_ez00_43)))->BgL_namez00); 
BgL_gz00_1554 = 
BGl_evmodulezd2findzd2globalz00zz__evmodulez00(BgL_arg1624z00_1555, BgL_arg1625z00_1556); } 
if(
CBOOL(BgL_gz00_1554))
{ /* Eval/evaluate_comp.scm 336 */
return 
VECTOR_REF(
((obj_t)BgL_gz00_1554),((long)2));}  else 
{ /* Eval/evaluate_comp.scm 336 */
return BFALSE;} }  else 
{ /* Eval/evaluate_comp.scm 333 */
return BFALSE;} } 

}



/* catch-goto-trampoline */
obj_t BGl_catchzd2gotozd2trampolinez00zz__evaluate_compz00(obj_t BgL_fz00_78, obj_t BgL_sz00_79)
{
{ /* Eval/evaluate_comp.scm 593 */
{ 
obj_t BgL_fz00_1566;
BgL_fz00_1566 = BgL_fz00_78; 
BgL_zc3z04anonymousza31634ze3z87_1567:
{ /* Eval/evaluate_comp.scm 597 */
obj_t BgL_rz00_1568;
BgL_rz00_1568 = 
PROCEDURE_ENTRY(BgL_fz00_1566)(BgL_fz00_1566, BgL_sz00_79, BEOA); 
{ /* Eval/evaluate_comp.scm 599 */
bool_t BgL_test5487z00_15289;
if(
PROCEDUREP(BgL_rz00_1568))
{ /* Eval/evaluate_comp.scm 599 */
obj_t BgL_arg1640z00_1573;
BgL_arg1640z00_1573 = 
PROCEDURE_ATTR(BgL_rz00_1568); 
if(
STRUCTP(BgL_arg1640z00_1573))
{ /* Eval/evaluate_comp.scm 569 */
BgL_test5487z00_15289 = 
(
STRUCT_KEY(BgL_arg1640z00_1573)==BGl_symbol5202z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 569 */
BgL_test5487z00_15289 = ((bool_t)0)
; } }  else 
{ /* Eval/evaluate_comp.scm 599 */
BgL_test5487z00_15289 = ((bool_t)0)
; } 
if(BgL_test5487z00_15289)
{ 
obj_t BgL_fz00_15297;
BgL_fz00_15297 = BgL_rz00_1568; 
BgL_fz00_1566 = BgL_fz00_15297; 
goto BgL_zc3z04anonymousza31634ze3z87_1567;}  else 
{ /* Eval/evaluate_comp.scm 599 */
return BgL_rz00_1568;} } } } } 

}



/* push-boxes-args-on-sp */
obj_t BGl_pushzd2boxeszd2argszd2onzd2spz00zz__evaluate_compz00(obj_t BgL_sz00_82, obj_t BgL_argsz00_83, obj_t BgL_boxesz00_84, long BgL_spz00_85, obj_t BgL_locz00_86)
{
{ /* Eval/evaluate_comp.scm 623 */
{ 
obj_t BgL_lz00_1576;obj_t BgL_bsz00_1577;long BgL_spz00_1578;
BgL_lz00_1576 = BgL_argsz00_83; 
BgL_bsz00_1577 = BgL_boxesz00_84; 
BgL_spz00_1578 = BgL_spz00_85; 
BgL_zc3z04anonymousza31641ze3z87_1579:
if(
NULLP(BgL_lz00_1576))
{ /* Eval/evaluate_comp.scm 625 */
if(
NULLP(BgL_bsz00_1577))
{ /* Eval/evaluate_comp.scm 626 */
return BFALSE;}  else 
{ /* Eval/evaluate_comp.scm 629 */
obj_t BgL_arg1644z00_1582;
{ /* Eval/evaluate_comp.scm 629 */
long BgL_arg1645z00_1583;long BgL_arg1646z00_1584;
BgL_arg1645z00_1583 = 
bgl_list_length(BgL_boxesz00_84); 
BgL_arg1646z00_1584 = 
bgl_list_length(BgL_argsz00_83); 
{ /* Eval/evaluate_comp.scm 628 */
obj_t BgL_list1647z00_1585;
{ /* Eval/evaluate_comp.scm 628 */
obj_t BgL_arg1648z00_1586;
BgL_arg1648z00_1586 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1646z00_1584), BNIL); 
BgL_list1647z00_1585 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1645z00_1583), BgL_arg1648z00_1586); } 
BgL_arg1644z00_1582 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string5216z00zz__evaluate_compz00, BgL_list1647z00_1585); } } 
return 
BGl_everrorz00zz__everrorz00(BgL_locz00_86, BGl_string5208z00zz__evaluate_compz00, BGl_string5217z00zz__evaluate_compz00, BgL_arg1644z00_1582);} }  else 
{ /* Eval/evaluate_comp.scm 625 */
if(
NULLP(BgL_bsz00_1577))
{ /* Eval/evaluate_comp.scm 633 */
obj_t BgL_arg1650z00_1588;
{ /* Eval/evaluate_comp.scm 633 */
long BgL_arg1652z00_1589;long BgL_arg1653z00_1590;
BgL_arg1652z00_1589 = 
bgl_list_length(BgL_boxesz00_84); 
BgL_arg1653z00_1590 = 
bgl_list_length(BgL_argsz00_83); 
{ /* Eval/evaluate_comp.scm 632 */
obj_t BgL_list1654z00_1591;
{ /* Eval/evaluate_comp.scm 632 */
obj_t BgL_arg1655z00_1592;
BgL_arg1655z00_1592 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1653z00_1590), BNIL); 
BgL_list1654z00_1591 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1652z00_1589), BgL_arg1655z00_1592); } 
BgL_arg1650z00_1588 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string5216z00zz__evaluate_compz00, BgL_list1654z00_1591); } } 
return 
BGl_everrorz00zz__everrorz00(BgL_locz00_86, BGl_string5208z00zz__evaluate_compz00, BGl_string5217z00zz__evaluate_compz00, BgL_arg1650z00_1588);}  else 
{ /* Eval/evaluate_comp.scm 630 */
{ /* Eval/evaluate_comp.scm 636 */
obj_t BgL_arg1656z00_1593;
{ /* Eval/evaluate_comp.scm 636 */
obj_t BgL_vz00_1594;
{ /* Eval/evaluate_comp.scm 636 */
obj_t BgL_fun1658z00_1596;
BgL_fun1658z00_1596 = 
CAR(
((obj_t)BgL_lz00_1576)); 
BgL_vz00_1594 = 
PROCEDURE_ENTRY(BgL_fun1658z00_1596)(BgL_fun1658z00_1596, BgL_sz00_82, BEOA); } 
if(
CBOOL(
CAR(
((obj_t)BgL_bsz00_1577))))
{ /* Eval/evaluate_comp.scm 202 */
obj_t BgL_newz00_6503;
BgL_newz00_6503 = 
create_struct(BGl_symbol5218z00zz__evaluate_compz00, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 202 */
int BgL_tmpz00_15332;
BgL_tmpz00_15332 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_6503, BgL_tmpz00_15332, BgL_vz00_1594); } 
BgL_arg1656z00_1593 = BgL_newz00_6503; }  else 
{ /* Eval/evaluate_comp.scm 637 */
BgL_arg1656z00_1593 = BgL_vz00_1594; } } 
VECTOR_SET(
((obj_t)BgL_sz00_82),BgL_spz00_1578,BgL_arg1656z00_1593); } 
{ /* Eval/evaluate_comp.scm 640 */
obj_t BgL_arg1659z00_1597;obj_t BgL_arg1660z00_1598;long BgL_arg1661z00_1599;
BgL_arg1659z00_1597 = 
CDR(
((obj_t)BgL_lz00_1576)); 
BgL_arg1660z00_1598 = 
CDR(
((obj_t)BgL_bsz00_1577)); 
BgL_arg1661z00_1599 = 
(BgL_spz00_1578+((long)1)); 
{ 
long BgL_spz00_15344;obj_t BgL_bsz00_15343;obj_t BgL_lz00_15342;
BgL_lz00_15342 = BgL_arg1659z00_1597; 
BgL_bsz00_15343 = BgL_arg1660z00_1598; 
BgL_spz00_15344 = BgL_arg1661z00_1599; 
BgL_spz00_1578 = BgL_spz00_15344; 
BgL_bsz00_1577 = BgL_bsz00_15343; 
BgL_lz00_1576 = BgL_lz00_15342; 
goto BgL_zc3z04anonymousza31641ze3z87_1579;} } } } } } 

}



/* sub-stk */
obj_t BGl_subzd2stkzd2zz__evaluate_compz00(obj_t BgL_l1z00_88, obj_t BgL_l2z00_89)
{
{ /* Eval/evaluate_comp.scm 645 */
BGl_subzd2stkzd2zz__evaluate_compz00:
if(
NULLP(BgL_l1z00_88))
{ /* Eval/evaluate_comp.scm 646 */
return BgL_l2z00_89;}  else 
{ /* Eval/evaluate_comp.scm 646 */
if(
(
CAR(
((obj_t)BgL_l1z00_88))==
CAR(
((obj_t)BgL_l2z00_89))))
{ /* Eval/evaluate_comp.scm 649 */
obj_t BgL_arg1666z00_1605;obj_t BgL_arg1667z00_1606;
BgL_arg1666z00_1605 = 
CDR(
((obj_t)BgL_l1z00_88)); 
BgL_arg1667z00_1606 = 
CDR(
((obj_t)BgL_l2z00_89)); 
{ 
obj_t BgL_l2z00_15358;obj_t BgL_l1z00_15357;
BgL_l1z00_15357 = BgL_arg1666z00_1605; 
BgL_l2z00_15358 = BgL_arg1667z00_1606; 
BgL_l2z00_89 = BgL_l2z00_15358; 
BgL_l1z00_88 = BgL_l1z00_15357; 
goto BGl_subzd2stkzd2zz__evaluate_compz00;} }  else 
{ /* Eval/evaluate_comp.scm 647 */
return 
BGl_errorz00zz__errorz00(BGl_string5208z00zz__evaluate_compz00, BGl_symbol5220z00zz__evaluate_compz00, BGl_symbol5222z00zz__evaluate_compz00);} } } 

}



/* catch-trampoline */
obj_t BGl_catchzd2trampolinezd2zz__evaluate_compz00(obj_t BgL_fz00_93, obj_t BgL_sz00_94, obj_t BgL_bpz00_95)
{
{ /* Eval/evaluate_comp.scm 669 */
{ /* Eval/evaluate_comp.scm 670 */
obj_t BgL_savedzd2bpzd2_1617;
BgL_savedzd2bpzd2_1617 = 
VECTOR_REF(
((obj_t)BgL_sz00_94),((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_94),((long)0),BgL_bpz00_95); 
{ 
obj_t BgL_fz00_1619;
BgL_fz00_1619 = BgL_fz00_93; 
BgL_zc3z04anonymousza31677ze3z87_1620:
{ /* Eval/evaluate_comp.scm 673 */
obj_t BgL_rz00_1621;
BgL_rz00_1621 = 
PROCEDURE_ENTRY(BgL_fz00_1619)(BgL_fz00_1619, BgL_sz00_94, BEOA); 
{ /* Eval/evaluate_comp.scm 674 */
bool_t BgL_test5496z00_15368;
if(
PROCEDUREP(BgL_rz00_1621))
{ /* Eval/evaluate_comp.scm 674 */
obj_t BgL_arg1681z00_1626;
BgL_arg1681z00_1626 = 
PROCEDURE_ATTR(BgL_rz00_1621); 
if(
STRUCTP(BgL_arg1681z00_1626))
{ /* Eval/evaluate_comp.scm 654 */
BgL_test5496z00_15368 = 
(
STRUCT_KEY(BgL_arg1681z00_1626)==BGl_symbol5204z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 654 */
BgL_test5496z00_15368 = ((bool_t)0)
; } }  else 
{ /* Eval/evaluate_comp.scm 674 */
BgL_test5496z00_15368 = ((bool_t)0)
; } 
if(BgL_test5496z00_15368)
{ 
obj_t BgL_fz00_15376;
BgL_fz00_15376 = BgL_rz00_1621; 
BgL_fz00_1619 = BgL_fz00_15376; 
goto BgL_zc3z04anonymousza31677ze3z87_1620;}  else 
{ /* Eval/evaluate_comp.scm 674 */
VECTOR_SET(
((obj_t)BgL_sz00_94),((long)0),BgL_savedzd2bpzd2_1617); 
return BgL_rz00_1621;} } } } } } 

}



/* check-stack */
bool_t BGl_checkzd2stackzd2zz__evaluate_compz00(obj_t BgL_sz00_114, obj_t BgL_bpz00_115, obj_t BgL_nz00_116)
{
{ /* Eval/evaluate_comp.scm 685 */
return 
(
(
(long)CINT(BgL_bpz00_115)+
(long)CINT(BgL_nz00_116))<
VECTOR_LENGTH(
((obj_t)BgL_sz00_114)));} 

}



/* comp-with-push */
obj_t BGl_compzd2withzd2pushz00zz__evaluate_compz00(obj_t BgL_eza2za2_117, obj_t BgL_stkz00_118)
{
{ /* Eval/evaluate_comp.scm 688 */
if(
NULLP(BgL_eza2za2_117))
{ /* Eval/evaluate_comp.scm 690 */
return BNIL;}  else 
{ /* Eval/evaluate_comp.scm 692 */
obj_t BgL_arg1692z00_1639;obj_t BgL_arg1693z00_1640;
{ /* Eval/evaluate_comp.scm 692 */
obj_t BgL_arg1694z00_1641;
BgL_arg1694z00_1641 = 
CAR(
((obj_t)BgL_eza2za2_117)); 
BgL_arg1692z00_1639 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_arg1694z00_1641), BgL_stkz00_118); } 
{ /* Eval/evaluate_comp.scm 693 */
obj_t BgL_arg1695z00_1642;obj_t BgL_arg1696z00_1643;
BgL_arg1695z00_1642 = 
CDR(
((obj_t)BgL_eza2za2_117)); 
{ /* Eval/evaluate_comp.scm 693 */
obj_t BgL_arg1697z00_1644;
BgL_arg1697z00_1644 = 
MAKE_YOUNG_PAIR(BFALSE, BNIL); 
BgL_arg1696z00_1643 = 
BGl_appendzd221010zd2zz__evaluate_compz00(BgL_stkz00_118, BgL_arg1697z00_1644); } 
BgL_arg1693z00_1640 = 
BGl_compzd2withzd2pushz00zz__evaluate_compz00(BgL_arg1695z00_1642, BgL_arg1696z00_1643); } 
return 
MAKE_YOUNG_PAIR(BgL_arg1692z00_1639, BgL_arg1693z00_1640);} } 

}



/* rec~0 */
obj_t BGl_recze70ze7zz__evaluate_compz00(obj_t BgL_stkz00_12609, obj_t BgL_lz00_1646, long BgL_iz00_1647)
{
{ /* Eval/evaluate_comp.scm 696 */
if(
NULLP(BgL_lz00_1646))
{ /* Eval/evaluate_comp.scm 697 */
return BNIL;}  else 
{ /* Eval/evaluate_comp.scm 697 */
if(
(BgL_iz00_1647==((long)0)))
{ /* Eval/evaluate_comp.scm 698 */
return 
BGl_compzd2withzd2pushz00zz__evaluate_compz00(BgL_lz00_1646, BgL_stkz00_12609);}  else 
{ /* Eval/evaluate_comp.scm 699 */
obj_t BgL_arg1701z00_1651;obj_t BgL_arg1702z00_1652;
{ /* Eval/evaluate_comp.scm 699 */
obj_t BgL_arg1703z00_1653;
BgL_arg1703z00_1653 = 
CAR(
((obj_t)BgL_lz00_1646)); 
BgL_arg1701z00_1651 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_arg1703z00_1653), BgL_stkz00_12609); } 
{ /* Eval/evaluate_comp.scm 700 */
obj_t BgL_arg1704z00_1654;long BgL_arg1705z00_1655;
BgL_arg1704z00_1654 = 
CDR(
((obj_t)BgL_lz00_1646)); 
BgL_arg1705z00_1655 = 
(BgL_iz00_1647-((long)1)); 
BgL_arg1702z00_1652 = 
BGl_recze70ze7zz__evaluate_compz00(BgL_stkz00_12609, BgL_arg1704z00_1654, BgL_arg1705z00_1655); } 
return 
MAKE_YOUNG_PAIR(BgL_arg1701z00_1651, BgL_arg1702z00_1652);} } } 

}



/* subr-call-with-push */
obj_t BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00(obj_t BgL_sz00_122, obj_t BgL_fz00_123, obj_t BgL_argsz00_124, obj_t BgL_bpz00_125, obj_t BgL_siza7eza7_126)
{
{ /* Eval/evaluate_comp.scm 702 */
{ /* Eval/evaluate_comp.scm 704 */
obj_t BgL_argsz00_1657;
if(
NULLP(BgL_argsz00_124))
{ /* Eval/evaluate_comp.scm 704 */
BgL_argsz00_1657 = BNIL; }  else 
{ /* Eval/evaluate_comp.scm 704 */
obj_t BgL_head1340z00_1662;
{ /* Eval/evaluate_comp.scm 704 */
obj_t BgL_res4034z00_6568;
BgL_res4034z00_6568 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1340z00_1662 = BgL_res4034z00_6568; } 
{ 
obj_t BgL_l1338z00_1664;obj_t BgL_tail1341z00_1665;
BgL_l1338z00_1664 = BgL_argsz00_124; 
BgL_tail1341z00_1665 = BgL_head1340z00_1662; 
BgL_zc3z04anonymousza31708ze3z87_1666:
if(
NULLP(BgL_l1338z00_1664))
{ /* Eval/evaluate_comp.scm 704 */
BgL_argsz00_1657 = 
CDR(BgL_head1340z00_1662); }  else 
{ /* Eval/evaluate_comp.scm 704 */
obj_t BgL_newtail1342z00_1668;
{ /* Eval/evaluate_comp.scm 704 */
obj_t BgL_arg1711z00_1670;
{ /* Eval/evaluate_comp.scm 704 */
obj_t BgL_az00_1671;
BgL_az00_1671 = 
CAR(
((obj_t)BgL_l1338z00_1664)); 
BgL_arg1711z00_1670 = 
PROCEDURE_ENTRY(BgL_az00_1671)(BgL_az00_1671, BgL_sz00_122, BEOA); } 
{ /* Eval/evaluate_comp.scm 704 */
obj_t BgL_res4036z00_6572;
BgL_res4036z00_6572 = 
MAKE_YOUNG_PAIR(BgL_arg1711z00_1670, BNIL); 
BgL_newtail1342z00_1668 = BgL_res4036z00_6572; } } 
SET_CDR(BgL_tail1341z00_1665, BgL_newtail1342z00_1668); 
{ /* Eval/evaluate_comp.scm 704 */
obj_t BgL_arg1710z00_1669;
BgL_arg1710z00_1669 = 
CDR(
((obj_t)BgL_l1338z00_1664)); 
{ 
obj_t BgL_tail1341z00_15428;obj_t BgL_l1338z00_15427;
BgL_l1338z00_15427 = BgL_arg1710z00_1669; 
BgL_tail1341z00_15428 = BgL_newtail1342z00_1668; 
BgL_tail1341z00_1665 = BgL_tail1341z00_15428; 
BgL_l1338z00_1664 = BgL_l1338z00_15427; 
goto BgL_zc3z04anonymousza31708ze3z87_1666;} } } } } 
{ /* Eval/evaluate_comp.scm 705 */
long BgL_arg1706z00_1658;
BgL_arg1706z00_1658 = 
(
(long)CINT(BgL_bpz00_125)+
(long)CINT(BgL_siza7eza7_126)); 
VECTOR_SET(
((obj_t)BgL_sz00_122),((long)0),
BINT(BgL_arg1706z00_1658)); } 
{ /* Eval/evaluate_comp.scm 706 */
obj_t BgL_za2za2resza2za2z00_1659;
BgL_za2za2resza2za2z00_1659 = 
apply(BgL_fz00_123, BgL_argsz00_1657); 
VECTOR_SET(
((obj_t)BgL_sz00_122),((long)0),BgL_bpz00_125); 
return BgL_za2za2resza2za2z00_1659;} } } 

}



/* push-args-on-sp */
bool_t BGl_pushzd2argszd2onzd2spzd2zz__evaluate_compz00(obj_t BgL_sz00_127, obj_t BgL_argsz00_128, obj_t BgL_spz00_129)
{
{ /* Eval/evaluate_comp.scm 709 */
{ 
obj_t BgL_lz00_1674;obj_t BgL_spz00_1675;
BgL_lz00_1674 = BgL_argsz00_128; 
BgL_spz00_1675 = BgL_spz00_129; 
BgL_zc3z04anonymousza31712ze3z87_1676:
if(
NULLP(BgL_lz00_1674))
{ /* Eval/evaluate_comp.scm 711 */
return ((bool_t)0);}  else 
{ /* Eval/evaluate_comp.scm 711 */
{ /* Eval/evaluate_comp.scm 712 */
obj_t BgL_arg1714z00_1678;
{ /* Eval/evaluate_comp.scm 712 */
obj_t BgL_fun1715z00_1679;
BgL_fun1715z00_1679 = 
CAR(
((obj_t)BgL_lz00_1674)); 
BgL_arg1714z00_1678 = 
PROCEDURE_ENTRY(BgL_fun1715z00_1679)(BgL_fun1715z00_1679, BgL_sz00_127, BEOA); } 
{ /* Eval/evaluate_comp.scm 712 */
long BgL_kz00_6583;
BgL_kz00_6583 = 
(long)CINT(BgL_spz00_1675); 
VECTOR_SET(
((obj_t)BgL_sz00_127),BgL_kz00_6583,BgL_arg1714z00_1678); } } 
{ /* Eval/evaluate_comp.scm 713 */
obj_t BgL_arg1716z00_1680;long BgL_arg1717z00_1681;
BgL_arg1716z00_1680 = 
CDR(
((obj_t)BgL_lz00_1674)); 
BgL_arg1717z00_1681 = 
(
(long)CINT(BgL_spz00_1675)+((long)1)); 
{ 
obj_t BgL_spz00_15455;obj_t BgL_lz00_15454;
BgL_lz00_15454 = BgL_arg1716z00_1680; 
BgL_spz00_15455 = 
BINT(BgL_arg1717z00_1681); 
BgL_spz00_1675 = BgL_spz00_15455; 
BgL_lz00_1674 = BgL_lz00_15454; 
goto BgL_zc3z04anonymousza31712ze3z87_1676;} } } } } 

}



/* push-nargs-on-sp */
obj_t BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00(obj_t BgL_arityz00_130, obj_t BgL_sz00_131, obj_t BgL_argsz00_132, obj_t BgL_spz00_133)
{
{ /* Eval/evaluate_comp.scm 715 */
{ /* Eval/evaluate_comp.scm 716 */
long BgL_g1146z00_1683;
BgL_g1146z00_1683 = 
(((long)-1)-
(long)CINT(BgL_arityz00_130)); 
{ 
obj_t BgL_lz00_1685;obj_t BgL_spz00_1686;long BgL_nz00_1687;
BgL_lz00_1685 = BgL_argsz00_132; 
BgL_spz00_1686 = BgL_spz00_133; 
BgL_nz00_1687 = BgL_g1146z00_1683; 
BgL_zc3z04anonymousza31718ze3z87_1688:
if(
(BgL_nz00_1687==((long)0)))
{ 
obj_t BgL_lz00_1692;obj_t BgL_rz00_1693;
BgL_lz00_1692 = BgL_lz00_1685; 
BgL_rz00_1693 = BNIL; 
BgL_zc3z04anonymousza31720ze3z87_1694:
if(
NULLP(BgL_lz00_1692))
{ /* Eval/evaluate_comp.scm 720 */
obj_t BgL_arg1722z00_1696;
BgL_arg1722z00_1696 = 
bgl_reverse_bang(BgL_rz00_1693); 
{ /* Eval/evaluate_comp.scm 720 */
long BgL_kz00_6593;
BgL_kz00_6593 = 
(long)CINT(BgL_spz00_1686); 
return 
VECTOR_SET(
((obj_t)BgL_sz00_131),BgL_kz00_6593,BgL_arg1722z00_1696);} }  else 
{ /* Eval/evaluate_comp.scm 721 */
obj_t BgL_arg1723z00_1697;obj_t BgL_arg1724z00_1698;
BgL_arg1723z00_1697 = 
CDR(
((obj_t)BgL_lz00_1692)); 
{ /* Eval/evaluate_comp.scm 721 */
obj_t BgL_arg1725z00_1699;
{ /* Eval/evaluate_comp.scm 721 */
obj_t BgL_fun1726z00_1700;
BgL_fun1726z00_1700 = 
CAR(
((obj_t)BgL_lz00_1692)); 
BgL_arg1725z00_1699 = 
PROCEDURE_ENTRY(BgL_fun1726z00_1700)(BgL_fun1726z00_1700, BgL_sz00_131, BEOA); } 
BgL_arg1724z00_1698 = 
MAKE_YOUNG_PAIR(BgL_arg1725z00_1699, BgL_rz00_1693); } 
{ 
obj_t BgL_rz00_15477;obj_t BgL_lz00_15476;
BgL_lz00_15476 = BgL_arg1723z00_1697; 
BgL_rz00_15477 = BgL_arg1724z00_1698; 
BgL_rz00_1693 = BgL_rz00_15477; 
BgL_lz00_1692 = BgL_lz00_15476; 
goto BgL_zc3z04anonymousza31720ze3z87_1694;} } }  else 
{ /* Eval/evaluate_comp.scm 717 */
{ /* Eval/evaluate_comp.scm 722 */
obj_t BgL_arg1727z00_1702;
{ /* Eval/evaluate_comp.scm 722 */
obj_t BgL_fun1728z00_1703;
BgL_fun1728z00_1703 = 
CAR(
((obj_t)BgL_lz00_1685)); 
BgL_arg1727z00_1702 = 
PROCEDURE_ENTRY(BgL_fun1728z00_1703)(BgL_fun1728z00_1703, BgL_sz00_131, BEOA); } 
{ /* Eval/evaluate_comp.scm 722 */
long BgL_kz00_6598;
BgL_kz00_6598 = 
(long)CINT(BgL_spz00_1686); 
VECTOR_SET(
((obj_t)BgL_sz00_131),BgL_kz00_6598,BgL_arg1727z00_1702); } } 
{ /* Eval/evaluate_comp.scm 723 */
obj_t BgL_arg1729z00_1704;long BgL_arg1730z00_1705;long BgL_arg1731z00_1706;
BgL_arg1729z00_1704 = 
CDR(
((obj_t)BgL_lz00_1685)); 
BgL_arg1730z00_1705 = 
(
(long)CINT(BgL_spz00_1686)+((long)1)); 
BgL_arg1731z00_1706 = 
(BgL_nz00_1687-((long)1)); 
{ 
long BgL_nz00_15495;obj_t BgL_spz00_15493;obj_t BgL_lz00_15492;
BgL_lz00_15492 = BgL_arg1729z00_1704; 
BgL_spz00_15493 = 
BINT(BgL_arg1730z00_1705); 
BgL_nz00_15495 = BgL_arg1731z00_1706; 
BgL_nz00_1687 = BgL_nz00_15495; 
BgL_spz00_1686 = BgL_spz00_15493; 
BgL_lz00_1685 = BgL_lz00_15492; 
goto BgL_zc3z04anonymousza31718ze3z87_1688;} } } } } } 

}



/* need-shift */
bool_t BGl_needzd2shiftzd2zz__evaluate_compz00(obj_t BgL_argsz00_134, obj_t BgL_stkz00_135)
{
{ /* Eval/evaluate_comp.scm 766 */
{ 
obj_t BgL_lz00_1709;obj_t BgL_stkz00_1710;
BgL_lz00_1709 = BgL_argsz00_134; 
BgL_stkz00_1710 = BgL_stkz00_135; 
BgL_zc3z04anonymousza31732ze3z87_1711:
{ /* Eval/evaluate_comp.scm 770 */
bool_t BgL_test5507z00_15496;
if(
NULLP(BgL_lz00_1709))
{ /* Eval/evaluate_comp.scm 770 */
BgL_test5507z00_15496 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate_comp.scm 770 */
BgL_test5507z00_15496 = 
NULLP(BgL_stkz00_1710)
; } 
if(BgL_test5507z00_15496)
{ /* Eval/evaluate_comp.scm 770 */
return ((bool_t)0);}  else 
{ /* Eval/evaluate_comp.scm 772 */
bool_t BgL_test5509z00_15500;
{ /* Eval/evaluate_comp.scm 772 */
obj_t BgL_g1345z00_1728;
BgL_g1345z00_1728 = 
CDR(
((obj_t)BgL_lz00_1709)); 
{ 
obj_t BgL_l1343z00_1730;
{ /* Eval/evaluate_comp.scm 772 */
obj_t BgL_tmpz00_15503;
BgL_l1343z00_1730 = BgL_g1345z00_1728; 
BgL_zc3z04anonymousza31743ze3z87_1731:
if(
NULLP(BgL_l1343z00_1730))
{ /* Eval/evaluate_comp.scm 772 */
BgL_tmpz00_15503 = BFALSE
; }  else 
{ /* Eval/evaluate_comp.scm 772 */
obj_t BgL__ortest_1346z00_1733;
{ /* Eval/evaluate_comp.scm 772 */
obj_t BgL_ez00_1735;
BgL_ez00_1735 = 
CAR(
((obj_t)BgL_l1343z00_1730)); 
{ /* Eval/evaluate_comp.scm 772 */
obj_t BgL_arg1745z00_1736;obj_t BgL_arg1746z00_1737;
BgL_arg1745z00_1736 = 
CAR(
((obj_t)BgL_stkz00_1710)); 
BgL_arg1746z00_1737 = 
BGl_usez00zz__evaluate_usez00(
((BgL_ev_exprz00_bglt)BgL_ez00_1735), BNIL); 
BgL__ortest_1346z00_1733 = 
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg1745z00_1736, BgL_arg1746z00_1737); } } 
if(
CBOOL(BgL__ortest_1346z00_1733))
{ /* Eval/evaluate_comp.scm 772 */
BgL_tmpz00_15503 = BgL__ortest_1346z00_1733
; }  else 
{ /* Eval/evaluate_comp.scm 772 */
obj_t BgL_arg1744z00_1734;
BgL_arg1744z00_1734 = 
CDR(
((obj_t)BgL_l1343z00_1730)); 
{ 
obj_t BgL_l1343z00_15517;
BgL_l1343z00_15517 = BgL_arg1744z00_1734; 
BgL_l1343z00_1730 = BgL_l1343z00_15517; 
goto BgL_zc3z04anonymousza31743ze3z87_1731;} } } 
BgL_test5509z00_15500 = 
CBOOL(BgL_tmpz00_15503); } } } 
if(BgL_test5509z00_15500)
{ /* Eval/evaluate_comp.scm 772 */
return ((bool_t)1);}  else 
{ /* Eval/evaluate_comp.scm 774 */
obj_t BgL_arg1741z00_1726;obj_t BgL_arg1742z00_1727;
BgL_arg1741z00_1726 = 
CDR(
((obj_t)BgL_lz00_1709)); 
BgL_arg1742z00_1727 = 
CDR(
((obj_t)BgL_stkz00_1710)); 
{ 
obj_t BgL_stkz00_15524;obj_t BgL_lz00_15523;
BgL_lz00_15523 = BgL_arg1741z00_1726; 
BgL_stkz00_15524 = BgL_arg1742z00_1727; 
BgL_stkz00_1710 = BgL_stkz00_15524; 
BgL_lz00_1709 = BgL_lz00_15523; 
goto BgL_zc3z04anonymousza31732ze3z87_1711;} } } } } } 

}



/* comp-old-call */
obj_t BGl_compzd2oldzd2callz00zz__evaluate_compz00(BgL_ev_appz00_bglt BgL_ez00_136, obj_t BgL_stkz00_137)
{
{ /* Eval/evaluate_comp.scm 776 */
{ /* Eval/evaluate_comp.scm 778 */
long BgL_siza7eza7_1742;long BgL_nbargsz00_1743;obj_t BgL_fz00_1744;obj_t BgL_symbzd2funzd2_1745;
BgL_siza7eza7_1742 = 
bgl_list_length(BgL_stkz00_137); 
BgL_nbargsz00_1743 = 
bgl_list_length(
(((BgL_ev_appz00_bglt)COBJECT(BgL_ez00_136))->BgL_argsz00)); 
BgL_fz00_1744 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_ez00_136))->BgL_funz00), BgL_stkz00_137); 
BgL_symbzd2funzd2_1745 = 
BGl_uncompilez00zz__evaluate_uncompz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_ez00_136))->BgL_funz00)); 
if(
CBOOL(
(((BgL_ev_appz00_bglt)COBJECT(BgL_ez00_136))->BgL_tailzf3zf3)))
{ /* Eval/evaluate_comp.scm 780 */
if(
BGl_needzd2shiftzd2zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_ez00_136))->BgL_argsz00), BgL_stkz00_137))
{ /* Eval/evaluate_comp.scm 787 */
bool_t BgL_test5514z00_15538;
{ /* Eval/evaluate_comp.scm 787 */
int BgL_arg1795z00_1824;
BgL_arg1795z00_1824 = 
bgl_debug(); 
BgL_test5514z00_15538 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg1795z00_1824), 
BINT(((long)0))); } 
if(BgL_test5514z00_15538)
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_argsz00_1751;
BgL_argsz00_1751 = 
BGl_compzd2withzd2pushz00zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_ez00_136))->BgL_argsz00), BgL_stkz00_137); 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_zc3z04anonymousza31752ze3z87_10638;
BgL_zc3z04anonymousza31752ze3z87_10638 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31752ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31752ze3z87_10638, 
(int)(((long)0)), BgL_fz00_1744); 
PROCEDURE_SET(BgL_zc3z04anonymousza31752ze3z87_10638, 
(int)(((long)1)), 
((obj_t)BgL_ez00_136)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31752ze3z87_10638, 
(int)(((long)2)), BgL_symbzd2funzd2_1745); 
PROCEDURE_SET(BgL_zc3z04anonymousza31752ze3z87_10638, 
(int)(((long)3)), 
BINT(BgL_nbargsz00_1743)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31752ze3z87_10638, 
(int)(((long)4)), BgL_argsz00_1751); 
PROCEDURE_SET(BgL_zc3z04anonymousza31752ze3z87_10638, 
(int)(((long)5)), 
BINT(BgL_siza7eza7_1742)); 
return BgL_zc3z04anonymousza31752ze3z87_10638;} }  else 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_argsz00_1789;
BgL_argsz00_1789 = 
BGl_compzd2withzd2pushz00zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_ez00_136))->BgL_argsz00), BgL_stkz00_137); 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_zc3z04anonymousza31775ze3z87_10639;
BgL_zc3z04anonymousza31775ze3z87_10639 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31775ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31775ze3z87_10639, 
(int)(((long)0)), BgL_fz00_1744); 
PROCEDURE_SET(BgL_zc3z04anonymousza31775ze3z87_10639, 
(int)(((long)1)), 
((obj_t)BgL_ez00_136)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31775ze3z87_10639, 
(int)(((long)2)), BgL_symbzd2funzd2_1745); 
PROCEDURE_SET(BgL_zc3z04anonymousza31775ze3z87_10639, 
(int)(((long)3)), 
BINT(BgL_nbargsz00_1743)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31775ze3z87_10639, 
(int)(((long)4)), BgL_argsz00_1789); 
PROCEDURE_SET(BgL_zc3z04anonymousza31775ze3z87_10639, 
(int)(((long)5)), 
BINT(BgL_siza7eza7_1742)); 
return BgL_zc3z04anonymousza31775ze3z87_10639;} } }  else 
{ /* Eval/evaluate_comp.scm 795 */
bool_t BgL_test5515z00_15583;
{ /* Eval/evaluate_comp.scm 795 */
int BgL_arg1835z00_1894;
BgL_arg1835z00_1894 = 
bgl_debug(); 
BgL_test5515z00_15583 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg1835z00_1894), 
BINT(((long)0))); } 
if(BgL_test5515z00_15583)
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_argsz00_1827;
BgL_argsz00_1827 = 
BGl_recze70ze7zz__evaluate_compz00(BgL_stkz00_137, 
(((BgL_ev_appz00_bglt)COBJECT(BgL_ez00_136))->BgL_argsz00), BgL_siza7eza7_1742); 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_zc3z04anonymousza31798ze3z87_10640;
BgL_zc3z04anonymousza31798ze3z87_10640 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31798ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31798ze3z87_10640, 
(int)(((long)0)), BgL_fz00_1744); 
PROCEDURE_SET(BgL_zc3z04anonymousza31798ze3z87_10640, 
(int)(((long)1)), 
((obj_t)BgL_ez00_136)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31798ze3z87_10640, 
(int)(((long)2)), BgL_symbzd2funzd2_1745); 
PROCEDURE_SET(BgL_zc3z04anonymousza31798ze3z87_10640, 
(int)(((long)3)), 
BINT(BgL_nbargsz00_1743)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31798ze3z87_10640, 
(int)(((long)4)), BgL_argsz00_1827); 
return BgL_zc3z04anonymousza31798ze3z87_10640;} }  else 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_argsz00_1862;
BgL_argsz00_1862 = 
BGl_recze70ze7zz__evaluate_compz00(BgL_stkz00_137, 
(((BgL_ev_appz00_bglt)COBJECT(BgL_ez00_136))->BgL_argsz00), BgL_siza7eza7_1742); 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_zc3z04anonymousza31818ze3z87_10641;
BgL_zc3z04anonymousza31818ze3z87_10641 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31818ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31818ze3z87_10641, 
(int)(((long)0)), BgL_fz00_1744); 
PROCEDURE_SET(BgL_zc3z04anonymousza31818ze3z87_10641, 
(int)(((long)1)), 
((obj_t)BgL_ez00_136)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31818ze3z87_10641, 
(int)(((long)2)), BgL_symbzd2funzd2_1745); 
PROCEDURE_SET(BgL_zc3z04anonymousza31818ze3z87_10641, 
(int)(((long)3)), 
BINT(BgL_nbargsz00_1743)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31818ze3z87_10641, 
(int)(((long)4)), BgL_argsz00_1862); 
return BgL_zc3z04anonymousza31818ze3z87_10641;} } } }  else 
{ /* Eval/evaluate_comp.scm 781 */
bool_t BgL_test5516z00_15622;
{ /* Eval/evaluate_comp.scm 781 */
int BgL_arg1876z00_1965;
BgL_arg1876z00_1965 = 
bgl_debug(); 
BgL_test5516z00_15622 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg1876z00_1965), 
BINT(((long)0))); } 
if(BgL_test5516z00_15622)
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_argsz00_1898;
BgL_argsz00_1898 = 
BGl_compzd2withzd2pushz00zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_ez00_136))->BgL_argsz00), BgL_stkz00_137); 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_zc3z04anonymousza31839ze3z87_10642;
BgL_zc3z04anonymousza31839ze3z87_10642 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31839ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31839ze3z87_10642, 
(int)(((long)0)), BgL_fz00_1744); 
PROCEDURE_SET(BgL_zc3z04anonymousza31839ze3z87_10642, 
(int)(((long)1)), 
((obj_t)BgL_ez00_136)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31839ze3z87_10642, 
(int)(((long)2)), BgL_symbzd2funzd2_1745); 
PROCEDURE_SET(BgL_zc3z04anonymousza31839ze3z87_10642, 
(int)(((long)3)), 
BINT(BgL_nbargsz00_1743)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31839ze3z87_10642, 
(int)(((long)4)), BgL_argsz00_1898); 
PROCEDURE_SET(BgL_zc3z04anonymousza31839ze3z87_10642, 
(int)(((long)5)), 
BINT(BgL_siza7eza7_1742)); 
return BgL_zc3z04anonymousza31839ze3z87_10642;} }  else 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_argsz00_1933;
BgL_argsz00_1933 = 
BGl_compzd2withzd2pushz00zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_ez00_136))->BgL_argsz00), BgL_stkz00_137); 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_zc3z04anonymousza31859ze3z87_10643;
BgL_zc3z04anonymousza31859ze3z87_10643 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31859ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31859ze3z87_10643, 
(int)(((long)0)), BgL_fz00_1744); 
PROCEDURE_SET(BgL_zc3z04anonymousza31859ze3z87_10643, 
(int)(((long)1)), 
((obj_t)BgL_ez00_136)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31859ze3z87_10643, 
(int)(((long)2)), BgL_symbzd2funzd2_1745); 
PROCEDURE_SET(BgL_zc3z04anonymousza31859ze3z87_10643, 
(int)(((long)3)), 
BINT(BgL_nbargsz00_1743)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31859ze3z87_10643, 
(int)(((long)4)), BgL_argsz00_1933); 
PROCEDURE_SET(BgL_zc3z04anonymousza31859ze3z87_10643, 
(int)(((long)5)), 
BINT(BgL_siza7eza7_1742)); 
return BgL_zc3z04anonymousza31859ze3z87_10643;} } } } } 

}



/* &<@anonymous:1752> */
obj_t BGl_z62zc3z04anonymousza31752ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10644, obj_t BgL_sz00_10651)
{
{ /* Eval/evaluate_comp.scm 787 */
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_fz00_10645;BgL_ev_appz00_bglt BgL_i1154z00_10646;obj_t BgL_symbzd2funzd2_10647;long BgL_nbargsz00_10648;obj_t BgL_argsz00_10649;long BgL_siza7eza7_10650;
BgL_fz00_10645 = 
PROCEDURE_REF(BgL_envz00_10644, 
(int)(((long)0))); 
BgL_i1154z00_10646 = 
((BgL_ev_appz00_bglt)
PROCEDURE_REF(BgL_envz00_10644, 
(int)(((long)1)))); 
BgL_symbzd2funzd2_10647 = 
PROCEDURE_REF(BgL_envz00_10644, 
(int)(((long)2))); 
BgL_nbargsz00_10648 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10644, 
(int)(((long)3)))); 
BgL_argsz00_10649 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10644, 
(int)(((long)4)))); 
BgL_siza7eza7_10650 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10644, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_bpz00_12630;
BgL_bpz00_12630 = 
VECTOR_REF(
((obj_t)BgL_sz00_10651),((long)0)); 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_fz00_12631;
BgL_fz00_12631 = 
PROCEDURE_ENTRY(BgL_fz00_10645)(BgL_fz00_10645, BgL_sz00_10651, BEOA); 
if(
PROCEDUREP(BgL_fz00_12631))
{ /* Eval/evaluate_comp.scm 787 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 787 */
BGl_evtypezd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1154z00_10646))->BgL_locz00), BGl_string5208z00zz__evaluate_compz00, BGl_string5224z00zz__evaluate_compz00, BgL_fz00_12631); } 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_ufz00_12632;
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_tmpz00_15693;
BgL_tmpz00_15693 = 
((obj_t)BgL_fz00_12631); 
BgL_ufz00_12632 = 
PROCEDURE_ATTR(BgL_tmpz00_15693); } 
{ /* Eval/evaluate_comp.scm 787 */
bool_t BgL_test5518z00_15696;
if(
STRUCTP(BgL_ufz00_12632))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5518z00_15696 = 
(
STRUCT_KEY(BgL_ufz00_12632)==BGl_symbol5225z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5518z00_15696 = ((bool_t)0)
; } 
if(BgL_test5518z00_15696)
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_arityz00_12633;obj_t BgL_runz00_12634;obj_t BgL_sfz00_12635;
BgL_arityz00_12633 = 
STRUCT_REF(BgL_ufz00_12632, 
(int)(((long)0))); 
BgL_runz00_12634 = 
STRUCT_REF(BgL_ufz00_12632, 
(int)(((long)1))); 
BgL_sfz00_12635 = 
STRUCT_REF(BgL_ufz00_12632, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 787 */
long BgL_spz00_12636;
BgL_spz00_12636 = 
(
(long)CINT(BgL_bpz00_12630)+BgL_siza7eza7_10650); 
if(
(
(long)CINT(BgL_arityz00_12633)==BgL_nbargsz00_10648))
{ /* Eval/evaluate_comp.scm 787 */
BGl_pushzd2argszd2onzd2spzd2zz__evaluate_compz00(BgL_sz00_10651, BgL_argsz00_10649, 
BINT(BgL_spz00_12636)); 
{ /* Eval/evaluate_comp.scm 791 */
long BgL_arg1757z00_12637;
BgL_arg1757z00_12637 = 
(BgL_spz00_12636+BgL_nbargsz00_10648); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_sz00_10651, 
(long)CINT(BgL_bpz00_12630), BgL_sz00_10651, 
BINT(BgL_spz00_12636), 
BINT(BgL_arg1757z00_12637)); } }  else 
{ /* Eval/evaluate_comp.scm 787 */
bool_t BgL_test5521z00_15719;
if(
(
(long)CINT(BgL_arityz00_12633)>=((long)0)))
{ /* Eval/evaluate_comp.scm 787 */
BgL_test5521z00_15719 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate_comp.scm 787 */
BgL_test5521z00_15719 = 
(
(long)CINT(BgL_arityz00_12633)<
(((long)-1)-BgL_nbargsz00_10648))
; } 
if(BgL_test5521z00_15719)
{ /* Eval/evaluate_comp.scm 787 */
BGl_evarityzd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1154z00_10646))->BgL_locz00), 
STRUCT_REF(BgL_ufz00_12632, 
(int)(((long)3))), 
(int)(BgL_nbargsz00_10648), 
CINT(BgL_arityz00_12633)); }  else 
{ /* Eval/evaluate_comp.scm 787 */
BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00(BgL_arityz00_12633, BgL_sz00_10651, BgL_argsz00_10649, 
BINT(BgL_spz00_12636)); 
{ /* Eval/evaluate_comp.scm 793 */
long BgL_arg1763z00_12638;
BgL_arg1763z00_12638 = 
(BgL_spz00_12636+
(((long)0)-
(long)CINT(BgL_arityz00_12633))); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_sz00_10651, 
(long)CINT(BgL_bpz00_12630), BgL_sz00_10651, 
BINT(BgL_spz00_12636), 
BINT(BgL_arg1763z00_12638)); } } } 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_z12denvz12_12639;
BgL_z12denvz12_12639 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_tmpz00_15742;
BgL_tmpz00_15742 = 
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1154z00_10646))->BgL_locz00); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_12639, BgL_tmpz00_15742); } 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10651, BgL_bpz00_12630, BgL_sfz00_12635))
{ /* Eval/evaluate_comp.scm 787 */
return BgL_runz00_12634;}  else 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_nsz00_12640;
BgL_nsz00_12640 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 787 */
long BgL_arg1768z00_12641;
BgL_arg1768z00_12641 = 
(
(long)CINT(BgL_bpz00_12630)+BgL_nbargsz00_10648); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12640, ((long)2), BgL_sz00_10651, BgL_bpz00_12630, 
BINT(BgL_arg1768z00_12641)); } 
VECTOR_SET(BgL_nsz00_12640,((long)1),BgL_sz00_10651); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12639, BgL_nsz00_12640); 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_ez00_12642;
BgL_ez00_12642 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12642, BgL_sz00_10651); 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_____rz00_12643;
BgL_____rz00_12643 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12634, BgL_nsz00_12640, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12642); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12639, BgL_sz00_10651); 
return BgL_____rz00_12643;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 787 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12631, 
(int)(BgL_nbargsz00_10648)))
{ /* Eval/evaluate_comp.scm 787 */
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_auxz00_15765;obj_t BgL_tmpz00_15763;
BgL_auxz00_15765 = 
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1154z00_10646))->BgL_locz00); 
BgL_tmpz00_15763 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_15763, BgL_auxz00_15765); } 
return 
BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00(BgL_sz00_10651, BgL_fz00_12631, BgL_argsz00_10649, BgL_bpz00_12630, 
BINT(BgL_siza7eza7_10650));}  else 
{ /* Eval/evaluate_comp.scm 787 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1154z00_10646))->BgL_locz00), BgL_symbzd2funzd2_10647, 
(int)(BgL_nbargsz00_10648), 
PROCEDURE_ARITY(BgL_fz00_12631));} } } } } } } } 

}



/* &<@anonymous:1775> */
obj_t BGl_z62zc3z04anonymousza31775ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10652, obj_t BgL_sz00_10659)
{
{ /* Eval/evaluate_comp.scm 787 */
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_fz00_10653;BgL_ev_appz00_bglt BgL_i1154z00_10654;obj_t BgL_symbzd2funzd2_10655;long BgL_nbargsz00_10656;obj_t BgL_argsz00_10657;long BgL_siza7eza7_10658;
BgL_fz00_10653 = 
PROCEDURE_REF(BgL_envz00_10652, 
(int)(((long)0))); 
BgL_i1154z00_10654 = 
((BgL_ev_appz00_bglt)
PROCEDURE_REF(BgL_envz00_10652, 
(int)(((long)1)))); 
BgL_symbzd2funzd2_10655 = 
PROCEDURE_REF(BgL_envz00_10652, 
(int)(((long)2))); 
BgL_nbargsz00_10656 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10652, 
(int)(((long)3)))); 
BgL_argsz00_10657 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10652, 
(int)(((long)4)))); 
BgL_siza7eza7_10658 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10652, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_bpz00_12644;
BgL_bpz00_12644 = 
VECTOR_REF(
((obj_t)BgL_sz00_10659),((long)0)); 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_fz00_12645;
BgL_fz00_12645 = 
PROCEDURE_ENTRY(BgL_fz00_10653)(BgL_fz00_10653, BgL_sz00_10659, BEOA); 
if(
PROCEDUREP(BgL_fz00_12645))
{ /* Eval/evaluate_comp.scm 787 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 787 */
BGl_evtypezd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1154z00_10654))->BgL_locz00), BGl_string5208z00zz__evaluate_compz00, BGl_string5224z00zz__evaluate_compz00, BgL_fz00_12645); } 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_ufz00_12646;
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_tmpz00_15800;
BgL_tmpz00_15800 = 
((obj_t)BgL_fz00_12645); 
BgL_ufz00_12646 = 
PROCEDURE_ATTR(BgL_tmpz00_15800); } 
{ /* Eval/evaluate_comp.scm 787 */
bool_t BgL_test5526z00_15803;
if(
STRUCTP(BgL_ufz00_12646))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5526z00_15803 = 
(
STRUCT_KEY(BgL_ufz00_12646)==BGl_symbol5225z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5526z00_15803 = ((bool_t)0)
; } 
if(BgL_test5526z00_15803)
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_arityz00_12647;obj_t BgL_runz00_12648;obj_t BgL_sfz00_12649;
BgL_arityz00_12647 = 
STRUCT_REF(BgL_ufz00_12646, 
(int)(((long)0))); 
BgL_runz00_12648 = 
STRUCT_REF(BgL_ufz00_12646, 
(int)(((long)1))); 
BgL_sfz00_12649 = 
STRUCT_REF(BgL_ufz00_12646, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 787 */
long BgL_spz00_12650;
BgL_spz00_12650 = 
(
(long)CINT(BgL_bpz00_12644)+BgL_siza7eza7_10658); 
if(
(
(long)CINT(BgL_arityz00_12647)==BgL_nbargsz00_10656))
{ /* Eval/evaluate_comp.scm 787 */
BGl_pushzd2argszd2onzd2spzd2zz__evaluate_compz00(BgL_sz00_10659, BgL_argsz00_10657, 
BINT(BgL_spz00_12650)); 
{ /* Eval/evaluate_comp.scm 791 */
long BgL_arg1780z00_12651;
BgL_arg1780z00_12651 = 
(BgL_spz00_12650+BgL_nbargsz00_10656); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_sz00_10659, 
(long)CINT(BgL_bpz00_12644), BgL_sz00_10659, 
BINT(BgL_spz00_12650), 
BINT(BgL_arg1780z00_12651)); } }  else 
{ /* Eval/evaluate_comp.scm 787 */
bool_t BgL_test5529z00_15826;
if(
(
(long)CINT(BgL_arityz00_12647)>=((long)0)))
{ /* Eval/evaluate_comp.scm 787 */
BgL_test5529z00_15826 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate_comp.scm 787 */
BgL_test5529z00_15826 = 
(
(long)CINT(BgL_arityz00_12647)<
(((long)-1)-BgL_nbargsz00_10656))
; } 
if(BgL_test5529z00_15826)
{ /* Eval/evaluate_comp.scm 787 */
BGl_evarityzd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1154z00_10654))->BgL_locz00), 
STRUCT_REF(BgL_ufz00_12646, 
(int)(((long)3))), 
(int)(BgL_nbargsz00_10656), 
CINT(BgL_arityz00_12647)); }  else 
{ /* Eval/evaluate_comp.scm 787 */
BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00(BgL_arityz00_12647, BgL_sz00_10659, BgL_argsz00_10657, 
BINT(BgL_spz00_12650)); 
{ /* Eval/evaluate_comp.scm 793 */
long BgL_arg1786z00_12652;
BgL_arg1786z00_12652 = 
(BgL_spz00_12650+
(((long)0)-
(long)CINT(BgL_arityz00_12647))); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_sz00_10659, 
(long)CINT(BgL_bpz00_12644), BgL_sz00_10659, 
BINT(BgL_spz00_12650), 
BINT(BgL_arg1786z00_12652)); } } } 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_z12denvz12_12653;
BgL_z12denvz12_12653 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10659, BgL_bpz00_12644, BgL_sfz00_12649))
{ /* Eval/evaluate_comp.scm 787 */
return BgL_runz00_12648;}  else 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_nsz00_12654;
BgL_nsz00_12654 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 787 */
long BgL_arg1790z00_12655;
BgL_arg1790z00_12655 = 
(
(long)CINT(BgL_bpz00_12644)+BgL_nbargsz00_10656); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12654, ((long)2), BgL_sz00_10659, BgL_bpz00_12644, 
BINT(BgL_arg1790z00_12655)); } 
VECTOR_SET(BgL_nsz00_12654,((long)1),BgL_sz00_10659); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12653, BgL_nsz00_12654); 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_ez00_12656;
BgL_ez00_12656 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12656, BgL_sz00_10659); 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_____rz00_12657;
BgL_____rz00_12657 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12648, BgL_nsz00_12654, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12656); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12653, BgL_sz00_10659); 
return BgL_____rz00_12657;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 787 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12645, 
(int)(BgL_nbargsz00_10656)))
{ /* Eval/evaluate_comp.scm 787 */
return 
BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00(BgL_sz00_10659, BgL_fz00_12645, BgL_argsz00_10657, BgL_bpz00_12644, 
BINT(BgL_siza7eza7_10658));}  else 
{ /* Eval/evaluate_comp.scm 787 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1154z00_10654))->BgL_locz00), BgL_symbzd2funzd2_10655, 
(int)(BgL_nbargsz00_10656), 
PROCEDURE_ARITY(BgL_fz00_12645));} } } } } } } } 

}



/* &<@anonymous:1798> */
obj_t BGl_z62zc3z04anonymousza31798ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10660, obj_t BgL_sz00_10666)
{
{ /* Eval/evaluate_comp.scm 795 */
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_fz00_10661;BgL_ev_appz00_bglt BgL_i1154z00_10662;obj_t BgL_symbzd2funzd2_10663;long BgL_nbargsz00_10664;obj_t BgL_argsz00_10665;
BgL_fz00_10661 = 
PROCEDURE_REF(BgL_envz00_10660, 
(int)(((long)0))); 
BgL_i1154z00_10662 = 
((BgL_ev_appz00_bglt)
PROCEDURE_REF(BgL_envz00_10660, 
(int)(((long)1)))); 
BgL_symbzd2funzd2_10663 = 
PROCEDURE_REF(BgL_envz00_10660, 
(int)(((long)2))); 
BgL_nbargsz00_10664 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10660, 
(int)(((long)3)))); 
BgL_argsz00_10665 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10660, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_bpz00_12658;
BgL_bpz00_12658 = 
VECTOR_REF(
((obj_t)BgL_sz00_10666),((long)0)); 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_fz00_12659;
BgL_fz00_12659 = 
PROCEDURE_ENTRY(BgL_fz00_10661)(BgL_fz00_10661, BgL_sz00_10666, BEOA); 
if(
PROCEDUREP(BgL_fz00_12659))
{ /* Eval/evaluate_comp.scm 795 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 795 */
BGl_evtypezd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1154z00_10662))->BgL_locz00), BGl_string5208z00zz__evaluate_compz00, BGl_string5224z00zz__evaluate_compz00, BgL_fz00_12659); } 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_ufz00_12660;
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_tmpz00_15896;
BgL_tmpz00_15896 = 
((obj_t)BgL_fz00_12659); 
BgL_ufz00_12660 = 
PROCEDURE_ATTR(BgL_tmpz00_15896); } 
{ /* Eval/evaluate_comp.scm 795 */
bool_t BgL_test5534z00_15899;
if(
STRUCTP(BgL_ufz00_12660))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5534z00_15899 = 
(
STRUCT_KEY(BgL_ufz00_12660)==BGl_symbol5225z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5534z00_15899 = ((bool_t)0)
; } 
if(BgL_test5534z00_15899)
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_arityz00_12661;obj_t BgL_runz00_12662;obj_t BgL_sfz00_12663;
BgL_arityz00_12661 = 
STRUCT_REF(BgL_ufz00_12660, 
(int)(((long)0))); 
BgL_runz00_12662 = 
STRUCT_REF(BgL_ufz00_12660, 
(int)(((long)1))); 
BgL_sfz00_12663 = 
STRUCT_REF(BgL_ufz00_12660, 
(int)(((long)2))); 
if(
(
(long)CINT(BgL_arityz00_12661)==BgL_nbargsz00_10664))
{ /* Eval/evaluate_comp.scm 795 */
BBOOL(
BGl_pushzd2argszd2onzd2spzd2zz__evaluate_compz00(BgL_sz00_10666, BgL_argsz00_10665, BgL_bpz00_12658)); }  else 
{ /* Eval/evaluate_comp.scm 795 */
bool_t BgL_test5537z00_15915;
if(
(
(long)CINT(BgL_arityz00_12661)>=((long)0)))
{ /* Eval/evaluate_comp.scm 795 */
BgL_test5537z00_15915 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate_comp.scm 795 */
BgL_test5537z00_15915 = 
(
(long)CINT(BgL_arityz00_12661)<
(((long)-1)-BgL_nbargsz00_10664))
; } 
if(BgL_test5537z00_15915)
{ /* Eval/evaluate_comp.scm 795 */
BGl_evarityzd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1154z00_10662))->BgL_locz00), 
STRUCT_REF(BgL_ufz00_12660, 
(int)(((long)3))), 
(int)(BgL_nbargsz00_10664), 
CINT(BgL_arityz00_12661)); }  else 
{ /* Eval/evaluate_comp.scm 795 */
BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00(BgL_arityz00_12661, BgL_sz00_10666, BgL_argsz00_10665, BgL_bpz00_12658); } } 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_z12denvz12_12664;
BgL_z12denvz12_12664 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_tmpz00_15930;
BgL_tmpz00_15930 = 
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1154z00_10662))->BgL_locz00); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_12664, BgL_tmpz00_15930); } 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10666, BgL_bpz00_12658, BgL_sfz00_12663))
{ /* Eval/evaluate_comp.scm 795 */
return BgL_runz00_12662;}  else 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_nsz00_12665;
BgL_nsz00_12665 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 795 */
long BgL_arg1811z00_12666;
BgL_arg1811z00_12666 = 
(
(long)CINT(BgL_bpz00_12658)+BgL_nbargsz00_10664); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12665, ((long)2), BgL_sz00_10666, BgL_bpz00_12658, 
BINT(BgL_arg1811z00_12666)); } 
VECTOR_SET(BgL_nsz00_12665,((long)1),BgL_sz00_10666); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12664, BgL_nsz00_12665); 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_ez00_12667;
BgL_ez00_12667 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12667, BgL_sz00_10666); 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_____rz00_12668;
BgL_____rz00_12668 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12662, BgL_nsz00_12665, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12667); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12664, BgL_sz00_10666); 
return BgL_____rz00_12668;} } } } }  else 
{ /* Eval/evaluate_comp.scm 795 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12659, 
(int)(BgL_nbargsz00_10664)))
{ /* Eval/evaluate_comp.scm 795 */
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_auxz00_15953;obj_t BgL_tmpz00_15951;
BgL_auxz00_15953 = 
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1154z00_10662))->BgL_locz00); 
BgL_tmpz00_15951 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_15951, BgL_auxz00_15953); } 
return 
BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00(BgL_sz00_10666, BgL_fz00_12659, BgL_argsz00_10665, BgL_bpz00_12658, 
BINT(BgL_nbargsz00_10664));}  else 
{ /* Eval/evaluate_comp.scm 795 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1154z00_10662))->BgL_locz00), BgL_symbzd2funzd2_10663, 
(int)(BgL_nbargsz00_10664), 
PROCEDURE_ARITY(BgL_fz00_12659));} } } } } } } } 

}



/* &<@anonymous:1818> */
obj_t BGl_z62zc3z04anonymousza31818ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10667, obj_t BgL_sz00_10673)
{
{ /* Eval/evaluate_comp.scm 795 */
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_fz00_10668;BgL_ev_appz00_bglt BgL_i1154z00_10669;obj_t BgL_symbzd2funzd2_10670;long BgL_nbargsz00_10671;obj_t BgL_argsz00_10672;
BgL_fz00_10668 = 
PROCEDURE_REF(BgL_envz00_10667, 
(int)(((long)0))); 
BgL_i1154z00_10669 = 
((BgL_ev_appz00_bglt)
PROCEDURE_REF(BgL_envz00_10667, 
(int)(((long)1)))); 
BgL_symbzd2funzd2_10670 = 
PROCEDURE_REF(BgL_envz00_10667, 
(int)(((long)2))); 
BgL_nbargsz00_10671 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10667, 
(int)(((long)3)))); 
BgL_argsz00_10672 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10667, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_bpz00_12669;
BgL_bpz00_12669 = 
VECTOR_REF(
((obj_t)BgL_sz00_10673),((long)0)); 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_fz00_12670;
BgL_fz00_12670 = 
PROCEDURE_ENTRY(BgL_fz00_10668)(BgL_fz00_10668, BgL_sz00_10673, BEOA); 
if(
PROCEDUREP(BgL_fz00_12670))
{ /* Eval/evaluate_comp.scm 795 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 795 */
BGl_evtypezd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1154z00_10669))->BgL_locz00), BGl_string5208z00zz__evaluate_compz00, BGl_string5224z00zz__evaluate_compz00, BgL_fz00_12670); } 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_ufz00_12671;
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_tmpz00_15985;
BgL_tmpz00_15985 = 
((obj_t)BgL_fz00_12670); 
BgL_ufz00_12671 = 
PROCEDURE_ATTR(BgL_tmpz00_15985); } 
{ /* Eval/evaluate_comp.scm 795 */
bool_t BgL_test5542z00_15988;
if(
STRUCTP(BgL_ufz00_12671))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5542z00_15988 = 
(
STRUCT_KEY(BgL_ufz00_12671)==BGl_symbol5225z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5542z00_15988 = ((bool_t)0)
; } 
if(BgL_test5542z00_15988)
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_arityz00_12672;obj_t BgL_runz00_12673;obj_t BgL_sfz00_12674;
BgL_arityz00_12672 = 
STRUCT_REF(BgL_ufz00_12671, 
(int)(((long)0))); 
BgL_runz00_12673 = 
STRUCT_REF(BgL_ufz00_12671, 
(int)(((long)1))); 
BgL_sfz00_12674 = 
STRUCT_REF(BgL_ufz00_12671, 
(int)(((long)2))); 
if(
(
(long)CINT(BgL_arityz00_12672)==BgL_nbargsz00_10671))
{ /* Eval/evaluate_comp.scm 795 */
BBOOL(
BGl_pushzd2argszd2onzd2spzd2zz__evaluate_compz00(BgL_sz00_10673, BgL_argsz00_10672, BgL_bpz00_12669)); }  else 
{ /* Eval/evaluate_comp.scm 795 */
bool_t BgL_test5545z00_16004;
if(
(
(long)CINT(BgL_arityz00_12672)>=((long)0)))
{ /* Eval/evaluate_comp.scm 795 */
BgL_test5545z00_16004 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate_comp.scm 795 */
BgL_test5545z00_16004 = 
(
(long)CINT(BgL_arityz00_12672)<
(((long)-1)-BgL_nbargsz00_10671))
; } 
if(BgL_test5545z00_16004)
{ /* Eval/evaluate_comp.scm 795 */
BGl_evarityzd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1154z00_10669))->BgL_locz00), 
STRUCT_REF(BgL_ufz00_12671, 
(int)(((long)3))), 
(int)(BgL_nbargsz00_10671), 
CINT(BgL_arityz00_12672)); }  else 
{ /* Eval/evaluate_comp.scm 795 */
BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00(BgL_arityz00_12672, BgL_sz00_10673, BgL_argsz00_10672, BgL_bpz00_12669); } } 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_z12denvz12_12675;
BgL_z12denvz12_12675 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10673, BgL_bpz00_12669, BgL_sfz00_12674))
{ /* Eval/evaluate_comp.scm 795 */
return BgL_runz00_12673;}  else 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_nsz00_12676;
BgL_nsz00_12676 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 795 */
long BgL_arg1830z00_12677;
BgL_arg1830z00_12677 = 
(
(long)CINT(BgL_bpz00_12669)+BgL_nbargsz00_10671); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12676, ((long)2), BgL_sz00_10673, BgL_bpz00_12669, 
BINT(BgL_arg1830z00_12677)); } 
VECTOR_SET(BgL_nsz00_12676,((long)1),BgL_sz00_10673); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12675, BgL_nsz00_12676); 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_ez00_12678;
BgL_ez00_12678 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12678, BgL_sz00_10673); 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_____rz00_12679;
BgL_____rz00_12679 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12673, BgL_nsz00_12676, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12678); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12675, BgL_sz00_10673); 
return BgL_____rz00_12679;} } } } }  else 
{ /* Eval/evaluate_comp.scm 795 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12670, 
(int)(BgL_nbargsz00_10671)))
{ /* Eval/evaluate_comp.scm 795 */
return 
BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00(BgL_sz00_10673, BgL_fz00_12670, BgL_argsz00_10672, BgL_bpz00_12669, 
BINT(BgL_nbargsz00_10671));}  else 
{ /* Eval/evaluate_comp.scm 795 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1154z00_10669))->BgL_locz00), BgL_symbzd2funzd2_10670, 
(int)(BgL_nbargsz00_10671), 
PROCEDURE_ARITY(BgL_fz00_12670));} } } } } } } } 

}



/* &<@anonymous:1839> */
obj_t BGl_z62zc3z04anonymousza31839ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10674, obj_t BgL_sz00_10681)
{
{ /* Eval/evaluate_comp.scm 781 */
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_fz00_10675;BgL_ev_appz00_bglt BgL_i1154z00_10676;obj_t BgL_symbzd2funzd2_10677;long BgL_nbargsz00_10678;obj_t BgL_argsz00_10679;long BgL_siza7eza7_10680;
BgL_fz00_10675 = 
PROCEDURE_REF(BgL_envz00_10674, 
(int)(((long)0))); 
BgL_i1154z00_10676 = 
((BgL_ev_appz00_bglt)
PROCEDURE_REF(BgL_envz00_10674, 
(int)(((long)1)))); 
BgL_symbzd2funzd2_10677 = 
PROCEDURE_REF(BgL_envz00_10674, 
(int)(((long)2))); 
BgL_nbargsz00_10678 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10674, 
(int)(((long)3)))); 
BgL_argsz00_10679 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10674, 
(int)(((long)4)))); 
BgL_siza7eza7_10680 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10674, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_bpz00_12680;
BgL_bpz00_12680 = 
VECTOR_REF(
((obj_t)BgL_sz00_10681),((long)0)); 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_fz00_12681;
BgL_fz00_12681 = 
PROCEDURE_ENTRY(BgL_fz00_10675)(BgL_fz00_10675, BgL_sz00_10681, BEOA); 
if(
PROCEDUREP(BgL_fz00_12681))
{ /* Eval/evaluate_comp.scm 781 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 781 */
BGl_evtypezd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1154z00_10676))->BgL_locz00), BGl_string5208z00zz__evaluate_compz00, BGl_string5224z00zz__evaluate_compz00, BgL_fz00_12681); } 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_ufz00_12682;
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_tmpz00_16069;
BgL_tmpz00_16069 = 
((obj_t)BgL_fz00_12681); 
BgL_ufz00_12682 = 
PROCEDURE_ATTR(BgL_tmpz00_16069); } 
{ /* Eval/evaluate_comp.scm 781 */
bool_t BgL_test5550z00_16072;
if(
STRUCTP(BgL_ufz00_12682))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5550z00_16072 = 
(
STRUCT_KEY(BgL_ufz00_12682)==BGl_symbol5225z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5550z00_16072 = ((bool_t)0)
; } 
if(BgL_test5550z00_16072)
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_arityz00_12683;obj_t BgL_runz00_12684;obj_t BgL_sfz00_12685;
BgL_arityz00_12683 = 
STRUCT_REF(BgL_ufz00_12682, 
(int)(((long)0))); 
BgL_runz00_12684 = 
STRUCT_REF(BgL_ufz00_12682, 
(int)(((long)1))); 
BgL_sfz00_12685 = 
STRUCT_REF(BgL_ufz00_12682, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 781 */
long BgL_spz00_12686;
BgL_spz00_12686 = 
(
(long)CINT(BgL_bpz00_12680)+BgL_siza7eza7_10680); 
if(
(
(long)CINT(BgL_arityz00_12683)==BgL_nbargsz00_10678))
{ /* Eval/evaluate_comp.scm 781 */
BBOOL(
BGl_pushzd2argszd2onzd2spzd2zz__evaluate_compz00(BgL_sz00_10681, BgL_argsz00_10679, 
BINT(BgL_spz00_12686))); }  else 
{ /* Eval/evaluate_comp.scm 781 */
bool_t BgL_test5553z00_16091;
if(
(
(long)CINT(BgL_arityz00_12683)>=((long)0)))
{ /* Eval/evaluate_comp.scm 781 */
BgL_test5553z00_16091 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate_comp.scm 781 */
BgL_test5553z00_16091 = 
(
(long)CINT(BgL_arityz00_12683)<
(((long)-1)-BgL_nbargsz00_10678))
; } 
if(BgL_test5553z00_16091)
{ /* Eval/evaluate_comp.scm 781 */
BGl_evarityzd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1154z00_10676))->BgL_locz00), 
STRUCT_REF(BgL_ufz00_12682, 
(int)(((long)3))), 
(int)(BgL_nbargsz00_10678), 
CINT(BgL_arityz00_12683)); }  else 
{ /* Eval/evaluate_comp.scm 781 */
BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00(BgL_arityz00_12683, BgL_sz00_10681, BgL_argsz00_10679, 
BINT(BgL_spz00_12686)); } } 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_z12denvz12_12687;
BgL_z12denvz12_12687 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_tmpz00_16107;
BgL_tmpz00_16107 = 
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1154z00_10676))->BgL_locz00); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_12687, BgL_tmpz00_16107); } 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10681, 
BINT(BgL_spz00_12686), BgL_sfz00_12685))
{ /* Eval/evaluate_comp.scm 781 */
return 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12684, BgL_sz00_10681, 
BINT(BgL_spz00_12686));}  else 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_nsz00_12688;
BgL_nsz00_12688 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 781 */
long BgL_arg1852z00_12689;
BgL_arg1852z00_12689 = 
(BgL_spz00_12686+BgL_nbargsz00_10678); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12688, ((long)2), BgL_sz00_10681, 
BINT(BgL_spz00_12686), 
BINT(BgL_arg1852z00_12689)); } 
VECTOR_SET(BgL_nsz00_12688,((long)1),BgL_sz00_10681); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12687, BgL_nsz00_12688); 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_ez00_12690;
BgL_ez00_12690 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12690, BgL_sz00_10681); 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_____rz00_12691;
BgL_____rz00_12691 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12684, BgL_nsz00_12688, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12690); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12687, BgL_sz00_10681); 
return BgL_____rz00_12691;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 781 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12681, 
(int)(BgL_nbargsz00_10678)))
{ /* Eval/evaluate_comp.scm 781 */
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_auxz00_16133;obj_t BgL_tmpz00_16131;
BgL_auxz00_16133 = 
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1154z00_10676))->BgL_locz00); 
BgL_tmpz00_16131 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_16131, BgL_auxz00_16133); } 
return 
BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00(BgL_sz00_10681, BgL_fz00_12681, BgL_argsz00_10679, BgL_bpz00_12680, 
BINT(BgL_siza7eza7_10680));}  else 
{ /* Eval/evaluate_comp.scm 781 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1154z00_10676))->BgL_locz00), BgL_symbzd2funzd2_10677, 
(int)(BgL_nbargsz00_10678), 
PROCEDURE_ARITY(BgL_fz00_12681));} } } } } } } } 

}



/* &<@anonymous:1859> */
obj_t BGl_z62zc3z04anonymousza31859ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10682, obj_t BgL_sz00_10689)
{
{ /* Eval/evaluate_comp.scm 781 */
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_fz00_10683;BgL_ev_appz00_bglt BgL_i1154z00_10684;obj_t BgL_symbzd2funzd2_10685;long BgL_nbargsz00_10686;obj_t BgL_argsz00_10687;long BgL_siza7eza7_10688;
BgL_fz00_10683 = 
PROCEDURE_REF(BgL_envz00_10682, 
(int)(((long)0))); 
BgL_i1154z00_10684 = 
((BgL_ev_appz00_bglt)
PROCEDURE_REF(BgL_envz00_10682, 
(int)(((long)1)))); 
BgL_symbzd2funzd2_10685 = 
PROCEDURE_REF(BgL_envz00_10682, 
(int)(((long)2))); 
BgL_nbargsz00_10686 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10682, 
(int)(((long)3)))); 
BgL_argsz00_10687 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10682, 
(int)(((long)4)))); 
BgL_siza7eza7_10688 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10682, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_bpz00_12692;
BgL_bpz00_12692 = 
VECTOR_REF(
((obj_t)BgL_sz00_10689),((long)0)); 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_fz00_12693;
BgL_fz00_12693 = 
PROCEDURE_ENTRY(BgL_fz00_10683)(BgL_fz00_10683, BgL_sz00_10689, BEOA); 
if(
PROCEDUREP(BgL_fz00_12693))
{ /* Eval/evaluate_comp.scm 781 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 781 */
BGl_evtypezd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1154z00_10684))->BgL_locz00), BGl_string5208z00zz__evaluate_compz00, BGl_string5224z00zz__evaluate_compz00, BgL_fz00_12693); } 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_ufz00_12694;
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_tmpz00_16168;
BgL_tmpz00_16168 = 
((obj_t)BgL_fz00_12693); 
BgL_ufz00_12694 = 
PROCEDURE_ATTR(BgL_tmpz00_16168); } 
{ /* Eval/evaluate_comp.scm 781 */
bool_t BgL_test5558z00_16171;
if(
STRUCTP(BgL_ufz00_12694))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5558z00_16171 = 
(
STRUCT_KEY(BgL_ufz00_12694)==BGl_symbol5225z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5558z00_16171 = ((bool_t)0)
; } 
if(BgL_test5558z00_16171)
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_arityz00_12695;obj_t BgL_runz00_12696;obj_t BgL_sfz00_12697;
BgL_arityz00_12695 = 
STRUCT_REF(BgL_ufz00_12694, 
(int)(((long)0))); 
BgL_runz00_12696 = 
STRUCT_REF(BgL_ufz00_12694, 
(int)(((long)1))); 
BgL_sfz00_12697 = 
STRUCT_REF(BgL_ufz00_12694, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 781 */
long BgL_spz00_12698;
BgL_spz00_12698 = 
(
(long)CINT(BgL_bpz00_12692)+BgL_siza7eza7_10688); 
if(
(
(long)CINT(BgL_arityz00_12695)==BgL_nbargsz00_10686))
{ /* Eval/evaluate_comp.scm 781 */
BBOOL(
BGl_pushzd2argszd2onzd2spzd2zz__evaluate_compz00(BgL_sz00_10689, BgL_argsz00_10687, 
BINT(BgL_spz00_12698))); }  else 
{ /* Eval/evaluate_comp.scm 781 */
bool_t BgL_test5561z00_16190;
if(
(
(long)CINT(BgL_arityz00_12695)>=((long)0)))
{ /* Eval/evaluate_comp.scm 781 */
BgL_test5561z00_16190 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate_comp.scm 781 */
BgL_test5561z00_16190 = 
(
(long)CINT(BgL_arityz00_12695)<
(((long)-1)-BgL_nbargsz00_10686))
; } 
if(BgL_test5561z00_16190)
{ /* Eval/evaluate_comp.scm 781 */
BGl_evarityzd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1154z00_10684))->BgL_locz00), 
STRUCT_REF(BgL_ufz00_12694, 
(int)(((long)3))), 
(int)(BgL_nbargsz00_10686), 
CINT(BgL_arityz00_12695)); }  else 
{ /* Eval/evaluate_comp.scm 781 */
BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00(BgL_arityz00_12695, BgL_sz00_10689, BgL_argsz00_10687, 
BINT(BgL_spz00_12698)); } } 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_z12denvz12_12699;
BgL_z12denvz12_12699 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10689, 
BINT(BgL_spz00_12698), BgL_sfz00_12697))
{ /* Eval/evaluate_comp.scm 781 */
return 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12696, BgL_sz00_10689, 
BINT(BgL_spz00_12698));}  else 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_nsz00_12700;
BgL_nsz00_12700 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 781 */
long BgL_arg1871z00_12701;
BgL_arg1871z00_12701 = 
(BgL_spz00_12698+BgL_nbargsz00_10686); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12700, ((long)2), BgL_sz00_10689, 
BINT(BgL_spz00_12698), 
BINT(BgL_arg1871z00_12701)); } 
VECTOR_SET(BgL_nsz00_12700,((long)1),BgL_sz00_10689); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12699, BgL_nsz00_12700); 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_ez00_12702;
BgL_ez00_12702 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12702, BgL_sz00_10689); 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_____rz00_12703;
BgL_____rz00_12703 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12696, BgL_nsz00_12700, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12702); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12699, BgL_sz00_10689); 
return BgL_____rz00_12703;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 781 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12693, 
(int)(BgL_nbargsz00_10686)))
{ /* Eval/evaluate_comp.scm 781 */
return 
BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00(BgL_sz00_10689, BgL_fz00_12693, BgL_argsz00_10687, BgL_bpz00_12692, 
BINT(BgL_siza7eza7_10688));}  else 
{ /* Eval/evaluate_comp.scm 781 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1154z00_10684))->BgL_locz00), BgL_symbzd2funzd2_10685, 
(int)(BgL_nbargsz00_10686), 
PROCEDURE_ARITY(BgL_fz00_12693));} } } } } } } } 

}



/* comp-call0 */
obj_t BGl_compzd2call0zd2zz__evaluate_compz00(obj_t BgL_locz00_138, BgL_ev_exprz00_bglt BgL_vfunz00_139, obj_t BgL_symbzd2funzd2_140, obj_t BgL_funz00_141, obj_t BgL_tailzf3zf3_142, obj_t BgL_stkz00_143, long BgL_siza7eza7_144)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_cfunz00_1969;
BgL_cfunz00_1969 = 
BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_139, ((long)0), BgL_locz00_138, BgL_symbzd2funzd2_140); 
if(
CBOOL(BgL_cfunz00_1969))
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5566z00_16236;
{ /* Eval/evaluate_comp.scm 896 */
int BgL_arg1885z00_1983;
BgL_arg1885z00_1983 = 
bgl_debug(); 
BgL_test5566z00_16236 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg1885z00_1983), 
BINT(((long)0))); } 
if(BgL_test5566z00_16236)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza31882ze3z87_10690;
BgL_zc3z04anonymousza31882ze3z87_10690 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31882ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31882ze3z87_10690, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_144)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31882ze3z87_10690, 
(int)(((long)1)), BgL_locz00_138); 
PROCEDURE_SET(BgL_zc3z04anonymousza31882ze3z87_10690, 
(int)(((long)2)), BgL_cfunz00_1969); 
return BgL_zc3z04anonymousza31882ze3z87_10690;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza31884ze3z87_10691;
BgL_zc3z04anonymousza31884ze3z87_10691 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31884ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31884ze3z87_10691, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_144)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31884ze3z87_10691, 
(int)(((long)1)), BgL_cfunz00_1969); 
return BgL_zc3z04anonymousza31884ze3z87_10691;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
CBOOL(BgL_tailzf3zf3_142))
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5568z00_16261;
{ /* Eval/evaluate_comp.scm 896 */
int BgL_arg1915z00_2047;
BgL_arg1915z00_2047 = 
bgl_debug(); 
BgL_test5568z00_16261 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg1915z00_2047), 
BINT(((long)0))); } 
if(BgL_test5568z00_16261)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza31888ze3z87_10692;
BgL_zc3z04anonymousza31888ze3z87_10692 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31888ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31888ze3z87_10692, 
(int)(((long)0)), BgL_funz00_141); 
PROCEDURE_SET(BgL_zc3z04anonymousza31888ze3z87_10692, 
(int)(((long)1)), BgL_locz00_138); 
PROCEDURE_SET(BgL_zc3z04anonymousza31888ze3z87_10692, 
(int)(((long)2)), BgL_symbzd2funzd2_140); 
PROCEDURE_SET(BgL_zc3z04anonymousza31888ze3z87_10692, 
(int)(((long)3)), 
BINT(BgL_siza7eza7_144)); 
return BgL_zc3z04anonymousza31888ze3z87_10692;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza31902ze3z87_10693;
BgL_zc3z04anonymousza31902ze3z87_10693 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31902ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31902ze3z87_10693, 
(int)(((long)0)), BgL_funz00_141); 
PROCEDURE_SET(BgL_zc3z04anonymousza31902ze3z87_10693, 
(int)(((long)1)), BgL_locz00_138); 
PROCEDURE_SET(BgL_zc3z04anonymousza31902ze3z87_10693, 
(int)(((long)2)), BgL_symbzd2funzd2_140); 
PROCEDURE_SET(BgL_zc3z04anonymousza31902ze3z87_10693, 
(int)(((long)3)), 
BINT(BgL_siza7eza7_144)); 
return BgL_zc3z04anonymousza31902ze3z87_10693;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5569z00_16290;
{ /* Eval/evaluate_comp.scm 896 */
int BgL_arg1945z00_2111;
BgL_arg1945z00_2111 = 
bgl_debug(); 
BgL_test5569z00_16290 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg1945z00_2111), 
BINT(((long)0))); } 
if(BgL_test5569z00_16290)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza31918ze3z87_10694;
BgL_zc3z04anonymousza31918ze3z87_10694 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31918ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31918ze3z87_10694, 
(int)(((long)0)), BgL_funz00_141); 
PROCEDURE_SET(BgL_zc3z04anonymousza31918ze3z87_10694, 
(int)(((long)1)), BgL_locz00_138); 
PROCEDURE_SET(BgL_zc3z04anonymousza31918ze3z87_10694, 
(int)(((long)2)), BgL_symbzd2funzd2_140); 
PROCEDURE_SET(BgL_zc3z04anonymousza31918ze3z87_10694, 
(int)(((long)3)), 
BINT(BgL_siza7eza7_144)); 
return BgL_zc3z04anonymousza31918ze3z87_10694;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza31932ze3z87_10695;
BgL_zc3z04anonymousza31932ze3z87_10695 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31932ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31932ze3z87_10695, 
(int)(((long)0)), BgL_funz00_141); 
PROCEDURE_SET(BgL_zc3z04anonymousza31932ze3z87_10695, 
(int)(((long)1)), BgL_locz00_138); 
PROCEDURE_SET(BgL_zc3z04anonymousza31932ze3z87_10695, 
(int)(((long)2)), BgL_symbzd2funzd2_140); 
PROCEDURE_SET(BgL_zc3z04anonymousza31932ze3z87_10695, 
(int)(((long)3)), 
BINT(BgL_siza7eza7_144)); 
return BgL_zc3z04anonymousza31932ze3z87_10695;} } } } } 

}



/* &<@anonymous:1882> */
obj_t BGl_z62zc3z04anonymousza31882ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10696, obj_t BgL_sz00_10700)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
long BgL_siza7eza7_10697;obj_t BgL_locz00_10698;obj_t BgL_cfunz00_10699;
BgL_siza7eza7_10697 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10696, 
(int)(((long)0)))); 
BgL_locz00_10698 = 
PROCEDURE_REF(BgL_envz00_10696, 
(int)(((long)1))); 
BgL_cfunz00_10699 = 
PROCEDURE_REF(BgL_envz00_10696, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12704;
BgL_bpz00_12704 = 
VECTOR_REF(
((obj_t)BgL_sz00_10700),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */

{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_12705;
BgL_nbpz00_12705 = 
(
(long)CINT(BgL_bpz00_12704)+BgL_siza7eza7_10697); 
VECTOR_SET(
((obj_t)BgL_sz00_10700),((long)0),
BINT(BgL_nbpz00_12705)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_16333;
BgL_tmpz00_16333 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_16333, BgL_locz00_10698); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_12706;
BgL_rz00_12706 = 
PROCEDURE_ENTRY(BgL_cfunz00_10699)(BgL_cfunz00_10699, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10700),((long)0),BgL_bpz00_12704); 
return BgL_rz00_12706;} } } } } } 

}



/* &<@anonymous:1884> */
obj_t BGl_z62zc3z04anonymousza31884ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10701, obj_t BgL_sz00_10704)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
long BgL_siza7eza7_10702;obj_t BgL_cfunz00_10703;
BgL_siza7eza7_10702 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10701, 
(int)(((long)0)))); 
BgL_cfunz00_10703 = 
PROCEDURE_REF(BgL_envz00_10701, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12707;
BgL_bpz00_12707 = 
VECTOR_REF(
((obj_t)BgL_sz00_10704),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */

{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_12708;
BgL_nbpz00_12708 = 
(
(long)CINT(BgL_bpz00_12707)+BgL_siza7eza7_10702); 
VECTOR_SET(
((obj_t)BgL_sz00_10704),((long)0),
BINT(BgL_nbpz00_12708)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_12709;
BgL_rz00_12709 = 
PROCEDURE_ENTRY(BgL_cfunz00_10703)(BgL_cfunz00_10703, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10704),((long)0),BgL_bpz00_12707); 
return BgL_rz00_12709;} } } } } } 

}



/* &<@anonymous:1888> */
obj_t BGl_z62zc3z04anonymousza31888ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10705, obj_t BgL_sz00_10710)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_10706;obj_t BgL_locz00_10707;obj_t BgL_symbzd2funzd2_10708;long BgL_siza7eza7_10709;
BgL_funz00_10706 = 
PROCEDURE_REF(BgL_envz00_10705, 
(int)(((long)0))); 
BgL_locz00_10707 = 
PROCEDURE_REF(BgL_envz00_10705, 
(int)(((long)1))); 
BgL_symbzd2funzd2_10708 = 
PROCEDURE_REF(BgL_envz00_10705, 
(int)(((long)2))); 
BgL_siza7eza7_10709 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10705, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12710;
BgL_bpz00_12710 = 
VECTOR_REF(
((obj_t)BgL_sz00_10710),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_12711;
BgL_fz00_12711 = 
PROCEDURE_ENTRY(BgL_funz00_10706)(BgL_funz00_10706, BgL_sz00_10710, BEOA); 
if(
PROCEDUREP(BgL_fz00_12711))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10707, BGl_string5208z00zz__evaluate_compz00, BGl_string5224z00zz__evaluate_compz00, BgL_fz00_12711); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_12712;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_16376;
BgL_tmpz00_16376 = 
((obj_t)BgL_fz00_12711); 
BgL_ufz00_12712 = 
PROCEDURE_ATTR(BgL_tmpz00_16376); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5571z00_16379;
if(
STRUCTP(BgL_ufz00_12712))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5571z00_16379 = 
(
STRUCT_KEY(BgL_ufz00_12712)==BGl_symbol5225z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5571z00_16379 = ((bool_t)0)
; } 
if(BgL_test5571z00_16379)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_12713;obj_t BgL_runz00_12714;obj_t BgL_sfz00_12715;
BgL_arityz00_12713 = 
STRUCT_REF(BgL_ufz00_12712, 
(int)(((long)0))); 
BgL_runz00_12714 = 
STRUCT_REF(BgL_ufz00_12712, 
(int)(((long)1))); 
BgL_sfz00_12715 = 
STRUCT_REF(BgL_ufz00_12712, 
(int)(((long)2))); 
if(
(
(long)CINT(BgL_arityz00_12713)==((long)0)))
{ /* Eval/evaluate_comp.scm 896 */BUNSPEC; }  else 
{ 

if(
INTEGERP(BgL_arityz00_12713))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_12713)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg1893z00_12718;obj_t BgL_arg1894z00_12719;
BgL_arg1893z00_12718 = 
(
(long)CINT(BgL_bpz00_12710)+((long)0)); 
BgL_arg1894z00_12719 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10710),BgL_arg1893z00_12718,BgL_arg1894z00_12719); } break;
default: 
BgL_case_else1170z00_12716:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg1896z00_12717;
BgL_arg1896z00_12717 = 
STRUCT_REF(
((obj_t)BgL_ufz00_12712), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10707, BgL_arg1896z00_12717, 
(int)(((long)0)), 
CINT(BgL_arityz00_12713)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1170z00_12716;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_12720;
BgL_z12denvz12_12720 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_12720, BgL_locz00_10707); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10710, BgL_bpz00_12710, BgL_sfz00_12715))
{ /* Eval/evaluate_comp.scm 896 */
return BgL_runz00_12714;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_12721;
BgL_nsz00_12721 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg1898z00_12722;
BgL_arg1898z00_12722 = 
(
(long)CINT(BgL_bpz00_12710)+((long)0)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12721, ((long)2), BgL_sz00_10710, BgL_bpz00_12710, 
BINT(BgL_arg1898z00_12722)); } 
VECTOR_SET(BgL_nsz00_12721,((long)1),BgL_sz00_10710); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12720, BgL_nsz00_12721); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_12723;
BgL_ez00_12723 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12723, BgL_sz00_10710); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_12724;
BgL_____rz00_12724 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12714, BgL_nsz00_12721, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12723); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12720, BgL_sz00_10710); 
return BgL_____rz00_12724;} } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12711, 
(int)(((long)0))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_12725;
BgL_nbpz00_12725 = 
(
(long)CINT(BgL_bpz00_12710)+BgL_siza7eza7_10709); 
VECTOR_SET(
((obj_t)BgL_sz00_10710),((long)0),
BINT(BgL_nbpz00_12725)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_16432;
BgL_tmpz00_16432 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_16432, BgL_locz00_10707); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_12726;
BgL_rz00_12726 = 
PROCEDURE_ENTRY(BgL_fz00_12711)(BgL_fz00_12711, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10710),((long)0),BgL_bpz00_12710); 
return BgL_rz00_12726;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10707, BgL_symbzd2funzd2_10708, 
(int)(((long)0)), 
PROCEDURE_ARITY(BgL_fz00_12711));} } } } } } } } 

}



/* &<@anonymous:1902> */
obj_t BGl_z62zc3z04anonymousza31902ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10711, obj_t BgL_sz00_10716)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_10712;obj_t BgL_locz00_10713;obj_t BgL_symbzd2funzd2_10714;long BgL_siza7eza7_10715;
BgL_funz00_10712 = 
PROCEDURE_REF(BgL_envz00_10711, 
(int)(((long)0))); 
BgL_locz00_10713 = 
PROCEDURE_REF(BgL_envz00_10711, 
(int)(((long)1))); 
BgL_symbzd2funzd2_10714 = 
PROCEDURE_REF(BgL_envz00_10711, 
(int)(((long)2))); 
BgL_siza7eza7_10715 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10711, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12727;
BgL_bpz00_12727 = 
VECTOR_REF(
((obj_t)BgL_sz00_10716),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_12728;
BgL_fz00_12728 = 
PROCEDURE_ENTRY(BgL_funz00_10712)(BgL_funz00_10712, BgL_sz00_10716, BEOA); 
if(
PROCEDUREP(BgL_fz00_12728))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10713, BGl_string5208z00zz__evaluate_compz00, BGl_string5224z00zz__evaluate_compz00, BgL_fz00_12728); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_12729;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_16461;
BgL_tmpz00_16461 = 
((obj_t)BgL_fz00_12728); 
BgL_ufz00_12729 = 
PROCEDURE_ATTR(BgL_tmpz00_16461); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5578z00_16464;
if(
STRUCTP(BgL_ufz00_12729))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5578z00_16464 = 
(
STRUCT_KEY(BgL_ufz00_12729)==BGl_symbol5225z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5578z00_16464 = ((bool_t)0)
; } 
if(BgL_test5578z00_16464)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_12730;obj_t BgL_runz00_12731;obj_t BgL_sfz00_12732;
BgL_arityz00_12730 = 
STRUCT_REF(BgL_ufz00_12729, 
(int)(((long)0))); 
BgL_runz00_12731 = 
STRUCT_REF(BgL_ufz00_12729, 
(int)(((long)1))); 
BgL_sfz00_12732 = 
STRUCT_REF(BgL_ufz00_12729, 
(int)(((long)2))); 
if(
(
(long)CINT(BgL_arityz00_12730)==((long)0)))
{ /* Eval/evaluate_comp.scm 896 */BUNSPEC; }  else 
{ 

if(
INTEGERP(BgL_arityz00_12730))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_12730)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg1907z00_12735;obj_t BgL_arg1908z00_12736;
BgL_arg1907z00_12735 = 
(
(long)CINT(BgL_bpz00_12727)+((long)0)); 
BgL_arg1908z00_12736 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10716),BgL_arg1907z00_12735,BgL_arg1908z00_12736); } break;
default: 
BgL_case_else1172z00_12733:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg1910z00_12734;
BgL_arg1910z00_12734 = 
STRUCT_REF(
((obj_t)BgL_ufz00_12729), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10713, BgL_arg1910z00_12734, 
(int)(((long)0)), 
CINT(BgL_arityz00_12730)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1172z00_12733;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_12737;
BgL_z12denvz12_12737 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10716, BgL_bpz00_12727, BgL_sfz00_12732))
{ /* Eval/evaluate_comp.scm 896 */
return BgL_runz00_12731;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_12738;
BgL_nsz00_12738 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg1912z00_12739;
BgL_arg1912z00_12739 = 
(
(long)CINT(BgL_bpz00_12727)+((long)0)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12738, ((long)2), BgL_sz00_10716, BgL_bpz00_12727, 
BINT(BgL_arg1912z00_12739)); } 
VECTOR_SET(BgL_nsz00_12738,((long)1),BgL_sz00_10716); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12737, BgL_nsz00_12738); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_12740;
BgL_ez00_12740 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12740, BgL_sz00_10716); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_12741;
BgL_____rz00_12741 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12731, BgL_nsz00_12738, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12740); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12737, BgL_sz00_10716); 
return BgL_____rz00_12741;} } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12728, 
(int)(((long)0))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_12742;
BgL_nbpz00_12742 = 
(
(long)CINT(BgL_bpz00_12727)+BgL_siza7eza7_10715); 
VECTOR_SET(
((obj_t)BgL_sz00_10716),((long)0),
BINT(BgL_nbpz00_12742)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_12743;
BgL_rz00_12743 = 
PROCEDURE_ENTRY(BgL_fz00_12728)(BgL_fz00_12728, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10716),((long)0),BgL_bpz00_12727); 
return BgL_rz00_12743;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10713, BgL_symbzd2funzd2_10714, 
(int)(((long)0)), 
PROCEDURE_ARITY(BgL_fz00_12728));} } } } } } } } 

}



/* &<@anonymous:1918> */
obj_t BGl_z62zc3z04anonymousza31918ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10717, obj_t BgL_sz00_10722)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_10718;obj_t BgL_locz00_10719;obj_t BgL_symbzd2funzd2_10720;long BgL_siza7eza7_10721;
BgL_funz00_10718 = 
PROCEDURE_REF(BgL_envz00_10717, 
(int)(((long)0))); 
BgL_locz00_10719 = 
PROCEDURE_REF(BgL_envz00_10717, 
(int)(((long)1))); 
BgL_symbzd2funzd2_10720 = 
PROCEDURE_REF(BgL_envz00_10717, 
(int)(((long)2))); 
BgL_siza7eza7_10721 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10717, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12744;
BgL_bpz00_12744 = 
VECTOR_REF(
((obj_t)BgL_sz00_10722),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_12745;
BgL_fz00_12745 = 
PROCEDURE_ENTRY(BgL_funz00_10718)(BgL_funz00_10718, BgL_sz00_10722, BEOA); 
if(
PROCEDUREP(BgL_fz00_12745))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10719, BGl_string5208z00zz__evaluate_compz00, BGl_string5224z00zz__evaluate_compz00, BgL_fz00_12745); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_12746;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_16542;
BgL_tmpz00_16542 = 
((obj_t)BgL_fz00_12745); 
BgL_ufz00_12746 = 
PROCEDURE_ATTR(BgL_tmpz00_16542); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5585z00_16545;
if(
STRUCTP(BgL_ufz00_12746))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5585z00_16545 = 
(
STRUCT_KEY(BgL_ufz00_12746)==BGl_symbol5225z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5585z00_16545 = ((bool_t)0)
; } 
if(BgL_test5585z00_16545)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_12747;obj_t BgL_runz00_12748;obj_t BgL_sfz00_12749;
BgL_arityz00_12747 = 
STRUCT_REF(BgL_ufz00_12746, 
(int)(((long)0))); 
BgL_runz00_12748 = 
STRUCT_REF(BgL_ufz00_12746, 
(int)(((long)1))); 
BgL_sfz00_12749 = 
STRUCT_REF(BgL_ufz00_12746, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_spz00_12750;
BgL_spz00_12750 = 
(
(long)CINT(BgL_bpz00_12744)+BgL_siza7eza7_10721); 
if(
(
(long)CINT(BgL_arityz00_12747)==((long)0)))
{ /* Eval/evaluate_comp.scm 896 */BUNSPEC; }  else 
{ 

if(
INTEGERP(BgL_arityz00_12747))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_12747)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg1923z00_12753;obj_t BgL_arg1924z00_12754;
BgL_arg1923z00_12753 = 
(BgL_spz00_12750+((long)0)); 
BgL_arg1924z00_12754 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10722),BgL_arg1923z00_12753,BgL_arg1924z00_12754); } break;
default: 
BgL_case_else1174z00_12751:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg1926z00_12752;
BgL_arg1926z00_12752 = 
STRUCT_REF(
((obj_t)BgL_ufz00_12746), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10719, BgL_arg1926z00_12752, 
(int)(((long)0)), 
CINT(BgL_arityz00_12747)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1174z00_12751;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_12755;
BgL_z12denvz12_12755 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_12755, BgL_locz00_10719); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10722, 
BINT(BgL_spz00_12750), BgL_sfz00_12749))
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12748, BgL_sz00_10722, 
BINT(BgL_spz00_12750));}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_12756;
BgL_nsz00_12756 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg1928z00_12757;
BgL_arg1928z00_12757 = 
(BgL_spz00_12750+((long)0)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12756, ((long)2), BgL_sz00_10722, 
BINT(BgL_spz00_12750), 
BINT(BgL_arg1928z00_12757)); } 
VECTOR_SET(BgL_nsz00_12756,((long)1),BgL_sz00_10722); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12755, BgL_nsz00_12756); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_12758;
BgL_ez00_12758 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12758, BgL_sz00_10722); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_12759;
BgL_____rz00_12759 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12748, BgL_nsz00_12756, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12758); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12755, BgL_sz00_10722); 
return BgL_____rz00_12759;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12745, 
(int)(((long)0))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_12760;
BgL_nbpz00_12760 = 
(
(long)CINT(BgL_bpz00_12744)+BgL_siza7eza7_10721); 
VECTOR_SET(
((obj_t)BgL_sz00_10722),((long)0),
BINT(BgL_nbpz00_12760)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_16602;
BgL_tmpz00_16602 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_16602, BgL_locz00_10719); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_12761;
BgL_rz00_12761 = 
PROCEDURE_ENTRY(BgL_fz00_12745)(BgL_fz00_12745, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10722),((long)0),BgL_bpz00_12744); 
return BgL_rz00_12761;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10719, BgL_symbzd2funzd2_10720, 
(int)(((long)0)), 
PROCEDURE_ARITY(BgL_fz00_12745));} } } } } } } } 

}



/* &<@anonymous:1932> */
obj_t BGl_z62zc3z04anonymousza31932ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10723, obj_t BgL_sz00_10728)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_10724;obj_t BgL_locz00_10725;obj_t BgL_symbzd2funzd2_10726;long BgL_siza7eza7_10727;
BgL_funz00_10724 = 
PROCEDURE_REF(BgL_envz00_10723, 
(int)(((long)0))); 
BgL_locz00_10725 = 
PROCEDURE_REF(BgL_envz00_10723, 
(int)(((long)1))); 
BgL_symbzd2funzd2_10726 = 
PROCEDURE_REF(BgL_envz00_10723, 
(int)(((long)2))); 
BgL_siza7eza7_10727 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10723, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12762;
BgL_bpz00_12762 = 
VECTOR_REF(
((obj_t)BgL_sz00_10728),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_12763;
BgL_fz00_12763 = 
PROCEDURE_ENTRY(BgL_funz00_10724)(BgL_funz00_10724, BgL_sz00_10728, BEOA); 
if(
PROCEDUREP(BgL_fz00_12763))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10725, BGl_string5208z00zz__evaluate_compz00, BGl_string5224z00zz__evaluate_compz00, BgL_fz00_12763); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_12764;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_16631;
BgL_tmpz00_16631 = 
((obj_t)BgL_fz00_12763); 
BgL_ufz00_12764 = 
PROCEDURE_ATTR(BgL_tmpz00_16631); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5592z00_16634;
if(
STRUCTP(BgL_ufz00_12764))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5592z00_16634 = 
(
STRUCT_KEY(BgL_ufz00_12764)==BGl_symbol5225z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5592z00_16634 = ((bool_t)0)
; } 
if(BgL_test5592z00_16634)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_12765;obj_t BgL_runz00_12766;obj_t BgL_sfz00_12767;
BgL_arityz00_12765 = 
STRUCT_REF(BgL_ufz00_12764, 
(int)(((long)0))); 
BgL_runz00_12766 = 
STRUCT_REF(BgL_ufz00_12764, 
(int)(((long)1))); 
BgL_sfz00_12767 = 
STRUCT_REF(BgL_ufz00_12764, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_spz00_12768;
BgL_spz00_12768 = 
(
(long)CINT(BgL_bpz00_12762)+BgL_siza7eza7_10727); 
if(
(
(long)CINT(BgL_arityz00_12765)==((long)0)))
{ /* Eval/evaluate_comp.scm 896 */BUNSPEC; }  else 
{ 

if(
INTEGERP(BgL_arityz00_12765))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_12765)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg1937z00_12771;obj_t BgL_arg1938z00_12772;
BgL_arg1937z00_12771 = 
(BgL_spz00_12768+((long)0)); 
BgL_arg1938z00_12772 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10728),BgL_arg1937z00_12771,BgL_arg1938z00_12772); } break;
default: 
BgL_case_else1176z00_12769:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg1940z00_12770;
BgL_arg1940z00_12770 = 
STRUCT_REF(
((obj_t)BgL_ufz00_12764), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10725, BgL_arg1940z00_12770, 
(int)(((long)0)), 
CINT(BgL_arityz00_12765)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1176z00_12769;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_12773;
BgL_z12denvz12_12773 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10728, 
BINT(BgL_spz00_12768), BgL_sfz00_12767))
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12766, BgL_sz00_10728, 
BINT(BgL_spz00_12768));}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_12774;
BgL_nsz00_12774 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg1942z00_12775;
BgL_arg1942z00_12775 = 
(BgL_spz00_12768+((long)0)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12774, ((long)2), BgL_sz00_10728, 
BINT(BgL_spz00_12768), 
BINT(BgL_arg1942z00_12775)); } 
VECTOR_SET(BgL_nsz00_12774,((long)1),BgL_sz00_10728); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12773, BgL_nsz00_12774); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_12776;
BgL_ez00_12776 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12776, BgL_sz00_10728); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_12777;
BgL_____rz00_12777 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12766, BgL_nsz00_12774, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12776); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12773, BgL_sz00_10728); 
return BgL_____rz00_12777;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12763, 
(int)(((long)0))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_12778;
BgL_nbpz00_12778 = 
(
(long)CINT(BgL_bpz00_12762)+BgL_siza7eza7_10727); 
VECTOR_SET(
((obj_t)BgL_sz00_10728),((long)0),
BINT(BgL_nbpz00_12778)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_12779;
BgL_rz00_12779 = 
PROCEDURE_ENTRY(BgL_fz00_12763)(BgL_fz00_12763, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10728),((long)0),BgL_bpz00_12762); 
return BgL_rz00_12779;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10725, BgL_symbzd2funzd2_10726, 
(int)(((long)0)), 
PROCEDURE_ARITY(BgL_fz00_12763));} } } } } } } } 

}



/* comp-call1 */
obj_t BGl_compzd2call1zd2zz__evaluate_compz00(obj_t BgL_locz00_145, BgL_ev_exprz00_bglt BgL_vfunz00_146, obj_t BgL_symbzd2funzd2_147, obj_t BgL_funz00_148, obj_t BgL_tailzf3zf3_149, obj_t BgL_stkz00_150, long BgL_siza7eza7_151, obj_t BgL_a1z00_152)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_cfunz00_2112;
BgL_cfunz00_2112 = 
BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_146, ((long)1), BgL_locz00_145, BgL_symbzd2funzd2_147); 
if(
CBOOL(BgL_cfunz00_2112))
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5599z00_16701;
{ /* Eval/evaluate_comp.scm 896 */
int BgL_arg1951z00_2128;
BgL_arg1951z00_2128 = 
bgl_debug(); 
BgL_test5599z00_16701 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg1951z00_2128), 
BINT(((long)0))); } 
if(BgL_test5599z00_16701)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza31948ze3z87_10729;
BgL_zc3z04anonymousza31948ze3z87_10729 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31948ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31948ze3z87_10729, 
(int)(((long)0)), BgL_a1z00_152); 
PROCEDURE_SET(BgL_zc3z04anonymousza31948ze3z87_10729, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_151)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31948ze3z87_10729, 
(int)(((long)2)), BgL_locz00_145); 
PROCEDURE_SET(BgL_zc3z04anonymousza31948ze3z87_10729, 
(int)(((long)3)), BgL_cfunz00_2112); 
return BgL_zc3z04anonymousza31948ze3z87_10729;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza31950ze3z87_10730;
BgL_zc3z04anonymousza31950ze3z87_10730 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31950ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31950ze3z87_10730, 
(int)(((long)0)), BgL_a1z00_152); 
PROCEDURE_SET(BgL_zc3z04anonymousza31950ze3z87_10730, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_151)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31950ze3z87_10730, 
(int)(((long)2)), BgL_cfunz00_2112); 
return BgL_zc3z04anonymousza31950ze3z87_10730;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
CBOOL(BgL_tailzf3zf3_149))
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5601z00_16730;
{ /* Eval/evaluate_comp.scm 896 */
int BgL_arg1991z00_2204;
BgL_arg1991z00_2204 = 
bgl_debug(); 
BgL_test5601z00_16730 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg1991z00_2204), 
BINT(((long)0))); } 
if(BgL_test5601z00_16730)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza31954ze3z87_10731;
BgL_zc3z04anonymousza31954ze3z87_10731 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31954ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31954ze3z87_10731, 
(int)(((long)0)), BgL_funz00_148); 
PROCEDURE_SET(BgL_zc3z04anonymousza31954ze3z87_10731, 
(int)(((long)1)), BgL_a1z00_152); 
PROCEDURE_SET(BgL_zc3z04anonymousza31954ze3z87_10731, 
(int)(((long)2)), BgL_locz00_145); 
PROCEDURE_SET(BgL_zc3z04anonymousza31954ze3z87_10731, 
(int)(((long)3)), BgL_symbzd2funzd2_147); 
PROCEDURE_SET(BgL_zc3z04anonymousza31954ze3z87_10731, 
(int)(((long)4)), 
BINT(BgL_siza7eza7_151)); 
return BgL_zc3z04anonymousza31954ze3z87_10731;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza31973ze3z87_10732;
BgL_zc3z04anonymousza31973ze3z87_10732 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31973ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31973ze3z87_10732, 
(int)(((long)0)), BgL_funz00_148); 
PROCEDURE_SET(BgL_zc3z04anonymousza31973ze3z87_10732, 
(int)(((long)1)), BgL_a1z00_152); 
PROCEDURE_SET(BgL_zc3z04anonymousza31973ze3z87_10732, 
(int)(((long)2)), BgL_locz00_145); 
PROCEDURE_SET(BgL_zc3z04anonymousza31973ze3z87_10732, 
(int)(((long)3)), BgL_symbzd2funzd2_147); 
PROCEDURE_SET(BgL_zc3z04anonymousza31973ze3z87_10732, 
(int)(((long)4)), 
BINT(BgL_siza7eza7_151)); 
return BgL_zc3z04anonymousza31973ze3z87_10732;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5602z00_16763;
{ /* Eval/evaluate_comp.scm 896 */
int BgL_arg2031z00_2280;
BgL_arg2031z00_2280 = 
bgl_debug(); 
BgL_test5602z00_16763 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg2031z00_2280), 
BINT(((long)0))); } 
if(BgL_test5602z00_16763)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza31994ze3z87_10733;
BgL_zc3z04anonymousza31994ze3z87_10733 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31994ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31994ze3z87_10733, 
(int)(((long)0)), BgL_funz00_148); 
PROCEDURE_SET(BgL_zc3z04anonymousza31994ze3z87_10733, 
(int)(((long)1)), BgL_a1z00_152); 
PROCEDURE_SET(BgL_zc3z04anonymousza31994ze3z87_10733, 
(int)(((long)2)), BgL_locz00_145); 
PROCEDURE_SET(BgL_zc3z04anonymousza31994ze3z87_10733, 
(int)(((long)3)), BgL_symbzd2funzd2_147); 
PROCEDURE_SET(BgL_zc3z04anonymousza31994ze3z87_10733, 
(int)(((long)4)), 
BINT(BgL_siza7eza7_151)); 
return BgL_zc3z04anonymousza31994ze3z87_10733;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32013ze3z87_10734;
BgL_zc3z04anonymousza32013ze3z87_10734 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32013ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32013ze3z87_10734, 
(int)(((long)0)), BgL_funz00_148); 
PROCEDURE_SET(BgL_zc3z04anonymousza32013ze3z87_10734, 
(int)(((long)1)), BgL_a1z00_152); 
PROCEDURE_SET(BgL_zc3z04anonymousza32013ze3z87_10734, 
(int)(((long)2)), BgL_locz00_145); 
PROCEDURE_SET(BgL_zc3z04anonymousza32013ze3z87_10734, 
(int)(((long)3)), BgL_symbzd2funzd2_147); 
PROCEDURE_SET(BgL_zc3z04anonymousza32013ze3z87_10734, 
(int)(((long)4)), 
BINT(BgL_siza7eza7_151)); 
return BgL_zc3z04anonymousza32013ze3z87_10734;} } } } } 

}



/* &<@anonymous:1948> */
obj_t BGl_z62zc3z04anonymousza31948ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10735, obj_t BgL_sz00_10740)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_a1z00_10736;long BgL_siza7eza7_10737;obj_t BgL_locz00_10738;obj_t BgL_cfunz00_10739;
BgL_a1z00_10736 = 
PROCEDURE_REF(BgL_envz00_10735, 
(int)(((long)0))); 
BgL_siza7eza7_10737 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10735, 
(int)(((long)1)))); 
BgL_locz00_10738 = 
PROCEDURE_REF(BgL_envz00_10735, 
(int)(((long)2))); 
BgL_cfunz00_10739 = 
PROCEDURE_REF(BgL_envz00_10735, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12780;
BgL_bpz00_12780 = 
VECTOR_REF(
((obj_t)BgL_sz00_10740),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_a1z00_12781;
BgL_a1z00_12781 = 
PROCEDURE_ENTRY(BgL_a1z00_10736)(BgL_a1z00_10736, BgL_sz00_10740, BEOA); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_12782;
BgL_nbpz00_12782 = 
(
(long)CINT(BgL_bpz00_12780)+BgL_siza7eza7_10737); 
VECTOR_SET(
((obj_t)BgL_sz00_10740),((long)0),
BINT(BgL_nbpz00_12782)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_16816;
BgL_tmpz00_16816 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_16816, BgL_locz00_10738); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_12783;
BgL_rz00_12783 = 
PROCEDURE_ENTRY(BgL_cfunz00_10739)(BgL_cfunz00_10739, BgL_a1z00_12781, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10740),((long)0),BgL_bpz00_12780); 
return BgL_rz00_12783;} } } } } } 

}



/* &<@anonymous:1950> */
obj_t BGl_z62zc3z04anonymousza31950ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10741, obj_t BgL_sz00_10745)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_a1z00_10742;long BgL_siza7eza7_10743;obj_t BgL_cfunz00_10744;
BgL_a1z00_10742 = 
PROCEDURE_REF(BgL_envz00_10741, 
(int)(((long)0))); 
BgL_siza7eza7_10743 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10741, 
(int)(((long)1)))); 
BgL_cfunz00_10744 = 
PROCEDURE_REF(BgL_envz00_10741, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12784;
BgL_bpz00_12784 = 
VECTOR_REF(
((obj_t)BgL_sz00_10745),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_a1z00_12785;
BgL_a1z00_12785 = 
PROCEDURE_ENTRY(BgL_a1z00_10742)(BgL_a1z00_10742, BgL_sz00_10745, BEOA); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_12786;
BgL_nbpz00_12786 = 
(
(long)CINT(BgL_bpz00_12784)+BgL_siza7eza7_10743); 
VECTOR_SET(
((obj_t)BgL_sz00_10745),((long)0),
BINT(BgL_nbpz00_12786)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_12787;
BgL_rz00_12787 = 
PROCEDURE_ENTRY(BgL_cfunz00_10744)(BgL_cfunz00_10744, BgL_a1z00_12785, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10745),((long)0),BgL_bpz00_12784); 
return BgL_rz00_12787;} } } } } } 

}



/* &<@anonymous:1954> */
obj_t BGl_z62zc3z04anonymousza31954ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10746, obj_t BgL_sz00_10752)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_10747;obj_t BgL_a1z00_10748;obj_t BgL_locz00_10749;obj_t BgL_symbzd2funzd2_10750;long BgL_siza7eza7_10751;
BgL_funz00_10747 = 
PROCEDURE_REF(BgL_envz00_10746, 
(int)(((long)0))); 
BgL_a1z00_10748 = 
PROCEDURE_REF(BgL_envz00_10746, 
(int)(((long)1))); 
BgL_locz00_10749 = 
PROCEDURE_REF(BgL_envz00_10746, 
(int)(((long)2))); 
BgL_symbzd2funzd2_10750 = 
PROCEDURE_REF(BgL_envz00_10746, 
(int)(((long)3))); 
BgL_siza7eza7_10751 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10746, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12788;
BgL_bpz00_12788 = 
VECTOR_REF(
((obj_t)BgL_sz00_10752),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_12789;obj_t BgL_a1z00_12790;
BgL_fz00_12789 = 
PROCEDURE_ENTRY(BgL_funz00_10747)(BgL_funz00_10747, BgL_sz00_10752, BEOA); 
BgL_a1z00_12790 = 
PROCEDURE_ENTRY(BgL_a1z00_10748)(BgL_a1z00_10748, BgL_sz00_10752, BEOA); 
if(
PROCEDUREP(BgL_fz00_12789))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10749, BGl_string5208z00zz__evaluate_compz00, BGl_string5224z00zz__evaluate_compz00, BgL_fz00_12789); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_12791;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_16873;
BgL_tmpz00_16873 = 
((obj_t)BgL_fz00_12789); 
BgL_ufz00_12791 = 
PROCEDURE_ATTR(BgL_tmpz00_16873); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5604z00_16876;
if(
STRUCTP(BgL_ufz00_12791))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5604z00_16876 = 
(
STRUCT_KEY(BgL_ufz00_12791)==BGl_symbol5225z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5604z00_16876 = ((bool_t)0)
; } 
if(BgL_test5604z00_16876)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_12792;obj_t BgL_runz00_12793;obj_t BgL_sfz00_12794;
BgL_arityz00_12792 = 
STRUCT_REF(BgL_ufz00_12791, 
(int)(((long)0))); 
BgL_runz00_12793 = 
STRUCT_REF(BgL_ufz00_12791, 
(int)(((long)1))); 
BgL_sfz00_12794 = 
STRUCT_REF(BgL_ufz00_12791, 
(int)(((long)2))); 
if(
(
(long)CINT(BgL_arityz00_12792)==((long)1)))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg1958z00_12795;
BgL_arg1958z00_12795 = 
(
(long)CINT(BgL_bpz00_12788)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10752),BgL_arg1958z00_12795,BgL_a1z00_12790); }  else 
{ 

if(
INTEGERP(BgL_arityz00_12792))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_12792)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg1960z00_12798;obj_t BgL_arg1961z00_12799;
BgL_arg1960z00_12798 = 
(
(long)CINT(BgL_bpz00_12788)+((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list1962z00_12800;
BgL_list1962z00_12800 = 
MAKE_YOUNG_PAIR(BgL_a1z00_12790, BNIL); 
BgL_arg1961z00_12799 = BgL_list1962z00_12800; } 
VECTOR_SET(
((obj_t)BgL_sz00_10752),BgL_arg1960z00_12798,BgL_arg1961z00_12799); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg1963z00_12801;
BgL_arg1963z00_12801 = 
(
(long)CINT(BgL_bpz00_12788)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10752),BgL_arg1963z00_12801,BgL_a1z00_12790); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg1964z00_12802;obj_t BgL_arg1965z00_12803;
BgL_arg1964z00_12802 = 
(
(long)CINT(BgL_bpz00_12788)+((long)1)); 
BgL_arg1965z00_12803 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10752),BgL_arg1964z00_12802,BgL_arg1965z00_12803); } break;
default: 
BgL_case_else1178z00_12796:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg1967z00_12797;
BgL_arg1967z00_12797 = 
STRUCT_REF(
((obj_t)BgL_ufz00_12791), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10749, BgL_arg1967z00_12797, 
(int)(((long)1)), 
CINT(BgL_arityz00_12792)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1178z00_12796;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_12804;
BgL_z12denvz12_12804 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_12804, BgL_locz00_10749); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10752, BgL_bpz00_12788, BgL_sfz00_12794))
{ /* Eval/evaluate_comp.scm 896 */
return BgL_runz00_12793;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_12805;
BgL_nsz00_12805 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg1969z00_12806;
BgL_arg1969z00_12806 = 
(
(long)CINT(BgL_bpz00_12788)+((long)1)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12805, ((long)2), BgL_sz00_10752, BgL_bpz00_12788, 
BINT(BgL_arg1969z00_12806)); } 
VECTOR_SET(BgL_nsz00_12805,((long)1),BgL_sz00_10752); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12804, BgL_nsz00_12805); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_12807;
BgL_ez00_12807 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12807, BgL_sz00_10752); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_12808;
BgL_____rz00_12808 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12793, BgL_nsz00_12805, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12807); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12804, BgL_sz00_10752); 
return BgL_____rz00_12808;} } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12789, 
(int)(((long)1))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_12809;
BgL_nbpz00_12809 = 
(
(long)CINT(BgL_bpz00_12788)+BgL_siza7eza7_10751); 
VECTOR_SET(
((obj_t)BgL_sz00_10752),((long)0),
BINT(BgL_nbpz00_12809)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_16942;
BgL_tmpz00_16942 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_16942, BgL_locz00_10749); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_12810;
BgL_rz00_12810 = 
PROCEDURE_ENTRY(BgL_fz00_12789)(BgL_fz00_12789, BgL_a1z00_12790, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10752),((long)0),BgL_bpz00_12788); 
return BgL_rz00_12810;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10749, BgL_symbzd2funzd2_10750, 
(int)(((long)1)), 
PROCEDURE_ARITY(BgL_fz00_12789));} } } } } } } } 

}



/* &<@anonymous:1973> */
obj_t BGl_z62zc3z04anonymousza31973ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10753, obj_t BgL_sz00_10759)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_10754;obj_t BgL_a1z00_10755;obj_t BgL_locz00_10756;obj_t BgL_symbzd2funzd2_10757;long BgL_siza7eza7_10758;
BgL_funz00_10754 = 
PROCEDURE_REF(BgL_envz00_10753, 
(int)(((long)0))); 
BgL_a1z00_10755 = 
PROCEDURE_REF(BgL_envz00_10753, 
(int)(((long)1))); 
BgL_locz00_10756 = 
PROCEDURE_REF(BgL_envz00_10753, 
(int)(((long)2))); 
BgL_symbzd2funzd2_10757 = 
PROCEDURE_REF(BgL_envz00_10753, 
(int)(((long)3))); 
BgL_siza7eza7_10758 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10753, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12811;
BgL_bpz00_12811 = 
VECTOR_REF(
((obj_t)BgL_sz00_10759),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_12812;obj_t BgL_a1z00_12813;
BgL_fz00_12812 = 
PROCEDURE_ENTRY(BgL_funz00_10754)(BgL_funz00_10754, BgL_sz00_10759, BEOA); 
BgL_a1z00_12813 = 
PROCEDURE_ENTRY(BgL_a1z00_10755)(BgL_a1z00_10755, BgL_sz00_10759, BEOA); 
if(
PROCEDUREP(BgL_fz00_12812))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10756, BGl_string5208z00zz__evaluate_compz00, BGl_string5224z00zz__evaluate_compz00, BgL_fz00_12812); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_12814;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_16978;
BgL_tmpz00_16978 = 
((obj_t)BgL_fz00_12812); 
BgL_ufz00_12814 = 
PROCEDURE_ATTR(BgL_tmpz00_16978); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5611z00_16981;
if(
STRUCTP(BgL_ufz00_12814))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5611z00_16981 = 
(
STRUCT_KEY(BgL_ufz00_12814)==BGl_symbol5225z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5611z00_16981 = ((bool_t)0)
; } 
if(BgL_test5611z00_16981)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_12815;obj_t BgL_runz00_12816;obj_t BgL_sfz00_12817;
BgL_arityz00_12815 = 
STRUCT_REF(BgL_ufz00_12814, 
(int)(((long)0))); 
BgL_runz00_12816 = 
STRUCT_REF(BgL_ufz00_12814, 
(int)(((long)1))); 
BgL_sfz00_12817 = 
STRUCT_REF(BgL_ufz00_12814, 
(int)(((long)2))); 
if(
(
(long)CINT(BgL_arityz00_12815)==((long)1)))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg1977z00_12818;
BgL_arg1977z00_12818 = 
(
(long)CINT(BgL_bpz00_12811)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10759),BgL_arg1977z00_12818,BgL_a1z00_12813); }  else 
{ 

if(
INTEGERP(BgL_arityz00_12815))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_12815)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg1979z00_12821;obj_t BgL_arg1980z00_12822;
BgL_arg1979z00_12821 = 
(
(long)CINT(BgL_bpz00_12811)+((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list1981z00_12823;
BgL_list1981z00_12823 = 
MAKE_YOUNG_PAIR(BgL_a1z00_12813, BNIL); 
BgL_arg1980z00_12822 = BgL_list1981z00_12823; } 
VECTOR_SET(
((obj_t)BgL_sz00_10759),BgL_arg1979z00_12821,BgL_arg1980z00_12822); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg1982z00_12824;
BgL_arg1982z00_12824 = 
(
(long)CINT(BgL_bpz00_12811)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10759),BgL_arg1982z00_12824,BgL_a1z00_12813); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg1983z00_12825;obj_t BgL_arg1984z00_12826;
BgL_arg1983z00_12825 = 
(
(long)CINT(BgL_bpz00_12811)+((long)1)); 
BgL_arg1984z00_12826 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10759),BgL_arg1983z00_12825,BgL_arg1984z00_12826); } break;
default: 
BgL_case_else1180z00_12819:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg1986z00_12820;
BgL_arg1986z00_12820 = 
STRUCT_REF(
((obj_t)BgL_ufz00_12814), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10756, BgL_arg1986z00_12820, 
(int)(((long)1)), 
CINT(BgL_arityz00_12815)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1180z00_12819;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_12827;
BgL_z12denvz12_12827 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10759, BgL_bpz00_12811, BgL_sfz00_12817))
{ /* Eval/evaluate_comp.scm 896 */
return BgL_runz00_12816;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_12828;
BgL_nsz00_12828 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg1988z00_12829;
BgL_arg1988z00_12829 = 
(
(long)CINT(BgL_bpz00_12811)+((long)1)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12828, ((long)2), BgL_sz00_10759, BgL_bpz00_12811, 
BINT(BgL_arg1988z00_12829)); } 
VECTOR_SET(BgL_nsz00_12828,((long)1),BgL_sz00_10759); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12827, BgL_nsz00_12828); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_12830;
BgL_ez00_12830 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12830, BgL_sz00_10759); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_12831;
BgL_____rz00_12831 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12816, BgL_nsz00_12828, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12830); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12827, BgL_sz00_10759); 
return BgL_____rz00_12831;} } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12812, 
(int)(((long)1))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_12832;
BgL_nbpz00_12832 = 
(
(long)CINT(BgL_bpz00_12811)+BgL_siza7eza7_10758); 
VECTOR_SET(
((obj_t)BgL_sz00_10759),((long)0),
BINT(BgL_nbpz00_12832)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_12833;
BgL_rz00_12833 = 
PROCEDURE_ENTRY(BgL_fz00_12812)(BgL_fz00_12812, BgL_a1z00_12813, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10759),((long)0),BgL_bpz00_12811); 
return BgL_rz00_12833;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10756, BgL_symbzd2funzd2_10757, 
(int)(((long)1)), 
PROCEDURE_ARITY(BgL_fz00_12812));} } } } } } } } 

}



/* &<@anonymous:1994> */
obj_t BGl_z62zc3z04anonymousza31994ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10760, obj_t BgL_sz00_10766)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_10761;obj_t BgL_a1z00_10762;obj_t BgL_locz00_10763;obj_t BgL_symbzd2funzd2_10764;long BgL_siza7eza7_10765;
BgL_funz00_10761 = 
PROCEDURE_REF(BgL_envz00_10760, 
(int)(((long)0))); 
BgL_a1z00_10762 = 
PROCEDURE_REF(BgL_envz00_10760, 
(int)(((long)1))); 
BgL_locz00_10763 = 
PROCEDURE_REF(BgL_envz00_10760, 
(int)(((long)2))); 
BgL_symbzd2funzd2_10764 = 
PROCEDURE_REF(BgL_envz00_10760, 
(int)(((long)3))); 
BgL_siza7eza7_10765 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10760, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12834;
BgL_bpz00_12834 = 
VECTOR_REF(
((obj_t)BgL_sz00_10766),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_12835;obj_t BgL_a1z00_12836;
BgL_fz00_12835 = 
PROCEDURE_ENTRY(BgL_funz00_10761)(BgL_funz00_10761, BgL_sz00_10766, BEOA); 
BgL_a1z00_12836 = 
PROCEDURE_ENTRY(BgL_a1z00_10762)(BgL_a1z00_10762, BgL_sz00_10766, BEOA); 
if(
PROCEDUREP(BgL_fz00_12835))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10763, BGl_string5208z00zz__evaluate_compz00, BGl_string5224z00zz__evaluate_compz00, BgL_fz00_12835); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_12837;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_17079;
BgL_tmpz00_17079 = 
((obj_t)BgL_fz00_12835); 
BgL_ufz00_12837 = 
PROCEDURE_ATTR(BgL_tmpz00_17079); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5618z00_17082;
if(
STRUCTP(BgL_ufz00_12837))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5618z00_17082 = 
(
STRUCT_KEY(BgL_ufz00_12837)==BGl_symbol5225z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5618z00_17082 = ((bool_t)0)
; } 
if(BgL_test5618z00_17082)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_12838;obj_t BgL_runz00_12839;obj_t BgL_sfz00_12840;
BgL_arityz00_12838 = 
STRUCT_REF(BgL_ufz00_12837, 
(int)(((long)0))); 
BgL_runz00_12839 = 
STRUCT_REF(BgL_ufz00_12837, 
(int)(((long)1))); 
BgL_sfz00_12840 = 
STRUCT_REF(BgL_ufz00_12837, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_spz00_12841;
BgL_spz00_12841 = 
(
(long)CINT(BgL_bpz00_12834)+BgL_siza7eza7_10765); 
if(
(
(long)CINT(BgL_arityz00_12838)==((long)1)))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg1998z00_12842;
BgL_arg1998z00_12842 = 
(BgL_spz00_12841+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10766),BgL_arg1998z00_12842,BgL_a1z00_12836); }  else 
{ 

if(
INTEGERP(BgL_arityz00_12838))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_12838)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2000z00_12845;obj_t BgL_arg2001z00_12846;
BgL_arg2000z00_12845 = 
(BgL_spz00_12841+((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2002z00_12847;
BgL_list2002z00_12847 = 
MAKE_YOUNG_PAIR(BgL_a1z00_12836, BNIL); 
BgL_arg2001z00_12846 = BgL_list2002z00_12847; } 
VECTOR_SET(
((obj_t)BgL_sz00_10766),BgL_arg2000z00_12845,BgL_arg2001z00_12846); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2003z00_12848;
BgL_arg2003z00_12848 = 
(BgL_spz00_12841+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10766),BgL_arg2003z00_12848,BgL_a1z00_12836); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2004z00_12849;obj_t BgL_arg2005z00_12850;
BgL_arg2004z00_12849 = 
(BgL_spz00_12841+((long)1)); 
BgL_arg2005z00_12850 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10766),BgL_arg2004z00_12849,BgL_arg2005z00_12850); } break;
default: 
BgL_case_else1182z00_12843:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2007z00_12844;
BgL_arg2007z00_12844 = 
STRUCT_REF(
((obj_t)BgL_ufz00_12837), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10763, BgL_arg2007z00_12844, 
(int)(((long)1)), 
CINT(BgL_arityz00_12838)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1182z00_12843;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_12851;
BgL_z12denvz12_12851 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_12851, BgL_locz00_10763); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10766, 
BINT(BgL_spz00_12841), BgL_sfz00_12840))
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12839, BgL_sz00_10766, 
BINT(BgL_spz00_12841));}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_12852;
BgL_nsz00_12852 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2009z00_12853;
BgL_arg2009z00_12853 = 
(BgL_spz00_12841+((long)1)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12852, ((long)2), BgL_sz00_10766, 
BINT(BgL_spz00_12841), 
BINT(BgL_arg2009z00_12853)); } 
VECTOR_SET(BgL_nsz00_12852,((long)1),BgL_sz00_10766); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12851, BgL_nsz00_12852); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_12854;
BgL_ez00_12854 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12854, BgL_sz00_10766); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_12855;
BgL_____rz00_12855 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12839, BgL_nsz00_12852, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12854); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12851, BgL_sz00_10766); 
return BgL_____rz00_12855;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12835, 
(int)(((long)1))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_12856;
BgL_nbpz00_12856 = 
(
(long)CINT(BgL_bpz00_12834)+BgL_siza7eza7_10765); 
VECTOR_SET(
((obj_t)BgL_sz00_10766),((long)0),
BINT(BgL_nbpz00_12856)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_17149;
BgL_tmpz00_17149 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_17149, BgL_locz00_10763); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_12857;
BgL_rz00_12857 = 
PROCEDURE_ENTRY(BgL_fz00_12835)(BgL_fz00_12835, BgL_a1z00_12836, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10766),((long)0),BgL_bpz00_12834); 
return BgL_rz00_12857;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10763, BgL_symbzd2funzd2_10764, 
(int)(((long)1)), 
PROCEDURE_ARITY(BgL_fz00_12835));} } } } } } } } 

}



/* &<@anonymous:2013> */
obj_t BGl_z62zc3z04anonymousza32013ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10767, obj_t BgL_sz00_10773)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_10768;obj_t BgL_a1z00_10769;obj_t BgL_locz00_10770;obj_t BgL_symbzd2funzd2_10771;long BgL_siza7eza7_10772;
BgL_funz00_10768 = 
PROCEDURE_REF(BgL_envz00_10767, 
(int)(((long)0))); 
BgL_a1z00_10769 = 
PROCEDURE_REF(BgL_envz00_10767, 
(int)(((long)1))); 
BgL_locz00_10770 = 
PROCEDURE_REF(BgL_envz00_10767, 
(int)(((long)2))); 
BgL_symbzd2funzd2_10771 = 
PROCEDURE_REF(BgL_envz00_10767, 
(int)(((long)3))); 
BgL_siza7eza7_10772 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10767, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12858;
BgL_bpz00_12858 = 
VECTOR_REF(
((obj_t)BgL_sz00_10773),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_12859;obj_t BgL_a1z00_12860;
BgL_fz00_12859 = 
PROCEDURE_ENTRY(BgL_funz00_10768)(BgL_funz00_10768, BgL_sz00_10773, BEOA); 
BgL_a1z00_12860 = 
PROCEDURE_ENTRY(BgL_a1z00_10769)(BgL_a1z00_10769, BgL_sz00_10773, BEOA); 
if(
PROCEDUREP(BgL_fz00_12859))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10770, BGl_string5208z00zz__evaluate_compz00, BGl_string5224z00zz__evaluate_compz00, BgL_fz00_12859); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_12861;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_17185;
BgL_tmpz00_17185 = 
((obj_t)BgL_fz00_12859); 
BgL_ufz00_12861 = 
PROCEDURE_ATTR(BgL_tmpz00_17185); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5625z00_17188;
if(
STRUCTP(BgL_ufz00_12861))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5625z00_17188 = 
(
STRUCT_KEY(BgL_ufz00_12861)==BGl_symbol5225z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5625z00_17188 = ((bool_t)0)
; } 
if(BgL_test5625z00_17188)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_12862;obj_t BgL_runz00_12863;obj_t BgL_sfz00_12864;
BgL_arityz00_12862 = 
STRUCT_REF(BgL_ufz00_12861, 
(int)(((long)0))); 
BgL_runz00_12863 = 
STRUCT_REF(BgL_ufz00_12861, 
(int)(((long)1))); 
BgL_sfz00_12864 = 
STRUCT_REF(BgL_ufz00_12861, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_spz00_12865;
BgL_spz00_12865 = 
(
(long)CINT(BgL_bpz00_12858)+BgL_siza7eza7_10772); 
if(
(
(long)CINT(BgL_arityz00_12862)==((long)1)))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2017z00_12866;
BgL_arg2017z00_12866 = 
(BgL_spz00_12865+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10773),BgL_arg2017z00_12866,BgL_a1z00_12860); }  else 
{ 

if(
INTEGERP(BgL_arityz00_12862))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_12862)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2019z00_12869;obj_t BgL_arg2020z00_12870;
BgL_arg2019z00_12869 = 
(BgL_spz00_12865+((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2021z00_12871;
BgL_list2021z00_12871 = 
MAKE_YOUNG_PAIR(BgL_a1z00_12860, BNIL); 
BgL_arg2020z00_12870 = BgL_list2021z00_12871; } 
VECTOR_SET(
((obj_t)BgL_sz00_10773),BgL_arg2019z00_12869,BgL_arg2020z00_12870); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2022z00_12872;
BgL_arg2022z00_12872 = 
(BgL_spz00_12865+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10773),BgL_arg2022z00_12872,BgL_a1z00_12860); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2023z00_12873;obj_t BgL_arg2024z00_12874;
BgL_arg2023z00_12873 = 
(BgL_spz00_12865+((long)1)); 
BgL_arg2024z00_12874 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10773),BgL_arg2023z00_12873,BgL_arg2024z00_12874); } break;
default: 
BgL_case_else1184z00_12867:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2026z00_12868;
BgL_arg2026z00_12868 = 
STRUCT_REF(
((obj_t)BgL_ufz00_12861), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10770, BgL_arg2026z00_12868, 
(int)(((long)1)), 
CINT(BgL_arityz00_12862)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1184z00_12867;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_12875;
BgL_z12denvz12_12875 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10773, 
BINT(BgL_spz00_12865), BgL_sfz00_12864))
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12863, BgL_sz00_10773, 
BINT(BgL_spz00_12865));}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_12876;
BgL_nsz00_12876 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2028z00_12877;
BgL_arg2028z00_12877 = 
(BgL_spz00_12865+((long)1)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12876, ((long)2), BgL_sz00_10773, 
BINT(BgL_spz00_12865), 
BINT(BgL_arg2028z00_12877)); } 
VECTOR_SET(BgL_nsz00_12876,((long)1),BgL_sz00_10773); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12875, BgL_nsz00_12876); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_12878;
BgL_ez00_12878 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12878, BgL_sz00_10773); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_12879;
BgL_____rz00_12879 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12863, BgL_nsz00_12876, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12878); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12875, BgL_sz00_10773); 
return BgL_____rz00_12879;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12859, 
(int)(((long)1))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_12880;
BgL_nbpz00_12880 = 
(
(long)CINT(BgL_bpz00_12858)+BgL_siza7eza7_10772); 
VECTOR_SET(
((obj_t)BgL_sz00_10773),((long)0),
BINT(BgL_nbpz00_12880)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_12881;
BgL_rz00_12881 = 
PROCEDURE_ENTRY(BgL_fz00_12859)(BgL_fz00_12859, BgL_a1z00_12860, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10773),((long)0),BgL_bpz00_12858); 
return BgL_rz00_12881;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10770, BgL_symbzd2funzd2_10771, 
(int)(((long)1)), 
PROCEDURE_ARITY(BgL_fz00_12859));} } } } } } } } 

}



/* comp-call2 */
obj_t BGl_compzd2call2zd2zz__evaluate_compz00(obj_t BgL_locz00_153, BgL_ev_exprz00_bglt BgL_vfunz00_154, obj_t BgL_symbzd2funzd2_155, obj_t BgL_funz00_156, obj_t BgL_tailzf3zf3_157, obj_t BgL_stkz00_158, long BgL_siza7eza7_159, obj_t BgL_a1z00_160, obj_t BgL_a2z00_161)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_cfunz00_2281;
BgL_cfunz00_2281 = 
BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_154, ((long)2), BgL_locz00_153, BgL_symbzd2funzd2_155); 
if(
CBOOL(BgL_cfunz00_2281))
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5632z00_17266;
{ /* Eval/evaluate_comp.scm 896 */
int BgL_arg2037z00_2299;
BgL_arg2037z00_2299 = 
bgl_debug(); 
BgL_test5632z00_17266 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg2037z00_2299), 
BINT(((long)0))); } 
if(BgL_test5632z00_17266)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32034ze3z87_10774;
BgL_zc3z04anonymousza32034ze3z87_10774 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32034ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32034ze3z87_10774, 
(int)(((long)0)), BgL_a1z00_160); 
PROCEDURE_SET(BgL_zc3z04anonymousza32034ze3z87_10774, 
(int)(((long)1)), BgL_a2z00_161); 
PROCEDURE_SET(BgL_zc3z04anonymousza32034ze3z87_10774, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_159)); 
PROCEDURE_SET(BgL_zc3z04anonymousza32034ze3z87_10774, 
(int)(((long)3)), BgL_locz00_153); 
PROCEDURE_SET(BgL_zc3z04anonymousza32034ze3z87_10774, 
(int)(((long)4)), BgL_cfunz00_2281); 
return BgL_zc3z04anonymousza32034ze3z87_10774;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32036ze3z87_10775;
BgL_zc3z04anonymousza32036ze3z87_10775 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32036ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32036ze3z87_10775, 
(int)(((long)0)), BgL_a1z00_160); 
PROCEDURE_SET(BgL_zc3z04anonymousza32036ze3z87_10775, 
(int)(((long)1)), BgL_a2z00_161); 
PROCEDURE_SET(BgL_zc3z04anonymousza32036ze3z87_10775, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_159)); 
PROCEDURE_SET(BgL_zc3z04anonymousza32036ze3z87_10775, 
(int)(((long)3)), BgL_cfunz00_2281); 
return BgL_zc3z04anonymousza32036ze3z87_10775;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
CBOOL(BgL_tailzf3zf3_157))
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5634z00_17299;
{ /* Eval/evaluate_comp.scm 896 */
int BgL_arg2091z00_2391;
BgL_arg2091z00_2391 = 
bgl_debug(); 
BgL_test5634z00_17299 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg2091z00_2391), 
BINT(((long)0))); } 
if(BgL_test5634z00_17299)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32040ze3z87_10776;
BgL_zc3z04anonymousza32040ze3z87_10776 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32040ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32040ze3z87_10776, 
(int)(((long)0)), BgL_funz00_156); 
PROCEDURE_SET(BgL_zc3z04anonymousza32040ze3z87_10776, 
(int)(((long)1)), BgL_a1z00_160); 
PROCEDURE_SET(BgL_zc3z04anonymousza32040ze3z87_10776, 
(int)(((long)2)), BgL_a2z00_161); 
PROCEDURE_SET(BgL_zc3z04anonymousza32040ze3z87_10776, 
(int)(((long)3)), BgL_locz00_153); 
PROCEDURE_SET(BgL_zc3z04anonymousza32040ze3z87_10776, 
(int)(((long)4)), BgL_symbzd2funzd2_155); 
PROCEDURE_SET(BgL_zc3z04anonymousza32040ze3z87_10776, 
(int)(((long)5)), 
BINT(BgL_siza7eza7_159)); 
return BgL_zc3z04anonymousza32040ze3z87_10776;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32066ze3z87_10777;
BgL_zc3z04anonymousza32066ze3z87_10777 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32066ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32066ze3z87_10777, 
(int)(((long)0)), BgL_funz00_156); 
PROCEDURE_SET(BgL_zc3z04anonymousza32066ze3z87_10777, 
(int)(((long)1)), BgL_a1z00_160); 
PROCEDURE_SET(BgL_zc3z04anonymousza32066ze3z87_10777, 
(int)(((long)2)), BgL_a2z00_161); 
PROCEDURE_SET(BgL_zc3z04anonymousza32066ze3z87_10777, 
(int)(((long)3)), BgL_locz00_153); 
PROCEDURE_SET(BgL_zc3z04anonymousza32066ze3z87_10777, 
(int)(((long)4)), BgL_symbzd2funzd2_155); 
PROCEDURE_SET(BgL_zc3z04anonymousza32066ze3z87_10777, 
(int)(((long)5)), 
BINT(BgL_siza7eza7_159)); 
return BgL_zc3z04anonymousza32066ze3z87_10777;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5635z00_17336;
{ /* Eval/evaluate_comp.scm 896 */
int BgL_arg2146z00_2483;
BgL_arg2146z00_2483 = 
bgl_debug(); 
BgL_test5635z00_17336 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg2146z00_2483), 
BINT(((long)0))); } 
if(BgL_test5635z00_17336)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32094ze3z87_10778;
BgL_zc3z04anonymousza32094ze3z87_10778 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32094ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32094ze3z87_10778, 
(int)(((long)0)), BgL_funz00_156); 
PROCEDURE_SET(BgL_zc3z04anonymousza32094ze3z87_10778, 
(int)(((long)1)), BgL_a1z00_160); 
PROCEDURE_SET(BgL_zc3z04anonymousza32094ze3z87_10778, 
(int)(((long)2)), BgL_a2z00_161); 
PROCEDURE_SET(BgL_zc3z04anonymousza32094ze3z87_10778, 
(int)(((long)3)), BgL_locz00_153); 
PROCEDURE_SET(BgL_zc3z04anonymousza32094ze3z87_10778, 
(int)(((long)4)), BgL_symbzd2funzd2_155); 
PROCEDURE_SET(BgL_zc3z04anonymousza32094ze3z87_10778, 
(int)(((long)5)), 
BINT(BgL_siza7eza7_159)); 
return BgL_zc3z04anonymousza32094ze3z87_10778;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32120ze3z87_10779;
BgL_zc3z04anonymousza32120ze3z87_10779 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32120ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32120ze3z87_10779, 
(int)(((long)0)), BgL_funz00_156); 
PROCEDURE_SET(BgL_zc3z04anonymousza32120ze3z87_10779, 
(int)(((long)1)), BgL_a1z00_160); 
PROCEDURE_SET(BgL_zc3z04anonymousza32120ze3z87_10779, 
(int)(((long)2)), BgL_a2z00_161); 
PROCEDURE_SET(BgL_zc3z04anonymousza32120ze3z87_10779, 
(int)(((long)3)), BgL_locz00_153); 
PROCEDURE_SET(BgL_zc3z04anonymousza32120ze3z87_10779, 
(int)(((long)4)), BgL_symbzd2funzd2_155); 
PROCEDURE_SET(BgL_zc3z04anonymousza32120ze3z87_10779, 
(int)(((long)5)), 
BINT(BgL_siza7eza7_159)); 
return BgL_zc3z04anonymousza32120ze3z87_10779;} } } } } 

}



/* &<@anonymous:2034> */
obj_t BGl_z62zc3z04anonymousza32034ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10780, obj_t BgL_sz00_10786)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_a1z00_10781;obj_t BgL_a2z00_10782;long BgL_siza7eza7_10783;obj_t BgL_locz00_10784;obj_t BgL_cfunz00_10785;
BgL_a1z00_10781 = 
PROCEDURE_REF(BgL_envz00_10780, 
(int)(((long)0))); 
BgL_a2z00_10782 = 
PROCEDURE_REF(BgL_envz00_10780, 
(int)(((long)1))); 
BgL_siza7eza7_10783 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10780, 
(int)(((long)2)))); 
BgL_locz00_10784 = 
PROCEDURE_REF(BgL_envz00_10780, 
(int)(((long)3))); 
BgL_cfunz00_10785 = 
PROCEDURE_REF(BgL_envz00_10780, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12882;
BgL_bpz00_12882 = 
VECTOR_REF(
((obj_t)BgL_sz00_10786),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_a1z00_12883;obj_t BgL_a2z00_12884;
BgL_a1z00_12883 = 
PROCEDURE_ENTRY(BgL_a1z00_10781)(BgL_a1z00_10781, BgL_sz00_10786, BEOA); 
BgL_a2z00_12884 = 
PROCEDURE_ENTRY(BgL_a2z00_10782)(BgL_a2z00_10782, BgL_sz00_10786, BEOA); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_12885;
BgL_nbpz00_12885 = 
(
(long)CINT(BgL_bpz00_12882)+BgL_siza7eza7_10783); 
VECTOR_SET(
((obj_t)BgL_sz00_10786),((long)0),
BINT(BgL_nbpz00_12885)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_17399;
BgL_tmpz00_17399 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_17399, BgL_locz00_10784); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_12886;
BgL_rz00_12886 = 
PROCEDURE_ENTRY(BgL_cfunz00_10785)(BgL_cfunz00_10785, BgL_a1z00_12883, BgL_a2z00_12884, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10786),((long)0),BgL_bpz00_12882); 
return BgL_rz00_12886;} } } } } } 

}



/* &<@anonymous:2036> */
obj_t BGl_z62zc3z04anonymousza32036ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10787, obj_t BgL_sz00_10792)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_a1z00_10788;obj_t BgL_a2z00_10789;long BgL_siza7eza7_10790;obj_t BgL_cfunz00_10791;
BgL_a1z00_10788 = 
PROCEDURE_REF(BgL_envz00_10787, 
(int)(((long)0))); 
BgL_a2z00_10789 = 
PROCEDURE_REF(BgL_envz00_10787, 
(int)(((long)1))); 
BgL_siza7eza7_10790 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10787, 
(int)(((long)2)))); 
BgL_cfunz00_10791 = 
PROCEDURE_REF(BgL_envz00_10787, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12887;
BgL_bpz00_12887 = 
VECTOR_REF(
((obj_t)BgL_sz00_10792),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_a1z00_12888;obj_t BgL_a2z00_12889;
BgL_a1z00_12888 = 
PROCEDURE_ENTRY(BgL_a1z00_10788)(BgL_a1z00_10788, BgL_sz00_10792, BEOA); 
BgL_a2z00_12889 = 
PROCEDURE_ENTRY(BgL_a2z00_10789)(BgL_a2z00_10789, BgL_sz00_10792, BEOA); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_12890;
BgL_nbpz00_12890 = 
(
(long)CINT(BgL_bpz00_12887)+BgL_siza7eza7_10790); 
VECTOR_SET(
((obj_t)BgL_sz00_10792),((long)0),
BINT(BgL_nbpz00_12890)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_12891;
BgL_rz00_12891 = 
PROCEDURE_ENTRY(BgL_cfunz00_10791)(BgL_cfunz00_10791, BgL_a1z00_12888, BgL_a2z00_12889, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10792),((long)0),BgL_bpz00_12887); 
return BgL_rz00_12891;} } } } } } 

}



/* &<@anonymous:2040> */
obj_t BGl_z62zc3z04anonymousza32040ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10793, obj_t BgL_sz00_10800)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_10794;obj_t BgL_a1z00_10795;obj_t BgL_a2z00_10796;obj_t BgL_locz00_10797;obj_t BgL_symbzd2funzd2_10798;long BgL_siza7eza7_10799;
BgL_funz00_10794 = 
PROCEDURE_REF(BgL_envz00_10793, 
(int)(((long)0))); 
BgL_a1z00_10795 = 
PROCEDURE_REF(BgL_envz00_10793, 
(int)(((long)1))); 
BgL_a2z00_10796 = 
PROCEDURE_REF(BgL_envz00_10793, 
(int)(((long)2))); 
BgL_locz00_10797 = 
PROCEDURE_REF(BgL_envz00_10793, 
(int)(((long)3))); 
BgL_symbzd2funzd2_10798 = 
PROCEDURE_REF(BgL_envz00_10793, 
(int)(((long)4))); 
BgL_siza7eza7_10799 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10793, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12892;
BgL_bpz00_12892 = 
VECTOR_REF(
((obj_t)BgL_sz00_10800),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_12893;obj_t BgL_a1z00_12894;obj_t BgL_a2z00_12895;
BgL_fz00_12893 = 
PROCEDURE_ENTRY(BgL_funz00_10794)(BgL_funz00_10794, BgL_sz00_10800, BEOA); 
BgL_a1z00_12894 = 
PROCEDURE_ENTRY(BgL_a1z00_10795)(BgL_a1z00_10795, BgL_sz00_10800, BEOA); 
BgL_a2z00_12895 = 
PROCEDURE_ENTRY(BgL_a2z00_10796)(BgL_a2z00_10796, BgL_sz00_10800, BEOA); 
if(
PROCEDUREP(BgL_fz00_12893))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10797, BGl_string5208z00zz__evaluate_compz00, BGl_string5224z00zz__evaluate_compz00, BgL_fz00_12893); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_12896;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_17470;
BgL_tmpz00_17470 = 
((obj_t)BgL_fz00_12893); 
BgL_ufz00_12896 = 
PROCEDURE_ATTR(BgL_tmpz00_17470); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5637z00_17473;
if(
STRUCTP(BgL_ufz00_12896))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5637z00_17473 = 
(
STRUCT_KEY(BgL_ufz00_12896)==BGl_symbol5225z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5637z00_17473 = ((bool_t)0)
; } 
if(BgL_test5637z00_17473)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_12897;obj_t BgL_runz00_12898;obj_t BgL_sfz00_12899;
BgL_arityz00_12897 = 
STRUCT_REF(BgL_ufz00_12896, 
(int)(((long)0))); 
BgL_runz00_12898 = 
STRUCT_REF(BgL_ufz00_12896, 
(int)(((long)1))); 
BgL_sfz00_12899 = 
STRUCT_REF(BgL_ufz00_12896, 
(int)(((long)2))); 
if(
(
(long)CINT(BgL_arityz00_12897)==((long)2)))
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2044z00_12900;
BgL_arg2044z00_12900 = 
(
(long)CINT(BgL_bpz00_12892)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10800),BgL_arg2044z00_12900,BgL_a1z00_12894); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2045z00_12901;
BgL_arg2045z00_12901 = 
(
(long)CINT(BgL_bpz00_12892)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10800),BgL_arg2045z00_12901,BgL_a2z00_12895); } }  else 
{ 

if(
INTEGERP(BgL_arityz00_12897))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_12897)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2047z00_12904;obj_t BgL_arg2048z00_12905;
BgL_arg2047z00_12904 = 
(
(long)CINT(BgL_bpz00_12892)+((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2049z00_12906;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2050z00_12907;
BgL_arg2050z00_12907 = 
MAKE_YOUNG_PAIR(BgL_a2z00_12895, BNIL); 
BgL_list2049z00_12906 = 
MAKE_YOUNG_PAIR(BgL_a1z00_12894, BgL_arg2050z00_12907); } 
BgL_arg2048z00_12905 = BgL_list2049z00_12906; } 
VECTOR_SET(
((obj_t)BgL_sz00_10800),BgL_arg2047z00_12904,BgL_arg2048z00_12905); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2051z00_12908;
BgL_arg2051z00_12908 = 
(
(long)CINT(BgL_bpz00_12892)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10800),BgL_arg2051z00_12908,BgL_a1z00_12894); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2052z00_12909;obj_t BgL_arg2053z00_12910;
BgL_arg2052z00_12909 = 
(
(long)CINT(BgL_bpz00_12892)+((long)1)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2054z00_12911;
BgL_list2054z00_12911 = 
MAKE_YOUNG_PAIR(BgL_a2z00_12895, BNIL); 
BgL_arg2053z00_12910 = BgL_list2054z00_12911; } 
VECTOR_SET(
((obj_t)BgL_sz00_10800),BgL_arg2052z00_12909,BgL_arg2053z00_12910); } break;case ((long)-3) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2055z00_12912;
BgL_arg2055z00_12912 = 
(
(long)CINT(BgL_bpz00_12892)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10800),BgL_arg2055z00_12912,BgL_a1z00_12894); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2056z00_12913;
BgL_arg2056z00_12913 = 
(
(long)CINT(BgL_bpz00_12892)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10800),BgL_arg2056z00_12913,BgL_a2z00_12895); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2057z00_12914;obj_t BgL_arg2058z00_12915;
BgL_arg2057z00_12914 = 
(
(long)CINT(BgL_bpz00_12892)+((long)2)); 
BgL_arg2058z00_12915 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10800),BgL_arg2057z00_12914,BgL_arg2058z00_12915); } break;
default: 
BgL_case_else1186z00_12902:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2060z00_12903;
BgL_arg2060z00_12903 = 
STRUCT_REF(
((obj_t)BgL_ufz00_12896), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10797, BgL_arg2060z00_12903, 
(int)(((long)2)), 
CINT(BgL_arityz00_12897)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1186z00_12902;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_12916;
BgL_z12denvz12_12916 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_12916, BgL_locz00_10797); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10800, BgL_bpz00_12892, BgL_sfz00_12899))
{ /* Eval/evaluate_comp.scm 896 */
return BgL_runz00_12898;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_12917;
BgL_nsz00_12917 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2062z00_12918;
BgL_arg2062z00_12918 = 
(
(long)CINT(BgL_bpz00_12892)+((long)2)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12917, ((long)2), BgL_sz00_10800, BgL_bpz00_12892, 
BINT(BgL_arg2062z00_12918)); } 
VECTOR_SET(BgL_nsz00_12917,((long)1),BgL_sz00_10800); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12916, BgL_nsz00_12917); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_12919;
BgL_ez00_12919 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12919, BgL_sz00_10800); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_12920;
BgL_____rz00_12920 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12898, BgL_nsz00_12917, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12919); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12916, BgL_sz00_10800); 
return BgL_____rz00_12920;} } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12893, 
(int)(((long)2))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_12921;
BgL_nbpz00_12921 = 
(
(long)CINT(BgL_bpz00_12892)+BgL_siza7eza7_10799); 
VECTOR_SET(
((obj_t)BgL_sz00_10800),((long)0),
BINT(BgL_nbpz00_12921)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_17557;
BgL_tmpz00_17557 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_17557, BgL_locz00_10797); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_12922;
BgL_rz00_12922 = 
PROCEDURE_ENTRY(BgL_fz00_12893)(BgL_fz00_12893, BgL_a1z00_12894, BgL_a2z00_12895, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10800),((long)0),BgL_bpz00_12892); 
return BgL_rz00_12922;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10797, BgL_symbzd2funzd2_10798, 
(int)(((long)2)), 
PROCEDURE_ARITY(BgL_fz00_12893));} } } } } } } } 

}



/* &<@anonymous:2066> */
obj_t BGl_z62zc3z04anonymousza32066ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10801, obj_t BgL_sz00_10808)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_10802;obj_t BgL_a1z00_10803;obj_t BgL_a2z00_10804;obj_t BgL_locz00_10805;obj_t BgL_symbzd2funzd2_10806;long BgL_siza7eza7_10807;
BgL_funz00_10802 = 
PROCEDURE_REF(BgL_envz00_10801, 
(int)(((long)0))); 
BgL_a1z00_10803 = 
PROCEDURE_REF(BgL_envz00_10801, 
(int)(((long)1))); 
BgL_a2z00_10804 = 
PROCEDURE_REF(BgL_envz00_10801, 
(int)(((long)2))); 
BgL_locz00_10805 = 
PROCEDURE_REF(BgL_envz00_10801, 
(int)(((long)3))); 
BgL_symbzd2funzd2_10806 = 
PROCEDURE_REF(BgL_envz00_10801, 
(int)(((long)4))); 
BgL_siza7eza7_10807 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10801, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12923;
BgL_bpz00_12923 = 
VECTOR_REF(
((obj_t)BgL_sz00_10808),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_12924;obj_t BgL_a1z00_12925;obj_t BgL_a2z00_12926;
BgL_fz00_12924 = 
PROCEDURE_ENTRY(BgL_funz00_10802)(BgL_funz00_10802, BgL_sz00_10808, BEOA); 
BgL_a1z00_12925 = 
PROCEDURE_ENTRY(BgL_a1z00_10803)(BgL_a1z00_10803, BgL_sz00_10808, BEOA); 
BgL_a2z00_12926 = 
PROCEDURE_ENTRY(BgL_a2z00_10804)(BgL_a2z00_10804, BgL_sz00_10808, BEOA); 
if(
PROCEDUREP(BgL_fz00_12924))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10805, BGl_string5208z00zz__evaluate_compz00, BGl_string5224z00zz__evaluate_compz00, BgL_fz00_12924); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_12927;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_17600;
BgL_tmpz00_17600 = 
((obj_t)BgL_fz00_12924); 
BgL_ufz00_12927 = 
PROCEDURE_ATTR(BgL_tmpz00_17600); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5644z00_17603;
if(
STRUCTP(BgL_ufz00_12927))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5644z00_17603 = 
(
STRUCT_KEY(BgL_ufz00_12927)==BGl_symbol5225z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5644z00_17603 = ((bool_t)0)
; } 
if(BgL_test5644z00_17603)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_12928;obj_t BgL_runz00_12929;obj_t BgL_sfz00_12930;
BgL_arityz00_12928 = 
STRUCT_REF(BgL_ufz00_12927, 
(int)(((long)0))); 
BgL_runz00_12929 = 
STRUCT_REF(BgL_ufz00_12927, 
(int)(((long)1))); 
BgL_sfz00_12930 = 
STRUCT_REF(BgL_ufz00_12927, 
(int)(((long)2))); 
if(
(
(long)CINT(BgL_arityz00_12928)==((long)2)))
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2070z00_12931;
BgL_arg2070z00_12931 = 
(
(long)CINT(BgL_bpz00_12923)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10808),BgL_arg2070z00_12931,BgL_a1z00_12925); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2071z00_12932;
BgL_arg2071z00_12932 = 
(
(long)CINT(BgL_bpz00_12923)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10808),BgL_arg2071z00_12932,BgL_a2z00_12926); } }  else 
{ 

if(
INTEGERP(BgL_arityz00_12928))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_12928)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2073z00_12935;obj_t BgL_arg2074z00_12936;
BgL_arg2073z00_12935 = 
(
(long)CINT(BgL_bpz00_12923)+((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2075z00_12937;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2076z00_12938;
BgL_arg2076z00_12938 = 
MAKE_YOUNG_PAIR(BgL_a2z00_12926, BNIL); 
BgL_list2075z00_12937 = 
MAKE_YOUNG_PAIR(BgL_a1z00_12925, BgL_arg2076z00_12938); } 
BgL_arg2074z00_12936 = BgL_list2075z00_12937; } 
VECTOR_SET(
((obj_t)BgL_sz00_10808),BgL_arg2073z00_12935,BgL_arg2074z00_12936); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2077z00_12939;
BgL_arg2077z00_12939 = 
(
(long)CINT(BgL_bpz00_12923)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10808),BgL_arg2077z00_12939,BgL_a1z00_12925); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2078z00_12940;obj_t BgL_arg2079z00_12941;
BgL_arg2078z00_12940 = 
(
(long)CINT(BgL_bpz00_12923)+((long)1)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2080z00_12942;
BgL_list2080z00_12942 = 
MAKE_YOUNG_PAIR(BgL_a2z00_12926, BNIL); 
BgL_arg2079z00_12941 = BgL_list2080z00_12942; } 
VECTOR_SET(
((obj_t)BgL_sz00_10808),BgL_arg2078z00_12940,BgL_arg2079z00_12941); } break;case ((long)-3) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2081z00_12943;
BgL_arg2081z00_12943 = 
(
(long)CINT(BgL_bpz00_12923)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10808),BgL_arg2081z00_12943,BgL_a1z00_12925); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2082z00_12944;
BgL_arg2082z00_12944 = 
(
(long)CINT(BgL_bpz00_12923)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10808),BgL_arg2082z00_12944,BgL_a2z00_12926); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2083z00_12945;obj_t BgL_arg2084z00_12946;
BgL_arg2083z00_12945 = 
(
(long)CINT(BgL_bpz00_12923)+((long)2)); 
BgL_arg2084z00_12946 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10808),BgL_arg2083z00_12945,BgL_arg2084z00_12946); } break;
default: 
BgL_case_else1188z00_12933:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2086z00_12934;
BgL_arg2086z00_12934 = 
STRUCT_REF(
((obj_t)BgL_ufz00_12927), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10805, BgL_arg2086z00_12934, 
(int)(((long)2)), 
CINT(BgL_arityz00_12928)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1188z00_12933;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_12947;
BgL_z12denvz12_12947 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10808, BgL_bpz00_12923, BgL_sfz00_12930))
{ /* Eval/evaluate_comp.scm 896 */
return BgL_runz00_12929;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_12948;
BgL_nsz00_12948 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2088z00_12949;
BgL_arg2088z00_12949 = 
(
(long)CINT(BgL_bpz00_12923)+((long)2)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12948, ((long)2), BgL_sz00_10808, BgL_bpz00_12923, 
BINT(BgL_arg2088z00_12949)); } 
VECTOR_SET(BgL_nsz00_12948,((long)1),BgL_sz00_10808); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12947, BgL_nsz00_12948); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_12950;
BgL_ez00_12950 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12950, BgL_sz00_10808); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_12951;
BgL_____rz00_12951 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12929, BgL_nsz00_12948, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12950); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12947, BgL_sz00_10808); 
return BgL_____rz00_12951;} } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12924, 
(int)(((long)2))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_12952;
BgL_nbpz00_12952 = 
(
(long)CINT(BgL_bpz00_12923)+BgL_siza7eza7_10807); 
VECTOR_SET(
((obj_t)BgL_sz00_10808),((long)0),
BINT(BgL_nbpz00_12952)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_12953;
BgL_rz00_12953 = 
PROCEDURE_ENTRY(BgL_fz00_12924)(BgL_fz00_12924, BgL_a1z00_12925, BgL_a2z00_12926, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10808),((long)0),BgL_bpz00_12923); 
return BgL_rz00_12953;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10805, BgL_symbzd2funzd2_10806, 
(int)(((long)2)), 
PROCEDURE_ARITY(BgL_fz00_12924));} } } } } } } } 

}



/* &<@anonymous:2094> */
obj_t BGl_z62zc3z04anonymousza32094ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10809, obj_t BgL_sz00_10816)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_10810;obj_t BgL_a1z00_10811;obj_t BgL_a2z00_10812;obj_t BgL_locz00_10813;obj_t BgL_symbzd2funzd2_10814;long BgL_siza7eza7_10815;
BgL_funz00_10810 = 
PROCEDURE_REF(BgL_envz00_10809, 
(int)(((long)0))); 
BgL_a1z00_10811 = 
PROCEDURE_REF(BgL_envz00_10809, 
(int)(((long)1))); 
BgL_a2z00_10812 = 
PROCEDURE_REF(BgL_envz00_10809, 
(int)(((long)2))); 
BgL_locz00_10813 = 
PROCEDURE_REF(BgL_envz00_10809, 
(int)(((long)3))); 
BgL_symbzd2funzd2_10814 = 
PROCEDURE_REF(BgL_envz00_10809, 
(int)(((long)4))); 
BgL_siza7eza7_10815 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10809, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12954;
BgL_bpz00_12954 = 
VECTOR_REF(
((obj_t)BgL_sz00_10816),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_12955;obj_t BgL_a1z00_12956;obj_t BgL_a2z00_12957;
BgL_fz00_12955 = 
PROCEDURE_ENTRY(BgL_funz00_10810)(BgL_funz00_10810, BgL_sz00_10816, BEOA); 
BgL_a1z00_12956 = 
PROCEDURE_ENTRY(BgL_a1z00_10811)(BgL_a1z00_10811, BgL_sz00_10816, BEOA); 
BgL_a2z00_12957 = 
PROCEDURE_ENTRY(BgL_a2z00_10812)(BgL_a2z00_10812, BgL_sz00_10816, BEOA); 
if(
PROCEDUREP(BgL_fz00_12955))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10813, BGl_string5208z00zz__evaluate_compz00, BGl_string5224z00zz__evaluate_compz00, BgL_fz00_12955); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_12958;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_17726;
BgL_tmpz00_17726 = 
((obj_t)BgL_fz00_12955); 
BgL_ufz00_12958 = 
PROCEDURE_ATTR(BgL_tmpz00_17726); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5651z00_17729;
if(
STRUCTP(BgL_ufz00_12958))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5651z00_17729 = 
(
STRUCT_KEY(BgL_ufz00_12958)==BGl_symbol5225z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5651z00_17729 = ((bool_t)0)
; } 
if(BgL_test5651z00_17729)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_12959;obj_t BgL_runz00_12960;obj_t BgL_sfz00_12961;
BgL_arityz00_12959 = 
STRUCT_REF(BgL_ufz00_12958, 
(int)(((long)0))); 
BgL_runz00_12960 = 
STRUCT_REF(BgL_ufz00_12958, 
(int)(((long)1))); 
BgL_sfz00_12961 = 
STRUCT_REF(BgL_ufz00_12958, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_spz00_12962;
BgL_spz00_12962 = 
(
(long)CINT(BgL_bpz00_12954)+BgL_siza7eza7_10815); 
if(
(
(long)CINT(BgL_arityz00_12959)==((long)2)))
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2098z00_12963;
BgL_arg2098z00_12963 = 
(BgL_spz00_12962+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10816),BgL_arg2098z00_12963,BgL_a1z00_12956); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2099z00_12964;
BgL_arg2099z00_12964 = 
(BgL_spz00_12962+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10816),BgL_arg2099z00_12964,BgL_a2z00_12957); } }  else 
{ 

if(
INTEGERP(BgL_arityz00_12959))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_12959)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2101z00_12967;obj_t BgL_arg2102z00_12968;
BgL_arg2101z00_12967 = 
(BgL_spz00_12962+((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2103z00_12969;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2104z00_12970;
BgL_arg2104z00_12970 = 
MAKE_YOUNG_PAIR(BgL_a2z00_12957, BNIL); 
BgL_list2103z00_12969 = 
MAKE_YOUNG_PAIR(BgL_a1z00_12956, BgL_arg2104z00_12970); } 
BgL_arg2102z00_12968 = BgL_list2103z00_12969; } 
VECTOR_SET(
((obj_t)BgL_sz00_10816),BgL_arg2101z00_12967,BgL_arg2102z00_12968); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2105z00_12971;
BgL_arg2105z00_12971 = 
(BgL_spz00_12962+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10816),BgL_arg2105z00_12971,BgL_a1z00_12956); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2106z00_12972;obj_t BgL_arg2107z00_12973;
BgL_arg2106z00_12972 = 
(BgL_spz00_12962+((long)1)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2108z00_12974;
BgL_list2108z00_12974 = 
MAKE_YOUNG_PAIR(BgL_a2z00_12957, BNIL); 
BgL_arg2107z00_12973 = BgL_list2108z00_12974; } 
VECTOR_SET(
((obj_t)BgL_sz00_10816),BgL_arg2106z00_12972,BgL_arg2107z00_12973); } break;case ((long)-3) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2109z00_12975;
BgL_arg2109z00_12975 = 
(BgL_spz00_12962+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10816),BgL_arg2109z00_12975,BgL_a1z00_12956); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2110z00_12976;
BgL_arg2110z00_12976 = 
(BgL_spz00_12962+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10816),BgL_arg2110z00_12976,BgL_a2z00_12957); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2111z00_12977;obj_t BgL_arg2112z00_12978;
BgL_arg2111z00_12977 = 
(BgL_spz00_12962+((long)2)); 
BgL_arg2112z00_12978 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10816),BgL_arg2111z00_12977,BgL_arg2112z00_12978); } break;
default: 
BgL_case_else1190z00_12965:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2114z00_12966;
BgL_arg2114z00_12966 = 
STRUCT_REF(
((obj_t)BgL_ufz00_12958), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10813, BgL_arg2114z00_12966, 
(int)(((long)2)), 
CINT(BgL_arityz00_12959)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1190z00_12965;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_12979;
BgL_z12denvz12_12979 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_12979, BgL_locz00_10813); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10816, 
BINT(BgL_spz00_12962), BgL_sfz00_12961))
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12960, BgL_sz00_10816, 
BINT(BgL_spz00_12962));}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_12980;
BgL_nsz00_12980 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2116z00_12981;
BgL_arg2116z00_12981 = 
(BgL_spz00_12962+((long)2)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12980, ((long)2), BgL_sz00_10816, 
BINT(BgL_spz00_12962), 
BINT(BgL_arg2116z00_12981)); } 
VECTOR_SET(BgL_nsz00_12980,((long)1),BgL_sz00_10816); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12979, BgL_nsz00_12980); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_12982;
BgL_ez00_12982 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12982, BgL_sz00_10816); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_12983;
BgL_____rz00_12983 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12960, BgL_nsz00_12980, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12982); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12979, BgL_sz00_10816); 
return BgL_____rz00_12983;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12955, 
(int)(((long)2))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_12984;
BgL_nbpz00_12984 = 
(
(long)CINT(BgL_bpz00_12954)+BgL_siza7eza7_10815); 
VECTOR_SET(
((obj_t)BgL_sz00_10816),((long)0),
BINT(BgL_nbpz00_12984)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_17810;
BgL_tmpz00_17810 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_17810, BgL_locz00_10813); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_12985;
BgL_rz00_12985 = 
PROCEDURE_ENTRY(BgL_fz00_12955)(BgL_fz00_12955, BgL_a1z00_12956, BgL_a2z00_12957, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10816),((long)0),BgL_bpz00_12954); 
return BgL_rz00_12985;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10813, BgL_symbzd2funzd2_10814, 
(int)(((long)2)), 
PROCEDURE_ARITY(BgL_fz00_12955));} } } } } } } } 

}



/* &<@anonymous:2120> */
obj_t BGl_z62zc3z04anonymousza32120ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10817, obj_t BgL_sz00_10824)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_10818;obj_t BgL_a1z00_10819;obj_t BgL_a2z00_10820;obj_t BgL_locz00_10821;obj_t BgL_symbzd2funzd2_10822;long BgL_siza7eza7_10823;
BgL_funz00_10818 = 
PROCEDURE_REF(BgL_envz00_10817, 
(int)(((long)0))); 
BgL_a1z00_10819 = 
PROCEDURE_REF(BgL_envz00_10817, 
(int)(((long)1))); 
BgL_a2z00_10820 = 
PROCEDURE_REF(BgL_envz00_10817, 
(int)(((long)2))); 
BgL_locz00_10821 = 
PROCEDURE_REF(BgL_envz00_10817, 
(int)(((long)3))); 
BgL_symbzd2funzd2_10822 = 
PROCEDURE_REF(BgL_envz00_10817, 
(int)(((long)4))); 
BgL_siza7eza7_10823 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10817, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12986;
BgL_bpz00_12986 = 
VECTOR_REF(
((obj_t)BgL_sz00_10824),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_12987;obj_t BgL_a1z00_12988;obj_t BgL_a2z00_12989;
BgL_fz00_12987 = 
PROCEDURE_ENTRY(BgL_funz00_10818)(BgL_funz00_10818, BgL_sz00_10824, BEOA); 
BgL_a1z00_12988 = 
PROCEDURE_ENTRY(BgL_a1z00_10819)(BgL_a1z00_10819, BgL_sz00_10824, BEOA); 
BgL_a2z00_12989 = 
PROCEDURE_ENTRY(BgL_a2z00_10820)(BgL_a2z00_10820, BgL_sz00_10824, BEOA); 
if(
PROCEDUREP(BgL_fz00_12987))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10821, BGl_string5208z00zz__evaluate_compz00, BGl_string5224z00zz__evaluate_compz00, BgL_fz00_12987); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_12990;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_17853;
BgL_tmpz00_17853 = 
((obj_t)BgL_fz00_12987); 
BgL_ufz00_12990 = 
PROCEDURE_ATTR(BgL_tmpz00_17853); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5658z00_17856;
if(
STRUCTP(BgL_ufz00_12990))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5658z00_17856 = 
(
STRUCT_KEY(BgL_ufz00_12990)==BGl_symbol5225z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5658z00_17856 = ((bool_t)0)
; } 
if(BgL_test5658z00_17856)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_12991;obj_t BgL_runz00_12992;obj_t BgL_sfz00_12993;
BgL_arityz00_12991 = 
STRUCT_REF(BgL_ufz00_12990, 
(int)(((long)0))); 
BgL_runz00_12992 = 
STRUCT_REF(BgL_ufz00_12990, 
(int)(((long)1))); 
BgL_sfz00_12993 = 
STRUCT_REF(BgL_ufz00_12990, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_spz00_12994;
BgL_spz00_12994 = 
(
(long)CINT(BgL_bpz00_12986)+BgL_siza7eza7_10823); 
if(
(
(long)CINT(BgL_arityz00_12991)==((long)2)))
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2124z00_12995;
BgL_arg2124z00_12995 = 
(BgL_spz00_12994+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10824),BgL_arg2124z00_12995,BgL_a1z00_12988); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2125z00_12996;
BgL_arg2125z00_12996 = 
(BgL_spz00_12994+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10824),BgL_arg2125z00_12996,BgL_a2z00_12989); } }  else 
{ 

if(
INTEGERP(BgL_arityz00_12991))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_12991)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2127z00_12999;obj_t BgL_arg2128z00_13000;
BgL_arg2127z00_12999 = 
(BgL_spz00_12994+((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2129z00_13001;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2130z00_13002;
BgL_arg2130z00_13002 = 
MAKE_YOUNG_PAIR(BgL_a2z00_12989, BNIL); 
BgL_list2129z00_13001 = 
MAKE_YOUNG_PAIR(BgL_a1z00_12988, BgL_arg2130z00_13002); } 
BgL_arg2128z00_13000 = BgL_list2129z00_13001; } 
VECTOR_SET(
((obj_t)BgL_sz00_10824),BgL_arg2127z00_12999,BgL_arg2128z00_13000); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2131z00_13003;
BgL_arg2131z00_13003 = 
(BgL_spz00_12994+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10824),BgL_arg2131z00_13003,BgL_a1z00_12988); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2132z00_13004;obj_t BgL_arg2133z00_13005;
BgL_arg2132z00_13004 = 
(BgL_spz00_12994+((long)1)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2134z00_13006;
BgL_list2134z00_13006 = 
MAKE_YOUNG_PAIR(BgL_a2z00_12989, BNIL); 
BgL_arg2133z00_13005 = BgL_list2134z00_13006; } 
VECTOR_SET(
((obj_t)BgL_sz00_10824),BgL_arg2132z00_13004,BgL_arg2133z00_13005); } break;case ((long)-3) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2135z00_13007;
BgL_arg2135z00_13007 = 
(BgL_spz00_12994+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10824),BgL_arg2135z00_13007,BgL_a1z00_12988); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2136z00_13008;
BgL_arg2136z00_13008 = 
(BgL_spz00_12994+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10824),BgL_arg2136z00_13008,BgL_a2z00_12989); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2137z00_13009;obj_t BgL_arg2138z00_13010;
BgL_arg2137z00_13009 = 
(BgL_spz00_12994+((long)2)); 
BgL_arg2138z00_13010 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10824),BgL_arg2137z00_13009,BgL_arg2138z00_13010); } break;
default: 
BgL_case_else1192z00_12997:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2140z00_12998;
BgL_arg2140z00_12998 = 
STRUCT_REF(
((obj_t)BgL_ufz00_12990), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10821, BgL_arg2140z00_12998, 
(int)(((long)2)), 
CINT(BgL_arityz00_12991)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1192z00_12997;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_13011;
BgL_z12denvz12_13011 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10824, 
BINT(BgL_spz00_12994), BgL_sfz00_12993))
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12992, BgL_sz00_10824, 
BINT(BgL_spz00_12994));}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_13012;
BgL_nsz00_13012 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2142z00_13013;
BgL_arg2142z00_13013 = 
(BgL_spz00_12994+((long)2)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_13012, ((long)2), BgL_sz00_10824, 
BINT(BgL_spz00_12994), 
BINT(BgL_arg2142z00_13013)); } 
VECTOR_SET(BgL_nsz00_13012,((long)1),BgL_sz00_10824); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13011, BgL_nsz00_13012); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_13014;
BgL_ez00_13014 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13014, BgL_sz00_10824); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_13015;
BgL_____rz00_13015 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12992, BgL_nsz00_13012, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13014); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13011, BgL_sz00_10824); 
return BgL_____rz00_13015;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12987, 
(int)(((long)2))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_13016;
BgL_nbpz00_13016 = 
(
(long)CINT(BgL_bpz00_12986)+BgL_siza7eza7_10823); 
VECTOR_SET(
((obj_t)BgL_sz00_10824),((long)0),
BINT(BgL_nbpz00_13016)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_13017;
BgL_rz00_13017 = 
PROCEDURE_ENTRY(BgL_fz00_12987)(BgL_fz00_12987, BgL_a1z00_12988, BgL_a2z00_12989, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10824),((long)0),BgL_bpz00_12986); 
return BgL_rz00_13017;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10821, BgL_symbzd2funzd2_10822, 
(int)(((long)2)), 
PROCEDURE_ARITY(BgL_fz00_12987));} } } } } } } } 

}



/* comp-call3 */
obj_t BGl_compzd2call3zd2zz__evaluate_compz00(obj_t BgL_locz00_162, BgL_ev_exprz00_bglt BgL_vfunz00_163, obj_t BgL_symbzd2funzd2_164, obj_t BgL_funz00_165, obj_t BgL_tailzf3zf3_166, obj_t BgL_stkz00_167, long BgL_siza7eza7_168, obj_t BgL_a1z00_169, obj_t BgL_a2z00_170, obj_t BgL_a3z00_171)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_cfunz00_2484;
BgL_cfunz00_2484 = 
BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_163, ((long)3), BgL_locz00_162, BgL_symbzd2funzd2_164); 
if(
CBOOL(BgL_cfunz00_2484))
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5665z00_17949;
{ /* Eval/evaluate_comp.scm 896 */
int BgL_arg2152z00_2504;
BgL_arg2152z00_2504 = 
bgl_debug(); 
BgL_test5665z00_17949 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg2152z00_2504), 
BINT(((long)0))); } 
if(BgL_test5665z00_17949)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32149ze3z87_10825;
BgL_zc3z04anonymousza32149ze3z87_10825 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32149ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32149ze3z87_10825, 
(int)(((long)0)), BgL_a1z00_169); 
PROCEDURE_SET(BgL_zc3z04anonymousza32149ze3z87_10825, 
(int)(((long)1)), BgL_a2z00_170); 
PROCEDURE_SET(BgL_zc3z04anonymousza32149ze3z87_10825, 
(int)(((long)2)), BgL_a3z00_171); 
PROCEDURE_SET(BgL_zc3z04anonymousza32149ze3z87_10825, 
(int)(((long)3)), 
BINT(BgL_siza7eza7_168)); 
PROCEDURE_SET(BgL_zc3z04anonymousza32149ze3z87_10825, 
(int)(((long)4)), BgL_locz00_162); 
PROCEDURE_SET(BgL_zc3z04anonymousza32149ze3z87_10825, 
(int)(((long)5)), BgL_cfunz00_2484); 
return BgL_zc3z04anonymousza32149ze3z87_10825;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32151ze3z87_10826;
BgL_zc3z04anonymousza32151ze3z87_10826 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32151ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32151ze3z87_10826, 
(int)(((long)0)), BgL_a1z00_169); 
PROCEDURE_SET(BgL_zc3z04anonymousza32151ze3z87_10826, 
(int)(((long)1)), BgL_a2z00_170); 
PROCEDURE_SET(BgL_zc3z04anonymousza32151ze3z87_10826, 
(int)(((long)2)), BgL_a3z00_171); 
PROCEDURE_SET(BgL_zc3z04anonymousza32151ze3z87_10826, 
(int)(((long)3)), 
BINT(BgL_siza7eza7_168)); 
PROCEDURE_SET(BgL_zc3z04anonymousza32151ze3z87_10826, 
(int)(((long)4)), BgL_cfunz00_2484); 
return BgL_zc3z04anonymousza32151ze3z87_10826;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
CBOOL(BgL_tailzf3zf3_166))
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5667z00_17986;
{ /* Eval/evaluate_comp.scm 896 */
int BgL_arg2225z00_2616;
BgL_arg2225z00_2616 = 
bgl_debug(); 
BgL_test5667z00_17986 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg2225z00_2616), 
BINT(((long)0))); } 
if(BgL_test5667z00_17986)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32155ze3z87_10827;
BgL_zc3z04anonymousza32155ze3z87_10827 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32155ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32155ze3z87_10827, 
(int)(((long)0)), BgL_funz00_165); 
PROCEDURE_SET(BgL_zc3z04anonymousza32155ze3z87_10827, 
(int)(((long)1)), BgL_a1z00_169); 
PROCEDURE_SET(BgL_zc3z04anonymousza32155ze3z87_10827, 
(int)(((long)2)), BgL_a2z00_170); 
PROCEDURE_SET(BgL_zc3z04anonymousza32155ze3z87_10827, 
(int)(((long)3)), BgL_a3z00_171); 
PROCEDURE_SET(BgL_zc3z04anonymousza32155ze3z87_10827, 
(int)(((long)4)), BgL_locz00_162); 
PROCEDURE_SET(BgL_zc3z04anonymousza32155ze3z87_10827, 
(int)(((long)5)), BgL_symbzd2funzd2_164); 
PROCEDURE_SET(BgL_zc3z04anonymousza32155ze3z87_10827, 
(int)(((long)6)), 
BINT(BgL_siza7eza7_168)); 
return BgL_zc3z04anonymousza32155ze3z87_10827;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32191ze3z87_10828;
BgL_zc3z04anonymousza32191ze3z87_10828 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32191ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32191ze3z87_10828, 
(int)(((long)0)), BgL_funz00_165); 
PROCEDURE_SET(BgL_zc3z04anonymousza32191ze3z87_10828, 
(int)(((long)1)), BgL_a1z00_169); 
PROCEDURE_SET(BgL_zc3z04anonymousza32191ze3z87_10828, 
(int)(((long)2)), BgL_a2z00_170); 
PROCEDURE_SET(BgL_zc3z04anonymousza32191ze3z87_10828, 
(int)(((long)3)), BgL_a3z00_171); 
PROCEDURE_SET(BgL_zc3z04anonymousza32191ze3z87_10828, 
(int)(((long)4)), BgL_locz00_162); 
PROCEDURE_SET(BgL_zc3z04anonymousza32191ze3z87_10828, 
(int)(((long)5)), BgL_symbzd2funzd2_164); 
PROCEDURE_SET(BgL_zc3z04anonymousza32191ze3z87_10828, 
(int)(((long)6)), 
BINT(BgL_siza7eza7_168)); 
return BgL_zc3z04anonymousza32191ze3z87_10828;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5668z00_18027;
{ /* Eval/evaluate_comp.scm 896 */
int BgL_arg2297z00_2728;
BgL_arg2297z00_2728 = 
bgl_debug(); 
BgL_test5668z00_18027 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg2297z00_2728), 
BINT(((long)0))); } 
if(BgL_test5668z00_18027)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32228ze3z87_10829;
BgL_zc3z04anonymousza32228ze3z87_10829 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32228ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32228ze3z87_10829, 
(int)(((long)0)), BgL_funz00_165); 
PROCEDURE_SET(BgL_zc3z04anonymousza32228ze3z87_10829, 
(int)(((long)1)), BgL_a1z00_169); 
PROCEDURE_SET(BgL_zc3z04anonymousza32228ze3z87_10829, 
(int)(((long)2)), BgL_a2z00_170); 
PROCEDURE_SET(BgL_zc3z04anonymousza32228ze3z87_10829, 
(int)(((long)3)), BgL_a3z00_171); 
PROCEDURE_SET(BgL_zc3z04anonymousza32228ze3z87_10829, 
(int)(((long)4)), BgL_locz00_162); 
PROCEDURE_SET(BgL_zc3z04anonymousza32228ze3z87_10829, 
(int)(((long)5)), BgL_symbzd2funzd2_164); 
PROCEDURE_SET(BgL_zc3z04anonymousza32228ze3z87_10829, 
(int)(((long)6)), 
BINT(BgL_siza7eza7_168)); 
return BgL_zc3z04anonymousza32228ze3z87_10829;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32263ze3z87_10830;
BgL_zc3z04anonymousza32263ze3z87_10830 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32263ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32263ze3z87_10830, 
(int)(((long)0)), BgL_funz00_165); 
PROCEDURE_SET(BgL_zc3z04anonymousza32263ze3z87_10830, 
(int)(((long)1)), BgL_a1z00_169); 
PROCEDURE_SET(BgL_zc3z04anonymousza32263ze3z87_10830, 
(int)(((long)2)), BgL_a2z00_170); 
PROCEDURE_SET(BgL_zc3z04anonymousza32263ze3z87_10830, 
(int)(((long)3)), BgL_a3z00_171); 
PROCEDURE_SET(BgL_zc3z04anonymousza32263ze3z87_10830, 
(int)(((long)4)), BgL_locz00_162); 
PROCEDURE_SET(BgL_zc3z04anonymousza32263ze3z87_10830, 
(int)(((long)5)), BgL_symbzd2funzd2_164); 
PROCEDURE_SET(BgL_zc3z04anonymousza32263ze3z87_10830, 
(int)(((long)6)), 
BINT(BgL_siza7eza7_168)); 
return BgL_zc3z04anonymousza32263ze3z87_10830;} } } } } 

}



/* &<@anonymous:2149> */
obj_t BGl_z62zc3z04anonymousza32149ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10831, obj_t BgL_sz00_10838)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_a1z00_10832;obj_t BgL_a2z00_10833;obj_t BgL_a3z00_10834;long BgL_siza7eza7_10835;obj_t BgL_locz00_10836;obj_t BgL_cfunz00_10837;
BgL_a1z00_10832 = 
PROCEDURE_REF(BgL_envz00_10831, 
(int)(((long)0))); 
BgL_a2z00_10833 = 
PROCEDURE_REF(BgL_envz00_10831, 
(int)(((long)1))); 
BgL_a3z00_10834 = 
PROCEDURE_REF(BgL_envz00_10831, 
(int)(((long)2))); 
BgL_siza7eza7_10835 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10831, 
(int)(((long)3)))); 
BgL_locz00_10836 = 
PROCEDURE_REF(BgL_envz00_10831, 
(int)(((long)4))); 
BgL_cfunz00_10837 = 
PROCEDURE_REF(BgL_envz00_10831, 
(int)(((long)5))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_13018;
BgL_bpz00_13018 = 
VECTOR_REF(
((obj_t)BgL_sz00_10838),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_a1z00_13019;obj_t BgL_a2z00_13020;obj_t BgL_a3z00_13021;
BgL_a1z00_13019 = 
PROCEDURE_ENTRY(BgL_a1z00_10832)(BgL_a1z00_10832, BgL_sz00_10838, BEOA); 
BgL_a2z00_13020 = 
PROCEDURE_ENTRY(BgL_a2z00_10833)(BgL_a2z00_10833, BgL_sz00_10838, BEOA); 
BgL_a3z00_13021 = 
PROCEDURE_ENTRY(BgL_a3z00_10834)(BgL_a3z00_10834, BgL_sz00_10838, BEOA); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_13022;
BgL_nbpz00_13022 = 
(
(long)CINT(BgL_bpz00_13018)+BgL_siza7eza7_10835); 
VECTOR_SET(
((obj_t)BgL_sz00_10838),((long)0),
BINT(BgL_nbpz00_13022)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_18100;
BgL_tmpz00_18100 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_18100, BgL_locz00_10836); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_13023;
BgL_rz00_13023 = 
PROCEDURE_ENTRY(BgL_cfunz00_10837)(BgL_cfunz00_10837, BgL_a1z00_13019, BgL_a2z00_13020, BgL_a3z00_13021, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10838),((long)0),BgL_bpz00_13018); 
return BgL_rz00_13023;} } } } } } 

}



/* &<@anonymous:2151> */
obj_t BGl_z62zc3z04anonymousza32151ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10839, obj_t BgL_sz00_10845)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_a1z00_10840;obj_t BgL_a2z00_10841;obj_t BgL_a3z00_10842;long BgL_siza7eza7_10843;obj_t BgL_cfunz00_10844;
BgL_a1z00_10840 = 
PROCEDURE_REF(BgL_envz00_10839, 
(int)(((long)0))); 
BgL_a2z00_10841 = 
PROCEDURE_REF(BgL_envz00_10839, 
(int)(((long)1))); 
BgL_a3z00_10842 = 
PROCEDURE_REF(BgL_envz00_10839, 
(int)(((long)2))); 
BgL_siza7eza7_10843 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10839, 
(int)(((long)3)))); 
BgL_cfunz00_10844 = 
PROCEDURE_REF(BgL_envz00_10839, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_13024;
BgL_bpz00_13024 = 
VECTOR_REF(
((obj_t)BgL_sz00_10845),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_a1z00_13025;obj_t BgL_a2z00_13026;obj_t BgL_a3z00_13027;
BgL_a1z00_13025 = 
PROCEDURE_ENTRY(BgL_a1z00_10840)(BgL_a1z00_10840, BgL_sz00_10845, BEOA); 
BgL_a2z00_13026 = 
PROCEDURE_ENTRY(BgL_a2z00_10841)(BgL_a2z00_10841, BgL_sz00_10845, BEOA); 
BgL_a3z00_13027 = 
PROCEDURE_ENTRY(BgL_a3z00_10842)(BgL_a3z00_10842, BgL_sz00_10845, BEOA); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_13028;
BgL_nbpz00_13028 = 
(
(long)CINT(BgL_bpz00_13024)+BgL_siza7eza7_10843); 
VECTOR_SET(
((obj_t)BgL_sz00_10845),((long)0),
BINT(BgL_nbpz00_13028)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_13029;
BgL_rz00_13029 = 
PROCEDURE_ENTRY(BgL_cfunz00_10844)(BgL_cfunz00_10844, BgL_a1z00_13025, BgL_a2z00_13026, BgL_a3z00_13027, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10845),((long)0),BgL_bpz00_13024); 
return BgL_rz00_13029;} } } } } } 

}



/* &<@anonymous:2155> */
obj_t BGl_z62zc3z04anonymousza32155ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10846, obj_t BgL_sz00_10854)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_10847;obj_t BgL_a1z00_10848;obj_t BgL_a2z00_10849;obj_t BgL_a3z00_10850;obj_t BgL_locz00_10851;obj_t BgL_symbzd2funzd2_10852;long BgL_siza7eza7_10853;
BgL_funz00_10847 = 
PROCEDURE_REF(BgL_envz00_10846, 
(int)(((long)0))); 
BgL_a1z00_10848 = 
PROCEDURE_REF(BgL_envz00_10846, 
(int)(((long)1))); 
BgL_a2z00_10849 = 
PROCEDURE_REF(BgL_envz00_10846, 
(int)(((long)2))); 
BgL_a3z00_10850 = 
PROCEDURE_REF(BgL_envz00_10846, 
(int)(((long)3))); 
BgL_locz00_10851 = 
PROCEDURE_REF(BgL_envz00_10846, 
(int)(((long)4))); 
BgL_symbzd2funzd2_10852 = 
PROCEDURE_REF(BgL_envz00_10846, 
(int)(((long)5))); 
BgL_siza7eza7_10853 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10846, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_13030;
BgL_bpz00_13030 = 
VECTOR_REF(
((obj_t)BgL_sz00_10854),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_13031;obj_t BgL_a1z00_13032;obj_t BgL_a2z00_13033;obj_t BgL_a3z00_13034;
BgL_fz00_13031 = 
PROCEDURE_ENTRY(BgL_funz00_10847)(BgL_funz00_10847, BgL_sz00_10854, BEOA); 
BgL_a1z00_13032 = 
PROCEDURE_ENTRY(BgL_a1z00_10848)(BgL_a1z00_10848, BgL_sz00_10854, BEOA); 
BgL_a2z00_13033 = 
PROCEDURE_ENTRY(BgL_a2z00_10849)(BgL_a2z00_10849, BgL_sz00_10854, BEOA); 
BgL_a3z00_13034 = 
PROCEDURE_ENTRY(BgL_a3z00_10850)(BgL_a3z00_10850, BgL_sz00_10854, BEOA); 
if(
PROCEDUREP(BgL_fz00_13031))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10851, BGl_string5208z00zz__evaluate_compz00, BGl_string5224z00zz__evaluate_compz00, BgL_fz00_13031); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_13035;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_18185;
BgL_tmpz00_18185 = 
((obj_t)BgL_fz00_13031); 
BgL_ufz00_13035 = 
PROCEDURE_ATTR(BgL_tmpz00_18185); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5670z00_18188;
if(
STRUCTP(BgL_ufz00_13035))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5670z00_18188 = 
(
STRUCT_KEY(BgL_ufz00_13035)==BGl_symbol5225z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5670z00_18188 = ((bool_t)0)
; } 
if(BgL_test5670z00_18188)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_13036;obj_t BgL_runz00_13037;obj_t BgL_sfz00_13038;
BgL_arityz00_13036 = 
STRUCT_REF(BgL_ufz00_13035, 
(int)(((long)0))); 
BgL_runz00_13037 = 
STRUCT_REF(BgL_ufz00_13035, 
(int)(((long)1))); 
BgL_sfz00_13038 = 
STRUCT_REF(BgL_ufz00_13035, 
(int)(((long)2))); 
if(
(
(long)CINT(BgL_arityz00_13036)==((long)3)))
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2159z00_13039;
BgL_arg2159z00_13039 = 
(
(long)CINT(BgL_bpz00_13030)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10854),BgL_arg2159z00_13039,BgL_a1z00_13032); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2160z00_13040;
BgL_arg2160z00_13040 = 
(
(long)CINT(BgL_bpz00_13030)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10854),BgL_arg2160z00_13040,BgL_a2z00_13033); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2161z00_13041;
BgL_arg2161z00_13041 = 
(
(long)CINT(BgL_bpz00_13030)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10854),BgL_arg2161z00_13041,BgL_a3z00_13034); } }  else 
{ 

if(
INTEGERP(BgL_arityz00_13036))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_13036)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2163z00_13044;obj_t BgL_arg2164z00_13045;
BgL_arg2163z00_13044 = 
(
(long)CINT(BgL_bpz00_13030)+((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2166z00_13046;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2167z00_13047;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2168z00_13048;
BgL_arg2168z00_13048 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13034, BNIL); 
BgL_arg2167z00_13047 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13033, BgL_arg2168z00_13048); } 
BgL_list2166z00_13046 = 
MAKE_YOUNG_PAIR(BgL_a1z00_13032, BgL_arg2167z00_13047); } 
BgL_arg2164z00_13045 = BgL_list2166z00_13046; } 
VECTOR_SET(
((obj_t)BgL_sz00_10854),BgL_arg2163z00_13044,BgL_arg2164z00_13045); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2169z00_13049;
BgL_arg2169z00_13049 = 
(
(long)CINT(BgL_bpz00_13030)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10854),BgL_arg2169z00_13049,BgL_a1z00_13032); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2170z00_13050;obj_t BgL_arg2171z00_13051;
BgL_arg2170z00_13050 = 
(
(long)CINT(BgL_bpz00_13030)+((long)1)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2172z00_13052;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2173z00_13053;
BgL_arg2173z00_13053 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13034, BNIL); 
BgL_list2172z00_13052 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13033, BgL_arg2173z00_13053); } 
BgL_arg2171z00_13051 = BgL_list2172z00_13052; } 
VECTOR_SET(
((obj_t)BgL_sz00_10854),BgL_arg2170z00_13050,BgL_arg2171z00_13051); } break;case ((long)-3) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2174z00_13054;
BgL_arg2174z00_13054 = 
(
(long)CINT(BgL_bpz00_13030)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10854),BgL_arg2174z00_13054,BgL_a1z00_13032); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2175z00_13055;
BgL_arg2175z00_13055 = 
(
(long)CINT(BgL_bpz00_13030)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10854),BgL_arg2175z00_13055,BgL_a2z00_13033); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2176z00_13056;obj_t BgL_arg2177z00_13057;
BgL_arg2176z00_13056 = 
(
(long)CINT(BgL_bpz00_13030)+((long)2)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2178z00_13058;
BgL_list2178z00_13058 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13034, BNIL); 
BgL_arg2177z00_13057 = BgL_list2178z00_13058; } 
VECTOR_SET(
((obj_t)BgL_sz00_10854),BgL_arg2176z00_13056,BgL_arg2177z00_13057); } break;case ((long)-4) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2179z00_13059;
BgL_arg2179z00_13059 = 
(
(long)CINT(BgL_bpz00_13030)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10854),BgL_arg2179z00_13059,BgL_a1z00_13032); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2180z00_13060;
BgL_arg2180z00_13060 = 
(
(long)CINT(BgL_bpz00_13030)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10854),BgL_arg2180z00_13060,BgL_a2z00_13033); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2181z00_13061;
BgL_arg2181z00_13061 = 
(
(long)CINT(BgL_bpz00_13030)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10854),BgL_arg2181z00_13061,BgL_a3z00_13034); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2182z00_13062;obj_t BgL_arg2183z00_13063;
BgL_arg2182z00_13062 = 
(
(long)CINT(BgL_bpz00_13030)+((long)3)); 
BgL_arg2183z00_13063 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10854),BgL_arg2182z00_13062,BgL_arg2183z00_13063); } break;
default: 
BgL_case_else1194z00_13042:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2185z00_13043;
BgL_arg2185z00_13043 = 
STRUCT_REF(
((obj_t)BgL_ufz00_13035), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10851, BgL_arg2185z00_13043, 
(int)(((long)3)), 
CINT(BgL_arityz00_13036)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1194z00_13042;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_13064;
BgL_z12denvz12_13064 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_13064, BgL_locz00_10851); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10854, BgL_bpz00_13030, BgL_sfz00_13038))
{ /* Eval/evaluate_comp.scm 896 */
return BgL_runz00_13037;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_13065;
BgL_nsz00_13065 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2187z00_13066;
BgL_arg2187z00_13066 = 
(
(long)CINT(BgL_bpz00_13030)+((long)3)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_13065, ((long)2), BgL_sz00_10854, BgL_bpz00_13030, 
BINT(BgL_arg2187z00_13066)); } 
VECTOR_SET(BgL_nsz00_13065,((long)1),BgL_sz00_10854); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13064, BgL_nsz00_13065); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_13067;
BgL_ez00_13067 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13067, BgL_sz00_10854); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_13068;
BgL_____rz00_13068 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_13037, BgL_nsz00_13065, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13067); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13064, BgL_sz00_10854); 
return BgL_____rz00_13068;} } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_13031, 
(int)(((long)3))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_13069;
BgL_nbpz00_13069 = 
(
(long)CINT(BgL_bpz00_13030)+BgL_siza7eza7_10853); 
VECTOR_SET(
((obj_t)BgL_sz00_10854),((long)0),
BINT(BgL_nbpz00_13069)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_18295;
BgL_tmpz00_18295 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_18295, BgL_locz00_10851); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_13070;
BgL_rz00_13070 = 
PROCEDURE_ENTRY(BgL_fz00_13031)(BgL_fz00_13031, BgL_a1z00_13032, BgL_a2z00_13033, BgL_a3z00_13034, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10854),((long)0),BgL_bpz00_13030); 
return BgL_rz00_13070;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10851, BgL_symbzd2funzd2_10852, 
(int)(((long)3)), 
PROCEDURE_ARITY(BgL_fz00_13031));} } } } } } } } 

}



/* &<@anonymous:2191> */
obj_t BGl_z62zc3z04anonymousza32191ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10855, obj_t BgL_sz00_10863)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_10856;obj_t BgL_a1z00_10857;obj_t BgL_a2z00_10858;obj_t BgL_a3z00_10859;obj_t BgL_locz00_10860;obj_t BgL_symbzd2funzd2_10861;long BgL_siza7eza7_10862;
BgL_funz00_10856 = 
PROCEDURE_REF(BgL_envz00_10855, 
(int)(((long)0))); 
BgL_a1z00_10857 = 
PROCEDURE_REF(BgL_envz00_10855, 
(int)(((long)1))); 
BgL_a2z00_10858 = 
PROCEDURE_REF(BgL_envz00_10855, 
(int)(((long)2))); 
BgL_a3z00_10859 = 
PROCEDURE_REF(BgL_envz00_10855, 
(int)(((long)3))); 
BgL_locz00_10860 = 
PROCEDURE_REF(BgL_envz00_10855, 
(int)(((long)4))); 
BgL_symbzd2funzd2_10861 = 
PROCEDURE_REF(BgL_envz00_10855, 
(int)(((long)5))); 
BgL_siza7eza7_10862 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10855, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_13071;
BgL_bpz00_13071 = 
VECTOR_REF(
((obj_t)BgL_sz00_10863),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_13072;obj_t BgL_a1z00_13073;obj_t BgL_a2z00_13074;obj_t BgL_a3z00_13075;
BgL_fz00_13072 = 
PROCEDURE_ENTRY(BgL_funz00_10856)(BgL_funz00_10856, BgL_sz00_10863, BEOA); 
BgL_a1z00_13073 = 
PROCEDURE_ENTRY(BgL_a1z00_10857)(BgL_a1z00_10857, BgL_sz00_10863, BEOA); 
BgL_a2z00_13074 = 
PROCEDURE_ENTRY(BgL_a2z00_10858)(BgL_a2z00_10858, BgL_sz00_10863, BEOA); 
BgL_a3z00_13075 = 
PROCEDURE_ENTRY(BgL_a3z00_10859)(BgL_a3z00_10859, BgL_sz00_10863, BEOA); 
if(
PROCEDUREP(BgL_fz00_13072))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10860, BGl_string5208z00zz__evaluate_compz00, BGl_string5224z00zz__evaluate_compz00, BgL_fz00_13072); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_13076;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_18345;
BgL_tmpz00_18345 = 
((obj_t)BgL_fz00_13072); 
BgL_ufz00_13076 = 
PROCEDURE_ATTR(BgL_tmpz00_18345); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5677z00_18348;
if(
STRUCTP(BgL_ufz00_13076))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5677z00_18348 = 
(
STRUCT_KEY(BgL_ufz00_13076)==BGl_symbol5225z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5677z00_18348 = ((bool_t)0)
; } 
if(BgL_test5677z00_18348)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_13077;obj_t BgL_runz00_13078;obj_t BgL_sfz00_13079;
BgL_arityz00_13077 = 
STRUCT_REF(BgL_ufz00_13076, 
(int)(((long)0))); 
BgL_runz00_13078 = 
STRUCT_REF(BgL_ufz00_13076, 
(int)(((long)1))); 
BgL_sfz00_13079 = 
STRUCT_REF(BgL_ufz00_13076, 
(int)(((long)2))); 
if(
(
(long)CINT(BgL_arityz00_13077)==((long)3)))
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2195z00_13080;
BgL_arg2195z00_13080 = 
(
(long)CINT(BgL_bpz00_13071)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10863),BgL_arg2195z00_13080,BgL_a1z00_13073); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2196z00_13081;
BgL_arg2196z00_13081 = 
(
(long)CINT(BgL_bpz00_13071)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10863),BgL_arg2196z00_13081,BgL_a2z00_13074); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2197z00_13082;
BgL_arg2197z00_13082 = 
(
(long)CINT(BgL_bpz00_13071)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10863),BgL_arg2197z00_13082,BgL_a3z00_13075); } }  else 
{ 

if(
INTEGERP(BgL_arityz00_13077))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_13077)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2199z00_13085;obj_t BgL_arg2200z00_13086;
BgL_arg2199z00_13085 = 
(
(long)CINT(BgL_bpz00_13071)+((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2201z00_13087;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2202z00_13088;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2203z00_13089;
BgL_arg2203z00_13089 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13075, BNIL); 
BgL_arg2202z00_13088 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13074, BgL_arg2203z00_13089); } 
BgL_list2201z00_13087 = 
MAKE_YOUNG_PAIR(BgL_a1z00_13073, BgL_arg2202z00_13088); } 
BgL_arg2200z00_13086 = BgL_list2201z00_13087; } 
VECTOR_SET(
((obj_t)BgL_sz00_10863),BgL_arg2199z00_13085,BgL_arg2200z00_13086); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2204z00_13090;
BgL_arg2204z00_13090 = 
(
(long)CINT(BgL_bpz00_13071)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10863),BgL_arg2204z00_13090,BgL_a1z00_13073); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2205z00_13091;obj_t BgL_arg2206z00_13092;
BgL_arg2205z00_13091 = 
(
(long)CINT(BgL_bpz00_13071)+((long)1)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2207z00_13093;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2208z00_13094;
BgL_arg2208z00_13094 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13075, BNIL); 
BgL_list2207z00_13093 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13074, BgL_arg2208z00_13094); } 
BgL_arg2206z00_13092 = BgL_list2207z00_13093; } 
VECTOR_SET(
((obj_t)BgL_sz00_10863),BgL_arg2205z00_13091,BgL_arg2206z00_13092); } break;case ((long)-3) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2209z00_13095;
BgL_arg2209z00_13095 = 
(
(long)CINT(BgL_bpz00_13071)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10863),BgL_arg2209z00_13095,BgL_a1z00_13073); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2210z00_13096;
BgL_arg2210z00_13096 = 
(
(long)CINT(BgL_bpz00_13071)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10863),BgL_arg2210z00_13096,BgL_a2z00_13074); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2211z00_13097;obj_t BgL_arg2212z00_13098;
BgL_arg2211z00_13097 = 
(
(long)CINT(BgL_bpz00_13071)+((long)2)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2213z00_13099;
BgL_list2213z00_13099 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13075, BNIL); 
BgL_arg2212z00_13098 = BgL_list2213z00_13099; } 
VECTOR_SET(
((obj_t)BgL_sz00_10863),BgL_arg2211z00_13097,BgL_arg2212z00_13098); } break;case ((long)-4) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2214z00_13100;
BgL_arg2214z00_13100 = 
(
(long)CINT(BgL_bpz00_13071)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10863),BgL_arg2214z00_13100,BgL_a1z00_13073); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2215z00_13101;
BgL_arg2215z00_13101 = 
(
(long)CINT(BgL_bpz00_13071)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10863),BgL_arg2215z00_13101,BgL_a2z00_13074); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2216z00_13102;
BgL_arg2216z00_13102 = 
(
(long)CINT(BgL_bpz00_13071)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10863),BgL_arg2216z00_13102,BgL_a3z00_13075); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2217z00_13103;obj_t BgL_arg2218z00_13104;
BgL_arg2217z00_13103 = 
(
(long)CINT(BgL_bpz00_13071)+((long)3)); 
BgL_arg2218z00_13104 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10863),BgL_arg2217z00_13103,BgL_arg2218z00_13104); } break;
default: 
BgL_case_else1196z00_13083:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2220z00_13084;
BgL_arg2220z00_13084 = 
STRUCT_REF(
((obj_t)BgL_ufz00_13076), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10860, BgL_arg2220z00_13084, 
(int)(((long)3)), 
CINT(BgL_arityz00_13077)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1196z00_13083;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_13105;
BgL_z12denvz12_13105 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10863, BgL_bpz00_13071, BgL_sfz00_13079))
{ /* Eval/evaluate_comp.scm 896 */
return BgL_runz00_13078;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_13106;
BgL_nsz00_13106 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2222z00_13107;
BgL_arg2222z00_13107 = 
(
(long)CINT(BgL_bpz00_13071)+((long)3)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_13106, ((long)2), BgL_sz00_10863, BgL_bpz00_13071, 
BINT(BgL_arg2222z00_13107)); } 
VECTOR_SET(BgL_nsz00_13106,((long)1),BgL_sz00_10863); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13105, BgL_nsz00_13106); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_13108;
BgL_ez00_13108 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13108, BgL_sz00_10863); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_13109;
BgL_____rz00_13109 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_13078, BgL_nsz00_13106, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13108); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13105, BgL_sz00_10863); 
return BgL_____rz00_13109;} } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_13072, 
(int)(((long)3))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_13110;
BgL_nbpz00_13110 = 
(
(long)CINT(BgL_bpz00_13071)+BgL_siza7eza7_10862); 
VECTOR_SET(
((obj_t)BgL_sz00_10863),((long)0),
BINT(BgL_nbpz00_13110)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_13111;
BgL_rz00_13111 = 
PROCEDURE_ENTRY(BgL_fz00_13072)(BgL_fz00_13072, BgL_a1z00_13073, BgL_a2z00_13074, BgL_a3z00_13075, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10863),((long)0),BgL_bpz00_13071); 
return BgL_rz00_13111;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10860, BgL_symbzd2funzd2_10861, 
(int)(((long)3)), 
PROCEDURE_ARITY(BgL_fz00_13072));} } } } } } } } 

}



/* &<@anonymous:2228> */
obj_t BGl_z62zc3z04anonymousza32228ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10864, obj_t BgL_sz00_10872)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_10865;obj_t BgL_a1z00_10866;obj_t BgL_a2z00_10867;obj_t BgL_a3z00_10868;obj_t BgL_locz00_10869;obj_t BgL_symbzd2funzd2_10870;long BgL_siza7eza7_10871;
BgL_funz00_10865 = 
PROCEDURE_REF(BgL_envz00_10864, 
(int)(((long)0))); 
BgL_a1z00_10866 = 
PROCEDURE_REF(BgL_envz00_10864, 
(int)(((long)1))); 
BgL_a2z00_10867 = 
PROCEDURE_REF(BgL_envz00_10864, 
(int)(((long)2))); 
BgL_a3z00_10868 = 
PROCEDURE_REF(BgL_envz00_10864, 
(int)(((long)3))); 
BgL_locz00_10869 = 
PROCEDURE_REF(BgL_envz00_10864, 
(int)(((long)4))); 
BgL_symbzd2funzd2_10870 = 
PROCEDURE_REF(BgL_envz00_10864, 
(int)(((long)5))); 
BgL_siza7eza7_10871 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10864, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_13112;
BgL_bpz00_13112 = 
VECTOR_REF(
((obj_t)BgL_sz00_10872),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_13113;obj_t BgL_a1z00_13114;obj_t BgL_a2z00_13115;obj_t BgL_a3z00_13116;
BgL_fz00_13113 = 
PROCEDURE_ENTRY(BgL_funz00_10865)(BgL_funz00_10865, BgL_sz00_10872, BEOA); 
BgL_a1z00_13114 = 
PROCEDURE_ENTRY(BgL_a1z00_10866)(BgL_a1z00_10866, BgL_sz00_10872, BEOA); 
BgL_a2z00_13115 = 
PROCEDURE_ENTRY(BgL_a2z00_10867)(BgL_a2z00_10867, BgL_sz00_10872, BEOA); 
BgL_a3z00_13116 = 
PROCEDURE_ENTRY(BgL_a3z00_10868)(BgL_a3z00_10868, BgL_sz00_10872, BEOA); 
if(
PROCEDUREP(BgL_fz00_13113))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10869, BGl_string5208z00zz__evaluate_compz00, BGl_string5224z00zz__evaluate_compz00, BgL_fz00_13113); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_13117;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_18501;
BgL_tmpz00_18501 = 
((obj_t)BgL_fz00_13113); 
BgL_ufz00_13117 = 
PROCEDURE_ATTR(BgL_tmpz00_18501); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5684z00_18504;
if(
STRUCTP(BgL_ufz00_13117))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5684z00_18504 = 
(
STRUCT_KEY(BgL_ufz00_13117)==BGl_symbol5225z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5684z00_18504 = ((bool_t)0)
; } 
if(BgL_test5684z00_18504)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_13118;obj_t BgL_runz00_13119;obj_t BgL_sfz00_13120;
BgL_arityz00_13118 = 
STRUCT_REF(BgL_ufz00_13117, 
(int)(((long)0))); 
BgL_runz00_13119 = 
STRUCT_REF(BgL_ufz00_13117, 
(int)(((long)1))); 
BgL_sfz00_13120 = 
STRUCT_REF(BgL_ufz00_13117, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_spz00_13121;
BgL_spz00_13121 = 
(
(long)CINT(BgL_bpz00_13112)+BgL_siza7eza7_10871); 
if(
(
(long)CINT(BgL_arityz00_13118)==((long)3)))
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2232z00_13122;
BgL_arg2232z00_13122 = 
(BgL_spz00_13121+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10872),BgL_arg2232z00_13122,BgL_a1z00_13114); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2233z00_13123;
BgL_arg2233z00_13123 = 
(BgL_spz00_13121+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10872),BgL_arg2233z00_13123,BgL_a2z00_13115); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2234z00_13124;
BgL_arg2234z00_13124 = 
(BgL_spz00_13121+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10872),BgL_arg2234z00_13124,BgL_a3z00_13116); } }  else 
{ 

if(
INTEGERP(BgL_arityz00_13118))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_13118)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2236z00_13127;obj_t BgL_arg2237z00_13128;
BgL_arg2236z00_13127 = 
(BgL_spz00_13121+((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2238z00_13129;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2239z00_13130;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2240z00_13131;
BgL_arg2240z00_13131 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13116, BNIL); 
BgL_arg2239z00_13130 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13115, BgL_arg2240z00_13131); } 
BgL_list2238z00_13129 = 
MAKE_YOUNG_PAIR(BgL_a1z00_13114, BgL_arg2239z00_13130); } 
BgL_arg2237z00_13128 = BgL_list2238z00_13129; } 
VECTOR_SET(
((obj_t)BgL_sz00_10872),BgL_arg2236z00_13127,BgL_arg2237z00_13128); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2241z00_13132;
BgL_arg2241z00_13132 = 
(BgL_spz00_13121+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10872),BgL_arg2241z00_13132,BgL_a1z00_13114); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2242z00_13133;obj_t BgL_arg2243z00_13134;
BgL_arg2242z00_13133 = 
(BgL_spz00_13121+((long)1)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2244z00_13135;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2245z00_13136;
BgL_arg2245z00_13136 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13116, BNIL); 
BgL_list2244z00_13135 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13115, BgL_arg2245z00_13136); } 
BgL_arg2243z00_13134 = BgL_list2244z00_13135; } 
VECTOR_SET(
((obj_t)BgL_sz00_10872),BgL_arg2242z00_13133,BgL_arg2243z00_13134); } break;case ((long)-3) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2246z00_13137;
BgL_arg2246z00_13137 = 
(BgL_spz00_13121+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10872),BgL_arg2246z00_13137,BgL_a1z00_13114); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2247z00_13138;
BgL_arg2247z00_13138 = 
(BgL_spz00_13121+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10872),BgL_arg2247z00_13138,BgL_a2z00_13115); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2248z00_13139;obj_t BgL_arg2249z00_13140;
BgL_arg2248z00_13139 = 
(BgL_spz00_13121+((long)2)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2250z00_13141;
BgL_list2250z00_13141 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13116, BNIL); 
BgL_arg2249z00_13140 = BgL_list2250z00_13141; } 
VECTOR_SET(
((obj_t)BgL_sz00_10872),BgL_arg2248z00_13139,BgL_arg2249z00_13140); } break;case ((long)-4) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2251z00_13142;
BgL_arg2251z00_13142 = 
(BgL_spz00_13121+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10872),BgL_arg2251z00_13142,BgL_a1z00_13114); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2252z00_13143;
BgL_arg2252z00_13143 = 
(BgL_spz00_13121+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10872),BgL_arg2252z00_13143,BgL_a2z00_13115); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2253z00_13144;
BgL_arg2253z00_13144 = 
(BgL_spz00_13121+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10872),BgL_arg2253z00_13144,BgL_a3z00_13116); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2254z00_13145;obj_t BgL_arg2255z00_13146;
BgL_arg2254z00_13145 = 
(BgL_spz00_13121+((long)3)); 
BgL_arg2255z00_13146 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10872),BgL_arg2254z00_13145,BgL_arg2255z00_13146); } break;
default: 
BgL_case_else1198z00_13125:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2257z00_13126;
BgL_arg2257z00_13126 = 
STRUCT_REF(
((obj_t)BgL_ufz00_13117), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10869, BgL_arg2257z00_13126, 
(int)(((long)3)), 
CINT(BgL_arityz00_13118)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1198z00_13125;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_13147;
BgL_z12denvz12_13147 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_13147, BgL_locz00_10869); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10872, 
BINT(BgL_spz00_13121), BgL_sfz00_13120))
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_13119, BgL_sz00_10872, 
BINT(BgL_spz00_13121));}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_13148;
BgL_nsz00_13148 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2259z00_13149;
BgL_arg2259z00_13149 = 
(BgL_spz00_13121+((long)3)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_13148, ((long)2), BgL_sz00_10872, 
BINT(BgL_spz00_13121), 
BINT(BgL_arg2259z00_13149)); } 
VECTOR_SET(BgL_nsz00_13148,((long)1),BgL_sz00_10872); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13147, BgL_nsz00_13148); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_13150;
BgL_ez00_13150 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13150, BgL_sz00_10872); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_13151;
BgL_____rz00_13151 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_13119, BgL_nsz00_13148, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13150); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13147, BgL_sz00_10872); 
return BgL_____rz00_13151;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_13113, 
(int)(((long)3))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_13152;
BgL_nbpz00_13152 = 
(
(long)CINT(BgL_bpz00_13112)+BgL_siza7eza7_10871); 
VECTOR_SET(
((obj_t)BgL_sz00_10872),((long)0),
BINT(BgL_nbpz00_13152)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_18603;
BgL_tmpz00_18603 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_18603, BgL_locz00_10869); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_13153;
BgL_rz00_13153 = 
PROCEDURE_ENTRY(BgL_fz00_13113)(BgL_fz00_13113, BgL_a1z00_13114, BgL_a2z00_13115, BgL_a3z00_13116, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10872),((long)0),BgL_bpz00_13112); 
return BgL_rz00_13153;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10869, BgL_symbzd2funzd2_10870, 
(int)(((long)3)), 
PROCEDURE_ARITY(BgL_fz00_13113));} } } } } } } } 

}



/* &<@anonymous:2263> */
obj_t BGl_z62zc3z04anonymousza32263ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10873, obj_t BgL_sz00_10881)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_10874;obj_t BgL_a1z00_10875;obj_t BgL_a2z00_10876;obj_t BgL_a3z00_10877;obj_t BgL_locz00_10878;obj_t BgL_symbzd2funzd2_10879;long BgL_siza7eza7_10880;
BgL_funz00_10874 = 
PROCEDURE_REF(BgL_envz00_10873, 
(int)(((long)0))); 
BgL_a1z00_10875 = 
PROCEDURE_REF(BgL_envz00_10873, 
(int)(((long)1))); 
BgL_a2z00_10876 = 
PROCEDURE_REF(BgL_envz00_10873, 
(int)(((long)2))); 
BgL_a3z00_10877 = 
PROCEDURE_REF(BgL_envz00_10873, 
(int)(((long)3))); 
BgL_locz00_10878 = 
PROCEDURE_REF(BgL_envz00_10873, 
(int)(((long)4))); 
BgL_symbzd2funzd2_10879 = 
PROCEDURE_REF(BgL_envz00_10873, 
(int)(((long)5))); 
BgL_siza7eza7_10880 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10873, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_13154;
BgL_bpz00_13154 = 
VECTOR_REF(
((obj_t)BgL_sz00_10881),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_13155;obj_t BgL_a1z00_13156;obj_t BgL_a2z00_13157;obj_t BgL_a3z00_13158;
BgL_fz00_13155 = 
PROCEDURE_ENTRY(BgL_funz00_10874)(BgL_funz00_10874, BgL_sz00_10881, BEOA); 
BgL_a1z00_13156 = 
PROCEDURE_ENTRY(BgL_a1z00_10875)(BgL_a1z00_10875, BgL_sz00_10881, BEOA); 
BgL_a2z00_13157 = 
PROCEDURE_ENTRY(BgL_a2z00_10876)(BgL_a2z00_10876, BgL_sz00_10881, BEOA); 
BgL_a3z00_13158 = 
PROCEDURE_ENTRY(BgL_a3z00_10877)(BgL_a3z00_10877, BgL_sz00_10881, BEOA); 
if(
PROCEDUREP(BgL_fz00_13155))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10878, BGl_string5208z00zz__evaluate_compz00, BGl_string5224z00zz__evaluate_compz00, BgL_fz00_13155); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_13159;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_18653;
BgL_tmpz00_18653 = 
((obj_t)BgL_fz00_13155); 
BgL_ufz00_13159 = 
PROCEDURE_ATTR(BgL_tmpz00_18653); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5691z00_18656;
if(
STRUCTP(BgL_ufz00_13159))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5691z00_18656 = 
(
STRUCT_KEY(BgL_ufz00_13159)==BGl_symbol5225z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5691z00_18656 = ((bool_t)0)
; } 
if(BgL_test5691z00_18656)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_13160;obj_t BgL_runz00_13161;obj_t BgL_sfz00_13162;
BgL_arityz00_13160 = 
STRUCT_REF(BgL_ufz00_13159, 
(int)(((long)0))); 
BgL_runz00_13161 = 
STRUCT_REF(BgL_ufz00_13159, 
(int)(((long)1))); 
BgL_sfz00_13162 = 
STRUCT_REF(BgL_ufz00_13159, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_spz00_13163;
BgL_spz00_13163 = 
(
(long)CINT(BgL_bpz00_13154)+BgL_siza7eza7_10880); 
if(
(
(long)CINT(BgL_arityz00_13160)==((long)3)))
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2267z00_13164;
BgL_arg2267z00_13164 = 
(BgL_spz00_13163+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10881),BgL_arg2267z00_13164,BgL_a1z00_13156); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2268z00_13165;
BgL_arg2268z00_13165 = 
(BgL_spz00_13163+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10881),BgL_arg2268z00_13165,BgL_a2z00_13157); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2269z00_13166;
BgL_arg2269z00_13166 = 
(BgL_spz00_13163+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10881),BgL_arg2269z00_13166,BgL_a3z00_13158); } }  else 
{ 

if(
INTEGERP(BgL_arityz00_13160))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_13160)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2271z00_13169;obj_t BgL_arg2272z00_13170;
BgL_arg2271z00_13169 = 
(BgL_spz00_13163+((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2273z00_13171;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2274z00_13172;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2275z00_13173;
BgL_arg2275z00_13173 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13158, BNIL); 
BgL_arg2274z00_13172 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13157, BgL_arg2275z00_13173); } 
BgL_list2273z00_13171 = 
MAKE_YOUNG_PAIR(BgL_a1z00_13156, BgL_arg2274z00_13172); } 
BgL_arg2272z00_13170 = BgL_list2273z00_13171; } 
VECTOR_SET(
((obj_t)BgL_sz00_10881),BgL_arg2271z00_13169,BgL_arg2272z00_13170); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2276z00_13174;
BgL_arg2276z00_13174 = 
(BgL_spz00_13163+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10881),BgL_arg2276z00_13174,BgL_a1z00_13156); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2277z00_13175;obj_t BgL_arg2278z00_13176;
BgL_arg2277z00_13175 = 
(BgL_spz00_13163+((long)1)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2279z00_13177;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2280z00_13178;
BgL_arg2280z00_13178 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13158, BNIL); 
BgL_list2279z00_13177 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13157, BgL_arg2280z00_13178); } 
BgL_arg2278z00_13176 = BgL_list2279z00_13177; } 
VECTOR_SET(
((obj_t)BgL_sz00_10881),BgL_arg2277z00_13175,BgL_arg2278z00_13176); } break;case ((long)-3) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2281z00_13179;
BgL_arg2281z00_13179 = 
(BgL_spz00_13163+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10881),BgL_arg2281z00_13179,BgL_a1z00_13156); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2282z00_13180;
BgL_arg2282z00_13180 = 
(BgL_spz00_13163+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10881),BgL_arg2282z00_13180,BgL_a2z00_13157); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2283z00_13181;obj_t BgL_arg2284z00_13182;
BgL_arg2283z00_13181 = 
(BgL_spz00_13163+((long)2)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2285z00_13183;
BgL_list2285z00_13183 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13158, BNIL); 
BgL_arg2284z00_13182 = BgL_list2285z00_13183; } 
VECTOR_SET(
((obj_t)BgL_sz00_10881),BgL_arg2283z00_13181,BgL_arg2284z00_13182); } break;case ((long)-4) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2286z00_13184;
BgL_arg2286z00_13184 = 
(BgL_spz00_13163+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10881),BgL_arg2286z00_13184,BgL_a1z00_13156); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2287z00_13185;
BgL_arg2287z00_13185 = 
(BgL_spz00_13163+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10881),BgL_arg2287z00_13185,BgL_a2z00_13157); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2288z00_13186;
BgL_arg2288z00_13186 = 
(BgL_spz00_13163+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10881),BgL_arg2288z00_13186,BgL_a3z00_13158); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2289z00_13187;obj_t BgL_arg2290z00_13188;
BgL_arg2289z00_13187 = 
(BgL_spz00_13163+((long)3)); 
BgL_arg2290z00_13188 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10881),BgL_arg2289z00_13187,BgL_arg2290z00_13188); } break;
default: 
BgL_case_else1200z00_13167:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2292z00_13168;
BgL_arg2292z00_13168 = 
STRUCT_REF(
((obj_t)BgL_ufz00_13159), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10878, BgL_arg2292z00_13168, 
(int)(((long)3)), 
CINT(BgL_arityz00_13160)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1200z00_13167;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_13189;
BgL_z12denvz12_13189 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10881, 
BINT(BgL_spz00_13163), BgL_sfz00_13162))
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_13161, BgL_sz00_10881, 
BINT(BgL_spz00_13163));}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_13190;
BgL_nsz00_13190 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2294z00_13191;
BgL_arg2294z00_13191 = 
(BgL_spz00_13163+((long)3)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_13190, ((long)2), BgL_sz00_10881, 
BINT(BgL_spz00_13163), 
BINT(BgL_arg2294z00_13191)); } 
VECTOR_SET(BgL_nsz00_13190,((long)1),BgL_sz00_10881); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13189, BgL_nsz00_13190); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_13192;
BgL_ez00_13192 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13192, BgL_sz00_10881); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_13193;
BgL_____rz00_13193 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_13161, BgL_nsz00_13190, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13192); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13189, BgL_sz00_10881); 
return BgL_____rz00_13193;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_13155, 
(int)(((long)3))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_13194;
BgL_nbpz00_13194 = 
(
(long)CINT(BgL_bpz00_13154)+BgL_siza7eza7_10880); 
VECTOR_SET(
((obj_t)BgL_sz00_10881),((long)0),
BINT(BgL_nbpz00_13194)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_13195;
BgL_rz00_13195 = 
PROCEDURE_ENTRY(BgL_fz00_13155)(BgL_fz00_13155, BgL_a1z00_13156, BgL_a2z00_13157, BgL_a3z00_13158, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10881),((long)0),BgL_bpz00_13154); 
return BgL_rz00_13195;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10878, BgL_symbzd2funzd2_10879, 
(int)(((long)3)), 
PROCEDURE_ARITY(BgL_fz00_13155));} } } } } } } } 

}



/* comp-call4 */
obj_t BGl_compzd2call4zd2zz__evaluate_compz00(obj_t BgL_locz00_172, BgL_ev_exprz00_bglt BgL_vfunz00_173, obj_t BgL_symbzd2funzd2_174, obj_t BgL_funz00_175, obj_t BgL_tailzf3zf3_176, obj_t BgL_stkz00_177, long BgL_siza7eza7_178, obj_t BgL_a1z00_179, obj_t BgL_a2z00_180, obj_t BgL_a3z00_181, obj_t BgL_a4z00_182)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_cfunz00_2729;
BgL_cfunz00_2729 = 
BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_173, ((long)4), BgL_locz00_172, BgL_symbzd2funzd2_174); 
if(
CBOOL(BgL_cfunz00_2729))
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5698z00_18768;
{ /* Eval/evaluate_comp.scm 896 */
int BgL_arg2303z00_2751;
BgL_arg2303z00_2751 = 
bgl_debug(); 
BgL_test5698z00_18768 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg2303z00_2751), 
BINT(((long)0))); } 
if(BgL_test5698z00_18768)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32300ze3z87_10882;
BgL_zc3z04anonymousza32300ze3z87_10882 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32300ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32300ze3z87_10882, 
(int)(((long)0)), BgL_a1z00_179); 
PROCEDURE_SET(BgL_zc3z04anonymousza32300ze3z87_10882, 
(int)(((long)1)), BgL_a2z00_180); 
PROCEDURE_SET(BgL_zc3z04anonymousza32300ze3z87_10882, 
(int)(((long)2)), BgL_a3z00_181); 
PROCEDURE_SET(BgL_zc3z04anonymousza32300ze3z87_10882, 
(int)(((long)3)), BgL_a4z00_182); 
PROCEDURE_SET(BgL_zc3z04anonymousza32300ze3z87_10882, 
(int)(((long)4)), 
BINT(BgL_siza7eza7_178)); 
PROCEDURE_SET(BgL_zc3z04anonymousza32300ze3z87_10882, 
(int)(((long)5)), BgL_locz00_172); 
PROCEDURE_SET(BgL_zc3z04anonymousza32300ze3z87_10882, 
(int)(((long)6)), BgL_cfunz00_2729); 
return BgL_zc3z04anonymousza32300ze3z87_10882;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32302ze3z87_10883;
BgL_zc3z04anonymousza32302ze3z87_10883 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32302ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32302ze3z87_10883, 
(int)(((long)0)), BgL_a1z00_179); 
PROCEDURE_SET(BgL_zc3z04anonymousza32302ze3z87_10883, 
(int)(((long)1)), BgL_a2z00_180); 
PROCEDURE_SET(BgL_zc3z04anonymousza32302ze3z87_10883, 
(int)(((long)2)), BgL_a3z00_181); 
PROCEDURE_SET(BgL_zc3z04anonymousza32302ze3z87_10883, 
(int)(((long)3)), BgL_a4z00_182); 
PROCEDURE_SET(BgL_zc3z04anonymousza32302ze3z87_10883, 
(int)(((long)4)), 
BINT(BgL_siza7eza7_178)); 
PROCEDURE_SET(BgL_zc3z04anonymousza32302ze3z87_10883, 
(int)(((long)5)), BgL_cfunz00_2729); 
return BgL_zc3z04anonymousza32302ze3z87_10883;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
CBOOL(BgL_tailzf3zf3_176))
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5700z00_18809;
{ /* Eval/evaluate_comp.scm 896 */
int BgL_arg2397z00_2887;
BgL_arg2397z00_2887 = 
bgl_debug(); 
BgL_test5700z00_18809 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg2397z00_2887), 
BINT(((long)0))); } 
if(BgL_test5700z00_18809)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32306ze3z87_10884;
BgL_zc3z04anonymousza32306ze3z87_10884 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32306ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)8))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32306ze3z87_10884, 
(int)(((long)0)), BgL_funz00_175); 
PROCEDURE_SET(BgL_zc3z04anonymousza32306ze3z87_10884, 
(int)(((long)1)), BgL_a1z00_179); 
PROCEDURE_SET(BgL_zc3z04anonymousza32306ze3z87_10884, 
(int)(((long)2)), BgL_a2z00_180); 
PROCEDURE_SET(BgL_zc3z04anonymousza32306ze3z87_10884, 
(int)(((long)3)), BgL_a3z00_181); 
PROCEDURE_SET(BgL_zc3z04anonymousza32306ze3z87_10884, 
(int)(((long)4)), BgL_a4z00_182); 
PROCEDURE_SET(BgL_zc3z04anonymousza32306ze3z87_10884, 
(int)(((long)5)), BgL_locz00_172); 
PROCEDURE_SET(BgL_zc3z04anonymousza32306ze3z87_10884, 
(int)(((long)6)), BgL_symbzd2funzd2_174); 
PROCEDURE_SET(BgL_zc3z04anonymousza32306ze3z87_10884, 
(int)(((long)7)), 
BINT(BgL_siza7eza7_178)); 
return BgL_zc3z04anonymousza32306ze3z87_10884;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32352ze3z87_10885;
BgL_zc3z04anonymousza32352ze3z87_10885 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32352ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)8))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32352ze3z87_10885, 
(int)(((long)0)), BgL_funz00_175); 
PROCEDURE_SET(BgL_zc3z04anonymousza32352ze3z87_10885, 
(int)(((long)1)), BgL_a1z00_179); 
PROCEDURE_SET(BgL_zc3z04anonymousza32352ze3z87_10885, 
(int)(((long)2)), BgL_a2z00_180); 
PROCEDURE_SET(BgL_zc3z04anonymousza32352ze3z87_10885, 
(int)(((long)3)), BgL_a3z00_181); 
PROCEDURE_SET(BgL_zc3z04anonymousza32352ze3z87_10885, 
(int)(((long)4)), BgL_a4z00_182); 
PROCEDURE_SET(BgL_zc3z04anonymousza32352ze3z87_10885, 
(int)(((long)5)), BgL_locz00_172); 
PROCEDURE_SET(BgL_zc3z04anonymousza32352ze3z87_10885, 
(int)(((long)6)), BgL_symbzd2funzd2_174); 
PROCEDURE_SET(BgL_zc3z04anonymousza32352ze3z87_10885, 
(int)(((long)7)), 
BINT(BgL_siza7eza7_178)); 
return BgL_zc3z04anonymousza32352ze3z87_10885;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5701z00_18854;
{ /* Eval/evaluate_comp.scm 896 */
int BgL_arg2491z00_3023;
BgL_arg2491z00_3023 = 
bgl_debug(); 
BgL_test5701z00_18854 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg2491z00_3023), 
BINT(((long)0))); } 
if(BgL_test5701z00_18854)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32400ze3z87_10886;
BgL_zc3z04anonymousza32400ze3z87_10886 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32400ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)8))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32400ze3z87_10886, 
(int)(((long)0)), BgL_funz00_175); 
PROCEDURE_SET(BgL_zc3z04anonymousza32400ze3z87_10886, 
(int)(((long)1)), BgL_a1z00_179); 
PROCEDURE_SET(BgL_zc3z04anonymousza32400ze3z87_10886, 
(int)(((long)2)), BgL_a2z00_180); 
PROCEDURE_SET(BgL_zc3z04anonymousza32400ze3z87_10886, 
(int)(((long)3)), BgL_a3z00_181); 
PROCEDURE_SET(BgL_zc3z04anonymousza32400ze3z87_10886, 
(int)(((long)4)), BgL_a4z00_182); 
PROCEDURE_SET(BgL_zc3z04anonymousza32400ze3z87_10886, 
(int)(((long)5)), BgL_locz00_172); 
PROCEDURE_SET(BgL_zc3z04anonymousza32400ze3z87_10886, 
(int)(((long)6)), BgL_symbzd2funzd2_174); 
PROCEDURE_SET(BgL_zc3z04anonymousza32400ze3z87_10886, 
(int)(((long)7)), 
BINT(BgL_siza7eza7_178)); 
return BgL_zc3z04anonymousza32400ze3z87_10886;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32446ze3z87_10887;
BgL_zc3z04anonymousza32446ze3z87_10887 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32446ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)8))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32446ze3z87_10887, 
(int)(((long)0)), BgL_funz00_175); 
PROCEDURE_SET(BgL_zc3z04anonymousza32446ze3z87_10887, 
(int)(((long)1)), BgL_a1z00_179); 
PROCEDURE_SET(BgL_zc3z04anonymousza32446ze3z87_10887, 
(int)(((long)2)), BgL_a2z00_180); 
PROCEDURE_SET(BgL_zc3z04anonymousza32446ze3z87_10887, 
(int)(((long)3)), BgL_a3z00_181); 
PROCEDURE_SET(BgL_zc3z04anonymousza32446ze3z87_10887, 
(int)(((long)4)), BgL_a4z00_182); 
PROCEDURE_SET(BgL_zc3z04anonymousza32446ze3z87_10887, 
(int)(((long)5)), BgL_locz00_172); 
PROCEDURE_SET(BgL_zc3z04anonymousza32446ze3z87_10887, 
(int)(((long)6)), BgL_symbzd2funzd2_174); 
PROCEDURE_SET(BgL_zc3z04anonymousza32446ze3z87_10887, 
(int)(((long)7)), 
BINT(BgL_siza7eza7_178)); 
return BgL_zc3z04anonymousza32446ze3z87_10887;} } } } } 

}



/* &<@anonymous:2300> */
obj_t BGl_z62zc3z04anonymousza32300ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10888, obj_t BgL_sz00_10896)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_a1z00_10889;obj_t BgL_a2z00_10890;obj_t BgL_a3z00_10891;obj_t BgL_a4z00_10892;long BgL_siza7eza7_10893;obj_t BgL_locz00_10894;obj_t BgL_cfunz00_10895;
BgL_a1z00_10889 = 
PROCEDURE_REF(BgL_envz00_10888, 
(int)(((long)0))); 
BgL_a2z00_10890 = 
PROCEDURE_REF(BgL_envz00_10888, 
(int)(((long)1))); 
BgL_a3z00_10891 = 
PROCEDURE_REF(BgL_envz00_10888, 
(int)(((long)2))); 
BgL_a4z00_10892 = 
PROCEDURE_REF(BgL_envz00_10888, 
(int)(((long)3))); 
BgL_siza7eza7_10893 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10888, 
(int)(((long)4)))); 
BgL_locz00_10894 = 
PROCEDURE_REF(BgL_envz00_10888, 
(int)(((long)5))); 
BgL_cfunz00_10895 = 
PROCEDURE_REF(BgL_envz00_10888, 
(int)(((long)6))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_13196;
BgL_bpz00_13196 = 
VECTOR_REF(
((obj_t)BgL_sz00_10896),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_a1z00_13197;obj_t BgL_a2z00_13198;obj_t BgL_a3z00_13199;obj_t BgL_a4z00_13200;
BgL_a1z00_13197 = 
PROCEDURE_ENTRY(BgL_a1z00_10889)(BgL_a1z00_10889, BgL_sz00_10896, BEOA); 
BgL_a2z00_13198 = 
PROCEDURE_ENTRY(BgL_a2z00_10890)(BgL_a2z00_10890, BgL_sz00_10896, BEOA); 
BgL_a3z00_13199 = 
PROCEDURE_ENTRY(BgL_a3z00_10891)(BgL_a3z00_10891, BgL_sz00_10896, BEOA); 
BgL_a4z00_13200 = 
PROCEDURE_ENTRY(BgL_a4z00_10892)(BgL_a4z00_10892, BgL_sz00_10896, BEOA); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_13201;
BgL_nbpz00_13201 = 
(
(long)CINT(BgL_bpz00_13196)+BgL_siza7eza7_10893); 
VECTOR_SET(
((obj_t)BgL_sz00_10896),((long)0),
BINT(BgL_nbpz00_13201)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_18937;
BgL_tmpz00_18937 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_18937, BgL_locz00_10894); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_13202;
BgL_rz00_13202 = 
PROCEDURE_ENTRY(BgL_cfunz00_10895)(BgL_cfunz00_10895, BgL_a1z00_13197, BgL_a2z00_13198, BgL_a3z00_13199, BgL_a4z00_13200, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10896),((long)0),BgL_bpz00_13196); 
return BgL_rz00_13202;} } } } } } 

}



/* &<@anonymous:2302> */
obj_t BGl_z62zc3z04anonymousza32302ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10897, obj_t BgL_sz00_10904)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_a1z00_10898;obj_t BgL_a2z00_10899;obj_t BgL_a3z00_10900;obj_t BgL_a4z00_10901;long BgL_siza7eza7_10902;obj_t BgL_cfunz00_10903;
BgL_a1z00_10898 = 
PROCEDURE_REF(BgL_envz00_10897, 
(int)(((long)0))); 
BgL_a2z00_10899 = 
PROCEDURE_REF(BgL_envz00_10897, 
(int)(((long)1))); 
BgL_a3z00_10900 = 
PROCEDURE_REF(BgL_envz00_10897, 
(int)(((long)2))); 
BgL_a4z00_10901 = 
PROCEDURE_REF(BgL_envz00_10897, 
(int)(((long)3))); 
BgL_siza7eza7_10902 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10897, 
(int)(((long)4)))); 
BgL_cfunz00_10903 = 
PROCEDURE_REF(BgL_envz00_10897, 
(int)(((long)5))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_13203;
BgL_bpz00_13203 = 
VECTOR_REF(
((obj_t)BgL_sz00_10904),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_a1z00_13204;obj_t BgL_a2z00_13205;obj_t BgL_a3z00_13206;obj_t BgL_a4z00_13207;
BgL_a1z00_13204 = 
PROCEDURE_ENTRY(BgL_a1z00_10898)(BgL_a1z00_10898, BgL_sz00_10904, BEOA); 
BgL_a2z00_13205 = 
PROCEDURE_ENTRY(BgL_a2z00_10899)(BgL_a2z00_10899, BgL_sz00_10904, BEOA); 
BgL_a3z00_13206 = 
PROCEDURE_ENTRY(BgL_a3z00_10900)(BgL_a3z00_10900, BgL_sz00_10904, BEOA); 
BgL_a4z00_13207 = 
PROCEDURE_ENTRY(BgL_a4z00_10901)(BgL_a4z00_10901, BgL_sz00_10904, BEOA); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_13208;
BgL_nbpz00_13208 = 
(
(long)CINT(BgL_bpz00_13203)+BgL_siza7eza7_10902); 
VECTOR_SET(
((obj_t)BgL_sz00_10904),((long)0),
BINT(BgL_nbpz00_13208)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_13209;
BgL_rz00_13209 = 
PROCEDURE_ENTRY(BgL_cfunz00_10903)(BgL_cfunz00_10903, BgL_a1z00_13204, BgL_a2z00_13205, BgL_a3z00_13206, BgL_a4z00_13207, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10904),((long)0),BgL_bpz00_13203); 
return BgL_rz00_13209;} } } } } } 

}



/* &<@anonymous:2306> */
obj_t BGl_z62zc3z04anonymousza32306ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10905, obj_t BgL_sz00_10914)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_10906;obj_t BgL_a1z00_10907;obj_t BgL_a2z00_10908;obj_t BgL_a3z00_10909;obj_t BgL_a4z00_10910;obj_t BgL_locz00_10911;obj_t BgL_symbzd2funzd2_10912;long BgL_siza7eza7_10913;
BgL_funz00_10906 = 
PROCEDURE_REF(BgL_envz00_10905, 
(int)(((long)0))); 
BgL_a1z00_10907 = 
PROCEDURE_REF(BgL_envz00_10905, 
(int)(((long)1))); 
BgL_a2z00_10908 = 
PROCEDURE_REF(BgL_envz00_10905, 
(int)(((long)2))); 
BgL_a3z00_10909 = 
PROCEDURE_REF(BgL_envz00_10905, 
(int)(((long)3))); 
BgL_a4z00_10910 = 
PROCEDURE_REF(BgL_envz00_10905, 
(int)(((long)4))); 
BgL_locz00_10911 = 
PROCEDURE_REF(BgL_envz00_10905, 
(int)(((long)5))); 
BgL_symbzd2funzd2_10912 = 
PROCEDURE_REF(BgL_envz00_10905, 
(int)(((long)6))); 
BgL_siza7eza7_10913 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10905, 
(int)(((long)7)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_13210;
BgL_bpz00_13210 = 
VECTOR_REF(
((obj_t)BgL_sz00_10914),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_13211;obj_t BgL_a1z00_13212;obj_t BgL_a2z00_13213;obj_t BgL_a3z00_13214;obj_t BgL_a4z00_13215;
BgL_fz00_13211 = 
PROCEDURE_ENTRY(BgL_funz00_10906)(BgL_funz00_10906, BgL_sz00_10914, BEOA); 
BgL_a1z00_13212 = 
PROCEDURE_ENTRY(BgL_a1z00_10907)(BgL_a1z00_10907, BgL_sz00_10914, BEOA); 
BgL_a2z00_13213 = 
PROCEDURE_ENTRY(BgL_a2z00_10908)(BgL_a2z00_10908, BgL_sz00_10914, BEOA); 
BgL_a3z00_13214 = 
PROCEDURE_ENTRY(BgL_a3z00_10909)(BgL_a3z00_10909, BgL_sz00_10914, BEOA); 
BgL_a4z00_13215 = 
PROCEDURE_ENTRY(BgL_a4z00_10910)(BgL_a4z00_10910, BgL_sz00_10914, BEOA); 
if(
PROCEDUREP(BgL_fz00_13211))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10911, BGl_string5208z00zz__evaluate_compz00, BGl_string5224z00zz__evaluate_compz00, BgL_fz00_13211); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_13216;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_19036;
BgL_tmpz00_19036 = 
((obj_t)BgL_fz00_13211); 
BgL_ufz00_13216 = 
PROCEDURE_ATTR(BgL_tmpz00_19036); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5703z00_19039;
if(
STRUCTP(BgL_ufz00_13216))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5703z00_19039 = 
(
STRUCT_KEY(BgL_ufz00_13216)==BGl_symbol5225z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5703z00_19039 = ((bool_t)0)
; } 
if(BgL_test5703z00_19039)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_13217;obj_t BgL_runz00_13218;obj_t BgL_sfz00_13219;
BgL_arityz00_13217 = 
STRUCT_REF(BgL_ufz00_13216, 
(int)(((long)0))); 
BgL_runz00_13218 = 
STRUCT_REF(BgL_ufz00_13216, 
(int)(((long)1))); 
BgL_sfz00_13219 = 
STRUCT_REF(BgL_ufz00_13216, 
(int)(((long)2))); 
if(
(
(long)CINT(BgL_arityz00_13217)==((long)4)))
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2310z00_13220;
BgL_arg2310z00_13220 = 
(
(long)CINT(BgL_bpz00_13210)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10914),BgL_arg2310z00_13220,BgL_a1z00_13212); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2311z00_13221;
BgL_arg2311z00_13221 = 
(
(long)CINT(BgL_bpz00_13210)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10914),BgL_arg2311z00_13221,BgL_a2z00_13213); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2312z00_13222;
BgL_arg2312z00_13222 = 
(
(long)CINT(BgL_bpz00_13210)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10914),BgL_arg2312z00_13222,BgL_a3z00_13214); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2313z00_13223;
BgL_arg2313z00_13223 = 
(
(long)CINT(BgL_bpz00_13210)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_10914),BgL_arg2313z00_13223,BgL_a4z00_13215); } }  else 
{ 

if(
INTEGERP(BgL_arityz00_13217))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_13217)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2315z00_13226;obj_t BgL_arg2316z00_13227;
BgL_arg2315z00_13226 = 
(
(long)CINT(BgL_bpz00_13210)+((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2317z00_13228;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2318z00_13229;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2319z00_13230;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2320z00_13231;
BgL_arg2320z00_13231 = 
MAKE_YOUNG_PAIR(BgL_a4z00_13215, BNIL); 
BgL_arg2319z00_13230 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13214, BgL_arg2320z00_13231); } 
BgL_arg2318z00_13229 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13213, BgL_arg2319z00_13230); } 
BgL_list2317z00_13228 = 
MAKE_YOUNG_PAIR(BgL_a1z00_13212, BgL_arg2318z00_13229); } 
BgL_arg2316z00_13227 = BgL_list2317z00_13228; } 
VECTOR_SET(
((obj_t)BgL_sz00_10914),BgL_arg2315z00_13226,BgL_arg2316z00_13227); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2321z00_13232;
BgL_arg2321z00_13232 = 
(
(long)CINT(BgL_bpz00_13210)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10914),BgL_arg2321z00_13232,BgL_a1z00_13212); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2322z00_13233;obj_t BgL_arg2323z00_13234;
BgL_arg2322z00_13233 = 
(
(long)CINT(BgL_bpz00_13210)+((long)1)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2324z00_13235;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2325z00_13236;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2326z00_13237;
BgL_arg2326z00_13237 = 
MAKE_YOUNG_PAIR(BgL_a4z00_13215, BNIL); 
BgL_arg2325z00_13236 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13214, BgL_arg2326z00_13237); } 
BgL_list2324z00_13235 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13213, BgL_arg2325z00_13236); } 
BgL_arg2323z00_13234 = BgL_list2324z00_13235; } 
VECTOR_SET(
((obj_t)BgL_sz00_10914),BgL_arg2322z00_13233,BgL_arg2323z00_13234); } break;case ((long)-3) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2327z00_13238;
BgL_arg2327z00_13238 = 
(
(long)CINT(BgL_bpz00_13210)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10914),BgL_arg2327z00_13238,BgL_a1z00_13212); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2328z00_13239;
BgL_arg2328z00_13239 = 
(
(long)CINT(BgL_bpz00_13210)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10914),BgL_arg2328z00_13239,BgL_a2z00_13213); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2329z00_13240;obj_t BgL_arg2330z00_13241;
BgL_arg2329z00_13240 = 
(
(long)CINT(BgL_bpz00_13210)+((long)2)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2331z00_13242;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2332z00_13243;
BgL_arg2332z00_13243 = 
MAKE_YOUNG_PAIR(BgL_a4z00_13215, BNIL); 
BgL_list2331z00_13242 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13214, BgL_arg2332z00_13243); } 
BgL_arg2330z00_13241 = BgL_list2331z00_13242; } 
VECTOR_SET(
((obj_t)BgL_sz00_10914),BgL_arg2329z00_13240,BgL_arg2330z00_13241); } break;case ((long)-4) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2333z00_13244;
BgL_arg2333z00_13244 = 
(
(long)CINT(BgL_bpz00_13210)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10914),BgL_arg2333z00_13244,BgL_a1z00_13212); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2334z00_13245;
BgL_arg2334z00_13245 = 
(
(long)CINT(BgL_bpz00_13210)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10914),BgL_arg2334z00_13245,BgL_a2z00_13213); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2335z00_13246;
BgL_arg2335z00_13246 = 
(
(long)CINT(BgL_bpz00_13210)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10914),BgL_arg2335z00_13246,BgL_a3z00_13214); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2336z00_13247;obj_t BgL_arg2337z00_13248;
BgL_arg2336z00_13247 = 
(
(long)CINT(BgL_bpz00_13210)+((long)3)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2338z00_13249;
BgL_list2338z00_13249 = 
MAKE_YOUNG_PAIR(BgL_a4z00_13215, BNIL); 
BgL_arg2337z00_13248 = BgL_list2338z00_13249; } 
VECTOR_SET(
((obj_t)BgL_sz00_10914),BgL_arg2336z00_13247,BgL_arg2337z00_13248); } break;case ((long)-5) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2339z00_13250;
BgL_arg2339z00_13250 = 
(
(long)CINT(BgL_bpz00_13210)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10914),BgL_arg2339z00_13250,BgL_a1z00_13212); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2340z00_13251;
BgL_arg2340z00_13251 = 
(
(long)CINT(BgL_bpz00_13210)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10914),BgL_arg2340z00_13251,BgL_a2z00_13213); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2341z00_13252;
BgL_arg2341z00_13252 = 
(
(long)CINT(BgL_bpz00_13210)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10914),BgL_arg2341z00_13252,BgL_a3z00_13214); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2342z00_13253;
BgL_arg2342z00_13253 = 
(
(long)CINT(BgL_bpz00_13210)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_10914),BgL_arg2342z00_13253,BgL_a4z00_13215); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2343z00_13254;obj_t BgL_arg2344z00_13255;
BgL_arg2343z00_13254 = 
(
(long)CINT(BgL_bpz00_13210)+((long)4)); 
BgL_arg2344z00_13255 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10914),BgL_arg2343z00_13254,BgL_arg2344z00_13255); } break;
default: 
BgL_case_else1202z00_13224:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2346z00_13225;
BgL_arg2346z00_13225 = 
STRUCT_REF(
((obj_t)BgL_ufz00_13216), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10911, BgL_arg2346z00_13225, 
(int)(((long)4)), 
CINT(BgL_arityz00_13217)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1202z00_13224;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_13256;
BgL_z12denvz12_13256 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_13256, BgL_locz00_10911); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10914, BgL_bpz00_13210, BgL_sfz00_13219))
{ /* Eval/evaluate_comp.scm 896 */
return BgL_runz00_13218;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_13257;
BgL_nsz00_13257 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2348z00_13258;
BgL_arg2348z00_13258 = 
(
(long)CINT(BgL_bpz00_13210)+((long)4)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_13257, ((long)2), BgL_sz00_10914, BgL_bpz00_13210, 
BINT(BgL_arg2348z00_13258)); } 
VECTOR_SET(BgL_nsz00_13257,((long)1),BgL_sz00_10914); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13256, BgL_nsz00_13257); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_13259;
BgL_ez00_13259 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13259, BgL_sz00_10914); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_13260;
BgL_____rz00_13260 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_13218, BgL_nsz00_13257, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13259); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13256, BgL_sz00_10914); 
return BgL_____rz00_13260;} } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_13211, 
(int)(((long)4))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_13261;
BgL_nbpz00_13261 = 
(
(long)CINT(BgL_bpz00_13210)+BgL_siza7eza7_10913); 
VECTOR_SET(
((obj_t)BgL_sz00_10914),((long)0),
BINT(BgL_nbpz00_13261)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_19174;
BgL_tmpz00_19174 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_19174, BgL_locz00_10911); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_13262;
BgL_rz00_13262 = 
PROCEDURE_ENTRY(BgL_fz00_13211)(BgL_fz00_13211, BgL_a1z00_13212, BgL_a2z00_13213, BgL_a3z00_13214, BgL_a4z00_13215, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10914),((long)0),BgL_bpz00_13210); 
return BgL_rz00_13262;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10911, BgL_symbzd2funzd2_10912, 
(int)(((long)4)), 
PROCEDURE_ARITY(BgL_fz00_13211));} } } } } } } } 

}



/* &<@anonymous:2352> */
obj_t BGl_z62zc3z04anonymousza32352ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10915, obj_t BgL_sz00_10924)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_10916;obj_t BgL_a1z00_10917;obj_t BgL_a2z00_10918;obj_t BgL_a3z00_10919;obj_t BgL_a4z00_10920;obj_t BgL_locz00_10921;obj_t BgL_symbzd2funzd2_10922;long BgL_siza7eza7_10923;
BgL_funz00_10916 = 
PROCEDURE_REF(BgL_envz00_10915, 
(int)(((long)0))); 
BgL_a1z00_10917 = 
PROCEDURE_REF(BgL_envz00_10915, 
(int)(((long)1))); 
BgL_a2z00_10918 = 
PROCEDURE_REF(BgL_envz00_10915, 
(int)(((long)2))); 
BgL_a3z00_10919 = 
PROCEDURE_REF(BgL_envz00_10915, 
(int)(((long)3))); 
BgL_a4z00_10920 = 
PROCEDURE_REF(BgL_envz00_10915, 
(int)(((long)4))); 
BgL_locz00_10921 = 
PROCEDURE_REF(BgL_envz00_10915, 
(int)(((long)5))); 
BgL_symbzd2funzd2_10922 = 
PROCEDURE_REF(BgL_envz00_10915, 
(int)(((long)6))); 
BgL_siza7eza7_10923 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10915, 
(int)(((long)7)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_13263;
BgL_bpz00_13263 = 
VECTOR_REF(
((obj_t)BgL_sz00_10924),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_13264;obj_t BgL_a1z00_13265;obj_t BgL_a2z00_13266;obj_t BgL_a3z00_13267;obj_t BgL_a4z00_13268;
BgL_fz00_13264 = 
PROCEDURE_ENTRY(BgL_funz00_10916)(BgL_funz00_10916, BgL_sz00_10924, BEOA); 
BgL_a1z00_13265 = 
PROCEDURE_ENTRY(BgL_a1z00_10917)(BgL_a1z00_10917, BgL_sz00_10924, BEOA); 
BgL_a2z00_13266 = 
PROCEDURE_ENTRY(BgL_a2z00_10918)(BgL_a2z00_10918, BgL_sz00_10924, BEOA); 
BgL_a3z00_13267 = 
PROCEDURE_ENTRY(BgL_a3z00_10919)(BgL_a3z00_10919, BgL_sz00_10924, BEOA); 
BgL_a4z00_13268 = 
PROCEDURE_ENTRY(BgL_a4z00_10920)(BgL_a4z00_10920, BgL_sz00_10924, BEOA); 
if(
PROCEDUREP(BgL_fz00_13264))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10921, BGl_string5208z00zz__evaluate_compz00, BGl_string5224z00zz__evaluate_compz00, BgL_fz00_13264); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_13269;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_19231;
BgL_tmpz00_19231 = 
((obj_t)BgL_fz00_13264); 
BgL_ufz00_13269 = 
PROCEDURE_ATTR(BgL_tmpz00_19231); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5710z00_19234;
if(
STRUCTP(BgL_ufz00_13269))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5710z00_19234 = 
(
STRUCT_KEY(BgL_ufz00_13269)==BGl_symbol5225z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5710z00_19234 = ((bool_t)0)
; } 
if(BgL_test5710z00_19234)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_13270;obj_t BgL_runz00_13271;obj_t BgL_sfz00_13272;
BgL_arityz00_13270 = 
STRUCT_REF(BgL_ufz00_13269, 
(int)(((long)0))); 
BgL_runz00_13271 = 
STRUCT_REF(BgL_ufz00_13269, 
(int)(((long)1))); 
BgL_sfz00_13272 = 
STRUCT_REF(BgL_ufz00_13269, 
(int)(((long)2))); 
if(
(
(long)CINT(BgL_arityz00_13270)==((long)4)))
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2356z00_13273;
BgL_arg2356z00_13273 = 
(
(long)CINT(BgL_bpz00_13263)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10924),BgL_arg2356z00_13273,BgL_a1z00_13265); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2357z00_13274;
BgL_arg2357z00_13274 = 
(
(long)CINT(BgL_bpz00_13263)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10924),BgL_arg2357z00_13274,BgL_a2z00_13266); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2358z00_13275;
BgL_arg2358z00_13275 = 
(
(long)CINT(BgL_bpz00_13263)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10924),BgL_arg2358z00_13275,BgL_a3z00_13267); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2359z00_13276;
BgL_arg2359z00_13276 = 
(
(long)CINT(BgL_bpz00_13263)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_10924),BgL_arg2359z00_13276,BgL_a4z00_13268); } }  else 
{ 

if(
INTEGERP(BgL_arityz00_13270))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_13270)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2361z00_13279;obj_t BgL_arg2362z00_13280;
BgL_arg2361z00_13279 = 
(
(long)CINT(BgL_bpz00_13263)+((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2363z00_13281;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2364z00_13282;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2365z00_13283;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2366z00_13284;
BgL_arg2366z00_13284 = 
MAKE_YOUNG_PAIR(BgL_a4z00_13268, BNIL); 
BgL_arg2365z00_13283 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13267, BgL_arg2366z00_13284); } 
BgL_arg2364z00_13282 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13266, BgL_arg2365z00_13283); } 
BgL_list2363z00_13281 = 
MAKE_YOUNG_PAIR(BgL_a1z00_13265, BgL_arg2364z00_13282); } 
BgL_arg2362z00_13280 = BgL_list2363z00_13281; } 
VECTOR_SET(
((obj_t)BgL_sz00_10924),BgL_arg2361z00_13279,BgL_arg2362z00_13280); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2367z00_13285;
BgL_arg2367z00_13285 = 
(
(long)CINT(BgL_bpz00_13263)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10924),BgL_arg2367z00_13285,BgL_a1z00_13265); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2368z00_13286;obj_t BgL_arg2369z00_13287;
BgL_arg2368z00_13286 = 
(
(long)CINT(BgL_bpz00_13263)+((long)1)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2370z00_13288;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2371z00_13289;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2372z00_13290;
BgL_arg2372z00_13290 = 
MAKE_YOUNG_PAIR(BgL_a4z00_13268, BNIL); 
BgL_arg2371z00_13289 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13267, BgL_arg2372z00_13290); } 
BgL_list2370z00_13288 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13266, BgL_arg2371z00_13289); } 
BgL_arg2369z00_13287 = BgL_list2370z00_13288; } 
VECTOR_SET(
((obj_t)BgL_sz00_10924),BgL_arg2368z00_13286,BgL_arg2369z00_13287); } break;case ((long)-3) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2373z00_13291;
BgL_arg2373z00_13291 = 
(
(long)CINT(BgL_bpz00_13263)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10924),BgL_arg2373z00_13291,BgL_a1z00_13265); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2374z00_13292;
BgL_arg2374z00_13292 = 
(
(long)CINT(BgL_bpz00_13263)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10924),BgL_arg2374z00_13292,BgL_a2z00_13266); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2375z00_13293;obj_t BgL_arg2376z00_13294;
BgL_arg2375z00_13293 = 
(
(long)CINT(BgL_bpz00_13263)+((long)2)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2377z00_13295;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2378z00_13296;
BgL_arg2378z00_13296 = 
MAKE_YOUNG_PAIR(BgL_a4z00_13268, BNIL); 
BgL_list2377z00_13295 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13267, BgL_arg2378z00_13296); } 
BgL_arg2376z00_13294 = BgL_list2377z00_13295; } 
VECTOR_SET(
((obj_t)BgL_sz00_10924),BgL_arg2375z00_13293,BgL_arg2376z00_13294); } break;case ((long)-4) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2379z00_13297;
BgL_arg2379z00_13297 = 
(
(long)CINT(BgL_bpz00_13263)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10924),BgL_arg2379z00_13297,BgL_a1z00_13265); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2380z00_13298;
BgL_arg2380z00_13298 = 
(
(long)CINT(BgL_bpz00_13263)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10924),BgL_arg2380z00_13298,BgL_a2z00_13266); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2381z00_13299;
BgL_arg2381z00_13299 = 
(
(long)CINT(BgL_bpz00_13263)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10924),BgL_arg2381z00_13299,BgL_a3z00_13267); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2382z00_13300;obj_t BgL_arg2383z00_13301;
BgL_arg2382z00_13300 = 
(
(long)CINT(BgL_bpz00_13263)+((long)3)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2384z00_13302;
BgL_list2384z00_13302 = 
MAKE_YOUNG_PAIR(BgL_a4z00_13268, BNIL); 
BgL_arg2383z00_13301 = BgL_list2384z00_13302; } 
VECTOR_SET(
((obj_t)BgL_sz00_10924),BgL_arg2382z00_13300,BgL_arg2383z00_13301); } break;case ((long)-5) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2385z00_13303;
BgL_arg2385z00_13303 = 
(
(long)CINT(BgL_bpz00_13263)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10924),BgL_arg2385z00_13303,BgL_a1z00_13265); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2386z00_13304;
BgL_arg2386z00_13304 = 
(
(long)CINT(BgL_bpz00_13263)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10924),BgL_arg2386z00_13304,BgL_a2z00_13266); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2387z00_13305;
BgL_arg2387z00_13305 = 
(
(long)CINT(BgL_bpz00_13263)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10924),BgL_arg2387z00_13305,BgL_a3z00_13267); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2388z00_13306;
BgL_arg2388z00_13306 = 
(
(long)CINT(BgL_bpz00_13263)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_10924),BgL_arg2388z00_13306,BgL_a4z00_13268); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2389z00_13307;obj_t BgL_arg2390z00_13308;
BgL_arg2389z00_13307 = 
(
(long)CINT(BgL_bpz00_13263)+((long)4)); 
BgL_arg2390z00_13308 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10924),BgL_arg2389z00_13307,BgL_arg2390z00_13308); } break;
default: 
BgL_case_else1204z00_13277:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2392z00_13278;
BgL_arg2392z00_13278 = 
STRUCT_REF(
((obj_t)BgL_ufz00_13269), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10921, BgL_arg2392z00_13278, 
(int)(((long)4)), 
CINT(BgL_arityz00_13270)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1204z00_13277;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_13309;
BgL_z12denvz12_13309 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10924, BgL_bpz00_13263, BgL_sfz00_13272))
{ /* Eval/evaluate_comp.scm 896 */
return BgL_runz00_13271;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_13310;
BgL_nsz00_13310 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2394z00_13311;
BgL_arg2394z00_13311 = 
(
(long)CINT(BgL_bpz00_13263)+((long)4)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_13310, ((long)2), BgL_sz00_10924, BgL_bpz00_13263, 
BINT(BgL_arg2394z00_13311)); } 
VECTOR_SET(BgL_nsz00_13310,((long)1),BgL_sz00_10924); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13309, BgL_nsz00_13310); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_13312;
BgL_ez00_13312 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13312, BgL_sz00_10924); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_13313;
BgL_____rz00_13313 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_13271, BgL_nsz00_13310, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13312); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13309, BgL_sz00_10924); 
return BgL_____rz00_13313;} } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_13264, 
(int)(((long)4))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_13314;
BgL_nbpz00_13314 = 
(
(long)CINT(BgL_bpz00_13263)+BgL_siza7eza7_10923); 
VECTOR_SET(
((obj_t)BgL_sz00_10924),((long)0),
BINT(BgL_nbpz00_13314)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_13315;
BgL_rz00_13315 = 
PROCEDURE_ENTRY(BgL_fz00_13264)(BgL_fz00_13264, BgL_a1z00_13265, BgL_a2z00_13266, BgL_a3z00_13267, BgL_a4z00_13268, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10924),((long)0),BgL_bpz00_13263); 
return BgL_rz00_13315;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10921, BgL_symbzd2funzd2_10922, 
(int)(((long)4)), 
PROCEDURE_ARITY(BgL_fz00_13264));} } } } } } } } 

}



/* &<@anonymous:2400> */
obj_t BGl_z62zc3z04anonymousza32400ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10925, obj_t BgL_sz00_10934)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_10926;obj_t BgL_a1z00_10927;obj_t BgL_a2z00_10928;obj_t BgL_a3z00_10929;obj_t BgL_a4z00_10930;obj_t BgL_locz00_10931;obj_t BgL_symbzd2funzd2_10932;long BgL_siza7eza7_10933;
BgL_funz00_10926 = 
PROCEDURE_REF(BgL_envz00_10925, 
(int)(((long)0))); 
BgL_a1z00_10927 = 
PROCEDURE_REF(BgL_envz00_10925, 
(int)(((long)1))); 
BgL_a2z00_10928 = 
PROCEDURE_REF(BgL_envz00_10925, 
(int)(((long)2))); 
BgL_a3z00_10929 = 
PROCEDURE_REF(BgL_envz00_10925, 
(int)(((long)3))); 
BgL_a4z00_10930 = 
PROCEDURE_REF(BgL_envz00_10925, 
(int)(((long)4))); 
BgL_locz00_10931 = 
PROCEDURE_REF(BgL_envz00_10925, 
(int)(((long)5))); 
BgL_symbzd2funzd2_10932 = 
PROCEDURE_REF(BgL_envz00_10925, 
(int)(((long)6))); 
BgL_siza7eza7_10933 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10925, 
(int)(((long)7)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_13316;
BgL_bpz00_13316 = 
VECTOR_REF(
((obj_t)BgL_sz00_10934),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_13317;obj_t BgL_a1z00_13318;obj_t BgL_a2z00_13319;obj_t BgL_a3z00_13320;obj_t BgL_a4z00_13321;
BgL_fz00_13317 = 
PROCEDURE_ENTRY(BgL_funz00_10926)(BgL_funz00_10926, BgL_sz00_10934, BEOA); 
BgL_a1z00_13318 = 
PROCEDURE_ENTRY(BgL_a1z00_10927)(BgL_a1z00_10927, BgL_sz00_10934, BEOA); 
BgL_a2z00_13319 = 
PROCEDURE_ENTRY(BgL_a2z00_10928)(BgL_a2z00_10928, BgL_sz00_10934, BEOA); 
BgL_a3z00_13320 = 
PROCEDURE_ENTRY(BgL_a3z00_10929)(BgL_a3z00_10929, BgL_sz00_10934, BEOA); 
BgL_a4z00_13321 = 
PROCEDURE_ENTRY(BgL_a4z00_10930)(BgL_a4z00_10930, BgL_sz00_10934, BEOA); 
if(
PROCEDUREP(BgL_fz00_13317))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10931, BGl_string5208z00zz__evaluate_compz00, BGl_string5224z00zz__evaluate_compz00, BgL_fz00_13317); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_13322;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_19422;
BgL_tmpz00_19422 = 
((obj_t)BgL_fz00_13317); 
BgL_ufz00_13322 = 
PROCEDURE_ATTR(BgL_tmpz00_19422); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5717z00_19425;
if(
STRUCTP(BgL_ufz00_13322))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5717z00_19425 = 
(
STRUCT_KEY(BgL_ufz00_13322)==BGl_symbol5225z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5717z00_19425 = ((bool_t)0)
; } 
if(BgL_test5717z00_19425)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_13323;obj_t BgL_runz00_13324;obj_t BgL_sfz00_13325;
BgL_arityz00_13323 = 
STRUCT_REF(BgL_ufz00_13322, 
(int)(((long)0))); 
BgL_runz00_13324 = 
STRUCT_REF(BgL_ufz00_13322, 
(int)(((long)1))); 
BgL_sfz00_13325 = 
STRUCT_REF(BgL_ufz00_13322, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_spz00_13326;
BgL_spz00_13326 = 
(
(long)CINT(BgL_bpz00_13316)+BgL_siza7eza7_10933); 
if(
(
(long)CINT(BgL_arityz00_13323)==((long)4)))
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2404z00_13327;
BgL_arg2404z00_13327 = 
(BgL_spz00_13326+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10934),BgL_arg2404z00_13327,BgL_a1z00_13318); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2405z00_13328;
BgL_arg2405z00_13328 = 
(BgL_spz00_13326+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10934),BgL_arg2405z00_13328,BgL_a2z00_13319); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2406z00_13329;
BgL_arg2406z00_13329 = 
(BgL_spz00_13326+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10934),BgL_arg2406z00_13329,BgL_a3z00_13320); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2407z00_13330;
BgL_arg2407z00_13330 = 
(BgL_spz00_13326+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_10934),BgL_arg2407z00_13330,BgL_a4z00_13321); } }  else 
{ 

if(
INTEGERP(BgL_arityz00_13323))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_13323)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2409z00_13333;obj_t BgL_arg2410z00_13334;
BgL_arg2409z00_13333 = 
(BgL_spz00_13326+((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2411z00_13335;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2412z00_13336;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2413z00_13337;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2414z00_13338;
BgL_arg2414z00_13338 = 
MAKE_YOUNG_PAIR(BgL_a4z00_13321, BNIL); 
BgL_arg2413z00_13337 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13320, BgL_arg2414z00_13338); } 
BgL_arg2412z00_13336 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13319, BgL_arg2413z00_13337); } 
BgL_list2411z00_13335 = 
MAKE_YOUNG_PAIR(BgL_a1z00_13318, BgL_arg2412z00_13336); } 
BgL_arg2410z00_13334 = BgL_list2411z00_13335; } 
VECTOR_SET(
((obj_t)BgL_sz00_10934),BgL_arg2409z00_13333,BgL_arg2410z00_13334); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2415z00_13339;
BgL_arg2415z00_13339 = 
(BgL_spz00_13326+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10934),BgL_arg2415z00_13339,BgL_a1z00_13318); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2416z00_13340;obj_t BgL_arg2417z00_13341;
BgL_arg2416z00_13340 = 
(BgL_spz00_13326+((long)1)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2418z00_13342;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2419z00_13343;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2420z00_13344;
BgL_arg2420z00_13344 = 
MAKE_YOUNG_PAIR(BgL_a4z00_13321, BNIL); 
BgL_arg2419z00_13343 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13320, BgL_arg2420z00_13344); } 
BgL_list2418z00_13342 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13319, BgL_arg2419z00_13343); } 
BgL_arg2417z00_13341 = BgL_list2418z00_13342; } 
VECTOR_SET(
((obj_t)BgL_sz00_10934),BgL_arg2416z00_13340,BgL_arg2417z00_13341); } break;case ((long)-3) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2421z00_13345;
BgL_arg2421z00_13345 = 
(BgL_spz00_13326+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10934),BgL_arg2421z00_13345,BgL_a1z00_13318); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2422z00_13346;
BgL_arg2422z00_13346 = 
(BgL_spz00_13326+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10934),BgL_arg2422z00_13346,BgL_a2z00_13319); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2423z00_13347;obj_t BgL_arg2424z00_13348;
BgL_arg2423z00_13347 = 
(BgL_spz00_13326+((long)2)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2425z00_13349;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2426z00_13350;
BgL_arg2426z00_13350 = 
MAKE_YOUNG_PAIR(BgL_a4z00_13321, BNIL); 
BgL_list2425z00_13349 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13320, BgL_arg2426z00_13350); } 
BgL_arg2424z00_13348 = BgL_list2425z00_13349; } 
VECTOR_SET(
((obj_t)BgL_sz00_10934),BgL_arg2423z00_13347,BgL_arg2424z00_13348); } break;case ((long)-4) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2427z00_13351;
BgL_arg2427z00_13351 = 
(BgL_spz00_13326+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10934),BgL_arg2427z00_13351,BgL_a1z00_13318); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2428z00_13352;
BgL_arg2428z00_13352 = 
(BgL_spz00_13326+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10934),BgL_arg2428z00_13352,BgL_a2z00_13319); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2429z00_13353;
BgL_arg2429z00_13353 = 
(BgL_spz00_13326+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10934),BgL_arg2429z00_13353,BgL_a3z00_13320); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2430z00_13354;obj_t BgL_arg2431z00_13355;
BgL_arg2430z00_13354 = 
(BgL_spz00_13326+((long)3)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2432z00_13356;
BgL_list2432z00_13356 = 
MAKE_YOUNG_PAIR(BgL_a4z00_13321, BNIL); 
BgL_arg2431z00_13355 = BgL_list2432z00_13356; } 
VECTOR_SET(
((obj_t)BgL_sz00_10934),BgL_arg2430z00_13354,BgL_arg2431z00_13355); } break;case ((long)-5) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2433z00_13357;
BgL_arg2433z00_13357 = 
(BgL_spz00_13326+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10934),BgL_arg2433z00_13357,BgL_a1z00_13318); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2434z00_13358;
BgL_arg2434z00_13358 = 
(BgL_spz00_13326+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10934),BgL_arg2434z00_13358,BgL_a2z00_13319); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2435z00_13359;
BgL_arg2435z00_13359 = 
(BgL_spz00_13326+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10934),BgL_arg2435z00_13359,BgL_a3z00_13320); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2436z00_13360;
BgL_arg2436z00_13360 = 
(BgL_spz00_13326+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_10934),BgL_arg2436z00_13360,BgL_a4z00_13321); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2437z00_13361;obj_t BgL_arg2438z00_13362;
BgL_arg2437z00_13361 = 
(BgL_spz00_13326+((long)4)); 
BgL_arg2438z00_13362 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10934),BgL_arg2437z00_13361,BgL_arg2438z00_13362); } break;
default: 
BgL_case_else1206z00_13331:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2440z00_13332;
BgL_arg2440z00_13332 = 
STRUCT_REF(
((obj_t)BgL_ufz00_13322), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10931, BgL_arg2440z00_13332, 
(int)(((long)4)), 
CINT(BgL_arityz00_13323)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1206z00_13331;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_13363;
BgL_z12denvz12_13363 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_13363, BgL_locz00_10931); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10934, 
BINT(BgL_spz00_13326), BgL_sfz00_13325))
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_13324, BgL_sz00_10934, 
BINT(BgL_spz00_13326));}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_13364;
BgL_nsz00_13364 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2442z00_13365;
BgL_arg2442z00_13365 = 
(BgL_spz00_13326+((long)4)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_13364, ((long)2), BgL_sz00_10934, 
BINT(BgL_spz00_13326), 
BINT(BgL_arg2442z00_13365)); } 
VECTOR_SET(BgL_nsz00_13364,((long)1),BgL_sz00_10934); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13363, BgL_nsz00_13364); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_13366;
BgL_ez00_13366 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13366, BgL_sz00_10934); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_13367;
BgL_____rz00_13367 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_13324, BgL_nsz00_13364, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13366); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13363, BgL_sz00_10934); 
return BgL_____rz00_13367;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_13317, 
(int)(((long)4))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_13368;
BgL_nbpz00_13368 = 
(
(long)CINT(BgL_bpz00_13316)+BgL_siza7eza7_10933); 
VECTOR_SET(
((obj_t)BgL_sz00_10934),((long)0),
BINT(BgL_nbpz00_13368)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_19546;
BgL_tmpz00_19546 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_19546, BgL_locz00_10931); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_13369;
BgL_rz00_13369 = 
PROCEDURE_ENTRY(BgL_fz00_13317)(BgL_fz00_13317, BgL_a1z00_13318, BgL_a2z00_13319, BgL_a3z00_13320, BgL_a4z00_13321, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10934),((long)0),BgL_bpz00_13316); 
return BgL_rz00_13369;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10931, BgL_symbzd2funzd2_10932, 
(int)(((long)4)), 
PROCEDURE_ARITY(BgL_fz00_13317));} } } } } } } } 

}



/* &<@anonymous:2446> */
obj_t BGl_z62zc3z04anonymousza32446ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10935, obj_t BgL_sz00_10944)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_10936;obj_t BgL_a1z00_10937;obj_t BgL_a2z00_10938;obj_t BgL_a3z00_10939;obj_t BgL_a4z00_10940;obj_t BgL_locz00_10941;obj_t BgL_symbzd2funzd2_10942;long BgL_siza7eza7_10943;
BgL_funz00_10936 = 
PROCEDURE_REF(BgL_envz00_10935, 
(int)(((long)0))); 
BgL_a1z00_10937 = 
PROCEDURE_REF(BgL_envz00_10935, 
(int)(((long)1))); 
BgL_a2z00_10938 = 
PROCEDURE_REF(BgL_envz00_10935, 
(int)(((long)2))); 
BgL_a3z00_10939 = 
PROCEDURE_REF(BgL_envz00_10935, 
(int)(((long)3))); 
BgL_a4z00_10940 = 
PROCEDURE_REF(BgL_envz00_10935, 
(int)(((long)4))); 
BgL_locz00_10941 = 
PROCEDURE_REF(BgL_envz00_10935, 
(int)(((long)5))); 
BgL_symbzd2funzd2_10942 = 
PROCEDURE_REF(BgL_envz00_10935, 
(int)(((long)6))); 
BgL_siza7eza7_10943 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10935, 
(int)(((long)7)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_13370;
BgL_bpz00_13370 = 
VECTOR_REF(
((obj_t)BgL_sz00_10944),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_13371;obj_t BgL_a1z00_13372;obj_t BgL_a2z00_13373;obj_t BgL_a3z00_13374;obj_t BgL_a4z00_13375;
BgL_fz00_13371 = 
PROCEDURE_ENTRY(BgL_funz00_10936)(BgL_funz00_10936, BgL_sz00_10944, BEOA); 
BgL_a1z00_13372 = 
PROCEDURE_ENTRY(BgL_a1z00_10937)(BgL_a1z00_10937, BgL_sz00_10944, BEOA); 
BgL_a2z00_13373 = 
PROCEDURE_ENTRY(BgL_a2z00_10938)(BgL_a2z00_10938, BgL_sz00_10944, BEOA); 
BgL_a3z00_13374 = 
PROCEDURE_ENTRY(BgL_a3z00_10939)(BgL_a3z00_10939, BgL_sz00_10944, BEOA); 
BgL_a4z00_13375 = 
PROCEDURE_ENTRY(BgL_a4z00_10940)(BgL_a4z00_10940, BgL_sz00_10944, BEOA); 
if(
PROCEDUREP(BgL_fz00_13371))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10941, BGl_string5208z00zz__evaluate_compz00, BGl_string5224z00zz__evaluate_compz00, BgL_fz00_13371); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_13376;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_19603;
BgL_tmpz00_19603 = 
((obj_t)BgL_fz00_13371); 
BgL_ufz00_13376 = 
PROCEDURE_ATTR(BgL_tmpz00_19603); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5724z00_19606;
if(
STRUCTP(BgL_ufz00_13376))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5724z00_19606 = 
(
STRUCT_KEY(BgL_ufz00_13376)==BGl_symbol5225z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5724z00_19606 = ((bool_t)0)
; } 
if(BgL_test5724z00_19606)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_13377;obj_t BgL_runz00_13378;obj_t BgL_sfz00_13379;
BgL_arityz00_13377 = 
STRUCT_REF(BgL_ufz00_13376, 
(int)(((long)0))); 
BgL_runz00_13378 = 
STRUCT_REF(BgL_ufz00_13376, 
(int)(((long)1))); 
BgL_sfz00_13379 = 
STRUCT_REF(BgL_ufz00_13376, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_spz00_13380;
BgL_spz00_13380 = 
(
(long)CINT(BgL_bpz00_13370)+BgL_siza7eza7_10943); 
if(
(
(long)CINT(BgL_arityz00_13377)==((long)4)))
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2450z00_13381;
BgL_arg2450z00_13381 = 
(BgL_spz00_13380+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10944),BgL_arg2450z00_13381,BgL_a1z00_13372); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2451z00_13382;
BgL_arg2451z00_13382 = 
(BgL_spz00_13380+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10944),BgL_arg2451z00_13382,BgL_a2z00_13373); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2452z00_13383;
BgL_arg2452z00_13383 = 
(BgL_spz00_13380+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10944),BgL_arg2452z00_13383,BgL_a3z00_13374); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2453z00_13384;
BgL_arg2453z00_13384 = 
(BgL_spz00_13380+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_10944),BgL_arg2453z00_13384,BgL_a4z00_13375); } }  else 
{ 

if(
INTEGERP(BgL_arityz00_13377))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_13377)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2455z00_13387;obj_t BgL_arg2456z00_13388;
BgL_arg2455z00_13387 = 
(BgL_spz00_13380+((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2457z00_13389;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2458z00_13390;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2459z00_13391;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2460z00_13392;
BgL_arg2460z00_13392 = 
MAKE_YOUNG_PAIR(BgL_a4z00_13375, BNIL); 
BgL_arg2459z00_13391 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13374, BgL_arg2460z00_13392); } 
BgL_arg2458z00_13390 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13373, BgL_arg2459z00_13391); } 
BgL_list2457z00_13389 = 
MAKE_YOUNG_PAIR(BgL_a1z00_13372, BgL_arg2458z00_13390); } 
BgL_arg2456z00_13388 = BgL_list2457z00_13389; } 
VECTOR_SET(
((obj_t)BgL_sz00_10944),BgL_arg2455z00_13387,BgL_arg2456z00_13388); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2461z00_13393;
BgL_arg2461z00_13393 = 
(BgL_spz00_13380+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10944),BgL_arg2461z00_13393,BgL_a1z00_13372); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2462z00_13394;obj_t BgL_arg2463z00_13395;
BgL_arg2462z00_13394 = 
(BgL_spz00_13380+((long)1)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2464z00_13396;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2465z00_13397;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2466z00_13398;
BgL_arg2466z00_13398 = 
MAKE_YOUNG_PAIR(BgL_a4z00_13375, BNIL); 
BgL_arg2465z00_13397 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13374, BgL_arg2466z00_13398); } 
BgL_list2464z00_13396 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13373, BgL_arg2465z00_13397); } 
BgL_arg2463z00_13395 = BgL_list2464z00_13396; } 
VECTOR_SET(
((obj_t)BgL_sz00_10944),BgL_arg2462z00_13394,BgL_arg2463z00_13395); } break;case ((long)-3) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2467z00_13399;
BgL_arg2467z00_13399 = 
(BgL_spz00_13380+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10944),BgL_arg2467z00_13399,BgL_a1z00_13372); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2468z00_13400;
BgL_arg2468z00_13400 = 
(BgL_spz00_13380+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10944),BgL_arg2468z00_13400,BgL_a2z00_13373); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2469z00_13401;obj_t BgL_arg2470z00_13402;
BgL_arg2469z00_13401 = 
(BgL_spz00_13380+((long)2)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2471z00_13403;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2472z00_13404;
BgL_arg2472z00_13404 = 
MAKE_YOUNG_PAIR(BgL_a4z00_13375, BNIL); 
BgL_list2471z00_13403 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13374, BgL_arg2472z00_13404); } 
BgL_arg2470z00_13402 = BgL_list2471z00_13403; } 
VECTOR_SET(
((obj_t)BgL_sz00_10944),BgL_arg2469z00_13401,BgL_arg2470z00_13402); } break;case ((long)-4) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2473z00_13405;
BgL_arg2473z00_13405 = 
(BgL_spz00_13380+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10944),BgL_arg2473z00_13405,BgL_a1z00_13372); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2474z00_13406;
BgL_arg2474z00_13406 = 
(BgL_spz00_13380+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10944),BgL_arg2474z00_13406,BgL_a2z00_13373); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2475z00_13407;
BgL_arg2475z00_13407 = 
(BgL_spz00_13380+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10944),BgL_arg2475z00_13407,BgL_a3z00_13374); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2476z00_13408;obj_t BgL_arg2477z00_13409;
BgL_arg2476z00_13408 = 
(BgL_spz00_13380+((long)3)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2478z00_13410;
BgL_list2478z00_13410 = 
MAKE_YOUNG_PAIR(BgL_a4z00_13375, BNIL); 
BgL_arg2477z00_13409 = BgL_list2478z00_13410; } 
VECTOR_SET(
((obj_t)BgL_sz00_10944),BgL_arg2476z00_13408,BgL_arg2477z00_13409); } break;case ((long)-5) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2479z00_13411;
BgL_arg2479z00_13411 = 
(BgL_spz00_13380+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10944),BgL_arg2479z00_13411,BgL_a1z00_13372); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2480z00_13412;
BgL_arg2480z00_13412 = 
(BgL_spz00_13380+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10944),BgL_arg2480z00_13412,BgL_a2z00_13373); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2481z00_13413;
BgL_arg2481z00_13413 = 
(BgL_spz00_13380+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10944),BgL_arg2481z00_13413,BgL_a3z00_13374); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2482z00_13414;
BgL_arg2482z00_13414 = 
(BgL_spz00_13380+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_10944),BgL_arg2482z00_13414,BgL_a4z00_13375); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2483z00_13415;obj_t BgL_arg2484z00_13416;
BgL_arg2483z00_13415 = 
(BgL_spz00_13380+((long)4)); 
BgL_arg2484z00_13416 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10944),BgL_arg2483z00_13415,BgL_arg2484z00_13416); } break;
default: 
BgL_case_else1208z00_13385:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2486z00_13386;
BgL_arg2486z00_13386 = 
STRUCT_REF(
((obj_t)BgL_ufz00_13376), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10941, BgL_arg2486z00_13386, 
(int)(((long)4)), 
CINT(BgL_arityz00_13377)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1208z00_13385;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_13417;
BgL_z12denvz12_13417 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10944, 
BINT(BgL_spz00_13380), BgL_sfz00_13379))
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_13378, BgL_sz00_10944, 
BINT(BgL_spz00_13380));}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_13418;
BgL_nsz00_13418 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2488z00_13419;
BgL_arg2488z00_13419 = 
(BgL_spz00_13380+((long)4)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_13418, ((long)2), BgL_sz00_10944, 
BINT(BgL_spz00_13380), 
BINT(BgL_arg2488z00_13419)); } 
VECTOR_SET(BgL_nsz00_13418,((long)1),BgL_sz00_10944); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13417, BgL_nsz00_13418); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_13420;
BgL_ez00_13420 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13420, BgL_sz00_10944); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_13421;
BgL_____rz00_13421 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_13378, BgL_nsz00_13418, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13420); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13417, BgL_sz00_10944); 
return BgL_____rz00_13421;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_13371, 
(int)(((long)4))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_13422;
BgL_nbpz00_13422 = 
(
(long)CINT(BgL_bpz00_13370)+BgL_siza7eza7_10943); 
VECTOR_SET(
((obj_t)BgL_sz00_10944),((long)0),
BINT(BgL_nbpz00_13422)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_13423;
BgL_rz00_13423 = 
PROCEDURE_ENTRY(BgL_fz00_13371)(BgL_fz00_13371, BgL_a1z00_13372, BgL_a2z00_13373, BgL_a3z00_13374, BgL_a4z00_13375, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10944),((long)0),BgL_bpz00_13370); 
return BgL_rz00_13423;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10941, BgL_symbzd2funzd2_10942, 
(int)(((long)4)), 
PROCEDURE_ARITY(BgL_fz00_13371));} } } } } } } } 

}



/* is-constant-fun? */
obj_t BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_ev_exprz00_bglt BgL_funz00_183, long BgL_nbargsz00_184, obj_t BgL_locz00_185, obj_t BgL_symbzd2funzd2_186)
{
{ /* Eval/evaluate_comp.scm 899 */
if(
BGl_isazf3zf3zz__objectz00(
((obj_t)BgL_funz00_183), BGl_ev_globalz00zz__evaluate_typesz00))
{ /* Eval/evaluate_comp.scm 903 */
obj_t BgL_gz00_3026;
{ /* Eval/evaluate_comp.scm 903 */
obj_t BgL_arg2498z00_3034;obj_t BgL_arg2499z00_3035;
BgL_arg2498z00_3034 = 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_funz00_183)))->BgL_modz00); 
BgL_arg2499z00_3035 = 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_funz00_183)))->BgL_namez00); 
BgL_gz00_3026 = 
BGl_evmodulezd2findzd2globalz00zz__evmodulez00(BgL_arg2498z00_3034, BgL_arg2499z00_3035); } 
if(
CBOOL(BgL_gz00_3026))
{ /* Eval/evaluate_comp.scm 905 */
bool_t BgL_test5732z00_19748;
{ /* Eval/evaluate_comp.scm 905 */
int BgL_arg2497z00_3033;
{ /* Eval/evaluate_comp.scm 905 */
int BgL_res4542z00_8189;
BgL_res4542z00_8189 = 
CINT(
VECTOR_REF(
((obj_t)BgL_gz00_3026),((long)0))); 
BgL_arg2497z00_3033 = BgL_res4542z00_8189; } 
BgL_test5732z00_19748 = 
(
(long)(BgL_arg2497z00_3033)==((long)0)); } 
if(BgL_test5732z00_19748)
{ /* Eval/evaluate_comp.scm 906 */
obj_t BgL_valz00_3029;
BgL_valz00_3029 = 
VECTOR_REF(
((obj_t)BgL_gz00_3026),((long)2)); 
{ /* Eval/evaluate_comp.scm 907 */
bool_t BgL_test5733z00_19756;
if(
PROCEDUREP(BgL_valz00_3029))
{ /* Eval/evaluate_comp.scm 907 */
BgL_test5733z00_19756 = 
PROCEDURE_CORRECT_ARITYP(BgL_valz00_3029, 
(int)(BgL_nbargsz00_184))
; }  else 
{ /* Eval/evaluate_comp.scm 907 */
BgL_test5733z00_19756 = ((bool_t)0)
; } 
if(BgL_test5733z00_19756)
{ /* Eval/evaluate_comp.scm 907 */
return BgL_valz00_3029;}  else 
{ /* Eval/evaluate_comp.scm 907 */
return BFALSE;} } }  else 
{ /* Eval/evaluate_comp.scm 905 */
return BFALSE;} }  else 
{ /* Eval/evaluate_comp.scm 904 */
return BFALSE;} }  else 
{ /* Eval/evaluate_comp.scm 910 */
bool_t BgL_test5735z00_19761;
if(
BGl_isazf3zf3zz__objectz00(
((obj_t)BgL_funz00_183), BGl_ev_littz00zz__evaluate_typesz00))
{ /* Eval/evaluate_comp.scm 911 */
obj_t BgL_tmpz00_19765;
BgL_tmpz00_19765 = 
(((BgL_ev_littz00_bglt)COBJECT(
((BgL_ev_littz00_bglt)BgL_funz00_183)))->BgL_valuez00); 
BgL_test5735z00_19761 = 
PROCEDUREP(BgL_tmpz00_19765); }  else 
{ /* Eval/evaluate_comp.scm 910 */
BgL_test5735z00_19761 = ((bool_t)0)
; } 
if(BgL_test5735z00_19761)
{ /* Eval/evaluate_comp.scm 913 */
bool_t BgL_test5737z00_19769;
{ /* Eval/evaluate_comp.scm 913 */
obj_t BgL_arg2507z00_3045;
BgL_arg2507z00_3045 = 
(((BgL_ev_littz00_bglt)COBJECT(
((BgL_ev_littz00_bglt)BgL_funz00_183)))->BgL_valuez00); 
BgL_test5737z00_19769 = 
PROCEDURE_CORRECT_ARITYP(BgL_arg2507z00_3045, 
(int)(BgL_nbargsz00_184)); } 
if(BgL_test5737z00_19769)
{ /* Eval/evaluate_comp.scm 913 */
return 
(((BgL_ev_littz00_bglt)COBJECT(
((BgL_ev_littz00_bglt)BgL_funz00_183)))->BgL_valuez00);}  else 
{ /* Eval/evaluate_comp.scm 915 */
int BgL_arg2505z00_3043;
{ /* Eval/evaluate_comp.scm 915 */
obj_t BgL_arg2506z00_3044;
BgL_arg2506z00_3044 = 
(((BgL_ev_littz00_bglt)COBJECT(
((BgL_ev_littz00_bglt)BgL_funz00_183)))->BgL_valuez00); 
BgL_arg2505z00_3043 = 
PROCEDURE_ARITY(BgL_arg2506z00_3044); } 
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_185, BgL_symbzd2funzd2_186, 
(int)(BgL_nbargsz00_184), BgL_arg2505z00_3043);} }  else 
{ /* Eval/evaluate_comp.scm 910 */
return BFALSE;} } } 

}



/* compile-float-arith */
obj_t BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(obj_t BgL_exprz00_187, obj_t BgL_stkz00_188)
{
{ /* Eval/evaluate_comp.scm 918 */
if(
BGl_isazf3zf3zz__objectz00(BgL_exprz00_187, BGl_ev_littz00zz__evaluate_typesz00))
{ /* Eval/evaluate_comp.scm 922 */
if(
INTEGERP(
(((BgL_ev_littz00_bglt)COBJECT(
((BgL_ev_littz00_bglt)BgL_exprz00_187)))->BgL_valuez00)))
{ /* Eval/evaluate_comp.scm 924 */
obj_t BgL_v1347z00_3054;
BgL_v1347z00_3054 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1347z00_3054,((long)0),
BINT(((long)1))); 
{ /* Eval/evaluate_comp.scm 924 */
double BgL_arg2512z00_3055;
BgL_arg2512z00_3055 = 
(double)(
(long)CINT(
(((BgL_ev_littz00_bglt)COBJECT(
((BgL_ev_littz00_bglt)BgL_exprz00_187)))->BgL_valuez00))); 
VECTOR_SET(BgL_v1347z00_3054,((long)1),
DOUBLE_TO_REAL(BgL_arg2512z00_3055)); } 
return BgL_v1347z00_3054;}  else 
{ /* Eval/evaluate_comp.scm 925 */
bool_t BgL_test5740z00_19796;
{ /* Eval/evaluate_comp.scm 925 */
obj_t BgL_tmpz00_19797;
BgL_tmpz00_19797 = 
(((BgL_ev_littz00_bglt)COBJECT(
((BgL_ev_littz00_bglt)BgL_exprz00_187)))->BgL_valuez00); 
BgL_test5740z00_19796 = 
REALP(BgL_tmpz00_19797); } 
if(BgL_test5740z00_19796)
{ /* Eval/evaluate_comp.scm 925 */
obj_t BgL_v1348z00_3059;
BgL_v1348z00_3059 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1348z00_3059,((long)0),
BINT(((long)1))); 
{ /* Eval/evaluate_comp.scm 925 */
obj_t BgL_arg2516z00_3060;
BgL_arg2516z00_3060 = 
(((BgL_ev_littz00_bglt)COBJECT(
((BgL_ev_littz00_bglt)BgL_exprz00_187)))->BgL_valuez00); 
VECTOR_SET(BgL_v1348z00_3059,((long)1),BgL_arg2516z00_3060); } 
return BgL_v1348z00_3059;}  else 
{ /* Eval/evaluate_comp.scm 926 */
obj_t BgL_v1349z00_3061;
BgL_v1349z00_3061 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1349z00_3061,((long)0),
BINT(((long)0))); 
{ /* Eval/evaluate_comp.scm 926 */
obj_t BgL_arg2517z00_3062;
BgL_arg2517z00_3062 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)
((BgL_ev_littz00_bglt)BgL_exprz00_187)), BgL_stkz00_188); 
VECTOR_SET(BgL_v1349z00_3061,((long)1),BgL_arg2517z00_3062); } 
return BgL_v1349z00_3061;} } }  else 
{ /* Eval/evaluate_comp.scm 922 */
if(
BGl_isazf3zf3zz__objectz00(BgL_exprz00_187, BGl_ev_varz00zz__evaluate_typesz00))
{ /* Eval/evaluate_comp.scm 927 */
if(
CBOOL(
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_exprz00_187)))->BgL_effz00)))
{ /* Eval/evaluate_comp.scm 930 */
obj_t BgL_v1350z00_3068;
BgL_v1350z00_3068 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1350z00_3068,((long)0),
BINT(((long)3))); 
VECTOR_SET(BgL_v1350z00_3068,((long)1),
BGl__indexz00zz__evaluate_compz00(BgL_exprz00_187, BgL_stkz00_188)); 
return BgL_v1350z00_3068;}  else 
{ /* Eval/evaluate_comp.scm 931 */
obj_t BgL_v1351z00_3070;
BgL_v1351z00_3070 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1351z00_3070,((long)0),
BINT(((long)2))); 
VECTOR_SET(BgL_v1351z00_3070,((long)1),
BGl__indexz00zz__evaluate_compz00(BgL_exprz00_187, BgL_stkz00_188)); 
return BgL_v1351z00_3070;} }  else 
{ /* Eval/evaluate_comp.scm 927 */
if(
BGl_isazf3zf3zz__objectz00(BgL_exprz00_187, BGl_ev_globalz00zz__evaluate_typesz00))
{ /* Eval/evaluate_comp.scm 934 */
obj_t BgL_gz00_3074;
{ /* Eval/evaluate_comp.scm 934 */
obj_t BgL_arg2529z00_3082;obj_t BgL_arg2530z00_3083;
BgL_arg2529z00_3082 = 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_exprz00_187)))->BgL_modz00); 
BgL_arg2530z00_3083 = 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_exprz00_187)))->BgL_namez00); 
BgL_gz00_3074 = 
BGl_evmodulezd2findzd2globalz00zz__evmodulez00(BgL_arg2529z00_3082, BgL_arg2530z00_3083); } 
if(
CBOOL(BgL_gz00_3074))
{ /* Eval/evaluate_comp.scm 936 */
bool_t BgL_test5745z00_19839;
{ /* Eval/evaluate_comp.scm 936 */
int BgL_arg2527z00_3079;
{ /* Eval/evaluate_comp.scm 936 */
int BgL_res4549z00_8212;
BgL_res4549z00_8212 = 
CINT(
VECTOR_REF(
((obj_t)BgL_gz00_3074),((long)0))); 
BgL_arg2527z00_3079 = BgL_res4549z00_8212; } 
BgL_test5745z00_19839 = 
(
BINT(BgL_arg2527z00_3079)==
BINT(((long)1))); } 
if(BgL_test5745z00_19839)
{ /* Eval/evaluate_comp.scm 937 */
obj_t BgL_v1352z00_3077;
BgL_v1352z00_3077 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1352z00_3077,((long)0),
BINT(((long)4))); 
VECTOR_SET(BgL_v1352z00_3077,((long)1),BgL_gz00_3074); 
return BgL_v1352z00_3077;}  else 
{ /* Eval/evaluate_comp.scm 938 */
obj_t BgL_v1353z00_3078;
BgL_v1353z00_3078 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1353z00_3078,((long)0),
BINT(((long)5))); 
VECTOR_SET(BgL_v1353z00_3078,((long)1),BgL_gz00_3074); 
return BgL_v1353z00_3078;} }  else 
{ /* Eval/evaluate_comp.scm 939 */
obj_t BgL_v1354z00_3080;
BgL_v1354z00_3080 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1354z00_3080,((long)0),
BINT(((long)0))); 
{ /* Eval/evaluate_comp.scm 939 */
obj_t BgL_arg2528z00_3081;
BgL_arg2528z00_3081 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)
((BgL_ev_globalz00_bglt)BgL_exprz00_187)), BgL_stkz00_188); 
VECTOR_SET(BgL_v1354z00_3080,((long)1),BgL_arg2528z00_3081); } 
return BgL_v1354z00_3080;} }  else 
{ /* Eval/evaluate_comp.scm 932 */
if(
BGl_isazf3zf3zz__objectz00(BgL_exprz00_187, BGl_ev_appz00zz__evaluate_typesz00))
{ /* Eval/evaluate_comp.scm 942 */
obj_t BgL_fvalz00_3086;
{ /* Eval/evaluate_comp.scm 942 */
BgL_ev_exprz00_bglt BgL_arg2572z00_3134;
BgL_arg2572z00_3134 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_exprz00_187)))->BgL_funz00); 
BgL_fvalz00_3086 = 
BGl_globalzd2funzd2valuez00zz__evaluate_compz00(BgL_arg2572z00_3134); } 
if(
(BgL_fvalz00_3086==BGl_zb2flzd2envz60zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 945 */
obj_t BgL_v1355z00_3088;
BgL_v1355z00_3088 = 
create_vector(((long)3)); 
VECTOR_SET(BgL_v1355z00_3088,((long)0),
BINT(((long)6))); 
{ /* Eval/evaluate_comp.scm 945 */
obj_t BgL_arg2533z00_3089;
{ /* Eval/evaluate_comp.scm 945 */
obj_t BgL_arg2534z00_3090;
{ /* Eval/evaluate_comp.scm 945 */
obj_t BgL_pairz00_8220;
BgL_pairz00_8220 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_exprz00_187)))->BgL_argsz00); 
BgL_arg2534z00_3090 = 
CAR(BgL_pairz00_8220); } 
BgL_arg2533z00_3089 = 
BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(BgL_arg2534z00_3090, BgL_stkz00_188); } 
VECTOR_SET(BgL_v1355z00_3088,((long)1),BgL_arg2533z00_3089); } 
{ /* Eval/evaluate_comp.scm 945 */
obj_t BgL_arg2536z00_3092;
{ /* Eval/evaluate_comp.scm 945 */
obj_t BgL_arg2537z00_3093;
{ /* Eval/evaluate_comp.scm 945 */
obj_t BgL_pairz00_8222;
BgL_pairz00_8222 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_exprz00_187)))->BgL_argsz00); 
BgL_arg2537z00_3093 = 
CAR(
CDR(BgL_pairz00_8222)); } 
BgL_arg2536z00_3092 = 
BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(BgL_arg2537z00_3093, BgL_stkz00_188); } 
VECTOR_SET(BgL_v1355z00_3088,((long)2),BgL_arg2536z00_3092); } 
return BgL_v1355z00_3088;}  else 
{ /* Eval/evaluate_comp.scm 944 */
if(
(BgL_fvalz00_3086==BGl_zd2flzd2envz00zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 947 */
obj_t BgL_v1356z00_3096;
BgL_v1356z00_3096 = 
create_vector(((long)3)); 
VECTOR_SET(BgL_v1356z00_3096,((long)0),
BINT(((long)7))); 
{ /* Eval/evaluate_comp.scm 947 */
obj_t BgL_arg2540z00_3097;
{ /* Eval/evaluate_comp.scm 947 */
obj_t BgL_arg2541z00_3098;
{ /* Eval/evaluate_comp.scm 947 */
obj_t BgL_pairz00_8228;
BgL_pairz00_8228 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_exprz00_187)))->BgL_argsz00); 
BgL_arg2541z00_3098 = 
CAR(BgL_pairz00_8228); } 
BgL_arg2540z00_3097 = 
BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(BgL_arg2541z00_3098, BgL_stkz00_188); } 
VECTOR_SET(BgL_v1356z00_3096,((long)1),BgL_arg2540z00_3097); } 
{ /* Eval/evaluate_comp.scm 947 */
obj_t BgL_arg2543z00_3100;
{ /* Eval/evaluate_comp.scm 947 */
obj_t BgL_arg2544z00_3101;
{ /* Eval/evaluate_comp.scm 947 */
obj_t BgL_pairz00_8230;
BgL_pairz00_8230 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_exprz00_187)))->BgL_argsz00); 
BgL_arg2544z00_3101 = 
CAR(
CDR(BgL_pairz00_8230)); } 
BgL_arg2543z00_3100 = 
BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(BgL_arg2544z00_3101, BgL_stkz00_188); } 
VECTOR_SET(BgL_v1356z00_3096,((long)2),BgL_arg2543z00_3100); } 
return BgL_v1356z00_3096;}  else 
{ /* Eval/evaluate_comp.scm 946 */
if(
(BgL_fvalz00_3086==BGl_za2flzd2envz70zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 949 */
obj_t BgL_v1357z00_3104;
BgL_v1357z00_3104 = 
create_vector(((long)3)); 
VECTOR_SET(BgL_v1357z00_3104,((long)0),
BINT(((long)8))); 
{ /* Eval/evaluate_comp.scm 949 */
obj_t BgL_arg2547z00_3105;
{ /* Eval/evaluate_comp.scm 949 */
obj_t BgL_arg2548z00_3106;
{ /* Eval/evaluate_comp.scm 949 */
obj_t BgL_pairz00_8236;
BgL_pairz00_8236 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_exprz00_187)))->BgL_argsz00); 
BgL_arg2548z00_3106 = 
CAR(BgL_pairz00_8236); } 
BgL_arg2547z00_3105 = 
BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(BgL_arg2548z00_3106, BgL_stkz00_188); } 
VECTOR_SET(BgL_v1357z00_3104,((long)1),BgL_arg2547z00_3105); } 
{ /* Eval/evaluate_comp.scm 949 */
obj_t BgL_arg2550z00_3108;
{ /* Eval/evaluate_comp.scm 949 */
obj_t BgL_arg2551z00_3109;
{ /* Eval/evaluate_comp.scm 949 */
obj_t BgL_pairz00_8238;
BgL_pairz00_8238 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_exprz00_187)))->BgL_argsz00); 
BgL_arg2551z00_3109 = 
CAR(
CDR(BgL_pairz00_8238)); } 
BgL_arg2550z00_3108 = 
BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(BgL_arg2551z00_3109, BgL_stkz00_188); } 
VECTOR_SET(BgL_v1357z00_3104,((long)2),BgL_arg2550z00_3108); } 
return BgL_v1357z00_3104;}  else 
{ /* Eval/evaluate_comp.scm 948 */
if(
(BgL_fvalz00_3086==BGl_zf2flzd2envz20zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 951 */
obj_t BgL_v1358z00_3112;
BgL_v1358z00_3112 = 
create_vector(((long)3)); 
VECTOR_SET(BgL_v1358z00_3112,((long)0),
BINT(((long)9))); 
{ /* Eval/evaluate_comp.scm 951 */
obj_t BgL_arg2554z00_3113;
{ /* Eval/evaluate_comp.scm 951 */
obj_t BgL_arg2555z00_3114;
{ /* Eval/evaluate_comp.scm 951 */
obj_t BgL_pairz00_8244;
BgL_pairz00_8244 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_exprz00_187)))->BgL_argsz00); 
BgL_arg2555z00_3114 = 
CAR(BgL_pairz00_8244); } 
BgL_arg2554z00_3113 = 
BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(BgL_arg2555z00_3114, BgL_stkz00_188); } 
VECTOR_SET(BgL_v1358z00_3112,((long)1),BgL_arg2554z00_3113); } 
{ /* Eval/evaluate_comp.scm 951 */
obj_t BgL_arg2557z00_3116;
{ /* Eval/evaluate_comp.scm 951 */
obj_t BgL_arg2558z00_3117;
{ /* Eval/evaluate_comp.scm 951 */
obj_t BgL_pairz00_8246;
BgL_pairz00_8246 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_exprz00_187)))->BgL_argsz00); 
BgL_arg2558z00_3117 = 
CAR(
CDR(BgL_pairz00_8246)); } 
BgL_arg2557z00_3116 = 
BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(BgL_arg2558z00_3117, BgL_stkz00_188); } 
VECTOR_SET(BgL_v1358z00_3112,((long)2),BgL_arg2557z00_3116); } 
return BgL_v1358z00_3112;}  else 
{ /* Eval/evaluate_comp.scm 950 */
if(
(BgL_fvalz00_3086==BGl_fixnumzd2ze3flonumzd2envze3zz__r4_numbers_6_5z00))
{ /* Eval/evaluate_comp.scm 953 */
obj_t BgL_v1359z00_3120;
BgL_v1359z00_3120 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1359z00_3120,((long)0),
BINT(((long)10))); 
{ /* Eval/evaluate_comp.scm 953 */
obj_t BgL_arg2561z00_3121;
{ /* Eval/evaluate_comp.scm 953 */
obj_t BgL_arg2562z00_3122;
{ /* Eval/evaluate_comp.scm 953 */
obj_t BgL_pairz00_8252;
BgL_pairz00_8252 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_exprz00_187)))->BgL_argsz00); 
BgL_arg2562z00_3122 = 
CAR(BgL_pairz00_8252); } 
BgL_arg2561z00_3121 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_arg2562z00_3122), BgL_stkz00_188); } 
VECTOR_SET(BgL_v1359z00_3120,((long)1),BgL_arg2561z00_3121); } 
return BgL_v1359z00_3120;}  else 
{ /* Eval/evaluate_comp.scm 952 */
if(
(BgL_fvalz00_3086==BGl_f64vectorzd2refzd2envz00zz__srfi4z00))
{ /* Eval/evaluate_comp.scm 955 */
obj_t BgL_v1360z00_3125;
BgL_v1360z00_3125 = 
create_vector(((long)3)); 
VECTOR_SET(BgL_v1360z00_3125,((long)0),
BINT(((long)11))); 
{ /* Eval/evaluate_comp.scm 955 */
obj_t BgL_arg2565z00_3126;
{ /* Eval/evaluate_comp.scm 955 */
obj_t BgL_arg2566z00_3127;
{ /* Eval/evaluate_comp.scm 955 */
obj_t BgL_pairz00_8255;
BgL_pairz00_8255 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_exprz00_187)))->BgL_argsz00); 
BgL_arg2566z00_3127 = 
CAR(BgL_pairz00_8255); } 
BgL_arg2565z00_3126 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_arg2566z00_3127), BgL_stkz00_188); } 
VECTOR_SET(BgL_v1360z00_3125,((long)1),BgL_arg2565z00_3126); } 
{ /* Eval/evaluate_comp.scm 955 */
obj_t BgL_arg2568z00_3129;
{ /* Eval/evaluate_comp.scm 955 */
obj_t BgL_arg2569z00_3130;
{ /* Eval/evaluate_comp.scm 955 */
obj_t BgL_pairz00_8257;
BgL_pairz00_8257 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_exprz00_187)))->BgL_argsz00); 
BgL_arg2569z00_3130 = 
CAR(
CDR(BgL_pairz00_8257)); } 
BgL_arg2568z00_3129 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_arg2569z00_3130), BgL_stkz00_188); } 
VECTOR_SET(BgL_v1360z00_3125,((long)2),BgL_arg2568z00_3129); } 
return BgL_v1360z00_3125;}  else 
{ /* Eval/evaluate_comp.scm 957 */
obj_t BgL_v1361z00_3132;
BgL_v1361z00_3132 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1361z00_3132,((long)0),
BINT(((long)0))); 
{ /* Eval/evaluate_comp.scm 957 */
obj_t BgL_arg2571z00_3133;
BgL_arg2571z00_3133 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)
((BgL_ev_appz00_bglt)BgL_exprz00_187)), BgL_stkz00_188); 
VECTOR_SET(BgL_v1361z00_3132,((long)1),BgL_arg2571z00_3133); } 
return BgL_v1361z00_3132;} } } } } } }  else 
{ /* Eval/evaluate_comp.scm 958 */
obj_t BgL_v1362z00_3135;
BgL_v1362z00_3135 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1362z00_3135,((long)0),
BINT(((long)0))); 
{ /* Eval/evaluate_comp.scm 958 */
obj_t BgL_arg2573z00_3136;
BgL_arg2573z00_3136 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_exprz00_187), BgL_stkz00_188); 
VECTOR_SET(BgL_v1362z00_3135,((long)1),BgL_arg2573z00_3136); } 
return BgL_v1362z00_3135;} } } } } 

}



/* eval-float-arith */
double BGl_evalzd2floatzd2arithz00zz__evaluate_compz00(obj_t BgL_bcz00_189, obj_t BgL_sz00_190)
{
{ /* Eval/evaluate_comp.scm 960 */
return 
REAL_TO_DOUBLE(
BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_190, BgL_bcz00_189));} 

}



/* E~0 */
obj_t BGl_Eze70ze7zz__evaluate_compz00(obj_t BgL_sz00_12607, obj_t BgL_bcz00_3141)
{
{ /* Eval/evaluate_comp.scm 975 */
{ 

{ /* Eval/evaluate_comp.scm 962 */
obj_t BgL_aux1218z00_3144;
BgL_aux1218z00_3144 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3141),((long)0)); 
if(
INTEGERP(BgL_aux1218z00_3144))
{ /* Eval/evaluate_comp.scm 962 */
switch( 
(long)CINT(BgL_aux1218z00_3144)) { case ((long)0) : 

{ /* Eval/evaluate_comp.scm 963 */
obj_t BgL_fun2577z00_3146;
BgL_fun2577z00_3146 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3141),((long)1)); 
return 
PROCEDURE_ENTRY(BgL_fun2577z00_3146)(BgL_fun2577z00_3146, BgL_sz00_12607, BEOA);} break;case ((long)1) : 

return 
VECTOR_REF(
((obj_t)BgL_bcz00_3141),((long)1));break;case ((long)2) : 

{ /* Eval/evaluate_comp.scm 965 */
long BgL_arg2578z00_3147;
{ /* Eval/evaluate_comp.scm 965 */
obj_t BgL_arg2579z00_3148;obj_t BgL_arg2580z00_3149;
BgL_arg2579z00_3148 = 
VECTOR_REF(
((obj_t)BgL_sz00_12607),((long)0)); 
BgL_arg2580z00_3149 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3141),((long)1)); 
BgL_arg2578z00_3147 = 
(
(long)CINT(BgL_arg2579z00_3148)+
(long)CINT(BgL_arg2580z00_3149)); } 
return 
VECTOR_REF(
((obj_t)BgL_sz00_12607),BgL_arg2578z00_3147);} break;case ((long)3) : 

{ /* Eval/evaluate_comp.scm 966 */
obj_t BgL_arg2581z00_3150;
{ /* Eval/evaluate_comp.scm 966 */
long BgL_arg2582z00_3151;
{ /* Eval/evaluate_comp.scm 966 */
obj_t BgL_arg2583z00_3152;obj_t BgL_arg2584z00_3153;
BgL_arg2583z00_3152 = 
VECTOR_REF(
((obj_t)BgL_sz00_12607),((long)0)); 
BgL_arg2584z00_3153 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3141),((long)1)); 
BgL_arg2582z00_3151 = 
(
(long)CINT(BgL_arg2583z00_3152)+
(long)CINT(BgL_arg2584z00_3153)); } 
BgL_arg2581z00_3150 = 
VECTOR_REF(
((obj_t)BgL_sz00_12607),BgL_arg2582z00_3151); } 
return 
STRUCT_REF(
((obj_t)BgL_arg2581z00_3150), 
(int)(((long)0)));} break;case ((long)4) : 

{ /* Eval/evaluate_comp.scm 967 */
obj_t BgL_arg2585z00_3154;
{ /* Eval/evaluate_comp.scm 967 */
obj_t BgL_arg2586z00_3155;
BgL_arg2586z00_3155 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3141),((long)1)); 
BgL_arg2585z00_3154 = 
VECTOR_REF(
((obj_t)BgL_arg2586z00_3155),((long)2)); } 
return 
__EVMEANING_ADDRESS_REF(BgL_arg2585z00_3154);} break;case ((long)5) : 

{ /* Eval/evaluate_comp.scm 968 */
obj_t BgL_arg2587z00_3156;
BgL_arg2587z00_3156 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3141),((long)1)); 
return 
VECTOR_REF(
((obj_t)BgL_arg2587z00_3156),((long)2));} break;case ((long)6) : 

{ /* Eval/evaluate_comp.scm 969 */
obj_t BgL_arg2588z00_3157;obj_t BgL_arg2589z00_3158;
{ /* Eval/evaluate_comp.scm 969 */
obj_t BgL_arg2590z00_3159;
BgL_arg2590z00_3159 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3141),((long)1)); 
BgL_arg2588z00_3157 = 
BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_12607, BgL_arg2590z00_3159); } 
{ /* Eval/evaluate_comp.scm 969 */
obj_t BgL_arg2591z00_3160;
BgL_arg2591z00_3160 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3141),((long)2)); 
BgL_arg2589z00_3158 = 
BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_12607, BgL_arg2591z00_3160); } 
return 
DOUBLE_TO_REAL(
(
REAL_TO_DOUBLE(BgL_arg2588z00_3157)+
REAL_TO_DOUBLE(BgL_arg2589z00_3158)));} break;case ((long)7) : 

{ /* Eval/evaluate_comp.scm 970 */
obj_t BgL_arg2592z00_3161;obj_t BgL_arg2593z00_3162;
{ /* Eval/evaluate_comp.scm 970 */
obj_t BgL_arg2594z00_3163;
BgL_arg2594z00_3163 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3141),((long)1)); 
BgL_arg2592z00_3161 = 
BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_12607, BgL_arg2594z00_3163); } 
{ /* Eval/evaluate_comp.scm 970 */
obj_t BgL_arg2595z00_3164;
BgL_arg2595z00_3164 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3141),((long)2)); 
BgL_arg2593z00_3162 = 
BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_12607, BgL_arg2595z00_3164); } 
return 
DOUBLE_TO_REAL(
(
REAL_TO_DOUBLE(BgL_arg2592z00_3161)-
REAL_TO_DOUBLE(BgL_arg2593z00_3162)));} break;case ((long)8) : 

{ /* Eval/evaluate_comp.scm 971 */
obj_t BgL_arg2596z00_3165;obj_t BgL_arg2597z00_3166;
{ /* Eval/evaluate_comp.scm 971 */
obj_t BgL_arg2598z00_3167;
BgL_arg2598z00_3167 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3141),((long)1)); 
BgL_arg2596z00_3165 = 
BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_12607, BgL_arg2598z00_3167); } 
{ /* Eval/evaluate_comp.scm 971 */
obj_t BgL_arg2599z00_3168;
BgL_arg2599z00_3168 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3141),((long)2)); 
BgL_arg2597z00_3166 = 
BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_12607, BgL_arg2599z00_3168); } 
return 
DOUBLE_TO_REAL(
(
REAL_TO_DOUBLE(BgL_arg2596z00_3165)*
REAL_TO_DOUBLE(BgL_arg2597z00_3166)));} break;case ((long)9) : 

{ /* Eval/evaluate_comp.scm 972 */
obj_t BgL_arg2600z00_3169;obj_t BgL_arg2601z00_3170;
{ /* Eval/evaluate_comp.scm 972 */
obj_t BgL_arg2602z00_3171;
BgL_arg2602z00_3171 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3141),((long)1)); 
BgL_arg2600z00_3169 = 
BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_12607, BgL_arg2602z00_3171); } 
{ /* Eval/evaluate_comp.scm 972 */
obj_t BgL_arg2603z00_3172;
BgL_arg2603z00_3172 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3141),((long)2)); 
BgL_arg2601z00_3170 = 
BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_12607, BgL_arg2603z00_3172); } 
return 
DOUBLE_TO_REAL(
(
REAL_TO_DOUBLE(BgL_arg2600z00_3169)/
REAL_TO_DOUBLE(BgL_arg2601z00_3170)));} break;case ((long)10) : 

{ /* Eval/evaluate_comp.scm 973 */
obj_t BgL_arg2604z00_3173;
{ /* Eval/evaluate_comp.scm 973 */
obj_t BgL_fun2605z00_3174;
BgL_fun2605z00_3174 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3141),((long)1)); 
BgL_arg2604z00_3173 = 
PROCEDURE_ENTRY(BgL_fun2605z00_3174)(BgL_fun2605z00_3174, BgL_sz00_12607, BEOA); } 
return 
DOUBLE_TO_REAL(
(double)(
(long)CINT(BgL_arg2604z00_3173)));} break;case ((long)11) : 

{ /* Eval/evaluate_comp.scm 974 */
obj_t BgL_arg2606z00_3175;obj_t BgL_arg2607z00_3176;
{ /* Eval/evaluate_comp.scm 974 */
obj_t BgL_fun2608z00_3177;
BgL_fun2608z00_3177 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3141),((long)1)); 
BgL_arg2606z00_3175 = 
PROCEDURE_ENTRY(BgL_fun2608z00_3177)(BgL_fun2608z00_3177, BgL_sz00_12607, BEOA); } 
{ /* Eval/evaluate_comp.scm 974 */
obj_t BgL_fun2609z00_3178;
BgL_fun2609z00_3178 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3141),((long)2)); 
BgL_arg2607z00_3176 = 
PROCEDURE_ENTRY(BgL_fun2609z00_3178)(BgL_fun2609z00_3178, BgL_sz00_12607, BEOA); } 
{ /* Eval/evaluate_comp.scm 974 */
double BgL_tmpz00_20077;
{ /* Eval/evaluate_comp.scm 974 */
long BgL_tmpz00_20078;
BgL_tmpz00_20078 = 
(long)CINT(BgL_arg2607z00_3176); 
BgL_tmpz00_20077 = 
BGL_F64VREF(BgL_arg2606z00_3175, BgL_tmpz00_20078); } 
return 
DOUBLE_TO_REAL(BgL_tmpz00_20077);} } break;
default: 
BgL_case_else1217z00_3143:
{ /* Eval/evaluate_comp.scm 975 */
obj_t BgL_arg2610z00_3179;
BgL_arg2610z00_3179 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3141),((long)0)); 
return 
BGl_errorz00zz__errorz00(BGl_string5208z00zz__evaluate_compz00, BGl_string5227z00zz__evaluate_compz00, BgL_arg2610z00_3179);} } }  else 
{ /* Eval/evaluate_comp.scm 962 */
goto BgL_case_else1217z00_3143;} } } } 

}



/* arith-expression */
obj_t BGl_arithzd2expressionzd2zz__evaluate_compz00(BgL_ev_appz00_bglt BgL_exprz00_191, obj_t BgL_stkz00_192)
{
{ /* Eval/evaluate_comp.scm 978 */
{ /* Eval/evaluate_comp.scm 980 */
obj_t BgL_fvalz00_3182;
BgL_fvalz00_3182 = 
BGl_globalzd2funzd2valuez00zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_exprz00_191))->BgL_funz00)); 
{ /* Eval/evaluate_comp.scm 981 */
bool_t BgL_test5754z00_20089;
if(
(BgL_fvalz00_3182==BGl_zb2flzd2envz60zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 981 */
BgL_test5754z00_20089 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate_comp.scm 981 */
if(
(BgL_fvalz00_3182==BGl_zd2flzd2envz00zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 981 */
BgL_test5754z00_20089 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate_comp.scm 981 */
if(
(BgL_fvalz00_3182==BGl_za2flzd2envz70zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 981 */
BgL_test5754z00_20089 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate_comp.scm 981 */
BgL_test5754z00_20089 = 
(BgL_fvalz00_3182==BGl_zf2flzd2envz20zz__r4_numbers_6_5_flonumz00)
; } } } 
if(BgL_test5754z00_20089)
{ /* Eval/evaluate_comp.scm 982 */
obj_t BgL_bcz00_3187;
BgL_bcz00_3187 = 
BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(
((obj_t)BgL_exprz00_191), BgL_stkz00_192); 
{ /* Eval/evaluate_comp.scm 983 */
obj_t BgL_zc3z04anonymousza32615ze3z87_10962;
BgL_zc3z04anonymousza32615ze3z87_10962 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32615ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32615ze3z87_10962, 
(int)(((long)0)), BgL_bcz00_3187); 
return BgL_zc3z04anonymousza32615ze3z87_10962;} }  else 
{ /* Eval/evaluate_comp.scm 981 */
return BFALSE;} } } } 

}



/* &<@anonymous:2615> */
obj_t BGl_z62zc3z04anonymousza32615ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10963, obj_t BgL_sz00_10965)
{
{ /* Eval/evaluate_comp.scm 983 */
{ /* Eval/evaluate_comp.scm 983 */
obj_t BgL_bcz00_10964;
BgL_bcz00_10964 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10963, 
(int)(((long)0)))); 
{ /* Eval/evaluate_comp.scm 983 */
double BgL_tmpz00_20107;
{ /* Eval/evaluate_comp.scm 983 */
obj_t BgL_bpz00_13424;
BgL_bpz00_13424 = 
VECTOR_REF(
((obj_t)BgL_sz00_10965),((long)0)); 
BgL_tmpz00_20107 = 
BGl_evalzd2floatzd2arithz00zz__evaluate_compz00(BgL_bcz00_10964, BgL_sz00_10965); } 
return 
DOUBLE_TO_REAL(BgL_tmpz00_20107);} } } 

}



/* inline-call */
obj_t BGl_inlinezd2callzd2zz__evaluate_compz00(obj_t BgL_locz00_193, BgL_ev_exprz00_bglt BgL_funz00_194, obj_t BgL_argsz00_195, obj_t BgL_stkz00_196)
{
{ /* Eval/evaluate_comp.scm 1012 */
{ /* Eval/evaluate_comp.scm 1013 */
obj_t BgL_valz00_3195;
BgL_valz00_3195 = 
BGl_globalzd2funzd2valuez00zz__evaluate_compz00(BgL_funz00_194); 
if(
CBOOL(BgL_valz00_3195))
{ /* Eval/evaluate_comp.scm 1015 */
long BgL_nz00_3196;
BgL_nz00_3196 = 
bgl_list_length(BgL_argsz00_195); 
{ /* Eval/evaluate_comp.scm 1016 */
obj_t BgL__ortest_1224z00_3197;
if(
(BgL_nz00_3196==((long)1)))
{ /* Eval/evaluate_comp.scm 1017 */
obj_t BgL_a1z00_3488;
BgL_a1z00_3488 = 
CAR(
((obj_t)BgL_argsz00_195)); 
if(
(BgL_valz00_3195==BGl_carzd2envzd2zz__r4_pairs_and_lists_6_3z00))
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_a1z00_3490;
BgL_a1z00_3490 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3488), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_zc3z04anonymousza32732ze3z87_10995;
BgL_zc3z04anonymousza32732ze3z87_10995 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32732ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32732ze3z87_10995, 
(int)(((long)0)), BgL_a1z00_3490); 
PROCEDURE_SET(BgL_zc3z04anonymousza32732ze3z87_10995, 
(int)(((long)1)), BgL_locz00_193); 
BgL__ortest_1224z00_3197 = BgL_zc3z04anonymousza32732ze3z87_10995; } }  else 
{ /* Eval/evaluate_comp.scm 1018 */
if(
(BgL_valz00_3195==BGl_cdrzd2envzd2zz__r4_pairs_and_lists_6_3z00))
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_a1z00_3497;
BgL_a1z00_3497 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3488), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_zc3z04anonymousza32735ze3z87_10996;
BgL_zc3z04anonymousza32735ze3z87_10996 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32735ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32735ze3z87_10996, 
(int)(((long)0)), BgL_a1z00_3497); 
PROCEDURE_SET(BgL_zc3z04anonymousza32735ze3z87_10996, 
(int)(((long)1)), BgL_locz00_193); 
BgL__ortest_1224z00_3197 = BgL_zc3z04anonymousza32735ze3z87_10996; } }  else 
{ /* Eval/evaluate_comp.scm 1018 */
if(
(BgL_valz00_3195==BGl_cadrzd2envzd2zz__r4_pairs_and_lists_6_3z00))
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_a1z00_3504;
BgL_a1z00_3504 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3488), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_zc3z04anonymousza32738ze3z87_10997;
BgL_zc3z04anonymousza32738ze3z87_10997 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32738ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32738ze3z87_10997, 
(int)(((long)0)), BgL_a1z00_3504); 
PROCEDURE_SET(BgL_zc3z04anonymousza32738ze3z87_10997, 
(int)(((long)1)), BgL_locz00_193); 
BgL__ortest_1224z00_3197 = BgL_zc3z04anonymousza32738ze3z87_10997; } }  else 
{ /* Eval/evaluate_comp.scm 1018 */
BgL__ortest_1224z00_3197 = BFALSE; } } } }  else 
{ /* Eval/evaluate_comp.scm 1016 */
BgL__ortest_1224z00_3197 = BFALSE; } 
if(
CBOOL(BgL__ortest_1224z00_3197))
{ /* Eval/evaluate_comp.scm 1016 */
return BgL__ortest_1224z00_3197;}  else 
{ /* Eval/evaluate_comp.scm 1016 */
if(
(BgL_nz00_3196==((long)2)))
{ /* Eval/evaluate_comp.scm 1020 */
obj_t BgL_a1z00_3199;obj_t BgL_a2z00_3200;
BgL_a1z00_3199 = 
CAR(
((obj_t)BgL_argsz00_195)); 
{ /* Eval/evaluate_comp.scm 1020 */
obj_t BgL_pairz00_8337;
BgL_pairz00_8337 = 
CDR(
((obj_t)BgL_argsz00_195)); 
BgL_a2z00_3200 = 
CAR(BgL_pairz00_8337); } 
if(
(BgL_valz00_3195==BGl_zb2zd2envz60zz__r4_numbers_6_5z00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3202;obj_t BgL_a2z00_3203;
BgL_a1z00_3202 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3199), BgL_stkz00_196); 
BgL_a2z00_3203 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3200), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32619ze3z87_10966;
BgL_zc3z04anonymousza32619ze3z87_10966 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32619ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32619ze3z87_10966, 
(int)(((long)0)), BgL_a1z00_3202); 
PROCEDURE_SET(BgL_zc3z04anonymousza32619ze3z87_10966, 
(int)(((long)1)), BgL_a2z00_3203); 
PROCEDURE_SET(BgL_zc3z04anonymousza32619ze3z87_10966, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32619ze3z87_10966;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3195==BGl_zd2zd2envz00zz__r4_numbers_6_5z00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3212;obj_t BgL_a2z00_3213;
BgL_a1z00_3212 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3199), BgL_stkz00_196); 
BgL_a2z00_3213 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3200), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32623ze3z87_10967;
BgL_zc3z04anonymousza32623ze3z87_10967 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32623ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32623ze3z87_10967, 
(int)(((long)0)), BgL_a1z00_3212); 
PROCEDURE_SET(BgL_zc3z04anonymousza32623ze3z87_10967, 
(int)(((long)1)), BgL_a2z00_3213); 
PROCEDURE_SET(BgL_zc3z04anonymousza32623ze3z87_10967, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32623ze3z87_10967;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3195==BGl_za2zd2envz70zz__r4_numbers_6_5z00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3222;obj_t BgL_a2z00_3223;
BgL_a1z00_3222 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3199), BgL_stkz00_196); 
BgL_a2z00_3223 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3200), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32627ze3z87_10968;
BgL_zc3z04anonymousza32627ze3z87_10968 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32627ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32627ze3z87_10968, 
(int)(((long)0)), BgL_a1z00_3222); 
PROCEDURE_SET(BgL_zc3z04anonymousza32627ze3z87_10968, 
(int)(((long)1)), BgL_a2z00_3223); 
PROCEDURE_SET(BgL_zc3z04anonymousza32627ze3z87_10968, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32627ze3z87_10968;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3195==BGl_zf2zd2envz20zz__r4_numbers_6_5z00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3232;obj_t BgL_a2z00_3233;
BgL_a1z00_3232 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3199), BgL_stkz00_196); 
BgL_a2z00_3233 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3200), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32631ze3z87_10969;
BgL_zc3z04anonymousza32631ze3z87_10969 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32631ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32631ze3z87_10969, 
(int)(((long)0)), BgL_a1z00_3232); 
PROCEDURE_SET(BgL_zc3z04anonymousza32631ze3z87_10969, 
(int)(((long)1)), BgL_a2z00_3233); 
PROCEDURE_SET(BgL_zc3z04anonymousza32631ze3z87_10969, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32631ze3z87_10969;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3195==BGl_zc3zd2envz11zz__r4_numbers_6_5z00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3242;obj_t BgL_a2z00_3243;
BgL_a1z00_3242 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3199), BgL_stkz00_196); 
BgL_a2z00_3243 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3200), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32635ze3z87_10970;
BgL_zc3z04anonymousza32635ze3z87_10970 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32635ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32635ze3z87_10970, 
(int)(((long)0)), BgL_a1z00_3242); 
PROCEDURE_SET(BgL_zc3z04anonymousza32635ze3z87_10970, 
(int)(((long)1)), BgL_a2z00_3243); 
PROCEDURE_SET(BgL_zc3z04anonymousza32635ze3z87_10970, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32635ze3z87_10970;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3195==BGl_ze3zd2envz31zz__r4_numbers_6_5z00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3252;obj_t BgL_a2z00_3253;
BgL_a1z00_3252 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3199), BgL_stkz00_196); 
BgL_a2z00_3253 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3200), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32639ze3z87_10971;
BgL_zc3z04anonymousza32639ze3z87_10971 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32639ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32639ze3z87_10971, 
(int)(((long)0)), BgL_a1z00_3252); 
PROCEDURE_SET(BgL_zc3z04anonymousza32639ze3z87_10971, 
(int)(((long)1)), BgL_a2z00_3253); 
PROCEDURE_SET(BgL_zc3z04anonymousza32639ze3z87_10971, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32639ze3z87_10971;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3195==BGl_zc3zd3zd2envzc2zz__r4_numbers_6_5z00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3262;obj_t BgL_a2z00_3263;
BgL_a1z00_3262 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3199), BgL_stkz00_196); 
BgL_a2z00_3263 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3200), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32643ze3z87_10972;
BgL_zc3z04anonymousza32643ze3z87_10972 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32643ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32643ze3z87_10972, 
(int)(((long)0)), BgL_a1z00_3262); 
PROCEDURE_SET(BgL_zc3z04anonymousza32643ze3z87_10972, 
(int)(((long)1)), BgL_a2z00_3263); 
PROCEDURE_SET(BgL_zc3z04anonymousza32643ze3z87_10972, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32643ze3z87_10972;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3195==BGl_ze3zd3zd2envze2zz__r4_numbers_6_5z00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3272;obj_t BgL_a2z00_3273;
BgL_a1z00_3272 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3199), BgL_stkz00_196); 
BgL_a2z00_3273 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3200), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32647ze3z87_10973;
BgL_zc3z04anonymousza32647ze3z87_10973 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32647ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32647ze3z87_10973, 
(int)(((long)0)), BgL_a1z00_3272); 
PROCEDURE_SET(BgL_zc3z04anonymousza32647ze3z87_10973, 
(int)(((long)1)), BgL_a2z00_3273); 
PROCEDURE_SET(BgL_zc3z04anonymousza32647ze3z87_10973, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32647ze3z87_10973;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3195==BGl_zd3zd2envz01zz__r4_numbers_6_5z00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3282;obj_t BgL_a2z00_3283;
BgL_a1z00_3282 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3199), BgL_stkz00_196); 
BgL_a2z00_3283 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3200), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32651ze3z87_10974;
BgL_zc3z04anonymousza32651ze3z87_10974 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32651ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32651ze3z87_10974, 
(int)(((long)0)), BgL_a1z00_3282); 
PROCEDURE_SET(BgL_zc3z04anonymousza32651ze3z87_10974, 
(int)(((long)1)), BgL_a2z00_3283); 
PROCEDURE_SET(BgL_zc3z04anonymousza32651ze3z87_10974, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32651ze3z87_10974;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3195==BGl_zb2fxzd2envz60zz__r4_numbers_6_5_fixnumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3292;obj_t BgL_a2z00_3293;
BgL_a1z00_3292 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3199), BgL_stkz00_196); 
BgL_a2z00_3293 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3200), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32655ze3z87_10975;
BgL_zc3z04anonymousza32655ze3z87_10975 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32655ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32655ze3z87_10975, 
(int)(((long)0)), BgL_a1z00_3292); 
PROCEDURE_SET(BgL_zc3z04anonymousza32655ze3z87_10975, 
(int)(((long)1)), BgL_a2z00_3293); 
PROCEDURE_SET(BgL_zc3z04anonymousza32655ze3z87_10975, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32655ze3z87_10975;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3195==BGl_zd2fxzd2envz00zz__r4_numbers_6_5_fixnumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3302;obj_t BgL_a2z00_3303;
BgL_a1z00_3302 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3199), BgL_stkz00_196); 
BgL_a2z00_3303 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3200), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32659ze3z87_10976;
BgL_zc3z04anonymousza32659ze3z87_10976 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32659ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32659ze3z87_10976, 
(int)(((long)0)), BgL_a1z00_3302); 
PROCEDURE_SET(BgL_zc3z04anonymousza32659ze3z87_10976, 
(int)(((long)1)), BgL_a2z00_3303); 
PROCEDURE_SET(BgL_zc3z04anonymousza32659ze3z87_10976, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32659ze3z87_10976;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3195==BGl_za2fxzd2envz70zz__r4_numbers_6_5_fixnumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3312;obj_t BgL_a2z00_3313;
BgL_a1z00_3312 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3199), BgL_stkz00_196); 
BgL_a2z00_3313 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3200), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32663ze3z87_10977;
BgL_zc3z04anonymousza32663ze3z87_10977 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32663ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32663ze3z87_10977, 
(int)(((long)0)), BgL_a1z00_3312); 
PROCEDURE_SET(BgL_zc3z04anonymousza32663ze3z87_10977, 
(int)(((long)1)), BgL_a2z00_3313); 
PROCEDURE_SET(BgL_zc3z04anonymousza32663ze3z87_10977, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32663ze3z87_10977;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3195==BGl_zf2fxzd2envz20zz__r4_numbers_6_5_fixnumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3322;obj_t BgL_a2z00_3323;
BgL_a1z00_3322 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3199), BgL_stkz00_196); 
BgL_a2z00_3323 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3200), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32667ze3z87_10978;
BgL_zc3z04anonymousza32667ze3z87_10978 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32667ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32667ze3z87_10978, 
(int)(((long)0)), BgL_a1z00_3322); 
PROCEDURE_SET(BgL_zc3z04anonymousza32667ze3z87_10978, 
(int)(((long)1)), BgL_a2z00_3323); 
PROCEDURE_SET(BgL_zc3z04anonymousza32667ze3z87_10978, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32667ze3z87_10978;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3195==BGl_zc3fxzd2envz11zz__r4_numbers_6_5_fixnumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3332;obj_t BgL_a2z00_3333;
BgL_a1z00_3332 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3199), BgL_stkz00_196); 
BgL_a2z00_3333 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3200), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32671ze3z87_10979;
BgL_zc3z04anonymousza32671ze3z87_10979 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32671ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32671ze3z87_10979, 
(int)(((long)0)), BgL_a1z00_3332); 
PROCEDURE_SET(BgL_zc3z04anonymousza32671ze3z87_10979, 
(int)(((long)1)), BgL_a2z00_3333); 
PROCEDURE_SET(BgL_zc3z04anonymousza32671ze3z87_10979, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32671ze3z87_10979;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3195==BGl_ze3fxzd2envz31zz__r4_numbers_6_5_fixnumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3342;obj_t BgL_a2z00_3343;
BgL_a1z00_3342 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3199), BgL_stkz00_196); 
BgL_a2z00_3343 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3200), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32675ze3z87_10980;
BgL_zc3z04anonymousza32675ze3z87_10980 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32675ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32675ze3z87_10980, 
(int)(((long)0)), BgL_a1z00_3342); 
PROCEDURE_SET(BgL_zc3z04anonymousza32675ze3z87_10980, 
(int)(((long)1)), BgL_a2z00_3343); 
PROCEDURE_SET(BgL_zc3z04anonymousza32675ze3z87_10980, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32675ze3z87_10980;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3195==BGl_zc3zd3fxzd2envzc2zz__r4_numbers_6_5_fixnumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3352;obj_t BgL_a2z00_3353;
BgL_a1z00_3352 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3199), BgL_stkz00_196); 
BgL_a2z00_3353 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3200), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32679ze3z87_10981;
BgL_zc3z04anonymousza32679ze3z87_10981 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32679ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32679ze3z87_10981, 
(int)(((long)0)), BgL_a1z00_3352); 
PROCEDURE_SET(BgL_zc3z04anonymousza32679ze3z87_10981, 
(int)(((long)1)), BgL_a2z00_3353); 
PROCEDURE_SET(BgL_zc3z04anonymousza32679ze3z87_10981, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32679ze3z87_10981;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3195==BGl_ze3zd3fxzd2envze2zz__r4_numbers_6_5_fixnumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3362;obj_t BgL_a2z00_3363;
BgL_a1z00_3362 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3199), BgL_stkz00_196); 
BgL_a2z00_3363 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3200), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32683ze3z87_10982;
BgL_zc3z04anonymousza32683ze3z87_10982 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32683ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32683ze3z87_10982, 
(int)(((long)0)), BgL_a1z00_3362); 
PROCEDURE_SET(BgL_zc3z04anonymousza32683ze3z87_10982, 
(int)(((long)1)), BgL_a2z00_3363); 
PROCEDURE_SET(BgL_zc3z04anonymousza32683ze3z87_10982, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32683ze3z87_10982;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3195==BGl_zd3fxzd2envz01zz__r4_numbers_6_5_fixnumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3372;obj_t BgL_a2z00_3373;
BgL_a1z00_3372 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3199), BgL_stkz00_196); 
BgL_a2z00_3373 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3200), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32687ze3z87_10983;
BgL_zc3z04anonymousza32687ze3z87_10983 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32687ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32687ze3z87_10983, 
(int)(((long)0)), BgL_a1z00_3372); 
PROCEDURE_SET(BgL_zc3z04anonymousza32687ze3z87_10983, 
(int)(((long)1)), BgL_a2z00_3373); 
PROCEDURE_SET(BgL_zc3z04anonymousza32687ze3z87_10983, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32687ze3z87_10983;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3195==BGl_zb2flzd2envz60zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3382;obj_t BgL_a2z00_3383;
BgL_a1z00_3382 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3199), BgL_stkz00_196); 
BgL_a2z00_3383 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3200), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32691ze3z87_10984;
BgL_zc3z04anonymousza32691ze3z87_10984 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32691ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32691ze3z87_10984, 
(int)(((long)0)), BgL_a1z00_3382); 
PROCEDURE_SET(BgL_zc3z04anonymousza32691ze3z87_10984, 
(int)(((long)1)), BgL_a2z00_3383); 
PROCEDURE_SET(BgL_zc3z04anonymousza32691ze3z87_10984, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32691ze3z87_10984;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3195==BGl_zd2flzd2envz00zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3392;obj_t BgL_a2z00_3393;
BgL_a1z00_3392 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3199), BgL_stkz00_196); 
BgL_a2z00_3393 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3200), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32695ze3z87_10985;
BgL_zc3z04anonymousza32695ze3z87_10985 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32695ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32695ze3z87_10985, 
(int)(((long)0)), BgL_a1z00_3392); 
PROCEDURE_SET(BgL_zc3z04anonymousza32695ze3z87_10985, 
(int)(((long)1)), BgL_a2z00_3393); 
PROCEDURE_SET(BgL_zc3z04anonymousza32695ze3z87_10985, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32695ze3z87_10985;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3195==BGl_za2flzd2envz70zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3402;obj_t BgL_a2z00_3403;
BgL_a1z00_3402 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3199), BgL_stkz00_196); 
BgL_a2z00_3403 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3200), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32699ze3z87_10986;
BgL_zc3z04anonymousza32699ze3z87_10986 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32699ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32699ze3z87_10986, 
(int)(((long)0)), BgL_a1z00_3402); 
PROCEDURE_SET(BgL_zc3z04anonymousza32699ze3z87_10986, 
(int)(((long)1)), BgL_a2z00_3403); 
PROCEDURE_SET(BgL_zc3z04anonymousza32699ze3z87_10986, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32699ze3z87_10986;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3195==BGl_zf2flzd2envz20zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3412;obj_t BgL_a2z00_3413;
BgL_a1z00_3412 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3199), BgL_stkz00_196); 
BgL_a2z00_3413 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3200), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32703ze3z87_10987;
BgL_zc3z04anonymousza32703ze3z87_10987 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32703ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32703ze3z87_10987, 
(int)(((long)0)), BgL_a1z00_3412); 
PROCEDURE_SET(BgL_zc3z04anonymousza32703ze3z87_10987, 
(int)(((long)1)), BgL_a2z00_3413); 
PROCEDURE_SET(BgL_zc3z04anonymousza32703ze3z87_10987, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32703ze3z87_10987;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3195==BGl_zc3flzd2envz11zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3422;obj_t BgL_a2z00_3423;
BgL_a1z00_3422 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3199), BgL_stkz00_196); 
BgL_a2z00_3423 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3200), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32707ze3z87_10988;
BgL_zc3z04anonymousza32707ze3z87_10988 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32707ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32707ze3z87_10988, 
(int)(((long)0)), BgL_a1z00_3422); 
PROCEDURE_SET(BgL_zc3z04anonymousza32707ze3z87_10988, 
(int)(((long)1)), BgL_a2z00_3423); 
PROCEDURE_SET(BgL_zc3z04anonymousza32707ze3z87_10988, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32707ze3z87_10988;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3195==BGl_ze3flzd2envz31zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3432;obj_t BgL_a2z00_3433;
BgL_a1z00_3432 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3199), BgL_stkz00_196); 
BgL_a2z00_3433 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3200), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32711ze3z87_10989;
BgL_zc3z04anonymousza32711ze3z87_10989 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32711ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32711ze3z87_10989, 
(int)(((long)0)), BgL_a1z00_3432); 
PROCEDURE_SET(BgL_zc3z04anonymousza32711ze3z87_10989, 
(int)(((long)1)), BgL_a2z00_3433); 
PROCEDURE_SET(BgL_zc3z04anonymousza32711ze3z87_10989, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32711ze3z87_10989;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3195==BGl_zc3zd3flzd2envzc2zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3442;obj_t BgL_a2z00_3443;
BgL_a1z00_3442 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3199), BgL_stkz00_196); 
BgL_a2z00_3443 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3200), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32715ze3z87_10990;
BgL_zc3z04anonymousza32715ze3z87_10990 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32715ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32715ze3z87_10990, 
(int)(((long)0)), BgL_a1z00_3442); 
PROCEDURE_SET(BgL_zc3z04anonymousza32715ze3z87_10990, 
(int)(((long)1)), BgL_a2z00_3443); 
PROCEDURE_SET(BgL_zc3z04anonymousza32715ze3z87_10990, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32715ze3z87_10990;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3195==BGl_ze3zd3flzd2envze2zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3452;obj_t BgL_a2z00_3453;
BgL_a1z00_3452 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3199), BgL_stkz00_196); 
BgL_a2z00_3453 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3200), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32719ze3z87_10991;
BgL_zc3z04anonymousza32719ze3z87_10991 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32719ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32719ze3z87_10991, 
(int)(((long)0)), BgL_a1z00_3452); 
PROCEDURE_SET(BgL_zc3z04anonymousza32719ze3z87_10991, 
(int)(((long)1)), BgL_a2z00_3453); 
PROCEDURE_SET(BgL_zc3z04anonymousza32719ze3z87_10991, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32719ze3z87_10991;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3195==BGl_zd3flzd2envz01zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3462;obj_t BgL_a2z00_3463;
BgL_a1z00_3462 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3199), BgL_stkz00_196); 
BgL_a2z00_3463 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3200), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32723ze3z87_10992;
BgL_zc3z04anonymousza32723ze3z87_10992 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32723ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32723ze3z87_10992, 
(int)(((long)0)), BgL_a1z00_3462); 
PROCEDURE_SET(BgL_zc3z04anonymousza32723ze3z87_10992, 
(int)(((long)1)), BgL_a2z00_3463); 
PROCEDURE_SET(BgL_zc3z04anonymousza32723ze3z87_10992, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32723ze3z87_10992;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3195==BGl_eqzf3zd2envz21zz__r4_equivalence_6_2z00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3472;obj_t BgL_a2z00_3473;
BgL_a1z00_3472 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3199), BgL_stkz00_196); 
BgL_a2z00_3473 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3200), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32727ze3z87_10993;
BgL_zc3z04anonymousza32727ze3z87_10993 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32727ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32727ze3z87_10993, 
(int)(((long)0)), BgL_a1z00_3472); 
PROCEDURE_SET(BgL_zc3z04anonymousza32727ze3z87_10993, 
(int)(((long)1)), BgL_a2z00_3473); 
return BgL_zc3z04anonymousza32727ze3z87_10993;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3195==BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3480;obj_t BgL_a2z00_3481;
BgL_a1z00_3480 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3199), BgL_stkz00_196); 
BgL_a2z00_3481 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3200), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32729ze3z87_10994;
BgL_zc3z04anonymousza32729ze3z87_10994 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32729ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32729ze3z87_10994, 
(int)(((long)0)), BgL_a1z00_3480); 
PROCEDURE_SET(BgL_zc3z04anonymousza32729ze3z87_10994, 
(int)(((long)1)), BgL_a2z00_3481); 
return BgL_zc3z04anonymousza32729ze3z87_10994;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
return BFALSE;} } } } } } } } } } } } } } } } } } } } } } } } } } } } } }  else 
{ /* Eval/evaluate_comp.scm 1019 */
return BFALSE;} } } }  else 
{ /* Eval/evaluate_comp.scm 1014 */
return BFALSE;} } } 

}



/* &<@anonymous:2619> */
obj_t BGl_z62zc3z04anonymousza32619ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10998, obj_t BgL_sz00_11002)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_10999;obj_t BgL_a2z00_11000;obj_t BgL_locz00_11001;
BgL_a1z00_10999 = 
PROCEDURE_REF(BgL_envz00_10998, 
(int)(((long)0))); 
BgL_a2z00_11000 = 
PROCEDURE_REF(BgL_envz00_10998, 
(int)(((long)1))); 
BgL_locz00_11001 = 
PROCEDURE_REF(BgL_envz00_10998, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13425;
BgL_bpz00_13425 = 
VECTOR_REF(
((obj_t)BgL_sz00_11002),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13426;obj_t BgL_a2z00_13427;
BgL_a1z00_13426 = 
PROCEDURE_ENTRY(BgL_a1z00_10999)(BgL_a1z00_10999, BgL_sz00_11002, BEOA); 
BgL_a2z00_13427 = 
PROCEDURE_ENTRY(BgL_a2z00_11000)(BgL_a2z00_11000, BgL_sz00_11002, BEOA); 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_13426))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5228z00zz__evaluate_compz00, BGl_symbol5230z00zz__evaluate_compz00, BgL_a1z00_13426, BgL_locz00_11001); } 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_13427))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5228z00zz__evaluate_compz00, BGl_symbol5230z00zz__evaluate_compz00, BgL_a2z00_13427, BgL_locz00_11001); } 
return 
BGl_2zb2zb2zz__r4_numbers_6_5z00(BgL_a1z00_13426, BgL_a2z00_13427);} } } } 

}



/* &<@anonymous:2623> */
obj_t BGl_z62zc3z04anonymousza32623ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11003, obj_t BgL_sz00_11007)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11004;obj_t BgL_a2z00_11005;obj_t BgL_locz00_11006;
BgL_a1z00_11004 = 
PROCEDURE_REF(BgL_envz00_11003, 
(int)(((long)0))); 
BgL_a2z00_11005 = 
PROCEDURE_REF(BgL_envz00_11003, 
(int)(((long)1))); 
BgL_locz00_11006 = 
PROCEDURE_REF(BgL_envz00_11003, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13428;
BgL_bpz00_13428 = 
VECTOR_REF(
((obj_t)BgL_sz00_11007),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13429;obj_t BgL_a2z00_13430;
BgL_a1z00_13429 = 
PROCEDURE_ENTRY(BgL_a1z00_11004)(BgL_a1z00_11004, BgL_sz00_11007, BEOA); 
BgL_a2z00_13430 = 
PROCEDURE_ENTRY(BgL_a2z00_11005)(BgL_a2z00_11005, BgL_sz00_11007, BEOA); 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_13429))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5232z00zz__evaluate_compz00, BGl_symbol5230z00zz__evaluate_compz00, BgL_a1z00_13429, BgL_locz00_11006); } 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_13430))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5232z00zz__evaluate_compz00, BGl_symbol5230z00zz__evaluate_compz00, BgL_a2z00_13430, BgL_locz00_11006); } 
return 
BGl_2zd2zd2zz__r4_numbers_6_5z00(BgL_a1z00_13429, BgL_a2z00_13430);} } } } 

}



/* &<@anonymous:2627> */
obj_t BGl_z62zc3z04anonymousza32627ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11008, obj_t BgL_sz00_11012)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11009;obj_t BgL_a2z00_11010;obj_t BgL_locz00_11011;
BgL_a1z00_11009 = 
PROCEDURE_REF(BgL_envz00_11008, 
(int)(((long)0))); 
BgL_a2z00_11010 = 
PROCEDURE_REF(BgL_envz00_11008, 
(int)(((long)1))); 
BgL_locz00_11011 = 
PROCEDURE_REF(BgL_envz00_11008, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13431;
BgL_bpz00_13431 = 
VECTOR_REF(
((obj_t)BgL_sz00_11012),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13432;obj_t BgL_a2z00_13433;
BgL_a1z00_13432 = 
PROCEDURE_ENTRY(BgL_a1z00_11009)(BgL_a1z00_11009, BgL_sz00_11012, BEOA); 
BgL_a2z00_13433 = 
PROCEDURE_ENTRY(BgL_a2z00_11010)(BgL_a2z00_11010, BgL_sz00_11012, BEOA); 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_13432))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5234z00zz__evaluate_compz00, BGl_symbol5230z00zz__evaluate_compz00, BgL_a1z00_13432, BgL_locz00_11011); } 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_13433))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5234z00zz__evaluate_compz00, BGl_symbol5230z00zz__evaluate_compz00, BgL_a2z00_13433, BgL_locz00_11011); } 
return 
BGl_2za2za2zz__r4_numbers_6_5z00(BgL_a1z00_13432, BgL_a2z00_13433);} } } } 

}



/* &<@anonymous:2631> */
obj_t BGl_z62zc3z04anonymousza32631ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11013, obj_t BgL_sz00_11017)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11014;obj_t BgL_a2z00_11015;obj_t BgL_locz00_11016;
BgL_a1z00_11014 = 
PROCEDURE_REF(BgL_envz00_11013, 
(int)(((long)0))); 
BgL_a2z00_11015 = 
PROCEDURE_REF(BgL_envz00_11013, 
(int)(((long)1))); 
BgL_locz00_11016 = 
PROCEDURE_REF(BgL_envz00_11013, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13434;
BgL_bpz00_13434 = 
VECTOR_REF(
((obj_t)BgL_sz00_11017),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13435;obj_t BgL_a2z00_13436;
BgL_a1z00_13435 = 
PROCEDURE_ENTRY(BgL_a1z00_11014)(BgL_a1z00_11014, BgL_sz00_11017, BEOA); 
BgL_a2z00_13436 = 
PROCEDURE_ENTRY(BgL_a2z00_11015)(BgL_a2z00_11015, BgL_sz00_11017, BEOA); 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_13435))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5236z00zz__evaluate_compz00, BGl_symbol5230z00zz__evaluate_compz00, BgL_a1z00_13435, BgL_locz00_11016); } 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_13436))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5236z00zz__evaluate_compz00, BGl_symbol5230z00zz__evaluate_compz00, BgL_a2z00_13436, BgL_locz00_11016); } 
return 
BGl_2zf2zf2zz__r4_numbers_6_5z00(BgL_a1z00_13435, BgL_a2z00_13436);} } } } 

}



/* &<@anonymous:2635> */
obj_t BGl_z62zc3z04anonymousza32635ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11018, obj_t BgL_sz00_11022)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11019;obj_t BgL_a2z00_11020;obj_t BgL_locz00_11021;
BgL_a1z00_11019 = 
PROCEDURE_REF(BgL_envz00_11018, 
(int)(((long)0))); 
BgL_a2z00_11020 = 
PROCEDURE_REF(BgL_envz00_11018, 
(int)(((long)1))); 
BgL_locz00_11021 = 
PROCEDURE_REF(BgL_envz00_11018, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
bool_t BgL_tmpz00_20691;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13437;
BgL_bpz00_13437 = 
VECTOR_REF(
((obj_t)BgL_sz00_11022),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13438;obj_t BgL_a2z00_13439;
BgL_a1z00_13438 = 
PROCEDURE_ENTRY(BgL_a1z00_11019)(BgL_a1z00_11019, BgL_sz00_11022, BEOA); 
BgL_a2z00_13439 = 
PROCEDURE_ENTRY(BgL_a2z00_11020)(BgL_a2z00_11020, BgL_sz00_11022, BEOA); 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_13438))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5238z00zz__evaluate_compz00, BGl_symbol5230z00zz__evaluate_compz00, BgL_a1z00_13438, BgL_locz00_11021); } 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_13439))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5238z00zz__evaluate_compz00, BGl_symbol5230z00zz__evaluate_compz00, BgL_a2z00_13439, BgL_locz00_11021); } 
BgL_tmpz00_20691 = 
BGl_2zc3zc3zz__r4_numbers_6_5z00(BgL_a1z00_13438, BgL_a2z00_13439); } } 
return 
BBOOL(BgL_tmpz00_20691);} } } 

}



/* &<@anonymous:2639> */
obj_t BGl_z62zc3z04anonymousza32639ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11023, obj_t BgL_sz00_11027)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11024;obj_t BgL_a2z00_11025;obj_t BgL_locz00_11026;
BgL_a1z00_11024 = 
PROCEDURE_REF(BgL_envz00_11023, 
(int)(((long)0))); 
BgL_a2z00_11025 = 
PROCEDURE_REF(BgL_envz00_11023, 
(int)(((long)1))); 
BgL_locz00_11026 = 
PROCEDURE_REF(BgL_envz00_11023, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
bool_t BgL_tmpz00_20716;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13440;
BgL_bpz00_13440 = 
VECTOR_REF(
((obj_t)BgL_sz00_11027),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13441;obj_t BgL_a2z00_13442;
BgL_a1z00_13441 = 
PROCEDURE_ENTRY(BgL_a1z00_11024)(BgL_a1z00_11024, BgL_sz00_11027, BEOA); 
BgL_a2z00_13442 = 
PROCEDURE_ENTRY(BgL_a2z00_11025)(BgL_a2z00_11025, BgL_sz00_11027, BEOA); 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_13441))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5240z00zz__evaluate_compz00, BGl_symbol5230z00zz__evaluate_compz00, BgL_a1z00_13441, BgL_locz00_11026); } 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_13442))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5240z00zz__evaluate_compz00, BGl_symbol5230z00zz__evaluate_compz00, BgL_a2z00_13442, BgL_locz00_11026); } 
BgL_tmpz00_20716 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(BgL_a1z00_13441, BgL_a2z00_13442); } } 
return 
BBOOL(BgL_tmpz00_20716);} } } 

}



/* &<@anonymous:2643> */
obj_t BGl_z62zc3z04anonymousza32643ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11028, obj_t BgL_sz00_11032)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11029;obj_t BgL_a2z00_11030;obj_t BgL_locz00_11031;
BgL_a1z00_11029 = 
PROCEDURE_REF(BgL_envz00_11028, 
(int)(((long)0))); 
BgL_a2z00_11030 = 
PROCEDURE_REF(BgL_envz00_11028, 
(int)(((long)1))); 
BgL_locz00_11031 = 
PROCEDURE_REF(BgL_envz00_11028, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
bool_t BgL_tmpz00_20741;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13443;
BgL_bpz00_13443 = 
VECTOR_REF(
((obj_t)BgL_sz00_11032),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13444;obj_t BgL_a2z00_13445;
BgL_a1z00_13444 = 
PROCEDURE_ENTRY(BgL_a1z00_11029)(BgL_a1z00_11029, BgL_sz00_11032, BEOA); 
BgL_a2z00_13445 = 
PROCEDURE_ENTRY(BgL_a2z00_11030)(BgL_a2z00_11030, BgL_sz00_11032, BEOA); 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_13444))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5242z00zz__evaluate_compz00, BGl_symbol5230z00zz__evaluate_compz00, BgL_a1z00_13444, BgL_locz00_11031); } 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_13445))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5242z00zz__evaluate_compz00, BGl_symbol5230z00zz__evaluate_compz00, BgL_a2z00_13445, BgL_locz00_11031); } 
BgL_tmpz00_20741 = 
BGl_2zc3zd3z10zz__r4_numbers_6_5z00(BgL_a1z00_13444, BgL_a2z00_13445); } } 
return 
BBOOL(BgL_tmpz00_20741);} } } 

}



/* &<@anonymous:2647> */
obj_t BGl_z62zc3z04anonymousza32647ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11033, obj_t BgL_sz00_11037)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11034;obj_t BgL_a2z00_11035;obj_t BgL_locz00_11036;
BgL_a1z00_11034 = 
PROCEDURE_REF(BgL_envz00_11033, 
(int)(((long)0))); 
BgL_a2z00_11035 = 
PROCEDURE_REF(BgL_envz00_11033, 
(int)(((long)1))); 
BgL_locz00_11036 = 
PROCEDURE_REF(BgL_envz00_11033, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
bool_t BgL_tmpz00_20766;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13446;
BgL_bpz00_13446 = 
VECTOR_REF(
((obj_t)BgL_sz00_11037),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13447;obj_t BgL_a2z00_13448;
BgL_a1z00_13447 = 
PROCEDURE_ENTRY(BgL_a1z00_11034)(BgL_a1z00_11034, BgL_sz00_11037, BEOA); 
BgL_a2z00_13448 = 
PROCEDURE_ENTRY(BgL_a2z00_11035)(BgL_a2z00_11035, BgL_sz00_11037, BEOA); 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_13447))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5244z00zz__evaluate_compz00, BGl_symbol5230z00zz__evaluate_compz00, BgL_a1z00_13447, BgL_locz00_11036); } 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_13448))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5244z00zz__evaluate_compz00, BGl_symbol5230z00zz__evaluate_compz00, BgL_a2z00_13448, BgL_locz00_11036); } 
BgL_tmpz00_20766 = 
BGl_2ze3zd3z30zz__r4_numbers_6_5z00(BgL_a1z00_13447, BgL_a2z00_13448); } } 
return 
BBOOL(BgL_tmpz00_20766);} } } 

}



/* &<@anonymous:2651> */
obj_t BGl_z62zc3z04anonymousza32651ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11038, obj_t BgL_sz00_11042)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11039;obj_t BgL_a2z00_11040;obj_t BgL_locz00_11041;
BgL_a1z00_11039 = 
PROCEDURE_REF(BgL_envz00_11038, 
(int)(((long)0))); 
BgL_a2z00_11040 = 
PROCEDURE_REF(BgL_envz00_11038, 
(int)(((long)1))); 
BgL_locz00_11041 = 
PROCEDURE_REF(BgL_envz00_11038, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
bool_t BgL_tmpz00_20791;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13449;
BgL_bpz00_13449 = 
VECTOR_REF(
((obj_t)BgL_sz00_11042),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13450;obj_t BgL_a2z00_13451;
BgL_a1z00_13450 = 
PROCEDURE_ENTRY(BgL_a1z00_11039)(BgL_a1z00_11039, BgL_sz00_11042, BEOA); 
BgL_a2z00_13451 = 
PROCEDURE_ENTRY(BgL_a2z00_11040)(BgL_a2z00_11040, BgL_sz00_11042, BEOA); 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_13450))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5246z00zz__evaluate_compz00, BGl_symbol5230z00zz__evaluate_compz00, BgL_a1z00_13450, BgL_locz00_11041); } 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_13451))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5246z00zz__evaluate_compz00, BGl_symbol5230z00zz__evaluate_compz00, BgL_a2z00_13451, BgL_locz00_11041); } 
BgL_tmpz00_20791 = 
BGl_2zd3zd3zz__r4_numbers_6_5z00(BgL_a1z00_13450, BgL_a2z00_13451); } } 
return 
BBOOL(BgL_tmpz00_20791);} } } 

}



/* &<@anonymous:2655> */
obj_t BGl_z62zc3z04anonymousza32655ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11043, obj_t BgL_sz00_11047)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11044;obj_t BgL_a2z00_11045;obj_t BgL_locz00_11046;
BgL_a1z00_11044 = 
PROCEDURE_REF(BgL_envz00_11043, 
(int)(((long)0))); 
BgL_a2z00_11045 = 
PROCEDURE_REF(BgL_envz00_11043, 
(int)(((long)1))); 
BgL_locz00_11046 = 
PROCEDURE_REF(BgL_envz00_11043, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
long BgL_tmpz00_20816;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13452;
BgL_bpz00_13452 = 
VECTOR_REF(
((obj_t)BgL_sz00_11047),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13453;obj_t BgL_a2z00_13454;
BgL_a1z00_13453 = 
PROCEDURE_ENTRY(BgL_a1z00_11044)(BgL_a1z00_11044, BgL_sz00_11047, BEOA); 
BgL_a2z00_13454 = 
PROCEDURE_ENTRY(BgL_a2z00_11045)(BgL_a2z00_11045, BgL_sz00_11047, BEOA); 
if(
INTEGERP(BgL_a1z00_13453))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5248z00zz__evaluate_compz00, BGl_symbol5250z00zz__evaluate_compz00, BgL_a1z00_13453, BgL_locz00_11046); } 
if(
INTEGERP(BgL_a2z00_13454))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5248z00zz__evaluate_compz00, BGl_symbol5250z00zz__evaluate_compz00, BgL_a2z00_13454, BgL_locz00_11046); } 
BgL_tmpz00_20816 = 
(
(long)CINT(BgL_a1z00_13453)+
(long)CINT(BgL_a2z00_13454)); } } 
return 
BINT(BgL_tmpz00_20816);} } } 

}



/* &<@anonymous:2659> */
obj_t BGl_z62zc3z04anonymousza32659ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11048, obj_t BgL_sz00_11052)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11049;obj_t BgL_a2z00_11050;obj_t BgL_locz00_11051;
BgL_a1z00_11049 = 
PROCEDURE_REF(BgL_envz00_11048, 
(int)(((long)0))); 
BgL_a2z00_11050 = 
PROCEDURE_REF(BgL_envz00_11048, 
(int)(((long)1))); 
BgL_locz00_11051 = 
PROCEDURE_REF(BgL_envz00_11048, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
long BgL_tmpz00_20843;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13455;
BgL_bpz00_13455 = 
VECTOR_REF(
((obj_t)BgL_sz00_11052),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13456;obj_t BgL_a2z00_13457;
BgL_a1z00_13456 = 
PROCEDURE_ENTRY(BgL_a1z00_11049)(BgL_a1z00_11049, BgL_sz00_11052, BEOA); 
BgL_a2z00_13457 = 
PROCEDURE_ENTRY(BgL_a2z00_11050)(BgL_a2z00_11050, BgL_sz00_11052, BEOA); 
if(
INTEGERP(BgL_a1z00_13456))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5252z00zz__evaluate_compz00, BGl_symbol5250z00zz__evaluate_compz00, BgL_a1z00_13456, BgL_locz00_11051); } 
if(
INTEGERP(BgL_a2z00_13457))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5252z00zz__evaluate_compz00, BGl_symbol5250z00zz__evaluate_compz00, BgL_a2z00_13457, BgL_locz00_11051); } 
BgL_tmpz00_20843 = 
(
(long)CINT(BgL_a1z00_13456)-
(long)CINT(BgL_a2z00_13457)); } } 
return 
BINT(BgL_tmpz00_20843);} } } 

}



/* &<@anonymous:2663> */
obj_t BGl_z62zc3z04anonymousza32663ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11053, obj_t BgL_sz00_11057)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11054;obj_t BgL_a2z00_11055;obj_t BgL_locz00_11056;
BgL_a1z00_11054 = 
PROCEDURE_REF(BgL_envz00_11053, 
(int)(((long)0))); 
BgL_a2z00_11055 = 
PROCEDURE_REF(BgL_envz00_11053, 
(int)(((long)1))); 
BgL_locz00_11056 = 
PROCEDURE_REF(BgL_envz00_11053, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
long BgL_tmpz00_20870;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13458;
BgL_bpz00_13458 = 
VECTOR_REF(
((obj_t)BgL_sz00_11057),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13459;obj_t BgL_a2z00_13460;
BgL_a1z00_13459 = 
PROCEDURE_ENTRY(BgL_a1z00_11054)(BgL_a1z00_11054, BgL_sz00_11057, BEOA); 
BgL_a2z00_13460 = 
PROCEDURE_ENTRY(BgL_a2z00_11055)(BgL_a2z00_11055, BgL_sz00_11057, BEOA); 
if(
INTEGERP(BgL_a1z00_13459))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5254z00zz__evaluate_compz00, BGl_symbol5250z00zz__evaluate_compz00, BgL_a1z00_13459, BgL_locz00_11056); } 
if(
INTEGERP(BgL_a2z00_13460))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5254z00zz__evaluate_compz00, BGl_symbol5250z00zz__evaluate_compz00, BgL_a2z00_13460, BgL_locz00_11056); } 
BgL_tmpz00_20870 = 
(
(long)CINT(BgL_a1z00_13459)*
(long)CINT(BgL_a2z00_13460)); } } 
return 
BINT(BgL_tmpz00_20870);} } } 

}



/* &<@anonymous:2667> */
obj_t BGl_z62zc3z04anonymousza32667ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11058, obj_t BgL_sz00_11062)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11059;obj_t BgL_a2z00_11060;obj_t BgL_locz00_11061;
BgL_a1z00_11059 = 
PROCEDURE_REF(BgL_envz00_11058, 
(int)(((long)0))); 
BgL_a2z00_11060 = 
PROCEDURE_REF(BgL_envz00_11058, 
(int)(((long)1))); 
BgL_locz00_11061 = 
PROCEDURE_REF(BgL_envz00_11058, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
long BgL_tmpz00_20897;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13461;
BgL_bpz00_13461 = 
VECTOR_REF(
((obj_t)BgL_sz00_11062),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13462;obj_t BgL_a2z00_13463;
BgL_a1z00_13462 = 
PROCEDURE_ENTRY(BgL_a1z00_11059)(BgL_a1z00_11059, BgL_sz00_11062, BEOA); 
BgL_a2z00_13463 = 
PROCEDURE_ENTRY(BgL_a2z00_11060)(BgL_a2z00_11060, BgL_sz00_11062, BEOA); 
if(
INTEGERP(BgL_a1z00_13462))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5256z00zz__evaluate_compz00, BGl_symbol5250z00zz__evaluate_compz00, BgL_a1z00_13462, BgL_locz00_11061); } 
if(
INTEGERP(BgL_a2z00_13463))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5256z00zz__evaluate_compz00, BGl_symbol5250z00zz__evaluate_compz00, BgL_a2z00_13463, BgL_locz00_11061); } 
BgL_tmpz00_20897 = 
(
(long)CINT(BgL_a1z00_13462)/
(long)CINT(BgL_a2z00_13463)); } } 
return 
BINT(BgL_tmpz00_20897);} } } 

}



/* &<@anonymous:2671> */
obj_t BGl_z62zc3z04anonymousza32671ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11063, obj_t BgL_sz00_11067)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11064;obj_t BgL_a2z00_11065;obj_t BgL_locz00_11066;
BgL_a1z00_11064 = 
PROCEDURE_REF(BgL_envz00_11063, 
(int)(((long)0))); 
BgL_a2z00_11065 = 
PROCEDURE_REF(BgL_envz00_11063, 
(int)(((long)1))); 
BgL_locz00_11066 = 
PROCEDURE_REF(BgL_envz00_11063, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
bool_t BgL_tmpz00_20924;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13464;
BgL_bpz00_13464 = 
VECTOR_REF(
((obj_t)BgL_sz00_11067),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13465;obj_t BgL_a2z00_13466;
BgL_a1z00_13465 = 
PROCEDURE_ENTRY(BgL_a1z00_11064)(BgL_a1z00_11064, BgL_sz00_11067, BEOA); 
BgL_a2z00_13466 = 
PROCEDURE_ENTRY(BgL_a2z00_11065)(BgL_a2z00_11065, BgL_sz00_11067, BEOA); 
if(
INTEGERP(BgL_a1z00_13465))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5258z00zz__evaluate_compz00, BGl_symbol5250z00zz__evaluate_compz00, BgL_a1z00_13465, BgL_locz00_11066); } 
if(
INTEGERP(BgL_a2z00_13466))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5258z00zz__evaluate_compz00, BGl_symbol5250z00zz__evaluate_compz00, BgL_a2z00_13466, BgL_locz00_11066); } 
BgL_tmpz00_20924 = 
(
(long)CINT(BgL_a1z00_13465)<
(long)CINT(BgL_a2z00_13466)); } } 
return 
BBOOL(BgL_tmpz00_20924);} } } 

}



/* &<@anonymous:2675> */
obj_t BGl_z62zc3z04anonymousza32675ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11068, obj_t BgL_sz00_11072)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11069;obj_t BgL_a2z00_11070;obj_t BgL_locz00_11071;
BgL_a1z00_11069 = 
PROCEDURE_REF(BgL_envz00_11068, 
(int)(((long)0))); 
BgL_a2z00_11070 = 
PROCEDURE_REF(BgL_envz00_11068, 
(int)(((long)1))); 
BgL_locz00_11071 = 
PROCEDURE_REF(BgL_envz00_11068, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
bool_t BgL_tmpz00_20951;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13467;
BgL_bpz00_13467 = 
VECTOR_REF(
((obj_t)BgL_sz00_11072),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13468;obj_t BgL_a2z00_13469;
BgL_a1z00_13468 = 
PROCEDURE_ENTRY(BgL_a1z00_11069)(BgL_a1z00_11069, BgL_sz00_11072, BEOA); 
BgL_a2z00_13469 = 
PROCEDURE_ENTRY(BgL_a2z00_11070)(BgL_a2z00_11070, BgL_sz00_11072, BEOA); 
if(
INTEGERP(BgL_a1z00_13468))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5260z00zz__evaluate_compz00, BGl_symbol5250z00zz__evaluate_compz00, BgL_a1z00_13468, BgL_locz00_11071); } 
if(
INTEGERP(BgL_a2z00_13469))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5260z00zz__evaluate_compz00, BGl_symbol5250z00zz__evaluate_compz00, BgL_a2z00_13469, BgL_locz00_11071); } 
BgL_tmpz00_20951 = 
(
(long)CINT(BgL_a1z00_13468)>
(long)CINT(BgL_a2z00_13469)); } } 
return 
BBOOL(BgL_tmpz00_20951);} } } 

}



/* &<@anonymous:2679> */
obj_t BGl_z62zc3z04anonymousza32679ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11073, obj_t BgL_sz00_11077)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11074;obj_t BgL_a2z00_11075;obj_t BgL_locz00_11076;
BgL_a1z00_11074 = 
PROCEDURE_REF(BgL_envz00_11073, 
(int)(((long)0))); 
BgL_a2z00_11075 = 
PROCEDURE_REF(BgL_envz00_11073, 
(int)(((long)1))); 
BgL_locz00_11076 = 
PROCEDURE_REF(BgL_envz00_11073, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
bool_t BgL_tmpz00_20978;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13470;
BgL_bpz00_13470 = 
VECTOR_REF(
((obj_t)BgL_sz00_11077),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13471;obj_t BgL_a2z00_13472;
BgL_a1z00_13471 = 
PROCEDURE_ENTRY(BgL_a1z00_11074)(BgL_a1z00_11074, BgL_sz00_11077, BEOA); 
BgL_a2z00_13472 = 
PROCEDURE_ENTRY(BgL_a2z00_11075)(BgL_a2z00_11075, BgL_sz00_11077, BEOA); 
if(
INTEGERP(BgL_a1z00_13471))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5262z00zz__evaluate_compz00, BGl_symbol5250z00zz__evaluate_compz00, BgL_a1z00_13471, BgL_locz00_11076); } 
if(
INTEGERP(BgL_a2z00_13472))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5262z00zz__evaluate_compz00, BGl_symbol5250z00zz__evaluate_compz00, BgL_a2z00_13472, BgL_locz00_11076); } 
BgL_tmpz00_20978 = 
(
(long)CINT(BgL_a1z00_13471)<=
(long)CINT(BgL_a2z00_13472)); } } 
return 
BBOOL(BgL_tmpz00_20978);} } } 

}



/* &<@anonymous:2683> */
obj_t BGl_z62zc3z04anonymousza32683ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11078, obj_t BgL_sz00_11082)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11079;obj_t BgL_a2z00_11080;obj_t BgL_locz00_11081;
BgL_a1z00_11079 = 
PROCEDURE_REF(BgL_envz00_11078, 
(int)(((long)0))); 
BgL_a2z00_11080 = 
PROCEDURE_REF(BgL_envz00_11078, 
(int)(((long)1))); 
BgL_locz00_11081 = 
PROCEDURE_REF(BgL_envz00_11078, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
bool_t BgL_tmpz00_21005;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13473;
BgL_bpz00_13473 = 
VECTOR_REF(
((obj_t)BgL_sz00_11082),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13474;obj_t BgL_a2z00_13475;
BgL_a1z00_13474 = 
PROCEDURE_ENTRY(BgL_a1z00_11079)(BgL_a1z00_11079, BgL_sz00_11082, BEOA); 
BgL_a2z00_13475 = 
PROCEDURE_ENTRY(BgL_a2z00_11080)(BgL_a2z00_11080, BgL_sz00_11082, BEOA); 
if(
INTEGERP(BgL_a1z00_13474))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5264z00zz__evaluate_compz00, BGl_symbol5250z00zz__evaluate_compz00, BgL_a1z00_13474, BgL_locz00_11081); } 
if(
INTEGERP(BgL_a2z00_13475))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5264z00zz__evaluate_compz00, BGl_symbol5250z00zz__evaluate_compz00, BgL_a2z00_13475, BgL_locz00_11081); } 
BgL_tmpz00_21005 = 
(
(long)CINT(BgL_a1z00_13474)>=
(long)CINT(BgL_a2z00_13475)); } } 
return 
BBOOL(BgL_tmpz00_21005);} } } 

}



/* &<@anonymous:2687> */
obj_t BGl_z62zc3z04anonymousza32687ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11083, obj_t BgL_sz00_11087)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11084;obj_t BgL_a2z00_11085;obj_t BgL_locz00_11086;
BgL_a1z00_11084 = 
PROCEDURE_REF(BgL_envz00_11083, 
(int)(((long)0))); 
BgL_a2z00_11085 = 
PROCEDURE_REF(BgL_envz00_11083, 
(int)(((long)1))); 
BgL_locz00_11086 = 
PROCEDURE_REF(BgL_envz00_11083, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
bool_t BgL_tmpz00_21032;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13476;
BgL_bpz00_13476 = 
VECTOR_REF(
((obj_t)BgL_sz00_11087),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13477;obj_t BgL_a2z00_13478;
BgL_a1z00_13477 = 
PROCEDURE_ENTRY(BgL_a1z00_11084)(BgL_a1z00_11084, BgL_sz00_11087, BEOA); 
BgL_a2z00_13478 = 
PROCEDURE_ENTRY(BgL_a2z00_11085)(BgL_a2z00_11085, BgL_sz00_11087, BEOA); 
if(
INTEGERP(BgL_a1z00_13477))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5266z00zz__evaluate_compz00, BGl_symbol5250z00zz__evaluate_compz00, BgL_a1z00_13477, BgL_locz00_11086); } 
if(
INTEGERP(BgL_a2z00_13478))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5266z00zz__evaluate_compz00, BGl_symbol5250z00zz__evaluate_compz00, BgL_a2z00_13478, BgL_locz00_11086); } 
BgL_tmpz00_21032 = 
(
(long)CINT(BgL_a1z00_13477)==
(long)CINT(BgL_a2z00_13478)); } } 
return 
BBOOL(BgL_tmpz00_21032);} } } 

}



/* &<@anonymous:2691> */
obj_t BGl_z62zc3z04anonymousza32691ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11088, obj_t BgL_sz00_11092)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11089;obj_t BgL_a2z00_11090;obj_t BgL_locz00_11091;
BgL_a1z00_11089 = 
PROCEDURE_REF(BgL_envz00_11088, 
(int)(((long)0))); 
BgL_a2z00_11090 = 
PROCEDURE_REF(BgL_envz00_11088, 
(int)(((long)1))); 
BgL_locz00_11091 = 
PROCEDURE_REF(BgL_envz00_11088, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
double BgL_tmpz00_21059;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13479;
BgL_bpz00_13479 = 
VECTOR_REF(
((obj_t)BgL_sz00_11092),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13480;obj_t BgL_a2z00_13481;
BgL_a1z00_13480 = 
PROCEDURE_ENTRY(BgL_a1z00_11089)(BgL_a1z00_11089, BgL_sz00_11092, BEOA); 
BgL_a2z00_13481 = 
PROCEDURE_ENTRY(BgL_a2z00_11090)(BgL_a2z00_11090, BgL_sz00_11092, BEOA); 
if(
REALP(BgL_a1z00_13480))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5268z00zz__evaluate_compz00, BGl_symbol5270z00zz__evaluate_compz00, BgL_a1z00_13480, BgL_locz00_11091); } 
if(
REALP(BgL_a2z00_13481))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5268z00zz__evaluate_compz00, BGl_symbol5270z00zz__evaluate_compz00, BgL_a2z00_13481, BgL_locz00_11091); } 
BgL_tmpz00_21059 = 
(
REAL_TO_DOUBLE(BgL_a1z00_13480)+
REAL_TO_DOUBLE(BgL_a2z00_13481)); } } 
return 
DOUBLE_TO_REAL(BgL_tmpz00_21059);} } } 

}



/* &<@anonymous:2695> */
obj_t BGl_z62zc3z04anonymousza32695ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11093, obj_t BgL_sz00_11097)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11094;obj_t BgL_a2z00_11095;obj_t BgL_locz00_11096;
BgL_a1z00_11094 = 
PROCEDURE_REF(BgL_envz00_11093, 
(int)(((long)0))); 
BgL_a2z00_11095 = 
PROCEDURE_REF(BgL_envz00_11093, 
(int)(((long)1))); 
BgL_locz00_11096 = 
PROCEDURE_REF(BgL_envz00_11093, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
double BgL_tmpz00_21086;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13482;
BgL_bpz00_13482 = 
VECTOR_REF(
((obj_t)BgL_sz00_11097),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13483;obj_t BgL_a2z00_13484;
BgL_a1z00_13483 = 
PROCEDURE_ENTRY(BgL_a1z00_11094)(BgL_a1z00_11094, BgL_sz00_11097, BEOA); 
BgL_a2z00_13484 = 
PROCEDURE_ENTRY(BgL_a2z00_11095)(BgL_a2z00_11095, BgL_sz00_11097, BEOA); 
if(
REALP(BgL_a1z00_13483))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5272z00zz__evaluate_compz00, BGl_symbol5270z00zz__evaluate_compz00, BgL_a1z00_13483, BgL_locz00_11096); } 
if(
REALP(BgL_a2z00_13484))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5272z00zz__evaluate_compz00, BGl_symbol5270z00zz__evaluate_compz00, BgL_a2z00_13484, BgL_locz00_11096); } 
BgL_tmpz00_21086 = 
(
REAL_TO_DOUBLE(BgL_a1z00_13483)-
REAL_TO_DOUBLE(BgL_a2z00_13484)); } } 
return 
DOUBLE_TO_REAL(BgL_tmpz00_21086);} } } 

}



/* &<@anonymous:2699> */
obj_t BGl_z62zc3z04anonymousza32699ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11098, obj_t BgL_sz00_11102)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11099;obj_t BgL_a2z00_11100;obj_t BgL_locz00_11101;
BgL_a1z00_11099 = 
PROCEDURE_REF(BgL_envz00_11098, 
(int)(((long)0))); 
BgL_a2z00_11100 = 
PROCEDURE_REF(BgL_envz00_11098, 
(int)(((long)1))); 
BgL_locz00_11101 = 
PROCEDURE_REF(BgL_envz00_11098, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
double BgL_tmpz00_21113;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13485;
BgL_bpz00_13485 = 
VECTOR_REF(
((obj_t)BgL_sz00_11102),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13486;obj_t BgL_a2z00_13487;
BgL_a1z00_13486 = 
PROCEDURE_ENTRY(BgL_a1z00_11099)(BgL_a1z00_11099, BgL_sz00_11102, BEOA); 
BgL_a2z00_13487 = 
PROCEDURE_ENTRY(BgL_a2z00_11100)(BgL_a2z00_11100, BgL_sz00_11102, BEOA); 
if(
REALP(BgL_a1z00_13486))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5274z00zz__evaluate_compz00, BGl_symbol5270z00zz__evaluate_compz00, BgL_a1z00_13486, BgL_locz00_11101); } 
if(
REALP(BgL_a2z00_13487))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5274z00zz__evaluate_compz00, BGl_symbol5270z00zz__evaluate_compz00, BgL_a2z00_13487, BgL_locz00_11101); } 
BgL_tmpz00_21113 = 
(
REAL_TO_DOUBLE(BgL_a1z00_13486)*
REAL_TO_DOUBLE(BgL_a2z00_13487)); } } 
return 
DOUBLE_TO_REAL(BgL_tmpz00_21113);} } } 

}



/* &<@anonymous:2703> */
obj_t BGl_z62zc3z04anonymousza32703ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11103, obj_t BgL_sz00_11107)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11104;obj_t BgL_a2z00_11105;obj_t BgL_locz00_11106;
BgL_a1z00_11104 = 
PROCEDURE_REF(BgL_envz00_11103, 
(int)(((long)0))); 
BgL_a2z00_11105 = 
PROCEDURE_REF(BgL_envz00_11103, 
(int)(((long)1))); 
BgL_locz00_11106 = 
PROCEDURE_REF(BgL_envz00_11103, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
double BgL_tmpz00_21140;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13488;
BgL_bpz00_13488 = 
VECTOR_REF(
((obj_t)BgL_sz00_11107),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13489;obj_t BgL_a2z00_13490;
BgL_a1z00_13489 = 
PROCEDURE_ENTRY(BgL_a1z00_11104)(BgL_a1z00_11104, BgL_sz00_11107, BEOA); 
BgL_a2z00_13490 = 
PROCEDURE_ENTRY(BgL_a2z00_11105)(BgL_a2z00_11105, BgL_sz00_11107, BEOA); 
if(
REALP(BgL_a1z00_13489))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5276z00zz__evaluate_compz00, BGl_symbol5270z00zz__evaluate_compz00, BgL_a1z00_13489, BgL_locz00_11106); } 
if(
REALP(BgL_a2z00_13490))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5276z00zz__evaluate_compz00, BGl_symbol5270z00zz__evaluate_compz00, BgL_a2z00_13490, BgL_locz00_11106); } 
BgL_tmpz00_21140 = 
(
REAL_TO_DOUBLE(BgL_a1z00_13489)/
REAL_TO_DOUBLE(BgL_a2z00_13490)); } } 
return 
DOUBLE_TO_REAL(BgL_tmpz00_21140);} } } 

}



/* &<@anonymous:2707> */
obj_t BGl_z62zc3z04anonymousza32707ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11108, obj_t BgL_sz00_11112)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11109;obj_t BgL_a2z00_11110;obj_t BgL_locz00_11111;
BgL_a1z00_11109 = 
PROCEDURE_REF(BgL_envz00_11108, 
(int)(((long)0))); 
BgL_a2z00_11110 = 
PROCEDURE_REF(BgL_envz00_11108, 
(int)(((long)1))); 
BgL_locz00_11111 = 
PROCEDURE_REF(BgL_envz00_11108, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
bool_t BgL_tmpz00_21167;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13491;
BgL_bpz00_13491 = 
VECTOR_REF(
((obj_t)BgL_sz00_11112),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13492;obj_t BgL_a2z00_13493;
BgL_a1z00_13492 = 
PROCEDURE_ENTRY(BgL_a1z00_11109)(BgL_a1z00_11109, BgL_sz00_11112, BEOA); 
BgL_a2z00_13493 = 
PROCEDURE_ENTRY(BgL_a2z00_11110)(BgL_a2z00_11110, BgL_sz00_11112, BEOA); 
if(
REALP(BgL_a1z00_13492))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5278z00zz__evaluate_compz00, BGl_symbol5270z00zz__evaluate_compz00, BgL_a1z00_13492, BgL_locz00_11111); } 
if(
REALP(BgL_a2z00_13493))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5278z00zz__evaluate_compz00, BGl_symbol5270z00zz__evaluate_compz00, BgL_a2z00_13493, BgL_locz00_11111); } 
BgL_tmpz00_21167 = 
(
REAL_TO_DOUBLE(BgL_a1z00_13492)<
REAL_TO_DOUBLE(BgL_a2z00_13493)); } } 
return 
BBOOL(BgL_tmpz00_21167);} } } 

}



/* &<@anonymous:2711> */
obj_t BGl_z62zc3z04anonymousza32711ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11113, obj_t BgL_sz00_11117)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11114;obj_t BgL_a2z00_11115;obj_t BgL_locz00_11116;
BgL_a1z00_11114 = 
PROCEDURE_REF(BgL_envz00_11113, 
(int)(((long)0))); 
BgL_a2z00_11115 = 
PROCEDURE_REF(BgL_envz00_11113, 
(int)(((long)1))); 
BgL_locz00_11116 = 
PROCEDURE_REF(BgL_envz00_11113, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
bool_t BgL_tmpz00_21194;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13494;
BgL_bpz00_13494 = 
VECTOR_REF(
((obj_t)BgL_sz00_11117),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13495;obj_t BgL_a2z00_13496;
BgL_a1z00_13495 = 
PROCEDURE_ENTRY(BgL_a1z00_11114)(BgL_a1z00_11114, BgL_sz00_11117, BEOA); 
BgL_a2z00_13496 = 
PROCEDURE_ENTRY(BgL_a2z00_11115)(BgL_a2z00_11115, BgL_sz00_11117, BEOA); 
if(
REALP(BgL_a1z00_13495))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5280z00zz__evaluate_compz00, BGl_symbol5270z00zz__evaluate_compz00, BgL_a1z00_13495, BgL_locz00_11116); } 
if(
REALP(BgL_a2z00_13496))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5280z00zz__evaluate_compz00, BGl_symbol5270z00zz__evaluate_compz00, BgL_a2z00_13496, BgL_locz00_11116); } 
BgL_tmpz00_21194 = 
(
REAL_TO_DOUBLE(BgL_a1z00_13495)>
REAL_TO_DOUBLE(BgL_a2z00_13496)); } } 
return 
BBOOL(BgL_tmpz00_21194);} } } 

}



/* &<@anonymous:2715> */
obj_t BGl_z62zc3z04anonymousza32715ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11118, obj_t BgL_sz00_11122)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11119;obj_t BgL_a2z00_11120;obj_t BgL_locz00_11121;
BgL_a1z00_11119 = 
PROCEDURE_REF(BgL_envz00_11118, 
(int)(((long)0))); 
BgL_a2z00_11120 = 
PROCEDURE_REF(BgL_envz00_11118, 
(int)(((long)1))); 
BgL_locz00_11121 = 
PROCEDURE_REF(BgL_envz00_11118, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
bool_t BgL_tmpz00_21221;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13497;
BgL_bpz00_13497 = 
VECTOR_REF(
((obj_t)BgL_sz00_11122),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13498;obj_t BgL_a2z00_13499;
BgL_a1z00_13498 = 
PROCEDURE_ENTRY(BgL_a1z00_11119)(BgL_a1z00_11119, BgL_sz00_11122, BEOA); 
BgL_a2z00_13499 = 
PROCEDURE_ENTRY(BgL_a2z00_11120)(BgL_a2z00_11120, BgL_sz00_11122, BEOA); 
if(
REALP(BgL_a1z00_13498))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5282z00zz__evaluate_compz00, BGl_symbol5270z00zz__evaluate_compz00, BgL_a1z00_13498, BgL_locz00_11121); } 
if(
REALP(BgL_a2z00_13499))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5282z00zz__evaluate_compz00, BGl_symbol5270z00zz__evaluate_compz00, BgL_a2z00_13499, BgL_locz00_11121); } 
BgL_tmpz00_21221 = 
(
REAL_TO_DOUBLE(BgL_a1z00_13498)<=
REAL_TO_DOUBLE(BgL_a2z00_13499)); } } 
return 
BBOOL(BgL_tmpz00_21221);} } } 

}



/* &<@anonymous:2719> */
obj_t BGl_z62zc3z04anonymousza32719ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11123, obj_t BgL_sz00_11127)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11124;obj_t BgL_a2z00_11125;obj_t BgL_locz00_11126;
BgL_a1z00_11124 = 
PROCEDURE_REF(BgL_envz00_11123, 
(int)(((long)0))); 
BgL_a2z00_11125 = 
PROCEDURE_REF(BgL_envz00_11123, 
(int)(((long)1))); 
BgL_locz00_11126 = 
PROCEDURE_REF(BgL_envz00_11123, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
bool_t BgL_tmpz00_21248;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13500;
BgL_bpz00_13500 = 
VECTOR_REF(
((obj_t)BgL_sz00_11127),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13501;obj_t BgL_a2z00_13502;
BgL_a1z00_13501 = 
PROCEDURE_ENTRY(BgL_a1z00_11124)(BgL_a1z00_11124, BgL_sz00_11127, BEOA); 
BgL_a2z00_13502 = 
PROCEDURE_ENTRY(BgL_a2z00_11125)(BgL_a2z00_11125, BgL_sz00_11127, BEOA); 
if(
REALP(BgL_a1z00_13501))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5284z00zz__evaluate_compz00, BGl_symbol5270z00zz__evaluate_compz00, BgL_a1z00_13501, BgL_locz00_11126); } 
if(
REALP(BgL_a2z00_13502))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5284z00zz__evaluate_compz00, BGl_symbol5270z00zz__evaluate_compz00, BgL_a2z00_13502, BgL_locz00_11126); } 
BgL_tmpz00_21248 = 
(
REAL_TO_DOUBLE(BgL_a1z00_13501)>=
REAL_TO_DOUBLE(BgL_a2z00_13502)); } } 
return 
BBOOL(BgL_tmpz00_21248);} } } 

}



/* &<@anonymous:2723> */
obj_t BGl_z62zc3z04anonymousza32723ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11128, obj_t BgL_sz00_11132)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11129;obj_t BgL_a2z00_11130;obj_t BgL_locz00_11131;
BgL_a1z00_11129 = 
PROCEDURE_REF(BgL_envz00_11128, 
(int)(((long)0))); 
BgL_a2z00_11130 = 
PROCEDURE_REF(BgL_envz00_11128, 
(int)(((long)1))); 
BgL_locz00_11131 = 
PROCEDURE_REF(BgL_envz00_11128, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
bool_t BgL_tmpz00_21275;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13503;
BgL_bpz00_13503 = 
VECTOR_REF(
((obj_t)BgL_sz00_11132),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13504;obj_t BgL_a2z00_13505;
BgL_a1z00_13504 = 
PROCEDURE_ENTRY(BgL_a1z00_11129)(BgL_a1z00_11129, BgL_sz00_11132, BEOA); 
BgL_a2z00_13505 = 
PROCEDURE_ENTRY(BgL_a2z00_11130)(BgL_a2z00_11130, BgL_sz00_11132, BEOA); 
if(
REALP(BgL_a1z00_13504))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5286z00zz__evaluate_compz00, BGl_symbol5270z00zz__evaluate_compz00, BgL_a1z00_13504, BgL_locz00_11131); } 
if(
REALP(BgL_a2z00_13505))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5286z00zz__evaluate_compz00, BGl_symbol5270z00zz__evaluate_compz00, BgL_a2z00_13505, BgL_locz00_11131); } 
BgL_tmpz00_21275 = 
(
REAL_TO_DOUBLE(BgL_a1z00_13504)==
REAL_TO_DOUBLE(BgL_a2z00_13505)); } } 
return 
BBOOL(BgL_tmpz00_21275);} } } 

}



/* &<@anonymous:2727> */
obj_t BGl_z62zc3z04anonymousza32727ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11133, obj_t BgL_sz00_11136)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11134;obj_t BgL_a2z00_11135;
BgL_a1z00_11134 = 
PROCEDURE_REF(BgL_envz00_11133, 
(int)(((long)0))); 
BgL_a2z00_11135 = 
PROCEDURE_REF(BgL_envz00_11133, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1021 */
bool_t BgL_tmpz00_21300;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13506;
BgL_bpz00_13506 = 
VECTOR_REF(
((obj_t)BgL_sz00_11136),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13507;obj_t BgL_a2z00_13508;
BgL_a1z00_13507 = 
PROCEDURE_ENTRY(BgL_a1z00_11134)(BgL_a1z00_11134, BgL_sz00_11136, BEOA); 
BgL_a2z00_13508 = 
PROCEDURE_ENTRY(BgL_a2z00_11135)(BgL_a2z00_11135, BgL_sz00_11136, BEOA); 
BgL_tmpz00_21300 = 
(BgL_a1z00_13507==BgL_a2z00_13508); } } 
return 
BBOOL(BgL_tmpz00_21300);} } } 

}



/* &<@anonymous:2729> */
obj_t BGl_z62zc3z04anonymousza32729ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11137, obj_t BgL_sz00_11140)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11138;obj_t BgL_a2z00_11139;
BgL_a1z00_11138 = 
PROCEDURE_REF(BgL_envz00_11137, 
(int)(((long)0))); 
BgL_a2z00_11139 = 
PROCEDURE_REF(BgL_envz00_11137, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13509;
BgL_bpz00_13509 = 
VECTOR_REF(
((obj_t)BgL_sz00_11140),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13510;obj_t BgL_a2z00_13511;
BgL_a1z00_13510 = 
PROCEDURE_ENTRY(BgL_a1z00_11138)(BgL_a1z00_11138, BgL_sz00_11140, BEOA); 
BgL_a2z00_13511 = 
PROCEDURE_ENTRY(BgL_a2z00_11139)(BgL_a2z00_11139, BgL_sz00_11140, BEOA); 
return 
MAKE_YOUNG_PAIR(BgL_a1z00_13510, BgL_a2z00_13511);} } } } 

}



/* &<@anonymous:2732> */
obj_t BGl_z62zc3z04anonymousza32732ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11141, obj_t BgL_sz00_11144)
{
{ /* Eval/evaluate_comp.scm 1018 */
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_a1z00_11142;obj_t BgL_locz00_11143;
BgL_a1z00_11142 = 
PROCEDURE_REF(BgL_envz00_11141, 
(int)(((long)0))); 
BgL_locz00_11143 = 
PROCEDURE_REF(BgL_envz00_11141, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_bpz00_13512;
BgL_bpz00_13512 = 
VECTOR_REF(
((obj_t)BgL_sz00_11144),((long)0)); 
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_a1z00_13513;
BgL_a1z00_13513 = 
PROCEDURE_ENTRY(BgL_a1z00_11142)(BgL_a1z00_11142, BgL_sz00_11144, BEOA); 
if(
PAIRP(BgL_a1z00_13513))
{ /* Eval/evaluate_comp.scm 1018 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1018 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5288z00zz__evaluate_compz00, BGl_symbol5290z00zz__evaluate_compz00, BgL_a1z00_13513, BgL_locz00_11143); } 
return 
CAR(
((obj_t)BgL_a1z00_13513));} } } } 

}



/* &<@anonymous:2735> */
obj_t BGl_z62zc3z04anonymousza32735ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11145, obj_t BgL_sz00_11148)
{
{ /* Eval/evaluate_comp.scm 1018 */
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_a1z00_11146;obj_t BgL_locz00_11147;
BgL_a1z00_11146 = 
PROCEDURE_REF(BgL_envz00_11145, 
(int)(((long)0))); 
BgL_locz00_11147 = 
PROCEDURE_REF(BgL_envz00_11145, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_bpz00_13514;
BgL_bpz00_13514 = 
VECTOR_REF(
((obj_t)BgL_sz00_11148),((long)0)); 
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_a1z00_13515;
BgL_a1z00_13515 = 
PROCEDURE_ENTRY(BgL_a1z00_11146)(BgL_a1z00_11146, BgL_sz00_11148, BEOA); 
if(
PAIRP(BgL_a1z00_13515))
{ /* Eval/evaluate_comp.scm 1018 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1018 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5292z00zz__evaluate_compz00, BGl_symbol5290z00zz__evaluate_compz00, BgL_a1z00_13515, BgL_locz00_11147); } 
return 
CDR(
((obj_t)BgL_a1z00_13515));} } } } 

}



/* &<@anonymous:2738> */
obj_t BGl_z62zc3z04anonymousza32738ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11149, obj_t BgL_sz00_11152)
{
{ /* Eval/evaluate_comp.scm 1018 */
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_a1z00_11150;obj_t BgL_locz00_11151;
BgL_a1z00_11150 = 
PROCEDURE_REF(BgL_envz00_11149, 
(int)(((long)0))); 
BgL_locz00_11151 = 
PROCEDURE_REF(BgL_envz00_11149, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_bpz00_13516;
BgL_bpz00_13516 = 
VECTOR_REF(
((obj_t)BgL_sz00_11152),((long)0)); 
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_a1z00_13517;
BgL_a1z00_13517 = 
PROCEDURE_ENTRY(BgL_a1z00_11150)(BgL_a1z00_11150, BgL_sz00_11152, BEOA); 
if(
BGl_cadrzf3zf3zz__evaluate_compz00(BgL_a1z00_13517))
{ /* Eval/evaluate_comp.scm 1018 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_arg2740z00_13518;
BgL_arg2740z00_13518 = 
BGl_cadrerrvz00zz__evaluate_compz00(BgL_a1z00_13517); 
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5294z00zz__evaluate_compz00, BGl_symbol5290z00zz__evaluate_compz00, BgL_arg2740z00_13518, BgL_locz00_11151); } 
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_pairz00_13519;
BgL_pairz00_13519 = 
CDR(
((obj_t)BgL_a1z00_13517)); 
return 
CAR(BgL_pairz00_13519);} } } } } 

}



/* cadr? */
bool_t BGl_cadrzf3zf3zz__evaluate_compz00(obj_t BgL_lz00_197)
{
{ /* Eval/evaluate_comp.scm 1026 */
if(
PAIRP(BgL_lz00_197))
{ /* Eval/evaluate_comp.scm 1027 */
obj_t BgL_tmpz00_21377;
BgL_tmpz00_21377 = 
CDR(BgL_lz00_197); 
return 
PAIRP(BgL_tmpz00_21377);}  else 
{ /* Eval/evaluate_comp.scm 1027 */
return ((bool_t)0);} } 

}



/* cadrerrv */
obj_t BGl_cadrerrvz00zz__evaluate_compz00(obj_t BgL_vz00_198)
{
{ /* Eval/evaluate_comp.scm 1029 */
if(
PAIRP(BgL_vz00_198))
{ /* Eval/evaluate_comp.scm 1030 */
return 
CDR(BgL_vz00_198);}  else 
{ /* Eval/evaluate_comp.scm 1030 */
return BgL_vz00_198;} } 

}



/* correct */
long BGl_correctz00zz__evaluate_compz00(obj_t BgL_nz00_201, long BgL_donez00_202)
{
{ /* Eval/evaluate_comp.scm 1058 */
if(
(
(long)CINT(BgL_nz00_201)<((long)0)))
{ /* Eval/evaluate_comp.scm 1059 */
return 
(
(long)CINT(BgL_nz00_201)+BgL_donez00_202);}  else 
{ /* Eval/evaluate_comp.scm 1059 */
return 
(
(long)CINT(BgL_nz00_201)-BgL_donez00_202);} } 

}



/* bind-frame */
obj_t BGl_bindzd2framezd2zz__evaluate_compz00(obj_t BgL_sz00_203, obj_t BgL_wherez00_204, long BgL_spz00_205, long BgL_arityz00_206, obj_t BgL_valsz00_207, obj_t BgL_locz00_208)
{
{ /* Eval/evaluate_comp.scm 1063 */
if(
(BgL_arityz00_206<((long)0)))
{ /* Eval/evaluate_comp.scm 1065 */
long BgL_g1234z00_3516;
BgL_g1234z00_3516 = 
(((long)-1)-BgL_arityz00_206); 
{ 
long BgL_rz00_3518;long BgL_spz00_3519;obj_t BgL_lz00_3520;
BgL_rz00_3518 = BgL_g1234z00_3516; 
BgL_spz00_3519 = BgL_spz00_205; 
BgL_lz00_3520 = BgL_valsz00_207; 
BgL_zc3z04anonymousza32745ze3z87_3521:
if(
(BgL_rz00_3518==((long)0)))
{ /* Eval/evaluate_comp.scm 1067 */
return 
VECTOR_SET(
((obj_t)BgL_sz00_203),BgL_spz00_3519,BgL_lz00_3520);}  else 
{ /* Eval/evaluate_comp.scm 1067 */
if(
PAIRP(BgL_lz00_3520))
{ /* Eval/evaluate_comp.scm 1069 */
{ /* Eval/evaluate_comp.scm 1072 */
obj_t BgL_arg2748z00_3524;
BgL_arg2748z00_3524 = 
CAR(BgL_lz00_3520); 
VECTOR_SET(
((obj_t)BgL_sz00_203),BgL_spz00_3519,BgL_arg2748z00_3524); } 
{ 
obj_t BgL_lz00_21406;long BgL_spz00_21404;long BgL_rz00_21402;
BgL_rz00_21402 = 
(BgL_rz00_3518-((long)1)); 
BgL_spz00_21404 = 
(BgL_spz00_3519+((long)1)); 
BgL_lz00_21406 = 
CDR(BgL_lz00_3520); 
BgL_lz00_3520 = BgL_lz00_21406; 
BgL_spz00_3519 = BgL_spz00_21404; 
BgL_rz00_3518 = BgL_rz00_21402; 
goto BgL_zc3z04anonymousza32745ze3z87_3521;} }  else 
{ /* Eval/evaluate_comp.scm 1070 */
long BgL_arg2752z00_3528;
BgL_arg2752z00_3528 = 
bgl_list_length(BgL_valsz00_207); 
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_208, BgL_wherez00_204, 
(int)(BgL_arityz00_206), 
(int)(BgL_arg2752z00_3528));} } } }  else 
{ 
long BgL_rz00_3531;long BgL_spz00_3532;obj_t BgL_lz00_3533;
BgL_rz00_3531 = BgL_arityz00_206; 
BgL_spz00_3532 = BgL_spz00_205; 
BgL_lz00_3533 = BgL_valsz00_207; 
BgL_zc3z04anonymousza32753ze3z87_3534:
if(
(BgL_rz00_3531==((long)0)))
{ /* Eval/evaluate_comp.scm 1076 */
if(
NULLP(BgL_lz00_3533))
{ /* Eval/evaluate_comp.scm 1077 */
return BFALSE;}  else 
{ /* Eval/evaluate_comp.scm 1078 */
long BgL_arg2756z00_3537;
BgL_arg2756z00_3537 = 
bgl_list_length(BgL_valsz00_207); 
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_208, BgL_wherez00_204, 
(int)(BgL_arityz00_206), 
(int)(BgL_arg2756z00_3537));} }  else 
{ /* Eval/evaluate_comp.scm 1076 */
if(
PAIRP(BgL_lz00_3533))
{ /* Eval/evaluate_comp.scm 1079 */
{ /* Eval/evaluate_comp.scm 1082 */
obj_t BgL_arg2758z00_3539;
BgL_arg2758z00_3539 = 
CAR(BgL_lz00_3533); 
VECTOR_SET(
((obj_t)BgL_sz00_203),BgL_spz00_3532,BgL_arg2758z00_3539); } 
{ 
obj_t BgL_lz00_21429;long BgL_spz00_21427;long BgL_rz00_21425;
BgL_rz00_21425 = 
(BgL_rz00_3531-((long)1)); 
BgL_spz00_21427 = 
(BgL_spz00_3532+((long)1)); 
BgL_lz00_21429 = 
CDR(BgL_lz00_3533); 
BgL_lz00_3533 = BgL_lz00_21429; 
BgL_spz00_3532 = BgL_spz00_21427; 
BgL_rz00_3531 = BgL_rz00_21425; 
goto BgL_zc3z04anonymousza32753ze3z87_3534;} }  else 
{ /* Eval/evaluate_comp.scm 1080 */
long BgL_arg2762z00_3543;
BgL_arg2762z00_3543 = 
bgl_list_length(BgL_valsz00_207); 
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_208, BgL_wherez00_204, 
(int)(BgL_arityz00_206), 
(int)(BgL_arg2762z00_3543));} } } } 

}



/* make-boxes */
bool_t BGl_makezd2boxeszd2zz__evaluate_compz00(obj_t BgL_sz00_211, obj_t BgL_ibza2za2_212, obj_t BgL_bpz00_213)
{
{ /* Eval/evaluate_comp.scm 1177 */
{ 
long BgL_iz00_3547;
BgL_iz00_3547 = ((long)0); 
BgL_zc3z04anonymousza32763ze3z87_3548:
{ /* Eval/evaluate_comp.scm 1180 */
long BgL_spz00_3549;
{ /* Eval/evaluate_comp.scm 1180 */
obj_t BgL_arg2767z00_3554;
BgL_arg2767z00_3554 = 
VECTOR_REF(
((obj_t)BgL_ibza2za2_212),BgL_iz00_3547); 
BgL_spz00_3549 = 
(
(long)CINT(BgL_bpz00_213)+
(long)CINT(BgL_arg2767z00_3554)); } 
{ /* Eval/evaluate_comp.scm 1181 */
obj_t BgL_arg2764z00_3550;
{ /* Eval/evaluate_comp.scm 1181 */
obj_t BgL_arg2765z00_3551;
BgL_arg2765z00_3551 = 
VECTOR_REF(
((obj_t)BgL_sz00_211),BgL_spz00_3549); 
{ /* Eval/evaluate_comp.scm 202 */
obj_t BgL_newz00_8507;
BgL_newz00_8507 = 
create_struct(BGl_symbol5218z00zz__evaluate_compz00, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 202 */
int BgL_tmpz00_21444;
BgL_tmpz00_21444 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_8507, BgL_tmpz00_21444, BgL_arg2765z00_3551); } 
BgL_arg2764z00_3550 = BgL_newz00_8507; } } 
VECTOR_SET(
((obj_t)BgL_sz00_211),BgL_spz00_3549,BgL_arg2764z00_3550); } 
{ /* Eval/evaluate_comp.scm 1182 */
long BgL_niz00_3552;
BgL_niz00_3552 = 
(BgL_iz00_3547+((long)1)); 
if(
(BgL_niz00_3552<
VECTOR_LENGTH(
((obj_t)BgL_ibza2za2_212))))
{ 
long BgL_iz00_21454;
BgL_iz00_21454 = BgL_niz00_3552; 
BgL_iz00_3547 = BgL_iz00_21454; 
goto BgL_zc3z04anonymousza32763ze3z87_3548;}  else 
{ /* Eval/evaluate_comp.scm 1183 */
return ((bool_t)0);} } } } } 

}



/* free-collect */
obj_t BGl_freezd2collectzd2zz__evaluate_compz00(obj_t BgL_sz00_214, obj_t BgL_bpz00_215, obj_t BgL_iza2za2_216)
{
{ /* Eval/evaluate_comp.scm 1185 */
{ /* Eval/evaluate_comp.scm 1186 */
obj_t BgL_rz00_3557;
BgL_rz00_3557 = 
make_vector(
VECTOR_LENGTH(
((obj_t)BgL_iza2za2_216)), BUNSPEC); 
{ /* Eval/evaluate_comp.scm 1186 */

{ 
long BgL_iz00_3559;
BgL_iz00_3559 = ((long)0); 
BgL_zc3z04anonymousza32768ze3z87_3560:
if(
(BgL_iz00_3559>=
VECTOR_LENGTH(
((obj_t)BgL_iza2za2_216))))
{ /* Eval/evaluate_comp.scm 1188 */
return BgL_rz00_3557;}  else 
{ /* Eval/evaluate_comp.scm 1188 */
{ /* Eval/evaluate_comp.scm 1191 */
obj_t BgL_arg2770z00_3562;
{ /* Eval/evaluate_comp.scm 1191 */
long BgL_arg2771z00_3563;
{ /* Eval/evaluate_comp.scm 1191 */
obj_t BgL_arg2772z00_3564;
BgL_arg2772z00_3564 = 
VECTOR_REF(
((obj_t)BgL_iza2za2_216),BgL_iz00_3559); 
BgL_arg2771z00_3563 = 
(
(long)CINT(BgL_bpz00_215)+
(long)CINT(BgL_arg2772z00_3564)); } 
BgL_arg2770z00_3562 = 
VECTOR_REF(
((obj_t)BgL_sz00_214),BgL_arg2771z00_3563); } 
VECTOR_SET(BgL_rz00_3557,BgL_iz00_3559,BgL_arg2770z00_3562); } 
{ 
long BgL_iz00_21470;
BgL_iz00_21470 = 
(BgL_iz00_3559+((long)1)); 
BgL_iz00_3559 = BgL_iz00_21470; 
goto BgL_zc3z04anonymousza32768ze3z87_3560;} } } } } } 

}



/* free-restore */
bool_t BGl_freezd2restorezd2zz__evaluate_compz00(obj_t BgL_sz00_217, obj_t BgL_valza2za2_218, long BgL_spz00_219)
{
{ /* Eval/evaluate_comp.scm 1194 */
{ /* Eval/evaluate_comp.scm 1195 */
long BgL_stopz00_3568;
BgL_stopz00_3568 = 
(BgL_spz00_219+
VECTOR_LENGTH(
((obj_t)BgL_valza2za2_218))); 
{ 
long BgL_iz00_3570;long BgL_spz00_3571;
BgL_iz00_3570 = ((long)0); 
BgL_spz00_3571 = BgL_spz00_219; 
BgL_zc3z04anonymousza32775ze3z87_3572:
if(
(BgL_spz00_3571<BgL_stopz00_3568))
{ /* Eval/evaluate_comp.scm 1197 */
{ /* Eval/evaluate_comp.scm 1198 */
obj_t BgL_arg2777z00_3574;
BgL_arg2777z00_3574 = 
VECTOR_REF(
((obj_t)BgL_valza2za2_218),BgL_iz00_3570); 
VECTOR_SET(
((obj_t)BgL_sz00_217),BgL_spz00_3571,BgL_arg2777z00_3574); } 
{ 
long BgL_spz00_21483;long BgL_iz00_21481;
BgL_iz00_21481 = 
(BgL_iz00_3570+((long)1)); 
BgL_spz00_21483 = 
(BgL_spz00_3571+((long)1)); 
BgL_spz00_3571 = BgL_spz00_21483; 
BgL_iz00_3570 = BgL_iz00_21481; 
goto BgL_zc3z04anonymousza32775ze3z87_3572;} }  else 
{ /* Eval/evaluate_comp.scm 1197 */
return ((bool_t)0);} } } } 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__evaluate_compz00()
{
{ /* Eval/evaluate_comp.scm 15 */
return BUNSPEC;} 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__evaluate_compz00()
{
{ /* Eval/evaluate_comp.scm 15 */
return 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_proc5296z00zz__evaluate_compz00, BGl_ev_exprz00zz__evaluate_typesz00, BGl_string5297z00zz__evaluate_compz00);} 

}



/* &comp1386 */
obj_t BGl_z62comp1386z62zz__evaluate_compz00(obj_t BgL_envz00_11238, obj_t BgL_ez00_11239, obj_t BgL_stkz00_11240)
{
{ /* Eval/evaluate_comp.scm 276 */
return 
BGl_errorz00zz__errorz00(BGl_string5208z00zz__evaluate_compz00, BGl_string5298z00zz__evaluate_compz00, 
((obj_t)
((BgL_ev_exprz00_bglt)BgL_ez00_11239)));} 

}



/* comp */
obj_t BGl_compz00zz__evaluate_compz00(BgL_ev_exprz00_bglt BgL_ez00_35, obj_t BgL_stkz00_36)
{
{ /* Eval/evaluate_comp.scm 276 */
{ /* Eval/evaluate_comp.scm 276 */
obj_t BgL_method1387z00_3584;
{ /* Eval/evaluate_comp.scm 276 */
obj_t BgL_res4653z00_8583;
{ /* Eval/evaluate_comp.scm 276 */
long BgL_objzd2classzd2numz00_8548;
{ /* Eval/evaluate_comp.scm 276 */
long BgL_res4643z00_8551;
BgL_res4643z00_8551 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_ez00_35)); 
BgL_objzd2classzd2numz00_8548 = BgL_res4643z00_8551; } 
{ /* Eval/evaluate_comp.scm 276 */
obj_t BgL_arg3974z00_8549;
BgL_arg3974z00_8549 = 
PROCEDURE_REF(BGl_compzd2envzd2zz__evaluate_compz00, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 276 */
int BgL_offsetz00_8553;
BgL_offsetz00_8553 = 
(int)(BgL_objzd2classzd2numz00_8548); 
{ /* Eval/evaluate_comp.scm 276 */
long BgL_offsetz00_8554;
BgL_offsetz00_8554 = 
(
(long)(BgL_offsetz00_8553)-OBJECT_TYPE); 
{ /* Eval/evaluate_comp.scm 276 */
long BgL_modz00_8555;
BgL_modz00_8555 = 
(BgL_offsetz00_8554 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Eval/evaluate_comp.scm 276 */
long BgL_restz00_8557;
BgL_restz00_8557 = 
(BgL_offsetz00_8554 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Eval/evaluate_comp.scm 276 */

{ /* Eval/evaluate_comp.scm 276 */
obj_t BgL_bucketz00_8559;
BgL_bucketz00_8559 = 
VECTOR_REF(
((obj_t)BgL_arg3974z00_8549),BgL_modz00_8555); 
BgL_res4653z00_8583 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_8559),BgL_restz00_8557); } } } } } } } } 
BgL_method1387z00_3584 = BgL_res4653z00_8583; } 
return 
PROCEDURE_ENTRY(BgL_method1387z00_3584)(BgL_method1387z00_3584, 
((obj_t)BgL_ez00_35), BgL_stkz00_36, BEOA);} } 

}



/* &comp */
obj_t BGl_z62compz62zz__evaluate_compz00(obj_t BgL_envz00_11241, obj_t BgL_ez00_11242, obj_t BgL_stkz00_11243)
{
{ /* Eval/evaluate_comp.scm 276 */
{ /* Eval/evaluate_comp.scm 276 */
BgL_ev_exprz00_bglt BgL_auxz00_21520;
if(
BGl_isazf3zf3zz__objectz00(BgL_ez00_11242, BGl_ev_exprz00zz__evaluate_typesz00))
{ /* Eval/evaluate_comp.scm 276 */
BgL_auxz00_21520 = 
((BgL_ev_exprz00_bglt)BgL_ez00_11242)
; }  else 
{ 
obj_t BgL_auxz00_21524;
BgL_auxz00_21524 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string5213z00zz__evaluate_compz00, 
BINT(((long)7022)), BGl_string5299z00zz__evaluate_compz00, BGl_string5215z00zz__evaluate_compz00, BgL_ez00_11242); 
FAILURE(BgL_auxz00_21524,BFALSE,BFALSE);} 
return 
BGl_compz00zz__evaluate_compz00(BgL_auxz00_21520, BgL_stkz00_11243);} } 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__evaluate_compz00()
{
{ /* Eval/evaluate_comp.scm 15 */
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_trapz00zz__evaluate_typesz00, BGl_proc5300z00zz__evaluate_compz00, BGl_string5301z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_varz00zz__evaluate_typesz00, BGl_proc5302z00zz__evaluate_compz00, BGl_string5301z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_setlocalz00zz__evaluate_typesz00, BGl_proc5303z00zz__evaluate_compz00, BGl_string5301z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_globalz00zz__evaluate_typesz00, BGl_proc5304z00zz__evaluate_compz00, BGl_string5301z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_setglobalz00zz__evaluate_typesz00, BGl_proc5305z00zz__evaluate_compz00, BGl_string5301z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_defglobalz00zz__evaluate_typesz00, BGl_proc5306z00zz__evaluate_compz00, BGl_string5301z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_littz00zz__evaluate_typesz00, BGl_proc5307z00zz__evaluate_compz00, BGl_string5301z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_ifz00zz__evaluate_typesz00, BGl_proc5308z00zz__evaluate_compz00, BGl_string5301z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_orz00zz__evaluate_typesz00, BGl_proc5309z00zz__evaluate_compz00, BGl_string5301z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_andz00zz__evaluate_typesz00, BGl_proc5310z00zz__evaluate_compz00, BGl_string5301z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_prog2z00zz__evaluate_typesz00, BGl_proc5311z00zz__evaluate_compz00, BGl_string5301z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_letz00zz__evaluate_typesz00, BGl_proc5312z00zz__evaluate_compz00, BGl_string5301z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_letza2za2zz__evaluate_typesz00, BGl_proc5313z00zz__evaluate_compz00, BGl_string5301z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_letrecz00zz__evaluate_typesz00, BGl_proc5314z00zz__evaluate_compz00, BGl_string5301z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_bindzd2exitzd2zz__evaluate_typesz00, BGl_proc5315z00zz__evaluate_compz00, BGl_string5301z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00, BGl_proc5316z00zz__evaluate_compz00, BGl_string5301z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_withzd2handlerzd2zz__evaluate_typesz00, BGl_proc5317z00zz__evaluate_compz00, BGl_string5301z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_synchroniza7eza7zz__evaluate_typesz00, BGl_proc5318z00zz__evaluate_compz00, BGl_string5301z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_labelsz00zz__evaluate_typesz00, BGl_proc5319z00zz__evaluate_compz00, BGl_string5301z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_gotoz00zz__evaluate_typesz00, BGl_proc5320z00zz__evaluate_compz00, BGl_string5301z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_appz00zz__evaluate_typesz00, BGl_proc5321z00zz__evaluate_compz00, BGl_string5301z00zz__evaluate_compz00); 
return 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_absz00zz__evaluate_typesz00, BGl_proc5322z00zz__evaluate_compz00, BGl_string5301z00zz__evaluate_compz00);} 

}



/* &comp-ev_abs1432 */
obj_t BGl_z62compzd2ev_abs1432zb0zz__evaluate_compz00(obj_t BgL_envz00_11438, obj_t BgL_ez00_11439, obj_t BgL_stkz00_11440)
{
{ /* Eval/evaluate_comp.scm 1165 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ifreesz00_13522;obj_t BgL_iboxesz00_13523;long BgL_siza7eza7_13524;long BgL_siza7ezd2framez75_13525;obj_t BgL_nstkz00_13526;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3683z00_13527;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_l1363z00_13528;
BgL_l1363z00_13528 = 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_ez00_11439)))->BgL_freez00); 
if(
NULLP(BgL_l1363z00_13528))
{ /* Eval/evaluate_comp.scm 1167 */
BgL_arg3683z00_13527 = BNIL; }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_head1365z00_13529;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_res4743z00_13530;
BgL_res4743z00_13530 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1365z00_13529 = BgL_res4743z00_13530; } 
{ 
obj_t BgL_l1363z00_13532;obj_t BgL_tail1366z00_13533;
BgL_l1363z00_13532 = BgL_l1363z00_13528; 
BgL_tail1366z00_13533 = BgL_head1365z00_13529; 
BgL_zc3z04anonymousza33685ze3z87_13531:
if(
NULLP(BgL_l1363z00_13532))
{ /* Eval/evaluate_comp.scm 1167 */
BgL_arg3683z00_13527 = 
CDR(BgL_head1365z00_13529); }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_newtail1367z00_13534;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3688z00_13535;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_vz00_13536;
BgL_vz00_13536 = 
CAR(
((obj_t)BgL_l1363z00_13532)); 
BgL_arg3688z00_13535 = 
BGl__indexz00zz__evaluate_compz00(BgL_vz00_13536, BgL_stkz00_11440); } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_res4745z00_13537;
BgL_res4745z00_13537 = 
MAKE_YOUNG_PAIR(BgL_arg3688z00_13535, BNIL); 
BgL_newtail1367z00_13534 = BgL_res4745z00_13537; } } 
SET_CDR(BgL_tail1366z00_13533, BgL_newtail1367z00_13534); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3687z00_13538;
BgL_arg3687z00_13538 = 
CDR(
((obj_t)BgL_l1363z00_13532)); 
{ 
obj_t BgL_tail1366z00_21567;obj_t BgL_l1363z00_21566;
BgL_l1363z00_21566 = BgL_arg3687z00_13538; 
BgL_tail1366z00_21567 = BgL_newtail1367z00_13534; 
BgL_tail1366z00_13533 = BgL_tail1366z00_21567; 
BgL_l1363z00_13532 = BgL_l1363z00_21566; 
goto BgL_zc3z04anonymousza33685ze3z87_13531;} } } } } } 
BgL_ifreesz00_13522 = 
BGl_listzd2ze3vectorz31zz__r4_vectors_6_8z00(BgL_arg3683z00_13527); } 
{ /* Eval/evaluate_comp.scm 1168 */
obj_t BgL_arg3689z00_13539;
{ /* Eval/evaluate_comp.scm 1168 */
obj_t BgL_l1368z00_13540;
BgL_l1368z00_13540 = 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_ez00_11439)))->BgL_boxesz00); 
if(
NULLP(BgL_l1368z00_13540))
{ /* Eval/evaluate_comp.scm 1168 */
BgL_arg3689z00_13539 = BNIL; }  else 
{ /* Eval/evaluate_comp.scm 1168 */
obj_t BgL_head1370z00_13541;
{ /* Eval/evaluate_comp.scm 1168 */
obj_t BgL_res4747z00_13542;
BgL_res4747z00_13542 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1370z00_13541 = BgL_res4747z00_13542; } 
{ 
obj_t BgL_l1368z00_13544;obj_t BgL_tail1371z00_13545;
BgL_l1368z00_13544 = BgL_l1368z00_13540; 
BgL_tail1371z00_13545 = BgL_head1370z00_13541; 
BgL_zc3z04anonymousza33691ze3z87_13543:
if(
NULLP(BgL_l1368z00_13544))
{ /* Eval/evaluate_comp.scm 1168 */
BgL_arg3689z00_13539 = 
CDR(BgL_head1370z00_13541); }  else 
{ /* Eval/evaluate_comp.scm 1168 */
obj_t BgL_newtail1372z00_13546;
{ /* Eval/evaluate_comp.scm 1168 */
obj_t BgL_arg3694z00_13547;
{ /* Eval/evaluate_comp.scm 1168 */
obj_t BgL_vz00_13548;
BgL_vz00_13548 = 
CAR(
((obj_t)BgL_l1368z00_13544)); 
BgL_arg3694z00_13547 = 
BGl__indexz00zz__evaluate_compz00(BgL_vz00_13548, 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_ez00_11439)))->BgL_varsz00)); } 
{ /* Eval/evaluate_comp.scm 1168 */
obj_t BgL_res4749z00_13549;
BgL_res4749z00_13549 = 
MAKE_YOUNG_PAIR(BgL_arg3694z00_13547, BNIL); 
BgL_newtail1372z00_13546 = BgL_res4749z00_13549; } } 
SET_CDR(BgL_tail1371z00_13545, BgL_newtail1372z00_13546); 
{ /* Eval/evaluate_comp.scm 1168 */
obj_t BgL_arg3693z00_13550;
BgL_arg3693z00_13550 = 
CDR(
((obj_t)BgL_l1368z00_13544)); 
{ 
obj_t BgL_tail1371z00_21587;obj_t BgL_l1368z00_21586;
BgL_l1368z00_21586 = BgL_arg3693z00_13550; 
BgL_tail1371z00_21587 = BgL_newtail1372z00_13546; 
BgL_tail1371z00_13545 = BgL_tail1371z00_21587; 
BgL_l1368z00_13544 = BgL_l1368z00_21586; 
goto BgL_zc3z04anonymousza33691ze3z87_13543;} } } } } } 
BgL_iboxesz00_13523 = 
BGl_listzd2ze3vectorz31zz__r4_vectors_6_8z00(BgL_arg3689z00_13539); } 
BgL_siza7eza7_13524 = 
bgl_list_length(
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_ez00_11439)))->BgL_varsz00)); 
BgL_siza7ezd2framez75_13525 = 
(
(long)(
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_ez00_11439)))->BgL_siza7eza7))+
bgl_list_length(
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_ez00_11439)))->BgL_freez00))); 
BgL_nstkz00_13526 = 
BGl_appendzd221010zd2zz__evaluate_compz00(
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_ez00_11439)))->BgL_varsz00), 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_ez00_11439)))->BgL_freez00)); 
{ /* Eval/evaluate_comp.scm 1172 */
obj_t BgL_bodyz00_13551;
BgL_bodyz00_13551 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_ez00_11439)))->BgL_bodyz00), BgL_nstkz00_13526); 
{ 

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_aux1246z00_13557;
BgL_aux1246z00_13557 = 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_ez00_11439)))->BgL_arityz00); 
if(
INTEGERP(BgL_aux1246z00_13557))
{ /* Eval/evaluate_comp.scm 1174 */
switch( 
(long)CINT(BgL_aux1246z00_13557)) { case ((long)0) : 

if(
(
VECTOR_LENGTH(BgL_ifreesz00_13522)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13523)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33145ze3z87_13558;
BgL_zc3z04anonymousza33145ze3z87_13558 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33145ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33145ze3z87_13558, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11439))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33145ze3z87_13558, 
(int)(((long)1)), BgL_bodyz00_13551); 
PROCEDURE_SET(BgL_zc3z04anonymousza33145ze3z87_13558, 
(int)(((long)2)), 
BINT(BgL_siza7ezd2framez75_13525)); 
return BgL_zc3z04anonymousza33145ze3z87_13558;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33151ze3z87_13559;
BgL_zc3z04anonymousza33151ze3z87_13559 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33151ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33151ze3z87_13559, 
(int)(((long)0)), BgL_iboxesz00_13523); 
PROCEDURE_SET(BgL_zc3z04anonymousza33151ze3z87_13559, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11439))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33151ze3z87_13559, 
(int)(((long)2)), BgL_bodyz00_13551); 
PROCEDURE_SET(BgL_zc3z04anonymousza33151ze3z87_13559, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_13525)); 
return BgL_zc3z04anonymousza33151ze3z87_13559;} }  else 
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13523)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33160ze3z87_13560;
BgL_zc3z04anonymousza33160ze3z87_13560 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33160ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33160ze3z87_13560, 
(int)(((long)0)), BgL_ifreesz00_13522); 
PROCEDURE_SET(BgL_zc3z04anonymousza33160ze3z87_13560, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_13524)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33160ze3z87_13560, 
(int)(((long)2)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11439))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33160ze3z87_13560, 
(int)(((long)3)), BgL_bodyz00_13551); 
PROCEDURE_SET(BgL_zc3z04anonymousza33160ze3z87_13560, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_13525)); 
return BgL_zc3z04anonymousza33160ze3z87_13560;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33167ze3z87_13561;
BgL_zc3z04anonymousza33167ze3z87_13561 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33167ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33167ze3z87_13561, 
(int)(((long)0)), BgL_ifreesz00_13522); 
PROCEDURE_SET(BgL_zc3z04anonymousza33167ze3z87_13561, 
(int)(((long)1)), BgL_iboxesz00_13523); 
PROCEDURE_SET(BgL_zc3z04anonymousza33167ze3z87_13561, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_13524)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33167ze3z87_13561, 
(int)(((long)3)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11439))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33167ze3z87_13561, 
(int)(((long)4)), BgL_bodyz00_13551); 
PROCEDURE_SET(BgL_zc3z04anonymousza33167ze3z87_13561, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_13525)); 
return BgL_zc3z04anonymousza33167ze3z87_13561;} } break;case ((long)-1) : 

if(
(
VECTOR_LENGTH(BgL_ifreesz00_13522)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13523)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33180ze3z87_13562;
BgL_zc3z04anonymousza33180ze3z87_13562 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33180ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33180ze3z87_13562, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11439))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33180ze3z87_13562, 
(int)(((long)1)), BgL_bodyz00_13551); 
PROCEDURE_SET(BgL_zc3z04anonymousza33180ze3z87_13562, 
(int)(((long)2)), 
BINT(BgL_siza7ezd2framez75_13525)); 
return BgL_zc3z04anonymousza33180ze3z87_13562;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33187ze3z87_13563;
BgL_zc3z04anonymousza33187ze3z87_13563 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33187ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33187ze3z87_13563, 
(int)(((long)0)), BgL_iboxesz00_13523); 
PROCEDURE_SET(BgL_zc3z04anonymousza33187ze3z87_13563, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11439))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33187ze3z87_13563, 
(int)(((long)2)), BgL_bodyz00_13551); 
PROCEDURE_SET(BgL_zc3z04anonymousza33187ze3z87_13563, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_13525)); 
return BgL_zc3z04anonymousza33187ze3z87_13563;} }  else 
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13523)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33197ze3z87_13564;
BgL_zc3z04anonymousza33197ze3z87_13564 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33197ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33197ze3z87_13564, 
(int)(((long)0)), BgL_ifreesz00_13522); 
PROCEDURE_SET(BgL_zc3z04anonymousza33197ze3z87_13564, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_13524)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33197ze3z87_13564, 
(int)(((long)2)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11439))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33197ze3z87_13564, 
(int)(((long)3)), BgL_bodyz00_13551); 
PROCEDURE_SET(BgL_zc3z04anonymousza33197ze3z87_13564, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_13525)); 
return BgL_zc3z04anonymousza33197ze3z87_13564;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33205ze3z87_13565;
BgL_zc3z04anonymousza33205ze3z87_13565 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33205ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33205ze3z87_13565, 
(int)(((long)0)), BgL_ifreesz00_13522); 
PROCEDURE_SET(BgL_zc3z04anonymousza33205ze3z87_13565, 
(int)(((long)1)), BgL_iboxesz00_13523); 
PROCEDURE_SET(BgL_zc3z04anonymousza33205ze3z87_13565, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_13524)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33205ze3z87_13565, 
(int)(((long)3)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11439))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33205ze3z87_13565, 
(int)(((long)4)), BgL_bodyz00_13551); 
PROCEDURE_SET(BgL_zc3z04anonymousza33205ze3z87_13565, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_13525)); 
return BgL_zc3z04anonymousza33205ze3z87_13565;} } break;case ((long)1) : 

if(
(
VECTOR_LENGTH(BgL_ifreesz00_13522)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13523)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33219ze3z87_13566;
BgL_zc3z04anonymousza33219ze3z87_13566 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33219ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33219ze3z87_13566, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11439))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33219ze3z87_13566, 
(int)(((long)1)), BgL_bodyz00_13551); 
PROCEDURE_SET(BgL_zc3z04anonymousza33219ze3z87_13566, 
(int)(((long)2)), 
BINT(BgL_siza7ezd2framez75_13525)); 
return BgL_zc3z04anonymousza33219ze3z87_13566;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33226ze3z87_13567;
BgL_zc3z04anonymousza33226ze3z87_13567 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33226ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33226ze3z87_13567, 
(int)(((long)0)), BgL_iboxesz00_13523); 
PROCEDURE_SET(BgL_zc3z04anonymousza33226ze3z87_13567, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11439))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33226ze3z87_13567, 
(int)(((long)2)), BgL_bodyz00_13551); 
PROCEDURE_SET(BgL_zc3z04anonymousza33226ze3z87_13567, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_13525)); 
return BgL_zc3z04anonymousza33226ze3z87_13567;} }  else 
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13523)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33236ze3z87_13568;
BgL_zc3z04anonymousza33236ze3z87_13568 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33236ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33236ze3z87_13568, 
(int)(((long)0)), BgL_ifreesz00_13522); 
PROCEDURE_SET(BgL_zc3z04anonymousza33236ze3z87_13568, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_13524)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33236ze3z87_13568, 
(int)(((long)2)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11439))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33236ze3z87_13568, 
(int)(((long)3)), BgL_bodyz00_13551); 
PROCEDURE_SET(BgL_zc3z04anonymousza33236ze3z87_13568, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_13525)); 
return BgL_zc3z04anonymousza33236ze3z87_13568;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33244ze3z87_13569;
BgL_zc3z04anonymousza33244ze3z87_13569 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33244ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33244ze3z87_13569, 
(int)(((long)0)), BgL_ifreesz00_13522); 
PROCEDURE_SET(BgL_zc3z04anonymousza33244ze3z87_13569, 
(int)(((long)1)), BgL_iboxesz00_13523); 
PROCEDURE_SET(BgL_zc3z04anonymousza33244ze3z87_13569, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_13524)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33244ze3z87_13569, 
(int)(((long)3)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11439))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33244ze3z87_13569, 
(int)(((long)4)), BgL_bodyz00_13551); 
PROCEDURE_SET(BgL_zc3z04anonymousza33244ze3z87_13569, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_13525)); 
return BgL_zc3z04anonymousza33244ze3z87_13569;} } break;case ((long)-2) : 

if(
(
VECTOR_LENGTH(BgL_ifreesz00_13522)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13523)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33258ze3z87_13570;
BgL_zc3z04anonymousza33258ze3z87_13570 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33258ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33258ze3z87_13570, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11439))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33258ze3z87_13570, 
(int)(((long)1)), BgL_bodyz00_13551); 
PROCEDURE_SET(BgL_zc3z04anonymousza33258ze3z87_13570, 
(int)(((long)2)), 
BINT(BgL_siza7ezd2framez75_13525)); 
return BgL_zc3z04anonymousza33258ze3z87_13570;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33266ze3z87_13571;
BgL_zc3z04anonymousza33266ze3z87_13571 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33266ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33266ze3z87_13571, 
(int)(((long)0)), BgL_iboxesz00_13523); 
PROCEDURE_SET(BgL_zc3z04anonymousza33266ze3z87_13571, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11439))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33266ze3z87_13571, 
(int)(((long)2)), BgL_bodyz00_13551); 
PROCEDURE_SET(BgL_zc3z04anonymousza33266ze3z87_13571, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_13525)); 
return BgL_zc3z04anonymousza33266ze3z87_13571;} }  else 
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13523)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33277ze3z87_13572;
BgL_zc3z04anonymousza33277ze3z87_13572 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33277ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33277ze3z87_13572, 
(int)(((long)0)), BgL_ifreesz00_13522); 
PROCEDURE_SET(BgL_zc3z04anonymousza33277ze3z87_13572, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_13524)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33277ze3z87_13572, 
(int)(((long)2)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11439))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33277ze3z87_13572, 
(int)(((long)3)), BgL_bodyz00_13551); 
PROCEDURE_SET(BgL_zc3z04anonymousza33277ze3z87_13572, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_13525)); 
return BgL_zc3z04anonymousza33277ze3z87_13572;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33286ze3z87_13573;
BgL_zc3z04anonymousza33286ze3z87_13573 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33286ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33286ze3z87_13573, 
(int)(((long)0)), BgL_ifreesz00_13522); 
PROCEDURE_SET(BgL_zc3z04anonymousza33286ze3z87_13573, 
(int)(((long)1)), BgL_iboxesz00_13523); 
PROCEDURE_SET(BgL_zc3z04anonymousza33286ze3z87_13573, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_13524)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33286ze3z87_13573, 
(int)(((long)3)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11439))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33286ze3z87_13573, 
(int)(((long)4)), BgL_bodyz00_13551); 
PROCEDURE_SET(BgL_zc3z04anonymousza33286ze3z87_13573, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_13525)); 
return BgL_zc3z04anonymousza33286ze3z87_13573;} } break;case ((long)2) : 

if(
(
VECTOR_LENGTH(BgL_ifreesz00_13522)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13523)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33301ze3z87_13574;
BgL_zc3z04anonymousza33301ze3z87_13574 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33301ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33301ze3z87_13574, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11439))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33301ze3z87_13574, 
(int)(((long)1)), BgL_bodyz00_13551); 
PROCEDURE_SET(BgL_zc3z04anonymousza33301ze3z87_13574, 
(int)(((long)2)), 
BINT(BgL_siza7ezd2framez75_13525)); 
return BgL_zc3z04anonymousza33301ze3z87_13574;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33309ze3z87_13575;
BgL_zc3z04anonymousza33309ze3z87_13575 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33309ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33309ze3z87_13575, 
(int)(((long)0)), BgL_iboxesz00_13523); 
PROCEDURE_SET(BgL_zc3z04anonymousza33309ze3z87_13575, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11439))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33309ze3z87_13575, 
(int)(((long)2)), BgL_bodyz00_13551); 
PROCEDURE_SET(BgL_zc3z04anonymousza33309ze3z87_13575, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_13525)); 
return BgL_zc3z04anonymousza33309ze3z87_13575;} }  else 
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13523)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33320ze3z87_13576;
BgL_zc3z04anonymousza33320ze3z87_13576 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33320ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33320ze3z87_13576, 
(int)(((long)0)), BgL_ifreesz00_13522); 
PROCEDURE_SET(BgL_zc3z04anonymousza33320ze3z87_13576, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_13524)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33320ze3z87_13576, 
(int)(((long)2)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11439))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33320ze3z87_13576, 
(int)(((long)3)), BgL_bodyz00_13551); 
PROCEDURE_SET(BgL_zc3z04anonymousza33320ze3z87_13576, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_13525)); 
return BgL_zc3z04anonymousza33320ze3z87_13576;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33329ze3z87_13577;
BgL_zc3z04anonymousza33329ze3z87_13577 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33329ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33329ze3z87_13577, 
(int)(((long)0)), BgL_ifreesz00_13522); 
PROCEDURE_SET(BgL_zc3z04anonymousza33329ze3z87_13577, 
(int)(((long)1)), BgL_iboxesz00_13523); 
PROCEDURE_SET(BgL_zc3z04anonymousza33329ze3z87_13577, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_13524)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33329ze3z87_13577, 
(int)(((long)3)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11439))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33329ze3z87_13577, 
(int)(((long)4)), BgL_bodyz00_13551); 
PROCEDURE_SET(BgL_zc3z04anonymousza33329ze3z87_13577, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_13525)); 
return BgL_zc3z04anonymousza33329ze3z87_13577;} } break;case ((long)-3) : 

if(
(
VECTOR_LENGTH(BgL_ifreesz00_13522)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13523)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33344ze3z87_13578;
BgL_zc3z04anonymousza33344ze3z87_13578 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33344ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33344ze3z87_13578, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11439))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33344ze3z87_13578, 
(int)(((long)1)), BgL_bodyz00_13551); 
PROCEDURE_SET(BgL_zc3z04anonymousza33344ze3z87_13578, 
(int)(((long)2)), 
BINT(BgL_siza7ezd2framez75_13525)); 
return BgL_zc3z04anonymousza33344ze3z87_13578;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33353ze3z87_13579;
BgL_zc3z04anonymousza33353ze3z87_13579 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33353ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33353ze3z87_13579, 
(int)(((long)0)), BgL_iboxesz00_13523); 
PROCEDURE_SET(BgL_zc3z04anonymousza33353ze3z87_13579, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11439))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33353ze3z87_13579, 
(int)(((long)2)), BgL_bodyz00_13551); 
PROCEDURE_SET(BgL_zc3z04anonymousza33353ze3z87_13579, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_13525)); 
return BgL_zc3z04anonymousza33353ze3z87_13579;} }  else 
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13523)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33365ze3z87_13580;
BgL_zc3z04anonymousza33365ze3z87_13580 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33365ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33365ze3z87_13580, 
(int)(((long)0)), BgL_ifreesz00_13522); 
PROCEDURE_SET(BgL_zc3z04anonymousza33365ze3z87_13580, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_13524)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33365ze3z87_13580, 
(int)(((long)2)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11439))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33365ze3z87_13580, 
(int)(((long)3)), BgL_bodyz00_13551); 
PROCEDURE_SET(BgL_zc3z04anonymousza33365ze3z87_13580, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_13525)); 
return BgL_zc3z04anonymousza33365ze3z87_13580;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33375ze3z87_13581;
BgL_zc3z04anonymousza33375ze3z87_13581 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33375ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33375ze3z87_13581, 
(int)(((long)0)), BgL_ifreesz00_13522); 
PROCEDURE_SET(BgL_zc3z04anonymousza33375ze3z87_13581, 
(int)(((long)1)), BgL_iboxesz00_13523); 
PROCEDURE_SET(BgL_zc3z04anonymousza33375ze3z87_13581, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_13524)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33375ze3z87_13581, 
(int)(((long)3)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11439))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33375ze3z87_13581, 
(int)(((long)4)), BgL_bodyz00_13551); 
PROCEDURE_SET(BgL_zc3z04anonymousza33375ze3z87_13581, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_13525)); 
return BgL_zc3z04anonymousza33375ze3z87_13581;} } break;case ((long)3) : 

if(
(
VECTOR_LENGTH(BgL_ifreesz00_13522)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13523)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33391ze3z87_13582;
BgL_zc3z04anonymousza33391ze3z87_13582 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33391ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33391ze3z87_13582, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11439))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33391ze3z87_13582, 
(int)(((long)1)), BgL_bodyz00_13551); 
PROCEDURE_SET(BgL_zc3z04anonymousza33391ze3z87_13582, 
(int)(((long)2)), 
BINT(BgL_siza7ezd2framez75_13525)); 
return BgL_zc3z04anonymousza33391ze3z87_13582;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33400ze3z87_13583;
BgL_zc3z04anonymousza33400ze3z87_13583 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33400ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33400ze3z87_13583, 
(int)(((long)0)), BgL_iboxesz00_13523); 
PROCEDURE_SET(BgL_zc3z04anonymousza33400ze3z87_13583, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11439))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33400ze3z87_13583, 
(int)(((long)2)), BgL_bodyz00_13551); 
PROCEDURE_SET(BgL_zc3z04anonymousza33400ze3z87_13583, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_13525)); 
return BgL_zc3z04anonymousza33400ze3z87_13583;} }  else 
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13523)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33412ze3z87_13584;
BgL_zc3z04anonymousza33412ze3z87_13584 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33412ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33412ze3z87_13584, 
(int)(((long)0)), BgL_ifreesz00_13522); 
PROCEDURE_SET(BgL_zc3z04anonymousza33412ze3z87_13584, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_13524)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33412ze3z87_13584, 
(int)(((long)2)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11439))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33412ze3z87_13584, 
(int)(((long)3)), BgL_bodyz00_13551); 
PROCEDURE_SET(BgL_zc3z04anonymousza33412ze3z87_13584, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_13525)); 
return BgL_zc3z04anonymousza33412ze3z87_13584;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33422ze3z87_13585;
BgL_zc3z04anonymousza33422ze3z87_13585 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33422ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33422ze3z87_13585, 
(int)(((long)0)), BgL_ifreesz00_13522); 
PROCEDURE_SET(BgL_zc3z04anonymousza33422ze3z87_13585, 
(int)(((long)1)), BgL_iboxesz00_13523); 
PROCEDURE_SET(BgL_zc3z04anonymousza33422ze3z87_13585, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_13524)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33422ze3z87_13585, 
(int)(((long)3)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11439))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33422ze3z87_13585, 
(int)(((long)4)), BgL_bodyz00_13551); 
PROCEDURE_SET(BgL_zc3z04anonymousza33422ze3z87_13585, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_13525)); 
return BgL_zc3z04anonymousza33422ze3z87_13585;} } break;case ((long)-4) : 

if(
(
VECTOR_LENGTH(BgL_ifreesz00_13522)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13523)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33438ze3z87_13586;
BgL_zc3z04anonymousza33438ze3z87_13586 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33438ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33438ze3z87_13586, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11439))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33438ze3z87_13586, 
(int)(((long)1)), BgL_bodyz00_13551); 
PROCEDURE_SET(BgL_zc3z04anonymousza33438ze3z87_13586, 
(int)(((long)2)), 
BINT(BgL_siza7ezd2framez75_13525)); 
return BgL_zc3z04anonymousza33438ze3z87_13586;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33448ze3z87_13587;
BgL_zc3z04anonymousza33448ze3z87_13587 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33448ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33448ze3z87_13587, 
(int)(((long)0)), BgL_iboxesz00_13523); 
PROCEDURE_SET(BgL_zc3z04anonymousza33448ze3z87_13587, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11439))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33448ze3z87_13587, 
(int)(((long)2)), BgL_bodyz00_13551); 
PROCEDURE_SET(BgL_zc3z04anonymousza33448ze3z87_13587, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_13525)); 
return BgL_zc3z04anonymousza33448ze3z87_13587;} }  else 
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13523)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33461ze3z87_13588;
BgL_zc3z04anonymousza33461ze3z87_13588 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33461ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33461ze3z87_13588, 
(int)(((long)0)), BgL_ifreesz00_13522); 
PROCEDURE_SET(BgL_zc3z04anonymousza33461ze3z87_13588, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_13524)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33461ze3z87_13588, 
(int)(((long)2)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11439))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33461ze3z87_13588, 
(int)(((long)3)), BgL_bodyz00_13551); 
PROCEDURE_SET(BgL_zc3z04anonymousza33461ze3z87_13588, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_13525)); 
return BgL_zc3z04anonymousza33461ze3z87_13588;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33472ze3z87_13589;
BgL_zc3z04anonymousza33472ze3z87_13589 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33472ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33472ze3z87_13589, 
(int)(((long)0)), BgL_ifreesz00_13522); 
PROCEDURE_SET(BgL_zc3z04anonymousza33472ze3z87_13589, 
(int)(((long)1)), BgL_iboxesz00_13523); 
PROCEDURE_SET(BgL_zc3z04anonymousza33472ze3z87_13589, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_13524)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33472ze3z87_13589, 
(int)(((long)3)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11439))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33472ze3z87_13589, 
(int)(((long)4)), BgL_bodyz00_13551); 
PROCEDURE_SET(BgL_zc3z04anonymousza33472ze3z87_13589, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_13525)); 
return BgL_zc3z04anonymousza33472ze3z87_13589;} } break;case ((long)4) : 

if(
(
VECTOR_LENGTH(BgL_ifreesz00_13522)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13523)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33489ze3z87_13590;
BgL_zc3z04anonymousza33489ze3z87_13590 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33489ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33489ze3z87_13590, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11439))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33489ze3z87_13590, 
(int)(((long)1)), BgL_bodyz00_13551); 
PROCEDURE_SET(BgL_zc3z04anonymousza33489ze3z87_13590, 
(int)(((long)2)), 
BINT(BgL_siza7ezd2framez75_13525)); 
return BgL_zc3z04anonymousza33489ze3z87_13590;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33499ze3z87_13591;
BgL_zc3z04anonymousza33499ze3z87_13591 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33499ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33499ze3z87_13591, 
(int)(((long)0)), BgL_iboxesz00_13523); 
PROCEDURE_SET(BgL_zc3z04anonymousza33499ze3z87_13591, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11439))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33499ze3z87_13591, 
(int)(((long)2)), BgL_bodyz00_13551); 
PROCEDURE_SET(BgL_zc3z04anonymousza33499ze3z87_13591, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_13525)); 
return BgL_zc3z04anonymousza33499ze3z87_13591;} }  else 
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13523)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33512ze3z87_13592;
BgL_zc3z04anonymousza33512ze3z87_13592 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33512ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33512ze3z87_13592, 
(int)(((long)0)), BgL_ifreesz00_13522); 
PROCEDURE_SET(BgL_zc3z04anonymousza33512ze3z87_13592, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_13524)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33512ze3z87_13592, 
(int)(((long)2)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11439))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33512ze3z87_13592, 
(int)(((long)3)), BgL_bodyz00_13551); 
PROCEDURE_SET(BgL_zc3z04anonymousza33512ze3z87_13592, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_13525)); 
return BgL_zc3z04anonymousza33512ze3z87_13592;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33523ze3z87_13593;
BgL_zc3z04anonymousza33523ze3z87_13593 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33523ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33523ze3z87_13593, 
(int)(((long)0)), BgL_ifreesz00_13522); 
PROCEDURE_SET(BgL_zc3z04anonymousza33523ze3z87_13593, 
(int)(((long)1)), BgL_iboxesz00_13523); 
PROCEDURE_SET(BgL_zc3z04anonymousza33523ze3z87_13593, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_13524)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33523ze3z87_13593, 
(int)(((long)3)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11439))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33523ze3z87_13593, 
(int)(((long)4)), BgL_bodyz00_13551); 
PROCEDURE_SET(BgL_zc3z04anonymousza33523ze3z87_13593, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_13525)); 
return BgL_zc3z04anonymousza33523ze3z87_13593;} } break;case ((long)-5) : 

if(
(
VECTOR_LENGTH(BgL_ifreesz00_13522)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13523)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33540ze3z87_13594;
BgL_zc3z04anonymousza33540ze3z87_13594 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33540ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33540ze3z87_13594, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11439))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33540ze3z87_13594, 
(int)(((long)1)), BgL_bodyz00_13551); 
PROCEDURE_SET(BgL_zc3z04anonymousza33540ze3z87_13594, 
(int)(((long)2)), 
BINT(BgL_siza7ezd2framez75_13525)); 
return BgL_zc3z04anonymousza33540ze3z87_13594;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33551ze3z87_13595;
BgL_zc3z04anonymousza33551ze3z87_13595 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33551ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33551ze3z87_13595, 
(int)(((long)0)), BgL_iboxesz00_13523); 
PROCEDURE_SET(BgL_zc3z04anonymousza33551ze3z87_13595, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11439))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33551ze3z87_13595, 
(int)(((long)2)), BgL_bodyz00_13551); 
PROCEDURE_SET(BgL_zc3z04anonymousza33551ze3z87_13595, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_13525)); 
return BgL_zc3z04anonymousza33551ze3z87_13595;} }  else 
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13523)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33565ze3z87_13596;
BgL_zc3z04anonymousza33565ze3z87_13596 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33565ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33565ze3z87_13596, 
(int)(((long)0)), BgL_ifreesz00_13522); 
PROCEDURE_SET(BgL_zc3z04anonymousza33565ze3z87_13596, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_13524)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33565ze3z87_13596, 
(int)(((long)2)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11439))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33565ze3z87_13596, 
(int)(((long)3)), BgL_bodyz00_13551); 
PROCEDURE_SET(BgL_zc3z04anonymousza33565ze3z87_13596, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_13525)); 
return BgL_zc3z04anonymousza33565ze3z87_13596;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33577ze3z87_13597;
BgL_zc3z04anonymousza33577ze3z87_13597 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33577ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33577ze3z87_13597, 
(int)(((long)0)), BgL_ifreesz00_13522); 
PROCEDURE_SET(BgL_zc3z04anonymousza33577ze3z87_13597, 
(int)(((long)1)), BgL_iboxesz00_13523); 
PROCEDURE_SET(BgL_zc3z04anonymousza33577ze3z87_13597, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_13524)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33577ze3z87_13597, 
(int)(((long)3)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11439))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33577ze3z87_13597, 
(int)(((long)4)), BgL_bodyz00_13551); 
PROCEDURE_SET(BgL_zc3z04anonymousza33577ze3z87_13597, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_13525)); 
return BgL_zc3z04anonymousza33577ze3z87_13597;} } break;
default: 
BgL_case_else1245z00_13552:
if(
(
VECTOR_LENGTH(BgL_ifreesz00_13522)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13523)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33595ze3z87_13553;
BgL_zc3z04anonymousza33595ze3z87_13553 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33595ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33595ze3z87_13553, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11439))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33595ze3z87_13553, 
(int)(((long)1)), BgL_bodyz00_13551); 
PROCEDURE_SET(BgL_zc3z04anonymousza33595ze3z87_13553, 
(int)(((long)2)), 
BINT(BgL_siza7ezd2framez75_13525)); 
return BgL_zc3z04anonymousza33595ze3z87_13553;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33615ze3z87_13554;
BgL_zc3z04anonymousza33615ze3z87_13554 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33615ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33615ze3z87_13554, 
(int)(((long)0)), BgL_iboxesz00_13523); 
PROCEDURE_SET(BgL_zc3z04anonymousza33615ze3z87_13554, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11439))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33615ze3z87_13554, 
(int)(((long)2)), BgL_bodyz00_13551); 
PROCEDURE_SET(BgL_zc3z04anonymousza33615ze3z87_13554, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_13525)); 
return BgL_zc3z04anonymousza33615ze3z87_13554;} }  else 
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13523)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33638ze3z87_13555;
BgL_zc3z04anonymousza33638ze3z87_13555 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33638ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33638ze3z87_13555, 
(int)(((long)0)), BgL_ifreesz00_13522); 
PROCEDURE_SET(BgL_zc3z04anonymousza33638ze3z87_13555, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_13524)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33638ze3z87_13555, 
(int)(((long)2)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11439))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33638ze3z87_13555, 
(int)(((long)3)), BgL_bodyz00_13551); 
PROCEDURE_SET(BgL_zc3z04anonymousza33638ze3z87_13555, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_13525)); 
return BgL_zc3z04anonymousza33638ze3z87_13555;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33659ze3z87_13556;
BgL_zc3z04anonymousza33659ze3z87_13556 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33659ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33659ze3z87_13556, 
(int)(((long)0)), BgL_ifreesz00_13522); 
PROCEDURE_SET(BgL_zc3z04anonymousza33659ze3z87_13556, 
(int)(((long)1)), BgL_iboxesz00_13523); 
PROCEDURE_SET(BgL_zc3z04anonymousza33659ze3z87_13556, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_13524)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33659ze3z87_13556, 
(int)(((long)3)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11439))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33659ze3z87_13556, 
(int)(((long)4)), BgL_bodyz00_13551); 
PROCEDURE_SET(BgL_zc3z04anonymousza33659ze3z87_13556, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_13525)); 
return BgL_zc3z04anonymousza33659ze3z87_13556;} } } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
goto BgL_case_else1245z00_13552;} } } } } } 

}



/* &<@anonymous:3540> */
obj_t BGl_z62zc3z04anonymousza33540ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11441, obj_t BgL_sz00_11445)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_11442;obj_t BgL_bodyz00_11443;long BgL_siza7ezd2framez75_11444;
BgL_i1244z00_11442 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11441, 
(int)(((long)0)))); 
BgL_bodyz00_11443 = 
PROCEDURE_REF(BgL_envz00_11441, 
(int)(((long)1))); 
BgL_siza7ezd2framez75_11444 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11441, 
(int)(((long)2)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13598;
BgL_bpz00_13598 = 
VECTOR_REF(
((obj_t)BgL_sz00_11445),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13599;
BgL_runz00_13599 = 
MAKE_FX_PROCEDURE(BGl_z62runz62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_runz00_13599, 
(int)(((long)0)), 
((obj_t)BgL_i1244z00_11442)); 
PROCEDURE_SET(BgL_runz00_13599, 
(int)(((long)1)), BgL_bodyz00_11443); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13600;
BgL_mainz00_13600 = 
MAKE_VA_PROCEDURE(BGl_z62mainz62zz__evaluate_compz00, 
(int)(((long)-5)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_mainz00_13600, 
(int)(((long)0)), 
((obj_t)BgL_i1244z00_11442)); 
PROCEDURE_SET(BgL_mainz00_13600, 
(int)(((long)1)), BgL_bodyz00_11443); 
PROCEDURE_SET(BgL_mainz00_13600, 
(int)(((long)2)), BgL_runz00_13599); 
PROCEDURE_SET(BgL_mainz00_13600, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_11444)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13601;
BgL_objz00_13601 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13599, BgL_objz00_13601); BgL_objz00_13601; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3541z00_13602;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3542z00_13603;
BgL_arg3542z00_13603 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11442))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13604;
BgL_newz00_13604 = 
create_struct(BGl_symbol5225z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_22429;
BgL_tmpz00_22429 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13604, BgL_tmpz00_22429, BgL_arg3542z00_13603); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_22434;int BgL_tmpz00_22432;
BgL_auxz00_22434 = 
BINT(BgL_siza7ezd2framez75_11444); 
BgL_tmpz00_22432 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13604, BgL_tmpz00_22432, BgL_auxz00_22434); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_22437;
BgL_tmpz00_22437 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13604, BgL_tmpz00_22437, BgL_runz00_13599); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_22442;int BgL_tmpz00_22440;
BgL_auxz00_22442 = 
BINT(((long)-5)); 
BgL_tmpz00_22440 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13604, BgL_tmpz00_22440, BgL_auxz00_22442); } 
BgL_arg3541z00_13602 = BgL_newz00_13604; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13600, BgL_arg3541z00_13602); BgL_arg3541z00_13602; } 
return BgL_mainz00_13600;} } } } } } 

}



/* &main */
obj_t BGl_z62mainz62zz__evaluate_compz00(obj_t BgL_envz00_11446, obj_t BgL_az00_11451, obj_t BgL_bz00_11452, obj_t BgL_cz00_11453, obj_t BgL_dz00_11454, obj_t BgL_lastz00_11455)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11449;long BgL_siza7ezd2framez75_11450;
BgL_runz00_11449 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11446, 
(int)(((long)2)))); 
BgL_siza7ezd2framez75_11450 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11446, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13605;
BgL_sz00_13605 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13606;
BgL_bpz00_13606 = 
VECTOR_REF(
((obj_t)BgL_sz00_13605),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13605, BgL_bpz00_13606, 
BINT(BgL_siza7ezd2framez75_11450)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3545z00_13607;
BgL_arg3545z00_13607 = 
(
(long)CINT(BgL_bpz00_13606)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13605),BgL_arg3545z00_13607,BgL_az00_11451); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3546z00_13608;
BgL_arg3546z00_13608 = 
(
(long)CINT(BgL_bpz00_13606)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13605),BgL_arg3546z00_13608,BgL_bz00_11452); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3547z00_13609;
BgL_arg3547z00_13609 = 
(
(long)CINT(BgL_bpz00_13606)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13605),BgL_arg3547z00_13609,BgL_cz00_11453); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3548z00_13610;
BgL_arg3548z00_13610 = 
(
(long)CINT(BgL_bpz00_13606)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_13605),BgL_arg3548z00_13610,BgL_dz00_11454); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3549z00_13611;
BgL_arg3549z00_13611 = 
(
(long)CINT(BgL_bpz00_13606)+((long)4)); 
VECTOR_SET(
((obj_t)BgL_sz00_13605),BgL_arg3549z00_13611,BgL_lastz00_11455); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13612;
BgL_ez00_13612 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13612, BgL_bpz00_13606); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13613;
BgL_accz00_13613 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11449, BgL_sz00_13605, BgL_bpz00_13606); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13612); 
VECTOR_SET(
((obj_t)BgL_sz00_13605),((long)0),BgL_bpz00_13606); 
return BgL_accz00_13613;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13614;
BgL_nsz00_13614 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13614,((long)1),BgL_sz00_13605); 
VECTOR_SET(BgL_nsz00_13614,((long)2),BgL_az00_11451); 
VECTOR_SET(BgL_nsz00_13614,((long)3),BgL_bz00_11452); 
VECTOR_SET(BgL_nsz00_13614,((long)4),BgL_cz00_11453); 
VECTOR_SET(BgL_nsz00_13614,((long)5),BgL_dz00_11454); 
VECTOR_SET(BgL_nsz00_13614,((long)6),BgL_lastz00_11455); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13615;
BgL_z12denvz12_13615 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13615, BgL_nsz00_13614); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13616;
BgL_ez00_13616 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13616, BgL_sz00_13605); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13617;
BgL_____rz00_13617 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11449, BgL_nsz00_13614, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13616); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13615, BgL_sz00_13605); 
return BgL_____rz00_13617;} } } } } } } } 

}



/* &run */
obj_t BGl_z62runz62zz__evaluate_compz00(obj_t BgL_envz00_11456, obj_t BgL_sz00_11459)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_11457;obj_t BgL_bodyz00_11458;
BgL_i1244z00_11457 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11456, 
(int)(((long)0)))); 
BgL_bodyz00_11458 = 
PROCEDURE_REF(BgL_envz00_11456, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13618;
BgL_bpz00_13618 = 
VECTOR_REF(
((obj_t)BgL_sz00_11459),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13619;obj_t BgL_wherez00_13620;obj_t BgL_locz00_13621;
BgL_z12denvz12_13619 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13620 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11457))->BgL_wherez00); 
BgL_locz00_13621 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11457))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13619, BgL_wherez00_13620, BgL_locz00_13621); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_13622;
BgL_za2za2resza2za2z00_13622 = 
PROCEDURE_ENTRY(BgL_bodyz00_11458)(BgL_bodyz00_11458, BgL_sz00_11459, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13619); 
return BgL_za2za2resza2za2z00_13622;} } } } } } 

}



/* &<@anonymous:3551> */
obj_t BGl_z62zc3z04anonymousza33551ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11460, obj_t BgL_sz00_11465)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11461;BgL_ev_absz00_bglt BgL_i1244z00_11462;obj_t BgL_bodyz00_11463;long BgL_siza7ezd2framez75_11464;
BgL_iboxesz00_11461 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11460, 
(int)(((long)0)))); 
BgL_i1244z00_11462 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11460, 
(int)(((long)1)))); 
BgL_bodyz00_11463 = 
PROCEDURE_REF(BgL_envz00_11460, 
(int)(((long)2))); 
BgL_siza7ezd2framez75_11464 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11460, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13623;
BgL_bpz00_13623 = 
VECTOR_REF(
((obj_t)BgL_sz00_11465),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13624;
BgL_runz00_13624 = 
MAKE_FX_PROCEDURE(BGl_z62run5111z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_runz00_13624, 
(int)(((long)0)), BgL_iboxesz00_11461); 
PROCEDURE_SET(BgL_runz00_13624, 
(int)(((long)1)), 
((obj_t)BgL_i1244z00_11462)); 
PROCEDURE_SET(BgL_runz00_13624, 
(int)(((long)2)), BgL_bodyz00_11463); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13625;
BgL_mainz00_13625 = 
MAKE_VA_PROCEDURE(BGl_z62main5110z62zz__evaluate_compz00, 
(int)(((long)-5)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_mainz00_13625, 
(int)(((long)0)), BgL_iboxesz00_11461); 
PROCEDURE_SET(BgL_mainz00_13625, 
(int)(((long)1)), 
((obj_t)BgL_i1244z00_11462)); 
PROCEDURE_SET(BgL_mainz00_13625, 
(int)(((long)2)), BgL_bodyz00_11463); 
PROCEDURE_SET(BgL_mainz00_13625, 
(int)(((long)3)), BgL_runz00_13624); 
PROCEDURE_SET(BgL_mainz00_13625, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_11464)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13626;
BgL_objz00_13626 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13624, BgL_objz00_13626); BgL_objz00_13626; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3552z00_13627;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3553z00_13628;
BgL_arg3553z00_13628 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11462))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13629;
BgL_newz00_13629 = 
create_struct(BGl_symbol5225z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_22557;
BgL_tmpz00_22557 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13629, BgL_tmpz00_22557, BgL_arg3553z00_13628); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_22562;int BgL_tmpz00_22560;
BgL_auxz00_22562 = 
BINT(BgL_siza7ezd2framez75_11464); 
BgL_tmpz00_22560 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13629, BgL_tmpz00_22560, BgL_auxz00_22562); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_22565;
BgL_tmpz00_22565 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13629, BgL_tmpz00_22565, BgL_runz00_13624); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_22570;int BgL_tmpz00_22568;
BgL_auxz00_22570 = 
BINT(((long)-5)); 
BgL_tmpz00_22568 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13629, BgL_tmpz00_22568, BgL_auxz00_22570); } 
BgL_arg3552z00_13627 = BgL_newz00_13629; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13625, BgL_arg3552z00_13627); BgL_arg3552z00_13627; } 
return BgL_mainz00_13625;} } } } } } 

}



/* &main5110 */
obj_t BGl_z62main5110z62zz__evaluate_compz00(obj_t BgL_envz00_11466, obj_t BgL_az00_11472, obj_t BgL_bz00_11473, obj_t BgL_cz00_11474, obj_t BgL_dz00_11475, obj_t BgL_lastz00_11476)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11470;long BgL_siza7ezd2framez75_11471;
BgL_runz00_11470 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11466, 
(int)(((long)3)))); 
BgL_siza7ezd2framez75_11471 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11466, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13630;
BgL_sz00_13630 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13631;
BgL_bpz00_13631 = 
VECTOR_REF(
((obj_t)BgL_sz00_13630),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13630, BgL_bpz00_13631, 
BINT(BgL_siza7ezd2framez75_11471)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3556z00_13632;
BgL_arg3556z00_13632 = 
(
(long)CINT(BgL_bpz00_13631)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13630),BgL_arg3556z00_13632,BgL_az00_11472); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3557z00_13633;
BgL_arg3557z00_13633 = 
(
(long)CINT(BgL_bpz00_13631)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13630),BgL_arg3557z00_13633,BgL_bz00_11473); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3558z00_13634;
BgL_arg3558z00_13634 = 
(
(long)CINT(BgL_bpz00_13631)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13630),BgL_arg3558z00_13634,BgL_cz00_11474); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3559z00_13635;
BgL_arg3559z00_13635 = 
(
(long)CINT(BgL_bpz00_13631)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_13630),BgL_arg3559z00_13635,BgL_dz00_11475); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3560z00_13636;
BgL_arg3560z00_13636 = 
(
(long)CINT(BgL_bpz00_13631)+((long)4)); 
VECTOR_SET(
((obj_t)BgL_sz00_13630),BgL_arg3560z00_13636,BgL_lastz00_11476); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13637;
BgL_ez00_13637 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13637, BgL_bpz00_13631); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13638;
BgL_accz00_13638 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11470, BgL_sz00_13630, BgL_bpz00_13631); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13637); 
VECTOR_SET(
((obj_t)BgL_sz00_13630),((long)0),BgL_bpz00_13631); 
return BgL_accz00_13638;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13639;
BgL_nsz00_13639 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13639,((long)1),BgL_sz00_13630); 
VECTOR_SET(BgL_nsz00_13639,((long)2),BgL_az00_11472); 
VECTOR_SET(BgL_nsz00_13639,((long)3),BgL_bz00_11473); 
VECTOR_SET(BgL_nsz00_13639,((long)4),BgL_cz00_11474); 
VECTOR_SET(BgL_nsz00_13639,((long)5),BgL_dz00_11475); 
VECTOR_SET(BgL_nsz00_13639,((long)6),BgL_lastz00_11476); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13640;
BgL_z12denvz12_13640 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13640, BgL_nsz00_13639); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13641;
BgL_ez00_13641 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13641, BgL_sz00_13630); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13642;
BgL_____rz00_13642 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11470, BgL_nsz00_13639, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13641); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13640, BgL_sz00_13630); 
return BgL_____rz00_13642;} } } } } } } } 

}



/* &run5111 */
obj_t BGl_z62run5111z62zz__evaluate_compz00(obj_t BgL_envz00_11477, obj_t BgL_sz00_11481)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11478;BgL_ev_absz00_bglt BgL_i1244z00_11479;obj_t BgL_bodyz00_11480;
BgL_iboxesz00_11478 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11477, 
(int)(((long)0)))); 
BgL_i1244z00_11479 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11477, 
(int)(((long)1)))); 
BgL_bodyz00_11480 = 
PROCEDURE_REF(BgL_envz00_11477, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13643;
BgL_bpz00_13643 = 
VECTOR_REF(
((obj_t)BgL_sz00_11481),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_11481, BgL_iboxesz00_11478, BgL_bpz00_13643); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13644;obj_t BgL_wherez00_13645;obj_t BgL_locz00_13646;
BgL_z12denvz12_13644 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13645 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11479))->BgL_wherez00); 
BgL_locz00_13646 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11479))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13644, BgL_wherez00_13645, BgL_locz00_13646); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_13647;
BgL_za2za2resza2za2z00_13647 = 
PROCEDURE_ENTRY(BgL_bodyz00_11480)(BgL_bodyz00_11480, BgL_sz00_11481, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13644); 
return BgL_za2za2resza2za2z00_13647;} } } } } } 

}



/* &<@anonymous:3565> */
obj_t BGl_z62zc3z04anonymousza33565ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11482, obj_t BgL_sz00_11488)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_11483;long BgL_siza7eza7_11484;BgL_ev_absz00_bglt BgL_i1244z00_11485;obj_t BgL_bodyz00_11486;long BgL_siza7ezd2framez75_11487;
BgL_ifreesz00_11483 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11482, 
(int)(((long)0)))); 
BgL_siza7eza7_11484 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11482, 
(int)(((long)1)))); 
BgL_i1244z00_11485 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11482, 
(int)(((long)2)))); 
BgL_bodyz00_11486 = 
PROCEDURE_REF(BgL_envz00_11482, 
(int)(((long)3))); 
BgL_siza7ezd2framez75_11487 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11482, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13648;
BgL_bpz00_13648 = 
VECTOR_REF(
((obj_t)BgL_sz00_11488),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_13649;
BgL_valza2za2_13649 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_11488, BgL_bpz00_13648, BgL_ifreesz00_11483); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13650;
BgL_runz00_13650 = 
MAKE_FX_PROCEDURE(BGl_z62run5113z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_runz00_13650, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_11484)); 
PROCEDURE_SET(BgL_runz00_13650, 
(int)(((long)1)), BgL_valza2za2_13649); 
PROCEDURE_SET(BgL_runz00_13650, 
(int)(((long)2)), 
((obj_t)BgL_i1244z00_11485)); 
PROCEDURE_SET(BgL_runz00_13650, 
(int)(((long)3)), BgL_bodyz00_11486); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13651;
BgL_mainz00_13651 = 
MAKE_VA_PROCEDURE(BGl_z62main5112z62zz__evaluate_compz00, 
(int)(((long)-5)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_mainz00_13651, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_11484)); 
PROCEDURE_SET(BgL_mainz00_13651, 
(int)(((long)1)), BgL_valza2za2_13649); 
PROCEDURE_SET(BgL_mainz00_13651, 
(int)(((long)2)), 
((obj_t)BgL_i1244z00_11485)); 
PROCEDURE_SET(BgL_mainz00_13651, 
(int)(((long)3)), BgL_bodyz00_11486); 
PROCEDURE_SET(BgL_mainz00_13651, 
(int)(((long)4)), BgL_runz00_13650); 
PROCEDURE_SET(BgL_mainz00_13651, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_11487)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13652;
BgL_objz00_13652 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13650, BgL_objz00_13652); BgL_objz00_13652; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3566z00_13653;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3567z00_13654;
BgL_arg3567z00_13654 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11485))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13655;
BgL_newz00_13655 = 
create_struct(BGl_symbol5225z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_22699;
BgL_tmpz00_22699 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13655, BgL_tmpz00_22699, BgL_arg3567z00_13654); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_22704;int BgL_tmpz00_22702;
BgL_auxz00_22704 = 
BINT(BgL_siza7ezd2framez75_11487); 
BgL_tmpz00_22702 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13655, BgL_tmpz00_22702, BgL_auxz00_22704); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_22707;
BgL_tmpz00_22707 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13655, BgL_tmpz00_22707, BgL_runz00_13650); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_22712;int BgL_tmpz00_22710;
BgL_auxz00_22712 = 
BINT(((long)-5)); 
BgL_tmpz00_22710 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13655, BgL_tmpz00_22710, BgL_auxz00_22712); } 
BgL_arg3566z00_13653 = BgL_newz00_13655; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13651, BgL_arg3566z00_13653); BgL_arg3566z00_13653; } 
return BgL_mainz00_13651;} } } } } } 

}



/* &main5112 */
obj_t BGl_z62main5112z62zz__evaluate_compz00(obj_t BgL_envz00_11489, obj_t BgL_az00_11496, obj_t BgL_bz00_11497, obj_t BgL_cz00_11498, obj_t BgL_dz00_11499, obj_t BgL_lastz00_11500)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11494;long BgL_siza7ezd2framez75_11495;
BgL_runz00_11494 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11489, 
(int)(((long)4)))); 
BgL_siza7ezd2framez75_11495 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11489, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13656;
BgL_sz00_13656 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13657;
BgL_bpz00_13657 = 
VECTOR_REF(
((obj_t)BgL_sz00_13656),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13656, BgL_bpz00_13657, 
BINT(BgL_siza7ezd2framez75_11495)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3570z00_13658;
BgL_arg3570z00_13658 = 
(
(long)CINT(BgL_bpz00_13657)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13656),BgL_arg3570z00_13658,BgL_az00_11496); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3571z00_13659;
BgL_arg3571z00_13659 = 
(
(long)CINT(BgL_bpz00_13657)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13656),BgL_arg3571z00_13659,BgL_bz00_11497); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3572z00_13660;
BgL_arg3572z00_13660 = 
(
(long)CINT(BgL_bpz00_13657)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13656),BgL_arg3572z00_13660,BgL_cz00_11498); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3573z00_13661;
BgL_arg3573z00_13661 = 
(
(long)CINT(BgL_bpz00_13657)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_13656),BgL_arg3573z00_13661,BgL_dz00_11499); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3574z00_13662;
BgL_arg3574z00_13662 = 
(
(long)CINT(BgL_bpz00_13657)+((long)4)); 
VECTOR_SET(
((obj_t)BgL_sz00_13656),BgL_arg3574z00_13662,BgL_lastz00_11500); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13663;
BgL_ez00_13663 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13663, BgL_bpz00_13657); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13664;
BgL_accz00_13664 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11494, BgL_sz00_13656, BgL_bpz00_13657); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13663); 
VECTOR_SET(
((obj_t)BgL_sz00_13656),((long)0),BgL_bpz00_13657); 
return BgL_accz00_13664;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13665;
BgL_nsz00_13665 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13665,((long)1),BgL_sz00_13656); 
VECTOR_SET(BgL_nsz00_13665,((long)2),BgL_az00_11496); 
VECTOR_SET(BgL_nsz00_13665,((long)3),BgL_bz00_11497); 
VECTOR_SET(BgL_nsz00_13665,((long)4),BgL_cz00_11498); 
VECTOR_SET(BgL_nsz00_13665,((long)5),BgL_dz00_11499); 
VECTOR_SET(BgL_nsz00_13665,((long)6),BgL_lastz00_11500); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13666;
BgL_z12denvz12_13666 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13666, BgL_nsz00_13665); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13667;
BgL_ez00_13667 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13667, BgL_sz00_13656); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13668;
BgL_____rz00_13668 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11494, BgL_nsz00_13665, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13667); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13666, BgL_sz00_13656); 
return BgL_____rz00_13668;} } } } } } } } 

}



/* &run5113 */
obj_t BGl_z62run5113z62zz__evaluate_compz00(obj_t BgL_envz00_11501, obj_t BgL_sz00_11506)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_siza7eza7_11502;obj_t BgL_valza2za2_11503;BgL_ev_absz00_bglt BgL_i1244z00_11504;obj_t BgL_bodyz00_11505;
BgL_siza7eza7_11502 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11501, 
(int)(((long)0)))); 
BgL_valza2za2_11503 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11501, 
(int)(((long)1)))); 
BgL_i1244z00_11504 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11501, 
(int)(((long)2)))); 
BgL_bodyz00_11505 = 
PROCEDURE_REF(BgL_envz00_11501, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13669;
BgL_bpz00_13669 = 
VECTOR_REF(
((obj_t)BgL_sz00_11506),((long)0)); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_11506, BgL_valza2za2_11503, 
(
(long)CINT(BgL_bpz00_13669)+BgL_siza7eza7_11502)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_13670;obj_t BgL_wherez00_13671;obj_t BgL_locz00_13672;
BgL_z12denvz12_13670 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13671 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11504))->BgL_wherez00); 
BgL_locz00_13672 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11504))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13670, BgL_wherez00_13671, BgL_locz00_13672); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_13673;
BgL_za2za2resza2za2z00_13673 = 
PROCEDURE_ENTRY(BgL_bodyz00_11505)(BgL_bodyz00_11505, BgL_sz00_11506, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13670); 
return BgL_za2za2resza2za2z00_13673;} } } } } } 

}



/* &<@anonymous:3577> */
obj_t BGl_z62zc3z04anonymousza33577ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11507, obj_t BgL_sz00_11514)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_11508;obj_t BgL_iboxesz00_11509;long BgL_siza7eza7_11510;BgL_ev_absz00_bglt BgL_i1244z00_11511;obj_t BgL_bodyz00_11512;long BgL_siza7ezd2framez75_11513;
BgL_ifreesz00_11508 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11507, 
(int)(((long)0)))); 
BgL_iboxesz00_11509 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11507, 
(int)(((long)1)))); 
BgL_siza7eza7_11510 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11507, 
(int)(((long)2)))); 
BgL_i1244z00_11511 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11507, 
(int)(((long)3)))); 
BgL_bodyz00_11512 = 
PROCEDURE_REF(BgL_envz00_11507, 
(int)(((long)4))); 
BgL_siza7ezd2framez75_11513 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11507, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13674;
BgL_bpz00_13674 = 
VECTOR_REF(
((obj_t)BgL_sz00_11514),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_13675;
BgL_valza2za2_13675 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_11514, BgL_bpz00_13674, BgL_ifreesz00_11508); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13676;
BgL_runz00_13676 = 
MAKE_FX_PROCEDURE(BGl_z62run5115z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_runz00_13676, 
(int)(((long)0)), BgL_iboxesz00_11509); 
PROCEDURE_SET(BgL_runz00_13676, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_11510)); 
PROCEDURE_SET(BgL_runz00_13676, 
(int)(((long)2)), BgL_valza2za2_13675); 
PROCEDURE_SET(BgL_runz00_13676, 
(int)(((long)3)), 
((obj_t)BgL_i1244z00_11511)); 
PROCEDURE_SET(BgL_runz00_13676, 
(int)(((long)4)), BgL_bodyz00_11512); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13677;
BgL_mainz00_13677 = 
MAKE_VA_PROCEDURE(BGl_z62main5114z62zz__evaluate_compz00, 
(int)(((long)-5)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_mainz00_13677, 
(int)(((long)0)), BgL_iboxesz00_11509); 
PROCEDURE_SET(BgL_mainz00_13677, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_11510)); 
PROCEDURE_SET(BgL_mainz00_13677, 
(int)(((long)2)), BgL_valza2za2_13675); 
PROCEDURE_SET(BgL_mainz00_13677, 
(int)(((long)3)), 
((obj_t)BgL_i1244z00_11511)); 
PROCEDURE_SET(BgL_mainz00_13677, 
(int)(((long)4)), BgL_bodyz00_11512); 
PROCEDURE_SET(BgL_mainz00_13677, 
(int)(((long)5)), BgL_runz00_13676); 
PROCEDURE_SET(BgL_mainz00_13677, 
(int)(((long)6)), 
BINT(BgL_siza7ezd2framez75_11513)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13678;
BgL_objz00_13678 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13676, BgL_objz00_13678); BgL_objz00_13678; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3578z00_13679;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3579z00_13680;
BgL_arg3579z00_13680 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11511))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13681;
BgL_newz00_13681 = 
create_struct(BGl_symbol5225z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_22853;
BgL_tmpz00_22853 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13681, BgL_tmpz00_22853, BgL_arg3579z00_13680); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_22858;int BgL_tmpz00_22856;
BgL_auxz00_22858 = 
BINT(BgL_siza7ezd2framez75_11513); 
BgL_tmpz00_22856 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13681, BgL_tmpz00_22856, BgL_auxz00_22858); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_22861;
BgL_tmpz00_22861 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13681, BgL_tmpz00_22861, BgL_runz00_13676); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_22866;int BgL_tmpz00_22864;
BgL_auxz00_22866 = 
BINT(((long)-5)); 
BgL_tmpz00_22864 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13681, BgL_tmpz00_22864, BgL_auxz00_22866); } 
BgL_arg3578z00_13679 = BgL_newz00_13681; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13677, BgL_arg3578z00_13679); BgL_arg3578z00_13679; } 
return BgL_mainz00_13677;} } } } } } 

}



/* &main5114 */
obj_t BGl_z62main5114z62zz__evaluate_compz00(obj_t BgL_envz00_11515, obj_t BgL_az00_11523, obj_t BgL_bz00_11524, obj_t BgL_cz00_11525, obj_t BgL_dz00_11526, obj_t BgL_lastz00_11527)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11521;long BgL_siza7ezd2framez75_11522;
BgL_runz00_11521 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11515, 
(int)(((long)5)))); 
BgL_siza7ezd2framez75_11522 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11515, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13682;
BgL_sz00_13682 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13683;
BgL_bpz00_13683 = 
VECTOR_REF(
((obj_t)BgL_sz00_13682),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13682, BgL_bpz00_13683, 
BINT(BgL_siza7ezd2framez75_11522)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3582z00_13684;
BgL_arg3582z00_13684 = 
(
(long)CINT(BgL_bpz00_13683)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13682),BgL_arg3582z00_13684,BgL_az00_11523); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3583z00_13685;
BgL_arg3583z00_13685 = 
(
(long)CINT(BgL_bpz00_13683)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13682),BgL_arg3583z00_13685,BgL_bz00_11524); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3584z00_13686;
BgL_arg3584z00_13686 = 
(
(long)CINT(BgL_bpz00_13683)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13682),BgL_arg3584z00_13686,BgL_cz00_11525); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3585z00_13687;
BgL_arg3585z00_13687 = 
(
(long)CINT(BgL_bpz00_13683)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_13682),BgL_arg3585z00_13687,BgL_dz00_11526); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3586z00_13688;
BgL_arg3586z00_13688 = 
(
(long)CINT(BgL_bpz00_13683)+((long)4)); 
VECTOR_SET(
((obj_t)BgL_sz00_13682),BgL_arg3586z00_13688,BgL_lastz00_11527); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13689;
BgL_ez00_13689 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13689, BgL_bpz00_13683); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13690;
BgL_accz00_13690 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11521, BgL_sz00_13682, BgL_bpz00_13683); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13689); 
VECTOR_SET(
((obj_t)BgL_sz00_13682),((long)0),BgL_bpz00_13683); 
return BgL_accz00_13690;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13691;
BgL_nsz00_13691 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13691,((long)1),BgL_sz00_13682); 
VECTOR_SET(BgL_nsz00_13691,((long)2),BgL_az00_11523); 
VECTOR_SET(BgL_nsz00_13691,((long)3),BgL_bz00_11524); 
VECTOR_SET(BgL_nsz00_13691,((long)4),BgL_cz00_11525); 
VECTOR_SET(BgL_nsz00_13691,((long)5),BgL_dz00_11526); 
VECTOR_SET(BgL_nsz00_13691,((long)6),BgL_lastz00_11527); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13692;
BgL_z12denvz12_13692 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13692, BgL_nsz00_13691); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13693;
BgL_ez00_13693 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13693, BgL_sz00_13682); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13694;
BgL_____rz00_13694 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11521, BgL_nsz00_13691, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13693); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13692, BgL_sz00_13682); 
return BgL_____rz00_13694;} } } } } } } } 

}



/* &run5115 */
obj_t BGl_z62run5115z62zz__evaluate_compz00(obj_t BgL_envz00_11528, obj_t BgL_sz00_11534)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11529;long BgL_siza7eza7_11530;obj_t BgL_valza2za2_11531;BgL_ev_absz00_bglt BgL_i1244z00_11532;obj_t BgL_bodyz00_11533;
BgL_iboxesz00_11529 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11528, 
(int)(((long)0)))); 
BgL_siza7eza7_11530 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11528, 
(int)(((long)1)))); 
BgL_valza2za2_11531 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11528, 
(int)(((long)2)))); 
BgL_i1244z00_11532 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11528, 
(int)(((long)3)))); 
BgL_bodyz00_11533 = 
PROCEDURE_REF(BgL_envz00_11528, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13695;
BgL_bpz00_13695 = 
VECTOR_REF(
((obj_t)BgL_sz00_11534),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_11534, BgL_iboxesz00_11529, BgL_bpz00_13695); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_11534, BgL_valza2za2_11531, 
(
(long)CINT(BgL_bpz00_13695)+BgL_siza7eza7_11530)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_13696;obj_t BgL_wherez00_13697;obj_t BgL_locz00_13698;
BgL_z12denvz12_13696 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13697 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11532))->BgL_wherez00); 
BgL_locz00_13698 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11532))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13696, BgL_wherez00_13697, BgL_locz00_13698); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_13699;
BgL_za2za2resza2za2z00_13699 = 
PROCEDURE_ENTRY(BgL_bodyz00_11533)(BgL_bodyz00_11533, BgL_sz00_11534, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13696); 
return BgL_za2za2resza2za2z00_13699;} } } } } } 

}



/* &<@anonymous:3489> */
obj_t BGl_z62zc3z04anonymousza33489ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11535, obj_t BgL_sz00_11539)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_11536;obj_t BgL_bodyz00_11537;long BgL_siza7ezd2framez75_11538;
BgL_i1244z00_11536 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11535, 
(int)(((long)0)))); 
BgL_bodyz00_11537 = 
PROCEDURE_REF(BgL_envz00_11535, 
(int)(((long)1))); 
BgL_siza7ezd2framez75_11538 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11535, 
(int)(((long)2)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13700;
BgL_bpz00_13700 = 
VECTOR_REF(
((obj_t)BgL_sz00_11539),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13701;
BgL_runz00_13701 = 
MAKE_FX_PROCEDURE(BGl_z62run5117z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_runz00_13701, 
(int)(((long)0)), 
((obj_t)BgL_i1244z00_11536)); 
PROCEDURE_SET(BgL_runz00_13701, 
(int)(((long)1)), BgL_bodyz00_11537); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13702;
BgL_mainz00_13702 = 
MAKE_FX_PROCEDURE(BGl_z62main5116z62zz__evaluate_compz00, 
(int)(((long)4)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_mainz00_13702, 
(int)(((long)0)), 
((obj_t)BgL_i1244z00_11536)); 
PROCEDURE_SET(BgL_mainz00_13702, 
(int)(((long)1)), BgL_bodyz00_11537); 
PROCEDURE_SET(BgL_mainz00_13702, 
(int)(((long)2)), BgL_runz00_13701); 
PROCEDURE_SET(BgL_mainz00_13702, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_11538)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13703;
BgL_objz00_13703 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13701, BgL_objz00_13703); BgL_objz00_13703; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3490z00_13704;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3491z00_13705;
BgL_arg3491z00_13705 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11536))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13706;
BgL_newz00_13706 = 
create_struct(BGl_symbol5225z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_22987;
BgL_tmpz00_22987 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13706, BgL_tmpz00_22987, BgL_arg3491z00_13705); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_22992;int BgL_tmpz00_22990;
BgL_auxz00_22992 = 
BINT(BgL_siza7ezd2framez75_11538); 
BgL_tmpz00_22990 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13706, BgL_tmpz00_22990, BgL_auxz00_22992); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_22995;
BgL_tmpz00_22995 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13706, BgL_tmpz00_22995, BgL_runz00_13701); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_23000;int BgL_tmpz00_22998;
BgL_auxz00_23000 = 
BINT(((long)4)); 
BgL_tmpz00_22998 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13706, BgL_tmpz00_22998, BgL_auxz00_23000); } 
BgL_arg3490z00_13704 = BgL_newz00_13706; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13702, BgL_arg3490z00_13704); BgL_arg3490z00_13704; } 
return BgL_mainz00_13702;} } } } } } 

}



/* &main5116 */
obj_t BGl_z62main5116z62zz__evaluate_compz00(obj_t BgL_envz00_11540, obj_t BgL_az00_11545, obj_t BgL_bz00_11546, obj_t BgL_cz00_11547, obj_t BgL_dz00_11548)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11543;long BgL_siza7ezd2framez75_11544;
BgL_runz00_11543 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11540, 
(int)(((long)2)))); 
BgL_siza7ezd2framez75_11544 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11540, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13707;
BgL_sz00_13707 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13708;
BgL_bpz00_13708 = 
VECTOR_REF(
((obj_t)BgL_sz00_13707),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13707, BgL_bpz00_13708, 
BINT(BgL_siza7ezd2framez75_11544)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3494z00_13709;
BgL_arg3494z00_13709 = 
(
(long)CINT(BgL_bpz00_13708)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13707),BgL_arg3494z00_13709,BgL_az00_11545); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3495z00_13710;
BgL_arg3495z00_13710 = 
(
(long)CINT(BgL_bpz00_13708)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13707),BgL_arg3495z00_13710,BgL_bz00_11546); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3496z00_13711;
BgL_arg3496z00_13711 = 
(
(long)CINT(BgL_bpz00_13708)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13707),BgL_arg3496z00_13711,BgL_cz00_11547); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3497z00_13712;
BgL_arg3497z00_13712 = 
(
(long)CINT(BgL_bpz00_13708)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_13707),BgL_arg3497z00_13712,BgL_dz00_11548); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13713;
BgL_ez00_13713 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13713, BgL_bpz00_13708); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13714;
BgL_accz00_13714 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11543, BgL_sz00_13707, BgL_bpz00_13708); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13713); 
VECTOR_SET(
((obj_t)BgL_sz00_13707),((long)0),BgL_bpz00_13708); 
return BgL_accz00_13714;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13715;
BgL_nsz00_13715 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13715,((long)1),BgL_sz00_13707); 
VECTOR_SET(BgL_nsz00_13715,((long)2),BgL_az00_11545); 
VECTOR_SET(BgL_nsz00_13715,((long)3),BgL_bz00_11546); 
VECTOR_SET(BgL_nsz00_13715,((long)4),BgL_cz00_11547); 
VECTOR_SET(BgL_nsz00_13715,((long)5),BgL_dz00_11548); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13716;
BgL_z12denvz12_13716 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13716, BgL_nsz00_13715); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13717;
BgL_ez00_13717 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13717, BgL_sz00_13707); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13718;
BgL_____rz00_13718 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11543, BgL_nsz00_13715, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13717); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13716, BgL_sz00_13707); 
return BgL_____rz00_13718;} } } } } } } } 

}



/* &run5117 */
obj_t BGl_z62run5117z62zz__evaluate_compz00(obj_t BgL_envz00_11549, obj_t BgL_sz00_11552)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_11550;obj_t BgL_bodyz00_11551;
BgL_i1244z00_11550 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11549, 
(int)(((long)0)))); 
BgL_bodyz00_11551 = 
PROCEDURE_REF(BgL_envz00_11549, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13719;
BgL_bpz00_13719 = 
VECTOR_REF(
((obj_t)BgL_sz00_11552),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13720;obj_t BgL_wherez00_13721;obj_t BgL_locz00_13722;
BgL_z12denvz12_13720 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13721 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11550))->BgL_wherez00); 
BgL_locz00_13722 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11550))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13720, BgL_wherez00_13721, BgL_locz00_13722); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_13723;
BgL_za2za2resza2za2z00_13723 = 
PROCEDURE_ENTRY(BgL_bodyz00_11551)(BgL_bodyz00_11551, BgL_sz00_11552, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13720); 
return BgL_za2za2resza2za2z00_13723;} } } } } } 

}



/* &<@anonymous:3499> */
obj_t BGl_z62zc3z04anonymousza33499ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11553, obj_t BgL_sz00_11558)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11554;BgL_ev_absz00_bglt BgL_i1244z00_11555;obj_t BgL_bodyz00_11556;long BgL_siza7ezd2framez75_11557;
BgL_iboxesz00_11554 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11553, 
(int)(((long)0)))); 
BgL_i1244z00_11555 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11553, 
(int)(((long)1)))); 
BgL_bodyz00_11556 = 
PROCEDURE_REF(BgL_envz00_11553, 
(int)(((long)2))); 
BgL_siza7ezd2framez75_11557 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11553, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13724;
BgL_bpz00_13724 = 
VECTOR_REF(
((obj_t)BgL_sz00_11558),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13725;
BgL_runz00_13725 = 
MAKE_FX_PROCEDURE(BGl_z62run5119z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_runz00_13725, 
(int)(((long)0)), BgL_iboxesz00_11554); 
PROCEDURE_SET(BgL_runz00_13725, 
(int)(((long)1)), 
((obj_t)BgL_i1244z00_11555)); 
PROCEDURE_SET(BgL_runz00_13725, 
(int)(((long)2)), BgL_bodyz00_11556); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13726;
BgL_mainz00_13726 = 
MAKE_FX_PROCEDURE(BGl_z62main5118z62zz__evaluate_compz00, 
(int)(((long)4)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_mainz00_13726, 
(int)(((long)0)), BgL_iboxesz00_11554); 
PROCEDURE_SET(BgL_mainz00_13726, 
(int)(((long)1)), 
((obj_t)BgL_i1244z00_11555)); 
PROCEDURE_SET(BgL_mainz00_13726, 
(int)(((long)2)), BgL_bodyz00_11556); 
PROCEDURE_SET(BgL_mainz00_13726, 
(int)(((long)3)), BgL_runz00_13725); 
PROCEDURE_SET(BgL_mainz00_13726, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_11557)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13727;
BgL_objz00_13727 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13725, BgL_objz00_13727); BgL_objz00_13727; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3500z00_13728;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3501z00_13729;
BgL_arg3501z00_13729 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11555))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13730;
BgL_newz00_13730 = 
create_struct(BGl_symbol5225z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_23110;
BgL_tmpz00_23110 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13730, BgL_tmpz00_23110, BgL_arg3501z00_13729); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_23115;int BgL_tmpz00_23113;
BgL_auxz00_23115 = 
BINT(BgL_siza7ezd2framez75_11557); 
BgL_tmpz00_23113 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13730, BgL_tmpz00_23113, BgL_auxz00_23115); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_23118;
BgL_tmpz00_23118 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13730, BgL_tmpz00_23118, BgL_runz00_13725); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_23123;int BgL_tmpz00_23121;
BgL_auxz00_23123 = 
BINT(((long)4)); 
BgL_tmpz00_23121 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13730, BgL_tmpz00_23121, BgL_auxz00_23123); } 
BgL_arg3500z00_13728 = BgL_newz00_13730; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13726, BgL_arg3500z00_13728); BgL_arg3500z00_13728; } 
return BgL_mainz00_13726;} } } } } } 

}



/* &main5118 */
obj_t BGl_z62main5118z62zz__evaluate_compz00(obj_t BgL_envz00_11559, obj_t BgL_az00_11565, obj_t BgL_bz00_11566, obj_t BgL_cz00_11567, obj_t BgL_dz00_11568)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11563;long BgL_siza7ezd2framez75_11564;
BgL_runz00_11563 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11559, 
(int)(((long)3)))); 
BgL_siza7ezd2framez75_11564 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11559, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13731;
BgL_sz00_13731 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13732;
BgL_bpz00_13732 = 
VECTOR_REF(
((obj_t)BgL_sz00_13731),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13731, BgL_bpz00_13732, 
BINT(BgL_siza7ezd2framez75_11564)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3504z00_13733;
BgL_arg3504z00_13733 = 
(
(long)CINT(BgL_bpz00_13732)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13731),BgL_arg3504z00_13733,BgL_az00_11565); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3505z00_13734;
BgL_arg3505z00_13734 = 
(
(long)CINT(BgL_bpz00_13732)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13731),BgL_arg3505z00_13734,BgL_bz00_11566); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3506z00_13735;
BgL_arg3506z00_13735 = 
(
(long)CINT(BgL_bpz00_13732)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13731),BgL_arg3506z00_13735,BgL_cz00_11567); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3507z00_13736;
BgL_arg3507z00_13736 = 
(
(long)CINT(BgL_bpz00_13732)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_13731),BgL_arg3507z00_13736,BgL_dz00_11568); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13737;
BgL_ez00_13737 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13737, BgL_bpz00_13732); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13738;
BgL_accz00_13738 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11563, BgL_sz00_13731, BgL_bpz00_13732); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13737); 
VECTOR_SET(
((obj_t)BgL_sz00_13731),((long)0),BgL_bpz00_13732); 
return BgL_accz00_13738;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13739;
BgL_nsz00_13739 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13739,((long)1),BgL_sz00_13731); 
VECTOR_SET(BgL_nsz00_13739,((long)2),BgL_az00_11565); 
VECTOR_SET(BgL_nsz00_13739,((long)3),BgL_bz00_11566); 
VECTOR_SET(BgL_nsz00_13739,((long)4),BgL_cz00_11567); 
VECTOR_SET(BgL_nsz00_13739,((long)5),BgL_dz00_11568); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13740;
BgL_z12denvz12_13740 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13740, BgL_nsz00_13739); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13741;
BgL_ez00_13741 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13741, BgL_sz00_13731); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13742;
BgL_____rz00_13742 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11563, BgL_nsz00_13739, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13741); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13740, BgL_sz00_13731); 
return BgL_____rz00_13742;} } } } } } } } 

}



/* &run5119 */
obj_t BGl_z62run5119z62zz__evaluate_compz00(obj_t BgL_envz00_11569, obj_t BgL_sz00_11573)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11570;BgL_ev_absz00_bglt BgL_i1244z00_11571;obj_t BgL_bodyz00_11572;
BgL_iboxesz00_11570 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11569, 
(int)(((long)0)))); 
BgL_i1244z00_11571 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11569, 
(int)(((long)1)))); 
BgL_bodyz00_11572 = 
PROCEDURE_REF(BgL_envz00_11569, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13743;
BgL_bpz00_13743 = 
VECTOR_REF(
((obj_t)BgL_sz00_11573),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_11573, BgL_iboxesz00_11570, BgL_bpz00_13743); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13744;obj_t BgL_wherez00_13745;obj_t BgL_locz00_13746;
BgL_z12denvz12_13744 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13745 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11571))->BgL_wherez00); 
BgL_locz00_13746 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11571))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13744, BgL_wherez00_13745, BgL_locz00_13746); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_13747;
BgL_za2za2resza2za2z00_13747 = 
PROCEDURE_ENTRY(BgL_bodyz00_11572)(BgL_bodyz00_11572, BgL_sz00_11573, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13744); 
return BgL_za2za2resza2za2z00_13747;} } } } } } 

}



/* &<@anonymous:3512> */
obj_t BGl_z62zc3z04anonymousza33512ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11574, obj_t BgL_sz00_11580)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_11575;long BgL_siza7eza7_11576;BgL_ev_absz00_bglt BgL_i1244z00_11577;obj_t BgL_bodyz00_11578;long BgL_siza7ezd2framez75_11579;
BgL_ifreesz00_11575 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11574, 
(int)(((long)0)))); 
BgL_siza7eza7_11576 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11574, 
(int)(((long)1)))); 
BgL_i1244z00_11577 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11574, 
(int)(((long)2)))); 
BgL_bodyz00_11578 = 
PROCEDURE_REF(BgL_envz00_11574, 
(int)(((long)3))); 
BgL_siza7ezd2framez75_11579 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11574, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13748;
BgL_bpz00_13748 = 
VECTOR_REF(
((obj_t)BgL_sz00_11580),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_13749;
BgL_valza2za2_13749 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_11580, BgL_bpz00_13748, BgL_ifreesz00_11575); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13750;
BgL_runz00_13750 = 
MAKE_FX_PROCEDURE(BGl_z62run5121z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_runz00_13750, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_11576)); 
PROCEDURE_SET(BgL_runz00_13750, 
(int)(((long)1)), BgL_valza2za2_13749); 
PROCEDURE_SET(BgL_runz00_13750, 
(int)(((long)2)), 
((obj_t)BgL_i1244z00_11577)); 
PROCEDURE_SET(BgL_runz00_13750, 
(int)(((long)3)), BgL_bodyz00_11578); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13751;
BgL_mainz00_13751 = 
MAKE_FX_PROCEDURE(BGl_z62main5120z62zz__evaluate_compz00, 
(int)(((long)4)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_mainz00_13751, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_11576)); 
PROCEDURE_SET(BgL_mainz00_13751, 
(int)(((long)1)), BgL_valza2za2_13749); 
PROCEDURE_SET(BgL_mainz00_13751, 
(int)(((long)2)), 
((obj_t)BgL_i1244z00_11577)); 
PROCEDURE_SET(BgL_mainz00_13751, 
(int)(((long)3)), BgL_bodyz00_11578); 
PROCEDURE_SET(BgL_mainz00_13751, 
(int)(((long)4)), BgL_runz00_13750); 
PROCEDURE_SET(BgL_mainz00_13751, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_11579)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13752;
BgL_objz00_13752 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13750, BgL_objz00_13752); BgL_objz00_13752; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3513z00_13753;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3514z00_13754;
BgL_arg3514z00_13754 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11577))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13755;
BgL_newz00_13755 = 
create_struct(BGl_symbol5225z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_23247;
BgL_tmpz00_23247 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13755, BgL_tmpz00_23247, BgL_arg3514z00_13754); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_23252;int BgL_tmpz00_23250;
BgL_auxz00_23252 = 
BINT(BgL_siza7ezd2framez75_11579); 
BgL_tmpz00_23250 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13755, BgL_tmpz00_23250, BgL_auxz00_23252); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_23255;
BgL_tmpz00_23255 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13755, BgL_tmpz00_23255, BgL_runz00_13750); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_23260;int BgL_tmpz00_23258;
BgL_auxz00_23260 = 
BINT(((long)4)); 
BgL_tmpz00_23258 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13755, BgL_tmpz00_23258, BgL_auxz00_23260); } 
BgL_arg3513z00_13753 = BgL_newz00_13755; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13751, BgL_arg3513z00_13753); BgL_arg3513z00_13753; } 
return BgL_mainz00_13751;} } } } } } 

}



/* &main5120 */
obj_t BGl_z62main5120z62zz__evaluate_compz00(obj_t BgL_envz00_11581, obj_t BgL_az00_11588, obj_t BgL_bz00_11589, obj_t BgL_cz00_11590, obj_t BgL_dz00_11591)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11586;long BgL_siza7ezd2framez75_11587;
BgL_runz00_11586 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11581, 
(int)(((long)4)))); 
BgL_siza7ezd2framez75_11587 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11581, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13756;
BgL_sz00_13756 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13757;
BgL_bpz00_13757 = 
VECTOR_REF(
((obj_t)BgL_sz00_13756),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13756, BgL_bpz00_13757, 
BINT(BgL_siza7ezd2framez75_11587)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3517z00_13758;
BgL_arg3517z00_13758 = 
(
(long)CINT(BgL_bpz00_13757)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13756),BgL_arg3517z00_13758,BgL_az00_11588); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3518z00_13759;
BgL_arg3518z00_13759 = 
(
(long)CINT(BgL_bpz00_13757)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13756),BgL_arg3518z00_13759,BgL_bz00_11589); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3519z00_13760;
BgL_arg3519z00_13760 = 
(
(long)CINT(BgL_bpz00_13757)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13756),BgL_arg3519z00_13760,BgL_cz00_11590); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3520z00_13761;
BgL_arg3520z00_13761 = 
(
(long)CINT(BgL_bpz00_13757)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_13756),BgL_arg3520z00_13761,BgL_dz00_11591); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13762;
BgL_ez00_13762 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13762, BgL_bpz00_13757); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13763;
BgL_accz00_13763 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11586, BgL_sz00_13756, BgL_bpz00_13757); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13762); 
VECTOR_SET(
((obj_t)BgL_sz00_13756),((long)0),BgL_bpz00_13757); 
return BgL_accz00_13763;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13764;
BgL_nsz00_13764 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13764,((long)1),BgL_sz00_13756); 
VECTOR_SET(BgL_nsz00_13764,((long)2),BgL_az00_11588); 
VECTOR_SET(BgL_nsz00_13764,((long)3),BgL_bz00_11589); 
VECTOR_SET(BgL_nsz00_13764,((long)4),BgL_cz00_11590); 
VECTOR_SET(BgL_nsz00_13764,((long)5),BgL_dz00_11591); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13765;
BgL_z12denvz12_13765 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13765, BgL_nsz00_13764); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13766;
BgL_ez00_13766 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13766, BgL_sz00_13756); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13767;
BgL_____rz00_13767 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11586, BgL_nsz00_13764, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13766); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13765, BgL_sz00_13756); 
return BgL_____rz00_13767;} } } } } } } } 

}



/* &run5121 */
obj_t BGl_z62run5121z62zz__evaluate_compz00(obj_t BgL_envz00_11592, obj_t BgL_sz00_11597)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_siza7eza7_11593;obj_t BgL_valza2za2_11594;BgL_ev_absz00_bglt BgL_i1244z00_11595;obj_t BgL_bodyz00_11596;
BgL_siza7eza7_11593 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11592, 
(int)(((long)0)))); 
BgL_valza2za2_11594 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11592, 
(int)(((long)1)))); 
BgL_i1244z00_11595 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11592, 
(int)(((long)2)))); 
BgL_bodyz00_11596 = 
PROCEDURE_REF(BgL_envz00_11592, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13768;
BgL_bpz00_13768 = 
VECTOR_REF(
((obj_t)BgL_sz00_11597),((long)0)); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_11597, BgL_valza2za2_11594, 
(
(long)CINT(BgL_bpz00_13768)+BgL_siza7eza7_11593)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_13769;obj_t BgL_wherez00_13770;obj_t BgL_locz00_13771;
BgL_z12denvz12_13769 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13770 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11595))->BgL_wherez00); 
BgL_locz00_13771 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11595))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13769, BgL_wherez00_13770, BgL_locz00_13771); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_13772;
BgL_za2za2resza2za2z00_13772 = 
PROCEDURE_ENTRY(BgL_bodyz00_11596)(BgL_bodyz00_11596, BgL_sz00_11597, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13769); 
return BgL_za2za2resza2za2z00_13772;} } } } } } 

}



/* &<@anonymous:3523> */
obj_t BGl_z62zc3z04anonymousza33523ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11598, obj_t BgL_sz00_11605)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_11599;obj_t BgL_iboxesz00_11600;long BgL_siza7eza7_11601;BgL_ev_absz00_bglt BgL_i1244z00_11602;obj_t BgL_bodyz00_11603;long BgL_siza7ezd2framez75_11604;
BgL_ifreesz00_11599 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11598, 
(int)(((long)0)))); 
BgL_iboxesz00_11600 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11598, 
(int)(((long)1)))); 
BgL_siza7eza7_11601 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11598, 
(int)(((long)2)))); 
BgL_i1244z00_11602 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11598, 
(int)(((long)3)))); 
BgL_bodyz00_11603 = 
PROCEDURE_REF(BgL_envz00_11598, 
(int)(((long)4))); 
BgL_siza7ezd2framez75_11604 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11598, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13773;
BgL_bpz00_13773 = 
VECTOR_REF(
((obj_t)BgL_sz00_11605),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_13774;
BgL_valza2za2_13774 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_11605, BgL_bpz00_13773, BgL_ifreesz00_11599); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13775;
BgL_runz00_13775 = 
MAKE_FX_PROCEDURE(BGl_z62run5123z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_runz00_13775, 
(int)(((long)0)), BgL_iboxesz00_11600); 
PROCEDURE_SET(BgL_runz00_13775, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_11601)); 
PROCEDURE_SET(BgL_runz00_13775, 
(int)(((long)2)), BgL_valza2za2_13774); 
PROCEDURE_SET(BgL_runz00_13775, 
(int)(((long)3)), 
((obj_t)BgL_i1244z00_11602)); 
PROCEDURE_SET(BgL_runz00_13775, 
(int)(((long)4)), BgL_bodyz00_11603); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13776;
BgL_mainz00_13776 = 
MAKE_FX_PROCEDURE(BGl_z62main5122z62zz__evaluate_compz00, 
(int)(((long)4)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_mainz00_13776, 
(int)(((long)0)), BgL_iboxesz00_11600); 
PROCEDURE_SET(BgL_mainz00_13776, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_11601)); 
PROCEDURE_SET(BgL_mainz00_13776, 
(int)(((long)2)), BgL_valza2za2_13774); 
PROCEDURE_SET(BgL_mainz00_13776, 
(int)(((long)3)), 
((obj_t)BgL_i1244z00_11602)); 
PROCEDURE_SET(BgL_mainz00_13776, 
(int)(((long)4)), BgL_bodyz00_11603); 
PROCEDURE_SET(BgL_mainz00_13776, 
(int)(((long)5)), BgL_runz00_13775); 
PROCEDURE_SET(BgL_mainz00_13776, 
(int)(((long)6)), 
BINT(BgL_siza7ezd2framez75_11604)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13777;
BgL_objz00_13777 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13775, BgL_objz00_13777); BgL_objz00_13777; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3524z00_13778;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3525z00_13779;
BgL_arg3525z00_13779 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11602))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13780;
BgL_newz00_13780 = 
create_struct(BGl_symbol5225z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_23396;
BgL_tmpz00_23396 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13780, BgL_tmpz00_23396, BgL_arg3525z00_13779); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_23401;int BgL_tmpz00_23399;
BgL_auxz00_23401 = 
BINT(BgL_siza7ezd2framez75_11604); 
BgL_tmpz00_23399 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13780, BgL_tmpz00_23399, BgL_auxz00_23401); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_23404;
BgL_tmpz00_23404 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13780, BgL_tmpz00_23404, BgL_runz00_13775); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_23409;int BgL_tmpz00_23407;
BgL_auxz00_23409 = 
BINT(((long)4)); 
BgL_tmpz00_23407 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13780, BgL_tmpz00_23407, BgL_auxz00_23409); } 
BgL_arg3524z00_13778 = BgL_newz00_13780; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13776, BgL_arg3524z00_13778); BgL_arg3524z00_13778; } 
return BgL_mainz00_13776;} } } } } } 

}



/* &main5122 */
obj_t BGl_z62main5122z62zz__evaluate_compz00(obj_t BgL_envz00_11606, obj_t BgL_az00_11614, obj_t BgL_bz00_11615, obj_t BgL_cz00_11616, obj_t BgL_dz00_11617)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11612;long BgL_siza7ezd2framez75_11613;
BgL_runz00_11612 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11606, 
(int)(((long)5)))); 
BgL_siza7ezd2framez75_11613 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11606, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13781;
BgL_sz00_13781 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13782;
BgL_bpz00_13782 = 
VECTOR_REF(
((obj_t)BgL_sz00_13781),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13781, BgL_bpz00_13782, 
BINT(BgL_siza7ezd2framez75_11613)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3528z00_13783;
BgL_arg3528z00_13783 = 
(
(long)CINT(BgL_bpz00_13782)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13781),BgL_arg3528z00_13783,BgL_az00_11614); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3529z00_13784;
BgL_arg3529z00_13784 = 
(
(long)CINT(BgL_bpz00_13782)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13781),BgL_arg3529z00_13784,BgL_bz00_11615); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3530z00_13785;
BgL_arg3530z00_13785 = 
(
(long)CINT(BgL_bpz00_13782)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13781),BgL_arg3530z00_13785,BgL_cz00_11616); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3531z00_13786;
BgL_arg3531z00_13786 = 
(
(long)CINT(BgL_bpz00_13782)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_13781),BgL_arg3531z00_13786,BgL_dz00_11617); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13787;
BgL_ez00_13787 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13787, BgL_bpz00_13782); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13788;
BgL_accz00_13788 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11612, BgL_sz00_13781, BgL_bpz00_13782); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13787); 
VECTOR_SET(
((obj_t)BgL_sz00_13781),((long)0),BgL_bpz00_13782); 
return BgL_accz00_13788;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13789;
BgL_nsz00_13789 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13789,((long)1),BgL_sz00_13781); 
VECTOR_SET(BgL_nsz00_13789,((long)2),BgL_az00_11614); 
VECTOR_SET(BgL_nsz00_13789,((long)3),BgL_bz00_11615); 
VECTOR_SET(BgL_nsz00_13789,((long)4),BgL_cz00_11616); 
VECTOR_SET(BgL_nsz00_13789,((long)5),BgL_dz00_11617); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13790;
BgL_z12denvz12_13790 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13790, BgL_nsz00_13789); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13791;
BgL_ez00_13791 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13791, BgL_sz00_13781); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13792;
BgL_____rz00_13792 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11612, BgL_nsz00_13789, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13791); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13790, BgL_sz00_13781); 
return BgL_____rz00_13792;} } } } } } } } 

}



/* &run5123 */
obj_t BGl_z62run5123z62zz__evaluate_compz00(obj_t BgL_envz00_11618, obj_t BgL_sz00_11624)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11619;long BgL_siza7eza7_11620;obj_t BgL_valza2za2_11621;BgL_ev_absz00_bglt BgL_i1244z00_11622;obj_t BgL_bodyz00_11623;
BgL_iboxesz00_11619 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11618, 
(int)(((long)0)))); 
BgL_siza7eza7_11620 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11618, 
(int)(((long)1)))); 
BgL_valza2za2_11621 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11618, 
(int)(((long)2)))); 
BgL_i1244z00_11622 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11618, 
(int)(((long)3)))); 
BgL_bodyz00_11623 = 
PROCEDURE_REF(BgL_envz00_11618, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13793;
BgL_bpz00_13793 = 
VECTOR_REF(
((obj_t)BgL_sz00_11624),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_11624, BgL_iboxesz00_11619, BgL_bpz00_13793); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_11624, BgL_valza2za2_11621, 
(
(long)CINT(BgL_bpz00_13793)+BgL_siza7eza7_11620)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_13794;obj_t BgL_wherez00_13795;obj_t BgL_locz00_13796;
BgL_z12denvz12_13794 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13795 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11622))->BgL_wherez00); 
BgL_locz00_13796 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11622))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13794, BgL_wherez00_13795, BgL_locz00_13796); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_13797;
BgL_za2za2resza2za2z00_13797 = 
PROCEDURE_ENTRY(BgL_bodyz00_11623)(BgL_bodyz00_11623, BgL_sz00_11624, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13794); 
return BgL_za2za2resza2za2z00_13797;} } } } } } 

}



/* &<@anonymous:3438> */
obj_t BGl_z62zc3z04anonymousza33438ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11625, obj_t BgL_sz00_11629)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_11626;obj_t BgL_bodyz00_11627;long BgL_siza7ezd2framez75_11628;
BgL_i1244z00_11626 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11625, 
(int)(((long)0)))); 
BgL_bodyz00_11627 = 
PROCEDURE_REF(BgL_envz00_11625, 
(int)(((long)1))); 
BgL_siza7ezd2framez75_11628 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11625, 
(int)(((long)2)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13798;
BgL_bpz00_13798 = 
VECTOR_REF(
((obj_t)BgL_sz00_11629),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13799;
BgL_runz00_13799 = 
MAKE_FX_PROCEDURE(BGl_z62run5125z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_runz00_13799, 
(int)(((long)0)), 
((obj_t)BgL_i1244z00_11626)); 
PROCEDURE_SET(BgL_runz00_13799, 
(int)(((long)1)), BgL_bodyz00_11627); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13800;
BgL_mainz00_13800 = 
MAKE_VA_PROCEDURE(BGl_z62main5124z62zz__evaluate_compz00, 
(int)(((long)-4)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_mainz00_13800, 
(int)(((long)0)), 
((obj_t)BgL_i1244z00_11626)); 
PROCEDURE_SET(BgL_mainz00_13800, 
(int)(((long)1)), BgL_bodyz00_11627); 
PROCEDURE_SET(BgL_mainz00_13800, 
(int)(((long)2)), BgL_runz00_13799); 
PROCEDURE_SET(BgL_mainz00_13800, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_11628)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13801;
BgL_objz00_13801 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13799, BgL_objz00_13801); BgL_objz00_13801; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3439z00_13802;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3440z00_13803;
BgL_arg3440z00_13803 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11626))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13804;
BgL_newz00_13804 = 
create_struct(BGl_symbol5225z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_23525;
BgL_tmpz00_23525 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13804, BgL_tmpz00_23525, BgL_arg3440z00_13803); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_23530;int BgL_tmpz00_23528;
BgL_auxz00_23530 = 
BINT(BgL_siza7ezd2framez75_11628); 
BgL_tmpz00_23528 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13804, BgL_tmpz00_23528, BgL_auxz00_23530); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_23533;
BgL_tmpz00_23533 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13804, BgL_tmpz00_23533, BgL_runz00_13799); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_23538;int BgL_tmpz00_23536;
BgL_auxz00_23538 = 
BINT(((long)-4)); 
BgL_tmpz00_23536 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13804, BgL_tmpz00_23536, BgL_auxz00_23538); } 
BgL_arg3439z00_13802 = BgL_newz00_13804; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13800, BgL_arg3439z00_13802); BgL_arg3439z00_13802; } 
return BgL_mainz00_13800;} } } } } } 

}



/* &main5124 */
obj_t BGl_z62main5124z62zz__evaluate_compz00(obj_t BgL_envz00_11630, obj_t BgL_bz00_11635, obj_t BgL_cz00_11636, obj_t BgL_dz00_11637, obj_t BgL_lastz00_11638)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11633;long BgL_siza7ezd2framez75_11634;
BgL_runz00_11633 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11630, 
(int)(((long)2)))); 
BgL_siza7ezd2framez75_11634 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11630, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13805;
BgL_sz00_13805 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13806;
BgL_bpz00_13806 = 
VECTOR_REF(
((obj_t)BgL_sz00_13805),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13805, BgL_bpz00_13806, 
BINT(BgL_siza7ezd2framez75_11634)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3443z00_13807;
BgL_arg3443z00_13807 = 
(
(long)CINT(BgL_bpz00_13806)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13805),BgL_arg3443z00_13807,BgL_bz00_11635); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3444z00_13808;
BgL_arg3444z00_13808 = 
(
(long)CINT(BgL_bpz00_13806)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13805),BgL_arg3444z00_13808,BgL_cz00_11636); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3445z00_13809;
BgL_arg3445z00_13809 = 
(
(long)CINT(BgL_bpz00_13806)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13805),BgL_arg3445z00_13809,BgL_dz00_11637); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3446z00_13810;
BgL_arg3446z00_13810 = 
(
(long)CINT(BgL_bpz00_13806)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_13805),BgL_arg3446z00_13810,BgL_lastz00_11638); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13811;
BgL_ez00_13811 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13811, BgL_bpz00_13806); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13812;
BgL_accz00_13812 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11633, BgL_sz00_13805, BgL_bpz00_13806); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13811); 
VECTOR_SET(
((obj_t)BgL_sz00_13805),((long)0),BgL_bpz00_13806); 
return BgL_accz00_13812;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13813;
BgL_nsz00_13813 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13813,((long)1),BgL_sz00_13805); 
VECTOR_SET(BgL_nsz00_13813,((long)2),BgL_bz00_11635); 
VECTOR_SET(BgL_nsz00_13813,((long)3),BgL_cz00_11636); 
VECTOR_SET(BgL_nsz00_13813,((long)4),BgL_dz00_11637); 
VECTOR_SET(BgL_nsz00_13813,((long)5),BgL_lastz00_11638); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13814;
BgL_z12denvz12_13814 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13814, BgL_nsz00_13813); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13815;
BgL_ez00_13815 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13815, BgL_sz00_13805); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13816;
BgL_____rz00_13816 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11633, BgL_nsz00_13813, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13815); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13814, BgL_sz00_13805); 
return BgL_____rz00_13816;} } } } } } } } 

}



/* &run5125 */
obj_t BGl_z62run5125z62zz__evaluate_compz00(obj_t BgL_envz00_11639, obj_t BgL_sz00_11642)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_11640;obj_t BgL_bodyz00_11641;
BgL_i1244z00_11640 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11639, 
(int)(((long)0)))); 
BgL_bodyz00_11641 = 
PROCEDURE_REF(BgL_envz00_11639, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13817;
BgL_bpz00_13817 = 
VECTOR_REF(
((obj_t)BgL_sz00_11642),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13818;obj_t BgL_wherez00_13819;obj_t BgL_locz00_13820;
BgL_z12denvz12_13818 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13819 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11640))->BgL_wherez00); 
BgL_locz00_13820 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11640))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13818, BgL_wherez00_13819, BgL_locz00_13820); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_13821;
BgL_za2za2resza2za2z00_13821 = 
PROCEDURE_ENTRY(BgL_bodyz00_11641)(BgL_bodyz00_11641, BgL_sz00_11642, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13818); 
return BgL_za2za2resza2za2z00_13821;} } } } } } 

}



/* &<@anonymous:3448> */
obj_t BGl_z62zc3z04anonymousza33448ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11643, obj_t BgL_sz00_11648)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11644;BgL_ev_absz00_bglt BgL_i1244z00_11645;obj_t BgL_bodyz00_11646;long BgL_siza7ezd2framez75_11647;
BgL_iboxesz00_11644 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11643, 
(int)(((long)0)))); 
BgL_i1244z00_11645 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11643, 
(int)(((long)1)))); 
BgL_bodyz00_11646 = 
PROCEDURE_REF(BgL_envz00_11643, 
(int)(((long)2))); 
BgL_siza7ezd2framez75_11647 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11643, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13822;
BgL_bpz00_13822 = 
VECTOR_REF(
((obj_t)BgL_sz00_11648),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13823;
BgL_runz00_13823 = 
MAKE_FX_PROCEDURE(BGl_z62run5127z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_runz00_13823, 
(int)(((long)0)), BgL_iboxesz00_11644); 
PROCEDURE_SET(BgL_runz00_13823, 
(int)(((long)1)), 
((obj_t)BgL_i1244z00_11645)); 
PROCEDURE_SET(BgL_runz00_13823, 
(int)(((long)2)), BgL_bodyz00_11646); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13824;
BgL_mainz00_13824 = 
MAKE_VA_PROCEDURE(BGl_z62main5126z62zz__evaluate_compz00, 
(int)(((long)-4)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_mainz00_13824, 
(int)(((long)0)), BgL_iboxesz00_11644); 
PROCEDURE_SET(BgL_mainz00_13824, 
(int)(((long)1)), 
((obj_t)BgL_i1244z00_11645)); 
PROCEDURE_SET(BgL_mainz00_13824, 
(int)(((long)2)), BgL_bodyz00_11646); 
PROCEDURE_SET(BgL_mainz00_13824, 
(int)(((long)3)), BgL_runz00_13823); 
PROCEDURE_SET(BgL_mainz00_13824, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_11647)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13825;
BgL_objz00_13825 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13823, BgL_objz00_13825); BgL_objz00_13825; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3449z00_13826;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3450z00_13827;
BgL_arg3450z00_13827 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11645))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13828;
BgL_newz00_13828 = 
create_struct(BGl_symbol5225z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_23648;
BgL_tmpz00_23648 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13828, BgL_tmpz00_23648, BgL_arg3450z00_13827); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_23653;int BgL_tmpz00_23651;
BgL_auxz00_23653 = 
BINT(BgL_siza7ezd2framez75_11647); 
BgL_tmpz00_23651 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13828, BgL_tmpz00_23651, BgL_auxz00_23653); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_23656;
BgL_tmpz00_23656 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13828, BgL_tmpz00_23656, BgL_runz00_13823); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_23661;int BgL_tmpz00_23659;
BgL_auxz00_23661 = 
BINT(((long)-4)); 
BgL_tmpz00_23659 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13828, BgL_tmpz00_23659, BgL_auxz00_23661); } 
BgL_arg3449z00_13826 = BgL_newz00_13828; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13824, BgL_arg3449z00_13826); BgL_arg3449z00_13826; } 
return BgL_mainz00_13824;} } } } } } 

}



/* &main5126 */
obj_t BGl_z62main5126z62zz__evaluate_compz00(obj_t BgL_envz00_11649, obj_t BgL_bz00_11655, obj_t BgL_cz00_11656, obj_t BgL_dz00_11657, obj_t BgL_lastz00_11658)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11653;long BgL_siza7ezd2framez75_11654;
BgL_runz00_11653 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11649, 
(int)(((long)3)))); 
BgL_siza7ezd2framez75_11654 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11649, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13829;
BgL_sz00_13829 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13830;
BgL_bpz00_13830 = 
VECTOR_REF(
((obj_t)BgL_sz00_13829),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13829, BgL_bpz00_13830, 
BINT(BgL_siza7ezd2framez75_11654)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3453z00_13831;
BgL_arg3453z00_13831 = 
(
(long)CINT(BgL_bpz00_13830)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13829),BgL_arg3453z00_13831,BgL_bz00_11655); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3454z00_13832;
BgL_arg3454z00_13832 = 
(
(long)CINT(BgL_bpz00_13830)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13829),BgL_arg3454z00_13832,BgL_cz00_11656); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3455z00_13833;
BgL_arg3455z00_13833 = 
(
(long)CINT(BgL_bpz00_13830)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13829),BgL_arg3455z00_13833,BgL_dz00_11657); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3456z00_13834;
BgL_arg3456z00_13834 = 
(
(long)CINT(BgL_bpz00_13830)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_13829),BgL_arg3456z00_13834,BgL_lastz00_11658); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13835;
BgL_ez00_13835 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13835, BgL_bpz00_13830); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13836;
BgL_accz00_13836 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11653, BgL_sz00_13829, BgL_bpz00_13830); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13835); 
VECTOR_SET(
((obj_t)BgL_sz00_13829),((long)0),BgL_bpz00_13830); 
return BgL_accz00_13836;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13837;
BgL_nsz00_13837 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13837,((long)1),BgL_sz00_13829); 
VECTOR_SET(BgL_nsz00_13837,((long)2),BgL_bz00_11655); 
VECTOR_SET(BgL_nsz00_13837,((long)3),BgL_cz00_11656); 
VECTOR_SET(BgL_nsz00_13837,((long)4),BgL_dz00_11657); 
VECTOR_SET(BgL_nsz00_13837,((long)5),BgL_lastz00_11658); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13838;
BgL_z12denvz12_13838 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13838, BgL_nsz00_13837); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13839;
BgL_ez00_13839 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13839, BgL_sz00_13829); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13840;
BgL_____rz00_13840 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11653, BgL_nsz00_13837, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13839); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13838, BgL_sz00_13829); 
return BgL_____rz00_13840;} } } } } } } } 

}



/* &run5127 */
obj_t BGl_z62run5127z62zz__evaluate_compz00(obj_t BgL_envz00_11659, obj_t BgL_sz00_11663)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11660;BgL_ev_absz00_bglt BgL_i1244z00_11661;obj_t BgL_bodyz00_11662;
BgL_iboxesz00_11660 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11659, 
(int)(((long)0)))); 
BgL_i1244z00_11661 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11659, 
(int)(((long)1)))); 
BgL_bodyz00_11662 = 
PROCEDURE_REF(BgL_envz00_11659, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13841;
BgL_bpz00_13841 = 
VECTOR_REF(
((obj_t)BgL_sz00_11663),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_11663, BgL_iboxesz00_11660, BgL_bpz00_13841); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13842;obj_t BgL_wherez00_13843;obj_t BgL_locz00_13844;
BgL_z12denvz12_13842 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13843 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11661))->BgL_wherez00); 
BgL_locz00_13844 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11661))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13842, BgL_wherez00_13843, BgL_locz00_13844); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_13845;
BgL_za2za2resza2za2z00_13845 = 
PROCEDURE_ENTRY(BgL_bodyz00_11662)(BgL_bodyz00_11662, BgL_sz00_11663, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13842); 
return BgL_za2za2resza2za2z00_13845;} } } } } } 

}



/* &<@anonymous:3461> */
obj_t BGl_z62zc3z04anonymousza33461ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11664, obj_t BgL_sz00_11670)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_11665;long BgL_siza7eza7_11666;BgL_ev_absz00_bglt BgL_i1244z00_11667;obj_t BgL_bodyz00_11668;long BgL_siza7ezd2framez75_11669;
BgL_ifreesz00_11665 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11664, 
(int)(((long)0)))); 
BgL_siza7eza7_11666 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11664, 
(int)(((long)1)))); 
BgL_i1244z00_11667 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11664, 
(int)(((long)2)))); 
BgL_bodyz00_11668 = 
PROCEDURE_REF(BgL_envz00_11664, 
(int)(((long)3))); 
BgL_siza7ezd2framez75_11669 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11664, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13846;
BgL_bpz00_13846 = 
VECTOR_REF(
((obj_t)BgL_sz00_11670),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_13847;
BgL_valza2za2_13847 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_11670, BgL_bpz00_13846, BgL_ifreesz00_11665); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13848;
BgL_runz00_13848 = 
MAKE_FX_PROCEDURE(BGl_z62run5129z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_runz00_13848, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_11666)); 
PROCEDURE_SET(BgL_runz00_13848, 
(int)(((long)1)), BgL_valza2za2_13847); 
PROCEDURE_SET(BgL_runz00_13848, 
(int)(((long)2)), 
((obj_t)BgL_i1244z00_11667)); 
PROCEDURE_SET(BgL_runz00_13848, 
(int)(((long)3)), BgL_bodyz00_11668); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13849;
BgL_mainz00_13849 = 
MAKE_VA_PROCEDURE(BGl_z62main5128z62zz__evaluate_compz00, 
(int)(((long)-4)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_mainz00_13849, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_11666)); 
PROCEDURE_SET(BgL_mainz00_13849, 
(int)(((long)1)), BgL_valza2za2_13847); 
PROCEDURE_SET(BgL_mainz00_13849, 
(int)(((long)2)), 
((obj_t)BgL_i1244z00_11667)); 
PROCEDURE_SET(BgL_mainz00_13849, 
(int)(((long)3)), BgL_bodyz00_11668); 
PROCEDURE_SET(BgL_mainz00_13849, 
(int)(((long)4)), BgL_runz00_13848); 
PROCEDURE_SET(BgL_mainz00_13849, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_11669)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13850;
BgL_objz00_13850 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13848, BgL_objz00_13850); BgL_objz00_13850; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3462z00_13851;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3463z00_13852;
BgL_arg3463z00_13852 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11667))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13853;
BgL_newz00_13853 = 
create_struct(BGl_symbol5225z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_23785;
BgL_tmpz00_23785 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13853, BgL_tmpz00_23785, BgL_arg3463z00_13852); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_23790;int BgL_tmpz00_23788;
BgL_auxz00_23790 = 
BINT(BgL_siza7ezd2framez75_11669); 
BgL_tmpz00_23788 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13853, BgL_tmpz00_23788, BgL_auxz00_23790); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_23793;
BgL_tmpz00_23793 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13853, BgL_tmpz00_23793, BgL_runz00_13848); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_23798;int BgL_tmpz00_23796;
BgL_auxz00_23798 = 
BINT(((long)-4)); 
BgL_tmpz00_23796 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13853, BgL_tmpz00_23796, BgL_auxz00_23798); } 
BgL_arg3462z00_13851 = BgL_newz00_13853; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13849, BgL_arg3462z00_13851); BgL_arg3462z00_13851; } 
return BgL_mainz00_13849;} } } } } } 

}



/* &main5128 */
obj_t BGl_z62main5128z62zz__evaluate_compz00(obj_t BgL_envz00_11671, obj_t BgL_bz00_11678, obj_t BgL_cz00_11679, obj_t BgL_dz00_11680, obj_t BgL_lastz00_11681)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11676;long BgL_siza7ezd2framez75_11677;
BgL_runz00_11676 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11671, 
(int)(((long)4)))); 
BgL_siza7ezd2framez75_11677 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11671, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13854;
BgL_sz00_13854 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13855;
BgL_bpz00_13855 = 
VECTOR_REF(
((obj_t)BgL_sz00_13854),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13854, BgL_bpz00_13855, 
BINT(BgL_siza7ezd2framez75_11677)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3466z00_13856;
BgL_arg3466z00_13856 = 
(
(long)CINT(BgL_bpz00_13855)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13854),BgL_arg3466z00_13856,BgL_bz00_11678); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3467z00_13857;
BgL_arg3467z00_13857 = 
(
(long)CINT(BgL_bpz00_13855)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13854),BgL_arg3467z00_13857,BgL_cz00_11679); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3468z00_13858;
BgL_arg3468z00_13858 = 
(
(long)CINT(BgL_bpz00_13855)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13854),BgL_arg3468z00_13858,BgL_dz00_11680); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3469z00_13859;
BgL_arg3469z00_13859 = 
(
(long)CINT(BgL_bpz00_13855)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_13854),BgL_arg3469z00_13859,BgL_lastz00_11681); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13860;
BgL_ez00_13860 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13860, BgL_bpz00_13855); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13861;
BgL_accz00_13861 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11676, BgL_sz00_13854, BgL_bpz00_13855); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13860); 
VECTOR_SET(
((obj_t)BgL_sz00_13854),((long)0),BgL_bpz00_13855); 
return BgL_accz00_13861;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13862;
BgL_nsz00_13862 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13862,((long)1),BgL_sz00_13854); 
VECTOR_SET(BgL_nsz00_13862,((long)2),BgL_bz00_11678); 
VECTOR_SET(BgL_nsz00_13862,((long)3),BgL_cz00_11679); 
VECTOR_SET(BgL_nsz00_13862,((long)4),BgL_dz00_11680); 
VECTOR_SET(BgL_nsz00_13862,((long)5),BgL_lastz00_11681); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13863;
BgL_z12denvz12_13863 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13863, BgL_nsz00_13862); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13864;
BgL_ez00_13864 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13864, BgL_sz00_13854); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13865;
BgL_____rz00_13865 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11676, BgL_nsz00_13862, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13864); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13863, BgL_sz00_13854); 
return BgL_____rz00_13865;} } } } } } } } 

}



/* &run5129 */
obj_t BGl_z62run5129z62zz__evaluate_compz00(obj_t BgL_envz00_11682, obj_t BgL_sz00_11687)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_siza7eza7_11683;obj_t BgL_valza2za2_11684;BgL_ev_absz00_bglt BgL_i1244z00_11685;obj_t BgL_bodyz00_11686;
BgL_siza7eza7_11683 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11682, 
(int)(((long)0)))); 
BgL_valza2za2_11684 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11682, 
(int)(((long)1)))); 
BgL_i1244z00_11685 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11682, 
(int)(((long)2)))); 
BgL_bodyz00_11686 = 
PROCEDURE_REF(BgL_envz00_11682, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13866;
BgL_bpz00_13866 = 
VECTOR_REF(
((obj_t)BgL_sz00_11687),((long)0)); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_11687, BgL_valza2za2_11684, 
(
(long)CINT(BgL_bpz00_13866)+BgL_siza7eza7_11683)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_13867;obj_t BgL_wherez00_13868;obj_t BgL_locz00_13869;
BgL_z12denvz12_13867 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13868 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11685))->BgL_wherez00); 
BgL_locz00_13869 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11685))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13867, BgL_wherez00_13868, BgL_locz00_13869); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_13870;
BgL_za2za2resza2za2z00_13870 = 
PROCEDURE_ENTRY(BgL_bodyz00_11686)(BgL_bodyz00_11686, BgL_sz00_11687, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13867); 
return BgL_za2za2resza2za2z00_13870;} } } } } } 

}



/* &<@anonymous:3472> */
obj_t BGl_z62zc3z04anonymousza33472ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11688, obj_t BgL_sz00_11695)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_11689;obj_t BgL_iboxesz00_11690;long BgL_siza7eza7_11691;BgL_ev_absz00_bglt BgL_i1244z00_11692;obj_t BgL_bodyz00_11693;long BgL_siza7ezd2framez75_11694;
BgL_ifreesz00_11689 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11688, 
(int)(((long)0)))); 
BgL_iboxesz00_11690 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11688, 
(int)(((long)1)))); 
BgL_siza7eza7_11691 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11688, 
(int)(((long)2)))); 
BgL_i1244z00_11692 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11688, 
(int)(((long)3)))); 
BgL_bodyz00_11693 = 
PROCEDURE_REF(BgL_envz00_11688, 
(int)(((long)4))); 
BgL_siza7ezd2framez75_11694 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11688, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13871;
BgL_bpz00_13871 = 
VECTOR_REF(
((obj_t)BgL_sz00_11695),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_13872;
BgL_valza2za2_13872 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_11695, BgL_bpz00_13871, BgL_ifreesz00_11689); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13873;
BgL_runz00_13873 = 
MAKE_FX_PROCEDURE(BGl_z62run5131z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_runz00_13873, 
(int)(((long)0)), BgL_iboxesz00_11690); 
PROCEDURE_SET(BgL_runz00_13873, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_11691)); 
PROCEDURE_SET(BgL_runz00_13873, 
(int)(((long)2)), BgL_valza2za2_13872); 
PROCEDURE_SET(BgL_runz00_13873, 
(int)(((long)3)), 
((obj_t)BgL_i1244z00_11692)); 
PROCEDURE_SET(BgL_runz00_13873, 
(int)(((long)4)), BgL_bodyz00_11693); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13874;
BgL_mainz00_13874 = 
MAKE_VA_PROCEDURE(BGl_z62main5130z62zz__evaluate_compz00, 
(int)(((long)-4)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_mainz00_13874, 
(int)(((long)0)), BgL_iboxesz00_11690); 
PROCEDURE_SET(BgL_mainz00_13874, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_11691)); 
PROCEDURE_SET(BgL_mainz00_13874, 
(int)(((long)2)), BgL_valza2za2_13872); 
PROCEDURE_SET(BgL_mainz00_13874, 
(int)(((long)3)), 
((obj_t)BgL_i1244z00_11692)); 
PROCEDURE_SET(BgL_mainz00_13874, 
(int)(((long)4)), BgL_bodyz00_11693); 
PROCEDURE_SET(BgL_mainz00_13874, 
(int)(((long)5)), BgL_runz00_13873); 
PROCEDURE_SET(BgL_mainz00_13874, 
(int)(((long)6)), 
BINT(BgL_siza7ezd2framez75_11694)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13875;
BgL_objz00_13875 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13873, BgL_objz00_13875); BgL_objz00_13875; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3473z00_13876;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3474z00_13877;
BgL_arg3474z00_13877 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11692))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13878;
BgL_newz00_13878 = 
create_struct(BGl_symbol5225z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_23934;
BgL_tmpz00_23934 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13878, BgL_tmpz00_23934, BgL_arg3474z00_13877); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_23939;int BgL_tmpz00_23937;
BgL_auxz00_23939 = 
BINT(BgL_siza7ezd2framez75_11694); 
BgL_tmpz00_23937 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13878, BgL_tmpz00_23937, BgL_auxz00_23939); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_23942;
BgL_tmpz00_23942 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13878, BgL_tmpz00_23942, BgL_runz00_13873); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_23947;int BgL_tmpz00_23945;
BgL_auxz00_23947 = 
BINT(((long)-4)); 
BgL_tmpz00_23945 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13878, BgL_tmpz00_23945, BgL_auxz00_23947); } 
BgL_arg3473z00_13876 = BgL_newz00_13878; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13874, BgL_arg3473z00_13876); BgL_arg3473z00_13876; } 
return BgL_mainz00_13874;} } } } } } 

}



/* &main5130 */
obj_t BGl_z62main5130z62zz__evaluate_compz00(obj_t BgL_envz00_11696, obj_t BgL_bz00_11704, obj_t BgL_cz00_11705, obj_t BgL_dz00_11706, obj_t BgL_lastz00_11707)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11702;long BgL_siza7ezd2framez75_11703;
BgL_runz00_11702 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11696, 
(int)(((long)5)))); 
BgL_siza7ezd2framez75_11703 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11696, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13879;
BgL_sz00_13879 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13880;
BgL_bpz00_13880 = 
VECTOR_REF(
((obj_t)BgL_sz00_13879),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13879, BgL_bpz00_13880, 
BINT(BgL_siza7ezd2framez75_11703)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3477z00_13881;
BgL_arg3477z00_13881 = 
(
(long)CINT(BgL_bpz00_13880)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13879),BgL_arg3477z00_13881,BgL_bz00_11704); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3478z00_13882;
BgL_arg3478z00_13882 = 
(
(long)CINT(BgL_bpz00_13880)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13879),BgL_arg3478z00_13882,BgL_cz00_11705); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3479z00_13883;
BgL_arg3479z00_13883 = 
(
(long)CINT(BgL_bpz00_13880)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13879),BgL_arg3479z00_13883,BgL_dz00_11706); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3480z00_13884;
BgL_arg3480z00_13884 = 
(
(long)CINT(BgL_bpz00_13880)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_13879),BgL_arg3480z00_13884,BgL_lastz00_11707); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13885;
BgL_ez00_13885 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13885, BgL_bpz00_13880); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13886;
BgL_accz00_13886 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11702, BgL_sz00_13879, BgL_bpz00_13880); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13885); 
VECTOR_SET(
((obj_t)BgL_sz00_13879),((long)0),BgL_bpz00_13880); 
return BgL_accz00_13886;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13887;
BgL_nsz00_13887 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13887,((long)1),BgL_sz00_13879); 
VECTOR_SET(BgL_nsz00_13887,((long)2),BgL_bz00_11704); 
VECTOR_SET(BgL_nsz00_13887,((long)3),BgL_cz00_11705); 
VECTOR_SET(BgL_nsz00_13887,((long)4),BgL_dz00_11706); 
VECTOR_SET(BgL_nsz00_13887,((long)5),BgL_lastz00_11707); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13888;
BgL_z12denvz12_13888 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13888, BgL_nsz00_13887); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13889;
BgL_ez00_13889 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13889, BgL_sz00_13879); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13890;
BgL_____rz00_13890 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11702, BgL_nsz00_13887, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13889); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13888, BgL_sz00_13879); 
return BgL_____rz00_13890;} } } } } } } } 

}



/* &run5131 */
obj_t BGl_z62run5131z62zz__evaluate_compz00(obj_t BgL_envz00_11708, obj_t BgL_sz00_11714)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11709;long BgL_siza7eza7_11710;obj_t BgL_valza2za2_11711;BgL_ev_absz00_bglt BgL_i1244z00_11712;obj_t BgL_bodyz00_11713;
BgL_iboxesz00_11709 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11708, 
(int)(((long)0)))); 
BgL_siza7eza7_11710 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11708, 
(int)(((long)1)))); 
BgL_valza2za2_11711 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11708, 
(int)(((long)2)))); 
BgL_i1244z00_11712 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11708, 
(int)(((long)3)))); 
BgL_bodyz00_11713 = 
PROCEDURE_REF(BgL_envz00_11708, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13891;
BgL_bpz00_13891 = 
VECTOR_REF(
((obj_t)BgL_sz00_11714),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_11714, BgL_iboxesz00_11709, BgL_bpz00_13891); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_11714, BgL_valza2za2_11711, 
(
(long)CINT(BgL_bpz00_13891)+BgL_siza7eza7_11710)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_13892;obj_t BgL_wherez00_13893;obj_t BgL_locz00_13894;
BgL_z12denvz12_13892 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13893 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11712))->BgL_wherez00); 
BgL_locz00_13894 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11712))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13892, BgL_wherez00_13893, BgL_locz00_13894); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_13895;
BgL_za2za2resza2za2z00_13895 = 
PROCEDURE_ENTRY(BgL_bodyz00_11713)(BgL_bodyz00_11713, BgL_sz00_11714, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13892); 
return BgL_za2za2resza2za2z00_13895;} } } } } } 

}



/* &<@anonymous:3391> */
obj_t BGl_z62zc3z04anonymousza33391ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11715, obj_t BgL_sz00_11719)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_11716;obj_t BgL_bodyz00_11717;long BgL_siza7ezd2framez75_11718;
BgL_i1244z00_11716 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11715, 
(int)(((long)0)))); 
BgL_bodyz00_11717 = 
PROCEDURE_REF(BgL_envz00_11715, 
(int)(((long)1))); 
BgL_siza7ezd2framez75_11718 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11715, 
(int)(((long)2)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13896;
BgL_bpz00_13896 = 
VECTOR_REF(
((obj_t)BgL_sz00_11719),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13897;
BgL_runz00_13897 = 
MAKE_FX_PROCEDURE(BGl_z62run5133z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_runz00_13897, 
(int)(((long)0)), 
((obj_t)BgL_i1244z00_11716)); 
PROCEDURE_SET(BgL_runz00_13897, 
(int)(((long)1)), BgL_bodyz00_11717); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13898;
BgL_mainz00_13898 = 
MAKE_FX_PROCEDURE(BGl_z62main5132z62zz__evaluate_compz00, 
(int)(((long)3)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_mainz00_13898, 
(int)(((long)0)), 
((obj_t)BgL_i1244z00_11716)); 
PROCEDURE_SET(BgL_mainz00_13898, 
(int)(((long)1)), BgL_bodyz00_11717); 
PROCEDURE_SET(BgL_mainz00_13898, 
(int)(((long)2)), BgL_runz00_13897); 
PROCEDURE_SET(BgL_mainz00_13898, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_11718)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13899;
BgL_objz00_13899 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13897, BgL_objz00_13899); BgL_objz00_13899; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3392z00_13900;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3393z00_13901;
BgL_arg3393z00_13901 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11716))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13902;
BgL_newz00_13902 = 
create_struct(BGl_symbol5225z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_24063;
BgL_tmpz00_24063 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13902, BgL_tmpz00_24063, BgL_arg3393z00_13901); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_24068;int BgL_tmpz00_24066;
BgL_auxz00_24068 = 
BINT(BgL_siza7ezd2framez75_11718); 
BgL_tmpz00_24066 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13902, BgL_tmpz00_24066, BgL_auxz00_24068); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_24071;
BgL_tmpz00_24071 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13902, BgL_tmpz00_24071, BgL_runz00_13897); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_24076;int BgL_tmpz00_24074;
BgL_auxz00_24076 = 
BINT(((long)3)); 
BgL_tmpz00_24074 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13902, BgL_tmpz00_24074, BgL_auxz00_24076); } 
BgL_arg3392z00_13900 = BgL_newz00_13902; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13898, BgL_arg3392z00_13900); BgL_arg3392z00_13900; } 
return BgL_mainz00_13898;} } } } } } 

}



/* &main5132 */
obj_t BGl_z62main5132z62zz__evaluate_compz00(obj_t BgL_envz00_11720, obj_t BgL_bz00_11725, obj_t BgL_cz00_11726, obj_t BgL_dz00_11727)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11723;long BgL_siza7ezd2framez75_11724;
BgL_runz00_11723 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11720, 
(int)(((long)2)))); 
BgL_siza7ezd2framez75_11724 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11720, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13903;
BgL_sz00_13903 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13904;
BgL_bpz00_13904 = 
VECTOR_REF(
((obj_t)BgL_sz00_13903),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13903, BgL_bpz00_13904, 
BINT(BgL_siza7ezd2framez75_11724)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3396z00_13905;
BgL_arg3396z00_13905 = 
(
(long)CINT(BgL_bpz00_13904)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13903),BgL_arg3396z00_13905,BgL_bz00_11725); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3397z00_13906;
BgL_arg3397z00_13906 = 
(
(long)CINT(BgL_bpz00_13904)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13903),BgL_arg3397z00_13906,BgL_cz00_11726); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3398z00_13907;
BgL_arg3398z00_13907 = 
(
(long)CINT(BgL_bpz00_13904)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13903),BgL_arg3398z00_13907,BgL_dz00_11727); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13908;
BgL_ez00_13908 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13908, BgL_bpz00_13904); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13909;
BgL_accz00_13909 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11723, BgL_sz00_13903, BgL_bpz00_13904); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13908); 
VECTOR_SET(
((obj_t)BgL_sz00_13903),((long)0),BgL_bpz00_13904); 
return BgL_accz00_13909;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13910;
BgL_nsz00_13910 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13910,((long)1),BgL_sz00_13903); 
VECTOR_SET(BgL_nsz00_13910,((long)2),BgL_bz00_11725); 
VECTOR_SET(BgL_nsz00_13910,((long)3),BgL_cz00_11726); 
VECTOR_SET(BgL_nsz00_13910,((long)4),BgL_dz00_11727); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13911;
BgL_z12denvz12_13911 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13911, BgL_nsz00_13910); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13912;
BgL_ez00_13912 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13912, BgL_sz00_13903); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13913;
BgL_____rz00_13913 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11723, BgL_nsz00_13910, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13912); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13911, BgL_sz00_13903); 
return BgL_____rz00_13913;} } } } } } } } 

}



/* &run5133 */
obj_t BGl_z62run5133z62zz__evaluate_compz00(obj_t BgL_envz00_11728, obj_t BgL_sz00_11731)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_11729;obj_t BgL_bodyz00_11730;
BgL_i1244z00_11729 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11728, 
(int)(((long)0)))); 
BgL_bodyz00_11730 = 
PROCEDURE_REF(BgL_envz00_11728, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13914;
BgL_bpz00_13914 = 
VECTOR_REF(
((obj_t)BgL_sz00_11731),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13915;obj_t BgL_wherez00_13916;obj_t BgL_locz00_13917;
BgL_z12denvz12_13915 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13916 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11729))->BgL_wherez00); 
BgL_locz00_13917 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11729))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13915, BgL_wherez00_13916, BgL_locz00_13917); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_13918;
BgL_za2za2resza2za2z00_13918 = 
PROCEDURE_ENTRY(BgL_bodyz00_11730)(BgL_bodyz00_11730, BgL_sz00_11731, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13915); 
return BgL_za2za2resza2za2z00_13918;} } } } } } 

}



/* &<@anonymous:3400> */
obj_t BGl_z62zc3z04anonymousza33400ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11732, obj_t BgL_sz00_11737)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11733;BgL_ev_absz00_bglt BgL_i1244z00_11734;obj_t BgL_bodyz00_11735;long BgL_siza7ezd2framez75_11736;
BgL_iboxesz00_11733 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11732, 
(int)(((long)0)))); 
BgL_i1244z00_11734 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11732, 
(int)(((long)1)))); 
BgL_bodyz00_11735 = 
PROCEDURE_REF(BgL_envz00_11732, 
(int)(((long)2))); 
BgL_siza7ezd2framez75_11736 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11732, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13919;
BgL_bpz00_13919 = 
VECTOR_REF(
((obj_t)BgL_sz00_11737),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13920;
BgL_runz00_13920 = 
MAKE_FX_PROCEDURE(BGl_z62run5135z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_runz00_13920, 
(int)(((long)0)), BgL_iboxesz00_11733); 
PROCEDURE_SET(BgL_runz00_13920, 
(int)(((long)1)), 
((obj_t)BgL_i1244z00_11734)); 
PROCEDURE_SET(BgL_runz00_13920, 
(int)(((long)2)), BgL_bodyz00_11735); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13921;
BgL_mainz00_13921 = 
MAKE_FX_PROCEDURE(BGl_z62main5134z62zz__evaluate_compz00, 
(int)(((long)3)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_mainz00_13921, 
(int)(((long)0)), BgL_iboxesz00_11733); 
PROCEDURE_SET(BgL_mainz00_13921, 
(int)(((long)1)), 
((obj_t)BgL_i1244z00_11734)); 
PROCEDURE_SET(BgL_mainz00_13921, 
(int)(((long)2)), BgL_bodyz00_11735); 
PROCEDURE_SET(BgL_mainz00_13921, 
(int)(((long)3)), BgL_runz00_13920); 
PROCEDURE_SET(BgL_mainz00_13921, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_11736)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13922;
BgL_objz00_13922 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13920, BgL_objz00_13922); BgL_objz00_13922; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3401z00_13923;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3402z00_13924;
BgL_arg3402z00_13924 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11734))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13925;
BgL_newz00_13925 = 
create_struct(BGl_symbol5225z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_24181;
BgL_tmpz00_24181 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13925, BgL_tmpz00_24181, BgL_arg3402z00_13924); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_24186;int BgL_tmpz00_24184;
BgL_auxz00_24186 = 
BINT(BgL_siza7ezd2framez75_11736); 
BgL_tmpz00_24184 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13925, BgL_tmpz00_24184, BgL_auxz00_24186); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_24189;
BgL_tmpz00_24189 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13925, BgL_tmpz00_24189, BgL_runz00_13920); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_24194;int BgL_tmpz00_24192;
BgL_auxz00_24194 = 
BINT(((long)3)); 
BgL_tmpz00_24192 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13925, BgL_tmpz00_24192, BgL_auxz00_24194); } 
BgL_arg3401z00_13923 = BgL_newz00_13925; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13921, BgL_arg3401z00_13923); BgL_arg3401z00_13923; } 
return BgL_mainz00_13921;} } } } } } 

}



/* &main5134 */
obj_t BGl_z62main5134z62zz__evaluate_compz00(obj_t BgL_envz00_11738, obj_t BgL_bz00_11744, obj_t BgL_cz00_11745, obj_t BgL_dz00_11746)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11742;long BgL_siza7ezd2framez75_11743;
BgL_runz00_11742 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11738, 
(int)(((long)3)))); 
BgL_siza7ezd2framez75_11743 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11738, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13926;
BgL_sz00_13926 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13927;
BgL_bpz00_13927 = 
VECTOR_REF(
((obj_t)BgL_sz00_13926),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13926, BgL_bpz00_13927, 
BINT(BgL_siza7ezd2framez75_11743)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3405z00_13928;
BgL_arg3405z00_13928 = 
(
(long)CINT(BgL_bpz00_13927)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13926),BgL_arg3405z00_13928,BgL_bz00_11744); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3406z00_13929;
BgL_arg3406z00_13929 = 
(
(long)CINT(BgL_bpz00_13927)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13926),BgL_arg3406z00_13929,BgL_cz00_11745); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3407z00_13930;
BgL_arg3407z00_13930 = 
(
(long)CINT(BgL_bpz00_13927)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13926),BgL_arg3407z00_13930,BgL_dz00_11746); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13931;
BgL_ez00_13931 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13931, BgL_bpz00_13927); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13932;
BgL_accz00_13932 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11742, BgL_sz00_13926, BgL_bpz00_13927); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13931); 
VECTOR_SET(
((obj_t)BgL_sz00_13926),((long)0),BgL_bpz00_13927); 
return BgL_accz00_13932;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13933;
BgL_nsz00_13933 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13933,((long)1),BgL_sz00_13926); 
VECTOR_SET(BgL_nsz00_13933,((long)2),BgL_bz00_11744); 
VECTOR_SET(BgL_nsz00_13933,((long)3),BgL_cz00_11745); 
VECTOR_SET(BgL_nsz00_13933,((long)4),BgL_dz00_11746); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13934;
BgL_z12denvz12_13934 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13934, BgL_nsz00_13933); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13935;
BgL_ez00_13935 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13935, BgL_sz00_13926); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13936;
BgL_____rz00_13936 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11742, BgL_nsz00_13933, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13935); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13934, BgL_sz00_13926); 
return BgL_____rz00_13936;} } } } } } } } 

}



/* &run5135 */
obj_t BGl_z62run5135z62zz__evaluate_compz00(obj_t BgL_envz00_11747, obj_t BgL_sz00_11751)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11748;BgL_ev_absz00_bglt BgL_i1244z00_11749;obj_t BgL_bodyz00_11750;
BgL_iboxesz00_11748 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11747, 
(int)(((long)0)))); 
BgL_i1244z00_11749 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11747, 
(int)(((long)1)))); 
BgL_bodyz00_11750 = 
PROCEDURE_REF(BgL_envz00_11747, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13937;
BgL_bpz00_13937 = 
VECTOR_REF(
((obj_t)BgL_sz00_11751),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_11751, BgL_iboxesz00_11748, BgL_bpz00_13937); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13938;obj_t BgL_wherez00_13939;obj_t BgL_locz00_13940;
BgL_z12denvz12_13938 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13939 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11749))->BgL_wherez00); 
BgL_locz00_13940 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11749))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13938, BgL_wherez00_13939, BgL_locz00_13940); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_13941;
BgL_za2za2resza2za2z00_13941 = 
PROCEDURE_ENTRY(BgL_bodyz00_11750)(BgL_bodyz00_11750, BgL_sz00_11751, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13938); 
return BgL_za2za2resza2za2z00_13941;} } } } } } 

}



/* &<@anonymous:3412> */
obj_t BGl_z62zc3z04anonymousza33412ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11752, obj_t BgL_sz00_11758)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_11753;long BgL_siza7eza7_11754;BgL_ev_absz00_bglt BgL_i1244z00_11755;obj_t BgL_bodyz00_11756;long BgL_siza7ezd2framez75_11757;
BgL_ifreesz00_11753 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11752, 
(int)(((long)0)))); 
BgL_siza7eza7_11754 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11752, 
(int)(((long)1)))); 
BgL_i1244z00_11755 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11752, 
(int)(((long)2)))); 
BgL_bodyz00_11756 = 
PROCEDURE_REF(BgL_envz00_11752, 
(int)(((long)3))); 
BgL_siza7ezd2framez75_11757 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11752, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13942;
BgL_bpz00_13942 = 
VECTOR_REF(
((obj_t)BgL_sz00_11758),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_13943;
BgL_valza2za2_13943 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_11758, BgL_bpz00_13942, BgL_ifreesz00_11753); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13944;
BgL_runz00_13944 = 
MAKE_FX_PROCEDURE(BGl_z62run5137z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_runz00_13944, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_11754)); 
PROCEDURE_SET(BgL_runz00_13944, 
(int)(((long)1)), BgL_valza2za2_13943); 
PROCEDURE_SET(BgL_runz00_13944, 
(int)(((long)2)), 
((obj_t)BgL_i1244z00_11755)); 
PROCEDURE_SET(BgL_runz00_13944, 
(int)(((long)3)), BgL_bodyz00_11756); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13945;
BgL_mainz00_13945 = 
MAKE_FX_PROCEDURE(BGl_z62main5136z62zz__evaluate_compz00, 
(int)(((long)3)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_mainz00_13945, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_11754)); 
PROCEDURE_SET(BgL_mainz00_13945, 
(int)(((long)1)), BgL_valza2za2_13943); 
PROCEDURE_SET(BgL_mainz00_13945, 
(int)(((long)2)), 
((obj_t)BgL_i1244z00_11755)); 
PROCEDURE_SET(BgL_mainz00_13945, 
(int)(((long)3)), BgL_bodyz00_11756); 
PROCEDURE_SET(BgL_mainz00_13945, 
(int)(((long)4)), BgL_runz00_13944); 
PROCEDURE_SET(BgL_mainz00_13945, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_11757)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13946;
BgL_objz00_13946 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13944, BgL_objz00_13946); BgL_objz00_13946; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3413z00_13947;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3414z00_13948;
BgL_arg3414z00_13948 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11755))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13949;
BgL_newz00_13949 = 
create_struct(BGl_symbol5225z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_24313;
BgL_tmpz00_24313 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13949, BgL_tmpz00_24313, BgL_arg3414z00_13948); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_24318;int BgL_tmpz00_24316;
BgL_auxz00_24318 = 
BINT(BgL_siza7ezd2framez75_11757); 
BgL_tmpz00_24316 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13949, BgL_tmpz00_24316, BgL_auxz00_24318); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_24321;
BgL_tmpz00_24321 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13949, BgL_tmpz00_24321, BgL_runz00_13944); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_24326;int BgL_tmpz00_24324;
BgL_auxz00_24326 = 
BINT(((long)3)); 
BgL_tmpz00_24324 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13949, BgL_tmpz00_24324, BgL_auxz00_24326); } 
BgL_arg3413z00_13947 = BgL_newz00_13949; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13945, BgL_arg3413z00_13947); BgL_arg3413z00_13947; } 
return BgL_mainz00_13945;} } } } } } 

}



/* &main5136 */
obj_t BGl_z62main5136z62zz__evaluate_compz00(obj_t BgL_envz00_11759, obj_t BgL_bz00_11766, obj_t BgL_cz00_11767, obj_t BgL_dz00_11768)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11764;long BgL_siza7ezd2framez75_11765;
BgL_runz00_11764 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11759, 
(int)(((long)4)))); 
BgL_siza7ezd2framez75_11765 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11759, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13950;
BgL_sz00_13950 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13951;
BgL_bpz00_13951 = 
VECTOR_REF(
((obj_t)BgL_sz00_13950),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13950, BgL_bpz00_13951, 
BINT(BgL_siza7ezd2framez75_11765)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3417z00_13952;
BgL_arg3417z00_13952 = 
(
(long)CINT(BgL_bpz00_13951)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13950),BgL_arg3417z00_13952,BgL_bz00_11766); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3418z00_13953;
BgL_arg3418z00_13953 = 
(
(long)CINT(BgL_bpz00_13951)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13950),BgL_arg3418z00_13953,BgL_cz00_11767); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3419z00_13954;
BgL_arg3419z00_13954 = 
(
(long)CINT(BgL_bpz00_13951)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13950),BgL_arg3419z00_13954,BgL_dz00_11768); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13955;
BgL_ez00_13955 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13955, BgL_bpz00_13951); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13956;
BgL_accz00_13956 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11764, BgL_sz00_13950, BgL_bpz00_13951); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13955); 
VECTOR_SET(
((obj_t)BgL_sz00_13950),((long)0),BgL_bpz00_13951); 
return BgL_accz00_13956;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13957;
BgL_nsz00_13957 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13957,((long)1),BgL_sz00_13950); 
VECTOR_SET(BgL_nsz00_13957,((long)2),BgL_bz00_11766); 
VECTOR_SET(BgL_nsz00_13957,((long)3),BgL_cz00_11767); 
VECTOR_SET(BgL_nsz00_13957,((long)4),BgL_dz00_11768); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13958;
BgL_z12denvz12_13958 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13958, BgL_nsz00_13957); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13959;
BgL_ez00_13959 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13959, BgL_sz00_13950); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13960;
BgL_____rz00_13960 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11764, BgL_nsz00_13957, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13959); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13958, BgL_sz00_13950); 
return BgL_____rz00_13960;} } } } } } } } 

}



/* &run5137 */
obj_t BGl_z62run5137z62zz__evaluate_compz00(obj_t BgL_envz00_11769, obj_t BgL_sz00_11774)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_siza7eza7_11770;obj_t BgL_valza2za2_11771;BgL_ev_absz00_bglt BgL_i1244z00_11772;obj_t BgL_bodyz00_11773;
BgL_siza7eza7_11770 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11769, 
(int)(((long)0)))); 
BgL_valza2za2_11771 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11769, 
(int)(((long)1)))); 
BgL_i1244z00_11772 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11769, 
(int)(((long)2)))); 
BgL_bodyz00_11773 = 
PROCEDURE_REF(BgL_envz00_11769, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13961;
BgL_bpz00_13961 = 
VECTOR_REF(
((obj_t)BgL_sz00_11774),((long)0)); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_11774, BgL_valza2za2_11771, 
(
(long)CINT(BgL_bpz00_13961)+BgL_siza7eza7_11770)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_13962;obj_t BgL_wherez00_13963;obj_t BgL_locz00_13964;
BgL_z12denvz12_13962 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13963 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11772))->BgL_wherez00); 
BgL_locz00_13964 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11772))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13962, BgL_wherez00_13963, BgL_locz00_13964); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_13965;
BgL_za2za2resza2za2z00_13965 = 
PROCEDURE_ENTRY(BgL_bodyz00_11773)(BgL_bodyz00_11773, BgL_sz00_11774, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13962); 
return BgL_za2za2resza2za2z00_13965;} } } } } } 

}



/* &<@anonymous:3422> */
obj_t BGl_z62zc3z04anonymousza33422ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11775, obj_t BgL_sz00_11782)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_11776;obj_t BgL_iboxesz00_11777;long BgL_siza7eza7_11778;BgL_ev_absz00_bglt BgL_i1244z00_11779;obj_t BgL_bodyz00_11780;long BgL_siza7ezd2framez75_11781;
BgL_ifreesz00_11776 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11775, 
(int)(((long)0)))); 
BgL_iboxesz00_11777 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11775, 
(int)(((long)1)))); 
BgL_siza7eza7_11778 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11775, 
(int)(((long)2)))); 
BgL_i1244z00_11779 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11775, 
(int)(((long)3)))); 
BgL_bodyz00_11780 = 
PROCEDURE_REF(BgL_envz00_11775, 
(int)(((long)4))); 
BgL_siza7ezd2framez75_11781 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11775, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13966;
BgL_bpz00_13966 = 
VECTOR_REF(
((obj_t)BgL_sz00_11782),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_13967;
BgL_valza2za2_13967 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_11782, BgL_bpz00_13966, BgL_ifreesz00_11776); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13968;
BgL_runz00_13968 = 
MAKE_FX_PROCEDURE(BGl_z62run5139z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_runz00_13968, 
(int)(((long)0)), BgL_iboxesz00_11777); 
PROCEDURE_SET(BgL_runz00_13968, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_11778)); 
PROCEDURE_SET(BgL_runz00_13968, 
(int)(((long)2)), BgL_valza2za2_13967); 
PROCEDURE_SET(BgL_runz00_13968, 
(int)(((long)3)), 
((obj_t)BgL_i1244z00_11779)); 
PROCEDURE_SET(BgL_runz00_13968, 
(int)(((long)4)), BgL_bodyz00_11780); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13969;
BgL_mainz00_13969 = 
MAKE_FX_PROCEDURE(BGl_z62main5138z62zz__evaluate_compz00, 
(int)(((long)3)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_mainz00_13969, 
(int)(((long)0)), BgL_iboxesz00_11777); 
PROCEDURE_SET(BgL_mainz00_13969, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_11778)); 
PROCEDURE_SET(BgL_mainz00_13969, 
(int)(((long)2)), BgL_valza2za2_13967); 
PROCEDURE_SET(BgL_mainz00_13969, 
(int)(((long)3)), 
((obj_t)BgL_i1244z00_11779)); 
PROCEDURE_SET(BgL_mainz00_13969, 
(int)(((long)4)), BgL_bodyz00_11780); 
PROCEDURE_SET(BgL_mainz00_13969, 
(int)(((long)5)), BgL_runz00_13968); 
PROCEDURE_SET(BgL_mainz00_13969, 
(int)(((long)6)), 
BINT(BgL_siza7ezd2framez75_11781)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13970;
BgL_objz00_13970 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13968, BgL_objz00_13970); BgL_objz00_13970; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3423z00_13971;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3424z00_13972;
BgL_arg3424z00_13972 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11779))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13973;
BgL_newz00_13973 = 
create_struct(BGl_symbol5225z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_24457;
BgL_tmpz00_24457 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13973, BgL_tmpz00_24457, BgL_arg3424z00_13972); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_24462;int BgL_tmpz00_24460;
BgL_auxz00_24462 = 
BINT(BgL_siza7ezd2framez75_11781); 
BgL_tmpz00_24460 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13973, BgL_tmpz00_24460, BgL_auxz00_24462); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_24465;
BgL_tmpz00_24465 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13973, BgL_tmpz00_24465, BgL_runz00_13968); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_24470;int BgL_tmpz00_24468;
BgL_auxz00_24470 = 
BINT(((long)3)); 
BgL_tmpz00_24468 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13973, BgL_tmpz00_24468, BgL_auxz00_24470); } 
BgL_arg3423z00_13971 = BgL_newz00_13973; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13969, BgL_arg3423z00_13971); BgL_arg3423z00_13971; } 
return BgL_mainz00_13969;} } } } } } 

}



/* &main5138 */
obj_t BGl_z62main5138z62zz__evaluate_compz00(obj_t BgL_envz00_11783, obj_t BgL_bz00_11791, obj_t BgL_cz00_11792, obj_t BgL_dz00_11793)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11789;long BgL_siza7ezd2framez75_11790;
BgL_runz00_11789 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11783, 
(int)(((long)5)))); 
BgL_siza7ezd2framez75_11790 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11783, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13974;
BgL_sz00_13974 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13975;
BgL_bpz00_13975 = 
VECTOR_REF(
((obj_t)BgL_sz00_13974),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13974, BgL_bpz00_13975, 
BINT(BgL_siza7ezd2framez75_11790)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3427z00_13976;
BgL_arg3427z00_13976 = 
(
(long)CINT(BgL_bpz00_13975)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13974),BgL_arg3427z00_13976,BgL_bz00_11791); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3428z00_13977;
BgL_arg3428z00_13977 = 
(
(long)CINT(BgL_bpz00_13975)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13974),BgL_arg3428z00_13977,BgL_cz00_11792); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3429z00_13978;
BgL_arg3429z00_13978 = 
(
(long)CINT(BgL_bpz00_13975)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13974),BgL_arg3429z00_13978,BgL_dz00_11793); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13979;
BgL_ez00_13979 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13979, BgL_bpz00_13975); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13980;
BgL_accz00_13980 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11789, BgL_sz00_13974, BgL_bpz00_13975); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13979); 
VECTOR_SET(
((obj_t)BgL_sz00_13974),((long)0),BgL_bpz00_13975); 
return BgL_accz00_13980;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13981;
BgL_nsz00_13981 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13981,((long)1),BgL_sz00_13974); 
VECTOR_SET(BgL_nsz00_13981,((long)2),BgL_bz00_11791); 
VECTOR_SET(BgL_nsz00_13981,((long)3),BgL_cz00_11792); 
VECTOR_SET(BgL_nsz00_13981,((long)4),BgL_dz00_11793); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13982;
BgL_z12denvz12_13982 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13982, BgL_nsz00_13981); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13983;
BgL_ez00_13983 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13983, BgL_sz00_13974); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13984;
BgL_____rz00_13984 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11789, BgL_nsz00_13981, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13983); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13982, BgL_sz00_13974); 
return BgL_____rz00_13984;} } } } } } } } 

}



/* &run5139 */
obj_t BGl_z62run5139z62zz__evaluate_compz00(obj_t BgL_envz00_11794, obj_t BgL_sz00_11800)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11795;long BgL_siza7eza7_11796;obj_t BgL_valza2za2_11797;BgL_ev_absz00_bglt BgL_i1244z00_11798;obj_t BgL_bodyz00_11799;
BgL_iboxesz00_11795 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11794, 
(int)(((long)0)))); 
BgL_siza7eza7_11796 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11794, 
(int)(((long)1)))); 
BgL_valza2za2_11797 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11794, 
(int)(((long)2)))); 
BgL_i1244z00_11798 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11794, 
(int)(((long)3)))); 
BgL_bodyz00_11799 = 
PROCEDURE_REF(BgL_envz00_11794, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13985;
BgL_bpz00_13985 = 
VECTOR_REF(
((obj_t)BgL_sz00_11800),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_11800, BgL_iboxesz00_11795, BgL_bpz00_13985); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_11800, BgL_valza2za2_11797, 
(
(long)CINT(BgL_bpz00_13985)+BgL_siza7eza7_11796)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_13986;obj_t BgL_wherez00_13987;obj_t BgL_locz00_13988;
BgL_z12denvz12_13986 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13987 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11798))->BgL_wherez00); 
BgL_locz00_13988 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11798))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13986, BgL_wherez00_13987, BgL_locz00_13988); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_13989;
BgL_za2za2resza2za2z00_13989 = 
PROCEDURE_ENTRY(BgL_bodyz00_11799)(BgL_bodyz00_11799, BgL_sz00_11800, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13986); 
return BgL_za2za2resza2za2z00_13989;} } } } } } 

}



/* &<@anonymous:3344> */
obj_t BGl_z62zc3z04anonymousza33344ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11801, obj_t BgL_sz00_11805)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_11802;obj_t BgL_bodyz00_11803;long BgL_siza7ezd2framez75_11804;
BgL_i1244z00_11802 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11801, 
(int)(((long)0)))); 
BgL_bodyz00_11803 = 
PROCEDURE_REF(BgL_envz00_11801, 
(int)(((long)1))); 
BgL_siza7ezd2framez75_11804 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11801, 
(int)(((long)2)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13990;
BgL_bpz00_13990 = 
VECTOR_REF(
((obj_t)BgL_sz00_11805),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13991;
BgL_runz00_13991 = 
MAKE_FX_PROCEDURE(BGl_z62run5141z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_runz00_13991, 
(int)(((long)0)), 
((obj_t)BgL_i1244z00_11802)); 
PROCEDURE_SET(BgL_runz00_13991, 
(int)(((long)1)), BgL_bodyz00_11803); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13992;
BgL_mainz00_13992 = 
MAKE_VA_PROCEDURE(BGl_z62main5140z62zz__evaluate_compz00, 
(int)(((long)-3)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_mainz00_13992, 
(int)(((long)0)), 
((obj_t)BgL_i1244z00_11802)); 
PROCEDURE_SET(BgL_mainz00_13992, 
(int)(((long)1)), BgL_bodyz00_11803); 
PROCEDURE_SET(BgL_mainz00_13992, 
(int)(((long)2)), BgL_runz00_13991); 
PROCEDURE_SET(BgL_mainz00_13992, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_11804)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13993;
BgL_objz00_13993 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13991, BgL_objz00_13993); BgL_objz00_13993; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3345z00_13994;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3346z00_13995;
BgL_arg3346z00_13995 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11802))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13996;
BgL_newz00_13996 = 
create_struct(BGl_symbol5225z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_24581;
BgL_tmpz00_24581 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13996, BgL_tmpz00_24581, BgL_arg3346z00_13995); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_24586;int BgL_tmpz00_24584;
BgL_auxz00_24586 = 
BINT(BgL_siza7ezd2framez75_11804); 
BgL_tmpz00_24584 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13996, BgL_tmpz00_24584, BgL_auxz00_24586); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_24589;
BgL_tmpz00_24589 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13996, BgL_tmpz00_24589, BgL_runz00_13991); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_24594;int BgL_tmpz00_24592;
BgL_auxz00_24594 = 
BINT(((long)-3)); 
BgL_tmpz00_24592 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13996, BgL_tmpz00_24592, BgL_auxz00_24594); } 
BgL_arg3345z00_13994 = BgL_newz00_13996; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13992, BgL_arg3345z00_13994); BgL_arg3345z00_13994; } 
return BgL_mainz00_13992;} } } } } } 

}



/* &main5140 */
obj_t BGl_z62main5140z62zz__evaluate_compz00(obj_t BgL_envz00_11806, obj_t BgL_cz00_11811, obj_t BgL_dz00_11812, obj_t BgL_lastz00_11813)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11809;long BgL_siza7ezd2framez75_11810;
BgL_runz00_11809 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11806, 
(int)(((long)2)))); 
BgL_siza7ezd2framez75_11810 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11806, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13997;
BgL_sz00_13997 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13998;
BgL_bpz00_13998 = 
VECTOR_REF(
((obj_t)BgL_sz00_13997),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13997, BgL_bpz00_13998, 
BINT(BgL_siza7ezd2framez75_11810)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3349z00_13999;
BgL_arg3349z00_13999 = 
(
(long)CINT(BgL_bpz00_13998)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13997),BgL_arg3349z00_13999,BgL_cz00_11811); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3350z00_14000;
BgL_arg3350z00_14000 = 
(
(long)CINT(BgL_bpz00_13998)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13997),BgL_arg3350z00_14000,BgL_dz00_11812); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3351z00_14001;
BgL_arg3351z00_14001 = 
(
(long)CINT(BgL_bpz00_13998)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13997),BgL_arg3351z00_14001,BgL_lastz00_11813); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14002;
BgL_ez00_14002 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14002, BgL_bpz00_13998); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14003;
BgL_accz00_14003 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11809, BgL_sz00_13997, BgL_bpz00_13998); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14002); 
VECTOR_SET(
((obj_t)BgL_sz00_13997),((long)0),BgL_bpz00_13998); 
return BgL_accz00_14003;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14004;
BgL_nsz00_14004 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14004,((long)1),BgL_sz00_13997); 
VECTOR_SET(BgL_nsz00_14004,((long)2),BgL_cz00_11811); 
VECTOR_SET(BgL_nsz00_14004,((long)3),BgL_dz00_11812); 
VECTOR_SET(BgL_nsz00_14004,((long)4),BgL_lastz00_11813); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14005;
BgL_z12denvz12_14005 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14005, BgL_nsz00_14004); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14006;
BgL_ez00_14006 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14006, BgL_sz00_13997); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14007;
BgL_____rz00_14007 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11809, BgL_nsz00_14004, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14006); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14005, BgL_sz00_13997); 
return BgL_____rz00_14007;} } } } } } } } 

}



/* &run5141 */
obj_t BGl_z62run5141z62zz__evaluate_compz00(obj_t BgL_envz00_11814, obj_t BgL_sz00_11817)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_11815;obj_t BgL_bodyz00_11816;
BgL_i1244z00_11815 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11814, 
(int)(((long)0)))); 
BgL_bodyz00_11816 = 
PROCEDURE_REF(BgL_envz00_11814, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14008;
BgL_bpz00_14008 = 
VECTOR_REF(
((obj_t)BgL_sz00_11817),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14009;obj_t BgL_wherez00_14010;obj_t BgL_locz00_14011;
BgL_z12denvz12_14009 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14010 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11815))->BgL_wherez00); 
BgL_locz00_14011 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11815))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14009, BgL_wherez00_14010, BgL_locz00_14011); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_14012;
BgL_za2za2resza2za2z00_14012 = 
PROCEDURE_ENTRY(BgL_bodyz00_11816)(BgL_bodyz00_11816, BgL_sz00_11817, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14009); 
return BgL_za2za2resza2za2z00_14012;} } } } } } 

}



/* &<@anonymous:3353> */
obj_t BGl_z62zc3z04anonymousza33353ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11818, obj_t BgL_sz00_11823)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11819;BgL_ev_absz00_bglt BgL_i1244z00_11820;obj_t BgL_bodyz00_11821;long BgL_siza7ezd2framez75_11822;
BgL_iboxesz00_11819 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11818, 
(int)(((long)0)))); 
BgL_i1244z00_11820 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11818, 
(int)(((long)1)))); 
BgL_bodyz00_11821 = 
PROCEDURE_REF(BgL_envz00_11818, 
(int)(((long)2))); 
BgL_siza7ezd2framez75_11822 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11818, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14013;
BgL_bpz00_14013 = 
VECTOR_REF(
((obj_t)BgL_sz00_11823),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14014;
BgL_runz00_14014 = 
MAKE_FX_PROCEDURE(BGl_z62run5143z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_runz00_14014, 
(int)(((long)0)), BgL_iboxesz00_11819); 
PROCEDURE_SET(BgL_runz00_14014, 
(int)(((long)1)), 
((obj_t)BgL_i1244z00_11820)); 
PROCEDURE_SET(BgL_runz00_14014, 
(int)(((long)2)), BgL_bodyz00_11821); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14015;
BgL_mainz00_14015 = 
MAKE_VA_PROCEDURE(BGl_z62main5142z62zz__evaluate_compz00, 
(int)(((long)-3)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_mainz00_14015, 
(int)(((long)0)), BgL_iboxesz00_11819); 
PROCEDURE_SET(BgL_mainz00_14015, 
(int)(((long)1)), 
((obj_t)BgL_i1244z00_11820)); 
PROCEDURE_SET(BgL_mainz00_14015, 
(int)(((long)2)), BgL_bodyz00_11821); 
PROCEDURE_SET(BgL_mainz00_14015, 
(int)(((long)3)), BgL_runz00_14014); 
PROCEDURE_SET(BgL_mainz00_14015, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_11822)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14016;
BgL_objz00_14016 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14014, BgL_objz00_14016); BgL_objz00_14016; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3354z00_14017;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3355z00_14018;
BgL_arg3355z00_14018 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11820))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14019;
BgL_newz00_14019 = 
create_struct(BGl_symbol5225z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_24699;
BgL_tmpz00_24699 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14019, BgL_tmpz00_24699, BgL_arg3355z00_14018); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_24704;int BgL_tmpz00_24702;
BgL_auxz00_24704 = 
BINT(BgL_siza7ezd2framez75_11822); 
BgL_tmpz00_24702 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14019, BgL_tmpz00_24702, BgL_auxz00_24704); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_24707;
BgL_tmpz00_24707 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14019, BgL_tmpz00_24707, BgL_runz00_14014); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_24712;int BgL_tmpz00_24710;
BgL_auxz00_24712 = 
BINT(((long)-3)); 
BgL_tmpz00_24710 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14019, BgL_tmpz00_24710, BgL_auxz00_24712); } 
BgL_arg3354z00_14017 = BgL_newz00_14019; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14015, BgL_arg3354z00_14017); BgL_arg3354z00_14017; } 
return BgL_mainz00_14015;} } } } } } 

}



/* &main5142 */
obj_t BGl_z62main5142z62zz__evaluate_compz00(obj_t BgL_envz00_11824, obj_t BgL_cz00_11830, obj_t BgL_dz00_11831, obj_t BgL_lastz00_11832)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11828;long BgL_siza7ezd2framez75_11829;
BgL_runz00_11828 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11824, 
(int)(((long)3)))); 
BgL_siza7ezd2framez75_11829 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11824, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14020;
BgL_sz00_14020 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14021;
BgL_bpz00_14021 = 
VECTOR_REF(
((obj_t)BgL_sz00_14020),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14020, BgL_bpz00_14021, 
BINT(BgL_siza7ezd2framez75_11829)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3358z00_14022;
BgL_arg3358z00_14022 = 
(
(long)CINT(BgL_bpz00_14021)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14020),BgL_arg3358z00_14022,BgL_cz00_11830); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3359z00_14023;
BgL_arg3359z00_14023 = 
(
(long)CINT(BgL_bpz00_14021)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_14020),BgL_arg3359z00_14023,BgL_dz00_11831); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3360z00_14024;
BgL_arg3360z00_14024 = 
(
(long)CINT(BgL_bpz00_14021)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_14020),BgL_arg3360z00_14024,BgL_lastz00_11832); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14025;
BgL_ez00_14025 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14025, BgL_bpz00_14021); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14026;
BgL_accz00_14026 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11828, BgL_sz00_14020, BgL_bpz00_14021); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14025); 
VECTOR_SET(
((obj_t)BgL_sz00_14020),((long)0),BgL_bpz00_14021); 
return BgL_accz00_14026;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14027;
BgL_nsz00_14027 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14027,((long)1),BgL_sz00_14020); 
VECTOR_SET(BgL_nsz00_14027,((long)2),BgL_cz00_11830); 
VECTOR_SET(BgL_nsz00_14027,((long)3),BgL_dz00_11831); 
VECTOR_SET(BgL_nsz00_14027,((long)4),BgL_lastz00_11832); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14028;
BgL_z12denvz12_14028 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14028, BgL_nsz00_14027); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14029;
BgL_ez00_14029 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14029, BgL_sz00_14020); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14030;
BgL_____rz00_14030 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11828, BgL_nsz00_14027, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14029); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14028, BgL_sz00_14020); 
return BgL_____rz00_14030;} } } } } } } } 

}



/* &run5143 */
obj_t BGl_z62run5143z62zz__evaluate_compz00(obj_t BgL_envz00_11833, obj_t BgL_sz00_11837)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11834;BgL_ev_absz00_bglt BgL_i1244z00_11835;obj_t BgL_bodyz00_11836;
BgL_iboxesz00_11834 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11833, 
(int)(((long)0)))); 
BgL_i1244z00_11835 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11833, 
(int)(((long)1)))); 
BgL_bodyz00_11836 = 
PROCEDURE_REF(BgL_envz00_11833, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14031;
BgL_bpz00_14031 = 
VECTOR_REF(
((obj_t)BgL_sz00_11837),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_11837, BgL_iboxesz00_11834, BgL_bpz00_14031); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14032;obj_t BgL_wherez00_14033;obj_t BgL_locz00_14034;
BgL_z12denvz12_14032 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14033 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11835))->BgL_wherez00); 
BgL_locz00_14034 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11835))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14032, BgL_wherez00_14033, BgL_locz00_14034); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_14035;
BgL_za2za2resza2za2z00_14035 = 
PROCEDURE_ENTRY(BgL_bodyz00_11836)(BgL_bodyz00_11836, BgL_sz00_11837, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14032); 
return BgL_za2za2resza2za2z00_14035;} } } } } } 

}



/* &<@anonymous:3365> */
obj_t BGl_z62zc3z04anonymousza33365ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11838, obj_t BgL_sz00_11844)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_11839;long BgL_siza7eza7_11840;BgL_ev_absz00_bglt BgL_i1244z00_11841;obj_t BgL_bodyz00_11842;long BgL_siza7ezd2framez75_11843;
BgL_ifreesz00_11839 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11838, 
(int)(((long)0)))); 
BgL_siza7eza7_11840 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11838, 
(int)(((long)1)))); 
BgL_i1244z00_11841 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11838, 
(int)(((long)2)))); 
BgL_bodyz00_11842 = 
PROCEDURE_REF(BgL_envz00_11838, 
(int)(((long)3))); 
BgL_siza7ezd2framez75_11843 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11838, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14036;
BgL_bpz00_14036 = 
VECTOR_REF(
((obj_t)BgL_sz00_11844),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_14037;
BgL_valza2za2_14037 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_11844, BgL_bpz00_14036, BgL_ifreesz00_11839); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14038;
BgL_runz00_14038 = 
MAKE_FX_PROCEDURE(BGl_z62run5145z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_runz00_14038, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_11840)); 
PROCEDURE_SET(BgL_runz00_14038, 
(int)(((long)1)), BgL_valza2za2_14037); 
PROCEDURE_SET(BgL_runz00_14038, 
(int)(((long)2)), 
((obj_t)BgL_i1244z00_11841)); 
PROCEDURE_SET(BgL_runz00_14038, 
(int)(((long)3)), BgL_bodyz00_11842); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14039;
BgL_mainz00_14039 = 
MAKE_VA_PROCEDURE(BGl_z62main5144z62zz__evaluate_compz00, 
(int)(((long)-3)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_mainz00_14039, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_11840)); 
PROCEDURE_SET(BgL_mainz00_14039, 
(int)(((long)1)), BgL_valza2za2_14037); 
PROCEDURE_SET(BgL_mainz00_14039, 
(int)(((long)2)), 
((obj_t)BgL_i1244z00_11841)); 
PROCEDURE_SET(BgL_mainz00_14039, 
(int)(((long)3)), BgL_bodyz00_11842); 
PROCEDURE_SET(BgL_mainz00_14039, 
(int)(((long)4)), BgL_runz00_14038); 
PROCEDURE_SET(BgL_mainz00_14039, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_11843)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14040;
BgL_objz00_14040 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14038, BgL_objz00_14040); BgL_objz00_14040; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3366z00_14041;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3367z00_14042;
BgL_arg3367z00_14042 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11841))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14043;
BgL_newz00_14043 = 
create_struct(BGl_symbol5225z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_24831;
BgL_tmpz00_24831 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14043, BgL_tmpz00_24831, BgL_arg3367z00_14042); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_24836;int BgL_tmpz00_24834;
BgL_auxz00_24836 = 
BINT(BgL_siza7ezd2framez75_11843); 
BgL_tmpz00_24834 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14043, BgL_tmpz00_24834, BgL_auxz00_24836); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_24839;
BgL_tmpz00_24839 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14043, BgL_tmpz00_24839, BgL_runz00_14038); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_24844;int BgL_tmpz00_24842;
BgL_auxz00_24844 = 
BINT(((long)-3)); 
BgL_tmpz00_24842 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14043, BgL_tmpz00_24842, BgL_auxz00_24844); } 
BgL_arg3366z00_14041 = BgL_newz00_14043; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14039, BgL_arg3366z00_14041); BgL_arg3366z00_14041; } 
return BgL_mainz00_14039;} } } } } } 

}



/* &main5144 */
obj_t BGl_z62main5144z62zz__evaluate_compz00(obj_t BgL_envz00_11845, obj_t BgL_cz00_11852, obj_t BgL_dz00_11853, obj_t BgL_lastz00_11854)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11850;long BgL_siza7ezd2framez75_11851;
BgL_runz00_11850 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11845, 
(int)(((long)4)))); 
BgL_siza7ezd2framez75_11851 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11845, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14044;
BgL_sz00_14044 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14045;
BgL_bpz00_14045 = 
VECTOR_REF(
((obj_t)BgL_sz00_14044),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14044, BgL_bpz00_14045, 
BINT(BgL_siza7ezd2framez75_11851)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3370z00_14046;
BgL_arg3370z00_14046 = 
(
(long)CINT(BgL_bpz00_14045)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14044),BgL_arg3370z00_14046,BgL_cz00_11852); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3371z00_14047;
BgL_arg3371z00_14047 = 
(
(long)CINT(BgL_bpz00_14045)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_14044),BgL_arg3371z00_14047,BgL_dz00_11853); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3372z00_14048;
BgL_arg3372z00_14048 = 
(
(long)CINT(BgL_bpz00_14045)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_14044),BgL_arg3372z00_14048,BgL_lastz00_11854); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14049;
BgL_ez00_14049 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14049, BgL_bpz00_14045); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14050;
BgL_accz00_14050 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11850, BgL_sz00_14044, BgL_bpz00_14045); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14049); 
VECTOR_SET(
((obj_t)BgL_sz00_14044),((long)0),BgL_bpz00_14045); 
return BgL_accz00_14050;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14051;
BgL_nsz00_14051 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14051,((long)1),BgL_sz00_14044); 
VECTOR_SET(BgL_nsz00_14051,((long)2),BgL_cz00_11852); 
VECTOR_SET(BgL_nsz00_14051,((long)3),BgL_dz00_11853); 
VECTOR_SET(BgL_nsz00_14051,((long)4),BgL_lastz00_11854); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14052;
BgL_z12denvz12_14052 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14052, BgL_nsz00_14051); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14053;
BgL_ez00_14053 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14053, BgL_sz00_14044); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14054;
BgL_____rz00_14054 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11850, BgL_nsz00_14051, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14053); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14052, BgL_sz00_14044); 
return BgL_____rz00_14054;} } } } } } } } 

}



/* &run5145 */
obj_t BGl_z62run5145z62zz__evaluate_compz00(obj_t BgL_envz00_11855, obj_t BgL_sz00_11860)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_siza7eza7_11856;obj_t BgL_valza2za2_11857;BgL_ev_absz00_bglt BgL_i1244z00_11858;obj_t BgL_bodyz00_11859;
BgL_siza7eza7_11856 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11855, 
(int)(((long)0)))); 
BgL_valza2za2_11857 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11855, 
(int)(((long)1)))); 
BgL_i1244z00_11858 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11855, 
(int)(((long)2)))); 
BgL_bodyz00_11859 = 
PROCEDURE_REF(BgL_envz00_11855, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14055;
BgL_bpz00_14055 = 
VECTOR_REF(
((obj_t)BgL_sz00_11860),((long)0)); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_11860, BgL_valza2za2_11857, 
(
(long)CINT(BgL_bpz00_14055)+BgL_siza7eza7_11856)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_14056;obj_t BgL_wherez00_14057;obj_t BgL_locz00_14058;
BgL_z12denvz12_14056 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14057 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11858))->BgL_wherez00); 
BgL_locz00_14058 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11858))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14056, BgL_wherez00_14057, BgL_locz00_14058); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_14059;
BgL_za2za2resza2za2z00_14059 = 
PROCEDURE_ENTRY(BgL_bodyz00_11859)(BgL_bodyz00_11859, BgL_sz00_11860, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14056); 
return BgL_za2za2resza2za2z00_14059;} } } } } } 

}



/* &<@anonymous:3375> */
obj_t BGl_z62zc3z04anonymousza33375ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11861, obj_t BgL_sz00_11868)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_11862;obj_t BgL_iboxesz00_11863;long BgL_siza7eza7_11864;BgL_ev_absz00_bglt BgL_i1244z00_11865;obj_t BgL_bodyz00_11866;long BgL_siza7ezd2framez75_11867;
BgL_ifreesz00_11862 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11861, 
(int)(((long)0)))); 
BgL_iboxesz00_11863 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11861, 
(int)(((long)1)))); 
BgL_siza7eza7_11864 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11861, 
(int)(((long)2)))); 
BgL_i1244z00_11865 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11861, 
(int)(((long)3)))); 
BgL_bodyz00_11866 = 
PROCEDURE_REF(BgL_envz00_11861, 
(int)(((long)4))); 
BgL_siza7ezd2framez75_11867 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11861, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14060;
BgL_bpz00_14060 = 
VECTOR_REF(
((obj_t)BgL_sz00_11868),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_14061;
BgL_valza2za2_14061 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_11868, BgL_bpz00_14060, BgL_ifreesz00_11862); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14062;
BgL_runz00_14062 = 
MAKE_FX_PROCEDURE(BGl_z62run5147z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_runz00_14062, 
(int)(((long)0)), BgL_iboxesz00_11863); 
PROCEDURE_SET(BgL_runz00_14062, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_11864)); 
PROCEDURE_SET(BgL_runz00_14062, 
(int)(((long)2)), BgL_valza2za2_14061); 
PROCEDURE_SET(BgL_runz00_14062, 
(int)(((long)3)), 
((obj_t)BgL_i1244z00_11865)); 
PROCEDURE_SET(BgL_runz00_14062, 
(int)(((long)4)), BgL_bodyz00_11866); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14063;
BgL_mainz00_14063 = 
MAKE_VA_PROCEDURE(BGl_z62main5146z62zz__evaluate_compz00, 
(int)(((long)-3)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_mainz00_14063, 
(int)(((long)0)), BgL_iboxesz00_11863); 
PROCEDURE_SET(BgL_mainz00_14063, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_11864)); 
PROCEDURE_SET(BgL_mainz00_14063, 
(int)(((long)2)), BgL_valza2za2_14061); 
PROCEDURE_SET(BgL_mainz00_14063, 
(int)(((long)3)), 
((obj_t)BgL_i1244z00_11865)); 
PROCEDURE_SET(BgL_mainz00_14063, 
(int)(((long)4)), BgL_bodyz00_11866); 
PROCEDURE_SET(BgL_mainz00_14063, 
(int)(((long)5)), BgL_runz00_14062); 
PROCEDURE_SET(BgL_mainz00_14063, 
(int)(((long)6)), 
BINT(BgL_siza7ezd2framez75_11867)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14064;
BgL_objz00_14064 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14062, BgL_objz00_14064); BgL_objz00_14064; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3376z00_14065;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3377z00_14066;
BgL_arg3377z00_14066 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11865))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14067;
BgL_newz00_14067 = 
create_struct(BGl_symbol5225z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_24975;
BgL_tmpz00_24975 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14067, BgL_tmpz00_24975, BgL_arg3377z00_14066); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_24980;int BgL_tmpz00_24978;
BgL_auxz00_24980 = 
BINT(BgL_siza7ezd2framez75_11867); 
BgL_tmpz00_24978 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14067, BgL_tmpz00_24978, BgL_auxz00_24980); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_24983;
BgL_tmpz00_24983 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14067, BgL_tmpz00_24983, BgL_runz00_14062); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_24988;int BgL_tmpz00_24986;
BgL_auxz00_24988 = 
BINT(((long)-3)); 
BgL_tmpz00_24986 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14067, BgL_tmpz00_24986, BgL_auxz00_24988); } 
BgL_arg3376z00_14065 = BgL_newz00_14067; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14063, BgL_arg3376z00_14065); BgL_arg3376z00_14065; } 
return BgL_mainz00_14063;} } } } } } 

}



/* &main5146 */
obj_t BGl_z62main5146z62zz__evaluate_compz00(obj_t BgL_envz00_11869, obj_t BgL_cz00_11877, obj_t BgL_dz00_11878, obj_t BgL_lastz00_11879)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11875;long BgL_siza7ezd2framez75_11876;
BgL_runz00_11875 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11869, 
(int)(((long)5)))); 
BgL_siza7ezd2framez75_11876 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11869, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14068;
BgL_sz00_14068 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14069;
BgL_bpz00_14069 = 
VECTOR_REF(
((obj_t)BgL_sz00_14068),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14068, BgL_bpz00_14069, 
BINT(BgL_siza7ezd2framez75_11876)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3380z00_14070;
BgL_arg3380z00_14070 = 
(
(long)CINT(BgL_bpz00_14069)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14068),BgL_arg3380z00_14070,BgL_cz00_11877); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3381z00_14071;
BgL_arg3381z00_14071 = 
(
(long)CINT(BgL_bpz00_14069)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_14068),BgL_arg3381z00_14071,BgL_dz00_11878); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3382z00_14072;
BgL_arg3382z00_14072 = 
(
(long)CINT(BgL_bpz00_14069)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_14068),BgL_arg3382z00_14072,BgL_lastz00_11879); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14073;
BgL_ez00_14073 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14073, BgL_bpz00_14069); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14074;
BgL_accz00_14074 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11875, BgL_sz00_14068, BgL_bpz00_14069); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14073); 
VECTOR_SET(
((obj_t)BgL_sz00_14068),((long)0),BgL_bpz00_14069); 
return BgL_accz00_14074;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14075;
BgL_nsz00_14075 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14075,((long)1),BgL_sz00_14068); 
VECTOR_SET(BgL_nsz00_14075,((long)2),BgL_cz00_11877); 
VECTOR_SET(BgL_nsz00_14075,((long)3),BgL_dz00_11878); 
VECTOR_SET(BgL_nsz00_14075,((long)4),BgL_lastz00_11879); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14076;
BgL_z12denvz12_14076 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14076, BgL_nsz00_14075); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14077;
BgL_ez00_14077 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14077, BgL_sz00_14068); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14078;
BgL_____rz00_14078 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11875, BgL_nsz00_14075, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14077); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14076, BgL_sz00_14068); 
return BgL_____rz00_14078;} } } } } } } } 

}



/* &run5147 */
obj_t BGl_z62run5147z62zz__evaluate_compz00(obj_t BgL_envz00_11880, obj_t BgL_sz00_11886)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11881;long BgL_siza7eza7_11882;obj_t BgL_valza2za2_11883;BgL_ev_absz00_bglt BgL_i1244z00_11884;obj_t BgL_bodyz00_11885;
BgL_iboxesz00_11881 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11880, 
(int)(((long)0)))); 
BgL_siza7eza7_11882 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11880, 
(int)(((long)1)))); 
BgL_valza2za2_11883 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11880, 
(int)(((long)2)))); 
BgL_i1244z00_11884 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11880, 
(int)(((long)3)))); 
BgL_bodyz00_11885 = 
PROCEDURE_REF(BgL_envz00_11880, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14079;
BgL_bpz00_14079 = 
VECTOR_REF(
((obj_t)BgL_sz00_11886),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_11886, BgL_iboxesz00_11881, BgL_bpz00_14079); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_11886, BgL_valza2za2_11883, 
(
(long)CINT(BgL_bpz00_14079)+BgL_siza7eza7_11882)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_14080;obj_t BgL_wherez00_14081;obj_t BgL_locz00_14082;
BgL_z12denvz12_14080 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14081 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11884))->BgL_wherez00); 
BgL_locz00_14082 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11884))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14080, BgL_wherez00_14081, BgL_locz00_14082); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_14083;
BgL_za2za2resza2za2z00_14083 = 
PROCEDURE_ENTRY(BgL_bodyz00_11885)(BgL_bodyz00_11885, BgL_sz00_11886, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14080); 
return BgL_za2za2resza2za2z00_14083;} } } } } } 

}



/* &<@anonymous:3301> */
obj_t BGl_z62zc3z04anonymousza33301ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11887, obj_t BgL_sz00_11891)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_11888;obj_t BgL_bodyz00_11889;long BgL_siza7ezd2framez75_11890;
BgL_i1244z00_11888 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11887, 
(int)(((long)0)))); 
BgL_bodyz00_11889 = 
PROCEDURE_REF(BgL_envz00_11887, 
(int)(((long)1))); 
BgL_siza7ezd2framez75_11890 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11887, 
(int)(((long)2)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14084;
BgL_bpz00_14084 = 
VECTOR_REF(
((obj_t)BgL_sz00_11891),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14085;
BgL_runz00_14085 = 
MAKE_FX_PROCEDURE(BGl_z62run5149z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_runz00_14085, 
(int)(((long)0)), 
((obj_t)BgL_i1244z00_11888)); 
PROCEDURE_SET(BgL_runz00_14085, 
(int)(((long)1)), BgL_bodyz00_11889); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14086;
BgL_mainz00_14086 = 
MAKE_FX_PROCEDURE(BGl_z62main5148z62zz__evaluate_compz00, 
(int)(((long)2)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_mainz00_14086, 
(int)(((long)0)), 
((obj_t)BgL_i1244z00_11888)); 
PROCEDURE_SET(BgL_mainz00_14086, 
(int)(((long)1)), BgL_bodyz00_11889); 
PROCEDURE_SET(BgL_mainz00_14086, 
(int)(((long)2)), BgL_runz00_14085); 
PROCEDURE_SET(BgL_mainz00_14086, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_11890)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14087;
BgL_objz00_14087 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14085, BgL_objz00_14087); BgL_objz00_14087; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3302z00_14088;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3303z00_14089;
BgL_arg3303z00_14089 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11888))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14090;
BgL_newz00_14090 = 
create_struct(BGl_symbol5225z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_25099;
BgL_tmpz00_25099 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14090, BgL_tmpz00_25099, BgL_arg3303z00_14089); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_25104;int BgL_tmpz00_25102;
BgL_auxz00_25104 = 
BINT(BgL_siza7ezd2framez75_11890); 
BgL_tmpz00_25102 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14090, BgL_tmpz00_25102, BgL_auxz00_25104); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_25107;
BgL_tmpz00_25107 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14090, BgL_tmpz00_25107, BgL_runz00_14085); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_25112;int BgL_tmpz00_25110;
BgL_auxz00_25112 = 
BINT(((long)2)); 
BgL_tmpz00_25110 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14090, BgL_tmpz00_25110, BgL_auxz00_25112); } 
BgL_arg3302z00_14088 = BgL_newz00_14090; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14086, BgL_arg3302z00_14088); BgL_arg3302z00_14088; } 
return BgL_mainz00_14086;} } } } } } 

}



/* &main5148 */
obj_t BGl_z62main5148z62zz__evaluate_compz00(obj_t BgL_envz00_11892, obj_t BgL_cz00_11897, obj_t BgL_dz00_11898)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11895;long BgL_siza7ezd2framez75_11896;
BgL_runz00_11895 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11892, 
(int)(((long)2)))); 
BgL_siza7ezd2framez75_11896 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11892, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14091;
BgL_sz00_14091 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14092;
BgL_bpz00_14092 = 
VECTOR_REF(
((obj_t)BgL_sz00_14091),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14091, BgL_bpz00_14092, 
BINT(BgL_siza7ezd2framez75_11896)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3306z00_14093;
BgL_arg3306z00_14093 = 
(
(long)CINT(BgL_bpz00_14092)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14091),BgL_arg3306z00_14093,BgL_cz00_11897); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3307z00_14094;
BgL_arg3307z00_14094 = 
(
(long)CINT(BgL_bpz00_14092)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_14091),BgL_arg3307z00_14094,BgL_dz00_11898); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14095;
BgL_ez00_14095 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14095, BgL_bpz00_14092); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14096;
BgL_accz00_14096 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11895, BgL_sz00_14091, BgL_bpz00_14092); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14095); 
VECTOR_SET(
((obj_t)BgL_sz00_14091),((long)0),BgL_bpz00_14092); 
return BgL_accz00_14096;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14097;
BgL_nsz00_14097 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14097,((long)1),BgL_sz00_14091); 
VECTOR_SET(BgL_nsz00_14097,((long)2),BgL_cz00_11897); 
VECTOR_SET(BgL_nsz00_14097,((long)3),BgL_dz00_11898); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14098;
BgL_z12denvz12_14098 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14098, BgL_nsz00_14097); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14099;
BgL_ez00_14099 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14099, BgL_sz00_14091); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14100;
BgL_____rz00_14100 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11895, BgL_nsz00_14097, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14099); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14098, BgL_sz00_14091); 
return BgL_____rz00_14100;} } } } } } } } 

}



/* &run5149 */
obj_t BGl_z62run5149z62zz__evaluate_compz00(obj_t BgL_envz00_11899, obj_t BgL_sz00_11902)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_11900;obj_t BgL_bodyz00_11901;
BgL_i1244z00_11900 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11899, 
(int)(((long)0)))); 
BgL_bodyz00_11901 = 
PROCEDURE_REF(BgL_envz00_11899, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14101;
BgL_bpz00_14101 = 
VECTOR_REF(
((obj_t)BgL_sz00_11902),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14102;obj_t BgL_wherez00_14103;obj_t BgL_locz00_14104;
BgL_z12denvz12_14102 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14103 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11900))->BgL_wherez00); 
BgL_locz00_14104 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11900))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14102, BgL_wherez00_14103, BgL_locz00_14104); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_14105;
BgL_za2za2resza2za2z00_14105 = 
PROCEDURE_ENTRY(BgL_bodyz00_11901)(BgL_bodyz00_11901, BgL_sz00_11902, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14102); 
return BgL_za2za2resza2za2z00_14105;} } } } } } 

}



/* &<@anonymous:3309> */
obj_t BGl_z62zc3z04anonymousza33309ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11903, obj_t BgL_sz00_11908)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11904;BgL_ev_absz00_bglt BgL_i1244z00_11905;obj_t BgL_bodyz00_11906;long BgL_siza7ezd2framez75_11907;
BgL_iboxesz00_11904 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11903, 
(int)(((long)0)))); 
BgL_i1244z00_11905 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11903, 
(int)(((long)1)))); 
BgL_bodyz00_11906 = 
PROCEDURE_REF(BgL_envz00_11903, 
(int)(((long)2))); 
BgL_siza7ezd2framez75_11907 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11903, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14106;
BgL_bpz00_14106 = 
VECTOR_REF(
((obj_t)BgL_sz00_11908),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14107;
BgL_runz00_14107 = 
MAKE_FX_PROCEDURE(BGl_z62run5151z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_runz00_14107, 
(int)(((long)0)), BgL_iboxesz00_11904); 
PROCEDURE_SET(BgL_runz00_14107, 
(int)(((long)1)), 
((obj_t)BgL_i1244z00_11905)); 
PROCEDURE_SET(BgL_runz00_14107, 
(int)(((long)2)), BgL_bodyz00_11906); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14108;
BgL_mainz00_14108 = 
MAKE_FX_PROCEDURE(BGl_z62main5150z62zz__evaluate_compz00, 
(int)(((long)2)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_mainz00_14108, 
(int)(((long)0)), BgL_iboxesz00_11904); 
PROCEDURE_SET(BgL_mainz00_14108, 
(int)(((long)1)), 
((obj_t)BgL_i1244z00_11905)); 
PROCEDURE_SET(BgL_mainz00_14108, 
(int)(((long)2)), BgL_bodyz00_11906); 
PROCEDURE_SET(BgL_mainz00_14108, 
(int)(((long)3)), BgL_runz00_14107); 
PROCEDURE_SET(BgL_mainz00_14108, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_11907)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14109;
BgL_objz00_14109 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14107, BgL_objz00_14109); BgL_objz00_14109; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3310z00_14110;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3311z00_14111;
BgL_arg3311z00_14111 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11905))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14112;
BgL_newz00_14112 = 
create_struct(BGl_symbol5225z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_25212;
BgL_tmpz00_25212 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14112, BgL_tmpz00_25212, BgL_arg3311z00_14111); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_25217;int BgL_tmpz00_25215;
BgL_auxz00_25217 = 
BINT(BgL_siza7ezd2framez75_11907); 
BgL_tmpz00_25215 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14112, BgL_tmpz00_25215, BgL_auxz00_25217); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_25220;
BgL_tmpz00_25220 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14112, BgL_tmpz00_25220, BgL_runz00_14107); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_25225;int BgL_tmpz00_25223;
BgL_auxz00_25225 = 
BINT(((long)2)); 
BgL_tmpz00_25223 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14112, BgL_tmpz00_25223, BgL_auxz00_25225); } 
BgL_arg3310z00_14110 = BgL_newz00_14112; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14108, BgL_arg3310z00_14110); BgL_arg3310z00_14110; } 
return BgL_mainz00_14108;} } } } } } 

}



/* &main5150 */
obj_t BGl_z62main5150z62zz__evaluate_compz00(obj_t BgL_envz00_11909, obj_t BgL_cz00_11915, obj_t BgL_dz00_11916)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11913;long BgL_siza7ezd2framez75_11914;
BgL_runz00_11913 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11909, 
(int)(((long)3)))); 
BgL_siza7ezd2framez75_11914 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11909, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14113;
BgL_sz00_14113 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14114;
BgL_bpz00_14114 = 
VECTOR_REF(
((obj_t)BgL_sz00_14113),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14113, BgL_bpz00_14114, 
BINT(BgL_siza7ezd2framez75_11914)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3314z00_14115;
BgL_arg3314z00_14115 = 
(
(long)CINT(BgL_bpz00_14114)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14113),BgL_arg3314z00_14115,BgL_cz00_11915); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3315z00_14116;
BgL_arg3315z00_14116 = 
(
(long)CINT(BgL_bpz00_14114)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_14113),BgL_arg3315z00_14116,BgL_dz00_11916); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14117;
BgL_ez00_14117 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14117, BgL_bpz00_14114); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14118;
BgL_accz00_14118 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11913, BgL_sz00_14113, BgL_bpz00_14114); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14117); 
VECTOR_SET(
((obj_t)BgL_sz00_14113),((long)0),BgL_bpz00_14114); 
return BgL_accz00_14118;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14119;
BgL_nsz00_14119 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14119,((long)1),BgL_sz00_14113); 
VECTOR_SET(BgL_nsz00_14119,((long)2),BgL_cz00_11915); 
VECTOR_SET(BgL_nsz00_14119,((long)3),BgL_dz00_11916); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14120;
BgL_z12denvz12_14120 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14120, BgL_nsz00_14119); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14121;
BgL_ez00_14121 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14121, BgL_sz00_14113); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14122;
BgL_____rz00_14122 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11913, BgL_nsz00_14119, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14121); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14120, BgL_sz00_14113); 
return BgL_____rz00_14122;} } } } } } } } 

}



/* &run5151 */
obj_t BGl_z62run5151z62zz__evaluate_compz00(obj_t BgL_envz00_11917, obj_t BgL_sz00_11921)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11918;BgL_ev_absz00_bglt BgL_i1244z00_11919;obj_t BgL_bodyz00_11920;
BgL_iboxesz00_11918 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11917, 
(int)(((long)0)))); 
BgL_i1244z00_11919 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11917, 
(int)(((long)1)))); 
BgL_bodyz00_11920 = 
PROCEDURE_REF(BgL_envz00_11917, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14123;
BgL_bpz00_14123 = 
VECTOR_REF(
((obj_t)BgL_sz00_11921),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_11921, BgL_iboxesz00_11918, BgL_bpz00_14123); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14124;obj_t BgL_wherez00_14125;obj_t BgL_locz00_14126;
BgL_z12denvz12_14124 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14125 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11919))->BgL_wherez00); 
BgL_locz00_14126 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11919))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14124, BgL_wherez00_14125, BgL_locz00_14126); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_14127;
BgL_za2za2resza2za2z00_14127 = 
PROCEDURE_ENTRY(BgL_bodyz00_11920)(BgL_bodyz00_11920, BgL_sz00_11921, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14124); 
return BgL_za2za2resza2za2z00_14127;} } } } } } 

}



/* &<@anonymous:3320> */
obj_t BGl_z62zc3z04anonymousza33320ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11922, obj_t BgL_sz00_11928)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_11923;long BgL_siza7eza7_11924;BgL_ev_absz00_bglt BgL_i1244z00_11925;obj_t BgL_bodyz00_11926;long BgL_siza7ezd2framez75_11927;
BgL_ifreesz00_11923 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11922, 
(int)(((long)0)))); 
BgL_siza7eza7_11924 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11922, 
(int)(((long)1)))); 
BgL_i1244z00_11925 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11922, 
(int)(((long)2)))); 
BgL_bodyz00_11926 = 
PROCEDURE_REF(BgL_envz00_11922, 
(int)(((long)3))); 
BgL_siza7ezd2framez75_11927 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11922, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14128;
BgL_bpz00_14128 = 
VECTOR_REF(
((obj_t)BgL_sz00_11928),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_14129;
BgL_valza2za2_14129 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_11928, BgL_bpz00_14128, BgL_ifreesz00_11923); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14130;
BgL_runz00_14130 = 
MAKE_FX_PROCEDURE(BGl_z62run5153z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_runz00_14130, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_11924)); 
PROCEDURE_SET(BgL_runz00_14130, 
(int)(((long)1)), BgL_valza2za2_14129); 
PROCEDURE_SET(BgL_runz00_14130, 
(int)(((long)2)), 
((obj_t)BgL_i1244z00_11925)); 
PROCEDURE_SET(BgL_runz00_14130, 
(int)(((long)3)), BgL_bodyz00_11926); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14131;
BgL_mainz00_14131 = 
MAKE_FX_PROCEDURE(BGl_z62main5152z62zz__evaluate_compz00, 
(int)(((long)2)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_mainz00_14131, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_11924)); 
PROCEDURE_SET(BgL_mainz00_14131, 
(int)(((long)1)), BgL_valza2za2_14129); 
PROCEDURE_SET(BgL_mainz00_14131, 
(int)(((long)2)), 
((obj_t)BgL_i1244z00_11925)); 
PROCEDURE_SET(BgL_mainz00_14131, 
(int)(((long)3)), BgL_bodyz00_11926); 
PROCEDURE_SET(BgL_mainz00_14131, 
(int)(((long)4)), BgL_runz00_14130); 
PROCEDURE_SET(BgL_mainz00_14131, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_11927)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14132;
BgL_objz00_14132 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14130, BgL_objz00_14132); BgL_objz00_14132; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3321z00_14133;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3322z00_14134;
BgL_arg3322z00_14134 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11925))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14135;
BgL_newz00_14135 = 
create_struct(BGl_symbol5225z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_25339;
BgL_tmpz00_25339 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14135, BgL_tmpz00_25339, BgL_arg3322z00_14134); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_25344;int BgL_tmpz00_25342;
BgL_auxz00_25344 = 
BINT(BgL_siza7ezd2framez75_11927); 
BgL_tmpz00_25342 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14135, BgL_tmpz00_25342, BgL_auxz00_25344); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_25347;
BgL_tmpz00_25347 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14135, BgL_tmpz00_25347, BgL_runz00_14130); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_25352;int BgL_tmpz00_25350;
BgL_auxz00_25352 = 
BINT(((long)2)); 
BgL_tmpz00_25350 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14135, BgL_tmpz00_25350, BgL_auxz00_25352); } 
BgL_arg3321z00_14133 = BgL_newz00_14135; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14131, BgL_arg3321z00_14133); BgL_arg3321z00_14133; } 
return BgL_mainz00_14131;} } } } } } 

}



/* &main5152 */
obj_t BGl_z62main5152z62zz__evaluate_compz00(obj_t BgL_envz00_11929, obj_t BgL_cz00_11936, obj_t BgL_dz00_11937)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11934;long BgL_siza7ezd2framez75_11935;
BgL_runz00_11934 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11929, 
(int)(((long)4)))); 
BgL_siza7ezd2framez75_11935 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11929, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14136;
BgL_sz00_14136 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14137;
BgL_bpz00_14137 = 
VECTOR_REF(
((obj_t)BgL_sz00_14136),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14136, BgL_bpz00_14137, 
BINT(BgL_siza7ezd2framez75_11935)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3325z00_14138;
BgL_arg3325z00_14138 = 
(
(long)CINT(BgL_bpz00_14137)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14136),BgL_arg3325z00_14138,BgL_cz00_11936); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3326z00_14139;
BgL_arg3326z00_14139 = 
(
(long)CINT(BgL_bpz00_14137)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_14136),BgL_arg3326z00_14139,BgL_dz00_11937); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14140;
BgL_ez00_14140 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14140, BgL_bpz00_14137); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14141;
BgL_accz00_14141 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11934, BgL_sz00_14136, BgL_bpz00_14137); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14140); 
VECTOR_SET(
((obj_t)BgL_sz00_14136),((long)0),BgL_bpz00_14137); 
return BgL_accz00_14141;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14142;
BgL_nsz00_14142 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14142,((long)1),BgL_sz00_14136); 
VECTOR_SET(BgL_nsz00_14142,((long)2),BgL_cz00_11936); 
VECTOR_SET(BgL_nsz00_14142,((long)3),BgL_dz00_11937); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14143;
BgL_z12denvz12_14143 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14143, BgL_nsz00_14142); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14144;
BgL_ez00_14144 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14144, BgL_sz00_14136); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14145;
BgL_____rz00_14145 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11934, BgL_nsz00_14142, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14144); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14143, BgL_sz00_14136); 
return BgL_____rz00_14145;} } } } } } } } 

}



/* &run5153 */
obj_t BGl_z62run5153z62zz__evaluate_compz00(obj_t BgL_envz00_11938, obj_t BgL_sz00_11943)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_siza7eza7_11939;obj_t BgL_valza2za2_11940;BgL_ev_absz00_bglt BgL_i1244z00_11941;obj_t BgL_bodyz00_11942;
BgL_siza7eza7_11939 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11938, 
(int)(((long)0)))); 
BgL_valza2za2_11940 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11938, 
(int)(((long)1)))); 
BgL_i1244z00_11941 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11938, 
(int)(((long)2)))); 
BgL_bodyz00_11942 = 
PROCEDURE_REF(BgL_envz00_11938, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14146;
BgL_bpz00_14146 = 
VECTOR_REF(
((obj_t)BgL_sz00_11943),((long)0)); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_11943, BgL_valza2za2_11940, 
(
(long)CINT(BgL_bpz00_14146)+BgL_siza7eza7_11939)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_14147;obj_t BgL_wherez00_14148;obj_t BgL_locz00_14149;
BgL_z12denvz12_14147 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14148 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11941))->BgL_wherez00); 
BgL_locz00_14149 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11941))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14147, BgL_wherez00_14148, BgL_locz00_14149); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_14150;
BgL_za2za2resza2za2z00_14150 = 
PROCEDURE_ENTRY(BgL_bodyz00_11942)(BgL_bodyz00_11942, BgL_sz00_11943, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14147); 
return BgL_za2za2resza2za2z00_14150;} } } } } } 

}



/* &<@anonymous:3329> */
obj_t BGl_z62zc3z04anonymousza33329ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11944, obj_t BgL_sz00_11951)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_11945;obj_t BgL_iboxesz00_11946;long BgL_siza7eza7_11947;BgL_ev_absz00_bglt BgL_i1244z00_11948;obj_t BgL_bodyz00_11949;long BgL_siza7ezd2framez75_11950;
BgL_ifreesz00_11945 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11944, 
(int)(((long)0)))); 
BgL_iboxesz00_11946 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11944, 
(int)(((long)1)))); 
BgL_siza7eza7_11947 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11944, 
(int)(((long)2)))); 
BgL_i1244z00_11948 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11944, 
(int)(((long)3)))); 
BgL_bodyz00_11949 = 
PROCEDURE_REF(BgL_envz00_11944, 
(int)(((long)4))); 
BgL_siza7ezd2framez75_11950 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11944, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14151;
BgL_bpz00_14151 = 
VECTOR_REF(
((obj_t)BgL_sz00_11951),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_14152;
BgL_valza2za2_14152 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_11951, BgL_bpz00_14151, BgL_ifreesz00_11945); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14153;
BgL_runz00_14153 = 
MAKE_FX_PROCEDURE(BGl_z62run5155z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_runz00_14153, 
(int)(((long)0)), BgL_iboxesz00_11946); 
PROCEDURE_SET(BgL_runz00_14153, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_11947)); 
PROCEDURE_SET(BgL_runz00_14153, 
(int)(((long)2)), BgL_valza2za2_14152); 
PROCEDURE_SET(BgL_runz00_14153, 
(int)(((long)3)), 
((obj_t)BgL_i1244z00_11948)); 
PROCEDURE_SET(BgL_runz00_14153, 
(int)(((long)4)), BgL_bodyz00_11949); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14154;
BgL_mainz00_14154 = 
MAKE_FX_PROCEDURE(BGl_z62main5154z62zz__evaluate_compz00, 
(int)(((long)2)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_mainz00_14154, 
(int)(((long)0)), BgL_iboxesz00_11946); 
PROCEDURE_SET(BgL_mainz00_14154, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_11947)); 
PROCEDURE_SET(BgL_mainz00_14154, 
(int)(((long)2)), BgL_valza2za2_14152); 
PROCEDURE_SET(BgL_mainz00_14154, 
(int)(((long)3)), 
((obj_t)BgL_i1244z00_11948)); 
PROCEDURE_SET(BgL_mainz00_14154, 
(int)(((long)4)), BgL_bodyz00_11949); 
PROCEDURE_SET(BgL_mainz00_14154, 
(int)(((long)5)), BgL_runz00_14153); 
PROCEDURE_SET(BgL_mainz00_14154, 
(int)(((long)6)), 
BINT(BgL_siza7ezd2framez75_11950)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14155;
BgL_objz00_14155 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14153, BgL_objz00_14155); BgL_objz00_14155; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3330z00_14156;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3331z00_14157;
BgL_arg3331z00_14157 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11948))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14158;
BgL_newz00_14158 = 
create_struct(BGl_symbol5225z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_25478;
BgL_tmpz00_25478 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14158, BgL_tmpz00_25478, BgL_arg3331z00_14157); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_25483;int BgL_tmpz00_25481;
BgL_auxz00_25483 = 
BINT(BgL_siza7ezd2framez75_11950); 
BgL_tmpz00_25481 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14158, BgL_tmpz00_25481, BgL_auxz00_25483); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_25486;
BgL_tmpz00_25486 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14158, BgL_tmpz00_25486, BgL_runz00_14153); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_25491;int BgL_tmpz00_25489;
BgL_auxz00_25491 = 
BINT(((long)2)); 
BgL_tmpz00_25489 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14158, BgL_tmpz00_25489, BgL_auxz00_25491); } 
BgL_arg3330z00_14156 = BgL_newz00_14158; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14154, BgL_arg3330z00_14156); BgL_arg3330z00_14156; } 
return BgL_mainz00_14154;} } } } } } 

}



/* &main5154 */
obj_t BGl_z62main5154z62zz__evaluate_compz00(obj_t BgL_envz00_11952, obj_t BgL_cz00_11960, obj_t BgL_dz00_11961)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11958;long BgL_siza7ezd2framez75_11959;
BgL_runz00_11958 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11952, 
(int)(((long)5)))); 
BgL_siza7ezd2framez75_11959 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11952, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14159;
BgL_sz00_14159 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14160;
BgL_bpz00_14160 = 
VECTOR_REF(
((obj_t)BgL_sz00_14159),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14159, BgL_bpz00_14160, 
BINT(BgL_siza7ezd2framez75_11959)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3334z00_14161;
BgL_arg3334z00_14161 = 
(
(long)CINT(BgL_bpz00_14160)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14159),BgL_arg3334z00_14161,BgL_cz00_11960); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3335z00_14162;
BgL_arg3335z00_14162 = 
(
(long)CINT(BgL_bpz00_14160)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_14159),BgL_arg3335z00_14162,BgL_dz00_11961); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14163;
BgL_ez00_14163 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14163, BgL_bpz00_14160); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14164;
BgL_accz00_14164 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11958, BgL_sz00_14159, BgL_bpz00_14160); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14163); 
VECTOR_SET(
((obj_t)BgL_sz00_14159),((long)0),BgL_bpz00_14160); 
return BgL_accz00_14164;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14165;
BgL_nsz00_14165 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14165,((long)1),BgL_sz00_14159); 
VECTOR_SET(BgL_nsz00_14165,((long)2),BgL_cz00_11960); 
VECTOR_SET(BgL_nsz00_14165,((long)3),BgL_dz00_11961); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14166;
BgL_z12denvz12_14166 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14166, BgL_nsz00_14165); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14167;
BgL_ez00_14167 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14167, BgL_sz00_14159); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14168;
BgL_____rz00_14168 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11958, BgL_nsz00_14165, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14167); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14166, BgL_sz00_14159); 
return BgL_____rz00_14168;} } } } } } } } 

}



/* &run5155 */
obj_t BGl_z62run5155z62zz__evaluate_compz00(obj_t BgL_envz00_11962, obj_t BgL_sz00_11968)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11963;long BgL_siza7eza7_11964;obj_t BgL_valza2za2_11965;BgL_ev_absz00_bglt BgL_i1244z00_11966;obj_t BgL_bodyz00_11967;
BgL_iboxesz00_11963 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11962, 
(int)(((long)0)))); 
BgL_siza7eza7_11964 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11962, 
(int)(((long)1)))); 
BgL_valza2za2_11965 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11962, 
(int)(((long)2)))); 
BgL_i1244z00_11966 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11962, 
(int)(((long)3)))); 
BgL_bodyz00_11967 = 
PROCEDURE_REF(BgL_envz00_11962, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14169;
BgL_bpz00_14169 = 
VECTOR_REF(
((obj_t)BgL_sz00_11968),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_11968, BgL_iboxesz00_11963, BgL_bpz00_14169); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_11968, BgL_valza2za2_11965, 
(
(long)CINT(BgL_bpz00_14169)+BgL_siza7eza7_11964)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_14170;obj_t BgL_wherez00_14171;obj_t BgL_locz00_14172;
BgL_z12denvz12_14170 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14171 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11966))->BgL_wherez00); 
BgL_locz00_14172 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11966))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14170, BgL_wherez00_14171, BgL_locz00_14172); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_14173;
BgL_za2za2resza2za2z00_14173 = 
PROCEDURE_ENTRY(BgL_bodyz00_11967)(BgL_bodyz00_11967, BgL_sz00_11968, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14170); 
return BgL_za2za2resza2za2z00_14173;} } } } } } 

}



/* &<@anonymous:3258> */
obj_t BGl_z62zc3z04anonymousza33258ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11969, obj_t BgL_sz00_11973)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_11970;obj_t BgL_bodyz00_11971;long BgL_siza7ezd2framez75_11972;
BgL_i1244z00_11970 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11969, 
(int)(((long)0)))); 
BgL_bodyz00_11971 = 
PROCEDURE_REF(BgL_envz00_11969, 
(int)(((long)1))); 
BgL_siza7ezd2framez75_11972 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11969, 
(int)(((long)2)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14174;
BgL_bpz00_14174 = 
VECTOR_REF(
((obj_t)BgL_sz00_11973),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14175;
BgL_runz00_14175 = 
MAKE_FX_PROCEDURE(BGl_z62run5157z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_runz00_14175, 
(int)(((long)0)), 
((obj_t)BgL_i1244z00_11970)); 
PROCEDURE_SET(BgL_runz00_14175, 
(int)(((long)1)), BgL_bodyz00_11971); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14176;
BgL_mainz00_14176 = 
MAKE_VA_PROCEDURE(BGl_z62main5156z62zz__evaluate_compz00, 
(int)(((long)-2)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_mainz00_14176, 
(int)(((long)0)), 
((obj_t)BgL_i1244z00_11970)); 
PROCEDURE_SET(BgL_mainz00_14176, 
(int)(((long)1)), BgL_bodyz00_11971); 
PROCEDURE_SET(BgL_mainz00_14176, 
(int)(((long)2)), BgL_runz00_14175); 
PROCEDURE_SET(BgL_mainz00_14176, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_11972)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14177;
BgL_objz00_14177 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14175, BgL_objz00_14177); BgL_objz00_14177; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3259z00_14178;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3260z00_14179;
BgL_arg3260z00_14179 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11970))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14180;
BgL_newz00_14180 = 
create_struct(BGl_symbol5225z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_25597;
BgL_tmpz00_25597 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14180, BgL_tmpz00_25597, BgL_arg3260z00_14179); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_25602;int BgL_tmpz00_25600;
BgL_auxz00_25602 = 
BINT(BgL_siza7ezd2framez75_11972); 
BgL_tmpz00_25600 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14180, BgL_tmpz00_25600, BgL_auxz00_25602); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_25605;
BgL_tmpz00_25605 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14180, BgL_tmpz00_25605, BgL_runz00_14175); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_25610;int BgL_tmpz00_25608;
BgL_auxz00_25610 = 
BINT(((long)-2)); 
BgL_tmpz00_25608 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14180, BgL_tmpz00_25608, BgL_auxz00_25610); } 
BgL_arg3259z00_14178 = BgL_newz00_14180; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14176, BgL_arg3259z00_14178); BgL_arg3259z00_14178; } 
return BgL_mainz00_14176;} } } } } } 

}



/* &main5156 */
obj_t BGl_z62main5156z62zz__evaluate_compz00(obj_t BgL_envz00_11974, obj_t BgL_dz00_11979, obj_t BgL_lastz00_11980)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11977;long BgL_siza7ezd2framez75_11978;
BgL_runz00_11977 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11974, 
(int)(((long)2)))); 
BgL_siza7ezd2framez75_11978 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11974, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14181;
BgL_sz00_14181 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14182;
BgL_bpz00_14182 = 
VECTOR_REF(
((obj_t)BgL_sz00_14181),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14181, BgL_bpz00_14182, 
BINT(BgL_siza7ezd2framez75_11978)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3263z00_14183;
BgL_arg3263z00_14183 = 
(
(long)CINT(BgL_bpz00_14182)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14181),BgL_arg3263z00_14183,BgL_dz00_11979); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3264z00_14184;
BgL_arg3264z00_14184 = 
(
(long)CINT(BgL_bpz00_14182)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_14181),BgL_arg3264z00_14184,BgL_lastz00_11980); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14185;
BgL_ez00_14185 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14185, BgL_bpz00_14182); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14186;
BgL_accz00_14186 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11977, BgL_sz00_14181, BgL_bpz00_14182); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14185); 
VECTOR_SET(
((obj_t)BgL_sz00_14181),((long)0),BgL_bpz00_14182); 
return BgL_accz00_14186;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14187;
BgL_nsz00_14187 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14187,((long)1),BgL_sz00_14181); 
VECTOR_SET(BgL_nsz00_14187,((long)2),BgL_dz00_11979); 
VECTOR_SET(BgL_nsz00_14187,((long)3),BgL_lastz00_11980); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14188;
BgL_z12denvz12_14188 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14188, BgL_nsz00_14187); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14189;
BgL_ez00_14189 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14189, BgL_sz00_14181); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14190;
BgL_____rz00_14190 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11977, BgL_nsz00_14187, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14189); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14188, BgL_sz00_14181); 
return BgL_____rz00_14190;} } } } } } } } 

}



/* &run5157 */
obj_t BGl_z62run5157z62zz__evaluate_compz00(obj_t BgL_envz00_11981, obj_t BgL_sz00_11984)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_11982;obj_t BgL_bodyz00_11983;
BgL_i1244z00_11982 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11981, 
(int)(((long)0)))); 
BgL_bodyz00_11983 = 
PROCEDURE_REF(BgL_envz00_11981, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14191;
BgL_bpz00_14191 = 
VECTOR_REF(
((obj_t)BgL_sz00_11984),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14192;obj_t BgL_wherez00_14193;obj_t BgL_locz00_14194;
BgL_z12denvz12_14192 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14193 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11982))->BgL_wherez00); 
BgL_locz00_14194 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11982))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14192, BgL_wherez00_14193, BgL_locz00_14194); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_14195;
BgL_za2za2resza2za2z00_14195 = 
PROCEDURE_ENTRY(BgL_bodyz00_11983)(BgL_bodyz00_11983, BgL_sz00_11984, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14192); 
return BgL_za2za2resza2za2z00_14195;} } } } } } 

}



/* &<@anonymous:3266> */
obj_t BGl_z62zc3z04anonymousza33266ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11985, obj_t BgL_sz00_11990)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11986;BgL_ev_absz00_bglt BgL_i1244z00_11987;obj_t BgL_bodyz00_11988;long BgL_siza7ezd2framez75_11989;
BgL_iboxesz00_11986 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11985, 
(int)(((long)0)))); 
BgL_i1244z00_11987 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11985, 
(int)(((long)1)))); 
BgL_bodyz00_11988 = 
PROCEDURE_REF(BgL_envz00_11985, 
(int)(((long)2))); 
BgL_siza7ezd2framez75_11989 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11985, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14196;
BgL_bpz00_14196 = 
VECTOR_REF(
((obj_t)BgL_sz00_11990),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14197;
BgL_runz00_14197 = 
MAKE_FX_PROCEDURE(BGl_z62run5159z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_runz00_14197, 
(int)(((long)0)), BgL_iboxesz00_11986); 
PROCEDURE_SET(BgL_runz00_14197, 
(int)(((long)1)), 
((obj_t)BgL_i1244z00_11987)); 
PROCEDURE_SET(BgL_runz00_14197, 
(int)(((long)2)), BgL_bodyz00_11988); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14198;
BgL_mainz00_14198 = 
MAKE_VA_PROCEDURE(BGl_z62main5158z62zz__evaluate_compz00, 
(int)(((long)-2)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_mainz00_14198, 
(int)(((long)0)), BgL_iboxesz00_11986); 
PROCEDURE_SET(BgL_mainz00_14198, 
(int)(((long)1)), 
((obj_t)BgL_i1244z00_11987)); 
PROCEDURE_SET(BgL_mainz00_14198, 
(int)(((long)2)), BgL_bodyz00_11988); 
PROCEDURE_SET(BgL_mainz00_14198, 
(int)(((long)3)), BgL_runz00_14197); 
PROCEDURE_SET(BgL_mainz00_14198, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_11989)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14199;
BgL_objz00_14199 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14197, BgL_objz00_14199); BgL_objz00_14199; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3267z00_14200;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3268z00_14201;
BgL_arg3268z00_14201 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11987))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14202;
BgL_newz00_14202 = 
create_struct(BGl_symbol5225z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_25710;
BgL_tmpz00_25710 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14202, BgL_tmpz00_25710, BgL_arg3268z00_14201); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_25715;int BgL_tmpz00_25713;
BgL_auxz00_25715 = 
BINT(BgL_siza7ezd2framez75_11989); 
BgL_tmpz00_25713 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14202, BgL_tmpz00_25713, BgL_auxz00_25715); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_25718;
BgL_tmpz00_25718 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14202, BgL_tmpz00_25718, BgL_runz00_14197); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_25723;int BgL_tmpz00_25721;
BgL_auxz00_25723 = 
BINT(((long)-2)); 
BgL_tmpz00_25721 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14202, BgL_tmpz00_25721, BgL_auxz00_25723); } 
BgL_arg3267z00_14200 = BgL_newz00_14202; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14198, BgL_arg3267z00_14200); BgL_arg3267z00_14200; } 
return BgL_mainz00_14198;} } } } } } 

}



/* &main5158 */
obj_t BGl_z62main5158z62zz__evaluate_compz00(obj_t BgL_envz00_11991, obj_t BgL_dz00_11997, obj_t BgL_lastz00_11998)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11995;long BgL_siza7ezd2framez75_11996;
BgL_runz00_11995 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11991, 
(int)(((long)3)))); 
BgL_siza7ezd2framez75_11996 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11991, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14203;
BgL_sz00_14203 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14204;
BgL_bpz00_14204 = 
VECTOR_REF(
((obj_t)BgL_sz00_14203),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14203, BgL_bpz00_14204, 
BINT(BgL_siza7ezd2framez75_11996)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3271z00_14205;
BgL_arg3271z00_14205 = 
(
(long)CINT(BgL_bpz00_14204)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14203),BgL_arg3271z00_14205,BgL_dz00_11997); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3272z00_14206;
BgL_arg3272z00_14206 = 
(
(long)CINT(BgL_bpz00_14204)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_14203),BgL_arg3272z00_14206,BgL_lastz00_11998); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14207;
BgL_ez00_14207 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14207, BgL_bpz00_14204); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14208;
BgL_accz00_14208 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11995, BgL_sz00_14203, BgL_bpz00_14204); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14207); 
VECTOR_SET(
((obj_t)BgL_sz00_14203),((long)0),BgL_bpz00_14204); 
return BgL_accz00_14208;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14209;
BgL_nsz00_14209 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14209,((long)1),BgL_sz00_14203); 
VECTOR_SET(BgL_nsz00_14209,((long)2),BgL_dz00_11997); 
VECTOR_SET(BgL_nsz00_14209,((long)3),BgL_lastz00_11998); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14210;
BgL_z12denvz12_14210 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14210, BgL_nsz00_14209); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14211;
BgL_ez00_14211 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14211, BgL_sz00_14203); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14212;
BgL_____rz00_14212 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11995, BgL_nsz00_14209, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14211); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14210, BgL_sz00_14203); 
return BgL_____rz00_14212;} } } } } } } } 

}



/* &run5159 */
obj_t BGl_z62run5159z62zz__evaluate_compz00(obj_t BgL_envz00_11999, obj_t BgL_sz00_12003)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_12000;BgL_ev_absz00_bglt BgL_i1244z00_12001;obj_t BgL_bodyz00_12002;
BgL_iboxesz00_12000 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11999, 
(int)(((long)0)))); 
BgL_i1244z00_12001 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11999, 
(int)(((long)1)))); 
BgL_bodyz00_12002 = 
PROCEDURE_REF(BgL_envz00_11999, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14213;
BgL_bpz00_14213 = 
VECTOR_REF(
((obj_t)BgL_sz00_12003),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_12003, BgL_iboxesz00_12000, BgL_bpz00_14213); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14214;obj_t BgL_wherez00_14215;obj_t BgL_locz00_14216;
BgL_z12denvz12_14214 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14215 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12001))->BgL_wherez00); 
BgL_locz00_14216 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12001))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14214, BgL_wherez00_14215, BgL_locz00_14216); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_14217;
BgL_za2za2resza2za2z00_14217 = 
PROCEDURE_ENTRY(BgL_bodyz00_12002)(BgL_bodyz00_12002, BgL_sz00_12003, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14214); 
return BgL_za2za2resza2za2z00_14217;} } } } } } 

}



/* &<@anonymous:3277> */
obj_t BGl_z62zc3z04anonymousza33277ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12004, obj_t BgL_sz00_12010)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_12005;long BgL_siza7eza7_12006;BgL_ev_absz00_bglt BgL_i1244z00_12007;obj_t BgL_bodyz00_12008;long BgL_siza7ezd2framez75_12009;
BgL_ifreesz00_12005 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12004, 
(int)(((long)0)))); 
BgL_siza7eza7_12006 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12004, 
(int)(((long)1)))); 
BgL_i1244z00_12007 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12004, 
(int)(((long)2)))); 
BgL_bodyz00_12008 = 
PROCEDURE_REF(BgL_envz00_12004, 
(int)(((long)3))); 
BgL_siza7ezd2framez75_12009 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12004, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14218;
BgL_bpz00_14218 = 
VECTOR_REF(
((obj_t)BgL_sz00_12010),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_14219;
BgL_valza2za2_14219 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_12010, BgL_bpz00_14218, BgL_ifreesz00_12005); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14220;
BgL_runz00_14220 = 
MAKE_FX_PROCEDURE(BGl_z62run5161z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_runz00_14220, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_12006)); 
PROCEDURE_SET(BgL_runz00_14220, 
(int)(((long)1)), BgL_valza2za2_14219); 
PROCEDURE_SET(BgL_runz00_14220, 
(int)(((long)2)), 
((obj_t)BgL_i1244z00_12007)); 
PROCEDURE_SET(BgL_runz00_14220, 
(int)(((long)3)), BgL_bodyz00_12008); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14221;
BgL_mainz00_14221 = 
MAKE_VA_PROCEDURE(BGl_z62main5160z62zz__evaluate_compz00, 
(int)(((long)-2)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_mainz00_14221, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_12006)); 
PROCEDURE_SET(BgL_mainz00_14221, 
(int)(((long)1)), BgL_valza2za2_14219); 
PROCEDURE_SET(BgL_mainz00_14221, 
(int)(((long)2)), 
((obj_t)BgL_i1244z00_12007)); 
PROCEDURE_SET(BgL_mainz00_14221, 
(int)(((long)3)), BgL_bodyz00_12008); 
PROCEDURE_SET(BgL_mainz00_14221, 
(int)(((long)4)), BgL_runz00_14220); 
PROCEDURE_SET(BgL_mainz00_14221, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_12009)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14222;
BgL_objz00_14222 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14220, BgL_objz00_14222); BgL_objz00_14222; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3278z00_14223;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3279z00_14224;
BgL_arg3279z00_14224 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12007))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14225;
BgL_newz00_14225 = 
create_struct(BGl_symbol5225z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_25837;
BgL_tmpz00_25837 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14225, BgL_tmpz00_25837, BgL_arg3279z00_14224); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_25842;int BgL_tmpz00_25840;
BgL_auxz00_25842 = 
BINT(BgL_siza7ezd2framez75_12009); 
BgL_tmpz00_25840 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14225, BgL_tmpz00_25840, BgL_auxz00_25842); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_25845;
BgL_tmpz00_25845 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14225, BgL_tmpz00_25845, BgL_runz00_14220); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_25850;int BgL_tmpz00_25848;
BgL_auxz00_25850 = 
BINT(((long)-2)); 
BgL_tmpz00_25848 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14225, BgL_tmpz00_25848, BgL_auxz00_25850); } 
BgL_arg3278z00_14223 = BgL_newz00_14225; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14221, BgL_arg3278z00_14223); BgL_arg3278z00_14223; } 
return BgL_mainz00_14221;} } } } } } 

}



/* &main5160 */
obj_t BGl_z62main5160z62zz__evaluate_compz00(obj_t BgL_envz00_12011, obj_t BgL_dz00_12018, obj_t BgL_lastz00_12019)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_12016;long BgL_siza7ezd2framez75_12017;
BgL_runz00_12016 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12011, 
(int)(((long)4)))); 
BgL_siza7ezd2framez75_12017 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12011, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14226;
BgL_sz00_14226 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14227;
BgL_bpz00_14227 = 
VECTOR_REF(
((obj_t)BgL_sz00_14226),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14226, BgL_bpz00_14227, 
BINT(BgL_siza7ezd2framez75_12017)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3282z00_14228;
BgL_arg3282z00_14228 = 
(
(long)CINT(BgL_bpz00_14227)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14226),BgL_arg3282z00_14228,BgL_dz00_12018); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3283z00_14229;
BgL_arg3283z00_14229 = 
(
(long)CINT(BgL_bpz00_14227)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_14226),BgL_arg3283z00_14229,BgL_lastz00_12019); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14230;
BgL_ez00_14230 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14230, BgL_bpz00_14227); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14231;
BgL_accz00_14231 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12016, BgL_sz00_14226, BgL_bpz00_14227); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14230); 
VECTOR_SET(
((obj_t)BgL_sz00_14226),((long)0),BgL_bpz00_14227); 
return BgL_accz00_14231;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14232;
BgL_nsz00_14232 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14232,((long)1),BgL_sz00_14226); 
VECTOR_SET(BgL_nsz00_14232,((long)2),BgL_dz00_12018); 
VECTOR_SET(BgL_nsz00_14232,((long)3),BgL_lastz00_12019); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14233;
BgL_z12denvz12_14233 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14233, BgL_nsz00_14232); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14234;
BgL_ez00_14234 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14234, BgL_sz00_14226); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14235;
BgL_____rz00_14235 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12016, BgL_nsz00_14232, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14234); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14233, BgL_sz00_14226); 
return BgL_____rz00_14235;} } } } } } } } 

}



/* &run5161 */
obj_t BGl_z62run5161z62zz__evaluate_compz00(obj_t BgL_envz00_12020, obj_t BgL_sz00_12025)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_siza7eza7_12021;obj_t BgL_valza2za2_12022;BgL_ev_absz00_bglt BgL_i1244z00_12023;obj_t BgL_bodyz00_12024;
BgL_siza7eza7_12021 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12020, 
(int)(((long)0)))); 
BgL_valza2za2_12022 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12020, 
(int)(((long)1)))); 
BgL_i1244z00_12023 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12020, 
(int)(((long)2)))); 
BgL_bodyz00_12024 = 
PROCEDURE_REF(BgL_envz00_12020, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14236;
BgL_bpz00_14236 = 
VECTOR_REF(
((obj_t)BgL_sz00_12025),((long)0)); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_12025, BgL_valza2za2_12022, 
(
(long)CINT(BgL_bpz00_14236)+BgL_siza7eza7_12021)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_14237;obj_t BgL_wherez00_14238;obj_t BgL_locz00_14239;
BgL_z12denvz12_14237 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14238 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12023))->BgL_wherez00); 
BgL_locz00_14239 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12023))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14237, BgL_wherez00_14238, BgL_locz00_14239); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_14240;
BgL_za2za2resza2za2z00_14240 = 
PROCEDURE_ENTRY(BgL_bodyz00_12024)(BgL_bodyz00_12024, BgL_sz00_12025, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14237); 
return BgL_za2za2resza2za2z00_14240;} } } } } } 

}



/* &<@anonymous:3286> */
obj_t BGl_z62zc3z04anonymousza33286ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12026, obj_t BgL_sz00_12033)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_12027;obj_t BgL_iboxesz00_12028;long BgL_siza7eza7_12029;BgL_ev_absz00_bglt BgL_i1244z00_12030;obj_t BgL_bodyz00_12031;long BgL_siza7ezd2framez75_12032;
BgL_ifreesz00_12027 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12026, 
(int)(((long)0)))); 
BgL_iboxesz00_12028 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12026, 
(int)(((long)1)))); 
BgL_siza7eza7_12029 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12026, 
(int)(((long)2)))); 
BgL_i1244z00_12030 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12026, 
(int)(((long)3)))); 
BgL_bodyz00_12031 = 
PROCEDURE_REF(BgL_envz00_12026, 
(int)(((long)4))); 
BgL_siza7ezd2framez75_12032 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12026, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14241;
BgL_bpz00_14241 = 
VECTOR_REF(
((obj_t)BgL_sz00_12033),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_14242;
BgL_valza2za2_14242 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_12033, BgL_bpz00_14241, BgL_ifreesz00_12027); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14243;
BgL_runz00_14243 = 
MAKE_FX_PROCEDURE(BGl_z62run5163z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_runz00_14243, 
(int)(((long)0)), BgL_iboxesz00_12028); 
PROCEDURE_SET(BgL_runz00_14243, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_12029)); 
PROCEDURE_SET(BgL_runz00_14243, 
(int)(((long)2)), BgL_valza2za2_14242); 
PROCEDURE_SET(BgL_runz00_14243, 
(int)(((long)3)), 
((obj_t)BgL_i1244z00_12030)); 
PROCEDURE_SET(BgL_runz00_14243, 
(int)(((long)4)), BgL_bodyz00_12031); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14244;
BgL_mainz00_14244 = 
MAKE_VA_PROCEDURE(BGl_z62main5162z62zz__evaluate_compz00, 
(int)(((long)-2)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_mainz00_14244, 
(int)(((long)0)), BgL_iboxesz00_12028); 
PROCEDURE_SET(BgL_mainz00_14244, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_12029)); 
PROCEDURE_SET(BgL_mainz00_14244, 
(int)(((long)2)), BgL_valza2za2_14242); 
PROCEDURE_SET(BgL_mainz00_14244, 
(int)(((long)3)), 
((obj_t)BgL_i1244z00_12030)); 
PROCEDURE_SET(BgL_mainz00_14244, 
(int)(((long)4)), BgL_bodyz00_12031); 
PROCEDURE_SET(BgL_mainz00_14244, 
(int)(((long)5)), BgL_runz00_14243); 
PROCEDURE_SET(BgL_mainz00_14244, 
(int)(((long)6)), 
BINT(BgL_siza7ezd2framez75_12032)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14245;
BgL_objz00_14245 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14243, BgL_objz00_14245); BgL_objz00_14245; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3287z00_14246;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3288z00_14247;
BgL_arg3288z00_14247 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12030))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14248;
BgL_newz00_14248 = 
create_struct(BGl_symbol5225z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_25976;
BgL_tmpz00_25976 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14248, BgL_tmpz00_25976, BgL_arg3288z00_14247); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_25981;int BgL_tmpz00_25979;
BgL_auxz00_25981 = 
BINT(BgL_siza7ezd2framez75_12032); 
BgL_tmpz00_25979 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14248, BgL_tmpz00_25979, BgL_auxz00_25981); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_25984;
BgL_tmpz00_25984 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14248, BgL_tmpz00_25984, BgL_runz00_14243); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_25989;int BgL_tmpz00_25987;
BgL_auxz00_25989 = 
BINT(((long)-2)); 
BgL_tmpz00_25987 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14248, BgL_tmpz00_25987, BgL_auxz00_25989); } 
BgL_arg3287z00_14246 = BgL_newz00_14248; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14244, BgL_arg3287z00_14246); BgL_arg3287z00_14246; } 
return BgL_mainz00_14244;} } } } } } 

}



/* &main5162 */
obj_t BGl_z62main5162z62zz__evaluate_compz00(obj_t BgL_envz00_12034, obj_t BgL_dz00_12042, obj_t BgL_lastz00_12043)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_12040;long BgL_siza7ezd2framez75_12041;
BgL_runz00_12040 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12034, 
(int)(((long)5)))); 
BgL_siza7ezd2framez75_12041 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12034, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14249;
BgL_sz00_14249 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14250;
BgL_bpz00_14250 = 
VECTOR_REF(
((obj_t)BgL_sz00_14249),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14249, BgL_bpz00_14250, 
BINT(BgL_siza7ezd2framez75_12041)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3291z00_14251;
BgL_arg3291z00_14251 = 
(
(long)CINT(BgL_bpz00_14250)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14249),BgL_arg3291z00_14251,BgL_dz00_12042); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3292z00_14252;
BgL_arg3292z00_14252 = 
(
(long)CINT(BgL_bpz00_14250)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_14249),BgL_arg3292z00_14252,BgL_lastz00_12043); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14253;
BgL_ez00_14253 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14253, BgL_bpz00_14250); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14254;
BgL_accz00_14254 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12040, BgL_sz00_14249, BgL_bpz00_14250); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14253); 
VECTOR_SET(
((obj_t)BgL_sz00_14249),((long)0),BgL_bpz00_14250); 
return BgL_accz00_14254;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14255;
BgL_nsz00_14255 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14255,((long)1),BgL_sz00_14249); 
VECTOR_SET(BgL_nsz00_14255,((long)2),BgL_dz00_12042); 
VECTOR_SET(BgL_nsz00_14255,((long)3),BgL_lastz00_12043); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14256;
BgL_z12denvz12_14256 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14256, BgL_nsz00_14255); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14257;
BgL_ez00_14257 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14257, BgL_sz00_14249); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14258;
BgL_____rz00_14258 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12040, BgL_nsz00_14255, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14257); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14256, BgL_sz00_14249); 
return BgL_____rz00_14258;} } } } } } } } 

}



/* &run5163 */
obj_t BGl_z62run5163z62zz__evaluate_compz00(obj_t BgL_envz00_12044, obj_t BgL_sz00_12050)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_12045;long BgL_siza7eza7_12046;obj_t BgL_valza2za2_12047;BgL_ev_absz00_bglt BgL_i1244z00_12048;obj_t BgL_bodyz00_12049;
BgL_iboxesz00_12045 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12044, 
(int)(((long)0)))); 
BgL_siza7eza7_12046 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12044, 
(int)(((long)1)))); 
BgL_valza2za2_12047 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12044, 
(int)(((long)2)))); 
BgL_i1244z00_12048 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12044, 
(int)(((long)3)))); 
BgL_bodyz00_12049 = 
PROCEDURE_REF(BgL_envz00_12044, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14259;
BgL_bpz00_14259 = 
VECTOR_REF(
((obj_t)BgL_sz00_12050),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_12050, BgL_iboxesz00_12045, BgL_bpz00_14259); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_12050, BgL_valza2za2_12047, 
(
(long)CINT(BgL_bpz00_14259)+BgL_siza7eza7_12046)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_14260;obj_t BgL_wherez00_14261;obj_t BgL_locz00_14262;
BgL_z12denvz12_14260 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14261 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12048))->BgL_wherez00); 
BgL_locz00_14262 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12048))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14260, BgL_wherez00_14261, BgL_locz00_14262); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_14263;
BgL_za2za2resza2za2z00_14263 = 
PROCEDURE_ENTRY(BgL_bodyz00_12049)(BgL_bodyz00_12049, BgL_sz00_12050, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14260); 
return BgL_za2za2resza2za2z00_14263;} } } } } } 

}



/* &<@anonymous:3219> */
obj_t BGl_z62zc3z04anonymousza33219ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12051, obj_t BgL_sz00_12055)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_12052;obj_t BgL_bodyz00_12053;long BgL_siza7ezd2framez75_12054;
BgL_i1244z00_12052 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12051, 
(int)(((long)0)))); 
BgL_bodyz00_12053 = 
PROCEDURE_REF(BgL_envz00_12051, 
(int)(((long)1))); 
BgL_siza7ezd2framez75_12054 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12051, 
(int)(((long)2)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14264;
BgL_bpz00_14264 = 
VECTOR_REF(
((obj_t)BgL_sz00_12055),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14265;
BgL_runz00_14265 = 
MAKE_FX_PROCEDURE(BGl_z62run5165z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_runz00_14265, 
(int)(((long)0)), 
((obj_t)BgL_i1244z00_12052)); 
PROCEDURE_SET(BgL_runz00_14265, 
(int)(((long)1)), BgL_bodyz00_12053); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14266;
BgL_mainz00_14266 = 
MAKE_FX_PROCEDURE(BGl_z62main5164z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_mainz00_14266, 
(int)(((long)0)), 
((obj_t)BgL_i1244z00_12052)); 
PROCEDURE_SET(BgL_mainz00_14266, 
(int)(((long)1)), BgL_bodyz00_12053); 
PROCEDURE_SET(BgL_mainz00_14266, 
(int)(((long)2)), BgL_runz00_14265); 
PROCEDURE_SET(BgL_mainz00_14266, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_12054)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14267;
BgL_objz00_14267 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14265, BgL_objz00_14267); BgL_objz00_14267; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3220z00_14268;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3221z00_14269;
BgL_arg3221z00_14269 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12052))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14270;
BgL_newz00_14270 = 
create_struct(BGl_symbol5225z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26095;
BgL_tmpz00_26095 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14270, BgL_tmpz00_26095, BgL_arg3221z00_14269); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_26100;int BgL_tmpz00_26098;
BgL_auxz00_26100 = 
BINT(BgL_siza7ezd2framez75_12054); 
BgL_tmpz00_26098 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14270, BgL_tmpz00_26098, BgL_auxz00_26100); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26103;
BgL_tmpz00_26103 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14270, BgL_tmpz00_26103, BgL_runz00_14265); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_26108;int BgL_tmpz00_26106;
BgL_auxz00_26108 = 
BINT(((long)1)); 
BgL_tmpz00_26106 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14270, BgL_tmpz00_26106, BgL_auxz00_26108); } 
BgL_arg3220z00_14268 = BgL_newz00_14270; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14266, BgL_arg3220z00_14268); BgL_arg3220z00_14268; } 
return BgL_mainz00_14266;} } } } } } 

}



/* &main5164 */
obj_t BGl_z62main5164z62zz__evaluate_compz00(obj_t BgL_envz00_12056, obj_t BgL_dz00_12061)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_12059;long BgL_siza7ezd2framez75_12060;
BgL_runz00_12059 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12056, 
(int)(((long)2)))); 
BgL_siza7ezd2framez75_12060 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12056, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14271;
BgL_sz00_14271 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14272;
BgL_bpz00_14272 = 
VECTOR_REF(
((obj_t)BgL_sz00_14271),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14271, BgL_bpz00_14272, 
BINT(BgL_siza7ezd2framez75_12060)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3224z00_14273;
BgL_arg3224z00_14273 = 
(
(long)CINT(BgL_bpz00_14272)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14271),BgL_arg3224z00_14273,BgL_dz00_12061); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14274;
BgL_ez00_14274 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14274, BgL_bpz00_14272); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14275;
BgL_accz00_14275 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12059, BgL_sz00_14271, BgL_bpz00_14272); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14274); 
VECTOR_SET(
((obj_t)BgL_sz00_14271),((long)0),BgL_bpz00_14272); 
return BgL_accz00_14275;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14276;
BgL_nsz00_14276 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14276,((long)1),BgL_sz00_14271); 
VECTOR_SET(BgL_nsz00_14276,((long)2),BgL_dz00_12061); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14277;
BgL_z12denvz12_14277 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14277, BgL_nsz00_14276); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14278;
BgL_ez00_14278 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14278, BgL_sz00_14271); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14279;
BgL_____rz00_14279 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12059, BgL_nsz00_14276, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14278); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14277, BgL_sz00_14271); 
return BgL_____rz00_14279;} } } } } } } } 

}



/* &run5165 */
obj_t BGl_z62run5165z62zz__evaluate_compz00(obj_t BgL_envz00_12062, obj_t BgL_sz00_12065)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_12063;obj_t BgL_bodyz00_12064;
BgL_i1244z00_12063 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12062, 
(int)(((long)0)))); 
BgL_bodyz00_12064 = 
PROCEDURE_REF(BgL_envz00_12062, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14280;
BgL_bpz00_14280 = 
VECTOR_REF(
((obj_t)BgL_sz00_12065),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14281;obj_t BgL_wherez00_14282;obj_t BgL_locz00_14283;
BgL_z12denvz12_14281 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14282 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12063))->BgL_wherez00); 
BgL_locz00_14283 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12063))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14281, BgL_wherez00_14282, BgL_locz00_14283); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_14284;
BgL_za2za2resza2za2z00_14284 = 
PROCEDURE_ENTRY(BgL_bodyz00_12064)(BgL_bodyz00_12064, BgL_sz00_12065, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14281); 
return BgL_za2za2resza2za2z00_14284;} } } } } } 

}



/* &<@anonymous:3226> */
obj_t BGl_z62zc3z04anonymousza33226ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12066, obj_t BgL_sz00_12071)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_12067;BgL_ev_absz00_bglt BgL_i1244z00_12068;obj_t BgL_bodyz00_12069;long BgL_siza7ezd2framez75_12070;
BgL_iboxesz00_12067 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12066, 
(int)(((long)0)))); 
BgL_i1244z00_12068 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12066, 
(int)(((long)1)))); 
BgL_bodyz00_12069 = 
PROCEDURE_REF(BgL_envz00_12066, 
(int)(((long)2))); 
BgL_siza7ezd2framez75_12070 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12066, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14285;
BgL_bpz00_14285 = 
VECTOR_REF(
((obj_t)BgL_sz00_12071),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14286;
BgL_runz00_14286 = 
MAKE_FX_PROCEDURE(BGl_z62run5167z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_runz00_14286, 
(int)(((long)0)), BgL_iboxesz00_12067); 
PROCEDURE_SET(BgL_runz00_14286, 
(int)(((long)1)), 
((obj_t)BgL_i1244z00_12068)); 
PROCEDURE_SET(BgL_runz00_14286, 
(int)(((long)2)), BgL_bodyz00_12069); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14287;
BgL_mainz00_14287 = 
MAKE_FX_PROCEDURE(BGl_z62main5166z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_mainz00_14287, 
(int)(((long)0)), BgL_iboxesz00_12067); 
PROCEDURE_SET(BgL_mainz00_14287, 
(int)(((long)1)), 
((obj_t)BgL_i1244z00_12068)); 
PROCEDURE_SET(BgL_mainz00_14287, 
(int)(((long)2)), BgL_bodyz00_12069); 
PROCEDURE_SET(BgL_mainz00_14287, 
(int)(((long)3)), BgL_runz00_14286); 
PROCEDURE_SET(BgL_mainz00_14287, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_12070)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14288;
BgL_objz00_14288 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14286, BgL_objz00_14288); BgL_objz00_14288; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3227z00_14289;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3228z00_14290;
BgL_arg3228z00_14290 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12068))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14291;
BgL_newz00_14291 = 
create_struct(BGl_symbol5225z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26203;
BgL_tmpz00_26203 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14291, BgL_tmpz00_26203, BgL_arg3228z00_14290); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_26208;int BgL_tmpz00_26206;
BgL_auxz00_26208 = 
BINT(BgL_siza7ezd2framez75_12070); 
BgL_tmpz00_26206 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14291, BgL_tmpz00_26206, BgL_auxz00_26208); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26211;
BgL_tmpz00_26211 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14291, BgL_tmpz00_26211, BgL_runz00_14286); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_26216;int BgL_tmpz00_26214;
BgL_auxz00_26216 = 
BINT(((long)1)); 
BgL_tmpz00_26214 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14291, BgL_tmpz00_26214, BgL_auxz00_26216); } 
BgL_arg3227z00_14289 = BgL_newz00_14291; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14287, BgL_arg3227z00_14289); BgL_arg3227z00_14289; } 
return BgL_mainz00_14287;} } } } } } 

}



/* &main5166 */
obj_t BGl_z62main5166z62zz__evaluate_compz00(obj_t BgL_envz00_12072, obj_t BgL_dz00_12078)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_12076;long BgL_siza7ezd2framez75_12077;
BgL_runz00_12076 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12072, 
(int)(((long)3)))); 
BgL_siza7ezd2framez75_12077 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12072, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14292;
BgL_sz00_14292 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14293;
BgL_bpz00_14293 = 
VECTOR_REF(
((obj_t)BgL_sz00_14292),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14292, BgL_bpz00_14293, 
BINT(BgL_siza7ezd2framez75_12077)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3231z00_14294;
BgL_arg3231z00_14294 = 
(
(long)CINT(BgL_bpz00_14293)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14292),BgL_arg3231z00_14294,BgL_dz00_12078); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14295;
BgL_ez00_14295 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14295, BgL_bpz00_14293); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14296;
BgL_accz00_14296 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12076, BgL_sz00_14292, BgL_bpz00_14293); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14295); 
VECTOR_SET(
((obj_t)BgL_sz00_14292),((long)0),BgL_bpz00_14293); 
return BgL_accz00_14296;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14297;
BgL_nsz00_14297 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14297,((long)1),BgL_sz00_14292); 
VECTOR_SET(BgL_nsz00_14297,((long)2),BgL_dz00_12078); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14298;
BgL_z12denvz12_14298 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14298, BgL_nsz00_14297); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14299;
BgL_ez00_14299 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14299, BgL_sz00_14292); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14300;
BgL_____rz00_14300 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12076, BgL_nsz00_14297, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14299); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14298, BgL_sz00_14292); 
return BgL_____rz00_14300;} } } } } } } } 

}



/* &run5167 */
obj_t BGl_z62run5167z62zz__evaluate_compz00(obj_t BgL_envz00_12079, obj_t BgL_sz00_12083)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_12080;BgL_ev_absz00_bglt BgL_i1244z00_12081;obj_t BgL_bodyz00_12082;
BgL_iboxesz00_12080 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12079, 
(int)(((long)0)))); 
BgL_i1244z00_12081 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12079, 
(int)(((long)1)))); 
BgL_bodyz00_12082 = 
PROCEDURE_REF(BgL_envz00_12079, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14301;
BgL_bpz00_14301 = 
VECTOR_REF(
((obj_t)BgL_sz00_12083),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_12083, BgL_iboxesz00_12080, BgL_bpz00_14301); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14302;obj_t BgL_wherez00_14303;obj_t BgL_locz00_14304;
BgL_z12denvz12_14302 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14303 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12081))->BgL_wherez00); 
BgL_locz00_14304 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12081))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14302, BgL_wherez00_14303, BgL_locz00_14304); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_14305;
BgL_za2za2resza2za2z00_14305 = 
PROCEDURE_ENTRY(BgL_bodyz00_12082)(BgL_bodyz00_12082, BgL_sz00_12083, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14302); 
return BgL_za2za2resza2za2z00_14305;} } } } } } 

}



/* &<@anonymous:3236> */
obj_t BGl_z62zc3z04anonymousza33236ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12084, obj_t BgL_sz00_12090)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_12085;long BgL_siza7eza7_12086;BgL_ev_absz00_bglt BgL_i1244z00_12087;obj_t BgL_bodyz00_12088;long BgL_siza7ezd2framez75_12089;
BgL_ifreesz00_12085 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12084, 
(int)(((long)0)))); 
BgL_siza7eza7_12086 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12084, 
(int)(((long)1)))); 
BgL_i1244z00_12087 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12084, 
(int)(((long)2)))); 
BgL_bodyz00_12088 = 
PROCEDURE_REF(BgL_envz00_12084, 
(int)(((long)3))); 
BgL_siza7ezd2framez75_12089 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12084, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14306;
BgL_bpz00_14306 = 
VECTOR_REF(
((obj_t)BgL_sz00_12090),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_14307;
BgL_valza2za2_14307 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_12090, BgL_bpz00_14306, BgL_ifreesz00_12085); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14308;
BgL_runz00_14308 = 
MAKE_FX_PROCEDURE(BGl_z62run5169z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_runz00_14308, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_12086)); 
PROCEDURE_SET(BgL_runz00_14308, 
(int)(((long)1)), BgL_valza2za2_14307); 
PROCEDURE_SET(BgL_runz00_14308, 
(int)(((long)2)), 
((obj_t)BgL_i1244z00_12087)); 
PROCEDURE_SET(BgL_runz00_14308, 
(int)(((long)3)), BgL_bodyz00_12088); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14309;
BgL_mainz00_14309 = 
MAKE_FX_PROCEDURE(BGl_z62main5168z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_mainz00_14309, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_12086)); 
PROCEDURE_SET(BgL_mainz00_14309, 
(int)(((long)1)), BgL_valza2za2_14307); 
PROCEDURE_SET(BgL_mainz00_14309, 
(int)(((long)2)), 
((obj_t)BgL_i1244z00_12087)); 
PROCEDURE_SET(BgL_mainz00_14309, 
(int)(((long)3)), BgL_bodyz00_12088); 
PROCEDURE_SET(BgL_mainz00_14309, 
(int)(((long)4)), BgL_runz00_14308); 
PROCEDURE_SET(BgL_mainz00_14309, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_12089)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14310;
BgL_objz00_14310 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14308, BgL_objz00_14310); BgL_objz00_14310; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3237z00_14311;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3238z00_14312;
BgL_arg3238z00_14312 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12087))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14313;
BgL_newz00_14313 = 
create_struct(BGl_symbol5225z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26325;
BgL_tmpz00_26325 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14313, BgL_tmpz00_26325, BgL_arg3238z00_14312); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_26330;int BgL_tmpz00_26328;
BgL_auxz00_26330 = 
BINT(BgL_siza7ezd2framez75_12089); 
BgL_tmpz00_26328 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14313, BgL_tmpz00_26328, BgL_auxz00_26330); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26333;
BgL_tmpz00_26333 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14313, BgL_tmpz00_26333, BgL_runz00_14308); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_26338;int BgL_tmpz00_26336;
BgL_auxz00_26338 = 
BINT(((long)1)); 
BgL_tmpz00_26336 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14313, BgL_tmpz00_26336, BgL_auxz00_26338); } 
BgL_arg3237z00_14311 = BgL_newz00_14313; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14309, BgL_arg3237z00_14311); BgL_arg3237z00_14311; } 
return BgL_mainz00_14309;} } } } } } 

}



/* &main5168 */
obj_t BGl_z62main5168z62zz__evaluate_compz00(obj_t BgL_envz00_12091, obj_t BgL_dz00_12098)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_12096;long BgL_siza7ezd2framez75_12097;
BgL_runz00_12096 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12091, 
(int)(((long)4)))); 
BgL_siza7ezd2framez75_12097 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12091, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14314;
BgL_sz00_14314 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14315;
BgL_bpz00_14315 = 
VECTOR_REF(
((obj_t)BgL_sz00_14314),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14314, BgL_bpz00_14315, 
BINT(BgL_siza7ezd2framez75_12097)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3241z00_14316;
BgL_arg3241z00_14316 = 
(
(long)CINT(BgL_bpz00_14315)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14314),BgL_arg3241z00_14316,BgL_dz00_12098); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14317;
BgL_ez00_14317 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14317, BgL_bpz00_14315); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14318;
BgL_accz00_14318 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12096, BgL_sz00_14314, BgL_bpz00_14315); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14317); 
VECTOR_SET(
((obj_t)BgL_sz00_14314),((long)0),BgL_bpz00_14315); 
return BgL_accz00_14318;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14319;
BgL_nsz00_14319 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14319,((long)1),BgL_sz00_14314); 
VECTOR_SET(BgL_nsz00_14319,((long)2),BgL_dz00_12098); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14320;
BgL_z12denvz12_14320 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14320, BgL_nsz00_14319); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14321;
BgL_ez00_14321 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14321, BgL_sz00_14314); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14322;
BgL_____rz00_14322 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12096, BgL_nsz00_14319, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14321); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14320, BgL_sz00_14314); 
return BgL_____rz00_14322;} } } } } } } } 

}



/* &run5169 */
obj_t BGl_z62run5169z62zz__evaluate_compz00(obj_t BgL_envz00_12099, obj_t BgL_sz00_12104)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_siza7eza7_12100;obj_t BgL_valza2za2_12101;BgL_ev_absz00_bglt BgL_i1244z00_12102;obj_t BgL_bodyz00_12103;
BgL_siza7eza7_12100 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12099, 
(int)(((long)0)))); 
BgL_valza2za2_12101 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12099, 
(int)(((long)1)))); 
BgL_i1244z00_12102 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12099, 
(int)(((long)2)))); 
BgL_bodyz00_12103 = 
PROCEDURE_REF(BgL_envz00_12099, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14323;
BgL_bpz00_14323 = 
VECTOR_REF(
((obj_t)BgL_sz00_12104),((long)0)); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_12104, BgL_valza2za2_12101, 
(
(long)CINT(BgL_bpz00_14323)+BgL_siza7eza7_12100)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_14324;obj_t BgL_wherez00_14325;obj_t BgL_locz00_14326;
BgL_z12denvz12_14324 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14325 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12102))->BgL_wherez00); 
BgL_locz00_14326 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12102))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14324, BgL_wherez00_14325, BgL_locz00_14326); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_14327;
BgL_za2za2resza2za2z00_14327 = 
PROCEDURE_ENTRY(BgL_bodyz00_12103)(BgL_bodyz00_12103, BgL_sz00_12104, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14324); 
return BgL_za2za2resza2za2z00_14327;} } } } } } 

}



/* &<@anonymous:3244> */
obj_t BGl_z62zc3z04anonymousza33244ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12105, obj_t BgL_sz00_12112)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_12106;obj_t BgL_iboxesz00_12107;long BgL_siza7eza7_12108;BgL_ev_absz00_bglt BgL_i1244z00_12109;obj_t BgL_bodyz00_12110;long BgL_siza7ezd2framez75_12111;
BgL_ifreesz00_12106 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12105, 
(int)(((long)0)))); 
BgL_iboxesz00_12107 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12105, 
(int)(((long)1)))); 
BgL_siza7eza7_12108 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12105, 
(int)(((long)2)))); 
BgL_i1244z00_12109 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12105, 
(int)(((long)3)))); 
BgL_bodyz00_12110 = 
PROCEDURE_REF(BgL_envz00_12105, 
(int)(((long)4))); 
BgL_siza7ezd2framez75_12111 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12105, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14328;
BgL_bpz00_14328 = 
VECTOR_REF(
((obj_t)BgL_sz00_12112),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_14329;
BgL_valza2za2_14329 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_12112, BgL_bpz00_14328, BgL_ifreesz00_12106); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14330;
BgL_runz00_14330 = 
MAKE_FX_PROCEDURE(BGl_z62run5171z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_runz00_14330, 
(int)(((long)0)), BgL_iboxesz00_12107); 
PROCEDURE_SET(BgL_runz00_14330, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_12108)); 
PROCEDURE_SET(BgL_runz00_14330, 
(int)(((long)2)), BgL_valza2za2_14329); 
PROCEDURE_SET(BgL_runz00_14330, 
(int)(((long)3)), 
((obj_t)BgL_i1244z00_12109)); 
PROCEDURE_SET(BgL_runz00_14330, 
(int)(((long)4)), BgL_bodyz00_12110); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14331;
BgL_mainz00_14331 = 
MAKE_FX_PROCEDURE(BGl_z62main5170z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_mainz00_14331, 
(int)(((long)0)), BgL_iboxesz00_12107); 
PROCEDURE_SET(BgL_mainz00_14331, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_12108)); 
PROCEDURE_SET(BgL_mainz00_14331, 
(int)(((long)2)), BgL_valza2za2_14329); 
PROCEDURE_SET(BgL_mainz00_14331, 
(int)(((long)3)), 
((obj_t)BgL_i1244z00_12109)); 
PROCEDURE_SET(BgL_mainz00_14331, 
(int)(((long)4)), BgL_bodyz00_12110); 
PROCEDURE_SET(BgL_mainz00_14331, 
(int)(((long)5)), BgL_runz00_14330); 
PROCEDURE_SET(BgL_mainz00_14331, 
(int)(((long)6)), 
BINT(BgL_siza7ezd2framez75_12111)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14332;
BgL_objz00_14332 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14330, BgL_objz00_14332); BgL_objz00_14332; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3245z00_14333;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3246z00_14334;
BgL_arg3246z00_14334 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12109))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14335;
BgL_newz00_14335 = 
create_struct(BGl_symbol5225z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26459;
BgL_tmpz00_26459 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14335, BgL_tmpz00_26459, BgL_arg3246z00_14334); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_26464;int BgL_tmpz00_26462;
BgL_auxz00_26464 = 
BINT(BgL_siza7ezd2framez75_12111); 
BgL_tmpz00_26462 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14335, BgL_tmpz00_26462, BgL_auxz00_26464); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26467;
BgL_tmpz00_26467 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14335, BgL_tmpz00_26467, BgL_runz00_14330); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_26472;int BgL_tmpz00_26470;
BgL_auxz00_26472 = 
BINT(((long)1)); 
BgL_tmpz00_26470 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14335, BgL_tmpz00_26470, BgL_auxz00_26472); } 
BgL_arg3245z00_14333 = BgL_newz00_14335; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14331, BgL_arg3245z00_14333); BgL_arg3245z00_14333; } 
return BgL_mainz00_14331;} } } } } } 

}



/* &main5170 */
obj_t BGl_z62main5170z62zz__evaluate_compz00(obj_t BgL_envz00_12113, obj_t BgL_dz00_12121)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_12119;long BgL_siza7ezd2framez75_12120;
BgL_runz00_12119 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12113, 
(int)(((long)5)))); 
BgL_siza7ezd2framez75_12120 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12113, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14336;
BgL_sz00_14336 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14337;
BgL_bpz00_14337 = 
VECTOR_REF(
((obj_t)BgL_sz00_14336),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14336, BgL_bpz00_14337, 
BINT(BgL_siza7ezd2framez75_12120)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3249z00_14338;
BgL_arg3249z00_14338 = 
(
(long)CINT(BgL_bpz00_14337)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14336),BgL_arg3249z00_14338,BgL_dz00_12121); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14339;
BgL_ez00_14339 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14339, BgL_bpz00_14337); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14340;
BgL_accz00_14340 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12119, BgL_sz00_14336, BgL_bpz00_14337); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14339); 
VECTOR_SET(
((obj_t)BgL_sz00_14336),((long)0),BgL_bpz00_14337); 
return BgL_accz00_14340;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14341;
BgL_nsz00_14341 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14341,((long)1),BgL_sz00_14336); 
VECTOR_SET(BgL_nsz00_14341,((long)2),BgL_dz00_12121); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14342;
BgL_z12denvz12_14342 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14342, BgL_nsz00_14341); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14343;
BgL_ez00_14343 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14343, BgL_sz00_14336); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14344;
BgL_____rz00_14344 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12119, BgL_nsz00_14341, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14343); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14342, BgL_sz00_14336); 
return BgL_____rz00_14344;} } } } } } } } 

}



/* &run5171 */
obj_t BGl_z62run5171z62zz__evaluate_compz00(obj_t BgL_envz00_12122, obj_t BgL_sz00_12128)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_12123;long BgL_siza7eza7_12124;obj_t BgL_valza2za2_12125;BgL_ev_absz00_bglt BgL_i1244z00_12126;obj_t BgL_bodyz00_12127;
BgL_iboxesz00_12123 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12122, 
(int)(((long)0)))); 
BgL_siza7eza7_12124 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12122, 
(int)(((long)1)))); 
BgL_valza2za2_12125 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12122, 
(int)(((long)2)))); 
BgL_i1244z00_12126 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12122, 
(int)(((long)3)))); 
BgL_bodyz00_12127 = 
PROCEDURE_REF(BgL_envz00_12122, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14345;
BgL_bpz00_14345 = 
VECTOR_REF(
((obj_t)BgL_sz00_12128),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_12128, BgL_iboxesz00_12123, BgL_bpz00_14345); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_12128, BgL_valza2za2_12125, 
(
(long)CINT(BgL_bpz00_14345)+BgL_siza7eza7_12124)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_14346;obj_t BgL_wherez00_14347;obj_t BgL_locz00_14348;
BgL_z12denvz12_14346 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14347 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12126))->BgL_wherez00); 
BgL_locz00_14348 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12126))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14346, BgL_wherez00_14347, BgL_locz00_14348); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_14349;
BgL_za2za2resza2za2z00_14349 = 
PROCEDURE_ENTRY(BgL_bodyz00_12127)(BgL_bodyz00_12127, BgL_sz00_12128, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14346); 
return BgL_za2za2resza2za2z00_14349;} } } } } } 

}



/* &<@anonymous:3180> */
obj_t BGl_z62zc3z04anonymousza33180ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12129, obj_t BgL_sz00_12133)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_12130;obj_t BgL_bodyz00_12131;long BgL_siza7ezd2framez75_12132;
BgL_i1244z00_12130 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12129, 
(int)(((long)0)))); 
BgL_bodyz00_12131 = 
PROCEDURE_REF(BgL_envz00_12129, 
(int)(((long)1))); 
BgL_siza7ezd2framez75_12132 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12129, 
(int)(((long)2)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14350;
BgL_bpz00_14350 = 
VECTOR_REF(
((obj_t)BgL_sz00_12133),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14351;
BgL_runz00_14351 = 
MAKE_FX_PROCEDURE(BGl_z62run5173z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_runz00_14351, 
(int)(((long)0)), 
((obj_t)BgL_i1244z00_12130)); 
PROCEDURE_SET(BgL_runz00_14351, 
(int)(((long)1)), BgL_bodyz00_12131); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14352;
BgL_mainz00_14352 = 
MAKE_VA_PROCEDURE(BGl_z62main5172z62zz__evaluate_compz00, 
(int)(((long)-1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_mainz00_14352, 
(int)(((long)0)), 
((obj_t)BgL_i1244z00_12130)); 
PROCEDURE_SET(BgL_mainz00_14352, 
(int)(((long)1)), BgL_bodyz00_12131); 
PROCEDURE_SET(BgL_mainz00_14352, 
(int)(((long)2)), BgL_runz00_14351); 
PROCEDURE_SET(BgL_mainz00_14352, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_12132)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14353;
BgL_objz00_14353 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14351, BgL_objz00_14353); BgL_objz00_14353; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3181z00_14354;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3182z00_14355;
BgL_arg3182z00_14355 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12130))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14356;
BgL_newz00_14356 = 
create_struct(BGl_symbol5225z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26573;
BgL_tmpz00_26573 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14356, BgL_tmpz00_26573, BgL_arg3182z00_14355); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_26578;int BgL_tmpz00_26576;
BgL_auxz00_26578 = 
BINT(BgL_siza7ezd2framez75_12132); 
BgL_tmpz00_26576 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14356, BgL_tmpz00_26576, BgL_auxz00_26578); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26581;
BgL_tmpz00_26581 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14356, BgL_tmpz00_26581, BgL_runz00_14351); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_26586;int BgL_tmpz00_26584;
BgL_auxz00_26586 = 
BINT(((long)-1)); 
BgL_tmpz00_26584 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14356, BgL_tmpz00_26584, BgL_auxz00_26586); } 
BgL_arg3181z00_14354 = BgL_newz00_14356; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14352, BgL_arg3181z00_14354); BgL_arg3181z00_14354; } 
return BgL_mainz00_14352;} } } } } } 

}



/* &main5172 */
obj_t BGl_z62main5172z62zz__evaluate_compz00(obj_t BgL_envz00_12134, obj_t BgL_lastz00_12139)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_12137;long BgL_siza7ezd2framez75_12138;
BgL_runz00_12137 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12134, 
(int)(((long)2)))); 
BgL_siza7ezd2framez75_12138 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12134, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14357;
BgL_sz00_14357 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14358;
BgL_bpz00_14358 = 
VECTOR_REF(
((obj_t)BgL_sz00_14357),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14357, BgL_bpz00_14358, 
BINT(BgL_siza7ezd2framez75_12138)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3185z00_14359;
BgL_arg3185z00_14359 = 
(
(long)CINT(BgL_bpz00_14358)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14357),BgL_arg3185z00_14359,BgL_lastz00_12139); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14360;
BgL_ez00_14360 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14360, BgL_bpz00_14358); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14361;
BgL_accz00_14361 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12137, BgL_sz00_14357, BgL_bpz00_14358); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14360); 
VECTOR_SET(
((obj_t)BgL_sz00_14357),((long)0),BgL_bpz00_14358); 
return BgL_accz00_14361;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14362;
BgL_nsz00_14362 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14362,((long)1),BgL_sz00_14357); 
VECTOR_SET(BgL_nsz00_14362,((long)2),BgL_lastz00_12139); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14363;
BgL_z12denvz12_14363 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14363, BgL_nsz00_14362); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14364;
BgL_ez00_14364 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14364, BgL_sz00_14357); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14365;
BgL_____rz00_14365 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12137, BgL_nsz00_14362, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14364); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14363, BgL_sz00_14357); 
return BgL_____rz00_14365;} } } } } } } } 

}



/* &run5173 */
obj_t BGl_z62run5173z62zz__evaluate_compz00(obj_t BgL_envz00_12140, obj_t BgL_sz00_12143)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_12141;obj_t BgL_bodyz00_12142;
BgL_i1244z00_12141 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12140, 
(int)(((long)0)))); 
BgL_bodyz00_12142 = 
PROCEDURE_REF(BgL_envz00_12140, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14366;
BgL_bpz00_14366 = 
VECTOR_REF(
((obj_t)BgL_sz00_12143),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14367;obj_t BgL_wherez00_14368;obj_t BgL_locz00_14369;
BgL_z12denvz12_14367 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14368 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12141))->BgL_wherez00); 
BgL_locz00_14369 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12141))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14367, BgL_wherez00_14368, BgL_locz00_14369); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_14370;
BgL_za2za2resza2za2z00_14370 = 
PROCEDURE_ENTRY(BgL_bodyz00_12142)(BgL_bodyz00_12142, BgL_sz00_12143, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14367); 
return BgL_za2za2resza2za2z00_14370;} } } } } } 

}



/* &<@anonymous:3187> */
obj_t BGl_z62zc3z04anonymousza33187ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12144, obj_t BgL_sz00_12149)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_12145;BgL_ev_absz00_bglt BgL_i1244z00_12146;obj_t BgL_bodyz00_12147;long BgL_siza7ezd2framez75_12148;
BgL_iboxesz00_12145 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12144, 
(int)(((long)0)))); 
BgL_i1244z00_12146 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12144, 
(int)(((long)1)))); 
BgL_bodyz00_12147 = 
PROCEDURE_REF(BgL_envz00_12144, 
(int)(((long)2))); 
BgL_siza7ezd2framez75_12148 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12144, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14371;
BgL_bpz00_14371 = 
VECTOR_REF(
((obj_t)BgL_sz00_12149),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14372;
BgL_runz00_14372 = 
MAKE_FX_PROCEDURE(BGl_z62run5175z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_runz00_14372, 
(int)(((long)0)), BgL_iboxesz00_12145); 
PROCEDURE_SET(BgL_runz00_14372, 
(int)(((long)1)), 
((obj_t)BgL_i1244z00_12146)); 
PROCEDURE_SET(BgL_runz00_14372, 
(int)(((long)2)), BgL_bodyz00_12147); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14373;
BgL_mainz00_14373 = 
MAKE_VA_PROCEDURE(BGl_z62main5174z62zz__evaluate_compz00, 
(int)(((long)-1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_mainz00_14373, 
(int)(((long)0)), BgL_iboxesz00_12145); 
PROCEDURE_SET(BgL_mainz00_14373, 
(int)(((long)1)), 
((obj_t)BgL_i1244z00_12146)); 
PROCEDURE_SET(BgL_mainz00_14373, 
(int)(((long)2)), BgL_bodyz00_12147); 
PROCEDURE_SET(BgL_mainz00_14373, 
(int)(((long)3)), BgL_runz00_14372); 
PROCEDURE_SET(BgL_mainz00_14373, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_12148)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14374;
BgL_objz00_14374 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14372, BgL_objz00_14374); BgL_objz00_14374; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3188z00_14375;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3189z00_14376;
BgL_arg3189z00_14376 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12146))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14377;
BgL_newz00_14377 = 
create_struct(BGl_symbol5225z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26681;
BgL_tmpz00_26681 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14377, BgL_tmpz00_26681, BgL_arg3189z00_14376); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_26686;int BgL_tmpz00_26684;
BgL_auxz00_26686 = 
BINT(BgL_siza7ezd2framez75_12148); 
BgL_tmpz00_26684 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14377, BgL_tmpz00_26684, BgL_auxz00_26686); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26689;
BgL_tmpz00_26689 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14377, BgL_tmpz00_26689, BgL_runz00_14372); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_26694;int BgL_tmpz00_26692;
BgL_auxz00_26694 = 
BINT(((long)-1)); 
BgL_tmpz00_26692 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14377, BgL_tmpz00_26692, BgL_auxz00_26694); } 
BgL_arg3188z00_14375 = BgL_newz00_14377; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14373, BgL_arg3188z00_14375); BgL_arg3188z00_14375; } 
return BgL_mainz00_14373;} } } } } } 

}



/* &main5174 */
obj_t BGl_z62main5174z62zz__evaluate_compz00(obj_t BgL_envz00_12150, obj_t BgL_lastz00_12156)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_12154;long BgL_siza7ezd2framez75_12155;
BgL_runz00_12154 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12150, 
(int)(((long)3)))); 
BgL_siza7ezd2framez75_12155 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12150, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14378;
BgL_sz00_14378 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14379;
BgL_bpz00_14379 = 
VECTOR_REF(
((obj_t)BgL_sz00_14378),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14378, BgL_bpz00_14379, 
BINT(BgL_siza7ezd2framez75_12155)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3192z00_14380;
BgL_arg3192z00_14380 = 
(
(long)CINT(BgL_bpz00_14379)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14378),BgL_arg3192z00_14380,BgL_lastz00_12156); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14381;
BgL_ez00_14381 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14381, BgL_bpz00_14379); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14382;
BgL_accz00_14382 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12154, BgL_sz00_14378, BgL_bpz00_14379); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14381); 
VECTOR_SET(
((obj_t)BgL_sz00_14378),((long)0),BgL_bpz00_14379); 
return BgL_accz00_14382;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14383;
BgL_nsz00_14383 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14383,((long)1),BgL_sz00_14378); 
VECTOR_SET(BgL_nsz00_14383,((long)2),BgL_lastz00_12156); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14384;
BgL_z12denvz12_14384 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14384, BgL_nsz00_14383); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14385;
BgL_ez00_14385 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14385, BgL_sz00_14378); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14386;
BgL_____rz00_14386 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12154, BgL_nsz00_14383, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14385); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14384, BgL_sz00_14378); 
return BgL_____rz00_14386;} } } } } } } } 

}



/* &run5175 */
obj_t BGl_z62run5175z62zz__evaluate_compz00(obj_t BgL_envz00_12157, obj_t BgL_sz00_12161)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_12158;BgL_ev_absz00_bglt BgL_i1244z00_12159;obj_t BgL_bodyz00_12160;
BgL_iboxesz00_12158 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12157, 
(int)(((long)0)))); 
BgL_i1244z00_12159 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12157, 
(int)(((long)1)))); 
BgL_bodyz00_12160 = 
PROCEDURE_REF(BgL_envz00_12157, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14387;
BgL_bpz00_14387 = 
VECTOR_REF(
((obj_t)BgL_sz00_12161),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_12161, BgL_iboxesz00_12158, BgL_bpz00_14387); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14388;obj_t BgL_wherez00_14389;obj_t BgL_locz00_14390;
BgL_z12denvz12_14388 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14389 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12159))->BgL_wherez00); 
BgL_locz00_14390 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12159))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14388, BgL_wherez00_14389, BgL_locz00_14390); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_14391;
BgL_za2za2resza2za2z00_14391 = 
PROCEDURE_ENTRY(BgL_bodyz00_12160)(BgL_bodyz00_12160, BgL_sz00_12161, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14388); 
return BgL_za2za2resza2za2z00_14391;} } } } } } 

}



/* &<@anonymous:3197> */
obj_t BGl_z62zc3z04anonymousza33197ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12162, obj_t BgL_sz00_12168)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_12163;long BgL_siza7eza7_12164;BgL_ev_absz00_bglt BgL_i1244z00_12165;obj_t BgL_bodyz00_12166;long BgL_siza7ezd2framez75_12167;
BgL_ifreesz00_12163 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12162, 
(int)(((long)0)))); 
BgL_siza7eza7_12164 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12162, 
(int)(((long)1)))); 
BgL_i1244z00_12165 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12162, 
(int)(((long)2)))); 
BgL_bodyz00_12166 = 
PROCEDURE_REF(BgL_envz00_12162, 
(int)(((long)3))); 
BgL_siza7ezd2framez75_12167 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12162, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14392;
BgL_bpz00_14392 = 
VECTOR_REF(
((obj_t)BgL_sz00_12168),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_14393;
BgL_valza2za2_14393 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_12168, BgL_bpz00_14392, BgL_ifreesz00_12163); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14394;
BgL_runz00_14394 = 
MAKE_FX_PROCEDURE(BGl_z62run5177z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_runz00_14394, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_12164)); 
PROCEDURE_SET(BgL_runz00_14394, 
(int)(((long)1)), BgL_valza2za2_14393); 
PROCEDURE_SET(BgL_runz00_14394, 
(int)(((long)2)), 
((obj_t)BgL_i1244z00_12165)); 
PROCEDURE_SET(BgL_runz00_14394, 
(int)(((long)3)), BgL_bodyz00_12166); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14395;
BgL_mainz00_14395 = 
MAKE_VA_PROCEDURE(BGl_z62main5176z62zz__evaluate_compz00, 
(int)(((long)-1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_mainz00_14395, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_12164)); 
PROCEDURE_SET(BgL_mainz00_14395, 
(int)(((long)1)), BgL_valza2za2_14393); 
PROCEDURE_SET(BgL_mainz00_14395, 
(int)(((long)2)), 
((obj_t)BgL_i1244z00_12165)); 
PROCEDURE_SET(BgL_mainz00_14395, 
(int)(((long)3)), BgL_bodyz00_12166); 
PROCEDURE_SET(BgL_mainz00_14395, 
(int)(((long)4)), BgL_runz00_14394); 
PROCEDURE_SET(BgL_mainz00_14395, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_12167)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14396;
BgL_objz00_14396 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14394, BgL_objz00_14396); BgL_objz00_14396; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3198z00_14397;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3199z00_14398;
BgL_arg3199z00_14398 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12165))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14399;
BgL_newz00_14399 = 
create_struct(BGl_symbol5225z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26803;
BgL_tmpz00_26803 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14399, BgL_tmpz00_26803, BgL_arg3199z00_14398); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_26808;int BgL_tmpz00_26806;
BgL_auxz00_26808 = 
BINT(BgL_siza7ezd2framez75_12167); 
BgL_tmpz00_26806 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14399, BgL_tmpz00_26806, BgL_auxz00_26808); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26811;
BgL_tmpz00_26811 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14399, BgL_tmpz00_26811, BgL_runz00_14394); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_26816;int BgL_tmpz00_26814;
BgL_auxz00_26816 = 
BINT(((long)-1)); 
BgL_tmpz00_26814 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14399, BgL_tmpz00_26814, BgL_auxz00_26816); } 
BgL_arg3198z00_14397 = BgL_newz00_14399; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14395, BgL_arg3198z00_14397); BgL_arg3198z00_14397; } 
return BgL_mainz00_14395;} } } } } } 

}



/* &main5176 */
obj_t BGl_z62main5176z62zz__evaluate_compz00(obj_t BgL_envz00_12169, obj_t BgL_lastz00_12176)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_12174;long BgL_siza7ezd2framez75_12175;
BgL_runz00_12174 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12169, 
(int)(((long)4)))); 
BgL_siza7ezd2framez75_12175 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12169, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14400;
BgL_sz00_14400 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14401;
BgL_bpz00_14401 = 
VECTOR_REF(
((obj_t)BgL_sz00_14400),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14400, BgL_bpz00_14401, 
BINT(BgL_siza7ezd2framez75_12175)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3202z00_14402;
BgL_arg3202z00_14402 = 
(
(long)CINT(BgL_bpz00_14401)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14400),BgL_arg3202z00_14402,BgL_lastz00_12176); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14403;
BgL_ez00_14403 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14403, BgL_bpz00_14401); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14404;
BgL_accz00_14404 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12174, BgL_sz00_14400, BgL_bpz00_14401); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14403); 
VECTOR_SET(
((obj_t)BgL_sz00_14400),((long)0),BgL_bpz00_14401); 
return BgL_accz00_14404;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14405;
BgL_nsz00_14405 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14405,((long)1),BgL_sz00_14400); 
VECTOR_SET(BgL_nsz00_14405,((long)2),BgL_lastz00_12176); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14406;
BgL_z12denvz12_14406 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14406, BgL_nsz00_14405); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14407;
BgL_ez00_14407 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14407, BgL_sz00_14400); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14408;
BgL_____rz00_14408 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12174, BgL_nsz00_14405, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14407); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14406, BgL_sz00_14400); 
return BgL_____rz00_14408;} } } } } } } } 

}



/* &run5177 */
obj_t BGl_z62run5177z62zz__evaluate_compz00(obj_t BgL_envz00_12177, obj_t BgL_sz00_12182)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_siza7eza7_12178;obj_t BgL_valza2za2_12179;BgL_ev_absz00_bglt BgL_i1244z00_12180;obj_t BgL_bodyz00_12181;
BgL_siza7eza7_12178 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12177, 
(int)(((long)0)))); 
BgL_valza2za2_12179 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12177, 
(int)(((long)1)))); 
BgL_i1244z00_12180 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12177, 
(int)(((long)2)))); 
BgL_bodyz00_12181 = 
PROCEDURE_REF(BgL_envz00_12177, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14409;
BgL_bpz00_14409 = 
VECTOR_REF(
((obj_t)BgL_sz00_12182),((long)0)); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_12182, BgL_valza2za2_12179, 
(
(long)CINT(BgL_bpz00_14409)+BgL_siza7eza7_12178)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_14410;obj_t BgL_wherez00_14411;obj_t BgL_locz00_14412;
BgL_z12denvz12_14410 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14411 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12180))->BgL_wherez00); 
BgL_locz00_14412 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12180))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14410, BgL_wherez00_14411, BgL_locz00_14412); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_14413;
BgL_za2za2resza2za2z00_14413 = 
PROCEDURE_ENTRY(BgL_bodyz00_12181)(BgL_bodyz00_12181, BgL_sz00_12182, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14410); 
return BgL_za2za2resza2za2z00_14413;} } } } } } 

}



/* &<@anonymous:3205> */
obj_t BGl_z62zc3z04anonymousza33205ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12183, obj_t BgL_sz00_12190)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_12184;obj_t BgL_iboxesz00_12185;long BgL_siza7eza7_12186;BgL_ev_absz00_bglt BgL_i1244z00_12187;obj_t BgL_bodyz00_12188;long BgL_siza7ezd2framez75_12189;
BgL_ifreesz00_12184 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12183, 
(int)(((long)0)))); 
BgL_iboxesz00_12185 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12183, 
(int)(((long)1)))); 
BgL_siza7eza7_12186 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12183, 
(int)(((long)2)))); 
BgL_i1244z00_12187 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12183, 
(int)(((long)3)))); 
BgL_bodyz00_12188 = 
PROCEDURE_REF(BgL_envz00_12183, 
(int)(((long)4))); 
BgL_siza7ezd2framez75_12189 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12183, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14414;
BgL_bpz00_14414 = 
VECTOR_REF(
((obj_t)BgL_sz00_12190),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_14415;
BgL_valza2za2_14415 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_12190, BgL_bpz00_14414, BgL_ifreesz00_12184); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14416;
BgL_runz00_14416 = 
MAKE_FX_PROCEDURE(BGl_z62run5179z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_runz00_14416, 
(int)(((long)0)), BgL_iboxesz00_12185); 
PROCEDURE_SET(BgL_runz00_14416, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_12186)); 
PROCEDURE_SET(BgL_runz00_14416, 
(int)(((long)2)), BgL_valza2za2_14415); 
PROCEDURE_SET(BgL_runz00_14416, 
(int)(((long)3)), 
((obj_t)BgL_i1244z00_12187)); 
PROCEDURE_SET(BgL_runz00_14416, 
(int)(((long)4)), BgL_bodyz00_12188); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14417;
BgL_mainz00_14417 = 
MAKE_VA_PROCEDURE(BGl_z62main5178z62zz__evaluate_compz00, 
(int)(((long)-1)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_mainz00_14417, 
(int)(((long)0)), BgL_iboxesz00_12185); 
PROCEDURE_SET(BgL_mainz00_14417, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_12186)); 
PROCEDURE_SET(BgL_mainz00_14417, 
(int)(((long)2)), BgL_valza2za2_14415); 
PROCEDURE_SET(BgL_mainz00_14417, 
(int)(((long)3)), 
((obj_t)BgL_i1244z00_12187)); 
PROCEDURE_SET(BgL_mainz00_14417, 
(int)(((long)4)), BgL_bodyz00_12188); 
PROCEDURE_SET(BgL_mainz00_14417, 
(int)(((long)5)), BgL_runz00_14416); 
PROCEDURE_SET(BgL_mainz00_14417, 
(int)(((long)6)), 
BINT(BgL_siza7ezd2framez75_12189)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14418;
BgL_objz00_14418 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14416, BgL_objz00_14418); BgL_objz00_14418; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3206z00_14419;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3207z00_14420;
BgL_arg3207z00_14420 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12187))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14421;
BgL_newz00_14421 = 
create_struct(BGl_symbol5225z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26937;
BgL_tmpz00_26937 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14421, BgL_tmpz00_26937, BgL_arg3207z00_14420); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_26942;int BgL_tmpz00_26940;
BgL_auxz00_26942 = 
BINT(BgL_siza7ezd2framez75_12189); 
BgL_tmpz00_26940 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14421, BgL_tmpz00_26940, BgL_auxz00_26942); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26945;
BgL_tmpz00_26945 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14421, BgL_tmpz00_26945, BgL_runz00_14416); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_26950;int BgL_tmpz00_26948;
BgL_auxz00_26950 = 
BINT(((long)-1)); 
BgL_tmpz00_26948 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14421, BgL_tmpz00_26948, BgL_auxz00_26950); } 
BgL_arg3206z00_14419 = BgL_newz00_14421; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14417, BgL_arg3206z00_14419); BgL_arg3206z00_14419; } 
return BgL_mainz00_14417;} } } } } } 

}



/* &main5178 */
obj_t BGl_z62main5178z62zz__evaluate_compz00(obj_t BgL_envz00_12191, obj_t BgL_lastz00_12199)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_12197;long BgL_siza7ezd2framez75_12198;
BgL_runz00_12197 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12191, 
(int)(((long)5)))); 
BgL_siza7ezd2framez75_12198 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12191, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14422;
BgL_sz00_14422 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14423;
BgL_bpz00_14423 = 
VECTOR_REF(
((obj_t)BgL_sz00_14422),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14422, BgL_bpz00_14423, 
BINT(BgL_siza7ezd2framez75_12198)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3210z00_14424;
BgL_arg3210z00_14424 = 
(
(long)CINT(BgL_bpz00_14423)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14422),BgL_arg3210z00_14424,BgL_lastz00_12199); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14425;
BgL_ez00_14425 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14425, BgL_bpz00_14423); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14426;
BgL_accz00_14426 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12197, BgL_sz00_14422, BgL_bpz00_14423); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14425); 
VECTOR_SET(
((obj_t)BgL_sz00_14422),((long)0),BgL_bpz00_14423); 
return BgL_accz00_14426;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14427;
BgL_nsz00_14427 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14427,((long)1),BgL_sz00_14422); 
VECTOR_SET(BgL_nsz00_14427,((long)2),BgL_lastz00_12199); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14428;
BgL_z12denvz12_14428 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14428, BgL_nsz00_14427); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14429;
BgL_ez00_14429 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14429, BgL_sz00_14422); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14430;
BgL_____rz00_14430 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12197, BgL_nsz00_14427, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14429); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14428, BgL_sz00_14422); 
return BgL_____rz00_14430;} } } } } } } } 

}



/* &run5179 */
obj_t BGl_z62run5179z62zz__evaluate_compz00(obj_t BgL_envz00_12200, obj_t BgL_sz00_12206)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_12201;long BgL_siza7eza7_12202;obj_t BgL_valza2za2_12203;BgL_ev_absz00_bglt BgL_i1244z00_12204;obj_t BgL_bodyz00_12205;
BgL_iboxesz00_12201 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12200, 
(int)(((long)0)))); 
BgL_siza7eza7_12202 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12200, 
(int)(((long)1)))); 
BgL_valza2za2_12203 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12200, 
(int)(((long)2)))); 
BgL_i1244z00_12204 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12200, 
(int)(((long)3)))); 
BgL_bodyz00_12205 = 
PROCEDURE_REF(BgL_envz00_12200, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14431;
BgL_bpz00_14431 = 
VECTOR_REF(
((obj_t)BgL_sz00_12206),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_12206, BgL_iboxesz00_12201, BgL_bpz00_14431); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_12206, BgL_valza2za2_12203, 
(
(long)CINT(BgL_bpz00_14431)+BgL_siza7eza7_12202)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_14432;obj_t BgL_wherez00_14433;obj_t BgL_locz00_14434;
BgL_z12denvz12_14432 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14433 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12204))->BgL_wherez00); 
BgL_locz00_14434 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12204))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14432, BgL_wherez00_14433, BgL_locz00_14434); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_14435;
BgL_za2za2resza2za2z00_14435 = 
PROCEDURE_ENTRY(BgL_bodyz00_12205)(BgL_bodyz00_12205, BgL_sz00_12206, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14432); 
return BgL_za2za2resza2za2z00_14435;} } } } } } 

}



/* &<@anonymous:3145> */
obj_t BGl_z62zc3z04anonymousza33145ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12207, obj_t BgL_sz00_12211)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_12208;obj_t BgL_bodyz00_12209;long BgL_siza7ezd2framez75_12210;
BgL_i1244z00_12208 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12207, 
(int)(((long)0)))); 
BgL_bodyz00_12209 = 
PROCEDURE_REF(BgL_envz00_12207, 
(int)(((long)1))); 
BgL_siza7ezd2framez75_12210 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12207, 
(int)(((long)2)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14436;
BgL_bpz00_14436 = 
VECTOR_REF(
((obj_t)BgL_sz00_12211),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14437;
BgL_runz00_14437 = 
MAKE_FX_PROCEDURE(BGl_z62run5181z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_runz00_14437, 
(int)(((long)0)), 
((obj_t)BgL_i1244z00_12208)); 
PROCEDURE_SET(BgL_runz00_14437, 
(int)(((long)1)), BgL_bodyz00_12209); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14438;
BgL_mainz00_14438 = 
MAKE_FX_PROCEDURE(BGl_z62main5180z62zz__evaluate_compz00, 
(int)(((long)0)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_mainz00_14438, 
(int)(((long)0)), 
((obj_t)BgL_i1244z00_12208)); 
PROCEDURE_SET(BgL_mainz00_14438, 
(int)(((long)1)), BgL_bodyz00_12209); 
PROCEDURE_SET(BgL_mainz00_14438, 
(int)(((long)2)), BgL_runz00_14437); 
PROCEDURE_SET(BgL_mainz00_14438, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_12210)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14439;
BgL_objz00_14439 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14437, BgL_objz00_14439); BgL_objz00_14439; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3146z00_14440;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3147z00_14441;
BgL_arg3147z00_14441 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12208))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14442;
BgL_newz00_14442 = 
create_struct(BGl_symbol5225z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_27051;
BgL_tmpz00_27051 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14442, BgL_tmpz00_27051, BgL_arg3147z00_14441); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_27056;int BgL_tmpz00_27054;
BgL_auxz00_27056 = 
BINT(BgL_siza7ezd2framez75_12210); 
BgL_tmpz00_27054 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14442, BgL_tmpz00_27054, BgL_auxz00_27056); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_27059;
BgL_tmpz00_27059 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14442, BgL_tmpz00_27059, BgL_runz00_14437); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_27064;int BgL_tmpz00_27062;
BgL_auxz00_27064 = 
BINT(((long)0)); 
BgL_tmpz00_27062 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14442, BgL_tmpz00_27062, BgL_auxz00_27064); } 
BgL_arg3146z00_14440 = BgL_newz00_14442; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14438, BgL_arg3146z00_14440); BgL_arg3146z00_14440; } 
return BgL_mainz00_14438;} } } } } } 

}



/* &main5180 */
obj_t BGl_z62main5180z62zz__evaluate_compz00(obj_t BgL_envz00_12212)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_12215;long BgL_siza7ezd2framez75_12216;
BgL_runz00_12215 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12212, 
(int)(((long)2)))); 
BgL_siza7ezd2framez75_12216 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12212, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14443;
BgL_sz00_14443 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14444;
BgL_bpz00_14444 = 
VECTOR_REF(
((obj_t)BgL_sz00_14443),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14443, BgL_bpz00_14444, 
BINT(BgL_siza7ezd2framez75_12216)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14445;
BgL_ez00_14445 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14445, BgL_bpz00_14444); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14446;
BgL_accz00_14446 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12215, BgL_sz00_14443, BgL_bpz00_14444); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14445); 
VECTOR_SET(
((obj_t)BgL_sz00_14443),((long)0),BgL_bpz00_14444); 
return BgL_accz00_14446;} }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14447;
BgL_nsz00_14447 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14447,((long)1),BgL_sz00_14443); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14448;
BgL_z12denvz12_14448 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14448, BgL_nsz00_14447); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14449;
BgL_ez00_14449 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14449, BgL_sz00_14443); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14450;
BgL_____rz00_14450 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12215, BgL_nsz00_14447, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14449); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14448, BgL_sz00_14443); 
return BgL_____rz00_14450;} } } } } } } } 

}



/* &run5181 */
obj_t BGl_z62run5181z62zz__evaluate_compz00(obj_t BgL_envz00_12217, obj_t BgL_sz00_12220)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_12218;obj_t BgL_bodyz00_12219;
BgL_i1244z00_12218 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12217, 
(int)(((long)0)))); 
BgL_bodyz00_12219 = 
PROCEDURE_REF(BgL_envz00_12217, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14451;
BgL_bpz00_14451 = 
VECTOR_REF(
((obj_t)BgL_sz00_12220),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14452;obj_t BgL_wherez00_14453;obj_t BgL_locz00_14454;
BgL_z12denvz12_14452 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14453 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12218))->BgL_wherez00); 
BgL_locz00_14454 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12218))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14452, BgL_wherez00_14453, BgL_locz00_14454); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_14455;
BgL_za2za2resza2za2z00_14455 = 
PROCEDURE_ENTRY(BgL_bodyz00_12219)(BgL_bodyz00_12219, BgL_sz00_12220, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14452); 
return BgL_za2za2resza2za2z00_14455;} } } } } } 

}



/* &<@anonymous:3151> */
obj_t BGl_z62zc3z04anonymousza33151ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12221, obj_t BgL_sz00_12226)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_12222;BgL_ev_absz00_bglt BgL_i1244z00_12223;obj_t BgL_bodyz00_12224;long BgL_siza7ezd2framez75_12225;
BgL_iboxesz00_12222 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12221, 
(int)(((long)0)))); 
BgL_i1244z00_12223 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12221, 
(int)(((long)1)))); 
BgL_bodyz00_12224 = 
PROCEDURE_REF(BgL_envz00_12221, 
(int)(((long)2))); 
BgL_siza7ezd2framez75_12225 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12221, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14456;
BgL_bpz00_14456 = 
VECTOR_REF(
((obj_t)BgL_sz00_12226),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14457;
BgL_runz00_14457 = 
MAKE_FX_PROCEDURE(BGl_z62run5183z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_runz00_14457, 
(int)(((long)0)), BgL_iboxesz00_12222); 
PROCEDURE_SET(BgL_runz00_14457, 
(int)(((long)1)), 
((obj_t)BgL_i1244z00_12223)); 
PROCEDURE_SET(BgL_runz00_14457, 
(int)(((long)2)), BgL_bodyz00_12224); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14458;
BgL_mainz00_14458 = 
MAKE_FX_PROCEDURE(BGl_z62main5182z62zz__evaluate_compz00, 
(int)(((long)0)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_mainz00_14458, 
(int)(((long)0)), BgL_iboxesz00_12222); 
PROCEDURE_SET(BgL_mainz00_14458, 
(int)(((long)1)), 
((obj_t)BgL_i1244z00_12223)); 
PROCEDURE_SET(BgL_mainz00_14458, 
(int)(((long)2)), BgL_bodyz00_12224); 
PROCEDURE_SET(BgL_mainz00_14458, 
(int)(((long)3)), BgL_runz00_14457); 
PROCEDURE_SET(BgL_mainz00_14458, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_12225)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14459;
BgL_objz00_14459 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14457, BgL_objz00_14459); BgL_objz00_14459; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3152z00_14460;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3153z00_14461;
BgL_arg3153z00_14461 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12223))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14462;
BgL_newz00_14462 = 
create_struct(BGl_symbol5225z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_27154;
BgL_tmpz00_27154 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14462, BgL_tmpz00_27154, BgL_arg3153z00_14461); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_27159;int BgL_tmpz00_27157;
BgL_auxz00_27159 = 
BINT(BgL_siza7ezd2framez75_12225); 
BgL_tmpz00_27157 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14462, BgL_tmpz00_27157, BgL_auxz00_27159); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_27162;
BgL_tmpz00_27162 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14462, BgL_tmpz00_27162, BgL_runz00_14457); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_27167;int BgL_tmpz00_27165;
BgL_auxz00_27167 = 
BINT(((long)0)); 
BgL_tmpz00_27165 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14462, BgL_tmpz00_27165, BgL_auxz00_27167); } 
BgL_arg3152z00_14460 = BgL_newz00_14462; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14458, BgL_arg3152z00_14460); BgL_arg3152z00_14460; } 
return BgL_mainz00_14458;} } } } } } 

}



/* &main5182 */
obj_t BGl_z62main5182z62zz__evaluate_compz00(obj_t BgL_envz00_12227)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_12231;long BgL_siza7ezd2framez75_12232;
BgL_runz00_12231 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12227, 
(int)(((long)3)))); 
BgL_siza7ezd2framez75_12232 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12227, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14463;
BgL_sz00_14463 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14464;
BgL_bpz00_14464 = 
VECTOR_REF(
((obj_t)BgL_sz00_14463),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14463, BgL_bpz00_14464, 
BINT(BgL_siza7ezd2framez75_12232)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14465;
BgL_ez00_14465 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14465, BgL_bpz00_14464); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14466;
BgL_accz00_14466 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12231, BgL_sz00_14463, BgL_bpz00_14464); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14465); 
VECTOR_SET(
((obj_t)BgL_sz00_14463),((long)0),BgL_bpz00_14464); 
return BgL_accz00_14466;} }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14467;
BgL_nsz00_14467 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14467,((long)1),BgL_sz00_14463); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14468;
BgL_z12denvz12_14468 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14468, BgL_nsz00_14467); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14469;
BgL_ez00_14469 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14469, BgL_sz00_14463); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14470;
BgL_____rz00_14470 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12231, BgL_nsz00_14467, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14469); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14468, BgL_sz00_14463); 
return BgL_____rz00_14470;} } } } } } } } 

}



/* &run5183 */
obj_t BGl_z62run5183z62zz__evaluate_compz00(obj_t BgL_envz00_12233, obj_t BgL_sz00_12237)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_12234;BgL_ev_absz00_bglt BgL_i1244z00_12235;obj_t BgL_bodyz00_12236;
BgL_iboxesz00_12234 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12233, 
(int)(((long)0)))); 
BgL_i1244z00_12235 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12233, 
(int)(((long)1)))); 
BgL_bodyz00_12236 = 
PROCEDURE_REF(BgL_envz00_12233, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14471;
BgL_bpz00_14471 = 
VECTOR_REF(
((obj_t)BgL_sz00_12237),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_12237, BgL_iboxesz00_12234, BgL_bpz00_14471); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14472;obj_t BgL_wherez00_14473;obj_t BgL_locz00_14474;
BgL_z12denvz12_14472 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14473 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12235))->BgL_wherez00); 
BgL_locz00_14474 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12235))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14472, BgL_wherez00_14473, BgL_locz00_14474); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_14475;
BgL_za2za2resza2za2z00_14475 = 
PROCEDURE_ENTRY(BgL_bodyz00_12236)(BgL_bodyz00_12236, BgL_sz00_12237, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14472); 
return BgL_za2za2resza2za2z00_14475;} } } } } } 

}



/* &<@anonymous:3160> */
obj_t BGl_z62zc3z04anonymousza33160ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12238, obj_t BgL_sz00_12244)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_12239;long BgL_siza7eza7_12240;BgL_ev_absz00_bglt BgL_i1244z00_12241;obj_t BgL_bodyz00_12242;long BgL_siza7ezd2framez75_12243;
BgL_ifreesz00_12239 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12238, 
(int)(((long)0)))); 
BgL_siza7eza7_12240 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12238, 
(int)(((long)1)))); 
BgL_i1244z00_12241 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12238, 
(int)(((long)2)))); 
BgL_bodyz00_12242 = 
PROCEDURE_REF(BgL_envz00_12238, 
(int)(((long)3))); 
BgL_siza7ezd2framez75_12243 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12238, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14476;
BgL_bpz00_14476 = 
VECTOR_REF(
((obj_t)BgL_sz00_12244),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_14477;
BgL_valza2za2_14477 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_12244, BgL_bpz00_14476, BgL_ifreesz00_12239); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14478;
BgL_runz00_14478 = 
MAKE_FX_PROCEDURE(BGl_z62run5185z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_runz00_14478, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_12240)); 
PROCEDURE_SET(BgL_runz00_14478, 
(int)(((long)1)), BgL_valza2za2_14477); 
PROCEDURE_SET(BgL_runz00_14478, 
(int)(((long)2)), 
((obj_t)BgL_i1244z00_12241)); 
PROCEDURE_SET(BgL_runz00_14478, 
(int)(((long)3)), BgL_bodyz00_12242); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14479;
BgL_mainz00_14479 = 
MAKE_FX_PROCEDURE(BGl_z62main5184z62zz__evaluate_compz00, 
(int)(((long)0)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_mainz00_14479, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_12240)); 
PROCEDURE_SET(BgL_mainz00_14479, 
(int)(((long)1)), BgL_valza2za2_14477); 
PROCEDURE_SET(BgL_mainz00_14479, 
(int)(((long)2)), 
((obj_t)BgL_i1244z00_12241)); 
PROCEDURE_SET(BgL_mainz00_14479, 
(int)(((long)3)), BgL_bodyz00_12242); 
PROCEDURE_SET(BgL_mainz00_14479, 
(int)(((long)4)), BgL_runz00_14478); 
PROCEDURE_SET(BgL_mainz00_14479, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_12243)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14480;
BgL_objz00_14480 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14478, BgL_objz00_14480); BgL_objz00_14480; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3161z00_14481;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3162z00_14482;
BgL_arg3162z00_14482 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12241))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14483;
BgL_newz00_14483 = 
create_struct(BGl_symbol5225z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_27271;
BgL_tmpz00_27271 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14483, BgL_tmpz00_27271, BgL_arg3162z00_14482); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_27276;int BgL_tmpz00_27274;
BgL_auxz00_27276 = 
BINT(BgL_siza7ezd2framez75_12243); 
BgL_tmpz00_27274 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14483, BgL_tmpz00_27274, BgL_auxz00_27276); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_27279;
BgL_tmpz00_27279 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14483, BgL_tmpz00_27279, BgL_runz00_14478); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_27284;int BgL_tmpz00_27282;
BgL_auxz00_27284 = 
BINT(((long)0)); 
BgL_tmpz00_27282 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14483, BgL_tmpz00_27282, BgL_auxz00_27284); } 
BgL_arg3161z00_14481 = BgL_newz00_14483; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14479, BgL_arg3161z00_14481); BgL_arg3161z00_14481; } 
return BgL_mainz00_14479;} } } } } } 

}



/* &main5184 */
obj_t BGl_z62main5184z62zz__evaluate_compz00(obj_t BgL_envz00_12245)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_12250;long BgL_siza7ezd2framez75_12251;
BgL_runz00_12250 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12245, 
(int)(((long)4)))); 
BgL_siza7ezd2framez75_12251 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12245, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14484;
BgL_sz00_14484 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14485;
BgL_bpz00_14485 = 
VECTOR_REF(
((obj_t)BgL_sz00_14484),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14484, BgL_bpz00_14485, 
BINT(BgL_siza7ezd2framez75_12251)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14486;
BgL_ez00_14486 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14486, BgL_bpz00_14485); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14487;
BgL_accz00_14487 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12250, BgL_sz00_14484, BgL_bpz00_14485); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14486); 
VECTOR_SET(
((obj_t)BgL_sz00_14484),((long)0),BgL_bpz00_14485); 
return BgL_accz00_14487;} }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14488;
BgL_nsz00_14488 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14488,((long)1),BgL_sz00_14484); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14489;
BgL_z12denvz12_14489 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14489, BgL_nsz00_14488); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14490;
BgL_ez00_14490 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14490, BgL_sz00_14484); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14491;
BgL_____rz00_14491 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12250, BgL_nsz00_14488, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14490); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14489, BgL_sz00_14484); 
return BgL_____rz00_14491;} } } } } } } } 

}



/* &run5185 */
obj_t BGl_z62run5185z62zz__evaluate_compz00(obj_t BgL_envz00_12252, obj_t BgL_sz00_12257)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_siza7eza7_12253;obj_t BgL_valza2za2_12254;BgL_ev_absz00_bglt BgL_i1244z00_12255;obj_t BgL_bodyz00_12256;
BgL_siza7eza7_12253 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12252, 
(int)(((long)0)))); 
BgL_valza2za2_12254 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12252, 
(int)(((long)1)))); 
BgL_i1244z00_12255 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12252, 
(int)(((long)2)))); 
BgL_bodyz00_12256 = 
PROCEDURE_REF(BgL_envz00_12252, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14492;
BgL_bpz00_14492 = 
VECTOR_REF(
((obj_t)BgL_sz00_12257),((long)0)); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_12257, BgL_valza2za2_12254, 
(
(long)CINT(BgL_bpz00_14492)+BgL_siza7eza7_12253)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_14493;obj_t BgL_wherez00_14494;obj_t BgL_locz00_14495;
BgL_z12denvz12_14493 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14494 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12255))->BgL_wherez00); 
BgL_locz00_14495 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12255))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14493, BgL_wherez00_14494, BgL_locz00_14495); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_14496;
BgL_za2za2resza2za2z00_14496 = 
PROCEDURE_ENTRY(BgL_bodyz00_12256)(BgL_bodyz00_12256, BgL_sz00_12257, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14493); 
return BgL_za2za2resza2za2z00_14496;} } } } } } 

}



/* &<@anonymous:3167> */
obj_t BGl_z62zc3z04anonymousza33167ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12258, obj_t BgL_sz00_12265)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_12259;obj_t BgL_iboxesz00_12260;long BgL_siza7eza7_12261;BgL_ev_absz00_bglt BgL_i1244z00_12262;obj_t BgL_bodyz00_12263;long BgL_siza7ezd2framez75_12264;
BgL_ifreesz00_12259 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12258, 
(int)(((long)0)))); 
BgL_iboxesz00_12260 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12258, 
(int)(((long)1)))); 
BgL_siza7eza7_12261 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12258, 
(int)(((long)2)))); 
BgL_i1244z00_12262 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12258, 
(int)(((long)3)))); 
BgL_bodyz00_12263 = 
PROCEDURE_REF(BgL_envz00_12258, 
(int)(((long)4))); 
BgL_siza7ezd2framez75_12264 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12258, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14497;
BgL_bpz00_14497 = 
VECTOR_REF(
((obj_t)BgL_sz00_12265),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_14498;
BgL_valza2za2_14498 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_12265, BgL_bpz00_14497, BgL_ifreesz00_12259); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14499;
BgL_runz00_14499 = 
MAKE_FX_PROCEDURE(BGl_z62run5187z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_runz00_14499, 
(int)(((long)0)), BgL_iboxesz00_12260); 
PROCEDURE_SET(BgL_runz00_14499, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_12261)); 
PROCEDURE_SET(BgL_runz00_14499, 
(int)(((long)2)), BgL_valza2za2_14498); 
PROCEDURE_SET(BgL_runz00_14499, 
(int)(((long)3)), 
((obj_t)BgL_i1244z00_12262)); 
PROCEDURE_SET(BgL_runz00_14499, 
(int)(((long)4)), BgL_bodyz00_12263); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14500;
BgL_mainz00_14500 = 
MAKE_FX_PROCEDURE(BGl_z62main5186z62zz__evaluate_compz00, 
(int)(((long)0)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_mainz00_14500, 
(int)(((long)0)), BgL_iboxesz00_12260); 
PROCEDURE_SET(BgL_mainz00_14500, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_12261)); 
PROCEDURE_SET(BgL_mainz00_14500, 
(int)(((long)2)), BgL_valza2za2_14498); 
PROCEDURE_SET(BgL_mainz00_14500, 
(int)(((long)3)), 
((obj_t)BgL_i1244z00_12262)); 
PROCEDURE_SET(BgL_mainz00_14500, 
(int)(((long)4)), BgL_bodyz00_12263); 
PROCEDURE_SET(BgL_mainz00_14500, 
(int)(((long)5)), BgL_runz00_14499); 
PROCEDURE_SET(BgL_mainz00_14500, 
(int)(((long)6)), 
BINT(BgL_siza7ezd2framez75_12264)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14501;
BgL_objz00_14501 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14499, BgL_objz00_14501); BgL_objz00_14501; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3168z00_14502;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3169z00_14503;
BgL_arg3169z00_14503 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12262))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14504;
BgL_newz00_14504 = 
create_struct(BGl_symbol5225z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_27400;
BgL_tmpz00_27400 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14504, BgL_tmpz00_27400, BgL_arg3169z00_14503); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_27405;int BgL_tmpz00_27403;
BgL_auxz00_27405 = 
BINT(BgL_siza7ezd2framez75_12264); 
BgL_tmpz00_27403 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14504, BgL_tmpz00_27403, BgL_auxz00_27405); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_27408;
BgL_tmpz00_27408 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14504, BgL_tmpz00_27408, BgL_runz00_14499); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_27413;int BgL_tmpz00_27411;
BgL_auxz00_27413 = 
BINT(((long)0)); 
BgL_tmpz00_27411 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14504, BgL_tmpz00_27411, BgL_auxz00_27413); } 
BgL_arg3168z00_14502 = BgL_newz00_14504; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14500, BgL_arg3168z00_14502); BgL_arg3168z00_14502; } 
return BgL_mainz00_14500;} } } } } } 

}



/* &main5186 */
obj_t BGl_z62main5186z62zz__evaluate_compz00(obj_t BgL_envz00_12266)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_12272;long BgL_siza7ezd2framez75_12273;
BgL_runz00_12272 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12266, 
(int)(((long)5)))); 
BgL_siza7ezd2framez75_12273 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12266, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14505;
BgL_sz00_14505 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14506;
BgL_bpz00_14506 = 
VECTOR_REF(
((obj_t)BgL_sz00_14505),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14505, BgL_bpz00_14506, 
BINT(BgL_siza7ezd2framez75_12273)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14507;
BgL_ez00_14507 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14507, BgL_bpz00_14506); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14508;
BgL_accz00_14508 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12272, BgL_sz00_14505, BgL_bpz00_14506); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14507); 
VECTOR_SET(
((obj_t)BgL_sz00_14505),((long)0),BgL_bpz00_14506); 
return BgL_accz00_14508;} }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14509;
BgL_nsz00_14509 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14509,((long)1),BgL_sz00_14505); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14510;
BgL_z12denvz12_14510 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14510, BgL_nsz00_14509); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14511;
BgL_ez00_14511 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14511, BgL_sz00_14505); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14512;
BgL_____rz00_14512 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12272, BgL_nsz00_14509, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14511); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14510, BgL_sz00_14505); 
return BgL_____rz00_14512;} } } } } } } } 

}



/* &run5187 */
obj_t BGl_z62run5187z62zz__evaluate_compz00(obj_t BgL_envz00_12274, obj_t BgL_sz00_12280)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_12275;long BgL_siza7eza7_12276;obj_t BgL_valza2za2_12277;BgL_ev_absz00_bglt BgL_i1244z00_12278;obj_t BgL_bodyz00_12279;
BgL_iboxesz00_12275 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12274, 
(int)(((long)0)))); 
BgL_siza7eza7_12276 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12274, 
(int)(((long)1)))); 
BgL_valza2za2_12277 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12274, 
(int)(((long)2)))); 
BgL_i1244z00_12278 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12274, 
(int)(((long)3)))); 
BgL_bodyz00_12279 = 
PROCEDURE_REF(BgL_envz00_12274, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14513;
BgL_bpz00_14513 = 
VECTOR_REF(
((obj_t)BgL_sz00_12280),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_12280, BgL_iboxesz00_12275, BgL_bpz00_14513); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_12280, BgL_valza2za2_12277, 
(
(long)CINT(BgL_bpz00_14513)+BgL_siza7eza7_12276)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_14514;obj_t BgL_wherez00_14515;obj_t BgL_locz00_14516;
BgL_z12denvz12_14514 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14515 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12278))->BgL_wherez00); 
BgL_locz00_14516 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12278))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14514, BgL_wherez00_14515, BgL_locz00_14516); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_14517;
BgL_za2za2resza2za2z00_14517 = 
PROCEDURE_ENTRY(BgL_bodyz00_12279)(BgL_bodyz00_12279, BgL_sz00_12280, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14514); 
return BgL_za2za2resza2za2z00_14517;} } } } } } 

}



/* &<@anonymous:3595> */
obj_t BGl_z62zc3z04anonymousza33595ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12281, obj_t BgL_sz00_12285)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_12282;obj_t BgL_bodyz00_12283;long BgL_siza7ezd2framez75_12284;
BgL_i1244z00_12282 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12281, 
(int)(((long)0)))); 
BgL_bodyz00_12283 = 
PROCEDURE_REF(BgL_envz00_12281, 
(int)(((long)1))); 
BgL_siza7ezd2framez75_12284 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12281, 
(int)(((long)2)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14518;
BgL_bpz00_14518 = 
VECTOR_REF(
((obj_t)BgL_sz00_12285),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14519;
BgL_runz00_14519 = 
MAKE_FX_PROCEDURE(BGl_z62run5189z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_runz00_14519, 
(int)(((long)0)), 
((obj_t)BgL_i1244z00_12282)); 
PROCEDURE_SET(BgL_runz00_14519, 
(int)(((long)1)), BgL_bodyz00_12283); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14520;
BgL_mainz00_14520 = 
MAKE_VA_PROCEDURE(BGl_z62main5188z62zz__evaluate_compz00, 
(int)(((long)-5)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_mainz00_14520, 
(int)(((long)0)), BgL_bodyz00_12283); 
PROCEDURE_SET(BgL_mainz00_14520, 
(int)(((long)1)), 
((obj_t)BgL_i1244z00_12282)); 
PROCEDURE_SET(BgL_mainz00_14520, 
(int)(((long)2)), BgL_runz00_14519); 
PROCEDURE_SET(BgL_mainz00_14520, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_12284)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14521;
BgL_objz00_14521 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14519, BgL_objz00_14521); BgL_objz00_14521; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3596z00_14522;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3597z00_14523;obj_t BgL_arg3598z00_14524;
BgL_arg3597z00_14523 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12282))->BgL_arityz00); 
BgL_arg3598z00_14524 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12282))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14525;
BgL_newz00_14525 = 
create_struct(BGl_symbol5225z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_27510;
BgL_tmpz00_27510 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14525, BgL_tmpz00_27510, BgL_arg3598z00_14524); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_27515;int BgL_tmpz00_27513;
BgL_auxz00_27515 = 
BINT(BgL_siza7ezd2framez75_12284); 
BgL_tmpz00_27513 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14525, BgL_tmpz00_27513, BgL_auxz00_27515); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_27518;
BgL_tmpz00_27518 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14525, BgL_tmpz00_27518, BgL_runz00_14519); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_27521;
BgL_tmpz00_27521 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14525, BgL_tmpz00_27521, BgL_arg3597z00_14523); } 
BgL_arg3596z00_14522 = BgL_newz00_14525; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14520, BgL_arg3596z00_14522); BgL_arg3596z00_14522; } 
return BgL_mainz00_14520;} } } } } } 

}



/* &main5188 */
obj_t BGl_z62main5188z62zz__evaluate_compz00(obj_t BgL_envz00_12286, obj_t BgL_az00_12291, obj_t BgL_bz00_12292, obj_t BgL_cz00_12293, obj_t BgL_dz00_12294, obj_t BgL_restz00_12295)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_12288;obj_t BgL_runz00_12289;long BgL_siza7ezd2framez75_12290;
BgL_i1244z00_12288 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12286, 
(int)(((long)1)))); 
BgL_runz00_12289 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12286, 
(int)(((long)2)))); 
BgL_siza7ezd2framez75_12290 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12286, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14526;
BgL_sz00_14526 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14527;
BgL_bpz00_14527 = 
VECTOR_REF(
((obj_t)BgL_sz00_14526),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14526, BgL_bpz00_14527, 
BINT(BgL_siza7ezd2framez75_12290)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3601z00_14528;
BgL_arg3601z00_14528 = 
(
(long)CINT(BgL_bpz00_14527)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14526),BgL_arg3601z00_14528,BgL_az00_12291); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3602z00_14529;
BgL_arg3602z00_14529 = 
(
(long)CINT(BgL_bpz00_14527)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_14526),BgL_arg3602z00_14529,BgL_bz00_12292); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3603z00_14530;
BgL_arg3603z00_14530 = 
(
(long)CINT(BgL_bpz00_14527)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_14526),BgL_arg3603z00_14530,BgL_cz00_12293); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3604z00_14531;
BgL_arg3604z00_14531 = 
(
(long)CINT(BgL_bpz00_14527)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_14526),BgL_arg3604z00_14531,BgL_dz00_12294); } 
BGl_bindzd2framezd2zz__evaluate_compz00(BgL_sz00_14526, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12288))->BgL_wherez00), 
(
(long)CINT(BgL_bpz00_14527)+((long)4)), 
BGl_correctz00zz__evaluate_compz00(
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12288))->BgL_arityz00), ((long)4)), BgL_restz00_12295, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12288))->BgL_locz00)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14532;
BgL_ez00_14532 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14532, BgL_bpz00_14527); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14533;
BgL_accz00_14533 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12289, BgL_sz00_14526, BgL_bpz00_14527); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14532); 
VECTOR_SET(
((obj_t)BgL_sz00_14526),((long)0),BgL_bpz00_14527); 
return BgL_accz00_14533;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14534;
BgL_nsz00_14534 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14534,((long)1),BgL_sz00_14526); 
VECTOR_SET(BgL_nsz00_14534,((long)2),BgL_az00_12291); 
VECTOR_SET(BgL_nsz00_14534,((long)3),BgL_bz00_12292); 
VECTOR_SET(BgL_nsz00_14534,((long)4),BgL_cz00_12293); 
VECTOR_SET(BgL_nsz00_14534,((long)5),BgL_dz00_12294); 
BGl_bindzd2framezd2zz__evaluate_compz00(BgL_nsz00_14534, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12288))->BgL_wherez00), ((long)6), 
BGl_correctz00zz__evaluate_compz00(
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12288))->BgL_arityz00), ((long)4)), BgL_restz00_12295, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12288))->BgL_locz00)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14535;
BgL_z12denvz12_14535 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14535, BgL_nsz00_14534); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14536;
BgL_ez00_14536 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14536, BgL_sz00_14526); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14537;
BgL_____rz00_14537 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12289, BgL_nsz00_14534, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14536); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14535, BgL_sz00_14526); 
return BgL_____rz00_14537;} } } } } } } } 

}



/* &run5189 */
obj_t BGl_z62run5189z62zz__evaluate_compz00(obj_t BgL_envz00_12296, obj_t BgL_sz00_12299)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_12297;obj_t BgL_bodyz00_12298;
BgL_i1244z00_12297 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12296, 
(int)(((long)0)))); 
BgL_bodyz00_12298 = 
PROCEDURE_REF(BgL_envz00_12296, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14538;
BgL_bpz00_14538 = 
VECTOR_REF(
((obj_t)BgL_sz00_12299),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14539;obj_t BgL_wherez00_14540;obj_t BgL_locz00_14541;
BgL_z12denvz12_14539 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14540 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12297))->BgL_wherez00); 
BgL_locz00_14541 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12297))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14539, BgL_wherez00_14540, BgL_locz00_14541); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_14542;
BgL_za2za2resza2za2z00_14542 = 
PROCEDURE_ENTRY(BgL_bodyz00_12298)(BgL_bodyz00_12298, BgL_sz00_12299, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14539); 
return BgL_za2za2resza2za2z00_14542;} } } } } } 

}



/* &<@anonymous:3615> */
obj_t BGl_z62zc3z04anonymousza33615ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12300, obj_t BgL_sz00_12305)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_12301;BgL_ev_absz00_bglt BgL_i1244z00_12302;obj_t BgL_bodyz00_12303;long BgL_siza7ezd2framez75_12304;
BgL_iboxesz00_12301 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12300, 
(int)(((long)0)))); 
BgL_i1244z00_12302 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12300, 
(int)(((long)1)))); 
BgL_bodyz00_12303 = 
PROCEDURE_REF(BgL_envz00_12300, 
(int)(((long)2))); 
BgL_siza7ezd2framez75_12304 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12300, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14543;
BgL_bpz00_14543 = 
VECTOR_REF(
((obj_t)BgL_sz00_12305),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14544;
BgL_runz00_14544 = 
MAKE_FX_PROCEDURE(BGl_z62run5191z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_runz00_14544, 
(int)(((long)0)), BgL_iboxesz00_12301); 
PROCEDURE_SET(BgL_runz00_14544, 
(int)(((long)1)), 
((obj_t)BgL_i1244z00_12302)); 
PROCEDURE_SET(BgL_runz00_14544, 
(int)(((long)2)), BgL_bodyz00_12303); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14545;
BgL_mainz00_14545 = 
MAKE_VA_PROCEDURE(BGl_z62main5190z62zz__evaluate_compz00, 
(int)(((long)-5)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_mainz00_14545, 
(int)(((long)0)), BgL_iboxesz00_12301); 
PROCEDURE_SET(BgL_mainz00_14545, 
(int)(((long)1)), BgL_bodyz00_12303); 
PROCEDURE_SET(BgL_mainz00_14545, 
(int)(((long)2)), 
((obj_t)BgL_i1244z00_12302)); 
PROCEDURE_SET(BgL_mainz00_14545, 
(int)(((long)3)), BgL_runz00_14544); 
PROCEDURE_SET(BgL_mainz00_14545, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_12304)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14546;
BgL_objz00_14546 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14544, BgL_objz00_14546); BgL_objz00_14546; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3616z00_14547;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3617z00_14548;obj_t BgL_arg3618z00_14549;
BgL_arg3617z00_14548 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12302))->BgL_arityz00); 
BgL_arg3618z00_14549 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12302))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14550;
BgL_newz00_14550 = 
create_struct(BGl_symbol5225z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_27647;
BgL_tmpz00_27647 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14550, BgL_tmpz00_27647, BgL_arg3618z00_14549); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_27652;int BgL_tmpz00_27650;
BgL_auxz00_27652 = 
BINT(BgL_siza7ezd2framez75_12304); 
BgL_tmpz00_27650 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14550, BgL_tmpz00_27650, BgL_auxz00_27652); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_27655;
BgL_tmpz00_27655 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14550, BgL_tmpz00_27655, BgL_runz00_14544); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_27658;
BgL_tmpz00_27658 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14550, BgL_tmpz00_27658, BgL_arg3617z00_14548); } 
BgL_arg3616z00_14547 = BgL_newz00_14550; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14545, BgL_arg3616z00_14547); BgL_arg3616z00_14547; } 
return BgL_mainz00_14545;} } } } } } 

}



/* &main5190 */
obj_t BGl_z62main5190z62zz__evaluate_compz00(obj_t BgL_envz00_12306, obj_t BgL_az00_12312, obj_t BgL_bz00_12313, obj_t BgL_cz00_12314, obj_t BgL_dz00_12315, obj_t BgL_restz00_12316)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_12309;obj_t BgL_runz00_12310;long BgL_siza7ezd2framez75_12311;
BgL_i1244z00_12309 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12306, 
(int)(((long)2)))); 
BgL_runz00_12310 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12306, 
(int)(((long)3)))); 
BgL_siza7ezd2framez75_12311 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12306, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14551;
BgL_sz00_14551 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14552;
BgL_bpz00_14552 = 
VECTOR_REF(
((obj_t)BgL_sz00_14551),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14551, BgL_bpz00_14552, 
BINT(BgL_siza7ezd2framez75_12311)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3621z00_14553;
BgL_arg3621z00_14553 = 
(
(long)CINT(BgL_bpz00_14552)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14551),BgL_arg3621z00_14553,BgL_az00_12312); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3622z00_14554;
BgL_arg3622z00_14554 = 
(
(long)CINT(BgL_bpz00_14552)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_14551),BgL_arg3622z00_14554,BgL_bz00_12313); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3623z00_14555;
BgL_arg3623z00_14555 = 
(
(long)CINT(BgL_bpz00_14552)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_14551),BgL_arg3623z00_14555,BgL_cz00_12314); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3624z00_14556;
BgL_arg3624z00_14556 = 
(
(long)CINT(BgL_bpz00_14552)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_14551),BgL_arg3624z00_14556,BgL_dz00_12315); } 
BGl_bindzd2framezd2zz__evaluate_compz00(BgL_sz00_14551, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12309))->BgL_wherez00), 
(
(long)CINT(BgL_bpz00_14552)+((long)4)), 
BGl_correctz00zz__evaluate_compz00(
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12309))->BgL_arityz00), ((long)4)), BgL_restz00_12316, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12309))->BgL_locz00)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14557;
BgL_ez00_14557 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14557, BgL_bpz00_14552); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14558;
BgL_accz00_14558 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12310, BgL_sz00_14551, BgL_bpz00_14552); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14557); 
VECTOR_SET(
((obj_t)BgL_sz00_14551),((long)0),BgL_bpz00_14552); 
return BgL_accz00_14558;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14559;
BgL_nsz00_14559 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14559,((long)1),BgL_sz00_14551); 
VECTOR_SET(BgL_nsz00_14559,((long)2),BgL_az00_12312); 
VECTOR_SET(BgL_nsz00_14559,((long)3),BgL_bz00_12313); 
VECTOR_SET(BgL_nsz00_14559,((long)4),BgL_cz00_12314); 
VECTOR_SET(BgL_nsz00_14559,((long)5),BgL_dz00_12315); 
BGl_bindzd2framezd2zz__evaluate_compz00(BgL_nsz00_14559, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12309))->BgL_wherez00), ((long)6), 
BGl_correctz00zz__evaluate_compz00(
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12309))->BgL_arityz00), ((long)4)), BgL_restz00_12316, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12309))->BgL_locz00)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14560;
BgL_z12denvz12_14560 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14560, BgL_nsz00_14559); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14561;
BgL_ez00_14561 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14561, BgL_sz00_14551); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14562;
BgL_____rz00_14562 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12310, BgL_nsz00_14559, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14561); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14560, BgL_sz00_14551); 
return BgL_____rz00_14562;} } } } } } } } 

}



/* &run5191 */
obj_t BGl_z62run5191z62zz__evaluate_compz00(obj_t BgL_envz00_12317, obj_t BgL_sz00_12321)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_12318;BgL_ev_absz00_bglt BgL_i1244z00_12319;obj_t BgL_bodyz00_12320;
BgL_iboxesz00_12318 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12317, 
(int)(((long)0)))); 
BgL_i1244z00_12319 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12317, 
(int)(((long)1)))); 
BgL_bodyz00_12320 = 
PROCEDURE_REF(BgL_envz00_12317, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14563;
BgL_bpz00_14563 = 
VECTOR_REF(
((obj_t)BgL_sz00_12321),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_12321, BgL_iboxesz00_12318, BgL_bpz00_14563); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14564;obj_t BgL_wherez00_14565;obj_t BgL_locz00_14566;
BgL_z12denvz12_14564 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14565 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12319))->BgL_wherez00); 
BgL_locz00_14566 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12319))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14564, BgL_wherez00_14565, BgL_locz00_14566); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_14567;
BgL_za2za2resza2za2z00_14567 = 
PROCEDURE_ENTRY(BgL_bodyz00_12320)(BgL_bodyz00_12320, BgL_sz00_12321, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14564); 
return BgL_za2za2resza2za2z00_14567;} } } } } } 

}



/* &<@anonymous:3638> */
obj_t BGl_z62zc3z04anonymousza33638ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12322, obj_t BgL_sz00_12328)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_12323;long BgL_siza7eza7_12324;BgL_ev_absz00_bglt BgL_i1244z00_12325;obj_t BgL_bodyz00_12326;long BgL_siza7ezd2framez75_12327;
BgL_ifreesz00_12323 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12322, 
(int)(((long)0)))); 
BgL_siza7eza7_12324 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12322, 
(int)(((long)1)))); 
BgL_i1244z00_12325 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12322, 
(int)(((long)2)))); 
BgL_bodyz00_12326 = 
PROCEDURE_REF(BgL_envz00_12322, 
(int)(((long)3))); 
BgL_siza7ezd2framez75_12327 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12322, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14568;
BgL_bpz00_14568 = 
VECTOR_REF(
((obj_t)BgL_sz00_12328),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_14569;
BgL_valza2za2_14569 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_12328, BgL_bpz00_14568, BgL_ifreesz00_12323); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14570;
BgL_runz00_14570 = 
MAKE_FX_PROCEDURE(BGl_z62run5193z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_runz00_14570, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_12324)); 
PROCEDURE_SET(BgL_runz00_14570, 
(int)(((long)1)), BgL_valza2za2_14569); 
PROCEDURE_SET(BgL_runz00_14570, 
(int)(((long)2)), 
((obj_t)BgL_i1244z00_12325)); 
PROCEDURE_SET(BgL_runz00_14570, 
(int)(((long)3)), BgL_bodyz00_12326); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14571;
BgL_mainz00_14571 = 
MAKE_VA_PROCEDURE(BGl_z62main5192z62zz__evaluate_compz00, 
(int)(((long)-5)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_mainz00_14571, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_12324)); 
PROCEDURE_SET(BgL_mainz00_14571, 
(int)(((long)1)), BgL_valza2za2_14569); 
PROCEDURE_SET(BgL_mainz00_14571, 
(int)(((long)2)), BgL_bodyz00_12326); 
PROCEDURE_SET(BgL_mainz00_14571, 
(int)(((long)3)), 
((obj_t)BgL_i1244z00_12325)); 
PROCEDURE_SET(BgL_mainz00_14571, 
(int)(((long)4)), BgL_runz00_14570); 
PROCEDURE_SET(BgL_mainz00_14571, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_12327)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14572;
BgL_objz00_14572 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14570, BgL_objz00_14572); BgL_objz00_14572; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3639z00_14573;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3640z00_14574;obj_t BgL_arg3641z00_14575;
BgL_arg3640z00_14574 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12325))->BgL_arityz00); 
BgL_arg3641z00_14575 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12325))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14576;
BgL_newz00_14576 = 
create_struct(BGl_symbol5225z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_27798;
BgL_tmpz00_27798 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14576, BgL_tmpz00_27798, BgL_arg3641z00_14575); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_27803;int BgL_tmpz00_27801;
BgL_auxz00_27803 = 
BINT(BgL_siza7ezd2framez75_12327); 
BgL_tmpz00_27801 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14576, BgL_tmpz00_27801, BgL_auxz00_27803); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_27806;
BgL_tmpz00_27806 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14576, BgL_tmpz00_27806, BgL_runz00_14570); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_27809;
BgL_tmpz00_27809 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14576, BgL_tmpz00_27809, BgL_arg3640z00_14574); } 
BgL_arg3639z00_14573 = BgL_newz00_14576; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14571, BgL_arg3639z00_14573); BgL_arg3639z00_14573; } 
return BgL_mainz00_14571;} } } } } } 

}



/* &main5192 */
obj_t BGl_z62main5192z62zz__evaluate_compz00(obj_t BgL_envz00_12329, obj_t BgL_az00_12336, obj_t BgL_bz00_12337, obj_t BgL_cz00_12338, obj_t BgL_dz00_12339, obj_t BgL_restz00_12340)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_12333;obj_t BgL_runz00_12334;long BgL_siza7ezd2framez75_12335;
BgL_i1244z00_12333 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12329, 
(int)(((long)3)))); 
BgL_runz00_12334 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12329, 
(int)(((long)4)))); 
BgL_siza7ezd2framez75_12335 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12329, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14577;
BgL_sz00_14577 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14578;
BgL_bpz00_14578 = 
VECTOR_REF(
((obj_t)BgL_sz00_14577),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14577, BgL_bpz00_14578, 
BINT(BgL_siza7ezd2framez75_12335)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3644z00_14579;
BgL_arg3644z00_14579 = 
(
(long)CINT(BgL_bpz00_14578)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14577),BgL_arg3644z00_14579,BgL_az00_12336); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3645z00_14580;
BgL_arg3645z00_14580 = 
(
(long)CINT(BgL_bpz00_14578)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_14577),BgL_arg3645z00_14580,BgL_bz00_12337); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3646z00_14581;
BgL_arg3646z00_14581 = 
(
(long)CINT(BgL_bpz00_14578)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_14577),BgL_arg3646z00_14581,BgL_cz00_12338); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3647z00_14582;
BgL_arg3647z00_14582 = 
(
(long)CINT(BgL_bpz00_14578)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_14577),BgL_arg3647z00_14582,BgL_dz00_12339); } 
BGl_bindzd2framezd2zz__evaluate_compz00(BgL_sz00_14577, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12333))->BgL_wherez00), 
(
(long)CINT(BgL_bpz00_14578)+((long)4)), 
BGl_correctz00zz__evaluate_compz00(
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12333))->BgL_arityz00), ((long)4)), BgL_restz00_12340, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12333))->BgL_locz00)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14583;
BgL_ez00_14583 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14583, BgL_bpz00_14578); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14584;
BgL_accz00_14584 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12334, BgL_sz00_14577, BgL_bpz00_14578); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14583); 
VECTOR_SET(
((obj_t)BgL_sz00_14577),((long)0),BgL_bpz00_14578); 
return BgL_accz00_14584;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14585;
BgL_nsz00_14585 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14585,((long)1),BgL_sz00_14577); 
VECTOR_SET(BgL_nsz00_14585,((long)2),BgL_az00_12336); 
VECTOR_SET(BgL_nsz00_14585,((long)3),BgL_bz00_12337); 
VECTOR_SET(BgL_nsz00_14585,((long)4),BgL_cz00_12338); 
VECTOR_SET(BgL_nsz00_14585,((long)5),BgL_dz00_12339); 
BGl_bindzd2framezd2zz__evaluate_compz00(BgL_nsz00_14585, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12333))->BgL_wherez00), ((long)6), 
BGl_correctz00zz__evaluate_compz00(
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12333))->BgL_arityz00), ((long)4)), BgL_restz00_12340, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12333))->BgL_locz00)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14586;
BgL_z12denvz12_14586 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14586, BgL_nsz00_14585); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14587;
BgL_ez00_14587 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14587, BgL_sz00_14577); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14588;
BgL_____rz00_14588 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12334, BgL_nsz00_14585, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14587); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14586, BgL_sz00_14577); 
return BgL_____rz00_14588;} } } } } } } } 

}



/* &run5193 */
obj_t BGl_z62run5193z62zz__evaluate_compz00(obj_t BgL_envz00_12341, obj_t BgL_sz00_12346)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_siza7eza7_12342;obj_t BgL_valza2za2_12343;BgL_ev_absz00_bglt BgL_i1244z00_12344;obj_t BgL_bodyz00_12345;
BgL_siza7eza7_12342 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12341, 
(int)(((long)0)))); 
BgL_valza2za2_12343 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12341, 
(int)(((long)1)))); 
BgL_i1244z00_12344 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12341, 
(int)(((long)2)))); 
BgL_bodyz00_12345 = 
PROCEDURE_REF(BgL_envz00_12341, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14589;
BgL_bpz00_14589 = 
VECTOR_REF(
((obj_t)BgL_sz00_12346),((long)0)); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_12346, BgL_valza2za2_12343, 
(
(long)CINT(BgL_bpz00_14589)+BgL_siza7eza7_12342)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_14590;obj_t BgL_wherez00_14591;obj_t BgL_locz00_14592;
BgL_z12denvz12_14590 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14591 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12344))->BgL_wherez00); 
BgL_locz00_14592 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12344))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14590, BgL_wherez00_14591, BgL_locz00_14592); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_14593;
BgL_za2za2resza2za2z00_14593 = 
PROCEDURE_ENTRY(BgL_bodyz00_12345)(BgL_bodyz00_12345, BgL_sz00_12346, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14590); 
return BgL_za2za2resza2za2z00_14593;} } } } } } 

}



/* &<@anonymous:3659> */
obj_t BGl_z62zc3z04anonymousza33659ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12347, obj_t BgL_sz00_12354)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_12348;obj_t BgL_iboxesz00_12349;long BgL_siza7eza7_12350;BgL_ev_absz00_bglt BgL_i1244z00_12351;obj_t BgL_bodyz00_12352;long BgL_siza7ezd2framez75_12353;
BgL_ifreesz00_12348 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12347, 
(int)(((long)0)))); 
BgL_iboxesz00_12349 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12347, 
(int)(((long)1)))); 
BgL_siza7eza7_12350 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12347, 
(int)(((long)2)))); 
BgL_i1244z00_12351 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12347, 
(int)(((long)3)))); 
BgL_bodyz00_12352 = 
PROCEDURE_REF(BgL_envz00_12347, 
(int)(((long)4))); 
BgL_siza7ezd2framez75_12353 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12347, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14594;
BgL_bpz00_14594 = 
VECTOR_REF(
((obj_t)BgL_sz00_12354),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_14595;
BgL_valza2za2_14595 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_12354, BgL_bpz00_14594, BgL_ifreesz00_12348); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14596;
BgL_runz00_14596 = 
MAKE_FX_PROCEDURE(BGl_z62run5195z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_runz00_14596, 
(int)(((long)0)), BgL_iboxesz00_12349); 
PROCEDURE_SET(BgL_runz00_14596, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_12350)); 
PROCEDURE_SET(BgL_runz00_14596, 
(int)(((long)2)), BgL_valza2za2_14595); 
PROCEDURE_SET(BgL_runz00_14596, 
(int)(((long)3)), 
((obj_t)BgL_i1244z00_12351)); 
PROCEDURE_SET(BgL_runz00_14596, 
(int)(((long)4)), BgL_bodyz00_12352); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14597;
BgL_mainz00_14597 = 
MAKE_VA_PROCEDURE(BGl_z62main5194z62zz__evaluate_compz00, 
(int)(((long)-5)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_mainz00_14597, 
(int)(((long)0)), BgL_iboxesz00_12349); 
PROCEDURE_SET(BgL_mainz00_14597, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_12350)); 
PROCEDURE_SET(BgL_mainz00_14597, 
(int)(((long)2)), BgL_valza2za2_14595); 
PROCEDURE_SET(BgL_mainz00_14597, 
(int)(((long)3)), BgL_bodyz00_12352); 
PROCEDURE_SET(BgL_mainz00_14597, 
(int)(((long)4)), 
((obj_t)BgL_i1244z00_12351)); 
PROCEDURE_SET(BgL_mainz00_14597, 
(int)(((long)5)), BgL_runz00_14596); 
PROCEDURE_SET(BgL_mainz00_14597, 
(int)(((long)6)), 
BINT(BgL_siza7ezd2framez75_12353)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14598;
BgL_objz00_14598 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14596, BgL_objz00_14598); BgL_objz00_14598; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3660z00_14599;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3661z00_14600;obj_t BgL_arg3662z00_14601;
BgL_arg3661z00_14600 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12351))->BgL_arityz00); 
BgL_arg3662z00_14601 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12351))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14602;
BgL_newz00_14602 = 
create_struct(BGl_symbol5225z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_27961;
BgL_tmpz00_27961 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14602, BgL_tmpz00_27961, BgL_arg3662z00_14601); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_27966;int BgL_tmpz00_27964;
BgL_auxz00_27966 = 
BINT(BgL_siza7ezd2framez75_12353); 
BgL_tmpz00_27964 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14602, BgL_tmpz00_27964, BgL_auxz00_27966); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_27969;
BgL_tmpz00_27969 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14602, BgL_tmpz00_27969, BgL_runz00_14596); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_27972;
BgL_tmpz00_27972 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14602, BgL_tmpz00_27972, BgL_arg3661z00_14600); } 
BgL_arg3660z00_14599 = BgL_newz00_14602; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14597, BgL_arg3660z00_14599); BgL_arg3660z00_14599; } 
return BgL_mainz00_14597;} } } } } } 

}



/* &main5194 */
obj_t BGl_z62main5194z62zz__evaluate_compz00(obj_t BgL_envz00_12355, obj_t BgL_az00_12363, obj_t BgL_bz00_12364, obj_t BgL_cz00_12365, obj_t BgL_dz00_12366, obj_t BgL_restz00_12367)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_12360;obj_t BgL_runz00_12361;long BgL_siza7ezd2framez75_12362;
BgL_i1244z00_12360 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12355, 
(int)(((long)4)))); 
BgL_runz00_12361 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12355, 
(int)(((long)5)))); 
BgL_siza7ezd2framez75_12362 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12355, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14603;
BgL_sz00_14603 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14604;
BgL_bpz00_14604 = 
VECTOR_REF(
((obj_t)BgL_sz00_14603),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14603, BgL_bpz00_14604, 
BINT(BgL_siza7ezd2framez75_12362)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3665z00_14605;
BgL_arg3665z00_14605 = 
(
(long)CINT(BgL_bpz00_14604)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14603),BgL_arg3665z00_14605,BgL_az00_12363); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3666z00_14606;
BgL_arg3666z00_14606 = 
(
(long)CINT(BgL_bpz00_14604)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_14603),BgL_arg3666z00_14606,BgL_bz00_12364); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3667z00_14607;
BgL_arg3667z00_14607 = 
(
(long)CINT(BgL_bpz00_14604)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_14603),BgL_arg3667z00_14607,BgL_cz00_12365); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3668z00_14608;
BgL_arg3668z00_14608 = 
(
(long)CINT(BgL_bpz00_14604)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_14603),BgL_arg3668z00_14608,BgL_dz00_12366); } 
BGl_bindzd2framezd2zz__evaluate_compz00(BgL_sz00_14603, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12360))->BgL_wherez00), 
(
(long)CINT(BgL_bpz00_14604)+((long)4)), 
BGl_correctz00zz__evaluate_compz00(
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12360))->BgL_arityz00), ((long)4)), BgL_restz00_12367, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12360))->BgL_locz00)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14609;
BgL_ez00_14609 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14609, BgL_bpz00_14604); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14610;
BgL_accz00_14610 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12361, BgL_sz00_14603, BgL_bpz00_14604); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14609); 
VECTOR_SET(
((obj_t)BgL_sz00_14603),((long)0),BgL_bpz00_14604); 
return BgL_accz00_14610;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14611;
BgL_nsz00_14611 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14611,((long)1),BgL_sz00_14603); 
VECTOR_SET(BgL_nsz00_14611,((long)2),BgL_az00_12363); 
VECTOR_SET(BgL_nsz00_14611,((long)3),BgL_bz00_12364); 
VECTOR_SET(BgL_nsz00_14611,((long)4),BgL_cz00_12365); 
VECTOR_SET(BgL_nsz00_14611,((long)5),BgL_dz00_12366); 
BGl_bindzd2framezd2zz__evaluate_compz00(BgL_nsz00_14611, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12360))->BgL_wherez00), ((long)6), 
BGl_correctz00zz__evaluate_compz00(
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12360))->BgL_arityz00), ((long)4)), BgL_restz00_12367, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12360))->BgL_locz00)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14612;
BgL_z12denvz12_14612 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14612, BgL_nsz00_14611); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14613;
BgL_ez00_14613 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14613, BgL_sz00_14603); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14614;
BgL_____rz00_14614 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12361, BgL_nsz00_14611, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14613); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14612, BgL_sz00_14603); 
return BgL_____rz00_14614;} } } } } } } } 

}



/* &run5195 */
obj_t BGl_z62run5195z62zz__evaluate_compz00(obj_t BgL_envz00_12368, obj_t BgL_sz00_12374)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_12369;long BgL_siza7eza7_12370;obj_t BgL_valza2za2_12371;BgL_ev_absz00_bglt BgL_i1244z00_12372;obj_t BgL_bodyz00_12373;
BgL_iboxesz00_12369 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12368, 
(int)(((long)0)))); 
BgL_siza7eza7_12370 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12368, 
(int)(((long)1)))); 
BgL_valza2za2_12371 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12368, 
(int)(((long)2)))); 
BgL_i1244z00_12372 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12368, 
(int)(((long)3)))); 
BgL_bodyz00_12373 = 
PROCEDURE_REF(BgL_envz00_12368, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14615;
BgL_bpz00_14615 = 
VECTOR_REF(
((obj_t)BgL_sz00_12374),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_12374, BgL_iboxesz00_12369, BgL_bpz00_14615); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_12374, BgL_valza2za2_12371, 
(
(long)CINT(BgL_bpz00_14615)+BgL_siza7eza7_12370)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_14616;obj_t BgL_wherez00_14617;obj_t BgL_locz00_14618;
BgL_z12denvz12_14616 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14617 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12372))->BgL_wherez00); 
BgL_locz00_14618 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_12372))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14616, BgL_wherez00_14617, BgL_locz00_14618); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_14619;
BgL_za2za2resza2za2z00_14619 = 
PROCEDURE_ENTRY(BgL_bodyz00_12373)(BgL_bodyz00_12373, BgL_sz00_12374, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14616); 
return BgL_za2za2resza2za2z00_14619;} } } } } } 

}



/* &comp-ev_app1430 */
obj_t BGl_z62compzd2ev_app1430zb0zz__evaluate_compz00(obj_t BgL_envz00_12375, obj_t BgL_ez00_12376, obj_t BgL_stkz00_12377)
{
{ /* Eval/evaluate_comp.scm 1044 */
{ /* Eval/evaluate_comp.scm 1046 */
obj_t BgL__ortest_1230z00_14621;
BgL__ortest_1230z00_14621 = 
BGl_arithzd2expressionzd2zz__evaluate_compz00(
((BgL_ev_appz00_bglt)BgL_ez00_12376), BgL_stkz00_12377); 
if(
CBOOL(BgL__ortest_1230z00_14621))
{ /* Eval/evaluate_comp.scm 1046 */
return BgL__ortest_1230z00_14621;}  else 
{ /* Eval/evaluate_comp.scm 1047 */
obj_t BgL__ortest_1231z00_14622;
BgL__ortest_1231z00_14622 = 
BGl_inlinezd2callzd2zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12376)))->BgL_locz00), 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12376)))->BgL_funz00), 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12376)))->BgL_argsz00), BgL_stkz00_12377); 
if(
CBOOL(BgL__ortest_1231z00_14622))
{ /* Eval/evaluate_comp.scm 1047 */
return BgL__ortest_1231z00_14622;}  else 
{ /* Eval/evaluate_comp.scm 1047 */
if(
(
bgl_list_length(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12376)))->BgL_argsz00))>((long)4)))
{ /* Eval/evaluate_comp.scm 1048 */
return 
BGl_compzd2oldzd2callz00zz__evaluate_compz00(
((BgL_ev_appz00_bglt)BgL_ez00_12376), BgL_stkz00_12377);}  else 
{ /* Eval/evaluate_comp.scm 1050 */
obj_t BgL_fz00_14623;long BgL_siza7eza7_14624;obj_t BgL_symbzd2funzd2_14625;
BgL_fz00_14623 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12376)))->BgL_funz00), BgL_stkz00_12377); 
BgL_siza7eza7_14624 = 
bgl_list_length(BgL_stkz00_12377); 
BgL_symbzd2funzd2_14625 = 
BGl_uncompilez00zz__evaluate_uncompz00(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12376)))->BgL_funz00)); 
if(
NULLP(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12376)))->BgL_argsz00)))
{ /* Eval/evaluate_comp.scm 1051 */
return 
BGl_compzd2call0zd2zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12376)))->BgL_locz00), 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12376)))->BgL_funz00), BgL_symbzd2funzd2_14625, BgL_fz00_14623, 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12376)))->BgL_tailzf3zf3), BgL_stkz00_12377, BgL_siza7eza7_14624);}  else 
{ /* Eval/evaluate_comp.scm 1053 */
obj_t BgL_a1z00_14626;obj_t BgL_argsz00_14627;
{ /* Eval/evaluate_comp.scm 1053 */
obj_t BgL_arg3129z00_14628;
BgL_arg3129z00_14628 = 
CAR(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12376)))->BgL_argsz00)); 
BgL_a1z00_14626 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_arg3129z00_14628), BgL_stkz00_12377); } 
BgL_argsz00_14627 = 
CDR(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12376)))->BgL_argsz00)); 
if(
NULLP(BgL_argsz00_14627))
{ /* Eval/evaluate_comp.scm 1053 */
return 
BGl_compzd2call1zd2zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12376)))->BgL_locz00), 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12376)))->BgL_funz00), BgL_symbzd2funzd2_14625, BgL_fz00_14623, 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12376)))->BgL_tailzf3zf3), BgL_stkz00_12377, BgL_siza7eza7_14624, BgL_a1z00_14626);}  else 
{ /* Eval/evaluate_comp.scm 1053 */
obj_t BgL_a2z00_14629;obj_t BgL_argsz00_14630;
{ /* Eval/evaluate_comp.scm 1053 */
obj_t BgL_arg3128z00_14631;
BgL_arg3128z00_14631 = 
CAR(
((obj_t)BgL_argsz00_14627)); 
BgL_a2z00_14629 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_arg3128z00_14631), BgL_stkz00_12377); } 
BgL_argsz00_14630 = 
CDR(
((obj_t)BgL_argsz00_14627)); 
if(
NULLP(BgL_argsz00_14630))
{ /* Eval/evaluate_comp.scm 1053 */
return 
BGl_compzd2call2zd2zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12376)))->BgL_locz00), 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12376)))->BgL_funz00), BgL_symbzd2funzd2_14625, BgL_fz00_14623, 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12376)))->BgL_tailzf3zf3), BgL_stkz00_12377, BgL_siza7eza7_14624, BgL_a1z00_14626, BgL_a2z00_14629);}  else 
{ /* Eval/evaluate_comp.scm 1053 */
obj_t BgL_a3z00_14632;obj_t BgL_argsz00_14633;
{ /* Eval/evaluate_comp.scm 1053 */
obj_t BgL_arg3127z00_14634;
BgL_arg3127z00_14634 = 
CAR(
((obj_t)BgL_argsz00_14630)); 
BgL_a3z00_14632 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_arg3127z00_14634), BgL_stkz00_12377); } 
BgL_argsz00_14633 = 
CDR(
((obj_t)BgL_argsz00_14630)); 
if(
NULLP(BgL_argsz00_14633))
{ /* Eval/evaluate_comp.scm 1053 */
return 
BGl_compzd2call3zd2zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12376)))->BgL_locz00), 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12376)))->BgL_funz00), BgL_symbzd2funzd2_14625, BgL_fz00_14623, 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12376)))->BgL_tailzf3zf3), BgL_stkz00_12377, BgL_siza7eza7_14624, BgL_a1z00_14626, BgL_a2z00_14629, BgL_a3z00_14632);}  else 
{ /* Eval/evaluate_comp.scm 1053 */
obj_t BgL_a4z00_14635;obj_t BgL_argsz00_14636;
{ /* Eval/evaluate_comp.scm 1053 */
obj_t BgL_arg3126z00_14637;
BgL_arg3126z00_14637 = 
CAR(
((obj_t)BgL_argsz00_14633)); 
BgL_a4z00_14635 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_arg3126z00_14637), BgL_stkz00_12377); } 
BgL_argsz00_14636 = 
CDR(
((obj_t)BgL_argsz00_14633)); 
if(
NULLP(BgL_argsz00_14636))
{ /* Eval/evaluate_comp.scm 1053 */
return 
BGl_compzd2call4zd2zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12376)))->BgL_locz00), 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12376)))->BgL_funz00), BgL_symbzd2funzd2_14625, BgL_fz00_14623, 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12376)))->BgL_tailzf3zf3), BgL_stkz00_12377, BgL_siza7eza7_14624, BgL_a1z00_14626, BgL_a2z00_14629, BgL_a3z00_14632, BgL_a4z00_14635);}  else 
{ /* Eval/evaluate_comp.scm 1053 */
return 
BGl_errorz00zz__errorz00(BGl_string5208z00zz__evaluate_compz00, BGl_string5323z00zz__evaluate_compz00, BGl_string5324z00zz__evaluate_compz00);} } } } } } } } } } 

}



/* &comp-ev_goto1428 */
obj_t BGl_z62compzd2ev_goto1428zb0zz__evaluate_compz00(obj_t BgL_envz00_12378, obj_t BgL_ez00_12379, obj_t BgL_stkz00_12380)
{
{ /* Eval/evaluate_comp.scm 604 */
{ /* Eval/evaluate_comp.scm 607 */
obj_t BgL_slotz00_14641;long BgL_siza7eza7_14642;obj_t BgL_lstkz00_14643;
BgL_slotz00_14641 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(
((obj_t)
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_ez00_12379)))->BgL_labelz00)), 
(((BgL_ev_labelsz00_bglt)COBJECT(
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_ez00_12379)))->BgL_labelsz00)))->BgL_envz00)); 
BgL_siza7eza7_14642 = 
bgl_list_length(BgL_stkz00_12380); 
BgL_lstkz00_14643 = 
(((BgL_ev_labelsz00_bglt)COBJECT(
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_ez00_12379)))->BgL_labelsz00)))->BgL_stkz00); 
{ /* Eval/evaluate_comp.scm 609 */
long BgL_llstkz00_14644;obj_t BgL_substkz00_14645;obj_t BgL_boxesz00_14646;
BgL_llstkz00_14644 = 
bgl_list_length(BgL_lstkz00_14643); 
BgL_substkz00_14645 = 
BGl_subzd2stkzd2zz__evaluate_compz00(BgL_lstkz00_14643, BgL_stkz00_12380); 
{ /* Eval/evaluate_comp.scm 609 */
obj_t BgL_pairz00_14647;
BgL_pairz00_14647 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(
((obj_t)
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_ez00_12379)))->BgL_labelz00)), 
(((BgL_ev_labelsz00_bglt)COBJECT(
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_ez00_12379)))->BgL_labelsz00)))->BgL_boxesz00)); 
BgL_boxesz00_14646 = 
CDR(BgL_pairz00_14647); } 
if(
BGl_needzd2shiftzd2zz__evaluate_compz00(
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_ez00_12379)))->BgL_argsz00), BgL_substkz00_14645))
{ /* Eval/evaluate_comp.scm 612 */
obj_t BgL_argsz00_14648;long BgL_nbargsz00_14649;
BgL_argsz00_14648 = 
BGl_compzd2withzd2pushz00zz__evaluate_compz00(
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_ez00_12379)))->BgL_argsz00), BgL_stkz00_12380); 
BgL_nbargsz00_14649 = 
bgl_list_length(
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_ez00_12379)))->BgL_argsz00)); 
{ /* Eval/evaluate_comp.scm 613 */
obj_t BgL_zc3z04anonymousza33084ze3z87_14650;
BgL_zc3z04anonymousza33084ze3z87_14650 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33084ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33084ze3z87_14650, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_14642)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33084ze3z87_14650, 
(int)(((long)1)), 
BINT(BgL_llstkz00_14644)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33084ze3z87_14650, 
(int)(((long)2)), 
((obj_t)
((BgL_ev_gotoz00_bglt)BgL_ez00_12379))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33084ze3z87_14650, 
(int)(((long)3)), BgL_argsz00_14648); 
PROCEDURE_SET(BgL_zc3z04anonymousza33084ze3z87_14650, 
(int)(((long)4)), BgL_boxesz00_14646); 
PROCEDURE_SET(BgL_zc3z04anonymousza33084ze3z87_14650, 
(int)(((long)5)), 
BINT(BgL_nbargsz00_14649)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33084ze3z87_14650, 
(int)(((long)6)), BgL_slotz00_14641); 
return BgL_zc3z04anonymousza33084ze3z87_14650;} }  else 
{ /* Eval/evaluate_comp.scm 618 */
obj_t BgL_argsz00_14651;
{ /* Eval/evaluate_comp.scm 618 */
obj_t BgL_lz00_14652;long BgL_nz00_14653;
BgL_lz00_14652 = 
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_ez00_12379)))->BgL_argsz00); 
BgL_nz00_14653 = 
(BgL_siza7eza7_14642-BgL_llstkz00_14644); 
BgL_argsz00_14651 = 
BGl_recze70ze7zz__evaluate_compz00(BgL_stkz00_12380, BgL_lz00_14652, BgL_nz00_14653); } 
{ /* Eval/evaluate_comp.scm 619 */
obj_t BgL_zc3z04anonymousza33090ze3z87_14654;
BgL_zc3z04anonymousza33090ze3z87_14654 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33090ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33090ze3z87_14654, 
(int)(((long)0)), 
BINT(BgL_llstkz00_14644)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33090ze3z87_14654, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_gotoz00_bglt)BgL_ez00_12379))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33090ze3z87_14654, 
(int)(((long)2)), BgL_argsz00_14651); 
PROCEDURE_SET(BgL_zc3z04anonymousza33090ze3z87_14654, 
(int)(((long)3)), BgL_boxesz00_14646); 
PROCEDURE_SET(BgL_zc3z04anonymousza33090ze3z87_14654, 
(int)(((long)4)), BgL_slotz00_14641); 
return BgL_zc3z04anonymousza33090ze3z87_14654;} } } } } 

}



/* &<@anonymous:3084> */
obj_t BGl_z62zc3z04anonymousza33084ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12381, obj_t BgL_sz00_12389)
{
{ /* Eval/evaluate_comp.scm 613 */
{ /* Eval/evaluate_comp.scm 613 */
long BgL_siza7eza7_12382;long BgL_llstkz00_12383;BgL_ev_gotoz00_bglt BgL_i1142z00_12384;obj_t BgL_argsz00_12385;obj_t BgL_boxesz00_12386;long BgL_nbargsz00_12387;obj_t BgL_slotz00_12388;
BgL_siza7eza7_12382 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12381, 
(int)(((long)0)))); 
BgL_llstkz00_12383 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12381, 
(int)(((long)1)))); 
BgL_i1142z00_12384 = 
((BgL_ev_gotoz00_bglt)
PROCEDURE_REF(BgL_envz00_12381, 
(int)(((long)2)))); 
BgL_argsz00_12385 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12381, 
(int)(((long)3)))); 
BgL_boxesz00_12386 = 
PROCEDURE_REF(BgL_envz00_12381, 
(int)(((long)4))); 
BgL_nbargsz00_12387 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12381, 
(int)(((long)5)))); 
BgL_slotz00_12388 = 
PROCEDURE_REF(BgL_envz00_12381, 
(int)(((long)6))); 
{ /* Eval/evaluate_comp.scm 613 */
obj_t BgL_bpz00_14655;
BgL_bpz00_14655 = 
VECTOR_REF(
((obj_t)BgL_sz00_12389),((long)0)); 
{ /* Eval/evaluate_comp.scm 614 */
long BgL_spz00_14656;long BgL_lspz00_14657;
BgL_spz00_14656 = 
(
(long)CINT(BgL_bpz00_14655)+BgL_siza7eza7_12382); 
BgL_lspz00_14657 = 
(
(long)CINT(BgL_bpz00_14655)+BgL_llstkz00_12383); 
BGl_pushzd2boxeszd2argszd2onzd2spz00zz__evaluate_compz00(BgL_sz00_12389, BgL_argsz00_12385, BgL_boxesz00_12386, BgL_spz00_14656, 
(((BgL_ev_gotoz00_bglt)COBJECT(BgL_i1142z00_12384))->BgL_locz00)); 
{ /* Eval/evaluate_comp.scm 616 */
long BgL_arg3086z00_14658;
BgL_arg3086z00_14658 = 
(BgL_spz00_14656+BgL_nbargsz00_12387); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_sz00_12389, BgL_lspz00_14657, BgL_sz00_12389, 
BINT(BgL_spz00_14656), 
BINT(BgL_arg3086z00_14658)); } 
return 
CDR(
((obj_t)BgL_slotz00_12388));} } } } 

}



/* &<@anonymous:3090> */
obj_t BGl_z62zc3z04anonymousza33090ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12390, obj_t BgL_sz00_12396)
{
{ /* Eval/evaluate_comp.scm 619 */
{ /* Eval/evaluate_comp.scm 619 */
long BgL_llstkz00_12391;BgL_ev_gotoz00_bglt BgL_i1142z00_12392;obj_t BgL_argsz00_12393;obj_t BgL_boxesz00_12394;obj_t BgL_slotz00_12395;
BgL_llstkz00_12391 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12390, 
(int)(((long)0)))); 
BgL_i1142z00_12392 = 
((BgL_ev_gotoz00_bglt)
PROCEDURE_REF(BgL_envz00_12390, 
(int)(((long)1)))); 
BgL_argsz00_12393 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12390, 
(int)(((long)2)))); 
BgL_boxesz00_12394 = 
PROCEDURE_REF(BgL_envz00_12390, 
(int)(((long)3))); 
BgL_slotz00_12395 = 
PROCEDURE_REF(BgL_envz00_12390, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 619 */
obj_t BgL_bpz00_14659;
BgL_bpz00_14659 = 
VECTOR_REF(
((obj_t)BgL_sz00_12396),((long)0)); 
BGl_pushzd2boxeszd2argszd2onzd2spz00zz__evaluate_compz00(BgL_sz00_12396, BgL_argsz00_12393, BgL_boxesz00_12394, 
(
(long)CINT(BgL_bpz00_14659)+BgL_llstkz00_12391), 
(((BgL_ev_gotoz00_bglt)COBJECT(BgL_i1142z00_12392))->BgL_locz00)); 
return 
CDR(
((obj_t)BgL_slotz00_12395));} } } 

}



/* &comp-ev_labels1426 */
obj_t BGl_z62compzd2ev_labels1426zb0zz__evaluate_compz00(obj_t BgL_envz00_12397, obj_t BgL_ez00_12398, obj_t BgL_stkz00_12399)
{
{ /* Eval/evaluate_comp.scm 572 */
{ 
obj_t BgL_fz00_14662;
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_ez00_12398)))->BgL_stkz00)=((obj_t)BgL_stkz00_12399),BUNSPEC); 
{ /* Eval/evaluate_comp.scm 579 */
obj_t BgL_envz00_14664;
{ /* Eval/evaluate_comp.scm 579 */
obj_t BgL_l1329z00_14665;
BgL_l1329z00_14665 = 
(((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_ez00_12398)))->BgL_varsz00); 
if(
NULLP(BgL_l1329z00_14665))
{ /* Eval/evaluate_comp.scm 579 */
BgL_envz00_14664 = BNIL; }  else 
{ /* Eval/evaluate_comp.scm 579 */
obj_t BgL_head1331z00_14666;
{ /* Eval/evaluate_comp.scm 579 */
obj_t BgL_res4727z00_14667;
BgL_res4727z00_14667 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1331z00_14666 = BgL_res4727z00_14667; } 
{ 
obj_t BgL_l1329z00_14669;obj_t BgL_tail1332z00_14670;
BgL_l1329z00_14669 = BgL_l1329z00_14665; 
BgL_tail1332z00_14670 = BgL_head1331z00_14666; 
BgL_zc3z04anonymousza33075ze3z87_14668:
if(
NULLP(BgL_l1329z00_14669))
{ /* Eval/evaluate_comp.scm 579 */
BgL_envz00_14664 = 
CDR(BgL_head1331z00_14666); }  else 
{ /* Eval/evaluate_comp.scm 579 */
obj_t BgL_newtail1333z00_14671;
{ /* Eval/evaluate_comp.scm 579 */
obj_t BgL_arg3078z00_14672;
{ /* Eval/evaluate_comp.scm 579 */
obj_t BgL_vz00_14673;
BgL_vz00_14673 = 
CAR(
((obj_t)BgL_l1329z00_14669)); 
BgL_arg3078z00_14672 = 
MAKE_YOUNG_PAIR(BgL_vz00_14673, BGl_symbol5325z00zz__evaluate_compz00); } 
{ /* Eval/evaluate_comp.scm 579 */
obj_t BgL_res4729z00_14674;
BgL_res4729z00_14674 = 
MAKE_YOUNG_PAIR(BgL_arg3078z00_14672, BNIL); 
BgL_newtail1333z00_14671 = BgL_res4729z00_14674; } } 
SET_CDR(BgL_tail1332z00_14670, BgL_newtail1333z00_14671); 
{ /* Eval/evaluate_comp.scm 579 */
obj_t BgL_arg3077z00_14675;
BgL_arg3077z00_14675 = 
CDR(
((obj_t)BgL_l1329z00_14669)); 
{ 
obj_t BgL_tail1332z00_28314;obj_t BgL_l1329z00_28313;
BgL_l1329z00_28313 = BgL_arg3077z00_14675; 
BgL_tail1332z00_28314 = BgL_newtail1333z00_14671; 
BgL_tail1332z00_14670 = BgL_tail1332z00_28314; 
BgL_l1329z00_14669 = BgL_l1329z00_28313; 
goto BgL_zc3z04anonymousza33075ze3z87_14668;} } } } } } 
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_ez00_12398)))->BgL_envz00)=((obj_t)BgL_envz00_14664),BUNSPEC); 
{ /* Eval/evaluate_comp.scm 582 */
obj_t BgL_g1337z00_14676;
BgL_g1337z00_14676 = 
(((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_ez00_12398)))->BgL_valsz00); 
{ 
obj_t BgL_ll1334z00_14678;obj_t BgL_ll1335z00_14679;
BgL_ll1334z00_14678 = BgL_envz00_14664; 
BgL_ll1335z00_14679 = BgL_g1337z00_14676; 
BgL_zc3z04anonymousza33065ze3z87_14677:
if(
NULLP(BgL_ll1334z00_14678))
{ /* Eval/evaluate_comp.scm 582 */((bool_t)1); }  else 
{ /* Eval/evaluate_comp.scm 582 */
{ /* Eval/evaluate_comp.scm 584 */
obj_t BgL_slotz00_14680;obj_t BgL_valz00_14681;
BgL_slotz00_14680 = 
CAR(
((obj_t)BgL_ll1334z00_14678)); 
BgL_valz00_14681 = 
CAR(
((obj_t)BgL_ll1335z00_14679)); 
{ /* Eval/evaluate_comp.scm 585 */
obj_t BgL_arg3067z00_14682;
{ /* Eval/evaluate_comp.scm 585 */
obj_t BgL_arg3068z00_14683;
{ /* Eval/evaluate_comp.scm 585 */
obj_t BgL_arg3069z00_14684;obj_t BgL_arg3070z00_14685;
BgL_arg3069z00_14684 = 
CDR(
((obj_t)BgL_valz00_14681)); 
{ /* Eval/evaluate_comp.scm 585 */
obj_t BgL_arg3071z00_14686;
BgL_arg3071z00_14686 = 
CAR(
((obj_t)BgL_valz00_14681)); 
BgL_arg3070z00_14685 = 
BGl_appendzd221010zd2zz__evaluate_compz00(BgL_stkz00_12399, BgL_arg3071z00_14686); } 
BgL_arg3068z00_14683 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_arg3069z00_14684), BgL_arg3070z00_14685); } 
BgL_fz00_14662 = BgL_arg3068z00_14683; 
{ /* Eval/evaluate_comp.scm 574 */
obj_t BgL_objz00_14663;
BgL_objz00_14663 = BGl_za2za2azd2labelza2za2zd2zz__evaluate_compz00; 
{ /* Eval/evaluate_comp.scm 574 */
obj_t BgL_tmpz00_28332;
BgL_tmpz00_28332 = 
((obj_t)BgL_fz00_14662); 
PROCEDURE_ATTR_SET(BgL_tmpz00_28332, BgL_objz00_14663); } BgL_objz00_14663; } 
BgL_arg3067z00_14682 = BgL_fz00_14662; } 
{ /* Eval/evaluate_comp.scm 584 */
obj_t BgL_tmpz00_28335;
BgL_tmpz00_28335 = 
((obj_t)BgL_slotz00_14680); 
SET_CDR(BgL_tmpz00_28335, BgL_arg3067z00_14682); } } } 
{ /* Eval/evaluate_comp.scm 582 */
obj_t BgL_arg3072z00_14687;obj_t BgL_arg3073z00_14688;
BgL_arg3072z00_14687 = 
CDR(
((obj_t)BgL_ll1334z00_14678)); 
BgL_arg3073z00_14688 = 
CDR(
((obj_t)BgL_ll1335z00_14679)); 
{ 
obj_t BgL_ll1335z00_28343;obj_t BgL_ll1334z00_28342;
BgL_ll1334z00_28342 = BgL_arg3072z00_14687; 
BgL_ll1335z00_28343 = BgL_arg3073z00_14688; 
BgL_ll1335z00_14679 = BgL_ll1335z00_28343; 
BgL_ll1334z00_14678 = BgL_ll1334z00_28342; 
goto BgL_zc3z04anonymousza33065ze3z87_14677;} } } } } } 
{ /* Eval/evaluate_comp.scm 589 */
obj_t BgL_bodyz00_14689;
BgL_bodyz00_14689 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_ez00_12398)))->BgL_bodyz00), BgL_stkz00_12399); 
{ /* Eval/evaluate_comp.scm 590 */
obj_t BgL_zc3z04anonymousza33079ze3z87_14690;
BgL_zc3z04anonymousza33079ze3z87_14690 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33079ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33079ze3z87_14690, 
(int)(((long)0)), BgL_bodyz00_14689); 
return BgL_zc3z04anonymousza33079ze3z87_14690;} } } } 

}



/* &<@anonymous:3079> */
obj_t BGl_z62zc3z04anonymousza33079ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12400, obj_t BgL_sz00_12402)
{
{ /* Eval/evaluate_comp.scm 590 */
{ /* Eval/evaluate_comp.scm 590 */
obj_t BgL_bodyz00_12401;
BgL_bodyz00_12401 = 
PROCEDURE_REF(BgL_envz00_12400, 
(int)(((long)0))); 
{ /* Eval/evaluate_comp.scm 590 */
obj_t BgL_bpz00_14691;
BgL_bpz00_14691 = 
VECTOR_REF(
((obj_t)BgL_sz00_12402),((long)0)); 
return 
BGl_catchzd2gotozd2trampolinez00zz__evaluate_compz00(BgL_bodyz00_12401, BgL_sz00_12402);} } } 

}



/* &comp-ev_synchronize1424 */
obj_t BGl_z62compzd2ev_synchroniza7e1424z17zz__evaluate_compz00(obj_t BgL_envz00_12403, obj_t BgL_ez00_12404, obj_t BgL_stkz00_12405)
{
{ /* Eval/evaluate_comp.scm 552 */
{ /* Eval/evaluate_comp.scm 554 */
obj_t BgL_mutexz00_14693;obj_t BgL_prelockz00_14694;obj_t BgL_bodyz00_14695;
BgL_mutexz00_14693 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_ez00_12404)))->BgL_mutexz00), BgL_stkz00_12405); 
BgL_prelockz00_14694 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_ez00_12404)))->BgL_prelockz00), BgL_stkz00_12405); 
BgL_bodyz00_14695 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_ez00_12404)))->BgL_bodyz00), BgL_stkz00_12405); 
{ /* Eval/evaluate_comp.scm 557 */
obj_t BgL_zc3z04anonymousza33058ze3z87_14696;
BgL_zc3z04anonymousza33058ze3z87_14696 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33058ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33058ze3z87_14696, 
(int)(((long)0)), BgL_mutexz00_14693); 
PROCEDURE_SET(BgL_zc3z04anonymousza33058ze3z87_14696, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_synchroniza7eza7_bglt)BgL_ez00_12404))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33058ze3z87_14696, 
(int)(((long)2)), BgL_prelockz00_14694); 
PROCEDURE_SET(BgL_zc3z04anonymousza33058ze3z87_14696, 
(int)(((long)3)), BgL_bodyz00_14695); 
return BgL_zc3z04anonymousza33058ze3z87_14696;} } } 

}



/* &<@anonymous:3058> */
obj_t BGl_z62zc3z04anonymousza33058ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12406, obj_t BgL_sz00_12411)
{
{ /* Eval/evaluate_comp.scm 557 */
{ /* Eval/evaluate_comp.scm 557 */
obj_t BgL_mutexz00_12407;BgL_ev_synchroniza7eza7_bglt BgL_i1139z00_12408;obj_t BgL_prelockz00_12409;obj_t BgL_bodyz00_12410;
BgL_mutexz00_12407 = 
PROCEDURE_REF(BgL_envz00_12406, 
(int)(((long)0))); 
BgL_i1139z00_12408 = 
((BgL_ev_synchroniza7eza7_bglt)
PROCEDURE_REF(BgL_envz00_12406, 
(int)(((long)1)))); 
BgL_prelockz00_12409 = 
PROCEDURE_REF(BgL_envz00_12406, 
(int)(((long)2))); 
BgL_bodyz00_12410 = 
PROCEDURE_REF(BgL_envz00_12406, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 557 */
obj_t BgL_bpz00_14697;
BgL_bpz00_14697 = 
VECTOR_REF(
((obj_t)BgL_sz00_12411),((long)0)); 
{ /* Eval/evaluate_comp.scm 558 */
obj_t BgL_mz00_14698;
BgL_mz00_14698 = 
PROCEDURE_ENTRY(BgL_mutexz00_12407)(BgL_mutexz00_12407, BgL_sz00_12411, BEOA); 
{ /* Eval/evaluate_comp.scm 559 */
bool_t BgL_test5958z00_28394;
{ /* Eval/evaluate_comp.scm 559 */
bool_t BgL_res4724z00_14699;
BgL_res4724z00_14699 = 
BGL_MUTEXP(BgL_mz00_14698); 
BgL_test5958z00_28394 = BgL_res4724z00_14699; } 
if(BgL_test5958z00_28394)
{ /* Eval/evaluate_comp.scm 560 */
obj_t BgL_pz00_14700;
BgL_pz00_14700 = 
PROCEDURE_ENTRY(BgL_prelockz00_12409)(BgL_prelockz00_12409, BgL_sz00_12411, BEOA); 
{ /* Eval/evaluate_comp.scm 562 */
obj_t BgL_za2za2resza2za2z00_14701;
if(
PAIRP(BgL_pz00_14700))
{ /* Eval/evaluate_comp.scm 563 */
obj_t BgL_top5961z00_28403;
BgL_top5961z00_28403 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGL_MUTEX_LOCK_PRELOCK(BgL_mz00_14698, BgL_pz00_14700); 
BGL_EXITD_PUSH_PROTECT(BgL_top5961z00_28403, BgL_mz00_14698); BUNSPEC; 
{ /* Eval/evaluate_comp.scm 563 */
obj_t BgL_tmp5960z00_28402;
BgL_tmp5960z00_28402 = 
PROCEDURE_ENTRY(BgL_bodyz00_12410)(BgL_bodyz00_12410, BgL_sz00_12411, BEOA); 
BGL_EXITD_POP_PROTECT(BgL_top5961z00_28403); BUNSPEC; 
BGL_MUTEX_UNLOCK(BgL_mz00_14698); 
BgL_za2za2resza2za2z00_14701 = BgL_tmp5960z00_28402; } }  else 
{ /* Eval/evaluate_comp.scm 564 */
obj_t BgL_top5963z00_28414;
BgL_top5963z00_28414 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGL_MUTEX_LOCK(BgL_mz00_14698); 
BGL_EXITD_PUSH_PROTECT(BgL_top5963z00_28414, BgL_mz00_14698); BUNSPEC; 
{ /* Eval/evaluate_comp.scm 564 */
obj_t BgL_tmp5962z00_28413;
BgL_tmp5962z00_28413 = 
PROCEDURE_ENTRY(BgL_bodyz00_12410)(BgL_bodyz00_12410, BgL_sz00_12411, BEOA); 
BGL_EXITD_POP_PROTECT(BgL_top5963z00_28414); BUNSPEC; 
BGL_MUTEX_UNLOCK(BgL_mz00_14698); 
BgL_za2za2resza2za2z00_14701 = BgL_tmp5962z00_28413; } } 
VECTOR_SET(
((obj_t)BgL_sz00_12411),((long)0),BgL_bpz00_14697); 
return BgL_za2za2resza2za2z00_14701;} }  else 
{ /* Eval/evaluate_comp.scm 559 */
return 
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_string5327z00zz__evaluate_compz00, BGl_string5328z00zz__evaluate_compz00, BgL_mz00_14698, 
(((BgL_ev_synchroniza7eza7_bglt)COBJECT(BgL_i1139z00_12408))->BgL_locz00));} } } } } } 

}



/* &comp-ev_with-handler1422 */
obj_t BGl_z62compzd2ev_withzd2handler1422z62zz__evaluate_compz00(obj_t BgL_envz00_12412, obj_t BgL_ez00_12413, obj_t BgL_stkz00_12414)
{
{ /* Eval/evaluate_comp.scm 543 */
{ /* Eval/evaluate_comp.scm 545 */
obj_t BgL_handlerz00_14703;obj_t BgL_bodyz00_14704;
BgL_handlerz00_14703 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_withzd2handlerzd2_bglt)COBJECT(
((BgL_ev_withzd2handlerzd2_bglt)BgL_ez00_12413)))->BgL_handlerz00), BgL_stkz00_12414); 
BgL_bodyz00_14704 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_withzd2handlerzd2_bglt)COBJECT(
((BgL_ev_withzd2handlerzd2_bglt)BgL_ez00_12413)))->BgL_bodyz00), BgL_stkz00_12414); 
{ /* Eval/evaluate_comp.scm 546 */
obj_t BgL_zc3z04anonymousza33044ze3z87_14705;
BgL_zc3z04anonymousza33044ze3z87_14705 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33044ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33044ze3z87_14705, 
(int)(((long)0)), BgL_handlerz00_14703); 
PROCEDURE_SET(BgL_zc3z04anonymousza33044ze3z87_14705, 
(int)(((long)1)), BgL_bodyz00_14704); 
return BgL_zc3z04anonymousza33044ze3z87_14705;} } } 

}



/* &<@anonymous:3044> */
obj_t BGl_z62zc3z04anonymousza33044ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12415, obj_t BgL_sz00_12418)
{
{ /* Eval/evaluate_comp.scm 546 */
{ /* Eval/evaluate_comp.scm 546 */
obj_t BgL_handlerz00_12416;obj_t BgL_bodyz00_12417;
BgL_handlerz00_12416 = 
PROCEDURE_REF(BgL_envz00_12415, 
(int)(((long)0))); 
BgL_bodyz00_12417 = 
PROCEDURE_REF(BgL_envz00_12415, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 546 */
obj_t BgL_bpz00_14706;
BgL_bpz00_14706 = 
VECTOR_REF(
((obj_t)BgL_sz00_12418),((long)0)); 
{ /* Eval/evaluate_comp.scm 547 */
obj_t BgL_hz00_14707;
BgL_hz00_14707 = 
PROCEDURE_ENTRY(BgL_handlerz00_12416)(BgL_handlerz00_12416, BgL_sz00_12418, BEOA); 
{ /* Eval/evaluate_comp.scm 549 */
obj_t BgL_za2za2resza2za2z00_14708;
{ /* Eval/evaluate_comp.scm 549 */
obj_t BgL_res1129z00_14709;
BgL_res1129z00_14709 = 
MAKE_CELL(BUNSPEC); 
if(
CBOOL(
BGl_zc3z04exitza33051ze3ze70z60zz__evaluate_compz00(BgL_sz00_12418, BgL_bodyz00_12417, BgL_res1129z00_14709)))
{ /* Eval/evaluate_comp.scm 549 */
BgL_za2za2resza2za2z00_14708 = 
PROCEDURE_ENTRY(BgL_hz00_14707)(BgL_hz00_14707, 
CELL_REF(BgL_res1129z00_14709), BEOA); }  else 
{ /* Eval/evaluate_comp.scm 549 */
BgL_za2za2resza2za2z00_14708 = 
CELL_REF(BgL_res1129z00_14709); } } 
VECTOR_SET(
((obj_t)BgL_sz00_12418),((long)0),BgL_bpz00_14706); 
return BgL_za2za2resza2za2z00_14708;} } } } } 

}



/* <@exit:3051>~0 */
obj_t BGl_zc3z04exitza33051ze3ze70z60zz__evaluate_compz00(obj_t BgL_sz00_12606, obj_t BgL_bodyz00_12605, obj_t BgL_res1129z00_12604)
{
{ /* Eval/evaluate_comp.scm 549 */
jmp_buf_t jmpbuf; 
void * BgL_an_exit1135z00_4216;
if( SET_EXIT(BgL_an_exit1135z00_4216) ) { 
return 
BGL_EXIT_VALUE();
} else {
#if( SIGSETJMP_SAVESIGS == 0 )
  bgl_restore_signal_handlers();
#endif

BgL_an_exit1135z00_4216 = 
(void *)jmpbuf; 
{ /* Eval/evaluate_comp.scm 549 */

PUSH_EXIT(BgL_an_exit1135z00_4216, ((long)1)); 
{ /* Eval/evaluate_comp.scm 549 */
obj_t BgL_an_exitd1136z00_4217;
BgL_an_exitd1136z00_4217 = 
((obj_t)(&exitd)); 
{ /* Eval/evaluate_comp.scm 549 */
bool_t BgL_res1138z00_4220;
{ /* Eval/evaluate_comp.scm 549 */
obj_t BgL_ohs1127z00_4221;
BgL_ohs1127z00_4221 = 
BGL_ERROR_HANDLER_GET(); 
{ /* Eval/evaluate_comp.scm 549 */
obj_t BgL_exitd1132z00_4222;
BgL_exitd1132z00_4222 = 
((obj_t)(&exitd)); 
{ 
obj_t BgL_zc3z04anonymousza33055ze3z87_11386;
BgL_zc3z04anonymousza33055ze3z87_11386 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33055ze3ze5zz__evaluate_compz00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33055ze3z87_11386, 
(int)(((long)0)), BgL_ohs1127z00_4221); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1132z00_4222, BgL_zc3z04anonymousza33055ze3z87_11386); 
{ /* Eval/evaluate_comp.scm 549 */
bool_t BgL_tmp1134z00_4224;
{ /* Eval/evaluate_comp.scm 549 */
obj_t BgL_arg3052z00_4225;
{ /* Eval/evaluate_comp.scm 549 */
obj_t BgL_zc3z04anonymousza33054ze3z87_11385;
BgL_zc3z04anonymousza33054ze3z87_11385 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33054ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33054ze3z87_11385, 
(int)(((long)0)), 
((obj_t)BgL_res1129z00_12604)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33054ze3z87_11385, 
(int)(((long)1)), BgL_an_exitd1136z00_4217); 
BgL_arg3052z00_4225 = 
MAKE_YOUNG_PAIR(BgL_zc3z04anonymousza33054ze3z87_11385, BgL_ohs1127z00_4221); } 
BGL_ERROR_HANDLER_SET(BgL_arg3052z00_4225); BUNSPEC; } 
{ /* Eval/evaluate_comp.scm 549 */
obj_t BgL_auxz00_12420;
BgL_auxz00_12420 = 
PROCEDURE_ENTRY(BgL_bodyz00_12605)(BgL_bodyz00_12605, BgL_sz00_12606, BEOA); 
CELL_SET(BgL_res1129z00_12604, BgL_auxz00_12420); } 
BgL_tmp1134z00_4224 = ((bool_t)0); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1132z00_4222); 
BGl_z62zc3z04anonymousza33055ze3ze5zz__evaluate_compz00(BgL_zc3z04anonymousza33055ze3z87_11386); 
BgL_res1138z00_4220 = BgL_tmp1134z00_4224; } } } } 
POP_EXIT(); 
return 
BBOOL(BgL_res1138z00_4220);} } } 
} } 

}



/* &<@anonymous:3054> */
obj_t BGl_z62zc3z04anonymousza33054ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12422, obj_t BgL_ez00_12425)
{
{ /* Eval/evaluate_comp.scm 549 */
{ /* Eval/evaluate_comp.scm 549 */
obj_t BgL_res1129z00_12423;obj_t BgL_an_exitd1136z00_12424;
BgL_res1129z00_12423 = 
PROCEDURE_REF(BgL_envz00_12422, 
(int)(((long)0))); 
BgL_an_exitd1136z00_12424 = 
PROCEDURE_REF(BgL_envz00_12422, 
(int)(((long)1))); 
CELL_SET(BgL_res1129z00_12423, BgL_ez00_12425); 
return 
BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1136z00_12424, BTRUE);} } 

}



/* &<@anonymous:3055> */
obj_t BGl_z62zc3z04anonymousza33055ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12427)
{
{ /* Eval/evaluate_comp.scm 549 */
{ 
obj_t BgL_ohs1127z00_12428;
BgL_ohs1127z00_12428 = 
PROCEDURE_REF(BgL_envz00_12427, 
(int)(((long)0))); 
BGL_ERROR_HANDLER_SET(BgL_ohs1127z00_12428); 
return BUNSPEC;} } 

}



/* &comp-ev_unwind-prote1420 */
obj_t BGl_z62compzd2ev_unwindzd2prote1420z62zz__evaluate_compz00(obj_t BgL_envz00_12429, obj_t BgL_ez00_12430, obj_t BgL_stkz00_12431)
{
{ /* Eval/evaluate_comp.scm 534 */
{ /* Eval/evaluate_comp.scm 536 */
obj_t BgL_ez00_14711;obj_t BgL_bodyz00_14712;
BgL_ez00_14711 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_unwindzd2protectzd2_bglt)COBJECT(
((BgL_ev_unwindzd2protectzd2_bglt)BgL_ez00_12430)))->BgL_ez00), BgL_stkz00_12431); 
BgL_bodyz00_14712 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_unwindzd2protectzd2_bglt)COBJECT(
((BgL_ev_unwindzd2protectzd2_bglt)BgL_ez00_12430)))->BgL_bodyz00), BgL_stkz00_12431); 
{ /* Eval/evaluate_comp.scm 537 */
obj_t BgL_zc3z04anonymousza33040ze3z87_14713;
BgL_zc3z04anonymousza33040ze3z87_14713 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33040ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33040ze3z87_14713, 
(int)(((long)0)), BgL_bodyz00_14712); 
PROCEDURE_SET(BgL_zc3z04anonymousza33040ze3z87_14713, 
(int)(((long)1)), BgL_ez00_14711); 
return BgL_zc3z04anonymousza33040ze3z87_14713;} } } 

}



/* &<@anonymous:3040> */
obj_t BGl_z62zc3z04anonymousza33040ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12432, obj_t BgL_sz00_12435)
{
{ /* Eval/evaluate_comp.scm 537 */
{ /* Eval/evaluate_comp.scm 537 */
obj_t BgL_bodyz00_12433;obj_t BgL_ez00_12434;
BgL_bodyz00_12433 = 
PROCEDURE_REF(BgL_envz00_12432, 
(int)(((long)0))); 
BgL_ez00_12434 = 
PROCEDURE_REF(BgL_envz00_12432, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 537 */
obj_t BgL_bpz00_14714;
BgL_bpz00_14714 = 
VECTOR_REF(
((obj_t)BgL_sz00_12435),((long)0)); 
{ /* Eval/evaluate_comp.scm 539 */
obj_t BgL_exitd1123z00_14715;
BgL_exitd1123z00_14715 = 
BGL_EXITD_TOP_AS_OBJ(); 
{ /* Eval/evaluate_comp.scm 540 */
obj_t BgL_zc3z04anonymousza33041ze3z87_14716;
BgL_zc3z04anonymousza33041ze3z87_14716 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33041ze3ze5zz__evaluate_compz00, 
(int)(((long)0)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33041ze3z87_14716, 
(int)(((long)0)), BgL_sz00_12435); 
PROCEDURE_SET(BgL_zc3z04anonymousza33041ze3z87_14716, 
(int)(((long)1)), BgL_bpz00_14714); 
PROCEDURE_SET(BgL_zc3z04anonymousza33041ze3z87_14716, 
(int)(((long)2)), BgL_bodyz00_12433); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1123z00_14715, BgL_zc3z04anonymousza33041ze3z87_14716); 
{ /* Eval/evaluate_comp.scm 539 */
obj_t BgL_tmp1125z00_14717;
BgL_tmp1125z00_14717 = 
PROCEDURE_ENTRY(BgL_ez00_12434)(BgL_ez00_12434, BgL_sz00_12435, BEOA); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1123z00_14715); 
BGl_z62zc3z04anonymousza33041ze3ze5zz__evaluate_compz00(BgL_zc3z04anonymousza33041ze3z87_14716); 
return BgL_tmp1125z00_14717;} } } } } } 

}



/* &<@anonymous:3041> */
obj_t BGl_z62zc3z04anonymousza33041ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12436)
{
{ /* Eval/evaluate_comp.scm 539 */
{ /* Eval/evaluate_comp.scm 540 */
obj_t BgL_sz00_12437;obj_t BgL_savedzd2bpzd2_12438;obj_t BgL_bodyz00_12439;
BgL_sz00_12437 = 
PROCEDURE_REF(BgL_envz00_12436, 
(int)(((long)0))); 
BgL_savedzd2bpzd2_12438 = 
PROCEDURE_REF(BgL_envz00_12436, 
(int)(((long)1))); 
BgL_bodyz00_12439 = 
PROCEDURE_REF(BgL_envz00_12436, 
(int)(((long)2))); 
VECTOR_SET(
((obj_t)BgL_sz00_12437),((long)0),BgL_savedzd2bpzd2_12438); 
return 
PROCEDURE_ENTRY(BgL_bodyz00_12439)(BgL_bodyz00_12439, BgL_sz00_12437, BEOA);} } 

}



/* &comp-ev_bind-exit1418 */
obj_t BGl_z62compzd2ev_bindzd2exit1418z62zz__evaluate_compz00(obj_t BgL_envz00_12440, obj_t BgL_ez00_12441, obj_t BgL_stkz00_12442)
{
{ /* Eval/evaluate_comp.scm 523 */
{ /* Eval/evaluate_comp.scm 525 */
long BgL_siza7eza7_14719;obj_t BgL_nstkz00_14720;
BgL_siza7eza7_14719 = 
bgl_list_length(BgL_stkz00_12442); 
{ /* Eval/evaluate_comp.scm 525 */
obj_t BgL_arg3038z00_14721;
{ /* Eval/evaluate_comp.scm 525 */
BgL_ev_varz00_bglt BgL_arg3039z00_14722;
BgL_arg3039z00_14722 = 
(((BgL_ev_bindzd2exitzd2_bglt)COBJECT(
((BgL_ev_bindzd2exitzd2_bglt)BgL_ez00_12441)))->BgL_varz00); 
BgL_arg3038z00_14721 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg3039z00_14722), BNIL); } 
BgL_nstkz00_14720 = 
BGl_appendzd221010zd2zz__evaluate_compz00(BgL_stkz00_12442, BgL_arg3038z00_14721); } 
{ /* Eval/evaluate_comp.scm 526 */
obj_t BgL_bodyz00_14723;obj_t BgL_effzf3zf3_14724;
BgL_bodyz00_14723 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_bindzd2exitzd2_bglt)COBJECT(
((BgL_ev_bindzd2exitzd2_bglt)BgL_ez00_12441)))->BgL_bodyz00), BgL_nstkz00_14720); 
BgL_effzf3zf3_14724 = 
(((BgL_ev_varz00_bglt)COBJECT(
(((BgL_ev_bindzd2exitzd2_bglt)COBJECT(
((BgL_ev_bindzd2exitzd2_bglt)BgL_ez00_12441)))->BgL_varz00)))->BgL_effz00); 
{ /* Eval/evaluate_comp.scm 527 */
obj_t BgL_zc3z04anonymousza33033ze3z87_14725;
BgL_zc3z04anonymousza33033ze3z87_14725 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33033ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33033ze3z87_14725, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_14719)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33033ze3z87_14725, 
(int)(((long)1)), BgL_effzf3zf3_14724); 
PROCEDURE_SET(BgL_zc3z04anonymousza33033ze3z87_14725, 
(int)(((long)2)), BgL_bodyz00_14723); 
return BgL_zc3z04anonymousza33033ze3z87_14725;} } } } 

}



/* &<@anonymous:3033> */
obj_t BGl_z62zc3z04anonymousza33033ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12443, obj_t BgL_sz00_12447)
{
{ /* Eval/evaluate_comp.scm 527 */
{ /* Eval/evaluate_comp.scm 527 */
long BgL_siza7eza7_12444;obj_t BgL_effzf3zf3_12445;obj_t BgL_bodyz00_12446;
BgL_siza7eza7_12444 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12443, 
(int)(((long)0)))); 
BgL_effzf3zf3_12445 = 
PROCEDURE_REF(BgL_envz00_12443, 
(int)(((long)1))); 
BgL_bodyz00_12446 = 
PROCEDURE_REF(BgL_envz00_12443, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 527 */
obj_t BgL_bpz00_14726;
BgL_bpz00_14726 = 
VECTOR_REF(
((obj_t)BgL_sz00_12447),((long)0)); 
{ /* Eval/evaluate_comp.scm 529 */
obj_t BgL_za2za2resza2za2z00_14727;
BgL_za2za2resza2za2z00_14727 = 
BGl_zc3z04exitza33034ze3ze70z60zz__evaluate_compz00(BgL_bodyz00_12446, BgL_sz00_12447, BgL_effzf3zf3_12445, BgL_siza7eza7_12444, BgL_bpz00_14726); 
VECTOR_SET(
((obj_t)BgL_sz00_12447),((long)0),BgL_bpz00_14726); 
return BgL_za2za2resza2za2z00_14727;} } } } 

}



/* <@exit:3034>~0 */
obj_t BGl_zc3z04exitza33034ze3ze70z60zz__evaluate_compz00(obj_t BgL_bodyz00_12603, obj_t BgL_sz00_12602, obj_t BgL_effzf3zf3_12601, long BgL_siza7eza7_12600, obj_t BgL_bpz00_12599)
{
{ /* Eval/evaluate_comp.scm 529 */
jmp_buf_t jmpbuf; 
void * BgL_an_exit1118z00_4151;
if( SET_EXIT(BgL_an_exit1118z00_4151) ) { 
return 
BGL_EXIT_VALUE();
} else {
#if( SIGSETJMP_SAVESIGS == 0 )
  bgl_restore_signal_handlers();
#endif

BgL_an_exit1118z00_4151 = 
(void *)jmpbuf; 
{ /* Eval/evaluate_comp.scm 529 */

PUSH_EXIT(BgL_an_exit1118z00_4151, ((long)1)); 
{ /* Eval/evaluate_comp.scm 529 */
obj_t BgL_an_exitd1119z00_4152;
BgL_an_exitd1119z00_4152 = 
((obj_t)(&exitd)); 
{ /* Eval/evaluate_comp.scm 529 */
obj_t BgL_exitz00_11392;
BgL_exitz00_11392 = 
MAKE_FX_PROCEDURE(BGl_z62exitz62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_exitz00_11392, 
(int)(((long)0)), BgL_an_exitd1119z00_4152); 
{ /* Eval/evaluate_comp.scm 529 */
obj_t BgL_res1121z00_4155;
{ /* Eval/evaluate_comp.scm 530 */
long BgL_arg3035z00_4156;obj_t BgL_arg3036z00_4157;
BgL_arg3035z00_4156 = 
(
(long)CINT(BgL_bpz00_12599)+BgL_siza7eza7_12600); 
if(
CBOOL(BgL_effzf3zf3_12601))
{ /* Eval/evaluate_comp.scm 202 */
obj_t BgL_newz00_8888;
BgL_newz00_8888 = 
create_struct(BGl_symbol5218z00zz__evaluate_compz00, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 202 */
int BgL_tmpz00_28592;
BgL_tmpz00_28592 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_8888, BgL_tmpz00_28592, BgL_exitz00_11392); } 
BgL_arg3036z00_4157 = BgL_newz00_8888; }  else 
{ /* Eval/evaluate_comp.scm 530 */
BgL_arg3036z00_4157 = BgL_exitz00_11392; } 
VECTOR_SET(
((obj_t)BgL_sz00_12602),BgL_arg3035z00_4156,BgL_arg3036z00_4157); } 
BgL_res1121z00_4155 = 
PROCEDURE_ENTRY(BgL_bodyz00_12603)(BgL_bodyz00_12603, BgL_sz00_12602, BEOA); 
POP_EXIT(); 
return BgL_res1121z00_4155;} } } } 
} } 

}



/* &exit */
obj_t BGl_z62exitz62zz__evaluate_compz00(obj_t BgL_envz00_12448, obj_t BgL_val1120z00_12450)
{
{ /* Eval/evaluate_comp.scm 529 */
return 
BGl_unwindzd2untilz12zc0zz__bexitz00(
PROCEDURE_REF(BgL_envz00_12448, 
(int)(((long)0))), BgL_val1120z00_12450);} 

}



/* &comp-ev_letrec1416 */
obj_t BGl_z62compzd2ev_letrec1416zb0zz__evaluate_compz00(obj_t BgL_envz00_12451, obj_t BgL_ez00_12452, obj_t BgL_stkz00_12453)
{
{ /* Eval/evaluate_comp.scm 494 */
{ /* Eval/evaluate_comp.scm 496 */
long BgL_siza7eza7_14729;obj_t BgL_nstkz00_14730;
BgL_siza7eza7_14729 = 
bgl_list_length(BgL_stkz00_12453); 
{ /* Eval/evaluate_comp.scm 496 */
obj_t BgL_arg3032z00_14731;
BgL_arg3032z00_14731 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letrecz00_bglt)BgL_ez00_12452))))->BgL_varsz00); 
BgL_nstkz00_14730 = 
BGl_appendzd221010zd2zz__evaluate_compz00(BgL_stkz00_12453, BgL_arg3032z00_14731); } 
{ /* Eval/evaluate_comp.scm 497 */
obj_t BgL_cvalsz00_14732;obj_t BgL_bodyz00_14733;
{ /* Eval/evaluate_comp.scm 497 */
obj_t BgL_l1315z00_14734;
BgL_l1315z00_14734 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letrecz00_bglt)BgL_ez00_12452))))->BgL_valsz00); 
if(
NULLP(BgL_l1315z00_14734))
{ /* Eval/evaluate_comp.scm 497 */
BgL_cvalsz00_14732 = BNIL; }  else 
{ /* Eval/evaluate_comp.scm 497 */
obj_t BgL_head1317z00_14735;
{ /* Eval/evaluate_comp.scm 497 */
obj_t BgL_res4703z00_14736;
BgL_res4703z00_14736 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1317z00_14735 = BgL_res4703z00_14736; } 
{ 
obj_t BgL_l1315z00_14738;obj_t BgL_tail1318z00_14739;
BgL_l1315z00_14738 = BgL_l1315z00_14734; 
BgL_tail1318z00_14739 = BgL_head1317z00_14735; 
BgL_zc3z04anonymousza33027ze3z87_14737:
if(
NULLP(BgL_l1315z00_14738))
{ /* Eval/evaluate_comp.scm 497 */
BgL_cvalsz00_14732 = 
CDR(BgL_head1317z00_14735); }  else 
{ /* Eval/evaluate_comp.scm 497 */
obj_t BgL_newtail1319z00_14740;
{ /* Eval/evaluate_comp.scm 497 */
obj_t BgL_arg3030z00_14741;
{ /* Eval/evaluate_comp.scm 497 */
obj_t BgL_vz00_14742;
BgL_vz00_14742 = 
CAR(
((obj_t)BgL_l1315z00_14738)); 
BgL_arg3030z00_14741 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_vz00_14742), BgL_nstkz00_14730); } 
{ /* Eval/evaluate_comp.scm 497 */
obj_t BgL_res4705z00_14743;
BgL_res4705z00_14743 = 
MAKE_YOUNG_PAIR(BgL_arg3030z00_14741, BNIL); 
BgL_newtail1319z00_14740 = BgL_res4705z00_14743; } } 
SET_CDR(BgL_tail1318z00_14739, BgL_newtail1319z00_14740); 
{ /* Eval/evaluate_comp.scm 497 */
obj_t BgL_arg3029z00_14744;
BgL_arg3029z00_14744 = 
CDR(
((obj_t)BgL_l1315z00_14738)); 
{ 
obj_t BgL_tail1318z00_28628;obj_t BgL_l1315z00_28627;
BgL_l1315z00_28627 = BgL_arg3029z00_14744; 
BgL_tail1318z00_28628 = BgL_newtail1319z00_14740; 
BgL_tail1318z00_14739 = BgL_tail1318z00_28628; 
BgL_l1315z00_14738 = BgL_l1315z00_28627; 
goto BgL_zc3z04anonymousza33027ze3z87_14737;} } } } } } 
{ /* Eval/evaluate_comp.scm 498 */
BgL_ev_exprz00_bglt BgL_arg3031z00_14745;
BgL_arg3031z00_14745 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letrecz00_bglt)BgL_ez00_12452))))->BgL_bodyz00); 
BgL_bodyz00_14733 = 
BGl_compz00zz__evaluate_compz00(BgL_arg3031z00_14745, BgL_nstkz00_14730); } 
{ /* Eval/evaluate_comp.scm 499 */
bool_t BgL_test5968z00_28633;
{ 
obj_t BgL_l1320z00_14747;
BgL_l1320z00_14747 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letrecz00_bglt)BgL_ez00_12452))))->BgL_valsz00); 
BgL_zc3z04anonymousza33024ze3z87_14746:
if(
NULLP(BgL_l1320z00_14747))
{ /* Eval/evaluate_comp.scm 499 */
BgL_test5968z00_28633 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate_comp.scm 499 */
bool_t BgL_test5970z00_28636;
{ /* Eval/evaluate_comp.scm 499 */
obj_t BgL_vz00_14748;
BgL_vz00_14748 = 
CAR(
((obj_t)BgL_l1320z00_14747)); 
BgL_test5970z00_28636 = 
BGl_isazf3zf3zz__objectz00(BgL_vz00_14748, BGl_ev_absz00zz__evaluate_typesz00); } 
if(BgL_test5970z00_28636)
{ 
obj_t BgL_l1320z00_28640;
BgL_l1320z00_28640 = 
CDR(
((obj_t)BgL_l1320z00_14747)); 
BgL_l1320z00_14747 = BgL_l1320z00_28640; 
goto BgL_zc3z04anonymousza33024ze3z87_14746;}  else 
{ /* Eval/evaluate_comp.scm 499 */
BgL_test5968z00_28633 = ((bool_t)0)
; } } } 
if(BgL_test5968z00_28633)
{ /* Eval/evaluate_comp.scm 500 */
obj_t BgL_zc3z04anonymousza32994ze3z87_14749;
BgL_zc3z04anonymousza32994ze3z87_14749 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32994ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32994ze3z87_14749, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_14729)); 
PROCEDURE_SET(BgL_zc3z04anonymousza32994ze3z87_14749, 
(int)(((long)1)), BgL_cvalsz00_14732); 
PROCEDURE_SET(BgL_zc3z04anonymousza32994ze3z87_14749, 
(int)(((long)2)), BgL_bodyz00_14733); 
return BgL_zc3z04anonymousza32994ze3z87_14749;}  else 
{ /* Eval/evaluate_comp.scm 510 */
obj_t BgL_zc3z04anonymousza33007ze3z87_14750;
BgL_zc3z04anonymousza33007ze3z87_14750 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33007ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33007ze3z87_14750, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_14729)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33007ze3z87_14750, 
(int)(((long)1)), BgL_cvalsz00_14732); 
PROCEDURE_SET(BgL_zc3z04anonymousza33007ze3z87_14750, 
(int)(((long)2)), BgL_bodyz00_14733); 
return BgL_zc3z04anonymousza33007ze3z87_14750;} } } } } 

}



/* &<@anonymous:2994> */
obj_t BGl_z62zc3z04anonymousza32994ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12454, obj_t BgL_sz00_12458)
{
{ /* Eval/evaluate_comp.scm 500 */
{ /* Eval/evaluate_comp.scm 500 */
long BgL_siza7eza7_12455;obj_t BgL_cvalsz00_12456;obj_t BgL_bodyz00_12457;
BgL_siza7eza7_12455 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12454, 
(int)(((long)0)))); 
BgL_cvalsz00_12456 = 
PROCEDURE_REF(BgL_envz00_12454, 
(int)(((long)1))); 
BgL_bodyz00_12457 = 
PROCEDURE_REF(BgL_envz00_12454, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 500 */
obj_t BgL_bpz00_14751;
BgL_bpz00_14751 = 
VECTOR_REF(
((obj_t)BgL_sz00_12458),((long)0)); 
{ /* Eval/evaluate_comp.scm 501 */
long BgL_g1112z00_14752;
BgL_g1112z00_14752 = 
(
(long)CINT(BgL_bpz00_14751)+BgL_siza7eza7_12455); 
{ 
obj_t BgL_lz00_14754;long BgL_iz00_14755;
BgL_lz00_14754 = BgL_cvalsz00_12456; 
BgL_iz00_14755 = BgL_g1112z00_14752; 
BgL_recz00_14753:
if(
NULLP(BgL_lz00_14754))
{ /* Eval/evaluate_comp.scm 502 */((bool_t)0); }  else 
{ /* Eval/evaluate_comp.scm 502 */
{ /* Eval/evaluate_comp.scm 503 */
obj_t BgL_arg2997z00_14756;
{ /* Eval/evaluate_comp.scm 202 */
obj_t BgL_newz00_14757;
BgL_newz00_14757 = 
create_struct(BGl_symbol5218z00zz__evaluate_compz00, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 202 */
int BgL_tmpz00_28681;
BgL_tmpz00_28681 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14757, BgL_tmpz00_28681, BUNSPEC); } 
BgL_arg2997z00_14756 = BgL_newz00_14757; } 
VECTOR_SET(
((obj_t)BgL_sz00_12458),BgL_iz00_14755,BgL_arg2997z00_14756); } 
{ /* Eval/evaluate_comp.scm 504 */
obj_t BgL_arg2998z00_14758;long BgL_arg2999z00_14759;
BgL_arg2998z00_14758 = 
CDR(
((obj_t)BgL_lz00_14754)); 
BgL_arg2999z00_14759 = 
(BgL_iz00_14755+((long)1)); 
{ 
long BgL_iz00_28690;obj_t BgL_lz00_28689;
BgL_lz00_28689 = BgL_arg2998z00_14758; 
BgL_iz00_28690 = BgL_arg2999z00_14759; 
BgL_iz00_14755 = BgL_iz00_28690; 
BgL_lz00_14754 = BgL_lz00_28689; 
goto BgL_recz00_14753;} } } } } 
{ /* Eval/evaluate_comp.scm 505 */
long BgL_g1113z00_14760;
BgL_g1113z00_14760 = 
(
(long)CINT(BgL_bpz00_14751)+BgL_siza7eza7_12455); 
{ 
obj_t BgL_lz00_14762;long BgL_iz00_14763;
BgL_lz00_14762 = BgL_cvalsz00_12456; 
BgL_iz00_14763 = BgL_g1113z00_14760; 
BgL_recz00_14761:
if(
NULLP(BgL_lz00_14762))
{ /* Eval/evaluate_comp.scm 506 */((bool_t)0); }  else 
{ /* Eval/evaluate_comp.scm 506 */
{ /* Eval/evaluate_comp.scm 507 */
obj_t BgL_arg3002z00_14764;obj_t BgL_arg3003z00_14765;
BgL_arg3002z00_14764 = 
VECTOR_REF(
((obj_t)BgL_sz00_12458),BgL_iz00_14763); 
{ /* Eval/evaluate_comp.scm 507 */
obj_t BgL_fun3004z00_14766;
BgL_fun3004z00_14766 = 
CAR(
((obj_t)BgL_lz00_14762)); 
BgL_arg3003z00_14765 = 
PROCEDURE_ENTRY(BgL_fun3004z00_14766)(BgL_fun3004z00_14766, BgL_sz00_12458, BEOA); } 
{ /* Eval/evaluate_comp.scm 202 */
int BgL_auxz00_28705;obj_t BgL_tmpz00_28703;
BgL_auxz00_28705 = 
(int)(((long)0)); 
BgL_tmpz00_28703 = 
((obj_t)BgL_arg3002z00_14764); 
STRUCT_SET(BgL_tmpz00_28703, BgL_auxz00_28705, BgL_arg3003z00_14765); } } 
{ /* Eval/evaluate_comp.scm 508 */
obj_t BgL_arg3005z00_14767;long BgL_arg3006z00_14768;
BgL_arg3005z00_14767 = 
CDR(
((obj_t)BgL_lz00_14762)); 
BgL_arg3006z00_14768 = 
(BgL_iz00_14763+((long)1)); 
{ 
long BgL_iz00_28712;obj_t BgL_lz00_28711;
BgL_lz00_28711 = BgL_arg3005z00_14767; 
BgL_iz00_28712 = BgL_arg3006z00_14768; 
BgL_iz00_14763 = BgL_iz00_28712; 
BgL_lz00_14762 = BgL_lz00_28711; 
goto BgL_recz00_14761;} } } } } 
return 
PROCEDURE_ENTRY(BgL_bodyz00_12457)(BgL_bodyz00_12457, BgL_sz00_12458, BEOA);} } } 

}



/* &<@anonymous:3007> */
obj_t BGl_z62zc3z04anonymousza33007ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12459, obj_t BgL_sz00_12463)
{
{ /* Eval/evaluate_comp.scm 510 */
{ /* Eval/evaluate_comp.scm 510 */
long BgL_siza7eza7_12460;obj_t BgL_cvalsz00_12461;obj_t BgL_bodyz00_12462;
BgL_siza7eza7_12460 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12459, 
(int)(((long)0)))); 
BgL_cvalsz00_12461 = 
PROCEDURE_REF(BgL_envz00_12459, 
(int)(((long)1))); 
BgL_bodyz00_12462 = 
PROCEDURE_REF(BgL_envz00_12459, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 510 */
obj_t BgL_bpz00_14769;
BgL_bpz00_14769 = 
VECTOR_REF(
((obj_t)BgL_sz00_12463),((long)0)); 
{ /* Eval/evaluate_comp.scm 511 */
long BgL_g1114z00_14770;
BgL_g1114z00_14770 = 
(
(long)CINT(BgL_bpz00_14769)+BgL_siza7eza7_12460); 
{ 
obj_t BgL_lz00_14772;long BgL_iz00_14773;
BgL_lz00_14772 = BgL_cvalsz00_12461; 
BgL_iz00_14773 = BgL_g1114z00_14770; 
BgL_recz00_14771:
if(
NULLP(BgL_lz00_14772))
{ /* Eval/evaluate_comp.scm 512 */((bool_t)0); }  else 
{ /* Eval/evaluate_comp.scm 512 */
{ /* Eval/evaluate_comp.scm 513 */
obj_t BgL_arg3010z00_14774;
{ /* Eval/evaluate_comp.scm 202 */
obj_t BgL_newz00_14775;
BgL_newz00_14775 = 
create_struct(BGl_symbol5218z00zz__evaluate_compz00, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 202 */
int BgL_tmpz00_28732;
BgL_tmpz00_28732 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14775, BgL_tmpz00_28732, BUNSPEC); } 
BgL_arg3010z00_14774 = BgL_newz00_14775; } 
VECTOR_SET(
((obj_t)BgL_sz00_12463),BgL_iz00_14773,BgL_arg3010z00_14774); } 
{ /* Eval/evaluate_comp.scm 514 */
obj_t BgL_arg3011z00_14776;long BgL_arg3012z00_14777;
BgL_arg3011z00_14776 = 
CDR(
((obj_t)BgL_lz00_14772)); 
BgL_arg3012z00_14777 = 
(BgL_iz00_14773+((long)1)); 
{ 
long BgL_iz00_28741;obj_t BgL_lz00_28740;
BgL_lz00_28740 = BgL_arg3011z00_14776; 
BgL_iz00_28741 = BgL_arg3012z00_14777; 
BgL_iz00_14773 = BgL_iz00_28741; 
BgL_lz00_14772 = BgL_lz00_28740; 
goto BgL_recz00_14771;} } } } } 
{ /* Eval/evaluate_comp.scm 515 */
obj_t BgL_rvalsz00_14778;
if(
NULLP(BgL_cvalsz00_12461))
{ /* Eval/evaluate_comp.scm 515 */
BgL_rvalsz00_14778 = BNIL; }  else 
{ /* Eval/evaluate_comp.scm 515 */
obj_t BgL_head1326z00_14779;
{ /* Eval/evaluate_comp.scm 515 */
obj_t BgL_res4717z00_14780;
BgL_res4717z00_14780 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1326z00_14779 = BgL_res4717z00_14780; } 
{ 
obj_t BgL_l1324z00_14782;obj_t BgL_tail1327z00_14783;
BgL_l1324z00_14782 = BgL_cvalsz00_12461; 
BgL_tail1327z00_14783 = BgL_head1326z00_14779; 
BgL_zc3z04anonymousza33020ze3z87_14781:
if(
NULLP(BgL_l1324z00_14782))
{ /* Eval/evaluate_comp.scm 515 */
BgL_rvalsz00_14778 = 
CDR(BgL_head1326z00_14779); }  else 
{ /* Eval/evaluate_comp.scm 515 */
obj_t BgL_newtail1328z00_14784;
{ /* Eval/evaluate_comp.scm 515 */
obj_t BgL_arg3023z00_14785;
{ /* Eval/evaluate_comp.scm 515 */
obj_t BgL_vz00_14786;
BgL_vz00_14786 = 
CAR(
((obj_t)BgL_l1324z00_14782)); 
BgL_arg3023z00_14785 = 
PROCEDURE_ENTRY(BgL_vz00_14786)(BgL_vz00_14786, BgL_sz00_12463, BEOA); } 
{ /* Eval/evaluate_comp.scm 515 */
obj_t BgL_res4719z00_14787;
BgL_res4719z00_14787 = 
MAKE_YOUNG_PAIR(BgL_arg3023z00_14785, BNIL); 
BgL_newtail1328z00_14784 = BgL_res4719z00_14787; } } 
SET_CDR(BgL_tail1327z00_14783, BgL_newtail1328z00_14784); 
{ /* Eval/evaluate_comp.scm 515 */
obj_t BgL_arg3022z00_14788;
BgL_arg3022z00_14788 = 
CDR(
((obj_t)BgL_l1324z00_14782)); 
{ 
obj_t BgL_tail1327z00_28759;obj_t BgL_l1324z00_28758;
BgL_l1324z00_28758 = BgL_arg3022z00_14788; 
BgL_tail1327z00_28759 = BgL_newtail1328z00_14784; 
BgL_tail1327z00_14783 = BgL_tail1327z00_28759; 
BgL_l1324z00_14782 = BgL_l1324z00_28758; 
goto BgL_zc3z04anonymousza33020ze3z87_14781;} } } } } 
{ /* Eval/evaluate_comp.scm 516 */
long BgL_g1115z00_14789;
BgL_g1115z00_14789 = 
(
(long)CINT(BgL_bpz00_14769)+BgL_siza7eza7_12460); 
{ 
obj_t BgL_lz00_14791;long BgL_iz00_14792;
BgL_lz00_14791 = BgL_rvalsz00_14778; 
BgL_iz00_14792 = BgL_g1115z00_14789; 
BgL_recz00_14790:
if(
NULLP(BgL_lz00_14791))
{ /* Eval/evaluate_comp.scm 517 */((bool_t)0); }  else 
{ /* Eval/evaluate_comp.scm 517 */
{ /* Eval/evaluate_comp.scm 518 */
obj_t BgL_arg3015z00_14793;obj_t BgL_arg3016z00_14794;
BgL_arg3015z00_14793 = 
VECTOR_REF(
((obj_t)BgL_sz00_12463),BgL_iz00_14792); 
BgL_arg3016z00_14794 = 
CAR(
((obj_t)BgL_lz00_14791)); 
{ /* Eval/evaluate_comp.scm 202 */
int BgL_auxz00_28770;obj_t BgL_tmpz00_28768;
BgL_auxz00_28770 = 
(int)(((long)0)); 
BgL_tmpz00_28768 = 
((obj_t)BgL_arg3015z00_14793); 
STRUCT_SET(BgL_tmpz00_28768, BgL_auxz00_28770, BgL_arg3016z00_14794); } } 
{ /* Eval/evaluate_comp.scm 519 */
obj_t BgL_arg3017z00_14795;long BgL_arg3018z00_14796;
BgL_arg3017z00_14795 = 
CDR(
((obj_t)BgL_lz00_14791)); 
BgL_arg3018z00_14796 = 
(BgL_iz00_14792+((long)1)); 
{ 
long BgL_iz00_28777;obj_t BgL_lz00_28776;
BgL_lz00_28776 = BgL_arg3017z00_14795; 
BgL_iz00_28777 = BgL_arg3018z00_14796; 
BgL_iz00_14792 = BgL_iz00_28777; 
BgL_lz00_14791 = BgL_lz00_28776; 
goto BgL_recz00_14790;} } } } } 
return 
PROCEDURE_ENTRY(BgL_bodyz00_12462)(BgL_bodyz00_12462, BgL_sz00_12463, BEOA);} } } } 

}



/* &comp-ev_let*1414 */
obj_t BGl_z62compzd2ev_letza21414z12zz__evaluate_compz00(obj_t BgL_envz00_12464, obj_t BgL_ez00_12465, obj_t BgL_stkz00_12466)
{
{ /* Eval/evaluate_comp.scm 481 */
{ /* Eval/evaluate_comp.scm 483 */
long BgL_siza7eza7_14798;obj_t BgL_nstkz00_14799;
BgL_siza7eza7_14798 = 
bgl_list_length(BgL_stkz00_12466); 
{ /* Eval/evaluate_comp.scm 483 */
obj_t BgL_arg2989z00_14800;
BgL_arg2989z00_14800 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letza2za2_bglt)BgL_ez00_12465))))->BgL_varsz00); 
BgL_nstkz00_14799 = 
BGl_appendzd221010zd2zz__evaluate_compz00(BgL_stkz00_12466, BgL_arg2989z00_14800); } 
{ /* Eval/evaluate_comp.scm 484 */
obj_t BgL_valsz00_14801;obj_t BgL_bodyz00_14802;
{ /* Eval/evaluate_comp.scm 484 */
obj_t BgL_l1310z00_14803;
BgL_l1310z00_14803 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letza2za2_bglt)BgL_ez00_12465))))->BgL_valsz00); 
if(
NULLP(BgL_l1310z00_14803))
{ /* Eval/evaluate_comp.scm 484 */
BgL_valsz00_14801 = BNIL; }  else 
{ /* Eval/evaluate_comp.scm 484 */
obj_t BgL_head1312z00_14804;
{ /* Eval/evaluate_comp.scm 484 */
obj_t BgL_res4696z00_14805;
BgL_res4696z00_14805 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1312z00_14804 = BgL_res4696z00_14805; } 
{ 
obj_t BgL_l1310z00_14807;obj_t BgL_tail1313z00_14808;
BgL_l1310z00_14807 = BgL_l1310z00_14803; 
BgL_tail1313z00_14808 = BgL_head1312z00_14804; 
BgL_zc3z04anonymousza32984ze3z87_14806:
if(
NULLP(BgL_l1310z00_14807))
{ /* Eval/evaluate_comp.scm 484 */
BgL_valsz00_14801 = 
CDR(BgL_head1312z00_14804); }  else 
{ /* Eval/evaluate_comp.scm 484 */
obj_t BgL_newtail1314z00_14809;
{ /* Eval/evaluate_comp.scm 484 */
obj_t BgL_arg2987z00_14810;
{ /* Eval/evaluate_comp.scm 484 */
obj_t BgL_vz00_14811;
BgL_vz00_14811 = 
CAR(
((obj_t)BgL_l1310z00_14807)); 
BgL_arg2987z00_14810 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_vz00_14811), BgL_nstkz00_14799); } 
{ /* Eval/evaluate_comp.scm 484 */
obj_t BgL_res4698z00_14812;
BgL_res4698z00_14812 = 
MAKE_YOUNG_PAIR(BgL_arg2987z00_14810, BNIL); 
BgL_newtail1314z00_14809 = BgL_res4698z00_14812; } } 
SET_CDR(BgL_tail1313z00_14808, BgL_newtail1314z00_14809); 
{ /* Eval/evaluate_comp.scm 484 */
obj_t BgL_arg2986z00_14813;
BgL_arg2986z00_14813 = 
CDR(
((obj_t)BgL_l1310z00_14807)); 
{ 
obj_t BgL_tail1313z00_28805;obj_t BgL_l1310z00_28804;
BgL_l1310z00_28804 = BgL_arg2986z00_14813; 
BgL_tail1313z00_28805 = BgL_newtail1314z00_14809; 
BgL_tail1313z00_14808 = BgL_tail1313z00_28805; 
BgL_l1310z00_14807 = BgL_l1310z00_28804; 
goto BgL_zc3z04anonymousza32984ze3z87_14806;} } } } } } 
{ /* Eval/evaluate_comp.scm 485 */
BgL_ev_exprz00_bglt BgL_arg2988z00_14814;
BgL_arg2988z00_14814 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letza2za2_bglt)BgL_ez00_12465))))->BgL_bodyz00); 
BgL_bodyz00_14802 = 
BGl_compz00zz__evaluate_compz00(BgL_arg2988z00_14814, BgL_nstkz00_14799); } 
{ /* Eval/evaluate_comp.scm 486 */
obj_t BgL_zc3z04anonymousza32973ze3z87_14815;
BgL_zc3z04anonymousza32973ze3z87_14815 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32973ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32973ze3z87_14815, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_14798)); 
PROCEDURE_SET(BgL_zc3z04anonymousza32973ze3z87_14815, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_letza2za2_bglt)BgL_ez00_12465))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32973ze3z87_14815, 
(int)(((long)2)), BgL_valsz00_14801); 
PROCEDURE_SET(BgL_zc3z04anonymousza32973ze3z87_14815, 
(int)(((long)3)), BgL_bodyz00_14802); 
return BgL_zc3z04anonymousza32973ze3z87_14815;} } } } 

}



/* &<@anonymous:2973> */
obj_t BGl_z62zc3z04anonymousza32973ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12467, obj_t BgL_sz00_12472)
{
{ /* Eval/evaluate_comp.scm 486 */
{ /* Eval/evaluate_comp.scm 486 */
long BgL_siza7eza7_12468;BgL_ev_letza2za2_bglt BgL_i1109z00_12469;obj_t BgL_valsz00_12470;obj_t BgL_bodyz00_12471;
BgL_siza7eza7_12468 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12467, 
(int)(((long)0)))); 
BgL_i1109z00_12469 = 
((BgL_ev_letza2za2_bglt)
PROCEDURE_REF(BgL_envz00_12467, 
(int)(((long)1)))); 
BgL_valsz00_12470 = 
PROCEDURE_REF(BgL_envz00_12467, 
(int)(((long)2))); 
BgL_bodyz00_12471 = 
PROCEDURE_REF(BgL_envz00_12467, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 486 */
obj_t BgL_bpz00_14816;
BgL_bpz00_14816 = 
VECTOR_REF(
((obj_t)BgL_sz00_12472),((long)0)); 
{ /* Eval/evaluate_comp.scm 487 */
long BgL_g1110z00_14817;
BgL_g1110z00_14817 = 
(
(long)CINT(BgL_bpz00_14816)+BgL_siza7eza7_12468); 
{ 
obj_t BgL_lz00_14819;long BgL_iz00_14820;obj_t BgL_bza2za2_14821;
BgL_lz00_14819 = BgL_valsz00_12470; 
BgL_iz00_14820 = BgL_g1110z00_14817; 
BgL_bza2za2_14821 = 
(((BgL_ev_letza2za2_bglt)COBJECT(BgL_i1109z00_12469))->BgL_boxesz00); 
BgL_recz00_14818:
if(
NULLP(BgL_lz00_14819))
{ /* Eval/evaluate_comp.scm 488 */((bool_t)0); }  else 
{ /* Eval/evaluate_comp.scm 488 */
{ /* Eval/evaluate_comp.scm 489 */
obj_t BgL_valz00_14822;
{ /* Eval/evaluate_comp.scm 489 */
obj_t BgL_fun2979z00_14823;
BgL_fun2979z00_14823 = 
CAR(
((obj_t)BgL_lz00_14819)); 
BgL_valz00_14822 = 
PROCEDURE_ENTRY(BgL_fun2979z00_14823)(BgL_fun2979z00_14823, BgL_sz00_12472, BEOA); } 
{ /* Eval/evaluate_comp.scm 490 */
obj_t BgL_arg2977z00_14824;
if(
CBOOL(
CAR(
((obj_t)BgL_bza2za2_14821))))
{ /* Eval/evaluate_comp.scm 202 */
obj_t BgL_newz00_14825;
BgL_newz00_14825 = 
create_struct(BGl_symbol5218z00zz__evaluate_compz00, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 202 */
int BgL_tmpz00_28852;
BgL_tmpz00_28852 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14825, BgL_tmpz00_28852, BgL_valz00_14822); } 
BgL_arg2977z00_14824 = BgL_newz00_14825; }  else 
{ /* Eval/evaluate_comp.scm 490 */
BgL_arg2977z00_14824 = BgL_valz00_14822; } 
VECTOR_SET(
((obj_t)BgL_sz00_12472),BgL_iz00_14820,BgL_arg2977z00_14824); } } 
{ /* Eval/evaluate_comp.scm 491 */
obj_t BgL_arg2980z00_14826;long BgL_arg2981z00_14827;obj_t BgL_arg2982z00_14828;
BgL_arg2980z00_14826 = 
CDR(
((obj_t)BgL_lz00_14819)); 
BgL_arg2981z00_14827 = 
(BgL_iz00_14820+((long)1)); 
BgL_arg2982z00_14828 = 
CDR(
((obj_t)BgL_bza2za2_14821)); 
{ 
obj_t BgL_bza2za2_28864;long BgL_iz00_28863;obj_t BgL_lz00_28862;
BgL_lz00_28862 = BgL_arg2980z00_14826; 
BgL_iz00_28863 = BgL_arg2981z00_14827; 
BgL_bza2za2_28864 = BgL_arg2982z00_14828; 
BgL_bza2za2_14821 = BgL_bza2za2_28864; 
BgL_iz00_14820 = BgL_iz00_28863; 
BgL_lz00_14819 = BgL_lz00_28862; 
goto BgL_recz00_14818;} } } } } 
return 
PROCEDURE_ENTRY(BgL_bodyz00_12471)(BgL_bodyz00_12471, BgL_sz00_12472, BEOA);} } } 

}



/* &comp-ev_let1412 */
obj_t BGl_z62compzd2ev_let1412zb0zz__evaluate_compz00(obj_t BgL_envz00_12473, obj_t BgL_ez00_12474, obj_t BgL_stkz00_12475)
{
{ /* Eval/evaluate_comp.scm 462 */
{ /* Eval/evaluate_comp.scm 464 */
long BgL_siza7eza7_14830;obj_t BgL_nstkz00_14831;
BgL_siza7eza7_14830 = 
bgl_list_length(BgL_stkz00_12475); 
{ /* Eval/evaluate_comp.scm 464 */
obj_t BgL_arg2972z00_14832;
BgL_arg2972z00_14832 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letz00_bglt)BgL_ez00_12474))))->BgL_varsz00); 
BgL_nstkz00_14831 = 
BGl_appendzd221010zd2zz__evaluate_compz00(BgL_stkz00_12475, BgL_arg2972z00_14832); } 
{ /* Eval/evaluate_comp.scm 465 */
obj_t BgL_valsz00_14833;obj_t BgL_iboxesz00_14834;obj_t BgL_bodyz00_14835;
{ /* Eval/evaluate_comp.scm 466 */
obj_t BgL_arg2965z00_14836;
BgL_arg2965z00_14836 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letz00_bglt)BgL_ez00_12474))))->BgL_valsz00); 
BgL_valsz00_14833 = 
BGl_compzd2withzd2pushz00zz__evaluate_compz00(BgL_arg2965z00_14836, BgL_stkz00_12475); } 
{ /* Eval/evaluate_comp.scm 467 */
obj_t BgL_l1305z00_14837;
BgL_l1305z00_14837 = 
(((BgL_ev_letz00_bglt)COBJECT(
((BgL_ev_letz00_bglt)BgL_ez00_12474)))->BgL_boxesz00); 
if(
NULLP(BgL_l1305z00_14837))
{ /* Eval/evaluate_comp.scm 467 */
BgL_iboxesz00_14834 = BNIL; }  else 
{ /* Eval/evaluate_comp.scm 467 */
obj_t BgL_head1307z00_14838;
{ /* Eval/evaluate_comp.scm 467 */
obj_t BgL_res4687z00_14839;
BgL_res4687z00_14839 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1307z00_14838 = BgL_res4687z00_14839; } 
{ 
obj_t BgL_l1305z00_14841;obj_t BgL_tail1308z00_14842;
BgL_l1305z00_14841 = BgL_l1305z00_14837; 
BgL_tail1308z00_14842 = BgL_head1307z00_14838; 
BgL_zc3z04anonymousza32967ze3z87_14840:
if(
NULLP(BgL_l1305z00_14841))
{ /* Eval/evaluate_comp.scm 467 */
BgL_iboxesz00_14834 = 
CDR(BgL_head1307z00_14838); }  else 
{ /* Eval/evaluate_comp.scm 467 */
obj_t BgL_newtail1309z00_14843;
{ /* Eval/evaluate_comp.scm 467 */
obj_t BgL_arg2970z00_14844;
{ /* Eval/evaluate_comp.scm 467 */
obj_t BgL_vz00_14845;
BgL_vz00_14845 = 
CAR(
((obj_t)BgL_l1305z00_14841)); 
BgL_arg2970z00_14844 = 
BGl__indexz00zz__evaluate_compz00(BgL_vz00_14845, BgL_nstkz00_14831); } 
{ /* Eval/evaluate_comp.scm 467 */
obj_t BgL_res4689z00_14846;
BgL_res4689z00_14846 = 
MAKE_YOUNG_PAIR(BgL_arg2970z00_14844, BNIL); 
BgL_newtail1309z00_14843 = BgL_res4689z00_14846; } } 
SET_CDR(BgL_tail1308z00_14842, BgL_newtail1309z00_14843); 
{ /* Eval/evaluate_comp.scm 467 */
obj_t BgL_arg2969z00_14847;
BgL_arg2969z00_14847 = 
CDR(
((obj_t)BgL_l1305z00_14841)); 
{ 
obj_t BgL_tail1308z00_28895;obj_t BgL_l1305z00_28894;
BgL_l1305z00_28894 = BgL_arg2969z00_14847; 
BgL_tail1308z00_28895 = BgL_newtail1309z00_14843; 
BgL_tail1308z00_14842 = BgL_tail1308z00_28895; 
BgL_l1305z00_14841 = BgL_l1305z00_28894; 
goto BgL_zc3z04anonymousza32967ze3z87_14840;} } } } } } 
{ /* Eval/evaluate_comp.scm 468 */
BgL_ev_exprz00_bglt BgL_arg2971z00_14848;
BgL_arg2971z00_14848 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letz00_bglt)BgL_ez00_12474))))->BgL_bodyz00); 
BgL_bodyz00_14835 = 
BGl_compz00zz__evaluate_compz00(BgL_arg2971z00_14848, BgL_nstkz00_14831); } 
{ /* Eval/evaluate_comp.scm 469 */
obj_t BgL_zc3z04anonymousza32952ze3z87_14849;
BgL_zc3z04anonymousza32952ze3z87_14849 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32952ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32952ze3z87_14849, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_14830)); 
PROCEDURE_SET(BgL_zc3z04anonymousza32952ze3z87_14849, 
(int)(((long)1)), BgL_valsz00_14833); 
PROCEDURE_SET(BgL_zc3z04anonymousza32952ze3z87_14849, 
(int)(((long)2)), BgL_iboxesz00_14834); 
PROCEDURE_SET(BgL_zc3z04anonymousza32952ze3z87_14849, 
(int)(((long)3)), BgL_bodyz00_14835); 
return BgL_zc3z04anonymousza32952ze3z87_14849;} } } } 

}



/* &<@anonymous:2952> */
obj_t BGl_z62zc3z04anonymousza32952ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12476, obj_t BgL_sz00_12481)
{
{ /* Eval/evaluate_comp.scm 469 */
{ /* Eval/evaluate_comp.scm 469 */
long BgL_siza7eza7_12477;obj_t BgL_valsz00_12478;obj_t BgL_iboxesz00_12479;obj_t BgL_bodyz00_12480;
BgL_siza7eza7_12477 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12476, 
(int)(((long)0)))); 
BgL_valsz00_12478 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12476, 
(int)(((long)1)))); 
BgL_iboxesz00_12479 = 
PROCEDURE_REF(BgL_envz00_12476, 
(int)(((long)2))); 
BgL_bodyz00_12480 = 
PROCEDURE_REF(BgL_envz00_12476, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 469 */
obj_t BgL_bpz00_14850;
BgL_bpz00_14850 = 
VECTOR_REF(
((obj_t)BgL_sz00_12481),((long)0)); 
{ /* Eval/evaluate_comp.scm 470 */
long BgL_g1108z00_14851;
BgL_g1108z00_14851 = 
(
(long)CINT(BgL_bpz00_14850)+BgL_siza7eza7_12477); 
{ 
obj_t BgL_lz00_14853;long BgL_iz00_14854;
BgL_lz00_14853 = BgL_valsz00_12478; 
BgL_iz00_14854 = BgL_g1108z00_14851; 
BgL_recz00_14852:
if(
NULLP(BgL_lz00_14853))
{ /* Eval/evaluate_comp.scm 471 */((bool_t)0); }  else 
{ /* Eval/evaluate_comp.scm 471 */
{ /* Eval/evaluate_comp.scm 472 */
obj_t BgL_arg2955z00_14855;
{ /* Eval/evaluate_comp.scm 472 */
obj_t BgL_fun2956z00_14856;
BgL_fun2956z00_14856 = 
CAR(
((obj_t)BgL_lz00_14853)); 
BgL_arg2955z00_14855 = 
PROCEDURE_ENTRY(BgL_fun2956z00_14856)(BgL_fun2956z00_14856, BgL_sz00_12481, BEOA); } 
VECTOR_SET(
((obj_t)BgL_sz00_12481),BgL_iz00_14854,BgL_arg2955z00_14855); } 
{ /* Eval/evaluate_comp.scm 473 */
obj_t BgL_arg2957z00_14857;long BgL_arg2958z00_14858;
BgL_arg2957z00_14857 = 
CDR(
((obj_t)BgL_lz00_14853)); 
BgL_arg2958z00_14858 = 
(BgL_iz00_14854+((long)1)); 
{ 
long BgL_iz00_28940;obj_t BgL_lz00_28939;
BgL_lz00_28939 = BgL_arg2957z00_14857; 
BgL_iz00_28940 = BgL_arg2958z00_14858; 
BgL_iz00_14854 = BgL_iz00_28940; 
BgL_lz00_14853 = BgL_lz00_28939; 
goto BgL_recz00_14852;} } } } } 
{ 
obj_t BgL_lz00_14860;
BgL_lz00_14860 = BgL_iboxesz00_12479; 
BgL_recz00_14859:
if(
NULLP(BgL_lz00_14860))
{ /* Eval/evaluate_comp.scm 475 */((bool_t)0); }  else 
{ /* Eval/evaluate_comp.scm 475 */
{ /* Eval/evaluate_comp.scm 476 */
long BgL_iz00_14861;
BgL_iz00_14861 = 
(
(long)CINT(BgL_bpz00_14850)+
(long)CINT(
CAR(
((obj_t)BgL_lz00_14860)))); 
{ /* Eval/evaluate_comp.scm 477 */
obj_t BgL_arg2961z00_14862;
{ /* Eval/evaluate_comp.scm 477 */
obj_t BgL_arg2962z00_14863;
BgL_arg2962z00_14863 = 
VECTOR_REF(
((obj_t)BgL_sz00_12481),BgL_iz00_14861); 
{ /* Eval/evaluate_comp.scm 202 */
obj_t BgL_newz00_14864;
BgL_newz00_14864 = 
create_struct(BGl_symbol5218z00zz__evaluate_compz00, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 202 */
int BgL_tmpz00_28952;
BgL_tmpz00_28952 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14864, BgL_tmpz00_28952, BgL_arg2962z00_14863); } 
BgL_arg2961z00_14862 = BgL_newz00_14864; } } 
VECTOR_SET(
((obj_t)BgL_sz00_12481),BgL_iz00_14861,BgL_arg2961z00_14862); } } 
{ /* Eval/evaluate_comp.scm 478 */
obj_t BgL_arg2964z00_14865;
BgL_arg2964z00_14865 = 
CDR(
((obj_t)BgL_lz00_14860)); 
{ 
obj_t BgL_lz00_28959;
BgL_lz00_28959 = BgL_arg2964z00_14865; 
BgL_lz00_14860 = BgL_lz00_28959; 
goto BgL_recz00_14859;} } } } 
return 
PROCEDURE_ENTRY(BgL_bodyz00_12480)(BgL_bodyz00_12480, BgL_sz00_12481, BEOA);} } } 

}



/* &comp-ev_prog21410 */
obj_t BGl_z62compzd2ev_prog21410zb0zz__evaluate_compz00(obj_t BgL_envz00_12482, obj_t BgL_ez00_12483, obj_t BgL_stkz00_12484)
{
{ /* Eval/evaluate_comp.scm 456 */
{ /* Eval/evaluate_comp.scm 458 */
obj_t BgL_e1z00_14867;obj_t BgL_e2z00_14868;
BgL_e1z00_14867 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_prog2z00_bglt)COBJECT(
((BgL_ev_prog2z00_bglt)BgL_ez00_12483)))->BgL_e1z00), BgL_stkz00_12484); 
BgL_e2z00_14868 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_prog2z00_bglt)COBJECT(
((BgL_ev_prog2z00_bglt)BgL_ez00_12483)))->BgL_e2z00), BgL_stkz00_12484); 
{ /* Eval/evaluate_comp.scm 459 */
obj_t BgL_zc3z04anonymousza32949ze3z87_14869;
BgL_zc3z04anonymousza32949ze3z87_14869 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32949ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32949ze3z87_14869, 
(int)(((long)0)), BgL_e1z00_14867); 
PROCEDURE_SET(BgL_zc3z04anonymousza32949ze3z87_14869, 
(int)(((long)1)), BgL_e2z00_14868); 
return BgL_zc3z04anonymousza32949ze3z87_14869;} } } 

}



/* &<@anonymous:2949> */
obj_t BGl_z62zc3z04anonymousza32949ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12485, obj_t BgL_sz00_12488)
{
{ /* Eval/evaluate_comp.scm 459 */
{ /* Eval/evaluate_comp.scm 459 */
obj_t BgL_e1z00_12486;obj_t BgL_e2z00_12487;
BgL_e1z00_12486 = 
PROCEDURE_REF(BgL_envz00_12485, 
(int)(((long)0))); 
BgL_e2z00_12487 = 
PROCEDURE_REF(BgL_envz00_12485, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 459 */
obj_t BgL_bpz00_14870;
BgL_bpz00_14870 = 
VECTOR_REF(
((obj_t)BgL_sz00_12488),((long)0)); 
PROCEDURE_ENTRY(BgL_e1z00_12486)(BgL_e1z00_12486, BgL_sz00_12488, BEOA); 
return 
PROCEDURE_ENTRY(BgL_e2z00_12487)(BgL_e2z00_12487, BgL_sz00_12488, BEOA);} } } 

}



/* &comp-ev_and1407 */
obj_t BGl_z62compzd2ev_and1407zb0zz__evaluate_compz00(obj_t BgL_envz00_12489, obj_t BgL_ez00_12490, obj_t BgL_stkz00_12491)
{
{ /* Eval/evaluate_comp.scm 446 */
{ /* Eval/evaluate_comp.scm 448 */
obj_t BgL_argsz00_14872;
{ /* Eval/evaluate_comp.scm 448 */
obj_t BgL_l1300z00_14873;
BgL_l1300z00_14873 = 
(((BgL_ev_listz00_bglt)COBJECT(
((BgL_ev_listz00_bglt)
((BgL_ev_andz00_bglt)BgL_ez00_12490))))->BgL_argsz00); 
if(
NULLP(BgL_l1300z00_14873))
{ /* Eval/evaluate_comp.scm 448 */
BgL_argsz00_14872 = BNIL; }  else 
{ /* Eval/evaluate_comp.scm 448 */
obj_t BgL_head1302z00_14874;
{ /* Eval/evaluate_comp.scm 448 */
obj_t BgL_res4682z00_14875;
BgL_res4682z00_14875 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1302z00_14874 = BgL_res4682z00_14875; } 
{ 
obj_t BgL_l1300z00_14877;obj_t BgL_tail1303z00_14878;
BgL_l1300z00_14877 = BgL_l1300z00_14873; 
BgL_tail1303z00_14878 = BgL_head1302z00_14874; 
BgL_zc3z04anonymousza32945ze3z87_14876:
if(
NULLP(BgL_l1300z00_14877))
{ /* Eval/evaluate_comp.scm 448 */
BgL_argsz00_14872 = 
CDR(BgL_head1302z00_14874); }  else 
{ /* Eval/evaluate_comp.scm 448 */
obj_t BgL_newtail1304z00_14879;
{ /* Eval/evaluate_comp.scm 448 */
obj_t BgL_arg2948z00_14880;
{ /* Eval/evaluate_comp.scm 448 */
obj_t BgL_ez00_14881;
BgL_ez00_14881 = 
CAR(
((obj_t)BgL_l1300z00_14877)); 
BgL_arg2948z00_14880 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_ez00_14881), BgL_stkz00_12491); } 
{ /* Eval/evaluate_comp.scm 448 */
obj_t BgL_res4684z00_14882;
BgL_res4684z00_14882 = 
MAKE_YOUNG_PAIR(BgL_arg2948z00_14880, BNIL); 
BgL_newtail1304z00_14879 = BgL_res4684z00_14882; } } 
SET_CDR(BgL_tail1303z00_14878, BgL_newtail1304z00_14879); 
{ /* Eval/evaluate_comp.scm 448 */
obj_t BgL_arg2947z00_14883;
BgL_arg2947z00_14883 = 
CDR(
((obj_t)BgL_l1300z00_14877)); 
{ 
obj_t BgL_tail1303z00_29009;obj_t BgL_l1300z00_29008;
BgL_l1300z00_29008 = BgL_arg2947z00_14883; 
BgL_tail1303z00_29009 = BgL_newtail1304z00_14879; 
BgL_tail1303z00_14878 = BgL_tail1303z00_29009; 
BgL_l1300z00_14877 = BgL_l1300z00_29008; 
goto BgL_zc3z04anonymousza32945ze3z87_14876;} } } } } } 
{ /* Eval/evaluate_comp.scm 449 */
obj_t BgL_zc3z04anonymousza32939ze3z87_14884;
BgL_zc3z04anonymousza32939ze3z87_14884 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32939ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32939ze3z87_14884, 
(int)(((long)0)), BgL_argsz00_14872); 
return BgL_zc3z04anonymousza32939ze3z87_14884;} } } 

}



/* &<@anonymous:2939> */
obj_t BGl_z62zc3z04anonymousza32939ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12492, obj_t BgL_sz00_12494)
{
{ /* Eval/evaluate_comp.scm 449 */
{ /* Eval/evaluate_comp.scm 449 */
obj_t BgL_argsz00_12493;
BgL_argsz00_12493 = 
PROCEDURE_REF(BgL_envz00_12492, 
(int)(((long)0))); 
{ /* Eval/evaluate_comp.scm 449 */
obj_t BgL_bpz00_14885;
BgL_bpz00_14885 = 
VECTOR_REF(
((obj_t)BgL_sz00_12494),((long)0)); 
{ 
obj_t BgL_lz00_14887;obj_t BgL_rz00_14888;
BgL_lz00_14887 = BgL_argsz00_12493; 
BgL_rz00_14888 = BTRUE; 
BgL_recz00_14886:
if(
NULLP(BgL_lz00_14887))
{ /* Eval/evaluate_comp.scm 451 */
return BgL_rz00_14888;}  else 
{ /* Eval/evaluate_comp.scm 453 */
obj_t BgL_vz00_14889;
{ /* Eval/evaluate_comp.scm 453 */
obj_t BgL_fun2943z00_14890;
BgL_fun2943z00_14890 = 
CAR(
((obj_t)BgL_lz00_14887)); 
BgL_vz00_14889 = 
PROCEDURE_ENTRY(BgL_fun2943z00_14890)(BgL_fun2943z00_14890, BgL_sz00_12494, BEOA); } 
if(
CBOOL(BgL_vz00_14889))
{ /* Eval/evaluate_comp.scm 454 */
obj_t BgL_arg2942z00_14891;
BgL_arg2942z00_14891 = 
CDR(
((obj_t)BgL_lz00_14887)); 
{ 
obj_t BgL_rz00_29032;obj_t BgL_lz00_29031;
BgL_lz00_29031 = BgL_arg2942z00_14891; 
BgL_rz00_29032 = BgL_vz00_14889; 
BgL_rz00_14888 = BgL_rz00_29032; 
BgL_lz00_14887 = BgL_lz00_29031; 
goto BgL_recz00_14886;} }  else 
{ /* Eval/evaluate_comp.scm 454 */
return BFALSE;} } } } } } 

}



/* &comp-ev_or1405 */
obj_t BGl_z62compzd2ev_or1405zb0zz__evaluate_compz00(obj_t BgL_envz00_12495, obj_t BgL_ez00_12496, obj_t BgL_stkz00_12497)
{
{ /* Eval/evaluate_comp.scm 437 */
{ /* Eval/evaluate_comp.scm 439 */
obj_t BgL_argsz00_14893;
{ /* Eval/evaluate_comp.scm 439 */
obj_t BgL_l1295z00_14894;
BgL_l1295z00_14894 = 
(((BgL_ev_listz00_bglt)COBJECT(
((BgL_ev_listz00_bglt)
((BgL_ev_orz00_bglt)BgL_ez00_12496))))->BgL_argsz00); 
if(
NULLP(BgL_l1295z00_14894))
{ /* Eval/evaluate_comp.scm 439 */
BgL_argsz00_14893 = BNIL; }  else 
{ /* Eval/evaluate_comp.scm 439 */
obj_t BgL_head1297z00_14895;
{ /* Eval/evaluate_comp.scm 439 */
obj_t BgL_res4677z00_14896;
BgL_res4677z00_14896 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1297z00_14895 = BgL_res4677z00_14896; } 
{ 
obj_t BgL_l1295z00_14898;obj_t BgL_tail1298z00_14899;
BgL_l1295z00_14898 = BgL_l1295z00_14894; 
BgL_tail1298z00_14899 = BgL_head1297z00_14895; 
BgL_zc3z04anonymousza32935ze3z87_14897:
if(
NULLP(BgL_l1295z00_14898))
{ /* Eval/evaluate_comp.scm 439 */
BgL_argsz00_14893 = 
CDR(BgL_head1297z00_14895); }  else 
{ /* Eval/evaluate_comp.scm 439 */
obj_t BgL_newtail1299z00_14900;
{ /* Eval/evaluate_comp.scm 439 */
obj_t BgL_arg2938z00_14901;
{ /* Eval/evaluate_comp.scm 439 */
obj_t BgL_ez00_14902;
BgL_ez00_14902 = 
CAR(
((obj_t)BgL_l1295z00_14898)); 
BgL_arg2938z00_14901 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_ez00_14902), BgL_stkz00_12497); } 
{ /* Eval/evaluate_comp.scm 439 */
obj_t BgL_res4679z00_14903;
BgL_res4679z00_14903 = 
MAKE_YOUNG_PAIR(BgL_arg2938z00_14901, BNIL); 
BgL_newtail1299z00_14900 = BgL_res4679z00_14903; } } 
SET_CDR(BgL_tail1298z00_14899, BgL_newtail1299z00_14900); 
{ /* Eval/evaluate_comp.scm 439 */
obj_t BgL_arg2937z00_14904;
BgL_arg2937z00_14904 = 
CDR(
((obj_t)BgL_l1295z00_14898)); 
{ 
obj_t BgL_tail1298z00_29051;obj_t BgL_l1295z00_29050;
BgL_l1295z00_29050 = BgL_arg2937z00_14904; 
BgL_tail1298z00_29051 = BgL_newtail1299z00_14900; 
BgL_tail1298z00_14899 = BgL_tail1298z00_29051; 
BgL_l1295z00_14898 = BgL_l1295z00_29050; 
goto BgL_zc3z04anonymousza32935ze3z87_14897;} } } } } } 
{ /* Eval/evaluate_comp.scm 440 */
obj_t BgL_zc3z04anonymousza32929ze3z87_14905;
BgL_zc3z04anonymousza32929ze3z87_14905 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32929ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32929ze3z87_14905, 
(int)(((long)0)), BgL_argsz00_14893); 
return BgL_zc3z04anonymousza32929ze3z87_14905;} } } 

}



/* &<@anonymous:2929> */
obj_t BGl_z62zc3z04anonymousza32929ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12498, obj_t BgL_sz00_12500)
{
{ /* Eval/evaluate_comp.scm 440 */
{ /* Eval/evaluate_comp.scm 440 */
obj_t BgL_argsz00_12499;
BgL_argsz00_12499 = 
PROCEDURE_REF(BgL_envz00_12498, 
(int)(((long)0))); 
{ /* Eval/evaluate_comp.scm 440 */
obj_t BgL_bpz00_14906;
BgL_bpz00_14906 = 
VECTOR_REF(
((obj_t)BgL_sz00_12500),((long)0)); 
{ 
obj_t BgL_lz00_14908;
BgL_lz00_14908 = BgL_argsz00_12499; 
BgL_recz00_14907:
if(
NULLP(BgL_lz00_14908))
{ /* Eval/evaluate_comp.scm 442 */
return BFALSE;}  else 
{ /* Eval/evaluate_comp.scm 444 */
obj_t BgL__ortest_1103z00_14909;
{ /* Eval/evaluate_comp.scm 444 */
obj_t BgL_fun2933z00_14910;
BgL_fun2933z00_14910 = 
CAR(
((obj_t)BgL_lz00_14908)); 
BgL__ortest_1103z00_14909 = 
PROCEDURE_ENTRY(BgL_fun2933z00_14910)(BgL_fun2933z00_14910, BgL_sz00_12500, BEOA); } 
if(
CBOOL(BgL__ortest_1103z00_14909))
{ /* Eval/evaluate_comp.scm 444 */
return BgL__ortest_1103z00_14909;}  else 
{ /* Eval/evaluate_comp.scm 444 */
obj_t BgL_arg2932z00_14911;
BgL_arg2932z00_14911 = 
CDR(
((obj_t)BgL_lz00_14908)); 
{ 
obj_t BgL_lz00_29073;
BgL_lz00_29073 = BgL_arg2932z00_14911; 
BgL_lz00_14908 = BgL_lz00_29073; 
goto BgL_recz00_14907;} } } } } } } 

}



/* &comp-ev_if1403 */
obj_t BGl_z62compzd2ev_if1403zb0zz__evaluate_compz00(obj_t BgL_envz00_12501, obj_t BgL_ez00_12502, obj_t BgL_stkz00_12503)
{
{ /* Eval/evaluate_comp.scm 431 */
{ /* Eval/evaluate_comp.scm 433 */
obj_t BgL_pz00_14913;obj_t BgL_tz00_14914;obj_t BgL_ez00_14915;
BgL_pz00_14913 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_ez00_12502)))->BgL_pz00), BgL_stkz00_12503); 
BgL_tz00_14914 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_ez00_12502)))->BgL_tz00), BgL_stkz00_12503); 
BgL_ez00_14915 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_ez00_12502)))->BgL_ez00), BgL_stkz00_12503); 
{ /* Eval/evaluate_comp.scm 434 */
obj_t BgL_zc3z04anonymousza32924ze3z87_14916;
BgL_zc3z04anonymousza32924ze3z87_14916 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32924ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32924ze3z87_14916, 
(int)(((long)0)), BgL_ez00_14915); 
PROCEDURE_SET(BgL_zc3z04anonymousza32924ze3z87_14916, 
(int)(((long)1)), BgL_tz00_14914); 
PROCEDURE_SET(BgL_zc3z04anonymousza32924ze3z87_14916, 
(int)(((long)2)), BgL_pz00_14913); 
return BgL_zc3z04anonymousza32924ze3z87_14916;} } } 

}



/* &<@anonymous:2924> */
obj_t BGl_z62zc3z04anonymousza32924ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12504, obj_t BgL_sz00_12508)
{
{ /* Eval/evaluate_comp.scm 434 */
{ /* Eval/evaluate_comp.scm 434 */
obj_t BgL_ez00_12505;obj_t BgL_tz00_12506;obj_t BgL_pz00_12507;
BgL_ez00_12505 = 
PROCEDURE_REF(BgL_envz00_12504, 
(int)(((long)0))); 
BgL_tz00_12506 = 
PROCEDURE_REF(BgL_envz00_12504, 
(int)(((long)1))); 
BgL_pz00_12507 = 
PROCEDURE_REF(BgL_envz00_12504, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 434 */
obj_t BgL_bpz00_14917;
BgL_bpz00_14917 = 
VECTOR_REF(
((obj_t)BgL_sz00_12508),((long)0)); 
if(
CBOOL(
PROCEDURE_ENTRY(BgL_pz00_12507)(BgL_pz00_12507, BgL_sz00_12508, BEOA)))
{ /* Eval/evaluate_comp.scm 435 */
return 
PROCEDURE_ENTRY(BgL_tz00_12506)(BgL_tz00_12506, BgL_sz00_12508, BEOA);}  else 
{ /* Eval/evaluate_comp.scm 435 */
return 
PROCEDURE_ENTRY(BgL_ez00_12505)(BgL_ez00_12505, BgL_sz00_12508, BEOA);} } } } 

}



/* &comp-ev_litt1401 */
obj_t BGl_z62compzd2ev_litt1401zb0zz__evaluate_compz00(obj_t BgL_envz00_12509, obj_t BgL_ez00_12510, obj_t BgL_stkz00_12511)
{
{ /* Eval/evaluate_comp.scm 426 */
{ /* Eval/evaluate_comp.scm 428 */
obj_t BgL_zc3z04anonymousza32923ze3z87_14919;
BgL_zc3z04anonymousza32923ze3z87_14919 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32923ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32923ze3z87_14919, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_littz00_bglt)BgL_ez00_12510))); 
return BgL_zc3z04anonymousza32923ze3z87_14919;} } 

}



/* &<@anonymous:2923> */
obj_t BGl_z62zc3z04anonymousza32923ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12512, obj_t BgL_sz00_12514)
{
{ /* Eval/evaluate_comp.scm 428 */
{ /* Eval/evaluate_comp.scm 428 */
BgL_ev_littz00_bglt BgL_i1100z00_12513;
BgL_i1100z00_12513 = 
((BgL_ev_littz00_bglt)
PROCEDURE_REF(BgL_envz00_12512, 
(int)(((long)0)))); 
{ /* Eval/evaluate_comp.scm 428 */
obj_t BgL_bpz00_14920;
BgL_bpz00_14920 = 
VECTOR_REF(
((obj_t)BgL_sz00_12514),((long)0)); 
return 
(((BgL_ev_littz00_bglt)COBJECT(BgL_i1100z00_12513))->BgL_valuez00);} } } 

}



/* &comp-ev_defglobal1399 */
obj_t BGl_z62compzd2ev_defglobal1399zb0zz__evaluate_compz00(obj_t BgL_envz00_12515, obj_t BgL_ez00_12516, obj_t BgL_stkz00_12517)
{
{ /* Eval/evaluate_comp.scm 395 */
{ /* Eval/evaluate_comp.scm 397 */
obj_t BgL_ez00_14922;
{ /* Eval/evaluate_comp.scm 397 */
BgL_ev_exprz00_bglt BgL_arg2922z00_14923;
BgL_arg2922z00_14923 = 
(((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)
((BgL_ev_defglobalz00_bglt)BgL_ez00_12516))))->BgL_ez00); 
BgL_ez00_14922 = 
BGl_compz00zz__evaluate_compz00(BgL_arg2922z00_14923, BgL_stkz00_12517); } 
{ /* Eval/evaluate_comp.scm 398 */
obj_t BgL_zc3z04anonymousza32897ze3z87_14924;
BgL_zc3z04anonymousza32897ze3z87_14924 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32897ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32897ze3z87_14924, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_defglobalz00_bglt)BgL_ez00_12516))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32897ze3z87_14924, 
(int)(((long)1)), BgL_ez00_14922); 
return BgL_zc3z04anonymousza32897ze3z87_14924;} } } 

}



/* &<@anonymous:2897> */
obj_t BGl_z62zc3z04anonymousza32897ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12518, obj_t BgL_sz00_12521)
{
{ /* Eval/evaluate_comp.scm 398 */
{ /* Eval/evaluate_comp.scm 398 */
BgL_ev_defglobalz00_bglt BgL_i1097z00_12519;obj_t BgL_ez00_12520;
BgL_i1097z00_12519 = 
((BgL_ev_defglobalz00_bglt)
PROCEDURE_REF(BgL_envz00_12518, 
(int)(((long)0)))); 
BgL_ez00_12520 = 
PROCEDURE_REF(BgL_envz00_12518, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 398 */
obj_t BgL_bpz00_14925;
BgL_bpz00_14925 = 
VECTOR_REF(
((obj_t)BgL_sz00_12521),((long)0)); 
{ /* Eval/evaluate_comp.scm 399 */
obj_t BgL_gz00_14926;
{ /* Eval/evaluate_comp.scm 399 */
obj_t BgL_arg2920z00_14927;obj_t BgL_arg2921z00_14928;
BgL_arg2920z00_14927 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1097z00_12519)))->BgL_modz00); 
BgL_arg2921z00_14928 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1097z00_12519)))->BgL_namez00); 
BgL_gz00_14926 = 
BGl_evmodulezd2findzd2globalz00zz__evmodulez00(BgL_arg2920z00_14927, BgL_arg2921z00_14928); } 
if(
CBOOL(BgL_gz00_14926))
{ /* Eval/evaluate_comp.scm 401 */
{ 

{ /* Eval/evaluate_comp.scm 403 */
int BgL_aux1099z00_14932;
{ /* Eval/evaluate_comp.scm 403 */
int BgL_res4675z00_14933;
BgL_res4675z00_14933 = 
CINT(
VECTOR_REF(
((obj_t)BgL_gz00_14926),((long)0))); 
BgL_aux1099z00_14932 = BgL_res4675z00_14933; } 
switch( 
(long)(BgL_aux1099z00_14932)) { case ((long)0) : 

{ /* Eval/evaluate_comp.scm 405 */
obj_t BgL_arg2899z00_14934;obj_t BgL_arg2900z00_14935;
BgL_arg2899z00_14934 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1097z00_12519)))->BgL_locz00); 
BgL_arg2900z00_14935 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1097z00_12519)))->BgL_namez00); 
BGl_everrorz00zz__everrorz00(BgL_arg2899z00_14934, BGl_string5329z00zz__evaluate_compz00, BGl_string5330z00zz__evaluate_compz00, BgL_arg2900z00_14935); } break;case ((long)1) : 

{ /* Eval/evaluate_comp.scm 407 */
obj_t BgL_arg2901z00_14936;obj_t BgL_arg2902z00_14937;
BgL_arg2901z00_14936 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1097z00_12519)))->BgL_locz00); 
BgL_arg2902z00_14937 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1097z00_12519)))->BgL_namez00); 
{ /* Eval/evaluate_comp.scm 407 */
obj_t BgL_list2903z00_14938;
{ /* Eval/evaluate_comp.scm 407 */
obj_t BgL_arg2904z00_14939;
{ /* Eval/evaluate_comp.scm 407 */
obj_t BgL_arg2905z00_14940;
BgL_arg2905z00_14940 = 
MAKE_YOUNG_PAIR(BgL_arg2902z00_14937, BNIL); 
BgL_arg2904z00_14939 = 
MAKE_YOUNG_PAIR(BGl_string5331z00zz__evaluate_compz00, BgL_arg2905z00_14940); } 
BgL_list2903z00_14938 = 
MAKE_YOUNG_PAIR(BGl_string5208z00zz__evaluate_compz00, BgL_arg2904z00_14939); } 
BGl_evwarningz00zz__everrorz00(BgL_arg2901z00_14936, BgL_list2903z00_14938); } } 
{ /* Eval/evaluate_comp.scm 409 */
obj_t BgL_arg2906z00_14941;obj_t BgL_arg2907z00_14942;
BgL_arg2906z00_14941 = 
VECTOR_REF(
((obj_t)BgL_gz00_14926),((long)2)); 
BgL_arg2907z00_14942 = 
PROCEDURE_ENTRY(BgL_ez00_12520)(BgL_ez00_12520, BgL_sz00_12521, BEOA); 
__EVMEANING_ADDRESS_SET(BgL_arg2906z00_14941, BgL_arg2907z00_14942); } break;case ((long)2) : 

{ /* Eval/evaluate_comp.scm 411 */
obj_t BgL_arg2908z00_14943;
BgL_arg2908z00_14943 = 
PROCEDURE_ENTRY(BgL_ez00_12520)(BgL_ez00_12520, BgL_sz00_12521, BEOA); 
VECTOR_SET(
((obj_t)BgL_gz00_14926),((long)2),BgL_arg2908z00_14943); } break;case ((long)3) : 

{ /* Eval/evaluate_comp.scm 413 */
obj_t BgL_arg2909z00_14944;
BgL_arg2909z00_14944 = 
PROCEDURE_ENTRY(BgL_ez00_12520)(BgL_ez00_12520, BgL_sz00_12521, BEOA); 
VECTOR_SET(
((obj_t)BgL_gz00_14926),((long)2),BgL_arg2909z00_14944); } 
VECTOR_SET(
((obj_t)BgL_gz00_14926),((long)0),
BINT(((long)2))); break;case ((long)4) : 

{ /* Eval/evaluate_comp.scm 416 */
obj_t BgL_arg2910z00_14945;
BgL_arg2910z00_14945 = 
PROCEDURE_ENTRY(BgL_ez00_12520)(BgL_ez00_12520, BgL_sz00_12521, BEOA); 
VECTOR_SET(
((obj_t)BgL_gz00_14926),((long)2),BgL_arg2910z00_14945); } 
VECTOR_SET(
((obj_t)BgL_gz00_14926),((long)0),
BINT(((long)5))); break;
default: 
{ /* Eval/evaluate_comp.scm 419 */
obj_t BgL_arg2911z00_14930;obj_t BgL_arg2912z00_14931;
BgL_arg2911z00_14930 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1097z00_12519)))->BgL_locz00); 
BgL_arg2912z00_14931 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1097z00_12519)))->BgL_namez00); 
BGl_everrorz00zz__everrorz00(BgL_arg2911z00_14930, BGl_string5329z00zz__evaluate_compz00, BGl_string5330z00zz__evaluate_compz00, BgL_arg2912z00_14931); } } } } 
return 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1097z00_12519)))->BgL_namez00);}  else 
{ /* Eval/evaluate_comp.scm 421 */
obj_t BgL_gz00_14946;
{ /* Eval/evaluate_comp.scm 421 */
obj_t BgL_arg2917z00_14947;obj_t BgL_arg2918z00_14948;obj_t BgL_arg2919z00_14949;
BgL_arg2917z00_14947 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1097z00_12519)))->BgL_namez00); 
BgL_arg2918z00_14948 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1097z00_12519)))->BgL_modz00); 
BgL_arg2919z00_14949 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1097z00_12519)))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 421 */
obj_t BgL_v1373z00_14950;
BgL_v1373z00_14950 = 
create_vector(((long)5)); 
VECTOR_SET(BgL_v1373z00_14950,((long)0),
BINT(((long)2))); 
VECTOR_SET(BgL_v1373z00_14950,((long)1),BgL_arg2917z00_14947); 
VECTOR_SET(BgL_v1373z00_14950,((long)2),BUNSPEC); 
VECTOR_SET(BgL_v1373z00_14950,((long)3),BgL_arg2918z00_14948); 
VECTOR_SET(BgL_v1373z00_14950,((long)4),BgL_arg2919z00_14949); 
BgL_gz00_14946 = BgL_v1373z00_14950; } } 
{ /* Eval/evaluate_comp.scm 422 */
obj_t BgL_arg2913z00_14951;
BgL_arg2913z00_14951 = 
PROCEDURE_ENTRY(BgL_ez00_12520)(BgL_ez00_12520, BgL_sz00_12521, BEOA); 
VECTOR_SET(BgL_gz00_14946,((long)2),BgL_arg2913z00_14951); } 
{ /* Eval/evaluate_comp.scm 423 */
obj_t BgL_arg2914z00_14952;obj_t BgL_arg2915z00_14953;obj_t BgL_arg2916z00_14954;
BgL_arg2914z00_14952 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1097z00_12519)))->BgL_modz00); 
BgL_arg2915z00_14953 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1097z00_12519)))->BgL_namez00); 
BgL_arg2916z00_14954 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1097z00_12519)))->BgL_locz00); 
BGl_evmodulezd2bindzd2globalz12z12zz__evmodulez00(BgL_arg2914z00_14952, BgL_arg2915z00_14953, BgL_gz00_14946, BgL_arg2916z00_14954); } 
return 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1097z00_12519)))->BgL_namez00);} } } } } 

}



/* &comp-ev_setglobal1397 */
obj_t BGl_z62compzd2ev_setglobal1397zb0zz__evaluate_compz00(obj_t BgL_envz00_12522, obj_t BgL_ez00_12523, obj_t BgL_stkz00_12524)
{
{ /* Eval/evaluate_comp.scm 372 */
{ /* Eval/evaluate_comp.scm 374 */
obj_t BgL_gz00_14956;obj_t BgL_ez00_14957;
BgL_gz00_14956 = 
BGl_evmodulezd2findzd2globalz00zz__evmodulez00(
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_ez00_12523)))->BgL_modz00), 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_ez00_12523)))->BgL_namez00)); 
{ /* Eval/evaluate_comp.scm 374 */
BgL_ev_exprz00_bglt BgL_arg2896z00_14958;
BgL_arg2896z00_14958 = 
(((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)
((BgL_ev_setglobalz00_bglt)BgL_ez00_12523))))->BgL_ez00); 
BgL_ez00_14957 = 
BGl_compz00zz__evaluate_compz00(BgL_arg2896z00_14958, BgL_stkz00_12524); } 
if(
CBOOL(BgL_gz00_14956))
{ 

{ /* Eval/evaluate_comp.scm 376 */
int BgL_aux1096z00_14961;
{ /* Eval/evaluate_comp.scm 376 */
int BgL_res4674z00_14962;
BgL_res4674z00_14962 = 
CINT(
VECTOR_REF(
((obj_t)BgL_gz00_14956),((long)0))); 
BgL_aux1096z00_14961 = BgL_res4674z00_14962; } 
switch( 
(long)(BgL_aux1096z00_14961)) { case ((long)1) : 

{ /* Eval/evaluate_comp.scm 378 */
obj_t BgL_zc3z04anonymousza32872ze3z87_14963;
BgL_zc3z04anonymousza32872ze3z87_14963 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32872ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32872ze3z87_14963, 
(int)(((long)0)), BgL_gz00_14956); 
PROCEDURE_SET(BgL_zc3z04anonymousza32872ze3z87_14963, 
(int)(((long)1)), BgL_ez00_14957); 
return BgL_zc3z04anonymousza32872ze3z87_14963;} break;case ((long)0) : 
case ((long)4) : 
case ((long)5) : 

return 
BGl_everrorz00zz__everrorz00(
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_ez00_12523)))->BgL_locz00), BGl_string5329z00zz__evaluate_compz00, BGl_string5330z00zz__evaluate_compz00, 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_ez00_12523)))->BgL_namez00));break;
default: 
{ /* Eval/evaluate_comp.scm 383 */
obj_t BgL_zc3z04anonymousza32877ze3z87_14960;
BgL_zc3z04anonymousza32877ze3z87_14960 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32877ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32877ze3z87_14960, 
(int)(((long)0)), BgL_ez00_14957); 
PROCEDURE_SET(BgL_zc3z04anonymousza32877ze3z87_14960, 
(int)(((long)1)), BgL_gz00_14956); 
return BgL_zc3z04anonymousza32877ze3z87_14960;} } } }  else 
{ /* Eval/evaluate_comp.scm 384 */
obj_t BgL_slotz00_14964;
BgL_slotz00_14964 = 
MAKE_CELL(BFALSE); 
if(
BGl_evmodulezf3zf3zz__evmodulez00(
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_ez00_12523)))->BgL_modz00)))
{ /* Eval/evaluate_comp.scm 386 */
obj_t BgL_gz00_14965;
{ /* Eval/evaluate_comp.scm 386 */
obj_t BgL_arg2884z00_14966;obj_t BgL_arg2885z00_14967;obj_t BgL_arg2886z00_14968;
BgL_arg2884z00_14966 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_ez00_12523)))->BgL_namez00); 
BgL_arg2885z00_14967 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_ez00_12523)))->BgL_modz00); 
BgL_arg2886z00_14968 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_ez00_12523)))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 386 */
obj_t BgL_v1373z00_14969;
BgL_v1373z00_14969 = 
create_vector(((long)5)); 
VECTOR_SET(BgL_v1373z00_14969,((long)0),
BINT(((long)2))); 
VECTOR_SET(BgL_v1373z00_14969,((long)1),BgL_arg2884z00_14966); 
VECTOR_SET(BgL_v1373z00_14969,((long)2),BUNSPEC); 
VECTOR_SET(BgL_v1373z00_14969,((long)3),BgL_arg2885z00_14967); 
VECTOR_SET(BgL_v1373z00_14969,((long)4),BgL_arg2886z00_14968); 
BgL_gz00_14965 = BgL_v1373z00_14969; } } 
VECTOR_SET(BgL_gz00_14965,((long)0),
BINT(((long)3))); 
BGl_evmodulezd2bindzd2globalz12z12zz__evmodulez00(
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_ez00_12523)))->BgL_modz00), 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_ez00_12523)))->BgL_namez00), BgL_gz00_14965, 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_ez00_12523)))->BgL_locz00)); }  else 
{ /* Eval/evaluate_comp.scm 385 */BFALSE; } 
{ /* Eval/evaluate_comp.scm 389 */
obj_t BgL_zc3z04anonymousza32888ze3z87_14970;
BgL_zc3z04anonymousza32888ze3z87_14970 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32888ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32888ze3z87_14970, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_setglobalz00_bglt)BgL_ez00_12523))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32888ze3z87_14970, 
(int)(((long)1)), 
((obj_t)BgL_slotz00_14964)); 
PROCEDURE_SET(BgL_zc3z04anonymousza32888ze3z87_14970, 
(int)(((long)2)), BgL_ez00_14957); 
return BgL_zc3z04anonymousza32888ze3z87_14970;} } } } 

}



/* &<@anonymous:2872> */
obj_t BGl_z62zc3z04anonymousza32872ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12527, obj_t BgL_sz00_12530)
{
{ /* Eval/evaluate_comp.scm 378 */
{ /* Eval/evaluate_comp.scm 378 */
obj_t BgL_gz00_12528;obj_t BgL_ez00_12529;
BgL_gz00_12528 = 
PROCEDURE_REF(BgL_envz00_12527, 
(int)(((long)0))); 
BgL_ez00_12529 = 
PROCEDURE_REF(BgL_envz00_12527, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 378 */
obj_t BgL_bpz00_14971;
BgL_bpz00_14971 = 
VECTOR_REF(
((obj_t)BgL_sz00_12530),((long)0)); 
{ /* Eval/evaluate_comp.scm 379 */
obj_t BgL_arg2873z00_14972;obj_t BgL_arg2874z00_14973;
BgL_arg2873z00_14972 = 
VECTOR_REF(
((obj_t)BgL_gz00_12528),((long)2)); 
BgL_arg2874z00_14973 = 
PROCEDURE_ENTRY(BgL_ez00_12529)(BgL_ez00_12529, BgL_sz00_12530, BEOA); 
return 
__EVMEANING_ADDRESS_SET(BgL_arg2873z00_14972, BgL_arg2874z00_14973);} } } } 

}



/* &<@anonymous:2877> */
obj_t BGl_z62zc3z04anonymousza32877ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12531, obj_t BgL_sz00_12534)
{
{ /* Eval/evaluate_comp.scm 383 */
{ /* Eval/evaluate_comp.scm 383 */
obj_t BgL_ez00_12532;obj_t BgL_gz00_12533;
BgL_ez00_12532 = 
PROCEDURE_REF(BgL_envz00_12531, 
(int)(((long)0))); 
BgL_gz00_12533 = 
PROCEDURE_REF(BgL_envz00_12531, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 383 */
obj_t BgL_bpz00_14974;
BgL_bpz00_14974 = 
VECTOR_REF(
((obj_t)BgL_sz00_12534),((long)0)); 
{ /* Eval/evaluate_comp.scm 383 */
obj_t BgL_arg2878z00_14975;
BgL_arg2878z00_14975 = 
PROCEDURE_ENTRY(BgL_ez00_12532)(BgL_ez00_12532, BgL_sz00_12534, BEOA); 
return 
VECTOR_SET(
((obj_t)BgL_gz00_12533),((long)2),BgL_arg2878z00_14975);} } } } 

}



/* &<@anonymous:2888> */
obj_t BGl_z62zc3z04anonymousza32888ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12535, obj_t BgL_sz00_12539)
{
{ /* Eval/evaluate_comp.scm 389 */
{ /* Eval/evaluate_comp.scm 389 */
BgL_ev_setglobalz00_bglt BgL_i1094z00_12536;obj_t BgL_slotz00_12537;obj_t BgL_ez00_12538;
BgL_i1094z00_12536 = 
((BgL_ev_setglobalz00_bglt)
PROCEDURE_REF(BgL_envz00_12535, 
(int)(((long)0)))); 
BgL_slotz00_12537 = 
PROCEDURE_REF(BgL_envz00_12535, 
(int)(((long)1))); 
BgL_ez00_12538 = 
PROCEDURE_REF(BgL_envz00_12535, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 389 */
obj_t BgL_bpz00_14976;
BgL_bpz00_14976 = 
VECTOR_REF(
((obj_t)BgL_sz00_12539),((long)0)); 
if(
CBOOL(
CELL_REF(BgL_slotz00_12537)))
{ /* Eval/evaluate_comp.scm 390 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 390 */
{ /* Eval/evaluate_comp.scm 391 */
obj_t BgL_auxz00_14977;
BgL_auxz00_14977 = 
BGl_evmodulezd2findzd2globalz00zz__evmodulez00(
(((BgL_ev_setglobalz00_bglt)COBJECT(BgL_i1094z00_12536))->BgL_modz00), 
(((BgL_ev_setglobalz00_bglt)COBJECT(BgL_i1094z00_12536))->BgL_namez00)); 
CELL_SET(BgL_slotz00_12537, BgL_auxz00_14977); } 
if(
CBOOL(
CELL_REF(BgL_slotz00_12537)))
{ /* Eval/evaluate_comp.scm 392 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 392 */
BGl_everrorz00zz__everrorz00(
(((BgL_ev_setglobalz00_bglt)COBJECT(BgL_i1094z00_12536))->BgL_locz00), BGl_string5208z00zz__evaluate_compz00, BGl_string5332z00zz__evaluate_compz00, 
(((BgL_ev_setglobalz00_bglt)COBJECT(BgL_i1094z00_12536))->BgL_namez00)); } } 
{ /* Eval/evaluate_comp.scm 393 */
obj_t BgL_arg2893z00_14978;
BgL_arg2893z00_14978 = 
PROCEDURE_ENTRY(BgL_ez00_12538)(BgL_ez00_12538, BgL_sz00_12539, BEOA); 
{ /* Eval/evaluate_comp.scm 393 */
obj_t BgL_evalzd2globalzd2_14979;
BgL_evalzd2globalzd2_14979 = 
CELL_REF(BgL_slotz00_12537); 
return 
VECTOR_SET(BgL_evalzd2globalzd2_14979,((long)2),BgL_arg2893z00_14978);} } } } } 

}



/* &comp-ev_global1395 */
obj_t BGl_z62compzd2ev_global1395zb0zz__evaluate_compz00(obj_t BgL_envz00_12541, obj_t BgL_varz00_12542, obj_t BgL_stkz00_12543)
{
{ /* Eval/evaluate_comp.scm 339 */
{ /* Eval/evaluate_comp.scm 341 */
obj_t BgL_gz00_14981;
BgL_gz00_14981 = 
BGl_evmodulezd2findzd2globalz00zz__evmodulez00(
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_varz00_12542)))->BgL_modz00), 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_varz00_12542)))->BgL_namez00)); 
if(
CBOOL(BgL_gz00_14981))
{ /* Eval/evaluate_comp.scm 343 */
bool_t BgL_test6000z00_29366;
{ /* Eval/evaluate_comp.scm 343 */
int BgL_arg2835z00_14982;
{ /* Eval/evaluate_comp.scm 343 */
int BgL_res4670z00_14983;
BgL_res4670z00_14983 = 
CINT(
VECTOR_REF(
((obj_t)BgL_gz00_14981),((long)0))); 
BgL_arg2835z00_14982 = BgL_res4670z00_14983; } 
BgL_test6000z00_29366 = 
(
BINT(BgL_arg2835z00_14982)==
BINT(((long)1))); } 
if(BgL_test6000z00_29366)
{ /* Eval/evaluate_comp.scm 344 */
obj_t BgL_zc3z04anonymousza32832ze3z87_14984;
BgL_zc3z04anonymousza32832ze3z87_14984 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32832ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32832ze3z87_14984, 
(int)(((long)0)), BgL_gz00_14981); 
return BgL_zc3z04anonymousza32832ze3z87_14984;}  else 
{ /* Eval/evaluate_comp.scm 346 */
obj_t BgL_zc3z04anonymousza32834ze3z87_14985;
BgL_zc3z04anonymousza32834ze3z87_14985 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32834ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32834ze3z87_14985, 
(int)(((long)0)), BgL_gz00_14981); 
return BgL_zc3z04anonymousza32834ze3z87_14985;} }  else 
{ /* Eval/evaluate_comp.scm 348 */
obj_t BgL_slotz00_14986;
BgL_slotz00_14986 = 
MAKE_CELL(BFALSE); 
if(
BGl_evmodulezf3zf3zz__evmodulez00(
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_varz00_12542)))->BgL_modz00)))
{ /* Eval/evaluate_comp.scm 350 */
obj_t BgL_gz00_14987;
{ /* Eval/evaluate_comp.scm 350 */
obj_t BgL_arg2841z00_14988;obj_t BgL_arg2842z00_14989;obj_t BgL_arg2843z00_14990;
BgL_arg2841z00_14988 = 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_varz00_12542)))->BgL_namez00); 
BgL_arg2842z00_14989 = 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_varz00_12542)))->BgL_modz00); 
BgL_arg2843z00_14990 = 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_varz00_12542)))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 350 */
obj_t BgL_v1373z00_14991;
BgL_v1373z00_14991 = 
create_vector(((long)5)); 
VECTOR_SET(BgL_v1373z00_14991,((long)0),
BINT(((long)2))); 
VECTOR_SET(BgL_v1373z00_14991,((long)1),BgL_arg2841z00_14988); 
VECTOR_SET(BgL_v1373z00_14991,((long)2),BUNSPEC); 
VECTOR_SET(BgL_v1373z00_14991,((long)3),BgL_arg2842z00_14989); 
VECTOR_SET(BgL_v1373z00_14991,((long)4),BgL_arg2843z00_14990); 
BgL_gz00_14987 = BgL_v1373z00_14991; } } 
VECTOR_SET(BgL_gz00_14987,((long)0),
BINT(((long)3))); 
BGl_evmodulezd2bindzd2globalz12z12zz__evmodulez00(
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_varz00_12542)))->BgL_modz00), 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_varz00_12542)))->BgL_namez00), BgL_gz00_14987, 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_varz00_12542)))->BgL_locz00)); }  else 
{ /* Eval/evaluate_comp.scm 349 */BFALSE; } 
{ /* Eval/evaluate_comp.scm 353 */
obj_t BgL_zc3z04anonymousza32845ze3z87_14992;
BgL_zc3z04anonymousza32845ze3z87_14992 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32845ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32845ze3z87_14992, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_globalz00_bglt)BgL_varz00_12542))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32845ze3z87_14992, 
(int)(((long)1)), 
((obj_t)BgL_slotz00_14986)); 
return BgL_zc3z04anonymousza32845ze3z87_14992;} } } } 

}



/* &<@anonymous:2832> */
obj_t BGl_z62zc3z04anonymousza32832ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12546, obj_t BgL_sz00_12548)
{
{ /* Eval/evaluate_comp.scm 344 */
{ /* Eval/evaluate_comp.scm 344 */
obj_t BgL_gz00_12547;
BgL_gz00_12547 = 
PROCEDURE_REF(BgL_envz00_12546, 
(int)(((long)0))); 
{ /* Eval/evaluate_comp.scm 344 */
obj_t BgL_bpz00_14993;
BgL_bpz00_14993 = 
VECTOR_REF(
((obj_t)BgL_sz00_12548),((long)0)); 
{ /* Eval/evaluate_comp.scm 345 */
obj_t BgL_arg2833z00_14994;
BgL_arg2833z00_14994 = 
VECTOR_REF(
((obj_t)BgL_gz00_12547),((long)2)); 
return 
__EVMEANING_ADDRESS_REF(BgL_arg2833z00_14994);} } } } 

}



/* &<@anonymous:2834> */
obj_t BGl_z62zc3z04anonymousza32834ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12549, obj_t BgL_sz00_12551)
{
{ /* Eval/evaluate_comp.scm 346 */
{ /* Eval/evaluate_comp.scm 346 */
obj_t BgL_gz00_12550;
BgL_gz00_12550 = 
PROCEDURE_REF(BgL_envz00_12549, 
(int)(((long)0))); 
{ /* Eval/evaluate_comp.scm 346 */
obj_t BgL_bpz00_14995;
BgL_bpz00_14995 = 
VECTOR_REF(
((obj_t)BgL_sz00_12551),((long)0)); 
return 
VECTOR_REF(
((obj_t)BgL_gz00_12550),((long)2));} } } 

}



/* &<@anonymous:2845> */
obj_t BGl_z62zc3z04anonymousza32845ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12552, obj_t BgL_sz00_12555)
{
{ /* Eval/evaluate_comp.scm 353 */
{ /* Eval/evaluate_comp.scm 353 */
BgL_ev_globalz00_bglt BgL_i1093z00_12553;obj_t BgL_slotz00_12554;
BgL_i1093z00_12553 = 
((BgL_ev_globalz00_bglt)
PROCEDURE_REF(BgL_envz00_12552, 
(int)(((long)0)))); 
BgL_slotz00_12554 = 
PROCEDURE_REF(BgL_envz00_12552, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 353 */
obj_t BgL_bpz00_14996;
BgL_bpz00_14996 = 
VECTOR_REF(
((obj_t)BgL_sz00_12555),((long)0)); 
if(
CBOOL(
CELL_REF(BgL_slotz00_12554)))
{ /* Eval/evaluate_comp.scm 354 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 354 */
{ /* Eval/evaluate_comp.scm 355 */
obj_t BgL_auxz00_14997;
BgL_auxz00_14997 = 
BGl_evmodulezd2findzd2globalz00zz__evmodulez00(
(((BgL_ev_globalz00_bglt)COBJECT(BgL_i1093z00_12553))->BgL_modz00), 
(((BgL_ev_globalz00_bglt)COBJECT(BgL_i1093z00_12553))->BgL_namez00)); 
CELL_SET(BgL_slotz00_12554, BgL_auxz00_14997); } 
if(
CBOOL(
CELL_REF(BgL_slotz00_12554)))
{ /* Eval/evaluate_comp.scm 356 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 357 */
obj_t BgL_idz00_14998;
if(
BGl_evmodulezf3zf3zz__evmodulez00(
(((BgL_ev_globalz00_bglt)COBJECT(BgL_i1093z00_12553))->BgL_modz00)))
{ /* Eval/evaluate_comp.scm 358 */
obj_t BgL_arg2851z00_14999;
{ /* Eval/evaluate_comp.scm 358 */
obj_t BgL_arg2852z00_15000;obj_t BgL_arg2853z00_15001;
BgL_arg2852z00_15000 = 
(((BgL_ev_globalz00_bglt)COBJECT(BgL_i1093z00_12553))->BgL_namez00); 
BgL_arg2853z00_15001 = 
MAKE_YOUNG_PAIR(
BGl_evmodulezd2namezd2zz__evmodulez00(
(((BgL_ev_globalz00_bglt)COBJECT(BgL_i1093z00_12553))->BgL_modz00)), BNIL); 
BgL_arg2851z00_14999 = 
MAKE_YOUNG_PAIR(BgL_arg2852z00_15000, BgL_arg2853z00_15001); } 
BgL_idz00_14998 = 
MAKE_YOUNG_PAIR(BGl_symbol5333z00zz__evaluate_compz00, BgL_arg2851z00_14999); }  else 
{ /* Eval/evaluate_comp.scm 357 */
BgL_idz00_14998 = 
(((BgL_ev_globalz00_bglt)COBJECT(BgL_i1093z00_12553))->BgL_namez00); } 
BGl_everrorz00zz__everrorz00(
(((BgL_ev_globalz00_bglt)COBJECT(BgL_i1093z00_12553))->BgL_locz00), BGl_string5208z00zz__evaluate_compz00, BGl_string5332z00zz__evaluate_compz00, BgL_idz00_14998); } } 
{ /* Eval/evaluate_comp.scm 361 */
obj_t BgL_vz00_15002;
{ /* Eval/evaluate_comp.scm 361 */
obj_t BgL_evalzd2globalzd2_15003;
BgL_evalzd2globalzd2_15003 = 
CELL_REF(BgL_slotz00_12554); 
BgL_vz00_15002 = 
VECTOR_REF(BgL_evalzd2globalzd2_15003,((long)2)); } 
if(
(BgL_vz00_15002==BUNSPEC))
{ /* Eval/evaluate_comp.scm 363 */
int BgL_tz00_15004;
{ /* Eval/evaluate_comp.scm 363 */
int BgL_res4671z00_15005;
{ /* Eval/evaluate_comp.scm 363 */
obj_t BgL_evalzd2globalzd2_15006;
BgL_evalzd2globalzd2_15006 = 
CELL_REF(BgL_slotz00_12554); 
BgL_res4671z00_15005 = 
CINT(
VECTOR_REF(BgL_evalzd2globalzd2_15006,((long)0))); } 
BgL_tz00_15004 = BgL_res4671z00_15005; } 
{ /* Eval/evaluate_comp.scm 364 */
bool_t BgL_test6006z00_29463;
if(
(
(long)(BgL_tz00_15004)==((long)3)))
{ /* Eval/evaluate_comp.scm 364 */
BgL_test6006z00_29463 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate_comp.scm 364 */
BgL_test6006z00_29463 = 
(
(long)(BgL_tz00_15004)==((long)4))
; } 
if(BgL_test6006z00_29463)
{ /* Eval/evaluate_comp.scm 365 */
obj_t BgL_idz00_15007;
if(
BGl_evmodulezf3zf3zz__evmodulez00(
(((BgL_ev_globalz00_bglt)COBJECT(BgL_i1093z00_12553))->BgL_modz00)))
{ /* Eval/evaluate_comp.scm 366 */
obj_t BgL_arg2863z00_15008;
{ /* Eval/evaluate_comp.scm 366 */
obj_t BgL_arg2864z00_15009;obj_t BgL_arg2865z00_15010;
BgL_arg2864z00_15009 = 
(((BgL_ev_globalz00_bglt)COBJECT(BgL_i1093z00_12553))->BgL_namez00); 
BgL_arg2865z00_15010 = 
MAKE_YOUNG_PAIR(
BGl_evmodulezd2namezd2zz__evmodulez00(
(((BgL_ev_globalz00_bglt)COBJECT(BgL_i1093z00_12553))->BgL_modz00)), BNIL); 
BgL_arg2863z00_15008 = 
MAKE_YOUNG_PAIR(BgL_arg2864z00_15009, BgL_arg2865z00_15010); } 
BgL_idz00_15007 = 
MAKE_YOUNG_PAIR(BGl_symbol5333z00zz__evaluate_compz00, BgL_arg2863z00_15008); }  else 
{ /* Eval/evaluate_comp.scm 365 */
BgL_idz00_15007 = 
(((BgL_ev_globalz00_bglt)COBJECT(BgL_i1093z00_12553))->BgL_namez00); } 
return 
BGl_everrorz00zz__everrorz00(
(((BgL_ev_globalz00_bglt)COBJECT(BgL_i1093z00_12553))->BgL_locz00), BGl_string5208z00zz__evaluate_compz00, BGl_string5335z00zz__evaluate_compz00, BgL_idz00_15007);}  else 
{ /* Eval/evaluate_comp.scm 364 */
return BgL_vz00_15002;} } }  else 
{ /* Eval/evaluate_comp.scm 362 */
return BgL_vz00_15002;} } } } } 

}



/* &comp-ev_setlocal1393 */
obj_t BGl_z62compzd2ev_setlocal1393zb0zz__evaluate_compz00(obj_t BgL_envz00_12557, obj_t BgL_ez00_12558, obj_t BgL_stkz00_12559)
{
{ /* Eval/evaluate_comp.scm 321 */
{ /* Eval/evaluate_comp.scm 323 */
obj_t BgL_iz00_15012;obj_t BgL_ez00_15013;
{ /* Eval/evaluate_comp.scm 323 */
BgL_ev_varz00_bglt BgL_arg2828z00_15014;
BgL_arg2828z00_15014 = 
(((BgL_ev_setlocalz00_bglt)COBJECT(
((BgL_ev_setlocalz00_bglt)BgL_ez00_12558)))->BgL_vz00); 
BgL_iz00_15012 = 
BGl__indexz00zz__evaluate_compz00(
((obj_t)BgL_arg2828z00_15014), BgL_stkz00_12559); } 
{ /* Eval/evaluate_comp.scm 323 */
BgL_ev_exprz00_bglt BgL_arg2829z00_15015;
BgL_arg2829z00_15015 = 
(((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)
((BgL_ev_setlocalz00_bglt)BgL_ez00_12558))))->BgL_ez00); 
BgL_ez00_15013 = 
BGl_compz00zz__evaluate_compz00(BgL_arg2829z00_15015, BgL_stkz00_12559); } 
if(
CBOOL(
(((BgL_ev_varz00_bglt)COBJECT(
(((BgL_ev_setlocalz00_bglt)COBJECT(
((BgL_ev_setlocalz00_bglt)BgL_ez00_12558)))->BgL_vz00)))->BgL_effz00)))
{ /* Eval/evaluate_comp.scm 326 */
obj_t BgL_zc3z04anonymousza32821ze3z87_15016;
BgL_zc3z04anonymousza32821ze3z87_15016 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32821ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32821ze3z87_15016, 
(int)(((long)0)), BgL_iz00_15012); 
PROCEDURE_SET(BgL_zc3z04anonymousza32821ze3z87_15016, 
(int)(((long)1)), BgL_ez00_15013); 
return BgL_zc3z04anonymousza32821ze3z87_15016;}  else 
{ /* Eval/evaluate_comp.scm 328 */
obj_t BgL_zc3z04anonymousza32825ze3z87_15017;
BgL_zc3z04anonymousza32825ze3z87_15017 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32825ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32825ze3z87_15017, 
(int)(((long)0)), BgL_iz00_15012); 
PROCEDURE_SET(BgL_zc3z04anonymousza32825ze3z87_15017, 
(int)(((long)1)), BgL_ez00_15013); 
return BgL_zc3z04anonymousza32825ze3z87_15017;} } } 

}



/* &<@anonymous:2821> */
obj_t BGl_z62zc3z04anonymousza32821ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12560, obj_t BgL_sz00_12563)
{
{ /* Eval/evaluate_comp.scm 326 */
{ /* Eval/evaluate_comp.scm 326 */
obj_t BgL_iz00_12561;obj_t BgL_ez00_12562;
BgL_iz00_12561 = 
PROCEDURE_REF(BgL_envz00_12560, 
(int)(((long)0))); 
BgL_ez00_12562 = 
PROCEDURE_REF(BgL_envz00_12560, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 326 */
obj_t BgL_bpz00_15018;
BgL_bpz00_15018 = 
VECTOR_REF(
((obj_t)BgL_sz00_12563),((long)0)); 
{ /* Eval/evaluate_comp.scm 327 */
obj_t BgL_arg2822z00_15019;obj_t BgL_arg2823z00_15020;
{ /* Eval/evaluate_comp.scm 327 */
long BgL_arg2824z00_15021;
BgL_arg2824z00_15021 = 
(
(long)CINT(BgL_bpz00_15018)+
(long)CINT(BgL_iz00_12561)); 
BgL_arg2822z00_15019 = 
VECTOR_REF(
((obj_t)BgL_sz00_12563),BgL_arg2824z00_15021); } 
BgL_arg2823z00_15020 = 
PROCEDURE_ENTRY(BgL_ez00_12562)(BgL_ez00_12562, BgL_sz00_12563, BEOA); 
{ /* Eval/evaluate_comp.scm 202 */
obj_t BgL_xz00_15022;
{ /* Eval/evaluate_comp.scm 202 */
int BgL_auxz00_29525;obj_t BgL_tmpz00_29523;
BgL_auxz00_29525 = 
(int)(((long)0)); 
BgL_tmpz00_29523 = 
((obj_t)BgL_arg2822z00_15019); 
BgL_xz00_15022 = 
STRUCT_SET(BgL_tmpz00_29523, BgL_auxz00_29525, BgL_arg2823z00_15020); } 
return BUNSPEC;} } } } } 

}



/* &<@anonymous:2825> */
obj_t BGl_z62zc3z04anonymousza32825ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12564, obj_t BgL_sz00_12567)
{
{ /* Eval/evaluate_comp.scm 328 */
{ /* Eval/evaluate_comp.scm 328 */
obj_t BgL_iz00_12565;obj_t BgL_ez00_12566;
BgL_iz00_12565 = 
PROCEDURE_REF(BgL_envz00_12564, 
(int)(((long)0))); 
BgL_ez00_12566 = 
PROCEDURE_REF(BgL_envz00_12564, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 328 */
obj_t BgL_bpz00_15023;
BgL_bpz00_15023 = 
VECTOR_REF(
((obj_t)BgL_sz00_12567),((long)0)); 
{ /* Eval/evaluate_comp.scm 329 */
long BgL_arg2826z00_15024;obj_t BgL_arg2827z00_15025;
BgL_arg2826z00_15024 = 
(
(long)CINT(BgL_bpz00_15023)+
(long)CINT(BgL_iz00_12565)); 
BgL_arg2827z00_15025 = 
PROCEDURE_ENTRY(BgL_ez00_12566)(BgL_ez00_12566, BgL_sz00_12567, BEOA); 
return 
VECTOR_SET(
((obj_t)BgL_sz00_12567),BgL_arg2826z00_15024,BgL_arg2827z00_15025);} } } } 

}



/* &comp-ev_var1391 */
obj_t BGl_z62compzd2ev_var1391zb0zz__evaluate_compz00(obj_t BgL_envz00_12568, obj_t BgL_varz00_12569, obj_t BgL_stkz00_12570)
{
{ /* Eval/evaluate_comp.scm 316 */
{ /* Eval/evaluate_comp.scm 317 */
obj_t BgL_iz00_15027;
BgL_iz00_15027 = 
BGl__indexz00zz__evaluate_compz00(
((obj_t)
((BgL_ev_varz00_bglt)BgL_varz00_12569)), BgL_stkz00_12570); 
{ 

if(
INTEGERP(BgL_iz00_15027))
{ /* Eval/evaluate_comp.scm 319 */
switch( 
(long)CINT(BgL_iz00_15027)) { case ((long)0) : 

if(
CBOOL(
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_varz00_12569)))->BgL_effz00)))
{ /* Eval/evaluate_comp.scm 319 */
return BGl_proc5336z00zz__evaluate_compz00;}  else 
{ /* Eval/evaluate_comp.scm 319 */
return BGl_proc5337z00zz__evaluate_compz00;} break;case ((long)1) : 

if(
CBOOL(
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_varz00_12569)))->BgL_effz00)))
{ /* Eval/evaluate_comp.scm 319 */
return BGl_proc5338z00zz__evaluate_compz00;}  else 
{ /* Eval/evaluate_comp.scm 319 */
return BGl_proc5339z00zz__evaluate_compz00;} break;case ((long)2) : 

if(
CBOOL(
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_varz00_12569)))->BgL_effz00)))
{ /* Eval/evaluate_comp.scm 319 */
return BGl_proc5340z00zz__evaluate_compz00;}  else 
{ /* Eval/evaluate_comp.scm 319 */
return BGl_proc5341z00zz__evaluate_compz00;} break;case ((long)3) : 

if(
CBOOL(
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_varz00_12569)))->BgL_effz00)))
{ /* Eval/evaluate_comp.scm 319 */
return BGl_proc5342z00zz__evaluate_compz00;}  else 
{ /* Eval/evaluate_comp.scm 319 */
return BGl_proc5343z00zz__evaluate_compz00;} break;
default: 
BgL_case_else1088z00_15028:
if(
CBOOL(
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_varz00_12569)))->BgL_effz00)))
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_zc3z04anonymousza32815ze3z87_15029;
BgL_zc3z04anonymousza32815ze3z87_15029 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32815ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32815ze3z87_15029, 
(int)(((long)0)), BgL_iz00_15027); 
return BgL_zc3z04anonymousza32815ze3z87_15029;}  else 
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_zc3z04anonymousza32818ze3z87_15030;
BgL_zc3z04anonymousza32818ze3z87_15030 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32818ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32818ze3z87_15030, 
(int)(((long)0)), BgL_iz00_15027); 
return BgL_zc3z04anonymousza32818ze3z87_15030;} } }  else 
{ /* Eval/evaluate_comp.scm 319 */
goto BgL_case_else1088z00_15028;} } } } 

}



/* &<@anonymous:2809> */
obj_t BGl_z62zc3z04anonymousza32809ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12571, obj_t BgL_sz00_12572)
{
{ /* Eval/evaluate_comp.scm 319 */
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_bpz00_15031;
BgL_bpz00_15031 = 
VECTOR_REF(
((obj_t)BgL_sz00_12572),((long)0)); 
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_arg2810z00_15032;
{ /* Eval/evaluate_comp.scm 319 */
long BgL_arg2811z00_15033;
BgL_arg2811z00_15033 = 
(
(long)CINT(BgL_bpz00_15031)+((long)3)); 
BgL_arg2810z00_15032 = 
VECTOR_REF(
((obj_t)BgL_sz00_12572),BgL_arg2811z00_15033); } 
return 
STRUCT_REF(
((obj_t)BgL_arg2810z00_15032), 
(int)(((long)0)));} } } 

}



/* &<@anonymous:2812> */
obj_t BGl_z62zc3z04anonymousza32812ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12573, obj_t BgL_sz00_12574)
{
{ /* Eval/evaluate_comp.scm 319 */
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_bpz00_15034;
BgL_bpz00_15034 = 
VECTOR_REF(
((obj_t)BgL_sz00_12574),((long)0)); 
{ /* Eval/evaluate_comp.scm 319 */
long BgL_arg2813z00_15035;
BgL_arg2813z00_15035 = 
(
(long)CINT(BgL_bpz00_15034)+((long)3)); 
return 
VECTOR_REF(
((obj_t)BgL_sz00_12574),BgL_arg2813z00_15035);} } } 

}



/* &<@anonymous:2803> */
obj_t BGl_z62zc3z04anonymousza32803ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12575, obj_t BgL_sz00_12576)
{
{ /* Eval/evaluate_comp.scm 319 */
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_bpz00_15036;
BgL_bpz00_15036 = 
VECTOR_REF(
((obj_t)BgL_sz00_12576),((long)0)); 
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_arg2804z00_15037;
{ /* Eval/evaluate_comp.scm 319 */
long BgL_arg2805z00_15038;
BgL_arg2805z00_15038 = 
(
(long)CINT(BgL_bpz00_15036)+((long)2)); 
BgL_arg2804z00_15037 = 
VECTOR_REF(
((obj_t)BgL_sz00_12576),BgL_arg2805z00_15038); } 
return 
STRUCT_REF(
((obj_t)BgL_arg2804z00_15037), 
(int)(((long)0)));} } } 

}



/* &<@anonymous:2806> */
obj_t BGl_z62zc3z04anonymousza32806ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12577, obj_t BgL_sz00_12578)
{
{ /* Eval/evaluate_comp.scm 319 */
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_bpz00_15039;
BgL_bpz00_15039 = 
VECTOR_REF(
((obj_t)BgL_sz00_12578),((long)0)); 
{ /* Eval/evaluate_comp.scm 319 */
long BgL_arg2807z00_15040;
BgL_arg2807z00_15040 = 
(
(long)CINT(BgL_bpz00_15039)+((long)2)); 
return 
VECTOR_REF(
((obj_t)BgL_sz00_12578),BgL_arg2807z00_15040);} } } 

}



/* &<@anonymous:2797> */
obj_t BGl_z62zc3z04anonymousza32797ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12579, obj_t BgL_sz00_12580)
{
{ /* Eval/evaluate_comp.scm 319 */
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_bpz00_15041;
BgL_bpz00_15041 = 
VECTOR_REF(
((obj_t)BgL_sz00_12580),((long)0)); 
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_arg2798z00_15042;
{ /* Eval/evaluate_comp.scm 319 */
long BgL_arg2799z00_15043;
BgL_arg2799z00_15043 = 
(
(long)CINT(BgL_bpz00_15041)+((long)1)); 
BgL_arg2798z00_15042 = 
VECTOR_REF(
((obj_t)BgL_sz00_12580),BgL_arg2799z00_15043); } 
return 
STRUCT_REF(
((obj_t)BgL_arg2798z00_15042), 
(int)(((long)0)));} } } 

}



/* &<@anonymous:2800> */
obj_t BGl_z62zc3z04anonymousza32800ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12581, obj_t BgL_sz00_12582)
{
{ /* Eval/evaluate_comp.scm 319 */
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_bpz00_15044;
BgL_bpz00_15044 = 
VECTOR_REF(
((obj_t)BgL_sz00_12582),((long)0)); 
{ /* Eval/evaluate_comp.scm 319 */
long BgL_arg2801z00_15045;
BgL_arg2801z00_15045 = 
(
(long)CINT(BgL_bpz00_15044)+((long)1)); 
return 
VECTOR_REF(
((obj_t)BgL_sz00_12582),BgL_arg2801z00_15045);} } } 

}



/* &<@anonymous:2791> */
obj_t BGl_z62zc3z04anonymousza32791ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12583, obj_t BgL_sz00_12584)
{
{ /* Eval/evaluate_comp.scm 319 */
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_bpz00_15046;
BgL_bpz00_15046 = 
VECTOR_REF(
((obj_t)BgL_sz00_12584),((long)0)); 
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_arg2792z00_15047;
{ /* Eval/evaluate_comp.scm 319 */
long BgL_arg2793z00_15048;
BgL_arg2793z00_15048 = 
(
(long)CINT(BgL_bpz00_15046)+((long)0)); 
BgL_arg2792z00_15047 = 
VECTOR_REF(
((obj_t)BgL_sz00_12584),BgL_arg2793z00_15048); } 
return 
STRUCT_REF(
((obj_t)BgL_arg2792z00_15047), 
(int)(((long)0)));} } } 

}



/* &<@anonymous:2794> */
obj_t BGl_z62zc3z04anonymousza32794ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12585, obj_t BgL_sz00_12586)
{
{ /* Eval/evaluate_comp.scm 319 */
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_bpz00_15049;
BgL_bpz00_15049 = 
VECTOR_REF(
((obj_t)BgL_sz00_12586),((long)0)); 
{ /* Eval/evaluate_comp.scm 319 */
long BgL_arg2795z00_15050;
BgL_arg2795z00_15050 = 
(
(long)CINT(BgL_bpz00_15049)+((long)0)); 
return 
VECTOR_REF(
((obj_t)BgL_sz00_12586),BgL_arg2795z00_15050);} } } 

}



/* &<@anonymous:2815> */
obj_t BGl_z62zc3z04anonymousza32815ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12587, obj_t BgL_sz00_12589)
{
{ /* Eval/evaluate_comp.scm 319 */
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_iz00_12588;
BgL_iz00_12588 = 
PROCEDURE_REF(BgL_envz00_12587, 
(int)(((long)0))); 
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_bpz00_15051;
BgL_bpz00_15051 = 
VECTOR_REF(
((obj_t)BgL_sz00_12589),((long)0)); 
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_arg2816z00_15052;
{ /* Eval/evaluate_comp.scm 319 */
long BgL_arg2817z00_15053;
BgL_arg2817z00_15053 = 
(
(long)CINT(BgL_bpz00_15051)+
(long)CINT(BgL_iz00_12588)); 
BgL_arg2816z00_15052 = 
VECTOR_REF(
((obj_t)BgL_sz00_12589),BgL_arg2817z00_15053); } 
return 
STRUCT_REF(
((obj_t)BgL_arg2816z00_15052), 
(int)(((long)0)));} } } } 

}



/* &<@anonymous:2818> */
obj_t BGl_z62zc3z04anonymousza32818ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12590, obj_t BgL_sz00_12592)
{
{ /* Eval/evaluate_comp.scm 319 */
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_iz00_12591;
BgL_iz00_12591 = 
PROCEDURE_REF(BgL_envz00_12590, 
(int)(((long)0))); 
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_bpz00_15054;
BgL_bpz00_15054 = 
VECTOR_REF(
((obj_t)BgL_sz00_12592),((long)0)); 
{ /* Eval/evaluate_comp.scm 319 */
long BgL_arg2819z00_15055;
BgL_arg2819z00_15055 = 
(
(long)CINT(BgL_bpz00_15054)+
(long)CINT(BgL_iz00_12591)); 
return 
VECTOR_REF(
((obj_t)BgL_sz00_12592),BgL_arg2819z00_15055);} } } } 

}



/* &comp-ev_trap1389 */
obj_t BGl_z62compzd2ev_trap1389zb0zz__evaluate_compz00(obj_t BgL_envz00_12593, obj_t BgL_ez00_12594, obj_t BgL_stkz00_12595)
{
{ /* Eval/evaluate_comp.scm 289 */
{ /* Eval/evaluate_comp.scm 291 */
obj_t BgL_ez00_15057;
{ /* Eval/evaluate_comp.scm 291 */
BgL_ev_exprz00_bglt BgL_arg2788z00_15058;
BgL_arg2788z00_15058 = 
(((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)
((BgL_ev_trapz00_bglt)BgL_ez00_12594))))->BgL_ez00); 
BgL_ez00_15057 = 
BGl_compz00zz__evaluate_compz00(BgL_arg2788z00_15058, BgL_stkz00_12595); } 
{ /* Eval/evaluate_comp.scm 292 */
obj_t BgL_zc3z04anonymousza32782ze3z87_15059;
BgL_zc3z04anonymousza32782ze3z87_15059 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32782ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32782ze3z87_15059, 
(int)(((long)0)), BgL_ez00_15057); 
return BgL_zc3z04anonymousza32782ze3z87_15059;} } } 

}



/* &<@anonymous:2782> */
obj_t BGl_z62zc3z04anonymousza32782ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12596, obj_t BgL_sz00_12598)
{
{ /* Eval/evaluate_comp.scm 292 */
{ /* Eval/evaluate_comp.scm 292 */
obj_t BgL_ez00_12597;
BgL_ez00_12597 = 
PROCEDURE_REF(BgL_envz00_12596, 
(int)(((long)0))); 
{ /* Eval/evaluate_comp.scm 292 */
obj_t BgL_bpz00_15060;
BgL_bpz00_15060 = 
VECTOR_REF(
((obj_t)BgL_sz00_12598),((long)0)); 
{ /* Eval/evaluate_comp.scm 293 */
obj_t BgL_cmdz00_15061;
BgL_cmdz00_15061 = 
PROCEDURE_ENTRY(BgL_ez00_12597)(BgL_ez00_12597, BgL_sz00_12598, BEOA); 
if(
(BgL_cmdz00_15061==BGl_symbol5344z00zz__evaluate_compz00))
{ /* Eval/evaluate_comp.scm 294 */
return BgL_bpz00_15060;}  else 
{ /* Eval/evaluate_comp.scm 294 */
if(
(BgL_cmdz00_15061==BGl_symbol5346z00zz__evaluate_compz00))
{ /* Eval/evaluate_comp.scm 294 */
return 
BGl_reset_profilez00zz__evaluate_compz00();}  else 
{ /* Eval/evaluate_comp.scm 294 */
if(
(BgL_cmdz00_15061==BGl_symbol5348z00zz__evaluate_compz00))
{ /* Eval/evaluate_comp.scm 294 */
return 
BGl_get_profilez00zz__evaluate_compz00();}  else 
{ /* Eval/evaluate_comp.scm 294 */
if(
(BgL_cmdz00_15061==BGl_symbol5350z00zz__evaluate_compz00))
{ /* Eval/evaluate_comp.scm 302 */
obj_t BgL_arg2787z00_15062;
BgL_arg2787z00_15062 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
return 
VECTOR_SET(
((obj_t)BgL_arg2787z00_15062),((long)0),
BINT(((long)2)));}  else 
{ /* Eval/evaluate_comp.scm 294 */
return 
BGl_errorz00zz__errorz00(BGl_string5208z00zz__evaluate_compz00, BGl_string5352z00zz__evaluate_compz00, BgL_cmdz00_15061);} } } } } } } } 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__evaluate_compz00()
{
{ /* Eval/evaluate_comp.scm 15 */
BGl_modulezd2initializa7ationz75zz__typez00(((long)121046086), 
BSTRING_TO_STRING(BGl_string5353z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)330490148), 
BSTRING_TO_STRING(BGl_string5353z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__biglooz00(((long)180158922), 
BSTRING_TO_STRING(BGl_string5353z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__tvectorz00(((long)135276775), 
BSTRING_TO_STRING(BGl_string5353z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__structurez00(((long)128218210), 
BSTRING_TO_STRING(BGl_string5353z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__bexitz00(((long)340267792), 
BSTRING_TO_STRING(BGl_string5353z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__bignumz00(((long)6519932), 
BSTRING_TO_STRING(BGl_string5353z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__osz00(((long)251314740), 
BSTRING_TO_STRING(BGl_string5353z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__dssslz00(((long)443936801), 
BSTRING_TO_STRING(BGl_string5353z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__bitz00(((long)439353001), 
BSTRING_TO_STRING(BGl_string5353z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__paramz00(((long)453939141), 
BSTRING_TO_STRING(BGl_string5353z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)193422112), 
BSTRING_TO_STRING(BGl_string5353z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__threadz00(((long)224967693), 
BSTRING_TO_STRING(BGl_string5353z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__srfi4z00(((long)467924964), 
BSTRING_TO_STRING(BGl_string5353z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long)68574988), 
BSTRING_TO_STRING(BGl_string5353z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)93454137), 
BSTRING_TO_STRING(BGl_string5353z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(((long)437057797), 
BSTRING_TO_STRING(BGl_string5353z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(((long)268155843), 
BSTRING_TO_STRING(BGl_string5353z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long)198620800), 
BSTRING_TO_STRING(BGl_string5353z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)473309430), 
BSTRING_TO_STRING(BGl_string5353z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(((long)459519430), 
BSTRING_TO_STRING(BGl_string5353z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long)460262918), 
BSTRING_TO_STRING(BGl_string5353z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)-400105135), 
BSTRING_TO_STRING(BGl_string5353z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)9614678), 
BSTRING_TO_STRING(BGl_string5353z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)376927882), 
BSTRING_TO_STRING(BGl_string5353z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)228151370), 
BSTRING_TO_STRING(BGl_string5353z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)127905250), 
BSTRING_TO_STRING(BGl_string5353z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)331540577), 
BSTRING_TO_STRING(BGl_string5353z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)86988580), 
BSTRING_TO_STRING(BGl_string5353z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__ppz00(((long)233942021), 
BSTRING_TO_STRING(BGl_string5353z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)220648206), 
BSTRING_TO_STRING(BGl_string5353z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__prognz00(((long)177147622), 
BSTRING_TO_STRING(BGl_string5353z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__expandz00(((long)414007149), 
BSTRING_TO_STRING(BGl_string5353z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__evenvz00(((long)528345299), 
BSTRING_TO_STRING(BGl_string5353z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__evcompilez00(((long)492754569), 
BSTRING_TO_STRING(BGl_string5353z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__everrorz00(((long)375872221), 
BSTRING_TO_STRING(BGl_string5353z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__evmodulez00(((long)505897955), 
BSTRING_TO_STRING(BGl_string5353z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(((long)0), 
BSTRING_TO_STRING(BGl_string5353z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__evaluate_uncompz00(((long)193509656), 
BSTRING_TO_STRING(BGl_string5353z00zz__evaluate_compz00)); 
return 
BGl_modulezd2initializa7ationz75zz__evaluate_usez00(((long)20669940), 
BSTRING_TO_STRING(BGl_string5353z00zz__evaluate_compz00));} 

}

#ifdef __cplusplus
}
#endif
